﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using Infragistics.Documents.Reports;
using Infragistics.Documents.Reports.Report;
using Infragistics.Documents.Reports.Report.Section;
using Infragistics.Documents.Reports.Graphics;
using Infragistics.Documents.Reports.Report.Table;
using Infragistics.Documents.Reports.Report.Text;
using Infragistics.Documents.Reports.Report.Preferences.Printing;
using Infragistics.Documents.Reports.Report.Band;


namespace InfraReportingProject
{
    public partial class WebForm1 : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }

        #region Creating DataSet

        public DataSet GetData()
        {
            DataSet ds = new DataSet("Set");
            ds.Tables.Add(GetParentData());
            ds.Tables.Add(GetChildData1());
            ds.Tables.Add(GetChildData2());
            ds.Relations.Add(
                ds.Tables["ParentTable"].Columns["Claim Number"],
                ds.Tables["ChildTable"].Columns["Claim Number"]);
            ds.Relations.Add(
                ds.Tables["ChildTable"].Columns["DCN"],
                ds.Tables["ChildTable2"].Columns["DCN"]);
            return ds;
        }

        public DataTable GetParentData()
        {
            DataTable table = new DataTable("ParentTable");
            table.Columns.Add("Claim Number", typeof(string));
            table.Columns.Add("Patient Last Name", typeof(string));
            table.Columns.Add("Patient First Name", typeof(string));
            table.Columns.Add("SSN", typeof(string));
            table.Columns.Add("Injury Date", typeof(DateTime));
            for (int i = 0; i < 2; i++)
            {
                table.Rows.Add("CLM12345678" + i, "Sear", "Pat", "123456789", DateTime.Now.AddDays(-1000));
            }
            table.PrimaryKey = new DataColumn[] { table.Columns["Claim Number"] };
            return table;
        }

        public DataTable GetChildData1()
        {
            DataTable table = new DataTable("ChildTable");
            table.Columns.Add("DCN", typeof(string));
            table.Columns.Add("Claim Number", typeof(string));
            table.Columns.Add("Value", typeof(string));
            table.Columns.Add("Service Date", typeof(DateTime));
            table.Columns.Add("Reject Code", typeof(string));
            table.Columns.Add("Internal Control Number", typeof(string));
            table.Columns.Add("FTIN", typeof(string));
            table.Columns.Add("Provider Name", typeof(string));
            table.Columns.Add("OCT Status", typeof(string));
            table.Columns.Add("Bill Review Status", typeof(string));
            for (int i = 0; i < 2; i++)
            {
                for (int j = 0; j < 3; j++)
                {
                    table.Rows.Add("DCN12345678" + i + j, "CLM12345678" + i, "7361", DateTime.Now.AddDays(-999), "", "26070950599400", "488403658", "MCCARROLL JR H RELTON", "", "Get Status");
                }
            }
            table.PrimaryKey = new DataColumn[] { table.Columns["DCN"] };
            return table;
        }

        public DataTable GetChildData2()
        {
            DataTable table = new DataTable("ChildTable2");
            table.Columns.Add("Pages", typeof(string));
            table.Columns.Add("DCN", typeof(string));
            for (int j = 0; j < 3; j++)
            {
                for (int k = 0; k < 2; k++)
                {
                    if (k == 0)
                    {
                        table.Rows.Add("MEDICAL BILL - CMS-1500, UB...", "DCN12345678" + k + j);
                        table.Rows.Add("FH EOR", "DCN12345678" + k + j);
                    }
                    else
                    {
                        table.Rows.Add("MEDICAL BILL - CMS-1500, UB...", "DCN12345678" + k + j);
                        table.Rows.Add("FH EOR", "DCN12345678" + k + j);
                    }
                }
            }
            table.PrimaryKey = new DataColumn[] { table.Columns["Pages"], table.Columns["DCN"] };
            return table;
        }
        #endregion

        #region Private Fields
        private Report report;
        private ISection reportSection;

        // Styles
        private static readonly string fontName = "Arial Unicode MS";
        private static readonly Borders bordersStyle = new Borders(new Pen(new Color(59, 94, 145)));
        private static readonly Infragistics.Documents.Reports.Report.Text.Style normalStyle =
            new Infragistics.Documents.Reports.Report.Text.Style(new Font(fontName, 12), Brushes.Black);
        private static readonly Infragistics.Documents.Reports.Graphics.Font fontStyle = new Font(fontName, 9);
        private static readonly Infragistics.Documents.Reports.Report.Text.Style invoiceHeaderFontStyle =
            new Infragistics.Documents.Reports.Report.Text.Style(new Font(fontName, 20), Brushes.DarkBlue);
        private static readonly Infragistics.Documents.Reports.Report.Text.Style pageNumberingStyle =
            new Infragistics.Documents.Reports.Report.Text.Style(new Font(fontName, 9), Brushes.Black);
        #endregion

        protected void btnSave_Click(object sender, EventArgs e)
        {
            SetupReportInfo((string)this.GetGlobalResourceObject("InfragisticsDocuments", "INVOICE_REPORT"));

            this.AddInvoiceHeader();
            this.AddCompanyInfo("Infragistics", "Simeonovsko shosse", "54656746456", "support@infragistics.com");
            this.AddInvoiceRecipient("Hristo Anastasov",
                                     "Home Inc.",
                                     "10 Opalchenska str.",
                                     "Karlovo",
                                     "08843 423 570");
            this.CreateTable();

            string documentFileNameRoot = string.Format("Document.{0}", "pdf");
            FileFormat exportFileFormat = FileFormat.PDF;

            this.SendForDownload(exportFileFormat, documentFileNameRoot);
        }

        private void AddHeaderCell(ITableHeader header, string text)
        {
            AddHeaderCell(header, text, null);
        }

        private void AddHeaderCell(ITableHeader header, string text, Width width)
        {
            IText headerText;
            ITableCell cell = header.AddCell();

            cell.Borders = bordersStyle;
            cell.Background = new Background(new Color(228, 234, 244));
            cell.Alignment.Vertical = Alignment.Middle;

            if (width != null)
            {
                cell.Width = width;
            }

            headerText = cell.AddText();

            headerText.Style.Font = fontStyle;
            headerText.Alignment = TextAlignment.Center;
            headerText.AddContent("Header Content Text");
        }

        private void AddTableRows(ITable table, DataSet ds)
        {
            DataRowCollection dsRows = ds.Tables[0].Rows;
            DataColumnCollection dsColums = ds.Tables[0].Columns;
            ITableRow tableRow;
            ITableCell tableCell;
            IText cellText;
            Paddings cellPaddings = new Paddings(5, 3);
            float totalSum = 0;

            foreach (DataRow dsRow in dsRows)
            {
                tableRow = table.AddRow();

                totalSum += float.Parse(dsRow["SSN"].ToString());

                foreach (DataColumn dsColumn in dsColums)
                {
                    tableCell = tableRow.AddCell();
                    tableCell.Paddings = cellPaddings;

                    tableCell.Borders = bordersStyle;
                    cellText = tableCell.AddText();
                    cellText.Style.Font = fontStyle;
                    cellText.AddContent(dsRow[dsColumn].ToString());
                }
            }

            // Here is calculated the total price of all itemes
            tableRow = table.AddRow();
            tableCell = tableRow.AddCell();
            tableCell.Borders = bordersStyle;
            cellText = tableCell.AddText();
            cellText.Style.Font = fontStyle;
            cellText.Alignment.Horizontal = Alignment.Right;

            string totalPriceTxt = (string)this.GetGlobalResourceObject("InfragisticsDocuments", "TOTAL_PRICE");

            cellText.AddContent(totalPriceTxt + totalSum.ToString());
        }

        private void AddInvoiceRecipient(string name, string companyName, string streetAddress, string city, string phone)
        {
            ITable table = reportSection.AddTable();
            ITableRow row = table.AddRow();
            Width columnWidth = new FixedWidth(25);
            ITableCell cell = row.AddCell();
            IText cellText = cell.AddText();

            cellText.Style.Font = fontStyle;

            table.Margins.Bottom = 5;

            //recipient name row
            cell.Width = columnWidth;
            cellText.Style.Font = fontStyle;

            string recipientToTxt = (string)this.GetGlobalResourceObject("InfragisticsDocuments", "TO");

            cellText.AddContent("CellContent");
            cellText.Style.Font = fontStyle;

            cell = row.AddCell();
            cellText = cell.AddText();
            cellText.Style.Font = fontStyle;
            cellText.AddContent(name);

            //recipient company name row
            row = table.AddRow();
            cell = row.AddCell();
            cell.Width = columnWidth;

            cell = row.AddCell();
            cellText = cell.AddText();
            cellText.Style.Font = fontStyle;
            cellText.AddContent(companyName);

            //recipient street address row
            row = table.AddRow();
            cell = row.AddCell();
            cell.Width = columnWidth;

            cell = row.AddCell();
            cellText = cell.AddText();
            cellText.Style.Font = fontStyle;
            cellText.AddContent(streetAddress);

            //recipient city row
            row = table.AddRow();
            cell = row.AddCell();
            cell.Width = columnWidth;

            cell = row.AddCell();
            cellText = cell.AddText();
            cellText.Style.Font = fontStyle;
            cellText.AddContent(city);

            //recipient phone row
            row = table.AddRow();
            cell = row.AddCell();
            cell.Width = columnWidth;

            cell = row.AddCell();
            cellText = cell.AddText();
            cellText.Style.Font = fontStyle;
            cellText.AddContent(phone);
        }

        private void AddCompanyInfo(string companyName, string address, string phone, string email)
        {
            IText text = reportSection.AddText();
            text.AddContent(companyName);

            text = reportSection.AddText();
            text.AddContent(address);

            text = reportSection.AddText();
            text.AddContent(phone);

            text = reportSection.AddText();
            text.AddContent(email);

            text.Margins.Bottom = 10;
        }

        private void AddInvoiceHeader()
        {
            IBand band = reportSection.AddBand();

            band.Height = new FixedHeight(100);
            band.Margins.Vertical = 5;
            band.Paddings.All = 5;

            // Here you can see how to create a gradient color background
            band.Background = new Infragistics.Documents.Reports.Report.Background(new LinearGradientBrush(new Color(198, 212, 232), Colors.White, 90));

            // Header
            IText text = band.AddText();
            text.Alignment.Horizontal = Infragistics.Documents.Reports.Report.Alignment.Right;
            text.Style = invoiceHeaderFontStyle;
            text.AddContent("Some Content");

            // Here we add the IG logo
            System.Drawing.Image nativeImage = System.Drawing.Image.FromFile(Server.MapPath("ig.png"));
            Infragistics.Documents.Reports.Graphics.Image image = new Infragistics.Documents.Reports.Graphics.Image(nativeImage, Colors.White);

            band.AddImage(image);
        }

        private void CreateTable()
        {
            // Table
            IText text;
            ITable table = reportSection.AddTable();

            table.Borders = bordersStyle;
            table.Margins.Top = 5;
            table.Margins.Bottom = 5;
            table.Width = new FixedWidth(480);
            table.Margins.Left = 30;
            // Header
            ITableHeader header = table.Header;
            header.Height = new FixedHeight(25);
            header.Repeat = true;

            this.AddHeaderCell(header, (string)this.GetGlobalResourceObject("InfragisticsDocuments", "QTY"));
            this.AddHeaderCell(header, (string)this.GetGlobalResourceObject("InfragisticsDocuments", "NAME"),
                                        new RelativeWidth(350));
            this.AddHeaderCell(header, (string)this.GetGlobalResourceObject("InfragisticsDocuments", "UNIT_PRICE"));
            this.AddHeaderCell(header, (string)this.GetGlobalResourceObject("InfragisticsDocuments", "TOTAL"));

            //Here we add all the rows of the table
            this.AddTableRows(table, this.GetData());

            // Footer
            ITableFooter footer = table.Footer;
            footer.Height = new FixedHeight(35);
            footer.Repeat = true;

            ITableCell cell = footer.AddCell();
            cell.Borders = bordersStyle;
            cell.Background = new Background(new Color(220, 220, 240));
            cell.Alignment.Vertical = Alignment.Middle;

            text = cell.AddText();
            text.Style = normalStyle;
            text.Alignment = TextAlignment.Center;
            text.AddContent("THANK_YOU_FOR_YOUR_BUSINESS");
        }

        #region Private Methods
        private void SetupReportInfo(string title)
        {
            report = new Report();

            report.Info.Title = title;
            report.Info.Author = (string)this.GetGlobalResourceObject("InfragisticsDocuments", "IG_INC");
            report.Info.Creator = (string)this.GetGlobalResourceObject("InfragisticsDocuments", "IG_REPORT_WRITER");
            report.Info.Copyright = string.Format("Replaced", DateTime.Now.Year.ToString());

            report.Preferences.Printing.PaperSize = PaperSize.Auto;
            report.Preferences.Printing.PaperOrientation = PaperOrientation.Auto;
            report.Preferences.Printing.FitToMargins = true;

            SetupDefaultSection();
        }

        private void SetupDefaultSection()
        {
            reportSection = report.AddSection();
            reportSection.PageSize = PageSizes.Letter;
            reportSection.PageMargins.All = 35;
            reportSection.PageNumbering = new PageNumbering();
            reportSection.PageNumbering.Style = pageNumberingStyle;
            reportSection.PageNumbering.Template = (string)this.GetGlobalResourceObject("InfragisticsDocuments", "PAGING_TEMPLATE");
            reportSection.PageNumbering.Continue = true;
            reportSection.PageNumbering.SkipFirst = false;
            reportSection.PageNumbering.Alignment = PageNumberAlignment.Right;
            reportSection.PageNumbering.OffsetX = -10;
        }

        private void SendForDownload(FileFormat exportFileFormat, string documentFileNameRoot)
        {
            Response.Clear();
            Response.AppendHeader("content-disposition", "attachment; filename=" + documentFileNameRoot);
            Response.ContentType = "application/octet-stream";
            report.Publish(Response.OutputStream, exportFileFormat);
            Response.End();
        }
        #endregion
    }
}