﻿/*!@license
	* Infragistics.Web.ClientUI Chart 14.2.20142.1018
	*
	* Copyright (c) 2011-2014 Infragistics Inc.
	*
	* http://www.infragistics.com/
	*
	* Depends on:
	* jquery-1.4.4.js
	* jquery.ui.core.js
	* jquery.ui.widget.js
	* infragistics.util.js
	* infragistics.dv.core.js
	* infragistics.chart_funnelchart.js
	*/

/*global jQuery */
if (typeof jQuery !== "function") {
	throw new Error("jQuery is undefined");
}

(function ($) {
	/*
		igChartLegend is a widget based on jQuery UI that can be used to identify 
		the name of a series or its elements represented in chart plot area.
	*/
	$.widget("ui.igChartLegend", {
		options: {
			/* type="item|legend|scale" Type of the legend.
				item type="string" Specify the legend as item legend. It displays a legend item for each pie in the igPieChart control.
				legend type="string" Specify the legend as legend. It is supported by all types of series in the igDataChart control.
				scale type="string" Specify the legend as a scale legend. It displays a color/size scale for the bubble series.
			*/
			type: "legend",
			/* type="number" The width of the legend. It can be set as a number in pixels, string (px) or percentage (%). */
			width: null,
			/* type="number" The height of the legend. It can be set as a number in pixels, string (px) or percentage (%). */
			height: null,/*BUILDREMOVESTHIS*/
			/* type="string" The swatch used to style this widget */
			theme: "c"
		},
		css: {
			/* Classes applied on the parent element. */
			legend: "ui-corner-all ui-widget-content ui-chart-legend",
			/* Class applied on the legend items table element. */
			legendItemsList: "ui-chart-legend-items-list",
			/* Class applied on the legend item tr element. */
			legendItem: "ui-chart-legend-item",
			/* Class applied on the legend item badge td element. */
			legendItemBadge: "ui-chart-legend-item-badge",
			/* Class applied on the legend item text td element. */
			legendItemText: "ui-chart-legend-item-text"
		},
		events: {
			/* cancel="false"
			Occurs when the left mouse button is pressed while the mouse pointer is over an element of this legend.
			Function takes arguments evt and ui.
			Use ui.legend to get reference to current legend object.
			Use ui.chart to get reference to chart owner object.
			Use ui.series to get reference to current series owner object.
			Use ui.actualItemBrush to get legend item brush.
			Use ui.actualSeriesBrush to get series owner brush.
			Use ui.item to get reference to chart item related to event.
			*/
			legendItemMouseLeftButtonDown: null,
			/* cancel="false"
			Occurs when the left mouse button is released while the mouse pointer is over an element of this legend.
			Function takes arguments evt and ui.
			Use ui.legend to get reference to current legend object.
			Use ui.chart to get reference to chart owner object.
			Use ui.series to get reference to current series owner object.
			Use ui.actualItemBrush to get legend item brush.
			Use ui.actualSeriesBrush to get series owner brush.
			Use ui.item to get reference to chart item related to event.
			*/
			legendItemMouseLeftButtonUp: null,
			/* cancel="false"
			Occurs when the left mouse pointer enters an element of this legend.
			Function takes arguments evt and ui.
			Use ui.legend to get reference to current legend object.
			Use ui.chart to get reference to chart owner object.
			Use ui.series to get reference to current series owner object.
			Use ui.actualItemBrush to get legend item brush.
			Use ui.actualSeriesBrush to get series owner brush.
			Use ui.item to get reference to chart item related to event.
			*/
			legendItemMouseEnter: null,
			/* cancel="false"
			Occurs when the left mouse pointer leaves an element of this legend.
			Function takes arguments evt and ui.
			Use ui.legend to get reference to current legend object.
			Use ui.chart to get reference to chart owner object.
			Use ui.series to get reference to current series owner object.
			Use ui.actualItemBrush to get legend item brush.
			Use ui.actualSeriesBrush to get series owner brush.
			Use ui.item to get reference to chart item related to event.
			*/
			legendItemMouseLeave: null
		},
		_create: function () {
			var legend, o = this.options, elem = this.element;
			if (o.type === "item") {
				legend = new $.ig.ItemLegend();
			} else if (o.type === "scale") {
			    legend = new $.ig.ScaleLegend();
			    if (!o.width) {
			        o.width = "100px";
			    }
			    if (!o.height) {
			        o.height = "150px";
			    }
			} else {
				legend = new $.ig.Legend();
			}
			if (o.owner) {
				this._owner = o.owner;
				o.owner = this._owner.options;
			}
			this.legend = legend;
			legend.name(this.id());
			legend.legendItemsListStyle(this.css.legendItemsList);
			legend.legendItemStyle(this.css.legendItem);
			legend.legendItemBadgeStyle(this.css.legendItemBadge);
			legend.legendItemTextStyle(this.css.legendItemText);
			if (o.width) {
				this._oldWidth = elem[0].style.width;
				elem.css("width", o.width);
			}
			if (o.height) {
				this._oldHeight = elem[0].style.width;
				elem.css("height", o.height);
			}
			this._cssLegend = this.css.legend.replace("{0}", o.theme);
			elem.addClass(this._cssLegend);
			this._bindLegendEvents(legend);
			legend.provideContainer(elem);
		},
		_bindLegendEvents: function (legend) {
			legend.legendItemMouseLeftButtonDown = $.ig.Delegate.prototype.combine(legend.legendItemMouseLeftButtonDown, jQuery.proxy(this._fireLegend_ItemMouseLeftButtonDown, this));
			legend.legendItemMouseLeftButtonUp = $.ig.Delegate.prototype.combine(legend.legendItemMouseLeftButtonUp, jQuery.proxy(this._fireLegend_ItemMouseLeftButtonUp, this));
			legend.legendItemMouseEnter = $.ig.Delegate.prototype.combine(legend.legendItemMouseEnter, jQuery.proxy(this._fireLegend_ItemMouseEnter, this));
			legend.legendItemMouseLeave = $.ig.Delegate.prototype.combine(legend.legendItemMouseLeave, jQuery.proxy(this._fireLegend_ItemMouseLeave, this));
		},
		_getLegendEvt: function (evtArgs) {
			var e, brush,
				series = evtArgs.series ? evtArgs.series() : null,
				owner = this._owner;
			if (!owner) {
				return null;
			}
			e = {
				legend: this.options,
				series: owner._seriesOpt && series ? owner._seriesOpt[series.name()] : owner.options,
				chart: owner,
				item: evtArgs._item
			};
			e[owner.dvWidget ? owner.dvWidget._getWidgetName() : owner.widgetName] = owner.options;
			brush = (evtArgs.legendItem && evtArgs.legendItem() !== null && evtArgs.legendItem().content) ? evtArgs.legendItem().content() : null;
			brush = brush && brush.actualItemBrush ? brush.actualItemBrush() : null;
			e.actualItemBrush = brush ? brush.fill() : null;
			brush = (series && series.actualBrush) ? series.actualBrush() : null;
			e.actualSeriesBrush = brush ? brush.fill() : null;
			return e;
		},
		_fireLegend_ItemMouseLeftButtonDown: function (sender, evtArgs) {
			this._trigger("legendItemMouseLeftButtonDown", null, this._getLegendEvt(evtArgs));
		},
		_fireLegend_ItemMouseLeftButtonUp: function (sender, evtArgs) {
			this._trigger("legendItemMouseLeftButtonUp", null, this._getLegendEvt(evtArgs));
		},
		_fireLegend_ItemMouseEnter: function (sender, evtArgs) {
			this._trigger("legendItemMouseEnter", null, this._getLegendEvt(evtArgs));
		},

		_fireLegend_ItemMouseLeave: function (sender, evtArgs) {
			this._trigger("legendItemMouseLeave", null, this._getLegendEvt(evtArgs));
		},
		_getLegend: function () {
			return this.legend;
		},
		_setOption: function (key, value) {
			switch (key) {
				case "width":
					this.element.css("width", value);
					break;
				case "height":
					this.element.css("height", value);
					break;
			}
		},
		destroy: function () {
			/* Destroys the widget. */
			var elements, elem = this.element;
			$.Widget.prototype.destroy.call(this);
			if (this.legend) {
				this.legend = null;
			}
			if (elem) {
				elem.removeClass(this._cssLegend);
				if (this.options.width) {
					elem[0].style.width = this._oldWidth || "";
				}
				if (this.options.height) {
					elem[0].style.height = this._oldHeight || "";
				}
				if (elem.children("table").length > 0) {
					elements = elem.children("table").children("tr");
					$.each(elements, function (key, tr) {
						$(tr).unbind("mouseleave").unbind("mouseup").unbind("mousedown").unbind("mousemove");
					});
				}
				elem.empty();
			}
			return this;
		},
		widget: function () {
			/* Returns the element holding the legend. */
			return this.element;
		},
		id: function () {
			/*  returns the ID of the DOM element holding the legend.
				returnType="string" 
			*/
			return this.element[0].id;
		}
	});
	$.extend($.ui.igChartLegend, {version: "14.2.20142.1018"});
}(jQuery));
