﻿/*!@license
* Infragistics.Web.ClientUI common utilities localization resources 14.2.20142.1018
*
* Copyright (c) 2011-2014 Infragistics Inc.
*
* http://www.infragistics.com/
*
*/

/*global jQuery */
(function ($) {
    $.ig = $.ig || {};

    if (!$.ig.util) {
	    $.ig.util = {};

	    $.extend($.ig.util, {

		    locale: {
			    unsupportedBrowser: "The current browser does not support HTML5 canvas element. <br/>Try upgrading to any of the following versions:",
			    currentBrowser: "Current browser: {0}",
			    ie9: "Microsoft Internet Explorer V 9+",
			    chrome8: "Google Chrome V 8+",
			    firefox36: "Mozilla Firefox V 3.6+",
			    safari5: "Apple Safari V 5+",
			    opera11: "Opera V 11+",
			    ieDownload: "http://www.microsoft.com/windows/internet-explorer/default.aspx",
			    operaDownload: "http://www.opera.com/download/",
			    chromeDownload: "http://www.google.com/chrome",
			    firefoxDownload: "http://www.mozilla.com/",
			    safariDownload: "http://www.apple.com/safari/download/"
		    }
	    });

    }
})(jQuery);

/*!@license
 * Infragistics.Web.ClientUI Util functions 14.2.20142.1018
 *
 * Copyright (c) 2011-2014 Infragistics Inc.
 * 
 * util functions that extend the jQuery  namespace 
 * if something is not already available in jQuery, please add it here. 
 *
 * http://www.infragistics.com/
 *
 * Depends on:
 *  jquery-1.4.4.js
 *
 */
  
 /* Simple JavaScript Inheritance
 * By John Resig http://ejohn.org/
 * MIT Licensed. 
 */
// Inspired by base2 and Prototype
/*global xyz */
/*global Class */
/*global define*/
/*global jQuery,$*/
(function ($) {

    var initializing = false, fnTest = /xyz/.test(function () { xyz(); }) ? /\b_super\b/ : /.*/;
    // The base Class implementation (does nothing)
    this.Class = function () { };

    // Create a new Class that inherits from this class
    Class.extend = function (prop, doAugment) {
        var doSuper = true,
			_super = this.prototype,
			prototype,
			name;

        if (doAugment) {
            doSuper = false;
        }

        // Instantiate a base class (but only create the instance,
        // don't run the init constructor)
        initializing = true;
        prototype = new this();
        initializing = false;

        function makeFn(name, fn) {
            return function () {
                var tmp = this._super,
					ret;

                // Add a new ._super() method that is the same method
                // but on the super-class
                this._super = _super[name];

                // The method only need to be bound temporarily, so we
                // remove it when we're done executing
                ret = fn.apply(this, arguments);
                this._super = tmp;

                return ret;
            };
        }

        // Copy the properties over onto the new prototype
        for (name in prop) {
            if (prop.hasOwnProperty(name)) {
                // Check if we're overwriting an existing function
                prototype[name] = doSuper && typeof prop[name] === "function" &&
					typeof _super[name] === "function" && fnTest.test(prop[name]) ?
					makeFn(name, prop[name]) : prop[name];
            }
        }

	    // For some reason, intellisense gets tripped up when we allow the constructors to call the init function. So when the intellisense 
	    // object is defined, just use a dummy constructor
        var isForIntellisense =
            window.intellisense &&
            window.intellisense.annotate;

        // The dummy class constructor
        function Class() {
            // All construction is actually done in the init method
            if (!initializing && this.init) {
                if (!isForIntellisense || Class === $.ig.Type) {
                    this.init.apply(this, arguments);
                }
            }
		}

        if (prop.$type) {
            prop.$type.InstanceConstructor = Class;
        }

        // Populate our constructed prototype object
        Class.prototype = prototype;

        // Enforce the constructor to be what we expect
        Class.constructor = Class;

        // And make this class extendable
        Class.extend = this.extend;

        if (doAugment) {
            Class.typeName = function () {
                return this.prototype.$type;
            };

            Class.baseType = function () {
                return this.$type.baseType;
            };

            Class.prototype.getType = function () {
                return this.$type;
            };

            Class.prototype.getHashCode = function () {
                if (this.$hashCode !== undefined) {
                    return this.$hashCode;
                }
                this.$hashCode = $.ig.nextHashCode++;
                return this.$hashCode;
            };
        }

        return Class;
    };

	// Expose util as an AMD module, but only for AMD loaders that
	// understand the issues with loading multiple versions of jQuery
	// in a page that all might call define(). The loader will indicate
	// they have special allowances for multiple jQuery versions by
	// specifying define.amd.jQuery = true. Register as a named module,
	// since jQuery can be concatenated with other files that may use define,
	// but not use a proper concatenation script that understands anonymous
	// AMD modules. A named AMD is safest and most robust way to register.
	// Lowercase ig.util is used because AMD module names are derived from
	// file names, and jQuery is normally delivered in a lowercase file name.
	// Do this after creating the global so that if an AMD module wants to call
	// noConflict to hide this version of jQuery, it will work.
	if (typeof define === "function" && define.amd && define.amd.jQuery) {
		define("ig.util", [], function () { return Class; });
	}

}(jQuery));

(function ($) {
    $.fn.startsWith = function (str) {
	    return this[0].innerHTML.indexOf(str) === 0;
	};

	$.ig = $.ig || { _isNamespace: true };
    $.ig.util = $.ig.util || {};

    $.ig.util.browserVersion = "";
    //D.A. 11th November 2013, Updated the isIE & browserVersion to be compatible with IE11+
    $.ig.util.isIE = window.navigator.userAgent.indexOf("MSIE") > -1 || !!window.navigator.userAgent.match(/trident/i);
    $.ig.util.isIEOld = $.ig.util.isIE && !window.HTMLElement ? true : false;
    if ($.ig.util.isIE) {
        var re;
        if (navigator.appName === 'Microsoft Internet Explorer') {
            re = new RegExp("MSIE ([0-9]{1,})");
            if (re.exec(navigator.userAgent)) {
			    $.ig.util.browserVersion = parseInt(RegExp.$1, 10);
            }
        } else if (navigator.appName === 'Netscape') {
            re = new RegExp("rv:([0-9]{1,})");
            if (re.exec(navigator.userAgent)) {
			    $.ig.util.browserVersion = parseInt(RegExp.$1, 10);
            }
        }
	    $.ig.util.isIE7 = $.ig.util.browserVersion <= 7;
	    $.ig.util.isIE8 = $.ig.util.browserVersion === 8;
	    $.ig.util.isIE9 = $.ig.util.browserVersion === 9;
	    $.ig.util.isIE10 = $.ig.util.browserVersion === 10;
	    $.ig.util.isIE11 = $.ig.util.browserVersion >= 11;
    }

    $.ig.util.isChrome = window.chrome;
    $.ig.util.isFF = window.mozInnerScreenX !== undefined;
    $.ig.util.isOpera = !!window.opera;
    $.ig.util.isSafari = (Object.prototype.toString.call(window.HTMLElement).indexOf('Constructor') > 0) ? true : false;
    $.ig.util.isWebKit = !!window.webkitURL;

    $.ajaxQueue = function (queueName, options) {
        var callback;
//        var s = $('#status');
//        s.html(options.url + '<br />' + s.html());

        if (typeof document.ajaxQueue === "undefined") {
            document.ajaxQueue = { queue: {} };
		}
        if (typeof document.ajaxQueue.queue[queueName] === "undefined") {
            document.ajaxQueue.queue[queueName] = [];
		}

        if (typeof options === "undefined") {
            return;
		}

        callback = options.complete; //original callback

        //overwrite complete
        options.complete = function (request, status) {
            document.ajaxQueue.queue[queueName].shift(); //remove the first element from the array
            //we should check if original callbak is defined in options
            if (typeof callback !== "undefined") {
                callback(request, status);
			}

            if (document.ajaxQueue.queue[queueName].length > 0) {
                $.ajax(document.ajaxQueue.queue[queueName][0]);
			}
        };

        document.ajaxQueue.queue[queueName].push(options);
        if (document.ajaxQueue.queue[queueName].length === 1) {
            $.ajax(document.ajaxQueue.queue[queueName][0]);
		}
    };

    //A.T. 29 Nov 2012 - Fix for bug #119896
    if (typeof $.ig.useDefineProperty === "undefined") { $.ig.useDefineProperty = true; }

    $.ig.extendNativePrototype = function (proto, propName, val) {
        if ($.ig.useDefineProperty) {
            try {
                Object.defineProperty(proto, propName, {
                    value: val,
                    enumerable: false,
					configurable: true,
					writable: true
                });
            } catch (e) { // IE8 has defineProperty defined, but doesn't support setting enumerable to false
                proto[propName] = val;
            }
        } else {
            proto[propName] = val;
        }
    };

     $.ig.util.stackPeek = function (array) {
        return array[array.length - 1];
     };

     $.ig.util.stackContains = function (array, item) {
         for (var i = 0; i < array.length; i++) {
             if ($.ig.Object.prototype.equalsStatic(array[i], item)) {
                 return true;
         }
         }

         return false;
     };

    $.ig.util.createString1 = function (charArray) {
        return charArray.join('');
    };

    $.ig.util.createString2 = function (c, count) {
        var ret = '';
        for (var i = 0; i < count; i++) {
            ret = ret + c;
        }

        return ret;
    };

    $.ig.util.createString3 = function (charArray, start, length) {
        var ret = '';
        for (var i = 0; i < length; i++) {
            ret = ret + charArray[start + i];
        }

        return ret;
    };

    String.prototype.copyTo = function (sourceIndex, destination, destinationIndex, count) {
        for (var i = destinationIndex; i < count; i++) {
            destination[i] = this.charAt(sourceIndex + i - destinationIndex);
        }
    };

	Date.prototype.stdTimezoneOffset = function () {
		var jan, jul, janOffset, julOffset;
		jan = new Date(this.getFullYear(), 0, 1);
		jul = new Date(this.getFullYear(), 6, 1);
		julOffset = jul.getTimezoneOffset();
		janOffset = jan.getTimezoneOffset();
		if (janOffset > 0 && julOffset > 0) {
			return Math.max(janOffset, julOffset);
		} else {
			return Math.min(janOffset, julOffset);
		}
	};

	Date.prototype.dst = function () {
		return this.getTimezoneOffset() < this.stdTimezoneOffset();
	};

	// From https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/keys
	if (!Object.keys) {
		Object.keys = (function () {
			"use strict";
			var hasOwnProperty = Object.prototype.hasOwnProperty,
				hasDontEnumBug = !({ toString: null }).propertyIsEnumerable("toString"),
				dontEnums = [
					"toString",
					"toLocaleString",
					"valueOf",
					"hasOwnProperty",
					"isPrototypeOf",
					"propertyIsEnumerable",
					"constructor"
				],
				dontEnumsLength = dontEnums.length;
			return function (obj) {
				if (typeof obj !== "object" && (typeof obj !== "function" || obj === null)) {
					throw new TypeError("Object.keys called on non-object");
				}
				var result = [], prop, i;
				for (prop in obj) {
					if (hasOwnProperty.call(obj, prop)) {
						result.push(prop);
					}
				}
				if (hasDontEnumBug) {
					for (i = 0; i < dontEnumsLength; i++) {
						if (hasOwnProperty.call(obj, dontEnums[i])) {
							result.push(dontEnums[i]);
						}
					}
				}
				return result;
			};
		}());
	}

	$.ig.findPath = function (dsObj, resKey) {
		var resPath, ds = dsObj;
		resPath = resKey.split(".");
		if (resPath.length > 0) {
			for (var i = 0; i < resPath.length; i++) {
				if (ds) {
					ds = ds[resPath[i]];
				} else {
					break;
				}
			}
		}
		return ds;
	};

$.ig.formatter = function (val, type, format, notTemplate, enableUTCDates, displayStyle) {
	var min, y, h, m, s, ms, am, e, pattern, len, n, dot, gr, gr0, grps, curS, percS, cur, perc, prefix, i, d = val && val.getTime, reg = $.ig.regional.defaults, pow,
	// L.A. 17 October 2012 - Fixing bug #123215 The group rows of a grouped checkbox column are too large
	display = displayStyle || 'inline-block';
	if (format === 'checkbox' && notTemplate) {
		s = '<span style="width:100%;display:' + display + ';overflow:hidden;text-align:center;">';
		s += '<span class="ui-state-default ui-corner-all ui-igcheckbox-small" style="display:inline-block">';
		s += '<span style="display:block" class="' + (val ? '' : 'ui-igcheckbox-small-off ');
		return s + 'ui-icon ui-icon-check ui-igcheckbox-small-on"></span></span></span>';
	}
		if (!val && val !== 0 && val !== false) {
			return '&nbsp;';
		}
		if (type === 'date' || d) {
			if (!val) {
				return '&nbsp;';
			}
			if (!d) {
				return val;
			}
			pattern = reg[(format && format !== 'null' && format !== 'undefined') ? format + 'Pattern' : 'datePattern'] || format;
			if (enableUTCDates) {
				y = val.getUTCFullYear();
				m = val.getUTCMonth() + 1;
				d = val.getUTCDate();
				h = val.getUTCHours();
				min = val.getUTCMinutes();
				s = val.getUTCSeconds();
				ms = val.getUTCMilliseconds();
			} else {
				y = val.getFullYear();
				m = val.getMonth() + 1;
				d = val.getDate();
				h = val.getHours();
				min = val.getMinutes();
				s = val.getSeconds();
				ms = val.getMilliseconds();
			}

				// M.P. 25 July 2014: 176543 - $.ig.formatter doesn't work with escaped characters for date formatting
				pattern = pattern.replace(/\\d/g, '\x06').replace(/\\y/g, '\x07').replace(/\\M/g, '\x08').replace(/\\m/g, '\x09').replace(/\\t/g, '\x0A').replace(/\\s/g, '\x0B').replace(/\\f/g, '\x0C').replace(/\\h/g, '\x0D').replace(/\\H/g, '\x0E');
			// remove MMMM, MMM, dddd, ddd, tt, t
			pattern = pattern.replace('MMMM', '\x01').replace('MMM', '\x02').replace('dddd', '\x03').replace('ddd', '\x04');
			if (pattern.indexOf('t') >= 0) {
				am = (h >= 12) ? reg.pm : reg.am;
				am = am || ' ';
				if (pattern.indexOf('tt') >= 0) {
					pattern = pattern.replace('tt', 't');
				} else if (am.length > 1) {
					am = am.substring(0, 1);
				}
				pattern = pattern.replace('t', '\x05');
			}
			if (pattern.indexOf('h') >= 0) {
				if (h > 12) {
					h -= 12;
				}
				// M.P. 2 August 2013 - Fix for bug #147778 Incorrect date formatting when 12 hour format is used
				if (h === 0) {
					h = 12;
				}
			}
			pattern = pattern.replace(/H/g, 'h');
			// L.A. 23 October 2012 - Fixing bug #125273 Missing leading zeros when using format MM/dd/yyyy for dates before 1000
			pattern = pattern.replace('yyyy', y < 10 ? '000' + y : y < 100 ? '00' + y : y < 1000 ? '0' + y : y).replace('yy', ((y = y % 100) < 10) ? '0' + y : y).replace('y', y % 100).replace('MM', (m < 10) ? '0' + m : m).replace('M', m);
			pattern = pattern.replace('dd', (d < 10) ? '0' + d : d).replace('d', d);
			pattern = pattern.replace('hh', (h < 10) ? '0' + h : h).replace('h', h).replace('mm', (min < 10) ? '0' + min : min).replace('m', min).replace('ss', (s < 10) ? '0' + s : s).replace('s', s);
			pattern = pattern.replace('fff', (ms < 10) ? '00' + ms : ((ms < 100) ? '0' + ms : ms)).replace('ff', ((ms = Math.round(ms / 10)) < 10) ? '0' + ms : ms).replace('f', Math.round(ms / 100));
			pattern = pattern.replace('\x01', reg.monthNames[m - 1]).replace('\x02', reg.monthNamesShort[m - 1]).replace('\x05', am);
			pattern = pattern.replace('\x03', reg.dayNames[val.getDay()]).replace('\x04', reg.dayNamesShort[val.getDay()]);
				pattern = pattern.replace(/\x06/g, 'd').replace(/\x07/g, 'y').replace(/\x08/g, 'M').replace(/\x09/g, 'm').replace(/\x0A/g, 't').replace(/\x0B/g, 's').replace(/\x0C/g, 'f').replace('\x0D', 'h').replace('\x0E', 'H');
			return pattern;
		}
		d = format === 'double';
		if (!d) {
			cur = format === (curS = 'currency');
			if (!cur) {
				perc = format === (percS = 'percent');
				if (!perc) {
					i = format === 'int';
				}
			}
		}
		n = typeof val === 'number';
		if (d || n || i || cur || perc || type === 'number') {
			if (!n) {
                // N.A. 26 April 2013 - Fixing bug #139790 When regional settings, different from english, are used and the decimal separator is different than '.' the value is calculated wrong
				// keep only e, E, -, +, decimal separator and digits
			    val = parseFloat(val.replace('(', '-').replace(new RegExp('[^0-9\\-eE\\' + reg.numericDecimalSeparator + '\\+]', 'gm'), '').replace(reg.numericDecimalSeparator, '.'));
			}
			if (isNaN(val)) {
				return '&nbsp;';
			}
			prefix = cur ? curS : (perc ? percS : 'numeric');
			pattern = reg[prefix + ((val < 0) ? 'Negative' : 'Positive') + 'Pattern'] || 'n';
			len = format ? format.length : 0;
			// calculate maximum number of decimals
			if (len > 0 && ((s = format.charAt(0)) === '0' || s === '#')) {
				min = m = 0;
				dot = format.indexOf('.');
				if (dot > 0) {
					m = len - 1 - dot;
					while (++dot < len) {
						if (format.charAt(dot) !== '0') {
							break;
						}
						min++;
					}
				}
			} else {
				min = reg[prefix + 'MinDecimals'] || 0;
				if (d) {
					m = 999;
				} else {
					m = reg[prefix + 'MaxDecimals'];
					m = (m && !i) ? m : 0;
				}
			}
			if (val < 0) {
				val = -val;
			}
			// S.S. March 26, 2013 Bug #137025. IE8 and below do not round numbers in toFixed() so we need to round
			// them first before passing them to toFixed()
			// val = (m === 999) ? val.toString(10) : val.toFixed(m);
			if (m === 999) {
				val = val.toString(10);
			} else {
			if ($.ig.util.isIE && $.ig.util.browserVersion <= 8) {
					pow = Math.pow(10, m);
					val = (Math.round(pow * val) / pow).toFixed(m);
				} else {
					val = val.toFixed(m);
				}
			}
			if ((i = val.indexOf('E')) < 0) {
				i = val.indexOf('e');
			}
			// cut-off E-power (e)
			e = '';
			if (i > 0) {
				e = val.substring(i);
				val = val.substring(0, i);
			}
			dot = val.indexOf('.');
			len = val.length;
			i = 0;
			// remove trailing 0s
			while (dot > 0 && m > min + i && val.charAt(len - 1 - i) === '0') {
				i++;
			}
			if (i > 0) {
				val = val.substring(0, len -= i);
			}
			// remove trailing .
			if (dot === len - 1) {
				val = val.substring(0, dot);
			}
			if (dot > 0) {
				len = dot;
			}
			// replace decimal separator
			s = reg[prefix + 'DecimalSeparator'];
			if (s) {
				val = val.replace('.', s);
			}
			// insert group separators
			s = reg[prefix + 'GroupSeparator'];
			grps = s ? reg[prefix + 'Groups'] : '';
			gr = gr0 = (grps.length > 0) ? grps[i = 0] : 0;
			while (gr > 0 && --len > 0) {
				if (--gr === 0) {
					val = val.substring(0, len) + s + val.substring(len);
					gr = grps[++i];
					if (!gr || gr < 1) {
						gr = gr0;
					} else {
						gr0 = gr;
					}
				}
			}
			// replace 'n' by number, '$' by symbol and '-' by negative sign
			s = reg[prefix + 'Symbol'] || '';
			return pattern.replace('-', reg.negativeSign).replace('n', val + e).replace('$', s);
		}
		if (format) {
			if (format.indexOf(s = '{0}') >= 0) {
				return format.replace(s, val);
			}
			if (format.indexOf(s = '[0]') >= 0) {
				return format.replace(s, val);
			}
		}
		return (val || val === 0) ? val : '&nbsp;';
	};
	$.ig._regional = {
		monthNames: ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'],
		monthNamesShort: ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'],
		dayNames: ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'],
		dayNamesShort: ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'],
		am: 'AM',
		pm: 'PM',
		datePattern: 'M/d/yyyy',
		dateLongPattern: 'dddd, MMMM dd, yyyy',
		dateTimePattern: 'M/d/yyyy h:mm tt',
		timePattern: 'h:mm tt',
		timeLongPattern: 'h:mm:ss tt',
		negativeSign: '-',
		numericNegativePattern: '-$n',
		numericDecimalSeparator: '.',
		numericGroupSeparator: ',',
		numericGroups: [3],
		numericMaxDecimals: 2,
		numericMinDecimals: 0,
		currencyPositivePattern: '$n',
		currencyNegativePattern: '$(n)',
		currencySymbol: '$',
		currencyDecimalSeparator: '.',
		currencyGroupSeparator: ',',
		currencyGroups: [3],
		currencyMaxDecimals: 2,
		currencyMinDecimals: 2,
		percentPositivePattern: 'n$',
		percentNegativePattern: '-n$',
		percentSymbol: '%',
		percentDecimalSeparator: '.',
		percentGroupSeparator: ',',
		percentGroups: [3],
		percentDisplayFactor: 100,
		percentMaxDecimals: 2,
		percentMinDecimals: 2
	};
$.ig.regional = $.ig.regional || {};
$.ig.regional.defaults = $.ig._regional;
	$.ig.setRegionalDefault = function (regional) {
	if ($.ui && $.ui.igEditor) {
			$.ui.igEditor.setDefaultCulture(regional);
		} else {
			$.ig.regional.defaults = $.extend($.ig._regional, (typeof regional === 'string') ? $.ig.regional[regional] : regional);
		}
	};
	$.ig.calcSummaries = function (summaryFunction, data, caller, dataType) {
		var sum = function (data) {
		var sum = 0,
			i;
		for (i = 0; i < data.length; i++) {
			sum += data[i];
		}
			return sum;
		};

		// M.H. 16 Nov. 2011 Fix for bug 97886
		summaryFunction = summaryFunction.toLowerCase();
		if (summaryFunction.startsWith('custom')) {
			summaryFunction = 'custom';
		}

		switch (summaryFunction) {
			case "min":
                if (data.length === 0) {
                    if (dataType === 'date') {
                        return null;
                    }
					return 0; 
				}
				return Math.min.apply(Math, data);
			case "max":
                if (data.length === 0) {
                    if (dataType === 'date') {
                        return null;
                    }
					return 0; 
				}
				return Math.max.apply(Math, data);
			case "sum":
				return sum(data);
			case "avg":
				if (data.length === 0) {
					return 0; 
				}
		return sum(data) / data.length;
			case "count":                    
				return data.length;
			case "custom":
				// M.H. 30 Sept. 2011 Fix for bug #88717 - fix when caller is string
				if (caller !== undefined && caller !== null) {
					if ($.type(caller) === 'function') {
						return caller(data);
			}
					if ($.type(caller) === 'string') {
					    /*jshint evil:true */
						caller = eval(caller);
						return caller(data);
					}
				} else {
					return null;
				}
		break;
		}
	};

    // get max zIndex of ui-dialogs - method is usually called by feautures for configuring zIndex of modal dialogs(like filtering, feature chooser, hiding, etc.)
	$.ig.getMaxZIndex = function (id) {
	    var maxZ = 10000, thisZ;
	    $('.ui-dialog').each(function () {
	        if (!id || $(this)[0].id !== id) {
	            thisZ = $(this).css('z-index');
	            if (!isNaN(thisZ)) {
	                maxZ = Math.max(maxZ, thisZ);
	            }
	        }
	    });
	    return maxZ;
	};

	// generate unique identifiers 
	$.ig.uid = function () {
		return ((1 + Math.random()) * parseInt('10000', 16)).toString(16).substring(1, 5);
	};

    $.ig.nextHashCode = 0;
    $.ig.util.ensureUniqueId = function (obj) {
    	if (!obj.getHashCode) {
    		var code = $.ig.nextHashCode++;
    		obj.getHashCode = function () {
    			return code;
    		};
    	}
    };
	
	$.ig.getColType = function (o) {
		var t = typeof o;
		if (t === "undefined") {
			return "string";
		} else if (o && o.getTime && !isNaN(o.getTime()) &&
			Object.prototype.toString.call(o) === "[object Date]") {
			return "date";
		} else if (t === "boolean") {
			return "bool";
		} else if (t === "number") {
			return t;
		} else if (t === "object") {
			return "object";
		} else {
			return "string";
		}

	};

    $.ig.typeIdentifierCache = {};
    $.ig.nextTypeIdentifier = 0;
    $.ig.Type = Class.extend({
        init: function (identifier, baseType, interfaces) {
            this.specializationCache = {};
            this.name = identifier; 
            this.typeArguments = null;
            this.baseType = null;
            this.interfaces = null;
            if (baseType) {
                this.baseType = baseType;
            }
            if (interfaces) {
                this.interfaces = interfaces;
            }

            if ($.ig.typeIdentifierCache[identifier]) {
                this.identifier = $.ig.typeIdentifierCache[identifier];
            } else {
                this.identifier = $.ig.nextTypeIdentifier++;
                $.ig.typeIdentifierCache[identifier] = this.identifier;
            }
        },
        typeName: function() {
            return this.name;
        },
        fullName: function () {
            return this.name;
        },
        getSpecId: function(types) {
            if (types.length === 1) {
                if (!types[0]) {
                    return "undef";
                } else if (!types[0].typeName) {
                    return types[0].toString();
                } else if (types[0].stringId) {
                    return types[0].stringId;
                } else {
                    return types[0].identifier.toString();
                }
            }

            var ret = "";
            for (var i = 0; i < types.length; i++) {
                var type = types[i];
                if (!types[0]) {
                    ret += "undef";
                } else if (!types[0].typeName) {
                    ret += types[0].toString();
                } else if (types[0].stringId) {
                    ret += types[0].stringId;
                } else {
                    ret += types[0].identifier.toString();
                }
            }
            return ret;
        },
		_isGenericType: null,
        isGenericType: function() {
			if (this._isGenericType === null) {
                this._isGenericType = this.name.indexOf('$') >= 0;
			}
			
            return this._isGenericType;
        },
        isGenericTypeDefinition: function() {
            return this.typeArguments === null && this.isGenericType();
        },
		genericTypeArguments: function() {
			return this.typeArguments;
		},
        specializationCache: null,
        specialize: function () {
			var i;
            if (!this.isGenericType()) {
                return this;
            }

            var specId = this.getSpecId(arguments);
            var ret = this.specializationCache[specId];
            if (ret) {
                return ret;
            }
            ret = new $.ig.Type(this.name, this.baseType, this.interfaces);
            
            var placeholders = this.typeArguments;
            var hasPlaceholders = false;
            // Make sure the placeholders are actually numbers. If they are types, we are re-specializing an
            // already specialized type.
            if (placeholders && placeholders.length && isFinite(placeholders[0])) {
                hasPlaceholders = true;
            }

            ret.typeArguments = [];
            if (hasPlaceholders) {
				for (i = 0; i < placeholders.length; i++) {
                    ret.typeArguments[i] = arguments[placeholders[i]];
                }
            } 
            else {
				for (i = 0; i < arguments.length; i++) {
                    ret.typeArguments[i] = arguments[i];
                }
            }

            if (this.baseType && this.baseType.typeArguments) {
                ret.baseType = this.specialize.apply(this.baseType, arguments);
            }

            if (this.interfaces) {
                ret.interfaces = [];
                for (i = 0; i < this.interfaces.length; i++) {
                    ret.interfaces[i] = this.specialize.apply(this.interfaces[i], arguments);
                }
            }

            this.specializationCache[specId] = ret;
            ret.stringId = ret.generateString();

            var _self = this;
            ret.InstanceConstructor = function () {
                _self.InstanceConstructor.apply(this, ret.typeArguments.concat(Array.prototype.slice.call(arguments, 0)));
                return this;
            };
            ret.InstanceConstructor.prototype = this.InstanceConstructor.prototype;

            return ret;
        },
        equals: function (other) {
            if (!(other instanceof $.ig.Type)) {
                return false;
            }
            if (this.identifier !== other.identifier) {
                return false;
            }
            if (this.typeArguments === null && other.typeArguments === null) {
                return true;
            }
            if (this.typeArguments === null && other.typeArguments !== null) {
                return false;
            }
            if (this.typeArguments !== null && other.typeArguments === null) {
                return false;
            }
            if (this.typeArguments.length !== other.typeArguments.length) {
                return false;
            }
            for (var i = 0; i < this.typeArguments.length; i++) {
                //TODO: handle covariance case here.
                //if (!$.ig.util.canAssign(this.typeArguments[i], other.typeArguments[i])) {
                //    return false;
                //}
                if (!$.ig.Type.prototype.checkEquals(this.typeArguments[i], other.typeArguments[i])) {
                    return false;
                }
            }

            return true;
        },
        checkEquals: function (type1, type2) {
            if (type1 instanceof $.ig.Type) {
                return type1.equals(type2);
            } else if (type2 instanceof $.ig.Type) {
                return type2.equals(type1);
            } else {
                return type1 === type2;
            }
        },
        op_Equality: function (type1, type2) {
            return type1.equals(type2);
        },
        op_Inequality: function (type1, type2) {
            return !type1.equals(type2);
        },
        generateString: function() {
			if (!this.typeArguments || !this.typeArguments.length) {
                return this.identifier.toString();
            } else {
                var ret = this.identifier.toString() + "[";
                var first = true;
                for (var i = 0; i < this.typeArguments.length; i++) {
                    if (this.typeArguments[i] == undefined) {
                        continue;
                    }
                    if (first) { first = false; } else { ret += ","; }
                    if (this.typeArguments[i].toString) {
                        ret += this.typeArguments[i].toString();
                    } else {
                        ret += this.typeArguments[i].identifier.toString();
                    }
                }
                ret += "]";
                return ret;
            }
        },
        isEnum: function () {
            return this.baseType === $.ig.Enum.prototype.$type;
        },
        isAssignableFrom: function (tOther) {
            // TODO: Unit test and make sure this is right (especially with generics
            if (this === tOther) {
                return true;
            }

            if (tOther.baseType && this.isAssignableFrom(tOther.baseType)) {
                return true;
            }
    
            if (tOther.interfaces) {
                for (var i = 0; i < tOther.interfaces.length; i++) {
                    if (this.isAssignableFrom(tOther.interfaces[i])) {
                        return true;
        }   
            }
            }

            return false;
        },
        isInstanceOfType: function (value) {
            return $.ig.util.cast(this, value) !== null;
        },
        isPrimitive: function() {
            return this === $.ig.Number.prototype.$type || this === $.ig.Boolean.prototype.$type;
        }
    }, true);

    $.ig.Object = Class.extend({
        init: function () {

        },
        equals: function(other) {
            return this === other;
        },
        equalsStatic: function (a, b) {
            /*jshint eqnull:true */
            var aIsNull = (a == null) || (!!a.isNullable && !a.hasValue());
            var bIsNull = (b == null) || (!!b.isNullable && !b.hasValue());

            if (aIsNull || bIsNull) {
                return aIsNull && bIsNull;
            }

            if (a.equals) {
                return a.equals(b);
            }

            if (b.equals) {
                return b.equals(a);
            }

            if ($.ig.util.isNaN(a) && $.ig.util.isNaN(b)) {
                return true;
            }

            return a == b && typeof a == typeof b;
        },
        memberwiseClone: function() {
            var clone = {};

            /*jshint proto:true */
            if (this.__proto__) {
                clone.__proto__ = this.__proto__;
            }

            for (var prop in this) {
                if (this.hasOwnProperty(prop)) {
                    clone[prop] = this[prop];
            }
            }

            return clone;
        },
        referenceEquals: function (a, b) {
            /*jshint eqnull:true */
            return a === b || (a == null && b == null);
        },
        $type: new $.ig.Type('Object')
    }, true);
	$.ig.$o = $.ig.Object;
	$.ig.$op = $.ig.Object.prototype;
	$.ig.$ot = $.ig.Object.prototype.$type;

	$.ig.Type.prototype.$type = new $.ig.Type('Type', $.ig.Object.prototype.$type);

	$.ig.IConvertible = Class.extend({
	    $type: new $.ig.Type('IConvertible')
	}, true);

	$.ig.IComparable = Class.extend({
	    $type: new $.ig.Type('IComparable')
	}, true);

$.ig.Enum = Class.extend({
    parse: function (enumType, value, ignoreCase) {
        var info = $.ig.util.getDefinedNameAndNamespace(enumType.name);

        if ($.ig.util.canAssign(this.$type, enumType)) {
		    var p = info.namespace[info.name].prototype;

		    if (p.hasOwnProperty(value)) {
				    return p.getBox(p[value]);
		    }
            else if (ignoreCase) {
                var upper = value.toUpperCase();

                for (var x in p) {
                    if (x.toUpperCase() === upper) {
						    return p.getBox(p[x]);
                    }
                }
			} else {
                // TODO: Find a more permanent solution to this casing issue. Maybe the Enums should have their names stored with the values somehow
				var firstChar = value.charAt(0);
				value = firstChar.toLowerCase() + value.substr(1);
		        if (p.hasOwnProperty(value)) {
				    return p.getBox(p[value]);
            }
        }
        }

		throw new Error('Invalid ' + info.name + ' value: ' + value);
    },
    getBox: function(v) {
        if (!this._boxes) {
            this._boxes = {};
        }

        if (!this._boxes[v]) {
            this._boxes[v] = new this.$type.InstanceConstructor(v);
        }
           
        return this._boxes[v];
    },
    toString: function () {
        return this.$type.InstanceConstructor.prototype.getName(this._v);
    },
    getFlaggedName: function (v, getName) {
        var names = [];
        var original = v;
        var zeroValueName;
        var value;

        var values = [];
        for (var p in this) {
            if (this.hasOwnProperty(p)) {
                value = this[p];
                if (typeof this[p] == 'number') {
                    values.push(p);
                }
            }
        }

        values.sort(function (a, b) { return this[a] - this[b]; });

        for (var i = values.length - 1; i >= 0; i--) {
            value = this[values[i]];
            if (value === 0) {
                zeroValueName = getName(0);
            }
            /*jslint bitwise: true */
            else if ((v & value) === value) {
                v -= value;
                names.unshift(getName(value));
            }
        }

        if (v !== 0) {
            return original.toString();
        }

        if (original !== 0) {
            return names.join(", ");
        }

        return zeroValueName || "0";
    },
    getValues: function ($t) {
        var result = [];

        var p = $t.InstanceConstructor._isEnum ? $t.InstanceConstructor : $t.InstanceConstructor.prototype;
        for (var member in p) {
            if (p.hasOwnProperty(member)) {
                if (typeof p[member] === "number") {
                    result.push(p[member]);
            }
        }
        }

        return result;
    },
    isDefined: function ($t, value) {
        value = $.ig.util.getValue(value);
        var p = $t.InstanceConstructor._isEnum ? $t.InstanceConstructor : $t.InstanceConstructor.prototype;
        for (var member in p) {
            if (p.hasOwnProperty(member)) {
                if (p[member] === value) {
                    return true;
            }
        }
        }

        return false;
    },
    // TODO: Fill out remaining IConvertible implementation
    toDouble: function(provider) {
        return this.value();
    },
    toObject: function($t, value) {
        return value;
    },
    tryParse$1: function ($tEnum, value, ignoreCase, result) {
        try {
            return {
                ret: true,
                p2: this.parse($tEnum, value, ignoreCase).value()
            };
        } catch (e) {
            result = $.ig.util.createInstance($tEnum);
            return {
                ret: false,
                p2: result
            };
        }
    },
    $type: new $.ig.Type('Enum', $.ig.Object.prototype.$type, [$.ig.IConvertible.prototype.$type])
}, true);
$.ig.$e = $.ig.Enum;
$.ig.$ep = $.ig.Enum.prototype;
$.ig.$et = $.ig.Enum.prototype.$type;

$.ig.ValueType = Class.extend({
	init: function () {

    },
	$type: new $.ig.Type('ValueType', $.ig.Object.prototype.$type)
}, true);

    $.ig.INotifyPropertyChanged = Class.extend({
        init: function () {

        },
        _PropertyChanged: function () {

        },
        $type: new $.ig.Type('INotifyPropertyChanged')
    }, true);

    $.ig.PropertyChangedEventArgs = $.ig.Object.extend({
        init: function(propertyName) {
            this._propertyName = propertyName;
        },
        _propertyName: null,
        propertyName: function (value) {
            if (arguments.length === 0) {
                return this._propertyName;
            }
            else {
                this._propertyName = value;
            }
        },
        $type: new $.ig.Type('PropertyChangedEventArgs', $.ig.Object.$type)
    }, true);

    $.ig.XmlNodeType = Class.extend({
        _None: 0,
        _Attribute:2,
        _CDATA:4,
        _Comment:8,
        _Document:9,
        _DocumentFragment:11,
        _DocumentType:10,
        _Element: 1,
        _EndElement: 15,
        _EndEntity: 16,
        _Entity:6,
        _EntityReference: 5,
        _Notation:12,
        _ProcessingInstruction: 7,
        _SignificantWhitespace: 14,
        _Text: 3,
        _Whitespace: 13,
        _XmlDeclaration: 17,

        none: 0,
    element: 1,
    attribute: 2,
    text: 3,
    cDATA: 4,
    entityReference: 5,
    entity: 6,
    processingInstruction: 7,
    comment: 8,
    document: 9,
    documentType: 10,
    documentFragment: 11,
        notation: 12,
		whitespace: 13,
		significantWhitespace: 14,
		endElement: 15,
		endEntity: 16,
		xmlDeclaration: 17

    }, true);

    $.ig.XmlDocumentParser = Class.extend({
		parse: function (markup) {
			if (!window.DOMParser) {
				var parsers = [ 'Msxml2.DOMDocument.3.0', 'Msxml2.DOMDocument' ];

				for (var i = 0; i < parsers.length; i++) {
					try {
					    var xmlDOM = new ActiveXObject(parsers[i]);
						xmlDOM.async = false;
						xmlDOM.loadXML(markup);
						xmlDOM.setProperty('SelectionLanguage', 'XPath');
						
						return xmlDOM;
					}
					catch (ex) {
					}
				}
			} else {
				try {
					var domParser = new DOMParser();
					return domParser.parseFromString(markup, 'text/xml');
				}
				catch (ex) {
				}
			}
			return null;
		}
    }, true);

    $.ig.Array = Array;

    $.ig.extendNativePrototype(Array.prototype, "$type", new $.ig.Type('Array', $.ig.Object.prototype.$type));

    /*
    $.ig.Array.prototype.add = function (item) {
        this[this.length] = item;
    };

	$.ig.Array.prototype.indexOf = function (item) {
		for (var i=0; i<this.length; i++)
		{
			if (this[i] == item)
				return i;			
		}
		return -1;
	};

$.ig.Array.prototype.copy = function (source, sourceIndex, dest, destIndex, count) {
    for (i = 0; i < count; i++) {
        dest[destIndex + i] = source[sourceIndex + i];
    }
};
	*/
    $.ig.extendNativePrototype(Array.prototype, "add", function (item) {
        this[this.length] = item;
    });

    $.ig.addToArray = function (arr, item) {
        arr[arr.length] = item;
    };

    $.ig.indexInArray = function (arr, item) {
        for (var i = 0; i < arr.length; i++) {
            if (arr[i] == item) {
                return i;
        }
        }
        return -1;
    };

    $.ig.arrayContains = function (arr, item) {
        var index = arr.indexOf(item);
        return (index >= 0);
    };

    $.ig.extendNativePrototype(Array.prototype, "indexOf", function (item) {
        for (var i = 0; i < this.length; i++) {
            if (this[i] == item) {
                return i;
        }
        }
        return -1;
    });

    // TODO: Can we remove this? We have $.ig.util.arrayCopy1 now
    $.ig.extendNativePrototype(Array.prototype, "copy", function (source, sourceIndex, dest, destIndex, count) {
        for (var i = 0; i < count; i++) {
            dest[destIndex + i] = source[sourceIndex + i];
        }
    });
 
	$.ig.removeFromArray = function (arr, from, to) {
		var rest = arr.slice((to || from) + 1 || arr.length);
		arr.length = from < 0 ? arr.length + from : from;
		return arr.push.apply(arr, rest);
	};
    /*
    $.ig.Array.prototype.contains =  function (item) {
        var index = this.indexOf(item);
        return (index >= 0);
    };

    $.ig.Array.prototype.insert = function (index, item) {
        this.splice(index, 0, item);
    };

    $.ig.Array.prototype.removeAt = function (i) {
        this.splice(i, 1);
    };

    $.ig.Array.prototype.removeItem = function (item) {
        var index = this.indexOf(item);
        if (index >= 0) {
            this.splice(index, 1);
            return true;
        }
        return false;
    };

    $.ig.Array.prototype.getEnumerator = function () {
         return new $.ig.ArrayEnumerator(this);
    };

    $.ig.Array.prototype.count = function () {
        return this.length;
    };

    $.ig.Array.prototype.item = function (index, value) {
        if (arguments.length === 2) {
            this[index] = value;
            return value;
        } else {
            return this[index];
        }
    };

    $.ig.Array.prototype.getLength = function (dimension) {
        if (dimension === 0) {
            return this.length;
        }
        else {
            return this.dimensionLength[dimension - 1];
        }
};

$.ig.Array.prototype.clear = function () {
    this.length = 0;
};
    */
	$.ig.extendNativePrototype(Array.prototype, "contains", function (item) {
	    var index = this.indexOf(item);
	    return (index >= 0);
	});

	$.ig.extendNativePrototype(Array.prototype, "insert", function (index, item) {
	    this.splice(index, 0, item);
	});

	$.ig.extendNativePrototype(Array.prototype, "removeAt", function (i) {
	    this.splice(i, 1);
	});

	$.ig.extendNativePrototype(Array.prototype, "removeItem", function (item) {
	    var index = this.indexOf(item);
	    if (index >= 0) {
	        this.splice(index, 1);
	        return true;
	    }
	    return false;
	});

	$.ig.extendNativePrototype(Array.prototype, "getEnumerator", function () {
	    return new $.ig.ArrayEnumerator(this);
	});

	$.ig.extendNativePrototype(Array.prototype, "count", function () {
	    return this.length;
	});

	$.ig.extendNativePrototype(Array.prototype, "item", function (index, value) {
	    if (arguments.length === 2) {
	        this[index] = value;
	        return value;
	    } else {
	        return this[index];
	    }
	});

	$.ig.extendNativePrototype(Array.prototype, "getLength", function (dimension) {

        // TODO: Is there a better way to do this? Maybe attach the rank values to the array?

	    var array = this;
	    var dim = dimension;

	    while (array) {
	        if (dim === 0) {
	            return array.length;
	        }

	        dim--;
	        array = array[0];
	    }

	    return this.dimensionLength[dimension - 1];
	});

    $.ig.extendNativePrototype(Array.prototype, "resize", function () {
        this.length = 0;
    });

    $.ig.ArrayEnumerator = Class.extend({
 
        init: function (array) {
            this._array = array;
            this._index = -1;
        },
        current: function() {
            return this._array[this._index];
        },
        moveNext: function() {
            this._index++;
            return (this._index < this._array.length);
        },
        reset: function() {
            this._index = -1;
        },
        dispose: function () { }
    }, true);

    $.ig.Date = Class.extend({
        init: function () {
            return new Date();
        },
        fromOADate: function (value) {
            var result = new Date(+(new Date(1899, 11, 30)) + (value * 86400000));

            if (result.dst && result.dst()) {
                return $.ig.Date.prototype.addHours(result, -1);
            }

            return result;
        },
        fromValues: function (year, month, day, hour, minute, second, millisecond) {
            return new Date(year, month - 1, day, hour, minute, second, millisecond);
        },
        fromTicks: function (ticks) {
            return new Date(ticks);
        },
        addHours: function (value, hours) {
            return $.ig.Date.prototype.addDays(value, hours / 24);
        },
        addDays: function(value, days)
        {
            var result = new Date(+value + (days * 86400000));

            // Correct for any daylight saving time shifts
            if (value.dst) {
                if (!value.dst()) {
                    if (result.dst()) {
                        result = new Date(+result - 3600000);
                    }
                } else {
                    if (!result.dst()) {
                        result = new Date(+result + 3600000);
                    }
                }
            }

            return result;
        },
        daysInMonth: function (year, month) {
            switch (month) {
                case 1: return 31; // Jan
                case 2: return $.ig.Date.prototype.isLeapYear(year) ? 29 : 28; // Feb
                case 3: return 31; // Mar
                case 4: return 30; // Apr
                case 5: return 31; // May
                case 6: return 30; // Jun
                case 7: return 31; // Jul
                case 8: return 31; // Aug
                case 9: return 30; // Sep
                case 10: return 31; // Oct
                case 11: return 30; // Nov
                case 12: return 31; // Dec
        }

            // TODO: throw error here?
            return 0;
        },
        isLeapYear: function (year) {
            return year % 4 === 0 && year % 100 !== 0;
        },
        toFileTime: function (value) {
            return (value - new Date(1600, 11, 31, 19, 0, 0, 0)) * 10000;
        },
        fromFileTime: function (value) {
            // TODO: Test this
            return (value / 10000) + new Date(1600, 11, 31, 19, 0, 0, 0);
        },
        tryParse: function (s) {
            var date = new Date(s);
            if (date === null || $.ig.util.isNaN(+date)) {
                return { p1: null, ret: false };
            }

            return { p1: date, ret: true };
        },
        parseExact: function (s, format, provider) {
            // TODO: Use the format and provider
            var r = $.ig.Date.prototype.tryParse(s);

            if (!r) {
                throw new $.ig.FormatException("Unknown date format");
            }

            return r.value;
        },
        toLocalTime: function (value) {
            // TODO: Implement
            return value;
        },
        toUniversalTime: function (value) {
            // TODO: Implement
            return value;
        },
        $type: new $.ig.Type('Date', $.ig.Object.$type)
    }, true);

    $.ig.extendNativePrototype(Date.prototype, "toOADate", function () {
        var result = (this - new Date(1899, 11, 30)) / 86400000;

        if (this.dst && this.dst()) {
            return result + (1 / 24);
        }

        return result;
    });

    $.ig.extendNativePrototype(Date.prototype, "kind", function () {
        return $.ig.DateTimeKind.prototype.local;
    });

    $.ig.Date.prototype.now = function () {
        return new Date();
    };
    $.ig.Date.prototype.minValue = function () {
        return new Date(1, 1, 1, 0, 0, 0, 0);
    };
    $.ig.Date.prototype.maxValue = function () {
        return new Date(9999, 12, 31, 23, 59, 59, 0.9999999);
    };
    $.ig.Date.prototype.fromMilliseconds = function (value) { 
        return value;
};

    $.ig.Date.prototype.toStringFormat = function (value, format, provider) {
        provider = provider || $.ig.CultureInfo.prototype.currentCulture(); // TODO: Use the provider below
        switch (format) {
            case 's':
                {
                    var s = value.toISOString();
                    var d = s.lastIndexOf('.');
                    if (d < 0) {
                        return d;
                    }

                    return s.slice(0, d);
                }
        }
        
        throw Error("Unknown format");
    };

    // implement casting
    $.ig.util.canAssign = function (targetType, type) {
        var nullableTypeName = $.ig.Nullable$1.prototype.$type.typeName();
        if (targetType.typeName && targetType.typeName() === nullableTypeName &&
            (!type.typeName || type.typeName() !== nullableTypeName)) {
            targetType = $.ig.Nullable.prototype.getUnderlyingType(targetType);
        }

        if ($.ig.Type.prototype.checkEquals(targetType, type)) {
            return true;
        }
        if (type.interfaces) {
            for (var i = 0; i < type.interfaces.length; i++) {
                if ($.ig.util.canAssign(targetType, type.interfaces[i])) {
                    return true;
                }
            }
        }
        if (type.baseType) {
            return $.ig.util.canAssign(targetType, type.baseType);
        }

        return false;
    };

    $.ig.util.cast = function (targetType, obj) {
		if (obj === undefined || obj === null) {
            return null;
        }
       
		if (targetType === String) {
		    targetType = $.ig.String.prototype.$type;
		}

        var type = obj;
        
        if (obj.$type) {
            type = obj.$type;
        }
        else if (typeof obj === 'number') {
            type = targetType === Number ? Number : $.ig.Number.prototype.$type;
        }
        else if (typeof obj === 'string') {
            type = $.ig.String.prototype.$type;
        }
        else if (typeof obj === 'boolean') {
            type = $.ig.Boolean.prototype.$type;
        }
        else if (obj instanceof Date) {
            type = $.ig.Date.prototype.$type;
        }
       
        var nullableTypeName = $.ig.Nullable$1.prototype.$type.typeName();
        if (targetType.typeName && targetType.typeName() === nullableTypeName &&
            (!type.typeName || type.typeName() !== nullableTypeName)) {
            targetType = $.ig.Nullable.prototype.getUnderlyingType(targetType);
            if ($.ig.util.canAssign(targetType, type)) {
                return $.ig.util.toNullable(targetType, obj);
            } else {
                return $.ig.util.toNullable(targetType, null);
            }
        }
       
        if ($.ig.util.canAssign(targetType, type)) {
            return obj;
        } else {
            return null;
        }
    };

    $.ig.Dictionary = Class.extend({
        init: function () {
            this.proxy = {};
            this.keysHolder = this.proxy;
            this._count = 0;
        },
        $type: new $.ig.Type('Dictionary', $.ig.Object.prototype.$type),
        proxy: null
    }, true);

    $.ig.Dictionary.prototype.getDictionary = function (o) {
        var dict = new $.ig.Dictionary();
        dict.proxy = o;
        dict.keysHolder = o;
        return dict;
    };

$.ig.Dictionary.prototype.containsKey = function (key) {
        return this.proxy[key] !== undefined;
};

    $.ig.Dictionary.prototype.count = function () {
        return this._count;
};

    $.ig.Dictionary.prototype.item = function (key, value) {
        if (arguments.length === 1) {
            return this.proxy[key];
        } 
        else {
            if (!this.proxy[key]) {
                this._count++;
            }
            this.proxy[key] = value;
        }       
};

    $.ig.Dictionary.prototype.add = function (key, value) {
        if (!this.proxy[key]) {
            this._count++;
        }
        this.proxy[key] = value;
};

    $.ig.Dictionary.prototype.remove = function (key) {
        delete this.proxy[key];
        this._count--;
};

    $.ig.Dictionary.prototype.keys = function () {
        return new $.ig.KeyEnumerator(this);
};

    $.ig.Dictionary.prototype.values = function () {
        return new $.ig.ValueEnumerator(this);
};

    $.ig.Dictionary.prototype.clear = function () {
        this.proxy = {};
        this.keysHolder = this.proxy;
        this._count = 0;
};

    $.ig.EventArgs  = $.ig.Object.extend({
        init: function () {

        }
    }, true);

$.ig.String = Class.extend({
    $type: new $.ig.Type('String', $.ig.Object.prototype.$type, [$.ig.IConvertible.prototype.$type, $.ig.IComparable.prototype.$type])
}, true);

$.ig.String.prototype.isDigit = function (str, index) {
    index = index || 0;
    var ch = str.charAt(index);
    if (ch >= '0' && ch <= '9') {
        return true;
    }

    return false;
};

$.ig.String.prototype.charMaxValue = function (s) {
    return 65535;
};

$.ig.String.prototype.charMinValue = function (s) {
    return 0;
};

$.ig.Boolean = Class.extend({
    tryParse: function (value) {

        value = value.toLowerCase();
        if (value == 'true') {
            return { p1: true, ret: true };
        }
        else if (value == 'false') {
            return { p1: false, ret: true };
        }
    
        return { p1: false, ret: false };
    },
    $type: new $.ig.Type('Boolean', $.ig.Object.prototype.$type, [$.ig.IConvertible.prototype.$type, $.ig.IComparable.prototype.$type])
}, true);

    $.ig.Number = Class.extend({
        $type: new $.ig.Type('Number', $.ig.Object.prototype.$type, [$.ig.IConvertible.prototype.$type, $.ig.IComparable.prototype.$type])
    }, true);

    $.ig.Number.prototype.parseInt = function (a,b) {
            return parseInt(a,b);
        };

$.ig.Number.prototype.log10 = function (x) {
        return Math.log(x) / Math.log(10);
};

if (!Number.isPrimitive) {
    Number.isPrimitive = function () { return true; };
}

if (!String.isPrimitive) {
    String.isPrimitive = function () { return false; };
}

$.ig.extendNativePrototype(String.prototype, "toDecimal", function (provider) {
    var result = +this;

    if ($.ig.util.isNaN(result)) {
        throw new $.ig.FormatException(1, "The string cannot be converted to a number");
    }

    return result;
});

$.ig.extendNativePrototype(String.prototype, "toString1", function (provider) {
    return this.toString();
});

$.ig.extendNativePrototype(Number.prototype, "toDecimal", function (provider) {
    return +this;
});

$.ig.extendNativePrototype(Number.prototype, "toDouble", function (provider) {
    return +this;
});

$.ig.extendNativePrototype(Number.prototype, "toString1", function (provider) {
    return this.toLocaleString(provider.name(), {useGrouping: false}); // TODO: Figure out how to use the provider correctly here
});

$.ig.extendNativePrototype(Date.prototype, "getType", function (provider) {
    return $.ig.Date.prototype.$type;
});

$.ig.extendNativePrototype(Date.prototype, "equals", function (other) {
    return other instanceof Date && +this === +other;
});

$.ig.extendNativePrototype(Boolean.prototype, "getHashCode", function (provider) {
    return +this;
});

$.ig.extendNativePrototype(Boolean.prototype, "toByte", function (provider) {
    return +this;
});

$.ig.extendNativePrototype(Boolean.prototype, "toSByte", function (provider) {
    return +this;
});

$.ig.extendNativePrototype(Boolean.prototype, "toInt16", function (provider) {
    return +this;
});

$.ig.extendNativePrototype(Boolean.prototype, "toUInt16", function (provider) {
    return +this;
});

$.ig.extendNativePrototype(Boolean.prototype, "toInt32", function (provider) {
    return +this;
});

$.ig.extendNativePrototype(Boolean.prototype, "toUInt32", function (provider) {
    return +this;
});

$.ig.extendNativePrototype(Boolean.prototype, "toInt64", function (provider) {
    return +this;
});

$.ig.extendNativePrototype(Boolean.prototype, "toUInt64", function (provider) {
    return +this;
});

$.ig.extendNativePrototype(Boolean.prototype, "toSingle", function (provider) {
    return +this;
});

$.ig.extendNativePrototype(Boolean.prototype, "toDouble", function (provider) {
    return +this;
});

$.ig.extendNativePrototype(Boolean.prototype, "toDecimal", function (provider) {
    return +this;
});

$.ig.extendNativePrototype(Boolean.prototype, "toBoolean", function (provider) {
    /*jshint -W018 */
    return !!+this;
});

$.ig.extendNativePrototype(Boolean.prototype, "toString1", function (provider) {
    return this.toString();
});

$.ig.extendNativePrototype(Boolean.prototype, "compareTo", function (other) {
    return $.ig.util.boolCompare(this, other);
});

$.ig.extendNativePrototype(Number.prototype, "compareTo", function (other) {
    return $.ig.util.compareSimple(+this, other);
});

    $.ig.Single = Class.extend({

    }, true);

    $.ig.Single.prototype.parseFloat = function (s) {
            return parseFloat(s);
        };

$.ig.Single.prototype.isInfinity = function (s) {
    return s === Infinity || s === -Infinity;
};

    $.ig.Int32 = Class.extend({
        $type: new $.ig.Type('Int32', $.ig.Object.prototype.$type)
    }, true);

    $.ig.Double = Class.extend({
        $type: new $.ig.Type('Double', $.ig.Object.prototype.$type)
    }, true);

    $.ig.Delegate = Class.extend({
        $type: new $.ig.Type('Delegate', $.ig.Object.prototype.$type)
    }, true);

$.ig.Delegate.prototype.combine = function (del1, del2) {
	if (!del1) {
            return del2;
        }

	if (!del2) {
            return del1;
        }

        var ret = function () {
            del1.apply(null, arguments);
            return del2.apply(null, arguments);
	};
        ret.enumerate = function (arr) {
            if (del1) {
                if (del1.enumerate) {
                    del1.enumerate(arr);
                } else {
                    arr.push(del1);
                }
            }
            if (del2) {
                if (del2.enumerate) {
                    del2.enumerate(arr);
                } else {
                    arr.push(del2);
                }
            }
	};

        return ret;
};

$.ig.Delegate.prototype.remove = function (del1, del2) {
        if (!del1) {
            return null;
        }
        if (!del2) {
            return del1;
        }

        var arr = [];
        var del = null;
        if (del1.enumerate) {
            del1.enumerate(arr);
        } else {
            arr.push(del1);
        }

        for (var i = 0; i < arr.length; i++) {
            if (del2.original) {
                if (arr[i].original == del2.original &&
                    arr[i].target == del2.target) {
                    continue;
                }
            }

            if (arr[i] == del2) {
                continue;
            }

            del = $.ig.Delegate.prototype.combine(del, arr[i]);
        }

        return del;
};

   $.ig.ReflectionUtil = Class.extend({
        $type: new $.ig.Type('ReflectionUtil', $.ig.Object.prototype.$type)
   }, true);

   $.ig.ReflectionUtil.prototype.getPropertyGetter = function (type, propertyName) {
        if (typeof type.prototype[propertyName] === "function") { 
            return function (instance) {
                return type.prototype[propertyName].apply(instance, arguments);
            };
        }

        return function (instance) {
            return instance[propertyName];
};
};

   $.ig.IEnumerable = Class.extend({
		$type: new $.ig.Type('IEnumerable', null)
   }, true);

   $.ig.IEnumerator = Class.extend({
		$type: new $.ig.Type('IEnumerator', null)
   }, true);

$.ig.IEqualityComparer$1 = Class.extend({
    $type: new $.ig.Type('IEqualityComparer', $.ig.Object.prototype.$type)
}, true);

   $.ig.IList = Class.extend({
		$type: new $.ig.Type('IList', null, [$.ig.IEnumerable.prototype.$type])
   }, true);

   $.ig.IEnumerable$1 = Class.extend({
       $type: new $.ig.Type('IEnumerable$1', null, [$.ig.IEnumerable.prototype.$type])
   }, true);

   $.ig.ICollection$1 = Class.extend({
       $type: new $.ig.Type('ICollection$1', null, [$.ig.IEnumerable$1.prototype.$type.specialize(0), $.ig.IEnumerable.prototype.$type])
   }, true);

   $.ig.IList$1 = Class.extend({
       $type: new $.ig.Type('IList$1', null, [$.ig.ICollection$1.prototype.$type.specialize(0), $.ig.IEnumerable$1.prototype.$type.specialize(0), $.ig.IEnumerable.prototype.$type])
   }, true);

   $.ig.IEnumerator$1 = Class.extend({
       $type: new $.ig.Type('IEnumerator$1', null, [$.ig.IEnumerator.prototype.$type])
   }, true);


   $.ig.Error = Class.extend({
	init: function (initNumber) {
		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
				case 2:
					this.init2.apply(this, arguments);
					break;
			}
			return;
		}
		this.__message = null;
		this.__innerException = null;
	},
	init1: function (initNumber, message) {
		this.__message = message;
	},
	init2: function (initNumber, message, innerException) {
		this.__message = message;
		this.__innerException = innerException;
	},
        $type: new $.ig.Type('Error', $.ig.Object.prototype.$type)
   }, true);

$.ig.Error.prototype.message = function () {
	return this.__message;
};

$.ig.Error.prototype.innerException = function () {
	return this.__innerException;
};

   $.ig.IDictionary = Class.extend({
        $type: new $.ig.Type('IDictionary', null)
   }, true);

    $.ig.ValueEnumerator = Class.extend({
        init: function (dict) {
            this._dict = dict;
            this._index = -1;
            this._count = 0;
            this._values = [];
            for (var item in this._dict.proxy) {
                if (this._dict.proxy.hasOwnProperty(item)) {
                    this._values[this._count] = this._dict.proxy[item];
                    this._count++;
                }
            }
        },
        current: function() {
            return this._values[this._index];
        },
        dispose: function () {
        },
        moveNext: function() {
            this._index++;
            return (this._index < this._count);
        },
        reset: function() {
            this._index = -1;
        },
        getEnumerator: function() {
            this.reset();
            return this;
        },
        $type: new $.ig.Type('ValueEnumerator', $.ig.Object.prototype.$type, [$.ig.IEnumerable.prototype.$type])
    }, true);

     $.ig.KeyEnumerator = Class.extend({
 
        init: function (dict) {
            this._dict = dict;
            this._index = -1;
            this._count = 0;
            this._keys = [];
            for (var item in this._dict.proxy) {
                if (this._dict.proxy.hasOwnProperty(item)) {
                    this._keys[this._count] = item;
                    this._count++;
                }
            }
        },
        current: function() {
            return this._keys[this._index];
        },
        moveNext: function() {
            this._index++;
            return (this._index < this._count);
        },
        reset: function() {
            this._index = -1;
        },
        getEnumerator: function() {
            this.reset();
            return this;
        },
        $type: new $.ig.Type('KeyEnumerator', $.ig.Object.prototype.$type, [$.ig.IEnumerable.prototype.$type])
    }, true);

     $.ig.truncate = function (val) {
         if (val >= 0) {
             return Math.floor(val);
        } else {
             return Math.ceil(val);
        }
};

    $.ig.intDivide = function (int1, int2) {
        var result = int1 / int2;
        return $.ig.truncate(result);
};

    $.ig.Nullable = Class.extend({
		getUnderlyingType: function (nullableType) {
		    if (nullableType.isGenericType !== undefined && nullableType.isGenericType() && !nullableType.isGenericTypeDefinition() && $.ig.Nullable$1.prototype.$type.typeName() == nullableType.typeName()) {
		        return nullableType.genericTypeArguments()[0];
		    }

		    return null;
		},

		$type: new $.ig.Type('Nullable', $.ig.Object.prototype.$type)
	}, true);

    $.ig.Nullable$1 = Class.extend({
        $t: null,
        init: function($t, value) {
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
            $.ig.Object.prototype.init.call(this);

            if (value !== undefined) {
                this._value = value;
            }
        },
        equals: function(value) {
            return $.ig.util.nullableEquals(this, value);
        },
        getHashCode: function() {
            return this._value === null ? 0 : this._value.getHashCode();
        },
        hasValue: function() {
            return this._value !== null;
        },
        _value: null,
        value: function(value) {
            if (arguments.length === 1) {
                this._value = value;
            } else {
                return this._value;
            }
        },
        getValueOrDefault: function() {
            if (this.hasValue()) {
                return this._value;
            } else {
                return this.getDefaultValue();
            }
        },
        getDefaultValue: function() { 
            if ($.ig.util.canAssign($.ig.Number.prototype.$type, this.$t)) {
                return 0;
            } else if ($.ig.util.canAssign($.ig.Boolean.prototype.$type, this.$t)) {
                return false;
            } else {
                return null;
            }
        },
        getValueOrDefault1: function(defaultValue) {
            if (this.hasValue()) {
                return this._value;
            } else {
                return defaultValue;
            }
        },
        preIncrement: function() {
            if (!this.hasValue()) {
                return this;
            }

            this._value++;
            return this;
			},
        preDecrement: function () {
            if (!this.hasValue()) {
                return this;
            }

            this._value--;
            return this;
        },
        postIncrement: function () {
            if (!this.hasValue()) {
                return this;
            }

            var originalValue = this._value;
            this._value++;
            return new $.ig.Nullable$1(this.$t, originalValue);
        },
        postDecrement: function () {
            if (!this.hasValue()) {
                return this;
            }

            var originalValue = this._value;
            this._value--;
            return new $.ig.Nullable$1(this.$t, originalValue);
        },
        isNullable: true,
        $type: new $.ig.Type('Nullable$1', $.ig.Object.prototype.$type)
    }, true);

$.ig.util.toNullable = function (t, value) {
        if (value && value.isNullable) {
            return value;
        }

        var ret = new $.ig.Nullable$1(t, value);
        return ret;
};

$.ig.util.toLowerCase = function (c) {
    return c.toLowerCase();
};

$.ig.util.toUpperCase = function (c) {
    return c.toUpperCase();
};

$.ig.util.nullableAdd = function (v1, v2) {
        if (v1.isNullable && !v1.hasValue()) {
            return null;
        }
        if (v2.isNullable && !v2.hasValue()) {
            return null;
        }

        var val1 = v1;
        var val2 = v2;
        if (v1.isNullable) {
            val1 = v1.value();
        }
        if (v2.isNullable) {
            val2 = v2.value();
        }

        return $.ig.util.toNullable($.ig.Number.prototype.$type, val1 + val2);
};

$.ig.util.nullableSubtract = function (v1, v2) {
        if (v1.isNullable && !v1.hasValue()) {
            return null;
        }
        if (v2.isNullable && !v2.hasValue()) {
            return null;
        }

        var val1 = v1;
        var val2 = v2;
        if (v1.isNullable) {
            val1 = v1.value();
        }
        if (v2.isNullable) {
            val2 = v2.value();
        }

        return $.ig.util.toNullable($.ig.Number.prototype.$type, val1 - val2);
};

$.ig.util.nullableMultiply = function (v1, v2) {
        if (v1.isNullable && !v1.hasValue()) {
            return null;
        }
        if (v2.isNullable && !v2.hasValue()) {
            return null;
        }

        var val1 = v1;
        var val2 = v2;
        if (v1.isNullable) {
            val1 = v1.value();
        }
        if (v2.isNullable) {
            val2 = v2.value();
        }

        return $.ig.util.toNullable($.ig.Number.prototype.$type, val1 * val2);
};

$.ig.util.nullableDivide = function (v1, v2) {
        if (v1.isNullable && !v1.hasValue()) {
            return null;
        }
        if (v2.isNullable && !v2.hasValue()) {
            return null;
        }

        var val1 = v1;
        var val2 = v2;
        if (v1.isNullable) {
            val1 = v1.value();
        }
        if (v2.isNullable) {
            val2 = v2.value();
        }

        return $.ig.util.toNullable($.ig.Number.prototype.$type, val1 / val2);
};

$.ig.util.nullableModulus = function (v1, v2) {
        if (v1.isNullable && !v1.hasValue()) {
            return null;
        }
        if (v2.isNullable && !v2.hasValue()) {
            return null;
        }

        var val1 = v1;
        var val2 = v2;
        if (v1.isNullable) {
            val1 = v1.value();
        }
        if (v2.isNullable) {
            val2 = v2.value();
        }

        return $.ig.util.toNullable($.ig.Number.prototype.$type, val1 % val2);
};

$.ig.util.nullableGreaterThan = function (v1, v2) {
        if (v1.isNullable && !v1.hasValue()) {
            return false;
        }
        if (v2.isNullable && !v2.hasValue()) {
            return false;
        }

        var val1 = v1;
        var val2 = v2;
        if (v1.isNullable) {
            val1 = v1.value();
        }
        if (v2.isNullable) {
            val2 = v2.value();
        }

        return val1 > val2;
};

$.ig.util.nullableGreaterThanOrEqual = function (v1, v2) {
        if (v1.isNullable && !v1.hasValue()) {
            return false;
        }
        if (v2.isNullable && !v2.hasValue()) {
            return false;
        }

        var val1 = v1;
        var val2 = v2;
        if (v1.isNullable) {
            val1 = v1.value();
        }
        if (v2.isNullable) {
            val2 = v2.value();
        }

        return val1 >= val2;
};

$.ig.util.nullableLessThan = function (v1, v2) {
        if (v1.isNullable && !v1.hasValue()) {
            return false;
        }
        if (v2.isNullable && !v2.hasValue()) {
            return false;
        }

        var val1 = v1;
        var val2 = v2;
        if (v1.isNullable) {
            val1 = v1.value();
        }
        if (v2.isNullable) {
            val2 = v2.value();
        }

        return val1 < val2;
};

$.ig.util.nullableLessThanOrEqual = function (v1, v2) {
        if (v1.isNullable && !v1.hasValue()) {
            return false;
        }
        if (v2.isNullable && !v2.hasValue()) {
            return false;
        }

        var val1 = v1;
        var val2 = v2;
        if (v1.isNullable) {
            val1 = v1.value();
        }
        if (v2.isNullable) {
            val2 = v2.value();
        }

        return val1 <= val2;
};

$.ig.util.nullableIsNull = function (v) {
    /*jshint eqnull:true */
    return v == null || (!!v.isNullable && !v.hasValue());
};

$.ig.util.nullableEquals = function (v1, v2) {
    /*jshint eqnull:true */
	var v1IsNull = (v1 == null) || (!!v1.isNullable && !v1.hasValue());
	var v2IsNull = (v2 == null) || (!!v2.isNullable && !v2.hasValue());

    if (v1IsNull && v2IsNull) {
        return true;
    }
    if (v1IsNull != v2IsNull) {
        return false;
    }

    var val1 = v1;
    var val2 = v2;
    if (v1.isNullable) {
        val1 = v1.value();
    }
    if (v2.isNullable) {
        val2 = v2.value();
    }

    return val1 == val2;
};

$.ig.util.nullableNotEquals = function (v1, v2) {
    return !$.ig.util.nullableEquals(v1, v2);
};

$.ig.util.unwrapNullable = function (v) {
    /*jshint eqnull:true */
    if (v == null || !v.isNullable) {
        return v;
    }

    if (!v.hasValue()) {
        return null;
    }

    return v.value();
};

$.ig.util.wrapNullable = function ($t, v) {
    /*jshint eqnull:true */
    if (v != null && v.isNullable) {
        return v;
    }

    return $.ig.util.toNullable($t, v);
};

$.ig.util.getColorStringSafe = function (v) {
    /*jshint eqnull:true */
    return v == null ? null : v.colorString();
};

    $.ig.util.wellKnownColors = {
        aliceblue: 'f0f8ff',
        antiquewhite: 'faebd7',
        aqua: '00ffff',
        aquamarine: '7fffd4',
        azure: 'f0ffff',
        beige: 'f5f5dc',
        bisque: 'ffe4c4',
        black: '000000',
        blanchedalmond: 'ffebcd',
        blue: '0000ff',
        blueviolet: '8a2be2',
        brown: 'a52a2a',
        burlywood: 'deb887',
        cadetblue: '5f9ea0',
        chartreuse: '7fff00',
        chocolate: 'd2691e',
        coral: 'ff7f50',
        cornflowerblue: '6495ed',
        cornsilk: 'fff8dc',
        crimson: 'dc143c',
        cyan: '00ffff',
        darkblue: '00008b',
        darkcyan: '008b8b',
        darkgoldenrod: 'b8860b',
        darkgray: 'a9a9a9',
        darkgreen: '006400',
        darkkhaki: 'bdb76b',
        darkmagenta: '8b008b',
        darkolivegreen: '556b2f',
        darkorange: 'ff8c00',
        darkorchid: '9932cc',
        darkred: '8b0000',
        darksalmon: 'e9967a',
        darkseagreen: '8fbc8f',
        darkslateblue: '483d8b',
        darkslategray: '2f4f4f',
        darkturquoise: '00ced1',
        darkviolet: '9400d3',
        deeppink: 'ff1493',
        deepskyblue: '00bfff',
        dimgray: '696969',
        dodgerblue: '1e90ff',
        feldspar: 'd19275',
        firebrick: 'b22222',
        floralwhite: 'fffaf0',
        forestgreen: '228b22',
        fuchsia: 'ff00ff',
        gainsboro: 'dcdcdc',
        ghostwhite: 'f8f8ff',
        gold: 'ffd700',
        goldenrod: 'daa520',
        gray: '808080',
        green: '008000',
        greenyellow: 'adff2f',
        honeydew: 'f0fff0',
        hotpink: 'ff69b4',
        indianred : 'cd5c5c',
        indigo : '4b0082',
        ivory: 'fffff0',
        khaki: 'f0e68c',
        lavender: 'e6e6fa',
        lavenderblush: 'fff0f5',
        lawngreen: '7cfc00',
        lemonchiffon: 'fffacd',
        lightblue: 'add8e6',
        lightcoral: 'f08080',
        lightcyan: 'e0ffff',
        lightgoldenrodyellow: 'fafad2',
        lightgrey: 'd3d3d3',
        lightgreen: '90ee90',
        lightpink: 'ffb6c1',
        lightsalmon: 'ffa07a',
        lightseagreen: '20b2aa',
        lightskyblue: '87cefa',
        lightslateblue: '8470ff',
        lightslategray: '778899',
        lightsteelblue: 'b0c4de',
        lightyellow: 'ffffe0',
        lime: '00ff00',
        limegreen: '32cd32',
        linen: 'faf0e6',
        magenta: 'ff00ff',
        maroon: '800000',
        mediumaquamarine: '66cdaa',
        mediumblue: '0000cd',
        mediumorchid: 'ba55d3',
        mediumpurple: '9370d8',
        mediumseagreen: '3cb371',
        mediumslateblue: '7b68ee',
        mediumspringgreen: '00fa9a',
        mediumturquoise: '48d1cc',
        mediumvioletred: 'c71585',
        midnightblue: '191970',
        mintcream: 'f5fffa',
        mistyrose: 'ffe4e1',
        moccasin: 'ffe4b5',
        navajowhite: 'ffdead',
        navy: '000080',
        oldlace: 'fdf5e6',
        olive: '808000',
        olivedrab: '6b8e23',
        orange: 'ffa500',
        orangered: 'ff4500',
        orchid: 'da70d6',
        palegoldenrod: 'eee8aa',
        palegreen: '98fb98',
        paleturquoise: 'afeeee',
        palevioletred: 'd87093',
        papayawhip: 'ffefd5',
        peachpuff: 'ffdab9',
        peru: 'cd853f',
        pink: 'ffc0cb',
        plum: 'dda0dd',
        powderblue: 'b0e0e6',
        purple: '800080',
        red: 'ff0000',
        rosybrown: 'bc8f8f',
        royalblue: '4169e1',
        saddlebrown: '8b4513',
        salmon: 'fa8072',
        sandybrown: 'f4a460',
        seagreen: '2e8b57',
        seashell: 'fff5ee',
        sienna: 'a0522d',
        silver: 'c0c0c0',
        skyblue: '87ceeb',
        slateblue: '6a5acd',
        slategray: '708090',
        snow: 'fffafa',
        springgreen: '00ff7f',
        steelblue: '4682b4',
        tan: 'd2b48c',
        teal: '008080',
        thistle: 'd8bfd8',
        tomato: 'ff6347',
        turquoise: '40e0d0',
        violet: 'ee82ee',
        violetred: 'd02090',
        wheat: 'f5deb3',
        white: 'ffffff',
        whitesmoke: 'f5f5f5',
        yellow: 'ffff00',
        yellowgreen: '9acd32'
    };

    $.ig.util.stringToColor = function (str) {
        var ret = {
        a: 255,
            r: 0,
            g: 0,
            b: 0
		};

        var asColorName = str.replace(' ', '').toLowerCase();
	
	if (asColorName === 'transparent') {
		return { a: 0, r: 0, g: 0, b: 0 };
	}
	
    if ($.ig.util.wellKnownColors[asColorName] !== undefined) {
            str = $.ig.util.wellKnownColors[asColorName];
        }
		var parts;
	if (str.lastIndexOf("rgba", 0) === 0) {
        str = str.replace('rgba', '').replace(' ', '').replace('(', '').replace(')', '');
			parts = str.split(',');
			ret.r = parseInt(parts[0], 10);
			ret.g = parseInt(parts[1], 10);
			ret.b = parseInt(parts[2], 10);
        ret.a = parseFloat(parts[3]) * 255.0;
	} else if (str.lastIndexOf("rgb", 0) === 0) {
        str = str.replace('rgb', '').replace(' ', '').replace('(', '').replace(')', '');
			parts = str.split(',');
			ret.r = parseInt(parts[0], 10);
			ret.g = parseInt(parts[1], 10);
			ret.b = parseInt(parts[2], 10);
        } else {
            str = str.replace('#', '').replace(' ', '');
            if (str.length === 6) {
                ret.r = parseInt(str.substr(0, 2), 16);
                ret.g = parseInt(str.substr(2, 2), 16);
                ret.b = parseInt(str.substr(4, 2), 16);
            } else if (str.length === 3) {
                ret.r = parseInt(str.substr(0, 1) + str.substr(0, 1), 16);
                ret.g = parseInt(str.substr(1, 1) + str.substr(1, 1), 16);
                ret.b = parseInt(str.substr(2, 1) + str.substr(2, 1), 16);
            } 
        }
    return ret;
    };

    $.ig.util.isResponseTypeSupported = function (responseType) {
    var xhr = null; 
    try {
		xhr = new XMLHttpRequest();
		xhr.open('GET', '/');
        xhr.responseType = responseType;
    } catch (e) {
        return false;
    }
	if (xhr === null) {
		return false;
	}
    return xhr.responseType === responseType;
};

	
$.ig.util.getBinary = function (url, callback, error) {
	var data, ret, req, useVbArray = false, 
	arrayBufferSupported = $.ig.util.isResponseTypeSupported('arraybuffer') && typeof Uint8Array != 'undefined';

	if (typeof XMLHttpRequest == "undefined") {
		try { req = ActiveXObject("Msxml2.XMLHTTP.6.0"); }
		catch (e) { }
		try { req = ActiveXObject("Msxml2.XMLHTTP.3.0"); }
		catch (e) { }
		req = new ActiveXObject("Microsoft.XMLHTTP");
	} else {
		req = new XMLHttpRequest();
	}

	if (!arrayBufferSupported) {
		if (req.overrideMimeType) {
			req.overrideMimeType('text/plain; charset=x-user-defined');
		} else {
			if (typeof VBArray != "undefined") {
				useVbArray = true;
			}
		}
	}

	req.onreadystatechange = function () {
		if (req.readyState == 4) {
			if (req.status == 200) {
				if (arrayBufferSupported) {
					callback(new Uint8Array(this.response));
				} else {
					if (useVbArray) {
						data = new VBArray(req.responseBody).toArray();
						for (var i = 0; i < data.length; i++) {
							data[i] = String.fromCharCode(data[i]);
						}
						ret = data.join('');
						callback(ret);
					} else {
						callback(req.responseText);
					}
				}
			} else {
				error(req.error);
			}
		}
	};

	req.open('GET', url, true);
	if (arrayBufferSupported) {
         req.responseType = "arraybuffer";
    }
	req.send(null);
};

$.ig.util.extCopy = function (source, bindings) {
	var i, j, k;
	if (typeof source == "undefined" || !source) {
		return;
	}
	for (j = 0; j < bindings.length; j++) {
		var dests = bindings[j][0];
		var meths = bindings[j][1];
		for (k = 0; k < dests.length; k++) {
			for (i = 0; i < meths.length; i++) {
				if (typeof dests[k] == "undefined" || !dests[k] ||
					typeof meths[i] == "undefined" || !meths[i]) {
					continue;
				}
				//A.T. make sure the translated code uses a similar approach to using defineProperty
				//dests[k].prototype[meths[i]] = source.prototype[meths[i]];
				$.ig.extendNativePrototype(dests[k].prototype, meths[i], source.prototype[meths[i]]);
			}
		}
	}
};

$.ig.$currDefinitions = null;
$.ig.$allDefinitions = [];

    $.ig.util.getDefinedNameAndNamespace = function (name) {
        var ns = $.ig;
        var nParts = name.split('.');
        if (nParts.length != 1) {
            for (var i = 0; i < nParts.length - 1; i++) {
                var nsName = nParts[i];
                if (!ns[nsName]) {
                    ns[nsName] = {};
                }

                ns = ns[nsName];
            }

            name = nParts[nParts.length - 1];
        }

        return { name: name, namespace: ns };
    };

    $.ig.util.bulkDefine = function (toDefine) {
        var i = 0, curr = null, els = null;
        for (i = 0; i < toDefine.length; i++) {
            curr = toDefine[i];
            els = curr.split(':');
            curr = els[0];
            var info = $.ig.util.getDefinedNameAndNamespace(curr);

            info.namespace[info.name] = info.namespace[info.name] || Class.extend({ $type: new $.ig.Type(curr, $.ig.Object.prototype.$type), $placeholder: true }, true);
            if (els.length > 1 && $.ig.$currDefinitions) {
                $.ig.$currDefinitions[els[1]] = info.namespace[info.name];
                $.ig.$currDefinitions['$' + els[1]] = info.namespace[info.name].prototype;
                $.ig.$currDefinitions['$_' + curr] = els[1];
            }
            if ($.ig.$allDefinitions && $.ig.$allDefinitions.indexOf($.ig.$currDefinitions) < 0) {
                $.ig.$allDefinitions.push($.ig.$currDefinitions);
            }
        }
    };

    $.ig.util.defType = function (name, baseName, definition) {
        var els = null, i, currDefs, shortName;
        els = name.split(':');
        name = els[0];

        var info = $.ig.util.getDefinedNameAndNamespace(name);

        var result = info.namespace[info.name];

        if (!result || result.prototype.$placeholder) {
            var baseInfo = $.ig.util.getDefinedNameAndNamespace(baseName);
            result = baseInfo.namespace[baseInfo.name].extend(definition);
            info.namespace[info.name] = result;

            if (els.length > 1 && $.ig.$currDefinitions) {
                $.ig.$currDefinitions[els[1]] = result;
                $.ig.$currDefinitions['$' + els[1]] = result.prototype;
                $.ig.$currDefinitions['$_' + name] = els[1];

                if ($.ig.$allDefinitions) {
                    for (i = 0; i < $.ig.$allDefinitions.length; i++) {
                        currDefs = $.ig.$allDefinitions[i];
                        if (currDefs['$_' + name] !== undefined) {
                            shortName = currDefs['$_' + name];
                            currDefs[shortName] = result;
                            currDefs['$' + shortName] = result.prototype;
                        }
                    }
                }
            }
        }

        return result;
    };

$.ig.util.getClassCount = function (classNamePrefix, isPrefix) {
	var styleSheets = document.styleSheets, numFound = 0, count = 0, currSheet, rules, currSelector, currVal;
	classNamePrefix = classNamePrefix.toLowerCase();
	if (!styleSheets) {
		return 0;
	}
	for (var i = 0; i < styleSheets.length; i++) {
        try {
			currSheet = styleSheets[i];
			rules = currSheet.rules ? currSheet.rules : currSheet.cssRules;
			if (!rules) {
				continue;
			}
			for (var j = 0; j < rules.length; j++) {
				currSelector = rules[j].selectorText;
				if (currSelector) {
					currSelector = currSelector.toLowerCase();
					if (isPrefix) {
						if (currSelector.indexOf(classNamePrefix) === 0) {
							currVal = parseInt(currSelector.replace(classNamePrefix, ""), 10);
							if (isNaN(currVal)) {
								count++;
							} else {
							numFound = Math.max(numFound, currVal);
						}
						}
					} else {
						if (currSelector == classNamePrefix) {
							numFound++;
						}
					}
				}
			}
        } catch (e) {
            //ignore cross domain sheets.
        }
	}
	return Math.max(numFound, count);
};
$.ig.util._isCanvasSupported = function () {
	var canvas = document.createElement('canvas');
	return !!(canvas.getContext && canvas.getContext('2d'));
};

$.ig.util._renderUnsupportedBrowser = function (widget, locale) {
	if (!widget.events || !widget.events.browserNotSupported || widget._trigger(widget.events.browserNotSupported)) {
		var elem = widget.element, o = widget.options, container = $('<div></div>').css("overflow", "auto").addClass(widget.css.unsupportedBrowserClass).appendTo(elem), ul, browserUnsupported;
		locale = locale || $.ig.util.locale;
		if ($.ig.util.isIE) {
			browserUnsupported = 'Internet Explorer ' + $.ig.util.browserVersion;
		} else if ($.ig.util.isOpera) {
			browserUnsupported = 'Opera ' + $.ig.util.browserVersion;
		} else if ($.ig.util.isWebKit) {
			browserUnsupported = 'Webkit ' + $.ig.util.browserVersion;
		} else if ($.ig.util.isFF) {
			browserUnsupported = 'Mozilla Firefox ' + $.ig.util.browserVersion;
		} else {
			browserUnsupported = $.ig.util.browserVersion;
		}

		$('<div></div>').addClass('ui-html5-current-browser-label').html(locale.currentBrowser.replace('{0}', browserUnsupported)).appendTo(container);
		$('<div></div>').addClass('ui-html5-non-html5-text').html(locale.unsupportedBrowser).appendTo(container);
		ul = $('<ul></ul>').addClass('ui-html5-browsers-list').appendTo(container);
		$('<a></a>').attr('href', locale.chromeDownload).attr('target', '_blank').addClass('ui-html5-chrome-icon').html(locale.chrome8).appendTo($('<li></li>').addClass('ui-corner-all').appendTo(ul));
		$('<a></a>').attr('href', locale.firefoxDownload).attr('target', '_blank').addClass('ui-html5-firefox-icon').html(locale.firefox36).appendTo($('<li></li>').addClass('ui-corner-all').appendTo(ul));
		$('<a></a>').attr('href', locale.operaDownload).attr('target', '_blank').addClass('ui-html5-Opera-icon').html(locale.opera11).appendTo($('<li></li>').addClass('ui-corner-all').appendTo(ul));
		$('<a></a>').attr('href', locale.safariDownload).attr('target', '_blank').addClass('ui-html5-safari-icon').html(locale.safari5).appendTo($('<li></li>').addClass('ui-corner-all').appendTo(ul));
		$('<a></a>').attr('href', locale.ieDownload).attr('target', '_blank').addClass('ui-html5-ie-icon').html(locale.ie9).appendTo($('<li></li>').addClass('ui-corner-all').appendTo(ul));
		if (widget.css.unsupportedBrowserClass.indexOf(" ui-html5-non-html5") === -1) {
			elem.addClass('ui-html5-non-html5');
		}
		if (o.width) {
			elem.css("width", o.width);
		}
		if (o.height) {
			elem.css("height", o.height);
		}
	}
};

$.ig.CultureInfo = Class.extend({
    _name: null,
    init: function (name) {
        this._name = name;
    },
        clone: function () {
        var copy = new $.ig.CultureInfo();
        for (var attr in this) {
                if (this.hasOwnProperty(attr)) {
                copy[attr] = this[attr];
        }
            }

        return copy;
    },
        compareInfo: function () {
        // TODO:
        return new $.ig.CompareInfo();
    },
    
    getFormat: function ($t) {
        if ($t === $.ig.NumberFormatInfo.prototype.$type) {
            return new $.ig.NumberFormatInfo(this._name);
        }

        throw new Error("Unknown format type");
    },
  
        name: function () {
        return this._name;
    },
    dateTimeFormat: function () {
        // TODO
        return new $.ig.DateTimeFormat(this._name);
    },
    numberFormat: function () {
        // TODO
        return new $.ig.NumberFormatInfo(this._name);
    },
    $type: new $.ig.Type('CultureInfo', $.ig.Object.prototype.$type)
}, true);

$.ig.CultureInfo.prototype.currentCulture = function () {

    var currentLocale = "en-US"; // TODO: What can we do here for the default?

        if (window.Intl) {
        currentLocale = new Intl.Collator().resolvedOptions().locale;
        }

        if (!this._cachedLocales) {
        this._cachedLocales = {};
        }

        if (this._cachedLocales[currentLocale]) {
        return this._cachedLocales[currentLocale];
        }

    /*jshint -W093 */
    return this._cachedLocales[currentLocale] = new $.ig.CultureInfo(currentLocale);
};

$.ig.CultureInfo.prototype.invariantCulture = function () {
        if (this._cachedInvariant) {
        return this._cachedInvariant;
        }

    // TODO:
    /*jshint -W093 */
    return this._cachedInvariant = new $.ig.CultureInfo("en-US");
};

$.ig.util.defType('CompareInfo', 'Object', {
    init: function () {
    },
        compare1: function (string1, offset1, length1, string2, offset2, length2, options) {
        var v1 = string1.substring(offset1, length1);
        var v2 = string2.substring(offset2, length2);

        // TODO: Handle other compare options
        /*jslint bitwise: true */
        if ((options & $.ig.CompareOptions.prototype.ignoreCase) !== 0) {
            v1 = v1.toLowerCase();
            v2 = v2.toLowerCase();
        }

        return $.ig.util.compare(v1, v2);
    },
    compare4: function (string1, string2) {
        return this.compare5(string1, string2, $.ig.CompareOptions.prototype.none);
    },
        compare5: function (string1, string2, options) {
        return this.compare1(string1, 0, string1.length, string2, 0, string2.length, options);
    },
        indexOf6: function (source, value, options) {
        // TODO: Handle other compare options
        /*jslint bitwise: true */
        if ((options & $.ig.CompareOptions.prototype.ignoreCase) !== 0) {
            source = source.toLowerCase();
            value = value.toLowerCase();
        }

        return source.indexOf(value);
    },
    indexOf5: function (source, value, options) {
        // TODO: Use options
        return source.indexOf(value);
    },
        referenceEquals: function (a, b) {
        return a === b;
    },
    $type: new $.ig.Type('CompareInfo', $.ig.Object.prototype.$type)
}, true);

$.ig.DateTimeFormat = Class.extend({
    _cultureName: null,
    _dateSeparator: null,
    _longDatePattern: null,
    _shortDatePattern: null,
    init: function (cultureName) {
        this._cultureName = cultureName;

        // TODO: Get these from the culture
        this._dateSeparator = '/';
        this._longDatePattern = 'dddd, MMMM d, yyyy';
        this._shortDatePattern = 'M/d/yyyy';
    },
    dateSeparator: function (value) {
        if (arguments.length === 1) {
            this._dateSeparator = value;
            return value;
        } else {
            return this._dateSeparator;
        }
    },
    longDatePattern: function (value) {
        if (arguments.length === 1) {
            this._longDatePattern = value;
            return value;
        } else {
            return this._longDatePattern;
        }
    },
    shortDatePattern: function (value) {
        if (arguments.length === 1) {
            this._shortDatePattern = value;
            return value;
        } else {
            return this._shortDatePattern;
        }
    },
    $type: new $.ig.Type('DateTimeFormat', $.ig.Object.prototype.$type) // TODO: Define and add IFormatProvider interface here
}, true);

$.ig.NumberFormatInfo = Class.extend({
    _cultureName: null,
    _currencySymbol: null,
    _negativeSign: null,
    _percentSymbol: null,
    _positiveSign: null,
    init: function (cultureName) {
        this._cultureName = cultureName;

        // TODO: Get these from the culture
        this._currencySymbol = '$';
        this._negativeSign = '-';
        this._percentSymbol = '%';
        this._positiveSign = '+';
    },
    currencySymbol: function (value) {
        if (arguments.length === 1) {
            this._currencySymbol = value;
            return value;
        } else {
            return this._currencySymbol;
        }
    },
    negativeSign: function (value) {
        if (arguments.length === 1) {
            this._negativeSign = value;
            return value;
        } else {
            return this._negativeSign;
        }
    },
    percentSymbol: function (value) {
        if (arguments.length === 1) {
            this._percentSymbol = value;
            return value;
        } else {
            return this._percentSymbol;
        }
    },
    positiveSign: function (value) {
        if (arguments.length === 1) {
            this._positiveSign = value;
            return value;
        } else {
            return this._positiveSign;
        }
    },
        numberDecimalSeparator: function () {
        return (1.1).toLocaleString(this._cultureName).substring(1, 2);
    },
    numberGroupSeparator: function () {
        var s = (123456789.0).toLocaleString(this._cultureName);
        var result = /\D/.exec(s);
            if (result === null || result.length === 0) {
            return ",";
            }

        return result[0];
    },
    numberGroupSizes: function () {
        var s = (123456789.0).toLocaleString(this._cultureName);
        var result = /\D(\d+)\D/.exec(s);

            if (result === null || result.length === 0) {
            return [3];
            }

        return [result[1].length];
    },
    $type: new $.ig.Type('NumberFormatInfo', $.ig.Object.prototype.$type) // TODO: Define and add IFormatProvider interface here
}, true);

$.ig.util.defType('Thread', 'Object', {
    init: function () {
    },
    currentThread: function () {
        return new $.ig.Thread();
    },
    currentCulture: function () {
        return $.ig.CultureInfo.prototype.currentCulture();
    },
    $type: new $.ig.Type('Thread', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('Stream', 'Object', {
    init: function () {
    },
    close: function () {
        this.disposeCore(true);
    },
    dispose: function () {
        this.close();
    },
    disposeCore: function (disposing) {
    },
        flush: function () {
    },
        readByte: function () {
        var bytes = [0];
        var count = this.read(bytes, 0, 1);
            if (count === 0) {
            return -1;
            }

        return bytes[0];
    },
        writeByte: function (value) {
        this.write([value], 0, 1);
    },
    $type: new $.ig.Type('Stream', $.ig.Object.prototype.$type)
}, true);

(function ($) {

        $.ig.util.profiler = {};
    
        var methods = {};
    
		$.ig.util.profiler.recordTime = function (methodName, time) {
            var key = "meth: " + methodName;
            if (!methods[key]) {
                methods[key] = [];
            }
            methods[key][methods[key].length] = time;
		};

        $.ig.util.profiler.reset = function () {
            methods = {};
		};

        $.ig.util.profiler.logReport = function () {
            var meths = [];
            var j = 0;
            var sum = 0;
            var avg = 0;
            for (var prop in methods) {
                if (prop.indexOf('meth:') === 0) {
                    var meth = {};
                    meth.name = prop.substr(5);

                    sum = 0;
                    for (var i = 0; i < methods[prop].length; i++) {
                        sum = sum + methods[prop][i];
                    }
					avg = sum / methods[prop].length;
                    meth.avg = avg;
                    meth.callCount = methods[prop].length;
                    meths[j] = meth;
                    j++;
                }
            }

            meths.sort(function (m1, m2) {
                if (m1.avg < m2.avg) {
                    return 1;
                }
                if (m1.avg > m2.avg) {
                    return -1;
                }
                if (m1.avg == m2.avg) {
                    return 0;
                }
            });

			for (var k = 0; k < Math.min(200, meths.length) ; k++) {
                console.log(meths[k].name + " avg: " + meths[k].avg + " callCount: " + meths[k].callCount);
            }
		};
}(jQuery));

/*
Function.prototype.invoke = function () {
    return this.apply(null, arguments);
};

Function.prototype.on = function (target) {
    var self = this;
    var ret = function () {
        return self.apply(target, arguments);
    };
    ret.original = this;
    ret.target = target;
    return ret;
};
*/

$.ig.extendNativePrototype(Function.prototype, "invoke", function () {
    return this.apply(null, arguments);
});

$.ig.extendNativePrototype(Function.prototype, "runOn", function (target) {
    var self = this;
    var ret = function () {
        return self.apply(target, arguments);
    };
    ret.original = this;
    ret.target = target;
    return ret;
});

String.prototype.startsWith = function (s) {
	return this.indexOf(s) === 0;
};

String.prototype.startsWith1 = function (s, comparisonType) {
    if (this.length < s.length) {
        return false;
    }

    return $.ig.util.stringCompare1(this.slice(0, s.length), s, comparisonType || 0) === 0;
};

String.prototype.endsWith = function (s, comparisonType) {
    if (this.length < s.length) {
        return false;
    }

    return $.ig.util.stringCompare1(this.slice(-s.length), s, comparisonType || 0) === 0;
};

String.prototype.remove = function (index, count) {
    if (!count || ((index + count) > this.length)) {
        return this.substr(0, index);
    }
    return this.substr(0, index) + this.substr(index + count);
};

String.prototype.compareTo = function (other) {
    if (this == other) {
        return 0;
    }
    if (this < other) {
        return -1;
    }
    return 1;
};

    if (!String.prototype.trim) {
	//String.trim() was added natively in JavaScript 1.8.1 / ECMAScript 5
	//supported in: Firefox 3.5+, Chrome/Safari 5+, IE9+ (in Standards mode only!)
	String.prototype.trim = function () {
		return this.replace(/^\s\s*/, '').replace(/\s\s*$/, '');
	};
}

    if (!String.prototype.getHashCode) {
    String.prototype.getHashCode = function () {
        var hash = 0, i, chr, len;
            if (this.length === 0) {
                return hash;
            }
        for (i = 0, len = this.length; i < len; i++) {
            chr = this.charCodeAt(i);
            /*jslint bitwise: true */
            hash = ((hash << 5) - hash) + chr;
            hash |= 0; // Convert to 32bit integer
        }

        return hash;
    };
}

String.prototype.fullTrim = function () {
        return this.replace(/(?:(?:^|\n)\s+|\s+(?:$|\n))/g, '').replace(/\s+/g, ' ');
};

String.prototype.trimStart = function () {
    var args = [' '];
    if (arguments.length > 0) {
        args = Array.prototype.slice.call(arguments);
    }
        if (this.length === 0) {
        return this;
        }
    var i = 0;
    for (; args.indexOf(this.charAt(i)) > -1 && i < this.length; i++);
    return this.substring(i);
};

String.prototype.trimEnd = function () {
    var args = [' '];
    if (arguments.length > 0) {
        args = Array.prototype.slice.call(arguments);
    }
    var i = this.length - 1;
    for (; i >= 0 && args.indexOf(this.charAt(i)) > -1; i--);
    return this.substring(0, i + 1);
};

String.getHashCode = function () { return this; };
String.isNullOrEmpty = function (s) { return !s || s.length < 1; };
String.isNullOrWhiteSpace = function (s) { return !s || s.trim().length < 1; };
String.empty = function () { return ""; };
String.concat = function () { return [].join.call(arguments, ""); };
String.concat1 = function (o1, o2) { return [].join.call(arguments, ""); };
String.concat2 = function (s1, s2) { return [].join.call(arguments, ""); };
String.concat3 = function () { return [].join.call(arguments, ""); };
String.concat4 = function (o1, o2, o3) { return [].join.call(arguments, ""); };
String.concat5 = function (s1, s2, s3) { return [].join.call(arguments, ""); };
String.concat6 = function (o1, o2, o3, o4) { return [].join.call(arguments, ""); };
String.concat7 = function (s1, s2, s3, s4) { return [].join.call(arguments, ""); };
String.equalsStatic = $.ig.Object.prototype.equalsStatic;

String.prototype.equals = function (other) {
    return this == other;
};

String.prototype.contains = function (s) {
    return this.indexOf(s) > -1;
};

String.prototype.padLeft = function (len, c) {
	var s = this;
	c = c || ' ';
    while (s.length < len) {
        s = c + s;
    }
    return s;
};

String.prototype.padRight = function (len, c) {
	var s = this;
	c = c || ' ';
    while (s.length < len) {
        s += c;
    }
    return s;
};

String.prototype.capitalize = function () {
    return this.charAt(0).toUpperCase() + this.slice(1);
};

if (!String.prototype.indexOfAny) {
    String.prototype.indexOfAny = function (chars) {

        for (var i = 0; i < this.length; i++) {
            if (chars.contains(this[i])) {
                return i;
        }
        }

        return -1;
    };
}

if (!String.prototype.lastIndexOfAny) {
    String.prototype.lastIndexOfAny = function (chars) {

        for (var i = this.length - 1; i >= 0; i--) {
            if (chars.contains(this[i])) {
                return i;
        }
        }

        return -1;
    };
}

/*
Array.prototype.insertRange = function (index, items) {
	var i = 0;
	if (this.length == 0) {
		for (i = 0; i < items.length; i++) {
        this[index++] = items[i];
    }
	} else {
		for (i = 0; i < items.length; i++) {
			this.splice(index++, 0, items[i]);
}
	}
};

Array.prototype.clone = function () {
	return $.extend(true, [], this);
};

Array.prototype.clear = function () {
    this.length = 0;
};
*/

/* S.S. March 12, 2013 - Bug #134399 Adding filter for older browsers */
if (!Array.prototype.filter) {
	Array.prototype.filter = function(fun/*, thisp */) {
		var t, len, res, thisp, val, i;
		if (this === undefined || this === null) {
			throw new TypeError();
		}
		t = Object(this);
	    /*jslint bitwise: true */
		len = t.length >>> 0;
		if (typeof fun != "function") {
			throw new TypeError();
		}
		res = [];
		thisp = arguments[1];
		for (i = 0; i < len; i++) {
			if (i in t) {
				val = t[i]; // in case fun mutates this
				if (fun.call(thisp, val, i, t)) {
					res.push(val);
				}
			}
		}
		return res;
	};
}

$.ig.extendNativePrototype(Array.prototype, "insertRange", function (index, items) {
	var i = 0;
	if (this.length === 0) {
		for (i = 0; i < items.length; i++) {
			this[index++] = items[i];
		}
	} else {
		for (i = 0; i < items.length; i++) {
			this.splice(index++, 0, items[i]);
		}
	}
});

$.ig.extendNativePrototype(Array.prototype, "insertRange1", function (index, items) {
    //TODO: adjust this later, but this is the safest change to make right now.
    var i = 0;
	if (this.length === 0) {
        for (i = 0; i < items.length; i++) {
            this[index++] = items[i];
        }
    } else {
        for (i = 0; i < items.length; i++) {
            this.splice(index++, 0, items[i]);
        }
    }
});

$.ig.extendNativePrototype(Array.prototype, "clone", function () {
	return $.extend(true, [], this);
});

$.ig.extendNativePrototype(Array.prototype, "clear", function () {
	this.length = 0;
});

Math.log10 = function (n) { 
    return Math.log(n) / Math.log(10);
};

Math.logBase = function (n, n2) {
	return Math.log(n) / Math.log(n2);
};

Math.sign = function (n) {
    if (n < 0) {
        return -1;
    } else if (n > 0) {
        return 1;
    }
    else {
        return 0;
    }
};

Number.getHashCode = function () { return this; };
//Number.isNaN = function(n) { return isNaN(n); }
Number.isInfinity = function(n) { return n === Infinity || n === -Infinity; };

if (!Number.prototype.getHashCode) {
    Number.prototype.getHashCode = function () {
        return this;
    };
}

Boolean.prototype.getType = function () {
    return jQuery.ig.Boolean.prototype.$type;
};

Number.prototype.getType = function () {
    return jQuery.ig.Number.prototype.$type;
};

String.prototype.getType = function () {
    return jQuery.ig.String.prototype.$type;
};

/*
// Array Remove - By John Resig (MIT Licensed)
Array.prototype.remove = function (from, to) {
	var rest = this.slice((to || from) + 1 || this.length);
	this.length = from < 0 ? this.length + from : from;
	return this.push.apply(this, rest);
};
*/

// K.D. Fix for WinJS dynamic content exceptions.
window.toStaticHTML = window.toStaticHTML || function (s) { return s; };
window.MSApp = window.MSApp || {};
window.MSApp.execUnsafeLocalFunction = window.MSApp.execUnsafeLocalFunction || function (fn) { fn.apply(); };

// N.A. 10/17/2013 - Bug #155039: The property "offset" is deprecated in 1.9.
$.ig.util.jQueryUIMainVersion = $.ui && $.ui.version && $.ui.version.length > 0 ? parseInt($.ui.version.split(".", 1)[0], 10) : null;
$.ig.util.jQueryUISubVersion = $.ui && $.ui.version && $.ui.version.length > 0 ? parseInt($.ui.version.split(".", 2)[1], 10) : null;

//A CommonJS Promises/A implementation that will be used with jquery versions prior to 1.5
//that do not have a $.Deferred implementation

// String to Object flags format cache
$.ig.util.jqueryFlagsCache = {};

// Convert String-formatted flags into Object-formatted ones and store in cache
$.ig.util.jqueryCreateFlags = function (flags) {
	var object = $.ig.util.jqueryFlagsCache[flags] = {},
		i, length;
	flags = flags.split(/\s+/);
	for (i = 0, length = flags.length; i < length; i++) {
		object[flags[i]] = true;
	}
	return object;
};

/*
 * Create a callback list using the following parameters:
 *
 *	flags:	an optional list of space-separated flags that will change how
 *			the callback list behaves
 *
 * By default a callback list will act like an event callback list and can be
 * "fired" multiple times.
 *
 * Possible flags:
 *
 *	once:			will ensure the callback list can only be fired once (like a Deferred)
 *
 *	memory:			will keep track of previous values and will call any callback added
 *					after the list has been fired right away with the latest "memorized"
 *					values (like a Deferred)
 *
 *	unique:			will ensure a callback can only be added once (no duplicate in the list)
 *
 *	stopOnFalse:	interrupt callings when a callback returns false
 *
 */
$.ig.util.jqueryCallbacks = function( flags ) {

	// Convert flags from String-formatted to Object-formatted
	// (we check in cache first)
	flags = flags ? ( $.ig.util.jqueryFlagsCache[ flags ] || $.ig.util.jqueryCreateFlags( flags ) ) : {};

	var // Actual callback list
		list = [],
		// Stack of fire calls for repeatable lists
		stack = [],
		// Last fire value (for non-forgettable lists)
		memory,
		// Flag to know if list was already fired
		fired,
		// Flag to know if list is currently firing
		firing,
		// First callback to fire (used internally by add and fireWith)
		firingStart,
		// End of the loop when firing
		firingLength,
		// Index of currently firing callback (modified by remove if needed)
		firingIndex,
		// Add one or several callbacks to the list
		add = function( args ) {
			var i,
				length,
				elem,
				type,
				actual;
			for ( i = 0, length = args.length; i < length; i++ ) {
				elem = args[ i ];
				type = jQuery.type( elem );
				if ( type === "array" ) {
					// Inspect recursively
					add( elem );
				} else if ( type === "function" ) {
					// Add if not in unique mode and callback is not in
					if ( !flags.unique || !self.has( elem ) ) {
						list.push( elem );
					}
				}
			}
		},
		// Fire callbacks
		fire = function( context, args ) {
			args = args || [];
			memory = !flags.memory || [ context, args ];
			fired = true;
			firing = true;
			firingIndex = firingStart || 0;
			firingStart = 0;
			firingLength = list.length;
			for ( ; list && firingIndex < firingLength; firingIndex++ ) {
				if ( list[ firingIndex ].apply( context, args ) === false && flags.stopOnFalse ) {
					memory = true; // Mark as halted
					break;
				}
			}
			firing = false;
			if ( list ) {
				if ( !flags.once ) {
					if ( stack && stack.length ) {
						memory = stack.shift();
						self.fireWith( memory[ 0 ], memory[ 1 ] );
					}
				} else if ( memory === true ) {
					self.disable();
				} else {
					list = [];
				}
			}
		},
		// Actual Callbacks object
		self = {
			// Add a callback or a collection of callbacks to the list
			add: function() {
				if ( list ) {
					var length = list.length;
					add( arguments );
					// Do we need to add the callbacks to the
					// current firing batch?
					if ( firing ) {
						firingLength = list.length;
					// With memory, if we're not firing then
					// we should call right away, unless previous
					// firing was halted (stopOnFalse)
					} else if ( memory && memory !== true ) {
						firingStart = length;
						fire( memory[ 0 ], memory[ 1 ] );
					}
				}
				return this;
			},
			// Remove a callback from the list
			remove: function() {
				if ( list ) {
					var args = arguments,
						argIndex = 0,
						argLength = args.length;
					for ( ; argIndex < argLength ; argIndex++ ) {
						for ( var i = 0; i < list.length; i++ ) {
							if ( args[ argIndex ] === list[ i ] ) {
								// Handle firingIndex and firingLength
								if ( firing ) {
									if ( i <= firingLength ) {
										firingLength--;
										if ( i <= firingIndex ) {
											firingIndex--;
										}
									}
								}
								// Remove the element
								list.splice( i--, 1 );
								// If we have some unicity property then
								// we only need to do this once
								if ( flags.unique ) {
									break;
								}
							}
						}
					}
				}
				return this;
			},
			// Control if a given callback is in the list
			has: function( fn ) {
				if ( list ) {
					var i = 0,
						length = list.length;
					for ( ; i < length; i++ ) {
						if ( fn === list[ i ] ) {
							return true;
						}
					}
				}
				return false;
			},
			// Remove all callbacks from the list
			empty: function() {
				list = [];
				return this;
			},
			// Have the list do nothing anymore
			disable: function() {
				list = stack = memory = undefined;
				return this;
			},
			// Is it disabled?
			disabled: function() {
				return !list;
			},
			// Lock the list in its current state
			lock: function() {
				stack = undefined;
				if ( !memory || memory === true ) {
					self.disable();
				}
				return this;
			},
			// Is it locked?
			locked: function() {
				return !stack;
			},
			// Call all callbacks with the given context and arguments
			fireWith: function( context, args ) {
				if ( stack ) {
					if ( firing ) {
						if ( !flags.once ) {
							stack.push( [ context, args ] );
						}
					} else if ( !( flags.once && memory ) ) {
						fire( context, args );
					}
				}
				return this;
			},
			// Call all the callbacks with the given arguments
			fire: function() {
				self.fireWith( this, arguments );
				return this;
			},
			// To know if the callbacks have already been called at least once
			fired: function() {
				return !!fired;
			}
		};

	return self;
};

$.ig.util.jqueryDeferred = function( func ) {
    var doneList = $.ig.util.jqueryCallbacks( "once memory" ),
        failList = $.ig.util.jqueryCallbacks( "once memory" ),
        progressList = $.ig.util.jqueryCallbacks( "memory" ),
        state = "pending",
        lists = {
            resolve: doneList,
            reject: failList,
            notify: progressList
        },
        promise = {
            done: doneList.add,
            fail: failList.add,
            progress: progressList.add,

            state: function() {
                return state;
            },

            // Deprecated
            isResolved: doneList.fired,
            isRejected: failList.fired,

            then: function( doneCallbacks, failCallbacks, progressCallbacks ) {
                deferred.done( doneCallbacks ).fail( failCallbacks ).progress( progressCallbacks );
                return this;
            },
            always: function() {
                deferred.done.apply( deferred, arguments ).fail.apply( deferred, arguments );
                return this;
            },
            pipe: function( fnDone, fnFail, fnProgress ) {
                return $.ig.util.jqueryDeferred(function( newDefer ) {
                    jQuery.each( {
                        done: [ fnDone, "resolve" ],
                        fail: [ fnFail, "reject" ],
                        progress: [ fnProgress, "notify" ]
                    }, function( handler, data ) {
                        var fn = data[ 0 ],
                            action = data[ 1 ],
                            returned;
                        if ( jQuery.isFunction( fn ) ) {
                            deferred[ handler ](function() {
                                returned = fn.apply( this, arguments );
                                if ( returned && jQuery.isFunction( returned.promise ) ) {
                                    returned.promise().then( newDefer.resolve, newDefer.reject, newDefer.notify );
                                } else {
                                    newDefer[ action + "With" ]( this === deferred ? newDefer : this, [ returned ] );
                                }
                            });
                        } else {
                            deferred[ handler ]( newDefer[ action ] );
                        }
                    });
                }).promise();
            },
            // Get a promise for this deferred
            // If obj is provided, the promise aspect is added to the object
            promise: function( obj ) {
				if (obj === undefined || obj === null) {
                    obj = promise;
                } else {
                    for ( var key in promise ) {
                        obj[ key ] = promise[ key ];
                    }
                }
                return obj;
            }
        },
        deferred = promise.promise({}),
        key;

    for ( key in lists ) {
        deferred[ key ] = lists[ key ].fire;
        deferred[ key + "With" ] = lists[ key ].fireWith;
    }

    // Handle state
    deferred.done( function() {
        state = "resolved";
    }, failList.disable, progressList.lock ).fail( function() {
        state = "rejected";
    }, doneList.disable, progressList.lock );

    // Call given func if any
    if ( func ) {
        func.call( deferred, deferred );
    }

    // All done!
    return deferred;
};

// PA 7/8/2013 - fix for jQuery versions in the interval (1.4.4, 1.7.0) where $.Deferred is defined, but has some missing members that we need
$.ig.util.checkDeferred = function () {
    $.ig.util.deferredDefined = !!($.Deferred !== undefined && $.Deferred().state);
};

$.ig.util.deferred = function () {
    if ($.ig.util.deferredDefined === undefined) {
        $.ig.util.checkDeferred();
    }

    if ($.ig.util.deferredDefined) {
        return $.Deferred();
    } else {
        return $.ig.util.jqueryDeferred();
    }
};

$.ig.util.ajax = function (url, contentType, data, method, requestOptions) {
    //return $.ig.util.corsRequest(url, contentType, data, method, requestOptions);

    var deferred = $.ig.util.deferred();
    var isCrossDomain;
    if (requestOptions && "isCrossDomain" in requestOptions) {
		isCrossDomain = requestOptions.isCrossDomain;
    } else {
        isCrossDomain = $.support.cors;
    }

    var xhrObj = (function (rOptions) {
        var xhr = new XMLHttpRequest();

        // do not use XDomainRequest for IE8/IE9 if the user has specifed withCredentials in request options
        // which is interpreted as XmlHttpRequest to be used against trusted domain
        // since XDomainRequest does not support withCredentials
		if (isCrossDomain &&
			!(("withCredentials" in xhr) || (rOptions && "withCredentials" in rOptions && rOptions.withCredentials)) &&
            typeof XDomainRequest != "undefined") {

            // handle IE8/IE9 with anonymous authentication
            xhr = new XDomainRequest();

            // fix for jQuery.ajax() callback is expecting some methods and props are defined
            // PP 12/05/2012 jQuery 1.4.4 fix
            xhr.getResponseHeader = function () {
                return null;
			};
		
			// M.S. July 24st, 2013 Bug #145199 Fixed the data loading from XMLA, when using jQuery 2.0.0 in IE9
			xhr.setRequestHeader = function() {
				xhr.status = 200;
			};
			
			xhr.getAllResponseHeaders = function() {
				return null;
			};

            xhr.onload = function () {
                xhr.readyState = 4;
                xhr.status = 200;
                xhr.statusText = "success";
                xhr.getAllResponseHeaders = function () {
            };
                xhr.onreadystatechange();
            };

            xhr.onerror = function () {
                xhr.readyState = 4;
                xhr.status = 0;
                xhr.statusText = "error";
                xhr.getAllResponseHeaders = function () {
                };
                xhr.onreadystatechange();
            };

            xhr.ontimeout = function () {
                xhr.readyState = 4;
                xhr.status = 0;
                xhr.statusText = "timeout";
                xhr.getAllResponseHeaders = function () {
                };
                xhr.onreadystatechange();
            };

            // keep this callback because otherwise XDomainRequest is aborted
            // it's a bug in XDomainRequest
            xhr.onprogress = function () {
            };
        }

        return xhr;
    })(requestOptions);

    var xhrFields;
    // when credentials are specified that will work with Chrome/FireFox/IE10
    if ("withCredentials" in xhrObj &&
        requestOptions && "withCredentials" in requestOptions &&
		requestOptions.withCredentials) {

        xhrFields = {
            withCredentials: true
};
    }

    var beforeSend = function (jqXHR, options) {
        if (requestOptions) {

            if ($.isFunction(requestOptions.beforeSend)) {
                jqXHR.setRequestHeader("Content-Type", contentType);
                requestOptions.beforeSend.call(this, jqXHR, options, requestOptions);
            }
        }
	};
        
    $.ajax({
		crossDomain: (isCrossDomain ? true : false),
        isLocal: false,
        url: url,
        contentType: contentType,
        data: data,
        type: method,
        dataType: 'text',
        xhrFields: xhrFields,
        beforeSend: beforeSend,
        xhr: function () {
            return xhrObj;
        },
        success: function (responce, textStatus, jqXHR) {
            deferred.resolve(responce);
        },
        error: function (jqXHR, textStatus, errorThrown) {
            deferred.reject(errorThrown);
        }
    });

    return deferred.promise();
};

// adjust jquery.offset for zoom in IE10
// e: jquery object/element
// xy: optional precalculated e.offset or existing position/point with members left/top
$.ig.util.offset = function (e, xy) {
	xy = xy || e.offset();
	e = e ? e[0].ownerDocument : document;
	e = e ? e.documentElement : null;
	var z = e ? e.msContentZoomFactor : null;
	if (z && z > 1) {
		xy.left += e.scrollLeft - window.pageXOffset;
		xy.top += e.scrollTop - window.pageYOffset;
	}
	return xy;
};
// Get relative offset of the passed element according to the closest parent element with relative position if any
// e: jquery element
$.ig.util.getRelativeOffset = function (e) {
	var elem = e.parent(), o = { left: 0, top: 0 }, position;
    
	while (elem[0] !== null && elem[0] !== undefined && elem[0].nodeName !== "#document" ) {
        position = elem.css('position');
        // because the element which is passed as argument is supposed to be with position absolute we should find whether it has parent in the DOM tree which is with position which is not static - like relative, absolute, etc
		if (position !== 'static' && position !== '') {
			o.left = elem.offset().left - elem.scrollLeft();
			o.top = elem.offset().top - elem.scrollTop();
			break;
		}
		elem = elem.parent();
	}
	return o;
};
// Synchronize width/height of widget with its chart/dv controller
// elem - jquery object which represents widget.element
// prop - string "width" or "height".
//   Notes: If it is missing, then a call from destroy is assumed and object/timer is deleted.
//   A widget must call that method within destroy passing only 1st this.element parameter.
// val - new value for width or height. It can be any html unit or number: 200, "200", "200px", "50%", "10cm", etc.
//   Note: if widget was created without explicit width/height and relies on size of target-html element, then null can be used.
//   In this case if html element was hidden on start, then that method catches first rendering, sets chart.width/height(values) and notifies resized.
// chart - reference to xam/chart object which controls widgit
// notifyResized - name of method which should be called when widget was resized
//
// Example for codes within create():
//   if (this.options.width)
//       $.ig.util.setSize(this.element, "width", this.options.width, this._chart, "notifyResized");
// Example for codes within create() when no width or height is specified (support for initially hidden element):
//   if (!this.options.width && !this.options.width)
//       $.ig.util.setSize(this.element, "width", null, this._chart, "notifyResized");
// Example for codes within _setOption(key, val):
//   if (key === "width" || key === "height")
//       $.ig.util.setSize(this.element, key, val, this._chart, "notifyResized");
// Example for codes within destroy():
//   $.ig.util.setSize(this.element);
$.ig.util.setSize = function (elem, prop, val, chart, notifyResized) {
	if (!elem || !elem[0]) {
		return;
	}
	var timer, px,
		obj = elem[0]._w_s_f = elem[0]._w_s_f || {},
		// width/height flags which trigger timer and adjustments of width/height on ticks
		perc = obj.perc;
	if (!prop) {
		if (obj.tickID) {
			obj.onTick(true);
		}
		delete obj.elem;
		delete obj.chart;
		elem[0]._w_s_f = null;
		return;
	}
	if (!val) {
		val = elem[prop]();
	}
	if (perc && perc.indexOf(prop) >= 0) {
		perc = perc.replace(prop, "");
	}
	if (val) {
		elem[prop](val);
		if (typeof val !== "number") {
			// possible cases to process:
			// if(##===##px) then use same logic as for number
			// ##% - start timer
			// ##xxx - use elem.offsetWidth/Height for _xam.width/height
			// if elem.offsetWidth or elem.offsetHeight is 0, then start timer
			val = val.toString();
			if (val.indexOf("%") > 0) {
				perc = perc || "";
				if (perc.indexOf(prop) < 0) {
					// start timer
					timer = perc += prop;
				}
			}
			px = val.indexOf("px");
			if (px > 0) {
				val = val.substring(0, px);
			}
			px = parseFloat(val);
			// use same logic as for number
			if (px.toString() === val) {
				val = px;
			} else {
				val = elem[prop]();
				if (!val) {
					// width/height flags which trigger timer and adjustments of width/height on ticks
					obj.wait = obj.wait || "";
					if (obj.wait.indexOf(prop) < 0) {
						obj.wait += prop;
					}
					// start timer
					timer = prop;
				}
			}
		}
		obj.perc = perc;
		if (val && chart) {
			if (chart[prop]) {
				chart[prop](val);
			}
			if (notifyResized) {
				chart[notifyResized]();
			}
		}
	}
	if (!timer && !elem[0].offsetWidth) {
		timer = obj.wait = "width";
	}
	if (timer) {
		obj.elem = elem;
		obj.chart = chart;
		obj.notify = notifyResized;
		// stop: stop timer: coming from destroy
		obj.onTick = obj.onTick || function (stop) {
			// request to call notifyResized
			var resize,
				obj = this,
				chart = obj.chart,
				elem = obj.elem,
				perc = obj.perc || "",
				wait = obj.wait || "",
				width = stop || elem[0].offsetWidth,
				height = stop || elem[0].offsetHeight,
				oldWidth = obj.oldWidth || 0,
				oldHeight = obj.oldHeight || 0;
			stop = stop === true || (!perc && !wait);
			if (stop) {
				if (obj.tickID) {
					clearInterval(obj.tickID);
				}
				delete obj.tickID;
				return;
			}
			if (!obj.tickID && (!width || !height || perc)) {
				obj.tickID = setInterval(function () {
					obj.onTick();
				}, 200);
			}
			if (!width || !height) {
				return;
			}
			// width/height was adjusted
			delete obj.wait;
			// current instant width/height
			obj.oldWidth = width;
			obj.oldHeight = height;
			if (!chart) {
				return;
			}
			if (chart.width && ((perc.indexOf("width") >= 0 && width !== oldWidth) || wait.indexOf("width") >= 0)) {
				chart.width(resize = width);
			}
			if (chart.height && ((perc.indexOf("height") >= 0 && height !== oldHeight) || wait.indexOf("height") >= 0)) {
				chart.height(resize = height);
			}
			if (resize && obj.notify) {
				chart[obj.notify]();
			}
		};
		obj.onTick();
	}
};

$.ig.util.getEasingFunction = function (easingValue) {
	if (easingValue === null || easingValue == "null" ||
		easingValue == "linear") {
		return null;
	}
	switch (easingValue) {
		case "cubic":
			return $.ig.EasingFunctions.prototype.cubicEase;
	}
	
	return easingValue;
};

// Check if given element has vertical scrollbar
// elem - jQuery object
$.ig.util.hasVerticalScroll = function (elem) {
    var overflow = $(elem).css('overflow-y');
    return overflow === 'scroll' ||
        overflow === 'auto' && elem[0].scrollHeight > elem[0].clientHeight;
};
// Check if given element has horizontal scrollbar
// elem - jQuery object
$.ig.util.hasHorizontalScroll = function (elem) {
    var overflow = $(elem).css('overflow-x');
    return overflow === 'scroll' ||
        overflow === 'auto' && elem[0].scrollWidth > elem[0].clientWidth;
};
// Returns the width of the vertical scrollbar
$.ig.util.getScrollWidth = function () {
    var el = $('<div style="width: 100px; height: 100px; position: absolute; top: -10000px; left: -10000px; overflow: scroll"></div>').appendTo($(document.body)), scrollWidth;
    scrollWidth = el[0].offsetWidth - el[0].clientWidth;
    el.remove();
    return scrollWidth;
};
// Returns the height of the horizontal scrollbar
$.ig.util.getScrollHeight = function () {
    var el = $('<div style="width: 100px; height: 100px; position: absolute; top: -10000px; left: -10000px; overflow: scroll"></div>').appendTo($(document.body)), scrollHeight;
    scrollHeight = el[0].offsetHeight - el[0].clientHeight;
    el.remove();
    return scrollHeight;
};
// Checks if given object is a DOM element
$.ig.util.isDomElement = function (o) {
    return (
        typeof HTMLElement === "object" ? o instanceof HTMLElement :
        o && typeof o === "object" && o !== null && o.nodeType === 1 && typeof o.nodeName === "string"
    );
};
// necessary to automatically detect whether to instantiate JSONP datasource from the URL
$.ig.util.isJsonpUrl = function (url) {
    var isJSONPExpr = /(=)\?(?=&|$)|\?\?/;

    return isJSONPExpr.test(url);
};
// returns button of mouse (down) event: 0-left, 1-middle, 2-right
$.ig.util.evtButton = function (e) {
	e = e ? e.button : null;
	if (e === 1) {
		e = this._ie_8;
		if (!e) {
			var v;
			e = window.navigator.userAgent;
			if (e) {
				// check if IE and its browser mode is 9 or higher
				v = e.toLowerCase().indexOf("msie ");
				if (v > 0) {
					v = parseFloat(e.substring(v + 5));
					if (v > 8) {
						// check if IE document mode is 9 or higher
						v = parseFloat(document.documentMode);
					}
				}
			}
			// flag for IE8 and less
			this._ie_8 = e = v && !isNaN(v) && v > 5 && v < 9 ? 1 : -1;
		}
		// treat button==1 of IE 8 and less as 0
		e = e < 0 ? 1 : 0;
	}
	// IE8 may have middle button as 4 instead of 1
	return (e === 2) ? 2 : (e ? 1 : 0);
};

$.ig.util.isTouchDevice = function () {
    return 'ontouchstart' in window ||
        window.navigator.msMaxTouchPoints > 0;
};

// animates rotation 
$.fn.animateRotate = function (startAngle, endAngle, duration, easing, complete) {
	return this.each(function(){
		var elem = $(this);
		$({deg: startAngle}).animate({deg: endAngle}, {
			duration: duration,
			easing: easing,
			step: function(now){
				elem.css({
					"-moz-transform": "rotate(" + now + "deg)",
					"-webkit-transform": "rotate(" + now + "deg)",
					"-o-transform": "rotate(" + now + "deg)",
					"-ms-transform": "rotate(" + now + "deg)",
					"transform": "rotate(" + now + "deg)"
				});
			},
			complete: complete || $.noop
		});
	});
};
// returns date object(from string formatted in ISO8601)
$.ig.util.dateFromISO = function (obj) {
	var //regexIso8601 = /^(\d{4}|\+\d{6})(?:-(\d{2})(?:-(\d{2})(?:T(\d{2}):(\d{2}):(\d{2})\.(\d{1,7})(?:Z|([\-+])(\d{2}):(\d{2}))?)?)?)?$/,
		regexIso8601 = /^(\d{4}|\+\d{6})(?:-(\d{2})(?:-(\d{2})(?:T(\d{2})(?::(\d{2})(?::(\d{2})(?:\.(\d{1,7})(?:Z|([\-+])(\d{2}):(\d{2}))?)?)?)?)?)?)?$/,
		m = regexIso8601.exec(obj);
	if (m) {
		return new Date(Date.UTC(
			m[1],
			(m[2] || 1) - 1,
			m[3] || 1,
			m[4] - (m[8] ? m[8] + m[9] : 0) || 0,
			m[5] - (m[8] ? m[8] + m[10] : 0) || 0,
			m[6] || 0,
			((m[7] || 0) + '00').substr(0, 3)
		));
	}
	return obj;
};

	$.ig.util.defaultDVDateParse = function (obj) {
	    return new Date(parseInt(obj.replace('/Date(', '').replace(')/', ''), 10));
	};

// creates crc32 table
$.ig.util.makeCRCTable = function () {
	var c, n, k, crcTable = [];
	for (n = 0; n < 256; n++) {
		c = n;
		for (k = 0; k < 8; k++) {
		    /*jslint bitwise: true */
			c = ((c & 1) ? (0xEDB88320 ^ (c >>> 1)) : (c >>> 1));
		}
		crcTable[n] = c;
	}
	return crcTable;
};
// returns crc32 checksum for the input string
$.ig.util.crc32 = function (str) {
    /*jslint bitwise: true */
	var crcTable = $.ig.util.crcTable || ($.ig.util.crcTable = $.ig.util.makeCRCTable()),
		crc = 0 ^ (-1), i;
	str = unescape(encodeURIComponent(str));
	for (i = 0; i < str.length; i++) {
		crc = (crc >>> 8) ^ crcTable[(crc ^ str.charCodeAt(i)) & 0xFF];
	}
	return (crc ^ (-1)) >>> 0;
};
// returns checksum based on the string representations of an object's property values
$.ig.util.getCheckSumForObject = function (obj) {
	var str = "", key;
	for (key in obj) {
		if (obj.hasOwnProperty(key) && typeof obj[key] !== "object"/* only stringify simple properties */) {
			str += obj[key];
		}
	}
	return $.ig.util.crc32(str);
};

$.ig.util.createGuid = function () {
    /*jslint bitwise: true */
    function S4() {
        return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
    }

    return (S4() + S4() + "-" + S4() + "-4" + S4().substr(0, 3) + "-" + S4() + "-" + S4() + S4() + S4()).toLowerCase();
};

$.ig.util.escapeRegExp = function (str) {
    return str.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&");
};

$.ig.util.replace = function (str, oldValue, newValue) {
    return str.replace(new RegExp($.ig.util.escapeRegExp(oldValue), "g"), newValue);
};

// Implements the .NET String.Format functionality
$.ig.util.stringFormat = function (format) {
    return $.ig.util.stringFormat1(format, Array.prototype.slice.call(arguments, 1));
};

$.ig.util.stringFormat1 = function (format, args) {
    return $.ig.util.stringFormat2($.ig.CultureInfo.prototype.currentCulture(), format, args);
};

$.ig.util.stringFormat2 = function (provider, format, args) {
    // TODO: Use the provider somehow
    return format.replace(/{(\d+)}/g, function (match, number) {
        var arg = args[number];
        return arg !== void 0 ? arg : match;
    });
};

$.ig.util.createInstance = function ($t) {
    if ($t === Number || $t == $.ig.Number.prototype.$type || $t.baseType === $.ig.Enum.prototype.$type) {
        return 0;
    }

    if ($t == Boolean || $t == $.ig.Boolean.prototype.$type) {
        return false;
    }

    if ($t.InstanceConstructor) {
        var result = Object.create($t.InstanceConstructor.prototype);
        $t.InstanceConstructor.apply(result, Array.prototype.slice.call(arguments, 1));
        return result;
    }

    throw new Error("Cannot find instance constructor for the type parameter");
};

$.ig.util.getDefaultValue = function ($t) {
    if ($t === Number || $t == $.ig.Number.prototype.$type || $t.baseType === $.ig.Enum.prototype.$type) {
        return 0;
    }

    if ($t == Boolean || $t == $.ig.Boolean.prototype.$type) {
        return false;
    }

    if ($t.baseType === $.ig.ValueType.prototype.$type) {
        return $.ig.util.createInstance($t);
    }

    return null;
};

$.ig.util.compareSimple = function (item1, item2) {
    if (item1 == item2) {
        return 0;
    }

    if (item1 < item2) {
        return -1;
    }
    return 1;
};

$.ig.util.compare = function (item1, item2) {
    if (item1 === item2) {
        return 0;
    }

    var xComparable = $.ig.util.cast($.ig.IComparable.prototype.$type, item1);
    if (xComparable !== null) {
        return xComparable.compareTo(item2);
    }

    var yComparable = $.ig.util.cast($.ig.IComparable.prototype.$type, item2);
    if (yComparable !== null) {
        return -yComparable.compareTo(item1);
    }

    return $.ig.util.compareSimple(item1, item2);
};

$.ig.util.boolCompare = function (item1, item2) {
    if (item1 == item2) {
        return 0;
    }

    return item1 ? 1 : -1;
};

$.ig.util.sleep = function (milliseconds) {
    var start = new Date().getTime();
    for (var i = 0; i < 1e7; i++) {
        if ((new Date().getTime() - start) > milliseconds) {
            break;
        }
    }
};

$.ig.util.toCharArray = function (string) {
    {
        return string.split('');
    }
};

$.ig.util.stringCompare1 = function (strA, strB, comparisonType) {

    if (!strA) {
        return !strB ? 0 : -1;
    }
    else if (!strB) {
        return 1;
    }

    // TODO: Make sure this is right
    switch (comparisonType) {
        case $.ig.StringComparison.prototype.currentCulture:
            return $.ig.CultureInfo.prototype.currentCulture().compareInfo().compare4(strA, strB);
        case $.ig.StringComparison.prototype.currentCultureIgnoreCase:
            return $.ig.CultureInfo.prototype.currentCulture().compareInfo().compare4(strA.toLowerCase(), strB.toLowerCase());
        case $.ig.StringComparison.prototype.invariantCulture:
        case $.ig.StringComparison.prototype.ordinal:
            return strA.compareTo(strB);
        case $.ig.StringComparison.prototype.invariantCultureIgnoreCase:
        case $.ig.StringComparison.prototype.ordinalIgnoreCase:
            return strA.toLowerCase().compareTo(strB.toLowerCase());
        default:
            break;
    }

    return 0;
};

$.ig.util.stringCompare2 = function (strA, strB, culture, options) {
    return culture.compareInfo().compare5(strA, strB, options);
};

$.ig.util.stringCompare3 = function (strA, indexA, strB, indexB, length) {
    var v1 = strA.substring(indexA, length);
    var v2 = strB.substring(indexB, length);
    return $.ig.util.stringCompare1(v1, v2, $.ig.StringComparison.prototype.currentCulture);
};

$.ig.util.tryParseNumber = function (s) {
    var value = Number(s);
    if (value !== null && isFinite(value) && s.trim().length !== 0) {
        return {
            p1: value,
            ret: true
        };
    } else {
        return {
            p1: 0,
            ret: false
        };
    }
};

$.ig.util.tryParseNumber1 = function (s, style, provider) {
    var value,
        i,
        currentCharCode;

    /*jslint bitwise: true */
    if (style & $.ig.NumberStyles.prototype.allowLeadingWhite) {
        s = s.trimStart();
    }

    if (style & $.ig.NumberStyles.prototype.allowTrailingWhite) {
        s = s.trimEnd();
    }

    if (s.length != s.trim().length) {
        return {
            p3: 0,
            ret: false
        };
    }

    var multiplier = 1;
    if (style & $.ig.NumberStyles.prototype.allowParentheses) {
        // TODO: Is this correct? will the parens always be on the outside of any leading/trailing sign?
        if (s[0] == '(' && s[s.length - 1] == ')') {
            multiplier *= -1;
            s = s.slice(1, -1);
        }
    }

    if (style & $.ig.NumberStyles.prototype.allowLeadingSign) {
        // TODO: Use culture info from the provider here
        if (s[0] == '+') {
            s = s.slice(1);
        } else if (s[0] == '-') {
            multiplier *= -1;
            s = s.slice(1);
        }
    }

    if (style & $.ig.NumberStyles.prototype.allowTrailingSign) {
        // TODO
    }

    if (style & $.ig.NumberStyles.prototype.allowCurrencySymbol) {
        // TODO
    }

    if (style & $.ig.NumberStyles.prototype.allowDecimalPoint) {

        if (style & $.ig.NumberStyles.prototype.allowExponent) {
            // TODO
        }

        // TODO: Use locale from provider here
        value = Number(s);

        if (value !== null && isFinite(value) && s.trim().length !== 0) {
            return {
                p3: value * multiplier,
                ret: true
            };
        }
    } else {
        var zeroCharCode = '0'.charCodeAt(0);
        var nineCharCode = '9'.charCodeAt(0);

        value = 0;

        if (style & $.ig.NumberStyles.prototype.allowHexSpecifier) {
            var aCharCode = 'a'.charCodeAt(0);
            var fCharCode = 'f'.charCodeAt(0);
            var ACharCode = 'A'.charCodeAt(0);
            var FCharCode = 'F'.charCodeAt(0);

            
            for (i = 0; i < s.length; i++) {
                value *= 16;

                currentCharCode = s[i].charCodeAt(0);
                if (zeroCharCode <= currentCharCode && currentCharCode <= nineCharCode) {
                    value += (currentCharCode - zeroCharCode);
                } else if (aCharCode <= currentCharCode && currentCharCode <= fCharCode) {
                    value += (currentCharCode - aCharCode) + 10;
                } else if (ACharCode <= currentCharCode && currentCharCode <= FCharCode) {
                    value += (currentCharCode - ACharCode) + 10;
                } else {
                    return {
                        p3: 0,
                        ret: false
                    };
                }
            }
        } else {
            for (i = 0; i < s.length; i++) {
                value *= 10;

                currentCharCode = s[i].charCodeAt(0);
                if (zeroCharCode <= currentCharCode && currentCharCode <= nineCharCode) {
                    value += (currentCharCode - zeroCharCode);
                } else {
                    return {
                        p3: 0,
                        ret: false
                    };
                }
            }
        }

        return {
            p3: value * multiplier,
            ret: true
        };
    }

    return {
        p3: 0,
        ret: false
    };
};

$.ig.util.parseNumber = function (s, provider) {
    var r = $.ig.util.tryParseNumber1(s, 231, provider);
    if (!r.ret) {
        throw new $.ig.FormatException(1, "Incorrect number format");
    }

    return r.p3;
};

$.ig.util.isNegativeInfinity = function (v) {
    return v == Number.NEGATIVE_INFINITY;
};

$.ig.util.isPositiveInfinity = function (v) {
    return v == Number.POSITIVE_INFINITY;
};

$.ig.util.parseInt8_1 = function (s, provider) {
    return $.ig.util.parseIntCore(s, provider, -128, 127);
};

$.ig.util.parseInt8_2 = function (s, style, provider) {
    return $.ig.util.parseIntCore(s, provider, -128, 127, style);
};

$.ig.util.parseInt16_1 = function (s, provider) {
    return $.ig.util.parseIntCore(s, provider, -32768, 32767);
};

$.ig.util.parseInt16_2 = function (s, style, provider) {
    return $.ig.util.parseIntCore(s, provider, -32768, 32767, style);
};

$.ig.util.parseInt32_1 = function (s, provider) {
    return $.ig.util.parseIntCore(s, provider, -2147483648, 2147483647);
};

$.ig.util.parseInt32_2 = function (s, style, provider) {
    return $.ig.util.parseIntCore(s, provider, -2147483648, 2147483647, style);
};

$.ig.util.parseInt64_1 = function (s, provider) {
    return $.ig.util.parseIntCore(s, provider, -9223372036854775808, 9223372036854775807);
};

$.ig.util.parseInt64_2 = function (s, style, provider) {
    return $.ig.util.parseIntCore(s, provider, -9223372036854775808, 9223372036854775807, style);
};

$.ig.util.parseUInt8_1 = function (s, provider) {
    return $.ig.util.parseIntCore(s, provider, 0, 255);
};

$.ig.util.parseUInt8_2 = function (s, style, provider) {
    return $.ig.util.parseIntCore(s, provider, 0, 255, style);
};

$.ig.util.parseUInt16_1 = function (s, provider) {
    return $.ig.util.parseIntCore(s, provider, 0, 65535);
};

$.ig.util.parseUInt16_2 = function (s, style, provider) {
    return $.ig.util.parseIntCore(s, provider, 0, 65535, style);
};

$.ig.util.parseUInt32_1 = function (s, provider) {
    return $.ig.util.parseIntCore(s, provider, 0, 4294967295);
};

$.ig.util.parseUInt32_2 = function (s, style, provider) {
    return $.ig.util.parseIntCore(s, provider, 0, 4294967295, style);
};

$.ig.util.parseUInt64_1 = function (s, provider) {
    return $.ig.util.parseIntCore(s, provider, 0, 18446744073709551615);
};

$.ig.util.parseUInt64_2 = function (s, style, provider) {
    return $.ig.util.parseIntCore(s, provider, 0, 18446744073709551615, style);
};

$.ig.util.parseIntCore = function (s, provider, min, max, style) {
    var r = $.ig.util.tryParseIntCore(s, provider, min, max, style);

    if (!r.ret) {
        throw new $.ig.FormatException(1, "Incorrect number format");
    }

    return r.p3;
};

$.ig.util.tryParseInt8_1 = function (s, provider) {
    return $.ig.util.tryParseIntCore(s, provider, -128, 127);
};

$.ig.util.tryParseInt8_2 = function (s, style, provider) {
    return $.ig.util.tryParseIntCore(s, provider, -128, 127, style);
};

$.ig.util.tryParseInt16_1 = function (s, provider) {
    return $.ig.util.tryParseIntCore(s, provider, -32768, 32767);
};

$.ig.util.tryParseInt16_2 = function (s, style, provider) {
    return $.ig.util.tryParseIntCore(s, provider, -32768, 32767, style);
};

$.ig.util.tryParseInt32_1 = function (s, provider) {
    return $.ig.util.tryParseIntCore(s, provider, -2147483648, 2147483647);
};

$.ig.util.tryParseInt32_2 = function (s, style, provider) {
    return $.ig.util.tryParseIntCore(s, provider, -2147483648, 2147483647, style);
};

$.ig.util.tryParseInt64_1 = function (s, provider) {
    return $.ig.util.tryParseIntCore(s, provider, -9223372036854775808, 9223372036854775807);
};

$.ig.util.tryParseInt64_2 = function (s, style, provider) {
    return $.ig.util.tryParseIntCore(s, provider, -9223372036854775808, 9223372036854775807, style);
};

$.ig.util.tryParseUInt8_1 = function (s, provider) {
    return $.ig.util.tryParseIntCore(s, provider, 0, 255);
};

$.ig.util.tryParseUInt8_2 = function (s, style, provider) {
    return $.ig.util.tryParseIntCore(s, provider, 0, 255, style);
};

$.ig.util.tryParseUInt16_1 = function (s, provider) {
    return $.ig.util.tryParseIntCore(s, provider, 0, 65535);
};

$.ig.util.tryParseUInt16_2 = function (s, style, provider) {
    return $.ig.util.tryParseIntCore(s, provider, 0, 65535, style);
};

$.ig.util.tryParseUInt32_1 = function (s, provider) {
    return $.ig.util.tryParseIntCore(s, provider, 0, 4294967295);
};

$.ig.util.tryParseUInt32_2 = function (s, style, provider) {
    return $.ig.util.tryParseIntCore(s, provider, 0, 4294967295, style);
};

$.ig.util.tryParseUInt64_1 = function (s, provider) {
    return $.ig.util.tryParseIntCore(s, provider, 0, 18446744073709551615);
};

$.ig.util.tryParseUInt64_2 = function (s, style, provider) {
    return $.ig.util.tryParseIntCore(s, provider, 0, 18446744073709551615, style);
};

$.ig.util.tryParseIntCore = function (s, provider, min, max, style) {
    /*jshint eqnull:true */
    /*jslint bitwise: true */
    style = style != null ? style : $.ig.NumberStyles.prototype.integer; // Don't use || here, because 0 could be a valid style
    provider = provider || $.ig.CultureInfo.prototype.currentCulture();

    var r = $.ig.util.tryParseNumber1(s, style, provider);

    if ((style & $.ig.NumberStyles.prototype.allowHexSpecifier) && max < r.p3) {
        r.p3 -= (-min * 2);
    }

    if (!r.ret || r.p3 < min || max < r.p3 || r.p3 % 1 !== 0) {
        return {
            p1: 0,
            p3: 0,
            ret: false
        };
    }

    r.p1 = r.p3;
    return r;
};

$.ig.util.arrayClear1 = function (array, index, length) {
    for (var i = index; i < index + length; i++) {
        array[i] = null;
    }
};

$.ig.util.arrayCopy1 = function (source, sourceIndex, dest, destIndex, count) {
    for (var i = 0; i < count; i++) {
        dest[i + destIndex] = source[i + sourceIndex];
    }
};

$.ig.util.arrayCopy2 = function (source, dest, count) {
    for (var i = 0; i < count; i++) {
        dest[i] = source[i];
    }
};

$.ig.util.arrayCopyTo = function (source, dest, index) {
    for (var i = 0; i < source.length; i++) {
        dest[index++] = source[i];
    }
};

$.ig.util.arrayIndexOf1 = function ($t, array, value) {
    return array.indexOf(value);
};

$.ig.util.isNaN = function (v) {
    return v !== v; // http://us6.campaign-archive1.com/?u=2cc20705b76fa66ab84a6634f&id=43bf7f05e9
};

$.ig.util.numberToString = function (number, provider) {
    return $.ig.util.numberToString1(number, 'G', provider);
};

var noGroupingOptions = { useGrouping: false };

$.ig.util.numberToString1 = function (number, format, provider) {
    provider = provider || $.ig.CultureInfo.prototype.currentCulture();

    switch (format) {
        case 'G':
        case 'R':
            return number.toLocaleString(provider.name(), noGroupingOptions);
    }

    throw new Error("Unsupported format code: " + format);
};

$.ig.util.intToString = function (number, provider) {
    return $.ig.util.intToString1(number, 'G', provider);
};

$.ig.util.intToString1 = function (number, format, provider) {
    provider = provider || $.ig.CultureInfo.prototype.currentCulture();

    if (format && format.length) {
        if (format[0] == 'X') {
            number = $.ig.util.intSToU(number);

            var result = number.toString(16).toUpperCase();
            if (format.length !== 1) {
                var digits = +format.substr(1);
                if (!isFinite(digits)) {
                    throw new Error("Unsupported format code: " + format);
                }

                while (result.length < digits) {
                    result = '0' + result;
                }
            }

            return result;
        }
    }

    switch (format) {
        case 'G':
            return number.toLocaleString(provider.name(), noGroupingOptions);
    }

    throw new Error("Unsupported format code: " + format);
};

$.ig.util.intSToU = function (number) {
    if (number < 0) {
        number = number + 1 + 0xFFFFFFFF;
    }

    return number;
};

$.ig.util.enumHasFlag = function (value, flag) {
    /*jslint bitwise: true */
    return (value & flag) === flag;
};

$.ig.util.boolToString = function (value, provider) {
    return value.toString();
};

$.ig.util.getArrayOfValues = function (obj) {
    var result = [];
    for (var i in obj) {
        if (obj.hasOwnProperty(i)) {
            result.push(obj[i]);
    }
    }

    return result;
};

$.ig.util.getArrayOfProperties = function (obj) {
    var result = [];
    for (var i in obj) {
        if (obj.hasOwnProperty(i)) {
            result.push(i);
    }
    }

    return result;
};

$.ig.util.stringInsert = function (str, index, value) {
    return str.substr(0, index) + value + str.substr(index);
};

$.ig.util.b64toUint8Array = function (b64Data, nBlocksSize) {
    /*jslint bitwise: true */
    function b64ToUint6(nChr) {

        return nChr > 64 && nChr < 91 ?
            nChr - 65
          : nChr > 96 && nChr < 123 ?
            nChr - 71
          : nChr > 47 && nChr < 58 ?
            nChr + 4
          : nChr === 43 ?
            62
          : nChr === 47 ?
            63
          :
            0;

    }

    var
        sB64Enc = b64Data.replace(/[^A-Za-z0-9\+\/]/g, ""), nInLen = sB64Enc.length,
        nOutLen = nBlocksSize ? Math.ceil((nInLen * 3 + 1 >> 2) / nBlocksSize) * nBlocksSize : nInLen * 3 + 1 >> 2, taBytes = new Uint8Array(nOutLen);

    for (var nMod3, nMod4, nUint24 = 0, nOutIdx = 0, nInIdx = 0; nInIdx < nInLen; nInIdx++) {
        nMod4 = nInIdx & 3;
        nUint24 |= b64ToUint6(sB64Enc.charCodeAt(nInIdx)) << 18 - 6 * nMod4;
        if (nMod4 === 3 || nInLen - nInIdx === 1) {
            for (nMod3 = 0; nMod3 < 3 && nOutIdx < nOutLen; nMod3++, nOutIdx++) {
                taBytes[nOutIdx] = nUint24 >>> (16 >>> nMod3 & 24) & 255;
            }
            nUint24 = 0;

        }
    }

    return taBytes;
};

$.ig.util.stringSplit = function (value, separators, options) {
    var r = "",
        i;
    for (i = 0; i < separators.length; i++) {

        if (i !== 0) {
            r += "|";
        }

        r += "(" + $.ig.util.escapeRegExp(separators[i]) + ")";
    }

    var result = value.split(new RegExp(r));

    for (i = result.length - 1; i >= 0; i--) {
        /*jslint bitwise: true */
        if ((result[i].length === 0 && (options & $.ig.StringSplitOptions.prototype.removeEmptyEntries)) || separators.contains(result[i])) {
            result.splice(i, 1);
        }
    }

    return result;
};

$.ig.util.stringJoin = function (sep, vals) {
    return vals.join(sep);
};

$.ig.util.stringJoin1 = function ($t, sep, vals) {
    var result;
    var en = vals.getEnumerator();
    while (en.moveNext()) {
        var v = en.current().toString();

        if (result === undefined) {
            result = v;
        }
        else {
            result += sep + v;
    }
    }

    return result;
};

$.ig.util.toString$1 = function ($t, v) {
    if (v !== null && $t && $t.isEnum && $t.isEnum()) {
        return $t.InstanceConstructor.prototype.getName(v);
    }

    return v.toString();
};

$.ig.util.getValueIfEnum = function ($t, v) {
    if (v !== null && $t && $t.isEnum && $t.isEnum()) {
        return v.value();
    }

    return v;
};

$.ig.util.getBoxIfEnum = function ($t, v) {
    if (v !== null && $t && $t.isEnum && $t.isEnum()) {
        return $t.InstanceConstructor.prototype.getBox(v);
    }

    return v;
};

$.ig.util.getValue = function (v) {
    if (v !== null && v.$type && v.$type.isEnum && v.$type.isEnum()) {
        return v.value();
    }

    return v;
};

$.ig.util.getEnumValue = function (v) {
    if (v !== null) {
    	if (typeof v === "number") {
    		return v;
    	} else {
    		return v.value();	
    	}
    }

    return 0;
};

$.ig.util.netRegexToJS = function (netPattern) {
    var jsPattern = "";
    var nextNETGroupIndex = 1;
    var nextJSGroupIndex = 1;
    var namedGroups = [];
    var nameToJSGroupIndexMap = {};
    var netToJSGroupIndexMap = [0];
    var matchMustStartAtCurrentPosition = false;
    var name;

    var i = 0;
    if (netPattern.startsWith('\\G')) {
        i += 2;
        matchMustStartAtCurrentPosition = true;
    }

    var isInClass = false;
    for (; i < netPattern.length; i++) {
        var current = netPattern.charAt(i);
        switch (current) {
            case '\\':
                switch (netPattern.charAt(i + 1)) {
                    case 'A':
                        jsPattern = jsPattern.concat('^');
                        i++;
                        break;

                    case 'z':
                    case 'Z':
                        jsPattern = jsPattern.concat('$');
                        i++;
                        break;

                    case 'G':
                        throw new Error("\\G .NET Regex escape is only supported at the start of the pattern.");

                    case 'p':
                        if (netPattern.charAt(i + 2) !== '{') {
                            throw new Error("\\p should be followed by braces.");
                        }

                        var endBraceIndex = netPattern.indexOf('}', i + 3);
                        if (endBraceIndex < 0) {
                            throw new Error("Could not find the close brace of the \\p pattern.");
                        }

                        var pattern = netPattern.substring(i + 3, endBraceIndex);
                        i = endBraceIndex;

                        switch (pattern) {
                            case 'L':
                                // TODO: Add unicode support
                                if (isInClass) {
                                    jsPattern = jsPattern.concat('A-Za-z');
                                }
                                else {
                                    jsPattern = jsPattern.concat('[A-Za-z]');
                                }

                                break;

                            default:
                                throw new Error("Unknown \\p pattern: " + pattern);
                        }
                        break;

                    default:
                        jsPattern = jsPattern.concat(netPattern.substr(i, 2));
                        i++;
                        break;
                }
                break;

            case '/':
                jsPattern = jsPattern.concat('\\/');
                break;

            case '[':
                isInClass = true;
                jsPattern = jsPattern.concat('[');
                break;

            case ']':
                isInClass = false;
                jsPattern = jsPattern.concat(']');
                break;

            case '(':

                jsPattern = jsPattern.concat('(');

                var next = netPattern[i + 1];
                name = "";

                if (next === '?') {
                    i++;
                    next = netPattern[i + 1];
                    if (next === '<' || next === '\'') {

                        if (netPattern[i + 2] === '=' || netPattern[i + 2] === '!') {
                            throw new Error("Lookbehind assertions are not supported in JavaScript: " + pattern);
                        }

                        i++;
                        var end = next === '<' ? '>' : '\'';
                        var start = ++i;
                        for (; i < netPattern.length && netPattern[i] != end; i++) {
                        }

                        name = netPattern.slice(start, i);
                    } else {
                        jsPattern = jsPattern.concat('?');

                        // Non-capturing group
                        if (next === ':') {
                            continue;
                        }
                    }
                }

                var currentJSGroupIndex = nextJSGroupIndex++;

                if (name.length !== 0) {
                    namedGroups.push(name);
                    nameToJSGroupIndexMap[name] = currentJSGroupIndex;
                } else {
                    netToJSGroupIndexMap[nextNETGroupIndex++] = currentJSGroupIndex;
                }

                break;

            default:
                jsPattern = jsPattern.concat(netPattern.substr(i, 1));
                break;
        }
    }

    var nameToNetGroupIndexMap = {};
    for (i = 0; i < namedGroups.length; i++) {
        var currentNETGroupIndex = nextNETGroupIndex++;
        name = namedGroups[i];
        netToJSGroupIndexMap[currentNETGroupIndex] = nameToJSGroupIndexMap[name];
        nameToNetGroupIndexMap[name] = currentNETGroupIndex;
    }

    return {
        pattern: jsPattern,
        nameToNetGroupIndexMap: nameToNetGroupIndexMap,
        netToJSGroupIndexMap: netToJSGroupIndexMap,
        matchMustStartAtCurrentPosition: matchMustStartAtCurrentPosition
    };
};
	$.ig.util.invokeCallback = function (callback, args) {
		if (callback) {
			if ($.type(callback) === 'string' && window[callback] && $.type(window[callback]) === 'function') {
				callback = window[callback];
			}
			if ($.type(callback) === 'function') {
				callback.apply(window, args);
			}
		}
	};
// M.H. 5 Mar 2013 Fix for bug #134982: When you instantiate dataSource object and there isn't reference to jQueryUI js error is thrown.
if ($.Widget) {
	// M.H. 1 Mar 2013 Fix for bug #134534: Updating the jQuery`s version breaks most of the samples in the new samples browser
	// In jquery-ui 1.9.2+ it is used only full name - we fix this breaking change as adding also widgetName(it is used in older versions)
	(function (createWidget) {
		$.Widget.prototype._createWidget = function (options, element) {
			var el = $(element || this.defaultElement || this)[0];
			if (el !== this) {
				$.data(el, this.widgetName, this);
			}
			return createWidget.apply(this, arguments);
		};
	})($.Widget.prototype._createWidget);
}

    /*<BeginType Name="System.SystemException" />*/
    $.ig.util.defType('SystemException', 'Error', {
        init: function (initNumber) {
            if (initNumber > 0) {
                switch (initNumber) {
                    case 1:
                        this.init1.apply(this, arguments);
                        break;
                    case 2:
                        this.init2.apply(this, arguments);
                        break;
                }
                return;
            }

            $.ig.Error.prototype.init.call(this, 0);
        },
        init1: function (initNumber, message) {
            $.ig.Error.prototype.init1.call(this, 1, message);
        },
        init2: function (initNumber, message, innerException) {
            $.ig.Error.prototype.init2.call(this, 2, message, innerException);
        },
        $type: new $.ig.Type('SystemException', $.ig.Error.prototype.$type)
    }, true);
    /*<EndType Name="System.SystemException" />*/

    /*<BeginType Name="System.FormatException" />*/
    $.ig.util.defType('FormatException', 'SystemException', {
        init: function (initNumber) {
            if (initNumber > 0) {
                switch (initNumber) {
                    case 1:
                        this.init1.apply(this, arguments);
                        break;
                    case 2:
                        this.init2.apply(this, arguments);
                        break;
                }
                return;
            }

            $.ig.SystemException.prototype.init.call(this, 0);
        },
        init1: function (initNumber, message) {
            $.ig.SystemException.prototype.init1.call(this, 1, message);
        },
        init2: function (initNumber, message, innerException) {
            $.ig.SystemException.prototype.init2.call(this, 2, message, innerException);
        },
        $type: new $.ig.Type('FormatException', $.ig.SystemException.prototype.$type)
    }, true);
    /*<EndType Name="System.FormatException" />*/

    $.ig.util.defType('NumberStyles', 'Enum', {
        init: function (v) {
            this._v = v;
        },
        getName: (function () {
            function getNameSingle(v) {
                switch (v) {
                    case 0: return "None";
                    case 1: return "AllowLeadingWhite";
                    case 2: return "AllowTrailingWhite";
                    case 4: return "AllowLeadingSign";
                    case 7: return "Integer";
                    case 8: return "AllowTrailingSign";
                    case 16: return "AllowParentheses";
                    case 32: return "AllowDecimalPoint";
                    case 64: return "AllowThousands";
                    case 111: return "Number";
                    case 128: return "AllowExponent";
                    case 167: return "Float";
                    case 256: return "AllowCurrencySymbol";
                    case 383: return "Currency";
                    case 511: return "Any";
                    case 512: return "AllowHexSpecifier";
                    case 515: return "HexNumber";
                    default: return v.toString();
                }
            }
            return function (v) {
                return this.getFlaggedName(v, getNameSingle);
            };
        }()),
        value: function () {
            return this._v;
        },
        $type: new $.ig.Type('NumberStyles', $.ig.Enum.prototype.$type)
    }, true);
    $.ig.NumberStyles.prototype.none = 0;
    $.ig.NumberStyles.prototype.allowLeadingWhite = 1;
    $.ig.NumberStyles.prototype.allowTrailingWhite = 2;
    $.ig.NumberStyles.prototype.allowLeadingSign = 4;
    $.ig.NumberStyles.prototype.integer = 7;
    $.ig.NumberStyles.prototype.allowTrailingSign = 8;
    $.ig.NumberStyles.prototype.allowParentheses = 16;
    $.ig.NumberStyles.prototype.allowDecimalPoint = 32;
    $.ig.NumberStyles.prototype.allowThousands = 64;
    $.ig.NumberStyles.prototype.number = 111;
    $.ig.NumberStyles.prototype.allowExponent = 128;
    $.ig.NumberStyles.prototype.floatNumber = 167;
    $.ig.NumberStyles.prototype.allowCurrencySymbol = 256;
    $.ig.NumberStyles.prototype.currency = 383;
    $.ig.NumberStyles.prototype.any = 511;
    $.ig.NumberStyles.prototype.allowHexSpecifier = 512;
    $.ig.NumberStyles.prototype.hexNumber = 515;

    $.ig.util.defType('CompareOptions', 'Enum', {
        init: function (v) {
            this._v = v;
        },
        getName: (function () {
            function getNameSingle(v) {
                switch (v) {
                    case 0: return "None";
                    case 1: return "IgnoreCase";
                    case 2: return "IgnoreNonSpace";
                    case 4: return "IgnoreSymbols";
                    case 8: return "IgnoreKanaType";
                    case 16: return "IgnoreWidth";
                    case 268435456: return "OrdinalIgnoreCase";
                    case 536870912: return "StringSort";
                    case 1073741824: return "Ordinal";
                    default: return v.toString();
                }
            }
            return function (v) {
                return this.getFlaggedName(v, getNameSingle);
            };
        }()),
        value: function () {
            return this._v;
        },
        $type: new $.ig.Type('CompareOptions', $.ig.Enum.prototype.$type)
    }, true);
    $.ig.CompareOptions.prototype.none = 0;
    $.ig.CompareOptions.prototype.ignoreCase = 1;
    $.ig.CompareOptions.prototype.ignoreNonSpace = 2;
    $.ig.CompareOptions.prototype.ignoreSymbols = 4;
    $.ig.CompareOptions.prototype.ignoreKanaType = 8;
    $.ig.CompareOptions.prototype.ignoreWidth = 16;
    $.ig.CompareOptions.prototype.ordinalIgnoreCase = 268435456;
    $.ig.CompareOptions.prototype.stringSort = 536870912;
    $.ig.CompareOptions.prototype.ordinal = 1073741824;

    $.ig.util.defType('StringComparison', 'Enum', {
        init: function (v) {
            this._v = v;
        },
        getName: function (v) {
            switch (v) {
                case 0: return "CurrentCulture";
                case 1: return "CurrentCultureIgnoreCase";
                case 2: return "InvariantCulture";
                case 3: return "InvariantCultureIgnoreCase";
                case 4: return "Ordinal";
                case 5: return "OrdinalIgnoreCase";
                default: return v.toString();
            }
        },
        value: function () {
            return this._v;
        },
        $type: new $.ig.Type('StringComparison', $.ig.Enum.prototype.$type)
    }, true);
    $.ig.StringComparison.prototype.currentCulture = 0;
    $.ig.StringComparison.prototype.currentCultureIgnoreCase = 1;
    $.ig.StringComparison.prototype.invariantCulture = 2;
    $.ig.StringComparison.prototype.invariantCultureIgnoreCase = 3;
    $.ig.StringComparison.prototype.ordinal = 4;
    $.ig.StringComparison.prototype.ordinalIgnoreCase = 5;
    
    $.ig.util.defType('DateTimeKind', 'Enum', {
        init: function (v) {
            this._v = v;
        },
        getName: function (v) {
            switch (v) {
                case 0: return "Unspecified";
                case 1: return "Utc";
                case 2: return "Local";
                default: return v.toString();
            }
        },
        value: function () {
            return this._v;
        },
        $type: new $.ig.Type('DateTimeKind', $.ig.Enum.prototype.$type)
    }, true);
    $.ig.DateTimeKind.prototype.unspecified = 0;
    $.ig.DateTimeKind.prototype.utc = 1;
    $.ig.DateTimeKind.prototype.local = 2;

    $.ig.util.defType('SeekOrigin', 'Enum', {
        init: function (v) {
            this._v = v;
        },
        getName: function (v) {
            switch (v) {
                case 0: return "Begin";
                case 1: return "Current";
                case 2: return "End";
                default: return v.toString();
            }
        },
        value: function () {
            return this._v;
        },
        $type: new $.ig.Type('SeekOrigin', $.ig.Enum.prototype.$type)
    }, true);
    $.ig.SeekOrigin.prototype.begin = 0;
    $.ig.SeekOrigin.prototype.current = 1;
    $.ig.SeekOrigin.prototype.end = 2;

    $.ig.util.defType('StringSplitOptions', 'Enum', {
        init: function (v) {
            this._v = v;
        },
        getName: function (v) {
            switch (v) {
                case 0: return "None";
                case 1: return "RemoveEmptyEntries";
                default: return v.toString();
            }
        },
        value: function () {
            return this._v;
        },
        $type: new $.ig.Type('StringSplitOptions', $.ig.Enum.prototype.$type)
    }, true);
    $.ig.StringSplitOptions.prototype.none = 0;
    $.ig.StringSplitOptions.prototype.removeEmptyEntries = 1;

})(jQuery);



/*!@license
* Infragistics.Web.ClientUI data source localization resources 14.2.20142.1018
*
* Copyright (c) 2011-2014 Infragistics Inc.
*
* http://www.infragistics.com/
*
*/

/*global jQuery */
(function ($) {

    $.ig = $.ig || {};

    if (!$.ig.DataSourceLocale) {
	    $.ig.DataSourceLocale = {};

	    $.extend($.ig.DataSourceLocale, {

		    locale: {
			    invalidDataSource: "The supplied data source is invalid. It happens to be a scalar.",
			    unknownDataSource: "Cannot determine the data source type. Please specify if it is JSON or XML data.",
			    errorParsingArrays: "There was an error parsing the array data and applying the defined data schema: ",
			    errorParsingJson: "There was an error parsing the JSON data and applying the defined data schema: ",
			    errorParsingXml: "There was an error parsing the XML data and applying the defined data schema: ",
			    errorParsingHtmlTable: "There was an error extracting the data from the HTML Table and applying the schema : ",
			    errorExpectedTbodyParameter: "Expected a tbody or a table as a parameter.",
			    errorTableWithIdNotFound: "The HTML Table with the following ID was not found: ",
			    errorParsingHtmlTableNoSchema: "There was an error parsing the Table DOM: ",
			    errorParsingJsonNoSchema: "There was an error parsing/evaluating the JSON string: ",
			    errorParsingXmlNoSchema: "There was an error parsing the XML string: ",
			    errorXmlSourceWithoutSchema: "The supplied data source is an xml document, but there is no defined data schema ($.IgDataSchema) ",
			    errorUnrecognizedFilterCondition: " The filter condition that was passed was not recognized: ",
			    errorRemoteRequest: "The remote request to fetch data has failed: ",
			    errorSchemaMismatch: "The input data doesn't match the schema, the following field couldn't be mapped: ",
			    errorSchemaFieldCountMismatch: "The input data doesn't match the schema in terms of number of fields. ",
			    errorUnrecognizedResponseType: "The response type was either not set correctly, or it was not possible to detect it automatically. Please set settings.responseDataType and/or settings.responseContentType.",
			    hierarchicalTablesNotSupported: "Tables are not supported for HierarchicalSchema",
			    cannotBuildTemplate: "The jQuery template could not be built. There are no records present in the data source, and no columns defined.",
			    unrecognizedCondition: "Unrecognized filtering condition in the following expression: ",
			    fieldMismatch: "The following expression contains an invalid field or filtering condition: ",
			    noSortingFields: "There are no fields specified. You need to specify at least one field to sort by, when calling sort().",
			    filteringNoSchema: "There is no schema / fields specified. You need to specify a schema with field definitions and types to be able to filter the data source."
		    }
	    });

    }
})(jQuery);

/*!@license
 * Infragistics.Web.ClientUI Data Binding Plugin 14.2.20142.1018
 *
 * Copyright (c) 2011-2014 Infragistics Inc.
 * 
 * igDataSource provides the following functionality:
 * - read and parse local XML , JSON , and HTML data
 * - normalize / transform the above data according to a schema
 * - data type conversion (date, string, number, etc.)
 * - define relationships between two and more flat data sources - with primary/foreign keys, etc
 * - build URL params for requests that get remote data 
 * - in case of scenarios such as paging, understand and prase the response - expect that it's in a predefined format that can be additionall configured by the developer
 * - get data from WCF services  
 * - ability to combine local with remote functionality  
 * - queueing AJAX requests
 *	paging,filtering (searching), and sorting functionality that are control-independent are also implemented here
 *	the idea of this code is to serve as a data-source abstraction layer (client-side data source control)
 *	that may well be used by all other client-side controls , such as dropdown, tree, menu, etc. 
 *
 * http://www.infragistics.com/
 *
 * Depends on:
 *	jquery-1.4.4.js
 *	infragistics.util.js
 *
 */
/*global jQuery, Class, window, ActiveXObject, DOMParser, XPathResult, XMLSerializer, define */
(function ($) {

	$.ig = $.ig || {};
	/* A.T. 7 Feb 2011 - Usability review changes */
	/*
	$.ig.Constants = $.ig.Constants || {};
	
	$.ig.Constants.SortDirection = {
	None: 'none',
	Ascending: 'asc',
	Descending: 'desc'
	};

	$.ig.Constants.OpType = {
	Remote: 0,
	Local: 1
	};

	$.ig.Constants.SortMode = {
	Single: 0,
	Multi: 1
	};
	
	$.ig.Constants.FilterCondition = {
	StartsWith: "StartsWith",
	EndsWith: "EndsWith",
	Contains: "Contains",
	DoesNotContain: "DoesNotContain",
	Equals: "Equals",
	DoesNotEqual: "DoesNotEqual",
	GreaterThan: "GreaterThan",
	LessThan: "LessThan",
	GreaterThanOrEqualTo: "GreaterThanOrEqualTo",
	LessThanOrEqualTo: "LessThanOrEqualTo",
	True: "True",
	False: "False",
	After: "After",
	Before: "Before",
	Today: "Today",
	Yesterday: "Yesterday",
	ThisMonth: "ThisMonth",
	LastMonth: "LastMonth",
	NextMonth: "NextMonth",
	ThisYear: "ThisYear",
	LastYear: "LastYear",
	NextYear: "NextYear",
	On: "On",
	NotOn: "NotOn",
	Null: "Null",
	NotNull: "NotNull",
	Empty: "Empty",
	NotEmpty: "NotEmpty"
	//ThisQuarter: "ThisQuarter",
	//LastQuarter: "LastQuarter",
	//NextQuarter: "NextQuarter"
	};

	$.ig.Constants.DataSourceType = {
	Function : 0,
	Array : 1,
	HtmlTableString: 2, // the data source could be either the id of the element, a string starting with <table>, or a DOM object that is of nodeType== "TABLE" 
	HtmlTableId: 3,
	HtmlTableDOM: 4,
	JSON : 5, // json data, could be string or object 
	XML : 6, // xml data - could be string or object 
	Invalid: 7, // when data source is se to a boolean, number or date
	Unknown: 8, // when data source is a string or object 
	RemoteUrl: 9,
	Empty: 10
	};
	*/
	$.ig.DataSource = $.ig.DataSource || Class.extend({
		/* The Infragistics Data Source client-side component is implemented as a class, and has support for paging, sorting, and filtering
		it supports binding to various types of data sources including JSON, XML, HTML Table, WCF/REST services, JSONP, JSONP and OData combined, etc. 
		*/
		settings: {
			/* type="string" setting this is only necessary when the data source is set to a table in string format. we need to create an invisible dummy data container in the body and append the table data to it */
			id: 'ds',
			/* type="string" this is the property in the dataView where actual resulting records will be put. (So the dataView will not be array but an object if this is defined), after the potential data source transformation */
			outputResultsName: null,
			/* type="function" callback function to call when data binding is complete */
			callback: null,
			/* type="object" object on which to invoke the callback function */
			callee: null,
			/* type="array" this is the normalized (transformed) resulting data, after it's fetched from the data source */
			data: [],
			/* type="object" this is the source of data - non normalized. Can be an array, can be reference to some JSON object, can be a DOM element for a HTML TABLE, or a function */
			dataSource: null,
			//dataSourceUrl: null, // we don't even need the dataSourceUrl, it can be set in the dataSource
			/* type="object" client-side dataBinding event. Can be a string pointing to a function name, or an object pointing to a function */
			dataBinding: null,
			/* type="object" client-side dataBound event. Can be a string pointing to a function name, or an object pointing to a function */
			dataBound: null,
			/* type="string" specifies the HTTP verb to be used to issue the request */
			requestType: 'GET',
			/* type="json|xml|unknown|array|function|htmlTableString|htmlTableId|htmlTableDom|invalid|remoteUrl|empty" Type of the data source 
			json type="string" Specifies that the data source is an already evaluated JSON (JavaScript object/array) or a string that can be evaluated to JSON
			xml type="string" Specifies that the data source is a XML Document object or a string that can be evaluated to XML
			unknown type="string" Specifies that the data source is of unknown type. In that case it will be analyzed and automatically detected if possible
			array type="string" Specifies that the data source is a simple array of objects.
			function type="string" Specifies that the data source points to a function. During data binding the function will be called and the result will be assumed to be an array of objects
			htmlTableString type="string" Specifies that the data source points to a string that represents a HTML table
			htmlTableId type="string" Specifies that the data source points to an ID of a HTML Table element that's loaded on the page
			htmlTableDom type="string" The data source points to a DOM object that is of TABLE type
			invalid type="string" Set whenever data source is analyzed (in case its type is unknown) and the type cannot be detected
			remoteUrl type="string" Specifies that the data source points to a remote URL, from which data will be retrieved using an AJAX call ($.ajax)
			htmlListDom type="string" The data source points to a DOM object that is of UL/OL type
			empty type="string"
			*/
			type: "unknown",
			/* type="object" a schema object that defines which fields from the data to bind to */
			schema: null,
			/* type="string" the unique field identifier */
			primaryKey: null,
			/* type="string" property in the response which specifies the total number of records in the backend (this is needed for paging) */
			responseTotalRecCountKey: null,
			/* type="string" property in the response which specifies where the data records array will be held (if the response is wrapped) */
			responseDataKey: null,
			/* 
			type="json|xml|html|script|jsonp|text" Response type when a URL is set as the data source. See http://api.jquery.com/jQuery.ajax/ => dataType 
			json type="string"
			xml type="string"
			html type="string"
			script type="string"
			jsonp type="string"
			text type="string"
			*/
			responseDataType: null,
			/* type="string" content type of the response. See http://api.jquery.com/jQuery.ajax/ => contentType */
			responseContentType: null,
			/* type="bool" if set to false will disable transformations on schema, even if it is defined locally in the javascript code */
			localSchemaTransform: true,
			/* type="object" event that is fired before URL parameters are encoded. Can point to a function name or the function object itself */
			urlParamsEncoding: null,
			/* type="object" event that is fired after URL parameters are encoded (When a remote request is done). Can point to a function name or the function object itself */
			urlParamsEncoded: null,
			/* Settings related to built-in paging functionality */
			paging: {
				/* type="bool" Paging is not enabled by default */
				enabled: false,
				/* type="remote|local" Type for the paging operation 
				local type="string" Data is paged client-side.
				remote type="string" A remote request is done and URL params encoded 
				*/
				type: "remote",
				/* type="number" number of records on each page */
				pageSize: 5,
				/* type="string" denotes the name of the encoded URL parameter that will state what is the currently requested page size */
				pageSizeUrlKey: null,
				/* type="string" denotes the name of the encoded URL parameter that will state what is the currently requested page index */
				pageIndexUrlKey: null,
				/* type="number" current page index */
				pageIndex: 0,
				/* type="bool" Whether when a new page of data is requested we should append the new data to the existing data */
				appendPage: false
			},
			/* Settings related to built-in filtering functionality */
			filtering: {
				/* type="remote|local" Filtering type.
				remote type="string" Parameters will be encoded and it's up to the backend to interpred them from the response.
				local type="string" The data will be filtered automatically client-side
				*/
				type: "remote",
				/* type="bool" enables or disables case sensitive filtering on the data. Works only for local filtering */
				caseSensitive: false,
				/* type="bool" if the type of paging/sorting/filtering is local and applyToAllData is true, filtering will be performed on the whole data source that's present locally, otherwise only on the current dataView. if type is remote, this setting doesn't have any effect. */
				applyToAllData: true,
				/* type="object" Can point to either a string or a function object. The parameters that are passed are 1) the data array to be filtered, 2) the filtering expression definitions. Should return an array of the filtered data */
				customFunc: null,
				/* type="string" url key that will be encoded in the request if remote filtering is performed. Default value of null implies OData-style URL encoding. Please see http://www.odata.org/developers/protocols/uri-conventions for details */
				filterExprUrlKey: null,
				/* type="string" url key that will be encoded in the request, specifying if the filtering logic will be AND or OR */
				filterLogicUrlKey: "filterLogic",
                /* type="array" data will be initially filtered accordingly, directly after dataBind() */
				defaultFields: [],
				/* type="array" a list of expression objects, containing the following key-value pairs: fieldName, expression (search string), condition , and logic (AND/OR) */
				expressions: [],
				/* type="string" an "SQL-like' encoded expressions string. Takes precedence over "expressions". Example: col2 > 100; col2 LIKE %test% */
				exprString: ''
			},
			/* Settings related to built-in sorting functionality */
			sorting: {
				/* type="none|asc|desc" Sorting direction 
				none type="string"
				asc type="string"
				desc type="string"
				*/
				defaultDirection: "none",
				/* type="array" when defaultDirection is different than "none", and defaultFields is specified, data will be initially sorted accordingly, directly after dataBind() */
				defaultFields: [],
				/* type="bool" If the sorting type is local and applyToAllData is true, sorting will be performed on the whole data source that's present locally, otherwise only on the current dataView. If sorting type is remote, this setting doesn't have any effect. */
				applyToAllData: true,
				/* type="object"  Custom sorting function that can point to either a string or a function object. When the function is called, the following arguments are passed: data array, fields (array of field definitions) , direction ("asc" or "desc"). The function should return a sorted data array */
				customFunc: null,
				/* type="object" Custom comparison sorting function. Accepts two values and returns a value 0 indicating that values are equal, 1 indicating that val1 > val2 and -1 indicating that val1 < val2 */
				compareFunc: null,
				/* type="object" Custom data value conversion function. Accepts a value and should return the converted value */
				customConvertFunc: null,
				/* type="remote|local" Specifies whether sorting will be applied locally or remotely (via a remote request) 
				remote type="string"
				local type="string"
				*/
				type: "remote",
				/* type="bool" Specifies if sorting will be case sensitive or not. Works only for local sorting */
				caseSensitive: false,
				/* type="string" URL param name which specifies how sorting expressions will be encoded in the URL. Default is null and uses OData conventions */
				sortUrlKey: null,
				/* type="string" URL param value for ascending type of sorting. Default is null and uses OData conventions */
				sortUrlAscValueKey: null,
				/* type="string" URL param value for descending type of sorting. Default is null and uses OData conventions */
				sortUrlDescValueKey: null,
				/* type="array" a list of sorting expressions , consisting of the following keys (and their respective values): fieldName and direction */
				expressions: [],
				/* type="string" takes precedence over experssions, an "SQL-like" encoded expressions string  : see sort(). Example col2 > 100 ORDER BY asc */
				exprString: ''
			},
			// M.H. add summaries support
			/* Settings related to built-in summaries functionality */
			summaries: {
				/* type="remote|local" Specifies whether summaries will be applied locally or remotely (via a remote request) 
				remote type="string" A remote request is done and URL params encoded
				local type="string" Data is paged client-side.
				*/
				type: "remote",
				/* type="string" Url key for retrieving data from response - used only when summaries are remote*/
				summaryExprUrlKey: "summaries",
				/* type="string" Key for retrieving data from the summaries response - used only when summaries are remote*/
				summariesResponseKey: "summaries",
				/* type="priortofilteringandpaging|afterfilteringbeforepaging|afterfilteringandpaging" Determines when the summary values are calculated  
				priortofilteringandpaging type="string"
				afterfilteringbeforepaging type="string"
				afterfilteringandpaging type="string"
				*/
				summaryExecution: 'afterfilteringandpaging',
				/* type="array" a list of column settings that specifies custom summaries options per column basis */
				columnSettings: [
				/* {key: '', summaryOperands: []}*/
				]
			},
			/* type="array" A list of field definitions specifying the schema of the data source. 
			Field objects description: {fieldName, [fieldDataType], [fieldXPath]}
			*/
			fields: [],
			/* type="bool" if true, will serialize the transaction log of updated values - if any - whenever commit is performed via a remote request. */
			serializeTransactionLog: true,
			/* type="bool" if set to true, the following behavior will take place:
			if a new row is added, and then deleted, there will be no transaction added to the log 
			if an edit is made to a row or cell, then the value is brought back to its original value, the transaction should be removed
			Note: This option takes effect only when autoCommit is set to false.
			*/
			aggregateTransactions: false,
			/* type="bool" if auto commit is true, data will be automatically commited to the data source, once a value or a batch of values are updated via saveChanges() */
			autoCommit: false,
			/* type="string" specifies an update remote URL, to which an AJAX request will be made as soon as saveChages() is called. */
			updateUrl: null,
			/* type="function" A function to call when row is added.
			Function takes first argument item and second argument dataSource.
			Use item.row to obtain reference to the added row.
			Use item.rowId to get the row ID.
			Use dataSource to obtain reference to $.ig.DataSource. */
			rowAdded: null,
			/* type="function" A function to call when row is updated (edited). 
			Function takes first argument item and second argument dataSource.
			Use item.rowIndex to get the row index.
			Use item.newRow to obtain reference to the updated row.
			Use item.oldRow to obtain reference to the row that was updated.
			Use dataSource to obtain reference to $.ig.DataSource. */
			rowUpdated: null,
			/* type="function" a function to call when row is inserted.
			Function takes first argument item and second argument dataSource.
			Use item.row to obtain reference to the inserted row.
			Use item.rowId to get the row ID.
			Use item.rowIndex to get the row index.
			Use dataSource to obtain reference to $.ig.DataSource. */
			rowInserted: null,
			/* type="function" a function to call when row is deleted.
			Use item.row to obtain reference to the deleted row.
			Use item.rowId to get the row ID.
			Use item.rowIndex to get the row index.
			Use dataSource to obtain reference to $.ig.DataSource. */
			rowDeleted: null,
			/* type="function" a function to call immediately after this._data is populated - this function is used in self referencing scenario
			Use item.row to obtain reference to the deleted row.
			Use item.rowId to get the row ID.
			Use item.rowIndex to get the row index.
			Use dataSource to obtain reference to $.ig.DataSource. */
			dataSourcePopulated: null
		},
		init: function (options) {
			var tempSource, tempCallee, arrayAlready = false, metadata;
			// merge defaults with passed-in values 
			if (options) {
				tempSource = options.dataSource;
				if (tempSource && ($.type(tempSource) === "array" || $.type(tempSource) === "object")) {
					// L.A. 28 August 2012 Fixing bug #119626 When the hierarchical grid is bound to remote data (without load on demand),
					// expanding a root grid row causes an error and no child layouts are shown
					if (($.type(tempSource) === "object") && options.responseDataKey && options.type !== "json") {
						// M.H. 14 Sep 2012 Fix for bug #121209: we should preserve metadata
						metadata = tempSource.Metadata;
						options.dataSource = $.ig.findPath(tempSource, options.responseDataKey);
						if (metadata && options.dataSource.Metadata === undefined) {
							options.dataSource.Metadata =  metadata;
						}
						arrayAlready = true;
					} else {
						options.dataSource = null;
					}
				}
				// M.H. 12 Nov 2012 Fix for bug #122201
				if (options.callee) {
					tempCallee = options.callee;
					options.callee = null;
				}
				this.settings = $.extend(true, {}, $.ig.DataSource.prototype.settings, options);
                // M.H. 15 May 2013 Fix for bug 141609: Cell value is split into single character when a flat grid is shown after a hierarchical grid has been expanded
                if (arrayAlready) {
                    this.settings.type = "array";
                } else if (tempSource && ($.type(tempSource) === "array" || $.type(tempSource) === "object")) {
					options.dataSource = tempSource;
					this.settings.dataSource = tempSource;
				}
				// M.H. 12 Nov 2012 Fix for bug #122201
				if (tempCallee) {
					this.settings.callee = tempCallee;
					tempCallee = null;
				}
			}
			// initialize local vars
			//this._pageIndex = 0;
			this.settings.paging.pageIndex = 0;
			this._isBound = false;
			this._url = null;
			this._dsCallback = null;
			this._data = []; // _data may be different than _dataView only when the whole data source is present locally, but we are performing sorting or filtering or paging on it, 
			this._dataView = []; // therefore the dataView will contain only a subset of the *local* data. 
			// Same applies when data is parsed from a table. With remote fetching, everything is in _data
			if (this.settings.type === "unknown") {
				this._runtimeType = this.analyzeDataSource();
			} else {
				this._runtimeType = this.settings.type;
			}

			this._parser = new $.ig.TypeParser();
			this._schema = null;
			// used only when doing remote paging, sorting and filtering, 
			// to determine the request type in order to know whether to parse metadata fields
			// such as total record count - from the response
			this._isSortingReq = false;
			this._isFilteringReq = false;
			this._isPagingReq = false;
			this._isSummariesReq = false;
			this._dataSummaries = [];
			this._recCount = 0;
			this._hasCount = false;
			this._initSchema();
			this._filteredDataView = [];
			this._transactionLog = []; // transactions support & batch updating 
			this._accumulatedTransactionLog = []; // this is the transaction log that will be serialized and posted to the server, if the option "serializeTransactionLog" is true (MVC scenarios!)
			return this;
		},
		_initSchema: function () {
			// performance optimization
			//if (this.settings.schema && this.settings.localSchemaTransform) {
			if (this.settings.schema) {
				if (this.settings.schema instanceof $.ig.DataSchema) {
					this._schema = this.settings.schema;
				} else {
					// two cases: the developer has explicitly set a type, and 2) he didn't - which means we need to analyze the data source at runtime 
					if (this.settings.type !== "unknown") {
						this._schema = new $.ig.DataSchema(this.settings.type, this.settings.schema);
					} else {
						this._schema = new $.ig.DataSchema(this._runtimeType, this.settings.schema);
					}
					this._schema._pk = this.settings.primaryKey;
				}
			}
		},
		fields: function (fields) {
			/* Sets a list of fields to the data source. If no parameter is specified, just returns the already existing list of fields
			paramType="object" optional="true" a field has the following format: {key: 'fieldKey', dataType: 'string/number/date' }
			returnType="object" if no parameters are specified, returns the existing list of fields
			*/
			if (fields === undefined || fields === null) {
				return this.settings.fields;
			}
			this.settings.fields = fields;
			return this;
		},
		analyzeDataSource: function () {
			/* analyzes the dataSource setting to automatically determine the type of the data source. Returns the data source type. See settings.type 
			returnType="string"
			*/
			var ds = this.dataSource(), dc;
			if (ds === undefined || ds === null) {
				return "empty";
			}
			if ($.type(ds) === "function") {
				// function
				return "function";
			}
			if ($.type(ds) === "array") {
				// string, assume JSON by default and eval it
				return "array";
			}
			if ($.type(ds) === "number" || $.type(ds) === "boolean" || $.type(ds) === "date") {
				// data source is either boolean, number date, etc. 
				return "invalid";
			}
			if ($.type(ds) === "string") { //string or object
				ds = $.trim(ds);
				if (ds.startsWith("/")) {
					return "remoteUrl";
				}
				// already passed through this code, we don't need to do the same thing again 
				if ($('#' + this.settings.id).length > 0 && ds.toLowerCase().startsWith("<table")) {
					return "htmlTableString";
				}
				// was: $(ds.toLowerCase())

				if (ds.toLowerCase().startsWith("<table")) {
					// store the contents in this._data:
					// for that purpose we create a dummy div "data container", append it to the body, set display none and visibility hidden, and append our table there.
					dc = "<div id='" + this.settings.id + "' style='display:none;visibility:hidden;'>" + ds + "</div>";
					//this._data = $(dc).appendTo($("body"));
					$(dc).appendTo($("body"));
					return "htmlTableString";
				}
				if (!ds.startsWith("[") && !ds.startsWith("{") && !ds.startsWith("<")) { // object, array or xml
					// try to see if it's not a table:
					// N.A. 02/10/2014 Bug #162293 Add support for https requests.
					if (!ds.startsWith("http://") && !ds.startsWith("https://") && $('#' + ds).length > 0 && $('#' + ds)[0].nodeName.toLowerCase() === "table") {
						return "htmlTableId";
					}
					this._url = ds;
					return "remoteUrl";
				}
				return "unknown";
			}
			if (ds.nodeName && ds.nodeName.toLowerCase() === "table") {
				return "htmlTableDom";
			}
			if (ds.nodeName && (ds.nodeName.toLowerCase() === "ul" || ds.nodeName.toLowerCase() === "ol")) {
				return "htmlListDom";
			}
			return "unknown";
		},
		dataView: function () {
			/* returns the current normalized/transformed and paged/filtered/sorted data, i.e. the dataView
			returnType="object"
			*/
			return this._dataView;
		},
		data: function () {
			/* returns all of the bound data, without taking into account local paging, sorting, filtering, etc. 
			returnType="object"
			*/
			return this._data;
		},
		transformedData: function (transformedExecution) {
			/*	returns transformed data according to transformed execution:
			1. Before paging and filtering
			2. After filtering before paging
			3. After filtering and paging

			returnType="object"
			*/
			switch (transformedExecution) {
			case 'priortofilteringandpaging':
				this._transformedData = this._data;
				break;
			// this is populated in populateDataSummaries method 
			case 'afterfilteringbeforepaging':
				break;
			case 'afterfilteringandpaging':
				this._transformedData = this.dataView();
				break;
			default:
				this._transformedData = this._dataView;
				break;
			}
			return this._transformedData;
		},
		dataSummaries: function () {
			/*	returns summaries data
			 * returnType="object"
			*/
			var s = this.settings.summaries, type = s.type;
			if (type === 'local') {
				this._dataSummaries = this.transformedData(s.summaryExecution);
			}
			return this._dataSummaries;
		},
		schema: function (s, t) {
			/* Gets/sets the schema definition. 
			paramType="object" optional="true" a schema object 
			paramType="string" optional="true" type of the data source. See settings.type
			*/
			// data source schema definition 
			if (s === undefined || s === null) {
				return this._schema;
			}
			if (s instanceof $.ig.DataSchema) {
				this._schema = s;
			} else {
				if (t === null || t === undefined) {
					this._schema = new $.ig.DataSchema(s.type, s);
				} else {
					this._schema = new $.ig.DataSchema(t, s);
				}
				this._schema._pk = this.settings.primaryKey;
			}
			return this;
		},
		pagingSettings: function (p) {
			/* gets/sets a list of paging settings 
			paramType="object" optional="true" object holding all paging settings. See settings.paging
			*/
			if (p === undefined || p === null) {
				return this.settings.paging;
			}
			this.settings.paging = p;
			return this;
		},
		filterSettings: function (f) {
			/* gets/sets a list of filtering settings 
			paramType="object" optional="true" object holding all filtering settings. See settings.filtering
			*/
			if (f === undefined || f === null) {
				return this.settings.filtering;
			}
			this.settings.filtering = f;
			return this;
		},
		sortSettings: function (s) {
			/* gets/sets a list of paging settings 
			paramType="object" optional="true" object holding all sorting settings. See settings.sorting
			*/
			if (s === undefined || s === null) {
				return this.settings.sorting;
			}
			this.settings.sorting = s;
			return this;
		},
		summariesSettings: function (s) {
			/* Gets/sets a list of summaries settings. 
			paramType="object" optional="true" object holding all summaries settings. See settings.summaries
			*/
			if (s === undefined || s === null) {
				return this.settings.summaries;
			}
			this.settings.summaries = s;
			return this;
		},
		dataSource: function (ds) {
			/* gets/sets the dataSource setting. If no parameter is specified, returns settings.dataSource
			paramType="object" optional="true"
			returnType="object"
			*/
			if (ds === undefined || ds === null) {
				return this.settings.dataSource;
			}
			this.settings.dataSource = ds;
			this.analyzeDataSource();
			return this;
		},
		type: function (t) {
			/* gets/sets the type of the dataSource. If no parameter is specified, returns settings.type
			paramType="json|xml|unknown|array|function|htmlTableString|htmlTableId|htmlTableDom|invalid|remoteUrl|empty" optional="true"
			returnType="json|xml|unknown|array|function|htmlTableString|htmlTableId|htmlTableDom|invalid|remoteUrl|empty"
			*/
			if (t === undefined || t === null) {
				//return this.settings.dataSourceType;
				return this._runtimeType;
			}
			this.settings.type = t;
			return this;
		},
		findRecordByKey: function (key, ds) {
			/* returns a record by a specified key (requires that primaryKey is set in the settings)
			paramType="string" Primary key of the record
			returnType="object" a JavaScript object specifying the found record, or null if no record is found
			*/
			//A.T 2 Feb 2011 for now i am going to traverse all records until the one specified by key is found. 
			// additional great optimization is to index all records so that they are in the form <key>: { <javascript object> } 
			//S.S. March 27, 2014 - slight code optimization, adding search capabilities for two-dimentional arrays used as a data source
			var i,
				data = ds || this._data,
				len = data ? data.length : 0,
				search = len > 0 && $.isArray(data[0]) ? this._lookupPkIndex() : this.settings.primaryKey;
			for (i = 0; i < len; i++) {
				if (data[i][search] === key) {
					return data[i];
				}
			}
			return null;
		},
		removeRecordByKey: function (key, origDs) {
			/* removes a specific record denoted by the primaryKey of the passed key parameter from the data source 
			paramType="string|number" primary key of the record 
			*/
			var i, len, data, count = 0,
				all = [this._data, this._dataView, this._filteredData, origDs],
				prime = this.settings.primaryKey,
				primeIdx = this._lookupPkIndex(),
				search;
			while (count < 4) {
				data = all[count++];
				len = data ? data.length : 0;
				search = len > 0 && $.isArray(data[0]) ? primeIdx : prime;
				for (i = 0; i < len; i++) {
					if (data[i] && data[i][search] === key) {
						//A.T. 8 March 2012 - Fix for bug #104244 
						//data.remove(i);
						$.ig.removeFromArray(data, i);
						break;
					}
				}
				// if next data is same, then skip it
				if (data === all[count]) {
					count++;
				}
			}
		},
		removeRecordByIndex: function (index, origDs) {
			/* Removes a record from the data source at specific index.
			paramType="number" index of record 
			*/
			var i, len, record, data = this._data, view = this._dataView, filter = this._filteredData;
			if (!data || isNaN(index) || index < 0 || index >= data.length) {
				return;
			}
			record = data[index];
			//A.T. 8 March 2012 - Fix for bug #104244 
			//data.remove(index);
			$.ig.removeFromArray(data, index);
			if (origDs) {
				$.ig.removeFromArray(origDs, index);
			}
			// if _dataView equals to _data, then skip it
			data = (data === view) ? filter : view;
			// if record is null, then it is not possible to find it in dataView
			while (record) {
				len = data ? data.length : 0;
				for (i = 0; i < len; i++) {
					if (data[i] === record) {
						//A.T. 8 March 2012 - Fix for bug #104244 
						//data.remove(i);
						$.ig.removeFromArray(data, i);
						break;
					}
				}
				if (data === filter) {
					return;
				}
				data = filter;
			}
		},
		setCellValue: function (rowId, colId, val, autoCommit) {
			/*  sets a cell value for the cell denoted by rowId and colId. Creates a transaction for the update operation and returns it
			paramType="object" the rowId - row key (string) or index (number)
			paramType="object" the column id - column key (string) or index (number)
			paramType="object" The new value 
			paramType="bool" if autoCommit is true, it updates the datasource automatically and the transaction is still stored in the accumulated transaction log
			returnType="object". The transaction object that was created 
			*/
			// create transaction
			var t = this._createCellTransaction(rowId, colId, val);
			this._addTransaction(t);
			// commit
			if (autoCommit === true) {
				this.commit(rowId);
			}
			return t;
		},
		updateRow: function (rowId, rowObject, autoCommit) {
			/* updates a record in the datasource. Creates a transaction that can be committed / rolled back 
			paramType="object" the record key - primaryKey (string) or index (number)
			paramType="object" the record object containing the key/value pairs we want to update. It doesn't have to include key/value pairs for all fields defined in the schema or in the data source (if no schema is defined)
			paramType="bool" if autoCommit is true, the datasource will be updated automatically and the transaction is still stored in the accumulated transaction log
			returnType="object". The transaction object that was created  
			*/
			// create transaction
			var t = this._createRowTransaction(rowId, rowObject), oldRow = (this.settings.primaryKey === null) ? this._data[parseInt(rowId, 10)] : this.findRecordByKey(rowId), rowIndex = (this.settings.primaryKey === null) ? rowId : $.ig.indexInArray(this._data, oldRow);
			this._addTransaction(t);
			// commit
			if (autoCommit === true) {
				this.commit(rowId);
			}
			if ($.type(this.settings.rowUpdated) === "function") {
				if (this.settings.callee) {
					this.settings.rowUpdated.apply(this.settings.callee, [{ rowIndex: rowIndex, newRow: rowObject, oldRow: oldRow }, this]);
				} else {
					this.settings.rowUpdated({ rowIndex: rowIndex, newRow: rowObject, oldRow: oldRow }, this);
				}
			}
			return t;
		},
		addRow: function (rowId, rowObject, autoCommit) {
			/* adds a new row to the data source. Creates a transaction that can be committed / rolled back 
			paramType="object" the record key - primaryKey (string) or index (number)
			paramType="object" the new record data. 
			paramType="bool" if autoCommit is true, the datasource will be updated automatically and the transaction is still stored in the accumulated transaction log
			returnType="object". The transaction object that was created 
			*/
			var t = this._createNewRowTransaction(rowId, rowObject);
			this._addTransaction(t);
			// commit
			if (autoCommit === true) {
				this.commit(rowId);
			}
			if ($.type(this.settings.rowAdded) === "function") {
				if (this.settings.callee) {
					this.settings.rowAdded.apply(this.settings.callee, [{ rowId: rowId, row: rowObject }, this]);
				} else {
					this.settings.rowAdded({ rowId: rowId, row: rowObject }, this);
				}
			}
			return t;
		},
		insertRow: function (rowId, rowObject, rowIndex, autoCommit) {
			/* adds a new row to the data source. Creates a transaction that can be committed / rolled back 
			paramType="object" the record key - primaryKey (string) or index (number)
			paramType="object" the new record data. 
			paramType="bool" if autoCommit is true, the datasource will be updated automatically and the transaction is still stored in the accumulated transaction log
			returnType="object". The transaction object that was created 
			*/
			var t = this._createInsertRowTransaction(rowId, rowObject, rowIndex);
			this._addTransaction(t);
			// commit
			if (autoCommit === true) {
				this.commit(rowId);
			}
			if ($.type(this.settings.rowInserted) === "function") {
				if (this.settings.callee) {
					this.settings.rowInserted.apply(this.settings.callee, [{ rowId: rowId, row: rowObject, rowIndex: rowIndex }, this]);
				} else {
					this.settings.rowInserted({ rowId: rowId, row: rowObject, rowIndex: rowIndex }, this);
				}
			}
			return t;
		},
		deleteRow: function (rowId, autoCommit) {
			/* deletes a row from the data source.
			paramType="object" the record key - primaryKey (string) or index (number)
			paramType="bool" if autoCommit is true, the datasource will be updated automatically and the transaction is still stored in the accumulated transaction log
			returnType="object". The transaction object that was created 
			*/
			var t = this._createDeleteRowTransaction(rowId), row = (this.settings.primaryKey === null) ? this._data[parseInt(rowId, 10)] : this.findRecordByKey(rowId), rowIndex = (this.settings.primaryKey === null) ? rowId : $.ig.indexInArray(this._data, row), isNewRow = false, i, j;
			for (i = 0; this.settings.aggregateTransactions && i < this._transactionLog.length; i++) {
				if (this._transactionLog[i].type === "newrow" && this._transactionLog[i].rowId === rowId) {
					isNewRow = true;
					// delete the new row transaction 
					rowId = this._transactionLog[i].rowId;
					this._removeTransactionByTransactionId(this._transactionLog[i].tid);
					// sync the global transaction log !
					//A.T. 23 March fix for #105958
					for (j = 0; j < this._accumulatedTransactionLog.length; j++) {
						if (this._accumulatedTransactionLog[j].rowId === rowId) {
							$.ig.removeFromArray(this._accumulatedTransactionLog, j);
						}
					}
					break;
				}
			}
			//A.T. 17 Jan 2012
			// check if we don't have an "add" transaction already
			if (!(this.settings.aggregateTransactions && isNewRow)) {
				this._addTransaction(t);
				if (autoCommit === true) {
					this.commit(rowId);
				}
				if ($.type(this.settings.rowDeleted) === "function") {
					if (this.settings.callee) {
						this.settings.rowDeleted.apply(this.settings.callee, [{ rowId: rowId, row: row, rowIndex: rowIndex }, this]);
					} else {
						this.settings.rowDeleted({ rowId: rowId, row: row, rowIndex: rowIndex }, this);
					}
				}
			}
		},
		/* Transactions for igTree */
		addNode: function (data) {
			/* adds a new node to the tree data source. Creates a transaction that can be committed / rolled back 
			paramType="object" the transaction data
			*/
			var t = this._createAddNodeTransaction(data);
			this._addTransaction(t);
		},
		removeNode: function (data) {
			/* removes a node from the tree data source. Creates a transaction that can be committed / rolled back 
			paramType="object" the transaction data
			*/
			var t = this._createRemoveNodeTransaction(data);
			this._addTransaction(t);
		},
		/* END Transactions for igTree */
		getDetachedRecord: function (t) {
			/* returns a standalone object (copy) that represents the commited transactions, but detached from the data source 
			paramType="object" a transaction object
			returnType="object" a copy of a record from the data source
			*/
			var o = $.type(this._data[0]) === "array" ? [] : {}, i, originalRec;

			if (this.settings.primaryKey === null) {
				originalRec = this._data[parseInt(t.rowId, 10)];
			} else {
				originalRec = this.findRecordByKey(t.rowId);
			}
			//o = $.extend(true, {}, originalRec);
			if (this._data[0] !== "array") {
				for (i in originalRec) {
					if (originalRec.hasOwnProperty(i)) {
						o[i] = originalRec[i];
					}
				}
			} else {
				for (i = 0; i < originalRec.length; i++) {
					o[i] = originalRec[i];
				}
			}
			if (t.type === 'cell') {
				o[t.col] = t.value;
				return o;
			}
			// merge objects or arrays
			//return $.extend(true, {}, o, t.row);
			if (o !== "array") {
				for (i in t.row) {
					if (t.row.hasOwnProperty(i)) {
						o[i] = t.row[i];
					}
				}
			} else {
				// if it's array, t.row is expected to have the same number of cells (elements) as the original record. It cannot contain partial data only for the updated cells 
				for (i = 0; i < t.row.length; i++) {
					o[i] = t.row[i];
				}
			}
			return o;
		},
		commit: function (id) {
			/* update the data source with every transaction from the log
			paramType="number" optional="true" Id of the transaction to commit. If no id is specified, will commit all transactions to the data source. 
			*/
			// if "id" is defined, commit only the transaction with the specified id
			if (id !== null && id !== undefined) {
				this._commitTransactionsByRowId(id);
			} else {
				// commit all
				// always reverse if we call pop. That's because we may have a row editing first, then row deleting,
				// if we call pop(), it will delete the row first, and then try to edit it, which is wrong. 
				// this is much easier and cleaner compared to implementing Queues 
				this._transactionLog.reverse();
				while (this._transactionLog.length > 0) {
					this._commitTransaction(this._transactionLog.pop());
				}
			}
		},
		rollback: function (id) {
			/* clears the transaction log without updating anything in the data source 
			paramType="string|number" optional="true" Record Id to find transactions for. If no id is specified, will rollback all transactions to the data source. 
			*/
			var i, trans;

			if (id !== null && id !== undefined) {
				trans = this._rollbackTransactionsByRowId(id);
			} else {
				// exclude the current transaction log from the accumulated transaction log. 
				// rollback all
				i = this._transactionLog.length;
				while (i-- > 0) {
					this._rollbackTransaction(this._transactionLog[i]);
				}
			}
			return trans;
		},
		pendingTransactions: function () {
			/* returns a list of all transaction objects that are pending to be committed or rolled back to the data source 
			returnType="array"
			*/
			return this._transactionLog;
		},
		allTransactions: function () {
			/* returns a list of all transaction objects that are either pending, or have been committed in the data source. 
			returnType="array"
			*/
			return this._accumulatedTransactionLog;
		},
		_createCellTransaction: function (rowId, colId, val) {
			return { type: 'cell', rowId: rowId, tid: this._generateTransactionId(), col: colId, value: val };
		},
		_createRowTransaction: function (rowId, rowObject) {
			return { type: 'row', tid: this._generateTransactionId(), row: rowObject, rowId: rowId };
		},
		_createNewRowTransaction: function (rowId, rowObject) {
			return { type: 'newrow', tid: this._generateTransactionId(), row: rowObject, rowId: rowId };
		},
		_createInsertRowTransaction: function (rowId, rowObject, rowIndex) {
			return { type: 'insertrow', tid: this._generateTransactionId(), row: rowObject, rowId: rowId, rowIndex: rowIndex };
		},
		_createDeleteRowTransaction: function (rowId) {
			return { type: 'deleterow', tid: this._generateTransactionId(), rowId: rowId };
		},
		/* Transactions for igTree */
		_createAddNodeTransaction: function (data) {
			return { type: 'addnode', tid: this._generateTransactionId(), tdata: data };
		},
		_createRemoveNodeTransaction: function (data) {
			return { type: 'removenode', tid: this._generateTransactionId(), tdata: data };
		},
		/* END Transactions for igTree */
		_addTransaction: function (t) {
			var exists = false, i = 0, prop, globalt, j, dirty = true, k;
			if (t.type === "cell") {
				// check if we don't have an existing transaction and if we do, overwrite it
				for (i = 0; i < this._transactionLog.length; i++) {
					if (this._transactionLog[i].rowId === t.rowId && this._transactionLog[i].col === t.col) {
						exists = true;
						// add extra check to see if the "new" value isn't the same as the original one, in that case remove the existing transaction
						if (this.settings.autoCommit === false && this.settings.aggregateTransactions === true) {
							// we need to find the data source row corresponding to rowId
							for (j = 0; j < this.dataView().length; j++) {
								if (this.dataView()[j][this.settings.primaryKey] === t.rowId && this.dataView()[j][t.col] === t.value) {
									for (k = 0; k < this._accumulatedTransactionLog.length; k++) {
										if (this._accumulatedTransactionLog[k].rowId === this._transactionLog[i].rowId) {
											$.ig.removeFromArray(this._accumulatedTransactionLog, k);
										}
									}
									// remove the transaction because the last entered value is the same as the first one
									this._removeTransactionByTransactionId(this._transactionLog[i].tid);
									dirty = false;
								}
							}
						}
						if (dirty) {
							this._transactionLog[i].value = t.value;
							this._syncGlobalTransaction(this._transactionLog[i]);
						}
					}
				}
				// ensure we check the newly added rows as well
				for (j = 0; j < this._transactionLog.length; j++) {
					if (this._transactionLog[j].type === "newrow" && this._transactionLog[j].rowId === t.rowId) {
						// copy the t.row into newrow's row
						if (t.type === "row") {
							this._transactionLog[j].value = t.value;
						} else {
							this._transactionLog[j].row[t.col] = t.value;
						}
						this._syncGlobalTransaction(this._transactionLog[j]);
						// don't add "t"
						return;
					}
				}
			} else if (t.type === "row") {
				for (i = 0; i < this._transactionLog.length; i++) {
					if (this._transactionLog[i].rowId === t.rowId && this._transactionLog[i].type !== "cell") {
						exists = true;
						if (this.settings.autoCommit === false && this.settings.aggregateTransactions === true) {
							dirty = false;
							for (j = 0; j < this.dataView().length; j++) {
								if (this.dataView()[j][this.settings.primaryKey] === t.rowId) {
									// now verify all values in the row correspond to the original ones
									for (prop in t.row) {
										if (t.row.hasOwnProperty(prop) && t.row[prop] !== this.dataView()[j][prop]) {
											dirty = true;
											break;
										}
									}
									break;
								}
							}
							// ensure we check the newly added rows as well
							for (j = 0, !dirty; j < this._transactionLog.length; j++) {
								if (this._transactionLog[j].type === "newrow" && this._transactionLog[j].rowId === t.rowId) {
									// copy the t.row into newrow's row
									this._transactionLog[j].row = t.row;
									// we need to find and sync the global transaction
									this._syncGlobalTransaction(this._transactionLog[j]);
									// don't add "t"
									return;
								}
							}
						}
						if (dirty) {
							this._transactionLog[i].row = t.row;
							this._syncGlobalTransaction(this._transactionLog[i]);
						} else {
							// remove the transaction because the last entered value is the same as the first one
							for (k = 0; k < this._accumulatedTransactionLog.length; k++) {
								if (this._accumulatedTransactionLog[k].rowId === this._transactionLog[i].rowId) {
									$.ig.removeFromArray(this._accumulatedTransactionLog, k);
								}
							}
							this._removeTransactionByTransactionId(this._transactionLog[i].tid);
						}
					}
				}
			} else if (t.type === 'addnode' || t.type === 'removenode') {
				// K.D. November 11th, 2013 Bug #155067 A deep copy of the object here throws call stack exceeded with recursive
				// objects, so moving the transaction push here and exiting.
				// K.D. June 24th, 2014 Bug #174207 The accumulated transaction log also needs to be updated.
				this._transactionLog.push(t);
				this._accumulatedTransactionLog.push(t);
				return;
			}
			if (!exists) {
				this._transactionLog.push(t);
				// A.T. 27 Sept. we need this change only for the global transaction log, since it's the one that will go to the server
				// for the local transaction log, we need to keep the Date "as is", because it won't get serialized/deserialized
				globalt = $.extend(true, {}, t);
				// Date fix. We need to encode it using \/Date(ticks)\/
				if (globalt.type === "cell" && $.type(globalt.value) === "date") {
					globalt.value = "\/Date(" + globalt.value.getTime() + ")\/";
				} else if (globalt.type === "row" || globalt.type === "insertrow" || globalt.type === "newrow") {
					for (prop in globalt.row) {
						if (globalt.row.hasOwnProperty(prop) && $.type(globalt.row[prop]) === "date") {
							globalt.row[prop] = "\/Date(" + globalt.row[prop].getTime() + ")\/";
						}
					}
				}
				this._accumulatedTransactionLog.push(globalt);
			}
		},
		_syncGlobalTransaction: function (t) {
			var i, prop;
			if (!t) {
				return;
			}
			if (t.type === "cell") {
				for (i = 0; i < this._accumulatedTransactionLog.length; i++) {
					if (this._accumulatedTransactionLog[i].rowId === t.rowId) {
						if ($.type(t.value) === "date") {
							this._accumulatedTransactionLog[i].value = "\/Date(" + t.value.getTime() + ")\/";
						} else {
							this._accumulatedTransactionLog[i].value = t.value;
						}
						break;
					}
				}
			} else if (t.type === "row" || t.type === "insertrow" || t.type === "newrow") {
				for (i = 0; i < this._accumulatedTransactionLog.length; i++) {
					if (this._accumulatedTransactionLog[i].rowId === t.rowId && this._accumulatedTransactionLog[i].type !== "cell") {
						for (prop in t.row) {
							if (t.row.hasOwnProperty(prop)) {
								if ($.type(t.row[prop]) === "date") {
									this._accumulatedTransactionLog[i].row[prop] = "\/Date(" + t.row[prop].getTime() + ")\/";
								} else {
									this._accumulatedTransactionLog[i].row[prop] = t.row[prop];
								}
							}
						}
					}
				}
			}
		},
		_removeTransactionByTransactionId: function (tid, removeFromAll) {
			// removes a transaction by a transaction ID
			var i;
			for (i = 0; i < this._transactionLog.length; i++) {
				if (this._transactionLog[i].tid === tid) {
					//A.T. 8 March 2012 - Fix for bug #104244 
					//this._transactionLog.remove(i);
					$.ig.removeFromArray(this._transactionLog, i);
					break;
				}
			}
			if (removeFromAll === true) {
				for (i = 0; i < this._accumulatedTransactionLog.length; i++) {
					if (this._accumulatedTransactionLog[i].tid === tid) {
						//A.T. 8 March 2012 - Fix for bug #104244 
						//this._accumulatedTransactionLog.remove(i);
						$.ig.removeFromArray(this._accumulatedTransactionLog, i);
						break;
					}
				}
			}
		},
		_removeTransactionsByRecordId: function (id) {
			// removes all transactions matching a specific row id (index or primary key)
			var i;
			for (i = 0; i < this._transactionLog.length; i++) {
				if (this._transactionLog[i].rowId === id) {
					//A.T. 8 March 2012 - Fix for bug #104244 
					//this._transactionLog.remove(i);
					$.ig.removeFromArray(this._transactionLog, i);
					break;
				}
			}
		},
		_addRow: function (row, index, origDs) {
			var data, key, count = 0, schema = this.settings.schema, layouts = schema ? schema.layouts : null, lo,
				all = [this._data, this._dataView, /*this._filteredData, */origDs], newRow;
			if (layouts) {
				// we'll try to include empty collections for the child layouts to keep the data source consistent
				for (key in layouts) {
					// filter out layouts with depth relative to the current one > 1
					if ((key.match(/\//g) || []).length !== 1) {
						continue;
					}
					if (layouts.hasOwnProperty(key) && layouts[key].key && !row.hasOwnProperty(layouts[key].key)) {
						if (layouts[key].responseDataKey) {
							lo = {};
							lo[layouts[key].responseDataKey] = [];
						} else {
							lo = [];
						}
						row[layouts[key].key] = lo;
					}
				}
			}
			while (count < 4) {
				data = all[count++];
				if (data) {
					// M.H. 17 June 2014 Fix for bug #171306: The ig_pk property is missing from the added row object.
					newRow = row;
					if (data === origDs && $.type(row) === 'object') {
						newRow = $.extend(true, {}, row);
					}
					if (index >= 0 && index < data.length) {
						data.splice(index, 0, newRow);
					} else {
						data.push(newRow);
					}
				}
				// if data same, then skip it
				if (data === all[count]) {
					count++;
				}
			}
		},
		_commitTransaction: function (t) {
			// commit, then remove from the transaction log
			var i, prop, rec, origRec, origDs = this.settings.localSchemaTransform ? this._origDs : null;
			if (origDs === this._data) {
				origDs = null;
			}
			if (this.settings.primaryKey === null) {
				rec = this._data[parseInt(t.rowId, 10)];
				if (origDs) {
					origRec = origDs[parseInt(t.rowId, 10)];
				}
			} else {
				rec = this.findRecordByKey(t.rowId);
				if (origDs) {
					origRec = this.findRecordByKey(t.rowId, origDs);
				}
			}

			if (t.type === 'cell') {
				rec[t.col] = t.value;
				if (origRec) {
					origRec[t.col] = t.value;
				}
			} else if (t.type === 'row') {
				if ($.type(t.row) === "array") {
					for (i = 0; i < t.row.length; i++) {
						rec[i] = t.row[i];
						if (origRec) {
							origRec[i] = t.row[i];
						}
					}
				} else {
					for (prop in t.row) {
						if (t.row.hasOwnProperty(prop)) {
							rec[prop] = t.row[prop];
							if (origRec) {
								origRec[prop] = t.row[prop];
							}
						}
					}
				}
			} else if (t.type === 'deleterow') {
				if (this.settings.primaryKey === null) {
					this.removeRecordByIndex(parseInt(t.rowId, 10), origDs);
				} else {
					this.removeRecordByKey(t.rowId, origDs);
				}
			} else if (t.type === 'newrow') {
				this._addRow(t.row, -1, origDs);
			} else if (t.type === 'insertrow') {
				this._addRow(t.row, t.rowIndex, origDs);
			}
			// finally remove from the log, since the transaction is already committed and shouldn't be pending
			this._removeTransactionByTransactionId(t.tid);
		},
		_rollbackTransaction: function (t) {
			this._removeTransactionByTransactionId(t.tid, true);
		},
		_commitTransactionsByRowId: function (id) {
			var i;

			for (i = 0; i < this._transactionLog.length; i++) {
				if (this._transactionLog[i].rowId === id) {
					this._commitTransaction(this._transactionLog[i]);
				}
			}
		},
		_rollbackTransactionsByRowId: function (id) {
			var i, trans = [];

			i = this._transactionLog.length;
			while (i-- > 0) {
				if (this._transactionLog[i].rowId === id) {
					trans.push(this._transactionLog[i]);
					this._rollbackTransaction(this._transactionLog[i]);
				}
			}
			return trans;
		},
		transactionsAsString: function () {
			/* returns the accumulated transaction log as a string. The purpose of this is to be passed to URLs or used conveniently
			returnType="string"
			*/
			return JSON.stringify(this._accumulatedTransactionLog);
		},
		_generateTransactionId: function () {
			return ((1 + Math.random()) * parseInt('10000', 16)).toString(16).substring(1, 5);
		},
		_lookupPkIndex: function () {
			var i;
			if (this._pkIndex !== undefined) {
				return this._pkIndex;	
			}
			if (typeof this.settings.primaryKey === "string") {
				if (this.schema() && this.schema().fields() && this.schema().fields().length > 0) {
					for (i = 0; i < this.schema().fields().length ; i++) {
						if (this.schema().fields()[i].name === this.settings.primaryKey) {
							this._pkIndex = i;
							return i;
						}
					}
				}
			}
			this._pkIndex = this.settings.primaryKey;
			return this.settings.primaryKey;
		},
		saveChanges: function (success, error) {
			/* posts to the settings.updateUrl using $.ajax, by serializing the changes as url params 
            paramType="function" Specifies a custom function to be called when AJAX request to the updateUrl option succeeds(optional)
            paramType="function" Specifies a custom function to be called when AJAX request to the updateUrl option fails(optional)
            */
			if (this.settings.updateUrl !== null) {
				// post to the Url using $.ajax, by serializing the changes as url params 
				var me = this, opts;

                opts = {
                    type: "POST",
                    url: this.settings.updateUrl,
                    data: { 'ig_transactions': JSON.stringify(this._accumulatedTransactionLog) },
                    success: function (data, textStatus, jqXHR) {
						me._saveChangesSuccess(data, textStatus, jqXHR);
                        if (success) {
                            success(data, textStatus, jqXHR);
                        }
					},
                    error: function (jqXHR, textStatus, errorThrown) {
                        me._saveChangesError(jqXHR, textStatus, errorThrown);
                        if (error) {
                            error(jqXHR, textStatus, errorThrown);
                        }
                    }
                };
                $.ajax(opts);
//				$.post(this.settings.updateUrl, { 'ig_transactions': JSON.stringify(this._accumulatedTransactionLog) },
//					function (data, textStatus, jqXHR) {
//						me._saveChangesSuccess(data, textStatus, jqXHR);
//					});
			}
		},
		_saveChangesSuccess: function (data, textStatus, jqXHR) {
			if (data.Success) {
				this.commit();
				this._transactionLog = [];
				this._accumulatedTransactionLog = [];
			}
			var schs = this._saveChangesHandlers, i = schs ? schs.length : 0;
			while (i-- > 0) {
				schs[i](data, textStatus, jqXHR);
			}
		},
        _saveChangesError: function (jqXHR, textStatus, errorThrown) {
			var sche = this._saveChangesErrorHandlers, i = sche ? sche.length : 0;
			while (i-- > 0) {
				sche[i](jqXHR, textStatus, errorThrown);
			}
		},
		_addChangesSuccessHandler: function (functionDelegate) {
			if (this._saveChangesHandlers === undefined) {
				this._saveChangesHandlers = [];
			}
			this._saveChangesHandlers[this._saveChangesHandlers.length] = functionDelegate;
		},
		_removeChangesSuccessHandler: function (functionDelegate) {
			if (this._saveChangesHandlers !== undefined) {
				var index = $.ig.indexInArray(this._saveChangesHandlers, functionDelegate);
				if (index > -1) {
					this._saveChangesHandlers = this._saveChangesHandlers.slice(0, index).concat(this._saveChangesHandlers.slice(index + 1, this._saveChangesHandlers.length));
				}
			}
		},
        _addChangesErrorHandler: function (functionDelegate) {
			if (this._saveChangesErrorHandlers === undefined) {
				this._saveChangesErrorHandlers = [];
			}
			this._saveChangesErrorHandlers[this._saveChangesErrorHandlers.length] = functionDelegate;
		},
		_removeChangesErrorHandler: function (functionDelegate) {
			if (this._saveChangesErrorHandlers !== undefined) {
				var index = $.ig.indexInArray(this._saveChangesErrorHandlers, functionDelegate);
				if (index > -1) {
					this._saveChangesErrorHandlers = this._saveChangesErrorHandlers.slice(0, index).concat(this._saveChangesErrorHandlers.slice(index + 1, this._saveChangesErrorHandlers.length));
				}
			}
		},
		// callback is the function to call when databinding is async (remote)
		// callee is the object on which to call the callback function
		dataBind: function (callback, callee) {
			/* data binds to the current data source  data source
			databinding works using the following workflow:
			1. fire the databinding event
			2. based on the data source type (see analyzeDataSource()), do the following:
			3. if type is HtmlTable, parse the table and set the data and dataView respectively. 
			if the type is Function, call it, apply Paging/Filtering/Sorting, and set this._dataView . If the developer wants to do his own paging, filtering or sorting
			in that case, then he should handle the PageIndexChanging and/or DataFiltering, and/or ColumnSorting client-side events, and cancel them. 
			if no paging/sorting/filtering are enabled, use just this._data to save space
			if the data source is of type RemoteUrl, use jQuery's $.ajax API to trigger a remote request to the service. Use the param() API to encode the URL
			if the data source is invalid, throw an exception 
			if the analyzed runtime data source type , that is, the result of analyzeDataSource(), is Unknown, check if 
			the value of settings.type is set to XML or JSON. If string, eval for JSON, and parse for the XML to build the object ree
			4. now normalize/transform the data, if a schema is supplied. This inplies any additional data type  conversion
			5. next, if OpType is Local, apply paging, sorting, and/or filtering to the data, and store the result in this._dataView
			6. fire the databound event 
				
			paramType="string" optional="true" callback function 
			paramType="object" optional="true" callee object on which the callback will be executed. If none is specified, will assume global execution context 
			*/
			// think about when would this._data be different than null at all? in which scenarios ?  
			var table, tableObj, dsObj, ds, s, p = this.settings, args, resKey, noCancel = true, callDataBound = true, f;
			this._transactionLog = [];
			this._accumulatedTransactionLog = [];

			if (!callback) {
				callback = p.callback;
			}

			// fire the data binding event
			args = { cancel: false };

			if ($.isFunction(p.dataBinding)) {
				noCancel = p.dataBinding(this, args);
				if (noCancel === undefined) {
					noCancel = true;
				}
			}
			//A.T. 18 Jan 2011 - Fix for bug #61623 - igDataSource dataBinding handler cannot cancel data binding
			//if (!args.cancel) {
			if (noCancel) {
				if (this.settings.type === "unknown" && (this._runtimeType === null || this._runtimeType === undefined)) {
					this._runtimeType = this.analyzeDataSource();
				} else if (this._runtimeType === "json") {// if datasource is indeed url
					// M.H. 9 Oct 2013 Fix for bug #139006: dataSourceType should be set explicitly when invoke dataBind with remote operations
					ds = this.dataSource();
					if ($.type(ds) === "string") { //string or object
						ds = $.trim(ds);
						// N.A. 02/10/2014 Bug #162293 Add support for https requests.
						if (ds.startsWith("/") || ds.startsWith("http://") || ds.startsWith("https://")) {
							this._runtimeType = "remoteUrl";
						}
					}
				} //else if (this.type !== $.ig.Constants.DataSourceType.Unknown) {
				//	this._runtimeType = this.settings.type;
				//}
				switch (this._runtimeType) {
				case "function":
					// determine context and pass parameters 
					this._data = p.dataSource(); // this.dataSource is a function
					if (this.schema()) {
						this._data = this.schema().transform(this._data); // Q: do we store the normalized data in this._data, or in this._dataView ? 
					}
					break;
				case "array":
					if (this.schema() && this.settings.localSchemaTransform) {
						this._data = this.schema().transform(this.dataSource());
						if (this.dataSource().Metadata) {
							this._metadata = this.dataSource().Metadata;
							// M.H. 18 Feb 2013 Fix for bug #133286: When the HGrid is bound to remote data, remote summaries are enabled and loadOnDemand is FALSE the summaries for child layouts are not rendered.
							this.summariesResponse(this.settings.summaries.summariesResponseKey, this.dataSource());
						}
						this._origDs = this.dataSource();
					} else {
						this._data = this.dataSource(); // no schema
					}
					break;
				case "htmlTableDom":
				case "htmlTableId":
				case "htmlTableString":
					//A.T. 10 April Fix for bug #108547 - we shouldn't re-analyze the HTML table and rebind more than once. 
					if (this._tableBound) {
						break;
					}
					//A.T. 18 Jan 2011 - Fix for bug #62123 - igDataSource HTMLTableString binding problem
					this._runtimeType = this.analyzeDataSource();
					if (this._runtimeType === "htmlTableId") {
						tableObj = $('#' + this.dataSource());
						table = this._validateTable(tableObj);
					} else if (this._runtimeType === "htmlTableString") {
						// the analyzeDataSource() call has already done most of the work to parse the string and attach to the DOM for us
						tableObj = $('#' + this.settings.id + ' > table');
						table = this._validateTable(tableObj);
					} else {
						table = this.dataSource();
					}
					if (this.schema() && this.settings.localSchemaTransform) {
						this._data = this.schema().transform(table);
					} else {
						this._data = this.tableToObject(table); // no schema
					}
					this._tableBound = true;
					break;
				case "htmlListDom":
					this._data = this.schema().transform(this.dataSource());
					break;
				case "invalid":
					throw new Error($.ig.DataSourceLocale.locale.invalidDataSource);
					//break;
				case "unknown":
				case "json":
				case "xml":
					if (this.settings.type !== "json" && p.type !== "xml") {
						//throw new Error("Cannot determine the data source type. Please specify if it is JSON or XML data. ");
						throw new Error($.ig.DataSourceLocale.locale.unknownDataSource);
					} else {
						resKey = this.settings.responseDataKey;
						// there are two cases:
						// 1. string which is either JSON objects or XML string
						// 2. object - already parsed, or XML document element
						if ($.type(this.dataSource()) === "string") {
							if (p.type === "json") {
								dsObj = this.stringToJSONObject(this.dataSource());
							} else {
								dsObj = this.stringToXmlObject(this.dataSource());
							}
						} else {
							dsObj = this.dataSource();
						}
						// now check if there is schema defined
						if (this.schema() && this.settings.localSchemaTransform === true) {
							this._data = this.schema().transform(dsObj);
							// reference to the original data source
							if (resKey !== null && resKey !== undefined) {
								this._origDs = $.ig.findPath(dsObj, resKey);
							} else {
								this._origDs = dsObj;
							}
						} else if ((!this.schema() || this.settings.localSchemaTransform === false) && p.type === "json") {
							if (resKey !== null && resKey !== undefined) {
								this._data = this._origDs = $.ig.findPath(dsObj, resKey);
							} else {
								this._data = dsObj;
							}
							// reference to the original data source
							this._origDs = dsObj;
						} else if (!this.schema() && p.type === "xml") {
							// XML: we have an XML document but have no schema associated to it 
							// for future: think about automating this a bit, i.e. even if there is no schema defined, assume a predefined structure and fallback to it
							// when a control like the client grid is bound to the data source, the column definitions automatically translate to a data schema ! 
							// in fact when the igGrid is bound to the igDataSource, and there is no explicit schema defined, we can assume a predefined schema, something like:
							// <row> <cell></cell> ... </row> and so on. The initial schema comes from the column definitions, and 1) => if we cannot find the XPath, fallback
							// to the default schema, or 2) => if no columns are defined, assume the default xml schema again. 
							throw new Error($.ig.DataSourceLocale.locale.errorXmlSourceWithoutSchema);
						}
						// make sure to read the responseTotalRecCountKey no matter if localSchemaTransform = true or false
						this.totalRecordsCount(null, this.settings.responseTotalRecCountKey, dsObj, this);

						if (dsObj.Metadata) {
							this._metadata = dsObj.Metadata;
						}

						this.summariesResponse(this.settings.summaries.summariesResponseKey, dsObj);
					}
					break;
				case "remoteUrl":
					// M.H. 18 Aug 2014 Fix for bug #177147: The dataBound event is called before the JSON file is returned
					callDataBound = false;
					// when the response arrives, we still need to additionally analyze it and apply schema, if it is present
					// Note that the schema may have already been applied directly on the server-side 
					//1. encode the parameters for sorting, paging and filtering 
					this._remoteData(callback, callee);
					break;
				case "empty":
					this._data = [];
					this._dataView = [];
					this._dataSummaries = [];
					break;
				default:
					break;
				}
				if (p.dataSourcePopulated) {
					this._data = p.dataSourcePopulated(this, this._data);
				}
				// describe the algorithm when dataView should be the same as data and when not
				this._dataView = this._data;
				this._filter = false;
				// apply initial sorting, if set, and if OpType is local.
				s = p.sorting;
				//if (s.type === $.ig.Constants.OpType.Local && s.defaultDirection !== $.ig.Constants.SortDirection.None && this._runtimeType !== $.ig.Constants.DataSourceType.RemoteUrl) {
				// A.T. fix for igGridSorting local sorting
				if (s.type === "local" && this._runtimeType !== "remoteUrl" && s.defaultFields.length > 0) {
					this.sort(s.defaultFields, s.defaultDirection);
				}
                // M.H. 19 Jul 2013 Fix for bug #147233: cannot set default filtering expressions in ig.DataSource (they aren't taken into account , similar to sorting default expressions)
                // add defaultFields to filtering similar to sorting
                f = p.filtering;
                if (f.type === "local" && this._runtimeType !== "remoteUrl" && f.defaultFields.length > 0) {
                    this.filter(f.defaultFields);
				}
				// Check if paging is configured, and if so, 
				// if OpType === $.ig.Constants.OpType.Local => apply local paging
				if (p.paging.enabled && p.paging.type === "local" && this._runtimeType !== "remoteUrl") {
					this._page();
					// this is necessary
				}
				// M.H. 13 Mar 2014 Fix for bug #166978: Summaries are calculated for the entire data source after persisting filtering with data bind
                if (!this._filter || !this._transformedData) {
                    this._populateTransformedData();
                }
				// invoke the callback if present:
				if (this._runtimeType !== "remoteUrl") {
					this._invokeCallback(callee, callback);
				}
				// fire the data bound event 
				// M.H. 18 Aug 2014 Fix for bug #177147: The dataBound event is called before the JSON file is returned
				if ($.isFunction(p.dataBound) && !args.cancel && callDataBound) {
					p.dataBound(this);
				}
			}
			return this;
		},
		summariesResponse: function (key, dsObj) {
			/* Get summaries calculation data from remote response */
			var rec, resPath, i, schema, func, offsets, offset, obj;

			if (key !== null && key !== '') {
				rec = dsObj;
				resPath = key.split(".");
				if (key.length > 0) {
					for (i = 0; i < resPath.length; i++) {
						// M.H. 18 Feb 2013 Fix for bug #133286: When the HGrid is bound to remote data, remote summaries are enabled and loadOnDemand is FALSE the summaries for child layouts are not rendered.
						if (rec === null || rec === undefined) {
							break;
						}
						rec = rec[resPath[i]];
					}
					this._dataSummaries = rec;
				} else {
					this._dataSummaries = dsObj;
				}
				if (this._dataSummaries === undefined || this._dataSummaries === null) {
					this._dataSummaries = [];
				}
				// M.H. 10 Jan 2014 Fix for bug #160204: Remote Summaries display dates which differ from the ones displayed in the grid
				if (this.settings.localSchemaTransform === true && this.schema() &&
                    dsObj && dsObj.Metadata && dsObj.Metadata.timezoneOffsetsSummaries) {
					offsets = dsObj.Metadata.timezoneOffsetsSummaries;
					this._dataSummaries._serverOffsetsSummaries = offsets;
					// transform dates
					schema = this.schema().schema;
					if (schema && schema.fields) {
						for (i = 0; i < schema.fields.length; i++) {
							// transform date
							if (schema.fields[i].type === 'date' &&
                                offsets[schema.fields[i].name] !== undefined) {
								key = schema.fields[i].name;
								for (func in offsets[key]) {
									offset = offsets[key][func];
									obj = this._dataSummaries[key][func];
									if ($.type(obj) === 'string' && obj.indexOf('/Date(') !== -1) {
										this._dataSummaries[key][func] = new Date(parseInt(obj.replace('/Date(', '').replace(')/', ''), 10) + offset);
									}
								}
							}
						}
					}
				}
			}
		},
		_populateTransformedData: function (data) {
			// M.H. populate summaries data
			// when datasource is local and we want to get summaries when summaryExecution is afterfilteringbeforepaging
			// we need to get filtered data BUT when all filter conditions are cleared then it is not called filter method(in datasource) from filter widget
			// but it is called dataBind and in this case we should not get this._filteredData but this._data
			if (data !== null && data !== undefined) {
				this._transformedData = data;
			} else {
				this._transformedData = this._data;
			}
		},

		_invokeCallback: function (callee, callback) {
			var cbResolved, calleeResolved;

			cbResolved = callback || this.settings.callback;
			calleeResolved = callee || this.settings.callee;

			if (cbResolved) {
				if (calleeResolved) {
					cbResolved.apply(calleeResolved, [true, "", this]);
				} else {
					cbResolved(true, "", this);
				}
			}
		},
		_remoteData: function (callback, callee) {
			var params, url = this.settings.dataSource, dataType = this.settings.responseDataType, contentType = this.settings.responseContentType, options, verb = this.settings.requestType;
			//1. encode URL params
			params = this._encodeUrl();
			if (callback) {
				this._customCallback = callback;
			} else {
				this._customCallback = null;
			}
			this._callee = callee;
			// finally invoke the call to $.ajax. This can be easily "overriden" in an extension of the $.ig.DataSource 
			options = {
				url: url,
				//params: params,
				data: verb === "GET" ? params : JSON.stringify(params),
				type: verb,
				dataType: dataType,
				async: true,
				context: this,
				contentType: contentType,
				cache: false,
				dataFilter: this._dataFilter,
				success: this._successCallback,
				complete: this._completeCallback,
				converters: {
					"text json": function (value) {
						return value;
					}
				},
				error: this._errorCallback
			};
			this._processRequest(options);
		},
		_dataFilter: function (data, type) {
			var ds, schema = this.context.schema(), rawData, t = this.context.settings.type, ver, returnString = false;
			// fall back
			//A.T. 21 Oct. Extra fix for 120718
			if (type === undefined || type === null) {
				if (typeof data === "object" && data && typeof data.charAt !== "function") {
					// L.A. Fixing bug #129413 - [igDataSource] Error is thrown when opening Stock Quotes sample
					if ($.isXMLDoc(data)) {
						type = "xml";
					} else {
						type = "json";
					}
				} else {
					type = "text";
				}
			}
			if (type === "xml") {
				schema._type = "xml";
				ds = this.context._processXmlResponse(data, true, this.context);
			} else if (type === "json") {
				if (schema) {
					schema._type = "json";
				}
				// data may be already a parsed JSON object
				if ($.type(data) === "string") {
					rawData = JSON.parse(data);
				} else {
					rawData = data;
				}
				returnString = true;
				ds = this.context._processJsonResponse(rawData, this.context);
				// should we really bother about this for now ? HTML data coming from the server ? 
				//} else if (type === "html") {
			} else { // "text"
				//A.T. workaround for jQuery's 1.5 and above bug related to dataFilter and success callback. We need to explicitly set the dataType to "text" when manually parsing it
				// get jquery version
				if (jQuery.fn.jquery) {
					ver = jQuery.fn.jquery.split('.');
				}
				if (ver && ver.length >= 2) {
					// if jQuery is 1.5 and greater or if the first major version is greater than 1 (when jQuery 2 comes out)
					// As of jQuery 1.5, using this dataFilter approach for manually controlling deserialization will no longer work if the request's dataType is set to "json" or even omitted.
					// another way of fixing this is using converters
					// http://api.jquery.com/extending-ajax/#Converters
					if (parseInt(ver[1], 10) > 4 || parseInt(ver[0], 10) > 1) {
						this.dataTypes = [];
						this.dataTypes.push("text");
						returnString = true;
					}
				}
				// try to analyze and detect automatically 
				data = $.type(data) === "string" ? $.trim(data) : data;
				if ((data && $.type(data) === "string" && (data.startsWith("<?xml") ||
					data.startsWith("<"))) || t === "xml") {
					// assume XML
					if (schema) {
						schema._type = "xml";
					}
					// we must convert the string to a document first
					ds = this.context._processXmlResponse(this.context.stringToXmlObject(data), false, this.context);
				} else if ((data && $.type(data) === "string" && data.startsWith("[")) ||
						(t === "json" || t === "array")) {
					if (schema) {
						schema._type = "json";
					}
					//ds = this.context._processJsonResponse(eval(data), this.context);
					//A.T. 20 Jan 2011 - fix for bug #62124 - igDataSource JSON string binding error
					ds = this.context._processJsonResponse(JSON.parse(data), this.context);
				} else if ((data && $.type(data) === "string" && data.startsWith("{")) ||
						t === "json") {
					if (schema) {
						schema._type = "json";
					}
					ds = this.context._processJsonResponse(JSON.parse(data), this.context);
				} else if ($.isXMLDoc(data)) {
					if (schema) {
						schema._type = "xml";
					}
					ds = this.context._processXmlResponse(data, true, this.context);
				} else if (data !== "" && data !== null) {
					throw new Error($.ig.DataSourceLocale.locale.errorUnrecognizedResponseType);
				}
			}
			/*
			resKey = this.context.settings.responseDataKey;
			if (resKey && resKey !== "") {
			ds = rawData[resKey];
			} else {
			ds = rawData;
			}
			
			if (this.context._isPagingReq || this.context._isFilteringReq) {
			key = this.context.settings.responseTotalRecCountKey;
			if (rawData && rawData[key]) {
			if ($.type(rawData[key]) === "number") {
			this.context.totalRecordsCount(rawData[key]);
			} else {
			// try parse
			this.context.totalRecordsCount(parseInt(rawData[key], 10));
			}
			}
			}
			*/
			//if (returnString) {
			//	return JSON.stringify(ds);
			//}
			if (returnString) {
				if (!(this.context.settings.paging && this.context.settings.paging.enabled && this.context.settings.paging.appendPage)) {
					this.context._data = ds;
				}
				this.context._alreadySet = true;
			}
			return ds;
		},
		_successCallback: function (data) {
			// set the data & dataView
			//if the response doesn't hold the list of records directly in the root of the response, should we 
			// set the data to the list of records, or only the dataView? 
			// meaning , should the "_data" contain the raw response , in this case, an object, if the resKey is set ?
			var x, len = data ? data.length : 0;
			if ((data === undefined || data === null) && !this._alreadySet) {
				this._data = [];
				this._dataView = [];
			} else {
				if (this._data.length >= 0 && this.settings.paging && this.settings.paging.enabled && this.settings.paging.appendPage) {
					for (x = 0; x < len; ++x) {
						this._data[this._data.length] = data[x];
					}
				} else {
					if (this._alreadySet) {
						this._dataView = this._data;
					} else {
						this._data = data;
						this._dataView = data;
					}
				}
			}
			if (this.settings.dataSourcePopulated) {
				this._data = this.settings.dataSourcePopulated(this, this._data);
			}
			this._alreadySet = false;
			this._populateTransformedData();
			this._isPagingReq = false;
			this._isFilteringReq = false;
			this._isSortingReq = false;
			this._isSummariesReq = false;
		},
		_errorCallback: function (req, status, error) {
			// first parameter denotes whether the request has been successful or not, second param is the error msg
			var f = this._customCallback || this.settings.callback, errmsg, statusMsg;
			this._isPagingReq = false;
			this._isFilteringReq = false;
			this._isSortingReq = false;
			this._isSummariesReq = false;
			if (req && req.status && req.statusText) {
				statusMsg = " ( " + req.status + " " + req.statusText + " )";
			} else if (status !== null) {
				statusMsg = " ( " + status + " ) ";
			} else if (error !== undefined) {
				statusMsg = " ( " + error.message || error + " ) ";
			}
			errmsg = $.ig.DataSourceLocale.locale.errorRemoteRequest + statusMsg;
			if (f && this._callee) {
				f.apply(this._callee, [false, errmsg, req, this]);
			} else if (f) {
				f(false, errmsg, req, this);
			}
		},
		_completeCallback: function () {
			var f, callee, s = this.settings.sorting, p = this.settings.paging, filtering = this.settings.filtering;
			// M.H. 3 June 2014 Fix for bug #172970: Local filtering is not persisted when the dataSource is remote
			if (filtering.type === "local" && filtering.defaultFields.length > 0) {
				this.filter(filtering.defaultFields);
			}
			if (s.type === "local" && s.defaultFields.length > 0) {
				this.sort(s.defaultFields, s.defaultDirection);
			}
			// Check if paging is configured, and if so, 
			// if OpType === $.ig.Constants.OpType.Local => apply local paging
			if (p.enabled && p.type === "local") {
				this._page();
			}
			// M.H. 18 Aug 2014 Fix for bug #177147: The dataBound event is called before the JSON file is returned
			if ($.isFunction(this.settings.dataBound)) {
				this.settings.dataBound(this);
			}
			f = this._customCallback || this.settings.callback;
			callee = this._callee || this.settings.callee;
			if (f && callee) {
				f.apply(callee, [true, "", this]);
			} else if (f) {
				f(true, "", this);
			}
		},
		_processRequest: function (options) {
			var o, s;
            // trigger the call
			if (this.settings.responseDataType === 'jsonp') {
				//$.getJSON(options.url, options.data, $.proxy(this._jsonpFilter, this));
                // M.H. 29 Aug 2013 Fix for bug #150723: When dataSource is remote and it is used JSONP then in Chrome and Firefox it is thrown exception and grid is not loaded
                // M.H. 19 Sep 2013 Fix for bug #151600: [Templating] Row Template with Images doesn't load
                o = {
                  dataType:'jsonp',
                  type: 'GET',
                  url: options.url,
                  data: options.data,
                  success: $.proxy(this._jsonpFilter, this)
                };
                // M.H. 19 Sep 2013 Fix for bug #151600: [Templating] Row Template with Images doesn't load
                s = this.settings;
                if (s.jsonp !== undefined && s.jsonp !== null) {
                    o.jsonp = this.settings.jsonp;
                }
                if (s.jsonpCallback !== undefined) {
                    o.jsonpCallback = this.settings.jsonpCallback;
                }
                $.ajax(o);
			} else {
				$.ajax(options);
				/*
				$.ajax({
				url: url,
				// do not specify a dataType, let jQuery detect the response type, and filter the data later on. 
				dataType: dataType,
				async: true,
				context: this,
				data: params,
				contentType: contentType,
				cache: false,
				dataFilter: dataFilterFunction,
				success: successCallback,
				complete: completeCallback,
				error: errorCallback
				});
				*/
			}
		},
		_jsonpFilter: function (data) {
			var resp, x;
			this.context = this;
			resp = this._dataFilter(data, "json");
			if (!resp.length && $.type(resp) === "object") {
				resp = [resp];
			}
			if (this._data.length >= 0 && this.settings.paging && this.settings.paging.enabled && this.settings.paging.appendPage) {
				for (x = 0; x < resp.length; ++x) {
					this._data[this._data.length] = resp[x];
				}
			} else {
				this._data = resp;
				this._dataView = resp;
			}
			this._populateTransformedData();
			this._completeCallback();
		},
		_processJsonResponse: function (data, context) {
			var ds, schema = context.schema(), resKey, resPath, i;
			// support for remote custom loadOnDemand
			if (this._responseData) {
				this._responseData(data);
			}
			if (schema && schema.fields && schema.fields().length > 0 && this.settings.localSchemaTransform) {
				ds = schema.transform(data);
			} else {
				resKey = context.settings.responseDataKey;
				if (resKey !== null && resKey !== undefined) {
					//we are not using eval() here, merge implementations with the schema code 
					//consider arrays here as well 
					resPath = resKey.split(".");

					//if (resKey && resKey !== "") {
					if (resPath.length > 0) {
						//	ds = data[resKey];
						ds = data;
						for (i = 0; i < resPath.length; i++) {
							ds = ds[resPath[i]];
						}
						if (typeof ds === 'string') {
							ds = JSON.parse(ds);
						}
					} else {
						ds = data;
					}
				} else {
					ds = data;
				}
			}

			if (context._isPagingReq || context._isFilteringReq) {
				this.totalRecordsCount(null, this.settings.responseTotalRecCountKey, data, context);
			}
			if (data.Metadata) {
				this._metadata = data.Metadata;
			}

			this.summariesResponse(this.settings.summaries.summariesResponseKey, data);
			return ds;
		},
		// think about how to combine both searchField in the schema and responseDataKey, if defined in the root settings of the data source 
		_processXmlResponse: function (data, isParsed, context) {

			var ds, schema = context.schema(), tmpSchema, resKey;

			//make sure it's also possible to just define a searchfield without schema. currently the search field is in the schema? 
			if (schema && schema.fields && schema.fields().length > 0) {
				ds = this.settings.localSchemaTransform ? schema.transform(data) : data;
			} else {
				// convert the XML document to an array of JSON objects
				resKey = context.settings.responseDataKey;
				if (resKey && resKey !== "") {
					tmpSchema = new $.ig.DataSchema();
					ds = context._xmlToArray(tmpSchema._findXmlRecordsRoot(data, resKey));
				} else {
					ds = context._xmlToArray(data);
				}
			}
			return ds;
		},
		_xmlToArray: function (data) {
			// the assumptions here are several:
			// - the data that comes as a parameter is a XML document
			// - we are only going to traverse the children of the first root element - this is the default response type
			// for WCF services declared with BodyStyle = WebMessageBodyStyle.Wrapped attribute
			// we will also check of the root contains more than 1 node, and then assume the response is of type WebMessageBodyStyle.Bare
			// all other cases need to be handled by the developer - either specify schema or make sure the response has the format
			//  <root>
			//		< child> </child>
			//		....
			//  </root>
			var ds = [], root = data, i, r, j, name, val, o;
			o = window.ActiveXObject;
			if (data && data.childNodes && data.childNodes.length === 1) {
				// parse children of first root
				root = data.childNodes[0];
			}
			for (i = 0; i < root.childNodes.length; i++) {
				r = root.childNodes[i];
				ds[i] = [];
				for (j = 0; j < r.childNodes.length; j++) {
					name = o === undefined ? r.childNodes[j].localName : r.childNodes[j].baseName;
					val = o === undefined ? r.childNodes[j].textContent : r.childNodes[j].text;
					ds[i][name] = val;
				}
			}
			return ds;
		},
		_encodeUrl: function () {
			var props = this.settings, sParams = {}, fParams = {}, pParams = {},
				params, selParams = {}, sumParams = {}, extraParams = {}, pkParams = {}, noCancel = true;
			// if the schema is defined on the client, but we have RemoteUrl data source type, 
			// in the oData protocol it's possible to list fields that will be included in the response
			// so let's read that from the schema and encode it in the URL, in case the server-side
			// supports it. Example:
			// http://www.odata.org/developers/protocols/uri-conventions#SelectSystemQueryOption
			params = { "sortingParams": sParams, "filteringParams": fParams, "pagingParams": pParams, "selectParams": selParams,
					"summariesParams": sumParams, "extraParams": extraParams, "pkParams": pkParams
				};
			if ($.isFunction(props.urlParamsEncoding)) {
				//args = props.urlParamsEncoding(this, params);
				noCancel = props.urlParamsEncoding(this, params);
			}
			//A.T. 18 Jan. 2011 - fix for bug #62309 - igDataSource unclear cancelability of urlParamsEncoding
			//if (!args.cancel) {
			if (noCancel) {
				this._encodeSelectParams(params);
				this._encodeSortingParams(params);
				this._encodeFilteringParams(params);
				this._encodePagingParams(params);
				this._encodeSummariesParams(params);
				// L.A. 10 August 2012 Fixing bugs #118643, #117764
				this._encodePkParams(params);
				// this should be implemented by any external features that are not direclly mapped as data source features
				// such as group by summaries
				if ($.isFunction(this.settings.encodeExtraParams)) {
					this.settings.encodeExtraParams(this, params);
				}

				if ($.isFunction(props.urlParamsEncoded)) {
					props.urlParamsEncoded(this, params);
				}
			}
			return $.extend(true, {}, params.sortingParams, params.filteringParams, params.pagingParams, params.selectParams, params.summariesParams,
				params.extraParams, params.pkParams);
		},
		// L.A. 10 August 2012 Fixing bugs #118643, #117764
		_encodePkParams: function (params) {
			var p = this.settings.paging, s = this.settings.sorting, f = this.settings.filtering,
				sm = this.settings.summaries, pk = this._schema ? this._schema._pk : null;
			// S.S. December 19, 2012 Bug #129394 this._metadata is always undefined on the first call because the dataSource
			// uses the first ajax response to set it. Therefore we shouldn't check for metadata availability
			if (pk && ((p.enabled && p.type === "remote") || (s.type === "remote"  || f.type === "remote" || sm.type === 'remote'))) {
				params.pkParams.pk = pk;
			}
		},
		_encodeSelectParams: function (params) {
			var selParams = params.selectParams, i;

			if (!this.settings.localSchemaTransform && this.schema() && this.schema().fields().length > 0) {
				// encode fields using oData $select
				// http://www.odata.org/developers/protocols/uri-conventions#SelectSystemQueryOption
				// example: http://services.odata.org/OData/OData.svc/Products?$select=Price,Name
				selParams.$select = "";
				for (i = 0; i < this.schema().fields().length; i++) {
					if (i !== 0) {
						selParams.$select += ",";
					}
					selParams.$select += this.schema().fields()[i].name;
				}
			} else if (!this.settings.localSchemaTransform && this.schema() && this.schema().fields().length === 0) {
				// include all fields
				// http://services.odata.org/OData/OData.svc/Products?$select=*
				selParams.$select = "*";
			}
		},
		_encodePagingParams: function (params) {
			var p = this.settings.paging;
			if (p.enabled && p.type === "remote") {
				//if (p.enabled) {
				// handle paging URL params
				// is also paging request
				this._isPagingReq = true;
				if (p.pageIndexUrlKey !== null && p.pageSizeUrlKey !== null) {
					params.pagingParams[p.pageIndexUrlKey] = this.pageIndex();
					params.pagingParams[p.pageSizeUrlKey] = this.pageSize();
				} else {
					// OData
					// $skip is the start index and $top is the end index 
					params.pagingParams.$skip = this.pageIndex() * this.pageSize();
					//params.pagingParams.$top = params.pagingParams.$skip + this.pageSize();
					params.pagingParams.$top = this.pageSize();

					// encode $inlinecount
					params.pagingParams.$inlinecount = "allpages";
					// set response key for total number of pages
					if (this.settings.responseTotalRecCountKey === null) {
						// http://www.odata.org/developers/protocols/uri-conventions#InlinecountSystemQueryOption
						this.settings.responseTotalRecCountKey = "d.__count"; // this is the default OData conventions
					}
				}
			}
		},
		_encodeSortingParams: function (params) {
			var s = this.settings.sorting, tmpdir, i, sfields, url, urlQS, hlayout = null;
			if (s.type === "remote") {
				// handle sorting params
				if (s.exprString) {
					sfields = this._parseSortExpressions(s.exprString);
				} else {
					// handle expressions array
					sfields = s.expressions;
				}
				this._isSortingReq = true;
				// now encode
				for (i = 0; i < sfields.length; i++) {
					if (sfields[i].layout) {
						hlayout = sfields[i].layout;
					}
					// it's a sorting request
					if (s.sortUrlAscValueKey !== null && s.sortUrlDescValueKey !== null && s.sortUrlKey !== null) {
						tmpdir = (sfields[i].dir && sfields[i].dir.toLowerCase().startsWith("asc")) ? s.sortUrlAscValueKey : s.sortUrlDescValueKey;
						params.sortingParams[s.sortUrlKey + '(' + sfields[i].fieldName + ')'] = tmpdir;
					} else {
						// OData style encoding (the default)
						if (params.sortingParams.$orderby === undefined) {
							params.sortingParams.$orderby = "";
						}
						params.sortingParams.$orderby = params.sortingParams.$orderby + sfields[i].fieldName + " " + sfields[i].dir.toLowerCase();
						if (i < sfields.length - 1) {
							params.sortingParams.$orderby += ",";
						}
						//params.sortingParams.$orderby = encodeURIComponent(params.sortingParams.$orderby);
					}
				}
				if (hlayout) {
					// we do not want to encode one and the same keyvalue pair twice
					// M.H. 9 Jan 2014 Fix for bug #158808: When using LoadOnDemand with remote GroupBy for the second child layout, the grouped rows are not properly sorted.
					url = this.settings.dataSource;
					if (url && $.type(url) === 'string' && url.indexOf("layout=" + hlayout) >= 0) {
						url = url.substr(url.indexOf('?') + 1);
						urlQS = url.split("&");
						for (i = 0; i < urlQS.length; i++) {
							if (urlQS[i].indexOf('layout=') >= 0) {
								if (urlQS[i].replace('layout=', '') === hlayout) {
									hlayout = null;
								}
								break;
							}
						}
					}
					if (hlayout) {
						params.sortingParams.layout = hlayout;
					}
				}
			}
		},
		_encodeFilteringParams: function (params) {
			var f = this.settings.filtering, ffields, i, key, exprNotReq, cond, d, day, month, year, curDate, expr, fieldName, logic = "and";
			if (f.type === "remote") {
				// handle filtering params
				if (f.exprString) {
					ffields = this._parseFilterExprString(f.exprString);
				} else {
					ffields = f.expressions;
				}
				for (i = 0; i < ffields.length; i++) {
					// is a filtering request
					this._isFilteringReq = true;
					cond = ffields[i].cond;

					exprNotReq = cond === "false" || cond === "true" ||
						cond === "today" ||
						cond === "yesterday" || cond === "thisMonth" ||
						cond === "lastMonth" || cond === "nextMonth" ||
						cond === "thisYear" || cond === "lastYear" ||
						cond === "nextYear" || cond === "null" ||
						cond === "notNull" || cond === "empty" ||
						cond === "notEmpty";
					// if the filtering url key is explicitly defined, use this encoding: 
					// example something.php?filter(Name)=Contains(NY)
					// otherwise we use OData as the default
					if (f.filterExprUrlKey !== null) {
						// check if a filtering condition for the column already exists
						key = f.filterExprUrlKey + '(' + ffields[i].fieldName + ')';
						if ($.type(ffields[i].expr) === "date") {
							d = Date.UTC(ffields[i].expr.getFullYear(), ffields[i].expr.getMonth(), ffields[i].expr.getDate(), ffields[i].expr.getHours(), ffields[i].expr.getMinutes());
							//d = ffields[i].expr.getTime();
						} else {
							d = ffields[i].expr;
						}
						if (params.filteringParams[key] === undefined) {
							params.filteringParams[key] = ffields[i].cond + '(' + (exprNotReq ? '' : d) + ')';
						} else {
							params.filteringParams[key] = params.filteringParams[key] + ',' + ffields[i].cond + '(' + (exprNotReq ? '' : d) + ')';
						}
					} else {
						// OData:
						// http://www.odata.org/developers/protocols/uri-conventions#FilterSystemQueryOption
						// we support the following out of the box:
						// Eq, Ne, Gt, Ge, Lt, Le, And, Or, Not
						// as well as the following functions:
						// endswith, startswith, indexof
						if (params.filteringParams.$filter === undefined) {
							params.filteringParams.$filter = "";
						}
						// M.H. 5 Sep 2013 Fix for bug #150774: OData Request ignores Case Sensitivity
						fieldName = ffields[i].fieldName;
						expr = ffields[i].expr;
						if ($.type(expr) === "string") {
							if (!f.caseSensitive) {
								fieldName = "tolower(" + fieldName + ")";
								expr = expr.toLowerCase();
							}
							// M.H. 3 Apr 2014 Fix for bug #168922: When using remote filtering, single quote characters are not escaped properly.
							expr = expr.replace(/\'/g, "''");
                        }
						if (ffields[i].cond === "startsWith") {

							params.filteringParams.$filter += "startswith(" + fieldName + "," + "'" + expr + "') eq true";

						} else if (ffields[i].cond === "endsWith") {

							params.filteringParams.$filter += "endswith(" + fieldName + "," + "'" + expr + "') eq true";

						} else if (ffields[i].cond === "contains") {

							params.filteringParams.$filter += "indexof(" + fieldName + "," + "'" + expr + "') ge 0";

						} else if (ffields[i].cond === "doesNotContain") {

							params.filteringParams.$filter += "indexof(" + fieldName + "," + "'" + expr + "') eq -1";

						} else if (ffields[i].cond === "equals") {

							if ($.type(ffields[i].expr) === "string") {
								params.filteringParams.$filter += fieldName + " eq " + "'" + expr + "'";
							} else {
								params.filteringParams.$filter += ffields[i].fieldName + " eq " + ffields[i].expr;
							}
						} else if (ffields[i].cond === "true") {
							params.filteringParams.$filter += ffields[i].fieldName + " eq true";
						} else if (ffields[i].cond === "false") {
							params.filteringParams.$filter += ffields[i].fieldName + " eq false";
						} else if (ffields[i].cond === "doesNotEqual") {

							if ($.type(ffields[i].expr) === "string") {
								params.filteringParams.$filter += fieldName + " ne " + "'" + expr + "'";
							} else {
								params.filteringParams.$filter += ffields[i].fieldName + " ne " + ffields[i].expr;
							}

						} else if (ffields[i].cond === "greaterThan") {

							params.filteringParams.$filter += ffields[i].fieldName + " gt " + ffields[i].expr;

						} else if (ffields[i].cond === "lessThan") {

							params.filteringParams.$filter += ffields[i].fieldName + " lt " + ffields[i].expr;

						} else if (ffields[i].cond === "greaterThanOrEqualTo") {

							params.filteringParams.$filter += ffields[i].fieldName + " ge " + ffields[i].expr;

						} else if (ffields[i].cond === "lessThanOrEqualTo") {

							params.filteringParams.$filter += ffields[i].fieldName + " le " + ffields[i].expr;
						} else if (ffields[i].cond === "null") {
							params.filteringParams.$filter += ffields[i].fieldName + " eq null";
						} else if (ffields[i].cond === "notNull") {
							params.filteringParams.$filter += ffields[i].fieldName + " ne null";
						} else if (ffields[i].cond === "empty") {
							params.filteringParams.$filter += "length(" + ffields[i].fieldName + ") eq 0";
						} else if (ffields[i].cond === "notEmpty") {
							params.filteringParams.$filter += "length(" + ffields[i].fieldName + ") gt 0";
						} else if (ffields[i].cond === "on") {
							expr = this._parser.toDate(ffields[i].expr);
							year = expr.getFullYear();
							month = expr.getMonth() + 1;
							day = expr.getDate();
							params.filteringParams.$filter += "day(" + ffields[i].fieldName + ") eq " + day + " and ";
							params.filteringParams.$filter += "month(" + ffields[i].fieldName + ") eq " + month + " and ";
							params.filteringParams.$filter += "year(" + ffields[i].fieldName + ") eq " + year;
						} else if (ffields[i].cond === "notOn") {
							expr = this._parser.toDate(ffields[i].expr);
							//params.filteringParams.$filter += ffields[i].fieldName + " ne DateTime'" + $.ig.formatter(expr, "date", "yyyy-MM-dd") + "'";
							// M.H. 15 May 2014 Fix for bug #171705: With odata filtering a date column by 'Not On' doesn't filter the selected date.
							year = expr.getFullYear();
							month = expr.getMonth() + 1;
							day = expr.getDate();
							params.filteringParams.$filter += "day(" + ffields[i].fieldName + ") ne " + day + " or ";
							params.filteringParams.$filter += "month(" + ffields[i].fieldName + ") ne " + month + " or ";
							params.filteringParams.$filter += "year(" + ffields[i].fieldName + ") ne " + year;
						} else if (ffields[i].cond === "after") {
							expr = this._parser.toDate(ffields[i].expr);
							params.filteringParams.$filter += ffields[i].fieldName + " gt DateTime'" + $.ig.formatter(expr, "date", "yyyy-MM-ddT23:59:59") + "'";
						} else if (ffields[i].cond === "before") {
							expr = this._parser.toDate(ffields[i].expr);
							params.filteringParams.$filter += ffields[i].fieldName + " lt DateTime'" + $.ig.formatter(expr, "date", "yyyy-MM-dd") + "'";
						} else if (ffields[i].cond === "today") {
							expr = this._parser.toDate(ffields[i].expr);
							year = expr.getFullYear();
							month = expr.getMonth() + 1;
							day = expr.getDate();
							params.filteringParams.$filter += "day(" + ffields[i].fieldName + ") eq " + day + " and ";
							params.filteringParams.$filter += "month(" + ffields[i].fieldName + ") eq " + month + " and ";
							params.filteringParams.$filter += "year(" + ffields[i].fieldName + ") eq " + year;
						} else if (ffields[i].cond === "yesterday") {
							expr = this._parser.toDate(ffields[i].expr);
							year = expr.getFullYear();
							month = expr.getMonth() + 1;
							day = expr.getDate();
							params.filteringParams.$filter += "day(" + ffields[i].fieldName + ") eq " + day + " and ";
							params.filteringParams.$filter += "month(" + ffields[i].fieldName + ") eq " + month + " and ";
							params.filteringParams.$filter += "year(" + ffields[i].fieldName + ") eq " + year;
						} else if (ffields[i].cond === "thisMonth") {
							curDate = new Date();
							month = curDate.getMonth() + 1;
							year = curDate.getFullYear();
							params.filteringParams.$filter += "month(" + ffields[i].fieldName + ") eq " + month + " and ";
							params.filteringParams.$filter += "year(" + ffields[i].fieldName + ") eq " + year;
						} else if (ffields[i].cond === "lastMonth") {
							curDate = new Date();
							month = curDate.getMonth() + 1;
							year = curDate.getFullYear();
							if (month === 1) {
								month = 12;
								year--;
							} else {
								month--;
							}
							params.filteringParams.$filter += "month(" + ffields[i].fieldName + ") eq " + month + " and ";
							params.filteringParams.$filter += "year(" + ffields[i].fieldName + ") eq " + year;
						} else if (ffields[i].cond === "nextMonth") {
							curDate = new Date();
							month = curDate.getMonth() + 1;
							year = curDate.getFullYear();
							if (month === 12) {
								month = 1;
								year++;
							} else {
								month++;
							}
							params.filteringParams.$filter += "month(" + ffields[i].fieldName + ") eq " + month + " and ";
							params.filteringParams.$filter += "year(" + ffields[i].fieldName + ") eq " + year;
						} else if (ffields[i].cond === "thisYear") {
							curDate = new Date();
							year = curDate.getFullYear();
							params.filteringParams.$filter += "year(" + ffields[i].fieldName + ") eq " + year;
						} else if (ffields[i].cond === "lastYear") {
							curDate = new Date();
							year = curDate.getFullYear() - 1;
							params.filteringParams.$filter += "year(" + ffields[i].fieldName + ") eq " + year;
						} else if (ffields[i].cond === "nextYear") {
							curDate = new Date();
							year = curDate.getFullYear() + 1;
							params.filteringParams.$filter += "year(" + ffields[i].fieldName + ") eq " + year;
						}
						// M.H. 28 May 2014 Fix for bug #172592: Cannot filter with ANY condition in the advanced filter dialog when the grid is bound to an oData data source
						logic = "and";
						if (ffields[i].logic && ffields[i].logic.toLowerCase() === 'or') {
							logic = "or";
						}
						if (i < ffields.length - 1) {
							// M.H. 28 May 2014 Fix for bug #172592: Cannot filter with ANY condition in the advanced filter dialog when the grid is bound to an oData data source
							params.filteringParams.$filter += " " + logic + " ";
						}
						//params.filteringParams.$filter = encodeURIComponent(params.filteringParams.$filter);
						// Before, After, Today, Yesterday, and so on - are not supported by OData, only by our custom filtering 
					}
				}
				// now encode the filtering logic, if defined
				if (f.filterLogicUrlKey !== null && ffields.length > 0) {
					// takes the first field's logic prop
					params.filteringParams[f.filterLogicUrlKey] = ffields[0].logic;
				}
			}
		},
		_encodeSummariesParams: function (params) {
			var i, j, s = this.settings.summaries, cs = s.columnSettings,
				methodsStr,
				csLength = cs.length;

			if (s.type === 'remote') {
				for (i = 0; i < csLength; i++) {
					methodsStr = '';
					// check if methods are defined
					if (cs[i].summaryOperands === undefined || cs[i].summaryOperands === null) {
						continue;
					}
					for (j = 0; j < cs[i].summaryOperands.length; j++) {
						if (cs[i].summaryOperands[j].active === true || cs[i].summaryOperands[j].active === 1) {
							methodsStr += cs[i].summaryOperands[j].type + ',';
						}
					}
					if (methodsStr !== '') {
						params.summariesParams[s.summaryExprUrlKey + '(' + cs[i].columnKey + ')'] = methodsStr.slice(0, -1);
					}
				}
			}
		},

		_page: function (keepRecords) {
			var count = 0, startIndex, endIndex, i = 0;
			if (keepRecords === undefined) {
				keepRecords = false;
			}
			//this._filteredDataView = [];
			// reset the dataView:
			if (keepRecords) {
				count = this._dataView.length;
			} else {
				this._dataView = [];
			}
			if (!this._filter) {
				// this._dataView should contain only the number of records specified by pageSize. 
				// load the data for the current page only , in the DataView
				startIndex = this.pageIndex() * this.pageSize();
				endIndex = startIndex + this.pageSize() >= this._data.length ? this._data.length : startIndex + this.pageSize();
				for (i = startIndex; i < endIndex; i++) {
					this._dataView[count++] = this._data[i];
				}
			} else {
				startIndex = this.pageIndex() * this.pageSize();
				endIndex = startIndex + this.pageSize() >= this._filteredData.length ? this._filteredData.length : startIndex + this.pageSize();
				for (i = startIndex; i < endIndex; i++) {
					this._dataView[count++] = this._filteredData[i];
				}
			}
		},
		// multi-column sorting  (third column - whether sorting should be preserved or cleared ) 
		// field can be a schema field, or an index of the column 
		// fields => an array of fields object definitions: 
		// example: [{fieldName : "firstName"}, {fieldName : "lastName"}]
		// example 2: [{fieldIndex : 1} , {fieldIndex : 2}]
		sort: function (fields, direction) {
			/* Sorts the data source locally. The result (filtered data) can be obtained by calling dataView(). Remote filtering can be performed by just calling dataBind() and setting the settings.filtering.expressions
			multi-column sorting can be enabled by setting keepSortState to true. 
			fields => an array of fields object definitions: 
			example: [{fieldName : "firstName"}, {fieldName : "lastName"}]
			example 2: [{fieldIndex : 1} , {fieldIndex : 2}]
				
			paramType="object" an array of fields object definitions
			paramType="string" asc / desc direction
			paramType="bool" if set to true, enables multi-column sorting, and the previous sorting state is not cleared
			*/
			// check if there is a custom function defined
			var s = this.settings.sorting, schema, sortF, convertFunc, p = this.settings.paging, data, resetPaging = false, settings = this.settings;
			if (fields === undefined || fields === null) {
				throw new Error($.ig.DataSourceLocale.locale.noSortingFields);
			}
			// default sort function
			sortF = function (grid, fields, schema, reverse, convertf) {
				reverse = reverse ? -1 : 1;
				function compareVals(format, enableUTCDates, rowTemplate, x, y) {
					if (format) {
						// L.A. 11 January 2013 - Fixing bug #130576 
						// L.A. 09 August 2012 - Fixing bug #118640 When the grid is bound to UTC dates 
						// (remote or local data), grouping a time-formatted date column produces incorrect groups
						if ($.type(x) === "date" && $.type(y) === "date") {
							if (format === "time" || format === "timeLong" || format === "h:mm:ss tt") {
								// Create date objects with fake year
                                // M.H. 23 Oct 2013 Fix for bug #155639: Unable to sort date column when format is "h:mm:ss tt"
								x = new Date("January 01, 2000 " + $.ig.formatter(x, "date", format, rowTemplate, enableUTCDates));
								y = new Date("January 01, 2000 " + $.ig.formatter(y, "date", format, rowTemplate, enableUTCDates));
							}
						}
					}
					if ((x === null || x === undefined) && (y === null || y === undefined)) {
						return 0;
					}
					if ((x === null || x === undefined) && y !== null && y !== undefined) {
						return -1;
					}
					if (x !== null && x !== undefined && (y === null || y === undefined)) {
						return 1;
					}
					return x > y ? 1 : x < y ? -1 : 0;
				}
				return function (obj1, obj2) {
					var i, f, arr1 = [], arr2 = [], a, b, key, col, format, o, enableUTCDates,
						rowTemplate;
					if (grid) {
						o = grid.options;
						enableUTCDates = o.enableUTCDates;
						rowTemplate = (!o.rowTemplate || o.rowTemplate.length <= 0);
					}
					for (i = 0; i < fields.length; i++) {
						key = fields[i].fieldName;
						if (grid && grid.columnByKey) {
							col = grid.columnByKey(key);
							if (col !== undefined && col !== null) {
								format = col.format;
							}
						}
						if (fields[i].layout && ((settings.key && settings.key !== fields[i].layout) || !settings.key)) {
							continue;
						}
						f = fields[i];
						if (f.fieldIndex >= 0) {
							f.fieldName = f.fieldIndex;
						}
						a = obj1[f.fieldName];
						b = obj2[f.fieldName];
						if (convertf !== undefined) {

							// this is assumed to be a custom-defined function, that will override the default data source type conversion logic
							a = convertf(a, f.fieldName);
							b = convertf(b, f.fieldName);
						}
						//A.T. 19 Jan 2011 - Fix for bug #62963 - igDataSource - case sensitivity is not applied to sorting
						if (s.caseSensitive === false) {
							if (a !== undefined && a !== null && a.toLowerCase) {
								a = a.toLowerCase();
							}
							if (b !== undefined && b !== null && b.toLowerCase) {
								b = b.toLowerCase();
							}
						}
						// support a different direction for every separate column
						if (f.dir !== undefined && f.dir !== null) {
							reverse = f.dir.toLowerCase().startsWith("desc");
							reverse = reverse ? -1 : 1;
						} else if (direction !== undefined && direction !== null && direction !== "") {
							reverse = direction.toLowerCase().startsWith("desc");
							reverse = reverse ? -1 : 1;
						}
						// differentiate between single and multi-col sorting (for performance reasons)
						if (fields.length === 1) {
							arr1 = reverse * compareVals(format, enableUTCDates, rowTemplate, a, b);
							arr2 = reverse * compareVals(format, enableUTCDates, rowTemplate, b, a);
						} else {
							if (reverse === -1) {
								arr1.push(-compareVals(format, enableUTCDates, rowTemplate, a, b));
								arr2.push(-compareVals(format, enableUTCDates, rowTemplate, b, a));
							} else {
								arr1.push(compareVals(format, enableUTCDates, rowTemplate, a, b));
								arr2.push(compareVals(format, enableUTCDates, rowTemplate, b, a));
							}
						}
					}
					if (arr1 < arr2) {
						return -1;
					}
					if (arr1 > arr2) {
						return 1;
					}
					return 0;
				};
			};
			if (s.applyToAllData && s.type === "local") {
                // M.H. 11 Mar 2013 Fix for bug #135542: When filtering is applied and then sort any column and there is remote paging, all of the records for the current page are sorted and rendered, no matter the applied filter
				if (this._filter && ((p.type === "local" && p.enabled === true) || p.enabled === false ||
						(p.type === "remote" && p.enabled === true && this.settings.filtering.type === 'local'))) {
					data = this._filteredData;
				} else {
					data = this.data();
				}
				resetPaging = true;
			} else {
				data = this.dataView();
			}
			if ($.type(s.customFunc) === 'function') {
				// call the function, passing the data to be sorted, the fields, and the direction
				data = s.customFunc(data, fields, direction);
			} else {
				schema = this.settings.schema;
				/*
				for (i = 0; i < schema.fields.length; i++) {
				if (schema.fields[i].name === fields[0].fieldName) {
				type = schema.fields[i].type;
				}
				}
				*/
				if (!direction) {
					direction = "";
				}
				// check if a custom compare function is set
				if ($.type(s.compareFunc) === "function") {
					sortF = s.compareFunc;
				}
				// check if a custom conversion function is set
				if ($.isFunction(s.customConvertFunc)) {
					convertFunc = s.customConvertFunc;
				}
				//else {
				// we do not want to reset the default data source type conversion logic
				// convertFunc returns a function 
				//convertFunc = this._convertf;
				//}

				// we allow the developer to provide a single string of sort expressions, in the following format:
				// "col1 asc, col2 desc, col3 asc" ... 
				if ($.type(fields) === "string") {
					fields = this._parseSortExpressions(fields);
				}
				// A.T. 21 Jan Fix for bug #63146 - reversing of sorting should be the other way around if "direction" is specified as parameter in sort()
				// M.H. 16 March 2012 Fix for bug #105043 - when fields.length is 0 then sortF returns 0. But in Chrome when there are empty values the issues is represented
				if (fields.length > 0) {
					data = data.sort(sortF(this.settings.callee, fields, schema, direction.toLowerCase().startsWith("asc") ? false : true, convertFunc));
                    // M.H. 14 Oct 2013 Fix for bug #154649: Rows are grouped incorrectly when applying and removing a filter if a filter is applied by default through code
                    // when ds is local and if the whole dataSource is not sorted but only dataView then on filtering data when groupby is applied grouping wouldn't be correct. 
                    // GroupBy takes the data(not sorted) from dataSource which is not sorted and apply filtering...
                    this._allDataSorted = (data === this.data());
				}
			}
			// now if paging is enabled, and "applyToAllData" is true, we need to re-initialize the dataView
			if (resetPaging && p.type === "local") {
				/* DAY 2/15/12 101818- when filtering, need to set the filtered data, not _data */
				if (!this._filter) {
					this._data = data;
				} else {
					this._filteredData = data;
				}
				this._page();
			} else {
				// A.T. 14 Feb 2011 - fix for bug #66214
				this._dataView = data;
			}
			// M.H. 17 April 2012 Fix for bug #109475
			this._populateTransformedData(data);
			return this; // preserve chaining
		},
		clearLocalSorting: function () {
			/* This clears local sorting applied to the data view by resetting it to the original data and applying any paging */
			var s = this.settings.sorting, p = this.settings.paging, data, resetPaging = false;

			if (s.applyToAllData && s.type === "local") {
				if (this._filter && ((p.type === "local" && p.enabled === true) || p.enabled === false)) {
					data = this._filteredData;
				} else {
					data = this.data();
				}
				resetPaging = true;
			} else {
				data = this.dataView();
			}
			// now if paging is enabled, and "applyToAllData" is true, we need to re-initialize the dataView
			if (resetPaging && p.type === "local") {
				/* DAY 2/15/12 101818- when filtering, need to set the filtered data, not _data */
				if (!this._filter) {
					this._data = data;
				} else {
					this._filteredData = data;
				}
				this._page();
			} else {
				this._dataView = data;
			}
			this._populateTransformedData();
			return this; // preserve chaining
		},
		// expected format is "col1 ASC, col2 DESC, col3 ASC" ... and so on 
		_parseSortExpressions: function (s) {

			var fields = [], tmp, tmp2, i;
			tmp = s.split(",");

			for (i = 0; i < tmp.length; i++) {
				fields[i] = {};
				tmp2 = $.trim(tmp[i]).split(" ");
				fields[i].fieldName = tmp2[0];
				fields[i].dir = tmp2[1];
			}

			return fields;
		},
		// this is used when sorting data
		// type can be "string", "number", "boolean", "date". 
		//Other values are ignored and default conversion is used 
		//_convertf: function (val, type) {
			// not necessary for now. default type conversion happens in the data source directly 
		//},
		// same regarding multi-col. filtering: rowFilter (ref: DataTable). 
		// example: [{fieldName : "firstName", expr: "abc", cond: "StartsWith"}, {fieldName : "lastName"}]
		// example 2: [{fieldIndex : 1} , {fieldIndex : 2, expr: "a", cond : "Contains"}]
		// expr is the filter expression text , such as "abc", or a regular expression such as *test*
		// cond is the filtering condition such as StartsWith, EndsWith, Contains, Equals, DoesNotEqual, DoesNotContain
		// if expr is detected to be a regular expression, the "cond" part is skipped 
		filter: function (fieldExpressions, boolLogic, keepFilterState, fieldExpressionsOnStrings) {
			/* filters the data source locally. Remote filtering can be performed by just calling dataBind() and setting the settings.filtering.expressions. The result (filtered data) can be obtained by calling dataView() 
			example: [{fieldName : "firstName", expr: "abc", cond: "StartsWith"}, {fieldName : "lastName"}]
			example 2: [{fieldIndex : 1} , {fieldIndex : 2, expr: "a", cond : "contains"}]
			expr is the filter expression text , such as "abc", or a regular expression such as *test*
			cond is the filtering condition such as startsWith, endsWith, contains, equals, doesNotEqual, doesNotContain
			if expr is detected to be a regular expression, the "cond" part is skipped 
			
			paramType="object" a list of field expression definitions
			paramType="AND|OR" boolean logic. Accepted values are AND and OR. 
			paramType="bool" if keepFilterState is set to true, it will not discard previous filtering expressions
			*/
			var i, j, expr = null, count = 0, skipRec = false, f = this.settings.filtering, p = this.settings.paging, data, t, k, schema, fields, tmpbool, resetPaging, allFieldsExpr, stringVal;
			schema = this.schema();
			if (schema === null || schema === undefined) {
				throw new Error($.ig.DataSourceLocale.locale.filteringNoSchema);
			}
			if ($.type(fieldExpressions) === "string") {
				expr = fieldExpressions;
			}
			if ($.type(fieldExpressionsOnStrings) === "string") {
				allFieldsExpr = fieldExpressionsOnStrings;
			} else if ($.type(fieldExpressionsOnStrings) === "undefined") {
				fieldExpressionsOnStrings = [];
			}
			if ($.type(fieldExpressions) === "array" && fieldExpressions.length === 0 && $.type(fieldExpressionsOnStrings) === "array" && fieldExpressionsOnStrings.length === 0) {
				return;
			}
			if (f.applyToAllData && f.type === "local") {
				data = this.data();
				resetPaging = true;
			} else {
				// cache the original dataView 
				if (this._cachedDataView && this._cachedDataView.length > 0) {
					//data = this.dataView();
					data = this._cachedDataView;
				} else {
					// COPY the this.dataView() in this._cachedDataView; this is necessary because we want to restore it later on 
					//this._cachedDataView = $.extend(true, {}, this.dataView());
					this._cachedDataView = $.merge([], this.dataView());
					data = this._cachedDataView;
				}
			}
			if ($.type(f.customFunc) === 'function') {
				// call the function, passing the filterExpression object which contains field names/indices, the current expression for the field, as well as condition for the field
				data = f.customFunc(fieldExpressions, data);
				//A.T. fix for bug #77646
				this._filteredData = data;
				//A.T. 20 Dec. 2011 Fix for bug #96819 - igDataSource filtering feature with own defined custom function does not filtering data
				this._dataView = [];
			} else {
				// re-initialize the dataView. We can do that safely, since data will either be cached, or will be stored in this.data(), meaning that will be the whole ds
				this._dataView = [];
				this._filteredData = [];
				// filter "data"
				// we will store all results in tmpData, and then assign it to the dataView. please ensure that 
				for (i = 0; i < data.length; i++) {
					skipRec = false;
					if (expr) {
						fieldExpressions = this._parseFilterExprString(expr);
					}
					if (allFieldsExpr) {
						fieldExpressionsOnStrings = this._parseFilterExprString(allFieldsExpr);
					}
					for (j = 0; j < fieldExpressions.length; j++) {
						// if there is no match, break, we aren't going to add the record to the resulting data view. 
						// the default boolean logic is to "AND" the fields 
						fields = schema.fields();
						if (fieldExpressions[j].fieldIndex) {
							if (fieldExpressions[j].fieldIndex < fields.length) {
								t = fields[fieldExpressions[j].fieldIndex].type;
							}
							skipRec = !this._findMatch(data[i][fieldExpressions[j].fieldIndex], fieldExpressions[j].expr, t, !f.caseSensitive, fieldExpressions[j].cond, fieldExpressions[j].preciseDateFormat);
						} else {
							// M.H. 10 Sep 2012 Fix for bug #120759
							if (fieldExpressions[j].dataType !== undefined && fieldExpressions[j].dataType !== null) {
								t = fieldExpressions[j].dataType;
							} else {
							for (k = 0; k < fields.length; k++) {
								if (fields[k].name === fieldExpressions[j].fieldName) {
									t = fields[k].type;
									break;
								}
							}
							}
							skipRec = !this._findMatch(data[i][fieldExpressions[j].fieldName], fieldExpressions[j].expr, t, !f.caseSensitive, fieldExpressions[j].cond, fieldExpressions[j].preciseDateFormat);
						}
						tmpbool = (fieldExpressions[j].logic !== null && fieldExpressions[j].logic !== undefined && (fieldExpressions[j].logic.toLowerCase() === "or" ||
							fieldExpressions[j].logic.toLowerCase() === "and")) ? fieldExpressions[j].logic : boolLogic;
						//A.T. 18 Jan. 2011 fix for bug 62126 - igDataSource local filtering expressions: the OR operator does not work
						if (tmpbool === undefined || tmpbool === null || $.type(tmpbool) !== "string") {
							tmpbool = "and";
						}
						if (skipRec && tmpbool.toLowerCase() === "and") {
							break;
						} else if (!skipRec && tmpbool.toLowerCase() === "or") {
							break;
						}
					}
					if (!skipRec) {
						for (j = 0; j < fieldExpressionsOnStrings.length; j++) {
							// if there is no match, break, we aren't going to add the record to the resulting data view. 
							// the default boolean logic is to "AND" the fields 
							fields = schema.fields();
							if (fieldExpressionsOnStrings[j].fieldIndex) {
								if (fieldExpressionsOnStrings[j].fieldIndex < fields.length) {
									t = fields[fieldExpressionsOnStrings[j].fieldIndex].type;
								}
								stringVal = data[i][fieldExpressionsOnStrings[j].fieldIndex] ? data[i][fieldExpressionsOnStrings[j].fieldIndex].toString() : "";
								skipRec = !this._findMatch(stringVal, fieldExpressionsOnStrings[j].expr, "string", !f.caseSensitive, fieldExpressionsOnStrings[j].cond);
							} else {
								for (k = 0; k < fields.length; k++) {
									if (fields[k].name === fieldExpressionsOnStrings[j].fieldName) {
										t = fields[k].type;
										break;
									}
								}
								stringVal = data[i][fieldExpressionsOnStrings[j].fieldName] !== null && data[i][fieldExpressionsOnStrings[j].fieldName] !== undefined ? data[i][fieldExpressionsOnStrings[j].fieldName].toString() : "";
								skipRec = !this._findMatch(stringVal, fieldExpressionsOnStrings[j].expr, "string", !f.caseSensitive, fieldExpressionsOnStrings[j].cond);
							}
							tmpbool = (fieldExpressionsOnStrings[j].logic !== null && fieldExpressionsOnStrings[j].logic !== undefined && (fieldExpressionsOnStrings[j].logic.toLowerCase() === "or" ||
								fieldExpressionsOnStrings[j].logic.toLowerCase() === "and")) ? fieldExpressionsOnStrings[j].logic : boolLogic;
							//A.T. 18 Jan. 2011 fix for bug 62126 - igDataSource local filtering expressions: the OR operator does not work
							if (tmpbool === undefined || tmpbool === null || $.type(tmpbool) !== "string") {
								tmpbool = "and";
							}
							if (skipRec && tmpbool.toLowerCase() === "and") {
								break;
							} else if (!skipRec && tmpbool.toLowerCase() === "or") {
								break;
							}
						}
					}
					if (!skipRec) {
						//this._dataView[count++] = data[i];
						this._filteredData[count++] = data[i];
					}
				}
			}
			this._filter = true;
			if (resetPaging && p.type === "local" && p.enabled === true) {
				// reset paging
				this.settings.paging.pageIndex = 0;
				this.pageSizeDirty(true);
				this._page();
			} else {
				for (i = 0; i < this._filteredData.length; i++) {
					this._dataView[i] = this._filteredData[i];
				}
			}
			this._populateTransformedData(this._filteredData);
			return this; // preserve chaining
		},
		clearLocalFilter: function () {
			/* This clears local filtering applied to the data view by resetting it to the original data and applying any paging */
			var i, f = this.settings.filtering, p = this.settings.paging, data, resetPaging;

			if (f.applyToAllData && f.type === "local") {
				data = this.data();
				resetPaging = true;
			} else {
				// cache the original dataView 
				if (this._cachedDataView && this._cachedDataView.length > 0) {
					//data = this.dataView();
					data = this._cachedDataView;
				} else {
					// COPY the this.dataView() in this._cachedDataView; this is necessary because we want to restore it later on 
					//this._cachedDataView = $.extend(true, {}, this.dataView());
					this._cachedDataView = $.merge([], this.dataView());
					data = this._cachedDataView;
				}
			}
			this._dataView = [];
			this._filteredData = data;
			if (resetPaging && p.type === "local" && p.enabled === true) {
				this._filter = true;
				// reset paging
				this.settings.paging.pageIndex = 0;
				this.pageSizeDirty(true);
				this._page();
			} else {
				if (p.enabled === false) {
					this._filter = true;
				}
				for (i = 0; i < this._filteredData.length; i++) {
					this._dataView[i] = this._filteredData[i];
				}
			}
			this._populateTransformedData(this._filteredData);
			return this; // preserve chaining
		},
		_parseFilterExprString: function (expr) {
			//A.T. 18 Jan 2011 - fix for bug #62418 
			var exprs = $.trim(expr).split(/(?=AND+)|(?=OR+)/i), i, j, fields = [], tmp, tmp2, isInvalid = true;
			for (i = 0; i < exprs.length; i++) {
				fields[i] = {};
				//A.T. 18 Jan 2011 -  Fix for bug #62415 - equality sign (=) is not parsed when in a filtering expression string
				//A.T. 19 Jan 2011 - removing (IN) operator. (bug #62365)
				tmp = $.trim(exprs[i]).split(/(?= \=+)|(?=<>+)|(?=>+)|(?=<+)|(?=LIKE+)|(?=NOT\WLIKE)+|(?=>\=+)|(?=<\=+)/);
				if ($.trim(exprs[i]).toLowerCase().startsWith("and")) {
					fields[i].logic = "AND";
					// strip AND 
					//tmp[0] = tmp[0].substring(tmp.indexOf(3));
				} else if ($.trim(exprs[i]).toLowerCase().startsWith("or")) {
					fields[i].logic = "OR";
					// strip OR
					//tmp[0] = tmp[0].substring(tmp.indexOf(2));
				}
				// the current logic field is always for the previous term 
				if (i > 0 && (fields[i].logic === "AND" || fields[i].logic === "OR")) {
					fields[i - 1].logic = fields[i].logic;
				}
				if (tmp[0].toLowerCase().startsWith("and") || tmp[0].toLowerCase().startsWith("or")) {
					fields[i].fieldName = $.trim(tmp[0].split(" ")[1]);
				} else {
					fields[i].fieldName = $.trim(tmp[0]);
				}
				tmp2 = $.trim(tmp[1]).split(" ");
				// fix ambiguous matching between <, >, and <>
				if (exprs[i].indexOf("<>") !== -1) {
					tmp2[0] = "<>";
					tmp2[1] = tmp[2].replace(">", "");
				}
				//A.T. 19 Jan 2011 - Fix for bug #62368 - igDataSource - Space character handling in filtering string expressions
				if (tmp2.length > 2) {
					// merge all entries from index one to the end into a single string 
					for (j = 2; j < tmp2.length; j++) {
						tmp2[1] = tmp2[1] + ' ' + tmp2[j];
					}
					tmp2 = [tmp2[0], tmp2[1]];
				}
				if (tmp[1].startsWith("NOT")) {
					fields[i].expr = $.trim(tmp[2].replace("LIKE", ""));
				} else {
					fields[i].expr = tmp2[1];
				}
				// validate field
				for (j = 0; j < this.schema().schema.fields.length; j++) {
					if (this.schema().schema.fields[j].name === fields[i].fieldName) {
						isInvalid = false;
						break;
					}
				}
				if (isInvalid) {
					//A.T. 18 Jan 2011 - fix for bug 62406 - filtering expression string fallback scenario should return an error
					throw new Error($.ig.DataSourceLocale.locale.fieldMismatch + fields[i].fieldName);
				}
				isInvalid = true;
				if (tmp2[0] === ">") {
					fields[i].cond = "greaterThan";
				} else if (tmp2[0] === "LIKE") {
					if (fields[i].expr.startsWith("%") && fields[i].expr.endsWith("%")) {
						fields[i].cond = "contains";
					} else if (fields[i].expr.endsWith("%")) {
						fields[i].cond = "startsWith";
					} else if (fields[i].expr.startsWith("%")) {
						fields[i].cond = "endsWith";
					} else {
						fields[i].cond = "equals";
					}
					//A.T. 18 Jan 2011 - Fix for bug #62355 the LIKE operator does not work as substitute for the Contains local filtering condition
					fields[i].expr = fields[i].expr.replace(/%/g, '');
				} else if (tmp2[0] === "NOT LIKE" || tmp2[0] === "NOT") {

					if (fields[i].expr.startsWith("%") && fields[i].expr.endsWith("%")) {
						fields[i].cond = "doesNotContain";
						//} else if (fields[i].expr.endsWith("%")) {
						//	fields[i].cond = "startsWith";
						//} else if (fields[i].expr.startsWith("%")) {
						//	fields[i].cond = "endsWith";
					} else {
						fields[i].cond = "doesNotEqual";
					}
					fields[i].expr = fields[i].expr.replace(/%/g, '');
				} else if (tmp2[0] === "=") {
					fields[i].cond = "equals";
				} else if (tmp2[0] === "<>") {
					fields[i].cond = "doesNotEqual";
				} else if (tmp2[0] === "<") {
					fields[i].cond = "lessThan";
				} else if (tmp2[0] === "<=") {
					fields[i].cond = "lessThanOrEqualTo";
				} else if (tmp2[0] === ">=") {
					fields[i].cond = "greaterThanOrEqualTo";
				} else {
					//A.T. 18 Jan 2011 - fix for bug 62406 - filtering expression string fallback scenario should return an error
					throw new Error($.ig.DataSourceLocale.locale.unrecognizedCondition + expr);
					// fallback
					//fields[i].cond = "Contains";
				}
			}
			return fields;
		},
		// think about passing the type directly as parameter, to avoid performance parsing overhead 
		_findMatch: function (val, expr, t, ignoreCase, cond, preciseDateFormat) {
			// if the filter condition is one of the below ones, we do not require a filter expression to be set
			var tmpExpr, exprNotReq = cond === "false" || cond === "true" ||
				cond === "today" ||
				cond === "yesterday" || cond === "thisMonth" ||
				cond === "lastMonth" || cond === "nextMonth" ||
				cond === "thisYear" || cond === "lastYear" ||
				cond === "nextYear" || cond === "null" ||
				cond === "notNull" || cond === "empty" ||
				cond === "notEmpty";
			// no filter, therefore everything matches OK 
			if (expr === "" && !exprNotReq) {
				return true;
			}
			tmpExpr = $.trim(expr);
			//if (t === null || t === undefined) {
			//	t = $.type(expr);
			//}
			if (t === "regexp" || (t === "string" && tmpExpr.startsWith("/") && tmpExpr.endsWith("/"))) {
				if (t === "regexp") {
					return this._findRegExpMatch(val, expr, false);
				}
				return this._findRegExpMatch(val, tmpExpr.substring(1, tmpExpr.length - 1), true);
			}
			if (($.type(val) === "date" && (t === undefined || t === null)) || t === "date") {
				// parse expr
				try {
					expr = this._parser.toDate(expr);
				} catch (ignore) {
					// log error that expr could not be converted 
				}
				return this._findDateMatch(val, expr, cond, preciseDateFormat);
			}
			if (($.type(val) === "boolean" && (t === undefined || t === null)) || (t === "boolean" || t === "bool")) {
				return this._findBoolMatch(val, cond);
			}
			if (($.type(val) === "number" && (t === undefined || t === null)) || t === "number") {
				return this._findNumericMatch(val, expr, cond);
			}
			return this._findStringMatch(val, expr, ignoreCase, cond);
		},
		_findStringMatch: function (val, expr, ignoreCase, cond) {
			var localVal;
			if (val !== null && val !== undefined) {
                // M.H. 16 Jan 2014 Fix for bug #161880: When localSchemaTransform is false and column data Type is not set filtering throws error when used data record value different from string
				localVal = ignoreCase ? val.toString().toLowerCase() : val || "";
			} else {
				localVal = val;
			}
			if (expr !== null && expr !== undefined) {
				// VS 09/15/2012 Bug 120973 val can be null and type-detection in _findMatch fails
				expr = ignoreCase ? expr.toString().toLowerCase() : expr.toString();
			}
			// check if expr is a regular expression
			if (cond === "startsWith") {
				return localVal !== null && localVal !== undefined && localVal.startsWith(expr);
			}
			if (cond === "endsWith") {
				return localVal !== null && localVal !== undefined && localVal.endsWith(expr);
			}
			if (cond === "contains") {
				return localVal !== null && localVal !== undefined && localVal.indexOf(expr) !== -1;
			}
			if (cond === "doesNotContain") {
				return localVal !== null && localVal !== undefined && localVal.indexOf(expr) === -1;
			}
			if (cond === "equals") {
				return localVal !== null && localVal !== undefined && localVal === expr;
			}
			if (cond === "doesNotEqual") {
				return localVal !== null && localVal !== undefined && localVal !== expr;
			}
			if (cond === "null") {
				return localVal === null;
			}
			if (cond === "notNull") {
				return localVal !== null;
			}
			if (cond === "empty") {
				return localVal === null || localVal === undefined || localVal.length === 0;
			}
			if (cond === "notEmpty") {
				return localVal === null || localVal === undefined || localVal.length !== 0;
			}
			throw new Error($.ig.DataSourceLocale.locale.errorUnrecognizedFilterCondition + cond);
			//return false;
		},
		_findRegExpMatch: function (val, expr, str) {
			if (str) {
				return (new RegExp(expr)).test(val);
			}
			return val.match(expr);
		},
		// Equals, DoesNotEqual, GreaterThan, LessThan, GreaterThanOrEqualTo, LEssThanOrEqualTo
		_findNumericMatch: function (val, expr, cond) {
			// if expr is not numeric, convert it
			if ($.type(expr) !== "number") {
				expr = this._parser.toNumber(expr);
			}
			if (cond === "equals") {
				return val === expr;
			}
			if (cond === "doesNotEqual") {
				return val !== expr;
			}
			if (cond === "greaterThan") {
				return val > expr;
			}
			if (cond === "lessThan") {
				return val < expr;
			}
			if (cond === "greaterThanOrEqualTo") {
				return val >= expr;
			}
			if (cond === "lessThanOrEqualTo") {
				return val <= expr;
			}
			if (cond === "null") {
				return val === null;
			}
			if (cond === "notNull") {
				return val !== null;
				// A.T. 14 Feb 2011 - Fix for bug #64156
			}
			if (cond === "empty") {
				return (val === null || val === undefined || isNaN(val));
			}
			if (cond === "notEmpty") {
				return (val !== null && val !== undefined && !isNaN(val));
			}
			throw new Error($.ig.DataSourceLocale.locale.errorUnrecognizedFilterCondition + cond);
		},
		// True or False
		_findBoolMatch: function (val, cond) {
			if (cond === "true") {
				return val;
			}
			if (cond === "false") {
				return !val;
			}
			if (cond === "null") {
				return val === null;
			}
			if (cond === "notNull") {
				return val !== null;
			}
			if (cond === "empty") {
				return (val === null || val === undefined);
			}
			if (cond === "notEmpty") {
				return (val !== null && val !== undefined);
			}
			throw new Error($.ig.DataSourceLocale.locale.errorUnrecognizedFilterCondition + cond);
		},
		// Equals, DoesNotEqual, Before, After, Today, Yesterday, ThisMonth, LastMonth, NextMonth, ThisYear, LastYear, NextYear, ThisQuarter, LastQuarter, NextQuarter
		// the expected types are both Date for both val and expr.
		_findDateMatch: function (val, expr, cond, preciseDateFormat) {
			var day1, mins1, hs1, yrs1, day2, mins2, hs2, yrs2, month1, month2, eq, cur,
				yrs3, month3, mday1, mday2, mday3, yesterday, onEq;
			// 1. get the "expr" date and divide it into year, month, quarter, day, week, etc.
			if (val !== null && val !== undefined) {
				day1 = val.getDay();
				mday1 = val.getDate();
				mins1 = val.getMinutes();
				hs1 = val.getHours();
				yrs1 = val.getYear();
				month1 = val.getMonth();
				//w1 = val.getWeek();
			}
			if ($.type(expr) === "date") {
				day2 = expr.getDay();
				mday2 = expr.getDate();
				mins2 = expr.getMinutes();
				hs2 = expr.getHours();
				yrs2 = expr.getYear();
				month2 = expr.getMonth();
			} else {
				expr = new Date(expr);
			}
			// current time
			cur = new Date();
			yesterday = new Date(cur.getTime());
			yesterday.setDate(yesterday.getDate() - 1);
			mday3 = cur.getDate();
			yrs3 = cur.getYear();
			month3 = cur.getMonth();
			eq = day1 === day2 && mins1 === mins2 && hs1 === hs2 && yrs1 === yrs2 && month1 === month2;
			// now compare
			if (cond === "equals") {
				return eq;
			}
			if (cond === "doesNotEqual") {
				return !eq;
			}
			if (cond === "before") {
				return val < expr;
			}
			if (cond === "after") {
				return val > expr;
			}
			if (cond === "today") {
				return mday1 === mday3 && month1 === month3 && yrs1 === yrs3;
			}
			if (cond === "yesterday") {
				// L.A. 29 January 2013 - Fixing bug #131649
				// Filtering condition yesterday is not working correctly
				// handle month and year boundaries 
				return yesterday.getDay() === val.getDay() && yesterday.getMonth() === val.getMonth() && yesterday.getFullYear() === val.getFullYear();
			}
			if (cond === "thisMonth") {
				return month1 === month3 && yrs1 === yrs3;
			}
			if (cond === "lastMonth") {
				//A.T. 18 Jan 2011 - Fix for bug #62354 - igDataSource LastMonth and NextMonth local filtering doesn't work properly
				// first month of the year special case
				if (month3 === 0) {
					return month1 === 11 && yrs1 === yrs3 - 1;
				}
				return month1 === month3 - 1 && yrs1 === yrs3;
			}
			if (cond === "nextMonth") {
				//A.T. 18 Jan 2011 - Fix for bug #62354 - igDataSource LastMonth and NextMonth local filtering doesn't work properly
				// last month of the year special case
				if (month3 === 11) {
					return month1 === 0 && yrs1 === yrs3 + 1;
				}
				return month1 === month3 + 1 && yrs1 === yrs3;
			}
			if (cond === "thisYear") {
				return yrs1 === yrs3;
			}
			if (cond === "lastYear") {
				return yrs1 === yrs3 - 1;
			}
			if (cond === "nextYear") {
				return yrs1 === yrs3 + 1;
			}
			if (cond === "on" || cond === "notOn") {
				onEq = (yrs1 === yrs2 && month1 === month2 && mday1 === mday2);
				if (preciseDateFormat) {
					// test minutes
					if (preciseDateFormat.indexOf('m') >= 0) {
						onEq = onEq && (mins1 === mins2);
					}
					if (preciseDateFormat.indexOf('h') >= 0 || preciseDateFormat.indexOf('H') >= 0) {
						onEq = onEq && (hs1 === hs2);
					}
					if (preciseDateFormat.indexOf('s') >= 0) {
						onEq = onEq && (val.getSeconds() === expr.getSeconds());
					}
					if (preciseDateFormat.indexOf('f') >= 0) {
						onEq = onEq && (val.getMilliseconds() === expr.getMilliseconds());
					}
				}
				if (cond === "on") {
					return onEq;
				}
				return !onEq;
			}
			if (cond === "null") {
				return val === null;
			}
			if (cond === "notNull") {
				return val !== null;
				// A.T. 14 Feb 2011 - fix for bug #64465
			}
			if (cond === "empty") {
				return (val === null || val === undefined);
			}
			if (cond === "notEmpty") {
				return (val !== null && val !== undefined);
			}
			throw new Error($.ig.DataSourceLocale.locale.errorUnrecognizedFilterCondition + cond);
		},
		/*
		clearFilter: function (fields) {
		// clears the filters, and rebinds the data so that there is no filtering applied on the dataView instance
		return this; // preserve chaining 
		},
		clearFilters: function () {	
		// clears all filters
		},
		*/
		// return 1 even if records count is 0.
		totalRecordsCount: function (count, key, dsObj, context) {
			/* Applicable only when the data source is bound to remote data. Gets / sets the total number of records in the data source. If data binding is remote, and there's paging or filtering enabled, the actual total number of records may not 
			match the number of records that exists on the client 
			paramType="number" optional="true" the total number of records 
			*/
			var rec, totalRecPath, i;
			if (context !== undefined && context !== null) {
				if (key) {
					rec = dsObj;
					if (rec.hasOwnProperty(key)) {
						rec = rec[key];
					} else {
						totalRecPath = key.split(".");
						for (i = 0; i < totalRecPath.length; i++) {
							rec = rec[totalRecPath[i]];
						}
					}
					if (dsObj && rec !== undefined && rec !== null) {
						if ($.type(rec) === "number") {
							this._recCount = rec;
						} else {
							// try parse
							this._recCount = parseInt(rec, 10);
						}
						this.hasTotalRecordsCount(true);
					} else {
						this.hasTotalRecordsCount(false);
					}
				} else {
					this.hasTotalRecordsCount(false);
				}
			} else if (count !== undefined && count !== null) {
				this._recCount = count;
			}
			return this._recCount;
		},
		hasTotalRecordsCount: function (hasCount) {
			/* gets / sets if the response from the server contains a property which specifies the total number of records in the server-side backend 
			paramType="bool" specifies if the data source contains a property that denotes the total number of records in the server-side backend
			*/
			if (hasCount === undefined || hasCount === null) {
				return this._hasCount;
			}
			this._hasCount = hasCount;
		},
		metadata: function (key) {
			/* returns metadata object for the specified key
			paramType="string" Primary key of the record
			returnType="object" metadata object
			*/

			// M.H. 24 Nov. 2011 Fix for bug 96603 - when metadata is undefined or null it should be returned otherwise it will be returned js error
			if (key === null || key === undefined || key === '' ||
					this._metadata === null || this._metadata === undefined) {
				return this._metadata;
			}

			return this._metadata[key];
		},
		totalLocalRecordsCount: function () {
			/* returns the total number of records in the local data source
			returnType="number" the number of records that are bound / exist locally 
			*/
			if (!this._filter) {
				return this._data.length;
			}
			return this._dataView.length;
		},
		pageCount: function () {
			/* returns the total number of pages 
			returnType="number" total number fo pages
			*/
			var c, realCount;
			if (!this._filter) {
				realCount = this.totalRecordsCount() > 0 ? this.totalRecordsCount() : this._data.length;
			} else {
				realCount = this.totalRecordsCount() > 0 ? this.totalRecordsCount() : this._filteredData.length;
			}
			c = Math.ceil(realCount / this.settings.paging.pageSize);
			return c === 0 ? 1 : c;
		},
		pageIndex: function (index) {
			/* gets /sets the current page index. If an index is passed as a parameter, the data source is re-bound. 
			paramType="number" optional="true" the page index. If none is specified, returns the current page index.
			returnType="number" the current page index 
			
			*/
			if (index === undefined || index === null) {
				//return this._pageIndex;
				return this.settings.paging.pageIndex === undefined ? 0 : this.settings.paging.pageIndex;
			}
			//this._pageIndex = index;
			// A.T. 18 Jan 2011 - Fix for bug #63149 - igDataSource - page content is erratic after changing page size
			this.settings.paging.pageIndex = parseInt(index, 10);
			this._cachedDataView = null;
			if (this.settings.paging.type === "local") {
				this._page(this.settings.paging.appendPage);
				this._invokeCallback();
			} else {
				this.dataBind();
			}
			return this;
		},
		// utility paging functions
		prevPage: function () {
			/* sets the page index to be equal to the previous page index and rebinds the data source */
			this.pageIndex(this.pageIndex() === 0 ? 0 : this.pageIndex() - 1);
			return this;
		},
		nextPage: function () {
			/* sets the page index to be equal to the next page index and rebinds the data source */
			if (this.pageIndex() >= this.pageCount() - 1) {
				return this;
			}
			this.pageIndex(this.pageIndex() + 1);
			return this;
		},
		pageSize: function (s) {
			/* gets /sets the page size and rebinds the data source if a parameter is specified. If no parameter is passed, returns the current page size
			paramType="number" optional="true" the page size. 
			*/
			if (s === undefined || s === null) {
				return this.settings.paging.pageSize;
			}
			// A.T. 18 Jan 2011 - Fix for bug #63149 - igDataSource - page content is erratic after changing page size
			this.settings.paging.pageSize = parseInt(s, 10);
			if (this.settings.paging.appendPage) {
				this.settings.paging.pageIndex = 0;
				this._cachedDataView = null;
			}
			if (this.settings.paging.type === "local") {
				this._page();
				this._invokeCallback();
			} else {
				this.dataBind();
			}
			return this;
		},
		pageSizeDirty: function (dirty) {
			/* for internal use
			paramType="object" excluded="true" 
			*/
			if (dirty === undefined || dirty === null) {
				return this._dirty;
			}
			this._dirty = dirty;
		},
		recordsForPage: function (p) {
			/* returns a list of records for the specified page. Implies that paging is enabled. 
			paramType="number" optional="false" the page index for which records will be returned 
			
			*/
			var d = [], si, ps, ei, i, c = 0;
			ps = this.pageSize();
			si = p * ps;
			ei = si + ps >= this._data.length ? this._data.length : si + ps;
			for (i = si; i < ei; i++) {
				d[c++] = this._data[i];
			}
			return d;
		},
		tableToObject: function (tableDOM) {
			/* converts a HTML TABLE dom element to a JavaScript array of objects that contain the records data 
			paramType="dom" TABLE dom element to transform
			returnType="object" 
			*/
			try {
				// no schema, just parse the table and store t in arrays
				var rows = $(tableDOM).children("tbody").children(), len, data, i, j;
				len = rows.length > 0 ? rows[0].cells.length : 0;
				data = [];
				for (i = 0; i < rows.length; i++) {
					data[i] = [];
					for (j = 0; j < len; j++) {
						data[i][j] = rows[i].cells[j].innerHTML;
					}
				}
				return data;
			} catch (e) {
				throw new Error($.ig.DataSourceLocale.locale.errorParsingHtmlTableNoSchema + e.message);
			}
		},
		_validateTable: function (obj) {
			if (obj.length === 0) {
				throw new Error($.ig.DataSourceLocale.locale.errorTableWithIdNotFound + this.dataSource());
			} else {
				return obj[0];
			}
		},
		stringToJSONObject: function (s) {
			/* parses the string and returns an evaluated JSON object
			paramType="string" the JSON as string. 
			*/
			var data = {};
			try {
				//data = eval(s);
				//A.T. 20 Jan 2011 Fix for bug #62124 - igDataSource JSON string binding error
				data = JSON.parse(s);
			} catch (e) {
				throw new Error($.ig.DataSourceLocale.locale.errorParsingJsonNoSchema + e.message);
			}
			return data;
		},
		stringToXmlObject: function (s) {
			/* parses a string and returns a XML Document 
			paramType="string" the XML represented as a string
			*/
			var doc, parser;
			try {
				if (window.ActiveXObject) {
					doc = new ActiveXObject('Microsoft.XMLDOM');
					doc.async = 'false';
					doc.loadXML(s);
				} else {
					parser = new DOMParser();
					doc = parser.parseFromString(s, 'text/xml');
				}
			} catch (e) {
				throw new Error($.ig.DataSourceLocale.locale.errorParsingXmlNoSchema + e.message);
			}
			return doc;
		}
		// this function is not currently used
		/*
		_filterData: function (data) {
		
		if (this.settings.pageSize > 0)
		{
		var filteredData = [], count = 0, i = 0;
		for (i = this._pageIndex * this.settings.pageSize; i < this._pageIndex * this.settings.pageSize + this.settings.pageSize; i++) {
		filteredData[count++] = data[i];
		}
		return filteredData;
		}
		return data;
		}
		*/
	});
	$.ig.TypeParser = $.ig.TypeParser || Class.extend({
		toStr: function (obj) {
			return this.isNullOrUndefined(obj) ? "" : obj + this.empty();
		},
		toDate: function (obj, pk, key) {
            // L.A. 18 June 2012 Fixing bug #113265 Column 'date' shows empty values as 'NaN'
			if (this.isNullOrUndefined(obj) || obj === '' || $.type(obj) === 'function') {
				return null;
			}
			if ($.type(obj) === 'date') {
				return obj;
			}
			var d;
			// OData & MS
			if (obj.length && obj.indexOf('/Date(') !== -1) {
				/*
				// account for timezone offset
				if (this._tzo === undefined) {
					this._tzo = new Date().getTimezoneOffset() * 60000;
				}
				if (this._dst === undefined) {
					this._dst = new Date().dst();
					if (this._dst) {
						this._tzo = new Date().stdTimezoneOffset() * 60000;
					}
				}
				*/
				// we need to get the local daylight offset on the client
				if (this._serverOffsets === undefined || this._serverOffsets[pk] === undefined) {
					return new Date(parseInt(obj.replace('/Date(', '').replace(')/', ''), 10)  + this._serverOffset);
				}
				if (this._serverOffsets[pk][key] !== undefined && this._serverOffsets[pk][key] !== null) {
					return new Date(parseInt(obj.replace('/Date(', '').replace(')/', ''), 10)  + this._serverOffsets[pk][key]);
				}
				return new Date(parseInt(obj.replace('/Date(', '').replace(')/', ''), 10));
			}
			d = new Date(obj);
			// M.H. 14 Apr 2014 Fix for bug #169770: Column dataType "date" format appear as NaN-NaN-NaN in IE8
			if (isNaN(d)) {
				d = $.ig.util.dateFromISO(obj);
			}
			return d;
		},
		toNumber: function (obj) {
			return (this.isNullOrUndefined(obj) || $.type(obj) === 'function') ? null : obj * this.num();
		},
		toBool: function (obj) {
            // M.H. 25 Jul 2013 Fix for bug #144944: Error gets thrown during data transformation of the values for an unbound column
            var typeObj = $.type(obj);
			if (typeObj === 'boolean') {
				return obj;
			}
			if (this.isNullOrUndefined(obj) || typeObj === 'function') {
				return false;
			}
            // M.H. 25 Jul 2013 Fix for bug #144944: Error gets thrown during data transformation of the values for an unbound column
			if (obj === "1" || obj === 1 || (typeObj === 'string' && obj.toLowerCase() === "true")) {
				return true;
			}
			return false;
		},
		isNullOrUndefined: function (obj) {
			return obj === null || obj === undefined;
		},
		empty: function () {
			return "";
		},
		num: function () {
			return 1;
		}
	});
	/* the $.ig.DataSchema handles transformations for Array, JSON and Xml data objects.
	if your data is in any other format and/or needs to be additionally worked on, please pass it through $.ig.DataSource first
	Eg: when you need to fetch the data remotely, or when it is stored in a string and needs to be evaluated first 
	*/
	$.ig.DataSchema = $.ig.DataSchema || Class.extend({
		/* The $.ig.DataSchema handles transformations for Array, JSON and Xml data objects.
		If your data is in any other format and/or needs to be additionally worked on, please pass it through $.ig.DataSource first.
		Eg: When you need to fetch the data remotely, or when it is stored in a string and needs to be evaluated first 
		*/
		schema: {
			/* type="array" A list of field definitions specifying the schema of the data source. Field objects description: {fieldName, [fieldDataType], [fieldXPath]} */
			fields: [
			],
			/* type="string" this is the property (path) in the data source where the records are located. */
			searchField: null,
			/* type="string" this is the property in the resulting object where actual resulting records will be put. (So the result will not be array but an object if this is defined), after the potential data source transformation */
			outputResultsName: null
		},
		init: function (type, options) {
			if (options) {
				this.schema = $.extend(true, {}, $.ig.DataSchema.prototype.schema, options);
			}
			this._type = type;
			this._parser = new $.ig.TypeParser();
			this._parser._serverOffset = 0;
		},
		transform: function (data) {
			/* performs a transformation on the schema so that the resulting data matches the schema 
			paramType="object" the data to transform
			returnType="object" the transformed data
			*/
			var ndata = []; // the resulting normalized data 
			// transform data according to the fields
			switch (this._type) {
			case "array":
				ndata = this._arrays(data);
				break;
			case "json":
				ndata = this._json(data);
				break;
			case "xml":
				ndata = this._xml(data);
				break;
			case "htmlTableDom":
				ndata = this._table(data);
				break;
			case "htmlListDom":
				ndata = this._list(data);
				break;
			default:
				throw new Error('unknown data source type: ' + this._type);
				//break;
			}
			return ndata;
		},
		_setResKey: function (resKey, out) {
			if (!this.isEmpty(resKey)) {
				out[resKey] = []; // was {}
				return out[resKey];
			}
			return out;
		},
		_convertType: function (t, obj, pk, key) {
			if (t === "string") {
				return this._parser.toStr(obj);
			}
			if (t === "date") {
				return this._parser.toDate(obj, pk, key);
			}
			if (t === "number") {
				return this._parser.toNumber(obj);
			}
			if (t === "boolean" || t === "bool") {
				return this._parser.toBool(obj);
			}
			// no type conversion / unknown type
			return obj;
		},
		//_val: function (field, val, results, i, j, rec) {
		_val: function (field, val, results, i, rec) {
			// return this to the state before 28 Nov
			var t = field.type, j = null;
			if (!this.isEmpty(t)) {
				if (this.isEmpty(field.name)) {
					results[i][j] = this._convertType(t, val, this._pk ? results[i][this._pk] : i, field.name);
				} else {
					results[i][field.name] = this._convertType(t, val, this._pk ? results[i][this._pk] : i, field.name);
				}
			} else {
				if (this.isEmpty(field.name)) {
					//results[i][j] = val;
					if (rec) {
						results[i][j] = rec[i][j];
					} else {
						results[i][j] = val;
					}
				} else {
					//results[i][field.name] = val;
					if (rec) {
						// we must copy the whole object refrence, in order to get "by reference" types. 
						results[i][field.name] = rec[i][field.name];
					} else {
						results[i][field.name] = val;
					}
				}
			}
		},
		isEmpty: function (o) {
			/* specifies if the object is null, undefined, or an empty string 
			paramType="object" the object to check for being empty
			returnType="boolean"
			*/
			return o === undefined || o === null || o === "";
		},
		_arrays: function (data) {
			var i, j, tmp, hasArrays, resKey = this.schema.outputResultsName, out = {}, results;
			// optionally, a developer may decide to set all contents directly in the output object 
			results = this._setResKey(resKey, out);
			// object is empty and is not an array
			if (this.isObjEmpty(results) && $.type(results) !== "array") {
				results = [];
				out = results;
			}
			try {
				//A.T. 12 July 2011
				/*
				if (!this.isEmpty(this.schema.searchField)) {
				//data = eval("data." + this.schema.searchField);
				path = this.schema.searchField.split(".");
				if (path.length > 0) {
				for (i = 0; i < path.length; i++) {
				data = data[path[i]];
				}
				}
				}
				*/

				if (data.length > 0) {
					hasArrays = $.type(data[0]) === 'array';
				}
				for (i = 0; i < data.length; i++) {
                    // L.A. 23 May 2012 - Fixed bug #112518 The grid cannot bind to an associative JavaScript array (which has one or more undefined items)
                    if (data[i] === undefined) {
                        continue;
                    }
					results.push({});
					for (j = 0; j < this.schema.fields.length; j++) {
						if (hasArrays) {
							tmp = data[i][j];
						} else {
							tmp = data[i][this.schema.fields[j].name];
						}
                        // L.A. 23 May 2012 - Fixed bug #112518 The grid cannot bind to an associative JavaScript array (which has one or more undefined items)
						this._val(this.schema.fields[j], tmp, results, results.length - 1);
					}
				}
			} catch (e) {
				throw new Error($.ig.DataSourceLocale.locale.errorParsingArrays + e.message);
			}
			return out;
		},
		// the data that comes is expected to be already evaluated 
		_json: function (data) {
		    var i, j, root, resKey = this.schema.outputResultsName, out = {}, results, searchPath, token;
			// optionally, a developer may decide to set all contents directly in the output object 
			results = this._setResKey(resKey, out);
			if (this.isObjEmpty(results)) {
				results = [];
				out = results;
			}
			try {
				if (data.Metadata && data.Metadata.timezoneOffset !== undefined && !isNaN(data.Metadata.timezoneOffset)) {
					this._serverOffset = data.Metadata.timezoneOffset;
					this._parser._serverOffset = this._serverOffset;
					// we need the offsets for every particular date
					if (data.Metadata.timezoneOffsets) {
						this._serverOffsets = data.Metadata.timezoneOffsets;
						this._parser._serverOffsets = data.Metadata.timezoneOffsets;
					}
				} else {
					this._parser._serverOffset = 0;
				}
				// find the object holding the data
				if (!this.isEmpty(this.schema.searchField)) {
					// we are splitting the string path by '[' , ']' and '.' which should give us the path parameters
					searchPath = this.schema.searchField.split(/[\[.\]]/);
					for (i = 0; i < searchPath.length; i++) {
						token = searchPath[i];
						if (token.length === 0) {
							continue;
						}
						// integer properties should be handled as indexes in an array
						// otherwise we have to trim the string from ' and " chars
						token = /^(0|[1-9]\d*)$/.test(token) ? parseInt(token, 10) : token.replace(/^('|")|('|")$/g, "");
						root = root ? root[token] : data[token];
						if (root === undefined || root === null) {
							break;
						}
					}
					// L.A. 14 January 2013 - Fixing bug #130634 - JS errors when having a second child layout and using knockout.
					if (!root && $.type(data) === "array") {
						root = data;
					}
				}
				// L.A. 02 October 2012 - Fixing bug #123398 
				// [Hierarchical Grid Knockoutjs Integration] Expanding a row in the hierarchical grid causes a JS error
				if (root === undefined || this.isEmpty(this.schema.searchField)) {
					root = data;
				}
				if (!root.length && $.type(root) === "object") {
					root = [root];
				}
				// traverse root
				if (root && root.length && root.length > 0) {
					for (i = 0; i < root.length; i++) {
						results[i] = {};
						// always process pk first
						if (this._pk && this._pk !== "ig_pk") {
							for (j = 0; j < this.schema.fields.length; j++) {
								if (this.schema.fields[j].name === this._pk) {
									break;
								}
							}
							if (j < this.schema.fields.length) { // if defined in the schema
								if (root[i][this._pk] === undefined) {
									// the input data doesn't match the schema
									throw new Error($.ig.DataSourceLocale.locale.errorSchemaMismatch + this._pk);
								}
								this._val(this.schema.fields[j], root[i][this.schema.fields[j].name], results, i, root);
							}
						}
						for (j = 0; j < this.schema.fields.length; j++) {
							if (this.schema.fields[j].name !== "ig_pk" && this.schema.fields[j].name !== this._pk) {
								if (root[i][this.schema.fields[j].name] === undefined) {
									// the input data doesn't match the schema
									throw new Error($.ig.DataSourceLocale.locale.errorSchemaMismatch + this.schema.fields[j].name);
								}
								this._val(this.schema.fields[j], root[i][this.schema.fields[j].name], results, i, root);
							}
						}
					}
				}
			} catch (e) {
				throw new Error($.ig.DataSourceLocale.locale.errorParsingJson + e.message);
			}
			return out;
		},
		// the data that comes is already expected to be a parsed XML document object 
		_xml: function (data, recursiveSF) {
			var i, j, root, resNode, item, resKey = this.schema.outputResultsName, out = {}, results, namespaced, sf, k, r, rc,
				len1, len2, o, carrysf, ireal = 0, s;
			o = window.ActiveXObject;
			// optionally, a developer may decide to set all contents directly in the output object 
			results = this._setResKey(resKey, out);
			if (this.isObjEmpty(results)) {
				results = [];
				out = results;
			}
			try {
				// find the searchField, if set
				// data is assumed to be a XML document 
				if (!this.isEmpty(this.schema.searchField)) {

					// it makes a big difference if the XML has namespace declarations (xmlns) or not
					// in the first case, we cannot use XPath expressions reliably directly, because 
					// they won't return any matches. Therefore if the XML is namespaced, we are going to 
					// manually traverse it and find matches by parsing the xpath expression (search field)
					// which will also sacrifice performance a bit
					namespaced = this._xmlHasNamespaces(data);
					if (!namespaced) {
						if (window.ActiveXObject === undefined) {
							if (!recursiveSF || recursiveSF.length <= 0) {
								root = data.evaluate(this.schema.searchField, data, null, XPathResult.ANY_TYPE, null);
							} else {
								root = data.evaluate(recursiveSF, data, null, XPathResult.ANY_TYPE, null);
							}
						} else {
							// M.H. 12 Mar 2013 Fix for bug #135224: [igDataSource] Exception is thrown  when opening Stock Quotes sample in IE10
							if (!(data instanceof ActiveXObject)) {
								s = new XMLSerializer().serializeToString(data);
								data = new window.ActiveXObject("Microsoft.XMLDOM");
								data.async = false;
								data.loadXML(s);
							}
							root = data.selectNodes(this.schema.searchField);
						}
					} else {
						// find the elements list manually
						if (this.schema.searchField.startsWith("//")) {
							sf = this.schema.searchField.substring(2, this.schema.searchField.length);
						} else {
							sf = this.schema.searchField;
						}
						// find *the first* instance, and assume it's parent will hold them all ! 
						root = this._findXmlRecordsRoot(data, sf);
					}
				} else {
					root = data;
				}
				// IEs
				if (!namespaced) {
					if (root && window.ActiveXObject !== undefined) {
						for (i = 0; i < root.length; i++) {
							item = root.item(i);
							results[i] = {};
							for (j = 0; j < this.schema.fields.length; j++) {
								// evaluate the xpath for the field, for the current item, if it is present
								resNode = item.selectSingleNode(this.schema.fields[j].xpath);
								if (resNode) {
									// If the node is an element then recursively go through the elements
									if (resNode.nodeType === 1 && this.schema.childDataProperty && resNode.nodeName === this.schema.childDataProperty) {
										this.schema.searchField = this.schema.childDataProperty;
										results[i][resNode.nodeName] = this._xml(item);
									} else {
										this._val(this.schema.fields[j], resNode.text, results, i);
									}
								} else {
									results[i][this.schema.fields[j].name] = "";
								}
							}
						}
					} else if (root) { // FF, Opera, Safari, Chrome etc. 
						i = 0;
						item = root.iterateNext();
						while (item) {
							results[i] = {};
							for (j = 0; j < this.schema.fields.length; j++) {
								// evaluate the xpath for the field, for the current item, if it is present
								resNode = data.evaluate(this.schema.fields[j].xpath, item, null, XPathResult.ANY_TYPE, null).iterateNext();
								if (resNode) {
									// If the node is an element then recursively go through the elements
									if (resNode.nodeType === 1 && this.schema.childDataProperty && (resNode.nodeName === this.schema.childDataProperty || resNode.nodeName === this.schema.seachField)) {
										if (!recursiveSF || recursiveSF.length <= 0) {
											carrysf = this.schema.searchField + '[' + (i + 1) + ']/' + this.schema.childDataProperty;
										} else {
											carrysf = recursiveSF + '[' + (i + 1) + ']/' + this.schema.childDataProperty;
										}
										results[i][this.schema.childDataProperty] = this._xml(data, carrysf);
									} else {
										this._val(this.schema.fields[j], resNode.textContent, results, i);
									}
								} else {
									results[i][this.schema.fields[j].name] = "";
								}
							}
							i++;
							item = root.iterateNext();
						}
					}
				} else {
					// list a list of records accessible by the childNodes prop
					len1 = root.childNodes.length;
					ireal = 0;
					for (i = 0; i < len1; i++) {
						r = root.childNodes[i];
						results.push({});
						for (j = 0; j < this.schema.fields.length; j++) {
							// think about how to optimize this, like that it could be awfully slow for bigger data sets ... 
							len2 = r.childNodes.length;
							for (k = 0; k < len2; k++) {
								rc = r.childNodes[k];
								if (this.schema.fields[j].name === (o === undefined ? rc.localName : rc.baseName)) {
									this._val(this.schema.fields[j], o === undefined ? rc.textContent : rc.text, results, ireal);
									break;
								}
							}
						}
						// check for empty object
						if ($.isEmptyObject(results[ireal])) {
							results.pop();
						} else {
							ireal++;
						}
					}
				}
			} catch (e) {
				throw new Error($.ig.DataSourceLocale.locale.errorParsingXml + e.message);
			}
			return out;
		},
		// recursively find the parent root record holding the children
		_findXmlRecordsRoot: function (data, field) {
			var i, len, r, o, ret;
			o = window.ActiveXObject;
			if ((o === undefined ? data.localName : data.baseName) === field) {
				ret = data.parentNode;
			} else if (data && data.childNodes && data.childNodes.length > 0) {
				len = data.childNodes.length;
				for (i = 0; i < len; i++) {
					r = data.childNodes[i];
					//if ((o === undefined ? r.localName : r.baseName) === field) {
					//	ret = data;
					//}
					if (r.childNodes && r.childNodes.length > 0) {
						ret = this._findXmlRecordsRoot(r, field);
					}
				}
			}
			return ret;
		},
		_xmlHasNamespaces: function (data) {
			// in order not to introduce big performance hits, we are going to only to check the root elements, and the first child of the root, for 
			// "xmlns" attributes
			var i, ns, r, len, fc;
			if (data.childNodes && data.childNodes.length && data.childNodes.length > 0) {
				len = data.childNodes.length;
				for (i = 0; i < len; i++) {
					r = data.childNodes[i];
					if (!r) {
						return false;
					}
					ns = r.namespaceURI;
					if (ns !== "" && ns !== undefined && ns !== null) {
						return true;
					}
				}
				// if we still haven't found a namespace, try the first child element
				if (r && r.childNodes && r.childNodes.length > 0) {
					fc = r.childNodes[0];
					if (!fc) {
						return false;
					}
					ns = fc.namespaceURI;
					return (ns !== "" && ns !== undefined && ns !== null);
				}
			}
			return false;
		},
		_table: function (data) {
			// the assumption is that "data" contains the table DOM element. 
			var i, j, r, tbody, rows, resKey = this.schema.outputResultsName, out = {}, results;
			tbody = $(data).find("tbody")[0];

			// if there are headers, remove them. the grid will create its own. 
			// L.A. 15 August 2012 Fixing bugs #118934, #74552
			//$(data).find('thead').remove();

			// optionally, a developer may decide to set all contents directly in the output object 
			results = this._setResKey(resKey, out);
			if (this.isObjEmpty(results)) {
				results = [];
				out = results;
			}
			try {
				if (tbody && tbody.nodeName && tbody.nodeName === "TBODY") {
					rows = tbody.rows;
					for (i = 0; i < rows.length; i++) {
						r = rows[i];
						results[i] = {};
						// iterate through the fields
						for (j = 0; j < this.schema.fields.length; j++) {
							this._val(this.schema.fields[j], r.cells[j].innerHTML, results, i);
						}
					}
				} else {
					throw new Error($.ig.DataSourceLocale.locale.errorExpectedTbodyParameter);
				}
			} catch (e) {
				throw new Error($.ig.DataSourceLocale.locale.errorParsingHtmlTable + e.message);
			}
			return out;
		},
		_list: function (data) {
			var parsedData, img, anchor, id, li, ul, self = this, d = $(data), text, i, header, descriptions, counts, jqmNS = "data-";
			if ($.mobile && $.mobile.ns) {
				jqmNS += $.mobile.ns;
			}

			parsedData = [];

			// Text: text
			// Value: value
			// ImageUrl: imageUrl
			// NavigateUrl: navigateUrl
			// ChildDataProperty: childData
			// Anchor Target: target
			// H1, H2, H3, H4, H5, H6: header (taken out of text)
			// p, dd: description (taken out of text)
			// Span with ui-li-count class: count
			// li has jqm data role of list divider sets isDivider
			// Index of li will become a primary key
			// Include any additional identifiers here and before extracting them, make a check for hasOwnProperty
			if (d && (d.is('ul') || d.is('ol')) && d.children().length > 0) {
				d.children('li:not([' + jqmNS + 'role="itemTemplate"], [' + jqmNS + 'role="detailsTemplate"], [' + jqmNS + 'role="dividerTemplate"])').each(function (index) {
					li = $(this);
					img = li.children('img');
					// Init the parsed data parts
					parsedData[index] = {};
					// Parse logic
					if (self.schema.hasOwnProperty('primaryKey')) {
						self._val(self.schema.primaryKey, li.index(), parsedData, index);
					}
					if (self.schema.hasOwnProperty('isDivider')) {
						self._val(self.schema.isDivider, li.attr(jqmNS + "role") === "list-divider", parsedData, index);
					}
					if (img.length > 0 && img.attr('src')) {
						if (self.schema.hasOwnProperty('imageUrl')) {
							self._val(self.schema.imageUrl, img.attr('src'), parsedData, index);
						}
					}
					anchor = li.children('a');
					if (anchor.length > 0) {
						// K.D. February 20th, 2012 Bug #101873 Switching from extracting text only to extracting
						// all of the contents of the anchor. This feature was requested by PG.
						text = anchor.html();
						if (anchor.attr('href')) {
							if (self.schema.hasOwnProperty('navigateUrl')) {
								self._val(self.schema.navigateUrl, anchor.attr('href'), parsedData, index);
							}
						}
						if (anchor.attr('target')) {
							if (self.schema.hasOwnProperty('target')) {
								self._val(self.schema.target, anchor.attr('target'), parsedData, index);
							}
						}
						if (img.length === 0) {
							img = anchor.children('img');
							if (img.length > 0) {
								img.each(function () {
									if (this.outerHTML) {
										text = text.replace(this.outerHTML, '');
									} else {
										text = text.replace($("<div>").append(this).html(), '');
									}
								});
								/* text = text.replace($("<div>").append(img[0]).html(), ''); // remove just first image from the text */
							}
							if (img.length > 0 && img.attr('src')) {
								if (self.schema.hasOwnProperty('imageUrl')) {
									self._val(self.schema.imageUrl, img.attr('src'), parsedData, index);
								}
							}
						}
					} else {
						text = '';
						for (i = 0; i < li[0].childNodes.length; i++) {
							if (li[0].childNodes[i].nodeType === 3 && li[0].childNodes[i].data) {
								text += $.trim(li[0].childNodes[i].data);
							}
						}

					}
					if (self.schema.hasOwnProperty('header')) {
						header = li.children('h1, h2, h3, h4, h5, h6');
						if (header.length === 0 && anchor.length > 0) {
							header = anchor.children('h1, h2, h3, h4, h5, h6');
						}
						if (header.length > 0) {
							self._val(self.schema.header, header.text(), parsedData, index);
							header.each(function () {
								if (this.outerHTML) {
									text = text.replace(this.outerHTML, '');
								} else {
									text = text.replace($("<div>").append(this).html(), '');
								}
							});
						}
					}
					if (self.schema.hasOwnProperty('description')) {
						descriptions = li.children('p, dd');
						if (descriptions.length === 0 && anchor.length > 0) {
							descriptions = anchor.children('p, dd');
						}
						if (descriptions.length > 0) {
							self._val(self.schema.description, descriptions.text(), parsedData, index);
							descriptions.each(function () {
								if (this.outerHTML) {
									text = text.replace(this.outerHTML, '');
								} else {
									text = text.replace($("<div>").append(this).html(), '');
								}
							});
						}
					}
					if (self.schema.hasOwnProperty('count')) {
						counts = li.children('span.ui-li-count');
						if (counts.length === 0 && anchor.length > 0) {
							counts = anchor.children('span.ui-li-count');
						}
						if (counts.length > 0) {
							self._val(self.schema.count, parseInt(counts.text(), 10), parsedData, index);
							counts.each(function () {
								if (this.outerHTML) {
									text = text.replace(this.outerHTML, '');
								} else {
									text = text.replace($("<div>").append(this).html(), '');
								}
							});
						}
					}
					if (self.schema.hasOwnProperty('text')) {
						self._val(self.schema.text, text, parsedData, index);
					}
					id = li.attr('id');
					if (id) {
						if (self.schema.hasOwnProperty('value')) {
							self._val(self.schema.value, id, parsedData, index);
						}
					}
					ul = li.children('ul, ol');
					if (ul.length > 0) {
						if (self.schema.hasOwnProperty('childData') && self.schema.childData.hasOwnProperty('name')) {
							parsedData[index][self.schema.childData.name] = self._list(ul);
						}
					}
				});
			}
			return parsedData;
		},
		isObjEmpty: function (obj) {
			/* specifies if the object has custom properties or not 
			paramType="object" the object to check for presence or lack of custom properties
			returnType="boolean" 
			*/
			var prop;
			for (prop in obj) {
				if (obj.hasOwnProperty(prop)) {
					return false;
				}
			}
			return true;
		},
		fields: function () {
			/* type="array" A list of field definitions specifying the schema of the data source. Field objects description: {fieldName, [fieldDataType], [fieldXPath]} */
			return this.schema.fields;
		}
	});
	// Helper/wrapper classes for $.ig.DataSource 
	$.ig.RemoteDataSource = $.ig.RemoteDataSource || $.ig.DataSource.extend({
		init: function (options) {
			if (!options) {
				options = {};
			}
			options.type = "remoteUrl";
			this._super(options);
			return this;
		}
	});
	$.ig.JSONDataSource = $.ig.JSONDataSource || $.ig.DataSource.extend({
		init: function (options) {
			if (!options) {
				options = {};
			}
			options.type = "json";
			this._super(options);
			return this;
		}
	});
	$.ig.RESTDataSource = $.ig.RESTDataSource || $.ig.DataSource.extend({
		settings: {
			/* Settings related to REST compliant update routine */
			restSettings: {
				/* Settings for create requests */
				create: {
					/* type="string" specifies a remote URL to which create requests will be sent. This will be used for both batch and non-batch, however if template is also set, this URL will only be used for batch requests. */
					url: null,
					/* type="string" specifies a remote URL template. Use ${id} in place of the resource id. */
					template: null,
					/* type="bool" specifies whether create requests will be sent in batches */
					batch: false
				},
				/* Settings for update requests */
				update: {
					/* type="string" specifies a remote URL to which update requests will be sent. This will be used for both batch and non-batch, however if template is also set, this URL will only be used for batch requests. */
					url: null,
					/* type="string" specifies a remote URL template. Use ${id} in place of the resource id. */
					template: null,
					/* type="bool" specifies whether update requests will be sent in batches */
					batch: false
				},
				/* Settings for remove requests */
				remove: {
					/* type="string" specifies a remote URL to which remove requests will be sent. This will be used for both batch and non-batch, however if template is also set, this URL will only be used for batch requests. */
					url: null,
					/* type="string" specifies a remote URL template. Use ${id} in place of the resource id. */
					template: null,
					/* type="bool" specifies whether update requests will be sent in batches */
					batch: false
				},
				/* type="bool" specifies whether the ids of the removed resources are send through the request URI */
				encodeRemoveInRequestUri: true,
				/* type="function" specifies a custom function to serialize content sent to the server. It should accept a single object or an array of objects and return a string. If not specified, JSON.stringify() will be used. */
				contentSerializer: null,
				/* type="string" specifies the content type of the request */
				contentType: 'application/json; charset=utf-8'
			}
		},
		init: function (options) {
			if (!options) {
				options = {};
			}
			options.restSettings = $.extend(true, this.settings.restSettings, options.restSettings);
			this._createHttpHandlers();
			this._createLogVerbMapping();
			this._setLazyUrls();
			this._super(options);
			return this;
		},
		saveChanges: function (success, error) {
			// use $.ajax with the HTTP verb for every type of CRUD operation on the specified URL
			// for each entry in the transaction log create a new request
			// if batching is enabled create seperate arrays and send together
			var log, verb, batchOps = { "POST": [], "PUT": [], "DELETE": [], "CELL": [] }, i;
			// set new callback count
			this._asyncCallbackCount = 0;
			this._isc = success && typeof success === "function" ? success : null;
			this._iec = error && typeof error === "function" ? error : null;
			for (i = 0; i < this._accumulatedTransactionLog.length; i++) {
				log = this._accumulatedTransactionLog[i];
				verb = this._logVerbMap[log.type];
				if (log.type === "cell") {
					batchOps.CELL.push(log);
				} else if (this._isBatch(verb) === true) {
					batchOps[verb].push(log);
				} else {
					this._asyncCallbackCount++;
					this._saveSingleChange(verb, log);
				}
			}
			if (batchOps.CELL.length > 0) {
				this._saveAllCellChanges(batchOps.CELL);
			}
			if (batchOps.POST.length > 0) {
				this._asyncCallbackCount++;
				this._saveAllCreateChanges(batchOps.POST);
			}
			if (batchOps.PUT.length > 0) {
				this._asyncCallbackCount++;
				this._saveAllUpdateChanges(batchOps.PUT);
			}
			if (batchOps.DELETE.length > 0) {
				this._asyncCallbackCount++;
				this._saveAllDeleteChanges(batchOps.DELETE);
			}
		},
		_saveSingleChange: function (verb, change) {
			/* saves a single (nonbatch) transaction */
			var data, url;
			data = (verb === "POST" || verb === "PUT") ? change.row : null;
			url = this._getProperUrl(verb, false, (verb === "DELETE" || verb === "PUT") ? change.rowId : undefined);
			this._call(verb, url, data);
		},
		_saveAllCellChanges: function (cellLogs) {
			var i, combined = {}, rowLogs = [], cl;
			for (i = 0; i < cellLogs.length; i++) {
				cl = cellLogs[i];
				if (combined[cl.rowId] === undefined) {
					combined[cl.rowId] = {};
					combined[cl.rowId].row = this.findRecordByKey(cl.rowId);
				}
				combined[cl.rowId].row[cl.col] = cl.value;
			}
			// normalize
			$.each(combined, function (key, value) {
				value.rowId = key;
				rowLogs.push(value);
			});
			if (this._isBatch('PUT') === true) {
				this._asyncCallbackCount++;
				this._saveAllUpdateChanges(rowLogs);
			} else {
				for (i = 0; i < rowLogs.length; i++) {
					this._asyncCallbackCount++;
					this._saveSingleChange('PUT', rowLogs[i]);
				}
			}
		},
		_saveAllCreateChanges: function (createLogs) {
			var data = [], i;
			for (i = 0; i < createLogs.length; i++) {
				data.push(createLogs[i].row);
			}
			this._call('POST', this._getProperUrl('POST', true), data);
		},
		_saveAllUpdateChanges: function (updateLogs) {
			var data = [], urlParams = "?", i;
			for (i = 0; i < updateLogs.length; i++) {
				data.push(updateLogs[i].row);
				urlParams += "index=" + updateLogs[i].rowId + (i !== updateLogs.length - 1 ? "&" : "");
			}
			this._call('PUT', this._getProperUrl('PUT', true) + urlParams, data);
		},
		_saveAllDeleteChanges: function (deleteLogs) {
			var urlParams = "", i, data = null;
			if (this.settings.restSettings.encodeRemoveInRequestUri === true) {
				urlParams = "?";
				for (i = 0; i < deleteLogs.length; i++) {
					urlParams += "index=" + deleteLogs[i].rowId + (i !== deleteLogs.length - 1 ? "&" : "");
				}
			} else {
				data = [];
				for (i = 0; i < deleteLogs.length; i++) {
					data.push(deleteLogs[i].rowId);
				}
			}
			this._call('DELETE', this._getProperUrl('DELETE', true) + urlParams, data);
		},
		_createHttpHandlers: function () {
			// Adding only success related handlers
			//  handle errors accurately
			this._okHandler = $.proxy(this._responseOk, this);
			this._createdHandler = $.proxy(this._responseCreated, this);
			this._noContentHandler = $.proxy(this._responseNoContent, this);
			this._httpHandlers = {
				"POST": {
					"201": this._createdHandler
				},
				"PUT": {
					"200": this._okHandler,
					"201": this._createdHandler,
					"204": this._noContentHandler
				},
				"DELETE": {
					"200": this._okHandler,
					"204": this._noContentHandler
				}
			};
		},
		_createLogVerbMapping: function () {
			this._logVerbMap = {
				"newrow": "POST",
				"row": "PUT",
				"deleterow": "DELETE",
				"cell": "PUT"
			};
		},
		_setLazyUrls: function () {
			var rs = this.settings.restSettings, tempUrl = null, tempTmpl = null;
			// get a single set value
			$.each(rs, function (key, value) {
				if (value) {
					if (value.url) {
						tempUrl = value.url;
					}
					if (value.template) {
						tempTmpl = value.template;
					}
				}
			});
			// use temp value on null options
			$.each(rs, function (key, value) {
				if (value) {
					if (value.url !== undefined && value.url === null) {
						value.url = tempUrl;
					}
					if (value.template !== undefined && value.template === null) {
						value.template = tempTmpl;
					}
				}
			});
			// set private urls
			this._putUrl = rs.update.url;
			this._putTmpl = rs.update.template;
			this._postUrl = rs.create.url;
			this._postTmpl = rs.create.template;
			this._deleteUrl = rs.remove.url;
			this._deleteTmpl = rs.remove.template;
		},
		_getProperUrl: function (verb, batch, id) {
			var vL = verb.toLowerCase(), url = this["_" + vL + "Url"];
			if (url && url.length > 0 && url.substr(url.length - 1) !== "/") {
				url += "/";
			}
			if (!batch || batch === false) {
				if (this["_" + vL + "Tmpl"] !== null) {
					url = this["_" + vL + "Tmpl"];
					if (id) {
						url = url.replace("${id}", id);
					}
				} else {
					if (id) {
						url += id;
					}
				}
			}
			return url;
		},
		// All success codes are currently doing the same thing - decreasing the async callback count and checking if
		// all async operations completed. If a more sophisticated status handling is required in the future these can be
		// changed accordingly.
		_responseOk: function (data, textStatus, jqXHR) {
			this._asyncCallbackCount--;
			if (this._asyncCallbackCount === 0) {
				this._saveChangesSuccess({ Success: textStatus === "success" }, textStatus, jqXHR);
			}
		},
		_responseCreated: function (data, textStatus, jqXHR) {
			this._asyncCallbackCount--;
			if (this._asyncCallbackCount === 0) {
				this._saveChangesSuccess({ Success: textStatus === "success" }, textStatus, jqXHR);
			}
		},
		_responseNoContent: function (data, textStatus, jqXHR) {
			this._asyncCallbackCount--;
			if (this._asyncCallbackCount === 0) {
				// with jquery 1.9+ 204 No Content with empty body would return textStatus = "nocontent"
				this._saveChangesSuccess({ Success: textStatus === "success" || textStatus === "nocontent" }, textStatus, jqXHR);
			}
		},
		_isBatch: function (verb) {
			switch (verb) {
				case "POST":
					return this.settings.restSettings.create.batch;
				case "PUT":
					return this.settings.restSettings.update.batch;
				case "DELETE":
					return this.settings.restSettings.remove.batch;
				default:
					return false;
			}
		},
		_call: function (verb, url, data) {
			var dataString, ct = this.settings.restSettings.contentType, serializer = this.settings.restSettings.contentSerializer, self = this;
			if (serializer !== null) {
				// we can set the serializer as a string when initializing 
				// the widget from an MVC wrapper
				if (typeof serializer === "string") {
					serializer = window[serializer];
				}
			}
			if (data !== null) {
				dataString = serializer !== null ? serializer(data) : JSON.stringify(data);
			} else {
				// if body is empty we should be using plain text as content type
				ct = "text/plain";
				dataString = "";
			}
			$.ajax({
				type: verb,
				url: url,
				data: dataString,
				statusCode: this._httpHandlers[verb],
				contentType: ct,
				cache: false,
				success: function (data, textStatus, jqXHR) {
					if (self._isc) {
						self._isc(data, textStatus, jqXHR);
					}
				},
				error: function (jqXHR, textStatus, errorThrown) {
					if (self._iec) {
						self._iec(jqXHR, textStatus, errorThrown);
					}
				},
				processData: true
			});
		}
	});
	$.ig.JSONPDataSource = $.ig.JSONPDataSource || $.ig.DataSource.extend({
        settings: {
            /* type="string|bool" Override the callback function name in a jsonp request. Sets option jsonp in $.ajax function 
            string Override the callback function name in a jsonp request
            bool Setting the jsonp option to false prevents jQuery from adding the "?callback" string to the URL or attempting to use "=?" for transformation
            */
            jsonp: null,
            /* type="string|function" Specify the callback function name for a JSONP request. Sets option jsonpCallback in $.ajax function 
            string Setting the name of the callback function for a JSONP request
            function As of jQuery 1.5, you can also use a function, in which case the value of jsonpCallback is set to the return value of that function
            */
            jsonpCallback: null
        },
		init: function (options) {
			if (!options) {
				options = {};
			}
			options.responseDataType = 'jsonp';
			this._super(options);
			return this;
		}
	});
	$.ig.XmlDataSource = $.ig.XmlDataSource || $.ig.DataSource.extend({
		init: function (options) {
			if (!options) {
				options = {};
			}
			options.type = "xml";
			this._super(options);
			return this;
		}
	});
	$.ig.FunctionDataSource = $.ig.FunctionDataSource || $.ig.DataSource.extend({
		init: function (options) {
			if (!options) {
				options = {};
			}
			options.type = "function";
			this._super(options);
			return this;
		}
	});
	// the dataSource should be a reference to a DOM element
	$.ig.HtmlTableDataSource = $.ig.HtmlTableDataSource || $.ig.DataSource.extend({
		init: function (options) {

			if (!options) {
				options = {};
			}
			options.type = "htmlTableDom";
			this._super(options);
			return this;
		}
	});
	$.ig.ArrayDataSource = $.ig.ArrayDataSource || $.ig.DataSource.extend({
		init: function (options) {
			if (!options) {
				options = {};
			}
			options.type = "array";
			this._super(options);
			return this;
		}
	});
	// the idea of the mashup data source is to combine several flat data sources from different locations into a single one
	// primary key matching is performed if keys are defined in the respective flat DataSource instances
	// after the mashup is processed, a combined data view and data instances are created and paging / sorting / filtering can work *locally* on the mashup
	// when some of the mashup sources is remote, callbacks are executed in order, and the final data binding part to combine the mashup
	// is called only when all of the individual data sources are data bound 
	$.ig.MashupDataSource = $.ig.MashupDataSource || $.ig.DataSource.extend({
		// the mashup data source is an array of flat data sources, which could be anything: local / remote / XML / JSON, etc. 
		// if an element in the dataSource array is not of type $.ig.DataSource, then it is assumed to be in the following format:
		// {options } 
		// where options will be used to create an $.ig.DataSource instance , example:
		//	var sources = [
		//		{dataSource: namedData, primaryKey: "ProductID"}, 
		//		{dataSource: "/demos/server/proxy.php?url=http://services.odata.org/OData/OData.svc/Products?$format=json", primaryKey: "ID"}
		//	];
		//	
		//	var ds = new $.ig.MashupDataSource({callback:render, dataSource: sources});
		//	ds.dataBind();
		//
		/* type="object" Defines the configuration setting for the mashup data source. */
		mashupSettings: {
			/* type="bool" Indicates whether to ignore records that have no corresponding data in all of the provided data sources. */
			ignorePartialRecords: false,
			/* type="array" An array of $.ig.DataSource instances holding the disperse data. */
			dataSource: []
		},
		init: function (options) {
			// initialize $.ig.DataSource
			this._super(options);
			if (options) {
				this.settings = $.extend(true, {}, $.ig.DataSource.prototype.settings, options);
				this.settings = $.extend(true, {}, $.ig.MashupDataSource.prototype.mashupSettings, this.settings);
			}
			// a list of flat data sources from which the mashup will be created 
			this._sources = [];
			this._dataBindingComplete = false;
			this._sourcesStatus = [];
			this._hashedDataViews = [];

			return this;
		},
		_checkDataBindingComplete: function (status, msg, ownerDs) {
			// once this is done, set it as dataSource of the actual mashup data source, and call super's dataBind()
			var i, j, k, hasPrimaryKeys = true, totalLength = 0, data = [], merged = [], d, rindex, keyVal, prop, keyIndexHash;

			this._dataBindingComplete = true;

			for (i = 0; i < this._sources.length; i++) {
				if (this._sources[i] === ownerDs) {
					this._sourcesStatus[i] = 1;
				}

				if (this._sourcesStatus[i] === 0) {
					this._dataBindingComplete = false; // still expecting some data source 
				}
			}
			// now that we have all separate data sources bound individually, and their dataViews filled with data 
			// we start assembling the mashup data source, by doing indexing on the primary keys (if defined)
			if (this._dataBindingComplete) {
				// check if there are primary keys defined for every individual data source 
				for (i = 0; i < this._sources.length; i++) {
					if (this._sources[i].settings.primaryKey === "" || this._sources[i].settings.primaryKey === null || this._sources[i].settings.primaryKey === undefined) {
						hasPrimaryKeys = false;
						break;
					}
				}
				// 1. determine the number of rows = max ( data source length) , also depending on the value of ignorePartialRecords
				// the data source with the largest number of records defines the mashup data source length 
				totalLength = this._sources[0].dataView().length;
				for (i = 0; i < this._sources.length; i++) {
					totalLength = this.settings.ignorePartialRecords ?
							(this._sources[i].dataView().length < totalLength ? this._sources[i].dataView().length : totalLength) :
							(this._sources[i].dataView().length > totalLength ? this._sources[i].dataView().length : totalLength);
				}
				// this also implies that there is schema present 
				if (hasPrimaryKeys) {
					// perform indexing based on the primary keys
					// for each data source, create hashes 
					for (i = 0; i < this._sources.length; i++) {
						this._hashedDataViews[i] = {};
						//consider the scenario where "primaryKey" is set to more than one field 
						// now iterate the records of the respective data source
						for (j = 0; j < this._sources[i].dataView().length; j++) {
							this._hashedDataViews[i][this._sources[i].dataView()[j][this._sources[i].settings.primaryKey]] = this._sources[i].dataView()[j];
						}
					}
					// now fill-in the "data":
					keyIndexHash = {};
					j = 0;
					for (i = 0; i < this._hashedDataViews.length; i++) {
						for (keyVal in this._hashedDataViews[i]) {
							if (this._hashedDataViews[i].hasOwnProperty(keyVal)) {
								if (keyIndexHash.hasOwnProperty(keyVal)) {
									data[keyIndexHash[keyVal]] = $.extend(true, {}, data[keyIndexHash[keyVal]], this._hashedDataViews[i][keyVal]);
									merged[keyIndexHash[keyVal]] ++;
								} else {
									data.push({});
									merged.push(1);
									data[j] = $.extend(true, {}, data[j], this._hashedDataViews[i][keyVal]);
									keyIndexHash[keyVal] = j;
									j++;
								}
							}
						}
					}
					if (this.settings.ignorePartialRecords) {
						for (i = merged.length - 1; i >= 0; i--) {
							if (merged[i] < this._sources.length) {
								data.splice(i, 1);
							}
						}
					}
				} else {
					// the easiest - no primary keys, process sequentially record by record 
					for (i = 0; i < totalLength; i++) {
						data[i] = {};
						for (j = 0; j < this._sources.length; j++) {
							d = this._sources[j];
							if (d.dataView()[0].length) {
								for (k = 0; k < d.dataView()[0].length; k++) {
									// check if there is schema defined or not 
									rindex += k;
									if (d.schema() && d.schema().fields().length > 0) {
										data[i][d.schema().fields()[k]] = i >= d.dataView().length ? '' : d.dataView()[i][d.schema().fields()[k]];
									} else {
										data[i][rindex] = i >= d.dataView().length ? '' : d.dataView()[i][k];
									}
								}
							} else {
								for (prop in d.dataView()[i]) {
									if (d.dataView()[i].hasOwnProperty(prop)) {
										//if (d.schema() && d.schema().fields().length > 0) {
										//	data[i][d.schema().fields().prop] = i >= d.dataView().length ? '' : d.dataView()[i][d.schema().fields().prop];
										//} else {
										data[i][prop] = i >= d.dataView().length ? '' : d.dataView()[i][prop];
										//}
									}
								}
							}
						}
						rindex = 0;
					}
				}
				this.settings.dataSource = data;
				this.settings.type = "array";
				this._runtimeType = this.analyzeDataSource();
				// finally call the data binding of the mashup 
				this.dataBind();
			}
		},
		dataBind: function () {
			var i, ds = this.settings.dataSource;
			if (this._dataBindingComplete) {
				// we can proceed to data binding the mashup 
				this._dataBindingComplete = false; // reset 
				this._super();
			} else {
				// setup the mashup for binding its individual data sources 
				this._dataBindingComplete = false;
				// traverse the sources and instantiate a data source object, if not already passed as parameter 
				for (i = 0; i < ds.length; i++) {
					if (ds[i] instanceof $.ig.DataSource) {
						this._sources[i] = ds[i];
					} else if (ds[i].hasOwnProperty('dataSource') && ds[i].dataSource instanceof $.ig.DataSource) {
						// K.D. November 17th, 2011 Bug #83399 There are cases where the dataSource property of the 
						// individual member is set to an $.ig.DataSource
						this._sources[i] = ds[i].dataSource;
					} else {
						this._sources[i] = new $.ig.DataSource(ds[i]);
					}
					// now data bind
					// attach a callback that will keep track of the data binding progress of all individual data sources
					this._sources[i].settings.callee = this;
					this._sources[i].settings.callback = this._checkDataBindingComplete;
					this._sourcesStatus[i] = 0; // mark the data source as not bound yet 
				}
				for (i = 0; i < ds.length; i++) {
					this._sources[i].dataBind();
				}
			}
			return this;
		}
	});
	//$.ig.HierarchicalDataSource = $.ig.HierarchicalDataSource || $.ig.DataSource.extend({
	// the hierarchical data source won't extend the flat one
	// as long as there is no paging or sorting or filtering, we don't need to create objects for flat ds'es
	$.ig.HierarchicalDataSource = $.ig.HierarchicalDataSource || Class.extend({
		settings: {
			// autogenerate will have limited support, since we cannot automatically infer which are the primary keys, therefore scenarios such as cascade delete or 
			// hierarchies when multiple flat sources are combined will not work correctly. 
			autogenerate: false, // if this property is true, the contents of "childbands" is ignored. 
			// load on demand support: always load only the top level
			// think about how to 'tell' the server that we do not want children to be loaded 
			initialDataBindDepth: 0,
			maxDataBindDepth: -1, // bind all levels by default
			defaultChildrenDataProperty: "children", // identifies the default property name in the data source where child nodes will be stored relative to their parent node/record
			//childbands: null, // a list of schemas and options, one for every level that we want to bind. Note that schemas here is different than relations. 
			// two defined schemas may have more than one relation defined. 
			//these two properties define if we want to do lazy loading based on virtualization, too. 
			// if virtualization is enabled, we may want to cache/load the data views for those records
			//startRecord: -1,
			//endRecord: -1
			callback: null,
			callee: null,
			data: [],
			dataSource: null,
			dataBinding: null,
			dataBound: null,
			// other options
			type: "unknown", // delegates to the flat data sources 
			responseDataType: null,
			responseContentType: null,
			localSchemaTransform: true,
			urlParamsEncoding: null,
			urlParamsEncoded: null,
			requestType: "GET",
			odata: false,
			paging: {

			},
			sorting: {

			},
			filtering: {

			},
			// all of the rest - paging, sorting, filtering, can be defined in the layouts definition, which will "override" the parent defs
			//IMPORTANT:  if there is no paging, sorting or filtering, an instance of $.ig.DataSource won't be created for child row islands 
			schema: [
			/* defined like this:
			{name: "someKey", type: "string", layouts: [
			{
			paging: { },
			sorting: { },
			filtering: { },
			childrenDataProperty: "children",
			foreignKey: "fk",
			// other flat grid specific props
			schema: [ ]
			}
			]},
			{name: "anotherKey", type: "string"}
				
			*/
			]
		},
		init: function (options) {
			// merge defaults with passed-in values 
			if (options) {
				this.__ds = options.dataSource;
				options.dataSource = null;
				this.settings = $.extend(true, {}, $.ig.HierarchicalDataSource.prototype.settings, options);
				this.settings.dataSource = this.__ds;
			}
			this._rootopts = this.settings;
			// necessary to push all of the layout children props 
			//this._rootopts.schema.fields.push({name: this.settings.defaultChildrenDataProperty});
			// depending on the value of initialDataBindDepth, we need to encode the URL so that load on demand works
			this._rootopts.urlParamsEncoded = $.proxy(this._encodeHierarchicalUrlParams, this);
			// K.D. April 22nd, 2014 Bug #169669 instanceof does not work in an iframe.
			if (this._rootopts.dataSource && typeof this._rootopts.dataSource._xmlToArray === "function" &&
					typeof this._rootopts.dataSource._encodePkParams === "function") {
				this._rootds = this._rootopts.dataSource;
				this._rootds.settings.urlParamsEncoded = this.settings.urlParamsEncoded;
				this._rootds.settings.odata = this.settings.odata;
				if (!this._rootds.settings.schema) {
					this._rootds.settings.schema = {};
				}
				this._rootds.settings.schema.layouts = this.settings.schema.layouts;
			} else {
				if ($.type(this._rootopts.dataSource) === "string" && this._rootopts.dataSource.indexOf("$callback=?") !== -1) {
					this._rootds = new $.ig.JSONPDataSource(this._rootopts);
				} else if (this._rootopts.restSettings &&
							(this._rootopts.restSettings.update.url !== null || this._rootopts.restSettings.update.template !== null ||
							this._rootopts.restSettings.create.url !== null || this._rootopts.restSettings.create.template !== null ||
							this._rootopts.restSettings.remove.url !== null || this._rootopts.restSettings.remove.template !== null)) {
					this._rootds = new $.ig.RESTDataSource(this._rootopts);
				} else {
					this._rootds = new $.ig.DataSource(this._rootopts);
				}
			}
		},
		dataBind: function (callback, callee) {
			// scenario -> paging on the top level, and then paging on a child level with different page size 
			// if it is local, there shouldn't be any problem
			// if it is remote, we need to additionally "craft" the URL of the root data source
			// additionally, when there is remote sorting, paging, or filtering on a child level, we must always pass the 
			// path in the child flat source

			//1. create a flat data source by creating its options first

			//2. check if the request is remote or local, if remote, "inject" the necessary additional URL parts (paging/sorting/filtering) so that the
			// correct data gets pulled out 
			// make sure the property marked with defaultChildrenDataProperty is part of he schema
			// also add all custom children data properties defined in custom layouts
			this._rootds.dataBind(callback, callee);
		},
		root: function () {
			if (!this._rootds) {
				this._rootds = new $.ig.DataSource(this._rootopts);
			}
			return this._rootds;
		},
		dataAt: function (path, keyspath) {
			// search the data. the data source must be indexed to speed up this access.
			var data = this.root().data(), paths = path.split("/"), kp = keyspath.split("/"), k, i, searchField = "Records",
				j, cd = null, ckey = this.settings.primaryKey, ckeyval = "", ckeys = [], ckeyvals = [], match = false;
			for (i = 0; i < paths.length; i++) {
				ckey = paths[i].split(":")[0];
				ckeyval = paths[i].split(":")[1];
				// NOTE: composite keys are keys whose values are separated by a comma. if ckey or ckeyval contain commas,
				// then the key is assumed to be composite and will be split based on ","
				if (paths[i] !== "") {
					for (j = 0; data && j < data.length; j++) {
						if (ckey && ckey.indexOf(",") !== -1) {
							ckeys = ckey.split(",");
							ckeyvals = ckeyval.split(",");
							for (k = 0; k < ckeys.length; k++) {
								if (!data[j][ckeys[k]].charAt && ckeyvals[k].charAt) {
									ckeyvals[k] = parseInt(ckeyvals[k], 10);
								}
								match = (data[j][ckeys[k]] === ckeyvals[k]);
								if (!match) {
									break;
								}
							}
						} else {
							if (data[j][ckey] !== undefined && !data[j][ckey].charAt && ckeyval.charAt) {
								ckeyval = parseInt(ckeyval, 10);
							}
							match = (data[j][ckey] === ckeyval);
						}
						// special case when we have responseDataKey / search fields defined for every children data instance
						if (match) {
							// get the children
							cd = data[j][kp[i]];
							// L.A. 14 January 2013 - Fixing bug #130634 - JS errors when having a second child layout and using knockout.
							searchField = this.root().schema && this.root().schema() && this.root().schema().schema ?
									this.root().schema().schema.searchField : searchField;
							if (cd && paths.length > 1 && i < paths.length - 1 && $.type(cd) !== "array" && cd[searchField]) {
								cd = cd[searchField];
							}
							break;
						}
					}
					data = cd;
				}
			}
			return cd;
		},
		/*
		populate: function (path, callback, params) {
		// after data is populated, call "callback" with "args" as arguments
		var url, o;
		// 1. get the url of the root ds (this._rootopts.dataSource)
		url = this._rootopts.dataSource;
		// construct params based on opts
		o = {
		url: url,
		dataType: this._rootopts.responseDataType,
		async: true,
		context: this,
		cache: false,
		data: params,
		success: this._hierarchicalProcessResponse
		};
		$.ajax(o);
		},
		_hierarchicalProcessResponse: function (data) {
		// data must be an object that contains data sources for each respective layout, as well as a "path"
		// property which specifies the location if the parent row
			
		//1. get the path from the response and locate the additional data from the queue
		// XML? 
		},
		*/
		_encodeUrlPath: function (rowid, name) {
			// we need to encode the current parent record path, when child records have their data sources set
			return "path=" + rowid + "&layout=" + name;
		},
		_encodeHierarchicalUrlParams: function (owner, args) {
			var expand = "", layouts = this.settings.schema.layouts, i, j, tmp, name, lc = 0;
			if (this.settings.odata && this.settings.initialDataBindDepth !== 0) {
				// use the OData $expand API
				// http://www.odata.org/developers/protocols/uri-conventions#ExpandSystemQueryOption
				// parse the root layouts in order to construct the expand statement
				i = j = 0;
				for (name in layouts) {
					if (layouts.hasOwnProperty(name)) {
						lc++;
					}
				}
				lc++;
				/*
				for (name in layouts) {
				if (layouts.hasOwnProperty(name) && $.type(layouts[name]) !== "function") {
				tmp = layouts[name].key;
				currentLayout = layouts[name];
				while (currentLayout.columnLayouts) {
				for (child in currentLayout.columnLayouts) {
				if (currentLayout.columnLayouts.hasOwnProperty(child)) {
				currentLayout = currentLayout.columnLayouts[child];
				break;
				}
				// OData supports only one band (one relationship)
				}
				tmp += "/" + currentLayout.key;
				}
				if (i !== 0 && i !== lc - 1) {
				expand += ",";
				}
				expand += tmp;
				i++;
				}
				}
				*/
				for (name in layouts) {
					if (layouts.hasOwnProperty(name)) {
						if ($.type(layouts[name]) !== "function") {
							if (name.startsWith("/")) {
								name = name.substring(1, name.length - 1);
							}
							tmp = name.split("/");
							for (i = 0; i < tmp.length; i++) {
								tmp[i] = tmp[i].substring(0, tmp[i].indexOf(":"));
							}
							tmp = tmp.join("/");
							if (j !== 0 && j !== lc - 1) {
								expand += ",";
							}
							expand += tmp;
							j++;
						}
					}
				}
				args.selectParams.$expand = expand;
			} else {
				// encode the initialDataBindDepth in the args
				// use args.selectParams to encode the initialDataBindDepth
				args.selectParams.dbdepth = this.settings.initialDataBindDepth;
				// we need to encode initial URL params in case paging / sorting / filtering are enabled on child layouts 
				// and their type is set to remote ! 
			}
		}
	});
	$.ig.TreeHierarchicalDataSource = $.ig.TreeHierarchicalDataSource || $.ig.DataSource.extend({
		settings: {
			treeDS: {
				dataSourceLayoutKey: null,
				foreignKey: null,
				hierarchicalDataSource: true,
				currentLevel: 0,
				root: null,
				initialDataBindDepth: -1,
				loadOnDemand: false,
				filtering: {
					fromLevel: 0,
					toLevel: -1,
					showHierarchicalData: true
				},
				sorting: {
					fromLevel: 0,
					toLevel: -1
				}
			}
		},
		init: function (options) {
			if (!options) {
				options = {};
			}
			options.treeDS = $.extend(true, {}, this.settings.treeDS, options.treeDS);
			//options.treeDS.filtering = $.extend(true, this.settings.treeDS.filtering, options.treeDS.filtering);
			//options.treeDS.sorting = $.extend(true, this.settings.treeDS.sorting, options.treeDS.sorting);
			this._rootOpts = options;
			this._super(options);
			return this;
		},
		_checkGeneratedSchema: function () {
			var s = this.settings.treeDS;
			this._checkGeneratedSchemaByKey(s.dataSourceLayoutKey);
			if (!s.hierarchicalDataSource) {
				this._checkGeneratedSchemaByKey(s.foreignKey);
			}
		},
		_checkGeneratedSchemaByKey: function (key) {
			if (key === null || key === undefined) {
				return;
			}
			var schema = this.schema(), i, fields = schema.fields(), fL = fields.length;
			for (i = 0; i < fL; i++) {
				if (fields[i].name === key) {
					break;
				}
			}
			if (i === fL) {
				fields.push({ name: key });
			}
		},
		dataBind: function () {
			this._level = this._currentLevel();
			this._checkGeneratedSchema(this.schema);
			this._super(function () {
				this.dataBindPerLevel(0, this.data());
			}, this);
		},
		_currentLevel: function () {
			return this.settings.treeDS.currentLevel;
		},
		dataBindPerLevel: function (level, data) {
			var i, layoutKey = this.settings.treeDS.dataSourceLayoutKey,
				dataLen, isRootLevel = false, dataRow;
			if (!level) {
				isRootLevel = true;
				level = this.settings.treeDS.currentLevel;
			}
			if (this._exceededDataBoundDepth(level)) {
				if (isRootLevel) {
					this._invokeCallback(this._callback, this._callee);
				}
				return;
			}
			if (level > this._levelDataBound || !this._levelDataBound) {
				this._levelDataBound = level;
			}
			if (this.settings.localSchemaTransform) {
				if (!this.settings.treeDS.loadOnDemand) {
					if (data === undefined) {
						data = this.data();
					}
					dataLen = data.length;
					for (i = 0; i < dataLen; i++) {
						dataRow = data[i];
						if (dataRow[layoutKey] && dataRow[layoutKey].length) {
							dataRow[layoutKey] = this.schema().transform(dataRow[layoutKey]);
							this.dataBindPerLevel(level + 1, dataRow[layoutKey]);
						}
					}
				}
			}
			if (isRootLevel) {
				this._invokeCallback(this._callback, this._callee);
			}
		},
		_exceededDataBoundDepth: function (currentLevel) {
			var dbDepth = this.settings.treeDS.initialDataBindDepth;
			return (dbDepth !== -1 &&
				currentLevel + 1 > dbDepth);
		},
		sort: function (fields, direction) {
			var s = this.settings.sorting, p = this.settings.paging, data, resetPaging = false;
			if (fields === undefined || fields === null) {
				throw new Error($.ig.DataSourceLocale.locale.noSortingFields);
			}
			if (s.applyToAllData && s.type === "local") {
				// M.H. 11 Mar 2013 Fix for bug #135542: When filtering is applied and then sort any column and there is remote paging, all of the records for the current page are sorted and rendered, no matter the applied filter
				if (this._filter && ((p.type === "local" && p.enabled === true) || p.enabled === false ||
						(p.type === "remote" && p.enabled === true && this.settings.filtering.type === 'local'))) {
					data = this._filteredData;
				} else {
					data = this.data();
				}
				resetPaging = true;
			} else {
				data = this.dataView();
			}
			data = this.sortDataRecursive(data, 0, fields, direction);
			// now if paging is enabled, and "applyToAllData" is true, we need to re-initialize the dataView
			if (resetPaging && p.type === "local") {
				/* DAY 2/15/12 101818- when filtering, need to set the filtered data, not _data */
				if (!this._filter) {
					this._data = data;
				} else {
					this._filteredData = data;
				}
				this._page();
			} else {
				// A.T. 14 Feb 2011 - fix for bug #66214
				this._dataView = data;
			}
			// M.H. 17 April 2012 Fix for bug #109475
			this._populateTransformedData(data);
			return this; // preserve chaining
		},
		sortDataRecursive: function (data, level, fields, direction) {
			var layoutKey = this.settings.treeDS.dataSourceLayoutKey, i, childDS, dataLen = data.length,
				s = this.settings.treeDS.sorting;
			for (i = 0; i < dataLen; i++) {
				childDS = data[i][layoutKey];
				if (childDS && childDS.length > 0) {
					childDS = this.sortDataRecursive(childDS, level + 1, fields, direction);
				}
			}
			if ((s.fromLevel <= level || s.fromLevel === -1) && (s.toLevel >= level || s.toLevel === -1)) {
				data = this.sortData(data, fields, direction);
			}
			return data;
		},
		sortData: function (data, fields, direction) {
			/* Sorts the data source locally. The result (filtered data) can be obtained by calling dataView(). Remote filtering can be performed by just calling dataBind() and setting the settings.filtering.expressions
			multi-column sorting can be enabled by setting keepSortState to true. 
			fields => an array of fields object definitions: 
			example: [{fieldName : "firstName"}, {fieldName : "lastName"}]
			example 2: [{fieldIndex : 1} , {fieldIndex : 2}]
				
			paramType="object" an array of fields object definitions
			paramType="string" asc / desc direction
			paramType="bool" if set to true, enables multi-column sorting, and the previous sorting state is not cleared
			*/
			var s = this.settings.sorting, schema, sortF, convertFunc, settings = this.settings;

			// check if there is a custom function defined
			if ($.type(s.customFunc) === 'function') {
				// call the function, passing the data to be sorted, the fields, and the direction
				data = s.customFunc(data, fields, direction);
			} else {
				schema = this.settings.schema;
				/*
				for (i = 0; i < schema.fields.length; i++) {
				if (schema.fields[i].name === fields[0].fieldName) {
				type = schema.fields[i].type;
				}
				}
				*/
				if (!direction) {
					direction = "";
				}
				// check if a custom compare function is set
				if ($.type(s.compareFunc) === "function") {
					sortF = s.compareFunc;
				} else {
					sortF = function (grid, fields, schema, reverse, convertf, caseSensitive) {
						reverse = reverse ? -1 : 1;
						function compareVals(format, enableUTCDates, rowTemplate, x, y) {
							if (format) {
								// L.A. 11 January 2013 - Fixing bug #130576 
								// L.A. 09 August 2012 - Fixing bug #118640 When the grid is bound to UTC dates 
								// (remote or local data), grouping a time-formatted date column produces incorrect groups
								if ($.type(x) === "date" && $.type(y) === "date") {
									if (format === "time" || format === "timeLong" || format === "h:mm:ss tt") {
										// Create date objects with fake year
										// M.H. 23 Oct 2013 Fix for bug #155639: Unable to sort date column when format is "h:mm:ss tt"
										x = new Date("January 01, 2000 " + $.ig.formatter(x, "date", format, rowTemplate, enableUTCDates));
										y = new Date("January 01, 2000 " + $.ig.formatter(y, "date", format, rowTemplate, enableUTCDates));
									}
								}
							}
							if ((x === null || x === undefined) && (y === null || y === undefined)) {
								return 0;
							}
							if ((x === null || x === undefined) && y !== null && y !== undefined) {
								return -1;
							}
							if (x !== null && x !== undefined && (y === null || y === undefined)) {
								return 1;
							}
							return x > y ? 1 : x < y ? -1 : 0;
						}
						return function (obj1, obj2) {
							var i, f, arr1 = [], arr2 = [], a, b, key, col, format, o, enableUTCDates,
								rowTemplate;
							if (grid) {
								o = grid.options;
								enableUTCDates = o.enableUTCDates;
								rowTemplate = (!o.rowTemplate || o.rowTemplate.length <= 0);
							}
							for (i = 0; i < fields.length; i++) {
								key = fields[i].fieldName;
								if (grid && grid.columnByKey) {
									col = grid.columnByKey(key);
									if (col !== undefined && col !== null) {
										format = col.format;
									}
								}
								if (fields[i].layout && ((settings.key && settings.key !== fields[i].layout) || !settings.key)) {
									continue;
								}
								f = fields[i];
								if (f.fieldIndex >= 0) {
									f.fieldName = f.fieldIndex;
								}
								a = obj1[f.fieldName];
								b = obj2[f.fieldName];
								if (convertf !== undefined) {

									// this is assumed to be a custom-defined function, that will override the default data source type conversion logic
									a = convertf(a, f.fieldName);
									b = convertf(b, f.fieldName);
								}
								//A.T. 19 Jan 2011 - Fix for bug #62963 - igDataSource - case sensitivity is not applied to sorting
								if (caseSensitive === false) {
									if (a !== undefined && a !== null && a.toLowerCase) {
										a = a.toLowerCase();
									}
									if (b !== undefined && b !== null && b.toLowerCase) {
										b = b.toLowerCase();
									}
								}
								// support a different direction for every separate column
								if (f.dir !== undefined && f.dir !== null) {
									reverse = f.dir.toLowerCase().startsWith("desc");
									reverse = reverse ? -1 : 1;
								} else if (direction !== undefined && direction !== null && direction !== "") {
									reverse = direction.toLowerCase().startsWith("desc");
									reverse = reverse ? -1 : 1;
								}
								// differentiate between single and multi-col sorting (for performance reasons)
								if (fields.length === 1) {
									arr1 = reverse * compareVals(format, enableUTCDates, rowTemplate, a, b);
									arr2 = reverse * compareVals(format, enableUTCDates, rowTemplate, b, a);
								} else {
									if (reverse === -1) {
										arr1.push(-compareVals(format, enableUTCDates, rowTemplate, a, b));
										arr2.push(-compareVals(format, enableUTCDates, rowTemplate, b, a));
									} else {
										arr1.push(compareVals(format, enableUTCDates, rowTemplate, a, b));
										arr2.push(compareVals(format, enableUTCDates, rowTemplate, b, a));
									}
								}
							}
							if (arr1 < arr2) {
								return -1;
							}
							if (arr1 > arr2) {
								return 1;
							}
							return 0;
						};
					};
				}
				// check if a custom conversion function is set
				if ($.isFunction(s.customConvertFunc)) {
					convertFunc = s.customConvertFunc;
				}
				//else {
				// we do not want to reset the default data source type conversion logic
				// convertFunc returns a function 
				//convertFunc = this._convertf;
				//}

				// we allow the developer to provide a single string of sort expressions, in the following format:
				// "col1 asc, col2 desc, col3 asc" ... 
				if ($.type(fields) === "string") {
					fields = this._parseSortExpressions(fields);
				}
				// A.T. 21 Jan Fix for bug #63146 - reversing of sorting should be the other way around if "direction" is specified as parameter in sort()
				// M.H. 16 March 2012 Fix for bug #105043 - when fields.length is 0 then sortF returns 0. But in Chrome when there are empty values the issues is represented
				if (fields.length > 0) {
					data = data.sort(sortF(this.settings.callee, fields, schema, direction.toLowerCase().startsWith("asc") ? false : true, convertFunc, s.caseSensitive));
					// M.H. 14 Oct 2013 Fix for bug #154649: Rows are grouped incorrectly when applying and removing a filter if a filter is applied by default through code
					// when ds is local and if the whole dataSource is not sorted but only dataView then on filtering data when groupby is applied grouping wouldn't be correct. 
					// GroupBy takes the data(not sorted) from dataSource which is not sorted and apply filtering...
					this._allDataSorted = (data === this.data());
				}
			}
			return data;
		},
		filter: function (fieldExpressions, boolLogic, keepFilterState, fieldExpressionsOnStrings) {
			var i, f = this.settings.filtering, p = this.settings.paging, data, resetPaging;
			if (f.applyToAllData && f.type === "local") {
				data = this.data();
				resetPaging = true;
			} else {
				// cache the original dataView 
				if (this._cachedDataView && this._cachedDataView.length > 0) {
					//data = this.dataView();
					data = this._cachedDataView;
				} else {
					// COPY the this.dataView() in this._cachedDataView; this is necessary because we want to restore it later on 
					//this._cachedDataView = $.extend(true, {}, this.dataView());
					this._cachedDataView = $.merge([], this.dataView());
					data = this._cachedDataView;
				}
			}
			this._filteredData = this._filterDataRecursive(data, 0, fieldExpressions, boolLogic, keepFilterState, fieldExpressionsOnStrings);
			this._dataView = [];

			this._filter = true;
			if (resetPaging && p.type === "local" && p.enabled === true) {
				// reset paging
				this.settings.paging.pageIndex = 0;
				this.pageSizeDirty(true);
				this._page();
			} else {
				for (i = 0; i < this._filteredData.length; i++) {
					this._dataView[i] = this._filteredData[i];
				}
			}
			this._populateTransformedData(this._filteredData);
			return this; // preserve chaining
		},
		_filterDataRecursive: function (data, level, fieldExpressions, boolLogic, keepFilterState, fieldExpressionsOnStrings) {
			var i, j, expr = null, count = 0, skipRec = false, f = this.settings.filtering, foundChildDS, subDS,
				t, k, schema, fields, tmpbool, allFieldsExpr, stringVal, fExprLen, fExprStrLen,
				filteredData = [], childDS, layoutKey = this.settings.treeDS.dataSourceLayoutKey,
				fts = this.settings.treeDS.filtering;
			schema = this.schema();
			if (schema === null || schema === undefined) {
				throw new Error($.ig.DataSourceLocale.locale.filteringNoSchema);
			}
			if ($.type(fieldExpressions) === "string") {
				expr = fieldExpressions;
			}
			if ($.type(fieldExpressionsOnStrings) === "string") {
				allFieldsExpr = fieldExpressionsOnStrings;
			} else if ($.type(fieldExpressionsOnStrings) === "undefined") {
				fieldExpressionsOnStrings = [];
			}
			if ($.type(fieldExpressions) === "array" && fieldExpressions.length === 0 && $.type(fieldExpressionsOnStrings) === "array" && fieldExpressionsOnStrings.length === 0) {
				return;
			}

			if ($.type(f.customFunc) === 'function') {
				// call the function, passing the filterExpression object which contains field names/indices, the current expression for the field, as well as condition for the field
				filteredData = f.customFunc(fieldExpressions, data);
			} else {
				if (expr) {
					fieldExpressions = this._parseFilterExprString(expr);
				}
				if (allFieldsExpr) {
					fieldExpressionsOnStrings = this._parseFilterExprString(allFieldsExpr);
				}
				fExprLen = fieldExpressions.length;
				fExprStrLen = fieldExpressionsOnStrings.length;
				// filter "data"
				// we will store all results in tmpData, and then assign it to the dataView. please ensure that 
				for (i = 0; i < data.length; i++) {
					if (!((fts.fromLevel <= level || fts.fromLevel === -1) && (fts.toLevel >= level || fts.toLevel === -1))) {
						childDS = data[i][layoutKey];
						if (childDS && childDS.length) {
							childDS = this._filterDataRecursive(childDS, level + 1, fieldExpressions, boolLogic, keepFilterState, fieldExpressionsOnStrings);
							if (childDS && childDS.length > 0) {
								filteredData[count++] = $.extend(true, {}, data[i]);
								filteredData[count - 1][layoutKey] = childDS;
							}
						}
						continue;
					}
					skipRec = false;
					for (j = 0; j < fExprLen; j++) {
						// if there is no match, break, we aren't going to add the record to the resulting data view. 
						// the default boolean logic is to "AND" the fields 
						fields = schema.fields();
						if (fieldExpressions[j].fieldIndex) {
							if (fieldExpressions[j].fieldIndex < fields.length) {
								t = fields[fieldExpressions[j].fieldIndex].type;
							}
							skipRec = !this._findMatch(data[i][fieldExpressions[j].fieldIndex], fieldExpressions[j].expr, t, !f.caseSensitive, fieldExpressions[j].cond, fieldExpressions[j].preciseDateFormat);
						} else {
							// M.H. 10 Sep 2012 Fix for bug #120759
							if (fieldExpressions[j].dataType !== undefined && fieldExpressions[j].dataType !== null) {
								t = fieldExpressions[j].dataType;
							} else {
								for (k = 0; k < fields.length; k++) {
									if (fields[k].name === fieldExpressions[j].fieldName) {
										t = fields[k].type;
										break;
									}
								}
							}
							skipRec = !this._findMatch(data[i][fieldExpressions[j].fieldName], fieldExpressions[j].expr, t, !f.caseSensitive, fieldExpressions[j].cond, fieldExpressions[j].preciseDateFormat);
						}
						tmpbool = (fieldExpressions[j].logic !== null && fieldExpressions[j].logic !== undefined && (fieldExpressions[j].logic.toLowerCase() === "or" ||
							fieldExpressions[j].logic.toLowerCase() === "and")) ? fieldExpressions[j].logic : boolLogic;
						//A.T. 18 Jan. 2011 fix for bug 62126 - igDataSource local filtering expressions: the OR operator does not work
						if (tmpbool === undefined || tmpbool === null || $.type(tmpbool) !== "string") {
							tmpbool = "and";
						}
						if (skipRec && tmpbool.toLowerCase() === "and") {
							break;
						} else if (!skipRec && tmpbool.toLowerCase() === "or") {
							break;
						}
					}
					if (!skipRec && fExprStrLen) {
						for (j = 0; j < fExprStrLen; j++) {
							// if there is no match, break, we aren't going to add the record to the resulting data view. 
							// the default boolean logic is to "AND" the fields 
							fields = schema.fields();
							if (fieldExpressionsOnStrings[j].fieldIndex) {
								if (fieldExpressionsOnStrings[j].fieldIndex < fields.length) {
									t = fields[fieldExpressionsOnStrings[j].fieldIndex].type;
								}
								stringVal = data[i][fieldExpressionsOnStrings[j].fieldIndex] ? data[i][fieldExpressionsOnStrings[j].fieldIndex].toString() : "";
								skipRec = !this._findMatch(stringVal, fieldExpressionsOnStrings[j].expr, "string", !f.caseSensitive, fieldExpressionsOnStrings[j].cond);
							} else {
								for (k = 0; k < fields.length; k++) {
									if (fields[k].name === fieldExpressionsOnStrings[j].fieldName) {
										t = fields[k].type;
										break;
									}
								}
								stringVal = data[i][fieldExpressionsOnStrings[j].fieldName] !== null && data[i][fieldExpressionsOnStrings[j].fieldName] !== undefined ? data[i][fieldExpressionsOnStrings[j].fieldName].toString() : "";
								skipRec = !this._findMatch(stringVal, fieldExpressionsOnStrings[j].expr, "string", !f.caseSensitive, fieldExpressionsOnStrings[j].cond);
							}
							tmpbool = (fieldExpressionsOnStrings[j].logic !== null && fieldExpressionsOnStrings[j].logic !== undefined && (fieldExpressionsOnStrings[j].logic.toLowerCase() === "or" ||
								fieldExpressionsOnStrings[j].logic.toLowerCase() === "and")) ? fieldExpressionsOnStrings[j].logic : boolLogic;
							//A.T. 18 Jan. 2011 fix for bug 62126 - igDataSource local filtering expressions: the OR operator does not work
							if (tmpbool === undefined || tmpbool === null || $.type(tmpbool) !== "string") {
								tmpbool = "and";
							}
							if (skipRec && tmpbool.toLowerCase() === "and") {
								break;
							} else if (!skipRec && tmpbool.toLowerCase() === "or") {
								break;
							}
						}
					}
					foundChildDS = false;
					childDS = data[i][layoutKey];
					subDS = null;
					if (childDS && childDS.length) {
						childDS = this._filterDataRecursive(childDS, level + 1, fieldExpressions, boolLogic, keepFilterState, fieldExpressionsOnStrings);
						if (childDS && childDS.length > 0) {
							subDS = data[i][layoutKey];
							data[i][layoutKey] = null;
							filteredData[count++] = $.extend(true, {}, data[i]);
							data[i][layoutKey] = subDS;
							filteredData[count - 1][layoutKey] = childDS;
							foundChildDS = true;
						}
					}
					if (!skipRec && !foundChildDS) {
						//this._dataView[count++] = data[i];
						if (!fts.showHierarchicalData && childDS) {
							subDS = data[i][layoutKey];
							data[i][layoutKey] = null;
							filteredData[count] = $.extend(true, {}, data[i]);
							data[i][layoutKey] = subDS;
							filteredData[count][layoutKey] = null;
							count++;
						} else {
							filteredData[count++] = data[i];
						}
					}
				}
			}
			return filteredData;
		},
		// override 
		findRecordByKey: function (key, ds) {
			/* returns a record by a specified key (requires that primaryKey is set in the settings)
			paramType="string" Primary key of the record
			returnType="object" a JavaScript object specifying the found record, or null if no record is found
			*/
			var i, d, layouts = [], res,
				data = ds || this._data,
				len = data ? data.length : 0,
                dsLayoutKey = this.settings.treeDS.dataSourceLayoutKey,
				search = len > 0 && $.isArray(data[0]) ? this._lookupPkIndex() : this.settings.primaryKey;
			for (i = 0; i < len; i++) {
				d = data[i];
				if (d[search] === key) {
					return data[i];
				}
				if (d[dsLayoutKey]) {
					layouts.push(d[dsLayoutKey]);
				}
			}
			len = layouts.length;
			for (i = 0; i < len; i++) {
				res = this.findRecordByKey(key, layouts[i]);
				if (res) {
					return res;
				}
			}
			return null;
		},
		// override
		removeRecordByKey: function (key, origDs) {
			/* removes a specific record denoted by the primaryKey of the passed key parameter from the data source 
			paramType="string|number" primary key of the record 
			*/
			var data, count = 0,
				all = [this._data, this._dataView, this._filteredData, origDs];
			while (count < 4) {
				data = all[count++];
				this._removeRecordByKeyForData(key, data);
				// if next data is same, then skip it
				if (data === all[count]) {
					count++;
				}
			}
		},
		_removeRecordByKeyForData: function (key, data) {
			var i, prime = this.settings.primaryKey,
				len = data ? data.length : 0,
				search = len > 0 && $.isArray(data[0]) ? this._lookupPkIndex() : prime,
				layoutKey = this.settings.treeDS.dataSourceLayoutKey,
				layoutData = [],
				found = false;

			for (i = 0; i < len; i++) {
				if (data[i]) {
					if (data[i][search] === key) {
						$.ig.removeFromArray(data, i);
						found = true;
						break;
					}
					if (data[i][layoutKey]) {
						layoutData.push(data[i][layoutKey]);
					}
				}
			}
			if (!found) {
				len = layoutData.length;
				for (i = 0; i < len; i++) {
					found = this._removeRecordByKeyForData(key, layoutData[i]);
					if (found) {
						return true;
					}
				}
			} else {
				return true;
			}
			return false;
		}
	});
	// Expose dataSource as an AMD module, but only for AMD loaders that
	// understand the issues with loading multiple versions of jQuery
	// in a page that all might call define(). The loader will indicate
	// they have special allowances for multiple jQuery versions by
	// specifying define.amd.jQuery = true. Register as a named module,
	// since jQuery can be concatenated with other files that may use define,
	// but not use a proper concatenation script that understands anonymous
	// AMD modules. A named AMD is safest and most robust way to register.
	// Lowercase ig.datasource is used because AMD module names are derived from
	// file names, and jQuery is normally delivered in a lowercase file name.
	// Do this after creating the global so that if an AMD module wants to call
	// noConflict to hide this version of jQuery, it will work.
	if (typeof define === "function" && define.amd && define.amd.jQuery) {
		define("ig.datasource", ["ig.util"], function () { return $.ig.DataSource; });
	}
}(jQuery));




/*!@license
* Infragistics.Web.ClientUI templating localization resources 14.2.20142.1018
*
* Copyright (c) 2011-2014 Infragistics Inc.
*
* http://www.infragistics.com/
*
*/

/*global jQuery */
(function ($) {
    $.ig = $.ig || {};

    if (!$.ig.Templating) {
	    $.ig.Templating = {};

	    $.extend($.ig.Templating, {
		    locale: {
			    undefinedArgument: 'An error has occurred while trying to retrieve data source property: '
		    }
	    });
    }
})(jQuery);

/*!@license
 * Infragistics.Web.ClientUI Templating Engine 14.2.20142.1018
 *
 * Copyright (c) 2011-2014 Infragistics Inc.
 * 
 * Engine used for data templating
 *
 * http://www.infragistics.com/
 *
 * Depends on:
 *
 */

 /*
	1. comment RegExp matches comments in the template string in the form # My comment #. 
		Unterminated comments would not be matched
	2. sub (substitute) RegExp matches templated data items to be replaced in the form of ${DataItem}.
	3. block RegExp matches terminated block statements
		e.g. {{if condition}} do something {{else}} do something else {{/if}}
		limitation: Regular expressions are equivalent to finite automatons as described by theory of computation and more precisely the formal languages and automata computability theory. This means that they are limited to recognizing languages of the type AB^nC but noy languages of the type [AB]^n which are recognized by context-free grammars (Regular expressions are still a subset of context-free grammars). However the A^nB^n is recognized due to the fact that we can use greedy regular expressions allowing us to match the last existing token of a type. Thus nested if-statements would not be recognized without stack-tokenizing the block statement.
	4. TO DO: Find a way to encorporate ? conditionals
 */
/*global jQuery */
(function ($) {

	$.ig = $.ig || {};

	$.extend($.ig, {
	/* pluginName="igTemplating" */
		tmpl: function (template, data, args) {
			/*  Templates the given template with the provided data. If data is a function that requires arguments, the arguments need to be provided as an array following the data. tmpl(template, data[, args])
				paramType="string" optional="false" Specifies the template string
				paramType="object|array|function" optional="false" Specifies the data to be templated in the template. If function is provided, then it has to be object or array returning function, possible receiving arguments array which can be specified as the third parameter
				paramType="array" optional="true" If function is provided as the second parameter, then this parameter is the arguments for the function.
				returnType="string" Returns the templated data as a string. Returns the original template if nothing is to be templated. */
			var tmpl = template, cacheConst;
			// K.D. May 28th, 2012 Bug #112490 Removing linebreaks in the template before rendering it.
			//D.U. February 28th 2014 Checking if tmpl is initialized
			if(tmpl){
				tmpl = tmpl.replace(this.regExp.lineBreak, '');
				// Removing comments
				tmpl = tmpl.replace(this.regExp.comment, '');
			
				if (typeof data === 'function') {
					if (args) {
						data = data.apply(this, args);
					} else {
						data = data.call();
					}
				}
				if (this._internalTmplCache && this._internalTmplCache.hasOwnProperty(tmpl)) {
					this.tokens = this._internalTmplCache[tmpl].tokens;
					this.args = this._internalTmplCache[tmpl].args;
					this.i = this._internalTmplCache[tmpl].i;
					this._hasBlock = this._internalTmplCache[tmpl]._hasBlock;
					tmpl = this._internalTmplCache[tmpl].tmpl;
				} else {
					this.tokens = [];
					this.args = [];
					this.i = 0;
					this._tokenizeTemplate(tmpl);
					cacheConst = tmpl;
					this._internalTmplCache[cacheConst] = {};
					this._internalTmplCache[cacheConst].tokens = this.tokens;
					if (this.regExp.block.test(tmpl)) {
						this._hasBlock = true;
						tmpl = this._tokenizeDirectives(tmpl);
					} else {
						this._hasBlock = false;
					}
					this._internalTmplCache[cacheConst].args = this.args;
					this._internalTmplCache[cacheConst].i = this.i;
					this._internalTmplCache[cacheConst]._hasBlock = this._hasBlock;
					this._internalTmplCache[cacheConst].tmpl = tmpl;
				}
				if (!this.tokens) {
					// Nothing got tokenized
					return tmpl; // An exception can be thrown here
				}
				if (this._hasBlock) {
					tmpl = this._compileTemplate(tmpl, data);
				} else {
					tmpl = this._populateTemplate(tmpl, data);
				}
				delete this.args;
				delete this.tokens;
				delete this._hasBlock;
				delete this.i;
			}
			return tmpl;
		},
		clearTmplCache: function () {
			delete this._internalTmplCache;
			this._internalTmplCache = {};
		},
		encode: function (value) {
			/* Encoding < > ' and "
				paramType="string" The string to be encoded.
				returnType="string" Returns the encoded string.
			 */
			return value !== null && value !== undefined ? value.toString().replace(this.regExp.lt, "&lt;").replace(this.regExp.gt, "&gt;").replace(this.regExp.ap, "&#39;").replace(this.regExp.ic, "&#34;") : '';
		},
		/* type="RegExp" Used to tokenize the template string. */
		regExp: {
			/* type="RegExp" Matches any comment in the template
				Use tmpl.replace($.ig.regExp.comment, '') in order to remove comments from the tmpl string
			*/
			// K.D. August 27th, 2013 Bug #150299 Making the comment to have to be preceded by a white space.
			// This avoids issues with double anchors with href="#"
			comment: /\s#[^#]*#/g,
			/* type="RegExp" Matches any substitution element in the template that is to be encoded before rendering
				Use $.ig.regExp.sub.exec(tmpl) in order to get the substitution element in the tmpl string
			*/
			sub: /\$\{(([\w\$]+(\.|\s)?[\w\$]*)+)\}/,
			/* type="RegExp" Matches any substitution element in the template that is to be rendered as it is
				Use $.ig.regExp.sub.exec(tmpl) in order to get the substitution element in the tmpl string
			*/
			nonEncodeSub: /\{\{html\s+([\w\$]+(\.|\s)?[\w\$]*)+\}\}/,
			forSub: /\$\{(([\w\$]+\.[\w\$]*)+)\}/,
			arg: /args\[\d+\](?!.*\+)/,
			/* type="RegExp" Matches any block directive in the template
				Use $.ig.regExp.block.exec(tmpl) in order to get the block directive in the tmpl string
			*/
			block: /\{\{(\w+).*?\}\}+(.*)(\{\{\/\1\}\})/,
			/* type="RegExp" Matches any continuation inside a block directive in the template
				Use $.ig.regExp.blockCont.exec(tmpl) in order to get the directive within a block in the tmpl string
			*/
			blockCont: /\{\{(?!\/)(\S+)(.*)\}\}(.*)/,
			/* type="RegExp" Matches any continuation inside a block directive in the template
				Use $.ig.regExp.blockCont.exec(tmpl) in order to get the directive within a block in the tmpl string
			*/
			blockDirective: /\{\{\S+.*?\}\}/,
			/* type="RegExp" Matches index substitution $i
				Use $.ig.regExp.index.test(tmpl) in order to test for index variable in the tmpl string
			*/
			index: /\$i/g,
			/* type="RegExp" Matches linebreaks and carriages */
			lineBreak: /(\r\n|\n|\r)/gm,
			/* Characters to encode */
			lt: /</g,
			gt: />/g,
			ap: /'/g,
			ic: /"/g
		},
		/* Used to compile template directives. */
		_directives: {
			'if': {
				start: 'if (',
				close: ') {',
				end: ' }'
			},
			'elseif': {
				start: ' } else if (',
				close: ') {',
				end: ''
			},
			'else': {
				start: ' } else {',
				close: '',
				end: ''
			},
			'each': {
				start: 'for (var i = 0; i < $data.length; i++) {',
				close: '',
				end: ' }'
			}
		},
		_internalTmplCache: {},
		_tokenizeTemplate: function (template) {
			var tempToken, splitName;
			if (this.regExp.sub.test(template)) {
				tempToken = this.regExp.sub.exec(template);
				while (tempToken !== null) {
					splitName = tempToken[1].split('.');
					// K.D. September 25th, 2012 Bug #122463 The property can contain $ in its name.
					template = template.replace(new RegExp('\\$\\{' + tempToken[1].replace(/\$/g, '\\$') + '\\}', 'g'), '');
					tempToken[3] = new RegExp('\\$\\{' + tempToken[1].replace(/\$/g, '\\$')  + '\\}', 'g');
					tempToken[1] = splitName;
					tempToken[2] = true;
					this.tokens.push(tempToken);
					tempToken = this.regExp.sub.exec(template);
				}
			}
			if (this.regExp.nonEncodeSub.test(template)) {
				tempToken = this.regExp.nonEncodeSub.exec(template);
				while (tempToken !== null) {
					splitName = tempToken[1].split('.');
					// K.D. September 25th, 2012 Bug #122463 The property can contain $ in its name.
					template = template.replace(new RegExp('\\{\\{html\\s+' + tempToken[1].replace(/\$/g, '\\$') + '\\}\\}', 'g'), '');
					tempToken[3] = new RegExp('\\{\\{html\\s+' + tempToken[1].replace(/\$/g, '\\$') + '\\}\\}', 'g');
					tempToken[1] = splitName;
					tempToken[2] = false;
					this.tokens.push(tempToken);
					tempToken = this.regExp.nonEncodeSub.exec(template);
				}
			}
		},
		_tokenizeDirectives: function (template) {
			var tmpl = 'var result = "";', tokens = this.regExp.block.exec(template), temp;
			// Begin handling of directives tokenization
			if (template.indexOf(tokens[0]) > 0 || template.length !== tokens[0].length) {
				temp = template.split(tokens[0]);
				if (temp[0] && temp[0].length > 0) {
					this.args.push(temp[0]);
					tmpl += 'result += args[' + this.i++ + '];';
				}
			}
			tmpl += this._handleCompleteBlock(tokens);
			if (temp && temp.length > 0 && temp[1].length > 0) {
				this.args.push(temp[1]);
				tmpl += 'result += args[' + this.i++ + '];';
			}
			tmpl += 'return result;';
			// Stack population is complete
			return tmpl;
		},
		_handleCompleteBlock: function (tokens) {
			var tmpl = tokens[0], template = '', blocks = [], i, temp;
			// Remove the start and end tokens of the completed block
			tmpl = tmpl.replace('{{' + tokens[1], this._directives[tokens[1]].start);
			// K.D. July 4th, 2013 Bug #146297 Adding logic to handle sequential {{each}}
			if (tokens[1] === 'each') {
				blocks.push(tokens[0].split(tokens[3]));
				blocks.push(tokens[2].split(tokens[3]));
				for (i = 0; i < blocks[1].length; i++) {
					if (blocks[0][i].indexOf('{{each') > 0) {
						temp = blocks[0][i].split('{{each')[0];
						this.args.push(temp);
						template += 'result += args[' + this.i++ + '];';
						blocks[0][i] = blocks[0][i].substr(blocks[0][i].indexOf('{{each'));
						temp = this.regExp.blockDirective.exec(blocks[1][i]);
						blocks[1][i] = blocks[1][i].substr(blocks[1][i].indexOf(temp[0]) + temp[0].length);
					}
					blocks[0][i] = blocks[0][i].replace('{{' + tokens[1], this._directives[tokens[1]].start);
					template += this._handleEach(blocks[0][i] + "{{/each}}", [
						blocks[0][i] + "{{/each}}",
						'each',
						blocks[1][i],
						'{{/each}}'
					]);
				}
			} else if (tokens[1] === 'if') {
				template += this._handleIfElse(tmpl, tokens);
			}
			return template;
		},
		_handleEach: function (template, tokens) {
			var tmpl = template, eachVar, body, forSub, sub, expr, inner;
			eachVar = this.regExp.sub.exec(tmpl);
			tmpl = tmpl.replace(eachVar[0], '');
			tmpl = tmpl.replace('$data', eachVar[0]);
			body = tokens[2];
			if (/\$data/.test(body)) {
				body = body.replace(/\$data/g, '" + ' + eachVar[0] + '[i] + "');
				this.args.push(eachVar[0]);
				this.i++;
			}
			forSub = this.regExp.forSub.exec(body);
			while (forSub) {
				body = body.replace(new RegExp('\\$\\{' + forSub[1] + '\\}', 'g'), '" + ' + eachVar[0] + '[i]' + forSub[1].substr(forSub[1].indexOf('.')) + ' + "');
				forSub = this.regExp.forSub.exec(body);
			}
			body = body.replace(/\$index/g, '" + i + "');
			tmpl = tmpl.replace(tokens[2], 'result += "' + body + '"');
			tmpl = tmpl.replace(/\}\}/, this._directives[tokens[1]].close);
			tmpl = tmpl.replace(tokens[3], this._directives[tokens[1]].end);
			// Check for a nested blocks and recursively handle them
			if (this.regExp.block.test(tmpl)) {
				inner = this.regExp.block.exec(tmpl);
				tmpl = tmpl.replace(inner[0], this._handleCompleteBlock(inner));
			}
			// Parse the contents of the block
			// Put all data members on the stack
			sub = this.regExp.sub.exec(tmpl);
			while (sub) {
				expr = new RegExp('\\$\\{' + sub[1] + '\\}', 'g');
				tmpl = tmpl.replace(expr, 'args[' + this.i++ + ']');
				this.args.push(sub[0]);
				sub = this.regExp.sub.exec(tmpl);
			}
			return tmpl;
		},
		_handleIfElse: function (template, tokens) {
			var tmpl = template, i = 0, htmlStrings, sub, inner, index, tmplArr = [];
			// Remove the start and end tokens of the completed block
			tmpl = tmpl.replace(/\}\}/, this._directives[tokens[1]].close);
			index = tmpl.lastIndexOf(tokens[3]);
			tmpl = tmpl.substr(0, index) + tmpl.slice(index + tokens[3].length - 1);
			// Check for a nested blocks and recursively handle them
			if (this.regExp.block.test(tmpl)) {
				inner = this.regExp.block.exec(tmpl);
				tmpl = tmpl.replace(inner[0], this._handleCompleteBlock(inner));
			}
			// Parse the contents of the block
			htmlStrings = tokens[2].split(this.regExp.blockDirective);
			// We need to make sure that we're not replacing a substitute inside the if condition with result +=...
			tmplArr.push(tmpl.slice(0, tmpl.indexOf(') {') + 3));
			tmplArr.push(tmpl.slice(tmpl.indexOf(') {') + 3));
			for (i; i < htmlStrings.length; i++) {
				if (htmlStrings[i] && htmlStrings[i].length && htmlStrings[i].length > 0) {
					tmplArr[1] = tmplArr[1].replace(htmlStrings[i], 'result += args[' + this.i++ + '];');
					this.args.push(htmlStrings[i]);
				}
			}
			tmpl = tmplArr.join('');
			// End Parse
			// Parse block continuations such as {{else}}
			tokens = this.regExp.blockCont.exec(tmpl);
			while (tokens) {
				tmpl = tmpl.replace('{{' + tokens[1], this._directives[tokens[1]].start);
				tmpl = tmpl.replace(/\}\}/, this._directives[tokens[1]].close);
				tokens = this.regExp.blockCont.exec(tmpl);
			}
			// Put all data members on the stack as well
			sub = this.regExp.sub.exec(tmpl);
			while (sub) {
				tmpl = tmpl.replace(new RegExp('\\$\\{' + sub[1] + '\\}', 'g'), 'args[' + this.i++ + ']');
				this.args.push(sub[0]);
				sub = this.regExp.sub.exec(tmpl);
			}
			// Stack population is complete
			return tmpl;
		},
		_populateTemplate: function (template, data) {
			var i, j, result = '', temp;
			if (!data.length) {
				for (i = 0; i < this.tokens.length; i++) {
					template = this._populateArgumentValue(data, this.tokens[i], template);
				}
				result = template;
			} else if (data.length) {
				for (j = 0; j < data.length; j++) {
					temp = template;
					for (i = 0; i < this.tokens.length; i++) {
						temp = this._populateArgumentValue(data[j], this.tokens[i], temp);
					}
					temp = temp.replace(this.regExp.index, j);
					result += temp;
				}
			}
			return result;
		},
		_compileTemplate: function (template, data) {
			var i, j, k, result = '', temp, tempArgs = [], arg = '', f;
			if (!data.length) {
				for (j = 0; j < this.args.length; j++) {
					arg = this.args[j];
					for (i = 0; i < this.tokens.length; i++) {
						if (arg === this.tokens[i][0]) {
							arg = this._getArgumentValue(data, this.tokens[i], arg);
							break;
						} else if (typeof arg === 'string') {
							arg = this._populateArgumentValue(data, this.tokens[i], arg);
						}
					}
					if (arg === undefined) {
						throw new Error($.ig.Templating.locale.undefinedArgument + this.tokens[i][0]);
					}
					if (typeof arg === 'string') {
						arg = arg.replace(this.regExp.index, 0);
					}
					tempArgs.push(arg);
				}
				template = template.replace(/\$i/g, 0);
				/*jshint -W054 */
				result = new Function("args", template).call(this, tempArgs) || '';
			} else if (data.length) {
				temp = template.replace(this.regExp.index, 'args[' + this.args.length + ']');
				f = new Function("args", temp);
				/*jshint +W054 */
				for (j = 0; j < data.length; j++) {
					tempArgs = [];
					for (k = 0; k < this.args.length; k++) {
						arg = this.args[k];
						for (i = 0; i < this.tokens.length; i++) {
							if (arg === this.tokens[i][0]) {
								arg = this._getArgumentValue(data[j], this.tokens[i], arg);
								break;
							} else if (typeof arg === 'string') {
								arg = this._populateArgumentValue(data[j], this.tokens[i], arg);
							}
						}
						if (arg === undefined) {
							throw new Error($.ig.Templating.locale.undefinedArgument + this.tokens[i][0]);
						}
						if (typeof arg === 'string') {
							arg = arg.replace(this.regExp.index, j);
						}
						tempArgs.push(arg);
					}
					tempArgs.push(j);
					result += f.call(this, tempArgs) || '';
				}
			}
			return result;
		},
		_getArgumentValue: function (data, token, arg) {
			var tempData, l;
			if (token[1].length && token[1].length > 1) {
				tempData = data;
				for (l = 0; l < token[1].length; l++) {
					// K.D. August 14th, 2012 Bug #118861 When a prop is undefined/null we should not try to evaluate a prop
					if (tempData && tempData.hasOwnProperty(token[1][l])) {
						tempData = tempData[token[1][l]];
					} else {
						tempData = '';
						break;
					}
				}
				if (token[2] && typeof tempData === 'string') {
					arg = this.encode(tempData);
				} else {
					arg = tempData;
				}
			} else {
				if (token[2] && typeof data[token[1]] === 'string') {
					arg = this.encode(data[token[1]]);
				} else {
					arg = data[token[1]];
				}
			}
			return arg;
		},
		_populateArgumentValue: function (data, token, arg) {
			var tempData, l, self = this;
			if (token[1].length && token[1].length > 1) {
				tempData = data;
				for (l = 0; l < token[1].length; l++) {
					// K.D. August 14th, 2012 Bug #118861 When a prop is undefined we should not try to evaluate a prop
					if (tempData && tempData.hasOwnProperty(token[1][l])) {
						tempData = tempData[token[1][l]];
					} else {
						tempData = '';
						break;
					}
				}
				if (token[2] && typeof tempData === 'string') {
					// K.D. June 14th, 2012 Bug #114536 Switching to a function to ignore flag parameters
					// https://developer.mozilla.org/en/JavaScript/Reference/Global_Objects/String/replace
					arg = arg.replace(token[3], function () {
						return self.encode(tempData);
					});
				} else {
					// K.D. June 14th, 2012 Bug #114536 Switching to a function to ignore flag parameters
					// https://developer.mozilla.org/en/JavaScript/Reference/Global_Objects/String/replace
					arg = arg.replace(token[3], function () {
						// K.D. May 7th, 2013 Bug #140356 null values are being returned as "null" and should be ''
						return tempData === null ? '' : tempData;
					});
				}
			} else {
				if (token[2]) {
					// K.D. June 14th, 2012 Bug #114536 Switching to a function to ignore flag parameters
					// https://developer.mozilla.org/en/JavaScript/Reference/Global_Objects/String/replace
				    arg = arg.replace(token[3], function () {
                        // K.D. June 25th, 2014 Bug #173722 Handling function types
						return self.encode(typeof data[token[1]] === "function" ? data[token[1]]() : data[token[1]]);
					});
				} else {
					// K.D. June 14th, 2012 Bug #114536 Switching to a function to ignore flag parameters
					// https://developer.mozilla.org/en/JavaScript/Reference/Global_Objects/String/replace
					arg = arg.replace(token[3], function () {
						// K.D. May 7th, 2013 Bug #140356 null values are being returned as "null" and should be ''
						return data[token[1]] === null ? '' : data[token[1]];
					});
				}
			}
			return arg;
		}
	});

}(jQuery));




/*!@license
* Infragistics.Web.ClientUI infragistics.dv.core.js 14.2.20142.1018
*
* Copyright (c) 2011-2014 Infragistics Inc.
*
* http://www.infragistics.com/
*
* Depends:
*     jquery-1.4.4.js
*     jquery.ui.core.js
*     jquery.ui.widget.js
*     infragistics.util.js
*/

// Declare empty types
$.ig = $.ig || {};
(function ($) {
var $$t = {}
$.ig.$currDefinitions = $$t;
$.ig.util.bulkDefine(["Object:b", 
"Type:c", 
"Boolean:d", 
"ValueType:e", 
"Void:f", 
"IConvertible:g", 
"IFormatProvider:h", 
"Number:i", 
"String:j", 
"IComparable:k", 
"Number:l", 
"Number:m", 
"Number:n", 
"Number:o", 
"NumberStyles:p", 
"Enum:q", 
"Array:r", 
"IList:s", 
"ICollection:t", 
"IEnumerable:u", 
"IEnumerator:v", 
"Number:w", 
"String:x", 
"StringComparison:y", 
"RegExp:z", 
"CultureInfo:aa", 
"Calendar:ab", 
"Date:ac", 
"DayOfWeek:ad", 
"DateTimeKind:ae", 
"Date:af", 
"Error:ag", 
"CompareInfo:ah", 
"CompareOptions:ai", 
"NumberFormatInfo:aj", 
"DateTimeFormatInfo:ak", 
"CalendarWeekRule:al", 
"IEnumerable$1:am", 
"IEnumerator$1:an", 
"IDisposable:ao", 
"StringSplitOptions:ap", 
"Number:aq", 
"Number:ar", 
"Number:as", 
"Number:at", 
"Number:au", 
"Number:av", 
"Assembly:aw", 
"Stream:ax", 
"SeekOrigin:ay", 
"RuntimeTypeHandle:az", 
"MethodInfo:a0", 
"MethodBase:a1", 
"MemberInfo:a2", 
"ParameterInfo:a3", 
"TypeCode:a4", 
"ConstructorInfo:a5", 
"PropertyInfo:a6", 
"APIFactory:a8", 
"Point:a9", 
"Rect:ba", 
"Size:bb", 
"Nullable$1:bc", 
"Math:bd", 
"Color:be", 
"ArgumentException:bf", 
"NotImplementedException:bg", 
"Script:bh", 
"ArgumentNullException:bi", 
"Convert:bl", 
"Environment:bm", 
"IComparable$1:bp", 
"IEquatable$1:bq", 
"InvalidOperationException:by", 
"Predicate$1:bz", 
"MulticastDelegate:b0", 
"IntPtr:b1", 
"IComparer:b3", 
"IEqualityComparer:b4", 
"IComparer$1:b5", 
"IEqualityComparer$1:b6", 
"Random:b7", 
"Tuple$2:b8", 
"List$1:ct", 
"IList$1:cu", 
"ICollection$1:cv", 
"IArray:cw", 
"Enumerable:cx", 
"Func$2:cy", 
"Func$3:cz", 
"IOrderedEnumerable$1:c0", 
"SortedList$1:c1", 
"IArrayList:c2", 
"Array:c3", 
"CompareCallback:c4", 
"Action$1:c5", 
"Comparer$1:c6", 
"DefaultComparer$1:c7", 
"Comparison$1:c8", 
"ReadOnlyCollection$1:c9", 
"UIElement:db", 
"DependencyObject:dc", 
"Dictionary:dd", 
"DependencyProperty:de", 
"PropertyMetadata:df", 
"PropertyChangedCallback:dg", 
"DependencyPropertyChangedEventArgs:dh", 
"UnsetValue:di", 
"DependencyPropertiesCollection:dj", 
"Binding:dk", 
"PropertyPath:dl", 
"Transform:dm", 
"UIElementCollection:dn", 
"ObservableCollection$1:dp", 
"INotifyCollectionChanged:dq", 
"NotifyCollectionChangedEventHandler:dr", 
"NotifyCollectionChangedEventArgs:ds", 
"EventArgs:dt", 
"NotifyCollectionChangedAction:du", 
"INotifyPropertyChanged:dv", 
"PropertyChangedEventHandler:dw", 
"PropertyChangedEventArgs:dx", 
"Delegate:dy", 
"Interlocked:dz", 
"FrameworkElement:d0", 
"Visibility:d1", 
"Style:d2", 
"Control:d3", 
"Thickness:d4", 
"HorizontalAlignment:d5", 
"VerticalAlignment:d6", 
"ContentControl:d7", 
"DataTemplate:d8", 
"DataTemplateRenderHandler:d9", 
"DataTemplateRenderInfo:ea", 
"DataTemplatePassInfo:eb", 
"DataTemplateMeasureHandler:ec", 
"DataTemplateMeasureInfo:ed", 
"DataTemplatePassHandler:ee", 
"PointCollection:eg", 
"Line:em", 
"Shape:en", 
"Brush:eo", 
"DoubleCollection:ep", 
"Path:eq", 
"Geometry:er", 
"GeometryType:es", 
"Polygon:et", 
"Polyline:eu", 
"Rectangle:ev", 
"LinearGradientBrush:ew", 
"GradientStop:ex", 
"FillRule:ey", 
"GeometryCollection:ez", 
"GeometryGroup:e0", 
"LineGeometry:e1", 
"RectangleGeometry:e2", 
"EllipseGeometry:e3", 
"PathGeometry:e4", 
"PathFigureCollection:e5", 
"PathFigure:e6", 
"PathSegmentCollection:e7", 
"PathSegmentType:e8", 
"PathSegment:e9", 
"LineSegment:fa", 
"BezierSegment:fb", 
"PolyBezierSegment:fc", 
"PolyLineSegment:fd", 
"ArcSegment:fe", 
"SweepDirection:ff", 
"PenLineCap:fg", 
"RotateTransform:fi", 
"TranslateTransform:fj", 
"ScaleTransform:fk", 
"TransformGroup:fl", 
"TransformCollection:fm", 
"Key:fn", 
"ModifierKeys:fo", 
"MouseEventArgs:fp", 
"MouseButtonEventArgs:fq", 
"Canvas:fr", 
"Panel:fs", 
"TextBlock:fu", 
"JQueryPromise:fy", 
"Action:fz", 
"JQueryDeferred:f2", 
"JQuery:f3", 
"JQueryObject:f4", 
"Element:f5", 
"ElementAttributeCollection:f6", 
"ElementCollection:f7", 
"WebStyle:f8", 
"ElementNodeType:f9", 
"Document:ga", 
"EventListener:gb", 
"IElementEventHandler:gc", 
"ElementEventHandler:gd", 
"ElementAttribute:ge", 
"JQueryPosition:gf", 
"JQueryCallback:gg", 
"JQueryEvent:gh", 
"JQueryUICallback:gi", 
"StringBuilder:gk", 
"Dictionary$2:hc", 
"IDictionary$2:hd", 
"IDictionary:he", 
"EqualityComparer$1:hf", 
"DefaultEqualityComparer$1:hg", 
"KeyValuePair$2:hi", 
"Debug:hs", 
"AbstractEnumerable:h6", 
"Func$1:h7", 
"AbstractEnumerator:h8", 
"GenericEnumerable$1:ia", 
"GenericEnumerator$1:ib", 
"LinkedList$1:id", 
"LinkedListNode$1:ie", 
"Stack$1:ii", 
"ReverseArrayEnumerator$1:ij"]);

$.ig.util.defType('NotifyCollectionChangedAction', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "Add";
			case 1: return "Remove";
			case 2: return "Replace";
			case 4: return "Reset";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('NotifyCollectionChangedAction', $.ig.Enum.prototype.$type)
}, true);




$.ig.util.defType('ModifierKeys', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "None";
			case 1: return "Alt";
			case 2: return "Control";
			case 4: return "Shift";
			case 8: return "Windows";
			case 8: return "Apple";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('ModifierKeys', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('Key', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "None";
			case 1: return "Back";
			case 2: return "Tab";
			case 3: return "Enter";
			case 4: return "Shift";
			case 5: return "Ctrl";
			case 6: return "Alt";
			case 7: return "CapsLock";
			case 8: return "Escape";
			case 9: return "Space";
			case 10: return "PageUp";
			case 11: return "PageDown";
			case 12: return "End";
			case 13: return "Home";
			case 14: return "Left";
			case 15: return "Up";
			case 16: return "Right";
			case 17: return "Down";
			case 18: return "Insert";
			case 19: return "Delete";
			case 20: return "D0";
			case 21: return "D1";
			case 22: return "D2";
			case 23: return "D3";
			case 24: return "D4";
			case 25: return "D5";
			case 26: return "D6";
			case 27: return "D7";
			case 28: return "D8";
			case 29: return "D9";
			case 30: return "A";
			case 31: return "B";
			case 32: return "C";
			case 33: return "D";
			case 34: return "E";
			case 35: return "F";
			case 36: return "G";
			case 37: return "H";
			case 38: return "I";
			case 39: return "J";
			case 40: return "K";
			case 41: return "L";
			case 42: return "M";
			case 43: return "N";
			case 44: return "O";
			case 45: return "P";
			case 46: return "Q";
			case 47: return "R";
			case 48: return "S";
			case 49: return "T";
			case 50: return "U";
			case 51: return "V";
			case 52: return "W";
			case 53: return "X";
			case 54: return "Y";
			case 55: return "Z";
			case 56: return "F1";
			case 57: return "F2";
			case 58: return "F3";
			case 59: return "F4";
			case 60: return "F5";
			case 61: return "F6";
			case 62: return "F7";
			case 63: return "F8";
			case 64: return "F9";
			case 65: return "F10";
			case 66: return "F11";
			case 67: return "F12";
			case 68: return "NumPad0";
			case 69: return "NumPad1";
			case 70: return "NumPad2";
			case 71: return "NumPad3";
			case 72: return "NumPad4";
			case 73: return "NumPad5";
			case 74: return "NumPad6";
			case 75: return "NumPad7";
			case 76: return "NumPad8";
			case 77: return "NumPad9";
			case 78: return "Multiply";
			case 79: return "Add";
			case 80: return "Subtract";
			case 81: return "Decimal";
			case 82: return "Divide";
			case 255: return "Unknown";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('Key', $.ig.Enum.prototype.$type)
}, true);


$.ig.util.defType('PenLineCap', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "Flat";
			case 1: return "Square";
			case 2: return "Round";
			case 3: return "Triangle";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('PenLineCap', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('SweepDirection', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "Counterclockwise";
			case 1: return "Clockwise";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('SweepDirection', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('PathSegmentType', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "Line";
			case 1: return "Bezier";
			case 2: return "PolyBezier";
			case 3: return "PolyLine";
			case 4: return "Arc";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('PathSegmentType', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('GeometryType', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "Group";
			case 1: return "Line";
			case 2: return "Rectangle";
			case 3: return "Ellipse";
			case 4: return "Path";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('GeometryType', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('FillRule', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "EvenOdd";
			case 1: return "Nonzero";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('FillRule', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('Visibility', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "Visible";
			case 1: return "Collapsed";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('Visibility', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('VerticalAlignment', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "Top";
			case 1: return "Center";
			case 2: return "Bottom";
			case 3: return "Stretch";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('VerticalAlignment', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('HorizontalAlignment', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "Left";
			case 1: return "Center";
			case 2: return "Right";
			case 3: return "Stretch";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('HorizontalAlignment', $.ig.Enum.prototype.$type)
}, true);







$.ig.util.defType('APIFactory', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	createPoint: function (x, y) {
		return {__x: x, __y: y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
	}

	, 
	createRect: function (left, top, width, height) {
		return new $.ig.Rect(0, left, top, width, height);
	}

	, 
	createSize: function (width, height) {
		return new $.ig.Size(1, width, height);
	}

	, 
	createColor: function (value) {
		var ret = new $.ig.Color();
		ret.colorString(value);
		return ret;
	}
	, 
	$type: new $.ig.Type('APIFactory', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('ArgumentException', 'Error', {
	init: function (initNumber, message) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
				case 2:
					this.init2.apply(this, arguments);
					break;
				case 3:
					this.init3.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.Error.prototype.init1.call(this, 1, message);
	}
	, 
	init1: function (initNumber, errorMessage, paramName) {


		$.ig.Error.prototype.init1.call(this, 1, errorMessage);
	}
	, 
	init2: function (initNumber) {


		$.ig.Error.prototype.init.call(this, 0);
			throw new $.ig.NotImplementedException(0);
	}
	, 
	init3: function (initNumber, message, innerException) {


		$.ig.Error.prototype.init2.call(this, 2, message, innerException);
			throw new $.ig.NotImplementedException(0);
	}
	, 
	$type: new $.ig.Type('ArgumentException', $.ig.Error.prototype.$type)
}, true);

$.ig.util.defType('ArgumentNullException', 'Error', {
	init: function (initNumber, argumentName) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
				case 2:
					this.init2.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.Error.prototype.init1.call(this, 1, argumentName + " cannot be null.");
	}
	, 
	init1: function (initNumber) {


		$.ig.Error.prototype.init.call(this, 0);
			throw new $.ig.NotImplementedException(0);
	}
	, 
	init2: function (initNumber, paramName, message) {


		$.ig.Error.prototype.init1.call(this, 1, message);
			throw new $.ig.NotImplementedException(0);
	}
	, 
	$type: new $.ig.Type('ArgumentNullException', $.ig.Error.prototype.$type)
}, true);




$.ig.util.defType('Environment', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	newLine: function () {

			return "\n";
	}
	, 
	$type: new $.ig.Type('Environment', $.ig.Object.prototype.$type)
}, true);


$.ig.util.defType('IComparable$1', 'Object', {
	$type: new $.ig.Type('IComparable$1', null)
}, true);

$.ig.util.defType('IEquatable$1', 'Object', {
	$type: new $.ig.Type('IEquatable$1', null)
}, true);




$.ig.util.defType('InvalidOperationException', 'Error', {
	init: function (initNumber) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
				case 2:
					this.init2.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.Error.prototype.init1.call(this, 1, "Invalid operation");
	}
	, 
	init1: function (initNumber, errorMessage) {


		$.ig.Error.prototype.init1.call(this, 1, errorMessage);
	}
	, 
	init2: function (initNumber, errorMessage, innerException) {


		$.ig.Error.prototype.init2.call(this, 2, errorMessage, innerException);
			throw new $.ig.NotImplementedException(0);
	}
	, 
	$type: new $.ig.Type('InvalidOperationException', $.ig.Error.prototype.$type)
}, true);


$.ig.util.defType('IComparer', 'Object', {
	$type: new $.ig.Type('IComparer', null)
}, true);

$.ig.util.defType('IComparer$1', 'Object', {
	$type: new $.ig.Type('IComparer$1', null)
}, true);


$.ig.util.defType('NotImplementedException', 'Error', {
	init: function (initNumber) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.Error.prototype.init1.call(this, 1, "not implemented");
	}
	, 
	init1: function (initNumber, message) {


		$.ig.Error.prototype.init1.call(this, 1, message);
			throw new $.ig.NotImplementedException(0);
	}
	, 
	$type: new $.ig.Type('NotImplementedException', $.ig.Error.prototype.$type)
}, true);

$.ig.util.defType('Random', 'Object', {

	nextDouble: function () {
		return Math.random();
	}

	, 
	next1: function (value) {
		return $.ig.truncate(Math.round(this.nextDouble() * (value - 1)));
	}

	, 
	next2: function (low, high) {
		return low + $.ig.truncate(Math.round(this.nextDouble() * ((high - low) - 1)));
	}
	, 
	init: function (initNumber) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.Object.prototype.init.call(this);
	}
	, 
	init1: function (initNumber, Seed) {


		$.ig.Object.prototype.init.call(this);
	}

	, 
	next: function () {
		return 0;
	}
	, 
	$type: new $.ig.Type('Random', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('Tuple$2', 'Object', {
	$t1: null, 
	$t2: null
	, 
	_item1: null,
	item1: function (value) {
		if (arguments.length === 1) {
			this._item1 = value;
			return value;
		} else {
			return this._item1;
		}
	}

	, 
	_item2: null,
	item2: function (value) {
		if (arguments.length === 1) {
			this._item2 = value;
			return value;
		} else {
			return this._item2;
		}
	}
	, 
	init: function ($t1, $t2, item1, item2) {

		this.$t1 = $t1;
		this.$t2 = $t2;
		this.$type = this.$type.specialize(this.$t1, this.$t2);


		$.ig.Object.prototype.init.call(this);
			this.item1(item1);
			this.item2(item2);
	}
	, 
	$type: new $.ig.Type('Tuple$2', $.ig.Object.prototype.$type)
}, true);













$.ig.util.defType('DependencyObject', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this._localValues = new $.ig.Dictionary(0);
			this._bindings = new $.ig.Dictionary(0);
	}
	, 
	_localValues: null
	, 
	_bindings: null

	, 
	getValue: function (dp) {
		if (this._localValues.containsKey(dp.name())) {
			return this._localValues.item(dp.name());
		}

		return dp.propertyMetadata().defaultValue();
	}

	, 
	setValue: function (dp_, value) {
		if (dp_.hasCallback()) {
			var oldValue_ = null;
			var old = this._localValues.proxy[dp_.__name]; if (typeof old != 'undefined') { oldValue_ = old };
			this._localValues.item(dp_.__name, value);
			dp_.propertyMetadata().propertyChangedCallback()(this, new $.ig.DependencyPropertyChangedEventArgs(dp_, value, oldValue_));

		} else {
			this._localValues.item(dp_.__name, value);
		}

	}

	, 
	clearValue: function (dp) {
		this._localValues.remove(dp.__name);
	}

	, 
	readLocalValue: function (dp) {
		if (this._localValues.containsKey(dp.__name)) {
		return this._localValues.item(dp.name());
		}

		return $.ig.DependencyProperty.prototype.unsetValue;
	}

	, 
	setBinding: function (dp, binding) {
		if (dp == null) {
			return;
		}

		this._bindings.item(dp.name(), binding);
	}
	, 
	$type: new $.ig.Type('DependencyObject', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('UIElement', 'DependencyObject', {
	init: function () {


		$.ig.DependencyObject.prototype.init.call(this);

	}
	, 
	_renderTransform: null,
	renderTransform: function (value) {
		if (arguments.length === 1) {
			this._renderTransform = value;
			return value;
		} else {
			return this._renderTransform;
		}
	}
	, 
	$type: new $.ig.Type('UIElement', $.ig.DependencyObject.prototype.$type)
}, true);

$.ig.util.defType('IArray', 'Object', {
	$type: new $.ig.Type('IArray', null)
}, true);

$.ig.util.defType('List$1', 'Object', {
	$t: null, 
	__inner: null
	, 
	init: function ($t, initNumber) {

		this.$t = $t;
		this.$type = this.$type.specialize(this.$t);

		this.__syncRoot = {};
		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
				case 2:
					this.init2.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.Object.prototype.init.call(this);
			this.__inner = [];
	}
	, 
	init1: function ($t, initNumber, source) {

		this.$t = $t;
		this.$type = this.$type.specialize(this.$t);

		$.ig.List$1.prototype.init.call(this, this.$t, 0);
			if (this.tryArray(0, source)) {
				return;
			}

			var en = source.getEnumerator();
			while (en.moveNext()) {
				var item = en.current();
				this.add1(item);
			}

	}
	, 
	init2: function ($t, initNumber, capacity) {

		this.$t = $t;
		this.$type = this.$type.specialize(this.$t);

		$.ig.List$1.prototype.init.call(this, this.$t, 0);
	}

	, 
	setItem: function (index, newItem) {
		this.__inner[index] = newItem;
	}

	, 
	insertItem: function (index_, newItem_) {
		this.__inner.splice(index_, 0, newItem_);
	}

	, 
	addItem: function (newItem_) {
		this.__inner.push(newItem_);
	}

	, 
	removeItem: function (index_) {
		this.__inner.splice(index_, 1);
	}

	, 
	clearItems: function () {
		this.__inner = [];
	}

	, 
	item: function (index, value) {
		if (arguments.length === 2) {

			this.setItem(index, value);
			return value;
		} else {

			return this.__inner[index];
		}
	}

	, 
	indexOf: function (item_) {
		return this.__inner.indexOf(item_);
	}

	, 
	indexOf2: function (item_, index_) {
		return this.__inner.indexOf(item_, index_);
	}

	, 
	lastIndexOf: function (item_) {
		return this.__inner.lastIndexOf(item_);
	}

	, 
	insert: function (index, item) {
		this.insertItem(index, item);
	}

	, 
	removeAt: function (index) {
		this.removeItem(index);
	}

	, 
	count: function () {

			return this.__inner.length;
	}

	, 
	isReadOnly: function () {

			return false;
	}

	, 
	add1: function (item) {
		this.addItem(item);
	}

	, 
	clear: function () {
		this.clearItems();
	}

	, 
	contains1: function (item) {
		return $.ig.Enumerable.prototype.contains$1(this.$t, this.__inner, item);
	}

	, 
	copyTo: function (array, arrayIndex) {
		for (var i = 0; i < this.__inner.length; i++) {
			array[arrayIndex + i] = this.__inner[i];
		}

	}

	, 
	remove1: function (item) {
		var indexOf = this.indexOf(item);
		if (indexOf < 0) {
			return false;
		}

		this.removeItem(indexOf);
		return true;
	}

	, 
	getEnumerator: function () {
		return this.__inner.getEnumerator();
	}

	, 
	getEnumerator: function () {
		return this.__inner.getEnumerator();
	}

	, 
	asArray: function () {
		return this.__inner;
	}

	, 
	tryArray: function (index_, collection_) {
		var asArrayList = $.ig.util.cast($.ig.IArrayList.prototype.$type, collection_);
		if (asArrayList != null) {
			var a_ = asArrayList.asArrayList();
			Array.prototype.splice.apply(this.__inner, Array.prototype.concat.apply([index_, 0], a_));
			return true;
		}

		var asArray = $.ig.util.cast($.ig.IArray.prototype.$type, collection_);
		if (asArray != null) {
			var a_ = asArray.asArray();
			Array.prototype.splice.apply(this.__inner, Array.prototype.concat.apply([index_, 0], a_));
			return true;
		}

		var asList_ = $.ig.util.cast($.ig.IList$1.prototype.$type.specialize(this.$t), collection_);
		if (asList_ != null) {
			for (var i_ = 0; i_ < asList_.count(); i_++) {
				var item_ = asList_.item(i_);
				this.__inner.splice(index_ + i_, 0, item_);
			}

			return true;
		}

		var arr_ = $.isArray(collection_) ? collection_ : null;;
		if (arr_ != null) {
			var inn_ = this.__inner;
			if (this.__inner.length == 0) {
				for (var i_ = 0; i_ < arr_.length; i_++) {
					inn_[index_++] = $.ig.util.getValueIfEnum(this.$t, arr_[i_]);
				}


			} else {
				for (var i_ = 0; i_ < arr_.length; i_++) {
					inn_.splice(index_++, 0, arr_[i_]);
				}

			}

			return true;
		}

		return false;
	}

	, 
	insertRange1: function (index, collection) {
		if (this.tryArray(index, collection)) {
			return;
		}

		var j_ = index;
		var en = collection.getEnumerator();
		while (en.moveNext()) {
			var item_ = en.current();
			this.__inner.splice(j_, 0, item_);
			j_++;
		}

	}

	, 
	insertRange: function (index, collection) {
		if (this.tryArray(index, collection)) {
			return;
		}

		var j_ = index;
		var en = collection.getEnumerator();
		while (en.moveNext()) {
			var item_ = en.current();
			this.__inner.splice(j_, 0, item_);
			j_++;
		}

	}

	, 
	removeRange: function (index_, numToRemove_) {
		this.__inner.splice(index_, numToRemove_);
	}

	, 
	copyTo1: function (array, index) {
		$.ig.util.arrayCopyTo(this.__inner, array, index);
	}

	, 
	isFixedSize: function () {

			return false;
	}

	, 
	add: function (value) {
		this.addItem($.ig.util.getValueIfEnum(this.$t, value));
		return this.__inner.length - 1;
	}

	, 
	contains: function (item_) {
		return this.__inner.indexOf(item_) >= 0;
	}

	, 
	indexOf1: function (item_) {
		return this.__inner.indexOf(item_);
	}

	, 
	insert1: function (index, value) {
		this.insertItem(index, $.ig.util.getValueIfEnum(this.$t, value));
	}

	, 
	remove: function (value) {
		var indexOf = this.indexOf1(value);
		this.removeItem(indexOf);
	}

	, 
	sort: function () {
		var $self = this;
		var c = null;
		if ($self.$t == Number) {
			c = function (n1, n2) {
					var d1 = n1;
					var d2 = n2;
					if (d1 < d2) {
						return -1;
					}

					if (d1 == d2) {
						return 0;
					}

					return 1;
			};

		} else if ($self.$t == $.ig.Number.prototype.$type) {
			c = function (n1, n2) {
					var f1 = n1;
					var f2 = n2;
					if (f1 < f2) {
						return -1;
					}

					if (f1 == f2) {
						return 0;
					}

					return 1;
			};

		} else if ($self.$t == $.ig.Number.prototype.$type) {
			c = function (n1, n2) {
					var i1 = $.ig.util.getValue(n1);
					var i2 = $.ig.util.getValue(n2);
					if (i1 < i2) {
						return -1;
					}

					if (i1 == i2) {
						return 0;
					}

					return 1;
			};

		} else if ($self.$t == $.ig.Date.prototype.$type) {
			c = function (n1, n2) {
					var d1 = n1;
					var d2 = n2;
					if (d1.getTime() < d2.getTime()) {
						return -1;
					}

					if (d1.getTime() == d2.getTime()) {
						return 0;
					}

					return 1;
			};

		} else {
			c = function (n1, n2) {
					return (n1).compareTo(n2);
			};
		}




		$self.sortHelper(c);
	}

	, 
	sortHelper: function (compare_) {
		this.__inner.sort(compare_);
	}

	, 
	sort2: function (compare_) {
		this.__inner.sort(compare_);
	}

	, 
	_capacity: 0,
	capacity: function (value) {
		if (arguments.length === 1) {
			this._capacity = value;
			return value;
		} else {
			return this._capacity;
		}
	}

	, 
	addRange: function (values) {
		var en = values.getEnumerator();
		while (en.moveNext()) {
			var item_ = en.current();
			this.__inner.push(item_);
		}

	}

	, 
	toArray: function () {
		return this.__inner;
	}

	, 
	forEach: function (action) {
		for (var i = 0; i < this.__inner.length; i++) {
			action(this.__inner[i]);
		}

	}

	, 
	isSynchronized: function () {

			return true;
	}
	, 
	__syncRoot: null

	, 
	syncRoot: function () {

			return this.__syncRoot;
	}

	, 
	binarySearch: function (item) {
		return this.binarySearch1(item, $.ig.Comparer$1.prototype.defaultComparerValue(this.$t));
	}

	, 
	binarySearch1: function (item, comparer) {
		var start = 0;
		var end = this.count() - 1;
		while (start <= end) {
			var mid = start + ($.ig.intDivide((end - start), 2));
			var testValue = this.__inner[mid];
			var compareResult = comparer.compare(testValue, item);
			if (compareResult == 0) {
			return mid;
			}

			if (compareResult < 0) {
			start = mid + 1;

			} else {
			end = mid - 1;
			}


		}
		return ~start;
	}

	, 
	asReadOnly: function () {
		return new $.ig.ReadOnlyCollection$1(this.$t, 1, this);
	}

	, 
	reverse: function () {
		for (var i = 0; i < $.ig.intDivide(this.count(), 2); i++) {
			var other = this.count() - i - 1;
			var temp = this.__inner[i];
			this.__inner[i] = this.__inner[other];
			this.__inner[other] = temp;
		}

	}

	, 
	sort1: function (comparer) {
		this.sort2(comparer.compare.runOn(comparer));
	}

	, 
	removeAll: function (match) {
		throw new $.ig.NotImplementedException(0);
		return 0;
	}
	, 
	$type: new $.ig.Type('List$1', $.ig.Object.prototype.$type, [$.ig.IList$1.prototype.$type.specialize(0), $.ig.IArray.prototype.$type, $.ig.IList.prototype.$type])
}, true);

$.ig.util.defType('INotifyCollectionChanged', 'Object', {
	$type: new $.ig.Type('INotifyCollectionChanged', null)
}, true);

$.ig.util.defType('ObservableCollection$1', 'List$1', {
	$t: null, 
	init: function ($t, initNumber) {

		this.$t = $t;
		this.$type = this.$type.specialize(this.$t);

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
				case 2:
					this.init2.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.List$1.prototype.init.call(this, this.$t, 0);
	}
	, 
	init1: function ($t, initNumber, source) {

		this.$t = $t;
		this.$type = this.$type.specialize(this.$t);

		$.ig.List$1.prototype.init1.call(this, this.$t, 1, source);
	}
	, 
	init2: function ($t, initNumber, capacity) {

		this.$t = $t;
		this.$type = this.$type.specialize(this.$t);

		$.ig.List$1.prototype.init2.call(this, this.$t, 2, capacity);
	}

	, 
	setItem: function (index, newItem) {
		var oldItem = this.__inner[index];
		$.ig.List$1.prototype.setItem.call(this, index, newItem);
		if (this.propertyChanged != null) {
			this.onPropertyChanged(new $.ig.PropertyChangedEventArgs("Item[]"));
		}

		if (this.collectionChanged != null) {
			var args = new $.ig.NotifyCollectionChangedEventArgs(2, $.ig.NotifyCollectionChangedAction.prototype.replace, $.ig.util.getBoxIfEnum(this.$t, newItem), $.ig.util.getBoxIfEnum(this.$t, oldItem), index);
			this.onCollectionChanged(args);
		}

	}

	, 
	clearItems: function () {
		$.ig.List$1.prototype.clearItems.call(this);
		if (this.propertyChanged != null) {
			this.onPropertyChanged(new $.ig.PropertyChangedEventArgs("Count"));
			this.onPropertyChanged(new $.ig.PropertyChangedEventArgs("Item[]"));
		}

		if (this.collectionChanged != null) {
			var args = new $.ig.NotifyCollectionChangedEventArgs(0, $.ig.NotifyCollectionChangedAction.prototype.reset);
			this.onCollectionChanged(args);
		}

	}

	, 
	insertItem: function (index, newItem) {
		$.ig.List$1.prototype.insertItem.call(this, index, newItem);
		if (this.propertyChanged != null) {
			this.onPropertyChanged(new $.ig.PropertyChangedEventArgs("Count"));
			this.onPropertyChanged(new $.ig.PropertyChangedEventArgs("Item[]"));
		}

		if (this.collectionChanged != null) {
			var args = new $.ig.NotifyCollectionChangedEventArgs(1, $.ig.NotifyCollectionChangedAction.prototype.add, $.ig.util.getBoxIfEnum(this.$t, newItem), index);
			this.onCollectionChanged(args);
		}

	}

	, 
	addItem: function (newItem) {
		$.ig.List$1.prototype.addItem.call(this, newItem);
		if (this.propertyChanged != null) {
			this.onPropertyChanged(new $.ig.PropertyChangedEventArgs("Count"));
			this.onPropertyChanged(new $.ig.PropertyChangedEventArgs("Item[]"));
		}

		if (this.collectionChanged != null) {
			var args = new $.ig.NotifyCollectionChangedEventArgs(1, $.ig.NotifyCollectionChangedAction.prototype.add, $.ig.util.getBoxIfEnum(this.$t, newItem), this.count() - 1);
			this.onCollectionChanged(args);
		}

	}

	, 
	removeItem: function (index) {
		var oldItem = this.__inner[index];
		$.ig.List$1.prototype.removeItem.call(this, index);
		if (this.propertyChanged != null) {
			this.onPropertyChanged(new $.ig.PropertyChangedEventArgs("Count"));
			this.onPropertyChanged(new $.ig.PropertyChangedEventArgs("Item[]"));
		}

		if (this.collectionChanged != null) {
			var args = new $.ig.NotifyCollectionChangedEventArgs(1, $.ig.NotifyCollectionChangedAction.prototype.remove, $.ig.util.getBoxIfEnum(this.$t, oldItem), index);
			this.onCollectionChanged(args);
		}

	}
	, 
	collectionChanged: null, 
	propertyChanged: null
	, 
	onPropertyChanged: function (args) {
		if (this.propertyChanged != null) {
			this.propertyChanged(this, args);
		}

	}

	, 
	onCollectionChanged: function (args) {
		if (this.collectionChanged != null) {
			this.collectionChanged(this, args);
		}

	}
	, 
	$type: new $.ig.Type('ObservableCollection$1', $.ig.List$1.prototype.$type.specialize(0), [$.ig.INotifyCollectionChanged.prototype.$type, $.ig.INotifyPropertyChanged.prototype.$type])
}, true);

$.ig.util.defType('UIElementCollection', 'ObservableCollection$1', {
	__owner: null
	, 
	init: function (owner) {



		$.ig.ObservableCollection$1.prototype.init.call(this, $.ig.UIElement.prototype.$type, 0);
			this.__owner = owner;
	}

	, 
	onCollectionChanged: function (args) {
		$.ig.ObservableCollection$1.prototype.onCollectionChanged.call(this, args);
		if (args.oldItems() != null) {
			var en = args.oldItems().getEnumerator();
			while (en.moveNext()) {
				var item = en.current();
				(item).parent(null);
			}

		}

		if (args.newItems() != null) {
			var en1 = args.newItems().getEnumerator();
			while (en1.moveNext()) {
				var item1 = en1.current();
				(item1).parent(this.__owner);
			}

		}

	}

	, 
	clearItems: function () {
		var en = this.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			(item).parent(null);
		}

		$.ig.ObservableCollection$1.prototype.clearItems.call(this);
	}
	, 
	$type: new $.ig.Type('UIElementCollection', $.ig.ObservableCollection$1.prototype.$type.specialize($.ig.UIElement.prototype.$type))
}, true);

$.ig.util.defType('FrameworkElement', 'UIElement', {
	init: function () {


		this.__opacity = 1;

		$.ig.UIElement.prototype.init.call(this);
			this.__opacity = 1;
			this.canvasZIndex(0);
			this.__visibility = $.ig.Visibility.prototype.visible;
			this.width(NaN);
			this.height(NaN);
	}

	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	_actualWidth: 0,
	actualWidth: function (value) {
		if (arguments.length === 1) {
			this._actualWidth = value;
			return value;
		} else {
			return this._actualWidth;
		}
	}

	, 
	_actualHeight: 0,
	actualHeight: function (value) {
		if (arguments.length === 1) {
			this._actualHeight = value;
			return value;
		} else {
			return this._actualHeight;
		}
	}
	, 
	__visibility: 0

	, 
	visibility: function (value) {
		if (arguments.length === 1) {

			this.__visibility = value;
			return value;
		} else {

			return this.__visibility;
		}
	}

	, 
	_width: 0,
	width: function (value) {
		if (arguments.length === 1) {
			this._width = value;
			return value;
		} else {
			return this._width;
		}
	}

	, 
	_height: 0,
	height: function (value) {
		if (arguments.length === 1) {
			this._height = value;
			return value;
		} else {
			return this._height;
		}
	}

	, 
	_canvasTop: 0,
	canvasTop: function (value) {
		if (arguments.length === 1) {
			this._canvasTop = value;
			return value;
		} else {
			return this._canvasTop;
		}
	}

	, 
	_canvasLeft: 0,
	canvasLeft: function (value) {
		if (arguments.length === 1) {
			this._canvasLeft = value;
			return value;
		} else {
			return this._canvasLeft;
		}
	}

	, 
	_canvasZIndex: 0,
	canvasZIndex: function (value) {
		if (arguments.length === 1) {
			this._canvasZIndex = value;
			return value;
		} else {
			return this._canvasZIndex;
		}
	}

	, 
	_parent: null,
	parent: function (value) {
		if (arguments.length === 1) {
			this._parent = value;
			return value;
		} else {
			return this._parent;
		}
	}

	, 
	_dataContext: null,
	dataContext: function (value) {
		if (arguments.length === 1) {
			this._dataContext = value;
			return value;
		} else {
			return this._dataContext;
		}
	}
	, 
	__opacity: 0

	, 
	opacity: function (value) {
		if (arguments.length === 1) {

			this.__opacity = value;
			this.onOpacityChanged();
			return value;
		} else {

			return this.__opacity;
		}
	}

	, 
	onOpacityChanged: function () {
	}

	, 
	_style: null,
	style: function (value) {
		if (arguments.length === 1) {
			this._style = value;
			return value;
		} else {
			return this._style;
		}
	}
	, 
	$type: new $.ig.Type('FrameworkElement', $.ig.UIElement.prototype.$type)
}, true);

$.ig.util.defType('Control', 'FrameworkElement', {
	init: function () {



		$.ig.FrameworkElement.prototype.init.call(this);
	}

	, 
	_defaultStyleKey: null,
	defaultStyleKey: function (value) {
		if (arguments.length === 1) {
			this._defaultStyleKey = value;
			return value;
		} else {
			return this._defaultStyleKey;
		}
	}

	, 
	_padding: null,
	padding: function (value) {
		if (arguments.length === 1) {
			this._padding = value;
			return value;
		} else {
			return this._padding;
		}
	}

	, 
	onApplyTemplate: function () {
	}

	, 
	_horizontalContentAlignment: 0,
	horizontalContentAlignment: function (value) {
		if (arguments.length === 1) {
			this._horizontalContentAlignment = value;
			return value;
		} else {
			return this._horizontalContentAlignment;
		}
	}

	, 
	_verticalContentAlignment: 0,
	verticalContentAlignment: function (value) {
		if (arguments.length === 1) {
			this._verticalContentAlignment = value;
			return value;
		} else {
			return this._verticalContentAlignment;
		}
	}
	, 
	$type: new $.ig.Type('Control', $.ig.FrameworkElement.prototype.$type)
}, true);

$.ig.util.defType('ContentControl', 'Control', {
	init: function () {


		$.ig.Control.prototype.init.call(this);

	}
	, 
	_content: null,
	content: function (value) {
		if (arguments.length === 1) {
			this._content = value;
			return value;
		} else {
			return this._content;
		}
	}

	, 
	_contentTemplate: null,
	contentTemplate: function (value) {
		if (arguments.length === 1) {
			this._contentTemplate = value;
			return value;
		} else {
			return this._contentTemplate;
		}
	}
	, 
	$type: new $.ig.Type('ContentControl', $.ig.Control.prototype.$type)
}, true);


$.ig.util.defType('DataTemplate', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	_render: null,
	render: function (value) {
		if (arguments.length === 1) {
			this._render = value;
			return value;
		} else {
			return this._render;
		}
	}

	, 
	_measure: null,
	measure: function (value) {
		if (arguments.length === 1) {
			this._measure = value;
			return value;
		} else {
			return this._measure;
		}
	}

	, 
	_passStarting: null,
	passStarting: function (value) {
		if (arguments.length === 1) {
			this._passStarting = value;
			return value;
		} else {
			return this._passStarting;
		}
	}

	, 
	_passCompleted: null,
	passCompleted: function (value) {
		if (arguments.length === 1) {
			this._passCompleted = value;
			return value;
		} else {
			return this._passCompleted;
		}
	}
	, 
	$type: new $.ig.Type('DataTemplate', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('DataTemplatePassInfo', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}, 
	renderContext: null
	, 
	context: null
	, 
	viewportTop: 0
	, 
	viewportLeft: 0
	, 
	viewportWidth: 0
	, 
	viewportHeight: 0
	, 
	isHitTestRender: false
	, 
	passID: null
	, 
	$type: new $.ig.Type('DataTemplatePassInfo', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('DataTemplateMeasureInfo', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}, 
	renderContext: null
	, 
	context: null
	, 
	width: 0
	, 
	height: 0
	, 
	isConstant: false
	, 
	data: null
	, 
	passInfo: null
	, 
	renderOffsetX: 0
	, 
	renderOffsetY: 0
	, 
	$type: new $.ig.Type('DataTemplateMeasureInfo', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('DataTemplateRenderInfo', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}, 
	renderContext: null
	, 
	context: null
	, 
	xPosition: 0
	, 
	yPosition: 0
	, 
	availableWidth: 0
	, 
	availableHeight: 0
	, 
	data: null
	, 
	isHitTestRender: false
	, 
	passInfo: null
	, 
	renderOffsetX: 0
	, 
	renderOffsetY: 0
	, 
	$type: new $.ig.Type('DataTemplateRenderInfo', $.ig.Object.prototype.$type)
}, true);




$.ig.util.defType('DependencyProperty', 'Object', {
	__name: null
	, 
	__propertyType: null
	, 
	__propertyMetadata: null
	, 
	__hasCallback: false

	, 
	hasCallback: function () {

			return this.__hasCallback;
	}
	, 
	init: function (name, propertyType, propertyMetadata) {


		this.__hasCallback = false;

		$.ig.Object.prototype.init.call(this);
			this.__name = name;
			this.__propertyType = propertyType;
			this.__propertyMetadata = propertyMetadata;
			if (this.__propertyMetadata != null && this.__propertyMetadata.propertyChangedCallback() != null) {
				this.__hasCallback = true;

			} else {
				this.__hasCallback = false;
			}

	}

	, 
	propertyMetadata: function () {

			return this.__propertyMetadata;
	}

	, 
	propertyType: function () {

			return this.__propertyType;
	}

	, 
	name: function () {

			return this.__name;
	}

	, 
	register: function (name, propertyType, ownerType, propertyMetadata) {
		return $.ig.DependencyPropertiesCollection.prototype.instance().register(name, propertyType, ownerType, propertyMetadata);
	}

	, 
	queryRegisteredProperty: function (name, ownerType) {
		if (ownerType == null) {
			return null;
		}

		var dp = $.ig.DependencyPropertiesCollection.prototype.instance().getProperty(ownerType.typeName() + name);
		if (dp != null) {
			return dp;
		}

		return $.ig.DependencyProperty.prototype.queryRegisteredProperty(name, ownerType.baseType);
	}
	, 
	$type: new $.ig.Type('DependencyProperty', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('UnsetValue', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('UnsetValue', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('DependencyPropertiesCollection', 'Object', {
	__dependencyProperties: null

	, 
	instance: function () {

			if ($.ig.DependencyPropertiesCollection.prototype.__instance == null) {
				$.ig.DependencyPropertiesCollection.prototype.__instance = new $.ig.DependencyPropertiesCollection();
			}

			return $.ig.DependencyPropertiesCollection.prototype.__instance;
	}
	, 
	init: function () {



		$.ig.Object.prototype.init.call(this);
			if (this.__dependencyProperties == null) {
				this.__dependencyProperties = new $.ig.Dictionary(0);
			}

	}

	, 
	getProperty: function (key) {
		return this.__dependencyProperties.item(key);
	}

	, 
	register: function (name, propertyType, ownerType, propertyMetadata) {
		var dependencyProperty = new $.ig.DependencyProperty(name, propertyType, propertyMetadata);
		this.__dependencyProperties.item(ownerType.typeName() + name, dependencyProperty);
		return dependencyProperty;
	}
	, 
	$type: new $.ig.Type('DependencyPropertiesCollection', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('DependencyPropertyChangedEventArgs', 'Object', {
	__newValue: null
	, 
	__oldValue: null
	, 
	init: function (dp, newValue, oldValue) {



		$.ig.Object.prototype.init.call(this);
			this.__newValue = newValue;
			this.__oldValue = oldValue;
			this.__property = dp;
	}
	, 
	__property: null

	, 
	property: function (value) {
		if (arguments.length === 1) {

			this.__property = value;
			return value;
		} else {

			return this.__property;
		}
	}

	, 
	newValue: function () {

			return this.__newValue;
	}

	, 
	oldValue: function () {

			return this.__oldValue;
	}
	, 
	$type: new $.ig.Type('DependencyPropertyChangedEventArgs', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('Thickness', 'Object', {
	init: function (initNumber, uniformLength) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.Object.prototype.init.call(this);
			this.bottom(this.left(this.right(this.top(uniformLength))));
	}
	, 
	init1: function (initNumber, left, top, right, bottom) {


		$.ig.Object.prototype.init.call(this);
			this.left(left);
			this.top(top);
			this.right(right);
			this.bottom(bottom);
	}

	, 
	_bottom: 0,
	bottom: function (value) {
		if (arguments.length === 1) {
			this._bottom = value;
			return value;
		} else {
			return this._bottom;
		}
	}

	, 
	_left: 0,
	left: function (value) {
		if (arguments.length === 1) {
			this._left = value;
			return value;
		} else {
			return this._left;
		}
	}

	, 
	_right: 0,
	right: function (value) {
		if (arguments.length === 1) {
			this._right = value;
			return value;
		} else {
			return this._right;
		}
	}

	, 
	_top: 0,
	top: function (value) {
		if (arguments.length === 1) {
			this._top = value;
			return value;
		} else {
			return this._top;
		}
	}

	, 
	equals: function (thickness) {
		return this.bottom() == thickness.bottom() && this.top() == thickness.top() && this.left() == thickness.left() && this.right() == thickness.right();
	}

	, 
	toString: function () {
		var marginsInfo = this.left().toString() + "," + this.top().toString() + "," + this.right().toString() + "," + this.bottom().toString();
		return marginsInfo;
	}
	, 
	$type: new $.ig.Type('Thickness', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('Point', 'Object', {
	init: function (initNumber) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.Object.prototype.init.call(this);
			this.__x = 0;
			this.__y = 0;
	}

	, 
	x: function (value) {
		if (arguments.length === 1) {

			this.__x = value;
			return value;
		} else {

			return this.__x;
		}
	}

	, 
	y: function (value) {
		if (arguments.length === 1) {

			this.__y = value;
			return value;
		} else {

			return this.__y;
		}
	}
	, 
	__x: 0
	, 
	__y: 0
	, 
	init1: function (initNumber, x, y) {


		$.ig.Object.prototype.init.call(this);
			this.__x = x;
			this.__y = y;
	}

	, 
	equals: function (obj) {
		if (obj == null) {
			return $.ig.Object.prototype.equals.call(this, obj);
		}

		var other = obj;
		return other.__x == this.__x && other.__y == this.__y;
	}
	, 
	$type: new $.ig.Type('Point', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('PointCollection', 'List$1', {
	init: function (initNumber) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.List$1.prototype.init.call(this, $.ig.Point.prototype.$type, 0);
	}
	, 
	init1: function (initNumber, source_) {


		$.ig.List$1.prototype.init.call(this, $.ig.Point.prototype.$type, 0);
			this.__inner = source_.__inner;
	}
	, 
	$type: new $.ig.Type('PointCollection', $.ig.List$1.prototype.$type.specialize($.ig.Point.prototype.$type))
}, true);



$.ig.util.defType('PropertyMetadata', 'Object', {
	__defaultValue: null

	, 
	defaultValue: function (value) {
		if (arguments.length === 1) {

			this.__defaultValue = value;
			return value;
		} else {

			return this.__defaultValue;
		}
	}
	, 
	__propertyChangedCallback: null

	, 
	propertyChangedCallback: function (value) {
		if (arguments.length === 1) {

			this.__propertyChangedCallback = value;
			return value;
		} else {

			return this.__propertyChangedCallback;
		}
	}
	, 
	init: function (initNumber, defaultValue) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
				case 2:
					this.init2.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.Object.prototype.init.call(this);
			this.defaultValue(defaultValue);
			this.propertyChangedCallback(null);
	}
	, 
	init1: function (initNumber, propertyChangedCallback) {


		$.ig.Object.prototype.init.call(this);
			this.defaultValue(null);
			this.propertyChangedCallback(propertyChangedCallback);
	}
	, 
	init2: function (initNumber, defaultValue, propertyChangedCallback) {


		$.ig.Object.prototype.init.call(this);
			this.defaultValue(defaultValue);
			this.propertyChangedCallback(propertyChangedCallback);
	}
	, 
	$type: new $.ig.Type('PropertyMetadata', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('PropertyPath', 'Object', {
	__path: null

	, 
	path: function (value) {
		if (arguments.length === 1) {

			this.__path = value;
			return value;
		} else {

			return this.__path;
		}
	}
	, 
	init: function (path) {



		$.ig.Object.prototype.init.call(this);
			this.path(path);
	}
	, 
	$type: new $.ig.Type('PropertyPath', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('Rect', 'Object', {
	init: function (initNumber, left, top, width, height) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
				case 2:
					this.init2.apply(this, arguments);
					break;
				case 3:
					this.init3.apply(this, arguments);
					break;
				case 4:
					this.init4.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.Object.prototype.init.call(this);
			this.top(top);
			this.left(left);
			this.width(width);
			this.height(height);
	}
	, 
	init1: function (initNumber, left, top, size) {


		$.ig.Object.prototype.init.call(this);
			this.top(top);
			this.left(left);
			this.width(size.width());
			this.height(size.height());
	}
	, 
	init2: function (initNumber, point1, point2) {


		$.ig.Object.prototype.init.call(this);
			this.top(Math.min(point1.__y, point2.__y));
			this.left(Math.min(point1.__x, point2.__x));
			this.width(Math.max(Math.max(point1.__x, point2.__x) - this.left(), 0));
			this.height(Math.max(Math.max(point1.__y, point2.__y) - this.top(), 0));
	}
	, 
	init3: function (initNumber, point1, size) {


		$.ig.Object.prototype.init.call(this);
			this.top(point1.__y);
			this.left(point1.__x);
			this.width(size.width());
			this.height(size.height());
	}
	, 
	init4: function (initNumber) {


		$.ig.Object.prototype.init.call(this);
			this.top(0);
			this.left(0);
			this.width(0);
			this.height(0);
	}
	, 
	__x: 0

	, 
	x: function (value) {
		if (arguments.length === 1) {

			this.__x = value;
			this.__left = this.__x;
			this.__right = this.__left + this.__width;
			return value;
		} else {

			return this.__x;
		}
	}
	, 
	__y: 0

	, 
	y: function (value) {
		if (arguments.length === 1) {

			this.__y = value;
			this.__top = this.__y;
			this.__bottom = this.__top + this.__height;
			return value;
		} else {

			return this.__y;
		}
	}
	, 
	__width: 0

	, 
	width: function (value) {
		if (arguments.length === 1) {

			this.__width = value;
			this.__right = this.__left + this.__width;
			return value;
		} else {

			return this.__width;
		}
	}
	, 
	__height: 0

	, 
	height: function (value) {
		if (arguments.length === 1) {

			this.__height = value;
			this.__bottom = this.__top + this.__height;
			return value;
		} else {

			return this.__height;
		}
	}
	, 
	__top: 0

	, 
	top: function (value) {
		if (arguments.length === 1) {

			this.__top = value;
			this.y(this.__top);
			return value;
		} else {

			return this.__top;
		}
	}
	, 
	__left: 0

	, 
	left: function (value) {
		if (arguments.length === 1) {

			this.__left = value;
			this.x(this.__left);
			return value;
		} else {

			return this.__left;
		}
	}
	, 
	__right: 0

	, 
	right: function (value) {
		if (arguments.length === 1) {

			this.__right = value;
			this.__width = this.__right - this.__left;
			return value;
		} else {

			return this.__right;
		}
	}
	, 
	__bottom: 0

	, 
	bottom: function (value) {
		if (arguments.length === 1) {

			this.__bottom = value;
			this.__height = this.__bottom - this.__top;
			return value;
		} else {

			return this.__bottom;
		}
	}

	, 
	isEmpty: function () {

			return this.__width < 0;
	}

	, 
	empty: function () {

			return new $.ig.Rect(0, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY, Number.NEGATIVE_INFINITY, Number.NEGATIVE_INFINITY);
	}

	, 
	equals1: function (value) {
		if (value == null) {
			return false;
		}

		if (value.x() == this.x() && value.y() == this.y() && value.width() == this.width() && value.height() == this.height()) {
			return true;
		}

		return false;
	}

	, 
	containsInternal: function (x, y) {
		return x >= this.__x && x - this.__width <= this.__x && y >= this.__y && y - this.__height <= this.__y;
	}

	, 
	containsLocation: function (x, y) {
		return !this.isEmpty() && this.containsInternal(x, y);
	}

	, 
	containsPoint: function (point) {
		return this.containsLocation(point.__x, point.__y);
	}

	, 
	containsRect: function (rect) {
		return !this.isEmpty() && !rect.isEmpty() && (this.__x <= rect.__x && this.__y <= rect.__y && this.__x + this.__width >= rect.__x + rect.__width) && this.__y + this.__height >= rect.__y + rect.__height;
	}

	, 
	intersectsWith: function (rect) {
		return !(rect.left() > this.right() || rect.right() < this.left() || rect.top() > this.bottom() || rect.bottom() < this.top());
	}

	, 
	intersect: function (other) {
		if (!this.intersectsWith(other)) {
			this.__top = Number.POSITIVE_INFINITY;
			this.__left = Number.POSITIVE_INFINITY;
			this.__width = Number.NEGATIVE_INFINITY;
			this.__height = Number.NEGATIVE_INFINITY;
		}

		var maxX = Math.max(this.x(), other.x());
		var maxY = Math.max(this.y(), other.y());
		var newWidth = Math.min(this.x() + this.width(), other.x() + other.width()) - maxX;
		var newHeight = Math.min(this.y() + this.height(), other.y() + other.height()) - maxY;
		if (newWidth < 0) {
			newWidth = 0;
		}

		if (newHeight < 0) {
			newHeight = 0;
		}

		this.__width = newWidth;
		this.__height = newHeight;
		this.__x = maxX;
		this.__y = maxY;
		this.__left = this.__x;
		this.__top = this.__y;
		this.__right = this.__left + this.__width;
		this.__bottom = this.__top + this.__height;
	}

	, 
	union: function (other) {
		if (this.isEmpty()) {
			this.__x = other.x();
			this.__y = other.y();
			this.__width = other.width();
			this.__height = other.height();
			this.__left = this.__x;
			this.__top = this.__y;
			this.__right = this.__left + this.__width;
			this.__bottom = this.__top + this.__height;
			return;
		}

		if (!other.isEmpty()) {
			var minX = Math.min(this.x(), other.x());
			var minY = Math.min(this.y(), other.y());
			var newWidth = this.width();
			var newHeight = this.height();
			if (other.width() == Number.POSITIVE_INFINITY || this.width() == Number.POSITIVE_INFINITY) {
				newWidth = Number.POSITIVE_INFINITY;

			} else {
				var maxRight = Math.max(this.right(), other.right());
				newWidth = maxRight - minX;
			}

			if (other.height() == Number.POSITIVE_INFINITY || this.height() == Number.POSITIVE_INFINITY) {
				newHeight = Number.POSITIVE_INFINITY;

			} else {
				var maxBottom = Math.max(this.bottom(), other.bottom());
				newHeight = maxBottom - minY;
			}

			this.__x = minX;
			this.__y = minY;
			this.__width = newWidth;
			this.__height = newHeight;
			this.__left = this.__x;
			this.__top = this.__y;
			this.__right = this.__left + this.__width;
			this.__bottom = this.__top + this.__height;
		}

	}

	, 
	equals: function (obj) {
		if (obj == null) {
			return $.ig.Object.prototype.equals.call(this, obj);
		}

		var other = obj;
		return other.left() == this.left() && other.top() == this.top() && other.width() == this.width() && other.height() == this.height();
	}
	, 
	$type: new $.ig.Type('Rect', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('Size', 'ValueType', {
	init: function (initNumber) {

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.ValueType.prototype.init.call(this);

	}, 
	init1: function (initNumber, width, height) {


		$.ig.ValueType.prototype.init.call(this);
			this.__width = width;
			this.__height = height;
	}
	, 
	__width: 0
	, 
	__height: 0

	, 
	width: function (value) {
		if (arguments.length === 1) {

			this.__width = value;
			return value;
		} else {

			return this.__width;
		}
	}

	, 
	height: function (value) {
		if (arguments.length === 1) {

			this.__height = value;
			return value;
		} else {

			return this.__height;
		}
	}

	, 
	isEmpty: function () {

			return this.height() == 0 && this.width() == 0;
	}

	, 
	l_op_Inequality: function (left, right) {
		return false;
	}

	, 
	l_op_Inequality_Lifted: function (left, right) {
		if (!left.hasValue()) {
		return right.hasValue();

		} else if (!right.hasValue()) {
		return true;
		}


		return $.ig.Size.prototype.l_op_Inequality(left.value(), right.value());
	}

	, 
	l_op_Equality: function (left, right) {
		return false;
	}

	, 
	l_op_Equality_Lifted: function (left, right) {
		if (!left.hasValue()) {
		return !right.hasValue();

		} else if (!right.hasValue()) {
		return false;
		}


		return $.ig.Size.prototype.l_op_Equality(left.value(), right.value());
	}
	, 
	$type: new $.ig.Type('Size', $.ig.ValueType.prototype.$type)
}, true);

$.ig.util.defType('Style', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('Style', $.ig.Object.prototype.$type)
}, true);




$.ig.util.defType('Shape', 'FrameworkElement', {
	init: function () {


		this.__fill = null;
		this.__stroke = null;

		$.ig.FrameworkElement.prototype.init.call(this);
	}
	, 
	__fill: null

	, 
	fill: function (value) {
		if (arguments.length === 1) {

			this.__fill = value;
			return value;
		} else {

			return this.__fill;
		}
	}
	, 
	__stroke: null

	, 
	stroke: function (value) {
		if (arguments.length === 1) {

			this.__stroke = value;
			return value;
		} else {

			return this.__stroke;
		}
	}

	, 
	_isHitTestVisible: false,
	isHitTestVisible: function (value) {
		if (arguments.length === 1) {
			this._isHitTestVisible = value;
			return value;
		} else {
			return this._isHitTestVisible;
		}
	}

	, 
	_strokeThickness: 0,
	strokeThickness: function (value) {
		if (arguments.length === 1) {
			this._strokeThickness = value;
			return value;
		} else {
			return this._strokeThickness;
		}
	}

	, 
	_strokeDashArray: null,
	strokeDashArray: function (value) {
		if (arguments.length === 1) {
			this._strokeDashArray = value;
			return value;
		} else {
			return this._strokeDashArray;
		}
	}

	, 
	_strokeDashCap: 0,
	strokeDashCap: function (value) {
		if (arguments.length === 1) {
			this._strokeDashCap = value;
			return value;
		} else {
			return this._strokeDashCap;
		}
	}
	, 
	$type: new $.ig.Type('Shape', $.ig.FrameworkElement.prototype.$type)
}, true);

$.ig.util.defType('Line', 'Shape', {
	init: function () {



		$.ig.Shape.prototype.init.call(this);
			this.x1(0);
			this.x2(0);
			this.y1(0);
			this.y2(0);
	}

	, 
	_x1: 0,
	x1: function (value) {
		if (arguments.length === 1) {
			this._x1 = value;
			return value;
		} else {
			return this._x1;
		}
	}

	, 
	_x2: 0,
	x2: function (value) {
		if (arguments.length === 1) {
			this._x2 = value;
			return value;
		} else {
			return this._x2;
		}
	}

	, 
	_y1: 0,
	y1: function (value) {
		if (arguments.length === 1) {
			this._y1 = value;
			return value;
		} else {
			return this._y1;
		}
	}

	, 
	_y2: 0,
	y2: function (value) {
		if (arguments.length === 1) {
			this._y2 = value;
			return value;
		} else {
			return this._y2;
		}
	}
	, 
	$type: new $.ig.Type('Line', $.ig.Shape.prototype.$type)
}, true);

$.ig.util.defType('Path', 'Shape', {
	init: function () {


		$.ig.Shape.prototype.init.call(this);

	}
	, 
	_data: null,
	data: function (value) {
		if (arguments.length === 1) {
			this._data = value;
			return value;
		} else {
			return this._data;
		}
	}
	, 
	_height: 0

	, 
	height: function (value) {
		if (arguments.length === 1) {

			this._height = value;
			return value;
		} else {

			return this._height;
		}
	}
	, 
	_width: 0

	, 
	width: function (value) {
		if (arguments.length === 1) {

			this._width = value;
			return value;
		} else {

			return this._width;
		}
	}
	, 
	$type: new $.ig.Type('Path', $.ig.Shape.prototype.$type)
}, true);

$.ig.util.defType('Polygon', 'Shape', {
	init: function () {



		$.ig.Shape.prototype.init.call(this);
			this.points(new $.ig.PointCollection(0));
	}

	, 
	_points: null,
	points: function (value) {
		if (arguments.length === 1) {
			this._points = value;
			return value;
		} else {
			return this._points;
		}
	}
	, 
	$type: new $.ig.Type('Polygon', $.ig.Shape.prototype.$type)
}, true);

$.ig.util.defType('Polyline', 'Shape', {
	init: function () {



		$.ig.Shape.prototype.init.call(this);
			this.points(new $.ig.PointCollection(0));
	}

	, 
	_points: null,
	points: function (value) {
		if (arguments.length === 1) {
			this._points = value;
			return value;
		} else {
			return this._points;
		}
	}
	, 
	$type: new $.ig.Type('Polyline', $.ig.Shape.prototype.$type)
}, true);

$.ig.util.defType('Rectangle', 'Shape', {
	__rect: null
	, 
	__radiusX: 0

	, 
	radiusX: function (value) {
		if (arguments.length === 1) {

			this.__radiusX = value;
			return value;
		} else {

			return this.__radiusX;
		}
	}
	, 
	__radiusY: 0

	, 
	radiusY: function (value) {
		if (arguments.length === 1) {

			this.__radiusY = value;
			return value;
		} else {

			return this.__radiusY;
		}
	}
	, 
	init: function () {



		$.ig.Shape.prototype.init.call(this);
			this.__rect = new $.ig.Rect(0, 0, 0, 0, 0);
	}

	, 
	arrange: function (rect) {
	}
	, 
	$type: new $.ig.Type('Rectangle', $.ig.Shape.prototype.$type)
}, true);

$.ig.util.defType('Brush', 'Object', {
	init: function () {

		this.__fill = null;
		this.__cachedFill = null;
		this.__cachedColor = new $.ig.Color();

		$.ig.Object.prototype.init.call(this);

	}, 
	_isGradient: false
	, 
	_isRadialGradient: false
	, 
	_isImageFill: false
	, 
	__fill: null

	, 
	fill: function (value) {
		if (arguments.length === 1) {

			this.__fill = value;
			return value;
		} else {

			return this.__fill;
		}
	}
	, 
	__cachedFill: null
	, 
	__cachedColor: null

	, 
	color: function (value) {
		if (arguments.length === 1) {

			this.__cachedColor = value;
			this.__cachedFill = this.__cachedColor.colorString();
			this.__fill = this.__cachedFill;
			return value;
		} else {

			if (this.__fill == this.__cachedFill) {
				return this.__cachedColor;
			}

			var color = new $.ig.Color();
			if (this.__fill != null) {
				color.colorString(this.__fill);
				this.__cachedColor = color;
				this.__cachedFill = this.__fill;
			}

			return color;
		}
	}

	, 
	equals: function (obj) {
		if (obj == null) {
			return false;
		}

		var other = obj;
		return this.__fill.equals(other.__fill) && this.color().equals(other.color()) && this._isGradient == other._isGradient && this._isImageFill == other._isImageFill && this._isRadialGradient == other._isRadialGradient;
	}

	, 
	create: function (val_) {
		var b_ = new $.ig.Brush();
		if (!val_) {
			return null;
			}
			
			if (typeof val_ == 'string') {
				b_ = new $.ig.Brush();
				b_.fill(val_);
			} else if (val_.type == 'linearGradient') {
				b_ = new $.ig.LinearGradientBrush();
				if (val_.startPoint && val_.endPoint) {
					b_._useCustomDirection = true;
					b_._startX = val_.startPoint.x;
					b_._startY = val_.startPoint.y;
					b_._endX = val_.endPoint.x;
					b_._endY = val_.endPoint.y;
				}
				
				if (val_.colorStops) {
					stops = [];
					for (var i = 0; i < val_.colorStops.length; i++) {
						colorStop = new $.ig.GradientStop();
						colorStop._offset = val_.colorStops[i].offset;
						colorStop.__fill = val_.colorStops[i].color;
						stops.push(colorStop);
					}
					b_._gradientStops = stops;
				}};
		return b_;
	}
	, 
	$type: new $.ig.Type('Brush', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('LinearGradientBrush', 'Brush', {
	init: function () {



		$.ig.Brush.prototype.init.call(this);
			this._useCustomDirection = false;
			this._startX = 0;
			this._startY = 0;
			this._endX = 0;
			this._endY = 1;
			this._isAbsolute = false;
			this._gradientStops = new Array(0);
			this._isGradient = true;
	}
	, 
	_useCustomDirection: false
	, 
	_startX: 0
	, 
	_startY: 0
	, 
	_endX: 0
	, 
	_endY: 0
	, 
	_isAbsolute: false
	, 
	_gradientStops: null

	, 
	clone: function () {
		var newBrush = new $.ig.LinearGradientBrush();
		newBrush._startX = this._startX;
		newBrush._startY = this._startY;
		newBrush._endX = this._endX;
		newBrush._endY = this._endY;
		newBrush._useCustomDirection = this._useCustomDirection;
		newBrush._isAbsolute = this._isAbsolute;
		if (this._gradientStops != null) {
			newBrush._gradientStops = new Array(this._gradientStops.length);
			for (var i = 0; i < this._gradientStops.length; i++) {
				newBrush._gradientStops[i] = this._gradientStops[i].clone();
			}

		}

		return newBrush;
	}

	, 
	equals: function (obj) {
		if (obj == null) {
			return false;
		}

		var other = obj;
		var retval = $.ig.Brush.prototype.equals.call(this, obj) && this._startX == other._startX && this._startY == other._startY && this._endX == other._endX && this._endY == other._endY && this._isAbsolute == other._isAbsolute && this._useCustomDirection == other._useCustomDirection;
		if (retval == false) {
			return false;
		}

		if (this._gradientStops.length != other._gradientStops.length) {
			return false;
		}

		for (var i = 0, length = this._gradientStops.length; i < length; i++) {
			if (!this._gradientStops[i].equals(other._gradientStops[i])) {
				return false;
			}

		}

		return true;
	}
	, 
	$type: new $.ig.Type('LinearGradientBrush', $.ig.Brush.prototype.$type)
}, true);

$.ig.util.defType('GradientStop', 'Object', {
	init: function () {


		this.__fill = null;
		this.__cachedFill = null;
		this.__cachedColor = new $.ig.Color();

		$.ig.Object.prototype.init.call(this);
			this._offset = 0;
	}
	, 
	_offset: 0

	, 
	clone: function () {
		var newStop = new $.ig.GradientStop();
		newStop._offset = this._offset;
		newStop.__fill = this.__fill;
		return newStop;
	}
	, 
	__fill: null

	, 
	fill: function (value) {
		if (arguments.length === 1) {

			this.__fill = value;
			return value;
		} else {

			return this.__fill;
		}
	}
	, 
	__cachedFill: null
	, 
	__cachedColor: null

	, 
	color: function (value) {
		if (arguments.length === 1) {

			this.__cachedColor = value;
			this.__cachedFill = this.__cachedColor.colorString();
			this.__fill = this.__cachedFill;
			return value;
		} else {

			if (this.__fill == this.__cachedFill) {
				return this.__cachedColor;
			}

			var color = new $.ig.Color();
			if (this.__fill != null) {
				color.colorString(this.__fill);
				this.__cachedColor = color;
				this.__cachedFill = this.__fill;
			}

			return color;
		}
	}

	, 
	equals: function (obj) {
		if (obj == null) {
			return false;
		}

		var other = obj;
		return this._offset == other._offset && this.color().equals(other.color()) && this.__fill.equals(other.__fill);
	}
	, 
	$type: new $.ig.Type('GradientStop', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('Color', 'ValueType', {
	init: function () {


		$.ig.ValueType.prototype.init.call(this);

	}, 
	__a: 0

	, 
	a: function (value) {
		if (arguments.length === 1) {

			this.__a = $.ig.truncate(Math.round(value));
			this.__stringDirty = true;
			return value;
		} else {

			return this.__a;
		}
	}
	, 
	__r: 0

	, 
	r: function (value) {
		if (arguments.length === 1) {

			this.__r = $.ig.truncate(Math.round(value));
			this.__stringDirty = true;
			return value;
		} else {

			return this.__r;
		}
	}
	, 
	__g: 0

	, 
	g: function (value) {
		if (arguments.length === 1) {

			this.__g = $.ig.truncate(Math.round(value));
			this.__stringDirty = true;
			return value;
		} else {

			return this.__g;
		}
	}
	, 
	__b: 0

	, 
	b: function (value) {
		if (arguments.length === 1) {

			this.__b = $.ig.truncate(Math.round(value));
			this.__stringDirty = true;
			return value;
		} else {

			return this.__b;
		}
	}
	, 
	__colorString: null

	, 
	colorString: function (value) {
		if (arguments.length === 1) {

			this.__colorString = value;
			this.updateColors();
			return value;
		} else {

			if (this.__stringDirty || this.__colorString == null) {
				this.__stringDirty = false;
				this.updateColorString();
			}

			return this.__colorString;
		}
	}
	, 
	__stringDirty: false

	, 
	create: function (value) {
		if ($.ig.util.cast($.ig.Color.prototype.$type, value) !== null) {
		return value;
		}

		var ret = new $.ig.Color();
		if ($.ig.util.cast(String, value) !== null || typeof value === "string") {
			ret.colorString(value);

		} else if (value != null) {
			throw new $.ig.ArgumentException(0, "Unknown color type");
		}


		return ret;
	}

	, 
	updateColorString: function () {
		this.__colorString = "rgba(" + this.__r + "," + this.__g + "," + this.__b + "," + this.__a / 255 + ")";
	}

	, 
	updateColors: function () {
		var obj_ = $.ig.util.stringToColor(this.__colorString);
		this.__a = typeof obj_.a != 'undefined' ? Math.round(obj_.a) : 0;
		this.__r = typeof obj_.r != 'undefined' ? Math.round(obj_.r) : 0;
		this.__g = typeof obj_.g != 'undefined' ? Math.round(obj_.g) : 0;
		this.__b = typeof obj_.b != 'undefined' ? Math.round(obj_.b) : 0;
	}

	, 
	fromArgb: function (a_, r_, g_, b_) {
		var c = new $.ig.Color();
		c.__a = a_ | 0;
		c.__r = r_ | 0;
		c.__g = g_ | 0;
		c.__b = b_ | 0;
		c.__stringDirty = true;
		return c;
	}

	, 
	equals: function (obj) {
		if (($.ig.util.cast($.ig.Color.prototype.$type, obj) !== null) == false) {
		return false;
		}

		var other = obj;
		return this.__a == other.__a && this.__r == other.__r && this.__g == other.__g && this.__b == other.__b;
	}

	, 
	getHashCode: function () {
		return (this.__a << 24) | (this.__r << 16) | (this.__g << 8) | this.__b;
	}

	, 
	l_op_Inequality: function (left, right) {
		return !($.ig.Color.prototype.l_op_Equality(left, right));
	}

	, 
	l_op_Inequality_Lifted: function (left, right) {
		if (!left.hasValue()) {
		return right.hasValue();

		} else if (!right.hasValue()) {
		return true;
		}


		return $.ig.Color.prototype.l_op_Inequality(left.value(), right.value());
	}

	, 
	l_op_Equality: function (left, right) {
		return left.__a == right.__a && left.__r == right.__r && left.__g == right.__g && left.__b == right.__b;
	}

	, 
	l_op_Equality_Lifted: function (left, right) {
		if (!left.hasValue()) {
		return !right.hasValue();

		} else if (!right.hasValue()) {
		return false;
		}


		return $.ig.Color.prototype.l_op_Equality(left.value(), right.value());
	}
	, 
	$type: new $.ig.Type('Color', $.ig.ValueType.prototype.$type)
}, true);

$.ig.util.defType('DoubleCollection', 'List$1', {
	init: function () {


		$.ig.List$1.prototype.init.call(this, Number, 0);

	}, 
	$type: new $.ig.Type('DoubleCollection', $.ig.List$1.prototype.$type.specialize(Number))
}, true);

$.ig.util.defType('Geometry', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
	}

	, 
	type: function () {
	}
	, 
	$type: new $.ig.Type('Geometry', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('GeometryCollection', 'List$1', {
	init: function () {


		$.ig.List$1.prototype.init.call(this, $.ig.Geometry.prototype.$type, 0);

	}, 
	$type: new $.ig.Type('GeometryCollection', $.ig.List$1.prototype.$type.specialize($.ig.Geometry.prototype.$type))
}, true);

$.ig.util.defType('GeometryGroup', 'Geometry', {
	init: function () {



		$.ig.Geometry.prototype.init.call(this);
			this.children(new $.ig.GeometryCollection());
	}

	, 
	_children: null,
	children: function (value) {
		if (arguments.length === 1) {
			this._children = value;
			return value;
		} else {
			return this._children;
		}
	}

	, 
	type: function () {

			return $.ig.GeometryType.prototype.group;
	}

	, 
	_fillRule: 0,
	fillRule: function (value) {
		if (arguments.length === 1) {
			this._fillRule = value;
			return value;
		} else {
			return this._fillRule;
		}
	}
	, 
	$type: new $.ig.Type('GeometryGroup', $.ig.Geometry.prototype.$type)
}, true);

$.ig.util.defType('LineGeometry', 'Geometry', {
	init: function () {


		$.ig.Geometry.prototype.init.call(this);

	}
	, 
	_startPoint: null,
	startPoint: function (value) {
		if (arguments.length === 1) {
			this._startPoint = value;
			return value;
		} else {
			return this._startPoint;
		}
	}

	, 
	_endPoint: null,
	endPoint: function (value) {
		if (arguments.length === 1) {
			this._endPoint = value;
			return value;
		} else {
			return this._endPoint;
		}
	}

	, 
	type: function () {

			return $.ig.GeometryType.prototype.line;
	}
	, 
	$type: new $.ig.Type('LineGeometry', $.ig.Geometry.prototype.$type)
}, true);

$.ig.util.defType('RectangleGeometry', 'Geometry', {
	init: function () {


		$.ig.Geometry.prototype.init.call(this);

	}
	, 
	_rect: null,
	rect: function (value) {
		if (arguments.length === 1) {
			this._rect = value;
			return value;
		} else {
			return this._rect;
		}
	}

	, 
	_radiusX: 0,
	radiusX: function (value) {
		if (arguments.length === 1) {
			this._radiusX = value;
			return value;
		} else {
			return this._radiusX;
		}
	}

	, 
	_radiusY: 0,
	radiusY: function (value) {
		if (arguments.length === 1) {
			this._radiusY = value;
			return value;
		} else {
			return this._radiusY;
		}
	}

	, 
	type: function () {

			return $.ig.GeometryType.prototype.rectangle;
	}
	, 
	$type: new $.ig.Type('RectangleGeometry', $.ig.Geometry.prototype.$type)
}, true);

$.ig.util.defType('EllipseGeometry', 'Geometry', {
	init: function () {


		$.ig.Geometry.prototype.init.call(this);

	}
	, 
	_center: null,
	center: function (value) {
		if (arguments.length === 1) {
			this._center = value;
			return value;
		} else {
			return this._center;
		}
	}

	, 
	_radiusX: 0,
	radiusX: function (value) {
		if (arguments.length === 1) {
			this._radiusX = value;
			return value;
		} else {
			return this._radiusX;
		}
	}

	, 
	_radiusY: 0,
	radiusY: function (value) {
		if (arguments.length === 1) {
			this._radiusY = value;
			return value;
		} else {
			return this._radiusY;
		}
	}

	, 
	type: function () {

			return $.ig.GeometryType.prototype.ellipse;
	}
	, 
	$type: new $.ig.Type('EllipseGeometry', $.ig.Geometry.prototype.$type)
}, true);

$.ig.util.defType('PathGeometry', 'Geometry', {
	init: function () {



		$.ig.Geometry.prototype.init.call(this);
			this.figures(new $.ig.PathFigureCollection());
	}

	, 
	_figures: null,
	figures: function (value) {
		if (arguments.length === 1) {
			this._figures = value;
			return value;
		} else {
			return this._figures;
		}
	}

	, 
	type: function () {

			return $.ig.GeometryType.prototype.path;
	}
	, 
	$type: new $.ig.Type('PathGeometry', $.ig.Geometry.prototype.$type)
}, true);

$.ig.util.defType('PathFigure', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.__segments = new $.ig.PathSegmentCollection();
			this.__isClosed = false;
			this.__isFilled = true;
	}
	, 
	__segments: null

	, 
	segments: function (value) {
		if (arguments.length === 1) {

			this.__segments = value;
			return value;
		} else {

			return this.__segments;
		}
	}
	, 
	__startPoint: null

	, 
	startPoint: function (value) {
		if (arguments.length === 1) {

			this.__startPoint = value;
			return value;
		} else {

			return this.__startPoint;
		}
	}
	, 
	__isFilled: false

	, 
	isFilled: function (value) {
		if (arguments.length === 1) {

			this.__isFilled = value;
			return value;
		} else {

			return this.__isFilled;
		}
	}
	, 
	__isClosed: false

	, 
	isClosed: function (value) {
		if (arguments.length === 1) {

			this.__isClosed = value;
			return value;
		} else {

			return this.__isClosed;
		}
	}
	, 
	$type: new $.ig.Type('PathFigure', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('PathFigureCollection', 'List$1', {
	init: function () {


		$.ig.List$1.prototype.init.call(this, $.ig.PathFigure.prototype.$type, 0);

	}, 
	$type: new $.ig.Type('PathFigureCollection', $.ig.List$1.prototype.$type.specialize($.ig.PathFigure.prototype.$type))
}, true);

$.ig.util.defType('PathSegment', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	type: function () {
	}
	, 
	$type: new $.ig.Type('PathSegment', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('PathSegmentCollection', 'List$1', {
	init: function () {


		$.ig.List$1.prototype.init.call(this, $.ig.PathSegment.prototype.$type, 0);

	}, 
	$type: new $.ig.Type('PathSegmentCollection', $.ig.List$1.prototype.$type.specialize($.ig.PathSegment.prototype.$type))
}, true);

$.ig.util.defType('LineSegment', 'PathSegment', {
	__point: null

	, 
	point: function (value) {
		if (arguments.length === 1) {

			this.__point = value;
			return value;
		} else {

			return this.__point;
		}
	}
	, 
	init: function (initNumber, point) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.PathSegment.prototype.init.call(this);
			this.point(point);
	}
	, 
	init1: function (initNumber) {


		$.ig.PathSegment.prototype.init.call(this);
	}

	, 
	type: function () {

			return $.ig.PathSegmentType.prototype.line;
	}
	, 
	$type: new $.ig.Type('LineSegment', $.ig.PathSegment.prototype.$type)
}, true);

$.ig.util.defType('BezierSegment', 'PathSegment', {
	__point1: null

	, 
	point1: function (value) {
		if (arguments.length === 1) {

			this.__point1 = value;
			return value;
		} else {

			return this.__point1;
		}
	}
	, 
	__point2: null

	, 
	point2: function (value) {
		if (arguments.length === 1) {

			this.__point2 = value;
			return value;
		} else {

			return this.__point2;
		}
	}
	, 
	__point3: null

	, 
	point3: function (value) {
		if (arguments.length === 1) {

			this.__point3 = value;
			return value;
		} else {

			return this.__point3;
		}
	}
	, 
	init: function (initNumber) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.PathSegment.prototype.init.call(this);
	}
	, 
	init1: function (initNumber, cp1, cp2, p) {


		$.ig.PathSegment.prototype.init.call(this);
			this.point1(cp1);
			this.point2(cp2);
			this.point3(p);
	}

	, 
	type: function () {

			return $.ig.PathSegmentType.prototype.bezier;
	}
	, 
	$type: new $.ig.Type('BezierSegment', $.ig.PathSegment.prototype.$type)
}, true);

$.ig.util.defType('PolyBezierSegment', 'PathSegment', {
	init: function () {



		$.ig.PathSegment.prototype.init.call(this);
			this.points(new $.ig.PointCollection(0));
	}

	, 
	_points: null,
	points: function (value) {
		if (arguments.length === 1) {
			this._points = value;
			return value;
		} else {
			return this._points;
		}
	}

	, 
	type: function () {

			return $.ig.PathSegmentType.prototype.polyBezier;
	}
	, 
	$type: new $.ig.Type('PolyBezierSegment', $.ig.PathSegment.prototype.$type)
}, true);

$.ig.util.defType('PolyLineSegment', 'PathSegment', {
	init: function () {



		$.ig.PathSegment.prototype.init.call(this);
			this.__points = new $.ig.PointCollection(0);
	}
	, 
	__points: null

	, 
	points: function (value) {
		if (arguments.length === 1) {

			this.__points = value;
			return value;
		} else {

			return this.__points;
		}
	}

	, 
	type: function () {

			return $.ig.PathSegmentType.prototype.polyLine;
	}
	, 
	$type: new $.ig.Type('PolyLineSegment', $.ig.PathSegment.prototype.$type)
}, true);

$.ig.util.defType('ArcSegment', 'PathSegment', {
	init: function () {


		this._size = new $.ig.Size();

		$.ig.PathSegment.prototype.init.call(this);
			this.isLargeArc(false);
			this.sweepDirection($.ig.SweepDirection.prototype.counterclockwise);
	}

	, 
	_point: null,
	point: function (value) {
		if (arguments.length === 1) {
			this._point = value;
			return value;
		} else {
			return this._point;
		}
	}

	, 
	_isLargeArc: false,
	isLargeArc: function (value) {
		if (arguments.length === 1) {
			this._isLargeArc = value;
			return value;
		} else {
			return this._isLargeArc;
		}
	}

	, 
	_sweepDirection: 0,
	sweepDirection: function (value) {
		if (arguments.length === 1) {
			this._sweepDirection = value;
			return value;
		} else {
			return this._sweepDirection;
		}
	}

	, 
	_size: null,
	size: function (value) {
		if (arguments.length === 1) {
			this._size = value;
			return value;
		} else {
			return this._size;
		}
	}

	, 
	_rotationAngle: 0,
	rotationAngle: function (value) {
		if (arguments.length === 1) {
			this._rotationAngle = value;
			return value;
		} else {
			return this._rotationAngle;
		}
	}

	, 
	type: function () {

			return $.ig.PathSegmentType.prototype.arc;
	}
	, 
	$type: new $.ig.Type('ArcSegment', $.ig.PathSegment.prototype.$type)
}, true);

$.ig.util.defType('Transform', 'DependencyObject', {
	init: function () {


		$.ig.DependencyObject.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('Transform', $.ig.DependencyObject.prototype.$type)
}, true);

$.ig.util.defType('RotateTransform', 'Transform', {
	init: function () {


		$.ig.Transform.prototype.init.call(this);

	}
	, 
	_angle: 0,
	angle: function (value) {
		if (arguments.length === 1) {
			this._angle = value;
			return value;
		} else {
			return this._angle;
		}
	}

	, 
	_centerX: 0,
	centerX: function (value) {
		if (arguments.length === 1) {
			this._centerX = value;
			return value;
		} else {
			return this._centerX;
		}
	}

	, 
	_centerY: 0,
	centerY: function (value) {
		if (arguments.length === 1) {
			this._centerY = value;
			return value;
		} else {
			return this._centerY;
		}
	}
	, 
	$type: new $.ig.Type('RotateTransform', $.ig.Transform.prototype.$type)
}, true);

$.ig.util.defType('TranslateTransform', 'Transform', {
	init: function () {


		$.ig.Transform.prototype.init.call(this);

	}
	, 
	_x: 0,
	x: function (value) {
		if (arguments.length === 1) {
			this._x = value;
			return value;
		} else {
			return this._x;
		}
	}

	, 
	_y: 0,
	y: function (value) {
		if (arguments.length === 1) {
			this._y = value;
			return value;
		} else {
			return this._y;
		}
	}
	, 
	$type: new $.ig.Type('TranslateTransform', $.ig.Transform.prototype.$type)
}, true);

$.ig.util.defType('ScaleTransform', 'Transform', {
	init: function () {


		$.ig.Transform.prototype.init.call(this);

	}
	, 
	_scaleX: 0,
	scaleX: function (value) {
		if (arguments.length === 1) {
			this._scaleX = value;
			return value;
		} else {
			return this._scaleX;
		}
	}

	, 
	_scaleY: 0,
	scaleY: function (value) {
		if (arguments.length === 1) {
			this._scaleY = value;
			return value;
		} else {
			return this._scaleY;
		}
	}

	, 
	_centerX: 0,
	centerX: function (value) {
		if (arguments.length === 1) {
			this._centerX = value;
			return value;
		} else {
			return this._centerX;
		}
	}

	, 
	_centerY: 0,
	centerY: function (value) {
		if (arguments.length === 1) {
			this._centerY = value;
			return value;
		} else {
			return this._centerY;
		}
	}
	, 
	$type: new $.ig.Type('ScaleTransform', $.ig.Transform.prototype.$type)
}, true);

$.ig.util.defType('TransformGroup', 'Transform', {

	_children: null,
	children: function (value) {
		if (arguments.length === 1) {
			this._children = value;
			return value;
		} else {
			return this._children;
		}
	}
	, 
	init: function () {



		$.ig.Transform.prototype.init.call(this);
			this.children(new $.ig.TransformCollection());
	}
	, 
	$type: new $.ig.Type('TransformGroup', $.ig.Transform.prototype.$type)
}, true);

$.ig.util.defType('TransformCollection', 'List$1', {
	init: function () {


		$.ig.List$1.prototype.init.call(this, $.ig.Transform.prototype.$type, 0);

	}, 
	$type: new $.ig.Type('TransformCollection', $.ig.List$1.prototype.$type.specialize($.ig.Transform.prototype.$type))
}, true);

$.ig.util.defType('MouseEventArgs', 'EventArgs', {
	init: function () {


		$.ig.EventArgs.prototype.init.call(this);

	}
	, 
	_position: null,
	position: function (value) {
		if (arguments.length === 1) {
			this._position = value;
			return value;
		} else {
			return this._position;
		}
	}

	, 
	_originalSource: null,
	originalSource: function (value) {
		if (arguments.length === 1) {
			this._originalSource = value;
			return value;
		} else {
			return this._originalSource;
		}
	}

	, 
	getPosition: function (relativeTo) {
		return this.position();
	}
	, 
	$type: new $.ig.Type('MouseEventArgs', $.ig.EventArgs.prototype.$type)
}, true);

$.ig.util.defType('MouseButtonEventArgs', 'MouseEventArgs', {
	init: function () {


		$.ig.MouseEventArgs.prototype.init.call(this);

	}
	, 
	_handled: false,
	handled: function (value) {
		if (arguments.length === 1) {
			this._handled = value;
			return value;
		} else {
			return this._handled;
		}
	}
	, 
	$type: new $.ig.Type('MouseButtonEventArgs', $.ig.MouseEventArgs.prototype.$type)
}, true);

$.ig.util.defType('Binding', 'Object', {
	init: function (initNumber) {


		this.__satisfied = false;
		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.Object.prototype.init.call(this);
	}
	, 
	init1: function (initNumber, path) {


		$.ig.Object.prototype.init.call(this);
			this.__path = new $.ig.PropertyPath(path);
	}
	, 
	__source: null

	, 
	source: function (value) {
		if (arguments.length === 1) {

			this.__source = value;
			return value;
		} else {

			return this.__source;
		}
	}
	, 
	__path: null

	, 
	path: function (value) {
		if (arguments.length === 1) {

			this.__path = value;
			return value;
		} else {

			return this.__path;
		}
	}
	, 
	__satisfied: false

	, 
	satisfied: function (value) {
		if (arguments.length === 1) {

			this.__satisfied = value;
			return value;
		} else {

			return this.__satisfied;
		}
	}
	, 
	$type: new $.ig.Type('Binding', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('Panel', 'FrameworkElement', {
	init: function () {



		$.ig.FrameworkElement.prototype.init.call(this);
			this.children(new $.ig.UIElementCollection(this));
	}

	, 
	_children: null,
	children: function (value) {
		if (arguments.length === 1) {
			this._children = value;
			return value;
		} else {
			return this._children;
		}
	}
	, 
	$type: new $.ig.Type('Panel', $.ig.FrameworkElement.prototype.$type)
}, true);

$.ig.util.defType('Canvas', 'Panel', {
	init: function () {


		$.ig.Panel.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('Canvas', $.ig.Panel.prototype.$type)
}, true);


$.ig.util.defType('TextBlock', 'FrameworkElement', {
	init: function () {


		$.ig.FrameworkElement.prototype.init.call(this);

	}, 
	__text: null

	, 
	text: function (value) {
		if (arguments.length === 1) {

			if (this.__text != value) {
				this.__text = value;
				this.textWidthCache(-1);
			}

			return value;
		} else {

			return this.__text;
		}
	}

	, 
	_fill: null,
	fill: function (value) {
		if (arguments.length === 1) {
			this._fill = value;
			return value;
		} else {
			return this._fill;
		}
	}

	, 
	_textWidthCache: 0,
	textWidthCache: function (value) {
		if (arguments.length === 1) {
			this._textWidthCache = value;
			return value;
		} else {
			return this._textWidthCache;
		}
	}
	, 
	$type: new $.ig.Type('TextBlock', $.ig.FrameworkElement.prototype.$type)
}, true);






$.ig.util.defType('StringBuilder', 'Object', {

	_internal: null,
	internal: function (value) {
		if (arguments.length === 1) {
			this._internal = value;
			return value;
		} else {
			return this._internal;
		}
	}
	, 
	init: function (initNumber) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
				case 2:
					this.init2.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.Object.prototype.init.call(this);
			this.internal("");
	}
	, 
	init1: function (initNumber, capacity) {


		$.ig.StringBuilder.prototype.init.call(this, 0);
	}
	, 
	init2: function (initNumber, value) {


		$.ig.Object.prototype.init.call(this);
			this.internal(value);
	}

	, 
	append3: function (str_) {
		if (str_ != null)
        {
            this._internal = this._internal.concat(str_);
        };
		return this;
	}

	, 
	append5: function (builder) {
		var str_ = builder.toString();
		this._internal = this._internal.concat(str_);
		return this;
	}

	, 
	append1: function (chr_) {
		this._internal = this._internal.concat(chr_);
		return this;
	}

	, 
	append2: function (value_) {
		this._internal = this._internal.concat(value_);
		return this;
	}

	, 
	append4: function (value_, startIndex_, count_) {
		this._internal = this._internal.concat(value_.substr(startIndex_, count_));
		return this;
	}

	, 
	append: function (value_, startIndex_, charCount_) {
		this._internal = this._internal.concat(value_.slice(startIndex_, startIndex_ + charCount_).join(''));
		return this;
	}

	, 
	appendLine: function () {
		return this.appendLine1("");
	}

	, 
	appendLine1: function (str_) {
		if (str_ != null)
        {
            this._internal = this._internal.concat(str_);
        }
        this._internal = this._internal.concat($.ig.Environment.prototype.newLine());;
		return this;
	}

	, 
	insert: function (index_, chr_) {
		if (index_ == this.length()) {
		this.append1(chr_);

		} else {
		this._internal = this._internal.substring(0, index_).concat(chr_).concat(this._internal.substring(index_, this._internal.length));
		}

		return this;
	}

	, 
	insert1: function (index_, str_) {
		if (index_ == this.length()) {
		this.append3(str_);

		} else {
		this._internal = this._internal.substring(0, index_).concat(str_).concat(this._internal.substring(index_, this._internal.length));
		}

		return this;
	}

	, 
	remove: function (startIndex_, length_) {
		this._internal = this._internal.substring(0, startIndex_).concat(this._internal.substring(startIndex_ + length_, this._internal.length));
		return this;
	}

	, 
	toString: function () {
		return this.internal();
	}

	, 
	toString1: function (startIndex, length) {
		return this.internal().substr(startIndex, length);
	}

	, 
	length: function (value) {
		if (arguments.length === 1) {

			if (value <= this.length()) {
			this._internal = this._internal.substring(0, value);

			} else {
			throw new $.ig.NotImplementedException(0);
			}

			return value;
		} else {

			return this.internal().length;
		}
	}

	, 
	item: function (index_, value) {
		if (arguments.length === 2) {

			this._internal = this._internal.substring(0, index_).concat(value).concat(this._internal.substring(index_ + 1, this._internal.length));
			return value;
		} else {

			return this.internal().charAt(index_);
		}
	}

	, 
	appendFormat2: function (format, arg0) {
		return this.append3($.ig.util.stringFormat(format, arg0));
	}

	, 
	appendFormat1: function (format, args) {
		return this.append3($.ig.util.stringFormat1(format, args));
	}

	, 
	appendFormat: function (provider, format, args) {
		return this.append3($.ig.util.stringFormat2(provider, format, args));
	}

	, 
	appendFormat3: function (format, arg0, arg1) {
		return this.append3($.ig.util.stringFormat(format, arg0, arg1));
	}

	, 
	appendFormat4: function (format, arg0, arg1, arg2) {
		return this.append3($.ig.util.stringFormat(format, arg0, arg1, arg2));
	}

	, 
	_capacity: 0,
	capacity: function (value) {
		if (arguments.length === 1) {
			this._capacity = value;
			return value;
		} else {
			return this._capacity;
		}
	}
	, 
	$type: new $.ig.Type('StringBuilder', $.ig.Object.prototype.$type)
}, true);


































$.ig.util.defType('Debug', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	assert1: function (condition, text) {
	}

	, 
	writeLine: function (line) {
	}

	, 
	assert: function (value) {
	}
	, 
	$type: new $.ig.Type('Debug', $.ig.Object.prototype.$type)
}, true);









$.ig.util.defType('Enumerable', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	where$1: function ($tSource, source, predicate) {
		var d__ = new $.ig.Enumerable___Where__IteratorClass$1($tSource, -2);
		d__.__3__source = source;
		d__.__3__predicate = predicate;
		return d__;
	}

	, 
	where$11: function ($tSource, source, predicate) {
		var d__ = new $.ig.Enumerable___Where__IteratorClass1$1($tSource, -2);
		d__.__3__source = source;
		d__.__3__predicate = predicate;
		return d__;
	}

	, 
	select$2: function ($tSource, $tResult, source, selector) {
		var d__ = new $.ig.Enumerable___Select__IteratorClass$2($tSource, $tResult, -2);
		d__.__3__source = source;
		d__.__3__selector = selector;
		return d__;
	}

	, 
	selectMany$2: function ($tSource, $tResult, source, selector) {
		var d__ = new $.ig.Enumerable___SelectMany__IteratorClass$2($tSource, $tResult, -2);
		d__.__3__source = source;
		d__.__3__selector = selector;
		return d__;
	}

	, 
	ofType$1: function ($tResult, source) {
		var d__ = new $.ig.Enumerable___OfType__IteratorClass$1($tResult, -2);
		d__.__3__source = source;
		return d__;
	}

	, 
	last$1: function ($tSource, source) {
		var ilist = $.ig.util.cast($.ig.IList$1.prototype.$type.specialize($tSource), source);
		if (ilist != null) {
			return ilist.item(ilist.count() - 1);
		}

		var current = $.ig.util.getDefaultValue($tSource);
		var en = source.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			current = item;
		}

		return current;
	}

	, 
	first$1: function ($tSource, source) {
		var en = source.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			return item;
		}

		return $.ig.util.getDefaultValue($tSource);
	}

	, 
	firstOrDefault$1: function ($tSource, source) {
		var en = source.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			return item;
		}

		return $.ig.util.getDefaultValue($tSource);
	}

	, 
	orderBy$2: function ($tSource, $tKey, source, keySelector) {
		var $self = this;
		var buffer = new $.ig.SortedList$1($tSource, source);
		buffer.sort2(function (o1, o2) {
			var t1 = o1;
			var t2 = o2;
			var k1 = keySelector(t1);
			var k2 = keySelector(t2);
			if ($.ig.util.cast($.ig.IComparable.prototype.$type, k1) !== null) {
				return ($.ig.util.cast($.ig.IComparable.prototype.$type, k1)).compareTo($.ig.util.getBoxIfEnum($tKey, k2));

			} else {
				return $.ig.util.toString$1($tKey, k1).compareTo($.ig.util.toString$1($tKey, k2));
			}

		});
		return buffer;
	}

	, 
	orderByDescending$2: function ($tSource, $tKey, source, keySelector) {
		var $self = this;
		var buffer = new $.ig.SortedList$1($tSource, source);
		buffer.sort2(function (o2, o1) {
			var t1 = o1;
			var t2 = o2;
			var k1 = keySelector(t1);
			var k2 = keySelector(t2);
			if ($.ig.util.cast($.ig.IComparable.prototype.$type, k1) !== null) {
				return ($.ig.util.cast($.ig.IComparable.prototype.$type, k1)).compareTo($.ig.util.getBoxIfEnum($tKey, k2));

			} else {
				return $.ig.util.toString$1($tKey, k1).compareTo($.ig.util.toString$1($tKey, k2));
			}

		});
		return buffer;
	}

	, 
	toList$1: function ($tSource, source) {
		var list = new $.ig.List$1($tSource, 1, source);
		return list;
	}

	, 
	range: function (startValue, count) {
		var d__ = new $.ig.Enumerable___Range__IteratorClass(-2);
		d__.__3__startValue = startValue;
		d__.__3__count = count;
		return d__;
	}

	, 
	concat$1: function ($tSource, source1, source2) {
		var d__ = new $.ig.Enumerable___Concat__IteratorClass$1($tSource, -2);
		d__.__3__source1 = source1;
		d__.__3__source2 = source2;
		return d__;
	}

	, 
	max: function (source) {
		var first = true;
		var max = 0;
		var en = source.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			if (first) {
				first = false;
				max = item;

			} else {
				max = Math.max(max, item);
			}

		}

		return max;
	}

	, 
	max$1: function ($tSource, source, selector) {
		return $.ig.Enumerable.prototype.max($.ig.Enumerable.prototype.select$2($tSource, $.ig.Number.prototype.$type, source, selector));
	}

	, 
	min: function (source) {
		var first = true;
		var min = 0;
		var en = source.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			if (first) {
				first = false;
				min = item;

			} else {
				min = Math.min(min, item);
			}

		}

		return min;
	}

	, 
	min$1: function ($tSource, source, selector) {
		return $.ig.Enumerable.prototype.max($.ig.Enumerable.prototype.select$2($tSource, $.ig.Number.prototype.$type, source, selector));
	}

	, 
	count$1: function ($tSource, source) {
		var count = 0;
		var en = source.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			count++;
		}

		return count;
	}

	, 
	reverse$1: function ($tSource, source) {
		var d__ = new $.ig.Enumerable___Reverse__IteratorClass$1($tSource, -2);
		d__.__3__source = source;
		return d__;
	}

	, 
	cast$1: function ($tResult, source) {
		if (source == null) {
			throw new $.ig.ArgumentNullException(0, "source");
		}

		var enumerable = $.ig.util.cast($.ig.IEnumerable$1.prototype.$type.specialize($tResult), source);
		if (enumerable != null) {
			return enumerable;
		}

		var list = new $.ig.List$1($tResult, 0);
		var en = source.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			if ($.ig.util.cast($tResult, item) !== null) {
				list.add1($.ig.util.getValueIfEnum($tResult, item));

			} else {
				list.add1($.ig.util.getDefaultValue($tResult));
			}

		}

		return list;
	}

	, 
	take$1: function ($tSource, source, toTake) {
		var d__ = new $.ig.Enumerable___Take__IteratorClass$1($tSource, -2);
		d__.__3__source = source;
		d__.__3__toTake = toTake;
		return d__;
	}

	, 
	skip$1: function ($tSource, source, toSkip) {
		var d__ = new $.ig.Enumerable___Skip__IteratorClass$1($tSource, -2);
		d__.__3__source = source;
		d__.__3__toSkip = toSkip;
		return d__;
	}

	, 
	any$1: function ($tSource, source) {
		var en = source.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			return true;
		}

		return false;
	}

	, 
	contains$1: function ($tSource, source, value_) {
		var en = source.getEnumerator();
		while (en.moveNext()) {
			var item_ = en.current();
			if (item_ === value_)
                {
                    return true;
                };
		}

		return false;
	}

	, 
	union$1: function ($tSource, first, second) {
		return null;
	}

	, 
	toArray$1: function ($tSource, source) {
		var arr = $.ig.util.cast($.ig.List$1.prototype.$type.specialize($tSource), source);
		if (arr != null) {
		return arr.toArray();
		}

		arr = new $.ig.List$1($tSource, 1, source);
		return arr.asArray();
	}

	, 
	elementAt$1: function ($tSource, source, index) {
		var iList = $.ig.util.cast($.ig.IList$1.prototype.$type.specialize($tSource), source);
		if (iList != null) {
			return iList.item(index);
		}

		return $.ig.Enumerable.prototype.first$1($tSource, $.ig.Enumerable.prototype.skip$1($tSource, source, index));
	}

	, 
	sum: function (source) {
		var sum = 0;
		var en = source.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			sum += item;
		}

		return sum;
	}

	, 
	sum$1: function ($tSource, source, selector) {
		return $.ig.Enumerable.prototype.sum($.ig.Enumerable.prototype.select$2($tSource, Number, source, selector));
	}

	, 
	sequenceEqual$1: function ($tSource, first, second) {
		if (first == null) {
		throw new $.ig.ArgumentNullException(0, "first");
		}

		if (second == null) {
		throw new $.ig.ArgumentNullException(0, "second");
		}

			var enumerator = first.getEnumerator();
			try {
					var enumerator2 = second.getEnumerator();
					try {
							while (enumerator.moveNext()) {
								if (!enumerator2.moveNext() || !$.ig.Object.prototype.equalsStatic($.ig.util.getBoxIfEnum($tSource, enumerator.current()), $.ig.util.getBoxIfEnum($tSource, enumerator2.current()))) {
									return false;
								}


							}
							return (enumerator2.moveNext() == false);

					}
					finally {
							if (enumerator2 != null) {
							enumerator2.dispose();
							}


					}

			}
			finally {
					if (enumerator != null) {
					enumerator.dispose();
					}


			}

	}

	, 
	empty$1: function ($tSource) {
		return new $.ig.Enumerable___Empty__IteratorClass$1($tSource, -2);
	}

	, 
	selectMany$3: function ($tSource, $tCollection, $tResult, source, collectionSelector, resultSelector) {
		var d__ = new $.ig.Enumerable___SelectMany__IteratorClass1$3($tSource, $tCollection, $tResult, -2);
		d__.__3__source = source;
		d__.__3__collectionSelector = collectionSelector;
		d__.__3__resultSelector = resultSelector;
		return d__;
	}

	, 
	any$11: function ($tSource, source, predicate) {
		var en = source.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			if (predicate(item)) {
			return true;
			}

		}

		return false;
	}

	, 
	firstOrDefault$11: function ($tSource, source, predicate) {
		var en = source.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			if (predicate(item)) {
			return item;
			}

		}

		return $.ig.util.getDefaultValue($tSource);
	}

	, 
	lastOrDefault$1: function ($tSource, source) {
		throw new $.ig.NotImplementedException(0);
		var ilist = $.ig.util.cast($.ig.IList$1.prototype.$type.specialize($tSource), source);
		if (ilist != null) {
			return ilist.count() == 0 ? $.ig.util.getDefaultValue($tSource) : ilist.item(ilist.count() - 1);
		}

		var current = $.ig.util.getDefaultValue($tSource);
		var en = source.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			current = item;
		}

		return current;
	}

	, 
	zip$3: function ($tFirst, $tSecond, $tResult, first, second, resultSelector) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	distinct$1: function ($tSource, source) {
		throw new $.ig.NotImplementedException(0);
		return null;
	}
	, 
	$type: new $.ig.Type('Enumerable', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('IOrderedEnumerable$1', 'Object', {
	$type: new $.ig.Type('IOrderedEnumerable$1', null, [$.ig.IEnumerable$1.prototype.$type.specialize(0), $.ig.IEnumerable.prototype.$type])
}, true);

$.ig.util.defType('SortedList$1', 'List$1', {
	$tElement: null, 
	init: function ($tElement, source) {

		this.$tElement = $tElement;
		this.$type = this.$type.specialize(this.$tElement);


		$.ig.List$1.prototype.init1.call(this, this.$tElement, 1, source);
	}

	, 
	getEnumerator: function () {
		return $.ig.List$1.prototype.getEnumerator.call(this);
	}
	, 
	$type: new $.ig.Type('SortedList$1', $.ig.List$1.prototype.$type.specialize(0), [$.ig.IOrderedEnumerable$1.prototype.$type.specialize(0)])
}, true);





$.ig.util.defType('AbstractEnumerable', 'Object', {
	__inner: null
	, 
	init: function (inner) {



		$.ig.Object.prototype.init.call(this);
			this.__inner = inner;
	}

	, 
	getEnumerator: function () {
		return new $.ig.AbstractEnumerator(this.__inner().getEnumerator());
	}
	, 
	$type: new $.ig.Type('AbstractEnumerable', $.ig.Object.prototype.$type, [$.ig.IEnumerable.prototype.$type])
}, true);

$.ig.util.defType('AbstractEnumerator', 'Object', {
	__inner: null
	, 
	init: function (inner) {



		$.ig.Object.prototype.init.call(this);
			this.__inner = inner;
	}

	, 
	current: function () {

			return this.__inner.current();
	}

	, 
	moveNext: function () {
		return this.__inner.moveNext();
	}

	, 
	reset: function () {
		this.__inner.reset();
	}
	, 
	$type: new $.ig.Type('AbstractEnumerator', $.ig.Object.prototype.$type, [$.ig.IEnumerator.prototype.$type])
}, true);



$.ig.util.defType('NotifyCollectionChangedEventArgs', 'EventArgs', {
	init: function (initNumber, action) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
				case 2:
					this.init2.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.EventArgs.prototype.init.call(this);
			this.__action = action;
			this.__oldItems = new $.ig.List$1($.ig.Object.prototype.$type, 0);
			this.__newItems = new $.ig.List$1($.ig.Object.prototype.$type, 0);
	}
	, 
	init1: function (initNumber, action, changedItem, index) {


		var $self = this;
		$.ig.EventArgs.prototype.init.call(this);
			this.__action = action;
			this.__oldItems = new $.ig.List$1($.ig.Object.prototype.$type, 0);
			if (this.__action == $.ig.NotifyCollectionChangedAction.prototype.remove || this.__action == $.ig.NotifyCollectionChangedAction.prototype.replace) {
				this.__oldItems.add(changedItem);
				this.__oldStartingIndex = index;
			}

			if (this.__action != $.ig.NotifyCollectionChangedAction.prototype.remove) {
				this.__newItems = (function () { var $ret = new $.ig.List$1($.ig.Object.prototype.$type, 0);
				$ret.add(changedItem); return $ret;}());

			} else {
				this.__newItems = new $.ig.List$1($.ig.Object.prototype.$type, 0);
			}

			this.__newStartingIndex = index;
	}
	, 
	init2: function (initNumber, action, newItem, oldItem, index) {


		var $self = this;
		$.ig.EventArgs.prototype.init.call(this);
			this.__action = action;
			this.__newStartingIndex = index;
			this.__oldStartingIndex = index;
			this.__newItems = (function () { var $ret = new $.ig.List$1($.ig.Object.prototype.$type, 0);
			$ret.add(newItem); return $ret;}());
			this.__oldItems = (function () { var $ret = new $.ig.List$1($.ig.Object.prototype.$type, 0);
			$ret.add(oldItem); return $ret;}());
	}
	, 
	__action: 0

	, 
	action: function () {

			return this.__action;
	}
	, 
	__newItems: null

	, 
	newItems: function () {

			return this.__newItems;
	}
	, 
	__newStartingIndex: 0

	, 
	newStartingIndex: function () {

			return this.__newStartingIndex;
	}
	, 
	__oldItems: null

	, 
	oldItems: function () {

			return this.__oldItems;
	}
	, 
	__oldStartingIndex: 0

	, 
	oldStartingIndex: function () {

			return this.__oldStartingIndex;
	}
	, 
	$type: new $.ig.Type('NotifyCollectionChangedEventArgs', $.ig.EventArgs.prototype.$type)
}, true);

$.ig.util.defType('Comparer$1', 'Object', {
	$t: null, 
	init: function ($t) {

		this.$t = $t;
		this.$type = this.$type.specialize(this.$t);


		$.ig.Object.prototype.init.call(this);
	}

	, 
	defaultComparerValue: function ($t) {

			return new $.ig.DefaultComparer$1($t);
	}

	, 
	compare: function (x, y) {}

	, 
	create: function ($t, comparison) {
		return null;
	}
	, 
	$type: new $.ig.Type('Comparer$1', $.ig.Object.prototype.$type, [$.ig.IComparer.prototype.$type, $.ig.IComparer$1.prototype.$type.specialize(0)])
}, true);

$.ig.util.defType('DefaultComparer$1', 'Comparer$1', {
	$t: null, 
	init: function ($t) {
		this.$t = $t;
		this.$type = this.$type.specialize(this.$t);


		$.ig.Comparer$1.prototype.init.call(this, this.$t);

	}
	, 
	compare: function (x, y) {
		var xComparable = $.ig.util.cast($.ig.IComparable$1.prototype.$type.specialize(this.$t), x);
		if (xComparable != null) {
		return xComparable.compareTo(y);
		}

		var yComparable = $.ig.util.cast($.ig.IComparable$1.prototype.$type.specialize(this.$t), y);
		if (yComparable != null) {
		return -yComparable.compareTo(x);
		}

		return $.ig.util.compare(x, y);
	}
	, 
	$type: new $.ig.Type('DefaultComparer$1', $.ig.Comparer$1.prototype.$type.specialize(0))
}, true);

$.ig.util.defType('KeyValuePair$2', 'ValueType', {
	$tKey: null, 
	$tValue: null, 
	init: function ($tKey, $tValue, initNumber) {
		this.$tKey = $tKey;
		this.$tValue = $tValue;
		this.$type = this.$type.specialize(this.$tKey, this.$tValue);

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.ValueType.prototype.init.call(this);

	}, 
	__key: null
	, 
	__value: null
	, 
	init1: function ($tKey, $tValue, initNumber, key, value) {

		this.$tKey = $tKey;
		this.$tValue = $tValue;
		this.$type = this.$type.specialize(this.$tKey, this.$tValue);

		$.ig.ValueType.prototype.init.call(this);
			this.__key = key;
			this.__value = value;
	}

	, 
	key: function () {

			return this.__key;
	}

	, 
	value: function () {

			return this.__value;
	}
	, 
	$type: new $.ig.Type('KeyValuePair$2', $.ig.ValueType.prototype.$type)
}, true);

$.ig.util.defType('IDictionary$2', 'Object', {
	$type: new $.ig.Type('IDictionary$2', null, [$.ig.ICollection$1.prototype.$type.specialize($.ig.KeyValuePair$2.prototype.$type.specialize(this.$tKey, this.$tValue)), $.ig.IEnumerable$1.prototype.$type.specialize($.ig.KeyValuePair$2.prototype.$type.specialize(this.$tKey, this.$tValue)), $.ig.IEnumerable.prototype.$type])
}, true);

$.ig.util.defType('Dictionary$2', 'Object', {
	$tKey: null, 
	$tValue: null, 
	__comparer: null
	, 
	__count: 0
	, 
	__useStrings: false
	, 
	__needsEnsure: false
	, 
	__assumeUniqueKeys: false
	, 
	__keysUnique: null
	, 
	__values: null
	, 
	init: function ($tKey, $tValue, initNumber) {

		this.$tKey = $tKey;
		this.$tValue = $tValue;
		this.$type = this.$type.specialize(this.$tKey, this.$tValue);

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
				case 2:
					this.init2.apply(this, arguments);
					break;
				case 3:
					this.init3.apply(this, arguments);
					break;
				case 4:
					this.init4.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.Dictionary$2.prototype.init4.call(this, this.$tKey, this.$tValue, 4, 0, null);
	}
	, 
	init1: function ($tKey, $tValue, initNumber, capacity) {

		this.$tKey = $tKey;
		this.$tValue = $tValue;
		this.$type = this.$type.specialize(this.$tKey, this.$tValue);

		$.ig.Dictionary$2.prototype.init4.call(this, this.$tKey, this.$tValue, 4, capacity, null);
	}
	, 
	init2: function ($tKey, $tValue, initNumber, comparer) {

		this.$tKey = $tKey;
		this.$tValue = $tValue;
		this.$type = this.$type.specialize(this.$tKey, this.$tValue);

		$.ig.Dictionary$2.prototype.init4.call(this, this.$tKey, this.$tValue, 4, 0, comparer);
	}
	, 
	init3: function ($tKey, $tValue, initNumber, dictionary) {

		this.$tKey = $tKey;
		this.$tValue = $tValue;
		this.$type = this.$type.specialize(this.$tKey, this.$tValue);

		$.ig.Dictionary$2.prototype.init1.call(this, this.$tKey, this.$tValue, 1, dictionary.count());
			var en = dictionary.getEnumerator();
			while (en.moveNext()) {
				var pair = en.current();
			this.item(pair.key(), pair.value())}

	}
	, 
	init4: function ($tKey, $tValue, initNumber, capacity, comparer) {

		this.$tKey = $tKey;
		this.$tValue = $tValue;
		this.$type = this.$type.specialize(this.$tKey, this.$tValue);

		var $self = this;
		$.ig.Object.prototype.init.call(this);
			this.__keysUnique = {};
			this.__values = {};
			this.__comparer = (function(t1) { return t1 != null ? t1 : $.ig.EqualityComparer$1.prototype.defaultEqualityComparerValue(this.$tKey) }(comparer));
			this.__useStrings = comparer == null && ($tKey === $.ig.String.prototype.$type || $tKey === String);
			this.__needsEnsure = $tKey === $.ig.Object.prototype.$type || ($tKey.InstanceConstructor && !$tKey.InstanceConstructor.prototype.getHashCode);
			this.__assumeUniqueKeys = comparer == null && (this.__useStrings || this.__needsEnsure || $tKey.InstanceConstructor && $tKey.InstanceConstructor.prototype.getHashCode == $.ig.Object.prototype.getHashCode);
	}

	, 
	count: function () {

			return this.__count;
	}

	, 
	item: function (key_, value) {
		if (arguments.length === 2) {

			this.addHelper(key_, value, false);
			return value;
		} else {

			var $self = this;
			var result;
			if ((function () { var $ret = $self.tryGetValue(key_, result); result = $ret.p1; return $ret.ret; }())) {
			return result;
			}

			return $.ig.util.getDefaultValue($self.$tValue);
		}
	}

	, 
	length: function () {

			return this.__count;
	}

	, 
	containsKey: function (key) {
		var $self = this;
		var value;
		return (function () { var $ret = $self.tryGetValue(key, value); value = $ret.p1; return $ret.ret; }());
	}

	, 
	remove: function (key) {
		if (this.__assumeUniqueKeys) {
			var hash = this.hashUnique(key);
			if (!this.__keysUnique.hasOwnProperty(hash)) {
			return false;
			}

			delete this.__keysUnique[hash];
			delete this.__values[hash];
			this.__count--;
			return true;
		}

		var hashCode = this.hashCode(key);
		var current = this.__values[hashCode];
		if (current) {
			if (current.$isHashSetBucket) {
				for (var i = 0; i < current.length; i++) {
					var currentItem = current[i];
					if (this.__comparer.equalsC(currentItem.key, key)) {
						current.removeItem(currentItem);
						if (current.length == 1) {
							this.__values[hashCode] = current[0];
						}

						this.__count--;
						return true;
					}

				}


			} else {
				if (this.__comparer.equalsC(current.key, key)) {
					delete this.__values[hashCode];
					this.__count--;
					return true;
				}

			}

		}

		return false;
	}

	, 
	clear: function () {
		this.__count = 0;
		this.__keysUnique = {};
		this.__values = {};
	}

	, 
	hashUnique: function (key) {
		if (this.__needsEnsure) {
			$.ig.util.ensureUniqueId(key);
		}

		if (this.__useStrings) {
			return $.ig.util.toString$1(this.$tKey, key);

		} else {
			return key.getHashCode().toString();
		}

	}

	, 
	hashCode: function (key) {
		if (this.__needsEnsure) {
			$.ig.util.ensureUniqueId(key);

		} else {
			if (!key.getHashCode) {
				this.__needsEnsure = true;
				$.ig.util.ensureUniqueId(key);
			}

		}

		return this.__comparer.getHashCodeC(key);
	}

	, 
	add: function (key, value) {
		this.addHelper(key, value, true);
	}

	, 
	addHelper: function (key, value, add) {
		if (this.__assumeUniqueKeys) {
			var hash = this.hashUnique(key);
			if (!this.__keysUnique.hasOwnProperty(hash)) {
			this.__count++;

			} else if (add) {
			throw new $.ig.ArgumentException(0, "Duplicate key added to the dictionary");
			}


			this.__keysUnique[hash] = key;
			this.__values[hash] = value;

		} else {
			var hashCode = this.hashCode(key);
			var current = this.__values[hashCode];
			if (current) {
				if (current.$isHashSetBucket) {
					for (var i = 0; i < current.length; i++) {
						var currentItem = current[i];
						if (this.__comparer.equalsC(currentItem.key, key)) {
							if (add) {
							throw new $.ig.ArgumentException(0, "Duplicate key added to the dictionary");
							}

							currentItem.value = value;
							return;
						}

					}

					current.push({key: key, value: value});
					this.__count++;

				} else {
					if (this.__comparer.equalsC(current.key, key)) {
						if (add) {
						throw new $.ig.ArgumentException(0, "Duplicate key added to the dictionary");
						}

						current.value = value;

					} else {
						var bucket = [current, {key: key, value: value}];
						bucket.$isHashSetBucket = true;;
						this.__values[hashCode] = bucket;
						this.__count++;
					}

				}


			} else {
				this.__values[hashCode] = {key: key, value: value};
				this.__count++;
			}

		}

	}

	, 
	tryGetValue: function (key, value_) {
		if (this.__assumeUniqueKeys) {
			var hash = this.hashUnique(key);
			if (this.__keysUnique.hasOwnProperty(hash)) {
				value_ = this.__values[hash];
				return {
					ret: true, 
					p1: value_
				};
			}


		} else {
			var hashCode = this.hashCode(key);
			var current = this.__values[hashCode];
			if (current) {
				if (current.$isHashSetBucket) {
					for (var i = 0; i < current.length; i++) {
						var currentItem = current[i];
						if (this.__comparer.equalsC(currentItem.key, key)) {
							value_ = currentItem.value;
							return {
								ret: true, 
								p1: value_
							};
						}

					}


				} else {
					if (this.__comparer.equalsC(current.key, key)) {
						value_ = current.value;
						return {
							ret: true, 
							p1: value_
						};
					}

				}

			}

		}

		value_ = $.ig.util.getDefaultValue(this.$tValue);
		return {
			ret: false, 
			p1: value_
		};
	}

	, 
	isReadOnly: function () {

			return false;
	}

	, 
	add1: function (item) {
		this.add(item.key(), item.value());
	}

	, 
	contains: function (item) {
		return this.containsKey(item.key());
	}

	, 
	copyTo: function (array, arrayIndex) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	remove1: function (item) {
		this.remove(item.key());
		return true;
	}

	, 
	getEnumerator: function () {
		return this.toEnumerable().getEnumerator();
	}

	, 
	toEnumerable: function () {
		var d__ = new $.ig.Dictionary___ToEnumerable__IteratorClass$2(this.$tKey, this.$tValue, -2);
		d__.__4__this = this;
		return d__;
	}

	, 
	getEnumerator: function () {
		return this.toEnumerable().getEnumerator();
	}

	, 
	keys: function () {

			var $self = this;
			return new $.ig.Dictionary_EnumerableCollection$3($self.$tKey, $self.$tValue, $self.$tKey, $self, $.ig.Enumerable.prototype.select$2($.ig.KeyValuePair$2.prototype.$type.specialize($self.$tKey, $self.$tValue), $self.$tKey, $self.toEnumerable(), function (p) { return p.key(); }), (function(t1) { return t1 != null ? t1 : $.ig.EqualityComparer$1.prototype.defaultEqualityComparerValue($self.$tKey) }($self.__comparer)));
	}

	, 
	values: function () {

			var $self = this;
			return new $.ig.Dictionary_EnumerableCollection$3($self.$tKey, $self.$tValue, $self.$tValue, $self, $.ig.Enumerable.prototype.select$2($.ig.KeyValuePair$2.prototype.$type.specialize($self.$tKey, $self.$tValue), $self.$tValue, $self.toEnumerable(), function (p) { return p.value(); }), $.ig.EqualityComparer$1.prototype.defaultEqualityComparerValue($self.$tValue));
	}
	, 
	$type: new $.ig.Type('Dictionary$2', $.ig.Object.prototype.$type, [$.ig.IDictionary$2.prototype.$type.specialize(0, 1), $.ig.IDictionary.prototype.$type])
}, true);

$.ig.util.defType('Dictionary_EnumerableCollection$3', 'Object', {
	$tKey: null, 
	$tValue: null, 
	$t: null, 
	__collection: null
	, 
	__comparer: null
	, 
	__owner: null
	, 
	init: function ($tKey, $tValue, $t, owner, collection, comparer) {

		this.$tKey = $tKey;
		this.$tValue = $tValue;
		this.$t = $t;
		this.$type = this.$type.specialize(this.$tKey, this.$tValue, this.$t);


		$.ig.Object.prototype.init.call(this);
			this.__collection = collection;
			this.__comparer = comparer;
			this.__owner = owner;
	}

	, 
	count: function () {

			return this.__owner.count();
	}

	, 
	isReadOnly: function () {

			return true;
	}

	, 
	add: function (item) {
		throw new $.ig.InvalidOperationException(0);
	}

	, 
	clear: function () {
		throw new $.ig.InvalidOperationException(0);
	}

	, 
	contains: function (item) {
		var en = this.__collection.getEnumerator();
		while (en.moveNext()) {
			var i = en.current();
			if ($.ig.Object.prototype.equalsStatic($.ig.util.getBoxIfEnum(this.$t, i), $.ig.util.getBoxIfEnum(this.$t, item))) {
			return true;
			}

		}

		return false;
	}

	, 
	copyTo: function (array, arrayIndex) {
		var en = this.__collection.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
		array[arrayIndex++] = item}

	}

	, 
	remove: function (item) {
		throw new $.ig.InvalidOperationException(0);
	}

	, 
	getEnumerator: function () {
		return this.__collection.getEnumerator();
	}

	, 
	getEnumerator1: function () {
		return this.__collection.getEnumerator();
	}
	, 
	$type: new $.ig.Type('Dictionary_EnumerableCollection$3', $.ig.Object.prototype.$type, [$.ig.ICollection$1.prototype.$type.specialize(0)])
}, true);

$.ig.util.defType('EqualityComparer$1', 'Object', {
	$t: null, 
	init: function ($t) {

		this.$t = $t;
		this.$type = this.$type.specialize(this.$t);


		$.ig.Object.prototype.init.call(this);
	}

	, 
	defaultEqualityComparerValue: function ($t) {

			return new $.ig.DefaultEqualityComparer$1($t);
	}

	, 
	equalsC: function (x, y) {}

	, 
	getHashCodeC: function (obj) {}

	, 
	equalsC: function (x, y) {
		return this.equalsC($.ig.util.getValueIfEnum(this.$t, x), $.ig.util.getValueIfEnum(this.$t, y));
	}

	, 
	getHashCodeC: function (obj) {
		return this.getHashCodeC($.ig.util.getValueIfEnum(this.$t, obj));
	}
	, 
	$type: new $.ig.Type('EqualityComparer$1', $.ig.Object.prototype.$type, [$.ig.IEqualityComparer.prototype.$type, $.ig.IEqualityComparer$1.prototype.$type.specialize(0)])
}, true);

$.ig.util.defType('DefaultEqualityComparer$1', 'EqualityComparer$1', {
	$t: null, 
	init: function ($t) {

		this.$t = $t;
		this.$type = this.$type.specialize(this.$t);


		$.ig.EqualityComparer$1.prototype.init.call(this, this.$t);
	}

	, 
	equalsC: function (x, y) {
		return $.ig.Object.prototype.equalsStatic($.ig.util.getBoxIfEnum(this.$t, x), $.ig.util.getBoxIfEnum(this.$t, y));
	}

	, 
	getHashCodeC: function (obj) {
		return obj.getHashCode();
	}
	, 
	$type: new $.ig.Type('DefaultEqualityComparer$1', $.ig.EqualityComparer$1.prototype.$type.specialize(0))
}, true);

$.ig.util.defType('GenericEnumerable$1', 'Object', {
	$t: null, 
	__inner: null
	, 
	init: function ($t, inner) {

		this.$t = $t;
		this.$type = this.$type.specialize(this.$t);


		$.ig.Object.prototype.init.call(this);
			this.__inner = inner;
	}

	, 
	getEnumerator: function () {
		return new $.ig.GenericEnumerator$1(this.$t, this.__inner().getEnumerator());
	}

	, 
	getEnumerator: function () {
		return new $.ig.GenericEnumerator$1(this.$t, this.__inner().getEnumerator());
	}
	, 
	$type: new $.ig.Type('GenericEnumerable$1', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(0)])
}, true);

$.ig.util.defType('GenericEnumerator$1', 'Object', {
	$t: null, 
	__inner: null
	, 
	init: function ($t, inner) {

		this.$t = $t;
		this.$type = this.$type.specialize(this.$t);


		$.ig.Object.prototype.init.call(this);
			this.__inner = inner;
	}

	, 
	current: function () {

			return this.__inner.current();
	}

	, 
	moveNext: function () {
		return this.__inner.moveNext();
	}

	, 
	reset: function () {
		this.__inner.reset();
	}

	, 
	dispose: function () {
	}
	, 
	$type: new $.ig.Type('GenericEnumerator$1', $.ig.Object.prototype.$type, [$.ig.IEnumerator$1.prototype.$type.specialize(0)])
}, true);


$.ig.util.defType('LinkedList$1', 'Object', {
	$t: null, 
	init: function ($t) {
		this.$t = $t;
		this.$type = this.$type.specialize(this.$t);


		$.ig.Object.prototype.init.call(this);

	}, 
	__first: null

	, 
	first: function () {

			return this.__first;
	}
	, 
	__last: null

	, 
	last: function () {

			return this.__last;
	}

	, 
	addFirst: function (item) {
		if (this.__first == null) {
			this.__first = new $.ig.LinkedListNode$1(this.$t, 1, item);
			this.__last = this.__first;

		} else {
			var oldFirst = this.__first;
			this.__first = new $.ig.LinkedListNode$1(this.$t, 1, item);
			this.__first._next = oldFirst;
			oldFirst._prev = this.__first;
		}

	}

	, 
	addLast: function (item) {
		if (this.__last == null) {
			this.__first = new $.ig.LinkedListNode$1(this.$t, 1, item);
			this.__last = this.__first;

		} else {
			var oldLast = this.__last;
			this.__last = new $.ig.LinkedListNode$1(this.$t, 1, item);
			this.__last._prev = oldLast;
			oldLast._next = this.__last;
		}

	}

	, 
	remove: function (node) {
		if (this.__first == node) {
			this.__first = node._next;
			if (node._next != null) {
				node._next._prev = null;
			}

		}

		if (this.__last == node) {
			this.__last = node._prev;
			if (node._prev != null) {
				node._prev._next = null;
			}

		}

		if (node._prev != null) {
			node._prev._next = node._next;
		}

		if (node._next != null) {
			node._next._prev = node._prev;
		}

		node._next = null;
		node._prev = null;
	}
	, 
	$type: new $.ig.Type('LinkedList$1', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('LinkedListNode$1', 'Object', {
	$t: null
	, 
	_value: null,
	value: function (value) {
		if (arguments.length === 1) {
			this._value = value;
			return value;
		} else {
			return this._value;
		}
	}
	, 
	_prev: null
	, 
	_next: null
	, 
	init: function ($t, initNumber) {

		this.$t = $t;
		this.$type = this.$type.specialize(this.$t);

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.Object.prototype.init.call(this);
	}
	, 
	init1: function ($t, initNumber, item) {

		this.$t = $t;
		this.$type = this.$type.specialize(this.$t);

		$.ig.Object.prototype.init.call(this);
			this.value(item);
	}
	, 
	$type: new $.ig.Type('LinkedListNode$1', $.ig.Object.prototype.$type)
}, true);





$.ig.util.defType('IArrayList', 'Object', {
	$type: new $.ig.Type('IArrayList', null)
}, true);


$.ig.util.defType('ReadOnlyCollection$1', 'Object', {
	$t: null, 
	init: function ($t, initNumber) {

		this.$t = $t;
		this.$type = this.$type.specialize(this.$t);

		this.__syncRoot = {};
		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.Object.prototype.init.call(this);
	}
	, 
	init1: function ($t, initNumber, source) {

		this.$t = $t;
		this.$type = this.$type.specialize(this.$t);

		$.ig.Object.prototype.init.call(this);
			this.__inner = source;
	}
	, 
	__inner: null

	, 
	item: function (index, value) {
		if (arguments.length === 2) {

			this.__inner.item(index, value);
			return value;
		} else {

			return this.__inner.item(index);
		}
	}

	, 
	indexOf: function (item) {
		return this.__inner.indexOf(item);
	}

	, 
	insert: function (index, item) {
	}

	, 
	removeAt: function (index) {
	}

	, 
	count: function () {

			return this.__inner.count();
	}

	, 
	isReadOnly: function () {

			return true;
	}

	, 
	add1: function (item) {
	}

	, 
	clear: function () {
	}

	, 
	contains1: function (item) {
		return this.__inner.contains(item);
	}

	, 
	copyTo: function (array, arrayIndex) {
		this.__inner.copyTo(array, arrayIndex);
	}

	, 
	remove1: function (item) {
		return false;
	}

	, 
	getEnumerator: function () {
		return this.__inner.getEnumerator();
	}

	, 
	getEnumerator: function () {
		return this.__inner.getEnumerator();
	}

	, 
	isFixedSize: function () {

			return true;
	}

	, 
	add: function (value) {
		return -1;
	}

	, 
	contains: function (value) {
		return this.__inner.contains($.ig.util.getValueIfEnum(this.$t, value));
	}

	, 
	indexOf1: function (value) {
		return this.__inner.indexOf($.ig.util.getValueIfEnum(this.$t, value));
	}

	, 
	insert1: function (index, value) {
	}

	, 
	remove: function (value) {
	}

	, 
	copyTo1: function (array, index) {
		this.__inner.copyTo(array, index);
	}

	, 
	items: function () {

			return this.__inner;
	}

	, 
	isSynchronized: function () {

			return true;
	}
	, 
	__syncRoot: null

	, 
	syncRoot: function () {

			return this.__syncRoot;
	}
	, 
	$type: new $.ig.Type('ReadOnlyCollection$1', $.ig.Object.prototype.$type, [$.ig.IList$1.prototype.$type.specialize(0), $.ig.IList.prototype.$type])
}, true);


$.ig.util.defType('Enumerable___Reverse__IteratorClass$1', 'Object', {
	$tSource: null, 
	__1__state: 0
	, 
	__2__current: null
	, 
	__list_5_0: null
	, 
	__i_5_1: 0
	, 
	_source: null
	, 
	__3__source: null
	, 
	init: function ($tSource, _1__state) {

		this.$tSource = $tSource;
		this.$type = this.$type.specialize(this.$tSource);


		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	moveNext: function () {
		while (this.__1__state >= 0) {
			switch (this.__1__state) {
				case 0:
					this.__1__state = -1;
					this.__list_5_0 = new $.ig.List$1(this.$tSource, 1, this._source);
					this.__i_5_1 = this.__list_5_0.count() - 1;
					this.__1__state = 1;
					break;
				case 1:
					this.__1__state = -1;
					if (this.__i_5_1 >= 0) {
						this.__2__current = this.__list_5_0.__inner[this.__i_5_1];
						this.__1__state = 2;
						return true;
					}

					break;
				case 2:
					this.__1__state = -1;
					this.__i_5_1--;
					this.__1__state = 1;
					break;
			}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.Enumerable___Reverse__IteratorClass$1(this.$tSource, 0);
		}

		d__._source = this.__3__source;
		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('Enumerable___Reverse__IteratorClass$1', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(0), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize(0), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

$.ig.util.defType('Enumerable___Concat__IteratorClass$1', 'Object', {
	$tSource: null, 
	__1__state: 0
	, 
	__2__current: null
	, 
	_itemEnumerator: null
	, 
	__item_5_0: null
	, 
	_itemEnumerator0: null
	, 
	__item_5_1: null
	, 
	_source1: null
	, 
	__3__source1: null
	, 
	_source2: null
	, 
	__3__source2: null
	, 
	init: function ($tSource, _1__state) {

		this.$tSource = $tSource;
		this.$type = this.$type.specialize(this.$tSource);


		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	_m_Finally0: function () {
		this.__1__state = -1;
		if (this._itemEnumerator != null) {
			this._itemEnumerator.dispose();
		}

	}

	, 
	_m_Finally1: function () {
		this.__1__state = -1;
		if (this._itemEnumerator0 != null) {
			this._itemEnumerator0.dispose();
		}

	}

	, 
	moveNext: function () {
		var __hasError__ = false;
		try {
				while (this.__1__state >= 0) {
					switch (this.__1__state) {
						case 0:
							this.__1__state = 1;
							this._itemEnumerator = this._source1.getEnumerator();
							this.__1__state = 2;
							break;
						case 2:
							this.__1__state = 1;
							if (this._itemEnumerator.moveNext()) {
								this.__item_5_0 = this._itemEnumerator.current();
								this.__2__current = this.__item_5_0;
								this.__1__state = 2;
								return true;
							}

							this._m_Finally0();
							this.__1__state = 3;
							this._itemEnumerator0 = this._source2.getEnumerator();
							this.__1__state = 4;
							break;
						case 4:
							this.__1__state = 3;
							if (this._itemEnumerator0.moveNext()) {
								this.__item_5_1 = this._itemEnumerator0.current();
								this.__2__current = this.__item_5_1;
								this.__1__state = 4;
								return true;
							}

							this._m_Finally1();
							break;
					}


				}

		}
		catch (e) {
				__hasError__ = true;
				throw e;

		}finally {
				if (__hasError__) {
				(this).dispose();
				}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.Enumerable___Concat__IteratorClass$1(this.$tSource, 0);
		}

		d__._source1 = this.__3__source1;
		d__._source2 = this.__3__source2;
		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
		switch (this.__1__state) {
			case 1:
			case 2:
				this._m_Finally0();
				break;
			case 3:
			case 4:
				this._m_Finally1();
				break;
		}

	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('Enumerable___Concat__IteratorClass$1', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(0), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize(0), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

$.ig.util.defType('Enumerable___Range__IteratorClass', 'Object', {
	__1__state: 0
	, 
	__2__current: 0
	, 
	__i_5_0: 0
	, 
	_startValue: 0
	, 
	__3__startValue: 0
	, 
	_count: 0
	, 
	__3__count: 0
	, 
	init: function (_1__state) {



		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	moveNext: function () {
		while (this.__1__state >= 0) {
			switch (this.__1__state) {
				case 0:
					this.__1__state = -1;
					this.__i_5_0 = this._startValue;
					this.__1__state = 1;
					break;
				case 1:
					this.__1__state = -1;
					if (this.__i_5_0 < this._count) {
						this.__2__current = this.__i_5_0;
						this.__1__state = 2;
						return true;
					}

					break;
				case 2:
					this.__1__state = -1;
					this.__i_5_0++;
					this.__1__state = 1;
					break;
			}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.Enumerable___Range__IteratorClass(0);
		}

		d__._startValue = this.__3__startValue;
		d__._count = this.__3__count;
		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('Enumerable___Range__IteratorClass', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize($.ig.Number.prototype.$type), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize($.ig.Number.prototype.$type), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);


$.ig.util.defType('Enumerable___OfType__IteratorClass$1', 'Object', {
	$tResult: null, 
	__1__state: 0
	, 
	__2__current: null
	, 
	_itemEnumerator: null
	, 
	__item_5_0: null
	, 
	_source: null
	, 
	__3__source: null
	, 
	init: function ($tResult, _1__state) {

		this.$tResult = $tResult;
		this.$type = this.$type.specialize(this.$tResult);


		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	_m_Finally0: function () {
		this.__1__state = -1;
		var d__ = $.ig.util.cast($.ig.IDisposable.prototype.$type, this._itemEnumerator);
		if (d__ != null) {
			d__.dispose();
		}

	}

	, 
	moveNext: function () {
		var __hasError__ = false;
		try {
				while (this.__1__state >= 0) {
					switch (this.__1__state) {
						case 0:
							this.__1__state = 1;
							this._itemEnumerator = this._source.getEnumerator();
							this.__1__state = 2;
							break;
						case 2:
							this.__1__state = 1;
							if (this._itemEnumerator.moveNext()) {
								this.__item_5_0 = this._itemEnumerator.current();
								if ($.ig.util.cast(this.$tResult, this.__item_5_0) !== null) {
									this.__2__current = $.ig.util.getValueIfEnum(this.$tResult, this.__item_5_0);
									this.__1__state = 2;
									return true;
								}

								this.__1__state = 2;
								break;
							}

							this._m_Finally0();
							break;
					}


				}

		}
		catch (e) {
				__hasError__ = true;
				throw e;

		}finally {
				if (__hasError__) {
				(this).dispose();
				}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.Enumerable___OfType__IteratorClass$1(this.$tResult, 0);
		}

		d__._source = this.__3__source;
		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
		switch (this.__1__state) {
			case 1:
			case 2:
				this._m_Finally0();
				break;
		}

	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('Enumerable___OfType__IteratorClass$1', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(0), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize(0), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

$.ig.util.defType('Enumerable___Select__IteratorClass$2', 'Object', {
	$tSource: null, 
	$tResult: null, 
	__1__state: 0
	, 
	__2__current: null
	, 
	_itemEnumerator: null
	, 
	__item_5_0: null
	, 
	_source: null
	, 
	__3__source: null
	, 
	_selector: null
	, 
	__3__selector: null
	, 
	init: function ($tSource, $tResult, _1__state) {

		this.$tSource = $tSource;
		this.$tResult = $tResult;
		this.$type = this.$type.specialize(this.$tSource, this.$tResult);


		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	_m_Finally0: function () {
		this.__1__state = -1;
		if (this._itemEnumerator != null) {
			this._itemEnumerator.dispose();
		}

	}

	, 
	moveNext: function () {
		var __hasError__ = false;
		try {
				while (this.__1__state >= 0) {
					switch (this.__1__state) {
						case 0:
							this.__1__state = 1;
							this._itemEnumerator = this._source.getEnumerator();
							this.__1__state = 2;
							break;
						case 2:
							this.__1__state = 1;
							if (this._itemEnumerator.moveNext()) {
								this.__item_5_0 = this._itemEnumerator.current();
								this.__2__current = this._selector(this.__item_5_0);
								this.__1__state = 2;
								return true;
							}

							this._m_Finally0();
							break;
					}


				}

		}
		catch (e) {
				__hasError__ = true;
				throw e;

		}finally {
				if (__hasError__) {
				(this).dispose();
				}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.Enumerable___Select__IteratorClass$2(this.$tSource, this.$tResult, 0);
		}

		d__._source = this.__3__source;
		d__._selector = this.__3__selector;
		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
		switch (this.__1__state) {
			case 1:
			case 2:
				this._m_Finally0();
				break;
		}

	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('Enumerable___Select__IteratorClass$2', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(0), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize(0), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

$.ig.util.defType('Enumerable___Skip__IteratorClass$1', 'Object', {
	$tSource: null, 
	__1__state: 0
	, 
	__2__current: null
	, 
	_itemEnumerator: null
	, 
	__item_5_0: null
	, 
	_source: null
	, 
	__3__source: null
	, 
	_toSkip: 0
	, 
	__3__toSkip: 0
	, 
	init: function ($tSource, _1__state) {

		this.$tSource = $tSource;
		this.$type = this.$type.specialize(this.$tSource);


		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	_m_Finally0: function () {
		this.__1__state = -1;
		if (this._itemEnumerator != null) {
			this._itemEnumerator.dispose();
		}

	}

	, 
	moveNext: function () {
		var __hasError__ = false;
		try {
				while (this.__1__state >= 0) {
					switch (this.__1__state) {
						case 0:
							this.__1__state = 1;
							this._itemEnumerator = this._source.getEnumerator();
							this.__1__state = 2;
							break;
						case 2:
							this.__1__state = 1;
							if (this._itemEnumerator.moveNext()) {
								this.__item_5_0 = this._itemEnumerator.current();
								if (this._toSkip <= 0) {
									this.__2__current = this.__item_5_0;
									this.__1__state = 2;
									return true;
								}

								this._toSkip--;
								this.__1__state = 2;
								break;
							}

							this._m_Finally0();
							break;
					}


				}

		}
		catch (e) {
				__hasError__ = true;
				throw e;

		}finally {
				if (__hasError__) {
				(this).dispose();
				}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.Enumerable___Skip__IteratorClass$1(this.$tSource, 0);
		}

		d__._source = this.__3__source;
		d__._toSkip = this.__3__toSkip;
		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
		switch (this.__1__state) {
			case 1:
			case 2:
				this._m_Finally0();
				break;
		}

	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('Enumerable___Skip__IteratorClass$1', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(0), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize(0), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

$.ig.util.defType('Enumerable___Where__IteratorClass1$1', 'Object', {
	$tSource: null, 
	__1__state: 0
	, 
	__2__current: null
	, 
	__index_5_0: 0
	, 
	_itemEnumerator: null
	, 
	__item_5_1: null
	, 
	_source: null
	, 
	__3__source: null
	, 
	_predicate: null
	, 
	__3__predicate: null
	, 
	init: function ($tSource, _1__state) {

		this.$tSource = $tSource;
		this.$type = this.$type.specialize(this.$tSource);


		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	_m_Finally0: function () {
		this.__1__state = -1;
		if (this._itemEnumerator != null) {
			this._itemEnumerator.dispose();
		}

	}

	, 
	moveNext: function () {
		var __hasError__ = false;
		try {
				while (this.__1__state >= 0) {
					switch (this.__1__state) {
						case 0:
							this.__1__state = -1;
							this.__index_5_0 = 0;
							this.__1__state = 1;
							this._itemEnumerator = this._source.getEnumerator();
							this.__1__state = 2;
							break;
						case 2:
							this.__1__state = 1;
							if (this._itemEnumerator.moveNext()) {
								this.__item_5_1 = this._itemEnumerator.current();
								if (this._predicate(this.__item_5_1, this.__index_5_0)) {
									this.__2__current = this.__item_5_1;
									this.__1__state = 3;
									return true;
								}

								this.__1__state = 3;
								break;
							}

							this._m_Finally0();
							break;
						case 3:
							this.__1__state = 1;
							this.__index_5_0++;
							this.__1__state = 2;
							break;
					}


				}

		}
		catch (e) {
				__hasError__ = true;
				throw e;

		}finally {
				if (__hasError__) {
				(this).dispose();
				}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.Enumerable___Where__IteratorClass1$1(this.$tSource, 0);
		}

		d__._source = this.__3__source;
		d__._predicate = this.__3__predicate;
		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
		switch (this.__1__state) {
			case 1:
			case 2:
			case 3:
				this._m_Finally0();
				break;
		}

	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('Enumerable___Where__IteratorClass1$1', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(0), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize(0), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

$.ig.util.defType('Dictionary___ToEnumerable__IteratorClass$2', 'Object', {
	$tKey: null, 
	$tValue: null, 
	__1__state: 0
	, 
	__2__current: null
	, 
	__array_5_0: null
	, 
	__i_5_1: 0
	, 
	__array_5_2: null
	, 
	__i_5_3: 0
	, 
	__pair_5_4: null
	, 
	__pArray_5_5: null
	, 
	__j_5_6: 0
	, 
	__subItem__5_7: null
	, 
	__4__this: null
	, 
	init: function ($tKey, $tValue, _1__state) {

		this.$tKey = $tKey;
		this.$tValue = $tValue;
		this.$type = this.$type.specialize(this.$tKey, this.$tValue);

		this.__2__current = new $.ig.KeyValuePair$2(this.$tKey, this.$tValue);

		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	moveNext: function () {
		while (this.__1__state >= 0) {
			switch (this.__1__state) {
				case 0:
					this.__1__state = -1;
					if (this.__4__this.__assumeUniqueKeys) {
						this.__array_5_0 = $.ig.util.getArrayOfProperties(this.__4__this.__keysUnique);
						this.__i_5_1 = 0;
						this.__1__state = 1;
						break;
					}

					this.__array_5_2 = $.ig.util.getArrayOfProperties(this.__4__this.__values);
					this.__i_5_3 = 0;
					this.__1__state = 3;
					break;
				case 1:
					this.__1__state = -1;
					if (this.__i_5_1 < this.__array_5_0.length) {
						this.__2__current = new $.ig.KeyValuePair$2(this.$tKey, this.$tValue, 1, this.__4__this.__keysUnique[this.__array_5_0[this.__i_5_1]], this.__4__this.__values[this.__array_5_0[this.__i_5_1]]);
						this.__1__state = 2;
						return true;
					}

					break;
				case 2:
					this.__1__state = -1;
					this.__i_5_1++;
					this.__1__state = 1;
					break;
				case 3:
					this.__1__state = -1;
					if (this.__i_5_3 < this.__array_5_2.length) {
						this.__pair_5_4 = this.__4__this.__values[this.__array_5_2[this.__i_5_3]];
						if (this.__pair_5_4.$isHashSetBucket) {
							this.__pArray_5_5 = this.__pair_5_4;
							this.__j_5_6 = 0;
							this.__1__state = 4;
							break;
						}

						this.__2__current = new $.ig.KeyValuePair$2(this.$tKey, this.$tValue, 1, this.__pair_5_4.key, this.__pair_5_4.value);
						this.__1__state = 6;
						return true;
					}

					break;
				case 4:
					this.__1__state = -1;
					if (this.__j_5_6 < this.__pArray_5_5.length) {
						this.__subItem__5_7 = this.__pArray_5_5[this.__j_5_6];
						this.__2__current = new $.ig.KeyValuePair$2(this.$tKey, this.$tValue, 1, this.__subItem__5_7.key, this.__subItem__5_7.value);
						this.__1__state = 5;
						return true;
					}

					this.__1__state = 6;
					break;
				case 5:
					this.__1__state = -1;
					this.__j_5_6++;
					this.__1__state = 4;
					break;
				case 6:
					this.__1__state = -1;
					this.__i_5_3++;
					this.__1__state = 3;
					break;
			}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.Dictionary___ToEnumerable__IteratorClass$2(this.$tKey, this.$tValue, 0);
			d__.__4__this = this.__4__this;
		}

		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('Dictionary___ToEnumerable__IteratorClass$2', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize($.ig.KeyValuePair$2.prototype.$type.specialize(this.$tKey, this.$tValue)), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize($.ig.KeyValuePair$2.prototype.$type.specialize(this.$tKey, this.$tValue)), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

$.ig.util.defType('Enumerable___Where__IteratorClass$1', 'Object', {
	$tSource: null, 
	__1__state: 0
	, 
	__2__current: null
	, 
	_itemEnumerator: null
	, 
	__item_5_0: null
	, 
	_source: null
	, 
	__3__source: null
	, 
	_predicate: null
	, 
	__3__predicate: null
	, 
	init: function ($tSource, _1__state) {

		this.$tSource = $tSource;
		this.$type = this.$type.specialize(this.$tSource);


		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	_m_Finally0: function () {
		this.__1__state = -1;
		if (this._itemEnumerator != null) {
			this._itemEnumerator.dispose();
		}

	}

	, 
	moveNext: function () {
		var __hasError__ = false;
		try {
				while (this.__1__state >= 0) {
					switch (this.__1__state) {
						case 0:
							this.__1__state = 1;
							this._itemEnumerator = this._source.getEnumerator();
							this.__1__state = 2;
							break;
						case 2:
							this.__1__state = 1;
							if (this._itemEnumerator.moveNext()) {
								this.__item_5_0 = this._itemEnumerator.current();
								if (this._predicate(this.__item_5_0)) {
									this.__2__current = this.__item_5_0;
									this.__1__state = 2;
									return true;
								}

								this.__1__state = 2;
								break;
							}

							this._m_Finally0();
							break;
					}


				}

		}
		catch (e) {
				__hasError__ = true;
				throw e;

		}finally {
				if (__hasError__) {
				(this).dispose();
				}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.Enumerable___Where__IteratorClass$1(this.$tSource, 0);
		}

		d__._source = this.__3__source;
		d__._predicate = this.__3__predicate;
		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
		switch (this.__1__state) {
			case 1:
			case 2:
				this._m_Finally0();
				break;
		}

	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('Enumerable___Where__IteratorClass$1', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(0), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize(0), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

$.ig.util.defType('Enumerable___Empty__IteratorClass$1', 'Object', {
	$tSource: null, 
	__1__state: 0
	, 
	__2__current: null
	, 
	init: function ($tSource, _1__state) {

		this.$tSource = $tSource;
		this.$type = this.$type.specialize(this.$tSource);


		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	moveNext: function () {
		switch (this.__1__state) {
			case 0:
				this.__1__state = -1;
				return false;
		}

		return false;
	}

	, 
	getEnumerator: function () {
		if (this.__1__state == -2) {
			this.__1__state = 0;
			return this;
		}

		return new $.ig.Enumerable___Empty__IteratorClass$1(this.$tSource, 0);
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('Enumerable___Empty__IteratorClass$1', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(0), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize(0), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

$.ig.util.defType('Enumerable___SelectMany__IteratorClass1$3', 'Object', {
	$tSource: null, 
	$tCollection: null, 
	$tResult: null, 
	__1__state: 0
	, 
	__2__current: null
	, 
	_itemEnumerator: null
	, 
	__item_5_0: null
	, 
	_resultEnumerator: null
	, 
	__result_5_1: null
	, 
	_source: null
	, 
	__3__source: null
	, 
	_collectionSelector: null
	, 
	__3__collectionSelector: null
	, 
	_resultSelector: null
	, 
	__3__resultSelector: null
	, 
	init: function ($tSource, $tCollection, $tResult, _1__state) {

		this.$tSource = $tSource;
		this.$tCollection = $tCollection;
		this.$tResult = $tResult;
		this.$type = this.$type.specialize(this.$tSource, this.$tCollection, this.$tResult);


		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	_m_Finally0: function () {
		this.__1__state = -1;
		if (this._itemEnumerator != null) {
			this._itemEnumerator.dispose();
		}

	}

	, 
	_m_Finally1: function () {
		this.__1__state = 1;
		if (this._resultEnumerator != null) {
			this._resultEnumerator.dispose();
		}

	}

	, 
	moveNext: function () {
		var __hasError__ = false;
		try {
				while (this.__1__state >= 0) {
					switch (this.__1__state) {
						case 0:
							this.__1__state = 1;
							this._itemEnumerator = this._source.getEnumerator();
							this.__1__state = 2;
							break;
						case 2:
							this.__1__state = 1;
							if (this._itemEnumerator.moveNext()) {
								this.__item_5_0 = this._itemEnumerator.current();
								this.__1__state = 3;
								this._resultEnumerator = this._collectionSelector(this.__item_5_0).getEnumerator();
								this.__1__state = 4;
								break;
							}

							this._m_Finally0();
							break;
						case 4:
							this.__1__state = 3;
							if (this._resultEnumerator.moveNext()) {
								this.__result_5_1 = this._resultEnumerator.current();
								this.__2__current = this._resultSelector(this.__item_5_0, this.__result_5_1);
								this.__1__state = 4;
								return true;
							}

							this._m_Finally1();
							this.__1__state = 2;
							break;
					}


				}

		}
		catch (e) {
				__hasError__ = true;
				throw e;

		}finally {
				if (__hasError__) {
				(this).dispose();
				}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.Enumerable___SelectMany__IteratorClass1$3(this.$tSource, this.$tCollection, this.$tResult, 0);
		}

		d__._source = this.__3__source;
		d__._collectionSelector = this.__3__collectionSelector;
		d__._resultSelector = this.__3__resultSelector;
		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
		switch (this.__1__state) {
			case 1:
			case 2:
				this._m_Finally0();
				break;
			case 3:
			case 4:
				try {
						this._m_Finally1();

				}
				finally {
						this._m_Finally0();

				}
				break;
		}

	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('Enumerable___SelectMany__IteratorClass1$3', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(0), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize(0), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

$.ig.util.defType('Enumerable___SelectMany__IteratorClass$2', 'Object', {
	$tSource: null, 
	$tResult: null, 
	__1__state: 0
	, 
	__2__current: null
	, 
	_itemEnumerator: null
	, 
	__item_5_0: null
	, 
	_item2Enumerator: null
	, 
	__item2_5_1: null
	, 
	_source: null
	, 
	__3__source: null
	, 
	_selector: null
	, 
	__3__selector: null
	, 
	init: function ($tSource, $tResult, _1__state) {

		this.$tSource = $tSource;
		this.$tResult = $tResult;
		this.$type = this.$type.specialize(this.$tSource, this.$tResult);


		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	_m_Finally0: function () {
		this.__1__state = -1;
		if (this._itemEnumerator != null) {
			this._itemEnumerator.dispose();
		}

	}

	, 
	_m_Finally1: function () {
		this.__1__state = 1;
		if (this._item2Enumerator != null) {
			this._item2Enumerator.dispose();
		}

	}

	, 
	moveNext: function () {
		var __hasError__ = false;
		try {
				while (this.__1__state >= 0) {
					switch (this.__1__state) {
						case 0:
							this.__1__state = 1;
							this._itemEnumerator = this._source.getEnumerator();
							this.__1__state = 2;
							break;
						case 2:
							this.__1__state = 1;
							if (this._itemEnumerator.moveNext()) {
								this.__item_5_0 = this._itemEnumerator.current();
								this.__1__state = 3;
								this._item2Enumerator = this._selector(this.__item_5_0).getEnumerator();
								this.__1__state = 4;
								break;
							}

							this._m_Finally0();
							break;
						case 4:
							this.__1__state = 3;
							if (this._item2Enumerator.moveNext()) {
								this.__item2_5_1 = this._item2Enumerator.current();
								this.__2__current = this.__item2_5_1;
								this.__1__state = 4;
								return true;
							}

							this._m_Finally1();
							this.__1__state = 2;
							break;
					}


				}

		}
		catch (e) {
				__hasError__ = true;
				throw e;

		}finally {
				if (__hasError__) {
				(this).dispose();
				}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.Enumerable___SelectMany__IteratorClass$2(this.$tSource, this.$tResult, 0);
		}

		d__._source = this.__3__source;
		d__._selector = this.__3__selector;
		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
		switch (this.__1__state) {
			case 1:
			case 2:
				this._m_Finally0();
				break;
			case 3:
			case 4:
				try {
						this._m_Finally1();

				}
				finally {
						this._m_Finally0();

				}
				break;
		}

	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('Enumerable___SelectMany__IteratorClass$2', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(0), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize(0), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

$.ig.util.defType('Enumerable___Take__IteratorClass$1', 'Object', {
	$tSource: null, 
	__1__state: 0
	, 
	__2__current: null
	, 
	_itemEnumerator: null
	, 
	__item_5_0: null
	, 
	_source: null
	, 
	__3__source: null
	, 
	_toTake: 0
	, 
	__3__toTake: 0
	, 
	init: function ($tSource, _1__state) {

		this.$tSource = $tSource;
		this.$type = this.$type.specialize(this.$tSource);


		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	_m_Finally0: function () {
		this.__1__state = -1;
		if (this._itemEnumerator != null) {
			this._itemEnumerator.dispose();
		}

	}

	, 
	moveNext: function () {
		var __hasError__ = false;
		try {
				while (this.__1__state >= 0) {
					switch (this.__1__state) {
						case 0:
							this.__1__state = 1;
							this._itemEnumerator = this._source.getEnumerator();
							this.__1__state = 2;
							break;
						case 2:
							this.__1__state = 1;
							if (this._itemEnumerator.moveNext()) {
								this.__item_5_0 = this._itemEnumerator.current();
								if (this._toTake > 0) {
									this._toTake--;
									this.__2__current = this.__item_5_0;
									this.__1__state = 2;
									return true;
								}

								return false;
							}

							this._m_Finally0();
							break;
					}


				}

		}
		catch (e) {
				__hasError__ = true;
				throw e;

		}finally {
				if (__hasError__) {
				(this).dispose();
				}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.Enumerable___Take__IteratorClass$1(this.$tSource, 0);
		}

		d__._source = this.__3__source;
		d__._toTake = this.__3__toTake;
		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
		switch (this.__1__state) {
			case 1:
			case 2:
				this._m_Finally0();
				break;
		}

	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('Enumerable___Take__IteratorClass$1', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(0), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize(0), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);


$.ig.NotifyCollectionChangedAction.prototype.add = 0;
$.ig.NotifyCollectionChangedAction.prototype.remove = 1;
$.ig.NotifyCollectionChangedAction.prototype.replace = 2;
$.ig.NotifyCollectionChangedAction.prototype.reset = 4;





$.ig.ModifierKeys.prototype.none = 0;
$.ig.ModifierKeys.prototype.alt = 1;
$.ig.ModifierKeys.prototype.control = 2;
$.ig.ModifierKeys.prototype.shift = 4;
$.ig.ModifierKeys.prototype.windows = 8;
$.ig.ModifierKeys.prototype.apple = 8;


$.ig.Key.prototype.none = 0;
$.ig.Key.prototype.back = 1;
$.ig.Key.prototype.tab = 2;
$.ig.Key.prototype.enter = 3;
$.ig.Key.prototype.shift = 4;
$.ig.Key.prototype.ctrl = 5;
$.ig.Key.prototype.alt = 6;
$.ig.Key.prototype.capsLock = 7;
$.ig.Key.prototype.escape = 8;
$.ig.Key.prototype.space = 9;
$.ig.Key.prototype.pageUp = 10;
$.ig.Key.prototype.pageDown = 11;
$.ig.Key.prototype.end = 12;
$.ig.Key.prototype.home = 13;
$.ig.Key.prototype.left = 14;
$.ig.Key.prototype.up = 15;
$.ig.Key.prototype.right = 16;
$.ig.Key.prototype.down = 17;
$.ig.Key.prototype.insert = 18;
$.ig.Key.prototype.del = 19;
$.ig.Key.prototype.d0 = 20;
$.ig.Key.prototype.d1 = 21;
$.ig.Key.prototype.d2 = 22;
$.ig.Key.prototype.d3 = 23;
$.ig.Key.prototype.d4 = 24;
$.ig.Key.prototype.d5 = 25;
$.ig.Key.prototype.d6 = 26;
$.ig.Key.prototype.d7 = 27;
$.ig.Key.prototype.d8 = 28;
$.ig.Key.prototype.d9 = 29;
$.ig.Key.prototype.a = 30;
$.ig.Key.prototype.b = 31;
$.ig.Key.prototype.c = 32;
$.ig.Key.prototype.d = 33;
$.ig.Key.prototype.e = 34;
$.ig.Key.prototype.f = 35;
$.ig.Key.prototype.g = 36;
$.ig.Key.prototype.h = 37;
$.ig.Key.prototype.i = 38;
$.ig.Key.prototype.j = 39;
$.ig.Key.prototype.k = 40;
$.ig.Key.prototype.l = 41;
$.ig.Key.prototype.m = 42;
$.ig.Key.prototype.n = 43;
$.ig.Key.prototype.o = 44;
$.ig.Key.prototype.p = 45;
$.ig.Key.prototype.q = 46;
$.ig.Key.prototype.r = 47;
$.ig.Key.prototype.s = 48;
$.ig.Key.prototype.t = 49;
$.ig.Key.prototype.u = 50;
$.ig.Key.prototype.v = 51;
$.ig.Key.prototype.w = 52;
$.ig.Key.prototype.x = 53;
$.ig.Key.prototype.y = 54;
$.ig.Key.prototype.z = 55;
$.ig.Key.prototype.f1 = 56;
$.ig.Key.prototype.f2 = 57;
$.ig.Key.prototype.f3 = 58;
$.ig.Key.prototype.f4 = 59;
$.ig.Key.prototype.f5 = 60;
$.ig.Key.prototype.f6 = 61;
$.ig.Key.prototype.f7 = 62;
$.ig.Key.prototype.f8 = 63;
$.ig.Key.prototype.f9 = 64;
$.ig.Key.prototype.f10 = 65;
$.ig.Key.prototype.f11 = 66;
$.ig.Key.prototype.f12 = 67;
$.ig.Key.prototype.numPad0 = 68;
$.ig.Key.prototype.numPad1 = 69;
$.ig.Key.prototype.numPad2 = 70;
$.ig.Key.prototype.numPad3 = 71;
$.ig.Key.prototype.numPad4 = 72;
$.ig.Key.prototype.numPad5 = 73;
$.ig.Key.prototype.numPad6 = 74;
$.ig.Key.prototype.numPad7 = 75;
$.ig.Key.prototype.numPad8 = 76;
$.ig.Key.prototype.numPad9 = 77;
$.ig.Key.prototype.multiply = 78;
$.ig.Key.prototype.add = 79;
$.ig.Key.prototype.subtract = 80;
$.ig.Key.prototype.decimal = 81;
$.ig.Key.prototype.divide = 82;
$.ig.Key.prototype.unknown = 255;



$.ig.PenLineCap.prototype.flat = 0;
$.ig.PenLineCap.prototype.square = 1;
$.ig.PenLineCap.prototype.round = 2;
$.ig.PenLineCap.prototype.triangle = 3;


$.ig.SweepDirection.prototype.counterclockwise = 0;
$.ig.SweepDirection.prototype.clockwise = 1;


$.ig.PathSegmentType.prototype.line = 0;
$.ig.PathSegmentType.prototype.bezier = 1;
$.ig.PathSegmentType.prototype.polyBezier = 2;
$.ig.PathSegmentType.prototype.polyLine = 3;
$.ig.PathSegmentType.prototype.arc = 4;


$.ig.GeometryType.prototype.group = 0;
$.ig.GeometryType.prototype.line = 1;
$.ig.GeometryType.prototype.rectangle = 2;
$.ig.GeometryType.prototype.ellipse = 3;
$.ig.GeometryType.prototype.path = 4;


$.ig.FillRule.prototype.evenOdd = 0;
$.ig.FillRule.prototype.nonzero = 1;


$.ig.Visibility.prototype.visible = 0;
$.ig.Visibility.prototype.collapsed = 1;


$.ig.VerticalAlignment.prototype.top = 0;
$.ig.VerticalAlignment.prototype.center = 1;
$.ig.VerticalAlignment.prototype.bottom = 2;
$.ig.VerticalAlignment.prototype.stretch = 3;


$.ig.HorizontalAlignment.prototype.left = 0;
$.ig.HorizontalAlignment.prototype.center = 1;
$.ig.HorizontalAlignment.prototype.right = 2;
$.ig.HorizontalAlignment.prototype.stretch = 3;









$.ig.DependencyProperty.prototype.unsetValue = new $.ig.UnsetValue();


$.ig.DependencyPropertiesCollection.prototype.__instance = null;


$.ig.Size.prototype.empty = new $.ig.Size();





} (jQuery));



// Declare empty types
$.ig = $.ig || {};
(function ($) {
var $$t = {}
$.ig.$currDefinitions = $$t;
$.ig.util.bulkDefine(["BrushCollection:a", 
"ObservableCollection$1:b", 
"List$1:c", 
"Object:d", 
"Type:e", 
"Boolean:f", 
"ValueType:g", 
"Void:h", 
"IConvertible:i", 
"IFormatProvider:j", 
"Number:k", 
"String:l", 
"IComparable:m", 
"Number:n", 
"Number:o", 
"Number:p", 
"Number:q", 
"NumberStyles:r", 
"Enum:s", 
"Array:t", 
"IList:u", 
"ICollection:v", 
"IEnumerable:w", 
"IEnumerator:x", 
"Number:y", 
"String:z", 
"StringComparison:aa", 
"RegExp:ab", 
"CultureInfo:ac", 
"Calendar:ad", 
"Date:ae", 
"DayOfWeek:af", 
"DateTimeKind:ag", 
"Date:ah", 
"Error:ai", 
"CompareInfo:aj", 
"CompareOptions:ak", 
"NumberFormatInfo:al", 
"DateTimeFormatInfo:am", 
"CalendarWeekRule:an", 
"IEnumerable$1:ao", 
"IEnumerator$1:ap", 
"IDisposable:aq", 
"StringSplitOptions:ar", 
"Number:as", 
"Number:at", 
"Number:au", 
"Number:av", 
"Number:aw", 
"Number:ax", 
"Assembly:ay", 
"Stream:az", 
"SeekOrigin:a0", 
"RuntimeTypeHandle:a1", 
"MethodInfo:a2", 
"MethodBase:a3", 
"MemberInfo:a4", 
"ParameterInfo:a5", 
"TypeCode:a6", 
"ConstructorInfo:a7", 
"PropertyInfo:a8", 
"IList$1:a9", 
"ICollection$1:ba", 
"IArray:bb", 
"Script:bc", 
"Enumerable:bd", 
"Func$2:be", 
"MulticastDelegate:bf", 
"IntPtr:bg", 
"Func$3:bh", 
"IOrderedEnumerable$1:bi", 
"SortedList$1:bj", 
"Math:bk", 
"ArgumentNullException:bl", 
"NotImplementedException:bm", 
"IArrayList:bn", 
"Array:bo", 
"CompareCallback:bp", 
"Action$1:bq", 
"Comparer$1:br", 
"IComparer:bs", 
"IComparer$1:bt", 
"DefaultComparer$1:bu", 
"IComparable$1:bv", 
"Comparison$1:bw", 
"ReadOnlyCollection$1:bx", 
"Predicate$1:by", 
"INotifyCollectionChanged:bz", 
"NotifyCollectionChangedEventHandler:b0", 
"NotifyCollectionChangedEventArgs:b1", 
"EventArgs:b2", 
"NotifyCollectionChangedAction:b3", 
"INotifyPropertyChanged:b4", 
"PropertyChangedEventHandler:b5", 
"PropertyChangedEventArgs:b6", 
"Delegate:b7", 
"Interlocked:b8", 
"InterpolationMode:b9", 
"Brush:ca", 
"Color:cb", 
"ArgumentException:cc", 
"Nullable$1:cd", 
"Random:ce", 
"MathUtil:cf", 
"RuntimeHelpers:cg", 
"RuntimeFieldHandle:ch", 
"ColorUtil:ci", 
"ErrorBarCalculatorReference:cj", 
"ErrorBarCalculatorType:ck", 
"IErrorBarCalculator:cl", 
"IFastItemColumn$1:cm", 
"IFastItemColumnPropertyName:cn", 
"EventHandler$1:co", 
"FastItemColumn:cq", 
"IFastItemColumnInternal:cr", 
"IFastItemsSource:cs", 
"FastReflectionHelper:ct", 
"FastItemDateTimeColumn:cu", 
"FastItemObjectColumn:cv", 
"FastItemIntColumn:cw", 
"FastItemsSource:cx", 
"Dictionary$2:cy", 
"IDictionary$2:cz", 
"IDictionary:c0", 
"IEqualityComparer$1:c1", 
"EqualityComparer$1:c2", 
"IEqualityComparer:c3", 
"DefaultEqualityComparer$1:c4", 
"InvalidOperationException:c5", 
"KeyValuePair$2:c6", 
"FastItemsSourceEventAction:c7", 
"FastItemsSourceEventArgs:c8", 
"ColumnReference:c9", 
"FastItemsSourceReference:da", 
"IFastItemsSourceProvider:db", 
"IRenderer:dc", 
"Rectangle:dd", 
"Shape:de", 
"FrameworkElement:df", 
"UIElement:dg", 
"DependencyObject:dh", 
"Dictionary:di", 
"DependencyProperty:dj", 
"PropertyMetadata:dk", 
"PropertyChangedCallback:dl", 
"DependencyPropertyChangedEventArgs:dm", 
"UnsetValue:dn", 
"DependencyPropertiesCollection:dp", 
"Binding:dq", 
"PropertyPath:dr", 
"Transform:ds", 
"Visibility:dt", 
"Style:du", 
"DoubleCollection:dv", 
"Rect:dw", 
"Size:dx", 
"Point:dy", 
"Path:dz", 
"Geometry:d0", 
"GeometryType:d1", 
"TextBlock:d2", 
"Polygon:d3", 
"PointCollection:d4", 
"Polyline:d5", 
"DataTemplateRenderInfo:d6", 
"DataTemplatePassInfo:d7", 
"ContentControl:d8", 
"Control:d9", 
"Thickness:ea", 
"HorizontalAlignment:eb", 
"VerticalAlignment:ec", 
"DataTemplate:ed", 
"DataTemplateRenderHandler:ee", 
"DataTemplateMeasureHandler:ef", 
"DataTemplateMeasureInfo:eg", 
"DataTemplatePassHandler:eh", 
"Line:ei", 
"RectChangedEventArgs:ej", 
"RectChangedEventHandler:ek", 
"RenderingContext:em", 
"ArrayUtil:en", 
"BrushUtil:eo", 
"LinearGradientBrush:ep", 
"GradientStop:eq", 
"JQueryObject:er", 
"Element:es", 
"ElementAttributeCollection:et", 
"ElementCollection:eu", 
"WebStyle:ev", 
"ElementNodeType:ew", 
"Document:ex", 
"EventListener:ey", 
"IElementEventHandler:ez", 
"ElementEventHandler:e0", 
"ElementAttribute:e1", 
"JQueryPosition:e2", 
"JQueryCallback:e3", 
"JQueryEvent:e4", 
"JQueryUICallback:e5", 
"CssHelper:e6", 
"JQuery:e7", 
"JQueryDeferred:e8", 
"JQueryPromise:e9", 
"Action:fa", 
"CssGradientUtil:fb", 
"GeometryUtil:fc", 
"Tuple$2:fd", 
"Clipper:fe", 
"EdgeClipper:ff", 
"LeftClipper:fg", 
"BottomClipper:fh", 
"RightClipper:fi", 
"TopClipper:fj", 
"EasingFunctions:fk", 
"FontUtil:fl", 
"FontInfo:fm", 
"DoubleAnimator:fn", 
"EasingFunctionHandler:fo", 
"Callback:fp", 
"Extensions:fq", 
"PathGeometry:fr", 
"PathFigureCollection:fs", 
"PathFigure:ft", 
"PathSegmentCollection:fu", 
"GeometryGroup:fv", 
"GeometryCollection:fw", 
"FillRule:fx", 
"Panel:fy", 
"UIElementCollection:fz", 
"Flattener:f0", 
"Stack$1:f1", 
"ReverseArrayEnumerator$1:f2", 
"SpiralTodo:f3", 
"Func$1:f5", 
"PathSegment:f8", 
"PathSegmentType:f9", 
"ArcSegment:ga", 
"SweepDirection:gb", 
"LineSegment:gc", 
"PolyLineSegment:gd", 
"Pool$1:gg", 
"IIndexedPool$1:gh", 
"IPool$1:gi", 
"IHashPool$2:gj", 
"HashPool$2:gk", 
"RectUtil:gm", 
"SmartPlaceableWrapper$1:gn", 
"ISmartPlaceable:go", 
"SmartPosition:gp", 
"SmartPlacer:gq", 
"IVisualData:gs", 
"PrimitiveVisualDataList:gt", 
"PrimitiveVisualData:gu", 
"PrimitiveAppearanceData:gv", 
"BrushAppearanceData:gw", 
"StringBuilder:gx", 
"Environment:gy", 
"AppearanceHelper:gz", 
"LinearGradientBrushAppearanceData:g0", 
"GradientStopAppearanceData:g1", 
"SolidBrushAppearanceData:g2", 
"LineGeometry:g3", 
"RectangleGeometry:g4", 
"EllipseGeometry:g5", 
"EllipseGeometryData:g6", 
"GeometryData:g7", 
"GetPointsSettings:g8", 
"RectangleGeometryData:g9", 
"LineGeometryData:ha", 
"PathGeometryData:hb", 
"PathFigureData:hc", 
"LineSegmentData:hd", 
"SegmentData:he", 
"PolylineSegmentData:hf", 
"ArcSegmentData:hg", 
"PolyBezierSegment:hh", 
"PolyBezierSegmentData:hi", 
"LabelAppearanceData:hj", 
"RotateTransform:hk", 
"TransformGroup:hl", 
"TransformCollection:hm", 
"ShapeTags:hn", 
"RectangleVisualData:hq", 
"PolyLineVisualData:hs", 
"PolygonVisualData:ht", 
"PathVisualData:hu", 
"DOMEventProxy:hv", 
"EventProxy:hw", 
"ModifierKeys:hx", 
"MouseWheelHandler:hy", 
"GestureHandler:hz", 
"ContactHandler:h0", 
"TouchHandler:h1", 
"MouseOverHandler:h2", 
"MouseHandler:h3", 
"KeyHandler:h4", 
"Key:h5", 
"MSGesture:h6", 
"window:h7", 
"MouseEventArgs:h8", 
"CanvasRenderScheduler:h9", 
"ISchedulableRender:ia", 
"CanvasViewRenderer:ib", 
"CanvasContext2D:ic", 
"CanvasContext:id", 
"TextMetrics:ie", 
"ImageData:ig", 
"CanvasElement:ih", 
"Gradient:ii", 
"BezierSegment:ij", 
"TranslateTransform:ik", 
"ScaleTransform:il", 
"InteractionState:io", 
"IOverviewPlusDetailControl:ip", 
"OverviewPlusDetailPaneMode:ir", 
"PropertyChangedEventArgs$1:is", 
"XamOverviewPlusDetailPane:it", 
"XamOverviewPlusDetailPaneView:iu", 
"XamOverviewPlusDetailPaneViewManager:iv", 
"DivElement:iw", 
"ImageElement:ix", 
"Convert:jb", 
"Debug:jc", 
"TrendCalculators:jg", 
"TrendLineType:jh", 
"UnknownValuePlotting:ji", 
"LeastSquaresFit:jj", 
"Numeric:jk", 
"AbstractEnumerable:jl", 
"AbstractEnumerator:jm", 
"GenericEnumerable$1:jn", 
"GenericEnumerator$1:jo"]);



$.ig.util.defType('OverviewPlusDetailPaneMode', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "Minimal";
			case 1: return "Full";
			case 2: return "Compact";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('OverviewPlusDetailPaneMode', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('InteractionState', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "None";
			case 1: return "DragZoom";
			case 2: return "DragPan";
			case 3: return "Auto";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('InteractionState', $.ig.Enum.prototype.$type)
}, true);


$.ig.util.defType('InterpolationMode', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "RGB";
			case 1: return "HSV";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('InterpolationMode', $.ig.Enum.prototype.$type)
}, true);


$.ig.util.defType('FastItemsSourceEventAction', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "Remove";
			case 1: return "Insert";
			case 2: return "Replace";
			case 3: return "Change";
			case 4: return "Reset";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('FastItemsSourceEventAction', $.ig.Enum.prototype.$type)
}, true);



$.ig.util.defType('BrushCollection', 'ObservableCollection$1', {
	init: function () {

		this._interpolationMode = $.ig.InterpolationMode.prototype.rGB;

		$.ig.ObservableCollection$1.prototype.init.call(this, $.ig.Brush.prototype.$type, 0);

	}
	, 
	selectRandom: function () {
		return this.item($.ig.BrushCollection.prototype._random.next1(this.count()));
	}

	, 
	interpolateRandom: function () {
		return this.getInterpolatedBrush($.ig.BrushCollection.prototype._random.nextDouble() * (this.count() - 1));
	}

	, 
	interpolationMode: function (value) {
		if (arguments.length === 1) {

			if (this._interpolationMode != value) {
				this._interpolationMode = value;
				this.onCollectionChanged(new $.ig.NotifyCollectionChangedEventArgs(0, $.ig.NotifyCollectionChangedAction.prototype.reset));
			}

			return value;
		} else {

			return this._interpolationMode;
		}
	}
	, 
	_interpolationMode: 0

	, 
	item: function (index, value) {
		if (arguments.length === 2) {

			$.ig.ObservableCollection$1.prototype.item.call(this, index, value);
			return value;
		} else {

			if (index < 0 || index >= this.count()) {
				return null;
			}

			return $.ig.ObservableCollection$1.prototype.item.call(this, index);
		}
	}

	, 
	getInterpolatedBrush: function (index) {
		if ($.ig.util.isNaN(index)) {
			return null;
		}

		index = $.ig.MathUtil.prototype.clamp(index, 0, this.count() - 1);
		var i = $.ig.truncate(Math.floor(index));
		if (i == index) {
			return this.item(i);
		}

		return this.interpolateBrushes(index - i, this.item(i), this.item(i + 1), this.interpolationMode());
	}

	, 
	interpolateBrushes: function (p, minBrush, maxBrush, InterpolationMode) {
		var minFill = minBrush.color();
		var maxFill = maxBrush.color();
		var interp = $.ig.ColorUtil.prototype.getInterpolation(minFill, p, maxFill, InterpolationMode);
		var b = new $.ig.Brush();
		b.color(interp);
		return b;
	}

	, 
	equals: function (obj) {
		if (obj == null) {
			return false;
		}

		var bc = obj;
		if (bc.count() != this.count()) {
			return false;
		}

		for (var i = 0; i < bc.count(); i++) {
			if (!bc.item(i).equals(this.item(i))) {
				return false;
			}

		}

		return true;
	}
	, 
	$type: new $.ig.Type('BrushCollection', $.ig.ObservableCollection$1.prototype.$type.specialize($.ig.Brush.prototype.$type))
}, true);



$.ig.util.defType('IFastItemColumnInternal', 'Object', {
	$type: new $.ig.Type('IFastItemColumnInternal', null)
}, true);

$.ig.util.defType('IFastItemColumnPropertyName', 'Object', {
	$type: new $.ig.Type('IFastItemColumnPropertyName', null)
}, true);

$.ig.util.defType('IFastItemColumn$1', 'Object', {
	$type: new $.ig.Type('IFastItemColumn$1', null, [$.ig.IList$1.prototype.$type.specialize(0), $.ig.IFastItemColumnPropertyName.prototype.$type])
}, true);

$.ig.util.defType('FastItemColumn', 'Object', {
	__coerceValue: null
	, 
	__expectFunctions: false
	, 
	init: function (fastItemsSource, propertyName, coerceValue, expectFunctions) {


		this.__coerceValue = null;
		this.__expectFunctions = false;
		this.__propertyName = null;

		$.ig.Object.prototype.init.call(this);
			this.__coerceValue = coerceValue;
			this.__expectFunctions = expectFunctions;
			this.propertyName(propertyName);
			this.fastItemsSource(fastItemsSource);
	}

	, 
	fastItemsSource: function (value) {
		if (arguments.length === 1) {

			this._fastItemsSource = value;
			this.reset();
			return value;
		} else {

			return this._fastItemsSource;
		}
	}
	, 
	_fastItemsSource: null
	, 
	__propertyName: null

	, 
	propertyName: function (value) {
		if (arguments.length === 1) {

			this.__propertyName = value;
			return value;
		} else {

			return this.__propertyName;
		}
	}

	, 
	minimum: function (value) {
		if (arguments.length === 1) {

			this._minimum = value;
			return value;
		} else {

			if ($.ig.util.isNaN(this._minimum) && this.values() != null) {
				this._minimum = Number.POSITIVE_INFINITY;
				var en = this.values().getEnumerator();
				while (en.moveNext()) {
					var value = en.current();
					if (!$.ig.util.isNaN(value)) {
						this._minimum = Math.min(this._minimum, value);
					}

				}

			}

			return this._minimum;
		}
	}
	, 
	_minimum: 0

	, 
	maximum: function (value) {
		if (arguments.length === 1) {

			this._maximum = value;
			return value;
		} else {

			if ($.ig.util.isNaN(this._maximum) && this.values() != null) {
				this._maximum = Number.NEGATIVE_INFINITY;
				var en = this.values().getEnumerator();
				while (en.moveNext()) {
					var value = en.current();
					if (!$.ig.util.isNaN(value)) {
						this._maximum = Math.max(this._maximum, value);
					}

				}

			}

			return this._maximum;
		}
	}
	, 
	_maximum: 0

	, 
	item: function (index, value) {
		if (arguments.length === 2) {

			this.values().__inner[index] = value;
			return value;
		} else {

			return this.values().__inner[index];
		}
	}

	, 
	getEnumerator: function () {
		return this.values().getEnumerator();
	}

	, 
	getEnumerator: function () {
		return this.values().getEnumerator();
	}

	, 
	contains: function (item) {
		return this.values().contains(item);
	}

	, 
	copyTo: function (array, arrayIndex) {
		this.values().copyTo(array, arrayIndex);
	}

	, 
	count: function () {

			return this.values().count();
	}

	, 
	isReadOnly: function () {

			return true;
	}

	, 
	indexOf: function (item) {
		return this.values().indexOf(item);
	}

	, 
	add: function (item) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	clear: function () {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	remove: function (item) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	insert: function (index, item) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	removeAt: function (index) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	reset: function () {
		this.values(null);
		this.minimum(NaN);
		this.maximum(NaN);
		return this.fastItemsSource() != null ? this.insertRange(0, this.fastItemsSource().count()) : true;
	}

	, 
	insertRange: function (position, count) {
		var newValues = new Array(count);
		var source_ = this._fastItemsSource.asArray();
		var item_;
		var minimum = this.minimum();
		var maximum = this.maximum();
		var minimumIsNaN = $.ig.util.isNaN(this.minimum());
		var maximumIsNaN = $.ig.util.isNaN(this.maximum());
		var newCount = 0;
		var newValue;
		var coerce = this.__coerceValue;
		var sourceItem_ = null;
		if (this.__coerceValue != null || this.__expectFunctions) {
			for (var i_ = position; i_ < position + count; ++i_) {
				sourceItem_ = source_[i_];
				if (sourceItem_ == null) {
					item_ = NaN;

				} else {
					item_ = sourceItem_[this.__propertyName];
				}

				if (this.__expectFunctions) {
					if (typeof(item_) == 'function') {
						item_ = item_();
					}

				}

				if (coerce != null) {
					item_ = coerce(item_);
				}

				newValue = item_ == null ? NaN : item_;
				var valIsNaN = (newValue != newValue);
				if (minimumIsNaN || newValue < minimum) {
					minimum = newValue;
					minimumIsNaN = valIsNaN;
				}

				if (maximumIsNaN || newValue > maximum) {
					maximum = newValue;
					maximumIsNaN = valIsNaN;
				}

				newValues[newCount] = newValue;
				newCount++;
			}


		} else {
			for (var i_ = position; i_ < position + count; ++i_) {
				sourceItem_ = source_[i_];
				if (sourceItem_ == null) {
					item_ = NaN;

				} else {
					item_ = sourceItem_[this.__propertyName];
				}

				newValue = item_ == null ? NaN : item_;
				var valIsNaN1 = (newValue != newValue);
				if (minimumIsNaN || newValue < minimum) {
					minimum = newValue;
					minimumIsNaN = valIsNaN1;
				}

				if (maximumIsNaN || newValue > maximum) {
					maximum = newValue;
					maximumIsNaN = valIsNaN1;
				}

				newValues[newCount] = newValue;
				newCount++;
			}

		}

		this.minimum(minimum);
		this.maximum(maximum);
		if (this.values() == null) {
			this.values(new $.ig.List$1(Number, 1, newValues));

		} else {
			this.values().insertRange(position, newValues);
		}

		return true;
	}

	, 
	removeRange: function (position, count) {
		for (var i = position; i < position + count && !$.ig.util.isNaN(this.minimum()) && !$.ig.util.isNaN(this.maximum()); ++i) {
			if (this.item(i) == this.minimum()) {
				this.minimum(NaN);
			}

			if (this.item(i) == this.maximum()) {
				this.maximum(NaN);
			}

		}

		this.values().removeRange(position, count);
		return true;
	}

	, 
	replaceMinMax: function (oldValue, newValue) {
		if ($.ig.util.isNaN(oldValue)) {
			if (!$.ig.util.isNaN(newValue)) {
				if (!$.ig.util.isNaN(this.minimum())) {
					this.minimum(Math.min(newValue, this.minimum()));
				}

				if (!$.ig.util.isNaN(this.maximum())) {
					this.maximum(Math.max(newValue, this.maximum()));
				}

			}

			return;
		}

		if ($.ig.util.isNaN(newValue)) {
			this.minimum(!$.ig.util.isNaN(this.minimum()) && oldValue == this.minimum() ? NaN : this.minimum());
			this.maximum(!$.ig.util.isNaN(this.maximum()) && oldValue == this.maximum() ? NaN : this.maximum());
			return;
		}

		if (!$.ig.util.isNaN(this.minimum())) {
			if (oldValue == this.minimum() && newValue > this.minimum()) {
				this.minimum(NaN);

			} else {
				this.minimum(Math.min(newValue, this.minimum()));
			}

		}

		if (!$.ig.util.isNaN(this.maximum())) {
			if (oldValue == this.maximum() && newValue < this.maximum()) {
				this.maximum(NaN);

			} else {
				this.maximum(Math.max(newValue, this.maximum()));
			}

		}

	}

	, 
	replaceRange: function (position, count) {
		var ret = false;
		for (var i = 0; i < count; ++i) {
			var oldValue = this.values().__inner[position + i];
			var newValue = this.toDouble(this.fastItemsSource().item(position + i));
			if (oldValue != newValue) {
				this.values().__inner[position + i] = newValue;
				ret = true;
				this.replaceMinMax(oldValue, newValue);
			}

		}

		return ret;
	}
	, 
	_fastReflectionHelper: null

	, 
	toDouble: function (item) {
		if (item == null) {
			return NaN;
		}

		var from_ = item;
		item = from_[this.__propertyName];
		if (this.__expectFunctions) {
			from_ = item;
			if (typeof(from_) == 'function') {
				item = from_();
			}

		}

		if (this.__coerceValue != null) {
			item = this.__coerceValue(item);
		}

		if (item == null) {
			return NaN;
		}

		return item;
		if ($.ig.util.cast(Number, item) !== null) {
			return item;
		}

	}

	, 
	_values: null,
	values: function (value) {
		if (arguments.length === 1) {
			this._values = value;
			return value;
		} else {
			return this._values;
		}
	}

	, 
	getSortedIndices1: function (values, comparison) {
		var $self = this;
		var result = new $.ig.List$1($.ig.Number.prototype.$type, 2, values.count());
		for (var i = 0; i < values.count(); i++) {
			result.add(i);
		}

		result.sort2(function (i1, i2) {
			var v1 = values.item(i1);
			var v2 = values.item(i2);
			return comparison(v1, v2);
		});
		return result;
	}

	, 
	getSortedIndices: function () {
		var $self = this;
		return $.ig.FastItemColumn.prototype.getSortedIndices1($self.values(), function (o1, o2) {
			var d1 = o1;
			var d2 = o2;
			if (d1 < d2) {
				return -1;
			}

			if (d1 > d2) {
				return 1;
			}

			return 0;
		});
	}

	, 
	asArray: function () {
		return this.values().asArray();
	}
	, 
	$type: new $.ig.Type('FastItemColumn', $.ig.Object.prototype.$type, [$.ig.IFastItemColumnInternal.prototype.$type, $.ig.IFastItemColumn$1.prototype.$type.specialize(Number)])
}, true);

$.ig.util.defType('FastItemDateTimeColumn', 'Object', {
	__coerceValue: null
	, 
	__expectFunctions: false
	, 
	init: function (fastItemsSource, propertyName, coerceValue, expectFunctions) {


		this.__propertyName = null;
		this._hasMinimum = false;
		this._hasMaximum = false;

		$.ig.Object.prototype.init.call(this);
			this.__coerceValue = coerceValue;
			this.__expectFunctions = expectFunctions;
			this.propertyName(propertyName);
			this.fastItemsSource(fastItemsSource);
	}

	, 
	fastItemsSource: function (value) {
		if (arguments.length === 1) {

			this._fastItemsSource = value;
			this.reset();
			return value;
		} else {

			return this._fastItemsSource;
		}
	}
	, 
	_fastItemsSource: null
	, 
	__propertyName: null

	, 
	propertyName: function (value) {
		if (arguments.length === 1) {

			this.__propertyName = value;
			return value;
		} else {

			return this.__propertyName;
		}
	}
	, 
	_hasMinimum: false
	, 
	_hasMaximum: false

	, 
	minimum: function (value) {
		if (arguments.length === 1) {

			this._minimum = value;
			return value;
		} else {

			if (!this._hasMinimum && this.values() != null) {
				var en = this.values().getEnumerator();
				while (en.moveNext()) {
					var value = en.current();
					if (value < this._minimum) {
						this._minimum = value;
					}

				}

				if (this.values().count() > 0) {
					this._hasMinimum = true;
				}

			}

			return this._minimum;
		}
	}
	, 
	_minimum: new Date()

	, 
	maximum: function (value) {
		if (arguments.length === 1) {

			this._maximum = value;
			return value;
		} else {

			if (!this._hasMaximum && this.values() != null) {
				var en = this.values().getEnumerator();
				while (en.moveNext()) {
					var value = en.current();
					if (value > this._maximum) {
						this._maximum = value;
					}

				}

				if (this.values().count() > 0) {
					this._hasMaximum = true;
				}

			}

			return this._maximum;
		}
	}
	, 
	_maximum: new Date()

	, 
	item: function (index, value) {
		if (arguments.length === 2) {

			throw new $.ig.NotImplementedException(0);
			return value;
		} else {

			return this.values().__inner[index];
		}
	}

	, 
	getEnumerator: function () {
		return this.values().getEnumerator();
	}

	, 
	getEnumerator: function () {
		return this.values().getEnumerator();
	}

	, 
	contains: function (item) {
		return this.values().contains(item);
	}

	, 
	copyTo: function (array, arrayIndex) {
		this.values().copyTo(array, arrayIndex);
	}

	, 
	count: function () {

			return this.values().count();
	}

	, 
	isReadOnly: function () {

			return true;
	}

	, 
	indexOf: function (item) {
		return this.values().indexOf(item);
	}

	, 
	add: function (item) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	clear: function () {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	remove: function (item) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	insert: function (index, item) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	removeAt: function (index) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	reset: function () {
		this.values(null);
		this._hasMinimum = false;
		this._hasMaximum = false;
		return this.fastItemsSource() != null ? this.insertRange(0, this.fastItemsSource().count()) : true;
	}

	, 
	insertRange: function (position, count) {
		var newValues = new Array(count);
		var source_ = this._fastItemsSource.asArray();
		var item_;
		var minimum = this.minimum();
		var maximum = this.maximum();
		var newValue;
		var newCount = 0;
		var coerce = this.__coerceValue;
		if (this.__coerceValue != null || this.__expectFunctions) {
			for (var i_ = position; i_ < position + count; ++i_) {
				item_ = source_[i_][this.__propertyName];
				if (this.__expectFunctions) {
					if (typeof(item_) == 'function') {
						item_ = item_();
					}

				}

				if (coerce != null) {
					item_ = coerce(item_);
				}

				newValue = item_ == null ? new Date() : item_;
				if (!this._hasMinimum) {
					minimum = newValue;
					this._hasMinimum = true;

				} else if (newValue < minimum) {
					minimum = newValue;
				}


				if (!this._hasMaximum) {
					maximum = newValue;
					this._hasMaximum = true;

				} else if (newValue > maximum) {
					maximum = newValue;
				}


				newValues[newCount] = newValue;
				newCount++;
			}


		} else {
			for (var i_ = position; i_ < position + count; ++i_) {
				item_ = source_[i_][this.__propertyName];
				newValue = item_ == null ? new Date() : item_;
				if (!this._hasMinimum) {
					minimum = newValue;
					this._hasMinimum = true;

				} else if (newValue < minimum) {
					minimum = newValue;
				}


				if (!this._hasMaximum) {
					maximum = newValue;
					this._hasMaximum = true;

				} else if (newValue > maximum) {
					maximum = newValue;
				}


				newValues[newCount] = newValue;
				newCount++;
			}

		}

		this.minimum(minimum);
		this.maximum(maximum);
		if (this.values() == null) {
			this.values(new $.ig.List$1($.ig.Date.prototype.$type, 1, newValues));

		} else {
			this.values().insertRange(position, newValues);
		}

		return true;
	}

	, 
	removeRange: function (position, count) {
		for (var i = position; i < position + count; ++i) {
			if (this.item(i) == this.minimum()) {
				this._hasMinimum = false;
			}

			if (this.item(i) == this.maximum()) {
				this._hasMaximum = false;
			}

		}

		this.values().removeRange(position, count);
		return true;
	}

	, 
	replaceMinMax: function (oldValue, newValue) {
		if (oldValue != $.ig.Date.prototype.minValue()) {
			if (newValue != $.ig.Date.prototype.minValue()) {
				this.minimum(newValue < this.minimum() ? newValue : this.minimum());
				this.maximum(newValue > this.maximum() ? newValue : this.maximum());
			}

			return;
		}

		this.minimum(newValue < this.minimum() ? newValue : this.minimum());
		this.maximum(newValue > this.maximum() ? newValue : this.maximum());
	}

	, 
	replaceRange: function (position, count) {
		var ret = false;
		for (var i = 0; i < count; ++i) {
			var oldValue = this.values().__inner[position + i];
			var newValue = this.toDateTime(this.fastItemsSource().item(position + i));
			if (oldValue != newValue) {
				this.values().__inner[position + i] = newValue;
				ret = true;
				this.replaceMinMax(oldValue, newValue);
			}

		}

		return ret;
	}
	, 
	_fastReflectionHelper: null

	, 
	toDateTime: function (item) {
		if (item == null) {
			return $.ig.Date.prototype.minValue();
		}

		var from_ = item;
		item = from_[this.__propertyName];
		if (this.__expectFunctions) {
			from_ = item;
			if (typeof(from_) == 'function') {
				item = from_();
			}

		}

		if (this.__coerceValue != null) {
			item = this.__coerceValue(item);
		}

		if (item == null) {
			return $.ig.Date.prototype.minValue();
		}

		return item;
	}

	, 
	_values: null,
	values: function (value) {
		if (arguments.length === 1) {
			this._values = value;
			return value;
		} else {
			return this._values;
		}
	}

	, 
	getSortedIndices: function () {
		var $self = this;
		return $.ig.FastItemColumn.prototype.getSortedIndices1($self.values(), function (o1, o2) {
			var d1 = o1;
			var d2 = o2;
			if (d1 < d2) {
				return -1;
			}

			if (d1 > d2) {
				return 1;
			}

			return 0;
		});
	}

	, 
	asArray: function () {
		return this.values().asArray();
	}
	, 
	$type: new $.ig.Type('FastItemDateTimeColumn', $.ig.Object.prototype.$type, [$.ig.IFastItemColumnInternal.prototype.$type, $.ig.IFastItemColumn$1.prototype.$type.specialize($.ig.Date.prototype.$type)])
}, true);

$.ig.util.defType('FastItemObjectColumn', 'Object', {
	__coerceValue: null
	, 
	__expectFunctions: false
	, 
	init: function (fastItemsSource, propertyName, coerceValue, expectFunctions) {



		$.ig.Object.prototype.init.call(this);
			this.__coerceValue = coerceValue;
			this.__expectFunctions = expectFunctions;
			this.propertyName(propertyName);
			this.fastItemsSource(fastItemsSource);
	}

	, 
	fastItemsSource: function (value) {
		if (arguments.length === 1) {

			this._fastItemsSource = value;
			this.reset();
			return value;
		} else {

			return this._fastItemsSource;
		}
	}
	, 
	_fastItemsSource: null
	, 
	__propertyName: null

	, 
	propertyName: function (value) {
		if (arguments.length === 1) {

			this.__propertyName = value;
			return value;
		} else {

			return this.__propertyName;
		}
	}

	, 
	minimum: function (value) {
		if (arguments.length === 1) {

			this.__minimum = value;
			return value;
		} else {

			return this.__minimum;
		}
	}
	, 
	__minimum: null

	, 
	maximum: function (value) {
		if (arguments.length === 1) {

			this.__maximum = value;
			return value;
		} else {

			return this.__maximum;
		}
	}
	, 
	__maximum: null

	, 
	item: function (index, value) {
		if (arguments.length === 2) {

			throw new $.ig.NotImplementedException(0);
			return value;
		} else {

			return this.values().__inner[index];
		}
	}

	, 
	getEnumerator: function () {
		return this.values().getEnumerator();
	}

	, 
	getEnumerator: function () {
		return this.values().getEnumerator();
	}

	, 
	contains: function (item) {
		return this.values().contains1(item);
	}

	, 
	copyTo: function (array, arrayIndex) {
		this.values().copyTo(array, arrayIndex);
	}

	, 
	count: function () {

			return this.values().count();
	}

	, 
	isReadOnly: function () {

			return true;
	}

	, 
	indexOf: function (item) {
		return this.values().indexOf1(item);
	}

	, 
	add: function (item) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	clear: function () {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	remove: function (item) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	insert: function (index, item) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	removeAt: function (index) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	reset: function () {
		this.values(null);
		return this.fastItemsSource() != null ? this.insertRange(0, this.fastItemsSource().count()) : true;
	}

	, 
	insertRange: function (position, count) {
		var $self = this;
		var newValues = (function () { var $ret = new $.ig.List$1($.ig.Object.prototype.$type, 0);
		$ret.capacity(count); return $ret;}());
		for (var i = position; i < position + count; ++i) {
			var newValue = $self.toObject($self.fastItemsSource().item(i));
			newValues.add1(newValue);
		}

		if ($self.values() == null) {
			$self.values(newValues);

		} else {
			$self.values().insertRange(position, newValues);
		}

		return true;
	}

	, 
	replaceRange: function (position, count) {
		var ret = false;
		for (var i = 0; i < count; ++i) {
			var oldValue = this.values().__inner[position + i];
			var newValue = this.toObject(this.fastItemsSource().item(position + i));
			if (oldValue != newValue) {
				this.values().__inner[position + i] = newValue;
				ret = true;
			}

		}

		return ret;
	}

	, 
	removeRange: function (position, count) {
		this.values().removeRange(position, count);
		return true;
	}
	, 
	_fastReflectionHelper: null

	, 
	toObject: function (item) {
		if (item == null) {
			return null;
		}

		var from_ = item;
		item = from_[this.__propertyName];
		if (this.__expectFunctions) {
			from_ = item;
			if (typeof(from_) == 'function') {
				item = from_();
			}

		}

		if (this.__coerceValue != null) {
			item = this.__coerceValue(item);
		}

		return item;
	}

	, 
	_values: null,
	values: function (value) {
		if (arguments.length === 1) {
			this._values = value;
			return value;
		} else {
			return this._values;
		}
	}

	, 
	getSortedIndices: function () {
		var $self = this;
		return $.ig.FastItemColumn.prototype.getSortedIndices1($self.values(), function (o1, o2) {
			var d1 = parseFloat(o1);
			var d2 = parseFloat(o2);
			if (d1 < d2) {
				return -1;
			}

			if (d1 > d2) {
				return 1;
			}

			return 0;
		});
	}

	, 
	asArray: function () {
		return this.values().asArray();
	}
	, 
	$type: new $.ig.Type('FastItemObjectColumn', $.ig.Object.prototype.$type, [$.ig.IFastItemColumnInternal.prototype.$type, $.ig.IFastItemColumn$1.prototype.$type.specialize($.ig.Object.prototype.$type)])
}, true);

$.ig.util.defType('FastItemIntColumn', 'Object', {
	__coerceValue: null
	, 
	__expectFunctions: false
	, 
	init: function (fastItemsSource, propertyName, coerceValue, expectFunctions) {


		this.__propertyName = null;

		$.ig.Object.prototype.init.call(this);
			this.__coerceValue = coerceValue;
			this.__expectFunctions = expectFunctions;
			this.propertyName(propertyName);
			this.fastItemsSource(fastItemsSource);
	}

	, 
	fastItemsSource: function (value) {
		if (arguments.length === 1) {

			this._fastItemsSource = value;
			this.reset();
			return value;
		} else {

			return this._fastItemsSource;
		}
	}
	, 
	_fastItemsSource: null
	, 
	__propertyName: null

	, 
	propertyName: function (value) {
		if (arguments.length === 1) {

			this.__propertyName = value;
			return value;
		} else {

			return this.__propertyName;
		}
	}

	, 
	minimum: function (value) {
		if (arguments.length === 1) {

			this.__minimum = value;
			return value;
		} else {

			return this.__minimum;
		}
	}
	, 
	__minimum: 0

	, 
	maximum: function (value) {
		if (arguments.length === 1) {

			this.__maximum = value;
			return value;
		} else {

			return this.__maximum;
		}
	}
	, 
	__maximum: 0

	, 
	item: function (index, value) {
		if (arguments.length === 2) {

			throw new $.ig.NotImplementedException(0);
			return value;
		} else {

			return this.values().__inner[index];
		}
	}

	, 
	getEnumerator: function () {
		return this.values().getEnumerator();
	}

	, 
	getEnumerator: function () {
		return this.values().getEnumerator();
	}

	, 
	contains: function (item) {
		return this.values().contains(item);
	}

	, 
	copyTo: function (array, arrayIndex) {
		this.values().copyTo(array, arrayIndex);
	}

	, 
	count: function () {

			return this.values().count();
	}

	, 
	isReadOnly: function () {

			return true;
	}

	, 
	indexOf: function (item) {
		return this.values().indexOf(item);
	}

	, 
	add: function (item) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	clear: function () {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	remove: function (item) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	insert: function (index, item) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	removeAt: function (index) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	reset: function () {
		this.values(null);
		return this.fastItemsSource() != null ? this.insertRange(0, this.fastItemsSource().count()) : true;
	}

	, 
	insertRange: function (position, count) {
		var newValues = new Array(count);
		var source_ = this._fastItemsSource.asArray();
		var item_;
		var minimum = this.minimum();
		var maximum = this.maximum();
		var newCount = 0;
		var coerce = this.__coerceValue;
		if (this.__coerceValue != null || this.__expectFunctions) {
			for (var i_ = position; i_ < position + count; ++i_) {
				item_ = source_[i_][this.__propertyName];
				if (this.__expectFunctions) {
					if (typeof(item_) == 'function') {
						item_ = item_();
					}

				}

				if (coerce != null) {
					item_ = coerce(item_);
				}

				var newValue = item_ == null ? 0 : $.ig.util.getValue(item_);
				newValues[newCount] = newValue;
				newCount++;
			}


		} else {
			for (var i_ = position; i_ < position + count; ++i_) {
				item_ = source_[i_][this.__propertyName];
				var newValue1 = item_ == null ? 0 : $.ig.util.getValue(item_);
				newValues[newCount] = newValue1;
				newCount++;
			}

		}

		if (this.values() == null) {
			this.values(new $.ig.List$1($.ig.Number.prototype.$type, 1, newValues));

		} else {
			this.values().insertRange(position, newValues);
		}

		return true;
	}

	, 
	replaceRange: function (position, count) {
		var ret = false;
		for (var i = 0; i < count; ++i) {
			var oldValue = this.values().__inner[position + i];
			var newValue = this.toInt(this.fastItemsSource().item(position + i));
			if (oldValue != newValue) {
				this.values().__inner[position + i] = newValue;
				ret = true;
			}

		}

		return ret;
	}

	, 
	removeRange: function (position, count) {
		this.values().removeRange(position, count);
		return true;
	}
	, 
	_fastReflectionHelper: null

	, 
	toInt: function (item) {
		var from_ = item;
		item = from_[this.__propertyName];
		if (this.__expectFunctions) {
			from_ = item;
			if (typeof(from_) == 'function') {
				item = from_();
			}

		}

		if (this.__coerceValue != null) {
			item = this.__coerceValue(item);
		}

		if (item == null) {
			return 0;
		}

		return $.ig.util.getValue(item);
	}

	, 
	_values: null,
	values: function (value) {
		if (arguments.length === 1) {
			this._values = value;
			return value;
		} else {
			return this._values;
		}
	}

	, 
	getSortedIndices: function () {
		var $self = this;
		return $.ig.FastItemColumn.prototype.getSortedIndices1($self.values(), function (o1, o2) {
			var d1 = $.ig.util.getValue(o1);
			var d2 = $.ig.util.getValue(o2);
			if (d1 < d2) {
				return -1;
			}

			if (d1 > d2) {
				return 1;
			}

			return 0;
		});
	}

	, 
	asArray: function () {
		return this.values().asArray();
	}
	, 
	$type: new $.ig.Type('FastItemIntColumn', $.ig.Object.prototype.$type, [$.ig.IFastItemColumnInternal.prototype.$type, $.ig.IFastItemColumn$1.prototype.$type.specialize($.ig.Number.prototype.$type)])
}, true);

$.ig.util.defType('IFastItemsSource', 'Object', {
	$type: new $.ig.Type('IFastItemsSource', null)
}, true);

$.ig.util.defType('FastItemsSource', 'Object', {
	init: function () {


		this._columns = new $.ig.Dictionary$2(String, $.ig.ColumnReference.prototype.$type, 0);
		this._contents = new $.ig.List$1($.ig.Object.prototype.$type, 0);
		this._index = null;

		$.ig.Object.prototype.init.call(this);
	}
	, 
	event: null
	, 
	raiseDataSourceEvent: function (action, position, count) {
		if (this.event != null) {
			this.event(this, new $.ig.FastItemsSourceEventArgs(0, action, position, count));
		}

	}

	, 
	raiseDataSourceEvent1: function (position, propertyName) {
		if (this.event != null) {
			this.event(this, new $.ig.FastItemsSourceEventArgs(1, position, propertyName));
		}

	}

	, 
	itemsSource: function (value) {
		if (arguments.length === 1) {

			if (this._itemsSource == value) {
				return;
			}

			this.detach();
			this._itemsSource = value;
			this._contents.clear();
			this._index = null;
			this.attach();
			var en = this._columns.values().getEnumerator();
			while (en.moveNext()) {
				var referencedColumn = en.current();
				referencedColumn._fastItemColumn.reset();
			}

			this.raiseDataSourceEvent($.ig.FastItemsSourceEventAction.prototype.insert, 0, this._contents.count());
			return value;
		} else {

			return this._itemsSource;
		}
	}

	, 
	detach: function () {
	}

	, 
	attach: function () {
		this._contents.insertRange1(this._contents.count(), this._itemsSource);
	}

	, 
	dataSourceAdd: function (position, newItems) {
		if (this._index != null) {
			for (var i = 0; i < newItems.count(); ++i) {
				this._index.add(newItems.item(i), position + i);
			}

			for (var i1 = position; i1 < this._contents.count(); ++i1) {
				this._index.item(this._contents.__inner[i1], i1 + newItems.count());
			}

		}

		this._contents.insertRange1(position, newItems);
		var en = this._columns.values().getEnumerator();
		while (en.moveNext()) {
			var referencedColumn = en.current();
			referencedColumn._fastItemColumn.insertRange(position, newItems.count());
		}

		this.raiseDataSourceEvent($.ig.FastItemsSourceEventAction.prototype.insert, position, newItems.count());
	}

	, 
	dataSourceRemove: function (position, oldItems) {
		this._contents.removeRange(position, oldItems.count());
		if (this._index != null) {
			var en = oldItems.getEnumerator();
			while (en.moveNext()) {
				var item = en.current();
				this._index.remove(item);
			}

			for (var i = position; i < this._contents.count(); ++i) {
				this._index.item(this._contents.__inner[i], i);
			}

		}

		var en1 = this._columns.values().getEnumerator();
		while (en1.moveNext()) {
			var referencedColumn = en1.current();
			referencedColumn._fastItemColumn.removeRange(position, oldItems.count());
		}

		this.raiseDataSourceEvent($.ig.FastItemsSourceEventAction.prototype.remove, position, oldItems.count());
	}

	, 
	dataSourceReplace: function (position, oldItems, newItems) {
		for (var i = 0; i < newItems.count(); ++i) {
			this._contents.__inner[position + i] = newItems.item(i);
		}

		if (this._index != null) {
			var en = oldItems.getEnumerator();
			while (en.moveNext()) {
				var item = en.current();
				this._index.remove(item);
			}

			for (var i1 = 0; i1 < newItems.count(); ++i1) {
				this._index.add(newItems.item(i1), position + i1);
			}

		}

		var en1 = this._columns.values().getEnumerator();
		while (en1.moveNext()) {
			var referencedColumn = en1.current();
			referencedColumn._fastItemColumn.replaceRange(position, newItems.count());
		}

		this.raiseDataSourceEvent($.ig.FastItemsSourceEventAction.prototype.replace, position, oldItems.count());
	}

	, 
	dataSourceReset: function () {
		this._contents.clear();
		this._index = null;
		this._contents.insertRange1(0, this._itemsSource);
		var en = this._columns.values().getEnumerator();
		while (en.moveNext()) {
			var referencedColumn = en.current();
			referencedColumn._fastItemColumn.reset();
		}

		this.raiseDataSourceEvent($.ig.FastItemsSourceEventAction.prototype.reset, 0, this._contents.count());
	}

	, 
	dataSourceChange: function (item, propertyName) {
		var $self = this;
		var columnReference = null;
		var position = $self.indexOf(item);
		if (position == -1) {
			throw new $.ig.ArgumentException(0, "item");
		}

		if ((function () { var $ret = $self._columns.tryGetValue(propertyName, columnReference); columnReference = $ret.p1; return $ret.ret; }())) {
			columnReference._fastItemColumn.replaceRange(position, 1);
		}

		if ((function () { var $ret = $self._columns.tryGetValue(propertyName + "_object", columnReference); columnReference = $ret.p1; return $ret.ret; }())) {
			columnReference._fastItemColumn.replaceRange(position, 1);
		}

		$self.raiseDataSourceEvent1(position, propertyName);
	}

	, 
	count: function () {

			return this._contents.count();
	}

	, 
	item: function (n) {

			return this._contents.__inner[n];
	}

	, 
	getEnumerator: function () {
		return this._contents.getEnumerator();
	}

	, 
	indexOf: function (item) {
		var $self = this;
		var ret;
		if ($self._index == null && $self._contents.count() > 0) {
			$self._index = new $.ig.Dictionary$2($.ig.Object.prototype.$type, $.ig.Number.prototype.$type, 0);
			var contents_ = $self._contents;
			var index_ = $self._index;
			for (var j_ = 0; j_ < $self._contents.count(); j_++) {
				var o = contents_.__inner[j_];
				if (!$self._index.containsKey(o)) {
					$self._index.add(o, j_);
				}

			}

		}

		if ((function () { var $ret = $self._index.tryGetValue(item, ret); ret = $ret.p1; return $ret.ret; }())) {
			return ret;

		} else {
			return -1;
		}

	}

	, 
	registerColumnDateTime: function (propertyName, coerceValue, expectFunctions) {
		var $self = this;
		var fastItemColumn = null;
		if (propertyName != null) {
			var columnReference = null;
			if (!(function () { var $ret = $self._columns.tryGetValue(propertyName, columnReference); columnReference = $ret.p1; return $ret.ret; }())) {
				columnReference = new $.ig.ColumnReference(new $.ig.FastItemDateTimeColumn($self, propertyName, coerceValue, expectFunctions));
				$self._columns.add(propertyName, columnReference);
			}

			columnReference.references(columnReference.references() + 1);
			fastItemColumn = $.ig.util.cast($.ig.IFastItemColumn$1.prototype.$type.specialize($.ig.Date.prototype.$type), columnReference._fastItemColumn);
		}

		return fastItemColumn;
	}

	, 
	registerColumnObject: function (propertyName, coerceValue, expectFunctions) {
		var $self = this;
		var fastItemColumn = null;
		var key = propertyName + "_object";
		if (propertyName != null) {
			var columnReference = null;
			if (!(function () { var $ret = $self._columns.tryGetValue(key, columnReference); columnReference = $ret.p1; return $ret.ret; }())) {
				columnReference = new $.ig.ColumnReference(new $.ig.FastItemObjectColumn($self, propertyName, coerceValue, expectFunctions));
				$self._columns.add(key, columnReference);
			}

			columnReference.references(columnReference.references() + 1);
			fastItemColumn = $.ig.util.cast($.ig.IFastItemColumn$1.prototype.$type.specialize($.ig.Object.prototype.$type), columnReference._fastItemColumn);
		}

		return fastItemColumn;
	}

	, 
	registerColumnInt: function (propertyName, coerceValue, expectFunctions) {
		var $self = this;
		var fastItemColumn = null;
		if (propertyName == null) {
			propertyName = "";
		}

		var columnReference = null;
		if (!(function () { var $ret = $self._columns.tryGetValue(propertyName, columnReference); columnReference = $ret.p1; return $ret.ret; }())) {
			columnReference = new $.ig.ColumnReference(new $.ig.FastItemIntColumn($self, propertyName, coerceValue, expectFunctions));
			$self._columns.add(propertyName, columnReference);
		}

		columnReference.references(columnReference.references() + 1);
		fastItemColumn = $.ig.util.cast($.ig.IFastItemColumn$1.prototype.$type.specialize($.ig.Number.prototype.$type), columnReference._fastItemColumn);
		return fastItemColumn;
	}

	, 
	registerColumn: function (propertyName, coerceValue, expectFunctions) {
		var $self = this;
		var fastItemColumn = null;
		if (propertyName == null) {
			propertyName = "";
		}

		var columnReference = null;
		if (!(function () { var $ret = $self._columns.tryGetValue(propertyName, columnReference); columnReference = $ret.p1; return $ret.ret; }())) {
			columnReference = new $.ig.ColumnReference(new $.ig.FastItemColumn($self, propertyName, coerceValue, expectFunctions));
			$self._columns.add(propertyName, columnReference);
		}

		columnReference.references(columnReference.references() + 1);
		fastItemColumn = $.ig.util.cast($.ig.IFastItemColumn$1.prototype.$type.specialize(Number), columnReference._fastItemColumn);
		return fastItemColumn;
	}

	, 
	deregisterColumn: function (fastItemColumn) {
		var $self = this;
		var propertyName = fastItemColumn != null ? fastItemColumn.propertyName() : null;
		var key = propertyName;
		if ($.ig.util.cast($.ig.IFastItemColumn$1.prototype.$type.specialize($.ig.Object.prototype.$type), fastItemColumn) !== null) {
			key += "_object";
		}

		if (propertyName != null) {
			var columnReference = null;
			if ((function () { var $ret = $self._columns.tryGetValue(propertyName, columnReference); columnReference = $ret.p1; return $ret.ret; }())) {
				columnReference.references(columnReference.references() - 1);
				if (columnReference.references() == 0) {
					$self._columns.remove(key);
				}

			}

		}

	}
	, 
	_columns: null
	, 
	_itemsSource: null
	, 
	_contents: null
	, 
	_index: null

	, 
	asArray: function () {
		return this._contents.asArray();
	}

	, 
	handleCollectionChanged: function (e) {
		switch (e.action()) {
			case $.ig.NotifyCollectionChangedAction.prototype.add:
				this.dataSourceAdd(e.newStartingIndex(), e.newItems());
				break;
			case $.ig.NotifyCollectionChangedAction.prototype.remove:
				this.dataSourceRemove(e.oldStartingIndex(), e.oldItems());
				break;
			case $.ig.NotifyCollectionChangedAction.prototype.replace:
				this.dataSourceReplace(e.newStartingIndex(), e.oldItems(), e.newItems());
				break;
			case $.ig.NotifyCollectionChangedAction.prototype.reset:
				this.dataSourceReset();
				break;
		}

	}
	, 
	$type: new $.ig.Type('FastItemsSource', $.ig.Object.prototype.$type, [$.ig.IEnumerable.prototype.$type, $.ig.IFastItemsSource.prototype.$type])
}, true);

$.ig.util.defType('ColumnReference', 'Object', {
	init: function (fastItemColumn) {



		$.ig.Object.prototype.init.call(this);
			this._fastItemColumn = fastItemColumn;
			this.references(0);
	}
	, 
	_fastItemColumn: null

	, 
	_references: 0,
	references: function (value) {
		if (arguments.length === 1) {
			this._references = value;
			return value;
		} else {
			return this._references;
		}
	}
	, 
	$type: new $.ig.Type('ColumnReference', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('FastItemsSourceReference', 'Object', {
	init: function (source) {



		$.ig.Object.prototype.init.call(this);
			this._fastItemsSource = source;
			this._references = 0;
	}
	, 
	_fastItemsSource: null
	, 
	_references: 0
	, 
	$type: new $.ig.Type('FastItemsSourceReference', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('IFastItemsSourceProvider', 'Object', {
	$type: new $.ig.Type('IFastItemsSourceProvider', null)
}, true);

$.ig.util.defType('FastItemsSourceEventArgs', 'EventArgs', {
	init: function (initNumber, action, position, count) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.EventArgs.prototype.init.call(this);
			this.action(action);
			this.position(position);
			this.count(count);
			this.propertyName(null);
	}
	, 
	init1: function (initNumber, position, propertyName) {


		$.ig.EventArgs.prototype.init.call(this);
			this.action($.ig.FastItemsSourceEventAction.prototype.change);
			this.position(position);
			this.count(1);
			this.propertyName(propertyName);
	}

	, 
	_action: 0,
	action: function (value) {
		if (arguments.length === 1) {
			this._action = value;
			return value;
		} else {
			return this._action;
		}
	}

	, 
	_position: 0,
	position: function (value) {
		if (arguments.length === 1) {
			this._position = value;
			return value;
		} else {
			return this._position;
		}
	}

	, 
	_count: 0,
	count: function (value) {
		if (arguments.length === 1) {
			this._count = value;
			return value;
		} else {
			return this._count;
		}
	}

	, 
	_propertyName: null,
	propertyName: function (value) {
		if (arguments.length === 1) {
			this._propertyName = value;
			return value;
		} else {
			return this._propertyName;
		}
	}
	, 
	$type: new $.ig.Type('FastItemsSourceEventArgs', $.ig.EventArgs.prototype.$type)
}, true);

$.ig.util.defType('FastReflectionHelper', 'Object', {
	init: function (useTraditionalReflection, propertyName) {



		$.ig.Object.prototype.init.call(this);
			this.useTraditionalReflection(useTraditionalReflection);
			this.updatePropertyName(propertyName);
	}
	, 
	__propertyName: null

	, 
	updatePropertyName: function (propertyName) {
		this.__propertyName = propertyName;
	}

	, 
	_useTraditionalReflection: false,
	useTraditionalReflection: function (value) {
		if (arguments.length === 1) {
			this._useTraditionalReflection = value;
			return value;
		} else {
			return this._useTraditionalReflection;
		}
	}

	, 
	getPropertyValue: function (item) {
		var from_ = item;
		return from_[this.__propertyName];
	}

	, 
	invalid: function () {

			return false;
	}
	, 
	$type: new $.ig.Type('FastReflectionHelper', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('IRenderer', 'Object', {
	$type: new $.ig.Type('IRenderer', null)
}, true);

$.ig.util.defType('RectChangedEventArgs', 'EventArgs', {
	init: function (oldRect, newRect) {



		$.ig.EventArgs.prototype.init.call(this);
			this.oldRect(oldRect);
			this.newRect(newRect);
	}

	, 
	_oldRect: null,
	oldRect: function (value) {
		if (arguments.length === 1) {
			this._oldRect = value;
			return value;
		} else {
			return this._oldRect;
		}
	}

	, 
	_newRect: null,
	newRect: function (value) {
		if (arguments.length === 1) {
			this._newRect = value;
			return value;
		} else {
			return this._newRect;
		}
	}
	, 
	$type: new $.ig.Type('RectChangedEventArgs', $.ig.EventArgs.prototype.$type)
}, true);


$.ig.util.defType('RenderingContext', 'Object', {
	__renderer: null

	, 
	getUnderlyingContext: function () {
		return this.__renderer.getUnderlyingContext();
	}
	, 
	init: function (renderer, data) {


		this.__renderer = null;

		$.ig.Object.prototype.init.call(this);
			this.__renderer = renderer;
			if (this.__renderer != null) {
				this.__renderer.data(data);
			}

	}

	, 
	shouldRender: function () {

			return true;
	}

	, 
	renderRectangle: function (rectangle) {
		this.__renderer.renderRectangle(rectangle);
	}

	, 
	renderPath: function (path) {
		this.__renderer.renderPath(path);
	}

	, 
	renderGeometry: function (geometry) {
		this.__renderer.renderGeometry(geometry);
	}

	, 
	renderTextBlock: function (tb) {
		this.__renderer.renderTextBlock(tb);
	}

	, 
	renderTextBlockInRect: function (tb, rect) {
		this.__renderer.renderTextBlockInRect(tb, rect);
	}

	, 
	renderPolygon: function (polygon) {
		this.__renderer.renderPolygon(polygon);
	}

	, 
	renderPolyline: function (polyline) {
		this.__renderer.renderPolyline(polyline);
	}

	, 
	renderContentControl: function (info, marker) {
		this.__renderer.renderContentControl(info, marker);
	}

	, 
	applyTransform: function (transform) {
		this.__renderer.applyTransform(transform);
	}

	, 
	renderLine: function (line) {
		this.__renderer.renderLine(line);
	}

	, 
	save: function () {
		this.__renderer.save();
	}

	, 
	restore: function () {
		this.__renderer.restore();
	}

	, 
	setRectangleClip: function (clipRectangle) {
		this.__renderer.setRectangleClip(clipRectangle);
	}

	, 
	scale: function (x, y) {
		this.__renderer.scale(x, y);
	}

	, 
	translate: function (x, y) {
		this.__renderer.translate(x, y);
	}

	, 
	clearRectangle: function (left, top, width, height) {
		this.__renderer.clearRectangle(left, top, width, height);
	}

	, 
	drawImage1: function (image, opacity, sourceLeft, sourceTop, sourceWidth, sourceHeight, left, top, width, height) {
		this.__renderer.drawImage1(image, opacity, sourceLeft, sourceTop, sourceWidth, sourceHeight, left, top, width, height);
	}

	, 
	drawImage: function (image, opacity, left, top, width, height) {
		this.__renderer.drawImage(image, opacity, left, top, width, height);
	}

	, 
	getPixelAt: function (x, y) {
		return this.__renderer.getPixelAt(x, y);
	}

	, 
	getFont: function () {
		return this.__renderer.getFont();
	}

	, 
	setFont: function (font) {
		this.__renderer.setFont(font);
	}

	, 
	measureTextWidth: function (text) {
		return this.__renderer.measureTextWidth(text);
	}

	, 
	setOpacity: function (p) {
		this.__renderer.setOpacity(p);
	}

	, 
	applyStyle: function (shape, style) {
		this.__renderer.applyStyle(shape, style);
	}

	, 
	enableDropShadow: function (color, blur, offsetX, offsetY) {
		this.__renderer.enableDropShadow(color, blur, offsetX, offsetY);
	}

	, 
	disableDropShadow: function () {
		this.__renderer.disableDropShadow();
	}
	, 
	$type: new $.ig.Type('RenderingContext', $.ig.Object.prototype.$type)
}, true);


$.ig.util.defType('BrushUtil', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	getLightened: function (brush, interpolation) {
		var $self = this;
		if (brush == null) {
			return brush;
		}

		if (brush._isGradient) {
			var newBrush = (brush).clone();
			for (var i = 0; i < newBrush._gradientStops.length; i++) {
				var currentStop = newBrush._gradientStops[i];
				currentStop.color($.ig.ColorUtil.prototype.getLightened(currentStop.color(), interpolation));
			}

			return newBrush;

		} else {
			var l = $.ig.ColorUtil.prototype.getLightened(brush.color(), interpolation);
			return (function () { var $ret = new $.ig.Brush();
			$ret.color(l); return $ret;}());
		}

	}

	, 
	getInterpolation: function (minimum, interpolation, maximum, interpolationMode) {
		var $self = this;
		var target = new $.ig.Brush();
		if (minimum == null && maximum == null) {
			target.__fill = "transparent";
			return target;
		}

		var minSolid = null, maxSolid = null;
		var minLinear = null, maxLinear = null;
		if (minimum == null) {
			var c = maximum._isGradient ? (function () { var $ret = new $.ig.Color();
			$ret.a(0);
			$ret.r(255);
			$ret.g(255);
			$ret.b(255); return $ret;}()) : (function () { var $ret = new $.ig.Color();
			$ret.a(0);
			$ret.r(maximum.color().r());
			$ret.g(maximum.color().g());
			$ret.b(maximum.color().b()); return $ret;}());
			minSolid = (function () { var $ret = new $.ig.Brush();
			$ret.color(c); return $ret;}());

		} else {
			if (minimum._isGradient) {
				minLinear = minimum;

			} else {
				minSolid = minimum;
			}

		}

		if (maximum == null) {
			var c1 = minimum._isGradient ? (function () { var $ret = new $.ig.Color();
			$ret.a(0);
			$ret.r(255);
			$ret.g(255);
			$ret.b(255); return $ret;}()) : (function () { var $ret = new $.ig.Color();
			$ret.a(0);
			$ret.r(minimum.color().r());
			$ret.g(minimum.color().g());
			$ret.b(minimum.color().b()); return $ret;}());
			maxSolid = (function () { var $ret = new $.ig.Brush();
			$ret.color(c1); return $ret;}());

		} else {
			if (maximum._isGradient) {
				maxLinear = maximum;

			} else {
				maxSolid = maximum;
			}

		}

		if (minSolid != null && maxSolid != null) {
			return $.ig.BrushUtil.prototype.solidSolid(minSolid, interpolation, maxSolid, interpolationMode);
		}

		if (minSolid != null && maxLinear != null) {
			return $.ig.BrushUtil.prototype.solidLinear(minSolid, interpolation, maxLinear, interpolationMode);
		}

		if (minLinear != null && maxSolid != null) {
			return $.ig.BrushUtil.prototype.solidLinear(maxSolid, 1 - interpolation, minLinear, interpolationMode);
		}

		if (minLinear != null && maxLinear != null) {
			return $.ig.BrushUtil.prototype.linearLinear(minLinear, interpolation, maxLinear, interpolationMode);
		}

		return target;
	}

	, 
	solidSolid: function (min, p, max, interpolationMode) {
		var b = new $.ig.Brush();
		b.color($.ig.ColorUtil.prototype.getInterpolation(min.color(), p, max.color(), interpolationMode));
		return b;
	}

	, 
	solidLinear: function (min, p, max, interpolationMode) {
		var b = new $.ig.LinearGradientBrush();
		b._gradientStops = $.ig.BrushUtil.prototype.gradientStops1(min.color(), p, max._gradientStops, interpolationMode);
		if (max._useCustomDirection) {
			b._useCustomDirection = true;
			b._startX = max._startX;
			b._startY = max._startY;
			b._endX = max._endX;
			b._endY = max._endY;
		}

		return b;
	}

	, 
	linearLinear: function (min, p, max, interpolationMode) {
		var b = new $.ig.LinearGradientBrush();
		b._gradientStops = $.ig.BrushUtil.prototype.gradientStops(min._gradientStops, p, max._gradientStops, interpolationMode);
		if (min._useCustomDirection || max._useCustomDirection) {
			b._useCustomDirection = true;
			b._startX = min._startX + p * (max._startX - min._startX);
			b._startY = min._startY + p * (max._startY - min._startY);
			b._endX = (1 - p) * min._endX + p * max._endX;
			b._endY = (1 - p) * min._endY + p * max._endY;
		}

		return b;
	}

	, 
	gradientStops1: function (min, p, max, interpolationMode) {
		var $self = this;
		var gradientStopCollection = new Array(max.length);
		for (var i = 0; i < max.length; ++i) {
			gradientStopCollection[i] = (function () { var $ret = new $.ig.GradientStop();
			$ret._offset = max[i]._offset;
			$ret.color($.ig.ColorUtil.prototype.getInterpolation(min, p, max[i].color(), interpolationMode)); return $ret;}());
		}

		return gradientStopCollection;
	}

	, 
	gradientStops: function (min, p, max, interpolationMode) {
		var $self = this;
		var minimumCount = Math.min(min.length, max.length);
		var maxCount = Math.max(min.length, max.length);
		var gradientStopCollection = new Array(maxCount);
		var i = 0;
		for (; i < minimumCount; ++i) {
			gradientStopCollection[i] = (function () { var $ret = new $.ig.GradientStop();
			$ret._offset = (1 - p) * min[i]._offset + p * max[i]._offset;
			$ret.color($.ig.ColorUtil.prototype.getInterpolation(min[i].color(), p, max[i].color(), interpolationMode)); return $ret;}());
		}

		for (; i < min.length; ++i) {
			gradientStopCollection[i] = (function () { var $ret = new $.ig.GradientStop();
			$ret._offset = (1 - p) * min[i]._offset + p * max[max.length - 1]._offset;
			$ret.color($.ig.ColorUtil.prototype.getInterpolation(min[i].color(), p, max[max.length - 1].color(), interpolationMode)); return $ret;}());
		}

		for (; i < max.length; ++i) {
			gradientStopCollection[i] = (function () { var $ret = new $.ig.GradientStop();
			$ret._offset = (1 - p) * min[min.length - 1]._offset + p * max[i]._offset;
			$ret.color($.ig.ColorUtil.prototype.getInterpolation(min[min.length - 1].color(), p, max[i].color(), interpolationMode)); return $ret;}());
		}

		return gradientStopCollection;
	}

	, 
	getCssBrushColors: function (className, obj) {
		var brushes = new Array(2);
		obj.addClass(className);
		var fill = new $.ig.Brush();
		fill.__fill = obj.css("background-color");
		var outline = new $.ig.Brush();
		outline.__fill = obj.css("border-top-color");
		obj.removeClass(className);
		brushes[0] = fill;
		brushes[1] = outline;
		return brushes;
	}

	, 
	getBrushCollection: function (palleteName_, container_, brushes, outlines, defaultColors) {
		var $self = this;
		brushes = new $.ig.BrushCollection();
		outlines = new $.ig.BrushCollection();
		var tempBrush;
		var names = new $.ig.List$1(String, 0);
		names.add("background-color");
		names.add("border-top-color");
		var discovery = $.ig.CssHelper.prototype.getDisoveryElement();
		var isNotInDom = false;
		if (container_ != null) {
			container_.append(discovery);
			isNotInDom = !jQuery.contains(document.documentElement, container_[0]);
			if (isNotInDom) {
			$("body").append(container_);
			}


		} else {
		$("body").append(discovery);
		}

		var palette = $.ig.CssHelper.prototype.getValuesForClassCollection(discovery, "ui-" + palleteName_ + "-palette-", names);
		var numPaletteColors = palette.count();
		if (numPaletteColors == 0) {
			if (defaultColors == null) {
				defaultColors = (function () { var $ret = new Array();
				$ret.add("#B1BFC9");
				$ret.add("#50a8be");
				$ret.add("#798995");
				$ret.add("#fc6754");
				$ret.add("#4F606C");
				$ret.add("#fec33c");
				$ret.add("#374650");
				$ret.add("#3c6399");
				$ret.add("#162C3B");
				$ret.add("#91af49");return $ret;}());
			}

			for (var i = 0; i < defaultColors.length - 1; i += 2) {
				tempBrush = new $.ig.Brush();
				tempBrush.__fill = defaultColors[i];
				outlines.add(tempBrush);
				tempBrush = new $.ig.Brush();
				tempBrush.__fill = defaultColors[i + 1];
				brushes.add(tempBrush);
			}

		}

		for (var i1 = 0; i1 < numPaletteColors; i1++) {
			var fillBrush = new $.ig.Brush();
			fillBrush.__fill = palette.__inner[i1].__inner[0];
			var outlineBrush = new $.ig.Brush();
			outlineBrush.__fill = palette.__inner[i1].__inner[1];
			brushes.add(fillBrush);
			outlines.add(outlineBrush);
		}

		discovery.remove();
		if (isNotInDom) {
		container_.remove();
		}

		return {
			p2: brushes, 
			p3: outlines
		};
	}

	, 
	getGradientBrushCollection: function (fillGradientPaletteName, outlineGradientPaletteName, paletteName, container_, brushes, outlines, defaultColors) {
		var $self = this;
		brushes = new $.ig.BrushCollection();
		outlines = new $.ig.BrushCollection();
		if (defaultColors == null) {
			defaultColors = (function () { var $ret = new Array();
			$ret.add("#B1BFC9");
			$ret.add("#50a8be");
			$ret.add("#798995");
			$ret.add("#fc6754");
			$ret.add("#4F606C");
			$ret.add("#fec33c");
			$ret.add("#374650");
			$ret.add("#3c6399");
			$ret.add("#162C3B");
			$ret.add("#91af49");return $ret;}());
		}

		var discovery = $.ig.CssHelper.prototype.getDisoveryElement();
		var isNotInDom = false;
		if (container_ != null) {
			container_.append(discovery);
			isNotInDom = !jQuery.contains(document.documentElement, container_[0]);
			if (isNotInDom) {
			$("body").append(container_);
			}


		} else {
		$("body").append(discovery);
		}

		var names = new $.ig.List$1(String, 0);
		names.add("background-image");
		var fillsPalette = $.ig.CssHelper.prototype.getValuesForClassCollection(discovery, fillGradientPaletteName, names);
		var numFillsPaletteColors = fillsPalette.count();
		var outlinesPalette = $.ig.CssHelper.prototype.getValuesForClassCollection(discovery, outlineGradientPaletteName, names);
		var numOutlinesPaletteColors = outlinesPalette.count();
		for (var i = 0; i < numFillsPaletteColors; i++) {
			brushes.add($.ig.CssGradientUtil.prototype.brushFromGradientString(fillsPalette.__inner[i].__inner[0]));
		}

		for (var i1 = 0; i1 < numOutlinesPaletteColors; i1++) {
			outlines.add($.ig.CssGradientUtil.prototype.brushFromGradientString(outlinesPalette.__inner[i1].__inner[0]));
		}

		names.clear();
		var fillIndex = 0;
		var outlineIndex = 0;
		var numPaletteColors = Math.min(numFillsPaletteColors, numOutlinesPaletteColors);
		var palette = null;
		if (numFillsPaletteColors == 0) {
			names.add("background-color");
		}

		if (numOutlinesPaletteColors == 0) {
			names.add("border-top-color");
			outlineIndex = numFillsPaletteColors == 0 ? 1 : 0;
		}

		if (names.count() > 0) {
			palette = $.ig.CssHelper.prototype.getValuesForClassCollection(discovery, paletteName, names);
			numPaletteColors = palette.count();
		}

		if (numFillsPaletteColors == 0) {
			if (numPaletteColors > 0) {
				for (var i2 = 0; i2 < numPaletteColors; i2++) {
					var fillBrush = new $.ig.Brush();
					fillBrush.__fill = palette.__inner[i2].__inner[fillIndex];
					brushes.add(fillBrush);
				}


			} else {
				for (var i3 = 0; i3 < defaultColors.length - 1; i3 += 2) {
					var fillBrush1 = new $.ig.Brush();
					fillBrush1 = new $.ig.Brush();
					fillBrush1.__fill = defaultColors[i3 + 1];
					brushes.add(fillBrush1);
				}

			}

		}

		if (numOutlinesPaletteColors == 0) {
			if (numPaletteColors > 0) {
				for (var i4 = 0; i4 < numPaletteColors; i4++) {
					var outlineBrush = new $.ig.Brush();
					outlineBrush.__fill = palette.__inner[i4].__inner[outlineIndex];
					outlines.add(outlineBrush);
				}


			} else {
				for (var i5 = 0; i5 < defaultColors.length - 1; i5 += 2) {
					var outlineBrush1 = new $.ig.Brush();
					outlineBrush1.__fill = defaultColors[i5];
					outlines.add(outlineBrush1);
				}

			}

		}

		discovery.remove();
		if (isNotInDom) {
		container_.remove();
		}

		return {
			p4: brushes, 
			p5: outlines
		};
	}

	, 
	getGradientBrush: function (gradientClassName, className, cssProp, container_, fallbackColor) {
		var b = null;
		var discovery = $.ig.CssHelper.prototype.getDisoveryElement();
		var isNotInDom = false;
		if (container_ != null) {
			container_.append(discovery);
			isNotInDom = !jQuery.contains(document.documentElement, container_[0]);
			if (isNotInDom) {
			$("body").append(container_);
			}


		} else {
			$("body").append(discovery);
		}

		var gradientString = $.ig.CssHelper.prototype.getPropertyValue(discovery, gradientClassName, "background-image");
		if (gradientString != null) {
			b = $.ig.CssGradientUtil.prototype.brushFromGradientString(gradientString);
		}

		if (b == null) {
			b = new $.ig.Brush();
			var fillColor = $.ig.CssHelper.prototype.getPropertyValue(discovery, className, cssProp);
			b.__fill = fillColor != null ? fillColor : fallbackColor;
		}

		discovery.remove();
		if (isNotInDom) {
		container_.remove();
		}

		return b;
	}
	, 
	$type: new $.ig.Type('BrushUtil', $.ig.Object.prototype.$type)
}, true);







$.ig.util.defType('ColorUtil', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	randomColor: function (alpha) {
		return $.ig.Color.prototype.fromArgb(alpha, $.ig.ColorUtil.prototype._r.next2(0, 255), $.ig.ColorUtil.prototype._r.next2(0, 255), $.ig.ColorUtil.prototype._r.next2(0, 255));
	}

	, 
	randomHue: function (color) {
		var ahsv = $.ig.ColorUtil.prototype.getAHSV(color);
		return $.ig.ColorUtil.prototype.fromAHSV(ahsv[0], $.ig.ColorUtil.prototype._r.next2(0, 359), ahsv[2], ahsv[3]);
	}

	, 
	getInterpolation: function (minimum, interpolation_, maximum_, interpolationMode) {
		var min_ = minimum;
		switch (interpolationMode) {
			case $.ig.InterpolationMode.prototype.hSV:
					var b = $.ig.ColorUtil.prototype.getAHSV(minimum);
					var e = $.ig.ColorUtil.prototype.getAHSV(maximum_);
					var b1 = b[1] >= 0 ? b[1] : e[1];
					var e1 = e[1] >= 0 ? e[1] : b[1];
					if (b1 >= 0 && e1 >= 0 && Math.abs(e1 - b1) > 180) {
						if (e1 > b1) {
							b1 += 360;

						} else {
							e1 += 360;
						}

					}

					interpolation_ = Math.max(0, Math.min(1, interpolation_));
					return $.ig.ColorUtil.prototype.fromAHSV(b[0] + interpolation_ * (e[0] - b[0]), b1 + interpolation_ * (e1 - b1), b[2] + interpolation_ * (e[2] - b[2]), b[3] + interpolation_ * (e[3] - b[3]));

			case $.ig.InterpolationMode.prototype.rGB:
				return $.ig.Color.prototype.fromArgb(min_.__a + interpolation_ * (maximum_.__a - min_.__a), min_.__r + interpolation_ * (maximum_.__r - min_.__r), min_.__g + interpolation_ * (maximum_.__g - min_.__g), min_.__b + interpolation_ * (maximum_.__b - min_.__b));
		}

		return minimum;
	}

	, 
	getAHSVInterpolation: function (minimum, interpolation, maximum) {
		var b1 = minimum[1] >= 0 ? minimum[1] : maximum[1];
		var e1 = maximum[1] >= 0 ? maximum[1] : minimum[1];
		if (b1 >= 0 && e1 >= 0 && Math.abs(e1 - b1) > 180) {
			if (e1 > b1) {
				b1 += 360;

			} else {
				e1 += 360;
			}

		}

		interpolation = Math.max(0, Math.min(1, interpolation));
		return $.ig.ColorUtil.prototype.fromAHSV(minimum[0] + interpolation * (maximum[0] - minimum[0]), b1 + interpolation * (e1 - b1), minimum[2] + interpolation * (maximum[2] - minimum[2]), minimum[3] + interpolation * (maximum[3] - minimum[3]));
	}

	, 
	getLightened: function (color, interpolation) {
		var ahsl = $.ig.ColorUtil.prototype.getAHSL(color);
		if (interpolation < 0) {
			return $.ig.ColorUtil.prototype.fromAHSL(ahsl[0], ahsl[1], ahsl[2], ahsl[3] * (1 - $.ig.MathUtil.prototype.clamp(-interpolation, 0, 1)));

		} else {
			return $.ig.ColorUtil.prototype.fromAHSL(ahsl[0], ahsl[1], ahsl[2], ahsl[3] + $.ig.MathUtil.prototype.clamp(interpolation, 0, 1) * (1 - ahsl[3]));
		}

	}

	, 
	getAHSL: function (color) {
		var ahsl = new Array(4);
		var r = color.r() / 255;
		var g = color.g() / 255;
		var b = color.b() / 255;
		var min = Math.min(Math.min(r, g), b);
		var max = Math.max(Math.max(r, g), b);
		var delta = max - min;
		ahsl[0] = color.a() / 255;
		ahsl[3] = (max + min) / 2;
		if (delta == 0) {
			ahsl[1] = -1;
			ahsl[2] = 0;

		} else {
			ahsl[1] = $.ig.ColorUtil.prototype.h(max, delta, r, g, b);
			ahsl[2] = ahsl[3] < 0.5 ? delta / (max + min) : delta / (2 - max - min);
		}

		return ahsl;
	}

	, 
	getAHSV: function (color) {
		var a = color.a() / 255;
		var r = color.r() / 255;
		var g = color.g() / 255;
		var b = color.b() / 255;
		var min = Math.min(r, Math.min(g, b));
		var max = Math.max(r, Math.max(g, b));
		var delta = max - min;
		var ahsv = new Array(4);
		ahsv[0] = a;
		ahsv[3] = max;
		if (delta == 0) {
			ahsv[1] = -1;
			ahsv[2] = 0;

		} else {
			ahsv[1] = $.ig.ColorUtil.prototype.h(max, delta, r, g, b);
			ahsv[2] = delta / max;
		}

		return ahsv;
	}

	, 
	fromAHSL: function (alpha, hue, saturation, lightness) {
		var r;
		var g;
		var b;
		if (saturation == 0) {
			r = lightness;
			g = lightness;
			b = lightness;

		} else {
			var q = lightness < 0.5 ? lightness * (1 + saturation) : lightness + saturation - (lightness * saturation);
			var p = 2 * lightness - q;
			var hk = hue / 360;
			r = $.ig.ColorUtil.prototype.c(p, q, hk + 1 / 3);
			g = $.ig.ColorUtil.prototype.c(p, q, hk);
			b = $.ig.ColorUtil.prototype.c(p, q, hk - 1 / 3);
		}

		return $.ig.Color.prototype.fromArgb($.ig.truncate((alpha * 255)), $.ig.truncate((r * 255)), $.ig.truncate((g * 255)), $.ig.truncate((b * 255)));
	}

	, 
	fromAHSV: function (alpha, hue, saturation, value) {
		var r;
		var g;
		var b;
		while (hue >= 360) {
			hue -= 360;

		}
		if (saturation == 0) {
			r = value;
			g = value;
			b = value;

		} else {
			hue /= 60;
			var i = Math.floor(hue);
			var f = hue - i;
			var p = value * (1 - saturation);
			var q = value * (1 - saturation * f);
			var t = value * (1 - saturation * (1 - f));
			switch ($.ig.truncate(i)) {
				case 0:
					r = value;
					g = t;
					b = p;
					break;
				case 1:
					r = q;
					g = value;
					b = p;
					break;
				case 2:
					r = p;
					g = value;
					b = t;
					break;
				case 3:
					r = p;
					g = q;
					b = value;
					break;
				case 4:
					r = t;
					g = p;
					b = value;
					break;
				default:
					r = value;
					g = p;
					b = q;
					break;
			}

		}

		return $.ig.Color.prototype.fromArgb($.ig.truncate((alpha * 255)), $.ig.truncate((r * 255)), $.ig.truncate((g * 255)), $.ig.truncate((b * 255)));
	}

	, 
	h: function (max, delta, r, g, b) {
		var h = r == max ? (g - b) / delta : g == max ? 2 + (b - r) / delta : 4 + (r - g) / delta;
		h *= 60;
		if (h < 0) {
			h += 360;
		}

		return h;
	}

	, 
	c: function (p, q, t) {
		t = t < 0 ? t + 1 : t > 1 ? t - 1 : t;
		if (t < 1 / 6) {
			return p + ((q - p) * 6 * t);
		}

		if (t < 1 / 2) {
			return q;
		}

		if (t < 2 / 3) {
			return p + ((q - p) * 6 * (2 / 3 - t));
		}

		return p;
	}

	, 
	randomColors: function () {

			if ($.ig.ColorUtil.prototype.__randomColors == null) {
				$.ig.ColorUtil.prototype.__randomColors = new Array(100);
				$.ig.ColorUtil.prototype.__randomColors[0] = $.ig.Color.prototype.fromArgb(255, 70, 130, 180);
				$.ig.ColorUtil.prototype.__randomColors[1] = $.ig.Color.prototype.fromArgb(255, 65, 105, 225);
				$.ig.ColorUtil.prototype.__randomColors[2] = $.ig.Color.prototype.fromArgb(255, 100, 149, 237);
				$.ig.ColorUtil.prototype.__randomColors[3] = $.ig.Color.prototype.fromArgb(255, 176, 196, 222);
				$.ig.ColorUtil.prototype.__randomColors[4] = $.ig.Color.prototype.fromArgb(255, 123, 104, 238);
				$.ig.ColorUtil.prototype.__randomColors[5] = $.ig.Color.prototype.fromArgb(255, 106, 90, 205);
				$.ig.ColorUtil.prototype.__randomColors[6] = $.ig.Color.prototype.fromArgb(255, 72, 61, 139);
				$.ig.ColorUtil.prototype.__randomColors[7] = $.ig.Color.prototype.fromArgb(255, 25, 25, 112);
				for (var colorIndex = 8; colorIndex < 100; colorIndex++) {
					$.ig.ColorUtil.prototype.__randomColors[colorIndex] = $.ig.Color.prototype.fromArgb(255, $.ig.ColorUtil.prototype._r.next1(255), $.ig.ColorUtil.prototype._r.next1(255), $.ig.ColorUtil.prototype._r.next1(255));
				}

			}

			return $.ig.ColorUtil.prototype.__randomColors;
	}

	, 
	getRandomColor: function (index) {
		index %= 100;
		return $.ig.ColorUtil.prototype.randomColors()[index];
	}

	, 
	colorToInt: function (color) {
		var aa = color.a() / 255;
		var rr = $.ig.truncate((color.r() * aa));
		var gg = $.ig.truncate((color.g() * aa));
		var bb = $.ig.truncate((color.b() * aa));
		return color.a() << 24 | rr << 16 | gg << 8 | bb;
	}

	, 
	getColor: function (brush) {
		return brush.color();
	}
	, 
	$type: new $.ig.Type('ColorUtil', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('CssGradientUtil', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	brushFromGradientString: function (value) {
		var regex = /hsl\([\s\S]+?\)[\s\S]*?[,\)]|rgba?\([\s\S]+?\)[\s\S]*?[,\)]|[^\(\)]*?[,\)]/gim, percentRegex = /\s*\d*%\s*$/, trimStartRegex = /^\s\s*/, trimEndRegex = /\s\s*$/, trimEndCharactersRegex = /[,\)]?$/;
		var match;
		var angle, i = 1, j = 0, length, offsetIndex;
		var hasUnsetOffsets = false;
		var stops;
		var matches = value.match(regex);
		if (matches == null || matches.length <= 1) {
		return null;
		}

		var b = new $.ig.LinearGradientBrush();
		length = matches.length;
		match = matches[0];
		if (match.contains("to") || match.contains("deg")) {
			angle = $.ig.CssGradientUtil.prototype.angleFromString(match);
			b._useCustomDirection = true;
			var points = $.ig.CssGradientUtil.prototype.calculatePointsFromAngle(angle);
			b._startX = points[0].__x;
			b._startY = points[0].__y;
			b._endX = points[1].__x;
			b._endY = points[1].__y;
			stops = new Array(length - 1);

		} else {
			stops = new Array(length);
			i = 0;
		}

		for (; i < length; i++) {
			var stop = new $.ig.GradientStop();
			match = matches[i];
			match = match.replace(trimStartRegex, "").replace(trimEndRegex, "").replace(trimEndCharactersRegex, "");
			offsetIndex = match.search(percentRegex);
			if (offsetIndex != -1) {
				stop.__fill = match.substr(0, offsetIndex);
				stop._offset = parseFloat(match.substr(offsetIndex + 1)) / 100;

			} else {
				stop.__fill = match;
				stop._offset = -1;
				hasUnsetOffsets = true;
			}

			stops[j] = stop;
			j++;
		}

		if (hasUnsetOffsets) {
			if (stops[0]._offset == -1) {
				stops[0]._offset = 0;
			}

			if (stops[stops.length - 1]._offset == -1) {
				stops[stops.length - 1]._offset = 1;
			}

			$.ig.CssGradientUtil.prototype.fixUnsetOffsets(stops);
			b._gradientStops = stops;
		}

		return b;
	}

	, 
	fixUnsetOffsets: function (stops) {
		var i, j, k, offsetRange, maxOffset = -1, lastSetOffsetIndex = -1, lastSetOffset = 0;
		var hasUnsetOffsets = false;
		for (i = lastSetOffsetIndex + 1; i < stops.length; i++) {
			var stop = stops[i];
			if (stop._offset != -1) {
				maxOffset = Math.max(maxOffset, stop._offset);
				stop._offset = maxOffset;
				if (hasUnsetOffsets) {
					k = 1;
					offsetRange = $.ig.intDivide((maxOffset - lastSetOffset), (i - lastSetOffsetIndex));
					for (j = lastSetOffsetIndex + 1; j < i; j++) {
						stops[j]._offset = lastSetOffset + offsetRange * k;
						k++;
					}

					hasUnsetOffsets = false;
				}

				lastSetOffsetIndex = i;
				lastSetOffset = maxOffset;

			} else {
				hasUnsetOffsets = true;
			}

		}

	}

	, 
	angleFromString: function (value) {
		var toTopRegex = /to\s*top\s*/i, toRightTopRegex = /to\s*right\s*top\s*/i, toRightRegex = /to\s*right\s*/i, toRightBottomRegex = /to\s*right\s*bottom\s*/i, toBottomRegex = /to\s*bottom\s*/i, toLeftBottomRegex = /to\s*left\s*bottom\s*/i, toLeftRegex = /to\s*left\s*/i, toLeftTopRegex = /to\s*left\s*top\s*/i;
		if (value.contains("deg")) {
			return parseFloat(value);
		}

		if (toTopRegex.test(value)) {
			return 0;
		}

		if (toRightTopRegex.test(value)) {
			return 45;
		}

		if (toRightRegex.test(value)) {
			return 90;
		}

		if (toRightBottomRegex.test(value)) {
			return 135;
		}

		if (toBottomRegex.test(value)) {
			return 180;
		}

		if (toLeftBottomRegex.test(value)) {
			return 225;
		}

		if (toLeftRegex.test(value)) {
			return 270;
		}

		return toLeftTopRegex.test(value) ? 315 : 180;
	}

	, 
	calculatePointsFromAngle: function (inputAngle) {
		var points = new Array(2);
		var p1 = new $.ig.Point(0);
		var p2 = new $.ig.Point(0);
		var angle = $.ig.GeometryUtil.prototype.simplifyAngle(inputAngle);
		if (angle >= 0 && angle <= 45) {
			var tan = Math.tan($.ig.MathUtil.prototype.radians(angle));
			p1.__x = 0.5 - 0.5 * tan;
			p1.__y = 1;
			p2.__x = 0.5 + 0.5 * tan;
			p2.__y = 0;

		} else if (angle > 180 && angle <= 225) {
			var tan1 = Math.tan($.ig.MathUtil.prototype.radians(angle - 180));
			p1.__x = 0.5 + 0.5 * tan1;
			p1.__y = 0;
			p2.__x = 0.5 - 0.5 * tan1;
			p2.__y = 1;

		} else if (angle > 135 && angle <= 180) {
			var tan2 = Math.tan($.ig.MathUtil.prototype.radians(180 - angle));
			p1.__x = 0.5 - 0.5 * tan2;
			p1.__y = 0;
			p2.__x = 0.5 + 0.5 * tan2;
			p2.__y = 1;

		} else if (angle > 315 && angle < 360) {
			var tan3 = Math.tan($.ig.MathUtil.prototype.radians(360 - angle));
			p1.__x = 0.5 + 0.5 * tan3;
			p1.__y = 1;
			p2.__x = 0.5 - 0.5 * tan3;
			p2.__y = 0;

		} else if (angle > 45 && angle <= 90) {
			var tan4 = Math.tan($.ig.MathUtil.prototype.radians(90 - angle));
			p2.__y = 0.5 - 0.5 * tan4;
			p2.__x = 1;
			p1.__y = 0.5 + 0.5 * tan4;
			p1.__x = 0;

		} else if (angle > 90 && angle <= 135) {
			var tan5 = Math.tan($.ig.MathUtil.prototype.radians(angle - 90));
			p2.__y = 0.5 + 0.5 * tan5;
			p2.__x = 1;
			p1.__y = 0.5 - 0.5 * tan5;
			p1.__x = 0;

		} else if (angle > 225 && angle <= 270) {
			var tan6 = Math.tan($.ig.MathUtil.prototype.radians(270 - angle));
			p1.__y = 0.5 - 0.5 * tan6;
			p1.__x = 1;
			p2.__y = 0.5 + 0.5 * tan6;
			p2.__x = 0;

		} else if (angle > 270 && angle <= 315) {
			var tan7 = Math.tan($.ig.MathUtil.prototype.radians(angle - 270));
			p1.__y = 0.5 + 0.5 * tan7;
			p1.__x = 1;
			p2.__y = 0.5 - 0.5 * tan7;
			p2.__x = 0;
		}








		points[0] = p1;
		points[1] = p2;
		return points;
	}
	, 
	$type: new $.ig.Type('CssGradientUtil', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('CssHelper', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	getDisoveryElement: function () {
		var discoveryStyle = $("#fakediscoveryelementstyle");
		if (discoveryStyle.length == 0) {
			var styleText = "fakediscoveryelement\n" + "{\n" + "\tdisplay: block;\n" + "   position: absolute;\n" + "   box-sizing: content-box;\n" + "   -moz-box-sizing: content-box;\n" + "\tmargin: " + $.ig.CssHelper.prototype.defaultMarginValue + ";\n" + "\tcolor: " + $.ig.CssHelper.prototype.defaultColorValue + ";\n" + "   border-style: solid;\n" + "   border-color: " + $.ig.CssHelper.prototype.defaultColorValue + ";\n" + "   background-color: " + $.ig.CssHelper.prototype.defaultColorValue + ";\n" + "   background-image: " + $.ig.CssHelper.prototype.defaultBackgroundImageValue + ";\n" + "   border-width: " + $.ig.CssHelper.prototype.defaultWidthHeightValue + ";\n" + "   border-radius: " + $.ig.CssHelper.prototype.defaultWidthHeightValue + ";\n" + "   vertical-align: " + $.ig.CssHelper.prototype.defaultVerticalAlignValue + ";\n" + "   text-align: " + $.ig.CssHelper.prototype.defaultTextAlignValue + ";\n" + "   opacity: " + $.ig.CssHelper.prototype.defaultOpacityValue + ";\n" + "   visibility: " + $.ig.CssHelper.prototype.defaultVisibilityValue + ";\n" + "   width: " + $.ig.CssHelper.prototype.defaultWidthHeightValue + ";\n" + "   height: " + $.ig.CssHelper.prototype.defaultWidthHeightValue + ";\n" + "}\n";
			discoveryStyle = $("<style id=\'fakediscoveryelementstyle\'></style>");
			discoveryStyle.html(styleText);
			$("head").append(discoveryStyle);
		}

		return $("<fakediscoveryelement></fakediscoveryelement>");
	}

	, 
	getDefaultValue: function (propertyName) {
		if (propertyName == "color" || propertyName == "border-color" || propertyName == "border-top-color" || propertyName == "border-left-color" || propertyName == "border-right-color" || propertyName == "border-bottom-color" || propertyName == "background-color") {
			return $.ig.CssHelper.prototype.defaultColorValue;

		} else if (propertyName == "margin-left" || propertyName == "margin-top" || propertyName == "margin-right" || propertyName == "margin-bottom") {
			return $.ig.CssHelper.prototype.defaultMarginValue;

		} else if (propertyName == "vertical-align") {
			return $.ig.CssHelper.prototype.defaultVerticalAlignValue;

		} else if (propertyName == "opacity") {
			return $.ig.CssHelper.prototype.defaultOpacityValue;

		} else if (propertyName == "background-image") {
			return $.ig.CssHelper.prototype.defaultBackgroundImageValue;

		} else if (propertyName == "text-align") {
			return $.ig.CssHelper.prototype.defaultTextAlignValue;

		} else if (propertyName == "visibility") {
			return $.ig.CssHelper.prototype.defaultVisibilityValue;

		} else if ($.ig.CssHelper.prototype.isWidthProperty(propertyName)) {
			return $.ig.CssHelper.prototype.defaultWidthHeightValue;
		}








		return "DEFAULT";
	}

	, 
	numberOfClasses: function (discoveryElement, classPrefix, propertyName) {
		var defaultValue = $.ig.CssHelper.prototype.getDefaultValue(propertyName);
		var curr = 1;
		var done = false;
		while (!done && curr < $.ig.CssHelper.prototype.maxClasses) {
			var className = classPrefix + curr.toString();
			discoveryElement.addClass(className);
			var propValue = discoveryElement.css(propertyName);
			if (propValue == defaultValue) {
				break;
			}

			curr++;

		}
		return curr;
	}

	, 
	getPropertyValue: function (discoveryElement, className, propertyName) {
		discoveryElement.addClass(className);
		var ret_ = discoveryElement.css(propertyName);
		discoveryElement.removeClass(className);
		if (propertyName == "opacity") {
		ret_ = Math.round(1000.0 * ret_) / 1000.0;
		}

		if ($.ig.CssHelper.prototype.isEqualToDefault(ret_, $.ig.CssHelper.prototype.getDefaultValue(propertyName), propertyName)) {
			return null;
		}

		return ret_;
	}

	, 
	isEqualToDefault: function (propValue, defaultValue, propertyName) {
		if (propValue == defaultValue) {
			return true;
		}

		if ($.ig.CssHelper.prototype.isWidthProperty(propertyName) && propValue != null && propValue.contains("px")) {
			var num = $.ig.util.replace(propValue, "px", "");
			var val = parseFloat(num);
			if (Math.abs(Math.round(val) - 4321) < 2) {
				return true;
			}

			return false;

		} else if ($.ig.CssHelper.prototype.isMarginProperty(propertyName) && propValue != null && propValue.contains("px")) {
			var num1 = $.ig.util.replace(propValue, "px", "");
			var val1 = parseFloat(num1);
			if (Math.abs(Math.round(val1) + 4321) < 2) {
				return true;
			}

			return false;

		} else {
			return propValue == defaultValue;
		}


	}

	, 
	isWidthProperty: function (propertyName) {
		return propertyName == "width" || propertyName == "height" || propertyName == "border-top-width" || propertyName == "border-left-width" || propertyName == "border-right-width" || propertyName == "border-bottom-width" || propertyName == "border-top-left-radius";
	}

	, 
	isMarginProperty: function (propertyName) {
		return propertyName == "margin-top" || propertyName == "margin-left" || propertyName == "margin-right" || propertyName == "margin-bottom";
	}

	, 
	getValuesForClassCollection: function (discoveryElement, classPrefix, propertyNames) {
		var ret = new $.ig.List$1($.ig.List$1.prototype.$type.specialize(String), 0);
		var curr = 1;
		var done = false;
		while (!done && curr < $.ig.CssHelper.prototype.maxClasses) {
			var className = classPrefix + curr.toString();
			discoveryElement.addClass(className);
			var row = new $.ig.List$1(String, 0);
			for (var i = 0; i < propertyNames.count(); i++) {
				var propertyName = propertyNames.__inner[i];
				var defaultValue = $.ig.CssHelper.prototype.getDefaultValue(propertyName);
				var propValue = discoveryElement.css(propertyName);
				if ($.ig.CssHelper.prototype.isEqualToDefault(propValue, defaultValue, propertyName)) {
					done = true;
					break;
				}

				row.add(propValue);
			}

			discoveryElement.removeClass(className);
			if (!done) {
				ret.add(row);
			}

			curr++;

		}
		return ret;
	}
	, 
	$type: new $.ig.Type('CssHelper', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('EasingFunctions', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	cubicEase: function (t) {
		t /= 1 / 2;
		if (t < 1) {
		return 1 / 2 * t * t * t + 0;
		}

		t -= 2;
		return 1 / 2 * (t * t * t + 2) + 0;
	}
	, 
	$type: new $.ig.Type('EasingFunctions', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('FontUtil', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	getCurrentFontHeight: function (container, font) {
		var tempSpan_ = $("<span>M</span>");
		var doc = $('body');
		doc.append(tempSpan_);
		tempSpan_.css("font", font);
		var offset_ = tempSpan_.attr("offsetHeight");
		if (isNaN(offset_)) { offset_ = tempSpan_[0].offsetHeight; };
		tempSpan_.remove();
		return parseInt(offset_);
	}

	, 
	getFontSize: function (font) {
		var tempSpan_ = $("<span>M</span>");
		var doc = $('body');
		doc.append(tempSpan_);
		tempSpan_.css("font", font);
		var fontSize = tempSpan_.css("font-size");
		tempSpan_.remove();
		return parseFloat(fontSize);
	}

	, 
	getFontWithNewFontSize: function (font, fontSize) {
		var returnFont = String.empty();
		var tempSpan_ = $("<span>M</span>");
		var doc = $('body');
		doc.append(tempSpan_);
		tempSpan_.css("font", font);
		tempSpan_.css("font-size", fontSize.toString() + "px");
		returnFont = $.ig.FontUtil.prototype.getFont(tempSpan_);
		tempSpan_.remove();
		return returnFont;
	}

	, 
	getLabelWidth: function (label, font) {
		var tempSpan_ = $("<span>" + label + "</span>");
		var doc = $('body');
		doc.append(tempSpan_);
		tempSpan_.css("font", font);
		var width = tempSpan_.css("width");
		tempSpan_.remove();
		return parseFloat(width);
	}

	, 
	getDefaultFont: function () {
		var newFont = String.empty();
		var tempSpan_ = $("<span>M</span>");
		var doc = $('body');
		doc.append(tempSpan_);
		newFont = $.ig.FontUtil.prototype.getFont(tempSpan_);
		tempSpan_.remove();
		return newFont;
	}

	, 
	getFont: function (container) {
		var font = String.empty();
		var fontStyle = container.css("font-style");
		var fontVariant = container.css("font-variant");
		var fontWeight = container.css("font-weight");
		var fontSize = container.css("font-size");
		var lineHeight = container.css("line-height");
		var fontFamily = container.css("font-family");
		var first = true;
		if (fontStyle.length > 0) {
			if (!first) {
				font += " ";

			} else {
				first = false;
			}

			font += fontStyle;
		}

		if (fontVariant.length > 0) {
			if (!first) {
				font += " ";

			} else {
				first = false;
			}

			font += fontVariant;
		}

		if (fontWeight.length > 0) {
			if (!first) {
				font += " ";

			} else {
				first = false;
			}

			font += fontWeight;
		}

		if (fontSize.length > 0) {
			if (!first) {
				font += " ";

			} else {
				first = false;
			}

			font += fontSize;
		}

		if (lineHeight.length > 0) {
			if (!first) {
				font += "/";

			} else {
				first = false;
			}

			font += lineHeight;
		}

		if (fontFamily.length > 0) {
			if (!first) {
				font += " ";

			} else {
				first = false;
			}

			font += fontFamily;
		}

		return font;
	}

	, 
	getFontInfo: function (tb, fontDescriptor) {
		var fi = new $.ig.FontInfo();
		var font = fontDescriptor;
		var tempDiv = $("<div></div>");
		tempDiv.css("font", font);
		var fontStyle = tempDiv.css("font-style");
		var fontVariant = tempDiv.css("font-variant");
		var fontWeight = tempDiv.css("font-weight");
		var fontSize = tempDiv.css("font-size");
		var lineHeight = tempDiv.css("line-height");
		var fontFamily = tempDiv.css("font-family");
		tempDiv = null;
		fi.fontFamily($.ig.util.replace(fontFamily, "\'", ""));
		fi.fontStyle($.ig.FontUtil.prototype.toUpperFirst(fontStyle));
		fi.fontWeight($.ig.FontUtil.prototype.toUpperFirst(fontWeight.toString()));
		fi.fontVariant(fontVariant);
		fi.lineHeight(parseFloat(lineHeight));
		fi.fontSize(parseFloat(fontSize));
		return fi;
	}

	, 
	toUpperFirst: function (label) {
		if (String.isNullOrEmpty(label)) {
			return String.empty();
		}

		var result = label.substr(0, 1).toUpperCase();
		if (label.length > 1) {
		result += label.substr(1);
		}

		return result;
	}
	, 
	$type: new $.ig.Type('FontUtil', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('FontInfo', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.fontSize(NaN);
			this.lineHeight(NaN);
	}

	, 
	_fontStyle: null,
	fontStyle: function (value) {
		if (arguments.length === 1) {
			this._fontStyle = value;
			return value;
		} else {
			return this._fontStyle;
		}
	}

	, 
	_fontVariant: null,
	fontVariant: function (value) {
		if (arguments.length === 1) {
			this._fontVariant = value;
			return value;
		} else {
			return this._fontVariant;
		}
	}

	, 
	_fontWeight: null,
	fontWeight: function (value) {
		if (arguments.length === 1) {
			this._fontWeight = value;
			return value;
		} else {
			return this._fontWeight;
		}
	}

	, 
	_fontSize: 0,
	fontSize: function (value) {
		if (arguments.length === 1) {
			this._fontSize = value;
			return value;
		} else {
			return this._fontSize;
		}
	}

	, 
	_lineHeight: 0,
	lineHeight: function (value) {
		if (arguments.length === 1) {
			this._lineHeight = value;
			return value;
		} else {
			return this._lineHeight;
		}
	}

	, 
	_fontFamily: null,
	fontFamily: function (value) {
		if (arguments.length === 1) {
			this._fontFamily = value;
			return value;
		} else {
			return this._fontFamily;
		}
	}

	, 
	_fontStretch: null,
	fontStretch: function (value) {
		if (arguments.length === 1) {
			this._fontStretch = value;
			return value;
		} else {
			return this._fontStretch;
		}
	}
	, 
	$type: new $.ig.Type('FontInfo', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('DoubleAnimator', 'Object', {

	needsFlush: function () {

			return this.transitionProgress() == 0;
	}

	, 
	flush: function () {
		this.update(true);
	}
	, 
	__transitionProgress: 0

	, 
	transitionProgress: function (value) {
		if (arguments.length === 1) {

			this.__transitionProgress = value;
			if (this.propertyChanged != null) {
				this.propertyChanged(this, new $.ig.PropertyChangedEventArgs("TransitionProgress"));
			}

			return value;
		} else {

			return this.__transitionProgress;
		}
	}
	, 
	__intervalMilliseconds: 0

	, 
	intervalMilliseconds: function (value) {
		if (arguments.length === 1) {

			this.__intervalMilliseconds = value;
			return value;
		} else {

			return this.__intervalMilliseconds;
		}
	}
	, 
	__easingFunction: null

	, 
	easingFunction: function (value) {
		if (arguments.length === 1) {

			this.__easingFunction = value;
			return value;
		} else {

			return this.__easingFunction;
		}
	}
	, 
	__from: 0
	, 
	__to: 0

	, 
	from: function (value) {
		if (arguments.length === 1) {

			this.__from = value;
			return value;
		} else {

			return this.__from;
		}
	}

	, 
	to: function (value) {
		if (arguments.length === 1) {

			this.__to = value;
			return value;
		} else {

			return this.__to;
		}
	}
	, 
	init: function (from, to, intervalMilliseconds) {


		this.__easingFunction = null;
		this.__from = 0;
		this.__to = 0;
		this.__active = false;
		this.__intervalId = -1;
		this.__lastRender = 0;

		$.ig.Object.prototype.init.call(this);
			this.__from = from;
			this.__to = to;
			this.__intervalMilliseconds = intervalMilliseconds;
			this.requestAnimationFrame(window.requestAnimationFrame ||
            window.webkitRequestAnimationFrame ||
            window.mozRequestAnimationFrame ||
            window.oRequestAnimationFrame ||
            window.msRequestAnimationFrame ||
            function(callback) {
                window.setTimeout(callback, 1000 / 60);
            });
	}

	, 
	_requestAnimationFrame: null,
	requestAnimationFrame: function (value) {
		if (arguments.length === 1) {
			this._requestAnimationFrame = value;
			return value;
		} else {
			return this._requestAnimationFrame;
		}
	}
	, 
	__active: false

	, 
	active: function (value) {
		if (arguments.length === 1) {

			this.__active = value;
			return value;
		} else {

			return this.__active;
		}
	}

	, 
	start: function () {
		this.__transitionProgress = 0;
		this.__lastRender = 0;
		this.__startTime = $.ig.Date.prototype.now();
		if (!this.__active) {
			this.__active = true;
			this.requestAnimationFrame()(this.tick.runOn(this));
		}

	}

	, 
	stop: function () {
		this.__active = false;
		this.__transitionProgress = 0;
		this.__lastRender = 0;
	}
	, 
	__startTime: new Date()
	, 
	__intervalId: 0
	, 
	__lastRender: 0

	, 
	tick: function () {
		this.update(false);
	}

	, 
	update: function (flush) {
		if (!this.__active) {
			this.stop();
			return;
		}

		var currentTime = $.ig.Date.prototype.now();
		var ellapsedMilliseconds = currentTime.getTime() - this.__startTime.getTime();
		if (ellapsedMilliseconds > this.__intervalMilliseconds) {
			ellapsedMilliseconds = this.__intervalMilliseconds;
		}

		if ((ellapsedMilliseconds - this.__lastRender < 16 && ellapsedMilliseconds != this.__intervalMilliseconds) && !flush) {
			this.requestAnimationFrame()(this.tick.runOn(this));
			return;
		}

		this.__lastRender = ellapsedMilliseconds;
		var p = (ellapsedMilliseconds / this.__intervalMilliseconds);
		if (this.__easingFunction != null) {
			p = this.__easingFunction(p);
		}

		var interpolatedValue = this.__from + ((this.__to - this.__from) * p);
		if (!flush) {
			if (ellapsedMilliseconds == this.__intervalMilliseconds) {
				this.stop();

			} else {
				this.requestAnimationFrame()(this.tick.runOn(this));
			}

		}

		this.transitionProgress(interpolatedValue);
	}

	, 
	getElapsedMilliseconds: function () {
		return this.__active ? $.ig.Date.prototype.now().getTime() - this.__startTime.getTime() : 0;
	}

	, 
	animationActive: function () {
		return this.__active;
	}
	, 
	propertyChanged: null, 
	$type: new $.ig.Type('DoubleAnimator', $.ig.Object.prototype.$type, [$.ig.INotifyPropertyChanged.prototype.$type])
}, true);





$.ig.util.defType('GeometryUtil', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	simplifyAngle: function (angle) {
		if ($.ig.util.isNaN(angle) || Number.isInfinity(angle)) {
			return angle;
		}

		while (angle > 360) {
			angle -= 360;

		}
		while (angle < 0) {
			angle += 360;

		}
		return angle;
	}

	, 
	angleFromSlope: function (slope) {
		return Math.atan(slope);
	}

	, 
	slope: function (point1, point2) {
		return (point2.__y - point1.__y) / (point2.__x - point1.__x);
	}

	, 
	eccentricity: function (bounds) {
		return 1 - Math.pow(bounds.height() / 2, 2) / Math.pow(bounds.width() / 2, 2);
	}

	, 
	pointOnEllipse: function (theta, eccentricity, center, halfHeight, extent) {
		var cos = Math.cos(theta);
		var sin = Math.sin(theta);
		var r = Math.sqrt(halfHeight * halfHeight / (1 - (eccentricity * Math.pow(cos, 2))));
		r *= extent;
		return {__x: r * cos + center.__x, __y: r * sin + center.__y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
	}

	, 
	findCenter: function (width, height, exploded, angle, radius) {
		var center;
		if (exploded) {
			center = $.ig.GeometryUtil.prototype.findRadialPoint({__x: width / 2, __y: height / 2, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}, angle, radius);

		} else {
			center = {__x: width / 2, __y: height / 2, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		}

		return center;
	}

	, 
	findRadialPoint: function (center, angle, radius) {
		angle = angle / 180 * Math.PI;
		var y = center.__y + radius * Math.sin(angle);
		var x = center.__x + radius * Math.cos(angle);
		return {__x: x, __y: y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
	}

	, 
	pointAtDistance: function (p1, p2, distance) {
		var x3 = p2.__x - p1.__x;
		var y3 = p2.__y - p1.__y;
		var length = Math.sqrt(x3 * x3 + y3 * y3);
		x3 = x3 / length * distance;
		y3 = y3 / length * distance;
		return {__x: p1.__x + x3, __y: p1.__y + y3, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
	}

	, 
	getSegmentLength: function (p1, p2) {
		var a = Math.abs(p2.__x - p1.__x);
		var b = Math.abs(p2.__y - p1.__y);
		return Math.sqrt(a * a + b * b);
	}

	, 
	getCenterFromArcSegment: function (startPoint, endPoint, radius, isCounter, isLargeArc) {
		var midway = {__x: (startPoint.__x + endPoint.__x) / 2, __y: (startPoint.__y + endPoint.__y) / 2, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		var vectorX = endPoint.__x - startPoint.__x;
		var vectorY = endPoint.__y - startPoint.__y;
		var vectorLength = Math.sqrt(vectorX * vectorX + vectorY * vectorY);
		var rotatedVectorX = vectorY;
		var rotatedVectorY = vectorX * -1;
		if (isLargeArc == isCounter) {
			rotatedVectorX = vectorY * -1;
			rotatedVectorY = vectorX;
		}

		var maxAbs = Math.max(Math.abs(rotatedVectorX), Math.abs(rotatedVectorY));
		rotatedVectorX = rotatedVectorX / maxAbs;
		rotatedVectorY = rotatedVectorY / maxAbs;
		var rotatedVectorLength = Math.sqrt(rotatedVectorX * rotatedVectorX + rotatedVectorY * rotatedVectorY);
		var normalizedVectorX = rotatedVectorX / rotatedVectorLength;
		var normalizedVectorY = rotatedVectorY / rotatedVectorLength;
		var halfChordLength = vectorLength / 2;
		var distToCenter = Math.sqrt(radius * radius - halfChordLength * halfChordLength);
		if ($.ig.util.isNaN(distToCenter)) {
			distToCenter = 0;
		}

		var centerVectorX = distToCenter * normalizedVectorX;
		var centerVectorY = distToCenter * normalizedVectorY;
		var center = {__x: midway.__x + centerVectorX, __y: midway.__y + centerVectorY, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		return center;
	}

	, 
	getAngleTo: function (center, toPoint) {
		var radius = Math.sqrt(Math.pow(toPoint.__x - center.__x, 2) + Math.pow(toPoint.__y - center.__y, 2));
		var angle = Math.acos((toPoint.__x - center.__x) / radius);
		if ((toPoint.__y - center.__y) < 0) {
			angle = (2 * Math.PI) - angle;
		}

		return angle;
	}

	, 
	getCircleIntersection: function (startPoint, endPoint, circleCenter, circleRadius) {
		var x1 = startPoint.__x - circleCenter.__x;
		var y1 = startPoint.__y - circleCenter.__y;
		var x2 = endPoint.__x - circleCenter.__x;
		var y2 = endPoint.__y - circleCenter.__y;
		var dx = x2 - x1;
		var dy = y2 - y1;
		var dr = Math.sqrt(dx * dx + dy * dy);
		var det = x1 * y2 - x2 * y1;
		var radSquared = circleRadius * circleRadius;
		var drSquared = dr * dr;
		var detSquared = det * det;
		var disc = radSquared * drSquared - detSquared;
		if (disc < 0) {
			return new $.ig.Tuple$2($.ig.Point.prototype.$type, $.ig.Point.prototype.$type, {__x: NaN, __y: NaN, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}, {__x: NaN, __y: NaN, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
		}

		var signDy = 1;
		if (dy < 0) {
			signDy = -1;
		}

		var interX1 = (det * dy + signDy * dx * Math.sqrt(disc)) / drSquared;
		var interX2 = (det * dy - signDy * dx * Math.sqrt(disc)) / drSquared;
		var interY1 = (-1 * det * dx + Math.abs(dy) * Math.sqrt(disc)) / drSquared;
		var interY2 = (-1 * det * dx - Math.abs(dy) * Math.sqrt(disc)) / drSquared;
		return new $.ig.Tuple$2($.ig.Point.prototype.$type, $.ig.Point.prototype.$type, {__x: interX1 + circleCenter.__x, __y: interY1 + circleCenter.__y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}, {__x: interX2 + circleCenter.__x, __y: interY2 + circleCenter.__y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
	}
	, 
	$type: new $.ig.Type('GeometryUtil', $.ig.Object.prototype.$type)
}, true);


$.ig.util.defType('MathUtil', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	asinh: function (angle) {
		var $self = this;
		return Math.log(angle + Math.sqrt(angle * angle + 1));
	}

	, 
	hypot: function (x, y) {
		var $self = this;
		return Math.sqrt(x * x + y * y);
	}

	, 
	sqr: function (x) {
		var $self = this;
		return x * x;
	}

	, 
	gammaLn: function (x) {
		var $self = this;
		if (x <= 0) {
			return NaN;
		}

		var cof = (function () { var $ret = new Array();
		$ret.add(57.156235665862923);
		$ret.add(-59.597960355475493);
		$ret.add(14.136097974741746);
		$ret.add(-0.49191381609762019);
		$ret.add(3.3994649984811891E-05);
		$ret.add(4.6523628927048578E-05);
		$ret.add(-9.8374475304879565E-05);
		$ret.add(0.00015808870322491249);
		$ret.add(-0.00021026444172410488);
		$ret.add(0.00021743961811521265);
		$ret.add(-0.00016431810653676389);
		$ret.add(8.441822398385275E-05);
		$ret.add(-2.6190838401581408E-05);
		$ret.add(3.6899182659531625E-06);return $ret;}());
		var y = x;
		var t = (x + 0.5) * Math.log(x + 5.2421875) - (x + 5.2421875);
		var s = 0.99999999999999711;
		for (var j = 0; j < 14; j++) {
			s += cof[j] / ++y;
		}

		return t + Math.log(2.5066282746310007 * s / x);
	}

	, 
	clamp: function (value, minimum, maximum) {
		return Math.min(maximum, Math.max(minimum, value));
	}

	, 
	radians: function (degrees) {
		return Math.PI * degrees / 180;
	}

	, 
	degrees: function (radians) {
		return 180 * radians / Math.PI;
	}

	, 
	noise: function (x, y, z) {
		var $self = this;
		var X = $.ig.truncate(Math.floor(x)) & 255;
		var Y = $.ig.truncate(Math.floor(y)) & 255;
		var Z = $.ig.truncate(Math.floor(z)) & 255;
		x -= Math.floor(x);
		y -= Math.floor(y);
		z -= Math.floor(z);
		var u = $.ig.MathUtil.prototype.fade(x);
		var v = $.ig.MathUtil.prototype.fade(y);
		var w = $.ig.MathUtil.prototype.fade(z);
		var A = $.ig.MathUtil.prototype._basis[X] + Y;
		var AA = $.ig.MathUtil.prototype._basis[A] + Z;
		var AB = $.ig.MathUtil.prototype._basis[A + 1] + Z;
		var B = $.ig.MathUtil.prototype._basis[X + 1] + Y;
		var BA = $.ig.MathUtil.prototype._basis[B] + Z;
		var BB = $.ig.MathUtil.prototype._basis[B + 1] + Z;
		return $.ig.MathUtil.prototype.lerp(w, $.ig.MathUtil.prototype.lerp(v, $.ig.MathUtil.prototype.lerp(u, $.ig.MathUtil.prototype.grad($.ig.MathUtil.prototype._basis[AA], x, y, z), $.ig.MathUtil.prototype.grad($.ig.MathUtil.prototype._basis[BA], x - 1, y, z)), $.ig.MathUtil.prototype.lerp(u, $.ig.MathUtil.prototype.grad($.ig.MathUtil.prototype._basis[AB], x, y - 1, z), $.ig.MathUtil.prototype.grad($.ig.MathUtil.prototype._basis[BB], x - 1, y - 1, z))), $.ig.MathUtil.prototype.lerp(v, $.ig.MathUtil.prototype.lerp(u, $.ig.MathUtil.prototype.grad($.ig.MathUtil.prototype._basis[AA + 1], x, y, z - 1), $.ig.MathUtil.prototype.grad($.ig.MathUtil.prototype._basis[BA + 1], x - 1, y, z - 1)), $.ig.MathUtil.prototype.lerp(u, $.ig.MathUtil.prototype.grad($.ig.MathUtil.prototype._basis[AB + 1], x, y - 1, z - 1), $.ig.MathUtil.prototype.grad($.ig.MathUtil.prototype._basis[BB + 1], x - 1, y - 1, z - 1))));
	}

	, 
	fade: function (t) {
		return t * t * t * (t * (t * 6 - 15) + 10);
	}

	, 
	lerp: function (t, a, b) {
		return a + t * (b - a);
	}

	, 
	grad: function (hash, x, y, z) {
		var h = hash & 15;
		var u = h < 8 ? x : y;
		var v = h < 4 ? y : h == 12 || h == 14 ? x : z;
		return ((h & 1) == 0 ? u : -u) + ((h & 2) == 0 ? v : -v);
	}

	, 
	niceFloor: function (value) {
		if (value == 0) {
			return 0;
		}

		if (value < 0) {
			return -$.ig.MathUtil.prototype.niceCeiling(-value);
		}

		var expv = $.ig.truncate(Math.floor(Math.log10(value)));
		var f = value / $.ig.MathUtil.prototype.expt(10, expv);
		var nf = f < 2 ? 1 : (f < 5 ? 2 : (f < 10 ? 5 : 10));
		return nf * $.ig.MathUtil.prototype.expt(10, expv);
	}

	, 
	niceRound: function (value) {
		if (value == 0) {
			return 0;
		}

		if (value < 0) {
			return -$.ig.MathUtil.prototype.niceRound(-value);
		}

		var expv = $.ig.truncate(Math.floor(Math.log10(value)));
		var f = value / $.ig.MathUtil.prototype.expt(10, expv);
		var nf = f < 1 ? 1 : (f < 3 ? 2 : (f < 7 ? 5 : 10));
		return nf * $.ig.MathUtil.prototype.expt(10, expv);
	}

	, 
	niceCeiling: function (value) {
		if (value == 0) {
			return 0;
		}

		if (value < 0) {
			return -$.ig.MathUtil.prototype.niceFloor(-value);
		}

		var expv = $.ig.truncate(Math.floor(Math.log10(value)));
		var f = value / $.ig.MathUtil.prototype.expt(10, expv);
		var nf = f <= 1 ? 1 : (f <= 2 ? 2 : (f <= 5 ? 5 : 10));
		return nf * $.ig.MathUtil.prototype.expt(10, expv);
	}

	, 
	expt: function (a, n) {
		var x = 1;
		for (; n > 0; --n) {
			x *= a;
		}

		for (; n < 0; ++n) {
			x /= a;
		}

		return x;
	}

	, 
	min3: function (v1, v2, v3) {
		return Math.min(v1, Math.min(v2, v3));
	}

	, 
	max3: function (v1, v2, v3) {
		return Math.max(v1, Math.max(v2, v3));
	}

	, 
	min: function (a) {
		var min = a[0];
		for (var i = 1; i < a.length; ++i) {
			min = Math.min(min, a[i]);
		}

		return min;
	}

	, 
	max: function (a) {
		var max = a[0];
		for (var i = 1; i < a.length; ++i) {
			max = Math.max(max, a[i]);
		}

		return max;
	}
	, 
	$type: new $.ig.Type('MathUtil', $.ig.Object.prototype.$type)
}, true);




$.ig.util.defType('IPool$1', 'Object', {
	$type: new $.ig.Type('IPool$1', null)
}, true);

$.ig.util.defType('IIndexedPool$1', 'Object', {
	$type: new $.ig.Type('IIndexedPool$1', null, [$.ig.IPool$1.prototype.$type.specialize(0)])
}, true);

$.ig.util.defType('Pool$1', 'Object', {
	$t: null, 
	init: function ($t) {

		this.$t = $t;
		this.$type = this.$type.specialize(this.$t);


		$.ig.Object.prototype.init.call(this);
			this.active(new $.ig.List$1(this.$t, 0));
			this.inactive(new $.ig.List$1(this.$t, 0));
	}

	, 
	_create: null,
	create: function (value) {
		if (arguments.length === 1) {
			this._create = value;
			return value;
		} else {
			return this._create;
		}
	}

	, 
	_disactivate: null,
	disactivate: function (value) {
		if (arguments.length === 1) {
			this._disactivate = value;
			return value;
		} else {
			return this._disactivate;
		}
	}

	, 
	_activate: null,
	activate: function (value) {
		if (arguments.length === 1) {
			this._activate = value;
			return value;
		} else {
			return this._activate;
		}
	}

	, 
	_destroy: null,
	destroy: function (value) {
		if (arguments.length === 1) {
			this._destroy = value;
			return value;
		} else {
			return this._destroy;
		}
	}

	, 
	item: function (index) {

			if (index >= this.count()) {
				this.count(index + 1);
			}

			return this.active().__inner[index];
	}

	, 
	clear: function () {
		this.count(0);
	}

	, 
	count: function (value) {
		if (arguments.length === 1) {

			var activeCount = this.active().count();
			while (value > this.active().count() && this.inactive().count() > 0) {
				var item = this.inactive().__inner[this.inactive().count() - 1];
				this.active().add(item);
				this.inactive().removeAt(this.inactive().count() - 1);
				if (this.activate() != null) {
					this.activate()(item);
				}


			}
			while (value > this.active().count() && this.inactive().count() == 0) {
				var item1 = this.create()();
				this.active().add(item1);
				if (this.activate() != null) {
					this.activate()(item1);
				}


			}
			var inactiveCount = 2;
			while (activeCount != 0) {
				activeCount >>= 1;
				inactiveCount <<= 1;

			}
			while (value < this.active().count()) {
				var item2 = this.active().__inner[this.active().count() - 1];
				this.active().removeAt(this.active().count() - 1);
				if (this.disactivate() != null) {
					this.disactivate()(item2);
				}

				if (this.inactive().count() < inactiveCount) {
					this.inactive().add(item2);

				} else {
					if (this.destroy() != null) {
						this.destroy()(item2);
					}

				}


			}
			if (inactiveCount < this.inactive().count()) {
				for (var i = inactiveCount; i < this.inactive().count(); ++i) {
					this.destroy()(this.inactive().__inner[i]);
				}

				this.inactive().removeRange(inactiveCount, this.inactive().count() - inactiveCount);
			}

			return value;
		} else {

			return this.active().count();
		}
	}

	, 
	_active: null,
	active: function (value) {
		if (arguments.length === 1) {
			this._active = value;
			return value;
		} else {
			return this._active;
		}
	}

	, 
	_inactive: null,
	inactive: function (value) {
		if (arguments.length === 1) {
			this._inactive = value;
			return value;
		} else {
			return this._inactive;
		}
	}

	, 
	doToAll: function (action) {
		for (var i = 0; i < this.inactive().count(); i++) {
			action(this.inactive().__inner[i]);
		}

		for (var i1 = 0; i1 < this.active().count(); i1++) {
			action(this.active().__inner[i1]);
		}

	}
	, 
	$type: new $.ig.Type('Pool$1', $.ig.Object.prototype.$type, [$.ig.IIndexedPool$1.prototype.$type.specialize(0)])
}, true);




$.ig.util.defType('RectUtil', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	getCenter: function (rect) {
		if (rect.isEmpty()) {
			return {__x: NaN, __y: NaN, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		}

		return {__x: 0.5 * (rect.left() + rect.right()), __y: 0.5 * (rect.bottom() + rect.top()), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
	}

	, 
	getArea: function (rect) {
		if (rect.isEmpty()) {
			return 0;
		}

		return rect.width() * rect.height();
	}

	, 
	duplicate: function (rect) {
		if (rect.isEmpty()) {
			return rect;
		}

		return new $.ig.Rect(0, rect.left(), rect.top(), rect.width(), rect.height());
	}

	, 
	getLeader: function (rect, anchor) {
		if (rect.containsPoint(anchor)) {
			return anchor;
		}

		var C = {__x: rect.left() + 0.5 * rect.width(), __y: rect.top() + 0.5 * rect.height(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		var D = {__x: anchor.__x - C.__x, __y: anchor.__y - C.__y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		var p;
		if (D.__x != 0) {
			p = (rect.left() - C.__x) / D.__x;
			var y = C.__y + p * D.__y;
			if (y > rect.top() && y < rect.bottom()) {
				return p > 0 ? {__x: rect.left(), __y: y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName} : {__x: rect.right(), __y: C.__y - p * D.__y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			}

		}

		p = (rect.top() - C.__y) / D.__y;
		var x = C.__x + p * D.__x;
		return p > 0 ? {__x: x, __y: rect.top(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName} : {__x: C.__x - p * D.__x, __y: rect.bottom(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
	}

	, 
	getDistanceSquared1: function (rect, pt) {
		if (rect.isEmpty()) {
			return NaN;
		}

		return $.ig.RectUtil.prototype.getDistanceSquared(rect, pt.__x, pt.__y);
	}

	, 
	getDistanceSquared2: function (rect, rc) {
		if (rect.isEmpty()) {
			return Number.POSITIVE_INFINITY;
		}

		var d2 = $.ig.RectUtil.prototype.getDistanceSquared(rect, rc.left(), rc.top());
		if (d2 > 0) {
			d2 = Math.min(d2, $.ig.RectUtil.prototype.getDistanceSquared(rect, rc.left(), rc.bottom()));
		}

		if (d2 > 0) {
			d2 = Math.min(d2, $.ig.RectUtil.prototype.getDistanceSquared(rect, rc.right(), rc.bottom()));
		}

		if (d2 > 0) {
			d2 = Math.min(d2, $.ig.RectUtil.prototype.getDistanceSquared(rect, rc.right(), rc.top()));
		}

		if (d2 > 0) {
			d2 = Math.min(d2, $.ig.RectUtil.prototype.getDistanceSquared(rc, rect.left(), rect.top()));
		}

		if (d2 > 0) {
			d2 = Math.min(d2, $.ig.RectUtil.prototype.getDistanceSquared(rc, rect.left(), rect.bottom()));
		}

		if (d2 > 0) {
			d2 = Math.min(d2, $.ig.RectUtil.prototype.getDistanceSquared(rc, rect.right(), rect.bottom()));
		}

		if (d2 > 0) {
			d2 = Math.min(d2, $.ig.RectUtil.prototype.getDistanceSquared(rc, rect.right(), rect.top()));
		}

		return d2;
	}

	, 
	getDistanceSquared: function (rc, X, Y) {
		var vs = X - rc.left();
		var vt = Y - rc.top();
		var s = rc.width() * vs;
		var t = rc.height() * vt;
		if (s > 0) {
			var s0 = rc.width() * rc.width();
			if (s < s0) {
				vs -= (s / s0) * rc.width();

			} else {
				vs -= rc.width();
			}

		}

		if (t > 0) {
			var t0 = rc.height() * rc.height();
			if (t < t0) {
				vt -= (t / t0) * rc.height();

			} else {
				vt -= rc.height();
			}

		}

		return vs * vs + vt * vt;
	}

	, 
	contains: function (rect, rc) {
		if (rect.isEmpty() || rc.isEmpty()) {
			return false;
		}

		if (rect.left() > rc.left()) {
			return false;
		}

		if (rect.right() < rc.right()) {
			return false;
		}

		if (rect.top() > rc.top()) {
			return false;
		}

		if (rect.bottom() < rc.bottom()) {
			return false;
		}

		return true;
	}

	, 
	intersectsWith: function (rect, rc) {
		if (rect.isEmpty() || rc.isEmpty()) {
			return false;
		}

		if (rect.right() < rc.left()) {
			return false;
		}

		if (rect.left() > rc.right()) {
			return false;
		}

		if (rect.top() > rc.bottom()) {
			return false;
		}

		if (rect.bottom() < rc.top()) {
			return false;
		}

		return true;
	}

	, 
	intersectionArea: function (rect, rc) {
		if (rect.isEmpty() || rc.isEmpty()) {
			return 0;
		}

		var width = Math.min(rect.right(), rc.right()) - Math.max(rect.left(), rc.left());
		if (width <= 0) {
			return 0;
		}

		var height = Math.min(rect.bottom(), rc.bottom()) - Math.max(rect.top(), rc.top());
		if (height <= 0) {
			return 0;
		}

		return width * height;
	}

	, 
	getInflated: function (rect, width, height) {
		if (rect.isEmpty()) {
			return rect;
		}

		return new $.ig.Rect(0, rect.x() - width, rect.y() - height, Math.max(0, rect.width() + 2 * width), Math.max(0, rect.height() + 2 * height));
	}

	, 
	inflate1: function (rect, dx, dy) {
		rect.x(rect.x() - dx);
		rect.y(rect.y() - dy);
		var width = rect.width() + 2 * dx;
		var height = rect.height() + 2 * dy;
		rect.width(width > 1 ? width : 1);
		rect.height(height > 1 ? height : 1);
		return rect;
	}

	, 
	inflate: function (rect, thickness) {
		var newX = rect.x() - thickness;
		var newY = rect.y() - thickness;
		var width = rect.width() + thickness + thickness;
		var height = rect.height() + thickness + thickness;
		var newWidth = width > 0 ? width : 0;
		var newHeight = height > 0 ? height : 0;
		return new $.ig.Rect(0, newX, newY, newWidth, newHeight);
	}

	, 
	round: function (rect) {
		rect.x(Math.round(rect.x()));
		rect.y(Math.round(rect.y()));
		rect.width(Math.round(rect.width()));
		rect.height(Math.round(rect.height()));
		return rect;
	}

	, 
	isNull: function (rect) {
		return rect.x() == 0 && rect.y() == 0 && rect.width() == 0 && rect.height() == 0;
	}

	, 
	size: function (rect) {
		var value = new $.ig.Size(1, rect.width(), rect.height());
		return value;
	}

	, 
	normalize: function (current, rect) {
		var normalizeRect = $.ig.RectUtil.prototype.normalize1(current, $.ig.RectUtil.prototype.size(rect));
		return normalizeRect;
	}

	, 
	normalize1: function (current, size) {
		var normalizeRect = current;
		normalizeRect.x(current.x() / size.width());
		normalizeRect.y(current.y() / size.height());
		normalizeRect.width(current.width() / size.width());
		normalizeRect.height(current.height() / size.height());
		return normalizeRect;
	}

	, 
	getTopLeft: function (rect) {
		var value = {__x: rect.x(), __y: rect.y(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		return value;
	}

	, 
	getTopRight: function (rect) {
		var value = {__x: rect.x() + rect.width(), __y: rect.y(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		return value;
	}

	, 
	getBottomLeft: function (rect) {
		var value = {__x: rect.x(), __y: rect.y() + rect.height(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		return value;
	}

	, 
	getBottomRight: function (rect) {
		var value = {__x: rect.x() + rect.width(), __y: rect.y() + rect.height(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		return value;
	}

	, 
	getCorners: function (rect) {
		var $self = this;
		var points = (function () { var $ret = new $.ig.List$1($.ig.Point.prototype.$type, 0);
		$ret.add($.ig.RectUtil.prototype.getTopLeft(rect));
		$ret.add($.ig.RectUtil.prototype.getTopRight(rect));
		$ret.add($.ig.RectUtil.prototype.getBottomRight(rect));
		$ret.add($.ig.RectUtil.prototype.getBottomLeft(rect)); return $ret;}());
		return points;
	}

	, 
	rotateAboutCenter: function (rect, angle) {
		angle = $.ig.GeometryUtil.prototype.simplifyAngle(angle);
		if (angle == 0 || angle == 180) {
			return new $.ig.Rect(0, rect.left(), rect.top(), rect.width(), rect.height());
		}

		var center = $.ig.RectUtil.prototype.getCenter(rect);
		if (angle == 90 || angle == 270) {
			var halfHeight = rect.height() / 2;
			var halfWidth = rect.width() / 2;
			return new $.ig.Rect(0, center.__x - halfHeight, center.__y - halfWidth, rect.height(), rect.width());
		}

		return $.ig.RectUtil.prototype.rotateAboutPoint(rect, center.__x, center.__y, angle);
	}

	, 
	rotateAboutPoint: function (rect, x, y, angle) {
		var points = $.ig.RectUtil.prototype.getCorners(rect);
		var angleRadians = $.ig.MathUtil.prototype.radians(angle);
		var cos = Math.cos(angleRadians);
		var sin = Math.sin(angleRadians);
		var top = 1.7976931348623157E+308;
		var left = 1.7976931348623157E+308;
		var right = -1.7976931348623157E+308;
		var bottom = -1.7976931348623157E+308;
		var p;
		for (var i = 0; i < points.count(); i++) {
			p = points.__inner[i];
			var rotatedX = (cos * (p.__x - x) - sin * (p.__y - y) + x);
			var rotatedY = (sin * (p.__x - x) + cos * (p.__y - y) + y);
			top = Math.min(top, rotatedY);
			left = Math.min(left, rotatedX);
			right = Math.max(right, rotatedX);
			bottom = Math.max(bottom, rotatedY);
		}

		var ret = new $.ig.Rect(0, left, top, right - left, bottom - top);
		return ret;
	}
	, 
	$type: new $.ig.Type('RectUtil', $.ig.Object.prototype.$type)
}, true);





$.ig.util.defType('IVisualData', 'Object', {
	$type: new $.ig.Type('IVisualData', null)
}, true);

$.ig.util.defType('PrimitiveVisualData', 'Object', {
	init: function (initNumber) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.Object.prototype.init.call(this);
	}
	, 
	init1: function (initNumber, name) {


		$.ig.Object.prototype.init.call(this);
			this.name(name);
			this.tags(new $.ig.ShapeTags());
			this.appearance(new $.ig.PrimitiveAppearanceData());
	}

	, 
	_appearance: null,
	appearance: function (value) {
		if (arguments.length === 1) {
			this._appearance = value;
			return value;
		} else {
			return this._appearance;
		}
	}

	, 
	_tags: null,
	tags: function (value) {
		if (arguments.length === 1) {
			this._tags = value;
			return value;
		} else {
			return this._tags;
		}
	}

	, 
	type: function () {
	}

	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	scaleByViewport: function (viewport) {
		this.appearance().scaleByViewport(viewport);
	}

	, 
	getPoints: function (settings) {
		var points = new $.ig.List$1($.ig.List$1.prototype.$type.specialize($.ig.Point.prototype.$type), 0);
		this.getPointsOverride(points, settings);
		return points;
	}

	, 
	getPointsOverride: function (points, settings) {}

	, 
	serialize: function () {
		var sb = new $.ig.StringBuilder(0);
		sb.appendLine1("{");
		sb.appendLine1("appearance: " + (this.appearance() != null ? this.appearance().serialize() : "null") + ", ");
		sb.appendLine1("tags: [");
		for (var i = 0; i < this.tags().count(); i++) {
			if (i != 0) {
				sb.append3(", ");
			}

			sb.append3("\'" + this.tags().__inner[i] + "\'");
		}

		sb.appendLine1("],");
		sb.appendLine1("type: \'" + this.type() + "\', ");
		sb.appendLine1("name: \'" + this.name() + "\', ");
		sb.appendLine1(this.serializeOverride());
		sb.appendLine1("}");
		return sb.toString();
	}

	, 
	serializeOverride: function () {
		return "";
	}
	, 
	$type: new $.ig.Type('PrimitiveVisualData', $.ig.Object.prototype.$type, [$.ig.IVisualData.prototype.$type])
}, true);

$.ig.util.defType('PrimitiveVisualDataList', 'List$1', {
	init: function () {


		$.ig.List$1.prototype.init.call(this, $.ig.PrimitiveVisualData.prototype.$type, 0);

	}
	, 
	containingTag: function (tag) {
		var ret = new $.ig.PrimitiveVisualDataList();
		for (var i = 0; i < this.count(); i++) {
			var curr = this.__inner[i];
			for (var j = 0; j < curr.tags().count(); j++) {
				if (curr.tags().__inner[j] == tag) {
					ret.add(curr);
					break;
				}

			}

		}

		return ret;
	}

	, 
	serialize: function () {
		var sb = new $.ig.StringBuilder(0);
		sb.append3("{ items: [");
		for (var i = 0; i < this.count(); i++) {
			if (i != 0) {
				sb.append3(", ");
			}

			sb.append3(this.__inner[i].serialize());
		}

		return sb.toString();
	}
	, 
	$type: new $.ig.Type('PrimitiveVisualDataList', $.ig.List$1.prototype.$type.specialize($.ig.PrimitiveVisualData.prototype.$type), [$.ig.IVisualData.prototype.$type])
}, true);

$.ig.util.defType('LabelAppearanceData', 'Object', {
	init: function () {

		this._labelBrush = new $.ig.Color();

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_text: null,
	text: function (value) {
		if (arguments.length === 1) {
			this._text = value;
			return value;
		} else {
			return this._text;
		}
	}

	, 
	_horizontalAlignment: null,
	horizontalAlignment: function (value) {
		if (arguments.length === 1) {
			this._horizontalAlignment = value;
			return value;
		} else {
			return this._horizontalAlignment;
		}
	}

	, 
	_verticalAlignment: null,
	verticalAlignment: function (value) {
		if (arguments.length === 1) {
			this._verticalAlignment = value;
			return value;
		} else {
			return this._verticalAlignment;
		}
	}

	, 
	_textAlignment: null,
	textAlignment: function (value) {
		if (arguments.length === 1) {
			this._textAlignment = value;
			return value;
		} else {
			return this._textAlignment;
		}
	}

	, 
	_textWrapping: null,
	textWrapping: function (value) {
		if (arguments.length === 1) {
			this._textWrapping = value;
			return value;
		} else {
			return this._textWrapping;
		}
	}

	, 
	_textPosition: null,
	textPosition: function (value) {
		if (arguments.length === 1) {
			this._textPosition = value;
			return value;
		} else {
			return this._textPosition;
		}
	}

	, 
	_labelBrush: null,
	labelBrush: function (value) {
		if (arguments.length === 1) {
			this._labelBrush = value;
			return value;
		} else {
			return this._labelBrush;
		}
	}

	, 
	_labelBrushExtended: null,
	labelBrushExtended: function (value) {
		if (arguments.length === 1) {
			this._labelBrushExtended = value;
			return value;
		} else {
			return this._labelBrushExtended;
		}
	}

	, 
	_angle: 0,
	angle: function (value) {
		if (arguments.length === 1) {
			this._angle = value;
			return value;
		} else {
			return this._angle;
		}
	}

	, 
	_opacity: 0,
	opacity: function (value) {
		if (arguments.length === 1) {
			this._opacity = value;
			return value;
		} else {
			return this._opacity;
		}
	}

	, 
	_visibility: false,
	visibility: function (value) {
		if (arguments.length === 1) {
			this._visibility = value;
			return value;
		} else {
			return this._visibility;
		}
	}

	, 
	_font: null,
	font: function (value) {
		if (arguments.length === 1) {
			this._font = value;
			return value;
		} else {
			return this._font;
		}
	}

	, 
	_fontFamily: null,
	fontFamily: function (value) {
		if (arguments.length === 1) {
			this._fontFamily = value;
			return value;
		} else {
			return this._fontFamily;
		}
	}

	, 
	_fontSize: 0,
	fontSize: function (value) {
		if (arguments.length === 1) {
			this._fontSize = value;
			return value;
		} else {
			return this._fontSize;
		}
	}

	, 
	_fontWeight: null,
	fontWeight: function (value) {
		if (arguments.length === 1) {
			this._fontWeight = value;
			return value;
		} else {
			return this._fontWeight;
		}
	}

	, 
	_fontStyle: null,
	fontStyle: function (value) {
		if (arguments.length === 1) {
			this._fontStyle = value;
			return value;
		} else {
			return this._fontStyle;
		}
	}

	, 
	_fontStretch: null,
	fontStretch: function (value) {
		if (arguments.length === 1) {
			this._fontStretch = value;
			return value;
		} else {
			return this._fontStretch;
		}
	}

	, 
	_marginLeft: 0,
	marginLeft: function (value) {
		if (arguments.length === 1) {
			this._marginLeft = value;
			return value;
		} else {
			return this._marginLeft;
		}
	}

	, 
	_marginRight: 0,
	marginRight: function (value) {
		if (arguments.length === 1) {
			this._marginRight = value;
			return value;
		} else {
			return this._marginRight;
		}
	}

	, 
	_marginTop: 0,
	marginTop: function (value) {
		if (arguments.length === 1) {
			this._marginTop = value;
			return value;
		} else {
			return this._marginTop;
		}
	}

	, 
	_marginBottom: 0,
	marginBottom: function (value) {
		if (arguments.length === 1) {
			this._marginBottom = value;
			return value;
		} else {
			return this._marginBottom;
		}
	}

	, 
	serialize: function () {
		var sb = new $.ig.StringBuilder(0);
		sb.appendLine1("{");
		sb.appendLine1("text: \'" + (this.text() != null ? this.text() : "") + "\', ");
		if (this.textAlignment() != null) {
			sb.appendLine1("textAlignment: \"" + this.textAlignment() + "\", ");
		}

		if (this.textWrapping() != null) {
			sb.appendLine1("textWrapping: \"" + this.textWrapping() + "\", ");
		}

		sb.appendLine1("labelBrush: " + ($.ig.Color.prototype.l_op_Inequality_Lifted($.ig.util.toNullable($.ig.Color.prototype.$type, this.labelBrush()), $.ig.util.toNullable($.ig.Color.prototype.$type, null)) ? $.ig.AppearanceHelper.prototype.serializeColor(this.labelBrush()) : "null") + ", ");
		sb.appendLine1("labelBrushExtended: " + (this.labelBrushExtended() != null ? this.labelBrushExtended().serialize() : "null") + ", ");
		sb.appendLine1("angle: " + this.angle() + ", ");
		sb.appendLine1("marginLeft: " + this.marginLeft() + ", ");
		sb.appendLine1("marginRight: " + this.marginRight() + ", ");
		sb.appendLine1("marginTop: " + this.marginTop() + ", ");
		sb.appendLine1("marginBottom: " + this.marginBottom() + ", ");
		sb.appendLine1("opacity: " + this.opacity() + ", ");
		sb.appendLine1("visibility: " + (this.visibility() ? "true" : "false") + ", ");
		if (this.horizontalAlignment() != null) {
			sb.appendLine1("horizontalAlignment: \"" + this.horizontalAlignment() + "\", ");
		}

		if (this.verticalAlignment() != null) {
			sb.appendLine1("verticalAlignment: \"" + this.verticalAlignment() + "\", ");
		}

		if (this.font() != null) {
			sb.appendLine1("font: \"" + this.font() + "\",");
		}

		if (this.fontFamily() != null) {
			sb.appendLine1("fontFamily: \"" + this.fontFamily() + "\",");
		}

		sb.appendLine1("fontWeight: \"" + this.fontWeight() + "\",");
		sb.appendLine1("fontStyle: \"" + this.fontStyle() + "\",");
		sb.appendLine1("fontStretch: \"" + this.fontStretch() + "\",");
		sb.appendLine1("fontSize: " + this.fontSize());
		sb.appendLine1("}");
		return sb.toString();
	}
	, 
	$type: new $.ig.Type('LabelAppearanceData', $.ig.Object.prototype.$type, [$.ig.IVisualData.prototype.$type])
}, true);



$.ig.util.defType('BrushAppearanceData', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	type: function () {
	}

	, 
	serialize: function () {
		return "{ type: \"" + this.type() + "\", " + this.serializeOverride() + " }";
	}

	, 
	serializeOverride: function () {
		return "";
	}
	, 
	$type: new $.ig.Type('BrushAppearanceData', $.ig.Object.prototype.$type, [$.ig.IVisualData.prototype.$type])
}, true);

$.ig.util.defType('SolidBrushAppearanceData', 'BrushAppearanceData', {
	init: function () {

		this._colorValue = new $.ig.Color();

		$.ig.BrushAppearanceData.prototype.init.call(this);

	}
	, 
	type: function () {

			return "solid";
	}

	, 
	_colorValue: null,
	colorValue: function (value) {
		if (arguments.length === 1) {
			this._colorValue = value;
			return value;
		} else {
			return this._colorValue;
		}
	}

	, 
	serializeOverride: function () {
		return "colorValue: " + ($.ig.Color.prototype.l_op_Inequality_Lifted($.ig.util.toNullable($.ig.Color.prototype.$type, this.colorValue()), $.ig.util.toNullable($.ig.Color.prototype.$type, null)) ? $.ig.AppearanceHelper.prototype.serializeColor(this.colorValue()) : "null");
	}
	, 
	$type: new $.ig.Type('SolidBrushAppearanceData', $.ig.BrushAppearanceData.prototype.$type)
}, true);

$.ig.util.defType('LinearGradientBrushAppearanceData', 'BrushAppearanceData', {
	init: function () {



		$.ig.BrushAppearanceData.prototype.init.call(this);
			this.stops(new $.ig.List$1($.ig.GradientStopAppearanceData.prototype.$type, 0));
	}

	, 
	type: function () {

			return "linear";
	}

	, 
	_startX: 0,
	startX: function (value) {
		if (arguments.length === 1) {
			this._startX = value;
			return value;
		} else {
			return this._startX;
		}
	}

	, 
	_startY: 0,
	startY: function (value) {
		if (arguments.length === 1) {
			this._startY = value;
			return value;
		} else {
			return this._startY;
		}
	}

	, 
	_endX: 0,
	endX: function (value) {
		if (arguments.length === 1) {
			this._endX = value;
			return value;
		} else {
			return this._endX;
		}
	}

	, 
	_endY: 0,
	endY: function (value) {
		if (arguments.length === 1) {
			this._endY = value;
			return value;
		} else {
			return this._endY;
		}
	}

	, 
	_stops: null,
	stops: function (value) {
		if (arguments.length === 1) {
			this._stops = value;
			return value;
		} else {
			return this._stops;
		}
	}

	, 
	serializeOverride: function () {
		var sb = new $.ig.StringBuilder(0);
		sb.append3("startX: " + this.startX() + ", endX: " + this.endX() + ", startY: " + this.startY() + ", endY: " + this.endY());
		sb.append3(", stops: [");
		for (var i = 0; i < this.stops().count(); i++) {
			if (i > 0) {
				sb.append3(", ");
			}

			sb.append3(this.stops().__inner[i].serialize());
		}

		sb.append3("]");
		return sb.toString();
	}
	, 
	$type: new $.ig.Type('LinearGradientBrushAppearanceData', $.ig.BrushAppearanceData.prototype.$type)
}, true);

$.ig.util.defType('GradientStopAppearanceData', 'Object', {
	init: function () {

		this._colorValue = new $.ig.Color();

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_colorValue: null,
	colorValue: function (value) {
		if (arguments.length === 1) {
			this._colorValue = value;
			return value;
		} else {
			return this._colorValue;
		}
	}

	, 
	_offset: 0,
	offset: function (value) {
		if (arguments.length === 1) {
			this._offset = value;
			return value;
		} else {
			return this._offset;
		}
	}

	, 
	serialize: function () {
		return "{ " + "colorValue: " + ($.ig.Color.prototype.l_op_Inequality_Lifted($.ig.util.toNullable($.ig.Color.prototype.$type, this.colorValue()), $.ig.util.toNullable($.ig.Color.prototype.$type, null)) ? $.ig.AppearanceHelper.prototype.serializeColor(this.colorValue()) : "null") + ", offset: " + this.offset() + " }";
	}
	, 
	$type: new $.ig.Type('GradientStopAppearanceData', $.ig.Object.prototype.$type, [$.ig.IVisualData.prototype.$type])
}, true);

$.ig.util.defType('PrimitiveAppearanceData', 'Object', {
	init: function () {

		this._stroke = new $.ig.Color();
		this._fill = new $.ig.Color();

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_stroke: null,
	stroke: function (value) {
		if (arguments.length === 1) {
			this._stroke = value;
			return value;
		} else {
			return this._stroke;
		}
	}

	, 
	_strokeExtended: null,
	strokeExtended: function (value) {
		if (arguments.length === 1) {
			this._strokeExtended = value;
			return value;
		} else {
			return this._strokeExtended;
		}
	}

	, 
	_fill: null,
	fill: function (value) {
		if (arguments.length === 1) {
			this._fill = value;
			return value;
		} else {
			return this._fill;
		}
	}

	, 
	_fillExtended: null,
	fillExtended: function (value) {
		if (arguments.length === 1) {
			this._fillExtended = value;
			return value;
		} else {
			return this._fillExtended;
		}
	}

	, 
	_strokeThickness: 0,
	strokeThickness: function (value) {
		if (arguments.length === 1) {
			this._strokeThickness = value;
			return value;
		} else {
			return this._strokeThickness;
		}
	}

	, 
	_visibility: 0,
	visibility: function (value) {
		if (arguments.length === 1) {
			this._visibility = value;
			return value;
		} else {
			return this._visibility;
		}
	}

	, 
	_opacity: 0,
	opacity: function (value) {
		if (arguments.length === 1) {
			this._opacity = value;
			return value;
		} else {
			return this._opacity;
		}
	}

	, 
	_canvasLeft: 0,
	canvasLeft: function (value) {
		if (arguments.length === 1) {
			this._canvasLeft = value;
			return value;
		} else {
			return this._canvasLeft;
		}
	}

	, 
	_canvasTop: 0,
	canvasTop: function (value) {
		if (arguments.length === 1) {
			this._canvasTop = value;
			return value;
		} else {
			return this._canvasTop;
		}
	}

	, 
	_canvaZIndex: 0,
	canvaZIndex: function (value) {
		if (arguments.length === 1) {
			this._canvaZIndex = value;
			return value;
		} else {
			return this._canvaZIndex;
		}
	}

	, 
	_dashArray: null,
	dashArray: function (value) {
		if (arguments.length === 1) {
			this._dashArray = value;
			return value;
		} else {
			return this._dashArray;
		}
	}

	, 
	_dashCap: 0,
	dashCap: function (value) {
		if (arguments.length === 1) {
			this._dashCap = value;
			return value;
		} else {
			return this._dashCap;
		}
	}

	, 
	scaleByViewport: function (viewport) {
		this.canvasLeft((this.canvasLeft() - viewport.left()) / viewport.width());
		this.canvasTop((this.canvasTop() - viewport.top()) / viewport.height());
	}

	, 
	serialize: function () {
		var sb = new $.ig.StringBuilder(0);
		sb.appendLine1("{");
		sb.appendLine1("stroke: " + ($.ig.Color.prototype.l_op_Inequality_Lifted($.ig.util.toNullable($.ig.Color.prototype.$type, this.stroke()), $.ig.util.toNullable($.ig.Color.prototype.$type, null)) ? $.ig.AppearanceHelper.prototype.serializeColor(this.stroke()) : "null") + ", ");
		sb.appendLine1("fill: " + ($.ig.Color.prototype.l_op_Inequality_Lifted($.ig.util.toNullable($.ig.Color.prototype.$type, this.fill()), $.ig.util.toNullable($.ig.Color.prototype.$type, null)) ? $.ig.AppearanceHelper.prototype.serializeColor(this.fill()) : "null") + ", ");
		sb.appendLine1("strokeExtended: " + (this.strokeExtended() != null ? this.strokeExtended().serialize() : "null") + ", ");
		sb.appendLine1("fillExtended: " + (this.fillExtended() != null ? this.fillExtended().serialize() : "null") + ", ");
		sb.appendLine1("strokeThickness: " + this.strokeThickness() + ", ");
		sb.appendLine1("visibility: " + (this.visibility() == $.ig.Visibility.prototype.visible ? "true" : "false") + ", ");
		sb.appendLine1("opacity: " + this.opacity() + ", ");
		sb.appendLine1("canvasLeft: " + this.canvasLeft() + ", ");
		sb.appendLine1("canvasTop: " + this.canvasTop() + ", ");
		sb.appendLine1("canvasZIndex: " + this.canvaZIndex() + ", ");
		sb.appendLine1("dashArray: null, ");
		sb.appendLine1("dashCap: " + this.dashCap());
		sb.appendLine1("}");
		return sb.toString();
	}
	, 
	$type: new $.ig.Type('PrimitiveAppearanceData', $.ig.Object.prototype.$type, [$.ig.IVisualData.prototype.$type])
}, true);

$.ig.util.defType('GetPointsSettings', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	_ignoreFigureStartPoint: false,
	ignoreFigureStartPoint: function (value) {
		if (arguments.length === 1) {
			this._ignoreFigureStartPoint = value;
			return value;
		} else {
			return this._ignoreFigureStartPoint;
		}
	}
	, 
	$type: new $.ig.Type('GetPointsSettings', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('RectangleVisualData', 'PrimitiveVisualData', {
	init: function (initNumber) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.PrimitiveVisualData.prototype.init1.call(this, 1, "rect1");
	}

	, 
	_width: 0,
	width: function (value) {
		if (arguments.length === 1) {
			this._width = value;
			return value;
		} else {
			return this._width;
		}
	}

	, 
	_height: 0,
	height: function (value) {
		if (arguments.length === 1) {
			this._height = value;
			return value;
		} else {
			return this._height;
		}
	}

	, 
	_radiusX: 0,
	radiusX: function (value) {
		if (arguments.length === 1) {
			this._radiusX = value;
			return value;
		} else {
			return this._radiusX;
		}
	}

	, 
	_radiusY: 0,
	radiusY: function (value) {
		if (arguments.length === 1) {
			this._radiusY = value;
			return value;
		} else {
			return this._radiusY;
		}
	}

	, 
	serializeOverride: function () {
		return "width: " + this.width() + ", height: " + this.height() + ", radiusX: " + this.radiusX() + ", radiusY: " + this.radiusY();
	}
	, 
	init1: function (initNumber, name, rect) {


		$.ig.PrimitiveVisualData.prototype.init1.call(this, 1, name);
			this.width(rect.width());
			this.height(rect.height());
			this.radiusX(rect.radiusX());
			this.radiusY(rect.radiusY());
			$.ig.AppearanceHelper.prototype.getShapeAppearance(this.appearance(), rect);
	}

	, 
	type: function () {

			return "Rectangle";
	}

	, 
	scaleByViewport: function (viewport) {
		$.ig.PrimitiveVisualData.prototype.scaleByViewport.call(this, viewport);
		this.width(this.width() / viewport.width());
		this.height(this.height() / viewport.height());
	}

	, 
	getPointsOverride: function (points, settings) {
		var current = new $.ig.List$1($.ig.Point.prototype.$type, 0);
		points.add(current);
		current.add({__x: this.appearance().canvasLeft(), __y: this.appearance().canvasTop(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
		current.add({__x: this.appearance().canvasLeft() + this.width(), __y: this.appearance().canvasTop(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
		current.add({__x: this.appearance().canvasLeft() + this.width(), __y: this.appearance().canvasTop() + this.height(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
		current.add({__x: this.appearance().canvasLeft(), __y: this.appearance().canvasTop() + this.height(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
	}
	, 
	$type: new $.ig.Type('RectangleVisualData', $.ig.PrimitiveVisualData.prototype.$type)
}, true);

$.ig.util.defType('ShapeTags', 'List$1', {
	init: function () {


		$.ig.List$1.prototype.init.call(this, String, 0);

	}, 
	$type: new $.ig.Type('ShapeTags', $.ig.List$1.prototype.$type.specialize(String))
}, true);


$.ig.util.defType('PolyLineVisualData', 'PrimitiveVisualData', {

	type: function () {

			return "Polyline";
	}
	, 
	init: function (initNumber) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.PrimitiveVisualData.prototype.init1.call(this, 1, "polyLine1");
			this.points(new $.ig.List$1($.ig.Point.prototype.$type, 0));
	}
	, 
	init1: function (initNumber, name, line) {


		$.ig.PrimitiveVisualData.prototype.init1.call(this, 1, name);
			this.points(new $.ig.List$1($.ig.Point.prototype.$type, 0));
			for (var i = 0; i < line.points().count(); i++) {
				this.points().add(line.points().__inner[i]);
			}

			$.ig.AppearanceHelper.prototype.getShapeAppearance(this.appearance(), line);
	}

	, 
	_points: null,
	points: function (value) {
		if (arguments.length === 1) {
			this._points = value;
			return value;
		} else {
			return this._points;
		}
	}

	, 
	serializeOverride: function () {
		var sb = new $.ig.StringBuilder(0);
		sb.appendLine1("points: [");
		for (var i = 0; i < this.points().count(); i++) {
			if (i != 0) {
				sb.append3(", ");
			}

			sb.append3("{ x: " + this.points().__inner[i].__x + ", y: " + this.points().__inner[i].__y + "}");
		}

		sb.appendLine1("]");
		return sb.toString();
	}

	, 
	scaleByViewport: function (viewport) {
		$.ig.PrimitiveVisualData.prototype.scaleByViewport.call(this, viewport);
		for (var i = 0; i < this.points().count(); i++) {
			this.points().__inner[i] = {__x: (this.points().__inner[i].__x - viewport.left()) / viewport.width(), __y: (this.points().__inner[i].__y - viewport.top()) / viewport.height(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		}

	}

	, 
	getPointsOverride: function (points, settings) {
		var current = new $.ig.List$1($.ig.Point.prototype.$type, 0);
		points.add(current);
		for (var i = 0; i < this.points().count(); i++) {
			current.add(this.points().__inner[i]);
		}

	}
	, 
	$type: new $.ig.Type('PolyLineVisualData', $.ig.PrimitiveVisualData.prototype.$type)
}, true);

$.ig.util.defType('PolygonVisualData', 'PrimitiveVisualData', {

	type: function () {

			return "Polygon";
	}
	, 
	init: function (initNumber) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.PrimitiveVisualData.prototype.init1.call(this, 1, "polygon1");
			this.points(new $.ig.List$1($.ig.Point.prototype.$type, 0));
	}
	, 
	init1: function (initNumber, name, polygon) {


		$.ig.PrimitiveVisualData.prototype.init1.call(this, 1, name);
			this.points(new $.ig.List$1($.ig.Point.prototype.$type, 0));
			for (var i = 0; i < polygon.points().count(); i++) {
				this.points().add(polygon.points().__inner[i]);
			}

			$.ig.AppearanceHelper.prototype.getShapeAppearance(this.appearance(), polygon);
	}

	, 
	_points: null,
	points: function (value) {
		if (arguments.length === 1) {
			this._points = value;
			return value;
		} else {
			return this._points;
		}
	}

	, 
	serializeOverride: function () {
		var sb = new $.ig.StringBuilder(0);
		sb.appendLine1("points: [");
		for (var i = 0; i < this.points().count(); i++) {
			if (i != 0) {
				sb.append3(", ");
			}

			sb.append3("{ x: " + this.points().__inner[i].__x + ", y: " + this.points().__inner[i].__y + "}");
		}

		sb.appendLine1("]");
		return sb.toString();
	}

	, 
	scaleByViewport: function (viewport) {
		$.ig.PrimitiveVisualData.prototype.scaleByViewport.call(this, viewport);
		for (var i = 0; i < this.points().count(); i++) {
			this.points().__inner[i] = {__x: (this.points().__inner[i].__x - viewport.left()) / viewport.width(), __y: (this.points().__inner[i].__y - viewport.top()) / viewport.height(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		}

	}

	, 
	getPointsOverride: function (points, settings) {
		var current = new $.ig.List$1($.ig.Point.prototype.$type, 0);
		points.add(current);
		for (var i = 0; i < this.points().count(); i++) {
			current.add(this.points().__inner[i]);
		}

	}
	, 
	$type: new $.ig.Type('PolygonVisualData', $.ig.PrimitiveVisualData.prototype.$type)
}, true);

$.ig.util.defType('PathVisualData', 'PrimitiveVisualData', {

	type: function () {

			return "Path";
	}
	, 
	init: function (initNumber) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.PrimitiveVisualData.prototype.init1.call(this, 1, "path1");
			this.data(new $.ig.List$1($.ig.GeometryData.prototype.$type, 0));
	}
	, 
	init1: function (initNumber, name, path) {


		$.ig.PrimitiveVisualData.prototype.init1.call(this, 1, name);
			this.data($.ig.AppearanceHelper.prototype.fromGeometry(path.data()));
			$.ig.AppearanceHelper.prototype.getShapeAppearance(this.appearance(), path);
	}

	, 
	_data: null,
	data: function (value) {
		if (arguments.length === 1) {
			this._data = value;
			return value;
		} else {
			return this._data;
		}
	}

	, 
	serializeOverride: function () {
		var sb = new $.ig.StringBuilder(0);
		sb.appendLine1("data: [");
		for (var i = 0; i < this.data().count(); i++) {
			if (i != 0) {
				sb.append3(", ");
			}

			sb.append3((this.data().__inner[i] != null ? this.data().__inner[i].serialize() : "null"));
		}

		sb.appendLine1("]");
		return sb.toString();
	}

	, 
	scaleByViewport: function (viewport) {
		$.ig.PrimitiveVisualData.prototype.scaleByViewport.call(this, viewport);
		var en = this.data().getEnumerator();
		while (en.moveNext()) {
			var data = en.current();
			data.scaleByViewport(viewport);
		}

	}

	, 
	getPointsOverride: function (points, settings) {
		for (var i = 0; i < this.data().count(); i++) {
			var data = this.data().__inner[i];
			data.getPointsOverride(points, settings);
		}

	}
	, 
	$type: new $.ig.Type('PathVisualData', $.ig.PrimitiveVisualData.prototype.$type)
}, true);

$.ig.util.defType('GeometryData', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	type: function () {
	}

	, 
	scaleByViewport: function (viewport) {}

	, 
	getPointsOverride: function (points, settings) {}

	, 
	serialize: function () {
		return "{ type: \'" + this.type() + "\', " + this.serializeOverride() + "}";
	}

	, 
	serializeOverride: function () {
		return "";
	}
	, 
	$type: new $.ig.Type('GeometryData', $.ig.Object.prototype.$type, [$.ig.IVisualData.prototype.$type])
}, true);

$.ig.util.defType('PathGeometryData', 'GeometryData', {
	init: function () {



		$.ig.GeometryData.prototype.init.call(this);
			this.figures(new $.ig.List$1($.ig.PathFigureData.prototype.$type, 0));
	}

	, 
	type: function () {

			return "Path";
	}

	, 
	_figures: null,
	figures: function (value) {
		if (arguments.length === 1) {
			this._figures = value;
			return value;
		} else {
			return this._figures;
		}
	}

	, 
	serializeOverride: function () {
		var sb = new $.ig.StringBuilder(0);
		sb.appendLine1("figures: [");
		for (var i = 0; i < this.figures().count(); i++) {
			if (i != 0) {
				sb.append3(", ");
			}

			sb.append3(this.figures().__inner[i].serialize());
		}

		sb.appendLine1("]");
		return sb.toString();
	}

	, 
	scaleByViewport: function (viewport) {
		var en = this.figures().getEnumerator();
		while (en.moveNext()) {
			var figure = en.current();
			figure.scaleByViewport(viewport);
		}

	}

	, 
	getPointsOverride: function (points, settings) {
		for (var i = 0; i < this.figures().count(); i++) {
			var figure = this.figures().__inner[i];
			figure.getPointsOverride(points, settings);
		}

	}
	, 
	$type: new $.ig.Type('PathGeometryData', $.ig.GeometryData.prototype.$type)
}, true);

$.ig.util.defType('LineGeometryData', 'GeometryData', {
	init: function () {


		$.ig.GeometryData.prototype.init.call(this);

	}
	, 
	type: function () {

			return "Line";
	}

	, 
	_x1: 0,
	x1: function (value) {
		if (arguments.length === 1) {
			this._x1 = value;
			return value;
		} else {
			return this._x1;
		}
	}

	, 
	_y1: 0,
	y1: function (value) {
		if (arguments.length === 1) {
			this._y1 = value;
			return value;
		} else {
			return this._y1;
		}
	}

	, 
	_x2: 0,
	x2: function (value) {
		if (arguments.length === 1) {
			this._x2 = value;
			return value;
		} else {
			return this._x2;
		}
	}

	, 
	_y2: 0,
	y2: function (value) {
		if (arguments.length === 1) {
			this._y2 = value;
			return value;
		} else {
			return this._y2;
		}
	}

	, 
	serializeOverride: function () {
		return "x1: " + this.x1() + ", y1: " + this.y1() + ", x2: " + this.x2() + ", y2:" + this.y2();
	}

	, 
	scaleByViewport: function (viewport) {
		this.x1((this.x1() - viewport.left()) / viewport.width());
		this.y1((this.y1() - viewport.top()) / viewport.height());
		this.x2((this.x2() - viewport.left()) / viewport.width());
		this.y2((this.y2() - viewport.top()) / viewport.height());
	}

	, 
	getPointsOverride: function (points, settings) {
		var current = new $.ig.List$1($.ig.Point.prototype.$type, 0);
		points.add(current);
		current.add({__x: this.x1(), __y: this.y1(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
		current.add({__x: this.x2(), __y: this.y2(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
	}
	, 
	$type: new $.ig.Type('LineGeometryData', $.ig.GeometryData.prototype.$type)
}, true);

$.ig.util.defType('RectangleGeometryData', 'GeometryData', {
	init: function () {


		$.ig.GeometryData.prototype.init.call(this);

	}
	, 
	type: function () {

			return "Rectangle";
	}

	, 
	_x: 0,
	x: function (value) {
		if (arguments.length === 1) {
			this._x = value;
			return value;
		} else {
			return this._x;
		}
	}

	, 
	_y: 0,
	y: function (value) {
		if (arguments.length === 1) {
			this._y = value;
			return value;
		} else {
			return this._y;
		}
	}

	, 
	_width: 0,
	width: function (value) {
		if (arguments.length === 1) {
			this._width = value;
			return value;
		} else {
			return this._width;
		}
	}

	, 
	_height: 0,
	height: function (value) {
		if (arguments.length === 1) {
			this._height = value;
			return value;
		} else {
			return this._height;
		}
	}

	, 
	serializeOverride: function () {
		return "x: " + this.x() + ", y: " + this.y() + ", width: " + this.width() + ", height: " + this.height();
	}

	, 
	scaleByViewport: function (viewport) {
		this.x((this.x() - viewport.left()) / viewport.width());
		this.y((this.y() - viewport.top()) / viewport.height());
		this.width(this.width() / viewport.width());
		this.height(this.height() / viewport.height());
	}

	, 
	getPointsOverride: function (points, settings) {
		var current = new $.ig.List$1($.ig.Point.prototype.$type, 0);
		points.add(current);
		current.add({__x: this.x(), __y: this.y(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
		current.add({__x: this.x() + this.width(), __y: this.y(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
		current.add({__x: this.x() + this.width(), __y: this.y() + this.height(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
		current.add({__x: this.x(), __y: this.y() + this.height(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
	}
	, 
	$type: new $.ig.Type('RectangleGeometryData', $.ig.GeometryData.prototype.$type)
}, true);

$.ig.util.defType('EllipseGeometryData', 'GeometryData', {
	init: function () {


		$.ig.GeometryData.prototype.init.call(this);

	}
	, 
	type: function () {

			return "Ellipse";
	}

	, 
	_centerX: 0,
	centerX: function (value) {
		if (arguments.length === 1) {
			this._centerX = value;
			return value;
		} else {
			return this._centerX;
		}
	}

	, 
	_centerY: 0,
	centerY: function (value) {
		if (arguments.length === 1) {
			this._centerY = value;
			return value;
		} else {
			return this._centerY;
		}
	}

	, 
	_radiusX: 0,
	radiusX: function (value) {
		if (arguments.length === 1) {
			this._radiusX = value;
			return value;
		} else {
			return this._radiusX;
		}
	}

	, 
	_radiusY: 0,
	radiusY: function (value) {
		if (arguments.length === 1) {
			this._radiusY = value;
			return value;
		} else {
			return this._radiusY;
		}
	}

	, 
	serializeOverride: function () {
		return "centerX: " + this.centerX() + ", centerY: " + this.centerY() + ", radiusX: " + this.radiusX() + ", radiusY: " + this.radiusY();
	}

	, 
	scaleByViewport: function (viewport) {
		this.centerX((this.centerX() - viewport.left()) / viewport.width());
		this.centerX((this.centerY() - viewport.top()) / viewport.height());
		this.radiusX(this.radiusX() / viewport.width());
		this.radiusY(this.radiusY() / viewport.height());
	}

	, 
	getPointsOverride: function (points, settings) {
		var current = new $.ig.List$1($.ig.Point.prototype.$type, 0);
		points.add(current);
		current.add({__x: this.centerX(), __y: this.centerY(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
	}
	, 
	$type: new $.ig.Type('EllipseGeometryData', $.ig.GeometryData.prototype.$type)
}, true);

$.ig.util.defType('PathFigureData', 'Object', {
	init: function (initNumber) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.Object.prototype.init.call(this);
			this.segments(new $.ig.List$1($.ig.SegmentData.prototype.$type, 0));
			this.startPoint(new $.ig.Point(0));
	}
	, 
	init1: function (initNumber, fig) {


		$.ig.Object.prototype.init.call(this);
			this.segments(new $.ig.List$1($.ig.SegmentData.prototype.$type, 0));
			this.startPoint(fig.__startPoint);
			for (var i = 0; i < fig.__segments.count(); i++) {
				var seg = fig.__segments.__inner[i];
				var newData = null;
				switch (seg.type()) {
					case $.ig.PathSegmentType.prototype.line:
						newData = new $.ig.LineSegmentData(1, seg);
						break;
					case $.ig.PathSegmentType.prototype.polyLine:
						newData = new $.ig.PolylineSegmentData(1, seg);
						break;
					case $.ig.PathSegmentType.prototype.arc:
						newData = new $.ig.ArcSegmentData(1, seg);
						break;
					case $.ig.PathSegmentType.prototype.polyBezier:
						newData = new $.ig.PolyBezierSegmentData(1, seg);
						break;
				}

				this.segments().add(newData);
			}

	}

	, 
	_startPoint: null,
	startPoint: function (value) {
		if (arguments.length === 1) {
			this._startPoint = value;
			return value;
		} else {
			return this._startPoint;
		}
	}

	, 
	_segments: null,
	segments: function (value) {
		if (arguments.length === 1) {
			this._segments = value;
			return value;
		} else {
			return this._segments;
		}
	}

	, 
	serialize: function () {
		var sb = new $.ig.StringBuilder(0);
		sb.appendLine1("{");
		sb.appendLine1("startPoint: { x: " + this.startPoint().__x + ", y: " + this.startPoint().__y + "}, ");
		sb.appendLine1("segments: [");
		for (var i = 0; i < this.segments().count(); i++) {
			if (i != 0) {
				sb.append3(", ");
			}

			sb.append3(this.segments().__inner[i].serialize());
		}

		sb.appendLine1("]");
		sb.appendLine1("}");
		return sb.toString();
	}

	, 
	scaleByViewport: function (viewport) {
		this.startPoint({__x: (this.startPoint().__x - viewport.left()) / viewport.width(), __y: (this.startPoint().__y - viewport.top()) / viewport.height(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
		for (var i = 0; i < this.segments().count(); i++) {
			this.segments().__inner[i].scaleByViewport(viewport);
		}

	}

	, 
	getPointsOverride: function (points, settings) {
		var current = new $.ig.List$1($.ig.Point.prototype.$type, 0);
		points.add(current);
		if (!settings.ignoreFigureStartPoint()) {
			current.add({__x: this.startPoint().__x, __y: this.startPoint().__y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
		}

		for (var i = 0; i < this.segments().count(); i++) {
			this.segments().__inner[i].getPointsOverride(current, settings);
		}

	}
	, 
	$type: new $.ig.Type('PathFigureData', $.ig.Object.prototype.$type, [$.ig.IVisualData.prototype.$type])
}, true);

$.ig.util.defType('SegmentData', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	type: function () {
	}

	, 
	scaleByViewport: function (viewport) {}

	, 
	getPointsOverride: function (current, settings) {}

	, 
	serialize: function () {
		var sb = new $.ig.StringBuilder(0);
		sb.appendLine1("{");
		sb.appendLine1("type: \'" + this.type() + "\', ");
		sb.appendLine1(this.serializeOverride());
		sb.appendLine1("}");
		return sb.toString();
	}

	, 
	serializeOverride: function () {
		return "";
	}
	, 
	$type: new $.ig.Type('SegmentData', $.ig.Object.prototype.$type, [$.ig.IVisualData.prototype.$type])
}, true);

$.ig.util.defType('LineSegmentData', 'SegmentData', {
	init: function (initNumber) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.SegmentData.prototype.init.call(this);
			this.point(new $.ig.Point(0));
	}
	, 
	init1: function (initNumber, seg) {


		$.ig.SegmentData.prototype.init.call(this);
			this.point(seg.point());
	}

	, 
	type: function () {

			return "Line";
	}

	, 
	_point: null,
	point: function (value) {
		if (arguments.length === 1) {
			this._point = value;
			return value;
		} else {
			return this._point;
		}
	}

	, 
	serializeOverride: function () {
		return "point: { x: " + this.point().__x + ", y: " + this.point().__y + "}";
	}

	, 
	scaleByViewport: function (viewport) {
		this.point({__x: (this.point().__x - viewport.left()) / viewport.width(), __y: (this.point().__y - viewport.top()) / viewport.height(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
	}

	, 
	getPointsOverride: function (current, settings) {
		current.add({__x: this.point().__x, __y: this.point().__y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
	}
	, 
	$type: new $.ig.Type('LineSegmentData', $.ig.SegmentData.prototype.$type)
}, true);

$.ig.util.defType('PolylineSegmentData', 'SegmentData', {
	init: function (initNumber) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.SegmentData.prototype.init.call(this);
			this.points(new $.ig.List$1($.ig.Point.prototype.$type, 0));
	}
	, 
	init1: function (initNumber, poly) {


		$.ig.SegmentData.prototype.init.call(this);
			this.points(new $.ig.List$1($.ig.Point.prototype.$type, 0));
			for (var i = 0; i < poly.__points.count(); i++) {
				this.points().add(poly.__points.__inner[i]);
			}

	}

	, 
	type: function () {

			return "Polyline";
	}

	, 
	_points: null,
	points: function (value) {
		if (arguments.length === 1) {
			this._points = value;
			return value;
		} else {
			return this._points;
		}
	}

	, 
	serializeOverride: function () {
		var sb = new $.ig.StringBuilder(0);
		sb.appendLine1("points: [");
		for (var i = 0; i < this.points().count(); i++) {
			if (i != 0) {
				sb.append3(", ");
			}

			sb.append3("{ x: " + this.points().__inner[i].__x + ", y: " + this.points().__inner[i].__y + "}");
		}

		sb.appendLine1("]");
		return sb.toString();
	}

	, 
	scaleByViewport: function (viewport) {
		for (var i = 0; i < this.points().count(); i++) {
			this.points().__inner[i] = {__x: (this.points().__inner[i].__x - viewport.left()) / viewport.width(), __y: (this.points().__inner[i].__y - viewport.top()) / viewport.height(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		}

	}

	, 
	getPointsOverride: function (current, settings) {
		for (var i = 0; i < this.points().count(); i++) {
			current.add({__x: this.points().__inner[i].__x, __y: this.points().__inner[i].__y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
		}

	}
	, 
	$type: new $.ig.Type('PolylineSegmentData', $.ig.SegmentData.prototype.$type)
}, true);

$.ig.util.defType('PolyBezierSegmentData', 'SegmentData', {
	init: function (initNumber) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.SegmentData.prototype.init.call(this);
			this.points(new $.ig.List$1($.ig.Point.prototype.$type, 0));
	}
	, 
	init1: function (initNumber, poly) {


		$.ig.SegmentData.prototype.init.call(this);
			this.points(new $.ig.List$1($.ig.Point.prototype.$type, 0));
			for (var i = 0; i < poly.points().count(); i++) {
				this.points().add(poly.points().__inner[i]);
			}

	}

	, 
	type: function () {

			return "PolyBezierSpline";
	}

	, 
	_points: null,
	points: function (value) {
		if (arguments.length === 1) {
			this._points = value;
			return value;
		} else {
			return this._points;
		}
	}

	, 
	serializeOverride: function () {
		var sb = new $.ig.StringBuilder(0);
		sb.appendLine1("points: [");
		for (var i = 0; i < this.points().count(); i++) {
			if (i != 0) {
				sb.append3(", ");
			}

			sb.append3("{ x: " + this.points().__inner[i].__x + ", y: " + this.points().__inner[i].__y + "}");
		}

		sb.appendLine1("]");
		return sb.toString();
	}

	, 
	scaleByViewport: function (viewport) {
		for (var i = 0; i < this.points().count(); i++) {
			this.points().__inner[i] = {__x: (this.points().__inner[i].__x - viewport.left()) / viewport.width(), __y: (this.points().__inner[i].__y - viewport.top()) / viewport.height(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		}

	}

	, 
	getPointsOverride: function (current, settings) {
		for (var i = 0; i < this.points().count(); i++) {
			current.add({__x: this.points().__inner[i].__x, __y: this.points().__inner[i].__y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
		}

	}
	, 
	$type: new $.ig.Type('PolyBezierSegmentData', $.ig.SegmentData.prototype.$type)
}, true);

$.ig.util.defType('ArcSegmentData', 'SegmentData', {
	init: function (initNumber) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.SegmentData.prototype.init.call(this);
			this.point(new $.ig.Point(0));
			this.isLargeArc(false);
			this.isCounterClockwise(true);
			this.rotationAngle(0);
	}
	, 
	init1: function (initNumber, arc) {


		$.ig.SegmentData.prototype.init.call(this);
			this.point(arc.point());
			this.isLargeArc(arc.isLargeArc());
			this.isCounterClockwise(arc.sweepDirection() == $.ig.SweepDirection.prototype.counterclockwise);
			this.sizeX(arc.size().width());
			this.sizeY(arc.size().height());
			this.rotationAngle(arc.rotationAngle());
	}

	, 
	type: function () {

			return "Arc";
	}

	, 
	_point: null,
	point: function (value) {
		if (arguments.length === 1) {
			this._point = value;
			return value;
		} else {
			return this._point;
		}
	}

	, 
	_isLargeArc: false,
	isLargeArc: function (value) {
		if (arguments.length === 1) {
			this._isLargeArc = value;
			return value;
		} else {
			return this._isLargeArc;
		}
	}

	, 
	_isCounterClockwise: false,
	isCounterClockwise: function (value) {
		if (arguments.length === 1) {
			this._isCounterClockwise = value;
			return value;
		} else {
			return this._isCounterClockwise;
		}
	}

	, 
	_sizeX: 0,
	sizeX: function (value) {
		if (arguments.length === 1) {
			this._sizeX = value;
			return value;
		} else {
			return this._sizeX;
		}
	}

	, 
	_sizeY: 0,
	sizeY: function (value) {
		if (arguments.length === 1) {
			this._sizeY = value;
			return value;
		} else {
			return this._sizeY;
		}
	}

	, 
	_rotationAngle: 0,
	rotationAngle: function (value) {
		if (arguments.length === 1) {
			this._rotationAngle = value;
			return value;
		} else {
			return this._rotationAngle;
		}
	}

	, 
	serializeOverride: function () {
		return "point: { x: " + this.point().__x + ", y: " + this.point().__y + " }, isLargeArc: " + (this.isLargeArc() ? "true" : "false") + ", isCounterClockwise: " + (this.isCounterClockwise() ? "true" : "false") + ", sizeX: " + this.sizeX() + ", sizeY: " + this.sizeY() + ", rotationAngle: " + this.rotationAngle();
	}

	, 
	scaleByViewport: function (viewport) {
		this.point({__x: (this.point().__x - viewport.left()) / viewport.width(), __y: (this.point().__y - viewport.top()) / viewport.height(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
		this.sizeX(this.sizeX() / viewport.width());
		this.sizeY(this.sizeY() / viewport.height());
	}

	, 
	getPointsOverride: function (current, settings) {
		current.add({__x: this.point().__x, __y: this.point().__y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
	}
	, 
	$type: new $.ig.Type('ArcSegmentData', $.ig.SegmentData.prototype.$type)
}, true);

$.ig.util.defType('AppearanceHelper', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	fromBrush: function (b) {
		if (b == null) {
			return $.ig.Color.prototype.fromArgb(0, 0, 0, 0);
		}

		if ($.ig.Color.prototype.l_op_Equality_Lifted($.ig.util.toNullable($.ig.Color.prototype.$type, b.color()), $.ig.util.toNullable($.ig.Color.prototype.$type, null))) {
			return $.ig.Color.prototype.fromArgb(0, 0, 0, 0);
		}

		return b.color();
	}

	, 
	fromBrushExtended: function (b) {
		if (b == null) {
			return null;
		}

		if (b._isGradient) {
			var linear = new $.ig.LinearGradientBrushAppearanceData();
			var inLinear = b;
			linear.startX(inLinear._startX);
			linear.startY(inLinear._startY);
			linear.endX(inLinear._endX);
			linear.endY(inLinear._endY);
			for (var i = 0; i < inLinear._gradientStops.length; i++) {
				var stop = inLinear._gradientStops[i];
				var newStop = new $.ig.GradientStopAppearanceData();
				newStop.colorValue(stop.color());
				newStop.offset(stop._offset);
				linear.stops().add(newStop);
			}

			return linear;

		} else if (b._isRadialGradient) {
			return null;

		} else {
			var solid = new $.ig.SolidBrushAppearanceData();
			solid.colorValue(b.color());
			return solid;
		}


		return null;
	}

	, 
	getCanvasLeft: function (line) {
		return line.canvasLeft();
	}

	, 
	getCanvasTop: function (line) {
		return line.canvasTop();
	}

	, 
	getCanvasZIndex: function (line) {
		return line.canvasZIndex();
	}

	, 
	fromPathData: function (path) {
		return $.ig.AppearanceHelper.prototype.fromGeometry(path.data());
	}

	, 
	fromGeometry: function (data) {
		if (data == null) {
			return new $.ig.List$1($.ig.GeometryData.prototype.$type, 0);
		}

		if ($.ig.util.cast($.ig.GeometryGroup.prototype.$type, data) !== null) {
			var ret = new $.ig.List$1($.ig.GeometryData.prototype.$type, 0);
			var group = data;
			for (var i = 0; i < group.children().count(); i++) {
				var items = $.ig.AppearanceHelper.prototype.fromGeometry(group.children().__inner[i]);
				for (var j = 0; j < items.count(); j++) {
					ret.add(items.__inner[j]);
				}

			}

			return ret;

		} else if ($.ig.util.cast($.ig.PathGeometry.prototype.$type, data) !== null) {
			return $.ig.AppearanceHelper.prototype.fromPathGeometry(data);

		} else if ($.ig.util.cast($.ig.LineGeometry.prototype.$type, data) !== null) {
			return $.ig.AppearanceHelper.prototype.fromLineGeometry(data);

		} else if ($.ig.util.cast($.ig.RectangleGeometry.prototype.$type, data) !== null) {
			return $.ig.AppearanceHelper.prototype.fromRectangleGeometry(data);

		} else if ($.ig.util.cast($.ig.EllipseGeometry.prototype.$type, data) !== null) {
			return $.ig.AppearanceHelper.prototype.fromEllipseGeometry(data);

		} else {
			throw new $.ig.Error(1, "not supported");
		}





	}

	, 
	fromEllipseGeometry: function (ellipseGeometry) {
		var ret = new $.ig.List$1($.ig.GeometryData.prototype.$type, 0);
		var newData = new $.ig.EllipseGeometryData();
		ret.add(newData);
		newData.centerX(ellipseGeometry.center().__x);
		newData.centerY(ellipseGeometry.center().__y);
		newData.radiusX(ellipseGeometry.radiusX());
		newData.radiusY(ellipseGeometry.radiusY());
		return ret;
	}

	, 
	fromRectangleGeometry: function (rectangleGeometry) {
		var ret = new $.ig.List$1($.ig.GeometryData.prototype.$type, 0);
		var newData = new $.ig.RectangleGeometryData();
		ret.add(newData);
		newData.x(rectangleGeometry.rect().x());
		newData.y(rectangleGeometry.rect().y());
		newData.width(rectangleGeometry.rect().width());
		newData.height(rectangleGeometry.rect().height());
		return ret;
	}

	, 
	fromLineGeometry: function (lineGeometry) {
		var ret = new $.ig.List$1($.ig.GeometryData.prototype.$type, 0);
		var newData = new $.ig.LineGeometryData();
		ret.add(newData);
		newData.x1(lineGeometry.startPoint().__x);
		newData.y1(lineGeometry.startPoint().__y);
		newData.x2(lineGeometry.endPoint().__x);
		newData.y2(lineGeometry.endPoint().__y);
		return ret;
	}

	, 
	fromPathGeometry: function (pathGeometry) {
		var ret = new $.ig.List$1($.ig.GeometryData.prototype.$type, 0);
		var newData = new $.ig.PathGeometryData();
		ret.add(newData);
		for (var i = 0; i < pathGeometry.figures().count(); i++) {
			var figure = pathGeometry.figures().__inner[i];
			var f = new $.ig.PathFigureData(1, figure);
			newData.figures().add(f);
		}

		return ret;
	}

	, 
	getShapeAppearance: function (appearance, path) {
		appearance.stroke($.ig.AppearanceHelper.prototype.fromBrush(path.__stroke));
		appearance.fill($.ig.AppearanceHelper.prototype.fromBrush(path.__fill));
		appearance.strokeExtended($.ig.AppearanceHelper.prototype.fromBrushExtended(path.__stroke));
		appearance.fillExtended($.ig.AppearanceHelper.prototype.fromBrushExtended(path.__fill));
		appearance.strokeThickness(path.strokeThickness());
		appearance.dashArray(null);
		if (path.strokeDashArray() != null) {
			appearance.dashArray(path.strokeDashArray().asArray());
		}

		appearance.dashCap(path.strokeDashCap());
		appearance.visibility(path.__visibility);
		appearance.opacity(path.__opacity);
		appearance.canvasLeft($.ig.AppearanceHelper.prototype.getCanvasLeft(path));
		appearance.canvasTop($.ig.AppearanceHelper.prototype.getCanvasTop(path));
		appearance.canvaZIndex($.ig.AppearanceHelper.prototype.getCanvasZIndex(path));
	}

	, 
	fromTextElement: function (frameworkElement, fontInfo) {
		var lad = new $.ig.LabelAppearanceData();
		var tb = frameworkElement;
		lad.text(tb.text());
		lad.labelBrush($.ig.AppearanceHelper.prototype.fromBrush(tb.fill()));
		lad.labelBrushExtended($.ig.AppearanceHelper.prototype.fromBrushExtended(tb.fill()));
		lad.visibility((tb.__visibility == $.ig.Visibility.prototype.visible) ? true : false);
		lad.opacity(tb.__opacity);
		if (fontInfo.fontFamily() != null) {
			lad.fontFamily(fontInfo.fontFamily());
		}

		if (!$.ig.util.isNaN(fontInfo.fontSize())) {
			lad.fontSize(fontInfo.fontSize());
		}

		if (fontInfo.fontWeight() != null) {
			lad.fontWeight(fontInfo.fontWeight());
		}

		if (fontInfo.fontStyle() != null) {
			lad.fontStyle(fontInfo.fontStyle());
		}

		if (fontInfo.fontStretch() != null) {
			lad.fontStretch(fontInfo.fontStyle());
		}

		var angle = 0;
		var xForm = tb.renderTransform();
		if ($.ig.util.cast($.ig.RotateTransform.prototype.$type, xForm) !== null) {
			var rt = $.ig.util.cast($.ig.RotateTransform.prototype.$type, xForm);
			angle = rt.angle();

		} else if ($.ig.util.cast($.ig.TransformGroup.prototype.$type, xForm) !== null) {
			var tg = $.ig.util.cast($.ig.TransformGroup.prototype.$type, xForm);
			var en = tg.children().getEnumerator();
			while (en.moveNext()) {
				var child = en.current();
				if ($.ig.util.cast($.ig.RotateTransform.prototype.$type, child) !== null) {
					var rt1 = $.ig.util.cast($.ig.RotateTransform.prototype.$type, child);
					angle = rt1.angle();
					break;
				}

			}

		}


		lad.angle(angle);
		return lad;
	}

	, 
	serializeColor: function (color) {
		return "{ r: " + color.r() + ", g: " + color.g() + ", b: " + color.b() + ", a: " + color.a() + "}";
	}

	, 
	serializeItems: function (sb, name, items, isFirst) {
		if (items != null) {
			if (!isFirst) {
			sb.append3(", ");
			}

			sb.append3(name);
			sb.append3(": [");
			var addedFirst = false;
			var en = items.getEnumerator();
			while (en.moveNext()) {
				var item = en.current();
				if (addedFirst) {
				sb.appendLine1(", ");

				} else {
				addedFirst = true;
				}

				sb.append3(item.serialize());
			}

			sb.appendLine1("]");
			return true;
		}

		return false;
	}

	, 
	serializeItem: function (sb, name, item, isFirst) {
		if (item != null) {
			if (!isFirst) {
			sb.append3(", ");
			}

			sb.append3(name);
			sb.append3(": ");
			sb.appendLine1(item.serialize());
			return true;
		}

		return false;
	}
	, 
	$type: new $.ig.Type('AppearanceHelper', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('EventProxy', 'Object', {
	init: function () {

		this.__isInteractionDisabled = false;

		$.ig.Object.prototype.init.call(this);

	}, 
	onMouseWheel: null, 
	onPinchStarted: null, 
	onPinchDelta: null, 
	onGestureCompleted: null, 
	onContactStarted: null, 
	onDragStarted: null, 
	onContactMoved: null, 
	onDragDelta: null, 
	onContactCompleted: null, 
	onDragCompleted: null, 
	onMouseLeave: null, 
	onMouseOver: null, 
	onMouseEnter: null, 
	onMouseDown: null, 
	onMouseUp: null, 
	onDoubleTap: null, 
	onHold: null, 
	onKeyDown: null, 
	onKeyUp: null
	, 
	_viewport: null,
	viewport: function (value) {
		if (arguments.length === 1) {
			this._viewport = value;
			return value;
		} else {
			return this._viewport;
		}
	}

	, 
	_currentModifiers: 0,
	currentModifiers: function (value) {
		if (arguments.length === 1) {
			this._currentModifiers = value;
			return value;
		} else {
			return this._currentModifiers;
		}
	}

	, 
	_rightButton: false,
	rightButton: function (value) {
		if (arguments.length === 1) {
			this._rightButton = value;
			return value;
		} else {
			return this._rightButton;
		}
	}

	, 
	_shouldInteract: null,
	shouldInteract: function (value) {
		if (arguments.length === 1) {
			this._shouldInteract = value;
			return value;
		} else {
			return this._shouldInteract;
		}
	}

	, 
	clone: function () {}

	, 
	destroy: function () {}

	, 
	raiseOnMouseWheel: function (point, delta) {
		if (this.onMouseWheel != null && !this.isInteractionDisabled()) {
			return this.onMouseWheel(point, delta);
		}

		return false;
	}

	, 
	raiseOnPinchStarted: function (point, scale) {
		if (this.onPinchStarted != null && !this.isInteractionDisabled()) {
			this.onPinchStarted(point, scale);
		}

	}

	, 
	raiseOnPinchDelta: function (point, scale) {
		if (this.onPinchDelta != null && !this.isInteractionDisabled()) {
			this.onPinchDelta(point, scale);
		}

	}

	, 
	raiseOnGestureCompleted: function (point, scale) {
		if (this.onGestureCompleted != null && !this.isInteractionDisabled()) {
			this.onGestureCompleted(point, scale);
		}

	}

	, 
	raiseOnContactStarted: function (point, isFinger) {
		if (this.onContactStarted != null && !this.isInteractionDisabled()) {
			this.onContactStarted(point, isFinger);
		}

	}

	, 
	raiseOnDragStarted: function (point) {
		if (this.onDragStarted != null && !this.isInteractionDisabled()) {
			this.onDragStarted(point);
		}

	}

	, 
	raiseOnContactMoved: function (point, isFinger) {
		if (this.onContactMoved != null && !this.isInteractionDisabled()) {
			this.onContactMoved(point, isFinger);
		}

	}

	, 
	raiseOnDragDelta: function (point) {
		if (this.onDragDelta != null && !this.isInteractionDisabled()) {
			this.onDragDelta(point);
		}

	}

	, 
	raiseOnContactCompleted: function (point, isFinger) {
		if (this.onContactCompleted != null && !this.isInteractionDisabled()) {
			this.onContactCompleted(point, isFinger);
		}

	}

	, 
	raiseOnDragCompleted: function (point) {
		if (this.onDragCompleted != null && !this.isInteractionDisabled()) {
			this.onDragCompleted(point);
		}

	}

	, 
	raiseOnMouseLeave: function (point) {
		if (this.onMouseLeave != null && !this.isInteractionDisabled()) {
			this.onMouseLeave(point);
		}

	}

	, 
	raiseOnMouseOver: function (point, onMouseMove, isFinger) {
		if (this.onMouseOver != null && !this.isInteractionDisabled()) {
			this.onMouseOver(point, onMouseMove, isFinger);
		}

	}

	, 
	raiseOnMouseEnter: function (point) {
		if (this.onMouseEnter != null && !this.isInteractionDisabled()) {
			this.onMouseEnter(point);
		}

	}

	, 
	raiseOnMouseDown: function (point) {
		if (this.onMouseDown != null && !this.isInteractionDisabled()) {
			this.onMouseDown(point);
		}

	}

	, 
	raiseOnMouseUp: function (point) {
		if (this.onMouseUp != null && !this.isInteractionDisabled()) {
			this.onMouseUp(point);
		}

	}

	, 
	raiseOnKeyDown: function (key) {
		if (this.onKeyDown != null && !this.isInteractionDisabled()) {
			return this.onKeyDown(key);
		}

		return false;
	}

	, 
	raiseOnKeyUp: function (key) {
		if (this.onKeyUp != null && !this.isInteractionDisabled()) {
			return this.onKeyUp(key);
		}

		return false;
	}

	, 
	raiseOnDoubleTap: function (point) {
		if (this.onDoubleTap != null && !this.isInteractionDisabled()) {
			this.onDoubleTap(point);
		}

	}

	, 
	raiseOnHold: function (point) {
		if (this.onHold != null && !this.isInteractionDisabled()) {
			this.onHold(point);
		}

	}

	, 
	getSourceOffsets: function () {}
	, 
	__isInteractionDisabled: false

	, 
	isInteractionDisabled: function (value) {
		if (arguments.length === 1) {

			this.__isInteractionDisabled = value;
			this.onIsInteractionDisabledChanged();
			return value;
		} else {

			return this.__isInteractionDisabled;
		}
	}

	, 
	_deferredTouchStartMode: false,
	deferredTouchStartMode: function (value) {
		if (arguments.length === 1) {
			this._deferredTouchStartMode = value;
			return value;
		} else {
			return this._deferredTouchStartMode;
		}
	}

	, 
	_shouldInteractForDirection: null,
	shouldInteractForDirection: function (value) {
		if (arguments.length === 1) {
			this._shouldInteractForDirection = value;
			return value;
		} else {
			return this._shouldInteractForDirection;
		}
	}

	, 
	onIsInteractionDisabledChanged: function () {
	}

	, 
	bindToSource: function (source, sourceId) {}

	, 
	unbindFromSource: function (source, sourceId) {}
	, 
	$type: new $.ig.Type('EventProxy', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('DOMEventProxy', 'EventProxy', {

	_eventSource: null,
	eventSource: function (value) {
		if (arguments.length === 1) {
			this._eventSource = value;
			return value;
		} else {
			return this._eventSource;
		}
	}

	, 
	clone: function () {
		var ret = new $.ig.DOMEventProxy(this.eventSource());
		ret.deferredTouchStartMode(this.deferredTouchStartMode());
		return ret;
	}

	, 
	preventDefault: function (e) {
		if (!this.isInteractionDisabled()) {
			e.preventDefault();
		}

	}
	, 
	__proxyID: 0
	, 
	__eventNS: null
	, 
	__pinching: false

	, 
	_mGesture: null,
	mGesture: function (value) {
		if (arguments.length === 1) {
			this._mGesture = value;
			return value;
		} else {
			return this._mGesture;
		}
	}
	, 
	init: function (DOMEventSource) {


		this.__proxyID = 0;
		this.__eventNS = "";
		this.__pinching = false;
		this.__touchCaptureEnabled = false;
		this.__mouseX = 0;
		this.__mouseY = 0;
		this.__containerMouseX = 0;
		this.__containerMouseY = 0;
		this.__numTouches = 0;
		this.__lastScale = 1;
		this.__touchStartDeferrred = false;
		this.__holdId = $.ig.DOMEventProxy.prototype._nullTimer;
		this.__suppressId = $.ig.DOMEventProxy.prototype._nullTimer;
		this.__tapArea = null;
		this.__holdStartX = 0;
		this.__holdStartY = 0;
		this.__holdCancelDistance = 5;
		this.__dragging = false;
		this.__dragStart = null;
		this.__suppressMouseEvents = false;
		this.__mouseCaptured = false;

		var $self = this;
		$.ig.EventProxy.prototype.init.call(this);
			this.shouldInteractForDirection(function (p) { return true; });
			this.deferredTouchStartMode(false);
			$.ig.DOMEventProxy.prototype.__proxyCount++;
			this.__proxyID = $.ig.DOMEventProxy.prototype.__proxyCount;
			this.__eventNS = ".DOMProxy" + this.__proxyID.toString();
			this.currentModifiers($.ig.ModifierKeys.prototype.none);
			this.eventSource(DOMEventSource);
			$.ig.DOMEventProxy.prototype.mSPointerEnabled = false;
			try {
					$.ig.DOMEventProxy.prototype.mSPointerEnabled = window.navigator.msPointerEnabled && MSGesture !== undefined;

			}
			catch (e) {

			}
			$.ig.DOMEventProxy.prototype.pointerEnabled = false;
			try {
					$.ig.DOMEventProxy.prototype.pointerEnabled = window.navigator.pointerEnabled;

			}
			catch (e1) {

			}
			$.ig.DOMEventProxy.prototype.tridentVersion = this.getTridentVersion();
			this.bindToSource(this.eventSource(), "");
			this.shouldInteract(function (p) { return true; });
	}

	, 
	bindToSource: function (objSource, sourceID) {
		var source = objSource;
		var ns = this.__eventNS + sourceID;
		if (!$.ig.DOMEventProxy.prototype.mSPointerEnabled) {
			source.bind("mousemove" + ns, this.canvasMouseMove.runOn(this));
			source.bind("mouseleave" + ns, this.canvasMouseLeave.runOn(this));
			source.bind("mousedown" + ns, this.canvasMouseDown.runOn(this));
			source.bind("mouseup" + ns, this.canvasMouseUp.runOn(this));
			$(window).bind("mouseup" + ns, this.windowMouseUp.runOn(this));
		}

		source.bind("keydown" + ns, this.canvasKeyDown.runOn(this));
		source.bind("keyup" + ns, this.canvasKeyUp.runOn(this));
		if ($.ig.DOMEventProxy.prototype.mSPointerEnabled) {
			var source_ = this.eventSource()[0];
			$.ig.DOMEventProxy.prototype.grabTouches(source_);
			var container = this.eventSource()[0];
			var gesture = new MSGesture();
			gesture.target = container;
			this.mGesture(gesture);
			source.bind("MSGestureStart" + ns, this.canvasGestureStart.runOn(this));
			source.bind("MSGestureChange" + ns, this.canvasGestureChange.runOn(this));
			source.bind("MSGestureEnd" + ns, this.canvasGestureEnd.runOn(this));
			if ($.ig.DOMEventProxy.prototype.pointerEnabled) {
				source.bind("pointerdown" + ns, this.canvasMSPointerDown.runOn(this));
				source.bind("pointerup" + ns, this.canvasMSPointerUp.runOn(this));
				source.bind("pointercancel" + ns, this.canvasMSPointerCancel.runOn(this));
				source.bind("pointermove" + ns, this.canvasMSPointerMove.runOn(this));
				source.bind("pointerout" + ns, this.canvasMSPointerOut.runOn(this));
				source.bind("lostpointercapture" + ns, this.canvasMSLostPointerCapture.runOn(this));

			} else {
				source.bind("MSPointerDown" + ns, this.canvasMSPointerDown.runOn(this));
				source.bind("MSPointerUp" + ns, this.canvasMSPointerUp.runOn(this));
				source.bind("MSPointerCancel" + ns, this.canvasMSPointerCancel.runOn(this));
				source.bind("MSPointerMove" + ns, this.canvasMSPointerMove.runOn(this));
				source.bind("MSPointerOut" + ns, this.canvasMSPointerOut.runOn(this));
				source.bind("MSLostPointerCapture" + ns, this.canvasMSLostPointerCapture.runOn(this));
			}

		}

		source.bind("DOMMouseScroll" + ns, this.canvasMouseScroll.runOn(this));
		source.bind("mousewheel" + ns, this.canvasMouseScroll.runOn(this));
		source.bind("gesturestart" + ns, this.canvasGestureStart.runOn(this));
		source.bind("gesturechange" + ns, this.canvasGestureChange.runOn(this));
		source.bind("gestureend" + ns, this.canvasGestureEnd.runOn(this));
		source.bind("touchstart" + ns, this.canvasTouchStart.runOn(this));
		source.bind("touchmove" + ns, this.canvasTouchMove.runOn(this));
		source.bind("touchend" + ns, this.canvasTouchEnd.runOn(this));
	}
	, 
	__touchCaptureEnabled: false

	, 
	enableTouchCapture: function () {
		if ($.ig.DOMEventProxy.prototype.mSPointerEnabled && !this.__touchCaptureEnabled) {
			var source_ = this.eventSource()[0];
			$.ig.DOMEventProxy.prototype.grabTouches(source_);
		}

	}

	, 
	grabTouches: function (source_) {
		if ($.ig.DOMEventProxy.prototype.pointerEnabled) {
			source_.style.touchAction = 'none';

		} else {
			source_.style.msTouchAction = 'none';
		}

		source_.style.msUserSelect = 'none';
	}

	, 
	deferTouches: function (source_) {
		if ($.ig.DOMEventProxy.prototype.pointerEnabled) {
			source_.style.touchAction = 'auto';

		} else {
			source_.style.msTouchAction = 'auto';
		}

		source_.style.msUserSelect = 'auto';
	}

	, 
	disableTouchCapture: function () {
		if ($.ig.DOMEventProxy.prototype.mSPointerEnabled && this.__touchCaptureEnabled) {
			var source_ = this.eventSource()[0];
			$.ig.DOMEventProxy.prototype.deferTouches(source_);
		}

	}

	, 
	onIsInteractionDisabledChanged: function () {
		$.ig.EventProxy.prototype.onIsInteractionDisabledChanged.call(this);
		if (!this.isInteractionDisabled()) {
			this.enableTouchCapture();

		} else {
			this.disableTouchCapture();
		}

	}

	, 
	getTridentVersion: function () {
		var ver_ = -1;
		var matchIE_ = /Trident\/([\d.]+)/;
		if (matchIE_.exec(navigator.userAgent) != null) {
			ver_ = parseFloat(RegExp.$1);
		}

		return ver_;
	}
	, 
	__mouseX: 0
	, 
	__mouseY: 0
	, 
	__containerMouseX: 0
	, 
	__containerMouseY: 0
	, 
	__numTouches: 0

	, 
	_mousePoint: null,
	mousePoint: function (value) {
		if (arguments.length === 1) {
			this._mousePoint = value;
			return value;
		} else {
			return this._mousePoint;
		}
	}

	, 
	_containerMousePoint: null,
	containerMousePoint: function (value) {
		if (arguments.length === 1) {
			this._containerMousePoint = value;
			return value;
		} else {
			return this._containerMousePoint;
		}
	}

	, 
	fixEvent: function (e_) {
		var ieHack = $.ig.DOMEventProxy.prototype.tridentVersion >= 6;
		var oe_ = e_.originalEvent;
		if (((typeof e_.pageX == 'undefined') || ieHack) && oe_.clientX != null) {
			var od_ = e_.target.ownerDocument;
			var ed_ = od_ ? od_ : document;
			var doc_ = ed_.documentElement;
			var body_ = ed_.body;
			var clientX_ = oe_.clientX;
			var clientY_ = oe_.clientY;
			var scrollLeft_ = doc_ && doc_.scrollLeft || body_ && body_.scrollLeft || 0;
			var scrollTop_ = doc_ && doc_.scrollTop || body_ && body_.scrollTop || 0;
			var clientLeft_ = doc_ && doc_.clientLeft || body_ && body_.clientLeft || 0;
			var clientTop_ = doc_ && doc_.clientTop || body_ && body_.clientTop || 0;
			e_.pageX = clientX_ + (scrollLeft_ - clientLeft_);
			e_.pageY = clientY_ + (scrollTop_ - clientTop_);
		}

	}

	, 
	getOffset: function (source) {
		var ieHack = $.ig.DOMEventProxy.prototype.tridentVersion >= 6;
		var source_ = source[0];
		var d_ = source_.ownerDocument;
		var doc_ = d_ ? d_.documentElement : null;
		var z_ = doc_ ? doc_.msContentZoomFactor : null;
		var body_ = doc_.body;
		if (z_ && z_ > 1 || ieHack) {
			var rect_ = source_.getBoundingClientRect();
			var x_ = rect_.left;
			var y_ = rect_.top;
			var scrollLeft_ = doc_ && doc_.scrollLeft || body_ && body_.scrollLeft || 0;
			var scrollTop_ = doc_ && doc_.scrollTop || body_ && body_.scrollTop || 0;
			var clientLeft_ = doc_ && doc_.clientLeft || body_ && body_.clientLeft || 0;
			var clientTop_ = doc_ && doc_.clientTop || body_ && body_.clientTop || 0;
			var left = x_ + scrollLeft_ - clientLeft_;
			var top = y_ + scrollTop_ - clientTop_;
			return new $.ig.Rect(0, left, top, 0, 0);

		} else {
			var offset = source.offset();
			return new $.ig.Rect(0, offset.left, offset.top, 0, 0);
		}

	}

	, 
	updateMousePosition: function (e) {
		$.ig.DOMEventProxy.prototype.fixEvent(e);
		var offset = $.ig.DOMEventProxy.prototype.getOffset(this.eventSource());
		this.__mouseX = e.pageX - offset.left();
		this.__mouseY = e.pageY - offset.top();
		this.__containerMouseX = this.__mouseX - this.viewport().left();
		this.__containerMouseY = this.__mouseY - this.viewport().top();
		this.mousePoint({__x: this.__mouseX, __y: this.__mouseY, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
		this.containerMousePoint({__x: this.__containerMouseX, __y: this.__containerMouseY, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
	}

	, 
	updateTouchPosition: function (e_) {
		$.ig.DOMEventProxy.prototype.fixEvent(e_);
		if ($.ig.DOMEventProxy.prototype.mSPointerEnabled) {
			var pageX = e_.pageX;
			var pageY = e_.pageY;
			var offset = $.ig.DOMEventProxy.prototype.getOffset(this.eventSource());
			this.__mouseX = pageX - offset.left();
			this.__mouseY = pageY - offset.top();

		} else {
			this.__numTouches = 0;
			if (!e_.originalEvent.targetTouches || e_.originalEvent.targetTouches.length < 1) { return; };
			this.__numTouches = e_.originalEvent.targetTouches.length;
			var pageX1 = e_.originalEvent.targetTouches[0].pageX;
			var pageY1 = e_.originalEvent.targetTouches[0].pageY;
			var offset1 = $.ig.DOMEventProxy.prototype.getOffset(this.eventSource());
			this.__mouseX = pageX1 - offset1.left();
			this.__mouseY = pageY1 - offset1.top();
		}

		this.__containerMouseX = this.__mouseX - this.viewport().left();
		this.__containerMouseY = this.__mouseY - this.viewport().top();
		this.mousePoint({__x: this.__mouseX, __y: this.__mouseY, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
		this.containerMousePoint({__x: this.__containerMouseX, __y: this.__containerMouseY, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
	}

	, 
	canvasMouseScroll: function (e_) {
		this.updateModifiers(e_);
		if (this.shouldInteract()(this.mousePoint())) {
			var delta_ = 0;
			if (e_.wheelDelta) { delta_ = e_.wheelDelta/120; };
			if (e_.originalEvent && e_.originalEvent.wheelDelta) { delta_ = e_.originalEvent.wheelDelta/120; };
			if (e_.detail) { delta_ = -e_.detail/3; };
			if (e_.originalEvent && e_.originalEvent.detail) { delta_ = -e_.originalEvent.detail/3; };
			delta_ = delta_ / 10;
			var handled = this.raiseOnMouseWheel(this.containerMousePoint(), delta_);
			if (handled) {
				this.preventDefault(e_);
			}

		}

	}
	, 
	__lastScale: 0

	, 
	canvasMSPointerUp: function (e_) {
		var isFinger = this.isFinger(e_);
		if (isFinger) {
			this.__numTouches--;
			if (this.__numTouches < 0) {
				this.__numTouches = 0;
			}

		}

		if (this.__numTouches < 2 && this.__pinching && isFinger) {
			this.__pinching = false;
			var scale = e_.originalEvent.scale;
			this.raiseOnGestureCompleted(this.containerMousePoint(), scale);

		} else {
			if (isFinger) {
				this.canvasTouchEnd(e_);

			} else {
				this.canvasMouseUp(e_);
			}

		}

	}

	, 
	canvasMSLostPointerCapture: function (e_) {
		var isFinger = this.isFinger(e_);
		if (isFinger) {
			this.__numTouches--;
			if (this.__numTouches < 0) {
				this.__numTouches = 0;
			}

		}

		if (this.__numTouches < 2 && this.__pinching && isFinger) {
			this.__pinching = false;
			var scale = e_.originalEvent.scale;
			this.raiseOnGestureCompleted(this.containerMousePoint(), scale);
		}

	}

	, 
	canvasMSPointerCancel: function (e_) {
		var isFinger = this.isFinger(e_);
		if (isFinger) {
			this.__numTouches--;
			if (this.__numTouches < 0) {
				this.__numTouches = 0;
			}

		}

		if (this.__numTouches < 2 && this.__pinching && isFinger) {
			this.__pinching = false;
			var scale = e_.originalEvent.scale;
			this.raiseOnGestureCompleted(this.containerMousePoint(), scale);
		}

	}

	, 
	canvasMSPointerDown: function (e_) {
		var isFinger = this.isFinger(e_);
		if (this.mGesture() != null && isFinger) {
			this.__numTouches++;
			this.mGesture().addPointer(e_.originalEvent.pointerId);
		}

		var eventSource_ = this.eventSource()[0];
		if ($.ig.DOMEventProxy.prototype.pointerEnabled) {
			eventSource_.setPointerCapture(e_.originalEvent.pointerId);

		} else {
			eventSource_.msSetPointerCapture(e_.originalEvent.pointerId);
		}

		if (this.__numTouches > 1 && !this.__pinching && isFinger) {
			this.__pinching = true;
			this.updateTouchPosition(e_);
			var scale = e_.originalEvent.scale;
			this.raiseOnPinchStarted(this.containerMousePoint(), scale);

		} else {
			if (isFinger) {
				this.canvasTouchStart(e_);

			} else {
				this.canvasMouseDown(e_);
			}

		}

	}

	, 
	isFinger: function (e_) {
		var pointerEvent_ = e_.originalEvent;
		var isFinger = false;
		if ($.ig.DOMEventProxy.prototype.pointerEnabled) {
			isFinger = pointerEvent_.pointerType == 'touch';

		} else {
			isFinger = pointerEvent_.pointerType == pointerEvent_.MSPOINTER_TYPE_TOUCH;
		}

		return isFinger;
	}

	, 
	canvasMSPointerMove: function (e_) {
		var isFinger = this.isFinger(e_);
		if (this.__pinching) {
			return;
		}

		if (isFinger) {
			this.canvasTouchMove(e_);

		} else {
			this.canvasMouseMove(e_);
		}

	}

	, 
	canvasMSPointerOut: function (e_) {
		var isFinger = this.isFinger(e_);
		if (this.__pinching) {
			return;
		}

		if (isFinger) {

		} else {
			this.canvasMouseLeave(e_);
		}

	}

	, 
	canvasGestureStart: function (e_) {
		this.mouseIsOver(true);
		this.updateModifiers(e_);
		this.updateTouchPosition(e_);
		this.dragStopHoldTimer();
		if (this.shouldInteract()(this.mousePoint())) {
			this.preventDefault(e_);
			if ($.ig.DOMEventProxy.prototype.mSPointerEnabled) {
				this.__lastScale = 1;
			}

			if ($.ig.DOMEventProxy.prototype.mSPointerEnabled && this.__numTouches < 2) {
				return;
			}

			var scale = e_.originalEvent.scale;
			this.raiseOnPinchStarted(this.containerMousePoint(), scale);
		}

	}

	, 
	canvasGestureChange: function (e_) {
		this.mouseIsOver(true);
		this.updateModifiers(e_);
		this.updateTouchPosition(e_);
		if (this.shouldInteract()(this.mousePoint())) {
			this.preventDefault(e_);
			if ($.ig.DOMEventProxy.prototype.mSPointerEnabled && this.__numTouches < 2) {
				return;
			}

			var scale = e_.originalEvent.scale;
			this.raiseOnPinchDelta(this.containerMousePoint(), scale);
		}

	}

	, 
	canvasGestureEnd: function (e_) {
		this.preventDefault(e_);
		var scale = e_.originalEvent.scale;
		this.mouseIsOver(false);
		this.updateModifiers(e_);
		this.updateTouchPosition(e_);
		if (!$.ig.DOMEventProxy.prototype.mSPointerEnabled || this.__pinching) {
			this.raiseOnGestureCompleted(this.containerMousePoint(), scale);
		}

	}
	, 
	__touchStartDeferrred: false
	, 
	__touchContainerStart: null

	, 
	canvasTouchStart: function (e_) {
		this.mouseIsOver(true);
		this.updateModifiers(e_);
		this.updateTouchPosition(e_);
		this.__touchContainerStart = this.containerMousePoint();
		if (this.shouldInteract()(this.mousePoint())) {
			if (!this.deferredTouchStartMode()) {
				this.preventDefault(e_);

			} else {
				this.__touchStartDeferrred = true;
			}

			this.raiseOnMouseOver(this.mousePoint(), false, true);
			this.raiseOnMouseDown(this.mousePoint());
			this.raiseOnContactStarted(this.containerMousePoint(), true);
			this.startHoldTimer();
		}

	}
	, 
	__holdId: 0
	, 
	__suppressId: 0
	, 
	__tapArea: null
	, 
	__holdStartX: 0
	, 
	__holdStartY: 0
	, 
	__holdCancelDistance: 0

	, 
	startHoldTimer: function () {
		if (this.__holdId == $.ig.DOMEventProxy.prototype._nullTimer) {
			this.__holdStartX = this.mousePoint().__x;
			this.__holdStartY = this.mousePoint().__y;
			this.__holdId = window.setTimeout(this.onHoldTimer.runOn(this), 1500);
		}

	}

	, 
	dragStopHoldTimer: function () {
		if (Math.abs(this.__holdStartX - this.mousePoint().__x) > this.__holdCancelDistance || Math.abs(this.__holdStartY - this.mousePoint().__y) > this.__holdCancelDistance) {
			this.stopHoldTimer();
		}

	}

	, 
	stopHoldTimer: function () {
		if (this.__holdId != $.ig.DOMEventProxy.prototype._nullTimer) {
			window.clearTimeout(this.__holdId);
			this.__holdId = $.ig.DOMEventProxy.prototype._nullTimer;
		}

	}

	, 
	onHoldTimer: function () {
		this.__holdId = $.ig.DOMEventProxy.prototype._nullTimer;
		if (this.__touchStartDeferrred) {
			this.__touchStartDeferrred = false;
			this.beginMouseSuppress();
		}

		this.raiseOnHold(this.containerMousePoint());
	}
	, 
	__dragging: false
	, 
	__dragStart: null
	, 
	__suppressMouseEvents: false

	, 
	canvasTouchMove: function (e) {
		this.mouseIsOver(true);
		this.updateModifiers(e);
		this.updateTouchPosition(e);
		if (this.__touchStartDeferrred) {
			if (this.shouldInteract()(this.mousePoint()) && this.shouldAllowTouchDrag()) {
				this.__touchStartDeferrred = false;
				this.beginMouseSuppress();
			}

		}

		this.dragStopHoldTimer();
		this.stopTapTimer();
		if (this.shouldInteract()(this.mousePoint()) && this.__numTouches == 1 && !this.__touchStartDeferrred) {
			this.preventDefault(e);
			if (!this.__dragging) {
				this.__dragging = true;
				this.__dragStart = this.containerMousePoint();
				this.raiseOnDragStarted(this.__dragStart);

			} else {
				this.raiseOnMouseOver(this.mousePoint(), true, true);
				this.raiseOnContactMoved(this.containerMousePoint(), true);
				this.raiseOnDragDelta(this.containerMousePoint());
			}

		}

	}

	, 
	shouldAllowTouchDrag: function () {
		var direction = {__x: this.__touchContainerStart.__x - this.containerMousePoint().__x, __y: this.__touchContainerStart.__y - this.containerMousePoint().__y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		if (Math.abs(direction.__x) < 2 && Math.abs(direction.__y) < 2) {
			return false;
		}

		if (Math.abs(direction.__x) > Math.abs(direction.__y)) {
			direction.__y = 0;
		}

		if (Math.abs(direction.__y) > Math.abs(direction.__x)) {
			direction.__x = 0;
		}

		return this.shouldInteractForDirection()(direction);
	}

	, 
	canvasTouchEnd: function (e) {
		this.mouseIsOver(false);
		this.updateModifiers(e);
		this.updateTouchPosition(e);
		this.stopHoldTimer();
		if (this.__touchStartDeferrred) {
			this.__touchStartDeferrred = false;
			this.beginMouseSuppress();
		}

		this.preventDefault(e);
		this.raiseOnMouseOver(this.mousePoint(), false, true);
		this.raiseOnMouseUp(this.mousePoint());
		if (this.__numTouches == 0) {
			this.raiseDoubleTap(this.mousePoint());
			this.endMouseSuppress();
		}

		if (this.__dragging && this.__numTouches == 0) {
			this.__dragging = false;
			this.__dragStart = null;
			this.raiseOnDragCompleted(this.containerMousePoint());
			this.endMouseSuppress();
		}

		this.raiseOnContactCompleted(this.containerMousePoint(), true);
	}

	, 
	endMouseSuppress: function () {
		if (this.__suppressMouseEvents) {
			if (this.__suppressId == $.ig.DOMEventProxy.prototype._nullTimer) {
				this.__suppressId = window.setTimeout(this.doEndSuppress.runOn(this), 500);

			} else {
				window.clearTimeout(this.__suppressId);
				this.__suppressId = $.ig.DOMEventProxy.prototype._nullTimer;
				this.__suppressId = window.setTimeout(this.doEndSuppress.runOn(this), 500);
			}

		}

	}

	, 
	beginMouseSuppress: function () {
		this.__suppressMouseEvents = true;
		if (this.__suppressId != $.ig.DOMEventProxy.prototype._nullTimer) {
			window.clearTimeout(this.__suppressId);
			this.__suppressId = $.ig.DOMEventProxy.prototype._nullTimer;
		}

	}

	, 
	doEndSuppress: function () {
		this.__suppressMouseEvents = false;
	}

	, 
	raiseDoubleTap: function (pt) {
		if (this.__tapArea == null) {
			this.__tapArea = new $.ig.Rect(0, pt.__x - 50, pt.__y - 50, 100, 100);
			window.setTimeout(this.stopTapTimer.runOn(this), 500);

		} else {
			if (pt.__x >= this.__tapArea.x() && pt.__x <= this.__tapArea.right() && pt.__y >= this.__tapArea.y() && pt.__y <= this.__tapArea.bottom()) {
				this.stopTapTimer();
				this.raiseOnDoubleTap(pt);
			}

		}

	}

	, 
	stopTapTimer: function () {
		this.__tapArea = null;
	}

	, 
	_mouseIsOver: false,
	mouseIsOver: function (value) {
		if (arguments.length === 1) {
			this._mouseIsOver = value;
			return value;
		} else {
			return this._mouseIsOver;
		}
	}

	, 
	canvasMouseLeave: function (e) {
		if (this.__touchStartDeferrred || this.__suppressMouseEvents) {
			return;
		}

		this.updateMousePosition(e);
		if (this.mouseIsOver()) {
			this.mouseIsOver(false);
			this.raiseOnMouseLeave(this.containerMousePoint());
		}

	}

	, 
	canvasMouseMove: function (e) {
		if (this.__touchStartDeferrred || this.__suppressMouseEvents) {
			return;
		}

		this.updateMousePosition(e);
		this.updateModifiers(e);
		var me = new $.ig.MouseEventArgs();
		me.position(this.mousePoint());
		if (this.shouldInteract()(this.mousePoint())) {
			if (!this.mouseIsOver()) {
				this.mouseIsOver(true);
				this.raiseOnMouseEnter(this.mousePoint());
			}

			this.raiseOnMouseOver(this.mousePoint(), true, false);
			this.raiseOnContactMoved(this.containerMousePoint(), false);

		} else if (this.mouseIsOver()) {
			this.canvasMouseLeave(e);
		}


	}
	, 
	__mouseCaptured: false

	, 
	canvasMouseDown: function (e) {
		if (this.__touchStartDeferrred || this.__suppressMouseEvents) {
			return;
		}

		this.eventSource().focus();
		this.updateMousePosition(e);
		this.updateModifiers(e);
		if (this.shouldInteract()(this.mousePoint())) {
			this.__mouseCaptured = true;
			this.raiseOnMouseDown(this.mousePoint());
			this.raiseOnContactStarted(this.containerMousePoint(), false);
			this.preventDefault(e);
		}

	}

	, 
	windowMouseUp: function (e) {
		if (this.__touchStartDeferrred || this.__suppressMouseEvents) {
			return;
		}

		if (this.__mouseCaptured) {
			this.canvasMouseUp(e);
		}

	}

	, 
	canvasMouseUp: function (e) {
		if (this.__touchStartDeferrred || this.__suppressMouseEvents) {
			return;
		}

		this.updateModifiers(e);
		this.__mouseCaptured = false;
		this.raiseOnMouseUp(this.mousePoint());
		this.raiseOnContactCompleted(this.containerMousePoint(), false);
		this.preventDefault(e);
	}

	, 
	canvasKeyDown: function (e) {
		this.canvasKeyEvent(e, true);
	}

	, 
	canvasKeyUp: function (e) {
		this.canvasKeyEvent(e, false);
	}

	, 
	getKey: function (e) {
		var downKey = $.ig.Key.prototype.none;
		switch (e.which) {
			case 33:
				downKey = $.ig.Key.prototype.pageUp;
				break;
			case 34:
				downKey = $.ig.Key.prototype.pageDown;
				break;
			case 36:
				downKey = $.ig.Key.prototype.home;
				break;
			case 37:
				downKey = $.ig.Key.prototype.left;
				break;
			case 38:
				downKey = $.ig.Key.prototype.up;
				break;
			case 39:
				downKey = $.ig.Key.prototype.right;
				break;
			case 40:
				downKey = $.ig.Key.prototype.down;
				break;
			case 9:
				downKey = $.ig.Key.prototype.tab;
				break;
			case 32:
				downKey = $.ig.Key.prototype.space;
				break;
			case 13:
				downKey = $.ig.Key.prototype.enter;
				break;
			case 27:
				downKey = $.ig.Key.prototype.escape;
				break;
			case 16:
				downKey = $.ig.Key.prototype.shift;
				break;
			case 17:
				downKey = $.ig.Key.prototype.ctrl;
				break;
			case 18:
				downKey = $.ig.Key.prototype.alt;
				break;
			default:
				if (112 <= e.which && e.which <= 123) {
				downKey = ($.ig.Key.prototype.f1 + e.which - 112);
				}

				break;
		}

		return downKey;
	}

	, 
	canvasKeyEvent: function (e, isDown) {
		var downKey = $.ig.DOMEventProxy.prototype.getKey(e);
		var send = downKey != $.ig.Key.prototype.none;
		this.updateModifiers(e);
		if (send && this.shouldInteract()(this.mousePoint())) {
			var handled = false;
			if (isDown) {
			handled = this.raiseOnKeyDown(downKey);

			} else {
			handled = this.raiseOnKeyUp(downKey);
			}

			if (handled) {
				this.preventDefault(e);
			}

		}

	}

	, 
	updateModifiers: function (e) {
		this.currentModifiers($.ig.ModifierKeys.prototype.none);
		if (e.shiftKey) {
			this.currentModifiers(this.currentModifiers() | $.ig.ModifierKeys.prototype.shift);
		}

		if (e.altKey) {
			this.currentModifiers(this.currentModifiers() | $.ig.ModifierKeys.prototype.alt);
		}

		if (e.ctrlKey) {
			this.currentModifiers(this.currentModifiers() | $.ig.ModifierKeys.prototype.control);
		}

		this.rightButton(e.button == 2);
	}

	, 
	getSourceOffsets: function () {
		var offset = $.ig.DOMEventProxy.prototype.getOffset(this.eventSource());
		var x = offset.left();
		var y = offset.top();
		return {__x: x, __y: y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
	}

	, 
	unbindFromSource: function (objSource, sourceID) {
		var source = objSource;
		var ns = this.__eventNS + sourceID;
		source.unbind(ns);
		if (!$.ig.DOMEventProxy.prototype.mSPointerEnabled) {
			$(window).unbind(ns);
		}

	}

	, 
	destroy: function () {
		if (this.eventSource() == null) {
			return;
		}

		this.eventSource().unbind(this.__eventNS);
		if (!$.ig.DOMEventProxy.prototype.mSPointerEnabled) {
			$(window).unbind(this.__eventNS);
		}

		this.eventSource(null);
	}
	, 
	$type: new $.ig.Type('DOMEventProxy', $.ig.EventProxy.prototype.$type)
}, true);








$.ig.util.defType('CanvasRenderScheduler', 'Object', {
	init: function () {


		this.__sortDirty = true;
		this.__scheduled = false;
		this.__scheduledId = -1;

		$.ig.Object.prototype.init.call(this);
			this.targets(new $.ig.List$1($.ig.ISchedulableRender.prototype.$type, 0));
			this.dependsOn(new $.ig.List$1($.ig.CanvasRenderScheduler.prototype.$type, 0));
	}
	, 
	__sortDirty: false

	, 
	_targets: null,
	targets: function (value) {
		if (arguments.length === 1) {
			this._targets = value;
			return value;
		} else {
			return this._targets;
		}
	}

	, 
	_dependsOn: null,
	dependsOn: function (value) {
		if (arguments.length === 1) {
			this._dependsOn = value;
			return value;
		} else {
			return this._dependsOn;
		}
	}

	, 
	register: function (target) {
		this.__sortDirty = true;
		this.targets().add(target);
	}

	, 
	unRegister: function (target) {
		this.__sortDirty = true;
		this.targets().remove(target);
	}

	, 
	sortDirty: function () {
		this.__sortDirty = true;
		this.schedule();
	}

	, 
	isScheduled: function () {

			return this.__scheduled;
	}
	, 
	__scheduled: false
	, 
	__scheduledId: 0

	, 
	schedule: function () {
		if (!this.__scheduled) {
			this.__scheduled = true;
			this.__scheduledId = window.setTimeout(this.refresh.runOn(this), 0);
		}

	}

	, 
	schedule1: function (context1, context2) {
		this.schedule();
	}

	, 
	flush: function () {
		if (this.__scheduledId != -1) {
			window.clearTimeout(this.__scheduledId);
			this.__scheduledId = -1;
		}

		if (this.__scheduled) {
			this.refresh();
		}

	}

	, 
	refresh: function () {
		this.__scheduledId = -1;
		if (this.__scheduled) {
			this.__scheduled = false;
			if (this.dependsOn().count() > 0) {
				for (var i = 0; i < this.dependsOn().count(); i++) {
					this.dependsOn().__inner[i].flush();
				}

			}

			if (this.__sortDirty) {
				this.sortTargets();
			}

			this.renderTargets();
		}

	}

	, 
	renderTargets: function () {
		if (this.isDisabled()) {
			return;
		}

		var first = true;
		for (var i = 0; i < this.targets().count(); i++) {
			var target = this.targets().__inner[i];
			target.preRender();
		}

		for (var i1 = 0; i1 < this.targets().count(); i1++) {
			var target1 = this.targets().__inner[i1];
			target1.undirty(first);
			first = false;
		}

		for (var i2 = 0; i2 < this.targets().count(); i2++) {
			var target2 = this.targets().__inner[i2];
			target2.postRender();
		}

	}

	, 
	sortTargets: function () {
		var $self = this;
		$self.targets().sort2(function (o1, o2) {
			var t1 = o1;
			var t2 = o2;
			if (t1.index() < t2.index()) {
				return -1;
			}

			if (t1.index() > t2.index()) {
				return 1;
			}

			return 0;
		});
		$self.__sortDirty = false;
	}

	, 
	_isDisabled: false,
	isDisabled: function (value) {
		if (arguments.length === 1) {
			this._isDisabled = value;
			return value;
		} else {
			return this._isDisabled;
		}
	}
	, 
	$type: new $.ig.Type('CanvasRenderScheduler', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('CanvasViewRenderer', 'Object', {
	init: function () {

		this.__trackBounds = false;
		this.__validBounds = false;
		this.__globalAlpha = 1;

		$.ig.Object.prototype.init.call(this);

	}, 
	__context: null

	, 
	getUnderlyingContext: function () {
		return this.__context;
	}

	, 
	data: function (value) {
		if (arguments.length === 1) {

			this.__context = value;
			return value;
		} else {

			return this.__context;
		}
	}

	, 
	createGradient1: function (brush, minX, minY, maxX, maxY, lineWidth, isStroke) {
		return $.ig.CanvasViewRenderer.prototype.createGradient(this.__context, brush, minX, minY, maxX, maxY, lineWidth, isStroke);
	}

	, 
	createGradient: function (context, brush, minX, minY, maxX, maxY, lineWidth, isStroke) {
		var gradient;
		if (brush._useCustomDirection) {
			var _minX, _minY, _maxX, _maxY, ratio;
			ratio = maxX - minX;
			_minX = minX + brush._startX * ratio;
			_maxX = minX + brush._endX * ratio;
			ratio = maxY - minY;
			_minY = minY + brush._startY * ratio;
			_maxY = minY + brush._endY * ratio;
			if (isStroke) {
				var halfWidth = lineWidth / 2;
				_minX -= halfWidth;
				_maxX += halfWidth;
				_minY -= halfWidth;
				_maxY += halfWidth;
			}

			gradient = context.createLinearGradient(_minX, _minY, _maxX, _maxY);

		} else {
			if (isStroke) {
				var halfWidth1 = lineWidth / 2;
				minX -= halfWidth1;
				maxX += halfWidth1;
				minY -= halfWidth1;
				maxY += halfWidth1;
			}

			gradient = context.createLinearGradient(minX, minY, minX, maxY);
		}

		for (var i = 0; i < brush._gradientStops.length; i++) {
			var stop = brush._gradientStops[i];
			gradient.addColorStop(stop._offset, stop.__fill);
		}

		return gradient;
	}

	, 
	renderRectangle: function (rectangle) {
		if (rectangle.__visibility != $.ig.Visibility.prototype.visible) {
			return;
		}

		var left = rectangle.canvasLeft();
		var top = rectangle.canvasTop();
		var width = rectangle.width();
		var height = rectangle.height();
		var radiusX = rectangle.radiusX();
		var radiusY = rectangle.radiusY();
		this.__context.beginPath();
		this.__context.globalAlpha = (rectangle.__opacity * this.__globalAlpha);
		if (radiusX > 0 || radiusY > 0) {
			if (radiusX > width / 2) {
				radiusX = (width / 2);
			}

			if (radiusY > height / 2) {
				radiusY = (height / 2);
			}

			var radius = Math.min(radiusX, radiusY);
			this.__context.beginPath();
			this.__context.moveTo(left + radius, top);
			this.__context.lineTo(left + width - radius, top);
			this.__context.arc(left + width - radius, top + radius, radius, (3 / 2 * Math.PI), 0, false);
			this.__context.lineTo(left + width, top + height - radius);
			this.__context.arc(left + width - radius, top + height - radius, radius, 0, (Math.PI / 2), false);
			this.__context.lineTo(left + radius, top + height);
			this.__context.arc(left + radius, top + height - radius, radius, (Math.PI / 2), Math.PI, false);
			this.__context.lineTo(left, top + radius);
			this.__context.arc(left + radius, top + radius, radius, Math.PI, (3 / 2 * Math.PI), false);
			this.__context.closePath();

		} else {
			this.__context.rect(left, top, width, height);
		}

		var fill = rectangle.__fill;
		var stroke = rectangle.__stroke;
		if (fill != null) {
			if (fill._isGradient && top == top && left == left) {
				this.__context.fillStyle = this.createGradient1(fill, left, top, left + width, top + height, rectangle.strokeThickness(), false);

			} else {
				this.__context.fillStyle = fill.__fill;
			}

			this.__context.fill();
		}

		if (stroke != null) {
			if (stroke._isGradient && top == top && left == left) {
				this.__context.strokeStyle = this.createGradient1(stroke, left, top, left + width, top + height, rectangle.strokeThickness(), true);

			} else {
				this.__context.strokeStyle = stroke.__fill;
			}

			this.__context.lineWidth = rectangle.strokeThickness();
			this.__context.stroke();
		}

		this.__context.globalAlpha = 1;
	}
	, 
	__minX: 0
	, 
	__maxX: 0
	, 
	__minY: 0
	, 
	__maxY: 0
	, 
	__trackBounds: false
	, 
	__validBounds: false

	, 
	renderPath: function (path) {
		if (path.__visibility != $.ig.Visibility.prototype.visible) {
			return;
		}

		this.__context.beginPath();
		if (path.__opacity < 1 || this.__globalAlpha < 1) {
			this.__context.globalAlpha = (path.__opacity * this.__globalAlpha);
		}

		var fill = path.__fill;
		var stroke = path.__stroke;
		this.__trackBounds = (fill != null && fill._isGradient) || (stroke != null && stroke._isGradient);
		if (this.__trackBounds) {
			this.__maxX = -1.7976931348623157E+308;
			this.__maxY = -1.7976931348623157E+308;
			this.__minX = 1.7976931348623157E+308;
			this.__minY = 1.7976931348623157E+308;
			this.__validBounds = false;
		}

		this.renderGeometry(path.data());
		if (fill != null) {
			if (fill._isGradient && this.__validBounds) {
				this.__context.fillStyle = this.createGradient1(fill, this.__minX, this.__minY, this.__maxX, this.__maxY, path.strokeThickness(), false);

			} else {
				this.__context.fillStyle = path.__fill.__fill;
			}

			this.__context.fill();
		}

		if (stroke != null) {
			if (stroke._isGradient && this.__validBounds) {
				this.__context.strokeStyle = this.createGradient1(stroke, this.__minX, this.__minY, this.__maxX, this.__maxY, path.strokeThickness(), true);

			} else {
				this.__context.strokeStyle = path.__stroke.__fill;
			}

			this.__context.lineWidth = path.strokeThickness();
			this.__context.stroke();
		}

		if (path.__opacity < 1 || this.__globalAlpha < 1) {
			this.__context.globalAlpha = 1;
		}

	}

	, 
	renderGeometry: function (geometry) {
		if (geometry == null) {
			return;
		}

		var type = geometry.type();
		switch (type) {
			case $.ig.GeometryType.prototype.group:
				for (var i = 0; i < (geometry).children().count(); i++) {
					this.renderGeometry((geometry).children().__inner[i]);
				}

				break;
			case $.ig.GeometryType.prototype.path:
				this.renderPathGeometry(geometry);
				break;
			case $.ig.GeometryType.prototype.line:
				this.renderLineGeometry(geometry);
				break;
			case $.ig.GeometryType.prototype.rectangle:
				this.renderRectangleGeometry(geometry);
				break;
			case $.ig.GeometryType.prototype.ellipse:
				this.renderEllipseGeometry(geometry);
				break;
		}

	}

	, 
	renderEllipseGeometry: function (ellipseGeometry) {
		var $self = this;
		$self.__context.moveTo(ellipseGeometry.center().__x, (ellipseGeometry.center().__y - ellipseGeometry.radiusY()));
		$self.__lastSegmentPoint = {__x: ellipseGeometry.center().__x, __y: ellipseGeometry.center().__y - ellipseGeometry.radiusY(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		var a1 = (function () { var $ret = new $.ig.ArcSegment();
		$ret.point({__x: ellipseGeometry.center().__x, __y: ellipseGeometry.center().__y + ellipseGeometry.radiusY(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
		$ret.isLargeArc(false);
		$ret.size(new $.ig.Size(1, ellipseGeometry.radiusX(), ellipseGeometry.radiusY())); return $ret;}());
		var a2 = (function () { var $ret = new $.ig.ArcSegment();
		$ret.point({__x: ellipseGeometry.center().__x, __y: ellipseGeometry.center().__y - ellipseGeometry.radiusY(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
		$ret.isLargeArc(false);
		$ret.size(new $.ig.Size(1, ellipseGeometry.radiusX(), ellipseGeometry.radiusY())); return $ret;}());
		var oldTrack = $self.__trackBounds;
		$self.__trackBounds = false;
		$self.renderArcSegment(a1);
		$self.renderArcSegment(a2);
		$self.__trackBounds = oldTrack;
		if (!$self.__trackBounds) {
			return;
		}

		var minX = ellipseGeometry.center().__x - ellipseGeometry.radiusX();
		var maxX = ellipseGeometry.center().__y + ellipseGeometry.radiusX();
		var minY = ellipseGeometry.center().__x - ellipseGeometry.radiusY();
		var maxY = ellipseGeometry.center().__y + ellipseGeometry.radiusY();
		var currMaxX = $self.__maxX;
		var currMaxY = $self.__maxY;
		var currMinX = $self.__minX;
		var currMinY = $self.__minY;
		$self.__minX = minX < currMinX ? minX : currMinX;
		$self.__minY = minY < currMinY ? minY : currMinY;
		$self.__maxX = maxX > currMaxX ? maxX : currMaxX;
		$self.__maxY = maxY > currMaxY ? maxY : currMaxY;
		$self.__validBounds = true;
	}

	, 
	renderPathGeometry: function (pathGeometry) {
		var figures = pathGeometry.figures();
		var count = figures.count();
		for (var i = 0; i < count; i++) {
			this.renderFigure(figures.__inner[i]);
		}

	}

	, 
	renderFigure: function (figure) {
		var p = figure == null ? null : figure.__startPoint;
		if (p == null) {
		return;
		}

		var x = p.__x;
		var y = p.__y;
		this.__context.moveTo(x, y);
		if (this.__trackBounds) {
			var currMaxX = this.__maxX;
			var currMaxY = this.__maxY;
			var currMinX = this.__minX;
			var currMinY = this.__minY;
			this.__minX = x < currMinX ? x : currMinX;
			this.__minY = y < currMinY ? y : currMinY;
			this.__maxX = x > currMaxX ? x : currMaxX;
			this.__maxY = y > currMaxY ? y : currMaxY;
			this.__validBounds = true;
		}

		this.__lastSegmentPoint = p;
		var segments = figure.__segments;
		var count = segments.count();
		for (var i = 0; i < count; i++) {
			this.renderSegment(segments.__inner[i]);
		}

		if (figure.__isClosed && (this.__lastSegmentPoint.__x != x || this.__lastSegmentPoint.__y != y)) {
			this.__context.closePath();
		}

	}

	, 
	renderSegment: function (segment) {
		var type = segment.type();
		switch (type) {
			case $.ig.PathSegmentType.prototype.line:
				this.renderLineSegment(segment);
				break;
			case $.ig.PathSegmentType.prototype.polyLine:
				this.renderPolyLineSegment(segment);
				break;
			case $.ig.PathSegmentType.prototype.arc:
				this.renderArcSegment(segment);
				break;
			case $.ig.PathSegmentType.prototype.bezier:
				this.renderBezierSegment(segment);
				break;
			case $.ig.PathSegmentType.prototype.polyBezier:
				this.renderPolyBezierSegment(segment);
				break;
		}

	}
	, 
	__lastSegmentPoint: null

	, 
	updateBoundsFromBezier: function (x0, y0, x1, y1, x2, y2, x3, y3) {
		var delta = 1 / 50;
		var oneMinusT;
		var oneMinusT2;
		var oneMinusT3;
		var t2;
		var t3;
		var currX;
		var currY;
		var currMinX = this.__minX;
		var currMinY = this.__minY;
		var currMaxX = this.__maxX;
		var currMaxY = this.__maxY;
		for (var t = 0; t <= 1; t += delta) {
			oneMinusT = 1 - t;
			oneMinusT2 = oneMinusT * oneMinusT;
			oneMinusT3 = oneMinusT2 * oneMinusT;
			t2 = t * t;
			t3 = t2 * t;
			currX = oneMinusT3 * x0 + 3 * oneMinusT2 * t * x1 + 3 * oneMinusT * t2 * x2 + t3 * x3;
			currY = oneMinusT3 * y0 + 3 * oneMinusT2 * t * y1 + 3 * oneMinusT * t2 * y2 + t3 * y3;
			currMinX = currX < currMinX ? currX : currMinX;
			currMinY = currY < currMinY ? currY : currMinY;
			currMaxX = currX > currMaxX ? currX : currMaxX;
			currMaxY = currY > currMaxY ? currY : currMaxY;
		}

		this.__minX = currMinX;
		this.__minY = currMinY;
		this.__maxX = currMaxX;
		this.__maxY = currMaxY;
		this.__validBounds = true;
	}

	, 
	renderBezierSegment: function (segment) {
		this.__context.bezierCurveTo(segment.point1().__x, segment.point1().__y, segment.point2().__x, segment.point2().__y, segment.point3().__x, segment.point3().__y);
		if (this.__trackBounds) {
			this.updateBoundsFromBezier(this.__lastSegmentPoint.__x, this.__lastSegmentPoint.__y, segment.point1().__x, segment.point1().__y, segment.point2().__x, segment.point2().__y, segment.point3().__x, segment.point3().__y);
		}

	}

	, 
	renderPolyBezierSegment: function (arcSegment) {
		var i = 0;
		var pointsCount = arcSegment.points().count();
		var points = arcSegment.points();
		var p1 = this.__lastSegmentPoint;
		var p2 = this.__lastSegmentPoint;
		var p3 = this.__lastSegmentPoint;
		var trackBounds = this.__trackBounds;
		while (i < pointsCount) {
			if (i + 1 < pointsCount && i + 2 < pointsCount) {
				p1 = points.__inner[i];
				p2 = points.__inner[i + 1];
				p3 = points.__inner[i + 2];
				this.__context.bezierCurveTo(p1.__x, p1.__y, p2.__x, p2.__y, p3.__x, p3.__y);
				if (trackBounds) {
					this.updateBoundsFromBezier(this.__lastSegmentPoint.__x, this.__lastSegmentPoint.__y, p1.__x, p1.__y, p2.__x, p2.__y, p3.__x, p3.__y);
					this.__lastSegmentPoint = p3;
				}

			}

			i = i + 3;

		}
		this.__lastSegmentPoint = p3;
	}

	, 
	updateBoundsFromArc: function (center, startAngle, endAngle, radius, isCounter) {
		var points = new $.ig.List$1($.ig.Point.prototype.$type, 0);
		points.add(center);
		points.add({__x: center.__x + Math.cos(startAngle) * radius, __y: center.__y + Math.sin(startAngle) * radius, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
		points.add({__x: center.__x + Math.cos(endAngle) * radius, __y: center.__y + Math.sin(endAngle) * radius, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
		var threeSixty = Math.PI * 2;
		var ninety = Math.PI / 2;
		var oneEighty = Math.PI;
		var twoSeventy = Math.PI * 3 / 2;
		while (startAngle < 0) {
			startAngle += threeSixty;

		}
		while (startAngle > threeSixty) {
			startAngle -= threeSixty;

		}
		while (endAngle < 0) {
			endAngle += threeSixty;

		}
		while (endAngle > threeSixty) {
			endAngle -= threeSixty;

		}
		if (isCounter) {
			if ((0 > endAngle && 0 < startAngle) || (threeSixty > endAngle && threeSixty < startAngle) || (startAngle < endAngle)) {
				points.add({__x: center.__x + Math.cos(0) * radius, __y: center.__y + Math.sin(0) * radius, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			}

			if (ninety > endAngle && ninety < startAngle) {
				points.add({__x: center.__x + Math.cos(ninety) * radius, __y: center.__y + Math.sin(ninety) * radius, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			}

			if (oneEighty > endAngle && oneEighty < startAngle) {
				points.add({__x: center.__x + Math.cos(oneEighty) * radius, __y: center.__y + Math.sin(oneEighty) * radius, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			}

			if (twoSeventy > endAngle && twoSeventy < startAngle) {
				points.add({__x: center.__x + Math.cos(twoSeventy) * radius, __y: center.__y + Math.sin(twoSeventy) * radius, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			}


		} else {
			if ((0 > startAngle && 0 < endAngle) || (threeSixty > startAngle && threeSixty < endAngle) || (endAngle < startAngle)) {
				points.add({__x: center.__x + Math.cos(0) * radius, __y: center.__y + Math.sin(0) * radius, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			}

			if (ninety > startAngle && ninety < endAngle) {
				points.add({__x: center.__x + Math.cos(ninety) * radius, __y: center.__y + Math.sin(ninety) * radius, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			}

			if (oneEighty > startAngle && oneEighty < endAngle) {
				points.add({__x: center.__x + Math.cos(oneEighty) * radius, __y: center.__y + Math.sin(oneEighty) * radius, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			}

			if (twoSeventy > startAngle && twoSeventy < endAngle) {
				points.add({__x: center.__x + Math.cos(twoSeventy) * radius, __y: center.__y + Math.sin(twoSeventy) * radius, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			}

		}

		var minX = 1.7976931348623157E+308;
		var minY = 1.7976931348623157E+308;
		var maxX = -1.7976931348623157E+308;
		var maxY = -1.7976931348623157E+308;
		for (var i = 0; i < points.count(); i++) {
			var point = points.__inner[i];
			minX = Math.min(minX, point.__x);
			minY = Math.min(minY, point.__y);
			maxX = Math.max(maxX, point.__x);
			maxY = Math.max(maxY, point.__y);
		}

		this.__minX = Math.min(this.__minX, minX);
		this.__minY = Math.min(this.__minY, minY);
		this.__maxX = Math.max(this.__maxX, maxX);
		this.__maxY = Math.max(this.__maxY, maxY);
		this.__validBounds = true;
	}

	, 
	renderArcSegment: function (arcSegment) {
		var startPoint = this.__lastSegmentPoint;
		var endPoint = arcSegment.point();
		if (arcSegment.size().width() != arcSegment.size().height()) {
			this.__context.save();
			this.__context.scale(arcSegment.size().width() / arcSegment.size().height(), 1);
			startPoint = {__x: startPoint.__x * (arcSegment.size().height() / arcSegment.size().width()), __y: startPoint.__y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			endPoint = {__x: endPoint.__x * (arcSegment.size().height() / arcSegment.size().width()), __y: endPoint.__y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		}

		var isCounter = arcSegment.sweepDirection() == $.ig.SweepDirection.prototype.counterclockwise;
		var center = $.ig.GeometryUtil.prototype.getCenterFromArcSegment(startPoint, endPoint, arcSegment.size().height(), isCounter, arcSegment.isLargeArc());
		var startAngle = Math.atan2(startPoint.__y - center.__y, startPoint.__x - center.__x);
		var endAngle = Math.atan2(endPoint.__y - center.__y, endPoint.__x - center.__x);
		var lessThan180 = (Math.abs(endAngle - startAngle) < Math.PI);
		if (arcSegment.isLargeArc() == lessThan180) {
			if (startAngle < endAngle) {
				startAngle += 2 * Math.PI;

			} else {
				endAngle += 2 * Math.PI;
			}

		}

		if (!$.ig.util.isNaN(center.__x) && !$.ig.util.isNaN(center.__y) && !$.ig.util.isNaN(arcSegment.size().height()) && !$.ig.util.isNaN(startAngle) && !$.ig.util.isNaN(endAngle)) {
			this.__context.arc(center.__x, center.__y, arcSegment.size().height(), startAngle, endAngle, isCounter);
			if (this.__trackBounds) {
				this.updateBoundsFromArc(center, startAngle, endAngle, arcSegment.size().height(), isCounter);
			}

		}

		this.__lastSegmentPoint = arcSegment.point();
		if (arcSegment.size().width() != arcSegment.size().height()) {
			this.__context.restore();
		}

	}

	, 
	renderLineSegment: function (lineSegment) {
		var x = lineSegment.point().__x;
		var y = lineSegment.point().__y;
		this.__context.lineTo(x, y);
		this.__lastSegmentPoint = lineSegment.point();
		if (this.__trackBounds) {
			var currMaxX = this.__maxX;
			var currMaxY = this.__maxY;
			var currMinX = this.__minX;
			var currMinY = this.__minY;
			this.__minX = x < currMinX ? x : currMinX;
			this.__minY = y < currMinY ? y : currMinY;
			this.__maxX = x > currMaxX ? x : currMaxX;
			this.__maxY = y > currMaxY ? y : currMaxY;
			this.__validBounds = true;
		}

	}

	, 
	renderPolyLineSegment: function (polyLineSegment) {
		var points = polyLineSegment.__points;
		var count = points.count();
		if (this.__trackBounds) {
			var currMinX = this.__minX;
			var currMinY = this.__minY;
			var currMaxX = this.__maxX;
			var currMaxY = this.__maxY;
			var x;
			var y;
			for (var i = 0; i < count; i++) {
				x = points.__inner[i].__x;
				y = points.__inner[i].__y;
				this.__context.lineTo(x, y);
				currMinX = x < currMinX ? x : currMinX;
				currMinY = y < currMinY ? y : currMinY;
				currMaxX = x > currMaxX ? x : currMaxX;
				currMaxY = y > currMaxY ? y : currMaxY;
			}

			this.__minX = currMinX;
			this.__minY = currMinY;
			this.__maxX = currMaxX;
			this.__maxY = currMaxY;
			this.__validBounds = true;

		} else {
			for (var i1 = 0; i1 < count; i1++) {
				this.__context.lineTo(points.__inner[i1].__x, points.__inner[i1].__y);
			}

		}

		this.__lastSegmentPoint = polyLineSegment.__points.__inner[count - 1];
	}

	, 
	renderRectangleGeometry: function (rectangleGeometry) {
		this.__context.rect(rectangleGeometry.rect().left(), rectangleGeometry.rect().top(), rectangleGeometry.rect().width(), rectangleGeometry.rect().height());
		if (this.__trackBounds) {
			var rect = rectangleGeometry.rect();
			var currMinX = this.__minX;
			var currMinY = this.__minY;
			var currMaxX = this.__maxX;
			var currMaxY = this.__maxY;
			var minX = rect.left();
			var maxX = rect.right();
			var minY = rect.top();
			var maxY = rect.bottom();
			this.__minX = minX < currMinX ? minX : currMinX;
			this.__minY = minY < currMinY ? minY : currMinY;
			this.__maxX = maxX > currMaxX ? maxX : currMaxX;
			this.__maxY = maxY > currMaxY ? maxY : currMaxY;
			this.__validBounds = true;
		}

	}

	, 
	renderLineGeometry: function (lineGeometry) {
		this.__context.moveTo(lineGeometry.startPoint().__x, lineGeometry.startPoint().__y);
		this.__context.lineTo(lineGeometry.endPoint().__x, lineGeometry.endPoint().__y);
		if (this.__trackBounds) {
			var p1 = lineGeometry.startPoint();
			var p2 = lineGeometry.endPoint();
			var currMinX = this.__minX;
			var currMinY = this.__minY;
			var currMaxX = this.__maxX;
			var currMaxY = this.__maxY;
			var minX = p1.__x < p2.__x ? p1.__x : p2.__x;
			var maxX = p1.__x > p2.__x ? p1.__x : p2.__x;
			var minY = p1.__y < p2.__y ? p1.__y : p2.__y;
			var maxY = p1.__y > p2.__y ? p1.__y : p2.__y;
			this.__minX = minX < currMinX ? minX : currMinX;
			this.__minY = minY < currMinY ? minY : currMinY;
			this.__maxX = maxX > currMaxX ? maxX : currMaxX;
			this.__maxY = maxY > currMaxY ? maxY : currMaxY;
			this.__validBounds = true;
		}

	}

	, 
	renderTextBlock: function (tb) {
		if (tb.__visibility == $.ig.Visibility.prototype.visible) {
			if (tb.__opacity < 1 || this.__globalAlpha < 1) {
				this.__context.globalAlpha = (tb.__opacity * this.__globalAlpha);
			}

			this.__context.fillStyle = tb.fill().__fill;
			this.__context.textBaseline = "top";
			this.__context.fillText(tb.text(), tb.canvasLeft(), tb.canvasTop());
			if (tb.__opacity < 1 || this.__globalAlpha < 1) {
				this.__context.globalAlpha = 1;
			}

		}

	}

	, 
	renderTextBlockInRect: function (tb, rect) {
		this.renderTextBlock(tb);
	}

	, 
	renderPolygon: function (polygon) {
		if (polygon.points() == null || polygon.points().count() < 1) {
			return;
		}

		this.__context.beginPath();
		this.__context.globalAlpha = (polygon.__opacity * this.__globalAlpha);
		var points = polygon.points();
		var startPoint = points.__inner[0];
		var fill = polygon.__fill;
		var stroke = polygon.__stroke;
		this.__trackBounds = (fill != null && fill._isGradient) || (stroke != null && stroke._isGradient);
		if (this.__trackBounds) {
			var minX = 1.7976931348623157E+308;
			var maxX = -1.7976931348623157E+308;
			var minY = 1.7976931348623157E+308;
			var maxY = -1.7976931348623157E+308;
			var x = startPoint.__x;
			var y = startPoint.__y;
			minX = x < minX ? x : minX;
			minY = y < minY ? y : minY;
			maxX = x > maxX ? x : maxX;
			maxY = y > maxY ? y : maxY;
			this.__context.moveTo(x, y);
			for (var i = 1; i < points.count(); i++) {
				x = points.__inner[i].__x;
				y = points.__inner[i].__y;
				this.__context.lineTo(x, y);
				minX = x < minX ? x : minX;
				minY = y < minY ? y : minY;
				maxX = x > maxX ? x : maxX;
				maxY = y > maxY ? y : maxY;
			}

			this.__context.closePath();
			this.__minX = minX;
			this.__minY = minY;
			this.__maxX = maxX;
			this.__maxY = maxY;

		} else {
			this.__context.moveTo(startPoint.__x, startPoint.__y);
			for (var i1 = 1; i1 < points.count(); i1++) {
				this.__context.lineTo(points.__inner[i1].__x, points.__inner[i1].__y);
			}

			this.__context.closePath();
		}

		if (fill != null) {
			if (fill._isGradient) {
				this.__context.fillStyle = this.createGradient1(fill, this.__minX, this.__minY, this.__maxX, this.__maxY, polygon.strokeThickness(), false);

			} else {
				this.__context.fillStyle = fill.__fill;
			}

			this.__context.fill();
		}

		if (stroke != null) {
			if (stroke._isGradient) {
				this.__context.strokeStyle = this.createGradient1(stroke, this.__minX, this.__minY, this.__maxX, this.__maxY, polygon.strokeThickness(), true);

			} else {
				this.__context.strokeStyle = stroke.__fill;
			}

			this.__context.lineWidth = polygon.strokeThickness();
			this.__context.stroke();
		}

		this.__context.globalAlpha = 1;
	}

	, 
	renderPolyline: function (polyline) {
		if (polyline.points() == null || polyline.points().count() < 1) {
			return;
		}

		this.__context.beginPath();
		this.__context.globalAlpha = (polyline.__opacity * this.__globalAlpha);
		var points = polyline.points();
		var startPoint = points.__inner[0];
		var fill = polyline.__fill;
		var stroke = polyline.__stroke;
		this.__trackBounds = (fill != null && fill._isGradient) || (stroke != null && stroke._isGradient);
		if (this.__trackBounds) {
			var minX = 1.7976931348623157E+308;
			var maxX = -1.7976931348623157E+308;
			var minY = 1.7976931348623157E+308;
			var maxY = -1.7976931348623157E+308;
			var x = startPoint.__x;
			var y = startPoint.__y;
			minX = x < minX ? x : minX;
			minY = y < minY ? y : minY;
			maxX = x > maxX ? x : maxX;
			maxY = y > maxY ? y : maxY;
			this.__context.moveTo(x, y);
			for (var i = 1; i < points.count(); i++) {
				x = points.__inner[i].__x;
				y = points.__inner[i].__y;
				this.__context.lineTo(x, y);
				minX = x < minX ? x : minX;
				minY = y < minY ? y : minY;
				maxX = x > maxX ? x : maxX;
				maxY = y > maxY ? y : maxY;
			}

			this.__minX = minX;
			this.__minY = minY;
			this.__maxX = maxX;
			this.__maxY = maxY;

		} else {
			this.__context.moveTo(startPoint.__x, startPoint.__y);
			for (var i1 = 1; i1 < points.count(); i1++) {
				this.__context.lineTo(points.__inner[i1].__x, points.__inner[i1].__y);
			}

		}

		if (fill != null) {
			if (fill._isGradient) {
				this.__context.fillStyle = this.createGradient1(fill, this.__minX, this.__minY, this.__maxX, this.__maxY, polyline.strokeThickness(), false);

			} else {
				this.__context.fillStyle = fill.__fill;
			}

			this.__context.fill();
		}

		if (stroke != null) {
			if (stroke._isGradient) {
				this.__context.strokeStyle = this.createGradient1(stroke, this.__minX, this.__minY, this.__maxX, this.__maxY, polyline.strokeThickness(), true);

			} else {
				this.__context.strokeStyle = stroke.__fill;
			}

			this.__context.lineWidth = polyline.strokeThickness();
			this.__context.stroke();
		}

		this.__context.globalAlpha = 1;
	}

	, 
	renderContentControl: function (renderInfo, marker) {
		if (marker.__visibility == $.ig.Visibility.prototype.collapsed) {
			return;
		}

		if ((marker.__opacity != 1 || this.__globalAlpha != 1) && !renderInfo.isHitTestRender) {
			this.__context.globalAlpha = (marker.__opacity * this.__globalAlpha);
		}

		var template = marker.contentTemplate();
		if (template != null && template.render() != null) {
			renderInfo.context = this.__context;
			renderInfo.xPosition = marker.canvasLeft();
			renderInfo.yPosition = marker.canvasTop();
			renderInfo.data = marker.content();
			template.render()(renderInfo);
		}

		this.__context.globalAlpha = 1;
	}

	, 
	applyTransform: function (transform) {
		if ($.ig.util.cast($.ig.TransformGroup.prototype.$type, transform) !== null) {
			var tg = transform;
			for (var i = tg.children().count() - 1; i >= 0; i--) {
				var tran = tg.children().__inner[i];
				this.applyTransform(tran);
			}


		} else if ($.ig.util.cast($.ig.TranslateTransform.prototype.$type, transform) !== null) {
			var trans = transform;
			this.__context.translate(trans.x(), trans.y());

		} else if ($.ig.util.cast($.ig.RotateTransform.prototype.$type, transform) !== null) {
			var rot = transform;
			var angle = rot.angle() * Math.PI / 180;
			var x = Math.cos(angle);
			var y = Math.sin(angle);
			var offsetX = rot.centerX() * (1 - x) + rot.centerY() * y;
			var offsetY = rot.centerY() * (1 - x) - rot.centerX() * y;
			this.__context.transform(x, y, y * -1, x, offsetX, offsetY);

		} else if ($.ig.util.cast($.ig.ScaleTransform.prototype.$type, transform) !== null) {
			var scale = transform;
			this.__context.transform(scale.scaleX(), 0, 0, scale.scaleY(), scale.centerX() - scale.scaleX() * scale.centerX(), scale.centerY() - scale.scaleY() * scale.centerY());
		}




	}

	, 
	renderLine: function (line) {
		if (line.__visibility != $.ig.Visibility.prototype.visible) {
			return;
		}

		this.__context.beginPath();
		this.__context.globalAlpha = (line.__opacity * this.__globalAlpha);
		this.__context.moveTo(line.x1(), line.y1());
		this.__context.lineTo(line.x2(), line.y2());
		if (this.__trackBounds) {
			this.__minX = 1.7976931348623157E+308;
			this.__maxX = -1.7976931348623157E+308;
			this.__minY = 1.7976931348623157E+308;
			this.__maxY = -1.7976931348623157E+308;
			var currMinX = this.__minX;
			var currMinY = this.__minY;
			var currMaxX = this.__maxX;
			var currMaxY = this.__maxY;
			var minX = line.x1() < line.x2() ? line.x1() : line.x2();
			var maxX = line.x1() > line.x2() ? line.x1() : line.x2();
			var minY = line.y1() < line.y2() ? line.y1() : line.y2();
			var maxY = line.y1() > line.y2() ? line.y1() : line.y2();
			this.__minX = minX < currMinX ? minX : currMinX;
			this.__minY = minY < currMinY ? minY : currMinY;
			this.__maxX = maxX > currMaxX ? maxX : currMaxX;
			this.__maxY = maxY > currMaxY ? maxY : currMaxY;
		}

		var fill = line.__fill;
		var stroke = line.__stroke;
		if (fill != null) {
			if (fill._isGradient) {
				this.__context.fillStyle = this.createGradient1(fill, this.__minX, this.__minY, this.__maxX, this.__maxX, line.strokeThickness(), false);

			} else {
				this.__context.fillStyle = fill.__fill;
			}

			this.__context.fill();
		}

		if (stroke != null) {
			if (stroke._isGradient) {
				this.__context.strokeStyle = this.createGradient1(stroke, this.__minX, this.__minY, this.__maxX, this.__maxX, line.strokeThickness(), true);

			} else {
				this.__context.strokeStyle = line.__stroke.__fill;
			}

			this.__context.lineWidth = line.strokeThickness();
			this.__context.stroke();
		}

		this.__context.globalAlpha = 1;
	}

	, 
	setRectangleClip: function (rect) {
		this.__context.beginPath();
		this.__context.rect(rect.left(), rect.top(), rect.width(), rect.height());
		this.__context.clip();
	}

	, 
	save: function () {
		this.__context.save();
	}

	, 
	restore: function () {
		this.__context.restore();
	}

	, 
	scale: function (x, y) {
		this.__context.scale(x, y);
	}

	, 
	translate: function (x, y) {
		this.__context.translate(x, y);
	}

	, 
	clearRectangle: function (left, top, width, height) {
		this.__context.clearRect(left, top, width, height);
	}

	, 
	drawImage: function (image, opacity, left, top, width, height) {
		if (opacity != 1) {
			this.__context.globalAlpha = (opacity * this.__globalAlpha);
		}

		this.__context.drawImage(image, left, top, width, height);
		if (opacity != 1) {
			this.__context.globalAlpha = 1;
		}

	}

	, 
	drawImage1: function (image, opacity, sourceLeft, sourceTop, sourceWidth, sourceHeight, left, top, width, height) {
		if (opacity != 1) {
			this.__context.globalAlpha = (opacity * this.__globalAlpha);
		}

		this.__context.drawImage(image, sourceLeft, sourceTop, sourceWidth, sourceHeight, left, top, width, height);
		if (opacity != 1) {
			this.__context.globalAlpha = 1;
		}

	}

	, 
	getPixelAt: function (x, y) {
		var data = this.__context.getImageData(x, y, 1, 1);
		var ret = new Array(4);
		ret[0] = data.data[0];
		ret[1] = data.data[1];
		ret[2] = data.data[2];
		ret[3] = data.data[3];
		return ret;
	}

	, 
	getFont: function () {
		return this.__context.font;
	}

	, 
	setFont: function (font) {
		if (this.__context.font != font) {
			this.__context.font = font;
		}

	}

	, 
	measureTextWidth: function (text) {
		var metrics = this.__context.measureText(text);
		return metrics.width;
	}
	, 
	__globalAlpha: 0

	, 
	setOpacity: function (p) {
		this.__globalAlpha = p;
	}

	, 
	applyStyle: function (shape_, style_) {
		var $self = this;
		if (style_ == null) {
			return;
		}

		var fillColor_ = null;
		var strokeColor_ = null;
		var strokeThickness_ = NaN;
		var opacity_ = NaN;
		if (style_.fill) { fillColor_ = style_.fill };
		if (style_.stroke) { strokeColor_ = style_.stroke };
		if (style_.strokeThickness) { strokeThickness_ = style_.strokeThickness };
		if (style_.opacity) { opacity_ = style_.opacity };
		if (fillColor_ != null) {
			shape_.__fill = (function () { var $ret = new $.ig.Brush();
			$ret.fill(fillColor_); return $ret;}());
		}

		if (strokeColor_ != null) {
			shape_.__stroke = (function () { var $ret = new $.ig.Brush();
			$ret.fill(strokeColor_); return $ret;}());
		}

		if (!$.ig.util.isNaN(strokeThickness_)) {
			shape_.strokeThickness(strokeThickness_);
		}

		if (!$.ig.util.isNaN(opacity_)) {
			shape_.__opacity = opacity_;
		}

	}

	, 
	enableDropShadow: function (color, blur, offsetX, offsetY) {
		this.__context.shadowColor = color;
		this.__context.shadowBlur = blur;
		this.__context.shadowOffsetX = offsetX;
		this.__context.shadowOffsetY = offsetY;
	}

	, 
	disableDropShadow: function () {
		this.__context.shadowColor = "rgba(0,0,0,0)";
		this.__context.shadowBlur = 0;
		this.__context.shadowOffsetX = 0;
		this.__context.shadowOffsetY = 0;
	}
	, 
	$type: new $.ig.Type('CanvasViewRenderer', $.ig.Object.prototype.$type, [$.ig.IRenderer.prototype.$type])
}, true);


$.ig.util.defType('IOverviewPlusDetailControl', 'Object', {
	$type: new $.ig.Type('IOverviewPlusDetailControl', null)
}, true);

$.ig.util.defType('ISchedulableRender', 'Object', {
	$type: new $.ig.Type('ISchedulableRender', null)
}, true);


$.ig.util.defType('PropertyChangedEventArgs$1', 'PropertyChangedEventArgs', {
	$t: null, 
	init: function ($t, propertyName, oldValue, newValue) {

		this.$t = $t;
		this.$type = this.$type.specialize(this.$t);


		$.ig.PropertyChangedEventArgs.prototype.init.call(this, propertyName);
			this.oldValue(oldValue);
			this.newValue(newValue);
	}

	, 
	_oldValue: null,
	oldValue: function (value) {
		if (arguments.length === 1) {
			this._oldValue = value;
			return value;
		} else {
			return this._oldValue;
		}
	}

	, 
	_newValue: null,
	newValue: function (value) {
		if (arguments.length === 1) {
			this._newValue = value;
			return value;
		} else {
			return this._newValue;
		}
	}
	, 
	$type: new $.ig.Type('PropertyChangedEventArgs$1', $.ig.PropertyChangedEventArgs.prototype.$type)
}, true);

$.ig.util.defType('XamOverviewPlusDetailPane', 'Control', {

	_view: null,
	view: function (value) {
		if (arguments.length === 1) {
			this._view = value;
			return value;
		} else {
			return this._view;
		}
	}
	, 
	init: function () {


		this.__ignoreContactUp = false;
		this.__mobileMode = false;

		$.ig.Control.prototype.init.call(this);
			this.view(new $.ig.XamOverviewPlusDetailPaneView(this));
			this.view().onInit();
			this.defaultStyleKey($.ig.XamOverviewPlusDetailPane.prototype.$type);
			this.anchor({__x: 0, __y: 0, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
	}
	, 
	windowChanging: null
	, 
	onWindowChanging: function (e) {
		if (e == null) {
			throw new $.ig.ArgumentNullException(0, "e");
		}

		if (this.immediate()) {
			this.window(e.newValue());
		}

		if (this.windowChanging != null) {
			this.windowChanging(this, e);
		}

	}
	, 
	windowChanged: null
	, 
	onWindowChanged: function (a) {
		if (this.windowChanged != null) {
			this.windowChanged(this, a);
		}

	}
	, 
	thumbnailSizeChanged: null
	, 
	onThumbnailSizeChanged: function (e) {
		if (this.thumbnailSizeChanged != null) {
			this.thumbnailSizeChanged(this, e);
		}

	}

	, 
	immediate: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.XamOverviewPlusDetailPane.prototype.immediateProperty, value);
			return value;
		} else {

			return this.getValue($.ig.XamOverviewPlusDetailPane.prototype.immediateProperty);
		}
	}

	, 
	world: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.XamOverviewPlusDetailPane.prototype.worldProperty, value);
			return value;
		} else {

			return this.getValue($.ig.XamOverviewPlusDetailPane.prototype.worldProperty);
		}
	}

	, 
	worldStyle: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.XamOverviewPlusDetailPane.prototype.worldStyleProperty, value);
			return value;
		} else {

			return this.getValue($.ig.XamOverviewPlusDetailPane.prototype.worldStyleProperty);
		}
	}

	, 
	window: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.XamOverviewPlusDetailPane.prototype.windowProperty, value);
			return value;
		} else {

			return this.getValue($.ig.XamOverviewPlusDetailPane.prototype.windowProperty);
		}
	}

	, 
	windowStyle: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.XamOverviewPlusDetailPane.prototype.windowStyleProperty, value);
			return value;
		} else {

			return this.getValue($.ig.XamOverviewPlusDetailPane.prototype.windowStyleProperty);
		}
	}

	, 
	preview: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.XamOverviewPlusDetailPane.prototype.previewProperty, value);
			return value;
		} else {

			return this.getValue($.ig.XamOverviewPlusDetailPane.prototype.previewProperty);
		}
	}

	, 
	previewStyle: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.XamOverviewPlusDetailPane.prototype.previewStyleProperty, value);
			return value;
		} else {

			return this.getValue($.ig.XamOverviewPlusDetailPane.prototype.previewStyleProperty);
		}
	}

	, 
	shrinkToThumbnail: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.XamOverviewPlusDetailPane.prototype.shrinkToThumbnailProperty, value);
			return value;
		} else {

			return this.getValue($.ig.XamOverviewPlusDetailPane.prototype.shrinkToThumbnailProperty);
		}
	}

	, 
	onShrinkToThumbnailChanged1: function (d, e) {
		(d).onShrinkToThumbnailChanged(e.oldValue(), e.newValue());
	}

	, 
	onShrinkToThumbnailChanged: function (oldValue, newValue) {
		if (newValue) {
			this.goToState($.ig.OverviewPlusDetailPaneMode.prototype.minimal);

		} else {
			this.goToState($.ig.OverviewPlusDetailPaneMode.prototype.compact);
		}

	}

	, 
	mode: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.XamOverviewPlusDetailPane.prototype.modeProperty, $.ig.OverviewPlusDetailPaneMode.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.XamOverviewPlusDetailPane.prototype.modeProperty));
		}
	}

	, 
	onModeChanged1: function (d, e) {
		(d).onModeChanged($.ig.util.getEnumValue(e.oldValue()), $.ig.util.getEnumValue(e.newValue()));
	}

	, 
	onModeChanged: function (oldValue, newValue) {
		this.goToState(newValue);
	}

	, 
	goToState: function (mode) {
		switch (mode) {
			case $.ig.OverviewPlusDetailPaneMode.prototype.full:
				this.view().goToFullState();
				if (this.isZoomable()) {
					this.view().goToZoomEnabledState();

				} else {
					this.view().goToZoomDisabledState();
				}

				break;
			case $.ig.OverviewPlusDetailPaneMode.prototype.compact:
				this.view().goToMinimalState();
				if (this.isZoomable()) {
					this.view().goToZoomEnabledState();

				} else {
					this.view().goToZoomDisabledState();
				}

				break;
			case $.ig.OverviewPlusDetailPaneMode.prototype.minimal:
				this.view().goToMinimalState();
				this.view().goToZoomDisabledState();
				break;
		}

	}

	, 
	updateVisualState: function () {
		if (this.shrinkToThumbnail()) {
			this.goToState($.ig.OverviewPlusDetailPaneMode.prototype.minimal);

		} else {
			this.goToState($.ig.OverviewPlusDetailPaneMode.prototype.compact);
		}

	}
	, 
	__surfaceViewer: null

	, 
	surfaceViewer: function (value) {
		if (arguments.length === 1) {

			if (this.__surfaceViewer != null) {
				var asIPropChange = $.ig.util.cast($.ig.INotifyPropertyChanged.prototype.$type, this.__surfaceViewer);
				if (asIPropChange != null) {
				asIPropChange.propertyChanged = $.ig.Delegate.prototype.remove(asIPropChange.propertyChanged, this.surfaceViewer_PropertyChanged.runOn(this));
				}

			}

			this.__surfaceViewer = value;
			if (this.__surfaceViewer != null) {
				var asIPropChange1 = $.ig.util.cast($.ig.INotifyPropertyChanged.prototype.$type, this.__surfaceViewer);
				if (asIPropChange1 != null) {
				asIPropChange1.propertyChanged = $.ig.Delegate.prototype.combine(asIPropChange1.propertyChanged, this.surfaceViewer_PropertyChanged.runOn(this));
				}

			}

			this.view().setSurfaceBindings();
			return value;
		} else {

			return this.__surfaceViewer;
		}
	}

	, 
	surfaceViewer_PropertyChanged: function (sender, e) {
		switch (e.propertyName()) {
			case "DefaultInteraction":
				this.view().updateInteractionButtonStates(this.__surfaceViewer.defaultInteraction());
				break;
		}

	}

	, 
	previewViewportdRect: function () {

			var rect = this.worldToCanvas(this.world());
			return new $.ig.Rect(0, 0, 0, rect.width(), rect.height());
	}

	, 
	zoomTo100ButtonVisibility: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.XamOverviewPlusDetailPane.prototype.zoomTo100ButtonVisibilityProperty, $.ig.Visibility.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.XamOverviewPlusDetailPane.prototype.zoomTo100ButtonVisibilityProperty));
		}
	}

	, 
	scaleToFitButtonVisibility: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.XamOverviewPlusDetailPane.prototype.scaleToFitButtonVisibilityProperty, $.ig.Visibility.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.XamOverviewPlusDetailPane.prototype.scaleToFitButtonVisibilityProperty));
		}
	}

	, 
	interactionStatesToolVisibility: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.XamOverviewPlusDetailPane.prototype.interactionStatesToolVisibilityProperty, $.ig.Visibility.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.XamOverviewPlusDetailPane.prototype.interactionStatesToolVisibilityProperty));
		}
	}

	, 
	zoomLevelLargeChange: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.XamOverviewPlusDetailPane.prototype.zoomLevelLargeChangeProperty, value);
			return value;
		} else {

			return this.getValue($.ig.XamOverviewPlusDetailPane.prototype.zoomLevelLargeChangeProperty);
		}
	}
	, 
	__isZoomable: false

	, 
	isZoomable: function (value) {
		if (arguments.length === 1) {

			this.__isZoomable = value;
			this.updateVisualState();
			return value;
		} else {

			return this.__isZoomable;
		}
	}

	, 
	viewport: function () {

			return this.view().viewport();
	}

	, 
	_refreshPending: false,
	refreshPending: function (value) {
		if (arguments.length === 1) {
			this._refreshPending = value;
			return value;
		} else {
			return this._refreshPending;
		}
	}

	, 
	getDesiredSize: function (availableSize) {
		var width = availableSize.width();
		var height = availableSize.height();
		var aspect = !this.world().isEmpty() ? this.world().width() / this.world().height() : 1;
		if (Number.isInfinity(height)) {
			if (Number.isInfinity(width)) {
				width = 128;
			}

			height = width / aspect;

		} else {
			if (Number.isInfinity(width)) {
				width = height * aspect;
			}

		}

		return new $.ig.Size(1, width, height);
	}

	, 
	_isPanning: false,
	isPanning: function (value) {
		if (arguments.length === 1) {
			this._isPanning = value;
			return value;
		} else {
			return this._isPanning;
		}
	}

	, 
	_anchor: null,
	anchor: function (value) {
		if (arguments.length === 1) {
			this._anchor = value;
			return value;
		} else {
			return this._anchor;
		}
	}

	, 
	onMouseEnter: function () {
		if (this.shrinkToThumbnail()) {
			this.goToState($.ig.OverviewPlusDetailPaneMode.prototype.full);
		}

	}

	, 
	onMouseLeave: function () {
		if (this.shrinkToThumbnail()) {
			this.goToState($.ig.OverviewPlusDetailPaneMode.prototype.minimal);
		}

	}

	, 
	onKeyDown: function (key) {
		switch (key) {
			case $.ig.Key.prototype.escape:
				if (this.isPanning()) {
					this.view().cancelMouseOperations();
					this.isPanning(false);
					this.preview($.ig.Rect.prototype.empty());
					return true;
				}

				break;
		}

		return false;
	}

	, 
	onMouseLeftButtonDown: function (p) {
		if (!this.__pinching) {
			this.__ignoreContactUp = false;
		}

		this.__lastPosition = p;
		var canvasToWorld = this.worldToCanvas(this.world());
		if (canvasToWorld.containsPoint(p) == false) {
			return;
		}

		var viewport = this.viewport();
		var world = !viewport.isEmpty() ? this.world() : $.ig.Rect.prototype.empty();
		var window = !world.isEmpty() ? this.window() : $.ig.Rect.prototype.empty();
		this.anchor(this.canvasToWorld(p));
		if (window.isEmpty() == false && this.view().captureMouse()) {
			this.isPanning(true);
			window = new $.ig.Rect(0, this.anchor().__x - 0.5 * window.width(), this.anchor().__y - 0.5 * window.height(), window.width(), window.height());
			if (!this.mobileMode()) {
				this.onWindowChanging(new $.ig.PropertyChangedEventArgs$1($.ig.Rect.prototype.$type, $.ig.XamOverviewPlusDetailPane.prototype._windowPropertyName, this.window(), window));
			}

		}

	}
	, 
	__lastPosition: null

	, 
	onMouseMove: function (p, onMouseMove, isFinger) {
		if ($.ig.util.isNaN(this.anchor().__x) || $.ig.util.isNaN(this.anchor().__y)) {
			this.anchor(this.canvasToWorld(p));
		}

		var distance = $.ig.XamOverviewPlusDetailPane.prototype._dRAG_DISTANCE_NEAR;
		if (isFinger) {
			distance = $.ig.XamOverviewPlusDetailPane.prototype._dRAG_DISTANCE;
		}

		var farFromAnchor = false;
		var a = this.worldPointToCanvas(this.anchor());
		var rect = new $.ig.Rect(2, a, p);
		if (rect.width() > distance && rect.height() > distance) {
			farFromAnchor = true;
		}

		if (!this.__pinching) {
			if (farFromAnchor) {
				this.__ignoreContactUp = false;
			}

		}

		this.__lastPosition = p;
		var viewport = this.viewport();
		var world = !viewport.isEmpty() ? this.world() : $.ig.Rect.prototype.empty();
		var window = !world.isEmpty() ? this.window() : $.ig.Rect.prototype.empty();
		if (this.isPanning()) {
			var center = this.canvasToWorld(p);
			window = new $.ig.Rect(0, center.__x - 0.5 * window.width(), center.__y - 0.5 * window.height(), window.width(), window.height());
			this.onWindowChanging(new $.ig.PropertyChangedEventArgs$1($.ig.Rect.prototype.$type, $.ig.XamOverviewPlusDetailPane.prototype._windowPropertyName, this.window(), window));
		}

	}

	, 
	onMouseLeftButtonUp: function (p) {
		this.__lastPosition = p;
		var viewport = this.viewport();
		var world = !viewport.isEmpty() ? this.world() : $.ig.Rect.prototype.empty();
		var window = !world.isEmpty() ? this.window() : $.ig.Rect.prototype.empty();
		if (this.isPanning() && !this.__ignoreContactUp) {
			this.view().cancelMouseOperations();
			this.isPanning(false);
			var center = this.canvasToWorld(p);
			window = new $.ig.Rect(0, center.__x - 0.5 * window.width(), center.__y - 0.5 * window.height(), window.width(), window.height());
			if (!this.mobileMode()) {
				this.onWindowChanged(new $.ig.PropertyChangedEventArgs$1($.ig.Rect.prototype.$type, $.ig.XamOverviewPlusDetailPane.prototype._windowPropertyName, this.window(), window));
			}

			return true;
		}

		return false;
	}

	, 
	onMouseWheel: function (delta) {
		var center = $.ig.RectUtil.prototype.getCenter(this.window());
		var scale = 1 - $.ig.MathUtil.prototype.clamp(delta, -0.5, 0.5);
		var left = center.__x - scale * (center.__x - this.window().left());
		var bottom = center.__y + scale * (this.window().bottom() - center.__y);
		var right = center.__x + scale * (this.window().right() - center.__x);
		var top = center.__y - scale * (center.__y - this.window().top());
		var window = new $.ig.Rect(0, left, top, right - left, bottom - top);
		this.onWindowChanged(new $.ig.PropertyChangedEventArgs$1($.ig.Rect.prototype.$type, $.ig.XamOverviewPlusDetailPane.prototype._windowPropertyName, this.window(), window));
		return true;
	}
	, 
	__ignoreContactUp: false
	, 
	__lastDistanceRatio: 0

	, 
	onPinchStarted: function (point) {
		this.__pinching = true;
		this.__ignoreContactUp = true;
		this.__lastDistanceRatio = 1;
	}

	, 
	onPinchDelta: function (p) {
		if (this.view().useDeltaZoom()) {
			this.doDeltaZoom(p);

		} else {
			this.doZoom(p);
			this.__lastDistanceRatio = p;
		}

	}

	, 
	onPinchCompleted: function (p) {
		this.__pinching = false;
		this.__ignoreContactUp = false;
		if (this.view().useDeltaZoom()) {
			this.doDeltaZoom(p);

		} else {
			this.doZoom(p);
		}

	}

	, 
	doZoom: function (distanceRatio) {
		var distanceRatioDiff = distanceRatio - this.__lastDistanceRatio;
		if (distanceRatioDiff != 0) {
			var p = 0.03;
			var f = distanceRatioDiff < 0 ? 1 + p : 1 - p;
			var wRectCenter = {__x: this.window().x() + this.window().width() / 2, __y: this.window().y() + this.window().height() / 2, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			var wRectOrigin = {__x: this.window().x() - wRectCenter.__x, __y: this.window().y() - wRectCenter.__y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			var scaledWindowRect = new $.ig.Rect(0, wRectOrigin.__x * f + wRectCenter.__x, wRectOrigin.__y * f + wRectCenter.__y, this.window().width() * f, this.window().height() * f);
			this.onWindowChanged(new $.ig.PropertyChangedEventArgs$1($.ig.Rect.prototype.$type, $.ig.XamOverviewPlusDetailPane.prototype._windowPropertyName, this.window(), scaledWindowRect));
		}

	}

	, 
	doDeltaZoom: function (deltaZoom) {
		var f = 1 / deltaZoom;
		var wRectCenter = {__x: this.window().x() + this.window().width() / 2, __y: this.window().y() + this.window().height() / 2, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		var wRectOrigin = {__x: this.window().x() - wRectCenter.__x, __y: this.window().y() - wRectCenter.__y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		var scaledWindowRect = new $.ig.Rect(0, wRectOrigin.__x * f + wRectCenter.__x, wRectOrigin.__y * f + wRectCenter.__y, this.window().width() * f, this.window().height() * f);
		this.onWindowChanged(new $.ig.PropertyChangedEventArgs$1($.ig.Rect.prototype.$type, $.ig.XamOverviewPlusDetailPane.prototype._windowPropertyName, this.window(), scaledWindowRect));
	}
	, 
	propertyChanged: null
	, 
	onPropertyUpdated: function (propertyName, oldValue, newValue) {
		this.onPropertyChanged(new $.ig.PropertyChangedEventArgs(propertyName));
	}

	, 
	onPropertyChanged: function (e) {
		if (this.propertyChanged != null) {
			this.propertyChanged(this, e);
		}

		switch (e.propertyName()) {
			case $.ig.XamOverviewPlusDetailPane.prototype._worldPropertyName:
				this.refresh(false);
				break;
			case $.ig.XamOverviewPlusDetailPane.prototype._windowPropertyName:
				this.refresh(false);
				break;
			case $.ig.XamOverviewPlusDetailPane.prototype._previewPropertyName:
				this.refresh(false);
				break;
		}

	}

	, 
	setRenderOrigin: function () {
		this.view().setRenderOrigin();
	}

	, 
	canvasToWorld: function (point) {
		var viewport = this.viewport();
		var world = !viewport.isEmpty() ? this.world() : $.ig.Rect.prototype.empty();
		if (!world.isEmpty()) {
			var s = viewport.width() / viewport.height() > world.width() / world.height() ? viewport.height() / world.height() : viewport.width() / world.width();
			var tx = 0.5 * ((viewport.left() + viewport.right()) - (world.left() + world.right()) * s);
			var ty = 0.5 * ((viewport.top() + viewport.bottom()) - (world.top() + world.bottom()) * s);
			return {__x: (point.__x - tx) / s, __y: (point.__y - ty) / s, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		}

		return {__x: NaN, __y: NaN, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
	}

	, 
	worldPointToCanvas: function (pt) {
		var viewport = this.viewport();
		var world = !viewport.isEmpty() ? this.world() : $.ig.Rect.prototype.empty();
		if (!world.isEmpty()) {
			var s = viewport.width() / viewport.height() > world.width() / world.height() ? viewport.height() / world.height() : viewport.width() / world.width();
			var tx = 0.5 * ((viewport.left() + viewport.right()) - (world.left() + world.right()) * s);
			var ty = 0.5 * ((viewport.top() + viewport.bottom()) - (world.top() + world.bottom()) * s);
			return {__x: pt.__x * s + tx, __y: pt.__y * s + ty, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		}

		return {__x: NaN, __y: NaN, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
	}

	, 
	worldToCanvas: function (rect) {
		var viewport = this.viewport();
		var world = !viewport.isEmpty() ? this.world() : $.ig.Rect.prototype.empty();
		if (!world.isEmpty() && !rect.isEmpty()) {
			var s = viewport.width() / viewport.height() > world.width() / world.height() ? viewport.height() / world.height() : viewport.width() / world.width();
			var tx = 0.5 * ((viewport.left() + viewport.right()) - (world.left() + world.right()) * s);
			var ty = 0.5 * ((viewport.top() + viewport.bottom()) - (world.top() + world.bottom()) * s);
			return new $.ig.Rect(0, rect.left() * s + tx, rect.top() * s + ty, rect.width() * s, rect.height() * s);
		}

		return $.ig.Rect.prototype.empty();
	}

	, 
	refresh: function (immediate) {
		var $self = this;
		$self.updateSliderRanges();
		if (!immediate) {
			if (!$self.refreshPending()) {
				$self.refreshPending(true);
				$self.view().queueWork(function () { $self.refresh(true); });
			}

			return;
		}

		$self.refreshPending(false);
		var world = $self.worldToCanvas($self.world());
		var windowRect = $self.worldToCanvas($self.window());
		var preview = $self.worldToCanvas($self.preview());
		if ($self.__visibility != $.ig.Visibility.prototype.visible || world.isEmpty() || $.ig.util.isNaN(world.x()) || $.ig.util.isNaN(world.y())) {
			$self.refreshPending(false);
			return;
		}

		$self.view().updateWorldRect(world);
		$self.view().positionPreview(world);
		$self.view().updateWindowPath(world, windowRect);
		$self.view().updatePreviewPath(world, preview);
		if ($self.surfaceViewer() != null) {
			$self.surfaceViewer().renderPreview();
		}

		$self.view().makeDirty();
	}

	, 
	_updatingSliderRanges: false,
	updatingSliderRanges: function (value) {
		if (arguments.length === 1) {
			this._updatingSliderRanges = value;
			return value;
		} else {
			return this._updatingSliderRanges;
		}
	}

	, 
	updateSliderRanges: function () {
		if (this.__visibility != $.ig.Visibility.prototype.visible || this.surfaceViewer() == null || !this.view().isReady()) {
			return;
		}

		var viewportRect = this.surfaceViewer().viewportRect();
		var worldRect = this.surfaceViewer().worldRect();
		if (viewportRect.isEmpty() || worldRect.isEmpty()) {
			return;
		}

		this.updatingSliderRanges(true);
		var currentValue = this.view().getSliderValue();
		var min = this.surfaceViewer().minimumZoomLevel();
		var max = this.surfaceViewer().maximumZoomLevel();
		if ($.ig.util.isNaN(min)) {
			min = Math.min(viewportRect.width() / worldRect.width(), viewportRect.height() / worldRect.height());
			min = Math.min(min, 0.5);
			min = Math.min(min, currentValue);
		}

		if ($.ig.util.isNaN(max)) {
			max = $.ig.XamOverviewPlusDetailPane.prototype._maxZoom;
			max = Math.max(max, currentValue);
		}

		this.view().setSliderMin(min);
		this.view().setSliderMax(max);
		this.updatingSliderRanges(false);
	}

	, 
	onDefaultInteraction: function (state) {
		if (this.surfaceViewer() != null) {
			this.surfaceViewer().defaultInteraction(state);
		}

	}

	, 
	onScaleToFit: function () {
		if (this.surfaceViewer() != null) {
			this.surfaceViewer().scaleToFit();
		}

	}

	, 
	onZoomTo100: function () {
		if (this.surfaceViewer() != null) {
			this.surfaceViewer().zoomTo100();
		}

	}

	, 
	onContainerSizeChanged: function () {
		this.refresh(false);
	}

	, 
	provideContainer: function (container) {
		this.view().onContainerProvided(container);
	}

	, 
	provideContext: function (context) {
		this.view().onContextProvided(context);
	}

	, 
	provideEventSource: function (eventSource) {
		this.view().onEventSourceProvided(eventSource);
	}
	, 
	__mobileMode: false

	, 
	mobileMode: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__mobileMode;
			this.__mobileMode = value;
			if (oldValue != this.__mobileMode) {
				this.view().mobileModeChanged(this.__mobileMode);
			}

			return value;
		} else {

			return this.__mobileMode;
		}
	}

	, 
	arrange: function (rect) {
		this.view().arrange(rect);
	}

	, 
	pushZoomLevel: function (zoomLevel) {
		this.view().pushZoomLevel(zoomLevel);
	}

	, 
	onMobileClosing: function () {
		if (this.__lastPosition == null) {
			return;
		}

		var center = this.canvasToWorld(this.__lastPosition);
		var viewport = this.viewport();
		var world = !viewport.isEmpty() ? this.world() : $.ig.Rect.prototype.empty();
		var window = !world.isEmpty() ? this.window() : $.ig.Rect.prototype.empty();
		window = new $.ig.Rect(0, center.__x - 0.5 * window.width(), center.__y - 0.5 * window.height(), window.width(), window.height());
		this.onWindowChanged(new $.ig.PropertyChangedEventArgs$1($.ig.Rect.prototype.$type, $.ig.XamOverviewPlusDetailPane.prototype._windowPropertyName, this.window(), this.window()));
	}
	, 
	__pinching: false

	, 
	pinching: function () {

			return this.__pinching;
	}

	, 
	onGestureCompleted: function (pt) {
		this.__pinching = false;
		this.anchor({__x: NaN, __y: NaN, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
	}
	, 
	$type: new $.ig.Type('XamOverviewPlusDetailPane', $.ig.Control.prototype.$type, [$.ig.INotifyPropertyChanged.prototype.$type])
}, true);

$.ig.util.defType('XamOverviewPlusDetailPaneView', 'Object', {

	_model: null,
	model: function (value) {
		if (arguments.length === 1) {
			this._model = value;
			return value;
		} else {
			return this._model;
		}
	}
	, 
	init: function (model) {


		this.__scheduler = null;
		this.__isDirty = false;
		this.__loadingEle = null;
		this.__backgroundImage = null;
		this.__backgroundImageWidth = 0;
		this.__backgroundImageHeight = 0;
		this._thumbnailSize = new $.ig.Size();

		$.ig.Object.prototype.init.call(this);
			this.viewport($.ig.Rect.prototype.empty());
			this.model(model);
			this.thumbnailSize(new $.ig.Size(1, 0, 0));
	}

	, 
	_viewManager: null,
	viewManager: function (value) {
		if (arguments.length === 1) {
			this._viewManager = value;
			return value;
		} else {
			return this._viewManager;
		}
	}

	, 
	onInit: function () {
		var $self = this;
		$self.animator(new $.ig.DoubleAnimator(0, 1, 300));
		$self.animator().propertyChanged = $.ig.Delegate.prototype.combine($self.animator().propertyChanged, $self.animator_PropertyChanged.runOn($self));
		$self.animationEnabled(true);
		$self.viewManager(new $.ig.XamOverviewPlusDetailPaneViewManager($self));
		var model_ = $self.model();
		var isTouch_ = typeof Modernizr !== 'undefined' && Modernizr.touch || ($self.viewManager().jqueryMobilePresent() && $.support.touch);
		model_.mobileMode(isTouch_);
		$self.worldPath((function () { var $ret = new $.ig.Path();
		$ret.isHitTestVisible(true);
		$ret.data(new $.ig.RectangleGeometry()); return $ret;}()));
		($self.worldPath().data()).rect($.ig.Rect.prototype.empty());
		$self.backgroundPath((function () { var $ret = new $.ig.Path();
		$ret.isHitTestVisible(true);
		$ret.data(new $.ig.RectangleGeometry()); return $ret;}()));
		$self.windowPath((function () { var $ret = new $.ig.Path();
		$ret.isHitTestVisible(false);
		$ret.data(new $.ig.GeometryGroup()); return $ret;}()));
		($.ig.util.cast($.ig.GeometryGroup.prototype.$type, $self.windowPath().data())).children().add(new $.ig.PathGeometry());
		($.ig.util.cast($.ig.GeometryGroup.prototype.$type, $self.windowPath().data())).children().add(new $.ig.PathGeometry());
		$self.previewPath((function () { var $ret = new $.ig.Path();
		$ret.isHitTestVisible(false);
		$ret.data(new $.ig.GeometryGroup()); return $ret;}()));
		($.ig.util.cast($.ig.GeometryGroup.prototype.$type, $self.previewPath().data())).children().add(new $.ig.PathGeometry());
		($.ig.util.cast($.ig.GeometryGroup.prototype.$type, $self.previewPath().data())).children().add(new $.ig.PathGeometry());
		$self.startingProgress(0);
		$self.transitionProgress(0);
		$self.disableZooms(false);
	}

	, 
	animator_PropertyChanged: function (sender, e) {
		if (this.isOpen()) {
			this.transitionProgress(this.startingProgress() + this.animator().transitionProgress() * (1 - this.startingProgress()));

		} else {
			this.transitionProgress(this.startingProgress() - this.animator().transitionProgress() * this.startingProgress());
		}

		if (this.transitionProgress() >= 1) {
			this.settingsVisible(true);
			this.arrange(this.fullSize());
			this.model().refresh(false);

		} else if (this.settingsVisible()) {
			this.settingsVisible(false);
			this.viewManager().hideSettingsPanel();
			this.arrange(this.fullSize());
			this.model().refresh(false);
		}


		this.makeDirty();
	}

	, 
	_useMobileOpd: false,
	useMobileOpd: function (value) {
		if (arguments.length === 1) {
			this._useMobileOpd = value;
			return value;
		} else {
			return this._useMobileOpd;
		}
	}

	, 
	_settingsVisible: false,
	settingsVisible: function (value) {
		if (arguments.length === 1) {
			this._settingsVisible = value;
			return value;
		} else {
			return this._settingsVisible;
		}
	}

	, 
	_animator: null,
	animator: function (value) {
		if (arguments.length === 1) {
			this._animator = value;
			return value;
		} else {
			return this._animator;
		}
	}

	, 
	_startingProgress: 0,
	startingProgress: function (value) {
		if (arguments.length === 1) {
			this._startingProgress = value;
			return value;
		} else {
			return this._startingProgress;
		}
	}

	, 
	_transitionProgress: 0,
	transitionProgress: function (value) {
		if (arguments.length === 1) {
			this._transitionProgress = value;
			return value;
		} else {
			return this._transitionProgress;
		}
	}

	, 
	_animationEnabled: false,
	animationEnabled: function (value) {
		if (arguments.length === 1) {
			this._animationEnabled = value;
			return value;
		} else {
			return this._animationEnabled;
		}
	}

	, 
	_isOpen: false,
	isOpen: function (value) {
		if (arguments.length === 1) {
			this._isOpen = value;
			return value;
		} else {
			return this._isOpen;
		}
	}

	, 
	goToFullState: function () {
		if (this.isOpen()) {
			return;
		}

		this.isOpen(true);
		if (this.animationEnabled()) {
			this.startingProgress(this.transitionProgress());
			this.animator().stop();
			this.animator().start();

		} else {
			this.startingProgress(1);
			this.transitionProgress(1);
			this.makeDirty();
		}

	}

	, 
	goToCompactState: function () {
	}

	, 
	goToMinimalState: function () {
		if (!this.isOpen()) {
			return;
		}

		this.isOpen(false);
		if (this.animationEnabled()) {
			this.startingProgress(this.transitionProgress());
			this.animator().stop();
			this.animator().start();

		} else {
			this.startingProgress(1);
			this.transitionProgress(1);
			this.makeDirty();
		}

	}

	, 
	goToZoomEnabledState: function () {
	}

	, 
	goToZoomDisabledState: function () {
	}

	, 
	_worldPath: null,
	worldPath: function (value) {
		if (arguments.length === 1) {
			this._worldPath = value;
			return value;
		} else {
			return this._worldPath;
		}
	}

	, 
	_windowPath: null,
	windowPath: function (value) {
		if (arguments.length === 1) {
			this._windowPath = value;
			return value;
		} else {
			return this._windowPath;
		}
	}

	, 
	_previewPath: null,
	previewPath: function (value) {
		if (arguments.length === 1) {
			this._previewPath = value;
			return value;
		} else {
			return this._previewPath;
		}
	}

	, 
	_backgroundPath: null,
	backgroundPath: function (value) {
		if (arguments.length === 1) {
			this._backgroundPath = value;
			return value;
		} else {
			return this._backgroundPath;
		}
	}
	, 
	__viewport: null

	, 
	viewport: function (value) {
		if (arguments.length === 1) {

			this.__viewport = value;
			if (this.eventProxy() != null) {
				this.eventProxy().viewport(this.__viewport);
			}

			return value;
		} else {

			return this.__viewport;
		}
	}

	, 
	setRenderOrigin: function () {
	}

	, 
	_worldRect: null,
	worldRect: function (value) {
		if (arguments.length === 1) {
			this._worldRect = value;
			return value;
		} else {
			return this._worldRect;
		}
	}

	, 
	_imageRect: null,
	imageRect: function (value) {
		if (arguments.length === 1) {
			this._imageRect = value;
			return value;
		} else {
			return this._imageRect;
		}
	}

	, 
	updateWorldRect: function (world) {
		this.worldRect(world);
		if (this.backgroundImage() != null) {
			var img_ = this.backgroundImage();
			var widthScale = world.width() / this.__backgroundImageWidth;
			var heightScale = world.height() / this.__backgroundImageHeight;
			var scale = (widthScale < heightScale) ? widthScale : heightScale;
			var renderWidth = this.__backgroundImageWidth * scale;
			var renderHeight = this.__backgroundImageHeight * scale;
			var widthDiff = world.width() - renderWidth;
			var heightDiff = world.height() - renderHeight;
			this.imageRect(new $.ig.Rect(0, this.worldRect().left() + (widthDiff / 2), this.worldRect().top() + (heightDiff / 2), renderWidth, renderHeight));
		}

		(this.worldPath().data()).rect(world);
		this.worldPath().__visibility = world.isEmpty() ? $.ig.Visibility.prototype.collapsed : $.ig.Visibility.prototype.visible;
	}

	, 
	updateWindowPath: function (world, window) {
		((this.windowPath().data()).children().__inner[0]).figures(this.toClockwisePath($.ig.RectUtil.prototype.inflate(world, 2)));
		((this.windowPath().data()).children().__inner[1]).figures(this.toAntiClockwisePath(window));
		this.windowPath().__visibility = window.isEmpty() ? $.ig.Visibility.prototype.collapsed : $.ig.Visibility.prototype.visible;
	}

	, 
	updatePreviewPath: function (world, preview) {
		((this.previewPath().data()).children().__inner[0]).figures(this.toClockwisePath($.ig.RectUtil.prototype.inflate(world, 2)));
		((this.previewPath().data()).children().__inner[1]).figures(this.toAntiClockwisePath(preview));
		this.previewPath().__visibility = preview.isEmpty() ? $.ig.Visibility.prototype.collapsed : $.ig.Visibility.prototype.visible;
	}

	, 
	toAntiClockwisePath: function (rect) {
		var figures = new $.ig.PathFigureCollection();
		var figure = new $.ig.PathFigure();
		figure.__isClosed = true;
		figure.__startPoint = {__x: rect.left(), __y: rect.top(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		figure.__segments.add(new $.ig.LineSegment(0, {__x: rect.left(), __y: rect.bottom(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		figure.__segments.add(new $.ig.LineSegment(0, {__x: rect.right(), __y: rect.bottom(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		figure.__segments.add(new $.ig.LineSegment(0, {__x: rect.right(), __y: rect.top(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		figure.__segments.add(new $.ig.LineSegment(0, {__x: rect.left(), __y: rect.top(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		figures.add(figure);
		return figures;
	}

	, 
	toClockwisePath: function (rect) {
		var figures = new $.ig.PathFigureCollection();
		var figure = new $.ig.PathFigure();
		figure.__isClosed = true;
		figure.__startPoint = {__x: rect.left(), __y: rect.top(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		figure.__segments.add(new $.ig.LineSegment(0, {__x: rect.right(), __y: rect.top(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		figure.__segments.add(new $.ig.LineSegment(0, {__x: rect.right(), __y: rect.bottom(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		figure.__segments.add(new $.ig.LineSegment(0, {__x: rect.left(), __y: rect.bottom(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		figure.__segments.add(new $.ig.LineSegment(0, {__x: rect.left(), __y: rect.top(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		figures.add(figure);
		return figures;
	}

	, 
	setSurfaceBindings: function () {
	}

	, 
	isReady: function () {
		return this.context() != null;
	}

	, 
	cancelMouseOperations: function () {
	}

	, 
	captureMouse: function () {
		return true;
	}

	, 
	positionPreview: function (world) {
		var sizeChanged = false;
		if (Math.round(this.thumbnailSize().width()) != Math.round(world.width())) {
			sizeChanged = true;
			this.viewManager().updateThumbnailWidth(world.width());
		}

		if (Math.round(this.thumbnailSize().height()) != Math.round(world.height())) {
			sizeChanged = true;
			this.viewManager().updateThumbnailHeight(world.height());
		}

		var oldSize = this.thumbnailSize();
		this.thumbnailSize(new $.ig.Size(1, world.width(), world.height()));
		if (sizeChanged) {
			this.model().onThumbnailSizeChanged(new $.ig.PropertyChangedEventArgs$1($.ig.Size.prototype.$type, "ThumbnailSize", oldSize, this.thumbnailSize()));
		}

	}

	, 
	_context: null,
	context: function (value) {
		if (arguments.length === 1) {
			this._context = value;
			return value;
		} else {
			return this._context;
		}
	}

	, 
	onContextProvided: function (context) {
		this.context(context);
	}
	, 
	__scheduler: null

	, 
	scheduler: function (value) {
		if (arguments.length === 1) {

			if (this.__scheduler != null) {
				this.__scheduler.unRegister(this);
			}

			this.__scheduler = value;
			if (this.__scheduler != null) {
				this.__scheduler.register(this);
				this.makeDirty();
			}

			return value;
		} else {

			return this.__scheduler;
		}
	}

	, 
	makeDirty: function () {
		if (!this.__isDirty && this.scheduler() != null) {
			this.__isDirty = true;
			this.scheduler().schedule();
		}

	}
	, 
	__isDirty: false

	, 
	isDirty: function (value) {
		if (arguments.length === 1) {

			this.__isDirty = value;
			return value;
		} else {

			return this.__isDirty;
		}
	}
	, 
	__backgroundImageUri: null
	, 
	__loadingEle: null

	, 
	backgroundImageUri: function (value) {
		if (arguments.length === 1) {

			this.__backgroundImageUri = value;
			if (this.__backgroundImageUri != null) {
				this.__loadingEle = $("<img></img>");
				var img = this.__loadingEle[0];
				var self_ = this;
				var ele_ = this.__loadingEle;
				ele_.bind('load readystatechange', function(e) { if (this.complete || (this.readyState == 'complete' && e.type == 'readystatechange')) { self_.downloadCompleted(e) }});
				img.src = this.__backgroundImageUri;

			} else {
				if (this.__loadingEle != null) {
					var ele_ = this.__loadingEle;
					ele_.unbind("load readystatechange");
					this.__loadingEle = null;
				}

				this.backgroundImage(null);
			}

			return value;
		} else {

			return this.__backgroundImageUri;
		}
	}

	, 
	downloadCompleted: function (e) {
		if (!(this.__loadingEle[0]).complete) {
			return;
		}

		this.backgroundImage(this.__loadingEle[0]);
	}
	, 
	__backgroundImage: null
	, 
	__backgroundImageWidth: 0
	, 
	__backgroundImageHeight: 0

	, 
	backgroundImage: function (value) {
		if (arguments.length === 1) {

			this.__backgroundImage = value;
			if (this.__backgroundImage != null) {
				var img_ = this.__backgroundImage;
				this.__backgroundImageWidth = img_.width;
				this.__backgroundImageHeight = img_.height;

			} else {
				this.__backgroundImageWidth = 0;
				this.__backgroundImageHeight = 0;
			}

			if (this.worldRect() != null) {
				this.updateWorldRect(this.worldRect());
			}

			this.makeDirty();
			return value;
		} else {

			return this.__backgroundImage;
		}
	}

	, 
	undirty: function (clearRect) {
		this.isDirty(false);
		if (this.context() == null) {
			return;
		}

		if (this.model().__visibility == $.ig.Visibility.prototype.collapsed) {
			return;
		}

		if (this.context().shouldRender()) {
			var scaleX = 1;
			var scaleY = 1;
			var opacity = 1;
			scaleX = 0.6 + this.transitionProgress() * (1 - 0.6);
			scaleY = 0.6 + this.transitionProgress() * (1 - 0.6);
			opacity = 0.7 + this.transitionProgress() * (1 - 0.7);
			this.backgroundPath().__opacity = opacity;
			this.backgroundPath().strokeThickness(1);
			this.viewManager().setBackgroundPathDefaults(this.backgroundPath());
			this.worldPath().__opacity = opacity;
			this.worldPath().strokeThickness(1);
			this.viewManager().setWorldPathDefaults(this.worldPath());
			this.windowPath().__opacity = opacity;
			this.windowPath().strokeThickness(1.5);
			this.viewManager().setWindowPathDefaults(this.windowPath());
			this.previewPath().__opacity = opacity;
			this.previewPath().strokeThickness(2);
			this.viewManager().setPreviewPathDefaults(this.previewPath());
			var rect = (this.worldPath().data()).rect();
			if (rect.isEmpty()) {
				return;
			}

			this.context().save();
			this.context().translate(this.fullSize().right(), this.fullSize().bottom());
			this.context().scale(scaleX, scaleY);
			this.context().translate(-this.fullSize().right(), -this.fullSize().bottom());
			this.context().renderPath(this.backgroundPath());
			this.viewManager().drawThumbnailImage(this.context(), rect);
			this.context().setRectangleClip(rect);
			this.context().renderPath(this.worldPath());
			if (this.backgroundImage() != null) {
				this.context().drawImage(this.backgroundImage(), opacity, this.imageRect().left(), this.imageRect().top(), this.imageRect().width(), this.imageRect().height());
			}

			this.context().renderPath(this.previewPath());
			this.context().renderPath(this.windowPath());
			this.context().restore();
		}

	}

	, 
	index: function () {

			return 10000;
	}

	, 
	postRender: function () {
	}

	, 
	updateInteractionButtonStates: function (activeState) {
	}

	, 
	onContainerProvided: function (container) {
		this.mSPointerEnabled(window.navigator.msPointerEnabled);
		if (this.mSPointerEnabled()) {
			this.useDeltaZoom(true);
		}

		if (container == null) {
			if (this.eventProxy() != null) {
				this.eventProxy().destroy();
			}

			this.viewManager().onContainerProvided(null);
			this.thumbnailContext(null);
			this.eventProxy(null);
			return;
		}

		this.viewManager().onContainerProvided(container);
		this.thumbnailContext(this.viewManager().thumbnailContext());
	}

	, 
	updateZoomLevel: function (value) {
		if (!this.disableZooms()) {
			var val_ = value;
			var obj_ = this.model().surfaceViewer();
			obj_.zoomLevel(val_);
		}

	}

	, 
	_eventProxy: null,
	eventProxy: function (value) {
		if (arguments.length === 1) {
			this._eventProxy = value;
			return value;
		} else {
			return this._eventProxy;
		}
	}

	, 
	onEventSourceProvided: function (eventSource) {
		var $self = this;
		if (eventSource == null) {
			return;
		}

		$self.eventProxy(eventSource.clone());
		$self.eventProxy().shouldInteract($self.shouldInteract.runOn($self));
		$self.eventProxy().onMouseWheel = $.ig.Delegate.prototype.combine($self.eventProxy().onMouseWheel, function (p, d) { return $self.model().onMouseWheel(d); });
		$self.eventProxy().onPinchDelta = $.ig.Delegate.prototype.combine($self.eventProxy().onPinchDelta, function (p, d) { $self.model().onPinchDelta(d); });
		$self.eventProxy().onPinchStarted = $.ig.Delegate.prototype.combine($self.eventProxy().onPinchStarted, function (p, d) { $self.model().onPinchStarted(p); });
		$self.eventProxy().onGestureCompleted = $.ig.Delegate.prototype.combine($self.eventProxy().onGestureCompleted, function (p, d) { $self.model().onGestureCompleted(p); });
		$self.eventProxy().onMouseUp = $.ig.Delegate.prototype.combine($self.eventProxy().onMouseUp, function (p) { $self.model().onMouseLeftButtonUp(p); });
		$self.eventProxy().onMouseDown = $.ig.Delegate.prototype.combine($self.eventProxy().onMouseDown, $self.model().onMouseLeftButtonDown.runOn($self.model()));
		$self.eventProxy().onMouseEnter = $.ig.Delegate.prototype.combine($self.eventProxy().onMouseEnter, function (p) { $self.model().onMouseEnter(); });
		$self.eventProxy().onMouseOver = $.ig.Delegate.prototype.combine($self.eventProxy().onMouseOver, function (p, mo, f) { $self.model().onMouseMove(p, mo, f); });
		$self.eventProxy().onKeyDown = $.ig.Delegate.prototype.combine($self.eventProxy().onKeyDown, $self.model().onKeyDown.runOn($self.model()));
		$self.eventProxy().onMouseLeave = $.ig.Delegate.prototype.combine($self.eventProxy().onMouseLeave, $self.mouseLeave.runOn($self));
		$self.eventProxy().viewport($self.viewport());
		$self.viewManager().eventProxy($self.eventProxy());
	}

	, 
	mouseLeave: function (p) {
		if (!this.shouldInteract({__x: this.viewport().left() + p.__x, __y: this.viewport().top() + p.__y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName})) {
			this.model().onMouseLeave();
		}

	}

	, 
	shouldInteract: function (p) {
		if (p == null) {
			return false;
		}

		if (this.model().__visibility != $.ig.Visibility.prototype.visible) {
			return false;
		}

		var mouseX = p.__x;
		var mouseY = p.__y;
		if (mouseX >= this.fullSize().left() && mouseY >= this.fullSize().top() && mouseX < this.fullSize().left() + this.fullSize().width() && mouseY < this.fullSize().top() + this.fullSize().height()) {
			return true;
		}

		return false;
	}

	, 
	mobileModeChanged: function (mobileMode) {
		if (mobileMode) {
			this.animationEnabled(false);
			if (this.viewManager() != null && this.model().__visibility == $.ig.Visibility.prototype.visible) {
				this.viewManager().enableMobileOPD();
			}


		} else {
			this.animationEnabled(true);
			if (this.viewManager() != null) {
				this.viewManager().disableMobileOPD();
				this.goToMinimalState();
				this.transitionProgress(0);
				this.startingProgress(0);
				this.viewManager().hideSettingsPanel();
			}

		}

	}

	, 
	_fullSize: null,
	fullSize: function (value) {
		if (arguments.length === 1) {
			this._fullSize = value;
			return value;
		} else {
			return this._fullSize;
		}
	}

	, 
	arrange: function (rect) {
		this.fullSize(rect);
		(this.backgroundPath().data()).rect(this.fullSize());
		var height = rect.height() - 4;
		var width = rect.width() - 4;
		if (this.transitionProgress() >= 1 && !this.model().mobileMode()) {
			height -= 20;
			this.viewManager().showSettingsPanel(this.fullSize(), width, height);
		}

		if (this.viewManager().mobilePanel() != null) {
			if (this.useMobileOpd()) {
			this.viewManager().mobilePanel().show();

			} else {
			this.viewManager().hideMobileOPD(true);
			}

		}

		this.viewport(new $.ig.Rect(0, this.fullSize().left() + 2, this.fullSize().top() + 2, width, height));
		this.makeDirty();
	}

	, 
	_disableZooms: false,
	disableZooms: function (value) {
		if (arguments.length === 1) {
			this._disableZooms = value;
			return value;
		} else {
			return this._disableZooms;
		}
	}

	, 
	pushZoomLevel: function (zoomLevel) {
		this.disableZooms(true);
		this.viewManager().changeSliderZoomLevel(zoomLevel);
		this.disableZooms(false);
	}

	, 
	onZoomTo100: function () {
		this.model().onZoomTo100();
	}

	, 
	_thumbnailContext: null,
	thumbnailContext: function (value) {
		if (arguments.length === 1) {
			this._thumbnailContext = value;
			return value;
		} else {
			return this._thumbnailContext;
		}
	}

	, 
	_thumbnailSize: null,
	thumbnailSize: function (value) {
		if (arguments.length === 1) {
			this._thumbnailSize = value;
			return value;
		} else {
			return this._thumbnailSize;
		}
	}

	, 
	positionImage: function (world) {
	}

	, 
	settingsMouseLeave: function (mouseX, mouseY) {
		if (!this.shouldInteract({__x: mouseX, __y: mouseY, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName})) {
			this.model().onMouseLeave();
		}

	}

	, 
	getSliderValue: function () {
		return this.viewManager().getSliderValue();
	}

	, 
	setSliderMin: function (min) {
		this.viewManager().setSliderMin(min);
	}

	, 
	setSliderMax: function (max) {
		this.viewManager().setSliderMax(max);
	}

	, 
	queueWork: function (work) {
		this.viewManager().queueWork(work);
	}

	, 
	onMobileClosing: function () {
		this.model().onMobileClosing();
	}

	, 
	_useDeltaZoom: false,
	useDeltaZoom: function (value) {
		if (arguments.length === 1) {
			this._useDeltaZoom = value;
			return value;
		} else {
			return this._useDeltaZoom;
		}
	}

	, 
	_mSPointerEnabled: false,
	mSPointerEnabled: function (value) {
		if (arguments.length === 1) {
			this._mSPointerEnabled = value;
			return value;
		} else {
			return this._mSPointerEnabled;
		}
	}

	, 
	preRender: function () {
	}
	, 
	$type: new $.ig.Type('XamOverviewPlusDetailPaneView', $.ig.Object.prototype.$type, [$.ig.ISchedulableRender.prototype.$type])
}, true);

$.ig.util.defType('XamOverviewPlusDetailPaneViewManager', 'Object', {

	_thumbnailCanvas: null,
	thumbnailCanvas: function (value) {
		if (arguments.length === 1) {
			this._thumbnailCanvas = value;
			return value;
		} else {
			return this._thumbnailCanvas;
		}
	}

	, 
	_thumbnailContext: null,
	thumbnailContext: function (value) {
		if (arguments.length === 1) {
			this._thumbnailContext = value;
			return value;
		} else {
			return this._thumbnailContext;
		}
	}

	, 
	_container: null,
	container: function (value) {
		if (arguments.length === 1) {
			this._container = value;
			return value;
		} else {
			return this._container;
		}
	}

	, 
	_settingsPanel: null,
	settingsPanel: function (value) {
		if (arguments.length === 1) {
			this._settingsPanel = value;
			return value;
		} else {
			return this._settingsPanel;
		}
	}

	, 
	_mobilePanel: null,
	mobilePanel: function (value) {
		if (arguments.length === 1) {
			this._mobilePanel = value;
			return value;
		} else {
			return this._mobilePanel;
		}
	}

	, 
	_slider: null,
	slider: function (value) {
		if (arguments.length === 1) {
			this._slider = value;
			return value;
		} else {
			return this._slider;
		}
	}

	, 
	_sliderEnabled: false,
	sliderEnabled: function (value) {
		if (arguments.length === 1) {
			this._sliderEnabled = value;
			return value;
		} else {
			return this._sliderEnabled;
		}
	}

	, 
	_isJqueryMobile: false,
	isJqueryMobile: function (value) {
		if (arguments.length === 1) {
			this._isJqueryMobile = value;
			return value;
		} else {
			return this._isJqueryMobile;
		}
	}
	, 
	__overviewText: null
	, 
	__closeText: null
	, 
	__zoomInText: null
	, 
	__zoomOutText: null
	, 
	__resetZoomText: null
	, 
	__owner: null
	, 
	init: function (owner) {


		this.__overviewText = "Overview";
		this.__closeText = "Close";
		this.__zoomInText = "Zoom In";
		this.__zoomOutText = "Zoom Out";
		this.__resetZoomText = "Reset Zoom";
		this.__mobileOPDShown = false;

		$.ig.Object.prototype.init.call(this);
			this.__owner = owner;
			this.isJqueryMobile(typeof $.mobile !== 'undefined' && $.mobile !== null);
			var overview_ = null;
			if ($.ig.Chart && $.ig.Chart.locale && $.ig.Chart.locale.overview) { overview_ = $.ig.Chart.locale.overview };
			var close_ = null;
			if ($.ig.Chart && $.ig.Chart.locale && $.ig.Chart.locale.close) { close_ = $.ig.Chart.locale.close };
			var zoomIn_ = null;
			if ($.ig.Chart && $.ig.Chart.locale && $.ig.Chart.locale.zoomIn) { zoomIn_ = $.ig.Chart.locale.zoomIn };
			var zoomOut_ = null;
			if ($.ig.Chart && $.ig.Chart.locale && $.ig.Chart.locale.zoomOut) { zoomOut_ = $.ig.Chart.locale.zoomOut };
			var resetZoom_ = null;
			if ($.ig.Chart && $.ig.Chart.locale && $.ig.Chart.locale.resetZoom) { resetZoom_ = $.ig.Chart.locale.resetZoom };
			if (overview_ != null) {
				this.__overviewText = overview_;
			}

			if (close_ != null) {
				this.__closeText = close_;
			}

			if (zoomIn_ != null) {
				this.__zoomInText = zoomIn_;
			}

			if (zoomOut_ != null) {
				this.__zoomOutText = zoomOut_;
			}

			if (resetZoom_ != null) {
				this.__resetZoomText = resetZoom_;
			}

			this.thumbnailCanvas($("<canvas></canvas>"));
			this.thumbnailContext(new $.ig.RenderingContext(new $.ig.CanvasViewRenderer(), (this.thumbnailCanvas()[0]).getContext("2d")));
	}

	, 
	_zoomIn: null,
	zoomIn: function (value) {
		if (arguments.length === 1) {
			this._zoomIn = value;
			return value;
		} else {
			return this._zoomIn;
		}
	}

	, 
	_zoomOut: null,
	zoomOut: function (value) {
		if (arguments.length === 1) {
			this._zoomOut = value;
			return value;
		} else {
			return this._zoomOut;
		}
	}

	, 
	_zoom100: null,
	zoom100: function (value) {
		if (arguments.length === 1) {
			this._zoom100 = value;
			return value;
		} else {
			return this._zoom100;
		}
	}

	, 
	onContainerProvided: function (container) {
		if (container == null) {
			this.unbind();
			this.container(null);
			this.settingsPanel(null);
			this.slider(null);
			return;
		}

		this.container($(container));
		var settingsPanel = $("<div class=\"ui-chart-toolbar\"></div>");
		settingsPanel.hide();
		this.settingsPanel(settingsPanel);
		this.container().append(settingsPanel);
		this.mobileRender();
		if (!this.__owner.model().mobileMode()) {
			this.hideMobileOPD(true);
		}

		var items = $("<ul class=\"ui-widget\" style=\"margin: 0; padding: 0\"></ul>");
		settingsPanel.append(items);
		var sliderHolder = $("<div class=\"ui-chart-slider\"></div>");
		var slider_ = this.isJqueryMobile() ? $("<input type=\'range\' style=\'display:none;\' max=\'100\' min=\'0\' />") : $("<div></div>");
		sliderHolder.append(slider_);
		this.slider(slider_);
		if (slider_.slider) { slider_.slider({mini: true}); this.sliderEnabled(true); };
		if (this.sliderEnabled()) {
			slider_.bind(this.isJqueryMobile() ? "change" : "slide", this.slideChanged.runOn(this));
		}

		var zoomout_ = $("<button></button>");
		var zoomin_ = $("<button></button>");
		var zoom100_ = $("<button></button>");
		var zoomOutText_ = this.__zoomOutText;
		var zoomInText_ = this.__zoomInText;
		var resetZoomText_ = this.__resetZoomText;
		if (this.isJqueryMobile()) {
			zoomout_ = $("<div title=" + zoomOutText_ + "></div>");
			zoomout_.buttonMarkup({ iconpos: "notext", icon: "zoomout", mini: true, inline: true, corners: false });
			zoomin_ = $("<div title=" + zoomInText_ + "></div>");
			zoomin_.buttonMarkup({ iconpos: "notext", icon: "zoomin", mini: true, inline: true, corners: false });
			zoom100_ = $("<div title=" + resetZoomText_ + "></div>");
			zoom100_.buttonMarkup({ iconpos: "notext", icon: "reset", mini: true, inline: true, corners: false });

		} else {
			zoomout_.button({ icons: { primary: "ui-icon-zoomout"}, label: zoomOutText_, text: false });
			zoomin_.button({ icons: { primary: "ui-icon-zoomin"}, label: zoomInText_, text: false });
			zoom100_.button({ icons: { primary: "ui-icon-arrow-4-diag"}, label: resetZoomText_, text: false });
		}

		zoomout_.click(this.zoomOutClicked.runOn(this));
		zoomin_.click(this.zoomInClicked.runOn(this));
		zoom100_.click(this.zoom100Clicked.runOn(this));
		this.zoomOut(zoomout_);
		this.zoomIn(zoomin_);
		this.zoom100(zoom100_);
		this.addToUL(items, zoomout_, true);
		this.addToUL(items, sliderHolder, false);
		this.addToUL(items, zoomin_, true);
		this.addToUL(items, zoom100_, true);
		settingsPanel.mouseleave(this.settingsMouseLeave.runOn(this));
	}

	, 
	unbind: function () {
		if (this.mobilePanel() != null) {
			this.mobilePanel().unbind("click");
		}

		if (this.zoomOut() != null) {
			this.zoomOut().unbind("click");
		}

		if (this.zoomIn() != null) {
			this.zoomIn().unbind("click");
		}

		if (this.zoom100() != null) {
			this.zoom100().unbind("click");
		}

		if (this.sliderEnabled()) {
			this.slider().unbind(this.isJqueryMobile() ? "change" : "slide");
		}

		this.zoomIn(null);
		this.zoomOut(null);
		this.zoom100(null);
		this.slider(null);
		this.mobilePanel(null);
	}

	, 
	mobileRender: function () {
		var closeIcon_ = $("<button toggle=\"closed\" class=\"ui-chart-opd-button\"></button>");
		var overview_ = this.__overviewText;
		if (this.isJqueryMobile()) {
			closeIcon_ = $("<div toggle=\"closed\" class=\"ui-chart-opd-button\"></div>");
			closeIcon_.html(overview_).buttonMarkup({ icon: "arrow-d", iconpos: "left"  });

		} else {
		closeIcon_.button({ icons: { secondary: "ui-icon-carat-1-s"}, label: overview_ });
		}

		if (!this.__owner.useMobileOpd()) {
			closeIcon_.hide();
		}

		closeIcon_.click(this.toggleOpd.runOn(this));
		this.mobilePanel(closeIcon_);
		this.container().append(closeIcon_);
	}

	, 
	settingsMouseLeave: function (e) {
		$.ig.DOMEventProxy.prototype.fixEvent(e);
		var offsets = this.eventProxy().getSourceOffsets();
		var mouseX = e.pageX - offsets.__x;
		var mouseY = e.pageY - offsets.__y;
		this.__owner.settingsMouseLeave(mouseX, mouseY);
	}

	, 
	addToUL: function (items, item, stateDefault) {
		var classString = "";
		if (stateDefault) {
			classString = "class=\"ui-corner-all\" ";
		}

		var li = $("<li></li>");
		if (stateDefault) {
			li.mousedown($.ig.XamOverviewPlusDetailPaneViewManager.prototype.buttonMouseDown).mouseup($.ig.XamOverviewPlusDetailPaneViewManager.prototype.buttonMouseUp).hover($.ig.XamOverviewPlusDetailPaneViewManager.prototype.buttonHoverIn, $.ig.XamOverviewPlusDetailPaneViewManager.prototype.buttonHoverOut);

		} else {
			li.addClass("ui-chart-slider-holder");
		}

		li.append(item);
		items.append(li);
	}

	, 
	zoomOutClicked: function (e) {
		this.changeSliderZoomLevel(this.getSliderValue() - 0.05);
		this.__owner.updateZoomLevel(this.getSliderValue());
		e.preventDefault();
	}

	, 
	zoomInClicked: function (e) {
		this.changeSliderZoomLevel(this.getSliderValue() + 0.05);
		this.__owner.updateZoomLevel(this.getSliderValue());
		e.preventDefault();
	}

	, 
	changeSliderZoomLevel: function (zoomLevel_) {
		if (this.sliderEnabled()) {
			var slider_ = this.slider();
			if (this.isJqueryMobile()) {
			slider_.slider("refresh", Math.round(zoomLevel_ * 100.0), true, false);

			} else {
			slider_.slider("option", "value", Math.round(zoomLevel_ * 100.0));
			}

		}

	}

	, 
	zoom100Clicked: function (e) {
		this.__owner.onZoomTo100();
		e.preventDefault();
	}

	, 
	toggleOpd: function (e) {
		if (this.mobilePanel().attr("toggle") == "closed" || (this.isJqueryMobile() && this.mobilePanel().attr("data-toggle") == "closed")) {
			this.showMobileOPD();

		} else {
			this.hideMobileOPD(false);
		}

		this.__owner.model().refresh(true);
		e.preventDefault();
	}

	, 
	getSliderValue: function () {
		if (this.sliderEnabled()) {
			var slider_ = this.slider();
			if (this.isJqueryMobile()) {
				return parseInt(slider_.val() || 0) / 100;

			} else {
			return slider_.slider("option", "value") / 100;
			}


		} else {
			return 0;
		}

	}

	, 
	setSliderMin: function (minimum) {
		var min_ = Math.round(minimum * 100);
		if (this.sliderEnabled()) {
			var slider_ = this.slider();
			if (this.isJqueryMobile()) {
			slider_.attr("min", min_);

			} else {
			slider_.slider("option", "min", min_);
			}

		}

	}

	, 
	setSliderMax: function (maximum) {
		var max_ = Math.round(maximum * 100);
		if (this.sliderEnabled()) {
			var slider_ = this.slider();
			if (this.isJqueryMobile()) {
			slider_.attr("max", max_);

			} else {
			slider_.slider("option", "max", max_);
			}

		}

	}

	, 
	buttonMouseDown: function (e) {
	}

	, 
	buttonMouseUp: function (e) {
	}

	, 
	buttonHoverIn: function (e) {
	}

	, 
	buttonHoverOut: function (e) {
	}

	, 
	slideChanged: function (e_, ui_) {
		var val = (ui_ ? ui_.value : e_.target.value) / 100;
		this.__owner.updateZoomLevel(val);
	}

	, 
	updateThumbnailWidth: function (width) {
		this.thumbnailCanvas().attr("width", width.toString());
	}

	, 
	updateThumbnailHeight: function (height) {
		this.thumbnailCanvas().attr("height", height.toString());
	}

	, 
	setBackgroundPathDefaults: function (backgroundPath) {
		var $self = this;
		backgroundPath.__stroke = (function () { var $ret = new $.ig.Brush();
		$ret.fill("#AEB8C2"); return $ret;}());
		backgroundPath.__fill = (function () { var $ret = new $.ig.Brush();
		$ret.fill("#C6CFD9"); return $ret;}());
	}

	, 
	setWorldPathDefaults: function (worldPath) {
		var $self = this;
		worldPath.__stroke = (function () { var $ret = new $.ig.Brush();
		$ret.fill("rgba(92,105,124,.4)"); return $ret;}());
		worldPath.__fill = (function () { var $ret = new $.ig.Brush();
		$ret.fill("rgba(147,159,175,0)"); return $ret;}());
	}

	, 
	setWindowPathDefaults: function (windowPath) {
		var $self = this;
		windowPath.__stroke = (function () { var $ret = new $.ig.Brush();
		$ret.fill("rgba(68,76,88,.6)"); return $ret;}());
		windowPath.__fill = (function () { var $ret = new $.ig.Brush();
		$ret.fill("rgba(92,105,118,.1)"); return $ret;}());
	}

	, 
	setPreviewPathDefaults: function (previewPath) {
		var $self = this;
		previewPath.__stroke = (function () { var $ret = new $.ig.Brush();
		$ret.fill("#2A3037"); return $ret;}());
	}

	, 
	drawThumbnailImage: function (context, rect) {
		context.drawImage(this.thumbnailCanvas()[0], 1, rect.left(), rect.top(), rect.width(), rect.height());
	}

	, 
	showSettingsPanel: function (fullSize, width, height) {
		this.settingsPanel().css("top", (fullSize.top() + 2 + height).toString() + "px");
		this.settingsPanel().css("left", (fullSize.left() + 2).toString() + "px");
		this.settingsPanel().css("width", width.toString() + "px");
		this.settingsPanel().css("height", "20px");
		this.settingsPanel().show();
	}
	, 
	__mobileOPDShown: false

	, 
	enableMobileOPD: function () {
		this.__owner.model().mode($.ig.OverviewPlusDetailPaneMode.prototype.full);
		if (this.settingsPanel() != null) {
			this.settingsPanel().hide();
		}

	}

	, 
	disableMobileOPD: function () {
		this.__owner.model().mode($.ig.OverviewPlusDetailPaneMode.prototype.minimal);
	}

	, 
	showMobileOPD: function () {
		this.__mobileOPDShown = true;
		this.__owner.model().__visibility = $.ig.Visibility.prototype.visible;
		this.enableMobileOPD();
		var mp_ = this.mobilePanel();
		var close_ = this.__closeText;
		if (this.isJqueryMobile()) {
			mp_.find(".ui-btn-text").html(close_);
			mp_.find(".ui-icon").removeClass('ui-icon-arrow-d').addClass('ui-icon-delete');

		} else {
			mp_.button("option", "icons", { secondary: "ui-icon-close"});
			mp_.button("option", "label",  close_);
		}

		this.mobilePanel().attr("toggle", "open").attr("data-toggle", "open");
		this.settingsPanel().css("left", (this.__owner.model().view().fullSize().left() + 5).toString() + "px");
		this.settingsPanel().css("width", (this.__owner.model().view().fullSize().width() - 10).toString() + "px");
		this.settingsPanel().css("top", (this.__owner.model().view().fullSize().height() - this.settingsPanel().height()).toString() + "px");
		this.settingsPanel().show();
	}

	, 
	hideMobileOPD: function (hideCloseIcon) {
		if (this.__mobileOPDShown) {
			this.__mobileOPDShown = false;
			this.__owner.model().__visibility = $.ig.Visibility.prototype.collapsed;
			var mp_ = this.mobilePanel();
			var overview_ = this.__overviewText;
			if (this.isJqueryMobile()) {
				mp_.find(".ui-btn-text").html(overview_);
				mp_.find(".ui-icon").removeClass('ui-icon-delete').addClass('ui-icon-arrow-d');

			} else {
				mp_.button("option", "icons", { secondary: "ui-icon-carat-1-s"});
				mp_.button("option", "label",  overview_);
			}

			this.mobilePanel().attr("toggle", "closed").attr("data-toggle", "closed");
			this.__owner.model().mode($.ig.OverviewPlusDetailPaneMode.prototype.minimal);
			this.settingsPanel().hide();
			this.__owner.onMobileClosing();
		}

		if (hideCloseIcon) {
			this.mobilePanel().hide();
		}

	}

	, 
	hideSettingsPanel: function () {
		this.settingsPanel().hide();
	}

	, 
	_eventProxy: null,
	eventProxy: function (value) {
		if (arguments.length === 1) {
			this._eventProxy = value;
			return value;
		} else {
			return this._eventProxy;
		}
	}

	, 
	queueWork: function (work) {
		window.setTimeout(work, 0);
	}

	, 
	jqueryMobilePresent: function () {
		return this.isJqueryMobile();
	}
	, 
	$type: new $.ig.Type('XamOverviewPlusDetailPaneViewManager', $.ig.Object.prototype.$type)
}, true);














$.ig.util.defType('TrendCalculators', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	wMA: function (sequence, period) {
		var d__ = new $.ig.TrendCalculators___WMA__IteratorClass(-2);
		d__.__3__sequence = sequence;
		d__.__3__period = period;
		return d__;
	}

	, 
	eMA: function (sequence, period) {
		var d__ = new $.ig.TrendCalculators___EMA__IteratorClass(-2);
		d__.__3__sequence = sequence;
		d__.__3__period = period;
		return d__;
	}

	, 
	mMA: function (sequence, period) {
		var d__ = new $.ig.TrendCalculators___MMA__IteratorClass(-2);
		d__.__3__sequence = sequence;
		d__.__3__period = period;
		return d__;
	}

	, 
	cMA: function (sequence) {
		var d__ = new $.ig.TrendCalculators___CMA__IteratorClass(-2);
		d__.__3__sequence = sequence;
		return d__;
	}

	, 
	sMA: function (sequence, period) {
		var d__ = new $.ig.TrendCalculators___SMA__IteratorClass(-2);
		d__.__3__sequence = sequence;
		d__.__3__period = period;
		return d__;
	}

	, 
	movingSum: function (sequence, period) {
		var d__ = new $.ig.TrendCalculators___MovingSum__IteratorClass(-2);
		d__.__3__sequence = sequence;
		d__.__3__period = period;
		return d__;
	}

	, 
	sTDEV: function (sequence, period) {
		var d__ = new $.ig.TrendCalculators___STDEV__IteratorClass(-2);
		d__.__3__sequence = sequence;
		d__.__3__period = period;
		return d__;
	}
	, 
	$type: new $.ig.Type('TrendCalculators', $.ig.Object.prototype.$type)
}, true);



$.ig.util.defType('TrendCalculators___STDEV__IteratorClass', 'Object', {
	__1__state: 0
	, 
	__2__current: 0
	, 
	__sma_5_0: null
	, 
	__price_5_1: null
	, 
	__buffer_5_2: null
	, 
	__i_5_3: 0
	, 
	__s_5_4: 0
	, 
	__effectivePeriod_5_5: 0
	, 
	__t_5_6: 0
	, 
	__t_5_7: 0
	, 
	_sequence: null
	, 
	__3__sequence: null
	, 
	_period: 0
	, 
	__3__period: 0
	, 
	init: function (_1__state) {



		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	moveNext: function () {
		while (this.__1__state >= 0) {
			switch (this.__1__state) {
				case 0:
					this.__1__state = -1;
					this.__sma_5_0 = $.ig.TrendCalculators.prototype.sMA(this._sequence, this._period).getEnumerator();
					this.__price_5_1 = this._sequence.getEnumerator();
					this.__buffer_5_2 = new Array(this._period);
					this.__i_5_3 = 0;
					for (this.__i_5_3 = 0; this.__i_5_3 < this._period; this.__i_5_3++) {
						this.__buffer_5_2[this.__i_5_3] = 0;
					}

					this.__i_5_3 = 0;
					this.__1__state = 1;
					break;
				case 1:
					this.__1__state = -1;
					if (this.__price_5_1.moveNext() && this.__sma_5_0.moveNext()) {
						this.__buffer_5_2[(this.__i_5_3++) % this._period] = this.__price_5_1.current();
						this.__s_5_4 = 0;
						if (this.__i_5_3 < this._period) {
							this.__effectivePeriod_5_5 = 0;
							for (var j = 0; j < this.__i_5_3; j++) {
								this.__t_5_6 = (this.__sma_5_0.current() - this.__buffer_5_2[j]);
								this.__s_5_4 += this.__t_5_6 * this.__t_5_6;
								this.__effectivePeriod_5_5++;
							}

							this.__2__current = Math.sqrt(this.__s_5_4 / this.__effectivePeriod_5_5);
							this.__1__state = 1;
							return true;
						}

						for (var j1 = 0; j1 < this._period; ++j1) {
							this.__t_5_7 = (this.__sma_5_0.current() - this.__buffer_5_2[j1]);
							this.__s_5_4 += this.__t_5_7 * this.__t_5_7;
						}

						this.__2__current = Math.sqrt(this.__s_5_4 / this._period);
						this.__1__state = 1;
						return true;
					}

					break;
			}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.TrendCalculators___STDEV__IteratorClass(0);
		}

		d__._sequence = this.__3__sequence;
		d__._period = this.__3__period;
		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('TrendCalculators___STDEV__IteratorClass', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(Number), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize(Number), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

$.ig.util.defType('TrendCalculators___MovingSum__IteratorClass', 'Object', {
	__1__state: 0
	, 
	__2__current: 0
	, 
	__buffer_5_0: null
	, 
	__i_5_1: 0
	, 
	__ms_5_2: 0
	, 
	_valueEnumerator: null
	, 
	__value_5_3: 0
	, 
	__next_5_4: 0
	, 
	__cursor_5_5: 0
	, 
	_sequence: null
	, 
	__3__sequence: null
	, 
	_period: 0
	, 
	__3__period: 0
	, 
	init: function (_1__state) {



		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	_m_Finally0: function () {
		this.__1__state = -1;
		if (this._valueEnumerator != null) {
			this._valueEnumerator.dispose();
		}

	}

	, 
	moveNext: function () {
		var __hasError__ = false;
		try {
				while (this.__1__state >= 0) {
					switch (this.__1__state) {
						case 0:
							this.__1__state = -1;
							this.__buffer_5_0 = new Array(this._period);
							this.__i_5_1 = 0;
							for (this.__i_5_1 = 0; this.__i_5_1 < this._period; this.__i_5_1++) {
								this.__buffer_5_0[this.__i_5_1] = 0;
							}

							this.__i_5_1 = 0;
							this.__ms_5_2 = NaN;
							this.__1__state = 1;
							this._valueEnumerator = this._sequence.getEnumerator();
							this.__1__state = 2;
							break;
						case 2:
							this.__1__state = 1;
							if (this._valueEnumerator.moveNext()) {
								this.__value_5_3 = this._valueEnumerator.current();
								if (!$.ig.util.isNaN(this.__value_5_3)) {
									this.__next_5_4 = this.__value_5_3;
									this.__cursor_5_5 = this.__i_5_1 % this._period;
									if (this.__i_5_1 < this._period) {
										this.__ms_5_2 = $.ig.util.isNaN(this.__ms_5_2) ? this.__next_5_4 : this.__ms_5_2 + this.__next_5_4;

									} else {
										this.__ms_5_2 = this.__ms_5_2 + this.__next_5_4 - this.__buffer_5_0[this.__cursor_5_5];
									}

									this.__buffer_5_0[this.__cursor_5_5] = this.__next_5_4;
									++this.__i_5_1;
								}

								this.__2__current = this.__ms_5_2;
								this.__1__state = 2;
								return true;
							}

							this._m_Finally0();
							break;
					}


				}

		}
		catch (e) {
				__hasError__ = true;
				throw e;

		}finally {
				if (__hasError__) {
				(this).dispose();
				}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.TrendCalculators___MovingSum__IteratorClass(0);
		}

		d__._sequence = this.__3__sequence;
		d__._period = this.__3__period;
		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
		switch (this.__1__state) {
			case 1:
			case 2:
				this._m_Finally0();
				break;
		}

	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('TrendCalculators___MovingSum__IteratorClass', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(Number), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize(Number), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

$.ig.util.defType('TrendCalculators___SMA__IteratorClass', 'Object', {
	__1__state: 0
	, 
	__2__current: 0
	, 
	__buffer_5_0: null
	, 
	__i_5_1: 0
	, 
	__sma_5_2: 0
	, 
	_valueEnumerator: null
	, 
	__value_5_3: 0
	, 
	__next_5_4: 0
	, 
	__cursor_5_5: 0
	, 
	_sequence: null
	, 
	__3__sequence: null
	, 
	_period: 0
	, 
	__3__period: 0
	, 
	init: function (_1__state) {



		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	_m_Finally0: function () {
		this.__1__state = -1;
		if (this._valueEnumerator != null) {
			this._valueEnumerator.dispose();
		}

	}

	, 
	moveNext: function () {
		var __hasError__ = false;
		try {
				while (this.__1__state >= 0) {
					switch (this.__1__state) {
						case 0:
							this.__1__state = -1;
							this.__buffer_5_0 = new Array(this._period);
							this.__i_5_1 = 0;
							for (this.__i_5_1 = 0; this.__i_5_1 < this._period; this.__i_5_1++) {
								this.__buffer_5_0[this.__i_5_1] = 0;
							}

							this.__i_5_1 = 0;
							this.__sma_5_2 = NaN;
							this.__1__state = 1;
							this._valueEnumerator = this._sequence.getEnumerator();
							this.__1__state = 2;
							break;
						case 2:
							this.__1__state = 1;
							if (this._valueEnumerator.moveNext()) {
								this.__value_5_3 = this._valueEnumerator.current();
								if (!$.ig.util.isNaN(this.__value_5_3)) {
									this.__next_5_4 = this.__value_5_3 / this._period;
									this.__cursor_5_5 = this.__i_5_1 % this._period;
									if (this.__i_5_1 < this._period) {
										this.__sma_5_2 = $.ig.util.isNaN(this.__sma_5_2) ? this.__value_5_3 : (this.__sma_5_2 * this.__i_5_1 + this.__value_5_3) / (this.__i_5_1 + 1);

									} else {
										this.__sma_5_2 = this.__sma_5_2 + this.__next_5_4 - this.__buffer_5_0[this.__cursor_5_5];
									}

									this.__buffer_5_0[this.__cursor_5_5] = this.__next_5_4;
									++this.__i_5_1;
								}

								this.__2__current = this.__sma_5_2;
								this.__1__state = 2;
								return true;
							}

							this._m_Finally0();
							break;
					}


				}

		}
		catch (e) {
				__hasError__ = true;
				throw e;

		}finally {
				if (__hasError__) {
				(this).dispose();
				}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.TrendCalculators___SMA__IteratorClass(0);
		}

		d__._sequence = this.__3__sequence;
		d__._period = this.__3__period;
		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
		switch (this.__1__state) {
			case 1:
			case 2:
				this._m_Finally0();
				break;
		}

	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('TrendCalculators___SMA__IteratorClass', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(Number), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize(Number), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

$.ig.util.defType('TrendCalculators___CMA__IteratorClass', 'Object', {
	__1__state: 0
	, 
	__2__current: 0
	, 
	__cma_5_0: 0
	, 
	__i_5_1: 0
	, 
	_valueEnumerator: null
	, 
	__value_5_2: 0
	, 
	_sequence: null
	, 
	__3__sequence: null
	, 
	init: function (_1__state) {



		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	_m_Finally0: function () {
		this.__1__state = -1;
		if (this._valueEnumerator != null) {
			this._valueEnumerator.dispose();
		}

	}

	, 
	moveNext: function () {
		var __hasError__ = false;
		try {
				while (this.__1__state >= 0) {
					switch (this.__1__state) {
						case 0:
							this.__1__state = -1;
							this.__cma_5_0 = NaN;
							this.__i_5_1 = 0;
							this.__1__state = 1;
							this._valueEnumerator = this._sequence.getEnumerator();
							this.__1__state = 2;
							break;
						case 2:
							this.__1__state = 1;
							if (this._valueEnumerator.moveNext()) {
								this.__value_5_2 = this._valueEnumerator.current();
								if (!$.ig.util.isNaN(this.__value_5_2)) {
									this.__cma_5_0 = $.ig.util.isNaN(this.__cma_5_0) ? this.__value_5_2 : (this.__cma_5_0 * this.__i_5_1 + this.__value_5_2) / (this.__i_5_1 + 1);
									++this.__i_5_1;
								}

								this.__2__current = this.__cma_5_0;
								this.__1__state = 2;
								return true;
							}

							this._m_Finally0();
							break;
					}


				}

		}
		catch (e) {
				__hasError__ = true;
				throw e;

		}finally {
				if (__hasError__) {
				(this).dispose();
				}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.TrendCalculators___CMA__IteratorClass(0);
		}

		d__._sequence = this.__3__sequence;
		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
		switch (this.__1__state) {
			case 1:
			case 2:
				this._m_Finally0();
				break;
		}

	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('TrendCalculators___CMA__IteratorClass', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(Number), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize(Number), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

$.ig.util.defType('TrendCalculators___MMA__IteratorClass', 'Object', {
	__1__state: 0
	, 
	__2__current: 0
	, 
	__i_5_0: 0
	, 
	__mma_5_1: 0
	, 
	__alpha_5_2: 0
	, 
	_valueEnumerator: null
	, 
	__value_5_3: 0
	, 
	_sequence: null
	, 
	__3__sequence: null
	, 
	_period: 0
	, 
	__3__period: 0
	, 
	init: function (_1__state) {



		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	_m_Finally0: function () {
		this.__1__state = -1;
		if (this._valueEnumerator != null) {
			this._valueEnumerator.dispose();
		}

	}

	, 
	moveNext: function () {
		var __hasError__ = false;
		try {
				while (this.__1__state >= 0) {
					switch (this.__1__state) {
						case 0:
							this.__1__state = -1;
							this.__i_5_0 = 0;
							this.__mma_5_1 = NaN;
							this.__alpha_5_2 = 1 / this._period;
							this.__1__state = 1;
							this._valueEnumerator = this._sequence.getEnumerator();
							this.__1__state = 2;
							break;
						case 2:
							this.__1__state = 1;
							if (this._valueEnumerator.moveNext()) {
								this.__value_5_3 = this._valueEnumerator.current();
								if (!$.ig.util.isNaN(this.__value_5_3)) {
									if (this.__i_5_0 < this._period) {
										this.__mma_5_1 = $.ig.util.isNaN(this.__mma_5_1) ? this.__value_5_3 : (this.__mma_5_1 * this.__i_5_0 + this.__value_5_3) / (this.__i_5_0 + 1);

									} else {
										this.__mma_5_1 = (this.__value_5_3 - this.__mma_5_1) * this.__alpha_5_2 + this.__mma_5_1;
									}

									++this.__i_5_0;
								}

								this.__2__current = this.__mma_5_1;
								this.__1__state = 2;
								return true;
							}

							this._m_Finally0();
							break;
					}


				}

		}
		catch (e) {
				__hasError__ = true;
				throw e;

		}finally {
				if (__hasError__) {
				(this).dispose();
				}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.TrendCalculators___MMA__IteratorClass(0);
		}

		d__._sequence = this.__3__sequence;
		d__._period = this.__3__period;
		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
		switch (this.__1__state) {
			case 1:
			case 2:
				this._m_Finally0();
				break;
		}

	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('TrendCalculators___MMA__IteratorClass', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(Number), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize(Number), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

$.ig.util.defType('TrendCalculators___EMA__IteratorClass', 'Object', {
	__1__state: 0
	, 
	__2__current: 0
	, 
	__i_5_0: 0
	, 
	__ema_5_1: 0
	, 
	__alpha_5_2: 0
	, 
	_valueEnumerator: null
	, 
	__value_5_3: 0
	, 
	_sequence: null
	, 
	__3__sequence: null
	, 
	_period: 0
	, 
	__3__period: 0
	, 
	init: function (_1__state) {



		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	_m_Finally0: function () {
		this.__1__state = -1;
		if (this._valueEnumerator != null) {
			this._valueEnumerator.dispose();
		}

	}

	, 
	moveNext: function () {
		var __hasError__ = false;
		try {
				while (this.__1__state >= 0) {
					switch (this.__1__state) {
						case 0:
							this.__1__state = -1;
							this.__i_5_0 = 0;
							this.__ema_5_1 = NaN;
							this.__alpha_5_2 = 2 / (1 + this._period);
							this.__1__state = 1;
							this._valueEnumerator = this._sequence.getEnumerator();
							this.__1__state = 2;
							break;
						case 2:
							this.__1__state = 1;
							if (this._valueEnumerator.moveNext()) {
								this.__value_5_3 = this._valueEnumerator.current();
								if (!$.ig.util.isNaN(this.__value_5_3)) {
									if (this.__i_5_0 < this._period) {
										this.__ema_5_1 = $.ig.util.isNaN(this.__ema_5_1) ? this.__value_5_3 : (this.__ema_5_1 * this.__i_5_0 + this.__value_5_3) / (this.__i_5_0 + 1);

									} else {
										this.__ema_5_1 = (this.__value_5_3 - this.__ema_5_1) * this.__alpha_5_2 + this.__ema_5_1;
									}

									++this.__i_5_0;
								}

								this.__2__current = this.__ema_5_1;
								this.__1__state = 2;
								return true;
							}

							this._m_Finally0();
							break;
					}


				}

		}
		catch (e) {
				__hasError__ = true;
				throw e;

		}finally {
				if (__hasError__) {
				(this).dispose();
				}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.TrendCalculators___EMA__IteratorClass(0);
		}

		d__._sequence = this.__3__sequence;
		d__._period = this.__3__period;
		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
		switch (this.__1__state) {
			case 1:
			case 2:
				this._m_Finally0();
				break;
		}

	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('TrendCalculators___EMA__IteratorClass', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(Number), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize(Number), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

$.ig.util.defType('TrendCalculators___WMA__IteratorClass', 'Object', {
	__1__state: 0
	, 
	__2__current: 0
	, 
	__buffer_5_0: null
	, 
	__i_5_1: 0
	, 
	__total_5_2: 0
	, 
	__numerator_5_3: 0
	, 
	__weightsum_5_4: 0
	, 
	__wma_5_5: 0
	, 
	_valueEnumerator: null
	, 
	__value_5_6: 0
	, 
	__cursor_5_7: 0
	, 
	_sequence: null
	, 
	__3__sequence: null
	, 
	_period: 0
	, 
	__3__period: 0
	, 
	init: function (_1__state) {



		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	_m_Finally0: function () {
		this.__1__state = -1;
		if (this._valueEnumerator != null) {
			this._valueEnumerator.dispose();
		}

	}

	, 
	moveNext: function () {
		var __hasError__ = false;
		try {
				while (this.__1__state >= 0) {
					switch (this.__1__state) {
						case 0:
							this.__1__state = -1;
							this.__buffer_5_0 = new Array(this._period);
							this.__i_5_1 = 0;
							for (this.__i_5_1 = 0; this.__i_5_1 < this._period; this.__i_5_1++) {
								this.__buffer_5_0[this.__i_5_1] = 0;
							}

							this.__total_5_2 = NaN;
							this.__numerator_5_3 = NaN;
							this.__weightsum_5_4 = NaN;
							this.__wma_5_5 = NaN;
							this.__i_5_1 = 0;
							this.__1__state = 1;
							this._valueEnumerator = this._sequence.getEnumerator();
							this.__1__state = 2;
							break;
						case 2:
							this.__1__state = 1;
							if (this._valueEnumerator.moveNext()) {
								this.__value_5_6 = this._valueEnumerator.current();
								if (!$.ig.util.isNaN(this.__value_5_6)) {
									this.__cursor_5_7 = this.__i_5_1 % this._period;
									if (this.__i_5_1 == 0) {
										this.__weightsum_5_4 = 1;
										this.__wma_5_5 = this.__numerator_5_3 = this.__total_5_2 = this.__value_5_6;

									} else if (this.__i_5_1 < this._period) {
										this.__weightsum_5_4 += (this.__i_5_1 + 1);
										this.__total_5_2 += this.__value_5_6;
										this.__numerator_5_3 += (this.__i_5_1 + 1) * this.__value_5_6;
										this.__wma_5_5 = this.__numerator_5_3 / this.__weightsum_5_4;

									} else {
										this.__numerator_5_3 = this.__numerator_5_3 + (this._period * this.__value_5_6) - this.__total_5_2;
										this.__wma_5_5 = this.__numerator_5_3 / this.__weightsum_5_4;
										this.__total_5_2 = this.__total_5_2 + this.__value_5_6 - this.__buffer_5_0[this.__cursor_5_7];
									}


									this.__buffer_5_0[this.__cursor_5_7] = this.__value_5_6;
									++this.__i_5_1;
								}

								this.__2__current = this.__wma_5_5;
								this.__1__state = 2;
								return true;
							}

							this._m_Finally0();
							break;
					}


				}

		}
		catch (e) {
				__hasError__ = true;
				throw e;

		}finally {
				if (__hasError__) {
				(this).dispose();
				}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.TrendCalculators___WMA__IteratorClass(0);
		}

		d__._sequence = this.__3__sequence;
		d__._period = this.__3__period;
		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
		switch (this.__1__state) {
			case 1:
			case 2:
				this._m_Finally0();
				break;
		}

	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('TrendCalculators___WMA__IteratorClass', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(Number), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize(Number), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);






$.ig.OverviewPlusDetailPaneMode.prototype.minimal = 0;
$.ig.OverviewPlusDetailPaneMode.prototype.full = 1;
$.ig.OverviewPlusDetailPaneMode.prototype.compact = 2;


$.ig.InteractionState.prototype.none = 0;
$.ig.InteractionState.prototype.dragZoom = 1;
$.ig.InteractionState.prototype.dragPan = 2;
$.ig.InteractionState.prototype.auto = 3;



$.ig.InterpolationMode.prototype.rGB = 0;
$.ig.InterpolationMode.prototype.hSV = 1;



$.ig.FastItemsSourceEventAction.prototype.remove = 0;
$.ig.FastItemsSourceEventAction.prototype.insert = 1;
$.ig.FastItemsSourceEventAction.prototype.replace = 2;
$.ig.FastItemsSourceEventAction.prototype.change = 3;
$.ig.FastItemsSourceEventAction.prototype.reset = 4;




$.ig.BrushCollection.prototype._random = new $.ig.Random(0);


$.ig.ColorUtil.prototype._r = new $.ig.Random(0);
$.ig.ColorUtil.prototype.__randomColors = null;


$.ig.CssHelper.prototype.defaultMarginValue = "-4321px";
$.ig.CssHelper.prototype.defaultColorValue = "rgb(3, 2, 1)";
$.ig.CssHelper.prototype.defaultBackgroundImageValue = "none";
$.ig.CssHelper.prototype.defaultTextAlignValue = "justify";
$.ig.CssHelper.prototype.defaultVerticalAlignValue = "baseline";
$.ig.CssHelper.prototype.defaultOpacityValue = "0.888";
$.ig.CssHelper.prototype.defaultVisibilityValue = "hidden";
$.ig.CssHelper.prototype.defaultWidthHeightValue = "4321px";
$.ig.CssHelper.prototype.maxClasses = 500;


$.ig.MathUtil.prototype.pHI = (1 + Math.sqrt(5)) / 2;
$.ig.MathUtil.prototype.sQRT2 = Math.sqrt(2);
$.ig.MathUtil.prototype.degreeAsRadian = Math.PI / 180;
$.ig.MathUtil.prototype._basis = [ 151, 160, 137, 91, 90, 15, 131, 13, 201, 95, 96, 53, 194, 233, 7, 225, 140, 36, 103, 30, 69, 142, 8, 99, 37, 240, 21, 10, 23, 190, 6, 148, 247, 120, 234, 75, 0, 26, 197, 62, 94, 252, 219, 203, 117, 35, 11, 32, 57, 177, 33, 88, 237, 149, 56, 87, 174, 20, 125, 136, 171, 168, 68, 175, 74, 165, 71, 134, 139, 48, 27, 166, 77, 146, 158, 231, 83, 111, 229, 122, 60, 211, 133, 230, 220, 105, 92, 41, 55, 46, 245, 40, 244, 102, 143, 54, 65, 25, 63, 161, 1, 216, 80, 73, 209, 76, 132, 187, 208, 89, 18, 169, 200, 196, 135, 130, 116, 188, 159, 86, 164, 100, 109, 198, 173, 186, 3, 64, 52, 217, 226, 250, 124, 123, 5, 202, 38, 147, 118, 126, 255, 82, 85, 212, 207, 206, 59, 227, 47, 16, 58, 17, 182, 189, 28, 42, 223, 183, 170, 213, 119, 248, 152, 2, 44, 154, 163, 70, 221, 153, 101, 155, 167, 43, 172, 9, 129, 22, 39, 253, 19, 98, 108, 110, 79, 113, 224, 232, 178, 185, 112, 104, 218, 246, 97, 228, 251, 34, 242, 193, 238, 210, 144, 12, 191, 179, 162, 241, 81, 51, 145, 235, 249, 14, 239, 107, 49, 192, 214, 31, 181, 199, 106, 157, 184, 84, 204, 176, 115, 121, 50, 45, 127, 4, 150, 254, 138, 236, 205, 93, 222, 114, 67, 29, 24, 72, 243, 141, 128, 195, 78, 66, 215, 61, 156, 180, 151, 160, 137, 91, 90, 15, 131, 13, 201, 95, 96, 53, 194, 233, 7, 225, 140, 36, 103, 30, 69, 142, 8, 99, 37, 240, 21, 10, 23, 190, 6, 148, 247, 120, 234, 75, 0, 26, 197, 62, 94, 252, 219, 203, 117, 35, 11, 32, 57, 177, 33, 88, 237, 149, 56, 87, 174, 20, 125, 136, 171, 168, 68, 175, 74, 165, 71, 134, 139, 48, 27, 166, 77, 146, 158, 231, 83, 111, 229, 122, 60, 211, 133, 230, 220, 105, 92, 41, 55, 46, 245, 40, 244, 102, 143, 54, 65, 25, 63, 161, 1, 216, 80, 73, 209, 76, 132, 187, 208, 89, 18, 169, 200, 196, 135, 130, 116, 188, 159, 86, 164, 100, 109, 198, 173, 186, 3, 64, 52, 217, 226, 250, 124, 123, 5, 202, 38, 147, 118, 126, 255, 82, 85, 212, 207, 206, 59, 227, 47, 16, 58, 17, 182, 189, 28, 42, 223, 183, 170, 213, 119, 248, 152, 2, 44, 154, 163, 70, 221, 153, 101, 155, 167, 43, 172, 9, 129, 22, 39, 253, 19, 98, 108, 110, 79, 113, 224, 232, 178, 185, 112, 104, 218, 246, 97, 228, 251, 34, 242, 193, 238, 210, 144, 12, 191, 179, 162, 241, 81, 51, 145, 235, 249, 14, 239, 107, 49, 192, 214, 31, 181, 199, 106, 157, 184, 84, 204, 176, 115, 121, 50, 45, 127, 4, 150, 254, 138, 236, 205, 93, 222, 114, 67, 29, 24, 72, 243, 141, 128, 195, 78, 66, 215, 61, 156, 180 ];



$.ig.DOMEventProxy.prototype.__proxyCount = 0;
$.ig.DOMEventProxy.prototype.mSPointerEnabled = false;
$.ig.DOMEventProxy.prototype.pointerEnabled = false;
$.ig.DOMEventProxy.prototype.tridentVersion = 0;
$.ig.DOMEventProxy.prototype._nullTimer = -1;



$.ig.XamOverviewPlusDetailPane.prototype._maxZoom = 2;
$.ig.XamOverviewPlusDetailPane.prototype.sizeStates = "SizeStates";
$.ig.XamOverviewPlusDetailPane.prototype.stateFull = "Full";
$.ig.XamOverviewPlusDetailPane.prototype.stateMinimal = "Minimal";
$.ig.XamOverviewPlusDetailPane.prototype.zoomableStates = "ZoomableStates";
$.ig.XamOverviewPlusDetailPane.prototype.stateZoomEnabled = "ZoomEnabled";
$.ig.XamOverviewPlusDetailPane.prototype.stateZoomDisabled = "ZoomDisabled";
$.ig.XamOverviewPlusDetailPane.prototype.rootElementName = "Root";
$.ig.XamOverviewPlusDetailPane.prototype.contentPresenterElementName = "ContentPresenter";
$.ig.XamOverviewPlusDetailPane.prototype.zoomOutName = "ZoomOut";
$.ig.XamOverviewPlusDetailPane.prototype.zoomLevelName = "ZoomLevel";
$.ig.XamOverviewPlusDetailPane.prototype.zoomInName = "ZoomIn";
$.ig.XamOverviewPlusDetailPane.prototype.zoomTo100Name = "ZoomTo100";
$.ig.XamOverviewPlusDetailPane.prototype.scaleToFitName = "ScaleToFit";
$.ig.XamOverviewPlusDetailPane.prototype.buttonCursorName = "ButtonCursor";
$.ig.XamOverviewPlusDetailPane.prototype.dragPanName = "DragPan";
$.ig.XamOverviewPlusDetailPane.prototype.dragZoomName = "DragZoom";
$.ig.XamOverviewPlusDetailPane.prototype.buttonsGridName = "ButtonsGrid";
$.ig.XamOverviewPlusDetailPane.prototype._immediatePropertyName = "Immediate";
$.ig.XamOverviewPlusDetailPane.prototype.immediateProperty = $.ig.DependencyProperty.prototype.register($.ig.XamOverviewPlusDetailPane.prototype._immediatePropertyName, $.ig.Boolean.prototype.$type, $.ig.XamOverviewPlusDetailPane.prototype.$type, new $.ig.PropertyMetadata(2, true, function (sender, e) {
	($.ig.util.cast($.ig.XamOverviewPlusDetailPane.prototype.$type, sender)).onPropertyChanged(new $.ig.PropertyChangedEventArgs$1($.ig.Boolean.prototype.$type, $.ig.XamOverviewPlusDetailPane.prototype._immediatePropertyName, e.oldValue(), e.newValue()));
}));
$.ig.XamOverviewPlusDetailPane.prototype._worldPropertyName = "World";
$.ig.XamOverviewPlusDetailPane.prototype.worldProperty = $.ig.DependencyProperty.prototype.register($.ig.XamOverviewPlusDetailPane.prototype._worldPropertyName, $.ig.Rect.prototype.$type, $.ig.XamOverviewPlusDetailPane.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.Rect.prototype.empty(), function (sender, e) {
	($.ig.util.cast($.ig.XamOverviewPlusDetailPane.prototype.$type, sender)).onPropertyChanged(new $.ig.PropertyChangedEventArgs$1($.ig.Rect.prototype.$type, $.ig.XamOverviewPlusDetailPane.prototype._worldPropertyName, e.oldValue(), e.newValue()));
}));
$.ig.XamOverviewPlusDetailPane.prototype.worldStylePropertyName = "WorldStyle";
$.ig.XamOverviewPlusDetailPane.prototype.worldStyleProperty = $.ig.DependencyProperty.prototype.register($.ig.XamOverviewPlusDetailPane.prototype.worldStylePropertyName, $.ig.Style.prototype.$type, $.ig.XamOverviewPlusDetailPane.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.XamOverviewPlusDetailPane.prototype.$type, sender)).onPropertyChanged(new $.ig.PropertyChangedEventArgs$1($.ig.Style.prototype.$type, $.ig.XamOverviewPlusDetailPane.prototype.worldStylePropertyName, $.ig.util.cast($.ig.Style.prototype.$type, e.oldValue()), $.ig.util.cast($.ig.Style.prototype.$type, e.newValue())));
}));
$.ig.XamOverviewPlusDetailPane.prototype._windowPropertyName = "Window";
$.ig.XamOverviewPlusDetailPane.prototype.windowProperty = $.ig.DependencyProperty.prototype.register($.ig.XamOverviewPlusDetailPane.prototype._windowPropertyName, $.ig.Rect.prototype.$type, $.ig.XamOverviewPlusDetailPane.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.Rect.prototype.empty(), function (sender, e) {
	($.ig.util.cast($.ig.XamOverviewPlusDetailPane.prototype.$type, sender)).onPropertyChanged(new $.ig.PropertyChangedEventArgs$1($.ig.Rect.prototype.$type, $.ig.XamOverviewPlusDetailPane.prototype._windowPropertyName, e.oldValue(), e.newValue()));
}));
$.ig.XamOverviewPlusDetailPane.prototype.windowStylePropertyName = "WindowStyle";
$.ig.XamOverviewPlusDetailPane.prototype.windowStyleProperty = $.ig.DependencyProperty.prototype.register($.ig.XamOverviewPlusDetailPane.prototype.windowStylePropertyName, $.ig.Style.prototype.$type, $.ig.XamOverviewPlusDetailPane.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.XamOverviewPlusDetailPane.prototype.$type, sender)).onPropertyChanged(new $.ig.PropertyChangedEventArgs$1($.ig.Style.prototype.$type, $.ig.XamOverviewPlusDetailPane.prototype.windowStylePropertyName, $.ig.util.cast($.ig.Style.prototype.$type, e.oldValue()), $.ig.util.cast($.ig.Style.prototype.$type, e.newValue())));
}));
$.ig.XamOverviewPlusDetailPane.prototype._previewPropertyName = "Preview";
$.ig.XamOverviewPlusDetailPane.prototype.previewProperty = $.ig.DependencyProperty.prototype.register($.ig.XamOverviewPlusDetailPane.prototype._previewPropertyName, $.ig.Rect.prototype.$type, $.ig.XamOverviewPlusDetailPane.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.Rect.prototype.empty(), function (sender, e) {
	($.ig.util.cast($.ig.XamOverviewPlusDetailPane.prototype.$type, sender)).onPropertyChanged(new $.ig.PropertyChangedEventArgs$1($.ig.Rect.prototype.$type, $.ig.XamOverviewPlusDetailPane.prototype._previewPropertyName, e.oldValue(), e.newValue()));
}));
$.ig.XamOverviewPlusDetailPane.prototype.previewStylePropertyName = "PreviewStyle";
$.ig.XamOverviewPlusDetailPane.prototype.previewStyleProperty = $.ig.DependencyProperty.prototype.register($.ig.XamOverviewPlusDetailPane.prototype.previewStylePropertyName, $.ig.Style.prototype.$type, $.ig.XamOverviewPlusDetailPane.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.XamOverviewPlusDetailPane.prototype.$type, sender)).onPropertyChanged(new $.ig.PropertyChangedEventArgs$1($.ig.Style.prototype.$type, $.ig.XamOverviewPlusDetailPane.prototype.previewStylePropertyName, $.ig.util.cast($.ig.Style.prototype.$type, e.oldValue()), $.ig.util.cast($.ig.Style.prototype.$type, e.newValue())));
}));
$.ig.XamOverviewPlusDetailPane.prototype.shrinkToThumbnailProperty = $.ig.DependencyProperty.prototype.register("ShrinkToThumbnail", $.ig.Boolean.prototype.$type, $.ig.XamOverviewPlusDetailPane.prototype.$type, new $.ig.PropertyMetadata(2, true, $.ig.XamOverviewPlusDetailPane.prototype.onShrinkToThumbnailChanged1));
$.ig.XamOverviewPlusDetailPane.prototype.modeProperty = $.ig.DependencyProperty.prototype.register("Mode", $.ig.OverviewPlusDetailPaneMode.prototype.$type, $.ig.XamOverviewPlusDetailPane.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.OverviewPlusDetailPaneMode.prototype.getBox($.ig.OverviewPlusDetailPaneMode.prototype.minimal), $.ig.XamOverviewPlusDetailPane.prototype.onModeChanged1));
$.ig.XamOverviewPlusDetailPane.prototype.zoomTo100ButtonVisibilityProperty = $.ig.DependencyProperty.prototype.register("ZoomTo100ButtonVisibility", $.ig.Visibility.prototype.$type, $.ig.XamOverviewPlusDetailPane.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.Visibility.prototype.getBox($.ig.Visibility.prototype.visible), function (o, e) { (o).onPropertyUpdated("ZoomTo100ButtonVisibility", e.oldValue(), e.newValue()); }));
$.ig.XamOverviewPlusDetailPane.prototype.scaleToFitButtonVisibilityProperty = $.ig.DependencyProperty.prototype.register("ScaleToFitButtonVisibility", $.ig.Visibility.prototype.$type, $.ig.XamOverviewPlusDetailPane.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.Visibility.prototype.getBox($.ig.Visibility.prototype.visible), function (o, e) { (o).onPropertyUpdated("ScaleToFitButtonVisibility", e.oldValue(), e.newValue()); }));
$.ig.XamOverviewPlusDetailPane.prototype.interactionStatesToolVisibilityProperty = $.ig.DependencyProperty.prototype.register("InteractionStatesToolVisibility", $.ig.Visibility.prototype.$type, $.ig.XamOverviewPlusDetailPane.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.Visibility.prototype.getBox($.ig.Visibility.prototype.visible), function (o, e) { (o).onPropertyUpdated("InteractionStatesToolVisibility", e.oldValue(), e.newValue()); }));
$.ig.XamOverviewPlusDetailPane.prototype._zoomLevelLargeChangePropertyName = "ZoomLevelLargeChange";
$.ig.XamOverviewPlusDetailPane.prototype.zoomLevelLargeChangeProperty = $.ig.DependencyProperty.prototype.register($.ig.XamOverviewPlusDetailPane.prototype._zoomLevelLargeChangePropertyName, Number, $.ig.XamOverviewPlusDetailPane.prototype.$type, new $.ig.PropertyMetadata(2, 1, function (o, e) { (o).onPropertyUpdated($.ig.XamOverviewPlusDetailPane.prototype._zoomLevelLargeChangePropertyName, e.oldValue(), e.newValue()); }));
$.ig.XamOverviewPlusDetailPane.prototype._dRAG_DISTANCE = 10;
$.ig.XamOverviewPlusDetailPane.prototype._dRAG_DISTANCE_NEAR = 2;







} (jQuery));



// Declare empty types
$.ig = $.ig || {};
(function ($) {
var $$t = {}
$.ig.$currDefinitions = $$t;
$.ig.util.bulkDefine(["Enum:b", 
"ValueType:c", 
"Object:d", 
"Type:e", 
"Boolean:f", 
"IConvertible:g", 
"IFormatProvider:h", 
"Number:i", 
"String:j", 
"IComparable:k", 
"Number:l", 
"Number:m", 
"Number:n", 
"Number:o", 
"NumberStyles:p", 
"Number:q", 
"Void:r", 
"String:s", 
"StringComparison:t", 
"Array:u", 
"IList:v", 
"ICollection:w", 
"IEnumerable:x", 
"IEnumerator:y", 
"RegExp:z", 
"CultureInfo:aa", 
"Calendar:ab", 
"Date:ac", 
"DayOfWeek:ad", 
"DateTimeKind:ae", 
"Date:af", 
"Error:ag", 
"CompareInfo:ah", 
"CompareOptions:ai", 
"NumberFormatInfo:aj", 
"DateTimeFormatInfo:ak", 
"CalendarWeekRule:al", 
"IEnumerable$1:am", 
"IEnumerator$1:an", 
"IDisposable:ao", 
"StringSplitOptions:ap", 
"Number:aq", 
"Number:ar", 
"Number:as", 
"Number:at", 
"Number:au", 
"Number:av", 
"Assembly:aw", 
"Stream:ax", 
"SeekOrigin:ay", 
"RuntimeTypeHandle:az", 
"MethodInfo:a0", 
"MethodBase:a1", 
"MemberInfo:a2", 
"ParameterInfo:a3", 
"TypeCode:a4", 
"ConstructorInfo:a5", 
"PropertyInfo:a6", 
"SeriesViewer:a7", 
"Control:a8", 
"FrameworkElement:a9", 
"UIElement:ba", 
"DependencyObject:bb", 
"Dictionary:bc", 
"DependencyProperty:bd", 
"PropertyMetadata:be", 
"PropertyChangedCallback:bf", 
"MulticastDelegate:bg", 
"IntPtr:bh", 
"DependencyPropertyChangedEventArgs:bi", 
"UnsetValue:bj", 
"DependencyPropertiesCollection:bk", 
"Script:bl", 
"Binding:bm", 
"PropertyPath:bn", 
"Transform:bo", 
"Visibility:bp", 
"Style:bq", 
"Thickness:br", 
"HorizontalAlignment:bs", 
"VerticalAlignment:bt", 
"INotifyPropertyChanged:bu", 
"PropertyChangedEventHandler:bv", 
"PropertyChangedEventArgs:bw", 
"SeriesViewerView:bx", 
"ISchedulableRender:by", 
"CanvasRenderScheduler:bz", 
"List$1:b0", 
"IList$1:b1", 
"ICollection$1:b2", 
"IArray:b3", 
"Enumerable:b4", 
"Func$2:b5", 
"Func$3:b6", 
"IOrderedEnumerable$1:b7", 
"SortedList$1:b8", 
"Math:b9", 
"ArgumentNullException:ca", 
"NotImplementedException:cb", 
"IArrayList:cc", 
"Array:cd", 
"CompareCallback:ce", 
"Action$1:cf", 
"Comparer$1:cg", 
"IComparer:ch", 
"IComparer$1:ci", 
"DefaultComparer$1:cj", 
"IComparable$1:ck", 
"Comparison$1:cl", 
"ReadOnlyCollection$1:cm", 
"Predicate$1:cn", 
"Callback:co", 
"window:cp", 
"RenderingContext:cq", 
"IRenderer:cr", 
"Rectangle:cs", 
"Shape:ct", 
"Brush:cu", 
"Color:cv", 
"ArgumentException:cw", 
"Nullable$1:cx", 
"DoubleCollection:cy", 
"Rect:cz", 
"Size:c0", 
"Point:c1", 
"Path:c2", 
"Geometry:c3", 
"GeometryType:c4", 
"TextBlock:c5", 
"Polygon:c6", 
"PointCollection:c7", 
"Polyline:c8", 
"DataTemplateRenderInfo:c9", 
"DataTemplatePassInfo:da", 
"ContentControl:db", 
"DataTemplate:dc", 
"DataTemplateRenderHandler:dd", 
"DataTemplateMeasureHandler:de", 
"DataTemplateMeasureInfo:df", 
"DataTemplatePassHandler:dg", 
"Line:dh", 
"XamOverviewPlusDetailPane:di", 
"XamOverviewPlusDetailPaneView:dj", 
"XamOverviewPlusDetailPaneViewManager:dk", 
"JQueryObject:dl", 
"Element:dm", 
"ElementAttributeCollection:dn", 
"ElementCollection:dp", 
"WebStyle:dq", 
"ElementNodeType:dr", 
"Document:ds", 
"EventListener:dt", 
"IElementEventHandler:du", 
"ElementEventHandler:dv", 
"ElementAttribute:dw", 
"JQueryPosition:dx", 
"JQueryCallback:dy", 
"JQueryEvent:dz", 
"JQueryUICallback:d0", 
"EventProxy:d1", 
"ModifierKeys:d2", 
"MouseWheelHandler:d3", 
"Delegate:d4", 
"Interlocked:d5", 
"GestureHandler:d6", 
"ContactHandler:d7", 
"TouchHandler:d8", 
"MouseOverHandler:d9", 
"MouseHandler:ea", 
"KeyHandler:eb", 
"Key:ec", 
"JQuery:ed", 
"JQueryDeferred:ee", 
"JQueryPromise:ef", 
"Action:eg", 
"CanvasViewRenderer:eh", 
"CanvasContext2D:ei", 
"CanvasContext:ej", 
"TextMetrics:ek", 
"ImageData:el", 
"CanvasElement:em", 
"Gradient:en", 
"LinearGradientBrush:eo", 
"GradientStop:ep", 
"GeometryGroup:eq", 
"GeometryCollection:er", 
"FillRule:es", 
"PathGeometry:et", 
"PathFigureCollection:eu", 
"LineGeometry:ev", 
"RectangleGeometry:ew", 
"EllipseGeometry:ex", 
"ArcSegment:ey", 
"PathSegment:ez", 
"PathSegmentType:e0", 
"SweepDirection:e1", 
"PathFigure:e2", 
"PathSegmentCollection:e3", 
"LineSegment:e4", 
"PolyLineSegment:e5", 
"BezierSegment:e6", 
"PolyBezierSegment:e7", 
"GeometryUtil:e8", 
"Tuple$2:e9", 
"TransformGroup:fa", 
"TransformCollection:fb", 
"TranslateTransform:fc", 
"RotateTransform:fd", 
"ScaleTransform:fe", 
"DivElement:ff", 
"DOMEventProxy:fg", 
"MSGesture:fh", 
"MouseEventArgs:fi", 
"EventArgs:fj", 
"DoubleAnimator:fk", 
"EasingFunctionHandler:fl", 
"ImageElement:fm", 
"RectUtil:fn", 
"MathUtil:fo", 
"RuntimeHelpers:fp", 
"RuntimeFieldHandle:fq", 
"PropertyChangedEventArgs$1:fr", 
"InteractionState:fs", 
"OverviewPlusDetailPaneMode:ft", 
"IOverviewPlusDetailControl:fu", 
"EventHandler$1:fv", 
"OverviewPlusDetailViewportHost:fw", 
"IProvidesViewport:fx", 
"SeriesCollection:fy", 
"ObservableCollection$1:fz", 
"INotifyCollectionChanged:f0", 
"NotifyCollectionChangedEventHandler:f1", 
"NotifyCollectionChangedEventArgs:f2", 
"NotifyCollectionChangedAction:f3", 
"AxisCollection:f4", 
"SeriesViewerViewManager:f5", 
"AxisTitlePosition:f6", 
"PointerTooltipStyle:f7", 
"Dictionary$2:f8", 
"IDictionary$2:f9", 
"IDictionary:ga", 
"IEqualityComparer$1:gb", 
"EqualityComparer$1:gc", 
"IEqualityComparer:gd", 
"DefaultEqualityComparer$1:ge", 
"InvalidOperationException:gf", 
"KeyValuePair$2:gg", 
"BrushCollection:gh", 
"InterpolationMode:gi", 
"Random:gj", 
"ColorUtil:gk", 
"CssHelper:gl", 
"CssGradientUtil:gm", 
"FontUtil:gn", 
"FontInfo:go", 
"TileZoomTile:gp", 
"TileZoomTileInfo:gq", 
"TileZoomTileCache:gr", 
"TileZoomManager:gs", 
"RectChangedEventHandler:gt", 
"RectChangedEventArgs:gu", 
"Debug:gv", 
"TileZoomInfo:gw", 
"LinkedList$1:gx", 
"LinkedListNode$1:gy", 
"RenderSurface:gz", 
"Series:g0", 
"SeriesView:g1", 
"XamDataChart:g2", 
"GridMode:g3", 
"XamDataChartView:g4", 
"FragmentBase:g5", 
"HorizontalAnchoredCategorySeries:g6", 
"AnchoredCategorySeries:g7", 
"CategorySeries:g8", 
"MarkerSeries:g9", 
"MarkerSeriesView:ha", 
"Marker:hb", 
"DataContext:hc", 
"MarkerTemplates:hd", 
"HashPool$2:he", 
"IHashPool$2:hf", 
"IPool$1:hg", 
"Func$1:hh", 
"Pool$1:hi", 
"IIndexedPool$1:hj", 
"MarkerType:hk", 
"SeriesVisualData:hl", 
"PrimitiveVisualDataList:hm", 
"IVisualData:hn", 
"PrimitiveVisualData:ho", 
"PrimitiveAppearanceData:hp", 
"BrushAppearanceData:hq", 
"StringBuilder:hr", 
"Environment:hs", 
"AppearanceHelper:ht", 
"LinearGradientBrushAppearanceData:hu", 
"GradientStopAppearanceData:hv", 
"SolidBrushAppearanceData:hw", 
"EllipseGeometryData:hx", 
"GeometryData:hy", 
"GetPointsSettings:hz", 
"RectangleGeometryData:h0", 
"LineGeometryData:h1", 
"PathGeometryData:h2", 
"PathFigureData:h3", 
"LineSegmentData:h4", 
"SegmentData:h5", 
"PolylineSegmentData:h6", 
"ArcSegmentData:h7", 
"PolyBezierSegmentData:h8", 
"LabelAppearanceData:h9", 
"ShapeTags:ia", 
"PointerTooltipVisualDataList:ib", 
"MarkerVisualDataList:ic", 
"MarkerVisualData:id", 
"PointerTooltipVisualData:ie", 
"RectangleVisualData:ig", 
"PolygonVisualData:ih", 
"PolyLineVisualData:ii", 
"IHasCategoryModePreference:ij", 
"IHasCategoryAxis:ik", 
"CategoryAxisBase:il", 
"Axis:im", 
"AxisView:io", 
"AxisLabelPanelBase:ip", 
"Panel:iq", 
"UIElementCollection:ir", 
"AxisLabelPanelBaseView:is", 
"AxisLabelSettings:it", 
"AxisLabelsLocation:iu", 
"PropertyUpdatedEventHandler:iv", 
"PropertyUpdatedEventArgs:iw", 
"PathRenderingInfo:ix", 
"NumericAxisBase:iy", 
"NumericAxisBaseView:iz", 
"NumericAxisRenderer:i0", 
"AxisRendererBase:i1", 
"ShouldRenderHandler:i2", 
"ScaleValueHandler:i3", 
"AxisRenderingParametersBase:i4", 
"RangeInfo:i5", 
"TickmarkValues:i6", 
"TickmarkValuesInitializationParameters:i7", 
"CategoryMode:i8", 
"Func$4:i9", 
"GetGroupCenterHandler:ja", 
"GetUnscaledGroupCenterHandler:jb", 
"RenderStripHandler:jc", 
"RenderLineHandler:jd", 
"ShouldRenderLinesHandler:je", 
"ShouldRenderContentHandler:jf", 
"RenderAxisLineHandler:jg", 
"DetermineCrossingValueHandler:jh", 
"ShouldRenderLabelHandler:ji", 
"GetLabelLocationHandler:jj", 
"LabelPosition:jk", 
"TransformToLabelValueHandler:jl", 
"AxisLabelManager:jm", 
"GetLabelForItemHandler:jn", 
"CreateRenderingParamsHandler:jo", 
"SnapMajorValueHandler:jp", 
"AdjustMajorValueHandler:jq", 
"CategoryAxisRenderingParameters:jr", 
"LogarithmicTickmarkValues:js", 
"LogarithmicNumericSnapper:jt", 
"Snapper:ju", 
"LinearTickmarkValues:jv", 
"LinearNumericSnapper:jw", 
"AxisRangeChangedEventArgs:jx", 
"AxisRange:jy", 
"IEquatable$1:jz", 
"AutoRangeCalculator:j0", 
"NumericYAxis:j1", 
"StraightNumericAxisBase:j2", 
"StraightNumericAxisBaseView:j3", 
"NumericScaler:j4", 
"ScalerParams:j5", 
"NumericScaleMode:j6", 
"LogarithmicScaler:j7", 
"IScaler:j8", 
"AxisOrientation:j9", 
"NumericYAxisView:ka", 
"VerticalAxisLabelPanel:kb", 
"VerticalAxisLabelPanelView:kc", 
"TitleSettings:kd", 
"NumericAxisRenderingParameters:ke", 
"VerticalLogarithmicScaler:kf", 
"VerticalLinearScaler:kg", 
"LinearScaler:kh", 
"NumericRadiusAxis:ki", 
"NumericRadiusAxisView:kj", 
"PolarAxisRenderingManager:kk", 
"ViewportUtils:kl", 
"PolarAxisRenderingParameters:km", 
"IPolarRadialRenderingParameters:kn", 
"RadialAxisRenderingParameters:ko", 
"RadialAxisLabelPanel:kp", 
"HorizontalAxisLabelPanelBase:kq", 
"HorizontalAxisLabelPanelBaseView:kr", 
"RadialAxisLabelPanelView:ks", 
"NumericAngleAxis:kt", 
"IAngleScaler:ku", 
"NumericAngleAxisView:kv", 
"AngleAxisLabelPanel:kw", 
"AngleAxisLabelPanelView:kx", 
"Extensions:ky", 
"CategoryAngleAxis:kz", 
"CategoryAngleAxisView:k0", 
"CategoryAxisBaseView:k1", 
"CategoryAxisRenderer:k2", 
"LinearCategorySnapper:k3", 
"IFastItemsSource:k4", 
"IFastItemColumn$1:k5", 
"IFastItemColumnPropertyName:k6", 
"CategoryTickmarkValues:k7", 
"AxisComponentsForView:k8", 
"AxisComponentsFromView:k9", 
"AxisFormatLabelHandler:la", 
"VisualExportHelper:lb", 
"Canvas:lc", 
"IFastItemsSourceProvider:ld", 
"AxisExtentType:le", 
"ContentInfo:lf", 
"SmartAxisLabelPanel:lg", 
"SmartAxisLabelPanelView:lh", 
"AxisRangeChangedEventHandler:li", 
"ChartContentManager:lj", 
"ChartContentType:lk", 
"SplineFragmentBase:ll", 
"SplineSeriesBase:lm", 
"SplineSeriesBaseView:ln", 
"AnchoredCategorySeriesView:lo", 
"CategorySeriesView:lp", 
"ISupportsMarkers:lq", 
"CategoryBucketCalculator:lr", 
"IBucketizer:ls", 
"ISortingAxis:lt", 
"CategoryFrame:lu", 
"Frame:lv", 
"BrushUtil:lw", 
"CategoryTrendLineManagerBase:lx", 
"TrendLineManagerBase$1:ly", 
"TrendLineType:lz", 
"Clipper:l0", 
"EdgeClipper:l1", 
"LeftClipper:l2", 
"BottomClipper:l3", 
"RightClipper:l4", 
"TopClipper:l5", 
"TrendResolutionParams:l6", 
"Flattener:l7", 
"Stack$1:l8", 
"ReverseArrayEnumerator$1:l9", 
"SpiralTodo:ma", 
"FastItemsSourceEventAction:mb", 
"IPreparesCategoryTrendline:mc", 
"SortingTrendLineManager:md", 
"TrendFitCalculator:me", 
"LeastSquaresFit:mf", 
"Numeric:mg", 
"TrendAverageCalculator:mh", 
"CategoryTrendLineManager:mi", 
"AnchoredCategoryBucketCalculator:mj", 
"CategoryDateTimeXAxis:mk", 
"CategoryDateTimeXAxisView:ml", 
"TimeAxisDisplayType:mm", 
"FastItemDateTimeColumn:mn", 
"IFastItemColumnInternal:mo", 
"FastItemColumn:mp", 
"FastReflectionHelper:mq", 
"HorizontalAxisLabelPanel:mr", 
"CoercionInfo:ms", 
"FastItemsSourceEventArgs:mt", 
"SortedListView$1:mu", 
"ArrayUtil:mv", 
"SplineType:mw", 
"CollisionAvoider:mx", 
"IDetectsCollisions:my", 
"SafeSortedReadOnlyDoubleCollection:mz", 
"SafeReadOnlyDoubleCollection:m0", 
"SafeEnumerable:m1", 
"StackedFragmentSeries:m2", 
"PenLineCap:m3", 
"StackedSeriesBase:m4", 
"IIsCategoryBased:m5", 
"ICategoryScaler:m6", 
"StackedSeriesView:m7", 
"StackedBucketCalculator:m8", 
"StackedSeriesManager:m9", 
"StackedSeriesCollection:na", 
"StackedLineSeries:nb", 
"HorizontalStackedSeriesBase:nc", 
"CategoryFramePreparerBase:nd", 
"FramePreparer:ne", 
"ISupportsErrorBars:nf", 
"DefaultSupportsMarkers:ng", 
"DefaultProvidesViewport:nh", 
"DefaultSupportsErrorBars:ni", 
"PreparationParams:nj", 
"CategoryYAxis:nk", 
"CategoryYAxisView:nl", 
"SyncSettings:nm", 
"NumericXAxis:nn", 
"NumericXAxisView:no", 
"HorizontalLogarithmicScaler:np", 
"HorizontalLinearScaler:nq", 
"ValuesHolder:nr", 
"LineSeries:ns", 
"LineSeriesView:nt", 
"UnknownValuePlotting:nu", 
"CategoryLineRasterizer:nv", 
"Action$5:nw", 
"PathVisualData:nx", 
"CategorySeriesRenderManager:ny", 
"AssigningCategoryStyleEventArgs:nz", 
"AssigningCategoryStyleEventArgsBase:n0", 
"GetCategoryItemsHandler:n1", 
"HighlightingInfo:n2", 
"HighlightingState:n3", 
"AssigningCategoryMarkerStyleEventArgs:n4", 
"HighlightingManager:n5", 
"AreaSeries:n6", 
"AreaSeriesView:n7", 
"LegendTemplates:n8", 
"PieChartBase:n9", 
"PieChartBaseView:oa", 
"PieChartViewManager:ob", 
"PieChartVisualData:oc", 
"PieSliceVisualDataList:od", 
"PieSliceVisualData:oe", 
"PieSliceDataContext:of", 
"Slice:og", 
"SliceView:oh", 
"PieLabel:oi", 
"MouseButtonEventArgs:oj", 
"FastItemsSource:ok", 
"ColumnReference:ol", 
"FastItemObjectColumn:om", 
"FastItemIntColumn:on", 
"LabelsPosition:oo", 
"LeaderLineType:op", 
"OthersCategoryType:oq", 
"IndexCollection:or", 
"LegendBase:os", 
"LegendBaseView:ot", 
"LegendBaseViewManager:ou", 
"GradientData:ov", 
"GradientStopData:ow", 
"DataChartLegendMouseButtonEventArgs:ox", 
"DataChartMouseButtonEventArgs:oy", 
"ChartLegendMouseEventArgs:oz", 
"ChartMouseEventArgs:o0", 
"DataChartLegendMouseButtonEventHandler:o1", 
"DataChartLegendMouseEventHandler:o2", 
"PieChartFormatLabelHandler:o3", 
"SliceClickEventHandler:o4", 
"SliceClickEventArgs:o5", 
"ItemLegend:o6", 
"ItemLegendView:o7", 
"LegendItemInfo:o8", 
"BubbleSeries:o9", 
"ScatterBase:pa", 
"ScatterBaseView:pb", 
"MarkerManagerBase:pc", 
"MarkerManagerBucket:pd", 
"ScatterTrendLineManager:pe", 
"NumericMarkerManager:pf", 
"OwnedPoint:pg", 
"CollisionAvoidanceType:ph", 
"SmartPlacer:pi", 
"ISmartPlaceable:pj", 
"SmartPosition:pk", 
"SmartPlaceableWrapper$1:pl", 
"ScatterAxisInfoCache:pm", 
"ScatterErrorBarSettings:pn", 
"ErrorBarSettingsBase:po", 
"EnableErrorBars:pp", 
"ErrorBarCalculatorReference:pq", 
"IErrorBarCalculator:pr", 
"ErrorBarCalculatorType:ps", 
"ScatterFrame:pt", 
"ScatterFrameBase$1:pu", 
"DictInterpolator$3:pv", 
"Action$6:pw", 
"SyncLink:px", 
"ChartCollection:py", 
"FastItemsSourceReference:pz", 
"SyncManager:p0", 
"SyncLinkManager:p1", 
"ErrorBarsHelper:p2", 
"BubbleSeriesView:p3", 
"BubbleMarkerManager:p4", 
"SizeScale:p5", 
"BrushScale:p6", 
"ScaleLegend:p7", 
"ScaleLegendView:p8", 
"CustomPaletteBrushScale:p9", 
"BrushSelectionMode:qa", 
"ValueBrushScale:qb", 
"RingSeriesBase:qc", 
"XamDoughnutChart:qd", 
"RingCollection:qe", 
"Ring:qf", 
"RingControl:qg", 
"RingControlView:qh", 
"Arc:qi", 
"ArcView:qj", 
"ArcItem:qk", 
"SliceItem:ql", 
"Legend:qm", 
"LegendView:qn", 
"BarSeries:qo", 
"VerticalAnchoredCategorySeries:qp", 
"IBarSeries:qq", 
"BarSeriesView:qr", 
"BarTrendLineManager:qs", 
"BarTrendFitCalculator:qt", 
"BarBucketCalculator:qu", 
"CategoryTransitionInMode:qv", 
"BarFramePreparer:qw", 
"CategoryFramePreparer:qx", 
"IHasCategoryTrendline:qy", 
"IHasTrendline:qz", 
"IHasSingleValueCategory:q0", 
"DefaultCategoryTrendlineHost:q1", 
"DefaultCategoryTrendlinePreparer:q2", 
"DefaultSingleValueProvider:q3", 
"SingleValuesHolder:q4", 
"RingSeriesBaseView:q5", 
"RingSeriesCollection:q6", 
"SliceCollection:q7", 
"XamDoughnutChartView:q8", 
"Action$2:q9", 
"DoughnutChartVisualData:ra", 
"RingSeriesVisualDataList:rb", 
"RingSeriesVisualData:rc", 
"RingVisualDataList:rd", 
"RingVisualData:re", 
"ArcVisualDataList:rf", 
"ArcVisualData:rg", 
"SliceVisualDataList:rh", 
"SliceVisualData:ri", 
"DoughnutChartLabelVisualData:rj", 
"HoleDimensionsChangedEventHandler:rk", 
"HoleDimensionsChangedEventArgs:rl", 
"FunnelSliceDataContext:rm", 
"XamFunnelChart:rn", 
"IItemProvider:ro", 
"Array:rv", 
"XamFunnelConnector:rw", 
"XamFunnelController:rx", 
"SliceInfoList:ry", 
"SliceInfoUnaryComparison:rz", 
"SliceInfo:r0", 
"SliceAppearance:r1", 
"PointList:r2", 
"FunnelSliceVisualData:r3", 
"Bezier:r4", 
"Array:r5", 
"BezierPoint:r6", 
"BezierOp:r7", 
"BezierPointComparison:r8", 
"DoubleColumn:r9", 
"ObjectColumn:sa", 
"XamFunnelView:sb", 
"IOuterLabelWidthDecider:sc", 
"IFunnelLabelSizeDecider:sd", 
"MouseButtonMessage:sh", 
"MouseButtonAction:si", 
"MouseButtonType:sj", 
"SetAreaSizeMessage:sk", 
"RenderSliceMessage:sm", 
"RenderOuterLabelMessage:sn", 
"TooltipValueChangedMessage:so", 
"TooltipUpdateMessage:sp", 
"FunnelDataContext:sq", 
"ClearTooltipMessage:su", 
"ViewPropertyChangedMessage:sx", 
"OuterLabelAlignment:sy", 
"FunnelSliceDisplay:sz", 
"SliceSelectionManager:s0", 
"DataUpdatedMessage:s1", 
"ItemsSourceAction:s2", 
"DictionaryEntry:s3", 
"FunnelFrame:s4", 
"UserSelectedItemsChangedMessage:s5", 
"LabelSizeChangedMessage:s6", 
"FrameRenderCompleteMessage:s7", 
"IntColumn:s8", 
"IntColumnComparison:s9", 
"Convert:ta", 
"SelectedItemsChangedMessage:tb", 
"ModelUpdateMessage:tc", 
"SliceClickedMessage:td", 
"FunnelSliceClickedEventHandler:te", 
"FunnelSliceClickedEventArgs:tf", 
"FunnelChartVisualData:tg", 
"FunnelSliceVisualDataList:th", 
"RingSeries:ti", 
"WaterfallSeries:tj", 
"WaterfallSeriesView:tk", 
"FinancialSeries:tl", 
"FinancialSeriesView:tm", 
"FinancialBucketCalculator:tn", 
"CategoryTransitionSourceFramePreparer:to", 
"TransitionInSpeedType:tp", 
"AssigningCategoryStyleEventHandler:tq", 
"FinancialValueList:tr", 
"FinancialEventHandler:ts", 
"FinancialEventArgs:tt", 
"FinancialCalculationDataSource:tu", 
"CalculatedColumn:tv", 
"FinancialCalculationSupportingCalculations:tw", 
"ColumnSupportingCalculation:tx", 
"SupportingCalculation$1:ty", 
"SupportingCalculationStrategy:tz", 
"DataSourceSupportingCalculation:t0", 
"ProvideColumnValuesStrategy:t1", 
"StepLineSeries:t2", 
"StepLineSeriesView:t3", 
"StepAreaSeries:t4", 
"StepAreaSeriesView:t5", 
"RangeAreaSeries:t6", 
"HorizontalRangeCategorySeries:t7", 
"RangeCategorySeries:t8", 
"IHasHighLowValueCategory:t9", 
"RangeCategorySeriesView:ua", 
"RangeCategoryBucketCalculator:ub", 
"RangeCategoryFramePreparer:uc", 
"DefaultHighLowValueProvider:ud", 
"HighLowValuesHolder:ue", 
"CategoryMarkerManager:uf", 
"RangeValueList:ug", 
"RangeAreaSeriesView:uh", 
"LineFragment:ui", 
"LineFragmentView:uj", 
"LineFragmentBucketCalculator:uk", 
"IStacked100Series:ul", 
"AreaFragment:um", 
"AreaFragmentView:un", 
"AreaFragmentBucketCalculator:uo", 
"StackedColumnSeries:up", 
"StackedColumnSeriesView:uq", 
"StackedColumnBucketCalculator:ur", 
"ColumnFragment:us", 
"ColumnFragmentView:ut", 
"StackedBarSeries:uu", 
"VerticalStackedSeriesBase:uv", 
"StackedBarSeriesView:uw", 
"StackedBarBucketCalculator:ux", 
"BarFragment:uy", 
"StackedAreaSeries:uz", 
"StackedSplineSeries:u0", 
"SplineFragment:u1", 
"SplineFragmentView:u2", 
"SplineFragmentBucketCalculator:u3", 
"StackedSplineAreaSeries:u4", 
"SplineAreaFragment:u5", 
"SplineAreaFragmentView:u6", 
"StackedSeriesFramePreparer:u7", 
"StackedSeriesCreatedEventHandler:u8", 
"StackedSeriesCreatedEventArgs:u9", 
"StackedSeriesVisualData:va", 
"SeriesVisualDataList:vb", 
"RenderRequestedEventArgs:vc", 
"ChartTitleVisualData:vd", 
"VisualDataSerializer:ve", 
"AxisVisualData:vf", 
"AxisLabelVisualDataList:vg", 
"AxisLabelVisualData:vh", 
"AssigningCategoryMarkerStyleEventHandler:vi", 
"SeriesComponentsForView:vj", 
"DataChartAxisRangeChangedEventHandler:vk", 
"ChartAxisRangeChangedEventArgs:vl", 
"ChartVisualData:vm", 
"AxisVisualDataList:vn", 
"RadialBase:vo", 
"RadialBaseView:vp", 
"RadialBucketCalculator:vq", 
"SeriesRenderer$2:vr", 
"SeriesRenderingArguments:vs", 
"RadialFrame:vt", 
"RadialAxes:vu", 
"PolarBase:vv", 
"PolarBaseView:vw", 
"PolarTrendLineManager:vx", 
"PolarLinePlanner:vy", 
"AngleRadiusPair:vz", 
"PolarAxisInfoCache:v0", 
"PolarFrame:v1", 
"PolarAxes:v2", 
"SeriesComponentsFromView:v3", 
"EasingFunctions:v4", 
"TrendCalculators:v5", 
"SeriesViewerComponentsFromView:v6", 
"SeriesViewerSurfaceViewer:v7", 
"LabelPanelArranger:v8", 
"LabelPanelsArrangeState:v9", 
"WindowResponse:wa", 
"SeriesViewerComponentsForView:wb", 
"DataChartCursorEventHandler:wc", 
"ChartCursorEventArgs:wd", 
"DataChartMouseButtonEventHandler:we", 
"DataChartMouseEventHandler:wf", 
"AnnotationLayer:wg", 
"AnnotationLayerView:wh", 
"RefreshCompletedEventHandler:wi", 
"AbstractEnumerable:acd", 
"AbstractEnumerator:ace", 
"GenericEnumerable$1:acf", 
"GenericEnumerator$1:acg"]);





$.ig.util.defType('WindowResponse', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "Deferred";
			case 1: return "Immediate";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('WindowResponse', $.ig.Enum.prototype.$type)
}, true);



$.ig.util.defType('OthersCategoryType', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "Number";
			case 1: return "Percent";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('OthersCategoryType', $.ig.Enum.prototype.$type)
}, true);


$.ig.util.defType('LabelsPosition', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "None";
			case 1: return "Center";
			case 2: return "InsideEnd";
			case 3: return "OutsideEnd";
			case 4: return "BestFit";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('LabelsPosition', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('GridMode', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "None";
			case 1: return "BeforeSeries";
			case 2: return "BehindSeries";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('GridMode', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('AxisOrientation', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "Horizontal";
			case 1: return "Vertical";
			case 2: return "Angular";
			case 3: return "Radial";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('AxisOrientation', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('CategoryMode', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "Mode0";
			case 1: return "Mode1";
			case 2: return "Mode2";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('CategoryMode', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('AxisLabelsLocation', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "OutsideTop";
			case 1: return "OutsideBottom";
			case 2: return "OutsideLeft";
			case 3: return "OutsideRight";
			case 4: return "InsideTop";
			case 5: return "InsideBottom";
			case 6: return "InsideLeft";
			case 7: return "InsideRight";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('AxisLabelsLocation', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('TransitionInSpeedType', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "Auto";
			case 1: return "Normal";
			case 2: return "ValueScaled";
			case 3: return "IndexScaled";
			case 4: return "Random";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('TransitionInSpeedType', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('HighlightingState', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "Out";
			case 1: return "In";
			case 2: return "Static";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('HighlightingState', $.ig.Enum.prototype.$type)
}, true);



$.ig.util.defType('ChartContentType', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "Series";
			case 1: return "Axis";
			case 2: return "Background";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('ChartContentType', $.ig.Enum.prototype.$type)
}, true);




$.ig.util.defType('LeaderLineType', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "Straight";
			case 1: return "Arc";
			case 2: return "Spline";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('LeaderLineType', $.ig.Enum.prototype.$type)
}, true);




$.ig.util.defType('AxisExtentType', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "Pixel";
			case 1: return "Percent";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('AxisExtentType', $.ig.Enum.prototype.$type)
}, true);


$.ig.util.defType('AxisTitlePosition', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "Auto";
			case 1: return "Left";
			case 2: return "Right";
			case 3: return "Top";
			case 4: return "Bottom";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('AxisTitlePosition', $.ig.Enum.prototype.$type)
}, true);





$.ig.util.defType('SeriesViewer', 'Control', {

	_view: null,
	view: function (value) {
		if (arguments.length === 1) {
			this._view = value;
			return value;
		} else {
			return this._view;
		}
	}
	, 
	staticInit: function () {



			$.ig.SeriesViewer.prototype.standardRect = new $.ig.Rect(0, 0, 0, 1, 1);
	}
	, 
	init: function () {


		this._series = new $.ig.SeriesCollection();
		this.__viewport = $.ig.Rect.prototype.empty();
		this.__effectiveViewport = $.ig.Rect.prototype.empty();
		this.__actualZoomTileCacheSize = $.ig.SeriesViewer.prototype.defaultZoomCacheSize;
		this.__componentsForView = new $.ig.SeriesViewerComponentsForView();
		this.__interactionHide = false;
		this._state = $.ig.InteractionState.prototype.none;
		this.__pinching = false;
		this.__crossHairActivated = false;
		this.__tileManager = null;
		this.__ignoreContactUp = false;
		this.__suppressCrosshairChange = false;
		this.__windowEventDepth = 0;
		this.__useOPD = false;
		this._previewRect = $.ig.Rect.prototype.empty();
		this.__titleTextColor = null;
		this.__subtitleTextColor = null;
		this.__titleTopMargin = NaN;
		this.__titleLeftMargin = NaN;
		this.__titleRightMargin = NaN;
		this.__titleBottomMargin = NaN;
		this.__subtitleTopMargin = NaN;
		this.__subtitleLeftMargin = NaN;
		this.__subtitleRightMargin = NaN;
		this.__subtitleBottomMargin = NaN;
		this.__mobileMode = false;
		this.__widgetLevelSource = null;
		this.__specificSources = new $.ig.Dictionary$2(String, $.ig.Object.prototype.$type, 0);
		this.__topMargin = NaN;
		this.__leftMargin = NaN;
		this.__rightMargin = NaN;
		this.__bottomMargin = NaN;
		this.__autoMarginWidth = 20;
		this.__autoMarginHeight = NaN;
		this.__pixelScalingRatio = NaN;
		this.__actualPixelScalingRatio = 1;
		this.__actualWindowPositionHorizontal = 0;
		this.__actualWindowPositionVertical = 0;
		this.__isThumbnailRequired = false;
		this.__uniqueIndex = 0;

		var $self = this;
		$.ig.Control.prototype.init.call(this);
			this.__actualWindowRect = $.ig.Rect.prototype.empty();
			this._crosshairPoint = {__x: NaN, __y: NaN, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			this.lastZoomTime($.ig.Date.prototype.now());
			this.isDefaultCrosshairDisabled(false);
			this.isDefaultTooltipDisabled(false);
			this.canvasRenderScheduler(new $.ig.CanvasRenderScheduler());
			this.thumbnailCanvasRenderScheduler(new $.ig.CanvasRenderScheduler());
			this.alternateViewRenderScheduler(new $.ig.CanvasRenderScheduler());
			$.ig.SeriesViewer.prototype.standardRect = new $.ig.Rect(0, 0, 0, 1, 1);
			this.syncSettings((function () { var $ret = new $.ig.SyncSettings();
			$ret.synchronizeHorizontally(true);
			$ret.synchronizeVertically(true); return $ret;}()));
			this.anchor($.ig.Rect.prototype.empty());
			this.dragStartPoint($.ig.Rect.prototype.empty());
			this.view(this.createView());
			this.onViewCreated(this.view());
			this.view().onInit();
			this.crosshairsVisible(this.crosshairVisibility() == $.ig.Visibility.prototype.visible || (this.mobileMode() && !this.userSetCrosshairVisibility()));
			this.overviewPlusDetailPane().thumbnailSizeChanged = $.ig.Delegate.prototype.combine(this.overviewPlusDetailPane().thumbnailSizeChanged, function (o, e) {
				($self.overviewPlusDetailPane().surfaceViewer()).isDirty(true);
				var en = $self.series().getEnumerator();
				while (en.moveNext()) {
					var series = en.current();
					series.thumbnailDirty(true);
				}

			});
			this.actualSyncLink(new $.ig.SyncLink());
			this.updateSyncLink(null, this.actualSyncLink());
			this.chartContentManager(new $.ig.ChartContentManager(this));
			this.propertyUpdated = $.ig.Delegate.prototype.combine(this.propertyUpdated, function (o, e) {
				$self.propertyUpdatedOverride(o, e.propertyName(), e.oldValue(), e.newValue());
			});
			this.series().collectionChanged = $.ig.Delegate.prototype.combine(this.series().collectionChanged, this.series_CollectionChanged.runOn(this));
			this.series().collectionResetting = $.ig.Delegate.prototype.combine(this.series().collectionResetting, this.series_CollectionResetting.runOn(this));
			this.highlightingManager(new $.ig.HighlightingManager());
			this.highlightingAnimator(new $.ig.DoubleAnimator(0, 1, this.highlightingTransitionDuration()));
			this.highlightingAnimator().propertyChanged = $.ig.Delegate.prototype.combine(this.highlightingAnimator().propertyChanged, this.highlightingAnimator_PropertyChanged.runOn(this));
			this.view().createLayout();
			this.invalidateActualWindowRect();
	}

	, 
	series: function () {

			return this._series;
	}
	, 
	_series: null

	, 
	series_CollectionChanged: function (sender, e) {
		if (e.oldItems() != null) {
			var en = e.oldItems().getEnumerator();
			while (en.moveNext()) {
				var series = en.current();
				series.syncLink(null);
				series.seriesViewer(null);
				this.removeDataSource(series);
				this.view().removeSeries(series);
			}

		}

		if (e.newItems() != null) {
			var en1 = e.newItems().getEnumerator();
			while (en1.moveNext()) {
				var series1 = en1.current();
				if (!this.view().seriesAttached(series1)) {
					this.updateDataSourceFor(series1);
					this.view().attachSeries(series1);
					series1.syncLink(this.actualSyncLink());
					series1.seriesViewer(this);
					series1.updateSeriesIndexedPropertiesInternal();
				}

			}

		}

		this.notifyThumbnailAppearanceChanged();
		this.onHoverBehaviorOverridesChanged();
	}

	, 
	removeDataSource: function (item) {
		if ($.ig.util.cast($.ig.Series.prototype.$type, item) !== null) {
			(item).itemsSource(null);

		} else if ($.ig.util.cast($.ig.CategoryAxisBase.prototype.$type, item) !== null) {
			(item).itemsSource(null);
		}


		this.removeSpecificDataSource((item).name(), true);
	}

	, 
	series_CollectionResetting: function (sender, e) {
		var en = this.series().getEnumerator();
		while (en.moveNext()) {
			var series = en.current();
			series.syncLink(null);
			series.seriesViewer(null);
			this.removeDataSource(series);
			this.view().removeSeries(series);
		}

	}

	, 
	matchRatio: function (width, height, widthChanging, heightChanging) {
		var viewport = this.viewportRect();
		var viewportWidth = viewport.width();
		var viewportHeight = viewport.height();
		var viewportRatio = viewportWidth / viewportHeight;
		var matchRatio = width / height;
		if ($.ig.util.isNaN(viewportRatio)) {
			return{
				p0: width, 
				p1: height
			};
		}

		if ($.ig.util.isNaN(matchRatio) || widthChanging || heightChanging || Math.abs(viewportRatio - matchRatio) > 0.0001) {
			if (widthChanging && heightChanging) {
				if (width > height) {
					height = width / viewportRatio;

				} else {
					width = height * viewportRatio;
				}


			} else if (widthChanging) {
				height = width / viewportRatio;

			} else {
				width = height * viewportRatio;
			}


		}

		if (height > 1) {
			var scale = 1 / height;
			height = 1;
			width = width * scale;
		}

		if (width > 1) {
			var scale1 = 1 / width;
			width = 1;
			height = height * scale1;
		}

		return {
			p0: width, 
			p1: height
		};
	}

	, 
	effectiveIsSquare: function () {
		return false;
	}

	, 
	_highlightingManager: null,
	highlightingManager: function (value) {
		if (arguments.length === 1) {
			this._highlightingManager = value;
			return value;
		} else {
			return this._highlightingManager;
		}
	}

	, 
	_highlightingAnimator: null,
	highlightingAnimator: function (value) {
		if (arguments.length === 1) {
			this._highlightingAnimator = value;
			return value;
		} else {
			return this._highlightingAnimator;
		}
	}

	, 
	highlightingAnimator_PropertyChanged: function (sender, e) {
		this.updateHighlights(this.highlightingAnimator().transitionProgress());
	}

	, 
	updateHighlights: function (transitionProgress) {
		var stillRunning = this.highlightingManager().tick(transitionProgress);
		if (transitionProgress == 1 && stillRunning && this.highlightingAnimator().intervalMilliseconds() > 0) {
			this.highlightingAnimator().start();
		}

		var dirtySeries = this.highlightingManager().dirtySeries();
		for (var i = 0; i < dirtySeries.count(); i++) {
			var series = dirtySeries.__inner[i];
			series.onVisualPropertiesChangedImmediate();
		}

		if (!stillRunning) {
			this.highlightingAnimator().stop();
		}

	}

	, 
	hideToolTip: function () {
		this.view().hideTooltip();
	}

	, 
	getBrushByIndex: function (index) {
		return null;
	}

	, 
	getOutlineByIndex: function (index) {
		return null;
	}

	, 
	getMarkerBrushByIndex: function (index) {
		return null;
	}

	, 
	getMarkerOutlineByIndex: function (index) {
		return null;
	}

	, 
	_chartContentManager: null,
	chartContentManager: function (value) {
		if (arguments.length === 1) {
			this._chartContentManager = value;
			return value;
		} else {
			return this._chartContentManager;
		}
	}

	, 
	crosshairPoint: function (value) {
		if (arguments.length === 1) {

			if (this._crosshairPoint != value) {
				var oldCrosshairPoint = this._crosshairPoint;
				this._crosshairPoint = value;
				this.raisePropertyChanged($.ig.SeriesViewer.prototype.crosshairPointPropertyName, oldCrosshairPoint, this._crosshairPoint);
			}

			return value;
		} else {

			return this._crosshairPoint;
		}
	}
	, 
	_crosshairPoint: null

	, 
	isInDragOperation: function () {

			return this.state() == $.ig.InteractionState.prototype.dragZoom || this.state() == $.ig.InteractionState.prototype.dragPan;
	}

	, 
	legend: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.legendProperty, value);
			return value;
		} else {

			return this.getValue($.ig.SeriesViewer.prototype.legendProperty);
		}
	}

	, 
	animateSeriesWhenAxisRangeChanges: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.animateSeriesWhenAxisRangeChangesProperty, value);
			return value;
		} else {

			return this.getValue($.ig.SeriesViewer.prototype.animateSeriesWhenAxisRangeChangesProperty);
		}
	}
	, 
	propertyChanged: null, 
	propertyUpdated: null
	, 
	raisePropertyChanged: function (name, oldValue, newValue) {
		if (this.propertyChanged != null) {
			this.propertyChanged(this, new $.ig.PropertyChangedEventArgs(name));
		}

		if (this.propertyUpdated != null) {
			this.propertyUpdated(this, new $.ig.PropertyUpdatedEventArgs(name, oldValue, newValue));
		}

	}

	, 
	onLegendSortChanged: function () {
		this.onLegendSortChanged1(this.series());
	}

	, 
	onLegendSortChanged1: function (seriesCollection) {
		var en = seriesCollection.getEnumerator();
		while (en.moveNext()) {
			var currSeries = en.current();
			var legend = currSeries.actualLegend();
			if (legend == null) {
				continue;
			}

			var item = currSeries.legendItem();
			if (item == null) {
				continue;
			}

			if (legend.children().contains(item)) {
				legend.children().remove(item);
			}

			if (!legend.children().contains(item) && currSeries.legendItemVisibility() != $.ig.Visibility.prototype.collapsed) {
				legend.addChildInOrder(item, currSeries);
			}

		}

	}

	, 
	onSeriesMouseEnter: function (series, item, data) {
		this.raiseSeriesMouseEnter(series, item, $.ig.util.cast($.ig.MouseEventArgs.prototype.$type, data));
	}

	, 
	onSeriesMouseMove: function (series, item, data) {
		this.raiseSeriesMouseMove(series, item, $.ig.util.cast($.ig.MouseEventArgs.prototype.$type, data));
	}

	, 
	onSeriesMouseLeave: function (series, item, data) {
		this.raiseSeriesMouseLeave(series, item, $.ig.util.cast($.ig.MouseEventArgs.prototype.$type, data));
	}

	, 
	onSeriesMouseLeftButtonDown: function (series, item, data) {
		this.raiseSeriesMouseLeftButtonDown(series, item, $.ig.util.cast($.ig.MouseButtonEventArgs.prototype.$type, data));
	}

	, 
	onSeriesMouseLeftButtonUp: function (series, item, data) {
		var args = $.ig.util.cast($.ig.MouseButtonEventArgs.prototype.$type, data);
		if (args != null) {
			this.raiseSeriesMouseLeftButtonUp(series, item, $.ig.util.cast($.ig.MouseButtonEventArgs.prototype.$type, data));
		}

	}

	, 
	onSeriesMouseRightButtonDown: function (series, item, data) {
	}

	, 
	onSeriesMouseRightButtonUp: function (series, item, data) {
	}
	, 
	seriesCursorMouseMove: null
	, 
	raiseSeriesCursorMouseMove: function (series, item) {
		if (this.seriesCursorMouseMove != null && this.crosshairsVisible()) {
			this.seriesCursorMouseMove(this, new $.ig.ChartCursorEventArgs(this, series, item));
		}

	}
	, 
	seriesMouseLeftButtonDown: null
	, 
	raiseSeriesMouseLeftButtonDown: function (series, item, e) {
		if (this.seriesMouseLeftButtonDown != null) {
			this.seriesMouseLeftButtonDown(this, new $.ig.DataChartMouseButtonEventArgs(this, series, item, e));
		}

	}
	, 
	seriesMouseLeftButtonUp: null
	, 
	raiseSeriesMouseLeftButtonUp: function (series, item, e) {
		if (this.seriesMouseLeftButtonUp != null) {
			this.seriesMouseLeftButtonUp(this, new $.ig.DataChartMouseButtonEventArgs(this, series, item, e));
		}

	}
	, 
	seriesMouseMove: null
	, 
	raiseSeriesMouseMove: function (series, item, e) {
		if (this.seriesMouseMove != null) {
			this.seriesMouseMove(this, new $.ig.ChartMouseEventArgs(this, series, item, e));
		}

	}
	, 
	seriesMouseEnter: null
	, 
	raiseSeriesMouseEnter: function (series, item, e) {
		if (this.seriesMouseEnter != null) {
			this.seriesMouseEnter(this, new $.ig.ChartMouseEventArgs(this, series, item, e));
		}

	}
	, 
	seriesMouseLeave: null
	, 
	raiseSeriesMouseLeave: function (series, item, e) {
		if (this.seriesMouseLeave != null) {
			this.seriesMouseLeave(this, new $.ig.ChartMouseEventArgs(this, series, item, e));
		}

	}
	, 
	__viewport: null

	, 
	viewportRect: function () {

			return this.__viewport;
	}
	, 
	__effectiveViewport: null

	, 
	effectiveViewport: function () {

			return this.__effectiveViewport;
	}

	, 
	computeEffectiveViewport: function (viewportRect) {
		return $.ig.Rect.prototype.empty();
	}

	, 
	updateAxisViewport: function (axis) {
		axis.viewportRect(this.viewportRect());
	}

	, 
	windowRect: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.windowRectProperty, value);
			return value;
		} else {

			return this.getValue($.ig.SeriesViewer.prototype.windowRectProperty);
		}
	}

	, 
	useTiledZooming: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.useTiledZoomingProperty, value);
			return value;
		} else {

			return this.getValue($.ig.SeriesViewer.prototype.useTiledZoomingProperty);
		}
	}

	, 
	_actualUseTiledZooming: false,
	actualUseTiledZooming: function (value) {
		if (arguments.length === 1) {
			this._actualUseTiledZooming = value;
			return value;
		} else {
			return this._actualUseTiledZooming;
		}
	}

	, 
	preferHigherResolutionTiles: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.preferHigherResolutionTilesProperty, value);
			return value;
		} else {

			return this.getValue($.ig.SeriesViewer.prototype.preferHigherResolutionTilesProperty);
		}
	}

	, 
	zoomTileCacheSize: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.zoomTileCacheSizeProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.SeriesViewer.prototype.zoomTileCacheSizeProperty));
		}
	}
	, 
	__actualZoomTileCacheSize: 0

	, 
	actualZoomTileCacheSize: function (value) {
		if (arguments.length === 1) {

			this.__actualZoomTileCacheSize = value;
			return value;
		} else {

			return this.__actualZoomTileCacheSize;
		}
	}

	, 
	_isTileZoomRunning: false,
	isTileZoomRunning: function (value) {
		if (arguments.length === 1) {
			this._isTileZoomRunning = value;
			return value;
		} else {
			return this._isTileZoomRunning;
		}
	}

	, 
	highlightingTransitionDuration: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.highlightingTransitionDurationProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.SeriesViewer.prototype.highlightingTransitionDurationProperty));
		}
	}

	, 
	processPlotAreaSizeChanged: function (oldGridAreaRect, newGridAreaRect) {
		if (!newGridAreaRect.isEmpty()) {
			this.__viewport = newGridAreaRect;
			this.__effectiveViewport = this.computeEffectiveViewport(this.__viewport);
			this.view().viewportChanged(this.__viewport);
		}

		if (this.effectiveIsSquare()) {
			if (this.actualSyncLink() != null) {
				this.windowNotify(this.actualWindowRect());
			}

		}

		this.onPlotAreaSizeChanged(oldGridAreaRect, newGridAreaRect);
	}
	, 
	__componentsForView: null

	, 
	getComponentsForView: function () {
		return this.__componentsForView;
	}

	, 
	isPagePanningAllowed: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.isPagePanningAllowedProperty, value);
			return value;
		} else {

			return this.getValue($.ig.SeriesViewer.prototype.isPagePanningAllowedProperty);
		}
	}

	, 
	isSurfaceInteractionDisabled: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.isSurfaceInteractionDisabledProperty, value);
			return value;
		} else {

			return this.getValue($.ig.SeriesViewer.prototype.isSurfaceInteractionDisabledProperty);
		}
	}

	, 
	isZoomingHorizontallyEnabled: function () {}

	, 
	isZoomingVerticallyEnabled: function () {}

	, 
	isZoomingEnabled: function () {
		return this.isZoomingHorizontallyEnabled() || this.isZoomingVerticallyEnabled();
	}

	, 
	onDetachedFromUI: function () {
		$.ig.SyncManager.prototype.suspendSyncChannel(this);
	}

	, 
	onAttachedToUI: function () {
		$.ig.SyncManager.prototype.ensureSyncChannel(this);
	}

	, 
	state: function (value) {
		if (arguments.length === 1) {

			if (this.state() != value) {
				this._state = value;
				switch (this._state) {
					case $.ig.InteractionState.prototype.none:
						this.view().setDefaultCursor();
						this.renderCrosshairs();
						this.view().goToIdleState();
						break;
					case $.ig.InteractionState.prototype.dragZoom:
						this.view().setHandCursor();
						this.view().hideTooltip();
						this.renderCrosshairs();
						this.view().goToDraggingVisualState();
						break;
					case $.ig.InteractionState.prototype.dragPan:
						this.view().setHandCursor();
						this.view().hideTooltip();
						this.renderCrosshairs();
						this.view().goToPanningVisualState();
						break;
				}

			}

			return value;
		} else {

			return this._state;
		}
	}
	, 
	__interactionHide: false
	, 
	_state: 0

	, 
	_anchor: null,
	anchor: function (value) {
		if (arguments.length === 1) {
			this._anchor = value;
			return value;
		} else {
			return this._anchor;
		}
	}

	, 
	_dragState: null,
	dragState: function (value) {
		if (arguments.length === 1) {
			this._dragState = value;
			return value;
		} else {
			return this._dragState;
		}
	}

	, 
	onMouseEnter: function (pt) {
		this.crosshairNotify(this.toWorld(pt));
	}

	, 
	onMouseLeave: function (pt) {
		this.crosshairNotify({__x: NaN, __y: NaN, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
	}

	, 
	onMouseWheel: function (pt, delta) {
		var cx = this.actualWindowRect().left() + this.actualWindowRect().width() * pt.__x / this.viewportRect().width();
		var cy = this.actualWindowRect().top() + this.actualWindowRect().height() * pt.__y / this.viewportRect().height();
		var scale = 1 - $.ig.MathUtil.prototype.clamp(delta, -0.5, 0.5);
		var left = Math.max(0, cx - scale * (cx - this.actualWindowRect().left()));
		var bottom = Math.min(1, cy + scale * (this.actualWindowRect().bottom() - cy));
		var right = Math.min(1, cx + scale * (this.actualWindowRect().right() - cx));
		var top = Math.max(0, cy - scale * (cy - this.actualWindowRect().top()));
		this.startTiledZoomingIfNecessary();
		this.deferEndToTiledZoom(1000);
		this.windowNotify(new $.ig.Rect(0, left, top, right - left, bottom - top));
		return this.isZoomingEnabled();
	}

	, 
	deferEndToTiledZoom: function (delay) {
		this.view().deferEndToTiledZoom(delay);
	}

	, 
	onDoubleTap: function (pt) {
		var cx = this.actualWindowRect().left() + this.actualWindowRect().width() * pt.__x / this.viewportRect().width();
		var cy = this.actualWindowRect().top() + this.actualWindowRect().height() * pt.__y / this.viewportRect().height();
		var scale = 0.7;
		var left = Math.max(0, cx - scale * (cx - this.actualWindowRect().left()));
		var bottom = Math.min(1, cy + scale * (this.actualWindowRect().bottom() - cy));
		var right = Math.min(1, cx + scale * (this.actualWindowRect().right() - cx));
		var top = Math.max(0, cy - scale * (cy - this.actualWindowRect().top()));
		this.windowNotify(new $.ig.Rect(0, left, top, right - left, bottom - top));
	}

	, 
	_windowRectAtStartOfWindowOperation: null,
	windowRectAtStartOfWindowOperation: function (value) {
		if (arguments.length === 1) {
			this._windowRectAtStartOfWindowOperation = value;
			return value;
		} else {
			return this._windowRectAtStartOfWindowOperation;
		}
	}

	, 
	onKeyDown: function (key) {
		if (this.state() == $.ig.InteractionState.prototype.dragPan && key == $.ig.Key.prototype.escape) {
			this.view().cancelMouseInteractions();
			this.state($.ig.InteractionState.prototype.none);
			this.endTiledZoomingIfRunning();
			this.previewNotify($.ig.Rect.prototype.empty());
			if (this.windowResponse() == $.ig.WindowResponse.prototype.immediate) {
				this.windowNotify(this.windowRectAtStartOfWindowOperation());
			}

			return true;
		}

		if (this.state() == $.ig.InteractionState.prototype.dragZoom && key == $.ig.Key.prototype.escape) {
			this.view().cancelMouseInteractions();
			this.state($.ig.InteractionState.prototype.none);
			this.endTiledZoomingIfRunning();
			this.view().hideDragPath();
			this.previewNotify($.ig.Rect.prototype.empty());
			return true;
		}

		var windowRect = $.ig.Rect.prototype.empty();
		var handled = false;
		switch (key) {
			case $.ig.Key.prototype.home:
				handled = true;
				windowRect = new $.ig.Rect(0, 0, 0, 1, 1);
				break;
			case $.ig.Key.prototype.pageDown:
				handled = true;
				windowRect = new $.ig.Rect(0, this.actualWindowRect().left() - 0.1 * this.actualWindowRect().width(), this.actualWindowRect().top() - 0.1 * this.actualWindowRect().height(), 1.2 * this.actualWindowRect().width(), 1.2 * this.actualWindowRect().height());
				break;
			case $.ig.Key.prototype.pageUp:
				handled = true;
				windowRect = new $.ig.Rect(0, this.actualWindowRect().left() + 0.1 * this.actualWindowRect().width(), this.actualWindowRect().top() + 0.1 * this.actualWindowRect().height(), 0.8 * this.actualWindowRect().width(), 0.8 * this.actualWindowRect().height());
				break;
			case $.ig.Key.prototype.left:
				handled = true;
				windowRect = new $.ig.Rect(0, this.actualWindowRect().left() - 0.1 * this.actualWindowRect().width(), this.actualWindowRect().top(), this.actualWindowRect().width(), this.actualWindowRect().height());
				windowRect.x(windowRect.x() - Math.min(windowRect.left(), 0));
				break;
			case $.ig.Key.prototype.right:
				handled = true;
				windowRect = new $.ig.Rect(0, this.actualWindowRect().left() + 0.1 * this.actualWindowRect().width(), this.actualWindowRect().top(), this.actualWindowRect().width(), this.actualWindowRect().height());
				windowRect.x(windowRect.x() - Math.max(windowRect.right() - 1, 0));
				break;
			case $.ig.Key.prototype.up:
				handled = true;
				windowRect = new $.ig.Rect(0, this.actualWindowRect().left(), this.actualWindowRect().top() - 0.1 * this.actualWindowRect().height(), this.actualWindowRect().width(), this.actualWindowRect().height());
				windowRect.y(windowRect.y() - Math.min(windowRect.top(), 0));
				break;
			case $.ig.Key.prototype.down:
				handled = true;
				windowRect = new $.ig.Rect(0, this.actualWindowRect().left(), this.actualWindowRect().top() + 0.1 * this.actualWindowRect().height(), this.actualWindowRect().width(), this.actualWindowRect().height());
				windowRect.y(windowRect.y() - Math.max(windowRect.bottom() - 1, 0));
				break;
		}

		if (!windowRect.isEmpty() && windowRect != this.actualWindowRect()) {
			this.windowNotify(windowRect);
		}

		return handled;
	}
	, 
	__pinching: false

	, 
	_crosshairsVisible: false,
	crosshairsVisible: function (value) {
		if (arguments.length === 1) {
			this._crosshairsVisible = value;
			return value;
		} else {
			return this._crosshairsVisible;
		}
	}
	, 
	__crossHairActivated: false

	, 
	areCrossHairsActivated: function () {

			return this.__crossHairActivated;
	}
	, 
	__lastDistanceRatio: 0

	, 
	onDragDelta: function (point) {
		if (point.__x >= 0 && point.__y >= 0 && point.__x <= this.viewportRect().width() && point.__y <= this.viewportRect().height()) {
			this.showDragTooltip(point);

		} else {
			this.hideDragCrosshairAndTooltip();
		}

	}

	, 
	showDragTooltip: function (pt) {
		if (this.isDefaultTooltipDisabled() || this.isDefaultCrosshairDisabled()) {
			return;
		}

		if (this.__crossHairActivated && this.crosshairsVisible()) {
			var isVertical = this.viewportRect().height() > this.viewportRect().width();
			this.view().clearInfoBox(isVertical);
			var en = this.series().getEnumerator();
			while (en.moveNext()) {
				var series = en.current();
				if (series.__visibility == $.ig.Visibility.prototype.visible) {
					series.showTooltip(pt, this.view().addToInfoBox.runOn(this.view()));
				}

			}

			this.view().showInfoBox();
		}

	}

	, 
	dragCrosshairActivated: function () {

			return this.__crossHairActivated;
	}

	, 
	_tooltipStyle: null,
	tooltipStyle: function (value) {
		if (arguments.length === 1) {
			this._tooltipStyle = value;
			return value;
		} else {
			return this._tooltipStyle;
		}
	}

	, 
	showDragCrosshair: function (pt) {
		if (this.crosshairsVisible() || this.isDragCrosshairEnabled() || this.isAnnotationLayerPresent()) {
			this.__crossHairActivated = true;
			this.anchor(new $.ig.Rect(0, pt.__x, pt.__y, 0, 0));
			this.dragState(new $.ig.Rect(0, pt.__x, pt.__y, 0, 0));
			this.state($.ig.InteractionState.prototype.none);
			this.crosshairNotify(this.toWorld(pt));
		}

	}

	, 
	onPlotAreaHold: function (pt) {
		this.showDragCrosshair(pt);
		this.showDragTooltip(pt);
		this.renderCrosshairs();
	}

	, 
	onDragStarted: function (pt, isFinger) {
		if (!this.__crossHairActivated) {
			this.startWindowOperation(pt, isFinger);
		}

	}

	, 
	onDragCompleted: function (point) {
		this.dragStartPoint($.ig.Rect.prototype.empty());
		this.hideDragCrosshairAndTooltip();
	}

	, 
	pinching: function () {

			return this.__pinching;
	}

	, 
	onPinchStarted: function (point) {
		this.__lastDistanceRatio = 1;
		this.__crossHairActivated = false;
		this.view().hidePreviewPath();
		this.view().hideDragPath();
		this.view().hideInfoBox();
		this.crosshairNotify({__x: NaN, __y: NaN, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
		this.view().hideHorizontalCrosshair();
		this.view().hideVerticalCrosshair();
		this.view().hideTooltip();
		this.state($.ig.InteractionState.prototype.none);
		this.__ignoreContactUp = true;
		this.__pinching = true;
		this.startTiledZoomingIfNecessary();
	}

	, 
	onPinchDelta: function (p) {
		this.view().hideHorizontalCrosshair();
		this.view().hideVerticalCrosshair();
		if (this.view().useDeltaZoom()) {
			this.doDeltaZoom(p);

		} else {
			this.doZoom(p);
			this.__lastDistanceRatio = p;
		}

	}

	, 
	onManipulationStarted: function (point) {
		this.anchor(new $.ig.Rect(0, point.__x, point.__y, 0, 0));
		this.dragState(new $.ig.Rect(0, point.__x, point.__y, 0, 0));
	}

	, 
	doScale: function (scaleDelta, anchor) {
		var width = this.actualWindowRect().width();
		var height = this.actualWindowRect().height();
		var cx = this.actualWindowRect().left() + width / 2;
		var cy = this.actualWindowRect().top() + height / 2;
		width = width / scaleDelta;
		height = height / scaleDelta;
		var left = cx - width / 2;
		var top = cy - height / 2;
		this.windowNotify(new $.ig.Rect(0, left, top, width, height));
	}

	, 
	onPinchCompleted: function (p) {
		if (this.view().useDeltaZoom()) {
			this.doDeltaZoom(p);

		} else {
			this.doZoom(p);
		}

		this.anchor($.ig.Rect.prototype.empty());
		this.__pinching = false;
	}

	, 
	onGestureCompleted: function (pt) {
		this.__pinching = false;
		this.anchor($.ig.Rect.prototype.empty());
		this.hideDragCrosshairAndTooltip();
	}

	, 
	onInfoBoxSizeChanged: function (size) {
		this.view().updateInfoBoxYTranslation(size.height());
	}

	, 
	hideDragCrosshairAndTooltip: function () {
		if (this.__crossHairActivated) {
			this.crosshairNotify({__x: NaN, __y: NaN, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			this.view().hideInfoBox();
		}

		this.__crossHairActivated = false;
	}

	, 
	doDeltaZoom: function (deltaZoom) {
		var f = 1 / deltaZoom;
		var wRectCenter = {__x: this.windowRect().x() + this.windowRect().width() / 2, __y: this.windowRect().y() + this.windowRect().height() / 2, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		var wRectOrigin = {__x: this.windowRect().x() - wRectCenter.__x, __y: this.windowRect().y() - wRectCenter.__y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		var scaledWindowRect = new $.ig.Rect(0, wRectOrigin.__x * f + wRectCenter.__x, wRectOrigin.__y * f + wRectCenter.__y, this.windowRect().width() * f, this.windowRect().height() * f);
		this.windowNotify(scaledWindowRect);
	}

	, 
	doZoom: function (distanceRatio) {
		var distanceRatioDiff = distanceRatio - this.__lastDistanceRatio;
		if (distanceRatioDiff != 0) {
			var p = 0.03;
			var f = distanceRatioDiff < 0 ? 1 + p : 1 - p;
			var wRectCenter = {__x: this.windowRect().x() + this.windowRect().width() / 2, __y: this.windowRect().y() + this.windowRect().height() / 2, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			var wRectOrigin = {__x: this.windowRect().x() - wRectCenter.__x, __y: this.windowRect().y() - wRectCenter.__y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			var scaledWindowRect = new $.ig.Rect(0, wRectOrigin.__x * f + wRectCenter.__x, wRectOrigin.__y * f + wRectCenter.__y, this.windowRect().width() * f, this.windowRect().height() * f);
			this.windowNotify(scaledWindowRect);
		}

	}

	, 
	onZoomChanged: function (rc) {
		this.previewNotify($.ig.Rect.prototype.empty());
		this.windowNotify(rc);
	}

	, 
	onContactStarted: function (pt, isFinger) {
		if (!this.__pinching) {
			this.__ignoreContactUp = false;
		}

		this.startWindowOperation(pt, isFinger);
	}

	, 
	resolveDefaultInteraction: function (isFinger) {
		if (this.defaultInteraction() != $.ig.InteractionState.prototype.auto) {
			return this.defaultInteraction();
		}

		return this.view().resolveDefaultInteraction(isFinger);
	}

	, 
	startWindowOperation: function (pt, isFinger) {
		var newState;
		var defaultInteraction = this.resolveDefaultInteraction(isFinger);
		if (this.view().currentModifiers() == $.ig.ModifierKeys.prototype.none) {
			switch (defaultInteraction) {
				case $.ig.InteractionState.prototype.dragZoom:
					newState = this.isZoomingEnabled() ? defaultInteraction : $.ig.InteractionState.prototype.none;
					break;
				default:
					newState = defaultInteraction;
					break;
			}


		} else {
			if (this.view().currentModifiers() == this.dragModifier()) {
				newState = $.ig.InteractionState.prototype.dragZoom;

			} else if (this.view().currentModifiers() == this.panModifier()) {
				newState = $.ig.InteractionState.prototype.dragPan;

			} else {
				newState = $.ig.InteractionState.prototype.none;
			}


		}

		switch (newState) {
			case $.ig.InteractionState.prototype.dragZoom:
			case $.ig.InteractionState.prototype.dragPan:
				this.view().focusChart();
				this.view().plotAreaCaptureMouse();
				break;
		}

		this.state(newState);
		switch (this.state()) {
			case $.ig.InteractionState.prototype.dragZoom:
				this.crosshairNotify({__x: NaN, __y: NaN, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
				this.anchor(new $.ig.Rect(0, pt.__x, pt.__y, 0, 0));
				this.dragState(new $.ig.Rect(0, pt.__x, pt.__y, 0, 0));
				this.dragStartPoint(new $.ig.Rect(0, pt.__x, pt.__y, 0, 0));
				this.view().showDragPath();
				this.view().updateDragPath(this.anchor());
				this.previewNotify($.ig.Rect.prototype.empty());
				break;
			case $.ig.InteractionState.prototype.dragPan:
				this.anchor(new $.ig.Rect(0, pt.__x, pt.__y, 0, 0));
				this.dragStartPoint(new $.ig.Rect(0, pt.__x, pt.__y, 0, 0));
				this.startTiledZoomingIfNecessary();
				break;
		}

		this.windowRectAtStartOfWindowOperation(this.actualWindowRect());
	}

	, 
	startTiledZoomingIfNecessary: function () {
		if (this.actualUseTiledZooming() && !this.isTileZoomRunning()) {
			this.isTileZoomRunning(true);
			this.startTileZoom();
		}

	}

	, 
	endTiledZoomingIfRunning: function () {
		if (this.isTileZoomRunning()) {
			this.endTileZoom();
			this.isTileZoomRunning(false);
		}

	}

	, 
	clearTileZoomCacheDueToVisualsChange: function () {
		this.clearTileZoomCache();
	}

	, 
	clearTileZoomCache: function () {
		if (this.__tileManager == null) {
			return;
		}

		this.tileManager().clearTileCache();
	}

	, 
	tileManager: function () {

			return this.__tileManager;
	}
	, 
	__tileManager: null

	, 
	startTileZoom: function () {
		if (this.__tileManager == null) {
			this.__tileManager = new $.ig.TileZoomManager(this, true, this.actualZoomTileCacheSize());
			this.__tileManager.roundDown(!this.preferHigherResolutionTiles());
		}

		this.ignoreWindowChanges(true);
		this.prepareAxesForTiledZoom();
		this.__tileManager.start();
		this.view().cancelDeferredCacheClear();
		this.view().cancelEndToTiledZoom();
	}

	, 
	prepareAxesForTiledZoom: function () {
	}

	, 
	endTileZoom: function () {
		if (this.__tileManager == null) {
			return;
		}

		this.ignoreWindowChanges(false);
		this.view().onTileZoomEnding();
		this.__tileManager.end();
		this.refreshAllContentAfterTiledZoom();
		this.view().deferCacheClear();
	}

	, 
	deferredClearOfTileZoomCache: function () {
		this.clearTileZoomCache();
		this.releaseAxesFromTiledZoom();
	}

	, 
	releaseAxesFromTiledZoom: function () {
	}

	, 
	refreshAllContentAfterTiledZoom: function () {
		for (var i = 0; i < this.series().count(); i++) {
			this.series().__inner[i].renderSeries(false);
		}

		this.flushInternal(false, false);
	}

	, 
	_dragStartPoint: null,
	dragStartPoint: function (value) {
		if (arguments.length === 1) {
			this._dragStartPoint = value;
			return value;
		} else {
			return this._dragStartPoint;
		}
	}

	, 
	shouldAllowPan: function () {
		return this.state() == $.ig.InteractionState.prototype.dragPan;
	}

	, 
	shouldImmediatePan: function (isFinger) {
		return this.windowResponse() == $.ig.WindowResponse.prototype.immediate || isFinger || this.actualUseTiledZooming();
	}

	, 
	shouldAllowDragZoom: function () {
		return this.state() == $.ig.InteractionState.prototype.dragZoom;
	}

	, 
	onContactMoved: function (pt, isFinger) {
		if (this.anchor().isEmpty() && isFinger) {
			this.startWindowOperation(pt, isFinger);
		}

		var distance = $.ig.SeriesViewer.prototype.dRAG_DISTANCE_NEAR;
		if (isFinger) {
			distance = $.ig.SeriesViewer.prototype.dRAG_DISTANCE;
		}

		var farFromAnchor = false;
		var rect = new $.ig.Rect(2, {__x: this.anchor().x(), __y: this.anchor().y(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}, pt);
		var dist = new $.ig.Rect(0, 0, 0, 0, 0);
		if (!this.dragStartPoint().isEmpty()) {
			dist = new $.ig.Rect(2, {__x: this.dragStartPoint().x(), __y: this.dragStartPoint().y(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}, pt);
		}

		if (dist.width() > distance && dist.height() > distance) {
			farFromAnchor = true;
		}

		if (!this.__pinching) {
			if (farFromAnchor) {
				this.__ignoreContactUp = false;
			}

		}

		if (!this.__pinching && (this.__crossHairActivated || !isFinger)) {
			this.crosshairNotify(this.toWorld(pt));
		}

		if (this.shouldAllowDragZoom()) {
			if (farFromAnchor) {
				var rc = this.toWorld1(rect);
				this.previewNotify(rc);

			} else {
				this.previewNotify($.ig.Rect.prototype.empty());
			}

			this.view().updateDragPath(rect);
		}

		if (this.shouldAllowPan()) {
			var gridAreaRect = this.viewportRect();
			var left = this.actualWindowRect().left() + this.actualWindowRect().width() * (this.anchor().x() - pt.__x) / gridAreaRect.width();
			var top = this.actualWindowRect().top() + this.actualWindowRect().height() * (this.anchor().y() - pt.__y) / gridAreaRect.height();
			var rc1 = new $.ig.Rect(0, left, top, this.actualWindowRect().width(), this.actualWindowRect().height());
			if (this.shouldImmediatePan(isFinger)) {
				this.startTiledZoomingIfNecessary();
				this.previewNotify($.ig.Rect.prototype.empty());
				this.windowNotify(rc1);
				this.anchor(new $.ig.Rect(3, pt, new $.ig.Size(1, 0, 0)));
				this.dragState(new $.ig.Rect(3, pt, new $.ig.Size(1, 0, 0)));

			} else {
				this.previewNotify(rc1);
			}

		}

		this.dragState(new $.ig.Rect(3, pt, new $.ig.Size(1, 0, 0)));
		this.view().checkInteractionCompleted(pt);
	}
	, 
	__ignoreContactUp: false
	, 
	__suppressCrosshairChange: false

	, 
	onContactCompleted: function (pt, isFinger) {
		var distance = $.ig.SeriesViewer.prototype.dRAG_DISTANCE_NEAR;
		if (isFinger) {
			distance = $.ig.SeriesViewer.prototype.dRAG_DISTANCE;
		}

		if (!this.__ignoreContactUp) {
			var farFromAnchor = false;
			var rect = new $.ig.Rect(2, {__x: this.anchor().x(), __y: this.anchor().y(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}, pt);
			if (rect.width() > distance && rect.height() > distance) {
				farFromAnchor = true;
			}

			if (this.state() == $.ig.InteractionState.prototype.dragZoom) {
				this.view().hideDragPath();
				if (farFromAnchor) {
					this.windowNotify(this.toWorld1(rect));
				}

			}

			if (this.state() == $.ig.InteractionState.prototype.dragPan) {
				var gridAreaRect = this.viewportRect();
				var left = this.actualWindowRect().left() + this.actualWindowRect().width() * (this.anchor().x() - pt.__x) / gridAreaRect.width();
				var top = this.actualWindowRect().top() + this.actualWindowRect().height() * (this.anchor().y() - pt.__y) / gridAreaRect.height();
				this.windowNotify(new $.ig.Rect(0, left, top, this.actualWindowRect().width(), this.actualWindowRect().height()));
			}

		}

		var farDrag = false;
		var dragRect = new $.ig.Rect(2, {__x: this.dragStartPoint().x(), __y: this.dragStartPoint().y(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}, pt);
		if (dragRect.width() > distance || dragRect.height() > distance) {
			farDrag = true;
		}

		if (farDrag) {
			this.__suppressCrosshairChange = true;
		}

		this.state($.ig.InteractionState.prototype.none);
		this.previewNotify($.ig.Rect.prototype.empty());
		this.view().completeMouseCapture();
		this.__suppressCrosshairChange = false;
		this.view().hideHorizontalCrosshair();
		this.view().hideVerticalCrosshair();
		if (isFinger) {
			this.view().hideTooltip();
			this.view().hideHorizontalCrosshair();
			this.view().hideVerticalCrosshair();
			this.view().hideInfoBox();
		}

		this.endTiledZoomingIfRunning();
	}

	, 
	updateSyncSettings: function (sender, e) {
		if (e.propertyName() == $.ig.SyncSettings.prototype.syncChannelPropertyName) {
			$.ig.SyncManager.prototype.changeSyncChannel(this, e.oldValue(), e.newValue());
		}

	}

	, 
	updateSyncLink: function (oldLink, newLink) {
		if (oldLink != null) {
			oldLink.chartsInternal().remove(this);
			oldLink.propertyUpdated = $.ig.Delegate.prototype.remove(oldLink.propertyUpdated, this.propertyUpdated);
		}

		if (newLink != null) {
			newLink.chartsInternal().add(this);
			newLink.propertyUpdated = $.ig.Delegate.prototype.combine(newLink.propertyUpdated, this.propertyUpdated);
		}

		var en = this.series().getEnumerator();
		while (en.moveNext()) {
			var series = en.current();
			series.syncLink(this.actualSyncLink());
			series.seriesViewer(this);
		}

	}

	, 
	crosshairNotify: function (notificationPoint) {
		this.actualSyncLink().crosshairNotify(this, notificationPoint);
	}

	, 
	windowNotify: function (windowRect) {
		this.actualSyncLink().windowNotify(this, windowRect);
	}

	, 
	previewNotify: function (previewRect) {
		this.actualSyncLink().previewNotify(this, previewRect);
	}

	, 
	onZoomChanging: function (rc) {
		if (this.windowResponse() == $.ig.WindowResponse.prototype.immediate || this.actualUseTiledZooming()) {
			this.previewNotify($.ig.Rect.prototype.empty());
			this.windowNotify(rc);

		} else {
			this.previewNotify(rc);
		}

	}

	, 
	isSyncReady: function () {

			return this.actualSyncLink() != null;
	}

	, 
	synchronizedCharts: function () {
		var d__ = new $.ig.SeriesViewer___SynchronizedCharts__IteratorClass(-2);
		d__.__4__this = this;
		return d__;
	}

	, 
	toWorld: function (pt) {
		var gridAreaRect = this.viewportRect();
		var x = this.actualWindowRect().left() + this.actualWindowRect().width() * pt.__x / gridAreaRect.width();
		var y = this.actualWindowRect().top() + this.actualWindowRect().height() * pt.__y / gridAreaRect.height();
		return {__x: x, __y: y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
	}

	, 
	toWorld1: function (rect) {
		var gridAreaRect = this.viewportRect();
		var left = this.actualWindowRect().left() + this.actualWindowRect().width() * rect.left() / gridAreaRect.width();
		var top = this.actualWindowRect().top() + this.actualWindowRect().height() * rect.top() / gridAreaRect.height();
		var right = this.actualWindowRect().left() + this.actualWindowRect().width() * rect.right() / gridAreaRect.width();
		var bottom = this.actualWindowRect().top() + this.actualWindowRect().height() * rect.bottom() / gridAreaRect.height();
		return new $.ig.Rect(0, left, top, right - left, bottom - top);
	}
	, 
	windowRectChanged: null
	, 
	raiseWindowRectChanged: function (oldWindowRect, newWindowRect) {
		if (this.windowRectChanged != null && oldWindowRect != newWindowRect) {
			this.windowRectChanged(this, new $.ig.RectChangedEventArgs(oldWindowRect, newWindowRect));
		}

	}

	, 
	onWindowRectChanged: function (oldRect, newRect) {
		this.raiseWindowRectChanged(oldRect, newRect);
	}

	, 
	_ignoreWindowChanges: false,
	ignoreWindowChanges: function (value) {
		if (arguments.length === 1) {
			this._ignoreWindowChanges = value;
			return value;
		} else {
			return this._ignoreWindowChanges;
		}
	}

	, 
	rectChanged: function (oldRect, newRect) {
		if (oldRect.width() != newRect.width() || oldRect.height() != newRect.height() || oldRect.x() != newRect.x() || oldRect.y() != newRect.y()) {
			return true;
		}

		return false;
	}
	, 
	actualWindowRectChanged: null
	, 
	raiseActualWindowRectChanged: function (oldRect, newRect) {
		if (this.actualWindowRectChanged != null && this.rectChanged(oldRect, newRect)) {
			this.actualWindowRectChanged(this, new $.ig.RectChangedEventArgs(oldRect, newRect));
		}

	}

	, 
	resetZoom: function () {
		this.view().resetWindowRect();
	}
	, 
	gridAreaRectChanged: null
	, 
	raiseGridAreaRectChanged: function (oldGridAreaRect, newGridAreaRect) {
		if (this.gridAreaRectChanged != null && oldGridAreaRect != newGridAreaRect) {
			this.gridAreaRectChanged(this, new $.ig.RectChangedEventArgs(oldGridAreaRect, newGridAreaRect));
		}

	}

	, 
	isMap: function () {

			return false;
	}

	, 
	onPlotAreaSizeChanged: function (oldGridAreaRect, newGridAreaRect) {
		this.raiseGridAreaRectChanged(oldGridAreaRect, newGridAreaRect);
		if (this.isMap() && (oldGridAreaRect == null || oldGridAreaRect.isEmpty() || oldGridAreaRect.width() == 0 || oldGridAreaRect.height() == 0)) {
			this.windowNotify(this.windowRect());

		} else {
			this.invalidateActualWindowRect();
		}

	}

	, 
	windowResponse: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.windowResponseProperty, $.ig.WindowResponse.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.SeriesViewer.prototype.windowResponseProperty));
		}
	}

	, 
	_dontNotify: false,
	dontNotify: function (value) {
		if (arguments.length === 1) {
			this._dontNotify = value;
			return value;
		} else {
			return this._dontNotify;
		}
	}

	, 
	windowRectMinWidth: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.windowRectMinWidthProperty, value);
			return value;
		} else {

			return this.getValue($.ig.SeriesViewer.prototype.windowRectMinWidthProperty);
		}
	}

	, 
	_syncChannel: null,
	syncChannel: function (value) {
		if (arguments.length === 1) {
			this._syncChannel = value;
			return value;
		} else {
			return this._syncChannel;
		}
	}
	, 
	__actualSyncLink: null

	, 
	actualSyncLink: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__actualSyncLink;
			this.__actualSyncLink = value;
			this.raisePropertyChanged($.ig.SeriesViewer.prototype.actualSyncLinkPropertyName, oldValue, this.__actualSyncLink);
			return value;
		} else {

			return this.__actualSyncLink;
		}
	}

	, 
	invalidatePanels: function () {
		this.view().resize();
	}

	, 
	overviewPlusDetailPaneVisibility: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.overviewPlusDetailPaneVisibilityProperty, $.ig.Visibility.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.SeriesViewer.prototype.overviewPlusDetailPaneVisibilityProperty));
		}
	}

	, 
	overviewPlusDetailPane: function () {

			return this.view().getComponentsFromView().overviewPlusDetailPane();
	}

	, 
	crosshairVisibility: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.crosshairVisibilityProperty, $.ig.Visibility.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.SeriesViewer.prototype.crosshairVisibilityProperty));
		}
	}

	, 
	_ignoreCrosshairVisibilityChange: false,
	ignoreCrosshairVisibilityChange: function (value) {
		if (arguments.length === 1) {
			this._ignoreCrosshairVisibilityChange = value;
			return value;
		} else {
			return this._ignoreCrosshairVisibilityChange;
		}
	}

	, 
	_userSetCrosshairVisibility: false,
	userSetCrosshairVisibility: function (value) {
		if (arguments.length === 1) {
			this._userSetCrosshairVisibility = value;
			return value;
		} else {
			return this._userSetCrosshairVisibility;
		}
	}

	, 
	isDragCrosshairEnabled: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.isDragCrosshairEnabledProperty, value);
			return value;
		} else {

			return this.getValue($.ig.SeriesViewer.prototype.isDragCrosshairEnabledProperty);
		}
	}

	, 
	plotAreaBorderBrush: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.plotAreaBorderBrushProperty, value);
			return value;
		} else {

			return this.getValue($.ig.SeriesViewer.prototype.plotAreaBorderBrushProperty);
		}
	}

	, 
	actualPlotAreaBorderBrush: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.actualPlotAreaBorderBrushProperty, value);
			return value;
		} else {

			return this.getValue($.ig.SeriesViewer.prototype.actualPlotAreaBorderBrushProperty);
		}
	}

	, 
	plotAreaBackground: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.plotAreaBackgroundProperty, value);
			return value;
		} else {

			return this.getValue($.ig.SeriesViewer.prototype.plotAreaBackgroundProperty);
		}
	}

	, 
	plotAreaMinWidth: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.plotAreaMinWidthProperty, value);
			return value;
		} else {

			return this.getValue($.ig.SeriesViewer.prototype.plotAreaMinWidthProperty);
		}
	}

	, 
	plotAreaMinHeight: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.plotAreaMinHeightProperty, value);
			return value;
		} else {

			return this.getValue($.ig.SeriesViewer.prototype.plotAreaMinHeightProperty);
		}
	}

	, 
	canDisplayAnnotations: function () {
		return this.state() == $.ig.InteractionState.prototype.none && !this.__pinching && !this.__suppressCrosshairChange;
	}

	, 
	allCanDisplayAnnotations: function () {
		if (this.actualSyncLink() != null && this.actualSyncLink().charts().count() > 0) {
			var canDisplay = true;
			canDisplay = this.canDisplayAnnotations();
			if (!canDisplay) {
				return false;
			}

			for (var i = 0; i < this.actualSyncLink().charts().count(); i++) {
				if (!this.actualSyncLink().charts().item(i).canDisplayAnnotations()) {
					return false;
				}

			}

			return true;

		} else {
			return this.canDisplayAnnotations();
		}

	}

	, 
	renderCrosshairs: function () {
		var crosshairPoint = this.crosshairPoint();
		var annotationPoint = crosshairPoint;
		var annotationsVisible = this.allCanDisplayAnnotations();
		if (!annotationsVisible) {
			annotationPoint = {__x: NaN, __y: NaN, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		}

		for (var i = 0; i < this.series().count(); i++) {
			var series = this.series().__inner[i];
			if (series.isAnnotationLayer()) {
				(series).moveCursorPoint(annotationPoint);
			}

		}

		var visible = this.state() == $.ig.InteractionState.prototype.none && !this.isDefaultCrosshairDisabled() && (this.crosshairsVisible() || this.__crossHairActivated) && !this.__pinching && !this.__suppressCrosshairChange;
		var viewportRect = this.viewportRect();
		if (visible && !$.ig.util.isNaN(crosshairPoint.__x) && !viewportRect.isEmpty()) {
			var x = viewportRect.width() * (crosshairPoint.__x - this.actualWindowRect().left()) / this.actualWindowRect().width();
			this.view().updateVerticalCrosshair(viewportRect.left() + x, viewportRect.top(), viewportRect.left() + x, viewportRect.bottom());
			this.view().showVerticalCrosshair();
			this.view().updateInfoBoxXTranslation(x);

		} else {
			this.view().hideVerticalCrosshair();
		}

		if (visible && !$.ig.util.isNaN(crosshairPoint.__y) && !viewportRect.isEmpty()) {
			var y = viewportRect.height() * (crosshairPoint.__y - this.actualWindowRect().top()) / this.actualWindowRect().height();
			this.view().updateHorizontalCrosshair(viewportRect.left(), viewportRect.top() + y, viewportRect.right(), viewportRect.top() + y);
			this.view().showHorizontalCrosshair();

		} else {
			this.view().hideHorizontalCrosshair();
		}

	}
	, 
	__windowEventDepth: 0

	, 
	notifyCrosshairUpdate: function () {
	}

	, 
	updateWindowRect: function (desiredWindowWidth, desiredWindowHeight) {
		var minWidth = this.windowRectMinWidth();
		this.windowRect(new $.ig.Rect(0, this.actualWindowPositionHorizontal(), this.actualWindowPositionVertical(), $.ig.MathUtil.prototype.clamp(desiredWindowWidth, minWidth, 1), $.ig.MathUtil.prototype.clamp(desiredWindowHeight, minWidth, 1)));
	}

	, 
	getActualWindowScaleHorizontal: function () {
		return 1;
	}

	, 
	getActualWindowScaleVertical: function () {
		return 1;
	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		switch (propertyName) {
			case $.ig.SeriesViewer.prototype.titlePropertyName:
				this.view().onTitlesChanged();
				break;
			case $.ig.SeriesViewer.prototype.subtitlePropertyName:
				this.view().onTitlesChanged();
				break;
			case $.ig.SeriesViewer.prototype.titleHorizontalAlignmentPropertyName:
				this.view().onTitleAlignmentChanged(oldValue, newValue);
				this.view().onTitlesChanged();
				break;
			case $.ig.SeriesViewer.prototype.subtitleHorizontalAlignmentPropertyName:
				this.view().onSubtitleAlignmentChanged(oldValue, newValue);
				this.view().onTitlesChanged();
				break;
			case $.ig.SeriesViewer.prototype.titleTextStylePropertyName:
			case $.ig.SeriesViewer.prototype.titleTextColorPropertyName:
			case $.ig.SeriesViewer.prototype.subtitleTextStylePropertyName:
			case $.ig.SeriesViewer.prototype.subtitleTextColorPropertyName:
			case $.ig.SeriesViewer.prototype.titleTopMarginPropertyName:
			case $.ig.SeriesViewer.prototype.titleLeftMarginPropertyName:
			case $.ig.SeriesViewer.prototype.titleRightMarginPropertyName:
			case $.ig.SeriesViewer.prototype.titleBottomMarginPropertyName:
			case $.ig.SeriesViewer.prototype.subtitleTopMarginPropertyName:
			case $.ig.SeriesViewer.prototype.subtitleLeftMarginPropertyName:
			case $.ig.SeriesViewer.prototype.subtitleRightMarginPropertyName:
			case $.ig.SeriesViewer.prototype.subtitleBottomMarginPropertyName:
				this.view().onTitlesChanged();
				break;
			case $.ig.SeriesViewer.prototype.pixelScalingRatioPropertyName:
				if ($.ig.util.isNaN(this.pixelScalingRatio()) || this.pixelScalingRatio() <= 0) {
					this.actualPixelScalingRatio(1);

				} else {
					this.actualPixelScalingRatio(this.pixelScalingRatio());
				}

				break;
			case $.ig.SeriesViewer.prototype.actualPixelScalingRatioPropertyName:
				this.view().pixelScalingRatioChanged();
				break;
			case $.ig.SeriesViewer.prototype.isPagePanningAllowedPropertyName:
				this.view().isPagePanningAllowedChanged();
				break;
			case $.ig.SeriesViewer.prototype.actualSyncLinkPropertyName:
				this.updateSyncLink($.ig.util.cast($.ig.SyncLink.prototype.$type, oldValue), $.ig.util.cast($.ig.SyncLink.prototype.$type, newValue));
				break;
			case $.ig.SeriesViewer.prototype.crosshairVisibilityPropertyName:
				if (!this.ignoreCrosshairVisibilityChange()) {
					this.userSetCrosshairVisibility(true);
				}

				if (this.crosshairVisibility() != $.ig.Visibility.prototype.collapsed) {
					this.crosshairsVisible(true);

				} else {
					this.crosshairsVisible(this.mobileMode());
				}

				this.renderCrosshairs();
				break;
			case $.ig.SeriesViewer.prototype.crosshairPointPropertyName:
				this.renderCrosshairs();
				this.notifyCrosshairUpdate();
				break;
			case $.ig.SeriesViewer.prototype.windowRectPropertyName:
				if (this.actualSyncLink() != null) {
					this.__windowEventDepth++;
					this.windowNotify(newValue);
					this.__windowEventDepth--;
				}

				if (!this.windowRect().equals1(oldValue) && this.__windowEventDepth == 0) {
					this.onWindowRectChanged(oldValue, this.windowRect());
				}

				this.invalidateActualWindowRect();
				break;
			case $.ig.SeriesViewer.prototype.windowPositionHorizontalPropertyName:
				this.actualWindowPositionHorizontal(this.windowPositionHorizontal());
				break;
			case $.ig.SeriesViewer.prototype.windowPositionVerticalPropertyName:
				this.actualWindowPositionVertical(this.windowPositionVertical());
				break;
			case $.ig.SeriesViewer.prototype.actualWindowPositionVerticalPropertyName:
			case $.ig.SeriesViewer.prototype.actualWindowPositionHorizontalPropertyName:
				if (!this.suspendWindowRect()) {
					this.updateWindowRect(this.getActualWindowScaleHorizontal(), this.getActualWindowScaleVertical());
				}

				break;
			case $.ig.SeriesViewer.prototype.isSurfaceInteractionDisabledPropertyName:
				this.view().onIsInteractionDisabledChanged();
				break;
			case $.ig.SeriesViewer.prototype.highlightingTransitionDurationPropertyName:
				this.highlightingAnimator().intervalMilliseconds(this.highlightingTransitionDuration());
				break;
			case $.ig.SeriesViewer.prototype.overviewPlusDetailPaneVisibilityPropertyName:
				if (!this.mobileMode()) {
					this.__useOPD = this.overviewPlusDetailPaneVisibility() == $.ig.Visibility.prototype.visible;
					this.overviewPlusDetailPane().view().useMobileOpd(false);
					this.view().overviewPlusDetailPaneVisibilityChanged();
					this.view().updateOverviewPlusDetailRects();
					this.invalidatePanels();

				} else {
					this.__useOPD = this.overviewPlusDetailPaneVisibility() == $.ig.Visibility.prototype.visible;
					this.overviewPlusDetailPane().view().useMobileOpd(this.__useOPD);
					this.invalidatePanels();
				}

				break;
			case $.ig.SeriesViewer.prototype.actualWindowRectPropertyName:
				if (!newValue.equals(oldValue)) {
					this.actualWindowRectUpdated();
				}

				if ((newValue).width() == 1 && (newValue).height() == 1 && (oldValue).isEmpty()) {
					this.zoomLongAgo(true);
				}

				this.raiseActualWindowRectChanged(oldValue, newValue);
				break;
			case $.ig.SeriesViewer.prototype.plotAreaBackgroundPropertyName:
				this.view().onPlotAreaBackgroundChanged(newValue);
				break;
			case $.ig.SeriesViewer.prototype.useTiledZoomingPropertyName:
				this.actualUseTiledZooming(this.useTiledZooming());
				break;
			case $.ig.SeriesViewer.prototype.zoomTileCacheSizePropertyName:
				this.actualZoomTileCacheSize(this.zoomTileCacheSize());
				if (this.tileManager() != null) {
					this.tileManager().clearVisible();
					this.tileManager().clearTileCache();
					this.__tileManager = null;
				}

				break;
			case $.ig.SeriesViewer.prototype.preferHigherResolutionTilesPropertyName:
				if (this.tileManager() != null) {
					this.tileManager().roundDown(!this.preferHigherResolutionTiles());
				}

				break;
		}

	}

	, 
	updateOverviewPlusDetailPaneControlPanelVisibility: function () {
		if (this.overviewPlusDetailPane() == null) {
			return;
		}

		this.overviewPlusDetailPane().isZoomable(this.isZoomingEnabled());
	}
	, 
	__useOPD: false

	, 
	_suspendWindowRect: false,
	suspendWindowRect: function (value) {
		if (arguments.length === 1) {
			this._suspendWindowRect = value;
			return value;
		} else {
			return this._suspendWindowRect;
		}
	}

	, 
	defaultInteraction: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.defaultInteractionProperty, $.ig.InteractionState.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.SeriesViewer.prototype.defaultInteractionProperty));
		}
	}

	, 
	dragModifier: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.dragModifierProperty, $.ig.ModifierKeys.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.SeriesViewer.prototype.dragModifierProperty));
		}
	}

	, 
	panModifier: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.panModifierProperty, $.ig.ModifierKeys.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.SeriesViewer.prototype.panModifierProperty));
		}
	}
	, 
	_previewRect: null

	, 
	previewRect: function (value) {
		if (arguments.length === 1) {

			var oldPreviewRect = this._previewRect;
			this._previewRect = value;
			if (this._previewRect.isEmpty()) {
				this.view().hidePreviewPath();

			} else {
				this.view().updatePreviewPath(this.viewportRect(), this.toGridArea(this.previewRect()));
				this.view().showPreviewPath();
				this.raisePropertyChanged("PreviewRect", oldPreviewRect, this._previewRect);
			}

			return value;
		} else {

			return this._previewRect;
		}
	}

	, 
	_lastZoomTime: new Date(),
	lastZoomTime: function (value) {
		if (arguments.length === 1) {
			this._lastZoomTime = value;
			return value;
		} else {
			return this._lastZoomTime;
		}
	}

	, 
	_zoomLongAgo: false,
	zoomLongAgo: function (value) {
		if (arguments.length === 1) {
			this._zoomLongAgo = value;
			return value;
		} else {
			return this._zoomLongAgo;
		}
	}

	, 
	updateAcutalWindowProperties: function () {
		this.actualWindowPositionHorizontal(this.actualWindowRect().x());
		this.actualWindowPositionVertical(this.actualWindowRect().y());
	}

	, 
	actualWindowRectUpdated: function () {
		this.zoomLongAgo(false);
		this.lastZoomTime($.ig.Date.prototype.now());
		this.highlightingManager().clear();
		if (this.highlightingAnimator().animationActive()) {
			this.highlightingAnimator().stop();
		}

		var suspendWindowRectStored = this.suspendWindowRect();
		this.suspendWindowRect(true);
		this.updateAcutalWindowProperties();
		this.suspendWindowRect(suspendWindowRectStored);
		this.view().hideTooltip();
		this.view().updateZoombars(this.actualWindowRect());
	}

	, 
	windowPositionHorizontal: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.windowPositionHorizontalProperty, value);
			return value;
		} else {

			return this.getValue($.ig.SeriesViewer.prototype.windowPositionHorizontalProperty);
		}
	}

	, 
	windowPositionVertical: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.windowPositionVerticalProperty, value);
			return value;
		} else {

			return this.getValue($.ig.SeriesViewer.prototype.windowPositionVerticalProperty);
		}
	}

	, 
	toGridArea: function (rect) {
		if (this.viewportRect().isEmpty()) {
			return $.ig.Rect.prototype.empty();
		}

		var gridAreaRect = this.viewportRect();
		var left = gridAreaRect.left() + (gridAreaRect.width() * (rect.left() - this.actualWindowRect().left()) / this.actualWindowRect().width());
		var top = gridAreaRect.top() + (gridAreaRect.height() * (rect.top() - this.actualWindowRect().top()) / this.actualWindowRect().height());
		var right = gridAreaRect.left() + (gridAreaRect.width() * (rect.right() - this.actualWindowRect().left()) / this.actualWindowRect().width());
		var bottom = gridAreaRect.top() + (gridAreaRect.height() * (rect.bottom() - this.actualWindowRect().top()) / this.actualWindowRect().height());
		return new $.ig.Rect(0, left, top, right - left, bottom - top);
	}
	, 
	refreshCompleted: null
	, 
	raiseRefreshCompleted: function () {
		if (this.refreshCompleted != null) {
			this.refreshCompleted(this, new $.ig.EventArgs());
		}

	}

	, 
	createView: function () {}

	, 
	onViewCreated: function (view) {
		this.updateOverviewPlusDetailPaneControlPanelVisibility();
	}

	, 
	crosshairLineStyle: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.crosshairLineStyleProperty, value);
			return value;
		} else {

			return this.getValue($.ig.SeriesViewer.prototype.crosshairLineStyleProperty);
		}
	}

	, 
	previewPathStyle: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.previewPathStyleProperty, value);
			return value;
		} else {

			return this.getValue($.ig.SeriesViewer.prototype.previewPathStyleProperty);
		}
	}

	, 
	zoombarStyle: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.zoombarStyleProperty, value);
			return value;
		} else {

			return this.getValue($.ig.SeriesViewer.prototype.zoombarStyleProperty);
		}
	}

	, 
	circleMarkerTemplate: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.circleMarkerTemplateProperty, value);
			return value;
		} else {

			return this.getValue($.ig.SeriesViewer.prototype.circleMarkerTemplateProperty);
		}
	}

	, 
	triangleMarkerTemplate: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.triangleMarkerTemplateProperty, value);
			return value;
		} else {

			return this.getValue($.ig.SeriesViewer.prototype.triangleMarkerTemplateProperty);
		}
	}

	, 
	pyramidMarkerTemplate: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.pyramidMarkerTemplateProperty, value);
			return value;
		} else {

			return this.getValue($.ig.SeriesViewer.prototype.pyramidMarkerTemplateProperty);
		}
	}

	, 
	squareMarkerTemplate: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.squareMarkerTemplateProperty, value);
			return value;
		} else {

			return this.getValue($.ig.SeriesViewer.prototype.squareMarkerTemplateProperty);
		}
	}

	, 
	diamondMarkerTemplate: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.diamondMarkerTemplateProperty, value);
			return value;
		} else {

			return this.getValue($.ig.SeriesViewer.prototype.diamondMarkerTemplateProperty);
		}
	}

	, 
	pentagonMarkerTemplate: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.pentagonMarkerTemplateProperty, value);
			return value;
		} else {

			return this.getValue($.ig.SeriesViewer.prototype.pentagonMarkerTemplateProperty);
		}
	}

	, 
	hexagonMarkerTemplate: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.hexagonMarkerTemplateProperty, value);
			return value;
		} else {

			return this.getValue($.ig.SeriesViewer.prototype.hexagonMarkerTemplateProperty);
		}
	}

	, 
	tetragramMarkerTemplate: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.tetragramMarkerTemplateProperty, value);
			return value;
		} else {

			return this.getValue($.ig.SeriesViewer.prototype.tetragramMarkerTemplateProperty);
		}
	}

	, 
	pentagramMarkerTemplate: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.pentagramMarkerTemplateProperty, value);
			return value;
		} else {

			return this.getValue($.ig.SeriesViewer.prototype.pentagramMarkerTemplateProperty);
		}
	}

	, 
	hexagramMarkerTemplate: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.hexagramMarkerTemplateProperty, value);
			return value;
		} else {

			return this.getValue($.ig.SeriesViewer.prototype.hexagramMarkerTemplateProperty);
		}
	}

	, 
	title: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.titleProperty, value);
			return value;
		} else {

			return this.getValue($.ig.SeriesViewer.prototype.titleProperty);
		}
	}

	, 
	titleHorizontalAlignment: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.titleHorizontalAlignmentProperty, $.ig.HorizontalAlignment.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.SeriesViewer.prototype.titleHorizontalAlignmentProperty));
		}
	}

	, 
	subtitleHorizontalAlignment: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.subtitleHorizontalAlignmentProperty, $.ig.HorizontalAlignment.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.SeriesViewer.prototype.subtitleHorizontalAlignmentProperty));
		}
	}
	, 
	__titleTextStyle: null

	, 
	titleTextStyle: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__titleTextStyle;
			this.__titleTextStyle = value;
			this.raisePropertyChanged($.ig.SeriesViewer.prototype.titleTextStylePropertyName, oldValue, value);
			return value;
		} else {

			return this.__titleTextStyle;
		}
	}
	, 
	__subtitleTextStyle: null

	, 
	subtitleTextStyle: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__subtitleTextStyle;
			this.__subtitleTextStyle = value;
			this.raisePropertyChanged($.ig.SeriesViewer.prototype.subtitleTextStylePropertyName, oldValue, value);
			return value;
		} else {

			return this.__subtitleTextStyle;
		}
	}
	, 
	__titleTextColor: null

	, 
	titleTextColor: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__titleTextColor;
			this.__titleTextColor = value;
			this.raisePropertyChanged($.ig.SeriesViewer.prototype.titleTextColorPropertyName, oldValue, value);
			return value;
		} else {

			return this.__titleTextColor;
		}
	}
	, 
	__subtitleTextColor: null

	, 
	subtitleTextColor: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__subtitleTextColor;
			this.__subtitleTextColor = value;
			this.raisePropertyChanged($.ig.SeriesViewer.prototype.subtitleTextColorPropertyName, oldValue, value);
			return value;
		} else {

			return this.__subtitleTextColor;
		}
	}
	, 
	__titleTopMargin: 0

	, 
	titleTopMargin: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__titleTopMargin;
			this.__titleTopMargin = value;
			this.raisePropertyChanged($.ig.SeriesViewer.prototype.titleTopMarginPropertyName, oldValue, value);
			return value;
		} else {

			return this.__titleTopMargin;
		}
	}
	, 
	__titleLeftMargin: 0

	, 
	titleLeftMargin: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__titleLeftMargin;
			this.__titleLeftMargin = value;
			this.raisePropertyChanged($.ig.SeriesViewer.prototype.titleLeftMarginPropertyName, oldValue, value);
			return value;
		} else {

			return this.__titleLeftMargin;
		}
	}
	, 
	__titleRightMargin: 0

	, 
	titleRightMargin: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__titleRightMargin;
			this.__titleRightMargin = value;
			this.raisePropertyChanged($.ig.SeriesViewer.prototype.titleRightMarginPropertyName, oldValue, value);
			return value;
		} else {

			return this.__titleRightMargin;
		}
	}
	, 
	__titleBottomMargin: 0

	, 
	titleBottomMargin: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__titleBottomMargin;
			this.__titleBottomMargin = value;
			this.raisePropertyChanged($.ig.SeriesViewer.prototype.titleBottomMarginPropertyName, oldValue, value);
			return value;
		} else {

			return this.__titleBottomMargin;
		}
	}
	, 
	__subtitleTopMargin: 0

	, 
	subtitleTopMargin: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__subtitleTopMargin;
			this.__subtitleTopMargin = value;
			this.raisePropertyChanged($.ig.SeriesViewer.prototype.subtitleTopMarginPropertyName, oldValue, value);
			return value;
		} else {

			return this.__subtitleTopMargin;
		}
	}
	, 
	__subtitleLeftMargin: 0

	, 
	subtitleLeftMargin: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__subtitleLeftMargin;
			this.__subtitleLeftMargin = value;
			this.raisePropertyChanged($.ig.SeriesViewer.prototype.subtitleLeftMarginPropertyName, oldValue, value);
			return value;
		} else {

			return this.__subtitleLeftMargin;
		}
	}
	, 
	__subtitleRightMargin: 0

	, 
	subtitleRightMargin: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__subtitleRightMargin;
			this.__subtitleRightMargin = value;
			this.raisePropertyChanged($.ig.SeriesViewer.prototype.subtitleRightMarginPropertyName, oldValue, value);
			return value;
		} else {

			return this.__subtitleRightMargin;
		}
	}
	, 
	__subtitleBottomMargin: 0

	, 
	subtitleBottomMargin: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__subtitleBottomMargin;
			this.__subtitleBottomMargin = value;
			this.raisePropertyChanged($.ig.SeriesViewer.prototype.subtitleBottomMarginPropertyName, oldValue, value);
			return value;
		} else {

			return this.__subtitleBottomMargin;
		}
	}

	, 
	subtitle: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewer.prototype.subtitleProperty, value);
			return value;
		} else {

			return this.getValue($.ig.SeriesViewer.prototype.subtitleProperty);
		}
	}

	, 
	getDefaultHorizontalAxisTitleMargin: function () {
		return this.view().getDefaultHorizontalAxisTitleMargin();
	}

	, 
	getDefaultVerticalAxisTitleMargin: function () {
		return this.view().getDefaultVerticalAxisTitleMargin();
	}

	, 
	getDefaultHorizontalAxisTitlePosition: function (axis) {
		return this.view().getDefaultHorizontalAxisTitlePosition(axis);
	}

	, 
	getDefaultVerticalAxisTitlePosition: function (axis) {
		return this.view().getDefaultVerticalAxisTitlePosition(axis);
	}

	, 
	getFontBrush: function () {}

	, 
	getFont: function () {}

	, 
	getAxisLineBrush: function () {}

	, 
	_tooltipTemplate: null,
	tooltipTemplate: function (value) {
		if (arguments.length === 1) {
			this._tooltipTemplate = value;
			return value;
		} else {
			return this._tooltipTemplate;
		}
	}

	, 
	provideContainer: function (container) {
		this.view().onContainerProvided(container);
	}

	, 
	onContainerResized: function (width, height) {
		this.view().onContainerResized(width, height);
	}

	, 
	notifyContainerResized: function () {
		this.view().notifyContainerResized();
	}

	, 
	getContainerRect: function () {
		return this.view().getContainerRect();
	}

	, 
	ensureCorrectSize: function () {
		this.view().ensureCorrectSize();
	}

	, 
	getContainerOffsets: function () {
		return this.view().getContainerOffsets();
	}

	, 
	getDefaultVerticalAxisFont: function () {
		return this.view().getDefaultVerticalAxisFont();
	}

	, 
	getDefaultHorizontalAxisFont: function () {
		return this.view().getDefaultHorizontalAxisFont();
	}

	, 
	getDefaultHorizontalAxisColor: function () {
		return this.view().getDefaultHorizontalAxisColor();
	}

	, 
	getDefaultverticalAxisColor: function () {
		return this.view().getDefaultVerticalAxisColor();
	}

	, 
	attachSeries: function (s) {
		this.view().attachSeries(s);
	}

	, 
	removeSeries: function (s) {
		this.view().removeSeries(s);
	}

	, 
	_canvasRenderScheduler: null,
	canvasRenderScheduler: function (value) {
		if (arguments.length === 1) {
			this._canvasRenderScheduler = value;
			return value;
		} else {
			return this._canvasRenderScheduler;
		}
	}

	, 
	_thumbnailCanvasRenderScheduler: null,
	thumbnailCanvasRenderScheduler: function (value) {
		if (arguments.length === 1) {
			this._thumbnailCanvasRenderScheduler = value;
			return value;
		} else {
			return this._thumbnailCanvasRenderScheduler;
		}
	}

	, 
	_alternateViewRenderScheduler: null,
	alternateViewRenderScheduler: function (value) {
		if (arguments.length === 1) {
			this._alternateViewRenderScheduler = value;
			return value;
		} else {
			return this._alternateViewRenderScheduler;
		}
	}
	, 
	__mobileMode: false

	, 
	mobileMode: function (value) {
		if (arguments.length === 1) {

			var oldMode = this.__mobileMode;
			this.__mobileMode = value;
			if (oldMode != this.__mobileMode) {
				this.view().mobileModeChanged(this.__mobileMode);
			}

			return value;
		} else {

			return this.__mobileMode;
		}
	}

	, 
	_syncSettings: null,
	syncSettings: function (value) {
		if (arguments.length === 1) {
			this._syncSettings = value;
			return value;
		} else {
			return this._syncSettings;
		}
	}

	, 
	addTooltipToView: function (control) {
		this.view().addTooltipToView(control);
	}

	, 
	removeTooltipFromView: function (control) {
		this.view().removeTooltipFromView(control);
	}

	, 
	notifySetItem: function (source_, index, oldItem, newItem) {
		if (source_.dataView && source_.dataSource) { source_ = source_.dataView() };
		var itemsSource = this.actualSyncLink().peekItemsSource(source_);
		if (itemsSource == null) {
			return;
		}

		itemsSource.handleCollectionChanged(new $.ig.NotifyCollectionChangedEventArgs(2, $.ig.NotifyCollectionChangedAction.prototype.replace, newItem, oldItem, index));
	}

	, 
	notifyClearItems: function (source_) {
		if (source_.dataView && source_.dataSource) { source_ = source_.dataView() };
		var itemsSource = this.actualSyncLink().peekItemsSource(source_);
		if (itemsSource == null) {
			return;
		}

		itemsSource.handleCollectionChanged(new $.ig.NotifyCollectionChangedEventArgs(0, $.ig.NotifyCollectionChangedAction.prototype.reset));
	}

	, 
	notifyInsertItem: function (source_, index, newItem) {
		if (source_.dataView && source_.dataSource) { source_ = source_.dataView() };
		var itemsSource = this.actualSyncLink().peekItemsSource(source_);
		if (itemsSource == null) {
			return;
		}

		itemsSource.handleCollectionChanged(new $.ig.NotifyCollectionChangedEventArgs(1, $.ig.NotifyCollectionChangedAction.prototype.add, newItem, index));
	}

	, 
	notifyRemoveItem: function (source_, index, oldItem) {
		if (source_.dataView && source_.dataSource) { source_ = source_.dataView() };
		var itemsSource = this.actualSyncLink().peekItemsSource(source_);
		if (itemsSource == null) {
			return;
		}

		itemsSource.handleCollectionChanged(new $.ig.NotifyCollectionChangedEventArgs(1, $.ig.NotifyCollectionChangedAction.prototype.remove, oldItem, index));
	}
	, 
	__widgetLevelSource: null
	, 
	__specificSources: null

	, 
	_manageDataSources: false,
	manageDataSources: function (value) {
		if (arguments.length === 1) {
			this._manageDataSources = value;
			return value;
		} else {
			return this._manageDataSources;
		}
	}

	, 
	destroy: function () {
		var toDestroy = new $.ig.List$1($.ig.Series.prototype.$type, 0);
		for (var i = 0; i < this.series().count(); i++) {
			toDestroy.add(this.series().__inner[i]);
		}

		for (var i1 = 0; i1 < toDestroy.count(); i1++) {
			if (toDestroy.__inner[i1].view() != null) {
				toDestroy.__inner[i1].view().destroy();
			}

			this.series().remove(toDestroy.__inner[i1]);
			this.removeSpecificDataSource(toDestroy.__inner[i1].name(), true);
			toDestroy.__inner[i1].itemsSource(null);
			toDestroy.__inner[i1].provideContext(null, null);
		}

		this.destroyOverride();
		this.removeWidgetLevelDataSource();
		this.view().onContainerProvided(null);
	}

	, 
	destroyOverride: function () {
	}

	, 
	setWidgetLevelDataSource: function (source_) {
		if (source_.dataView && source_.dataSource) { source_ = source_.dataView() };
		this.__widgetLevelSource = source_;
		this.updateDataSources();
	}

	, 
	removeWidgetLevelDataSource: function () {
		this.__widgetLevelSource = null;
		this.updateDataSources();
	}

	, 
	setSpecificDataSource: function (targetName, source_) {
		if (source_.dataView && source_.dataSource) { source_ = source_.dataView() };
		if (!this.__specificSources.containsKey(targetName)) {
			this.__specificSources.add(targetName, source_);

		} else {
			this.__specificSources.item(targetName, source_);
		}

		this.updateDataSources();
	}

	, 
	removeSpecificDataSource: function (targetName, dontUpdate) {
		if (this.__specificSources.containsKey(targetName)) {
			this.__specificSources.remove(targetName);
		}

		if (!dontUpdate) {
			this.updateDataSources();
		}

	}

	, 
	setDataSourceForSeries: function (target, source) {
		if (target.itemsSource() != source) {
			target.itemsSource(source);
		}

	}

	, 
	updateDataSourceFor: function (target) {
		if (!this.manageDataSources()) {
			return;
		}

		if ($.ig.util.cast($.ig.Series.prototype.$type, target) !== null) {
			var series = target;
			if (this.__specificSources.containsKey(series.name())) {
				var specific = this.__specificSources.item(series.name());
				this.setDataSourceForSeries(series, specific);

			} else {
				this.setDataSourceForSeries(series, this.__widgetLevelSource);
			}

		}

		if ($.ig.util.cast($.ig.CategoryAxisBase.prototype.$type, target) !== null) {
			var cat = target;
			if (this.__specificSources.containsKey(cat.name())) {
				var specific1 = this.__specificSources.item(cat.name());
				if (cat.itemsSource() != specific1) {
					cat.itemsSource(specific1);
				}


			} else {
				if (cat.itemsSource() != this.__widgetLevelSource) {
					cat.itemsSource(this.__widgetLevelSource);
				}

			}

		}

	}

	, 
	updateDataSources: function () {
		if (!this.manageDataSources()) {
			return;
		}

		var en = this.series().getEnumerator();
		while (en.moveNext()) {
			var series = en.current();
			this.updateDataSourceFor(series);
		}

	}
	, 
	__topMargin: 0

	, 
	topMargin: function (value) {
		if (arguments.length === 1) {

			this.__topMargin = value;
			this.invalidatePanels();
			return value;
		} else {

			return this.__topMargin;
		}
	}
	, 
	__leftMargin: 0

	, 
	leftMargin: function (value) {
		if (arguments.length === 1) {

			this.__leftMargin = value;
			this.invalidatePanels();
			return value;
		} else {

			return this.__leftMargin;
		}
	}
	, 
	__rightMargin: 0

	, 
	rightMargin: function (value) {
		if (arguments.length === 1) {

			this.__rightMargin = value;
			this.invalidatePanels();
			return value;
		} else {

			return this.__rightMargin;
		}
	}
	, 
	__bottomMargin: 0

	, 
	bottomMargin: function (value) {
		if (arguments.length === 1) {

			this.__bottomMargin = value;
			this.invalidatePanels();
			return value;
		} else {

			return this.__bottomMargin;
		}
	}
	, 
	__autoMarginWidth: 0

	, 
	autoMarginWidth: function (value) {
		if (arguments.length === 1) {

			this.__autoMarginWidth = value;
			this.invalidatePanels();
			return value;
		} else {

			return this.__autoMarginWidth;
		}
	}
	, 
	__autoMarginHeight: 0

	, 
	autoMarginHeight: function (value) {
		if (arguments.length === 1) {

			this.__autoMarginHeight = value;
			this.invalidatePanels();
			return value;
		} else {

			return this.__autoMarginHeight;
		}
	}

	, 
	shouldAddAutoMargins: function () {
		return false;
	}
	, 
	__pixelScalingRatio: 0

	, 
	pixelScalingRatio: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__pixelScalingRatio;
			this.__pixelScalingRatio = value;
			this.raisePropertyChanged($.ig.SeriesViewer.prototype.pixelScalingRatioPropertyName, oldValue, this.__pixelScalingRatio);
			return value;
		} else {

			return this.__pixelScalingRatio;
		}
	}
	, 
	__actualPixelScalingRatio: 0

	, 
	actualPixelScalingRatio: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__actualPixelScalingRatio;
			this.__actualPixelScalingRatio = value;
			this.raisePropertyChanged($.ig.SeriesViewer.prototype.actualPixelScalingRatioPropertyName, oldValue, this.__actualPixelScalingRatio);
			return value;
		} else {

			return this.__actualPixelScalingRatio;
		}
	}

	, 
	getCoercionMethod: function (memberPath, coercionMethods) {
		var info = new $.ig.CoercionInfo();
		info.memberPath(memberPath);
		info.coercionMethod(null);
		var parsed = $.ig.SeriesViewer.prototype.parseMemberPath(memberPath);
		if (parsed.item2() == null) {
			return info;
		}

		if (coercionMethods != null) {
			var methods_ = coercionMethods;
			var key_ = parsed.item2();
			var val_ = null;
			if (typeof methods_[key_] != 'undefined') { val_ = methods_[key_]; };
			info.memberPath(parsed.item1());
			info.coercionMethod(val_);

		} else if (parsed.item2() == "defaultDateParse") {
			var func = $.ig.util.defaultDVDateParse;
			info.memberPath(parsed.item1());
			info.coercionMethod(func);
		}


		return info;
	}

	, 
	parseMemberPath: function (memberPath) {
		var vals = memberPath.split('!');
		if (vals.length == 2) {
			return new $.ig.Tuple$2(String, String, vals[0], vals[1]);

		} else {
			return new $.ig.Tuple$2(String, String, memberPath, null);
		}

	}

	, 
	overviewPlusDetailPaneBackgroundImageUri: function (value) {
		if (arguments.length === 1) {

			this.overviewPlusDetailPane().view().backgroundImageUri(value);
			return value;
		} else {

			return this.overviewPlusDetailPane().view().backgroundImageUri();
		}
	}
	, 
	__actualWindowRect: null

	, 
	actualWindowRect: function (value) {
		if (arguments.length === 1) {

			var changed = this.__actualWindowRect != value;
			if (changed) {
				var oldValue = this.__actualWindowRect;
				this.__actualWindowRect = value;
				this.raisePropertyChanged($.ig.SeriesViewer.prototype.actualWindowRectPropertyName, oldValue, value);
			}

			return value;
		} else {

			return this.__actualWindowRect;
		}
	}

	, 
	invalidateActualWindowRect: function () {
		this.actualWindowRect(this.calculateActualWindowRect());
	}

	, 
	calculateActualWindowRect: function () {
		return new $.ig.Rect(0, Math.min(1, Math.max(0, this.windowRect().left())), Math.min(1, Math.max(0, this.windowRect().top())), Math.min(1, Math.max(0, this.windowRect().width())), Math.min(1, Math.max(0, this.windowRect().height())));
	}
	, 
	__actualWindowPositionHorizontal: 0

	, 
	actualWindowPositionHorizontal: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__actualWindowPositionHorizontal;
			this.__actualWindowPositionHorizontal = value;
			this.raisePropertyChanged($.ig.SeriesViewer.prototype.actualWindowPositionHorizontalPropertyName, oldValue, this.__actualWindowPositionHorizontal);
			return value;
		} else {

			return this.__actualWindowPositionHorizontal;
		}
	}
	, 
	__actualWindowPositionVertical: 0

	, 
	actualWindowPositionVertical: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__actualWindowPositionVertical;
			this.__actualWindowPositionVertical = value;
			this.raisePropertyChanged($.ig.SeriesViewer.prototype.actualWindowPositionVerticalPropertyName, oldValue, this.__actualWindowPositionVertical);
			return value;
		} else {

			return this.__actualWindowPositionVertical;
		}
	}

	, 
	notifyThumbnailDataChanged: function () {
		if (this.__useOPD) {
			(this.overviewPlusDetailPane().surfaceViewer()).isDirty(true);
			this.overviewPlusDetailPane().refresh(false);
		}

		this.clearTileZoomCacheDueToVisualsChange();
	}

	, 
	notifyThumbnailAppearanceChanged: function () {
		if (this.__useOPD) {
			(this.overviewPlusDetailPane().surfaceViewer()).isDirty(true);
			this.overviewPlusDetailPane().refresh(false);
		}

		this.clearTileZoomCacheDueToVisualsChange();
	}

	, 
	flush: function () {
		this.flushInternal(true, true);
	}

	, 
	flushInternal: function (forceLayout, forceOverlay) {
		this.chartContentManager().force();
		if (forceLayout) {
			this.view().ensurePanelsArranged();
			this.chartContentManager().force();
		}

		this.canvasRenderScheduler().flush();
		if (forceOverlay) {
			this.view().overlayScheduler().flush();
		}

		this.zoomLongAgo(true);
	}

	, 
	useFixedAspectZoom: function () {
		return false;
	}
	, 
	__background: null
	, 
	__backgroundContentInfo: null

	, 
	registerBackgroundContent: function (content, refresh) {
		if (this.__background != null) {
			this.unRegisterBackgroundContent(this.__background);
			this.__background = null;
			this.__backgroundContentInfo = null;
		}

		this.__background = content;
		this.__backgroundContentInfo = this.chartContentManager().subscribe($.ig.ChartContentType.prototype.background, content, refresh);
	}

	, 
	unRegisterBackgroundContent: function (content) {
		this.chartContentManager().unsubscribe($.ig.ChartContentType.prototype.background, content);
		this.__background = null;
		this.__backgroundContentInfo = null;
	}

	, 
	deferBackgroundRefresh: function () {
		this.chartContentManager().refresh($.ig.ChartContentType.prototype.background, this.__background, this.__backgroundContentInfo, false);
	}

	, 
	_isDefaultCrosshairDisabled: false,
	isDefaultCrosshairDisabled: function (value) {
		if (arguments.length === 1) {
			this._isDefaultCrosshairDisabled = value;
			return value;
		} else {
			return this._isDefaultCrosshairDisabled;
		}
	}

	, 
	_isDefaultTooltipDisabled: false,
	isDefaultTooltipDisabled: function (value) {
		if (arguments.length === 1) {
			this._isDefaultTooltipDisabled = value;
			return value;
		} else {
			return this._isDefaultTooltipDisabled;
		}
	}

	, 
	_isAnnotationLayerPresent: false,
	isAnnotationLayerPresent: function (value) {
		if (arguments.length === 1) {
			this._isAnnotationLayerPresent = value;
			return value;
		} else {
			return this._isAnnotationLayerPresent;
		}
	}

	, 
	onHoverBehaviorOverridesChanged: function () {
		var crosshairDisabled = false;
		var tooltipDisabled = false;
		var containsAnnotationLayer = false;
		for (var i = 0; i < this.series().count(); i++) {
			var series = this.series().__inner[i];
			if (series.isDefaultCrosshairBehaviorDisabled()) {
				crosshairDisabled = true;
			}

			if (series.isDefaultTooltipBehaviorDisabled()) {
				tooltipDisabled = true;
			}

			if (series.isAnnotationLayer()) {
				containsAnnotationLayer = true;
			}

		}

		this.isDefaultCrosshairDisabled(crosshairDisabled);
		this.isDefaultTooltipDisabled(tooltipDisabled);
		this.isAnnotationLayerPresent(containsAnnotationLayer);
	}

	, 
	exportTitleData: function (visualData) {
		this.view().exportTitleData(visualData);
	}
	, 
	__isThumbnailRequired: false

	, 
	isThumbnailRequired: function () {

			return this.__useOPD;
	}

	, 
	beforeContentRefresh: function () {
		this.view().beforeContentRefresh();
	}

	, 
	justZoomed: function () {
		return this.view().justZoomed();
	}
	, 
	__uniqueIndex: 0

	, 
	getNextUniqueIndex: function () {
		var toUse = this.__uniqueIndex;
		this.__uniqueIndex++;
		return toUse;
	}
	, 
	$type: new $.ig.Type('SeriesViewer', $.ig.Control.prototype.$type, [$.ig.INotifyPropertyChanged.prototype.$type])
}, true);

$.ig.util.defType('CoercionInfo', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	_memberPath: null,
	memberPath: function (value) {
		if (arguments.length === 1) {
			this._memberPath = value;
			return value;
		} else {
			return this._memberPath;
		}
	}

	, 
	_coercionMethod: null,
	coercionMethod: function (value) {
		if (arguments.length === 1) {
			this._coercionMethod = value;
			return value;
		} else {
			return this._coercionMethod;
		}
	}
	, 
	$type: new $.ig.Type('CoercionInfo', $.ig.Object.prototype.$type)
}, true);


$.ig.util.defType('SeriesViewerView', 'Object', {
	init: function (model) {


		this.__componentsFromView = new $.ig.SeriesViewerComponentsFromView();
		this.__currentPlotArea = $.ig.Rect.prototype.empty();
		this.__sizeChanged = false;
		this.__titlesDirty = true;
		this.__fromEmpty = false;
		this.__subTitleHeight = NaN;
		this.__renderedRect = $.ig.Rect.prototype.empty();
		this.__gradientsEnabled = false;
		this.__seriesMouseDown = false;
		this.__isDirty = false;
		this.__infoBoxVisible = false;
		this.__titleText = null;
		this.__subTitleText = null;
		this.__hasUserTitleAlignment = false;
		this.__hasUserSubtitleAlignment = false;
		this.__panelsDirty = true;
		this._visibleTiles = null;
		this.__plotContentShown = true;

		var $self = this;
		$.ig.Object.prototype.init.call(this);
			this.containerWidth(0);
			this.containerHeight(0);
			this.model(model);
			this.model().crosshairPoint({__x: NaN, __y: NaN, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			this.model().windowResponse($.ig.WindowResponse.prototype.immediate);
			this.viewManager(new $.ig.SeriesViewerViewManager(this));
			this.horizontalCrosshairLine((function () { var $ret = new $.ig.Line();
			$ret.visibility($.ig.Visibility.prototype.collapsed); return $ret;}()));
			this.verticalCrosshairLine((function () { var $ret = new $.ig.Line();
			$ret.visibility($.ig.Visibility.prototype.collapsed); return $ret;}()));
	}

	, 
	_model: null,
	model: function (value) {
		if (arguments.length === 1) {
			this._model = value;
			return value;
		} else {
			return this._model;
		}
	}

	, 
	onInit: function () {
		this.model().ignoreCrosshairVisibilityChange(true);
		this.model().crosshairVisibility($.ig.Visibility.prototype.collapsed);
		this.model().ignoreCrosshairVisibilityChange(false);
		var model_ = this.model();
		var isTouch_ = typeof Modernizr !== 'undefined' && Modernizr.touch || (typeof $.mobile !== 'undefined' && $.mobile !== null && $.support.touch);
		model_.mobileMode(isTouch_);
		this.previewPath(new $.ig.Path());
		this.dragPathRect(new $.ig.Rectangle());
		this.dragPathRect().__visibility = $.ig.Visibility.prototype.collapsed;
		this.setDefaultMarkerTemplates();
		this.attachedSeries(new $.ig.SeriesCollection());
		this.attachedAxes(new $.ig.AxisCollection());
		this.overviewPlusDetailPane(new $.ig.XamOverviewPlusDetailPane());
		this.updateOverviewPlusDetailRects();
		this.overviewPlusDetailPane().world(new $.ig.Rect(0, 0, 0, 1, 1));
		this.overviewPlusDetailPane().window(this.model().windowRect());
		this.overviewPlusDetailPane().surfaceViewer(new $.ig.SeriesViewerSurfaceViewer(this.model(), this));
		this.model().windowRectChanged = $.ig.Delegate.prototype.combine(this.model().windowRectChanged, this.model_WindowRectChanged.runOn(this));
		this.model().gridAreaRectChanged = $.ig.Delegate.prototype.combine(this.model().gridAreaRectChanged, this.model_GridAreaRectChanged.runOn(this));
		this.overviewPlusDetailViewportHost(new $.ig.OverviewPlusDetailViewportHost(this));
		this.overlayScheduler(new $.ig.CanvasRenderScheduler());
		this.overlayScheduler().register(this);
		this.overlayScheduler().dependsOn().add(this.model().thumbnailCanvasRenderScheduler());
		if (this.model().overviewPlusDetailPane() != null) {
			this.model().overviewPlusDetailPane().view().scheduler(this.overlayScheduler());
			this.overviewPlusDetailPane().windowChanging = $.ig.Delegate.prototype.combine(this.overviewPlusDetailPane().windowChanging, this.overviewPlusDetailPane_WindowChanging.runOn(this));
			this.overviewPlusDetailPane().windowChanged = $.ig.Delegate.prototype.combine(this.overviewPlusDetailPane().windowChanged, this.overviewPlusDetailPane_WindowChanged.runOn(this));
		}

		this.overviewPlusDetailPaneVisibilityChanged();
	}

	, 
	_overlayScheduler: null,
	overlayScheduler: function (value) {
		if (arguments.length === 1) {
			this._overlayScheduler = value;
			return value;
		} else {
			return this._overlayScheduler;
		}
	}

	, 
	_overviewPlusDetailPane: null,
	overviewPlusDetailPane: function (value) {
		if (arguments.length === 1) {
			this._overviewPlusDetailPane = value;
			return value;
		} else {
			return this._overviewPlusDetailPane;
		}
	}

	, 
	overviewPlusDetailPane_WindowChanging: function (sender, e) {
		var newWindowRect = $.ig.SeriesViewerSurfaceViewer.prototype.changeRect(e.oldValue(), e.newValue(), this.model().isZoomingHorizontallyEnabled(), this.model().isZoomingVerticallyEnabled(), this.overviewPlusDetailPane().world());
		if (newWindowRect.isEmpty()) {
			this.overviewPlusDetailPane().window(e.oldValue());

		} else if (!newWindowRect.equals1(e.newValue())) {
			this.overviewPlusDetailPane().window(newWindowRect);
		}


		if (this.model().windowResponse() == $.ig.WindowResponse.prototype.immediate) {
			var aspect = this.model().viewportRect().width() / this.model().viewportRect().height();
			newWindowRect = new $.ig.Rect(0, newWindowRect.left() / aspect, newWindowRect.top(), newWindowRect.width() / aspect, newWindowRect.height());
			this.model().windowRect(newWindowRect);
		}

	}

	, 
	overviewPlusDetailPane_WindowChanged: function (sender, e) {
		var newWindowRect = $.ig.SeriesViewerSurfaceViewer.prototype.changeRect(e.oldValue(), e.newValue(), this.model().isZoomingHorizontallyEnabled(), this.model().isZoomingVerticallyEnabled(), this.overviewPlusDetailPane().world());
		if (newWindowRect.isEmpty()) {
			newWindowRect = e.oldValue();

		} else if (!newWindowRect.equals1(e.newValue())) {
			this.overviewPlusDetailPane().window(newWindowRect);
		}


		var aspect = this.model().viewportRect().width() / this.model().viewportRect().height();
		newWindowRect = new $.ig.Rect(0, newWindowRect.left() / aspect, newWindowRect.top(), newWindowRect.width() / aspect, newWindowRect.height());
		this.model().windowRect(newWindowRect);
	}

	, 
	updateOverviewPlusDetailRects: function () {
		if (this.model().overviewPlusDetailPaneVisibility() != $.ig.Visibility.prototype.visible) {
			return;
		}

		var aspect = 1;
		if (this.model().viewportRect().isEmpty() == false) {
			aspect = this.model().viewportRect().width() / this.model().viewportRect().height();
		}

		var oldRect = this.overviewPlusDetailPane().world();
		var newRect = new $.ig.Rect(0, 0, 0, aspect, 1);
		this.overviewPlusDetailPane().world(newRect);
		if (oldRect.width() != newRect.width() || oldRect.height() != newRect.height() || oldRect.x() != newRect.x() || oldRect.y() != newRect.y()) {
			(this.overviewPlusDetailPane().surfaceViewer()).isDirty(true);
		}

		this.overviewPlusDetailPane().window(new $.ig.Rect(0, this.model().windowRect().left() * aspect, this.model().windowRect().top(), this.model().windowRect().width() * aspect, this.model().windowRect().height()));
	}

	, 
	model_WindowRectChanged: function (sender, e) {
		this.updateOverviewPlusDetailRects();
	}

	, 
	model_GridAreaRectChanged: function (sender, e) {
		this.updateOverviewPlusDetailRects();
	}

	, 
	_overviewPlusDetailViewportHost: null,
	overviewPlusDetailViewportHost: function (value) {
		if (arguments.length === 1) {
			this._overviewPlusDetailViewportHost = value;
			return value;
		} else {
			return this._overviewPlusDetailViewportHost;
		}
	}

	, 
	getThumbnail: function (width, height, surface) {
		var first = true;
		var en = this.model().series().getEnumerator();
		while (en.moveNext()) {
			var s = en.current();
			if (first && s.thumbnailDirty()) {
				first = false;
				surface.surface().clearRectangle(0, 0, width, height);
			}

			s.renderThumbnail(new $.ig.Rect(0, 0, 0, width, height), surface);
		}

	}

	, 
	setDefaultCursor: function () {
		this.viewManager().setDefaultCursor();
	}

	, 
	goToIdleState: function () {
	}

	, 
	setHandCursor: function () {
		this.viewManager().setHandCursor();
	}

	, 
	hideTooltip: function () {
		for (var i = 0; i < this.model().series().count(); i++) {
			this.model().series().__inner[i].view().hideTooltip();
		}

	}

	, 
	goToDraggingVisualState: function () {
	}

	, 
	goToPanningVisualState: function () {
	}

	, 
	removeSeries: function (series) {
		var index = this.attachedSeries().indexOf(series);
		if (index >= 0) {
			this.attachedSeries().removeAt(index);
		}

		if ($.ig.util.cast($.ig.StackedSeriesBase.prototype.$type, series) !== null) {
			var en = (series).stackedSeriesManager().seriesVisual().getEnumerator();
			while (en.moveNext()) {
				var sub = en.current();
				index = this.attachedSeries().indexOf(sub);
				if (index >= 0) {
					this.attachedSeries().removeAt(index);
				}

			}

		}

		series.provideContext(null, null);
		this.onSeriesRemoved();
	}

	, 
	onSeriesRemoved: function () {
		if (this.attachedSeries().count() == 0) {
			if (this.mainContext() != null && this.model().viewportRect() != null && !this.model().viewportRect().isEmpty()) {
				this.mainContext().clearRectangle(this.model().viewportRect().left(), this.model().viewportRect().top(), this.model().viewportRect().width(), this.model().viewportRect().height());
			}

		}

		this.model().canvasRenderScheduler().schedule();
	}

	, 
	seriesAttached: function (series) {
		series.onViewportChanged(series.view().viewport(), this.__currentPlotArea);
		return this.attachedSeries().contains(series);
	}

	, 
	_attachedSeries: null,
	attachedSeries: function (value) {
		if (arguments.length === 1) {
			this._attachedSeries = value;
			return value;
		} else {
			return this._attachedSeries;
		}
	}

	, 
	_attachedAxes: null,
	attachedAxes: function (value) {
		if (arguments.length === 1) {
			this._attachedAxes = value;
			return value;
		} else {
			return this._attachedAxes;
		}
	}

	, 
	attachSeries: function (series) {
		if (!this.attachedSeries().contains(series)) {
			this.attachedSeries().add(series);
			if ($.ig.util.cast($.ig.StackedSeriesBase.prototype.$type, series) !== null) {
				var en = (series).stackedSeriesManager().seriesVisual().getEnumerator();
				while (en.moveNext()) {
					var sub = en.current();
					this.attachedSeries().add(sub);
				}

			}

		}

		series.provideContext(this.mainContext(), this.hitContext());
		this.model().invalidatePanels();
	}

	, 
	createLayout: function () {
	}

	, 
	cancelMouseInteractions: function () {
		this.hideDragPath();
		this.hideTooltip();
	}

	, 
	hideDragPath: function () {
		this.dragPathRect().__visibility = $.ig.Visibility.prototype.collapsed;
		this.makeDirty();
	}

	, 
	focusChart: function () {
	}

	, 
	plotAreaCaptureMouse: function () {
	}

	, 
	_dragPathRect: null,
	dragPathRect: function (value) {
		if (arguments.length === 1) {
			this._dragPathRect = value;
			return value;
		} else {
			return this._dragPathRect;
		}
	}

	, 
	_previewPath: null,
	previewPath: function (value) {
		if (arguments.length === 1) {
			this._previewPath = value;
			return value;
		} else {
			return this._previewPath;
		}
	}

	, 
	showDragPath: function () {
		this.dragPathRect().__visibility = $.ig.Visibility.prototype.visible;
		this.makeDirty();
	}

	, 
	updateDragPath: function (rect) {
		this.dragPathRect().canvasTop(rect.top() + this.model().viewportRect().top());
		this.dragPathRect().canvasLeft(rect.left() + this.model().viewportRect().left());
		this.dragPathRect().width(rect.width());
		this.dragPathRect().height(rect.height());
		this.dragPathRect().__stroke = this.viewManager().getBlackBrush();
		this.dragPathRect().__fill = null;
		this.dragPathRect().strokeThickness(0.5);
		this.makeDirty();
	}

	, 
	completeMouseCapture: function () {
	}

	, 
	onTemplateProvided: function () {
	}

	, 
	updateVerticalCrosshair: function (x1, y1, x2, y2) {
		this.verticalCrosshairLine().x1(x1);
		this.verticalCrosshairLine().y1(y1);
		this.verticalCrosshairLine().x2(x2);
		this.verticalCrosshairLine().y2(y2);
		this.makeDirty();
	}

	, 
	_verticalCrosshairLine: null,
	verticalCrosshairLine: function (value) {
		if (arguments.length === 1) {
			this._verticalCrosshairLine = value;
			return value;
		} else {
			return this._verticalCrosshairLine;
		}
	}

	, 
	_horizontalCrosshairLine: null,
	horizontalCrosshairLine: function (value) {
		if (arguments.length === 1) {
			this._horizontalCrosshairLine = value;
			return value;
		} else {
			return this._horizontalCrosshairLine;
		}
	}

	, 
	showVerticalCrosshair: function () {
		this.verticalCrosshairLine().__visibility = $.ig.Visibility.prototype.visible;
		this.makeDirty();
	}

	, 
	hideVerticalCrosshair: function () {
		if (this.verticalCrosshairLine().__visibility == $.ig.Visibility.prototype.visible) {
			this.verticalCrosshairLine().__visibility = $.ig.Visibility.prototype.collapsed;
			this.makeDirty();
		}

	}

	, 
	updateHorizontalCrosshair: function (x1, y1, x2, y2) {
		this.horizontalCrosshairLine().x1(x1);
		this.horizontalCrosshairLine().y1(y1);
		this.horizontalCrosshairLine().x2(x2);
		this.horizontalCrosshairLine().y2(y2);
		this.makeDirty();
	}

	, 
	showHorizontalCrosshair: function () {
		this.horizontalCrosshairLine().__visibility = $.ig.Visibility.prototype.visible;
		this.makeDirty();
	}

	, 
	hideHorizontalCrosshair: function () {
		if (this.horizontalCrosshairLine().__visibility == $.ig.Visibility.prototype.visible) {
			this.horizontalCrosshairLine().__visibility = $.ig.Visibility.prototype.collapsed;
			this.makeDirty();
		}

	}

	, 
	hidePreviewPath: function () {
		this.previewPath().__visibility = $.ig.Visibility.prototype.collapsed;
		this.makeDirty();
	}

	, 
	toAntiClockwisePath: function (rect) {
		var figures = new $.ig.PathFigureCollection();
		var figure = new $.ig.PathFigure();
		figure.__isClosed = true;
		figure.__startPoint = {__x: rect.left(), __y: rect.top(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		figure.__segments.add(new $.ig.LineSegment(0, {__x: rect.left(), __y: rect.bottom(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		figure.__segments.add(new $.ig.LineSegment(0, {__x: rect.right(), __y: rect.bottom(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		figure.__segments.add(new $.ig.LineSegment(0, {__x: rect.right(), __y: rect.top(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		figure.__segments.add(new $.ig.LineSegment(0, {__x: rect.left(), __y: rect.top(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		figures.add(figure);
		return figures;
	}

	, 
	toClockwisePath: function (rect) {
		var figures = new $.ig.PathFigureCollection();
		var figure = new $.ig.PathFigure();
		figure.__isClosed = true;
		figure.__startPoint = {__x: rect.left(), __y: rect.top(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		figure.__segments.add(new $.ig.LineSegment(0, {__x: rect.right(), __y: rect.top(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		figure.__segments.add(new $.ig.LineSegment(0, {__x: rect.right(), __y: rect.bottom(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		figure.__segments.add(new $.ig.LineSegment(0, {__x: rect.left(), __y: rect.bottom(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		figure.__segments.add(new $.ig.LineSegment(0, {__x: rect.left(), __y: rect.top(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		figures.add(figure);
		return figures;
	}

	, 
	updatePreviewPath: function (viewportRect, rect) {
		rect.intersect(viewportRect);
		var pg1 = new $.ig.PathGeometry();
		pg1.figures(this.toClockwisePath(viewportRect));
		var pg2 = new $.ig.PathGeometry();
		pg2.figures(this.toAntiClockwisePath(rect));
		var geometryGroup = new $.ig.GeometryGroup();
		geometryGroup.children().add(pg1);
		geometryGroup.children().add(pg2);
		this.previewPath().data(geometryGroup);
		this.previewPath().__fill = this.viewManager().getBlackBrush();
		this.previewPath().__opacity = 0.1;
		this.makeDirty();
	}

	, 
	showPreviewPath: function () {
		this.previewPath().__visibility = $.ig.Visibility.prototype.visible;
		this.makeDirty();
	}

	, 
	updateZoombars: function (WindowRect) {
	}

	, 
	removeAxis: function (axis) {
		var index = this.attachedAxes().indexOf(axis);
		this.attachedAxes().removeAt(index);
		axis.provideContext(null, null);
		this.resize();
		this.model().removeSpecificDataSource(axis.name(), true);
	}

	, 
	removeLabelPanel: function (axis) {
	}

	, 
	attachAxis: function (axis) {
		if (!this.attachedAxes().contains(axis)) {
			this.attachedAxes().add(axis);
		}

		axis.provideContext(this.mainContext(), this.hitContext());
		this.resize();
	}

	, 
	addLabelPanel: function (axis) {
	}
	, 
	__componentsFromView: null

	, 
	getComponentsFromView: function () {
		this.__componentsFromView.overviewPlusDetailPane(this.overviewPlusDetailPane());
		return this.__componentsFromView;
	}

	, 
	getAllSeries: function (series) {
		var seriesList = series.seriesViewer().series();
		var allSeries = new $.ig.List$1($.ig.Series.prototype.$type, 0);
		for (var i = 0; i < seriesList.count(); i++) {
			allSeries.add(seriesList.__inner[i]);
			if ($.ig.util.cast($.ig.StackedSeriesBase.prototype.$type, seriesList.__inner[i]) !== null) {
				var stacked = seriesList.__inner[i];
				var visualSeries = stacked.stackedSeriesManager().seriesVisual();
				for (var j = 0; j < visualSeries.count(); j++) {
					allSeries.add(visualSeries.__inner[j]);
				}

			}

		}

		return allSeries;
	}

	, 
	resetWindowRect: function () {
		this.model().windowRect(new $.ig.Rect(0, 0, 0, 1, 1));
	}

	, 
	_viewManager: null,
	viewManager: function (value) {
		if (arguments.length === 1) {
			this._viewManager = value;
			return value;
		} else {
			return this._viewManager;
		}
	}

	, 
	_backgroundContext: null,
	backgroundContext: function (value) {
		if (arguments.length === 1) {
			this._backgroundContext = value;
			return value;
		} else {
			return this._backgroundContext;
		}
	}

	, 
	_overlayContext: null,
	overlayContext: function (value) {
		if (arguments.length === 1) {
			this._overlayContext = value;
			return value;
		} else {
			return this._overlayContext;
		}
	}

	, 
	_mainContext: null,
	mainContext: function (value) {
		if (arguments.length === 1) {
			this._mainContext = value;
			return value;
		} else {
			return this._mainContext;
		}
	}

	, 
	_hitContext: null,
	hitContext: function (value) {
		if (arguments.length === 1) {
			this._hitContext = value;
			return value;
		} else {
			return this._hitContext;
		}
	}

	, 
	_mSPointerEnabled: false,
	mSPointerEnabled: function (value) {
		if (arguments.length === 1) {
			this._mSPointerEnabled = value;
			return value;
		} else {
			return this._mSPointerEnabled;
		}
	}

	, 
	onContainerProvided: function (container) {
		var $self = this;
		if (container == null) {
			if ($self.eventProxy() != null) {
				$self.eventProxy().destroy();
			}

			$self.viewManager().onContainerProvided(null);
			$self.backgroundContext(null);
			$self.overlayContext(null);
			$self.mainContext(null);
			$self.hitContext(null);
			$self.eventProxy(null);
			if ($self.model().overviewPlusDetailPane() != null) {
				$self.model().overviewPlusDetailPane().provideContext(null);
				$self.model().overviewPlusDetailPane().provideContainer(null);
				$self.model().overviewPlusDetailPane().provideEventSource(null);
			}

			return;
		}

		$self.viewManager().onContainerProvided(container);
		$self.backgroundContext($self.viewManager().backgroundContext());
		$self.overlayContext($self.viewManager().overlayContext());
		$self.mainContext($self.viewManager().mainContext());
		$self.hitContext($self.viewManager().hitContext());
		$self.mSPointerEnabled(window.navigator.msPointerEnabled);
		if ($self.mSPointerEnabled()) {
			$self.useDeltaZoom(true);
		}

		$self.eventProxy($self.viewManager().eventProxy());
		$self.eventProxy().viewport($self.model().viewportRect());
		$self.eventProxy().shouldInteract($self.shouldInteract.runOn($self));
		$self.eventProxy().onContactCompleted = $.ig.Delegate.prototype.combine($self.eventProxy().onContactCompleted, $self.onContactCompleted.runOn($self));
		$self.eventProxy().onContactMoved = $.ig.Delegate.prototype.combine($self.eventProxy().onContactMoved, $self.onContactMoved.runOn($self));
		$self.eventProxy().onContactStarted = $.ig.Delegate.prototype.combine($self.eventProxy().onContactStarted, $self.onContactStarted.runOn($self));
		$self.eventProxy().onDragCompleted = $.ig.Delegate.prototype.combine($self.eventProxy().onDragCompleted, $self.model().onDragCompleted.runOn($self.model()));
		$self.eventProxy().onDragDelta = $.ig.Delegate.prototype.combine($self.eventProxy().onDragDelta, function (p) { $self.model().onDragDelta(p); });
		$self.eventProxy().onDragStarted = $.ig.Delegate.prototype.combine($self.eventProxy().onDragStarted, function (p) { $self.model().onDragStarted(p, true); });
		$self.eventProxy().onGestureCompleted = $.ig.Delegate.prototype.combine($self.eventProxy().onGestureCompleted, function (p, d) { $self.model().onGestureCompleted(p); });
		$self.eventProxy().onKeyDown = $.ig.Delegate.prototype.combine($self.eventProxy().onKeyDown, $self.model().onKeyDown.runOn($self.model()));
		$self.eventProxy().onMouseDown = $.ig.Delegate.prototype.combine($self.eventProxy().onMouseDown, $self.onMouseDown.runOn($self));
		$self.eventProxy().onMouseLeave = $.ig.Delegate.prototype.combine($self.eventProxy().onMouseLeave, $self.onMouseLeave.runOn($self));
		$self.eventProxy().onMouseOver = $.ig.Delegate.prototype.combine($self.eventProxy().onMouseOver, $self.onMouseOver.runOn($self));
		$self.eventProxy().onMouseUp = $.ig.Delegate.prototype.combine($self.eventProxy().onMouseUp, $self.onMouseUp.runOn($self));
		$self.eventProxy().onMouseWheel = $.ig.Delegate.prototype.combine($self.eventProxy().onMouseWheel, $self.model().onMouseWheel.runOn($self.model()));
		$self.eventProxy().onPinchDelta = $.ig.Delegate.prototype.combine($self.eventProxy().onPinchDelta, function (p, d) { $self.model().onPinchDelta(d); });
		$self.eventProxy().onPinchStarted = $.ig.Delegate.prototype.combine($self.eventProxy().onPinchStarted, function (p, d) { $self.model().onPinchStarted(p); });
		$self.eventProxy().onDoubleTap = $.ig.Delegate.prototype.combine($self.eventProxy().onDoubleTap, function (p) { $self.model().onDoubleTap(p); });
		$self.eventProxy().onHold = $.ig.Delegate.prototype.combine($self.eventProxy().onHold, $self.onHold.runOn($self));
		if ($self.model().overviewPlusDetailPane() != null) {
			$self.model().overviewPlusDetailPane().provideContext($self.overlayContext());
			$self.model().overviewPlusDetailPane().provideContainer(container);
			$self.model().overviewPlusDetailPane().provideEventSource($self.eventProxy());
		}

	}

	, 
	onContactMoved: function (p, isFinger) {
		this.model().onContactMoved(p, isFinger);
	}

	, 
	onContactStarted: function (p, isFinger) {
		if (!isFinger && this.model().mobileMode()) {
			this.model().mobileMode(false);
		}

		if (isFinger && !this.model().mobileMode()) {
			this.model().mobileMode(true);
		}

		this.model().onContactStarted(p, isFinger);
	}

	, 
	onHold: function (p) {
		this.model().onPlotAreaHold(p);
	}

	, 
	onContactCompleted: function (p, isFinger) {
		this.model().onContactCompleted(p, isFinger);
	}

	, 
	provideBackgroundContext: function (context) {
	}

	, 
	_eventProxy: null,
	eventProxy: function (value) {
		if (arguments.length === 1) {
			this._eventProxy = value;
			return value;
		} else {
			return this._eventProxy;
		}
	}

	, 
	updateCurrentFontHeight: function () {
		this.fontHeight($.ig.FontUtil.prototype.getCurrentFontHeight(this.viewManager().container(), this.model().getFont()));
	}

	, 
	_fontHeight: 0,
	fontHeight: function (value) {
		if (arguments.length === 1) {
			this._fontHeight = value;
			return value;
		} else {
			return this._fontHeight;
		}
	}

	, 
	getHitSeries: function (p, forceUpdate, context) {
		var mouseX = $.ig.truncate(Math.round(p.__x));
		var mouseY = $.ig.truncate(Math.round(p.__y));
		context = null;
		var hitPointX = mouseX;
		var hitPointY = mouseY;
		if (this.model().actualPixelScalingRatio() != 1) {
			hitPointX = $.ig.truncate(Math.round(p.__x * this.model().actualPixelScalingRatio()));
			hitPointY = $.ig.truncate(Math.round(p.__y * this.model().actualPixelScalingRatio()));
		}

		var imageData = this.hitContext().getPixelAt(hitPointX, hitPointY);
		if (imageData == null || imageData.length == 0) {
			context = null;
			return {
				ret: null, 
				p2: context
			};
		}

		if ((imageData[0] > 0 || imageData[1] > 0 || imageData[2] > 0) && imageData[3] == 255) {
			var num2_ = imageData[2];
			if (num2_ % 4 != 0) {
				num2_ = num2_ + (4 - (num2_ % 4));
			}

			var num1_ = imageData[1];
			if (num1_ % 4 != 0) {
				num1_ = num1_ + (4 - (num1_ % 4));
			}

			var num0_ = imageData[0];
			if (num0_ % 4 != 0) {
				num0_ = num0_ + (4 - (num0_ % 4));
			}

			var num_ = 0;
			num_ = num2_ >> 2;
			num_ = num_ << 6;
			num_ = num_ | (num1_ >> 2);
			num_ = num_ << 6;
			num_ = num_ | (num0_ >> 2);
			var seriesIndex = $.ig.truncate(Math.floor(($.ig.intDivide(num_, $.ig.SeriesView.prototype.iTEM_ALLOCATION))));
			seriesIndex--;
			var hitSeries = null;
			var foundSeries = false;
			var en = this.attachedSeries().getEnumerator();
			while (en.moveNext()) {
				var series = en.current();
				if (foundSeries) {
					break;
				}

				var stackedSeries = $.ig.util.cast($.ig.StackedSeriesBase.prototype.$type, series);
				if (stackedSeries != null) {
					var en1 = stackedSeries.series().getEnumerator();
					while (en1.moveNext()) {
						var fragment = en1.current();
						if (fragment.visualSeriesLink() != null && fragment.visualSeriesLink()._uniqueIndex == seriesIndex) {
							hitSeries = fragment.visualSeriesLink();
							foundSeries = true;
							break;
						}

					}


				} else if (series._uniqueIndex == seriesIndex) {
					hitSeries = series;
					break;
				}


			}

			if (hitSeries != null) {
				var hitDataContext = hitSeries.getHitDataContext({__x: mouseX, __y: mouseY, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
				if (hitDataContext != null) {
					context = hitDataContext;
				}

			}

			return {
				ret: hitSeries, 
				p2: context
			};
		}

		return {
			ret: null, 
			p2: context
		};
	}

	, 
	_containerWidth: 0,
	containerWidth: function (value) {
		if (arguments.length === 1) {
			this._containerWidth = value;
			return value;
		} else {
			return this._containerWidth;
		}
	}

	, 
	_containerHeight: 0,
	containerHeight: function (value) {
		if (arguments.length === 1) {
			this._containerHeight = value;
			return value;
		} else {
			return this._containerHeight;
		}
	}
	, 
	__currentPlotArea: null
	, 
	__sizeChanged: false

	, 
	notifyContainerResized: function () {
		this.viewManager().notifyContainerResized();
	}

	, 
	onContainerResized: function (width, height) {
		if (this.containerWidth() != width) {
			this.__sizeChanged = true;
		}

		this.containerWidth(width);
		if (this.containerHeight() != height) {
			this.__sizeChanged = true;
		}

		this.containerHeight(height);
		this.onTitlesChanged();
		this.resize();
	}

	, 
	resize: function () {
		this.__panelsDirty = true;
		this.model().chartContentManager().makePending();
	}
	, 
	__actualTopMargin: 0
	, 
	__actualLeftMargin: 0
	, 
	__actualRightMargin: 0
	, 
	__actualBottomMargin: 0
	, 
	__titlesDirty: false
	, 
	__fromEmpty: false

	, 
	determinePlotAreaSize: function () {
		var $self = this;
		if ($self.containerWidth() == 0 || $self.containerHeight() == 0) {
			return;
		}

		$self.__panelsDirty = false;
		$self.__fromEmpty = false;
		if ($self.__titlesDirty) {
			$self.onTitleChanged();
			$self.onSubtitleChanged();
			$self.__titlesDirty = false;
		}

		var _newPlotAreaWidth = $self.containerWidth();
		var _newPlotAreaHeight = $self.containerHeight();
		var leftMargin = $self.model().leftMargin();
		var rightMargin = $self.model().rightMargin();
		var bottomMargin = $self.model().bottomMargin();
		var topMargin = $self.model().topMargin();
		var autoMarginHeight = $self.model().autoMarginHeight();
		var autoMarginWidth = $self.model().autoMarginWidth();
		if ($.ig.util.isNaN(autoMarginHeight)) {
			autoMarginHeight = $self.fontHeight() / 2;
		}

		if ($.ig.util.isNaN(autoMarginWidth)) {
			autoMarginWidth = 0;
		}

		var autoAddMargins = $self.model().shouldAddAutoMargins();
		var labelPanels = new $.ig.List$1($.ig.AxisLabelPanelBase.prototype.$type, 0);
		var en = $self.attachedAxes().getEnumerator();
		while (en.moveNext()) {
			var axis = en.current();
			if (axis.labelPanel() != null) {
				labelPanels.add(axis.labelPanel());
			}

		}

		if (autoAddMargins) {
			var hasOutsideLeft = false;
			var hasOutsideRight = false;
			var hasOutsideTop = false;
			var hasOutsideBottom = false;
			var en1 = labelPanels.getEnumerator();
			while (en1.moveNext()) {
				var panel = en1.current();
				if ($.ig.LabelPanelArranger.prototype.resolveLabelLocation(panel) == $.ig.AxisLabelsLocation.prototype.outsideLeft && (panel.axis().labelSettings() == null || panel.axis().labelSettings().visibility() == $.ig.Visibility.prototype.visible)) {
					hasOutsideLeft = true;
				}

				if ($.ig.LabelPanelArranger.prototype.resolveLabelLocation(panel) == $.ig.AxisLabelsLocation.prototype.outsideRight && (panel.axis().labelSettings() == null || panel.axis().labelSettings().visibility() == $.ig.Visibility.prototype.visible)) {
					hasOutsideRight = true;
				}

				if ($.ig.LabelPanelArranger.prototype.resolveLabelLocation(panel) == $.ig.AxisLabelsLocation.prototype.outsideTop && (panel.axis().labelSettings() == null || panel.axis().labelSettings().visibility() == $.ig.Visibility.prototype.visible)) {
					hasOutsideTop = true;
				}

				if ($.ig.LabelPanelArranger.prototype.resolveLabelLocation(panel) == $.ig.AxisLabelsLocation.prototype.outsideBottom && (panel.axis().labelSettings() == null || panel.axis().labelSettings().visibility() == $.ig.Visibility.prototype.visible)) {
					hasOutsideBottom = true;
				}

				if (panel.axis() != null && panel.axis().labelSettings() != null) {
					panel.axis().labelSettings().actualLocation(panel.axis().labelSettings().location());
				}

			}

			if (hasOutsideLeft || hasOutsideRight) {
				if (!hasOutsideTop && $.ig.util.isNaN(topMargin)) {
					topMargin = autoMarginHeight;
				}

				if (!hasOutsideBottom && $.ig.util.isNaN(bottomMargin)) {
					bottomMargin = autoMarginHeight;
				}

			}

			if (hasOutsideBottom || hasOutsideTop) {
				if (!hasOutsideLeft && $.ig.util.isNaN(leftMargin)) {
					leftMargin = autoMarginWidth;
				}

				if (!hasOutsideRight && $.ig.util.isNaN(rightMargin)) {
					rightMargin = autoMarginWidth;
				}

			}

		}

		if ($.ig.util.isNaN(topMargin)) {
			topMargin = 0;
		}

		if ($.ig.util.isNaN(leftMargin)) {
			leftMargin = 0;
		}

		if ($.ig.util.isNaN(rightMargin)) {
			rightMargin = 0;
		}

		if ($.ig.util.isNaN(bottomMargin)) {
			bottomMargin = 0;
		}

		var titleHeight = $self.getTitleContainerHeight();
		topMargin += titleHeight;
		var subtitleHeight = $self.getSubtitleContainerHeight();
		topMargin += subtitleHeight;
		var gridAreaRect = new $.ig.Rect(0, leftMargin, topMargin, _newPlotAreaWidth - (leftMargin + rightMargin), _newPlotAreaHeight - (topMargin + bottomMargin));
		gridAreaRect = $.ig.LabelPanelArranger.prototype.preparePanels(labelPanels, gridAreaRect);
		var finalSize = new $.ig.Size(1, _newPlotAreaWidth - (leftMargin + rightMargin), _newPlotAreaHeight - (topMargin + bottomMargin));
		if ($self.model().effectiveIsSquare() && gridAreaRect.width() != gridAreaRect.height()) {
			if (gridAreaRect.width() < gridAreaRect.height()) {
				topMargin += (gridAreaRect.height() - gridAreaRect.width()) / 2;
				gridAreaRect.top(gridAreaRect.top() + ((gridAreaRect.height() - gridAreaRect.width()) / 2));
				finalSize.height(finalSize.height() - (gridAreaRect.height() - gridAreaRect.width()));
				gridAreaRect.height(gridAreaRect.width());

			} else {
				leftMargin += (gridAreaRect.width() - gridAreaRect.height()) / 2;
				gridAreaRect.left(gridAreaRect.left() + ((gridAreaRect.width() - gridAreaRect.height()) / 2));
				finalSize.width(finalSize.width() - (gridAreaRect.width() - gridAreaRect.height()));
				gridAreaRect.width(gridAreaRect.height());
			}

		}

		$self.__actualTopMargin = topMargin - (titleHeight + subtitleHeight);
		$self.__actualLeftMargin = leftMargin;
		$self.__actualRightMargin = rightMargin;
		$self.__actualBottomMargin = bottomMargin;
		var arrangeState = (function () { var $ret = new $.ig.LabelPanelsArrangeState();
		$ret.left(leftMargin);
		$ret.insideLeft(leftMargin);
		$ret.bottom(topMargin + finalSize.height());
		$ret.insideBottom(topMargin + finalSize.height());
		$ret.right(leftMargin + finalSize.width());
		$ret.insideRight(leftMargin + finalSize.width());
		$ret.top(topMargin);
		$ret.insideTop(topMargin); return $ret;}());
		$.ig.LabelPanelArranger.prototype.arrangePanels(labelPanels, arrangeState, gridAreaRect, function (p, b) {
			if (!p.labelViewport().equals1(b)) {
				p.labelViewport(b);
				p.axis().view().labelNeedRearrange();
			}

		});
		var changed = false;
		if ($self.__sizeChanged) {
			$self.__sizeChanged = false;
			changed = true;
		}

		$self.__currentPlotArea = gridAreaRect;
		$self.model().processPlotAreaSizeChanged($self.model().viewportRect(), gridAreaRect);
		var en2 = $self.attachedAxes().getEnumerator();
		while (en2.moveNext()) {
			var axis1 = en2.current();
			if (axis1.viewportRect() == null || axis1.viewportRect().isEmpty()) {
				$self.__fromEmpty = true;
			}

			if (axis1.viewportRect().equals1(gridAreaRect)) {
				continue;
			}

			axis1.handleRectChanged(axis1.viewportRect(), gridAreaRect);
		}

		var en3 = $self.attachedSeries().getEnumerator();
		while (en3.moveNext()) {
			var series = en3.current();
			if (series.view().viewport() == null || series.view().viewport().isEmpty()) {
				$self.__fromEmpty = true;
			}

			if (series.view().viewport().equals1(gridAreaRect)) {
				continue;
			}

			series.onViewportChanged(series.view().viewport(), gridAreaRect);
		}

		if ($self.model().overviewPlusDetailPane() != null) {
			var element = $self.model().overviewPlusDetailPane();
			var opdWidth = ($self.model().mobileMode()) ? gridAreaRect.width() : Number.POSITIVE_INFINITY;
			var opdHeight = ($self.model().mobileMode()) ? gridAreaRect.height() : Number.POSITIVE_INFINITY;
			var desiredSize = element.getDesiredSize(new $.ig.Size(1, opdWidth, opdHeight));
			$self.model().overviewPlusDetailPane().arrange(new $.ig.Rect(0, gridAreaRect.right() - desiredSize.width(), gridAreaRect.bottom() - desiredSize.height(), desiredSize.width(), desiredSize.height()));
		}

		$self.provideBackgroundViewport(gridAreaRect);
	}

	, 
	getTitleFont: function () {
		var font = this.model().getFont();
		var defFont = this.getDefaultTitleFont();
		if (this.model().titleTextStyle() != null) {
			font = this.model().titleTextStyle();

		} else if (defFont == font) {
			font = "16px Arial, Helvetica, sans-serif";

		} else if (String.isNullOrEmpty(defFont) == false) {
			font = defFont;
		}



		return font;
	}

	, 
	getSubtitleFont: function () {
		var font = this.model().getFont();
		var defFont = this.getDefaultSubtitleFont();
		if (this.model().subtitleTextStyle() != null) {
			font = this.model().subtitleTextStyle();

		} else if (defFont == font) {
			font = "12px/normal Arial, Helvetica, sans-serif";

		} else if (String.isNullOrEmpty(defFont) == false) {
			font = defFont;
		}



		return font;
	}

	, 
	getTitleBrush: function () {
		var fontBrush = this.model().getFontBrush();
		var defBrush = this.getDefaultTitleBrush();
		if (this.model().titleTextColor() != null) {
			fontBrush = this.model().titleTextColor();

		} else if (defBrush != null) {
			fontBrush = defBrush;
		}


		return fontBrush;
	}

	, 
	getSubtitleBrush: function () {
		var fontBrush = this.model().getFontBrush();
		var defBrush = this.getDefaultSubtitleBrush();
		if (this.model().subtitleTextColor() != null) {
			fontBrush = this.model().subtitleTextColor();

		} else if (defBrush != null) {
			fontBrush = defBrush;
		}


		return fontBrush;
	}

	, 
	getTitleContainerHeight: function () {
		if (this.model().title() == null || !($.ig.util.cast($.ig.XamDataChart.prototype.$type, this.model()) !== null)) {
			return 0;
		}

		var font = this.getTitleFont();
		var height = 0;
		height = $.ig.FontUtil.prototype.getCurrentFontHeight(this.viewManager().container(), font);
		var margin = this.getTitleMargin();
		height += margin.top() + margin.bottom();
		return height;
	}
	, 
	__subTitleHeight: 0

	, 
	getSubtitleContainerHeight: function () {
		if (this.model().subtitle() == null || !($.ig.util.cast($.ig.XamDataChart.prototype.$type, this.model()) !== null)) {
			return 0;
		}

		if (!$.ig.util.isNaN(this.__subTitleHeight)) {
			return this.__subTitleHeight;
		}

		var font = this.getSubtitleFont();
		this.__subTitleHeight = $.ig.FontUtil.prototype.getCurrentFontHeight(this.viewManager().container(), font);
		var margin = this.getSubtitleMargin();
		this.__subTitleHeight += margin.top() + margin.bottom();
		return this.__subTitleHeight;
	}

	, 
	getTitleMargin: function () {
		var defaultMargin = this.viewManager().getDefaultChartTitleMargin();
		var top = $.ig.util.isNaN(this.model().titleTopMargin()) ? defaultMargin.top() : this.model().titleTopMargin();
		var left = $.ig.util.isNaN(this.model().titleLeftMargin()) ? defaultMargin.left() : this.model().titleLeftMargin();
		var right = $.ig.util.isNaN(this.model().titleRightMargin()) ? defaultMargin.right() : this.model().titleRightMargin();
		var bottom = $.ig.util.isNaN(this.model().titleBottomMargin()) ? defaultMargin.bottom() : this.model().titleBottomMargin();
		return new $.ig.Thickness(1, left, top, right, bottom);
	}

	, 
	getSubtitleMargin: function () {
		var defaultMargin = this.viewManager().getDefaultChartSubTitleMargin();
		var top = $.ig.util.isNaN(this.model().subtitleTopMargin()) ? defaultMargin.top() : this.model().subtitleTopMargin();
		var left = $.ig.util.isNaN(this.model().subtitleLeftMargin()) ? defaultMargin.left() : this.model().subtitleLeftMargin();
		var right = $.ig.util.isNaN(this.model().subtitleRightMargin()) ? defaultMargin.right() : this.model().subtitleRightMargin();
		var bottom = $.ig.util.isNaN(this.model().subtitleBottomMargin()) ? defaultMargin.bottom() : this.model().subtitleBottomMargin();
		return new $.ig.Thickness(1, left, top, right, bottom);
	}

	, 
	provideBackgroundViewport: function (viewport) {
	}

	, 
	makeDirty: function () {
		if (!this.__isDirty) {
			this.__isDirty = true;
			this.overlayScheduler().schedule();
		}

	}
	, 
	__renderedRect: null

	, 
	render: function () {
		if (this.overlayContext() == null) {
			return;
		}

		if (this.overlayContext().shouldRender()) {
			if (this.model().actualPixelScalingRatio() != 1) {
				this.overlayContext().save();
				this.overlayContext().scale(this.model().actualPixelScalingRatio(), this.model().actualPixelScalingRatio());
			}

			if (!this.__renderedRect.isEmpty()) {
				this.overlayContext().clearRectangle(this.__renderedRect.left(), this.__renderedRect.top(), this.__renderedRect.width(), this.__renderedRect.height());
			}

		}

		this.renderOverride();
		if (this.overlayContext().shouldRender()) {
			if (this.model().actualPixelScalingRatio() != 1) {
				this.overlayContext().restore();
			}

		}

	}

	, 
	preRender: function () {
		this.viewManager().ensureCorrectSize(this.containerWidth(), this.containerHeight());
		this.preRenderOverride();
	}

	, 
	preRenderOverride: function () {
	}
	, 
	__gradientsEnabled: false

	, 
	renderOverride: function () {
		if (this.overlayContext().shouldRender()) {
			this.__renderedRect = new $.ig.Rect(0, 0, 0, this.containerWidth(), this.containerHeight());
			if (this._visibleTiles != null && this._visibleTiles.count() > 0) {
				this.hidePlotContent();
				this.overlayContext().save();
				this.overlayContext().setRectangleClip(this.model().viewportRect());
				this.overlayContext().clearRectangle(this.model().viewportRect().left(), this.model().viewportRect().top(), this.model().viewportRect().width(), this.model().viewportRect().height());
			}

			this.overlayContext().renderLine(this.horizontalCrosshairLine());
			this.overlayContext().renderLine(this.verticalCrosshairLine());
			this.overlayContext().renderPath(this.previewPath());
			this.overlayContext().renderRectangle(this.dragPathRect());
			this.overlayContext().setFont(this.getTitleFont());
			if (this.__titleText != null) {
				this.__titleText.fill(this.getTitleBrush());
				this.overlayContext().renderTextBlock(this.__titleText);
			}

			this.overlayContext().setFont(this.getSubtitleFont());
			if (this.__subTitleText != null) {
				this.__subTitleText.fill(this.getSubtitleBrush());
				this.overlayContext().renderTextBlock(this.__subTitleText);
			}

			if (this._visibleTiles != null && this._visibleTiles.count() > 0) {
				this.viewManager().renderTiles(this._visibleTiles);
				this.overlayContext().restore();
			}

			if (this.shouldClearTiles()) {
				this.showPlotContent();
				this.shouldClearTiles(false);
				this._visibleTiles.clear();
				this.model().tileManager().clearVisible();
				this.makeDirty();
			}

		}

	}

	, 
	getContainerRect: function () {
		return new $.ig.Rect(0, 0, 0, this.containerWidth(), this.containerHeight());
	}

	, 
	getContainerOffsets: function () {
		return this.viewManager().getContainerOffsets();
	}

	, 
	setDefaultMarkerTemplates: function () {
		var $self = this;
		$self.model().circleMarkerTemplate((function () { var $ret = new $.ig.DataTemplate();
		$ret.render($.ig.MarkerTemplates.prototype.renderCircleMarkerTemplate);
		$ret.measure($.ig.MarkerTemplates.prototype.measureAsEightByEightConstantMarkerTemplate); return $ret;}()));
		$self.model().triangleMarkerTemplate((function () { var $ret = new $.ig.DataTemplate();
		$ret.render($.ig.MarkerTemplates.prototype.renderTriangleMarkerTemplate);
		$ret.measure($.ig.MarkerTemplates.prototype.measureAsEightByEightConstantMarkerTemplate); return $ret;}()));
		$self.model().pyramidMarkerTemplate((function () { var $ret = new $.ig.DataTemplate();
		$ret.render($.ig.MarkerTemplates.prototype.renderPyramidMarkerTemplate);
		$ret.measure($.ig.MarkerTemplates.prototype.measureAsEightByEightConstantMarkerTemplate); return $ret;}()));
		$self.model().squareMarkerTemplate((function () { var $ret = new $.ig.DataTemplate();
		$ret.render($.ig.MarkerTemplates.prototype.renderSquareMarkerTemplate);
		$ret.measure($.ig.MarkerTemplates.prototype.measureAsEightByEightConstantMarkerTemplate); return $ret;}()));
		$self.model().diamondMarkerTemplate((function () { var $ret = new $.ig.DataTemplate();
		$ret.render($.ig.MarkerTemplates.prototype.renderDiamondMarkerTemplate);
		$ret.measure($.ig.MarkerTemplates.prototype.measureAsEightByEightConstantMarkerTemplate); return $ret;}()));
		$self.model().pentagonMarkerTemplate((function () { var $ret = new $.ig.DataTemplate();
		$ret.render($.ig.MarkerTemplates.prototype.renderPentagonMarkerTemplate);
		$ret.measure($.ig.MarkerTemplates.prototype.measureAsEightByEightConstantMarkerTemplate); return $ret;}()));
		$self.model().hexagonMarkerTemplate((function () { var $ret = new $.ig.DataTemplate();
		$ret.render($.ig.MarkerTemplates.prototype.renderHexagonMarkerTemplate);
		$ret.measure($.ig.MarkerTemplates.prototype.measureAsEightByEightConstantMarkerTemplate); return $ret;}()));
		$self.model().tetragramMarkerTemplate((function () { var $ret = new $.ig.DataTemplate();
		$ret.render($.ig.MarkerTemplates.prototype.renderTetragramMarkerTemplate);
		$ret.measure($.ig.MarkerTemplates.prototype.measureAsEightByEightConstantMarkerTemplate); return $ret;}()));
		$self.model().pentagramMarkerTemplate((function () { var $ret = new $.ig.DataTemplate();
		$ret.render($.ig.MarkerTemplates.prototype.renderPentagramMarkerTemplate);
		$ret.measure($.ig.MarkerTemplates.prototype.measureAsEightByEightConstantMarkerTemplate); return $ret;}()));
		$self.model().hexagramMarkerTemplate((function () { var $ret = new $.ig.DataTemplate();
		$ret.render($.ig.MarkerTemplates.prototype.renderHexagramMarkerTemplate);
		$ret.measure($.ig.MarkerTemplates.prototype.measureAsEightByEightConstantMarkerTemplate); return $ret;}()));
	}

	, 
	styleUpdated: function () {
		this.viewManager().styleUpdated();
		this.setDefaultBrushes();
		var oldFontHeight = this.fontHeight();
		this.updateCurrentFontHeight();
		if (oldFontHeight != this.fontHeight()) {
			this.model().invalidatePanels();
		}

	}

	, 
	overviewPlusDetailPaneVisibilityChanged: function () {
		if (this.model().overviewPlusDetailPane() != null) {
			var visibility = this.model().overviewPlusDetailPaneVisibility();
			this.model().overviewPlusDetailPane().__visibility = visibility;
			this.model().overviewPlusDetailPane().refresh(false);
		}

	}

	, 
	shouldInteract: function (p) {
		if (p == null) {
			return false;
		}

		var mouseX = p.__x;
		var mouseY = p.__y;
		if (mouseX >= this.model().viewportRect().left() && mouseY >= this.model().viewportRect().top() && mouseX <= this.model().viewportRect().left() + this.model().viewportRect().width() && mouseY <= this.model().viewportRect().top() + this.model().viewportRect().height()) {
			var opd = this.model().overviewPlusDetailPane();
			if (opd != null && opd.__visibility == $.ig.Visibility.prototype.visible && mouseX >= opd.view().fullSize().left() && mouseY >= opd.view().fullSize().top() && mouseX <= opd.view().fullSize().left() + opd.view().fullSize().width() && mouseY <= opd.view().fullSize().top() + opd.view().fullSize().height()) {
				return false;
			}

			return true;
		}

		return false;
	}

	, 
	_mouseOverSeries: null,
	mouseOverSeries: function (value) {
		if (arguments.length === 1) {
			this._mouseOverSeries = value;
			return value;
		} else {
			return this._mouseOverSeries;
		}
	}

	, 
	_mouseOverContext: null,
	mouseOverContext: function (value) {
		if (arguments.length === 1) {
			this._mouseOverContext = value;
			return value;
		} else {
			return this._mouseOverContext;
		}
	}

	, 
	onMouseOver: function (p, onMouseMove, isFinger) {
		var $self = this;
		if (!isFinger && $self.model().mobileMode()) {
			$self.model().mobileMode(false);
		}

		var me = new $.ig.MouseEventArgs();
		me.position(p);
		if ($self.model().state() == $.ig.InteractionState.prototype.dragPan || $self.model().state() == $.ig.InteractionState.prototype.dragZoom || $self.model().pinching() || ($self.model().overviewPlusDetailPane() == null || $self.model().overviewPlusDetailPane().pinching())) {
			if ($self.mouseOverSeries() != null) {
				if ($self.__seriesMouseDown) {
					$self.onMouseUp(p);
				}

				$self.mouseOverSeries().onMouseLeave(me.position(), $self.mouseOverContext(), me);
				$self.mouseOverSeries(null);
			}

			return;
		}

		var context = null;
		var hitSeries = (function () { var $ret = $self.getHitSeries(p, !onMouseMove, context); context = $ret.p2; return $ret.ret; }());
		$self.mouseOverContext(context);
		var parentSeries = $self.getParentSeries(hitSeries);
		if (hitSeries != null) {
			var notOver = false;
			var changeSeries = false;
			if ($self.mouseOverSeries() != hitSeries) {
				changeSeries = true;
			}

			if ($self.mouseOverSeries() == null || changeSeries) {
				notOver = true;
			}

			if (notOver) {
				if (changeSeries) {
					if ($self.mouseOverSeries() != null) {
						parentSeries = $self.getParentSeries($self.mouseOverSeries());
						$self.mouseOverSeries().onMouseLeave(me.position(), context, me);
						if (parentSeries != null) {
							parentSeries.onMouseLeave(me.position(), context, me);
						}

					}

				}

				$self.mouseOverSeries(hitSeries);
				hitSeries.onMouseEnter(me.position(), context, me);
				if (parentSeries != null) {
					parentSeries.onMouseEnter(me.position(), context, me);
				}


			} else {
				$self.mouseOverSeries(hitSeries);
				hitSeries.onMouseMove(me.position(), context, me);
				if (parentSeries != null) {
					parentSeries.onMouseMove(me.position(), context, me);
				}

			}


		} else {
			if ($self.mouseOverSeries() != null) {
				parentSeries = $self.getParentSeries($self.mouseOverSeries());
				$self.mouseOverSeries().onMouseLeave(me.position(), context, me);
				if (parentSeries != null) {
					parentSeries.onMouseLeave(me.position(), context, me);
				}

				$self.mouseOverSeries(null);
			}

			for (var i = 0; i < $self.model().series().count(); i++) {
				var s = $self.model().series().__inner[i];
				if (s.isMouseLeaveDeferred()) {
					parentSeries = $self.getParentSeries(s);
					s.onMouseLeave(me.position(), s.lastHoverItem(), me);
					if (parentSeries != null) {
						parentSeries.onMouseLeave(me.position(), s.lastHoverItem(), me);
					}

				}

			}

		}

	}

	, 
	getParentSeries: function (series) {
		var parentSeries = null;
		if (series != null && $.ig.util.cast($.ig.FragmentBase.prototype.$type, series) !== null) {
			parentSeries = (series).parentSeries();
		}

		if (series != null && $.ig.util.cast($.ig.SplineFragmentBase.prototype.$type, series) !== null) {
			parentSeries = (series).parentSeries();
		}

		return parentSeries;
	}

	, 
	onMouseLeave: function (p) {
		if (this.mouseOverSeries() != null) {
			var parentSeries = this.getParentSeries(this.mouseOverSeries());
			var me = new $.ig.MouseEventArgs();
			me.position(p);
			this.mouseOverSeries().onMouseLeave(me.position(), null, me);
			if (parentSeries != null) {
				parentSeries.onMouseLeave(me.position(), null, me);
			}

			this.mouseOverSeries(null);
		}

		this.model().onMouseLeave(p);
	}
	, 
	__seriesMouseDown: false

	, 
	onMouseDown: function (p) {
		if (this.mouseOverSeries() != null) {
			this.__seriesMouseDown = true;
			var ev = new $.ig.MouseButtonEventArgs();
			ev.position(p);
			this.mouseOverSeries().onLeftButtonDown(ev.position(), this.mouseOverContext(), ev);
		}

	}

	, 
	onMouseUp: function (p) {
		if (this.mouseOverSeries() != null) {
			this.__seriesMouseDown = false;
			var ev = new $.ig.MouseButtonEventArgs();
			ev.position(p);
			this.mouseOverSeries().onMouseLeftButtonUp(ev.position(), this.mouseOverContext(), ev);
		}

	}

	, 
	setDefaultBrushes: function () {
	}

	, 
	currentModifiers: function () {

			return this.eventProxy().currentModifiers();
	}

	, 
	viewportChanged: function (_viewport) {
		if (this.eventProxy() != null) {
			this.eventProxy().viewport(this.model().viewportRect());
		}

	}

	, 
	mobileModeChanged: function (_mobileMode) {
		this.model().ignoreCrosshairVisibilityChange(true);
		this.model().crosshairsVisible((this.model().mobileMode() && !this.model().userSetCrosshairVisibility()) || this.model().crosshairVisibility() == $.ig.Visibility.prototype.visible);
		this.model().ignoreCrosshairVisibilityChange(false);
		this.changeOPDMobileMode(_mobileMode);
	}

	, 
	changeOPDMobileMode: function (_mobileMode) {
		if (this.model().overviewPlusDetailPane() != null) {
			this.model().overviewPlusDetailPane().mobileMode(_mobileMode);
			if (!_mobileMode) {
				this.model().overviewPlusDetailPane().__visibility = this.model().overviewPlusDetailPaneVisibility();
				this.model().overviewPlusDetailPane().view().useMobileOpd(false);

			} else {
				this.model().overviewPlusDetailPane().__visibility = $.ig.Visibility.prototype.collapsed;
				this.model().overviewPlusDetailPane().view().useMobileOpd(this.model().overviewPlusDetailPaneVisibility() == $.ig.Visibility.prototype.visible);
			}

			this.model().invalidatePanels();
		}

	}
	, 
	__isDirty: false

	, 
	isDirty: function (value) {
		if (arguments.length === 1) {

			this.__isDirty = value;
			return value;
		} else {

			return this.__isDirty;
		}
	}

	, 
	undirty: function (clearRect) {
		this.__isDirty = false;
		this.render();
	}

	, 
	index: function () {

			return 10;
	}

	, 
	postRender: function () {
	}

	, 
	ensurePanelsArranged: function () {
		this.resize();
	}
	, 
	__infoBoxVisible: false

	, 
	hideInfoBox: function () {
		this.viewManager().hideInfoBox();
	}

	, 
	showInfoBox: function () {
		this.viewManager().showInfoBox();
	}

	, 
	clearInfoBox: function (isVertical) {
		this.viewManager().clearInfoBox();
	}

	, 
	addToInfoBox: function (control) {
		this.viewManager().addToInfoBox(control);
	}

	, 
	updateInfoBoxXTranslation: function (x) {
		this.viewManager().updateInfoBoxXTranslation(x);
	}

	, 
	updateInfoBoxYTranslation: function (p) {
		this.viewManager().updateInfoBoxYTranslation(p);
	}

	, 
	addTooltipToView: function (control) {
		this.viewManager().addTooltipToView(control);
	}

	, 
	removeTooltipFromView: function (control) {
		this.viewManager().removeTooltipFromView(control);
	}

	, 
	onPlotAreaBackgroundChanged: function (plotAreaBackground) {
		this.model().canvasRenderScheduler().schedule();
	}

	, 
	checkInteractionCompleted: function (pt) {
	}

	, 
	_useDeltaZoom: false,
	useDeltaZoom: function (value) {
		if (arguments.length === 1) {
			this._useDeltaZoom = value;
			return value;
		} else {
			return this._useDeltaZoom;
		}
	}

	, 
	resolveDefaultInteraction: function (isFinger) {
		if (this.model().mobileMode()) {
			return $.ig.InteractionState.prototype.dragPan;

		} else {
			return $.ig.InteractionState.prototype.dragZoom;
		}

	}

	, 
	onIsInteractionDisabledChanged: function () {
		this.eventProxy().isInteractionDisabled(this.model().isSurfaceInteractionDisabled());
	}
	, 
	__titleText: null
	, 
	__subTitleText: null

	, 
	getDesiredTextWidth: function (text, font) {
		if (text == null) {
			return 0;
		}

		this.overlayContext().setFont(font);
		return this.overlayContext().measureTextWidth(text);
	}

	, 
	getDesiredTextHeight: function (text, font) {
		if (text == null) {
			return 0;
		}

		var height = 0;
		height = $.ig.FontUtil.prototype.getCurrentFontHeight(this.viewManager().container(), font);
		return height;
	}

	, 
	onTitlesChanged: function () {
		this.__titlesDirty = true;
		this.resize();
		this.makeDirty();
	}

	, 
	onTitleChanged: function () {
		if (this.model().title() == null || !($.ig.util.cast($.ig.XamDataChart.prototype.$type, this.model()) !== null)) {
			this.__titleText = null;

		} else {
			this.__titleText = new $.ig.TextBlock();
			this.__titleText.text(this.model().title().toString());
			var titleMargin = this.getTitleMargin();
			var textWidth = this.getDesiredTextWidth(this.__titleText.text(), this.getTitleFont());
			this.__titleText.canvasLeft((this.containerWidth() / 2) - ((textWidth + titleMargin.left() + titleMargin.right()) / 2));
			this.__titleText.canvasTop(titleMargin.top());
			var textHeight = this.getDesiredTextHeight(this.__titleText.text(), this.getTitleFont());
			this.__titleText.actualWidth(textWidth);
			this.__titleText.actualHeight(textHeight);
			var textAlign = this.getTitleAlignement();
			switch (textAlign) {
				case $.ig.HorizontalAlignment.prototype.left:
					this.__titleText.canvasLeft(titleMargin.left());
					break;
				case $.ig.HorizontalAlignment.prototype.right:
					this.__titleText.canvasLeft(Math.max((this.containerWidth() - titleMargin.right()) - textWidth, titleMargin.left()));
					break;
			}

		}

	}

	, 
	onSubtitleChanged: function () {
		this.__subTitleHeight = NaN;
		if (this.model().subtitle() == null || !($.ig.util.cast($.ig.XamDataChart.prototype.$type, this.model()) !== null)) {
			this.__subTitleText = null;

		} else {
			this.__subTitleText = new $.ig.TextBlock();
			this.__subTitleText.text(this.model().subtitle().toString());
			var subTitleMargin = this.getSubtitleMargin();
			var textWidth = this.getDesiredTextWidth(this.__subTitleText.text(), this.getSubtitleFont());
			this.__subTitleText.canvasLeft((this.containerWidth() / 2) - ((textWidth + subTitleMargin.left() + subTitleMargin.right()) / 2));
			this.__subTitleText.canvasTop(this.getTitleContainerHeight() + subTitleMargin.top());
			var textHeight = this.getDesiredTextHeight(this.__subTitleText.text(), this.getSubtitleFont());
			this.__subTitleText.actualWidth(textWidth);
			this.__subTitleText.actualHeight(textHeight);
			var textAlign = this.getSubtitleAlignement();
			switch (textAlign) {
				case $.ig.HorizontalAlignment.prototype.left:
					this.__subTitleText.canvasLeft(subTitleMargin.left());
					break;
				case $.ig.HorizontalAlignment.prototype.right:
					this.__subTitleText.canvasLeft(Math.max((this.containerWidth() - subTitleMargin.right()) - textWidth, subTitleMargin.left()));
					break;
			}

		}

	}

	, 
	getDefaultHorizontalAxisTitlePosition: function (axis) {
		var position = this.viewManager().getDefaultHorizontalAxisTitlePosition();
		if (position == $.ig.AxisTitlePosition.prototype.auto) {
			var actualLocation = $.ig.LabelPanelArranger.prototype.resolveLabelLocation(axis.labelPanel());
			if (axis.crossingAxis() == null) {
				if (actualLocation == $.ig.AxisLabelsLocation.prototype.insideTop) {
				return $.ig.AxisTitlePosition.prototype.bottom;
				}

				if (actualLocation == $.ig.AxisLabelsLocation.prototype.insideBottom) {
				return $.ig.AxisTitlePosition.prototype.top;
				}


			} else {
				if (actualLocation == $.ig.AxisLabelsLocation.prototype.insideTop) {
				return $.ig.AxisTitlePosition.prototype.top;
				}

				if (actualLocation == $.ig.AxisLabelsLocation.prototype.insideBottom) {
				return $.ig.AxisTitlePosition.prototype.bottom;
				}

			}

			if (actualLocation == $.ig.AxisLabelsLocation.prototype.outsideTop) {
				return $.ig.AxisTitlePosition.prototype.top;
			}

			return $.ig.AxisTitlePosition.prototype.bottom;
		}

		return position;
	}

	, 
	getDefaultVerticalAxisTitlePosition: function (axis) {
		var position = this.viewManager().getDefaultVerticalAxisTitlePosition();
		if (position == $.ig.AxisTitlePosition.prototype.auto) {
			var actualLocation = $.ig.LabelPanelArranger.prototype.resolveLabelLocation(axis.labelPanel());
			if (axis.crossingAxis() == null) {
				if (actualLocation == $.ig.AxisLabelsLocation.prototype.insideRight) {
				return $.ig.AxisTitlePosition.prototype.left;
				}

				if (actualLocation == $.ig.AxisLabelsLocation.prototype.insideLeft) {
				return $.ig.AxisTitlePosition.prototype.right;
				}


			} else {
				if (actualLocation == $.ig.AxisLabelsLocation.prototype.insideRight) {
				return $.ig.AxisTitlePosition.prototype.right;
				}

				if (actualLocation == $.ig.AxisLabelsLocation.prototype.insideLeft) {
				return $.ig.AxisTitlePosition.prototype.left;
				}

			}

			if (actualLocation == $.ig.AxisLabelsLocation.prototype.outsideRight) {
				return $.ig.AxisTitlePosition.prototype.right;
			}

			return $.ig.AxisTitlePosition.prototype.left;
		}

		return position;
	}

	, 
	getDefaultVerticalAxisFont: function () {
		return this.viewManager().getDefaultVerticalAxisFont();
	}

	, 
	getDefaultVerticalAxisColor: function () {
		return this.viewManager().getDefaultVerticalAxisColor();
	}

	, 
	getDefaultHorizontalAxisFont: function () {
		return this.viewManager().getDefaultHorizontalAxisFont();
	}

	, 
	getDefaultHorizontalAxisColor: function () {
		return this.viewManager().getDefaultHorizontalAxisColor();
	}

	, 
	getDefaultTitleFont: function () {
		return this.viewManager().getDefaultChartTitleFont();
	}

	, 
	getDefaultSubtitleFont: function () {
		return this.viewManager().getDefaultChartSubTitleFont();
	}

	, 
	getDefaultTitleBrush: function () {
		return this.viewManager().getDefaultChartTitleColor();
	}

	, 
	getDefaultSubtitleBrush: function () {
		return this.viewManager().getDefaultChartSubTitleColor();
	}

	, 
	exportTitleData: function (visualData) {
		var font = "";
		visualData.title(null);
		visualData.subtitle(null);
		var titleMargin = this.getTitleMargin();
		var titleContainerHeight = 0;
		var titleHeight = 0;
		if (this.__titleText != null) {
			font = this.getTitleFont();
			var fontInfo = $.ig.FontUtil.prototype.getFontInfo(this.__titleText, font);
			var titleOrigin = {__x: 0, __y: 0, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			titleHeight = this.__titleText.actualHeight() + titleMargin.bottom() + titleMargin.top();
			var titleData = new $.ig.ChartTitleVisualData();
			var contentArea = this.getContentArea();
			titleData.viewport(new $.ig.Rect(0, contentArea.left(), contentArea.top(), contentArea.width(), titleHeight));
			titleData.textPlotArea(this.exportTitleBounds(this.__titleText));
			titleData.textPlotArea(new $.ig.Rect(0, this.__titleText.canvasLeft(), this.__titleText.canvasTop(), this.__titleText.actualWidth(), this.__titleText.actualHeight()));
			titleContainerHeight = titleData.height();
			titleData.appearance($.ig.AppearanceHelper.prototype.fromTextElement(this.__titleText, fontInfo));
			var margin = this.getTitleMargin();
			titleData.appearance().marginTop(margin.top());
			titleData.appearance().marginLeft(margin.left());
			titleData.appearance().marginRight(margin.right());
			titleData.appearance().marginBottom(margin.bottom());
			var alignment = this.getTitleAlignement();
			titleData.appearance().horizontalAlignment($.ig.HorizontalAlignment.prototype.getName(alignment));
			visualData.title(titleData);
		}

		if (this.__subTitleText != null) {
			font = this.getSubtitleFont();
			var fontInfo1 = $.ig.FontUtil.prototype.getFontInfo(this.__subTitleText, font);
			var subTitleOrigin = {__x: 0, __y: titleContainerHeight, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			var subTitleMargin = this.getSubtitleMargin();
			var subTitleHeight = this.__subTitleText.actualHeight() + subTitleMargin.bottom() + subTitleMargin.top();
			var subTitleData = new $.ig.ChartTitleVisualData();
			var contentArea1 = this.getContentArea();
			subTitleData.viewport(new $.ig.Rect(0, contentArea1.left(), contentArea1.top() + titleHeight, contentArea1.width(), subTitleHeight));
			subTitleData.textPlotArea(this.exportTitleBounds(this.__subTitleText));
			subTitleData.appearance($.ig.AppearanceHelper.prototype.fromTextElement(this.__subTitleText, fontInfo1));
			var margin1 = this.getSubtitleMargin();
			subTitleData.appearance().marginTop(margin1.top());
			subTitleData.appearance().marginLeft(margin1.left());
			subTitleData.appearance().marginRight(margin1.right());
			subTitleData.appearance().marginBottom(margin1.bottom());
			var alignment1 = this.getSubtitleAlignement();
			subTitleData.appearance().horizontalAlignment($.ig.HorizontalAlignment.prototype.getName(alignment1));
			visualData.subtitle(subTitleData);
		}

	}

	, 
	getContentArea: function () {
		return new $.ig.Rect(0, 0, 0, this.containerWidth(), this.containerHeight());
	}

	, 
	exportTitleBounds: function (textBlock) {
		var bounds = $.ig.VisualExportHelper.prototype.getRotatedBounds(textBlock);
		return bounds;
	}

	, 
	exportChartData: function (cvd) {
		cvd.width(this.containerWidth());
		cvd.height(this.containerHeight());
		cvd.contentArea(this.getContentArea());
		cvd.centralArea(new $.ig.Rect(0, this.__actualLeftMargin, 0, this.containerWidth() - (this.__actualLeftMargin + this.__actualRightMargin), this.containerHeight() - (this.__actualTopMargin + this.__actualBottomMargin)));
		cvd.plotArea(this.model().viewportRect());
	}

	, 
	getDefaultVerticalAxisTitleMargin: function () {
		return this.viewManager().getDefaultVerticalAxisTitleMargin();
	}

	, 
	getDefaultHorizontalAxisTitleMargin: function () {
		return this.viewManager().getDefaultHorizontalAxisTitleMargin();
	}
	, 
	__hasUserTitleAlignment: false
	, 
	__hasUserSubtitleAlignment: false

	, 
	onSubtitleAlignmentChanged: function (oldValue, newValue) {
		this.__hasUserSubtitleAlignment = true;
	}

	, 
	onTitleAlignmentChanged: function (oldValue, newValue) {
		this.__hasUserTitleAlignment = true;
	}

	, 
	getTitleAlignement: function () {
		if (this.__hasUserTitleAlignment) {
			return this.model().titleHorizontalAlignment();

		} else {
			var ret = $.ig.HorizontalAlignment.prototype.center;
			switch (this.viewManager().getDefaultChartTitleTextAlign()) {
				case "left":
					ret = $.ig.HorizontalAlignment.prototype.left;
					break;
				case "right":
					ret = $.ig.HorizontalAlignment.prototype.right;
					break;
			}

			return ret;
		}

	}

	, 
	getSubtitleAlignement: function () {
		if (this.__hasUserSubtitleAlignment) {
			return this.model().subtitleHorizontalAlignment();

		} else {
			var ret = $.ig.HorizontalAlignment.prototype.center;
			switch (this.viewManager().getDefaultChartSubTitleTextAlign()) {
				case "left":
					ret = $.ig.HorizontalAlignment.prototype.left;
					break;
				case "right":
					ret = $.ig.HorizontalAlignment.prototype.right;
					break;
			}

			return ret;
		}

	}
	, 
	__panelsDirty: false

	, 
	beforeContentRefresh: function () {
		if (this.__panelsDirty) {
			this.determinePlotAreaSize();
			if (this.__fromEmpty) {
				this.model().chartContentManager().force();
			}

			if (this.__panelsDirty) {
				this.determinePlotAreaSize();
			}

		}

	}

	, 
	justZoomed: function () {
		if (this.model().zoomLongAgo()) {
			return false;
		}

		if (($.ig.Date.prototype.now().getTime() - this.model().lastZoomTime().getTime()) < 300) {
			return true;
		}

		return false;
	}

	, 
	ensureCorrectSize: function () {
		this.viewManager().ensureCorrectSize(this.containerWidth(), this.containerHeight());
	}

	, 
	isPagePanningAllowedChanged: function () {
		this.viewManager().isPagePanningAllowedChanged(this.model().isPagePanningAllowed());
	}

	, 
	shouldInteractForDirection: function (direction) {
		var window = this.model().actualWindowRect();
		var isUpAllowed = window.top() > 0;
		var isLeftAllowed = window.left() > 0;
		var isRightAllowed = window.right() < 1;
		var isDownAllowed = window.bottom() < 1;
		var isUpRequested = direction.__y < 0;
		var isDownRequested = direction.__y > 0;
		var isLeftRequested = direction.__x < 0;
		var isRightRequested = direction.__x > 0;
		if (isUpAllowed && isUpRequested) {
			return true;
		}

		if (isLeftAllowed && isLeftRequested) {
			return true;
		}

		if (isDownAllowed && isDownRequested) {
			return true;
		}

		if (isRightRequested && isRightAllowed) {
			return true;
		}

		return false;
	}

	, 
	pixelScalingRatioChanged: function () {
		this.model().canvasRenderScheduler().schedule();
		this.model().thumbnailCanvasRenderScheduler().schedule();
		this.model().alternateViewRenderScheduler().schedule();
		this.overlayScheduler().schedule();
	}
	, 
	_visibleTiles: null

	, 
	displayZoomTiles: function (existing, newTiles, tileSize) {
		this.shouldClearTiles(false);
		if (this._visibleTiles == null) {
			this._visibleTiles = new $.ig.List$1($.ig.TileZoomTile.prototype.$type, 0);
		}

		for (var i = 0; i < this._visibleTiles.count(); i++) {
			while (i < this._visibleTiles.count() && !existing.containsKey(this._visibleTiles.__inner[i].content())) {
				this._visibleTiles.removeAt(i);

			}
		}

		for (var i1 = 0; i1 < newTiles.count(); i1++) {
			this._visibleTiles.add(newTiles.__inner[i1]);
		}

		this.makeDirty();
	}

	, 
	acquireTileContent: function (window, tile, tileSize) {
		return this.viewManager().acquireTileContent(window, tile, tileSize);
	}

	, 
	destroyAllTileContent: function () {
		this.viewManager().destroyAllTileContent();
	}

	, 
	destroyTileContent: function (tile) {
		this.viewManager().destroyTileContent(tile);
	}

	, 
	hideZoomTiles: function () {
		if (this._visibleTiles == null) {
			return;
		}

		this.shouldClearTiles(true);
		this.makeDirty();
	}

	, 
	_shouldClearTiles: false,
	shouldClearTiles: function (value) {
		if (arguments.length === 1) {
			this._shouldClearTiles = value;
			return value;
		} else {
			return this._shouldClearTiles;
		}
	}
	, 
	__cacheClearTimer: 0

	, 
	deferCacheClear: function () {
		this.viewManager().deferCacheClear();
	}

	, 
	cancelDeferredCacheClear: function () {
		this.viewManager().cancelDeferredCacheClear();
	}

	, 
	deferEndToTiledZoom: function (delay) {
		this.viewManager().deferEndToTiledZoom(delay);
	}

	, 
	cancelEndToTiledZoom: function () {
		this.viewManager().cancelEndToTiledZoom();
	}
	, 
	__plotContentShown: false

	, 
	hidePlotContent: function () {
		if (this.__plotContentShown) {
			this.__plotContentShown = false;
			this.mainContext().clearRectangle(this.model().viewportRect().left(), this.model().viewportRect().top(), this.model().viewportRect().width(), this.model().viewportRect().height());
			this.model().canvasRenderScheduler().isDisabled(true);
		}

	}

	, 
	showPlotContent: function () {
		if (!this.__plotContentShown) {
			this.__plotContentShown = true;
			this.model().canvasRenderScheduler().isDisabled(false);
			this.model().canvasRenderScheduler().schedule1(this.mainContext(), this.hitContext());
		}

	}

	, 
	onTileZoomEnding: function () {
	}
	, 
	$type: new $.ig.Type('SeriesViewerView', $.ig.Object.prototype.$type, [$.ig.ISchedulableRender.prototype.$type])
}, true);

$.ig.util.defType('IProvidesViewport', 'Object', {
	$type: new $.ig.Type('IProvidesViewport', null)
}, true);

$.ig.util.defType('OverviewPlusDetailViewportHost', 'Object', {
	init: function (view) {



		$.ig.Object.prototype.init.call(this);
			if (view == null) {
				throw new $.ig.ArgumentNullException(0, "view");
			}

			this.view(view);
	}

	, 
	_view: null,
	view: function (value) {
		if (arguments.length === 1) {
			this._view = value;
			return value;
		} else {
			return this._view;
		}
	}

	, 
	getViewInfo: function (viewportRect, windowRect) {
		viewportRect = new $.ig.Rect(0, 0, 0, this.view().overviewPlusDetailPane().view().worldRect().width(), this.view().overviewPlusDetailPane().view().worldRect().height());
		windowRect = $.ig.SeriesViewer.prototype.standardRect;
		return {
			p0: viewportRect, 
			p1: windowRect
		};
	}
	, 
	$type: new $.ig.Type('OverviewPlusDetailViewportHost', $.ig.Object.prototype.$type, [$.ig.IProvidesViewport.prototype.$type])
}, true);

$.ig.util.defType('Series', 'Control', {

	_view: null,
	view: function (value) {
		if (arguments.length === 1) {
			this._view = value;
			return value;
		} else {
			return this._view;
		}
	}
	, 
	_uniqueIndex: 0

	, 
	_customClipRect: null,
	customClipRect: function (value) {
		if (arguments.length === 1) {
			this._customClipRect = value;
			return value;
		} else {
			return this._customClipRect;
		}
	}
	, 
	init: function () {


		this.__alternateViews = new $.ig.Dictionary$2(String, $.ig.SeriesView.prototype.$type, 0);
		this.__thumbnailDirty = true;
		this.__transitionInViable = false;
		this.__isDefaultToolTipSelected = false;
		this.__seriesComponentsForView = new $.ig.SeriesComponentsForView();
		this.__useDeferredMouseEnterAndLeave = false;
		this.__expectFunctions = false;

		var $self = this;
		$.ig.Control.prototype.init.call(this);
			this._uniqueIndex = $.ig.Series.prototype.__currentUniqueIndex++;
			this.thumbnailDirty(true);
			this.customClipRect($.ig.Rect.prototype.empty());
			this.view(this.createView());
			this.view().viewport($.ig.Rect.prototype.empty());
			this.onViewCreated(this.view());
			this.view().duringInit(true);
			this.view().onInit();
			this.view().duringInit(false);
			this.defaultStyleKey($.ig.Series.prototype.$type);
			this._seriesViewer_WindowRectChanged = function (o, e) {
				if ($self.seriesViewer() == null || !$self.seriesViewer().ignoreWindowChanges()) {
					$self.windowRectChangedOverride(e.oldRect(), e.newRect());
				}

			};
			this._seriesViewer_PropertyUpdated = function (o, e) {
				$self.propertyUpdatedOverride(o, e.propertyName(), e.oldValue(), e.newValue());
			};
			this._fastItemsSource_Event = function (o, e) {
				if ($self.seriesViewer() != null) {
					$self.thumbnailDirty(true);
					$self.seriesViewer().notifyThumbnailDataChanged();
				}

				$self.dataUpdatedOverride(e.action(), e.position(), e.count(), e.propertyName());
			};
			this.propertyUpdated = $.ig.Delegate.prototype.combine(this.propertyUpdated, function (o, e) {
				$self.propertyUpdatedOverride(o, e.propertyName(), e.oldValue(), e.newValue());
			});
			this.rootCanvas(new $.ig.Canvas());
			this.animator(new $.ig.DoubleAnimator(0, 1, this.transitionDuration()));
			this.animator().propertyChanged = $.ig.Delegate.prototype.combine(this.animator().propertyChanged, this.animator_PropertyChanged.runOn(this));
			this.setBinding($.ig.Series.prototype._visibilityProxyProperty, (function () { var $ret = new $.ig.Binding(1, "Visibility");
			$ret.source($self); return $ret;}()));
	}

	, 
	animator_PropertyChanged: function (sender, e) {
		this.transitionProgress(this.animator().transitionProgress());
	}

	, 
	_animator: null,
	animator: function (value) {
		if (arguments.length === 1) {
			this._animator = value;
			return value;
		} else {
			return this._animator;
		}
	}

	, 
	onViewCreated: function (view) {
	}

	, 
	onSeriesAttached: function () {
		this.assertLegendItems(this.actualLegend(), this.actualLegend());
		if (this.fastItemsSource() == null && this.syncLink() != null && this.itemsSource() != null) {
			this.fastItemsSource(($.ig.util.cast($.ig.IFastItemsSourceProvider.prototype.$type, this.syncLink())).getFastItemsSource(this.itemsSource()));
		}

		this.view().onSeriesAttached();
	}

	, 
	onSeriesDetached: function () {
		this.clearLegendItems();
		if (this.fastItemsSource() != null && this.syncLink() != null && this.itemsSource() != null) {
			this.fastItemsSource(($.ig.util.cast($.ig.IFastItemsSourceProvider.prototype.$type, this.syncLink())).releaseFastItemsSource(this.itemsSource()));
		}

		this.view().onSeriesDetached();
	}

	, 
	createView: function () {
		return new $.ig.SeriesView(this);
	}

	, 
	_rootCanvas: null,
	rootCanvas: function (value) {
		if (arguments.length === 1) {
			this._rootCanvas = value;
			return value;
		} else {
			return this._rootCanvas;
		}
	}

	, 
	useParentMarkerCanvas: function () {
		return false;
	}

	, 
	getExactItemIndex: function (world) {
		return this.getItemIndex(world);
	}

	, 
	getItemIndex: function (world) {
		return -1;
	}

	, 
	getItem: function (world) {
		return null;
	}

	, 
	getSeriesItem: function (series, world) {
		return series.getItem(world);
	}

	, 
	isAnnotationLayer: function () {

			return false;
	}

	, 
	isVertical: function () {

			return false;
	}

	, 
	isPolar: function () {

			return false;
	}

	, 
	isScatter: function () {

			return false;
	}

	, 
	isRadial: function () {

			return false;
	}

	, 
	isStacked: function () {

			return false;
	}

	, 
	isFinancial: function () {

			return false;
	}

	, 
	isRange: function () {

			return false;
	}

	, 
	isCategory: function () {

			return false;
	}

	, 
	isDefaultCrosshairBehaviorDisabled: function () {

			return false;
	}

	, 
	isDefaultTooltipBehaviorDisabled: function () {

			return false;
	}

	, 
	getDistanceToIndex: function (world, index, axis, p, offset) {
		return Number.POSITIVE_INFINITY;
	}

	, 
	getDistanceToIndexHelper: function (world, index, axis, scalerParams, offset, count, getExactUnsortedIndex) {
		if (axis == null) {
			return Number.POSITIVE_INFINITY;
		}

		if (index < 0 || index > count - 1) {
			return Number.POSITIVE_INFINITY;
		}

		var indexPos = 0;
		var exactItemIndex;
		var prevVal = NaN;
		var nextVal = NaN;
		var indVal = NaN;
		var inter = NaN;
		if (axis.isSorting()) {
			var sorting = axis;
			exactItemIndex = getExactUnsortedIndex(world);
			var prevItem = $.ig.truncate(Math.floor(exactItemIndex));
			var nextItem = $.ig.truncate(Math.ceil(exactItemIndex));
			inter = exactItemIndex - prevItem;
			if (prevItem >= 0 && prevItem < count) {
				var unscaled = sorting.getUnscaledValueAt(sorting.sortedIndices().__inner[prevItem]);
				prevVal = axis.getScaledValue(unscaled, scalerParams) + offset;

			} else {
				prevVal = NaN;
			}

			if (nextItem >= 0 && nextItem < count) {
				var unscaled1 = sorting.getUnscaledValueAt(sorting.sortedIndices().__inner[nextItem]);
				nextVal = axis.getScaledValue(unscaled1, scalerParams) + offset;

			} else {
				nextVal = NaN;
			}

			if ($.ig.util.isNaN(prevVal) && !$.ig.util.isNaN(nextVal)) {
				prevVal = nextVal;
			}

			if ($.ig.util.isNaN(nextVal) && !$.ig.util.isNaN(prevVal)) {
				nextVal = prevVal;
			}

			if (index >= 0 && index < count) {
				var unscaled2 = sorting.getUnscaledValueAt(sorting.sortedIndices().__inner[index]);
				indVal = axis.getScaledValue(unscaled2, scalerParams) + offset;
			}


		} else {
			exactItemIndex = this.getExactItemIndex(world);
			var prevItem1 = $.ig.truncate(Math.floor(exactItemIndex));
			var nextItem1 = $.ig.truncate(Math.ceil(exactItemIndex));
			inter = exactItemIndex - prevItem1;
			if (prevItem1 >= 0 && prevItem1 < count) {
				prevVal = axis.getScaledValue(prevItem1, scalerParams) + offset;

			} else {
				prevVal = NaN;
			}

			if (nextItem1 >= 0 && nextItem1 < count) {
				nextVal = axis.getScaledValue(nextItem1, scalerParams) + offset;

			} else {
				nextVal = NaN;
			}

			if ($.ig.util.isNaN(prevVal) && !$.ig.util.isNaN(nextVal)) {
				prevVal = nextVal;
			}

			if ($.ig.util.isNaN(nextVal) && !$.ig.util.isNaN(prevVal)) {
				nextVal = prevVal;
			}

			if (index >= 0 && index < count) {
				indVal = axis.getScaledValue(index, scalerParams) + offset;
			}

		}

		var worldVal = prevVal + inter * (nextVal - prevVal);
		return Math.abs(indVal - worldVal);
	}

	, 
	usesPresortedValueColumn: function () {

			return false;
	}

	, 
	getSeriesValueHelper: function (column, world, axis, pars, offset, getExactUnsortedIndex, useInterpolation, skipUnknowns) {
		if (column == null) {
			return NaN;
		}

		var presorted = this.usesPresortedValueColumn();
		var prevItem = this.getPreviousOrExactIndexHelper(world, skipUnknowns, axis, getExactUnsortedIndex, column);
		var nextItem = this.getNextOrExactIndexHelper(world, skipUnknowns, axis, getExactUnsortedIndex, column);
		var distToPrev = this.getDistanceToIndex(world, prevItem, axis, pars, offset);
		var distToNext = this.getDistanceToIndex(world, nextItem, axis, pars, offset);
		var unsortedPrevItem = prevItem;
		var unsortedNextItem = nextItem;
		var isSorting = axis.isSorting();
		if (isSorting && !presorted) {
			var sorting = axis;
			if (prevItem >= 0 && prevItem < sorting.sortedIndices().count()) {
				prevItem = sorting.sortedIndices().__inner[prevItem];
			}

			if (nextItem >= 0 && prevItem < sorting.sortedIndices().count()) {
				nextItem = sorting.sortedIndices().__inner[nextItem];
			}

		}

		var p = distToPrev / (distToNext + distToPrev);
		if (distToPrev == 0) {
			p = 0;
		}

		if (distToNext == 0) {
			p = 1;
		}

		if (!useInterpolation) {
			if (distToNext <= distToPrev) {
				if (nextItem >= 0 && nextItem < column.count()) {
					return column.item(nextItem);
				}


			} else {
				if (prevItem >= 0 && prevItem < column.count()) {
					return column.item(prevItem);
				}

			}

			return NaN;
		}

		return this.getInterpolatedSeriesValue(p, column, prevItem, nextItem, unsortedPrevItem, unsortedNextItem, offset, isSorting);
	}

	, 
	getInterpolatedSeriesValue: function (p, column, prevItem, nextItem, unsortedPrevItem, unsortedNextItem, offset, isSorting) {
		var prevValue = NaN;
		if (prevItem >= 0 && prevItem < column.count()) {
			prevValue = column.item(prevItem);
		}

		var nextValue = NaN;
		if (nextItem >= 0 && nextItem < column.count()) {
			nextValue = column.item(nextItem);
		}

		if (unsortedNextItem == 0) {
			return nextValue;
		}

		if (unsortedPrevItem == column.count() - 1) {
			return prevValue;
		}

		if ($.ig.util.isNaN(nextValue) && offset != 0 && p <= 0.5 && !isSorting) {
			return prevValue;
		}

		if ($.ig.util.isNaN(prevValue) && offset != 0 && p >= 0.5 && !isSorting) {
			return nextValue;
		}

		return prevValue * (1 - p) + nextValue * p;
	}

	, 
	getPreviousOrExactIndexHelper: function (world, skipUnknowns, indexAxis, getExactUnsortedIndex, valueColumn) {
		if (indexAxis == null) {
			return -1;
		}

		var isSorting = indexAxis.isSorting();
		var preSorted = this.usesPresortedValueColumn();
		var sorting = null;
		if (isSorting) {
			sorting = indexAxis;
		}

		var itemIndex = -1;
		var prevItem = -1;
		var nextItem = -1;
		if (isSorting) {
			itemIndex = getExactUnsortedIndex(world);
			if ($.ig.util.isNaN(itemIndex)) {
				return -1;
			}

			prevItem = $.ig.truncate(Math.floor(itemIndex));
			nextItem = $.ig.truncate(Math.ceil(itemIndex));

		} else {
			itemIndex = this.getExactItemIndex(world);
			if ($.ig.util.isNaN(itemIndex)) {
				return -1;
			}

			prevItem = $.ig.truncate(Math.floor(itemIndex));
			nextItem = $.ig.truncate(Math.ceil(itemIndex));
		}

		if (valueColumn == null) {
			return -1;
		}

		if (prevItem < 0 || prevItem > valueColumn.count() - 1) {
			return -1;
		}

		if (!skipUnknowns) {
			return prevItem;
		}

		var currVal = NaN;
		if (isSorting && !preSorted) {
			if (prevItem < sorting.sortedIndices().count() && sorting.sortedIndices().__inner[prevItem] < valueColumn.count()) {
				currVal = valueColumn.item(sorting.sortedIndices().__inner[prevItem]);
			}


		} else {
			currVal = valueColumn.item(prevItem);
		}

		while ($.ig.util.isNaN(currVal)) {
			prevItem--;
			if (prevItem < 0 || prevItem > valueColumn.count() - 1) {
				return -1;
			}

			if (isSorting && !preSorted) {
				currVal = valueColumn.item(sorting.sortedIndices().__inner[prevItem]);

			} else {
				currVal = valueColumn.item(prevItem);
			}


		}
		return prevItem;
	}

	, 
	getNextOrExactIndexHelper: function (world, skipUnknowns, indexAxis, getExactUnsortedIndex, valueColumn) {
		var preSorted = this.usesPresortedValueColumn();
		var isSorting = indexAxis.isSorting();
		var sorting = null;
		if (isSorting) {
			sorting = indexAxis;
		}

		var itemIndex = -1;
		var prevItem = -1;
		var nextItem = -1;
		if (isSorting) {
			itemIndex = getExactUnsortedIndex(world);
			if ($.ig.util.isNaN(itemIndex)) {
				return -1;
			}

			prevItem = $.ig.truncate(Math.floor(itemIndex));
			nextItem = $.ig.truncate(Math.ceil(itemIndex));

		} else {
			itemIndex = this.getExactItemIndex(world);
			if ($.ig.util.isNaN(itemIndex)) {
				return -1;
			}

			prevItem = $.ig.truncate(Math.floor(itemIndex));
			nextItem = $.ig.truncate(Math.ceil(itemIndex));
		}

		if (valueColumn == null) {
			return -1;
		}

		if (nextItem < 0 || nextItem > valueColumn.count() - 1) {
			return -1;
		}

		if (!skipUnknowns) {
			return nextItem;
		}

		var currVal = NaN;
		if (isSorting && !preSorted) {
			if (nextItem < sorting.sortedIndices().count() && sorting.sortedIndices().__inner[nextItem] < valueColumn.count()) {
				currVal = valueColumn.item(sorting.sortedIndices().__inner[nextItem]);
			}


		} else {
			currVal = valueColumn.item(nextItem);
		}

		while ($.ig.util.isNaN(currVal)) {
			nextItem++;
			if (nextItem < 0 || nextItem > valueColumn.count() - 1) {
				return -1;
			}

			if (isSorting && !preSorted) {
				currVal = valueColumn.item(sorting.sortedIndices().__inner[nextItem]);

			} else {
				currVal = valueColumn.item(nextItem);
			}


		}
		return nextItem;
	}

	, 
	getExactUnsortedItemIndexHelper: function (world, axis) {
		var windowRect = this.view().windowRect();
		var viewportRect = this.view().viewport();
		if (windowRect.isEmpty() || viewportRect.isEmpty()) {
			return -1;
		}

		var sorting = null;
		if (axis.isSorting()) {
			sorting = axis;
		}

		var p = new $.ig.ScalerParams(windowRect, viewportRect, axis.isInverted());
		if (this.seriesViewer() == null) {
			return -1;
		}

		p._effectiveViewportRect = this.getEffectiveViewport(this.view());
		var axisValue = 0;
		if (axis.isVertical()) {
			var top = axis.getUnscaledValue(viewportRect.top(), p);
			var bottom = axis.getUnscaledValue(viewportRect.bottom(), p);
			var windowY = (world.__y - windowRect.top()) / windowRect.height();
			axisValue = top + ((bottom - top) * windowY);

		} else {
			var left = axis.getUnscaledValue(viewportRect.left(), p);
			var right = axis.getUnscaledValue(viewportRect.right(), p);
			var windowX = (world.__x - windowRect.left()) / windowRect.width();
			axisValue = left + ((right - left) * windowX);
		}

		if (axis.isDateTime()) {
		}

		var exactItemIndex = sorting.getExactUnsortedIndexClosestToUnscaledValue(axisValue);
		return exactItemIndex;
	}

	, 
	getPreviousOrExactIndex: function (world, skipUnknowns) {
		return -1;
	}

	, 
	getNextOrExactIndex: function (world, skipUnknowns) {
		return -1;
	}

	, 
	getSeriesValue: function (world, useInterpolation, skipUnknowns) {
		return NaN;
	}

	, 
	getSeriesValuePosition: function (world, useInterpolation, skipUnknowns) {
		return {__x: NaN, __y: NaN, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
	}

	, 
	getSeriesValuePositionHelper: function (world, useInterpolation, skipUnknowns, offset, valueAxis, indexAxis, getSeriesValue, getPrevious, getNext) {
		if (valueAxis == null || indexAxis == null || this.view() == null || this.view().windowRect().isEmpty() || this.view().viewport().isEmpty()) {
			return {__x: NaN, __y: NaN, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		}

		var valueParams = new $.ig.ScalerParams(this.view().windowRect(), this.view().viewport(), valueAxis.isInverted());
		valueParams._effectiveViewportRect = this.getEffectiveViewport(this.view());
		var indexPos;
		if (indexAxis.isVertical()) {
			indexPos = world.__y;
			indexPos = this.view().viewport().top() + this.view().viewport().height() * (indexPos - this.view().windowRect().top()) / this.view().windowRect().height();

		} else {
			indexPos = world.__x;
			indexPos = this.view().viewport().left() + this.view().viewport().width() * (indexPos - this.view().windowRect().left()) / this.view().windowRect().width();
		}

		if (!useInterpolation && indexAxis != null) {
			var prevItem;
			var nextItem;
			if (getPrevious != null) {
				prevItem = getPrevious(world, skipUnknowns);

			} else {
				prevItem = this.getPreviousOrExactIndex(world, skipUnknowns);
			}

			if (getNext != null) {
				nextItem = getNext(world, skipUnknowns);

			} else {
				nextItem = this.getNextOrExactIndex(world, skipUnknowns);
			}

			var indexParams = new $.ig.ScalerParams(this.view().windowRect(), this.view().viewport(), indexAxis.isInverted());
			indexParams._effectiveViewportRect = this.seriesViewer().viewportRect();
			var distToPrev = this.getDistanceToIndex(world, prevItem, indexAxis, indexParams, offset);
			var distToNext = this.getDistanceToIndex(world, nextItem, indexAxis, indexParams, offset);
			var nextVal = nextItem;
			var prevVal = prevItem;
			if (indexAxis.isSorting()) {
				var sorting = indexAxis;
				if (nextVal >= 0 && nextVal < sorting.sortedIndices().count()) {
					nextVal = sorting.getUnscaledValueAt(sorting.sortedIndices().__inner[$.ig.truncate(nextVal)]);
				}

				if (prevVal >= 0 && prevVal < sorting.sortedIndices().count()) {
					prevVal = sorting.getUnscaledValueAt(sorting.sortedIndices().__inner[$.ig.truncate(prevVal)]);
				}

			}

			if ((distToNext + distToPrev) != 0) {
				var rat = distToNext / (distToPrev + distToNext);
				if (Math.abs(rat - 0.5) < $.ig.Series.prototype._cLOSENESS_FACTOR) {
					distToNext = distToPrev;
				}

			}

			if (distToNext <= distToPrev) {
				indexPos = indexAxis.getScaledValue(nextVal, indexParams) + offset;

			} else {
				indexPos = indexAxis.getScaledValue(prevVal, indexParams) + offset;
			}


		} else {
			if (indexAxis.isCategory() && !indexAxis.isDateTime() && (indexAxis).categoryMode() != $.ig.CategoryMode.prototype.mode0) {
				var groupWidth = 0.5 * (indexAxis).getCategorySize(this.view().windowRect(), this.view().viewport());
				if (this.isVertical()) {
					groupWidth = groupWidth * -1;
				}

				if (indexAxis.isInverted()) {
					groupWidth = groupWidth * -1;
				}

				indexPos -= groupWidth;
				indexPos += offset;
			}

		}

		var val;
		if (getSeriesValue != null) {
			val = getSeriesValue(world, useInterpolation, skipUnknowns);

		} else {
			val = this.getSeriesValue(world, useInterpolation, skipUnknowns);
		}

		var valuePos = valueAxis.getScaledValue(val, valueParams);
		if (indexAxis.isVertical()) {
			return {__x: valuePos, __y: indexPos, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};

		} else {
			return {__x: indexPos, __y: valuePos, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		}

	}

	, 
	getSeriesHighValue: function (world, useInterpolation, skipUnknowns) {
		return this.getSeriesValue(world, useInterpolation, skipUnknowns);
	}

	, 
	getSeriesHighValuePosition: function (world, useInterpolation, skipUnknowns) {
		return this.getSeriesValuePosition(world, useInterpolation, skipUnknowns);
	}

	, 
	getSeriesLowValue: function (world, useInterpolation, skipUnknowns) {
		return this.getSeriesValue(world, useInterpolation, skipUnknowns);
	}

	, 
	getSeriesLowValuePosition: function (world, useInterpolation, skipUnknowns) {
		return this.getSeriesValuePosition(world, useInterpolation, skipUnknowns);
	}

	, 
	getSeriesValuePositionFromSeriesPixel: function (mouse, useInterpolation, skipUnknowns) {
		var world = this.toWorldPosition(mouse);
		return this.getSeriesValuePosition(world, useInterpolation, skipUnknowns);
	}

	, 
	getSeriesValueFromSeriesPixel: function (mouse, useInterpolation, skipUnknowns) {
		var world = this.toWorldPosition(mouse);
		return this.getSeriesValue(world, useInterpolation, skipUnknowns);
	}

	, 
	getSeriesHighValuePositionFromSeriesPixel: function (mouse, useInterpolation, skipUnknowns) {
		var world = this.toWorldPosition(mouse);
		return this.getSeriesHighValuePosition(world, useInterpolation, skipUnknowns);
	}

	, 
	getSeriesHighValueFromSeriesPixel: function (mouse, useInterpolation, skipUnknowns) {
		var world = this.toWorldPosition(mouse);
		return this.getSeriesHighValue(world, useInterpolation, skipUnknowns);
	}

	, 
	getSeriesLowValuePositionFromSeriesPixel: function (mouse, useInterpolation, skipUnknowns) {
		var world = this.toWorldPosition(mouse);
		return this.getSeriesLowValuePosition(world, useInterpolation, skipUnknowns);
	}

	, 
	getSeriesLowValueFromSeriesPixel: function (mouse, useInterpolation, skipUnknowns) {
		var world = this.toWorldPosition(mouse);
		return this.getSeriesLowValue(world, useInterpolation, skipUnknowns);
	}

	, 
	getItemIndexFromSeriesPixel: function (mouse) {
		var world = this.toWorldPosition(mouse);
		return this.getItemIndex(world);
	}

	, 
	getExactItemIndexFromSeriesPixel: function (mouse) {
		var world = this.toWorldPosition(mouse);
		return this.getExactItemIndex(world);
	}

	, 
	getItemFromSeriesPixel: function (mouse) {
		var world = this.toWorldPosition(mouse);
		return this.getItem(world);
	}
	, 
	propertyChanged: null, 
	propertyUpdated: null
	, 
	raisePropertyChanged: function (propertyName, oldValue, newValue) {
		if (this.propertyChanged != null) {
			this.propertyChanged(this, new $.ig.PropertyChangedEventArgs(propertyName));
		}

		if (this.propertyUpdated != null) {
			this.propertyUpdated(this, new $.ig.PropertyUpdatedEventArgs(propertyName, oldValue, newValue));
		}

	}

	, 
	hasMarkers: function () {

			return false;
	}

	, 
	getActualMarkerBrush: function () {
		return null;
	}

	, 
	getActualMarkerOutlineBrush: function () {
		return null;
	}

	, 
	getActualMarkerTemplate: function () {
		return null;
	}

	, 
	toWorldPosition: function (seriesPoint) {
		var viewportRect = this.view().viewport();
		var windowRect = this.view().windowRect();
		var world = {__x: windowRect.left() + windowRect.width() * (seriesPoint.__x - viewportRect.left()) / viewportRect.width(), __y: windowRect.top() + windowRect.height() * (seriesPoint.__y - viewportRect.top()) / viewportRect.height(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		return world;
	}

	, 
	fromWorldPosition: function (world) {
		var viewportRect = this.view().viewport();
		var windowRect = this.view().windowRect();
		var seriesX = viewportRect.left() + (world.__x - windowRect.left()) / windowRect.width() * viewportRect.width();
		var seriesY = viewportRect.top() + (world.__y - windowRect.top()) / windowRect.height() * viewportRect.height();
		return {__x: seriesX, __y: seriesY, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
	}

	, 
	item: function (sender, point) {
		var dataContext = this.view().getDataContextFromSender(sender);
		var item = dataContext != null ? dataContext.item() : null;
		if (item == null) {
			var viewportRect = this.view().viewport();
			var windowRect = this.view().windowRect();
			var world = this.toWorldPosition(point);
			item = this.getItem(world);
		}

		return item;
	}

	, 
	scrollIntoView: function (item) {
		return false;
	}

	, 
	getRange: function (axis) {
		return new $.ig.AxisRange(NaN, NaN);
	}

	, 
	renderSeries: function (animate) {
		this.skipPrepare(false);
		if (this.seriesViewer() != null) {
			this.seriesViewer().chartContentManager().refresh($.ig.ChartContentType.prototype.series, this, this.contentInfo(), animate);
			if (this.renderRequested != null) {
				var args = new $.ig.RenderRequestedEventArgs();
				args.animate(animate);
				this.renderRequested(this, args);
				animate = args.animate();
			}

		}

	}
	, 
	renderRequested: null
	, 
	doRenderSeries: function (animate) {
		this.renderSeriesOverride(animate);
		this.skipPrepare(false);
	}

	, 
	renderSeriesOverride: function (animate) {
		if (this.transitionInViable() && !this.shouldTransitionIn()) {
			this.transitionInViable(false);
		}

	}

	, 
	_transitionInIsInProgress: false,
	transitionInIsInProgress: function (value) {
		if (arguments.length === 1) {
			this._transitionInIsInProgress = value;
			return value;
		} else {
			return this._transitionInIsInProgress;
		}
	}

	, 
	checkTransitionInterrupted: function () {
		if (this.transitionInIsInProgress() && !this.transitionInViable()) {
			this.animator().intervalMilliseconds($.ig.truncate(Math.max(this.getTotalMilliseconds(), this.getTotalTransitionInMilliseconds())));
			this.clearSpeedModifiers();
		}

	}

	, 
	clearSpeedModifiers: function () {
	}

	, 
	_thumbnailView: null,
	thumbnailView: function (value) {
		if (arguments.length === 1) {
			this._thumbnailView = value;
			return value;
		} else {
			return this._thumbnailView;
		}
	}

	, 
	renderThumbnail: function (viewportRect, surface) {
		if (this.thumbnailView() == null) {
			this.thumbnailView(this.createView());
			this.thumbnailView().isThumbnailView(true);
			if (this.seriesViewer() != null) {
				this.seriesViewer().thumbnailCanvasRenderScheduler().register(this.thumbnailView());
				this.thumbnailView().currentScheduler(this.seriesViewer().thumbnailCanvasRenderScheduler());
			}

			this.thumbnailView().onInit();
		}

		this.thumbnailView().viewport(viewportRect);
	}
	, 
	__alternateViews: null

	, 
	alternateViews: function () {

			return this.__alternateViews;
	}

	, 
	renderAlternateView: function (viewportRect, windowRect, surface, viewIdentifier, effectiveScalingRatio) {
		this.ensureAlternateView(viewportRect, windowRect, viewIdentifier, effectiveScalingRatio);
	}

	, 
	ensureAlternateView: function (viewportRect, windowRect, viewIdentifier, effectiveScalingRatio) {
		var $self = this;
		var view;
		if (!(function () { var $ret = $self.__alternateViews.tryGetValue(viewIdentifier, view); view = $ret.p1; return $ret.ret; }())) {
			view = $self.createView();
			view.isThumbnailView(true);
			view.isAlternateView(true);
			if ($self.seriesViewer() != null) {
				view.currentScheduler($self.seriesViewer().alternateViewRenderScheduler());
				$self.seriesViewer().alternateViewRenderScheduler().register(view);
			}

			view.onInit();
			view.alternateViewIdentifier(viewIdentifier);
			$self.__alternateViews.item(viewIdentifier, view);
		}

		view.scalingRatioOverride(effectiveScalingRatio);
		view.viewport(viewportRect);
		view.alternateWindow(windowRect);
	}

	, 
	getEffectiveViewport: function (view) {
		if (view.isAlternateView() || this.seriesViewer() == null) {
			return view.viewport();
		}

		return this.seriesViewer().effectiveViewport();
	}

	, 
	removeAllAlternateViews: function () {
		this.removeAllAlternateViews1(null);
	}

	, 
	removeAllAlternateViews1: function (oldViewer) {
		var toRemove = new $.ig.List$1(String, 0);
		var en = this.__alternateViews.keys().getEnumerator();
		while (en.moveNext()) {
			var key = en.current();
			toRemove.add(key);
		}

		for (var i = 0; i < toRemove.count(); i++) {
			this.removeAlternateView1(toRemove.__inner[i], oldViewer);
		}

	}

	, 
	removeAlternateView: function (viewIdentifier) {
		this.removeAlternateView1(viewIdentifier, this.seriesViewer());
	}

	, 
	removeAlternateView1: function (viewIdentifier, oldViewer) {
		var $self = this;
		var view;
		var viewer = oldViewer;
		if (viewer == null) {
			viewer = $self.seriesViewer();
		}

		if ((function () { var $ret = $self.__alternateViews.tryGetValue(viewIdentifier, view); view = $ret.p1; return $ret.ret; }())) {
			if (viewer != null) {
				view.currentScheduler(null);
				viewer.alternateViewRenderScheduler().unRegister(view);
			}

			$self.__alternateViews.remove(viewIdentifier);
		}

	}

	, 
	getViewInfo: function (viewportRect, windowRect) {
		viewportRect = this.view().viewport();
		windowRect = this.view().windowRect();
		return {
			p0: viewportRect, 
			p1: windowRect
		};
	}

	, 
	validateSeries: function (viewportRect, windowRect, view) {
		if ($.ig.util.cast($.ig.SplineFragmentBase.prototype.$type, this) !== null || $.ig.util.cast($.ig.FragmentBase.prototype.$type, this) !== null) {
			return true;
		}

		return this.__visibility == $.ig.Visibility.prototype.visible;
	}

	, 
	clearRendering: function (wipeClean, view) {
		if (wipeClean) {
			this.thumbnailDirty(true);
		}

	}

	, 
	clearAndAbortIfInvalid: function () {
		return this.clearAndAbortIfInvalid1(this.view());
	}

	, 
	clearAndAbortIfInvalid1: function (view) {
		var viewportRect = view.viewport();
		var windowRect = view.windowRect();
		if (!this.validateSeries(viewportRect, windowRect, view)) {
			this.clearRendering(true, view);
			return true;
		}

		return false;
	}

	, 
	onViewportChanged: function (oldViewportRect, newViewportRect) {
		this.view().viewport(newViewportRect);
		this.viewportRectChangedOverride(oldViewportRect, newViewportRect);
		if (this.seriesViewer() != null) {
			this.seriesViewer().chartContentManager().viewportChanged($.ig.ChartContentType.prototype.series, this, this.contentInfo(), newViewportRect);
		}

	}

	, 
	windowRectChangedOverride: function (oldWindowRect, newWindowRect) {
	}

	, 
	viewportRectChangedOverride: function (oldViewportRect, newViewportRect) {
	}

	, 
	_contentInfo: null,
	contentInfo: function (value) {
		if (arguments.length === 1) {
			this._contentInfo = value;
			return value;
		} else {
			return this._contentInfo;
		}
	}
	, 
	__thumbnailDirty: false

	, 
	thumbnailDirty: function (value) {
		if (arguments.length === 1) {

			this.__thumbnailDirty = value;
			return value;
		} else {

			return this.__thumbnailDirty;
		}
	}

	, 
	forceIndexUpdate: function (other) {
		other.doUpdateIndexedProperties();
	}

	, 
	notifyThumbnailDataChanged: function () {
		this.skipThumbnailPrepare(false);
		this.thumbnailDirty(true);
		if (this.seriesViewer() != null) {
			this.seriesViewer().notifyThumbnailDataChanged();
		}

	}

	, 
	notifyThumbnailAppearanceChanged: function () {
		this.skipThumbnailPrepare(false);
		this.thumbnailDirty(true);
		if (this.seriesViewer() != null) {
			this.seriesViewer().notifyThumbnailAppearanceChanged();
		}

	}

	, 
	isIndexed: function () {

			return true;
	}

	, 
	isUsableInLegend: function () {

			return true;
	}

	, 
	onIsDropShadowEnabledChanged: function () {
		this.view().handleIsDropShadowEnabledChanged();
	}

	, 
	notifyVisualPropertiesChanged: function () {
		this.onVisualPropertiesChanged();
	}

	, 
	onVisualPropertiesChanged: function () {
		this.view().onVisualPropertiesChanged();
		this.onVisualPropertiesChangedOverride(false);
	}

	, 
	onVisualPropertiesChangedImmediate: function () {
		this.view().onVisualPropertiesChanged();
		this.onVisualPropertiesChangedOverride(true);
	}

	, 
	_skipPrepare: false,
	skipPrepare: function (value) {
		if (arguments.length === 1) {
			this._skipPrepare = value;
			return value;
		} else {
			return this._skipPrepare;
		}
	}

	, 
	_skipThumbnailPrepare: false,
	skipThumbnailPrepare: function (value) {
		if (arguments.length === 1) {
			this._skipThumbnailPrepare = value;
			return value;
		} else {
			return this._skipThumbnailPrepare;
		}
	}

	, 
	onVisualPropertiesChangedOverride: function (immediate) {
		if (this.contentInfo() == null || this.contentInfo().isDirty()) {
			return;
		}

		var viewport = this.view().viewport();
		var window = this.view().windowRect();
		var mainViewValid = this.validateSeries(viewport, window, this.view());
		var thumbnailValid = this.seriesViewer() != null && this.seriesViewer().isThumbnailRequired() && this.thumbnailView() != null && this.validateSeries(this.thumbnailView().viewport(), this.thumbnailView().windowRect(), this.thumbnailView());
		if (mainViewValid) {
			if (immediate) {
				this.skipPrepare(true);
				this.doRenderSeries(false);

			} else {
				this.renderSeries(false);
				this.skipPrepare(true);
			}

		}

		if (thumbnailValid) {
			if (!this.thumbnailDirty()) {
				this.notifyThumbnailAppearanceChanged();
				this.skipThumbnailPrepare(true);
			}

		}

	}
	, 
	__transitionInViable: false

	, 
	transitionInViable: function (value) {
		if (arguments.length === 1) {

			this.__transitionInViable = value;
			return value;
		} else {

			return this.__transitionInViable;
		}
	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		switch (propertyName) {
			case $.ig.Series.prototype.syncLinkPropertyName:
				if ($.ig.util.cast($.ig.SyncLink.prototype.$type, oldValue) != null) {
					($.ig.util.cast($.ig.SyncLink.prototype.$type, oldValue)).propertyUpdated = $.ig.Delegate.prototype.remove(($.ig.util.cast($.ig.SyncLink.prototype.$type, oldValue)).propertyUpdated, this._seriesViewer_PropertyUpdated);
					this.releaseItemsSource($.ig.util.cast($.ig.IFastItemsSourceProvider.prototype.$type, oldValue));
				}

				if ($.ig.util.cast($.ig.SyncLink.prototype.$type, newValue) != null) {
					($.ig.util.cast($.ig.SyncLink.prototype.$type, newValue)).propertyUpdated = $.ig.Delegate.prototype.combine(($.ig.util.cast($.ig.SyncLink.prototype.$type, newValue)).propertyUpdated, this._seriesViewer_PropertyUpdated);
					this.registerItemsSource($.ig.util.cast($.ig.IFastItemsSourceProvider.prototype.$type, newValue));
				}

				if (this.index() == -1) {
					this.index($.ig.XamDataChart.prototype.findSeriesIndex(this));
				}

				break;
			case $.ig.XamDataChart.prototype.brushesPropertyName:
			case $.ig.XamDataChart.prototype.markerOutlinesPropertyName:
			case $.ig.XamDataChart.prototype.markerBrushesPropertyName:
			case $.ig.XamDataChart.prototype.outlinesPropertyName:
				this.doUpdateIndexedProperties();
				break;
			case $.ig.Series.prototype.seriesViewerPropertyName:
				if ($.ig.util.cast($.ig.SeriesViewer.prototype.$type, oldValue) != null) {
					($.ig.util.cast($.ig.SeriesViewer.prototype.$type, oldValue)).windowRectChanged = $.ig.Delegate.prototype.remove(($.ig.util.cast($.ig.SeriesViewer.prototype.$type, oldValue)).windowRectChanged, this._seriesViewer_WindowRectChanged);
					($.ig.util.cast($.ig.SeriesViewer.prototype.$type, oldValue)).series().collectionChanged = $.ig.Delegate.prototype.remove(($.ig.util.cast($.ig.SeriesViewer.prototype.$type, oldValue)).series().collectionChanged, this._seriesViewer_SeriesCollectionChanged);
					($.ig.util.cast($.ig.SeriesViewer.prototype.$type, oldValue)).propertyUpdated = $.ig.Delegate.prototype.remove(($.ig.util.cast($.ig.SeriesViewer.prototype.$type, oldValue)).propertyUpdated, this._seriesViewer_PropertyUpdated);
					($.ig.util.cast($.ig.SeriesViewer.prototype.$type, oldValue)).chartContentManager().unsubscribe($.ig.ChartContentType.prototype.series, this);
					this.removeAllAlternateViews1(oldValue);
					this.view().detachFromChart(oldValue);
				}

				if ($.ig.util.cast($.ig.SeriesViewer.prototype.$type, newValue) != null) {
					($.ig.util.cast($.ig.SeriesViewer.prototype.$type, newValue)).windowRectChanged = $.ig.Delegate.prototype.combine(($.ig.util.cast($.ig.SeriesViewer.prototype.$type, newValue)).windowRectChanged, this._seriesViewer_WindowRectChanged);
					($.ig.util.cast($.ig.SeriesViewer.prototype.$type, newValue)).series().collectionChanged = $.ig.Delegate.prototype.combine(($.ig.util.cast($.ig.SeriesViewer.prototype.$type, newValue)).series().collectionChanged, this._seriesViewer_SeriesCollectionChanged);
					($.ig.util.cast($.ig.SeriesViewer.prototype.$type, newValue)).propertyUpdated = $.ig.Delegate.prototype.combine(($.ig.util.cast($.ig.SeriesViewer.prototype.$type, newValue)).propertyUpdated, this._seriesViewer_PropertyUpdated);
					this.contentInfo(($.ig.util.cast($.ig.SeriesViewer.prototype.$type, newValue)).chartContentManager().subscribe($.ig.ChartContentType.prototype.series, this, this.doRenderSeries.runOn(this)));
					this.view().attachToChart(newValue);
					this.updateActualAreaFillOpacity();
					this._uniqueIndex = this.seriesViewer().getNextUniqueIndex();
				}

				if (this.index() == -1 || newValue == null) {
					this.index($.ig.XamDataChart.prototype.findSeriesIndex(this));
				}

				this.actualLegend(this.findActualLegend());
				this.assertLegendItems1($.ig.util.cast($.ig.XamDataChart.prototype.$type, oldValue), $.ig.util.cast($.ig.XamDataChart.prototype.$type, newValue));
				break;
			case $.ig.Series.prototype.titlePropertyName:
				if (this.view() != null) {
					this.view().onTitlePropertyChanged();
				}

				break;
			case $.ig.Series.prototype.legendItemBadgeTemplatePropertyName:
			case $.ig.Series.prototype.legendItemTemplatePropertyName:
				this.view().updateLegendItemVisual();
				break;
			case $.ig.Series.prototype.brushPropertyName:
			case $.ig.Series.prototype.outlinePropertyName:
			case $.ig.Series.prototype.dashArrayPropertyName:
			case $.ig.Series.prototype.dashCapPropertyName:
				this.doUpdateIndexedProperties();
				this.onVisualPropertiesChanged();
				break;
			case $.ig.Series.prototype.indexPropertyName:
				if ($.ig.util.getValue(oldValue) != $.ig.util.getValue(newValue)) {
					this.doUpdateIndexedProperties();
					this.onVisualPropertiesChanged();
				}

				break;
			case "RadiusX":
			case "RadiusY":
			case "RoundedCornersLocation":
				this.onVisualPropertiesChanged();
				break;
			case $.ig.Series.prototype._areaFillOpacityPropertyName:
				this.updateActualAreaFillOpacity();
				this.onVisualPropertiesChanged();
				break;
			case $.ig.Series.prototype.startCapPropertyName:
			case $.ig.Series.prototype.endCapPropertyName:
			case $.ig.Series.prototype.miterLimitPropertyName:
				this.onVisualPropertiesChanged();
				break;
			case $.ig.Series.prototype.isDropShadowEnabledPropertyName:
				this.onIsDropShadowEnabledChanged();
				this.onVisualPropertiesChanged();
				break;
			case $.ig.Series.prototype.useSingleShadowPropertyName:
			case $.ig.Series.prototype.shadowColorPropertyName:
			case $.ig.Series.prototype.shadowBlurPropertyName:
			case $.ig.Series.prototype.shadowOffsetXPropertyName:
			case $.ig.Series.prototype.shadowOffsetYPropertyName:
				this.onVisualPropertiesChanged();
				break;
			case $.ig.Series.prototype.actualBrushPropertyName:
			case $.ig.Series.prototype.actualOutlinePropertyName:
			case $.ig.Series.prototype.thicknessPropertyName:
				this.onVisualPropertiesChanged();
				this.view().updateLegendItemVisual();
				if (this.toolTip() != null) {
					this.view().updateToolTipValue(this.toolTip());
				}

				break;
			case "Visibility":
				this.view().visibilityChanged();
				break;
			case $.ig.Series.prototype.itemsSourcePropertyName:
				if (this.syncLink() != null) {
					this.registerItemsSource(this.syncLink());
				}

				break;
			case $.ig.Series.prototype.fastItemsSourcePropertyName:
				if (oldValue != newValue && newValue != null) {
					this.transitionInViable(true);
				}

				this.notifyThumbnailDataChanged();
				if ($.ig.util.cast($.ig.IFastItemsSource.prototype.$type, oldValue) != null) {
					($.ig.util.cast($.ig.IFastItemsSource.prototype.$type, oldValue)).event = $.ig.Delegate.prototype.remove(($.ig.util.cast($.ig.IFastItemsSource.prototype.$type, oldValue)).event, this._fastItemsSource_Event);
				}

				if ($.ig.util.cast($.ig.IFastItemsSource.prototype.$type, newValue) != null) {
					($.ig.util.cast($.ig.IFastItemsSource.prototype.$type, newValue)).event = $.ig.Delegate.prototype.combine(($.ig.util.cast($.ig.IFastItemsSource.prototype.$type, newValue)).event, this._fastItemsSource_Event);
				}

				break;
			case $.ig.XamDataChart.prototype.legendPropertyName:
				if (newValue != null) {
					if (sender == this) {
						($.ig.util.cast($.ig.LegendBase.prototype.$type, newValue)).seriesOwner(this);

					} else if ($.ig.util.cast($.ig.XamDataChart.prototype.$type, sender) !== null) {
						($.ig.util.cast($.ig.LegendBase.prototype.$type, newValue)).chartOwner(sender);
					}


				}

				this.actualLegend(this.findActualLegend());
				break;
			case $.ig.Series.prototype.actualLegendPropertyName:
				this.assertLegendItems($.ig.util.cast($.ig.LegendBase.prototype.$type, oldValue), $.ig.util.cast($.ig.LegendBase.prototype.$type, newValue));
				break;
			case $.ig.Series.prototype.legendItemPropertyName:
				this.assertLegendItems2($.ig.util.cast($.ig.Control.prototype.$type, oldValue), $.ig.util.cast($.ig.Control.prototype.$type, newValue));
				break;
			case $.ig.Series.prototype.legendItemVisibilityPropertyName:
				this.view().onLegendItemVisibilityChanged();
				break;
			case $.ig.Series.prototype.toolTipPropertyName:
				this.view().updateToolTipValue(this.toolTip());
				break;
			case $.ig.XamDataChart.prototype.crosshairPointPropertyName:
				if (this.seriesViewer() != null) {
					if (!this.disableCursorEvents()) {
						this.seriesViewer().raiseSeriesCursorMouseMove(this, this.getItem(this.seriesViewer().crosshairPoint()));
					}

				}

				break;
			case $.ig.Series.prototype.resolutionPropertyName:
				this.renderSeries(false);
				this.notifyThumbnailAppearanceChanged();
				break;
			case $.ig.Series.prototype.transitionDurationPropertyName:
			case $.ig.Series.prototype.transitionEasingFunctionPropertyName:
				this.animator().stop();
				this.animator().intervalMilliseconds(this.transitionDuration());
				this.animator().easingFunction(this.transitionEasingFunction());
				this.renderSeries(false);
				break;
			case $.ig.Series.prototype.discreteLegendItemTemplatePropertyName:
				this.renderSeries(false);
				break;
			case $.ig.Series.prototype.visibilityProxyPropertyName:
				if (oldValue != newValue) {
					this.renderSeries(false);
				}

				this.notifyThumbnailAppearanceChanged();
				this.view().visibilityChanged();
				break;
			case $.ig.Series.prototype.isHighlightingEnabledPropertyName:
				this.actualIsHighlightingEnabled(this.getIsHighlightingEnabled());
				this.renderSeries(false);
				break;
		}

	}

	, 
	getIsHighlightingEnabled: function () {
		return this.isHighlightingEnabled() && this.isHighlightingSupported();
	}

	, 
	isHighlightingSupported: function () {

			return false;
	}

	, 
	_disableCursorEvents: false,
	disableCursorEvents: function (value) {
		if (arguments.length === 1) {
			this._disableCursorEvents = value;
			return value;
		} else {
			return this._disableCursorEvents;
		}
	}

	, 
	disableCursorEventsForSeries: function (series) {
		series.disableCursorEvents(true);
	}

	, 
	syncLink: function (value) {
		if (arguments.length === 1) {

			if (this.syncLink() != value) {
				var oldDataChart = this.syncLink();
				this._syncLink = value;
				this.raisePropertyChanged($.ig.Series.prototype.syncLinkPropertyName, oldDataChart, this.syncLink());
			}

			return value;
		} else {

			return this._syncLink;
		}
	}
	, 
	_syncLink: null

	, 
	seriesViewer: function (value) {
		if (arguments.length === 1) {

			if (this.seriesViewer() != value) {
				var oldChart = this.seriesViewer();
				this.__seriesViewer = value;
				this.raisePropertyChanged($.ig.Series.prototype.seriesViewerPropertyName, oldChart, this.__seriesViewer);
			}

			return value;
		} else {

			return this.__seriesViewer;
		}
	}
	, 
	__seriesViewer: null

	, 
	chart: function (value) {
		if (arguments.length === 1) {

			this.seriesViewer(value);
			return value;
		} else {

			return $.ig.util.cast($.ig.XamDataChart.prototype.$type, this.seriesViewer());
		}
	}
	, 
	_seriesViewer_SeriesCollectionChanged: null
	, 
	_seriesViewer_PropertyUpdated: null
	, 
	_seriesViewer_WindowRectChanged: null

	, 
	itemsSource: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Series.prototype.itemsSourceProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Series.prototype.itemsSourceProperty);
		}
	}

	, 
	fastItemsSource: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Series.prototype.fastItemsSourceProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Series.prototype.fastItemsSourceProperty);
		}
	}
	, 
	_fastItemsSource_Event: null

	, 
	dataUpdatedOverride: function (action, position, count, propertyName) {
	}

	, 
	legend: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Series.prototype.legendProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Series.prototype.legendProperty);
		}
	}

	, 
	legendItem: function (value) {
		if (arguments.length === 1) {

			if (this.legendItem() != value) {
				var oldLegendItem = this.legendItem();
				this._legendItem = value;
				this.raisePropertyChanged($.ig.Series.prototype.legendItemPropertyName, oldLegendItem, this._legendItem);
			}

			return value;
		} else {

			return this._legendItem;
		}
	}
	, 
	_legendItem: null

	, 
	provideLegendItem: function () {
		return this.getLegendItem();
	}

	, 
	getLegendItem: function () {
		var $self = this;
		var legendItem = $.ig.util.cast($.ig.ContentControl.prototype.$type, $self.legendItem());
		var dataTemplate = $self.legendItemTemplate();
		if (dataTemplate != null) {
			if (legendItem == null) {
				legendItem = new $.ig.ContentControl();
			}

			legendItem.content((function () { var $ret = new $.ig.DataContext();
			$ret.series($self);
			$ret.item(null); return $ret;}()));
			legendItem.contentTemplate(dataTemplate);

		} else {
			legendItem = null;
		}

		return legendItem;
	}

	, 
	actualLegend: function (value) {
		if (arguments.length === 1) {

			if (this.actualLegend() != value) {
				var oldActualLegend = this._actualLegend;
				this._actualLegend = value;
				this.raisePropertyChanged($.ig.Series.prototype.actualLegendPropertyName, oldActualLegend, this._actualLegend);
			}

			return value;
		} else {

			return this._actualLegend;
		}
	}
	, 
	_actualLegend: null

	, 
	legendItemVisibility: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Series.prototype.legendItemVisibilityProperty, $.ig.Visibility.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.Series.prototype.legendItemVisibilityProperty));
		}
	}

	, 
	legendItemBadgeTemplate: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Series.prototype.legendItemBadgeTemplateProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Series.prototype.legendItemBadgeTemplateProperty);
		}
	}

	, 
	legendItemTemplate: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Series.prototype.legendItemTemplateProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Series.prototype.legendItemTemplateProperty);
		}
	}

	, 
	discreteLegendItemTemplate: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Series.prototype.discreteLegendItemTemplateProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Series.prototype.discreteLegendItemTemplateProperty);
		}
	}

	, 
	index: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Series.prototype.indexProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.Series.prototype.indexProperty));
		}
	}

	, 
	updateSeriesIndexedPropertiesInternal: function () {
		this.updateIndexedProperties();
	}

	, 
	doUpdateIndexedProperties: function () {
		this.updateIndexedProperties();
	}

	, 
	updateIndexedProperties: function () {
		this.notifyThumbnailAppearanceChanged();
		if (this.index() < 0) {
			return;
		}

		if (this.brush() != null) {
			this.view().resetActualBrush();
			this.view().bindActualToUserBrush();

		} else {
			this.actualBrush(this.seriesViewer() == null ? null : this.seriesViewer().getBrushByIndex(this.index()));
		}

		if (this.outline() != null) {
			this.view().resetActualOutlineBrush();
			this.view().bindActualToUserOutline();

		} else {
			this.actualOutline(this.seriesViewer() == null ? null : this.seriesViewer().getOutlineByIndex(this.index()));
		}

	}

	, 
	transitionEasingFunction: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Series.prototype.transitionEasingFunctionProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Series.prototype.transitionEasingFunctionProperty);
		}
	}

	, 
	transitionInEasingFunction: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Series.prototype.transitionInEasingFunctionProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Series.prototype.transitionInEasingFunctionProperty);
		}
	}

	, 
	_functionOrDurationUpdated: false,
	functionOrDurationUpdated: function (value) {
		if (arguments.length === 1) {
			this._functionOrDurationUpdated = value;
			return value;
		} else {
			return this._functionOrDurationUpdated;
		}
	}

	, 
	transitionDuration: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Series.prototype.transitionDurationProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.Series.prototype.transitionDurationProperty));
		}
	}

	, 
	transitionProgress: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Series.prototype.transitionProgressProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Series.prototype.transitionProgressProperty);
		}
	}

	, 
	animationActive: function () {
		return this.animator().animationActive();
	}

	, 
	startAnimation: function () {
		this.animator().start();
	}

	, 
	resolution: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Series.prototype.resolutionProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Series.prototype.resolutionProperty);
		}
	}

	, 
	title: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Series.prototype.titleProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Series.prototype.titleProperty);
		}
	}

	, 
	brush: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Series.prototype.brushProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Series.prototype.brushProperty);
		}
	}

	, 
	actualBrush: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Series.prototype.actualBrushProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Series.prototype.actualBrushProperty);
		}
	}

	, 
	outline: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Series.prototype.outlineProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Series.prototype.outlineProperty);
		}
	}

	, 
	actualOutline: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Series.prototype.actualOutlineProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Series.prototype.actualOutlineProperty);
		}
	}

	, 
	miterLimit: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Series.prototype.miterLimitProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Series.prototype.miterLimitProperty);
		}
	}

	, 
	thickness: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Series.prototype.thicknessProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Series.prototype.thicknessProperty);
		}
	}

	, 
	dashCap: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Series.prototype.dashCapProperty, $.ig.PenLineCap.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.Series.prototype.dashCapProperty));
		}
	}

	, 
	dashArray: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Series.prototype.dashArrayProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Series.prototype.dashArrayProperty);
		}
	}

	, 
	toolTip: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Series.prototype.toolTipProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Series.prototype.toolTipProperty);
		}
	}

	, 
	isHighlightingEnabled: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Series.prototype.isHighlightingEnabledProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Series.prototype.isHighlightingEnabledProperty);
		}
	}

	, 
	isDropShadowEnabled: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Series.prototype.isDropShadowEnabledProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Series.prototype.isDropShadowEnabledProperty);
		}
	}

	, 
	isDropShadowSupported: function () {

			return true;
	}

	, 
	shadowBlur: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Series.prototype.shadowBlurProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Series.prototype.shadowBlurProperty);
		}
	}

	, 
	shadowColor: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Series.prototype.shadowColorProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Series.prototype.shadowColorProperty);
		}
	}

	, 
	useSingleShadow: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Series.prototype.useSingleShadowProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Series.prototype.useSingleShadowProperty);
		}
	}

	, 
	shadowOffsetX: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Series.prototype.shadowOffsetXProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Series.prototype.shadowOffsetXProperty);
		}
	}

	, 
	shadowOffsetY: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Series.prototype.shadowOffsetYProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Series.prototype.shadowOffsetYProperty);
		}
	}

	, 
	_actualIsHighlightingEnabled: false,
	actualIsHighlightingEnabled: function (value) {
		if (arguments.length === 1) {
			this._actualIsHighlightingEnabled = value;
			return value;
		} else {
			return this._actualIsHighlightingEnabled;
		}
	}

	, 
	areaFillOpacity: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Series.prototype.areaFillOpacityProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Series.prototype.areaFillOpacityProperty);
		}
	}

	, 
	actualAreaFillOpacity: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Series.prototype.actualAreaFillOpacityProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Series.prototype.actualAreaFillOpacityProperty);
		}
	}

	, 
	updateActualAreaFillOpacity: function () {
		var chart = ($.ig.util.cast($.ig.XamDataChart.prototype.$type, this.seriesViewer()));
		if (chart != null) {
			this.actualAreaFillOpacity($.ig.util.isNaN(this.areaFillOpacity()) ? chart.chartView().defaultAreaFillOpacity() : this.areaFillOpacity());
		}

	}
	, 
	__isDefaultToolTipSelected: false

	, 
	isDefaultToolTipSelected: function (value) {
		if (arguments.length === 1) {

			this.__isDefaultToolTipSelected = value;
			return value;
		} else {

			return this.__isDefaultToolTipSelected;
		}
	}

	, 
	getTooltipContext: function (item) {
		var $self = this;
		return (function () { var $ret = new $.ig.DataContext();
		$ret.series($self);
		$ret.item(item); return $ret;}());
	}

	, 
	transitionInDuration: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Series.prototype.transitionInDurationProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.Series.prototype.transitionInDurationProperty));
		}
	}

	, 
	transitionInSpeedType: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Series.prototype.transitionInSpeedTypeProperty, $.ig.TransitionInSpeedType.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.Series.prototype.transitionInSpeedTypeProperty));
		}
	}

	, 
	getDefaultTransitionInSpeedType: function () {
		return $.ig.TransitionInSpeedType.prototype.normal;
	}

	, 
	_currentToolTipParent: null,
	currentToolTipParent: function (value) {
		if (arguments.length === 1) {
			this._currentToolTipParent = value;
			return value;
		} else {
			return this._currentToolTipParent;
		}
	}

	, 
	removeToolTipFromCurrentParent: function () {
		this.view().removeToolTipFromCurrentParent();
	}

	, 
	replayTransitionIn: function () {
		this.transitionInViable(true);
		this.renderSeries(true);
	}

	, 
	invalidateAxes: function () {
	}

	, 
	wMA: function (sequence, period) {
		return $.ig.TrendCalculators.prototype.wMA(sequence, period);
	}

	, 
	eMA: function (sequence, period) {
		return $.ig.TrendCalculators.prototype.eMA(sequence, period);
	}

	, 
	mMA: function (sequence, period) {
		return $.ig.TrendCalculators.prototype.mMA(sequence, period);
	}

	, 
	cMA: function (sequence) {
		return $.ig.TrendCalculators.prototype.cMA(sequence);
	}

	, 
	sMA: function (sequence, period) {
		return $.ig.TrendCalculators.prototype.sMA(sequence, period);
	}

	, 
	movingSum: function (sequence, period) {
		return $.ig.TrendCalculators.prototype.movingSum(sequence, period);
	}

	, 
	sTDEV: function (sequence, period) {
		return $.ig.TrendCalculators.prototype.sTDEV(sequence, period);
	}

	, 
	toEnumerableRange: function (expression, start, length) {
		var d__ = new $.ig.Series___ToEnumerableRange__IteratorClass(-2);
		d__.__3__expression = expression;
		d__.__3__start = start;
		d__.__3__length = length;
		return d__;
	}

	, 
	toEnumerable: function (expression, length) {
		return $.ig.Series.prototype.toEnumerableRange(expression, 0, length);
	}

	, 
	startCap: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Series.prototype.startCapProperty, $.ig.PenLineCap.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.Series.prototype.startCapProperty));
		}
	}

	, 
	endCap: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Series.prototype.endCapProperty, $.ig.PenLineCap.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.Series.prototype.endCapProperty));
		}
	}
	, 
	__seriesComponentsForView: null

	, 
	getSeriesComponentsForView: function () {
		return this.__seriesComponentsForView;
	}

	, 
	setMarkerCanvas: function (canvas) {
		this.updateMarkerCanvas(canvas);
	}

	, 
	getTotalMilliseconds: function () {
		return this.transitionDuration();
	}

	, 
	getTotalTransitionInMilliseconds: function () {
		return this.transitionInDuration();
	}

	, 
	_lastHoverItem: null,
	lastHoverItem: function (value) {
		if (arguments.length === 1) {
			this._lastHoverItem = value;
			return value;
		} else {
			return this._lastHoverItem;
		}
	}

	, 
	_mouseIsOver: false,
	mouseIsOver: function (value) {
		if (arguments.length === 1) {
			this._mouseIsOver = value;
			return value;
		} else {
			return this._mouseIsOver;
		}
	}

	, 
	_pressed: false,
	pressed: function (value) {
		if (arguments.length === 1) {
			this._pressed = value;
			return value;
		} else {
			return this._pressed;
		}
	}
	, 
	__useDeferredMouseEnterAndLeave: false

	, 
	useDeferredMouseEnterAndLeave: function (value) {
		if (arguments.length === 1) {

			this.__useDeferredMouseEnterAndLeave = value;
			return value;
		} else {

			return this.__useDeferredMouseEnterAndLeave;
		}
	}

	, 
	shouldDeferEnterAndLeave: function () {

			return this.useDeferredMouseEnterAndLeave();
	}
	, 
	__isMouseEnterDeferred: false

	, 
	isMouseEnterDeferred: function (value) {
		if (arguments.length === 1) {

			this.__isMouseEnterDeferred = value;
			return value;
		} else {

			return this.__isMouseEnterDeferred;
		}
	}
	, 
	__isMouseLeaveDeferred: false

	, 
	isMouseLeaveDeferred: function (value) {
		if (arguments.length === 1) {

			this.__isMouseLeaveDeferred = value;
			return value;
		} else {

			return this.__isMouseLeaveDeferred;
		}
	}

	, 
	getHighlightingInfo: function (item, world) {
		return null;
	}

	, 
	getMarkerHighlightingInfo: function (item, world) {
		return null;
	}

	, 
	_lastHighlightingInfo: null,
	lastHighlightingInfo: function (value) {
		if (arguments.length === 1) {
			this._lastHighlightingInfo = value;
			return value;
		} else {
			return this._lastHighlightingInfo;
		}
	}

	, 
	_lastMarkerHighlightingInfo: null,
	lastMarkerHighlightingInfo: function (value) {
		if (arguments.length === 1) {
			this._lastMarkerHighlightingInfo = value;
			return value;
		} else {
			return this._lastMarkerHighlightingInfo;
		}
	}

	, 
	modifyHighlights: function (item, world, directlyOver, leaving) {
		if (this.seriesViewer().justZoomed() && !leaving) {
			return;
		}

		if (!this.actualIsHighlightingEnabled()) {
			return;
		}

		if (this.seriesViewer() == null) {
			return;
		}

		var info = null;
		var markerInfo = null;
		var highlightingManager = this.seriesViewer().highlightingManager();
		var highlightingAnimator = this.seriesViewer().highlightingAnimator();
		if (leaving && this.lastHighlightingInfo() != null) {
			info = this.lastHighlightingInfo();

		} else {
			info = this.getHighlightingInfo(item, world);
			if (this.lastHighlightingInfo() != null && this.lastHighlightingInfo() != info) {
				if (this.seriesViewer() != null) {
					highlightingManager.endHighlight(this.lastHighlightingInfo());
				}

			}

			this.lastHighlightingInfo(info);
		}

		if (this.hasMarkers()) {
			if (leaving && this.lastMarkerHighlightingInfo() != null) {
				markerInfo = this.lastMarkerHighlightingInfo();

			} else {
				markerInfo = this.getMarkerHighlightingInfo(item, world);
				if (this.lastMarkerHighlightingInfo() != null && this.lastMarkerHighlightingInfo() != markerInfo) {
					highlightingManager.endHighlight(this.lastMarkerHighlightingInfo());
				}

				this.lastMarkerHighlightingInfo(markerInfo);
			}

		}

		var onlyDirect = true;
		if (leaving) {
			highlightingManager.endHighlight(info);
			if (markerInfo != null) {
				highlightingManager.endHighlight(markerInfo);
			}


		} else {
			if (directlyOver || !onlyDirect) {
				highlightingManager.startHighlight(info);
				if (markerInfo != null) {
					highlightingManager.startHighlight(markerInfo);
				}

			}

		}

		if (!highlightingAnimator.animationActive() && highlightingAnimator.intervalMilliseconds() > 0) {
			highlightingAnimator.start();
		}

		if (highlightingAnimator.intervalMilliseconds() == 0) {
			this.seriesViewer().updateHighlights(1);
		}

	}

	, 
	onMouseEnter: function (pt, source, data) {
		this.view().goToMouseOverState();
		this.mouseIsOver(true);
		var item = this.item(source, pt);
		this.lastHoverItem(item);
		if (this.seriesViewer() != null && !this.contentInfo().isDirty()) {
			this.view().updateToolTip(pt, item, data);
		}

		this.__isMouseEnterDeferred = false;
		if (this.shouldDeferEnterAndLeave() && item == null) {
			this.__isMouseEnterDeferred = true;
		}

		if (this.seriesViewer() != null && !this.__isMouseEnterDeferred) {
			if (this.shouldDeferEnterAndLeave()) {
				this.__isMouseLeaveDeferred = true;
			}

			this.modifyHighlights(item, this.toWorldPosition(pt), true, false);
			this.seriesViewer().onSeriesMouseEnter(this, item, data);
		}

	}

	, 
	simulateHover: function (point) {
		var $self = this;
		var source = null;
		var data = null;
		var cont;
		var series = (function () { var $ret = $self.seriesViewer().view().getHitSeries(point, false, cont); cont = $ret.p2; return $ret.ret; }());
		if (series != $self) {
			if ($self.mouseIsOver()) {
				$self.onMouseLeave(point, null, null);
			}

			return;
		}

		source = cont;
		if (!$self.mouseIsOver()) {
			$self.onMouseEnter(point, source, data);
		}

		$self.onMouseMove(point, source, data);
	}

	, 
	onMouseMove: function (point, source, data) {
		this.mouseIsOver(true);
		var item = this.item(source, point);
		this.view().updateToolTip(point, item, data);
		if (item != null) {
			this.lastHoverItem(item);
		}

		if (this.seriesViewer() != null && item != null && this.__isMouseEnterDeferred) {
			this.__isMouseEnterDeferred = false;
			this.__isMouseLeaveDeferred = true;
			this.modifyHighlights(item, this.toWorldPosition(point), true, false);
			this.seriesViewer().onSeriesMouseEnter(this, item, data);
		}

		if (this.seriesViewer() != null && (!this.shouldDeferEnterAndLeave() || item != null) && !this.__isMouseEnterDeferred) {
			this.modifyHighlights(item, this.toWorldPosition(point), true, false);
			this.seriesViewer().onSeriesMouseMove(this, item, data);
		}

		if (item == null && !this.__isMouseEnterDeferred && this.shouldDeferEnterAndLeave()) {
			this.modifyHighlights(item, this.toWorldPosition(point), false, true);
			this.seriesViewer().onSeriesMouseLeave(this, this.lastHoverItem(), data);
			this.__isMouseLeaveDeferred = false;
			this.__isMouseEnterDeferred = true;
		}

	}

	, 
	onMouseLeave: function (pt, p, data) {
		this.view().goToNormalState();
		this.mouseIsOver(false);
		var item = this.lastHoverItem();
		this.view().hideTooltip();
		if (this.seriesViewer() != null && (this.__isMouseLeaveDeferred || !this.shouldDeferEnterAndLeave())) {
			this.__isMouseLeaveDeferred = false;
			this.__isMouseEnterDeferred = false;
			this.modifyHighlights(item, this.toWorldPosition(pt), false, true);
			this.seriesViewer().onSeriesMouseLeave(this, item, data);
		}

	}

	, 
	onLeftButtonDown: function (pt, source, data) {
		this.pressed(true);
		if (this.seriesViewer() != null) {
			this.seriesViewer().onSeriesMouseLeftButtonDown(this, this.item(source, pt), data);
		}

	}

	, 
	onMouseLeftButtonUp: function (pt, source, data) {
		this.pressed(false);
		if (this.seriesViewer() != null && this.mouseIsOver()) {
			this.seriesViewer().onSeriesMouseLeftButtonUp(this, this.item(source, pt), data);
		}

	}

	, 
	onLostMouseCapture: function (pt, source, data) {
		if (this.pressed()) {
			this.onMouseLeftButtonUp(pt, source, data);
		}

		if (this.mouseIsOver()) {
			this.onMouseLeave(pt, source, data);
		}

	}

	, 
	onRightButtonDown: function (pt, source, data) {
		if (this.seriesViewer() != null) {
			this.seriesViewer().onSeriesMouseRightButtonDown(this, this.item(source, pt), data);
		}

	}

	, 
	onRightButtonUp: function (pt, source, data) {
		if (this.seriesViewer() != null) {
			this.seriesViewer().onSeriesMouseRightButtonUp(this, this.item(source, pt), data);
		}

	}

	, 
	assertLegendItems1: function (oldChart, newChart) {
		if (this.actualLegend() != null && this.legendItem() != null) {
			if (newChart == null && this.actualLegend().children().contains(this.legendItem())) {
				this.actualLegend().children().remove(this.legendItem());
			}

			if (newChart != null && !this.actualLegend().children().contains(this.legendItem()) && this.legendItemVisibility() != $.ig.Visibility.prototype.collapsed) {
				this.actualLegend().addChildInOrder(this.legendItem(), this);
			}

		}

	}

	, 
	clearLegendItems: function () {
		if (this.actualLegend() == null || this.legendItem() == null) {
			return;
		}

		this.actualLegend().children().remove(this.legendItem());
	}

	, 
	assertLegendItems: function (oldLegend, newLegend) {
		if (this.legendItem() != null) {
			if (oldLegend != null && oldLegend.children().contains(this.legendItem())) {
				oldLegend.children().remove(this.legendItem());
			}

			if (this.seriesViewer() != null && newLegend != null && !newLegend.children().contains(this.legendItem()) && this.legendItemVisibility() != $.ig.Visibility.prototype.collapsed) {
				newLegend.addChildInOrder(this.legendItem(), this);
			}

		}

	}

	, 
	assertLegendItems2: function (oldItem, newItem) {
		if (this.actualLegend() != null && oldItem != null && this.actualLegend().children().contains(oldItem)) {
			this.actualLegend().children().remove(oldItem);
		}

		if (this.seriesViewer() != null && this.actualLegend() != null && newItem != null && this.legendItemVisibility() != $.ig.Visibility.prototype.collapsed) {
			this.actualLegend().addChildInOrder(newItem, this);
		}

	}

	, 
	releaseItemsSource: function (provider) {
		this.fastItemsSource(provider.releaseFastItemsSource(this.itemsSource()));
	}

	, 
	registerItemsSource: function (provider) {
		this.fastItemsSource(provider.getFastItemsSource(this.itemsSource()));
	}

	, 
	findActualLegend: function () {
		if (this.legend() != null) {
			return this.legend();
		}

		if (this.seriesViewer() != null && this.seriesViewer().legend() != null) {
			return this.seriesViewer().legend();
		}

		return null;
	}

	, 
	shouldTransitionIn: function () {
		return false;
	}

	, 
	shouldAnimate: function (animate) {
		return (animate && this.getTotalMilliseconds() > 0) || this.animationActive() || (this.transitionInViable() && this.shouldTransitionIn() && this.getTotalTransitionInMilliseconds() > 0);
	}

	, 
	deregisterForAxis: function (axis) {
		if (axis != null) {
			axis.deregisterSeries(this);
		}

	}

	, 
	registerForAxis: function (axis) {
		if (axis != null) {
			axis.registerSeries(this);
		}

	}

	, 
	getSeriesComponentsFromView: function () {
		return this.view().getSeriesComponentsFromView();
	}

	, 
	updateMarkerCanvas: function (canvas) {
		this.view().setMarkerCanvas(canvas);
	}

	, 
	showTooltip: function (pt, add) {
		this.view().showToolTip(pt, add);
	}

	, 
	useOverlaySchdeduler: function () {

			return false;
	}

	, 
	provideContext: function (context, hitContext) {
		this.view().onContextProvided(context, hitContext);
	}

	, 
	provideViewport: function (newViewport) {
		this.onViewportChanged(this.viewport(), newViewport);
	}

	, 
	handleCollectionChanged: function (e) {
		if (this.fastItemsSource() != null) {
			this.fastItemsSource().handleCollectionChanged(e);
		}

	}

	, 
	notifySetItem: function (index, oldItem, newItem) {
		this.handleCollectionChanged(new $.ig.NotifyCollectionChangedEventArgs(2, $.ig.NotifyCollectionChangedAction.prototype.replace, newItem, oldItem, index));
	}

	, 
	notifyClearItems: function () {
		this.handleCollectionChanged(new $.ig.NotifyCollectionChangedEventArgs(0, $.ig.NotifyCollectionChangedAction.prototype.reset));
	}

	, 
	notifyInsertItem: function (index, newItem) {
		this.handleCollectionChanged(new $.ig.NotifyCollectionChangedEventArgs(1, $.ig.NotifyCollectionChangedAction.prototype.add, newItem, index));
	}

	, 
	notifyRemoveItem: function (index, oldItem) {
		this.handleCollectionChanged(new $.ig.NotifyCollectionChangedEventArgs(1, $.ig.NotifyCollectionChangedAction.prototype.remove, oldItem, index));
	}

	, 
	styleUpdated: function () {
		this.renderSeries(false);
	}

	, 
	_tooltipTemplate: null,
	tooltipTemplate: function (value) {
		if (arguments.length === 1) {
			this._tooltipTemplate = value;
			return value;
		} else {
			return this._tooltipTemplate;
		}
	}

	, 
	_flattenEventArgs: null,
	flattenEventArgs: function (value) {
		if (arguments.length === 1) {
			this._flattenEventArgs = value;
			return value;
		} else {
			return this._flattenEventArgs;
		}
	}
	, 
	__coercionMethods: null

	, 
	coercionMethods: function (value) {
		if (arguments.length === 1) {

			this.__coercionMethods = value;
			return value;
		} else {

			return this.__coercionMethods;
		}
	}
	, 
	__expectFunctions: false

	, 
	expectFunctions: function (value) {
		if (arguments.length === 1) {

			this.__expectFunctions = value;
			return value;
		} else {

			return this.__expectFunctions;
		}
	}

	, 
	getHitDataContext: function (position) {
		return null;
	}

	, 
	registerDoubleColumn: function (memberPath) {
		if (memberPath == null) {
			return this.fastItemsSource().registerColumn(null, null, false);
		}

		var coercionMethod = null;
		var info = $.ig.SeriesViewer.prototype.getCoercionMethod(memberPath, this.coercionMethods());
		memberPath = info.memberPath();
		coercionMethod = info.coercionMethod();
		return this.fastItemsSource().registerColumn(memberPath, coercionMethod, this.expectFunctions());
	}

	, 
	registerIntColumn: function (memberPath) {
		if (memberPath == null) {
			return this.fastItemsSource().registerColumnInt(null, null, false);
		}

		var coercionMethod = null;
		var info = $.ig.SeriesViewer.prototype.getCoercionMethod(memberPath, this.coercionMethods());
		memberPath = info.memberPath();
		coercionMethod = info.coercionMethod();
		return this.fastItemsSource().registerColumnInt(memberPath, coercionMethod, this.expectFunctions());
	}

	, 
	registerObjectColumn: function (memberPath) {
		if (memberPath == null) {
			return this.fastItemsSource().registerColumnObject(null, null, false);
		}

		var coercionMethod = null;
		var info = $.ig.SeriesViewer.prototype.getCoercionMethod(memberPath, this.coercionMethods());
		memberPath = info.memberPath();
		coercionMethod = info.coercionMethod();
		return this.fastItemsSource().registerColumnObject(memberPath, coercionMethod, this.expectFunctions());
	}

	, 
	viewport: function () {

			return this.view() != null ? this.view().viewport() : $.ig.Rect.prototype.empty();
	}

	, 
	sanitizeTypeName: function (name) {
		return name;
	}

	, 
	exportVisualData: function () {
		var svd = new $.ig.SeriesVisualData();
		svd.viewport(this.viewport());
		svd.type(this.sanitizeTypeName(this.getType().typeName()));
		svd.name(this.name());
		svd.opacity(this.__opacity);
		this.exportVisualDataOverride(svd);
		this.view().exportViewShapes(svd);
		return svd;
	}

	, 
	exportVisualDataOverride: function (svd) {
	}

	, 
	notifyBrushScalesDirty: function () {
	}
	, 
	$type: new $.ig.Type('Series', $.ig.Control.prototype.$type, [$.ig.INotifyPropertyChanged.prototype.$type, $.ig.IProvidesViewport.prototype.$type])
}, true);


$.ig.util.defType('SeriesView', 'Object', {

	_model: null,
	model: function (value) {
		if (arguments.length === 1) {
			this._model = value;
			return value;
		} else {
			return this._model;
		}
	}
	, 
	init: function (model) {


		this.__renderedRect = $.ig.Rect.prototype.empty();
		this.__hitBrush = new $.ig.Brush();
		this.__toolTipObject = null;
		this.__toolTipString = null;
		this.__seriesComponentsFromView = new $.ig.SeriesComponentsFromView();
		this.__tooltipDisconnected = true;
		this.__tooltipInInfoBox = false;
		this.__isThumbnailView = false;

		$.ig.Object.prototype.init.call(this);
			this.scalingRatioOverride(NaN);
			this.isVisible(true);
			this.model(model);
			this.isThumbnailView(false);
			this.__backgroundRect = new $.ig.Rectangle();
	}

	, 
	onInit: function () {
		var $self = this;
		if (!$self.isThumbnailView()) {
			$self.model().legendItemTemplate((function () { var $ret = new $.ig.DataTemplate();
			$ret.render($self.legendItem());
			$ret.measure($self.legendItemMeasure()); return $ret;}()));
			$self.model().legendItemBadgeTemplate((function () { var $ret = new $.ig.DataTemplate();
			$ret.render($self.badgeTemplate());
			$ret.measure($self.badgeTemplateMeasure()); return $ret;}()));
			$self.model().discreteLegendItemTemplate((function () { var $ret = new $.ig.DataTemplate();
			$ret.render($self.discreteLegendItem());
			$ret.measure($self.discreteLegendItemMeasure()); return $ret;}()));
			$self.toolTipContext(new $.ig.DataContext());
			$self.toolTipContext().series($self.model());
			$self.model().transitionInEasingFunction($.ig.EasingFunctions.prototype.cubicEase);
			$self.applyDropShadowDefaultSettings();
		}

	}

	, 
	onVisualPropertiesChanged: function () {
		this.makeDirty();
	}

	, 
	destroy: function () {
	}

	, 
	discreteLegendItem: function () {
		return $.ig.LegendTemplates.prototype.defaultDiscreteLegendItemRender;
	}

	, 
	discreteLegendItemMeasure: function () {
		return $.ig.LegendTemplates.prototype.defaultDiscreteLegendItemMeasure;
	}

	, 
	legendItem: function () {
		return $.ig.LegendTemplates.prototype.defaultLegendItemRender;
	}

	, 
	legendItemMeasure: function () {
		return $.ig.LegendTemplates.prototype.defaultLegendItemMeasure;
	}

	, 
	badgeTemplate: function () {
		return $.ig.LegendTemplates.prototype.lineBadgeTemplate;
	}

	, 
	badgeTemplateMeasure: function () {
		return $.ig.LegendTemplates.prototype.legendItemBadgeMeasure;
	}

	, 
	_isDirty: false,
	isDirty: function (value) {
		if (arguments.length === 1) {
			this._isDirty = value;
			return value;
		} else {
			return this._isDirty;
		}
	}

	, 
	index: function () {

			var chart = $.ig.util.cast($.ig.XamDataChart.prototype.$type, this.model().chart());
			var before = 0;
			if (chart != null) {
				if (chart.gridMode() == $.ig.GridMode.prototype.behindSeries || chart.gridMode() == $.ig.GridMode.prototype.none) {
					before = chart.axes().count();
				}

			}

			return before + this.model().seriesViewer().series().indexOf(this.model());
	}

	, 
	makeDirty: function () {
		if (this.model().seriesViewer() == null) {
			return;
		}

		if (!this.isDirty()) {
			this.isDirty(true);
			this.currentScheduler().schedule1(this.context(), this.hitContext());
		}

	}

	, 
	undirty: function (clearRect) {
		this.isDirty(false);
		this.render(clearRect);
	}
	, 
	__backgroundRect: null

	, 
	onRenderFrame: function () {
		this.makeDirty();
	}

	, 
	_scalingRatioOverride: 0,
	scalingRatioOverride: function (value) {
		if (arguments.length === 1) {
			this._scalingRatioOverride = value;
			return value;
		} else {
			return this._scalingRatioOverride;
		}
	}

	, 
	getScalingRatio: function () {
		if (!$.ig.util.isNaN(this.scalingRatioOverride())) {
			return this.scalingRatioOverride();
		}

		if (this.model().seriesViewer() != null) {
			return this.model().seriesViewer().actualPixelScalingRatio();

		} else {
			return 1;
		}

	}

	, 
	render: function (clearRect) {
		if (this.context() == null) {
			return;
		}

		if (this.__renderedRect.isEmpty()) {
			this.__renderedRect = this.viewport();
		}

		var prevRect = this.__renderedRect;
		var _container = this.model().seriesViewer().getContainerRect();
		var clearLeft = _container.left();
		var clearTop = _container.top();
		var clearWidth = _container.width();
		var clearHeight = _container.height();
		var scalingRatio = this.getScalingRatio();
		if (this.isAlternateView()) {
			clearLeft = this.viewport().left();
			clearTop = this.viewport().top();
			clearWidth = this.viewport().width();
			clearHeight = this.viewport().height();
		}

		if (this.context().shouldRender()) {
			if (scalingRatio != 1) {
				this.context().save();
				this.context().scale(scalingRatio, scalingRatio);
			}

			if (clearRect) {
				this.context().clearRectangle(clearLeft, clearTop, clearWidth, clearHeight);
			}

			if (clearRect) {
				if (this.model().seriesViewer().plotAreaBackground() != null) {
					this.__backgroundRect.canvasTop(this.viewport().top());
					this.__backgroundRect.canvasLeft(this.viewport().left());
					this.__backgroundRect.width(this.viewport().width());
					this.__backgroundRect.height(this.viewport().height());
					this.__backgroundRect.__fill = this.model().seriesViewer().plotAreaBackground();
					this.context().renderRectangle(this.__backgroundRect);
				}

			}

			if (scalingRatio != 1) {
				this.context().restore();
			}

		}

		if (this.hitContext() != null && this.isVisible()) {
			if (this.hitContext().shouldRender()) {
				if (this.model().seriesViewer() != null && scalingRatio != 1) {
					this.hitContext().save();
					this.hitContext().scale(scalingRatio, scalingRatio);
				}

				if (!prevRect.isEmpty() && clearRect) {
					this.hitContext().clearRectangle(prevRect.left(), prevRect.top(), prevRect.width(), prevRect.height());
				}

				this.setupAppearance(true);
				this.renderOverride(this.hitContext(), true);
				this.renderMarkersOverride(this.hitContext(), true);
				if (scalingRatio != 1) {
					this.hitContext().restore();
				}

			}

		}

		if (this.context().shouldRender() && this.isVisible()) {
			if (scalingRatio != 1) {
				this.context().save();
				this.context().scale(scalingRatio, scalingRatio);
			}

			this.context().save();
			if (!this.isThumbnailView() && this.model().customClipRect() != null && !this.model().customClipRect().isEmpty() && (this.model().customClipRect().width() != 1 || this.model().customClipRect().height() != 1)) {
				this.context().setRectangleClip(new $.ig.Rect(0, this.viewport().left() + this.viewport().width() * this.model().customClipRect().left(), this.viewport().top() + this.viewport().height() * this.model().customClipRect().top(), this.viewport().width() * this.model().customClipRect().width(), this.viewport().height() * this.model().customClipRect().height()));

			} else {
				this.context().setRectangleClip(this.viewport());
			}

			this.setupAppearance(false);
			this.context().setOpacity(this.model().__opacity);
			if (this.model().isDropShadowEnabled() && this.model().isDropShadowSupported() && !this.isThumbnailView()) {
				if (this.model().useSingleShadow()) {
					this.context().enableDropShadow(this.model().shadowColor().colorString(), 0, this.model().shadowOffsetX(), this.model().shadowOffsetY());
					var shadowContext = this.model().seriesViewer().view().viewManager().shadowContext();
					var shadowCanvas = this.model().seriesViewer().view().viewManager().shadowCanvas();
					shadowContext.clearRectangle(_container.left(), _container.top(), _container.width(), _container.height());
					this.renderOverride(shadowContext, false);
					this.renderMarkersOverride(shadowContext, false);
					this.context().drawImage(shadowCanvas[0], 1, 0, 0, _container.width(), _container.height());

				} else {
					this.context().enableDropShadow(this.model().shadowColor().colorString(), this.model().shadowBlur(), this.model().shadowOffsetX(), this.model().shadowOffsetY());
					this.renderOverride(this.context(), false);
					this.renderMarkersOverride(this.context(), false);
				}

				this.context().disableDropShadow();

			} else {
				this.renderOverride(this.context(), false);
				this.renderMarkersOverride(this.context(), false);
			}

			this.context().setOpacity(1);
			this.context().restore();
			if (scalingRatio != 1) {
				this.context().restore();
			}

		}

	}
	, 
	__renderedRect: null

	, 
	setupItemAppearance: function (item, index, isHitContext) {
		if (isHitContext) {
			this.setupItemHitAppearanceOverride(item, index);

		} else {
			this.setupItemAppearanceOverride(item, index);
		}

	}

	, 
	setupMarkerAppearance: function (item, index, isHitContext) {
		if (isHitContext) {
			this.setupMarkerHitAppearanceOverride(item, index);

		} else {
			this.setupMarkerAppearanceOverride(item, index);
		}

	}

	, 
	getCurrentItem: function (index, isHitContext) {
		if (isHitContext) {
			return this.getHitItem(index);

		} else {
			return this.getItem(index);
		}

	}

	, 
	getHitItem: function (index) {
		return null;
	}

	, 
	getItem: function (index) {
		return null;
	}

	, 
	setupItemAppearanceOverride: function (item, index) {
	}

	, 
	setupMarkerAppearanceOverride: function (item, index) {
	}

	, 
	setupItemHitAppearanceOverride: function (item, index) {
	}

	, 
	setupMarkerHitAppearanceOverride: function (item, index) {
	}

	, 
	setupAppearance: function (isHitContext) {
		if (isHitContext) {
			this.setupHitAppearanceOverride();

		} else {
			this.setupAppearanceOverride();
		}

	}

	, 
	setupAppearanceOverride: function () {
	}

	, 
	setupHitAppearanceOverride: function () {
	}
	, 
	__hitBrush: null

	, 
	getHitBrush1: function (index) {
		return this.getHitBrush();
	}

	, 
	getHitBrush: function () {
		var seriesIndex = this.model()._uniqueIndex;
		var num_ = (seriesIndex + 1) * $.ig.SeriesView.prototype.iTEM_ALLOCATION;
		var r = (num_ & 0x3F) << 2;
		num_ = num_ >> 6;
		var g = (num_ & 0x3F) << 2;
		num_ = num_ >> 6;
		var b = (num_ & 0x3F) << 2;
		this.__hitBrush.__fill = "rgb(" + r + "," + g + "," + b + ")";
		return this.__hitBrush;
	}

	, 
	renderOverride: function (context, isHitContext) {
		this.__renderedRect = this.viewport();
	}

	, 
	renderMarkersOverride: function (context, isHitContext) {
	}

	, 
	onTemplateProvided: function () {
	}

	, 
	goToMouseOverState: function () {
	}

	, 
	goToNormalState: function () {
	}

	, 
	hideTooltip: function () {
		if (this.__toolTipObject != null && this.toolTipVisible()) {
			this.toolTipVisible(false);
			var context_ = this.toolTipContext();
			if (this.__toolTipObject.hideToolTip) { this.__toolTipObject.hideToolTip(context_); };
		}

	}
	, 
	__toolTipObject: null
	, 
	__toolTipString: null

	, 
	updateToolTipValue: function (p) {
		var oldObject = this.__toolTipObject;
		this.__toolTipString = null;
		this.__toolTipObject = null;
		if ($.ig.util.cast(String, p) !== null || typeof p === "string") {
			this.__toolTipString = p;

		} else {
			this.__toolTipObject = p;
			if (this.__toolTipObject != null) {
				this.__toolTipObject.css("position", "absolute");
				this.__toolTipObject.css("top", "0");
				this.__toolTipObject.css("left", "0");
				this.__toolTipObject.css("z-index", "10000");
				if (this.model().actualOutline() != null && $.ig.Color.prototype.l_op_Inequality_Lifted($.ig.util.toNullable($.ig.Color.prototype.$type, this.model().actualOutline().color()), $.ig.util.toNullable($.ig.Color.prototype.$type, null))) {
					this.__toolTipObject.css("border-color", this.model().actualOutline().__fill);
				}


			} else {
				if (!this.__tooltipDisconnected && oldObject != null) {
					this.model().seriesViewer().removeTooltipFromView(oldObject);
					this.__tooltipDisconnected = true;
				}

			}

		}

	}
	, 
	__seriesComponentsFromView: null

	, 
	getSeriesComponentsFromView: function () {
		return this.__seriesComponentsFromView;
	}

	, 
	setMarkerCanvas: function (canvas) {
	}

	, 
	ready: function () {
		return true;
	}

	, 
	onSeriesDetached: function () {
	}

	, 
	onSeriesAttached: function () {
	}

	, 
	resetActualBrush: function () {
		this.model().actualBrush(null);
	}

	, 
	bindActualToUserBrush: function () {
		this.model().actualBrush(this.model().brush());
	}

	, 
	resetActualOutlineBrush: function () {
		this.model().actualOutline(null);
	}

	, 
	bindActualToUserOutline: function () {
		this.model().actualOutline(this.model().outline());
	}

	, 
	getDataContextFromSender: function (sender) {
		if ($.ig.util.cast($.ig.DataContext.prototype.$type, sender) !== null) {
			return sender;
		}

		return null;
	}

	, 
	_toolTipPosition: null,
	toolTipPosition: function (value) {
		if (arguments.length === 1) {
			this._toolTipPosition = value;
			return value;
		} else {
			return this._toolTipPosition;
		}
	}

	, 
	_toolTipItem: null,
	toolTipItem: function (value) {
		if (arguments.length === 1) {
			this._toolTipItem = value;
			return value;
		} else {
			return this._toolTipItem;
		}
	}

	, 
	_toolTipVisible: false,
	toolTipVisible: function (value) {
		if (arguments.length === 1) {
			this._toolTipVisible = value;
			return value;
		} else {
			return this._toolTipVisible;
		}
	}

	, 
	_toolTipContext: null,
	toolTipContext: function (value) {
		if (arguments.length === 1) {
			this._toolTipContext = value;
			return value;
		} else {
			return this._toolTipContext;
		}
	}
	, 
	__tooltipDisconnected: false
	, 
	__tooltipInInfoBox: false

	, 
	updateToolTip: function (pt, item, data) {
		var tooltipDisabled = false;
		if (this.model().seriesViewer() != null) {
			tooltipDisabled = this.model().seriesViewer().isDefaultTooltipDisabled();
		}

		if (tooltipDisabled) {
			return;
		}

		if (this.model().seriesViewer() == null || this.model().seriesViewer().dragCrosshairActivated()) {
			return;
		}

		this.toolTipVisible(true);
		this.toolTipPosition(pt);
		this.toolTipItem(item);
		this.toolTipContext().item(item);
		var offsets = this.model().seriesViewer().getContainerOffsets();
		var pos_ = {__x: pt.__x + 15 + offsets.width(), __y: pt.__y + 15 + offsets.height(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		var context_ = this.toolTipContext();
		if (this.__toolTipObject != null) {
			if (this.__tooltipInInfoBox) {
				this.__tooltipInInfoBox = false;
				this.__toolTipObject.remove();
				this.__toolTipObject.css("position", "absolute");
				this.__toolTipObject.addClass(this.model().seriesViewer().tooltipStyle());
				this.model().seriesViewer().addTooltipToView(this.__toolTipObject);
				this.__toolTipObject.hide();
			}

			if (this.__tooltipDisconnected) {
				this.model().seriesViewer().addTooltipToView(this.__toolTipObject);
				this.__tooltipDisconnected = false;
			}

			context_.hideOthers = true;
			if (this.__toolTipObject.updateToolTip) { this.__toolTipObject.updateToolTip(context_); };
			if (this.__toolTipObject.offset) { this.__toolTipObject.offset({ left: pos_.__x, top: pos_.__y }); };
		}

	}

	, 
	showToolTip: function (pt, add) {
		this.toolTipVisible(true);
		var point = {__x: pt.__x + this.viewport().left(), __y: pt.__y + this.viewport().top(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		var data = this.model().item(null, point);
		if (this.toolTipContext() != null) {
			this.toolTipContext().series(this.model());
			this.toolTipContext().item(data);
		}

		var tooltip_ = this.__toolTipObject;
		var context_ = this.toolTipContext();
		if (context_ != null) {
			context_.hideOthers = false;
		}

		if (!this.__tooltipInInfoBox && tooltip_ != null) {
			this.__tooltipInInfoBox = true;
			tooltip_.remove();
			tooltip_.css("position", "relative");
			tooltip_.css("top", "");
			tooltip_.css("left", "");
			tooltip_.removeClass(this.model().seriesViewer().tooltipStyle());
		}

		if (this.__toolTipObject != null) {
			if (tooltip_.updateToolTip) { tooltip_.updateToolTip(context_); };
		}

		if (tooltip_ != null) {
			add(tooltip_);
		}

	}

	, 
	getDefaultTooltipTemplate: function () {
		var tooltipObject = "<div class=\'ui-chart-default-tooltip-content\'><span";
		if (this.model().actualOutline() != null && $.ig.Color.prototype.l_op_Inequality_Lifted($.ig.util.toNullable($.ig.Color.prototype.$type, this.model().actualOutline().color()), $.ig.util.toNullable($.ig.Color.prototype.$type, null))) {
			tooltipObject += " style=\'color:" + this.model().actualOutline().__fill + "\'";
		}

		tooltipObject += ">" + this.model().title() + "</span></div>";
		return tooltipObject;
	}

	, 
	_context: null,
	context: function (value) {
		if (arguments.length === 1) {
			this._context = value;
			return value;
		} else {
			return this._context;
		}
	}

	, 
	_hitContext: null,
	hitContext: function (value) {
		if (arguments.length === 1) {
			this._hitContext = value;
			return value;
		} else {
			return this._hitContext;
		}
	}

	, 
	onContextProvided: function (context, hitContext) {
		this.context(context);
		this.hitContext(hitContext);
	}
	, 
	__viewport: null

	, 
	viewport: function (value) {
		if (arguments.length === 1) {

			this.__viewport = value;
			return value;
		} else {

			return this.__viewport;
		}
	}

	, 
	_alternateWindow: null,
	alternateWindow: function (value) {
		if (arguments.length === 1) {
			this._alternateWindow = value;
			return value;
		} else {
			return this._alternateWindow;
		}
	}

	, 
	windowRect: function () {

			if (this.isAlternateView()) {
				return this.alternateWindow();

			} else if (this.isThumbnailView()) {
				return $.ig.XamDataChart.prototype.standardRect;

			} else {
				return this.model().seriesViewer() != null ? this.model().seriesViewer().actualWindowRect() : $.ig.Rect.prototype.empty();
			}


	}
	, 
	__isThumbnailView: false

	, 
	isThumbnailView: function (value) {
		if (arguments.length === 1) {

			this.__isThumbnailView = value;
			return value;
		} else {

			return this.__isThumbnailView;
		}
	}

	, 
	detachFromChart: function (oldSeriesViewer) {
		if (oldSeriesViewer != null) {
			this.currentScheduler().unRegister(this);
			if (this.model().thumbnailView() != null) {
				this.model().thumbnailView().currentScheduler().unRegister(this.model().thumbnailView());
			}

		}

	}

	, 
	_currentScheduler: null,
	currentScheduler: function (value) {
		if (arguments.length === 1) {
			this._currentScheduler = value;
			return value;
		} else {
			return this._currentScheduler;
		}
	}

	, 
	attachToChart: function (newSeriesViewer) {
		if (newSeriesViewer != null) {
			if (this.model().useOverlaySchdeduler()) {
				this.context(this.model().seriesViewer().view().overlayContext());
				newSeriesViewer.view().overlayScheduler().register(this);
				this.currentScheduler(newSeriesViewer.view().overlayScheduler());

			} else {
				this.context(this.model().seriesViewer().view().mainContext());
				newSeriesViewer.canvasRenderScheduler().register(this);
				this.currentScheduler(newSeriesViewer.canvasRenderScheduler());
			}

			if (this.model().thumbnailView() != null) {
				newSeriesViewer.thumbnailCanvasRenderScheduler().register(this.model().thumbnailView());
				this.model().thumbnailView().currentScheduler(newSeriesViewer.thumbnailCanvasRenderScheduler());
				this.model().thumbnailView().makeDirty();
			}

			var en = this.model().alternateViews().keys().getEnumerator();
			while (en.moveNext()) {
				var key = en.current();
				newSeriesViewer.alternateViewRenderScheduler().register(this.model().alternateViews().item(key));
				this.model().alternateViews().item(key).currentScheduler(newSeriesViewer.alternateViewRenderScheduler());
				this.model().alternateViews().item(key).makeDirty();
			}

			this.makeDirty();
		}

	}

	, 
	postRender: function () {
		this.postRenderOverride();
	}

	, 
	postRenderOverride: function () {
	}

	, 
	getDataContextByIndex: function (itemIndex) {
		return null;
	}

	, 
	prepSurface: function (surface) {
		this.model().thumbnailView().context(surface.surface());
	}

	, 
	exportViewShapes: function (svd) {
	}

	, 
	updateLegendItemVisual: function () {
		if (this.duringInit()) {
			return;
		}

		if (this.model().seriesViewer() != null) {
			var curLegend = (this.model().legend() != null) ? this.model().legend() : this.model().seriesViewer().legend();
			if (curLegend != null && this.model().legendItem() != null && curLegend.children().contains(this.model().legendItem())) {
				curLegend.children().remove(this.model().legendItem());
				var legendItem = this.model().provideLegendItem();
				(legendItem.content()).actualItemBrush(this.model().actualBrush());
				(legendItem.content()).outline(this.model().outline());
				(legendItem.content()).thickness(this.model().thickness());
				curLegend.addChildInOrder(this.model().legendItem(), this.model());
			}

		}

	}

	, 
	onLegendItemVisibilityChanged: function () {
		this.model().assertLegendItems(this.model().actualLegend(), this.model().actualLegend());
	}

	, 
	onTitlePropertyChanged: function () {
		this.model().assertLegendItems(this.model().actualLegend(), this.model().actualLegend());
	}

	, 
	getViewInfo: function (viewportRect, windowRect) {
		viewportRect = this.viewport();
		windowRect = this.windowRect();
		return {
			p0: viewportRect, 
			p1: windowRect
		};
	}

	, 
	hasSurface: function () {
		return this.context() != null;
	}

	, 
	_isVisible: false,
	isVisible: function (value) {
		if (arguments.length === 1) {
			this._isVisible = value;
			return value;
		} else {
			return this._isVisible;
		}
	}

	, 
	visibilityChanged: function () {
		this.isVisible(this.model().__visibility == $.ig.Visibility.prototype.visible);
		this.makeDirty();
	}

	, 
	removeToolTipFromCurrentParent: function () {
	}

	, 
	getBrightenedBrush: function (brush, additionalBrightness) {
		if (brush == null) {
			return brush;
		}

		return $.ig.BrushUtil.prototype.getLightened(brush, additionalBrightness);
	}

	, 
	applyDropShadowDefaultSettings: function () {
		var color = new $.ig.Color();
		color.colorString("rgba(95,95,95,0.5)");
		this.model().shadowColor(color);
		this.model().shadowBlur(5);
		this.model().shadowOffsetX(5);
		this.model().shadowOffsetY(5);
	}

	, 
	handleIsDropShadowEnabledChanged: function () {
	}

	, 
	preRender: function () {
		if (this.model().seriesViewer() != null && !this.isThumbnailView()) {
			this.model().seriesViewer().ensureCorrectSize();
		}

	}

	, 
	_duringInit: false,
	duringInit: function (value) {
		if (arguments.length === 1) {
			this._duringInit = value;
			return value;
		} else {
			return this._duringInit;
		}
	}

	, 
	_isAlternateView: false,
	isAlternateView: function (value) {
		if (arguments.length === 1) {
			this._isAlternateView = value;
			return value;
		} else {
			return this._isAlternateView;
		}
	}

	, 
	prepAltSurface: function (surface) {
		this.context(surface.surface());
	}

	, 
	_alternateViewIdentifier: null,
	alternateViewIdentifier: function (value) {
		if (arguments.length === 1) {
			this._alternateViewIdentifier = value;
			return value;
		} else {
			return this._alternateViewIdentifier;
		}
	}
	, 
	$type: new $.ig.Type('SeriesView', $.ig.Object.prototype.$type, [$.ig.ISchedulableRender.prototype.$type, $.ig.IProvidesViewport.prototype.$type])
}, true);

























$.ig.util.defType('PointerTooltipStyle', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.strokeThickness(NaN);
			this.cornerRadius(NaN);
	}

	, 
	_strokeThickness: 0,
	strokeThickness: function (value) {
		if (arguments.length === 1) {
			this._strokeThickness = value;
			return value;
		} else {
			return this._strokeThickness;
		}
	}

	, 
	_cornerRadius: 0,
	cornerRadius: function (value) {
		if (arguments.length === 1) {
			this._cornerRadius = value;
			return value;
		} else {
			return this._cornerRadius;
		}
	}

	, 
	_strokeColor: null,
	strokeColor: function (value) {
		if (arguments.length === 1) {
			this._strokeColor = value;
			return value;
		} else {
			return this._strokeColor;
		}
	}

	, 
	_fillColor: null,
	fillColor: function (value) {
		if (arguments.length === 1) {
			this._fillColor = value;
			return value;
		} else {
			return this._fillColor;
		}
	}
	, 
	$type: new $.ig.Type('PointerTooltipStyle', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('AxisLabelPanelBaseView', 'Object', {

	_model: null,
	model: function (value) {
		if (arguments.length === 1) {
			this._model = value;
			return value;
		} else {
			return this._model;
		}
	}

	, 
	_ticks: null,
	ticks: function (value) {
		if (arguments.length === 1) {
			this._ticks = value;
			return value;
		} else {
			return this._ticks;
		}
	}
	, 
	init: function (model) {


		this.__renderedRect = $.ig.Rect.prototype.empty();
		this.__fontHeight = 0;
		this.__titleHeight = NaN;

		$.ig.Object.prototype.init.call(this);
			this.model(model);
	}

	, 
	arrangeTextToBounds: function (frameworkElement, rect, leftMargin, topMargin, rightMargin, bottomMargin) {
		var tb = $.ig.util.cast($.ig.TextBlock.prototype.$type, frameworkElement);
		if (tb != null) {
			tb.__visibility = $.ig.Visibility.prototype.visible;
			if (rect.width() == 0 && rect.height() == 0) {
				tb.__visibility = $.ig.Visibility.prototype.collapsed;
			}

			var newHeight = rect.height() - (topMargin + bottomMargin);
			var newWidth = rect.width() - (leftMargin + rightMargin);
			tb.canvasLeft(rect.left() + leftMargin);
			tb.canvasTop(rect.top() + topMargin);
			if (newWidth < 0) {
				newWidth = 0;
			}

			if (newHeight < 0) {
				newHeight = 0;
			}

			tb.actualHeight(newHeight);
			tb.actualWidth(newWidth);
			if (tb.renderTransform() != null) {
				var tg = tb.renderTransform();
				var rot = tg.children().__inner[0];
				rot.centerX(rot.centerX() + tb.canvasLeft());
				rot.centerY(rot.centerY() + tb.canvasTop());
			}

		}

	}

	, 
	clearTransforms: function (frameworkElement) {
		var fe = frameworkElement;
		fe.renderTransform(null);
	}

	, 
	handleMeasureLabel: function (element) {
	}

	, 
	handleMeasureLabel1: function (element, availableSize) {
	}

	, 
	handleSetLabelRotationTransform: function (label, effAngle) {
		var $self = this;
		var fe = $.ig.util.cast($.ig.FrameworkElement.prototype.$type, label);
		var centerX = 0;
		var centerY = 0;
		var group = new $.ig.TransformGroup();
		var transform = (function () { var $ret = new $.ig.RotateTransform();
		$ret.angle(effAngle);
		$ret.centerX(centerX);
		$ret.centerY(centerY); return $ret;}());
		group.children().add(transform);
		fe.renderTransform(group);
	}

	, 
	trimTextBlock: function (textblock, availableWidth) {
		var length = textblock.text().length;
		var text = textblock.text();
		var originalText = textblock.text();
		while (this.getWidthBounds(textblock) > availableWidth && length > 0) {
			length--;
			text = text.substr(0, length) + "\u2026";
			textblock.text(text);

		}
		textblock.text(originalText);
		return text;
	}

	, 
	determineLongestLabel: function () {
		var labels = this.getLabels();
		var en = labels.getEnumerator();
		while (en.moveNext()) {
			var child = en.current();
			var tb = $.ig.util.cast($.ig.FrameworkElement.prototype.$type, child);
			if (tb != null) {
				this.model().onProcessTextBlock(tb);
			}

			this.model().considerForLongestTextBlock(child);
		}

	}

	, 
	getLabels: function () {
		var textBlocks = this.model().getTextBlocks();
		var children = this.model().getLabels();
		if (!this.model().axis().usingTemplate()) {
			return textBlocks;

		} else {
			return children;
		}

	}

	, 
	getDesiredHeight: function (element) {
		return this.__fontHeight;
	}

	, 
	getHeightBounds: function (element) {
		return this.getDesiredHeight(element) + this.getLabelTopMargin() + this.getLabelBottomMargin();
	}

	, 
	onInit: function () {
		var $self = this;
		$self.ticks((function () { var $ret = new $.ig.Path();
		$ret.data(new $.ig.GeometryGroup());
		$ret.isHitTestVisible(false); return $ret;}()));
	}

	, 
	getDesiredWidth: function (element) {
		var tb = element;
		if (tb != null && tb.text() != null) {
			return this.context().measureTextWidth(tb.text());
		}

		return 0;
	}

	, 
	getWidthBounds: function (element) {
		var tb = element;
		if (tb != null && tb.text() != null) {
			return this.getDesiredWidth(element) + this.getLabelLeftMargin() + this.getLabelRightMargin();
		}

		return 0;
	}

	, 
	bindExtentToSettings: function () {
		this.model().extent(this.model().axis().getUserExtent());
	}

	, 
	measure: function () {
		this.ensureContextFont();
		this.model().measureLabels(new $.ig.Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY));
	}

	, 
	_context: null,
	context: function (value) {
		if (arguments.length === 1) {
			this._context = value;
			return value;
		} else {
			return this._context;
		}
	}

	, 
	onContextProvided: function (context) {
		this.context(context);
	}

	, 
	arrange: function () {
		if (this.model().labelViewport().isEmpty()) {
			return;
		}

		var oldExtent = this.model()._actualExtent;
		this.model().arrangeLabels(new $.ig.Size(1, this.model().labelViewport().width(), this.model().labelViewport().height()));
		if (this.model()._actualExtent != oldExtent) {
			this.model().axis().chart().invalidatePanels();
			this.onExtentChangedAfterArrange();
		}

	}

	, 
	onExtentChangedAfterArrange: function () {
	}
	, 
	__renderedRect: null

	, 
	render: function () {
		if (this.context() == null) {
			return;
		}

		if (this.context().shouldRender()) {
			if (this.model().axis().seriesViewer() != null && this.model().axis().seriesViewer().actualPixelScalingRatio() != 1) {
				this.context().save();
				this.context().scale(this.model().axis().seriesViewer().actualPixelScalingRatio(), this.model().axis().seriesViewer().actualPixelScalingRatio());
			}

			this.ensureContextFont();
			this.__renderedRect = this.model().labelViewport();
			var labelBrush = this.model().axis().chart().getFontBrush();
			if (this.model().labelSettings() != null && this.model().labelSettings().textColor() != null) {
				labelBrush = this.model().labelSettings().textColor();
			}

			var en = this.getLabels().getEnumerator();
			while (en.moveNext()) {
				var child = en.current();
				var tb = $.ig.util.cast($.ig.TextBlock.prototype.$type, child);
				if (tb != null) {
					tb.fill(labelBrush);
					if (tb.renderTransform() != null) {
						this.context().save();
						this.context().applyTransform(tb.renderTransform());
					}

					this.context().renderTextBlock(tb);
					if (tb.renderTransform() != null) {
						this.context().restore();
					}

				}

			}

			this.renderTicks();
			labelBrush = this.getAxisTitleColor();
			this.context().setFont(this.getAxisTitleFont());
			var axisTitleTb = this.model().axis().titleTextBlock();
			if (axisTitleTb != null) {
				axisTitleTb.fill(labelBrush);
				if (axisTitleTb.renderTransform() != null) {
					this.context().save();
					this.context().applyTransform(axisTitleTb.renderTransform());
				}

				this.context().renderTextBlock(axisTitleTb);
				if (axisTitleTb.renderTransform() != null) {
					this.context().restore();
				}

			}

			if (this.model().axis().seriesViewer() != null && this.model().axis().seriesViewer().actualPixelScalingRatio() != 1) {
				this.context().restore();
			}

		}

	}

	, 
	getAxisTitleFont: function () {
		var font = this.model().axis().seriesViewer().getFont();
		if (this.model().axis().titleSettings() != null && this.model().axis().titleSettings().textStyle() != null) {
			font = this.model().axis().titleSettings().textStyle();

		} else {
			var defFont = this.model().axis().seriesViewer().getDefaultHorizontalAxisFont();
			if (String.isNullOrEmpty(defFont) == false) {
				font = defFont;
			}

		}

		return font;
	}

	, 
	getAxisTitleColor: function () {
		var brush = this.model().axis().chart().getFontBrush();
		if (this.model().axis().titleSettings() != null && this.model().axis().titleSettings().textColor() != null) {
			brush = this.model().axis().titleSettings().textColor();

		} else {
			var defBrush = this.model().axis().seriesViewer().getDefaultHorizontalAxisColor();
			if (defBrush != null) {
				brush = defBrush;
			}

		}

		return brush;
	}
	, 
	__previousFont: null

	, 
	ensureContextFont: function () {
		if (this.context() == null) {
			return;
		}

		var font = this.model().axis().seriesViewer().getFont();
		if (this.model().labelSettings() != null && this.model().labelSettings().textStyle() != null) {
			font = this.model().labelSettings().textStyle();
		}

		if (this.__previousFont != font) {
			this.updateCurrentFontHeight();
		}

		this.context().setFont(font);
	}
	, 
	__fontHeight: 0

	, 
	updateCurrentFontHeight: function () {
		if (this.model().axis() != null && this.model().axis().seriesViewer() != null) {
			if (this.model().labelSettings() == null || this.model().labelSettings().textStyle() == null) {
				this.__fontHeight = this.model().axis().seriesViewer().view().fontHeight();
				return;
			}

			if (this.__fontHeight == 0) {
				this.__fontHeight = this.model().axis().seriesViewer().view().fontHeight();
			}

			var oldHeight = this.__fontHeight;
			var font = this.model().axis().seriesViewer().getFont();
			if (this.model().labelSettings() != null && this.model().labelSettings().textStyle() != null) {
				font = this.model().labelSettings().textStyle();
			}

			var height = $.ig.FontUtil.prototype.getCurrentFontHeight(this.model().axis().seriesViewer().view().viewManager().container(), font);
			this.__fontHeight = height;
			if (oldHeight != this.__fontHeight) {
				this.model().axis().seriesViewer().invalidatePanels();
			}

		}

	}
	, 
	__titleHeight: 0

	, 
	getAxisTitleDesiredHeight: function () {
		if (this.model().axis().title() == null) {
			return 0;
		}

		if (!$.ig.util.isNaN(this.__titleHeight)) {
			return this.__titleHeight;
		}

		var font = this.getAxisTitleFont();
		this.__titleHeight = $.ig.FontUtil.prototype.getCurrentFontHeight(this.model().axis().seriesViewer().view().viewManager().container(), font);
		return this.__titleHeight;
	}

	, 
	getAxisTitleDesiredWidth: function () {
		var tb = this.model().axis().titleTextBlock();
		if (tb != null && tb.text() != null) {
			this.context().setFont(this.getAxisTitleFont());
			var val = this.context().measureTextWidth(tb.text());
			this.ensureContextFont();
			return val;
		}

		return 0;
	}

	, 
	renderTicks: function () {
		if (this.model().axis().tickStroke() == null) {
			this.ticks().__stroke = this.model().axis().chart().getAxisLineBrush();

		} else {
			this.ticks().__stroke = this.model().axis().tickStroke();
		}

		this.ticks().strokeThickness(this.model().axis().tickStrokeThickness());
		this.context().renderPath(this.ticks());
	}

	, 
	arrangeTicks: function (finalSize) {
	}

	, 
	getTitleTopMargin: function () {
		if (this.model().axis().titleSettings() != null && !$.ig.util.isNaN(this.model().axis().titleSettings().topMargin())) {
			return Math.max(0, this.model().axis().titleSettings().topMargin());

		} else {
			return this.model().axis().seriesViewer().getDefaultHorizontalAxisTitleMargin().top();
		}

	}

	, 
	getTitleBottomMargin: function () {
		if (this.model().axis().titleSettings() != null && !$.ig.util.isNaN(this.model().axis().titleSettings().bottomMargin())) {
			return Math.max(0, this.model().axis().titleSettings().bottomMargin());

		} else {
			return this.model().axis().seriesViewer().getDefaultHorizontalAxisTitleMargin().bottom();
		}

	}

	, 
	getTitleLeftMargin: function () {
		if (this.model().axis().titleSettings() != null && !$.ig.util.isNaN(this.model().axis().titleSettings().leftMargin())) {
			return Math.max(0, this.model().axis().titleSettings().leftMargin());

		} else {
			return this.model().axis().seriesViewer().getDefaultHorizontalAxisTitleMargin().left();
		}

	}

	, 
	getTitleRightMargin: function () {
		if (this.model().axis().titleSettings() != null && !$.ig.util.isNaN(this.model().axis().titleSettings().rightMargin())) {
			return Math.max(0, this.model().axis().titleSettings().rightMargin());

		} else {
			return this.model().axis().seriesViewer().getDefaultHorizontalAxisTitleMargin().right();
		}

	}

	, 
	getTicksGeometry: function () {
		return ($.ig.util.cast($.ig.GeometryGroup.prototype.$type, this.ticks().data())).children();
	}

	, 
	getThicksRenderingInfo: function () {
		var $self = this;
		var ret = (function () { var $ret = new $.ig.PathRenderingInfo();
		$ret.stroke($self.model().axis().tickStroke());
		$ret.strokeThickness($self.model().axis().tickStrokeThickness()); return $ret;}());
		if ($self.model().axis() != null && $.ig.util.cast($.ig.XamDataChart.prototype.$type, $self.model().axis().chart()) !== null) {
			var c = $self.model().axis().chart();
			if (c.alignsGridLinesToPixels() && c.state() != $.ig.InteractionState.prototype.dragPan && c.state() != $.ig.InteractionState.prototype.dragZoom) {
				ret.alignToPixels(true);
			}

		}

		return ret;
	}

	, 
	getLabelTopMargin: function () {
		if (this.model().labelSettings() == null) {
			return 0;
		}

		return Math.max(0, this.model().labelSettings().topMargin());
	}

	, 
	getLabelLeftMargin: function () {
		if (this.model().labelSettings() == null) {
			return 0;
		}

		return Math.max(0, this.model().labelSettings().leftMargin());
	}

	, 
	getLabelRightMargin: function () {
		if (this.model().labelSettings() == null) {
			return 0;
		}

		return Math.max(0, this.model().labelSettings().rightMargin());
	}

	, 
	getLabelBottomMargin: function () {
		if (this.model().labelSettings() == null) {
			return 0;
		}

		return Math.max(0, this.model().labelSettings().bottomMargin());
	}
	, 
	$type: new $.ig.Type('AxisLabelPanelBaseView', $.ig.Object.prototype.$type)
}, true);


$.ig.util.defType('AxisLabelPanelBase', 'Panel', {

	createView: function () {
		return new $.ig.AxisLabelPanelBaseView(this);
	}

	, 
	onViewCreated: function (view) {
	}

	, 
	_view: null,
	view: function (value) {
		if (arguments.length === 1) {
			this._view = value;
			return value;
		} else {
			return this._view;
		}
	}
	, 
	init: function () {


		this._actualExtent = 50;

		$.ig.Panel.prototype.init.call(this);
			this.viewportRect($.ig.Rect.prototype.empty());
			this.labelViewport($.ig.Rect.prototype.empty());
			this.view(this.createView());
			this.onViewCreated(this.view());
			this.view().onInit();
			this.textBlocks(new $.ig.List$1($.ig.FrameworkElement.prototype.$type, 0));
			this.labelPositions(new $.ig.List$1($.ig.LabelPosition.prototype.$type, 0));
			this.labelBounds(new $.ig.List$1($.ig.Rect.prototype.$type, 0));
			this.useStaggering(false);
			this.useRotation(false);
			this.useWrapping(false);
			this.foundCollisions(false);
	}

	, 
	_interval: 0,
	interval: function (value) {
		if (arguments.length === 1) {
			this._interval = value;
			return value;
		} else {
			return this._interval;
		}
	}

	, 
	_axis: null,
	axis: function (value) {
		if (arguments.length === 1) {
			this._axis = value;
			return value;
		} else {
			return this._axis;
		}
	}

	, 
	_labelDataContext: null,
	labelDataContext: function (value) {
		if (arguments.length === 1) {
			this._labelDataContext = value;
			return value;
		} else {
			return this._labelDataContext;
		}
	}

	, 
	_labelPositions: null,
	labelPositions: function (value) {
		if (arguments.length === 1) {
			this._labelPositions = value;
			return value;
		} else {
			return this._labelPositions;
		}
	}

	, 
	_viewportRect: null,
	viewportRect: function (value) {
		if (arguments.length === 1) {
			this._viewportRect = value;
			return value;
		} else {
			return this._viewportRect;
		}
	}

	, 
	_labelViewport: null,
	labelViewport: function (value) {
		if (arguments.length === 1) {
			this._labelViewport = value;
			return value;
		} else {
			return this._labelViewport;
		}
	}

	, 
	_windowRect: null,
	windowRect: function (value) {
		if (arguments.length === 1) {
			this._windowRect = value;
			return value;
		} else {
			return this._windowRect;
		}
	}
	, 
	__crossingValue: 0

	, 
	crossingValue: function (value) {
		if (arguments.length === 1) {

			this.__crossingValue = value;
			return value;
		} else {

			return this.__crossingValue;
		}
	}

	, 
	_textBlocks: null,
	textBlocks: function (value) {
		if (arguments.length === 1) {
			this._textBlocks = value;
			return value;
		} else {
			return this._textBlocks;
		}
	}

	, 
	_labelBounds: null,
	labelBounds: function (value) {
		if (arguments.length === 1) {
			this._labelBounds = value;
			return value;
		} else {
			return this._labelBounds;
		}
	}

	, 
	_labelSettings: null,
	labelSettings: function (value) {
		if (arguments.length === 1) {
			this._labelSettings = value;
			return value;
		} else {
			return this._labelSettings;
		}
	}

	, 
	_foundCollisions: false,
	foundCollisions: function (value) {
		if (arguments.length === 1) {
			this._foundCollisions = value;
			return value;
		} else {
			return this._foundCollisions;
		}
	}

	, 
	_useRotation: false,
	useRotation: function (value) {
		if (arguments.length === 1) {
			this._useRotation = value;
			return value;
		} else {
			return this._useRotation;
		}
	}

	, 
	_useStaggering: false,
	useStaggering: function (value) {
		if (arguments.length === 1) {
			this._useStaggering = value;
			return value;
		} else {
			return this._useStaggering;
		}
	}

	, 
	_useWrapping: false,
	useWrapping: function (value) {
		if (arguments.length === 1) {
			this._useWrapping = value;
			return value;
		} else {
			return this._useWrapping;
		}
	}

	, 
	_longestTextBlock: null,
	longestTextBlock: function (value) {
		if (arguments.length === 1) {
			this._longestTextBlock = value;
			return value;
		} else {
			return this._longestTextBlock;
		}
	}

	, 
	_areLabelsUnevenlySpaced: false,
	areLabelsUnevenlySpaced: function (value) {
		if (arguments.length === 1) {
			this._areLabelsUnevenlySpaced = value;
			return value;
		} else {
			return this._areLabelsUnevenlySpaced;
		}
	}

	, 
	detectCollisions: function (rectangles) {
		for (var i = 0; i < rectangles.count() - 1; i++) {
			for (var j = i; j < rectangles.count() - 1; j++) {
				if (rectangles.__inner[i].intersectsWith(rectangles.__inner[j + 1])) {
					return true;
				}

			}

		}

		return false;
	}

	, 
	staggerLabels: function (largestHeight, rectangles) {
		return {
			ret: 0, 
			p1: rectangles
		};
	}

	, 
	createBoundsRectangles: function () {
		return null;
	}

	, 
	bindExtent: function () {
	}

	, 
	applyPanelRotation: function (finalSize) {
	}

	, 
	getEffectiveAngle: function () {
		return this.labelSettings() != null ? this.labelSettings().angle() : 0;
	}

	, 
	getTitleEffectiveAngle: function () {
		return this.axis().titleSettings() != null ? this.axis().titleSettings().angle() : 0;
	}

	, 
	shouldDisplay: function (index, bounds) {
		if (index == 0 && !this.axis().isAngular() && this.labelSettings() != null) {
			if (this.axis().isVertical()) {
				if (!this.labelSettings().showFirstLabel() && this.axis().seriesViewer().getActualWindowScaleVertical() == 1) {
					return false;
				}


			} else {
				if (!this.labelSettings().showFirstLabel() && this.axis().seriesViewer().getActualWindowScaleHorizontal() == 1) {
					return false;
				}

			}

		}

		return true;
	}

	, 
	getDesiredWidth: function (element) {
		return this.view().getDesiredWidth(element);
	}

	, 
	getWidthBounds: function (element) {
		return this.view().getWidthBounds(element);
	}

	, 
	getHeightBounds: function (element) {
		return this.view().getHeightBounds(element);
	}

	, 
	getDesiredHeight: function (element) {
		return this.view().getDesiredHeight(element);
	}

	, 
	isHorizontalPanel: function () {
		return false;
	}

	, 
	determineLabelBounds: function () {
		if (this.children().count() < 1 || this.labelPositions().count() == 0) {
			return new $.ig.List$1($.ig.Rect.prototype.$type, 0);
		}

		this.textBlocks(new $.ig.List$1($.ig.FrameworkElement.prototype.$type, 0));
		this.labelBounds(new $.ig.List$1($.ig.Rect.prototype.$type, 0));
		this.bindExtent();
		this.view().determineLongestLabel();
		var angle = this.getEffectiveAngle();
		if (angle % 360 == 0) {
			this.useRotation(false);
		}

		if (this.textBlocks().count() == 0) {
			return new $.ig.List$1($.ig.Rect.prototype.$type, 0);
		}

		this.labelBounds(this.createBoundsRectangles());
		return this.labelBounds();
	}

	, 
	getRotatedRectWidth: function (angleDegrees, rect) {
		var rad = angleDegrees * (Math.PI / 180);
		var rotatedTitleWidth = Math.abs(rect.width() * Math.cos(rad)) + Math.abs(rect.height() * Math.sin(rad));
		return rotatedTitleWidth;
	}

	, 
	getRotatedRectHeight: function (angleDegrees, rect) {
		var rad = angleDegrees * (Math.PI / 180);
		var rotatedTitleHeight = Math.abs(rect.height() * Math.cos(rad)) + Math.abs(rect.width() * Math.sin(rad));
		return rotatedTitleHeight;
	}

	, 
	getTitleWidth: function () {
		var titleWidth = this.view().getAxisTitleDesiredWidth();
		return titleWidth;
	}

	, 
	getTitleHeight: function () {
		var titleHeight = this.view().getAxisTitleDesiredHeight();
		return titleHeight;
	}

	, 
	getTitleHeightBounds: function () {
		if (this.axis().title() == null) {
			return 0;
		}

		var height = this.getTitleHeight();
		var width = this.getTitleWidth();
		var rect = new $.ig.Rect(0, 0, 0, width, height);
		var angleDegrees = this.getTitleEffectiveAngle();
		var rotated = $.ig.RectUtil.prototype.rotateAboutCenter(rect, angleDegrees);
		return rotated.height() + this.view().getTitleTopMargin() + this.view().getTitleBottomMargin();
	}

	, 
	getTitleWidthBounds: function () {
		if (this.axis().title() == null) {
			return 0;
		}

		var height = this.getTitleHeight();
		var width = this.getTitleWidth();
		var rect = new $.ig.Rect(0, 0, 0, width, height);
		var angleDegrees = this.getTitleEffectiveAngle();
		var rotated = $.ig.RectUtil.prototype.rotateAboutCenter(rect, angleDegrees);
		return rotated.width() + this.view().getTitleLeftMargin() + this.view().getTitleRightMargin();
	}

	, 
	arrangeLabels: function (finalSize) {
		if (this.axis() == null || this.children().count() == 0) {
			return finalSize;
		}

		this.arrangeTitle(finalSize);
		this.createTicks();
		this.arrangeTicks(finalSize);
		this.labelBounds(this.determineLabelBounds());
		if (this.textBlocks().count() != this.labelBounds().count()) {
			return finalSize;
		}

		var leftMargin = this.view().getLabelLeftMargin();
		var topMargin = this.view().getLabelTopMargin();
		var rightMargin = this.view().getLabelRightMargin();
		var botomMargin = this.view().getLabelBottomMargin();
		if (this.useRotation()) {
			for (var i = 0; i < this.textBlocks().count(); i++) {
				if (this.shouldDisplay(i, this.labelBounds().__inner[i])) {
					this.view().arrangeTextToBounds(this.textBlocks().__inner[i], this.labelBounds().__inner[i], leftMargin, topMargin, rightMargin, botomMargin);
				}

				this.setLabelRotationTransform(this.textBlocks().__inner[i], this.getEffectiveAngle());
			}

		}

		for (var i1 = 0; i1 < this.textBlocks().count(); i1++) {
			if (!this.useRotation()) {
				this.view().clearTransforms(this.textBlocks().__inner[i1]);
			}

			if (this.shouldDisplay(i1, this.labelBounds().__inner[i1])) {
				this.view().arrangeTextToBounds(this.textBlocks().__inner[i1], this.labelBounds().__inner[i1], leftMargin, topMargin, rightMargin, botomMargin);

			} else {
				this.view().arrangeTextToBounds(this.textBlocks().__inner[i1], new $.ig.Rect(0, 0, 0, 0, 0), leftMargin, topMargin, rightMargin, botomMargin);
			}

		}

		this.applyPanelRotation(finalSize);
		return finalSize;
	}

	, 
	getTitleBounds: function () {
		return $.ig.Rect.prototype.empty();
	}

	, 
	arrangeTitle: function (finalSize) {
		if (this.axis().titleTextBlock() == null) {
			return;
		}

		this.view().handleMeasureLabel1(this.axis().titleTextBlock(), new $.ig.Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY));
		var useTitleRotation = Math.abs(this.getTitleEffectiveAngle() - 0) > 1E-06;
		var titleBounds = this.getTitleBounds();
		var titleBoundsWidthMiddle = titleBounds.left() + (titleBounds.width() / 2);
		var titleBoundsHeightMiddle = titleBounds.top() + (titleBounds.height() / 2);
		var titleWidth = this.getTitleWidth() + this.view().getTitleLeftMargin() + this.view().getTitleRightMargin();
		var titleHeight = this.getTitleHeight() + this.view().getTitleTopMargin() + this.view().getTitleBottomMargin();
		var titleWidthHalf = titleWidth / 2;
		var titleHeightHalf = titleHeight / 2;
		var renderBounds = new $.ig.Rect(0, titleBoundsWidthMiddle - titleWidthHalf, titleBoundsHeightMiddle - titleHeightHalf, titleWidth, titleHeight);
		if (useTitleRotation) {
			this.setTitleRotationTransform(this.axis().titleTextBlock());

		} else {
			this.view().clearTransforms(this.axis().titleTextBlock());
		}

		this.view().arrangeTextToBounds(this.axis().titleTextBlock(), renderBounds, this.view().getTitleLeftMargin(), this.view().getTitleTopMargin(), this.view().getTitleRightMargin(), this.view().getTitleBottomMargin());
		if (this.axis().labelSettings() == null || this.axis().labelSettings().visibility() == $.ig.Visibility.prototype.visible) {
			this.axis().titleTextBlock().__visibility = $.ig.Visibility.prototype.visible;

		} else {
			this.axis().titleTextBlock().__visibility = $.ig.Visibility.prototype.collapsed;
		}

	}

	, 
	arrangeTicks: function (finalSize) {
		this.view().arrangeTicks(finalSize);
	}

	, 
	createTicks: function () {
	}

	, 
	getTickValues: function () {
		if ($.ig.util.cast($.ig.CategoryAxisBase.prototype.$type, this.axis()) !== null) {
			return (this.axis()).majorLinePositions();
		}

		if ($.ig.util.cast($.ig.NumericAxisBase.prototype.$type, this.axis()) !== null) {
			var values = new $.ig.List$1(Number, 0);
			for (var i = 0; i < (this.axis()).actualTickmarkValues().majorValuesArray().length; i++) {
				var val = (this.axis()).actualTickmarkValues().majorValuesArray()[i];
				var sParams = new $.ig.ScalerParams(this.axis().seriesViewer().windowRect(), this.axis().viewportRect(), this.axis().isInvertedCached());
				values.add(this.axis().getScaledValue(val, sParams));
			}

			return values;
		}

		return null;
	}

	, 
	actualLabelLocation: function () {

			var actualLocation = this.labelSettings() != null ? this.labelSettings().actualLocation() : this.getDefaultLabelsLocation();
			if (this.axis().crossingAxis() == null) {
				if (actualLocation == $.ig.AxisLabelsLocation.prototype.insideTop) {
				actualLocation = $.ig.AxisLabelsLocation.prototype.insideBottom;

				} else if (actualLocation == $.ig.AxisLabelsLocation.prototype.insideBottom) {
				actualLocation = $.ig.AxisLabelsLocation.prototype.insideTop;

				} else if (actualLocation == $.ig.AxisLabelsLocation.prototype.insideLeft) {
				actualLocation = $.ig.AxisLabelsLocation.prototype.insideRight;

				} else if (actualLocation == $.ig.AxisLabelsLocation.prototype.insideRight) {
				actualLocation = $.ig.AxisLabelsLocation.prototype.insideLeft;
				}




			}

			return actualLocation;
	}

	, 
	verticalTick: function (geometry, x, y1, y2, viewportRect, renderingInfo) {
		if (x >= viewportRect.left() && x <= viewportRect.right()) {
			if (renderingInfo.alignToPixels()) {
				x = this.axis().alignLineToPixels(x, viewportRect.left(), viewportRect.right(), renderingInfo);
			}

			var tick = new $.ig.LineGeometry();
			tick.startPoint({__x: x, __y: y1, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			tick.endPoint({__x: x, __y: y2, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			geometry.add(tick);
		}

	}

	, 
	horizontalTick: function (geometry, y, x1, x2, viewportRect, renderingInfo) {
		if (y <= viewportRect.bottom() && y >= viewportRect.top()) {
			if (renderingInfo.alignToPixels()) {
				y = this.axis().alignLineToPixels(y, viewportRect.top(), viewportRect.bottom(), renderingInfo);
			}

			var tick = new $.ig.LineGeometry();
			tick.startPoint({__x: x1, __y: y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			tick.endPoint({__x: x2, __y: y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			geometry.add(tick);
		}

	}

	, 
	setLabelRotationTransform: function (label, angle) {
		var effAngle = this.getEffectiveAngle();
		this.view().handleSetLabelRotationTransform(label, effAngle);
	}

	, 
	setTitleRotationTransform: function (label) {
		var effAngle = this.getTitleEffectiveAngle();
		this.handleSetTitleLabelRotationTransform(label, effAngle);
	}

	, 
	handleSetTitleLabelRotationTransform: function (label, effAngle) {
		var $self = this;
		var fe = $.ig.util.cast($.ig.FrameworkElement.prototype.$type, label);
		var height = $self.getTitleHeight();
		var width = $self.getTitleWidth();
		var centerX = 0.5 * width;
		var centerY = 0.5 * height;
		var transform = (function () { var $ret = new $.ig.RotateTransform();
		$ret.angle(effAngle);
		$ret.centerX(centerX);
		$ret.centerY(centerY); return $ret;}());
		var group = new $.ig.TransformGroup();
		group.children().add(transform);
		fe.renderTransform(group);
	}

	, 
	measureLabels: function (availableSize) {
		var en = this.children().getEnumerator();
		while (en.moveNext()) {
			var element = en.current();
			this.view().handleMeasureLabel(element);
		}

		var extent = (this.axis() == null || this._actualExtent <= 0 || $.ig.util.isNaN(this._actualExtent)) ? 50 : this._actualExtent;
		if (this.axis() != null && (this.axis().series() == null || this.axis().series().count() == 0)) {
			if (this.axis().hasUserExtent()) {
				extent = this.axis().getUserExtent();
			}

		}

		var size = new $.ig.Size(1, extent, extent);
		if (Number.isInfinity(size.width())) {
			size.width(50);
		}

		if (Number.isInfinity(size.height())) {
			size.height(50);
		}

		return size;
	}

	, 
	extent: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.AxisLabelPanelBase.prototype.extentProperty, value);
			return value;
		} else {

			return this.getValue($.ig.AxisLabelPanelBase.prototype.extentProperty);
		}
	}
	, 
	_actualExtent: 0

	, 
	getTitlePosition: function (titleSettings) {
		if (titleSettings == null) {
			return this.axis().seriesViewer().getDefaultHorizontalAxisTitlePosition(this.axis());
		}

		if (titleSettings.position() == $.ig.AxisTitlePosition.prototype.auto) {
			if (this.axis() != null && this.axis().seriesViewer() != null) {
				return this.axis().seriesViewer().getDefaultHorizontalAxisTitlePosition(this.axis());
			}

			return $.ig.AxisTitlePosition.prototype.bottom;
		}

		return titleSettings.position();
	}

	, 
	getDefaultLabelsLocation: function () {
		return $.ig.AxisLabelsLocation.prototype.outsideBottom;
	}

	, 
	validLocation: function (location) {
		return true;
	}

	, 
	getLabels: function () {
		var d__ = new $.ig.AxisLabelPanelBase___GetLabels__IteratorClass(-2);
		d__.__4__this = this;
		return d__;
	}

	, 
	trimTextBlock: function (index, textblock, availableWidth) {
		var result = this.view().trimTextBlock(textblock, availableWidth);
		return result;
	}

	, 
	considerForLongestTextBlock: function (textElement) {
		if (this.longestTextBlock() == null || this.getDesiredWidth(this.longestTextBlock()) < this.getDesiredWidth(textElement)) {
			this.longestTextBlock(textElement);
		}

	}

	, 
	onProcessTextBlock: function (textElement) {
		this.textBlocks().add(textElement);
	}

	, 
	getTextBlocks: function () {
		var d__ = new $.ig.AxisLabelPanelBase___GetTextBlocks__IteratorClass(-2);
		d__.__4__this = this;
		return d__;
	}

	, 
	ensureExtentSet: function () {
		this.view().ensureContextFont();
		this.updateLabelBounds();
	}

	, 
	updateLabelBounds: function () {
		this.labelBounds(this.determineLabelBounds());
	}

	, 
	measure: function () {
		this.view().measure();
	}

	, 
	provideContext: function (context) {
		this.view().onContextProvided(context);
	}

	, 
	arrange: function () {
		this.view().arrange();
	}

	, 
	render: function () {
		this.view().render();
	}
	, 
	$type: new $.ig.Type('AxisLabelPanelBase', $.ig.Panel.prototype.$type)
}, true);



$.ig.util.defType('Axis', 'Control', {

	createView: function () {
		return new $.ig.AxisView(this);
	}

	, 
	_view: null,
	view: function (value) {
		if (arguments.length === 1) {
			this._view = value;
			return value;
		} else {
			return this._view;
		}
	}

	, 
	onViewCreated: function (view) {
	}

	, 
	isCategory: function () {

			return false;
	}

	, 
	isNumeric: function () {

			return false;
	}

	, 
	isAngular: function () {

			return false;
	}

	, 
	isRadial: function () {

			return false;
	}

	, 
	isVertical: function () {

			return false;
	}

	, 
	isSorting: function () {

			return false;
	}

	, 
	isDateTime: function () {

			return false;
	}
	, 
	init: function () {


		this.__useSmartAxis = false;
		this.__smartAxisExtent = NaN;
		this.__actualSmartAxisExtent = 50;
		this.__smartAxisMinimumExtent = 0;
		this.__smartAxisMaximumExtent = NaN;
		this.__smartAxisExtentType = $.ig.AxisExtentType.prototype.pixel;
		this.__smartAxisAngle = NaN;
		this.__smartAxisMinimumAngle = 0;
		this.__smartAxisMaximumAngle = 180;
		this.__smartAxisFont = $.ig.FontUtil.prototype.getDefaultFont();
		this.__smartAxisFontSize = NaN;
		this.__smartAxisMinimumFontSize = 8;
		this.__smartAxisMaximumFontSize = 16;
		this.__smartAxisNumberOfStaggerLevels = -1;
		this.__smartAxisMinimumStaggerLevels = 1;
		this.__smartAxisMaximumStaggerLevels = 3;
		this.__smartAxisVerticalAlignment = $.ig.VerticalAlignment.prototype.top;
		this.__smartAxisTopMargin = 0;
		this.__smartAxisProximityMargin = 20;
		this.__viewport = $.ig.Rect.prototype.empty();
		this.__mustInvalidateLabels = false;
		this.__expectFunctions = false;
		this._measuredSize = new $.ig.Size();
		this.__axisComponentsForView = new $.ig.AxisComponentsForView();
		this.__currentLabelSettings = new $.ig.AxisLabelSettings();

		var $self = this;
		$.ig.Control.prototype.init.call(this);
			this.extentOverride(NaN);
			this.view(this.createView());
			this.onViewCreated(this.view());
			this.view().onInit();
			this.textBlocks((function () { var $ret = new $.ig.Pool$1($.ig.TextBlock.prototype.$type);
			$ret.create($self.view().textBlockCreate.runOn($self.view()));
			$ret.activate($self.view().textBlockActivate.runOn($self.view()));
			$ret.disactivate($self.view().textBlockDisactivate.runOn($self.view()));
			$ret.destroy($self.view().textBlockDestroy.runOn($self.view())); return $ret;}()));
			this.viewportOverride($.ig.Rect.prototype.empty());
			this.labelDataContext(new $.ig.List$1($.ig.Object.prototype.$type, 0));
			this.labelPositions(new $.ig.List$1($.ig.LabelPosition.prototype.$type, 0));
			this.labelPanel(this.createLabelPanel());
			this.labelPanel().labelSettings(this.labelSettings());
			this.labelPanel().axis(this);
			this.series(new $.ig.List$1($.ig.Series.prototype.$type, 0));
			this.defaultStyleKey($.ig.Axis.prototype.$type);
			this.propertyUpdated = $.ig.Delegate.prototype.combine(this.propertyUpdated, function (o, e) { $self.propertyUpdatedOverride(o, e.propertyName(), e.oldValue(), e.newValue()); });
			this._seriesViewer_WindowRectChanged = function (o, e) {
				if ($self.seriesViewer() == null || !$self.seriesViewer().ignoreWindowChanges()) {
					$self.windowRectChangedOverride(e.oldRect(), e.newRect());
				}

			};
			this.view().bindLabelPanelStyle();
			this.applyDefaultSettings();
			this.labelPanel().labelSettings(this.labelSettings());
	}

	, 
	formatLabel: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Axis.prototype.formatLabelProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Axis.prototype.formatLabelProperty);
		}
	}

	, 
	handleRectChanged: function (oldRect, newRect) {
		if (!oldRect.equals1(newRect)) {
			this.viewportChangedOverride(oldRect, newRect);
		}

	}

	, 
	createLabelPanel: function () {}

	, 
	onApplyTemplate: function () {
		$.ig.Control.prototype.onApplyTemplate.call(this);
		this.view().onTemplateProvided();
	}

	, 
	_rootCanvas: null,
	rootCanvas: function (value) {
		if (arguments.length === 1) {
			this._rootCanvas = value;
			return value;
		} else {
			return this._rootCanvas;
		}
	}

	, 
	fastItemsSourceProvider: function (value) {
		if (arguments.length === 1) {

			if (this.fastItemsSourceProvider() != value) {
				var oldChart = this.fastItemsSourceProvider();
				this._fastItemsSourceProvider = value;
				this.raisePropertyChanged($.ig.Axis.prototype.fastItemsSourceProviderPropertyName, oldChart, this._fastItemsSourceProvider);
			}

			return value;
		} else {

			return this._fastItemsSourceProvider;
		}
	}
	, 
	_fastItemsSourceProvider: null

	, 
	seriesViewer: function (value) {
		if (arguments.length === 1) {

			if (this.seriesViewer() != value) {
				var oldChart = this.seriesViewer();
				this.__seriesViewer = value;
				this.raisePropertyChanged($.ig.Axis.prototype.seriesViewerPropertyName, oldChart, this.__seriesViewer);
			}

			return value;
		} else {

			return this.__seriesViewer;
		}
	}
	, 
	__seriesViewer: null

	, 
	chart: function (value) {
		if (arguments.length === 1) {

			this.seriesViewer(value);
			return value;
		} else {

			return $.ig.util.cast($.ig.XamDataChart.prototype.$type, this.seriesViewer());
		}
	}
	, 
	_seriesViewer_WindowRectChanged: null
	, 
	__useSmartAxis: false

	, 
	useSmartAxis: function (value) {
		if (arguments.length === 1) {

			this.__useSmartAxis = value;
			var labelViewport = null;
			if (this.labelPanel() != null && this.labelPanel().labelViewport() != null) {
				labelViewport = this.labelPanel().labelViewport();
			}

			this.labelPanel(this.createLabelPanel());
			this.labelPanel().axis(this);
			this.labelPanel().labelSettings(this.labelSettings());
			if (labelViewport != null) {
				this.labelPanel().labelViewport(labelViewport);
			}

			if (this.seriesViewer() != null && this.seriesViewer().view() != null) {
				this.labelPanel().view().onContextProvided(this.seriesViewer().view().mainContext());
				this.refreshAxis1(true);
			}

			return value;
		} else {

			return this.__useSmartAxis;
		}
	}
	, 
	__smartAxisExtent: 0

	, 
	smartAxisExtent: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__smartAxisExtent;
			if (oldValue != value) {
				this.__smartAxisExtent = value;
				this.actualSmartAxisExtent(value);
				this.refreshAxis1(true);
			}

			return value;
		} else {

			return this.__smartAxisExtent;
		}
	}
	, 
	__actualSmartAxisExtent: 0

	, 
	actualSmartAxisExtent: function (value) {
		if (arguments.length === 1) {

			this.__actualSmartAxisExtent = value;
			return value;
		} else {

			return this.__actualSmartAxisExtent;
		}
	}
	, 
	__smartAxisMinimumExtent: 0

	, 
	smartAxisMinimumExtent: function (value) {
		if (arguments.length === 1) {

			this.__smartAxisMinimumExtent = value;
			this.refreshAxis1(true);
			return value;
		} else {

			return this.__smartAxisMinimumExtent;
		}
	}
	, 
	__smartAxisMaximumExtent: 0

	, 
	smartAxisMaximumExtent: function (value) {
		if (arguments.length === 1) {

			this.__smartAxisMaximumExtent = value;
			this.refreshAxis1(true);
			return value;
		} else {

			return this.__smartAxisMaximumExtent;
		}
	}
	, 
	__smartAxisExtentType: 0

	, 
	smartAxisExtentType: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__smartAxisExtentType;
			if (oldValue != value) {
				this.__smartAxisExtentType = value;
				this.refreshAxis1(true);
			}

			return value;
		} else {

			return this.__smartAxisExtentType;
		}
	}
	, 
	__smartAxisAngle: 0

	, 
	smartAxisAngle: function (value) {
		if (arguments.length === 1) {

			this.__smartAxisAngle = value;
			this.refreshAxis();
			return value;
		} else {

			return this.__smartAxisAngle;
		}
	}

	, 
	_actualSmartAxisAngle: 0,
	actualSmartAxisAngle: function (value) {
		if (arguments.length === 1) {
			this._actualSmartAxisAngle = value;
			return value;
		} else {
			return this._actualSmartAxisAngle;
		}
	}
	, 
	__smartAxisMinimumAngle: 0

	, 
	smartAxisMinimumAngle: function (value) {
		if (arguments.length === 1) {

			this.__smartAxisMinimumAngle = value;
			this.refreshAxis();
			return value;
		} else {

			return this.__smartAxisMinimumAngle;
		}
	}
	, 
	__smartAxisMaximumAngle: 0

	, 
	smartAxisMaximumAngle: function (value) {
		if (arguments.length === 1) {

			this.__smartAxisMaximumAngle = value;
			this.refreshAxis();
			return value;
		} else {

			return this.__smartAxisMaximumAngle;
		}
	}
	, 
	__smartAxisFont: null

	, 
	smartAxisFont: function (value) {
		if (arguments.length === 1) {

			this.__smartAxisFont = value;
			this.__smartAxisFontSize = $.ig.FontUtil.prototype.getFontSize(this.__smartAxisFont);
			this.refreshAxis();
			return value;
		} else {

			return this.__smartAxisFont;
		}
	}
	, 
	__smartAxisFontSize: 0

	, 
	smartAxisFontSize: function (value) {
		if (arguments.length === 1) {

			this.__smartAxisFontSize = value;
			this.__smartAxisFont = $.ig.FontUtil.prototype.getFontWithNewFontSize(this.__smartAxisFont, this.__smartAxisFontSize);
			this.refreshAxis();
			return value;
		} else {

			return this.__smartAxisFontSize;
		}
	}

	, 
	_actualSmartAxisFontSize: 0,
	actualSmartAxisFontSize: function (value) {
		if (arguments.length === 1) {
			this._actualSmartAxisFontSize = value;
			return value;
		} else {
			return this._actualSmartAxisFontSize;
		}
	}
	, 
	__smartAxisMinimumFontSize: 0

	, 
	smartAxisMinimumFontSize: function (value) {
		if (arguments.length === 1) {

			this.__smartAxisMinimumFontSize = value;
			this.refreshAxis();
			return value;
		} else {

			return this.__smartAxisMinimumFontSize;
		}
	}
	, 
	__smartAxisMaximumFontSize: 0

	, 
	smartAxisMaximumFontSize: function (value) {
		if (arguments.length === 1) {

			this.__smartAxisMaximumFontSize = value;
			this.refreshAxis();
			return value;
		} else {

			return this.__smartAxisMaximumFontSize;
		}
	}
	, 
	__smartAxisNumberOfStaggerLevels: 0

	, 
	smartAxisNumberOfStaggerLevels: function (value) {
		if (arguments.length === 1) {

			this.__smartAxisNumberOfStaggerLevels = value;
			this.refreshAxis();
			return value;
		} else {

			return this.__smartAxisNumberOfStaggerLevels;
		}
	}
	, 
	__smartAxisMinimumStaggerLevels: 0

	, 
	smartAxisMinimumStaggerLevels: function (value) {
		if (arguments.length === 1) {

			this.__smartAxisMinimumStaggerLevels = value;
			this.refreshAxis();
			return value;
		} else {

			return this.__smartAxisMinimumStaggerLevels;
		}
	}
	, 
	__smartAxisMaximumStaggerLevels: 0

	, 
	smartAxisMaximumStaggerLevels: function (value) {
		if (arguments.length === 1) {

			this.__smartAxisMaximumStaggerLevels = value;
			this.refreshAxis();
			return value;
		} else {

			return this.__smartAxisMaximumStaggerLevels;
		}
	}

	, 
	_actualSmartAxisNumberOfStaggerLevels: 0,
	actualSmartAxisNumberOfStaggerLevels: function (value) {
		if (arguments.length === 1) {
			this._actualSmartAxisNumberOfStaggerLevels = value;
			return value;
		} else {
			return this._actualSmartAxisNumberOfStaggerLevels;
		}
	}
	, 
	__smartAxisVerticalAlignment: 0

	, 
	smartAxisVerticalAlignment: function (value) {
		if (arguments.length === 1) {

			this.__smartAxisVerticalAlignment = value;
			this.refreshAxis();
			return value;
		} else {

			return this.__smartAxisVerticalAlignment;
		}
	}
	, 
	__smartAxisTopMargin: 0

	, 
	smartAxisTopMargin: function (value) {
		if (arguments.length === 1) {

			this.__smartAxisTopMargin = value;
			this.refreshAxis();
			return value;
		} else {

			return this.__smartAxisTopMargin;
		}
	}
	, 
	__smartAxisProximityMargin: 0

	, 
	smartAxisProximityMargin: function (value) {
		if (arguments.length === 1) {

			this.__smartAxisProximityMargin = value;
			this.refreshAxis();
			return value;
		} else {

			return this.__smartAxisProximityMargin;
		}
	}

	, 
	refreshAxis: function () {
		this.refreshAxis1(false);
	}

	, 
	refreshAxis1: function (shouldResizeAxisPanel) {
		if (this.useSmartAxis() && $.ig.util.cast($.ig.SmartAxisLabelPanel.prototype.$type, this.labelPanel()) !== null) {
			(this.labelPanel()).shouldResize(shouldResizeAxisPanel);
		}

		this.mustInvalidateLabels(true);
		this.refresh();
	}

	, 
	_titleTextBlock: null,
	titleTextBlock: function (value) {
		if (arguments.length === 1) {
			this._titleTextBlock = value;
			return value;
		} else {
			return this._titleTextBlock;
		}
	}

	, 
	title: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Axis.prototype.titleProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Axis.prototype.titleProperty);
		}
	}

	, 
	stroke: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Axis.prototype.strokeProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Axis.prototype.strokeProperty);
		}
	}

	, 
	actualStroke: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Axis.prototype.actualStrokeProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Axis.prototype.actualStrokeProperty);
		}
	}

	, 
	strokeThickness: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Axis.prototype.strokeThicknessProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Axis.prototype.strokeThicknessProperty);
		}
	}

	, 
	strokeDashArray: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Axis.prototype.strokeDashArrayProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Axis.prototype.strokeDashArrayProperty);
		}
	}

	, 
	strip: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Axis.prototype.stripProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Axis.prototype.stripProperty);
		}
	}

	, 
	majorStroke: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Axis.prototype.majorStrokeProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Axis.prototype.majorStrokeProperty);
		}
	}

	, 
	actualMajorStroke: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Axis.prototype.actualMajorStrokeProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Axis.prototype.actualMajorStrokeProperty);
		}
	}

	, 
	majorStrokeThickness: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Axis.prototype.majorStrokeThicknessProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Axis.prototype.majorStrokeThicknessProperty);
		}
	}

	, 
	majorStrokeDashArray: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Axis.prototype.majorStrokeDashArrayProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Axis.prototype.majorStrokeDashArrayProperty);
		}
	}

	, 
	minorStroke: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Axis.prototype.minorStrokeProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Axis.prototype.minorStrokeProperty);
		}
	}

	, 
	actualMinorStroke: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Axis.prototype.actualMinorStrokeProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Axis.prototype.actualMinorStrokeProperty);
		}
	}

	, 
	minorStrokeThickness: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Axis.prototype.minorStrokeThicknessProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Axis.prototype.minorStrokeThicknessProperty);
		}
	}

	, 
	minorStrokeDashArray: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Axis.prototype.minorStrokeDashArrayProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Axis.prototype.minorStrokeDashArrayProperty);
		}
	}

	, 
	tickStroke: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Axis.prototype.tickStrokeProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Axis.prototype.tickStrokeProperty);
		}
	}

	, 
	tickStrokeThickness: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Axis.prototype.tickStrokeThicknessProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Axis.prototype.tickStrokeThicknessProperty);
		}
	}

	, 
	tickStrokeDashArray: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Axis.prototype.tickStrokeDashArrayProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Axis.prototype.tickStrokeDashArrayProperty);
		}
	}

	, 
	tickLength: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Axis.prototype.tickLengthProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Axis.prototype.tickLengthProperty);
		}
	}

	, 
	_actualTickLength: 0,
	actualTickLength: function (value) {
		if (arguments.length === 1) {
			this._actualTickLength = value;
			return value;
		} else {
			return this._actualTickLength;
		}
	}

	, 
	updateActualTickLength: function () {
		if (this.tickLength() > 0) {
			this.actualTickLength(this.tickLength());
			return;
		}

		var chart = $.ig.util.cast($.ig.XamDataChart.prototype.$type, this.seriesViewer());
		if (chart != null && $.ig.util.isNaN(this.tickLength()) && this.isCategory() && (this.isVertical() || this.orientation() == $.ig.AxisOrientation.prototype.horizontal)) {
			this.actualTickLength(chart.chartView().defaultCategoryAxisTickLength());
			return;
		}

		this.actualTickLength(0);
	}

	, 
	isDisabled: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Axis.prototype.isDisabledProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Axis.prototype.isDisabledProperty);
		}
	}

	, 
	isInverted: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Axis.prototype.isInvertedProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Axis.prototype.isInvertedProperty);
		}
	}

	, 
	_isInvertedCached: false,
	isInvertedCached: function (value) {
		if (arguments.length === 1) {
			this._isInvertedCached = value;
			return value;
		} else {
			return this._isInvertedCached;
		}
	}

	, 
	labelSettings: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Axis.prototype.labelSettingsProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Axis.prototype.labelSettingsProperty);
		}
	}

	, 
	labelPanelStyle: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Axis.prototype.labelPanelStyleProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Axis.prototype.labelPanelStyleProperty);
		}
	}

	, 
	crossingAxis: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Axis.prototype.crossingAxisProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Axis.prototype.crossingAxisProperty);
		}
	}

	, 
	crossingValue: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Axis.prototype.crossingValueProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Axis.prototype.crossingValueProperty);
		}
	}
	, 
	rangeChanged: null
	, 
	raiseRangeChanged: function (ea) {
		if (this.rangeChanged != null) {
			this.rangeChanged(this, ea);
		}

	}

	, 
	titleSettings: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Axis.prototype.titleSettingsProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Axis.prototype.titleSettingsProperty);
		}
	}
	, 
	__viewport: null

	, 
	viewportRect: function (value) {
		if (arguments.length === 1) {

			this.__viewport = value;
			return value;
		} else {

			if (this.viewportOverride().isEmpty()) {
				return this.__viewport;
			}

			return this.viewportOverride();
		}
	}

	, 
	_viewportOverride: null,
	viewportOverride: function (value) {
		if (arguments.length === 1) {
			this._viewportOverride = value;
			return value;
		} else {
			return this._viewportOverride;
		}
	}

	, 
	updateLineVisibility: function () {
		var visible = $.ig.Visibility.prototype.visible;
		var dataChart = $.ig.util.cast($.ig.XamDataChart.prototype.$type, this.seriesViewer());
		if (dataChart != null && dataChart.gridMode() == $.ig.GridMode.prototype.none) {
			visible = $.ig.Visibility.prototype.collapsed;
		}

		this.view().updateLineVisibility(visible);
	}

	, 
	validateAxis: function (viewportRect, windowRect, view) {
		return this.seriesViewer() != null;
	}

	, 
	isValid: function () {
		var window = $.ig.Rect.prototype.empty();
		if (this.seriesViewer() != null) {
			window = this.seriesViewer().windowRect();
		}

		return this.validateAxis(this.viewportRect(), window, this.view());
	}

	, 
	_labelDataContext: null,
	labelDataContext: function (value) {
		if (arguments.length === 1) {
			this._labelDataContext = value;
			return value;
		} else {
			return this._labelDataContext;
		}
	}

	, 
	_labelPositions: null,
	labelPositions: function (value) {
		if (arguments.length === 1) {
			this._labelPositions = value;
			return value;
		} else {
			return this._labelPositions;
		}
	}

	, 
	_labelPanel: null,
	labelPanel: function (value) {
		if (arguments.length === 1) {
			this._labelPanel = value;
			return value;
		} else {
			return this._labelPanel;
		}
	}

	, 
	viewportChangedOverride: function (oldRect, newRect) {
		this.viewportRect(newRect);
		this.mustInvalidateLabels(true);
		this.updateRange();
		this.renderAxis1(false);
		if (this.seriesViewer() != null) {
			this.seriesViewer().chartContentManager().viewportChanged($.ig.ChartContentType.prototype.axis, this, this.contentInfo(), newRect);
		}

	}
	, 
	__mustInvalidateLabels: false

	, 
	mustInvalidateLabels: function (value) {
		if (arguments.length === 1) {

			this.__mustInvalidateLabels = value;
			return value;
		} else {

			return this.__mustInvalidateLabels;
		}
	}

	, 
	windowRectChangedOverride: function (oldRect, newRect) {
		this.mustInvalidateLabels(true);
		this.renderAxis1(true);
	}

	, 
	refresh: function () {
		this.renderAxis1(false);
	}

	, 
	_contentInfo: null,
	contentInfo: function (value) {
		if (arguments.length === 1) {
			this._contentInfo = value;
			return value;
		} else {
			return this._contentInfo;
		}
	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		switch (propertyName) {
			case $.ig.Axis.prototype.seriesViewerPropertyName:
				var oldSeriesViewer = $.ig.util.cast($.ig.SeriesViewer.prototype.$type, oldValue);
				if (oldSeriesViewer != null) {
					oldSeriesViewer.windowRectChanged = $.ig.Delegate.prototype.remove(oldSeriesViewer.windowRectChanged, this._seriesViewer_WindowRectChanged);
					oldSeriesViewer.chartContentManager().unsubscribe($.ig.ChartContentType.prototype.axis, this);
					this.view().detachFromChart(oldSeriesViewer);
				}

				var newSeriesViewer = $.ig.util.cast($.ig.SeriesViewer.prototype.$type, newValue);
				if (newSeriesViewer != null) {
					newSeriesViewer.windowRectChanged = $.ig.Delegate.prototype.combine(newSeriesViewer.windowRectChanged, this._seriesViewer_WindowRectChanged);
					this.contentInfo(newSeriesViewer.chartContentManager().subscribe($.ig.ChartContentType.prototype.axis, this, this.doRenderAxis.runOn(this)));
					this.view().attachToChart(newSeriesViewer);
					if (this.rangeDirty() && !this.contentInfo().rangeDirty()) {
						this.rangeDirty(false);
						this.updateRange();
					}

					this.updateActualBrushes();
					this.updateActualTickLength();
				}

				break;
			case $.ig.Axis.prototype.isDisabledPropertyName:
				this.renderAxis1(false);
				break;
			case $.ig.Axis.prototype.isInvertedPropertyName:
				this.isInvertedCached(this.isInverted());
				var rangeChangedEventArgs = new $.ig.AxisRangeChangedEventArgs(0, 0, 1, 1);
				this.doRaiseRangeChanged(rangeChangedEventArgs);
				var en = this.series().getEnumerator();
				while (en.moveNext()) {
					var series = en.current();
					series.invalidateAxes();
					if (series.seriesViewer() != null) {
						series.notifyThumbnailAppearanceChanged();
					}

				}

				break;
			case $.ig.Axis.prototype.labelPropertyName:
				if ($.ig.util.cast($.ig.DataTemplate.prototype.$type, newValue) !== null) {
					this.usingTemplate(true);

				} else {
					this.usingTemplate(false);
				}

				this.mustInvalidateLabels(true);
				this.resetLabelPanel();
				this.renderAxis1(false);
				break;
			case $.ig.Axis.prototype.majorStrokeThicknessPropertyName:
			case $.ig.Axis.prototype.minorStrokeThicknessPropertyName:
			case $.ig.Axis.prototype.strokeThicknessPropertyName:
				this.renderAxis1(false);
				break;
			case $.ig.Axis.prototype.labelPanelStylePropertyName:
				this.view().onLabelPanelStyleChanged(newValue);
				this.renderAxis1(false);
				break;
			case $.ig.Axis.prototype.labelSettingsPropertyName:
				var labelSettings = $.ig.util.cast($.ig.AxisLabelSettings.prototype.$type, newValue);
				if (labelSettings != null) {
					labelSettings.registerAxis(this);
					this.__currentLabelSettings = labelSettings;

				} else {
					this.__currentLabelSettings = new $.ig.AxisLabelSettings();
				}

				if (this.labelPanel() != null) {
					this.labelPanel().labelSettings(this.__currentLabelSettings);
				}

				if (this.view().ready()) {
					this.view().changeLabelSettings(this.__currentLabelSettings);
				}

				this.mustInvalidateLabels(true);
				this.renderAxis1(false);
				break;
			case $.ig.Axis.prototype.titlePropertyName:
				this.view().onTitleChange();
				break;
			case $.ig.Axis.prototype.titleSettingsPropertyName:
				var titleSettings = $.ig.util.cast($.ig.TitleSettings.prototype.$type, newValue);
				if (titleSettings != null) {
					titleSettings.registerAxis(this);

				} else {
					titleSettings = new $.ig.TitleSettings();
				}

				if (this.titleTextBlock() != null) {
					this.titleTextBlock().dataContext(titleSettings);
				}

				this.view().onTitleChange();
				this.renderAxis1(false);
				break;
			case $.ig.Axis.prototype.tickLengthPropertyName:
				this.mustInvalidateLabels(true);
				this.updateActualTickLength();
				this.view().labelNeedRearrange();
				this.renderAxis1(false);
				break;
			case $.ig.Axis.prototype.crossingAxisPropertyName:
				if (this.seriesViewer() != null) {
					this.seriesViewer().invalidatePanels();
				}

				break;
			case $.ig.Axis.prototype.minorStrokePropertyName:
				this.updateActualBrushes();
				if (newValue != null) {
					this.shouldRenderMinorLines(true);
					this.renderAxis1(false);

				} else {
					this.shouldRenderMinorLines(false);
				}

				break;
			case $.ig.Axis.prototype.strokePropertyName:
			case $.ig.Axis.prototype.majorStrokePropertyName:
				this.updateActualBrushes();
				this.renderAxis1(false);
				break;
			case $.ig.Axis.prototype.strokeDashArrayPropertyName:
			case $.ig.Axis.prototype.majorStrokeDashArrayPropertyName:
			case $.ig.Axis.prototype.minorStrokeDashArrayPropertyName:
			case $.ig.Axis.prototype.formatLabelPropertyName:
			case $.ig.Axis.prototype.tickStrokePropertyName:
			case $.ig.Axis.prototype.tickStrokeThicknessPropertyName:
			case $.ig.Axis.prototype.tickStrokeDashArrayPropertyName:
			case $.ig.Axis.prototype.actualStrokePropertyName:
			case $.ig.Axis.prototype.actualMajorStrokePropertyName:
			case $.ig.Axis.prototype.actualMinorStrokePropertyName:
				this.renderAxis1(false);
				break;
		}

	}

	, 
	_coercionMethods: null,
	coercionMethods: function (value) {
		if (arguments.length === 1) {
			this._coercionMethods = value;
			return value;
		} else {
			return this._coercionMethods;
		}
	}
	, 
	__expectFunctions: false

	, 
	expectFunctions: function (value) {
		if (arguments.length === 1) {

			this.__expectFunctions = value;
			return value;
		} else {

			return this.__expectFunctions;
		}
	}

	, 
	_shouldRenderMinorLines: false,
	shouldRenderMinorLines: function (value) {
		if (arguments.length === 1) {
			this._shouldRenderMinorLines = value;
			return value;
		} else {
			return this._shouldRenderMinorLines;
		}
	}

	, 
	resetLabelPanel: function () {
		this.textBlocks().count(0);
		if (this.view().ready()) {
			this.view().resetLabelPanel();
		}

	}

	, 
	_usingTemplate: false,
	usingTemplate: function (value) {
		if (arguments.length === 1) {
			this._usingTemplate = value;
			return value;
		} else {
			return this._usingTemplate;
		}
	}

	, 
	horizontalStrip: function (geometry, y0, y1, viewportRect) {
		var ymin = Math.min(y0, y1);
		var ymax = Math.max(y0, y1);
		if (ymin < viewportRect.bottom() && ymax > viewportRect.top()) {
			var strip = new $.ig.RectangleGeometry();
			strip.rect(new $.ig.Rect(0, viewportRect.left(), ymin, viewportRect.width(), ymax - ymin));
			geometry.add(strip);
		}

	}

	, 
	horizontalLine: function (geometry, y, viewportRect, renderingInfo) {
		if (y <= viewportRect.bottom() && y >= viewportRect.top()) {
			if (renderingInfo.alignToPixels()) {
				y = this.alignLineToPixels(y, viewportRect.top(), viewportRect.bottom(), renderingInfo);
			}

			var line = new $.ig.LineGeometry();
			line.startPoint({__x: viewportRect.left(), __y: y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			line.endPoint({__x: viewportRect.right(), __y: y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			geometry.add(line);
		}

	}

	, 
	verticalStrip: function (geometry, x0, x1, viewportRect) {
		var xmin = Math.min(x0, x1);
		var xmax = Math.max(x0, x1);
		if (xmax > viewportRect.left() && xmin < viewportRect.right()) {
			var strip = new $.ig.RectangleGeometry();
			strip.rect(new $.ig.Rect(0, xmin, viewportRect.top(), xmax - xmin, viewportRect.height()));
			geometry.add(strip);
		}

	}

	, 
	verticalLine: function (geometry, x, viewportRect, renderingInfo) {
		if (x >= viewportRect.left() && x <= viewportRect.right()) {
			if (renderingInfo.alignToPixels()) {
				x = this.alignLineToPixels(x, viewportRect.left(), viewportRect.right(), renderingInfo);
			}

			var majorLine = new $.ig.LineGeometry();
			majorLine.startPoint({__x: x, __y: viewportRect.top(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			majorLine.endPoint({__x: x, __y: viewportRect.bottom(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			geometry.add(majorLine);
		}

	}

	, 
	alignLineToPixels: function (value, min, max, renderingInfo) {
		var result = value;
		if (renderingInfo != null && renderingInfo.strokeThickness() > 0) {
			var remainder = renderingInfo.strokeThickness() % 2;
			if (remainder == 0 || remainder == 1) {
				var sign = 1;
				result = Math.floor(value);
				if (result + 0.5 < value) {
					sign = -1;
					result = Math.ceil(value);
				}

				if (remainder == 1) {
					result += 0.5 * sign;
				}

				if (result >= max) {
					result -= 1;

				} else if (result <= min) {
					result += 1;
				}


			}

		}

		return result;
	}

	, 
	clearMarks: function (geometry) {
		this.view().clearMarks(geometry);
	}

	, 
	clearAllMarks: function () {
		this.textBlocks().count(0);
		this.view().clearAllMarks();
		this.labelDataContext().clear();
		this.labelPositions().clear();
	}

	, 
	renderAxis: function () {
		this.renderAxis1(false);
	}

	, 
	renderAxis1: function (animate) {
		if (this.seriesViewer() != null) {
			this.seriesViewer().chartContentManager().refresh($.ig.ChartContentType.prototype.axis, this, this.contentInfo(), animate);
			if (this.renderRequested != null) {
				var args = new $.ig.RenderRequestedEventArgs();
				args.animate(animate);
				this.renderRequested(this, args);
				animate = args.animate();
			}

		}

	}
	, 
	renderRequested: null
	, 
	doRenderAxis: function (animate) {
		if (this.view().isDisabled()) {
			return;
		}

		var lastPos = 0;
		if (this.labelPositions() != null && this.labelPositions().count() > 0) {
			lastPos = $.ig.Enumerable.prototype.last$1($.ig.LabelPosition.prototype.$type, this.labelPositions()).value();
		}

		this.renderAxisOverride(animate);
		var currPos = 1;
		if (this.labelPositions() != null && this.labelPositions().count() > 0) {
			currPos = $.ig.Enumerable.prototype.last$1($.ig.LabelPosition.prototype.$type, this.labelPositions()).value();
		}

		var markedLabelsForRearrange = false;
		if (currPos != lastPos || this.mustInvalidateLabels()) {
			this.mustInvalidateLabels(false);
			if (this.view().ready()) {
				this.view().labelNeedRearrange();
				markedLabelsForRearrange = true;
			}

		}

		this.view().ensureRender();
		if (!markedLabelsForRearrange) {
			this.ensureExtentUpdated();
		}

	}

	, 
	ensureExtentUpdated: function () {
		if (!this.view().ready()) {
			return;
		}

		if (!this.hasUserExtent()) {
			this.view().ensureAutoExtent();
		}

	}

	, 
	_rangeDirty: false,
	rangeDirty: function (value) {
		if (arguments.length === 1) {
			this._rangeDirty = value;
			return value;
		} else {
			return this._rangeDirty;
		}
	}

	, 
	updateRange: function () {
		return this.updateRange1(false);
	}

	, 
	updateRange1: function (immediate) {
		if (immediate || this.seriesViewer() == null) {
			var ret = this.updateRangeOverride();
			if (ret) {
				this.mustInvalidateLabels(true);
			}

			this.rangeDirty(false);
			return ret;
		}

		if (!this.rangeDirty()) {
			this.rangeDirty(true);
			this.seriesViewer().chartContentManager().rangeDirty(this, this.contentInfo());
		}

		return false;
	}

	, 
	updateRangeOverride: function () {
		return false;
	}

	, 
	renderAxisOverride: function (animate) {
		if (this.titleTextBlock() != null) {
			if (this.labelSettings() == null || this.labelSettings().visibility() == $.ig.Visibility.prototype.visible) {
				this.titleTextBlock().__visibility = $.ig.Visibility.prototype.visible;

			} else {
				this.titleTextBlock().__visibility = $.ig.Visibility.prototype.collapsed;
			}

		}

	}

	, 
	updateActualBrushes: function () {
		var chart = $.ig.util.cast($.ig.XamDataChart.prototype.$type, this.seriesViewer());
		if (chart == null) {
			return;
		}

		var stroke = null, majorStroke = null, minorStroke = null;
		if (this.isCategory() && !this.isAngular()) {
			stroke = chart.defaultAxisStroke();
			var en = this.series().getEnumerator();
			while (en.moveNext()) {
				var series = en.current();
				if (series.isScatter() || series.isRadial() || series.isPolar() || series.isRadial()) {
					majorStroke = chart.defaultAxisMajorStroke();
					minorStroke = chart.defaultAxisMinorStroke();
					break;
				}

			}


		} else if (this.isNumeric() && !this.isAngular()) {
			majorStroke = chart.defaultAxisMajorStroke();
			minorStroke = chart.defaultAxisMinorStroke();
			stroke = this.crossingAxis() != null ? chart.defaultAxisStroke() : null;
			var en1 = this.series().getEnumerator();
			while (en1.moveNext()) {
				var series1 = en1.current();
				if (series1.isScatter() || series1.isRadial() || series1.isPolar() || series1.isRadial()) {
					stroke = chart.defaultAxisStroke();
					break;
				}

			}


		} else if (this.isAngular() || this.orientation() == $.ig.AxisOrientation.prototype.radial) {
			stroke = chart.defaultAxisStroke();
			majorStroke = chart.defaultAxisMajorStroke();
			minorStroke = chart.defaultAxisMinorStroke();
		}



		this.actualStroke(this.stroke() != null ? this.stroke() : stroke);
		this.actualMajorStroke(this.majorStroke() != null ? this.majorStroke() : majorStroke);
		this.actualMinorStroke(this.minorStroke() != null ? this.minorStroke() : minorStroke);
	}
	, 
	propertyChanged: null, 
	propertyUpdated: null
	, 
	raisePropertyChanged: function (name, oldValue, newValue) {
		if (this.propertyChanged != null) {
			this.propertyChanged(this, new $.ig.PropertyChangedEventArgs(name));
		}

		if (this.propertyUpdated != null) {
			this.propertyUpdated(this, new $.ig.PropertyUpdatedEventArgs(name, oldValue, newValue));
		}

	}

	, 
	_series: null,
	series: function (value) {
		if (arguments.length === 1) {
			this._series = value;
			return value;
		} else {
			return this._series;
		}
	}

	, 
	registerSeries: function (series) {
		var present = this.series().contains(series);
		if (!present) {
			this.series().add(series);
		}

		this.updateActualBrushes();
		return !present;
	}

	, 
	deregisterSeries: function (series) {
		var present = this.series().contains(series);
		if (present) {
			this.series().remove(series);
		}

		this.updateActualBrushes();
		return present;
	}

	, 
	label: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Axis.prototype.labelProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Axis.prototype.labelProperty);
		}
	}

	, 
	getLabel: function (dataItem) {
		return this.view().getLabelValue(dataItem);
	}

	, 
	getScaledValue: function (unscaledValue, p) {
		return 0;
	}

	, 
	getScaledValue1: function (unscaledValue, windowRect, viewportRect) {
		var p = new $.ig.ScalerParams(windowRect, viewportRect, this.isInverted());
		return this.getScaledValue(unscaledValue, p);
	}

	, 
	getScaledValueList: function (unscaledValues, startIndex, count, p) {
	}

	, 
	getUnscaledValue: function (scaledValue, p) {
		return 0;
	}

	, 
	getUnscaledValue1: function (scaledValue, windowRect, viewportRect) {
		var p = new $.ig.ScalerParams(windowRect, viewportRect, this.isInverted());
		return this.getUnscaledValue(scaledValue, p);
	}

	, 
	getUnscaledValueList: function (scaledValues, startIndex, count, p) {
	}

	, 
	scaleValue: function (unscaledValue) {
		var p = new $.ig.ScalerParams(this.seriesViewer().windowRect(), this.viewportRect(), this.isInverted());
		p._effectiveViewportRect = this.seriesViewer().effectiveViewport();
		return this.getScaledValue(unscaledValue, p);
	}

	, 
	orientation: function () {
	}

	, 
	_measuredSize: null,
	measuredSize: function (value) {
		if (arguments.length === 1) {
			this._measuredSize = value;
			return value;
		} else {
			return this._measuredSize;
		}
	}

	, 
	overrideViewport: function () {
		this.viewportOverride(new $.ig.Rect(0, 0, 0, this.measuredSize().width(), this.measuredSize().height()));
	}
	, 
	__axisComponentsForView: null

	, 
	getAxisComponentsForView: function () {
		this.__axisComponentsForView.labelPanel(this.labelPanel());
		return this.__axisComponentsForView;
	}

	, 
	_extentOverride: 0,
	extentOverride: function (value) {
		if (arguments.length === 1) {
			this._extentOverride = value;
			return value;
		} else {
			return this._extentOverride;
		}
	}

	, 
	hasUserExtent: function () {
		if (!$.ig.util.isNaN(this.extentOverride())) {
			return true;
		}

		if (this.labelSettings() == null) {
			return false;

		} else {
			return this.labelSettings().hasUserExtent();
		}

	}

	, 
	getUserExtent: function () {
		if (!$.ig.util.isNaN(this.extentOverride())) {
			return this.extentOverride();
		}

		if (this.labelSettings() == null) {
			return 50;
		}

		return this.labelSettings().extent();
	}

	, 
	applyDefaultSettings: function () {
		this.view().applyDefaultSettings();
	}

	, 
	doRaiseRangeChanged: function (rangeChangedEventArgs) {
		this.raiseRangeChanged(rangeChangedEventArgs);
	}

	, 
	_textBlocks: null,
	textBlocks: function (value) {
		if (arguments.length === 1) {
			this._textBlocks = value;
			return value;
		} else {
			return this._textBlocks;
		}
	}

	, 
	axisLines: function () {

			return this.getAxisComponentsFromView().axisLines();
	}

	, 
	majorLines: function () {

			return this.getAxisComponentsFromView().majorLines();
	}

	, 
	strips: function () {

			return this.view().getAxisComponentsFromView().strips();
	}

	, 
	minorLines: function () {

			return this.getAxisComponentsFromView().minorLines();
	}

	, 
	getSyncSettings: function () {
		return $.ig.SyncManager.prototype.getSyncSettings(this.__seriesViewer);
	}

	, 
	getAxisComponentsFromView: function () {
		return this.view().getAxisComponentsFromView();
	}
	, 
	__currentLabelSettings: null

	, 
	currentLabelSettings: function () {

			return this.__currentLabelSettings;
	}

	, 
	provideContext: function (context, hitContext) {
		if (this.labelPanel() != null) {
			this.labelPanel().provideContext(context);
		}

		this.view().onContextProvided(context, hitContext);
	}

	, 
	hasCrossingValue: function () {
		return false;
	}

	, 
	exportTitleVisualData: function (model, axisType, titlePresenter) {
		var titleData = new $.ig.ChartTitleVisualData();
		var titleParentViewport = this.view().exportLabelsPanelViewport();
		titleData.viewport(titleParentViewport);
		var textBounds = this.view().exportTitleBounds(titlePresenter);
		titleData.textPlotArea(textBounds);
		var isTitleParentVisible = titlePresenter.__visibility == $.ig.Visibility.prototype.visible && titlePresenter.parent() != null;
		var font = this.labelPanel().view().getAxisTitleFont();
		var margin = this.view().exportTitleMargin(titlePresenter);
		var fontInfo = $.ig.FontUtil.prototype.getFontInfo(titlePresenter, font);
		var titleAppearance = $.ig.AppearanceHelper.prototype.fromTextElement(titlePresenter, fontInfo);
		titleAppearance.marginLeft(margin.left());
		titleAppearance.marginRight(margin.right());
		titleAppearance.marginTop(margin.top());
		titleAppearance.marginBottom(margin.bottom());
		titleAppearance.fontStretch("Normal");
		titleAppearance.textWrapping("Wrap");
		titleAppearance.visibility(isTitleParentVisible);
		if (this.titleSettings() != null) {
			titleAppearance.horizontalAlignment($.ig.HorizontalAlignment.prototype.getName(this.titleSettings().horizontalAlignment()));
			titleAppearance.verticalAlignment($.ig.VerticalAlignment.prototype.getName(this.titleSettings().verticalAlignment()));
			titleAppearance.textPosition($.ig.AxisTitlePosition.prototype.getName(this.titleSettings().position()));
		}

		titleData.appearance(titleAppearance);
		return titleData;
	}

	, 
	sanitizeTypeName: function (name) {
		return name;
	}

	, 
	exportVisualData: function () {
		var $self = this;
		var avd = new $.ig.AxisVisualData();
		avd.viewport($self.viewportRect());
		avd.labelsViewport($self.view().exportLabelsPanelViewport());
		avd.type($self.sanitizeTypeName($self.getType().typeName()));
		avd.name($self.name());
		avd.axisLine(new $.ig.PathVisualData(1, "axisLine", $self.view().axisLines()));
		avd.tickMarks(new $.ig.PathVisualData(1, "tickMarks", $self.labelPanel().view().ticks()));
		avd.minorLines(new $.ig.PathVisualData(1, "minorLines", $self.view().minorLines()));
		avd.majorLines(new $.ig.PathVisualData(1, "majorLines", $self.view().majorLines()));
		avd.strips(new $.ig.PathVisualData(1, "strips", $self.view().strips()));
		if ($self.title() != null) {
			var titleData = $self.exportTitleVisualData($self.seriesViewer(), avd.type(), $self.titleTextBlock());
			avd.title(titleData);

		} else {
			avd.title(null);
		}

		var font = $self.seriesViewer().getFont();
		if ($self.labelSettings() != null && $self.labelSettings().textStyle() != null) {
			font = $self.labelSettings().textStyle();
		}

		var currentDeltaX, currentDeltaY, prevDeltaX, prevDeltaY;
		var marks = ($.ig.util.cast($.ig.GeometryGroup.prototype.$type, $self.labelPanel().view().ticks().data())).children();
		for (var i = 1; i < marks.count(); i++) {
			var currentLine = ($.ig.util.cast($.ig.LineGeometry.prototype.$type, marks.__inner[i]));
			var previousLIne = ($.ig.util.cast($.ig.LineGeometry.prototype.$type, marks.__inner[i - 1]));
			currentDeltaX = currentLine.startPoint().__x - currentLine.endPoint().__x;
			currentDeltaY = currentLine.startPoint().__y - currentLine.endPoint().__y;
			prevDeltaX = previousLIne.startPoint().__x - previousLIne.endPoint().__x;
			prevDeltaY = previousLIne.startPoint().__y - previousLIne.endPoint().__y;
			if (1 == i) {
				avd.tickMarksLength(Math.sqrt(Math.pow(currentDeltaX, 2) + Math.pow(currentDeltaY, 2)));
			}

		}

		for (var i1 = 0; i1 < $self.labelPanel().labelPositions().count(); i1++) {
			var labelPosition = $self.labelPanel().labelPositions().__inner[i1];
			var labelContext = $self.labelPanel().labelDataContext().__inner[i1];
			var newLabelData = (function () { var $ret = new $.ig.AxisLabelVisualData();
			$ret.labelPosition(labelPosition.value());
			$ret.labelValue(labelContext);
			$ret.panelPosition($self.view().exportLabelsPanelPosition()); return $ret;}());
			if (i1 < $self.labelPanel().textBlocks().count()) {
				var fontInfo = $.ig.FontUtil.prototype.getFontInfo($self.labelPanel().textBlocks().__inner[i1], font);
				newLabelData.appearance($.ig.AppearanceHelper.prototype.fromTextElement($self.labelPanel().textBlocks().__inner[i1], fontInfo));
				var activeTextBlock = $self.textBlocks().active().__inner[i1];
				newLabelData.position($self.view().exportLabelPosition(activeTextBlock));
				newLabelData.size(new $.ig.Size(1, activeTextBlock.actualWidth(), activeTextBlock.actualHeight()));
			}

			avd.labels().add(newLabelData);
		}

		return avd;
	}

	, 
	directSeries: function () {
		var d__ = new $.ig.Axis___DirectSeries__IteratorClass(-2);
		d__.__4__this = this;
		return d__;
	}
	, 
	$type: new $.ig.Type('Axis', $.ig.Control.prototype.$type, [$.ig.INotifyPropertyChanged.prototype.$type])
}, true);


$.ig.util.defType('AxisCollection', 'ObservableCollection$1', {
	init: function () {



		var $self = this;
		$.ig.ObservableCollection$1.prototype.init.call(this, $.ig.Axis.prototype.$type, 0);
			this.propertyChanged = $.ig.Delegate.prototype.combine(this.propertyChanged, function (o, e) {
				if (e.propertyName() == "Name") {
					for (var i = 0; i < $self.count(); ++i) {
						if ($self.__inner[i].name() == e.propertyName()) {
							$self.onCollectionChanged(new $.ig.NotifyCollectionChangedEventArgs(2, $.ig.NotifyCollectionChangedAction.prototype.replace, $self.__inner[i], $self.__inner[i], i));
						}

					}

				}

			});
	}
	, 
	collectionResetting: null
	, 
	clearItems: function () {
		if (this.collectionResetting != null) {
			this.collectionResetting(this, null);
		}

		$.ig.ObservableCollection$1.prototype.clearItems.call(this);
	}
	, 
	$type: new $.ig.Type('AxisCollection', $.ig.ObservableCollection$1.prototype.$type.specialize($.ig.Axis.prototype.$type))
}, true);

$.ig.util.defType('AxisComponentsForView', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	_labelPanel: null,
	labelPanel: function (value) {
		if (arguments.length === 1) {
			this._labelPanel = value;
			return value;
		} else {
			return this._labelPanel;
		}
	}
	, 
	$type: new $.ig.Type('AxisComponentsForView', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('AxisComponentsFromView', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	_axisLines: null,
	axisLines: function (value) {
		if (arguments.length === 1) {
			this._axisLines = value;
			return value;
		} else {
			return this._axisLines;
		}
	}

	, 
	_majorLines: null,
	majorLines: function (value) {
		if (arguments.length === 1) {
			this._majorLines = value;
			return value;
		} else {
			return this._majorLines;
		}
	}

	, 
	_strips: null,
	strips: function (value) {
		if (arguments.length === 1) {
			this._strips = value;
			return value;
		} else {
			return this._strips;
		}
	}

	, 
	_minorLines: null,
	minorLines: function (value) {
		if (arguments.length === 1) {
			this._minorLines = value;
			return value;
		} else {
			return this._minorLines;
		}
	}
	, 
	$type: new $.ig.Type('AxisComponentsFromView', $.ig.Object.prototype.$type)
}, true);



$.ig.util.defType('LabelPosition', 'Object', {

	_value: 0,
	value: function (value) {
		if (arguments.length === 1) {
			this._value = value;
			return value;
		} else {
			return this._value;
		}
	}
	, 
	init: function (value) {



		$.ig.Object.prototype.init.call(this);
			this.value(value);
	}
	, 
	$type: new $.ig.Type('LabelPosition', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('AxisLabelSettings', 'Object', {
	init: function () {


		this.__textColor = null;
		this.__location = $.ig.AxisLabelsLocation.prototype.outsideBottom;
		this.__visibility = $.ig.Visibility.prototype.visible;
		this.__showFirstLabel = true;
		this.__angle = 0;
		this.__extent = NaN;
		this.__leftMargin = 2;
		this.__rightMargin = 2;
		this.__topMargin = 2;
		this.__bottomMargin = 2;
		this.__horizontalAlignment = $.ig.HorizontalAlignment.prototype.left;
		this.__verticalAlignment = $.ig.VerticalAlignment.prototype.center;

		var $self = this;
		$.ig.Object.prototype.init.call(this);
			this.propertyUpdated = $.ig.Delegate.prototype.combine(this.propertyUpdated, function (o, e) { $self.propertyUpdatedOverride(o, e.propertyName(), e.oldValue(), e.newValue()); });
	}
	, 
	__textStyle: null

	, 
	textStyle: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__textStyle;
			this.__textStyle = value;
			this.raisePropertyChanged($.ig.AxisLabelSettings.prototype.textStylePropertyName, oldValue, value);
			return value;
		} else {

			return this.__textStyle;
		}
	}
	, 
	__textColor: null

	, 
	textColor: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__textColor;
			this.__textColor = value;
			this.raisePropertyChanged($.ig.AxisLabelSettings.prototype.textColorPropertyName, oldValue, value);
			return value;
		} else {

			return this.__textColor;
		}
	}

	, 
	location: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__location;
			this.__location = value;
			this.raisePropertyChanged($.ig.AxisLabelSettings.prototype.locationPropertyName, $.ig.AxisLabelsLocation.prototype.getBox(oldValue), $.ig.AxisLabelsLocation.prototype.getBox(value));
			return value;
		} else {

			return this.__location;
		}
	}
	, 
	__location: 0

	, 
	visibility: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__visibility;
			this.__visibility = value;
			this.raisePropertyChanged($.ig.AxisLabelSettings.prototype.visibilityPropertyName, $.ig.Visibility.prototype.getBox(oldValue), $.ig.Visibility.prototype.getBox(value));
			return value;
		} else {

			return this.__visibility;
		}
	}
	, 
	__visibility: 0

	, 
	showFirstLabel: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__showFirstLabel;
			this.__showFirstLabel = value;
			this.raisePropertyChanged($.ig.AxisLabelSettings.prototype.showFirstLabelPropertyName, oldValue, value);
			return value;
		} else {

			return this.__showFirstLabel;
		}
	}
	, 
	__showFirstLabel: false

	, 
	_actualLocation: 0,
	actualLocation: function (value) {
		if (arguments.length === 1) {
			this._actualLocation = value;
			return value;
		} else {
			return this._actualLocation;
		}
	}

	, 
	_axis: null,
	axis: function (value) {
		if (arguments.length === 1) {
			this._axis = value;
			return value;
		} else {
			return this._axis;
		}
	}

	, 
	registerAxis: function (axis) {
		this.axis(axis);
	}

	, 
	unregisterAxis: function (axis) {
		this.axis(null);
	}

	, 
	angle: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__angle;
			this.__angle = value;
			this.raisePropertyChanged($.ig.AxisLabelSettings.prototype.anglePropertyName, oldValue, value);
			return value;
		} else {

			return this.__angle;
		}
	}
	, 
	__angle: 0

	, 
	extent: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__extent;
			this.__extent = value;
			this.raisePropertyChanged($.ig.AxisLabelSettings.prototype.extentPropertyName, oldValue, value);
			return value;
		} else {

			return this.__extent;
		}
	}
	, 
	__extent: 0

	, 
	margin: function (value) {

			this.topMargin(this.rightMargin(this.bottomMargin(this.leftMargin(value))));
		return value;
	}

	, 
	leftMargin: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__leftMargin;
			this.__leftMargin = value;
			this.raisePropertyChanged($.ig.AxisLabelSettings.prototype.leftMarginPropertyName, oldValue, value);
			return value;
		} else {

			return this.__leftMargin;
		}
	}
	, 
	__leftMargin: 0

	, 
	rightMargin: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__rightMargin;
			this.__rightMargin = value;
			this.raisePropertyChanged($.ig.AxisLabelSettings.prototype.rightMarginPropertyName, oldValue, value);
			return value;
		} else {

			return this.__rightMargin;
		}
	}
	, 
	__rightMargin: 0

	, 
	topMargin: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__topMargin;
			this.__topMargin = value;
			this.raisePropertyChanged($.ig.AxisLabelSettings.prototype.topMarginPropertyName, oldValue, value);
			return value;
		} else {

			return this.__topMargin;
		}
	}
	, 
	__topMargin: 0

	, 
	bottomMargin: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__bottomMargin;
			this.__bottomMargin = value;
			this.raisePropertyChanged($.ig.AxisLabelSettings.prototype.bottomMarginPropertyName, oldValue, value);
			return value;
		} else {

			return this.__bottomMargin;
		}
	}
	, 
	__bottomMargin: 0
	, 
	__horizontalAlignment: 0

	, 
	horizontalAlignment: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__horizontalAlignment;
			this.__horizontalAlignment = value;
			this.raisePropertyChanged($.ig.AxisLabelSettings.prototype.horizontalAlignmentPropertyName, $.ig.HorizontalAlignment.prototype.getBox(oldValue), $.ig.HorizontalAlignment.prototype.getBox(value));
			return value;
		} else {

			return this.__horizontalAlignment;
		}
	}
	, 
	__verticalAlignment: 0

	, 
	verticalAlignment: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__verticalAlignment;
			this.__verticalAlignment = value;
			this.raisePropertyChanged($.ig.AxisLabelSettings.prototype.verticalAlignmentPropertyName, $.ig.VerticalAlignment.prototype.getBox(oldValue), $.ig.VerticalAlignment.prototype.getBox(value));
			return value;
		} else {

			return this.__verticalAlignment;
		}
	}
	, 
	propertyChanged: null, 
	propertyUpdated: null
	, 
	raisePropertyChanged: function (name, oldValue, newValue) {
		if (this.propertyChanged != null) {
			this.propertyChanged(this, new $.ig.PropertyChangedEventArgs(name));
		}

		if (this.propertyUpdated != null) {
			this.propertyUpdated(this, new $.ig.PropertyUpdatedEventArgs(name, oldValue, newValue));
		}

	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		switch (propertyName) {
			case $.ig.AxisLabelSettings.prototype.locationPropertyName:
				this.actualLocation(this.location());
				break;
		}

		if (this.axis() == null || this.axis().chart() == null) {
			return;
		}

		switch (propertyName) {
			case $.ig.AxisLabelSettings.prototype.anglePropertyName:
				this.axis().mustInvalidateLabels(true);
				this.axis().renderAxis();
				break;
			case $.ig.AxisLabelSettings.prototype.locationPropertyName:
			case $.ig.AxisLabelSettings.prototype.extentPropertyName:
			case $.ig.AxisLabelSettings.prototype.visibilityPropertyName:
			case $.ig.AxisLabelSettings.prototype.textStylePropertyName:
			case $.ig.AxisLabelSettings.prototype.horizontalAlignmentPropertyName:
			case $.ig.AxisLabelSettings.prototype.verticalAlignmentPropertyName:
			case $.ig.AxisLabelSettings.prototype.topMarginPropertyName:
			case $.ig.AxisLabelSettings.prototype.rightMarginPropertyName:
			case $.ig.AxisLabelSettings.prototype.bottomMarginPropertyName:
			case $.ig.AxisLabelSettings.prototype.leftMarginPropertyName:
			case $.ig.AxisLabelSettings.prototype.showFirstLabelPropertyName:
				this.axis().mustInvalidateLabels(true);
				if (this.axis().seriesViewer() != null) {
					this.axis().seriesViewer().invalidatePanels();
				}

				this.axis().renderAxis();
				break;
			case $.ig.AxisLabelSettings.prototype.textColorPropertyName:
				this.axis().renderAxis();
				break;
		}

	}

	, 
	hasUserAngle: function () {
		return this.__angle != 0;
	}

	, 
	hasUserExtent: function () {
		return !$.ig.util.isNaN(this.__extent);
	}
	, 
	$type: new $.ig.Type('AxisLabelSettings', $.ig.Object.prototype.$type, [$.ig.INotifyPropertyChanged.prototype.$type])
}, true);

$.ig.util.defType('TitleSettings', 'AxisLabelSettings', {
	init: function () {


		this.__titlePosition = $.ig.AxisTitlePosition.prototype.auto;

		$.ig.AxisLabelSettings.prototype.init.call(this);
			this.horizontalAlignment($.ig.HorizontalAlignment.prototype.center);
			this.leftMargin(NaN);
			this.rightMargin(NaN);
			this.topMargin(NaN);
			this.bottomMargin(NaN);
	}
	, 
	__titlePosition: 0

	, 
	position: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__titlePosition;
			this.__titlePosition = value;
			this.raisePropertyChanged($.ig.TitleSettings.prototype.axisTitlePositionPropertyName, $.ig.AxisTitlePosition.prototype.getBox(oldValue), $.ig.AxisTitlePosition.prototype.getBox(value));
			return value;
		} else {

			return this.__titlePosition;
		}
	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		$.ig.AxisLabelSettings.prototype.propertyUpdatedOverride.call(this, sender, propertyName, oldValue, newValue);
		if (this.axis() == null || this.axis().seriesViewer() == null) {
			return;
		}

		switch (propertyName) {
			case $.ig.TitleSettings.prototype.axisTitlePositionPropertyName:
				this.axis().mustInvalidateLabels(true);
				this.axis().renderAxis();
				break;
		}

	}
	, 
	$type: new $.ig.Type('TitleSettings', $.ig.AxisLabelSettings.prototype.$type)
}, true);

$.ig.util.defType('AxisRange', 'Object', {
	init: function (minimum, maximum) {



		$.ig.Object.prototype.init.call(this);
			this.minimum(minimum);
			this.maximum(maximum);
	}

	, 
	_minimum: 0,
	minimum: function (value) {
		if (arguments.length === 1) {
			this._minimum = value;
			return value;
		} else {
			return this._minimum;
		}
	}

	, 
	_maximum: 0,
	maximum: function (value) {
		if (arguments.length === 1) {
			this._maximum = value;
			return value;
		} else {
			return this._maximum;
		}
	}

	, 
	equals: function (other) {
		return other != null && this.minimum() == other.minimum() && this.maximum() == other.maximum();
	}

	, 
	equals1: function (other) {
		return this.equals($.ig.util.cast($.ig.AxisRange.prototype.$type, other));
	}

	, 
	getHashCode: function () {
		return $.ig.Object.prototype.getHashCode.call(this);
	}
	, 
	$type: new $.ig.Type('AxisRange', $.ig.Object.prototype.$type, [$.ig.IEquatable$1.prototype.$type.specialize($.ig.AxisRange.prototype.$type)])
}, true);





$.ig.util.defType('AxisView', 'Object', {

	_model: null,
	model: function (value) {
		if (arguments.length === 1) {
			this._model = value;
			return value;
		} else {
			return this._model;
		}
	}
	, 
	init: function (model) {


		this.__axisComponentsFromView = new $.ig.AxisComponentsFromView();
		this.__renderedRect = $.ig.Rect.prototype.empty();

		$.ig.Object.prototype.init.call(this);
			this.model(model);
			this.__backgroundRect = new $.ig.Rectangle();
	}

	, 
	onInit: function () {
		var $self = this;
		$self.axisLines((function () { var $ret = new $.ig.Path();
		$ret.data(new $.ig.GeometryGroup()); return $ret;}()));
		$self.strips((function () { var $ret = new $.ig.Path();
		$ret.data(new $.ig.GeometryGroup());
		$ret.isHitTestVisible(false);
		$ret.stroke(null); return $ret;}()));
		$self.majorLines((function () { var $ret = new $.ig.Path();
		$ret.data(new $.ig.GeometryGroup());
		$ret.isHitTestVisible(false); return $ret;}()));
		$self.minorLines((function () { var $ret = new $.ig.Path();
		$ret.data(new $.ig.GeometryGroup());
		$ret.isHitTestVisible(false); return $ret;}()));
		$self.model().majorStrokeThickness(1);
		$self.model().strokeThickness(1);
	}

	, 
	onLabelPanelStyleChanged: function (style) {
	}

	, 
	_axisLines: null,
	axisLines: function (value) {
		if (arguments.length === 1) {
			this._axisLines = value;
			return value;
		} else {
			return this._axisLines;
		}
	}

	, 
	_majorLines: null,
	majorLines: function (value) {
		if (arguments.length === 1) {
			this._majorLines = value;
			return value;
		} else {
			return this._majorLines;
		}
	}

	, 
	_strips: null,
	strips: function (value) {
		if (arguments.length === 1) {
			this._strips = value;
			return value;
		} else {
			return this._strips;
		}
	}

	, 
	_minorLines: null,
	minorLines: function (value) {
		if (arguments.length === 1) {
			this._minorLines = value;
			return value;
		} else {
			return this._minorLines;
		}
	}

	, 
	textBlockCreate: function () {
		var textBlock = new $.ig.TextBlock();
		return textBlock;
	}

	, 
	textBlockActivate: function (textBlock) {
		textBlock.__visibility = $.ig.Visibility.prototype.visible;
		if (textBlock.parent() == null) {
			this.model().labelPanel().children().add(textBlock);
		}

	}

	, 
	textBlockDisactivate: function (textBlock) {
		textBlock.__visibility = $.ig.Visibility.prototype.collapsed;
	}

	, 
	textBlockDestroy: function (textBlock) {
		if (this.model().labelPanel().children().contains(textBlock)) {
			this.model().labelPanel().children().remove(textBlock);
		}

	}

	, 
	onTemplateProvided: function () {
	}

	, 
	ready: function () {
		return true;
	}

	, 
	index: function () {

			var chart = $.ig.util.cast($.ig.XamDataChart.prototype.$type, this.model().chart());
			var before = 0;
			if (chart == null) {
				return 0;
			}

			if (chart != null && chart.gridMode() == $.ig.GridMode.prototype.beforeSeries) {
				before = chart.series().count();
			}

			return before + chart.axes().indexOf(this.model());
	}

	, 
	labelNeedRearrange: function () {
		this.labelPanel().measure();
		this.labelPanel().arrange();
	}

	, 
	ensureAutoExtent: function () {
		this.labelPanel().ensureExtentSet();
	}

	, 
	clearAllMarks: function () {
		if (this.labelPanel() != null) {
			this.labelPanel().children().clear();
		}

		this.clearMarks(($.ig.util.cast($.ig.GeometryGroup.prototype.$type, this.axisLines().data())).children());
		this.clearMarks(($.ig.util.cast($.ig.GeometryGroup.prototype.$type, this.strips().data())).children());
		this.clearMarks(($.ig.util.cast($.ig.GeometryGroup.prototype.$type, this.majorLines().data())).children());
		this.clearMarks(($.ig.util.cast($.ig.GeometryGroup.prototype.$type, this.minorLines().data())).children());
		this.makeDirty();
	}

	, 
	updateLineVisibility: function (visible) {
		this.axisLines().__visibility = visible;
		this.majorLines().__visibility = visible;
		this.strips().__visibility = visible;
		this.minorLines().__visibility = visible;
	}

	, 
	resetLabelPanel: function () {
	}

	, 
	changeLabelSettings: function (_currentLabelSettings) {
		this.model().mustInvalidateLabels(true);
		if (this.model().seriesViewer() != null) {
			this.model().seriesViewer().invalidatePanels();
		}

		this.model().renderAxis();
	}
	, 
	__axisComponentsFromView: null

	, 
	getAxisComponentsFromView: function () {
		this.__axisComponentsFromView.axisLines(this.axisLines());
		this.__axisComponentsFromView.majorLines(this.majorLines());
		this.__axisComponentsFromView.minorLines(this.minorLines());
		this.__axisComponentsFromView.strips(this.strips());
		return this.__axisComponentsFromView;
	}

	, 
	clearMarks: function (geometry) {
		if (geometry != null) {
			geometry.clear();
		}

	}

	, 
	getAxisLinesGeometry: function () {
		return ($.ig.util.cast($.ig.GeometryGroup.prototype.$type, this.axisLines().data())).children();
	}

	, 
	getAxisLinesPathInfo: function () {
		var $self = this;
		var ret = (function () { var $ret = new $.ig.PathRenderingInfo();
		$ret.stroke($self.model().stroke());
		$ret.strokeThickness($self.model().strokeThickness());
		$ret.dashArray($self.model().strokeDashArray()); return $ret;}());
		if ($.ig.util.cast($.ig.XamDataChart.prototype.$type, $self.model().chart()) !== null) {
			var c = $self.model().chart();
			if (c.alignsGridLinesToPixels() && c.state() != $.ig.InteractionState.prototype.dragPan && c.state() != $.ig.InteractionState.prototype.dragZoom) {
				ret.alignToPixels(true);
			}

		}

		return ret;
	}

	, 
	getStripsGeometry: function () {
		return ($.ig.util.cast($.ig.GeometryGroup.prototype.$type, this.strips().data())).children();
	}

	, 
	getMajorLinesGeometry: function () {
		return ($.ig.util.cast($.ig.GeometryGroup.prototype.$type, this.majorLines().data())).children();
	}

	, 
	getMajorLinesPathInfo: function () {
		var $self = this;
		var ret = (function () { var $ret = new $.ig.PathRenderingInfo();
		$ret.stroke($self.model().majorStroke());
		$ret.strokeThickness($self.model().majorStrokeThickness());
		$ret.dashArray($self.model().majorStrokeDashArray()); return $ret;}());
		if ($.ig.util.cast($.ig.XamDataChart.prototype.$type, $self.model().chart()) !== null) {
			var c = $self.model().chart();
			if (c.alignsGridLinesToPixels() && c.state() != $.ig.InteractionState.prototype.dragPan && c.state() != $.ig.InteractionState.prototype.dragZoom) {
				ret.alignToPixels(true);
			}

		}

		return ret;
	}

	, 
	getMinorLinesGeometry: function () {
		return ($.ig.util.cast($.ig.GeometryGroup.prototype.$type, this.minorLines().data())).children();
	}

	, 
	getMinorLinesPathInfo: function () {
		var $self = this;
		var ret = (function () { var $ret = new $.ig.PathRenderingInfo();
		$ret.stroke($self.model().minorStroke());
		$ret.strokeThickness($self.model().minorStrokeThickness());
		$ret.dashArray($self.model().minorStrokeDashArray()); return $ret;}());
		if ($.ig.util.cast($.ig.XamDataChart.prototype.$type, $self.model().chart()) !== null) {
			var c = $self.model().chart();
			if (c.alignsGridLinesToPixels() && c.state() != $.ig.InteractionState.prototype.dragPan && c.state() != $.ig.InteractionState.prototype.dragZoom) {
				ret.alignToPixels(true);
			}

		}

		return ret;
	}

	, 
	labelPanel: function () {

			return this.model().getAxisComponentsForView().labelPanel();
	}

	, 
	updateLabelPanel: function (model, windowRect, viewportRect) {
		this.labelPanel().axis(model);
		this.labelPanel().windowRect(windowRect);
		this.labelPanel().viewportRect(viewportRect);
		this.makeDirty();
	}

	, 
	clearLabelPanel: function () {
		this.labelPanel().children().clear();
		this.makeDirty();
	}

	, 
	setLabelPanelInterval: function (p) {
		this.labelPanel().interval(p);
		this.makeDirty();
	}

	, 
	updateLabelPanelContent: function (dataContexts, positions) {
		this.labelPanel().labelDataContext(dataContexts);
		this.labelPanel().labelPositions(positions);
	}

	, 
	setLabelPanelCrossingValue: function (crossingValue) {
		this.labelPanel().crossingValue(crossingValue);
	}

	, 
	bindLabelPanelStyle: function () {
	}

	, 
	getLabelValue: function (dataItem_) {
		if (this.model().formatLabel() != null) {
			return this.model().formatLabel()(dataItem_);
		}

		var label_ = this.model().label();
		var labelValue_ = (typeof dataItem_[label_] != 'undefined') ? dataItem_[label_] : label_;;
		if (this.model().expectFunctions()) {
			if (typeof(labelValue_) == 'function') {
				labelValue_ = labelValue_();
			}

		}

		return labelValue_;
	}

	, 
	_hitContext: null,
	hitContext: function (value) {
		if (arguments.length === 1) {
			this._hitContext = value;
			return value;
		} else {
			return this._hitContext;
		}
	}

	, 
	_context: null,
	context: function (value) {
		if (arguments.length === 1) {
			this._context = value;
			return value;
		} else {
			return this._context;
		}
	}

	, 
	onContextProvided: function (context, hitContext) {
		this.context(context);
		this.hitContext(hitContext);
	}

	, 
	_isDirty: false,
	isDirty: function (value) {
		if (arguments.length === 1) {
			this._isDirty = value;
			return value;
		} else {
			return this._isDirty;
		}
	}

	, 
	makeDirty: function () {
		if (this.model().chart() == null) {
			return;
		}

		if (!this.isDirty()) {
			this.isDirty(true);
			this.model().chart().canvasRenderScheduler().schedule();
		}

	}

	, 
	undirty: function (clearRect) {
		this.isDirty(false);
		this.render(clearRect);
	}
	, 
	__backgroundRect: null

	, 
	render: function (clearRect) {
		if (this.context() == null) {
			return;
		}

		if (this.context().shouldRender()) {
			if (this.model().seriesViewer() != null && this.model().seriesViewer().actualPixelScalingRatio() != 1) {
				this.context().save();
				this.context().scale(this.model().seriesViewer().actualPixelScalingRatio(), this.model().seriesViewer().actualPixelScalingRatio());
			}

			var _container = this.model().chart().getContainerRect();
			if (clearRect) {
				this.context().clearRectangle(_container.left(), _container.top(), _container.width(), _container.height());
			}

			if (clearRect) {
				if (this.model().seriesViewer().plotAreaBackground() != null) {
					this.__backgroundRect.canvasTop(this.model().viewportRect().top());
					this.__backgroundRect.canvasLeft(this.model().viewportRect().left());
					this.__backgroundRect.width(this.model().viewportRect().width());
					this.__backgroundRect.height(this.model().viewportRect().height());
					this.__backgroundRect.__fill = this.model().seriesViewer().plotAreaBackground();
					this.context().renderRectangle(this.__backgroundRect);
				}

			}

			this.context().save();
			this.context().setRectangleClip(this.model().viewportRect());
			this.renderOverride();
			this.context().restore();
			if (this.model().seriesViewer() != null && this.model().seriesViewer().actualPixelScalingRatio() != 1) {
				this.context().restore();
			}

		}

		if (this.hitContext().shouldRender()) {
			if (this.model().seriesViewer() != null && this.model().seriesViewer().actualPixelScalingRatio() != 1) {
				this.hitContext().save();
				this.hitContext().scale(this.model().seriesViewer().actualPixelScalingRatio(), this.model().seriesViewer().actualPixelScalingRatio());
			}

			var prevRect = this.__renderedRect;
			var _container1 = this.model().chart().getContainerRect();
			if (!prevRect.isEmpty() && clearRect) {
				this.hitContext().clearRectangle(_container1.left(), _container1.top(), _container1.width(), _container1.height());
			}

			if (this.model().seriesViewer() != null && this.model().seriesViewer().actualPixelScalingRatio() != 1) {
				this.hitContext().restore();
			}

		}

	}

	, 
	postRender: function () {
		this.labelPanel().render();
	}
	, 
	__renderedRect: null

	, 
	renderOverride: function () {
		if (this.context().shouldRender()) {
			this.axisLines().__stroke = this.model().actualStroke();
			this.strips().__fill = this.model().strip();
			this.minorLines().__stroke = this.model().actualMinorStroke();
			this.majorLines().__stroke = this.model().actualMajorStroke();
			this.minorLines().strokeThickness(this.model().minorStrokeThickness());
			this.majorLines().strokeThickness(this.model().majorStrokeThickness());
			this.axisLines().strokeThickness(this.model().strokeThickness());
			this.minorLines().strokeDashArray(this.model().minorStrokeDashArray());
			this.majorLines().strokeDashArray(this.model().majorStrokeDashArray());
			this.axisLines().strokeDashArray(this.model().strokeDashArray());
			this.__renderedRect = this.model().viewportRect();
			this.context().renderPath(this.axisLines());
			this.context().renderPath(this.strips());
			this.context().renderPath(this.majorLines());
			this.context().renderPath(this.minorLines());
		}

	}

	, 
	ensureRender: function () {
		this.makeDirty();
	}

	, 
	detachFromChart: function (oldSeriesViewer) {
		if (oldSeriesViewer != null) {
			oldSeriesViewer.canvasRenderScheduler().unRegister(this);
		}

	}

	, 
	attachToChart: function (newSeriesViewer) {
		if (newSeriesViewer != null) {
			newSeriesViewer.canvasRenderScheduler().register(this);
			this.makeDirty();
		}

	}

	, 
	isDisabled: function () {
		return this.context() == null;
	}

	, 
	onTitleChange: function () {
		if (this.model().isAngular() || this.model().isRadial()) {
		return;
		}

		if (this.model().title() == null) {
			this.model().titleTextBlock(null);
			this.model().mustInvalidateLabels(true);
			this.model().renderAxis();
			return;
		}

		if (this.model().titleTextBlock() == null) {
			var titleTextBlock = new $.ig.TextBlock();
			titleTextBlock.text(this.model().title());
			titleTextBlock.dataContext(this.model().titleSettings());
			this.model().titleTextBlock(titleTextBlock);

		} else {
			this.model().titleTextBlock().text(this.model().title());
			this.model().titleTextBlock().dataContext(this.model().titleSettings());
		}

		this.model().mustInvalidateLabels(true);
		this.model().renderAxis();
	}

	, 
	applyDefaultSettings: function () {
		var className;
		var settings = new $.ig.AxisLabelSettings();
		if (this.model().isAngular()) {
			className = "ui-angular-axis-labels";
			settings.margin(0);

		} else if (this.model().isVertical()) {
			className = "ui-vertical-axis-labels";
			settings.location($.ig.AxisLabelsLocation.prototype.outsideLeft);

		} else if (this.model().orientation() == $.ig.AxisOrientation.prototype.radial) {
			className = "ui-radial-axis-labels";
			settings.location($.ig.AxisLabelsLocation.prototype.insideBottom);

		} else {
			className = "ui-horizontal-axis-labels";
			settings.location($.ig.AxisLabelsLocation.prototype.outsideBottom);
		}



		this.applyCssLabelSettings(settings, className);
	}

	, 
	updateStrokeBrushesFromCss: function () {
		if (this.model().seriesViewer() == null) {
			return;
		}

		var chartView = (this.model().seriesViewer()).chartView();
		var cssStroke = chartView.cssAxisStroke();
		var cssMajorStroke = chartView.cssAxisMajorStroke();
		if (this.model().stroke() == null) {
			if (cssStroke == null) {
				this.model().stroke(chartView.axisLineBrush());

			} else if (cssStroke.color().a() != 0) {
				this.model().stroke(cssStroke);
			}


		}

		if (this.model().majorStroke() == null) {
			if (cssMajorStroke == null) {
				this.model().majorStroke(chartView.axisLineBrush());

			} else if (cssMajorStroke.color().a() != 0) {
				this.model().majorStroke(cssMajorStroke);
			}


		}

	}

	, 
	applyCssLabelSettings: function (settings, className) {
		var discovery = $.ig.CssHelper.prototype.getDisoveryElement();
		var body = $("body");
		body.append(discovery);
		var axisTopMargin = $.ig.CssHelper.prototype.getPropertyValue(discovery, className, "margin-top");
		var axisRightMargin = $.ig.CssHelper.prototype.getPropertyValue(discovery, className, "margin-right");
		var axisBottomMargin = $.ig.CssHelper.prototype.getPropertyValue(discovery, className, "margin-bottom");
		var axisLeftMargin = $.ig.CssHelper.prototype.getPropertyValue(discovery, className, "margin-left");
		var horizontalAlignment = $.ig.CssHelper.prototype.getPropertyValue(discovery, className, "text-align");
		var vericalAlignment = $.ig.CssHelper.prototype.getPropertyValue(discovery, className, "vertical-align");
		var textColor = $.ig.CssHelper.prototype.getPropertyValue(discovery, className, "color");
		if (axisTopMargin != null) {
		settings.topMargin(parseFloat(axisTopMargin));
		}

		if (axisRightMargin != null) {
		settings.rightMargin(parseFloat(axisRightMargin));
		}

		if (axisBottomMargin != null) {
		settings.bottomMargin(parseFloat(axisBottomMargin));
		}

		if (axisLeftMargin != null) {
		settings.leftMargin(parseFloat(axisLeftMargin));
		}

		if (textColor != null) {
			if (settings.textColor() == null) {
			settings.textColor(new $.ig.Brush());
			}

			settings.textColor().__fill = textColor;
		}

		if (horizontalAlignment != null) {
			switch (horizontalAlignment) {
				case "right":
					settings.horizontalAlignment($.ig.HorizontalAlignment.prototype.right);
					break;
				case "left":
					settings.horizontalAlignment($.ig.HorizontalAlignment.prototype.left);
					break;
				default:
					settings.horizontalAlignment($.ig.HorizontalAlignment.prototype.center);
					break;
			}

		}

		if (vericalAlignment != null) {
			switch (vericalAlignment) {
				case "top":
					settings.verticalAlignment($.ig.VerticalAlignment.prototype.top);
					break;
				case "bottom":
					settings.verticalAlignment($.ig.VerticalAlignment.prototype.bottom);
					break;
				default:
					settings.verticalAlignment($.ig.VerticalAlignment.prototype.center);
					break;
			}

		}

		discovery.remove();
		this.model().labelSettings(settings);
	}

	, 
	preRender: function () {
		if (this.model().seriesViewer() != null) {
			this.model().seriesViewer().ensureCorrectSize();
		}

	}

	, 
	exportLabelPosition: function (textBlock) {
		return {__x: textBlock.canvasLeft(), __y: textBlock.canvasTop(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
	}

	, 
	exportLabelsPanelPosition: function () {
		return {__x: this.model().labelPanel().labelViewport().left(), __y: this.model().labelPanel().labelViewport().top(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
	}

	, 
	exportLabelsPanelViewport: function () {
		var viewport = this.model().labelPanel().labelViewport();
		return viewport;
	}

	, 
	exportTitlePosition: function (textBlock) {
		return {__x: textBlock.canvasLeft(), __y: textBlock.canvasTop(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
	}

	, 
	exportTitleBounds: function (textBlock) {
		var bounds = $.ig.VisualExportHelper.prototype.getRotatedBounds(textBlock);
		return bounds;
	}

	, 
	exportTitleMargin: function (textBlock) {
		var left = this.model().labelPanel().view().getTitleLeftMargin();
		var top = this.model().labelPanel().view().getTitleTopMargin();
		var right = this.model().labelPanel().view().getTitleRightMargin();
		var bottom = this.model().labelPanel().view().getTitleBottomMargin();
		return new $.ig.Thickness(1, left, top, right, bottom);
	}
	, 
	$type: new $.ig.Type('AxisView', $.ig.Object.prototype.$type, [$.ig.ISchedulableRender.prototype.$type])
}, true);








$.ig.util.defType('ISortingAxis', 'Object', {
	$type: new $.ig.Type('ISortingAxis', null)
}, true);











$.ig.util.defType('HorizontalAxisLabelPanelBase', 'AxisLabelPanelBase', {
	init: function () {


		$.ig.AxisLabelPanelBase.prototype.init.call(this);

	}
	, 
	createView: function () {
		return new $.ig.HorizontalAxisLabelPanelBaseView(this);
	}

	, 
	onViewCreated: function (view) {
		$.ig.AxisLabelPanelBase.prototype.onViewCreated.call(this, view);
		this.horizontalView(view);
	}

	, 
	_horizontalView: null,
	horizontalView: function (value) {
		if (arguments.length === 1) {
			this._horizontalView = value;
			return value;
		} else {
			return this._horizontalView;
		}
	}

	, 
	_largestWidth: 0,
	largestWidth: function (value) {
		if (arguments.length === 1) {
			this._largestWidth = value;
			return value;
		} else {
			return this._largestWidth;
		}
	}

	, 
	_largestHeight: 0,
	largestHeight: function (value) {
		if (arguments.length === 1) {
			this._largestHeight = value;
			return value;
		} else {
			return this._largestHeight;
		}
	}

	, 
	_largestRenderWidth: 0,
	largestRenderWidth: function (value) {
		if (arguments.length === 1) {
			this._largestRenderWidth = value;
			return value;
		} else {
			return this._largestRenderWidth;
		}
	}

	, 
	_largestRenderHeight: 0,
	largestRenderHeight: function (value) {
		if (arguments.length === 1) {
			this._largestRenderHeight = value;
			return value;
		} else {
			return this._largestRenderHeight;
		}
	}

	, 
	bindExtent: function () {
		this.horizontalView().bindExtent();
	}

	, 
	shouldRotate: function () {
		return this.labelSettings() != null && this.labelSettings().hasUserAngle() && this.getEffectiveAngle() % 360 != 0;
	}

	, 
	shouldTryStagger: function () {
		return this.foundCollisions() && !this.useRotation();
	}

	, 
	isHorizontalPanel: function () {
		return true;
	}

	, 
	createBoundsRectangles: function () {
		var $self = this;
		var rectangles = new $.ig.List$1($.ig.Rect.prototype.$type, 0);
		$self.useStaggering(false);
		$self.useRotation(false);
		$self.useWrapping(false);
		var angleDegrees = $self.labelSettings() != null ? ($self.labelSettings().angle()) : 0;
		var angleRadians = angleDegrees * Math.PI / 180;
		if ($self.shouldRotate()) {
			$self.useRotation(true);
		}

		$self.horizontalView().determineTallestLabel(rectangles, angleRadians);
		$self.foundCollisions($self.foundCollisions() || $self.detectCollisions(rectangles));
		if ($self.foundCollisions()) {
			$self.hideOptionalLabels(rectangles);

		} else {
			$self.showOptionalLabels();
		}

		if (!$self.axis().hasUserExtent()) {
			var rad = angleDegrees * (Math.PI / 180);
			var rotatedLabelHeight = Math.abs($self.largestRenderWidth() * Math.sin(rad)) + Math.abs($self.largestRenderHeight() * Math.cos(rad));
			rotatedLabelHeight += $self.view().getLabelTopMargin() + $self.view().getLabelBottomMargin();
			var heightBounds = $self.getTitleHeightBounds();
			$self.extent((rotatedLabelHeight) + (heightBounds) + $self.axis().actualTickLength());

		} else {
			$self.view().bindExtentToSettings();
		}

		if ($self.useRotation()) {
			for (var i = 0; i < rectangles.count(); i++) {
				var currentRect = rectangles.__inner[i];
				currentRect.x($self.labelPositions().__inner[i].value());
				rectangles.__inner[i] = currentRect;
			}

		}

		var staggerLevels = 0;
		if ($self.shouldTryStagger()) {
			staggerLevels = (function () { var $ret = $self.staggerLabels($self.largestHeight(), rectangles); rectangles = $ret.p1; return $ret.ret; }());
		}

		if ($self.foundCollisions() && !$self.useStaggering()) {
			if (staggerLevels > 0) {
				if ($self.horizontalView().shouldUseWrapping()) {
					$self.useWrapping(true);
				}

			}

		}

		if ($self.foundCollisions() && $self.shouldClip()) {
			var actualWidth = $self.labelViewport().width();
			var labelHeightSpan = $self.getLabelSpan();
			var labelRenderHeightSpan = $self.getLabelRenderSpan();
			var span = $self.labelPositions().count() > 1 ? $self.labelPositions().__inner[1].value() - $self.labelPositions().__inner[0].value() : actualWidth;
			var clipWidth = Math.abs(span * 0.8);
			var RectX = 0;
			var startClippingAngle = Math.abs(Math.atan($self.largestHeight() / span) * 180 / Math.PI);
			for (var i1 = 0; i1 < rectangles.count(); i1++) {
				if ($self.areLabelsUnevenlySpaced()) {
					if (i1 > 0 && i1 < rectangles.count() - 1) {
						var spanFront = $self.labelPositions().count() > 1 ? $self.labelPositions().__inner[i1].value() - (rectangles.__inner[i1 - 1].x() + rectangles.__inner[i1 - 1].width()) : actualWidth;
						var spanEnd = $self.labelPositions().count() > 1 ? rectangles.__inner[i1 + 1].x() - $self.labelPositions().__inner[i1].value() : actualWidth;
						clipWidth = Math.abs(Math.min(Math.abs(spanFront * 2), Math.abs(spanEnd * 2)) * 0.8);

					} else {
						if (i1 == 0) {
							var spanEnd1 = $self.labelPositions().count() > 1 ? rectangles.__inner[i1 + 1].x() - $self.labelPositions().__inner[i1].value() : actualWidth;
							clipWidth = Math.abs((span * 2) * 0.8);
						}

						if (i1 == rectangles.count() - 1) {
							var spanFront1 = $self.labelPositions().count() > 1 ? $self.labelPositions().__inner[i1].value() - (rectangles.__inner[i1 - 1].x() + rectangles.__inner[i1 - 1].width()) : actualWidth;
							clipWidth = Math.abs((spanFront1 * 2) * 0.8);
						}

					}

				}

				var clipValueToUse = Math.min(rectangles.__inner[i1].width(), clipWidth);
				RectX = $self.useRotation() ? $self.labelPositions().__inner[i1].value() : $self.labelPositions().__inner[i1].value() - clipValueToUse / 2;
				var simplifiedAngleDegrees = $.ig.GeometryUtil.prototype.simplifyAngle(angleDegrees);
				var optimize = (simplifiedAngleDegrees >= startClippingAngle && simplifiedAngleDegrees <= 180 - startClippingAngle) || (simplifiedAngleDegrees >= 180 + startClippingAngle && simplifiedAngleDegrees <= 360 - startClippingAngle);
				var currentRect1 = rectangles.__inner[i1];
				if ($self.useRotation() && optimize) {
					var textwidth = $self.getWidthBounds($self.textBlocks().__inner[i1]);
					clipWidth = Math.min(labelHeightSpan / Math.abs(Math.sin(angleRadians)), textwidth);
				}

				currentRect1.x(RectX);
				currentRect1.width(Math.min(clipWidth, currentRect1.width()));
				rectangles.__inner[i1] = currentRect1;
				if (!($.ig.util.cast($.ig.TextBlock.prototype.$type, $self.textBlocks().__inner[i1]) !== null)) {
					$self.textBlocks().__inner[i1].width(Math.min(clipWidth, currentRect1.width()));
				}

				var textBlock = $.ig.util.cast($.ig.TextBlock.prototype.$type, $self.textBlocks().__inner[i1]);
				if (textBlock != null) {
					var newText = $self.trimTextBlock(i1, textBlock, clipWidth);
					if ($self.useWrapping()) {
						textBlock.height(labelRenderHeightSpan);

					} else if (!textBlock.text().equals(newText)) {
						textBlock.text(newText);
						$self.textBlocks().__inner[i1].width(Math.min(clipWidth, $self.getDesiredWidth($self.textBlocks().__inner[i1])));
						$self.largestRenderWidth(Math.min($self.largestRenderWidth(), $self.textBlocks().__inner[i1].width()));
					}


				}

			}

		}

		if ($self.shouldVerticalAlign()) {
			$self.doVerticalAlignment(rectangles);
		}

		return rectangles;
	}

	, 
	doVerticalAlignment: function (rectangles) {
		this.horizontalView().handleVerticalAlignment(rectangles);
	}

	, 
	hideOptionalLabels: function (rectangles) {
	}

	, 
	showOptionalLabels: function () {
	}

	, 
	setLabelRotationTransform: function (label, angle) {
		var $self = this;
		var centerX = 0;
		var centerY = $self.largestRenderHeight() / 2;
		var group = new $.ig.TransformGroup();
		var effectiveAngle = $.ig.GeometryUtil.prototype.simplifyAngle($self.getEffectiveAngle());
		var transform = (function () { var $ret = new $.ig.RotateTransform();
		$ret.angle(effectiveAngle);
		$ret.centerX(centerX);
		$ret.centerY(centerY); return $ret;}());
		var yShift = 0;
		var xShift = 0;
		if (effectiveAngle != 0 && effectiveAngle != 360) {
			if (effectiveAngle > 0 && effectiveAngle < 180) {
				yShift = -Math.sin($.ig.MathUtil.prototype.radians(effectiveAngle)) * ($self.largestRenderHeight() / 2);

			} else {
				transform.centerX($self.largestRenderWidth());
				xShift = -$self.largestRenderWidth();
				yShift = -Math.sin($.ig.MathUtil.prototype.radians(effectiveAngle - 180)) * ($self.largestRenderHeight() / 2);
			}

		}

		var translate = (function () { var $ret = new $.ig.TranslateTransform();
		$ret.y(yShift);
		$ret.x(xShift); return $ret;}());
		group.children().add(transform);
		group.children().add(translate);
		label.renderTransform(group);
	}

	, 
	shouldVerticalAlign: function () {
		return !this.useStaggering() && !this.useRotation();
	}

	, 
	shouldClip: function () {
		return true;
	}

	, 
	staggerLabels: function (largestHeight, rectangles) {
		var staggerLevels = 0;
		var tempRectangles = new $.ig.List$1($.ig.Rect.prototype.$type, 0);
		var topOffset = this.getLabelTopOffset() + this.labelViewport().top();
		var span = this.getLabelSpan();
		var bottomOffset = topOffset + span;
		if (largestHeight * 3 <= this._actualExtent) {
			staggerLevels = 3;

		} else if (largestHeight * 2 <= this._actualExtent) {
			staggerLevels = 2;

		} else {
			return {
				ret: staggerLevels, 
				p1: rectangles
			};
		}


		for (var i = 0; i < rectangles.count(); i++) {
			var rect = $.ig.RectUtil.prototype.duplicate(rectangles.__inner[i]);
			if (i % staggerLevels == 0) {
				rect.y(topOffset);

			} else if (i % staggerLevels == staggerLevels - 1) {
				rect.y(bottomOffset - rect.height());

			} else {
				rect.y((topOffset + (span / 2)) - rect.height() / 2);
			}


			tempRectangles.add(rect);
		}

		this.foundCollisions(this.detectCollisions(tempRectangles));
		if (!this.foundCollisions()) {
			this.useStaggering(true);
			rectangles = tempRectangles;
		}

		return {
			ret: staggerLevels, 
			p1: rectangles
		};
	}

	, 
	getTitleBounds: function () {
		var position = this.getTitlePosition(this.axis().titleSettings());
		var titleHeight = this.getTitleHeightBounds();
		var actualLocation = this.actualLabelLocation();
		var top = 0;
		if (position == $.ig.AxisTitlePosition.prototype.top) {
			top += this.labelViewport().top();
			if (actualLocation == $.ig.AxisLabelsLocation.prototype.outsideBottom || actualLocation == $.ig.AxisLabelsLocation.prototype.insideBottom) {
				top += this.axis().actualTickLength();
			}


		} else {
			top = this.labelViewport().bottom() - titleHeight;
			if (actualLocation == $.ig.AxisLabelsLocation.prototype.insideTop || actualLocation == $.ig.AxisLabelsLocation.prototype.outsideTop) {
				top -= this.axis().actualTickLength();
			}

		}

		var titleWidth = this.getTitleWidthBounds();
		var left = 0;
		var horz = this.axis().titleSettings() == null ? $.ig.HorizontalAlignment.prototype.center : this.axis().titleSettings().horizontalAlignment();
		if (horz == $.ig.HorizontalAlignment.prototype.left) {
			left = this.labelViewport().left();

		} else if (horz == $.ig.HorizontalAlignment.prototype.right) {
			left = this.labelViewport().right() - titleWidth;

		} else {
			left = (this.labelViewport().left() + (this.labelViewport().width() / 2)) - (titleWidth / 2);
		}


		return new $.ig.Rect(0, left, top, titleWidth, titleHeight);
	}

	, 
	measureLabels: function (availableSize) {
		if (this.children().contains(this.axis().titleTextBlock()) == false && this.axis().titleTextBlock() != null) {
			this.children().add(this.axis().titleTextBlock());
		}

		var en = this.children().getEnumerator();
		while (en.moveNext()) {
			var element = en.current();
			if (element != this.axis().titleTextBlock() && element != this.view().ticks()) {
				this.view().handleMeasureLabel(element);
			}

		}

		var extent = (this.axis() == null || this._actualExtent <= 0 || $.ig.util.isNaN(this._actualExtent)) ? 50 : this._actualExtent;
		if (this.axis() != null && (this.axis().series() == null || this.axis().series().count() == 0)) {
			if (this.axis().hasUserExtent()) {
				extent = this.axis().getUserExtent();
			}

		}

		if (extent > availableSize.height()) {
			extent = availableSize.height();
		}

		var size = new $.ig.Size(1, 50, extent);
		if (Number.isInfinity(size.width())) {
			size.width(50);
		}

		if (Number.isInfinity(size.height())) {
			size.height(50);
		}

		return size;
	}

	, 
	getLabelTopOffset: function () {
		var offset = 0;
		var posistion = this.getTitlePosition(this.axis().titleSettings());
		if (posistion == $.ig.AxisTitlePosition.prototype.top) {
			offset += this.getTitleHeightBounds();
		}

		var actualLocation = this.actualLabelLocation();
		if (actualLocation == $.ig.AxisLabelsLocation.prototype.outsideBottom || actualLocation == $.ig.AxisLabelsLocation.prototype.insideBottom) {
			offset += this.axis().actualTickLength();
		}

		return offset;
	}

	, 
	getLabelBottomOffset: function () {
		var offset = 0;
		var posistion = this.getTitlePosition(this.axis().titleSettings());
		if (posistion == $.ig.AxisTitlePosition.prototype.bottom) {
			offset += this.getTitleHeightBounds();
		}

		var actualLocation = this.actualLabelLocation();
		if (actualLocation == $.ig.AxisLabelsLocation.prototype.outsideTop || actualLocation == $.ig.AxisLabelsLocation.prototype.insideTop) {
			offset += this.axis().actualTickLength();
		}

		return offset;
	}

	, 
	getLabelSpan: function () {
		var span = (this._actualExtent - this.getLabelTopOffset()) - this.getLabelBottomOffset();
		if (span < 0) {
			span = 0;
		}

		return span;
	}

	, 
	getLabelRenderSpan: function () {
		var span = ((this.getLabelSpan() - this.view().getLabelTopMargin()) - this.view().getLabelBottomMargin());
		if (span < 0) {
			span = 0;
		}

		return span;
	}

	, 
	createTicks: function () {
		var ticksGeometry = this.view().getTicksGeometry();
		this.axis().clearMarks(ticksGeometry);
		if (this.labelSettings() != null && this.labelSettings().visibility() != $.ig.Visibility.prototype.visible) {
			return;
		}

		var tickLength = this.axis().actualTickLength();
		if (tickLength == 0) {
			return;
		}

		var positions = this.getTickValues();
		if (positions == null) {
		return;
		}

		var y1 = this.labelViewport().top();
		var y2;
		var actualLocation = this.actualLabelLocation();
		if (actualLocation == $.ig.AxisLabelsLocation.prototype.outsideTop || actualLocation == $.ig.AxisLabelsLocation.prototype.insideTop) {
			y1 = this.labelViewport().bottom();
			y2 = y1 - this.axis().actualTickLength();

		} else {
			y2 = y1 + this.axis().actualTickLength();
		}

		var tickRenderingInfo = this.view().getThicksRenderingInfo();
		var en = positions.getEnumerator();
		while (en.moveNext()) {
			var x = en.current();
			this.verticalTick(ticksGeometry, x, y1, y2, this.viewportRect(), tickRenderingInfo);
		}

		if (!this.children().contains(this.view().ticks())) {
			this.children().add(this.view().ticks());
		}

	}
	, 
	$type: new $.ig.Type('HorizontalAxisLabelPanelBase', $.ig.AxisLabelPanelBase.prototype.$type)
}, true);

$.ig.util.defType('HorizontalAxisLabelPanel', 'HorizontalAxisLabelPanelBase', {
	init: function () {


		$.ig.HorizontalAxisLabelPanelBase.prototype.init.call(this);

	}
	, 
	getDefaultLabelsLocation: function () {
		return $.ig.AxisLabelsLocation.prototype.outsideBottom;
	}

	, 
	validLocation: function (location) {
		return location == $.ig.AxisLabelsLocation.prototype.insideBottom || location == $.ig.AxisLabelsLocation.prototype.insideTop || location == $.ig.AxisLabelsLocation.prototype.outsideBottom || location == $.ig.AxisLabelsLocation.prototype.outsideTop;
	}
	, 
	$type: new $.ig.Type('HorizontalAxisLabelPanel', $.ig.HorizontalAxisLabelPanelBase.prototype.$type)
}, true);

$.ig.util.defType('HorizontalAxisLabelPanelBaseView', 'AxisLabelPanelBaseView', {

	_horizontalModel: null,
	horizontalModel: function (value) {
		if (arguments.length === 1) {
			this._horizontalModel = value;
			return value;
		} else {
			return this._horizontalModel;
		}
	}
	, 
	init: function (model) {



		$.ig.AxisLabelPanelBaseView.prototype.init.call(this, model);
			this.horizontalModel(model);
	}

	, 
	bindExtent: function () {
	}

	, 
	determineTallestLabel: function (rectangles, angleRadians) {
		var titleHeightBounds = this.model().getTitleHeightBounds();
		var topOffset = this.horizontalModel().getLabelTopOffset();
		this.horizontalModel().largestHeight(-1.7976931348623157E+308);
		this.horizontalModel().largestWidth(-1.7976931348623157E+308);
		this.horizontalModel().largestRenderHeight(-1.7976931348623157E+308);
		this.horizontalModel().largestRenderWidth(-1.7976931348623157E+308);
		var leftMargin = this.getLabelLeftMargin();
		var rightMargin = this.getLabelRightMargin();
		var topMargin = this.getLabelTopMargin();
		var bottomMargin = this.getLabelBottomMargin();
		var viewportTop = this.model().labelViewport().top();
		var actualHeight = (this.model().labelViewport().height() - titleHeightBounds);
		for (var i = 0; i < this.model().textBlocks().count(); i++) {
			if (this.model().labelPositions() == null || i >= this.model().labelPositions().count()) {
			break;
			}

			var x, y, height, elementWidth, renderWidth, renderHeight;
			var currentLabel = this.model().textBlocks().__inner[i];
			renderWidth = this.getDesiredWidth(currentLabel);
			renderHeight = this.getDesiredHeight(currentLabel);
			elementWidth = renderWidth + leftMargin + rightMargin;
			height = renderHeight + topMargin + bottomMargin;
			if (this.model().useRotation()) {
				x = this.model().labelPositions().__inner[i].value();

			} else {
				x = this.model().labelPositions().__inner[i].value() - elementWidth / 2;
			}

			y = viewportTop + topOffset;
			this.horizontalModel().largestHeight(Math.max(height, this.horizontalModel().largestHeight()));
			this.horizontalModel().largestWidth(Math.max(elementWidth, this.horizontalModel().largestWidth()));
			this.horizontalModel().largestRenderHeight(Math.max(renderHeight, this.horizontalModel().largestRenderHeight()));
			this.horizontalModel().largestRenderWidth(Math.max(renderWidth, this.horizontalModel().largestRenderWidth()));
			var rect = new $.ig.Rect(0, x, y, elementWidth, height);
			rectangles.add(rect);
			var lengthV = elementWidth * Math.abs(Math.sin(angleRadians));
			this.model().foundCollisions(lengthV > actualHeight);
		}

	}

	, 
	shouldUseWrapping: function () {
		return false;
	}

	, 
	handleVerticalAlignment: function (rectangles) {
		var titleHeight = this.model().getTitleHeightBounds();
		var topOffset, bottomOffset;
		topOffset = this.horizontalModel().getLabelTopOffset();
		bottomOffset = this.horizontalModel().getLabelBottomOffset();
		var alignment = this.model().labelSettings() != null ? this.model().labelSettings().verticalAlignment() : $.ig.VerticalAlignment.prototype.center;
		var extent = this.model()._actualExtent;
		var count = rectangles.count();
		var labelViewport = this.model().labelViewport();
		var span = this.horizontalModel().getLabelSpan();
		var halfSpan = span / 2;
		for (var i = 0; i < count; i++) {
			var rect = rectangles.__inner[i];
			var halfRectHeight = rect.height() / 2;
			switch (alignment) {
				case $.ig.VerticalAlignment.prototype.top:
					rect.y(labelViewport.top() + topOffset);
					break;
				case $.ig.VerticalAlignment.prototype.center:
				case $.ig.VerticalAlignment.prototype.stretch:
					rect.y((labelViewport.top() + topOffset + halfSpan) - halfRectHeight);
					break;
				case $.ig.VerticalAlignment.prototype.bottom:
					rect.y((labelViewport.bottom() - bottomOffset) - rect.height());
					break;
			}

		}

	}
	, 
	$type: new $.ig.Type('HorizontalAxisLabelPanelBaseView', $.ig.AxisLabelPanelBaseView.prototype.$type)
}, true);








































$.ig.util.defType('PathRenderingInfo', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	_strokeThickness: 0,
	strokeThickness: function (value) {
		if (arguments.length === 1) {
			this._strokeThickness = value;
			return value;
		} else {
			return this._strokeThickness;
		}
	}

	, 
	_stroke: null,
	stroke: function (value) {
		if (arguments.length === 1) {
			this._stroke = value;
			return value;
		} else {
			return this._stroke;
		}
	}

	, 
	_fill: null,
	fill: function (value) {
		if (arguments.length === 1) {
			this._fill = value;
			return value;
		} else {
			return this._fill;
		}
	}

	, 
	_dashArray: null,
	dashArray: function (value) {
		if (arguments.length === 1) {
			this._dashArray = value;
			return value;
		} else {
			return this._dashArray;
		}
	}

	, 
	_alignToPixels: false,
	alignToPixels: function (value) {
		if (arguments.length === 1) {
			this._alignToPixels = value;
			return value;
		} else {
			return this._alignToPixels;
		}
	}
	, 
	$type: new $.ig.Type('PathRenderingInfo', $.ig.Object.prototype.$type)
}, true);








$.ig.util.defType('ScalerParams', 'Object', {
	init: function (window, viewport, inverted) {



		$.ig.Object.prototype.init.call(this);
			this._windowRect = window;
			this._viewportRect = viewport;
			this._effectiveViewportRect = $.ig.Rect.prototype.empty();
			this._isInverted = inverted;
	}
	, 
	_windowRect: null
	, 
	_viewportRect: null
	, 
	_effectiveViewportRect: null
	, 
	_isInverted: false
	, 
	$type: new $.ig.Type('ScalerParams', $.ig.Object.prototype.$type)
}, true);



$.ig.util.defType('SmartAxisLabelPanel', 'AxisLabelPanelBase', {
	__labels: null
	, 
	__labelBounds: null
	, 
	__labelAnchors: null
	, 
	__hasResized: false
	, 
	__shouldResize: false
	, 
	__horizontalLabelAlignment: 0
	, 
	__labelMap: null
	, 
	__actualPanelBounds: null

	, 
	extent: function () {

			return this.axis().smartAxisExtent();
	}

	, 
	actualExtent1: function (value) {
		if (arguments.length === 1) {

			this.axis().actualSmartAxisExtent(value);
			return value;
		} else {

			return this.axis().actualSmartAxisExtent();
		}
	}

	, 
	minimumExtent: function () {

			return this.axis().smartAxisMinimumExtent();
	}

	, 
	maximumExtent: function () {

			return this.axis().smartAxisMaximumExtent();
	}

	, 
	extentType: function () {

			return this.axis().smartAxisExtentType();
	}

	, 
	angle: function () {

			return this.axis().smartAxisAngle();
	}

	, 
	actualAngle: function (value) {
		if (arguments.length === 1) {

			this.axis().actualSmartAxisAngle(value);
			return value;
		} else {

			return this.axis().actualSmartAxisAngle();
		}
	}

	, 
	minimumAngle: function () {

			return this.axis().smartAxisMinimumAngle();
	}

	, 
	maximumAngle: function () {

			return this.axis().smartAxisMaximumAngle();
	}

	, 
	font: function () {

			return this.axis().smartAxisFont();
	}

	, 
	fontSize: function () {

			return this.axis().smartAxisFontSize();
	}

	, 
	actualFontSize: function (value) {
		if (arguments.length === 1) {

			this.axis().actualSmartAxisFontSize(value);
			return value;
		} else {

			return this.axis().actualSmartAxisFontSize();
		}
	}

	, 
	minimumFontSize: function () {

			return this.axis().smartAxisMinimumFontSize();
	}

	, 
	maximumFontSize: function () {

			return this.axis().smartAxisMaximumFontSize();
	}

	, 
	numberOfStaggerLevels: function () {

			return this.axis().smartAxisNumberOfStaggerLevels();
	}

	, 
	minimumStaggerLevels: function () {

			return this.axis().smartAxisMinimumStaggerLevels();
	}

	, 
	maximumStaggerLevels: function () {

			return this.axis().smartAxisMaximumStaggerLevels();
	}

	, 
	actualNumberOfStaggerLevels: function (value) {
		if (arguments.length === 1) {

			this.axis().actualSmartAxisNumberOfStaggerLevels(value);
			return value;
		} else {

			return this.axis().actualSmartAxisNumberOfStaggerLevels();
		}
	}

	, 
	verticalAlignment: function () {

			return this.axis().smartAxisVerticalAlignment();
	}

	, 
	topMargin: function () {

			return this.axis().smartAxisTopMargin();
	}

	, 
	proximityMargin: function () {

			return this.axis().smartAxisProximityMargin();
	}

	, 
	shouldResize: function (value) {
		if (arguments.length === 1) {

			this.__shouldResize = value;
			return value;
		} else {

			return this.__shouldResize;
		}
	}

	, 
	createView: function () {
		return new $.ig.SmartAxisLabelPanelView(this);
	}

	, 
	onViewCreated: function (view) {
		$.ig.AxisLabelPanelBase.prototype.onViewCreated.call(this, view);
		this.horizontalView(view);
	}

	, 
	_horizontalView: null,
	horizontalView: function (value) {
		if (arguments.length === 1) {
			this._horizontalView = value;
			return value;
		} else {
			return this._horizontalView;
		}
	}
	, 
	init: function () {


		this.__horizontalLabelAlignment = $.ig.HorizontalAlignment.prototype.center;

		$.ig.AxisLabelPanelBase.prototype.init.call(this);
			this.__labelBounds = new $.ig.List$1($.ig.Rect.prototype.$type, 0);
			this.__labels = new $.ig.List$1(String, 0);
			this.__labelAnchors = new $.ig.List$1(Number, 0);
			this.__labelMap = new $.ig.List$1($.ig.List$1.prototype.$type.specialize($.ig.Rect.prototype.$type), 0);
			this.__hasResized = false;
			this.__shouldResize = false;
	}

	, 
	toDegrees: function (radians) {
		return radians * 180 / Math.PI;
	}

	, 
	toRadians: function (degrees) {
		return degrees * Math.PI / 180;
	}

	, 
	isHorizontal: function (angle) {
		if (angle % 180 == 0) {
		return true;
		}

		return false;
	}

	, 
	isPositive: function (value) {
		if (!this.isNumber(value)) {
		return false;
		}

		if (value <= 0) {
		return false;
		}

		return true;
	}

	, 
	isNotNegative: function (value) {
		if (!this.isNumber(value)) {
		return false;
		}

		if (value < 0) {
		return false;
		}

		return true;
	}

	, 
	isNumber: function (value) {
		if ($.ig.util.isNaN(value) || Number.isInfinity(value)) {
		return false;
		}

		return true;
	}

	, 
	getLongestLabel: function () {
		var label = "";
		var en = this.__labels.getEnumerator();
		while (en.moveNext()) {
			var currentLabel = en.current();
			if (currentLabel.length > label.length) {
			label = currentLabel;
			}

		}

		return label;
	}

	, 
	shouldUseRotation: function () {
		if (this.isNumber(this.angle())) {
			if (this.isHorizontal(this.angle())) {
			return false;
			}

			return true;
		}

		if (this.isNumber(this.minimumAngle()) && !this.isHorizontal(this.minimumAngle())) {
		return true;
		}

		if (this.__labelAnchors != null && this.__labelAnchors.count() != 0 && this.__labels != null && this.__labels.count() != 0 && this.__actualPanelBounds != null) {
			var posFirst = this.__labelAnchors.__inner[0];
			var posLast = this.__labelAnchors.__inner[this.__labelAnchors.count() - 1];
			var labelFirst = this.__labels.__inner[0];
			var labelLast = this.__labels.__inner[this.__labels.count() - 1];
			var fontSize = this.isUserFont() ? this.fontSize() : (this.minimumFontSize() + this.maximumFontSize()) / 2;
			var labelWidthFirst = this.calculateWidthForLabel(labelFirst, fontSize);
			var labelWidthLast = this.calculateWidthForLabel(labelLast, fontSize);
			if (posFirst - labelWidthFirst / 2 < this.__actualPanelBounds.left() || posLast + labelWidthLast / 2 > this.__actualPanelBounds.right()) {
				return true;
			}

		}

		return false;
	}

	, 
	isUserFont: function () {
		if (this.isNumber(this.fontSize()) && this.fontSize() >= this.minimumFontSize() && this.fontSize() <= this.maximumFontSize()) {
		return true;
		}

		return false;
	}

	, 
	isUserAngle: function () {
		if (this.isNumber(this.angle()) && this.angle() >= this.minimumAngle() && this.angle() <= this.maximumAngle()) {
		return true;
		}

		return false;
	}

	, 
	isUserStaggerLevels: function () {
		if (this.isPositive(this.numberOfStaggerLevels()) && this.numberOfStaggerLevels() >= this.minimumStaggerLevels() && this.numberOfStaggerLevels() <= this.maximumStaggerLevels()) {
		return true;
		}

		return false;
	}

	, 
	isUserExtent: function () {
		if (this.isNumber(this.extent()) && this.extent() >= this.minimumExtent() && this.extent() <= this.maximumExtent()) {
		return true;
		}

		return false;
	}

	, 
	isHorizontalPanel: function () {
		return true;
	}

	, 
	refreshAxis: function () {
		this.axis().mustInvalidateLabels(true);
		this.axis().refresh();
	}

	, 
	calculateWidthForLabel: function (label, fontSize) {
		var tempFont = $.ig.FontUtil.prototype.getFontWithNewFontSize(this.font(), fontSize);
		return $.ig.FontUtil.prototype.getLabelWidth(label, tempFont);
	}

	, 
	calculateTotalWidthForFont: function (fontSize) {
		if (this.__labelAnchors == null && this.__labelAnchors.count() == 0) {
		return 0;
		}

		if (this.__labels.count() == 1) {
		return this.calculateWidthForLabel(this.__labels.__inner[0], fontSize);
		}

		var totalWidth = this.calculateWidthForLabel(this.__labels.__inner[0], fontSize) / 2;
		for (var i = 0; i < this.__labels.count() - 1; i++) {
			var posCurrent = this.__labelAnchors.__inner[i];
			var posNext = this.__labelAnchors.__inner[i + 1];
			var labelCurrent = this.__labels.__inner[i];
			var labelNext = this.__labels.__inner[i + 1];
			var labelWidthCurrent = this.calculateWidthForLabel(labelCurrent, fontSize);
			var labelWidthNext = this.calculateWidthForLabel(labelNext, fontSize);
			var calcWidth = Math.max(posNext - posCurrent, labelWidthNext / 2 + labelWidthCurrent / 2);
			totalWidth = totalWidth + calcWidth;
		}

		totalWidth = totalWidth + this.calculateWidthForLabel(this.__labels.__inner[this.__labels.count() - 1], fontSize) / 2;
		return totalWidth;
	}

	, 
	calculateFontHeight: function (fontSize) {
		var tempFont = $.ig.FontUtil.prototype.getFontWithNewFontSize(this.font(), fontSize);
		return $.ig.FontUtil.prototype.getCurrentFontHeight(this.horizontalView().getContainer(), tempFont);
	}

	, 
	arrangeLabels1: function (width, height) {
		this.view().determineLongestLabel();
		var userFont = false;
		var userAngle = false;
		if (this.isNumber(this.fontSize()) && this.fontSize() >= this.minimumFontSize() && this.fontSize() <= this.maximumFontSize()) {
		userFont = true;
		}

		if (this.isNumber(this.angle()) && this.angle() >= this.minimumAngle() && this.angle() <= this.maximumAngle()) {
		userAngle = true;
		}

		var fontSizeToUse = userFont ? this.fontSize() : this.minimumFontSize();
		var horizontalLayout = false;
		var minimumTotalWidth = this.calculateTotalWidthForFont(fontSizeToUse);
		var fontHeight = this.calculateFontHeight(fontSizeToUse);
		var staggerLevels = $.ig.truncate(Math.min(this.maximumStaggerLevels(), height / fontHeight));
		if ((this.isNumber(this.angle()) && this.isHorizontal(this.angle())) || minimumTotalWidth / staggerLevels <= width) {
		horizontalLayout = true;
		}

		var numberOfStaggerLevels = this.determineNumberOfStaggerLevels(width, height);
		if (numberOfStaggerLevels >= 0) {
			fontHeight = this.calculateFontHeight(this.actualFontSize());
			var counter = 0;
			var en = this.getTextBlocks().getEnumerator();
			while (en.moveNext()) {
				var textBlock = en.current();
				var transform = new $.ig.TransformGroup();
				var translate = new $.ig.TranslateTransform();
				translate.x(this.__labelBounds.__inner[counter].x());
				translate.y(this.labelViewport().top() + this.topMargin() + fontHeight * (counter % this.actualNumberOfStaggerLevels()));
				transform.children().add(translate);
				textBlock.renderTransform(transform);
				counter++;
			}


		} else if (userAngle) {
			var angle = this.angle();
			var previousFontSize = fontSizeToUse;
			var containerBounds = this.__actualPanelBounds;
			while (fontSizeToUse <= this.maximumFontSize() && !userFont) {
				this.__labelMap.clear();
				fontHeight = this.calculateFontHeight(fontSizeToUse);
				this.createLabelMap(1, fontSizeToUse, fontHeight, true);
				var foundCollisions = this.foundAngledCollisions(this.__labelMap.__inner[0], angle, containerBounds, fontSizeToUse);
				if (foundCollisions) {
					break;
				}

				previousFontSize = fontSizeToUse;
				fontSizeToUse = fontSizeToUse + 1;

			}
			this.actualFontSize(previousFontSize);
			this.actualAngle(this.angle());
			var counter1 = 0;
			var en1 = this.getTextBlocks().getEnumerator();
			while (en1.moveNext()) {
				var textBlock1 = en1.current();
				var label = this.__labels.__inner[counter1];
				var anchor = {__x: this.__labelAnchors.__inner[counter1], __y: this.topMargin(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
				var translateY = this.labelViewport().top() + anchor.__y;
				var transform1 = new $.ig.TransformGroup();
				var translate1 = new $.ig.TranslateTransform();
				translate1.x(anchor.__x);
				translate1.y(translateY);
				transform1.children().add(translate1);
				var rotate = new $.ig.RotateTransform();
				rotate.angle(this.actualAngle());
				rotate.centerX(anchor.__x);
				rotate.centerY(translateY);
				transform1.children().add(rotate);
				if (this.actualAngle() == 90) {
					var g = new $.ig.RectangleGeometry();
					g.rect(new $.ig.Rect(0, 0, 0, this.actualExtent1(), this.calculateFontHeight(this.actualFontSize())));
				}

				textBlock1.renderTransform(transform1);
				counter1++;
			}


		} else {
			var longestLabel = this.getLongestLabel();
			var longestLabelWidth = this.calculateWidthForLabel(longestLabel, fontSizeToUse);
			var tickInterval = 0;
			var minAngle = 45;
			if (this.isNumber(this.minimumAngle())) {
				minAngle = this.minimumAngle();
			}

			var maxAngle = 135;
			if (this.isNumber(this.maximumAngle())) {
				maxAngle = this.maximumAngle();
			}

			var angle1 = 45;
			if (userAngle) {
			angle1 = this.angle();
			}

			var previousAngle = 90;
			var previousFontSize1 = fontSizeToUse;
			var containerBounds1 = this.__actualPanelBounds;
			while (fontSizeToUse <= this.maximumFontSize()) {
				this.__labelMap.clear();
				fontHeight = this.calculateFontHeight(fontSizeToUse);
				this.createLabelMap(1, fontSizeToUse, fontHeight, true);
				var foundCollisions1 = this.foundAngledCollisions(this.__labelMap.__inner[0], angle1, containerBounds1, fontSizeToUse);
				if (foundCollisions1) {
					if (angle1 == 45) {
						angle1 = 135;
						continue;

					} else if (angle1 == 135) {
						angle1 = 90;
						continue;

					} else if (angle1 == 90) {
					break;
					}



				}

				previousAngle = angle1;
				previousFontSize1 = fontSizeToUse;
				if (userFont) {
				break;
				}

				fontSizeToUse = fontSizeToUse + 1;
				angle1 = 45;

			}
			this.actualFontSize(previousFontSize1);
			this.actualAngle(previousAngle);
			var counter2 = 0;
			var en2 = this.getTextBlocks().getEnumerator();
			while (en2.moveNext()) {
				var textBlock2 = en2.current();
				var label1 = this.__labels.__inner[counter2];
				var anchor1 = {__x: this.__labelAnchors.__inner[counter2], __y: this.topMargin(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
				var translateY1 = this.labelViewport().top() + anchor1.__y;
				var transform2 = new $.ig.TransformGroup();
				var translate2 = new $.ig.TranslateTransform();
				translate2.x(anchor1.__x);
				translate2.y(translateY1);
				transform2.children().add(translate2);
				var rotate1 = new $.ig.RotateTransform();
				rotate1.angle(this.actualAngle());
				rotate1.centerX(anchor1.__x);
				rotate1.centerY(translateY1);
				transform2.children().add(rotate1);
				if (this.actualAngle() == 90) {
					var g1 = new $.ig.RectangleGeometry();
					g1.rect(new $.ig.Rect(0, 0, 0, this.actualExtent1(), this.calculateFontHeight(this.actualFontSize())));
				}

				textBlock2.renderTransform(transform2);
				counter2++;
			}

		}


	}

	, 
	calculatePanelHeight: function (minHeight, maxHeight, availableWidth, minAngle, maxAngle, minFontSize, maxFontSize) {
		if (this.__labels.count() == 0) {
			return 0;
		}

		var averageFontSize = (minFontSize + maxFontSize) / 2;
		if (this.isUserFont()) {
			averageFontSize = this.fontSize();
		}

		if (!this.shouldUseRotation()) {
			var minimumTotalWidth = this.calculateTotalWidthForFont(averageFontSize);
			if (minimumTotalWidth <= this.maximumStaggerLevels() * availableWidth) {
				return this.calculatePanelHeightWithNoRotation(availableWidth, minHeight, maxHeight, minFontSize, maxFontSize);
			}

		}

		var longestLabel = this.getLongestLabel();
		var longestLabelWidth = this.calculateWidthForLabel(longestLabel, averageFontSize);
		var averageFontHeight;
		var tickInterval = 0;
		averageFontHeight = this.calculateFontHeight(averageFontSize);
		this.actualFontSize(averageFontSize);
		if (this.__labelAnchors.count() > 1) {
			tickInterval = this.__labelAnchors.__inner[1] - this.__labelAnchors.__inner[0];
		}

		if (this.isNumber(this.angle())) {
			this.actualAngle(this.angle());
			return Math.min(maxHeight, this.topMargin() + averageFontHeight + longestLabelWidth * Math.sin(this.toRadians(this.angle())));
		}

		return Math.min(maxHeight, this.topMargin() + averageFontHeight + longestLabelWidth);
	}

	, 
	calculatePanelHeightWithNoRotation: function (availableWidth, minHeight, maxHeight, minFontSize, maxFontSize) {
		var fontSize = (minFontSize + maxFontSize) / 2;
		var direction = 0;
		var fontHeight = 0;
		var previousHeight = 0;
		var currentHeight = 0;
		var userFont = this.isUserFont();
		var userStagger = this.isUserStaggerLevels();
		if (userFont) {
			fontHeight = this.calculateFontHeight(this.fontSize());
			if (userStagger) {
				this.actualNumberOfStaggerLevels(this.numberOfStaggerLevels());
				currentHeight = fontHeight * this.numberOfStaggerLevels() + this.topMargin();

			} else {
				var totalWidth = this.calculateTotalWidthForFont(this.fontSize());
				for (var stagger = 1; stagger <= this.maximumStaggerLevels(); stagger++) {
					if (totalWidth / stagger <= availableWidth) {
						this.actualNumberOfStaggerLevels(stagger);
						currentHeight = fontHeight * stagger + this.topMargin();
						break;
					}

				}

			}


		} else {
			while (fontSize >= this.minimumFontSize() && fontSize <= this.maximumFontSize()) {
				var totalWidth1 = this.calculateTotalWidthForFont(fontSize);
				if (direction == 0) {
					if (totalWidth1 / this.maximumStaggerLevels() <= availableWidth) {
						direction = 1;

					} else {
						direction = -1;
					}

				}

				if (userStagger) {
					this.actualNumberOfStaggerLevels(this.numberOfStaggerLevels());
					fontHeight = this.calculateFontHeight(fontSize);
					currentHeight = fontHeight * this.numberOfStaggerLevels() + this.topMargin();

				} else {
					for (var stagger1 = 1; stagger1 <= this.maximumStaggerLevels(); stagger1++) {
						if (totalWidth1 / stagger1 <= availableWidth) {
							this.actualNumberOfStaggerLevels(stagger1);
							fontHeight = this.calculateFontHeight(fontSize);
							currentHeight = fontHeight * stagger1 + this.topMargin();
							break;
						}

					}

				}

				fontSize = fontSize + direction;

			}
		}

		currentHeight = Math.max(currentHeight, minHeight);
		currentHeight = Math.min(currentHeight, maxHeight);
		return currentHeight;
	}

	, 
	calculatePanelSize: function (availableSize) {
		var height = 0;
		var viewportHeight = this.axis().chart().viewportRect().height();
		if (this.isNotNegative(this.extent())) {
			if (this.extentType() == $.ig.AxisExtentType.prototype.pixel) {
				height = this.extent();

			} else {
				height = viewportHeight * this.extent() / 100;
			}

			this.actualExtent1(height);
			return new $.ig.Size(1, availableSize.width(), height);
		}

		var minHeight = 0;
		var maxHeight = availableSize.height();
		if (this.isNotNegative(this.minimumExtent())) {
			if (this.extentType() != $.ig.AxisExtentType.prototype.percent) {
				minHeight = this.minimumExtent();

			} else {
				minHeight = this.minimumExtent() * viewportHeight / 100;
			}

		}

		if (this.isNotNegative(this.maximumExtent())) {
			if (this.extentType() != $.ig.AxisExtentType.prototype.percent) {
				maxHeight = this.maximumExtent();

			} else {
				maxHeight = this.maximumExtent() * viewportHeight / 100;
			}

		}

		var minAngle = 0;
		if (this.isNumber(this.minimumAngle())) {
			minAngle = this.minimumAngle();
		}

		var maxAngle = 90;
		if (this.isNumber(this.maximumAngle())) {
			maxAngle = this.maximumAngle();
		}

		var minFont = 8;
		if (this.isNumber(this.minimumFontSize())) {
			minFont = this.minimumFontSize();
		}

		var maxFont = 16;
		if (this.isNumber(this.maximumFontSize())) {
			maxFont = this.maximumFontSize();
		}

		var panelHeight = this.calculatePanelHeight(minHeight, maxHeight, availableSize.width(), minAngle, maxAngle, minFont, maxFont);
		this.actualExtent1(panelHeight);
		return new $.ig.Size(1, availableSize.width(), panelHeight);
	}

	, 
	foundHorizontalCollisions: function (rects, containerBounds) {
		if (rects == null || rects.count() == 0) {
		return false;
		}

		if (rects.count() == 1) {
			var rect = rects.__inner[0];
			if (rect.width() > containerBounds.width() || rect.bottom() > containerBounds.bottom()) {
			return true;
			}

		}

		for (var i = 0; i < rects.count() - 1; i++) {
			var current = rects.__inner[i];
			var next = rects.__inner[i + 1];
			if (current.right() + this.proximityMargin() > next.left() || current.right() > containerBounds.right() || next.right() > containerBounds.right() || current.bottom() > containerBounds.bottom() || next.bottom() > containerBounds.bottom()) {
				return true;
			}

		}

		return false;
	}

	, 
	foundAngledCollisions: function (rects, angle, containerBounds, fontSizeToUse) {
		if (rects == null || rects.count() <= 1) {
		return false;
		}

		var angleToUse = this.toRadians(angle);
		for (var i = 0; i < rects.count(); i++) {
			var current = rects.__inner[i];
			var next = rects.__inner[i + 1];
			var displacement = (next.left() - current.left()) * Math.sin(angleToUse);
			var nextTransformed = new $.ig.Rect(0, next.left(), next.top() - displacement, next.width(), next.height());
			if ($.ig.RectUtil.prototype.intersectsWith(current, nextTransformed)) {
			return true;
			}

			if (!$.ig.RectUtil.prototype.contains(containerBounds, $.ig.RectUtil.prototype.rotateAboutPoint(current, current.x(), current.y() + current.height() / 2, angle))) {
			return true;
			}

			if (!$.ig.RectUtil.prototype.contains(containerBounds, $.ig.RectUtil.prototype.rotateAboutPoint(next, next.x(), next.y() + next.height() / 2, angle))) {
			return true;
			}

		}

		return false;
	}

	, 
	createLabelMap: function (staggerLevels, fontSizeToUse, fontHeight, rotated) {
		this.__labelMap.clear();
		for (var i = 0; i < staggerLevels; i++) {
			this.__labelMap.add(new $.ig.List$1($.ig.Rect.prototype.$type, 0));
		}

		for (var i1 = 0; i1 < this.__labels.count(); i1++) {
			var labelString = this.__labels.__inner[i1];
			var labelWidth = this.calculateWidthForLabel(labelString, fontSizeToUse);
			var anchorX = rotated ? this.__labelAnchors.__inner[i1] : this.__labelAnchors.__inner[i1] - labelWidth / 2;
			var labelRect = new $.ig.Rect(0, anchorX, this.topMargin(), labelWidth, fontHeight);
			this.__labelMap.__inner[i1 % staggerLevels].add(labelRect);
		}

		if (!rotated) {
			for (var i2 = 0; i2 < staggerLevels; i2++) {
				var first = this.__labelMap.__inner[i2].__inner[0];
				var offset = 0;
				if (first.left() < 0) {
					offset = 0 - first.left();
				}

				if (offset > 0) {
					for (var j = 0; j < this.__labelMap.__inner[i2].count(); j++) {
						var currentRect = this.__labelMap.__inner[i2].__inner[j];
						currentRect.x(currentRect.x() + offset);
						this.__labelMap.__inner[i2].__inner[j] = currentRect;
					}

				}

			}

		}

	}

	, 
	determineNumberOfStaggerLevels: function (width, height) {
		var numLevels = -1;
		if (this.__labels.count() == 0) {
		return 0;
		}

		var userFont = this.isUserFont();
		var useRotation = this.shouldUseRotation();
		var userStagger = this.isUserStaggerLevels();
		var fontSizeToUse = userFont ? this.fontSize() : this.minimumFontSize();
		var horizontalLayout = false;
		var minimumTotalWidth = this.calculateTotalWidthForFont(fontSizeToUse);
		var fontHeight = this.calculateFontHeight(fontSizeToUse);
		var staggerLevels = $.ig.truncate(Math.min(this.maximumStaggerLevels(), height / fontHeight));
		var containerBounds = this.__actualPanelBounds;
		if ((this.isNumber(this.angle()) && this.isHorizontal(this.angle())) || minimumTotalWidth / staggerLevels <= width) {
		horizontalLayout = true;
		}

		if (!horizontalLayout || useRotation) {
			this.actualNumberOfStaggerLevels(0);
			return -1;
		}

		if (userStagger) {
			staggerLevels = this.numberOfStaggerLevels();

		} else {
			staggerLevels = 1;
		}

		this.__labelMap = new $.ig.List$1($.ig.List$1.prototype.$type.specialize($.ig.Rect.prototype.$type), 0);
		if (userFont) {
			fontSizeToUse = this.fontSize();
			fontHeight = this.calculateFontHeight(this.fontSize());
			if (userStagger) {
				numLevels = this.numberOfStaggerLevels();

			} else {
				var foundCollisions = false;
				for (var i = 1; i <= this.maximumStaggerLevels(); i++) {
					this.createLabelMap(i, fontSizeToUse, fontHeight, false);
					for (var j = 0; j < i; j++) {
						foundCollisions = this.foundHorizontalCollisions(this.__labelMap.__inner[j], containerBounds);
						if (foundCollisions) {
						break;
						}

					}

					if (!foundCollisions) {
						numLevels = i;
						break;
					}

				}

			}


		} else {
			while (height >= staggerLevels * fontHeight && fontSizeToUse <= this.maximumFontSize() && staggerLevels <= this.maximumStaggerLevels()) {
				this.createLabelMap(staggerLevels, fontSizeToUse, fontHeight, false);
				var foundCollisions1 = false;
				for (var i1 = 0; i1 < staggerLevels; i1++) {
					if (foundCollisions1) {
					break;
					}

					foundCollisions1 = this.foundHorizontalCollisions(this.__labelMap.__inner[i1], containerBounds);
				}

				if (!foundCollisions1) {
					numLevels = staggerLevels;
					fontSizeToUse = fontSizeToUse + 1;
					fontHeight = this.calculateFontHeight(fontSizeToUse);

				} else {
					if (!userStagger) {
						staggerLevels = staggerLevels + 1;
					}

				}


			}
			fontSizeToUse = Math.max(fontSizeToUse - 1, this.minimumFontSize());
			fontHeight = this.calculateFontHeight(fontSizeToUse);
		}

		if (numLevels > 0) {
			this.createLabelMap(numLevels, fontSizeToUse, fontHeight, false);
			this.__labelBounds.clear();
			for (var i2 = 0; i2 < this.__labels.count(); i2++) {
				this.__labelBounds.add(this.__labelMap.__inner[i2 % numLevels].__inner[$.ig.intDivide(i2, numLevels)]);
			}

		}

		this.actualFontSize(fontSizeToUse);
		this.actualNumberOfStaggerLevels(Math.max(0, numLevels));
		return numLevels;
	}

	, 
	measure: function () {
		if (this.labelViewport().isEmpty() || this.labelDataContext() == null) {
			return;
		}

		this.__labels.clear();
		var en = this.labelDataContext().getEnumerator();
		while (en.moveNext()) {
			var obj = en.current();
			this.__labels.add(obj);
		}

		this.__labelAnchors.clear();
		for (var i = 0; i < this.labelPositions().count(); i++) {
			var pos = this.labelPositions().__inner[i];
			this.__labelAnchors.add(pos.value());
		}

		var windowScale = 1;
		var chartWidth = this.labelViewport().width();
		var axisWindowRect = this.windowRect();
		if (this.axis() != null && this.axis().chart() != null && this.axis().chart().view() != null) {
			chartWidth = this.axis().chart().getContainerRect().width();
			windowScale = Math.min(1, this.axis().chart().windowRect().width());
			axisWindowRect = this.axis().chart().windowRect();
		}

		var panelWidth = chartWidth / windowScale;
		var panelHeight = this.labelViewport().height();
		var panelLeft = 0 - axisWindowRect.left() * panelWidth;
		var panelTop = 0;
		this.__actualPanelBounds = new $.ig.Rect(0, panelLeft, panelTop, panelWidth, panelHeight);
		var size = new $.ig.Size(1, panelWidth, panelHeight);
		this.measureOverride(size);
	}

	, 
	arrange: function () {
		if (this.__actualPanelBounds == null) {
		return;
		}

		var size = new $.ig.Size(1, this.__actualPanelBounds.width(), this.__actualPanelBounds.height());
		this.arrangeOverride(size);
	}

	, 
	render: function () {
		this.view().render();
	}

	, 
	measureOverride: function (availableSize) {
		if (this.__labels.count() == 0) {
		return availableSize;
		}

		if (!this.__hasResized || this.__shouldResize) {
			availableSize = this.calculatePanelSize(availableSize);
			this.__hasResized = true;
			this.__shouldResize = false;
			this.axis().chart().invalidatePanels();
		}

		return new $.ig.Size(1, availableSize.width(), this.actualExtent1());
	}

	, 
	arrangeOverride: function (finalSize) {
		if (this.__labels.count() == 0) {
		return finalSize;
		}

		this.arrangeLabels1(finalSize.width(), this.actualExtent1());
		return new $.ig.Size(1, finalSize.width(), this.actualExtent1());
	}
	, 
	$type: new $.ig.Type('SmartAxisLabelPanel', $.ig.AxisLabelPanelBase.prototype.$type)
}, true);

$.ig.util.defType('SmartAxisLabelPanelView', 'AxisLabelPanelBaseView', {

	_horizontalModel: null,
	horizontalModel: function (value) {
		if (arguments.length === 1) {
			this._horizontalModel = value;
			return value;
		} else {
			return this._horizontalModel;
		}
	}
	, 
	init: function (model) {



		$.ig.AxisLabelPanelBaseView.prototype.init.call(this, model);
			this.horizontalModel(model);
	}

	, 
	render: function () {
		if (this.context() == null) {
			return;
		}

		if (this.context().shouldRender()) {
			if (this.model().axis().seriesViewer() != null && this.model().axis().seriesViewer().actualPixelScalingRatio() != 1) {
				this.context().save();
				this.context().scale(this.model().axis().seriesViewer().actualPixelScalingRatio(), this.model().axis().seriesViewer().actualPixelScalingRatio());
			}

			this.context().setFont(this.horizontalModel().font());
			var labelBrush = this.model().axis().chart().getFontBrush();
			if (this.model().labelSettings() != null && this.model().labelSettings().textColor() != null) {
				labelBrush = this.model().labelSettings().textColor();
			}

			var en = this.getLabels().getEnumerator();
			while (en.moveNext()) {
				var child = en.current();
				var tb = $.ig.util.cast($.ig.TextBlock.prototype.$type, child);
				if (tb != null) {
					tb.fill(labelBrush);
					if (tb.renderTransform() != null) {
						this.context().save();
						tb.canvasLeft(0);
						tb.canvasTop(0);
						this.context().applyTransform(tb.renderTransform());
					}

					this.context().renderTextBlock(tb);
					if (tb.renderTransform() != null) {
						this.context().restore();
					}

				}

			}

			if (this.model().axis().seriesViewer() != null && this.model().axis().seriesViewer().actualPixelScalingRatio() != 1) {
				this.context().restore();
			}

		}

	}
	, 
	__fakeContainer: null

	, 
	getContainer: function () {
		if (this.model().axis().seriesViewer() != null) {
			return this.model().axis().seriesViewer().view().viewManager().container();

		} else {
			if (this.__fakeContainer == null) {
				this.__fakeContainer = $("<div></div>");
			}

			return this.__fakeContainer;
		}

	}
	, 
	$type: new $.ig.Type('SmartAxisLabelPanelView', $.ig.AxisLabelPanelBaseView.prototype.$type)
}, true);

$.ig.util.defType('TickmarkValues', 'DependencyObject', {
	init: function () {


		$.ig.DependencyObject.prototype.init.call(this);

	}
	, 
	initialize: function (initializationParameters) {
		this.visibleMaximum(initializationParameters.visibleMaximum());
	}

	, 
	_visibleMaximum: 0,
	visibleMaximum: function (value) {
		if (arguments.length === 1) {
			this._visibleMaximum = value;
			return value;
		} else {
			return this._visibleMaximum;
		}
	}

	, 
	_interval: 0,
	interval: function (value) {
		if (arguments.length === 1) {
			this._interval = value;
			return value;
		} else {
			return this._interval;
		}
	}

	, 
	_firstIndex: 0,
	firstIndex: function (value) {
		if (arguments.length === 1) {
			this._firstIndex = value;
			return value;
		} else {
			return this._firstIndex;
		}
	}

	, 
	_lastIndex: 0,
	lastIndex: function (value) {
		if (arguments.length === 1) {
			this._lastIndex = value;
			return value;
		} else {
			return this._lastIndex;
		}
	}

	, 
	majorValuesArray: function () {}

	, 
	minorValuesArray: function () {}

	, 
	_minorCount: 0,
	minorCount: function (value) {
		if (arguments.length === 1) {
			this._minorCount = value;
			return value;
		} else {
			return this._minorCount;
		}
	}
	, 
	$type: new $.ig.Type('TickmarkValues', $.ig.DependencyObject.prototype.$type)
}, true);




$.ig.util.defType('TickmarkValuesInitializationParameters', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	_visibleMinimum: 0,
	visibleMinimum: function (value) {
		if (arguments.length === 1) {
			this._visibleMinimum = value;
			return value;
		} else {
			return this._visibleMinimum;
		}
	}

	, 
	_visibleMaximum: 0,
	visibleMaximum: function (value) {
		if (arguments.length === 1) {
			this._visibleMaximum = value;
			return value;
		} else {
			return this._visibleMaximum;
		}
	}

	, 
	_actualMinimum: 0,
	actualMinimum: function (value) {
		if (arguments.length === 1) {
			this._actualMinimum = value;
			return value;
		} else {
			return this._actualMinimum;
		}
	}

	, 
	_actualMaximum: 0,
	actualMaximum: function (value) {
		if (arguments.length === 1) {
			this._actualMaximum = value;
			return value;
		} else {
			return this._actualMaximum;
		}
	}

	, 
	_resolution: 0,
	resolution: function (value) {
		if (arguments.length === 1) {
			this._resolution = value;
			return value;
		} else {
			return this._resolution;
		}
	}

	, 
	_hasUserInterval: false,
	hasUserInterval: function (value) {
		if (arguments.length === 1) {
			this._hasUserInterval = value;
			return value;
		} else {
			return this._hasUserInterval;
		}
	}

	, 
	_userInterval: 0,
	userInterval: function (value) {
		if (arguments.length === 1) {
			this._userInterval = value;
			return value;
		} else {
			return this._userInterval;
		}
	}

	, 
	_intervalOverride: 0,
	intervalOverride: function (value) {
		if (arguments.length === 1) {
			this._intervalOverride = value;
			return value;
		} else {
			return this._intervalOverride;
		}
	}

	, 
	_minorCountOverride: 0,
	minorCountOverride: function (value) {
		if (arguments.length === 1) {
			this._minorCountOverride = value;
			return value;
		} else {
			return this._minorCountOverride;
		}
	}

	, 
	_mode: 0,
	mode: function (value) {
		if (arguments.length === 1) {
			this._mode = value;
			return value;
		} else {
			return this._mode;
		}
	}

	, 
	_mode2GroupCount: 0,
	mode2GroupCount: function (value) {
		if (arguments.length === 1) {
			this._mode2GroupCount = value;
			return value;
		} else {
			return this._mode2GroupCount;
		}
	}

	, 
	_viewport: null,
	viewport: function (value) {
		if (arguments.length === 1) {
			this._viewport = value;
			return value;
		} else {
			return this._viewport;
		}
	}

	, 
	_window: null,
	window: function (value) {
		if (arguments.length === 1) {
			this._window = value;
			return value;
		} else {
			return this._window;
		}
	}

	, 
	_isInverted: false,
	isInverted: function (value) {
		if (arguments.length === 1) {
			this._isInverted = value;
			return value;
		} else {
			return this._isInverted;
		}
	}

	, 
	_getScaledValue: null,
	getScaledValue: function (value) {
		if (arguments.length === 1) {
			this._getScaledValue = value;
			return value;
		} else {
			return this._getScaledValue;
		}
	}

	, 
	_getGroupCenter: null,
	getGroupCenter: function (value) {
		if (arguments.length === 1) {
			this._getGroupCenter = value;
			return value;
		} else {
			return this._getGroupCenter;
		}
	}

	, 
	_getUnscaledGroupCenter: null,
	getUnscaledGroupCenter: function (value) {
		if (arguments.length === 1) {
			this._getUnscaledGroupCenter = value;
			return value;
		} else {
			return this._getUnscaledGroupCenter;
		}
	}
	, 
	$type: new $.ig.Type('TickmarkValuesInitializationParameters', $.ig.Object.prototype.$type)
}, true);































































$.ig.util.defType('VerticalAxisLabelPanel', 'AxisLabelPanelBase', {
	init: function () {


		$.ig.AxisLabelPanelBase.prototype.init.call(this);

	}
	, 
	createView: function () {
		return new $.ig.VerticalAxisLabelPanelView(this);
	}

	, 
	onViewCreated: function (view) {
		$.ig.AxisLabelPanelBase.prototype.onViewCreated.call(this, view);
		this.verticalView(view);
	}

	, 
	_verticalView: null,
	verticalView: function (value) {
		if (arguments.length === 1) {
			this._verticalView = value;
			return value;
		} else {
			return this._verticalView;
		}
	}

	, 
	_largestWidth: 0,
	largestWidth: function (value) {
		if (arguments.length === 1) {
			this._largestWidth = value;
			return value;
		} else {
			return this._largestWidth;
		}
	}

	, 
	_largestHeight: 0,
	largestHeight: function (value) {
		if (arguments.length === 1) {
			this._largestHeight = value;
			return value;
		} else {
			return this._largestHeight;
		}
	}

	, 
	_largestRenderWidth: 0,
	largestRenderWidth: function (value) {
		if (arguments.length === 1) {
			this._largestRenderWidth = value;
			return value;
		} else {
			return this._largestRenderWidth;
		}
	}

	, 
	_largestRenderHeight: 0,
	largestRenderHeight: function (value) {
		if (arguments.length === 1) {
			this._largestRenderHeight = value;
			return value;
		} else {
			return this._largestRenderHeight;
		}
	}

	, 
	bindExtent: function () {
		this.verticalView().bindExtent();
	}

	, 
	getTitleEffectiveAngle: function () {
		return this.axis().titleSettings() != null ? this.axis().titleSettings().angle() : -90;
	}

	, 
	getLabelLeftOffset: function () {
		var offset = 0;
		var posistion = this.getTitlePosition(this.axis().titleSettings());
		if (posistion == $.ig.AxisTitlePosition.prototype.left) {
			offset += this.getTitleWidthBounds();
		}

		var actualLocation = this.actualLabelLocation();
		if (actualLocation == $.ig.AxisLabelsLocation.prototype.outsideRight || actualLocation == $.ig.AxisLabelsLocation.prototype.insideRight) {
			offset += this.axis().actualTickLength();
		}

		return offset;
	}

	, 
	getLabelRightOffset: function () {
		var offset = 0;
		var posistion = this.getTitlePosition(this.axis().titleSettings());
		if (posistion == $.ig.AxisTitlePosition.prototype.right) {
			offset += this.getTitleWidthBounds();
		}

		var actualLocation = this.actualLabelLocation();
		if (actualLocation == $.ig.AxisLabelsLocation.prototype.outsideLeft || actualLocation == $.ig.AxisLabelsLocation.prototype.insideLeft) {
			offset += this.axis().actualTickLength();
		}

		return offset;
	}

	, 
	getLabelSpan: function () {
		var span = (this._actualExtent - this.getLabelLeftOffset()) - this.getLabelRightOffset();
		if (span < 0) {
			span = 0;
		}

		return span;
	}

	, 
	getLabelRenderSpan: function () {
		var span = ((this.getLabelSpan() - this.view().getLabelLeftMargin()) - this.view().getLabelRightMargin());
		if (span < 0) {
			span = 0;
		}

		return span;
	}

	, 
	createBoundsRectangles: function () {
		var rectangles = new $.ig.List$1($.ig.Rect.prototype.$type, 0);
		this.useStaggering(false);
		this.useRotation(false);
		if (this.labelSettings() != null && this.labelSettings().hasUserAngle() && this.getEffectiveAngle() % 360 != 0) {
			this.useRotation(true);
		}

		this.largestWidth(-1.7976931348623157E+308);
		this.largestHeight(-1.7976931348623157E+308);
		this.largestRenderWidth(-1.7976931348623157E+308);
		this.largestRenderHeight(-1.7976931348623157E+308);
		var marginLeft = this.view().getLabelLeftMargin();
		var marginTop = this.view().getLabelTopMargin();
		var marginRight = this.view().getLabelRightMargin();
		var marginBottom = this.view().getLabelBottomMargin();
		var labelLeftOffset = this.getLabelLeftOffset();
		for (var i = 0; i < this.textBlocks().count(); i++) {
			var currentTextBlock = this.textBlocks().__inner[i];
			var textHeight = this.getDesiredHeight(currentTextBlock);
			var textWidth = this.getDesiredWidth(currentTextBlock);
			var rectHeight = textHeight + marginTop + marginBottom;
			var rectWidth = textWidth + marginLeft + marginRight;
			var x = this.labelViewport().left() + labelLeftOffset;
			var y = this.labelPositions().__inner[i].value() - rectHeight / 2;
			this.largestWidth(Math.max(rectWidth, this.largestWidth()));
			this.largestHeight(Math.max(rectHeight, this.largestHeight()));
			this.largestRenderWidth(Math.max(textWidth, this.largestRenderWidth()));
			this.largestRenderHeight(Math.max(textHeight, this.largestRenderHeight()));
			var rect = new $.ig.Rect(0, x, y, rectWidth, rectHeight);
			rectangles.add(rect);
		}

		var angleDegrees = 0;
		if (this.useRotation()) {
			angleDegrees = this.getEffectiveAngle() % 360;
			if (angleDegrees < 0) {
				angleDegrees += 360;
			}

		}

		if (!this.axis().hasUserExtent()) {
			var rad = angleDegrees * (Math.PI / 180);
			var rotatedLabelWidth = Math.abs(this.largestRenderWidth() * Math.cos(rad)) + Math.abs(this.largestRenderHeight() * Math.sin(rad));
			var widthBounds = this.getTitleWidthBounds();
			this.extent((rotatedLabelWidth + marginLeft + marginRight) + (widthBounds) + this.axis().actualTickLength());

		} else {
			this.view().bindExtentToSettings();
		}

		if (this.useRotation()) {
			for (var i1 = 0; i1 < rectangles.count(); i1++) {
				var currentRect = rectangles.__inner[i1];
				currentRect.y(this.labelPositions().__inner[i1].value() - this.largestHeight() / 2);
				rectangles.__inner[i1] = currentRect;
			}

		}

		var skipClipping = false;
		if (!this.useRotation() && this.largestWidth() <= this._actualExtent) {
			skipClipping = true;
		}

		if (!skipClipping) {
			var actualHeight = this.labelViewport().height();
			var labelSpan = this.getLabelSpan();
			var clipWidth = labelSpan;
			var span = this.labelPositions().count() > 1 ? Math.abs(this.labelPositions().__inner[1].value() - this.labelPositions().__inner[0].value()) : actualHeight;
			var startClippingAngle = Math.abs(Math.asin(span / this.largestWidth()) * (180 / Math.PI));
			var optimize = (angleDegrees >= startClippingAngle && angleDegrees <= 180 - startClippingAngle) || (angleDegrees - 180 >= startClippingAngle && angleDegrees - 180 <= 180 - startClippingAngle);
			for (var i2 = 0; i2 < rectangles.count(); i2++) {
				if (this.useRotation()) {
					var angleRadians = angleDegrees * (Math.PI / 180);
					var textwidth = this.getWidthBounds(this.textBlocks().__inner[i2]);
					clipWidth = Math.min(labelSpan / Math.abs(Math.cos(angleRadians)), textwidth);
					if (optimize) {
						var rad1;
						if (angleDegrees > 0 && angleDegrees < 90) {
							rad1 = (Math.PI / 180) * (90 - angleDegrees);

						} else if (angleDegrees > 270 && angleDegrees < 360) {
							rad1 = (Math.PI / 180) * (angleDegrees - 270);

						} else {
							rad1 = 0;
						}


						clipWidth = span / Math.cos(rad1);
					}

				}

				var currentRect1 = rectangles.__inner[i2];
				currentRect1.width(Math.min(currentRect1.width(), clipWidth + marginLeft + marginRight));
				rectangles.__inner[i2] = currentRect1;
				if (!($.ig.util.cast($.ig.TextBlock.prototype.$type, this.textBlocks().__inner[i2]) !== null)) {
					this.textBlocks().__inner[i2].width(clipWidth);
				}

				var textBlock = $.ig.util.cast($.ig.TextBlock.prototype.$type, this.textBlocks().__inner[i2]);
				if (textBlock != null) {
					var newText = this.trimTextBlock(i2, textBlock, clipWidth);
					if (!textBlock.text().equals(newText)) {
						textBlock.text(newText);
						this.textBlocks().__inner[i2].width(clipWidth);
					}

				}

			}

		}

		if (this.shouldHorizontalAlign()) {
			this.doHorizontalAlignment(rectangles);
		}

		return rectangles;
	}

	, 
	doHorizontalAlignment: function (rectangles) {
		this.verticalView().handleHorizontalAlignment(rectangles, this.largestWidth());
	}

	, 
	setLabelRotationTransform: function (label, angle) {
		var $self = this;
		var centerX = 0;
		var centerY = $self.largestRenderHeight() / 2;
		var group = new $.ig.TransformGroup();
		var effectiveAngle = $.ig.GeometryUtil.prototype.simplifyAngle($self.getEffectiveAngle());
		var transform = (function () { var $ret = new $.ig.RotateTransform();
		$ret.angle(effectiveAngle);
		$ret.centerX(centerX);
		$ret.centerY(centerY); return $ret;}());
		var xShift = 0;
		var yShift = 0;
		if (effectiveAngle != 0 && effectiveAngle != 360) {
			effectiveAngle -= 90;
			if (effectiveAngle > 0 && effectiveAngle < 180) {
				transform.centerX($self.largestRenderWidth());
				xShift = -$self.largestRenderWidth() + $self.largestRenderHeight() / 2;
				xShift = xShift + Math.sin($.ig.MathUtil.prototype.radians(effectiveAngle - 180)) * ($self.largestRenderHeight() / 2);

			} else {
				if (effectiveAngle >= 180) {
					xShift = xShift - Math.cos($.ig.MathUtil.prototype.radians(effectiveAngle)) * ($self.largestRenderHeight() / 2);

				} else {
					xShift = xShift + Math.cos($.ig.MathUtil.prototype.radians(effectiveAngle)) * ($self.largestRenderHeight() / 2);
				}

			}

		}

		var translate = (function () { var $ret = new $.ig.TranslateTransform();
		$ret.x(xShift);
		$ret.y(yShift); return $ret;}());
		group.children().add(transform);
		group.children().add(translate);
		label.renderTransform(group);
	}

	, 
	shouldHorizontalAlign: function () {
		return !this.useStaggering() && !this.useRotation();
	}

	, 
	getTitleBounds: function () {
		var position = this.getTitlePosition(this.axis().titleSettings());
		var titleWidth = this.getTitleWidthBounds();
		var actualLocation = this.actualLabelLocation();
		var left = 0;
		if (position == $.ig.AxisTitlePosition.prototype.left) {
			left += this.labelViewport().left();
			if (actualLocation == $.ig.AxisLabelsLocation.prototype.outsideRight || actualLocation == $.ig.AxisLabelsLocation.prototype.insideRight) {
				left += this.axis().actualTickLength();
			}


		} else {
			left = this.labelViewport().right() - titleWidth;
			if (actualLocation == $.ig.AxisLabelsLocation.prototype.insideLeft || actualLocation == $.ig.AxisLabelsLocation.prototype.outsideLeft) {
				left -= this.axis().actualTickLength();
			}

		}

		var titleHeight = this.getTitleHeightBounds();
		var top = 0;
		var vert = this.axis().titleSettings() == null ? $.ig.VerticalAlignment.prototype.center : this.axis().titleSettings().verticalAlignment();
		if (vert == $.ig.VerticalAlignment.prototype.top) {
			top = this.labelViewport().top();

		} else if (vert == $.ig.VerticalAlignment.prototype.bottom) {
			top = this.labelViewport().bottom() - titleHeight;

		} else {
			top = (this.labelViewport().top() + (this.labelViewport().height() / 2)) - (titleHeight / 2);
		}


		return new $.ig.Rect(0, left, top, titleWidth, titleHeight);
	}

	, 
	getTitlePosition: function (titleSettings) {
		if (titleSettings == null) {
			return this.axis().seriesViewer().getDefaultVerticalAxisTitlePosition(this.axis());
		}

		if (titleSettings.position() == $.ig.AxisTitlePosition.prototype.auto) {
			if (this.axis() != null && this.axis().seriesViewer() != null) {
				return this.axis().seriesViewer().getDefaultVerticalAxisTitlePosition(this.axis());
			}

			return $.ig.AxisTitlePosition.prototype.left;
		}

		return titleSettings.position();
	}

	, 
	getDefaultLabelsLocation: function () {
		return $.ig.AxisLabelsLocation.prototype.outsideLeft;
	}

	, 
	validLocation: function (location) {
		return location == $.ig.AxisLabelsLocation.prototype.outsideLeft || location == $.ig.AxisLabelsLocation.prototype.outsideRight || location == $.ig.AxisLabelsLocation.prototype.insideLeft || location == $.ig.AxisLabelsLocation.prototype.insideRight;
	}

	, 
	measureLabels: function (availableSize) {
		if ((this.children().contains(this.axis().titleTextBlock()) == false) && this.axis().titleTextBlock() != null) {
			this.children().add(this.axis().titleTextBlock());
		}

		var en = this.children().getEnumerator();
		while (en.moveNext()) {
			var element = en.current();
			if (element != this.axis().titleTextBlock() && element != this.view().ticks()) {
				this.view().handleMeasureLabel(element);
			}

		}

		var extent = (this.axis() == null || this._actualExtent <= 0 || $.ig.util.isNaN(this._actualExtent)) ? 50 : this._actualExtent;
		if (extent > availableSize.width()) {
			extent = availableSize.width();
		}

		var size = new $.ig.Size(1, extent, 50);
		if (Number.isInfinity(size.width())) {
			size.width(50);
		}

		if (Number.isInfinity(size.height())) {
			size.height(50);
		}

		return size;
	}

	, 
	createTicks: function () {
		var ticksGeometry = this.view().getTicksGeometry();
		this.axis().clearMarks(ticksGeometry);
		if (this.labelSettings() != null && this.labelSettings().visibility() != $.ig.Visibility.prototype.visible) {
			return;
		}

		var tickLength = this.axis().actualTickLength();
		if (tickLength == 0) {
			return;
		}

		var positions = this.getTickValues();
		if (positions == null) {
		return;
		}

		var x1 = this.labelViewport().left();
		var x2;
		var actualLocation = this.actualLabelLocation();
		if (actualLocation == $.ig.AxisLabelsLocation.prototype.outsideLeft || actualLocation == $.ig.AxisLabelsLocation.prototype.insideLeft) {
			x1 = this.labelViewport().right();
			x2 = x1 - tickLength;

		} else {
			x2 = x1 + tickLength;
		}

		var tickRenderingInfo = this.view().getThicksRenderingInfo();
		var en = positions.getEnumerator();
		while (en.moveNext()) {
			var y = en.current();
			this.horizontalTick(ticksGeometry, y, x1, x2, this.viewportRect(), tickRenderingInfo);
		}

		if (!this.children().contains(this.view().ticks())) {
			this.children().add(this.view().ticks());
		}

	}
	, 
	$type: new $.ig.Type('VerticalAxisLabelPanel', $.ig.AxisLabelPanelBase.prototype.$type)
}, true);

$.ig.util.defType('VerticalAxisLabelPanelView', 'AxisLabelPanelBaseView', {

	_verticalModel: null,
	verticalModel: function (value) {
		if (arguments.length === 1) {
			this._verticalModel = value;
			return value;
		} else {
			return this._verticalModel;
		}
	}
	, 
	init: function (model) {



		$.ig.AxisLabelPanelBaseView.prototype.init.call(this, model);
			this.verticalModel(model);
	}

	, 
	bindExtent: function () {
	}

	, 
	getAxisTitleFont: function () {
		var font = this.model().axis().seriesViewer().getFont();
		if (this.model().axis().titleSettings() != null && this.model().axis().titleSettings().textStyle() != null) {
			font = this.model().axis().titleSettings().textStyle();

		} else {
			var defFont = this.model().axis().seriesViewer().getDefaultVerticalAxisFont();
			if (String.isNullOrEmpty(defFont) == false) {
				font = defFont;
			}

		}

		return font;
	}

	, 
	getAxisTitleColor: function () {
		var brush = this.model().axis().chart().getFontBrush();
		if (this.model().axis().titleSettings() != null && this.model().axis().titleSettings().textColor() != null) {
			brush = this.model().axis().titleSettings().textColor();

		} else {
			var defBrush = this.model().axis().seriesViewer().getDefaultverticalAxisColor();
			if (defBrush != null) {
				brush = defBrush;
			}

		}

		return brush;
	}

	, 
	handleHorizontalAlignment: function (rectangles, largestWidth) {
		var leftOffset, rightOffset;
		leftOffset = this.verticalModel().getLabelLeftOffset();
		rightOffset = this.verticalModel().getLabelRightOffset();
		var alignment = this.model().labelSettings() != null ? this.model().labelSettings().horizontalAlignment() : $.ig.HorizontalAlignment.prototype.center;
		var extent = this.model()._actualExtent;
		var span = this.verticalModel().getLabelSpan();
		var halfSpan = span / 2;
		var labelViewport = this.model().labelViewport();
		for (var i = 0; i < rectangles.count(); i++) {
			var rect = rectangles.__inner[i];
			var halfRectWidth = rect.width() / 2;
			switch (alignment) {
				case $.ig.HorizontalAlignment.prototype.left:
					rect.x(labelViewport.left() + leftOffset);
					break;
				case $.ig.HorizontalAlignment.prototype.center:
				case $.ig.HorizontalAlignment.prototype.stretch:
					rect.x((labelViewport.left() + leftOffset + halfSpan) - halfRectWidth);
					break;
				case $.ig.HorizontalAlignment.prototype.right:
					rect.x((labelViewport.right() - rightOffset) - rect.width());
					break;
			}

		}

	}
	, 
	$type: new $.ig.Type('VerticalAxisLabelPanelView', $.ig.AxisLabelPanelBaseView.prototype.$type)
}, true);



























$.ig.util.defType('MarkerTemplates', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	startMarker: function (context, dataContext, info) {
		context.beginPath();
		var brush = dataContext.actualItemBrush();
		var outlineBrush = dataContext.outline();
		if (brush != null) {
			if (brush._isGradient) {
				var halfWidth = info.availableWidth / 2;
				var halfHeight = info.availableHeight / 2;
				var x = info.xPosition - halfWidth;
				var y = info.yPosition - halfWidth;
				x += info.renderOffsetX;
				y += info.renderOffsetY;
				var grad = $.ig.CanvasViewRenderer.prototype.createGradient(context, brush, x, y, x + info.availableWidth, y + info.availableHeight, dataContext.thickness(), false);
				context.fillStyle = grad;

			} else {
				if (context.fillStyle != brush.__fill) {
					context.fillStyle = brush.__fill;
				}

			}

		}

		if (dataContext.outline() != null) {
			if (dataContext.outline()._isGradient) {
				var halfWidth1 = info.availableWidth / 2;
				var halfHeight1 = info.availableHeight / 2;
				var x1 = info.xPosition - halfWidth1;
				var y1 = info.yPosition - halfWidth1;
				x1 += info.renderOffsetX;
				y1 += info.renderOffsetY;
				var grad1 = $.ig.CanvasViewRenderer.prototype.createGradient(context, dataContext.outline(), x1, y1, x1 + info.availableWidth, y1 + info.availableHeight, dataContext.thickness(), true);
				context.strokeStyle = grad1;

			} else {
				if (context.strokeStyle != dataContext.outline().__fill) {
					context.strokeStyle = dataContext.outline().__fill;
				}

			}

			context.lineWidth = dataContext.thickness();
		}

	}

	, 
	endMarker: function (context, dataContext) {
		if (dataContext.actualItemBrush() != null) {
			context.fill();
		}

		if (dataContext.outline() != null) {
			context.stroke();
		}

		context.closePath();
	}

	, 
	measureAsEightByEightConstantMarkerTemplate: function (info) {
		info.isConstant = true;
		info.width = 8;
		info.height = 8;
	}

	, 
	renderCircleMarkerTemplate: function (info) {
		var ctx = info.context;
		var dataContext = info.data;
		$.ig.MarkerTemplates.prototype.startMarker(ctx, dataContext, info);
		var radius = Math.min(info.availableWidth, info.availableHeight) / 2;
		ctx.arc(info.xPosition, info.yPosition, radius, 0, (Math.PI * 2), false);
		$.ig.MarkerTemplates.prototype.endMarker(ctx, dataContext);
	}

	, 
	renderTriangleMarkerTemplate: function (info) {
		var ctx = info.context;
		var dataContext = info.data;
		$.ig.MarkerTemplates.prototype.startMarker(ctx, dataContext, info);
		var halfHeight = (info.availableHeight / 2);
		var halfWidth = (info.availableWidth / 2);
		var left = (info.xPosition - halfWidth);
		var top = (info.yPosition - halfHeight);
		ctx.moveTo(left, top);
		ctx.lineTo(left + halfWidth, top + info.availableHeight);
		ctx.lineTo(left + info.availableWidth, top + 0);
		ctx.lineTo(left, top);
		$.ig.MarkerTemplates.prototype.endMarker(ctx, dataContext);
	}

	, 
	renderPyramidMarkerTemplate: function (info) {
		var ctx = info.context;
		var dataContext = info.data;
		$.ig.MarkerTemplates.prototype.startMarker(ctx, dataContext, info);
		var halfHeight = (info.availableHeight / 2);
		var halfWidth = (info.availableWidth / 2);
		var left = (info.xPosition - halfWidth);
		var top = (info.yPosition - halfHeight);
		ctx.moveTo(left, top + info.availableHeight);
		ctx.lineTo(left + halfWidth, top + 0);
		ctx.lineTo(left + info.availableWidth, top + info.availableHeight);
		ctx.lineTo(left, top + info.availableHeight);
		$.ig.MarkerTemplates.prototype.endMarker(ctx, dataContext);
	}

	, 
	renderSquareMarkerTemplate: function (info) {
		var ctx = info.context;
		var dataContext = info.data;
		$.ig.MarkerTemplates.prototype.startMarker(ctx, dataContext, info);
		var halfHeight = (info.availableHeight / 2);
		var halfWidth = (info.availableWidth / 2);
		var left = (info.xPosition - halfWidth);
		var top = (info.yPosition - halfHeight);
		ctx.rect(left, top, info.availableWidth, info.availableHeight);
		$.ig.MarkerTemplates.prototype.endMarker(ctx, dataContext);
	}

	, 
	renderAlignedSquareMarkerTemplate: function (info) {
		var ctx = info.context;
		var dataContext = info.data;
		$.ig.MarkerTemplates.prototype.startMarker(ctx, dataContext, info);
		var halfHeight = (info.availableHeight / 2);
		var halfWidth = (info.availableWidth / 2);
		var left_ = (info.xPosition - halfWidth);
		var top_ = (info.yPosition - halfHeight);
		ctx.rect(left_ | 0, top_ | 0, info.availableWidth, info.availableHeight);
		$.ig.MarkerTemplates.prototype.endMarker(ctx, dataContext);
	}

	, 
	renderDiamondMarkerTemplate: function (info) {
		var ctx = info.context;
		var dataContext = info.data;
		$.ig.MarkerTemplates.prototype.startMarker(ctx, dataContext, info);
		var halfHeight = (info.availableHeight / 2);
		var halfWidth = (info.availableWidth / 2);
		var left = (info.xPosition - halfWidth);
		var top = (info.yPosition - halfHeight);
		ctx.moveTo(left + 0, top + halfHeight);
		ctx.lineTo(left + halfWidth, top + info.availableHeight);
		ctx.lineTo(left + info.availableWidth, top + halfHeight);
		ctx.lineTo(left + halfWidth, top + 0);
		ctx.lineTo(left + 0, top + halfHeight);
		$.ig.MarkerTemplates.prototype.endMarker(ctx, dataContext);
	}

	, 
	renderPentagonMarkerTemplate: function (info) {
		var ctx = info.context;
		var dataContext = info.data;
		$.ig.MarkerTemplates.prototype.startMarker(ctx, dataContext, info);
		var halfHeight = (info.availableHeight / 2);
		var halfWidth = (info.availableWidth / 2);
		var left = (info.xPosition - halfWidth);
		var top = (info.yPosition - halfHeight);
		ctx.moveTo(left + ((4 / 8) * info.availableWidth), top + 0);
		ctx.lineTo(left + ((0.1956 / 8) * info.availableWidth), top + ((2.764 / 8) * info.availableHeight));
		ctx.lineTo(left + ((1.65 / 8) * info.availableWidth), top + ((7.236 / 8) * info.availableHeight));
		ctx.lineTo(left + ((6.35 / 8) * info.availableWidth), top + ((7.236 / 8) * info.availableHeight));
		ctx.lineTo(left + ((7.8044 / 8) * info.availableWidth), top + ((2.764 / 8) * info.availableHeight));
		ctx.lineTo(left + ((4 / 8) * info.availableWidth), top + 0);
		$.ig.MarkerTemplates.prototype.endMarker(ctx, dataContext);
	}

	, 
	renderHexagonMarkerTemplate: function (info) {
		var ctx = info.context;
		var dataContext = info.data;
		$.ig.MarkerTemplates.prototype.startMarker(ctx, dataContext, info);
		var halfHeight = (info.availableHeight / 2);
		var halfWidth = (info.availableWidth / 2);
		var left = (info.xPosition - halfWidth);
		var top = (info.yPosition - halfHeight);
		ctx.moveTo(left + ((4 / 8) * info.availableWidth), top + 0);
		ctx.lineTo(left + ((0.356 / 8) * info.availableWidth), top + ((2 / 8) * info.availableHeight));
		ctx.lineTo(left + ((0.356 / 8) * info.availableWidth), top + ((6 / 8) * info.availableHeight));
		ctx.lineTo(left + ((4 / 8) * info.availableWidth), top + (info.availableHeight));
		ctx.lineTo(left + ((7.464 / 8) * info.availableWidth), top + ((6 / 8) * info.availableHeight));
		ctx.lineTo(left + ((7.464 / 8) * info.availableWidth), top + ((2 / 8) * info.availableHeight));
		ctx.lineTo(left + ((4 / 8) * info.availableWidth), top + 0);
		$.ig.MarkerTemplates.prototype.endMarker(ctx, dataContext);
	}

	, 
	renderTetragramMarkerTemplate: function (info) {
		var ctx = info.context;
		var dataContext = info.data;
		$.ig.MarkerTemplates.prototype.startMarker(ctx, dataContext, info);
		var halfHeight = (info.availableHeight / 2);
		var halfWidth = (info.availableWidth / 2);
		var left = (info.xPosition - halfWidth);
		var top = (info.yPosition - halfHeight);
		ctx.moveTo(left + ((4 / 8) * info.availableWidth), top + 0);
		ctx.lineTo(left + ((2.5856 / 8) * info.availableWidth), top + ((2.5856 / 8) * info.availableHeight));
		ctx.lineTo(left + ((0 / 8) * info.availableWidth), top + ((4 / 8) * info.availableHeight));
		ctx.lineTo(left + ((2.5856 / 8) * info.availableWidth), top + ((5.4144 / 8) * info.availableHeight));
		ctx.lineTo(left + ((4 / 8) * info.availableWidth), top + ((8 / 8) * info.availableHeight));
		ctx.lineTo(left + ((5.4144 / 8) * info.availableWidth), top + ((5.4144 / 8) * info.availableHeight));
		ctx.lineTo(left + ((8 / 8) * info.availableWidth), top + ((4 / 8) * info.availableHeight));
		ctx.lineTo(left + ((5.4144 / 8) * info.availableWidth), top + ((2.5856 / 8) * info.availableHeight));
		ctx.lineTo(left + ((4 / 8) * info.availableWidth), top + 0);
		$.ig.MarkerTemplates.prototype.endMarker(ctx, dataContext);
	}

	, 
	renderPentagramMarkerTemplate: function (info) {
		var ctx = info.context;
		var dataContext = info.data;
		$.ig.MarkerTemplates.prototype.startMarker(ctx, dataContext, info);
		var halfHeight = (info.availableHeight / 2);
		var halfWidth = (info.availableWidth / 2);
		var left = (info.xPosition - halfWidth);
		var top = (info.yPosition - halfHeight);
		ctx.moveTo(left + ((4 / 8) * info.availableWidth), top + 0);
		ctx.lineTo(left + ((2.8244 / 8) * info.availableWidth), top + ((2.382 / 8) * info.availableHeight));
		ctx.lineTo(left + ((0.1956 / 8) * info.availableWidth), top + ((2.764 / 8) * info.availableHeight));
		ctx.lineTo(left + ((2.098 / 8) * info.availableWidth), top + ((4.618 / 8) * info.availableHeight));
		ctx.lineTo(left + ((1.6488 / 8) * info.availableWidth), top + ((7.236 / 8) * info.availableHeight));
		ctx.lineTo(left + ((4 / 8) * info.availableWidth), top + ((6 / 8) * info.availableHeight));
		ctx.lineTo(left + ((6.3512 / 8) * info.availableWidth), top + ((7.236 / 8) * info.availableHeight));
		ctx.lineTo(left + ((5.902 / 8) * info.availableWidth), top + ((4.618 / 8) * info.availableHeight));
		ctx.lineTo(left + ((7.8044 / 8) * info.availableWidth), top + ((2.764 / 8) * info.availableHeight));
		ctx.lineTo(left + ((5.1756 / 8) * info.availableWidth), top + ((2.382 / 8) * info.availableHeight));
		ctx.lineTo(left + ((4 / 8) * info.availableWidth), top + 0);
		$.ig.MarkerTemplates.prototype.endMarker(ctx, dataContext);
	}

	, 
	renderHexagramMarkerTemplate: function (info) {
		var ctx = info.context;
		var dataContext = info.data;
		$.ig.MarkerTemplates.prototype.startMarker(ctx, dataContext, info);
		var halfHeight = (info.availableHeight / 2);
		var halfWidth = (info.availableWidth / 2);
		var left = (info.xPosition - halfWidth);
		var top = (info.yPosition - halfHeight);
		ctx.moveTo(left + ((4 / 8) * info.availableWidth), top + 0);
		ctx.lineTo(left + ((3 / 8) * info.availableWidth), top + ((2.268 / 8) * info.availableHeight));
		ctx.lineTo(left + ((0.536 / 8) * info.availableWidth), top + ((2 / 8) * info.availableHeight));
		ctx.lineTo(left + ((2 / 8) * info.availableWidth), top + ((4 / 8) * info.availableHeight));
		ctx.lineTo(left + ((0.536 / 8) * info.availableWidth), top + ((6 / 8) * info.availableHeight));
		ctx.lineTo(left + ((3 / 8) * info.availableWidth), top + ((5.732 / 8) * info.availableHeight));
		ctx.lineTo(left + ((4 / 8) * info.availableWidth), top + ((8 / 8) * info.availableHeight));
		ctx.lineTo(left + ((5 / 8) * info.availableWidth), top + ((5.732 / 8) * info.availableHeight));
		ctx.lineTo(left + ((7.464 / 8) * info.availableWidth), top + ((6 / 8) * info.availableHeight));
		ctx.lineTo(left + ((6 / 8) * info.availableWidth), top + ((4 / 8) * info.availableHeight));
		ctx.lineTo(left + ((7.464 / 8) * info.availableWidth), top + ((2 / 8) * info.availableHeight));
		ctx.lineTo(left + ((5 / 8) * info.availableWidth), top + ((2.268 / 8) * info.availableHeight));
		ctx.lineTo(left + ((4 / 8) * info.availableWidth), top + 0);
		$.ig.MarkerTemplates.prototype.endMarker(ctx, dataContext);
	}
	, 
	$type: new $.ig.Type('MarkerTemplates', $.ig.Object.prototype.$type)
}, true);


$.ig.util.defType('PieChartBase', 'Control', {

	createView: function () {
		return new $.ig.PieChartBaseView(this);
	}

	, 
	onViewCreated: function (view) {
		this.view(view);
	}

	, 
	_view: null,
	view: function (value) {
		if (arguments.length === 1) {
			this._view = value;
			return value;
		} else {
			return this._view;
		}
	}
	, 
	init: function () {


		this.__brushesAttached = false;
		this.__outlinesAttached = false;
		this.__fastItemsSourceAttached = false;
		this.__selectedAttached = false;
		this.__explodedAttached = false;
		this.__explodedSlices = new $.ig.IndexCollection();
		this.__selectedSlices = new $.ig.IndexCollection();
		this.__textStyle = null;

		var $self = this;
		$.ig.Control.prototype.init.call(this);
			this.viewport($.ig.Rect.prototype.empty());
			var view = this.createView();
			this.onViewCreated(view);
			view.onInit();
			this.defaultStyleKey($.ig.PieChartBase.prototype.$type);
			this.valueIndices(new $.ig.List$1($.ig.Number.prototype.$type, 0));
			this.othersValueIndices(new $.ig.List$1($.ig.Number.prototype.$type, 0));
			this.others(new $.ig.List$1($.ig.Object.prototype.$type, 0));
			this.__propertyUpdatedOverride = function (o, e) {
				$self.propertyUpdatedOverride(o, e.propertyName(), e.oldValue(), e.newValue());
			};
			this.__brushesChangedOverride = function (o, e) {
				$self.renderSlices();
				$self.renderLegendItems();
			};
			this.__explodedIndicesChangedOverride = function (o, e) {
				if ($self.allowSliceExplosion()) {
					$self.prepareSlices();
					$self.prepareLabels();
					$self.renderSlices();
					$self.renderLabels();
				}

			};
			this.__selectedIndicesChangedOverride = function (o, e) {
				$self.selectedIndicesChangedOverride(e);
			};
			this._fastItemsSource_Event = function (o, e) {
				$self.dataUpdatedOverride(e.action(), e.position(), e.count(), e.propertyName());
			};
			this.propertyUpdated = $.ig.Delegate.prototype.combine(this.propertyUpdated, this.__propertyUpdatedOverride);
			this.selectedSlices().collectionChanged = $.ig.Delegate.prototype.combine(this.selectedSlices().collectionChanged, this.__selectedIndicesChangedOverride);
			this.__selectedAttached = true;
			this.explodedSlices().collectionChanged = $.ig.Delegate.prototype.combine(this.explodedSlices().collectionChanged, this.__explodedIndicesChangedOverride);
			this.__explodedAttached = true;
			this._slices = (function () { var $ret = new $.ig.Pool$1($.ig.Slice.prototype.$type);
			$ret.create($self.view().sliceCreate.runOn($self.view()));
			$ret.activate($self.view().sliceActivate.runOn($self.view()));
			$ret.disactivate($self.view().sliceDisactivate.runOn($self.view()));
			$ret.destroy($self.view().sliceDestroy.runOn($self.view())); return $ret;}());
			this._labels = (function () { var $ret = new $.ig.Pool$1($.ig.PieLabel.prototype.$type);
			$ret.create($self.view().labelCreate.runOn($self.view()));
			$ret.activate($self.view().labelActivate.runOn($self.view()));
			$ret.disactivate($self.view().labelDisactivate.runOn($self.view()));
			$ret.destroy($self.view().labelDestroy.runOn($self.view())); return $ret;}());
	}
	, 
	__brushesAttached: false
	, 
	__outlinesAttached: false
	, 
	__fastItemsSourceAttached: false
	, 
	__selectedAttached: false
	, 
	__explodedAttached: false
	, 
	__propertyUpdatedOverride: null
	, 
	__brushesChangedOverride: null
	, 
	__selectedIndicesChangedOverride: null
	, 
	__explodedIndicesChangedOverride: null
	, 
	_fastItemsSource_Event: null

	, 
	fastItemsSource: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.PieChartBase.prototype.fastItemsSourceProperty, value);
			return value;
		} else {

			return this.getValue($.ig.PieChartBase.prototype.fastItemsSourceProperty);
		}
	}
	, 
	__valueColumn: null

	, 
	valueColumn: function (value) {
		if (arguments.length === 1) {

			if (this.__valueColumn != value) {
				var oldValueColumn = this.__valueColumn;
				this.__valueColumn = value;
				this.raisePropertyChanged($.ig.PieChartBase.prototype.valueColumnPropertyName, oldValueColumn, this.__valueColumn);
			}

			return value;
		} else {

			return this.__valueColumn;
		}
	}

	, 
	_othersTotal: 0,
	othersTotal: function (value) {
		if (arguments.length === 1) {
			this._othersTotal = value;
			return value;
		} else {
			return this._othersTotal;
		}
	}

	, 
	_total: 0,
	total: function (value) {
		if (arguments.length === 1) {
			this._total = value;
			return value;
		} else {
			return this._total;
		}
	}

	, 
	_valueIndices: null,
	valueIndices: function (value) {
		if (arguments.length === 1) {
			this._valueIndices = value;
			return value;
		} else {
			return this._valueIndices;
		}
	}

	, 
	_othersValueIndices: null,
	othersValueIndices: function (value) {
		if (arguments.length === 1) {
			this._othersValueIndices = value;
			return value;
		} else {
			return this._othersValueIndices;
		}
	}

	, 
	_others: null,
	others: function (value) {
		if (arguments.length === 1) {
			this._others = value;
			return value;
		} else {
			return this._others;
		}
	}

	, 
	_actualStartAngle: 0,
	actualStartAngle: function (value) {
		if (arguments.length === 1) {
			this._actualStartAngle = value;
			return value;
		} else {
			return this._actualStartAngle;
		}
	}

	, 
	_legendItems: null,
	legendItems: function (value) {
		if (arguments.length === 1) {
			this._legendItems = value;
			return value;
		} else {
			return this._legendItems;
		}
	}

	, 
	chartInnerExtent: function () {

			return this.innerExtent();
	}

	, 
	itemsSource: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.PieChartBase.prototype.itemsSourceProperty, value);
			return value;
		} else {

			return this.getValue($.ig.PieChartBase.prototype.itemsSourceProperty);
		}
	}

	, 
	innerExtent: function (value) {
		if (arguments.length === 1) {

			var coercedValue = value;
			if ($.ig.util.isNaN(value) || Number.isInfinity(value)) {
			coercedValue = 0;
			}

			if (value < 0) {
			coercedValue = 0;
			}

			if (value > 100) {
			coercedValue = 100;
			}

			this.setValue($.ig.PieChartBase.prototype.innerExtentProperty, coercedValue);
			return value;
		} else {

			return this.getValue($.ig.PieChartBase.prototype.innerExtentProperty);
		}
	}

	, 
	valueMemberPath: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.PieChartBase.prototype.valueMemberPathProperty, value);
			return value;
		} else {

			return this.getValue($.ig.PieChartBase.prototype.valueMemberPathProperty);
		}
	}

	, 
	labelMemberPath: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.PieChartBase.prototype.labelMemberPathProperty, value);
			return value;
		} else {

			return this.getValue($.ig.PieChartBase.prototype.labelMemberPathProperty);
		}
	}
	, 
	__labelColumn: null

	, 
	labelColumn: function (value) {
		if (arguments.length === 1) {

			if (this.__labelColumn != value) {
				var oldColumn = this.labelColumn();
				this.__labelColumn = value;
				this.raisePropertyChanged($.ig.PieChartBase.prototype.labelColumnPropertyName, oldColumn, this.labelColumn());
			}

			return value;
		} else {

			return this.__labelColumn;
		}
	}

	, 
	labelsPosition: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.PieChartBase.prototype.labelsPositionProperty, $.ig.LabelsPosition.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.PieChartBase.prototype.labelsPositionProperty));
		}
	}

	, 
	leaderLineVisibility: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.PieChartBase.prototype.leaderLineVisibilityProperty, $.ig.Visibility.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.PieChartBase.prototype.leaderLineVisibilityProperty));
		}
	}

	, 
	leaderLineStyle: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.PieChartBase.prototype.leaderLineStyleProperty, value);
			return value;
		} else {

			return this.getValue($.ig.PieChartBase.prototype.leaderLineStyleProperty);
		}
	}

	, 
	leaderLineType: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.PieChartBase.prototype.leaderLineTypeProperty, $.ig.LeaderLineType.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.PieChartBase.prototype.leaderLineTypeProperty));
		}
	}

	, 
	leaderLineMargin: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.PieChartBase.prototype.leaderLineMarginProperty, value);
			return value;
		} else {

			return this.getValue($.ig.PieChartBase.prototype.leaderLineMarginProperty);
		}
	}

	, 
	toolTip: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.PieChartBase.prototype.toolTipProperty, value);
			return value;
		} else {

			return this.getValue($.ig.PieChartBase.prototype.toolTipProperty);
		}
	}

	, 
	othersCategoryThreshold: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.PieChartBase.prototype.othersCategoryThresholdProperty, value);
			return value;
		} else {

			return this.getValue($.ig.PieChartBase.prototype.othersCategoryThresholdProperty);
		}
	}

	, 
	othersCategoryType: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.PieChartBase.prototype.othersCategoryTypeProperty, $.ig.OthersCategoryType.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.PieChartBase.prototype.othersCategoryTypeProperty));
		}
	}

	, 
	othersCategoryText: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.PieChartBase.prototype.othersCategoryTextProperty, value);
			return value;
		} else {

			return this.getValue($.ig.PieChartBase.prototype.othersCategoryTextProperty);
		}
	}

	, 
	explodedRadius: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.PieChartBase.prototype.explodedRadiusProperty, value);
			return value;
		} else {

			return this.getValue($.ig.PieChartBase.prototype.explodedRadiusProperty);
		}
	}

	, 
	actualExplodedRadius: function () {

			var radius = this.explodedRadius();
			if ($.ig.util.isNaN(radius) || Number.isInfinity(radius) || radius < 0) {
			return 0;
			}

			if (radius > 1) {
			return 1;
			}

			return radius;
	}

	, 
	radiusFactor: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.PieChartBase.prototype.radiusFactorProperty, value);
			return value;
		} else {

			return this.getValue($.ig.PieChartBase.prototype.radiusFactorProperty);
		}
	}

	, 
	actualRadiusFactor: function () {

			var radiusFactor = this.radiusFactor();
			if ($.ig.util.isNaN(radiusFactor) || Number.isInfinity(radiusFactor) || radiusFactor < 0) {
			return 0;
			}

			if (radiusFactor > 1) {
			return 1;
			}

			return radiusFactor;
	}

	, 
	allowSliceSelection: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.PieChartBase.prototype.allowSliceSelectionProperty, value);
			return value;
		} else {

			return this.getValue($.ig.PieChartBase.prototype.allowSliceSelectionProperty);
		}
	}

	, 
	allowSliceExplosion: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.PieChartBase.prototype.allowSliceExplosionProperty, value);
			return value;
		} else {

			return this.getValue($.ig.PieChartBase.prototype.allowSliceExplosionProperty);
		}
	}

	, 
	explodedSlices: function (value) {
		if (arguments.length === 1) {

			this.__explodedSlices.collectionChanged = $.ig.Delegate.prototype.remove(this.__explodedSlices.collectionChanged, this.__explodedIndicesChangedOverride);
			this.__explodedAttached = false;
			this.__explodedSlices = value;
			if (this.__explodedSlices != null) {
				this.__explodedSlices.collectionChanged = $.ig.Delegate.prototype.combine(this.__explodedSlices.collectionChanged, this.__explodedIndicesChangedOverride);
				this.__explodedAttached = true;
			}

			if (this.allowSliceExplosion()) {
				this.prepareSlices();
				this.prepareLabels();
				this.renderSlices();
				this.renderLabels();
			}

			return value;
		} else {

			return this.__explodedSlices;
		}
	}
	, 
	__explodedSlices: null

	, 
	legend: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.PieChartBase.prototype.legendProperty, value);
			return value;
		} else {

			return this.getValue($.ig.PieChartBase.prototype.legendProperty);
		}
	}

	, 
	labelExtent: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.PieChartBase.prototype.labelExtentProperty, value);
			return value;
		} else {

			return this.getValue($.ig.PieChartBase.prototype.labelExtentProperty);
		}
	}

	, 
	startAngle: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.PieChartBase.prototype.startAngleProperty, value);
			return value;
		} else {

			return this.getValue($.ig.PieChartBase.prototype.startAngleProperty);
		}
	}

	, 
	sweepDirection: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.PieChartBase.prototype.sweepDirectionProperty, $.ig.SweepDirection.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.PieChartBase.prototype.sweepDirectionProperty));
		}
	}

	, 
	selectedSlices: function (value) {
		if (arguments.length === 1) {

			this.__selectedSlices.collectionChanged = $.ig.Delegate.prototype.remove(this.__selectedSlices.collectionChanged, this.__selectedIndicesChangedOverride);
			this.__selectedAttached = false;
			this.__selectedSlices = value;
			if (this.__selectedSlices != null) {
				this.__selectedSlices.collectionChanged = $.ig.Delegate.prototype.combine(this.__selectedSlices.collectionChanged, this.__selectedIndicesChangedOverride);
				this.__selectedAttached = true;
			}

			if (this.allowSliceSelection()) {
				this.prepareSlices();
				this.prepareLabels();
				this.renderSlices();
				this.renderLabels();
				this.renderLegendItems();
			}

			return value;
		} else {

			return this.__selectedSlices;
		}
	}
	, 
	__selectedSlices: null

	, 
	othersCategoryStyle: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.PieChartBase.prototype.othersCategoryStyleProperty, value);
			return value;
		} else {

			return this.getValue($.ig.PieChartBase.prototype.othersCategoryStyleProperty);
		}
	}

	, 
	selectedStyle: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.PieChartBase.prototype.selectedStyleProperty, value);
			return value;
		} else {

			return this.getValue($.ig.PieChartBase.prototype.selectedStyleProperty);
		}
	}

	, 
	toolTipStyle: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.PieChartBase.prototype.toolTipStyleProperty, value);
			return value;
		} else {

			return this.getValue($.ig.PieChartBase.prototype.toolTipStyleProperty);
		}
	}

	, 
	brushes: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.PieChartBase.prototype.brushesProperty, value);
			return value;
		} else {

			return this.getValue($.ig.PieChartBase.prototype.brushesProperty);
		}
	}

	, 
	outlines: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.PieChartBase.prototype.outlinesProperty, value);
			return value;
		} else {

			return this.getValue($.ig.PieChartBase.prototype.outlinesProperty);
		}
	}

	, 
	legendItemTemplate: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.PieChartBase.prototype.legendItemTemplateProperty, value);
			return value;
		} else {

			return this.getValue($.ig.PieChartBase.prototype.legendItemTemplateProperty);
		}
	}

	, 
	legendItemBadgeTemplate: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.PieChartBase.prototype.legendItemBadgeTemplateProperty, value);
			return value;
		} else {

			return this.getValue($.ig.PieChartBase.prototype.legendItemBadgeTemplateProperty);
		}
	}

	, 
	labelTemplate: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.PieChartBase.prototype.labelTemplateProperty, value);
			return value;
		} else {

			return $.ig.util.cast($.ig.DataTemplate.prototype.$type, this.getValue($.ig.PieChartBase.prototype.labelTemplateProperty));
		}
	}

	, 
	isSurfaceInteractionDisabled: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.PieChartBase.prototype.isSurfaceInteractionDisabledProperty, value);
			return value;
		} else {

			return this.getValue($.ig.PieChartBase.prototype.isSurfaceInteractionDisabledProperty);
		}
	}

	, 
	formatLabel: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.PieChartBase.prototype.formatLabelProperty, value);
			return value;
		} else {

			return this.getValue($.ig.PieChartBase.prototype.formatLabelProperty);
		}
	}
	, 
	sliceClick: null
	, 
	onSliceClick: function (sender, e) {
		if (this.sliceClick != null) {
			this.sliceClick(sender, e);
		}

	}
	, 
	_slices: null
	, 
	_labels: null

	, 
	explodeSlice: function (slice, explode) {
		if (!this.explodedSlices().contains(slice.index()) && explode) {
			this.explodedSlices().add(slice.index());
		}

		if (this.explodedSlices().contains(slice.index()) && !explode) {
			this.explodedSlices().remove(slice.index());
		}

	}

	, 
	selectSlice: function (slice, shouldSelect) {
		if (!this.selectedSlices().contains(slice.index()) && shouldSelect) {
			this.selectedSlices().add(slice.index());
		}

		if (this.selectedSlices().contains(slice.index()) && !shouldSelect) {
			this.selectedSlices().remove(slice.index());
		}

	}

	, 
	setSliceAppearance: function (slice) {
		this.view().setSliceAppearance(slice);
	}

	, 
	getLabel: function (slice) {
		return this.view().getLabel(slice);
	}

	, 
	getSliceInnerBounds: function (slice, position) {
		var bounds = new $.ig.Rect(0, 0, 0, 0, 0);
		return bounds;
	}

	, 
	fitsInsideBounds: function (label, center) {
		var slice = label.slice();
		if (slice == null) {
		return false;
		}

		var origin = slice.getSliceOrigin();
		var startAngle = this.sweepDirection() == $.ig.SweepDirection.prototype.clockwise ? slice.startAngle() : slice.endAngle();
		var endAngle = this.sweepDirection() == $.ig.SweepDirection.prototype.clockwise ? slice.endAngle() : slice.startAngle();
		var useAngleOffset = false;
		var isCircle = false;
		var startPoint = $.ig.GeometryUtil.prototype.findRadialPoint(origin, startAngle, slice.radius());
		var endPoint = $.ig.GeometryUtil.prototype.findRadialPoint(origin, endAngle, slice.radius());
		startAngle = $.ig.PieChartBase.prototype.findAngle(startPoint.__x, origin.__x, startPoint.__y, origin.__y);
		endAngle = $.ig.PieChartBase.prototype.findAngle(endPoint.__x, origin.__x, endPoint.__y, origin.__y);
		if (this.isCircle(slice)) {
			isCircle = true;
		}

		var labelRadius;
		labelRadius = $.ig.MathUtil.prototype.hypot(label.bounds().right() - origin.__x, label.bounds().top() - origin.__y);
		if (labelRadius > slice.radius()) {
		return false;
		}

		labelRadius = $.ig.MathUtil.prototype.hypot(label.bounds().right() - origin.__x, label.bounds().bottom() - origin.__y);
		if (labelRadius > slice.radius()) {
		return false;
		}

		labelRadius = $.ig.MathUtil.prototype.hypot(label.bounds().left() - origin.__x, label.bounds().top() - origin.__y);
		if (labelRadius > slice.radius()) {
		return false;
		}

		labelRadius = $.ig.MathUtil.prototype.hypot(label.bounds().left() - origin.__x, label.bounds().bottom() - origin.__y);
		if (labelRadius > slice.radius()) {
		return false;
		}

		if (isCircle) {
		return true;
		}

		if (startAngle > endAngle) {
			startAngle = startAngle - 360;
			useAngleOffset = true;
		}

		var labelAngle;
		labelAngle = $.ig.PieChartBase.prototype.findAngle(label.bounds().right(), origin.__x, label.bounds().top(), origin.__y);
		if (useAngleOffset && labelAngle > 180 && labelAngle < 360) {
		labelAngle = labelAngle - 360;
		}

		if (labelAngle < startAngle || labelAngle > endAngle) {
		return false;
		}

		labelAngle = $.ig.PieChartBase.prototype.findAngle(label.bounds().right(), origin.__x, label.bounds().bottom(), origin.__y);
		if (useAngleOffset && labelAngle > 180 && labelAngle < 360) {
		labelAngle = labelAngle - 360;
		}

		if (labelAngle < startAngle || labelAngle > endAngle) {
		return false;
		}

		labelAngle = $.ig.PieChartBase.prototype.findAngle(label.bounds().left(), origin.__x, label.bounds().top(), origin.__y);
		if (useAngleOffset && labelAngle > 180 && labelAngle < 360) {
		labelAngle = labelAngle - 360;
		}

		if (labelAngle < startAngle || labelAngle > endAngle) {
		return false;
		}

		labelAngle = $.ig.PieChartBase.prototype.findAngle(label.bounds().left(), origin.__x, label.bounds().bottom(), origin.__y);
		if (useAngleOffset && labelAngle > 180 && labelAngle < 360) {
		labelAngle = labelAngle - 360;
		}

		if (labelAngle < startAngle || labelAngle > endAngle) {
		return false;
		}

		return true;
	}

	, 
	roundAngle: function (angle) {
		var val = Math.round(angle * Math.pow(10, 5)) / Math.pow(10, 5);
		return val;
	}

	, 
	isCircle: function (slice) {
		return $.ig.PieChartBase.prototype.roundAngle(Math.abs(slice.endAngle() - slice.startAngle())) == 360;
	}

	, 
	findAngle: function (x, centerX, y, centerY) {
		var h = $.ig.MathUtil.prototype.hypot(x - centerX, y - centerY);
		var angle = Math.asin((y - centerY) / h) * 180 / Math.PI;
		if (x < centerX) {
		angle = 180 - angle;
		}

		if (x > centerX) {
		angle = 360 + angle;
		}

		if (angle == 360) {
		angle = 0;
		}

		return $.ig.GeometryUtil.prototype.simplifyAngle(angle);
	}

	, 
	sortLabels: function (labels) {
		for (var i = 0; i < labels.count(); i++) {
			for (var j = i + 1; j < labels.count(); j++) {
				if (labels.__inner[i].bounds().top() > labels.__inner[j].bounds().top()) {
					var temp = labels.__inner[i];
					labels.__inner[i] = labels.__inner[j];
					labels.__inner[j] = temp;
				}

			}

		}

	}

	, 
	resolveCollisions: function (labels) {
		if (labels.count() == 0) {
		return;
		}

		var renderWidth = this.view().viewport().width();
		var renderHeight = this.view().viewport().height();
		var count = labels.count();
		var radius = labels.__inner[0].slice().radius();
		var center = labels.__inner[0].slice().getSliceOrigin();
		var hasEnoughSpace = true;
		var collisions = 0;
		var minHeight = Number.POSITIVE_INFINITY;
		var maxHeight = Number.NEGATIVE_INFINITY;
		for (var i = 0; i < count - 1; i++) {
			var currentLabel = labels.__inner[i];
			var nextLabel = labels.__inner[i + 1];
			if (currentLabel.bounds().intersectsWith(nextLabel.bounds())) {
				collisions++;
			}

		}

		var totalHeight = 0;
		var en = labels.getEnumerator();
		while (en.moveNext()) {
			var label = en.current();
			minHeight = Math.min(minHeight, label.bounds().height());
			maxHeight = Math.max(maxHeight, label.bounds().height());
			totalHeight += label.bounds().height();
		}

		if (totalHeight > renderHeight) {
			hasEnoughSpace = false;
		}

		if (hasEnoughSpace && collisions > 0) {
			for (var i1 = 0; i1 < count - 1; i1++) {
				for (var j = i1 + 1; j < count; j++) {
					var currentLabel1 = labels.__inner[i1];
					var nextLabel1 = labels.__inner[j];
					if (currentLabel1.bounds().intersectsWith(nextLabel1.bounds())) {
						var bounds = nextLabel1.bounds();
						bounds.y(Math.min(currentLabel1.bounds().bottom() + 0.01, renderHeight - minHeight));
						var c = this.labelExtent() + radius;
						var b = Math.abs(center.__y - (bounds.y() + minHeight / 2));
						var x = Math.sqrt(Math.abs(c * c - b * b));
						var angle = $.ig.GeometryUtil.prototype.simplifyAngle(nextLabel1.angle());
						if (angle > 90 && angle < 270) {
							x = (bounds.width() + x) * -1;
						}

						bounds.x(center.__x + x);
						nextLabel1.bounds(bounds);
					}

				}

			}

			for (var i2 = count - 1; i2 > 0; i2--) {
				for (var j1 = i2 - 1; j1 >= 0; j1--) {
					var currentLabel2 = labels.__inner[i2];
					var nextLabel2 = labels.__inner[j1];
					if (currentLabel2.bounds().intersectsWith(nextLabel2.bounds())) {
						var bounds1 = nextLabel2.bounds();
						bounds1.y(Math.max(currentLabel2.bounds().top() - minHeight - 0.01, 0));
						var c1 = this.labelExtent() + radius;
						var b1 = Math.abs(center.__y - (bounds1.y() + minHeight / 2));
						var x1 = Math.sqrt(Math.abs(c1 * c1 - b1 * b1));
						var angle1 = $.ig.GeometryUtil.prototype.simplifyAngle(nextLabel2.angle());
						if (angle1 > 90 && angle1 < 270) {
							x1 = (bounds1.width() + x1) * -1;
						}

						bounds1.x(center.__x + x1);
						nextLabel2.bounds(bounds1);
					}

				}

			}

		}

		var en1 = labels.getEnumerator();
		while (en1.moveNext()) {
			var label1 = en1.current();
			var bounds2 = label1.bounds();
			if (bounds2.left() > renderWidth || bounds2.right() < 0) {
				label1.__visibility = $.ig.Visibility.prototype.collapsed;
				if (this.leaderLineType() == $.ig.LeaderLineType.prototype.straight) {
					label1.leaderLine().__visibility = $.ig.Visibility.prototype.collapsed;

				} else {
					label1.leaderLinePath().__visibility = $.ig.Visibility.prototype.collapsed;
				}


			} else if (bounds2.left() < 0) {
				var offset = Math.abs(bounds2.x());
				bounds2.x(0);
				if (offset > bounds2.width()) {
					bounds2.width(0);

				} else {
				}

				label1.bounds(bounds2);

			} else if (bounds2.right() > renderWidth) {
				var offset1 = bounds2.right() - renderWidth;
				if (offset1 > bounds2.width()) {
					bounds2.width(0);

				} else {
					bounds2.width(bounds2.width() - offset1);
				}

				label1.bounds(bounds2);
			}



		}

	}

	, 
	dataUpdatedOverride: function (action, position, count, propertyName) {
		this.renderChart();
	}

	, 
	renderChart: function () {
		this.prepareData();
		this.prepareSlices();
		this.prepareLabels();
		this.renderSlices();
		this.renderLabels();
		this.renderLegendItems();
		this.view().updateView();
	}

	, 
	prepareData: function () {
		this.total(0);
		this.othersTotal(0);
		this.valueIndices().clear();
		this.othersValueIndices().clear();
		this.others().clear();
		if (this.itemsSource() == null || this.fastItemsSource() == null) {
			return;
		}

		if (this.valueColumn() == null || this.valueColumn().count() == 0) {
			return;
		}

		var en = this.valueColumn().getEnumerator();
		while (en.moveNext()) {
			var value = en.current();
			if ($.ig.util.isNaN(value) || Number.isInfinity(value) || value <= 0) {
				continue;
			}

			this.total(this.total() + value);
		}

		for (var i = 0; i < this.valueColumn().count(); i++) {
			var value1 = this.valueColumn().item(i);
			if ($.ig.util.isNaN(value1) || Number.isInfinity(value1) || value1 <= 0) {
			continue;
			}

			var calculatedValue = this.othersCategoryType() == $.ig.OthersCategoryType.prototype.percent ? value1 / this.total() : value1;
			var calculatedThreshold = this.othersCategoryType() == $.ig.OthersCategoryType.prototype.percent ? this.othersCategoryThreshold() / 100 : this.othersCategoryThreshold();
			if (calculatedValue <= calculatedThreshold) {
				this.othersTotal(this.othersTotal() + value1);
				this.othersValueIndices().add(i);
				this.others().add1(this.fastItemsSource().item(i));

			} else {
				this.valueIndices().add(i);
			}

		}

	}

	, 
	prepareSlices: function () {
		if (this.itemsSource() == null || this.fastItemsSource() == null) {
			this._slices.count(0);
			return;
		}

		var totalSliceCount = this.valueIndices().count();
		var hasOtherSlice = this.othersValueIndices().count() > 0;
		var startAngle = $.ig.PieChartBase.prototype.roundAngle(this.actualStartAngle());
		var endAngle = $.ig.PieChartBase.prototype.roundAngle(this.actualStartAngle());
		if (hasOtherSlice) {
			totalSliceCount++;
		}

		for (var i = 0; i < totalSliceCount; i++) {
			var isOtherSlice = false;
			var value;
			if (i == totalSliceCount - 1 && hasOtherSlice) {
				value = this.othersTotal();
				isOtherSlice = true;

			} else {
				value = this.valueColumn().item(this.valueIndices().__inner[i]);
			}

			if (this.sweepDirection() == $.ig.SweepDirection.prototype.clockwise) {
				endAngle += $.ig.PieChartBase.prototype.roundAngle(Math.abs(value) * 360 / this.total());

			} else {
				endAngle -= $.ig.PieChartBase.prototype.roundAngle(Math.abs(value) * 360 / this.total());
			}

			var slice = this._slices.item(i);
			slice.suspendCreation(true);
			slice.startAngle(startAngle);
			slice.endAngle(endAngle);
			slice.innerExtentStart(slice.innerExtentEnd(this.chartInnerExtent()));
			slice.isOthersSlice(isOtherSlice);
			slice.explodedRadius(this.actualExplodedRadius());
			slice.index(i);
			slice.dataContext(isOtherSlice ? this.others() : this.fastItemsSource().item(this.valueIndices().__inner[i]));
			slice.isExploded(this.explodedSlices().contains(i));
			slice.isSelected(this.selectedSlices().contains(i));
			startAngle = endAngle;
			slice.suspendCreation(false);
		}

		this._slices.count(totalSliceCount);
	}

	, 
	prepareLabels: function () {
		var $self = this;
		if ($self.itemsSource() == null || $self.fastItemsSource() == null) {
			$self._labels.count(0);
			return;
		}

		if ($self.labelColumn() == null || $self.labelColumn().count() == 0 || $self.labelsPosition() == $.ig.LabelsPosition.prototype.none) {
			$self._labels.count(0);
			return;
		}

		var totalLabelCount = $self.valueIndices().count();
		if ($self.othersValueIndices().count() > 0) {
			totalLabelCount++;
		}

		$self.view().labelPreMeasure();
		for (var i = 0; i < totalLabelCount; i++) {
			var labelString = String.empty();
			var isOthersLabel = false;
			var labelFromLabelColumn;
			if (i == totalLabelCount - 1 && $self.othersValueIndices().count() > 0) {
				labelFromLabelColumn = $self.othersCategoryText();
				isOthersLabel = true;
				if ($self.formatLabel() != null) {
					var context = (function () { var $ret = new $.ig.PieSliceDataContext();
					$ret.series($self);
					$ret.item(isOthersLabel ? $self.others() : $self.fastItemsSource().item($self.valueIndices().__inner[i]));
					$ret.itemLabel(labelFromLabelColumn);
					$ret.percentValue($self.getPercentValue($self._slices.item(i)));
					$ret.isOthersSlice(isOthersLabel); return $ret;}());
					var c = context;
					c = (c).flatten();
					labelFromLabelColumn = $self.formatLabel()(c);
				}

				if (null != labelFromLabelColumn) {
					labelString = labelFromLabelColumn.toString();
				}


			} else {
				labelFromLabelColumn = $self.labelColumn().item($self.valueIndices().__inner[i]);
				if ($self.formatLabel() != null) {
					var context1 = (function () { var $ret = new $.ig.PieSliceDataContext();
					$ret.series($self);
					$ret.item(isOthersLabel ? $self.others() : $self.fastItemsSource().item($self.valueIndices().__inner[i]));
					$ret.itemLabel(labelFromLabelColumn);
					$ret.percentValue($self.getPercentValue($self._slices.item(i)));
					$ret.isOthersSlice(isOthersLabel); return $ret;}());
					var c1 = context1;
					c1 = (c1).flatten();
					var formatedLabel_ = $self.formatLabel()(c1);
					if (null == formatedLabel_) {
						labelFromLabelColumn = $self.labelColumn().item($self.valueIndices().__inner[i]);

					} else {
						labelFromLabelColumn = formatedLabel_;
					}

				}

				var label_ = labelFromLabelColumn;
				if(label_ === undefined) { throw new Error($.ig.Chart.locale.invalidLabelBinding); };
				if (null != labelFromLabelColumn) {
					labelString = labelFromLabelColumn.toString();
				}

			}

			var label = $self._labels.item(i);
			var slice = $self._slices.item(i);
			slice.label(label);
			label.angle($.ig.GeometryUtil.prototype.simplifyAngle((slice.startAngle() + slice.endAngle()) / 2));
			label.slice(slice);
			label.label((function () { var $ret = new $.ig.TextBlock();
			$ret.text(labelString); return $ret;}()));
			if ($self.labelTemplate() == null) {
				label.dataContext(isOthersLabel ? $self.others() : $self.fastItemsSource().item($self.valueIndices().__inner[i]));
				label.createContent($self.view());

			} else {
			}

			label.__visibility = $.ig.Visibility.prototype.visible;
			label.bounds($self.view().getLabelBounds(label));
		}

		$self._labels.count(totalLabelCount);
	}

	, 
	_viewport: null,
	viewport: function (value) {
		if (arguments.length === 1) {
			this._viewport = value;
			return value;
		} else {
			return this._viewport;
		}
	}

	, 
	renderSlices: function () {
		if (this.itemsSource() == null || this.fastItemsSource() == null) {
			return;
		}

		var pieCanvasSize = this.view().updatePieViewport();
		this.viewport(new $.ig.Rect(0, 0, 0, pieCanvasSize.width(), pieCanvasSize.height()));
		var center = {__x: pieCanvasSize.width() / 2, __y: pieCanvasSize.height() / 2, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		var radius = Math.min(pieCanvasSize.height() / 2, pieCanvasSize.width() / 2) * this.actualRadiusFactor();
		var en = this._slices.active().getEnumerator();
		while (en.moveNext()) {
			var slice = en.current();
			var explodedCenter = $.ig.GeometryUtil.prototype.findCenter(pieCanvasSize.width(), pieCanvasSize.height(), true, (slice.startAngle() + slice.endAngle()) / 2, radius * this.actualExplodedRadius());
			slice.suspendCreation(true);
			slice.innerExtentStart(slice.innerExtentEnd(this.chartInnerExtent()));
			slice.radius(radius);
			slice.explodedRadius(this.actualExplodedRadius());
			slice.origin(center);
			slice.explodedOrigin(explodedCenter);
			this.setSliceAppearance(slice);
			slice.suspendCreation(false);
		}

		this.view().updateView();
	}

	, 
	renderLabels: function () {
		var renderWidth = this.view().viewport().width();
		var renderHeight = this.view().viewport().height();
		if (renderHeight == 0 || renderWidth == 0) {
			return;
		}

		if (this._labels.active().count() == 0 || this.labelsPosition() == $.ig.LabelsPosition.prototype.none) {
			this._labels.count(0);
			return;
		}

		var rightLabels = new $.ig.List$1($.ig.PieLabel.prototype.$type, 0);
		var leftLabels = new $.ig.List$1($.ig.PieLabel.prototype.$type, 0);
		var centerLabels = new $.ig.List$1($.ig.PieLabel.prototype.$type, 0);
		var insideEndLabels = new $.ig.List$1($.ig.PieLabel.prototype.$type, 0);
		var en = this._labels.active().getEnumerator();
		while (en.moveNext()) {
			var label = en.current();
			var slice = label.slice();
			if (slice == null) {
			continue;
			}

			var center = slice.getSliceOrigin();
			var width = label.bounds().width();
			var height = label.bounds().height();
			if (this.labelsPosition() == $.ig.LabelsPosition.prototype.center || this.labelsPosition() == $.ig.LabelsPosition.prototype.bestFit) {
				var innerRadius = slice.radius() * slice.innerExtentStart() / 100;
				var labelCenter = $.ig.GeometryUtil.prototype.findRadialPoint(center, label.angle(), slice.radius() - (slice.radius() - innerRadius) / 2);
				label.bounds(new $.ig.Rect(0, labelCenter.__x - width / 2, labelCenter.__y - height / 2, width, height));
				var fitsInCenter = this.fitsInsideBounds(label, labelCenter);
				if (fitsInCenter || this.labelsPosition() == $.ig.LabelsPosition.prototype.center) {
					centerLabels.add(label);
					if (label.slice().owner().leaderLineType() == $.ig.LeaderLineType.prototype.straight) {
						label.leaderLine().__visibility = $.ig.Visibility.prototype.collapsed;

					} else {
						label.leaderLinePath().__visibility = $.ig.Visibility.prototype.collapsed;
					}

					if (!fitsInCenter && this.labelsPosition() == $.ig.LabelsPosition.prototype.center) {
						label.__visibility = $.ig.Visibility.prototype.collapsed;

					} else {
						label.__visibility = $.ig.Visibility.prototype.visible;
					}

					continue;
				}

			}

			if (this.labelsPosition() == $.ig.LabelsPosition.prototype.insideEnd || this.labelsPosition() == $.ig.LabelsPosition.prototype.bestFit) {
				var labelOffset = $.ig.PieChartBase.prototype.findLabelOffset(center, slice.radius(), label);
				var labelCenter1 = $.ig.GeometryUtil.prototype.findRadialPoint(center, label.angle(), labelOffset);
				label.bounds(new $.ig.Rect(0, labelCenter1.__x - width / 2, labelCenter1.__y - height / 2, width, height));
				var fitsOnInside = this.fitsInsideBounds(label, labelCenter1);
				if (fitsOnInside || this.labelsPosition() == $.ig.LabelsPosition.prototype.insideEnd) {
					insideEndLabels.add(label);
					if (label.slice().owner().leaderLineType() == $.ig.LeaderLineType.prototype.straight) {
						label.leaderLine().__visibility = $.ig.Visibility.prototype.collapsed;

					} else {
						label.leaderLinePath().__visibility = $.ig.Visibility.prototype.collapsed;
					}

					if (!fitsOnInside && this.labelsPosition() == $.ig.LabelsPosition.prototype.insideEnd) {
						label.__visibility = $.ig.Visibility.prototype.collapsed;

					} else {
						label.__visibility = $.ig.Visibility.prototype.visible;
					}

					continue;
				}

			}

			var labelPoint = $.ig.GeometryUtil.prototype.findRadialPoint(center, label.angle(), slice.radius() + this.labelExtent());
			label.__visibility = $.ig.Visibility.prototype.visible;
			label.updateCascadingLeaderLineStroke();
			if (label.angle() < 90 && label.angle() >= 0) {
				label.bounds(new $.ig.Rect(0, labelPoint.__x, labelPoint.__y, width, height));
				rightLabels.add(label);

			} else if (label.angle() < 180 && label.angle() >= 90) {
				label.bounds(new $.ig.Rect(0, labelPoint.__x - width, labelPoint.__y, width, height));
				leftLabels.add(label);

			} else if (label.angle() < 270 && label.angle() >= 180) {
				label.bounds(new $.ig.Rect(0, labelPoint.__x - width, labelPoint.__y - height, width, height));
				leftLabels.add(label);

			} else {
				label.bounds(new $.ig.Rect(0, labelPoint.__x, labelPoint.__y - height, width, height));
				rightLabels.add(label);
			}



			if (label.bounds().y() < 0) {
				label.bounds(new $.ig.Rect(0, label.bounds().x(), 0, label.bounds().width(), label.bounds().height()));
			}

			if (label.bounds().bottom() > renderHeight) {
				label.bounds(new $.ig.Rect(0, label.bounds().x(), renderHeight - label.bounds().height(), label.bounds().width(), label.bounds().height()));
			}

		}

		$.ig.PieChartBase.prototype.sortLabels(rightLabels);
		this.resolveCollisions(rightLabels);
		$.ig.PieChartBase.prototype.sortLabels(leftLabels);
		this.resolveCollisions(leftLabels);
		var en1 = centerLabels.getEnumerator();
		while (en1.moveNext()) {
			var label1 = en1.current();
			this.view().updateLabelPosition(label1, label1.bounds().x(), label1.bounds().y());
		}

		var en2 = insideEndLabels.getEnumerator();
		while (en2.moveNext()) {
			var label2 = en2.current();
			this.view().updateLabelPosition(label2, label2.bounds().x(), label2.bounds().y());
		}

		var en3 = rightLabels.getEnumerator();
		while (en3.moveNext()) {
			var label3 = en3.current();
			this.view().updateLabelPosition(label3, label3.bounds().x(), label3.bounds().y());
			if (label3.slice().owner().leaderLineType() == $.ig.LeaderLineType.prototype.straight) {
				label3.updateLeaderLine();

			} else {
				label3.updateLeaderLinePath();
			}

		}

		var en4 = leftLabels.getEnumerator();
		while (en4.moveNext()) {
			var label4 = en4.current();
			this.view().updateLabelPosition(label4, label4.bounds().x(), label4.bounds().y());
			if (label4.slice().owner().leaderLineType() == $.ig.LeaderLineType.prototype.straight) {
				label4.updateLeaderLine();

			} else {
				label4.updateLeaderLinePath();
			}

		}

		this.view().updateView();
	}

	, 
	findLabelOffset: function (center, radius, label) {
		var labelAngleRadians = label.angle() * Math.PI / 180;
		var testRadius = 1;
		var rectCenter = $.ig.GeometryUtil.prototype.findRadialPoint({__x: 0, __y: 0, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}, label.angle(), testRadius);
		var collisionPoint = $.ig.PieChartBase.prototype.getCollisionPoint(label);
		var dist = Math.sqrt(collisionPoint.__x * collisionPoint.__x + collisionPoint.__y * collisionPoint.__y);
		var collisionVect = {__x: collisionPoint.__x / dist, __y: collisionPoint.__y / dist, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		var angle = $.ig.PieChartBase.prototype.getAngleBetween(rectCenter, collisionVect);
		var p = dist / radius;
		var angleAtEnd = angle * p;
		var deltaAngle = angleAtEnd;
		var centAng = $.ig.GeometryUtil.prototype.getAngleTo({__x: 0, __y: 0, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}, rectCenter);
		var collAng = $.ig.GeometryUtil.prototype.getAngleTo({__x: 0, __y: 0, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}, collisionVect);
		if (collAng < centAng) {
			deltaAngle = -deltaAngle;
		}

		var collisionPointAtEnd = $.ig.GeometryUtil.prototype.findRadialPoint(center, (labelAngleRadians + deltaAngle) * 180 / Math.PI, radius);
		var centerAtEnd = $.ig.PieChartBase.prototype.getCenterFromCollisionPoint(label, collisionPointAtEnd);
		var distToCenter = Math.sqrt((centerAtEnd.__x - center.__x) * (centerAtEnd.__x - center.__x) + (centerAtEnd.__y - center.__y) * (centerAtEnd.__y - center.__y));
		var labelOffset = distToCenter - 5;
		return labelOffset;
	}

	, 
	getCenterFromCollisionPoint: function (label, collisionPointAtEnd) {
		var angle = $.ig.GeometryUtil.prototype.simplifyAngle(label.angle());
		var halfWidth = label.bounds().width() / 2;
		var halfHeight = label.bounds().height() / 2;
		if (angle >= 0 && angle <= 90) {
			return {__x: collisionPointAtEnd.__x - halfWidth, __y: collisionPointAtEnd.__y - halfHeight, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		}

		if (angle >= 90 && angle <= 180) {
			return {__x: collisionPointAtEnd.__x + halfWidth, __y: collisionPointAtEnd.__y - halfHeight, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		}

		if (angle >= 180 && angle <= 270) {
			return {__x: collisionPointAtEnd.__x + halfWidth, __y: collisionPointAtEnd.__y + halfHeight, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		}

		return {__x: collisionPointAtEnd.__x - halfWidth, __y: collisionPointAtEnd.__y + halfHeight, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
	}

	, 
	getAngleBetween: function (rectCenter, collisionVect) {
		var prod = rectCenter.__x * collisionVect.__x + rectCenter.__y * collisionVect.__y;
		var magCenter = Math.sqrt(rectCenter.__x * rectCenter.__x + rectCenter.__y * rectCenter.__y);
		var magColl = Math.sqrt(collisionVect.__x * collisionVect.__x + collisionVect.__y * collisionVect.__y);
		var ang = Math.acos(prod / (magCenter * magColl));
		return ang;
	}

	, 
	getCollisionPoint: function (label) {
		var angle = $.ig.GeometryUtil.prototype.simplifyAngle(label.angle());
		var halfWidth = label.bounds().width() / 2;
		var halfHeight = label.bounds().height() / 2;
		if (angle >= 0 && angle <= 90) {
			return {__x: halfWidth, __y: halfHeight, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		}

		if (angle >= 90 && angle <= 180) {
			return {__x: -halfWidth, __y: halfHeight, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		}

		if (angle >= 180 && angle <= 270) {
			return {__x: -halfWidth, __y: -halfHeight, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		}

		return {__x: halfWidth, __y: -halfHeight, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
	}

	, 
	renderLegendItems: function () {
		var $self = this;
		var itemLegend = $.ig.util.cast($.ig.ItemLegend.prototype.$type, $self.legend());
		if (itemLegend == null) {
		return;
		}

		if ($self.labelColumn() == null || $self.labelColumn().count() == 0) {
			itemLegend.clearLegendItems($self);
			return;
		}

		$self.legendItems(new $.ig.List$1($.ig.UIElement.prototype.$type, 0));
		var en = $self._slices.active().getEnumerator();
		while (en.moveNext()) {
			var slice = en.current();
			var item = new $.ig.ContentControl();
			var itemLabel = $self.getLabel(slice);
			var itemBrush = slice.background();
			item.content((function () { var $ret = new $.ig.PieSliceDataContext();
			$ret.series($self);
			$ret.slice(slice);
			$ret.item(slice.dataContext());
			$ret.itemBrush(itemBrush);
			$ret.itemLabel(itemLabel != null ? itemLabel.toString() : null);
			$ret.percentValue($self.getPercentValue(slice));
			$ret.isOthersSlice(slice.isOthersSlice()); return $ret;}()));
			if ($self.legendItemTemplate() != null) {
				item.contentTemplate($self.legendItemTemplate());
			}

			$self.legendItems().add(item);
		}

		itemLegend.createLegendItems($self.legendItems(), $self);
	}

	, 
	exportVisualData: function () {
		var chart = new $.ig.PieChartVisualData();
		chart.viewport(this.viewport());
		this.view().exportViewData(chart);
		for (var i = 0; i < this._slices.count(); i++) {
			var slice = this._slices.item(i).exportVisualData();
			chart.slices().add(slice);
			if (this._slices.item(i).isOthersSlice()) {
			chart.othersSlice(this._slices.item(i).exportVisualData());
			}

		}

		chart.others(this.others());
		chart.name(this.name());
		return chart;
	}

	, 
	registerDoubleColumn: function (memberPath) {
		var coercionMethod = null;
		return this.fastItemsSource().registerColumn(memberPath, coercionMethod, false);
	}

	, 
	registerObjectColumn: function (memberPath) {
		var coercionMethod = null;
		return this.fastItemsSource().registerColumnObject(memberPath, coercionMethod, false);
	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		var $self = this;
		switch (propertyName) {
			case $.ig.PieChartBase.prototype.itemsSourcePropertyName:
				$self.fastItemsSource((function () { var $ret = new $.ig.FastItemsSource();
				$ret.itemsSource(newValue); return $ret;}()));
				break;
			case $.ig.PieChartBase.prototype.fastItemsSourcePropertyName:
				if ($.ig.util.cast($.ig.FastItemsSource.prototype.$type, oldValue) != null) {
					($.ig.util.cast($.ig.FastItemsSource.prototype.$type, oldValue)).event = $.ig.Delegate.prototype.remove(($.ig.util.cast($.ig.FastItemsSource.prototype.$type, oldValue)).event, $self._fastItemsSource_Event);
					$self.__fastItemsSourceAttached = false;
					($.ig.util.cast($.ig.FastItemsSource.prototype.$type, oldValue)).deregisterColumn($self.valueColumn());
					($.ig.util.cast($.ig.FastItemsSource.prototype.$type, oldValue)).deregisterColumn($self.labelColumn());
					$self.valueColumn(null);
					$self.labelColumn(null);
				}

				if ($.ig.util.cast($.ig.FastItemsSource.prototype.$type, newValue) != null) {
					($.ig.util.cast($.ig.FastItemsSource.prototype.$type, newValue)).event = $.ig.Delegate.prototype.combine(($.ig.util.cast($.ig.FastItemsSource.prototype.$type, newValue)).event, $self._fastItemsSource_Event);
					$self.__fastItemsSourceAttached = true;
					$self.valueColumn($self.registerDoubleColumn($self.valueMemberPath()));
					$self.labelColumn($self.registerObjectColumn($self.labelMemberPath()));
				}

				$self.renderChart();
				break;
			case $.ig.PieChartBase.prototype.valueMemberPathPropertyName:
				if ($self.fastItemsSource() != null) {
					$self.fastItemsSource().deregisterColumn($self.valueColumn());
					$self.valueColumn($self.registerDoubleColumn($self.valueMemberPath()));
				}

				break;
			case $.ig.PieChartBase.prototype.formatLabelPropertyName:
			case $.ig.PieChartBase.prototype.labelMemberPathPropertyName:
				if ($self.fastItemsSource() != null) {
					$self.fastItemsSource().deregisterColumn($self.labelColumn());
					$self.labelColumn($self.registerObjectColumn($self.labelMemberPath()));
					$self.prepareLabels();
					$self.renderLabels();
					$self.renderLegendItems();
				}

				break;
			case $.ig.PieChartBase.prototype.startAnglePropertyName:
				$self.actualStartAngle(newValue);
				$self.prepareSlices();
				$self.prepareLabels();
				$self.renderSlices();
				$self.renderLabels();
				break;
			case $.ig.PieChartBase.prototype.toolTipPropertyName:
				$self.view().updateToolTipContent($self.toolTip());
				break;
			case $.ig.PieChartBase.prototype.legendPropertyName:
				var oldLegend = $.ig.util.cast($.ig.ItemLegend.prototype.$type, oldValue);
				if (oldLegend != null) {
					oldLegend.clearLegendItems($self);
				}

				$self.renderLegendItems();
				break;
			case $.ig.PieChartBase.prototype.legendItemBadgeTemplatePropertyName:
			case $.ig.PieChartBase.prototype.legendItemTemplatePropertyName:
				$self.renderLegendItems();
				break;
			case $.ig.PieChartBase.prototype.radiusFactorPropertyName:
			case $.ig.PieChartBase.prototype.explodedRadiusPropertyName:
			case $.ig.PieChartBase.prototype.sweepDirectionPropertyName:
				$self.prepareSlices();
				$self.prepareLabels();
				$self.renderSlices();
				$self.renderLabels();
				break;
			case $.ig.PieChartBase.prototype.othersCategoryStylePropertyName:
			case $.ig.PieChartBase.prototype.selectedStylePropertyName:
				$self.renderSlices();
				$self.renderLegendItems();
				break;
			case $.ig.PieChartBase.prototype.brushesPropertyName:
				if (oldValue != null) {
					var ov = oldValue;
					ov.collectionChanged = $.ig.Delegate.prototype.remove(ov.collectionChanged, $self.__brushesChangedOverride);
					$self.__brushesAttached = false;
				}

				if (newValue != null) {
					var bc = newValue;
					bc.collectionChanged = $.ig.Delegate.prototype.combine(bc.collectionChanged, $self.__brushesChangedOverride);
					$self.__brushesAttached = true;
				}

				$self.renderSlices();
				$self.renderLegendItems();
				break;
			case $.ig.PieChartBase.prototype.outlinesPropertyName:
				if (oldValue != null) {
					var ov1 = oldValue;
					ov1.collectionChanged = $.ig.Delegate.prototype.remove(ov1.collectionChanged, $self.__brushesChangedOverride);
					$self.__outlinesAttached = false;
				}

				if (newValue != null) {
					var bc1 = newValue;
					bc1.collectionChanged = $.ig.Delegate.prototype.combine(bc1.collectionChanged, $self.__brushesChangedOverride);
					$self.__outlinesAttached = true;
				}

				$self.renderSlices();
				$self.renderLegendItems();
				break;
			case $.ig.PieChartBase.prototype.valueColumnPropertyName:
			case $.ig.PieChartBase.prototype.othersCategoryThresholdPropertyName:
			case $.ig.PieChartBase.prototype.othersCategoryTypePropertyName:
			case $.ig.PieChartBase.prototype.allowSliceExplosionPropertyName:
			case $.ig.PieChartBase.prototype.allowSliceSelectionPropertyName:
				$self.renderChart();
				break;
			case $.ig.PieChartBase.prototype.labelsPositionPropertyName:
				$self.prepareLabels();
				$self.renderLabels();
				$self.view().updateView();
				break;
			case $.ig.PieChartBase.prototype.labelExtentPropertyName:
				$self.prepareLabels();
				$self.renderLabels();
				break;
			case $.ig.PieChartBase.prototype.othersCategoryTextPropertyName:
				$self.prepareLabels();
				$self.renderLabels();
				$self.renderLegendItems();
				break;
			case $.ig.PieChartBase.prototype.leaderLineVisibilityPropertyName:
				$self.renderLabels();
				break;
			case $.ig.PieChartBase.prototype.leaderLineStylePropertyName:
				$self.renderLabels();
				break;
			case $.ig.PieChartBase.prototype.textStylePropertyName:
				$self.view().styleUpdated();
				break;
			case $.ig.PieChartBase.prototype._labelTemplatePropertyName:
				$self.prepareLabels();
				$self.renderLabels();
				break;
			case $.ig.PieChartBase.prototype.leaderLineTypePropertyName:
			case $.ig.PieChartBase.prototype.leaderLineMarginPropertyName:
				$self._labels.doToAll($self.view().updateLabelLeaderLine.runOn($self.view()));
				$self.renderLabels();
				break;
			case $.ig.PieChartBase.prototype.isSurfaceInteractionDisabledPropertyName:
				$self.view().onIsSurfaceInteractionDisabledChanged();
				break;
			case $.ig.PieChartBase.prototype.innerExtentPropertyName:
				$self.renderChart();
				break;
		}

	}

	, 
	selectedIndicesChangedOverride: function (args) {
		if (this.allowSliceSelection()) {
			this.prepareSlices();
			this.renderSlices();
			this.renderLegendItems();
		}

	}
	, 
	propertyChanged: null, 
	propertyUpdated: null
	, 
	raisePropertyChanged: function (name, oldValue, newValue) {
		if (this.propertyChanged != null) {
			this.propertyChanged(this, new $.ig.PropertyChangedEventArgs(name));
		}

		if (this.propertyUpdated != null) {
			this.propertyUpdated(this, new $.ig.PropertyUpdatedEventArgs(name, oldValue, newValue));
		}

	}

	, 
	sliceClicked: function (slice, args) {
		var sliceClickEventArgs = new $.ig.SliceClickEventArgs(slice);
		this.onSliceClick(this, sliceClickEventArgs);
		this.view().updateToolTip(slice, args);
	}

	, 
	itemEntered: function (item, args) {
		this.view().updateToolTip(item, args);
	}

	, 
	itemMouseMoved: function (item, args) {
		this.view().updateToolTip(item, args);
	}

	, 
	itemMouseLeft: function (o, e) {
		this.view().closeToolTip();
	}

	, 
	onSizeUpdated: function () {
		this.renderChart();
	}

	, 
	provideContainer: function (container) {
		this.view().onContainerProvided(container);
	}

	, 
	onContainerResized: function (width, height) {
		this.view().onContainerResized(width, height);
	}

	, 
	notifyContainerResized: function () {
		this.view().notifyContainerResized();
	}

	, 
	getContainerRect: function () {
		return this.view().getContainerRect();
	}

	, 
	getContainerOffsets: function () {
		return this.view().getContainerOffsets();
	}

	, 
	destroy: function () {
		this.removeWidgetLevelDataSource();
		this.view().onContainerProvided(null);
	}

	, 
	flush: function () {
		this.view().flush();
	}
	, 
	__textStyle: null

	, 
	textStyle: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__textStyle;
			this.__textStyle = value;
			this.raisePropertyChanged($.ig.PieChartBase.prototype.textStylePropertyName, oldValue, value);
			return value;
		} else {

			return this.__textStyle;
		}
	}

	, 
	getPercentValue: function (slice) {
		if (slice == null || this.valueColumn() == null || this.valueIndices() == null) {
			return NaN;
		}

		if (slice.isOthersSlice()) {
			return this.othersTotal() / this.total() * 100;

		} else {
			return this.valueColumn().item(this.valueIndices().__inner[slice.index()]) / this.total() * 100;
		}

	}

	, 
	notifySetItem: function (source_, index, oldItem, newItem) {
		if (source_.dataView && source_.dataSource) { source_ = source_.dataView() };
		if (source_ != this.itemsSource()) {
			return;
		}

		var itemsSource = this.fastItemsSource();
		if (itemsSource == null) {
			return;
		}

		itemsSource.handleCollectionChanged(new $.ig.NotifyCollectionChangedEventArgs(2, $.ig.NotifyCollectionChangedAction.prototype.replace, newItem, oldItem, index));
	}

	, 
	notifyClearItems: function (source_) {
		if (source_.dataView && source_.dataSource) { source_ = source_.dataView() };
		if (source_ != this.itemsSource()) {
			return;
		}

		var itemsSource = this.fastItemsSource();
		itemsSource.handleCollectionChanged(new $.ig.NotifyCollectionChangedEventArgs(0, $.ig.NotifyCollectionChangedAction.prototype.reset));
	}

	, 
	notifyInsertItem: function (source_, index, newItem) {
		if (source_.dataView && source_.dataSource) { source_ = source_.dataView() };
		if (source_ != this.itemsSource()) {
			return;
		}

		var itemsSource = this.fastItemsSource();
		if (itemsSource == null) {
			return;
		}

		itemsSource.handleCollectionChanged(new $.ig.NotifyCollectionChangedEventArgs(1, $.ig.NotifyCollectionChangedAction.prototype.add, newItem, index));
	}

	, 
	notifyRemoveItem: function (source_, index, oldItem) {
		if (source_.dataView && source_.dataSource) { source_ = source_.dataView() };
		if (source_ != this.itemsSource()) {
			return;
		}

		var itemsSource = this.fastItemsSource();
		if (itemsSource == null) {
			return;
		}

		itemsSource.handleCollectionChanged(new $.ig.NotifyCollectionChangedEventArgs(1, $.ig.NotifyCollectionChangedAction.prototype.remove, oldItem, index));
	}

	, 
	setWidgetLevelDataSource: function (source_) {
		if (source_.dataView && source_.dataSource) { source_ = source_.dataView() };
		this.itemsSource(source_);
	}

	, 
	removeWidgetLevelDataSource: function () {
		this.itemsSource(null);
	}

	, 
	styleUpdated: function () {
		this.view().styleUpdated();
	}
	, 
	$type: new $.ig.Type('PieChartBase', $.ig.Control.prototype.$type, [$.ig.INotifyPropertyChanged.prototype.$type])
}, true);

$.ig.util.defType('Arc', 'PieChartBase', {

	createView: function () {
		return new $.ig.ArcView(this);
	}

	, 
	onViewCreated: function (view) {
		$.ig.PieChartBase.prototype.onViewCreated.call(this, view);
		this.arcView(view);
	}

	, 
	_arcView: null,
	arcView: function (value) {
		if (arguments.length === 1) {
			this._arcView = value;
			return value;
		} else {
			return this._arcView;
		}
	}
	, 
	init: function () {


		this.__ring = null;

		$.ig.PieChartBase.prototype.init.call(this);
			this.defaultStyleKey($.ig.Arc.prototype.$type);
	}
	, 
	__ring: null

	, 
	ring: function (value) {
		if (arguments.length === 1) {

			var oldRing = this.__ring;
			this.__ring = value;
			this.arcView().onRingChanged(oldRing, this.__ring);
			return value;
		} else {

			return this.__ring;
		}
	}

	, 
	_arcItem: null,
	arcItem: function (value) {
		if (arguments.length === 1) {
			this._arcItem = value;
			return value;
		} else {
			return this._arcItem;
		}
	}

	, 
	endAngle: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Arc.prototype.endAngleProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Arc.prototype.endAngleProperty);
		}
	}

	, 
	_actualEndAngle: 0,
	actualEndAngle: function (value) {
		if (arguments.length === 1) {
			this._actualEndAngle = value;
			return value;
		} else {
			return this._actualEndAngle;
		}
	}

	, 
	arcBreadth: function () {

			if (this.ring() != null) {
				return this.ring().ringBreadth();
			}

			return 0;
	}

	, 
	onSliceClick: function (sender, e) {
		$.ig.PieChartBase.prototype.onSliceClick.call(this, sender, e);
		if (this.ring() != null) {
			this.ring().ringSeries().chart().onSliceClick(sender, e);
		}

	}

	, 
	explodeSlice: function (slice, explode) {
		if (this.ring() != null && this.ring().owner() != null) {
			$.ig.PieChartBase.prototype.explodeSlice.call(this, slice, explode);
			var item = this.getSliceItem(slice);
			this.ring().owner().explodeSlice(item, explode);
		}

	}

	, 
	selectSlice: function (slice, shouldSelect) {
		if (this.ring() != null && this.ring().owner() != null) {
			$.ig.PieChartBase.prototype.selectSlice.call(this, slice, shouldSelect);
			var item = this.getSliceItem(slice);
			this.ring().owner().selectSlice(item, shouldSelect);
		}

	}

	, 
	getSliceItem: function (slice) {
		var en = this.arcItem().sliceItems().getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			if (item.slice() == slice) {
				return item;
			}

		}

		return null;
	}

	, 
	selectedIndicesChangedOverride: function (args) {
		if (this.allowSliceSelection()) {
			this.prepareSlices();
			this.renderSlices();
			this.renderLegendItems();
		}

	}

	, 
	prepareSlices: function () {
		if (this.itemsSource() == null || this.fastItemsSource() == null) {
			this._slices.count(0);
			return;
		}

		var totalSliceCount = this.valueIndices().count();
		var hasOtherSlice = this.othersValueIndices().count() > 0;
		var startAngle = $.ig.PieChartBase.prototype.roundAngle(this.actualStartAngle());
		var endAngle = $.ig.PieChartBase.prototype.roundAngle(this.actualStartAngle());
		if (hasOtherSlice) {
			totalSliceCount++;
		}

		for (var i = 0; i < totalSliceCount; i++) {
			var isOtherSlice = false;
			var value;
			if (i == totalSliceCount - 1 && hasOtherSlice) {
				value = this.othersTotal();
				isOtherSlice = true;

			} else {
				value = this.valueColumn().item(this.valueIndices().__inner[i]);
			}

			if (this.sweepDirection() == $.ig.SweepDirection.prototype.clockwise) {
				endAngle += $.ig.PieChartBase.prototype.roundAngle(Math.abs(value) * this.endAngle() / this.total());

			} else {
				endAngle -= $.ig.PieChartBase.prototype.roundAngle(Math.abs(value) * this.endAngle() / this.total());
			}

			var slice = this._slices.item(i);
			if (this.chartInnerExtent() >= 100) {
				slice.__visibility = $.ig.Visibility.prototype.collapsed;

			} else {
				slice.__visibility = $.ig.Visibility.prototype.visible;
			}

			slice.suspendCreation(true);
			slice.startAngle(startAngle);
			slice.endAngle(endAngle);
			slice.innerExtentStart(slice.innerExtentEnd(this.chartInnerExtent()));
			slice.isOthersSlice(isOtherSlice);
			slice.explodedRadius(this.actualExplodedRadius());
			slice.index(i);
			slice.dataContext(isOtherSlice ? this.others() : this.fastItemsSource().item(this.valueIndices().__inner[i]));
			slice.isExploded(this.explodedSlices().contains(i));
			slice.isSelected(this.selectedSlices().contains(i));
			startAngle = endAngle;
			slice.suspendCreation(false);
		}

		this._slices.count(totalSliceCount);
		if (this.arcItem() != null) {
			this.arcItem().updateSliceItems(this);
		}

	}

	, 
	renderLegendItems: function () {
		var $self = this;
		var itemLegend = $.ig.util.cast($.ig.ItemLegend.prototype.$type, $self.legend());
		if (itemLegend == null) {
		return;
		}

		if ($self.labelColumn() == null || $self.labelColumn().count() == 0 || (($self.ring() != null && $self.ring().ringSeries() != null) && ($self.ring().owner() != null && !$self.ring().owner().series().contains($self.ring().ringSeries())))) {
			itemLegend.clearLegendItems($self.ring().ringSeries());
			return;
		}

		$self.legendItems(new $.ig.List$1($.ig.UIElement.prototype.$type, 0));
		var en = $self._slices.active().getEnumerator();
		while (en.moveNext()) {
			var slice = en.current();
			var item = new $.ig.ContentControl();
			var itemLabel = $self.getLabel(slice);
			var itemBrush = slice.background();
			item.content((function () { var $ret = new $.ig.PieSliceDataContext();
			$ret.series($self.ring().ringSeries());
			$ret.slice(slice);
			$ret.item(slice.dataContext());
			$ret.itemBrush(itemBrush);
			$ret.itemLabel(itemLabel != null ? itemLabel.toString() : null);
			$ret.percentValue($self.getPercentValue(slice));
			$ret.isOthersSlice(slice.isOthersSlice()); return $ret;}()));
			if ($self.legendItemTemplate() != null) {
				item.contentTemplate($self.legendItemTemplate());
			}

			$self.legendItems().add(item);
		}

		itemLegend.createLegendItemsInsert($self.legendItems(), $self.ring().ringSeries());
	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		$.ig.PieChartBase.prototype.propertyUpdatedOverride.call(this, sender, propertyName, oldValue, newValue);
		switch (propertyName) {
			case $.ig.Arc.prototype.endAnglePropertyName:
				this.actualEndAngle(newValue);
				this.prepareSlices();
				this.prepareLabels();
				this.renderSlices();
				this.renderLabels();
				break;
			case $.ig.PieChartBase.prototype.radiusFactorPropertyName:
				if (this.ring() != null && this.ring().owner() != null) {
					this.ring().owner().prepareCenterPresenter();
				}

				break;
			case $.ig.PieChartBase.prototype.legendPropertyName:
				var oldLegend = $.ig.util.cast($.ig.ItemLegend.prototype.$type, oldValue);
				if (oldLegend != null && this.ring() != null && this.ring().ringSeries() != null) {
					oldLegend.clearLegendItems(this.ring().ringSeries());
				}

				break;
		}

	}

	, 
	getContainer: function () {
		return this.view().getContainer();
	}
	, 
	$type: new $.ig.Type('Arc', $.ig.PieChartBase.prototype.$type)
}, true);

$.ig.util.defType('ArcItem', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.startAngle(0);
			this.endAngle(360);
			this.sliceItems(new $.ig.List$1($.ig.SliceItem.prototype.$type, 0));
	}

	, 
	_ring: null,
	ring: function (value) {
		if (arguments.length === 1) {
			this._ring = value;
			return value;
		} else {
			return this._ring;
		}
	}

	, 
	_parent: null,
	parent: function (value) {
		if (arguments.length === 1) {
			this._parent = value;
			return value;
		} else {
			return this._parent;
		}
	}

	, 
	_valueMemberPath: null,
	valueMemberPath: function (value) {
		if (arguments.length === 1) {
			this._valueMemberPath = value;
			return value;
		} else {
			return this._valueMemberPath;
		}
	}

	, 
	_index: 0,
	index: function (value) {
		if (arguments.length === 1) {
			this._index = value;
			return value;
		} else {
			return this._index;
		}
	}

	, 
	_levelDepth: 0,
	levelDepth: function (value) {
		if (arguments.length === 1) {
			this._levelDepth = value;
			return value;
		} else {
			return this._levelDepth;
		}
	}

	, 
	_startAngle: 0,
	startAngle: function (value) {
		if (arguments.length === 1) {
			this._startAngle = value;
			return value;
		} else {
			return this._startAngle;
		}
	}

	, 
	_endAngle: 0,
	endAngle: function (value) {
		if (arguments.length === 1) {
			this._endAngle = value;
			return value;
		} else {
			return this._endAngle;
		}
	}

	, 
	_othersCategoryThreshold: 0,
	othersCategoryThreshold: function (value) {
		if (arguments.length === 1) {
			this._othersCategoryThreshold = value;
			return value;
		} else {
			return this._othersCategoryThreshold;
		}
	}

	, 
	_brushes: null,
	brushes: function (value) {
		if (arguments.length === 1) {
			this._brushes = value;
			return value;
		} else {
			return this._brushes;
		}
	}

	, 
	_sliceItems: null,
	sliceItems: function (value) {
		if (arguments.length === 1) {
			this._sliceItems = value;
			return value;
		} else {
			return this._sliceItems;
		}
	}

	, 
	_parentSlice: null,
	parentSlice: function (value) {
		if (arguments.length === 1) {
			this._parentSlice = value;
			return value;
		} else {
			return this._parentSlice;
		}
	}

	, 
	_itemSource: null,
	itemSource: function (value) {
		if (arguments.length === 1) {
			this._itemSource = value;
			return value;
		} else {
			return this._itemSource;
		}
	}

	, 
	prepareSliceItems: function (seriesStartAngle) {
		var $self = this;
		var startAngle = $self.parentSlice() == null ? seriesStartAngle : $self.parentSlice().startAngle();
		var endAngle = $self.parentSlice() == null ? 360 : $self.parentSlice().endAngle();
		var arc = (function () { var $ret = new $.ig.Arc();
		$ret.othersCategoryThreshold($self.othersCategoryThreshold());
		$ret.itemsSource($self.itemSource());
		$ret.valueMemberPath($self.valueMemberPath());
		$ret.startAngle(startAngle);
		$ret.endAngle(endAngle); return $ret;}());
		arc.prepareData();
		arc.prepareSlices();
		$self.updateSliceItems(arc);
	}

	, 
	updateSliceItems: function (arc) {
		var $self = this;
		$self.sliceItems().clear();
		for (var index = 0; index < arc._slices.count(); index++) {
			var slice = arc._slices.item(index);
			$self.sliceItems().add((function () { var $ret = new $.ig.SliceItem();
			$ret.startAngle(slice.startAngle());
			$ret.endAngle(slice.endAngle() - slice.startAngle());
			$ret.index(index);
			$ret.arcItem($self);
			$ret.data(slice.dataContext());
			$ret.isOther(slice.isOthersSlice());
			$ret.slice(slice); return $ret;}()));
		}

	}
	, 
	$type: new $.ig.Type('ArcItem', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('PieChartBaseView', 'Object', {
	init: function (model) {


		this.__dirty = false;
		this.__renderedRect = $.ig.Rect.prototype.empty();

		$.ig.Object.prototype.init.call(this);
			this.model(model);
			this.viewManager(new $.ig.PieChartViewManager(this));
	}

	, 
	_model: null,
	model: function (value) {
		if (arguments.length === 1) {
			this._model = value;
			return value;
		} else {
			return this._model;
		}
	}

	, 
	onInit: function () {
		var $self = this;
		$self.fontBrush(null);
		$self.toolTipContext(new $.ig.PieSliceDataContext());
		$self.toolTipContext().series($self.model());
		$self.viewport($.ig.Rect.prototype.empty());
		$self.slices(new $.ig.List$1($.ig.Slice.prototype.$type, 0));
		$self.labels(new $.ig.List$1($.ig.PieLabel.prototype.$type, 0));
		$self.model().legendItemTemplate((function () { var $ret = new $.ig.DataTemplate();
		$ret.render($.ig.LegendTemplates.prototype.pieLegendItemRender);
		$ret.measure($.ig.LegendTemplates.prototype.defaultLegendItemMeasure); return $ret;}()));
		$self.model().legendItemBadgeTemplate((function () { var $ret = new $.ig.DataTemplate();
		$ret.render($.ig.LegendTemplates.prototype.pieBadgeTemplate);
		$ret.measure($.ig.LegendTemplates.prototype.legendItemBadgeMeasure); return $ret;}()));
	}

	, 
	setDefaultBrushes: function () {
		var $self = this;
		var brushes = new $.ig.BrushCollection();
		var outlines = new $.ig.BrushCollection();
		var fontBrush;
		var font;
		(function () { var $ret = $self.viewManager().getDefaultStyle(brushes, outlines, fontBrush, font); brushes = $ret.p0; outlines = $ret.p1; fontBrush = $ret.p2; font = $ret.p3; return $ret.ret; }());
		if ($self.model().brushes() == null) {
			$self.model().brushes(brushes);
		}

		if ($self.model().outlines() == null) {
			$self.model().outlines(outlines);
		}

		if ($self.fontBrush() == null) {
			$self.fontBrush(fontBrush);
		}

		if ($self.model().textStyle() != null) {
			$self.font($self.model().textStyle());

		} else {
			$self.font(font);
		}

	}

	, 
	_fontBrush: null,
	fontBrush: function (value) {
		if (arguments.length === 1) {
			this._fontBrush = value;
			return value;
		} else {
			return this._fontBrush;
		}
	}

	, 
	_font: null,
	font: function (value) {
		if (arguments.length === 1) {
			this._font = value;
			return value;
		} else {
			return this._font;
		}
	}

	, 
	_backgroundContext: null,
	backgroundContext: function (value) {
		if (arguments.length === 1) {
			this._backgroundContext = value;
			return value;
		} else {
			return this._backgroundContext;
		}
	}

	, 
	_mainContext: null,
	mainContext: function (value) {
		if (arguments.length === 1) {
			this._mainContext = value;
			return value;
		} else {
			return this._mainContext;
		}
	}

	, 
	_labelContext: null,
	labelContext: function (value) {
		if (arguments.length === 1) {
			this._labelContext = value;
			return value;
		} else {
			return this._labelContext;
		}
	}

	, 
	_overlayContext: null,
	overlayContext: function (value) {
		if (arguments.length === 1) {
			this._overlayContext = value;
			return value;
		} else {
			return this._overlayContext;
		}
	}

	, 
	_viewManager: null,
	viewManager: function (value) {
		if (arguments.length === 1) {
			this._viewManager = value;
			return value;
		} else {
			return this._viewManager;
		}
	}

	, 
	onContainerProvided: function (container) {
		if (container == null) {
			this.__dirty = false;
			this.viewManager().onContainerProvided(null);
			this.backgroundContext(null);
			this.mainContext(null);
			this.labelContext(null);
			this.overlayContext(null);
			return;
		}

		this.viewManager().onContainerProvided(container);
		this.backgroundContext(this.viewManager().backgroundContext());
		this.mainContext(this.viewManager().mainContext());
		this.labelContext(this.viewManager().labelContext());
		this.overlayContext(this.viewManager().labelContext());
	}

	, 
	getContainerRect: function () {
		return this.viewport();
	}

	, 
	getContainerOffsets: function () {
		return this.viewManager().getContainerOffsets();
	}

	, 
	resize: function () {
		this.viewport(this.viewManager().resize());
		this.model().onSizeUpdated();
	}

	, 
	_viewport: null,
	viewport: function (value) {
		if (arguments.length === 1) {
			this._viewport = value;
			return value;
		} else {
			return this._viewport;
		}
	}
	, 
	__dirty: false

	, 
	makeDirty: function () {
		if (!this.__dirty) {
			this.__dirty = true;
			this.viewManager().queueWork(this.undirty.runOn(this));
		}

	}

	, 
	undirty: function () {
		if (this.__dirty) {
			this.__dirty = false;
			this.render();
		}

	}
	, 
	__renderedRect: null

	, 
	render: function () {
		this.ensureContextFont();
		if (!this.__renderedRect.isEmpty()) {
			if (this.overlayContext().shouldRender()) {
				this.overlayContext().clearRectangle(this.__renderedRect.left(), this.__renderedRect.top(), this.__renderedRect.width(), this.__renderedRect.height());
			}

			if (this.labelContext().shouldRender()) {
				this.labelContext().clearRectangle(this.__renderedRect.left(), this.__renderedRect.top(), this.__renderedRect.width(), this.__renderedRect.height());
			}

			if (this.mainContext().shouldRender()) {
				this.mainContext().clearRectangle(this.__renderedRect.left(), this.__renderedRect.top(), this.__renderedRect.width(), this.__renderedRect.height());
			}

			if (this.backgroundContext().shouldRender()) {
				this.backgroundContext().clearRectangle(this.__renderedRect.left(), this.__renderedRect.top(), this.__renderedRect.width(), this.__renderedRect.height());
			}

		}

		this.renderOverride();
	}

	, 
	renderOverride: function () {
		this.__renderedRect = this.viewport();
		if (this.mainContext() != null && this.mainContext().shouldRender()) {
			var en = this.slices().getEnumerator();
			while (en.moveNext()) {
				var slice = en.current();
				if (slice.__visibility == $.ig.Visibility.prototype.visible) {
					var slicePath = slice.view().getSlicePath();
					this.viewManager().setDefaultSliceBrushes(slicePath);
					slicePath.strokeThickness(1);
					slicePath.__opacity = slice.__opacity;
					if (slice.background() != null) {
						slicePath.__fill = slice.background();
					}

					if (slice.borderBrush() != null) {
						slicePath.__stroke = slice.borderBrush();
					}

					if (slice.style() != null) {
						this.mainContext().applyStyle(slicePath, slice.style());
					}

					if (slicePath.renderTransform() != null) {
						this.mainContext().save();
						this.mainContext().applyTransform(slicePath.renderTransform());
					}

					this.mainContext().renderPath(slicePath);
					if (slicePath.renderTransform() != null) {
						this.mainContext().restore();
					}

				}

			}

		}

		if (this.labelContext() != null && this.labelContext().shouldRender()) {
			var font = this.font();
			if (this.model().textStyle() != null) {
				font = this.model().textStyle();
			}

			this.labelContext().setFont(font);
			var en1 = this.labels().getEnumerator();
			while (en1.moveNext()) {
				var label = en1.current();
				if (label.__visibility == $.ig.Visibility.prototype.visible) {
					var txt = label.label();
					if (txt != null) {
							txt.fill(this.fontBrush());
							this.labelContext().renderTextBlock(txt);

					}

					if (this.model().leaderLineType() != $.ig.LeaderLineType.prototype.straight && label.leaderLinePath() != null) {
						label.leaderLinePath().__stroke = label.slice().background();
						label.leaderLinePath().strokeThickness(1);
						if (this.model().leaderLineStyle() != null) {
							this.labelContext().applyStyle(label.leaderLinePath(), this.model().leaderLineStyle());
						}

						this.labelContext().renderPath(label.leaderLinePath());
					}

					if (this.model().leaderLineType() == $.ig.LeaderLineType.prototype.straight && label.leaderLine() != null) {
						label.leaderLine().__stroke = label.slice().background();
						label.leaderLine().strokeThickness(1);
						if (this.model().leaderLineStyle() != null) {
							this.labelContext().applyStyle(label.leaderLine(), this.model().leaderLineStyle());
						}

						this.labelContext().renderLine(label.leaderLine());
					}

				}

			}

		}

	}

	, 
	canvasMouseMove: function (p, onMouseMove, isFinger) {
		var $self = this;
		var prev = $self.activeSlice();
		$self.updateActiveSlice(p);
		if ($self.activeSlice() == null && prev != null) {
			var me = (function () { var $ret = new $.ig.MouseEventArgs();
			$ret.position(p); return $ret;}());
			$self.model().itemMouseLeft($self.activeSlice(), me);

		} else if ($self.activeSlice() != null) {
			var me1 = (function () { var $ret = new $.ig.MouseEventArgs();
			$ret.position(p); return $ret;}());
			$self.model().itemMouseMoved($self.activeSlice(), me1);
		}


	}

	, 
	canvasMouseLeave: function (p) {
		var $self = this;
		var prev = $self.activeSlice();
		$self.updateActiveSlice(p);
		var me = (function () { var $ret = new $.ig.MouseEventArgs();
		$ret.position(p); return $ret;}());
		$self.model().itemMouseLeft(prev, me);
	}

	, 
	canvasMouseDown: function (p) {
		this.updateActiveSlice(p);
	}

	, 
	canvasMouseUp: function (p) {
		var $self = this;
		$self.updateActiveSlice(p);
		if ($self.activeSlice() != null) {
			var me = (function () { var $ret = new $.ig.MouseButtonEventArgs();
			$ret.position(p); return $ret;}());
			$self.model().sliceClicked($self.activeSlice(), me);
		}

	}

	, 
	_activeSlice: null,
	activeSlice: function (value) {
		if (arguments.length === 1) {
			this._activeSlice = value;
			return value;
		} else {
			return this._activeSlice;
		}
	}

	, 
	updateActiveSlice: function (p) {
		this.activeSlice(null);
		for (var i = 0; i < this.slices().count(); i++) {
			if (this.slices().__inner[i].__visibility == $.ig.Visibility.prototype.visible && this.slices().__inner[i].containsPoint(p)) {
				this.activeSlice(this.slices().__inner[i]);
				break;
			}

		}

	}

	, 
	sizeUpdated: function () {
		this.model().onSizeUpdated();
	}

	, 
	closeToolTip: function () {
		this.hideTooltip();
	}

	, 
	updateToolTip: function (item, args) {
		var me = args;
		this.updateToolTip1(me.position(), item, args);
	}

	, 
	_slices: null,
	slices: function (value) {
		if (arguments.length === 1) {
			this._slices = value;
			return value;
		} else {
			return this._slices;
		}
	}

	, 
	sliceCreate: function () {
		var slice = new $.ig.Slice();
		slice.owner(this.model());
		this.slices().add(slice);
		return slice;
	}

	, 
	sliceActivate: function (slice) {
		slice.__visibility = $.ig.Visibility.prototype.visible;
	}

	, 
	sliceDisactivate: function (slice) {
		slice.__visibility = $.ig.Visibility.prototype.collapsed;
	}

	, 
	sliceDestroy: function (slice) {
		slice.owner(null);
		this.slices().remove(slice);
	}

	, 
	_labels: null,
	labels: function (value) {
		if (arguments.length === 1) {
			this._labels = value;
			return value;
		} else {
			return this._labels;
		}
	}

	, 
	labelCreate: function () {
		var label = new $.ig.PieLabel();
		if (this.model().leaderLineType() == $.ig.LeaderLineType.prototype.straight) {
			label.leaderLine(new $.ig.Line());

		} else {
			label.leaderLinePath(new $.ig.Path());
			var geom = new $.ig.PathGeometry();
			geom.figures().add(new $.ig.PathFigure());
			geom.figures().__inner[0].__segments.add(new $.ig.BezierSegment(0));
			label.leaderLinePath().data(geom);
		}

		this.labels().add(label);
		return label;
	}

	, 
	labelActivate: function (label) {
		label.__visibility = $.ig.Visibility.prototype.visible;
	}

	, 
	labelDisactivate: function (label) {
		label.__visibility = $.ig.Visibility.prototype.collapsed;
	}

	, 
	labelDestroy: function (label) {
		this.labels().remove(label);
	}

	, 
	updateLabelLeaderLine: function (label) {
		if ((this.model().leaderLineType() != $.ig.LeaderLineType.prototype.straight && label.leaderLinePath() != null) || (this.model().leaderLineType() == $.ig.LeaderLineType.prototype.straight && label.leaderLine() != null)) {
			return;
		}

		if (this.model().leaderLineType() == $.ig.LeaderLineType.prototype.straight) {
			label.leaderLinePath(null);
			label.leaderLine(new $.ig.Line());

		} else {
			label.leaderLine(null);
			label.leaderLinePath(new $.ig.Path());
			var geom = new $.ig.PathGeometry();
			geom.figures().add(new $.ig.PathFigure());
			geom.figures().__inner[0].__segments.add(new $.ig.BezierSegment(0));
			label.leaderLinePath().data(geom);
		}

	}

	, 
	setSliceAppearance: function (slice) {
		if (this.model().othersCategoryStyle() != null && slice.isOthersSlice()) {
			slice.style(this.model().othersCategoryStyle());

		} else if (slice.isSelected() && this.model().allowSliceSelection() && this.model().selectedStyle() != null) {
			slice.style(this.model().selectedStyle());

		} else {
			slice.style(null);
			var background;
			var borderBrush;
			if (this.model().brushes() != null && slice.index() >= 0 && this.model().brushes().count() > 0) {
				background = this.model().brushes().item(slice.index() % this.model().brushes().count());

			} else {
				background = null;
			}

			if (this.model().outlines() != null && slice.index() >= 0 && this.model().outlines().count() > 0) {
				borderBrush = this.model().outlines().item(slice.index() % this.model().outlines().count());

			} else {
				borderBrush = null;
			}

			slice.background(background);
			slice.borderBrush(borderBrush);
		}


	}

	, 
	getLabel: function (slice) {
		if (slice == null || slice.label() == null) {
			return this.model().labelMemberPath();
		}

		var pieLabel = slice.label();
		var label = pieLabel.label();
		if ($.ig.util.cast($.ig.TextBlock.prototype.$type, label) !== null) {
			return ($.ig.util.cast($.ig.TextBlock.prototype.$type, label)).text();
		}

		return label;
	}

	, 
	getDesiredWidth: function (element) {
		var tb = $.ig.util.cast($.ig.TextBlock.prototype.$type, element);
		if (tb != null && tb.text() != null) {
			return this.labelContext().measureTextWidth(tb.text()) + $.ig.PieChartBaseView.prototype.tEXT_MARGIN;
		}

		return 0;
	}

	, 
	updateCurrentFontHeight: function () {
		this.fontHeight($.ig.FontUtil.prototype.getCurrentFontHeight(this.viewManager().container(), this.viewManager().getOwnerFont()));
	}

	, 
	_fontHeight: 0,
	fontHeight: function (value) {
		if (arguments.length === 1) {
			this._fontHeight = value;
			return value;
		} else {
			return this._fontHeight;
		}
	}

	, 
	getDesiredHeight: function (element) {
		return this.fontHeight() + $.ig.PieChartBaseView.prototype.tEXT_MARGIN;
	}

	, 
	getLabelBounds: function (label) {
		var lbl = label.label();
		if ($.ig.util.cast($.ig.TextBlock.prototype.$type, lbl) !== null) {
			var desiredWidth = this.getDesiredWidth(lbl);
			var desiredHeight = this.getDesiredHeight(lbl);
			return new $.ig.Rect(0, 0, 0, desiredWidth, desiredHeight);
		}

		return $.ig.Rect.prototype.empty();
	}

	, 
	updatePieViewport: function () {
		return new $.ig.Size(1, this.viewport().width(), this.viewport().height());
	}

	, 
	updateLabelPosition: function (label, x, y) {
		var txt = $.ig.util.cast($.ig.TextBlock.prototype.$type, label.label());
		if (txt != null) {
			txt.canvasLeft(x);
			txt.canvasTop(y);
		}

		this.makeDirty();
	}

	, 
	updateToolTipContent: function (toolTip) {
		this.updateToolTipValue(toolTip);
	}

	, 
	updateView: function () {
		this.makeDirty();
	}

	, 
	labelPreMeasure: function () {
		this.ensureContextFont();
	}

	, 
	ensureContextFont: function () {
		var font = this.font();
		if (this.model().textStyle() != null) {
			font = this.model().textStyle();
		}

		if (this.labelContext() != null) {
			this.labelContext().setFont(font);
		}

	}

	, 
	onContainerResized: function (width, height) {
		this.viewManager().onContainerResized(width, height);
	}

	, 
	notifyContainerResized: function () {
		this.viewManager().notifyContainerResized();
	}

	, 
	_toolTipPosition: null,
	toolTipPosition: function (value) {
		if (arguments.length === 1) {
			this._toolTipPosition = value;
			return value;
		} else {
			return this._toolTipPosition;
		}
	}

	, 
	_toolTipItem: null,
	toolTipItem: function (value) {
		if (arguments.length === 1) {
			this._toolTipItem = value;
			return value;
		} else {
			return this._toolTipItem;
		}
	}

	, 
	_toolTipVisible: false,
	toolTipVisible: function (value) {
		if (arguments.length === 1) {
			this._toolTipVisible = value;
			return value;
		} else {
			return this._toolTipVisible;
		}
	}

	, 
	_toolTipContext: null,
	toolTipContext: function (value) {
		if (arguments.length === 1) {
			this._toolTipContext = value;
			return value;
		} else {
			return this._toolTipContext;
		}
	}

	, 
	hideTooltip: function () {
		if (this.toolTipVisible() == true) {
			this.toolTipVisible(false);
			this.viewManager().hideTooltip(this.toolTipContext());
		}

	}

	, 
	updateToolTipValue: function (p) {
		this.viewManager().updateTooltipValue(p);
	}

	, 
	updateToolTip1: function (pt, item, data) {
		this.toolTipVisible(true);
		this.toolTipPosition(pt);
		if (item == null) {
			this.toolTipItem(null);
			this.toolTipContext().item(null);

		} else {
			this.toolTipItem((item).dataContext());
			this.toolTipContext().item((item).dataContext());
		}

		var offsets = this.model().getContainerOffsets();
		var pos_ = {__x: pt.__x + 15 + offsets.width(), __y: pt.__y + 15 + offsets.height(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		var context_ = this.toolTipContext();
		this.viewManager().updateTooltipPosition(pos_, context_);
	}

	, 
	styleUpdated: function () {
		this.setDefaultBrushes();
		this.updateCurrentFontHeight();
		this.model().renderChart();
	}

	, 
	onIsSurfaceInteractionDisabledChanged: function () {
		this.viewManager().onIsSurfaceInteractionDisabledChanged(this.model().isSurfaceInteractionDisabled());
	}

	, 
	getContainer: function () {
		return this.viewManager().getContainer();
	}

	, 
	flush: function () {
		if (this.__dirty) {
			this.undirty();
		}

	}

	, 
	ready: function () {
		return this.getContainer() != null;
	}

	, 
	exportViewData: function (visualData) {
		this.viewManager().exportViewData(visualData);
	}

	, 
	preRender: function () {
	}

	, 
	getActualBackground: function (slice) {
		var bg = this.viewManager().getStyleBackground(slice.style());
		if (bg != null) {
			return bg;
		}

		return slice.background();
	}

	, 
	getActualOutline: function (slice) {
		var outline = this.viewManager().getStyleOutline(slice.style());
		if (outline != null) {
			return outline;
		}

		return slice.borderBrush();
	}
	, 
	$type: new $.ig.Type('PieChartBaseView', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('ArcView', 'PieChartBaseView', {

	_arcModel: null,
	arcModel: function (value) {
		if (arguments.length === 1) {
			this._arcModel = value;
			return value;
		} else {
			return this._arcModel;
		}
	}
	, 
	init: function (model) {



		$.ig.PieChartBaseView.prototype.init.call(this, model);
			this.arcModel(model);
	}

	, 
	onRingChanged: function (oldRing, _ring) {
		this.toolTipContext().series(this.arcModel().ring().ringSeries());
	}

	, 
	getActiveSlice: function () {
		return this.activeSlice();
	}

	, 
	updateFont: function () {
		this.fontBrush(new $.ig.Brush());
		var container = this.viewManager().getContainer();
		this.fontBrush().__fill = container.css("color");
		this.font($.ig.FontUtil.prototype.getFont(container));
	}
	, 
	$type: new $.ig.Type('ArcView', $.ig.PieChartBaseView.prototype.$type)
}, true);

$.ig.util.defType('RingSeriesBase', 'Control', {
	__propertyUpdatedOverride: null
	, 
	init: function () {



		var $self = this;
		$.ig.Control.prototype.init.call(this);
			this.location({__x: 0, __y: 0, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			this.__propertyUpdatedOverride = function (o, e) {
				$self.propertyUpdatedOverride(o, e.propertyName(), e.oldValue(), e.newValue());
			};
			this.propertyUpdated = $.ig.Delegate.prototype.combine(this.propertyUpdated, this.__propertyUpdatedOverride);
			this.view(this.createView());
			this.onViewCreated(this.view());
			this.view().onInit();
			var nullValue = $.ig.util.toNullable($.ig.Boolean.prototype.$type, null);
			this.isSurfaceInteractionDisabled(nullValue);
	}

	, 
	_chart: null,
	chart: function (value) {
		if (arguments.length === 1) {
			this._chart = value;
			return value;
		} else {
			return this._chart;
		}
	}

	, 
	itemsSource: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.RingSeriesBase.prototype.itemsSourceProperty, value);
			return value;
		} else {

			return this.getValue($.ig.RingSeriesBase.prototype.itemsSourceProperty);
		}
	}

	, 
	valueMemberPath: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.RingSeriesBase.prototype.valueMemberPathProperty, value);
			return value;
		} else {

			return this.getValue($.ig.RingSeriesBase.prototype.valueMemberPathProperty);
		}
	}

	, 
	labelMemberPath: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.RingSeriesBase.prototype.labelMemberPathProperty, value);
			return value;
		} else {

			return this.getValue($.ig.RingSeriesBase.prototype.labelMemberPathProperty);
		}
	}
	, 
	propertyChanged: null, 
	propertyUpdated: null
	, 
	raisePropertyChanged: function (propertyName, oldValue, newValue) {
		if (this.propertyChanged != null) {
			this.propertyChanged(this, new $.ig.PropertyChangedEventArgs(propertyName));
		}

		if (this.propertyUpdated != null) {
			this.propertyUpdated(this, new $.ig.PropertyUpdatedEventArgs(propertyName, oldValue, newValue));
		}

	}

	, 
	labelsPosition: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.RingSeriesBase.prototype.labelsPositionProperty, $.ig.LabelsPosition.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.RingSeriesBase.prototype.labelsPositionProperty));
		}
	}

	, 
	leaderLineVisibility: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.RingSeriesBase.prototype.leaderLineVisibilityProperty, $.ig.Visibility.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.RingSeriesBase.prototype.leaderLineVisibilityProperty));
		}
	}

	, 
	leaderLineStyle: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.RingSeriesBase.prototype.leaderLineStyleProperty, value);
			return value;
		} else {

			return this.getValue($.ig.RingSeriesBase.prototype.leaderLineStyleProperty);
		}
	}

	, 
	leaderLineType: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.RingSeriesBase.prototype.leaderLineTypeProperty, $.ig.LeaderLineType.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.RingSeriesBase.prototype.leaderLineTypeProperty));
		}
	}

	, 
	leaderLineMargin: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.RingSeriesBase.prototype.leaderLineMarginProperty, value);
			return value;
		} else {

			return this.getValue($.ig.RingSeriesBase.prototype.leaderLineMarginProperty);
		}
	}

	, 
	toolTip: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.RingSeriesBase.prototype.toolTipProperty, value);
			return value;
		} else {

			return this.getValue($.ig.RingSeriesBase.prototype.toolTipProperty);
		}
	}

	, 
	othersCategoryThreshold: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.RingSeriesBase.prototype.othersCategoryThresholdProperty, value);
			return value;
		} else {

			return this.getValue($.ig.RingSeriesBase.prototype.othersCategoryThresholdProperty);
		}
	}

	, 
	othersCategoryType: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.RingSeriesBase.prototype.othersCategoryTypeProperty, $.ig.OthersCategoryType.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.RingSeriesBase.prototype.othersCategoryTypeProperty));
		}
	}

	, 
	othersCategoryText: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.RingSeriesBase.prototype.othersCategoryTextProperty, value);
			return value;
		} else {

			return this.getValue($.ig.RingSeriesBase.prototype.othersCategoryTextProperty);
		}
	}

	, 
	legend: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.RingSeriesBase.prototype.legendProperty, value);
			return value;
		} else {

			return this.getValue($.ig.RingSeriesBase.prototype.legendProperty);
		}
	}

	, 
	formatLabel: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.RingSeriesBase.prototype.formatLabelProperty, value);
			return value;
		} else {

			return this.getValue($.ig.RingSeriesBase.prototype.formatLabelProperty);
		}
	}

	, 
	labelExtent: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.RingSeriesBase.prototype.labelExtentProperty, value);
			return value;
		} else {

			return this.getValue($.ig.RingSeriesBase.prototype.labelExtentProperty);
		}
	}

	, 
	startAngle: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.RingSeriesBase.prototype.startAngleProperty, value);
			return value;
		} else {

			return this.getValue($.ig.RingSeriesBase.prototype.startAngleProperty);
		}
	}

	, 
	othersCategoryStyle: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.RingSeriesBase.prototype.othersCategoryStyleProperty, value);
			return value;
		} else {

			return this.getValue($.ig.RingSeriesBase.prototype.othersCategoryStyleProperty);
		}
	}

	, 
	selectedStyle: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.RingSeriesBase.prototype.selectedStyleProperty, value);
			return value;
		} else {

			return this.getValue($.ig.RingSeriesBase.prototype.selectedStyleProperty);
		}
	}

	, 
	selectedStyleResolved: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.selectedStyleResolved();
			if (this.selectedStyle() != null && value != this.selectedStyle()) {
				value = this.selectedStyle();
			}

			this.raisePropertyChanged($.ig.RingSeriesBase.prototype.selectedStyleResolvedPropertyName, oldValue, value);
			return value;
		} else {

			if (this.selectedStyle() != null) {
				return this.selectedStyle();
			}

			if (this.chart() != null && this.chart().selectedStyle() != null) {
				return this.chart().selectedStyle();
			}

			return null;
		}
	}

	, 
	toolTipStyle: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.RingSeriesBase.prototype.toolTipStyleProperty, value);
			return value;
		} else {

			return this.getValue($.ig.RingSeriesBase.prototype.toolTipStyleProperty);
		}
	}

	, 
	brushes: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.RingSeriesBase.prototype.brushesProperty, value);
			return value;
		} else {

			return this.getValue($.ig.RingSeriesBase.prototype.brushesProperty);
		}
	}

	, 
	outlines: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.RingSeriesBase.prototype.outlinesProperty, value);
			return value;
		} else {

			return this.getValue($.ig.RingSeriesBase.prototype.outlinesProperty);
		}
	}

	, 
	legendItemTemplate: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.RingSeriesBase.prototype.legendItemTemplateProperty, value);
			return value;
		} else {

			return this.getValue($.ig.RingSeriesBase.prototype.legendItemTemplateProperty);
		}
	}

	, 
	legendItemBadgeTemplate: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.RingSeriesBase.prototype.legendItemBadgeTemplateProperty, value);
			return value;
		} else {

			return this.getValue($.ig.RingSeriesBase.prototype.legendItemBadgeTemplateProperty);
		}
	}

	, 
	labelTemplate: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.RingSeriesBase.prototype.labelTemplateProperty, value);
			return value;
		} else {

			return $.ig.util.cast($.ig.DataTemplate.prototype.$type, this.getValue($.ig.RingSeriesBase.prototype.labelTemplateProperty));
		}
	}

	, 
	isSurfaceInteractionDisabled: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.RingSeriesBase.prototype.isSurfaceInteractionDisabledProperty, value);
			return value;
		} else {

			return this.getValue($.ig.RingSeriesBase.prototype.isSurfaceInteractionDisabledProperty);
		}
	}

	, 
	radiusFactor: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.RingSeriesBase.prototype.radiusFactorProperty, value);
			return value;
		} else {

			return this.getValue($.ig.RingSeriesBase.prototype.radiusFactorProperty);
		}
	}

	, 
	_location: null,
	location: function (value) {
		if (arguments.length === 1) {
			this._location = value;
			return value;
		} else {
			return this._location;
		}
	}

	, 
	_view: null,
	view: function (value) {
		if (arguments.length === 1) {
			this._view = value;
			return value;
		} else {
			return this._view;
		}
	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		switch (propertyName) {
			case $.ig.RingSeriesBase.prototype.selectedStylePropertyName:
				this.selectedStyleResolved(newValue);
				break;
		}

	}

	, 
	_rootCanvas: null,
	rootCanvas: function (value) {
		if (arguments.length === 1) {
			this._rootCanvas = value;
			return value;
		} else {
			return this._rootCanvas;
		}
	}

	, 
	createView: function () {
		return new $.ig.RingSeriesBaseView(this);
	}

	, 
	onViewCreated: function (view) {
	}

	, 
	analyzeRings: function () {}

	, 
	prepareData: function () {}

	, 
	prepareBrushes: function () {}

	, 
	provideContainer: function (container) {
		this.view().provideContainer(container);
	}

	, 
	clearView: function () {
		if (this.view() != null) {
			this.view().clearView();
		}

	}

	, 
	renderSeries: function () {}

	, 
	renderLegendItems: function () {}
	, 
	$type: new $.ig.Type('RingSeriesBase', $.ig.Control.prototype.$type, [$.ig.INotifyPropertyChanged.prototype.$type])
}, true);





$.ig.util.defType('HoleDimensionsChangedEventArgs', 'EventArgs', {
	init: function (center, radius) {



		$.ig.EventArgs.prototype.init.call(this);
			this.__center = center;
			this.__radius = radius;
	}
	, 
	__center: null

	, 
	center: function () {

			return this.__center;
	}
	, 
	__radius: 0

	, 
	radius: function () {

			return this.__radius;
	}
	, 
	$type: new $.ig.Type('HoleDimensionsChangedEventArgs', $.ig.EventArgs.prototype.$type)
}, true);

$.ig.util.defType('Ring', 'Object', {
	init: function () {


		this._controlSize = new $.ig.Size();

		var $self = this;
		$.ig.Object.prototype.init.call(this);
			this.center({__x: 0, __y: 0, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			this.controlSize(new $.ig.Size(1, 0, 0));
			this.ringControl((function () { var $ret = new $.ig.RingControl();
			$ret.ring($self); return $ret;}()));
			this.arcItems(new $.ig.List$1($.ig.ArcItem.prototype.$type, 0));
			this.clearContent(true);
	}

	, 
	_index: 0,
	index: function (value) {
		if (arguments.length === 1) {
			this._index = value;
			return value;
		} else {
			return this._index;
		}
	}

	, 
	_innerExtend: 0,
	innerExtend: function (value) {
		if (arguments.length === 1) {
			this._innerExtend = value;
			return value;
		} else {
			return this._innerExtend;
		}
	}

	, 
	_controlSize: null,
	controlSize: function (value) {
		if (arguments.length === 1) {
			this._controlSize = value;
			return value;
		} else {
			return this._controlSize;
		}
	}

	, 
	_center: null,
	center: function (value) {
		if (arguments.length === 1) {
			this._center = value;
			return value;
		} else {
			return this._center;
		}
	}

	, 
	_ringControl: null,
	ringControl: function (value) {
		if (arguments.length === 1) {
			this._ringControl = value;
			return value;
		} else {
			return this._ringControl;
		}
	}
	, 
	__ringSeries: null

	, 
	ringSeries: function (value) {
		if (arguments.length === 1) {

			this.__ringSeries = value;
			this.__ringSeries.view().addRing(this.ringControl());
			if (this.ringControl() != null) {
			this.ringControl().view().onSeriesProvided(value);
			}

			return value;
		} else {

			return this.__ringSeries;
		}
	}

	, 
	_ringBreadth: 0,
	ringBreadth: function (value) {
		if (arguments.length === 1) {
			this._ringBreadth = value;
			return value;
		} else {
			return this._ringBreadth;
		}
	}

	, 
	_arcItems: null,
	arcItems: function (value) {
		if (arguments.length === 1) {
			this._arcItems = value;
			return value;
		} else {
			return this._arcItems;
		}
	}

	, 
	_owner: null,
	owner: function (value) {
		if (arguments.length === 1) {
			this._owner = value;
			return value;
		} else {
			return this._owner;
		}
	}

	, 
	_clearContent: false,
	clearContent: function (value) {
		if (arguments.length === 1) {
			this._clearContent = value;
			return value;
		} else {
			return this._clearContent;
		}
	}

	, 
	renderArcs: function () {
		if (this.ringControl() != null && this.ringControl().view().isReady()) {
			var x, y;
			x = this.center().__x - this.ringSeries().location().__x;
			y = this.center().__y - this.ringSeries().location().__y;
			this.ringControl().view().positionRingControl(x, y);
			return this.ringControl().renderControl();
		}

		return false;
	}

	, 
	prepareArcs: function () {
		if (this.ringControl() != null) {
			this.ringControl().width(this.controlSize().width());
			this.ringControl().height(this.controlSize().height());
			this.ringSeries().view().addRing(this.ringControl());
			this.ringControl().itemsSource(this.arcItems());
		}

	}
	, 
	$type: new $.ig.Type('Ring', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('RingCollection', 'ObservableCollection$1', {
	init: function () {


		$.ig.ObservableCollection$1.prototype.init.call(this, $.ig.Ring.prototype.$type, 0);

	}
	, 
	clearItems: function () {
		var en = this.getEnumerator();
		while (en.moveNext()) {
			var ring = en.current();
			if (ring.clearContent()) {
				var index = 0;
				var count = ring.ringControl()._arcs.count();
				while (index < count) {
					ring.ringControl()._arcs.destroy()(ring.ringControl()._arcs.item(index));
					index++;

				}
				ring.ringControl()._arcs.count(0);
				ring.ringControl(null);
			}

		}

		$.ig.ObservableCollection$1.prototype.clearItems.call(this);
	}

	, 
	removeItem: function (index) {
		var ring = this.__inner[index];
		if (ring.clearContent()) {
			ring.ringControl()._arcs.destroy()(ring.ringControl()._arcs.item(index));
			ring.ringControl()._arcs.count(0);
			ring.ringControl(null);
		}

		$.ig.ObservableCollection$1.prototype.removeItem.call(this, index);
	}
	, 
	$type: new $.ig.Type('RingCollection', $.ig.ObservableCollection$1.prototype.$type.specialize($.ig.Ring.prototype.$type))
}, true);

$.ig.util.defType('RingControl', 'Control', {
	init: function () {



		var $self = this;
		$.ig.Control.prototype.init.call(this);
			this.defaultStyleKey($.ig.RingControl.prototype.$type);
			this.view(this.createView());
			this.onViewCreated(this.view());
			this.view().onInit();
			this._arcs = (function () { var $ret = new $.ig.Pool$1($.ig.Arc.prototype.$type);
			$ret.create($self.view().arcCreate.runOn($self.view()));
			$ret.activate($self.view().arcActivate.runOn($self.view()));
			$ret.disactivate($self.view().arcDisactivate.runOn($self.view()));
			$ret.destroy($self.view().arcDestroy.runOn($self.view())); return $ret;}());
	}

	, 
	series: function () {

			return this.ring().ringSeries();
	}

	, 
	_view: null,
	view: function (value) {
		if (arguments.length === 1) {
			this._view = value;
			return value;
		} else {
			return this._view;
		}
	}
	, 
	__ring: null

	, 
	ring: function (value) {
		if (arguments.length === 1) {

			this.__ring = value;
			if (this.__ring == null) {
				this.view().onSeriesProvided(null);

			} else {
				this.view().onSeriesProvided(this.__ring.ringSeries());
			}

			return value;
		} else {

			return this.__ring;
		}
	}
	, 
	_arcs: null

	, 
	_itemsSource: null,
	itemsSource: function (value) {
		if (arguments.length === 1) {
			this._itemsSource = value;
			return value;
		} else {
			return this._itemsSource;
		}
	}

	, 
	_rootCanvas: null,
	rootCanvas: function (value) {
		if (arguments.length === 1) {
			this._rootCanvas = value;
			return value;
		} else {
			return this._rootCanvas;
		}
	}

	, 
	createView: function () {
		return new $.ig.RingControlView(this);
	}

	, 
	onViewCreated: function (view) {
	}
	, 
	propertyChanged: null, 
	propertyUpdated: null
	, 
	raisePropertyChanged: function (propertyName, oldValue, newValue) {
		if (this.propertyChanged != null) {
			this.propertyChanged(this, new $.ig.PropertyChangedEventArgs(propertyName));
		}

		if (this.propertyUpdated != null) {
			this.propertyUpdated(this, new $.ig.PropertyUpdatedEventArgs(propertyName, oldValue, newValue));
		}

	}

	, 
	onSizeUpdated: function () {
		this.renderControl();
	}

	, 
	renderControl: function () {
		if (this.itemsSource() == null) {
			return false;
		}

		var index = 0;
		var areResized = false;
		var en = this.itemsSource().getEnumerator();
		while (en.moveNext()) {
			var arcItem = en.current();
			var arc = this._arcs.item(index);
			arc.arcItem(arcItem);
			if (arc.innerExtent() != this.ring().innerExtend()) {
				arc.innerExtent(this.ring().innerExtend());
			}

			if ((arc.width() != this.ring().controlSize().width() || arc.height() != this.ring().controlSize().height()) && arc.view().ready()) {
				arc.width(this.ring().controlSize().width());
				arc.height(this.ring().controlSize().height());
				this.view().updateArcSize(arc);
				areResized = true;
			}

			if (arc.startAngle() != arcItem.startAngle()) {
				arc.startAngle(arcItem.startAngle());
			}

			if (arc.endAngle() != arcItem.endAngle()) {
				arc.endAngle(arcItem.endAngle());
			}

			if (arc.itemsSource() != arcItem.itemSource()) {
				arc.itemsSource(arcItem.itemSource());
			}

			if (arc.brushes() != arcItem.brushes()) {
				arc.brushes(arcItem.brushes());
			}

			this.view().positionArc(arc, 0, 0);
			index++;
		}

		this._arcs.count(index);
		return areResized;
	}

	, 
	provideContainer: function (container) {
		this.view().provideContainer(container);
	}

	, 
	onContainerResized: function () {
		this.view().onContainerResized();
	}

	, 
	getContainer: function () {
		return this.view().getContainer();
	}
	, 
	$type: new $.ig.Type('RingControl', $.ig.Control.prototype.$type, [$.ig.INotifyPropertyChanged.prototype.$type])
}, true);

$.ig.util.defType('RingControlView', 'Object', {

	_model: null,
	model: function (value) {
		if (arguments.length === 1) {
			this._model = value;
			return value;
		} else {
			return this._model;
		}
	}
	, 
	init: function (model) {


		this.__allArcs = new $.ig.List$1($.ig.Arc.prototype.$type, 0);
		this.__visibleArcs = new $.ig.List$1($.ig.Arc.prototype.$type, 0);
		this.__arcDivs = new $.ig.Dictionary$2($.ig.Arc.prototype.$type, $.ig.JQueryObject.prototype.$type, 0);
		this.__owningSeries = null;

		$.ig.Object.prototype.init.call(this);
			this.model(model);
	}
	, 
	__allArcs: null
	, 
	__visibleArcs: null

	, 
	arcCreate: function () {
		var arc = new $.ig.Arc();
		arc.canvasTop(0);
		arc.canvasLeft(0);
		arc.ring(this.model().ring());
		this.__allArcs.add(arc);
		this.setupArc(arc);
		arc.labelExtent(this.model().series().labelExtent());
		arc.formatLabel(this.model().series().formatLabel());
		arc.labelMemberPath(this.model().series().labelMemberPath());
		arc.labelsPosition(this.model().series().labelsPosition());
		arc.labelTemplate(this.model().series().labelTemplate());
		arc.valueMemberPath(this.model().series().valueMemberPath());
		if (this.model().series().toolTip() != null) {
		arc.toolTip(this.model().series().toolTip());
		}

		arc.leaderLineVisibility(this.model().series().leaderLineVisibility());
		arc.leaderLineStyle(this.model().series().leaderLineStyle());
		arc.leaderLineType(this.model().series().leaderLineType());
		arc.leaderLineMargin(this.model().series().leaderLineMargin());
		arc.othersCategoryThreshold(this.model().series().othersCategoryThreshold());
		arc.othersCategoryType(this.model().series().othersCategoryType());
		arc.othersCategoryText(this.model().series().othersCategoryText());
		arc.othersCategoryStyle(this.model().series().othersCategoryStyle());
		arc.legend(this.model().series().legend());
		arc.legendItemTemplate(this.model().series().legendItemTemplate());
		arc.legendItemBadgeTemplate(this.model().series().legendItemBadgeTemplate());
		arc.outlines(this.model().series().outlines());
		arc.startAngle(this.model().series().startAngle());
		arc.brushes(this.model().series().brushes());
		arc.selectedStyle(this.model().series().selectedStyleResolved());
		arc.isSurfaceInteractionDisabled(true);
		arc.radiusFactor(this.model().series().radiusFactor());
		return arc;
	}

	, 
	arcActivate: function (arc) {
		var div = this.__arcDivs.item(arc);
		if (div != null) {
			div.show();
		}

		this.__visibleArcs.add(arc);
	}

	, 
	arcDisactivate: function (arc) {
		var div = this.__arcDivs.item(arc);
		if (div != null) {
			div.hide();
		}

		this.__visibleArcs.remove(arc);
	}

	, 
	arcDestroy: function (arc) {
		this.destroyArc(arc);
		this.__allArcs.remove(arc);
	}

	, 
	arcs: function () {
		return this.__allArcs;
	}

	, 
	onInit: function () {
	}

	, 
	sizeUpdated: function () {
		this.model().onSizeUpdated();
	}

	, 
	positionArc: function (arc, x, y) {
		x = x + this.model().canvasLeft();
		y = y + this.model().canvasTop();
		if (this.__owningSeries != null) {
			x = x + this.__owningSeries.canvasLeft();
			y = y + this.__owningSeries.canvasTop();
		}

		if (arc.canvasLeft() != x || arc.canvasTop() != y) {
			arc.canvasLeft(x);
			arc.canvasTop(y);
			this.positionDiv(arc, this.__arcDivs.item(arc));
		}

	}

	, 
	_container: null,
	container: function (value) {
		if (arguments.length === 1) {
			this._container = value;
			return value;
		} else {
			return this._container;
		}
	}

	, 
	provideContainer: function (container) {
		if (container == null) {
			this.model()._arcs.count(0);
			this.__allArcs.clear();
			this.__arcDivs.clear();
			this.__visibleArcs.clear();
			return;
		}

		this.container($(container));
		this.container().css("position", "relative");
		var en = this.__allArcs.getEnumerator();
		while (en.moveNext()) {
			var arc = en.current();
			var div = this.__arcDivs.item(arc);
			this.container().append(div);
			arc.arcView().updateFont();
		}

	}
	, 
	__arcDivs: null

	, 
	setupArc: function (arc) {
		var arcDiv = $("<div style=\"position : absolute;\" />");
		this.__arcDivs.add(arc, arcDiv);
		this.adjustDiv(arc, arcDiv);
		this.positionDiv(arc, arcDiv);
		if (this.container() != null) {
			this.container().append(arcDiv);
		}

		arc.provideContainer(arcDiv);
		arcDiv.css("position", "absolute");
		arcDiv.removeClass("ui-corner-all ui-widget-content");
	}

	, 
	adjustDiv: function (arc, arcDiv) {
		arcDiv.css("width", arc.width().toString());
		arcDiv.css("height", arc.height().toString());
	}

	, 
	positionDiv: function (arc, arcDiv) {
		arcDiv.css("top", arc.canvasTop().toString() + "px");
		arcDiv.css("left", arc.canvasLeft().toString() + "px");
	}

	, 
	destroyArc: function (arc) {
		var div = this.__arcDivs.item(arc);
		div.remove();
		this.__arcDivs.remove(arc);
		arc.provideContainer(null);
	}

	, 
	updateArcSize: function (arc) {
		this.adjustDiv(arc, arc.getContainer());
		arc.onContainerResized(arc.width(), arc.height());
	}

	, 
	isReady: function () {
		return true;
	}

	, 
	onContainerResized: function () {
	}
	, 
	__owningSeries: null

	, 
	onSeriesProvided: function (ringSeriesBase) {
		this.__owningSeries = ringSeriesBase;
		if (ringSeriesBase != null) {
		ringSeriesBase.propertyUpdated = $.ig.Delegate.prototype.combine(ringSeriesBase.propertyUpdated, this.ringSeriesBase_PropertyUpdated.runOn(this));
		}

	}

	, 
	ringSeriesBase_PropertyUpdated: function (sender, e) {
		switch (e.propertyName()) {
			case "LabelExtent":
				for (var i = 0; i < this.__allArcs.count(); i++) {
					this.__allArcs.__inner[i].labelExtent(e.newValue());
				}

				break;
			case "LabelMemberPath":
				for (var i1 = 0; i1 < this.__allArcs.count(); i1++) {
					this.__allArcs.__inner[i1].labelMemberPath(e.newValue());
				}

				break;
			case "LabelsPosition":
				for (var i2 = 0; i2 < this.__allArcs.count(); i2++) {
					this.__allArcs.__inner[i2].labelsPosition($.ig.util.getEnumValue(e.newValue()));
				}

				break;
			case "LabelTemplate":
				for (var i3 = 0; i3 < this.__allArcs.count(); i3++) {
					this.__allArcs.__inner[i3].labelTemplate(e.newValue());
				}

				break;
			case "ValueMemberPath":
				for (var i4 = 0; i4 < this.__allArcs.count(); i4++) {
					this.__allArcs.__inner[i4].valueMemberPath(e.newValue());
				}

				break;
			case "ToolTip":
				for (var i5 = 0; i5 < this.__allArcs.count(); i5++) {
					this.__allArcs.__inner[i5].toolTip(e.newValue());
				}

				break;
			case "LeaderLineVisibility":
				for (var i6 = 0; i6 < this.__allArcs.count(); i6++) {
					this.__allArcs.__inner[i6].leaderLineVisibility($.ig.util.getEnumValue(e.newValue()));
				}

				break;
			case "LeaderLineStyle":
				for (var i7 = 0; i7 < this.__allArcs.count(); i7++) {
					this.__allArcs.__inner[i7].leaderLineStyle(e.newValue());
				}

				break;
			case "LeaderLineType":
				for (var i8 = 0; i8 < this.__allArcs.count(); i8++) {
					this.__allArcs.__inner[i8].leaderLineType($.ig.util.getEnumValue(e.newValue()));
				}

				break;
			case "LeaderLineMargin":
				for (var i9 = 0; i9 < this.__allArcs.count(); i9++) {
					this.__allArcs.__inner[i9].leaderLineMargin(e.newValue());
				}

				break;
			case "OthersCategoryThreshold":
				for (var i10 = 0; i10 < this.__allArcs.count(); i10++) {
					this.__allArcs.__inner[i10].othersCategoryThreshold(e.newValue());
				}

				break;
			case "OthersCategoryType":
				for (var i11 = 0; i11 < this.__allArcs.count(); i11++) {
					this.__allArcs.__inner[i11].othersCategoryType($.ig.util.getEnumValue(e.newValue()));
				}

				break;
			case "OthersCategoryText":
				for (var i12 = 0; i12 < this.__allArcs.count(); i12++) {
					this.__allArcs.__inner[i12].othersCategoryText(e.newValue());
				}

				break;
			case "OthersCategoryStyle":
				for (var i13 = 0; i13 < this.__allArcs.count(); i13++) {
					this.__allArcs.__inner[i13].othersCategoryStyle(e.newValue());
				}

				break;
			case "Legend":
				for (var i14 = 0; i14 < this.__allArcs.count(); i14++) {
					this.__allArcs.__inner[i14].legend(e.newValue());
				}

				break;
			case "LegendItemTemplate":
				for (var i15 = 0; i15 < this.__allArcs.count(); i15++) {
					this.__allArcs.__inner[i15].legendItemTemplate(e.newValue());
				}

				break;
			case "LegendItemBadgeTemplate":
				for (var i16 = 0; i16 < this.__allArcs.count(); i16++) {
					this.__allArcs.__inner[i16].legendItemBadgeTemplate(e.newValue());
				}

				break;
			case "Outlines":
				for (var i17 = 0; i17 < this.__allArcs.count(); i17++) {
					this.__allArcs.__inner[i17].outlines(e.newValue());
				}

				break;
			case "Brushes":
				for (var i18 = 0; i18 < this.__allArcs.count(); i18++) {
					this.__allArcs.__inner[i18].brushes(e.newValue());
				}

				break;
			case "SelectedStyle":
				for (var i19 = 0; i19 < this.__allArcs.count(); i19++) {
					this.__allArcs.__inner[i19].selectedStyle(e.newValue());
				}

				break;
			case "SelectedStyleResolved":
				for (var i20 = 0; i20 < this.__allArcs.count(); i20++) {
					this.__allArcs.__inner[i20].selectedStyle(e.newValue());
				}

				break;
			case "RadiusFactor":
				for (var i21 = 0; i21 < this.__allArcs.count(); i21++) {
					this.__allArcs.__inner[i21].radiusFactor(e.newValue());
				}

				break;
		}

	}

	, 
	onArcsResized: function () {
		var en = this.__allArcs.getEnumerator();
		while (en.moveNext()) {
			var arc = en.current();
			arc.flush();
		}

	}

	, 
	getContainer: function () {
		return this.container();
	}

	, 
	positionRingControl: function (x, y) {
		this.model().canvasLeft(x);
		this.model().canvasTop(y);
		this.repositionArcs();
	}

	, 
	repositionArcs: function () {
		for (var i = 0; i < this.__allArcs.count(); i++) {
			var arc = this.__allArcs.__inner[i];
			this.positionArc(arc, 0, 0);
		}

	}
	, 
	$type: new $.ig.Type('RingControlView', $.ig.Object.prototype.$type)
}, true);


$.ig.util.defType('RingSeriesBaseView', 'Object', {

	_model: null,
	model: function (value) {
		if (arguments.length === 1) {
			this._model = value;
			return value;
		} else {
			return this._model;
		}
	}
	, 
	init: function (model) {



		$.ig.Object.prototype.init.call(this);
			this.attachedRings(new $.ig.List$1($.ig.RingControl.prototype.$type, 0));
			this.model(model);
	}

	, 
	onInit: function () {
		var $self = this;
		$self.model().legendItemTemplate((function () { var $ret = new $.ig.DataTemplate();
		$ret.render($.ig.LegendTemplates.prototype.doughnutLegendItemRender);
		$ret.measure($.ig.LegendTemplates.prototype.defaultLegendItemMeasure); return $ret;}()));
		$self.model().legendItemBadgeTemplate((function () { var $ret = new $.ig.DataTemplate();
		$ret.render($.ig.LegendTemplates.prototype.doughnutBadgeTemplate);
		$ret.measure($.ig.LegendTemplates.prototype.legendItemBadgeMeasure); return $ret;}()));
	}

	, 
	_attachedRings: null,
	attachedRings: function (value) {
		if (arguments.length === 1) {
			this._attachedRings = value;
			return value;
		} else {
			return this._attachedRings;
		}
	}

	, 
	addRing: function (ringControl) {
		if (!this.attachedRings().contains(ringControl)) {
			this.attachedRings().add(ringControl);
		}

		if (this.container() != null && (ringControl.getContainer() != this.container())) {
			ringControl.provideContainer(this.container());
		}

	}

	, 
	_container: null,
	container: function (value) {
		if (arguments.length === 1) {
			this._container = value;
			return value;
		} else {
			return this._container;
		}
	}

	, 
	getDefaultStyle: function (container, brushes, outlines, fontBrush, font) {
		var $self = this;
		(function () { var $ret = $.ig.BrushUtil.prototype.getBrushCollection("chart", container, brushes, outlines, null); brushes = $ret.p2; outlines = $ret.p3; return $ret.ret; }());
		fontBrush = new $.ig.Brush();
		fontBrush.__fill = $self.container().css("color");
		font = $.ig.FontUtil.prototype.getFont(container);
		return {
			p1: brushes, 
			p2: outlines, 
			p3: fontBrush, 
			p4: font
		};
	}
	, 
	__brushes: null
	, 
	__outlines: null
	, 
	__fontBrush: null
	, 
	__font: null

	, 
	provideContainer: function (container) {
		var $self = this;
		if (container == null) {
			var en = $self.attachedRings().getEnumerator();
			while (en.moveNext()) {
				var ring = en.current();
				ring.provideContainer(null);
			}

			return;
		}

		$self.container($(container));
		var brushes;
		var outlines;
		var fontBrush;
		var font;
		(function () { var $ret = $self.getDefaultStyle($self.container(), brushes, outlines, fontBrush, font); brushes = $ret.p1; outlines = $ret.p2; fontBrush = $ret.p3; font = $ret.p4; return $ret.ret; }());
		$self.__brushes = brushes;
		$self.__outlines = outlines;
		$self.__fontBrush = fontBrush;
		$self.__font = font;
		if ($self.model().brushes() == null) {
			$self.model().brushes($self.__brushes);
		}

		if ($self.model().outlines() == null) {
			$self.model().outlines($self.__outlines);
		}

		var en1 = $self.attachedRings().getEnumerator();
		while (en1.moveNext()) {
			var ring1 = en1.current();
			ring1.provideContainer($self.container());
		}

	}

	, 
	isReady: function () {
		return true;
	}

	, 
	clearView: function () {
		this.provideContainer(null);
	}

	, 
	onSizeChanged: function () {
		for (var i = 0; i < this.attachedRings().count(); i++) {
			var currRing = this.attachedRings().__inner[i];
			for (var j = 0; j < currRing._arcs.active().count(); j++) {
				var arc = currRing._arcs.active().__inner[j];
				arc.flush();
			}

		}

	}

	, 
	positionSeries: function (x, y) {
		this.model().canvasLeft(x);
		this.model().canvasTop(y);
		this.model().location({__x: x, __y: y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
	}
	, 
	$type: new $.ig.Type('RingSeriesBaseView', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('RingSeriesCollection', 'ObservableCollection$1', {
	init: function () {


		$.ig.ObservableCollection$1.prototype.init.call(this, $.ig.RingSeriesBase.prototype.$type, 0);

	}, 
	$type: new $.ig.Type('RingSeriesCollection', $.ig.ObservableCollection$1.prototype.$type.specialize($.ig.RingSeriesBase.prototype.$type))
}, true);

$.ig.util.defType('SliceItem', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
	}

	, 
	_startAngle: 0,
	startAngle: function (value) {
		if (arguments.length === 1) {
			this._startAngle = value;
			return value;
		} else {
			return this._startAngle;
		}
	}

	, 
	_endAngle: 0,
	endAngle: function (value) {
		if (arguments.length === 1) {
			this._endAngle = value;
			return value;
		} else {
			return this._endAngle;
		}
	}

	, 
	_arcItem: null,
	arcItem: function (value) {
		if (arguments.length === 1) {
			this._arcItem = value;
			return value;
		} else {
			return this._arcItem;
		}
	}

	, 
	_index: 0,
	index: function (value) {
		if (arguments.length === 1) {
			this._index = value;
			return value;
		} else {
			return this._index;
		}
	}

	, 
	_slice: null,
	slice: function (value) {
		if (arguments.length === 1) {
			this._slice = value;
			return value;
		} else {
			return this._slice;
		}
	}

	, 
	_data: null,
	data: function (value) {
		if (arguments.length === 1) {
			this._data = value;
			return value;
		} else {
			return this._data;
		}
	}

	, 
	_isOther: false,
	isOther: function (value) {
		if (arguments.length === 1) {
			this._isOther = value;
			return value;
		} else {
			return this._isOther;
		}
	}
	, 
	$type: new $.ig.Type('SliceItem', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('SliceCollection', 'ObservableCollection$1', {
	init: function () {


		$.ig.ObservableCollection$1.prototype.init.call(this, $.ig.SliceItem.prototype.$type, 0);

	}
	, 
	_isAttached: false,
	isAttached: function (value) {
		if (arguments.length === 1) {
			this._isAttached = value;
			return value;
		} else {
			return this._isAttached;
		}
	}

	, 
	_useForSelection: false,
	useForSelection: function (value) {
		if (arguments.length === 1) {
			this._useForSelection = value;
			return value;
		} else {
			return this._useForSelection;
		}
	}

	, 
	insertItem: function (index, item) {
		if (this.contains(item)) {
			return;
		}

		var sliceItemIndex = this.findSliceItemIndexBySlice(item.slice());
		if (sliceItemIndex != -1) {
			$.ig.ObservableCollection$1.prototype.setItem.call(this, sliceItemIndex, item);

		} else {
			$.ig.ObservableCollection$1.prototype.insertItem.call(this, index, item);
			if (this.isAttached()) {
				if (this.useForSelection()) {
					item.slice().isSelected(true);

				} else {
					item.slice().isExploded(true);
				}

			}

		}

	}

	, 
	setItem: function (index, item) {
		if (this.isAttached()) {
			if (this.useForSelection()) {
				this.__inner[index].slice().isSelected(false);

			} else {
				this.__inner[index].slice().isExploded(false);
			}

		}

		$.ig.ObservableCollection$1.prototype.setItem.call(this, index, item);
	}

	, 
	removeItem: function (index) {
		var sliceItem = this.__inner[index];
		$.ig.ObservableCollection$1.prototype.removeItem.call(this, index);
		if (this.isAttached()) {
			if (this.useForSelection()) {
				sliceItem.slice().isSelected(false);

			} else {
				sliceItem.slice().isExploded(false);
			}

		}

	}

	, 
	remove: function (item) {
		var sliceItemIndex = this.findSliceItemIndexBySlice(item.slice());
		if (sliceItemIndex != -1) {
			this.removeItem(sliceItemIndex);
			return true;

		} else {
			return false;
		}

	}

	, 
	clearItems: function () {
		while (this.count() > 0) {
			this.removeItem(0);

		}
	}

	, 
	findSliceItemIndexBySlice: function (slice) {
		for (var i = 0; i < this.count(); i++) {
			if (this.__inner[i].slice() == slice) {
				return i;
			}

		}

		return -1;
	}
	, 
	$type: new $.ig.Type('SliceCollection', $.ig.ObservableCollection$1.prototype.$type.specialize($.ig.SliceItem.prototype.$type))
}, true);

$.ig.util.defType('XamDoughnutChart', 'Control', {
	__series: null
	, 
	__rings: null
	, 
	__selectedSlices: null
	, 
	__explodedSlices: null
	, 
	__propertyUpdatedOverride: null
	, 
	init: function () {


		this.__series = new $.ig.RingSeriesCollection();
		this.__rings = new $.ig.RingCollection();
		this.__selectedSlices = (function () { var $ret = new $.ig.SliceCollection();
		$ret.isAttached(true);
		$ret.useForSelection(true); return $ret;}());
		this.__explodedSlices = (function () { var $ret = new $.ig.SliceCollection();
		$ret.isAttached(true);
		$ret.useForSelection(false); return $ret;}());

		var $self = this;
		$.ig.Control.prototype.init.call(this);
			var view = this.createView();
			this.onViewCreated(view);
			view.onInit();
			this.defaultStyleKey($.ig.XamDoughnutChart.prototype.$type);
			this.__propertyUpdatedOverride = function (o, e) {
				$self.propertyUpdatedOverride(o, e.propertyName(), e.oldValue(), e.newValue());
			};
			this.propertyUpdated = $.ig.Delegate.prototype.combine(this.propertyUpdated, this.__propertyUpdatedOverride);
			this.series().collectionChanged = $.ig.Delegate.prototype.combine(this.series().collectionChanged, this.series_CollectionChanged.runOn(this));
			var nullValue = $.ig.util.toNullable($.ig.Boolean.prototype.$type, null);
			this.isSurfaceInteractionDisabled(nullValue);
	}

	, 
	rings: function () {

			return this.__rings;
	}

	, 
	allowSliceSelection: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.XamDoughnutChart.prototype.allowSliceSelectionProperty, value);
			return value;
		} else {

			return this.getValue($.ig.XamDoughnutChart.prototype.allowSliceSelectionProperty);
		}
	}

	, 
	isSurfaceInteractionDisabled: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.XamDoughnutChart.prototype.isSurfaceInteractionDisabledProperty, value);
			return value;
		} else {

			return this.getValue($.ig.XamDoughnutChart.prototype.isSurfaceInteractionDisabledProperty);
		}
	}

	, 
	allowSliceExplosion: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.XamDoughnutChart.prototype.allowSliceExplosionProperty, value);
			return value;
		} else {

			return this.getValue($.ig.XamDoughnutChart.prototype.allowSliceExplosionProperty);
		}
	}

	, 
	series: function () {

			return this.__series;
	}

	, 
	series_CollectionChanged: function (sender, e) {
		var removed = new $.ig.List$1($.ig.RingSeriesBase.prototype.$type, 0);
		if (e.oldItems() != null) {
			var en = e.oldItems().getEnumerator();
			while (en.moveNext()) {
				var item = en.current();
				if (e.newItems() == null || !e.newItems().contains(item)) {
					(item).clearView();
					this.view().removeSeries(item);
				}

			}

		}

		this.prepareRingCollection();
		this.renderChart();
	}

	, 
	innerExtent: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.XamDoughnutChart.prototype.innerExtentProperty, value);
			return value;
		} else {

			return this.getValue($.ig.XamDoughnutChart.prototype.innerExtentProperty);
		}
	}

	, 
	selectedSlices: function (value) {
		if (arguments.length === 1) {

			this.__selectedSlices.clear();
			this.__selectedSlices.isAttached(false);
			this.__selectedSlices = value;
			this.__selectedSlices.isAttached(true);
			this.__selectedSlices.useForSelection(true);
			for (var i = 0; i < this.__selectedSlices.count(); i++) {
				this.__selectedSlices.__inner[i].slice().isSelected(true);
			}

			return value;
		} else {

			return this.__selectedSlices;
		}
	}

	, 
	explodedSlices: function (value) {
		if (arguments.length === 1) {

			this.__explodedSlices.clear();
			this.__explodedSlices.isAttached(false);
			this.__explodedSlices = value;
			this.__explodedSlices.isAttached(true);
			this.__explodedSlices.useForSelection(false);
			for (var i = 0; i < this.__explodedSlices.count(); i++) {
				this.__explodedSlices.__inner[i].slice().isExploded(true);
			}

			return value;
		} else {

			return this.__explodedSlices;
		}
	}

	, 
	selectedStyle: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.XamDoughnutChart.prototype.selectedStyleProperty, value);
			return value;
		} else {

			return this.getValue($.ig.XamDoughnutChart.prototype.selectedStyleProperty);
		}
	}

	, 
	centerData: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.XamDoughnutChart.prototype.centerDataProperty, value);
			return value;
		} else {

			return this.getValue($.ig.XamDoughnutChart.prototype.centerDataProperty);
		}
	}

	, 
	centerDataTemplate: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.XamDoughnutChart.prototype.centerDataTemplateProperty, value);
			return value;
		} else {

			return this.getValue($.ig.XamDoughnutChart.prototype.centerDataTemplateProperty);
		}
	}

	, 
	_view: null,
	view: function (value) {
		if (arguments.length === 1) {
			this._view = value;
			return value;
		} else {
			return this._view;
		}
	}

	, 
	selectSlice: function (slice, shouldSelect) {
		if (shouldSelect) {
			this.selectedSlices().add(slice);

		} else {
			this.selectedSlices().remove(slice);
		}

	}

	, 
	explodeSlice: function (slice, explode) {
		if (explode) {
			this.explodedSlices().add(slice);

		} else {
			this.explodedSlices().remove(slice);
		}

	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		switch (propertyName) {
			case $.ig.XamDoughnutChart.prototype.selectedStylePropertyName:
				var en = this.series().getEnumerator();
				while (en.moveNext()) {
					var series = en.current();
					series.selectedStyleResolved(newValue);
				}

				break;
			case $.ig.XamDoughnutChart.prototype.allowSliceExplosionPropertyName:
				for (var i = 0; i < this.__rings.count(); i++) {
					var en1 = this.__rings.__inner[i].ringControl()._arcs.active().getEnumerator();
					while (en1.moveNext()) {
						var arc = en1.current();
						arc.allowSliceExplosion(this.allowSliceExplosion());
					}

				}

				break;
			case $.ig.XamDoughnutChart.prototype.allowSliceSelectionPropertyName:
				for (var i1 = 0; i1 < this.__rings.count(); i1++) {
					var en2 = this.__rings.__inner[i1].ringControl()._arcs.active().getEnumerator();
					while (en2.moveNext()) {
						var arc1 = en2.current();
						arc1.allowSliceSelection(this.allowSliceSelection());
					}

				}

				break;
		}

	}

	, 
	createView: function () {
		return new $.ig.XamDoughnutChartView(this);
	}

	, 
	onViewCreated: function (view) {
		this.view(view);
	}

	, 
	renderChart: function () {
		this.prepareRings();
		this.renderSeries();
		this.renderRings();
		this.prepareCenterPresenter();
		this.view().updateView();
	}

	, 
	renderSeries: function () {
		var en = this.series().getEnumerator();
		while (en.moveNext()) {
			var series = en.current();
			series.renderSeries();
		}

	}

	, 
	prepareCenterPresenter: function () {
		var viewport = this.view().viewport();
		if (viewport.isEmpty() || viewport.width() == 0 || viewport.height() == 0) {
			return;
		}

		var centerPoint = {__x: viewport.width() / 2, __y: viewport.height() / 2, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		var breadth = Math.min(viewport.width() / 2, viewport.height() / 2);
		var innerSeriesRadiusFactor = 0.9;
		if (this.series().count() > 0) {
			innerSeriesRadiusFactor = this.series().__inner[0].radiusFactor();
			if ($.ig.util.isNaN(innerSeriesRadiusFactor) || Number.isInfinity(innerSeriesRadiusFactor) || innerSeriesRadiusFactor < 0) {
			innerSeriesRadiusFactor = 0;

			} else if (innerSeriesRadiusFactor > 1) {
			innerSeriesRadiusFactor = 1;
			}


		}

		var initialOffset = this.innerExtent() * breadth / 100 * innerSeriesRadiusFactor;
		this.view().setCenterPresenterSize(initialOffset * 2, initialOffset * 2);
		this.view().positonCenterPresenter(centerPoint.__x - initialOffset, centerPoint.__y - initialOffset);
	}

	, 
	renderRings: function () {
		var sizeChanged = false;
		var en = this.__rings.getEnumerator();
		while (en.moveNext()) {
			var ring = en.current();
			if (ring.renderArcs()) {
				sizeChanged = true;
			}

		}

		if (sizeChanged) {
			var en1 = this.__rings.getEnumerator();
			while (en1.moveNext()) {
				var ring1 = en1.current();
				ring1.ringSeries().view().onSizeChanged();
			}

		}

	}

	, 
	prepareRings: function () {
		var viewport = this.view().viewport();
		if (viewport.isEmpty() || viewport.width() == 0 || viewport.height() == 0) {
			return;
		}

		var centerPoint = {__x: viewport.width() / 2, __y: viewport.height() / 2, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		var widthBreadth = Math.min(viewport.width() / 2, viewport.height() / 2);
		var heightBreadth = Math.max(viewport.width() / 2, viewport.height() / 2);
		if (viewport.width() > viewport.height()) {
			widthBreadth = widthBreadth + heightBreadth;
			heightBreadth = widthBreadth - heightBreadth;
			widthBreadth = widthBreadth - heightBreadth;
		}

		var seriesWidthBreadth = ((100 - this.innerExtent()) / 100 * widthBreadth) / this.__rings.count();
		var seriesHeightBreadth = ((100 - this.innerExtent()) / 100 * heightBreadth) / this.__rings.count();
		var initialWidthOffset = this.innerExtent() * widthBreadth / 100;
		var initialHeightOffset = this.innerExtent() * heightBreadth / 100;
		var index = 1;
		var en = this.__rings.getEnumerator();
		while (en.moveNext()) {
			var ring = en.current();
			var halfWidth = (initialWidthOffset + (seriesWidthBreadth * index));
			var halfHeight = (initialHeightOffset + (seriesHeightBreadth * index));
			ring.ringBreadth(seriesWidthBreadth);
			ring.controlSize(new $.ig.Size(1, halfWidth * 2, halfHeight * 2));
			ring.center({__x: centerPoint.__x - halfWidth, __y: centerPoint.__y - halfHeight, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			ring.innerExtend(100 - (seriesWidthBreadth / halfWidth * 100));
			ring.prepareArcs();
			index++;
		}

	}

	, 
	prepareRingCollection: function () {
		this.explodedSlices().clear();
		this.selectedSlices().clear();
		this.__rings.clear();
		this.view().ensureCenterPresenter();
		var index = 0;
		for (var i = 0; i < this.series().count(); i++) {
			var series = this.series().__inner[i];
			series.chart(this);
			this.view().addSeries(series);
			var seriesRings = series.analyzeRings();
			var en = seriesRings.getEnumerator();
			while (en.moveNext()) {
				var ring = en.current();
				ring.owner(this);
				ring.index(index);
				this.__rings.add(ring);
				index++;
			}

		}

	}

	, 
	onSizeUpdated: function () {
		this.renderChart();
	}
	, 
	sliceClick: null
	, 
	onSliceClick: function (sender, e) {
		if (this.isSurfaceInteractionDisabled().hasValue() && this.isSurfaceInteractionDisabled().value()) {
			var arc = sender;
			var ringSeries = arc.ring().ringSeries();
			if (ringSeries.isSurfaceInteractionDisabled().hasValue()) {
				if (ringSeries.isSurfaceInteractionDisabled().value()) {
					return;
				}


			} else {
				return;
			}

		}

		if (this.sliceClick != null) {
			this.sliceClick(sender, e);
		}

	}
	, 
	propertyChanged: null, 
	propertyUpdated: null
	, 
	raisePropertyChanged: function (name, oldValue, newValue) {
		if (this.propertyChanged != null) {
			this.propertyChanged(this, new $.ig.PropertyChangedEventArgs(name));
		}

		if (this.propertyUpdated != null) {
			this.propertyUpdated(this, new $.ig.PropertyUpdatedEventArgs(name, oldValue, newValue));
		}

	}

	, 
	provideContainer: function (container) {
		this.view().provideContainer(container);
	}

	, 
	notifyResized: function () {
		this.view().sizeUpdated();
	}

	, 
	getContainerID: function () {
		return this.view().getContainerID();
	}

	, 
	getCenterCoordinates: function () {
		return this.view().centerCoordinates();
	}

	, 
	getHoleRadius: function () {
		return this.view().holeRadius();
	}

	, 
	flush: function () {
		var arcs;
		var rings;
		for (var i = 0; i < this.series().count(); i++) {
			rings = this.series().__inner[i].analyzeRings();
			for (var j = 0; j < rings.count(); j++) {
				arcs = rings.__inner[j].ringControl().view().arcs();
				for (var k = 0; k < arcs.count(); k++) {
					arcs.__inner[k].flush();
				}

			}

		}

	}
	, 
	holeDimensionsChanged: null
	, 
	onHoleDimensionsChanged: function () {
		if (this.holeDimensionsChanged != null) {
			this.holeDimensionsChanged(this, new $.ig.HoleDimensionsChangedEventArgs(this.getCenterCoordinates(), this.getHoleRadius()));
		}

	}

	, 
	exportVisualData: function () {
		var visualData = new $.ig.DoughnutChartVisualData();
		visualData.series(new $.ig.RingSeriesVisualDataList());
		visualData.viewport(this.view().viewport());
		this.view().exportViewShapes(visualData);
		return visualData;
	}
	, 
	$type: new $.ig.Type('XamDoughnutChart', $.ig.Control.prototype.$type, [$.ig.INotifyPropertyChanged.prototype.$type])
}, true);

$.ig.util.defType('XamDoughnutChartView', 'Object', {

	_model: null,
	model: function (value) {
		if (arguments.length === 1) {
			this._model = value;
			return value;
		} else {
			return this._model;
		}
	}

	, 
	_centerCoordinates: null,
	centerCoordinates: function (value) {
		if (arguments.length === 1) {
			this._centerCoordinates = value;
			return value;
		} else {
			return this._centerCoordinates;
		}
	}

	, 
	_holeRadius: 0,
	holeRadius: function (value) {
		if (arguments.length === 1) {
			this._holeRadius = value;
			return value;
		} else {
			return this._holeRadius;
		}
	}
	, 
	init: function (model) {



		$.ig.Object.prototype.init.call(this);
			this.viewport($.ig.Rect.prototype.empty());
			this.centerCoordinates({__x: 0, __y: 0, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			this.holeRadius(0);
			this.attachedSeries(new $.ig.List$1($.ig.RingSeriesBase.prototype.$type, 0));
			this.model(model);
	}

	, 
	onInit: function () {
	}

	, 
	updateView: function () {
	}

	, 
	_attachedSeries: null,
	attachedSeries: function (value) {
		if (arguments.length === 1) {
			this._attachedSeries = value;
			return value;
		} else {
			return this._attachedSeries;
		}
	}

	, 
	addSeries: function (series) {
		if (!this.attachedSeries().contains(series)) {
			series.provideContainer(this.container());
			this.attachedSeries().add(series);
		}

	}

	, 
	removeSeries: function (series) {
		if (this.attachedSeries().contains(series)) {
			series.provideContainer(null);
			this.attachedSeries().remove(series);
		}

	}

	, 
	_viewport: null,
	viewport: function (value) {
		if (arguments.length === 1) {
			this._viewport = value;
			return value;
		} else {
			return this._viewport;
		}
	}

	, 
	sizeUpdated: function () {
		if (this.container() == null) {
			return;
		}

		var width = this.container().width();
		var height = this.container().height();
		this.viewport(new $.ig.Rect(0, 0, 0, width, height));
		if (this.eventProxy() != null) {
			this.eventProxy().viewport(this.viewport());
		}

		this.model().onSizeUpdated();
	}

	, 
	_canvas: null,
	canvas: function (value) {
		if (arguments.length === 1) {
			this._canvas = value;
			return value;
		} else {
			return this._canvas;
		}
	}

	, 
	_container: null,
	container: function (value) {
		if (arguments.length === 1) {
			this._container = value;
			return value;
		} else {
			return this._container;
		}
	}

	, 
	_eventProxy: null,
	eventProxy: function (value) {
		if (arguments.length === 1) {
			this._eventProxy = value;
			return value;
		} else {
			return this._eventProxy;
		}
	}

	, 
	provideContainer: function (container) {
		var cont = $(container);
		this.container(cont);
		var width = this.container().width();
		var height = this.container().height();
		this.viewport(new $.ig.Rect(0, 0, 0, width, height));
		this.eventProxy(new $.ig.DOMEventProxy(this.container()));
		this.eventProxy().viewport(this.viewport());
		this.eventProxy().onMouseOver = $.ig.Delegate.prototype.combine(this.eventProxy().onMouseOver, this.eventProxy_OnMouseOver.runOn(this));
		this.eventProxy().onMouseLeave = $.ig.Delegate.prototype.combine(this.eventProxy().onMouseLeave, this.eventProxy_OnMouseLeave.runOn(this));
		this.eventProxy().onMouseDown = $.ig.Delegate.prototype.combine(this.eventProxy().onMouseDown, this.eventProxy_OnMouseDown.runOn(this));
		this.eventProxy().onMouseUp = $.ig.Delegate.prototype.combine(this.eventProxy().onMouseUp, this.eventProxy_OnMouseUp.runOn(this));
		this.sizeUpdated();
	}

	, 
	passArcEvent: function (point, action, eventType) {
		var nullValue = $.ig.util.toNullable($.ig.Boolean.prototype.$type, null);
		for (var i = this.attachedSeries().count() - 1; i >= 0; i--) {
			var currSeries = this.attachedSeries().__inner[i];
			if ($.ig.util.nullableEquals(currSeries.isSurfaceInteractionDisabled(), nullValue)) {
				if ($.ig.util.nullableEquals(this.model().isSurfaceInteractionDisabled(), nullValue)) {

				} else {
					if (this.model().isSurfaceInteractionDisabled().value()) {
						continue;
					}

				}


			} else {
				if (currSeries.isSurfaceInteractionDisabled().value()) {
					continue;
				}

			}

			var attachedRings = currSeries.view().attachedRings();
			for (var j = 0; j < attachedRings.count(); j++) {
				var currRing = attachedRings.__inner[j];
				var activeArcs = currRing._arcs.active();
				for (var k = 0; k < activeArcs.count(); k++) {
					var currentArc = activeArcs.__inner[k];
					var translatedPoint = {__x: point.__x - currentArc.canvasLeft(), __y: point.__y - currentArc.canvasTop(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
					action(currentArc.view(), translatedPoint);
					if (eventType == "mouseUp") {
						var activeSlice = currentArc.arcView().getActiveSlice();
						if (activeSlice != null) {
							return;
						}

					}

				}

			}

		}

	}

	, 
	eventProxy_OnMouseUp: function (point) {
		var $self = this;
		$self.passArcEvent(point, function (a, p) { a.canvasMouseUp(p); }, "mouseUp");
	}

	, 
	eventProxy_OnMouseDown: function (point) {
		var $self = this;
		$self.passArcEvent(point, function (a, p) { a.canvasMouseDown(p); }, "mouseDown");
	}

	, 
	eventProxy_OnMouseLeave: function (point) {
		var $self = this;
		$self.passArcEvent(point, function (a, p) { a.canvasMouseLeave(p); }, "mouseLeave");
	}

	, 
	eventProxy_OnMouseOver: function (point, onMouseMove, isFinger) {
		var $self = this;
		$self.passArcEvent(point, function (a, p) { a.canvasMouseMove(p, onMouseMove, isFinger); }, "mouseOver");
	}

	, 
	getContainerID: function () {
		return this.container().attr("id");
	}

	, 
	positonCenterPresenter: function (x, y) {
		if (!this.viewport().isEmpty() && this.viewport().width() != 0 && this.viewport().height() != 0) {
			var oldX = this.centerCoordinates().__x;
			var oldY = this.centerCoordinates().__y;
			this.centerCoordinates().__x = this.viewport().width() / 2;
			this.centerCoordinates().__y = this.viewport().height() / 2;
			if (this.centerCoordinates().__x != oldX || this.centerCoordinates().__y != oldY) {
				this.model().onHoleDimensionsChanged();
			}

		}

	}

	, 
	setCenterPresenterSize: function (width, height) {
		var oldRadius = this.holeRadius();
		this.holeRadius(width / 2);
		if (oldRadius != this.holeRadius()) {
			this.model().onHoleDimensionsChanged();
		}

	}

	, 
	ensureCenterPresenter: function () {
	}

	, 
	exportViewShapes: function (doughnutChart) {
		var $self = this;
		doughnutChart.width($self.model().width());
		doughnutChart.height($self.model().height());
		doughnutChart.holeRadius($self.model().getHoleRadius());
		for (var i = 0; i < $self.model().series().count(); i++) {
			doughnutChart.series().add(new $.ig.RingSeriesVisualData());
			doughnutChart.series().__inner[i].rings(new $.ig.RingVisualDataList());
			doughnutChart.series().__inner[i].name($self.model().series().__inner[i].name());
			doughnutChart.series().__inner[i].labelExtent($self.model().series().__inner[i].labelExtent());
			doughnutChart.series().__inner[i].leaderLineMargin($self.model().series().__inner[i].leaderLineMargin());
			doughnutChart.series().__inner[i].leaderLineType($.ig.LeaderLineType.prototype.getName($self.model().series().__inner[i].leaderLineType()));
			doughnutChart.series().__inner[i].labelsPosition($.ig.LabelsPosition.prototype.getName($self.model().series().__inner[i].labelsPosition()));
			doughnutChart.series().__inner[i].leaderLineVisibility($self.model().series().__inner[i].leaderLineVisibility());
			for (var j = 0; j < $self.model().series().__inner[i].analyzeRings().count(); j++) {
				doughnutChart.series().__inner[i].rings().add(new $.ig.RingVisualData());
				doughnutChart.series().__inner[i].rings().__inner[j].arcs(new $.ig.ArcVisualDataList());
				for (var k = 0; k < $self.model().series().__inner[i].analyzeRings().__inner[j].arcItems().count(); k++) {
					doughnutChart.series().__inner[i].rings().__inner[j].arcs().add(new $.ig.ArcVisualData());
					doughnutChart.series().__inner[i].rings().__inner[j].arcs().__inner[k].slices(new $.ig.SliceVisualDataList());
					for (var m = 0; m < $self.model().series().__inner[i].analyzeRings().__inner[j].arcItems().__inner[k].sliceItems().count(); m++) {
						if (null == $self.model().series().__inner[i].analyzeRings().__inner[j].arcItems().__inner[k].sliceItems().__inner[m].slice()) {
							continue;
						}

						doughnutChart.series().__inner[i].rings().__inner[j].arcs().__inner[k].slices().add(new $.ig.SliceVisualData());
						var svd = new $.ig.SliceVisualData();
						var currentSlice = $self.model().series().__inner[i].analyzeRings().__inner[j].arcItems().__inner[k].sliceItems().__inner[m].slice();
						svd.visibility(currentSlice.__visibility);
						svd.endAngle(currentSlice.endAngle());
						svd.startAngle(currentSlice.startAngle());
						svd.radius(currentSlice.radius());
						svd.origin(currentSlice.origin());
						svd.explodedOrigin(currentSlice.explodedOrigin());
						svd.index(currentSlice.index());
						svd.isExploded(currentSlice.isExploded());
						svd.isSelected(currentSlice.isSelected());
						svd.outline(currentSlice.borderBrush());
						svd.backgroundPath(new $.ig.PathVisualData(1, "slicePath", currentSlice.view().getSlicePath()));
						doughnutChart.series().__inner[i].rings().__inner[j].arcs().__inner[k].slices().__inner[m] = svd;
						var currentLabel = currentSlice.label();
						if (null != currentLabel) {
							doughnutChart.series().__inner[i].rings().__inner[j].arcs().__inner[k].slices().__inner[m].labelVisualData((function () { var $ret = new $.ig.DoughnutChartLabelVisualData();
							$ret.labelSize($.ig.RectUtil.prototype.size(currentLabel.bounds()));
							$ret.labelValue((currentLabel.label()).text()); return $ret;}()));
							if (!$.ig.util.isNaN(currentLabel.canvasLeft()) && !$.ig.util.isNaN(currentLabel.canvasTop())) {
								doughnutChart.series().__inner[i].rings().__inner[j].arcs().__inner[k].slices().__inner[m].labelVisualData().labelPosition({__x: currentLabel.canvasLeft(), __y: currentLabel.canvasTop(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
							}

						}

					}

				}

			}

		}

	}
	, 
	$type: new $.ig.Type('XamDoughnutChartView', $.ig.Object.prototype.$type)
}, true);







$.ig.util.defType('ChartAxisRangeChangedEventArgs', 'EventArgs', {
	init: function (chart, axis, oldMinimumValue, minimumValue, oldMaximumValue, maximumValue) {



		$.ig.EventArgs.prototype.init.call(this);
			this.chart(chart);
			this.axis(axis);
			this.oldMinimumValue(oldMinimumValue);
			this.minimumValue(minimumValue);
			this.oldMaximumValue(oldMaximumValue);
			this.maximumValue(maximumValue);
	}

	, 
	_chart: null,
	chart: function (value) {
		if (arguments.length === 1) {
			this._chart = value;
			return value;
		} else {
			return this._chart;
		}
	}

	, 
	_axis: null,
	axis: function (value) {
		if (arguments.length === 1) {
			this._axis = value;
			return value;
		} else {
			return this._axis;
		}
	}

	, 
	_oldMinimumValue: 0,
	oldMinimumValue: function (value) {
		if (arguments.length === 1) {
			this._oldMinimumValue = value;
			return value;
		} else {
			return this._oldMinimumValue;
		}
	}

	, 
	_minimumValue: 0,
	minimumValue: function (value) {
		if (arguments.length === 1) {
			this._minimumValue = value;
			return value;
		} else {
			return this._minimumValue;
		}
	}

	, 
	_oldMaximumValue: 0,
	oldMaximumValue: function (value) {
		if (arguments.length === 1) {
			this._oldMaximumValue = value;
			return value;
		} else {
			return this._oldMaximumValue;
		}
	}

	, 
	_maximumValue: 0,
	maximumValue: function (value) {
		if (arguments.length === 1) {
			this._maximumValue = value;
			return value;
		} else {
			return this._maximumValue;
		}
	}
	, 
	$type: new $.ig.Type('ChartAxisRangeChangedEventArgs', $.ig.EventArgs.prototype.$type)
}, true);














































































$.ig.util.defType('LegendBaseViewManager', 'Object', {
	__owner: null
	, 
	init: function (owner) {


		this.__gradientsEnabled = false;

		$.ig.Object.prototype.init.call(this);
			this.__owner = owner;
			this.items(new $.ig.Dictionary$2($.ig.Object.prototype.$type, $.ig.JQueryObject.prototype.$type, 0));
	}

	, 
	onContainerProvided: function (container) {
		this.container($(container));
		this.list($("<table></table>"));
		this.list().addClass(this.__owner.legendItemsListStyle());
		this.container().append(this.list());
	}

	, 
	_list: null,
	list: function (value) {
		if (arguments.length === 1) {
			this._list = value;
			return value;
		} else {
			return this._list;
		}
	}

	, 
	_container: null,
	container: function (value) {
		if (arguments.length === 1) {
			this._container = value;
			return value;
		} else {
			return this._container;
		}
	}
	, 
	__gradientsEnabled: false

	, 
	getVisual: function (item, container) {
		var legendItem = $.ig.util.cast($.ig.ContentControl.prototype.$type, item);
		var row = $("<tr></tr>");
		row.addClass(this.__owner.legendItemStyle());
		if (legendItem != null) {
			var dc = $.ig.util.cast($.ig.DataContext.prototype.$type, legendItem.content());
			if (dc != null && legendItem.contentTemplate() != null) {
				var passInfo = new $.ig.DataTemplatePassInfo();
				passInfo.context = row;
				passInfo.passID = "LegendItem";
				var measureInfo = new $.ig.DataTemplateMeasureInfo();
				measureInfo.passInfo = passInfo;
				measureInfo.width = NaN;
				measureInfo.height = NaN;
				measureInfo.data = dc;
				measureInfo.context = row;
				var renderInfo = new $.ig.DataTemplateRenderInfo();
				renderInfo.passInfo = passInfo;
				if (legendItem.contentTemplate().measure() != null) {
					legendItem.contentTemplate().measure()(measureInfo);
				}

				renderInfo.context = row;
				renderInfo.availableWidth = measureInfo.width;
				renderInfo.availableHeight = measureInfo.height;
				renderInfo.data = dc;
				renderInfo.xPosition = 0;
				renderInfo.yPosition = 0;
				legendItem.contentTemplate().render()(renderInfo);
				row.find(".ui-legend-item-badge").removeClass("ui-legend-item-badge").addClass(this.__owner.legendItemBadgeStyle());
				row.find(".ui-legend-item-text").removeClass("ui-legend-item-text").addClass(this.__owner.legendItemTextStyle());
			}

		}

		return row;
	}

	, 
	_items: null,
	items: function (value) {
		if (arguments.length === 1) {
			this._items = value;
			return value;
		} else {
			return this._items;
		}
	}

	, 
	addItemVisual: function (item, index) {
		var visual = this.getVisual(item, this.list());
		visual.attr("id", index.toString());
		visual.mouseup(this.__owner.legendMouseUp.runOn(this.__owner));
		visual.mousedown(this.__owner.legendMouseDown.runOn(this.__owner));
		visual.mouseleave(this.__owner.legendMouseLeave.runOn(this.__owner));
		visual.mousemove(this.__owner.legendMouseOver.runOn(this.__owner));
		this.items().add(item, visual);
		if ((this.list().children().size() == 0) || (index >= this.list().children().size())) {
			this.list().append(visual);

		} else {
			var insBefore = this.list().children().eq(index);
			insBefore.after(visual);
		}

	}

	, 
	refreshLegendItem: function (index) {
	}

	, 
	removeItemVisual: function (item) {
		var $self = this;
		var toRemove;
		if ((function () { var $ret = $self.items().tryGetValue(item, toRemove); toRemove = $ret.p1; return $ret.ret; }())) {
			toRemove.remove();
			$self.items().remove(item);
		}

	}

	, 
	containsContext: function (dataContext) {
		var en = this.items().keys().getEnumerator();
		while (en.moveNext()) {
			var element = en.current();
			var contentControl = $.ig.util.cast($.ig.ContentControl.prototype.$type, element);
			if (contentControl != null && contentControl.content() != null) {
				var context = $.ig.util.cast($.ig.DataContext.prototype.$type, contentControl.content());
				if (context != null && context.itemLabel() == dataContext.itemLabel() && context.series() == dataContext.series() && context.itemBrush() == dataContext.itemBrush()) {
					return true;
				}

			}

		}

		return false;
	}

	, 
	_scaleCanvas: null,
	scaleCanvas: function (value) {
		if (arguments.length === 1) {
			this._scaleCanvas = value;
			return value;
		} else {
			return this._scaleCanvas;
		}
	}

	, 
	_scaleContext: null,
	scaleContext: function (value) {
		if (arguments.length === 1) {
			this._scaleContext = value;
			return value;
		} else {
			return this._scaleContext;
		}
	}

	, 
	getScaleContext: function (container) {
		var width = this.container().width();
		var height = this.container().height();
		var div = $("<div style=\"position : relative;\" />");
		this.scaleCanvas($("<canvas style=\"position : absolute; top : 0; left : 0\" />"));
		this.container().append(div);
		div.append(this.scaleCanvas());
		this.scaleContext(new $.ig.RenderingContext(new $.ig.CanvasViewRenderer(), (this.scaleCanvas()[0]).getContext("2d")));
		this.scaleCanvas().attr("width", width.toString());
		this.scaleCanvas().attr("height", height.toString());
		return this.scaleContext();
	}

	, 
	getScaleContainerSize: function () {
		return new $.ig.Size(1, this.container().width(), Math.max(10, this.container().height() - 15));
	}

	, 
	renderGradientShape: function (ScaleContext, polygon, currGradient, rect) {
		var cont = ScaleContext.getUnderlyingContext();
		cont.beginPath();
		cont.moveTo(polygon.points().__inner[0].__x, polygon.points().__inner[0].__y);
		for (var i = 1; i < polygon.points().count(); i++) {
			cont.lineTo(polygon.points().__inner[i].__x, polygon.points().__inner[i].__y);
		}

		cont.lineTo(polygon.points().__inner[0].__x, polygon.points().__inner[0].__y);
		var grad = cont.createLinearGradient(rect.left(), rect.top(), rect.left(), rect.top() + rect.height());
		var en = currGradient.gradientStops().getEnumerator();
		while (en.moveNext()) {
			var stop = en.current();
			grad.addColorStop(stop.offset(), stop.brush().__fill);
		}

		cont.fillStyle = grad;
		cont.fill();
	}
	, 
	$type: new $.ig.Type('LegendBaseViewManager', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('LegendBase', 'ContentControl', {

	createView: function () {
		return new $.ig.LegendBaseView(this);
	}

	, 
	onViewCreated: function (view) {
		this.view(view);
	}

	, 
	_view: null,
	view: function (value) {
		if (arguments.length === 1) {
			this._view = value;
			return value;
		} else {
			return this._view;
		}
	}
	, 
	init: function () {



		$.ig.ContentControl.prototype.init.call(this);
			var view = this.createView();
			this.onViewCreated(view);
			view.onInit();
			this.children(new $.ig.ObservableCollection$1($.ig.UIElement.prototype.$type, 0));
	}

	, 
	addChildInOrder: function (legendItem, series) {
	}

	, 
	createLegendItems: function (legendItems, itemsHost) {
	}

	, 
	_children: null,
	children: function (value) {
		if (arguments.length === 1) {
			this._children = value;
			return value;
		} else {
			return this._children;
		}
	}

	, 
	_seriesOwner: null,
	seriesOwner: function (value) {
		if (arguments.length === 1) {
			this._seriesOwner = value;
			return value;
		} else {
			return this._seriesOwner;
		}
	}

	, 
	_chartOwner: null,
	chartOwner: function (value) {
		if (arguments.length === 1) {
			this._chartOwner = value;
			return value;
		} else {
			return this._chartOwner;
		}
	}

	, 
	owner: function () {

			if (this.seriesOwner() != null) {
				return this.seriesOwner();

			} else {
				return this.chartOwner();
			}

	}
	, 
	propertyChanged: null, 
	propertyUpdated: null
	, 
	raisePropertyChanged: function (name, oldValue, newValue) {
		if (this.propertyChanged != null) {
			this.propertyChanged(this, new $.ig.PropertyChangedEventArgs(name));
		}

		if (this.propertyUpdated != null) {
			this.propertyUpdated(this, new $.ig.PropertyUpdatedEventArgs(name, oldValue, newValue));
		}

	}
	, 
	legendItemMouseLeftButtonDown: null
	, 
	onLegendItemMouseLeftButtonDown: function (args) {
		if (this.legendItemMouseLeftButtonDown != null) {
			this.legendItemMouseLeftButtonDown(this, args);
		}

	}
	, 
	legendItemMouseLeftButtonUp: null
	, 
	onLegendItemMouseLeftButtonUp: function (args) {
		if (this.legendItemMouseLeftButtonUp != null) {
			this.legendItemMouseLeftButtonUp(this, args);
		}

	}
	, 
	legendItemMouseEnter: null
	, 
	onLegendItemMouseEnter: function (args) {
		if (this.legendItemMouseEnter != null) {
			this.legendItemMouseEnter(this, args);
		}

	}
	, 
	legendItemMouseLeave: null
	, 
	onLegendItemMouseLeave: function (args) {
		if (this.legendItemMouseLeave != null) {
			this.legendItemMouseLeave(this, args);
		}

	}
	, 
	legendItemMouseMove: null
	, 
	onLegendItemMouseMove: function (args) {
		if (this.legendItemMouseMove != null) {
			this.legendItemMouseMove(this, args);
		}

	}

	, 
	provideContainer: function (container) {
		this.view().onContainerProvided(container);
	}

	, 
	legendItemsListStyle: function (value) {
		if (arguments.length === 1) {

			this.view().legendItemsListStyle(value);
			return value;
		} else {

			return this.view().legendItemsListStyle();
		}
	}

	, 
	legendItemStyle: function (value) {
		if (arguments.length === 1) {

			this.view().legendItemStyle(value);
			return value;
		} else {

			return this.view().legendItemStyle();
		}
	}

	, 
	legendItemBadgeStyle: function (value) {
		if (arguments.length === 1) {

			this.view().legendItemBadgeStyle(value);
			return value;
		} else {

			return this.view().legendItemBadgeStyle();
		}
	}

	, 
	legendItemTextStyle: function (value) {
		if (arguments.length === 1) {

			this.view().legendItemTextStyle(value);
			return value;
		} else {

			return this.view().legendItemTextStyle();
		}
	}
	, 
	$type: new $.ig.Type('LegendBase', $.ig.ContentControl.prototype.$type, [$.ig.INotifyPropertyChanged.prototype.$type])
}, true);


$.ig.util.defType('LegendBaseView', 'Object', {
	init: function (model) {


		this._mouseOver = false;

		$.ig.Object.prototype.init.call(this);
			this.model(model);
			this.viewManager(new $.ig.LegendBaseViewManager(this));
	}

	, 
	_viewManager: null,
	viewManager: function (value) {
		if (arguments.length === 1) {
			this._viewManager = value;
			return value;
		} else {
			return this._viewManager;
		}
	}

	, 
	_model: null,
	model: function (value) {
		if (arguments.length === 1) {
			this._model = value;
			return value;
		} else {
			return this._model;
		}
	}

	, 
	onInit: function () {
	}

	, 
	isDiscrete: function () {

			return false;
	}

	, 
	createMouseButtonArgs: function (legendItem) {
		var $self = this;
		var chart;
		var series;
		var item;
		(function () { var $ret = $self.fetchLegendEnvironment(legendItem, chart, series, item); chart = $ret.p1; series = $ret.p2; item = $ret.p3; return $ret.ret; }());
		var be = new $.ig.MouseButtonEventArgs();
		var args = new $.ig.DataChartLegendMouseButtonEventArgs(chart, series, item, be, legendItem);
		return args;
	}

	, 
	createMouseArgs: function (legendItem) {
		var $self = this;
		var chart;
		var series;
		var item;
		(function () { var $ret = $self.fetchLegendEnvironment(legendItem, chart, series, item); chart = $ret.p1; series = $ret.p2; item = $ret.p3; return $ret.ret; }());
		var be = new $.ig.MouseEventArgs();
		var args = new $.ig.ChartLegendMouseEventArgs(chart, series, item, be, legendItem);
		return args;
	}

	, 
	fetchLegendEnvironment: function (legendItem, chart, series, item) {
		chart = ($.ig.util.cast($.ig.SeriesViewer.prototype.$type, this.model().owner()));
		series = null;
		item = null;
		if (legendItem != null) {
			var contentControl = $.ig.util.cast($.ig.ContentControl.prototype.$type, legendItem);
			if (contentControl != null && contentControl.content() != null && $.ig.util.cast($.ig.DataContext.prototype.$type, contentControl.content()) !== null) {
				var dc = $.ig.util.cast($.ig.DataContext.prototype.$type, contentControl.content());
				series = $.ig.util.cast($.ig.Series.prototype.$type, dc.series());
				if (series != null) {
					chart = series.seriesViewer();
				}

				item = dc.item();
			}

		}

		return {
			p1: chart, 
			p2: series, 
			p3: item
		};
	}

	, 
	detachContent: function () {
	}

	, 
	ready: function () {
		return true;
	}

	, 
	attachItemEvents: function (uiElement) {
	}

	, 
	removeItemEvents: function (uiElement) {
	}

	, 
	onContainerProvided: function (container) {
		this.viewManager().onContainerProvided(container);
	}

	, 
	removeItemVisual: function (item) {
		this.viewManager().removeItemVisual(item);
	}

	, 
	addItemVisual: function (item) {
		var index = this.model().children().indexOf(item);
		this.viewManager().addItemVisual(item, index);
	}

	, 
	_legendItemsListStyle: null,
	legendItemsListStyle: function (value) {
		if (arguments.length === 1) {
			this._legendItemsListStyle = value;
			return value;
		} else {
			return this._legendItemsListStyle;
		}
	}

	, 
	_legendItemStyle: null,
	legendItemStyle: function (value) {
		if (arguments.length === 1) {
			this._legendItemStyle = value;
			return value;
		} else {
			return this._legendItemStyle;
		}
	}

	, 
	_legendItemBadgeStyle: null,
	legendItemBadgeStyle: function (value) {
		if (arguments.length === 1) {
			this._legendItemBadgeStyle = value;
			return value;
		} else {
			return this._legendItemBadgeStyle;
		}
	}

	, 
	_legendItemTextStyle: null,
	legendItemTextStyle: function (value) {
		if (arguments.length === 1) {
			this._legendItemTextStyle = value;
			return value;
		} else {
			return this._legendItemTextStyle;
		}
	}
	, 
	_mouseOver: false

	, 
	item: function (e_) {
		var i_ = $(e_.currentTarget).attr('id');
		return (i_ == null || i_ == "") ? null : this.model().children().__inner[$.ig.Number.prototype.parseInt(i_)];
	}

	, 
	legendMouseOver: function (e) {
		if (!this._mouseOver) {
		this.model().onLegendItemMouseEnter(this.createMouseArgs(this.item(e)));
		}

		this._mouseOver = true;
	}

	, 
	legendMouseLeave: function (e) {
		if (this._mouseOver) {
		this.model().onLegendItemMouseLeave(this.createMouseArgs(this.item(e)));
		}

		this._mouseOver = false;
	}

	, 
	legendMouseDown: function (e) {
		this.model().onLegendItemMouseLeftButtonDown(this.createMouseButtonArgs(this.item(e)));
	}

	, 
	legendMouseUp: function (e) {
		this.model().onLegendItemMouseLeftButtonUp(this.createMouseButtonArgs(this.item(e)));
	}
	, 
	$type: new $.ig.Type('LegendBaseView', $.ig.Object.prototype.$type)
}, true);


$.ig.util.defType('GradientData', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.gradientStops(new $.ig.List$1($.ig.GradientStopData.prototype.$type, 0));
	}

	, 
	_gradientStops: null,
	gradientStops: function (value) {
		if (arguments.length === 1) {
			this._gradientStops = value;
			return value;
		} else {
			return this._gradientStops;
		}
	}
	, 
	$type: new $.ig.Type('GradientData', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('GradientStopData', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	_offset: 0,
	offset: function (value) {
		if (arguments.length === 1) {
			this._offset = value;
			return value;
		} else {
			return this._offset;
		}
	}

	, 
	_brush: null,
	brush: function (value) {
		if (arguments.length === 1) {
			this._brush = value;
			return value;
		} else {
			return this._brush;
		}
	}
	, 
	$type: new $.ig.Type('GradientStopData', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('PieChartViewManager', 'Object', {

	_container: null,
	container: function (value) {
		if (arguments.length === 1) {
			this._container = value;
			return value;
		} else {
			return this._container;
		}
	}

	, 
	_backgroundCanvas: null,
	backgroundCanvas: function (value) {
		if (arguments.length === 1) {
			this._backgroundCanvas = value;
			return value;
		} else {
			return this._backgroundCanvas;
		}
	}

	, 
	_overlayCanvas: null,
	overlayCanvas: function (value) {
		if (arguments.length === 1) {
			this._overlayCanvas = value;
			return value;
		} else {
			return this._overlayCanvas;
		}
	}

	, 
	_mainCanvas: null,
	mainCanvas: function (value) {
		if (arguments.length === 1) {
			this._mainCanvas = value;
			return value;
		} else {
			return this._mainCanvas;
		}
	}

	, 
	_labelCanvas: null,
	labelCanvas: function (value) {
		if (arguments.length === 1) {
			this._labelCanvas = value;
			return value;
		} else {
			return this._labelCanvas;
		}
	}
	, 
	__containerWidth: 0
	, 
	__containerHeight: 0

	, 
	_viewport: null,
	viewport: function (value) {
		if (arguments.length === 1) {
			this._viewport = value;
			return value;
		} else {
			return this._viewport;
		}
	}

	, 
	_backgroundContext: null,
	backgroundContext: function (value) {
		if (arguments.length === 1) {
			this._backgroundContext = value;
			return value;
		} else {
			return this._backgroundContext;
		}
	}

	, 
	_mainContext: null,
	mainContext: function (value) {
		if (arguments.length === 1) {
			this._mainContext = value;
			return value;
		} else {
			return this._mainContext;
		}
	}

	, 
	_labelContext: null,
	labelContext: function (value) {
		if (arguments.length === 1) {
			this._labelContext = value;
			return value;
		} else {
			return this._labelContext;
		}
	}

	, 
	_overlayContext: null,
	overlayContext: function (value) {
		if (arguments.length === 1) {
			this._overlayContext = value;
			return value;
		} else {
			return this._overlayContext;
		}
	}
	, 
	__owner: null
	, 
	init: function (owner) {


		this.__containerWidth = 0;
		this.__containerHeight = 0;
		this.__sizeChanged = false;
		this.__toolTipObject = null;
		this.__toolTipString = null;
		this.__tooltipDisconnected = true;

		$.ig.Object.prototype.init.call(this);
			this.__owner = owner;
	}
	, 
	__sizeChanged: false

	, 
	notifyContainerResized: function () {
		var newWidth = this.container().width();
		var newHeight = this.container().height();
		this.onContainerResized(newWidth, newHeight);
	}

	, 
	onContainerResized: function (width, height) {
		this.eventProxy().viewport(new $.ig.Rect(0, 0, 0, width, height));
		if (this.__containerWidth != width) {
			this.__sizeChanged = true;
		}

		this.__containerWidth = width;
		if (this.__containerHeight != height) {
			this.__sizeChanged = true;
		}

		this.__containerHeight = height;
		this.__owner.resize();
	}

	, 
	resize: function () {
		this.viewport(new $.ig.Rect(0, 0, 0, this.__containerWidth, this.__containerHeight));
		this.backgroundCanvas().attr("width", this.__containerWidth.toString());
		this.backgroundCanvas().attr("height", this.__containerHeight.toString());
		this.mainCanvas().attr("width", this.__containerWidth.toString());
		this.mainCanvas().attr("height", this.__containerHeight.toString());
		this.labelCanvas().attr("width", this.__containerWidth.toString());
		this.labelCanvas().attr("height", this.__containerHeight.toString());
		this.overlayCanvas().attr("width", this.__containerWidth.toString());
		this.overlayCanvas().attr("height", this.__containerHeight.toString());
		return this.viewport();
	}

	, 
	getOwnerFont: function () {
		return this.__owner.font();
	}

	, 
	getContainerOffsets: function () {
		var offset = $.ig.DOMEventProxy.prototype.getOffset(this.container());
		return new $.ig.Size(1, offset.left(), offset.top());
	}

	, 
	getCssBrushColors: function (className, obj) {
		var brushes = new Array(2);
		obj.addClass(className);
		var fill = new $.ig.Brush();
		fill.__fill = obj.css("background-color");
		var outline = new $.ig.Brush();
		outline.__fill = obj.css("border-top-color");
		obj.removeClass(className);
		brushes[0] = fill;
		brushes[1] = outline;
		return brushes;
	}

	, 
	queueWork: function (work) {
		window.setTimeout(work, 0);
	}

	, 
	getDefaultStyle: function (brushes, outlines, fontBrush, font) {
		var $self = this;
		(function () { var $ret = $.ig.BrushUtil.prototype.getBrushCollection("chart", $self.container(), brushes, outlines, null); brushes = $ret.p2; outlines = $ret.p3; return $ret.ret; }());
		fontBrush = new $.ig.Brush();
		fontBrush.__fill = $self.container().css("color");
		font = $.ig.FontUtil.prototype.getFont($self.container());
		return {
			p0: brushes, 
			p1: outlines, 
			p2: fontBrush, 
			p3: font
		};
	}

	, 
	setDefaultSliceBrushes: function (slicePath) {
		var $self = this;
		slicePath.__stroke = (function () { var $ret = new $.ig.Brush();
		$ret.fill("#000000"); return $ret;}());
		slicePath.__fill = (function () { var $ret = new $.ig.Brush();
		$ret.fill("#222222"); return $ret;}());
	}

	, 
	_eventProxy: null,
	eventProxy: function (value) {
		if (arguments.length === 1) {
			this._eventProxy = value;
			return value;
		} else {
			return this._eventProxy;
		}
	}

	, 
	onContainerProvided: function (theContainer) {
		if (theContainer == null) {
			if (this.eventProxy() != null) {
				this.eventProxy().destroy();
			}

			this.container(null);
			this.backgroundCanvas(null);
			this.mainCanvas(null);
			this.labelCanvas(null);
			this.overlayCanvas(null);
			this.backgroundContext(null);
			this.mainContext(null);
			this.labelContext(null);
			this.overlayContext(null);
			this.eventProxy(null);
			return;
		}

		var container = theContainer;
		this.container($(container));
		this.__owner.setDefaultBrushes();
		this.__owner.updateCurrentFontHeight();
		this.container().css("position", "relative");
		this.container().addClass("ui-corner-all ui-widget-content");
		this.backgroundCanvas($("<canvas style=\"position : absolute; top : 0; left : 0\" />"));
		this.mainCanvas($("<canvas style=\"position : absolute; top : 0; left : 0\" />"));
		this.labelCanvas($("<canvas style=\"position : absolute; top : 0; left : 0\" />"));
		this.overlayCanvas($("<canvas style=\"position : absolute; top : 0; left : 0\" />"));
		this.container().append(this.backgroundCanvas());
		this.container().append(this.mainCanvas());
		this.container().append(this.labelCanvas());
		this.container().append(this.overlayCanvas());
		this.backgroundContext(new $.ig.RenderingContext(new $.ig.CanvasViewRenderer(), (this.backgroundCanvas()[0]).getContext("2d")));
		this.mainContext(new $.ig.RenderingContext(new $.ig.CanvasViewRenderer(), (this.mainCanvas()[0]).getContext("2d")));
		this.labelContext(new $.ig.RenderingContext(new $.ig.CanvasViewRenderer(), (this.labelCanvas()[0]).getContext("2d")));
		this.overlayContext(new $.ig.RenderingContext(new $.ig.CanvasViewRenderer(), (this.overlayCanvas()[0]).getContext("2d")));
		this.eventProxy(new $.ig.DOMEventProxy(this.overlayCanvas()));
		this.eventProxy().onMouseOver = $.ig.Delegate.prototype.combine(this.eventProxy().onMouseOver, this.__owner.canvasMouseMove.runOn(this.__owner));
		this.eventProxy().onMouseLeave = $.ig.Delegate.prototype.combine(this.eventProxy().onMouseLeave, this.__owner.canvasMouseLeave.runOn(this.__owner));
		this.eventProxy().onMouseDown = $.ig.Delegate.prototype.combine(this.eventProxy().onMouseDown, this.__owner.canvasMouseDown.runOn(this.__owner));
		this.eventProxy().onMouseUp = $.ig.Delegate.prototype.combine(this.eventProxy().onMouseUp, this.__owner.canvasMouseUp.runOn(this.__owner));
		this.eventProxy().isInteractionDisabled(this.__owner.model().isSurfaceInteractionDisabled());
		this.onContainerResized(this.container().width(), this.container().height());
	}

	, 
	addToContainer: function (_toolTipObject) {
		this.container().append(_toolTipObject);
	}

	, 
	onIsSurfaceInteractionDisabledChanged: function (newValue) {
		if (this.eventProxy() == null) {
			return;
		}

		this.eventProxy().isInteractionDisabled(newValue);
	}

	, 
	getContainer: function () {
		return this.container();
	}

	, 
	exportViewData: function (visualData) {
		visualData.width(this.__containerWidth);
		visualData.height(this.__containerHeight);
	}
	, 
	__toolTipObject: null
	, 
	__toolTipString: null
	, 
	__tooltipDisconnected: false

	, 
	updateTooltipValue: function (p) {
		this.__toolTipString = null;
		this.__toolTipObject = null;
		if ($.ig.util.cast(String, p) !== null || typeof p === "string") {
			this.__toolTipString = p;

		} else {
			this.__toolTipObject = p;
			if (this.__toolTipObject != null) {
				this.__toolTipObject.css("position", "fixed");
				this.__toolTipObject.css("top", "0");
				this.__toolTipObject.css("left", "0");
				this.__toolTipObject.css("z-index", "10000");
			}

		}

	}

	, 
	updateTooltipPosition: function (pos_, context_) {
		if (this.__toolTipObject != null) {
			if (this.__tooltipDisconnected) {
				this.addToContainer(this.__toolTipObject);
				this.__tooltipDisconnected = false;
			}

			context_.hideOthers = true;
			if (this.__toolTipObject.updateToolTip) { this.__toolTipObject.updateToolTip(context_); };
			if (this.__toolTipObject.offset) { this.__toolTipObject.offset({ left: pos_.__x, top: pos_.__y }); };
		}

	}

	, 
	hideTooltip: function (context) {
		if (this.__toolTipObject != null) {
			var context_ = context;
			if (this.__toolTipObject.hideToolTip) { this.__toolTipObject.hideToolTip(context_); };
		}

	}

	, 
	getStyleBackground: function (style_) {
		var actualBrush = null;
		var fillColor_ = null;
		if (style_ != null) {
			if (style_.fill) { fillColor_ = style_.fill };
			if (fillColor_ != null) {
				actualBrush = $.ig.Brush.prototype.create(fillColor_);
			}

		}

		return actualBrush;
	}

	, 
	getStyleOutline: function (style_) {
		var actualOutline = null;
		var outlineColor_ = null;
		if (style_ != null) {
			if (style_.stroke) { outlineColor_ = style_.stroke };
			if (outlineColor_ != null) {
				actualOutline = $.ig.Brush.prototype.create(outlineColor_);
			}

		}

		return actualOutline;
	}
	, 
	$type: new $.ig.Type('PieChartViewManager', $.ig.Object.prototype.$type)
}, true);
























$.ig.util.defType('SeriesViewerComponentsForView', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('SeriesViewerComponentsForView', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('SeriesViewerComponentsFromView', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	_overviewPlusDetailPane: null,
	overviewPlusDetailPane: function (value) {
		if (arguments.length === 1) {
			this._overviewPlusDetailPane = value;
			return value;
		} else {
			return this._overviewPlusDetailPane;
		}
	}
	, 
	$type: new $.ig.Type('SeriesViewerComponentsFromView', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('XamDataChart', 'SeriesViewer', {
	staticInit: function () {



			$.ig.XamDataChart.prototype.decimalMinimumValueAsDouble = -1.7976931348623157E+308;
			$.ig.XamDataChart.prototype.decimalMaximumValueAsDouble = 1.7976931348623157E+308;
	}

	, 
	findSeriesIndex: function (series) {
		var $self = this;
		if (series.seriesViewer() == null) {
		return -1;
		}

		if (!series.isIndexed()) {
		return -1;
		}

		var allSeries = $.ig.XamDataChartView.prototype.getAllSeries(series);
		if ($.ig.Enumerable.prototype.count$1($.ig.Series.prototype.$type, allSeries) == 0) {
		return -1;
		}

		var index = $.ig.Enumerable.prototype.max$1($.ig.Series.prototype.$type, allSeries, function (s) { return s.index(); }) + 1;
		if ($.ig.util.cast($.ig.FragmentBase.prototype.$type, series) !== null || $.ig.util.cast($.ig.SplineFragmentBase.prototype.$type, series) !== null) {
			var parentSeries = $.ig.util.cast($.ig.FragmentBase.prototype.$type, series) !== null ? ($.ig.util.cast($.ig.FragmentBase.prototype.$type, series)).parentSeries() : ($.ig.util.cast($.ig.SplineFragmentBase.prototype.$type, series)).parentSeries();
			var anchoredSeries = $.ig.util.cast($.ig.AnchoredCategorySeries.prototype.$type, series);
			if (parentSeries.index() == -1 || parentSeries.stackedSeriesManager() == null || anchoredSeries == null || parentSeries.stackedSeriesManager().seriesVisual().indexOf(anchoredSeries) == -1) {
				return -1;
			}

			index = parentSeries.index() + parentSeries.stackedSeriesManager().seriesVisual().indexOf(anchoredSeries);
		}

		return index;
	}
	, 
	init: function () {


		this.__actualWindowScaleHorizontal = 1;
		this.__actualWindowScaleVertical = 1;
		this._axes = new $.ig.AxisCollection();

		$.ig.SeriesViewer.prototype.init.call(this);
			this.defaultStyleKey($.ig.XamDataChart.prototype.$type);
			this.axes().collectionChanged = $.ig.Delegate.prototype.combine(this.axes().collectionChanged, this.axes_CollectionChanged.runOn(this));
			this.axes().collectionResetting = $.ig.Delegate.prototype.combine(this.axes().collectionResetting, this.axes_CollectionResetting.runOn(this));
	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		$.ig.SeriesViewer.prototype.propertyUpdatedOverride.call(this, sender, propertyName, oldValue, newValue);
		switch (propertyName) {
			case $.ig.XamDataChart.prototype.windowScaleHorizontalPropertyName:
				this.actualWindowScaleHorizontal(this.windowScaleHorizontal());
				break;
			case $.ig.XamDataChart.prototype.windowScaleVerticalPropertyName:
				this.actualWindowScaleVertical(this.windowScaleVertical());
				break;
			case $.ig.XamDataChart.prototype.actualWindowScaleHorizontalPropertyName:
			case $.ig.XamDataChart.prototype.actualWindowScaleVerticalPropertyName:
				if (!this.suspendWindowRect()) {
					this.updateWindowRect(this.getActualWindowScaleHorizontal(), this.getActualWindowScaleVertical());
				}

				break;
			case $.ig.XamDataChart.prototype.gridModePropertyName:
				(this.view()).updateGridMode(newValue);
					var en = this.axes().getEnumerator();
					while (en.moveNext()) {
						var axis = en.current();
						axis.renderAxis();
					}


				break;
			case $.ig.XamDataChart.prototype.horizontalZoomablePropertyName:
			case $.ig.XamDataChart.prototype.verticalZoomablePropertyName:
				this.updateOverviewPlusDetailPaneControlPanelVisibility();
				break;
			case $.ig.XamDataChart.prototype.alignsGridLinesToPixelsPropertyName:
				if (oldValue != newValue) {
					var en1 = this.axes().getEnumerator();
					while (en1.moveNext()) {
						var axis1 = en1.current();
						axis1.renderAxis();
					}

				}

				break;
			case $.ig.XamDataChart.prototype.defaultAxisStrokePropertyName:
			case $.ig.XamDataChart.prototype.defaultAxisMajorStrokePropertyName:
			case $.ig.XamDataChart.prototype.defaultAxisMinorStrokePropertyName:
				var en2 = this.axes().getEnumerator();
				while (en2.moveNext()) {
					var axis2 = en2.current();
					axis2.updateActualBrushes();
				}

				break;
		}

	}

	, 
	isSquare: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.XamDataChart.prototype.isSquareProperty, value);
			return value;
		} else {

			return this.getValue($.ig.XamDataChart.prototype.isSquareProperty);
		}
	}

	, 
	getActualWindowScaleHorizontal: function () {
		return this.actualWindowScaleHorizontal();
	}

	, 
	getActualWindowScaleVertical: function () {
		return this.actualWindowScaleVertical();
	}

	, 
	updateAcutalWindowProperties: function () {
		$.ig.SeriesViewer.prototype.updateAcutalWindowProperties.call(this);
		this.actualWindowScaleHorizontal(this.actualWindowRect().width());
		this.actualWindowScaleVertical(this.actualWindowRect().height());
	}

	, 
	windowScaleHorizontal: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.XamDataChart.prototype.windowScaleHorizontalProperty, value);
			return value;
		} else {

			return this.getValue($.ig.XamDataChart.prototype.windowScaleHorizontalProperty);
		}
	}

	, 
	windowScaleVertical: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.XamDataChart.prototype.windowScaleVerticalProperty, value);
			return value;
		} else {

			return this.getValue($.ig.XamDataChart.prototype.windowScaleVerticalProperty);
		}
	}
	, 
	__actualWindowScaleHorizontal: 0

	, 
	actualWindowScaleHorizontal: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__actualWindowScaleHorizontal;
			this.__actualWindowScaleHorizontal = value;
			this.raisePropertyChanged($.ig.XamDataChart.prototype.actualWindowScaleHorizontalPropertyName, oldValue, this.__actualWindowScaleHorizontal);
			return value;
		} else {

			return this.__actualWindowScaleHorizontal;
		}
	}
	, 
	__actualWindowScaleVertical: 0

	, 
	actualWindowScaleVertical: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__actualWindowScaleVertical;
			this.__actualWindowScaleVertical = value;
			this.raisePropertyChanged($.ig.XamDataChart.prototype.actualWindowScaleVerticalPropertyName, oldValue, this.__actualWindowScaleVertical);
			return value;
		} else {

			return this.__actualWindowScaleVertical;
		}
	}

	, 
	isZoomingHorizontallyEnabled: function () {
		return this.horizontalZoomable();
	}

	, 
	isZoomingVerticallyEnabled: function () {
		return this.verticalZoomable();
	}

	, 
	horizontalZoomable: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.XamDataChart.prototype.horizontalZoomableProperty, value);
			return value;
		} else {

			return this.getValue($.ig.XamDataChart.prototype.horizontalZoomableProperty);
		}
	}

	, 
	verticalZoomable: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.XamDataChart.prototype.verticalZoomableProperty, value);
			return value;
		} else {

			return this.getValue($.ig.XamDataChart.prototype.verticalZoomableProperty);
		}
	}

	, 
	horizontalZoombarVisibility: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.XamDataChart.prototype.horizontalZoombarVisibilityProperty, $.ig.Visibility.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.XamDataChart.prototype.horizontalZoombarVisibilityProperty));
		}
	}

	, 
	verticalZoombarVisibility: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.XamDataChart.prototype.verticalZoombarVisibilityProperty, $.ig.Visibility.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.XamDataChart.prototype.verticalZoombarVisibilityProperty));
		}
	}

	, 
	gridMode: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.XamDataChart.prototype.gridModeProperty, $.ig.GridMode.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.XamDataChart.prototype.gridModeProperty));
		}
	}

	, 
	alignsGridLinesToPixels: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.XamDataChart.prototype.alignsGridLinesToPixelsProperty, value);
			return value;
		} else {

			return this.getValue($.ig.XamDataChart.prototype.alignsGridLinesToPixelsProperty);
		}
	}

	, 
	brushes: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.XamDataChart.prototype.brushesProperty, value);
			return value;
		} else {

			return this.getValue($.ig.XamDataChart.prototype.brushesProperty);
		}
	}

	, 
	markerBrushes: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.XamDataChart.prototype.markerBrushesProperty, value);
			return value;
		} else {

			return this.getValue($.ig.XamDataChart.prototype.markerBrushesProperty);
		}
	}

	, 
	outlines: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.XamDataChart.prototype.outlinesProperty, value);
			return value;
		} else {

			return this.getValue($.ig.XamDataChart.prototype.outlinesProperty);
		}
	}

	, 
	markerOutlines: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.XamDataChart.prototype.markerOutlinesProperty, value);
			return value;
		} else {

			return this.getValue($.ig.XamDataChart.prototype.markerOutlinesProperty);
		}
	}

	, 
	defaultAxisStroke: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.XamDataChart.prototype.defaultAxisStrokeProperty, value);
			return value;
		} else {

			return this.getValue($.ig.XamDataChart.prototype.defaultAxisStrokeProperty);
		}
	}

	, 
	defaultAxisMajorStroke: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.XamDataChart.prototype.defaultAxisMajorStrokeProperty, value);
			return value;
		} else {

			return this.getValue($.ig.XamDataChart.prototype.defaultAxisMajorStrokeProperty);
		}
	}

	, 
	defaultAxisMinorStroke: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.XamDataChart.prototype.defaultAxisMinorStrokeProperty, value);
			return value;
		} else {

			return this.getValue($.ig.XamDataChart.prototype.defaultAxisMinorStrokeProperty);
		}
	}

	, 
	axes: function () {

			return this._axes;
	}
	, 
	_axes: null

	, 
	axes_CollectionChanged: function (sender, e) {
		if (e.oldItems() != null) {
			var en = e.oldItems().getEnumerator();
			while (en.moveNext()) {
				var axis = en.current();
				if (axis != null) {
					axis.fastItemsSourceProvider(null);
					axis.seriesViewer(null);
					this.removeDataSource(axis);
					this.view().removeAxis(axis);
					axis.rangeChanged = $.ig.Delegate.prototype.remove(axis.rangeChanged, this.axis_RangeChanged.runOn(this));
					this.view().removeLabelPanel(axis);
					if (axis.series() != null) {
						var en1 = axis.directSeries().getEnumerator();
						while (en1.moveNext()) {
							var series = en1.current();
							series.renderSeries(false);
						}

					}

				}

			}

			if (this.axes().count() == 0) {
				this.resetZoom();
			}

		}

		if (e.newItems() != null) {
			var en2 = e.newItems().getEnumerator();
			while (en2.moveNext()) {
				var axis1 = en2.current();
				if (axis1 != null) {
					this.updateDataSourceFor(axis1);
					axis1.fastItemsSourceProvider(this.actualSyncLink());
					axis1.seriesViewer(this);
					axis1.view().updateStrokeBrushesFromCss();
					this.view().attachAxis(axis1);
					axis1.rangeChanged = $.ig.Delegate.prototype.combine(axis1.rangeChanged, this.axis_RangeChanged.runOn(this));
					this.view().addLabelPanel(axis1);
				}

			}

		}

		this.notifyThumbnailAppearanceChanged();
	}

	, 
	axes_CollectionResetting: function (sender, e) {
		var seriesList = new $.ig.List$1($.ig.Series.prototype.$type, 0);
		var en = this.axes().getEnumerator();
		while (en.moveNext()) {
			var axis = en.current();
			if (axis.series() != null) {
				var en1 = axis.directSeries().getEnumerator();
				while (en1.moveNext()) {
					var series = en1.current();
					if (!seriesList.contains(series)) {
						seriesList.add(series);
					}

				}

			}

			axis.fastItemsSourceProvider(null);
			axis.seriesViewer(null);
			this.removeDataSource(axis);
			this.view().removeAxis(axis);
			axis.rangeChanged = $.ig.Delegate.prototype.remove(axis.rangeChanged, this.axis_RangeChanged.runOn(this));
			this.view().removeLabelPanel(axis);
			this.resetZoom();
		}

		var en2 = this.series().getEnumerator();
		while (en2.moveNext()) {
			var series1 = en2.current();
			if (!seriesList.contains(series1)) {
				seriesList.add(series1);
			}

		}

		var en3 = seriesList.getEnumerator();
		while (en3.moveNext()) {
			var series2 = en3.current();
			series2.renderSeries(false);
		}

	}
	, 
	axisRangeChanged: null
	, 
	axis_RangeChanged: function (sender, args) {
		var targetAxis = $.ig.util.cast($.ig.Axis.prototype.$type, sender);
		if (targetAxis == null) {
			return;
		}

		this.notifyThumbnailAppearanceChanged();
		if (this.axisRangeChanged != null) {
			this.axisRangeChanged(this, new $.ig.ChartAxisRangeChangedEventArgs(this, targetAxis, args.oldMinimumValue(), args.minimumValue(), args.oldMaximumValue(), args.maximumValue()));
		}

		if (targetAxis.crossingAxis() != null) {
			targetAxis.crossingAxis().refresh();
		}

		targetAxis.refresh();
		var animate = this.animateSeriesWhenAxisRangeChanges();
		if ($.ig.util.cast($.ig.CategoryAxisBase.prototype.$type, targetAxis) !== null) {
			animate = true;
		}

		var en = targetAxis.directSeries().getEnumerator();
		while (en.moveNext()) {
			var series = en.current();
			series.thumbnailDirty(true);
			this.notifyThumbnailAppearanceChanged();
			series.renderSeries(animate);
		}

		var en1 = targetAxis.seriesViewer().series().getEnumerator();
		while (en1.moveNext()) {
			var series1 = en1.current();
			$.ig.XamDataChart.prototype.onValueOverlayRangeChanged(targetAxis, animate, series1);
		}

		var en2 = this.axes().getEnumerator();
		while (en2.moveNext()) {
			var chartAxis = en2.current();
			if (chartAxis != targetAxis && chartAxis.crossingAxis() != null && chartAxis.crossingAxis() == targetAxis) {
				chartAxis.refresh();
			}

		}

	}

	, 
	onValueOverlayRangeChanged: function (targetAxis, animate, series) {
	}

	, 
	updateSyncLink: function (oldLink, newLink) {
		$.ig.SeriesViewer.prototype.updateSyncLink.call(this, oldLink, newLink);
		if (this.axes() == null) {
			return;
		}

		var en = this.axes().getEnumerator();
		while (en.moveNext()) {
			var axis = en.current();
			axis.fastItemsSourceProvider(this.actualSyncLink());
			axis.seriesViewer(this);
		}

	}

	, 
	gridZIndex: function () {

			return this.gridMode() == $.ig.GridMode.prototype.beforeSeries ? 2 : 1;
	}

	, 
	seriesZIndex: function () {

			return this.gridMode() == $.ig.GridMode.prototype.beforeSeries ? 1 : 2;
	}

	, 
	styleUpdated: function () {
		this.view().styleUpdated();
		var en = this.axes().getEnumerator();
		while (en.moveNext()) {
			var axis = en.current();
			axis.renderAxis1(false);
		}

		var en1 = this.series().getEnumerator();
		while (en1.moveNext()) {
			var series = en1.current();
			series.view().updateLegendItemVisual();
			series.renderSeries(false);
		}

	}

	, 
	getFontBrush: function () {
		return this.chartView().fontBrush();
	}

	, 
	destroyOverride: function () {
		$.ig.SeriesViewer.prototype.destroyOverride.call(this);
		var toDestroy = new $.ig.List$1($.ig.Axis.prototype.$type, 0);
		for (var i = 0; i < this.axes().count(); i++) {
			toDestroy.add(this.axes().__inner[i]);
		}

		for (var i1 = 0; i1 < toDestroy.count(); i1++) {
			this.axes().remove(toDestroy.__inner[i1]);
			if ($.ig.util.cast($.ig.CategoryAxisBase.prototype.$type, toDestroy.__inner[i1]) !== null) {
				var cat = toDestroy.__inner[i1];
				this.removeSpecificDataSource(cat.name(), true);
				cat.itemsSource(null);
			}

			toDestroy.__inner[i1].provideContext(null, null);
		}

	}

	, 
	getFont: function () {
		return this.chartView().font();
	}

	, 
	getAxisLineBrush: function () {
		return this.chartView().axisLineBrush();
	}

	, 
	shouldAddAutoMargins: function () {
		return true;
	}

	, 
	updateDataSources: function () {
		$.ig.SeriesViewer.prototype.updateDataSources.call(this);
		if (!this.manageDataSources()) {
			return;
		}

		var en = this.axes().getEnumerator();
		while (en.moveNext()) {
			var axis = en.current();
			this.updateDataSourceFor(axis);
		}

	}

	, 
	getBrushByIndex: function (index) {
		return this.getBrushByIndex1(index, this.brushes());
	}

	, 
	getBrushByIndex1: function (index, brushes) {
		if (brushes != null && brushes.count() > 0) {
			return brushes.item(index % brushes.count());

		} else {
			return null;
		}

	}

	, 
	getMarkerBrushByIndex: function (index) {
		return this.getBrushByIndex1(index, this.markerBrushes());
	}

	, 
	getMarkerOutlineByIndex: function (index) {
		return this.getBrushByIndex1(index, this.markerOutlines());
	}

	, 
	getOutlineByIndex: function (index) {
		return this.getBrushByIndex1(index, this.outlines());
	}

	, 
	effectiveIsSquare: function () {
		if (this.isSquare()) {
			return true;
		}

		return this.hasPolarOrRadial();
	}

	, 
	hasPolarOrRadial: function () {
		var $self = this;
		var polarAndRadial = $.ig.Enumerable.prototype.select$2($.ig.Series.prototype.$type, $.ig.Series.prototype.$type, ($.ig.Enumerable.prototype.where$1($.ig.Series.prototype.$type, ($self.series()), function (series) { return $.ig.util.cast($.ig.RadialBase.prototype.$type, series) !== null || $.ig.util.cast($.ig.PolarBase.prototype.$type, series) !== null; })), function (series) { return series; });
		if ($.ig.Enumerable.prototype.any$1($.ig.Series.prototype.$type, polarAndRadial)) {
			return true;
		}

		var angleAndRadius = $.ig.Enumerable.prototype.select$2($.ig.Axis.prototype.$type, $.ig.Axis.prototype.$type, ($.ig.Enumerable.prototype.where$1($.ig.Axis.prototype.$type, ($self.axes()), function (axis) { return $.ig.util.cast($.ig.NumericAngleAxis.prototype.$type, axis) !== null || $.ig.util.cast($.ig.NumericRadiusAxis.prototype.$type, axis) !== null || $.ig.util.cast($.ig.CategoryAngleAxis.prototype.$type, axis) !== null; })), function (axis) { return axis; });
		if ($.ig.Enumerable.prototype.any$1($.ig.Axis.prototype.$type, angleAndRadius)) {
			return true;
		}

		return false;
	}

	, 
	createView: function () {
		return new $.ig.XamDataChartView(this);
	}

	, 
	onViewCreated: function (view) {
		$.ig.SeriesViewer.prototype.onViewCreated.call(this, view);
		this.chartView(view);
	}

	, 
	_chartView: null,
	chartView: function (value) {
		if (arguments.length === 1) {
			this._chartView = value;
			return value;
		} else {
			return this._chartView;
		}
	}

	, 
	refreshAllContentAfterTiledZoom: function () {
		for (var i = 0; i < this._axes.count(); i++) {
			this._axes.__inner[i].mustInvalidateLabels(true);
			this._axes.__inner[i].renderAxis1(false);
		}

		$.ig.SeriesViewer.prototype.refreshAllContentAfterTiledZoom.call(this);
	}

	, 
	plotAreaBackgroundContent: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.XamDataChart.prototype.plotAreaBackgroundContentProperty, value);
			return value;
		} else {

			return this.getValue($.ig.XamDataChart.prototype.plotAreaBackgroundContentProperty);
		}
	}

	, 
	exportVisualData: function () {
		var cvd = new $.ig.ChartVisualData();
		for (var i = 0; i < this.axes().count(); i++) {
			var avd = this.axes().__inner[i].exportVisualData();
			cvd.axes().add(avd);
		}

		for (var i1 = 0; i1 < this.series().count(); i1++) {
			var svd = this.series().__inner[i1].exportVisualData();
			cvd.series().add(svd);
		}

		cvd.name(this.name());
		this.exportTitleData(cvd);
		this.view().exportChartData(cvd);
		return cvd;
	}

	, 
	prepareAxesForTiledZoom: function () {
		$.ig.SeriesViewer.prototype.prepareAxesForTiledZoom.call(this);
		for (var i = 0; i < this.axes().count(); i++) {
			var currentAxis = this.axes().__inner[i];
			var extent = 50;
			if (!$.ig.util.isNaN(currentAxis.labelPanel().extent())) {
				extent = currentAxis.labelPanel().extent();
			}

			currentAxis.extentOverride(extent);
		}

	}

	, 
	releaseAxesFromTiledZoom: function () {
		$.ig.SeriesViewer.prototype.releaseAxesFromTiledZoom.call(this);
		for (var i = 0; i < this.axes().count(); i++) {
			var currentAxis = this.axes().__inner[i];
			currentAxis.extentOverride(NaN);
			currentAxis.mustInvalidateLabels(true);
			currentAxis.renderAxis1(false);
		}

	}
	, 
	$type: new $.ig.Type('XamDataChart', $.ig.SeriesViewer.prototype.$type)
}, true);

$.ig.util.defType('XamDataChartView', 'SeriesViewerView', {
	init: function (model) {



		$.ig.SeriesViewerView.prototype.init.call(this, model);
			this.chartModel(model);
	}

	, 
	_chartModel: null,
	chartModel: function (value) {
		if (arguments.length === 1) {
			this._chartModel = value;
			return value;
		} else {
			return this._chartModel;
		}
	}

	, 
	updateGridMode: function (newValue) {
		this.model().canvasRenderScheduler().sortDirty();
	}

	, 
	preRenderOverride: function () {
		$.ig.SeriesViewerView.prototype.preRenderOverride.call(this);
		if (this.attachedAxes().count() == 0 && this.mainContext() != null) {
			this.mainContext().clearRectangle(0, 0, this.containerWidth(), this.containerHeight());
		}

	}

	, 
	setDefaultBrushes: function () {
		var $self = this;
		var brushes;
		var outlines;
		var fontBrush;
		var font;
		var axisLineBrush, axisStroke, axisMajorStroke, axisMinorStroke;
		var areaFillOpacity = 1, categoryAxisTickLength = 0;
		var alignsGridLines = false;
		(function () { var $ret = $self.viewManager().getDefaultPalette(brushes, outlines, fontBrush, font, axisLineBrush); brushes = $ret.p0; outlines = $ret.p1; fontBrush = $ret.p2; font = $ret.p3; axisLineBrush = $ret.p4; return $ret.ret; }());
		var chartMargins;
		(function () { var $ret = $self.viewManager().getChartSpecificDefaults(areaFillOpacity, chartMargins, axisStroke, axisMajorStroke, categoryAxisTickLength, alignsGridLines); areaFillOpacity = $ret.p0; chartMargins = $ret.p1; axisStroke = $ret.p2; axisMajorStroke = $ret.p3; categoryAxisTickLength = $ret.p4; alignsGridLines = $ret.p5; return $ret.ret; }());
		$self.model().topMargin(chartMargins[0]);
		$self.model().rightMargin(chartMargins[1]);
		$self.model().bottomMargin(chartMargins[2]);
		$self.model().leftMargin(chartMargins[3]);
		$self.chartModel().defaultAxisStroke(axisLineBrush);
		$self.chartModel().defaultAxisMajorStroke(axisLineBrush);
		$self.chartModel().defaultAxisMinorStroke(axisLineBrush);
		$self.chartModel().alignsGridLinesToPixels(alignsGridLines);
		$self.cssAxisStroke(axisStroke);
		$self.cssAxisMajorStroke(axisMajorStroke);
		$self.chartModel().brushes(brushes);
		$self.chartModel().outlines(outlines);
		$self.chartModel().markerBrushes(brushes);
		$self.chartModel().markerOutlines(outlines);
		$self.fontBrush(fontBrush);
		$self.font(font);
		$self.axisLineBrush(axisLineBrush);
		$self.defaultAreaFillOpacity(areaFillOpacity);
		$self.defaultCategoryAxisTickLength(categoryAxisTickLength);
	}

	, 
	_fontBrush: null,
	fontBrush: function (value) {
		if (arguments.length === 1) {
			this._fontBrush = value;
			return value;
		} else {
			return this._fontBrush;
		}
	}

	, 
	_axisLineBrush: null,
	axisLineBrush: function (value) {
		if (arguments.length === 1) {
			this._axisLineBrush = value;
			return value;
		} else {
			return this._axisLineBrush;
		}
	}

	, 
	_cssAxisStroke: null,
	cssAxisStroke: function (value) {
		if (arguments.length === 1) {
			this._cssAxisStroke = value;
			return value;
		} else {
			return this._cssAxisStroke;
		}
	}

	, 
	_cssAxisMajorStroke: null,
	cssAxisMajorStroke: function (value) {
		if (arguments.length === 1) {
			this._cssAxisMajorStroke = value;
			return value;
		} else {
			return this._cssAxisMajorStroke;
		}
	}

	, 
	_defaultAreaFillOpacity: 0,
	defaultAreaFillOpacity: function (value) {
		if (arguments.length === 1) {
			this._defaultAreaFillOpacity = value;
			return value;
		} else {
			return this._defaultAreaFillOpacity;
		}
	}

	, 
	_defaultCategoryAxisTickLength: 0,
	defaultCategoryAxisTickLength: function (value) {
		if (arguments.length === 1) {
			this._defaultCategoryAxisTickLength = value;
			return value;
		} else {
			return this._defaultCategoryAxisTickLength;
		}
	}

	, 
	onContainerProvided: function (container) {
		$.ig.SeriesViewerView.prototype.onContainerProvided.call(this, container);
	}

	, 
	renderOverride: function () {
		this.horizontalCrosshairLine().strokeThickness(1);
		this.verticalCrosshairLine().strokeThickness(1);
		this.horizontalCrosshairLine().__stroke = this.fontBrush();
		this.verticalCrosshairLine().__stroke = this.fontBrush();
		$.ig.SeriesViewerView.prototype.renderOverride.call(this);
	}

	, 
	_font: null,
	font: function (value) {
		if (arguments.length === 1) {
			this._font = value;
			return value;
		} else {
			return this._font;
		}
	}
	, 
	$type: new $.ig.Type('XamDataChartView', $.ig.SeriesViewerView.prototype.$type)
}, true);

$.ig.util.defType('ChartCollection', 'ObservableCollection$1', {
	init: function () {



		$.ig.ObservableCollection$1.prototype.init.call(this, $.ig.SeriesViewer.prototype.$type, 0);
	}
	, 
	collectionResetting: null
	, 
	clearItems: function () {
		if (this.collectionResetting != null) {
			this.collectionResetting(this, null);
		}

		$.ig.ObservableCollection$1.prototype.clearItems.call(this);
	}
	, 
	$type: new $.ig.Type('ChartCollection', $.ig.ObservableCollection$1.prototype.$type.specialize($.ig.SeriesViewer.prototype.$type))
}, true);

$.ig.util.defType('ChartContentManager', 'DependencyObject', {
	__owner: null
	, 
	__content: null
	, 
	__seriesList: null

	, 
	seriesList: function (value) {
		if (arguments.length === 1) {

			this.__seriesList = value;
			return value;
		} else {

			return this.__seriesList;
		}
	}
	, 
	init: function (owner) {


		this.__owner = null;
		this.__content = new $.ig.Dictionary$2($.ig.ChartContentType.prototype.$type, $.ig.Dictionary$2.prototype.$type.specialize($.ig.DependencyObject.prototype.$type, $.ig.ContentInfo.prototype.$type), 0);
		this.__seriesList = new $.ig.List$1($.ig.Series.prototype.$type, 0);
		this.__pending = false;

		$.ig.DependencyObject.prototype.init.call(this);
			this.firstTime(true);
			this.firstMeasure(true);
			this.__content.add($.ig.ChartContentType.prototype.series, new $.ig.Dictionary$2($.ig.DependencyObject.prototype.$type, $.ig.ContentInfo.prototype.$type, 0));
			this.__content.add($.ig.ChartContentType.prototype.axis, new $.ig.Dictionary$2($.ig.DependencyObject.prototype.$type, $.ig.ContentInfo.prototype.$type, 0));
			this.__content.add($.ig.ChartContentType.prototype.background, new $.ig.Dictionary$2($.ig.DependencyObject.prototype.$type, $.ig.ContentInfo.prototype.$type, 0));
			this.__owner = owner;
	}

	, 
	subscribe: function (type, obj, refresh) {
		var info = this.getInfo(type, obj);
		info.refresh(refresh);
		return info;
	}

	, 
	unsubscribe: function (type, obj) {
		var ofType = this.__content.item(type);
		if (ofType.containsKey(obj)) {
			ofType.remove(obj);
		}

		var s = $.ig.util.cast($.ig.Series.prototype.$type, obj);
		if (s != null && this.seriesList().contains(s)) {
			this.seriesList().remove(s);
		}

	}
	, 
	__pending: false

	, 
	makePending: function () {
		if (!this.__pending) {
			this.__pending = true;
			window.setTimeout(this.doRefresh.runOn(this), 0);
		}

	}

	, 
	refresh: function (type, obj, info, animate) {
		var contentInfo = info;
		if (!contentInfo.isDirty()) {
			contentInfo.doAnimation(animate);

		} else {
			if (!animate) {
				contentInfo.doAnimation(false);
			}

		}

		if (!contentInfo.isDirty()) {
			contentInfo.isDirty(true);
			this.makePending();
		}

	}

	, 
	_previewRefreshPending: false,
	previewRefreshPending: function (value) {
		if (arguments.length === 1) {
			this._previewRefreshPending = value;
			return value;
		} else {
			return this._previewRefreshPending;
		}
	}

	, 
	getInfo: function (type, obj) {
		var $self = this;
		var ofType = $self.__content.item(type);
		var info = null;
		if (!(function () { var $ret = ofType.tryGetValue(obj, info); info = $ret.p1; return $ret.ret; }())) {
			info = new $.ig.ContentInfo();
			info.content(obj);
			ofType.add(obj, info);
			var s = $.ig.util.cast($.ig.Series.prototype.$type, obj);
			if (s != null && !$self.seriesList().contains(s)) {
				if ($.ig.util.cast($.ig.FragmentBase.prototype.$type, s) !== null || $.ig.util.cast($.ig.SplineFragmentBase.prototype.$type, s) !== null) {
					var fragmentSeries = $.ig.util.cast($.ig.FragmentBase.prototype.$type, s);
					var splineFragmentSeries = $.ig.util.cast($.ig.SplineFragmentBase.prototype.$type, s);
					var parentSeries = fragmentSeries != null ? fragmentSeries.parentSeries() : splineFragmentSeries.parentSeries();
					var logicalSeries = fragmentSeries != null ? fragmentSeries.logicalSeriesLink() : splineFragmentSeries.logicalSeriesLink();
					var index = 0;
					if ($self.seriesList().indexOf(parentSeries) == 0) {
					index++;
					}

					index += parentSeries.series().indexOf(logicalSeries);
					if ($self.seriesList().count() <= index || parentSeries.series().count() == 0 || index == -1) {
						$self.seriesList().add(s);

					} else {
						$self.seriesList().insert(index, s);
					}


				} else {
					$self.seriesList().add(s);
				}

			}

		}

		return info;
	}

	, 
	force: function () {
		this.doRefresh();
	}

	, 
	doRefresh: function () {
		if (this.__owner == null || this.__content == null) {
			return;
		}

		if (!this.__pending) {
			return;
		}

		if (this.__owner != null) {
			this.__owner.beforeContentRefresh();
		}

		this.__pending = false;
		var en = this.inOrder().getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			item.doRefresh();
		}

		if (!this.__pending) {
			this.__owner.raiseRefreshCompleted();
		}

	}

	, 
	inOrder: function () {
		var d__ = new $.ig.ChartContentManager___InOrder__IteratorClass(-2);
		d__.__4__this = this;
		return d__;
	}

	, 
	ensureAxesRendered: function (plotSize) {
		var en = this.__content.item($.ig.ChartContentType.prototype.axis).values().getEnumerator();
		while (en.moveNext()) {
			var info = en.current();
			($.ig.util.cast($.ig.Axis.prototype.$type, info.content())).overrideViewport();
		}

		var en1 = this.__content.item($.ig.ChartContentType.prototype.axis).values().getEnumerator();
		while (en1.moveNext()) {
			var info1 = en1.current();
			info1.doRefresh();
		}

		var en2 = this.__content.item($.ig.ChartContentType.prototype.axis).values().getEnumerator();
		while (en2.moveNext()) {
			var info2 = en2.current();
			($.ig.util.cast($.ig.Axis.prototype.$type, info2.content())).viewportOverride($.ig.Rect.prototype.empty());
		}

	}

	, 
	_firstMeasure: false,
	firstMeasure: function (value) {
		if (arguments.length === 1) {
			this._firstMeasure = value;
			return value;
		} else {
			return this._firstMeasure;
		}
	}

	, 
	_firstTime: false,
	firstTime: function (value) {
		if (arguments.length === 1) {
			this._firstTime = value;
			return value;
		} else {
			return this._firstTime;
		}
	}

	, 
	viewportChanged: function (chartContentType, obj, info, newViewportRect) {
		info.viewport(newViewportRect);
	}

	, 
	rangeDirty: function (axis, info) {
		if (!info.rangeDirty()) {
			info.rangeDirty(true);
			this.makePending();
		}

	}
	, 
	$type: new $.ig.Type('ChartContentManager', $.ig.DependencyObject.prototype.$type)
}, true);

$.ig.util.defType('ContentInfo', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	_content: null,
	content: function (value) {
		if (arguments.length === 1) {
			this._content = value;
			return value;
		} else {
			return this._content;
		}
	}

	, 
	_refresh: null,
	refresh: function (value) {
		if (arguments.length === 1) {
			this._refresh = value;
			return value;
		} else {
			return this._refresh;
		}
	}

	, 
	_doAnimation: false,
	doAnimation: function (value) {
		if (arguments.length === 1) {
			this._doAnimation = value;
			return value;
		} else {
			return this._doAnimation;
		}
	}

	, 
	_isDirty: false,
	isDirty: function (value) {
		if (arguments.length === 1) {
			this._isDirty = value;
			return value;
		} else {
			return this._isDirty;
		}
	}

	, 
	_viewport: null,
	viewport: function (value) {
		if (arguments.length === 1) {
			this._viewport = value;
			return value;
		} else {
			return this._viewport;
		}
	}

	, 
	isViewportValid: function () {

			if (this.viewport().isEmpty()) {
				return false;
			}

			if (this.viewport().width() == 0 && this.viewport().height() == 0) {
				return false;
			}

			return true;
	}

	, 
	undirtyRange: function () {
		if (this.rangeDirty() && $.ig.util.cast($.ig.Axis.prototype.$type, this.content()) !== null) {
			this.rangeDirty(false);
			var wasDirty = this.isDirty();
			this.isDirty(true);
			var ret = ($.ig.util.cast($.ig.Axis.prototype.$type, this.content())).updateRange1(true);
			if (!ret) {
				this.isDirty(wasDirty);
			}

		}

	}

	, 
	doRefresh: function () {
		this.undirtyRange();
		if ($.ig.util.cast($.ig.Axis.prototype.$type, this.content()) !== null) {
			var axis = $.ig.util.cast($.ig.Axis.prototype.$type, this.content());
			if (axis.crossingAxis() != null) {
				var crossing = axis.crossingAxis();
				if (crossing.contentInfo() != null && crossing.contentInfo().rangeDirty()) {
					crossing.contentInfo().undirtyRange();
				}

			}

		}

		if (this.isDirty()) {
			this.isDirty(false);
			this.refresh()(this.doAnimation());
			this.doAnimation(false);
		}

	}

	, 
	_rangeDirty: false,
	rangeDirty: function (value) {
		if (arguments.length === 1) {
			this._rangeDirty = value;
			return value;
		} else {
			return this._rangeDirty;
		}
	}
	, 
	$type: new $.ig.Type('ContentInfo', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('DataContext', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	_series: null,
	series: function (value) {
		if (arguments.length === 1) {
			this._series = value;
			return value;
		} else {
			return this._series;
		}
	}

	, 
	_item: null,
	item: function (value) {
		if (arguments.length === 1) {
			this._item = value;
			return value;
		} else {
			return this._item;
		}
	}

	, 
	_actualItemBrush: null,
	actualItemBrush: function (value) {
		if (arguments.length === 1) {
			this._actualItemBrush = value;
			return value;
		} else {
			return this._actualItemBrush;
		}
	}

	, 
	_outline: null,
	outline: function (value) {
		if (arguments.length === 1) {
			this._outline = value;
			return value;
		} else {
			return this._outline;
		}
	}

	, 
	_itemLabel: null,
	itemLabel: function (value) {
		if (arguments.length === 1) {
			this._itemLabel = value;
			return value;
		} else {
			return this._itemLabel;
		}
	}

	, 
	_itemBrush: null,
	itemBrush: function (value) {
		if (arguments.length === 1) {
			this._itemBrush = value;
			return value;
		} else {
			return this._itemBrush;
		}
	}

	, 
	_thickness: 0,
	thickness: function (value) {
		if (arguments.length === 1) {
			this._thickness = value;
			return value;
		} else {
			return this._thickness;
		}
	}

	, 
	flatten: function () {
		var series_ = this.series();
		var item_ = this.item();
		var actualItemBrush_ = this.actualItemBrush();
		var outline_ = this.outline();
		var itemLabel_ = this.itemLabel();
		var itemBrush_ = this.itemBrush();
		var thickness_ = this.thickness();
		return { item: item_, itemBrush: actualItemBrush_, outline: outline_, itemLabel: itemLabel_, thickness: thickness_ };
	}
	, 
	$type: new $.ig.Type('DataContext', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('PieSliceDataContext', 'DataContext', {
	init: function () {


		$.ig.DataContext.prototype.init.call(this);

	}
	, 
	_slice: null,
	slice: function (value) {
		if (arguments.length === 1) {
			this._slice = value;
			return value;
		} else {
			return this._slice;
		}
	}

	, 
	_percentValue: 0,
	percentValue: function (value) {
		if (arguments.length === 1) {
			this._percentValue = value;
			return value;
		} else {
			return this._percentValue;
		}
	}

	, 
	_isOthersSlice: false,
	isOthersSlice: function (value) {
		if (arguments.length === 1) {
			this._isOthersSlice = value;
			return value;
		} else {
			return this._isOthersSlice;
		}
	}

	, 
	flatten: function () {
		var ret_ = $.ig.DataContext.prototype.flatten.call(this);
		var percentValue_ = this.percentValue();
		var isOthersSlice_ = this.isOthersSlice();
		ret_.percentValue = percentValue_;
		ret_.isOthersSlice = isOthersSlice_;
		if (isOthersSlice_ && this.item() != null) {
			var items_ = [];
			var en = this.item().getEnumerator();
			while (en.moveNext()) {
				var currItem_ = en.current();
				items_.push(currItem_);
			}

			ret_.item = items_;
		}

		return ret_;
	}
	, 
	$type: new $.ig.Type('PieSliceDataContext', $.ig.DataContext.prototype.$type)
}, true);


$.ig.util.defType('LabelPanelArranger', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	preparePanels: function (labelPanels, gridAreaRect) {
		var en = labelPanels.getEnumerator();
		while (en.moveNext()) {
			var panel = en.current();
			var axis = panel.axis();
			var crossingAxis = axis.crossingAxis();
			crossingAxis = $.ig.LabelPanelArranger.prototype.ensurePolarCrossing(panel, axis, crossingAxis);
			var labelLocation = $.ig.LabelPanelArranger.prototype.resolveLabelLocation(panel);
			var desiredWidth = 0;
			var desiredHeight = 0;
			var desiredExtent = panel._actualExtent;
			if ($.ig.util.cast($.ig.SmartAxisLabelPanel.prototype.$type, panel) !== null) {
				desiredExtent = (panel).actualExtent1();
			}

			desiredWidth = desiredExtent;
			desiredHeight = desiredExtent;
			if (panel.axis().labelSettings() != null && panel.axis().labelSettings().visibility() != $.ig.Visibility.prototype.visible) {
				desiredHeight = 0;
				desiredWidth = 0;
			}

			if (panel.isHorizontalPanel()) {
				switch (labelLocation) {
					case $.ig.AxisLabelsLocation.prototype.outsideTop:
						gridAreaRect.y(Math.max(0, gridAreaRect.top() + desiredHeight));
						gridAreaRect.height(Math.max(0, gridAreaRect.height() - desiredHeight));
						axis.labelSettings().actualLocation($.ig.AxisLabelsLocation.prototype.outsideTop);
						break;
					case $.ig.AxisLabelsLocation.prototype.insideTop:
						if (crossingAxis != null && (panel.crossingValue() - gridAreaRect.top() < desiredHeight && $.ig.util.cast($.ig.HorizontalAxisLabelPanel.prototype.$type, panel) !== null)) {
							axis.labelSettings().actualLocation($.ig.AxisLabelsLocation.prototype.insideBottom);

						} else {
							axis.labelSettings().actualLocation($.ig.AxisLabelsLocation.prototype.insideTop);
						}

						break;
					case $.ig.AxisLabelsLocation.prototype.insideBottom:
						if (crossingAxis != null && (gridAreaRect.bottom() - panel.crossingValue() < desiredHeight && $.ig.util.cast($.ig.HorizontalAxisLabelPanel.prototype.$type, panel) !== null)) {
							if (axis.labelSettings() != null) {
								axis.labelSettings().actualLocation($.ig.AxisLabelsLocation.prototype.insideTop);
							}


						} else {
							if (axis.labelSettings() != null) {
								axis.labelSettings().actualLocation($.ig.AxisLabelsLocation.prototype.insideBottom);
							}

						}

						break;
					case $.ig.AxisLabelsLocation.prototype.outsideBottom:
					default:
						if (axis.labelSettings() != null) {
							axis.labelSettings().actualLocation($.ig.AxisLabelsLocation.prototype.outsideBottom);
						}

						gridAreaRect.height(Math.max(0, gridAreaRect.height() - desiredHeight));
						break;
				}

			}

			if ($.ig.util.cast($.ig.VerticalAxisLabelPanel.prototype.$type, panel) !== null) {
				switch (labelLocation) {
					case $.ig.AxisLabelsLocation.prototype.outsideRight:
						gridAreaRect.width(Math.max(0, gridAreaRect.width() - desiredWidth));
						axis.labelSettings().actualLocation($.ig.AxisLabelsLocation.prototype.outsideRight);
						break;
					case $.ig.AxisLabelsLocation.prototype.insideLeft:
						if (crossingAxis != null && panel.crossingValue() - gridAreaRect.left() < desiredWidth) {
							axis.labelSettings().actualLocation($.ig.AxisLabelsLocation.prototype.insideRight);

						} else {
							axis.labelSettings().actualLocation($.ig.AxisLabelsLocation.prototype.insideLeft);
						}

						break;
					case $.ig.AxisLabelsLocation.prototype.insideRight:
						if (crossingAxis != null && gridAreaRect.right() - panel.crossingValue() < desiredWidth) {
							axis.labelSettings().actualLocation($.ig.AxisLabelsLocation.prototype.insideLeft);

						} else {
							axis.labelSettings().actualLocation($.ig.AxisLabelsLocation.prototype.insideRight);
						}

						break;
					case $.ig.AxisLabelsLocation.prototype.outsideLeft:
					default:
						if (axis.labelSettings() != null) {
							axis.labelSettings().actualLocation($.ig.AxisLabelsLocation.prototype.outsideLeft);
						}

						gridAreaRect.x(Math.max(0, gridAreaRect.left() + desiredWidth));
						gridAreaRect.width(Math.max(0, gridAreaRect.width() - desiredWidth));
						break;
				}

			}

			if ($.ig.util.cast($.ig.AngleAxisLabelPanel.prototype.$type, panel) !== null) {
				if (axis.labelSettings() != null) {
					axis.labelSettings().actualLocation(labelLocation);
				}

			}

		}

		return gridAreaRect;
	}

	, 
	ensurePolarCrossing: function (panel, axis, crossingAxis) {
		if ($.ig.util.cast($.ig.RadialAxisLabelPanel.prototype.$type, panel) !== null && $.ig.util.cast($.ig.NumericRadiusAxis.prototype.$type, axis) !== null) {
			crossingAxis = ($.ig.util.cast($.ig.NumericRadiusAxis.prototype.$type, axis)).angleAxis();
		}

		if ($.ig.util.cast($.ig.AngleAxisLabelPanel.prototype.$type, panel) !== null && $.ig.util.cast($.ig.NumericAngleAxis.prototype.$type, axis) !== null) {
			crossingAxis = ($.ig.util.cast($.ig.NumericAngleAxis.prototype.$type, axis)).radiusAxis();
		}

		if ($.ig.util.cast($.ig.AngleAxisLabelPanel.prototype.$type, panel) !== null && $.ig.util.cast($.ig.CategoryAngleAxis.prototype.$type, axis) !== null) {
			crossingAxis = ($.ig.util.cast($.ig.CategoryAngleAxis.prototype.$type, axis)).radiusAxis();
		}

		return crossingAxis;
	}

	, 
	resolveLabelLocation: function (panel) {
		if (panel == null) {
			return $.ig.AxisLabelsLocation.prototype.outsideBottom;

		} else {
			var axis = panel.axis();
			if (axis != null && axis.labelSettings() != null) {
				var location = axis.labelSettings().actualLocation();
				if (!panel.validLocation(location)) {
					return panel.getDefaultLabelsLocation();
				}

				return location;

			} else {
				return panel.getDefaultLabelsLocation();
			}

		}

	}

	, 
	arrangeLabelPanel: function (panel, arrangeState, gridAreaRect, setBounds) {
		var axis = panel.axis();
		var crossingAxis = axis.crossingAxis();
		crossingAxis = $.ig.LabelPanelArranger.prototype.ensurePolarCrossing(panel, axis, crossingAxis);
		var labelLocation = $.ig.LabelPanelArranger.prototype.resolveLabelLocation(panel);
		var bounds;
		var desiredExtent = panel._actualExtent;
		if ($.ig.util.cast($.ig.SmartAxisLabelPanel.prototype.$type, panel) !== null) {
			desiredExtent = (panel).actualExtent1();
		}

		var panelHeight = desiredExtent;
		var panelWidth = desiredExtent;
		if (panel.axis() != null && panel.axis().labelSettings() != null && panel.axis().labelSettings().visibility() == $.ig.Visibility.prototype.collapsed) {
			return;
		}

		switch (labelLocation) {
			case $.ig.AxisLabelsLocation.prototype.outsideRight:
				arrangeState.right(arrangeState.right() - panelWidth);
				arrangeState.insideRight(arrangeState.insideRight() - panelWidth);
				bounds = new $.ig.Rect(0, arrangeState.right(), gridAreaRect.top(), panelWidth, gridAreaRect.height());
				setBounds(panel, bounds);
				break;
			case $.ig.AxisLabelsLocation.prototype.outsideLeft:
				bounds = new $.ig.Rect(0, arrangeState.left(), gridAreaRect.top(), panelWidth, gridAreaRect.height());
				setBounds(panel, bounds);
				arrangeState.left(arrangeState.left() + panelWidth);
				arrangeState.insideLeft(arrangeState.insideLeft() + panelWidth);
				break;
			case $.ig.AxisLabelsLocation.prototype.insideRight:
				if (crossingAxis != null) {
					bounds = new $.ig.Rect(0, arrangeState.left() + panel.crossingValue(), gridAreaRect.top(), panelWidth, gridAreaRect.height());

				} else {
					arrangeState.insideRight(arrangeState.insideRight() - panelWidth);
					bounds = new $.ig.Rect(0, arrangeState.insideRight(), gridAreaRect.top(), panelWidth, gridAreaRect.height());
				}

				setBounds(panel, bounds);
				break;
			case $.ig.AxisLabelsLocation.prototype.insideLeft:
				if (crossingAxis != null) {
					bounds = new $.ig.Rect(0, arrangeState.left() + panel.crossingValue() - panelWidth, gridAreaRect.top(), panelWidth, gridAreaRect.height());

				} else {
					bounds = new $.ig.Rect(0, arrangeState.insideLeft(), gridAreaRect.top(), panelWidth, gridAreaRect.height());
					arrangeState.insideLeft(arrangeState.insideLeft() + panelWidth);
				}

				setBounds(panel, bounds);
				break;
			case $.ig.AxisLabelsLocation.prototype.outsideBottom:
				arrangeState.bottom(arrangeState.bottom() - panelHeight);
				arrangeState.insideBottom(arrangeState.insideBottom() - panelHeight);
				bounds = new $.ig.Rect(0, gridAreaRect.left(), arrangeState.bottom(), gridAreaRect.width(), panelHeight);
				setBounds(panel, bounds);
				break;
			case $.ig.AxisLabelsLocation.prototype.outsideTop:
				bounds = new $.ig.Rect(0, gridAreaRect.left(), arrangeState.top(), gridAreaRect.width(), panelHeight);
				setBounds(panel, bounds);
				arrangeState.top(arrangeState.top() + panelHeight);
				arrangeState.insideTop(arrangeState.insideTop() + panelHeight);
				break;
			case $.ig.AxisLabelsLocation.prototype.insideBottom:
				if (crossingAxis != null) {
					bounds = new $.ig.Rect(0, gridAreaRect.left(), arrangeState.top() + panel.crossingValue(), gridAreaRect.width(), panelHeight);

				} else {
					arrangeState.insideBottom(arrangeState.insideBottom() - panelHeight);
					bounds = new $.ig.Rect(0, gridAreaRect.left(), arrangeState.insideBottom(), gridAreaRect.width(), panelHeight);
				}

				setBounds(panel, bounds);
				break;
			case $.ig.AxisLabelsLocation.prototype.insideTop:
				if (crossingAxis != null) {
					bounds = new $.ig.Rect(0, gridAreaRect.left(), arrangeState.top() + panel.crossingValue() - panelHeight, gridAreaRect.width(), panelHeight);

				} else {
					bounds = new $.ig.Rect(0, gridAreaRect.left(), arrangeState.insideTop(), gridAreaRect.width(), panelHeight);
					arrangeState.insideTop(arrangeState.insideTop() + panelHeight);
				}

				setBounds(panel, bounds);
				break;
		}

		if ($.ig.util.cast($.ig.AngleAxisLabelPanel.prototype.$type, panel) !== null) {
			bounds = new $.ig.Rect(0, gridAreaRect.left(), gridAreaRect.top(), gridAreaRect.width(), gridAreaRect.height());
			setBounds(panel, bounds);
		}

	}

	, 
	arrangePanels: function (labelPanels, arrangeState, gridAreaRect, setBounds) {
		var insidePanels = new $.ig.List$1($.ig.AxisLabelPanelBase.prototype.$type, 0);
		var outsidePanels = new $.ig.List$1($.ig.AxisLabelPanelBase.prototype.$type, 0);
		var en = labelPanels.getEnumerator();
		while (en.moveNext()) {
			var panel = en.current();
			var labelLocation = $.ig.LabelPanelArranger.prototype.resolveLabelLocation(panel);
			switch (labelLocation) {
				case $.ig.AxisLabelsLocation.prototype.outsideBottom:
				case $.ig.AxisLabelsLocation.prototype.outsideLeft:
				case $.ig.AxisLabelsLocation.prototype.outsideTop:
				case $.ig.AxisLabelsLocation.prototype.outsideRight:
					outsidePanels.add(panel);
					break;
				case $.ig.AxisLabelsLocation.prototype.insideBottom:
				case $.ig.AxisLabelsLocation.prototype.insideLeft:
				case $.ig.AxisLabelsLocation.prototype.insideTop:
				case $.ig.AxisLabelsLocation.prototype.insideRight:
					insidePanels.add(panel);
					break;
			}

		}

		var en1 = outsidePanels.getEnumerator();
		while (en1.moveNext()) {
			var panel1 = en1.current();
			$.ig.LabelPanelArranger.prototype.arrangeLabelPanel(panel1, arrangeState, gridAreaRect, setBounds);
		}

		var en2 = insidePanels.getEnumerator();
		while (en2.moveNext()) {
			var panel2 = en2.current();
			$.ig.LabelPanelArranger.prototype.arrangeLabelPanel(panel2, arrangeState, gridAreaRect, setBounds);
		}

	}
	, 
	$type: new $.ig.Type('LabelPanelArranger', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('LabelPanelsArrangeState', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	_bottom: 0,
	bottom: function (value) {
		if (arguments.length === 1) {
			this._bottom = value;
			return value;
		} else {
			return this._bottom;
		}
	}

	, 
	_top: 0,
	top: function (value) {
		if (arguments.length === 1) {
			this._top = value;
			return value;
		} else {
			return this._top;
		}
	}

	, 
	_insideBottom: 0,
	insideBottom: function (value) {
		if (arguments.length === 1) {
			this._insideBottom = value;
			return value;
		} else {
			return this._insideBottom;
		}
	}

	, 
	_insideTop: 0,
	insideTop: function (value) {
		if (arguments.length === 1) {
			this._insideTop = value;
			return value;
		} else {
			return this._insideTop;
		}
	}

	, 
	_left: 0,
	left: function (value) {
		if (arguments.length === 1) {
			this._left = value;
			return value;
		} else {
			return this._left;
		}
	}

	, 
	_right: 0,
	right: function (value) {
		if (arguments.length === 1) {
			this._right = value;
			return value;
		} else {
			return this._right;
		}
	}

	, 
	_insideLeft: 0,
	insideLeft: function (value) {
		if (arguments.length === 1) {
			this._insideLeft = value;
			return value;
		} else {
			return this._insideLeft;
		}
	}

	, 
	_insideRight: 0,
	insideRight: function (value) {
		if (arguments.length === 1) {
			this._insideRight = value;
			return value;
		} else {
			return this._insideRight;
		}
	}
	, 
	$type: new $.ig.Type('LabelPanelsArrangeState', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('LegendTemplates', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	defaultLegendItemRender: function (info) {
		var cont = info.data;
		var s = cont.series();
		var template = s.legendItemBadgeTemplate();
		var title = s.title();
		if (title == null) {
			title = "Series Title";
		}

		$.ig.LegendTemplates.prototype.coreLegendItemRender(info.context, info.xPosition, info.yPosition, info.availableWidth, info.availableHeight, info.data, title.toString(), template, info.passInfo);
	}

	, 
	defaultDiscreteLegendItemRender: function (info) {
		var cont = info.data;
		var s = cont.series();
		var template = s.legendItemBadgeTemplate();
		var title = cont.itemLabel();
		if (title == null) {
			title = "Series Item";
		}

		$.ig.LegendTemplates.prototype.coreLegendItemRender(info.context, info.xPosition, info.yPosition, info.availableWidth, info.availableHeight, info.data, title.toString(), template, info.passInfo);
	}

	, 
	pieLegendItemRender: function (info) {
		var cont = info.data;
		var s = cont.series();
		var template = s.legendItemBadgeTemplate();
		var title = cont.itemLabel();
		if (title == null) {
			title = "Pie Item";
		}

		$.ig.LegendTemplates.prototype.coreLegendItemRender(info.context, info.xPosition, info.yPosition, info.availableWidth, info.availableHeight, info.data, title.toString(), template, info.passInfo);
	}

	, 
	doughnutLegendItemRender: function (info) {
		var cont = info.data;
		var s = cont.series();
		var template = s.legendItemBadgeTemplate();
		var title = cont.itemLabel();
		if (title == null) {
			title = "Doughnut Item";
		}

		$.ig.LegendTemplates.prototype.coreLegendItemRender(info.context, info.xPosition, info.yPosition, info.availableWidth, info.availableHeight, info.data, title.toString(), template, info.passInfo);
	}

	, 
	funnelLegendItemRender: function (info) {
		var cont = info.data;
		var s = cont.series();
		var template = s.legendItemBadgeTemplate();
		var title = cont.itemLabel();
		if (title == null) {
			title = "Funnel Item";
		}

		$.ig.LegendTemplates.prototype.coreLegendItemRender(info.context, info.xPosition, info.yPosition, info.availableWidth, info.availableHeight, info.data, title.toString(), template, info.passInfo);
	}

	, 
	coreLegendItemRender: function (context, xPosition, yPosition, availableWidth, availableHeight, data, title, template, passInfo) {
		var obj = context;
		var cont = data;
		if (cont != null && cont.series() != null) {
			if (template != null) {
				var badgeDom = $("<canvas></canvas>");
				badgeDom.attr("width", "18");
				badgeDom.attr("height", "16");
				var badgeCellDom = $("<td class=\'ui-legend-item-badge\'></td>");
				badgeCellDom.append(badgeDom);
				var badgeContext = (badgeDom[0]).getContext("2d");
				var measureInfo = new $.ig.DataTemplateMeasureInfo();
				measureInfo.passInfo = passInfo;
				measureInfo.context = badgeContext;
				measureInfo.width = 18;
				measureInfo.height = 16;
				measureInfo.data = cont;
				template.measure()(measureInfo);
				var renderInfo = new $.ig.DataTemplateRenderInfo();
				renderInfo.availableWidth = $.ig.util.isNaN(measureInfo.width) ? 18 : Math.min(measureInfo.width, 18);
				renderInfo.availableHeight = $.ig.util.isNaN(measureInfo.height) ? 16 : Math.min(measureInfo.height, 16);
				renderInfo.passInfo = passInfo;
				renderInfo.context = badgeContext;
				renderInfo.data = cont;
				renderInfo.xPosition = 0;
				renderInfo.yPosition = 0;
				template.render()(renderInfo);
				obj.append(badgeCellDom);
			}

			var titleDom = $("<td class=\'ui-legend-item-text\'><span>" + title + "</span></td>");
			obj.append(titleDom);
		}

	}

	, 
	pieBadgeTemplate: function (info) {
		var dc = info.data;
		var cont = info.context;
		var renderCont = new $.ig.RenderingContext(new $.ig.CanvasViewRenderer(), cont);
		var slice = dc.slice();
		var pieChart = dc.series();
		var itemBrush = pieChart.view().getActualBackground(slice);
		var itemOutline = pieChart.view().getActualOutline(slice);
		var rect = new $.ig.Rectangle();
		rect.width(info.availableWidth - (slice.strokeThickness() * 2) - 2);
		rect.height(info.availableHeight - (slice.strokeThickness() * 2));
		rect.canvasLeft(slice.strokeThickness() + 1);
		rect.canvasTop(slice.strokeThickness());
		rect.strokeThickness(slice.strokeThickness());
		rect.__fill = itemBrush;
		rect.__stroke = itemOutline;
		renderCont.renderRectangle(rect);
	}

	, 
	doughnutBadgeTemplate: function (info) {
		var dc = info.data;
		var cont = info.context;
		var renderCont = new $.ig.RenderingContext(new $.ig.CanvasViewRenderer(), cont);
		var slice = dc.slice();
		var pieChart = (dc.series()).ring().ringControl()._arcs.item(0);
		var itemBrush = pieChart.view().getActualBackground(slice);
		var itemOutline = pieChart.view().getActualOutline(slice);
		var rect = new $.ig.Rectangle();
		rect.width(info.availableWidth - (slice.strokeThickness() * 2) - 2);
		rect.height(info.availableHeight - (slice.strokeThickness() * 2));
		rect.canvasLeft(slice.strokeThickness() + 1);
		rect.canvasTop(slice.strokeThickness());
		rect.strokeThickness(slice.strokeThickness());
		rect.__fill = itemBrush;
		rect.__stroke = itemOutline;
		renderCont.renderRectangle(rect);
	}

	, 
	funnelBadgeTemplate: function (info) {
		var dc = info.data;
		var cont = info.context;
		if (dc.itemBrush() != null) {
			dc.actualItemBrush(dc.itemBrush());
		}

		if (dc.itemOutline() != null) {
			dc.outline(dc.itemOutline());
		}

		var renderCont = new $.ig.RenderingContext(new $.ig.CanvasViewRenderer(), cont);
		var strokeThickness = dc.thickness();
		if ($.ig.util.isNaN(strokeThickness)) {
		strokeThickness = 1;
		}

		var rect = new $.ig.Rectangle();
		rect.width(info.availableWidth - (strokeThickness * 2) - 2);
		rect.height(info.availableHeight - (strokeThickness * 2));
		rect.canvasLeft(strokeThickness + 1);
		rect.canvasTop(strokeThickness);
		rect.strokeThickness(strokeThickness);
		rect.__fill = dc.actualItemBrush();
		rect.__stroke = dc.outline();
		renderCont.renderRectangle(rect);
	}

	, 
	lineBadgeTemplate: function (info) {
		var dc = info.data;
		var cont = info.context;
		var s = dc.series();
		if (dc.itemBrush() != null) {
			dc.actualItemBrush(dc.itemBrush());

		} else {
			dc.actualItemBrush(s.actualBrush());
		}

		var renderCont = new $.ig.RenderingContext(new $.ig.CanvasViewRenderer(), cont);
		var line = new $.ig.Line();
		line.x1(0);
		line.y1(info.availableHeight / 2);
		line.x2(info.availableWidth);
		line.y2(info.availableHeight / 2);
		line.strokeThickness(s.thickness());
		line.__stroke = dc.actualItemBrush();
		line.strokeDashArray(s.dashArray());
		renderCont.renderLine(line);
		var m = $.ig.util.cast($.ig.MarkerSeries.prototype.$type, dc.series());
		if (m != null && m.actualMarkerTemplate() != null && m.actualMarkerTemplate().render() != null) {
			dc.outline(s.actualOutline());
			$.ig.LegendTemplates.prototype.renderMarkerTemplate(m.actualMarkerTemplate(), info);
		}

	}

	, 
	renderMarkerTemplate: function (template, info) {
		var measureInfo = new $.ig.DataTemplateMeasureInfo();
		measureInfo.passInfo = info.passInfo;
		measureInfo.width = 11;
		measureInfo.height = 11;
		measureInfo.data = info.data;
		measureInfo.context = info.context;
		measureInfo.renderContext = info.renderContext;
		var dc = info.data;
		var oldActualFill = dc.actualItemBrush();
		var oldFill = dc.itemBrush();
		if ($.ig.util.cast($.ig.Series.prototype.$type, dc.series()) !== null) {
			if (dc.itemBrush() == null) {
				var ser = dc.series();
				dc.actualItemBrush(ser.getActualMarkerBrush());
			}

		}

		if (template.measure() != null) {
			template.measure()(measureInfo);
			if ($.ig.util.isNaN(measureInfo.width) || Number.isInfinity(measureInfo.width) || measureInfo.width > 11) {
				measureInfo.width = 11;
			}

			if ($.ig.util.isNaN(measureInfo.height) || Number.isInfinity(measureInfo.height) || measureInfo.height > 11) {
				measureInfo.height = 11;
			}

		}

		var renderInfo = new $.ig.DataTemplateRenderInfo();
		renderInfo.passInfo = info.passInfo;
		renderInfo.availableWidth = measureInfo.width;
		renderInfo.availableHeight = measureInfo.height;
		renderInfo.xPosition = info.availableWidth / 2;
		renderInfo.yPosition = info.availableHeight / 2;
		renderInfo.data = info.data;
		renderInfo.context = info.context;
		renderInfo.renderContext = info.renderContext;
		template.render()(renderInfo);
		dc.itemBrush(oldFill);
		dc.actualItemBrush(oldActualFill);
	}

	, 
	updateItemBrush: function (dc) {
		var s = null;
		if ($.ig.util.cast($.ig.Series.prototype.$type, dc.series()) !== null) {
			s = dc.series();
		}

		if (dc.itemBrush() != null) {
			dc.actualItemBrush(dc.itemBrush());

		} else {
			if (s != null) {
				dc.actualItemBrush(s.actualBrush());

			} else {
				dc.actualItemBrush(dc.itemBrush());
			}

		}

	}

	, 
	defaultLegendItemMeasure: function (info) {
	}

	, 
	defaultDiscreteLegendItemMeasure: function (info) {
	}

	, 
	legendItemBadgeMeasure: function (info) {
	}

	, 
	rectBadgeTemplate: function (info) {
		var $self = this;
		var dc = info.data;
		var cont = info.context;
		$.ig.LegendTemplates.prototype.updateItemBrush(dc);
		var renderCont = new $.ig.RenderingContext(new $.ig.CanvasViewRenderer(), cont);
		var p = new $.ig.Path();
		var pg = new $.ig.PathGeometry();
		var f = new $.ig.PathFigure();
		f.__isFilled = true;
		f.__startPoint = {__x: 0, __y: 5, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		f.__segments.add(new $.ig.LineSegment(0, {__x: 0, __y: 14, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		f.__segments.add(new $.ig.LineSegment(0, {__x: 11, __y: 14, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		f.__segments.add((function () { var $ret = new $.ig.ArcSegment();
		$ret.size(new $.ig.Size(1, 5, 5));
		$ret.isLargeArc(false);
		$ret.point({__x: 16, __y: 9, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}); return $ret;}()));
		f.__segments.add(new $.ig.LineSegment(0, {__x: 16, __y: 0, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		f.__segments.add(new $.ig.LineSegment(0, {__x: 5, __y: 0, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		f.__segments.add((function () { var $ret = new $.ig.ArcSegment();
		$ret.size(new $.ig.Size(1, 5, 5));
		$ret.isLargeArc(false);
		$ret.point({__x: 0, __y: 5, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}); return $ret;}()));
		pg.figures().add(f);
		p.data(pg);
		if ($.ig.util.cast($.ig.Series.prototype.$type, dc.series()) !== null) {
			p.strokeThickness((dc.series()).thickness());
			p.__stroke = (dc.series()).actualOutline();
			p.strokeDashArray((dc.series()).dashArray());
		}

		p.__fill = dc.actualItemBrush();
		renderCont.renderPath(p);
		var m = $.ig.util.cast($.ig.MarkerSeries.prototype.$type, dc.series());
		if (m != null && m.actualMarkerTemplate() != null && m.actualMarkerTemplate().render() != null) {
			if ($.ig.util.cast($.ig.Series.prototype.$type, dc.series()) !== null) {
				dc.outline((dc.series()).actualOutline());
			}

			$.ig.LegendTemplates.prototype.renderMarkerTemplate(m.actualMarkerTemplate(), info);
		}

	}

	, 
	markerlessRectBadgeTemplate: function (info) {
		var $self = this;
		var dc = info.data;
		var cont = info.context;
		$.ig.LegendTemplates.prototype.updateItemBrush(dc);
		var p = new $.ig.Path();
		var pg = new $.ig.PathGeometry();
		var f = new $.ig.PathFigure();
		f.__isFilled = true;
		f.__startPoint = {__x: 0, __y: 5, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		f.__segments.add(new $.ig.LineSegment(0, {__x: 0, __y: 14, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		f.__segments.add(new $.ig.LineSegment(0, {__x: 11, __y: 14, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		f.__segments.add((function () { var $ret = new $.ig.ArcSegment();
		$ret.size(new $.ig.Size(1, 5, 5));
		$ret.isLargeArc(false);
		$ret.point({__x: 16, __y: 9, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}); return $ret;}()));
		f.__segments.add(new $.ig.LineSegment(0, {__x: 16, __y: 0, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		f.__segments.add(new $.ig.LineSegment(0, {__x: 5, __y: 0, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		f.__segments.add((function () { var $ret = new $.ig.ArcSegment();
		$ret.size(new $.ig.Size(1, 5, 5));
		$ret.isLargeArc(false);
		$ret.point({__x: 0, __y: 5, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}); return $ret;}()));
		pg.figures().add(f);
		p.data(pg);
		if ($.ig.util.cast($.ig.Series.prototype.$type, dc.series()) !== null) {
			p.strokeThickness((dc.series()).thickness());
			p.__stroke = (dc.series()).actualOutline();
			p.strokeDashArray((dc.series()).dashArray());
		}

		p.__fill = dc.actualItemBrush();
		var renderCont = new $.ig.RenderingContext(new $.ig.CanvasViewRenderer(), cont);
		renderCont.renderPath(p);
	}

	, 
	markerlessLineBadgeTemplate: function (info) {
		var dc = info.data;
		var cont = info.context;
		var s = dc.series();
		if (dc.itemBrush() != null) {
			dc.actualItemBrush(dc.itemBrush());

		} else {
			dc.actualItemBrush(s.actualBrush());
		}

		var line = new $.ig.Line();
		line.x1(0);
		line.y1(info.availableHeight / 2);
		line.x2(info.availableWidth);
		line.y2(info.availableHeight / 2);
		line.strokeThickness(s.thickness());
		line.strokeDashArray(s.dashArray());
		line.__stroke = dc.actualItemBrush();
		var renderCont = new $.ig.RenderingContext(new $.ig.CanvasViewRenderer(), cont);
		renderCont.renderLine(line);
	}

	, 
	pointBadgeTemplate: function (info) {
		var dc = info.data;
		$.ig.LegendTemplates.prototype.updateItemBrush(dc);
		var m = $.ig.util.cast($.ig.MarkerSeries.prototype.$type, dc.series());
		if (m != null && m.actualMarkerTemplate() != null && m.actualMarkerTemplate().render() != null) {
			if ($.ig.util.cast($.ig.Series.prototype.$type, dc.series()) !== null) {
				dc.outline((dc.series()).actualOutline());
			}

			$.ig.LegendTemplates.prototype.renderMarkerTemplate(m.actualMarkerTemplate(), info);
		}

	}

	, 
	positiveNegativeBadgeTemplate: function (info) {
		var $self = this;
		var dc = info.data;
		var cont = info.context;
		var s = dc.series();
		if (dc.itemBrush() != null) {
			dc.actualItemBrush(dc.itemBrush());

		} else {
			dc.actualItemBrush(s.actualBrush());
		}

		var p = new $.ig.Path();
		var pg = new $.ig.PathGeometry();
		var f = new $.ig.PathFigure();
		f.__isFilled = true;
		f.__startPoint = {__x: 0, __y: 5, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		f.__segments.add(new $.ig.LineSegment(0, {__x: 0, __y: 14, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		f.__segments.add(new $.ig.LineSegment(0, {__x: 16, __y: 0, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		f.__segments.add(new $.ig.LineSegment(0, {__x: 5, __y: 0, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		f.__segments.add((function () { var $ret = new $.ig.ArcSegment();
		$ret.size(new $.ig.Size(1, 5, 5));
		$ret.isLargeArc(false);
		$ret.point({__x: 0, __y: 5, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}); return $ret;}()));
		pg.figures().add(f);
		p.data(pg);
		if ($.ig.util.cast($.ig.Series.prototype.$type, dc.series()) !== null) {
			p.strokeThickness((dc.series()).thickness());
			p.__stroke = (dc.series()).actualOutline();
			p.strokeDashArray((dc.series()).dashArray());
		}

		p.__fill = dc.actualItemBrush();
		var p2 = new $.ig.Path();
		var pg2 = new $.ig.PathGeometry();
		var f2 = new $.ig.PathFigure();
		f2.__isFilled = true;
		f2.__startPoint = {__x: 0, __y: 14, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		f2.__segments.add(new $.ig.LineSegment(0, {__x: 11, __y: 14, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		f2.__segments.add((function () { var $ret = new $.ig.ArcSegment();
		$ret.size(new $.ig.Size(1, 5, 5));
		$ret.isLargeArc(false);
		$ret.point({__x: 16, __y: 9, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}); return $ret;}()));
		f2.__segments.add(new $.ig.LineSegment(0, {__x: 16, __y: 0, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		pg2.figures().add(f2);
		p2.data(pg2);
		if ($.ig.util.cast($.ig.Series.prototype.$type, dc.series()) !== null) {
			p2.strokeThickness((dc.series()).thickness());
			p2.__stroke = (dc.series()).actualOutline();
		}

		if ($.ig.util.cast($.ig.WaterfallSeries.prototype.$type, dc.series()) !== null) {
			p2.__fill = (dc.series()).negativeBrush();
		}

		var renderCont = new $.ig.RenderingContext(new $.ig.CanvasViewRenderer(), cont);
		renderCont.renderPath(p);
		renderCont.renderPath(p2);
		var m = $.ig.util.cast($.ig.MarkerSeries.prototype.$type, dc.series());
		if (m != null && m.actualMarkerTemplate() != null && m.actualMarkerTemplate().render() != null) {
			if ($.ig.util.cast($.ig.Series.prototype.$type, dc.series()) !== null) {
				dc.outline((dc.series()).actualOutline());
			}

			$.ig.LegendTemplates.prototype.renderMarkerTemplate(m.actualMarkerTemplate(), info);
		}

	}

	, 
	financialBadgeTemplate: function (info) {
		var $self = this;
		var dc = info.data;
		var cont = info.context;
		var s = dc.series();
		if (dc.itemBrush() != null) {
			dc.actualItemBrush(dc.itemBrush());

		} else {
			dc.actualItemBrush(s.actualBrush());
		}

		var p = new $.ig.Path();
		var pg = new $.ig.PathGeometry();
		var f = new $.ig.PathFigure();
		f.__isFilled = true;
		f.__startPoint = {__x: 0, __y: 5, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		f.__segments.add(new $.ig.LineSegment(0, {__x: 0, __y: 14, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		f.__segments.add(new $.ig.LineSegment(0, {__x: 16, __y: 0, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		f.__segments.add(new $.ig.LineSegment(0, {__x: 5, __y: 0, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		f.__segments.add((function () { var $ret = new $.ig.ArcSegment();
		$ret.size(new $.ig.Size(1, 5, 5));
		$ret.isLargeArc(false);
		$ret.point({__x: 0, __y: 5, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}); return $ret;}()));
		pg.figures().add(f);
		p.data(pg);
		if ($.ig.util.cast($.ig.Series.prototype.$type, dc.series()) !== null) {
			p.strokeThickness((dc.series()).thickness());
			p.__stroke = (dc.series()).actualOutline();
			p.strokeDashArray((dc.series()).dashArray());
		}

		p.__fill = dc.actualItemBrush();
		var p2 = new $.ig.Path();
		var pg2 = new $.ig.PathGeometry();
		var f2 = new $.ig.PathFigure();
		f2.__isFilled = true;
		f2.__startPoint = {__x: 0, __y: 14, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		f2.__segments.add(new $.ig.LineSegment(0, {__x: 11, __y: 14, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		f2.__segments.add((function () { var $ret = new $.ig.ArcSegment();
		$ret.size(new $.ig.Size(1, 5, 5));
		$ret.isLargeArc(false);
		$ret.point({__x: 16, __y: 9, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}); return $ret;}()));
		f2.__segments.add(new $.ig.LineSegment(0, {__x: 16, __y: 0, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		pg2.figures().add(f2);
		p2.data(pg2);
		if ($.ig.util.cast($.ig.Series.prototype.$type, dc.series()) !== null) {
			p2.strokeThickness((dc.series()).thickness());
			p2.__stroke = (dc.series()).actualOutline();
			p2.strokeDashArray((dc.series()).dashArray());
		}

		if ($.ig.util.cast($.ig.FinancialSeries.prototype.$type, dc.series()) !== null) {
			p2.__fill = (dc.series()).negativeBrush();
		}

		var renderCont = new $.ig.RenderingContext(new $.ig.CanvasViewRenderer(), cont);
		renderCont.renderPath(p);
		renderCont.renderPath(p2);
	}

	, 
	financialIndicatorBadgeTemplate: function (info) {
		var $self = this;
		var dc = info.data;
		var cont = info.context;
		var s = dc.series();
		if (dc.itemBrush() != null) {
			dc.actualItemBrush(dc.itemBrush());

		} else {
			dc.actualItemBrush(s.actualBrush());
		}

		var p = new $.ig.Path();
		var pg = new $.ig.PathGeometry();
		var f = new $.ig.PathFigure();
		f.__isFilled = true;
		f.__startPoint = {__x: 0, __y: 5, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		f.__segments.add(new $.ig.LineSegment(0, {__x: 0, __y: 14, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		f.__segments.add(new $.ig.LineSegment(0, {__x: 16, __y: 0, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		f.__segments.add(new $.ig.LineSegment(0, {__x: 5, __y: 0, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		f.__segments.add((function () { var $ret = new $.ig.ArcSegment();
		$ret.size(new $.ig.Size(1, 5, 5));
		$ret.isLargeArc(false);
		$ret.point({__x: 0, __y: 5, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}); return $ret;}()));
		pg.figures().add(f);
		p.data(pg);
		if ($.ig.util.cast($.ig.Series.prototype.$type, dc.series()) !== null) {
			p.strokeThickness((dc.series()).thickness());
			p.__stroke = (dc.series()).actualOutline();
			p.strokeDashArray((dc.series()).dashArray());
		}

		p.__fill = dc.actualItemBrush();
		var p2 = new $.ig.Path();
		var pg2 = new $.ig.PathGeometry();
		var f2 = new $.ig.PathFigure();
		f2.__isFilled = true;
		f2.__startPoint = {__x: 0, __y: 14, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		f2.__segments.add(new $.ig.LineSegment(0, {__x: 11, __y: 14, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		f2.__segments.add((function () { var $ret = new $.ig.ArcSegment();
		$ret.size(new $.ig.Size(1, 5, 5));
		$ret.isLargeArc(false);
		$ret.point({__x: 16, __y: 9, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}); return $ret;}()));
		f2.__segments.add(new $.ig.LineSegment(0, {__x: 16, __y: 0, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}));
		pg2.figures().add(f2);
		p2.data(pg2);
		if ($.ig.util.cast($.ig.Series.prototype.$type, dc.series()) !== null) {
			p2.strokeThickness((dc.series()).thickness());
			p2.__stroke = (dc.series()).actualOutline();
			p2.strokeDashArray((dc.series()).dashArray());
		}

		if ($.ig.util.cast($.ig.FinancialSeries.prototype.$type, dc.series()) !== null) {
			p2.__fill = (dc.series()).negativeBrush();
		}

		var renderCont = new $.ig.RenderingContext(new $.ig.CanvasViewRenderer(), cont);
		renderCont.renderPath(p);
		renderCont.renderPath(p2);
	}
	, 
	$type: new $.ig.Type('LegendTemplates', $.ig.Object.prototype.$type)
}, true);









$.ig.util.defType('RenderSurface', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	_surface: null,
	surface: function (value) {
		if (arguments.length === 1) {
			this._surface = value;
			return value;
		} else {
			return this._surface;
		}
	}
	, 
	$type: new $.ig.Type('RenderSurface', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('RenderRequestedEventArgs', 'EventArgs', {
	init: function () {


		$.ig.EventArgs.prototype.init.call(this);

	}
	, 
	_animate: false,
	animate: function (value) {
		if (arguments.length === 1) {
			this._animate = value;
			return value;
		} else {
			return this._animate;
		}
	}
	, 
	$type: new $.ig.Type('RenderRequestedEventArgs', $.ig.EventArgs.prototype.$type)
}, true);

$.ig.util.defType('HighlightingInfo', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.state($.ig.HighlightingState.prototype.outward);
			this.progress(0);
			this.isMarker(false);
	}

	, 
	_startIndex: 0,
	startIndex: function (value) {
		if (arguments.length === 1) {
			this._startIndex = value;
			return value;
		} else {
			return this._startIndex;
		}
	}

	, 
	_endIndex: 0,
	endIndex: function (value) {
		if (arguments.length === 1) {
			this._endIndex = value;
			return value;
		} else {
			return this._endIndex;
		}
	}

	, 
	_state: 0,
	state: function (value) {
		if (arguments.length === 1) {
			this._state = value;
			return value;
		} else {
			return this._state;
		}
	}

	, 
	_progress: 0,
	progress: function (value) {
		if (arguments.length === 1) {
			this._progress = value;
			return value;
		} else {
			return this._progress;
		}
	}

	, 
	_isMarker: false,
	isMarker: function (value) {
		if (arguments.length === 1) {
			this._isMarker = value;
			return value;
		} else {
			return this._isMarker;
		}
	}

	, 
	_series: null,
	series: function (value) {
		if (arguments.length === 1) {
			this._series = value;
			return value;
		} else {
			return this._series;
		}
	}
	, 
	$type: new $.ig.Type('HighlightingInfo', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('HighlightingManager', 'Object', {
	init: function () {


		this.__activeHighlights = new $.ig.Dictionary$2($.ig.HighlightingInfo.prototype.$type, $.ig.HighlightingInfo.prototype.$type, 0);
		this.__allHighlights = new $.ig.List$1($.ig.HighlightingInfo.prototype.$type, 0);
		this.__extraFlow = 0;
		this.__extraMarkerFlow = 0;
		this.__lastProgress = 0;
		this.__dirtySeriesMap = new $.ig.Dictionary$2($.ig.Series.prototype.$type, $.ig.Boolean.prototype.$type, 0);

		$.ig.Object.prototype.init.call(this);
			this.dirtySeries(new $.ig.List$1($.ig.Series.prototype.$type, 0));
	}
	, 
	__activeHighlights: null
	, 
	__allHighlights: null

	, 
	startHighlight: function (info) {
		if (info == null) {
			return;
		}

		this.inProgress(true);
		if (!this.__activeHighlights.containsKey(info)) {
			info.state($.ig.HighlightingState.prototype.inward);
			this.__activeHighlights.item(info, info);
			this.__allHighlights.add(info);
		}

		if (info.state() == $.ig.HighlightingState.prototype.outward) {
			info.state($.ig.HighlightingState.prototype.inward);
		}

	}
	, 
	__extraFlow: 0
	, 
	__extraMarkerFlow: 0

	, 
	endHighlight: function (info) {
		if (info == null) {
			return;
		}

		if (!this.__activeHighlights.containsKey(info)) {
			return;
		}

		if (info.state() == $.ig.HighlightingState.prototype.inward) {
			if (info.progress() < 0.05) {
				if (info.isMarker()) {
					this.__extraMarkerFlow = this.__extraMarkerFlow + info.progress();

				} else {
					this.__extraFlow = this.__extraFlow + info.progress();
				}

				this.__activeHighlights.remove(info);
				this.__allHighlights.remove(info);
				return;
			}

			info.state($.ig.HighlightingState.prototype.outward);
		}

		if (info.state() == $.ig.HighlightingState.prototype.static) {
			info.state($.ig.HighlightingState.prototype.outward);
			info.progress(1);
		}

	}

	, 
	clear: function () {
		this.__allHighlights.clear();
		this.__activeHighlights.clear();
	}

	, 
	getHighlightingInfo: function (owner, itemsSource, indexAxis, startIndex, endIndex, isMarker) {
		for (var i = 0; i < this.__allHighlights.count(); i++) {
			var info = this.__allHighlights.__inner[i];
			var start = info.startIndex();
			var end = info.endIndex();
			if (startIndex >= start && endIndex <= end && info.isMarker() == isMarker && owner == info.series() && (info.state() == $.ig.HighlightingState.prototype.inward || info.state() == $.ig.HighlightingState.prototype.static)) {
				return info;
			}

		}

		for (var i1 = 0; i1 < this.__allHighlights.count(); i1++) {
			var info1 = this.__allHighlights.__inner[i1];
			var start1 = info1.startIndex();
			var end1 = info1.endIndex();
			if (startIndex >= start1 && endIndex <= end1 && info1.isMarker() == isMarker && owner == info1.series() && (info1.state() == $.ig.HighlightingState.prototype.outward)) {
				return info1;
			}

		}

		return null;
	}
	, 
	__lastProgress: 0

	, 
	_dirtySeries: null,
	dirtySeries: function (value) {
		if (arguments.length === 1) {
			this._dirtySeries = value;
			return value;
		} else {
			return this._dirtySeries;
		}
	}
	, 
	__dirtySeriesMap: null

	, 
	tick: function (progress) {
		this.__dirtySeriesMap.clear();
		this.dirtySeries().clear();
		var deltaProgress = 0;
		if (this.__lastProgress > progress) {
			deltaProgress = (1 - this.__lastProgress) + progress;

		} else {
			deltaProgress = progress - this.__lastProgress;
		}

		this.__lastProgress = progress;
		var stillRunning = false;
		var toRemove = new $.ig.List$1($.ig.HighlightingInfo.prototype.$type, 0);
		this.maxHighlightingProgress(0);
		this.sumHighlightingProgress(0);
		this.maxMarkerHighlightingProgress(0);
		this.sumMarkerHighlightingProgress(0);
		var inMarkerExists = false;
		var inExists = false;
		var totalIn = 0;
		var totalOut = 0;
		var totalMarkerIn = 0;
		var totalMarkerOut = 0;
		var numOut = 0;
		var numMarkerOut = 0;
		for (var i = 0; i < this.__allHighlights.count(); i++) {
			var item = this.__allHighlights.__inner[i];
			if (item.state() == $.ig.HighlightingState.prototype.inward) {
				if (item.isMarker()) {
					inMarkerExists = true;
					totalMarkerIn = totalMarkerIn + Math.min(1 - item.progress(), deltaProgress);

				} else {
					inExists = true;
					totalIn = totalIn + Math.min(1 - item.progress(), deltaProgress);
				}

			}

			if (item.state() == $.ig.HighlightingState.prototype.outward) {
				if (item.isMarker()) {
					totalMarkerOut = totalMarkerOut + Math.min(item.progress(), deltaProgress);
					numMarkerOut++;

				} else {
					totalOut = totalOut + Math.min(item.progress(), deltaProgress);
					numOut++;
				}

			}

		}

		totalOut = totalOut + this.__extraFlow;
		this.__extraFlow = 0;
		totalMarkerOut = totalMarkerOut + this.__extraMarkerFlow;
		this.__extraMarkerFlow = 0;
		var perOutRatio = 1;
		var perOutMarkerRatio = 1;
		if (inExists && totalOut > totalIn) {
			var diff = totalOut - totalIn;
			perOutRatio = totalIn / totalOut;
		}

		if (inMarkerExists && totalMarkerOut > totalMarkerIn) {
			var diff1 = totalMarkerOut - totalMarkerIn;
			perOutMarkerRatio = totalMarkerIn / totalMarkerOut;
		}

		var changeProgress;
		for (var i1 = 0; i1 < this.__allHighlights.count(); i1++) {
			var item1 = this.__allHighlights.__inner[i1];
			changeProgress = deltaProgress;
			if (item1.state() == $.ig.HighlightingState.prototype.outward) {
				changeProgress = Math.min(changeProgress, item1.progress());
				if (item1.isMarker()) {
					changeProgress = changeProgress * perOutMarkerRatio;

				} else {
					changeProgress = changeProgress * perOutRatio;
				}

				item1.progress(item1.progress() - changeProgress);

			} else {
				item1.progress(item1.progress() + changeProgress);
			}

			if (item1.state() == $.ig.HighlightingState.prototype.static) {
				item1.progress(1);
			}

			if (item1.progress() > 1) {
				item1.progress(1);
			}

			if (item1.progress() < 0) {
				item1.progress(0);
			}

			if (item1.isMarker()) {
				this.maxMarkerHighlightingProgress(Math.max(item1.progress(), this.maxMarkerHighlightingProgress()));
				this.sumMarkerHighlightingProgress(this.sumMarkerHighlightingProgress() + item1.progress());

			} else {
				this.maxHighlightingProgress(Math.max(item1.progress(), this.maxHighlightingProgress()));
				this.sumHighlightingProgress(this.sumHighlightingProgress() + item1.progress());
			}

			if (item1.state() != $.ig.HighlightingState.prototype.outward && item1.progress() != 1) {
				stillRunning = true;
			}

			if (item1.state() == $.ig.HighlightingState.prototype.outward && item1.progress() != 0) {
				stillRunning = true;
			}

			if (item1.progress() == 1 && item1.state() == $.ig.HighlightingState.prototype.inward) {
				item1.state($.ig.HighlightingState.prototype.static);
			}

			if (item1.progress() == 0 && item1.state() == $.ig.HighlightingState.prototype.outward) {
				toRemove.add(item1);
			}

			if (!this.__dirtySeriesMap.containsKey(item1.series())) {
				this.__dirtySeriesMap.add(item1.series(), true);
				this.dirtySeries().add(item1.series());
			}

		}

		var en = toRemove.getEnumerator();
		while (en.moveNext()) {
			var item2 = en.current();
			this.__activeHighlights.remove(item2);
			this.__allHighlights.remove(item2);
		}

		if (this.__activeHighlights.count() == 0) {
			this.inProgress(false);
			this.maxHighlightingProgress(0);
			this.sumHighlightingProgress(0);
			this.maxMarkerHighlightingProgress(0);
			this.sumMarkerHighlightingProgress(0);
		}

		if (!stillRunning) {
			this.__lastProgress = 0;
		}

		return stillRunning;
	}

	, 
	_inProgress: false,
	inProgress: function (value) {
		if (arguments.length === 1) {
			this._inProgress = value;
			return value;
		} else {
			return this._inProgress;
		}
	}

	, 
	_maxHighlightingProgress: 0,
	maxHighlightingProgress: function (value) {
		if (arguments.length === 1) {
			this._maxHighlightingProgress = value;
			return value;
		} else {
			return this._maxHighlightingProgress;
		}
	}

	, 
	_sumHighlightingProgress: 0,
	sumHighlightingProgress: function (value) {
		if (arguments.length === 1) {
			this._sumHighlightingProgress = value;
			return value;
		} else {
			return this._sumHighlightingProgress;
		}
	}

	, 
	_maxMarkerHighlightingProgress: 0,
	maxMarkerHighlightingProgress: function (value) {
		if (arguments.length === 1) {
			this._maxMarkerHighlightingProgress = value;
			return value;
		} else {
			return this._maxMarkerHighlightingProgress;
		}
	}

	, 
	_sumMarkerHighlightingProgress: 0,
	sumMarkerHighlightingProgress: function (value) {
		if (arguments.length === 1) {
			this._sumMarkerHighlightingProgress = value;
			return value;
		} else {
			return this._sumMarkerHighlightingProgress;
		}
	}
	, 
	$type: new $.ig.Type('HighlightingManager', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('SeriesCollection', 'ObservableCollection$1', {
	init: function () {



		$.ig.ObservableCollection$1.prototype.init.call(this, $.ig.Series.prototype.$type, 0);
	}
	, 
	collectionResetting: null
	, 
	clearItems: function () {
		if (this.collectionResetting != null) {
			this.collectionResetting(this, null);
		}

		$.ig.ObservableCollection$1.prototype.clearItems.call(this);
	}
	, 
	$type: new $.ig.Type('SeriesCollection', $.ig.ObservableCollection$1.prototype.$type.specialize($.ig.Series.prototype.$type))
}, true);

$.ig.util.defType('SeriesComponentsForView', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('SeriesComponentsForView', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('SeriesComponentsFromView', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('SeriesComponentsFromView', $.ig.Object.prototype.$type)
}, true);



$.ig.util.defType('SyncLink', 'FrameworkElement', {
	init: function () {


		this._fastItemsSources = new $.ig.Dictionary$2($.ig.IEnumerable.prototype.$type, $.ig.FastItemsSourceReference.prototype.$type, 0);

		var $self = this;
		$.ig.FrameworkElement.prototype.init.call(this);
			this.propertyUpdated = $.ig.Delegate.prototype.combine(this.propertyUpdated, function (o, e) {
				$self.propertyUpdatedOverride(o, e.propertyName(), e.oldValue(), e.newValue());
			});
			this.chartsInternal(new $.ig.ChartCollection());
			this.chartsInternal().collectionChanged = $.ig.Delegate.prototype.combine(this.chartsInternal().collectionChanged, this.charts_CollectionChanged.runOn(this));
			this.defaultWindowRect(new $.ig.Rect(0, 0, 0, 1, 1));
	}

	, 
	_syncChannel: null,
	syncChannel: function (value) {
		if (arguments.length === 1) {
			this._syncChannel = value;
			return value;
		} else {
			return this._syncChannel;
		}
	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
	}

	, 
	releaseFastItemsSource: function (itemsSource) {
		var $self = this;
		if (itemsSource != null) {
			var itemsSourceReference = null;
			if ((function () { var $ret = $self._fastItemsSources.tryGetValue(itemsSource, itemsSourceReference); itemsSourceReference = $ret.p1; return $ret.ret; }())) {
				--itemsSourceReference._references;
				if (itemsSourceReference._references == 0) {
					$self._fastItemsSources.remove(itemsSource);
				}

			}

		}

		return null;
	}

	, 
	_fastItemsSourceFactory: null,
	fastItemsSourceFactory: function (value) {
		if (arguments.length === 1) {
			this._fastItemsSourceFactory = value;
			return value;
		} else {
			return this._fastItemsSourceFactory;
		}
	}

	, 
	createDefaultFastItemsSource: function (data) {
		var $self = this;
		return (function () { var $ret = new $.ig.FastItemsSource();
		$ret.itemsSource(data); return $ret;}());
	}

	, 
	getFastItemsSource: function (itemsSource) {
		var $self = this;
		if ($.ig.SyncLink.prototype.fastItemsSourceFactory() == null) {
			$.ig.SyncLink.prototype.fastItemsSourceFactory($.ig.SyncLink.prototype.createDefaultFastItemsSource);
		}

		var fastItemsSource = null;
		if (itemsSource != null) {
			var itemsSourceReference = null;
			if (!(function () { var $ret = $self._fastItemsSources.tryGetValue(itemsSource, itemsSourceReference); itemsSourceReference = $ret.p1; return $ret.ret; }())) {
				fastItemsSource = $.ig.SyncLink.prototype.fastItemsSourceFactory()(itemsSource);
				itemsSourceReference = new $.ig.FastItemsSourceReference(fastItemsSource);
				$self._fastItemsSources.add(itemsSource, itemsSourceReference);
			}

			itemsSourceReference._references++;
			fastItemsSource = itemsSourceReference._fastItemsSource;
		}

		return fastItemsSource;
	}

	, 
	peekItemsSource: function (itemsSource) {
		var $self = this;
		var fastItemsSource = null;
		if (itemsSource != null) {
			var itemsSourceReference = null;
			if (!(function () { var $ret = $self._fastItemsSources.tryGetValue(itemsSource, itemsSourceReference); itemsSourceReference = $ret.p1; return $ret.ret; }())) {
				return null;
			}

			fastItemsSource = itemsSourceReference._fastItemsSource;
		}

		return fastItemsSource;
	}
	, 
	_fastItemsSources: null

	, 
	_defaultWindowRect: null,
	defaultWindowRect: function (value) {
		if (arguments.length === 1) {
			this._defaultWindowRect = value;
			return value;
		} else {
			return this._defaultWindowRect;
		}
	}

	, 
	synchroniseRect: function (sender, chart, rect) {
		var $self = this;
		if (!rect.isEmpty()) {
			rect = new $.ig.Rect(0, rect.left(), rect.top(), rect.width(), rect.height());
			var minWidth = sender.windowRectMinWidth();
			if (chart == sender) {
				if (!chart.isZoomingHorizontallyEnabled()) {
					rect.x(chart.windowRect().x());
					rect.width(chart.windowRect().width());
				}

				if (!chart.isZoomingVerticallyEnabled()) {
					rect.y(chart.windowRect().y());
					rect.height(chart.windowRect().height());
				}


			} else {
				var settings = $.ig.SyncManager.prototype.getSyncSettings(chart);
				if (settings == null || !settings.synchronizeHorizontally()) {
					rect.x(chart.windowRect().x());
					rect.width(chart.windowRect().width());
				}

				if (settings == null || !settings.synchronizeVertically()) {
					rect.y(chart.windowRect().y());
					rect.height(chart.windowRect().height());
				}

			}

			var cx = 0.5 * (rect.left() + rect.right());
			var cy = 0.5 * (rect.top() + rect.bottom());
			var width = $.ig.MathUtil.prototype.clamp(rect.width(), minWidth, 1);
			var height = $.ig.MathUtil.prototype.clamp(rect.height(), minWidth, 1);
			if (sender.useFixedAspectZoom() && !sender.viewportRect().isEmpty()) {
				var viewport = sender.viewportRect();
				var matchAspect = viewport.width() / viewport.height();
				var projectedWidth = width * viewport.width();
				var projectedHeight = height * viewport.height();
				var projectedAspect = projectedWidth / projectedHeight;
				if (projectedAspect != matchAspect) {
					if (projectedHeight * matchAspect > projectedWidth) {
						projectedWidth = projectedHeight * matchAspect;
						width = projectedWidth / viewport.width();

					} else {
						projectedHeight = projectedWidth / matchAspect;
						height = projectedHeight / viewport.height();
					}

				}


			} else if (sender.effectiveIsSquare()) {
				var widthChanging = false;
				var heightChanging = false;
				if (Math.abs(width - sender.actualWindowRect().width()) > minWidth) {
					widthChanging = true;
				}

				if (Math.abs(height - sender.actualWindowRect().height()) > minWidth) {
					heightChanging = true;
				}

				(function () { var $ret = sender.matchRatio(width, height, widthChanging, heightChanging); width = $ret.p0; height = $ret.p1; return $ret.ret; }());
				width = $.ig.MathUtil.prototype.clamp(width, minWidth, 1);
				height = $.ig.MathUtil.prototype.clamp(height, minWidth, 1);
			}


			var left = cx - 0.5 * width;
			var top = cy - 0.5 * height;
			var right = cx + 0.5 * width;
			var bottom = cy + 0.5 * height;
			if (left < 0) {
				left = 0;
				right = left + width;
			}

			if (right > 1) {
				right = 1;
				left = right - width;
			}

			if (top < 0) {
				top = 0;
				bottom = top + height;
			}

			if (bottom > 1) {
				bottom = 1;
				top = bottom - height;
			}

			rect = new $.ig.Rect(0, left, top, right - left, bottom - top);
		}

		return rect;
	}

	, 
	charts: function () {

			return this.chartsInternal();
	}

	, 
	_chartsInternal: null,
	chartsInternal: function (value) {
		if (arguments.length === 1) {
			this._chartsInternal = value;
			return value;
		} else {
			return this._chartsInternal;
		}
	}

	, 
	charts_CollectionChanged: function (sender, e) {
		if (e.newItems() != null) {
			var en = e.newItems().getEnumerator();
			while (en.moveNext()) {
				var chart = en.current();
				if (chart.windowRect().isEmpty()) {
					chart.windowRect(this.synchroniseRect(null, chart, this.defaultWindowRect()));
				}

			}

		}

	}

	, 
	crosshairNotify: function (sender, crossHairPoint) {
		var en = this.charts().getEnumerator();
		while (en.moveNext()) {
			var chart = en.current();
			if (chart == sender) {
				chart.crosshairPoint({__x: crossHairPoint.__x, __y: crossHairPoint.__y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});

			} else {
				var pt = {__x: crossHairPoint.__x, __y: crossHairPoint.__y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
				var settings = $.ig.SyncManager.prototype.getSyncSettings(chart);
				if (settings == null || !settings.synchronizeHorizontally()) {
					pt.__x = NaN;
				}

				if (settings == null || !settings.synchronizeVertically()) {
					pt.__y = NaN;
				}

				chart.crosshairPoint(pt);
			}

		}

	}

	, 
	previewNotify: function (sender, previewRect) {
		var en = this.charts().getEnumerator();
		while (en.moveNext()) {
			var chart = en.current();
			chart.previewRect(this.synchroniseRect(sender, chart, previewRect));
		}

	}

	, 
	windowNotify: function (sender, windowRect) {
		var invalid = windowRect.isEmpty() || $.ig.util.isNaN(windowRect.x()) || $.ig.util.isNaN(windowRect.y()) || $.ig.util.isNaN(windowRect.width()) || $.ig.util.isNaN(windowRect.height());
		$.ig.Debug.prototype.assert1(!invalid, "SyncLink attempted to apply an invalid WindowRect");
		if (!invalid && !sender.dontNotify()) {
			var en = this.charts().getEnumerator();
			while (en.moveNext()) {
				var chart = en.current();
				chart.dontNotify(true);
				chart.windowRect(this.synchroniseRect(sender, chart, windowRect));
				chart.dontNotify(false);
			}

		}

	}
	, 
	propertyChanged: null, 
	propertyUpdated: null
	, 
	raisePropertyChanged: function (name, oldValue, newValue) {
		if (this.propertyChanged != null) {
			this.propertyChanged(this, new $.ig.PropertyChangedEventArgs(name));
		}

		if (this.propertyUpdated != null) {
			this.propertyUpdated(this, new $.ig.PropertyUpdatedEventArgs(name, oldValue, newValue));
		}

	}
	, 
	$type: new $.ig.Type('SyncLink', $.ig.FrameworkElement.prototype.$type, [$.ig.INotifyPropertyChanged.prototype.$type, $.ig.IFastItemsSourceProvider.prototype.$type])
}, true);

$.ig.util.defType('SyncSettings', 'FrameworkElement', {
	init: function () {


		$.ig.FrameworkElement.prototype.init.call(this);

	}
	, 
	syncChannel: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SyncSettings.prototype.syncChannelProperty, value);
			return value;
		} else {

			return this.getValue($.ig.SyncSettings.prototype.syncChannelProperty);
		}
	}

	, 
	synchronizeVertically: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SyncSettings.prototype.synchronizeVerticallyProperty, value);
			return value;
		} else {

			return this.getValue($.ig.SyncSettings.prototype.synchronizeVerticallyProperty);
		}
	}

	, 
	synchronizeHorizontally: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SyncSettings.prototype.synchronizeHorizontallyProperty, value);
			return value;
		} else {

			return this.getValue($.ig.SyncSettings.prototype.synchronizeHorizontallyProperty);
		}
	}

	, 
	raisePropertyChanged: function (propertyName, oldValue, newValue) {
		if (this.propertyChanged != null) {
			this.propertyChanged(this, new $.ig.PropertyChangedEventArgs(propertyName));
		}

		if (this.propertyUpdated != null) {
			this.propertyUpdated(this, new $.ig.PropertyUpdatedEventArgs(propertyName, oldValue, newValue));
		}

	}
	, 
	propertyChanged: null, 
	propertyUpdated: null, 
	$type: new $.ig.Type('SyncSettings', $.ig.FrameworkElement.prototype.$type, [$.ig.INotifyPropertyChanged.prototype.$type])
}, true);


$.ig.util.defType('SyncLinkManager', 'Object', {

	instance: function () {
		if ($.ig.SyncLinkManager.prototype.__instance == null) {
			$.ig.SyncLinkManager.prototype.__instance = new $.ig.SyncLinkManager();
		}

		return $.ig.SyncLinkManager.prototype.__instance;
	}
	, 
	__links: null

	, 
	linkCount: function () {

			return this.__links.count();
	}
	, 
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.__links = new $.ig.Dictionary$2(String, $.ig.SyncLink.prototype.$type, 0);
	}

	, 
	getLink: function (name) {
		var $self = this;
		var link;
		if ((function () { var $ret = $self.__links.tryGetValue(name, link); link = $ret.p1; return $ret.ret; }())) {
			return link;
		}

		link = new $.ig.SyncLink();
		link.syncChannel(name);
		$self.__links.add(name, link);
		return link;
	}

	, 
	releaseLink: function (link) {
		if (link.charts().count() == 0 && link.syncChannel() != null && this.__links.containsKey(link.syncChannel())) {
			this.__links.remove(link.syncChannel());
		}

	}
	, 
	$type: new $.ig.Type('SyncLinkManager', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('SyncManager', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	suspendSyncChannel: function (chart) {
		var settings = $.ig.SyncManager.prototype.getSyncSettings(chart);
		if (settings == null) {
			return;
		}

		if (!chart.isSyncReady()) {
			return;
		}

		if (chart.syncChannel() != settings.syncChannel()) {
			return;
		}

		$.ig.SyncManager.prototype.changeSyncChannel(chart, chart.syncChannel(), null);
	}

	, 
	ensureSyncChannel: function (chart) {
		var settings = $.ig.SyncManager.prototype.getSyncSettings(chart);
		if (settings == null) {
			return;
		}

		if (chart.isSyncReady() && chart.syncChannel() == settings.syncChannel()) {
			return;
		}

		var lastChannel = null;
		if (chart.isSyncReady()) {
			lastChannel = chart.syncChannel();
		}

		$.ig.SyncManager.prototype.changeSyncChannel(chart, lastChannel, settings.syncChannel());
	}

	, 
	changeSyncChannel: function (chart, oldSyncChannel, newSyncChannel) {
		if (chart != null) {
			if (String.isNullOrEmpty(newSyncChannel)) {
				var oldLink = chart.actualSyncLink();
				chart.actualSyncLink(null);
				chart.actualSyncLink(new $.ig.SyncLink());
				if (oldLink != null) {
					$.ig.SyncLinkManager.prototype.instance().releaseLink(oldLink);
				}

				chart.syncChannel(null);

			} else {
				if (!String.isNullOrEmpty(oldSyncChannel)) {
					var oldLink1 = chart.actualSyncLink();
					chart.actualSyncLink(null);
					if (oldLink1 != null) {
						$.ig.SyncLinkManager.prototype.instance().releaseLink(oldLink1);
					}

				}

				chart.actualSyncLink($.ig.SyncLinkManager.prototype.instance().getLink(newSyncChannel));
				chart.syncChannel(newSyncChannel);
			}

		}

	}

	, 
	setSyncSettings: function (target, syncSettings) {
		(target).syncSettings(syncSettings);
	}

	, 
	getSyncSettings: function (target) {
		return (target).syncSettings();
	}
	, 
	$type: new $.ig.Type('SyncManager', $.ig.Object.prototype.$type)
}, true);














$.ig.util.defType('AxisRangeChangedEventArgs', 'EventArgs', {
	init: function (oldMinimumValue, minimumValue, oldMaximumValue, maximumValue) {



		$.ig.EventArgs.prototype.init.call(this);
			this.oldMinimumValue(oldMinimumValue);
			this.minimumValue(minimumValue);
			this.oldMaximumValue(oldMaximumValue);
			this.maximumValue(maximumValue);
	}

	, 
	_oldMinimumValue: 0,
	oldMinimumValue: function (value) {
		if (arguments.length === 1) {
			this._oldMinimumValue = value;
			return value;
		} else {
			return this._oldMinimumValue;
		}
	}

	, 
	_minimumValue: 0,
	minimumValue: function (value) {
		if (arguments.length === 1) {
			this._minimumValue = value;
			return value;
		} else {
			return this._minimumValue;
		}
	}

	, 
	_oldMaximumValue: 0,
	oldMaximumValue: function (value) {
		if (arguments.length === 1) {
			this._oldMaximumValue = value;
			return value;
		} else {
			return this._oldMaximumValue;
		}
	}

	, 
	_maximumValue: 0,
	maximumValue: function (value) {
		if (arguments.length === 1) {
			this._maximumValue = value;
			return value;
		} else {
			return this._maximumValue;
		}
	}
	, 
	$type: new $.ig.Type('AxisRangeChangedEventArgs', $.ig.EventArgs.prototype.$type)
}, true);


$.ig.util.defType('DataChartMouseButtonEventArgs', 'EventArgs', {
	init: function (chart, series, item, mouseButtonEventArgs) {



		$.ig.EventArgs.prototype.init.call(this);
			this.chart(chart);
			this.series(series);
			this.item(item);
			this.originalEvent(mouseButtonEventArgs);
	}

	, 
	toString: function () {
		return this.chart().name() + ", " + this.series().name() + ", " + (this.item() != null ? this.item().toString() : "") + ", " + this.getPosition(null).toString();
	}

	, 
	_originalEvent: null,
	originalEvent: function (value) {
		if (arguments.length === 1) {
			this._originalEvent = value;
			return value;
		} else {
			return this._originalEvent;
		}
	}

	, 
	handled: function (value) {
		if (arguments.length === 1) {

			this.originalEvent().handled(value);
			return value;
		} else {

			return this.originalEvent().handled();
		}
	}

	, 
	getPosition: function (relativeTo) {
		return this.originalEvent().getPosition(relativeTo);
	}

	, 
	originalSource: function () {

			return this.originalEvent().originalSource();
	}

	, 
	_item: null,
	item: function (value) {
		if (arguments.length === 1) {
			this._item = value;
			return value;
		} else {
			return this._item;
		}
	}

	, 
	_series: null,
	series: function (value) {
		if (arguments.length === 1) {
			this._series = value;
			return value;
		} else {
			return this._series;
		}
	}

	, 
	_chart: null,
	chart: function (value) {
		if (arguments.length === 1) {
			this._chart = value;
			return value;
		} else {
			return this._chart;
		}
	}
	, 
	$type: new $.ig.Type('DataChartMouseButtonEventArgs', $.ig.EventArgs.prototype.$type)
}, true);


$.ig.util.defType('DataChartLegendMouseButtonEventArgs', 'DataChartMouseButtonEventArgs', {
	init: function (chart, series, item, mouseButtonEventArgs, legendItem) {



		$.ig.DataChartMouseButtonEventArgs.prototype.init.call(this, chart, series, item, mouseButtonEventArgs);
			this.legendItem(legendItem);
	}

	, 
	_legendItem: null,
	legendItem: function (value) {
		if (arguments.length === 1) {
			this._legendItem = value;
			return value;
		} else {
			return this._legendItem;
		}
	}
	, 
	$type: new $.ig.Type('DataChartLegendMouseButtonEventArgs', $.ig.DataChartMouseButtonEventArgs.prototype.$type)
}, true);


$.ig.util.defType('ChartMouseEventArgs', 'EventArgs', {
	init: function (chart, series, item, originalEvent) {



		$.ig.EventArgs.prototype.init.call(this);
			this.chart(chart);
			this.series(series);
			this.item(item);
			this.originalEvent(originalEvent);
	}

	, 
	toString: function () {
		return this.chart().name() + ", " + this.series().name() + ", " + (this.item() != null ? this.item().toString() : "") + ", " + this.getPosition(null).toString();
	}

	, 
	_originalEvent: null,
	originalEvent: function (value) {
		if (arguments.length === 1) {
			this._originalEvent = value;
			return value;
		} else {
			return this._originalEvent;
		}
	}

	, 
	getPosition: function (relativeTo) {
		return this.originalEvent().getPosition(relativeTo);
	}

	, 
	originalSource: function () {

			return this.originalEvent().originalSource();
	}

	, 
	_item: null,
	item: function (value) {
		if (arguments.length === 1) {
			this._item = value;
			return value;
		} else {
			return this._item;
		}
	}

	, 
	_series: null,
	series: function (value) {
		if (arguments.length === 1) {
			this._series = value;
			return value;
		} else {
			return this._series;
		}
	}

	, 
	_chart: null,
	chart: function (value) {
		if (arguments.length === 1) {
			this._chart = value;
			return value;
		} else {
			return this._chart;
		}
	}
	, 
	$type: new $.ig.Type('ChartMouseEventArgs', $.ig.EventArgs.prototype.$type)
}, true);


$.ig.util.defType('ChartLegendMouseEventArgs', 'ChartMouseEventArgs', {
	init: function (chart, series, item, mouseEventArgs, legendItem) {



		$.ig.ChartMouseEventArgs.prototype.init.call(this, chart, series, item, mouseEventArgs);
			this.legendItem(legendItem);
	}

	, 
	_legendItem: null,
	legendItem: function (value) {
		if (arguments.length === 1) {
			this._legendItem = value;
			return value;
		} else {
			return this._legendItem;
		}
	}
	, 
	$type: new $.ig.Type('ChartLegendMouseEventArgs', $.ig.ChartMouseEventArgs.prototype.$type)
}, true);


$.ig.util.defType('ChartCursorEventArgs', 'EventArgs', {
	init: function (chart, series, item) {



		$.ig.EventArgs.prototype.init.call(this);
			this.seriesViewer(chart);
			this.series(series);
			this.item(item);
	}

	, 
	toString: function () {
		return this.seriesViewer().name() + ", " + this.series().name() + ", " + (this.item() != null ? this.item().toString() : "");
	}

	, 
	_item: null,
	item: function (value) {
		if (arguments.length === 1) {
			this._item = value;
			return value;
		} else {
			return this._item;
		}
	}

	, 
	_series: null,
	series: function (value) {
		if (arguments.length === 1) {
			this._series = value;
			return value;
		} else {
			return this._series;
		}
	}

	, 
	_seriesViewer: null,
	seriesViewer: function (value) {
		if (arguments.length === 1) {
			this._seriesViewer = value;
			return value;
		} else {
			return this._seriesViewer;
		}
	}

	, 
	chart: function () {

			return $.ig.util.cast($.ig.XamDataChart.prototype.$type, this.seriesViewer());
	}
	, 
	$type: new $.ig.Type('ChartCursorEventArgs', $.ig.EventArgs.prototype.$type)
}, true);




$.ig.util.defType('PropertyUpdatedEventArgs', 'EventArgs', {
	init: function (propertyName, oldValue, newValue) {



		$.ig.EventArgs.prototype.init.call(this);
			this.propertyName(propertyName);
			this.oldValue(oldValue);
			this.newValue(newValue);
	}

	, 
	_propertyName: null,
	propertyName: function (value) {
		if (arguments.length === 1) {
			this._propertyName = value;
			return value;
		} else {
			return this._propertyName;
		}
	}

	, 
	_oldValue: null,
	oldValue: function (value) {
		if (arguments.length === 1) {
			this._oldValue = value;
			return value;
		} else {
			return this._oldValue;
		}
	}

	, 
	_newValue: null,
	newValue: function (value) {
		if (arguments.length === 1) {
			this._newValue = value;
			return value;
		} else {
			return this._newValue;
		}
	}
	, 
	$type: new $.ig.Type('PropertyUpdatedEventArgs', $.ig.EventArgs.prototype.$type)
}, true);


$.ig.util.defType('SliceClickEventArgs', 'EventArgs', {
	init: function (slice) {



		$.ig.EventArgs.prototype.init.call(this);
			this.slice(slice);
			if (slice == null) {
			return;
			}

			this.isSelected(slice.isSelected());
			this.isExploded(slice.isExploded());
	}

	, 
	_slice: null,
	slice: function (value) {
		if (arguments.length === 1) {
			this._slice = value;
			return value;
		} else {
			return this._slice;
		}
	}

	, 
	isSelected: function (value) {
		if (arguments.length === 1) {

			this.__isSelected = value;
			this.slice().isSelected(value);
			return value;
		} else {

			return this.__isSelected;
		}
	}
	, 
	__isSelected: false

	, 
	isExploded: function (value) {
		if (arguments.length === 1) {

			this.__isExploded = value;
			this.slice().isExploded(value);
			return value;
		} else {

			return this.__isExploded;
		}
	}
	, 
	__isExploded: false

	, 
	isOthersSlice: function () {

			return this.slice().isOthersSlice();
	}

	, 
	dataContext: function () {

			if (this.slice() != null) {
				return this.slice().dataContext();
			}

			return null;
	}
	, 
	$type: new $.ig.Type('SliceClickEventArgs', $.ig.EventArgs.prototype.$type)
}, true);














$.ig.util.defType('ItemLegend', 'LegendBase', {

	createView: function () {
		return new $.ig.ItemLegendView(this);
	}

	, 
	onViewCreated: function (view) {
		$.ig.LegendBase.prototype.onViewCreated.call(this, view);
		this.itemView(view);
	}

	, 
	_itemView: null,
	itemView: function (value) {
		if (arguments.length === 1) {
			this._itemView = value;
			return value;
		} else {
			return this._itemView;
		}
	}
	, 
	init: function () {



		var $self = this;
		$.ig.LegendBase.prototype.init.call(this);
			this.defaultStyleKey($.ig.ItemLegend.prototype.$type);
			this.children().collectionChanged = $.ig.Delegate.prototype.combine(this.children().collectionChanged, function (o, e) {
				if (e.oldItems() != null) {
					var en = e.oldItems().getEnumerator();
					while (en.moveNext()) {
						var item = en.current();
						$self.itemView().removeItemVisual(item);
					}

				}

				if (e.newItems() != null) {
					var en1 = e.newItems().getEnumerator();
					while (en1.moveNext()) {
						var item1 = en1.current();
						$self.itemView().addItemVisual(item1);
					}

				}

			});
	}

	, 
	addChildInOrder: function (legendItem, series) {
		if (!this.view().ready()) {
			return;
		}

		this.renderLegend(series);
	}

	, 
	createLegendItems: function (legendItems, itemsHost) {
		this.clearLegendItems(itemsHost);
		if (itemsHost == null || legendItems == null || legendItems.count() == 0) {
			return;
		}

		var en = legendItems.getEnumerator();
		while (en.moveNext()) {
			var currentLegendItem = en.current();
			var contentControl = $.ig.util.cast($.ig.ContentControl.prototype.$type, currentLegendItem);
			if (contentControl != null && contentControl.content() != null) {
				var context = $.ig.util.cast($.ig.DataContext.prototype.$type, contentControl.content());
				if (context != null && !this.containsContext(context)) {
					this.children().add(currentLegendItem);
					var info = new $.ig.LegendItemInfo();
					info.dataContext(context);
					info.legendItem(currentLegendItem);
					info.series(itemsHost);
					info.text(context.itemLabel());
				}

			}

		}

	}

	, 
	createLegendItemsInsert: function (legendItems, itemsHost) {
		var insertIndex = this.clearLegendItemsAndReturnInsertIndex(itemsHost);
		if (itemsHost == null || legendItems == null || legendItems.count() == 0) {
			return;
		}

		var en = legendItems.getEnumerator();
		while (en.moveNext()) {
			var currentLegendItem = en.current();
			var contentControl = $.ig.util.cast($.ig.ContentControl.prototype.$type, currentLegendItem);
			if (contentControl != null && contentControl.content() != null) {
				var context = $.ig.util.cast($.ig.DataContext.prototype.$type, contentControl.content());
				if (context != null && !this.containsContext(context)) {
					this.children().insert(insertIndex, currentLegendItem);
					insertIndex++;
					var info = new $.ig.LegendItemInfo();
					info.dataContext(context);
					info.legendItem(currentLegendItem);
					info.series(itemsHost);
					info.text(context.itemLabel());
				}

			}

		}

	}

	, 
	renderLegend: function (itemsHost) {
		this.clearLegendItems(itemsHost);
		var bubbleSeries = $.ig.util.cast($.ig.BubbleSeries.prototype.$type, itemsHost);
		if (bubbleSeries != null && bubbleSeries.labelColumn() != null && bubbleSeries.legendItems() != null && bubbleSeries.legendItems().count() > 0) {
			var en = bubbleSeries.legendItems().getEnumerator();
			while (en.moveNext()) {
				var legendItem = en.current();
				var contentControl = $.ig.util.cast($.ig.ContentControl.prototype.$type, legendItem);
				if (contentControl != null && contentControl.content() != null) {
					var context = $.ig.util.cast($.ig.DataContext.prototype.$type, contentControl.content());
					if (context != null && !this.containsContext(context)) {
						this.children().add(legendItem);
						var info = new $.ig.LegendItemInfo();
						info.dataContext(context);
						info.legendItem(legendItem);
						info.series(itemsHost);
						info.text(context.itemLabel());
					}

				}

			}

		}

	}

	, 
	clearLegendItems: function (itemsHost) {
		if (itemsHost == null || this.children() == null || this.children().count() == 0) {
		return;
		}

		var legendItems = new $.ig.ObservableCollection$1($.ig.UIElement.prototype.$type, 0);
		var en = this.children().getEnumerator();
		while (en.moveNext()) {
			var existingLegendItem = en.current();
			var contentControl = $.ig.util.cast($.ig.ContentControl.prototype.$type, existingLegendItem);
			if (contentControl != null && contentControl.content() != null) {
				var context = $.ig.util.cast($.ig.DataContext.prototype.$type, contentControl.content());
				if (context != null && context.series() == itemsHost) {
					legendItems.add(existingLegendItem);
				}

			}

		}

		var en1 = legendItems.getEnumerator();
		while (en1.moveNext()) {
			var legendItem = en1.current();
			this.children().remove(legendItem);
		}

	}

	, 
	clearLegendItemsAndReturnInsertIndex: function (itemsHost) {
		if (itemsHost == null || this.children() == null || this.children().count() == 0) {
		return 0;
		}

		var legendItems = new $.ig.ObservableCollection$1($.ig.UIElement.prototype.$type, 0);
		var insertIndex = -1;
		var index = 0;
		var en = this.children().getEnumerator();
		while (en.moveNext()) {
			var existingLegendItem = en.current();
			var contentControl = $.ig.util.cast($.ig.ContentControl.prototype.$type, existingLegendItem);
			if (contentControl != null && contentControl.content() != null) {
				var context = $.ig.util.cast($.ig.DataContext.prototype.$type, contentControl.content());
				if (context != null && context.series() == itemsHost) {
					if (insertIndex == -1) {
						insertIndex = index;
					}

					legendItems.add(existingLegendItem);
				}

			}

			index++;
		}

		var en1 = legendItems.getEnumerator();
		while (en1.moveNext()) {
			var legendItem = en1.current();
			this.children().remove(legendItem);
		}

		if (insertIndex == -1) {
			return this.children().count();
		}

		return insertIndex;
	}

	, 
	containsContext: function (dataContext) {
		return this.itemView().containsContext(dataContext);
	}

	, 
	_fillColumn: null,
	fillColumn: function (value) {
		if (arguments.length === 1) {
			this._fillColumn = value;
			return value;
		} else {
			return this._fillColumn;
		}
	}
	, 
	$type: new $.ig.Type('ItemLegend', $.ig.LegendBase.prototype.$type)
}, true);

$.ig.util.defType('ItemLegendView', 'LegendBaseView', {
	init: function (model) {



		$.ig.LegendBaseView.prototype.init.call(this, model);
			this.itemModel(model);
	}

	, 
	_itemModel: null,
	itemModel: function (value) {
		if (arguments.length === 1) {
			this._itemModel = value;
			return value;
		} else {
			return this._itemModel;
		}
	}

	, 
	onInit: function () {
		$.ig.LegendBaseView.prototype.onInit.call(this);
	}

	, 
	isDiscrete: function () {

			return true;
	}

	, 
	containsContext: function (dataContext) {
		return this.viewManager().containsContext(dataContext);
	}
	, 
	$type: new $.ig.Type('ItemLegendView', $.ig.LegendBaseView.prototype.$type)
}, true);

$.ig.util.defType('Legend', 'LegendBase', {

	createView: function () {
		return new $.ig.LegendView(this);
	}

	, 
	onViewCreated: function (view) {
		$.ig.LegendBase.prototype.onViewCreated.call(this, view);
		this.legendView(view);
	}

	, 
	_legendView: null,
	legendView: function (value) {
		if (arguments.length === 1) {
			this._legendView = value;
			return value;
		} else {
			return this._legendView;
		}
	}
	, 
	init: function () {



		var $self = this;
		$.ig.LegendBase.prototype.init.call(this);
			this.defaultStyleKey($.ig.Legend.prototype.$type);
			this.children().collectionChanged = $.ig.Delegate.prototype.combine(this.children().collectionChanged, function (o, e) {
				if (e.oldItems() != null) {
					var en = e.oldItems().getEnumerator();
					while (en.moveNext()) {
						var item = en.current();
						$self.legendView().removeItemVisual(item);
					}

				}

				if (e.newItems() != null) {
					var en1 = e.newItems().getEnumerator();
					while (en1.moveNext()) {
						var item1 = en1.current();
						$self.legendView().addItemVisual(item1);
					}

				}

			});
	}

	, 
	addChildInOrder: function (legendItem, series) {
		var $self = this;
		if ($.ig.util.cast($.ig.StackedSeriesBase.prototype.$type, series) !== null) {
		return;
		}

		if (!series.isUsableInLegend()) {
		return;
		}

		var index = 0;
		var en = $self.children().getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			var itemChart;
			var itemSeries;
			var itemItem;
			(function () { var $ret = $self.view().fetchLegendEnvironment(item, itemChart, itemSeries, itemItem); itemChart = $ret.p1; itemSeries = $ret.p2; itemItem = $ret.p3; return $ret.ret; }());
			if (series.seriesViewer() != null && itemChart != null && ($self.getSortOrder(series.seriesViewer()) < $self.getSortOrder(itemChart) || ($self.getSortOrder(series.seriesViewer()) == -1 && $self.getSortOrder(itemChart) == -1 && series.seriesViewer().getHashCode() < itemChart.getHashCode()))) {
				break;
			}

			if (series.seriesViewer() != null && itemChart != null && series.seriesViewer() == itemChart && itemSeries != null) {
				var indexOfSeries = series.index();
				var indexOfItemSeries = itemSeries.index();
				var sortOrderSeries = $self.getSortOrder(series);
				var sortOrderItemSeries = $self.getSortOrder(itemSeries);
				if ($.ig.util.cast($.ig.FragmentBase.prototype.$type, series) !== null || $.ig.util.cast($.ig.SplineFragmentBase.prototype.$type, series) !== null) {
					var parentSeries = $.ig.util.cast($.ig.FragmentBase.prototype.$type, series) !== null ? ($.ig.util.cast($.ig.FragmentBase.prototype.$type, series)).parentSeries() : ($.ig.util.cast($.ig.SplineFragmentBase.prototype.$type, series)).parentSeries();
					if (parentSeries.reverseLegendOrder()) {
						indexOfSeries = parentSeries.index() + parentSeries.actualSeries().count() - parentSeries.stackedSeriesManager().seriesVisual().indexOf($.ig.util.cast($.ig.AnchoredCategorySeries.prototype.$type, series));
					}

				}

				if ($.ig.util.cast($.ig.FragmentBase.prototype.$type, itemSeries) !== null || $.ig.util.cast($.ig.SplineFragmentBase.prototype.$type, itemSeries) !== null) {
					var parentSeries1 = $.ig.util.cast($.ig.FragmentBase.prototype.$type, itemSeries) !== null ? ($.ig.util.cast($.ig.FragmentBase.prototype.$type, itemSeries)).parentSeries() : ($.ig.util.cast($.ig.SplineFragmentBase.prototype.$type, itemSeries)).parentSeries();
					if (parentSeries1.reverseLegendOrder()) {
						indexOfItemSeries = parentSeries1.index() + parentSeries1.actualSeries().count() - parentSeries1.stackedSeriesManager().seriesVisual().indexOf($.ig.util.cast($.ig.AnchoredCategorySeries.prototype.$type, itemSeries));
					}

				}

				if ($.ig.util.cast($.ig.BarSeries.prototype.$type, itemSeries) !== null) {
					if (sortOrderItemSeries == -1 && sortOrderSeries == -1) {
						index = 0;
						break;
					}

					if (sortOrderSeries < sortOrderItemSeries || sortOrderItemSeries == -1) {
						break;
					}

				}

				if (indexOfSeries <= indexOfItemSeries) {
					break;
				}

			}

			index++;
		}

		$self.children().insert(index, legendItem);
		var info = new $.ig.LegendItemInfo();
		info.legendItem(legendItem);
		info.series(series);
		var contentControl = $.ig.util.cast($.ig.ContentControl.prototype.$type, legendItem);
		if (contentControl != null && contentControl.content() != null) {
			var context = $.ig.util.cast($.ig.DataContext.prototype.$type, contentControl.content());
			if (context != null) {
				info.dataContext(context);
				info.text(context.itemLabel());
			}

		}

	}

	, 
	getSortOrder: function (target) {
		return -1;
	}
	, 
	$type: new $.ig.Type('Legend', $.ig.LegendBase.prototype.$type)
}, true);

$.ig.util.defType('LegendItemInfo', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	_text: null,
	text: function (value) {
		if (arguments.length === 1) {
			this._text = value;
			return value;
		} else {
			return this._text;
		}
	}

	, 
	_legendItem: null,
	legendItem: function (value) {
		if (arguments.length === 1) {
			this._legendItem = value;
			return value;
		} else {
			return this._legendItem;
		}
	}

	, 
	_series: null,
	series: function (value) {
		if (arguments.length === 1) {
			this._series = value;
			return value;
		} else {
			return this._series;
		}
	}

	, 
	_dataContext: null,
	dataContext: function (value) {
		if (arguments.length === 1) {
			this._dataContext = value;
			return value;
		} else {
			return this._dataContext;
		}
	}
	, 
	$type: new $.ig.Type('LegendItemInfo', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('LegendView', 'LegendBaseView', {
	init: function (model) {



		$.ig.LegendBaseView.prototype.init.call(this, model);
			this.legendModel(model);
	}

	, 
	_legendModel: null,
	legendModel: function (value) {
		if (arguments.length === 1) {
			this._legendModel = value;
			return value;
		} else {
			return this._legendModel;
		}
	}

	, 
	onInit: function () {
		$.ig.LegendBaseView.prototype.onInit.call(this);
	}
	, 
	$type: new $.ig.Type('LegendView', $.ig.LegendBaseView.prototype.$type)
}, true);

$.ig.util.defType('PieLabel', 'Control', {
	init: function () {



		$.ig.Control.prototype.init.call(this);
	}

	, 
	_slice: null,
	slice: function (value) {
		if (arguments.length === 1) {
			this._slice = value;
			return value;
		} else {
			return this._slice;
		}
	}

	, 
	_bounds: null,
	bounds: function (value) {
		if (arguments.length === 1) {
			this._bounds = value;
			return value;
		} else {
			return this._bounds;
		}
	}

	, 
	_angle: 0,
	angle: function (value) {
		if (arguments.length === 1) {
			this._angle = value;
			return value;
		} else {
			return this._angle;
		}
	}

	, 
	_label: null,
	label: function (value) {
		if (arguments.length === 1) {
			this._label = value;
			return value;
		} else {
			return this._label;
		}
	}

	, 
	_leaderLine: null,
	leaderLine: function (value) {
		if (arguments.length === 1) {
			this._leaderLine = value;
			return value;
		} else {
			return this._leaderLine;
		}
	}

	, 
	_leaderLinePath: null,
	leaderLinePath: function (value) {
		if (arguments.length === 1) {
			this._leaderLinePath = value;
			return value;
		} else {
			return this._leaderLinePath;
		}
	}

	, 
	createContent: function (view) {
		if (view.model().labelsPosition() == $.ig.LabelsPosition.prototype.outsideEnd) {
			this.bounds(view.getLabelBounds(this));
			var textBlock = $.ig.util.cast($.ig.TextBlock.prototype.$type, this.label());
			var sampleText = textBlock.text();
			view.model().renderSlices();
			var origin = this.slice().isExploded() ? this.slice().explodedOrigin() : this.slice().origin();
			var bounds = $.ig.GeometryUtil.prototype.findRadialPoint(origin, this.angle(), this.slice().radius() + view.model().labelExtent());
			var containerWidth = view.viewport().width();
			if (view.getDesiredWidth(textBlock) + bounds.__x > containerWidth && bounds.__x < containerWidth) {
				while (view.getDesiredWidth(textBlock) + bounds.__x > containerWidth) {
					sampleText = sampleText.substr(0, sampleText.length - 1);
					textBlock.text(sampleText);

				}
				if (sampleText.length > 3) {
					sampleText = sampleText.substr(0, sampleText.length - 3);
					sampleText = sampleText + "...";

				} else {
					if (view.getDesiredWidth("...") < this.bounds().width()) {
						sampleText = "...";

					} else {
						sampleText = String.empty();
					}

				}

			}

			var newLabel = new $.ig.TextBlock();
			newLabel.text(sampleText);
			this.label(newLabel);
		}

	}

	, 
	updateCascadingLeaderLineStroke: function () {
	}

	, 
	updateLeaderLine: function () {
		this.leaderLine().__visibility = this.slice().owner().leaderLineVisibility() != $.ig.Visibility.prototype.visible ? this.slice().owner().leaderLineVisibility() : this.slice().label().__visibility;
		var endPoint;
		var margin = this.slice().owner().leaderLineMargin();
		var startPoint = $.ig.GeometryUtil.prototype.findRadialPoint(this.slice().getSliceOrigin(), this.angle(), this.slice().radius());
		this.leaderLine().x1(startPoint.__x);
		this.leaderLine().y1(startPoint.__y);
		if (this.angle() < 90 || this.angle() >= 270) {
			endPoint = {__x: this.bounds().left(), __y: (this.bounds().top() + this.bounds().bottom()) / 2, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};

		} else {
			endPoint = {__x: this.bounds().right(), __y: (this.bounds().top() + this.bounds().bottom()) / 2, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		}

		if (margin > 0) {
			var lineLength = $.ig.GeometryUtil.prototype.getSegmentLength(startPoint, endPoint);
			if (margin < lineLength) {
				endPoint = $.ig.GeometryUtil.prototype.pointAtDistance(endPoint, startPoint, margin);

			} else {
				endPoint = startPoint;
			}

		}

		this.leaderLine().x2(endPoint.__x);
		this.leaderLine().y2(endPoint.__y);
	}

	, 
	updateLeaderLinePath: function () {
		this.leaderLinePath().__visibility = this.slice().owner().leaderLineVisibility() != $.ig.Visibility.prototype.visible ? this.slice().owner().leaderLineVisibility() : this.slice().label().__visibility;
		var sliceOrigin = this.slice().getSliceOrigin();
		var figure = (this.leaderLinePath().data()).figures().__inner[0];
		var segment = (figure.__segments.__inner[0]);
		var margin = this.slice().owner().leaderLineMargin();
		var endPointY = (this.bounds().top() + this.bounds().bottom()) / 2;
		var startPoint = $.ig.GeometryUtil.prototype.findRadialPoint(sliceOrigin, this.angle(), this.slice().radius());
		var cp1 = $.ig.GeometryUtil.prototype.findRadialPoint(sliceOrigin, this.angle(), this.slice().radius() + this.slice().owner().labelExtent() / 2);
		var cp2;
		var actualEndPoint;
		var endPoint;
		var cpY = endPointY;
		if (this.angle() < 90 && this.angle() >= 0) {
			cp2 = {__x: this.bounds().left() - $.ig.PieChartBase.prototype.leaderLinePathControlPointOffset, __y: cpY, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			endPoint = {__x: this.bounds().left(), __y: endPointY, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};

		} else if (this.angle() < 180 && this.angle() >= 90) {
			cp2 = {__x: this.bounds().right() + $.ig.PieChartBase.prototype.leaderLinePathControlPointOffset, __y: cpY, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			endPoint = {__x: this.bounds().right(), __y: endPointY, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};

		} else if (this.angle() < 270 && this.angle() >= 180) {
			cp2 = {__x: this.bounds().right() + $.ig.PieChartBase.prototype.leaderLinePathControlPointOffset, __y: cpY, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			endPoint = {__x: this.bounds().right(), __y: endPointY, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};

		} else {
			cp2 = {__x: this.bounds().left() - $.ig.PieChartBase.prototype.leaderLinePathControlPointOffset, __y: cpY, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			endPoint = {__x: this.bounds().left(), __y: endPointY, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		}



		if (margin > 0) {
			var lineLength = $.ig.GeometryUtil.prototype.getSegmentLength(startPoint, endPoint);
			if (margin < lineLength) {
				actualEndPoint = $.ig.GeometryUtil.prototype.pointAtDistance(endPoint, startPoint, margin);
				var deltaX1 = cp1.__x - startPoint.__x;
				var deltaY1 = cp1.__y - startPoint.__y;
				cp1 = $.ig.GeometryUtil.prototype.pointAtDistance(cp1, startPoint, margin);
				var deltaX2 = cp1.__x - startPoint.__x;
				var deltaY2 = cp1.__y - startPoint.__y;
				if ((deltaX1 > 0 && deltaX2 < 0) || (deltaX1 < 0 && deltaX2 > 0) || (deltaY1 > 0 && deltaY2 < 0) || (deltaY1 < 0 && deltaY2 > 0)) {
					cp1 = startPoint;
				}

				cp2 = $.ig.GeometryUtil.prototype.pointAtDistance(cp2, startPoint, margin);
				var scaleFactor = $.ig.GeometryUtil.prototype.getSegmentLength(startPoint, actualEndPoint) / $.ig.GeometryUtil.prototype.getSegmentLength(startPoint, endPoint);
				cp2.__x = startPoint.__x + (cp2.__x - startPoint.__x) * scaleFactor;
				cp2.__y = startPoint.__y + (cp2.__y - startPoint.__y) * scaleFactor;

			} else {
				this.leaderLinePath().__visibility = $.ig.Visibility.prototype.collapsed;
				return;
			}


		} else {
			actualEndPoint = endPoint;
		}

		if (this.angle() < 180 && this.angle() >= 0) {
			if (cp1.__y > cp2.__y) {
				cp1.__y = startPoint.__y;
			}


		} else {
			if (cp1.__y < cp2.__y) {
				cp1.__y = startPoint.__y;
			}

		}

		figure.__startPoint = startPoint;
		if (this.slice().owner().leaderLineType() == $.ig.LeaderLineType.prototype.arc) {
			segment.point1(startPoint);

		} else {
			segment.point1(cp1);
		}

		segment.point2(cp2);
		segment.point3(actualEndPoint);
	}
	, 
	$type: new $.ig.Type('PieLabel', $.ig.Control.prototype.$type)
}, true);

$.ig.util.defType('IndexCollection', 'ObservableCollection$1', {
	init: function () {


		$.ig.ObservableCollection$1.prototype.init.call(this, $.ig.Number.prototype.$type, 0);

	}
	, 
	insertItem: function (index, item) {
		if (!this.contains(item)) {
		$.ig.ObservableCollection$1.prototype.insertItem.call(this, index, item);
		}

	}

	, 
	setItem: function (index, item) {
		if (this.contains(item)) {
			this.remove(item);
			this.insertItem(index, item);

		} else {
		$.ig.ObservableCollection$1.prototype.setItem.call(this, index, item);
		}

	}
	, 
	$type: new $.ig.Type('IndexCollection', $.ig.ObservableCollection$1.prototype.$type.specialize($.ig.Number.prototype.$type))
}, true);


$.ig.util.defType('Slice', 'ContentControl', {

	createView: function () {
		return new $.ig.SliceView(this);
	}

	, 
	onViewCreated: function (view) {
		this.view(view);
	}

	, 
	_view: null,
	view: function (value) {
		if (arguments.length === 1) {
			this._view = value;
			return value;
		} else {
			return this._view;
		}
	}
	, 
	init: function () {


		this.__suspendCreation = false;

		$.ig.ContentControl.prototype.init.call(this);
			var view = this.createView();
			this.onViewCreated(view);
			view.onInit();
	}

	, 
	startAngle: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Slice.prototype.startAngleProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Slice.prototype.startAngleProperty);
		}
	}

	, 
	endAngle: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Slice.prototype.endAngleProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Slice.prototype.endAngleProperty);
		}
	}

	, 
	innerExtentStart: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Slice.prototype.innerExtentStartProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Slice.prototype.innerExtentStartProperty);
		}
	}

	, 
	innerExtentEnd: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Slice.prototype.innerExtentEndProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Slice.prototype.innerExtentEndProperty);
		}
	}

	, 
	isSelected: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Slice.prototype.isSelectedProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Slice.prototype.isSelectedProperty);
		}
	}

	, 
	isExploded: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Slice.prototype.isExplodedProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Slice.prototype.isExplodedProperty);
		}
	}

	, 
	isOthersSlice: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Slice.prototype.isOtherSliceProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Slice.prototype.isOtherSliceProperty);
		}
	}

	, 
	origin: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Slice.prototype.originProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Slice.prototype.originProperty);
		}
	}

	, 
	explodedOrigin: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Slice.prototype.explodedOriginProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Slice.prototype.explodedOriginProperty);
		}
	}

	, 
	radius: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Slice.prototype.radiusProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Slice.prototype.radiusProperty);
		}
	}

	, 
	explodedRadius: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Slice.prototype.explodedRadiusProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Slice.prototype.explodedRadiusProperty);
		}
	}

	, 
	index: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Slice.prototype.indexProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.Slice.prototype.indexProperty));
		}
	}

	, 
	strokeThickness: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.Slice.prototype.strokeThicknessProperty, value);
			return value;
		} else {

			return this.getValue($.ig.Slice.prototype.strokeThicknessProperty);
		}
	}

	, 
	_bounds: null,
	bounds: function (value) {
		if (arguments.length === 1) {
			this._bounds = value;
			return value;
		} else {
			return this._bounds;
		}
	}

	, 
	_owner: null,
	owner: function (value) {
		if (arguments.length === 1) {
			this._owner = value;
			return value;
		} else {
			return this._owner;
		}
	}

	, 
	_label: null,
	label: function (value) {
		if (arguments.length === 1) {
			this._label = value;
			return value;
		} else {
			return this._label;
		}
	}

	, 
	_correctedExplodedBounds: null,
	correctedExplodedBounds: function (value) {
		if (arguments.length === 1) {
			this._correctedExplodedBounds = value;
			return value;
		} else {
			return this._correctedExplodedBounds;
		}
	}

	, 
	_correctedExplodedOrigin: null,
	correctedExplodedOrigin: function (value) {
		if (arguments.length === 1) {
			this._correctedExplodedOrigin = value;
			return value;
		} else {
			return this._correctedExplodedOrigin;
		}
	}

	, 
	_hasCorrecttedBounds: false,
	hasCorrecttedBounds: function (value) {
		if (arguments.length === 1) {
			this._hasCorrecttedBounds = value;
			return value;
		} else {
			return this._hasCorrecttedBounds;
		}
	}

	, 
	onApplyTemplate: function () {
		$.ig.ContentControl.prototype.onApplyTemplate.call(this);
		this.view().onTemplateProvided();
	}

	, 
	getActualRadius: function () {
		var circle = Math.abs($.ig.PieChartBase.prototype.roundAngle(this.endAngle() - this.startAngle())) == 360;
		if (circle) {
			return this.radius();
		}

		return this.radius();
	}

	, 
	getSliceBounds: function () {
		var allowExploded = (this.owner() != null && this.owner().allowSliceExplosion()) ? true : false;
		var actualRadius = this.getActualRadius();
		if (this.isExploded() && allowExploded) {
			var bounds = new $.ig.Rect(0, this.explodedOrigin().__x - actualRadius, this.explodedOrigin().__y - actualRadius, actualRadius * 2, actualRadius * 2);
			return bounds;
		}

		return new $.ig.Rect(0, this.origin().__x - actualRadius, this.origin().__y - actualRadius, actualRadius * 2, actualRadius * 2);
	}

	, 
	getSliceOrigin: function () {
		if (this.isExploded() && this.owner() != null && this.owner().allowSliceExplosion()) {
			if (this.hasCorrecttedBounds()) {
				return this.correctedExplodedOrigin();
			}

			return this.explodedOrigin();
		}

		return this.origin();
	}
	, 
	__suspendCreation: false

	, 
	suspendCreation: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__suspendCreation;
			this.__suspendCreation = value;
			if (oldValue && !this.__suspendCreation) {
				this.createShape();
			}

			return value;
		} else {

			return this.__suspendCreation;
		}
	}

	, 
	createShape: function () {
		var $self = this;
		if ($self.suspendCreation()) {
			return;
		}

		var slicePath = $self.view().getSlicePath();
		var viewport = $self.owner().viewport();
		if ($.ig.util.isNaN($self.startAngle()) || $.ig.util.isNaN($self.endAngle()) || $.ig.util.isNaN($self.radius()) || $.ig.util.isNaN($self.explodedRadius()) || $self.index() < 0 || $self.owner() == null || viewport.width() == 0 || viewport.height() == 0 || ($self.origin().__x == 0 && $self.origin().__y == 0) || ($self.explodedOrigin().__x == 0 && $self.explodedOrigin().__y == 0)) {
			return;
		}

		$self.bounds($self.getSliceBounds());
		var ecc = $.ig.GeometryUtil.prototype.eccentricity($self.bounds());
		var halfHeight = $self.bounds().height() / 2;
		var actualRadius = $self.getActualRadius();
		var center = $.ig.RectUtil.prototype.getCenter($self.bounds());
		var startPointOuter = $.ig.Slice.prototype.ellipsePointAlternate($.ig.MathUtil.prototype.radians($self.startAngle()), ecc, center, halfHeight, 100);
		var endPointOuter = $.ig.Slice.prototype.ellipsePointAlternate($.ig.MathUtil.prototype.radians($self.endAngle()), ecc, center, halfHeight, 100);
		var endPointInner = $.ig.Slice.prototype.ellipsePointAlternate($.ig.MathUtil.prototype.radians($self.endAngle()), ecc, center, $self.radius(), $self.innerExtentEnd());
		var startPointInner = $.ig.Slice.prototype.ellipsePointAlternate($.ig.MathUtil.prototype.radians($self.startAngle()), ecc, center, $self.radius(), $self.innerExtentStart());
		var circle = Math.abs($.ig.PieChartBase.prototype.roundAngle($self.endAngle() - $self.startAngle())) == 360;
		if (circle) {
			if ($self.innerExtentEnd() == 0) {
				var circleGeometry = (function () { var $ret = new $.ig.EllipseGeometry();
				$ret.center(center);
				$ret.radiusX($self.radius());
				$ret.radiusY($self.radius()); return $ret;}());
				slicePath.data(circleGeometry);
				return;

			} else if ($self.innerExtentEnd() > 0) {
				var outerSize = new $.ig.Size(1, $self.radius(), $self.radius());
				var innerSize = new $.ig.Size(1, $self.radius() * $self.innerExtentEnd() / 100, $self.radius() * $self.innerExtentEnd() / 100);
				var leftOuterPoint = (function () { var $ret = new $.ig.Point(0);
				$ret.x(center.__x - $self.radius());
				$ret.y(center.__y); return $ret;}());
				var rightOuterPoint = (function () { var $ret = new $.ig.Point(0);
				$ret.x(center.__x + $self.radius());
				$ret.y(center.__y); return $ret;}());
				var leftInnerPoint = (function () { var $ret = new $.ig.Point(0);
				$ret.x(center.__x - $self.radius() * $self.innerExtentEnd() / 100);
				$ret.y(center.__y); return $ret;}());
				var rightInnerPoint = (function () { var $ret = new $.ig.Point(0);
				$ret.x(center.__x + $self.radius() * $self.innerExtentEnd() / 100);
				$ret.y(center.__y); return $ret;}());
				var firstOuterArc = (function () { var $ret = new $.ig.PathFigure();
				$ret.startPoint(leftOuterPoint); return $ret;}());
				var firstOuterArcSegments = new $.ig.PathSegmentCollection();
				var topOuterArc = (function () { var $ret = new $.ig.ArcSegment();
				$ret.size(outerSize);
				$ret.sweepDirection($.ig.SweepDirection.prototype.clockwise);
				$ret.point(rightOuterPoint); return $ret;}());
				firstOuterArcSegments.add(topOuterArc);
				firstOuterArc.__segments = firstOuterArcSegments;
				var firstInnerArc = (function () { var $ret = new $.ig.PathFigure();
				$ret.startPoint(rightInnerPoint); return $ret;}());
				var firstInnerArcSegments = new $.ig.PathSegmentCollection();
				var topInnerArc = (function () { var $ret = new $.ig.ArcSegment();
				$ret.size(innerSize);
				$ret.sweepDirection($.ig.SweepDirection.prototype.counterclockwise);
				$ret.point(leftInnerPoint); return $ret;}());
				firstInnerArcSegments.add(topInnerArc);
				firstInnerArc.__segments = firstInnerArcSegments;
				var secondOuterArc = (function () { var $ret = new $.ig.PathFigure();
				$ret.startPoint(leftOuterPoint); return $ret;}());
				var secondOuterArcSegments = new $.ig.PathSegmentCollection();
				var bottomOuterArc = (function () { var $ret = new $.ig.ArcSegment();
				$ret.size(outerSize);
				$ret.sweepDirection($.ig.SweepDirection.prototype.counterclockwise);
				$ret.point(rightOuterPoint); return $ret;}());
				secondOuterArcSegments.add(bottomOuterArc);
				secondOuterArc.__segments = secondOuterArcSegments;
				var secondInnerArc = (function () { var $ret = new $.ig.PathFigure();
				$ret.startPoint(rightInnerPoint); return $ret;}());
				var secondInnerArcSegments = new $.ig.PathSegmentCollection();
				var bottomInnerArc = (function () { var $ret = new $.ig.ArcSegment();
				$ret.size(innerSize);
				$ret.sweepDirection($.ig.SweepDirection.prototype.clockwise);
				$ret.point(leftInnerPoint); return $ret;}());
				secondInnerArcSegments.add(bottomInnerArc);
				secondInnerArc.__segments = secondInnerArcSegments;
				var figureCollection = (function () { var $ret = new $.ig.PathFigureCollection();
				$ret.add(firstOuterArc);
				$ret.add(firstInnerArc);
				$ret.add(secondOuterArc);
				$ret.add(secondInnerArc); return $ret;}());
				var pg = (function () { var $ret = new $.ig.PathGeometry();
				$ret.figures(figureCollection); return $ret;}());
				var gg = new $.ig.GeometryGroup();
				gg.children().add(pg);
				slicePath.data(gg);
				return;

			} else {
				var group = (function () { var $ret = new $.ig.GeometryGroup();
				$ret.fillRule($.ig.FillRule.prototype.evenOdd); return $ret;}());
				group.children().add((function () { var $ret = new $.ig.EllipseGeometry();
				$ret.center(center);
				$ret.radiusX($self.radius());
				$ret.radiusY($self.radius()); return $ret;}()));
				group.children().add((function () { var $ret = new $.ig.EllipseGeometry();
				$ret.center(center);
				$ret.radiusX($self.radius() * $self.innerExtentEnd() / 100);
				$ret.radiusY($self.radius() * $self.innerExtentEnd() / 100); return $ret;}()));
				slicePath.data(group);
				return;
			}


		}

		var geometry = new $.ig.PathGeometry();
		slicePath.data(geometry);
		var figure = (function () { var $ret = new $.ig.PathFigure();
		$ret.isClosed(true); return $ret;}());
		geometry.figures(new $.ig.PathFigureCollection());
		geometry.figures().add(figure);
		figure.__startPoint = startPointOuter;
		var largeArc = Math.abs($self.endAngle() - $self.startAngle()) > 180;
		var arcOuter = new $.ig.ArcSegment();
		arcOuter.point(endPointOuter);
		arcOuter.size(new $.ig.Size(1, $self.bounds().width() / 2, $self.bounds().height() / 2));
		arcOuter.isLargeArc(largeArc);
		if ($self.endAngle() > $self.startAngle()) {
			arcOuter.sweepDirection($.ig.SweepDirection.prototype.clockwise);

		} else {
			arcOuter.sweepDirection($.ig.SweepDirection.prototype.counterclockwise);
		}

		figure.__segments = new $.ig.PathSegmentCollection();
		figure.__segments.add(arcOuter);
		var connectEnd = new $.ig.LineSegment(1);
		connectEnd.point(endPointInner);
		figure.__segments.add(connectEnd);
		var lineLenght = Math.sqrt(Math.pow(endPointInner.__x - endPointOuter.__x, 2) + Math.pow(endPointInner.__y - endPointOuter.__y, 2));
		var innerRadius = actualRadius - lineLenght;
		var arcInner = new $.ig.ArcSegment();
		arcInner.point(startPointInner);
		if (innerRadius < 0) {
			innerRadius = 0.1;
		}

		arcInner.size(new $.ig.Size(1, innerRadius, innerRadius));
		arcInner.isLargeArc(arcOuter.isLargeArc());
		arcInner.sweepDirection($.ig.SweepDirection.prototype.counterclockwise);
		figure.__segments.add(arcInner);
		var bounds = $self.getBounds(slicePath, startPointOuter, endPointOuter, $self.startAngle(), $self.endAngle(), center, actualRadius);
		var slicesWithinBounds = true;
		if (slicesWithinBounds && $self.bounds().height() > 0 && $self.bounds().width() > 0 && !viewport.containsRect(bounds)) {
			var sliceBounds = bounds;
			var chartBounds = new $.ig.Rect(0, 0, 0, viewport.width(), viewport.height());
			chartBounds.intersect(sliceBounds);
			var midAngle = $.ig.GeometryUtil.prototype.simplifyAngle(($self.startAngle() + $self.endAngle()) / 2);
			var midAngleRad = midAngle / 180 * Math.PI;
			var dx = Math.abs((sliceBounds.height() - chartBounds.height()) / Math.sin(midAngleRad));
			var dy = Math.abs((sliceBounds.width() - chartBounds.width()) / Math.cos(midAngleRad));
			if ($.ig.util.isNaN(dx) || Number.isInfinity(dx)) {
			dx = 0;
			}

			if ($.ig.util.isNaN(dy) || Number.isInfinity(dy)) {
			dy = 0;
			}

			var distance = Math.max(dx, dy);
			var explodedCenterNew = $.ig.GeometryUtil.prototype.findCenter($self.owner().viewport().width(), $self.owner().viewport().height(), true, midAngle, $self.radius() * $self.owner().actualExplodedRadius() - distance);
			$self.view().positionSlice(explodedCenterNew.__x - $self.explodedOrigin().__x, explodedCenterNew.__y - $self.explodedOrigin().__y);
			$self.hasCorrecttedBounds(true);
			$self.correctedExplodedOrigin(explodedCenterNew);
			$self.correctedExplodedBounds(new $.ig.Rect(0, sliceBounds.x() - (explodedCenterNew.__x - $self.explodedOrigin().__x), sliceBounds.y() - (explodedCenterNew.__y - $self.explodedOrigin().__y), sliceBounds.width(), sliceBounds.height()));

		} else {
			$self.hasCorrecttedBounds(false);
			$self.view().resetSlicePosition();
		}

	}

	, 
	containsPoint: function (p) {
		var viewport = this.owner().viewport();
		if (this.__visibility == $.ig.Visibility.prototype.collapsed) {
			return false;
		}

		if ($.ig.util.isNaN(this.startAngle()) || $.ig.util.isNaN(this.endAngle()) || $.ig.util.isNaN(this.radius()) || $.ig.util.isNaN(this.explodedRadius()) || this.index() < 0 || this.owner() == null || viewport.width() == 0 || viewport.height() == 0 || (this.origin().__x == 0 && this.origin().__y == 0) || (this.explodedOrigin().__x == 0 && this.explodedOrigin().__y == 0)) {
			return false;
		}

		var actualRadius = this.getActualRadius();
		var startRadius = ((this.innerExtentEnd() / 100) * actualRadius);
		var endRadius = actualRadius;
		var center = this.origin();
		if (this.isExploded() && this.owner().allowSliceExplosion()) {
			center = this.explodedOrigin();
			if (this.hasCorrecttedBounds()) {
				center = this.correctedExplodedOrigin();
			}

		}

		var startRadiusSquared = startRadius * startRadius;
		var endRadiusSquared = endRadius * endRadius;
		var dist = Math.pow(p.__x - center.__x, 2) + Math.pow(p.__y - center.__y, 2);
		if (dist < startRadiusSquared || dist > endRadiusSquared) {
			return false;
		}

		var angle = Math.atan2(p.__y - center.__y, p.__x - center.__x);
		angle = angle * 180 / Math.PI;
		angle = angle - this.startAngle();
		angle = $.ig.GeometryUtil.prototype.simplifyAngle(angle);
		var endAngle = this.endAngle() - this.startAngle();
		if (angle > endAngle) {
			return false;
		}

		return true;
	}

	, 
	getBounds: function (slicePath, outerStart, outerEnd, startAngle, endAngle, center, radius) {
		var points = new $.ig.List$1($.ig.Point.prototype.$type, 0);
		points.add(outerStart);
		points.add(outerEnd);
		points.add(center);
		startAngle = $.ig.GeometryUtil.prototype.simplifyAngle(startAngle);
		endAngle = $.ig.GeometryUtil.prototype.simplifyAngle(endAngle);
		if ((0 > startAngle && 0 < endAngle) || (360 > startAngle && 360 < endAngle) || (endAngle < startAngle)) {
			points.add($.ig.GeometryUtil.prototype.findRadialPoint(center, 0, radius));
		}

		if (90 > startAngle && 90 < endAngle) {
			points.add($.ig.GeometryUtil.prototype.findRadialPoint(center, 90, radius));
		}

		if (180 > startAngle && 180 < endAngle) {
			points.add($.ig.GeometryUtil.prototype.findRadialPoint(center, 180, radius));
		}

		if (270 > startAngle && 270 < endAngle) {
			points.add($.ig.GeometryUtil.prototype.findRadialPoint(center, 270, radius));
		}

		var minX = 1.7976931348623157E+308;
		var minY = 1.7976931348623157E+308;
		var maxX = -1.7976931348623157E+308;
		var maxY = -1.7976931348623157E+308;
		var en = points.getEnumerator();
		while (en.moveNext()) {
			var point = en.current();
			minX = Math.min(minX, point.__x);
			minY = Math.min(minY, point.__y);
			maxX = Math.max(maxX, point.__x);
			maxY = Math.max(maxY, point.__y);
		}

		return new $.ig.Rect(0, minX, minY, maxX - minX, maxY - minY);
	}

	, 
	exportVisualData: function () {
		var slice = new $.ig.PieSliceVisualData();
		slice.appearance(new $.ig.PrimitiveAppearanceData());
		slice.labelAppearance(new $.ig.LabelAppearanceData());
		slice.leaderLineAppearance(new $.ig.PrimitiveAppearanceData());
		slice.labelAppearance().angle(this.label().angle());
		slice.labelBounds(this.label().bounds());
		if ($.ig.util.cast($.ig.TextBlock.prototype.$type, this.label().label()) !== null) {
			var label = $.ig.util.cast($.ig.TextBlock.prototype.$type, this.label().label());
			slice.label(label.text());
			slice.labelAppearance().labelBrush($.ig.AppearanceHelper.prototype.fromBrush(label.fill()));
			slice.labelAppearance().text(label.text());
			slice.labelAppearance().visibility(label.__visibility == $.ig.Visibility.prototype.visible);

		} else {
			slice.label(this.label().label().toString());
		}

		slice.leaderLineAppearance().fill($.ig.AppearanceHelper.prototype.fromBrush(this.label().leaderLine().__fill));
		slice.leaderLineAppearance().opacity(this.label().leaderLine().__opacity);
		slice.leaderLineAppearance().stroke($.ig.AppearanceHelper.prototype.fromBrush(this.label().leaderLine().__stroke));
		slice.leaderLineAppearance().strokeThickness(this.label().leaderLine().strokeThickness());
		slice.leaderLineAppearance().visibility(this.label().leaderLine().__visibility);
		if (this.view() != null) {
			var slicePath = this.view().getSlicePath();
			slice.slicePath(new $.ig.PathVisualData(1, "slicePath", slicePath));
			slice.appearance().fill($.ig.AppearanceHelper.prototype.fromBrush(slicePath.__fill));
			slice.appearance().opacity(slicePath.__opacity);
			slice.appearance().stroke($.ig.AppearanceHelper.prototype.fromBrush(slicePath.__stroke));
			slice.appearance().strokeThickness(slicePath.strokeThickness());
			slice.appearance().visibility(slicePath.__visibility);
		}

		return slice;
	}

	, 
	ellipsePointAlternate: function (theta, eccentricity, center, halfHeight, extent) {
		var cos = Math.cos(theta);
		var sin = Math.sin(theta);
		var r = Math.sqrt(halfHeight * halfHeight / (1 - (eccentricity * Math.pow(cos, 2))));
		r *= (extent / 100);
		return {__x: r * cos + center.__x, __y: r * sin + center.__y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
	}

	, 
	_background: null,
	background: function (value) {
		if (arguments.length === 1) {
			this._background = value;
			return value;
		} else {
			return this._background;
		}
	}

	, 
	_borderBrush: null,
	borderBrush: function (value) {
		if (arguments.length === 1) {
			this._borderBrush = value;
			return value;
		} else {
			return this._borderBrush;
		}
	}
	, 
	$type: new $.ig.Type('Slice', $.ig.ContentControl.prototype.$type)
}, true);

$.ig.util.defType('SliceView', 'Object', {

	_model: null,
	model: function (value) {
		if (arguments.length === 1) {
			this._model = value;
			return value;
		} else {
			return this._model;
		}
	}
	, 
	init: function (model) {



		$.ig.Object.prototype.init.call(this);
			this.model(model);
	}

	, 
	_slicePath: null,
	slicePath: function (value) {
		if (arguments.length === 1) {
			this._slicePath = value;
			return value;
		} else {
			return this._slicePath;
		}
	}

	, 
	onInit: function () {
		this.slicePath(new $.ig.Path());
		this.model().content(this.slicePath());
	}

	, 
	onTemplateProvided: function () {
		this.model().createShape();
	}

	, 
	getSlicePath: function () {
		return this.slicePath();
	}

	, 
	positionSlice: function (x, y) {
		var $self = this;
		$self.slicePath().renderTransform((function () { var $ret = new $.ig.TranslateTransform();
		$ret.x(x);
		$ret.y(y); return $ret;}()));
	}

	, 
	resetSlicePosition: function () {
		this.slicePath().renderTransform(null);
	}
	, 
	$type: new $.ig.Type('SliceView', $.ig.Object.prototype.$type)
}, true);






































$.ig.util.defType('SeriesViewerSurfaceViewer', 'DependencyObject', {
	init: function (model, view) {


		this.__isDirty = true;

		$.ig.DependencyObject.prototype.init.call(this);
			if (model == null || view == null) {
				throw new $.ig.ArgumentNullException(0, "model");
			}

			this.model(model);
			this.model().windowRectChanged = $.ig.Delegate.prototype.combine(this.model().windowRectChanged, this.model_WindowRectChanged.runOn(this));
			this.view(view);
			this.previewCanvas(new $.ig.Canvas());
			this.updateZoomLevelDisplayText();
	}

	, 
	_view: null,
	view: function (value) {
		if (arguments.length === 1) {
			this._view = value;
			return value;
		} else {
			return this._view;
		}
	}

	, 
	_suspendWindowRectChanges: false,
	suspendWindowRectChanges: function (value) {
		if (arguments.length === 1) {
			this._suspendWindowRectChanges = value;
			return value;
		} else {
			return this._suspendWindowRectChanges;
		}
	}

	, 
	model_WindowRectChanged: function (sender, e) {
		var suspendWindowRectChangesStored = this.suspendWindowRectChanges();
		this.suspendWindowRectChanges(true);
		this.zoomLevel(1 - Math.min(e.newRect().height(), e.newRect().width()));
		this.suspendWindowRectChanges(suspendWindowRectChangesStored);
	}
	, 
	__model: null

	, 
	model: function (value) {
		if (arguments.length === 1) {

			if (this.__model != null) {
				var asIPropChange = $.ig.util.cast($.ig.INotifyPropertyChanged.prototype.$type, this.__model);
				if (asIPropChange != null) {
				asIPropChange.propertyChanged = $.ig.Delegate.prototype.remove(asIPropChange.propertyChanged, this.model_PropertyChanged.runOn(this));
				}

			}

			this.__model = value;
			if (this.__model != null) {
				var asIPropChange1 = $.ig.util.cast($.ig.INotifyPropertyChanged.prototype.$type, this.__model);
				if (asIPropChange1 != null) {
				asIPropChange1.propertyChanged = $.ig.Delegate.prototype.combine(asIPropChange1.propertyChanged, this.model_PropertyChanged.runOn(this));
				}

			}

			return value;
		} else {

			return this.__model;
		}
	}

	, 
	model_PropertyChanged: function (sender, e) {
		if (e.propertyName() == "DefaultInteraction") {
			this.__defaultInteraction = this.model().defaultInteraction();
			this.onPropertyChanged(e.propertyName(), $.ig.InteractionState.prototype.getBox(this.defaultInteraction()), $.ig.InteractionState.prototype.getBox(this.defaultInteraction()));
		}

	}

	, 
	_previewCanvas: null,
	previewCanvas: function (value) {
		if (arguments.length === 1) {
			this._previewCanvas = value;
			return value;
		} else {
			return this._previewCanvas;
		}
	}

	, 
	zoomTo100: function () {
		this.model().windowRect($.ig.XamDataChart.prototype.standardRect);
	}

	, 
	scaleToFit: function () {
		this.model().windowRect($.ig.XamDataChart.prototype.standardRect);
	}

	, 
	renderPreview: function () {
		if (!this.isDirty()) {
			return;
		}

		var surface = new $.ig.RenderSurface();
		surface.surface(this.view().overviewPlusDetailPane().view().thumbnailContext());
		if (surface.surface() != null && surface.surface().shouldRender()) {
			var thumbnailSize = this.view().overviewPlusDetailPane().view().thumbnailSize();
			this.view().getThumbnail(thumbnailSize.width(), thumbnailSize.height(), surface);
		}

		this.isDirty(false);
	}

	, 
	worldRect: function () {

			return $.ig.XamDataChart.prototype.standardRect;
	}

	, 
	viewportRect: function () {

			return this.model().viewportRect();
	}

	, 
	minimumZoomLevel: function () {

			return 0;
	}

	, 
	maximumZoomLevel: function () {

			if (this.model().windowRectMinWidth() == 0.0001) {
				return 0.9;

			} else {
				return 1 - this.model().windowRectMinWidth();
			}

	}
	, 
	__isDirty: false

	, 
	isDirty: function (value) {
		if (arguments.length === 1) {

			this.__isDirty = value;
			return value;
		} else {

			return this.__isDirty;
		}
	}

	, 
	zoomLevel: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SeriesViewerSurfaceViewer.prototype.zoomLevelProperty, value);
			return value;
		} else {

			return this.getValue($.ig.SeriesViewerSurfaceViewer.prototype.zoomLevelProperty);
		}
	}

	, 
	onPropertyChanged: function (propertyName, oldValue, newValue) {
		if (this.propertyChanged != null) {
			this.propertyChanged(this, new $.ig.PropertyChangedEventArgs(propertyName));
		}

		switch (propertyName) {
			case $.ig.SeriesViewerSurfaceViewer.prototype._zoomLevelPropertyName:
				if (newValue - this.minimumZoomLevel() < -1E-05) {
					this.zoomLevel(this.minimumZoomLevel());
					return;
				}

				if (newValue - this.maximumZoomLevel() > 0.0001) {
					this.zoomLevel(this.maximumZoomLevel());
					return;
				}

				var updatingSliderRanges = this.model() != null && this.model().overviewPlusDetailPane() != null && this.model().overviewPlusDetailPane().updatingSliderRanges();
				if (!this.suspendWindowRectChanges() && !updatingSliderRanges) {
					var windowSize = 1 - this.zoomLevel();
					var center = $.ig.RectUtil.prototype.getCenter(this.model().actualWindowRect());
					var newRect = new $.ig.Rect(0, center.__x - windowSize / 2, center.__y - windowSize / 2, windowSize, windowSize);
					this.model().windowRect($.ig.SeriesViewerSurfaceViewer.prototype.changeRect(this.model().windowRect(), newRect, this.model().isZoomingHorizontallyEnabled(), this.model().isZoomingVerticallyEnabled(), this.worldRect()));
				}

				this.updateZoomLevelDisplayText();
				if (this.model().overviewPlusDetailPane() != null) {
					this.model().overviewPlusDetailPane().pushZoomLevel(this.zoomLevel());
				}

				break;
		}

	}

	, 
	updateZoomLevelDisplayText: function () {
		var zoomLevelDisplay = Math.round(100 * (1 / (1 - this.zoomLevel())));
		if (zoomLevelDisplay <= 1000) {
			this.zoomLevelDisplayText(zoomLevelDisplay.toString());

		} else {
			this.zoomLevelDisplayText("> 1000");
		}

	}
	, 
	__zoomLevelDisplayText: null

	, 
	zoomLevelDisplayText: function (value) {
		if (arguments.length === 1) {

			var changed = this.zoomLevelDisplayText() != value;
			if (changed) {
				var oldValue = this.zoomLevelDisplayText();
				this.__zoomLevelDisplayText = value;
				this.onPropertyChanged($.ig.SeriesViewerSurfaceViewer.prototype._zoomLevelDisplayTextPropertyName, oldValue, value);
			}

			return value;
		} else {

			return this.__zoomLevelDisplayText;
		}
	}
	, 
	__defaultInteraction: 0

	, 
	defaultInteraction: function (value) {
		if (arguments.length === 1) {

			this.__defaultInteraction = value;
			this.model().defaultInteraction(value);
			return value;
		} else {

			return this.__defaultInteraction;
		}
	}
	, 
	propertyChanged: null
	, 
	changeRect: function (oldRect, newRect, horizontalZoomable, verticalZoomable, worldRect) {
		var left, top, width, height;
		if (horizontalZoomable) {
			left = newRect.left();
			width = newRect.width();

		} else {
			left = oldRect.left();
			width = oldRect.width();
		}

		if (verticalZoomable) {
			top = newRect.top();
			height = newRect.height();

		} else {
			top = oldRect.top();
			height = oldRect.height();
		}

		var right = left + width;
		var bottom = top + height;
		var leftOverflow = Math.max(0, worldRect.left() - left);
		var rightOverflow = Math.max(0, right - worldRect.right());
		var topOverflow = Math.max(0, worldRect.top() - top);
		var bottomOverflow = Math.max(0, bottom - worldRect.bottom());
		left += leftOverflow - rightOverflow;
		top += topOverflow - bottomOverflow;
		var result = new $.ig.Rect(0, left, top, width, height);
		result.intersect(worldRect);
		return result;
	}
	, 
	$type: new $.ig.Type('SeriesViewerSurfaceViewer', $.ig.DependencyObject.prototype.$type, [$.ig.IOverviewPlusDetailControl.prototype.$type, $.ig.INotifyPropertyChanged.prototype.$type])
}, true);

$.ig.util.defType('SeriesViewerViewManager', 'Object', {

	_container: null,
	container: function (value) {
		if (arguments.length === 1) {
			this._container = value;
			return value;
		} else {
			return this._container;
		}
	}

	, 
	_backgroundCanvas: null,
	backgroundCanvas: function (value) {
		if (arguments.length === 1) {
			this._backgroundCanvas = value;
			return value;
		} else {
			return this._backgroundCanvas;
		}
	}

	, 
	_overlayCanvas: null,
	overlayCanvas: function (value) {
		if (arguments.length === 1) {
			this._overlayCanvas = value;
			return value;
		} else {
			return this._overlayCanvas;
		}
	}

	, 
	_mainCanvas: null,
	mainCanvas: function (value) {
		if (arguments.length === 1) {
			this._mainCanvas = value;
			return value;
		} else {
			return this._mainCanvas;
		}
	}

	, 
	_hitCanvas: null,
	hitCanvas: function (value) {
		if (arguments.length === 1) {
			this._hitCanvas = value;
			return value;
		} else {
			return this._hitCanvas;
		}
	}

	, 
	_shadowCanvas: null,
	shadowCanvas: function (value) {
		if (arguments.length === 1) {
			this._shadowCanvas = value;
			return value;
		} else {
			return this._shadowCanvas;
		}
	}

	, 
	_backgroundContext: null,
	backgroundContext: function (value) {
		if (arguments.length === 1) {
			this._backgroundContext = value;
			return value;
		} else {
			return this._backgroundContext;
		}
	}

	, 
	_overlayContext: null,
	overlayContext: function (value) {
		if (arguments.length === 1) {
			this._overlayContext = value;
			return value;
		} else {
			return this._overlayContext;
		}
	}

	, 
	_mainContext: null,
	mainContext: function (value) {
		if (arguments.length === 1) {
			this._mainContext = value;
			return value;
		} else {
			return this._mainContext;
		}
	}

	, 
	_hitContext: null,
	hitContext: function (value) {
		if (arguments.length === 1) {
			this._hitContext = value;
			return value;
		} else {
			return this._hitContext;
		}
	}

	, 
	_shadowContext: null,
	shadowContext: function (value) {
		if (arguments.length === 1) {
			this._shadowContext = value;
			return value;
		} else {
			return this._shadowContext;
		}
	}

	, 
	_eventProxy: null,
	eventProxy: function (value) {
		if (arguments.length === 1) {
			this._eventProxy = value;
			return value;
		} else {
			return this._eventProxy;
		}
	}
	, 
	__owner: null
	, 
	init: function (owner) {


		this.__currentCanvasWidth = 0;
		this.__currentCanvasHeight = 0;
		this.__currentPixelRatio = 1;
		this.__defaultChartTitleFont = String.empty();
		this.__defaultChartTitleMargin = new $.ig.Thickness(0, 0);
		this.__defaultChartTitleTextAlign = String.empty();
		this.__defaultChartSubTitleTextAlign = String.empty();
		this.__defaultChartSubTitleMargin = new $.ig.Thickness(0, 0);
		this.__defaultChartTitleColor = null;
		this.__defaultChartSubTitleColor = null;
		this.__defaultChartSubTitleFont = String.empty();
		this.__defaultAxisTitlePosition = $.ig.AxisTitlePosition.prototype.auto;
		this.__defaultVerticalAxisTitlePosition = $.ig.AxisTitlePosition.prototype.auto;
		this.__defaultVerticalAxisFont = String.empty();
		this.__defaultVerticalAxisColor = null;
		this.__defaultHorizontalAxisFont = String.empty();
		this.__defaultHorizontalAxisColor = null;
		this.__defaultHorizontalAxisTitleMargin = new $.ig.Thickness(0, 0);
		this.__defaultVerticalAxisTitleMargin = new $.ig.Thickness(0, 0);
		this.__pointerTooltipStyle = null;
		this.__tileMap = new $.ig.Dictionary$2(String, $.ig.Tuple$2.prototype.$type.specialize($.ig.CanvasElement.prototype.$type, $.ig.RenderingContext.prototype.$type), 0);
		this.__cacheClearID = -1;
		this.__endTileID = -1;

		$.ig.Object.prototype.init.call(this);
			this.__owner = owner;
	}

	, 
	_infoBox: null,
	infoBox: function (value) {
		if (arguments.length === 1) {
			this._infoBox = value;
			return value;
		} else {
			return this._infoBox;
		}
	}

	, 
	onContainerProvided: function (theContainer) {
		if (theContainer == null) {
			if (this.eventProxy() != null) {
				this.eventProxy().destroy();
			}

			this.container(null);
			this.backgroundCanvas(null);
			this.overlayCanvas(null);
			this.mainCanvas(null);
			this.hitCanvas(null);
			this.shadowCanvas(null);
			this.backgroundContext(null);
			this.overlayContext(null);
			this.mainContext(null);
			this.hitContext(null);
			this.infoBox(null);
			this.eventProxy(null);
			return;
		}

		var container = theContainer;
		this.container($(container));
		this.__owner.setDefaultBrushes();
		this.__owner.updateCurrentFontHeight();
		this.styleUpdated();
		this.container().css("position", "relative");
		this.backgroundCanvas($("<canvas style=\"position : absolute; top : 0; left : 0\" />"));
		this.overlayCanvas($("<canvas style=\"position : absolute; top : 0; left : 0;\" />"));
		this.mainCanvas($("<canvas style=\"position : absolute; top : 0; left : 0\" />"));
		this.hitCanvas($("<canvas style=\"position : absolute; top : 0; left : 0\" />"));
		this.shadowCanvas($("<canvas style=\"position : absolute; top : 0; left : 0\" />"));
		this.container().append(this.backgroundCanvas());
		this.container().append(this.mainCanvas());
		this.container().append(this.overlayCanvas());
		this.backgroundContext(new $.ig.RenderingContext(new $.ig.CanvasViewRenderer(), (this.backgroundCanvas()[0]).getContext("2d")));
		this.overlayContext(new $.ig.RenderingContext(new $.ig.CanvasViewRenderer(), (this.overlayCanvas()[0]).getContext("2d")));
		this.mainContext(new $.ig.RenderingContext(new $.ig.CanvasViewRenderer(), (this.mainCanvas()[0]).getContext("2d")));
		this.hitContext(new $.ig.RenderingContext(new $.ig.CanvasViewRenderer(), (this.hitCanvas()[0]).getContext("2d")));
		this.shadowContext(new $.ig.RenderingContext(new $.ig.CanvasViewRenderer(), (this.shadowCanvas()[0]).getContext("2d")));
		this.__owner.provideBackgroundContext(this.backgroundContext());
		this.__owner.onContainerResized(this.container().width(), this.container().height());
		this.eventProxy(new $.ig.DOMEventProxy(this.overlayCanvas()));
		this.infoBox($("<div></div>"));
		this.infoBox().hide();
		this.infoBox().css("position", "absolute");
		this.infoBox().css("z-index", "10000");
		this.infoBox().addClass(this.__owner.model().tooltipStyle());
		this.container().append(this.infoBox());
	}

	, 
	setDefaultCursor: function () {
		this.overlayCanvas().css("cursor", "default");
	}

	, 
	setHandCursor: function () {
		this.overlayCanvas().css("cursor", "pointer");
	}

	, 
	getBlackBrush: function () {
		var $self = this;
		return (function () { var $ret = new $.ig.Brush();
		$ret.fill("#000000"); return $ret;}());
	}
	, 
	__currentCanvasWidth: 0
	, 
	__currentCanvasHeight: 0
	, 
	__currentPixelRatio: 0

	, 
	containerSizeChanging: function (width, height, pixelScale) {
		this.__currentCanvasWidth = width;
		this.__currentCanvasHeight = height;
		this.__currentPixelRatio = pixelScale;
		var pixelWidth = width;
		var pixelHeight = height;
		if (pixelScale != 1) {
			pixelWidth = Math.round(width * pixelScale);
			pixelHeight = Math.round(height * pixelScale);
		}

		this.backgroundCanvas().attr("width", pixelWidth.toString());
		this.backgroundCanvas().attr("height", pixelHeight.toString());
		this.backgroundCanvas().css("width", width.toString() + "px");
		this.backgroundCanvas().css("height", height.toString() + "px");
		this.overlayCanvas().attr("width", pixelWidth.toString());
		this.overlayCanvas().attr("height", pixelHeight.toString());
		this.overlayCanvas().css("width", width.toString() + "px");
		this.overlayCanvas().css("height", height.toString() + "px");
		this.overlayCanvas().attr("tabindex", "0");
		this.overlayCanvas().css("outline", "0");
		this.mainCanvas().attr("width", pixelWidth.toString());
		this.mainCanvas().attr("height", pixelHeight.toString());
		this.mainCanvas().css("width", width.toString() + "px");
		this.mainCanvas().css("height", height.toString() + "px");
		this.hitCanvas().attr("width", pixelWidth.toString());
		this.hitCanvas().attr("height", pixelHeight.toString());
		this.hitCanvas().css("width", width.toString() + "px");
		this.hitCanvas().css("height", height.toString() + "px");
		this.shadowCanvas().attr("width", pixelWidth.toString());
		this.shadowCanvas().attr("height", pixelHeight.toString());
		this.shadowCanvas().css("width", width.toString() + "px");
		this.shadowCanvas().css("height", height.toString() + "px");
		this.__owner.model().canvasRenderScheduler().schedule();
		this.__owner.model().thumbnailCanvasRenderScheduler().schedule();
		this.__owner.model().alternateViewRenderScheduler().schedule();
	}

	, 
	getContainerOffsets: function () {
		var offset = $.ig.DOMEventProxy.prototype.getOffset(this.container());
		return new $.ig.Size(1, offset.left(), offset.top());
	}

	, 
	getDefaultPalette: function (brushes, outlines, fontBrush, font, axisLineBrush) {
		brushes = new $.ig.BrushCollection();
		outlines = new $.ig.BrushCollection();
		var names = new $.ig.List$1(String, 0);
		names.add("background-image");
		var discovery = $.ig.CssHelper.prototype.getDisoveryElement();
		this.container().append(discovery);
		var fillsPalette = $.ig.CssHelper.prototype.getValuesForClassCollection(discovery, "ui-chart-fill-palette-", names);
		var numFillsPaletteColors = fillsPalette.count();
		var outlinesPalette = $.ig.CssHelper.prototype.getValuesForClassCollection(discovery, "ui-chart-outline-palette-", names);
		var numOutlinesPaletteColors = outlinesPalette.count();
		for (var i = 0; i < numFillsPaletteColors; i++) {
			brushes.add($.ig.CssGradientUtil.prototype.brushFromGradientString(fillsPalette.__inner[i].__inner[0]));
		}

		for (var i1 = 0; i1 < numOutlinesPaletteColors; i1++) {
			outlines.add($.ig.CssGradientUtil.prototype.brushFromGradientString(outlinesPalette.__inner[i1].__inner[0]));
		}

		names.clear();
		var fillIndex = 0;
		var outlineIndex = 0;
		var numPaletteColors = Math.min(numFillsPaletteColors, numOutlinesPaletteColors);
		var palette = null;
		if (numFillsPaletteColors == 0) {
			names.add("background-color");
		}

		if (numOutlinesPaletteColors == 0) {
			names.add("border-top-color");
			outlineIndex = numFillsPaletteColors == 0 ? 1 : 0;
		}

		if (names.count() > 0) {
			palette = $.ig.CssHelper.prototype.getValuesForClassCollection(discovery, "ui-chart-palette-", names);
			numPaletteColors = palette.count();
		}

		if (numFillsPaletteColors == 0) {
			if (numPaletteColors > 0) {
				for (var i2 = 0; i2 < numPaletteColors; i2++) {
					var fillBrush = new $.ig.Brush();
					fillBrush.__fill = palette.__inner[i2].__inner[fillIndex];
					brushes.add(fillBrush);
				}


			} else {
				var b1Fill = new $.ig.Brush();
				b1Fill.__fill = "#50a8be";
				var b2Fill = new $.ig.Brush();
				b2Fill.__fill = "#fc6754";
				var b3Fill = new $.ig.Brush();
				b3Fill.__fill = "#fec33c";
				var b4Fill = new $.ig.Brush();
				b4Fill.__fill = "#3c6399";
				var b5Fill = new $.ig.Brush();
				b5Fill.__fill = "#91af49";
				brushes.add(b1Fill);
				brushes.add(b2Fill);
				brushes.add(b3Fill);
				brushes.add(b4Fill);
				brushes.add(b5Fill);
			}

		}

		if (numOutlinesPaletteColors == 0) {
			if (numPaletteColors > 0) {
				for (var i3 = 0; i3 < numPaletteColors; i3++) {
					var outlineBrush = new $.ig.Brush();
					outlineBrush.__fill = palette.__inner[i3].__inner[outlineIndex];
					outlines.add(outlineBrush);
				}


			} else {
				var b1Outline = new $.ig.Brush();
				b1Outline.__fill = "#B1BFC9";
				var b2Outline = new $.ig.Brush();
				b2Outline.__fill = "#798995";
				var b3Outline = new $.ig.Brush();
				b3Outline.__fill = "#4F606C";
				var b4Outline = new $.ig.Brush();
				b4Outline.__fill = "#374650";
				var b5Outline = new $.ig.Brush();
				b5Outline.__fill = "#162C3B";
				outlines.add(b1Outline);
				outlines.add(b2Outline);
				outlines.add(b3Outline);
				outlines.add(b4Outline);
				outlines.add(b5Outline);
			}

		}

		var axisStrokeColor = $.ig.CssHelper.prototype.getPropertyValue(discovery, "ui-chart-axis", "border-top-color");
		if (axisStrokeColor != null) {
			axisLineBrush = new $.ig.Brush();
			axisLineBrush.__fill = axisStrokeColor;

		} else {
			var axisStroke = new $.ig.Brush();
			axisStroke.__fill = "#989EA3";
			axisLineBrush = axisStroke;
		}

		discovery.remove();
		fontBrush = new $.ig.Brush();
		fontBrush.__fill = this.container().css("color");
		var fontStyle = this.container().css("font-style");
		var fontVariant = this.container().css("font-variant");
		var fontWeight = this.container().css("font-weight");
		var fontSize = this.container().css("font-size");
		var lineHeight = this.container().css("line-height");
		var fontFamily = this.container().css("font-family");
		font = "";
		var first = true;
		if (fontStyle.length > 0) {
			if (!first) {
				font += " ";

			} else {
				first = false;
			}

			font += fontStyle;
		}

		if (fontVariant.length > 0) {
			if (!first) {
				font += " ";

			} else {
				first = false;
			}

			font += fontVariant;
		}

		if (fontWeight.length > 0) {
			if (!first) {
				font += " ";

			} else {
				first = false;
			}

			font += fontWeight;
		}

		if (fontSize.length > 0) {
			if (!first) {
				font += " ";

			} else {
				first = false;
			}

			font += fontSize;
		}

		if (lineHeight.length > 0) {
			if (!first) {
				font += "/";

			} else {
				first = false;
			}

			font += lineHeight;
		}

		if (fontFamily.length > 0) {
			if (!first) {
				font += " ";

			} else {
				first = false;
			}

			font += fontFamily;
		}

		return {
			p0: brushes, 
			p1: outlines, 
			p2: fontBrush, 
			p3: font, 
			p4: axisLineBrush
		};
	}

	, 
	getChartSpecificDefaults: function (opacity, margins, axisStroke, axisMajorStroke, categoryAxisTickLength, alignsGridLines) {
		var discovery = $.ig.CssHelper.prototype.getDisoveryElement();
		this.container().append(discovery);
		var cssOpacity = $.ig.CssHelper.prototype.getPropertyValue(discovery, "ui-chart-area-fill-opacity", "opacity");
		opacity = cssOpacity != null ? parseFloat(cssOpacity) : 1;
		margins = new Array(4);
		var marginTop = $.ig.CssHelper.prototype.getPropertyValue(discovery, "ui-chart-render-margins", "margin-top");
		var marginRight = $.ig.CssHelper.prototype.getPropertyValue(discovery, "ui-chart-render-margins", "margin-right");
		var marginBottom = $.ig.CssHelper.prototype.getPropertyValue(discovery, "ui-chart-render-margins", "margin-bottom");
		var marginLeft = $.ig.CssHelper.prototype.getPropertyValue(discovery, "ui-chart-render-margins", "margin-left");
		margins[0] = marginTop != null ? parseFloat(marginTop) : NaN;
		margins[1] = marginRight != null ? parseFloat(marginRight) : NaN;
		margins[2] = marginBottom != null ? parseFloat(marginBottom) : NaN;
		margins[3] = marginLeft != null ? parseFloat(marginLeft) : NaN;
		axisStroke = axisMajorStroke = null;
		var cssAxisStroke = $.ig.CssHelper.prototype.getPropertyValue(discovery, "ui-chart-axis-stroke", "border-top-color");
		if (cssAxisStroke != null) {
			var b = new $.ig.Brush();
			b.__fill = cssAxisStroke;
			axisStroke = b;
		}

		var cssAxisMajorStroke = $.ig.CssHelper.prototype.getPropertyValue(discovery, "ui-chart-axis-major-line", "border-top-color");
		if (cssAxisMajorStroke != null) {
			var b1 = new $.ig.Brush();
			b1.__fill = cssAxisMajorStroke;
			axisMajorStroke = b1;
		}

		var cssAlignsGridLines = $.ig.CssHelper.prototype.getPropertyValue(discovery, "ui-chart-aligned-gridlines", "visibility");
		alignsGridLines = cssAlignsGridLines != null && cssAlignsGridLines == "visible";
		var cssCategoryAxisTickLength = $.ig.CssHelper.prototype.getPropertyValue(discovery, "ui-chart-category-axis-tick", "height");
		if (cssCategoryAxisTickLength != null) {
			categoryAxisTickLength = parseFloat(cssCategoryAxisTickLength);
			if (Math.abs(categoryAxisTickLength) > 4000) {
				categoryAxisTickLength = 0;
			}


		} else {
			cssCategoryAxisTickLength = $.ig.CssHelper.prototype.getPropertyValue(discovery, "ui-chart-category-axis-tick", "width");
			categoryAxisTickLength = cssCategoryAxisTickLength != null ? parseFloat(cssCategoryAxisTickLength) : 0;
		}

		discovery.remove();
		return {
			p0: opacity, 
			p1: margins, 
			p2: axisStroke, 
			p3: axisMajorStroke, 
			p4: categoryAxisTickLength, 
			p5: alignsGridLines
		};
	}

	, 
	clearInfoBox: function () {
		this.infoBox().children().remove();
	}

	, 
	updateInfoBoxXTranslation: function (x_) {
		var box_ = this.infoBox();
		var offset_ = $.ig.DOMEventProxy.prototype.getOffset(this.infoBox());
		var container = this.getContainerOffsets();
		x_ = container.width() + this.__owner.model().viewportRect().left() + x_;
		box_.offset({ left: x_, top: offset_.top});
	}

	, 
	updateInfoBoxYTranslation: function (y_) {
		var box_ = this.infoBox();
		var offset_ = this.infoBox().offset();
		var container = this.getContainerOffsets();
		y_ = container.height() + this.__owner.model().viewportRect().top() + y_;
		box_.offset({ left: offset_.left, top: y_});
	}

	, 
	addToInfoBox: function (control) {
		var c = control;
		c.show();
		this.infoBox().append(c);
	}

	, 
	hideInfoBox: function () {
		this.infoBox().hide();
	}

	, 
	showInfoBox: function () {
		this.infoBox().show();
	}

	, 
	addTooltipToView: function (control) {
		$("body").append(control);
	}

	, 
	removeTooltipFromView: function (control) {
		(control).remove();
	}

	, 
	notifyContainerResized: function () {
		this.__owner.onContainerResized(this.container().width(), this.container().height());
	}
	, 
	__defaultChartTitleFont: null

	, 
	getDefaultChartTitleFont: function () {
		return this.__defaultChartTitleFont;
	}
	, 
	__defaultChartTitleMargin: null

	, 
	getDefaultChartTitleMargin: function () {
		return this.__defaultChartTitleMargin;
	}
	, 
	__defaultChartTitleTextAlign: null

	, 
	getDefaultChartTitleTextAlign: function () {
		return this.__defaultChartTitleTextAlign;
	}
	, 
	__defaultChartSubTitleTextAlign: null

	, 
	getDefaultChartSubTitleTextAlign: function () {
		return this.__defaultChartSubTitleTextAlign;
	}
	, 
	__defaultChartSubTitleMargin: null

	, 
	getDefaultChartSubTitleMargin: function () {
		return this.__defaultChartSubTitleMargin;
	}
	, 
	__defaultChartTitleColor: null

	, 
	getDefaultChartTitleColor: function () {
		return this.__defaultChartTitleColor;
	}
	, 
	__defaultChartSubTitleColor: null

	, 
	getDefaultChartSubTitleColor: function () {
		return this.__defaultChartSubTitleColor;
	}
	, 
	__defaultChartSubTitleFont: null

	, 
	getDefaultChartSubTitleFont: function () {
		return this.__defaultChartSubTitleFont;
	}
	, 
	__defaultAxisTitlePosition: 0

	, 
	getDefaultHorizontalAxisTitlePosition: function () {
		return this.__defaultAxisTitlePosition;
	}
	, 
	__defaultVerticalAxisTitlePosition: 0

	, 
	getDefaultVerticalAxisTitlePosition: function () {
		return this.__defaultVerticalAxisTitlePosition;
	}
	, 
	__defaultVerticalAxisFont: null

	, 
	getDefaultVerticalAxisFont: function () {
		return this.__defaultVerticalAxisFont;
	}
	, 
	__defaultVerticalAxisColor: null

	, 
	getDefaultVerticalAxisColor: function () {
		return this.__defaultVerticalAxisColor;
	}
	, 
	__defaultHorizontalAxisFont: null

	, 
	getDefaultHorizontalAxisFont: function () {
		return this.__defaultHorizontalAxisFont;
	}
	, 
	__defaultHorizontalAxisColor: null

	, 
	getDefaultHorizontalAxisColor: function () {
		return this.__defaultHorizontalAxisColor;
	}
	, 
	__defaultHorizontalAxisTitleMargin: null

	, 
	getDefaultHorizontalAxisTitleMargin: function () {
		return this.__defaultHorizontalAxisTitleMargin;
	}
	, 
	__defaultVerticalAxisTitleMargin: null

	, 
	getDefaultVerticalAxisTitleMargin: function () {
		return this.__defaultVerticalAxisTitleMargin;
	}

	, 
	styleUpdated: function () {
		var ele = $.ig.CssHelper.prototype.getDisoveryElement();
		var fontEle = $("<div></div>");
		this.container().append(fontEle);
		this.container().append(ele);
		this.updateChartTitle(fontEle, ele);
		this.updateChartSubTitle(fontEle, ele);
		this.updateDefaulVerrticalAxis(fontEle, ele);
		this.updateDefaultHorizontalAxis(fontEle, ele);
		this.updatePointerTooltipStyle(fontEle, ele);
		fontEle.remove();
		ele.remove();
	}

	, 
	updatePointerTooltipStyle: function (fontEle, ele) {
		var $self = this;
		var className = "ui-chart-pointer-tooltip";
		var backgroundColor = $.ig.CssHelper.prototype.getPropertyValue(ele, className, "background-color");
		var borderColor = $.ig.CssHelper.prototype.getPropertyValue(ele, className, "border-top-color");
		var borderRadius = $.ig.CssHelper.prototype.getPropertyValue(ele, className, "border-top-left-radius");
		var borderWidth = $.ig.CssHelper.prototype.getPropertyValue(ele, className, "border-top-width");
		var style = new $.ig.PointerTooltipStyle();
		style.cornerRadius(borderRadius != null ? parseFloat(borderRadius) : 0);
		style.fillColor(backgroundColor != null ? $.ig.Brush.prototype.create(backgroundColor) : (function () { var $ret = new $.ig.Brush();
		$ret.fill("white"); return $ret;}()));
		style.strokeColor(borderColor != null ? $.ig.Brush.prototype.create(borderColor) : (function () { var $ret = new $.ig.Brush();
		$ret.fill("gray"); return $ret;}()));
		style.strokeThickness(borderWidth != null ? parseFloat(borderWidth) : 0);
		$self.__pointerTooltipStyle = style;
	}

	, 
	updateChartTitle: function (fontEle, ele) {
		var $self = this;
		var className = "ui-chart-title";
		fontEle.addClass(className);
		$self.__defaultChartTitleFont = $.ig.FontUtil.prototype.getFont(fontEle);
		$self.__defaultChartTitleColor = (function () { var $ret = new $.ig.Brush();
		$ret.fill(fontEle.css("color")); return $ret;}());
		fontEle.removeClass(className);
		$self.__defaultChartTitleTextAlign = $.ig.CssHelper.prototype.getPropertyValue(ele, className, "text-align");
		if ($self.__defaultChartTitleTextAlign == null) {
			$self.__defaultChartTitleTextAlign = "center";
		}

		var marginTop = $.ig.CssHelper.prototype.getPropertyValue(ele, className, "margin-top");
		var marginBottom = $.ig.CssHelper.prototype.getPropertyValue(ele, className, "margin-bottom");
		var marginLeft = $.ig.CssHelper.prototype.getPropertyValue(ele, className, "margin-left");
		var marginRight = $.ig.CssHelper.prototype.getPropertyValue(ele, className, "margin-right");
		var marginTopDb = marginTop != null ? parseFloat(marginTop) : 0;
		var marginBottomDb = marginBottom != null ? parseFloat(marginBottom) : 0;
		var marginLeftDb = marginLeft != null ? parseFloat(marginLeft) : 0;
		var marginRightDb = marginRight != null ? parseFloat(marginRight) : 0;
		$self.__defaultChartTitleMargin = new $.ig.Thickness(1, marginLeftDb, marginTopDb, marginRightDb, marginBottomDb);
	}

	, 
	updateChartSubTitle: function (fontEle, ele) {
		var $self = this;
		var className = "ui-chart-subtitle";
		fontEle.addClass(className);
		$self.__defaultChartSubTitleFont = $.ig.FontUtil.prototype.getFont(fontEle);
		$self.__defaultChartSubTitleColor = (function () { var $ret = new $.ig.Brush();
		$ret.fill(fontEle.css("color")); return $ret;}());
		fontEle.removeClass(className);
		$self.__defaultChartSubTitleTextAlign = $.ig.CssHelper.prototype.getPropertyValue(ele, className, "text-align");
		if ($self.__defaultChartSubTitleTextAlign == null) {
			$self.__defaultChartSubTitleTextAlign = "center";
		}

		var marginTop = $.ig.CssHelper.prototype.getPropertyValue(ele, className, "margin-top");
		var marginBottom = $.ig.CssHelper.prototype.getPropertyValue(ele, className, "margin-bottom");
		var marginLeft = $.ig.CssHelper.prototype.getPropertyValue(ele, className, "margin-left");
		var marginRight = $.ig.CssHelper.prototype.getPropertyValue(ele, className, "margin-right");
		var marginTopDb = marginTop != null ? parseFloat(marginTop) : 0;
		var marginBottomDb = marginBottom != null ? parseFloat(marginBottom) : 0;
		var marginLeftDb = marginLeft != null ? parseFloat(marginLeft) : 0;
		var marginRightDb = marginRight != null ? parseFloat(marginRight) : 0;
		$self.__defaultChartSubTitleMargin = new $.ig.Thickness(1, marginLeftDb, marginTopDb, marginRightDb, marginBottomDb);
	}

	, 
	updateDefaultHorizontalAxis: function (fontEle, ele) {
		var $self = this;
		var className = "ui-chart-horizontal-axis-title";
		fontEle.addClass(className);
		$self.__defaultHorizontalAxisFont = $.ig.FontUtil.prototype.getFont(fontEle);
		$self.__defaultHorizontalAxisColor = (function () { var $ret = new $.ig.Brush();
		$ret.fill(fontEle.css("color")); return $ret;}());
		fontEle.removeClass(className);
		var val = $.ig.CssHelper.prototype.getPropertyValue(ele, className, "vertical-align");
		if (val == null) {
			$self.__defaultAxisTitlePosition = $.ig.AxisTitlePosition.prototype.auto;

		} else if (val.toLowerCase() == "bottom") {
			$self.__defaultAxisTitlePosition = $.ig.AxisTitlePosition.prototype.bottom;

		} else {
			$self.__defaultAxisTitlePosition = $.ig.AxisTitlePosition.prototype.top;
		}


		var marginTop = $.ig.CssHelper.prototype.getPropertyValue(ele, className, "margin-top");
		var marginBottom = $.ig.CssHelper.prototype.getPropertyValue(ele, className, "margin-bottom");
		var marginLeft = $.ig.CssHelper.prototype.getPropertyValue(ele, className, "margin-left");
		var marginRight = $.ig.CssHelper.prototype.getPropertyValue(ele, className, "margin-right");
		var marginTopDb = marginTop != null ? parseFloat(marginTop) : 2;
		var marginBottomDb = marginBottom != null ? parseFloat(marginBottom) : 2;
		var marginLeftDb = marginLeft != null ? parseFloat(marginLeft) : 2;
		var marginRightDb = marginRight != null ? parseFloat(marginRight) : 2;
		$self.__defaultHorizontalAxisTitleMargin = new $.ig.Thickness(1, marginLeftDb, marginTopDb, marginRightDb, marginBottomDb);
	}

	, 
	updateDefaulVerrticalAxis: function (fontEle, ele) {
		var $self = this;
		var className = "ui-chart-vertical-axis-title";
		fontEle.addClass(className);
		$self.__defaultVerticalAxisFont = $.ig.FontUtil.prototype.getFont(fontEle);
		$self.__defaultVerticalAxisColor = (function () { var $ret = new $.ig.Brush();
		$ret.fill(fontEle.css("color")); return $ret;}());
		fontEle.removeClass(className);
		var val = $.ig.CssHelper.prototype.getPropertyValue(ele, className, "text-align");
		if (val == null) {
			$self.__defaultVerticalAxisTitlePosition = $.ig.AxisTitlePosition.prototype.auto;

		} else if (val.toLowerCase() == "right") {
			$self.__defaultVerticalAxisTitlePosition = $.ig.AxisTitlePosition.prototype.right;

		} else {
			$self.__defaultVerticalAxisTitlePosition = $.ig.AxisTitlePosition.prototype.left;
		}


		var marginTop = $.ig.CssHelper.prototype.getPropertyValue(ele, className, "margin-top");
		var marginBottom = $.ig.CssHelper.prototype.getPropertyValue(ele, className, "margin-bottom");
		var marginLeft = $.ig.CssHelper.prototype.getPropertyValue(ele, className, "margin-left");
		var marginRight = $.ig.CssHelper.prototype.getPropertyValue(ele, className, "margin-right");
		var marginTopDb = marginTop != null ? parseFloat(marginTop) : 0;
		var marginBottomDb = marginBottom != null ? parseFloat(marginBottom) : 0;
		var marginLeftDb = marginLeft != null ? parseFloat(marginLeft) : 0;
		var marginRightDb = marginRight != null ? parseFloat(marginRight) : 0;
		$self.__defaultVerticalAxisTitleMargin = new $.ig.Thickness(1, marginLeftDb, marginTopDb, marginRightDb, marginBottomDb);
	}

	, 
	ensureCorrectSize: function (width, height) {
		var pixelRatio = this.__owner.model().actualPixelScalingRatio();
		if (width != this.__currentCanvasWidth || height != this.__currentCanvasHeight || pixelRatio != this.__currentPixelRatio) {
			this.containerSizeChanging(width, height, this.__owner.model().actualPixelScalingRatio());
		}

	}
	, 
	__pointerTooltipStyle: null

	, 
	getPointerTooltipStyle: function () {
		return this.__pointerTooltipStyle;
	}

	, 
	isPagePanningAllowedChanged: function (allowed) {
		this.eventProxy().deferredTouchStartMode(allowed);
		this.eventProxy().shouldInteractForDirection(this.__owner.shouldInteractForDirection.runOn(this.__owner));
	}
	, 
	__tileMap: null

	, 
	acquireTileContent: function (window, tile, tileSize) {
		var $self = this;
		var canvas;
		if (!(function () { var $ret = $self.__tileMap.tryGetValue(tile.iD().toString(), canvas); canvas = $ret.p1; return $ret.ret; }())) {
			var canv = $("<canvas></canvas>");
			canv.attr("width", tileSize.toString());
			canv.attr("height", tileSize.toString());
			canv.css("width", tileSize.toString() + "px");
			canv.css("height", tileSize.toString() + "px");
			var c = canv[0];
			var context = c.getContext("2d");
			var r = new $.ig.RenderingContext(new $.ig.CanvasViewRenderer(), context);
			var t = new $.ig.Tuple$2($.ig.CanvasElement.prototype.$type, $.ig.RenderingContext.prototype.$type, c, r);
			canvas = t;
			$self.__tileMap.add(tile.iD().toString(), canvas);
		}

		var viewport = new $.ig.Rect(0, 0, 0, tileSize, tileSize);
		var surface = new $.ig.RenderSurface();
		surface.surface(canvas.item2());
		for (var i = 0; i < $self.__owner.model().series().count(); i++) {
			var series = $self.__owner.model().series().__inner[i];
			series.renderAlternateView(viewport, window, surface, "tile", 1);
		}

		$self.__owner.model().alternateViewRenderScheduler().flush();
		return canvas.item1();
	}

	, 
	destroyTileContent: function (tile) {
		this.__tileMap.remove(tile.iD().toString());
	}

	, 
	destroyAllTileContent: function () {
		this.__tileMap.clear();
	}

	, 
	renderTiles: function (visibleTiles) {
		for (var i = 0; i < visibleTiles.count(); i++) {
			var tile = visibleTiles.__inner[i];
			this.__owner.overlayContext().drawImage(tile.content(), 1, tile.xPosition() + this.__owner.model().viewportRect().left(), tile.yPosition() + this.__owner.model().viewportRect().top(), tile.width(), tile.height());
		}

	}
	, 
	__cacheClearID: 0

	, 
	deferCacheClear: function () {
		var $self = this;
		if ($self.__cacheClearID != -1) {
			$self.cancelDeferredCacheClear();
		}

		$self.__cacheClearID = window.setTimeout(function () { $self.__owner.model().deferredClearOfTileZoomCache(); }, 5000);
	}

	, 
	cancelDeferredCacheClear: function () {
		if (this.__cacheClearID != -1) {
			window.clearTimeout(this.__cacheClearID);
			this.__cacheClearID = -1;
		}

	}
	, 
	__endTileID: 0

	, 
	deferEndToTiledZoom: function (delay) {
		var $self = this;
		if ($self.__endTileID != -1) {
			$self.cancelEndToTiledZoom();
		}

		$self.__endTileID = window.setTimeout(function () { $self.__owner.model().endTiledZoomingIfRunning(); }, delay);
	}

	, 
	cancelEndToTiledZoom: function () {
		if (this.__endTileID != -1) {
			window.clearTimeout(this.__endTileID);
			this.__endTileID = -1;
		}

	}
	, 
	$type: new $.ig.Type('SeriesViewerViewManager', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('TileZoomManager', 'Object', {

	_viewer: null,
	viewer: function (value) {
		if (arguments.length === 1) {
			this._viewer = value;
			return value;
		} else {
			return this._viewer;
		}
	}

	, 
	_viewport: null,
	viewport: function (value) {
		if (arguments.length === 1) {
			this._viewport = value;
			return value;
		} else {
			return this._viewport;
		}
	}

	, 
	_window: null,
	window: function (value) {
		if (arguments.length === 1) {
			this._window = value;
			return value;
		} else {
			return this._window;
		}
	}

	, 
	_tileViewport: null,
	tileViewport: function (value) {
		if (arguments.length === 1) {
			this._tileViewport = value;
			return value;
		} else {
			return this._tileViewport;
		}
	}

	, 
	_running: false,
	running: function (value) {
		if (arguments.length === 1) {
			this._running = value;
			return value;
		} else {
			return this._running;
		}
	}

	, 
	_minZoomLevel: 0,
	minZoomLevel: function (value) {
		if (arguments.length === 1) {
			this._minZoomLevel = value;
			return value;
		} else {
			return this._minZoomLevel;
		}
	}

	, 
	_existingTiles: null,
	existingTiles: function (value) {
		if (arguments.length === 1) {
			this._existingTiles = value;
			return value;
		} else {
			return this._existingTiles;
		}
	}

	, 
	_persistentTiles: null,
	persistentTiles: function (value) {
		if (arguments.length === 1) {
			this._persistentTiles = value;
			return value;
		} else {
			return this._persistentTiles;
		}
	}

	, 
	_newTiles: null,
	newTiles: function (value) {
		if (arguments.length === 1) {
			this._newTiles = value;
			return value;
		} else {
			return this._newTiles;
		}
	}
	, 
	init: function (viewer, roundDown, cacheSize) {


		this.__lastDimension = -1;
		this.__horizontalCorrectiveSkew = 1;
		this.__verticalCorrectiveSkew = 1;
		this._tileID = 0;

		$.ig.Object.prototype.init.call(this);
			this.viewer(viewer);
			this.viewer().actualWindowRectChanged = $.ig.Delegate.prototype.combine(this.viewer().actualWindowRectChanged, this.viewer_ActualWindowRectChanged.runOn(this));
			this.viewer().gridAreaRectChanged = $.ig.Delegate.prototype.combine(this.viewer().gridAreaRectChanged, this.viewer_GridAreaRectChanged.runOn(this));
			this.tileCache(new $.ig.TileZoomTileCache(cacheSize, this));
			this.visibleTiles(new $.ig.List$1($.ig.TileZoomTileInfo.prototype.$type, 0));
			this.currentTiles(new $.ig.List$1($.ig.TileZoomTile.prototype.$type, 0));
			this.existingTiles(new $.ig.Dictionary$2($.ig.TileZoomTile.prototype.$type, $.ig.TileZoomTile.prototype.$type, 0));
			this.persistentTiles(new $.ig.Dictionary$2($.ig.TileZoomTile.prototype.$type, $.ig.TileZoomTile.prototype.$type, 0));
			this.newTiles(new $.ig.List$1($.ig.TileZoomTile.prototype.$type, 0));
			this.roundDown(roundDown);
			this.onViewportChanged();
	}
	, 
	__lastDimension: 0

	, 
	onViewportChanged: function () {
		this.viewport(this.viewer().viewportRect());
		this.actualViewport(this.applySkew(this.viewport()));
		var dimension = this.getDimension();
		this.clearVisible();
		this.clearTileCache();
		this.__lastDimension = dimension;
		this.minZoomLevel(this.getMinZoomLevel(dimension));
		this.tileViewport(new $.ig.Rect(0, 0, 0, dimension, dimension));
	}

	, 
	_actualViewport: null,
	actualViewport: function (value) {
		if (arguments.length === 1) {
			this._actualViewport = value;
			return value;
		} else {
			return this._actualViewport;
		}
	}

	, 
	applySkew: function (viewport) {
		return new $.ig.Rect(0, viewport.left(), viewport.top(), viewport.width() * this.__horizontalCorrectiveSkew, viewport.height() * this.__verticalCorrectiveSkew);
	}

	, 
	getMinZoomLevel: function (dimension) {
		var numTiles = dimension / $.ig.TileZoomManager.prototype.tileSize;
		var zoomLevel = Math.logBase(numTiles, 2);
		return zoomLevel;
	}

	, 
	getDimension: function () {
		var maxDimension = Math.max(this.actualViewport().width(), this.actualViewport().height());
		var targetDimensionMult = 1;
		var targetDimension = $.ig.TileZoomManager.prototype.tileSize;
		while (targetDimension < maxDimension) {
			targetDimensionMult++;
			targetDimension = $.ig.TileZoomManager.prototype.tileSize * targetDimensionMult;

		}
		return targetDimension;
	}

	, 
	viewer_GridAreaRectChanged: function (sender, e) {
		this.onViewportChanged();
		this.onWindowChanged();
	}

	, 
	viewer_ActualWindowRectChanged: function (sender, e) {
		this.onWindowChanged();
	}

	, 
	onWindowChanged: function () {
		this.__hasContent = true;
		this.window(this.viewer().actualWindowRect());
		if (this.running()) {
			if (this.updateCorrectiveSkew(this.window())) {
				$.ig.Debug.prototype.writeLine("skew change: " + this.__horizontalCorrectiveSkew + ", " + this.__verticalCorrectiveSkew);
				this.onViewportChanged();
			}

			this.determineVisibleTiles();
			this.readyVisibleTiles();
			this.displayVisibleTiles();
		}

	}
	, 
	__horizontalCorrectiveSkew: 0
	, 
	__verticalCorrectiveSkew: 0

	, 
	updateCorrectiveSkew: function (window) {
		var horizontalSkewCorrection = 1;
		var verticalSkewCorrection = 1;
		if (this.isTooSkewed(window)) {
			if (window.width() > window.height()) {
				var skew = 1;
				if (window.height() != 0) {
					skew = window.width() / window.height();
				}

				var snapPow = 0;
				var snap = 1;
				while (snap < skew) {
					snapPow++;
					snap = $.ig.truncate(Math.pow(3, snapPow));

				}
				snap = $.ig.truncate(Math.pow(3, snapPow - 1));
				verticalSkewCorrection = snap;
				if (verticalSkewCorrection == 0 || Number.isInfinity(verticalSkewCorrection) || $.ig.util.isNaN(verticalSkewCorrection)) {
					verticalSkewCorrection = 1;
				}


			} else {
				var skew1 = 1;
				if (window.width() != 0) {
					skew1 = window.height() / window.width();
				}

				var snapPow1 = 0;
				var snap1 = 1;
				while (snap1 < skew1) {
					snapPow1++;
					snap1 = $.ig.truncate(Math.pow(3, snapPow1));

				}
				snap1 = $.ig.truncate(Math.pow(3, snapPow1 - 1));
				horizontalSkewCorrection = snap1;
				if (Number.isInfinity(horizontalSkewCorrection) || $.ig.util.isNaN(horizontalSkewCorrection)) {
					horizontalSkewCorrection = 1;
				}

			}


		} else {
			horizontalSkewCorrection = 1;
			verticalSkewCorrection = 1;
		}

		var changed = verticalSkewCorrection != this.__verticalCorrectiveSkew || horizontalSkewCorrection != this.__horizontalCorrectiveSkew;
		this.__horizontalCorrectiveSkew = horizontalSkewCorrection;
		this.__verticalCorrectiveSkew = verticalSkewCorrection;
		return changed;
	}

	, 
	isTooSkewed: function (window) {
		return (window.width() / window.height()) > $.ig.TileZoomManager.prototype._maxAllowedSkew || (window.height() / window.width()) > $.ig.TileZoomManager.prototype._maxAllowedSkew;
	}

	, 
	displayVisibleTiles: function () {
		var info = this.getZoomInfo();
		for (var i = 0; i < this.currentTiles().count(); i++) {
			this.assignTileLocation(info, this.currentTiles().__inner[i]);
		}

		var existing = new $.ig.Dictionary$2($.ig.Object.prototype.$type, $.ig.TileZoomTile.prototype.$type, 0);
		var en = this.persistentTiles().keys().getEnumerator();
		while (en.moveNext()) {
			var key = en.current();
			existing.add(this.persistentTiles().item(key).content(), this.persistentTiles().item(key));
		}

		this.viewer().view().displayZoomTiles(existing, this.newTiles(), $.ig.TileZoomManager.prototype.tileSize);
	}

	, 
	assignTileLocation: function (info, tile) {
		var window = this.getTileWindow(tile, info);
		var left = window.left() * info.actualWidth();
		var top = window.top() * info.actualHeight();
		var right = window.right() * info.actualWidth();
		var bottom = window.bottom() * info.actualHeight();
		var locX = left - info.actualRect().left();
		var locY = top - info.actualRect().top();
		var width = right - left;
		var height = bottom - top;
		$.ig.Debug.prototype.assert(width > 0);
		$.ig.Debug.prototype.assert(height > 0);
		tile.xPosition(locX / this.__horizontalCorrectiveSkew);
		tile.yPosition(locY / this.__verticalCorrectiveSkew);
		tile.width(width / this.__horizontalCorrectiveSkew);
		tile.height(height / this.__verticalCorrectiveSkew);
	}

	, 
	readyVisibleTiles: function () {
		var info = this.getZoomInfo();
		this.existingTiles().clear();
		for (var i = 0; i < this.currentTiles().count(); i++) {
			var currentTile = this.currentTiles().__inner[i];
			this.existingTiles().add(currentTile, currentTile);
		}

		this.currentTiles().clear();
		this.persistentTiles().clear();
		this.newTiles().clear();
		for (var i1 = 0; i1 < this.visibleTiles().count(); i1++) {
			var currentTile1 = this.visibleTiles().__inner[i1];
			var tile = this.tileCache().getTile(currentTile1);
			if (tile == null) {
				tile = this.acquireTile(currentTile1, info);
				this.tileCache().addTile(tile);
			}

			if (this.existingTiles().containsKey(tile)) {
				this.existingTiles().remove(tile);
				this.persistentTiles().add(tile, tile);

			} else {
				this.activateTile(tile);
				this.newTiles().add(tile);
			}

			this.currentTiles().add(tile);
		}

		var en = this.existingTiles().keys().getEnumerator();
		while (en.moveNext()) {
			var key = en.current();
			this.deactivateTile(key);
		}

	}

	, 
	deactivateTile: function (key) {
	}

	, 
	activateTile: function (tile) {
	}

	, 
	acquireTile: function (tileInfo, info) {
		var tile = this.createTile(tileInfo);
		var window = this.getTileWindow(tile, info);
		var effectiveWindow = this.getEffectiveWindow();
		var widthScale = 1 / effectiveWindow.width();
		var heightScale = effectiveWindow.height();
		if (effectiveWindow.width() > effectiveWindow.height()) {
			widthScale = effectiveWindow.width();
			heightScale = 1 / effectiveWindow.height();
		}

		var left = (window.left() - effectiveWindow.left()) * widthScale;
		var top = (window.top() - effectiveWindow.top()) * heightScale;
		var right = (window.right() - effectiveWindow.left()) * widthScale;
		var bottom = (window.bottom() - effectiveWindow.top()) * heightScale;
		window = new $.ig.Rect(0, left, top, right - left, bottom - top);
		var content = this.viewer().view().acquireTileContent(window, tile, $.ig.truncate($.ig.TileZoomManager.prototype.tileSize));
		tile.content(content);
		return tile;
	}

	, 
	getEffectiveWindow: function () {
		var viewport = this.viewer().viewportRect();
		var effectiveViewport = this.viewer().effectiveViewport();
		if (effectiveViewport.isEmpty()) {
			return new $.ig.Rect(0, 0, 0, 1, 1);
		}

		var left = (effectiveViewport.left() - viewport.left()) / viewport.width();
		var top = (effectiveViewport.top() - viewport.top()) / viewport.height();
		var right = (effectiveViewport.right() - viewport.left()) / viewport.width();
		var bottom = (effectiveViewport.bottom() - viewport.top()) / viewport.height();
		return new $.ig.Rect(0, left, top, right - left, bottom - top);
	}

	, 
	getTileWindow: function (tile, info) {
		var tileLeft = tile.info().xPosition() * $.ig.TileZoomManager.prototype.tileSize;
		var tileTop = tile.info().yPosition() * $.ig.TileZoomManager.prototype.tileSize;
		var tileRight = tileLeft + $.ig.TileZoomManager.prototype.tileSize;
		var tileBottom = tileTop + $.ig.TileZoomManager.prototype.tileSize;
		var worldX = tileLeft / info.zoomWidth();
		var worldY = tileTop / info.zoomHeight();
		var worldWidth = $.ig.TileZoomManager.prototype.tileSize / info.zoomWidth();
		var worldHeight = $.ig.TileZoomManager.prototype.tileSize / info.zoomHeight();
		return new $.ig.Rect(0, worldX, worldY, worldWidth, worldHeight);
	}
	, 
	_tileID: 0

	, 
	createTile: function (tileInfo) {
		var id = 0;
		id = this._tileID;
		this._tileID++;
		var tile = new $.ig.TileZoomTile();
		tile.info(tileInfo);
		tile.iD(id);
		return tile;
	}

	, 
	_visibleTiles: null,
	visibleTiles: function (value) {
		if (arguments.length === 1) {
			this._visibleTiles = value;
			return value;
		} else {
			return this._visibleTiles;
		}
	}

	, 
	_currentTiles: null,
	currentTiles: function (value) {
		if (arguments.length === 1) {
			this._currentTiles = value;
			return value;
		} else {
			return this._currentTiles;
		}
	}

	, 
	getZoomInfo: function () {
		var actualWindow = this.getActualWindow(this.window());
		var currentZoomLevel = this.getZoomLevel(actualWindow);
		var width = Math.pow(2, currentZoomLevel) * $.ig.TileZoomManager.prototype.tileSize;
		var height = width;
		var zoomWidth = (this.actualViewport().width() / this.tileViewport().width()) * width;
		var zoomHeight = (this.actualViewport().height() / this.tileViewport().height()) * height;
		var actualWidth = (this.actualViewport().width() / actualWindow.width());
		var actualHeight = (this.actualViewport().height() / actualWindow.height());
		var actualLeft = actualWindow.left() * actualWidth;
		var actualTop = actualWindow.top() * actualHeight;
		var actualRight = actualWindow.right() * actualWidth;
		var actualBottom = actualWindow.bottom() * actualHeight;
		var info = new $.ig.TileZoomInfo();
		info.actualRect(new $.ig.Rect(0, actualLeft, actualTop, actualRight - actualLeft, actualBottom - actualTop));
		var windowAtZoom = this.getWindowAtZoom(this.window(), info.actualRect(), currentZoomLevel, actualWidth, actualHeight, zoomWidth, zoomHeight);
		var zoomLeft = windowAtZoom.left() * zoomWidth;
		var zoomTop = windowAtZoom.top() * zoomHeight;
		var zoomRight = windowAtZoom.right() * zoomWidth;
		var zoomBottom = windowAtZoom.bottom() * zoomHeight;
		info.zoomRect(new $.ig.Rect(0, zoomLeft, zoomTop, zoomRight - zoomLeft, zoomBottom - zoomTop));
		info.currentZoomLevel(currentZoomLevel);
		info.zoomWidth(zoomWidth);
		info.zoomHeight(zoomHeight);
		info.actualWidth(actualWidth);
		info.actualHeight(actualHeight);
		return info;
	}

	, 
	getActualWindow: function (window) {
		return window;
	}

	, 
	getWindowAtZoom: function (window, actualRect, currentZoomLevel, actualWidth, actualHeight, zoomWidth, zoomHeight) {
		var centerX = (window.left() + window.right()) / 2;
		var centerY = (window.top() + window.bottom()) / 2;
		var width = window.width();
		var height = window.height();
		width = width * actualWidth / zoomWidth;
		height = height * actualHeight / zoomHeight;
		var halfWidth = width / 2;
		var halfHeight = height / 2;
		return new $.ig.Rect(0, centerX - halfWidth, centerY - halfHeight, width, height);
	}

	, 
	determineVisibleTiles: function () {
		var $self = this;
		var info = $self.getZoomInfo();
		var tileSizeX = $.ig.TileZoomManager.prototype.tileSize * info.actualWidth() / info.zoomWidth();
		var tileSizeY = $.ig.TileZoomManager.prototype.tileSize * info.actualHeight() / info.zoomHeight();
		var xStart = $.ig.truncate(Math.floor(info.actualRect().left() / tileSizeX));
		var yStart = $.ig.truncate(Math.floor(info.actualRect().top() / tileSizeY));
		var xEnd = $.ig.truncate(Math.floor(info.actualRect().right() / tileSizeX));
		var yEnd = $.ig.truncate(Math.floor(info.actualRect().bottom() / tileSizeY));
		$self.visibleTiles().clear();
		for (var y = yStart; y <= yEnd; y++) {
			for (var x = xStart; x <= xEnd; x++) {
				$self.visibleTiles().add((function () { var $ret = new $.ig.TileZoomTileInfo();
				$ret.xPosition(x);
				$ret.yPosition(y);
				$ret.zoomLevel(info.currentZoomLevel()); return $ret;}()));
			}

		}

	}

	, 
	getZoomLevel: function (window) {
		var scaleHoriz = 1 / window.width();
		var scaleVert = 1 / window.height();
		var zoomHoriz;
		var zoomVert;
		if (this.roundDown()) {
			zoomHoriz = Math.floor(Math.logBase(scaleHoriz, 2));
			zoomVert = Math.floor(Math.logBase(scaleVert, 2));

		} else {
			zoomHoriz = Math.ceil(Math.logBase(scaleHoriz, 2));
			zoomVert = Math.ceil(Math.logBase(scaleVert, 2));
		}

		var zoom = Math.min(zoomHoriz, zoomVert) + (this.minZoomLevel());
		return $.ig.truncate(zoom);
	}

	, 
	_tileCache: null,
	tileCache: function (value) {
		if (arguments.length === 1) {
			this._tileCache = value;
			return value;
		} else {
			return this._tileCache;
		}
	}
	, 
	__hasContent: false

	, 
	clearTileCache: function () {
		if (!this.__hasContent) {
			return;
		}

		this.__hasContent = false;
		this.viewer().view().destroyAllTileContent();
		this.tileCache().clear();
	}

	, 
	start: function () {
		this.running(true);
	}

	, 
	end: function () {
		this.running(false);
		this.viewer().view().hideZoomTiles();
	}

	, 
	_roundDown: false,
	roundDown: function (value) {
		if (arguments.length === 1) {
			this._roundDown = value;
			return value;
		} else {
			return this._roundDown;
		}
	}

	, 
	destroyTile: function (tileZoomTile) {
		this.viewer().view().destroyTileContent(tileZoomTile);
	}

	, 
	clearVisible: function () {
		this.currentTiles().clear();
		this.visibleTiles().clear();
		this.existingTiles().clear();
	}
	, 
	$type: new $.ig.Type('TileZoomManager', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('TileZoomInfo', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	_actualRect: null,
	actualRect: function (value) {
		if (arguments.length === 1) {
			this._actualRect = value;
			return value;
		} else {
			return this._actualRect;
		}
	}

	, 
	_zoomRect: null,
	zoomRect: function (value) {
		if (arguments.length === 1) {
			this._zoomRect = value;
			return value;
		} else {
			return this._zoomRect;
		}
	}

	, 
	_currentZoomLevel: 0,
	currentZoomLevel: function (value) {
		if (arguments.length === 1) {
			this._currentZoomLevel = value;
			return value;
		} else {
			return this._currentZoomLevel;
		}
	}

	, 
	_zoomWidth: 0,
	zoomWidth: function (value) {
		if (arguments.length === 1) {
			this._zoomWidth = value;
			return value;
		} else {
			return this._zoomWidth;
		}
	}

	, 
	_zoomHeight: 0,
	zoomHeight: function (value) {
		if (arguments.length === 1) {
			this._zoomHeight = value;
			return value;
		} else {
			return this._zoomHeight;
		}
	}

	, 
	_actualWidth: 0,
	actualWidth: function (value) {
		if (arguments.length === 1) {
			this._actualWidth = value;
			return value;
		} else {
			return this._actualWidth;
		}
	}

	, 
	_actualHeight: 0,
	actualHeight: function (value) {
		if (arguments.length === 1) {
			this._actualHeight = value;
			return value;
		} else {
			return this._actualHeight;
		}
	}
	, 
	$type: new $.ig.Type('TileZoomInfo', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('TileZoomTileInfo', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	_zoomLevel: 0,
	zoomLevel: function (value) {
		if (arguments.length === 1) {
			this._zoomLevel = value;
			return value;
		} else {
			return this._zoomLevel;
		}
	}

	, 
	_xPosition: 0,
	xPosition: function (value) {
		if (arguments.length === 1) {
			this._xPosition = value;
			return value;
		} else {
			return this._xPosition;
		}
	}

	, 
	_yPosition: 0,
	yPosition: function (value) {
		if (arguments.length === 1) {
			this._yPosition = value;
			return value;
		} else {
			return this._yPosition;
		}
	}

	, 
	toString: function () {
		return this.zoomLevel() + "_" + this.xPosition() + "_" + this.yPosition();
	}
	, 
	$type: new $.ig.Type('TileZoomTileInfo', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('TileZoomTileCache', 'Object', {
	__cache: null
	, 
	__mru: null
	, 
	__maxTiles: 0
	, 
	__owner: null
	, 
	init: function (maxTiles, owner) {


		this.__cache = new $.ig.Dictionary$2(String, $.ig.TileZoomTile.prototype.$type, 0);
		this.__mru = new $.ig.LinkedList$1($.ig.TileZoomTile.prototype.$type);

		$.ig.Object.prototype.init.call(this);
			this.__maxTiles = maxTiles;
			this.__owner = owner;
	}

	, 
	clear: function () {
		this.__cache.clear();
		this.__mru = new $.ig.LinkedList$1($.ig.TileZoomTile.prototype.$type);
	}

	, 
	touch: function (tileZoomTile) {
		this.__mru.remove(tileZoomTile.node());
		this.__mru.addLast(tileZoomTile);
		tileZoomTile.node(this.__mru.last());
	}

	, 
	addTile: function (tileZoomTile) {
		this.__mru.addLast(tileZoomTile);
		this.__cache.add(tileZoomTile.info().toString(), tileZoomTile);
		tileZoomTile.owningCache(this);
		tileZoomTile.node(this.__mru.last());
		while (this.__cache.count() > this.__maxTiles) {
			this.removeTile(this.__mru.first().value());

		}
	}

	, 
	removeTile: function (tileZoomTile) {
		this.__mru.remove(tileZoomTile.node());
		this.__cache.remove(tileZoomTile.info().toString());
		this.__owner.destroyTile(tileZoomTile);
	}

	, 
	getTile: function (info) {
		if (this.__cache.containsKey(info.toString())) {
			var tile = this.__cache.item(info.toString());
			tile.touch();
			return tile;
		}

		return null;
	}
	, 
	$type: new $.ig.Type('TileZoomTileCache', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('TileZoomTile', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	_info: null,
	info: function (value) {
		if (arguments.length === 1) {
			this._info = value;
			return value;
		} else {
			return this._info;
		}
	}

	, 
	_owningCache: null,
	owningCache: function (value) {
		if (arguments.length === 1) {
			this._owningCache = value;
			return value;
		} else {
			return this._owningCache;
		}
	}

	, 
	_node: null,
	node: function (value) {
		if (arguments.length === 1) {
			this._node = value;
			return value;
		} else {
			return this._node;
		}
	}

	, 
	touch: function () {
		if (this.owningCache() == null) {
			return;
		}

		this.owningCache().touch(this);
	}

	, 
	_content: null,
	content: function (value) {
		if (arguments.length === 1) {
			this._content = value;
			return value;
		} else {
			return this._content;
		}
	}

	, 
	_xPosition: 0,
	xPosition: function (value) {
		if (arguments.length === 1) {
			this._xPosition = value;
			return value;
		} else {
			return this._xPosition;
		}
	}

	, 
	_width: 0,
	width: function (value) {
		if (arguments.length === 1) {
			this._width = value;
			return value;
		} else {
			return this._width;
		}
	}

	, 
	_yPosition: 0,
	yPosition: function (value) {
		if (arguments.length === 1) {
			this._yPosition = value;
			return value;
		} else {
			return this._yPosition;
		}
	}

	, 
	_height: 0,
	height: function (value) {
		if (arguments.length === 1) {
			this._height = value;
			return value;
		} else {
			return this._height;
		}
	}

	, 
	_iD: 0,
	iD: function (value) {
		if (arguments.length === 1) {
			this._iD = value;
			return value;
		} else {
			return this._iD;
		}
	}
	, 
	$type: new $.ig.Type('TileZoomTile', $.ig.Object.prototype.$type)
}, true);


































































































































$.ig.util.defType('DoughnutChartVisualData', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	_series: null,
	series: function (value) {
		if (arguments.length === 1) {
			this._series = value;
			return value;
		} else {
			return this._series;
		}
	}

	, 
	_height: 0,
	height: function (value) {
		if (arguments.length === 1) {
			this._height = value;
			return value;
		} else {
			return this._height;
		}
	}

	, 
	_width: 0,
	width: function (value) {
		if (arguments.length === 1) {
			this._width = value;
			return value;
		} else {
			return this._width;
		}
	}

	, 
	_holeRadius: 0,
	holeRadius: function (value) {
		if (arguments.length === 1) {
			this._holeRadius = value;
			return value;
		} else {
			return this._holeRadius;
		}
	}

	, 
	scaleByViewport: function () {
		if (this.series() != null) {
			var en = this.series().getEnumerator();
			while (en.moveNext()) {
				var series = en.current();
				var en1 = series.rings().getEnumerator();
				while (en1.moveNext()) {
					var ring = en1.current();
					var en2 = ring.arcs().getEnumerator();
					while (en2.moveNext()) {
						var arc = en2.current();
						var en3 = arc.slices().getEnumerator();
						while (en3.moveNext()) {
							var slice = en3.current();
							slice.scaleByViewport(this.viewport());
						}

					}

				}

			}

		}

	}

	, 
	serialize: function () {
		var sb = new $.ig.StringBuilder(0);
		var first = true;
		sb.appendLine1("{");
		if (!$.ig.util.isNaN(this.width())) {
			if (first) {
				first = false;

			} else {
				sb.append3(", ");
			}

			sb.append3("width: ");
			sb.appendLine1(this.width().toString());
		}

		if (!$.ig.util.isNaN(this.height())) {
			if (first) {
				first = false;

			} else {
				sb.append3(", ");
			}

			sb.append3("height: ");
			sb.appendLine1(this.height().toString());
		}

		if (!$.ig.util.isNaN(this.holeRadius())) {
			if (first) {
				first = false;

			} else {
				sb.append3(", ");
			}

			sb.append3("holeRadius: ");
			sb.appendLine1(this.holeRadius().toString());
		}

		if (this.series() != null) {
			if (first) {
				first = false;

			} else {
				sb.append3(", ");
			}

			sb.appendLine1("series: [");
			for (var i = 0; i < this.series().count(); i++) {
				if (i != 0) {
					sb.append3(", ");
				}

				sb.append3(this.series().__inner[i].serialize());
			}

			sb.appendLine1("]");
		}

		sb.appendLine1("}");
		return sb.toString();
	}

	, 
	_viewport: null,
	viewport: function (value) {
		if (arguments.length === 1) {
			this._viewport = value;
			return value;
		} else {
			return this._viewport;
		}
	}
	, 
	$type: new $.ig.Type('DoughnutChartVisualData', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('RingSeriesVisualData', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	_labelExtent: 0,
	labelExtent: function (value) {
		if (arguments.length === 1) {
			this._labelExtent = value;
			return value;
		} else {
			return this._labelExtent;
		}
	}

	, 
	_labelsPosition: null,
	labelsPosition: function (value) {
		if (arguments.length === 1) {
			this._labelsPosition = value;
			return value;
		} else {
			return this._labelsPosition;
		}
	}

	, 
	_leaderLineType: null,
	leaderLineType: function (value) {
		if (arguments.length === 1) {
			this._leaderLineType = value;
			return value;
		} else {
			return this._leaderLineType;
		}
	}

	, 
	_leaderLineVisibility: 0,
	leaderLineVisibility: function (value) {
		if (arguments.length === 1) {
			this._leaderLineVisibility = value;
			return value;
		} else {
			return this._leaderLineVisibility;
		}
	}

	, 
	_leaderLineMargin: 0,
	leaderLineMargin: function (value) {
		if (arguments.length === 1) {
			this._leaderLineMargin = value;
			return value;
		} else {
			return this._leaderLineMargin;
		}
	}

	, 
	_rings: null,
	rings: function (value) {
		if (arguments.length === 1) {
			this._rings = value;
			return value;
		} else {
			return this._rings;
		}
	}

	, 
	serialize: function () {
		var sb = new $.ig.StringBuilder(0);
		var first = true;
		sb.appendLine1("{");
		if (this.name() != null) {
			if (first) {
				first = false;

			} else {
				sb.append3(", ");
			}

			sb.append3("name: ");
			sb.appendLine1("\'" + this.name() + "\'");
		}

		if (!$.ig.util.isNaN(this.labelExtent())) {
			if (first) {
				first = false;

			} else {
				sb.append3(", ");
			}

			sb.append3("labelExtent: ");
			sb.appendLine1(this.labelExtent().toString());
		}

		if (this.labelsPosition() != null) {
			if (first) {
				first = false;

			} else {
				sb.append3(", ");
			}

			sb.append3("labelsPosition: ");
			sb.appendLine1(this.labelsPosition());
		}

		if (this.leaderLineType() != null) {
			if (first) {
				first = false;

			} else {
				sb.append3(", ");
			}

			sb.append3("leaderLineType: ");
			sb.appendLine1(this.leaderLineType());
		}

		sb.append3(", leaderLineVisibility: ");
		sb.appendLine1(this.leaderLineVisibility() == $.ig.Visibility.prototype.visible ? "1" : "0");
		if (!$.ig.util.isNaN(this.leaderLineMargin())) {
			if (first) {
				first = false;

			} else {
				sb.append3(", ");
			}

			sb.append3("leaderLineMargin: ");
			sb.appendLine1(this.leaderLineMargin().toString());
		}

		sb.appendLine1(", rings: [");
		for (var i = 0; i < this.rings().count(); i++) {
			if (i != 0) {
				sb.append3(", ");
			}

			sb.append3(this.rings().__inner[i].serialize());
		}

		sb.appendLine1("]}");
		return sb.toString();
	}
	, 
	$type: new $.ig.Type('RingSeriesVisualData', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('RingSeriesVisualDataList', 'List$1', {
	init: function () {


		$.ig.List$1.prototype.init.call(this, $.ig.RingSeriesVisualData.prototype.$type, 0);

	}, 
	$type: new $.ig.Type('RingSeriesVisualDataList', $.ig.List$1.prototype.$type.specialize($.ig.RingSeriesVisualData.prototype.$type))
}, true);

$.ig.util.defType('RingVisualData', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	_arcs: null,
	arcs: function (value) {
		if (arguments.length === 1) {
			this._arcs = value;
			return value;
		} else {
			return this._arcs;
		}
	}

	, 
	serialize: function () {
		var sb = new $.ig.StringBuilder(0);
		var first = true;
		sb.appendLine1("{");
		if (this.arcs() != null) {
			if (first) {
				first = false;

			} else {
				sb.append3(", ");
			}

			sb.appendLine1("arcs: [");
			for (var i = 0; i < this.arcs().count(); i++) {
				if (i != 0) {
					sb.append3(", ");
				}

				sb.append3(this.arcs().__inner[i].serialize());
			}

			sb.appendLine1("]");
		}

		sb.appendLine1("}");
		return sb.toString();
	}
	, 
	$type: new $.ig.Type('RingVisualData', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('RingVisualDataList', 'List$1', {
	init: function () {


		$.ig.List$1.prototype.init.call(this, $.ig.RingVisualData.prototype.$type, 0);

	}, 
	$type: new $.ig.Type('RingVisualDataList', $.ig.List$1.prototype.$type.specialize($.ig.RingVisualData.prototype.$type))
}, true);

$.ig.util.defType('ArcVisualData', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	_slices: null,
	slices: function (value) {
		if (arguments.length === 1) {
			this._slices = value;
			return value;
		} else {
			return this._slices;
		}
	}

	, 
	_leaderLine: null,
	leaderLine: function (value) {
		if (arguments.length === 1) {
			this._leaderLine = value;
			return value;
		} else {
			return this._leaderLine;
		}
	}

	, 
	scaleByViewport: function (viewport) {
		var en = this.slices().getEnumerator();
		while (en.moveNext()) {
			var slice = en.current();
			slice.scaleByViewport(viewport);
		}

	}

	, 
	serialize: function () {
		var sb = new $.ig.StringBuilder(0);
		var first = true;
		sb.appendLine1("{");
		if (this.leaderLine() != null) {
			if (first) {
				first = false;

			} else {
				sb.append3(", ");
			}

			sb.append3("leaderLine: ");
			sb.appendLine1(this.leaderLine().serialize());
		}

		if (this.slices() != null) {
			if (first) {
				first = false;

			} else {
				sb.append3(", ");
			}

			sb.appendLine1("slices: [");
			for (var i = 0; i < this.slices().count(); i++) {
				if (i != 0) {
					sb.append3(", ");
				}

				sb.append3(this.slices().__inner[i].serialize());
			}

		}

		sb.appendLine1("]}");
		return sb.toString();
	}
	, 
	$type: new $.ig.Type('ArcVisualData', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('ArcVisualDataList', 'List$1', {
	init: function () {


		$.ig.List$1.prototype.init.call(this, $.ig.ArcVisualData.prototype.$type, 0);

	}, 
	$type: new $.ig.Type('ArcVisualDataList', $.ig.List$1.prototype.$type.specialize($.ig.ArcVisualData.prototype.$type))
}, true);

$.ig.util.defType('SliceVisualData', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	_pieSlice: null,
	pieSlice: function (value) {
		if (arguments.length === 1) {
			this._pieSlice = value;
			return value;
		} else {
			return this._pieSlice;
		}
	}

	, 
	_outline: null,
	outline: function (value) {
		if (arguments.length === 1) {
			this._outline = value;
			return value;
		} else {
			return this._outline;
		}
	}

	, 
	_labelVisualData: null,
	labelVisualData: function (value) {
		if (arguments.length === 1) {
			this._labelVisualData = value;
			return value;
		} else {
			return this._labelVisualData;
		}
	}

	, 
	_backgroundPath: null,
	backgroundPath: function (value) {
		if (arguments.length === 1) {
			this._backgroundPath = value;
			return value;
		} else {
			return this._backgroundPath;
		}
	}

	, 
	_origin: null,
	origin: function (value) {
		if (arguments.length === 1) {
			this._origin = value;
			return value;
		} else {
			return this._origin;
		}
	}

	, 
	_explodedOrigin: null,
	explodedOrigin: function (value) {
		if (arguments.length === 1) {
			this._explodedOrigin = value;
			return value;
		} else {
			return this._explodedOrigin;
		}
	}

	, 
	_isExploded: false,
	isExploded: function (value) {
		if (arguments.length === 1) {
			this._isExploded = value;
			return value;
		} else {
			return this._isExploded;
		}
	}

	, 
	_isSelected: false,
	isSelected: function (value) {
		if (arguments.length === 1) {
			this._isSelected = value;
			return value;
		} else {
			return this._isSelected;
		}
	}

	, 
	_index: 0,
	index: function (value) {
		if (arguments.length === 1) {
			this._index = value;
			return value;
		} else {
			return this._index;
		}
	}

	, 
	_radius: 0,
	radius: function (value) {
		if (arguments.length === 1) {
			this._radius = value;
			return value;
		} else {
			return this._radius;
		}
	}

	, 
	_startAngle: 0,
	startAngle: function (value) {
		if (arguments.length === 1) {
			this._startAngle = value;
			return value;
		} else {
			return this._startAngle;
		}
	}

	, 
	_endAngle: 0,
	endAngle: function (value) {
		if (arguments.length === 1) {
			this._endAngle = value;
			return value;
		} else {
			return this._endAngle;
		}
	}

	, 
	_visibility: 0,
	visibility: function (value) {
		if (arguments.length === 1) {
			this._visibility = value;
			return value;
		} else {
			return this._visibility;
		}
	}

	, 
	scaleByViewport: function (viewport) {
		this.origin({__x: (this.origin().__x - viewport.left()) / viewport.width(), __y: (this.origin().__y - viewport.top()) / viewport.height(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
		this.explodedOrigin({__x: (this.explodedOrigin().__x - viewport.left()) / viewport.width(), __y: (this.explodedOrigin().__y - viewport.top()) / viewport.height(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
	}

	, 
	serialize: function () {
		var sb = new $.ig.StringBuilder(0);
		var first = true;
		sb.appendLine1("{");
		if (this.pieSlice() != null) {
			if (first) {
				first = false;

			} else {
				sb.append3(", ");
			}

			sb.append3("pieSlice: ");
			sb.appendLine1(this.pieSlice().serialize());
		}

		if (this.labelVisualData() != null) {
			if (first) {
				first = false;

			} else {
				sb.append3(", ");
			}

			sb.append3("labelVisualData: ");
			sb.appendLine1(this.labelVisualData().serialize());
		}

		if (this.backgroundPath() != null) {
			if (first) {
				first = false;

			} else {
				sb.append3(", ");
			}

			sb.append3("backgroundPath: ");
			sb.appendLine1(this.backgroundPath().serialize());
		}

		if (first) {
			first = false;

		} else {
			sb.append3(", ");
		}

		sb.append3("isExploded: ");
		sb.appendLine1(this.isExploded().toString());
		if (first) {
			first = false;

		} else {
			sb.append3(", ");
		}

		sb.append3("isSelected: ");
		sb.appendLine1(this.isSelected().toString());
		if (!$.ig.util.isNaN(this.explodedOrigin().__x) && !$.ig.util.isNaN(this.explodedOrigin().__y)) {
			if (first) {
				first = false;

			} else {
				sb.append3(", ");
			}

			sb.append3("explodedOrigin: ");
			sb.appendLine1("{ x: " + this.explodedOrigin().__x.toString() + ", y: " + this.explodedOrigin().__y.toString() + "}");
		}

		if (!$.ig.util.isNaN(this.origin().__x) && !$.ig.util.isNaN(this.origin().__y)) {
			if (first) {
				first = false;

			} else {
				sb.append3(", ");
			}

			sb.append3("origin: ");
			sb.appendLine1("{ x: " + this.origin().__x.toString() + ", y: " + this.origin().__y.toString() + "}");
		}

		if (!$.ig.util.isNaN(this.index())) {
			if (first) {
				first = false;

			} else {
				sb.append3(", ");
			}

			sb.append3("index: ");
			sb.appendLine1(this.index().toString());
		}

		if (!$.ig.util.isNaN(this.radius())) {
			if (first) {
				first = false;

			} else {
				sb.append3(", ");
			}

			sb.append3("radius: ");
			sb.appendLine1(this.radius().toString());
		}

		sb.append3(", visibility: ");
		sb.appendLine1($.ig.Visibility.prototype.getName(this.visibility()));
		if (!$.ig.util.isNaN(this.startAngle())) {
			if (first) {
				first = false;

			} else {
				sb.append3(", ");
			}

			sb.append3("startAngle: ");
			sb.appendLine1(this.startAngle().toString());
		}

		if (!$.ig.util.isNaN(this.endAngle())) {
			if (first) {
				first = false;

			} else {
				sb.append3(", ");
			}

			sb.append3("endAngle: ");
			sb.appendLine1(this.endAngle().toString());
		}

		sb.appendLine1("}");
		return sb.toString();
	}
	, 
	$type: new $.ig.Type('SliceVisualData', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('SliceVisualDataList', 'List$1', {
	init: function () {


		$.ig.List$1.prototype.init.call(this, $.ig.SliceVisualData.prototype.$type, 0);

	}, 
	$type: new $.ig.Type('SliceVisualDataList', $.ig.List$1.prototype.$type.specialize($.ig.SliceVisualData.prototype.$type))
}, true);

$.ig.util.defType('DoughnutChartLabelVisualData', 'Object', {
	init: function () {

		this._labelSize = new $.ig.Size();

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_labelValue: null,
	labelValue: function (value) {
		if (arguments.length === 1) {
			this._labelValue = value;
			return value;
		} else {
			return this._labelValue;
		}
	}

	, 
	_labelSize: null,
	labelSize: function (value) {
		if (arguments.length === 1) {
			this._labelSize = value;
			return value;
		} else {
			return this._labelSize;
		}
	}

	, 
	_labelPosition: null,
	labelPosition: function (value) {
		if (arguments.length === 1) {
			this._labelPosition = value;
			return value;
		} else {
			return this._labelPosition;
		}
	}

	, 
	scaleByViewport: function (viewport) {
		this.labelPosition({__x: (this.labelPosition().__x - viewport.left()) / viewport.width(), __y: (this.labelPosition().__y - viewport.top()) / viewport.height(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
		this.labelSize(new $.ig.Size(1, (this.labelSize().width()) / viewport.width(), (this.labelSize().height()) / viewport.height()));
	}

	, 
	serialize: function () {
		return "{ labelValue: \'" + this.labelValue() + "\', labelSize: { width: " + this.labelSize().width() + ", height: " + this.labelSize().height() + "}, labelPosition: { x: " + this.labelPosition().__x + ", y: " + this.labelPosition().__y + "}}";
	}
	, 
	$type: new $.ig.Type('DoughnutChartLabelVisualData', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('ChartVisualData', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.dipScalingRatio(1);
			this.axes(new $.ig.AxisVisualDataList());
			this.series(new $.ig.SeriesVisualDataList());
	}

	, 
	_axes: null,
	axes: function (value) {
		if (arguments.length === 1) {
			this._axes = value;
			return value;
		} else {
			return this._axes;
		}
	}

	, 
	_series: null,
	series: function (value) {
		if (arguments.length === 1) {
			this._series = value;
			return value;
		} else {
			return this._series;
		}
	}

	, 
	_title: null,
	title: function (value) {
		if (arguments.length === 1) {
			this._title = value;
			return value;
		} else {
			return this._title;
		}
	}

	, 
	_subtitle: null,
	subtitle: function (value) {
		if (arguments.length === 1) {
			this._subtitle = value;
			return value;
		} else {
			return this._subtitle;
		}
	}

	, 
	_width: 0,
	width: function (value) {
		if (arguments.length === 1) {
			this._width = value;
			return value;
		} else {
			return this._width;
		}
	}

	, 
	_height: 0,
	height: function (value) {
		if (arguments.length === 1) {
			this._height = value;
			return value;
		} else {
			return this._height;
		}
	}

	, 
	_contentArea: null,
	contentArea: function (value) {
		if (arguments.length === 1) {
			this._contentArea = value;
			return value;
		} else {
			return this._contentArea;
		}
	}

	, 
	_centralArea: null,
	centralArea: function (value) {
		if (arguments.length === 1) {
			this._centralArea = value;
			return value;
		} else {
			return this._centralArea;
		}
	}

	, 
	_plotArea: null,
	plotArea: function (value) {
		if (arguments.length === 1) {
			this._plotArea = value;
			return value;
		} else {
			return this._plotArea;
		}
	}

	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	_isViewportScaled: false,
	isViewportScaled: function (value) {
		if (arguments.length === 1) {
			this._isViewportScaled = value;
			return value;
		} else {
			return this._isViewportScaled;
		}
	}

	, 
	scaleByViewport: function () {
		var en = this.axes().getEnumerator();
		while (en.moveNext()) {
			var axis = en.current();
			axis.scaleByViewport();
		}

		var en1 = this.series().getEnumerator();
		while (en1.moveNext()) {
			var series = en1.current();
			series.scaleByViewport();
		}

		if (this.title() != null) {
			this.title().scaleByViewport();
		}

		if (this.subtitle() != null) {
			this.subtitle().scaleByViewport();
		}

	}

	, 
	getBounds: function () {
		return new $.ig.Rect(0, 0, 0, this.width(), this.height());
	}

	, 
	serialize: function () {
		var sb = new $.ig.StringBuilder(0);
		sb.appendLine1("{");
		sb.appendLine1("name: " + this.name() + ",");
		sb.appendLine1("width: " + this.width() + ",");
		sb.appendLine1("height: " + this.height() + ",");
		sb.appendLine1("plotArea: { left: " + this.plotArea().left() + ", top: " + this.plotArea().top() + ", width: " + this.plotArea().width() + ", height: " + this.plotArea().height() + "}, ");
		sb.appendLine1("contentArea: { left: " + this.contentArea().left() + ", top: " + this.contentArea().top() + ", width: " + this.contentArea().width() + ", height: " + this.contentArea().height() + "}, ");
		sb.appendLine1("centralArea: { left: " + this.centralArea().left() + ", top: " + this.centralArea().top() + ", width: " + this.centralArea().width() + ", height: " + this.centralArea().height() + "}, ");
		sb.appendLine1("isViewportScaled: " + (this.isViewportScaled() ? "true" : "false") + ", ");
		sb.appendLine1("axes: [");
		for (var i = 0; i < this.axes().count(); i++) {
			if (i != 0) {
				sb.append3(", ");
			}

			sb.append3(this.axes().__inner[i].serialize());
		}

		sb.appendLine1("],");
		sb.appendLine1("series: [");
		for (var i1 = 0; i1 < this.series().count(); i1++) {
			if (i1 != 0) {
				sb.append3(", ");
			}

			sb.append3(this.series().__inner[i1].serialize());
		}

		sb.appendLine1("]");
		if (this.title() != null) {
			sb.appendLine1(", title: " + this.title().serialize());
		}

		if (this.subtitle() != null) {
			sb.appendLine1(", subtitle: " + this.subtitle().serialize());
		}

		sb.append3(", dipScalingRatio: " + this.dipScalingRatio().toString());
		sb.appendLine1("}");
		return sb.toString();
	}

	, 
	getSerializedSeriesPoints: function (seriesName, tag, settings) {
		var points = new $.ig.List$1($.ig.List$1.prototype.$type.specialize($.ig.Point.prototype.$type), 0);
		for (var i = 0; i < this.series().count(); i++) {
			if (this.series().__inner[i].name() == seriesName) {
				var hasTag = this.series().__inner[i].shapes().containingTag(tag);
				for (var j = 0; j < hasTag.count(); j++) {
					var shape = hasTag.__inner[i];
					shape.getPointsOverride(points, settings);
				}

			}

		}

		var sb = new $.ig.StringBuilder(0);
		sb.appendLine1("[");
		for (var i1 = 0; i1 < points.count(); i1++) {
			var pointList = points.__inner[i1];
			sb.appendLine1("[");
			for (var j1 = 0; j1 < pointList.count(); j1++) {
				if (j1 != 0) {
					sb.append3(", ");
				}

				sb.append3("{ x: " + pointList.__inner[j1].__x + ", y: " + pointList.__inner[j1].__y + "}");
			}

			sb.appendLine1("]");
		}

		sb.appendLine1("]");
		return sb.toString();
	}

	, 
	_dipScalingRatio: 0,
	dipScalingRatio: function (value) {
		if (arguments.length === 1) {
			this._dipScalingRatio = value;
			return value;
		} else {
			return this._dipScalingRatio;
		}
	}
	, 
	$type: new $.ig.Type('ChartVisualData', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('ChartTitleVisualData', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.appearance(new $.ig.LabelAppearanceData());
	}

	, 
	width: function () {

			return this.viewport().width();
	}

	, 
	height: function () {

			return this.viewport().height();
	}

	, 
	_viewport: null,
	viewport: function (value) {
		if (arguments.length === 1) {
			this._viewport = value;
			return value;
		} else {
			return this._viewport;
		}
	}

	, 
	_textPlotArea: null,
	textPlotArea: function (value) {
		if (arguments.length === 1) {
			this._textPlotArea = value;
			return value;
		} else {
			return this._textPlotArea;
		}
	}

	, 
	_appearance: null,
	appearance: function (value) {
		if (arguments.length === 1) {
			this._appearance = value;
			return value;
		} else {
			return this._appearance;
		}
	}

	, 
	serialize: function () {
		var sb = new $.ig.StringBuilder(0);
		sb.appendLine1("{");
		sb.appendLine1("viewport: " + $.ig.VisualDataSerializer.prototype.serialize(this.viewport()) + ", ");
		sb.appendLine1("textPlotArea: " + $.ig.VisualDataSerializer.prototype.serialize(this.textPlotArea()) + ", ");
		sb.appendLine1("appearance: " + this.appearance().serialize());
		sb.appendLine1("}");
		return sb.toString();
	}

	, 
	scaleByViewport1: function (viewport) {
		var x = (this.textPlotArea().x() - viewport.left()) / viewport.width();
		var y = (this.textPlotArea().y() - viewport.top()) / viewport.height();
		var width = this.textPlotArea().width() / viewport.width();
		var height = this.textPlotArea().height() / viewport.height();
		this.textPlotArea(new $.ig.Rect(0, x, y, width, height));
	}

	, 
	scaleByViewport: function () {
		var x = (this.textPlotArea().x() - this.viewport().left()) / this.viewport().width();
		var y = (this.textPlotArea().y() - this.viewport().top()) / this.viewport().height();
		var width = this.textPlotArea().width() / this.viewport().width();
		var height = this.textPlotArea().height() / this.viewport().height();
		this.textPlotArea(new $.ig.Rect(0, x, y, width, height));
	}

	, 
	unScaleByViewport1: function (viewport) {
		var x = this.textPlotArea().x() * viewport.width();
		var y = this.textPlotArea().y() * viewport.height();
		var width = this.textPlotArea().width() * viewport.width();
		var height = this.textPlotArea().height() * viewport.height();
		this.textPlotArea(new $.ig.Rect(0, x, y, width, height));
	}

	, 
	unScaleByViewport: function () {
		var x = this.textPlotArea().x() * this.viewport().width();
		var y = this.textPlotArea().y() * this.viewport().height();
		var width = this.textPlotArea().width() * this.viewport().width();
		var height = this.textPlotArea().height() * this.viewport().height();
		this.textPlotArea(new $.ig.Rect(0, x, y, width, height));
	}
	, 
	$type: new $.ig.Type('ChartTitleVisualData', $.ig.Object.prototype.$type)
}, true);


$.ig.util.defType('PieChartVisualData', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.slices(new $.ig.PieSliceVisualDataList());
			this.others(new $.ig.List$1($.ig.Object.prototype.$type, 0));
	}

	, 
	_slices: null,
	slices: function (value) {
		if (arguments.length === 1) {
			this._slices = value;
			return value;
		} else {
			return this._slices;
		}
	}

	, 
	_othersSlice: null,
	othersSlice: function (value) {
		if (arguments.length === 1) {
			this._othersSlice = value;
			return value;
		} else {
			return this._othersSlice;
		}
	}

	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	_viewport: null,
	viewport: function (value) {
		if (arguments.length === 1) {
			this._viewport = value;
			return value;
		} else {
			return this._viewport;
		}
	}

	, 
	_width: 0,
	width: function (value) {
		if (arguments.length === 1) {
			this._width = value;
			return value;
		} else {
			return this._width;
		}
	}

	, 
	_height: 0,
	height: function (value) {
		if (arguments.length === 1) {
			this._height = value;
			return value;
		} else {
			return this._height;
		}
	}

	, 
	_others: null,
	others: function (value) {
		if (arguments.length === 1) {
			this._others = value;
			return value;
		} else {
			return this._others;
		}
	}

	, 
	_isViewportScaled: false,
	isViewportScaled: function (value) {
		if (arguments.length === 1) {
			this._isViewportScaled = value;
			return value;
		} else {
			return this._isViewportScaled;
		}
	}

	, 
	scaleByViewport: function () {
		if (this.isViewportScaled()) {
			return;
		}

		this.isViewportScaled(true);
		for (var i = 0; i < this.slices().count(); i++) {
			this.slices().__inner[i].scaleByViewport(this.viewport());
		}

		if (this.othersSlice() != null) {
			this.othersSlice().scaleByViewport(this.viewport());
		}

	}

	, 
	serialize: function () {
		var sb = new $.ig.StringBuilder(0);
		sb.appendLine1("{");
		sb.appendLine1("name: " + this.name() + ",");
		sb.appendLine1("width: " + this.width() + ",");
		sb.appendLine1("height: " + this.height() + ",");
		sb.appendLine1("isViewportScaled: " + (this.isViewportScaled() ? "true" : "false") + ", ");
		sb.appendLine1("slices: [");
		for (var i = 0; i < this.slices().count(); i++) {
			if (i != 0) {
				sb.append3(", ");
			}

			sb.append3(this.slices().__inner[i].serialize());
		}

		sb.appendLine1("],");
		sb.appendLine1("viewport: { left: " + this.viewport().left() + ", top: " + this.viewport().top() + ", width: " + this.viewport().width() + ", height: " + this.viewport().height() + "}");
		sb.appendLine1("}");
		return sb.toString();
	}
	, 
	$type: new $.ig.Type('PieChartVisualData', $.ig.Object.prototype.$type)
}, true);


$.ig.util.defType('SeriesVisualData', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.shapes(new $.ig.PrimitiveVisualDataList());
			this.markerShapes(new $.ig.MarkerVisualDataList());
			this.pointerTooltips(new $.ig.PointerTooltipVisualDataList());
	}

	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	_type: null,
	type: function (value) {
		if (arguments.length === 1) {
			this._type = value;
			return value;
		} else {
			return this._type;
		}
	}

	, 
	_viewport: null,
	viewport: function (value) {
		if (arguments.length === 1) {
			this._viewport = value;
			return value;
		} else {
			return this._viewport;
		}
	}

	, 
	_opacity: 0,
	opacity: function (value) {
		if (arguments.length === 1) {
			this._opacity = value;
			return value;
		} else {
			return this._opacity;
		}
	}

	, 
	_shapes: null,
	shapes: function (value) {
		if (arguments.length === 1) {
			this._shapes = value;
			return value;
		} else {
			return this._shapes;
		}
	}

	, 
	_pointerTooltips: null,
	pointerTooltips: function (value) {
		if (arguments.length === 1) {
			this._pointerTooltips = value;
			return value;
		} else {
			return this._pointerTooltips;
		}
	}

	, 
	_markerShapes: null,
	markerShapes: function (value) {
		if (arguments.length === 1) {
			this._markerShapes = value;
			return value;
		} else {
			return this._markerShapes;
		}
	}

	, 
	_pixels: null,
	pixels: function (value) {
		if (arguments.length === 1) {
			this._pixels = value;
			return value;
		} else {
			return this._pixels;
		}
	}

	, 
	_pixelWidth: 0,
	pixelWidth: function (value) {
		if (arguments.length === 1) {
			this._pixelWidth = value;
			return value;
		} else {
			return this._pixelWidth;
		}
	}

	, 
	scaleByViewport: function () {
		var en = this.shapes().getEnumerator();
		while (en.moveNext()) {
			var shape = en.current();
			shape.scaleByViewport(this.viewport());
		}

		var en1 = this.markerShapes().getEnumerator();
		while (en1.moveNext()) {
			var markerShape = en1.current();
			markerShape.scaleByViewport(this.viewport());
		}

		var en2 = this.pointerTooltips().getEnumerator();
		while (en2.moveNext()) {
			var pointer = en2.current();
			pointer.scaleByViewport(this.viewport());
		}

	}

	, 
	serialize: function () {
		var sb = new $.ig.StringBuilder(0);
		sb.appendLine1("{");
		sb.appendLine1("name: \"" + this.name() + "\",");
		sb.appendLine1("type: \"" + this.type() + "\", ");
		sb.appendLine1("opacity: " + this.opacity() + ", ");
		sb.appendLine1("viewport: { left: " + this.viewport().left() + ", top: " + this.viewport().top() + ", width: " + this.viewport().width() + ", height: " + this.viewport().height() + "}, ");
		sb.appendLine1("shapes: [");
		for (var i = 0; i < this.shapes().count(); i++) {
			if (i != 0) {
				sb.append3(", ");
			}

			sb.append3(this.shapes().__inner[i].serialize());
		}

		sb.appendLine1("],");
		sb.appendLine1("pointerTooltips: [");
		for (var i1 = 0; i1 < this.pointerTooltips().count(); i1++) {
			if (i1 != 0) {
				sb.append3(", ");
			}

			sb.append3(this.pointerTooltips().__inner[i1].serialize());
		}

		sb.appendLine1("],");
		sb.appendLine1("markerShapes: [");
		for (var i2 = 0; i2 < this.markerShapes().count(); i2++) {
			if (i2 != 0) {
				sb.append3(", ");
			}

			sb.append3(this.markerShapes().__inner[i2].serialize());
		}

		sb.appendLine1("]");
		if (this.pixels() != null) {
			sb.appendLine1(", pixels: [");
			for (var i3 = 0; i3 < this.pixels().length; i3++) {
				if (i3 != 0) {
					sb.append3(", ");
				}

				sb.append3(this.pixels()[i3].toString());
			}

			sb.appendLine1("], ");
			sb.appendLine1("pixelWidth: " + this.pixelWidth() + ", ");
		}

		sb.appendLine1("}");
		return sb.toString();
	}
	, 
	$type: new $.ig.Type('SeriesVisualData', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('SeriesVisualDataList', 'List$1', {
	init: function () {


		$.ig.List$1.prototype.init.call(this, $.ig.SeriesVisualData.prototype.$type, 0);

	}, 
	$type: new $.ig.Type('SeriesVisualDataList', $.ig.List$1.prototype.$type.specialize($.ig.SeriesVisualData.prototype.$type))
}, true);

$.ig.util.defType('MarkerVisualData', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	_x: 0,
	x: function (value) {
		if (arguments.length === 1) {
			this._x = value;
			return value;
		} else {
			return this._x;
		}
	}

	, 
	_y: 0,
	y: function (value) {
		if (arguments.length === 1) {
			this._y = value;
			return value;
		} else {
			return this._y;
		}
	}

	, 
	_index: 0,
	index: function (value) {
		if (arguments.length === 1) {
			this._index = value;
			return value;
		} else {
			return this._index;
		}
	}

	, 
	_markerAppearance: null,
	markerAppearance: function (value) {
		if (arguments.length === 1) {
			this._markerAppearance = value;
			return value;
		} else {
			return this._markerAppearance;
		}
	}

	, 
	_markerType: null,
	markerType: function (value) {
		if (arguments.length === 1) {
			this._markerType = value;
			return value;
		} else {
			return this._markerType;
		}
	}

	, 
	_contentTemplate: null,
	contentTemplate: function (value) {
		if (arguments.length === 1) {
			this._contentTemplate = value;
			return value;
		} else {
			return this._contentTemplate;
		}
	}

	, 
	_visibility: 0,
	visibility: function (value) {
		if (arguments.length === 1) {
			this._visibility = value;
			return value;
		} else {
			return this._visibility;
		}
	}

	, 
	serialize: function () {
		return "{ x: " + this.x() + ", y: " + this.y() + ", index: " + this.index() + ", markerAppearance: " + (this.markerAppearance() != null ? this.markerAppearance().serialize() : "null") + ", markerType: \"" + this.markerType() + "\", visibility: " + (this.visibility() == $.ig.Visibility.prototype.visible ? "true" : "false") + "}";
	}

	, 
	scaleByViewport: function (viewport) {
		this.x((this.x() - viewport.left()) / viewport.width());
		this.y((this.y() - viewport.top()) / viewport.height());
	}
	, 
	$type: new $.ig.Type('MarkerVisualData', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('MarkerVisualDataList', 'List$1', {
	init: function () {


		$.ig.List$1.prototype.init.call(this, $.ig.MarkerVisualData.prototype.$type, 0);

	}, 
	$type: new $.ig.Type('MarkerVisualDataList', $.ig.List$1.prototype.$type.specialize($.ig.MarkerVisualData.prototype.$type))
}, true);

$.ig.util.defType('AxisVisualData', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.tickMarksLength(0);
			this.labels(new $.ig.AxisLabelVisualDataList());
			this.title(new $.ig.ChartTitleVisualData());
	}

	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	_type: null,
	type: function (value) {
		if (arguments.length === 1) {
			this._type = value;
			return value;
		} else {
			return this._type;
		}
	}

	, 
	_viewport: null,
	viewport: function (value) {
		if (arguments.length === 1) {
			this._viewport = value;
			return value;
		} else {
			return this._viewport;
		}
	}

	, 
	_tickMarksLength: 0,
	tickMarksLength: function (value) {
		if (arguments.length === 1) {
			this._tickMarksLength = value;
			return value;
		} else {
			return this._tickMarksLength;
		}
	}

	, 
	_tickMarks: null,
	tickMarks: function (value) {
		if (arguments.length === 1) {
			this._tickMarks = value;
			return value;
		} else {
			return this._tickMarks;
		}
	}

	, 
	_labels: null,
	labels: function (value) {
		if (arguments.length === 1) {
			this._labels = value;
			return value;
		} else {
			return this._labels;
		}
	}

	, 
	_axisLine: null,
	axisLine: function (value) {
		if (arguments.length === 1) {
			this._axisLine = value;
			return value;
		} else {
			return this._axisLine;
		}
	}

	, 
	_majorLines: null,
	majorLines: function (value) {
		if (arguments.length === 1) {
			this._majorLines = value;
			return value;
		} else {
			return this._majorLines;
		}
	}

	, 
	_minorLines: null,
	minorLines: function (value) {
		if (arguments.length === 1) {
			this._minorLines = value;
			return value;
		} else {
			return this._minorLines;
		}
	}

	, 
	_strips: null,
	strips: function (value) {
		if (arguments.length === 1) {
			this._strips = value;
			return value;
		} else {
			return this._strips;
		}
	}

	, 
	_labelsPlotArea: null,
	labelsPlotArea: function (value) {
		if (arguments.length === 1) {
			this._labelsPlotArea = value;
			return value;
		} else {
			return this._labelsPlotArea;
		}
	}

	, 
	_labelsViewport: null,
	labelsViewport: function (value) {
		if (arguments.length === 1) {
			this._labelsViewport = value;
			return value;
		} else {
			return this._labelsViewport;
		}
	}

	, 
	_title: null,
	title: function (value) {
		if (arguments.length === 1) {
			this._title = value;
			return value;
		} else {
			return this._title;
		}
	}

	, 
	scaleByViewport: function () {
		var isHorizontal = true;
		if (this.type().equals("NumericYAxis") || this.type().equals("CategoryYAxis")) {
			isHorizontal = false;
		}

		var en = this.labels().getEnumerator();
		while (en.moveNext()) {
			var label = en.current();
			label.scaleByViewport(this.labelsViewport(), isHorizontal);
		}

		this.tickMarks().scaleByViewport(this.labelsViewport());
		this.axisLine().scaleByViewport(this.labelsViewport());
		if (this.title() != null) {
			this.title().scaleByViewport1(this.labelsViewport());
		}

		this.majorLines().scaleByViewport(this.viewport());
		this.minorLines().scaleByViewport(this.viewport());
		this.strips().scaleByViewport(this.viewport());
	}

	, 
	serialize: function () {
		var sb = new $.ig.StringBuilder(0);
		sb.appendLine1("{");
		sb.appendLine1("name: \"" + this.name() + "\",");
		sb.appendLine1("type: \"" + this.type() + "\", ");
		sb.appendLine1("tickMarksLength: \"" + this.tickMarksLength().toString() + "\", ");
		sb.appendLine1("viewport: " + $.ig.VisualDataSerializer.prototype.serialize(this.viewport()) + ", ");
		sb.appendLine1("labelsViewport: " + $.ig.VisualDataSerializer.prototype.serialize(this.labelsViewport()) + ", ");
		if (this.labelsPlotArea() != null) {
			sb.appendLine1("labelsPlotArea: " + $.ig.VisualDataSerializer.prototype.serialize(this.labelsPlotArea()) + ", ");
		}

		sb.appendLine1("labels: [");
		for (var i = 0; i < this.labels().count(); i++) {
			if (i != 0) {
				sb.append3(", ");
			}

			sb.append3(this.labels().__inner[i].serialize());
		}

		sb.appendLine1("],");
		if (this.title() != null) {
			sb.appendLine1("title: " + ((this.title() != null) ? this.title().serialize() : "null") + ", ");
		}

		sb.appendLine1("axisLine: " + ((this.axisLine() != null) ? this.axisLine().serialize() : "null") + ", ");
		sb.appendLine1("tickMarks: " + ((this.tickMarks() != null) ? this.tickMarks().serialize() : "null") + ", ");
		if (this.axisLine() != null) {
			sb.appendLine1("majorLines: " + ((this.majorLines() != null) ? this.majorLines().serialize() : "null") + ", ");
			sb.appendLine1("minorLines: " + ((this.minorLines() != null) ? this.minorLines().serialize() : "null") + ", ");
			sb.appendLine1("strips: " + ((this.strips() != null) ? this.strips().serialize() : "null"));
		}

		sb.appendLine1("}");
		return sb.toString();
	}
	, 
	$type: new $.ig.Type('AxisVisualData', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('AxisVisualDataList', 'List$1', {
	init: function () {


		$.ig.List$1.prototype.init.call(this, $.ig.AxisVisualData.prototype.$type, 0);

	}, 
	$type: new $.ig.Type('AxisVisualDataList', $.ig.List$1.prototype.$type.specialize($.ig.AxisVisualData.prototype.$type))
}, true);

$.ig.util.defType('PieSliceVisualData', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.labelBounds($.ig.Rect.prototype.empty());
	}

	, 
	_label: null,
	label: function (value) {
		if (arguments.length === 1) {
			this._label = value;
			return value;
		} else {
			return this._label;
		}
	}

	, 
	_labelBounds: null,
	labelBounds: function (value) {
		if (arguments.length === 1) {
			this._labelBounds = value;
			return value;
		} else {
			return this._labelBounds;
		}
	}

	, 
	_appearance: null,
	appearance: function (value) {
		if (arguments.length === 1) {
			this._appearance = value;
			return value;
		} else {
			return this._appearance;
		}
	}

	, 
	_labelAppearance: null,
	labelAppearance: function (value) {
		if (arguments.length === 1) {
			this._labelAppearance = value;
			return value;
		} else {
			return this._labelAppearance;
		}
	}

	, 
	_leaderLineAppearance: null,
	leaderLineAppearance: function (value) {
		if (arguments.length === 1) {
			this._leaderLineAppearance = value;
			return value;
		} else {
			return this._leaderLineAppearance;
		}
	}

	, 
	_slicePath: null,
	slicePath: function (value) {
		if (arguments.length === 1) {
			this._slicePath = value;
			return value;
		} else {
			return this._slicePath;
		}
	}

	, 
	scaleByViewport: function (viewport) {
		if (this.slicePath() != null) {
			this.slicePath().scaleByViewport(viewport);
		}

		var left = (this.labelBounds().left() - viewport.left()) / viewport.width();
		var top = (this.labelBounds().top() - viewport.top()) / viewport.height();
		var right = (this.labelBounds().right() - viewport.left()) / viewport.width();
		var bottom = (this.labelBounds().bottom() - viewport.top()) / viewport.height();
		this.labelBounds(new $.ig.Rect(0, left, top, right - left, bottom - top));
	}

	, 
	serialize: function () {
		var sb = new $.ig.StringBuilder(0);
		sb.appendLine1("{");
		if (this.label() != null) {
			sb.appendLine1("label: " + this.label() + ", ");
		}

		if (this.appearance() != null) {
			sb.appendLine1(" : " + this.appearance().serialize() + ", ");
		}

		if (this.labelAppearance() != null) {
			sb.appendLine1(" : " + this.labelAppearance().serialize() + ", ");
		}

		if (this.leaderLineAppearance() != null) {
			sb.appendLine1(" : " + this.leaderLineAppearance().serialize() + ", ");
		}

		if (this.slicePath() != null) {
			sb.appendLine1(" : " + this.slicePath().serialize());
		}

		sb.appendLine1("labelBounds: { left: " + this.labelBounds().left() + ", top: " + this.labelBounds().top() + ", width: " + this.labelBounds().width() + ", height: " + this.labelBounds().height() + "}");
		sb.appendLine1("}");
		return sb.toString();
	}
	, 
	$type: new $.ig.Type('PieSliceVisualData', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('PieSliceVisualDataList', 'List$1', {
	init: function () {


		$.ig.List$1.prototype.init.call(this, $.ig.PieSliceVisualData.prototype.$type, 0);

	}, 
	$type: new $.ig.Type('PieSliceVisualDataList', $.ig.List$1.prototype.$type.specialize($.ig.PieSliceVisualData.prototype.$type))
}, true);



$.ig.util.defType('AxisLabelVisualData', 'Object', {

	_labelValue: null,
	labelValue: function (value) {
		if (arguments.length === 1) {
			this._labelValue = value;
			return value;
		} else {
			return this._labelValue;
		}
	}

	, 
	_labelPosition: 0,
	labelPosition: function (value) {
		if (arguments.length === 1) {
			this._labelPosition = value;
			return value;
		} else {
			return this._labelPosition;
		}
	}

	, 
	_position: null,
	position: function (value) {
		if (arguments.length === 1) {
			this._position = value;
			return value;
		} else {
			return this._position;
		}
	}

	, 
	_panelPosition: null,
	panelPosition: function (value) {
		if (arguments.length === 1) {
			this._panelPosition = value;
			return value;
		} else {
			return this._panelPosition;
		}
	}

	, 
	_appearance: null,
	appearance: function (value) {
		if (arguments.length === 1) {
			this._appearance = value;
			return value;
		} else {
			return this._appearance;
		}
	}

	, 
	_size: null,
	size: function (value) {
		if (arguments.length === 1) {
			this._size = value;
			return value;
		} else {
			return this._size;
		}
	}
	, 
	init: function () {


		this._size = new $.ig.Size();

		$.ig.Object.prototype.init.call(this);
			this.position({__x: NaN, __y: NaN, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			this.size(new $.ig.Size(1, NaN, NaN));
			this.panelPosition({__x: NaN, __y: NaN, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
	}

	, 
	serialize: function () {
		var sb = new $.ig.StringBuilder(0);
		sb.appendLine1("{");
		sb.appendLine1("position: " + "{ x: " + this.position().__x + ", y: " + this.position().__y + "},");
		sb.appendLine1("size: " + "{ width: " + this.size().width() + ", height: " + this.size().height() + "},");
		sb.appendLine1("labelPosition: " + this.labelPosition() + ",");
		sb.appendLine1("appearance: " + (this.appearance() != null ? this.appearance().serialize() : "null"));
		sb.appendLine1("}");
		return sb.toString();
	}

	, 
	scaleByViewport: function (viewport, isHorizontal) {
		if (isHorizontal) {
			this.labelPosition((this.labelPosition() - viewport.left()) / viewport.width());

		} else {
			this.labelPosition((this.labelPosition() - viewport.top()) / viewport.height());
		}

		var x = (this.position().__x - viewport.left()) / viewport.width();
		var y = (this.position().__y - viewport.top()) / viewport.height();
		this.position({__x: x, __y: y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
		var w = (this.size().width()) / viewport.width();
		var h = (this.size().height()) / viewport.height();
		this.size(new $.ig.Size(1, w, h));
		;}
	, 
	$type: new $.ig.Type('AxisLabelVisualData', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('AxisLabelVisualDataList', 'List$1', {
	init: function () {


		$.ig.List$1.prototype.init.call(this, $.ig.AxisLabelVisualData.prototype.$type, 0);

	}, 
	$type: new $.ig.Type('AxisLabelVisualDataList', $.ig.List$1.prototype.$type.specialize($.ig.AxisLabelVisualData.prototype.$type))
}, true);

$.ig.util.defType('PointerTooltipVisualData', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	_boxShape: null,
	boxShape: function (value) {
		if (arguments.length === 1) {
			this._boxShape = value;
			return value;
		} else {
			return this._boxShape;
		}
	}

	, 
	_pointerFillShape: null,
	pointerFillShape: function (value) {
		if (arguments.length === 1) {
			this._pointerFillShape = value;
			return value;
		} else {
			return this._pointerFillShape;
		}
	}

	, 
	_pointerOutlineShape: null,
	pointerOutlineShape: function (value) {
		if (arguments.length === 1) {
			this._pointerOutlineShape = value;
			return value;
		} else {
			return this._pointerOutlineShape;
		}
	}

	, 
	_offsetX: 0,
	offsetX: function (value) {
		if (arguments.length === 1) {
			this._offsetX = value;
			return value;
		} else {
			return this._offsetX;
		}
	}

	, 
	_offsetY: 0,
	offsetY: function (value) {
		if (arguments.length === 1) {
			this._offsetY = value;
			return value;
		} else {
			return this._offsetY;
		}
	}

	, 
	_categoryNames: null,
	categoryNames: function (value) {
		if (arguments.length === 1) {
			this._categoryNames = value;
			return value;
		} else {
			return this._categoryNames;
		}
	}

	, 
	serialize: function () {
		var catNames = "";
		if (this.categoryNames() != null) {
			var en = this.categoryNames().getEnumerator();
			while (en.moveNext()) {
				var name = en.current();
				catNames += "\'" + name + "\',";
			}

			if (catNames != "") {
				catNames = catNames.substr(0, catNames.length - 1);
			}

		}

		var sb = new $.ig.StringBuilder(0);
		sb.appendLine1("{");
		sb.appendLine1("offsetX: " + this.offsetX() + ", ");
		sb.appendLine1("offsetY: " + this.offsetY() + ", ");
		sb.appendLine1("boxShape: " + this.boxShape().serialize() + ", ");
		sb.appendLine1("pointerFillShape: " + this.pointerFillShape().serialize() + ", ");
		sb.appendLine1("viewport: { left: " + this.viewport().left() + ", top: " + this.viewport().top() + ", width: " + this.viewport().width() + ", height: " + this.viewport().height() + "}, ");
		sb.appendLine1("pointerOutlineShape: " + this.pointerOutlineShape().serialize() + ", ");
		sb.appendLine1("categoryNames: [" + catNames + "]");
		sb.appendLine1("}");
		return sb.toString();
	}

	, 
	scaleByViewport: function (viewport) {
		this.boxShape().scaleByViewport(this.viewport());
		this.pointerFillShape().scaleByViewport(this.viewport());
		this.pointerOutlineShape().scaleByViewport(this.viewport());
		this.offsetX((this.offsetX() - viewport.left()) / viewport.width());
		this.offsetY((this.offsetY() - viewport.top()) / viewport.height());
	}

	, 
	_viewport: null,
	viewport: function (value) {
		if (arguments.length === 1) {
			this._viewport = value;
			return value;
		} else {
			return this._viewport;
		}
	}
	, 
	$type: new $.ig.Type('PointerTooltipVisualData', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('PointerTooltipVisualDataList', 'List$1', {
	init: function () {


		$.ig.List$1.prototype.init.call(this, $.ig.PointerTooltipVisualData.prototype.$type, 0);

	}, 
	$type: new $.ig.Type('PointerTooltipVisualDataList', $.ig.List$1.prototype.$type.specialize($.ig.PointerTooltipVisualData.prototype.$type))
}, true);


$.ig.util.defType('VisualExportHelper', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	getRotatedBounds: function (textBlock) {
		var location = {__x: textBlock.canvasLeft(), __y: textBlock.canvasTop(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		var bounds = new $.ig.Rect(0, location.__x, location.__y, textBlock.actualWidth(), textBlock.actualHeight());
		var transform = textBlock.renderTransform();
		if (transform == null) {
			return bounds;
		}

		var angle = 0;
		var x = 0;
		var y = 0;
		var rotTransform = null;
		if ($.ig.util.cast($.ig.RotateTransform.prototype.$type, transform) !== null) {
			rotTransform = $.ig.util.cast($.ig.RotateTransform.prototype.$type, transform);
			angle = rotTransform.angle();

		} else if ($.ig.util.cast($.ig.TransformGroup.prototype.$type, transform) !== null) {
			var tg = $.ig.util.cast($.ig.TransformGroup.prototype.$type, transform);
			var en = tg.children().getEnumerator();
			while (en.moveNext()) {
				var child = en.current();
				if ($.ig.util.cast($.ig.RotateTransform.prototype.$type, child) !== null) {
					rotTransform = $.ig.util.cast($.ig.RotateTransform.prototype.$type, child);
					angle = rotTransform.angle();
				}

				if ($.ig.util.cast($.ig.TranslateTransform.prototype.$type, child) !== null) {
					var tt = $.ig.util.cast($.ig.TranslateTransform.prototype.$type, child);
					x = tt.x();
					y = tt.y();
				}

			}

		}


		if (rotTransform != null) {
		bounds = $.ig.RectUtil.prototype.rotateAboutPoint(bounds, rotTransform.centerX(), rotTransform.centerY(), angle);
		}

		bounds.x(bounds.x() + x);
		bounds.y(bounds.y() + y);
		return bounds;
	}
	, 
	$type: new $.ig.Type('VisualExportHelper', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('VisualDataSerializer', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	serialize: function (rect) {
		var ret = "{ left: " + rect.left() + ", top: " + rect.top() + ", width: " + rect.width() + ", height: " + rect.height() + " }";
		return ret;
	}
	, 
	$type: new $.ig.Type('VisualDataSerializer', $.ig.Object.prototype.$type)
}, true);







$.ig.util.defType('Series___ToEnumerableRange__IteratorClass', 'Object', {
	__1__state: 0
	, 
	__2__current: 0
	, 
	__i_5_0: 0
	, 
	_expression: null
	, 
	__3__expression: null
	, 
	_start: 0
	, 
	__3__start: 0
	, 
	_length: 0
	, 
	__3__length: 0
	, 
	init: function (_1__state) {



		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	moveNext: function () {
		while (this.__1__state >= 0) {
			switch (this.__1__state) {
				case 0:
					this.__1__state = -1;
					this.__i_5_0 = this._start;
					this.__1__state = 1;
					break;
				case 1:
					this.__1__state = -1;
					if (this.__i_5_0 < this._length) {
						this.__2__current = this._expression(this.__i_5_0);
						this.__1__state = 2;
						return true;
					}

					break;
				case 2:
					this.__1__state = -1;
					this.__i_5_0++;
					this.__1__state = 1;
					break;
			}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.Series___ToEnumerableRange__IteratorClass(0);
		}

		d__._expression = this.__3__expression;
		d__._start = this.__3__start;
		d__._length = this.__3__length;
		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('Series___ToEnumerableRange__IteratorClass', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(Number), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize(Number), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);



$.ig.util.defType('ChartContentManager___InOrder__IteratorClass', 'Object', {
	__1__state: 0
	, 
	__2__current: null
	, 
	__ofType_5_0: null
	, 
	_itemEnumerator: null
	, 
	__item_5_1: null
	, 
	__contentList_5_2: null
	, 
	_itemEnumerator0: null
	, 
	__item_5_3: null
	, 
	_itemEnumerator1: null
	, 
	__item_5_4: null
	, 
	__4__this: null
	, 
	init: function (_1__state) {



		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	_m_Finally0: function () {
		this.__1__state = -1;
		if (this._itemEnumerator != null) {
			this._itemEnumerator.dispose();
		}

	}

	, 
	_m_Finally1: function () {
		this.__1__state = -1;
		if (this._itemEnumerator0 != null) {
			this._itemEnumerator0.dispose();
		}

	}

	, 
	_m_Finally2: function () {
		this.__1__state = -1;
		if (this._itemEnumerator1 != null) {
			this._itemEnumerator1.dispose();
		}

	}

	, 
	moveNext: function () {
		var __hasError__ = false;
		try {
				while (this.__1__state >= 0) {
					switch (this.__1__state) {
						case 0:
							this.__1__state = -1;
							this.__ofType_5_0 = null;
							this.__ofType_5_0 = this.__4__this.__content.item($.ig.ChartContentType.prototype.axis);
							this.__1__state = 1;
							this._itemEnumerator = ((this.__ofType_5_0.values())).getEnumerator();
							this.__1__state = 2;
							break;
						case 2:
							this.__1__state = 1;
							if (this._itemEnumerator.moveNext()) {
								this.__item_5_1 = this._itemEnumerator.current();
								this.__2__current = this.__item_5_1;
								this.__1__state = 2;
								return true;
							}

							this._m_Finally0();
							this.__ofType_5_0 = this.__4__this.__content.item($.ig.ChartContentType.prototype.series);
							this.__contentList_5_2 = new $.ig.List$1($.ig.ContentInfo.prototype.$type, 0);
							var en = this.__4__this.seriesList().getEnumerator();
							while (en.moveNext()) {
								var series = en.current();
								if (!series.isAnnotationLayer()) {
									this.__contentList_5_2.add(this.__ofType_5_0.item(series));
								}

							}

							var en1 = this.__4__this.seriesList().getEnumerator();
							while (en1.moveNext()) {
								var series1 = en1.current();
								if (series1.isAnnotationLayer()) {
									this.__contentList_5_2.add(this.__ofType_5_0.item(series1));
								}

							}

							this.__1__state = 3;
							this._itemEnumerator0 = this.__contentList_5_2.getEnumerator();
							this.__1__state = 4;
							break;
						case 4:
							this.__1__state = 3;
							if (this._itemEnumerator0.moveNext()) {
								this.__item_5_3 = this._itemEnumerator0.current();
								this.__2__current = this.__item_5_3;
								this.__1__state = 4;
								return true;
							}

							this._m_Finally1();
							this.__ofType_5_0 = this.__4__this.__content.item($.ig.ChartContentType.prototype.background);
							this.__1__state = 5;
							this._itemEnumerator1 = ((this.__ofType_5_0.values())).getEnumerator();
							this.__1__state = 6;
							break;
						case 6:
							this.__1__state = 5;
							if (this._itemEnumerator1.moveNext()) {
								this.__item_5_4 = this._itemEnumerator1.current();
								this.__2__current = this.__item_5_4;
								this.__1__state = 6;
								return true;
							}

							this._m_Finally2();
							break;
					}


				}

		}
		catch (e) {
				__hasError__ = true;
				throw e;

		}finally {
				if (__hasError__) {
				(this).dispose();
				}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.ChartContentManager___InOrder__IteratorClass(0);
			d__.__4__this = this.__4__this;
		}

		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
		switch (this.__1__state) {
			case 1:
			case 2:
				this._m_Finally0();
				break;
			case 3:
			case 4:
				this._m_Finally1();
				break;
			case 5:
			case 6:
				this._m_Finally2();
				break;
		}

	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('ChartContentManager___InOrder__IteratorClass', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize($.ig.ContentInfo.prototype.$type), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize($.ig.ContentInfo.prototype.$type), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

$.ig.util.defType('SeriesViewer___SynchronizedCharts__IteratorClass', 'Object', {
	__1__state: 0
	, 
	__2__current: null
	, 
	_chartEnumerator: null
	, 
	__chart_5_0: null
	, 
	__4__this: null
	, 
	init: function (_1__state) {



		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	_m_Finally0: function () {
		this.__1__state = -1;
		if (this._chartEnumerator != null) {
			this._chartEnumerator.dispose();
		}

	}

	, 
	moveNext: function () {
		var __hasError__ = false;
		try {
				while (this.__1__state >= 0) {
					switch (this.__1__state) {
						case 0:
							this.__1__state = -1;
							if (this.__4__this.actualSyncLink() == null) {
								return false;
							}

							this.__1__state = 1;
							this._chartEnumerator = ((this.__4__this.actualSyncLink().charts())).getEnumerator();
							this.__1__state = 2;
							break;
						case 2:
							this.__1__state = 1;
							if (this._chartEnumerator.moveNext()) {
								this.__chart_5_0 = this._chartEnumerator.current();
								this.__2__current = this.__chart_5_0;
								this.__1__state = 2;
								return true;
							}

							this._m_Finally0();
							break;
					}


				}

		}
		catch (e) {
				__hasError__ = true;
				throw e;

		}finally {
				if (__hasError__) {
				(this).dispose();
				}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.SeriesViewer___SynchronizedCharts__IteratorClass(0);
			d__.__4__this = this.__4__this;
		}

		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
		switch (this.__1__state) {
			case 1:
			case 2:
				this._m_Finally0();
				break;
		}

	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('SeriesViewer___SynchronizedCharts__IteratorClass', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize($.ig.SeriesViewer.prototype.$type), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize($.ig.SeriesViewer.prototype.$type), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);


$.ig.util.defType('Axis___DirectSeries__IteratorClass', 'Object', {
	__1__state: 0
	, 
	__2__current: null
	, 
	__i_5_0: 0
	, 
	__currentSeries_5_1: null
	, 
	__4__this: null
	, 
	init: function (_1__state) {



		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	moveNext: function () {
		while (this.__1__state >= 0) {
			switch (this.__1__state) {
				case 0:
					this.__1__state = -1;
					this.__i_5_0 = 0;
					this.__1__state = 1;
					break;
				case 1:
					this.__1__state = -1;
					if (this.__i_5_0 < this.__4__this.series().count()) {
						this.__currentSeries_5_1 = this.__4__this.series().__inner[this.__i_5_0];
						this.__2__current = this.__currentSeries_5_1;
						this.__1__state = 2;
						return true;
					}

					break;
				case 2:
					this.__1__state = -1;
					this.__i_5_0++;
					this.__1__state = 1;
					break;
			}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.Axis___DirectSeries__IteratorClass(0);
			d__.__4__this = this.__4__this;
		}

		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('Axis___DirectSeries__IteratorClass', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize($.ig.Series.prototype.$type), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize($.ig.Series.prototype.$type), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

$.ig.util.defType('AxisLabelPanelBase___GetLabels__IteratorClass', 'Object', {
	__1__state: 0
	, 
	__2__current: null
	, 
	_eleEnumerator: null
	, 
	__ele_5_0: null
	, 
	__4__this: null
	, 
	init: function (_1__state) {



		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	_m_Finally0: function () {
		this.__1__state = -1;
		if (this._eleEnumerator != null) {
			this._eleEnumerator.dispose();
		}

	}

	, 
	moveNext: function () {
		var __hasError__ = false;
		try {
				while (this.__1__state >= 0) {
					switch (this.__1__state) {
						case 0:
							this.__1__state = 1;
							this._eleEnumerator = ((this.__4__this.children())).getEnumerator();
							this.__1__state = 2;
							break;
						case 2:
							this.__1__state = 1;
							if (this._eleEnumerator.moveNext()) {
								this.__ele_5_0 = this._eleEnumerator.current();
								if (this.__ele_5_0 != this.__4__this.axis().titleTextBlock() && this.__ele_5_0 != this.__4__this.view().ticks()) {
									this.__2__current = this.__ele_5_0;
									this.__1__state = 2;
									return true;
								}

								this.__1__state = 2;
								break;
							}

							this._m_Finally0();
							break;
					}


				}

		}
		catch (e) {
				__hasError__ = true;
				throw e;

		}finally {
				if (__hasError__) {
				(this).dispose();
				}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.AxisLabelPanelBase___GetLabels__IteratorClass(0);
			d__.__4__this = this.__4__this;
		}

		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
		switch (this.__1__state) {
			case 1:
			case 2:
				this._m_Finally0();
				break;
		}

	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('AxisLabelPanelBase___GetLabels__IteratorClass', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize($.ig.Object.prototype.$type), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize($.ig.Object.prototype.$type), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);


$.ig.util.defType('AxisLabelPanelBase___GetTextBlocks__IteratorClass', 'Object', {
	__1__state: 0
	, 
	__2__current: null
	, 
	__i_5_0: 0
	, 
	__4__this: null
	, 
	init: function (_1__state) {



		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	moveNext: function () {
		while (this.__1__state >= 0) {
			switch (this.__1__state) {
				case 0:
					this.__1__state = -1;
					this.__i_5_0 = 0;
					this.__1__state = 1;
					break;
				case 1:
					this.__1__state = -1;
					if (this.__i_5_0 < this.__4__this.axis().textBlocks().count()) {
						this.__2__current = this.__4__this.axis().textBlocks().item(this.__i_5_0);
						this.__1__state = 2;
						return true;
					}

					break;
				case 2:
					this.__1__state = -1;
					this.__i_5_0++;
					this.__1__state = 1;
					break;
			}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.AxisLabelPanelBase___GetTextBlocks__IteratorClass(0);
			d__.__4__this = this.__4__this;
		}

		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('AxisLabelPanelBase___GetTextBlocks__IteratorClass', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize($.ig.Object.prototype.$type), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize($.ig.Object.prototype.$type), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

















$.ig.WindowResponse.prototype.deferred = 0;
$.ig.WindowResponse.prototype.immediate = 1;




$.ig.OthersCategoryType.prototype.number = 0;
$.ig.OthersCategoryType.prototype.percent = 1;



$.ig.LabelsPosition.prototype.none = 0;
$.ig.LabelsPosition.prototype.center = 1;
$.ig.LabelsPosition.prototype.insideEnd = 2;
$.ig.LabelsPosition.prototype.outsideEnd = 3;
$.ig.LabelsPosition.prototype.bestFit = 4;


$.ig.GridMode.prototype.none = 0;
$.ig.GridMode.prototype.beforeSeries = 1;
$.ig.GridMode.prototype.behindSeries = 2;


$.ig.AxisOrientation.prototype.horizontal = 0;
$.ig.AxisOrientation.prototype.vertical = 1;
$.ig.AxisOrientation.prototype.angular = 2;
$.ig.AxisOrientation.prototype.radial = 3;


$.ig.CategoryMode.prototype.mode0 = 0;
$.ig.CategoryMode.prototype.mode1 = 1;
$.ig.CategoryMode.prototype.mode2 = 2;


$.ig.AxisLabelsLocation.prototype.outsideTop = 0;
$.ig.AxisLabelsLocation.prototype.outsideBottom = 1;
$.ig.AxisLabelsLocation.prototype.outsideLeft = 2;
$.ig.AxisLabelsLocation.prototype.outsideRight = 3;
$.ig.AxisLabelsLocation.prototype.insideTop = 4;
$.ig.AxisLabelsLocation.prototype.insideBottom = 5;
$.ig.AxisLabelsLocation.prototype.insideLeft = 6;
$.ig.AxisLabelsLocation.prototype.insideRight = 7;


$.ig.TransitionInSpeedType.prototype.auto = 0;
$.ig.TransitionInSpeedType.prototype.normal = 1;
$.ig.TransitionInSpeedType.prototype.valueScaled = 2;
$.ig.TransitionInSpeedType.prototype.indexScaled = 3;
$.ig.TransitionInSpeedType.prototype.random = 4;


$.ig.HighlightingState.prototype.outward = 0;
$.ig.HighlightingState.prototype.inward = 1;
$.ig.HighlightingState.prototype.static = 2;




$.ig.ChartContentType.prototype.series = 0;
$.ig.ChartContentType.prototype.axis = 1;
$.ig.ChartContentType.prototype.background = 2;





$.ig.LeaderLineType.prototype.straight = 0;
$.ig.LeaderLineType.prototype.arc = 1;
$.ig.LeaderLineType.prototype.spline = 2;





$.ig.AxisExtentType.prototype.pixel = 0;
$.ig.AxisExtentType.prototype.percent = 1;



$.ig.AxisTitlePosition.prototype.auto = 0;
$.ig.AxisTitlePosition.prototype.left = 1;
$.ig.AxisTitlePosition.prototype.right = 2;
$.ig.AxisTitlePosition.prototype.top = 3;
$.ig.AxisTitlePosition.prototype.bottom = 4;






$.ig.SeriesViewer.prototype.crosshairPointPropertyName = "CrosshairPoint";
$.ig.SeriesViewer.prototype.legendPropertyName = "Legend";
$.ig.SeriesViewer.prototype.legendProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.legendPropertyName, $.ig.LegendBase.prototype.$type, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	var chart = $.ig.util.cast($.ig.SeriesViewer.prototype.$type, sender);
	chart.raisePropertyChanged($.ig.SeriesViewer.prototype.legendPropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.animateSeriesWhenAxisRangeChangesPropertyName = "AnimateSeriesWhenAxisRangeChanges";
$.ig.SeriesViewer.prototype.animateSeriesWhenAxisRangeChangesProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.animateSeriesWhenAxisRangeChangesPropertyName, $.ig.Boolean.prototype.$type, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, false, function (sender, e) {
	var chart = $.ig.util.cast($.ig.SeriesViewer.prototype.$type, sender);
	chart.raisePropertyChanged($.ig.SeriesViewer.prototype.animateSeriesWhenAxisRangeChangesPropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.windowRectPropertyName = "WindowRect";
$.ig.SeriesViewer.prototype.windowRectProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.windowRectPropertyName, $.ig.Rect.prototype.$type, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, new $.ig.Rect(0, 0, 0, 1, 1), function (sender, e) {
	($.ig.util.cast($.ig.SeriesViewer.prototype.$type, sender)).raisePropertyChanged($.ig.SeriesViewer.prototype.windowRectPropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.useTiledZoomingPropertyName = "UseTiledZooming";
$.ig.SeriesViewer.prototype.useTiledZoomingProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.useTiledZoomingPropertyName, $.ig.Boolean.prototype.$type, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, false, function (sender, e) {
	(sender).raisePropertyChanged($.ig.SeriesViewer.prototype.useTiledZoomingPropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.preferHigherResolutionTilesPropertyName = "PreferHigherResolutionTiles";
$.ig.SeriesViewer.prototype.preferHigherResolutionTilesProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.preferHigherResolutionTilesPropertyName, $.ig.Boolean.prototype.$type, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, false, function (sender, e) {
	(sender).raisePropertyChanged($.ig.SeriesViewer.prototype.preferHigherResolutionTilesPropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.defaultZoomCacheSize = 30;
$.ig.SeriesViewer.prototype.zoomTileCacheSizePropertyName = "ZoomTileCacheSize";
$.ig.SeriesViewer.prototype.zoomTileCacheSizeProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.zoomTileCacheSizePropertyName, $.ig.Number.prototype.$type, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.SeriesViewer.prototype.defaultZoomCacheSize, function (sender, e) {
	(sender).raisePropertyChanged($.ig.SeriesViewer.prototype.zoomTileCacheSizePropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.highlightingTransitionDurationPropertyName = "HighlightingTransitionDuration";
$.ig.SeriesViewer.prototype.highlightingTransitionDurationProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.highlightingTransitionDurationPropertyName, $.ig.Number.prototype.$type, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, 300, function (sender, e) {
	($.ig.util.cast($.ig.SeriesViewer.prototype.$type, sender)).raisePropertyChanged($.ig.SeriesViewer.prototype.highlightingTransitionDurationPropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.isPagePanningAllowedPropertyName = "IsPagePanningAllowed";
$.ig.SeriesViewer.prototype.isPagePanningAllowedProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.isPagePanningAllowedPropertyName, $.ig.Boolean.prototype.$type, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, false, function (sender, e) {
	($.ig.util.cast($.ig.SeriesViewer.prototype.$type, sender)).raisePropertyChanged($.ig.SeriesViewer.prototype.isPagePanningAllowedPropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.isSurfaceInteractionDisabledPropertyName = "IsSurfaceInteractionDisabled";
$.ig.SeriesViewer.prototype.isSurfaceInteractionDisabledProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.isSurfaceInteractionDisabledPropertyName, $.ig.Boolean.prototype.$type, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, false, function (sender, e) {
	(sender).raisePropertyChanged($.ig.SeriesViewer.prototype.isSurfaceInteractionDisabledPropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.dRAG_DISTANCE = 10;
$.ig.SeriesViewer.prototype.dRAG_DISTANCE_NEAR = 2;
$.ig.SeriesViewer.prototype._windowResponsePropertyName = "WindowResponse";
$.ig.SeriesViewer.prototype.windowResponseProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype._windowResponsePropertyName, $.ig.WindowResponse.prototype.$type, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.WindowResponse.prototype.getBox($.ig.WindowResponse.prototype.deferred), function (sender, e) {
	($.ig.util.cast($.ig.SeriesViewer.prototype.$type, sender)).raisePropertyChanged($.ig.SeriesViewer.prototype._windowResponsePropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.windowRectMinWidthPropertyName = "WindowRectMinWidth";
$.ig.SeriesViewer.prototype.windowRectMinWidthProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.windowRectMinWidthPropertyName, Number, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, 0.0001, function (o, e) { ($.ig.util.cast($.ig.SeriesViewer.prototype.$type, o)).raisePropertyChanged($.ig.SeriesViewer.prototype.windowRectMinWidthPropertyName, e.oldValue(), e.newValue()); }));
$.ig.SeriesViewer.prototype.actualSyncLinkPropertyName = "ActualSyncLink";
$.ig.SeriesViewer.prototype.overviewPlusDetailPaneVisibilityPropertyName = "OverviewPlusDetailPaneVisibility";
$.ig.SeriesViewer.prototype.overviewPlusDetailPaneVisibilityProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.overviewPlusDetailPaneVisibilityPropertyName, $.ig.Visibility.prototype.$type, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.Visibility.prototype.getBox($.ig.Visibility.prototype.collapsed), function (sender, e) {
	($.ig.util.cast($.ig.SeriesViewer.prototype.$type, sender)).raisePropertyChanged($.ig.SeriesViewer.prototype.overviewPlusDetailPaneVisibilityPropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.crosshairVisibilityPropertyName = "CrosshairVisibility";
$.ig.SeriesViewer.prototype.crosshairVisibilityProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.crosshairVisibilityPropertyName, $.ig.Visibility.prototype.$type, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.Visibility.prototype.getBox($.ig.Visibility.prototype.visible), function (sender, e) {
	($.ig.util.cast($.ig.SeriesViewer.prototype.$type, sender)).raisePropertyChanged($.ig.SeriesViewer.prototype.crosshairVisibilityPropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.isDragCrosshairEnabledPropertyName = "IsDragCrosshairEnabled";
$.ig.SeriesViewer.prototype.isDragCrosshairEnabledProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.isDragCrosshairEnabledPropertyName, $.ig.Boolean.prototype.$type, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, false, function (sender, e) {
	($.ig.util.cast($.ig.SeriesViewer.prototype.$type, sender)).raisePropertyChanged($.ig.SeriesViewer.prototype.isDragCrosshairEnabledPropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.plotAreaBorderBrushPropertyName = "PlotAreaBorderBrush";
$.ig.SeriesViewer.prototype.plotAreaBorderBrushProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.plotAreaBorderBrushPropertyName, $.ig.Brush.prototype.$type, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.SeriesViewer.prototype.$type, sender)).raisePropertyChanged($.ig.SeriesViewer.prototype.plotAreaBorderBrushPropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.actualPlotAreaBorderBrushPropertyName = "ActualPlotAreaBorderBrush";
$.ig.SeriesViewer.prototype.actualPlotAreaBorderBrushProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.actualPlotAreaBorderBrushPropertyName, $.ig.Brush.prototype.$type, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.SeriesViewer.prototype.$type, sender)).raisePropertyChanged($.ig.SeriesViewer.prototype.actualPlotAreaBorderBrushPropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.plotAreaBorderThicknessPropertyName = "PlotAreaBorderThickness";
$.ig.SeriesViewer.prototype.plotAreaBackgroundPropertyName = "PlotAreaBackground";
$.ig.SeriesViewer.prototype.plotAreaBackgroundProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.plotAreaBackgroundPropertyName, $.ig.Brush.prototype.$type, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.SeriesViewer.prototype.$type, sender)).raisePropertyChanged($.ig.SeriesViewer.prototype.plotAreaBackgroundPropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.plotAreaMinWidthPropertyName = "PlotAreaMinWidth";
$.ig.SeriesViewer.prototype.plotAreaMinWidthProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.plotAreaMinWidthPropertyName, Number, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, 50, function (sender, e) {
	($.ig.util.cast($.ig.SeriesViewer.prototype.$type, sender)).raisePropertyChanged($.ig.SeriesViewer.prototype.plotAreaMinWidthPropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.plotAreaMinHeightPropertyName = "PlotAreaMinHeight";
$.ig.SeriesViewer.prototype.plotAreaMinHeightProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.plotAreaMinHeightPropertyName, Number, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, 50, function (sender, e) {
	($.ig.util.cast($.ig.SeriesViewer.prototype.$type, sender)).raisePropertyChanged($.ig.SeriesViewer.prototype.plotAreaMinHeightPropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.defaultInteractionPropertyName = "DefaultInteraction";
$.ig.SeriesViewer.prototype.defaultInteractionProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.defaultInteractionPropertyName, $.ig.InteractionState.prototype.$type, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.InteractionState.prototype.getBox($.ig.InteractionState.prototype.auto), function (sender, e) {
	($.ig.util.cast($.ig.SeriesViewer.prototype.$type, sender)).raisePropertyChanged($.ig.SeriesViewer.prototype.defaultInteractionPropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.dragModifierPropertyName = "DragModifier";
$.ig.SeriesViewer.prototype.dragModifierProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.dragModifierPropertyName, $.ig.ModifierKeys.prototype.$type, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.ModifierKeys.prototype.getBox($.ig.ModifierKeys.prototype.none), function (sender, e) {
	($.ig.util.cast($.ig.SeriesViewer.prototype.$type, sender)).raisePropertyChanged($.ig.SeriesViewer.prototype.dragModifierPropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.panModifierPropertyName = "PanModifier";
$.ig.SeriesViewer.prototype.panModifierProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.panModifierPropertyName, $.ig.ModifierKeys.prototype.$type, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.ModifierKeys.prototype.getBox($.ig.ModifierKeys.prototype.shift), function (sender, e) {
	($.ig.util.cast($.ig.SeriesViewer.prototype.$type, sender)).raisePropertyChanged($.ig.SeriesViewer.prototype.panModifierPropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.windowPositionHorizontalPropertyName = "WindowPositionHorizontal";
$.ig.SeriesViewer.prototype.windowPositionHorizontalProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.windowPositionHorizontalPropertyName, Number, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, NaN, function (sender, e) {
	($.ig.util.cast($.ig.SeriesViewer.prototype.$type, sender)).raisePropertyChanged($.ig.SeriesViewer.prototype.windowPositionHorizontalPropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.windowPositionVerticalPropertyName = "WindowPositionVertical";
$.ig.SeriesViewer.prototype.windowPositionVerticalProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.windowPositionVerticalPropertyName, Number, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, NaN, function (sender, e) {
	($.ig.util.cast($.ig.SeriesViewer.prototype.$type, sender)).raisePropertyChanged($.ig.SeriesViewer.prototype.windowPositionVerticalPropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype._contentPresenterName = "ContentPresenter";
$.ig.SeriesViewer.prototype.crosshairLineStylePropertyName = "CrosshairLineStyle";
$.ig.SeriesViewer.prototype.crosshairLineStyleProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.crosshairLineStylePropertyName, $.ig.Style.prototype.$type, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.SeriesViewer.prototype.$type, sender)).raisePropertyChanged($.ig.SeriesViewer.prototype.crosshairLineStylePropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.idleVisualStateName = "Idle";
$.ig.SeriesViewer.prototype.draggingVisualStateName = "Dragging";
$.ig.SeriesViewer.prototype.panningVisualStateName = "Panning";
$.ig.SeriesViewer.prototype.inkingVisualStateName = "Inking";
$.ig.SeriesViewer.prototype.erasingVisualStateName = "Erasing";
$.ig.SeriesViewer.prototype.previewPathStylePropertyName = "PreviewPathStyle";
$.ig.SeriesViewer.prototype.previewPathStyleProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.previewPathStylePropertyName, $.ig.Style.prototype.$type, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.SeriesViewer.prototype.$type, sender)).raisePropertyChanged($.ig.SeriesViewer.prototype.previewPathStylePropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.standardRect = $.ig.Rect.prototype.empty();
$.ig.SeriesViewer.prototype.zoombarStylePropertyName = "ZoombarStyle";
$.ig.SeriesViewer.prototype.zoombarStyleProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.zoombarStylePropertyName, $.ig.Style.prototype.$type, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.SeriesViewer.prototype.$type, sender)).raisePropertyChanged($.ig.SeriesViewer.prototype.zoombarStylePropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.circleMarkerTemplatePropertyName = "CircleMarkerTemplate";
$.ig.SeriesViewer.prototype.circleMarkerTemplateProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.circleMarkerTemplatePropertyName, $.ig.DataTemplate.prototype.$type, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.SeriesViewer.prototype.$type, sender)).raisePropertyChanged($.ig.SeriesViewer.prototype.circleMarkerTemplatePropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.triangleMarkerTemplatePropertyName = "TriangleMarkerTemplate";
$.ig.SeriesViewer.prototype.triangleMarkerTemplateProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.triangleMarkerTemplatePropertyName, $.ig.DataTemplate.prototype.$type, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.SeriesViewer.prototype.$type, sender)).raisePropertyChanged($.ig.SeriesViewer.prototype.triangleMarkerTemplatePropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.pyramidMarkerTemplatePropertyName = "PyramidMarkerTemplate";
$.ig.SeriesViewer.prototype.pyramidMarkerTemplateProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.pyramidMarkerTemplatePropertyName, $.ig.DataTemplate.prototype.$type, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.SeriesViewer.prototype.$type, sender)).raisePropertyChanged($.ig.SeriesViewer.prototype.pyramidMarkerTemplatePropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.squareMarkerTemplatePropertyName = "SquareMarkerTemplate";
$.ig.SeriesViewer.prototype.squareMarkerTemplateProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.squareMarkerTemplatePropertyName, $.ig.DataTemplate.prototype.$type, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.SeriesViewer.prototype.$type, sender)).raisePropertyChanged($.ig.SeriesViewer.prototype.squareMarkerTemplatePropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.diamondMarkerTemplatePropertyName = "DiamondMarkerTemplate";
$.ig.SeriesViewer.prototype.diamondMarkerTemplateProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.diamondMarkerTemplatePropertyName, $.ig.DataTemplate.prototype.$type, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.SeriesViewer.prototype.$type, sender)).raisePropertyChanged($.ig.SeriesViewer.prototype.diamondMarkerTemplatePropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.pentagonMarkerTemplatePropertyName = "PentagonMarkerTemplate";
$.ig.SeriesViewer.prototype.pentagonMarkerTemplateProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.pentagonMarkerTemplatePropertyName, $.ig.DataTemplate.prototype.$type, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.SeriesViewer.prototype.$type, sender)).raisePropertyChanged($.ig.SeriesViewer.prototype.pentagonMarkerTemplatePropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.hexagonMarkerTemplatePropertyName = "HexagonMarkerTemplate";
$.ig.SeriesViewer.prototype.hexagonMarkerTemplateProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.hexagonMarkerTemplatePropertyName, $.ig.DataTemplate.prototype.$type, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.SeriesViewer.prototype.$type, sender)).raisePropertyChanged($.ig.SeriesViewer.prototype.hexagonMarkerTemplatePropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.tetragramMarkerTemplatePropertyName = "TetragramMarkerTemplate";
$.ig.SeriesViewer.prototype.tetragramMarkerTemplateProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.tetragramMarkerTemplatePropertyName, $.ig.DataTemplate.prototype.$type, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.SeriesViewer.prototype.$type, sender)).raisePropertyChanged($.ig.SeriesViewer.prototype.tetragramMarkerTemplatePropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.pentagramMarkerTemplatePropertyName = "PentagramMarkerTemplate";
$.ig.SeriesViewer.prototype.pentagramMarkerTemplateProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.pentagramMarkerTemplatePropertyName, $.ig.DataTemplate.prototype.$type, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.SeriesViewer.prototype.$type, sender)).raisePropertyChanged($.ig.SeriesViewer.prototype.pentagramMarkerTemplatePropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.hexagramMarkerTemplatePropertyName = "HexagramMarkerTemplate";
$.ig.SeriesViewer.prototype.hexagramMarkerTemplateProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.hexagramMarkerTemplatePropertyName, $.ig.DataTemplate.prototype.$type, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.SeriesViewer.prototype.$type, sender)).raisePropertyChanged($.ig.SeriesViewer.prototype.hexagramMarkerTemplatePropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.titlePropertyName = "Title";
$.ig.SeriesViewer.prototype.titleProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.titlePropertyName, String, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.SeriesViewer.prototype.$type, sender)).raisePropertyChanged($.ig.SeriesViewer.prototype.titlePropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.titleHorizontalAlignmentPropertyName = "TitleHorizontalAlignment";
$.ig.SeriesViewer.prototype.titleHorizontalAlignmentProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.titleHorizontalAlignmentPropertyName, $.ig.HorizontalAlignment.prototype.$type, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.HorizontalAlignment.prototype.getBox($.ig.HorizontalAlignment.prototype.center), function (sender, e) {
	($.ig.util.cast($.ig.SeriesViewer.prototype.$type, sender)).raisePropertyChanged($.ig.SeriesViewer.prototype.titleHorizontalAlignmentPropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.subtitleHorizontalAlignmentPropertyName = "SubtitleHorizontalAlignment";
$.ig.SeriesViewer.prototype.subtitleHorizontalAlignmentProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.subtitleHorizontalAlignmentPropertyName, $.ig.HorizontalAlignment.prototype.$type, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.HorizontalAlignment.prototype.getBox($.ig.HorizontalAlignment.prototype.center), function (sender, e) {
	($.ig.util.cast($.ig.SeriesViewer.prototype.$type, sender)).raisePropertyChanged($.ig.SeriesViewer.prototype.subtitleHorizontalAlignmentPropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.titleTextStylePropertyName = "TitleTextStyle";
$.ig.SeriesViewer.prototype.subtitleTextStylePropertyName = "SubtitleTextStyle";
$.ig.SeriesViewer.prototype.titleTextColorPropertyName = "TitleTextColor";
$.ig.SeriesViewer.prototype.subtitleTextColorPropertyName = "SubtitleTextColor";
$.ig.SeriesViewer.prototype.titleTopMarginPropertyName = "TitleTopMargin";
$.ig.SeriesViewer.prototype.titleLeftMarginPropertyName = "TitleLeftMargin";
$.ig.SeriesViewer.prototype.titleRightMarginPropertyName = "TitleRightMargin";
$.ig.SeriesViewer.prototype.titleBottomMarginPropertyName = "TitleBottomMargin";
$.ig.SeriesViewer.prototype.subtitleTopMarginPropertyName = "SubtitleTopMargin";
$.ig.SeriesViewer.prototype.subtitleLeftMarginPropertyName = "SubtitleLeftMargin";
$.ig.SeriesViewer.prototype.subtitleRightMarginPropertyName = "SubtitleRightMargin";
$.ig.SeriesViewer.prototype.subtitleBottomMarginPropertyName = "SubtitleBottomMargin";
$.ig.SeriesViewer.prototype.subtitlePropertyName = "Subtitle";
$.ig.SeriesViewer.prototype.subtitleProperty = $.ig.DependencyProperty.prototype.register($.ig.SeriesViewer.prototype.subtitlePropertyName, String, $.ig.SeriesViewer.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.SeriesViewer.prototype.$type, sender)).raisePropertyChanged($.ig.SeriesViewer.prototype.subtitlePropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewer.prototype.pixelScalingRatioPropertyName = "PixelScalingRatio";
$.ig.SeriesViewer.prototype.actualPixelScalingRatioPropertyName = "ActualPixelScalingRatio";
$.ig.SeriesViewer.prototype.actualWindowRectPropertyName = "ActualWindowRect";
$.ig.SeriesViewer.prototype.actualWindowPositionHorizontalPropertyName = "ActualWindowPositionHorizontal";
$.ig.SeriesViewer.prototype.actualWindowPositionVerticalPropertyName = "ActualWindowPositionVertical";
if ($.ig.SeriesViewer.prototype.staticInit && !$.ig.SeriesViewer.prototype.seriesViewerStaticInitCalled) { $.ig.SeriesViewer.prototype.staticInit(); $.ig.SeriesViewer.prototype.seriesViewerStaticInitCalled = true; }


$.ig.Series.prototype.mouseOverVisualStateName = "MouseOver";
$.ig.Series.prototype.normalVisualStateName = "Normal";
$.ig.Series.prototype.__currentUniqueIndex = 0;
$.ig.Series.prototype.visibilityProxyPropertyName = "VisibilityProxy";
$.ig.Series.prototype._visibilityProxyProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.visibilityProxyPropertyName, $.ig.Visibility.prototype.$type, $.ig.Series.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.Visibility.prototype.getBox($.ig.Visibility.prototype.visible), function (sender, e) {
	(sender).raisePropertyChanged($.ig.Series.prototype.visibilityProxyPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Series.prototype._rootCanvasName = "RootCanvas";
$.ig.Series.prototype._cLOSENESS_FACTOR = 1E-07;
$.ig.Series.prototype.syncLinkPropertyName = "SyncLink";
$.ig.Series.prototype.seriesViewerPropertyName = "SeriesViewer";
$.ig.Series.prototype.itemsSourcePropertyName = "ItemsSource";
$.ig.Series.prototype.itemsSourceProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.itemsSourcePropertyName, $.ig.IEnumerable.prototype.$type, $.ig.Series.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
		var series = $.ig.util.cast($.ig.Series.prototype.$type, sender);
		if (series.syncLink() != null) {
			($.ig.util.cast($.ig.IFastItemsSourceProvider.prototype.$type, series.syncLink())).releaseFastItemsSource(e.oldValue());
		}

		($.ig.util.cast($.ig.Series.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.itemsSourcePropertyName, e.oldValue(), e.newValue());
}));
$.ig.Series.prototype.fastItemsSourcePropertyName = "FastItemsSource";
$.ig.Series.prototype.fastItemsSourceProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.fastItemsSourcePropertyName, $.ig.IFastItemsSource.prototype.$type, $.ig.Series.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.Series.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.fastItemsSourcePropertyName, e.oldValue(), e.newValue());
}));
$.ig.Series.prototype.legendProperty = $.ig.DependencyProperty.prototype.register("Legend", $.ig.LegendBase.prototype.$type, $.ig.Series.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	var series = $.ig.util.cast($.ig.Series.prototype.$type, sender);
	series.raisePropertyChanged($.ig.XamDataChart.prototype.legendPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Series.prototype.legendItemPropertyName = "LegendItem";
$.ig.Series.prototype.actualLegendPropertyName = "ActualLegend";
$.ig.Series.prototype.legendItemVisibilityPropertyName = "LegendItemVisibility";
$.ig.Series.prototype.legendItemVisibilityProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.legendItemVisibilityPropertyName, $.ig.Visibility.prototype.$type, $.ig.Series.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.Visibility.prototype.getBox($.ig.Visibility.prototype.visible), function (sender, e) {
	($.ig.util.cast($.ig.Series.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.legendItemVisibilityPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Series.prototype.legendItemBadgeTemplatePropertyName = "LegendItemBadgeTemplate";
$.ig.Series.prototype.legendItemBadgeTemplateProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.legendItemBadgeTemplatePropertyName, $.ig.DataTemplate.prototype.$type, $.ig.Series.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	var series = $.ig.util.cast($.ig.Series.prototype.$type, sender);
	series.raisePropertyChanged($.ig.Series.prototype.legendItemBadgeTemplatePropertyName, e.oldValue(), e.newValue());
	series.legendItem(series.getLegendItem());
}));
$.ig.Series.prototype.legendItemTemplatePropertyName = "LegendItemTemplate";
$.ig.Series.prototype.legendItemTemplateProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.legendItemTemplatePropertyName, $.ig.DataTemplate.prototype.$type, $.ig.Series.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	var series = $.ig.util.cast($.ig.Series.prototype.$type, sender);
	series.raisePropertyChanged($.ig.Series.prototype.legendItemTemplatePropertyName, e.oldValue(), e.newValue());
	series.legendItem(series.getLegendItem());
}));
$.ig.Series.prototype.discreteLegendItemTemplatePropertyName = "DiscreteLegendItemTemplate";
$.ig.Series.prototype.discreteLegendItemTemplateProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.discreteLegendItemTemplatePropertyName, $.ig.DataTemplate.prototype.$type, $.ig.Series.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	var series = $.ig.util.cast($.ig.Series.prototype.$type, sender);
	series.raisePropertyChanged($.ig.Series.prototype.discreteLegendItemTemplatePropertyName, e.oldValue(), e.newValue());
}));
$.ig.Series.prototype.indexPropertyName = "Index";
$.ig.Series.prototype.indexProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.indexPropertyName, $.ig.Number.prototype.$type, $.ig.Series.prototype.$type, new $.ig.PropertyMetadata(2, -1, function (sender, e) {
	var series = $.ig.util.cast($.ig.Series.prototype.$type, sender);
	series.raisePropertyChanged($.ig.Series.prototype.indexPropertyName, e.oldValue(), e.newValue());
	series.legendItem(series.getLegendItem());
}));
$.ig.Series.prototype.transitionEasingFunctionPropertyName = "TransitionEasingFunction";
$.ig.Series.prototype.transitionInEasingFunctionPropertyName = "TransitionInEasingFunction";
$.ig.Series.prototype.transitionEasingFunctionProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.transitionEasingFunctionPropertyName, $.ig.EasingFunctionHandler.prototype.$type, $.ig.Series.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.Series.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.transitionEasingFunctionPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Series.prototype.transitionInEasingFunctionProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.transitionInEasingFunctionPropertyName, $.ig.EasingFunctionHandler.prototype.$type, $.ig.Series.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.Series.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.transitionInEasingFunctionPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Series.prototype.transitionDurationPropertyName = "TransitionDuration";
$.ig.Series.prototype.transitionDurationProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.transitionDurationPropertyName, $.ig.Number.prototype.$type, $.ig.Series.prototype.$type, new $.ig.PropertyMetadata(2, 0, function (sender, e) {
	($.ig.util.cast($.ig.Series.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.transitionDurationPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Series.prototype.transitionProgressPropertyName = "TransitionProgress";
$.ig.Series.prototype.transitionProgressProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.transitionProgressPropertyName, Number, $.ig.Series.prototype.$type, new $.ig.PropertyMetadata(2, 0, function (sender, e) {
	($.ig.util.cast($.ig.Series.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.transitionProgressPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Series.prototype._animationTickMilliseconds = 10;
$.ig.Series.prototype._useDispatcherTimer = false;
$.ig.Series.prototype.resolutionPropertyName = "Resolution";
$.ig.Series.prototype.resolutionProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.resolutionPropertyName, Number, $.ig.Series.prototype.$type, new $.ig.PropertyMetadata(2, 1, function (sender, e) {
	($.ig.util.cast($.ig.Series.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.resolutionPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Series.prototype.titlePropertyName = "Title";
$.ig.Series.prototype.titleProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.titlePropertyName, $.ig.Object.prototype.$type, $.ig.Series.prototype.$type, new $.ig.PropertyMetadata(2, "Series Title", function (sender, e) {
	($.ig.util.cast($.ig.Series.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.titlePropertyName, e.oldValue(), e.newValue());
}));
$.ig.Series.prototype.brushPropertyName = "Brush";
$.ig.Series.prototype.brushProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.brushPropertyName, $.ig.Brush.prototype.$type, $.ig.Series.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.Series.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.brushPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Series.prototype.actualBrushPropertyName = "ActualBrush";
$.ig.Series.prototype.actualBrushProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.actualBrushPropertyName, $.ig.Brush.prototype.$type, $.ig.Series.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.Series.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.actualBrushPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Series.prototype.outlinePropertyName = "Outline";
$.ig.Series.prototype.outlineProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.outlinePropertyName, $.ig.Brush.prototype.$type, $.ig.Series.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.Series.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.outlinePropertyName, e.oldValue(), e.newValue());
}));
$.ig.Series.prototype.actualOutlinePropertyName = "ActualOutline";
$.ig.Series.prototype.actualOutlineProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.actualOutlinePropertyName, $.ig.Brush.prototype.$type, $.ig.Series.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.Series.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.actualOutlinePropertyName, e.oldValue(), e.newValue());
}));
$.ig.Series.prototype.lineJoinPropertyName = "LineJoin";
$.ig.Series.prototype.miterLimitPropertyName = "MiterLimit";
$.ig.Series.prototype.miterLimitProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.miterLimitPropertyName, Number, $.ig.Series.prototype.$type, new $.ig.PropertyMetadata(2, 0, function (sender, e) {
	($.ig.util.cast($.ig.Series.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.miterLimitPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Series.prototype.thicknessPropertyName = "Thickness";
$.ig.Series.prototype.thicknessProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.thicknessPropertyName, Number, $.ig.Series.prototype.$type, new $.ig.PropertyMetadata(2, 1.5, function (sender, e) {
	($.ig.util.cast($.ig.Series.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.thicknessPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Series.prototype.dashCapPropertyName = "DashCap";
$.ig.Series.prototype.dashCapProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.dashCapPropertyName, $.ig.PenLineCap.prototype.$type, $.ig.Series.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.PenLineCap.prototype.getBox($.ig.PenLineCap.prototype.flat), function (sender, e) {
	($.ig.util.cast($.ig.Series.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.dashCapPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Series.prototype.dashArrayPropertyName = "DashArray";
$.ig.Series.prototype.dashArrayProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.dashArrayPropertyName, $.ig.DoubleCollection.prototype.$type, $.ig.Series.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.Series.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.dashArrayPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Series.prototype.toolTipPropertyName = "ToolTip";
$.ig.Series.prototype.toolTipProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.toolTipPropertyName, $.ig.Object.prototype.$type, $.ig.Series.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.Series.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.toolTipPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Series.prototype.isHighlightingEnabledPropertyName = "IsHighlightingEnabled";
$.ig.Series.prototype.isHighlightingEnabledProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.isHighlightingEnabledPropertyName, $.ig.Boolean.prototype.$type, $.ig.Series.prototype.$type, new $.ig.PropertyMetadata(2, false, function (sender, e) {
	($.ig.util.cast($.ig.Series.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.isHighlightingEnabledPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Series.prototype.isDropShadowEnabledPropertyName = "IsDropShadowEnabled";
$.ig.Series.prototype.isDropShadowEnabledProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.isDropShadowEnabledPropertyName, $.ig.Boolean.prototype.$type, $.ig.Series.prototype.$type, new $.ig.PropertyMetadata(2, false, function (sender, e) {
	($.ig.util.cast($.ig.Series.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.isDropShadowEnabledPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Series.prototype.shadowBlurPropertyName = "ShadowBlur";
$.ig.Series.prototype.shadowBlurProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.shadowBlurPropertyName, Number, $.ig.Series.prototype.$type, new $.ig.PropertyMetadata(2, NaN, function (sender, e) {
	($.ig.util.cast($.ig.Series.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.shadowBlurPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Series.prototype.shadowColorPropertyName = "ShadowColor";
$.ig.Series.prototype.shadowColorProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.shadowColorPropertyName, $.ig.Color.prototype.$type, $.ig.Series.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.Series.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.shadowColorPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Series.prototype.useSingleShadowPropertyName = "UseSingleShadow";
$.ig.Series.prototype.useSingleShadowProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.useSingleShadowPropertyName, $.ig.Boolean.prototype.$type, $.ig.Series.prototype.$type, new $.ig.PropertyMetadata(2, true, function (sender, e) {
	($.ig.util.cast($.ig.Series.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.useSingleShadowPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Series.prototype.shadowOffsetXPropertyName = "ShadowOffsetX";
$.ig.Series.prototype.shadowOffsetXProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.shadowOffsetXPropertyName, Number, $.ig.Series.prototype.$type, new $.ig.PropertyMetadata(2, NaN, function (sender, e) {
	($.ig.util.cast($.ig.Series.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.shadowOffsetXPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Series.prototype.shadowOffsetYPropertyName = "ShadowOffsetY";
$.ig.Series.prototype.shadowOffsetYProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.shadowOffsetYPropertyName, Number, $.ig.Series.prototype.$type, new $.ig.PropertyMetadata(2, NaN, function (sender, e) {
	($.ig.util.cast($.ig.Series.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.shadowOffsetYPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Series.prototype._areaFillOpacityPropertyName = "AreaFillOpacity";
$.ig.Series.prototype.areaFillOpacityProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype._areaFillOpacityPropertyName, Number, $.ig.Series.prototype.$type, new $.ig.PropertyMetadata(2, NaN, function (sender, e) {
	($.ig.util.cast($.ig.Series.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype._areaFillOpacityPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Series.prototype._actualAreaFillOpacityPropertyName = "ActualAreaFillOpacity";
$.ig.Series.prototype.actualAreaFillOpacityProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype._actualAreaFillOpacityPropertyName, Number, $.ig.Series.prototype.$type, new $.ig.PropertyMetadata(2, 1, function (sender, e) {
	($.ig.util.cast($.ig.Series.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype._actualAreaFillOpacityPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Series.prototype.transitionInDurationPropertyName = "TransitionInDuration";
$.ig.Series.prototype.transitionInDurationProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.transitionInDurationPropertyName, $.ig.Number.prototype.$type, $.ig.Series.prototype.$type, new $.ig.PropertyMetadata(2, 1000, function (sender, e) {
	($.ig.util.cast($.ig.Series.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.transitionInDurationPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Series.prototype.transitionInSpeedTypePropertyName = "TransitionInSpeedType";
$.ig.Series.prototype.transitionInSpeedTypeProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.transitionInSpeedTypePropertyName, $.ig.TransitionInSpeedType.prototype.$type, $.ig.Series.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.TransitionInSpeedType.prototype.getBox($.ig.TransitionInSpeedType.prototype.auto), function (sender, e) {
	($.ig.util.cast($.ig.Series.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.transitionInSpeedTypePropertyName, e.oldValue(), e.newValue());
}));
$.ig.Series.prototype.startCapPropertyName = "StartCap";
$.ig.Series.prototype.startCapProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.startCapPropertyName, $.ig.PenLineCap.prototype.$type, $.ig.Series.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.PenLineCap.prototype.getBox($.ig.PenLineCap.prototype.round), function (sender, e) {
	($.ig.util.cast($.ig.Series.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.startCapPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Series.prototype.endCapPropertyName = "EndCap";
$.ig.Series.prototype.endCapProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.endCapPropertyName, $.ig.PenLineCap.prototype.$type, $.ig.Series.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.PenLineCap.prototype.getBox($.ig.PenLineCap.prototype.round), function (sender, e) {
	($.ig.util.cast($.ig.Series.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.endCapPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Series.prototype.trendLineDashArrayPropertyName = "TrendLineDashArray";
$.ig.Series.prototype.trendLineTypePropertyName = "TrendLineType";
$.ig.Series.prototype.trendLinePeriodPropertyName = "TrendLinePeriod";
$.ig.Series.prototype.trendLineBrushPropertyName = "TrendLineBrush";
$.ig.Series.prototype.trendLineActualBrushPropertyName = "ActualTrendLineBrush";
$.ig.Series.prototype.trendLineThicknessPropertyName = "TrendLineThickness";
$.ig.Series.prototype.trendLineDashCapPropertyName = "TrendLineDashCap";
$.ig.Series.prototype.trendLineZIndexPropertyName = "TrendLineZIndex";



$.ig.SeriesView.prototype.iTEM_ALLOCATION = 1000;
$.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT = 3;








$.ig.AxisLabelPanelBase.prototype.extentPropertyName = "Extent";
$.ig.AxisLabelPanelBase.prototype.extentProperty = $.ig.DependencyProperty.prototype.register($.ig.AxisLabelPanelBase.prototype.extentPropertyName, Number, $.ig.AxisLabelPanelBase.prototype.$type, new $.ig.PropertyMetadata(2, 50, function (sender, e) {
	(sender)._actualExtent = e.newValue();
}));


$.ig.Axis.prototype.formatLabelPropertyName = "FormatLabel";
$.ig.Axis.prototype.formatLabelProperty = $.ig.DependencyProperty.prototype.register($.ig.Axis.prototype.formatLabelPropertyName, $.ig.AxisFormatLabelHandler.prototype.$type, $.ig.Axis.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.Axis.prototype.$type, sender)).raisePropertyChanged($.ig.Axis.prototype.formatLabelPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Axis.prototype._rootCanvasName = "RootCanvas";
$.ig.Axis.prototype.fastItemsSourceProviderPropertyName = "FastItemsSourceProvider";
$.ig.Axis.prototype.seriesViewerPropertyName = "SeriesViewer";
$.ig.Axis.prototype.titlePropertyName = "Title";
$.ig.Axis.prototype.titleProperty = $.ig.DependencyProperty.prototype.register($.ig.Axis.prototype.titlePropertyName, String, $.ig.Axis.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.Axis.prototype.$type, sender)).raisePropertyChanged($.ig.Axis.prototype.titlePropertyName, e.oldValue(), e.newValue());
}));
$.ig.Axis.prototype.strokePropertyName = "Stroke";
$.ig.Axis.prototype.strokeProperty = $.ig.DependencyProperty.prototype.register($.ig.Axis.prototype.strokePropertyName, $.ig.Brush.prototype.$type, $.ig.Axis.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.Axis.prototype.$type, sender)).raisePropertyChanged($.ig.Axis.prototype.strokePropertyName, e.oldValue(), e.newValue());
}));
$.ig.Axis.prototype.actualStrokePropertyName = "ActualStroke";
$.ig.Axis.prototype.actualStrokeProperty = $.ig.DependencyProperty.prototype.register($.ig.Axis.prototype.actualStrokePropertyName, $.ig.Brush.prototype.$type, $.ig.Axis.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.Axis.prototype.$type, sender)).raisePropertyChanged($.ig.Axis.prototype.actualStrokePropertyName, e.oldValue(), e.newValue());
}));
$.ig.Axis.prototype.strokeThicknessPropertyName = "StrokeThickness";
$.ig.Axis.prototype.strokeThicknessProperty = $.ig.DependencyProperty.prototype.register($.ig.Axis.prototype.strokeThicknessPropertyName, Number, $.ig.Axis.prototype.$type, new $.ig.PropertyMetadata(2, 1, function (sender, e) {
	($.ig.util.cast($.ig.Axis.prototype.$type, sender)).raisePropertyChanged($.ig.Axis.prototype.strokeThicknessPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Axis.prototype.strokeDashArrayPropertyName = "StrokeDashArray";
$.ig.Axis.prototype.strokeDashArrayProperty = $.ig.DependencyProperty.prototype.register($.ig.Axis.prototype.strokeDashArrayPropertyName, $.ig.DoubleCollection.prototype.$type, $.ig.Axis.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.Axis.prototype.$type, sender)).raisePropertyChanged($.ig.Axis.prototype.strokeDashArrayPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Axis.prototype.stripPropertyName = "Strip";
$.ig.Axis.prototype.stripProperty = $.ig.DependencyProperty.prototype.register($.ig.Axis.prototype.stripPropertyName, $.ig.Brush.prototype.$type, $.ig.Axis.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.Axis.prototype.$type, sender)).raisePropertyChanged($.ig.Axis.prototype.stripPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Axis.prototype.majorStrokePropertyName = "MajorStroke";
$.ig.Axis.prototype.majorStrokeProperty = $.ig.DependencyProperty.prototype.register($.ig.Axis.prototype.majorStrokePropertyName, $.ig.Brush.prototype.$type, $.ig.Axis.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.Axis.prototype.$type, sender)).raisePropertyChanged($.ig.Axis.prototype.majorStrokePropertyName, e.oldValue(), e.newValue());
}));
$.ig.Axis.prototype.actualMajorStrokePropertyName = "ActualMajorStroke";
$.ig.Axis.prototype.actualMajorStrokeProperty = $.ig.DependencyProperty.prototype.register($.ig.Axis.prototype.actualMajorStrokePropertyName, $.ig.Brush.prototype.$type, $.ig.Axis.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.Axis.prototype.$type, sender)).raisePropertyChanged($.ig.Axis.prototype.actualMajorStrokePropertyName, e.oldValue(), e.newValue());
}));
$.ig.Axis.prototype.majorStrokeThicknessPropertyName = "MajorStrokeThickness";
$.ig.Axis.prototype.majorStrokeThicknessProperty = $.ig.DependencyProperty.prototype.register($.ig.Axis.prototype.majorStrokeThicknessPropertyName, Number, $.ig.Axis.prototype.$type, new $.ig.PropertyMetadata(2, 1, function (sender, e) {
	($.ig.util.cast($.ig.Axis.prototype.$type, sender)).raisePropertyChanged($.ig.Axis.prototype.majorStrokeThicknessPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Axis.prototype.majorStrokeDashArrayPropertyName = "MajorStrokeDashArray";
$.ig.Axis.prototype.majorStrokeDashArrayProperty = $.ig.DependencyProperty.prototype.register($.ig.Axis.prototype.majorStrokeDashArrayPropertyName, $.ig.DoubleCollection.prototype.$type, $.ig.Axis.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.Axis.prototype.$type, sender)).raisePropertyChanged($.ig.Axis.prototype.majorStrokeDashArrayPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Axis.prototype.minorStrokePropertyName = "MinorStroke";
$.ig.Axis.prototype.minorStrokeProperty = $.ig.DependencyProperty.prototype.register($.ig.Axis.prototype.minorStrokePropertyName, $.ig.Brush.prototype.$type, $.ig.Axis.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.Axis.prototype.$type, sender)).raisePropertyChanged($.ig.Axis.prototype.minorStrokePropertyName, e.oldValue(), e.newValue());
}));
$.ig.Axis.prototype.actualMinorStrokePropertyName = "ActualMinorStroke";
$.ig.Axis.prototype.actualMinorStrokeProperty = $.ig.DependencyProperty.prototype.register($.ig.Axis.prototype.actualMinorStrokePropertyName, $.ig.Brush.prototype.$type, $.ig.Axis.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.Axis.prototype.$type, sender)).raisePropertyChanged($.ig.Axis.prototype.actualMinorStrokePropertyName, e.oldValue(), e.newValue());
}));
$.ig.Axis.prototype.minorStrokeThicknessPropertyName = "MinorStrokeThickness";
$.ig.Axis.prototype.minorStrokeThicknessProperty = $.ig.DependencyProperty.prototype.register($.ig.Axis.prototype.minorStrokeThicknessPropertyName, Number, $.ig.Axis.prototype.$type, new $.ig.PropertyMetadata(2, 1, function (sender, e) {
	($.ig.util.cast($.ig.Axis.prototype.$type, sender)).raisePropertyChanged($.ig.Axis.prototype.minorStrokeThicknessPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Axis.prototype.minorStrokeDashArrayPropertyName = "MinorStrokeDashArray";
$.ig.Axis.prototype.minorStrokeDashArrayProperty = $.ig.DependencyProperty.prototype.register($.ig.Axis.prototype.minorStrokeDashArrayPropertyName, $.ig.DoubleCollection.prototype.$type, $.ig.Axis.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.Axis.prototype.$type, sender)).raisePropertyChanged($.ig.Axis.prototype.minorStrokeDashArrayPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Axis.prototype.tickStrokePropertyName = "TickStroke";
$.ig.Axis.prototype.tickStrokeProperty = $.ig.DependencyProperty.prototype.register($.ig.Axis.prototype.tickStrokePropertyName, $.ig.Brush.prototype.$type, $.ig.Axis.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.Axis.prototype.$type, sender)).raisePropertyChanged($.ig.Axis.prototype.tickStrokePropertyName, e.oldValue(), e.newValue());
}));
$.ig.Axis.prototype.tickStrokeThicknessPropertyName = "TickStrokeThickness";
$.ig.Axis.prototype.tickStrokeThicknessProperty = $.ig.DependencyProperty.prototype.register($.ig.Axis.prototype.tickStrokeThicknessPropertyName, Number, $.ig.Axis.prototype.$type, new $.ig.PropertyMetadata(2, 1, function (sender, e) {
	($.ig.util.cast($.ig.Axis.prototype.$type, sender)).raisePropertyChanged($.ig.Axis.prototype.tickStrokeThicknessPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Axis.prototype.tickStrokeDashArrayPropertyName = "TickStrokeDashArray";
$.ig.Axis.prototype.tickStrokeDashArrayProperty = $.ig.DependencyProperty.prototype.register($.ig.Axis.prototype.tickStrokeDashArrayPropertyName, $.ig.DoubleCollection.prototype.$type, $.ig.Axis.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.Axis.prototype.$type, sender)).raisePropertyChanged($.ig.Axis.prototype.tickStrokeDashArrayPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Axis.prototype.tickLengthPropertyName = "TickLength";
$.ig.Axis.prototype.tickLengthProperty = $.ig.DependencyProperty.prototype.register($.ig.Axis.prototype.tickLengthPropertyName, Number, $.ig.Axis.prototype.$type, new $.ig.PropertyMetadata(2, NaN, function (sender, e) {
	($.ig.util.cast($.ig.Axis.prototype.$type, sender)).raisePropertyChanged($.ig.Axis.prototype.tickLengthPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Axis.prototype.isDisabledPropertyName = "IsDisabled";
$.ig.Axis.prototype.isDisabledProperty = $.ig.DependencyProperty.prototype.register($.ig.Axis.prototype.isDisabledPropertyName, $.ig.Boolean.prototype.$type, $.ig.Axis.prototype.$type, new $.ig.PropertyMetadata(2, false, function (sender, e) {
	($.ig.util.cast($.ig.Axis.prototype.$type, sender)).raisePropertyChanged($.ig.Axis.prototype.isDisabledPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Axis.prototype.isInvertedPropertyName = "IsInverted";
$.ig.Axis.prototype.isInvertedProperty = $.ig.DependencyProperty.prototype.register($.ig.Axis.prototype.isInvertedPropertyName, $.ig.Boolean.prototype.$type, $.ig.Axis.prototype.$type, new $.ig.PropertyMetadata(2, false, function (sender, e) {
	($.ig.util.cast($.ig.Axis.prototype.$type, sender)).raisePropertyChanged($.ig.Axis.prototype.isInvertedPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Axis.prototype.labelSettingsPropertyName = "LabelSettings";
$.ig.Axis.prototype.labelSettingsProperty = $.ig.DependencyProperty.prototype.register($.ig.Axis.prototype.labelSettingsPropertyName, $.ig.AxisLabelSettings.prototype.$type, $.ig.Axis.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.Axis.prototype.$type, sender)).raisePropertyChanged($.ig.Axis.prototype.labelSettingsPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Axis.prototype.labelPanelStylePropertyName = "LabelPanelStyle";
$.ig.Axis.prototype.labelPanelStyleProperty = $.ig.DependencyProperty.prototype.register($.ig.Axis.prototype.labelPanelStylePropertyName, $.ig.Style.prototype.$type, $.ig.Axis.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.Axis.prototype.$type, sender)).raisePropertyChanged($.ig.Axis.prototype.labelPanelStylePropertyName, e.oldValue(), e.newValue());
}));
$.ig.Axis.prototype.crossingAxisPropertyName = "CrossingAxis";
$.ig.Axis.prototype.crossingAxisProperty = $.ig.DependencyProperty.prototype.register($.ig.Axis.prototype.crossingAxisPropertyName, $.ig.Axis.prototype.$type, $.ig.Axis.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.Axis.prototype.$type, sender)).raisePropertyChanged($.ig.Axis.prototype.crossingAxisPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Axis.prototype.crossingValuePropertyName = "CrossingValue";
$.ig.Axis.prototype.crossingValueProperty = $.ig.DependencyProperty.prototype.register($.ig.Axis.prototype.crossingValuePropertyName, $.ig.Object.prototype.$type, $.ig.Axis.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.Axis.prototype.$type, sender)).raisePropertyChanged($.ig.Axis.prototype.crossingValuePropertyName, e.oldValue(), e.newValue());
}));
$.ig.Axis.prototype.titleSettingsPropertyName = "TitleSettings";
$.ig.Axis.prototype.titleSettingsProperty = $.ig.DependencyProperty.prototype.register($.ig.Axis.prototype.titleSettingsPropertyName, $.ig.TitleSettings.prototype.$type, $.ig.Axis.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.Axis.prototype.$type, sender)).raisePropertyChanged($.ig.Axis.prototype.titleSettingsPropertyName, e.oldValue(), e.newValue());
}));
$.ig.Axis.prototype.labelPropertyName = "Label";
$.ig.Axis.prototype.labelProperty = $.ig.DependencyProperty.prototype.register($.ig.Axis.prototype.labelPropertyName, $.ig.Object.prototype.$type, $.ig.Axis.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.Axis.prototype.$type, sender)).raisePropertyChanged($.ig.Axis.prototype.labelPropertyName, e.oldValue(), e.newValue());
}));


$.ig.AxisLabelSettings.prototype.textStylePropertyName = "TextStyle";
$.ig.AxisLabelSettings.prototype.textColorPropertyName = "TextColor";
$.ig.AxisLabelSettings.prototype.locationPropertyName = "Location";
$.ig.AxisLabelSettings.prototype.visibilityPropertyName = "Visibility";
$.ig.AxisLabelSettings.prototype.showFirstLabelPropertyName = "ShowFirstLabel";
$.ig.AxisLabelSettings.prototype.anglePropertyName = "Angle";
$.ig.AxisLabelSettings.prototype.extentPropertyName = "Extent";
$.ig.AxisLabelSettings.prototype.marginPropertyName = "Margin";
$.ig.AxisLabelSettings.prototype.leftMarginPropertyName = "LeftMargin";
$.ig.AxisLabelSettings.prototype.rightMarginPropertyName = "RightMargin";
$.ig.AxisLabelSettings.prototype.topMarginPropertyName = "TopMargin";
$.ig.AxisLabelSettings.prototype.bottomMarginPropertyName = "BottomMargin";
$.ig.AxisLabelSettings.prototype.horizontalAlignmentPropertyName = "HorizontalAlignment";
$.ig.AxisLabelSettings.prototype.verticalAlignmentPropertyName = "VerticalAlignment";
$.ig.AxisLabelSettings.prototype.extentPropertyDefault = 50;


$.ig.TitleSettings.prototype.axisTitlePositionPropertyName = "AxisTitlePosition";



































$.ig.PieChartBase.prototype._contentPresenterName = "ContentPresenter";
$.ig.PieChartBase.prototype.fastItemsSourcePropertyName = "FastItemsSource";
$.ig.PieChartBase.prototype.fastItemsSourceProperty = $.ig.DependencyProperty.prototype.register($.ig.PieChartBase.prototype.fastItemsSourcePropertyName, $.ig.FastItemsSource.prototype.$type, $.ig.PieChartBase.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.PieChartBase.prototype.$type, sender)).raisePropertyChanged($.ig.PieChartBase.prototype.fastItemsSourcePropertyName, e.oldValue(), e.newValue());
}));
$.ig.PieChartBase.prototype.valueColumnPropertyName = "ValueColumn";
$.ig.PieChartBase.prototype.leaderLinePathControlPointOffset = 30;
$.ig.PieChartBase.prototype.itemsSourcePropertyName = "ItemsSource";
$.ig.PieChartBase.prototype.itemsSourceProperty = $.ig.DependencyProperty.prototype.register($.ig.PieChartBase.prototype.itemsSourcePropertyName, $.ig.IEnumerable.prototype.$type, $.ig.PieChartBase.prototype.$type, new $.ig.PropertyMetadata(2, null, function (o, e) {
	($.ig.util.cast($.ig.PieChartBase.prototype.$type, o)).raisePropertyChanged($.ig.PieChartBase.prototype.itemsSourcePropertyName, e.oldValue(), e.newValue());
}));
$.ig.PieChartBase.prototype.innerExtentPropertyName = "InnerExtent";
$.ig.PieChartBase.prototype.innerExtentProperty = $.ig.DependencyProperty.prototype.register($.ig.PieChartBase.prototype.innerExtentPropertyName, Number, $.ig.PieChartBase.prototype.$type, new $.ig.PropertyMetadata(2, 0, function (o, e) {
	(o).raisePropertyChanged($.ig.PieChartBase.prototype.innerExtentPropertyName, e.oldValue(), e.newValue());
}));
$.ig.PieChartBase.prototype.valueMemberPathPropertyName = "ValueMemberPath";
$.ig.PieChartBase.prototype.valueMemberPathProperty = $.ig.DependencyProperty.prototype.register($.ig.PieChartBase.prototype.valueMemberPathPropertyName, String, $.ig.PieChartBase.prototype.$type, new $.ig.PropertyMetadata(2, null, function (o, e) {
	($.ig.util.cast($.ig.PieChartBase.prototype.$type, o)).raisePropertyChanged($.ig.PieChartBase.prototype.valueMemberPathPropertyName, e.oldValue(), e.newValue());
}));
$.ig.PieChartBase.prototype.labelMemberPathPropertyName = "LabelMemberPath";
$.ig.PieChartBase.prototype.labelMemberPathProperty = $.ig.DependencyProperty.prototype.register($.ig.PieChartBase.prototype.labelMemberPathPropertyName, String, $.ig.PieChartBase.prototype.$type, new $.ig.PropertyMetadata(1, function (o, e) {
	($.ig.util.cast($.ig.PieChartBase.prototype.$type, o)).raisePropertyChanged($.ig.PieChartBase.prototype.labelMemberPathPropertyName, e.oldValue(), e.newValue());
}));
$.ig.PieChartBase.prototype.labelColumnPropertyName = "LabelColumn";
$.ig.PieChartBase.prototype.labelsPositionPropertyName = "LabelsPosition";
$.ig.PieChartBase.prototype.labelsPositionProperty = $.ig.DependencyProperty.prototype.register($.ig.PieChartBase.prototype.labelsPositionPropertyName, $.ig.LabelsPosition.prototype.$type, $.ig.PieChartBase.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.LabelsPosition.prototype.getBox($.ig.LabelsPosition.prototype.center), function (o, e) {
	($.ig.util.cast($.ig.PieChartBase.prototype.$type, o)).raisePropertyChanged($.ig.PieChartBase.prototype.labelsPositionPropertyName, e.oldValue(), e.newValue());
}));
$.ig.PieChartBase.prototype.leaderLineVisibilityPropertyName = "LeaderLineVisibility";
$.ig.PieChartBase.prototype.leaderLineVisibilityProperty = $.ig.DependencyProperty.prototype.register($.ig.PieChartBase.prototype.leaderLineVisibilityPropertyName, $.ig.Visibility.prototype.$type, $.ig.PieChartBase.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.Visibility.prototype.getBox($.ig.Visibility.prototype.visible), function (o, e) {
	($.ig.util.cast($.ig.PieChartBase.prototype.$type, o)).raisePropertyChanged($.ig.PieChartBase.prototype.leaderLineVisibilityPropertyName, e.oldValue(), e.newValue());
}));
$.ig.PieChartBase.prototype.leaderLineStylePropertyName = "LeaderLineStyle";
$.ig.PieChartBase.prototype.leaderLineStyleProperty = $.ig.DependencyProperty.prototype.register($.ig.PieChartBase.prototype.leaderLineStylePropertyName, $.ig.Style.prototype.$type, $.ig.PieChartBase.prototype.$type, new $.ig.PropertyMetadata(2, null, function (o, e) {
	($.ig.util.cast($.ig.PieChartBase.prototype.$type, o)).raisePropertyChanged($.ig.PieChartBase.prototype.leaderLineStylePropertyName, e.oldValue(), e.newValue());
}));
$.ig.PieChartBase.prototype.leaderLineTypePropertyName = "LeaderLineType";
$.ig.PieChartBase.prototype.leaderLineTypeProperty = $.ig.DependencyProperty.prototype.register($.ig.PieChartBase.prototype.leaderLineTypePropertyName, $.ig.LeaderLineType.prototype.$type, $.ig.PieChartBase.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.LeaderLineType.prototype.getBox($.ig.LeaderLineType.prototype.straight), function (o, e) {
	($.ig.util.cast($.ig.PieChartBase.prototype.$type, o)).raisePropertyChanged($.ig.PieChartBase.prototype.leaderLineTypePropertyName, e.oldValue(), e.newValue());
}));
$.ig.PieChartBase.prototype.leaderLineMarginPropertyName = "LeaderLineMargin";
$.ig.PieChartBase.prototype.leaderLineMarginProperty = $.ig.DependencyProperty.prototype.register($.ig.PieChartBase.prototype.leaderLineMarginPropertyName, Number, $.ig.PieChartBase.prototype.$type, new $.ig.PropertyMetadata(2, 6, function (o, e) {
	($.ig.util.cast($.ig.PieChartBase.prototype.$type, o)).raisePropertyChanged($.ig.PieChartBase.prototype.leaderLineMarginPropertyName, e.oldValue(), e.newValue());
}));
$.ig.PieChartBase.prototype.toolTipPropertyName = "ToolTip";
$.ig.PieChartBase.prototype.toolTipProperty = $.ig.DependencyProperty.prototype.register($.ig.PieChartBase.prototype.toolTipPropertyName, $.ig.Object.prototype.$type, $.ig.PieChartBase.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.PieChartBase.prototype.$type, sender)).raisePropertyChanged($.ig.PieChartBase.prototype.toolTipPropertyName, e.oldValue(), e.newValue());
}));
$.ig.PieChartBase.prototype.othersCategoryThresholdPropertyName = "OthersCategoryThreshold";
$.ig.PieChartBase.prototype.othersCategoryThresholdProperty = $.ig.DependencyProperty.prototype.register($.ig.PieChartBase.prototype.othersCategoryThresholdPropertyName, Number, $.ig.PieChartBase.prototype.$type, new $.ig.PropertyMetadata(2, 3, function (o, e) {
	($.ig.util.cast($.ig.PieChartBase.prototype.$type, o)).raisePropertyChanged($.ig.PieChartBase.prototype.othersCategoryThresholdPropertyName, e.oldValue(), e.newValue());
}));
$.ig.PieChartBase.prototype.othersCategoryTypePropertyName = "OthersCategoryType";
$.ig.PieChartBase.prototype.othersCategoryTypeProperty = $.ig.DependencyProperty.prototype.register($.ig.PieChartBase.prototype.othersCategoryTypePropertyName, $.ig.OthersCategoryType.prototype.$type, $.ig.PieChartBase.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.OthersCategoryType.prototype.getBox($.ig.OthersCategoryType.prototype.percent), function (o, e) {
	($.ig.util.cast($.ig.PieChartBase.prototype.$type, o)).raisePropertyChanged($.ig.PieChartBase.prototype.othersCategoryTypePropertyName, e.oldValue(), e.newValue());
}));
$.ig.PieChartBase.prototype.othersCategoryTextPropertyName = "OthersCategoryText";
$.ig.PieChartBase.prototype.othersCategoryTextProperty = $.ig.DependencyProperty.prototype.register($.ig.PieChartBase.prototype.othersCategoryTextPropertyName, String, $.ig.PieChartBase.prototype.$type, new $.ig.PropertyMetadata(2, "Others", function (o, e) {
	($.ig.util.cast($.ig.PieChartBase.prototype.$type, o)).raisePropertyChanged($.ig.PieChartBase.prototype.othersCategoryTextPropertyName, e.oldValue(), e.newValue());
}));
$.ig.PieChartBase.prototype.explodedRadiusPropertyName = "ExplodedRadius";
$.ig.PieChartBase.prototype.explodedRadiusProperty = $.ig.DependencyProperty.prototype.register($.ig.PieChartBase.prototype.explodedRadiusPropertyName, Number, $.ig.PieChartBase.prototype.$type, new $.ig.PropertyMetadata(2, 0.2, function (o, e) {
	($.ig.util.cast($.ig.PieChartBase.prototype.$type, o)).raisePropertyChanged($.ig.PieChartBase.prototype.explodedRadiusPropertyName, e.oldValue(), e.newValue());
}));
$.ig.PieChartBase.prototype.radiusFactorPropertyName = "RadiusFactor";
$.ig.PieChartBase.prototype.radiusFactorProperty = $.ig.DependencyProperty.prototype.register($.ig.PieChartBase.prototype.radiusFactorPropertyName, Number, $.ig.PieChartBase.prototype.$type, new $.ig.PropertyMetadata(2, 0.9, function (o, e) {
	($.ig.util.cast($.ig.PieChartBase.prototype.$type, o)).raisePropertyChanged($.ig.PieChartBase.prototype.radiusFactorPropertyName, e.oldValue(), e.newValue());
}));
$.ig.PieChartBase.prototype.allowSliceSelectionPropertyName = "AllowSliceSelection";
$.ig.PieChartBase.prototype.allowSliceSelectionProperty = $.ig.DependencyProperty.prototype.register($.ig.PieChartBase.prototype.allowSliceSelectionPropertyName, $.ig.Boolean.prototype.$type, $.ig.PieChartBase.prototype.$type, new $.ig.PropertyMetadata(2, true, function (o, e) {
	($.ig.util.cast($.ig.PieChartBase.prototype.$type, o)).raisePropertyChanged($.ig.PieChartBase.prototype.allowSliceSelectionPropertyName, e.oldValue(), e.newValue());
}));
$.ig.PieChartBase.prototype.allowSliceExplosionPropertyName = "AllowSliceExplosion";
$.ig.PieChartBase.prototype.allowSliceExplosionProperty = $.ig.DependencyProperty.prototype.register($.ig.PieChartBase.prototype.allowSliceExplosionPropertyName, $.ig.Boolean.prototype.$type, $.ig.PieChartBase.prototype.$type, new $.ig.PropertyMetadata(2, true, function (o, e) {
	($.ig.util.cast($.ig.PieChartBase.prototype.$type, o)).raisePropertyChanged($.ig.PieChartBase.prototype.allowSliceExplosionPropertyName, e.oldValue(), e.newValue());
}));
$.ig.PieChartBase.prototype.legendPropertyName = "Legend";
$.ig.PieChartBase.prototype.legendProperty = $.ig.DependencyProperty.prototype.register($.ig.PieChartBase.prototype.legendPropertyName, $.ig.LegendBase.prototype.$type, $.ig.PieChartBase.prototype.$type, new $.ig.PropertyMetadata(2, null, function (o, e) {
	($.ig.util.cast($.ig.PieChartBase.prototype.$type, o)).raisePropertyChanged($.ig.PieChartBase.prototype.legendPropertyName, e.oldValue(), e.newValue());
}));
$.ig.PieChartBase.prototype.labelExtentPropertyName = "LabelExtent";
$.ig.PieChartBase.prototype.labelExtentProperty = $.ig.DependencyProperty.prototype.register($.ig.PieChartBase.prototype.labelExtentPropertyName, Number, $.ig.PieChartBase.prototype.$type, new $.ig.PropertyMetadata(2, 10, function (o, e) {
	($.ig.util.cast($.ig.PieChartBase.prototype.$type, o)).raisePropertyChanged($.ig.PieChartBase.prototype.labelExtentPropertyName, e.oldValue(), e.newValue());
}));
$.ig.PieChartBase.prototype.startAnglePropertyName = "StartAngle";
$.ig.PieChartBase.prototype.startAngleProperty = $.ig.DependencyProperty.prototype.register($.ig.PieChartBase.prototype.startAnglePropertyName, Number, $.ig.PieChartBase.prototype.$type, new $.ig.PropertyMetadata(2, 0, function (o, e) {
	($.ig.util.cast($.ig.PieChartBase.prototype.$type, o)).raisePropertyChanged($.ig.PieChartBase.prototype.startAnglePropertyName, e.oldValue(), e.newValue());
}));
$.ig.PieChartBase.prototype.sweepDirectionPropertyName = "SweepDirection";
$.ig.PieChartBase.prototype.sweepDirectionProperty = $.ig.DependencyProperty.prototype.register($.ig.PieChartBase.prototype.sweepDirectionPropertyName, $.ig.SweepDirection.prototype.$type, $.ig.PieChartBase.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.SweepDirection.prototype.getBox($.ig.SweepDirection.prototype.clockwise), function (o, e) {
	($.ig.util.cast($.ig.PieChartBase.prototype.$type, o)).raisePropertyChanged($.ig.PieChartBase.prototype.sweepDirectionPropertyName, e.oldValue(), e.newValue());
}));
$.ig.PieChartBase.prototype.othersCategoryStylePropertyName = "OthersCategoryStyle";
$.ig.PieChartBase.prototype.othersCategoryStyleProperty = $.ig.DependencyProperty.prototype.register($.ig.PieChartBase.prototype.othersCategoryStylePropertyName, $.ig.Style.prototype.$type, $.ig.PieChartBase.prototype.$type, new $.ig.PropertyMetadata(2, null, function (o, e) {
	($.ig.util.cast($.ig.PieChartBase.prototype.$type, o)).raisePropertyChanged($.ig.PieChartBase.prototype.othersCategoryStylePropertyName, e.oldValue(), e.newValue());
}));
$.ig.PieChartBase.prototype.selectedStylePropertyName = "SelectedStyle";
$.ig.PieChartBase.prototype.selectedStyleProperty = $.ig.DependencyProperty.prototype.register($.ig.PieChartBase.prototype.selectedStylePropertyName, $.ig.Style.prototype.$type, $.ig.PieChartBase.prototype.$type, new $.ig.PropertyMetadata(2, null, function (o, e) {
	($.ig.util.cast($.ig.PieChartBase.prototype.$type, o)).raisePropertyChanged($.ig.PieChartBase.prototype.selectedStylePropertyName, e.oldValue(), e.newValue());
}));
$.ig.PieChartBase.prototype.toolTipStylePropertyName = "ToolTipStyle";
$.ig.PieChartBase.prototype.toolTipStyleProperty = $.ig.DependencyProperty.prototype.register($.ig.PieChartBase.prototype.toolTipStylePropertyName, $.ig.Style.prototype.$type, $.ig.PieChartBase.prototype.$type, new $.ig.PropertyMetadata(2, null, function (o, e) {
	($.ig.util.cast($.ig.PieChartBase.prototype.$type, o)).raisePropertyChanged($.ig.PieChartBase.prototype.toolTipStylePropertyName, e.oldValue(), e.newValue());
}));
$.ig.PieChartBase.prototype.brushesPropertyName = "Brushes";
$.ig.PieChartBase.prototype.brushesProperty = $.ig.DependencyProperty.prototype.register($.ig.PieChartBase.prototype.brushesPropertyName, $.ig.BrushCollection.prototype.$type, $.ig.PieChartBase.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.PieChartBase.prototype.$type, sender)).raisePropertyChanged($.ig.PieChartBase.prototype.brushesPropertyName, e.oldValue(), e.newValue());
}));
$.ig.PieChartBase.prototype.outlinesPropertyName = "Outlines";
$.ig.PieChartBase.prototype.outlinesProperty = $.ig.DependencyProperty.prototype.register($.ig.PieChartBase.prototype.outlinesPropertyName, $.ig.BrushCollection.prototype.$type, $.ig.PieChartBase.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.PieChartBase.prototype.$type, sender)).raisePropertyChanged($.ig.PieChartBase.prototype.outlinesPropertyName, e.oldValue(), e.newValue());
}));
$.ig.PieChartBase.prototype.legendItemTemplatePropertyName = "LegendItemTemplate";
$.ig.PieChartBase.prototype.legendItemTemplateProperty = $.ig.DependencyProperty.prototype.register($.ig.PieChartBase.prototype.legendItemTemplatePropertyName, $.ig.DataTemplate.prototype.$type, $.ig.PieChartBase.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.PieChartBase.prototype.$type, sender)).raisePropertyChanged($.ig.PieChartBase.prototype.legendItemTemplatePropertyName, e.oldValue(), e.newValue());
}));
$.ig.PieChartBase.prototype.legendItemBadgeTemplatePropertyName = "LegendItemBadgeTemplate";
$.ig.PieChartBase.prototype.legendItemBadgeTemplateProperty = $.ig.DependencyProperty.prototype.register($.ig.PieChartBase.prototype.legendItemBadgeTemplatePropertyName, $.ig.DataTemplate.prototype.$type, $.ig.PieChartBase.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.PieChartBase.prototype.$type, sender)).raisePropertyChanged($.ig.PieChartBase.prototype.legendItemBadgeTemplatePropertyName, e.oldValue(), e.newValue());
}));
$.ig.PieChartBase.prototype._labelTemplatePropertyName = "LabelTemplate";
$.ig.PieChartBase.prototype.labelTemplateProperty = $.ig.DependencyProperty.prototype.register($.ig.PieChartBase.prototype._labelTemplatePropertyName, $.ig.DataTemplate.prototype.$type, $.ig.PieChartBase.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.PieChartBase.prototype.$type, sender)).raisePropertyChanged($.ig.PieChartBase.prototype._labelTemplatePropertyName, e.oldValue(), e.newValue());
}));
$.ig.PieChartBase.prototype.isSurfaceInteractionDisabledPropertyName = "IsSurfaceInteractionDisabled";
$.ig.PieChartBase.prototype.isSurfaceInteractionDisabledProperty = $.ig.DependencyProperty.prototype.register($.ig.PieChartBase.prototype.isSurfaceInteractionDisabledPropertyName, $.ig.Boolean.prototype.$type, $.ig.PieChartBase.prototype.$type, new $.ig.PropertyMetadata(2, false, function (sender, e) {
	(sender).raisePropertyChanged($.ig.PieChartBase.prototype.isSurfaceInteractionDisabledPropertyName, e.oldValue(), e.newValue());
}));
$.ig.PieChartBase.prototype.formatLabelPropertyName = "FormatLabel";
$.ig.PieChartBase.prototype.formatLabelProperty = $.ig.DependencyProperty.prototype.register($.ig.PieChartBase.prototype.formatLabelPropertyName, $.ig.PieChartFormatLabelHandler.prototype.$type, $.ig.PieChartBase.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.PieChartBase.prototype.$type, sender)).raisePropertyChanged($.ig.PieChartBase.prototype.formatLabelPropertyName, e.oldValue(), e.newValue());
}));
$.ig.PieChartBase.prototype.textStylePropertyName = "TextStyle";


$.ig.Arc.prototype.endAnglePropertyName = "EndAngle";
$.ig.Arc.prototype.endAngleProperty = $.ig.DependencyProperty.prototype.register($.ig.Arc.prototype.endAnglePropertyName, Number, $.ig.Arc.prototype.$type, new $.ig.PropertyMetadata(2, 360, function (o, e) {
	($.ig.util.cast($.ig.Arc.prototype.$type, o)).raisePropertyChanged($.ig.Arc.prototype.endAnglePropertyName, e.oldValue(), e.newValue());
}));


$.ig.PieChartBaseView.prototype.tEXT_MARGIN = 0;


$.ig.RingSeriesBase.prototype.itemsSourcePropertyName = "ItemsSource";
$.ig.RingSeriesBase.prototype.itemsSourceProperty = $.ig.DependencyProperty.prototype.register($.ig.RingSeriesBase.prototype.itemsSourcePropertyName, $.ig.IEnumerable.prototype.$type, $.ig.RingSeriesBase.prototype.$type, new $.ig.PropertyMetadata(2, null, function (o, e) {
	($.ig.util.cast($.ig.RingSeriesBase.prototype.$type, o)).raisePropertyChanged($.ig.RingSeriesBase.prototype.itemsSourcePropertyName, e.oldValue(), e.newValue());
}));
$.ig.RingSeriesBase.prototype.valueMemberPathPropertyName = "ValueMemberPath";
$.ig.RingSeriesBase.prototype.valueMemberPathProperty = $.ig.DependencyProperty.prototype.register($.ig.RingSeriesBase.prototype.valueMemberPathPropertyName, String, $.ig.RingSeriesBase.prototype.$type, new $.ig.PropertyMetadata(2, null, function (o, e) {
	($.ig.util.cast($.ig.RingSeriesBase.prototype.$type, o)).raisePropertyChanged($.ig.RingSeriesBase.prototype.valueMemberPathPropertyName, e.oldValue(), e.newValue());
}));
$.ig.RingSeriesBase.prototype.labelMemberPathPropertyName = "LabelMemberPath";
$.ig.RingSeriesBase.prototype.labelMemberPathProperty = $.ig.DependencyProperty.prototype.register($.ig.RingSeriesBase.prototype.labelMemberPathPropertyName, String, $.ig.RingSeriesBase.prototype.$type, new $.ig.PropertyMetadata(1, function (o, e) {
	($.ig.util.cast($.ig.RingSeriesBase.prototype.$type, o)).raisePropertyChanged($.ig.RingSeriesBase.prototype.labelMemberPathPropertyName, e.oldValue(), e.newValue());
}));
$.ig.RingSeriesBase.prototype.labelsPositionPropertyName = "LabelsPosition";
$.ig.RingSeriesBase.prototype.labelsPositionProperty = $.ig.DependencyProperty.prototype.register($.ig.RingSeriesBase.prototype.labelsPositionPropertyName, $.ig.LabelsPosition.prototype.$type, $.ig.RingSeriesBase.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.LabelsPosition.prototype.getBox($.ig.LabelsPosition.prototype.center), function (o, e) {
	($.ig.util.cast($.ig.RingSeriesBase.prototype.$type, o)).raisePropertyChanged($.ig.RingSeriesBase.prototype.labelsPositionPropertyName, e.oldValue(), e.newValue());
}));
$.ig.RingSeriesBase.prototype.leaderLineVisibilityPropertyName = "LeaderLineVisibility";
$.ig.RingSeriesBase.prototype.leaderLineVisibilityProperty = $.ig.DependencyProperty.prototype.register($.ig.RingSeriesBase.prototype.leaderLineVisibilityPropertyName, $.ig.Visibility.prototype.$type, $.ig.RingSeriesBase.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.Visibility.prototype.getBox($.ig.Visibility.prototype.visible), function (o, e) {
	($.ig.util.cast($.ig.RingSeriesBase.prototype.$type, o)).raisePropertyChanged($.ig.RingSeriesBase.prototype.leaderLineVisibilityPropertyName, e.oldValue(), e.newValue());
}));
$.ig.RingSeriesBase.prototype.leaderLineStylePropertyName = "LeaderLineStyle";
$.ig.RingSeriesBase.prototype.leaderLineStyleProperty = $.ig.DependencyProperty.prototype.register($.ig.RingSeriesBase.prototype.leaderLineStylePropertyName, $.ig.Style.prototype.$type, $.ig.RingSeriesBase.prototype.$type, new $.ig.PropertyMetadata(2, null, function (o, e) {
	($.ig.util.cast($.ig.RingSeriesBase.prototype.$type, o)).raisePropertyChanged($.ig.RingSeriesBase.prototype.leaderLineStylePropertyName, e.oldValue(), e.newValue());
}));
$.ig.RingSeriesBase.prototype.leaderLineTypePropertyName = "LeaderLineType";
$.ig.RingSeriesBase.prototype.leaderLineTypeProperty = $.ig.DependencyProperty.prototype.register($.ig.RingSeriesBase.prototype.leaderLineTypePropertyName, $.ig.LeaderLineType.prototype.$type, $.ig.RingSeriesBase.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.LeaderLineType.prototype.getBox($.ig.LeaderLineType.prototype.straight), function (o, e) {
	($.ig.util.cast($.ig.RingSeriesBase.prototype.$type, o)).raisePropertyChanged($.ig.RingSeriesBase.prototype.leaderLineTypePropertyName, e.oldValue(), e.newValue());
}));
$.ig.RingSeriesBase.prototype.leaderLineMarginPropertyName = "LeaderLineMargin";
$.ig.RingSeriesBase.prototype.leaderLineMarginProperty = $.ig.DependencyProperty.prototype.register($.ig.RingSeriesBase.prototype.leaderLineMarginPropertyName, Number, $.ig.RingSeriesBase.prototype.$type, new $.ig.PropertyMetadata(2, 6, function (o, e) {
	($.ig.util.cast($.ig.RingSeriesBase.prototype.$type, o)).raisePropertyChanged($.ig.RingSeriesBase.prototype.leaderLineMarginPropertyName, e.oldValue(), e.newValue());
}));
$.ig.RingSeriesBase.prototype.toolTipPropertyName = "ToolTip";
$.ig.RingSeriesBase.prototype.toolTipProperty = $.ig.DependencyProperty.prototype.register($.ig.RingSeriesBase.prototype.toolTipPropertyName, $.ig.Object.prototype.$type, $.ig.RingSeriesBase.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.RingSeriesBase.prototype.$type, sender)).raisePropertyChanged($.ig.RingSeriesBase.prototype.toolTipPropertyName, e.oldValue(), e.newValue());
}));
$.ig.RingSeriesBase.prototype.othersCategoryThresholdPropertyName = "OthersCategoryThreshold";
$.ig.RingSeriesBase.prototype.othersCategoryThresholdProperty = $.ig.DependencyProperty.prototype.register($.ig.RingSeriesBase.prototype.othersCategoryThresholdPropertyName, Number, $.ig.RingSeriesBase.prototype.$type, new $.ig.PropertyMetadata(2, 3, function (o, e) {
	($.ig.util.cast($.ig.RingSeriesBase.prototype.$type, o)).raisePropertyChanged($.ig.RingSeriesBase.prototype.othersCategoryThresholdPropertyName, e.oldValue(), e.newValue());
}));
$.ig.RingSeriesBase.prototype.othersCategoryTypePropertyName = "OthersCategoryType";
$.ig.RingSeriesBase.prototype.othersCategoryTypeProperty = $.ig.DependencyProperty.prototype.register($.ig.RingSeriesBase.prototype.othersCategoryTypePropertyName, $.ig.OthersCategoryType.prototype.$type, $.ig.RingSeriesBase.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.OthersCategoryType.prototype.getBox($.ig.OthersCategoryType.prototype.percent), function (o, e) {
	($.ig.util.cast($.ig.RingSeriesBase.prototype.$type, o)).raisePropertyChanged($.ig.RingSeriesBase.prototype.othersCategoryTypePropertyName, e.oldValue(), e.newValue());
}));
$.ig.RingSeriesBase.prototype.othersCategoryTextPropertyName = "OthersCategoryText";
$.ig.RingSeriesBase.prototype.othersCategoryTextProperty = $.ig.DependencyProperty.prototype.register($.ig.RingSeriesBase.prototype.othersCategoryTextPropertyName, String, $.ig.RingSeriesBase.prototype.$type, new $.ig.PropertyMetadata(2, "Others", function (o, e) {
	($.ig.util.cast($.ig.RingSeriesBase.prototype.$type, o)).raisePropertyChanged($.ig.RingSeriesBase.prototype.othersCategoryTextPropertyName, e.oldValue(), e.newValue());
}));
$.ig.RingSeriesBase.prototype.legendPropertyName = "Legend";
$.ig.RingSeriesBase.prototype.legendProperty = $.ig.DependencyProperty.prototype.register($.ig.RingSeriesBase.prototype.legendPropertyName, $.ig.LegendBase.prototype.$type, $.ig.RingSeriesBase.prototype.$type, new $.ig.PropertyMetadata(2, null, function (o, e) {
	($.ig.util.cast($.ig.RingSeriesBase.prototype.$type, o)).raisePropertyChanged($.ig.RingSeriesBase.prototype.legendPropertyName, e.oldValue(), e.newValue());
}));
$.ig.RingSeriesBase.prototype.formatLabelPropertyName = "FormatLabel";
$.ig.RingSeriesBase.prototype.formatLabelProperty = $.ig.DependencyProperty.prototype.register($.ig.RingSeriesBase.prototype.formatLabelPropertyName, $.ig.Func$2.prototype.$type.specialize($.ig.Object.prototype.$type, String), $.ig.RingSeriesBase.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.RingSeriesBase.prototype.$type, sender)).raisePropertyChanged($.ig.RingSeriesBase.prototype.formatLabelPropertyName, e.oldValue(), e.newValue());
}));
$.ig.RingSeriesBase.prototype.labelExtentPropertyName = "LabelExtent";
$.ig.RingSeriesBase.prototype.labelExtentProperty = $.ig.DependencyProperty.prototype.register($.ig.RingSeriesBase.prototype.labelExtentPropertyName, Number, $.ig.RingSeriesBase.prototype.$type, new $.ig.PropertyMetadata(2, 10, function (o, e) {
	($.ig.util.cast($.ig.RingSeriesBase.prototype.$type, o)).raisePropertyChanged($.ig.RingSeriesBase.prototype.labelExtentPropertyName, e.oldValue(), e.newValue());
}));
$.ig.RingSeriesBase.prototype.startAnglePropertyName = "StartAngle";
$.ig.RingSeriesBase.prototype.startAngleProperty = $.ig.DependencyProperty.prototype.register($.ig.RingSeriesBase.prototype.startAnglePropertyName, Number, $.ig.RingSeriesBase.prototype.$type, new $.ig.PropertyMetadata(2, 0, function (o, e) {
	($.ig.util.cast($.ig.RingSeriesBase.prototype.$type, o)).raisePropertyChanged($.ig.RingSeriesBase.prototype.startAnglePropertyName, e.oldValue(), e.newValue());
}));
$.ig.RingSeriesBase.prototype.othersCategoryStylePropertyName = "OthersCategoryStyle";
$.ig.RingSeriesBase.prototype.othersCategoryStyleProperty = $.ig.DependencyProperty.prototype.register($.ig.RingSeriesBase.prototype.othersCategoryStylePropertyName, $.ig.Style.prototype.$type, $.ig.RingSeriesBase.prototype.$type, new $.ig.PropertyMetadata(2, null, function (o, e) {
	($.ig.util.cast($.ig.RingSeriesBase.prototype.$type, o)).raisePropertyChanged($.ig.RingSeriesBase.prototype.othersCategoryStylePropertyName, e.oldValue(), e.newValue());
}));
$.ig.RingSeriesBase.prototype.selectedStylePropertyName = "SelectedStyle";
$.ig.RingSeriesBase.prototype.selectedStyleProperty = $.ig.DependencyProperty.prototype.register($.ig.RingSeriesBase.prototype.selectedStylePropertyName, $.ig.Style.prototype.$type, $.ig.RingSeriesBase.prototype.$type, new $.ig.PropertyMetadata(2, null, function (o, e) {
	($.ig.util.cast($.ig.RingSeriesBase.prototype.$type, o)).raisePropertyChanged($.ig.RingSeriesBase.prototype.selectedStylePropertyName, e.oldValue(), e.newValue());
}));
$.ig.RingSeriesBase.prototype.selectedStyleResolvedPropertyName = "SelectedStyleResolved";
$.ig.RingSeriesBase.prototype.toolTipStylePropertyName = "ToolTipStyle";
$.ig.RingSeriesBase.prototype.toolTipStyleProperty = $.ig.DependencyProperty.prototype.register($.ig.RingSeriesBase.prototype.toolTipStylePropertyName, $.ig.Style.prototype.$type, $.ig.RingSeriesBase.prototype.$type, new $.ig.PropertyMetadata(2, null, function (o, e) {
	($.ig.util.cast($.ig.RingSeriesBase.prototype.$type, o)).raisePropertyChanged($.ig.RingSeriesBase.prototype.toolTipStylePropertyName, e.oldValue(), e.newValue());
}));
$.ig.RingSeriesBase.prototype.brushesPropertyName = "Brushes";
$.ig.RingSeriesBase.prototype.brushesProperty = $.ig.DependencyProperty.prototype.register($.ig.RingSeriesBase.prototype.brushesPropertyName, $.ig.BrushCollection.prototype.$type, $.ig.RingSeriesBase.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.RingSeriesBase.prototype.$type, sender)).raisePropertyChanged($.ig.RingSeriesBase.prototype.brushesPropertyName, e.oldValue(), e.newValue());
}));
$.ig.RingSeriesBase.prototype.outlinesPropertyName = "Outlines";
$.ig.RingSeriesBase.prototype.outlinesProperty = $.ig.DependencyProperty.prototype.register($.ig.RingSeriesBase.prototype.outlinesPropertyName, $.ig.BrushCollection.prototype.$type, $.ig.RingSeriesBase.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.RingSeriesBase.prototype.$type, sender)).raisePropertyChanged($.ig.RingSeriesBase.prototype.outlinesPropertyName, e.oldValue(), e.newValue());
}));
$.ig.RingSeriesBase.prototype.legendItemTemplatePropertyName = "LegendItemTemplate";
$.ig.RingSeriesBase.prototype.legendItemTemplateProperty = $.ig.DependencyProperty.prototype.register($.ig.RingSeriesBase.prototype.legendItemTemplatePropertyName, $.ig.DataTemplate.prototype.$type, $.ig.RingSeriesBase.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.RingSeriesBase.prototype.$type, sender)).raisePropertyChanged($.ig.RingSeriesBase.prototype.legendItemTemplatePropertyName, e.oldValue(), e.newValue());
}));
$.ig.RingSeriesBase.prototype.legendItemBadgeTemplatePropertyName = "LegendItemBadgeTemplate";
$.ig.RingSeriesBase.prototype.legendItemBadgeTemplateProperty = $.ig.DependencyProperty.prototype.register($.ig.RingSeriesBase.prototype.legendItemBadgeTemplatePropertyName, $.ig.DataTemplate.prototype.$type, $.ig.RingSeriesBase.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.RingSeriesBase.prototype.$type, sender)).raisePropertyChanged($.ig.RingSeriesBase.prototype.legendItemBadgeTemplatePropertyName, e.oldValue(), e.newValue());
}));
$.ig.RingSeriesBase.prototype._labelTemplatePropertyName = "LabelTemplate";
$.ig.RingSeriesBase.prototype.labelTemplateProperty = $.ig.DependencyProperty.prototype.register($.ig.RingSeriesBase.prototype._labelTemplatePropertyName, $.ig.DataTemplate.prototype.$type, $.ig.RingSeriesBase.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.RingSeriesBase.prototype.$type, sender)).raisePropertyChanged($.ig.RingSeriesBase.prototype._labelTemplatePropertyName, e.oldValue(), e.newValue());
}));
$.ig.RingSeriesBase.prototype.isSurfaceInteractionDisabledPropertyName = "IsSurfaceInteractionDisabled";
$.ig.RingSeriesBase.prototype.isSurfaceInteractionDisabledProperty = $.ig.DependencyProperty.prototype.register($.ig.RingSeriesBase.prototype.isSurfaceInteractionDisabledPropertyName, $.ig.Nullable$1.prototype.$type.specialize($.ig.Boolean.prototype.$type), $.ig.RingSeriesBase.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	(sender).raisePropertyChanged($.ig.RingSeriesBase.prototype.isSurfaceInteractionDisabledPropertyName, e.oldValue(), e.newValue());
}));
$.ig.RingSeriesBase.prototype.radiusFactorPropertyName = "RadiusFactor";
$.ig.RingSeriesBase.prototype.radiusFactorProperty = $.ig.DependencyProperty.prototype.register($.ig.RingSeriesBase.prototype.radiusFactorPropertyName, Number, $.ig.RingSeriesBase.prototype.$type, new $.ig.PropertyMetadata(2, 0.9, function (o, e) {
	($.ig.util.cast($.ig.RingSeriesBase.prototype.$type, o)).raisePropertyChanged($.ig.RingSeriesBase.prototype.radiusFactorPropertyName, e.oldValue(), e.newValue());
}));
$.ig.RingSeriesBase.prototype._rootCanvasName = "RootCanvas";



$.ig.RingControl.prototype._rootCanvasName = "RootCanvas";


$.ig.XamDoughnutChart.prototype.allowSliceSelectionPropertyName = "AllowSliceSelection";
$.ig.XamDoughnutChart.prototype.allowSliceSelectionProperty = $.ig.DependencyProperty.prototype.register($.ig.XamDoughnutChart.prototype.allowSliceSelectionPropertyName, $.ig.Boolean.prototype.$type, $.ig.XamDoughnutChart.prototype.$type, new $.ig.PropertyMetadata(2, true, function (o, e) {
	($.ig.util.cast($.ig.XamDoughnutChart.prototype.$type, o)).raisePropertyChanged($.ig.XamDoughnutChart.prototype.allowSliceSelectionPropertyName, e.oldValue(), e.newValue());
}));
$.ig.XamDoughnutChart.prototype.isSurfaceInteractionDisabledPropertyName = "IsSurfaceInteractionDisabled";
$.ig.XamDoughnutChart.prototype.isSurfaceInteractionDisabledProperty = $.ig.DependencyProperty.prototype.register($.ig.XamDoughnutChart.prototype.isSurfaceInteractionDisabledPropertyName, $.ig.Nullable$1.prototype.$type.specialize($.ig.Boolean.prototype.$type), $.ig.XamDoughnutChart.prototype.$type, new $.ig.PropertyMetadata(2, null, function (o, e) {
	($.ig.util.cast($.ig.XamDoughnutChart.prototype.$type, o)).raisePropertyChanged($.ig.XamDoughnutChart.prototype.isSurfaceInteractionDisabledPropertyName, e.oldValue(), e.newValue());
}));
$.ig.XamDoughnutChart.prototype.allowSliceExplosionPropertyName = "AllowSliceExplosion";
$.ig.XamDoughnutChart.prototype.allowSliceExplosionProperty = $.ig.DependencyProperty.prototype.register($.ig.XamDoughnutChart.prototype.allowSliceExplosionPropertyName, $.ig.Boolean.prototype.$type, $.ig.XamDoughnutChart.prototype.$type, new $.ig.PropertyMetadata(2, true, function (o, e) {
	($.ig.util.cast($.ig.XamDoughnutChart.prototype.$type, o)).raisePropertyChanged($.ig.XamDoughnutChart.prototype.allowSliceExplosionPropertyName, e.oldValue(), e.newValue());
}));
$.ig.XamDoughnutChart.prototype._contentPresenterName = "ContentPresenter";
$.ig.XamDoughnutChart.prototype.innerExtentPropertyName = "InnerExtent";
$.ig.XamDoughnutChart.prototype.innerExtentProperty = $.ig.DependencyProperty.prototype.register($.ig.XamDoughnutChart.prototype.innerExtentPropertyName, Number, $.ig.XamDoughnutChart.prototype.$type, new $.ig.PropertyMetadata(2, 40, function (o, e) {
	var newValue = e.newValue();
	if (newValue < 0 || newValue > 100) {
		if (e.oldValue() != null) {
			(o).innerExtent(e.oldValue());
		}

		return;
	}

	(o).renderChart();
	(o).raisePropertyChanged($.ig.XamDoughnutChart.prototype.innerExtentPropertyName, e.oldValue(), e.newValue());
}));
$.ig.XamDoughnutChart.prototype.selectedStylePropertyName = "SelectedStyle";
$.ig.XamDoughnutChart.prototype.selectedStyleProperty = $.ig.DependencyProperty.prototype.register($.ig.XamDoughnutChart.prototype.selectedStylePropertyName, $.ig.Style.prototype.$type, $.ig.XamDoughnutChart.prototype.$type, new $.ig.PropertyMetadata(2, null, function (o, e) {
	($.ig.util.cast($.ig.XamDoughnutChart.prototype.$type, o)).raisePropertyChanged($.ig.XamDoughnutChart.prototype.selectedStylePropertyName, e.oldValue(), e.newValue());
}));
$.ig.XamDoughnutChart.prototype.centerDataPropertyName = "CenterData";
$.ig.XamDoughnutChart.prototype.centerDataProperty = $.ig.DependencyProperty.prototype.register($.ig.XamDoughnutChart.prototype.centerDataPropertyName, $.ig.Object.prototype.$type, $.ig.XamDoughnutChart.prototype.$type, new $.ig.PropertyMetadata(2, null, function (o, e) {
	($.ig.util.cast($.ig.XamDoughnutChart.prototype.$type, o)).raisePropertyChanged($.ig.XamDoughnutChart.prototype.centerDataPropertyName, e.oldValue(), e.newValue());
}));
$.ig.XamDoughnutChart.prototype.centerDataTemplatePropertyName = "CenterDataTemplate";
$.ig.XamDoughnutChart.prototype.centerDataTemplateProperty = $.ig.DependencyProperty.prototype.register($.ig.XamDoughnutChart.prototype.centerDataTemplatePropertyName, $.ig.DataTemplate.prototype.$type, $.ig.XamDoughnutChart.prototype.$type, new $.ig.PropertyMetadata(2, null, function (o, e) {
	($.ig.util.cast($.ig.XamDoughnutChart.prototype.$type, o)).raisePropertyChanged($.ig.XamDoughnutChart.prototype.centerDataTemplatePropertyName, e.oldValue(), e.newValue());
}));









































$.ig.XamDataChart.prototype.decimalMinimumValueAsDouble = 0;
$.ig.XamDataChart.prototype.decimalMaximumValueAsDouble = 0;
$.ig.XamDataChart.prototype.isSquarePropertyName = "IsSquare";
$.ig.XamDataChart.prototype.isSquareProperty = $.ig.DependencyProperty.prototype.register($.ig.XamDataChart.prototype.isSquarePropertyName, $.ig.Boolean.prototype.$type, $.ig.XamDataChart.prototype.$type, new $.ig.PropertyMetadata(2, false, function (sender, e) {
	($.ig.util.cast($.ig.XamDataChart.prototype.$type, sender)).raisePropertyChanged($.ig.XamDataChart.prototype.isSquarePropertyName, e.oldValue(), e.newValue());
}));
$.ig.XamDataChart.prototype.windowScaleHorizontalPropertyName = "WindowScaleHorizontal";
$.ig.XamDataChart.prototype.windowScaleHorizontalProperty = $.ig.DependencyProperty.prototype.register($.ig.XamDataChart.prototype.windowScaleHorizontalPropertyName, Number, $.ig.XamDataChart.prototype.$type, new $.ig.PropertyMetadata(2, NaN, function (sender, e) {
	($.ig.util.cast($.ig.XamDataChart.prototype.$type, sender)).raisePropertyChanged($.ig.XamDataChart.prototype.windowScaleHorizontalPropertyName, e.oldValue(), e.newValue());
}));
$.ig.XamDataChart.prototype.windowScaleVerticalPropertyName = "WindowScaleVertical";
$.ig.XamDataChart.prototype.windowScaleVerticalProperty = $.ig.DependencyProperty.prototype.register($.ig.XamDataChart.prototype.windowScaleVerticalPropertyName, Number, $.ig.XamDataChart.prototype.$type, new $.ig.PropertyMetadata(2, NaN, function (sender, e) {
	($.ig.util.cast($.ig.XamDataChart.prototype.$type, sender)).raisePropertyChanged($.ig.XamDataChart.prototype.windowScaleVerticalPropertyName, e.oldValue(), e.newValue());
}));
$.ig.XamDataChart.prototype.actualWindowScaleHorizontalPropertyName = "ActualWindowScaleHorizontal";
$.ig.XamDataChart.prototype.actualWindowScaleVerticalPropertyName = "ActualWindowScaleVertical";
$.ig.XamDataChart.prototype.horizontalZoomablePropertyName = "HorizontalZoomable";
$.ig.XamDataChart.prototype.horizontalZoomableProperty = $.ig.DependencyProperty.prototype.register($.ig.XamDataChart.prototype.horizontalZoomablePropertyName, $.ig.Boolean.prototype.$type, $.ig.XamDataChart.prototype.$type, new $.ig.PropertyMetadata(2, false, function (sender, e) {
	($.ig.util.cast($.ig.XamDataChart.prototype.$type, sender)).raisePropertyChanged($.ig.XamDataChart.prototype.horizontalZoomablePropertyName, e.oldValue(), e.newValue());
}));
$.ig.XamDataChart.prototype.verticalZoomablePropertyName = "VerticalZoomable";
$.ig.XamDataChart.prototype.verticalZoomableProperty = $.ig.DependencyProperty.prototype.register($.ig.XamDataChart.prototype.verticalZoomablePropertyName, $.ig.Boolean.prototype.$type, $.ig.XamDataChart.prototype.$type, new $.ig.PropertyMetadata(2, false, function (sender, e) {
	($.ig.util.cast($.ig.XamDataChart.prototype.$type, sender)).raisePropertyChanged($.ig.XamDataChart.prototype.verticalZoomablePropertyName, e.oldValue(), e.newValue());
}));
$.ig.XamDataChart.prototype.horizontalZoombarVisibilityPropertyName = "HorizontalZoombarVisibility";
$.ig.XamDataChart.prototype.horizontalZoombarVisibilityProperty = $.ig.DependencyProperty.prototype.register($.ig.XamDataChart.prototype.horizontalZoombarVisibilityPropertyName, $.ig.Visibility.prototype.$type, $.ig.XamDataChart.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.Visibility.prototype.getBox($.ig.Visibility.prototype.collapsed), function (sender, e) {
	($.ig.util.cast($.ig.XamDataChart.prototype.$type, sender)).raisePropertyChanged($.ig.XamDataChart.prototype.horizontalZoombarVisibilityPropertyName, e.oldValue(), e.newValue());
}));
$.ig.XamDataChart.prototype.verticalZoombarVisibilityPropertyName = "VerticalZoombarVisibility";
$.ig.XamDataChart.prototype.verticalZoombarVisibilityProperty = $.ig.DependencyProperty.prototype.register($.ig.XamDataChart.prototype.verticalZoombarVisibilityPropertyName, $.ig.Visibility.prototype.$type, $.ig.XamDataChart.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.Visibility.prototype.getBox($.ig.Visibility.prototype.collapsed), function (sender, e) {
	($.ig.util.cast($.ig.XamDataChart.prototype.$type, sender)).raisePropertyChanged($.ig.XamDataChart.prototype.verticalZoombarVisibilityPropertyName, e.oldValue(), e.newValue());
}));
$.ig.XamDataChart.prototype.gridModePropertyName = "GridMode";
$.ig.XamDataChart.prototype.gridModeProperty = $.ig.DependencyProperty.prototype.register($.ig.XamDataChart.prototype.gridModePropertyName, $.ig.GridMode.prototype.$type, $.ig.XamDataChart.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.GridMode.prototype.getBox($.ig.GridMode.prototype.behindSeries), function (sender, e) {
	($.ig.util.cast($.ig.XamDataChart.prototype.$type, sender)).raisePropertyChanged($.ig.XamDataChart.prototype.gridModePropertyName, e.oldValue(), e.newValue());
}));
$.ig.XamDataChart.prototype.alignsGridLinesToPixelsPropertyName = "AlignsGridLinesToPixels";
$.ig.XamDataChart.prototype.alignsGridLinesToPixelsProperty = $.ig.DependencyProperty.prototype.register("AlignsGridLinesToPixels", $.ig.Boolean.prototype.$type, $.ig.XamDataChart.prototype.$type, new $.ig.PropertyMetadata(2, true, function (sender, e) {
	($.ig.util.cast($.ig.XamDataChart.prototype.$type, sender)).raisePropertyChanged($.ig.XamDataChart.prototype.alignsGridLinesToPixelsPropertyName, e.oldValue(), e.newValue());
}));
$.ig.XamDataChart.prototype.brushesPropertyName = "Brushes";
$.ig.XamDataChart.prototype.brushesProperty = $.ig.DependencyProperty.prototype.register($.ig.XamDataChart.prototype.brushesPropertyName, $.ig.BrushCollection.prototype.$type, $.ig.XamDataChart.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.XamDataChart.prototype.$type, sender)).raisePropertyChanged($.ig.XamDataChart.prototype.brushesPropertyName, e.oldValue(), e.newValue());
}));
$.ig.XamDataChart.prototype.markerBrushesPropertyName = "MarkerBrushes";
$.ig.XamDataChart.prototype.markerBrushesProperty = $.ig.DependencyProperty.prototype.register($.ig.XamDataChart.prototype.markerBrushesPropertyName, $.ig.BrushCollection.prototype.$type, $.ig.XamDataChart.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.XamDataChart.prototype.$type, sender)).raisePropertyChanged($.ig.XamDataChart.prototype.markerBrushesPropertyName, e.oldValue(), e.newValue());
}));
$.ig.XamDataChart.prototype.outlinesPropertyName = "Outlines";
$.ig.XamDataChart.prototype.outlinesProperty = $.ig.DependencyProperty.prototype.register($.ig.XamDataChart.prototype.outlinesPropertyName, $.ig.BrushCollection.prototype.$type, $.ig.XamDataChart.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.XamDataChart.prototype.$type, sender)).raisePropertyChanged($.ig.XamDataChart.prototype.outlinesPropertyName, e.oldValue(), e.newValue());
}));
$.ig.XamDataChart.prototype.markerOutlinesPropertyName = "MarkerOutlines";
$.ig.XamDataChart.prototype.markerOutlinesProperty = $.ig.DependencyProperty.prototype.register($.ig.XamDataChart.prototype.markerOutlinesPropertyName, $.ig.BrushCollection.prototype.$type, $.ig.XamDataChart.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.XamDataChart.prototype.$type, sender)).raisePropertyChanged($.ig.XamDataChart.prototype.markerOutlinesPropertyName, e.oldValue(), e.newValue());
}));
$.ig.XamDataChart.prototype.defaultAxisStrokePropertyName = "DefaultAxisStroke";
$.ig.XamDataChart.prototype.defaultAxisStrokeProperty = $.ig.DependencyProperty.prototype.register($.ig.XamDataChart.prototype.defaultAxisStrokePropertyName, $.ig.Brush.prototype.$type, $.ig.XamDataChart.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.XamDataChart.prototype.$type, sender)).raisePropertyChanged($.ig.XamDataChart.prototype.defaultAxisStrokePropertyName, e.oldValue(), e.newValue());
}));
$.ig.XamDataChart.prototype.defaultAxisMajorStrokePropertyName = "DefaultAxisMajorStroke";
$.ig.XamDataChart.prototype.defaultAxisMajorStrokeProperty = $.ig.DependencyProperty.prototype.register($.ig.XamDataChart.prototype.defaultAxisMajorStrokePropertyName, $.ig.Brush.prototype.$type, $.ig.XamDataChart.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.XamDataChart.prototype.$type, sender)).raisePropertyChanged($.ig.XamDataChart.prototype.defaultAxisMajorStrokePropertyName, e.oldValue(), e.newValue());
}));
$.ig.XamDataChart.prototype.defaultAxisMinorStrokePropertyName = "DefaultAxisMinorStroke";
$.ig.XamDataChart.prototype.defaultAxisMinorStrokeProperty = $.ig.DependencyProperty.prototype.register($.ig.XamDataChart.prototype.defaultAxisMinorStrokePropertyName, $.ig.Brush.prototype.$type, $.ig.XamDataChart.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.XamDataChart.prototype.$type, sender)).raisePropertyChanged($.ig.XamDataChart.prototype.defaultAxisMinorStrokePropertyName, e.oldValue(), e.newValue());
}));
$.ig.XamDataChart.prototype.plotAreaBackgroundContentPropertyName = "PlotAreaBackgroundContent";
$.ig.XamDataChart.prototype.plotAreaBackgroundContentProperty = $.ig.DependencyProperty.prototype.register($.ig.XamDataChart.prototype.plotAreaBackgroundContentPropertyName, $.ig.FrameworkElement.prototype.$type, $.ig.XamDataChart.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.XamDataChart.prototype.$type, sender)).raisePropertyChanged($.ig.XamDataChart.prototype.plotAreaBackgroundContentPropertyName, e.oldValue(), e.newValue());
}));
if ($.ig.XamDataChart.prototype.staticInit && !$.ig.XamDataChart.prototype.xamDataChartStaticInitCalled) { $.ig.XamDataChart.prototype.staticInit(); $.ig.XamDataChart.prototype.xamDataChartStaticInitCalled = true; }



$.ig.SyncSettings.prototype.syncChannelPropertyName = "SyncChannel";
$.ig.SyncSettings.prototype.syncChannelProperty = $.ig.DependencyProperty.prototype.register($.ig.SyncSettings.prototype.syncChannelPropertyName, String, $.ig.SyncSettings.prototype.$type, new $.ig.PropertyMetadata(2, null, function (o, e) {
	($.ig.util.cast($.ig.SyncSettings.prototype.$type, o)).raisePropertyChanged($.ig.SyncSettings.prototype.syncChannelPropertyName, e.oldValue(), e.newValue());
}));
$.ig.SyncSettings.prototype.synchronizeVerticallyPropertyName = "SynchronizeVertically";
$.ig.SyncSettings.prototype.synchronizeVerticallyProperty = $.ig.DependencyProperty.prototype.register($.ig.SyncSettings.prototype.synchronizeVerticallyPropertyName, $.ig.Boolean.prototype.$type, $.ig.SyncSettings.prototype.$type, new $.ig.PropertyMetadata(2, true, function (o, e) {
	($.ig.util.cast($.ig.SyncSettings.prototype.$type, o)).raisePropertyChanged($.ig.SyncSettings.prototype.synchronizeVerticallyPropertyName, e.oldValue(), e.newValue());
}));
$.ig.SyncSettings.prototype.synchronizeHorizontallyPropertyName = "SynchronizeHorizontally";
$.ig.SyncSettings.prototype.synchronizeHorizontallyProperty = $.ig.DependencyProperty.prototype.register($.ig.SyncSettings.prototype.synchronizeHorizontallyPropertyName, $.ig.Boolean.prototype.$type, $.ig.SyncSettings.prototype.$type, new $.ig.PropertyMetadata(2, true, function (o, e) {
	($.ig.util.cast($.ig.SyncSettings.prototype.$type, o)).raisePropertyChanged($.ig.SyncSettings.prototype.synchronizeHorizontallyPropertyName, e.oldValue(), e.newValue());
}));


$.ig.SyncLinkManager.prototype.__instance = null;






$.ig.Legend.prototype.orientationPropertyName = "Orientation";


$.ig.Slice.prototype.startAnglePropertyName = "StartAngle";
$.ig.Slice.prototype.startAngleProperty = $.ig.DependencyProperty.prototype.register($.ig.Slice.prototype.startAnglePropertyName, Number, $.ig.Slice.prototype.$type, new $.ig.PropertyMetadata(2, 0, function (o, e) { ($.ig.util.cast($.ig.Slice.prototype.$type, o)).createShape(); }));
$.ig.Slice.prototype.endAnglePropertyName = "EndAngle";
$.ig.Slice.prototype.endAngleProperty = $.ig.DependencyProperty.prototype.register($.ig.Slice.prototype.endAnglePropertyName, Number, $.ig.Slice.prototype.$type, new $.ig.PropertyMetadata(2, 0, function (o, e) { ($.ig.util.cast($.ig.Slice.prototype.$type, o)).createShape(); }));
$.ig.Slice.prototype.innerExtentStartPropertyName = "InnerExtentStart";
$.ig.Slice.prototype.innerExtentStartProperty = $.ig.DependencyProperty.prototype.register($.ig.Slice.prototype.innerExtentStartPropertyName, Number, $.ig.Slice.prototype.$type, new $.ig.PropertyMetadata(2, 0, function (o, e) { ($.ig.util.cast($.ig.Slice.prototype.$type, o)).createShape(); }));
$.ig.Slice.prototype.innerExtentEndPropertyName = "InnerExtentEnd";
$.ig.Slice.prototype.innerExtentEndProperty = $.ig.DependencyProperty.prototype.register($.ig.Slice.prototype.innerExtentEndPropertyName, Number, $.ig.Slice.prototype.$type, new $.ig.PropertyMetadata(2, 0, function (o, e) { ($.ig.util.cast($.ig.Slice.prototype.$type, o)).createShape(); }));
$.ig.Slice.prototype.isSelectedPropertyName = "IsSelected";
$.ig.Slice.prototype.isSelectedProperty = $.ig.DependencyProperty.prototype.register($.ig.Slice.prototype.isSelectedPropertyName, $.ig.Boolean.prototype.$type, $.ig.Slice.prototype.$type, new $.ig.PropertyMetadata(2, false, function (o, e) {
	var slice = $.ig.util.cast($.ig.Slice.prototype.$type, o);
	var shouldSelect = e.newValue();
	slice.owner().selectSlice(slice, shouldSelect);
}));
$.ig.Slice.prototype.isExplodedPropertyName = "IsExploded";
$.ig.Slice.prototype.isExplodedProperty = $.ig.DependencyProperty.prototype.register($.ig.Slice.prototype.isExplodedPropertyName, $.ig.Boolean.prototype.$type, $.ig.Slice.prototype.$type, new $.ig.PropertyMetadata(2, false, function (o, e) {
	var slice = $.ig.util.cast($.ig.Slice.prototype.$type, o);
	var explode = e.newValue();
	slice.owner().explodeSlice(slice, explode);
}));
$.ig.Slice.prototype.isOtherSlicePropertyName = "IsOtherSlice";
$.ig.Slice.prototype.isOtherSliceProperty = $.ig.DependencyProperty.prototype.register($.ig.Slice.prototype.isOtherSlicePropertyName, $.ig.Boolean.prototype.$type, $.ig.Slice.prototype.$type, new $.ig.PropertyMetadata(2, false, function (o, e) { ($.ig.util.cast($.ig.Slice.prototype.$type, o)).createShape(); }));
$.ig.Slice.prototype.originPropertyName = "Origin";
$.ig.Slice.prototype.originProperty = $.ig.DependencyProperty.prototype.register($.ig.Slice.prototype.originPropertyName, $.ig.Point.prototype.$type, $.ig.Slice.prototype.$type, new $.ig.PropertyMetadata(2, new $.ig.Point(0), function (o, e) { ($.ig.util.cast($.ig.Slice.prototype.$type, o)).createShape(); }));
$.ig.Slice.prototype.explodedOriginPropertyName = "ExplodedOrigin";
$.ig.Slice.prototype.explodedOriginProperty = $.ig.DependencyProperty.prototype.register($.ig.Slice.prototype.explodedOriginPropertyName, $.ig.Point.prototype.$type, $.ig.Slice.prototype.$type, new $.ig.PropertyMetadata(2, new $.ig.Point(0), function (o, e) { ($.ig.util.cast($.ig.Slice.prototype.$type, o)).createShape(); }));
$.ig.Slice.prototype.radiusPropertyName = "Radius";
$.ig.Slice.prototype.radiusProperty = $.ig.DependencyProperty.prototype.register($.ig.Slice.prototype.radiusPropertyName, Number, $.ig.Slice.prototype.$type, new $.ig.PropertyMetadata(2, 0, function (o, e) { ($.ig.util.cast($.ig.Slice.prototype.$type, o)).createShape(); }));
$.ig.Slice.prototype.explodedRadiusPropertyName = "ExplodedRadius";
$.ig.Slice.prototype.explodedRadiusProperty = $.ig.DependencyProperty.prototype.register($.ig.Slice.prototype.explodedRadiusPropertyName, Number, $.ig.Slice.prototype.$type, new $.ig.PropertyMetadata(2, 0, function (o, e) { ($.ig.util.cast($.ig.Slice.prototype.$type, o)).createShape(); }));
$.ig.Slice.prototype.indexPropertyName = "Index";
$.ig.Slice.prototype.indexProperty = $.ig.DependencyProperty.prototype.register($.ig.Slice.prototype.indexPropertyName, $.ig.Number.prototype.$type, $.ig.Slice.prototype.$type, new $.ig.PropertyMetadata(2, -1, function (o, e) { ($.ig.util.cast($.ig.Slice.prototype.$type, o)).createShape(); }));
$.ig.Slice.prototype.strokeThicknessPropertyName = "StrokeThickness";
$.ig.Slice.prototype.strokeThicknessProperty = $.ig.DependencyProperty.prototype.register($.ig.Slice.prototype.strokeThicknessPropertyName, Number, $.ig.Slice.prototype.$type, new $.ig.PropertyMetadata(2, 1, function (o, e) { ($.ig.util.cast($.ig.Slice.prototype.$type, o)).createShape(); }));










$.ig.SeriesViewerSurfaceViewer.prototype._zoomLevelPropertyName = "ZoomLevel";
$.ig.SeriesViewerSurfaceViewer.prototype.zoomLevelProperty = $.ig.DependencyProperty.prototype.register("ZoomLevel", Number, $.ig.SeriesViewerSurfaceViewer.prototype.$type, new $.ig.PropertyMetadata(2, 0, function (sender, e) {
	($.ig.util.cast($.ig.SeriesViewerSurfaceViewer.prototype.$type, sender)).onPropertyChanged($.ig.SeriesViewerSurfaceViewer.prototype._zoomLevelPropertyName, e.oldValue(), e.newValue());
}));
$.ig.SeriesViewerSurfaceViewer.prototype._zoomLevelDisplayTextPropertyName = "ZoomLevelDisplayText";


$.ig.TileZoomManager.prototype.tileSize = 512;
$.ig.TileZoomManager.prototype._maxAllowedSkew = 3;









} (jQuery));



// Declare empty types
$.ig = $.ig || {};
(function ($) {
var $$t = {}
$.ig.$currDefinitions = $$t;
$.ig.util.bulkDefine(["HorizontalLinearScaler:b", 
"LinearScaler:c", 
"NumericScaler:d", 
"DependencyObject:e", 
"Object:f", 
"Type:g", 
"Boolean:h", 
"ValueType:i", 
"Void:j", 
"IConvertible:k", 
"IFormatProvider:l", 
"Number:m", 
"String:n", 
"IComparable:o", 
"Number:p", 
"Number:q", 
"Number:r", 
"Number:s", 
"NumberStyles:t", 
"Enum:u", 
"Array:v", 
"IList:w", 
"ICollection:x", 
"IEnumerable:y", 
"IEnumerator:z", 
"Number:aa", 
"String:ab", 
"StringComparison:ac", 
"RegExp:ad", 
"CultureInfo:ae", 
"Calendar:af", 
"Date:ag", 
"DayOfWeek:ah", 
"DateTimeKind:ai", 
"Date:aj", 
"Error:ak", 
"CompareInfo:al", 
"CompareOptions:am", 
"NumberFormatInfo:an", 
"DateTimeFormatInfo:ao", 
"CalendarWeekRule:ap", 
"IEnumerable$1:aq", 
"IEnumerator$1:ar", 
"IDisposable:as", 
"StringSplitOptions:at", 
"Number:au", 
"Number:av", 
"Number:aw", 
"Number:ax", 
"Number:ay", 
"Number:az", 
"Assembly:a0", 
"Stream:a1", 
"SeekOrigin:a2", 
"RuntimeTypeHandle:a3", 
"MethodInfo:a4", 
"MethodBase:a5", 
"MemberInfo:a6", 
"ParameterInfo:a7", 
"TypeCode:a8", 
"ConstructorInfo:a9", 
"PropertyInfo:ba", 
"Dictionary:bb", 
"DependencyProperty:bc", 
"PropertyMetadata:bd", 
"PropertyChangedCallback:be", 
"MulticastDelegate:bf", 
"IntPtr:bg", 
"DependencyPropertyChangedEventArgs:bh", 
"UnsetValue:bi", 
"DependencyPropertiesCollection:bj", 
"Script:bk", 
"Binding:bl", 
"PropertyPath:bm", 
"NumericAxisBase:bn", 
"Axis:bo", 
"Control:bp", 
"FrameworkElement:bq", 
"UIElement:br", 
"Transform:bs", 
"Visibility:bt", 
"Style:bu", 
"Thickness:bv", 
"HorizontalAlignment:bw", 
"VerticalAlignment:bx", 
"INotifyPropertyChanged:by", 
"PropertyChangedEventHandler:bz", 
"PropertyChangedEventArgs:b0", 
"AxisView:b1", 
"ISchedulableRender:b2", 
"Path:b3", 
"Shape:b4", 
"Brush:b5", 
"Color:b6", 
"Math:b7", 
"ArgumentException:b8", 
"NotImplementedException:b9", 
"Nullable$1:ca", 
"DoubleCollection:cb", 
"List$1:cc", 
"IList$1:cd", 
"ICollection$1:ce", 
"IArray:cf", 
"Enumerable:cg", 
"Func$2:ch", 
"Func$3:ci", 
"IOrderedEnumerable$1:cj", 
"SortedList$1:ck", 
"ArgumentNullException:cl", 
"IArrayList:cm", 
"Array:cn", 
"CompareCallback:co", 
"Action$1:cp", 
"Comparer$1:cq", 
"IComparer:cr", 
"IComparer$1:cs", 
"DefaultComparer$1:ct", 
"IComparable$1:cu", 
"Comparison$1:cv", 
"ReadOnlyCollection$1:cw", 
"Predicate$1:cx", 
"Geometry:cy", 
"GeometryType:cz", 
"XamDataChart:c0", 
"SeriesViewer:c1", 
"SeriesViewerView:c2", 
"CanvasRenderScheduler:c3", 
"Callback:c4", 
"window:c5", 
"RenderingContext:c6", 
"IRenderer:c7", 
"Rectangle:c8", 
"Rect:c9", 
"Size:da", 
"Point:db", 
"TextBlock:dc", 
"Polygon:dd", 
"PointCollection:de", 
"Polyline:df", 
"DataTemplateRenderInfo:dg", 
"DataTemplatePassInfo:dh", 
"ContentControl:di", 
"DataTemplate:dj", 
"DataTemplateRenderHandler:dk", 
"DataTemplateMeasureHandler:dl", 
"DataTemplateMeasureInfo:dm", 
"DataTemplatePassHandler:dn", 
"Line:dp", 
"XamOverviewPlusDetailPane:dq", 
"XamOverviewPlusDetailPaneView:dr", 
"XamOverviewPlusDetailPaneViewManager:ds", 
"JQueryObject:dt", 
"Element:du", 
"ElementAttributeCollection:dv", 
"ElementCollection:dw", 
"WebStyle:dx", 
"ElementNodeType:dy", 
"Document:dz", 
"EventListener:d0", 
"IElementEventHandler:d1", 
"ElementEventHandler:d2", 
"ElementAttribute:d3", 
"JQueryPosition:d4", 
"JQueryCallback:d5", 
"JQueryEvent:d6", 
"JQueryUICallback:d7", 
"EventProxy:d8", 
"ModifierKeys:d9", 
"MouseWheelHandler:ea", 
"Delegate:eb", 
"Interlocked:ec", 
"GestureHandler:ed", 
"ContactHandler:ee", 
"TouchHandler:ef", 
"MouseOverHandler:eg", 
"MouseHandler:eh", 
"KeyHandler:ei", 
"Key:ej", 
"JQuery:ek", 
"JQueryDeferred:el", 
"JQueryPromise:em", 
"Action:en", 
"CanvasViewRenderer:eo", 
"CanvasContext2D:ep", 
"CanvasContext:eq", 
"TextMetrics:er", 
"ImageData:es", 
"CanvasElement:et", 
"Gradient:eu", 
"LinearGradientBrush:ev", 
"GradientStop:ew", 
"GeometryGroup:ex", 
"GeometryCollection:ey", 
"FillRule:ez", 
"PathGeometry:e0", 
"PathFigureCollection:e1", 
"LineGeometry:e2", 
"RectangleGeometry:e3", 
"EllipseGeometry:e4", 
"ArcSegment:e5", 
"PathSegment:e6", 
"PathSegmentType:e7", 
"SweepDirection:e8", 
"PathFigure:e9", 
"PathSegmentCollection:fa", 
"LineSegment:fb", 
"PolyLineSegment:fc", 
"BezierSegment:fd", 
"PolyBezierSegment:fe", 
"GeometryUtil:ff", 
"Tuple$2:fg", 
"TransformGroup:fh", 
"TransformCollection:fi", 
"TranslateTransform:fj", 
"RotateTransform:fk", 
"ScaleTransform:fl", 
"DivElement:fm", 
"DOMEventProxy:fn", 
"MSGesture:fo", 
"MouseEventArgs:fp", 
"EventArgs:fq", 
"DoubleAnimator:fr", 
"EasingFunctionHandler:fs", 
"ImageElement:ft", 
"RectUtil:fu", 
"MathUtil:fv", 
"RuntimeHelpers:fw", 
"RuntimeFieldHandle:fx", 
"PropertyChangedEventArgs$1:fy", 
"InteractionState:fz", 
"OverviewPlusDetailPaneMode:f0", 
"IOverviewPlusDetailControl:f1", 
"EventHandler$1:f2", 
"OverviewPlusDetailViewportHost:f3", 
"IProvidesViewport:f4", 
"SeriesCollection:f5", 
"ObservableCollection$1:f6", 
"INotifyCollectionChanged:f7", 
"NotifyCollectionChangedEventHandler:f8", 
"NotifyCollectionChangedEventArgs:f9", 
"NotifyCollectionChangedAction:ga", 
"AxisCollection:gb", 
"SeriesViewerViewManager:gc", 
"AxisTitlePosition:gd", 
"PointerTooltipStyle:ge", 
"Dictionary$2:gf", 
"IDictionary$2:gg", 
"IDictionary:gh", 
"IEqualityComparer$1:gi", 
"EqualityComparer$1:gj", 
"IEqualityComparer:gk", 
"DefaultEqualityComparer$1:gl", 
"InvalidOperationException:gm", 
"KeyValuePair$2:gn", 
"BrushCollection:go", 
"InterpolationMode:gp", 
"Random:gq", 
"ColorUtil:gr", 
"CssHelper:gs", 
"CssGradientUtil:gt", 
"FontUtil:gu", 
"FontInfo:gv", 
"TileZoomTile:gw", 
"TileZoomTileInfo:gx", 
"TileZoomTileCache:gy", 
"TileZoomManager:gz", 
"RectChangedEventHandler:g0", 
"RectChangedEventArgs:g1", 
"Debug:g2", 
"TileZoomInfo:g3", 
"LinkedList$1:g4", 
"LinkedListNode$1:g5", 
"RenderSurface:g6", 
"Series:g7", 
"SeriesView:g8", 
"DataContext:g9", 
"SeriesComponentsFromView:ha", 
"EasingFunctions:hb", 
"LegendTemplates:hc", 
"PieChartBase:hd", 
"PieChartBaseView:he", 
"PieChartViewManager:hf", 
"BrushUtil:hg", 
"PieChartVisualData:hh", 
"PieSliceVisualDataList:hi", 
"PieSliceVisualData:hj", 
"PrimitiveAppearanceData:hk", 
"IVisualData:hl", 
"BrushAppearanceData:hm", 
"StringBuilder:hn", 
"Environment:ho", 
"AppearanceHelper:hp", 
"LinearGradientBrushAppearanceData:hq", 
"GradientStopAppearanceData:hr", 
"SolidBrushAppearanceData:hs", 
"EllipseGeometryData:ht", 
"GeometryData:hu", 
"GetPointsSettings:hv", 
"RectangleGeometryData:hw", 
"LineGeometryData:hx", 
"PathGeometryData:hy", 
"PathFigureData:hz", 
"LineSegmentData:h0", 
"SegmentData:h1", 
"PolylineSegmentData:h2", 
"ArcSegmentData:h3", 
"PolyBezierSegmentData:h4", 
"LabelAppearanceData:h5", 
"PathVisualData:h6", 
"PrimitiveVisualData:h7", 
"ShapeTags:h8", 
"PieSliceDataContext:h9", 
"Slice:ia", 
"SliceView:ib", 
"PieLabel:ic", 
"MouseButtonEventArgs:id", 
"FastItemsSource:ie", 
"IFastItemsSource:ig", 
"IFastItemColumn$1:ih", 
"IFastItemColumnPropertyName:ii", 
"IFastItemColumnInternal:ij", 
"FastItemsSourceEventAction:ik", 
"FastItemsSourceEventArgs:il", 
"ColumnReference:im", 
"FastItemDateTimeColumn:io", 
"FastItemColumn:ip", 
"FastReflectionHelper:iq", 
"FastItemObjectColumn:ir", 
"FastItemIntColumn:is", 
"LabelsPosition:it", 
"LeaderLineType:iu", 
"OthersCategoryType:iv", 
"IndexCollection:iw", 
"LegendBase:ix", 
"LegendBaseView:iy", 
"LegendBaseViewManager:iz", 
"GradientData:i0", 
"GradientStopData:i1", 
"DataChartLegendMouseButtonEventArgs:i2", 
"DataChartMouseButtonEventArgs:i3", 
"ChartLegendMouseEventArgs:i4", 
"ChartMouseEventArgs:i5", 
"PropertyUpdatedEventHandler:i6", 
"PropertyUpdatedEventArgs:i7", 
"DataChartLegendMouseButtonEventHandler:i8", 
"DataChartLegendMouseEventHandler:i9", 
"PieChartFormatLabelHandler:ja", 
"Pool$1:jb", 
"IIndexedPool$1:jc", 
"IPool$1:jd", 
"Func$1:je", 
"SliceClickEventHandler:jf", 
"SliceClickEventArgs:jg", 
"ItemLegend:jh", 
"ItemLegendView:ji", 
"LegendItemInfo:jj", 
"BubbleSeries:jk", 
"ScatterBase:jl", 
"MarkerSeries:jm", 
"MarkerSeriesView:jn", 
"Marker:jo", 
"MarkerTemplates:jp", 
"HashPool$2:jq", 
"IHashPool$2:jr", 
"MarkerType:js", 
"SeriesVisualData:jt", 
"PrimitiveVisualDataList:ju", 
"PointerTooltipVisualDataList:jv", 
"MarkerVisualDataList:jw", 
"MarkerVisualData:jx", 
"PointerTooltipVisualData:jy", 
"RectangleVisualData:jz", 
"PolygonVisualData:j0", 
"PolyLineVisualData:j1", 
"ISupportsErrorBars:j2", 
"ScatterBaseView:j3", 
"MarkerManagerBase:j4", 
"MarkerManagerBucket:j5", 
"ArrayUtil:j6", 
"ScatterTrendLineManager:j7", 
"TrendLineManagerBase$1:j8", 
"TrendLineType:j9", 
"Clipper:ka", 
"EdgeClipper:kb", 
"LeftClipper:kc", 
"BottomClipper:kd", 
"RightClipper:ke", 
"TopClipper:kf", 
"TrendResolutionParams:kg", 
"Flattener:kh", 
"Stack$1:ki", 
"ReverseArrayEnumerator$1:kj", 
"SpiralTodo:kk", 
"Canvas:kl", 
"Panel:km", 
"UIElementCollection:kn", 
"TrendFitCalculator:ko", 
"LeastSquaresFit:kp", 
"Numeric:kq", 
"TrendAverageCalculator:kr", 
"NumericMarkerManager:ks", 
"OwnedPoint:kt", 
"CollisionAvoidanceType:ku", 
"SmartPlacer:kv", 
"ISmartPlaceable:kw", 
"SmartPosition:kx", 
"SmartPlaceableWrapper$1:ky", 
"ScatterAxisInfoCache:kz", 
"NumericXAxis:k0", 
"StraightNumericAxisBase:k1", 
"StraightNumericAxisBaseView:k2", 
"NumericAxisBaseView:k3", 
"NumericScaleMode:k4", 
"LogarithmicScaler:k5", 
"AutoRangeCalculator:k6", 
"AxisRange:k7", 
"IEquatable$1:k8", 
"NumericYAxis:k9", 
"IScaler:la", 
"ScalerParams:lb", 
"AxisOrientation:lc", 
"NumericYAxisView:ld", 
"AxisLabelPanelBase:le", 
"AxisLabelPanelBaseView:lf", 
"AxisLabelSettings:lg", 
"AxisLabelsLocation:lh", 
"PathRenderingInfo:li", 
"CategoryAxisBase:lj", 
"ICategoryScaler:lk", 
"CategoryMode:ll", 
"CategoryAxisBaseView:lm", 
"IFastItemsSourceProvider:ln", 
"IHasCategoryModePreference:lo", 
"IHasCategoryAxis:lp", 
"AxisRangeChangedEventArgs:lq", 
"CategorySeries:lr", 
"CategoryFramePreparer:ls", 
"CategoryFramePreparerBase:lt", 
"FramePreparer:lu", 
"ISupportsMarkers:lv", 
"DefaultSupportsMarkers:lw", 
"DefaultProvidesViewport:lx", 
"DefaultSupportsErrorBars:ly", 
"Frame:lz", 
"IBucketizer:l0", 
"IIsCategoryBased:l1", 
"IDetectsCollisions:l2", 
"CategoryFrame:l3", 
"PreparationParams:l4", 
"ISortingAxis:l5", 
"FragmentBase:l6", 
"HorizontalAnchoredCategorySeries:l7", 
"AnchoredCategorySeries:l8", 
"IHasSingleValueCategory:l9", 
"IHasCategoryTrendline:ma", 
"IHasTrendline:mb", 
"IPreparesCategoryTrendline:mc", 
"AnchoredCategorySeriesView:md", 
"CategorySeriesView:me", 
"CategoryBucketCalculator:mf", 
"CategoryTrendLineManagerBase:mg", 
"Func$4:mh", 
"SortingTrendLineManager:mi", 
"CategoryTrendLineManager:mj", 
"AnchoredCategoryBucketCalculator:mk", 
"CategoryDateTimeXAxis:ml", 
"CategoryDateTimeXAxisView:mm", 
"TimeAxisDisplayType:mn", 
"SmartAxisLabelPanel:mo", 
"AxisExtentType:mp", 
"SmartAxisLabelPanelView:mq", 
"LabelPosition:mr", 
"HorizontalAxisLabelPanel:ms", 
"HorizontalAxisLabelPanelBase:mt", 
"HorizontalAxisLabelPanelBaseView:mu", 
"LinearNumericSnapper:mv", 
"Snapper:mw", 
"CoercionInfo:mx", 
"SortedListView$1:my", 
"CategoryLineRasterizer:mz", 
"UnknownValuePlotting:m0", 
"Action$5:m1", 
"PenLineCap:m2", 
"SyncLink:m3", 
"ChartCollection:m4", 
"FastItemsSourceReference:m5", 
"SyncManager:m6", 
"SyncSettings:m7", 
"SyncLinkManager:m8", 
"CategoryMarkerManager:m9", 
"CollisionAvoider:na", 
"StackedFragmentSeries:nb", 
"StackedSeriesBase:nc", 
"StackedSeriesView:nd", 
"StackedBucketCalculator:ne", 
"StackedSeriesManager:nf", 
"StackedSeriesCollection:ng", 
"StackedLineSeries:nh", 
"HorizontalStackedSeriesBase:ni", 
"XamDataChartView:nj", 
"LineFragment:nk", 
"LineFragmentView:nl", 
"LineFragmentBucketCalculator:nm", 
"IStacked100Series:nn", 
"StackedColumnSeries:no", 
"StackedColumnSeriesView:np", 
"StackedColumnBucketCalculator:nq", 
"ColumnFragment:nr", 
"ColumnFragmentView:ns", 
"StackedBarSeries:nt", 
"VerticalStackedSeriesBase:nu", 
"CategoryYAxis:nv", 
"CategoryYAxisView:nw", 
"VerticalAxisLabelPanel:nx", 
"VerticalAxisLabelPanelView:ny", 
"TitleSettings:nz", 
"LinearCategorySnapper:n0", 
"IBarSeries:n1", 
"StackedBarSeriesView:n2", 
"StackedBarBucketCalculator:n3", 
"BarFragment:n4", 
"StackedAreaSeries:n5", 
"AreaFragment:n6", 
"AreaFragmentView:n7", 
"AreaFragmentBucketCalculator:n8", 
"StackedSplineSeries:n9", 
"SplineFragment:oa", 
"SplineFragmentBase:ob", 
"SplineSeriesBase:oc", 
"SplineSeriesBaseView:od", 
"SplineType:oe", 
"SafeSortedReadOnlyDoubleCollection:of", 
"SafeReadOnlyDoubleCollection:og", 
"SafeEnumerable:oh", 
"SplineFragmentView:oi", 
"SplineFragmentBucketCalculator:oj", 
"StackedSplineAreaSeries:ok", 
"SplineAreaFragment:ol", 
"SplineAreaFragmentView:om", 
"StackedSeriesFramePreparer:on", 
"ValuesHolder:oo", 
"SingleValuesHolder:op", 
"StackedSeriesCreatedEventHandler:oq", 
"StackedSeriesCreatedEventArgs:or", 
"StackedSeriesVisualData:os", 
"SeriesVisualDataList:ot", 
"LineSeries:ou", 
"LineSeriesView:ov", 
"CategorySeriesRenderManager:ow", 
"AssigningCategoryStyleEventArgs:ox", 
"AssigningCategoryStyleEventArgsBase:oy", 
"GetCategoryItemsHandler:oz", 
"HighlightingInfo:o0", 
"HighlightingState:o1", 
"AssigningCategoryMarkerStyleEventArgs:o2", 
"HighlightingManager:o3", 
"AreaSeries:o4", 
"AreaSeriesView:o5", 
"CategoryTransitionInMode:o6", 
"StepLineSeries:o7", 
"StepLineSeriesView:o8", 
"StepAreaSeries:o9", 
"StepAreaSeriesView:pa", 
"RangeAreaSeries:pb", 
"HorizontalRangeCategorySeries:pc", 
"RangeCategorySeries:pd", 
"IHasHighLowValueCategory:pe", 
"RangeCategorySeriesView:pf", 
"RangeCategoryBucketCalculator:pg", 
"RangeCategoryFramePreparer:ph", 
"DefaultCategoryTrendlineHost:pi", 
"DefaultCategoryTrendlinePreparer:pj", 
"DefaultHighLowValueProvider:pk", 
"HighLowValuesHolder:pl", 
"RangeValueList:pm", 
"RangeAreaSeriesView:pn", 
"DefaultSingleValueProvider:po", 
"CategoryTransitionSourceFramePreparer:pp", 
"TransitionInSpeedType:pq", 
"AssigningCategoryStyleEventHandler:pr", 
"AssigningCategoryMarkerStyleEventHandler:ps", 
"SeriesComponentsForView:pt", 
"TickmarkValues:pu", 
"TickmarkValuesInitializationParameters:pv", 
"GetGroupCenterHandler:pw", 
"GetUnscaledGroupCenterHandler:px", 
"NumericAxisRenderer:py", 
"AxisRendererBase:pz", 
"ShouldRenderHandler:p0", 
"ScaleValueHandler:p1", 
"AxisRenderingParametersBase:p2", 
"RangeInfo:p3", 
"RenderStripHandler:p4", 
"RenderLineHandler:p5", 
"ShouldRenderLinesHandler:p6", 
"ShouldRenderContentHandler:p7", 
"RenderAxisLineHandler:p8", 
"DetermineCrossingValueHandler:p9", 
"ShouldRenderLabelHandler:qa", 
"GetLabelLocationHandler:qb", 
"TransformToLabelValueHandler:qc", 
"AxisLabelManager:qd", 
"GetLabelForItemHandler:qe", 
"CreateRenderingParamsHandler:qf", 
"SnapMajorValueHandler:qg", 
"AdjustMajorValueHandler:qh", 
"CategoryAxisRenderingParameters:qi", 
"NumericAxisRenderingParameters:qj", 
"VerticalLogarithmicScaler:qk", 
"VerticalLinearScaler:ql", 
"NumericRadiusAxis:qm", 
"NumericRadiusAxisView:qn", 
"PolarAxisRenderingManager:qo", 
"ViewportUtils:qp", 
"PolarAxisRenderingParameters:qq", 
"IPolarRadialRenderingParameters:qr", 
"RadialAxisRenderingParameters:qs", 
"RadialAxisLabelPanel:qt", 
"RadialAxisLabelPanelView:qu", 
"NumericAngleAxis:qv", 
"IAngleScaler:qw", 
"NumericAngleAxisView:qx", 
"AngleAxisLabelPanel:qy", 
"AngleAxisLabelPanelView:qz", 
"Extensions:q0", 
"CategoryAngleAxis:q1", 
"CategoryAngleAxisView:q2", 
"CategoryAxisRenderer:q3", 
"CategoryTickmarkValues:q4", 
"LogarithmicTickmarkValues:q5", 
"LogarithmicNumericSnapper:q6", 
"LinearTickmarkValues:q7", 
"NumericXAxisView:q8", 
"HorizontalLogarithmicScaler:q9", 
"ScatterErrorBarSettings:ra", 
"ErrorBarSettingsBase:rb", 
"EnableErrorBars:rc", 
"ErrorBarCalculatorReference:rd", 
"IErrorBarCalculator:re", 
"ErrorBarCalculatorType:rf", 
"ScatterFrame:rg", 
"ScatterFrameBase$1:rh", 
"DictInterpolator$3:ri", 
"Action$6:rj", 
"ErrorBarsHelper:rk", 
"BubbleSeriesView:rl", 
"BubbleMarkerManager:rm", 
"SizeScale:rn", 
"BrushScale:ro", 
"ScaleLegend:rp", 
"ScaleLegendView:rq", 
"CustomPaletteBrushScale:rr", 
"BrushSelectionMode:rs", 
"ValueBrushScale:rt", 
"RingSeriesBase:ru", 
"XamDoughnutChart:rv", 
"RingCollection:rw", 
"Ring:rx", 
"RingControl:ry", 
"RingControlView:rz", 
"Arc:r0", 
"ArcView:r1", 
"ArcItem:r2", 
"SliceItem:r3", 
"Legend:r4", 
"LegendView:r5", 
"BarSeries:r6", 
"VerticalAnchoredCategorySeries:r7", 
"BarSeriesView:r8", 
"BarTrendLineManager:r9", 
"BarTrendFitCalculator:sa", 
"BarBucketCalculator:sb", 
"BarFramePreparer:sc", 
"RingSeriesBaseView:sd", 
"RingSeriesCollection:se", 
"SliceCollection:sf", 
"XamDoughnutChartView:sg", 
"Action$2:sh", 
"DoughnutChartVisualData:si", 
"RingSeriesVisualDataList:sj", 
"RingSeriesVisualData:sk", 
"RingVisualDataList:sl", 
"RingVisualData:sm", 
"ArcVisualDataList:sn", 
"ArcVisualData:so", 
"SliceVisualDataList:sp", 
"SliceVisualData:sq", 
"DoughnutChartLabelVisualData:sr", 
"HoleDimensionsChangedEventHandler:ss", 
"HoleDimensionsChangedEventArgs:st", 
"FunnelSliceDataContext:su", 
"XamFunnelChart:sv", 
"IItemProvider:sw", 
"Array:s3", 
"XamFunnelConnector:s4", 
"XamFunnelController:s5", 
"SliceInfoList:s6", 
"SliceInfoUnaryComparison:s7", 
"SliceInfo:s8", 
"SliceAppearance:s9", 
"PointList:ta", 
"FunnelSliceVisualData:tb", 
"Bezier:tc", 
"Array:td", 
"BezierPoint:te", 
"BezierOp:tf", 
"BezierPointComparison:tg", 
"DoubleColumn:th", 
"ObjectColumn:ti", 
"XamFunnelView:tj", 
"IOuterLabelWidthDecider:tk", 
"IFunnelLabelSizeDecider:tl", 
"MouseButtonMessage:tp", 
"MouseButtonAction:tq", 
"MouseButtonType:tr", 
"SetAreaSizeMessage:ts", 
"RenderSliceMessage:tu", 
"RenderOuterLabelMessage:tv", 
"TooltipValueChangedMessage:tw", 
"TooltipUpdateMessage:tx", 
"FunnelDataContext:ty", 
"ClearTooltipMessage:t2", 
"ViewPropertyChangedMessage:t5", 
"OuterLabelAlignment:t6", 
"FunnelSliceDisplay:t7", 
"SliceSelectionManager:t8", 
"DataUpdatedMessage:t9", 
"ItemsSourceAction:ua", 
"DictionaryEntry:ub", 
"FunnelFrame:uc", 
"UserSelectedItemsChangedMessage:ud", 
"LabelSizeChangedMessage:ue", 
"FrameRenderCompleteMessage:uf", 
"IntColumn:ug", 
"IntColumnComparison:uh", 
"Convert:ui", 
"SelectedItemsChangedMessage:uj", 
"ModelUpdateMessage:uk", 
"SliceClickedMessage:ul", 
"FunnelSliceClickedEventHandler:um", 
"FunnelSliceClickedEventArgs:un", 
"FunnelChartVisualData:uo", 
"FunnelSliceVisualDataList:up", 
"RingSeries:uq", 
"WaterfallSeries:ur", 
"WaterfallSeriesView:us", 
"FinancialSeries:ut", 
"FinancialSeriesView:uu", 
"FinancialBucketCalculator:uv", 
"FinancialValueList:uw", 
"FinancialEventHandler:ux", 
"FinancialEventArgs:uy", 
"FinancialCalculationDataSource:uz", 
"CalculatedColumn:u0", 
"FinancialCalculationSupportingCalculations:u1", 
"ColumnSupportingCalculation:u2", 
"SupportingCalculation$1:u3", 
"SupportingCalculationStrategy:u4", 
"DataSourceSupportingCalculation:u5", 
"ProvideColumnValuesStrategy:u6", 
"ContentInfo:u7", 
"ChartContentManager:u8", 
"ChartContentType:u9", 
"RenderRequestedEventArgs:va", 
"TrendCalculators:vb", 
"SeriesViewerComponentsFromView:vc", 
"SeriesViewerSurfaceViewer:vd", 
"LabelPanelArranger:ve", 
"LabelPanelsArrangeState:vf", 
"ChartVisualData:vg", 
"AxisVisualDataList:vh", 
"ChartTitleVisualData:vi", 
"VisualDataSerializer:vj", 
"AxisVisualData:vk", 
"AxisLabelVisualDataList:vl", 
"AxisLabelVisualData:vm", 
"VisualExportHelper:vn", 
"WindowResponse:vo", 
"SeriesViewerComponentsForView:vp", 
"DataChartCursorEventHandler:vq", 
"ChartCursorEventArgs:vr", 
"DataChartMouseButtonEventHandler:vs", 
"DataChartMouseEventHandler:vt", 
"AnnotationLayer:vu", 
"AnnotationLayerView:vv", 
"RefreshCompletedEventHandler:vw", 
"GridMode:vx", 
"AxisRangeChangedEventHandler:vy", 
"DataChartAxisRangeChangedEventHandler:vz", 
"ChartAxisRangeChangedEventArgs:v0", 
"RadialBase:v1", 
"RadialBaseView:v2", 
"RadialBucketCalculator:v3", 
"SeriesRenderer$2:v4", 
"SeriesRenderingArguments:v5", 
"RadialFrame:v6", 
"RadialAxes:v7", 
"PolarBase:v8", 
"PolarBaseView:v9", 
"PolarTrendLineManager:wa", 
"PolarLinePlanner:wb", 
"AngleRadiusPair:wc", 
"PolarAxisInfoCache:wd", 
"PolarFrame:we", 
"PolarAxes:wf", 
"AxisComponentsForView:wg", 
"AxisComponentsFromView:wh", 
"AxisFormatLabelHandler:wi", 
"AbstractEnumerable:z1", 
"AbstractEnumerator:z2", 
"GenericEnumerable$1:z3", 
"GenericEnumerator$1:z4"]);
























































































































} (jQuery));



/*!@license
* Infragistics.Web.ClientUI common DV widget localization resources 14.2.20142.1018
*
* Copyright (c) 2011-2014 Infragistics Inc.
*
* http://www.infragistics.com/
*
*/

/*global jQuery */
(function ($) {
    $.ig = $.ig || {};

    if (!$.ig.Chart) {
	    $.ig.Chart = {};

	    $.extend($.ig.Chart, {

		    locale: {
			    seriesName: "must specify series name option when setting options.",
			    axisName: "must specify axis name option when setting options.",
			    invalidLabelBinding: "There is no such value for the labels to bind.",
			    close: "Close",
			    overview: "Overview",
			    zoomOut: "Zoom Out",
			    zoomIn: "Zoom In",
			    resetZoom: "Reset Zoom"
		    }
	    });

    }
})(jQuery);


/*!@license
 * Infragistics.Web.ClientUI charting and map common widget 14.2.20142.1018
 *
 * Copyright (c) 2011-2014 Infragistics Inc.
 *
 * http://www.infragistics.com/
 *
 * Depends on: 
 *	jquery-1.4.4.js
 *	jquery.ui.core.js
 *	jquery.ui.widget.js
 *	infragistics.dataSource.js
 *	infragistics.templating.js (Optional)
 *	infragistics.util.js
 */
/*global jQuery, Class, window, ActiveXObject, DOMParser, XPathResult, define */
(function ($) {

    $.ig.dvCommonWidget = $.ig.dvCommonWidget || Class.extend({
        init: function (widget) {
            this.widget = widget;
        },

        _createWidget: function (options, element, widget) {
            var self = this;
            this.widget = widget;
            this.widget._duringInit = true;

            options = $.extend(false, {}, options);
            this.widget._creationOptions = options;
            this.widget._defaultOptions = this.widget.options;
            this.widget.options = {};

            if ((options.dataSource && $.type(options.dataSource) === "array") || ($.type(options.dataSource) === "object" && (typeof options.dataSource._xmlToArray !== "function" || typeof options.dataSource._encodePkParams !== "function"))) {
                this.widget._initialDataSource = options.dataSource;
                options.dataSource = null;
            }
            this.widget._initialSeriesDataSource = {};
            this.widget._initialAxesDataSource = {};

            if (options.series) {
                options.series = options.series.slice(0);
                $.each(options.series, function (i, val) {
                    if ((val.name && val.dataSource && $.type(val.dataSource) === "array") || ($.type(val.dataSource) === "object" && (typeof val.dataSource._xmlToArray !== "function" || typeof val.dataSource._encodePkParams !== "function"))) {
                        self.widget._initialSeriesDataSource[val.name] = val.dataSource;
                        val.dataSource = null;
                    }
                });
            }
            if (options.axes) {
                options.axes = options.axes.slice(0);
                $.each(options.axes, function (i, val) {
                    if ((val.name && val.dataSource && $.type(val.dataSource) === "array") || ($.type(val.dataSource) === "object" && (typeof val.dataSource._xmlToArray !== "function" || typeof val.dataSource._encodePkParams !== "function"))) {
                        self.widget._initialAxesDataSource[val.name] = val.dataSource;
                        val.dataSource = null;
                    }
                });
            }

            switch (this.widget.widgetName) {
                case "igDataChart":
                    this.widget._axisTemplate = $.extend(false, {}, {});
                    this.widget._seriesTemplate = $.extend(false, {}, {});
                    //this.widget.options.legend = null;
                    //this.widget.options.series[0].legend = null;
                    if (options.series === undefined) {
                        options.series = [];
                    }
                    if (options.axes === undefined) {
                        options.axes = [];
                    }
                    break;
                case "igPieChart":
                    break;
                case "igMap":
                    this.widget._seriesTemplate = $.extend(false, {}, {});
                    if (options.series === undefined) {
                        options.series = [];
                    }
                    this.widget.options.backgroundContent = null;
                    break;
            }

            $.Widget.prototype._createWidget.apply(this.widget, [options, element]);

            /* VS 03/14/2013 Bug 135879 */
            // note: that block can not be before base call: objects (legend) of multi-stacked series can be broken
            //var a = widget.options.series;
            //if (a && a.length === 1 && !a[0].name && !a[0].type) {
            //    a.pop();
            //}
            //a = widget.options.axis;
            //if (a && a.length === 1 && !a[0].name && !a[0].type) {
            //    a.pop();
            //}
        },

        option: function (key, value) {
            var val = $.Widget.prototype.option.apply(this.widget, arguments);
            if (val === undefined) {
                if (typeof key == "string") {
                    if (value === undefined) {
                        return this.widget._defaultOptions[key];
                    }
                }
            }
            return val;
        },

        _create: function () {
            var widget = this.widget;
            if (!$.ig.util._isCanvasSupported()) {
                $.ig.util._renderUnsupportedBrowser(widget);
            } else {
                this.widget._notInitialized = true;
                if (widget._initialDataSource) {
                    widget._creationOptions.dataSource = this.widget._initialDataSource;
                    widget.options.dataSource = this.widget._initialDataSource;
                }

                if (widget.options.series) {
                    $.each(widget.options.series, function (i, val) {
                        if (val.name && widget._initialSeriesDataSource[val.name] !== undefined) {
                            val.dataSource = widget._initialSeriesDataSource[val.name];
                        }
                    });
                }
                if (widget.options.axes) {
                    $.each(widget.options.axes, function (i, val) {
                        if (val.name && widget._initialAxesDataSource[val.name] !== undefined) {
                            val.dataSource = widget._initialAxesDataSource[val.name];
                        }
                    });
                }

                widget._pendingCrossingAxes = [];
                widget._tooltipTemplate = null;
                widget._tooltipTtemplates = null;
                widget._tooltip = {};
                this.widget._tooltipTemplates = {};

                switch (this.widget.widgetName) {
                    case "igDataChart":
                        widget._chart = new $.ig.XamDataChart();
                        widget._chart.manageDataSources(true);
                        widget._axes = {};
                        widget._series = {};
                        widget._axisOpt = {};
                        widget._seriesOpt = {};
                        widget._seriesSubOpt = {};
                        widget._seriesSub = {};
                        this._bindDataChartEvents(widget._chart);
                        this._renderChartContainer(this.widget);
                        this._initialDataBind();
                        break;
                    case "igPieChart":
                        widget._chart = new $.ig.XamPieChart();
                        // widget._chart.manageDataSources(true);
                        this._bindPieChartEvents(widget._chart);
                        this._renderChartContainer(this.widget);
                        this._initialDataBind();
                        break;
                    case "igMap":
                        widget._chart = new $.ig.XamGeographicMap();
                        widget._chart.manageDataSources(true);
                        widget._axes = {};
                        widget._series = {};
                        widget._axisOpt = {};
                        widget._seriesOpt = {};
                        widget._seriesSubOpt = {};
                        widget._seriesSub = {};
                        this._bindMapEvents(widget._chart);
                        this._setBackgroundContent(widget.options.backgroundContent);
                        break;
                }

                if (this.widget._creationOptions.name) {
                    this.widget._chart.name(this.widget._creationOptions.name);
                }

                if (this.widget.dsCount === 0 && this.widget._notInitialized) {
                    this._initializeWidget(this.widget);
                }
            }
        },
        _converterCallback: function () {
            var context = this.settings.callee;
            context.widget.dsCount--;
            if (context.widget.dsCount === 0) {
                context._initializeWidget(context.widget);
            }
        },
        _initDataOptions: function (options, callBack) {
            var widget = this.widget, dataOptions;
            if (options.dataSourceUrl) {
                options.dataSource = options.dataSourceUrl;
            }
            widget._containerSourceID = widget.id();
            dataOptions = {
                id: options.name || widget._containerSourceID,
                rowAdded: this._itemAdded,
                rowDeleted: this._itemRemoved,
                rowUpdated: this._itemUpdated,
                rowInserted: this._itemInserted,
                callback: callBack,
                callee: this,
                responseDataKey: options.responseDataKey,
                primaryKey: options.primaryKey,
                responseTotalRecCountKey: options.responseTotalRecCountKey,
                dataSource: options.dataSource
            };
            if (options.dataSourceType !== null) {
                dataOptions.type = options.dataSourceType;
            }
            return dataOptions;
        },

        _setupDataSource: function (options, callback) {
            var dataOptions = this._initDataOptions(options, callback);
            if (this.widget.dataSources === undefined) {
                this.widget.dataSources = {};
            }
            if (!dataOptions.dataSource ||
				typeof dataOptions.dataSource._xmlToArray !== "function" ||
				typeof dataOptions.dataSource._encodePkParams !== "function") {
                // fix for JSONP
                if ($.type(dataOptions.dataSource) === "string" && dataOptions.dataSource.indexOf("$callback=?") !== -1) {
                    this.widget.dataSources[dataOptions.id] = new $.ig.JSONPDataSource(dataOptions);
                } else {
                    this.widget.dataSources[dataOptions.id] = new $.ig.DataSource(dataOptions);
                }
            } else {
                this.widget.dataSources[dataOptions.id] = dataOptions.dataSource;
                dataOptions.dataSource = this.widget.dataSources[dataOptions.id].settings.dataSource;

                if (this.widget.dataSources[dataOptions.id].settings.responseDataKey !== null) {
                    delete dataOptions.responseDataKey;
                    if (dataOptions.schema) {
                        dataOptions.schema.searchField = this.widget.dataSource.settings.responseDataKey;
                    }
                }

                this.widget.dataSources[dataOptions.id].settings = this._mergeDataSourceSettings(this.widget.dataSources[dataOptions.id].settings, dataOptions);
                if (dataOptions.schema) {
                    this.widget.dataSources[dataOptions.id]._initSchema();
                }
            }
        },
        _initCallback: function (success, error, dataSource) {
            var context = dataSource.settings.callee;
            context.widget.dsCount--;
            if (context.widget.dsCount === 0 && success) {
                context._initializeWidget(context.widget);
            }
        },
        _initializeWidget: function (widget) {
            this.widget = widget;

            if (this.widget.dataSources[this.widget._containerSourceID]) {
                this._setItemsSource(this.widget, this.widget._chart, this.widget._containerSourceID);
            }
            this._setWidgetOptions(this.widget._creationOptions, widget._chart);
            this.widget._duringInit = false;

            if (widget._creationOptions.series) {
                this._setCoreWidgetOption(widget._chart, "series", this.widget._creationOptions.series);
            }

            widget._notInitialized = false;
        },

        _getNotifyTarget: function (targetName) {
            var target;
            if (this.widget.widgetName === 'igPieChart') {
                target = this.widget._chart;
            } else {
                if (targetName === this.widget.id()) {
                    target = this.widget._chart;
                } else {
                    target = this._getSeriesByName(targetName);
                    if (!target) {
                        target = this._getAxisByName(targetName);
                        if (!target) {
                            target = this._getSubSeriesByName(null, targetName);
                        }
                    }
                }
            }
            return target !== undefined ? target : null;
        },

        _notifyItemAdded: function (dataSource, newItem, index) {
            this.widget._chart.notifyInsertItem(dataSource, index, newItem.row);
        },

        _itemAdded: function (item, dataSource) {
            this._notifyItemAdded(dataSource, item, dataSource.dataView().length - 1);
        },

        _itemInserted: function (item, dataSource) {
            this._notifyItemAdded(dataSource, item, item.rowIndex);
        },

        _itemUpdated: function (item, dataSource) {
            this.widget._chart.notifySetItem(dataSource, item.rowIndex, item.oldRow, item.newRow);
        },

        _itemRemoved: function (item, dataSource) {
            this.widget._chart.notifyRemoveItem(dataSource, item.rowIndex, item.row);
        },
        _setWidgetOptions: function (options, chart) {
            var self = this;

            $.each(options, function (key, value) {
                if (!self._setWidgetOption(chart, key, value)) {
                    self._setCoreWidgetOption(chart, key, value);
                } else {
                    //still propagate the value so that it can be read back by the user.
                    self.widget.options[key] = value;
                }
            });
        },

        _createBrushFromValue: function(val) {
            var b, stops, colorStop, currOffset;
            if (!val) {
                return null;
            }

            if (typeof val == 'string') {
                b = new $.ig.Brush();
                b.fill(val);
            } else if (val.type == "linearGradient") {
                b = new $.ig.LinearGradientBrush();
                if (val.startPoint && val.endPoint) {
                    b._useCustomDirection = true;
                    b._startX = val.startPoint.x;
                    b._startY = val.startPoint.y;
                    b._endX = val.endPoint.x;
                    b._endY = val.endPoint.y;
                }

                if (val.colorStops) {
                    stops = [];
                    for (var i = 0; i < val.colorStops.length; i++) {
                        colorStop = new $.ig.GradientStop();
                        currOffset = 0;
                        if (val.colorStops[i].offset) {
                            currOffset = val.colorStops[i].offset
                        }
                        colorStop._offset = currOffset;
                        colorStop.__fill = val.colorStops[i].color;
                        stops.push(colorStop);
                    }
                    b._gradientStops = stops;
                }

            }

            return b;
        },

        _getValueFromBrush: function (brush) {
            var ret = {}, currStop, newStop;
            if (brush._isGradient) {
                ret.type = "linearGradient";
                if (brush._useCustomDirection) {
                    ret.startPoint = {};
                    ret.startPoint.x = brush._startX;
                    ret.startPoint.y = brush._startY;
                    ret.endPoint = {};
                    ret.endPoint.x = brush._endX;
                    ret.endPoint.y = brush._endY;
                }
                if (brush._gradientStops) {
                    ret.colorStops = [];
                    for (var i = 0; i < brush._gradientStops.length; i++) {
                        currStop = brush._gradientStops[i];
                        newStop = {};

                        newStop.offset = currStop._offset;
                        newStop.color = currStop.__fill;
                        ret.colorStops.push(newStop);
                    }
                }
                return ret;
            } else {
                return brush.fill();
            }
        },

        _setWidgetOption: function (chart, key, value) {
            var $tempBrushCollection, isRGB, $tempBrush, i;

            switch (key) {
                case "crosshairPoint":
                chart.crosshairPoint($.ig.APIFactory.prototype.createPoint(value.x, value.y));
                    return true;
                case "windowRect":
                chart.windowRect($.ig.APIFactory.prototype.createRect(value.left, value.top, value.width, value.height));
                    return true;
                case "horizontalZoomable":
                    chart.horizontalZoomable(value);
                    return true;
                case "isPagePanningAllowed":
                    chart.isPagePanningAllowed(value);
                    return true;
                case "useTiledZooming":
                    chart.useTiledZooming(value);
                    return true;
                case "preferHigherResolutionTiles":
                    chart.preferHigherResolutionTiles(value);
                    return true;
                case "zoomTileCacheSize":
                    chart.zoomTileCacheSize(value);
                    return true;
                case "verticalZoomable":
                    chart.verticalZoomable(value);
                    return true;
                case "zoomable":
                    chart.zoomable(value);
                    return true;
                case "windowResponse":
                    switch (value) {
                        case "deferred":
                            chart.windowResponse(0);
                            break;
                        case "immediate":
                            chart.windowResponse(1);
                            break;
                    }
                    return true;
                case "windowRectMinWidth":
                    chart.windowRectMinWidth(value);
                    return true;
                case "overviewPlusDetailPaneVisibility":
                    switch (value) {
                        case "visible":
                            chart.overviewPlusDetailPaneVisibility(0);
                            break;
                        case "collapsed":
                            chart.overviewPlusDetailPaneVisibility(1);
                            break;
                    }
                    return true;
                case "crosshairVisibility":
                    switch (value) {
                        case "visible":
                            chart.crosshairVisibility(0);
                            break;
                        case "collapsed":
                            chart.crosshairVisibility(1);
                            break;
                    }
                    return true;
                case "plotAreaBackground":
                    if (value === null) {
                        chart.plotAreaBackground(null);
                    } else {
                        chart.plotAreaBackground(this._createBrushFromValue(value));
                    }
                    return true;
                case "defaultInteraction":
                    switch (value) {
                        case "none":
                            chart.defaultInteraction(0);
                            break;
                        case "dragZoom":
                            chart.defaultInteraction(1);
                            break;
                        case "dragPan":
                            chart.defaultInteraction(2);
                            break;
                    }
                    return true;
                case "dragModifier":
                    switch (value) {
                        case "none":
                            chart.dragModifier(0);
                            break;
                        case "alt":
                            chart.dragModifier(1);
                            break;
                        case "control":
                            chart.dragModifier(2);
                            break;
                        case "shift":
                            chart.dragModifier(4);
                            break;
                        case "windows":
                            chart.dragModifier(8);
                            break;
                        case "apple":
                            chart.dragModifier(8);
                            break;
                    }
                    return true;
                case "panModifier":
                    switch (value) {
                        case "none":
                            chart.panModifier(0);
                            break;
                        case "alt":
                            chart.panModifier(1);
                            break;
                        case "control":
                            chart.panModifier(2);
                            break;
                        case "shift":
                            chart.panModifier(4);
                            break;
                        case "windows":
                            chart.panModifier(8);
                            break;
                        case "apple":
                            chart.panModifier(8);
                            break;
                    }

                    return true;
                case "previewRect":
                chart.previewRect($.ig.APIFactory.prototype.createRect(value.left, value.top, value.width, value.height));
                    return true;
                case "windowPositionHorizontal":
                    chart.windowPositionHorizontal(value);
                    return true;
                case "windowPositionVertical":
                    chart.windowPositionVertical(value);
                    return true;
                case "windowScaleHorizontal":
                    chart.windowScaleHorizontal(value);
                    return true;
                case "windowScaleVertical":
                    chart.windowScaleVertical(value);
                    return true;
                case "windowScale":
                    chart.windowScale(value);
                    return true;
                case "triangleMarkerTemplate":
                case "circleMarkerTemplate":
                case "pyramidMarkerTemplate":
                case "squareMarkerTemplate":
                case "diamondMarkerTemplate":
                case "pentagonMarkerTemplate":
                case "hexagonMarkerTemplate":
                case "tetragramMarkerTemplate":
                case "pentagramMarkerTemplate":
                case "hexagramMarkerTemplate":
                    this._setDataTemplate(chart, key, value);
                    return true;
                case "topMargin":
                    chart.topMargin(value);
                    return true;
                case "leftMargin":
                    chart.leftMargin(value);
                    return true;
                case "rightMargin":
                    chart.rightMargin(value);
                    return true;
                case "bottomMargin":
                    chart.bottomMargin(value);
                    return true;
                case "autoMarginWidth":
                    chart.autoMarginWidth(value);
                    return true;
                case "autoMarginHeight":
                    chart.autoMarginHeight(value);
                    return true;
                case "worldRect":
                chart.worldRect($.ig.APIFactory.prototype.createRect(value.left, value.top, value.width, value.height));
                    return true;
                    /*case "backgroundContent":
                    chart.backgroundContent(value);
                    return true; */
                case "xAxis":
                    chart.xAxis(this._getAxisByName(value));
                    return true;
                case "yAxis":
                    chart.yAxis(this._getAxisByName(value));
                    return true;
                case "isSquare":
                    chart.isSquare(value);
                    return true;
                case "gridMode":
                    switch (value) {
                        case "none":
                            chart.gridMode(0);
                            break;
                        case "beforeSeries":
                            chart.gridMode(1);
                            break;
                        case "behindSeries":
                            chart.gridMode(2);
                            break;
                    }
                    return true;
                case "alignsGridLinesToPixels":
                    chart.alignsGridLinesToPixels(value);
                    return true;
                case "brushes":
                    isRGB = true;
                    if ((typeof value[0] === "string" && value[0] === "HSV") || value[0] === "RGB") { if (value[0] === "HSV") { isRGB = false; } value = value.slice(1); }
                    $tempBrushCollection = new $.ig.BrushCollection();
                    for (i = 0; i < value.length; i++) {
                        $tempBrushCollection.add(this._createBrushFromValue(value[i]));
                    }
                    chart.brushes($tempBrushCollection);
                    return true;
                case "markerBrushes":
                    isRGB = true;
                    if ((typeof value[0] === "string" && value[0] === "HSV") || value[0] === "RGB") { if (value[0] === "HSV") { isRGB = false; } value = value.slice(1); }
                    $tempBrushCollection = new $.ig.BrushCollection();
                    for (i = 0; i < value.length; i++) {
                        $tempBrushCollection.add(this._createBrushFromValue(value[i]));
                    }
                    chart.markerBrushes($tempBrushCollection);
                    return true;
                case "outlines":
                    isRGB = true;
                    if ((typeof value[0] === "string" && value[0] === "HSV") || value[0] === "RGB") { if (value[0] === "HSV") { isRGB = false; } value = value.slice(1); }
                    $tempBrushCollection = new $.ig.BrushCollection();
                    for (i = 0; i < value.length; i++) {
                        $tempBrushCollection.add(this._createBrushFromValue(value[i]));
                    }
                    chart.outlines($tempBrushCollection);
                    return true;
                case "markerOutlines":
                    isRGB = true;
                    if ((typeof value[0] === "string" && value[0] === "HSV") || value[0] === "RGB") { if (value[0] === "HSV") { isRGB = false; } value = value.slice(1); }
                    $tempBrushCollection = new $.ig.BrushCollection();
                    for (i = 0; i < value.length; i++) {
                        $tempBrushCollection.add(this._createBrushFromValue(value[i]));
                    }
                    chart.markerOutlines($tempBrushCollection);
                    return true;
                    //pie chart
                case "valueMemberPath":
                    chart.valueMemberPath(value);
                    return true;
                case "labelMemberPath":
                    chart.labelMemberPath(value);
                    return true;
                case "labelsPosition":
                    switch (value) {
                        case "none":
                            chart.labelsPosition(0);
                            break;
                        case "center":
                            chart.labelsPosition(1);
                            break;
                        case "insideEnd":
                            chart.labelsPosition(2);
                            break;
                        case "outsideEnd":
                            chart.labelsPosition(3);
                            break;
                        case "bestFit":
                            chart.labelsPosition(4);
                            break;
                    }
                    return true;
                case "leaderLineVisibility":
                    switch (value) {
                        case "visible":
                            chart.leaderLineVisibility(0);
                            break;
                        case "collapsed":
                            chart.leaderLineVisibility(1);
                            break;
                    }
                    return true;
                case "leaderLineType":
                    switch (value) {
                        case "straight":
                            chart.leaderLineType(0);
                            break;
                        case "arc":
                            chart.leaderLineType(1);
                            break;
                        case "spline":
                            chart.leaderLineType(2);
                            break;
                    }
                    return true;
                case "leaderLineMargin":
                    chart.leaderLineMargin(value);
                    return true;
                case "leaderLineStyle":
                    chart.leaderLineStyle(value);
                    return true;
                case "othersCategoryThreshold":
                    chart.othersCategoryThreshold(value);
                    return true;
                case "formatLabel":
                    chart.formatLabel(value);
                    return true;
                case "othersCategoryStyle":
                    chart.othersCategoryStyle(value);
                    return true;
                case "othersCategoryType":
                    switch (value) {
                        case "number":
                            chart.othersCategoryType(0);
                            break;
                        case "percent":
                            chart.othersCategoryType(1);
                            break;
                    }
                    return true;
                case "othersCategoryText":
                    chart.othersCategoryText(value);
                    return true;
                case "explodedRadius":
                    chart.explodedRadius(value);
                    return true;
                case "radiusFactor":
                    chart.radiusFactor(value);
                    return true;
                case "allowSliceSelection":
                    chart.allowSliceSelection(value);
                    return true;
                case "allowSliceExplosion":
                    chart.allowSliceExplosion(value);
                    return true;
                case "labelExtent":
                    chart.labelExtent(value);
                    return true;
                case "startAngle":
                    chart.startAngle(value);
                    return true;
                case "sweepDirection":
                    switch (value) {
                        case "counterclockwise":
                            chart.sweepDirection(0);
                            break;
                        case "clockwise":
                            chart.sweepDirection(1);
                            break;
                    }
                    return true;
                case "selectedStyle":
                    chart.selectedStyle(value);
                    return true;
                case "legendItemTemplate":
                    this._setDataTemplate(chart, key, value);
                    return true;
                case "legendItemBadgeTemplate":
                    this._setDataTemplate(chart, key, value);
                    return true;
                case "textStyle":
                    chart.textStyle(value);
                    return true;
                case "overviewPlusDetailPaneBackgroundImageUri":
                    chart.overviewPlusDetailPaneBackgroundImageUri(value);
                    return true;
                case "isSurfaceInteractionDisabled":
                    chart.isSurfaceInteractionDisabled(value);
                    return true;
                case "animateSeriesWhenAxisRangeChanges":
                    chart.animateSeriesWhenAxisRangeChanges(value);
                    return true;
                case "innerExtent":
                    chart.innerExtent(value);
                    return true;
                case "title":
                    chart.title(value);
                    return true;
                case "subtitle":
                    chart.subtitle(value);
                    return true;
                case "titleTextStyle":
                    chart.titleTextStyle(value);
                    return true;
                case "titleTopMargin":
                    chart.titleTopMargin(value);
                    return true;
                case "titleLeftMargin":
                    chart.titleLeftMargin(value);
                    return true;
                case "titleRightMargin":
                    chart.titleRightMargin(value);
                    return true;
                case "titleBottomMargin":
                    chart.titleBottomMargin(value);
                    return true;
                case "subtitleTopMargin":
                    chart.subtitleTopMargin(value);
                    return true;
                case "subtitleLeftMargin":
                    chart.subtitleLeftMargin(value);
                    return true;
                case "subtitleRightMargin":
                    chart.subtitleRightMargin(value);
                    return true;
                case "subtitleBottomMargin":
                    chart.subtitleBottomMargin(value);
                    return true;
                case "subtitleTextStyle":
                    chart.subtitleTextStyle(value);
                    return true;
                case "titleTextColor":
                    if (value === null || value === undefined) {
                        chart.titleTextColor(null);
                    } else {
                        chart.titleTextColor(this._createBrushFromValue(value));
                    }
                    return true;
                case "subtitleTextColor":
                    if (value === null || value === undefined) {
                        chart.subtitleTextColor(null);
                    } else {
                        chart.subtitleTextColor(this._createBrushFromValue(value));
                    }
                    return true;
                case "titleHorizontalAlignment":
                    switch (value) {
                        case "left":
                            chart.titleHorizontalAlignment(0);
                            break;
                        case "center":
                            chart.titleHorizontalAlignment(1);
                            break;
                        case "right":
                            chart.titleHorizontalAlignment(2);
                            break;
                        default:
                            break;
                    }
                    break;
                case "subtitleHorizontalAlignment":
                    switch (value) {
                        case "left":
                            chart.subtitleHorizontalAlignment(0);
                            break;
                        case "center":
                            chart.subtitleHorizontalAlignment(1);
                            break;
                        case "right":
                            chart.subtitleHorizontalAlignment(2);
                            break;
                        default:
                            break;
                    }
                    break;
                case "highlightingTransitionDuration":
                    chart.highlightingTransitionDuration(value);
                    return true;
                case "pixelScalingRatio":
                    chart.pixelScalingRatio(value);
                    return true;
            }

            return false;
        },

        _createAxisFromType: function (axisType) {
            switch (axisType) {
                case "numericX":
                    return new $.ig.NumericXAxis();
                case "numericY":
                    return new $.ig.NumericYAxis();
                case "categoryX":
                    return new $.ig.CategoryXAxis();
                case "categoryDateTimeX":
                    return new $.ig.CategoryDateTimeXAxis();
                case "categoryY":
                    return new $.ig.CategoryYAxis();
                case "categoryAngle":
                    return new $.ig.CategoryAngleAxis();
                case "numericAngle":
                    return new $.ig.NumericAngleAxis();
                case "numericRadius":
                    return new $.ig.NumericRadiusAxis();
                default:
                    break;
            }
        },
        _createSeriesFromType: function (seriesType) {
            switch (seriesType) {
                case "area":
                    return new $.ig.AreaSeries();
                case "bar":
                    return new $.ig.BarSeries();
                case "column":
                    return new $.ig.ColumnSeries();
                case "line":
                    return new $.ig.LineSeries();
                case "rangeArea":
                    return new $.ig.RangeAreaSeries();
                case "rangeColumn":
                    return new $.ig.RangeColumnSeries();
                case "splineArea":
                    return new $.ig.SplineAreaSeries();
                case "spline":
                    return new $.ig.SplineSeries();
                case "stepArea":
                    return new $.ig.StepAreaSeries();
                case "stepLine":
                    return new $.ig.StepLineSeries();
                case "waterfall":
                    return new $.ig.WaterfallSeries();
                case "financial":
                    return new $.ig.FinancialPriceSeries();
                case "typicalPriceIndicator":
                    return new $.ig.TypicalPriceIndicator();
                case "polarArea":
                    return new $.ig.PolarAreaSeries();
                case "polarLine":
                    return new $.ig.PolarLineSeries();
                case "polarSpline":
                    return new $.ig.PolarSplineSeries();
                case "polarSplineArea":
                    return new $.ig.PolarSplineAreaSeries();
                case "polarScatter":
                    return new $.ig.PolarScatterSeries();
                case "radialColumn":
                    return new $.ig.RadialColumnSeries();
                case "radialLine":
                    return new $.ig.RadialLineSeries();
                case "radialPie":
                    return new $.ig.RadialPieSeries();
                case "radialArea":
                    return new $.ig.RadialAreaSeries();
                case "scatter":
                    return new $.ig.ScatterSeries();
                case "highDensityScatter":
                    return new $.ig.HighDensityScatterSeries();
                case "scatterLine":
                    return new $.ig.ScatterLineSeries();
                case "scatterSpline":
                    return new $.ig.ScatterSplineSeries();
                case "bubble":
                    return new $.ig.BubbleSeries();
                case "absoluteVolumeOscillatorIndicator":
                    return new $.ig.AbsoluteVolumeOscillatorIndicator();
                case "averageTrueRangeIndicator":
                    return new $.ig.AverageTrueRangeIndicator();
                case "accumulationDistributionIndicator":
                    return new $.ig.AccumulationDistributionIndicator();
                case "averageDirectionalIndexIndicator":
                    return new $.ig.AverageDirectionalIndexIndicator();
                case "geographicShape":
                    return new $.ig.GeographicShapeSeries();
                case "geographicSymbol":
                    return new $.ig.GeographicSymbolSeries();
                case "geographicScatterArea":
                    return new $.ig.GeographicScatterAreaSeries();
                case "geographicContourLine":
                    return new $.ig.GeographicContourLineSeries();
                case "geographicHighDensityScatter":
                    return new $.ig.GeographicHighDensityScatterSeries();
                case "geographicProportionalSymbol":
                    return new $.ig.GeographicProportionalSymbolSeries();
                case "geographicTileSeries":
                    return new $.ig.GeographicTileSeries();
                case "geographicPolyline":
                    return new $.ig.GeographicPolylineSeries();
                case "bollingerBandWidthIndicator":
                    return new $.ig.BollingerBandWidthIndicator();
                case "chaikinOscillatorIndicator":
                    return new $.ig.ChaikinOscillatorIndicator();
                case "chaikinVolatilityIndicator":
                    return new $.ig.ChaikinVolatilityIndicator();
                case "commodityChannelIndexIndicator":
                    return new $.ig.CommodityChannelIndexIndicator();
                case "detrendedPriceOscillatorIndicator":
                    return new $.ig.DetrendedPriceOscillatorIndicator();
                case "easeOfMovementIndicator":
                    return new $.ig.EaseOfMovementIndicator();
                case "fastStochasticOscillatorIndicator":
                    return new $.ig.FastStochasticOscillatorIndicator();
                case "forceIndexIndicator":
                    return new $.ig.ForceIndexIndicator();
                case "fullStochasticOscillatorIndicator":
                    return new $.ig.FullStochasticOscillatorIndicator();
                case "marketFacilitationIndexIndicator":
                    return new $.ig.MarketFacilitationIndexIndicator();
                case "massIndexIndicator":
                    return new $.ig.MassIndexIndicator();
                case "medianPriceIndicator":
                    return new $.ig.MedianPriceIndicator();
                case "moneyFlowIndexIndicator":
                    return new $.ig.MoneyFlowIndexIndicator();
                case "movingAverageConvergenceDivergenceIndicator":
                    return new $.ig.MovingAverageConvergenceDivergenceIndicator();
                case "negativeVolumeIndexIndicator":
                    return new $.ig.NegativeVolumeIndexIndicator();
                case "onBalanceVolumeIndicator":
                    return new $.ig.OnBalanceVolumeIndicator();
                case "percentagePriceOscillatorIndicator":
                    return new $.ig.PercentagePriceOscillatorIndicator();
                case "percentageVolumeOscillatorIndicator":
                    return new $.ig.PercentageVolumeOscillatorIndicator();
                case "positiveVolumeIndexIndicator":
                    return new $.ig.PositiveVolumeIndexIndicator();
                case "priceVolumeTrendIndicator":
                    return new $.ig.PriceVolumeTrendIndicator();
                case "rateOfChangeAndMomentumIndicator":
                    return new $.ig.RateOfChangeAndMomentumIndicator();
                case "relativeStrengthIndexIndicator":
                    return new $.ig.RelativeStrengthIndexIndicator();
                case "slowStochasticOscillatorIndicator":
                    return new $.ig.SlowStochasticOscillatorIndicator();
                case "standardDeviationIndicator":
                    return new $.ig.StandardDeviationIndicator();
                case "stochRSIIndicator":
                    return new $.ig.StochRSIIndicator();
                case "trixIndicator":
                    return new $.ig.TRIXIndicator();
                case "ultimateOscillatorIndicator":
                    return new $.ig.UltimateOscillatorIndicator();
                case "weightedCloseIndicator":
                    return new $.ig.WeightedCloseIndicator();
                case "williamsPercentRIndicator":
                    return new $.ig.WilliamsPercentRIndicator();
                case "bollingerBandsOverlay":
                    return new $.ig.BollingerBandsOverlay();
                case "priceChannelOverlay":
                    return new $.ig.PriceChannelOverlay();
                case "customIndicator":
                    return new $.ig.CustomIndicator();
                case "point":
                    return new $.ig.PointSeries();
                case "stackedColumn":
                    return new $.ig.StackedColumnSeries();
                case "stacked100Column":
                    return new $.ig.Stacked100ColumnSeries();
                case "stackedArea":
                    return new $.ig.StackedAreaSeries();
                case "stacked100Area":
                    return new $.ig.Stacked100AreaSeries();
                case "stackedBar":
                    return new $.ig.StackedBarSeries();
                case "stacked100Bar":
                    return new $.ig.Stacked100BarSeries();
                case "stackedLine":
                    return new $.ig.StackedLineSeries();
                case "stacked100Line":
                    return new $.ig.Stacked100LineSeries();
                case "stackedSpline":
                    return new $.ig.StackedSplineSeries();
                case "stacked100Spline":
                    return new $.ig.Stacked100SplineSeries();
                case "stackedSplineArea":
                    return new $.ig.StackedSplineAreaSeries();
                case "stacked100SplineArea":
                    return new $.ig.Stacked100SplineAreaSeries();
                case "stackedFragment":
                    return new $.ig.StackedFragmentSeries();
                case "crosshairLayer":
                    return new $.ig.CrosshairLayer();
                case "categoryHighlightLayer":
                    return new $.ig.CategoryHighlightLayer();
                case "categoryItemHighlightLayer":
                    return new $.ig.CategoryItemHighlightLayer();
                case "itemToolTipLayer":
                    return new $.ig.ItemToolTipLayer();
                case "categoryToolTipLayer":
                    return new $.ig.CategoryToolTipLayer();

                default:
                    break;
            }
        },

        _clearAxes: function (series) {
            if (series.xAxis) {
                series.xAxis(null);
            }
            if (series.yAxis) {
                series.yAxis(null);
            }
            if (series.angleAxis) {
                series.angleAxis(null);
            }
            if (series.valueAxis) {
                series.valueAxis(null);
            }
            if (series.radiusAxis) {
                series.radiusAxis(null);
            }
        },
        // replace or append new object obj to array a
        // if item has same name as obj, then replace, otherwise append
        _setForName: function (a, obj) {
            var i = a.length;
            while (i-- > 0) {
                if (a[i] && a[i].name === obj.name) {
                    a[i] = obj;
                    return;
                }
            }
            a.push(obj);
        },

        _setCoreWidgetOption: function (chart, key, value) {
            var self = this, widget = this.widget, axis = null, axisOpt = null, axisIsNew = false, merged, settings, newLink, oldLink, seriesIsNew, series = null, seriesOpt = null, exploded, templ;
            switch (key) {
                case "axes":
                    //set axis
                    if (this.widget.widgetName === "igMap") {
                        return;
                    }
                    $.each(value, function (i, val) {
                        if (!val.name) {
                            throw new Error($.ig.Chart.locale.axisName);
                        }
                        if (self.widget._series[val.name]) {
                            throw new Error($.ig.Chart.locale.nameInUse);
                        }
                        axis = self._getAxisByName(val.name);
                        if (axis && val.remove) {
                            delete widget._axes[val.name];
                            delete widget._axisOpt[val.name];
                        var ind =
                            self._getIndexByName(
                            widget.options.axes,
                            val.name);
                            widget.options.axes.splice(ind, 1);
                            widget._chart.axes().remove(axis);
                            if (widget.dataSources[val.name]) {
                                delete widget.dataSources[val.name].settings;
                                delete widget.dataSources[val.name];
                            }
                            if (widget._target && widget._target.name() === val.name) {
                                widget._target = null;
                            }
                            return;
                        }

                        if (axis) {
                            axisOpt = widget._axisOpt[val.name];
                        }

                        if (!axis && !val.remove) {
                            axis = self._createAxisFromType(val.type);
                            axis.name(val.name);
                            axisIsNew = true;
                        }

                        if (axis) {
                            if (axisIsNew) {
                                widget._axes[val.name] = axis;
                                merged = self._mergeIntoNewWithDataSource(widget._axisTemplate, val);
                                /* VS 03/14/2013 Bug 135879 */
                                /* VS 04/02/2013 Bug 138644 */
                                self._setForName(widget.options.axes, merged);
                                widget._axisOpt[val.name] = merged;
                            }
                            if (val.coercionMethods) {
                                axis.coercionMethods(val.coercionMethods);
                            }
                            if (widget.options.expectFunctions !== undefined &&
                                widget.options.expectFunctions) {
                                axis.expectFunctions(widget.options.expectFunctions);
                            }
                            if (val.expectFunctions !== undefined) {
                                axis.expectFunctions(val.expectFunctions);
                            }

                            self._setAxisOptions(val, axis);
                            if (axisIsNew) {
                                if (widget.dataSources[axis.name()]) {
                                    self._setItemsSource(self.widget, axis, axis.name());
                                    //axis.itemsSource(widget.dataSources[axis.name()].dataView());
                                }
                            } else {
                                self._mergeIntoWithDataSource(axisOpt, val);
                            }
                            if (axisIsNew) {
                                widget._chart.axes().add(axis);
                            }
                        }
                    });

                    if (widget._pendingCrossingAxes && widget._pendingCrossingAxes.length > 0) {
                        $.each(widget._pendingCrossingAxes, function (i, val) {
                            val();
                        });
                        widget._pendingCrossingAxes.length = 0;
                    }
                    return;
                case "series":
                    if (!widget._duringInit) {
                        seriesIsNew = false;
                        //set series
                        $.each(value, function (i, val) {
                            if (!val.name) {
                                throw new Error($.ig.Chart.locale.seriesName);
                            }
                            if (self.widget._axes[val.name]) {
                                throw new Error($.ig.Chart.locale.nameInUse);
                            }
                            series = self._getSeriesByName(val.name);
                            if (series && val.remove) {
                                delete widget._series[val.name];
                                delete widget._seriesOpt[val.name];
                                delete widget._seriesSubOpt[val.name];
                                delete widget._seriesSub[val.name];

                                if (widget.dataSources[val.name]) {
                                    delete widget.dataSources[val.name].settings;
                                    delete widget.dataSources[val.name];
                                }
                            var ind = self._getIndexByName(
                                widget.options.series,
                                val.name);
                                widget.options.series.splice(ind, 1);
                                widget._chart.series().remove(series);
                                self._clearAxes(series);
                                return;
                            }
                            if (!series && !val.remove) {
                                series = self._createSeriesFromType(val.type);
                                self._bindSeriesEvents(series);
                                series.name(val.name);
                                seriesIsNew = true;
                            }
                            if (series) {
                                seriesOpt = widget._seriesOpt[val.name];
                            }
                            if (series) {
                                if (seriesIsNew) {
                                    widget._series[val.name] = series;
                                    widget._seriesSub[val.name] = {};
                                    merged = self._mergeIntoNewWithDataSource(widget._seriesTemplate, val);
                                    /* VS 03/14/2013 Bug 135879 */
                                    /* VS 04/02/2013 Bug 138644 */
                                    self._setForName(widget.options.series, merged);
                                    widget._seriesOpt[val.name] = merged;
                                    widget._seriesSubOpt[val.name] = {};
                                }
                                if (val.coercionMethods) {
                                    series.coercionMethods(val.coercionMethods);
                                }
                                if (widget.options.expectFunctions !== undefined &&
                                    widget.options.expectFunctions) {
                                    series.expectFunctions(widget.options.expectFunctions);
                                }
                                if (val.expectFunctions !== undefined) {
                                    series.expectFunctions(val.expectFunctions);
                                }
                                self._setSeriesOptions(val, series, widget);
                                if (seriesIsNew) {
                                    if (widget.dataSources[series.name()]) {
                                        self._setItemsSource(self.widget, series, series.name());
                                    }
                                } else {
                                    self._mergeIntoWithDataSource(seriesOpt, val);
                                }
                                if (seriesIsNew) {
                                    widget._chart.series().add(series);
                                }
                            }
                        });
                    }
                    return;
                case "syncChannel":
                    newLink = null;
                    if (value && value.length > 0) {
                        newLink = $.ig.SyncLinkManager.prototype.instance().getLink(value);
                    }
                    oldLink = widget._chart.actualSyncLink();
                    if (oldLink) {
                        $.ig.SyncLinkManager.prototype.instance().releaseLink(oldLink);
                    }
                    if (newLink) {
                        widget._chart.actualSyncLink(newLink);
                    } else {
                        widget._chart.actualSyncLink(new $.ig.SyncLink());
                    }
                    break;
                case "synchronizeVertically":
                    settings = widget._chart.syncSettings();
                    settings.synchronizeVertically(value);
                    break;
                case "synchronizeHorizontally":
                    settings = widget._chart.syncSettings();
                    settings.synchronizeHorizontally(value);
                    break;
                case "legend":
                    this._setLegend(widget._chart, value);
                    break;
                case "width":
                case "height":
                    this._setSize(widget._chart, key, value);
                    break;
                case "size":
                    if (value.width) {
                        this._setSize(widget._chart, "width", value.width);
                        /* VS 03/14/2013 Bug 135879 */
                        widget.options.width = value.width;
                    }
                    if (value.height) {
                        this._setSize(widget._chart, "height", value.height);
                        /* VS 03/14/2013 Bug 135879 */
                        widget.options.height = value.height;
                    }
                    return;
                    //pie chart	specific                                                  
                case "explodedSlices":
                    if (value.length) {
                        exploded = new $.ig.IndexCollection();
                        $.each(value, function (i, val) {
                            exploded.add(val);
                        });
                        widget._chart.explodedSlices(exploded);
                    }
                    break;
                case "showTooltip":
                    if (value === true) {
                        this._addTooltip(widget, widget._chart, widget.css.tooltip);
                    }
                    if (value === false) {
                        this._removeTooltip(widget, widget._chart);
                    }
                    break;
                case "tooltipTemplate":
                    if ($.ig.tmpl) {
                        if (this._htmlCheckExpr.test(value)) {
                            templ = value;
                        } else {
                            if ($('#' + value).length > 0) {
                                templ = $('#' + value).text();
                            } else if ($(value).length > 0) {
                                templ = $(value).text();
                            } else {
                                templ = value;
                            }
                        }
                        //templ = (typeof $('#' + value).data().tmpl === 'undefined') ? $.template(widget.id() + 'TooltipTemplate', value) : value;
                        widget._tooltipTemplate = templ;
                        if (widget._chart.tooltipTemplate) {
                            widget._chart.tooltipTemplate(templ);
                        }
                    }
                    break;
                //			case "dataSource":                                                                                          
                //				this._setItemsSource(this.widget, this.widget._chart, this.widget._containerSourceID);                                                                                          
                //				break;                                                                                          
                //map specific                                                                                          
                case "backgroundContent":
                    if (value === null) {
                        widget._chart.backgroundContent(null);
                    }
                    if (!widget._duringInit) {
                        this._setBackgroundContent(value);
                    }
                    break;
                default:
                    return;
            }
            /* VS 03/14/2013 Bug 135879 */
            widget.options[key] = value;
        },

        _htmlCheckExpr: /^[^<]*(<[\w\W]+>)[^>]*$/,

        _getAxisByName: function (name) {
            if (this.widget._axes[name] === undefined) {
                if (this.widget.widgetName === "igMap") {
                    if (name === "xAxis") {
                        return this.widget._chart.xAxis();
                    }
                    if (name === "yAxis") {
                        return this.widget._chart.yAxis();
                    }
                }
                return null;
            }
            return this.widget._axes[name];
        },

        _getSeriesByName: function (name) {
            if (this.widget._series[name] === undefined) {
                return null;
            }
            return this.widget._series[name];
        },

        _setAxisOptions: function (options, axis) {
            var self = this;
            $.each(options, function (key, value) {
                if (!self._setAxisOption(axis, key, value)) {
                    self._setCoreAxisOption(axis, key, value);
                }
                /* Graham 03/14/2013 Bug 135879 */
                //still propagate the axis option so the user can read it back.
                self.widget._axisOpt[axis.name()][key] = value;
            });
        },

        _setSeriesOptions: function (options, series) {
            var self = this;
            $.each(options, function (key, value) {
                if (!self._setCoreSeriesOption(series, key, value)) {
                    self._seriesSetOption(series, key, value);
                }
                /* Graham 03/14/2013 Bug 135879 */
                if (key !== "series") {
                    //still propagate the series option so the user can read it back.
                    self.widget._seriesOpt[series.name()][key] = value;
                }
            });
        },

        _setSubSeriesOptions: function (options, parentSeries, series) {
            var self = this;
            $.each(options, function (key, value) {
                if (!self._setCoreSeriesOption(series, key, value)) {
                    self._seriesSetOption(series, key, value);
                }
                /* Graham 03/14/2013 Bug 135879 */
                //still propagate the series option so the user can read it back.
                self.widget._seriesSubOpt[parentSeries.name()][series.name()][key] = value;
            });
        },

        _setCoreSeriesOption: function (series, key, value) {
            var templ;
            switch (key) {
                case "legend":
                    this._setLegend(series, value);
                    return true;
                case "showTooltip":
                    if (value === true) {
                        this._addTooltip(this.widget, series, this.widget.css.tooltip);
                        this._setCoreSeriesOption(series, "tooltipTemplate", "default");
                    } else {
                        this._removeTooltip(this.widget, series);
                    }
                    return true;
                case "tooltipTemplate":
                    if ($.ig.tmpl) {
                        if (this._htmlCheckExpr.test(value)) {
                            templ = value;
                        } else {
                            if ($('#' + value).length > 0) {
                                templ = $('#' + value).text();
                            } else if ($(value).length > 0) {
                                templ = $(value).text();
                            } else {
                                templ = value;
                            }
                        }
                        //templ = (typeof $('#' + value).data().tmpl === 'undefined') ? $.template(series.name() + 'TooltipTemplate', value) : value;
                        this.widget._tooltipTemplates[series.name()] = templ;
                        if (series.tooltipTemplate) {
                            series.tooltipTemplate(templ);
                        }
                        if (series.flattenEventArgs) {
                            series.flattenEventArgs($.proxy(this._getChartEvt, this));
                        }
                    }
                    return true;
                case "displayType":
                    switch (value) {
                        case "candlestick":
                            series.displayType(0);
                            break;
                        case "ohlc":
                            series.displayType(1);
                            break;
                        case "line":
                            series.displayType(0);
                            break;
                        case "area":
                            series.displayType(1);
                            break;
                        case "column":
                            series.displayType(2);
                            break;
                    }
                    return true;
                case "tileImagery":
                    if (value === null) {
                        series.backgroundContent(null);
                    }
                    this._setSeriesBackgroundContent(series, value);
                    return true;
            }
            return false;
        },
        _initMap: function () {
            if (this.widget._duringInit) {
                this._renderChartContainer(this.widget);
                this._initialDataBind();

                if (this.widget.dsCount === 0 && this.widget._notInitialized) {
                    this._initializeWidget(this.widget);
                }
            }
        },
		_setSeriesBackgroundContent: function(series, bgOptions) {
            var seriesOpt = this.widget._seriesOpt[series.name()];
            seriesOpt.tileImagery = bgOptions;

            switch (bgOptions.type) {
                case "cloudMade":
                    series.tileImagery(this._setBackgroundOptions(new $.ig.CloudMadeMapImagery(), bgOptions));
                    break;
                case "bing":
                    this._initializeBingMapsImageryForSeries(series, bgOptions);
                    break;
                case "openStreet":
                    series.tileImagery(this._setBackgroundOptions(new $.ig.OpenStreetMapImagery(), bgOptions));
                    break;
                default:
                    return;
            }
        },
        _setBackgroundContent: function (bgOptions) {
            if (!bgOptions) {
                this._initMap();
            } else {
                this.widget.options.backgroundContent = bgOptions;

                switch (bgOptions.type) {
                    case "cloudMade":
                        this.widget._chart.backgroundContent(this._setBackgroundOptions(new $.ig.CloudMadeMapImagery(), bgOptions));
                        this._initMap();
                        break;
                    case "bing":
                        this._initializeBingMapsImagery(bgOptions);
                        break;
                    case "openStreet":
                        this.widget._chart.backgroundContent(this._setBackgroundOptions(new $.ig.OpenStreetMapImagery(), bgOptions));
                        this._initMap();
                        break;
                    default:
                        return;
                }
            }
        },
        _initializeBingMapsImagery: function (bgOptions) {
            var bingUrl = bgOptions.bingUrl || "http://dev.virtualearth.net/REST/v1/Imagery/Metadata/", imagerySet = bgOptions.imagerySet || "AerialWithLabels", bingKey = bgOptions.key;
            $.ajax({
                url: bingUrl + imagerySet,
                data: "key=" + bingKey + "&include=ImageryProviders",
                success: $.proxy(this._setBingBackground, this),
                dataType: "jsonp",
                jsonp: "jsonp"
            });
        },
        _initializeBingMapsImageryForSeries: function (series, bgOptions) {
            var bingUrl = bgOptions.bingUrl || "http://dev.virtualearth.net/REST/v1/Imagery/Metadata/", imagerySet = bgOptions.imagerySet || "AerialWithLabels", bingKey = bgOptions.key, self = this;
            $.ajax({
                url: bingUrl + imagerySet,
                data: "key=" + bingKey + "&include=ImageryProviders",
                success: function (res) { self._setBingBackgroundForSeries(series, res); },
                dataType: "jsonp",
                jsonp: "jsonp"
            });
        },
        _setBingBackgroundForSeries: function (series, res) {
            var i, bg = new $.ig.BingMapsMapImagery(), meta = res.resourceSets[0].resources[0], culture = this.widget.options.backgroundContent.cultureName || "en-US";
            bg.tilePath(meta.imageUrl);
            bg.cultureName(culture);
            for (i = 0; i < meta.imageUrlSubdomains.length; i++) {
                bg.subDomains().add(meta.imageUrlSubdomains[i]);
            }
            series.tileImagery(bg);
        },
           _setBingBackground: function (res){
            var i, bg = new $.ig.BingMapsMapImagery(), meta, culture = this.widget.options.backgroundContent.cultureName || "en-US";
            if (!res || !res.resourceSets || res.resourceSets.length < 1 || !res.resourceSets[0].resources || res.resourceSets[0].resources.length < 1)
                return;

            meta = res.resourceSets[0].resources[0];
            bg.tilePath(meta.imageUrl);
            bg.cultureName(culture);
            for (i = 0; i < meta.imageUrlSubdomains.length; i++) {
                bg.subDomains().add(meta.imageUrlSubdomains[i]);
            }
            this.widget._chart.backgroundContent(bg);
            this._initMap();
        },
        _setBackgroundOptions: function (background, options) {
            var self = this;
            $.each(options, function (key, val) {
                self._backgroundContextSetOption(background, key, val);
            });
            return background;
        },
        _backgroundContextSetOption: function (background, key, value) {
            switch (key) {
                case "key":
                    background.key(value);
                    break;
                case "parameter":
                    background.parameter(value);
                    break;
                case "opacity":
                    background.parameter(value);
                    break;
                default:
                    break;
            }
        },
        _setDataTemplate: function (series, key, value) {
            var tempTemplate = new $.ig.DataTemplate(), requireThis = false;
            if (!value) {
                if (series[key]) {
                    series[key](null);
                }
                return;
            }

            if (value.requireThis) {
                requireThis = true;
            }

            if (value.render) {
                if (requireThis) {
                    tempTemplate.render($.proxy(value.render, value));
                } else {
                    tempTemplate.render(value.render);
                }
            } else {
                tempTemplate.render(value);
            }
            if (value.measure) {
                if (requireThis) {
                    tempTemplate.measure($.proxy(value.measure, value));
                } else {
                    tempTemplate.measure(value.measure);
                }
            }
            if (value.passStarting) {
                if (requireThis) {
                    tempTemplate.passStarting($.proxy(value.passStarting, value));
                } else {
                    tempTemplate.passStarting(value.passStarting);
                }
            }
            if (value.passCompleted) {
                if (requireThis) {
                    tempTemplate.passCompleted($.proxy(value.passCompleted, value));
                } else {
                    tempTemplate.passCompleted(value.passCompleted);
                }
            }
            if (series[key]) {
                series[key](tempTemplate);
            }
        },
        _seriesSetOption: function (series, key, value) {
            var $tempBrush, $tempColor, $old;
            switch (key) {
                case "legendItemVisibility":
                    switch (value) {
                        case "visible":
                            series.legendItemVisibility(0);
                            break;
                        case "collapsed":
                            series.legendItemVisibility(1);
                            break;
                    }
                    return true;
                case "legendItemBadgeTemplate":
                case "legendItemTemplate":
                case "discreteLegendItemTemplate":
                case "markerTemplate":
                    this._setDataTemplate(series, key, value);
                    return true;
                case "transitionDuration":
                    series.transitionDuration(value);
                    return true;
                case "transitionEasingFunction":
                    series.transitionEasingFunction($.ig.util.getEasingFunction(value));
                    return true;
                case "transitionInEasingFunction":
                    series.transitionInEasingFunction($.ig.util.getEasingFunction(value));
                    return true;
                case "resolution":
                    series.resolution(value);
                    return true;
                case "title":
                    series.title(value);
                    return true;
                case "brush":
                    if (value === null) {
                        series.brush(null);
                    } else {
                        series.brush(this._createBrushFromValue(value));
                    }
                    return true;
                case "outline":
                    if (value === null) {
                        series.outline(null);
                    } else {
                        series.outline(this._createBrushFromValue(value));
                    }
                    return true;
                case "thickness":
                    series.thickness(value);
                    return true;
                case "isDropShadowEnabled":
                    series.isDropShadowEnabled(value);
                    return true;
                case "useSingleShadow":
                    series.useSingleShadow(value);
                    return true;
                case "shadowColor":
                    if (value === null) {
                        series.shadowColor(null);
                    } else {
                        $tempColor = $.ig.APIFactory.prototype.createColor(value);
                        series.shadowColor($tempColor);
                    }
                    return true;
                case "shadowBlur":
                    series.shadowBlur(value);
                    return true;
                case "shadowOffsetX":
                    series.shadowOffsetX(value);
                    return true;
                case "shadowOffsetY":
                    series.shadowOffsetY(value);
                    return true;
                case "markerType":
                    switch (value) {
                        case "unset":
                            series.markerType(0);
                            break;
                        case "none":
                            series.markerType(1);
                            break;
                        case "automatic":
                            series.markerType(2);
                            break;
                        case "circle":
                            series.markerType(3);
                            break;
                        case "triangle":
                            series.markerType(4);
                            break;
                        case "pyramid":
                            series.markerType(5);
                            break;
                        case "square":
                            series.markerType(6);
                            break;
                        case "diamond":
                            series.markerType(7);
                            break;
                        case "pentagon":
                            series.markerType(8);
                            break;
                        case "hexagon":
                            series.markerType(9);
                            break;
                        case "tetragram":
                            series.markerType(10);
                            break;
                        case "pentagram":
                            series.markerType(11);
                            break;
                        case "hexagram":
                            series.markerType(12);
                            break;
                    }
                    return true;
                case "shapeMemberPath":
                    series.shapeMemberPath(value);
                    return true;
                case "shapeStyleSelector":
                    series.shapeStyleSelector(value);
                    return true;
                case "shapeStyle":
                    series.shapeStyle(value);
                    return true;
                case "markerBrush":
                    if (value === null) {
                        series.markerBrush(null);
                    } else {
                        series.markerBrush(this._createBrushFromValue(value));
                    }
                    return true;
                case "markerOutline":
                    if (value === null) {
                        series.markerOutline(null);
                    } else {
                        series.markerOutline(this._createBrushFromValue(value));
                    }
                    return true;
                case "markerCollisionAvoidance":
                    switch (value) {
                        case "none":
                            series.markerCollisionAvoidance(0);
                            break;
                        case "omit":
                            series.markerCollisionAvoidance(1);
                            break;
                        case "fade":
                            series.markerCollisionAvoidance(2);
                            break;
                        case "omitAndShift":
                            series.markerCollisionAvoidance(3);
                            break;
                        case "fadeAndShift":
                            series.markerCollisionAvoidance(4);
                            break;
                    }
                    return true;
                case "xAxis":
                    series.xAxis(this._getAxisByName(value));
                    return true;
                case "yAxis":
                    series.yAxis(this._getAxisByName(value));
                    return true;
                case "xMemberPath":
                    series.xMemberPath(value);
                    return true;
                case "yMemberPath":
                    series.yMemberPath(value);
                    return true;
                case "trendLineType":
                    switch (value) {
                        case "none":
                            series.trendLineType(0);
                            break;
                        case "linearFit":
                            series.trendLineType(1);
                            break;
                        case "quadraticFit":
                            series.trendLineType(2);
                            break;
                        case "cubicFit":
                            series.trendLineType(3);
                            break;
                        case "quarticFit":
                            series.trendLineType(4);
                            break;
                        case "quinticFit":
                            series.trendLineType(5);
                            break;
                        case "logarithmicFit":
                            series.trendLineType(6);
                            break;
                        case "exponentialFit":
                            series.trendLineType(7);
                            break;
                        case "powerLawFit":
                            series.trendLineType(8);
                            break;
                        case "simpleAverage":
                            series.trendLineType(9);
                            break;
                        case "exponentialAverage":
                            series.trendLineType(10);
                            break;
                        case "modifiedAverage":
                            series.trendLineType(11);
                            break;
                        case "cumulativeAverage":
                            series.trendLineType(12);
                            break;
                        case "weightedAverage":
                            series.trendLineType(13);
                            break;
                    }
                    return true;
                case "trendLineBrush":
                    if (value === null) {
                        series.trendLineBrush(null);
                    } else {
                        series.trendLineBrush(this._createBrushFromValue(value));
                    }
                    return true;
                case "trendLineThickness":
                    series.trendLineThickness(value);
                    return true;
                case "trendLinePeriod":
                    series.trendLinePeriod(value);
                    return true;
                case "trendLineZIndex":
                    series.trendLineZIndex(value);
                    return true;
                case "isTransitionInEnabled":
                    series.isTransitionInEnabled(value);
                    return true;
                case "transitionInSpeedType":
					switch (value)
					{
                        case "auto":
                            series.transitionInSpeedType(0);
                            break;
                        case "normal":
                            series.transitionInSpeedType(1);
                            break;
                        case "valueScaled":
                            series.transitionInSpeedType(2);
                            break;
                        case "indexScaled":
                            series.transitionInSpeedType(3);
                            break;
                        case "random":
                            series.transitionInSpeedType(4);
                            break;
                    }
                    return true;
                case "transitionInMode":
					switch (value)
					{
                        case "auto":
                            series.transitionInMode(0);
                            break;
                        case "fromZero":
                            series.transitionInMode(1);
                            break;
                        case "sweepFromLeft":
                            series.transitionInMode(2);
                            break;
                        case "sweepFromRight":
                            series.transitionInMode(3);
                            break;
                        case "sweepFromTop":
                            series.transitionInMode(4);
                            break;
                        case "sweepFromBottom":
                            series.transitionInMode(5);
                            break;
                        case "sweepFromCenter":
                            series.transitionInMode(6);
                            break;
                        case "accordionFromLeft":
                            series.transitionInMode(7);
                            break;
                        case "accordionFromRight":
                            series.transitionInMode(8);
                            break;
                        case "accordionFromTop":
                            series.transitionInMode(9);
                            break;
                        case "accordionFromBottom":
                            series.transitionInMode(10);
                            break;
                        case "expand":
                            series.transitionInMode(11);
                            break;
                        case "sweepFromCategoryAxisMinimum":
                            series.transitionInMode(12);
                            break;
                        case "sweepFromCategoryAxisMaximum":
                            series.transitionInMode(13);
                            break;
                        case "sweepFromValueAxisMinimum":
                            series.transitionInMode(14);
                            break;
                        case "sweepFromValueAxisMaximum":
                            series.transitionInMode(15);
                            break;
                        case "accordionFromCategoryAxisMinimum":
                            series.transitionInMode(16);
                            break;
                        case "accordionFromCategoryAxisMaximum":
                            series.transitionInMode(17);
                            break;
                        case "accordionFromValueAxisMinimum":
                            series.transitionInMode(18);
                            break;
                        case "accordionFromValueAxisMaximum":
                            series.transitionInMode(19);
                            break;

                    }
                    return true;
                case "transitionInDuration":
                    series.transitionInDuration(value);
                    return true;
                case "maximumMarkers":
                    series.maximumMarkers(value);
                    return true;
                case "radiusMemberPath":
                    series.radiusMemberPath(value);
                    return true;
                case "radiusScale":
                    series.radiusScale(this._getSizeScale(value));
                    return true;
                case "labelMemberPath":
                    series.labelMemberPath(value);
                    return true;
                case "fillMemberPath":
                    series.fillMemberPath(value);
                    return true;
                case "fillScale":
                    series.fillScale(this._getBrushScale(value));
                    return true;
                case "angleAxis":
                    series.angleAxis(this._getAxisByName(value));
                    return true;
                case "valueAxis":
                    series.valueAxis(this._getAxisByName(value));
                    return true;
                case "clipSeriesToBounds":
                    series.clipSeriesToBounds(value);
                    return true;
                case "valueMemberPath":
                    series.valueMemberPath(value);
                    return true;
                case "unknownValuePlotting":
                    switch (value) {
                        case "linearInterpolate":
                            series.unknownValuePlotting(0);
                            break;
                        case "dontPlot":
                            series.unknownValuePlotting(1);
                            break;
                    }
                    return true;
                case "radiusX":
                    series.radiusX(value);
                    return true;
                case "radiusY":
                    series.radiusY(value);
                    return true;
                case "radius":
                    series.radiusX(value);
                    series.radiusY(value);
                    return true;
                case "angleMemberPath":
                    series.angleMemberPath(value);
                    return true;
                case "radiusAxis":
                    series.radiusAxis(this._getAxisByName(value));
                    return true;
                case "useCartesianInterpolation":
                    series.useCartesianInterpolation(value);
                    return true;
                case "negativeBrush":
                    if (value === null) {
                        series.negativeBrush(null);
                    } else {
                        series.negativeBrush(this._createBrushFromValue(value));
                    }
                    return true;
                case "splineType":
                    switch (value) {
                        case "natural":
                            series.splineType(0);
                            break;
                        case "clamped":
                            series.splineType(1);
                            break;
                    }
                    return true;
                case "lowMemberPath":
                    series.lowMemberPath(value);
                    return true;
                case "highMemberPath":
                    series.highMemberPath(value);
                    return true;
                case "openMemberPath":
                    series.openMemberPath(value);
                    return true;
                case "closeMemberPath":
                    series.closeMemberPath(value);
                    return true;
                case "volumeMemberPath":
                    series.volumeMemberPath(value);
                    return true;
                case "ignoreFirst":
                    series.ignoreFirst(value);
                    return true;
                case "period":
                    series.period(value);
                    return true;
                case "shortPeriod":
                    series.shortPeriod(value);
                    return true;
                case "longPeriod":
                    series.longPeriod(value);
                    return true;
                case "trianglesSource":
                    series.trianglesSource(value);
                    return true;
                case "triangleVertexMemberPath1":
                    series.triangleVertexMemberPath1(value);
                    return true;
                case "triangleVertexMemberPath2":
                    series.triangleVertexMemberPath2(value);
                    return true;
                case "triangleVertexMemberPath3":
                    series.triangleVertexMemberPath3(value);
                    return true;
                case "colorScale":
                    series.colorScale(this._getColorScale(value));
                    return true;
                case "colorMemberPath":
                    series.colorMemberPath(value);
                    return true;
                case "visibleFromScale":
                    series.visibleFromScale(value);
                    return true;
                case "longitudeMemberPath":
                    series.longitudeMemberPath(value);
                    return true;
                case "latitudeMemberPath":
                    series.latitudeMemberPath(value);
                    return true;
                case "valueResolver":
                    series.valueResolver(this._getValueResolver(value));
                    return true;
                case "shapeFilterResolution":
                    series.shapeFilterResolution(value);
                    return true;
                case "useBruteForce":
                    series.useBruteForce(value);
                    return true;
                case "progressiveLoad":
                    series.progressiveLoad(value);
                    return true;
                case "heatMinimumColor":
                    if (value === null) {
                        series.heatMinimumColor(null);
                    } else {
                        $tempColor = $.ig.APIFactory.prototype.createColor(value);
                        series.heatMinimumColor($tempColor);
                    }
                    return true;
                case "heatMaximumColor":
                    if (value === null) {
                        series.heatMaximumColor(null);
                    } else {
                        $tempColor = $.ig.APIFactory.prototype.createColor(value);
                        series.heatMaximumColor($tempColor);
                    }
                    return true;
                case "mouseOverEnabled":
                    series.mouseOverEnabled(value);
                    return true;
                case "pointExtent":
                    series.pointExtent(value);
                    return true;
                case "heatMinimum":
                    series.heatMinimum(value);
                    return true;
                case "heatMaximum":
                    series.heatMaximum(value);
                    return true;
                case "multiplier":
                    series.multiplier(value);
                    return true;
                case "smoothingPeriod":
                    series.smoothingPeriod(value);
                    return true;
                case "triggerPeriod":
                    series.triggerPeriod(value);
                    return true;
                case "signalPeriod":
                    series.signalPeriod(value);
                    return true;
                case "useHighMarkerFidelity":
                    series.useHighMarkerFidelity(value);
                    return true;
                case "series":
                    this._setSubSeries(series, value);
                    return true;
                case "opacity":
                    $old = series.opacity();
                    series.opacity(value);
                    if (series.raisePropertyChanged) {
                        series.raisePropertyChanged("Opacity", $old, value);
                    }
                    if (series.renderSeries) {
                        series.renderSeries(false);
                    }
                    return true;
                case "areaFillOpacity":
                    series.areaFillOpacity(value);
                    return true;
                case "expectFunctions":
                    series.expectFunctions(value);
                    return true;
                case "useInterpolation":
                    series.useInterpolation(value);
                    return true;
                case "skipUnknownValues":
                    series.skipUnknownValues(value);
                    return true;
                case "verticalLineVisibility":
                    switch (value) {
                        case "visible":
                            series.verticalLineVisibility(0);
                            break;
                        case "collapsed":
                            series.verticalLineVisibility(1);
                            break;
                        default:
                            break;
                    }
                    return true;
                case "horizontalLineVisibility":
                    switch (value) {
                        case "visible":
                            series.horizontalLineVisibility(0);
                            break;
                        case "collapsed":
                            series.horizontalLineVisibility(1);
                            break;
                        default:
                            break;
                    }
                    return true;
                case "targetSeries":
                    if (value === undefined || value === null || this._getNotifyTarget(value) === null) {
                        series.targetSeries(null);
                    } else {
                        series.targetSeries(this._getNotifyTarget(value));
                    }
                    return true;
                case "targetAxis":
                    if (value === undefined || value === null || this._getNotifyTarget(value) === null) {
                        series.targetAxis(null);
                    } else {
                        series.targetAxis(this._getNotifyTarget(value));
                    }
                    return true;
                case "cursorPosition":
					series.cursorPosition($.ig.APIFactory.prototype.createPoint(value.x, value.y));
                    return true;
                case "bandHighlightWidth":
                    series.bandHighlightWidth(value);
                    return true;
                case "toolTipPosition":
                    switch (value) {
                        case "auto":
                            series.toolTipPosition(0);
                            break;
                        case "outsideStart":
                            series.toolTipPosition(1);
                            break;
                        case "insideStart":
                            series.toolTipPosition(2);
                            break;
                        case "insideEnd":
                            series.toolTipPosition(3);
                            break;
                        case "outsideEnd":
                            series.toolTipPosition(4);
                            break;
                        default:
                            break;
                    }
                    return true;
                case "highlightType":
                    switch (value) {
                        case "auto":
                            series.highlightType(0);
                            break;
                        case "marker":
                            series.highlightType(1);
                            break;
                        case "shape":
                            series.highlightType(2);
                            break;
                        default:
                            break;
                    }
                    return true;
                case "useIndex":
                    series.useIndex(value);
                    return true;
                case "useLegend":
                    series.useLegend(value);
                    return true;
                case "isCustomCategoryStyleAllowed":
                    series.isCustomCategoryStyleAllowed(value);
                    return true;
                case "isCustomCategoryMarkerStyleAllowed":
                    series.isCustomCategoryMarkerStyleAllowed(value);
                    return true;
                case "isHighlightingEnabled":
                    series.isHighlightingEnabled(value);
                    return true;
            }

            return false;
        },
		_getSubSeriesByName: function(parentSeries, name) {
            var subSeries = null;

            if (parentSeries === null) {
                for (var s in this.widget._seriesSub) {
                    parentSeries = this._getSeriesByName(s);
                    if (parentSeries !== null) {
                        subSeries = this._getSubSeriesByName(parentSeries, name);

                        if (subSeries !== null) {
                            return subSeries;
                        }
                    }
                }
            }
            if (!parentSeries) {
                return null;
            }
            var parentName = parentSeries.name();

            if (this.widget._seriesSub[parentName][name] === undefined) {
                return null;
            }

            return this.widget._seriesSub[parentName][name];
        },
		_getIndexByName: function (fromArray, name) {
		    for (var i = 0; i < fromArray.length; i++) {
		        if (fromArray[i].name &&
                    fromArray[i].name == name) {
		            return i;
		        }
		    }
		    return -1;
		},
        _setSubSeries: function (parentSeries, subSeries) {
            var self = this, series = null, widget = this.widget, seriesIsNew = false, subSeriesOpt, parentInd, i, parentName = parentSeries.name(), seriesOpt, merged, checkParent;

            parentInd = -1;
            for (i = 0; i < widget.options.series.length; i++) {
                checkParent = widget.options.series[i];
                if (checkParent && checkParent.name === parentName) {
                    parentInd = i;
                    break;
                }
            }

            //set series
            $.each(subSeries, function (i, val) {
                if (!val.name) {
                    throw new Error($.ig.Chart.locale.seriesName);
                }

                if (self._getSeriesByName(val.name)) {
                    throw new Error($.ig.Chart.locale.nameInUse);
                }

                series = self._getSubSeriesByName(parentSeries, val.name);
                if (series && val.remove) {
                    if (widget._seriesSub[parentName]) {
                        delete widget._seriesSub[parentName][val.name];
                    }

                    if (widget._seriesSubOpt[parentName]) {
                        subSeriesOpt = widget._seriesSubOpt[parentName][val.name];
                        delete widget._seriesSubOpt[parentName][val.name];
                    }

                    if (parentInd !== -1) {
					    var ind =
                            self._getIndexByName(
                            widget.options.series[parentInd].series,
                            subSeriesOpt.name);
                        widget.options.series[parentInd].series.splice(ind, 1);
                    }

                    parentSeries.series().remove(series);
                    self._clearAxes(series);

                    return;
                }
                if (!series && !val.remove) {
                    series = self._createSeriesFromType(val.type);
                    self._bindSeriesEvents(series);
                    series.name(val.name);
                    seriesIsNew = true;
                }
                if (series) {
                    seriesOpt = widget._seriesSubOpt[parentName][val.name];
                    if (seriesIsNew) {
                        widget._seriesSub[parentName][val.name] = series;
                        if (parentInd !== -1) {
                            /* Graham 03/14/2013 Bug 135879 */
                            /* VS 04/02/2013 Bug 138644 */
                            self._setForName(widget.options.series, val);
                        }
                        /* Graham 03/14/2013 Bug 135879 */
                        widget._seriesSubOpt[parentName][val.name] = val;
                    }
                    if (val.coercionMethods) {
                        series.coercionMethods(val.coercionMethods);
                    }
                    if (widget.options.expectFunctions !== undefined &&
						widget.options.expectFunctions) {
                        series.expectFunctions(widget.options.expectFunctions);
                    }
                    if (val.expectFunctions !== undefined) {
                        series.expectFunctions(val.expectFunctions);
                    }
                    self._setSubSeriesOptions(val, parentSeries, series, widget);

                    if (seriesIsNew) {
                        parentSeries.series().add(series);
                    }
                }
            });
        },
        _getValueResolver: function (value) {
            var valueResolver;
            if (value.type === undefined || value.type === 'linear') {
                valueResolver = new $.ig.LinearContourValueResolver();
            }
            if (value.valueCount) {
                valueResolver.valueCount(value.valueCount);
            }
            return valueResolver;
        },
        _getSizeScale: function (value) {
            var scale = new $.ig.SizeScale();
            if (value.minimumValue) {
                scale.minimumValue(value.minimumValue);
            }
            if (value.maximumValue) {
                scale.maximumValue(value.maximumValue);
            }
            if (value.isLogarithmic) {
                scale.isLogarithmic(value.isLogarithmic);
            }
            if (value.logarithmBase) {
                scale.logarithmBase(value.logarithmBase);
            }
            return scale;
        },
        _getColorScale: function (value) {
            var type = "customPalette", scale = null;
            if (value.type) {
                type = value.type;
            }

            switch (type) {
                case "customPalette":
                    scale = new $.ig.CustomPaletteColorScale();
                    break;
            }

            if (scale) {
                if (value.minimumValue) {
                    scale.minimumValue(value.minimumValue);
                }
                if (value.maximumValue) {
                    scale.maximumValue(value.maximumValue);
                }

                if (value.interpolationMode) {
                    switch (value.interpolationMode) {
                        case "select":
                            scale.interpolationMode(0);
                            break;
                        case "interpolateRGB":
                            scale.interpolationMode(1);
                            break;
                        case "interpolateHSV":
                            scale.interpolationMode(2);
                            break;
                    }
                }

                if (value.palette) {
                    scale.providePalette(value.palette);
                }
            }

            return scale;
        },
        _getBrushScale: function (value) {
            var type = "value", scale = null, isRGB, $tempBrush, i, brushes, $tempBrushCollection;
            if (value.type) {
                type = value.type;
            }

            switch (type) {
                case "value":
                    scale = new $.ig.ValueBrushScale();
                    break;
                case "customPalette":
                    scale = new $.ig.CustomPaletteBrushScale();
                    break;
            }

            if (scale) {
                if (value.brushes) {
                    isRGB = true;
                    brushes = value.brushes;
                    if ((typeof brushes[0] === "string" && brushes[0] === "HSV") || brushes[0] === "RGB") { if (brushes[0] === "HSV") { isRGB = false; } brushes = brushes.slice(1); }
                    $tempBrushCollection = new $.ig.BrushCollection();
                    for (i = 0; i < brushes.length; i++) {
                        $tempBrushCollection.add(this._createBrushFromValue(brushes[i]));
                    }
                    scale.brushes($tempBrushCollection);
                }
                if (value.brushSelectionMode) {
                    switch (value.brushSelectionMode) {
                        case "select":
                            scale.brushSelectionMode(0);
                            break;
                        case "interpolate":
                            scale.brushSelectionMode(1);
                            break;
                    }
                }
                if (value.minimumValue) {
                    scale.minimumValue(value.minimumValue);
                }
                if (value.maximumValue) {
                    scale.maximumValue(value.maximumValue);
                }
                if (value.isLogarithmic) {
                    scale.isLogarithmic(value.isLogarithmic);
                }
                if (value.logarithmBase) {
                    scale.logarithmBase(value.logarithmBase);
                }
            }

            return scale;
        },
        _setAxisOption: function (axis, key, value) {
            var $tempBrush;
            switch (key) {
                case "strokeThickness":
                case "majorStrokeThickness":
                case "minorStrokeThickness":
                case "isInverted":
                case "crossingValue":
                case "label":
                case "gap":
                case "overlap":
                case "interval":
                case "startAngleOffset":
                case "minimumValue":
                case "maximumValue":
                case "referenceValue":
                case "isLogarithmic":
                case "logarithmBase":
                case "radiusExtentScale":
                case "innerRadiusExtentScale":
                case "dateTimeMemberPath":
                case "formatLabel":
                case "title":
                case "useClusteringMode":
                    if (axis[key]) {
                        axis[key](value);
                    }
                    return true;
                case "stroke":
                    axis.stroke(this._createBrushFromValue(value));
                    return true;
                case "strip":
                    axis.strip(this._createBrushFromValue(value));
                    return true;
                case "majorStroke":
                    axis.majorStroke(this._createBrushFromValue(value));
                    return true;
                case "minorStroke":
                    axis.minorStroke(this._createBrushFromValue(value));
                    return true;
                case "scaleMode":
                    switch (value) {
                        case "linear":
                            axis.scaleMode(0);
                            break;
                        case "logarithmic":
                            axis.scaleMode(1);
                            break;
                    }
                    return true;
                case "expectFunctions":
                    axis.expectFunctions(value);
                    return true;
            }
        },
        _setCoreAxisOption: function (axis, key, value) {
            var labelSettings = null, titleSettings = null, tempBrush, tempAxis, self = this;

            switch (key) {
                case "crossingAxis":
                    if (value) {
                        tempAxis = this._getAxisByName(value);
                        if (tempAxis) {
                            axis.crossingAxis(tempAxis);
                        } else {
                            this.widget._pendingCrossingAxes.push(function () {
                                var tempAxis = self._getAxisByName(value);
                                if (tempAxis) {
                                    axis.crossingAxis(tempAxis);
                                }
                            });
                        }
                    } else {
                        axis.crossingAxis(null);
                    }
                    break;
                case "labelLocation":
                    labelSettings = axis.labelSettings();
                    if (labelSettings === null) {
                        labelSettings = new $.ig.AxisLabelSettings();
                    }
                    switch (value) {
                        case "outsideTop":
                            labelSettings.location(0);
                            break;
                        case "outsideBottom":
                            labelSettings.location(1);
                            break;
                        case "outsideLeft":
                            labelSettings.location(2);
                            break;
                        case "outsideRight":
                            labelSettings.location(3);
                            break;
                        case "insideTop":
                            labelSettings.location(4);
                            break;
                        case "insideBottom":
                            labelSettings.location(5);
                            break;
                        case "insideLeft":
                            labelSettings.location(6);
                            break;
                        case "insideRight":
                            labelSettings.location(7);
                            break;
                        default:
                            break;
                    }
                    if (!axis.labelSettings()) {
                        axis.labelSettings(labelSettings);
                    }
                    break;
                case "labelVisibility":
                    labelSettings = axis.labelSettings();
                    if (labelSettings === null) {
                        labelSettings = new $.ig.AxisLabelSettings();
                    }
                    switch (value) {
                        case "visible":
                            labelSettings.visibility(0);
                            break;
                        case "collapsed":
                            labelSettings.visibility(1);
                            break;
                        default:
                            break;
                    }
                    if (!axis.labelSettings()) {
                        axis.labelSettings(labelSettings);
                    }
                    break;
                case "labelExtent":
                    if (value === null) {
                        value = NaN;
                    }
                    labelSettings = axis.labelSettings();
                    if (labelSettings === null) {
                        labelSettings = new $.ig.AxisLabelSettings();
                    }
                    labelSettings.extent(value);
                    if (!axis.labelSettings()) {
                        axis.labelSettings(labelSettings);
                    }
                    break;
                case "labelHorizontalAlignment":
                    labelSettings = axis.labelSettings();
                    if (labelSettings === null) {
                        labelSettings = new $.ig.AxisLabelSettings();
                    }
                    switch (value) {
                        case "left":
                            labelSettings.horizontalAlignment(0);
                            break;
                        case "center":
                            labelSettings.horizontalAlignment(1);
                            break;
                        case "right":
                            labelSettings.horizontalAlignment(2);
                            break;
                        case "stretch":
                            labelSettings.horizontalAlignment(1);
                            break;
                        default:
                            break;
                    }
                    if (!axis.labelSettings()) {
                        axis.labelSettings(labelSettings);
                    }
                    break;
                case "labelVerticalAlignment":
                    labelSettings = axis.labelSettings();
                    if (labelSettings === null) {
                        labelSettings = new $.ig.AxisLabelSettings();
                    }
                    switch (value) {
                        case "top":
                            labelSettings.verticalAlignment(0);
                            break;
                        case "center":
                            labelSettings.verticalAlignment(1);
                            break;
                        case "bottom":
                            labelSettings.verticalAlignment(2);
                            break;
                        case "stretch":
                            labelSettings.verticalAlignment(1);
                            break;
                        default:
                            break;
                    }
                    if (!axis.labelSettings()) {
                        axis.labelSettings(labelSettings);
                    }
                    break;
                case "labelMargin":
                    labelSettings = axis.labelSettings();
                    if (labelSettings === null) {
                        labelSettings = new $.ig.AxisLabelSettings();
                    }
                    labelSettings.margin(value);
                    if (!axis.labelSettings()) {
                        axis.labelSettings(labelSettings);
                    }
                    break;
                case "labelTopMargin":
                    labelSettings = axis.labelSettings();
                    if (labelSettings === null) {
                        labelSettings = new $.ig.AxisLabelSettings();
                    }
                    labelSettings.topMargin(value);
                    if (!axis.labelSettings()) {
                        axis.labelSettings(labelSettings);
                    }
                    break;
                case "labelRightMargin":
                    labelSettings = axis.labelSettings();
                    if (labelSettings === null) {
                        labelSettings = new $.ig.AxisLabelSettings();
                    }
                    labelSettings.rightMargin(value);
                    if (!axis.labelSettings()) {
                        axis.labelSettings(labelSettings);
                    }
                    break;
                case "labelBottomMargin":
                    labelSettings = axis.labelSettings();
                    if (labelSettings === null) {
                        labelSettings = new $.ig.AxisLabelSettings();
                    }
                    labelSettings.bottomMargin(value);
                    if (!axis.labelSettings()) {
                        axis.labelSettings(labelSettings);
                    }
                    break;
                case "labelLeftMargin":
                    labelSettings = axis.labelSettings();
                    if (labelSettings === null) {
                        labelSettings = new $.ig.AxisLabelSettings();
                    }
                    labelSettings.leftMargin(value);
                    if (!axis.labelSettings()) {
                        axis.labelSettings(labelSettings);
                    }
                    break;
                case "showFirstLabel":
                    labelSettings = axis.labelSettings();
                    if (labelSettings === null) {
                        labelSettings = new $.ig.AxisLabelSettings();
                    }
                    labelSettings.showFirstLabel(value);
                    if (!axis.labelSettings()) {
                        axis.labelSettings(labelSettings);
                    }
                    break;
                case "labelAngle":
                    if (value === null) {
                        value = 0;
                    }
                    labelSettings = axis.labelSettings();
                    if (labelSettings === null) {
                        labelSettings = new $.ig.AxisLabelSettings();
                    }
                    labelSettings.angle(value);
                    if (!axis.labelSettings()) {
                        axis.labelSettings(labelSettings);
                    }
                    break;
                case "labelTextStyle":
                    labelSettings = axis.labelSettings();
                    if (labelSettings === null) {
                        labelSettings = new $.ig.AxisLabelSettings();
                    }
                    labelSettings.textStyle(value);
                    if (!axis.labelSettings()) {
                        axis.labelSettings(labelSettings);
                    }
                    break;
                case "labelTextColor":
                    labelSettings = axis.labelSettings();
                    if (labelSettings === null) {
                        labelSettings = new $.ig.AxisLabelSettings();
                    }
                    labelSettings.textColor(this._createBrushFromValue(value));
                    if (!axis.labelSettings()) {
                        axis.labelSettings(labelSettings);
                    }
                    break;
                case "titleAngle":
                    if (value === null) {
                        value = 0;
                    }
                    titleSettings = axis.titleSettings();
                    if (titleSettings === null) {
                        titleSettings = new $.ig.TitleSettings();
                    }
                    titleSettings.angle(value);
                    if (!axis.titleSettings()) {
                        axis.titleSettings(titleSettings);
                    }
                    break;
                case "titleTextStyle":
                    titleSettings = axis.titleSettings();
                    if (titleSettings === null) {
                        titleSettings = new $.ig.TitleSettings();
                    }
                    titleSettings.textStyle(value);
                    if (!axis.titleSettings()) {
                        axis.titleSettings(titleSettings);
                    }
                    break;
                case "titleMargin":
                    titleSettings = axis.titleSettings();
                    if (titleSettings === null) {
                        titleSettings = new $.ig.TitleSettings();
                    }
                    titleSettings.margin(value);
                    if (!axis.titleSettings()) {
                        axis.titleSettings(titleSettings);
                    }
                    break;
                case "titleTopMargin":
                    titleSettings = axis.titleSettings();
                    if (titleSettings === null) {
                        titleSettings = new $.ig.TitleSettings();
                    }
                    titleSettings.topMargin(value);
                    if (!axis.titleSettings()) {
                        axis.titleSettings(titleSettings);
                    }
                    break;
                case "titleRightMargin":
                    titleSettings = axis.titleSettings();
                    if (titleSettings === null) {
                        titleSettings = new $.ig.TitleSettings();
                    }
                    titleSettings.rightMargin(value);
                    if (!axis.titleSettings()) {
                        axis.titleSettings(titleSettings);
                    }
                    break;
                case "titleBottomMargin":
                    titleSettings = axis.titleSettings();
                    if (titleSettings === null) {
                        titleSettings = new $.ig.TitleSettings();
                    }
                    titleSettings.bottomMargin(value);
                    if (!axis.titleSettings()) {
                        axis.titleSettings(titleSettings);
                    }
                    break;
                case "titleLeftMargin":
                    titleSettings = axis.titleSettings();
                    if (titleSettings === null) {
                        titleSettings = new $.ig.TitleSettings();
                    }
                    titleSettings.leftMargin(value);
                    if (!axis.titleSettings()) {
                        axis.titleSettings(titleSettings);
                    }
                    break;
                case "titleTextColor":
                    titleSettings = axis.titleSettings();
                    if (titleSettings === null) {
                        titleSettings = new $.ig.TitleSettings();
                    }
                    titleSettings.textColor(this._createBrushFromValue(value));
                    if (!axis.titleSettings()) {
                        axis.titleSettings(titleSettings);
                    }
                    break;

                case "titleVerticalAlignment":
                    titleSettings = axis.titleSettings();
                    if (titleSettings === null) {
                        titleSettings = new $.ig.TitleSettings();
                    }
                    switch (value) {
                        case "top":
                            titleSettings.verticalAlignment(0);
                            break;
                        case "center":
                            titleSettings.verticalAlignment(1);
                            break;
                        case "bottom":
                            titleSettings.verticalAlignment(2);
                            break;
                        default:
                            break;
                    }
                    if (!axis.titleSettings()) {
                        axis.titleSettings(titleSettings);
                    }
                    break;
                case "titleHorizontalAlignment":
                    titleSettings = axis.titleSettings();
                    if (titleSettings === null) {
                        titleSettings = new $.ig.TitleSettings();
                    }

                    switch (value) {
                        case "left":
                            titleSettings.horizontalAlignment(0);
                            break;
                        case "center":
                            titleSettings.horizontalAlignment(1);
                            break;
                        case "right":
                            titleSettings.horizontalAlignment(2);
                            break;
                        default:
                            break;
                    }
                    if (!axis.titleSettings()) {
                        axis.titleSettings(titleSettings);
                    }
                    break;
                case "titlePosition":
                    titleSettings = axis.titleSettings();
                    if (titleSettings === null) {
                        titleSettings = new $.ig.TitleSettings();
                    }
                    switch (value) {
                        case "auto":
                            titleSettings.position(0);
                            break;
                        case "left":
                            titleSettings.position(1);
                            break;
                        case "right":
                            titleSettings.position(2);
                            break;
                        case "top":
                            titleSettings.position(3);
                            break;
                        case "bottom":
                            titleSettings.position(4);
                            break;
                        default:
                            break;
                    }
                    if (!axis.titleSettings()) {
                        axis.titleSettings(titleSettings);
                    }
                    break;
                case "tickLength":
                    axis.tickLength(value);
                    break;
                case "tickStrokeThickness":
                    axis.tickStrokeThickness(value);
                    break;
                case "tickStroke":
                    axis.tickStroke(this._createBrushFromValue(value));
                    break;
                case "displayType":
                    switch (value) {
                        case "continuous":
                            axis.displayType(0);
                            break;
                        case "discrete":
                            axis.displayType(1);
                            break;
                    }
            }
        },
        _setOption: function (key, value) {
            //check if it is a data option
            if (key === "dataSource" || key === "dataSourceUrl" || key === "responseDataKey" || (value && value[0] && (value[0].dataSource !== undefined || value[0].dataSourceUrl !== undefined))) {
                var dataOptions = {}, id;
                if (key === "dataSource" || key === "dataSourceUrl") {
                    dataOptions.dataSource = value;
                    if (this.widget.options.responseDataKey) {
                        dataOptions.responseDataKey = this.widget.options.responseDataKey;
                    }
                    id = this.widget._containerSourceID;
                } else if (key === "responseDataKey") {
                    dataOptions.responseDataKey = value;
                    if (this.widget.options.dataSource) {
                        dataOptions.dataSource = this.widget.options.dataSource;
                    } else if (this.widget.options.dataSourceUrl) {
                        dataOptions.dataSource = this.widget.options.dataSourceUrl;
                    }
                    id = this.widget._containerSourceID;
                } else {
                    dataOptions = value[0];
                    id = value[0].name;
                    if (this.widget._target && this.widget._target.name() === id) {
                        this.widget._target = null;
                    }
                }
				this.widget._setCoreCallbackOptions = { key: key, value: value};
                this._setupDataSource(dataOptions, this._chartDataCallBack);
                if (id === undefined || id === null) {
                    id = this.widget._containerSourceID;
                }
                this.widget.dataSources[id].dataBind();
                if (key === "dataSource") {
                    this.widget.options.dataSource = value;
                }
                if (key === "dataSourceUrl") {
                    this.widget.options.dataSourceUrl = value;
                }
                if (key === "responseDataKey") {
                    this.widget.options.responseDataKey = value;
                }
            } else if (value && value[0] && (value[0].shapeDataSource !== undefined || value[0].triangulatedDataSource !== undefined)) {
                this.widget._initConverter(value[0], this._convDataCallback);
				this.widget._setCoreCallbackOptions = { key: key, value: value};
            } else {
                this._setOptionAfterInit(key, value);
            }
        },
        _chartDataCallBack: function (success, e, dataSource) {
            var key = this.widget._setCoreCallbackOptions.key, value = this.widget._setCoreCallbackOptions.value;
            if (!success) {
                return false;
            }
            this._setItemsSource(this.widget, this._getNotifyTarget(dataSource.settings.id), dataSource.settings.id);
            if (key === "series" || key === "axes") {
                this._setOptionAfterInit(key, value);
            }
        },
        _convDataCallback: function () {
            var context = this.settings.callee, id = this.settings.id, key = context.widget._setCoreCallbackOptions.key, value = context.widget._setCoreCallbackOptions.value;
            context._setItemsSource(context.widget, context._getNotifyTarget(id), id);
            if (key === "series") {
                context._setOptionAfterInit(key, value);
            }
        },
        _setOptionAfterInit: function (key, value) {
            if (!this._setWidgetOption(this.widget._chart, key, value)) {
                this._setCoreWidgetOption(this.widget._chart, key, value);
            } else {
                //still propagate a value into the options so that it can be examined by the user.
                this.widget.options[key] = value;
            }
        },
        _setItemsSource: function (widget, target, id) {
            var ds = widget.dataSources[id];
            if (target === widget._chart) {
                if (ds !== null) {
                    widget._chart.setWidgetLevelDataSource(ds);
                } else {
                    widget._chart.removeWidgetLevelDataSource();
                }
            } else {
                if (ds !== null) {
                    widget._chart.setSpecificDataSource(id, ds);
                } else {
                    widget._chart.removeSpecificDataSource(id, false);
                }
            }
        },
        _initialDataBind: function () {
            var ds = this._initDataSources(), self = this;
            $.each(ds, function (i, val) {
                if (typeof self.widget.dataSources[i].dataBind === 'function') {
                    self.widget.dataSources[i].dataBind();
                }
            });
        },
        _initDataSources: function () {
            var self = this, widget = this.widget, options = this.widget.options, axes, series;
            widget.dataSources = {};
            widget.dsCount = 0;
            if (options.dataSource || options.dataSourceUrl) {
                widget.dsCount++;
                self._setupDataSource(options, this._initCallback);
            }
            if (options.shapeDataSource || options.triangulationDataSource) {
                widget.dsCount++;
                self.widget._initConverter(options, self._converterCallback);
            }
            if (options.axes) {
                axes = options.axes;
                $.each(axes, function (i, val) {
                    if (val.dataSource || val.dataSourceUrl) {
                        widget.dsCount++;
                        self._setupDataSource(val, self._initCallback);
                    }
                });
            }
            if (options.series) {
                series = options.series;
                $.each(series, function (i, val) {
                    if (val.dataSource || val.dataSourceUrl) {
                        widget.dsCount++;
                        self._setupDataSource(val, self._initCallback);
                    }
                    if (val.shapeDataSource || val.triangulationDataSource) {
                        widget.dsCount++;
                        self.widget._initConverter(val, self._converterCallback);
                    }
                });
            }
            return widget.dataSources;
        },
        _drawCanvas: function (canvasElemnts, iWidth, iHeight) {
            var oSaveCanvas = document.createElement("canvas"), oSaveCtx;

            oSaveCanvas.width = iWidth;
            oSaveCanvas.height = iHeight;
            oSaveCanvas.style.width = iWidth + "px";
            oSaveCanvas.style.height = iHeight + "px";

            oSaveCtx = oSaveCanvas.getContext("2d");
            $.each(canvasElemnts, function (i, canvas) {
                oSaveCtx.drawImage(canvas, 0, 0, iWidth, iHeight);
            });
            return oSaveCanvas;
        },
        _getLegendElements: function () {
            var options = this.widget.options, elements = [];
            if (this.widget.options.legend) {
                elements.push($('#' + this.widget.options.legend.element));
            }
            if (options.series) {
                $.each(options.series, function (i, ser) {
                    if (ser && ser.legend) {
                        elements.push($('#' + ser.legend.element));
                    }
                });
            }
            return elements;
        },
        _print: function () {
            var doc = document,
				widget = this.widget,
				legends = this._getLegendElements(),
				chartWrapper = $('#' + this.widget.id()),
				origDisplay = [],
				origWrappers = [],
				body = doc.body,
				childNodes = body.childNodes;

            if (widget._isPrinting) {
                return;
            }

            widget._isPrinting = true;

            $.each(childNodes, function (i, node) {
                if (node.nodeType === 1) {
                    origDisplay[i] = node.style.display;
                    node.style.display = 'none';
                }
            });
            origWrappers[0] = (chartWrapper.parent());
            $(body).append(chartWrapper);

            $.each(legends, function (i, legend) {
                origWrappers[i + 1] = legend.parent();
                $(body).append(legend);
            });

            window.print();
            //restore
            setTimeout(function () {
                widget._isPrinting = false;
                origWrappers[0].prepend(chartWrapper);
                $.each(legends, function (i, legend) {
                    origWrappers[i + 1].prepend(legend);
                });

                $.each(childNodes, function (i, node) {
                    if (node.nodeType === 1) {
                        node.style.display = origDisplay[i];
                    }
                });

            }, 1000);
        },
        _getImage: function (width, height, chart) {
            var expCanvas, imgElement = document.createElement("img");
            width = width || $('#' + chart.id() + '_chart_container').width();
            height = height || $('#' + chart.id() + '_chart_container').height();
            expCanvas = this._drawCanvas($('#' + chart.id() + ' canvas'), width, height);
            imgElement.src = expCanvas.toDataURL("image/png");
            return imgElement;
        },
        _initSize: function (widget, o) {
            var v, key, size, i = -1,
				chart = widget._chart,
				elem = widget.element[0];
            this._oldProp = { width: elem.style.width, height: elem.style.height };
            while (i++ < 1) {
                key = i === 0 ? "width" : "height";
                if (o[key]) {
                    size = key;
                } else {
                    v = elem.style[key];
                    if (!v || (v && v.indexOf("%") > 0)) {
                        this._setSize(chart, size = key, v || 500);
                    }
                }
            }
            // _setSize should be called at least once: support for initially invisible container of char
            if (!size) {
                this._setSize(chart, "width");
            }
        },
        _setSize: function (chart, key, val) {
            $.ig.util.setSize(this.widget.element, key, val, chart, "notifyContainerResized");
        },
        _renderChartContainer: function (chart) {
            var opt = chart.options, chartElement;

            if (!chart._isRendered) {
                chartElement = $("<div id='" + chart.id() + "_chart_container' style='width:100%;height:100%'></div>").appendTo(chart.element);
                chartElement.addClass(chart.css.chart || chart.css.map);
                this._chartElement = chartElement;
                chart._chart.provideContainer(chartElement);
                this._initSize(chart, opt);
            }
        },

        _setLegend: function (item, value) {
            var legend;
            if (value !== null) {
                value.owner = this.widget;
                if (value.type === undefined) {
                    value.type = (this.widget.widgetName === "igPieChart") ? "item" : "legend";
                }
                if (item.legend() === null) {
                    //check if the widget is created already
                    if ($('#' + value.element).data("igChartLegend") || (value.data && value.data("igChartLegend"))) {
                        legend = (!value.element) ? value.data("igChartLegend") : $('#' + value.element).data("igChartLegend");
                        legend.options.owner = this.widget.options;
                        legend._owner = this.widget;
                    } else {
                        legend = $('#' + value.element).igChartLegend(value).data("igChartLegend");
                    }
                    item.legend(legend.legend);
                } else {
                    $('#' + item.legend().name()).igChartLegend(value);
                }
            } else {
                if (item.legend() !== null && $('#' + item.legend().name()).length > 0) {
                    $('#' + item.legend().name()).igChartLegend('destroy');
                }
            }
        },

        _mergeDataSourceSettings: function (s1, s2) {
            if (!s1) {
                return s2;
            }
            if (!s2) {
                return s1;
            }
            var source1 = s1.dataSource, source2 = s2.dataSource, newSettings;
            if (source1 && ($.type(source1) === "array" || $.type(source1) === "object")) {
                s1.dataSource = null;
            }
            if (source2 && ($.type(source2) === "array" || $.type(source2) === "object")) {
                s2.dataSource = null;
            }
            newSettings = $.extend(true, {}, s1, s2);
            if (source2 && ($.type(source2) === "array" || $.type(source2) === "object")) {
                s2.dataSource = source2;
                newSettings.dataSource = source2;
            } else if (source1 && ($.type(source1) === "array" || $.type(source1) === "object")) {
                s1.dataSource = source1;
            }
            if (source2 === null) {
                newSettings.dataSource = null;
            }
            return newSettings;
        },

        _mergeIntoWithDataSource: function (o1, o2) {
            var ds1, ds2, setToNull, s1 = null, s2 = null;
            if (o1.dataSource) {
                ds1 = o1.dataSource;
            }
            if (o2.dataSource) {
                ds2 = o2.dataSource;
            }
            setToNull = false;
            if (o2.dataSource === null) {
                setToNull = true;
            }

            if (o1.dataSource) {
                o1.dataSource = null;
            }
            if (o2.dataSource) {
                o2.dataSource = null;
            }

            $.extend(true, o1, o2);
            if (ds1) {
                o1.dataSource = ds1;
            }
            if (ds2) {
                o2.dataSource = ds2;
                o1.dataSource = ds2;
            }
            if (o1.dataSource) {
                if (o1.dataSource && o1.dataSource.settings) {
                    s1 = o1.dataSource.settings;
                }
                if (o2.dataSource && o2.dataSource.settings) {
                    s2 = o2.dataSource.settings;
                }
                o1.dataSource.settings = this._mergeDataSourceSettings(s1, s2);
            }
        },

        _mergeIntoNewWithDataSource: function (o1, o2) {
            var ds1, ds2, setToNull, newObj, s1 = null, s2 = null;
            if (o1.dataSource) {
                ds1 = o1.dataSource;
            }
            if (o2.dataSource) {
                ds2 = o2.dataSource;
            }
            setToNull = false;
            if (o2.dataSource === null) {
                setToNull = true;
            }

            if (o1.dataSource) {
                o1.dataSource = null;
            }
            if (o2.dataSource) {
                o2.dataSource = null;
            }

            newObj = $.extend(true, {}, o1, o2);

            if (ds1) {
                o1.dataSource = ds1;
                newObj.dataSource = ds1;
            }
            if (ds2) {
                o2.dataSource = ds2;
                newObj.dataSource = ds2;
            }
            if (newObj.dataSource) {
                if (o1.dataSource && o1.dataSource.settings) {
                    s1 = o1.dataSource.settings;
                }
                if (o2.dataSource && o2.dataSource.settings) {
                    s2 = o2.dataSource.settings;
                }
                newObj.dataSource.settings = this._mergeDataSourceSettings(s1, s2);
            }

            return newObj;
        },

        _addTooltip: function (widget, series, clss) {
            if (typeof widget._chart.toolTip === 'function') {
                if (widget._tooltip[widget.id()] === undefined) {
                    widget._tooltip[widget.id()] = $("<div id=\"" + widget.id() + "_tooltip\" class=\"" + clss + "\"></div>");
                }
                this._bindTooltipEvents(widget, widget._tooltip[widget.id()]);
                widget._chart.toolTip(widget._tooltip[widget.id()]);
            } else {
                if (widget._tooltip[series.name()] === undefined) {
                    widget._tooltip[series.name()] = $("<div id=\"" + series.name() + "_tooltip\" class=\"" + clss + "\"></div>");
                }
                this._bindTooltipEvents(widget, widget._tooltip[series.name()]);
                series.toolTip(widget._tooltip[series.name()]);
            }
        },

        _removeTooltip: function (widget, series) {
            if (typeof widget._chart.toolTip === 'function') {
                if (widget._tooltip[widget.id()] !== undefined) {
                    this._removeTooltipEvents(widget, widget._tooltip[widget.id()]);
                    delete widget._tooltip[widget.id()];
                    widget._chart.toolTip(null);
                }
            } else {
                if (widget._tooltip[series.name()] !== undefined) {
                    this._removeTooltipEvents(widget, widget._tooltip[series.name()]);
                    delete widget._tooltip[series.name()];
                    series.toolTip(null);
                }
            }
        },

        _bindTooltipEvents: function (chart, tooltip) {
            tooltip.updateToolTip = $.ig.Delegate.prototype.combine(tooltip.updateToolTip, jQuery.proxy(this._fireToolTip_updateToolTip, this));
            tooltip.hideToolTip = $.ig.Delegate.prototype.combine(tooltip.hideToolTip, jQuery.proxy(this._fireToolTip_hideToolTip, this));
        },

        _removeTooltipEvents: function (chart, tooltip) {
            delete tooltip.updateToolTip;
            delete tooltip.hideToolTip;
        },

        _bindMapEvents: function (chart) {
            chart.seriesCursorMouseMove = $.ig.Delegate.prototype.combine(chart.seriesCursorMouseMove, jQuery.proxy(this._fireChart_seriesCursorMouseMove, this));
            chart.seriesMouseLeftButtonDown = $.ig.Delegate.prototype.combine(chart.seriesMouseLeftButtonDown, jQuery.proxy(this._fireChart_seriesMouseLeftButtonDown, this));
            chart.seriesMouseLeftButtonUp = $.ig.Delegate.prototype.combine(chart.seriesMouseLeftButtonUp, jQuery.proxy(this._fireChart_seriesMouseLeftButtonUp, this));
            chart.seriesMouseMove = $.ig.Delegate.prototype.combine(chart.seriesMouseMove, jQuery.proxy(this._fireChart_seriesMouseMove, this));
            chart.seriesMouseEnter = $.ig.Delegate.prototype.combine(chart.seriesMouseEnter, jQuery.proxy(this._fireChart_seriesMouseEnter, this));
            chart.seriesMouseLeave = $.ig.Delegate.prototype.combine(chart.seriesMouseLeave, jQuery.proxy(this._fireChart_seriesMouseLeave, this));
            chart.windowRectChanged = $.ig.Delegate.prototype.combine(chart.windowRectChanged, jQuery.proxy(this._fireChart_windowRectChanged, this));
            chart.actualWindowRectChanged = $.ig.Delegate.prototype.combine(chart.actualWindowRectChanged, jQuery.proxy(this._fireChart_actualWindowRectChanged, this));
            chart.gridAreaRectChanged = $.ig.Delegate.prototype.combine(chart.gridAreaRectChanged, jQuery.proxy(this._fireChart_gridAreaRectChanged, this));
            chart.refreshCompleted = $.ig.Delegate.prototype.combine(chart.refreshCompleted, jQuery.proxy(this._fireChart_refreshCompleted, this));
            chart.imageTilesReady = $.ig.Delegate.prototype.combine(chart.imageTilesReady, jQuery.proxy(this._fireChart_imageTilesReady, this));

            chart.notifyCrosshairUpdate = $.ig.Delegate.prototype.combine(chart.notifyCrosshairUpdate, jQuery.proxy(this._notifyCrosshairUpdate, this));
        },

        _bindSeriesEvents: function (series) {
            if (series.basedOnColumns !== undefined) {
                series.basedOnColumns($.ig.Delegate.prototype.combine(series.basedOnColumns(), jQuery.proxy(this._fireChart_basedOnColumns, this)));
            }
            if (series.indicator !== undefined) {
                series.indicator($.ig.Delegate.prototype.combine(series.indicator(), jQuery.proxy(this._fireChart_indicator, this)));
            }
            if (series.typical !== undefined) {
                series.typical = $.ig.Delegate.prototype.combine(series.typical, jQuery.proxy(this._fireChart_typical, this));
            }
            if (series.typicalBasedOn !== undefined) {
                series.typicalBasedOn = $.ig.Delegate.prototype.combine(series.typicalBasedOn, jQuery.proxy(this._fireChart_typicalBasedOn, this));
            }
            if (series.triangulationStatusChanged !== undefined) {
                series.triangulationStatusChanged = $.ig.Delegate.prototype.combine(series.triangulationStatusChanged, jQuery.proxy(this._fireMap_triangulationStatusChanged, this));
            }
            if (series.progressiveLoadStatusChanged !== undefined) {
                series.progressiveLoadStatusChanged = $.ig.Delegate.prototype.combine(series.progressiveLoadStatusChanged, jQuery.proxy(this._fireChart_progressiveLoadStatusChanged, this));
            }
            if (series.assigningCategoryStyle !== undefined) {
                series.assigningCategoryStyle = $.ig.Delegate.prototype.combine(series.assigningCategoryStyle, jQuery.proxy(this._fireChart_assigningCategoryStyle, this));
            }
            if (series.assigningCategoryMarkerStyle !== undefined) {
                series.assigningCategoryMarkerStyle = $.ig.Delegate.prototype.combine(series.assigningCategoryMarkerStyle, jQuery.proxy(this._fireChart_assigningCategoryMarkerStyle, this));
            }
            //if (series.scatterMouseOver !== undefined) {
            //	series.scatterMouseOver = $.ig.Delegate.prototype.combine(series.scatterMouseOver, jQuery.proxy(this._fireChart_scatterMouseOver, this));
            //}
        },
        _getWidgetName: function () {
            switch (this.widget.widgetName) {
                case "igPieChart":
                case "igDataChart":
                    return "chart";
                case "igMap":
                    return "map";
            }
        },
        _fireChart_progressiveLoadStatusChanged: function (sender, evtArgs) {
            var e = {}, widget = this._getWidgetName(), seriesOpt = this.widget._seriesOpt[sender.name()];
            e.currentStatus = evtArgs.currentStatus();
            e[widget] = this.widget.options;
            e.series = seriesOpt;
            seriesOpt.progressiveStatus = e.currentStatus;
            this.widget._trigger("progressiveLoadStatusChanged", null, e);
        },
        _fireChart_scatterMouseOver: function (sender, evtArgs) {
            var e = {}, widget = this._getWidgetName();
            e[widget] = this.widget.options;
            e.args = evtArgs;
            e.series = sender;
            this.widget._trigger("scatterMouseOver", null, e);
        },
        _fireChart_typicalBasedOn: function (sender, evtArgs) {
            var e = {}, widget = this._getWidgetName(), seriesOpt = this.widget._seriesOpt[sender.name()], i, intSeries = this.widget._series[sender.name()], self = this;
            e[widget] = this.widget.options;
            e.series = seriesOpt;
            e.position = evtArgs.position();
            e.count = evtArgs.count();
            e.getDataSource = function () {
                return self._flattenDataSource(intSeries, evtArgs.dataSource());
            };
            e.basedOn = []; //evtArgs.basedOn();
            e.minimumValue = evtArgs.dataSource().minimumValue();
            e.maximumValue = evtArgs.dataSource().maximumValue();
            this.widget._trigger("typicalBasedOn", null, e);
            if (e.basedOn !== null && e.basedOn.length && e.basedOn.length > 0) {
                for (i = 0; i < e.basedOn.length; i++) {
                    evtArgs.basedOn().add(e.basedOn[i]);
                }
            }
            if (!isNaN(e.minimum)) {
                evtArgs.dataSource().minimumValue(e.minimumValue);
            }
            if (!isNaN(e.maximum)) {
                evtArgs.dataSource().maximumValue(e.maximumValue);
            }
        },
        _fireChart_basedOnColumns: function (sender, evtArgs) {
            var e = {}, widget = this._getWidgetName(), seriesOpt = this.widget._seriesOpt[sender.name()], i, intSeries = this.widget._series[sender.name()], self = this;
            e[widget] = this.widget.options;
            e.series = seriesOpt;
            e.position = evtArgs.position();
            e.count = evtArgs.count();
            e.getDataSource = function () {
                return self._flattenDataSource(intSeries, evtArgs.dataSource());
            };
            e.basedOn = []; //evtArgs.basedOn();
            e.minimumValue = evtArgs.dataSource().minimumValue();
            e.maximumValue = evtArgs.dataSource().maximumValue();
            this.widget._trigger("basedOn", null, e);
            if (e.basedOn !== null && e.basedOn.length && e.basedOn.length > 0) {
                for (i = 0; i < e.basedOn.length; i++) {
                    evtArgs.basedOn().add(e.basedOn[i]);
                }
            }
            if (!isNaN(e.minimum)) {
                evtArgs.dataSource().minimumValue(e.minimumValue);
            }
            if (!isNaN(e.maximum)) {
                evtArgs.dataSource().maximumValue(e.maximumValue);
            }
        },
        _fireChart_indicator: function (sender, evtArgs) {
            var e = {}, widget = this._getWidgetName(), seriesOpt = this.widget._seriesOpt[sender.name()], intSeries = this.widget._series[sender.name()], self = this;
            e[widget] = this.widget.options;
            e.series = seriesOpt;
            e.position = evtArgs.position();
            e.count = evtArgs.count();
            e.getDataSource = function () {
                return self._flattenDataSource(intSeries, evtArgs.dataSource());
            };
            e.basedOn = evtArgs.basedOn();
            e.minimumValue = evtArgs.dataSource().minimumValue();
            e.maximumValue = evtArgs.dataSource().maximumValue();
            this.widget._trigger("indicator", null, e);
            if (!isNaN(e.minimum)) {
                evtArgs.dataSource().minimumValue(e.minimumValue);
            }
            if (!isNaN(e.maximum)) {
                evtArgs.dataSource().maximumValue(e.maximumValue);
            }
        },
        _fireChart_typical: function (sender, evtArgs) {
            var e = {}, widget = this._getWidgetName(), seriesOpt = this.widget._seriesOpt[sender.name()],
				intSeries = this.widget._series[sender.name()], self = this,
				typicalRet, tBasedOn;
            e[widget] = this.widget.options;
            e.series = seriesOpt;
            e.position = evtArgs.position();
            e.count = evtArgs.count();
            e.getDataSource = function () {
                var ds = self._flattenDataSource(intSeries, evtArgs.dataSource());
                return ds;
            };
            e.basedOn = evtArgs.basedOn();
            e.minimumValue = evtArgs.dataSource().minimumValue();
            e.maximumValue = evtArgs.dataSource().maximumValue();
            e.typicalColumn = [];
            tBasedOn = evtArgs.dataSource().typicalColumn().basedOn();
            this.widget._trigger("typical", null, e);
            if (e.typicalColumn !== null && e.typicalColumn.length > 0) {
                typicalRet = new $.ig.List$1(Number, 1, e.typicalColumn);
                evtArgs.dataSource().typicalColumn(new $.ig.CalculatedColumn(1, typicalRet, tBasedOn));
            } else {
                evtArgs.dataSource().typicalColumn(null);
            }

            if (!isNaN(e.minimum)) {
                evtArgs.dataSource().minimumValue(e.minimumValue);
            }
            if (!isNaN(e.maximum)) {
                evtArgs.dataSource().maximumValue(e.maximumValue);
            }
        },
        _flattenHighlightingInfo: function (info) {
            var ret = null;
            if (info === null) {
                return ret;
            }

            ret = {};
            ret.startIndex = info.startIndex();
            ret.endIndex = info.endIndex();
            switch (info.state()) {
                case 0:
                    ret.state = "out";
                    break;
                case 1:
                    ret.state = "in";
                    break;
                case 2:
                    ret.state = "static";
                    break;
            }
            ret.progress = info.progress();
            ret.isMarker = info.isMarker();
            return ret;
        },
        _fireChart_assigningCategoryMarkerStyle: function (sender, evtArgs) {
            var e = {}, widget = this._getWidgetName(), seriesOpt = this.widget._seriesOpt[sender.name()], inFill,
			inStroke, inStrokeDashArray, outFill, outStroke, outStrokeDashArray, i;
            if (!sender.isCustomCategoryMarkerStyleAllowed) {
                return;
            }

            e[widget] = this.widget.options;
            e.series = seriesOpt;
            e.startIndex = evtArgs.startIndex();
            e.endIndex = evtArgs.endIndex();
            e.hasDateRange = evtArgs.hasDateRange();
            if (e.hasDateRange) {
                e.startDate = evtArgs.startDate();
                e.endDate = evtArgs.endDate();
            }
            e.getItems = $.proxy(evtArgs.getItems(), sender);
            e.fill = inFill = this._getValueFromBrush(evtArgs.fill());
            e.stroke = inStroke = this._getValueFromBrush(evtArgs.stroke());
            e.opacity = evtArgs.opacity();
            e.highlightingHandled = evtArgs.highlightingHandled();
            e.maxAllSeriesHighlightingProgress = evtArgs.maxAllSeriesHighlightingProgress();
            e.sumAllSeriesHighlightingProgress = evtArgs.sumAllSeriesHighlightingProgress();
            e.highlightingInfo = this._flattenHighlightingInfo(evtArgs.highlightingInfo());
            e.isNegativeShape = evtArgs.isNegativeShape();
            e.isThumbnail = evtArgs.isThumbnail();

            this.widget._trigger("assigningCategoryMarkerStyle", null, e);

            if (e.fill != inFill) {
                evtArgs.fill(this._createBrushFromValue(e.fill));
            }
            if (e.stroke != inStroke) {
                evtArgs.stroke(this._createBrushFromValue(e.stroke));
            }
            evtArgs.opacity(e.opacity);
            evtArgs.highlightingHandled(e.highlightingHandled);
        },
        _fireChart_assigningCategoryStyle: function (sender, evtArgs) {
            var e = {}, widget = this._getWidgetName(), seriesOpt = this.widget._seriesOpt[sender.name()], inFill,
			inStroke, inStrokeDashArray, outFill, outStroke, outStrokeDashArray, i;
            if (!sender.isCustomCategoryStyleAllowed) {
                return;
            }

            e[widget] = this.widget.options;
            e.series = seriesOpt;
            e.startIndex = evtArgs.startIndex();
            e.endIndex = evtArgs.endIndex();
            e.hasDateRange = evtArgs.hasDateRange();
            if (e.hasDateRange) {
                e.startDate = evtArgs.startDate();
                e.endDate = evtArgs.endDate();
            }
            e.getItems = $.proxy(evtArgs.getItems(), sender);
            e.fill = inFill = this._getValueFromBrush(evtArgs.fill());
            e.stroke = inStroke = this._getValueFromBrush(evtArgs.stroke());
            e.strokeThickness = evtArgs.strokeThickness();
            var sda = evtArgs.strokeDashArray();
            if (sda !== undefined && sda !== null) {
                e.strokeDashArray = inStrokeDashArray = sda.toArray();
            }
            e.strokeDashCap = evtArgs.strokeDashCap();
            e.radiusX = evtArgs.radiusX();
            e.radiusY = evtArgs.radiusY();
            e.opacity = evtArgs.opacity();
            e.highlightingHandled = evtArgs.highlightingHandled();
            e.maxAllSeriesHighlightingProgress = evtArgs.maxAllSeriesHighlightingProgress();
            e.sumAllSeriesHighlightingProgress = evtArgs.sumAllSeriesHighlightingProgress();
            e.highlightingInfo = this._flattenHighlightingInfo(evtArgs.highlightingInfo());
            e.isNegativeShape = evtArgs.isNegativeShape();
            e.isThumbnail = evtArgs.isThumbnail();

            this.widget._trigger("assigningCategoryStyle", null, e);

            if (e.fill != inFill) {
                evtArgs.fill(this._createBrushFromValue(e.fill));
            }
            if (e.stroke != inStroke) {
                evtArgs.stroke(this._createBrushFromValue(e.stroke));
            }
            evtArgs.strokeThickness(e.strokeThickness);
            if (e.strokeDashArray !== inStrokeDashArray) {
                outStrokeDashArray = new $.ig.DoubleCollection();
                for (i = 0; i < e.strokeDashArray.length; i++) {
                    outStrokeDashArray.add(e.strokeDashArray[i]);
                }
                evtArgs.strokeDashArray(outStrokeDashArray);
            }
            evtArgs.strokeDashCap(e.strokeDashCap);
            evtArgs.radiusX(e.radiusX);
            evtArgs.radiusY(e.radiusY);
            evtArgs.opacity(e.opacity);
            evtArgs.highlightingHandled(e.highlightingHandled);
        },
        _flattenDataSource: function (series, ds) {
            var ret = {},
				openColumn = series.getOpenColumnAsArray(),
				highColumn = series.getHighColumnAsArray(),
				lowColumn = series.getLowColumnAsArray(),
				closeColumn = series.getCloseColumnAsArray(),
				volumeColumn = series.getVolumeColumnAsArray();

            ret.indicatorColumn = ds.indicatorColumn().asArrayList();
            ret.openColumn = openColumn;
            ret.highColumn = highColumn;
            ret.lowColumn = lowColumn;
            ret.closeColumn = closeColumn;
            ret.volumeColumn = volumeColumn;
            return ret;
        },
        _fireMap_triangulationStatusChanged: function (sender, evtArgs) {
            var e = {}, widget = this._getWidgetName(), seriesOpt = this.widget._seriesOpt[sender.name()];
            e.currentStatus = evtArgs.currentStatus();
            e[widget] = this.widget.options;
            e.series = seriesOpt;
            this.widget._trigger("triangulationStatusChanged", null, e);
        },
        _bindPieChartEvents: function (chart) {
            chart.sliceClick = $.ig.Delegate.prototype.combine(chart.sliceClick, jQuery.proxy(this._firePieChart_sliceClick, this));
        },
        _firePieChart_sliceClick: function (sender, evtArgs) {
            var e = {}, isExploded, isSelected;
            e.slice = {};
            e.slice.item = evtArgs.slice().dataContext();
            isExploded = evtArgs.slice().isExploded();
            isSelected = evtArgs.slice().isSelected();
            e.slice.isExploded = isExploded;
            e.slice.isSelected = isSelected;
            e.chart = this.widget.options;
            this.widget._trigger("sliceClick", null, e);
            if (e.slice.isExploded !== isExploded) {
                evtArgs.slice().isExploded(e.slice.isExploded);
            }
            if (e.slice.isSelected !== isSelected) {
                evtArgs.slice().isSelected(e.slice.isSelected);
            }
        },
        _bindDataChartEvents: function (chart) {
            chart.seriesCursorMouseMove = $.ig.Delegate.prototype.combine(chart.seriesCursorMouseMove, jQuery.proxy(this._fireChart_seriesCursorMouseMove, this));
            chart.seriesMouseLeftButtonDown = $.ig.Delegate.prototype.combine(chart.seriesMouseLeftButtonDown, jQuery.proxy(this._fireChart_seriesMouseLeftButtonDown, this));
            chart.seriesMouseLeftButtonUp = $.ig.Delegate.prototype.combine(chart.seriesMouseLeftButtonUp, jQuery.proxy(this._fireChart_seriesMouseLeftButtonUp, this));
            chart.seriesMouseMove = $.ig.Delegate.prototype.combine(chart.seriesMouseMove, jQuery.proxy(this._fireChart_seriesMouseMove, this));
            chart.seriesMouseEnter = $.ig.Delegate.prototype.combine(chart.seriesMouseEnter, jQuery.proxy(this._fireChart_seriesMouseEnter, this));
            chart.seriesMouseLeave = $.ig.Delegate.prototype.combine(chart.seriesMouseLeave, jQuery.proxy(this._fireChart_seriesMouseLeave, this));
            chart.windowRectChanged = $.ig.Delegate.prototype.combine(chart.windowRectChanged, jQuery.proxy(this._fireChart_windowRectChanged, this));
            chart.actualWindowRectChanged = $.ig.Delegate.prototype.combine(chart.actualWindowRectChanged, jQuery.proxy(this._fireChart_actualWindowRectChanged, this));
            chart.gridAreaRectChanged = $.ig.Delegate.prototype.combine(chart.gridAreaRectChanged, jQuery.proxy(this._fireChart_gridAreaRectChanged, this));
            chart.refreshCompleted = $.ig.Delegate.prototype.combine(chart.refreshCompleted, jQuery.proxy(this._fireChart_refreshCompleted, this));
            chart.axisRangeChanged = $.ig.Delegate.prototype.combine(chart.axisRangeChanged, jQuery.proxy(this._fireChart_axisRangeChanged, this));

            chart.notifyCrosshairUpdate = $.ig.Delegate.prototype.combine(chart.notifyCrosshairUpdate, jQuery.proxy(this._notifyCrosshairUpdate, this));
        },
        _getSeriesOpt: function (evtArgs) {
            var widget = this.widget, opt, parentSeries, logicalSeries;

            if (!widget._seriesOpt) {
                return widget.options;
            }

            if (widget._seriesOpt[evtArgs.series().name()]) {
                return widget._seriesOpt[evtArgs.series().name()];
            }

            if (!evtArgs.series().parentSeries) {
                return widget.options;
            }

            parentSeries = evtArgs.series().parentSeries();
            logicalSeries = evtArgs.series().logicalSeriesLink();

            if (widget._seriesSubOpt[parentSeries.name()][logicalSeries.name()]) {
                return widget._seriesSubOpt[parentSeries.name()][logicalSeries.name()];
            }

            return widget.options;
        },
        _getChartEvt: function (evtArgs) {
            var e = {}, seriesOpt = this._getSeriesOpt(evtArgs), pos, widget = this._getWidgetName(), intSeries = null;

            e[widget] = this.widget.options;
            e.series = seriesOpt;
            if (e.series && !e.series.title) {
                e.series.title = "Series Title";
            }
            e.item = evtArgs.item();

            if (evtArgs.series && evtArgs.series() !== null) {
                intSeries = evtArgs.series();
            }
            if (intSeries !== null && intSeries.hostedSeries && intSeries.hostedSeries() !== null) {
                intSeries = intSeries.hostedSeries();
            }

            if (evtArgs.actualItemBrush && evtArgs.actualItemBrush() !== null) {
                e.actualItemBrush = this._getValueFromBrush(evtArgs.actualItemBrush());
            } else if (intSeries !== null && intSeries.actualMarkerBrush && intSeries.actualMarkerBrush() !== null) {
                e.actualItemBrush = this._getValueFromBrush(intSeries.actualMarkerBrush());
            }
            if (intSeries !== null && intSeries.actualBrush && intSeries.actualBrush() !== null) {
                e.actualSeriesBrush = this._getValueFromBrush(intSeries.actualBrush());
            }

            if (evtArgs.originalEvent && evtArgs.originalEvent() !== null && evtArgs.originalEvent().position && evtArgs.originalEvent().position() !== null) {
                pos = evtArgs.originalEvent().position();
                e.positionX = pos.__x;
                e.positionY = pos.__y;
            }
            return e;
        },
		_notifyCrosshairUpdate: function() {
            if (this.widget._chart &&
				this.widget._chart.crosshairPoint){
                this.widget.options.crosshairPoint = {
                    x: this.widget._chart.crosshairPoint().__x,
                    y: this.widget._chart.crosshairPoint().__y
                };
            }
        },
        _fireChart_seriesCursorMouseMove: function (sender, evtArgs) {
            var e = this._getChartEvt(evtArgs);

            this.widget._trigger("seriesCursorMouseMove", null, e);
        },
        _fireChart_seriesMouseLeftButtonDown: function (sender, evtArgs) {
            var e = this._getChartEvt(evtArgs);
            this.widget._trigger("seriesMouseLeftButtonDown", null, e);
        },
        _fireChart_seriesMouseLeftButtonUp: function (sender, evtArgs) {
            var e = this._getChartEvt(evtArgs);
            this.widget._trigger("seriesMouseLeftButtonUp", null, e);
        },
        _fireChart_seriesMouseMove: function (sender, evtArgs) {
            var e = this._getChartEvt(evtArgs);
            this.widget._trigger("seriesMouseMove", null, e);
        },
        _fireChart_seriesMouseEnter: function (sender, evtArgs) {
            var e = this._getChartEvt(evtArgs);
            this.widget._trigger("seriesMouseEnter", null, e);
        },
        _fireChart_seriesMouseLeave: function (sender, evtArgs) {
            var e = this._getChartEvt(evtArgs);
            this.widget._trigger("seriesMouseLeave", null, e);
        },
        _fireChart_windowRectChanged: function (sender, evtArgs) {
            var e = {}, oldRect = evtArgs.oldRect(), newRect = evtArgs.newRect(), widget = this._getWidgetName();
            if (oldRect) {
                e.oldTop = oldRect.top();
                e.oldLeft = oldRect.left();
                e.oldWidth = oldRect.width();
                e.oldHeight = oldRect.height();
            }

            e.newTop = newRect.top();
            e.newLeft = newRect.left();
            e.newWidth = newRect.width();
            e.newHeight = newRect.height();
            e[widget] = this.widget.options;

            this.widget.options.windowRect = {
                top: e.newTop,
                left: e.newLeft,
                width: e.newWidth,
                height: e.newHeight
            };

            this.widget._trigger("windowRectChanged", null, e);
        },
        _fireChart_actualWindowRectChanged: function (sender, evtArgs) {
            var e = {}, oldRect = evtArgs.oldRect(), newRect = evtArgs.newRect(), widget = this._getWidgetName();
            if (oldRect) {
                e.oldTop = oldRect.top();
                e.oldLeft = oldRect.left();
                e.oldWidth = oldRect.width();
                e.oldHeight = oldRect.height();
            }

            e.newTop = newRect.top();
            e.newLeft = newRect.left();
            e.newWidth = newRect.width();
            e.newHeight = newRect.height();
            e[widget] = this.widget.options;

            this.widget.options.actualWindowRect = {
                top: e.newTop,
                left: e.newLeft,
                width: e.newWidth,
                height: e.newHeight
            };

            this.widget._trigger("actualWindowRectChanged", null, e);
        },
        _fireChart_gridAreaRectChanged: function (sender, evtArgs) {
            var e = {}, oldRect = evtArgs.oldRect(), newRect = evtArgs.newRect(), widget = this._getWidgetName();
            if (oldRect) {
                e.oldTop = oldRect.top();
                e.oldLeft = oldRect.left();
                e.oldWidth = oldRect.width();
                e.oldHeight = oldRect.height();
            }

            e.newTop = newRect.top();
            e.newLeft = newRect.left();
            e.newWidth = newRect.width();
            e.newHeight = newRect.height();
            e[widget] = this.widget.options;

            this.widget.options.gridAreaRect = {
                top: e.newTop,
                left: e.newLeft,
                width: e.newWidth,
                height: e.newHeight
            };

            this.widget._trigger("gridAreaRectChanged", null, e);
        },
        _fireChart_refreshCompleted: function (sender, evtArgs) {
            var e = {}, widget = this._getWidgetName();
            e[widget] = this.widget.options;

            this.widget._trigger("refreshCompleted", null, e);
        },
        _fireChart_imageTilesReady: function (sender, evtArgs) {
            var e = {}, widget = this._getWidgetName();
            e[widget] = this.widget.options;

            this.widget._trigger("imageTilesReady", null, e);
        },
        _fireChart_axisRangeChanged: function (sender, evtArgs) {
            var e = {};
            e.chart = this.widget.options;
            e.axis = this.widget._axisOpt[evtArgs.axis().name()];
            e.oldMinimumValue = evtArgs.oldMinimumValue();
            e.oldMaximumValue = evtArgs.oldMaximumValue();
            e.newMinimumValue = evtArgs.minimumValue();
            e.newMaximumValue = evtArgs.maximumValue();

            this.widget._trigger("axisRangeChanged", null, e);
        },
        _fireToolTip_updateToolTip: function (args) {
            var e = {}, noCancel, template;
            e = this._getChartEvt(args);
            e.tempId = (this.widget._seriesOpt) ? e.series.name : this.widget.id();
            e.element = null;
            if (e.series !== null) {
                e.element = this.widget._tooltip[e.tempId];
            }

            noCancel = this.widget._trigger(this.widget.events.tooltipShowing, null, e);

            if (e === null) {
                noCancel = false;
            }
            if (noCancel) {
                template = this.widget._tooltipTemplate;
                if (e.series !== null && this.widget._tooltipTemplates[e.tempId] !== undefined) {
                    template = this.widget._tooltipTemplates[e.tempId];
                }


                if(template == "default") {
                    if (args.series().view) {
                        template = args.series().view().getDefaultTooltipTemplate();
                        this.widget._tooltipTemplates[e.tempId] = template;
                        if (args.series() && args.series().isDefaultToolTipSelected) {
                            args.series().isDefaultToolTipSelected(true);
                        }
                    }
                } else {
                    if (args.series() && args.series().isDefaultToolTipSelected) {
                        args.series().isDefaultToolTipSelected(false);
                    }
                }

                if (template) {
                    this.widget._tooltip[e.tempId].children().remove();
                    if (e.item === null) {
                        noCancel = false;
                    }

                    if (noCancel) {
                        this.widget._tooltip[e.tempId].html($.ig.tmpl(template, e));
                    }
                }
                if (args.hideOthers) {
                    $.each(this.widget._tooltip, function (i, tip) {
                        tip.hide();
                    });
                }

                if (noCancel) {
                    this.widget._tooltip[e.tempId].show();
                    this.widget._trigger(this.widget.events.tooltipShown, null, e);
                }
            }
        },
        _fireToolTip_hideToolTip: function (args) {
            var e = {}, noCancel;
            e = (this.widget._seriesOpt) ? this._getChartEvt(args) : args;
            e.tempId = (this.widget._seriesOpt) ? e.series.name : this.widget.id();
            e.element = null;
            if (e.series !== null) {
                e.element = this.widget._tooltip[e.tempId];
            }

            noCancel = this.widget._trigger(this.widget.events.tooltipHiding, null, e);
            if (noCancel) {
                $.each(this.widget._tooltip, function (i, tip) {
                    tip.hide();
                });
                this.widget._trigger(this.widget.events.tooltipHidden, null, e);
            }
        },
        _destroy: function (widget) {
            var elem = this._chartElement, old = this._oldProp;
            if (elem) {
                delete this._chartElement;
                elem.remove();
                // stop possible timer
                this._setSize(widget._chart);
                // restore original width/height
                elem = widget.element;
                elem.css("width", old.width);
                elem.css("height", old.height);
            }
            widget._axes = null;
            widget._series = null;
            widget._axisOpt = null;
            widget._seriesOpt = null;
            widget.dataSources = null;

            $.each(this.widget._tooltip, function (i, tip) {
                tip.hide();
                tip.remove();
            });

            widget._tooltip = null;
            widget._tooltipTemplates = null;
        }
    });

    $.ig.SimpleTextMarkerTemplate = $.ig.TextMarkerTemplate || Class.extend({
        requireThis: true,

        settings: {
            padding: 5,
            getText: null,
            backgroundColor: "rgba(255,255,255,.6)",
            borderColor: "rgba(20, 20, 20, .6)",
            borderThickness: 1,
            textColor: "black",
            font: null
        },

        init: function (options) {
            if (options !== undefined) {
                this.settings = $.extend(true, {}, $.ig.SimpleTextMarkerTemplate.prototype.settings, options);
            }
            return this;
        },

        getText: function (item, textDelegate) {
            if (textDelegate === null) {
                return "";
            }

            return textDelegate(item);
        },

        measure: function (measureInfo) {
            var s = this.settings, data, text, cont = measureInfo.context, height, width;

            if (s.font !== null) {
                cont.font = s.font;
            }
            if (s.textColor !== null) {
                cont.fillStyle = s.textColor;
            }

            data = measureInfo.data;

            text = "null";
            if (data.item() !== null) {
                text = this.getText(data.item(), s.getText);
            }
            height = cont.measureText("M").width;
            width = cont.measureText(text).width;
            measureInfo.width = width + s.padding * 2.0;
            measureInfo.height = height + s.padding * 2.0;
        },

        render: function (renderInfo) {
            var s = this.settings, ctx = renderInfo.context, data, text, halfWidth, halfHeight, x, y;

            if (renderInfo.isHitTestRender) {
                ctx.globalAlpha = 1;
                ctx.fillStyle = renderInfo.data.actualItemBrush().fill();
            } else {
                ctx.fillStyle = s.backgroundColor;
                ctx.strokeStyle = s.borderColor;
                ctx.lineWidth = s.borderThickness;
            }

            data = renderInfo.data;
            text = this.getText(data.item(), s.getText);

            halfWidth = renderInfo.availableWidth / 2.0;
            halfHeight = renderInfo.availableHeight / 2.0;
            x = renderInfo.xPosition - halfWidth;
            y = renderInfo.yPosition - halfHeight;

            if (renderInfo.isHitTestRender) {
                ctx.fillRect(x, y, renderInfo.availableWidth, renderInfo.availableHeight);
            } else {
                ctx.fillRect(x, y, renderInfo.availableWidth, renderInfo.availableHeight);
                ctx.strokeRect(x, y, renderInfo.availableWidth, renderInfo.availableHeight);

                ctx.fillStyle = s.textColor;
                ctx.textBaseline = "top";
                ctx.fillText(text, x + s.padding, y + s.padding);
            }
        }

    });
}(jQuery));




/*!@license
 * Infragistics.Web.ClientUI Chart 14.2.20142.1018
 *
 * Copyright (c) 2011-2014 Infragistics Inc.
 *
 * http://www.infragistics.com/
 *
 * Depends on:
 * jquery-1.4.4.js
 * jquery.ui.core.js
 * jquery.ui.widget.js
 * infragistics.util.js
 * infragistics.dv.core.js
 * infragistics.chart_piechart.js
 * infragistics.chart_categorychart.js
 * infragistics.chart_financialchart.js
 * infragistics.chart_polarchart.js
 * infragistics.chart_radialchart.js
 * infragistics.chart_rangecategorychart.js
 * infragistics.chart_scatterchart.js
 * infragistics.datasource.js
 * infragistics.dvcommonwidget.js
 */

/*global jQuery */
if (typeof jQuery !== "function") {
	throw new Error("jQuery is undefined");
}

(function ($) {

	// igChart definition
	$.widget('ui.igDataChart', {
		options: {
			/* type="string" The channel name to use to sync this chart with other charts. */
			syncChannel: null,
			/* type="bool" Whether the chart should be synchronized vertically */
			synchronizeVertically: true,
			/* type="bool" Whether the chart should be synchronized horizontally */
			syncrhonizeHorizontally: false,
			/* type="object"
			Gets or sets the cross hair point (in world coordinates)
			Either or both of the crosshair point's X and Y may be set to double.NaN, in which
			case the relevant crosshair line is hidden.
			*/
			crosshairPoint: {
				/* type="number" The x coordinate. */
				x: NaN,
				/* type="number" The y coordinate. */
				y: NaN
			},
			/* type="object"
			A rectangle representing the portion of the chart currently in view.
			A rectangle at X=0, Y=0 with a Height and Width of 1 implies the entire plotting area is in view.  A Height and Width of .5 would imply that the view is halfway zoomed in.
			The provided object should have numeric properties called left, top, width and height.
			*/
			windowRect: null,
			/* type="bool"
			Gets or sets the current Chart's horizontal zoomability.
			*/
			horizontalZoomable: false,
			/* type="bool"
			Gets or sets the current Chart's vertical zoomability.
			*/
			verticalZoomable: false,
			/* type="deferred|immediate"
			The response to user panning and zooming: whether to update the view immediately while the user action is happening, or to defer the update to after the user action is complete.  The user action will be an action such as a mouse drag which causes panning and/or zooming to occur.
			deferred type="string" Defer the view update until after the user action is complete.             
			immediate type="string" Update the view immediately while the user action is happening.             
			*/
			windowResponse: null,
			/* type="number"
			Sets or gets the minimum width that the window rect is allowed to reach before being clamped.
			Decrease this value if you want to allow for further zooming into the viewer.
			If this value is lowered too much it can cause graphical corruption due to floating point arithmetic inaccuracy.
			*/
			windowRectMinWidth: 0,
			/* type="visible|collapsed" The visibility of the OverviewPlusDetailPane.
			visible type="string" The overview pane should be visible.
			collapsed type="string" The overview pane should not be visible.
			*/
			overviewPlusDetailPaneVisibility: "collapsed",
			/* type="visible|collapsed" Gets or sets the current Chart's crosshair visibility override.
			visible type="string" Crosshair should be visible.
			collapsed type="string" Crosshair should not be visible.
			*/
			crosshairVisibility: "collapsed",
			/* type="string"
			Gets or sets the brush used as the background for the current Chart object's plot area.
			*/
			plotAreaBackground: null,
			/* type="none|dragZoom|dragPan" Gets or sets the DefaultInteraction property. The default interaction state defines the chart's response to mouse events.
			none type="string" User gesture will not change the state of the chart.
			dragZoom type="string" User gesture will start a drag rectangle to zoom the chart.
			dragPan type="string" User gesture will start a pan action to move the chart's window.
			*/
			defaultInteraction: "dragZoom",
			/* type="none|alt|control|shift|windows|apple" Gets or sets the current Chart's DragModifier property.
			none type="string" No modifier key is set.
			alt type="string" The modifier is set to alt key.
			control type="string" The modifier is set to control key.
			shift type="string" The modifier is set to shift key.
			*/
			dragModifier: "none",
			/* type="none|alt|control|shift|windows|apple" Gets or sets the current Chart's PanModifier property.
			none type="string" No modifier key is set.
			alt type="string" The modifier is set to alt key.
			control type="string" The modifier is set to control key.
			shift type="string" The modifier is set to shift key.
			*/
			panModifier: "shift",
			/* type="object"
			Gets or sets the preview rectangle.
			The preview rectangle may be set to Rect.Empty, in which case the visible preview
			strokePath is hidden.
			The provided object should have numeric properties called left, top, width and height.
			*/
			previewRect: null,
			/* type="number"
			A number between 0 and 1 determining the position of the horizontal scroll.
			This property is effectively a shortcut to the X position of the WindowRect property.
			*/
			windowPositionHorizontal: 0,
			/* type="number"
			A number between 0 and 1 determining the position of the vertical scroll.
			This property is effectively a shortcut to the Y position of the WindowRect property.
			*/
			windowPositionVertical: 0,
			/* type="number"
			A number between 0 and 1 determining the scale of the horizontal zoom.
			This property is effectively a shortcut to the Width of the WindowRect property.
			*/
			windowScaleHorizontal: 1,
			/* type="number"
			A number between 0 and 1 determining the scale of the vertical zoom.
			This property is effectively a shortcut to the Height of the WindowRect property.
			*/
			windowScaleVertical: 1,
			/* type="object"
			Gets or sets the template to use for circle markers on the chart.
			Defines the marker template used for
			series with a marker type of circle.
			The provided object should have properties called render and optionally measure. See definition for option: legendItemBadgeTemplate 
			*/
			circleMarkerTemplate: null,
			/* type="object"
			Gets or sets the template to use for triangle markers on the chart.
			Defines the marker template used for
			series with a marker type of triangle.
			The provided object should have properties called render and optionally measure. See definition for option: legendItemBadgeTemplate 
			*/
			triangleMarkerTemplate: null,
			/* type="object"
			Gets or sets the template to use for pyramid markers on the chart.
			Defines the marker template used for
			series with a marker type of pyramid.
			The provided object should have properties called render and optionally measure. See definition for option: legendItemBadgeTemplate 
			*/
			pyramidMarkerTemplate: null,
			/* type="object"
			Gets or sets the template to use for square markers on the chart.
			Defines the marker template used for
			series with a marker type of square.
			The provided object should have properties called render and optionally measure. See definition for option: legendItemBadgeTemplate 
			*/
			squareMarkerTemplate: null,
			/* type="object"
			Gets or sets the template to use for diamond markers on the chart.
			Defines the marker template used for
			series with a marker type of diamond.
			The provided object should have properties called render and optionally measure. See definition for option: legendItemBadgeTemplate 
			*/
			diamondMarkerTemplate: null,
			/* type="object"
			Gets or sets the template to use for pentagon markers on the chart.
			Defines the marker template used for
			series with a marker type of pentagon.
			The provided object should have properties called render and optionally measure. See definition for option: legendItemBadgeTemplate 
			*/
			pentagonMarkerTemplate: null,
			/* type="object"
			Gets or sets the template to use for hexagon markers on the chart.
			Defines the marker template used for
			series with a marker type of hexagon.
			The provided object should have properties called render and optionally measure. See definition for option: legendItemBadgeTemplate 
			*/
			hexagonMarkerTemplate: null,
			/* type="object"
			Gets or sets the template to use for tetragram markers on the chart.
			Defines the marker template used for
			series with a marker type of tetragram.
			The provided object should have properties called render and optionally measure. See definition for option: legendItemBadgeTemplate 
			*/
			tetragramMarkerTemplate: null,
			/* type="object"
			Gets or sets the template to use for pentragram markers on the chart.
			Defines the marker template used for
			series with a marker type of pentagram.
			The provided object should have properties called render and optionally measure. See definition for option: legendItemBadgeTemplate 
			*/
			pentagramMarkerTemplate: null,
			/* type="object"
			Gets or sets the template to use for hexagram markers on the chart.
			Defines the marker template used for
			series with a marker type of hexagram.
			The provided object should have properties called render and optionally measure. See definition for option: legendItemBadgeTemplate 
			*/
			hexagramMarkerTemplate: null,
			/* type="number"
			Sets or gets the top margin to use around the chart content in the canvas.
			*/
			topMargin: 0,
			/* type="number"
			Sets or gets the left margin to use around the chart content in the canvas.
			*/
			leftMargin: 0,
			/* type="number"
			Sets or gets the right margin to use around the chart content in the canvas.
			*/
			rightMargin: 0,
			/* type="number"
			Sets or gets the bottom margin to use around the chart content in the canvas.
			*/
			bottomMargin: 0,
			/* type="number"
			Sets or gets the automatic width to add when automatically adding margins to the chart.
			*/
			autoMarginWidth: 20,
			/* type="number"
			Sets or gets the automatic height to add when automatically adding margins to the chart.
			*/
			autoMarginHeight: 0,
			/* type="bool"
			Gets or sets whether to use a square aspect ratio for the chart. This is locked to true for polar and radial charts.
			*/
			isSquare: false,
			/* type="none|beforeSeries|behindSeries" Gets or sets the GridMode property.
			none type="string" No chart grid.
			beforeSeries type="string" Chart grid should be rendered before or in front of the data series.
			behindSeries type="string" Chart grid should be rendered behind or in back of the data series.
			*/
			gridMode: "behindSeries",
			/* type="object"
			Gets or sets the Brushes property.
			The brushes property defines the palette from which automatically assigned series brushes are selected.
			The value provided should be an array of css color strings. Optionally the first element can be a string reading "RGB" or "HSV" to specify the interpolation mode of the collection.
			*/
			brushes: null,
			/* type="object"
			Gets or sets the MarkerBrushes property.
			The marker brushes property defines the palette from which automatically assigned marker brushes are selected.
			The value provided should be an array of css color strings. Optionally the first element can be a string reading "RGB" or "HSV" to specify the interpolation mode of the collection.
			*/
			markerBrushes: null,
			/* type="object"
			Gets or sets the Outlines property.
			The outlines property defines the palette from which automatically assigned series outlines are selected.
			The value provided should be an array of css color strings. Optionally the first element can be a string reading "RGB" or "HSV" to specify the interpolation mode of the collection.
			*/
			outlines: null,
			/* type="object"
			Gets or sets the MarkerOutlines property.
			The marker outlines property defines the palette from which automatically assigned marker outlines are selected.
			The value provided should be an array of css color strings. Optionally the first element can be a string reading "RGB" or "HSV" to specify the interpolation mode of the collection.
			*/
			markerOutlines: null,
			/* type="number" The width of the chart. It can be set as a number in pixels, string (px) or percentage (%). */
			width: null,
			/* type="number" The height of the chart. It can be set as a number in pixels, string (px) or percentage (%). */
			height: null,
			/* type="object"
				To set both dimensions of the chart simultaneously an object with a width and height property can be provided
			*/
			size: null,
			/* type="object" can be any valid data source accepted by $.ig.DataSource, or an instance of an $.ig.DataSource itself */
			dataSource: null,
			/* type="string" Specifies a remote URL accepted by $.ig.DataSource in order to request data from it */
			dataSourceUrl: null,
			/* type="string" Explicitly set data source type (such as "json"). Please refer to the documentation of $.ig.DataSource and its type property. */
			dataSourceType: null,
			/* type="string" see $.ig.DataSource. Specifies the name of the property in which data records are held if the response is wrapped. */
			responseDataKey: null,
			/* type="bool" Set to true in order to disable any interactions with the plot surface. */
			isSurfaceInteractionDisabled: false,
			/* type="bool" Set to true in order to override the default behavior in which series do not animate if an axis range changes */
			animateSeriesWhenAxisRangeChanges : false,
			/* type="string" the title to display for the component. */
			title: null,
			/* type="string" the subtitle to display for the component. */
			subtitle: null,
			/* type="string" the css font property to use for the title. */
			titleTextStyle: null,
			/* type="number" the top margin to use for the title. */
			titleTopMargin: 0,
			/* type="number" the left margin to use for the title. */
			titleLeftMargin: 0,
			/* type="number" the right margin to use for the title. */
			titleRightMargin: 0,
			/* type="number" the bottom margin to use for the title. */
			titleBottomMargin: 0,
			/* type="string" the css font property to use for the title. */
			subtitleTextStyle: null,
			/* type="number" the top margin to use for the subtitle. */
			subtitleTopMargin: 0,
			/* type="number" the left margin to use for the subtitle. */
			subtitleLeftMargin: 0,
			/* type="number" the right margin to use for the subtitle. */
			subtitleRightMargin: 0,
			/* type="number" the bottom margin to use for the subtitle. */
			subtitleBottomMargin: 0,
			/* type="object" the color to use for the title. */
			titleTextColor: "black",
			/* type="object" the color to use for the subtitle. */
			subtitleTextColor: "black",
			/* type="left|center|right" the horizontal alignment to use for the title. 
				left type="string" left aligns the title.
				center type="string" center aligns the title.
				right type="string" right aligns the title.
			*/
			titleHorizontalAlignment: "center",
			/* type="left|center|right" the horizontal alignment to use for the subtitle. 
				left type="string" left aligns the subtitle.
				center type="string" center aligns the subtitle.
				right type="string" right aligns the subtitle.
			*/
			subtitleHorizontalAlignment: "center",
			/* type="number" the length, in milliseconds of the highlighting transition. */
			highlightingTransitionDuration: 300,
		    /* type="bool" sets whether the series viewer should use cached tiles during zooms rather than the default live content. */
			useTiledZooming: false,
		    /* type="bool" sets whether the series viewer should prefer selecting higher resolution tiles over lower resolution tiles when performing tile zooming. Setting this to true will lower performance but increase quality. */
			preferHigherResolutionTiles: false,
		    /* type="number" sets the maximum number of zoom tiles that the series viewer should cache while in tiled zooming mode. */
			zoomTileCacheSize: 30,
			/* type="object" can be any valid options accepted by $.ig.ChartLegend, or an instance of an $.ig.ChartLegend itself. */
			legend: {
				/* type="string" the name of the element to turn into a legend. */
				element: null,
				/* type="item|legend" Type of the legend.
					item type="string" Specify the legend as item legend. It displays a legend item for each pie in the igPieChart control.
					legend type="string" Specify the legend as legend. It is supported by all types of series in the igDataChart control.
				*/
				type: "legend",
				/* type="string|number|null" The width of the legend.
					string The widget width can be set in pixels (px) and percentage (%).
					number The widget width can be set as a number.
					null type="object" will stretch to fit data, if no other widths are defined.
				*/
				width: null,
				/* type="string|number|null" The height of the legend.
					string The widget height can be set in pixels (px) and percentage (%).
					number The widget height can be set as a number.
					null will stretch vertically to fit data, no other height are defined.
				*/
				height : null
			},
			/* type="array" an array of axis objects */
			axes: [{
				/* type="numericX|numericY|categoryX|categoryDateTimeX|categoryY|categoryAngle|numericAngle|numericRadius" Type of the axis.
					numericX type="string" Specify the axis as numeric X axis. Useful for displaying scatter, category and financial price series.
					numericY type="string" Specify the axis as numeric Y axis.Useful for displaying scatter, category and financial price series.
					categoryX type="string" Specify the axis as category X axis. Useful for displaying scatter, category and financial price series.
					categoryDateTimeX type="string" Specify the axis as category datetime X axis. Useful for displaying category and financial price series with date based data.
					categoryY type="string" Specify the axis as category Y axis. Useful for displaying scatter, category and financial price series.
					categoryAngle type="string" Specify the axis as category angle axis. Useful for displaying polar and radial categories. 
					numericAngle type="string" Specify the axis as numeric angle axis. Useful for displaying polar and radial series.
					numericRadius type="string" Specify the axis as numeric radius axis. Useful for displaying polar and radial series.
				*/
				type: null,
				/* type="string" the unique identifier of the axis. */
				name: null,
				/* type="object" can be any valid data source accepted by $.ig.DataSource, or an instance of an $.ig.DataSource itself */
				dataSource: null,
				/* type="string" Specifies a remote URL accepted by $.ig.DataSource in order to request data from it */
				dataSourceUrl: null,
				/* type="string" Explicitly set data source type (such as "json"). Please refer to the documentation of $.ig.DataSource and its type property. */
				dataSourceType: null,
				/* type="string" see $.ig.DataSource. Specifies the name of the property in which data records are held if the response is wrapped. */
				responseDataKey: null,
				/* type="bool" Set to true in order to have an existing axis removed from the chart, by name */
				remove: false,
				/* type="outsideTop|outsideBottom|outsideLeft|outsideRight|insideTop|insideBottom|insideLeft|insideRight" Specifies the location to display the axis labels for this axis.
					outsideTop type="string" The labels should have an outside top position.
					outsideBottom type="string" The labels should have an outside bottom position.
					outsideLeft type="string" The labels should have an outside left position.
					outsideRight type="string" The labels should have an outside right position.
					insideTop type="string" The labels should have an inside top position.
					insideBottom type="string" The labels should have an inside bottom position.
					insideLeft type="string" The labels should have an inside left position.
					insideRight type="string" The labels should have an inside right position. */
				labelLocation: null,
				/* type="visible|collapsed" Specifies whether the labels are visible.
					visible type="string" The labels should be visisble for this axis.
					collapsed type="string" The labels should not be visible for this axis. */
				labelVisibility: "visible",
				/* type="number" Specifies the extent of the area dedicated to the labels for this axis. If unspecified, this value is auto-calculated. */
				labelExtent: null,
				/*type="number" Specifies the angle that labels on the axis should be rotated */
				labelAngle: 0,
				/*type="string" Overrides the style of the text used for the axis labels. */
				labelTextStyle: null,
				/*type="string" Overrides the color of the text used for the axis labels. */
				labelTextColor: null,
				/* type="object"
				Sets or gets a function which takes an object that produces a formatted label for displaying in the chart.
				*/
				formatLabel: null,
				/* type="string"
				Gets or sets the Stroke property.
				*/
				stroke: null,
				/* type="number"
				Gets or sets the StrokeThickness property.
				*/
				strokeThickness: 1,
				/* type="string"
				Gets or sets the Strip property.
				*/
				strip: null,
				/* type="string"
				Gets or sets the MajorStroke property.
				*/
				majorStroke: null,
				/* type="number"
				Gets or sets the MajorStrokeThickness property.
				*/
				majorStrokeThickness: 1,
				/* type="string"
				Gets or sets the MinorStroke property.
				*/
				minorStroke: null,
				/* type="number"
				Gets or sets the MinorStrokeThickness property.
				*/
				minorStrokeThickness: 1,
				/* type="bool"
				Gets or sets the IsInverted property.
				*/
				isInverted: false,
				/* type="string"
				Gets or sets the CrossingAxis property.
				*/
				crossingAxis: null,
				/* type="object"
				Gets or sets the CrossingValue property.
				*/
				crossingValue: null,
				/* type="object"
				Gets or sets the coercion methods to use when loading data from data sources.
				Should be specified before setting any member paths, if being used. Setting it later 
				will not cause data to be reimported into the chart.
				*/
				coercionMethods: null,
				/* type="object"
				Gets or sets the axis label format string.
				*/
				label: null,
				/* type="number"
				Gets or sets the amount of space between adjacent categories for the current axis object.
				The gap is silently clamped to the range [0, 1] when used.
				*/
				gap: 0,
				/* type="number"
				Gets or sets the amount of overlap between adjacent categories for the current axis object.
				The overlap is silently clamped to the range [-1, 1] when used.
				*/
				overlap: 0,
				/* type="number"
				Indicates the angle in degress that the chart's 0th angle should be offset.
				*/
				startAngleOffset: 0,
				/* type="number"
				Gets or sets the frequency of displayed labels.
				The set value is a factor that determines which labels will be hidden. For example, an interval of 2 will display every other label.
				*/
				interval: 0,
				/* type="continuous|discrete" Gets or sets the axis display type. Continuous display type divides the axis into even intervals, where labels will not necessarily be aligned with data points. Discrete display type will not use a constant interval, but will align each label with its data point.
				continuous type="string" Points occur at even intervals, even where data is not present at a given point.             
				discrete type="string" Points occur when data is present, possibly at uneven intervals.             
				*/
				displayType: null,
				/* type="number"
				Gets or sets the axis MinimumValue.
				*/
				minimumValue: 0,
				/* type="number"
				Gets or sets the axis MaximumValue.
				*/
				maximumValue: 0,
				/* type="string"
				Gets or sets the DateTime mapping property for the CategoryDateTimeXAxis.
				*/
				dateTimeMemberPath: null,
				/* type="number"
				Gets or sets the ReferenceValue property.
				*/
				referenceValue: 0,
				/* type="bool"
				Gets or sets the IsLogarithmic property.
				*/
				isLogarithmic: false,
				/* type="number"
				Gets or sets the LogarithmBase property.
				*/
				logarithmBase: 10,
				/* type="number"
				Defines the percentage of the maximum radius extent to use as the maximum radius. Should be 
				a value between 0.0 and 1.0.
				*/
				radiusExtentScale: 0.75,
				/* type="number"
				Defines the percentage of the maximum radius extent to leave blank at the center of the chart. Should be 
				a value between 0.0 and 1.0.
				*/
				innerRadiusExtentScale: 0,
				/* type="string" the title to display for the component. */
				title: null,
				/* type="string" the css font property to use for the title. */
				titleTextStyle: null,
				/* type="number" the margin to display around the title of the axis. */
				titleMargin: 0,
				/* type="left|center|right" the horizontal alignment to use for the title. 
				left type="string" left aligns the title.
				center type="string" center aligns the title.
				right type="string" right aligns the title.
				*/
				titleHorizontalAlignment: "center",
				/* type="left|center|right" the vertical alignment to use for the title. 
				top type="string" top aligns the title.
				center type="string" center aligns the title.
				bottom type="string" bottom aligns the title.
				*/
				titleVerticalAlignment: "center",
				/* type="auto|left|right|top|bottom" the position to use for the title. 
				auto type="string" the title is positioned automatically.
				left type="string" the title is positioned on the left of the labels, if applicable.
				right type="string" the title is positioned on the right of the labels, if applicable.
				top type="string" the title is positioned on the top of the labels, if applicable.
				bottom type="string" the title is positioned on the bottom of the labels, if applicable.
				*/
				titlePosition: "auto",
				/* type="number" the top margin to use for the title. */
				titleTopMargin: 0,
				/* type="number" the left margin to use for the title. */
				titleLeftMargin: 0,
				/* type="number" the right margin to use for the title. */
				titleRightMargin: 0,
				/* type="number" the bottom margin to use for the title. */
				titleBottomMargin: 0,
				/* type="left|center|right" the horizontal alignment to use for the labels. Only applicable to vertical axes.
				left type="string" left aligns the labels.
				center type="string" center aligns the labels.
				right type="string" right aligns the labels.
				*/
				labelHorizontalAlignment: "right",
				/* type="top|center|bottom" the vertical alignment to use for the labels. Only applicable to horizontal axes.
				top type="string" top aligns the labels.
				center type="string" center aligns the labels.
				bottom type="string" bottom aligns the labels.
				*/
				labelVerticalAlignment: "top",
				/* type="number" the margin to use for the labels. */
				labelMargin: 0,
				/* type="number" the top margin to use for the labels. */
				labelTopMargin: 0,
				/* type="number" the left margin to use for the labels. */
				labelLeftMargin: 0,
				/* type="number" the right margin to use for the labels. */
				labelRightMargin: 0,
				/* type="number" the bottom margin to use for the labels. */
				labelBottomMargin: 0,
				/* type="bool" sets whether or not to show the first label on the axis. */
				showFirstLabel: true,
				/* type="number" the angle to use for the axis title. */
				titleAngle: 0,
				/* type="number" the length of the tickmarks to display for this axis. */
				tickLength: 0,
				/* type="number" the stroke thickness to use for the tickmarks. */
				tickStrokeThickness: 0.5,
				/* type="object" the color to use for the tickmarks. */
				tickStroke: "black",
				/* type="bool" Gets or sets whether the cateogory axis should use clustering display mode even if no series are present that would force clustering mode. */
				useClusteringMode: false
			}],
			/* type="array" an array of series objects */
			series: [{
				/* type="area|bar|column|line|rangeArea|rangeColumn|splineArea|spline|stepArea|stepLine|waterfall|financial|typicalPriceIndicator|polarArea|polarLine|polarScatter|radialColumn|radialLine|radialPie|scatter|scatterLine|bubble|absoluteVolumeOscillatorIndicator|averageTrueRangeIndicator|accumulationDistributionIndicator|averageDirectionalIndexIndicator" Type of the series.
					area type="string" Specify the series as Area series.
					bar type="string" Specify the series as Bar series.
					column type="string" Specify the series as Column series.
					line type="string" Specify the series as Line series.
					rangeArea type="string" Specify the series as Range Area series.
					rangeColumn type="string" Specify the series as Range Column series.
					splineArea type="string" Specify the series as Spline Area series.
					spline type="string" Specify the series as Spline series.
					stepArea type="string" Specify the series as Step Area series.
					stepLine type="string" Specify the series as Step Line series.
					waterfall type="string" Specify the series as Waterfall series.
					financial type="string" Specify the series as Financial series.
					typicalPriceIndicator type="string" Specify the series as Typical Price Indicator series.
					point type="string" Specify the series as Point series.
					polarSplineArea type="string" Specify the series as Polar Spline Area series.
					polarSpline type="string" Specify the series as Polar Spline series.
					polarArea type="string" Specify the series as Polar Area series.
					polarLine type="string" Specify the series as Polar Line series.
					polarScatter type="string" Specify the series as Polar Scatter series.
					radialColumn type="string" Specify the series as Radial Column series.
					radialLine type="string" Specify the series as Radial Line series.
					radialPie type="string" Specify the series as Radial Pie series.
					radialArea type="string" Specify the series as Radial Area series.
					scatter type="string" Specify the series as Scatter series.
					scatterLine type="string" Specify the series as Scatter Line series.
					scatterSpline type="string" Specify the series as Scatter Spline series.
					bubble type="string" Specify the series as Bubble series.
					absoluteVolumeOscillatorIndicator type="string" Specify the series as Absolute Volume Oscillator Indicator series.
					averageTrueRangeIndicator type="string" Specify the series as Average True Range Indicator series.
					accumulationDistributionIndicator type="string" Specify the series as Accumulation Distribution Indicator series
					averageDirectionalIndexIndicator type="string" Specify the series as Average Directional Index Indicator series.
					bollingerBandWidthIndicator type="string" Specify the series as Bollinger Band Width Indicator series.
					chaikinOscillatorIndicator type="string" Specify the series as Chaikin Oscillator Indicator series.
					chaikinVolatilityIndicator type="string" Specify the series as Chaikin Volitility Indicator series.
					commodityChannelIndexIndicator type="string" Specify the series as Commodity Channel Index Indicator series.
					detrendedPriceOscillatorIndicator type="string" Specify the series as Detrended Price Oscillator Indicator series.
					easeOfMovementIndicator type="string" Specify the series as Ease Of Movement Indicator series.
					fastStochasticOscillatorIndicator type="string" Specify the series as Fast Stochastic Oscillator Indicator series.
					forceIndexIndicator type="string" Specify the series as Force Index Indicator series.
					fullStochasticOscillatorIndicator type="string" Specify the series as Full Stochastic Oscillator Indicator series.
					marketFacilitationIndexIndicator type="string" Specify the series as Market Facilitation Index Indicator series.
					massIndexIndicator type="string" Specify the series as Mass Index Indicator series.
					medianPriceIndicator type="string" Specify the series as Median Price Indicator series.
					moneyFlowIndexIndicator type="string" Specify the series as Money Flow Index Indicator series.
					movingAverageConvergenceDivergenceIndicator type="string" Specify the series as Moving Average Convergence Divergence Indicator series.
					negativeVolumeIndexIndicator type="string" Specify the series as Negative Volume Index Indicator series.
					onBalanceVolumeIndicator type="string" Specify the series as On Balance Volume Indicator series.
					percentagePriceOscillatorIndicator type="string" Specify the series as Percentage Price Oscillator Indicator series.
					percentageVolumeOscillatorIndicator type="string" Specify the series as Percentage Volume Oscillator Indicator series.
					positiveVolumeIndexIndicator type="string" Specify the series as Positive Volume Index Indicator series.
					priceVolumeTrendIndictor type="string" Specify the series as Price Volume Trend Indictor series.
					rateOfChangeAndMomentumIndicator type="string" Specify the series as Rate Of Change And Momentum Indicator series.
					relativeStrengthIndexIndicator type="string" Specify the series as Relative Strength Index Indicator series.
					slowStochasticOscillatorIndicator type="string" Specify the series as Slow Stochastic Oscillator Indicator series.
					standardDeviationIndicator type="string" Specify the series as Standard Deviation Indicator series.
					stochRSIIndicator type="string" Specify the series as Stoch RSI Indicator series.
					trixIndicator type="string" Specify the series as Trix Indicator series.
					ultimateOscillatorIndicator type="string" Specify the series as Ultimate Oscillator Indicator series.
					weightedCloseIndicator type="string" Specify the series as Weighted Close Indicator series.
					williamsPercentRIndicator type="string" Specify the series as Williams Percent R Indicator series.
					bollingerBandsOverlay type="string" Specify the series as Bollinger Bands Overlay series.
					priceChannelOverlay type="string" Specify the series as Price Channel Overlay series.
					customIndicator type="string" Specify the series as Custom Indicator series.
					stackedBar type="string" Specify the series as Stacked Bar series.
					stacked100Bar type="string" Specify the series as Stacked 100 Bar series.
					stackedArea type="string" Specify the series as Stacked Area series.
					stacked100Area type="string" Specify the series as Stacked 100 Area series.
					stackedColumn type="string" Specify the series as Stacked Column series.
					stacked100Column type="string" Specify the series as Stacked 100 Column series.
					stackedLine type="string" Specify the series as Stacked Line series.
					stacked100Line type="string" Specify the series as Stacked 100 Line series.
					stackedSpline type="string" Specify the series as Stacked Spline series.
					stacked100Spline type="string" Specify the series as Stacked 100 Spline series.
					stackedSplineArea type="string" Specify the series as Stacked Spline Area series.
					stacked100SplineArea type="string" Specify the series as Stacked 100 Spline Area series.
					crosshairLayer type="string" Specify the series as a crosshair layer.
					categoryHighlightLayer type="string" Specify the series as a category highlight layer.
					categoryItemHighlightLayer type="string" Specify the series as a category item highlight layer.
					itemToolTipLayer type="string" Specify the series as an item tooltip layer.
					categoryToolTipLayer type="string" Specify the series as a category tooltip layer.
				*/
				type: null,
				/* type="string" the unique identifier of the series. */
				name: null,
				/* type="object" can be any valid data source accepted by $.ig.DataSource, or an instance of an $.ig.DataSource itself */
				dataSource: null,
				/* type="string" Specifies a remote URL accepted by $.ig.DataSource in order to request data from it */
				dataSourceUrl: null,
				/* type="string" Explicitly set data source type (such as "json"). Please refer to the documentation of $.ig.DataSource and its type property. */
				dataSourceType: null,
				/* type="string" see $.ig.DataSource. Specifies the name of the property in which data records are held if the response is wrapped. */
				responseDataKey: null,
				/* type="bool" Set to true in order to have an existing series removed from the chart, by name */
				remove: false,
				/* type="bool" Whether the chart should render a tooltip. */
				showTooltip: false,
				/* type="string" The name of template or the template itself that chart tooltip will use to render. */
				tooltipTemplate: null,
				/* type="object" can be any valid options accepted by $.ig.ChartLegend, or an instance of an $.ig.ChartLegend itself. */
				legend: {
					/* type="string" the name of the element to turn into a legend. */
					element: null,
					/* type="item|legend" Type of the legend.
						item type="string" Specify the legend as item legend. It displays a legend item for each pie in the igPieChart control.
						legend type="string" Specify the legend as legend. It is supported by all types of series in the igDataChart control.
					*/
					type: "legend",
					/* type="string|number|null" The width of the legend.
						string The widget width can be set in pixels (px) and percentage (%).
						number The widget width can be set as a number
						null type="object" will stretch to fit data, if no other widths are defined
					*/
					width: null,
					/* type="string|number|null" The height of the legend.
						string The widget height can be set in pixels (px) and percentage (%).
						number The widget height can be set as a number
						null will stretch vertically to fit data, no other height are defined
					*/
					height : null
				},
				/* type="visible|collapsed" Gets or sets the legend item visibility for the current series object.
				visible type="string" The legend item should be visible.
				collapsed type="string" The legend item should not be visible.
				*/
				legendItemVisibility: "visible",
				/* type="object"
				Gets or sets the LegendItemBadgeTemplate property.
				The legend item badge is created according to the LegendItemBadgeTemplate on-demand by 
				the series object itself.
				The provided object should have properties called render and optionally measure.
				These are functions which will be called that will be called to handle the user specified custom rendering.
				measure will be passed an object that looks like this:
				{
					context: [either a DOM element or a CanvasContext2D depending on the particular template scenario],
					width: [if value is present, specifies the available width, user may set to desired width for content],
					height: [if value is present, specifies the available height, user may set to desired height for content],
					isConstant: [user should set to true if desired with and height will always be the same for this template],
					data: [if present, represents the contextual data for this template]
				}
				render will be passed an object that looks like this:
				{
					context: [either a DOM element or a CanvasContext2D depending on the particular template scenario],
					xPosition: [if present, specifies the x position at which to render the content],
					yPosition: [if present, specifies the y position at which to render the content],
					availableWidth: [if present, specifies the available width in which to render the content],
					availableHeight: [if present, specifies the available height in which to render the content],
					data: [if present, specifies the data that is in context for this content],
					isHitTestRender: [if true, indicates that this is a special render pass for hit testing, in which case the brushes from the data should be used]
				}
				*/
				legendItemBadgeTemplate: null,
				/* type="object"
				Gets or sets the LegendItemTemplate property.
				The legend item control content is created according to the LegendItemTemplate on-demand by 
				the series object itself.
				The provided object should have properties called render and optionally measure. See definition for option: legendItemBadgeTemplate 
				*/
				legendItemTemplate: null,
				/* type="object"
				Gets or sets the DiscreteLegendItemTemplate property.
				The legend item control content is created according to the DiscreteLegendItemTemplate on-demand by 
				the series object itself.
				The provided object should have properties called render and optionally measure. See definition for option: legendItemBadgeTemplate 
				*/
				discreteLegendItemTemplate: null,
				/* type="number"
				Gets or sets the duration of the current series's morph.
				*/
				transitionDuration: 0,
				/* type="object"
				Provides an easing function to use for the transitions. This should either be a well known name of an easing function (The only currently supported name is cubic), or it should be a function that takes a number and returns the output with the function applied. */
				transitionEasingFunction: null,
				/* type="number"
				Gets or sets the current series object's rendering resolution.
				*/
				resolution: 1,
				/* type="string"
				Gets or sets the Title property.
				The legend item control is created according to the Title on-demand by 
				the series object itself.
				*/
				title: null,
				/* type="string"
				Gets or sets the brush to use for the series.
				*/
				brush: null,
				/* type="string"
				Gets or sets the brush to use for the outline of the series.
				Some series types, such as LineSeries, do not display outlines.  Therefore, this property does not affect some charts.
				*/
				outline: null,
				/* type="number"
				Gets or sets the width of the current series object's line thickness.
				*/
				thickness: 0,
				/* type="object"
				Gets or gets the coercion methods to use when loading data from data sources.
				Should be specified before setting any member paths, if being used. Setting it later 
				will not cause data to be reimported into the chart.
				*/
				coercionMethods: null,
				/* type="unset|none|automatic|circle|triangle|pyramid|square|diamond|pentagon|hexagon|tetragram|pentagram|hexagram" Gets or sets the marker type for the current series object. If the MarkerTemplate property is set, the setting of the MarkerType property will be ignored.
				unset type="string" Marker hasn't been set.             
				none type="string" No markerItems.             
				automatic type="string" Automatic marker shape.             
				circle type="string" Circle marker shape.             
				triangle type="string" Flat-top triangle marker shape.             
				pyramid type="string" Flat-base triangle marker shape.             
				square type="string" Square marker shape.             
				diamond type="string" Diamond marker shape.             
				pentagon type="string" Pentagon marker shape.              
				hexagon type="string" Hexagon marker shape.              
				tetragram type="string" Four-pointed star marker shape.             
				pentagram type="string" Five-pointed star marker shape.             
				hexagram type="string" Six-pointed star marker shape.             
				*/
				markerType: "none",
				/* type="object"
				Gets or sets the MarkerTemplate for the current series object.
				The provided object should have properties called render and optionally measure. See definition for option: legendItemBadgeTemplate 
				*/
				markerTemplate: null,
				/* type="string"
				Gets or sets the brush that specifies how the current series object's marker interiors are painted.
				*/
				markerBrush: null,
				/* type="string"
				Gets or sets the brush that specifies how the current series object's marker outlines are painted.
				*/
				markerOutline: null,
				/* type="string"
				Gets or sets the effective x-axis for the current object.
				*/
				xAxis: null,
				/* type="string"
				Gets or sets the effective y-axis for the current object.
				*/
				yAxis: null,
				/* type="string"
				Gets or sets the value mapping property for the current series object.
				*/
				xMemberPath: null,
				/* type="string"
				Gets or sets the value mapping property for the current series object.
				*/
				yMemberPath: null,
				/* type="none|linearFit|quadraticFit|cubicFit|quarticFit|quinticFit|logarithmicFit|exponentialFit|powerLawFit|simpleAverage|exponentialAverage|modifiedAverage|cumulativeAverage|weightedAverage" Gets or sets the trend type for the current scatter series.
				none type="string" No trendline should display.
				linearFit type="string" Linear fit.
				quadraticFit type="string" Quadratic polynomial fit.
				cubicFit type="string" Cubic polynomial fit.
				quarticFit type="string" Quartic polynomial fit.
				quinticFit type="string" Quintic polynomial fit.
				logarithmicFit type="string" Logarithmic fit.
				exponentialFit type="string" Exponential fit.
				powerLawFit type="string" Powerlaw fit.
				simpleAverage type="string" Simple moving average.
				exponentialAverage type="string" Exponential moving average.
				modifiedAverage type="string" Modified moving average.
				cumulativeAverage type="string" Cumulative moving average.
				weightedAverage type="string" Weighted moving average.
				*/
				trendLineType: "none",
				/* type="string"
				Gets or sets the brush to use to draw the trend line.
				*/
				trendLineBrush: null,
				/* type="number"
				Gets or sets the thickness of the current scatter series object's trend line.
				*/
				trendLineThickness: 1.5,
				/* type="number"
				Gets or sets the moving average period for the current scatter series object.
				The typical, and initial, value for trend line period is 7.
				*/
				trendLinePeriod: 7,
				/* type="number"
				Gets or sets the Z-Index of the trend line.  Values greater than 1000 will result in the trend line being rendered in front of the series data.
				*/
				trendLineZIndex: 1001,
				/* type="number"
				Gets or sets the maximum number of markerItems displayed by the current series.
				If more than the specified number of markerItems are visible, the series will automatically
				choose a representative set.
				*/
				maximumMarkers: 400,
				/* type="linearInterpolate|dontPlot" Determines how unknown values will be plotted on the chart. Null and Double.NaN are two examples of unknown values.
				linearInterpolate type="string" Plot the unknown value as the midpoint between surrounding known values using linear interpolation.
				dontPlot type="string" Do not plot the unknown value on the chart.
				*/
				unknownValuePlotting: "dontPlot",
				/* type="string"
				Gets or sets the radius mapping property for the current series object.
				*/
				radiusMemberPath: null,
				/* type="object"
				Gets or sets the radius size scale for the bubbles.
				*/
				radiusScale: null,
				/* type="string"
				Gets or sets the Label mapping property for the current series object.
				*/
				labelMemberPath: null,
				/* type="string"
				Gets or sets the fill mapping property for the current series object.
				*/
				fillMemberPath: null,
				/* type="object"
				Gets or sets the brush scale for the marker brush.
				*/
				fillScale: null,
				/* type="string"
				Gets the effective angle axis for the current series object.
				*/
				angleAxis: null,
				/* type="string"
				Gets the effective value axis for the current series object.
				*/
				valueAxis: null,
				/* type="bool"
				Gets or sets whether to clip the series to the bounds.
				Setting this to true can effect performance.
				*/
				clipSeriesToBounds: null,
				/* type="string"
				Gets or sets the item path that provides the values for the current series.
				*/
				valueMemberPath: null,
				/* type="number"
				Gets or sets the x-radius of the ellipse that is used to round the corners of the column.
				*/
				radiusX: 2.0,
				/* type="number"
				Gets or sets the y-radius of the ellipse that is used to round the corners of the column.
				*/
				radiusY: 2.0,
				/* type="number"
				Gets or sets the x-radius of the ellipse that is used to round the corners of the column.
				*/
				angleMemberPath: null,
				/* type="string"
				Gets the effective radius axis for the current series object.
				*/
				radiusAxis: null,
				/* type="bool"
				Gets or sets whether Cartesian Interpolation should be used rather than Archimedian 
				spiral based interpolation.
				*/
				useCartesianInterpolation: true,
				/* type="string"
				Gets or sets the brush to use for negative portions of the series.
				*/
				negativeBrush: null,
				/* type="natural|clamped" Gets or sets the type of spline to be rendered.
				natural type="string" Calculates the spline using a natural spline calculation formula.        
				clamped type="string" Calculated the spline using a clamped spline calculation formula.        
				*/
				splineType: "natural",
				/* type="string"
				Gets or sets the value mapping property for the current series object.
				*/
				lowMemberPath: null,
				/* type="string"
				Gets or sets the value mapping property for the current series object.
				*/
				highMemberPath: null,
				/* type="string"
				Gets or sets the open mapping property for the current series object.
				*/
				openMemberPath: null,
				/* type="string"
				Gets or sets the close mapping property for the current series object.
				*/
				closeMemberPath: null,
				/* type="string"
				Gets or sets the volume mapping property for the current series object.
				*/
				volumeMemberPath: null,
				/* type="candlestick|OHLC" Gets or sets the display for the current FinancialIndicator object.
				candlestick type="string" Displays prices as a Japanese Candlestick.
				OHLC type="string" Displays prices as an OHLC bar.
				*/
				displayType: "candlestick",
				/* type="number"
				Gets or sets the number of values to hide at the beginning of the indicator.
				*/
				ignoreFirst: 0,
				/* type="number"
				Gets or sets the moving average period for the current AverageDirectionalIndexIndicator object.
				The typical, and initial, value for AverageDirectionalIndexIndicator periods is 14.
				*/
				period: 0,
				/* type="number"
				Gets or sets the short moving average period for the current AbsoluteVolumeOscillatorIndicator object.
				The typical, and initial, value for short AVO periods is 10.
				*/
				shortPeriod: 0,
				/* type="number"
				Gets or sets the short moving average period for the current AbsoluteVolumeOscillatorIndicator object.
				The typical, and initial, value for long AVO periods is 30.
				*/
				longPeriod: 0,
				/* type="none|omit|fade|omitAndShift|fadeAndShift" Gets or sets the MarkerCollisionAvoidance 
				none type="string" No collision avoidance is attempted.
				omit type="string" Markers that collide will be omitted.
				fade type="string" Markers that collide will be faded in opacity.
				omitAndShift type="string" Markers that collide may be shifted or omitted.
				omitAndFade type="string" Markers that collide may be shifted or faded.
				*/
				markerCollisionAvoidance: "none",
				/* type="bool"
				Sets or Gets whether to increase marker fidelity for extreme data shapes that have lots of Y variation over short X intervals.
				*/
				useHighMarkerFidelity: false,
				/* type="bool"
				Gets or sets the whether to use use brute force mode.
				*/
				useBruteForce: false,
				/* type="bool"
				Gets or sets the whether to progressively load the data into the chart.
				*/
				progressiveLoad: true,
				/* type="bool"
				Gets or sets the whether the chart reacts to mouse move events.
				*/
				mouseOverEnabled: false,
				/* type="bool"
				Gets or sets the whether to use squares when halting a render traversal rather than the shape of the coalesced area.
				*/
				useSquareCutoffStyle: false,
				/* type="number"
				Gets or sets the density value that maps to the minimum heat color.
				*/
				heatMinimum: 0,
				/* type="number"
				Gets or sets the value that maps to the maximum heat color.
				*/
				heatMaximum: 50,
				/* type="object"
				Gets or sets the minimum heat color for the density scale.
				*/
				heatMinimumColor: "black",
				/* type="object"
				Gets or sets the maximum heat color for the density scale.
				*/
				heatMaximumColor: "red",
				/* type="array"
				Gets or sets the series for stacked charts. It should contain array of series objects. Each item in array should represent a series with type="stackedFragment" and it may have most options supported by top-level series object, such as xAxis, yAxis, valueMemberPath, etc.
				*/
				series: null,
				/* type="bool" 
				Gets or sets whether drop shadow should be enabled for this series.
				*/
				isDropShadowEnabled: false,
				/* type="bool" 
				Gets or sets whether drop shadow is applied to the whole series visual or to each of the individual shapes forming the series.
				*/
				useSingleShadow: true,
				/* type="object" 
				Gets or sets the color to use for the drop shadow.
				*/
				shadowColor: "rgba(95,95,95,0.5)",
				/* type="number" 
				Gets or sets the blur amount to use for the drop shadow.
				*/
				shadowBlur: 10,
				/* type="number" 
				Gets or sets the x offset amount to use for the drop shadow.
				*/
				shadowOffsetX: 5,
				/* type="number" 
				Gets or sets the y offset amount to use for the drop shadow.
				*/
				shadowOffsetY: 5,
				/* type="bool"
				Gets or sets if the series should play a transition in animation when the data source is assigned.
				*/
				isTransitionInEnabled: false,
				/* type="auto|normal|valueScaled|indexScaled|random" Gets or sets the speed to transition in the series data points.
				auto type="string" A speed type is automatically selected.
				normal type="string" All speeds are normal, data points will arrive at the same time.
				valueScaled type="string" Data points will arrive later if their value is further from the start point.
				indexScaled type="string" Data points will arrive later if their index is further from the axis origin.
				random type="string" Data points will arrive at random times.
				*/
				transitionInSpeedType: "auto",
				/* type="auto|fromZero|sweepFromLeft|sweepFromRight|sweepFromTop|sweepFromBottom|sweepFromCenter|accordionFromLeft|accordionFromRight|accordionFromTop|accordionFromBottom|expand|sweepFromCategoryAxisMinimum|sweepFromCategoryAxisMaximum|sweepFromValueAxisMinimum|sweepFromValueAxisMaximum|accordionFromCategoryAxisMinimum|accordionFromCategoryAxisMaximum|accordionFromValueAxisMinimum|accordionFromValueAxisMaximum" Gets or sets the method to transition in the series.
				auto type="string" Series transitions in an automatically chosen way.
				fromZero type="string" Series transitions in from the reference value of the value axis.
				sweepFromLeft type="string" Series sweeps in from the left.
				sweepFromRight type="string" Series sweeps in from the right.
				sweepFromTop type="string" Series sweeps in from the top.
				sweepFromBottom type="string" Series sweeps in from the bottom.
				sweepFromCenter type="string" Series sweeps in from the center.
				accordionFromLeft type="string" Series accordions in from the left.
				accordionFromRight type="string" Series accordions in from the right.
				accordionFromTop type="string" Series accordions in from the top.
				accordionFromBottom type="string" Series accordions in from the bottom.
				expand type="string" Series expands from the value midpoints.
				sweepFromCategoryAxisMinimum type="string" Series sweeps in from the category axis minimum.
				sweepFromCategoryAxisMaximum type="string" Series sweeps in from the category axis maximum.
				sweepFromValueAxisMinimum type="string" Series sweeps in from the value axis minimum.
				sweepFromValueAxisMaximum type="string" Series sweeps in from the value axis maximum.
				accordionFromCategoryAxisMinimum type="string" Series accordions in from the category axis minimum.
				accordionFromCategoryAxisMaximum type="string" Series accordions in from the category axis maximum.
				accordionFromValueAxisMinimum type="string" Series accordions in from the value axis minimum.
				accordionFromValueAxisMaximum type="string" Series accordions in from the value axis maximum.
				*/
				transitionInMode: "auto",
				/* type="number" Gets or sets the duration of the current series's transition in morph in milliseconds.
				*/
				transitionInDuration: 500,
				/* type="number" Gets or sets the corner radius to use for the series, if applicable.
				*/
				radius: 2,
				/* type="number" Gets or sets the opacity modifier to apply to the area fill shape of the series, if applicable.
				*/
				areaFillOpacity: 1.0,
				/* type="bool" Gets or sets whether the series should expect that its data source members need to be called as functions to get their values.
				*/
				expectFunctions: false,
				/* type="bool" Gets or sets whether the hover layer should use interpolation to position itself relative the closest values.
				*/
				useInterpolation: false,
				/* type="bool" Gets or sets whether the hover layer should skip unknown values when trying to find the closest values.
				*/
				skipUnknownValues: false,
				/* type="bool" Gets or sets whether the vertical crosshair portion of the layer should be visible.
				*/
				verticalLineVisibility: "visible",
				/* type="bool" Gets or sets whether the horizontal crosshair portion of the layer should be visible.
				*/
				horizontalLineVisibility: "visible",
				/* type="string" Gets or sets the name of the target series for the layer, if desired. Setting the target series will scope the layer to target just that series.
				*/
				targetSeries: null,
				/* type="string" Gets or sets the name of the target axis for the layer, if desired. Setting the target axis will scope the layer to target just that axis.
				*/
				targetAxis: null,
				/* type="bool" Gets or sets whether a custom category style is allowed. Setting this to true will case the assigningCategoryStyle event to get fired, if provided.
				*/
				isCustomCategoryStyleAllowed: false,
				/* type="bool" Gets or sets whether a custom category marker style is allowed. Setting this to true will case the assigningCategoryMarkerStyle event to get fired, if provided.
				*/
				isCustomCategoryMarkerStyleAllowed: false,
				/* type="bool" Gets or sets whether highlighting should be enabled for the series, if supported.
				*/
				isHighlightingEnabled: false,
				/* type="number" Gets or sets the width to use for the highlight region if highlighting items in a grid aligned series (line, spline, etc), with a banded shape.
				*/
				bandHighlightWidth: 10.0,
				/* type="auto|marker|shape" Gets or sets which type of highlight shape to use when highlighting items.
				auto type="string" use an automatic highlight type for this series.
				marker type="string" use a marker highlight type for this series.
				shape type="string" use a shape highlight type for this series.
				*/
				highlightType: "auto",
				/* type="auto|outsideStart|insideStart|insideEnd|outsideEnd" Gets or sets the Position to apply to the tooltip containers.
				auto type="string" use an automatic position for the category tooltips.
				outsideStart type="string" position the category tooltip at the outside start of the value axis.
				insideStart type="string" position the category tooltip at the inside start of the value axis.
				insideEnd type="string" position the category tooltip at the inside end of the value axis.
				outsideEnd type="string" position the category tooltip at the outside end of the value axis.
				*/
				tooltipPosition: "auto",
				/* type="object" Sets the position a cursor position to use instead of the current mouse cursor position for displaying the annotations in this layer.
				Should be an object with an x and a y property in world coordinates (ranging from 0 to 1)
				*/
				cursorPosition: null,
				/* type="bool" Sets if the presence of this layer should disable the default crosshair behavior of the chart, if present.
				*/
				isDefaultCrosshairDisabled: true,
				/* type="bool" Sets if the current layer should take up a brush/ordering index in the series collection to derive its color automatically.
				*/
				useIndex: false,
				/* type="bool" Sets if the current layer should have an entry in the legend of the chart. By default annotation layers are not present in the legend.
				*/
				useLegend: false
			}],/*BUILDREMOVESTHIS*/
			/* type="string" The swatch used to style this widget */
			theme: "c"
		},
		css: {
			/* Classes applied on a div element. */
			chart: "ui-corner-all ui-widget-content ui-chart-container",
			/* Classes applied on a div element, shown when the chart is opened in a non HTML5 compatible browser. */
			unsupportedBrowserClass: "ui-html5-non-html5-supported-message ui-helper-clearfix  ui-html5-non-html5",
			/* Classes applied to the tooltip div element. */
			tooltip: "ui-chart-tooltip ui-widget-content ui-corner-all",
			/* Class applying background-color and border-color to the n-th series in the chart. As many palettes can be defined as neccessary. */
			seriesPalettes: "ui-chart-palette-n",
			/* Class applying background-image to the fill of the n-th series in the chart. Only gradient colors are accepted. As many palettes can be defined as neccessary. */
			seriesFillPalettes: "ui-chart-fill-palette-n",
			/* Class applying background-image to the outline of the n-th series in the chart. Only gradient colors are accepted. As many palettes can be defined as neccessary. */
			seriesOutlinePalettes: "ui-chart-outline-palette-n",
			/* Class applying opacity value to the fill shape of all area-like series. */
			areaFillOpacity: "ui-chart-area-fill-opacity",
			/* Class applying border-color to all of the chart axis lines. */
			axis: "ui-chart-axis",
			/* Class applying border-color to the chart axes stroke lines. Transparent is treated as auto meaning that the chart decides which lines to be displayed based on the series types used in it. For horizontal category series (Column, Line, Area), only horizontal lines are displayed. For vertical category series (Bar), only vertical lines are displayed. For scatter, polar and radial series all gridlines are displayed. */
			axisStroke: "ui-chart-axis-stroke",
			/* Class applying border-color to the chart axes major lines. Transparent is treated as auto meaning that the chart decides which lines to be displayed based on the series types used in it. For horizontal category series (Column, Line, Area), only horizontal lines are displayed. For vertical category series (Bar), only vertical lines are displayed. For scatter, polar and radial series all gridlines are displayed. */
			axisMajorStroke: "ui-chart-axis-major-line",
			/* When the visibility CSS property is set to visible for this class, all grid lines in the chart will be snapped to the nearest pixel. */
			alignedGridLines: "ui-chart-aligned-gridlines",
			/* Class used for specifying width/height for the tick marks of the category axes. */
			categoryAxisTick: "ui-chart-category-axis-tick",
			/* Class applying font color, margin, and vertical alignment to the labels of horizontal axes. */
			horizontalAxisLabels: "ui-horizontal-axis-labels",
			/* Class applying font color, margin, and horizontal (text) alignment to the labels of vertical axes. */
			verticalAxisLabels: "ui-vertical-axis-labels",
			/* Class applying font color to the labels of angular axes. */
			angularAxisLabels: "ui-angular-axis-labels",
			/* Class applying font color, margin, and vertical alignment to the labels of radial axes. */
			radialAxisLabels: "ui-radial-axis-labels",
			/* Class applying font, color, and margin to the chart title. */
			title: "ui-chart-title",
			/* Class applying font, color, and margin to the chart subtitle. */
			subtitle: "ui-chart-subtitle",
			/* Class applying font, color, and margin to the title of horizontal chart axes. */
			horizontalAxisTitle: "ui-chart-horizontal-axis-title",
			/* Class applying font, color, and margin to the title of vertical chart axes. */
			verticalAxisTitle: "ui-chart-vertical-axis-title",
			/* Class setting all styling options to chart legends. */
			legendItemsList: "ui-chart-legend-items-list",
			/* Class setting all styling options to legend item text. */
			legendItemsText: "ui-chart-legend-item-text",
			/* Class setting all styling options to legend item icons. */
			legendItemsBadge: "ui-chart-legend-item-badge"
		},
		events: {
			/* cancel="true" event fired when the mouse has hovered on a series and the tooltip is about to show 
			Function takes arguments evt and ui.
			Use ui.element to get reference to tooltip DOM element.
			Use ui.item to get reference to current series item object.
			Use ui.chart to get reference to chart object.
			Use ui.series to get reference to current series object.
			Use ui.actualItemBrush to get item brush.
			Use ui.actualSeriesBrush to get series brush.
			*/
			tooltipShowing: "tooltipShowing",
			/* event fired after a tooltip is shown
			Function takes arguments evt and ui.
			Use ui.element to get reference to tooltip DOM element.
			Use ui.item to get reference to current series item object.
			Use ui.chart to get reference to chart object.
			Use ui.series to get reference to current series object.
			Use ui.actualItemBrush to get item brush.
			Use ui.actualSeriesBrush to get series brush.
			*/
			tooltipShown: "tooltipShown",
			/* cancel="true" event fired when the mouse has left a series and the tooltip is about to hide
			Function takes arguments evt and ui.
			Use ui.element to get reference to tooltip DOM element.
			Use ui.item to get reference to current series item object.
			Use ui.chart to get reference to chart object.
			Use ui.series to get reference to current series object.
			Use ui.actualItemBrush to get item brush.
			Use ui.actualSeriesBrush to get series brush.
			*/
			tooltipHiding: "tooltipHiding",
			/* event fired after a tooltip is hidden 
			Function takes arguments evt and ui.
			Use ui.element to get reference to tooltip DOM element.
			Use ui.item to get reference to current series item object.
			Use ui.chart to get reference to chart object.
			Use ui.series to get reference to current series object.
			Use ui.actualItemBrush to get item brush.
			Use ui.actualSeriesBrush to get series brush.
			*/
			tooltipHidden: "tooltipHidden",
			/* event fired when the control is displayed on a non HTML5 compliant browser */
			browserNotSupported: "browserNotSupported",
			/* cancel="false"
			Occurs when the cursors are moved over a series in this chart.
			Function takes arguments evt and ui.
			Use ui.item to get reference to current series item object.
			Use ui.chart to get reference to chart object.
			Use ui.series to get reference to current series object.
			Use ui.actualItemBrush to get item brush.
			Use ui.actualSeriesBrush to get series brush.
			Use ui.positionX to get mouse X position.
			Use ui.positionY to get mouse Y position.
			*/
			seriesCursorMouseMove: null,
			/* cancel="false"
			Occurs when the left mouse button is pressed while the mouse pointer is over an element of this chart.
			Function takes arguments evt and ui.
			Use ui.item to get reference to current series item object.
			Use ui.chart to get reference to chart object.
			Use ui.series to get reference to current series object.
			Use ui.actualItemBrush to get item brush.
			Use ui.actualSeriesBrush to get series brush.
			Use ui.positionX to get mouse X position.
			Use ui.positionY to get mouse Y position.
			*/
			seriesMouseLeftButtonDown: null,
			/* cancel="false"
			Occurs when the left mouse button is released while the mouse pointer is over an element of this chart.
			Function takes arguments evt and ui.
			Use ui.item to get reference to current series item object.
			Use ui.chart to get reference to chart object.
			Use ui.series to get reference to current series object.
			Use ui.actualItemBrush to get item brush.
			Use ui.actualSeriesBrush to get series brush.
			Use ui.positionX to get mouse X position.
			Use ui.positionY to get mouse Y position.
			*/
			seriesMouseLeftButtonUp: null,
			/* cancel="false"
			Occurs when the left mouse pointer moves while over an element of this chart.
			Function takes arguments evt and ui.
			Use ui.item to get reference to current series item object.
			Use ui.chart to get reference to chart object.
			Use ui.series to get reference to current series object.
			Use ui.actualItemBrush to get item brush.
			Use ui.actualSeriesBrush to get series brush.
			Use ui.positionX to get mouse X position.
			Use ui.positionY to get mouse Y position.
			*/
			seriesMouseMove: null,
			/* cancel="false"
			Occurs when the left mouse pointer enters an element of this chart.
			Function takes arguments evt and ui.
			Use ui.item to get reference to current series item object.
			Use ui.chart to get reference to chart object.
			Use ui.series to get reference to current series object.
			Use ui.actualItemBrush to get item brush.
			Use ui.actualSeriesBrush to get series brush.
			Use ui.positionX to get mouse X position.
			Use ui.positionY to get mouse Y position.
			*/
			seriesMouseEnter: null,
			/* cancel="false"
			Occurs when the left mouse pointer leaves an element of this chart.
			Function takes arguments evt and ui.
			Use ui.item to get reference to current series item object.
			Use ui.chart to get reference to chart object.
			Use ui.series to get reference to current series object.
			Use ui.actualItemBrush to get item brush.
			Use ui.actualSeriesBrush to get series brush.
			Use ui.positionX to get mouse X position.
			Use ui.positionY to get mouse Y position.
			*/
			seriesMouseLeave: null,
			/* cancel="false"
			Occurs just after the current Chart's window rectangle is changed.
			Function takes arguments evt and ui.
			Use ui.chart to get reference to chart object.
			Use ui.newHeight to get new height value.
			Use ui.newLeft to get new left value.
			Use ui.newTop to get new top value.
			Use ui.newWidth to get new top value.
			Use ui.oldHeight to get old height value.
			Use ui.oldLeft to get old left value.
			Use ui.oldTop to get old top value.
			Use ui.oldWidth to get old top value.
			*/
			windowRectChanged: null,
			/* cancel="false"
			Occurs just after the current Chart's grid area rectangle is changed.
			The grid area may change as the result of the Chart being resized, or
			of an axis being added or changing size, possibly in another Chart.
			Function takes arguments evt and ui.
			Use ui.chart to get reference to chart object.
			Use ui.newHeight to get new height value.
			Use ui.newLeft to get new left value.
			Use ui.newTop to get new top value.
			Use ui.newWidth to get new top value.
			Use ui.oldHeight to get old height value.
			Use ui.oldLeft to get old left value.
			Use ui.oldTop to get old top value.
			Use ui.oldWidth to get old top value.
			*/
			gridAreaRectChanged: null,
			/* cancel="false"
			Raised when the chart's processing for an update has completed.
			Function takes arguments evt and ui.
			Use ui.chart to get reference to chart object.
			*/
			refreshCompleted: null,
			/* cancel="false"
			Event fired when the range of and axis on the chart changes.
			Function takes arguments evt and ui.
			Use ui.axis to get reference to current chart axis object.
			Use ui.chart to get reference to chart object.
			Use ui.newMaximumValue to get new maximum value.
			Use ui.newMinimumValue to get new minimum value.
			Use ui.oldMaximumValue to get old maximum value.
			Use ui.oldMinimumValue to get old minimum value.
			*/
			axisRangeChanged: null,
			/* cancel="false"
			Handle this event in order to specify which columns the Typical price calculation is based on. 
			Function takes arguments evt and ui.
			Use ui.chart to get reference to chart object.
			Use ui.series to get reference to current series object.
			Use ui.count to get the number of positions that should be calculated from the start.
			Use ui.position to get the beginning position that should be calculated from.
			Use ui.supportingCalculations to get the supporting calculations to use in the calculation.
			Use ui.dataSource to get the data to use for the calculation.
			Use ui.basedOn to specify which columns changing will invalidate the series and cause it to be recalculated.
			*/
			typicalBasedOn: null,
			/* cancel="false"
			Event fired when the progressive loading state of the series has changed.
			Function takes arguments evt and ui.
			Use ui.chart to get reference to chart object.
			Use ui.series to get reference to current series object.
			Use ui.currentStatus to get current status.
			*/
			progressiveLoadStatusChanged: null,
			/* cancel="false"
			Event fired to allow you to override the style of items in a category or financial series. Only fires if you set allowCustomCategoryStyle to true for a series.
			Function takes arguments evt and ui.
			Use ui.chart to get reference to chart object.
			Use ui.series to get reference to current series object.
			Use ui.startIndex to get the start index for the current items.
			Use ui.endIndex to get the end index for the current items.
			Use ui.hasDateRange to tell if you should use the startDate and endDate to know the current items instead of startIndex/endIndex.
			Use ui.startDate if ui.hasDateRange is true.
			Use ui.endDate if ui.hasDateRange is true.
			Use ui.getItems to get all the items associated with the event (only if necessary).
			Use ui.fill to get or set the fill to use for the current item.
			Use ui.stroke to get or set the stroke to use for the current item.
			Use ui.opacity to get or set the opacity to use for the current item.
			Use ui.highlightingHandled to set if the default highlighting behavior should not run, given that you are handling it in this event.
			Use ui.maxAllSeriesHighlightingProgress to get the maximum highlighted progress across all series.
			Use ui.sumAllSeriesHighlightingProgress to get the sum of highlighting progtess across all series.
			Use ui.highlightingInfo.progress to tell what the highlighting progress is for the current item, if highlightingInfo is not null.
			Use ui.highlightingInfo.state to tell whether the current item is currently highlighting in or out, is static, if highlightingInfo is not null.
			*/
			assigningCategoryStyle: null,
			/* cancel="false"
			Event fired to allow you to override the style of markers for the items in a category or financial series. Only fires if you set allowCustomCategoryMarkerStyle to true for a series.
			Function takes arguments evt and ui.
			Use ui.chart to get reference to chart object.
			Use ui.series to get reference to current series object.
			Use ui.startIndex to get the start index for the current items.
			Use ui.endIndex to get the end index for the current items.
			Use ui.hasDateRange to tell if you should use the startDate and endDate to know the current items instead of startIndex/endIndex.
			Use ui.startDate if ui.hasDateRange is true.
			Use ui.endDate if ui.hasDateRange is true.
			Use ui.getItems to get all the items associated with the event (only if necessary).
			Use ui.fill to get or set the fill to use for the current item.
			Use ui.stroke to get or set the stroke to use for the current item.
			Use ui.opacity to get or set the opacity to use for the current item.
			Use ui.highlightingHandled to set if the default highlighting behavior should not run, given that you are handling it in this event.
			Use ui.maxAllSeriesHighlightingProgress to get the maximum highlighted progress across all series.
			Use ui.sumAllSeriesHighlightingProgress to get the sum of highlighting progtess across all series.
			Use ui.highlightingInfo.progress to tell what the highlighting progress is for the current item, if highlightingInfo is not null.
			Use ui.highlightingInfo.state to tell whether the current item is currently highlighting in or out, is static, if highlightingInfo is not null.
			*/
			assigningCategoryMarkerStyle: null
		},
		_createWidget: function (options, element) {
			this._fixCss();
			this.dvWidget = new $.ig.dvCommonWidget(this);
			this.dvWidget._createWidget(options, element, this);
		},
		_init: function () {

			//Once the widget instance is created, all other calls to the widget name where the first 
			//parameter is not a string will call the _init() method; if options are passed, the / 
			// setOption()  method will be called before the _init() method.
		},
		_create: function () {
			this._fixCss();
			this.dvWidget._create();
		},
		_fixCss: function () {
			if (this.css.chart.indexOf('{0}') > -1) {
				this.css.chart = this.css.chart.replace('{0}', this.options.theme);
				this.css.tooltip = this.css.tooltip.replace('{0}', this.options.theme);
			}
		},
		_setOption: function (key, value) {
			this.dvWidget._setOption(key, value);
		},
		option: function () {
		    return this.dvWidget.option.apply(this.dvWidget, arguments);
		},
		widget: function () {
			/* Returns the element holding the chart. */
			return this.element;
		},
		id: function () {
			/*  returns the ID of parent element holding the chart.
				returnType="string" 
			*/
			return this.element[0].id;
		},
		exportImage: function (width, height) {
			/* Exports the chart to a PNG image.
				paramType="string|number" optional="true" The width of the image.
				paramType="string|number" optional="true" The height of the image.
				returnType="object" Returns a IMG DOM element. */
			return this.dvWidget._getImage(width, height, this);
		},
		destroy: function () {
			/* Destroys the widget. */
			if (this._chart) {
				this._chart.destroy();
				this._chart = null;
			}
			this.dvWidget._destroy(this);

			$.Widget.prototype.destroy.apply(this, arguments);
		},
		styleUpdated: function () {
			/* Notify the chart that styles it draws colors from may have been updated.
				returnType="object" Returns a reference to this igChart. */
			this._chart.styleUpdated();
			return this;
		},
		resetZoom: function () {
			/* Resets the zoom level of the chart to default.
				returnType="object" Returns a reference to this igChart. */
			this._chart.resetZoom();
			return this;
		},
		addItem: function (item, targetName) {
			/* adds a new item to the data source and notifies the chart.
				paramType="object" The item that we want to add to the data source. 
				paramType="string" The name of the series or axis bound to the data source. 
			*/
			var dataSourceId = targetName || this._containerSourceID;
			if (this.dataSources[dataSourceId]) {
				this.dataSources[dataSourceId].addRow(null, item, true);
			}
		},
		insertItem: function (item, index, targetName) {
			/* inserts a new item to the data source and notifies the chart.
				paramType="object" the new item that we want to insert in the data source. 
				paramType="number" The index in the data source where the new item will be inserted.
				paramType="string" The name of the series or axis bound to the data source. 
			*/
			var dataSourceId = targetName || this._containerSourceID;
			if (this.dataSources[dataSourceId]) {
				this.dataSources[dataSourceId].insertRow(null, item, index, true);
			}
		},
		removeItem: function (index, targetName) {
			/* deletes an item from the data source and notifies the chart.
				paramType="number" The index in the data source from where the item will be been removed.
				paramType="string" The name of the series or axis bound to the data source. 
			*/
			var dataSourceId = targetName || this._containerSourceID;
			if (this.dataSources[dataSourceId]) {
				this.dataSources[dataSourceId].deleteRow(index, true);
			}
		},
		setItem: function (index, item, targetName) {
			/* updates an item in the data source and notifies the chart.
				paramType="number" The index of the item in the data source that we want to change.
				paramType="object" The new item object that will be set in the data source.
				paramType="string" The name of the series or axis bound to the data source. 
			*/
			var dataSourceId = targetName || this._containerSourceID;
			if (this.dataSources[dataSourceId]) {
				this.dataSources[dataSourceId].updateRow(index, item, true);
			}
		},
		notifySetItem: function (dataSource, index, newItem, oldItem) {
			/* Notifies the chart that an item has been set in an associated data source.
				paramType="object" optional="false" The data source in which the change happened.
				paramType="number" optional="false" The index in the items source that has been changed.
				paramType="object" optional="false" the new item that has been set in the collection.
				paramType="object" optional="false" the old item that has been overwritten in the collection.
				returnType="object" Returns a reference to this chart. */
			this._chart.notifySetItem(dataSource, index, oldItem, newItem);
			return this;
		},
		notifyClearItems: function (dataSource) {
			/* Notifies the chart that the items have been cleared from an associated data source.
				It's not necessary to notify more than one target of a change if they share the same items source.
				paramType="object" optional="false" The data source in which the change happened.
				returnType="object" Returns a reference to this chart. */
			this._chart.notifyClearItems(dataSource);
			return this;
		},
		notifyInsertItem: function (dataSource, index, newItem) {
			/* Notifies the target axis or series that an item has been inserted at the specified index in its data source.
				It's not necessary to notify more than one target of a change if they share the same items source.
				paramType="object" optional="false" The data source in which the change happened.
				paramType="number" optional="false" The index in the items source where the new item has been inserted.
				paramType="object" optional="false" the new item that has been set in the collection.
				returnType="object" Returns a reference to this chart. */
			this._chart.notifyInsertItem(dataSource, index, newItem);
			return this;
		},
		notifyRemoveItem: function (dataSource, index, oldItem) {
			/* Notifies the target axis or series that an item has been removed from the specified index in its data source.
				It's not necessary to notify more than one target of a change if they share the same items source.
				paramType="object" optional="false" The data source in which the change happened.
				paramType="number" optional="false" The index in the items source from where the old item has been removed.
				paramType="object" optional="false" the old item that has been removed from the collection.
				returnType="object" Returns a reference to this chart. */
			this._chart.notifyRemoveItem(dataSource, index, oldItem);
			return this;
		},
		scrollIntoView: function (targetName, item) {
			/* Notifies the target axis or series that it should scroll the requested data item into view.
				paramType="string" optional="false" The name of the axis or series notify.
				paramType="object" optional="false" The data item to bring into view, if possible.
				returnType="object" Returns a reference to this chart. */
			var target = this.dvWidget._getNotifyTarget(targetName);
			if (target && target.scrollIntoView) {
				target.scrollIntoView(item);
			}
			return this;
		},
		scaleValue: function (targetName, unscaledValue) {
			/* Notifies the target axis that it should scale the requested value into chart space from axis space.
				For example you can use this method if you want to find where value 50 of the x axis stands scaled to chart's width.
				paramType="string" optional="false" The name of the axis to notify.
				paramType="number" optional="false" The value in axis space to translate into chart space.
				returnType="number" Returns the scaled value. */
			var target = this.dvWidget._getNotifyTarget(targetName);
			if (target && target.scaleValue) {
				return target.scaleValue(unscaledValue);
			}
			return 0.0;
		},
		unscaleValue: function (targetName, scaledValue) {
			/* Notifies the target axis that it should unscale the requested value into axis space from chart space.
				For example you can use this method if you want to find what is the value of x axis unscaled from 0 width of the chart.
				paramType="string" optional="false" The name of the axis to notify.
				paramType="number" optional="false" The value in chart space to translate into axis space.
				returnType="number" Returns the unscaled value. */
			var target = this.dvWidget._getNotifyTarget(targetName);
			if (target && target.unscaleValue) {
				return target.unscaleValue(scaledValue);
			}
			return 0.0;
		},
		notifyVisualPropertiesChanged: function (targetName) {
			/* Notifies the target series that something that affects its visual properties has changed and the visual output needs a repaint.
				paramType="string" optional="false" The name of the series to notify.
				returnType="object" Returns a reference to this chart. */
			var target = this.dvWidget._getNotifyTarget(targetName);
			if (target && target.notifyVisualPropertiesChanged) {
				return target.notifyVisualPropertiesChanged();
			}
			return this;
		},
		flush: function () {
			/* Forces any pending deferred work to render on the chart before continuing */
			this._chart.flush();
		},
		exportVisualData: function () {
			/* exports visual data from the chart to aid in unit testing */
			return this._chart.exportVisualData();
		},
		getActualMinimumValue: function (targetName) {
			/* Gets the actual minimum value of the target numeric or date time axis
			paramType="string" optional="false" The name of the axis from which to get the minimum value. */
			var target = this.dvWidget._getNotifyTarget(targetName);
			if (target && target.actualMinimumValue) {
				return target.actualMinimumValue();
			}
			return 0.0;
		},
		getActualMaximumValue: function (targetName) {
			/* Gets the actual maximum value of the target numeric or date time axis
			paramType="string" optional="false" The name of the axis from which to get the maximum value. */
			var target = this.dvWidget._getNotifyTarget(targetName);
			if (target && target.actualMaximumValue) {
				return target.actualMaximumValue();
			}
			return 0.0;
		},
		print: function () {
			/* Creates a print preview page with the chart, hiding all other elements on the page. */
			this.dvWidget._print();
		},
		renderSeries: function (targetName, animate) {
			/* Indicates that a series should render, even though no option has been modified that would normally cause it to refresh.
				paramType="string" The name of the series to render.
				paramType="bool" Whether the change should be animated, if possible. */
			var target = this.dvWidget._getNotifyTarget(targetName);
			if (target && target.renderSeries) {
				return target.renderSeries(animate);
			}
			return this;
		},
		getItemIndex: function (targetName, worldPoint) {
			/* Gets the item item index associated with the specified world position. 
			paramType="string" The name of the series to target.
			paramType="object" The world position (in the form {x: [number from 0 to 1], y: [number from 0 to 1]} ) that represents a position in the space of the axes.
			returnType="number" Item index or -1 if no item is assocated with the specified world position. */
			var target = this.dvWidget._getNotifyTarget(targetName), p = $.ig.APIFactory.prototype.createPoint(worldPoint.x, worldPoint.y);
			if (target && target.getItemIndex) {
				return target.getItemIndex(p);
			}
		},
		getItem: function (targetName, worldPoint) {
			/* Gets the item that is the best match for the specified world coordinates.
			paramType="string" The name of the series to target.
			paramType="object" The world position (in the form {x: [number from 0 to 1], y: [number from 0 to 1]} ) that represents a position in the space of the axes.
			returnType="object" The item that is the best match. */
		    var target = this.dvWidget._getNotifyTarget(targetName), p = $.ig.APIFactory.prototype.createPoint(worldPoint.x, worldPoint.y);
			if (target && target.getItem) {
				return target.getItem(p);
			}
		},
		_flattenPoint: function(point) {
		    var retPoint = {
		        __x: point.__x,
		        __y: point.__y,
		        x: point.__x,
		        y: point.__y
		    };

		    return retPoint;
		},
		getSeriesValue: function (targetName, worldPoint,  useInterpolation, skipUnknowns) {
			/* If possible, will return the best available main value of the series for a given world coordinate. 
			paramType="string" The name of the series to target.
			paramType="object" The world position (in the form {x: [number from 0 to 1], y: [number from 0 to 1]} ) that represents a position in the space of the axes.
			paramType="bool" If true, interpolation should be used to get in-between values, rather than only the actual values in the data set.
			paramType="bool" If true, unknown values should be skipped.
			returnType="number" The value of the series at the specified world coordinate, or double.NaN if unavailable. */
		    var target = this.dvWidget._getNotifyTarget(targetName), p = $.ig.APIFactory.prototype.createPoint(worldPoint.x, worldPoint.y);
			if (target && target.getSeriesValue) {
				return target.getSeriesValue(p, useInterpolation, skipUnknowns);
			}
		},
		getSeriesValuePosition: function (targetName, worldPoint,  useInterpolation, skipUnknowns) {
			/* If possible, will return the best available main value position of the series for a given world coordinate. 
			paramType="string" The name of the series to target.
			paramType="object" The world position (in the form {x: [number from 0 to 1], y: [number from 0 to 1]} ) that represents a position in the space of the axes.
			paramType="bool" If true, interpolation should be used to get in-between values, rather than only the actual values in the data set.
			paramType="bool" If true, unknown values should be skipped.
			returnType="object" The position of the best available main value for the series in series pixel space. */
		    var target = this.dvWidget._getNotifyTarget(targetName), p = $.ig.APIFactory.prototype.createPoint(worldPoint.x, worldPoint.y);
			if (target && target.getSeriesValuePosition) {
			    return this._flattenPoint(target.getSeriesValuePosition(p, useInterpolation, skipUnknowns));
			}
		},
		getSeriesValuePositionFromSeriesPixel: function (targetName, seriesPoint,  useInterpolation, skipUnknowns) {
			/* If possible, will return the best available main value position of the series for a given world coordinate. 
			paramType="string" The name of the series to target.
			paramType="object" The series pixel position (in the form {x: [number], y: [number]} that represents a position within the pixel space of the series.
			paramType="bool" If true, interpolation should be used to get in-between values, rather than only the actual values in the data set.
			paramType="bool" If true, unknown values should be skipped.
			returnType="object" The position (in the form {x: [number], y: [number]} ) of the best available main value for the series in series pixel space. */
		    var target = this.dvWidget._getNotifyTarget(targetName), p = $.ig.APIFactory.prototype.createPoint(seriesPoint.x, seriesPoint.y);
			if (target && target.getSeriesValuePositionFromSeriesPixel) {
			    return this._flattenPoint(target.getSeriesValuePositionFromSeriesPixel(p, useInterpolation, skipUnknowns));
			}
		},
		getSeriesValueFromSeriesPixel: function (targetName, seriesPoint,  useInterpolation, skipUnknowns) {
			/* If possible, will return the best available main value of the series for a given world coordinate. 
			paramType="string" The name of the series to target.
			paramType="object" The series pixel position (in the form {x: [number], y: [number]} ) that represents a position in the pixel space of the series.
			paramType="bool" If true, interpolation should be used to get in-between values, rather than only the actual values in the data set.
			paramType="bool" If true, unknown values should be skipped.
			returnType="number" The value of the series at the specified world coordinate, or double.NaN if unavailable. */
		    var target = this.dvWidget._getNotifyTarget(targetName), p = $.ig.APIFactory.prototype.createPoint(seriesPoint.x, seriesPoint.y);
			if (target && target.getSeriesValueFromSeriesPixel) {
				return target.getSeriesValueFromSeriesPixel(p, useInterpolation, skipUnknowns);
			}
		},
		getSeriesHighValue: function (targetName, worldPoint,  useInterpolation, skipUnknowns) {
			/* If possible, will return the best available high value of the series for a given world coordinate. 
			paramType="string" The name of the series to target.
			paramType="object" The world position (in the form {x: [number from 0 to 1], y: [number from 0 to 1]} ) that represents a position in the space of the axes.
			paramType="bool" If true, interpolation should be used to get in-between values, rather than only the actual values in the data set.
			paramType="bool" If true, unknown values should be skipped.
			returnType="number" The value of the series at the specified world coordinate, or double.NaN if unavailable. */
		    var target = this.dvWidget._getNotifyTarget(targetName), p = $.ig.APIFactory.prototype.createPoint(worldPoint.x, worldPoint.y);
			if (target && target.getSeriesHighValue) {
				return target.getSeriesHighValue(p, useInterpolation, skipUnknowns);
			}
		},
		getSeriesHighValuePosition: function (targetName, worldPoint,  useInterpolation, skipUnknowns) {
			/* If possible, will return the best available high value position of the series for a given world coordinate. 
			paramType="string" The name of the series to target.
			paramType="object" The world position (in the form {x: [number from 0 to 1], y: [number from 0 to 1]} ) that represents a position in the space of the axes.
			paramType="bool" If true, interpolation should be used to get in-between values, rather than only the actual values in the data set.
			paramType="bool" If true, unknown values should be skipped.
			returnType="object" The position of the best available high value for the series in series pixel space. */
		    var target = this.dvWidget._getNotifyTarget(targetName), p = $.ig.APIFactory.prototype.createPoint(worldPoint.x, worldPoint.y);
			if (target && target.getSeriesHighValuePosition) {
			    return this._flattenPoint(target.getSeriesHighValuePosition(p, useInterpolation, skipUnknowns));
			}
		},
		getSeriesHighValuePositionFromSeriesPixel: function (targetName, seriesPoint,  useInterpolation, skipUnknowns) {
			/* If possible, will return the best available high value position of the series for a given world coordinate. 
			paramType="string" The name of the series to target.
			paramType="object" The series pixel position (in the form {x: [number], y: [number]} that represents a position within the pixel space of the series.
			paramType="bool" If true, interpolation should be used to get in-between values, rather than only the actual values in the data set.
			paramType="bool" If true, unknown values should be skipped.
			returnType="object" The position (in the form {x: [number], y: [number]} ) of the best available high value for the series in series pixel space. */
		    var target = this.dvWidget._getNotifyTarget(targetName), p = $.ig.APIFactory.prototype.createPoint(seriesPoint.x, seriesPoint.y);
			if (target && target.getSeriesHighValuePositionFromSeriesPixel) {
			    return this._flattenPoint(target.getSeriesHighValuePositionFromSeriesPixel(p, useInterpolation, skipUnknowns));
			}
		},
		getSeriesHighValueFromSeriesPixel: function (targetName, seriesPoint,  useInterpolation, skipUnknowns) {
			/* If possible, will return the best available high value of the series for a given world coordinate. 
			paramType="string" The name of the series to target.
			paramType="object" The series pixel position (in the form {x: [number], y: [number]} ) that represents a position in the pixel space of the series.
			paramType="bool" If true, interpolation should be used to get in-between values, rather than only the actual values in the data set.
			paramType="bool" If true, unknown values should be skipped.
			returnType="number" The value of the series at the specified world coordinate, or double.NaN if unavailable. */
		    var target = this.dvWidget._getNotifyTarget(targetName), p = $.ig.APIFactory.prototype.createPoint(seriesPoint.x, seriesPoint.y);
			if (target && target.getSeriesHighValueFromSeriesPixel) {
				return target.getSeriesHighValueFromSeriesPixel(p, useInterpolation, skipUnknowns);
			}
		},
		getSeriesLowValue: function (targetName, worldPoint,  useInterpolation, skipUnknowns) {
			/* If possible, will return the best available low value of the series for a given world coordinate. 
			paramType="string" The name of the series to target.
			paramType="object" The world position (in the form {x: [number from 0 to 1], y: [number from 0 to 1]} ) that represents a position in the space of the axes.
			paramType="bool" If true, interpolation should be used to get in-between values, rather than only the actual values in the data set.
			paramType="bool" If true, unknown values should be skipped.
			returnType="number" The value of the series at the specified world coordinate, or double.NaN if unavailable. */
		    var target = this.dvWidget._getNotifyTarget(targetName), p = $.ig.APIFactory.prototype.createPoint(worldPoint.x, worldPoint.y);
			if (target && target.getSeriesLowValue) {
				return target.getSeriesLowValue(p, useInterpolation, skipUnknowns);
			}
		},
		getSeriesLowValuePosition: function (targetName, worldPoint,  useInterpolation, skipUnknowns) {
			/* If possible, will return the best available low value position of the series for a given world coordinate. 
			paramType="string" The name of the series to target.
			paramType="object" The world position (in the form {x: [number from 0 to 1], y: [number from 0 to 1]} ) that represents a position in the space of the axes.
			paramType="bool" If true, interpolation should be used to get in-between values, rather than only the actual values in the data set.
			paramType="bool" If true, unknown values should be skipped.
			returnType="object" The position of the best available low value for the series in series pixel space. */
		    var target = this.dvWidget._getNotifyTarget(targetName), p = $.ig.APIFactory.prototype.createPoint(worldPoint.x, worldPoint.y);
			if (target && target.getSeriesLowValuePosition) {
			    return this._flattenPoint(target.getSeriesLowValuePosition(p, useInterpolation, skipUnknowns));
			}
		},
		getSeriesLowValuePositionFromSeriesPixel: function (targetName, seriesPoint,  useInterpolation, skipUnknowns) {
			/* If possible, will return the best available low value position of the series for a given world coordinate. 
			paramType="string" The name of the series to target.
			paramType="object" The series pixel position (in the form {x: [number], y: [number]} that represents a position within the pixel space of the series.
			paramType="bool" If true, interpolation should be used to get in-between values, rather than only the actual values in the data set.
			paramType="bool" If true, unknown values should be skipped.
			returnType="object" The position (in the form {x: [number], y: [number]} ) of the best available low value for the series in series pixel space. */
		    var target = this.dvWidget._getNotifyTarget(targetName), p = $.ig.APIFactory.prototype.createPoint(seriesPoint.x, seriesPoint.y);
			if (target && target.getSeriesLowValuePositionFromSeriesPixel) {
			    return this._flattenPoint(target.getSeriesLowValuePositionFromSeriesPixel(p, useInterpolation, skipUnknowns));
			}
		},
		getSeriesLowValueFromSeriesPixel: function (targetName, seriesPoint,  useInterpolation, skipUnknowns) {
			/* If possible, will return the best available low value of the series for a given world coordinate. 
			paramType="string" The name of the series to target.
			paramType="object" The series pixel position (in the form {x: [number], y: [number]} ) that represents a position in the pixel space of the series.
			paramType="bool" If true, interpolation should be used to get in-between values, rather than only the actual values in the data set.
			paramType="bool" If true, unknown values should be skipped.
			returnType="number" The value of the series at the specified world coordinate, or double.NaN if unavailable. */
		    var target = this.dvWidget._getNotifyTarget(targetName), p = $.ig.APIFactory.prototype.createPoint(seriesPoint.x, seriesPoint.y);
			if (target && target.getSeriesLowValueFromSeriesPixel) {
				return target.getSeriesLowValueFromSeriesPixel(p, useInterpolation, skipUnknowns);
			}
		},
		getItemIndexFromSeriesPixel: function (targetName, seriesPoint) {
			/* Gets the item item index associated with the specified series pixel coordinate. 
			paramType="string" The name of the series to target.
			paramType="object" The world position (in the form {x: [number from 0 to 1], y: [number from 0 to 1]} ) that represents a position in the space of the axes.
			returnType="number" Item index or -1 if no item is assocated with the specified world position. */
		    var target = this.dvWidget._getNotifyTarget(targetName), p = $.ig.APIFactory.prototype.createPoint(seriesPoint.x, seriesPoint.y);
			if (target && target.getItemIndexFromSeriesPixel) {
				return target.getItemIndexFromSeriesPixel(p);
			}
		},
		getItemFromSeriesPixel: function (targetName, seriesPoint) {
			/* Gets the item that is the best match for the specified world coordinates.
			paramType="string" The name of the series to target.
			paramType="object" The series pixel position (in the form {x: [number], y: [number]} ) that represents a position in the pixel space of the series.
			returnType="object" The item that is the best match. */
		    var target = this.dvWidget._getNotifyTarget(targetName), p = $.ig.APIFactory.prototype.createPoint(seriesPoint.x, seriesPoint.y);
			if (target && target.getItemFromSeriesPixel) {
				return target.getItemFromSeriesPixel(p);
			}
		},
		getSeriesOffsetValue: function (targetName) {
			/* Gets the category offset for a series, if applicable.
			paramType="string" The name of the series to target.
			returnType="number" The pixel category offset. */
			var target = this.dvWidget._getNotifyTarget(targetName);
			if (target && target.getOffsetValue) {
				return target.getOffsetValue();
			}
		},
		getSeriesCategoryWidth: function (targetName) {
			/* Gets the category width for a series, if applicable.
			paramType="string" The name of the series to target.
			returnType="number" The pixel width of the categories. */
			var target = this.dvWidget._getNotifyTarget(targetName);
			if (target && target.getCategoryWidth) {
				return target.getCategoryWidth();
			}
		},
		replayTransitionIn: function (targetName) {
			/* Replays the transition in animation for a series, if applicable.
			paramType="string" The name of the series to target.
			returnType="object" Returns a reference to this chart. */
			var target = this.dvWidget._getNotifyTarget(targetName);
			if (target && target.replayTransitionIn) {
				target.replayTransitionIn();
			}
			return this;
		},
		simulateHover: function (targetName, seriesPoint) {
			/* Simulates a hover interaction over a given point in the viewport of a series.
			paramType="string" The name of the series to target.
			paramType="object" The point at which to hover. Should have an x property with type number and a y property with type number.
			returnType="object" Returns a reference to this chart. */
			var target = this.dvWidget._getNotifyTarget(targetName);
			if (target && target.simulateHover) {
			    target.simulateHover($.ig.APIFactory.prototype.createPoint(seriesPoint.x, seriesPoint.y));
			}
			return this;
		},
		moveCursorPoint: function (targetName, worldPoint) {
			/* Moves the cursor point of the target annotation layer to the desired world coordinates.
			paramType="string" The name of the series to target.
			paramType="object" The point to which to move the cursor. Should have an x property with type number and a y property with type number.
			returnType="object" Returns a reference to this chart. */
			var target = this.dvWidget._getNotifyTarget(targetName);
			if (target && target.moveCursorPoint) {
			    target.moveCursorPoint($.ig.APIFactory.prototype.createPoint(worldPoint.x, worldPoint.y));
			}
			return this;
		},
		startTiledZoomingIfNecessary: function () {
		    /* Manually starts a tiled zoom if one isn't already running.
			*/
		    this._chart.startTiledZoomingIfNecessary();
		    return this;
		},
		endTiledZoomingIfRunning: function () {
		    /* Manually ends a tiled zoom if one is running.
			*/
		    this._chart.endTiledZoomingIfRunning();
		    return this;
		},
		clearTileZoomCache: function () {
		    /* Clears the tile zoom tile cache so that new tiles will be generated. Only applies if the viewer is using a tile based zoom.
			*/
		    this._chart.clearTileZoomCache();
		    return this;
		}
	});
	$.extend($.ui.igDataChart, {version: '14.2.20142.1018'});

	$.widget("ui.igPieChart", {
		options: {
			/* type="number" The width of the chart. It can be set as a number in pixels, string (px) or percentage (%). */
			width: null,
			/* type="number" The height of the chart. It can be set as a number in pixels, string (px) or percentage (%). */
			height: null,
			/* type="object" can be any valid data source accepted by $.ig.DataSource, or an instance of an $.ig.DataSource itself */
			dataSource: null,
			/* type="string" Specifies a remote URL accepted by $.ig.DataSource in order to request data from it */
			dataSourceUrl: null,
			/* type="string" Explicitly set data source type (such as "json"). Please refer to the documentation of $.ig.DataSource and its type property. */
			dataSourceType: null,
			/* type="string" see $.ig.DataSource. Specifies the name of the property in which data records are held if the response is wrapped. */
			responseDataKey: null,
			/* type="string"
			Gets or Sets the property name that contains the values.
			*/
			valueMemberPath: null,
			/* type="string"
			Gets or sets the property name that contains the labels.
			*/
			labelMemberPath: null,
			/* type="none|center|insideEnd|outsideEnd|bestFit"
			Gets or sets the position of chart labels.
			none type="string" No labels will be displayed.             
			center type="string" Labels will be displayed in the center.             
			insideEnd type="string" Labels will be displayed inside and by the edge of the container.             
			outsideEnd type="string" Labels will be displayed outside the container.             
			bestFit type="string" Labels will automatically decide their location.             
			*/
			labelsPosition: "center",
			/* type="visible|collapsed"
			Gets or sets whether the leader lines are visible.
			visible type="string" 
			collapsed type="string" 
			*/
			leaderLineVisibility: "visible",
			/* type="straightLine|simpleCurve|radialCurve"
			Gets or sets what type of leader lines will be used for the outside end labels.
			straightLine type="string" 
			simpleCurve type="string" 
			radialCurve type="string" 
			*/
			leaderLineType: "straightLine",
			/* type="number"
			Gets or sets the margin between a label and the end of its leader line.
			*/
			leaderLineMargin: 6.0,
			/* type="number"
			Gets or sets the threshold value that determines if slices are grouped into the Others slice.
			*/
			othersCategoryThreshold: 3,
			/* type="function"
			Gets or sets the function to use to transform a pie slice data context into a label for the slice. Function takes one argument of type object.
			Use context.item to get the item associated with the slice, if any.
			Use context.actualItemBrush to get the brush used to paint the slice.
			Use context.outline to get the outline brush used to paint the slice.
			Use context.itemLabel to get the label object that would be used for the slice.
			Use context.percentValue to see the percentage value that is associated with the slice.
			Use context.isOthersSlice to tell if the associated slice is the others slice.
			Should return a string value that should be used for the label.
			*/
			formatLabel: null,
			/* type="object"
			Gets or sets a style object that can be used to override the style settings on the others category slice.
			*/
			othersCategoryStyle: null,
			/* type="number|percent" Gets or sets whether to use numeric or percent-based threshold value.
			number type="string" Data value is compared directly to the value of OthersCategoryThreshold.             
			percent type="string" Data value is compared to OthersCategoryThreshold as a percentage of the total.             
			*/
			othersCategoryType: "percent",
			/* type="string"
			Gets or sets the label of the Others slice.
			*/
			othersCategoryText: "Others",
			/* type="number"
			Determines how much the exploded slice is offset from the center. Value between 0 and 1.
			*/
			explodedRadius: 0.2,
			/* type="number"
			Gets or sets the scaling factor of the chart's radius. Value between 0 and 1.
			*/
			radiusFactor: 0.9,
			/* type="bool"
			Gets or sets whether the slices can be selected.
			*/
			allowSliceSelection: null,
			/* type="bool"
			Gets or sets whether the slices can be exploded.
			*/
			allowSliceExplosion: null,
			/* type="array"
			Gets or sets the collection of exploded slice indices.
			Should be an array of integers that indicate the indexes of the slices to explode.
			*/
			explodedSlices: null,
			/* type="bool" Whether the chart should render a tooltip. */
			showTooltip: false,
			/* type="string" The name of template or the template itself that chart tooltip will use to render. */
			tooltipTemplate: null,
			/* type="object" can be any valid options accepted by $.ig.ChartLegend, or an instance of an $.ig.ChartLegend itself. */
			legend: {
				/* type="string" the name of the element to turn into a legend. */
				element: null,
				/* type="item|legend" Type of the legend.
					item type="string" Specify the legend as item legend. It displays a legend item for each pie in the igPieChart control.
					legend type="string" Specify the legend as legend. It is supported by all types of series in the igDataChart control.
				*/
				type: "item",
				/* type="number" The width of the legend. It can be set as a number in pixels, string (px) or percentage (%). */
				width: null,
				/* type="number" The height of the legend. It can be set as a number in pixels, string (px) or percentage (%). */
				height: null
			},
			/* type="number"
			Gets or sets the pixel amount, by which the labels are offset from the edge of the slices.
			*/
			labelExtent: 10,
			/* type="number"
			Gets or sets the starting angle of the chart.
			The default zero value is equivalent to 3 o'clock.
			*/
			startAngle: 0,
			/* type="counterclockwise|clockwise"
			Gets or sets the rotational direction of the chart.
			counterclockwise type="string" 
			clockwise type="string" 
			*/
			sweepDirection: "clockwise",
			/* type="object"
			Gets or sets the style used when a slice is selected.
			*/
			selectedStyle: null,
			/* type="object"
			Gets or sets the Brushes property.
			The brushes property defines the palette from which automatically assigned slice brushes are selected.
			The value provided should be an array of css color strings. Optionally the first element can be a string reading "RGB" or "HSV" to specify the interpolation mode of the collection.
			*/
			brushes: null,
			/* type="object"
			Gets or sets the Outlines property.
			The Outlines property defines the palette from which automatically assigned slice outlines are selected.
			The value provided should be an array of css color strings. Optionally the first element can be a string reading "RGB" or "HSV" to specify the interpolation mode of the collection.
			*/
			outlines: null,
			/* type="object"
			Gets or sets the LegendItemTemplate property.
			The legend item control content is created according to the LegendItemTemplate on-demand by
			the chart object itself.
			The provided object should have properties called render and optionally measure. See definition for option: legendItemBadgeTemplate 
			*/
			legendItemTemplate: null,
			/* type="object"
			Gets or sets the LegendItemBadgeTemplate property.
			The legend item badge is created according to the LegendItemBadgeTemplate on-demand by
			the chart object itself.
			The provided object should have properties called render and optionally measure. See definition for option: legendItemBadgeTemplate 
			*/
			legendItemBadgeTemplate: null,
			/* type="string" Overrides the style used for text in the pie chart.
			*/
			textStyle: null,/*BUILDREMOVESTHIS*/
			/* type="string" The swatch used to style this widget */
			theme: "c"

		},
		css: {
			/* Get or set the class applied on a div element. */
			chart: "ui-corner-all ui-widget-content ui-chart-piechart-container",
			/* Get or set the class applied on a div element, shown when the chart is opened in a non HTML5 compatible browser. */
			unsupportedBrowserClass: "ui-html5-non-html5-supported-message ui-helper-clearfix ui-html5-non-html5",
			/* Get or set the class applied to the tooltip div element. */
			tooltip: "ui-chart-tooltip ui-widget-content ui-corner-all"
		},
		events: {
			/* cancel="true" event fired when the mouse has hovered on an element long enough to display a tooltip 
			Function takes arguments evt and ui.
			Use ui.element to get reference to tooltip DOM element.
			Use ui.item to get reference to current pie chart item.
			Use ui.chart to get reference to chart object.
			*/
			tooltipShowing: "tooltipShowing",
			/* event fired after a tooltip is shown 
			Function takes arguments evt and ui.
			Use ui.element to get reference to tooltip DOM element.
			Use ui.item to get reference to current pie chart item.
			Use ui.chart to get reference to chart object.
			*/
			tooltipShown: "tooltipShown",
			/* cancel="true" event fired when the mouse has left an element and the tooltip is about to hide 
			Function takes arguments evt and ui.
			Use ui.element to get reference to tooltip DOM element.
			Use ui.item to get reference to current pie chart item.
			Use ui.chart to get reference to chart object.
			*/
			tooltipHiding: "tooltipHiding",
			/* event fired after a tooltip is hidden
			Function takes arguments evt and ui.
			Use ui.element to get reference to tooltip DOM element.
			Use ui.item to get reference to current pie chart item.
			Use ui.chart to get reference to chart object.
			*/
			tooltipHidden: "tooltipHidden",
			/* event fired when the control is displayed on a non HTML5 compliant browser */
			browserNotSupported: "browserNotSupported",
			/* cancel="false"
			Raised when the slice is clicked.
			Function takes arguments evt and ui.
			Use ui.chart to get reference to chart object.
			Use ui.slice to get reference to slice object.
			Use ui.slice.item to get reference to current pie chart item.
			Use ui.slice.isExploded to get is the slice exploded.
			Use ui.slice.isSelected to get is the slice selected.
			*/
			sliceClick: null
		},
		_createWidget: function (options, element) {
			this._fixCss();
			this.dvWidget = new $.ig.dvCommonWidget(this);
			this.dvWidget._createWidget(options, element, this);
		},
		_create: function () {
			this._fixCss();
			this.dvWidget._create();
		},
		_fixCss: function () {
			if (this.css.chart.indexOf('{0}') > -1) {
				this.css.chart = this.css.chart.replace('{0}', this.options.theme);
				this.css.tooltip = this.css.tooltip.replace('{0}', this.options.theme);
			}
		},
		_setOption: function (key, value) {
			this.dvWidget._setOption(key, value);
		},
		option: function () {
		    return this.dvWidget.option.apply(this.dvWidget, arguments);
		},
		addItem: function (item) {
			/* adds a new item to the data source and notifies the chart.
				paramType="object" the new item that will be added to the data source.  
			*/
			this.dataSources[this.id()].addRow(item, true);
		},
		insertItem: function (item, index) {
			/* inserts a new item to the data source and notifies the chart.
				paramType="object" the new item that will be inserted in the data source. 
				paramType="number" The index in the data source where the new item will be inserted.
			*/
			this.dataSources[this.id()].insertRow(null, item, index, true);
		},
		removeItem: function (index) {
			/* deletes an item from the data source and notifies the chart.
				paramType="number" The index in the data source from where the item will be been removed.
			*/
			this.dataSources[this.id()].deleteRow(index, true);
		},
		setItem: function (index, item) {
			/* updates an item in the data source and notifies the chart.
				paramType="number" optional="false" The index in the data source that we want to change.
				paramType="object" the new item that we want to set in the data source.
			*/
			this.dataSources[this.id()].updateRow(index, item, true);
		},
		exportImage: function (width, height) {
			/* Exports the chart to a PNG image.
				paramType="string|number" optional="true" The width of the image.
				paramType="string|number" optional="true" The height of the image.
				returnType="object" Returns a IMG DOM element. */
			return this.dvWidget._getImage(width, height, this);
		},
		destroy: function () {
			/* Destroys the widget. */
			if (this._chart) {
				this._chart.destroy();
				this._chart = null;
			}
			this.dvWidget._destroy(this);

			$.Widget.prototype.destroy.call(this);
			return this;
		},
		id: function () {
			/*  returns the ID of parent element holding the chart.
				returnType="string" 
			*/
			return this.element[0].id;
		},
		widget: function () {
			/* Returns the element holding the chart. */
			return this.element;
		},
		print: function () {
			/* Creates a print preview page with the chart, hiding all other elements on the page. */
			this.dvWidget._print();
		},
		exportVisualData: function () {
			/* exports visual data from the pie chart to aid in unit testing */
			return this._chart.exportVisualData();
		}
	});
	$.extend($.ui.igPieChart, {version: '14.2.20142.1018'});
	/*MOBILEHERE*/
}(jQuery));

/*!@license
* Infragistics.Web.ClientUI infragistics.chart_categorychart.js 14.2.20142.1018
*
* Copyright (c) 2011-2014 Infragistics Inc.
*
* http://www.infragistics.com/
*
* Depends:
*     jquery-1.4.4.js
*     jquery.ui.core.js
*     jquery.ui.widget.js
*     infragistics.util.js
*/

// Declare empty types
$.ig = $.ig || {};
(function ($) {
var $$t = {}
$.ig.$currDefinitions = $$t;
$.ig.util.bulkDefine(["Object:b", 
"Type:c", 
"Boolean:d", 
"ValueType:e", 
"Void:f", 
"IConvertible:g", 
"IFormatProvider:h", 
"Number:i", 
"String:j", 
"IComparable:k", 
"Number:l", 
"Number:m", 
"Number:n", 
"Number:o", 
"NumberStyles:p", 
"Enum:q", 
"Array:r", 
"IList:s", 
"ICollection:t", 
"IEnumerable:u", 
"IEnumerator:v", 
"Number:w", 
"String:x", 
"StringComparison:y", 
"RegExp:z", 
"CultureInfo:aa", 
"Calendar:ab", 
"Date:ac", 
"DayOfWeek:ad", 
"DateTimeKind:ae", 
"Date:af", 
"Error:ag", 
"CompareInfo:ah", 
"CompareOptions:ai", 
"NumberFormatInfo:aj", 
"DateTimeFormatInfo:ak", 
"CalendarWeekRule:al", 
"IEnumerable$1:am", 
"IEnumerator$1:an", 
"IDisposable:ao", 
"StringSplitOptions:ap", 
"Number:aq", 
"Number:ar", 
"Number:as", 
"Number:at", 
"Number:au", 
"Number:av", 
"Assembly:aw", 
"Stream:ax", 
"SeekOrigin:ay", 
"RuntimeTypeHandle:az", 
"MethodInfo:a0", 
"MethodBase:a1", 
"MemberInfo:a2", 
"ParameterInfo:a3", 
"TypeCode:a4", 
"ConstructorInfo:a5", 
"PropertyInfo:a6", 
"Point:a9", 
"Rect:ba", 
"Size:bb", 
"Nullable$1:bc", 
"Math:bd", 
"Color:be", 
"ArgumentException:bf", 
"NotImplementedException:bg", 
"Script:bh", 
"ArgumentNullException:bi", 
"Convert:bl", 
"Environment:bm", 
"IComparable$1:bp", 
"IEquatable$1:bq", 
"InvalidOperationException:by", 
"Predicate$1:bz", 
"MulticastDelegate:b0", 
"IntPtr:b1", 
"IComparer:b3", 
"IEqualityComparer:b4", 
"IComparer$1:b5", 
"IEqualityComparer$1:b6", 
"Random:b7", 
"Tuple$2:b8", 
"List$1:ct", 
"IList$1:cu", 
"ICollection$1:cv", 
"IArray:cw", 
"Enumerable:cx", 
"Func$2:cy", 
"Func$3:cz", 
"IOrderedEnumerable$1:c0", 
"SortedList$1:c1", 
"IArrayList:c2", 
"Array:c3", 
"CompareCallback:c4", 
"Action$1:c5", 
"Comparer$1:c6", 
"DefaultComparer$1:c7", 
"Comparison$1:c8", 
"ReadOnlyCollection$1:c9", 
"UIElement:db", 
"DependencyObject:dc", 
"Dictionary:dd", 
"DependencyProperty:de", 
"PropertyMetadata:df", 
"PropertyChangedCallback:dg", 
"DependencyPropertyChangedEventArgs:dh", 
"UnsetValue:di", 
"DependencyPropertiesCollection:dj", 
"Binding:dk", 
"PropertyPath:dl", 
"Transform:dm", 
"UIElementCollection:dn", 
"ObservableCollection$1:dp", 
"INotifyCollectionChanged:dq", 
"NotifyCollectionChangedEventHandler:dr", 
"NotifyCollectionChangedEventArgs:ds", 
"EventArgs:dt", 
"NotifyCollectionChangedAction:du", 
"INotifyPropertyChanged:dv", 
"PropertyChangedEventHandler:dw", 
"PropertyChangedEventArgs:dx", 
"Delegate:dy", 
"Interlocked:dz", 
"FrameworkElement:d0", 
"Visibility:d1", 
"Style:d2", 
"Control:d3", 
"Thickness:d4", 
"HorizontalAlignment:d5", 
"VerticalAlignment:d6", 
"ContentControl:d7", 
"DataTemplate:d8", 
"DataTemplateRenderHandler:d9", 
"DataTemplateRenderInfo:ea", 
"DataTemplatePassInfo:eb", 
"DataTemplateMeasureHandler:ec", 
"DataTemplateMeasureInfo:ed", 
"DataTemplatePassHandler:ee", 
"PointCollection:eg", 
"Line:em", 
"Shape:en", 
"Brush:eo", 
"DoubleCollection:ep", 
"Path:eq", 
"Geometry:er", 
"GeometryType:es", 
"Polygon:et", 
"Polyline:eu", 
"Rectangle:ev", 
"LinearGradientBrush:ew", 
"GradientStop:ex", 
"FillRule:ey", 
"GeometryCollection:ez", 
"GeometryGroup:e0", 
"LineGeometry:e1", 
"RectangleGeometry:e2", 
"EllipseGeometry:e3", 
"PathGeometry:e4", 
"PathFigureCollection:e5", 
"PathFigure:e6", 
"PathSegmentCollection:e7", 
"PathSegmentType:e8", 
"PathSegment:e9", 
"LineSegment:fa", 
"BezierSegment:fb", 
"PolyBezierSegment:fc", 
"PolyLineSegment:fd", 
"ArcSegment:fe", 
"SweepDirection:ff", 
"PenLineCap:fg", 
"RotateTransform:fi", 
"TranslateTransform:fj", 
"ScaleTransform:fk", 
"TransformGroup:fl", 
"TransformCollection:fm", 
"Key:fn", 
"ModifierKeys:fo", 
"MouseEventArgs:fp", 
"MouseButtonEventArgs:fq", 
"Canvas:fr", 
"Panel:fs", 
"TextBlock:fu", 
"JQueryPromise:fy", 
"Action:fz", 
"JQueryDeferred:f2", 
"JQuery:f3", 
"JQueryObject:f4", 
"Element:f5", 
"ElementAttributeCollection:f6", 
"ElementCollection:f7", 
"WebStyle:f8", 
"ElementNodeType:f9", 
"Document:ga", 
"EventListener:gb", 
"IElementEventHandler:gc", 
"ElementEventHandler:gd", 
"ElementAttribute:ge", 
"JQueryPosition:gf", 
"JQueryCallback:gg", 
"JQueryEvent:gh", 
"JQueryUICallback:gi", 
"StringBuilder:gk", 
"Dictionary$2:hc", 
"IDictionary$2:hd", 
"IDictionary:he", 
"EqualityComparer$1:hf", 
"DefaultEqualityComparer$1:hg", 
"KeyValuePair$2:hi", 
"Debug:hs", 
"AbstractEnumerable:h6", 
"Func$1:h7", 
"AbstractEnumerator:h8", 
"GenericEnumerable$1:ia", 
"GenericEnumerator$1:ib", 
"LinkedList$1:id", 
"LinkedListNode$1:ie", 
"Stack$1:ii", 
"ReverseArrayEnumerator$1:ij"]);













































































































































































































$.ig.util.defType('Stack$1', 'Object', {
	$t: null, 
	init: function ($t) {
		this.$t = $t;
		this.$type = this.$type.specialize(this.$t);

		this.__inner = new $.ig.Array();

		$.ig.Object.prototype.init.call(this);

	}, 
	__inner: null

	, 
	push: function (item) {
		this.__inner.add($.ig.util.getBoxIfEnum(this.$t, item));
	}

	, 
	peek: function () {
		if (this.__inner.length < 1) {
			return $.ig.util.getDefaultValue(this.$t);
		}

		return $.ig.util.getValueIfEnum(this.$t, this.__inner[this.__inner.length - 1]);
	}

	, 
	pop: function () {
		var ret = this.__inner[this.__inner.length - 1];
		this.__inner.removeAt(this.__inner.length - 1);
		return $.ig.util.getValueIfEnum(this.$t, ret);
	}

	, 
	count: function () {

			return this.__inner.length;
	}

	, 
	clear: function () {
		this.__inner.clear();
	}

	, 
	contains: function (item) {
		return this.__inner.contains($.ig.util.getBoxIfEnum(this.$t, item));
	}

	, 
	getEnumerator: function () {
		return new $.ig.ReverseArrayEnumerator$1(this.$t, this.__inner);
	}

	, 
	getEnumerator: function () {
		return new $.ig.ReverseArrayEnumerator$1(this.$t, this.__inner);
	}
	, 
	$type: new $.ig.Type('Stack$1', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(0)])
}, true);

$.ig.util.defType('ReverseArrayEnumerator$1', 'Object', {
	$t: null, 
	__index: 0
	, 
	__array: null
	, 
	init: function ($t, array) {

		this.$t = $t;
		this.$type = this.$type.specialize(this.$t);


		$.ig.Object.prototype.init.call(this);
			this.__array = array;
			this.__index = array.length;
	}

	, 
	current: function () {

			return $.ig.util.getValueIfEnum(this.$t, this.__array[this.__index]);
	}

	, 
	current: function () {

			return this.__array[this.__index];
	}

	, 
	moveNext: function () {
		this.__index--;
		return this.__index >= 0;
	}

	, 
	reset: function () {
		this.__index = this.__array.length;
	}

	, 
	dispose: function () {
		throw new $.ig.NotImplementedException(0);
	}
	, 
	$type: new $.ig.Type('ReverseArrayEnumerator$1', $.ig.Object.prototype.$type, [$.ig.IEnumerator$1.prototype.$type.specialize(0)])
}, true);
















































} (jQuery));



// Declare empty types
$.ig = $.ig || {};
(function ($) {
var $$t = {}
$.ig.$currDefinitions = $$t;
$.ig.util.bulkDefine(["BrushCollection:a", 
"ObservableCollection$1:b", 
"List$1:c", 
"Object:d", 
"Type:e", 
"Boolean:f", 
"ValueType:g", 
"Void:h", 
"IConvertible:i", 
"IFormatProvider:j", 
"Number:k", 
"String:l", 
"IComparable:m", 
"Number:n", 
"Number:o", 
"Number:p", 
"Number:q", 
"NumberStyles:r", 
"Enum:s", 
"Array:t", 
"IList:u", 
"ICollection:v", 
"IEnumerable:w", 
"IEnumerator:x", 
"Number:y", 
"String:z", 
"StringComparison:aa", 
"RegExp:ab", 
"CultureInfo:ac", 
"Calendar:ad", 
"Date:ae", 
"DayOfWeek:af", 
"DateTimeKind:ag", 
"Date:ah", 
"Error:ai", 
"CompareInfo:aj", 
"CompareOptions:ak", 
"NumberFormatInfo:al", 
"DateTimeFormatInfo:am", 
"CalendarWeekRule:an", 
"IEnumerable$1:ao", 
"IEnumerator$1:ap", 
"IDisposable:aq", 
"StringSplitOptions:ar", 
"Number:as", 
"Number:at", 
"Number:au", 
"Number:av", 
"Number:aw", 
"Number:ax", 
"Assembly:ay", 
"Stream:az", 
"SeekOrigin:a0", 
"RuntimeTypeHandle:a1", 
"MethodInfo:a2", 
"MethodBase:a3", 
"MemberInfo:a4", 
"ParameterInfo:a5", 
"TypeCode:a6", 
"ConstructorInfo:a7", 
"PropertyInfo:a8", 
"IList$1:a9", 
"ICollection$1:ba", 
"IArray:bb", 
"Script:bc", 
"Enumerable:bd", 
"Func$2:be", 
"MulticastDelegate:bf", 
"IntPtr:bg", 
"Func$3:bh", 
"IOrderedEnumerable$1:bi", 
"SortedList$1:bj", 
"Math:bk", 
"ArgumentNullException:bl", 
"NotImplementedException:bm", 
"IArrayList:bn", 
"Array:bo", 
"CompareCallback:bp", 
"Action$1:bq", 
"Comparer$1:br", 
"IComparer:bs", 
"IComparer$1:bt", 
"DefaultComparer$1:bu", 
"IComparable$1:bv", 
"Comparison$1:bw", 
"ReadOnlyCollection$1:bx", 
"Predicate$1:by", 
"INotifyCollectionChanged:bz", 
"NotifyCollectionChangedEventHandler:b0", 
"NotifyCollectionChangedEventArgs:b1", 
"EventArgs:b2", 
"NotifyCollectionChangedAction:b3", 
"INotifyPropertyChanged:b4", 
"PropertyChangedEventHandler:b5", 
"PropertyChangedEventArgs:b6", 
"Delegate:b7", 
"Interlocked:b8", 
"InterpolationMode:b9", 
"Brush:ca", 
"Color:cb", 
"ArgumentException:cc", 
"Nullable$1:cd", 
"Random:ce", 
"MathUtil:cf", 
"RuntimeHelpers:cg", 
"RuntimeFieldHandle:ch", 
"ColorUtil:ci", 
"ErrorBarCalculatorReference:cj", 
"ErrorBarCalculatorType:ck", 
"IErrorBarCalculator:cl", 
"IFastItemColumn$1:cm", 
"IFastItemColumnPropertyName:cn", 
"EventHandler$1:co", 
"FastItemColumn:cq", 
"IFastItemColumnInternal:cr", 
"IFastItemsSource:cs", 
"FastReflectionHelper:ct", 
"FastItemDateTimeColumn:cu", 
"FastItemObjectColumn:cv", 
"FastItemIntColumn:cw", 
"FastItemsSource:cx", 
"Dictionary$2:cy", 
"IDictionary$2:cz", 
"IDictionary:c0", 
"IEqualityComparer$1:c1", 
"EqualityComparer$1:c2", 
"IEqualityComparer:c3", 
"DefaultEqualityComparer$1:c4", 
"InvalidOperationException:c5", 
"KeyValuePair$2:c6", 
"FastItemsSourceEventAction:c7", 
"FastItemsSourceEventArgs:c8", 
"ColumnReference:c9", 
"FastItemsSourceReference:da", 
"IFastItemsSourceProvider:db", 
"IRenderer:dc", 
"Rectangle:dd", 
"Shape:de", 
"FrameworkElement:df", 
"UIElement:dg", 
"DependencyObject:dh", 
"Dictionary:di", 
"DependencyProperty:dj", 
"PropertyMetadata:dk", 
"PropertyChangedCallback:dl", 
"DependencyPropertyChangedEventArgs:dm", 
"UnsetValue:dn", 
"DependencyPropertiesCollection:dp", 
"Binding:dq", 
"PropertyPath:dr", 
"Transform:ds", 
"Visibility:dt", 
"Style:du", 
"DoubleCollection:dv", 
"Rect:dw", 
"Size:dx", 
"Point:dy", 
"Path:dz", 
"Geometry:d0", 
"GeometryType:d1", 
"TextBlock:d2", 
"Polygon:d3", 
"PointCollection:d4", 
"Polyline:d5", 
"DataTemplateRenderInfo:d6", 
"DataTemplatePassInfo:d7", 
"ContentControl:d8", 
"Control:d9", 
"Thickness:ea", 
"HorizontalAlignment:eb", 
"VerticalAlignment:ec", 
"DataTemplate:ed", 
"DataTemplateRenderHandler:ee", 
"DataTemplateMeasureHandler:ef", 
"DataTemplateMeasureInfo:eg", 
"DataTemplatePassHandler:eh", 
"Line:ei", 
"RectChangedEventArgs:ej", 
"RectChangedEventHandler:ek", 
"RenderingContext:em", 
"ArrayUtil:en", 
"BrushUtil:eo", 
"LinearGradientBrush:ep", 
"GradientStop:eq", 
"JQueryObject:er", 
"Element:es", 
"ElementAttributeCollection:et", 
"ElementCollection:eu", 
"WebStyle:ev", 
"ElementNodeType:ew", 
"Document:ex", 
"EventListener:ey", 
"IElementEventHandler:ez", 
"ElementEventHandler:e0", 
"ElementAttribute:e1", 
"JQueryPosition:e2", 
"JQueryCallback:e3", 
"JQueryEvent:e4", 
"JQueryUICallback:e5", 
"CssHelper:e6", 
"JQuery:e7", 
"JQueryDeferred:e8", 
"JQueryPromise:e9", 
"Action:fa", 
"CssGradientUtil:fb", 
"GeometryUtil:fc", 
"Tuple$2:fd", 
"Clipper:fe", 
"EdgeClipper:ff", 
"LeftClipper:fg", 
"BottomClipper:fh", 
"RightClipper:fi", 
"TopClipper:fj", 
"EasingFunctions:fk", 
"FontUtil:fl", 
"FontInfo:fm", 
"DoubleAnimator:fn", 
"EasingFunctionHandler:fo", 
"Callback:fp", 
"Extensions:fq", 
"PathGeometry:fr", 
"PathFigureCollection:fs", 
"PathFigure:ft", 
"PathSegmentCollection:fu", 
"GeometryGroup:fv", 
"GeometryCollection:fw", 
"FillRule:fx", 
"Panel:fy", 
"UIElementCollection:fz", 
"Flattener:f0", 
"Stack$1:f1", 
"ReverseArrayEnumerator$1:f2", 
"SpiralTodo:f3", 
"Func$1:f5", 
"PathSegment:f8", 
"PathSegmentType:f9", 
"ArcSegment:ga", 
"SweepDirection:gb", 
"LineSegment:gc", 
"PolyLineSegment:gd", 
"Pool$1:gg", 
"IIndexedPool$1:gh", 
"IPool$1:gi", 
"IHashPool$2:gj", 
"HashPool$2:gk", 
"RectUtil:gm", 
"SmartPlaceableWrapper$1:gn", 
"ISmartPlaceable:go", 
"SmartPosition:gp", 
"SmartPlacer:gq", 
"IVisualData:gs", 
"PrimitiveVisualDataList:gt", 
"PrimitiveVisualData:gu", 
"PrimitiveAppearanceData:gv", 
"BrushAppearanceData:gw", 
"StringBuilder:gx", 
"Environment:gy", 
"AppearanceHelper:gz", 
"LinearGradientBrushAppearanceData:g0", 
"GradientStopAppearanceData:g1", 
"SolidBrushAppearanceData:g2", 
"LineGeometry:g3", 
"RectangleGeometry:g4", 
"EllipseGeometry:g5", 
"EllipseGeometryData:g6", 
"GeometryData:g7", 
"GetPointsSettings:g8", 
"RectangleGeometryData:g9", 
"LineGeometryData:ha", 
"PathGeometryData:hb", 
"PathFigureData:hc", 
"LineSegmentData:hd", 
"SegmentData:he", 
"PolylineSegmentData:hf", 
"ArcSegmentData:hg", 
"PolyBezierSegment:hh", 
"PolyBezierSegmentData:hi", 
"LabelAppearanceData:hj", 
"RotateTransform:hk", 
"TransformGroup:hl", 
"TransformCollection:hm", 
"ShapeTags:hn", 
"RectangleVisualData:hq", 
"PolyLineVisualData:hs", 
"PolygonVisualData:ht", 
"PathVisualData:hu", 
"DOMEventProxy:hv", 
"EventProxy:hw", 
"ModifierKeys:hx", 
"MouseWheelHandler:hy", 
"GestureHandler:hz", 
"ContactHandler:h0", 
"TouchHandler:h1", 
"MouseOverHandler:h2", 
"MouseHandler:h3", 
"KeyHandler:h4", 
"Key:h5", 
"MSGesture:h6", 
"window:h7", 
"MouseEventArgs:h8", 
"CanvasRenderScheduler:h9", 
"ISchedulableRender:ia", 
"CanvasViewRenderer:ib", 
"CanvasContext2D:ic", 
"CanvasContext:id", 
"TextMetrics:ie", 
"ImageData:ig", 
"CanvasElement:ih", 
"Gradient:ii", 
"BezierSegment:ij", 
"TranslateTransform:ik", 
"ScaleTransform:il", 
"InteractionState:io", 
"IOverviewPlusDetailControl:ip", 
"OverviewPlusDetailPaneMode:ir", 
"PropertyChangedEventArgs$1:is", 
"XamOverviewPlusDetailPane:it", 
"XamOverviewPlusDetailPaneView:iu", 
"XamOverviewPlusDetailPaneViewManager:iv", 
"DivElement:iw", 
"ImageElement:ix", 
"Convert:jb", 
"Debug:jc", 
"TrendCalculators:jg", 
"TrendLineType:jh", 
"UnknownValuePlotting:ji", 
"LeastSquaresFit:jj", 
"Numeric:jk", 
"AbstractEnumerable:jl", 
"AbstractEnumerator:jm", 
"GenericEnumerable$1:jn", 
"GenericEnumerator$1:jo"]);

$.ig.util.defType('UnknownValuePlotting', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "LinearInterpolate";
			case 1: return "DontPlot";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('UnknownValuePlotting', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('TrendLineType', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "None";
			case 1: return "LinearFit";
			case 2: return "QuadraticFit";
			case 3: return "CubicFit";
			case 4: return "QuarticFit";
			case 5: return "QuinticFit";
			case 6: return "LogarithmicFit";
			case 7: return "ExponentialFit";
			case 8: return "PowerLawFit";
			case 9: return "SimpleAverage";
			case 10: return "ExponentialAverage";
			case 11: return "ModifiedAverage";
			case 12: return "CumulativeAverage";
			case 13: return "WeightedAverage";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('TrendLineType', $.ig.Enum.prototype.$type)
}, true);






























$.ig.util.defType('ArrayUtil', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	shuffle$1: function ($t, list) {
		if (list != null) {
			var random = new $.ig.Random(0);
			for (var n = list.count() - 1; n > 0; --n) {
				var k = random.next1(n);
				var temp = list.item(n);
				list.item(n, list.item(k));
				list.item(k, temp);
			}

		}

	}

	, 
	insertionIndex$11: function ($t, collection, value) {
		var index = -1;
		var b = 0;
		var e = collection.count();
		while (index == -1) {
			if (e <= b) {
				index = b;

			} else {
				var m = $.ig.intDivide((b + e), 2);
				switch (Math.sign((value).compareTo($.ig.util.getBoxIfEnum($t, collection.item(m))))) {
					case -1:
						e = m;
						break;
					case 0:
						index = m;
						break;
					case 1:
						b = m + 1;
						break;
				}

			}


		}
		return index;
	}

	, 
	insertionIndex$1: function ($t, collection, comparison, value) {
		var index = -1;
		var b = 0;
		var e = collection.count();
		while (index == -1) {
			if (e <= b) {
				index = b;

			} else {
				var m = $.ig.intDivide((b + e), 2);
				switch (Math.sign(comparison(value, collection.item(m)))) {
					case -1:
						e = m;
						break;
					case 0:
						index = m;
						break;
					case 1:
						b = m + 1;
						break;
				}

			}


		}
		return index;
	}

	, 
	binarySearch$1: function ($t, list, comparisonFunction) {
		var currMin = 0;
		var currMax = list.count() - 1;
		while (currMin <= currMax) {
			var currMid = (currMin + ((currMax - currMin) >> 1));
			var compResult = comparisonFunction(list.item(currMid));
			if (compResult < 0) {
				currMax = currMid - 1;

			} else if (compResult > 0) {
				currMin = currMid + 1;

			} else {
				return currMid;
			}



		}
		return ~currMin;
	}
	, 
	$type: new $.ig.Type('ArrayUtil', $.ig.Object.prototype.$type)
}, true);


$.ig.util.defType('Clipper', 'Object', {

	target: function (value) {
		if (arguments.length === 1) {

			if (this.__firstClipper != null) {
				this.__firstClipper.clear();
			}

			this.__firstClipper = null;
			this._target = value;
			var headVal = this._target;
			if (this._leftClipper != null) {
				this._leftClipper.dst(headVal);
				headVal = this._leftClipper;
				this.__firstClipper = this._leftClipper;
			}

			if (this._bottomClipper != null) {
				this._bottomClipper.dst(headVal);
				headVal = this._bottomClipper;
				this._bottomClipper.__nextClipper = this.__firstClipper;
				this.__firstClipper = this._bottomClipper;
			}

			if (this._rightClipper != null) {
				this._rightClipper.dst(headVal);
				headVal = this._rightClipper;
				this._rightClipper.__nextClipper = this.__firstClipper;
				this.__firstClipper = this._rightClipper;
			}

			if (this._topClipper != null) {
				this._topClipper.dst(headVal);
				headVal = this._topClipper;
				this._topClipper.__nextClipper = this.__firstClipper;
				this.__firstClipper = this._topClipper;
			}

			this._head = headVal;
			return value;
		} else {

			return this._target;
		}
	}
	, 
	_head: null
	, 
	__firstClipper: null
	, 
	_target: null
	, 
	_leftClipper: null
	, 
	_bottomClipper: null
	, 
	_rightClipper: null
	, 
	_topClipper: null
	, 
	init: function (initNumber, clip, isClosed) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		var $self = this;
		$.ig.Object.prototype.init.call(this);
			this._leftClipper = (function () { var $ret = new $.ig.LeftClipper();
			$ret._edge = clip.left();
			$ret._isClosed = isClosed; return $ret;}());
			this._bottomClipper = (function () { var $ret = new $.ig.BottomClipper();
			$ret._edge = clip.bottom();
			$ret._isClosed = isClosed; return $ret;}());
			this._rightClipper = (function () { var $ret = new $.ig.RightClipper();
			$ret._edge = clip.right();
			$ret._isClosed = isClosed; return $ret;}());
			this._topClipper = (function () { var $ret = new $.ig.TopClipper();
			$ret._edge = clip.top();
			$ret._isClosed = isClosed; return $ret;}());
	}
	, 
	init1: function (initNumber, left, bottom, right, top, isClosed) {


		var $self = this;
		$.ig.Object.prototype.init.call(this);
			this._leftClipper = !$.ig.util.isNaN(left) ? (function () { var $ret = new $.ig.LeftClipper();
			$ret._edge = left;
			$ret._isClosed = isClosed; return $ret;}()) : null;
			this._bottomClipper = !$.ig.util.isNaN(bottom) ? (function () { var $ret = new $.ig.BottomClipper();
			$ret._edge = bottom;
			$ret._isClosed = isClosed; return $ret;}()) : null;
			this._rightClipper = !$.ig.util.isNaN(right) ? (function () { var $ret = new $.ig.RightClipper();
			$ret._edge = right;
			$ret._isClosed = isClosed; return $ret;}()) : null;
			this._topClipper = !$.ig.util.isNaN(top) ? (function () { var $ret = new $.ig.TopClipper();
			$ret._edge = top;
			$ret._isClosed = isClosed; return $ret;}()) : null;
	}

	, 
	add: function (point) {
		this._head.add(point);
	}

	, 
	isClosed: function (value) {
		if (arguments.length === 1) {

			if (this._leftClipper != null) {
			this._leftClipper._isClosed = value;
			}

			if (this._bottomClipper != null) {
			this._bottomClipper._isClosed = value;
			}

			if (this._rightClipper != null) {
			this._rightClipper._isClosed = value;
			}

			if (this._topClipper != null) {
			this._topClipper._isClosed = value;
			}

			return value;
		} else {

			return (this._leftClipper == null || this._leftClipper._isClosed) && (this._bottomClipper == null || this._bottomClipper._isClosed) && (this._rightClipper == null || this._rightClipper._isClosed) && (this._topClipper == null || this._topClipper._isClosed);
		}
	}
	, 
	$type: new $.ig.Type('Clipper', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('EdgeClipper', 'Object', {
	init: function () {

		this._init = true;
		this._isOutput = false;

		$.ig.Object.prototype.init.call(this);

	}
	, 
	dst: function (value) {
		if (arguments.length === 1) {

			if (this._dst != value) {
				this._init = true;
				this._dst = value;
			}

			return value;
		} else {

			return this._dst;
		}
	}
	, 
	_dst: null
	, 
	__nextClipper: null

	, 
	nextClipper: function (value) {
		if (arguments.length === 1) {

			this.__nextClipper = value;
			return value;
		} else {

			return this.__nextClipper;
		}
	}
	, 
	_init: false
	, 
	_first: null
	, 
	_prev: null
	, 
	_prevInside: false
	, 
	_isClosed: false
	, 
	_isOutput: false

	, 
	add: function (cur) {
		var CurInside = this.isInside(cur);
		if (this._init) {
			this._init = false;
			this._first = cur;

		} else {
			if (true) {
				if (CurInside) {
					if (!this._prevInside) {
						this.dst().add(this.intersection(this._prev, cur));

					} else {
						if (!this._isClosed && !this._isOutput) {
							this.dst().add(this._prev);
							this._isOutput = true;
						}

					}

					this.dst().add(cur);

				} else {
					if (this._prevInside) {
						if (!this._isClosed && !this._isOutput) {
							this.dst().add(this._prev);
							this._isOutput = true;
						}

						this.dst().add(this.intersection(this._prev, cur));
					}

				}

			}

		}

		this._prev = cur;
		this._prevInside = CurInside;
	}

	, 
	clear: function () {
		if (this._isClosed && !this._init) {
			this.add(this._first);
		}

		if (this.__nextClipper != null) {
			this.__nextClipper.clear();
		}

		this._init = true;
		this._isOutput = false;
	}

	, 
	isInside: function (pt) {}

	, 
	intersection: function (b, e) {}

	, 
	getEnumerator: function () {
		return null;
	}

	, 
	getEnumerator: function () {
		return null;
	}

	, 
	isReadOnly: function () {

			return false;
	}

	, 
	count: function () {

			return 0;
	}

	, 
	remove: function (pt) {
		return false;
	}

	, 
	removeAt: function (n) {
	}

	, 
	copyTo: function (pt, n) {
	}

	, 
	contains: function (pt) {
		return false;
	}

	, 
	item: function (n, value) {
		if (arguments.length === 2) {

			return value;
		} else {

			return {__x: 0, __y: 0, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		}
	}

	, 
	insert: function (n, pt) {
	}

	, 
	indexOf: function (pt) {
		return -1;
	}
	, 
	$type: new $.ig.Type('EdgeClipper', $.ig.Object.prototype.$type, [$.ig.IList$1.prototype.$type.specialize($.ig.Point.prototype.$type)])
}, true);

$.ig.util.defType('LeftClipper', 'EdgeClipper', {
	init: function () {


		$.ig.EdgeClipper.prototype.init.call(this);

	}, 
	_edge: 0

	, 
	isInside: function (pt) {
		return pt.__x >= this._edge;
	}

	, 
	intersection: function (b, e) {
		return {__x: this._edge, __y: b.__y + (e.__y - b.__y) * (this._edge - b.__x) / (e.__x - b.__x), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
	}
	, 
	$type: new $.ig.Type('LeftClipper', $.ig.EdgeClipper.prototype.$type)
}, true);

$.ig.util.defType('BottomClipper', 'EdgeClipper', {
	init: function () {


		$.ig.EdgeClipper.prototype.init.call(this);

	}, 
	_edge: 0

	, 
	isInside: function (pt) {
		return pt.__y <= this._edge;
	}

	, 
	intersection: function (b, e) {
		return {__x: b.__x + (e.__x - b.__x) * (this._edge - b.__y) / (e.__y - b.__y), __y: this._edge, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
	}
	, 
	$type: new $.ig.Type('BottomClipper', $.ig.EdgeClipper.prototype.$type)
}, true);

$.ig.util.defType('RightClipper', 'EdgeClipper', {
	init: function () {


		$.ig.EdgeClipper.prototype.init.call(this);

	}, 
	_edge: 0

	, 
	isInside: function (pt) {
		return pt.__x <= this._edge;
	}

	, 
	intersection: function (b, e) {
		return {__x: this._edge, __y: b.__y + (e.__y - b.__y) * (this._edge - b.__x) / (e.__x - b.__x), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
	}
	, 
	$type: new $.ig.Type('RightClipper', $.ig.EdgeClipper.prototype.$type)
}, true);

$.ig.util.defType('TopClipper', 'EdgeClipper', {
	init: function () {


		$.ig.EdgeClipper.prototype.init.call(this);

	}, 
	_edge: 0

	, 
	isInside: function (pt) {
		return pt.__y >= this._edge;
	}

	, 
	intersection: function (b, e) {
		return {__x: b.__x + (e.__x - b.__x) * (this._edge - b.__y) / (e.__y - b.__y), __y: this._edge, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
	}
	, 
	$type: new $.ig.Type('TopClipper', $.ig.EdgeClipper.prototype.$type)
}, true);










$.ig.util.defType('Flattener', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
	}

	, 
	spiral: function (startAngle, startRadius, endAngle, endRadius, error) {
		var $self = this;
		if ($.ig.util.isNaN(error) || error <= 0) {
			error = 1;
		}

		var ret = new $.ig.List$1(Number, 0);
		var todo = new $.ig.Stack$1($.ig.SpiralTodo.prototype.$type);
		var b = (endRadius - startRadius) / (endAngle - startAngle);
		var a = startRadius - b * startAngle;
		var b2 = b * b;
		var a2 = a * a;
		var ab = a * b;
		todo.push((function () { var $ret = new $.ig.SpiralTodo();
		$ret._p0 = 0;
		$ret._p1 = 1; return $ret;}()));
		while (todo.count() != 0) {
			var s = todo.pop();
			var r0 = startRadius + s._p0 * (endRadius - startRadius);
			var t0 = startAngle + s._p0 * (endAngle - startAngle);
			var t02 = t0 * t0;
			var t03 = t02 * t0;
			var r1 = startRadius + s._p1 * (endRadius - startRadius);
			var t1 = startAngle + s._p1 * (endAngle - startAngle);
			var t12 = t1 * t1;
			var t13 = t12 * t1;
			var segment;
			if (b == 0) {
				segment = a2 * (t1 - t0) / 2 + ab * (t12 - t02) / 2 + b2 * (t13 - t03) / 6;

			} else {
				segment = (Math.pow(a + b * t1, 3) - Math.pow(a + b * t0, 3)) / (6 * b);
			}

			var triangle = 0.5 * r0 * r1 * Math.sin(t1 - t0);
			if (segment - triangle > error) {
				var pm = 0.5 * (s._p0 + s._p1);
				todo.push((function () { var $ret = new $.ig.SpiralTodo();
				$ret._p0 = pm;
				$ret._p1 = s._p1; return $ret;}()));
				todo.push((function () { var $ret = new $.ig.SpiralTodo();
				$ret._p0 = s._p0;
				$ret._p1 = pm; return $ret;}()));

			} else {
				ret.add(s._p0);
			}


		}
		ret.add(1);
		return ret;
	}

	, 
	flatten3: function (count, X, Y, resolution) {
		var indices = new $.ig.List$1($.ig.Number.prototype.$type, 0);
		$.ig.Flattener.prototype.flatten2(indices, X, Y, 0, count - 1, resolution);
		return indices;
	}

	, 
	flatten2: function (result, X, Y, b, e, E) {
		var $self = this;
		return $.ig.Flattener.prototype.flatten1(result, function (i) {
			return i;
		}, X, Y, b, e, E);
	}

	, 
	flatten: function (result, indices, X, Y, b, e, E) {
		var $self = this;
		return $.ig.Flattener.prototype.flatten1(result, function (i) {
			return indices.item(i);
		}, X, Y, b, e, E);
	}

	, 
	flatten1: function (result, getIndex, X, Y, b, e, E) {
		if (b > e) {
			return result;
		}

		var Xb = X(getIndex(b));
		var Yb = Y(getIndex(b));
		while (($.ig.util.isNaN(Xb) || $.ig.util.isNaN(Yb)) && b < e) {
			++b;
			Xb = X(getIndex(b));
			Yb = Y(getIndex(b));

		}
		var Xe = X(getIndex(e));
		var Ye = Y(getIndex(e));
		while (($.ig.util.isNaN(Xe) || $.ig.util.isNaN(Ye)) && b < e) {
			--e;
			Xe = X(getIndex(e));
			Ye = Y(getIndex(e));

		}
		if (b == e) {
			result.add(getIndex(b));
			return result;
		}

		result.add(getIndex(b));
		$.ig.Flattener.prototype.flattenRecursive(result, getIndex, X, Y, b, e, E);
		result.add(getIndex(e));
		return result;
	}

	, 
	fastFlatten2: function (result, X, Y, b, e, E) {
		if (b > e) {
			return result;
		}

		var Xb = X[b];
		var Yb = Y[b];
		while (($.ig.util.isNaN(Xb) || $.ig.util.isNaN(Yb)) && b < e) {
			++b;
			Xb = X[b];
			Yb = Y[b];

		}
		var Xe = X[e];
		var Ye = Y[e];
		while (($.ig.util.isNaN(Xe) || $.ig.util.isNaN(Ye)) && b < e) {
			--e;
			Xe = X[e];
			Ye = Y[e];

		}
		if (b == e) {
			result.add(b);
			return result;
		}

		result.add(b);
		$.ig.Flattener.prototype.fastFlattenRecursive(result, X, Y, b, e, E);
		result.add(e);
		return result;
	}

	, 
	fastFlatten: function (count, buckets, point0, useX0AsX1, resolution) {
		var xIndex;
		var yIndex;
		if (point0) {
			xIndex = 0;
			yIndex = 1;

		} else if (useX0AsX1) {
			xIndex = 0;
			yIndex = 2;

		} else {
			xIndex = 2;
			yIndex = 3;
		}


		return $.ig.Flattener.prototype.fastFlatten1(count, buckets, xIndex, yIndex, resolution);
	}

	, 
	fastFlatten1: function (count, buckets, xIndex, yIndex, resolution) {
		var indices = new $.ig.List$1($.ig.Number.prototype.$type, 0);
		$.ig.Flattener.prototype.fastFlatten4(indices, buckets, xIndex, yIndex, 0, count - 1, resolution);
		return indices;
	}

	, 
	fastFlatten3: function (result, buckets, point0, useX0AsX1, b, e, E) {
		var xIndex;
		var yIndex;
		if (point0) {
			xIndex = 0;
			yIndex = 1;

		} else if (useX0AsX1) {
			xIndex = 0;
			yIndex = 2;

		} else {
			xIndex = 2;
			yIndex = 3;
		}


		return $.ig.Flattener.prototype.fastFlatten4(result, buckets, xIndex, yIndex, b, e, E);
	}

	, 
	fastFlatten4: function (result, buckets, xIndex, yIndex, b, e, E) {
		if (b > e) {
			return result;
		}

		var bucketB = buckets.__inner[b];
		var Xb, Yb;
		Xb = bucketB[xIndex];
		Yb = bucketB[yIndex];
		while (($.ig.util.isNaN(Xb) || $.ig.util.isNaN(Yb)) && b < e) {
			++b;
			bucketB = buckets.__inner[b];
			Xb = bucketB[xIndex];
			Yb = bucketB[yIndex];

		}
		var bucketE = buckets.__inner[e];
		var Xe, Ye;
		Xe = bucketE[xIndex];
		Ye = bucketE[yIndex];
		while (($.ig.util.isNaN(Xe) || $.ig.util.isNaN(Ye)) && b < e) {
			--e;
			bucketE = buckets.__inner[e];
			Xe = bucketE[xIndex];
			Ye = bucketE[yIndex];

		}
		if (b == e) {
			result.add(b);
			return result;
		}

		result.add(b);
		$.ig.Flattener.prototype.fastFlattenRecursive1(result, buckets, xIndex, yIndex, b, e, E);
		result.add(e);
		return result;
	}

	, 
	fastFlattenRecursive: function (result, X, Y, b, e, E) {
		var Xb = X[b];
		var Yb = Y[b];
		while (($.ig.util.isNaN(Xb) || $.ig.util.isNaN(Yb)) && b < e) {
			++b;
			Xb = X[b];
			Yb = Y[b];

		}
		var Xe = X[e];
		var Ye = Y[e];
		while (($.ig.util.isNaN(Xe) || $.ig.util.isNaN(Ye)) && b < e) {
			--e;
			Xe = X[e];
			Ye = Y[e];

		}
		if (b + 1 >= e) {
			return;
		}

		var si = -1;
		var se = E * E;
		var xDelt;
		var yDelt;
		xDelt = Xe - Xb;
		yDelt = Ye - Yb;
		var L = xDelt * xDelt + yDelt * yDelt;
		if (L == 0) {
			for (var i = b + 1; i < e; ++i) {
				var Xi = X[i];
				var Yi = Y[i];
				if ($.ig.util.isNaN(Xi) || $.ig.util.isNaN(Yi)) {
					continue;
				}

				xDelt = Xe - Xi;
				yDelt = Ye - Yi;
				var err = xDelt * xDelt + yDelt * yDelt;
				if (err >= se) {
					se = err;
					si = i;
				}

			}


		} else {
			var vx = Xe - Xb;
			var vy = Ye - Yb;
			for (var i1 = b + 1; i1 < e; ++i1) {
				var Xi1 = X[i1];
				var Yi1 = Y[i1];
				if ($.ig.util.isNaN(Xi1) || $.ig.util.isNaN(Yi1)) {
					continue;
				}

				var err1 = NaN;
				var wx = X[i1] - Xb;
				var wy = Y[i1] - Yb;
				var c1 = vx * wx + vy * wy;
				if (c1 <= 0) {
					xDelt = Xb - Xi1;
					yDelt = Yb - Yi1;
					err1 = xDelt * xDelt + yDelt * yDelt;

				} else {
					var c2 = vx * vx + vy * vy;
					if (c2 <= c1) {
						xDelt = Xe - Xi1;
						yDelt = Ye - Yi1;
						err1 = xDelt * xDelt + yDelt * yDelt;

					} else {
						var p = c1 / c2;
						xDelt = Xb + p * vx - Xi1;
						yDelt = Yb + p * vy - Yi1;
						err1 = xDelt * xDelt + yDelt * yDelt;
					}

				}

				if (err1 >= se) {
					se = err1;
					si = i1;
				}

			}

		}

		if (si != -1) {
			$.ig.Flattener.prototype.fastFlattenRecursive(result, X, Y, b, si, E);
			result.add(si);
			$.ig.Flattener.prototype.fastFlattenRecursive(result, X, Y, si, e, E);
		}

		return;
	}

	, 
	fastFlattenRecursive1: function (result, buckets, xIndex, yIndex, b, e, E) {
		var bucketB = buckets.__inner[b];
		var Xb, Yb;
		Xb = bucketB[xIndex];
		Yb = bucketB[yIndex];
		while ((Xb != Xb) || (Yb != Yb) && b < e) {
			++b;
			bucketB = buckets.__inner[b];
			Xb = bucketB[xIndex];
			Yb = bucketB[yIndex];

		}
		var bucketE = buckets.__inner[e];
		var Xe, Ye;
		Xe = bucketE[xIndex];
		Ye = bucketE[yIndex];
		while ((Xe != Xe) || (Ye != Ye) && b < e) {
			--e;
			bucketE = buckets.__inner[e];
			Xe = bucketE[xIndex];
			Ye = bucketE[yIndex];

		}
		if (b + 1 >= e) {
			return;
		}

		var si = -1;
		var se = E * E;
		var xDelt;
		var yDelt;
		xDelt = Xe - Xb;
		yDelt = Ye - Yb;
		var L = xDelt * xDelt + yDelt * yDelt;
		if (L == 0) {
			for (var i = b + 1; i < e; ++i) {
				var bucketI = buckets.__inner[i];
				var Xi, Yi;
				Xi = bucketI[xIndex];
				Yi = bucketI[yIndex];
				if ((Xi != Xi) || (Yi != Yi)) {
					continue;
				}

				xDelt = Xe - Xi;
				yDelt = Ye - Yi;
				var err = xDelt * xDelt + yDelt * yDelt;
				if (err >= se) {
					se = err;
					si = i;
				}

			}


		} else {
			var vx = Xe - Xb;
			var vy = Ye - Yb;
			for (var i1 = b + 1; i1 < e; ++i1) {
				var bucketI1 = buckets.__inner[i1];
				var Xi1, Yi1;
				Xi1 = bucketI1[xIndex];
				Yi1 = bucketI1[yIndex];
				if ((Xi1 != Xi1) || (Yi1 != Yi1)) {
					continue;
				}

				var err1 = NaN;
				var wx = Xi1 - Xb;
				var wy = Yi1 - Yb;
				var c1 = vx * wx + vy * wy;
				if (c1 <= 0) {
					xDelt = Xb - Xi1;
					yDelt = Yb - Yi1;
					err1 = xDelt * xDelt + yDelt * yDelt;

				} else {
					var c2 = vx * vx + vy * vy;
					if (c2 <= c1) {
						xDelt = Xe - Xi1;
						yDelt = Ye - Yi1;
						err1 = xDelt * xDelt + yDelt * yDelt;

					} else {
						var p = c1 / c2;
						xDelt = Xb + p * vx - Xi1;
						yDelt = Yb + p * vy - Yi1;
						err1 = xDelt * xDelt + yDelt * yDelt;
					}

				}

				if (err1 >= se) {
					se = err1;
					si = i1;
				}

			}

		}

		if (si != -1) {
			$.ig.Flattener.prototype.fastFlattenRecursive1(result, buckets, xIndex, yIndex, b, si, E);
			result.add(si);
			$.ig.Flattener.prototype.fastFlattenRecursive1(result, buckets, xIndex, yIndex, si, e, E);
		}

		return;
	}

	, 
	flattenRecursive: function (result, getIndex, X, Y, b, e, E) {
		var Xb = X(getIndex(b));
		var Yb = Y(getIndex(b));
		while (($.ig.util.isNaN(Xb) || $.ig.util.isNaN(Yb)) && b < e) {
			++b;
			Xb = X(getIndex(b));
			Yb = Y(getIndex(b));

		}
		var Xe = X(getIndex(e));
		var Ye = Y(getIndex(e));
		while (($.ig.util.isNaN(Xe) || $.ig.util.isNaN(Ye)) && b < e) {
			--e;
			Xe = X(getIndex(e));
			Ye = Y(getIndex(e));

		}
		if (b + 1 >= e) {
			return;
		}

		var si = -1;
		var se = E;
		var L = $.ig.MathUtil.prototype.hypot(Xe - Xb, Ye - Yb);
		if (L == 0) {
			for (var i = b + 1; i < e; ++i) {
				var Xi = X(getIndex(i));
				var Yi = Y(getIndex(i));
				if ($.ig.util.isNaN(Xi) || $.ig.util.isNaN(Yi)) {
					continue;
				}

				var err = $.ig.MathUtil.prototype.hypot(Xe - Xi, Ye - Yi);
				if (err >= se) {
					se = err;
					si = i;
				}

			}


		} else {
			var vx = Xe - Xb;
			var vy = Ye - Yb;
			for (var i1 = b + 1; i1 < e; ++i1) {
				var Xi1 = X(getIndex(i1));
				var Yi1 = Y(getIndex(i1));
				if ($.ig.util.isNaN(Xi1) || $.ig.util.isNaN(Yi1)) {
					continue;
				}

				var err1 = NaN;
				var wx = X(getIndex(i1)) - Xb;
				var wy = Y(getIndex(i1)) - Yb;
				var c1 = vx * wx + vy * wy;
				if (c1 <= 0) {
					err1 = $.ig.MathUtil.prototype.hypot(Xb - Xi1, Yb - Yi1);

				} else {
					var c2 = vx * vx + vy * vy;
					if (c2 <= c1) {
						err1 = $.ig.MathUtil.prototype.hypot(Xe - Xi1, Ye - Yi1);

					} else {
						var p = c1 / c2;
						err1 = $.ig.MathUtil.prototype.hypot(Xb + p * vx - Xi1, Yb + p * vy - Yi1);
					}

				}

				if (err1 >= se) {
					se = err1;
					si = i1;
				}

			}

		}

		if (si != -1) {
			$.ig.Flattener.prototype.flattenRecursive(result, getIndex, X, Y, b, si, E);
			result.add(getIndex(si));
			$.ig.Flattener.prototype.flattenRecursive(result, getIndex, X, Y, si, e, E);
		}

		return;
	}

	, 
	spline: function (count, X, Y) {
		var spline = new $.ig.PointCollection(0);
		if (count < 5) {
			for (var i = 0; i < count; ++i) {
				spline.add({__x: X(i), __y: Y(i), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			}

			return spline;
		}

		spline.add({__x: X(0), __y: Y(0), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
		var n = count - 1;
		var pa;
		var pb = {__x: X(0), __y: Y(0), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		var pc = {__x: X(0 + 1), __y: Y(0 + 1), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		var pd = {__x: X(0 + 2), __y: Y(0 + 2), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		var eab;
		var mab;
		var ebc = {__x: pc.__x - pb.__x, __y: pc.__y - pb.__y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		var mbc = $.ig.MathUtil.prototype.hypot(ebc.__x, ebc.__y);
		var ecd = {__x: pd.__x - pc.__x, __y: pd.__y - pc.__y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		var mcd = $.ig.MathUtil.prototype.hypot(ecd.__x, ecd.__y);
		var tc;
		var sc;
		var alpha = 0.1;
		var beta = 0.3;
			tc = {__x: pd.__x - pb.__x, __y: pd.__y - pb.__y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
				var m = $.ig.MathUtil.prototype.hypot(tc.__x, tc.__y);
				tc.__x /= m;
				tc.__y /= m;

			sc = 0.5 + (ebc.__x * ecd.__x + ebc.__y * ecd.__y) / (2 * mbc * mcd);
			spline.add({__x: pc.__x - tc.__x * (alpha + beta * sc) * mbc, __y: pc.__y - tc.__y * (alpha + beta * sc) * mbc, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			spline.add(pc);

		for (var i1 = 1; i1 < n - 1; ++i1) {
			pa = pb;
			pb = pc;
			pc = pd;
			pd = {__x: X(i1 + 2), __y: Y(i1 + 2), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			eab = ebc;
			mab = mbc;
			ebc = ecd;
			mbc = mcd;
			ecd = {__x: pd.__x - pc.__x, __y: pd.__y - pc.__y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			mcd = $.ig.MathUtil.prototype.hypot(ecd.__x, ecd.__y);
			var tb = tc;
			var sb = sc;
			tc = {__x: pd.__x - pb.__x, __y: pd.__y - pb.__y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
				var m1 = $.ig.MathUtil.prototype.hypot(tc.__x, tc.__y);
				tc.__x /= m1;
				tc.__y /= m1;

			sc = 0.5 + (ebc.__x * ecd.__x + ebc.__y * ecd.__y) / (2 * mbc * mcd);
			spline.add({__x: pb.__x + tb.__x * (alpha + beta * sb) * mbc, __y: pb.__y + tb.__y * (alpha + beta * sb) * mbc, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			spline.add({__x: pc.__x - tc.__x * (alpha + beta * sc) * mbc, __y: pc.__y - tc.__y * (alpha + beta * sc) * mbc, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			spline.add(pc);
		}

			pa = pb;
			pb = pc;
			pc = pd;
			eab = ebc;
			mab = mbc;
			ebc = ecd;
			mbc = mcd;
			var tb1 = tc;
			var sb1 = sc;
			spline.add({__x: pb.__x + tb1.__x * (alpha + beta * sb1) * mbc, __y: pb.__y + tb1.__y * (alpha + beta * sb1) * mbc, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			spline.add(pc);

		return spline;
	}
	, 
	$type: new $.ig.Type('Flattener', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('SpiralTodo', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}, 
	_p0: 0
	, 
	_p1: 0
	, 
	$type: new $.ig.Type('SpiralTodo', $.ig.Object.prototype.$type)
}, true);










$.ig.util.defType('IHashPool$2', 'Object', {
	$type: new $.ig.Type('IHashPool$2', null, [$.ig.IPool$1.prototype.$type.specialize(0)])
}, true);

$.ig.util.defType('HashPool$2', 'Object', {
	$tKey: null, 
	$tValue: null
	, 
	_inactive: null,
	inactive: function (value) {
		if (arguments.length === 1) {
			this._inactive = value;
			return value;
		} else {
			return this._inactive;
		}
	}

	, 
	_active: null,
	active: function (value) {
		if (arguments.length === 1) {
			this._active = value;
			return value;
		} else {
			return this._active;
		}
	}
	, 
	init: function ($tKey, $tValue) {

		this.$tKey = $tKey;
		this.$tValue = $tValue;
		this.$type = this.$type.specialize(this.$tKey, this.$tValue);


		$.ig.Object.prototype.init.call(this);
			this.inactive(new $.ig.List$1(this.$tValue, 0));
			this.active(new $.ig.Dictionary$2(this.$tKey, this.$tValue, 0));
	}

	, 
	_create: null,
	create: function (value) {
		if (arguments.length === 1) {
			this._create = value;
			return value;
		} else {
			return this._create;
		}
	}

	, 
	_disactivate: null,
	disactivate: function (value) {
		if (arguments.length === 1) {
			this._disactivate = value;
			return value;
		} else {
			return this._disactivate;
		}
	}

	, 
	_activate: null,
	activate: function (value) {
		if (arguments.length === 1) {
			this._activate = value;
			return value;
		} else {
			return this._activate;
		}
	}

	, 
	_destroy: null,
	destroy: function (value) {
		if (arguments.length === 1) {
			this._destroy = value;
			return value;
		} else {
			return this._destroy;
		}
	}

	, 
	item: function (key) {

			var $self = this;
			var ret;
			if (!(function () { var $ret = $self.active().tryGetValue(key, ret); ret = $ret.p1; return $ret.ret; }())) {
				if ($self.inactive().count() > 0) {
					ret = $self.inactive().__inner[$self.inactive().count() - 1];
					$self.inactive().removeAt($self.inactive().count() - 1);

				} else {
					ret = $self.create()();
				}

				if ($self.activate() != null) {
					$self.activate()(ret);
				}

				$self.active().item(key, ret);
			}

			return ret;
	}

	, 
	activeKeys: function () {

			return this.active().keys();
	}

	, 
	isActiveKey: function (key) {
		return this.active().containsKey(key);
	}

	, 
	remove: function (key) {
		var $self = this;
		var remove;
		if ((function () { var $ret = $self.active().tryGetValue(key, remove); remove = $ret.p1; return $ret.ret; }())) {
			$self.active().remove(key);
			if ($self.disactivate() != null) {
				$self.disactivate()(remove);
			}

			$self.inactive().add(remove);
			var activeCount = $self.active().count();
			var inactiveCount = 2;
			while (activeCount != 0) {
				activeCount >>= 1;
				inactiveCount <<= 1;

			}
			if (inactiveCount < $self.inactive().count()) {
				for (var i = inactiveCount; i < $self.inactive().count(); ++i) {
					$self.destroy()($self.inactive().__inner[i]);
				}

				$self.inactive().removeRange(inactiveCount, $self.inactive().count() - inactiveCount);
			}

		}

	}

	, 
	clear: function () {
		var deactivate = new $.ig.List$1(this.$tKey, 0);
		var en = this.active().keys().getEnumerator();
		while (en.moveNext()) {
			var active = en.current();
			deactivate.add(active);
		}

		var en1 = deactivate.getEnumerator();
		while (en1.moveNext()) {
			var key = en1.current();
			this.remove(key);
		}

	}

	, 
	activeCount: function () {

			return this.active().count();
	}

	, 
	doToAll: function (action) {
		for (var i = 0; i < this.inactive().count(); i++) {
			action(this.inactive().__inner[i]);
		}

		var en = this.active().values().getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			action(item);
		}

	}
	, 
	$type: new $.ig.Type('HashPool$2', $.ig.Object.prototype.$type, [$.ig.IHashPool$2.prototype.$type.specialize(0, 1)])
}, true);






































































$.ig.util.defType('Numeric', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
	}

	, 
	solve1: function (a, b, c, r, u) {
		var j;
		var n = a.count();
		var gam = new Array(n);
		if (b.__inner[0] == 0) {
			return false;
		}

		var bet = b.__inner[0];
		u.__inner[0] = r.__inner[0] / (bet);
		for (j = 1; j < n; j++) {
			gam[j] = c.__inner[j - 1] / bet;
			bet = b.__inner[j] - a.__inner[j] * gam[j];
			if (bet == 0) {
				return false;
			}

			u.__inner[j] = (r.__inner[j] - a.__inner[j] * u.__inner[j - 1]) / bet;
		}

		for (j = (n - 2); j >= 0; j--) {
			u.__inner[j] -= gam[j + 1] * u.__inner[j + 1];
		}

		return true;
	}

	, 
	solve: function (a, b) {
		var n = a.getLength(0);
		var indxc = new Array(n);
		var indxr = new Array(n);
		var ipiv = new Array(n);
		for (var i = 0; i < n; i++) {
			ipiv[i] = 0;
		}

		for (var i1 = 0; i1 < n; i1++) {
			var big = 0;
			var irow = 0;
			var icol = 0;
			for (var j = 0; j < n; j++) {
				if (ipiv[j] != 1) {
					for (var k = 0; k < n; k++) {
						if (ipiv[k] == 0) {
							if (Math.abs(a[j][k]) >= big) {
								big = Math.abs(a[j][k]);
								irow = j;
								icol = k;
							}

						}

					}

				}

			}

			++(ipiv[icol]);
			if (irow != icol) {
				for (var j1 = 0; j1 < n; j1++) {
					var t = a[irow][j1];
					a[irow][j1] = a[icol][j1];
					a[icol][j1] = t;
				}

					var t1 = b[irow];
					b[irow] = b[icol];
					b[icol] = t1;

			}

			indxr[i1] = irow;
			indxc[i1] = icol;
			if (a[icol][icol] == 0) {
				return false;
			}

			var pivinv = 1 / a[icol][icol];
			a[icol][icol] = 1;
			for (var j2 = 0; j2 < n; j2++) {
				a[icol][j2] *= pivinv;
			}

			b[icol] *= pivinv;
			for (var j3 = 0; j3 < n; j3++) {
				if (j3 != icol) {
					var dum = a[j3][icol];
					a[j3][icol] = 0;
					for (var l = 0; l < n; l++) {
						a[j3][l] -= a[icol][l] * dum;
					}

					b[j3] -= b[icol] * dum;
				}

			}

		}

		for (var i2 = n - 1; i2 >= 0; i2--) {
			if (indxr[i2] != indxc[i2]) {
				for (var j4 = 0; j4 < n; j4++) {
					var t2 = a[j4][indxr[i2]];
					a[j4][indxr[i2]] = a[j4][indxc[i2]];
					a[j4][indxc[i2]] = t2;
				}

			}

		}

		return true;
	}

	, 
	safeCubicSplineFit: function (count, x, y, yp1, ypn) {
		var ret = new $.ig.List$1(Number, 0);
		for (var i = 0; i < count; ++i) {
			while (i < count && ($.ig.util.isNaN(x(i)) || $.ig.util.isNaN(y(i)))) {
				ret.add(NaN);
				++i;

			}
			var j = i;
			while (i < count && !$.ig.util.isNaN(x(i)) && !$.ig.util.isNaN(y(i))) {
				++i;

			}
			--i;
			if (i - j > 0) {
				ret.addRange($.ig.Numeric.prototype.cubicSplineFit1(j, i - j + 1, x, y, yp1, ypn));

			} else {
				for (; j <= i; ++j) {
					ret.add(NaN);
				}

			}

		}

		return ret.toArray();
	}

	, 
	cubicSplineFit1: function (start, count, x, y, yp1, ypn) {
		var $self = this;
		return $.ig.Numeric.prototype.cubicSplineFit(count, function (i) { return x(i + start); }, function (i) { return y(i + start); }, yp1, ypn);
	}

	, 
	cubicSplineFit: function (count, x, y, yp1, ypn) {
		var u = new Array(count - 1);
		var y2 = new Array(count);
		y2[0] = $.ig.util.isNaN(yp1) ? 0 : -0.5;
		u[0] = $.ig.util.isNaN(yp1) ? 0 : (3 / (x(1) - x(0))) * ((y(1) - y(0)) / (x(1) - x(0)) - yp1);
		for (var i = 1; i < count - 1; i++) {
			var sig = (x(i) - x(i - 1)) / (x(i + 1) - x(i - 1));
			var p = sig * y2[i - 1] + 2;
			y2[i] = (sig - 1) / p;
			u[i] = (y(i + 1) - y(i)) / (x(i + 1) - x(i)) - (y(i) - y(i - 1)) / (x(i) - x(i - 1));
			u[i] = (6 * u[i] / (x(i + 1) - x(i - 1)) - sig * u[i - 1]) / p;
		}

		var qn = $.ig.util.isNaN(ypn) ? 0 : 0.5;
		var un = $.ig.util.isNaN(ypn) ? 0 : (3 / (x(count - 1) - x(count - 2))) * (ypn - (y(count - 1) - y(count - 2)) / (x(count - 1) - x(count - 2)));
		y2[count - 1] = (un - qn * u[count - 2]) / (qn * y2[count - 2] + 1);
		for (var i1 = count - 2; i1 >= 0; i1--) {
			y2[i1] = y2[i1] * y2[i1 + 1] + u[i1];
		}

		return y2;
	}

	, 
	cubicSplineEvaluate: function (x, x1, y1, x2, y2, u1, u2) {
		var h = x2 - x1;
		var a = (x2 - x) / h;
		var b = (x - x1) / h;
		return a * y1 + b * y2 + ((a * a * a - a) * u1 + (b * b * b - b) * u2) * (h * h) / 6;
	}

	, 
	spline2D1: function (count, x, y, stiffness) {
		var result = new $.ig.PathFigureCollection();
		var currentSegmentStart = 0;
		var currentSegmentEnd = -1;
		var valueX = NaN;
		var valueY = NaN;
		for (var i = 0; i < count; i++) {
			valueX = x(i);
			valueY = y(i);
			if ($.ig.util.isNaN(valueX) || $.ig.util.isNaN(valueY)) {
				currentSegmentEnd = i - 1;
				if (currentSegmentEnd - currentSegmentStart > 0) {
					result.add($.ig.Numeric.prototype.spline2D(currentSegmentStart, currentSegmentEnd, x, y, stiffness));
				}

				currentSegmentStart = i + 1;
			}

		}

		if (!$.ig.util.isNaN(valueX) && !$.ig.util.isNaN(valueY)) {
			currentSegmentEnd = count - 1;
		}

		if (currentSegmentEnd - currentSegmentStart > 0) {
			result.add($.ig.Numeric.prototype.spline2D(currentSegmentStart, currentSegmentEnd, x, y, stiffness));
		}

		return result;
	}

	, 
	spline2D: function (startIndex, endIndex, x, y, stiffness) {
		var $self = this;
		stiffness = 0.5 * $.ig.MathUtil.prototype.clamp($.ig.util.isNaN(stiffness) ? 0.5 : stiffness, 0, 1);
		var pathFigure = new $.ig.PathFigure();
		var count = endIndex - startIndex + 1;
		if (count < 2) {
			return pathFigure;
		}

		if (count == 2) {
			pathFigure.__startPoint = {__x: x(startIndex), __y: y(startIndex), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			var newSeg = (function () { var $ret = new $.ig.LineSegment(1);
			$ret.point({__x: x(startIndex + 1), __y: y(startIndex + 1), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}); return $ret;}());
			pathFigure.__segments.add(newSeg);
			return pathFigure;
		}

		var Segment = new $.ig.PolyBezierSegment();
		var pix = x(startIndex);
		var piy = y(startIndex);
		var pixnext = x(startIndex + 1);
		var piynext = y(startIndex + 1);
		while (pixnext == pix && piynext == piy && startIndex + 1 <= endIndex) {
			startIndex++;
			pixnext = x(startIndex + 1);
			piynext = y(startIndex + 1);

		}
		var tix = pixnext - pix;
		var tiy = piynext - piy;
		var li = Math.sqrt(tix * tix + tiy * tiy);
		for (var j = startIndex + 1; j < endIndex; ++j) {
			var pjx = x(j);
			var pjy = y(j);
			if (pjx == pix && pjy == piy) {
				continue;
			}

			var tjx = x(j + 1) - x(j - 1);
			var tjy = y(j + 1) - y(j - 1);
			var lj = tjx * tjx + tjy * tjy;
			if (lj < 0.01) {
				tjx = -(y(j + 1) - y(j));
				tjy = x(j + 1) - x(j);
				lj = tjx * tjx + tjy * tjy;
			}

			lj = Math.sqrt(lj);
			var d = stiffness * Math.sqrt((pjx - pix) * (pjx - pix) + (pjy - piy) * (pjy - piy));
			if (lj > 0.01) {
				Segment.points().add({__x: pix + tix * d / li, __y: piy + tiy * d / li, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
				Segment.points().add({__x: pjx - tjx * d / lj, __y: pjy - tjy * d / lj, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
				Segment.points().add({__x: pjx, __y: pjy, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
				pix = pjx;
				piy = pjy;
				tix = tjx;
				tiy = tjy;
				li = lj;
			}

		}

			var j1 = endIndex;
			var pjx1 = x(j1);
			var pjy1 = y(j1);
			var tjx1 = x(j1) - x(j1 - 1);
			var tjy1 = y(j1) - y(j1 - 1);
			var lj1 = tjx1 * tjx1 + tjy1 * tjy1;
			var d1 = stiffness * Math.sqrt((pjx1 - pix) * (pjx1 - pix) + (pjy1 - piy) * (pjy1 - piy));
			Segment.points().add({__x: pix + tix * d1 / li, __y: piy + tiy * d1 / li, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			Segment.points().add({__x: pjx1 - tjx1 * d1 / lj1, __y: pjy1 - tjy1 * d1 / lj1, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			Segment.points().add({__x: pjx1, __y: pjy1, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});

		pathFigure.__startPoint = {__x: x(startIndex), __y: y(startIndex), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		pathFigure.__segments.add(Segment);
		return pathFigure;
	}
	, 
	$type: new $.ig.Type('Numeric', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('LeastSquaresFit', 'Numeric', {

	test: function () {
		return $.ig.LeastSquaresFit.prototype.linearTest() && $.ig.LeastSquaresFit.prototype.logarithmicTest() && $.ig.LeastSquaresFit.prototype.exponentialTest() && $.ig.LeastSquaresFit.prototype.powerLawTest() && $.ig.LeastSquaresFit.prototype.quadraticTest() && $.ig.LeastSquaresFit.prototype.cubicTest() && $.ig.LeastSquaresFit.prototype.quarticTest() && $.ig.LeastSquaresFit.prototype.quinticTest();
	}
	, 
	init: function () {



		$.ig.Numeric.prototype.init.call(this);
	}

	, 
	linearFit: function (n, x, y) {
		var $self = this;
		var s0 = 0;
		var s1 = 0;
		var s2 = 0;
		var s3 = 0;
		var N = 0;
		for (var i = 0; i < n; ++i) {
			var xi = x(i);
			var yi = y(i);
			if (!$.ig.util.isNaN(xi) && !$.ig.util.isNaN(yi)) {
				s0 += yi;
				s1 += xi * xi;
				s2 += xi;
				s3 += xi * yi;
				++N;
			}

		}

		if (N < 2) {
			return null;
		}

		var A = (s0 * s1 - s2 * s3) / (N * s1 - s2 * s2);
		var B = (N * s3 - s2 * s0) / (N * s1 - s2 * s2);
		return (function () { var $ret = new Array();
		$ret.add(A);
		$ret.add(B);return $ret;}());
	}

	, 
	linearEvaluate: function (a, x) {
		if (a.length != 2) {
			return NaN;
		}

		return a[0] + a[1] * x;
	}

	, 
	linearTest: function () {
		var $self = this;
		var random = new $.ig.Random(0);
		var coeffs = new Array(2);
		for (var i = 0; i < coeffs.length; ++i) {
			coeffs[i] = 10 * random.nextDouble();
		}

		var x = new $.ig.List$1(Number, 0);
		var y = new $.ig.List$1(Number, 0);
		for (var i1 = -100; i1 < 100; ++i1) {
			var X = i1;
			var Y = $.ig.LeastSquaresFit.prototype.linearEvaluate(coeffs, X);
			if (!$.ig.util.isNaN(Y)) {
				x.add(X);
				y.add(Y);
			}

		}

		var fit = $.ig.LeastSquaresFit.prototype.linearFit(x.count(), function (i) {
				return x.__inner[i];
		}, function (i) {
				return y.__inner[i];
		});
		for (var i2 = 0; i2 < coeffs.length; ++i2) {
			if (Math.abs(coeffs[i2] - fit[i2]) > 0.0001) {
			}

		}

		return true;
	}

	, 
	logarithmicFit: function (n, x, y) {
		var $self = this;
		var s0 = 0;
		var s1 = 0;
		var s2 = 0;
		var s3 = 0;
		var N = 0;
		for (var i = 0; i < n; ++i) {
			var xi = x(i);
			var yi = y(i);
			if (!$.ig.util.isNaN(xi) && !$.ig.util.isNaN(yi) && xi > 0) {
				var lnxi = Math.log(xi);
				s0 += yi * lnxi;
				s1 += yi;
				s2 += lnxi;
				s3 += lnxi * lnxi;
				++N;
			}

		}

		if (N < 2) {
			return null;
		}

		var B = (N * s0 - s1 * s2) / (N * s3 - s2 * s2);
		var A = (s1 - B * s2) / N;
		return (function () { var $ret = new Array();
		$ret.add(A);
		$ret.add(B);return $ret;}());
	}

	, 
	logarithmicEvaluate: function (a, x) {
		if (a.length != 2 || x < 0 || Number.isInfinity(x) || $.ig.util.isNaN(x)) {
			return NaN;
		}

		return a[0] + a[1] * Math.log(x);
	}

	, 
	logarithmicTest: function () {
		var $self = this;
		var random = new $.ig.Random(0);
		var coeffs = new Array(2);
		for (var i = 0; i < coeffs.length; ++i) {
			coeffs[i] = 10 * random.nextDouble();
		}

		var x = new $.ig.List$1(Number, 0);
		var y = new $.ig.List$1(Number, 0);
		for (var i1 = 1; i1 < 100; ++i1) {
			var X = i1;
			var Y = $.ig.LeastSquaresFit.prototype.logarithmicEvaluate(coeffs, X);
			if (!$.ig.util.isNaN(Y)) {
				x.add(X);
				y.add(Y);
			}

		}

		var fit = $.ig.LeastSquaresFit.prototype.logarithmicFit(x.count(), function (i) {
				return x.__inner[i];
		}, function (i) {
				return y.__inner[i];
		});
		for (var i2 = 0; i2 < coeffs.length; ++i2) {
			if (Math.abs(coeffs[i2] - fit[i2]) > 0.0001) {
			}

		}

		return true;
	}

	, 
	exponentialFit: function (n, x, y) {
		var $self = this;
		var s0 = 0;
		var s1 = 0;
		var s2 = 0;
		var s3 = 0;
		var s4 = 0;
		var N = 0;
		for (var i = 0; i < n; ++i) {
			var xi = x(i);
			var yi = y(i);
			if (!$.ig.util.isNaN(xi) && !$.ig.util.isNaN(yi) && yi > 0) {
				var lnyi = Math.log(yi);
				s0 += xi * xi * yi;
				s1 += yi * lnyi;
				s2 += xi * yi;
				s3 += xi * yi * lnyi;
				s4 += yi;
				++N;
			}

		}

		if (N < 2) {
			return null;
		}

		var a = (s0 * s1 - s2 * s3) / (s4 * s0 - s2 * s2);
		var B = (s4 * s3 - s2 * s1) / (s4 * s0 - s2 * s2);
		return (function () { var $ret = new Array();
		$ret.add(Math.exp(a));
		$ret.add(B);return $ret;}());
	}

	, 
	exponentialEvaluate: function (a, x) {
		if (a.length != 2 || x < 0 || Number.isInfinity(x) || $.ig.util.isNaN(x)) {
			return NaN;
		}

		return a[0] * Math.exp(a[1] * x);
	}

	, 
	exponentialTest: function () {
		var $self = this;
		var random = new $.ig.Random(0);
		var coeffs = new Array(2);
		for (var i = 0; i < coeffs.length; ++i) {
			coeffs[i] = 2 * random.nextDouble();
		}

		var x = new $.ig.List$1(Number, 0);
		var y = new $.ig.List$1(Number, 0);
		for (var i1 = 1; i1 < 100; ++i1) {
			var X = i1;
			var Y = $.ig.LeastSquaresFit.prototype.exponentialEvaluate(coeffs, X);
			if (!$.ig.util.isNaN(Y)) {
				x.add(X);
				y.add(Y);
			}

		}

		var fit = $.ig.LeastSquaresFit.prototype.exponentialFit(x.count(), function (i) {
				return x.__inner[i];
		}, function (i) {
				return y.__inner[i];
		});
		for (var i2 = 0; i2 < coeffs.length; ++i2) {
			if (Math.abs(coeffs[i2] - fit[i2]) > 0.0001) {
				return false;
			}

		}

		return true;
	}

	, 
	powerLawFit: function (n, x, y) {
		var $self = this;
		var s0 = 0;
		var s1 = 0;
		var s2 = 0;
		var s3 = 0;
		var N = 0;
		for (var i = 0; i < n; ++i) {
			var xi = x(i);
			var yi = y(i);
			if (!$.ig.util.isNaN(xi) && !$.ig.util.isNaN(yi) && xi > 0 && yi > 0) {
				var lnxi = Math.log(x(i));
				var lnyi = Math.log(y(i));
				s0 += lnxi * lnyi;
				s1 += lnxi;
				s2 += lnyi;
				s3 += lnxi * lnxi;
				++N;
			}

		}

		if (N < 2) {
			return null;
		}

		var B = (N * s0 - s1 * s2) / (N * s3 - s1 * s1);
		var A = Math.exp((s2 - B * s1) / N);
		return (function () { var $ret = new Array();
		$ret.add(A);
		$ret.add(B);return $ret;}());
	}

	, 
	powerLawEvaluate: function (a, x) {
		if (a.length != 2 || x < 0 || Number.isInfinity(x) || $.ig.util.isNaN(x)) {
			return NaN;
		}

		return a[0] * Math.pow(x, a[1]);
	}

	, 
	powerLawTest: function () {
		var $self = this;
		var random = new $.ig.Random(0);
		var coeffs = new Array(2);
		for (var i = 0; i < coeffs.length; ++i) {
			coeffs[i] = 10 * random.nextDouble();
		}

		var x = new $.ig.List$1(Number, 0);
		var y = new $.ig.List$1(Number, 0);
		for (var i1 = -100; i1 < 100; ++i1) {
			x.add(i1);
			y.add($.ig.LeastSquaresFit.prototype.powerLawEvaluate(coeffs, i1));
		}

		var fit = $.ig.LeastSquaresFit.prototype.powerLawFit(x.count(), function (i) {
				return x.__inner[i];
		}, function (i) {
				return y.__inner[i];
		});
		for (var i2 = 0; i2 < coeffs.length; ++i2) {
			if (Math.abs(coeffs[i2] - fit[i2]) > 0.0001) {
				return false;
			}

		}

		return true;
	}

	, 
	quadraticFit: function (n, x, y) {
		return $.ig.LeastSquaresFit.prototype.polynomialFit(n, 2, x, y);
	}

	, 
	quadraticEvaluate: function (a, x) {
		return $.ig.LeastSquaresFit.prototype.polynomialEvaluate(a, x);
	}

	, 
	quadraticTest: function () {
		return $.ig.LeastSquaresFit.prototype.polynomialTest(2);
	}

	, 
	cubicFit: function (n, x, y) {
		return $.ig.LeastSquaresFit.prototype.polynomialFit(n, 3, x, y);
	}

	, 
	cubicEvaluate: function (a, x) {
		return $.ig.LeastSquaresFit.prototype.polynomialEvaluate(a, x);
	}

	, 
	cubicTest: function () {
		return $.ig.LeastSquaresFit.prototype.polynomialTest(3);
	}

	, 
	quarticFit: function (n, x, y) {
		return $.ig.LeastSquaresFit.prototype.polynomialFit(n, 4, x, y);
	}

	, 
	quarticEvaluate: function (a, x) {
		return $.ig.LeastSquaresFit.prototype.polynomialEvaluate(a, x);
	}

	, 
	quarticTest: function () {
		return $.ig.LeastSquaresFit.prototype.polynomialTest(4);
	}

	, 
	quinticFit: function (n, x, y) {
		return $.ig.LeastSquaresFit.prototype.polynomialFit(n, 5, x, y);
	}

	, 
	quinticEvaluate: function (a, x) {
		return $.ig.LeastSquaresFit.prototype.polynomialEvaluate(a, x);
	}

	, 
	quinticTest: function () {
		return $.ig.LeastSquaresFit.prototype.polynomialTest(5);
	}

	, 
	polynomialFit: function (n, k, x, y) {
		var ps = new Array(1 + 2 * k);
		for (var ind1 = 0; ind1 < ps.length; ind1++) {
			ps[ind1] = 0;
		}

		var A = (function () { var $ret = new Array($firstRank = k + 1); var $currRet = $ret; for (var $rankInit = 0; $rankInit < $firstRank; $rankInit++) { $currRet[$rankInit] = new Array(k + 1); };return $ret;}());
		var B = new Array(k + 1);
		for (var ind2 = 0; ind2 < B.length; ind2++) {
			B[ind2] = 0;
		}

		var N = 0;
		for (var i = 0; i < n; ++i) {
			var s = 1;
			var xi = x(i);
			if (!$.ig.util.isNaN(xi) && !$.ig.util.isNaN(y(i))) {
				for (var p = 0; p < ps.length; ++p) {
					ps[p] += s;
					s *= xi;
					++N;
				}

			}

		}

		if (N < k) {
			return null;
		}

		for (var i1 = 0; i1 <= k; ++i1) {
			for (var j = 0; j <= k; ++j) {
				A[i1][j] = ps[i1 + j];
			}

		}

		for (var i2 = 0; i2 < n; ++i2) {
			var xi1 = x(i2);
			var yi = y(i2);
			if (!$.ig.util.isNaN(xi1) && !$.ig.util.isNaN(yi)) {
				for (var j1 = 0; j1 <= k; ++j1) {
					B[j1] += (Math.pow(xi1, j1) * yi);
				}

			}

		}

		return $.ig.Numeric.prototype.solve(A, B) ? B : null;
	}

	, 
	polynomialEvaluate: function (a, x) {
		if (a.length < 1 || Number.isInfinity(x) || $.ig.util.isNaN(x)) {
			return NaN;
		}

		var y = 0;
		for (var i = 0; i < a.length; ++i) {
			y += a[i] * Math.pow(x, i);
		}

		return y;
	}

	, 
	polynomialTest: function (k) {
		var $self = this;
		var random = new $.ig.Random(0);
		var coeffs = new Array(k + 1);
		for (var i = 0; i < coeffs.length; ++i) {
			coeffs[i] = 2 * random.nextDouble();
		}

		var x = new $.ig.List$1(Number, 0);
		var y = new $.ig.List$1(Number, 0);
		for (var i1 = -100; i1 < 100; ++i1) {
			var X = i1;
			var Y = $.ig.LeastSquaresFit.prototype.polynomialEvaluate(coeffs, X);
			if (!$.ig.util.isNaN(Y)) {
				x.add(X);
				y.add(Y);
			}

		}

		var fit = $.ig.LeastSquaresFit.prototype.polynomialFit(x.count(), k, function (i) {
				return x.__inner[i];
		}, function (i) {
				return y.__inner[i];
		});
		for (var i2 = 0; i2 < k; ++i2) {
			if (Math.abs(coeffs[i2] - fit[i2]) > 0.0001) {
				return false;
			}

		}

		return true;
	}
	, 
	$type: new $.ig.Type('LeastSquaresFit', $.ig.Numeric.prototype.$type)
}, true);











$.ig.UnknownValuePlotting.prototype.linearInterpolate = 0;
$.ig.UnknownValuePlotting.prototype.dontPlot = 1;


$.ig.TrendLineType.prototype.none = 0;
$.ig.TrendLineType.prototype.linearFit = 1;
$.ig.TrendLineType.prototype.quadraticFit = 2;
$.ig.TrendLineType.prototype.cubicFit = 3;
$.ig.TrendLineType.prototype.quarticFit = 4;
$.ig.TrendLineType.prototype.quinticFit = 5;
$.ig.TrendLineType.prototype.logarithmicFit = 6;
$.ig.TrendLineType.prototype.exponentialFit = 7;
$.ig.TrendLineType.prototype.powerLawFit = 8;
$.ig.TrendLineType.prototype.simpleAverage = 9;
$.ig.TrendLineType.prototype.exponentialAverage = 10;
$.ig.TrendLineType.prototype.modifiedAverage = 11;
$.ig.TrendLineType.prototype.cumulativeAverage = 12;
$.ig.TrendLineType.prototype.weightedAverage = 13;























} (jQuery));



// Declare empty types
$.ig = $.ig || {};
(function ($) {
var $$t = {}
$.ig.$currDefinitions = $$t;
$.ig.util.bulkDefine(["Enum:b", 
"ValueType:c", 
"Object:d", 
"Type:e", 
"Boolean:f", 
"IConvertible:g", 
"IFormatProvider:h", 
"Number:i", 
"String:j", 
"IComparable:k", 
"Number:l", 
"Number:m", 
"Number:n", 
"Number:o", 
"NumberStyles:p", 
"Number:q", 
"Void:r", 
"String:s", 
"StringComparison:t", 
"Array:u", 
"IList:v", 
"ICollection:w", 
"IEnumerable:x", 
"IEnumerator:y", 
"RegExp:z", 
"CultureInfo:aa", 
"Calendar:ab", 
"Date:ac", 
"DayOfWeek:ad", 
"DateTimeKind:ae", 
"Date:af", 
"Error:ag", 
"CompareInfo:ah", 
"CompareOptions:ai", 
"NumberFormatInfo:aj", 
"DateTimeFormatInfo:ak", 
"CalendarWeekRule:al", 
"IEnumerable$1:am", 
"IEnumerator$1:an", 
"IDisposable:ao", 
"StringSplitOptions:ap", 
"Number:aq", 
"Number:ar", 
"Number:as", 
"Number:at", 
"Number:au", 
"Number:av", 
"Assembly:aw", 
"Stream:ax", 
"SeekOrigin:ay", 
"RuntimeTypeHandle:az", 
"MethodInfo:a0", 
"MethodBase:a1", 
"MemberInfo:a2", 
"ParameterInfo:a3", 
"TypeCode:a4", 
"ConstructorInfo:a5", 
"PropertyInfo:a6", 
"SeriesViewer:a7", 
"Control:a8", 
"FrameworkElement:a9", 
"UIElement:ba", 
"DependencyObject:bb", 
"Dictionary:bc", 
"DependencyProperty:bd", 
"PropertyMetadata:be", 
"PropertyChangedCallback:bf", 
"MulticastDelegate:bg", 
"IntPtr:bh", 
"DependencyPropertyChangedEventArgs:bi", 
"UnsetValue:bj", 
"DependencyPropertiesCollection:bk", 
"Script:bl", 
"Binding:bm", 
"PropertyPath:bn", 
"Transform:bo", 
"Visibility:bp", 
"Style:bq", 
"Thickness:br", 
"HorizontalAlignment:bs", 
"VerticalAlignment:bt", 
"INotifyPropertyChanged:bu", 
"PropertyChangedEventHandler:bv", 
"PropertyChangedEventArgs:bw", 
"SeriesViewerView:bx", 
"ISchedulableRender:by", 
"CanvasRenderScheduler:bz", 
"List$1:b0", 
"IList$1:b1", 
"ICollection$1:b2", 
"IArray:b3", 
"Enumerable:b4", 
"Func$2:b5", 
"Func$3:b6", 
"IOrderedEnumerable$1:b7", 
"SortedList$1:b8", 
"Math:b9", 
"ArgumentNullException:ca", 
"NotImplementedException:cb", 
"IArrayList:cc", 
"Array:cd", 
"CompareCallback:ce", 
"Action$1:cf", 
"Comparer$1:cg", 
"IComparer:ch", 
"IComparer$1:ci", 
"DefaultComparer$1:cj", 
"IComparable$1:ck", 
"Comparison$1:cl", 
"ReadOnlyCollection$1:cm", 
"Predicate$1:cn", 
"Callback:co", 
"window:cp", 
"RenderingContext:cq", 
"IRenderer:cr", 
"Rectangle:cs", 
"Shape:ct", 
"Brush:cu", 
"Color:cv", 
"ArgumentException:cw", 
"Nullable$1:cx", 
"DoubleCollection:cy", 
"Rect:cz", 
"Size:c0", 
"Point:c1", 
"Path:c2", 
"Geometry:c3", 
"GeometryType:c4", 
"TextBlock:c5", 
"Polygon:c6", 
"PointCollection:c7", 
"Polyline:c8", 
"DataTemplateRenderInfo:c9", 
"DataTemplatePassInfo:da", 
"ContentControl:db", 
"DataTemplate:dc", 
"DataTemplateRenderHandler:dd", 
"DataTemplateMeasureHandler:de", 
"DataTemplateMeasureInfo:df", 
"DataTemplatePassHandler:dg", 
"Line:dh", 
"XamOverviewPlusDetailPane:di", 
"XamOverviewPlusDetailPaneView:dj", 
"XamOverviewPlusDetailPaneViewManager:dk", 
"JQueryObject:dl", 
"Element:dm", 
"ElementAttributeCollection:dn", 
"ElementCollection:dp", 
"WebStyle:dq", 
"ElementNodeType:dr", 
"Document:ds", 
"EventListener:dt", 
"IElementEventHandler:du", 
"ElementEventHandler:dv", 
"ElementAttribute:dw", 
"JQueryPosition:dx", 
"JQueryCallback:dy", 
"JQueryEvent:dz", 
"JQueryUICallback:d0", 
"EventProxy:d1", 
"ModifierKeys:d2", 
"MouseWheelHandler:d3", 
"Delegate:d4", 
"Interlocked:d5", 
"GestureHandler:d6", 
"ContactHandler:d7", 
"TouchHandler:d8", 
"MouseOverHandler:d9", 
"MouseHandler:ea", 
"KeyHandler:eb", 
"Key:ec", 
"JQuery:ed", 
"JQueryDeferred:ee", 
"JQueryPromise:ef", 
"Action:eg", 
"CanvasViewRenderer:eh", 
"CanvasContext2D:ei", 
"CanvasContext:ej", 
"TextMetrics:ek", 
"ImageData:el", 
"CanvasElement:em", 
"Gradient:en", 
"LinearGradientBrush:eo", 
"GradientStop:ep", 
"GeometryGroup:eq", 
"GeometryCollection:er", 
"FillRule:es", 
"PathGeometry:et", 
"PathFigureCollection:eu", 
"LineGeometry:ev", 
"RectangleGeometry:ew", 
"EllipseGeometry:ex", 
"ArcSegment:ey", 
"PathSegment:ez", 
"PathSegmentType:e0", 
"SweepDirection:e1", 
"PathFigure:e2", 
"PathSegmentCollection:e3", 
"LineSegment:e4", 
"PolyLineSegment:e5", 
"BezierSegment:e6", 
"PolyBezierSegment:e7", 
"GeometryUtil:e8", 
"Tuple$2:e9", 
"TransformGroup:fa", 
"TransformCollection:fb", 
"TranslateTransform:fc", 
"RotateTransform:fd", 
"ScaleTransform:fe", 
"DivElement:ff", 
"DOMEventProxy:fg", 
"MSGesture:fh", 
"MouseEventArgs:fi", 
"EventArgs:fj", 
"DoubleAnimator:fk", 
"EasingFunctionHandler:fl", 
"ImageElement:fm", 
"RectUtil:fn", 
"MathUtil:fo", 
"RuntimeHelpers:fp", 
"RuntimeFieldHandle:fq", 
"PropertyChangedEventArgs$1:fr", 
"InteractionState:fs", 
"OverviewPlusDetailPaneMode:ft", 
"IOverviewPlusDetailControl:fu", 
"EventHandler$1:fv", 
"OverviewPlusDetailViewportHost:fw", 
"IProvidesViewport:fx", 
"SeriesCollection:fy", 
"ObservableCollection$1:fz", 
"INotifyCollectionChanged:f0", 
"NotifyCollectionChangedEventHandler:f1", 
"NotifyCollectionChangedEventArgs:f2", 
"NotifyCollectionChangedAction:f3", 
"AxisCollection:f4", 
"SeriesViewerViewManager:f5", 
"AxisTitlePosition:f6", 
"PointerTooltipStyle:f7", 
"Dictionary$2:f8", 
"IDictionary$2:f9", 
"IDictionary:ga", 
"IEqualityComparer$1:gb", 
"EqualityComparer$1:gc", 
"IEqualityComparer:gd", 
"DefaultEqualityComparer$1:ge", 
"InvalidOperationException:gf", 
"KeyValuePair$2:gg", 
"BrushCollection:gh", 
"InterpolationMode:gi", 
"Random:gj", 
"ColorUtil:gk", 
"CssHelper:gl", 
"CssGradientUtil:gm", 
"FontUtil:gn", 
"FontInfo:go", 
"TileZoomTile:gp", 
"TileZoomTileInfo:gq", 
"TileZoomTileCache:gr", 
"TileZoomManager:gs", 
"RectChangedEventHandler:gt", 
"RectChangedEventArgs:gu", 
"Debug:gv", 
"TileZoomInfo:gw", 
"LinkedList$1:gx", 
"LinkedListNode$1:gy", 
"RenderSurface:gz", 
"Series:g0", 
"SeriesView:g1", 
"XamDataChart:g2", 
"GridMode:g3", 
"XamDataChartView:g4", 
"FragmentBase:g5", 
"HorizontalAnchoredCategorySeries:g6", 
"AnchoredCategorySeries:g7", 
"CategorySeries:g8", 
"MarkerSeries:g9", 
"MarkerSeriesView:ha", 
"Marker:hb", 
"DataContext:hc", 
"MarkerTemplates:hd", 
"HashPool$2:he", 
"IHashPool$2:hf", 
"IPool$1:hg", 
"Func$1:hh", 
"Pool$1:hi", 
"IIndexedPool$1:hj", 
"MarkerType:hk", 
"SeriesVisualData:hl", 
"PrimitiveVisualDataList:hm", 
"IVisualData:hn", 
"PrimitiveVisualData:ho", 
"PrimitiveAppearanceData:hp", 
"BrushAppearanceData:hq", 
"StringBuilder:hr", 
"Environment:hs", 
"AppearanceHelper:ht", 
"LinearGradientBrushAppearanceData:hu", 
"GradientStopAppearanceData:hv", 
"SolidBrushAppearanceData:hw", 
"EllipseGeometryData:hx", 
"GeometryData:hy", 
"GetPointsSettings:hz", 
"RectangleGeometryData:h0", 
"LineGeometryData:h1", 
"PathGeometryData:h2", 
"PathFigureData:h3", 
"LineSegmentData:h4", 
"SegmentData:h5", 
"PolylineSegmentData:h6", 
"ArcSegmentData:h7", 
"PolyBezierSegmentData:h8", 
"LabelAppearanceData:h9", 
"ShapeTags:ia", 
"PointerTooltipVisualDataList:ib", 
"MarkerVisualDataList:ic", 
"MarkerVisualData:id", 
"PointerTooltipVisualData:ie", 
"RectangleVisualData:ig", 
"PolygonVisualData:ih", 
"PolyLineVisualData:ii", 
"IHasCategoryModePreference:ij", 
"IHasCategoryAxis:ik", 
"CategoryAxisBase:il", 
"Axis:im", 
"AxisView:io", 
"AxisLabelPanelBase:ip", 
"Panel:iq", 
"UIElementCollection:ir", 
"AxisLabelPanelBaseView:is", 
"AxisLabelSettings:it", 
"AxisLabelsLocation:iu", 
"PropertyUpdatedEventHandler:iv", 
"PropertyUpdatedEventArgs:iw", 
"PathRenderingInfo:ix", 
"NumericAxisBase:iy", 
"NumericAxisBaseView:iz", 
"NumericAxisRenderer:i0", 
"AxisRendererBase:i1", 
"ShouldRenderHandler:i2", 
"ScaleValueHandler:i3", 
"AxisRenderingParametersBase:i4", 
"RangeInfo:i5", 
"TickmarkValues:i6", 
"TickmarkValuesInitializationParameters:i7", 
"CategoryMode:i8", 
"Func$4:i9", 
"GetGroupCenterHandler:ja", 
"GetUnscaledGroupCenterHandler:jb", 
"RenderStripHandler:jc", 
"RenderLineHandler:jd", 
"ShouldRenderLinesHandler:je", 
"ShouldRenderContentHandler:jf", 
"RenderAxisLineHandler:jg", 
"DetermineCrossingValueHandler:jh", 
"ShouldRenderLabelHandler:ji", 
"GetLabelLocationHandler:jj", 
"LabelPosition:jk", 
"TransformToLabelValueHandler:jl", 
"AxisLabelManager:jm", 
"GetLabelForItemHandler:jn", 
"CreateRenderingParamsHandler:jo", 
"SnapMajorValueHandler:jp", 
"AdjustMajorValueHandler:jq", 
"CategoryAxisRenderingParameters:jr", 
"LogarithmicTickmarkValues:js", 
"LogarithmicNumericSnapper:jt", 
"Snapper:ju", 
"LinearTickmarkValues:jv", 
"LinearNumericSnapper:jw", 
"AxisRangeChangedEventArgs:jx", 
"AxisRange:jy", 
"IEquatable$1:jz", 
"AutoRangeCalculator:j0", 
"NumericYAxis:j1", 
"StraightNumericAxisBase:j2", 
"StraightNumericAxisBaseView:j3", 
"NumericScaler:j4", 
"ScalerParams:j5", 
"NumericScaleMode:j6", 
"LogarithmicScaler:j7", 
"IScaler:j8", 
"AxisOrientation:j9", 
"NumericYAxisView:ka", 
"VerticalAxisLabelPanel:kb", 
"VerticalAxisLabelPanelView:kc", 
"TitleSettings:kd", 
"NumericAxisRenderingParameters:ke", 
"VerticalLogarithmicScaler:kf", 
"VerticalLinearScaler:kg", 
"LinearScaler:kh", 
"NumericRadiusAxis:ki", 
"NumericRadiusAxisView:kj", 
"PolarAxisRenderingManager:kk", 
"ViewportUtils:kl", 
"PolarAxisRenderingParameters:km", 
"IPolarRadialRenderingParameters:kn", 
"RadialAxisRenderingParameters:ko", 
"RadialAxisLabelPanel:kp", 
"HorizontalAxisLabelPanelBase:kq", 
"HorizontalAxisLabelPanelBaseView:kr", 
"RadialAxisLabelPanelView:ks", 
"NumericAngleAxis:kt", 
"IAngleScaler:ku", 
"NumericAngleAxisView:kv", 
"AngleAxisLabelPanel:kw", 
"AngleAxisLabelPanelView:kx", 
"Extensions:ky", 
"CategoryAngleAxis:kz", 
"CategoryAngleAxisView:k0", 
"CategoryAxisBaseView:k1", 
"CategoryAxisRenderer:k2", 
"LinearCategorySnapper:k3", 
"IFastItemsSource:k4", 
"IFastItemColumn$1:k5", 
"IFastItemColumnPropertyName:k6", 
"CategoryTickmarkValues:k7", 
"AxisComponentsForView:k8", 
"AxisComponentsFromView:k9", 
"AxisFormatLabelHandler:la", 
"VisualExportHelper:lb", 
"Canvas:lc", 
"IFastItemsSourceProvider:ld", 
"AxisExtentType:le", 
"ContentInfo:lf", 
"SmartAxisLabelPanel:lg", 
"SmartAxisLabelPanelView:lh", 
"AxisRangeChangedEventHandler:li", 
"ChartContentManager:lj", 
"ChartContentType:lk", 
"SplineFragmentBase:ll", 
"SplineSeriesBase:lm", 
"SplineSeriesBaseView:ln", 
"AnchoredCategorySeriesView:lo", 
"CategorySeriesView:lp", 
"ISupportsMarkers:lq", 
"CategoryBucketCalculator:lr", 
"IBucketizer:ls", 
"ISortingAxis:lt", 
"CategoryFrame:lu", 
"Frame:lv", 
"BrushUtil:lw", 
"CategoryTrendLineManagerBase:lx", 
"TrendLineManagerBase$1:ly", 
"TrendLineType:lz", 
"Clipper:l0", 
"EdgeClipper:l1", 
"LeftClipper:l2", 
"BottomClipper:l3", 
"RightClipper:l4", 
"TopClipper:l5", 
"TrendResolutionParams:l6", 
"Flattener:l7", 
"Stack$1:l8", 
"ReverseArrayEnumerator$1:l9", 
"SpiralTodo:ma", 
"FastItemsSourceEventAction:mb", 
"IPreparesCategoryTrendline:mc", 
"SortingTrendLineManager:md", 
"TrendFitCalculator:me", 
"LeastSquaresFit:mf", 
"Numeric:mg", 
"TrendAverageCalculator:mh", 
"CategoryTrendLineManager:mi", 
"AnchoredCategoryBucketCalculator:mj", 
"CategoryDateTimeXAxis:mk", 
"CategoryDateTimeXAxisView:ml", 
"TimeAxisDisplayType:mm", 
"FastItemDateTimeColumn:mn", 
"IFastItemColumnInternal:mo", 
"FastItemColumn:mp", 
"FastReflectionHelper:mq", 
"HorizontalAxisLabelPanel:mr", 
"CoercionInfo:ms", 
"FastItemsSourceEventArgs:mt", 
"SortedListView$1:mu", 
"ArrayUtil:mv", 
"SplineType:mw", 
"CollisionAvoider:mx", 
"IDetectsCollisions:my", 
"SafeSortedReadOnlyDoubleCollection:mz", 
"SafeReadOnlyDoubleCollection:m0", 
"SafeEnumerable:m1", 
"StackedFragmentSeries:m2", 
"PenLineCap:m3", 
"StackedSeriesBase:m4", 
"IIsCategoryBased:m5", 
"ICategoryScaler:m6", 
"StackedSeriesView:m7", 
"StackedBucketCalculator:m8", 
"StackedSeriesManager:m9", 
"StackedSeriesCollection:na", 
"StackedLineSeries:nb", 
"HorizontalStackedSeriesBase:nc", 
"CategoryFramePreparerBase:nd", 
"FramePreparer:ne", 
"ISupportsErrorBars:nf", 
"DefaultSupportsMarkers:ng", 
"DefaultProvidesViewport:nh", 
"DefaultSupportsErrorBars:ni", 
"PreparationParams:nj", 
"CategoryYAxis:nk", 
"CategoryYAxisView:nl", 
"SyncSettings:nm", 
"NumericXAxis:nn", 
"NumericXAxisView:no", 
"HorizontalLogarithmicScaler:np", 
"HorizontalLinearScaler:nq", 
"ValuesHolder:nr", 
"LineSeries:ns", 
"LineSeriesView:nt", 
"UnknownValuePlotting:nu", 
"CategoryLineRasterizer:nv", 
"Action$5:nw", 
"PathVisualData:nx", 
"CategorySeriesRenderManager:ny", 
"AssigningCategoryStyleEventArgs:nz", 
"AssigningCategoryStyleEventArgsBase:n0", 
"GetCategoryItemsHandler:n1", 
"HighlightingInfo:n2", 
"HighlightingState:n3", 
"AssigningCategoryMarkerStyleEventArgs:n4", 
"HighlightingManager:n5", 
"AreaSeries:n6", 
"AreaSeriesView:n7", 
"LegendTemplates:n8", 
"PieChartBase:n9", 
"PieChartBaseView:oa", 
"PieChartViewManager:ob", 
"PieChartVisualData:oc", 
"PieSliceVisualDataList:od", 
"PieSliceVisualData:oe", 
"PieSliceDataContext:of", 
"Slice:og", 
"SliceView:oh", 
"PieLabel:oi", 
"MouseButtonEventArgs:oj", 
"FastItemsSource:ok", 
"ColumnReference:ol", 
"FastItemObjectColumn:om", 
"FastItemIntColumn:on", 
"LabelsPosition:oo", 
"LeaderLineType:op", 
"OthersCategoryType:oq", 
"IndexCollection:or", 
"LegendBase:os", 
"LegendBaseView:ot", 
"LegendBaseViewManager:ou", 
"GradientData:ov", 
"GradientStopData:ow", 
"DataChartLegendMouseButtonEventArgs:ox", 
"DataChartMouseButtonEventArgs:oy", 
"ChartLegendMouseEventArgs:oz", 
"ChartMouseEventArgs:o0", 
"DataChartLegendMouseButtonEventHandler:o1", 
"DataChartLegendMouseEventHandler:o2", 
"PieChartFormatLabelHandler:o3", 
"SliceClickEventHandler:o4", 
"SliceClickEventArgs:o5", 
"ItemLegend:o6", 
"ItemLegendView:o7", 
"LegendItemInfo:o8", 
"BubbleSeries:o9", 
"ScatterBase:pa", 
"ScatterBaseView:pb", 
"MarkerManagerBase:pc", 
"MarkerManagerBucket:pd", 
"ScatterTrendLineManager:pe", 
"NumericMarkerManager:pf", 
"OwnedPoint:pg", 
"CollisionAvoidanceType:ph", 
"SmartPlacer:pi", 
"ISmartPlaceable:pj", 
"SmartPosition:pk", 
"SmartPlaceableWrapper$1:pl", 
"ScatterAxisInfoCache:pm", 
"ScatterErrorBarSettings:pn", 
"ErrorBarSettingsBase:po", 
"EnableErrorBars:pp", 
"ErrorBarCalculatorReference:pq", 
"IErrorBarCalculator:pr", 
"ErrorBarCalculatorType:ps", 
"ScatterFrame:pt", 
"ScatterFrameBase$1:pu", 
"DictInterpolator$3:pv", 
"Action$6:pw", 
"SyncLink:px", 
"ChartCollection:py", 
"FastItemsSourceReference:pz", 
"SyncManager:p0", 
"SyncLinkManager:p1", 
"ErrorBarsHelper:p2", 
"BubbleSeriesView:p3", 
"BubbleMarkerManager:p4", 
"SizeScale:p5", 
"BrushScale:p6", 
"ScaleLegend:p7", 
"ScaleLegendView:p8", 
"CustomPaletteBrushScale:p9", 
"BrushSelectionMode:qa", 
"ValueBrushScale:qb", 
"RingSeriesBase:qc", 
"XamDoughnutChart:qd", 
"RingCollection:qe", 
"Ring:qf", 
"RingControl:qg", 
"RingControlView:qh", 
"Arc:qi", 
"ArcView:qj", 
"ArcItem:qk", 
"SliceItem:ql", 
"Legend:qm", 
"LegendView:qn", 
"BarSeries:qo", 
"VerticalAnchoredCategorySeries:qp", 
"IBarSeries:qq", 
"BarSeriesView:qr", 
"BarTrendLineManager:qs", 
"BarTrendFitCalculator:qt", 
"BarBucketCalculator:qu", 
"CategoryTransitionInMode:qv", 
"BarFramePreparer:qw", 
"CategoryFramePreparer:qx", 
"IHasCategoryTrendline:qy", 
"IHasTrendline:qz", 
"IHasSingleValueCategory:q0", 
"DefaultCategoryTrendlineHost:q1", 
"DefaultCategoryTrendlinePreparer:q2", 
"DefaultSingleValueProvider:q3", 
"SingleValuesHolder:q4", 
"RingSeriesBaseView:q5", 
"RingSeriesCollection:q6", 
"SliceCollection:q7", 
"XamDoughnutChartView:q8", 
"Action$2:q9", 
"DoughnutChartVisualData:ra", 
"RingSeriesVisualDataList:rb", 
"RingSeriesVisualData:rc", 
"RingVisualDataList:rd", 
"RingVisualData:re", 
"ArcVisualDataList:rf", 
"ArcVisualData:rg", 
"SliceVisualDataList:rh", 
"SliceVisualData:ri", 
"DoughnutChartLabelVisualData:rj", 
"HoleDimensionsChangedEventHandler:rk", 
"HoleDimensionsChangedEventArgs:rl", 
"FunnelSliceDataContext:rm", 
"XamFunnelChart:rn", 
"IItemProvider:ro", 
"Array:rv", 
"XamFunnelConnector:rw", 
"XamFunnelController:rx", 
"SliceInfoList:ry", 
"SliceInfoUnaryComparison:rz", 
"SliceInfo:r0", 
"SliceAppearance:r1", 
"PointList:r2", 
"FunnelSliceVisualData:r3", 
"Bezier:r4", 
"Array:r5", 
"BezierPoint:r6", 
"BezierOp:r7", 
"BezierPointComparison:r8", 
"DoubleColumn:r9", 
"ObjectColumn:sa", 
"XamFunnelView:sb", 
"IOuterLabelWidthDecider:sc", 
"IFunnelLabelSizeDecider:sd", 
"MouseButtonMessage:sh", 
"MouseButtonAction:si", 
"MouseButtonType:sj", 
"SetAreaSizeMessage:sk", 
"RenderSliceMessage:sm", 
"RenderOuterLabelMessage:sn", 
"TooltipValueChangedMessage:so", 
"TooltipUpdateMessage:sp", 
"FunnelDataContext:sq", 
"ClearTooltipMessage:su", 
"ViewPropertyChangedMessage:sx", 
"OuterLabelAlignment:sy", 
"FunnelSliceDisplay:sz", 
"SliceSelectionManager:s0", 
"DataUpdatedMessage:s1", 
"ItemsSourceAction:s2", 
"DictionaryEntry:s3", 
"FunnelFrame:s4", 
"UserSelectedItemsChangedMessage:s5", 
"LabelSizeChangedMessage:s6", 
"FrameRenderCompleteMessage:s7", 
"IntColumn:s8", 
"IntColumnComparison:s9", 
"Convert:ta", 
"SelectedItemsChangedMessage:tb", 
"ModelUpdateMessage:tc", 
"SliceClickedMessage:td", 
"FunnelSliceClickedEventHandler:te", 
"FunnelSliceClickedEventArgs:tf", 
"FunnelChartVisualData:tg", 
"FunnelSliceVisualDataList:th", 
"RingSeries:ti", 
"WaterfallSeries:tj", 
"WaterfallSeriesView:tk", 
"FinancialSeries:tl", 
"FinancialSeriesView:tm", 
"FinancialBucketCalculator:tn", 
"CategoryTransitionSourceFramePreparer:to", 
"TransitionInSpeedType:tp", 
"AssigningCategoryStyleEventHandler:tq", 
"FinancialValueList:tr", 
"FinancialEventHandler:ts", 
"FinancialEventArgs:tt", 
"FinancialCalculationDataSource:tu", 
"CalculatedColumn:tv", 
"FinancialCalculationSupportingCalculations:tw", 
"ColumnSupportingCalculation:tx", 
"SupportingCalculation$1:ty", 
"SupportingCalculationStrategy:tz", 
"DataSourceSupportingCalculation:t0", 
"ProvideColumnValuesStrategy:t1", 
"StepLineSeries:t2", 
"StepLineSeriesView:t3", 
"StepAreaSeries:t4", 
"StepAreaSeriesView:t5", 
"RangeAreaSeries:t6", 
"HorizontalRangeCategorySeries:t7", 
"RangeCategorySeries:t8", 
"IHasHighLowValueCategory:t9", 
"RangeCategorySeriesView:ua", 
"RangeCategoryBucketCalculator:ub", 
"RangeCategoryFramePreparer:uc", 
"DefaultHighLowValueProvider:ud", 
"HighLowValuesHolder:ue", 
"CategoryMarkerManager:uf", 
"RangeValueList:ug", 
"RangeAreaSeriesView:uh", 
"LineFragment:ui", 
"LineFragmentView:uj", 
"LineFragmentBucketCalculator:uk", 
"IStacked100Series:ul", 
"AreaFragment:um", 
"AreaFragmentView:un", 
"AreaFragmentBucketCalculator:uo", 
"StackedColumnSeries:up", 
"StackedColumnSeriesView:uq", 
"StackedColumnBucketCalculator:ur", 
"ColumnFragment:us", 
"ColumnFragmentView:ut", 
"StackedBarSeries:uu", 
"VerticalStackedSeriesBase:uv", 
"StackedBarSeriesView:uw", 
"StackedBarBucketCalculator:ux", 
"BarFragment:uy", 
"StackedAreaSeries:uz", 
"StackedSplineSeries:u0", 
"SplineFragment:u1", 
"SplineFragmentView:u2", 
"SplineFragmentBucketCalculator:u3", 
"StackedSplineAreaSeries:u4", 
"SplineAreaFragment:u5", 
"SplineAreaFragmentView:u6", 
"StackedSeriesFramePreparer:u7", 
"StackedSeriesCreatedEventHandler:u8", 
"StackedSeriesCreatedEventArgs:u9", 
"StackedSeriesVisualData:va", 
"SeriesVisualDataList:vb", 
"RenderRequestedEventArgs:vc", 
"ChartTitleVisualData:vd", 
"VisualDataSerializer:ve", 
"AxisVisualData:vf", 
"AxisLabelVisualDataList:vg", 
"AxisLabelVisualData:vh", 
"AssigningCategoryMarkerStyleEventHandler:vi", 
"SeriesComponentsForView:vj", 
"DataChartAxisRangeChangedEventHandler:vk", 
"ChartAxisRangeChangedEventArgs:vl", 
"ChartVisualData:vm", 
"AxisVisualDataList:vn", 
"RadialBase:vo", 
"RadialBaseView:vp", 
"RadialBucketCalculator:vq", 
"SeriesRenderer$2:vr", 
"SeriesRenderingArguments:vs", 
"RadialFrame:vt", 
"RadialAxes:vu", 
"PolarBase:vv", 
"PolarBaseView:vw", 
"PolarTrendLineManager:vx", 
"PolarLinePlanner:vy", 
"AngleRadiusPair:vz", 
"PolarAxisInfoCache:v0", 
"PolarFrame:v1", 
"PolarAxes:v2", 
"SeriesComponentsFromView:v3", 
"EasingFunctions:v4", 
"TrendCalculators:v5", 
"SeriesViewerComponentsFromView:v6", 
"SeriesViewerSurfaceViewer:v7", 
"LabelPanelArranger:v8", 
"LabelPanelsArrangeState:v9", 
"WindowResponse:wa", 
"SeriesViewerComponentsForView:wb", 
"DataChartCursorEventHandler:wc", 
"ChartCursorEventArgs:wd", 
"DataChartMouseButtonEventHandler:we", 
"DataChartMouseEventHandler:wf", 
"AnnotationLayer:wg", 
"AnnotationLayerView:wh", 
"RefreshCompletedEventHandler:wi", 
"CategoryXAxis:xb", 
"CategoryXAxisView:xc", 
"PointSeries:xe", 
"PointSeriesView:xf", 
"SplineAreaSeriesView:xi", 
"SplineAreaSeries:xj", 
"ColumnSeries:xk", 
"ColumnSeriesView:xl", 
"SplineSeries:xm", 
"SplineSeriesView:xn", 
"AbstractEnumerable:acd", 
"AbstractEnumerator:ace", 
"GenericEnumerable$1:acf", 
"GenericEnumerator$1:acg"]);






$.ig.util.defType('SplineType', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "Natural";
			case 1: return "Clamped";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('SplineType', $.ig.Enum.prototype.$type)
}, true);



$.ig.util.defType('MarkerType', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "Unset";
			case 1: return "None";
			case 2: return "Automatic";
			case 3: return "Circle";
			case 4: return "Triangle";
			case 5: return "Pyramid";
			case 6: return "Square";
			case 7: return "Diamond";
			case 8: return "Pentagon";
			case 9: return "Hexagon";
			case 10: return "Tetragram";
			case 11: return "Pentagram";
			case 12: return "Hexagram";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('MarkerType', $.ig.Enum.prototype.$type)
}, true);













$.ig.util.defType('TimeAxisDisplayType', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "Continuous";
			case 1: return "Discrete";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('TimeAxisDisplayType', $.ig.Enum.prototype.$type)
}, true);




$.ig.util.defType('CategoryTransitionInMode', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "Auto";
			case 1: return "FromZero";
			case 2: return "SweepFromLeft";
			case 3: return "SweepFromRight";
			case 4: return "SweepFromTop";
			case 5: return "SweepFromBottom";
			case 6: return "SweepFromCenter";
			case 7: return "AccordionFromLeft";
			case 8: return "AccordionFromRight";
			case 9: return "AccordionFromTop";
			case 10: return "AccordionFromBottom";
			case 11: return "Expand";
			case 12: return "SweepFromCategoryAxisMinimum";
			case 13: return "SweepFromCategoryAxisMaximum";
			case 14: return "SweepFromValueAxisMinimum";
			case 15: return "SweepFromValueAxisMaximum";
			case 16: return "AccordionFromCategoryAxisMinimum";
			case 17: return "AccordionFromCategoryAxisMaximum";
			case 18: return "AccordionFromValueAxisMinimum";
			case 19: return "AccordionFromValueAxisMaximum";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('CategoryTransitionInMode', $.ig.Enum.prototype.$type)
}, true);


$.ig.util.defType('NumericScaleMode', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "Linear";
			case 1: return "Logarithmic";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('NumericScaleMode', $.ig.Enum.prototype.$type)
}, true);

















$.ig.util.defType('Frame', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	interpolate3: function (p, min, max) {}

	, 
	interpolate: function (ret, p, min, max) {
		var minCount = min.count();
		var maxCount = max.count();
		var count = Math.max(minCount, maxCount);
		var q = 1 - p;
		if (ret.count() < count) {
			ret.insertRange(ret.count(), new Array(count - ret.count()));
		}

		if (ret.count() > count) {
			ret.removeRange(count, ret.count() - count);
		}

		for (var i = 0; i < Math.min(minCount, maxCount); ++i) {
			ret.__inner[i] = {__x: min.__inner[i].__x * q + max.__inner[i].__x * p, __y: min.__inner[i].__y * q + max.__inner[i].__y * p, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		}

		if (minCount < maxCount) {
			var mn = minCount > 0 ? min.__inner[minCount - 1] : {__x: 0, __y: 0, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			for (var i1 = minCount; i1 < maxCount; ++i1) {
				ret.__inner[i1] = {__x: mn.__x * q + max.__inner[i1].__x * p, __y: mn.__y * q + max.__inner[i1].__y * p, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			}

		}

		if (minCount > maxCount) {
			var mx = maxCount > 0 ? max.__inner[maxCount - 1] : {__x: 0, __y: 0, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			for (var i2 = maxCount; i2 < minCount; ++i2) {
				ret.__inner[i2] = {__x: min.__inner[i2].__x * q + mx.__x * p, __y: min.__inner[i2].__y * q + mx.__y * p, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			}

		}

	}

	, 
	interpolateWithSpeed: function (ret, p, min, max, speedModifiers) {
		var minCount = min.count();
		var maxCount = max.count();
		var count = Math.max(minCount, maxCount);
		var q = 1 - p;
		if (ret.count() < count) {
			ret.insertRange(ret.count(), new Array(count - ret.count()));
		}

		if (ret.count() > count) {
			ret.removeRange(count, ret.count() - count);
		}

		var speed;
		var speedq;
		for (var i = 0; i < Math.min(minCount, maxCount); ++i) {
			speed = p * speedModifiers.__inner[i];
			speed = speed > 1 ? 1 : speed;
			speedq = 1 - speed;
			ret.__inner[i] = {__x: min.__inner[i].__x * speedq + max.__inner[i].__x * speed, __y: min.__inner[i].__y * speedq + max.__inner[i].__y * speed, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		}

		if (minCount < maxCount) {
			var mn = minCount > 0 ? min.__inner[minCount - 1] : {__x: 0, __y: 0, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			for (var i1 = minCount; i1 < maxCount; ++i1) {
				speed = p * speedModifiers.__inner[i1];
				speed = speed > 1 ? 1 : speed;
				speedq = 1 - speed;
				ret.__inner[i1] = {__x: mn.__x * speedq + max.__inner[i1].__x * speed, __y: mn.__y * speedq + max.__inner[i1].__y * speed, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			}

		}

		if (minCount > maxCount) {
			var mx = maxCount > 0 ? max.__inner[maxCount - 1] : {__x: 0, __y: 0, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			for (var i2 = maxCount; i2 < minCount; ++i2) {
				speed = p * speedModifiers.__inner[i2];
				speed = speed > 1 ? 1 : speed;
				speedq = 1 - speed;
				ret.__inner[i2] = {__x: min.__inner[i2].__x * speedq + mx.__x * speed, __y: min.__inner[i2].__y * speedq + mx.__y * speed, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			}

		}

	}

	, 
	interpolate1: function (ret, p, min, max) {
		var minCount = min.count();
		var maxCount = max.count();
		var count = Math.max(minCount, maxCount);
		var q = 1 - p;
		if (ret.count() < count) {
			var newVals = new Array(count - ret.count());
			for (var i = 0; i < count - ret.count(); i++) {
				newVals[i] = 0;
			}

			ret.insertRange(ret.count(), newVals);
		}

		if (ret.count() > count) {
			ret.removeRange(count, ret.count() - count);
		}

		for (var i1 = 0; i1 < Math.min(minCount, maxCount); ++i1) {
			ret.__inner[i1] = min.__inner[i1] * q + max.__inner[i1] * p;
		}

		if (minCount < maxCount) {
			var mn = minCount > 0 ? min.__inner[minCount - 1] : 0;
			for (var i2 = minCount; i2 < maxCount; ++i2) {
				ret.__inner[i2] = mn * q + max.__inner[i2] * p;
			}

		}

		if (minCount > maxCount) {
			var mx = maxCount > 0 ? max.__inner[maxCount - 1] : 0;
			for (var i3 = maxCount; i3 < minCount; ++i3) {
				ret.__inner[i3] = min.__inner[i3] * q + mx * p;
			}

		}

	}

	, 
	interpolateWithSpeed1: function (ret, p, min, max, speedModifiers) {
		var minCount = min.count();
		var maxCount = max.count();
		var count = Math.max(minCount, maxCount);
		var q = 1 - p;
		if (ret.count() < count) {
			var newVals = new Array(count - ret.count());
			for (var i = 0; i < count - ret.count(); i++) {
				newVals[i] = 0;
			}

			ret.insertRange(ret.count(), newVals);
		}

		if (ret.count() > count) {
			ret.removeRange(count, ret.count() - count);
		}

		var speed;
		var speedq;
		for (var i1 = 0; i1 < Math.min(minCount, maxCount); ++i1) {
			speed = p * speedModifiers.__inner[i1];
			speed = speed > 1 ? 1 : speed;
			speedq = 1 - speed;
			ret.__inner[i1] = min.__inner[i1] * speedq + max.__inner[i1] * speed;
		}

		if (minCount < maxCount) {
			var mn = minCount > 0 ? min.__inner[minCount - 1] : 0;
			for (var i2 = minCount; i2 < maxCount; ++i2) {
				speed = p * speedModifiers.__inner[i2];
				speed = speed > 1 ? 1 : speed;
				speedq = 1 - speed;
				ret.__inner[i2] = mn * speedq + max.__inner[i2] * speed;
			}

		}

		if (minCount > maxCount) {
			var mx = maxCount > 0 ? max.__inner[maxCount - 1] : 0;
			for (var i3 = maxCount; i3 < minCount; ++i3) {
				speed = p * speedModifiers.__inner[i3];
				speed = speed > 1 ? 1 : speed;
				speedq = 1 - speed;
				ret.__inner[i3] = min.__inner[i3] * speedq + mx * speed;
			}

		}

	}

	, 
	interpolateBrushes: function (p, minBrush, maxBrush, InterpolationMode) {
		var b = $.ig.BrushUtil.prototype.getInterpolation(minBrush, p, maxBrush, InterpolationMode);
		return b;
	}

	, 
	interpolate2: function (ret, p, min, max, interpolationMode) {
		var $self = this;
		var minCount = min.count();
		var maxCount = max.count();
		var count = Math.max(minCount, maxCount);
		var transparentBrush = (function () { var $ret = new $.ig.Brush();
		$ret.fill("transparent"); return $ret;}());
		var q = 1 - p;
		if (ret.count() < count) {
			var newVals = new Array(count - ret.count());
			for (var i = 0; i < count - ret.count(); i++) {
				newVals[i] = new $.ig.Brush();
			}

			ret.insertRange(ret.count(), newVals);
		}

		if (ret.count() > count) {
			ret.removeRange(count, ret.count() - count);
		}

		for (var i1 = 0; i1 < Math.min(minCount, maxCount); ++i1) {
			ret.__inner[i1] = $.ig.Frame.prototype.interpolateBrushes(p, min.__inner[i1], max.__inner[i1], interpolationMode);
		}

		if (minCount < maxCount) {
			var mn = minCount > 0 ? min.__inner[minCount - 1] : transparentBrush;
			for (var i2 = minCount; i2 < maxCount; ++i2) {
				ret.__inner[i2] = $.ig.Frame.prototype.interpolateBrushes(p, mn, max.__inner[i2], interpolationMode);
			}

		}

		if (minCount > maxCount) {
			var mx = maxCount > 0 ? max.__inner[maxCount - 1] : transparentBrush;
			for (var i3 = maxCount; i3 < minCount; ++i3) {
				ret.__inner[i3] = $.ig.Frame.prototype.interpolateBrushes(p, min.__inner[i3], mx, interpolationMode);
			}

		}

	}
	, 
	$type: new $.ig.Type('Frame', $.ig.Object.prototype.$type)
}, true);



























$.ig.util.defType('AutoRangeCalculator', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	getAxisWidth: function (target) {
		return target.viewportRect().width();
	}

	, 
	getAxisHeight: function (target) {
		return target.viewportRect().height();
	}

	, 
	calculateRange: function (target, userMinimum, userMaximum, isLogarithmic, logarithmBase, minimumValue, maximumValue) {
		minimumValue = !$.ig.util.isNaN(userMinimum) && !Number.isInfinity(userMinimum) ? userMinimum : Number.POSITIVE_INFINITY;
		maximumValue = !$.ig.util.isNaN(userMaximum) && !Number.isInfinity(userMaximum) ? userMaximum : Number.NEGATIVE_INFINITY;
		var min = minimumValue;
		var max = maximumValue;
		if (Number.isInfinity(min) || Number.isInfinity(max)) {
			if (target != null) {
				var axisRange = target.getAxisRange();
				if (axisRange != null) {
					min = Math.min(min, axisRange.minimum());
					max = Math.max(max, axisRange.maximum());
				}

			}

		}

		if (!Number.isInfinity(min) && !Number.isInfinity(max)) {
			if (min == max && min != 0) {
				min *= min > 0 ? 0.9 : 1.1;
				max *= max > 0 ? 1.1 : 0.9;
			}

			if (min == max && min == 0) {
				max = 1;
			}

			if (userMinimum > userMaximum) {
				var temp = userMaximum;
				userMaximum = userMinimum;
				userMinimum = temp;
			}

			var actualMinimum = $.ig.util.isNaN(userMinimum) || Number.isInfinity(userMinimum) ? min : userMinimum;
			var actualMaximum = $.ig.util.isNaN(userMaximum) || Number.isInfinity(userMaximum) ? max : userMaximum;
			if (isLogarithmic) {
				if (actualMinimum <= 0) {
					if (actualMaximum > 1) {
						actualMinimum = 1;

					} else {
						actualMinimum = Math.pow(logarithmBase, Math.floor(Math.logBase(actualMaximum, logarithmBase)));
					}

				}

				if ($.ig.util.isNaN(userMinimum) || Number.isInfinity(userMinimum)) {
					min = Math.pow(logarithmBase, Math.floor(Math.logBase(actualMinimum, logarithmBase)));

				} else {
					min = actualMinimum;
				}

				if ($.ig.util.isNaN(userMaximum) || Number.isInfinity(userMaximum)) {
					max = Math.pow(logarithmBase, Math.ceil(Math.logBase(actualMaximum, logarithmBase)));

				} else {
					max = actualMaximum;
				}


			} else {
				var n = Math.pow(10, Math.floor(Math.log10(actualMaximum - actualMinimum)) - 1);
				var axisResolution = $.ig.AutoRangeCalculator.prototype.getAxisWidth(target);
				if ($.ig.util.cast($.ig.NumericYAxis.prototype.$type, target) !== null) {
					axisResolution = $.ig.AutoRangeCalculator.prototype.getAxisHeight(target);
				}

				if ($.ig.util.cast($.ig.NumericRadiusAxis.prototype.$type, target) !== null && axisResolution > 0) {
					var radiusExtentScale = (target).actualRadiusExtentScale();
					var innerRadiusExtentScale = (target).actualInnerRadiusExtentScale();
					axisResolution = Math.min($.ig.AutoRangeCalculator.prototype.getAxisWidth(target), $.ig.AutoRangeCalculator.prototype.getAxisHeight(target)) * (radiusExtentScale - innerRadiusExtentScale) / 2;
					axisResolution = Math.max(axisResolution, 14);
				}

				if (target != null && axisResolution > 0 && (!target.hasUserMinimum() && !target.hasUserMaximum())) {
					var snapper = new $.ig.LinearNumericSnapper(0, min, max, axisResolution);
					n = snapper.interval();
				}

				if (($.ig.util.isNaN(userMinimum) || Number.isInfinity(userMinimum)) && !$.ig.util.isNaN(min) && !$.ig.util.isNaN(n) && n != 0) {
						min = n * Math.floor(min / n);


				} else {
					min = actualMinimum;
				}

				if (($.ig.util.isNaN(userMaximum) || Number.isInfinity(userMaximum)) && !$.ig.util.isNaN(max) && !$.ig.util.isNaN(n) && n != 0) {
					var ceilingOfQuotient = Math.ceil(max / n);
						max = n * ceilingOfQuotient;


				} else {
					max = actualMaximum;
				}

			}

		}

		minimumValue = min;
		maximumValue = max;
		return {
			p5: minimumValue, 
			p6: maximumValue
		};
	}
	, 
	$type: new $.ig.Type('AutoRangeCalculator', $.ig.Object.prototype.$type)
}, true);







$.ig.util.defType('AxisLabelManager', 'Object', {

	_labelDataContext: null,
	labelDataContext: function (value) {
		if (arguments.length === 1) {
			this._labelDataContext = value;
			return value;
		} else {
			return this._labelDataContext;
		}
	}

	, 
	_labelPositions: null,
	labelPositions: function (value) {
		if (arguments.length === 1) {
			this._labelPositions = value;
			return value;
		} else {
			return this._labelPositions;
		}
	}

	, 
	_targetPanel: null,
	targetPanel: function (value) {
		if (arguments.length === 1) {
			this._targetPanel = value;
			return value;
		} else {
			return this._targetPanel;
		}
	}

	, 
	_axis: null,
	axis: function (value) {
		if (arguments.length === 1) {
			this._axis = value;
			return value;
		} else {
			return this._axis;
		}
	}

	, 
	_floatPanelAction: null,
	floatPanelAction: function (value) {
		if (arguments.length === 1) {
			this._floatPanelAction = value;
			return value;
		} else {
			return this._floatPanelAction;
		}
	}
	, 
	init: function () {



		var $self = this;
		$.ig.Object.prototype.init.call(this);
			this.floatPanelAction(function (crossing) {
			});
	}

	, 
	clear: function (windowRect, viewportRect) {
		this.labelDataContext().clear();
		this.labelPositions().clear();
		this.targetPanel().axis(this.axis());
		this.targetPanel().windowRect(windowRect);
		this.targetPanel().viewportRect(viewportRect);
		if (viewportRect.isEmpty() || windowRect.isEmpty()) {
			this.setTextBlockCount(0);
		}

		if (this.axis().textBlocks().count() == 0) {
			this.targetPanel().children().clear();
		}

	}

	, 
	addLabelObject: function (labelObject, position) {
		this.labelDataContext().add1(labelObject);
		this.labelPositions().add(position);
	}

	, 
	updateLabelPanel: function () {
		this.targetPanel().labelDataContext(this.labelDataContext());
		this.targetPanel().labelPositions(this.labelPositions());
	}

	, 
	bindLabel: function (label) {
	}

	, 
	bindTitleLabel: function (label) {
	}

	, 
	addLabel: function (label) {
		this.targetPanel().children().add(label);
	}

	, 
	setLabelInterval: function (p) {
		this.targetPanel().interval(p);
	}

	, 
	floatPanel: function (crossingValue) {
		this.floatPanelAction()(crossingValue);
	}

	, 
	getTextBlock: function (i) {
		var tb = this.axis().textBlocks().item(i);
		return tb;
	}

	, 
	setTextBlockCount: function (p) {
		if (this.axis() == null) {
			return;
		}

		this.axis().textBlocks().count(p);
	}

	, 
	labelsHidden: function () {

			if (this.axis() == null || this.axis().labelSettings() == null) {
				return false;
			}

			return this.axis().labelSettings().visibility() != $.ig.Visibility.prototype.visible;
	}

	, 
	resetLabels: function () {
		this.axis().textBlocks().count(0);
		this.axis().labelPanel().textBlocks().clear();
	}
	, 
	$type: new $.ig.Type('AxisLabelManager', $.ig.Object.prototype.$type)
}, true);





$.ig.util.defType('Snapper', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	expt: function (a, n) {
		var x = 1;
		if (n > 0) {
			for (; n > 0; --n) {
				x *= a;
			}


		} else {
			for (; n < 0; ++n) {
				x /= a;
			}

		}

		return x;
	}

	, 
	nicenum: function (x, round) {
		var exp = $.ig.truncate(Math.floor(Math.log10(x)));
		var f = x / Math.pow(10, exp);
		if (round) {
			var nf = f < 1.5 ? 1 : f < 3 ? 2 : f < 7 ? 5 : 10;
			return nf * Math.pow(10, exp);

		} else {
			var nf1 = f <= 1 ? 1 : f <= 2 ? 2 : f <= 5 ? 5 : 10;
			return nf1 * Math.pow(10, exp);
		}

	}

	, 
	nicenum1: function (span, round) {
		var niceSpan = $.ig.Date.prototype.zero;
		if (span.totalDays() > 1) {
			niceSpan = $.ig.Date.prototype.fromDays(Math.ceil(span.totalDays()));

		} else if (span.totalHours() > 1) {
			niceSpan = $.ig.Date.prototype.fromHours(Math.ceil(span.totalHours()));

		} else if (span.totalMinutes() > 1) {
			niceSpan = $.ig.Date.prototype.fromMinutes(Math.ceil(span.totalMinutes()));

		} else if (span.totalSeconds() > 1) {
			niceSpan = $.ig.Date.prototype.fromSeconds(Math.ceil(span.totalSeconds()));

		} else if (span.totalMilliseconds() > 1) {
			niceSpan = $.ig.Date.prototype.fromMilliseconds(Math.ceil(span.totalMilliseconds()));
		}





		return niceSpan;
	}
	, 
	$type: new $.ig.Type('Snapper', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('LinearNumericSnapper', 'Snapper', {
	init: function (initNumber, visibleMinimum, visibleMaximum, pixels) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.Snapper.prototype.init.call(this);
			this.initialize(visibleMinimum, visibleMaximum, pixels, 10);
	}
	, 
	init1: function (initNumber, visibleMinimum, visibleMaximum, pixels, minTicks) {


		$.ig.Snapper.prototype.init.call(this);
			this.initialize(visibleMinimum, visibleMaximum, pixels, minTicks);
	}

	, 
	initialize: function (visibleMinimum, visibleMaximum, pixels, minTicks) {
		this.interval(NaN);
		this.precision(0);
		this.minorCount(0);
		var ticks = Math.min(minTicks, $.ig.truncate((pixels / $.ig.Snapper.prototype.resolution)));
		if (ticks > 0) {
			var range = $.ig.Snapper.prototype.nicenum(visibleMaximum - visibleMinimum, false);
			this.interval($.ig.Snapper.prototype.nicenum(range / (ticks - 1), true));
			var graphmin = Math.floor(visibleMinimum / this.interval()) * this.interval();
			var graphmax = Math.ceil(visibleMaximum / this.interval()) * this.interval();
			ticks = $.ig.truncate(Math.round((graphmax - graphmin) / this.interval()));
			if (pixels / ticks > $.ig.Snapper.prototype.resolution * 10) {
				this.minorCount(10);

			} else {
				if (pixels / ticks > $.ig.Snapper.prototype.resolution * 5) {
					this.minorCount(5);

				} else {
					if (pixels / ticks > $.ig.Snapper.prototype.resolution * 2) {
						this.minorCount(2);
					}

				}

			}

			this.precision(Math.max(-$.ig.truncate(Math.floor(Math.log10(this.interval()))), 0));
		}

	}

	, 
	_interval: 0,
	interval: function (value) {
		if (arguments.length === 1) {
			this._interval = value;
			return value;
		} else {
			return this._interval;
		}
	}

	, 
	_precision: 0,
	precision: function (value) {
		if (arguments.length === 1) {
			this._precision = value;
			return value;
		} else {
			return this._precision;
		}
	}

	, 
	_minorCount: 0,
	minorCount: function (value) {
		if (arguments.length === 1) {
			this._minorCount = value;
			return value;
		} else {
			return this._minorCount;
		}
	}
	, 
	$type: new $.ig.Type('LinearNumericSnapper', $.ig.Snapper.prototype.$type)
}, true);

$.ig.util.defType('LogarithmicNumericSnapper', 'Snapper', {
	init: function (visibleMinimum, visibleMaximum, logarithmBase, pixels) {



		$.ig.Snapper.prototype.init.call(this);
			this.interval(1);
			this.minorCount(logarithmBase);
	}

	, 
	_interval: 0,
	interval: function (value) {
		if (arguments.length === 1) {
			this._interval = value;
			return value;
		} else {
			return this._interval;
		}
	}

	, 
	_minorCount: 0,
	minorCount: function (value) {
		if (arguments.length === 1) {
			this._minorCount = value;
			return value;
		} else {
			return this._minorCount;
		}
	}
	, 
	$type: new $.ig.Type('LogarithmicNumericSnapper', $.ig.Snapper.prototype.$type)
}, true);

$.ig.util.defType('LinearCategorySnapper', 'Snapper', {
	init: function (initNumber, visibleMinimum, visibleMaximum, pixels) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.LinearCategorySnapper.prototype.init1.call(this, 1, visibleMinimum, visibleMaximum, pixels, NaN, $.ig.CategoryMode.prototype.mode0);
	}
	, 
	init1: function (initNumber, visibleMinimum, visibleMaximum, pixels, interval, categoryMode) {


		$.ig.Snapper.prototype.init.call(this);
			this.interval(interval);
			this.minorCount(0);
			var ticks = Math.min(10, $.ig.truncate((pixels / $.ig.Snapper.prototype.resolution)));
			if (ticks > 0) {
				var range = $.ig.Snapper.prototype.nicenum(visibleMaximum - visibleMinimum, false);
				if ($.ig.util.isNaN(this.interval())) {
					this.interval($.ig.Snapper.prototype.nicenum(range / (ticks - 1), true));
				}

				if (this.interval() < 1) {
					this.interval(1);
				}

				var graphmin = Math.floor(visibleMinimum / this.interval()) * this.interval();
				var graphmax = Math.ceil(visibleMaximum / this.interval()) * this.interval();
				ticks = $.ig.truncate(Math.round((graphmax - graphmin) / this.interval()));
				if (pixels / ticks > $.ig.Snapper.prototype.resolution * 10) {
					this.minorCount(10);

				} else {
					if (pixels / ticks > $.ig.Snapper.prototype.resolution * 5) {
						this.minorCount(5);

					} else {
						if (pixels / ticks > $.ig.Snapper.prototype.resolution * 2) {
							this.minorCount(2);
						}

					}

				}

			}

	}

	, 
	_interval: 0,
	interval: function (value) {
		if (arguments.length === 1) {
			this._interval = value;
			return value;
		} else {
			return this._interval;
		}
	}

	, 
	_minorCount: 0,
	minorCount: function (value) {
		if (arguments.length === 1) {
			this._minorCount = value;
			return value;
		} else {
			return this._minorCount;
		}
	}
	, 
	$type: new $.ig.Type('LinearCategorySnapper', $.ig.Snapper.prototype.$type)
}, true);


$.ig.util.defType('IScaler', 'Object', {
	$type: new $.ig.Type('IScaler', null)
}, true);

$.ig.util.defType('ICategoryScaler', 'Object', {
	$type: new $.ig.Type('ICategoryScaler', null, [$.ig.IScaler.prototype.$type])
}, true);

$.ig.util.defType('CategoryAxisBase', 'Axis', {

	createView: function () {
		return new $.ig.CategoryAxisBaseView(this);
	}

	, 
	onViewCreated: function (view) {
		$.ig.Axis.prototype.onViewCreated.call(this, view);
		this.categoryView(view);
	}

	, 
	_categoryView: null,
	categoryView: function (value) {
		if (arguments.length === 1) {
			this._categoryView = value;
			return value;
		} else {
			return this._categoryView;
		}
	}
	, 
	init: function () {


		this.__itemsCount = 0;
		this._cachedItemsCount = 0;
		this._mode2GroupCount = 0;
		this.__spreading = false;

		$.ig.Axis.prototype.init.call(this);
			this.majorLinePositions(new $.ig.List$1(Number, 0));
	}

	, 
	validateAxis: function (viewportRect, windowRect, view) {
		var isValid = $.ig.Axis.prototype.validateAxis.call(this, viewportRect, windowRect, view);
		if (!isValid) {
			return false;
		}

		return this.itemsSource() != null && this._cachedItemsCount > 0;
	}

	, 
	onDetached: function () {
		if (this.fastItemsSource() != null && this.fastItemsSourceProvider() != null && this.itemsSource() != null) {
			this.fastItemsSource(this.fastItemsSourceProvider().releaseFastItemsSource(this.itemsSource()));
		}

	}

	, 
	onAttached: function () {
		if (this.fastItemsSource() == null && this.fastItemsSourceProvider() != null && this.itemsSource() != null) {
			this.fastItemsSource(this.fastItemsSourceProvider().getFastItemsSource(this.itemsSource()));
		}

	}

	, 
	_majorLinePositions: null,
	majorLinePositions: function (value) {
		if (arguments.length === 1) {
			this._majorLinePositions = value;
			return value;
		} else {
			return this._majorLinePositions;
		}
	}

	, 
	isCategory: function () {

			return true;
	}

	, 
	getCategoryBoundingBox: function (point, useInterpolation, singularWidth) {
		if (this.isAngular()) {
			return $.ig.Rect.prototype.empty();
		}

		return this.getCategoryBoundingBoxHelper(point, useInterpolation, singularWidth, this.isVertical());
	}

	, 
	getCategoryBoundingBoxHelper: function (point, useInterpolation, singularWidth, isVertical) {
		var i = 0;
		var comparison = point.__x;
		var viewportMinExtreme = this.viewportRect().left();
		var viewportMaxExtreme = this.viewportRect().right();
		if (isVertical) {
			comparison = point.__y;
			viewportMinExtreme = this.viewportRect().top();
			viewportMaxExtreme = this.viewportRect().bottom();
		}

		var positions = this.majorLinePositions();
		if ((isVertical && !this.isInverted()) || (!isVertical && this.isInverted())) {
			positions = new $.ig.List$1(Number, 0);
			for (var j = this.majorLinePositions().count() - 1; j >= 0; j--) {
				positions.add(this.majorLinePositions().__inner[j]);
			}

		}

		if (this.categoryMode() == $.ig.CategoryMode.prototype.mode0) {
			if (useInterpolation) {
				var ret;
				if (isVertical) {
					ret = new $.ig.Rect(0, this.viewportRect().left(), point.__y - singularWidth / 2, this.viewportRect().width(), singularWidth);

				} else {
					ret = new $.ig.Rect(0, point.__x - singularWidth / 2, this.viewportRect().top(), singularWidth, this.viewportRect().height());
				}

				ret.intersect(this.viewportRect());
				return ret;

			} else {
				if (comparison > viewportMaxExtreme) {
					return $.ig.Rect.prototype.empty();
				}

				if (comparison < viewportMinExtreme) {
					return $.ig.Rect.prototype.empty();
				}

				var minDist = 1.7976931348623157E+308;
				var minPos = -1;
				for (i = 0; i < positions.count(); i++) {
					var dist = Math.abs(positions.__inner[i] - comparison);
					if (dist < minDist) {
						minDist = dist;
						minPos = i;
					}

				}

				if (minPos == -1) {
					return $.ig.Rect.prototype.empty();
				}

				var target = positions.__inner[minPos];
				var ret1;
				if (isVertical) {
					ret1 = new $.ig.Rect(0, this.viewportRect().left(), target - singularWidth / 2, this.viewportRect().width(), singularWidth);

				} else {
					ret1 = new $.ig.Rect(0, target - singularWidth / 2, this.viewportRect().top(), singularWidth, this.viewportRect().height());
				}

				ret1.intersect(this.viewportRect());
				return ret1;
			}


		} else {
			for (i = 0; i < positions.count(); i++) {
				if (positions.__inner[i] > comparison) {
					break;
				}

			}

			if (i == 0) {
				return $.ig.Rect.prototype.empty();
			}

			if (comparison > viewportMaxExtreme) {
				return $.ig.Rect.prototype.empty();
			}

			if (comparison < viewportMinExtreme) {
				return $.ig.Rect.prototype.empty();
			}

			var curr = this.viewportRect().right();
			if (isVertical) {
				curr = this.viewportRect().bottom();
			}

			if (i < positions.count()) {
				curr = positions.__inner[i];
			}

			if (isVertical) {
				return new $.ig.Rect(0, this.viewportRect().left(), positions.__inner[i - 1], this.viewportRect().width(), curr - positions.__inner[i - 1]);

			} else {
				return new $.ig.Rect(0, positions.__inner[i - 1], this.viewportRect().top(), curr - positions.__inner[i - 1], this.viewportRect().height());
			}

		}

	}

	, 
	fastItemsSource: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.CategoryAxisBase.prototype.fastItemsSourceProperty, value);
			return value;
		} else {

			return this.getValue($.ig.CategoryAxisBase.prototype.fastItemsSourceProperty);
		}
	}
	, 
	__fastItemsSource: null

	, 
	itemsSource: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.CategoryAxisBase.prototype.itemsSourceProperty, value);
			return value;
		} else {

			return this.getValue($.ig.CategoryAxisBase.prototype.itemsSourceProperty);
		}
	}
	, 
	__itemsCount: 0
	, 
	_cachedItemsCount: 0

	, 
	itemsCount: function (value) {
		if (arguments.length === 1) {

			this.__itemsCount = value;
			this._cachedItemsCount = this.__itemsCount;
			return value;
		} else {

			return this.__itemsCount;
		}
	}

	, 
	categoryMode: function (value) {
		if (arguments.length === 1) {

			if (this.__categoryMode != value) {
				var oldValue = this.__categoryMode;
				this.__categoryMode = value;
				this.raisePropertyChanged($.ig.CategoryAxisBase.prototype.categoryModePropertyName, $.ig.CategoryMode.prototype.getBox(oldValue), $.ig.CategoryMode.prototype.getBox(value));
			}

			return value;
		} else {

			return this.__categoryMode;
		}
	}
	, 
	__categoryMode: 0

	, 
	gap: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.CategoryAxisBase.prototype.gapProperty, value);
			return value;
		} else {

			return this.getValue($.ig.CategoryAxisBase.prototype.gapProperty);
		}
	}

	, 
	overlap: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.CategoryAxisBase.prototype.overlapProperty, value);
			return value;
		} else {

			return this.getValue($.ig.CategoryAxisBase.prototype.overlapProperty);
		}
	}

	, 
	useClusteringMode: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.CategoryAxisBase.prototype.useClusteringModeProperty, value);
			return value;
		} else {

			return this.getValue($.ig.CategoryAxisBase.prototype.useClusteringModeProperty);
		}
	}

	, 
	mode2GroupCount: function (value) {
		if (arguments.length === 1) {

			if (value != this._mode2GroupCount) {
				var oldGroupCount = this._mode2GroupCount;
				this._mode2GroupCount = value;
				this.raisePropertyChanged($.ig.CategoryAxisBase.prototype.groupCountPropertyName, oldGroupCount, this._mode2GroupCount);
			}

			return value;
		} else {

			return this._mode2GroupCount;
		}
	}
	, 
	_mode2GroupCount: 0

	, 
	getUnscaledValue: function (scaledValue, p) {
		return NaN;
	}

	, 
	getUnscaledValue2: function (scaledValue, windowRect, viewportRect, categoryMode) {
		return NaN;
	}

	, 
	getCategorySize: function (windowRect, viewportRect) {
		return NaN;
	}

	, 
	getGroupSize: function (windowRect, viewportRect) {
		return NaN;
	}

	, 
	getGroupCenter: function (index, windowRect, viewportRect) {
		return NaN;
	}

	, 
	unscaleValue: function (unscaledValue) {
		var windowRect = this.seriesViewer().windowRect();
		var viewportRect = this.viewportRect();
		var sParams = new $.ig.ScalerParams(windowRect, viewportRect, this.isInverted());
		return this.getUnscaledValue(unscaledValue, sParams);
	}

	, 
	relatedSeries: function () {
		var d__ = new $.ig.CategoryAxisBase___RelatedSeries__IteratorClass(-2);
		d__.__4__this = this;
		return d__;
	}

	, 
	hasSeries: function (series) {
		return this.series().contains(series);
	}

	, 
	shouldShareMode: function (chart) {
		return false;
	}

	, 
	relatedAxes: function () {
		var d__ = new $.ig.CategoryAxisBase___RelatedAxes__IteratorClass(-2);
		d__.__4__this = this;
		return d__;
	}
	, 
	__spreading: false

	, 
	spread: function (propagate) {
		if (this.__spreading) {
			return;
		}

		try {
				this.__spreading = true;
				var categoryMode = $.ig.CategoryMode.prototype.mode0;
				var mode2GroupCount = 0;
				var mode2Present = false;
				var en = this.relatedSeries().getEnumerator();
				while (en.moveNext()) {
					var currentSeries = en.current();
					var categorySeries = $.ig.util.cast($.ig.IHasCategoryModePreference.prototype.$type, currentSeries);
					if (categorySeries != null) {
						var seriesMode = categorySeries.preferredCategoryMode(this);
						if (seriesMode == $.ig.CategoryMode.prototype.mode2) {
							categoryMode = $.ig.CategoryMode.prototype.mode2;
							mode2Present = true;
							if (this.hasSeries(currentSeries)) {
								mode2GroupCount++;
							}

						}

						if (seriesMode == $.ig.CategoryMode.prototype.mode1 && !mode2Present) {
							categoryMode = $.ig.CategoryMode.prototype.mode1;
						}

					}

				}

				var useClusteringMode = this.useClusteringMode();
				var en1 = this.relatedAxes().getEnumerator();
				while (en1.moveNext()) {
					var axis = en1.current();
					if (axis.useClusteringMode()) {
						useClusteringMode = true;
					}

					if (propagate) {
						axis.spread(false);
					}

				}

				if (categoryMode == $.ig.CategoryMode.prototype.mode0 && useClusteringMode) {
					categoryMode = $.ig.CategoryMode.prototype.mode2;
					if (mode2GroupCount == 0) {
						mode2GroupCount = 1;
					}

				}

				this.categoryMode(categoryMode);
				this.mode2GroupCount(mode2GroupCount);

		}
		finally {
				this.__spreading = false;

		}
	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		$.ig.Axis.prototype.propertyUpdatedOverride.call(this, sender, propertyName, oldValue, newValue);
		switch (propertyName) {
			case $.ig.CategoryAxisBase.prototype.fastItemsSourceProviderPropertyName:
				if (($.ig.util.cast($.ig.IFastItemsSourceProvider.prototype.$type, oldValue)) != null) {
					this.fastItemsSource(($.ig.util.cast($.ig.IFastItemsSourceProvider.prototype.$type, oldValue)).releaseFastItemsSource(this.itemsSource()));
				}

				if (($.ig.util.cast($.ig.IFastItemsSourceProvider.prototype.$type, newValue)) != null) {
					this.fastItemsSource(($.ig.util.cast($.ig.IFastItemsSourceProvider.prototype.$type, newValue)).getFastItemsSource(this.itemsSource()));
				}

				this.itemsCount(0);
				if (this.fastItemsSource() != null) {
					this.itemsCount(this.fastItemsSource().count());
				}

				this.spread(true);
				break;
			case $.ig.CategoryAxisBase.prototype.itemsSourcePropertyName:
				if (this.fastItemsSourceProvider() != null) {
					this.fastItemsSource(this.fastItemsSourceProvider().getFastItemsSource(this.itemsSource()));
				}

				break;
			case $.ig.CategoryAxisBase.prototype.fastItemsSourcePropertyName:
				var oldFastItemsSource = $.ig.util.cast($.ig.IFastItemsSource.prototype.$type, oldValue);
				this.cacheFastItemsSource();
				this.mustInvalidateLabels(true);
				if (oldFastItemsSource != null) {
					oldFastItemsSource.event = $.ig.Delegate.prototype.remove(oldFastItemsSource.event, this.handleFastItemsSourceEvent.runOn(this));
				}

				this.itemsCount(0);
				if (this.fastItemsSource() != null) {
					this.itemsCount(this.fastItemsSource().count());
				}

				if (this.fastItemsSource() != null) {
					this.fastItemsSource().event = $.ig.Delegate.prototype.combine(this.fastItemsSource().event, this.handleFastItemsSourceEvent.runOn(this));
					this.renderAxis1(false);
					var en = this.directSeries().getEnumerator();
					while (en.moveNext()) {
						var currentSeries = en.current();
						currentSeries.renderSeries(false);
						if (currentSeries.seriesViewer() != null) {
							currentSeries.notifyThumbnailAppearanceChanged();
						}

					}


				} else {
					this.clearAllMarks();
					var en1 = this.directSeries().getEnumerator();
					while (en1.moveNext()) {
						var currentSeries1 = en1.current();
						currentSeries1.clearRendering(true, currentSeries1.view());
						if (currentSeries1.seriesViewer() != null) {
							currentSeries1.notifyThumbnailAppearanceChanged();
						}

					}

				}

				break;
			case $.ig.CategoryAxisBase.prototype.itemsCountPropertyName:
				this.raiseRangeChanged(new $.ig.AxisRangeChangedEventArgs(0, 0, $.ig.util.getValue((oldValue)) - 1, $.ig.util.getValue((newValue)) - 1));
				this.renderAxis1(false);
				break;
			case $.ig.CategoryAxisBase.prototype.useClusteringModePropertyName:
				this.mustInvalidateLabels(true);
				this.updateCategoryMode();
				this.renderAxis1(false);
				this.forceSeriesUpdate();
				break;
			case $.ig.CategoryAxisBase.prototype.categoryModePropertyName:
				this.mustInvalidateLabels(true);
				this.renderAxis1(false);
				this.renderCrossingAxis();
				this.forceSeriesUpdate();
				break;
			case $.ig.CategoryAxisBase.prototype.overlapPropertyName:
			case $.ig.CategoryAxisBase.prototype.gapPropertyName:
				this.mustInvalidateLabels(true);
				var en2 = this.directSeries().getEnumerator();
				while (en2.moveNext()) {
					var currentSeries2 = en2.current();
					currentSeries2.thumbnailDirty(true);
					var currentCategorySeries = $.ig.util.cast($.ig.IHasCategoryModePreference.prototype.$type, currentSeries2);
					if (currentCategorySeries != null && currentCategorySeries.preferredCategoryMode(this) == $.ig.CategoryMode.prototype.mode2) {
						currentSeries2.renderSeries(false);
					}

				}

				this.renderAxis1(false);
				if (this.seriesViewer() != null) {
					this.seriesViewer().notifyThumbnailAppearanceChanged();
				}

				break;
			case $.ig.CategoryAxisBase.prototype.crossingValuePropertyName:
			case $.ig.CategoryAxisBase.prototype.crossingAxisPropertyName:
				this.mustInvalidateLabels(true);
				this.renderAxis1(true);
				break;
		}

	}

	, 
	forceSeriesUpdate: function () {
		var en = this.directSeries().getEnumerator();
		while (en.moveNext()) {
			var currentSeries = en.current();
			currentSeries.renderSeries(false);
		}

	}

	, 
	handleFastItemsSourceEvent: function (sender, e) {
		switch (e.action()) {
			case $.ig.FastItemsSourceEventAction.prototype.change:
			case $.ig.FastItemsSourceEventAction.prototype.remove:
			case $.ig.FastItemsSourceEventAction.prototype.insert:
			case $.ig.FastItemsSourceEventAction.prototype.replace:
			case $.ig.FastItemsSourceEventAction.prototype.reset:
				if (this.fastItemsSource() != null) {
					this.itemsCount(this.fastItemsSource().count());
				}

				this.renderAxis1(false);
				break;
		}

		if (this.fastItemsSource() != null) {
			this.itemsCount(this.fastItemsSource().count());
		}

	}

	, 
	updateCategoryMode: function () {
		var mode1Present = false, mode2Present = false;
		var en = this.series().getEnumerator();
		while (en.moveNext()) {
			var currentSeries = en.current();
			var currentCategorySeries = $.ig.util.cast($.ig.IHasCategoryModePreference.prototype.$type, currentSeries);
			if (currentCategorySeries == null) {
				continue;
			}

			var currentMode = currentCategorySeries.preferredCategoryMode(this);
			mode1Present |= currentMode == $.ig.CategoryMode.prototype.mode1;
			mode2Present |= currentMode == $.ig.CategoryMode.prototype.mode2;
		}

		var categoryMode = mode2Present ? $.ig.CategoryMode.prototype.mode2 : mode1Present ? $.ig.CategoryMode.prototype.mode1 : $.ig.CategoryMode.prototype.mode0;
		if (categoryMode == $.ig.CategoryMode.prototype.mode0 && this.useClusteringMode()) {
			categoryMode = $.ig.CategoryMode.prototype.mode1;
			if (this.mode2GroupCount() == 0) {
				this.mode2GroupCount(1);
			}

		}

		this.categoryMode(categoryMode);
	}

	, 
	registerSeries: function (series) {
		var success = $.ig.Axis.prototype.registerSeries.call(this, series);
		if (success) {
			this.spread(true);
			var registeredCategorySeries = $.ig.util.cast($.ig.IHasCategoryModePreference.prototype.$type, series);
			if (registeredCategorySeries != null && registeredCategorySeries.preferredCategoryMode(this) == $.ig.CategoryMode.prototype.mode2) {
				var en = this.directSeries().getEnumerator();
				while (en.moveNext()) {
					var currentSeries = en.current();
					var currentCategorySeries = $.ig.util.cast($.ig.IHasCategoryModePreference.prototype.$type, currentSeries);
					if (currentCategorySeries != null && currentCategorySeries != registeredCategorySeries && currentCategorySeries.preferredCategoryMode(this) == $.ig.CategoryMode.prototype.mode2) {
						currentSeries.renderSeries(false);
					}

				}

			}

			this.renderAxis1(false);
			this.updateRange();
		}

		return success;
	}

	, 
	deregisterSeries: function (series) {
		var success = $.ig.Axis.prototype.deregisterSeries.call(this, series);
		if (success) {
			this.spread(true);
			var deregisteredCategorySeries = $.ig.util.cast($.ig.IHasCategoryModePreference.prototype.$type, series);
			if (deregisteredCategorySeries != null && deregisteredCategorySeries.preferredCategoryMode(this) != $.ig.CategoryMode.prototype.mode0) {
				var en = this.directSeries().getEnumerator();
				while (en.moveNext()) {
					var currentSeries = en.current();
					var currentCategorySeries = $.ig.util.cast($.ig.IHasCategoryModePreference.prototype.$type, currentSeries);
					if (currentCategorySeries != null) {
						currentSeries.renderSeries(false);
					}

				}

			}

			this.renderAxis1(false);
		}

		return success;
	}

	, 
	renderCrossingAxis: function () {
		var crossingAxis = null;
		var en = this.directSeries().getEnumerator();
		while (en.moveNext()) {
			var currentSeries = en.current();
			var categorySeries = $.ig.util.cast($.ig.CategorySeries.prototype.$type, currentSeries);
			if (categorySeries != null) {
				var yAxis = categorySeries.getYAxis();
				if (yAxis != null && yAxis.crossingAxis() == this) {
					crossingAxis = yAxis;
				}

			}

		}

		if (crossingAxis != null) {
			crossingAxis.renderAxis();
		}

	}

	, 
	cacheFastItemsSource: function () {
		this.__fastItemsSource = this.fastItemsSource();
	}

	, 
	renderLabels: function () {
		var labelSettings = this.labelSettings();
		if (labelSettings == null) {
			labelSettings = new $.ig.AxisLabelSettings();
		}

		if (labelSettings.visibility() == $.ig.Visibility.prototype.collapsed) {
			this.textBlocks().count(0);

		} else {
			var textBlockCount = 0;
			textBlockCount = this.categoryView().addLabels(this.labelDataContext());
			this.textBlocks().count(textBlockCount);
		}

	}

	, 
	handleCollectionChanged: function (e) {
		if (this.fastItemsSource() != null) {
			this.fastItemsSource().handleCollectionChanged(e);
		}

	}

	, 
	notifySetItem: function (index, oldItem, newItem) {
		this.handleCollectionChanged(new $.ig.NotifyCollectionChangedEventArgs(2, $.ig.NotifyCollectionChangedAction.prototype.replace, newItem, oldItem, index));
	}

	, 
	notifyClearItems: function () {
		this.handleCollectionChanged(new $.ig.NotifyCollectionChangedEventArgs(0, $.ig.NotifyCollectionChangedAction.prototype.reset));
	}

	, 
	notifyInsertItem: function (index, newItem) {
		this.handleCollectionChanged(new $.ig.NotifyCollectionChangedEventArgs(1, $.ig.NotifyCollectionChangedAction.prototype.add, newItem, index));
	}

	, 
	notifyRemoveItem: function (index, oldItem) {
		this.handleCollectionChanged(new $.ig.NotifyCollectionChangedEventArgs(1, $.ig.NotifyCollectionChangedAction.prototype.remove, oldItem, index));
	}
	, 
	$type: new $.ig.Type('CategoryAxisBase', $.ig.Axis.prototype.$type, [$.ig.ICategoryScaler.prototype.$type])
}, true);



$.ig.util.defType('CategoryAxisBaseView', 'AxisView', {

	_categoryModel: null,
	categoryModel: function (value) {
		if (arguments.length === 1) {
			this._categoryModel = value;
			return value;
		} else {
			return this._categoryModel;
		}
	}
	, 
	init: function (model) {



		$.ig.AxisView.prototype.init.call(this, model);
			this.categoryModel(model);
	}

	, 
	addLabels: function (list) {
		var textBlockCount = 0;
		for (var i = 0; i < list.count(); i++) {
			var label = $.ig.util.cast($.ig.FrameworkElement.prototype.$type, list.__inner[i]);
			if (label == null) {
				label = this.model().textBlocks().item(i);
				($.ig.util.cast($.ig.TextBlock.prototype.$type, label)).text(list.__inner[i] == null ? "" : list.__inner[i].toString());
				textBlockCount++;

			} else {
				this.labelPanel().children().add(label);
			}

		}

		return textBlockCount;
	}
	, 
	$type: new $.ig.Type('CategoryAxisBaseView', $.ig.AxisView.prototype.$type)
}, true);



$.ig.util.defType('CategoryDateTimeXAxis', 'CategoryAxisBase', {
	init: function () {



		$.ig.CategoryAxisBase.prototype.init.call(this);
			this.defaultStyleKey($.ig.CategoryDateTimeXAxis.prototype.$type);
			this.__actualMinimumValue = new Date();
			this.__actualMaximumValue = new Date();
	}

	, 
	createView: function () {
		return new $.ig.CategoryDateTimeXAxisView(this);
	}

	, 
	onViewCreated: function (view) {
		$.ig.CategoryAxisBase.prototype.onViewCreated.call(this, view);
		this.dateTimeView(view);
	}

	, 
	_dateTimeView: null,
	dateTimeView: function (value) {
		if (arguments.length === 1) {
			this._dateTimeView = value;
			return value;
		} else {
			return this._dateTimeView;
		}
	}

	, 
	isSorting: function () {

			return true;
	}

	, 
	isDateTime: function () {

			return true;
	}

	, 
	displayType: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.CategoryDateTimeXAxis.prototype.displayTypeProperty, $.ig.TimeAxisDisplayType.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.CategoryDateTimeXAxis.prototype.displayTypeProperty));
		}
	}

	, 
	minimumValue: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.CategoryDateTimeXAxis.prototype.minimumValueProperty, value);
			return value;
		} else {

			return this.getValue($.ig.CategoryDateTimeXAxis.prototype.minimumValueProperty);
		}
	}

	, 
	maximumValue: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.CategoryDateTimeXAxis.prototype.maximumValueProperty, value);
			return value;
		} else {

			return this.getValue($.ig.CategoryDateTimeXAxis.prototype.maximumValueProperty);
		}
	}

	, 
	interval: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.CategoryDateTimeXAxis.prototype.intervalProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.CategoryDateTimeXAxis.prototype.intervalProperty));
		}
	}

	, 
	validateAxis: function (viewportRect, windowRect, view) {
		var isValid = $.ig.CategoryAxisBase.prototype.validateAxis.call(this, viewportRect, windowRect, view);
		if (!isValid) {
			return false;
		}

		return this.actualMinimumValue() != this.actualMaximumValue();
	}

	, 
	createLabelPanel: function () {
		if (this.useSmartAxis()) {
			return new $.ig.SmartAxisLabelPanel();

		} else {
			return new $.ig.HorizontalAxisLabelPanel();
		}

	}

	, 
	getCategorySize: function (windowRect, viewportRect) {
		return viewportRect.width() / (this._cachedItemsCount * windowRect.width());
	}

	, 
	getGroupCenter: function (groupIndex, windowRect, viewportRect) {
		return this.getCategorySize(windowRect, viewportRect) * 0.5;
	}

	, 
	getGroupSize: function (windowRect, viewportRect) {
		var gap = !$.ig.util.isNaN(this.gap()) ? $.ig.MathUtil.prototype.clamp(this.gap(), 0, 1) : 0;
		var categorySpace = 1 - 0.5 * gap;
		var ret = this.getCategorySize(windowRect, viewportRect) * categorySpace;
		return ret;
	}
	, 
	__sorderDateTimeIndices: null

	, 
	sortedDateTimeIndices: function (value) {
		if (arguments.length === 1) {

			this.__sorderDateTimeIndices = value;
			return value;
		} else {

			return this.__sorderDateTimeIndices;
		}
	}

	, 
	renderAxisOverride: function (animate) {
		$.ig.CategoryAxisBase.prototype.renderAxisOverride.call(this, animate);
		var windowRect = this.seriesViewer() != null ? this.seriesViewer().actualWindowRect() : $.ig.Rect.prototype.empty();
		var viewportRect = !windowRect.isEmpty() ? this.viewportRect() : $.ig.Rect.prototype.empty();
		var xParams = new $.ig.ScalerParams(windowRect, viewportRect, this.isInverted());
		var axisGeometry = this.view().getAxisLinesGeometry();
		var stripsGeometry = this.view().getStripsGeometry();
		var majorGeometry = this.view().getMajorLinesGeometry();
		var minorGeometry = this.view().getMinorLinesGeometry();
		var axisLinesPathInfo = this.view().getAxisLinesPathInfo();
		var majorLinesPathInfo = this.view().getMajorLinesPathInfo();
		var minorLinesPathInfo = this.view().getMinorLinesPathInfo();
		this.updateLineVisibility();
		this.clearMarks(axisGeometry);
		this.clearMarks(stripsGeometry);
		this.clearMarks(majorGeometry);
		this.clearMarks(minorGeometry);
		this.labelDataContext().clear();
		this.labelPositions().clear();
		this.majorLinePositions().clear();
		this.labelPanel().axis(this);
		this.labelPanel().windowRect(windowRect);
		this.labelPanel().viewportRect(viewportRect);
		if (windowRect.isEmpty() || viewportRect.isEmpty()) {
			this.textBlocks().count(0);
		}

		if (this.textBlocks().count() == 0) {
			this.labelPanel().children().clear();
		}

		if (this.labelSettings() != null) {
			this.labelSettings().registerAxis(this);
		}

		this.initializeActualMinimumAndMaximum();
		if (!windowRect.isEmpty() && !viewportRect.isEmpty() && (this.displayType() != $.ig.TimeAxisDisplayType.prototype.discrete || this.dateTimeColumn() != null)) {
			var crossingValue = viewportRect.bottom();
			var relativeCrossingValue = crossingValue - viewportRect.top();
			if (this.crossingAxis() != null) {
				var yAxis = $.ig.util.cast($.ig.NumericYAxis.prototype.$type, this.crossingAxis());
				if (yAxis != null) {
					var yParams = new $.ig.ScalerParams(windowRect, viewportRect, yAxis.isInverted());
					crossingValue = this.crossingValue();
					crossingValue = yAxis.getScaledValue(crossingValue, yParams);
					relativeCrossingValue = crossingValue - viewportRect.top();
					if (crossingValue < viewportRect.top()) {
						crossingValue = viewportRect.top();

					} else if (crossingValue > viewportRect.bottom()) {
						crossingValue = viewportRect.bottom();
					}


					if (relativeCrossingValue < 0) {
						relativeCrossingValue = 0;

					} else if (relativeCrossingValue > viewportRect.height()) {
						relativeCrossingValue = viewportRect.height();
					}


				}

			}

			if ($.ig.util.isNaN(crossingValue)) {
				crossingValue = 0;
			}

			this.horizontalLine(axisGeometry, crossingValue, viewportRect, axisLinesPathInfo);
			this.labelPanel().crossingValue(relativeCrossingValue);
			if (this.displayType() == $.ig.TimeAxisDisplayType.prototype.discrete) {
				var first = (this).getFirstVisibleIndex(windowRect, viewportRect);
				var last = (this).getLastVisibleIndex(windowRect, viewportRect);
				if (first < 0 || last < 0) {
					return;
				}

				var lastMajorValue = NaN;
				for (var i = first; i <= last; i++) {
					var sortedIndex = this.sortedDateTimeIndices() == null ? i : this.sortedDateTimeIndices().__inner[i];
					var majorValue = this.getScaledValue(this.dateTimeColumn().item(sortedIndex).getTime(), xParams);
					if (majorValue == lastMajorValue) {
						continue;
					}

					lastMajorValue = majorValue;
					if (this.categoryMode() == $.ig.CategoryMode.prototype.mode2) {
						majorValue += this.isInverted() ? -this.getGroupCenter(i, windowRect, viewportRect) : this.getGroupCenter(i, windowRect, viewportRect);
					}

					if (majorValue < viewportRect.left() || majorValue > viewportRect.right()) {
						continue;
					}

					this.verticalLine(majorGeometry, majorValue, viewportRect, majorLinesPathInfo);
					this.majorLinePositions().add(majorValue);
					if (this.fastItemsSource() != null && i < this.fastItemsSource().count()) {
						var dataItem = this.fastItemsSource().item(sortedIndex);
						var labelText = $.ig.CategoryAxisBase.prototype.getLabel.call(this, dataItem);
						if (!$.ig.util.isNaN(majorValue) && !Number.isInfinity(majorValue) && labelText != null) {
							if (($.ig.util.cast(String, labelText) !== null || typeof labelText === "string") && (labelText).equals("")) {

							} else {
								this.labelDataContext().add1(labelText);
								this.labelPositions().add(new $.ig.LabelPosition(majorValue));
							}

						}

					}

				}


			} else {
				var visibleMinimum = this.getUnscaledValue(viewportRect.left(), xParams);
				var visibleMaximum = this.getUnscaledValue(viewportRect.right(), xParams);
				var trueVisibleMinimum = Math.min(visibleMinimum, visibleMaximum);
				var trueVisibleMaximum = Math.max(visibleMinimum, visibleMaximum);
				var snapper = new $.ig.LinearNumericSnapper(0, trueVisibleMinimum, trueVisibleMaximum, viewportRect.width());
				var interval = this.hasUserInterval() ? this.getUserIntervalTicks() : snapper.interval();
				var first1 = $.ig.truncate(Math.floor((trueVisibleMinimum - this.actualMinimumValue().getTime()) / interval));
				var last1 = $.ig.truncate(Math.ceil((trueVisibleMaximum - this.actualMinimumValue().getTime()) / interval));
				var offset = 0;
				if (this.categoryMode() == $.ig.CategoryMode.prototype.mode2) {
					offset = this.getGroupCenter(0, windowRect, viewportRect);
					offset = this.isInverted() ? -offset : offset;
				}

				var viewportPixelRight = $.ig.truncate(Math.ceil(viewportRect.right()));
				var viewportPixelLeft = $.ig.truncate(Math.floor(viewportRect.left()));
				var majorValue1 = this.getScaledValue(this.actualMinimumValue().getTime() + first1 * interval, xParams) + offset;
				for (var i1 = first1; i1 <= last1; i1++) {
					var nextMajorValue = this.getScaledValue(this.actualMinimumValue().getTime() + (i1 + 1) * interval, xParams) + offset;
					if (!$.ig.util.isNaN(majorValue1) && !Number.isInfinity(majorValue1)) {
						var categoryPixelValue = $.ig.truncate(Math.round(majorValue1));
						if (categoryPixelValue <= viewportPixelRight) {
							if (i1 % 2 == 0) {
								this.verticalStrip(stripsGeometry, majorValue1, nextMajorValue, viewportRect);
							}

							this.verticalLine(majorGeometry, majorValue1, viewportRect, majorLinesPathInfo);
							this.majorLinePositions().add(majorValue1);
							if (this.shouldRenderMinorLines()) {
								for (var j = 1; j < snapper.minorCount(); ++j) {
									var minorValue = this.getScaledValue(this.actualMinimumValue().getTime() + i1 * interval + (j * interval) / snapper.minorCount(), xParams) + offset;
									this.verticalLine(minorGeometry, minorValue, viewportRect, minorLinesPathInfo);
								}

							}

						}

						if (categoryPixelValue >= viewportPixelLeft && categoryPixelValue <= viewportPixelRight) {
							var majorX = this.actualMinimumValue().getTime() + i1 * interval;
							var ticks_ = $.ig.truncate(Math.floor(majorX));
							var dateValue = new Date(ticks_);
							var labelText1 = this.getLabel(dateValue);
							if (labelText1 != null && labelText1 != "") {
								this.labelDataContext().add1(labelText1);
								this.labelPositions().add(new $.ig.LabelPosition(majorValue1));
							}

						}

					}

					majorValue1 = nextMajorValue;
				}

			}

			if ((this.labelSettings() == null || this.labelSettings().visibility() == $.ig.Visibility.prototype.visible) && this.crossingAxis() != null) {
				if (this.labelSettings() != null && (this.labelSettings().location() == $.ig.AxisLabelsLocation.prototype.insideTop || this.labelSettings().location() == $.ig.AxisLabelsLocation.prototype.insideBottom)) {
					this.seriesViewer().invalidatePanels();
				}

			}

			this.labelPanel().labelDataContext(this.labelDataContext());
			this.labelPanel().labelPositions(this.labelPositions());
			this.renderLabels();
		}

	}

	, 
	getUserIntervalTicks: function () {
		return this.actualInterval();
	}

	, 
	initializeActualMinimumAndMaximum: function () {
		var windowRect = this.seriesViewer() != null ? this.seriesViewer().actualWindowRect() : $.ig.Rect.prototype.empty();
		var viewportRect = !windowRect.isEmpty() ? this.viewportRect() : $.ig.Rect.prototype.empty();
		var newActualMinimum = new Date();
		var newActualMaximum = new Date();
		if (!windowRect.isEmpty() && !viewportRect.isEmpty() && this.dateTimeColumn() != null) {
			var fastDateColumn = $.ig.util.cast($.ig.FastItemDateTimeColumn.prototype.$type, this.dateTimeColumn());
			if (fastDateColumn != null) {
				if (this.sortedDateTimeIndices() == null) {
					this.sortedDateTimeIndices(fastDateColumn.getSortedIndices());
				}


			} else {
				this.sortedDateTimeIndices(null);
			}

			if (this.dateTimeColumn().count() > 0) {
				var firstIndex = this.sortedDateTimeIndices() == null ? 0 : this.sortedDateTimeIndices().__inner[0];
				var lastIndex = this.sortedDateTimeIndices() == null ? this.dateTimeColumn().count() - 1 : this.sortedDateTimeIndices().__inner[this.dateTimeColumn().count() - 1];
				newActualMinimum = this.dateTimeColumn().item(firstIndex);
				newActualMaximum = this.dateTimeColumn().item(lastIndex);
				this.hasUserInterval(false);
				if (this.categoryMode() == $.ig.CategoryMode.prototype.mode2) {
					var timeSpan = newActualMaximum.getTime() - newActualMinimum.getTime();
					var timeOffset_ = $.ig.truncate(Math.round(timeSpan * 1.25 / this._cachedItemsCount / 2));
					if (timeOffset_ == 0) {
						timeOffset_ = 1;
					}

					var minTime_ = newActualMinimum.getTime();
					var maxTime_ = newActualMaximum.getTime();
					newActualMinimum = new Date(minTime_ - timeOffset_);
					newActualMaximum = new Date(maxTime_ + timeOffset_);
				}

			}

		}

		if (this.minimumValueIsSet()) {
			newActualMinimum = this.minimumValue();
		}

		if (this.maximumValueIsSet()) {
			newActualMaximum = this.maximumValue();
		}

		if (this.intervalIsSet()) {
			this.actualInterval(this.interval());
			var span = Math.abs(newActualMaximum.getTime() - newActualMinimum.getTime());
			this.hasUserInterval(this.actualIntervalIsEmpty() || (this.displayType() == $.ig.TimeAxisDisplayType.prototype.discrete) || (1 * span / this.getUserIntervalTicks() > (viewportRect.width() / windowRect.width())) ? false : true);

		} else {
			this.hasUserInterval(false);
		}

		this.actualMinimumValue(newActualMinimum);
		this.actualMaximumValue(newActualMaximum);
	}

	, 
	intervalIsSet: function () {
		return this.interval() != 0;
	}

	, 
	actualIntervalIsEmpty: function () {
		return this.actualInterval() == 0;
	}

	, 
	minimumValueIsSet: function () {
		return this.minimumValue() != null;
	}

	, 
	maximumValueIsSet: function () {
		return this.maximumValue() != null;
	}
	, 
	__actualMinimumValue: new Date()

	, 
	actualMinimumValue: function (value) {
		if (arguments.length === 1) {

			var changed = this.__actualMinimumValue != value;
			if (changed) {
				var oldValue = this.__actualMinimumValue;
				this.__actualMinimumValue = value;
				this.raisePropertyChanged($.ig.CategoryDateTimeXAxis.prototype._actualMinimumValuePropertyName, oldValue, value);
			}

			return value;
		} else {

			return this.__actualMinimumValue;
		}
	}
	, 
	__actualMaximumValue: new Date()

	, 
	actualMaximumValue: function (value) {
		if (arguments.length === 1) {

			var changed = this.__actualMaximumValue != value;
			if (changed) {
				var oldValue = this.__actualMaximumValue;
				this.__actualMaximumValue = value;
				this.raisePropertyChanged($.ig.CategoryDateTimeXAxis.prototype._actualMaximumValuePropertyName, oldValue, value);
			}

			return value;
		} else {

			return this.__actualMaximumValue;
		}
	}

	, 
	_hasUserInterval: false,
	hasUserInterval: function (value) {
		if (arguments.length === 1) {
			this._hasUserInterval = value;
			return value;
		} else {
			return this._hasUserInterval;
		}
	}
	, 
	__actualInterval: 0

	, 
	actualInterval: function (value) {
		if (arguments.length === 1) {

			this.__actualInterval = value;
			return value;
		} else {

			return this.__actualInterval;
		}
	}

	, 
	getScaledValue: function (unscaledValue, p) {
		var scaledValue;
		if (this.actualMaximumValue() == this.actualMinimumValue()) {
			scaledValue = -1;

		} else {
			scaledValue = (unscaledValue - this.actualMinimumValue().getTime()) / (this.actualMaximumValue().getTime() - this.actualMinimumValue().getTime());
		}

		var offset = 0;
		if (this.categoryMode() == $.ig.CategoryMode.prototype.mode2) {
			offset = this.getGroupCenter(0, p._windowRect, p._viewportRect);
		}

		if (this.isInverted()) {
			scaledValue = 1 - scaledValue;
			offset = -offset;
		}

		return p._viewportRect.left() + p._viewportRect.width() * (scaledValue - p._windowRect.left()) / p._windowRect.width() - offset;
	}

	, 
	getUnscaledValue: function (scaledValue, p) {
		return this.getUnscaledValue2(scaledValue, p._windowRect, p._viewportRect, this.categoryMode());
	}

	, 
	getUnscaledValue2: function (scaledValue, windowRect, viewportRect, categoryMode) {
		var unscaledValue = windowRect.left() + windowRect.width() * (scaledValue - viewportRect.left()) / viewportRect.width();
		if (this.isInverted()) {
			unscaledValue = 1 - unscaledValue;
		}

		return $.ig.truncate(Math.floor(this.actualMinimumValue().getTime() + unscaledValue * (this.actualMaximumValue().getTime() - this.actualMinimumValue().getTime())));
	}

	, 
	getDate: function (index) {
		return this.dateTimeColumn() == null ? $.ig.Date.prototype.minValue() : this.dateTimeColumn().item(index);
	}

	, 
	dateTimeMemberPath: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.CategoryDateTimeXAxis.prototype.dateTimeMemberPathProperty, value);
			return value;
		} else {

			return this.getValue($.ig.CategoryDateTimeXAxis.prototype.dateTimeMemberPathProperty);
		}
	}

	, 
	dateTimeColumn: function (value) {
		if (arguments.length === 1) {

			if (this._dateTimeColumn != value) {
				var oldDateTimeColumn = this._dateTimeColumn;
				this._dateTimeColumn = value;
				this.raisePropertyChanged($.ig.CategoryDateTimeXAxis.prototype.dateTimeColumnPropertyName, oldDateTimeColumn, this._dateTimeColumn);
			}

			return value;
		} else {

			return this._dateTimeColumn;
		}
	}
	, 
	_dateTimeColumn: null

	, 
	registerDateTimeColumn: function (memberPath) {
		if (memberPath == null) {
			return this.fastItemsSource().registerColumnDateTime(null, null, false);
		}

		var coercionMethod = null;
		var info = $.ig.SeriesViewer.prototype.getCoercionMethod(memberPath, this.coercionMethods());
		memberPath = info.memberPath();
		coercionMethod = info.coercionMethod();
		return this.fastItemsSource().registerColumnDateTime(memberPath, coercionMethod, this.expectFunctions());
	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		$.ig.CategoryAxisBase.prototype.propertyUpdatedOverride.call(this, sender, propertyName, oldValue, newValue);
		switch (propertyName) {
			case $.ig.CategoryAxisBase.prototype.fastItemsSourcePropertyName:
				var oldFastItemsSource = $.ig.util.cast($.ig.IFastItemsSource.prototype.$type, oldValue);
				if (oldFastItemsSource != null) {
					oldFastItemsSource.deregisterColumn(this.dateTimeColumn());
					this.dateTimeColumn(null);
					oldFastItemsSource.event = $.ig.Delegate.prototype.remove(oldFastItemsSource.event, this.fastItemsSource_Event.runOn(this));
				}

				var newFastItemsSource = $.ig.util.cast($.ig.IFastItemsSource.prototype.$type, newValue);
				if (newFastItemsSource != null) {
					this.sortedDateTimeIndices(null);
					this.dateTimeColumn(this.registerDateTimeColumn(this.dateTimeMemberPath()));
					newFastItemsSource.event = $.ig.Delegate.prototype.combine(newFastItemsSource.event, this.fastItemsSource_Event.runOn(this));
				}

				this.renderAxisAndSeries(false);
				break;
			case $.ig.CategoryDateTimeXAxis.prototype._dateTimeMemberPathPropertyName:
				if (this.fastItemsSource() != null) {
					this.fastItemsSource().deregisterColumn(this.dateTimeColumn());
					this.dateTimeColumn(this.registerDateTimeColumn(this.dateTimeMemberPath()));
					this.sortedDateTimeIndices(null);
				}

				break;
			case $.ig.CategoryDateTimeXAxis.prototype.displayTypePropertyName:
				this.mustInvalidateLabels(true);
				this.labelPanel().areLabelsUnevenlySpaced(this.displayType() == $.ig.TimeAxisDisplayType.prototype.discrete);
				this.renderAxis1(false);
				break;
			case $.ig.CategoryDateTimeXAxis.prototype.minimumValuePropertyName:
				this.updateRange();
				this.renderAxisAndSeries(false);
				break;
			case $.ig.CategoryDateTimeXAxis.prototype.maximumValuePropertyName:
				this.updateRange();
				this.renderAxisAndSeries(false);
				break;
			case $.ig.CategoryDateTimeXAxis.prototype.intervalPropertyName:
				this.mustInvalidateLabels(true);
				this.renderAxis1(false);
				break;
		}

	}

	, 
	fastItemsSource_Event: function (sender, e) {
		this.sortedDateTimeIndices(null);
	}

	, 
	renderAxisAndSeries: function (animate) {
		this.renderAxisOverride(animate);
		if (this.fastItemsSource() == null) {
		return;
		}

		var en = this.directSeries().getEnumerator();
		while (en.moveNext()) {
			var currentSeries = en.current();
			currentSeries.renderSeries(animate);
		}

	}

	, 
	updateRangeOverride: function () {
		var oldMin = this.actualMinimumValue().getTime();
		var oldMax = this.actualMaximumValue().getTime();
		var newMin = !this.minimumValueIsSet() ? this.actualMinimumValue().getTime() : this.minimumValue().getTime();
		var newMax = !this.maximumValueIsSet() ? this.actualMaximumValue().getTime() : this.maximumValue().getTime();
		var ea = new $.ig.AxisRangeChangedEventArgs(oldMin, newMin, oldMax, newMax);
		this.raiseRangeChanged(ea);
		return true;
	}

	, 
	sortedIndices: function () {

			if (this.sortedDateTimeIndices() == null) {
				var fastDateColumn = $.ig.util.cast($.ig.FastItemDateTimeColumn.prototype.$type, this.dateTimeColumn());
				if (fastDateColumn != null) {
					this.sortedDateTimeIndices(fastDateColumn.getSortedIndices());

				} else {
					this.sortedDateTimeIndices(null);
				}

			}

			return this.sortedDateTimeIndices();
	}

	, 
	getFirstVisibleIndex: function (windowRect, viewportRect) {
		var xParams = new $.ig.ScalerParams(windowRect, viewportRect, this.isInverted());
		var x0, x1;
		if (this.isInverted()) {
			x1 = this.getUnscaledValue(viewportRect.left(), xParams);
			x0 = this.getUnscaledValue(viewportRect.right(), xParams);

		} else {
			x0 = this.getUnscaledValue(viewportRect.left(), xParams);
			x1 = this.getUnscaledValue(viewportRect.right(), xParams);
		}

		var result = 0;
		for (var i = 0; i < this.sortedDateTimeIndices().count(); i++) {
			if (this.dateTimeColumn() == null) {
				break;
			}

			var currentDateTime = this.dateTimeColumn().item(this.sortedDateTimeIndices().__inner[i]);
			if (currentDateTime.getTime() >= x0) {
				break;
			}

			result = i;
		}

		return result;
	}

	, 
	getLastVisibleIndex: function (windowRect, viewportRect) {
		var xParams = new $.ig.ScalerParams(windowRect, viewportRect, this.isInverted());
		var x0, x1;
		if (this.isInverted()) {
			x1 = this.getUnscaledValue(viewportRect.left(), xParams);
			x0 = this.getUnscaledValue(viewportRect.right(), xParams);

		} else {
			x0 = this.getUnscaledValue(viewportRect.left(), xParams);
			x1 = this.getUnscaledValue(viewportRect.right(), xParams);
		}

		var last = this.sortedDateTimeIndices().count() - 1;
		var result = last;
		for (var i = last; i >= 0; i--) {
			if (this.dateTimeColumn() == null || this.sortedDateTimeIndices().count() <= i) {
				break;
			}

			var sortedIndex = this.sortedDateTimeIndices().__inner[i];
			if (sortedIndex >= this.dateTimeColumn().count()) {
				break;
			}

			var currentDateTime = this.dateTimeColumn().item(sortedIndex);
			if (currentDateTime.getTime() < x1) {
				break;
			}

			result = Math.min(i + 1, this.sortedDateTimeIndices().count() - 1);
		}

		return result;
	}

	, 
	getUnscaledValueAt: function (index) {
		if (this.dateTimeColumn() == null) {
		return NaN;
		}

		var date = this._dateTimeColumn.item(index);
		var ticks = date.getTime();
		var ticksAsDouble = ticks;
		return ticksAsDouble;
	}

	, 
	getExactUnsortedIndexClosestToUnscaledValue: function (unscaledValue) {
		var sorting = this;
		var view = new $.ig.SortedListView$1($.ig.Date.prototype.$type, this.dateTimeColumn(), sorting.sortedIndices());
		var ticks_ = unscaledValue;
		var target = new Date(ticks_);
		var res = this.getSearchResult(unscaledValue, target, view);
		if (res >= 0 && res < sorting.sortedIndices().count() && res - 1 >= 0 && res - 1 < sorting.sortedIndices().count()) {
			var diff1_ = target.getTime() - view.item(res - 1).getTime();
			var diff2_ = view.item(res).getTime() - target.getTime();
			var prev = res - 1;
			var next = res;
			if (prev < 0 && next >= 0) {
				return next;
			}

			if (next > sorting.sortedIndices().count() - 1 && prev < sorting.sortedIndices().count()) {
				return prev;
			}

			if (prev < 0 && next < 0) {
				return -1;
			}

			if (prev > sorting.sortedIndices().count() - 1 && next > sorting.sortedIndices().count() - 1) {
				return -1;
			}

			var p = diff1_ / (diff1_ + diff2_);
			if ($.ig.util.isNaN(p)) {
				p = 0;
			}

			return prev + p;
		}

		if (res >= 0 && res < sorting.sortedIndices().count()) {
			return res;
		}

		return -1;
	}

	, 
	getSearchResult: function (unscaledValue, target, view) {
		var $self = this;
		var sorting = $self;
		if ($self.dateTimeColumn() == null || sorting.sortedIndices() == null) {
			return -1;
		}

		var res = -1;
		var result = $.ig.ArrayUtil.prototype.binarySearch$1($.ig.Date.prototype.$type, view, function (item) {
			if (target < item) {
				return -1;
			}

			if (target > item) {
				return 1;
			}

			return 0;
		});
		if (result >= 0) {
			res = result;

		} else {
			res = ~result;
		}

		while (res >= 0 && res < view.count() && res - 1 >= 0 && view.item(res) == view.item(res - 1)) {
			res--;

		}
		return res;
	}

	, 
	getIndexClosestToUnscaledValue: function (unscaledValue) {
		var sorting = this;
		var view = new $.ig.SortedListView$1($.ig.Date.prototype.$type, this.dateTimeColumn(), sorting.sortedIndices());
		var ticks_ = unscaledValue;
		var target = new Date(ticks_);
		var res = this.getSearchResult(unscaledValue, target, view);
		if (res >= 0 && res < sorting.sortedIndices().count() && res - 1 >= 0 && res - 1 < sorting.sortedIndices().count()) {
			var diff1 = target - view.item(res - 1);
			var diff2 = view.item(res) - target;
			if (diff1 < diff2) {
				res = res - 1;
			}

		}

		if (res >= 0 && res < sorting.sortedIndices().count()) {
			return sorting.sortedIndices().__inner[res];
		}

		if (res == sorting.sortedIndices().count() && this.seriesViewer() != null && Math.abs(this.getScaledValue(unscaledValue, new $.ig.ScalerParams(this.seriesViewer().actualWindowRect(), this.viewportRect(), this.isInverted())) - this.viewportRect().right()) < 2) {
			return res - 1;
		}

		if (res == -1 && this.seriesViewer() != null && Math.abs(this.getScaledValue(unscaledValue, new $.ig.ScalerParams(this.seriesViewer().actualWindowRect(), this.viewportRect(), this.isInverted())) - this.viewportRect().left()) < 2) {
			return 0;
		}

		return -1;
	}

	, 
	notifyDataChanged: function () {
		this.sortedDateTimeIndices(null);
		this.renderAxis();
	}

	, 
	orientation: function () {

			return $.ig.AxisOrientation.prototype.horizontal;
	}
	, 
	$type: new $.ig.Type('CategoryDateTimeXAxis', $.ig.CategoryAxisBase.prototype.$type, [$.ig.ISortingAxis.prototype.$type])
}, true);

$.ig.util.defType('CategoryDateTimeXAxisView', 'CategoryAxisBaseView', {

	_xModel: null,
	xModel: function (value) {
		if (arguments.length === 1) {
			this._xModel = value;
			return value;
		} else {
			return this._xModel;
		}
	}
	, 
	init: function (model) {



		$.ig.CategoryAxisBaseView.prototype.init.call(this, model);
			this.xModel(model);
	}
	, 
	$type: new $.ig.Type('CategoryDateTimeXAxisView', $.ig.CategoryAxisBaseView.prototype.$type)
}, true);

$.ig.util.defType('AxisRenderingParametersBase', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.rangeInfos(new $.ig.List$1($.ig.RangeInfo.prototype.$type, 0));
	}

	, 
	_viewportRect: null,
	viewportRect: function (value) {
		if (arguments.length === 1) {
			this._viewportRect = value;
			return value;
		} else {
			return this._viewportRect;
		}
	}

	, 
	_windowRect: null,
	windowRect: function (value) {
		if (arguments.length === 1) {
			this._windowRect = value;
			return value;
		} else {
			return this._windowRect;
		}
	}

	, 
	_rangeInfos: null,
	rangeInfos: function (value) {
		if (arguments.length === 1) {
			this._rangeInfos = value;
			return value;
		} else {
			return this._rangeInfos;
		}
	}

	, 
	_currentRangeInfo: null,
	currentRangeInfo: function (value) {
		if (arguments.length === 1) {
			this._currentRangeInfo = value;
			return value;
		} else {
			return this._currentRangeInfo;
		}
	}

	, 
	_tickmarkValues: null,
	tickmarkValues: function (value) {
		if (arguments.length === 1) {
			this._tickmarkValues = value;
			return value;
		} else {
			return this._tickmarkValues;
		}
	}

	, 
	_strips: null,
	strips: function (value) {
		if (arguments.length === 1) {
			this._strips = value;
			return value;
		} else {
			return this._strips;
		}
	}

	, 
	_major: null,
	major: function (value) {
		if (arguments.length === 1) {
			this._major = value;
			return value;
		} else {
			return this._major;
		}
	}

	, 
	_minor: null,
	minor: function (value) {
		if (arguments.length === 1) {
			this._minor = value;
			return value;
		} else {
			return this._minor;
		}
	}

	, 
	_axisGeometry: null,
	axisGeometry: function (value) {
		if (arguments.length === 1) {
			this._axisGeometry = value;
			return value;
		} else {
			return this._axisGeometry;
		}
	}

	, 
	_actualMinimumValue: 0,
	actualMinimumValue: function (value) {
		if (arguments.length === 1) {
			this._actualMinimumValue = value;
			return value;
		} else {
			return this._actualMinimumValue;
		}
	}

	, 
	_actualMaximumValue: 0,
	actualMaximumValue: function (value) {
		if (arguments.length === 1) {
			this._actualMaximumValue = value;
			return value;
		} else {
			return this._actualMaximumValue;
		}
	}

	, 
	_crossingValue: 0,
	crossingValue: function (value) {
		if (arguments.length === 1) {
			this._crossingValue = value;
			return value;
		} else {
			return this._crossingValue;
		}
	}

	, 
	_relativeCrossingValue: 0,
	relativeCrossingValue: function (value) {
		if (arguments.length === 1) {
			this._relativeCrossingValue = value;
			return value;
		} else {
			return this._relativeCrossingValue;
		}
	}

	, 
	_label: null,
	label: function (value) {
		if (arguments.length === 1) {
			this._label = value;
			return value;
		} else {
			return this._label;
		}
	}

	, 
	_interval: 0,
	interval: function (value) {
		if (arguments.length === 1) {
			this._interval = value;
			return value;
		} else {
			return this._interval;
		}
	}

	, 
	_hasUserInterval: false,
	hasUserInterval: function (value) {
		if (arguments.length === 1) {
			this._hasUserInterval = value;
			return value;
		} else {
			return this._hasUserInterval;
		}
	}

	, 
	_hasUserMax: false,
	hasUserMax: function (value) {
		if (arguments.length === 1) {
			this._hasUserMax = value;
			return value;
		} else {
			return this._hasUserMax;
		}
	}

	, 
	_shouldRenderMinorLines: false,
	shouldRenderMinorLines: function (value) {
		if (arguments.length === 1) {
			this._shouldRenderMinorLines = value;
			return value;
		} else {
			return this._shouldRenderMinorLines;
		}
	}

	, 
	_currentRenderingInfo: null,
	currentRenderingInfo: function (value) {
		if (arguments.length === 1) {
			this._currentRenderingInfo = value;
			return value;
		} else {
			return this._currentRenderingInfo;
		}
	}

	, 
	_axisRenderingInfo: null,
	axisRenderingInfo: function (value) {
		if (arguments.length === 1) {
			this._axisRenderingInfo = value;
			return value;
		} else {
			return this._axisRenderingInfo;
		}
	}

	, 
	_majorRenderingInfo: null,
	majorRenderingInfo: function (value) {
		if (arguments.length === 1) {
			this._majorRenderingInfo = value;
			return value;
		} else {
			return this._majorRenderingInfo;
		}
	}

	, 
	_minorRenderingInfo: null,
	minorRenderingInfo: function (value) {
		if (arguments.length === 1) {
			this._minorRenderingInfo = value;
			return value;
		} else {
			return this._minorRenderingInfo;
		}
	}
	, 
	$type: new $.ig.Type('AxisRenderingParametersBase', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('CategoryAxisRenderingParameters', 'AxisRenderingParametersBase', {
	init: function () {


		$.ig.AxisRenderingParametersBase.prototype.init.call(this);

	}
	, 
	_count: 0,
	count: function (value) {
		if (arguments.length === 1) {
			this._count = value;
			return value;
		} else {
			return this._count;
		}
	}

	, 
	_categoryMode: 0,
	categoryMode: function (value) {
		if (arguments.length === 1) {
			this._categoryMode = value;
			return value;
		} else {
			return this._categoryMode;
		}
	}

	, 
	_wrapAround: false,
	wrapAround: function (value) {
		if (arguments.length === 1) {
			this._wrapAround = value;
			return value;
		} else {
			return this._wrapAround;
		}
	}

	, 
	_mode2GroupCount: 0,
	mode2GroupCount: function (value) {
		if (arguments.length === 1) {
			this._mode2GroupCount = value;
			return value;
		} else {
			return this._mode2GroupCount;
		}
	}

	, 
	_isInverted: false,
	isInverted: function (value) {
		if (arguments.length === 1) {
			this._isInverted = value;
			return value;
		} else {
			return this._isInverted;
		}
	}
	, 
	$type: new $.ig.Type('CategoryAxisRenderingParameters', $.ig.AxisRenderingParametersBase.prototype.$type)
}, true);

$.ig.util.defType('AxisRendererBase', 'Object', {
	init: function (labelManager) {



		var $self = this;
		$.ig.Object.prototype.init.call(this);
			this.clear(function () {
			});
			this.shouldRender(function (r1, r2) {
				return false;
			});
			this.onRendering(function () {
			});
			this.scaling(function (p, v) {
				return v;
			});
			this.strip(function (p, g, min, max) {
			});
			this.line(function (p, g, v) {
			});
			this.shouldRenderLines(function (p, v) {
				return false;
			});
			this.shouldRenderContent(function (p, v) {
				return $self.shouldRenderLines()(p, v);
			});
			this.axisLine(function (p) {
			});
			this.determineCrossingValue(function (p) {
			});
			this.shouldRenderLabel(function (p, v, last) {
				return false;
			});
			this.getLabelLocation(function (p, v) {
				return new $.ig.LabelPosition(v);
			});
			this.transformToLabelValue(function (p, v) {
				return v;
			});
			this.getLabelForItem(function (item) { return null; });
			this.snapMajorValue(function (p, v, i, interval) { return v; });
			this.adjustMajorValue(function (p, v, i, interval) { return v; });
			this.labelManager(labelManager);
			this.createRenderingParams(function (r1, r2) {
				return null;
			});
	}

	, 
	_clear: null,
	clear: function (value) {
		if (arguments.length === 1) {
			this._clear = value;
			return value;
		} else {
			return this._clear;
		}
	}

	, 
	_shouldRender: null,
	shouldRender: function (value) {
		if (arguments.length === 1) {
			this._shouldRender = value;
			return value;
		} else {
			return this._shouldRender;
		}
	}

	, 
	_onRendering: null,
	onRendering: function (value) {
		if (arguments.length === 1) {
			this._onRendering = value;
			return value;
		} else {
			return this._onRendering;
		}
	}

	, 
	_scaling: null,
	scaling: function (value) {
		if (arguments.length === 1) {
			this._scaling = value;
			return value;
		} else {
			return this._scaling;
		}
	}

	, 
	_strip: null,
	strip: function (value) {
		if (arguments.length === 1) {
			this._strip = value;
			return value;
		} else {
			return this._strip;
		}
	}

	, 
	_line: null,
	line: function (value) {
		if (arguments.length === 1) {
			this._line = value;
			return value;
		} else {
			return this._line;
		}
	}

	, 
	_shouldRenderLines: null,
	shouldRenderLines: function (value) {
		if (arguments.length === 1) {
			this._shouldRenderLines = value;
			return value;
		} else {
			return this._shouldRenderLines;
		}
	}

	, 
	_shouldRenderContent: null,
	shouldRenderContent: function (value) {
		if (arguments.length === 1) {
			this._shouldRenderContent = value;
			return value;
		} else {
			return this._shouldRenderContent;
		}
	}

	, 
	_axisLine: null,
	axisLine: function (value) {
		if (arguments.length === 1) {
			this._axisLine = value;
			return value;
		} else {
			return this._axisLine;
		}
	}

	, 
	_determineCrossingValue: null,
	determineCrossingValue: function (value) {
		if (arguments.length === 1) {
			this._determineCrossingValue = value;
			return value;
		} else {
			return this._determineCrossingValue;
		}
	}

	, 
	_shouldRenderLabel: null,
	shouldRenderLabel: function (value) {
		if (arguments.length === 1) {
			this._shouldRenderLabel = value;
			return value;
		} else {
			return this._shouldRenderLabel;
		}
	}

	, 
	_getLabelLocation: null,
	getLabelLocation: function (value) {
		if (arguments.length === 1) {
			this._getLabelLocation = value;
			return value;
		} else {
			return this._getLabelLocation;
		}
	}

	, 
	_transformToLabelValue: null,
	transformToLabelValue: function (value) {
		if (arguments.length === 1) {
			this._transformToLabelValue = value;
			return value;
		} else {
			return this._transformToLabelValue;
		}
	}

	, 
	_labelManager: null,
	labelManager: function (value) {
		if (arguments.length === 1) {
			this._labelManager = value;
			return value;
		} else {
			return this._labelManager;
		}
	}

	, 
	_getLabelForItem: null,
	getLabelForItem: function (value) {
		if (arguments.length === 1) {
			this._getLabelForItem = value;
			return value;
		} else {
			return this._getLabelForItem;
		}
	}

	, 
	_createRenderingParams: null,
	createRenderingParams: function (value) {
		if (arguments.length === 1) {
			this._createRenderingParams = value;
			return value;
		} else {
			return this._createRenderingParams;
		}
	}

	, 
	_snapMajorValue: null,
	snapMajorValue: function (value) {
		if (arguments.length === 1) {
			this._snapMajorValue = value;
			return value;
		} else {
			return this._snapMajorValue;
		}
	}

	, 
	_adjustMajorValue: null,
	adjustMajorValue: function (value) {
		if (arguments.length === 1) {
			this._adjustMajorValue = value;
			return value;
		} else {
			return this._adjustMajorValue;
		}
	}

	, 
	_getGroupCenter: null,
	getGroupCenter: function (value) {
		if (arguments.length === 1) {
			this._getGroupCenter = value;
			return value;
		} else {
			return this._getGroupCenter;
		}
	}

	, 
	_getUnscaledGroupCenter: null,
	getUnscaledGroupCenter: function (value) {
		if (arguments.length === 1) {
			this._getUnscaledGroupCenter = value;
			return value;
		} else {
			return this._getUnscaledGroupCenter;
		}
	}

	, 
	render: function (animate, viewportRect, windowRect) {
		var $self = this;
		$self.clearLabels(windowRect, viewportRect);
		if ($self.shouldRender()(viewportRect, windowRect)) {
			$self.onRendering()();
			var renderingParams = $self.createRenderingParams()(viewportRect, windowRect);
			$self.clearLabels(windowRect, viewportRect);
			if (renderingParams == null) {
				$self.resetLabels();
				return;
			}

			if (renderingParams.rangeInfos().count() > 1 && !renderingParams.hasUserInterval()) {
				$self.spreadInterval(renderingParams);
			}

			var en = renderingParams.rangeInfos().getEnumerator();
			while (en.moveNext()) {
				var range = en.current();
				renderingParams.currentRangeInfo(range);
				if ($.ig.util.isNaN(range.visibleMaximum()) || Number.isInfinity(range.visibleMaximum()) || $.ig.util.isNaN(range.visibleMinimum()) || Number.isInfinity(range.visibleMinimum())) {
					continue;
				}

				if (range.visibleMinimum() == range.visibleMaximum()) {
					continue;
				}

				$self.determineCrossingValue()(renderingParams);
				$self.labelManager().floatPanel(renderingParams.crossingValue());
				var mode = $.ig.CategoryMode.prototype.mode0;
				var mode2GroupCount = 0;
				var isInverted = false;
				var getUnscaledGroupCenter = function (n) { return n; };
				if ($self.getGroupCenter() != null) {
					getUnscaledGroupCenter = $self.getUnscaledGroupCenter();
				}

				if ($.ig.util.cast($.ig.CategoryAxisRenderingParameters.prototype.$type, renderingParams) !== null) {
					mode = (renderingParams).categoryMode();
					mode2GroupCount = (renderingParams).mode2GroupCount();
					isInverted = (renderingParams).isInverted();
				}

				renderingParams.tickmarkValues($self.getTickmarkValues(renderingParams));
				renderingParams.tickmarkValues().initialize((function () { var $ret = new $.ig.TickmarkValuesInitializationParameters();
				$ret.visibleMinimum(renderingParams.currentRangeInfo().visibleMinimum());
				$ret.visibleMaximum(renderingParams.currentRangeInfo().visibleMaximum());
				$ret.actualMinimum(renderingParams.actualMinimumValue());
				$ret.actualMaximum(renderingParams.actualMaximumValue());
				$ret.resolution(renderingParams.currentRangeInfo().resolution());
				$ret.hasUserInterval(renderingParams.hasUserInterval());
				$ret.userInterval(renderingParams.interval());
				$ret.intervalOverride(renderingParams.currentRangeInfo().intervalOverride());
				$ret.minorCountOverride(renderingParams.currentRangeInfo().minorCountOverride());
				$ret.mode(mode);
				$ret.mode2GroupCount(mode2GroupCount);
				$ret.window(renderingParams.windowRect());
				$ret.viewport(renderingParams.viewportRect());
				$ret.isInverted(isInverted);
				$ret.getUnscaledGroupCenter(getUnscaledGroupCenter); return $ret;}()));
				$self.renderInternal(renderingParams);
			}

			$self.renderLabels();
		}

	}

	, 
	resetLabels: function () {
		this.labelManager().resetLabels();
	}

	, 
	spreadInterval: function (renderingParams) {
		var $self = this;
		var maxInterval = -1.7976931348623157E+308;
		var maxMinorCount = -2147483648;
		var mode = $.ig.CategoryMode.prototype.mode0;
		var mode2GroupCount = 0;
		var isInverted = false;
		var getUnscaledGroupCenter = function (n) { return n; };
		if ($self.getGroupCenter() != null) {
			getUnscaledGroupCenter = $self.getUnscaledGroupCenter();
		}

		if ($.ig.util.cast($.ig.CategoryAxisRenderingParameters.prototype.$type, renderingParams) !== null) {
			mode = (renderingParams).categoryMode();
			mode2GroupCount = (renderingParams).mode2GroupCount();
			isInverted = (renderingParams).isInverted();
		}

		var en = renderingParams.rangeInfos().getEnumerator();
		while (en.moveNext()) {
			var rangeInfo = en.current();
			renderingParams.currentRangeInfo(rangeInfo);
			renderingParams.tickmarkValues().initialize((function () { var $ret = new $.ig.TickmarkValuesInitializationParameters();
			$ret.visibleMinimum(rangeInfo.visibleMinimum());
			$ret.visibleMaximum(rangeInfo.visibleMaximum());
			$ret.actualMinimum(renderingParams.actualMinimumValue());
			$ret.actualMaximum(renderingParams.actualMaximumValue());
			$ret.resolution(rangeInfo.resolution());
			$ret.hasUserInterval(renderingParams.hasUserInterval());
			$ret.userInterval(renderingParams.interval());
			$ret.intervalOverride(rangeInfo.intervalOverride());
			$ret.minorCountOverride(rangeInfo.minorCountOverride());
			$ret.mode(mode);
			$ret.mode2GroupCount(mode2GroupCount);
			$ret.window(renderingParams.windowRect());
			$ret.viewport(renderingParams.viewportRect());
			$ret.isInverted(isInverted);
			$ret.getUnscaledGroupCenter(getUnscaledGroupCenter); return $ret;}()));
			rangeInfo.intervalOverride(renderingParams.tickmarkValues().interval());
			rangeInfo.minorCountOverride(renderingParams.tickmarkValues().minorCount());
			if (!$.ig.util.isNaN(renderingParams.tickmarkValues().interval())) {
				maxInterval = Math.max(maxInterval, renderingParams.tickmarkValues().interval());
				maxMinorCount = Math.max(maxMinorCount, renderingParams.tickmarkValues().minorCount());
			}

		}

		var en1 = renderingParams.rangeInfos().getEnumerator();
		while (en1.moveNext()) {
			var rangeInfo1 = en1.current();
			if (rangeInfo1.intervalOverride() == maxInterval) {
				rangeInfo1.intervalOverride(-1);
				rangeInfo1.minorCountOverride(-1);

			} else {
				rangeInfo1.intervalOverride(maxInterval);
				rangeInfo1.minorCountOverride(maxMinorCount);
			}

		}

	}

	, 
	clearLabels: function (windowRect, viewportRect) {
		this.clear()();
		this.labelManager().clear(windowRect, viewportRect);
		this.labelManager().updateLabelPanel();
	}

	, 
	renderLabels: function () {
		this.labelManager().updateLabelPanel();
		if (this.labelManager().labelsHidden()) {
			this.labelManager().setTextBlockCount(0);

		} else {
			var textBlockCount = 0;
			var en = this.labelManager().labelDataContext().getEnumerator();
			while (en.moveNext()) {
				var labelObj = en.current();
				var label = $.ig.util.cast($.ig.FrameworkElement.prototype.$type, labelObj);
				if (label == null) {
					label = this.labelManager().getTextBlock(textBlockCount);
					(label).text(labelObj.toString());
					textBlockCount++;

				} else {
					this.labelManager().addLabel(label);
				}

			}

			this.labelManager().setTextBlockCount(textBlockCount);
		}

	}

	, 
	getTickmarkValues: function (renderingParams) {
		return renderingParams.tickmarkValues();
	}

	, 
	renderInternal: function (renderingParams) {
		var majorTicks = renderingParams.tickmarkValues().majorValuesArray();
		var minorTicks = renderingParams.tickmarkValues().minorValuesArray();
		this.labelManager().setLabelInterval(this.scaling()(renderingParams, renderingParams.tickmarkValues().interval()));
		this.axisLine()(renderingParams);
		for (var maj = 0; maj < majorTicks.length; maj++) {
			var absoluteIndex = renderingParams.tickmarkValues().firstIndex() + maj;
			var majorTick = majorTicks[maj];
			var unscaledValue = majorTick;
			var nextUnscaledValue = 0;
			if (maj < majorTicks.length - 1) {
				nextUnscaledValue = majorTicks[maj + 1];

			} else {
				nextUnscaledValue = Number.POSITIVE_INFINITY;
			}

			unscaledValue = this.snapMajorValue()(renderingParams, unscaledValue, absoluteIndex, renderingParams.tickmarkValues().interval());
			nextUnscaledValue = this.snapMajorValue()(renderingParams, nextUnscaledValue, absoluteIndex, renderingParams.tickmarkValues().interval());
			var majorValue = this.scaling()(renderingParams, unscaledValue);
			var nextMajorValue = this.scaling()(renderingParams, nextUnscaledValue);
			if (this.shouldRenderLines()(renderingParams, majorValue)) {
				if (absoluteIndex % 2 == 0 && this.shouldRenderContent()(renderingParams, nextMajorValue) && !Number.isInfinity(nextMajorValue)) {
					this.strip()(renderingParams, renderingParams.strips(), majorValue, nextMajorValue);
				}

				renderingParams.currentRenderingInfo(renderingParams.majorRenderingInfo());
				this.line()(renderingParams, renderingParams.major(), majorValue);
				renderingParams.currentRenderingInfo(null);
			}

			majorValue = this.adjustMajorValue()(renderingParams, majorValue, absoluteIndex, renderingParams.tickmarkValues().interval());
			if (!$.ig.util.isNaN(majorValue) && !Number.isInfinity(majorValue) && this.shouldRenderLabel()(renderingParams, majorValue, maj == majorTicks.length - 1)) {
				var label = this.getLabel(renderingParams, unscaledValue, absoluteIndex, renderingParams.tickmarkValues().interval());
				if (label != null) {
					this.labelManager().addLabelObject(label, this.getLabelLocation()(renderingParams, majorValue));
				}

			}

		}

		if (renderingParams.shouldRenderMinorLines()) {
			for (var min = 0; min < minorTicks.length; min++) {
				var minorTick = minorTicks[min];
				var minorValue = this.scaling()(renderingParams, minorTick);
				renderingParams.currentRenderingInfo(renderingParams.minorRenderingInfo());
				this.line()(renderingParams, renderingParams.minor(), minorValue);
				renderingParams.currentRenderingInfo(null);
			}

		}

	}

	, 
	getLabel: function (renderingParams, unscaledValue, index, interval) {
		return null;
	}
	, 
	$type: new $.ig.Type('AxisRendererBase', $.ig.Object.prototype.$type)
}, true);


$.ig.util.defType('CategoryXAxis', 'CategoryAxisBase', {

	createView: function () {
		return new $.ig.CategoryXAxisView(this);
	}

	, 
	onViewCreated: function (view) {
		$.ig.CategoryAxisBase.prototype.onViewCreated.call(this, view);
		this.xView(view);
	}

	, 
	_xView: null,
	xView: function (value) {
		if (arguments.length === 1) {
			this._xView = value;
			return value;
		} else {
			return this._xView;
		}
	}
	, 
	init: function () {


		this.__actualMinimum = 1;
		this.__actualMaximum = 1;

		$.ig.CategoryAxisBase.prototype.init.call(this);
			this.majorLinePositions(new $.ig.List$1(Number, 0));
			this.defaultStyleKey($.ig.CategoryXAxis.prototype.$type);
	}
	, 
	__actualMinimum: 0

	, 
	actualMinimum: function (value) {
		if (arguments.length === 1) {

			this.__actualMinimum = value;
			return value;
		} else {

			return this.__actualMinimum;
		}
	}
	, 
	__actualMaximum: 0

	, 
	actualMaximum: function (value) {
		if (arguments.length === 1) {

			this.__actualMaximum = value;
			return value;
		} else {

			return this.__actualMaximum;
		}
	}

	, 
	createLabelPanel: function () {
		if (this.useSmartAxis()) {
			return new $.ig.SmartAxisLabelPanel();

		} else {
			return new $.ig.HorizontalAxisLabelPanel();
		}

	}

	, 
	getCategorySize: function (windowRect, viewportRect) {
		return viewportRect.width() / (this._cachedItemsCount * windowRect.width());
	}

	, 
	getGroupSize: function (windowRect, viewportRect) {
		var gap = !$.ig.util.isNaN(this.gap()) ? $.ig.MathUtil.prototype.clamp(this.gap(), 0, 1) : 0;
		var overlap = 0;
		if (!$.ig.util.isNaN(this.overlap())) {
			overlap = Math.min(this.overlap(), 1);

		} else {
			overlap = 0;
		}

		;var categorySpace = 1 - 0.5 * gap;
		var mode2GroupCount = this.mode2GroupCount() == 0 ? 1 : this.mode2GroupCount();
		var ret = this.getCategorySize(windowRect, viewportRect) * categorySpace / (mode2GroupCount - (mode2GroupCount - 1) * overlap);
		return ret;
	}

	, 
	getGroupCenter: function (groupIndex, windowRect, viewportRect) {
		var groupCenter = 0.5;
		if (this.mode2GroupCount() > 1) {
			var gap = !$.ig.util.isNaN(this.gap()) ? $.ig.MathUtil.prototype.clamp(this.gap(), 0, 1) : 0;
			var overlap = 0;
			if (!$.ig.util.isNaN(this.overlap())) {
				overlap = Math.min(this.overlap(), 1);
			}

			var categorySpace = 1 - 0.5 * gap;
			var groupWidth = categorySpace / (this.mode2GroupCount() - (this.mode2GroupCount() - 1) * overlap);
			var groupSep = (categorySpace - groupWidth) / (this.mode2GroupCount() - 1);
			groupCenter = 0.25 * gap + 0.5 * groupWidth + groupIndex * groupSep;
		}

		return this.getCategorySize(windowRect, viewportRect) * groupCenter;
	}

	, 
	scrollIntoView: function (item) {
		var windowRect = this.seriesViewer() != null ? this.seriesViewer().actualWindowRect() : $.ig.Rect.prototype.empty();
		var viewportRect = this.viewportRect();
		var unitRect = new $.ig.Rect(0, 0, 0, 1, 1);
		var xParams = new $.ig.ScalerParams(unitRect, unitRect, this.isInverted());
		var index = !windowRect.isEmpty() && !viewportRect.isEmpty() && this.fastItemsSource() != null ? this.fastItemsSource().indexOf(item) : -1;
		var cx = index > -1 ? this.getScaledValue(index, xParams) : NaN;
		if (!$.ig.util.isNaN(cx) && this.seriesViewer().isSyncReady()) {
			if (!$.ig.util.isNaN(cx)) {
				if (cx < windowRect.left() + 0.1 * windowRect.width()) {
					cx = cx + 0.4 * windowRect.width();
					windowRect.x(cx - 0.5 * windowRect.width());
				}

				if (cx > windowRect.right() - 0.1 * windowRect.width()) {
					cx = cx - 0.4 * windowRect.width();
					windowRect.x(cx - 0.5 * windowRect.width());
				}

			}

			this.seriesViewer().windowNotify(windowRect);
		}

	}

	, 
	getScaledValue: function (unscaledValue, p) {
		var itemCount = this.categoryMode() == $.ig.CategoryMode.prototype.mode0 ? this._cachedItemsCount - 1 : this._cachedItemsCount;
		if (itemCount < 0) {
			itemCount = 0;
		}

		var scaledValue = itemCount >= 1 ? (unscaledValue) / (itemCount) : itemCount == 0 ? 0.5 : NaN;
		if (this.isInvertedCached()) {
			scaledValue = 1 - scaledValue;
		}

		return p._viewportRect.left() + p._viewportRect.width() * (scaledValue - p._windowRect.left()) / p._windowRect.width();
	}

	, 
	getUnscaledValue: function (scaledValue, p) {
		return this.getUnscaledValue2(scaledValue, p._windowRect, p._viewportRect, this.categoryMode());
	}

	, 
	getUnscaledValue2: function (scaledValue, windowRect, viewportRect, categoryMode) {
		var unscaledValue = windowRect.left() + (scaledValue - viewportRect.left()) * windowRect.width() / viewportRect.width();
		if (this.isInvertedCached()) {
			unscaledValue = 1 - unscaledValue;
		}

		var itemCount = categoryMode == $.ig.CategoryMode.prototype.mode0 ? this._cachedItemsCount - 1 : this._cachedItemsCount;
		if (itemCount < 0) {
			itemCount = 0;
		}

		return unscaledValue * itemCount;
	}

	, 
	renderAxisOverride: function (animate) {
		$.ig.CategoryAxisBase.prototype.renderAxisOverride.call(this, animate);
		var windowRect = this.seriesViewer() != null ? this.seriesViewer().actualWindowRect() : $.ig.Rect.prototype.empty();
		var viewportRect = this.viewportRect();
		var xParams = new $.ig.ScalerParams(windowRect, viewportRect, this.isInverted());
		var axisGeometry = this.view().getAxisLinesGeometry();
		var stripsGeometry = this.view().getStripsGeometry();
		var majorGeometry = this.view().getMajorLinesGeometry();
		var minorGeometry = this.view().getMinorLinesGeometry();
		var axisLinesPathInfo = this.view().getAxisLinesPathInfo();
		var majorLinesPathInfo = this.view().getMajorLinesPathInfo();
		var minorLinesPathInfo = this.view().getMinorLinesPathInfo();
		var fastItemsSource = this.fastItemsSource();
		this.updateLineVisibility();
		this.clearMarks(axisGeometry);
		this.clearMarks(stripsGeometry);
		this.clearMarks(majorGeometry);
		this.clearMarks(minorGeometry);
		this.labelDataContext().clear();
		this.labelPositions().clear();
		this.majorLinePositions().clear();
		this.view().updateLabelPanel(this, windowRect, viewportRect);
		if (windowRect.isEmpty() || viewportRect.isEmpty()) {
			this.textBlocks().count(0);
		}

		if (this.textBlocks().count() == 0) {
			this.view().clearLabelPanel();
		}

		if (this.labelSettings() != null) {
			this.labelSettings().registerAxis(this);
		}

		if (this.itemsSource() == null || fastItemsSource == null || fastItemsSource.count() == 0) {
		return;
		}

		if (!windowRect.isEmpty() && !viewportRect.isEmpty()) {
			var visibleMinimum = this.getUnscaledValue(viewportRect.left(), xParams);
			var visibleMaximum = this.getUnscaledValue(viewportRect.right(), xParams);
			if (this.isInverted()) {
				visibleMinimum = Math.ceil(visibleMinimum);
				visibleMaximum = Math.floor(visibleMaximum);

			} else {
				visibleMinimum = Math.floor(visibleMinimum);
				visibleMaximum = Math.ceil(visibleMaximum);
			}

			var crossingValue = viewportRect.bottom();
			var relativeCrossingValue = crossingValue - viewportRect.top();
			if (this.crossingAxis() != null) {
				var yAxis = $.ig.util.cast($.ig.NumericYAxis.prototype.$type, this.crossingAxis());
				if (yAxis != null) {
					var yParams = new $.ig.ScalerParams(windowRect, viewportRect, yAxis.isInverted());
					crossingValue = this.crossingValue();
					crossingValue = yAxis.getScaledValue(crossingValue, yParams);
					relativeCrossingValue = crossingValue - viewportRect.top();
					if (crossingValue < viewportRect.top()) {
						crossingValue = viewportRect.top();

					} else if (crossingValue > viewportRect.bottom()) {
						crossingValue = viewportRect.bottom();
					}


					if (relativeCrossingValue < 0) {
						relativeCrossingValue = 0;

					} else if (relativeCrossingValue > viewportRect.height()) {
						relativeCrossingValue = viewportRect.height();
					}


				}

			}

			this.horizontalLine(axisGeometry, crossingValue, viewportRect, axisLinesPathInfo);
			this.view().setLabelPanelCrossingValue(relativeCrossingValue);
			var trueVisibleMinimum = Math.min(visibleMinimum, visibleMaximum);
			var trueVisibleMaximum = Math.max(visibleMinimum, visibleMaximum);
			var snapper = new $.ig.LinearCategorySnapper(1, trueVisibleMinimum, trueVisibleMaximum, viewportRect.width(), this.interval(), this.categoryMode());
			var firstValue = Math.floor((trueVisibleMinimum - 0) / snapper.interval());
			var lastValue = Math.ceil((trueVisibleMaximum - 0) / snapper.interval());
			if (!$.ig.util.isNaN(firstValue) && !$.ig.util.isNaN(lastValue)) {
				var first = $.ig.truncate(firstValue);
				var last = $.ig.truncate(lastValue);
				var majorValue = this.getScaledValue(0 + first * snapper.interval(), xParams);
				this.view().setLabelPanelInterval(this.getScaledValue(snapper.interval(), xParams));
				var viewportPixelRight = $.ig.truncate(Math.ceil(viewportRect.right()));
				var viewportPixelLeft = $.ig.truncate(Math.floor(viewportRect.left()));
				for (var i = first; i <= last; ++i) {
					var nextMajorValue = this.getScaledValue(0 + (i + 1) * snapper.interval(), xParams);
					if (majorValue <= viewportRect.right()) {
						if (i % 2 == 0) {
							this.verticalStrip(stripsGeometry, majorValue, nextMajorValue, viewportRect);
						}

						this.verticalLine(majorGeometry, majorValue, viewportRect, majorLinesPathInfo);
						this.majorLinePositions().add(majorValue);
						if (this.categoryMode() != $.ig.CategoryMode.prototype.mode0 && this.mode2GroupCount() != 0 && this.shouldRenderMinorLines()) {
							for (var categoryNumber = 0; categoryNumber < $.ig.truncate(snapper.interval()); categoryNumber++) {
								for (var groupNumber = 0; groupNumber < this.mode2GroupCount(); groupNumber++) {
									var center = this.getGroupCenter(groupNumber, windowRect, viewportRect);
									if (this.isInverted()) {
									center = -center;
									}

									var minorValue = this.getScaledValue(categoryNumber + i * snapper.interval(), xParams) + center;
									this.verticalLine(minorGeometry, minorValue, viewportRect, minorLinesPathInfo);
								}

							}

						}

					}

					var categoryValue = majorValue;
					if (this.categoryMode() != $.ig.CategoryMode.prototype.mode0) {
						var nextCategoryValue = this.getScaledValue(i * snapper.interval() + 1, xParams);
						categoryValue = (majorValue + nextCategoryValue) / 2;
					}

					var categoryPixelValue = $.ig.truncate(Math.round(categoryValue));
					if (categoryPixelValue >= viewportPixelLeft && categoryPixelValue <= viewportPixelRight) {
						var itemIndex = 0;
						if (snapper.interval() >= 1) {
							itemIndex = i * $.ig.truncate(Math.floor(snapper.interval()));

						} else {
							if ((i * snapper.interval()) * 2 % 2 == 0) {
								itemIndex = $.ig.truncate(Math.floor(i * snapper.interval()));

							} else {
								itemIndex = -1;
							}

						}

						if (fastItemsSource != null && itemIndex < fastItemsSource.count() && itemIndex >= 0) {
							var dataItem = fastItemsSource.item(itemIndex);
							var labelText = this.getLabel(dataItem);
							if (!$.ig.util.isNaN(categoryValue) && !Number.isInfinity(categoryValue) && labelText != null) {
								if (($.ig.util.cast(String, labelText) !== null || typeof labelText === "string") && (labelText).equals("")) {

								} else {
									this.labelDataContext().add1(labelText);
									this.labelPositions().add(new $.ig.LabelPosition(categoryValue));
								}

							}

						}

					}

					majorValue = nextMajorValue;
				}

			}

			if ((this.labelSettings() == null || this.labelSettings().visibility() == $.ig.Visibility.prototype.visible) && this.crossingAxis() != null) {
				if (this.labelSettings() != null && (this.labelSettings().location() == $.ig.AxisLabelsLocation.prototype.insideTop || this.labelSettings().location() == $.ig.AxisLabelsLocation.prototype.insideBottom)) {
					this.seriesViewer().invalidatePanels();
				}

			}

			this.view().updateLabelPanelContent(this.labelDataContext(), this.labelPositions());
			this.renderLabels();
		}

	}

	, 
	updateRangeOverride: function () {
		if (this.fastItemsSource() == null) {
			return false;
		}

		var max = this.fastItemsSource().count();
		if (max != this.actualMaximum()) {
			var ea = new $.ig.AxisRangeChangedEventArgs(1, 1, this.actualMaximum(), max);
			this.actualMaximum(max);
			this.raiseRangeChanged(ea);
			return true;
		}

		return false;
	}

	, 
	interval: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.CategoryXAxis.prototype.intervalProperty, value);
			return value;
		} else {

			return this.getValue($.ig.CategoryXAxis.prototype.intervalProperty);
		}
	}

	, 
	shouldShareMode: function (chart) {
		if (chart == null) {
			return false;
		}

		var settings = this.getSyncSettings();
		if (settings == null) {
			return false;
		}

		return settings.synchronizeHorizontally();
	}

	, 
	orientation: function () {

			return $.ig.AxisOrientation.prototype.horizontal;
	}
	, 
	$type: new $.ig.Type('CategoryXAxis', $.ig.CategoryAxisBase.prototype.$type)
}, true);

$.ig.util.defType('CategoryXAxisView', 'CategoryAxisBaseView', {

	_xModel: null,
	xModel: function (value) {
		if (arguments.length === 1) {
			this._xModel = value;
			return value;
		} else {
			return this._xModel;
		}
	}
	, 
	init: function (model) {



		$.ig.CategoryAxisBaseView.prototype.init.call(this, model);
			this.xModel(model);
	}
	, 
	$type: new $.ig.Type('CategoryXAxisView', $.ig.CategoryAxisBaseView.prototype.$type)
}, true);

$.ig.util.defType('CategoryYAxis', 'CategoryAxisBase', {

	createView: function () {
		return new $.ig.CategoryYAxisView(this);
	}

	, 
	onViewCreated: function (view) {
		$.ig.CategoryAxisBase.prototype.onViewCreated.call(this, view);
		this.yView(view);
	}

	, 
	_yView: null,
	yView: function (value) {
		if (arguments.length === 1) {
			this._yView = value;
			return value;
		} else {
			return this._yView;
		}
	}

	, 
	isVertical: function () {

			return true;
	}

	, 
	getCategoryBoundingBox: function (point, useInterpolation, singularWidth) {
		return this.getCategoryBoundingBoxHelper(point, useInterpolation, singularWidth, true);
	}
	, 
	init: function () {


		this.__actualMinimum = 1;
		this.__actualMaximum = 1;

		$.ig.CategoryAxisBase.prototype.init.call(this);
			this.majorLinePositions(new $.ig.List$1(Number, 0));
			this.defaultStyleKey($.ig.CategoryYAxis.prototype.$type);
	}

	, 
	interval: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.CategoryYAxis.prototype.intervalProperty, value);
			return value;
		} else {

			return this.getValue($.ig.CategoryYAxis.prototype.intervalProperty);
		}
	}
	, 
	__actualMinimum: 0

	, 
	actualMinimum: function (value) {
		if (arguments.length === 1) {

			this.__actualMinimum = value;
			return value;
		} else {

			return this.__actualMinimum;
		}
	}
	, 
	__actualMaximum: 0

	, 
	actualMaximum: function (value) {
		if (arguments.length === 1) {

			this.__actualMaximum = value;
			return value;
		} else {

			return this.__actualMaximum;
		}
	}

	, 
	getScaledValue: function (unscaledValue, p) {
		var itemCount = this.categoryMode() == $.ig.CategoryMode.prototype.mode0 ? this._cachedItemsCount - 1 : this._cachedItemsCount;
		if (itemCount < 0) {
			itemCount = 0;
		}

		var scaledValue = itemCount >= 1 ? (unscaledValue) / (itemCount) : itemCount == 0 ? 0.5 : NaN;
		if (!this.isInvertedCached()) {
			scaledValue = 1 - scaledValue;
		}

		return p._viewportRect.top() + p._viewportRect.height() * (scaledValue - p._windowRect.top()) / p._windowRect.height();
	}

	, 
	getUnscaledValue: function (scaledValue, p) {
		return this.getUnscaledValue2(scaledValue, p._windowRect, p._viewportRect, this.categoryMode());
	}

	, 
	getUnscaledValue2: function (scaledValue, windowRect, viewportRect, categoryMode) {
		var unscaledValue = windowRect.top() + (scaledValue - viewportRect.top()) * windowRect.height() / viewportRect.height();
		if (!this.isInvertedCached()) {
			unscaledValue = 1 - unscaledValue;
		}

		var itemCount = categoryMode == $.ig.CategoryMode.prototype.mode0 ? this._cachedItemsCount - 1 : this._cachedItemsCount;
		if (itemCount < 0) {
			itemCount = 0;
		}

		return unscaledValue * itemCount;
	}

	, 
	createLabelPanel: function () {
		return new $.ig.VerticalAxisLabelPanel();
	}

	, 
	getCategorySize: function (windowRect, viewportRect) {
		return viewportRect.height() / (this._cachedItemsCount * windowRect.height());
	}

	, 
	getGroupSize: function (windowRect, viewportRect) {
		var gap = 0;
		if (!$.ig.util.isNaN(this.gap())) {
			gap = $.ig.MathUtil.prototype.clamp(this.gap(), 0, 1);
		}

		var overlap = 0;
		if (!$.ig.util.isNaN(this.overlap())) {
			overlap = Math.min(this.overlap(), 1);
		}

		var categorySpace = 1 - 0.5 * gap;
		var ret = this.getCategorySize(windowRect, viewportRect) * categorySpace / (this.mode2GroupCount() - (this.mode2GroupCount() - 1) * overlap);
		return ret;
	}

	, 
	getGroupCenter: function (groupIndex, windowRect, viewportRect) {
		var groupCenter = 0.5;
		if (this.mode2GroupCount() > 1) {
			var gap = 0;
			if (!$.ig.util.isNaN(this.gap())) {
				gap = $.ig.MathUtil.prototype.clamp(this.gap(), 0, 1);
			}

			var overlap = 0;
			if (!$.ig.util.isNaN(this.overlap())) {
				overlap = Math.min(this.overlap(), 1);
			}

			var categorySpace = 1 - 0.5 * gap;
			var groupWidth = categorySpace / (this.mode2GroupCount() - (this.mode2GroupCount() - 1) * overlap);
			var groupSep = (categorySpace - groupWidth) / (this.mode2GroupCount() - 1);
			groupCenter = 0.25 * gap + 0.5 * groupWidth + groupIndex * groupSep;
		}

		return this.getCategorySize(windowRect, viewportRect) * groupCenter;
	}

	, 
	scrollIntoView: function (item) {
		var windowRect = this.seriesViewer() != null ? this.seriesViewer().actualWindowRect() : $.ig.Rect.prototype.empty();
		var viewportRect = this.viewportRect();
		var unitRect = new $.ig.Rect(0, 0, 0, 1, 1);
		var yParams = new $.ig.ScalerParams(unitRect, unitRect, this.isInverted());
		var index = !windowRect.isEmpty() && !viewportRect.isEmpty() && this.fastItemsSource() != null ? this.fastItemsSource().indexOf(item) : -1;
		var cy = index > -1 ? this.getScaledValue(index, yParams) : NaN;
		if (!$.ig.util.isNaN(cy) && this.seriesViewer().isSyncReady()) {
			if (!$.ig.util.isNaN(cy)) {
				if (cy < windowRect.top() + 0.1 * windowRect.height()) {
					cy = cy + 0.4 * windowRect.height();
					windowRect.y(cy - 0.5 * windowRect.height());
				}

				if (cy > windowRect.bottom() - 0.1 * windowRect.height()) {
					cy = cy - 0.4 * windowRect.height();
					windowRect.y(cy - 0.5 * windowRect.height());
				}

			}

			this.seriesViewer().windowNotify(windowRect);
		}

	}

	, 
	updateRangeOverride: function () {
		if (this.fastItemsSource() == null) {
			return false;
		}

		var max = this.fastItemsSource().count();
		if (max != this.actualMaximum()) {
			var ea = new $.ig.AxisRangeChangedEventArgs(1, 1, this.actualMaximum(), max);
			this.actualMaximum(max);
			this.raiseRangeChanged(ea);
			return true;
		}

		return false;
	}

	, 
	shouldShareMode: function (chart) {
		if (chart == null) {
			return false;
		}

		var settings = this.getSyncSettings();
		if (settings == null) {
			return false;
		}

		return settings.synchronizeVertically();
	}

	, 
	renderAxisOverride: function (animate) {
		$.ig.CategoryAxisBase.prototype.renderAxisOverride.call(this, animate);
		var windowRect = this.seriesViewer() != null ? this.seriesViewer().actualWindowRect() : $.ig.Rect.prototype.empty();
		var viewportRect = this.viewportRect();
		var yParams = new $.ig.ScalerParams(windowRect, viewportRect, this.isInverted());
		var axisGeometry = this.view().getAxisLinesGeometry();
		var stripsGeometry = this.view().getStripsGeometry();
		var majorGeometry = this.view().getMajorLinesGeometry();
		var minorGeometry = this.view().getMinorLinesGeometry();
		var axisLinesPathInfo = this.view().getAxisLinesPathInfo();
		var majorLinesPathInfo = this.view().getMajorLinesPathInfo();
		var minorLinesPathInfo = this.view().getMinorLinesPathInfo();
		this.updateLineVisibility();
		this.clearMarks(axisGeometry);
		this.clearMarks(stripsGeometry);
		this.clearMarks(majorGeometry);
		this.clearMarks(minorGeometry);
		this.labelDataContext().clear();
		this.labelPositions().clear();
		this.majorLinePositions().clear();
		this.view().updateLabelPanel(this, windowRect, viewportRect);
		if (windowRect.isEmpty() || viewportRect.isEmpty()) {
			this.textBlocks().count(0);
		}

		if (this.textBlocks().count() == 0) {
			this.view().clearLabelPanel();
		}

		if (this.labelSettings() != null) {
			this.labelSettings().registerAxis(this);
		}

		if (this.itemsSource() == null || this.fastItemsSource() == null || this.fastItemsSource().count() == 0) {
		return;
		}

		if (!windowRect.isEmpty() && !viewportRect.isEmpty()) {
			var visibleMinimum = this.getUnscaledValue(viewportRect.top(), yParams);
			var visibleMaximum = this.getUnscaledValue(viewportRect.bottom(), yParams);
			if (!this.isInverted()) {
				visibleMinimum = Math.ceil(visibleMinimum);
				visibleMaximum = Math.floor(visibleMaximum);

			} else {
				visibleMinimum = Math.floor(visibleMinimum);
				visibleMaximum = Math.ceil(visibleMaximum);
			}

			var crossingValue = viewportRect.left();
			var relativeCrossingValue = 0;
			if (this.crossingAxis() != null) {
				var xAxis = $.ig.util.cast($.ig.NumericXAxis.prototype.$type, this.crossingAxis());
				if (xAxis != null) {
					var xParams = new $.ig.ScalerParams(windowRect, viewportRect, xAxis.isInverted());
					crossingValue = this.crossingValue();
					crossingValue = xAxis.getScaledValue(crossingValue, xParams);
					relativeCrossingValue = crossingValue - viewportRect.left();
					if (crossingValue < viewportRect.left()) {
						crossingValue = viewportRect.left();

					} else if (crossingValue > viewportRect.right()) {
						crossingValue = viewportRect.right();
					}


					if (relativeCrossingValue < 0) {
						relativeCrossingValue = 0;

					} else if (relativeCrossingValue > viewportRect.width()) {
						relativeCrossingValue = viewportRect.width();
					}


				}

			}

			this.verticalLine(axisGeometry, crossingValue, viewportRect, axisLinesPathInfo);
			this.view().setLabelPanelCrossingValue(relativeCrossingValue);
			var trueVisibleMinimum = Math.min(visibleMinimum, visibleMaximum);
			var trueVisibleMaximum = Math.max(visibleMinimum, visibleMaximum);
			var snapper = new $.ig.LinearCategorySnapper(1, trueVisibleMinimum, trueVisibleMaximum, viewportRect.height(), this.interval(), this.categoryMode());
			var firstValue = Math.floor((trueVisibleMinimum - 0) / snapper.interval());
			var lastValue = Math.ceil((trueVisibleMaximum - 0) / snapper.interval());
			if (!$.ig.util.isNaN(firstValue) && !$.ig.util.isNaN(lastValue)) {
				var first = $.ig.truncate(firstValue);
				var last = $.ig.truncate(lastValue);
				var majorValue = this.getScaledValue(0 + first * snapper.interval(), yParams);
				this.labelPanel().interval(this.getScaledValue(snapper.interval(), yParams));
				for (var i = first; i <= last; ++i) {
					var nextMajorValue = this.getScaledValue(0 + (i + 1) * snapper.interval(), yParams);
					if (majorValue <= viewportRect.bottom()) {
						if (i % 2 == 0) {
							this.horizontalStrip(stripsGeometry, majorValue, nextMajorValue, viewportRect);
						}

						this.horizontalLine(majorGeometry, majorValue, viewportRect, majorLinesPathInfo);
						this.majorLinePositions().add(majorValue);
						if (this.categoryMode() != $.ig.CategoryMode.prototype.mode0 && this.mode2GroupCount() != 0 && this.shouldRenderMinorLines()) {
							for (var categoryNumber = 0; categoryNumber < $.ig.truncate(snapper.interval()); categoryNumber++) {
								for (var groupNumber = 0; groupNumber < this.mode2GroupCount(); groupNumber++) {
									var center = this.getGroupCenter(groupNumber, windowRect, viewportRect);
									if (!this.isInverted()) {
									center = -center;
									}

									var minorValue = this.getScaledValue(categoryNumber + i * snapper.interval(), yParams) + center;
									this.horizontalLine(minorGeometry, minorValue, viewportRect, minorLinesPathInfo);
								}

							}

						}

					}

					var categoryValue = majorValue;
					if (this.categoryMode() != $.ig.CategoryMode.prototype.mode0) {
						var nextCategoryValue = this.getScaledValue(i * snapper.interval() + 1, yParams);
						categoryValue = (majorValue + nextCategoryValue) / 2;
					}

					if (categoryValue <= viewportRect.bottom() && categoryValue >= viewportRect.top()) {
						var itemIndex = 0;
						if (snapper.interval() >= 1) {
							itemIndex = i * $.ig.truncate(Math.floor(snapper.interval()));

						} else {
							if ((i * snapper.interval()) * 2 % 2 == 0) {
								itemIndex = $.ig.truncate(Math.floor(i * snapper.interval()));

							} else {
								itemIndex = -1;
							}

						}

						if (this.fastItemsSource() != null && itemIndex < this.fastItemsSource().count() && itemIndex >= 0) {
							var dataItem = this.fastItemsSource().item(itemIndex);
							var labelText = this.getLabel(dataItem);
							if (!$.ig.util.isNaN(categoryValue) && !Number.isInfinity(categoryValue) && labelText != null) {
								if (($.ig.util.cast(String, labelText) !== null || typeof labelText === "string") && (labelText).equals("")) {

								} else {
									this.labelDataContext().add1(labelText);
									this.labelPositions().add(new $.ig.LabelPosition(categoryValue));
								}

							}

						}

					}

					majorValue = nextMajorValue;
				}

			}

			if ((this.labelSettings() == null || this.labelSettings().visibility() == $.ig.Visibility.prototype.visible) && this.crossingAxis() != null) {
				if (this.labelSettings() != null && (this.labelSettings().location() == $.ig.AxisLabelsLocation.prototype.insideLeft || this.labelSettings().location() == $.ig.AxisLabelsLocation.prototype.insideRight)) {
					this.seriesViewer().invalidatePanels();
				}

			}

			this.view().updateLabelPanelContent(this.labelDataContext(), this.labelPositions());
			this.renderLabels();
		}

	}

	, 
	orientation: function () {

			return $.ig.AxisOrientation.prototype.vertical;
	}
	, 
	$type: new $.ig.Type('CategoryYAxis', $.ig.CategoryAxisBase.prototype.$type)
}, true);

$.ig.util.defType('CategoryYAxisView', 'CategoryAxisBaseView', {

	_yModel: null,
	yModel: function (value) {
		if (arguments.length === 1) {
			this._yModel = value;
			return value;
		} else {
			return this._yModel;
		}
	}
	, 
	init: function (model) {



		$.ig.CategoryAxisBaseView.prototype.init.call(this, model);
			this.yModel(model);
	}
	, 
	$type: new $.ig.Type('CategoryYAxisView', $.ig.CategoryAxisBaseView.prototype.$type)
}, true);




$.ig.util.defType('NumericAxisBase', 'Axis', {

	createView: function () {
		return new $.ig.NumericAxisBaseView(this);
	}

	, 
	onViewCreated: function (view) {
		$.ig.Axis.prototype.onViewCreated.call(this, view);
		this.numericView(view);
	}

	, 
	_numericView: null,
	numericView: function (value) {
		if (arguments.length === 1) {
			this._numericView = value;
			return value;
		} else {
			return this._numericView;
		}
	}

	, 
	isNumeric: function () {

			return true;
	}
	, 
	init: function () {



		$.ig.Axis.prototype.init.call(this);
			this.logarithmBaseCached(10);
	}

	, 
	minimumValue: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.NumericAxisBase.prototype.minimumValueProperty, value);
			return value;
		} else {

			return this.getValue($.ig.NumericAxisBase.prototype.minimumValueProperty);
		}
	}

	, 
	actualMinimumValue: function (value) {
		if (arguments.length === 1) {

			if (this.actualMinimumValue() != value) {
				var oldValue = this._actualMinimumValue;
				this._actualMinimumValue = value;
				this.logActualMinimumValue(Math.log(this.actualMinimumValue()));
				this.raisePropertyChanged($.ig.NumericAxisBase.prototype.actualMinimumValuePropertyName, oldValue, this.actualMinimumValue());
			}

			return value;
		} else {

			return this._actualMinimumValue;
		}
	}
	, 
	_actualMinimumValue: 0

	, 
	_logActualMinimumValue: 0,
	logActualMinimumValue: function (value) {
		if (arguments.length === 1) {
			this._logActualMinimumValue = value;
			return value;
		} else {
			return this._logActualMinimumValue;
		}
	}

	, 
	maximumValue: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.NumericAxisBase.prototype.maximumValueProperty, value);
			return value;
		} else {

			return this.getValue($.ig.NumericAxisBase.prototype.maximumValueProperty);
		}
	}

	, 
	actualMaximumValue: function (value) {
		if (arguments.length === 1) {

			if (this.actualMaximumValue() != value) {
				var oldValue = this._actualMaximumValue;
				this._actualMaximumValue = value;
				this.logActualMaximumValue(Math.log(this.actualMaximumValue()));
				this.raisePropertyChanged($.ig.NumericAxisBase.prototype.actualMaximumValuePropertyName, oldValue, this.actualMaximumValue());
			}

			return value;
		} else {

			return this._actualMaximumValue;
		}
	}
	, 
	_actualMaximumValue: 0

	, 
	_logActualMaximumValue: 0,
	logActualMaximumValue: function (value) {
		if (arguments.length === 1) {
			this._logActualMaximumValue = value;
			return value;
		} else {
			return this._logActualMaximumValue;
		}
	}

	, 
	interval: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.NumericAxisBase.prototype.intervalProperty, value);
			return value;
		} else {

			return this.getValue($.ig.NumericAxisBase.prototype.intervalProperty);
		}
	}

	, 
	referenceValue: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.NumericAxisBase.prototype.referenceValueProperty, value);
			return value;
		} else {

			return this.getValue($.ig.NumericAxisBase.prototype.referenceValueProperty);
		}
	}

	, 
	isLogarithmic: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.NumericAxisBase.prototype.isLogarithmicProperty, value);
			return value;
		} else {

			return this.getValue($.ig.NumericAxisBase.prototype.isLogarithmicProperty);
		}
	}
	, 
	__actualIsLogarithmic: false

	, 
	actualIsLogarithmic: function (value) {
		if (arguments.length === 1) {

			if (this.actualIsLogarithmic() != value) {
				var oldValue = this.__actualIsLogarithmic;
				if (oldValue != value) {
					this.__actualIsLogarithmic = value;
					this.raisePropertyChanged($.ig.NumericAxisBase.prototype._actualIsLogarithmicPropertyName, oldValue, this.actualIsLogarithmic());
				}

			}

			return value;
		} else {

			return this.__actualIsLogarithmic;
		}
	}

	, 
	isReallyLogarithmic: function () {

			return this.actualIsLogarithmic() && this.actualMinimumValue() > 0 && this.logarithmBaseCached() > 1;
	}

	, 
	logarithmBase: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.NumericAxisBase.prototype.logarithmBaseProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.NumericAxisBase.prototype.logarithmBaseProperty));
		}
	}

	, 
	_logarithmBaseCached: 0,
	logarithmBaseCached: function (value) {
		if (arguments.length === 1) {
			this._logarithmBaseCached = value;
			return value;
		} else {
			return this._logarithmBaseCached;
		}
	}

	, 
	_renderer: null,
	renderer: function (value) {
		if (arguments.length === 1) {
			this._renderer = value;
			return value;
		} else {
			return this._renderer;
		}
	}

	, 
	_logDirty: false,
	logDirty: function (value) {
		if (arguments.length === 1) {
			this._logDirty = value;
			return value;
		} else {
			return this._logDirty;
		}
	}

	, 
	renderAxisOverride: function (animate) {
		var $self = this;
		$.ig.Axis.prototype.renderAxisOverride.call($self, animate);
		if ($self.isReallyLogarithmic() && $self.seriesViewer() != null) {
			var renderingParams = $self.createRenderingParams($self.viewportRect(), $self.seriesViewer().actualWindowRect());
			if (renderingParams == null) {
				return;
			}

			for (var i = 0; i < renderingParams.rangeInfos().count(); i++) {
				var logBase = $self.logarithmBase();
				var currentRange = renderingParams.rangeInfos().__inner[i];
				var trueVisibleMinimum = Math.min(currentRange.visibleMinimum(), currentRange.visibleMaximum());
				var trueVisibleMaximum = Math.max(currentRange.visibleMinimum(), currentRange.visibleMaximum());
				var logMin = Math.floor(Math.logBase(trueVisibleMinimum, logBase));
				var logMax = Math.ceil(Math.logBase(trueVisibleMaximum, logBase));
				if (logMax - logMin < 2) {
					if ($.ig.util.cast($.ig.LogarithmicTickmarkValues.prototype.$type, $self.__actualTickmarkValues) !== null) {
						$self.__actualTickmarkValues = new $.ig.LinearTickmarkValues();
					}


				} else {
					$self.__actualTickmarkValues = $self.tickmarkValues() != null ? $self.tickmarkValues() : (function () { var $ret = new $.ig.LogarithmicTickmarkValues();
					$ret.logarithmBase(logBase); return $ret;}());
				}

			}

		}

	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		$.ig.Axis.prototype.propertyUpdatedOverride.call(this, sender, propertyName, oldValue, newValue);
		switch (propertyName) {
			case $.ig.NumericAxisBase.prototype.minimumValuePropertyName:
				this.updateRange();
				this.renderAxis1(false);
				break;
			case $.ig.NumericAxisBase.prototype.maximumValuePropertyName:
				this.updateRange();
				this.renderAxis1(false);
				break;
			case $.ig.NumericAxisBase.prototype.isLogarithmicPropertyName:
				this.logDirty(true);
				this.actualIsLogarithmic(this.isLogarithmic());
				break;
			case $.ig.Axis.prototype.crossingValuePropertyName:
			case $.ig.Axis.prototype.crossingAxisPropertyName:
			case $.ig.NumericAxisBase.prototype.intervalPropertyName:
				this.mustInvalidateLabels(true);
				this.renderAxis1(false);
				break;
			case $.ig.NumericAxisBase.prototype.logarithmBasePropertyName:
				this.logDirty(true);
				this.logarithmBaseCached(this.logarithmBase());
				if (this.actualIsLogarithmic()) {
					this.updateRange();
					this.invalidateSeries();
					this.renderAxis1(false);
				}

				break;
			case $.ig.NumericAxisBase.prototype.referenceValuePropertyName:
				var ea = new $.ig.AxisRangeChangedEventArgs(this.actualMinimumValue(), this.actualMinimumValue(), this.actualMaximumValue(), this.actualMaximumValue());
				this.raiseRangeChanged(ea);
				this.mustInvalidateLabels(true);
				this.renderAxis1(false);
				break;
			case $.ig.NumericAxisBase.prototype.labelSettingsPropertyName:
				this.renderer(this.createRenderer());
				this.mustInvalidateLabels(true);
				this.renderAxis1(false);
				break;
			case $.ig.NumericAxisBase.prototype._tickmarkValuesPropertyName:
				this.updateActualTickmarkValues();
				break;
			case $.ig.NumericAxisBase.prototype._actualIsLogarithmicPropertyName:
				this.updateRange();
				this.invalidateSeries();
				this.mustInvalidateLabels(true);
				this.updateActualTickmarkValues();
				this.renderAxis1(false);
				break;
			case $.ig.NumericAxisBase.prototype._actualTickmarkValuesPropertyName:
				this.mustInvalidateLabels(true);
				this.renderAxis1(false);
				break;
		}

	}

	, 
	invalidateSeries: function () {
		var en = this.directSeries().getEnumerator();
		while (en.moveNext()) {
			var series = en.current();
			series.renderSeries(false);
		}

	}

	, 
	getAxisRange: function () {
		var newRange = new $.ig.AxisRange(Number.POSITIVE_INFINITY, Number.NEGATIVE_INFINITY);
		var rangeFound = false;
		if (this.seriesViewer() != null) {
			var en = this.directSeries().getEnumerator();
			while (en.moveNext()) {
				var series = en.current();
				var range = series.getRange(this);
				if (range != null) {
					rangeFound = true;
					newRange = new $.ig.AxisRange(Math.min(newRange.minimum(), range.minimum()), Math.max(newRange.maximum(), range.maximum()));
				}

			}

		}

		if (rangeFound) {
			return newRange;
		}

		return null;
	}

	, 
	calculateRange: function (target, minimumValue, maximumValue, isLogarithmic, logarithmBase, actualMinimumValue, actualMaximumValue) {
		var $self = this;
		(function () { var $ret = $.ig.AutoRangeCalculator.prototype.calculateRange(target, minimumValue, maximumValue, isLogarithmic, logarithmBase, actualMinimumValue, actualMaximumValue); actualMinimumValue = $ret.p5; actualMaximumValue = $ret.p6; return $ret.ret; }());
		return {
			p5: actualMinimumValue, 
			p6: actualMaximumValue
		};
	}

	, 
	updateRangeOverride: function () {
		var $self = this;
		var isLogarithmic = $self.actualIsLogarithmic() && !$.ig.util.isNaN($self.logarithmBase()) && !Number.isInfinity($self.logarithmBase()) && $self.logarithmBase() > 1;
		var minimumValue;
		var maximumValue;
		(function () { var $ret = $self.calculateRange($self, $self.minimumValue(), $self.maximumValue(), isLogarithmic, $self.logarithmBase(), minimumValue, maximumValue); minimumValue = $ret.p5; maximumValue = $ret.p6; return $ret.ret; }());
		if (minimumValue != $self.actualMinimumValue() || maximumValue != $self.actualMaximumValue() || $self.logDirty()) {
			$self.logDirty(false);
			var ea = new $.ig.AxisRangeChangedEventArgs($self.actualMinimumValue(), minimumValue, $self.actualMaximumValue(), maximumValue);
			$self.actualMinimumValue(minimumValue);
			$self.actualMaximumValue(maximumValue);
			$self.raiseRangeChanged(ea);
			$self.onRangeChanged(ea);
			$self.renderAxis1(true);
			return true;
		}

		return false;
	}

	, 
	onRangeChanged: function (ea) {
	}

	, 
	registerSeries: function (series) {
		var success = $.ig.Axis.prototype.registerSeries.call(this, series);
		if (success) {
			this.updateRange();
		}

		return success;
	}

	, 
	deregisterSeries: function (series) {
		var success = $.ig.Axis.prototype.deregisterSeries.call(this, series);
		if (success) {
			this.updateRange();
		}

		return success;
	}

	, 
	createRenderer: function () {
		var $self = this;
		var labelManager = (function () { var $ret = new $.ig.AxisLabelManager();
		$ret.axis($self);
		$ret.labelPositions($self.labelPositions());
		$ret.labelDataContext($self.labelDataContext());
		$ret.targetPanel($self.labelPanel()); return $ret;}());
		if ($self.labelSettings() != null) {
			$self.labelSettings().registerAxis($self);
		}

		var renderer = new $.ig.NumericAxisRenderer(labelManager);
		renderer.clear(function () {
			var axisGeometry = $self.view().getAxisLinesGeometry();
			var stripsGeometry = $self.view().getStripsGeometry();
			var majorGeometry = $self.view().getMajorLinesGeometry();
			var minorGeometry = $self.view().getMinorLinesGeometry();
			$self.updateLineVisibility();
			$self.clearMarks(axisGeometry);
			$self.clearMarks(stripsGeometry);
			$self.clearMarks(majorGeometry);
			$self.clearMarks(minorGeometry);
		});
		renderer.shouldRender(function (viewport, window) {
			return !window.isEmpty() && !viewport.isEmpty();
		});
		renderer.createRenderingParams(function (viewport, window) {
			return $self.createRenderingParams(viewport, window);
		});
		renderer.getLabelForItem(function (item) {
			return $self.getLabel(item);
		});
		return renderer;
	}

	, 
	createRenderingParamsInstance: function () {
		return new $.ig.NumericAxisRenderingParameters();
	}

	, 
	floatLabelPanel: function () {
	}

	, 
	createScalerOverride: function () {
		return null;
	}

	, 
	createRenderingParams: function (viewportRect, windowRect) {
		var parameters = this.createRenderingParamsInstance();
		var axisGeometry = this.view().getAxisLinesGeometry();
		var stripsGeometry = this.view().getStripsGeometry();
		var majorGeometry = this.view().getMajorLinesGeometry();
		var minorGeometry = this.view().getMinorLinesGeometry();
		var axisRenderingInfo = this.view().getAxisLinesPathInfo();
		var majorLinesRenderingInfo = this.view().getMajorLinesPathInfo();
		var minorLinesRenderingInfo = this.view().getMinorLinesPathInfo();
		parameters.axisGeometry(axisGeometry);
		parameters.strips(stripsGeometry);
		parameters.major(majorGeometry);
		parameters.minor(minorGeometry);
		parameters.axisRenderingInfo(axisRenderingInfo);
		parameters.majorRenderingInfo(majorLinesRenderingInfo);
		parameters.minorRenderingInfo(minorLinesRenderingInfo);
		parameters.actualMaximumValue(this.actualMaximumValue());
		parameters.actualMinimumValue(this.actualMinimumValue());
		parameters.hasUserMax(this.hasUserMaximum());
		parameters.tickmarkValues(this.actualTickmarkValues());
		parameters.viewportRect(viewportRect);
		parameters.windowRect(windowRect);
		parameters.hasUserInterval(this.hasUserInterval());
		parameters.interval(this.interval());
		parameters.label(this.label());
		if (this.label() == null && this.formatLabel() != null) {
			parameters.label("Format");
		}

		parameters.shouldRenderMinorLines(this.shouldRenderMinorLines());
		return parameters;
	}

	, 
	unscaleValue: function (unscaledValue) {
		var sParams = new $.ig.ScalerParams(this.seriesViewer().windowRect(), this.viewportRect(), this.isInverted());
		sParams._effectiveViewportRect = this.seriesViewer().effectiveViewport();
		return this.getUnscaledValue(unscaledValue, sParams);
	}

	, 
	hasUserInterval: function () {
		return !$.ig.util.isNaN(this.interval());
	}

	, 
	hasUserMinimum: function () {

			return !$.ig.util.isNaN(this.minimumValue());
	}

	, 
	hasUserMaximum: function () {

			return !$.ig.util.isNaN(this.maximumValue());
	}

	, 
	updateActualTickmarkValues: function () {
		if (this.tickmarkValues() != null) {
			this.actualTickmarkValues(this.tickmarkValues());

		} else if (this.actualIsLogarithmic()) {
			this.actualTickmarkValues(new $.ig.LogarithmicTickmarkValues());
			this.numericView().bindLogarithmBaseToActualTickmarks();

		} else {
			this.actualTickmarkValues(new $.ig.LinearTickmarkValues());
		}


	}

	, 
	tickmarkValues: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.NumericAxisBase.prototype.tickmarkValuesProperty, value);
			return value;
		} else {

			return $.ig.util.cast($.ig.TickmarkValues.prototype.$type, this.getValue($.ig.NumericAxisBase.prototype.tickmarkValuesProperty));
		}
	}
	, 
	__actualTickmarkValues: null

	, 
	actualTickmarkValues: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__actualTickmarkValues;
			var changed = oldValue != value;
			if (changed) {
				this.__actualTickmarkValues = value;
				this.raisePropertyChanged($.ig.NumericAxisBase.prototype._actualTickmarkValuesPropertyName, oldValue, value);
			}

			return value;
		} else {

			if (this.__actualTickmarkValues == null) {
				this.updateActualTickmarkValues();
			}

			return this.__actualTickmarkValues;
		}
	}
	, 
	$type: new $.ig.Type('NumericAxisBase', $.ig.Axis.prototype.$type)
}, true);


$.ig.util.defType('NumericAxisBaseView', 'AxisView', {

	_numericModel: null,
	numericModel: function (value) {
		if (arguments.length === 1) {
			this._numericModel = value;
			return value;
		} else {
			return this._numericModel;
		}
	}
	, 
	init: function (model) {



		$.ig.AxisView.prototype.init.call(this, model);
			this.numericModel(model);
	}

	, 
	bindLogarithmBaseToActualTickmarks: function () {
	}
	, 
	$type: new $.ig.Type('NumericAxisBaseView', $.ig.AxisView.prototype.$type)
}, true);


$.ig.util.defType('StraightNumericAxisBase', 'NumericAxisBase', {
	init: function () {



		$.ig.NumericAxisBase.prototype.init.call(this);
			this.updateActualScaler();
	}

	, 
	createView: function () {
		return new $.ig.StraightNumericAxisBaseView(this);
	}

	, 
	onViewCreated: function (view) {
		$.ig.NumericAxisBase.prototype.onViewCreated.call(this, view);
		this.straightView(view);
	}

	, 
	_straightView: null,
	straightView: function (value) {
		if (arguments.length === 1) {
			this._straightView = value;
			return value;
		} else {
			return this._straightView;
		}
	}

	, 
	scaleMode: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StraightNumericAxisBase.prototype.scaleModeProperty, $.ig.NumericScaleMode.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.StraightNumericAxisBase.prototype.scaleModeProperty));
		}
	}

	, 
	scaler: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StraightNumericAxisBase.prototype.scalerProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StraightNumericAxisBase.prototype.scalerProperty);
		}
	}

	, 
	onScalerPropertyChanged: function (d, e) {
		var strNumAcxisBase = $.ig.util.cast($.ig.StraightNumericAxisBase.prototype.$type, d);
		strNumAcxisBase.updateActualScaler();
		strNumAcxisBase.raisePropertyChanged($.ig.StraightNumericAxisBase.prototype.scalerPropertyName, e.oldValue(), e.newValue());
	}

	, 
	createLinearScaler: function () {
		return null;
	}
	, 
	_cachedActualScaler: null

	, 
	actualScaler: function (value) {
		if (arguments.length === 1) {

			var changed = this._cachedActualScaler != value;
			if (changed) {
				var oldValue = this._cachedActualScaler;
				this._cachedActualScaler = value;
				this.raisePropertyChanged($.ig.StraightNumericAxisBase.prototype._actualScalerPropertyName, oldValue, value);
			}

			return value;
		} else {

			if (this._cachedActualScaler == null) {
				this.updateActualScaler();
			}

			return this._cachedActualScaler;
		}
	}

	, 
	calculateRange: function (target, minimumValue, maximumValue, isLogarithmic, logarithmBase, actualMinimumValue, actualMaximumValue) {
		var $self = this;
		(function () { var $ret = $self.actualScaler().calculateRange(target, minimumValue, maximumValue, actualMinimumValue, actualMaximumValue); actualMinimumValue = $ret.p3; actualMaximumValue = $ret.p4; return $ret.ret; }());
		return {
			p5: actualMinimumValue, 
			p6: actualMaximumValue
		};
	}

	, 
	suspendPropertyUpdatedAndExecute: function (a) {
		var suspendPropertyUpdatedStored = this.suspendPropertyUpdated();
		this.suspendPropertyUpdated(true);
		a.invoke();
		this.suspendPropertyUpdated(suspendPropertyUpdatedStored);
	}

	, 
	_suspendPropertyUpdated: false,
	suspendPropertyUpdated: function (value) {
		if (arguments.length === 1) {
			this._suspendPropertyUpdated = value;
			return value;
		} else {
			return this._suspendPropertyUpdated;
		}
	}

	, 
	updateActualScaler: function () {
		var scaler = this.scaler();
		if (scaler == null) {
			scaler = this.createScalerOverride();
		}

		this.actualScaler(scaler);
		if (this.actualScaler() == null) {
			throw new $.ig.ArgumentNullException(0, "ActualScaler");
		}

		this.bindScalerProperties();
	}

	, 
	bindScalerProperties: function () {
		this.straightView().bindScalerProperties();
	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		if (this.suspendPropertyUpdated()) {
			return;
		}

		$.ig.NumericAxisBase.prototype.propertyUpdatedOverride.call(this, sender, propertyName, oldValue, newValue);
		switch (propertyName) {
			case $.ig.NumericAxisBase.prototype.logarithmBasePropertyName:
				this.updateActualScaler();
				break;
			case $.ig.NumericAxisBase.prototype.isLogarithmicPropertyName:
				this.updateActualScaler();
				break;
			case $.ig.StraightNumericAxisBase.prototype.scaleModePropertyName:
				this.updateActualScaler();
				break;
			case $.ig.StraightNumericAxisBase.prototype.scalerPropertyName:
				this.updateActualScaler();
				break;
			case $.ig.StraightNumericAxisBase.prototype._actualScalerPropertyName:
				this.actualIsLogarithmic($.ig.util.cast($.ig.LogarithmicScaler.prototype.$type, this.actualScaler()) !== null);
				this.bindScalerProperties();
				this.updateRange();
				this.renderAxis1(false);
				break;
			case $.ig.NumericAxisBase.prototype.actualMaximumValuePropertyName:
				this.onActualMaximumValueChanged();
				break;
			case $.ig.NumericAxisBase.prototype.actualMinimumValuePropertyName:
				this.onActualMinimumValueChanged();
				this.updateActualScaler();
				break;
		}

	}

	, 
	onActualMinimumValueChanged: function () {
		this.actualScaler().setActualMinimumValue(this.actualMinimumValue());
	}

	, 
	onActualMaximumValueChanged: function () {
		this.actualScaler().setActualMaximumValue(this.actualMaximumValue());
	}
	, 
	$type: new $.ig.Type('StraightNumericAxisBase', $.ig.NumericAxisBase.prototype.$type)
}, true);



$.ig.util.defType('NumericXAxis', 'StraightNumericAxisBase', {

	createView: function () {
		return new $.ig.NumericXAxisView(this);
	}

	, 
	onViewCreated: function (view) {
		$.ig.StraightNumericAxisBase.prototype.onViewCreated.call(this, view);
		this.xView(view);
	}

	, 
	_xView: null,
	xView: function (value) {
		if (arguments.length === 1) {
			this._xView = value;
			return value;
		} else {
			return this._xView;
		}
	}
	, 
	init: function () {



		$.ig.StraightNumericAxisBase.prototype.init.call(this);
			this.defaultStyleKey($.ig.NumericXAxis.prototype.$type);
			this.renderer(this.createRenderer());
	}

	, 
	createLabelPanel: function () {
		if (this.useSmartAxis()) {
			return new $.ig.SmartAxisLabelPanel();

		} else {
			return new $.ig.HorizontalAxisLabelPanel();
		}

	}

	, 
	createRenderer: function () {
		var $self = this;
		var renderer = $.ig.StraightNumericAxisBase.prototype.createRenderer.call($self);
		renderer.labelManager().floatPanelAction(function (crossing) {
			if (($self.labelSettings() == null || $self.labelSettings().visibility() == $.ig.Visibility.prototype.visible) && $self.crossingAxis() != null) {
				$self.labelPanel().crossingValue(crossing);
				if ($self.labelSettings() != null && ($self.labelSettings().location() == $.ig.AxisLabelsLocation.prototype.insideTop || $self.labelSettings().location() == $.ig.AxisLabelsLocation.prototype.insideBottom)) {
					$self.seriesViewer().invalidatePanels();
				}

			}

		});
		renderer.line(function (p, g, value) {
			$self.verticalLine(g, value, p.viewportRect(), p.currentRenderingInfo());
		});
		renderer.strip(function (p, g, start, end) {
			$self.verticalStrip(g, start, end, p.viewportRect());
		});
		renderer.scaling(function (p, unscaled) {
			var sParams = new $.ig.ScalerParams(p.windowRect(), p.viewportRect(), $self.isInvertedCached());
			return $self.getScaledValue(unscaled, sParams);
		});
		renderer.shouldRenderLines(function (p, value) {
			return true;
		});
		renderer.axisLine(function (p) {
			$self.horizontalLine(p.axisGeometry(), p.crossingValue(), p.viewportRect(), p.axisRenderingInfo());
		});
		renderer.determineCrossingValue(function (p) {
			p.crossingValue(p.viewportRect().bottom());
			var sParams2 = new $.ig.ScalerParams(p.windowRect(), p.viewportRect(), $self.isInvertedCached());
			if ($self.crossingAxis() != null && $self.crossingAxis().seriesViewer() != null) {
				p.crossingValue($self.crossingValue());
				p.crossingValue($self.crossingAxis().getScaledValue(p.crossingValue(), sParams2));
				var categoryAxis = $.ig.util.cast($.ig.CategoryAxisBase.prototype.$type, $self.crossingAxis());
				if (categoryAxis != null && categoryAxis.categoryMode() == $.ig.CategoryMode.prototype.mode2) {
					var offset = 0.5 * categoryAxis.getCategorySize(p.windowRect(), p.viewportRect());
					if (!categoryAxis.isInverted()) {
					offset = -offset;
					}

					p.crossingValue(p.crossingValue() + offset);
				}

				p.relativeCrossingValue(p.crossingValue() - p.viewportRect().top());
				if (p.crossingValue() < p.viewportRect().top()) {
					p.crossingValue(p.viewportRect().top());

				} else if (p.crossingValue() > p.viewportRect().bottom()) {
					p.crossingValue(p.viewportRect().bottom());
				}


				if (p.relativeCrossingValue() < 0) {
					p.relativeCrossingValue(0);

				} else if (p.relativeCrossingValue() > p.viewportRect().height()) {
					p.relativeCrossingValue(p.viewportRect().height());
				}


			}

		});
		renderer.shouldRenderLabel(function (p, value, last) {
			var pixelValue = Math.round(value);
			return pixelValue >= Math.floor(p.viewportRect().left()) && pixelValue <= Math.ceil(p.viewportRect().right());
		});
		return renderer;
	}

	, 
	getScaledValue: function (unscaledValue, p) {
		if (this._cachedActualScaler != null) {
			return this._cachedActualScaler.getScaledValue(unscaledValue, p);
		}

		return this.actualScaler().getScaledValue(unscaledValue, p);
	}

	, 
	getUnscaledValue: function (scaledValue, p) {
		if (this._cachedActualScaler != null) {
			return this._cachedActualScaler.getUnscaledValue(scaledValue, p);
		}

		return this.actualScaler().getUnscaledValue(scaledValue, p);
	}

	, 
	getScaledValueList: function (unscaledValues, startIndex, count, p) {
		if (this._cachedActualScaler != null) {
			this._cachedActualScaler.getScaledValueList(unscaledValues, startIndex, count, p);
			return;
		}

		this.actualScaler().getScaledValueList(unscaledValues, startIndex, count, p);
	}

	, 
	getUnscaledValueList: function (scaledValues, startIndex, count, p) {
		if (this._cachedActualScaler != null) {
			this._cachedActualScaler.getUnscaledValueList(scaledValues, startIndex, count, p);
			return;
		}

		this.actualScaler().getUnscaledValueList(scaledValues, startIndex, count, p);
	}

	, 
	createRenderingParams: function (viewportRect, windowRect) {
		var $self = this;
		var renderingParams = $.ig.StraightNumericAxisBase.prototype.createRenderingParams.call($self, viewportRect, windowRect);
		var xParams = new $.ig.ScalerParams(windowRect, viewportRect, $self.isInverted());
		var visibleMinimum = NaN;
		var visibleMaximum = NaN;
		if (!$self.isInverted() && windowRect.right() == 1) {
			visibleMaximum = $self.actualMaximumValue();

		} else if ($self.isInverted() && windowRect.left() == 0) {
			visibleMinimum = $self.actualMaximumValue();
		}


		if ($.ig.util.isNaN(visibleMinimum)) {
			visibleMinimum = $self.getUnscaledValue(viewportRect.left(), xParams);
		}

		if ($.ig.util.isNaN(visibleMaximum)) {
			visibleMaximum = $self.getUnscaledValue(viewportRect.right(), xParams);
		}

		var trueVisibleMinimum = Math.min(visibleMinimum, visibleMaximum);
		var trueVisibleMaximum = Math.max(visibleMinimum, visibleMaximum);
		renderingParams.rangeInfos().add((function () { var $ret = new $.ig.RangeInfo();
		$ret.visibleMinimum(trueVisibleMinimum);
		$ret.visibleMaximum(trueVisibleMaximum);
		$ret.resolution(viewportRect.width()); return $ret;}()));
		return renderingParams;
	}

	, 
	renderAxisOverride: function (animate) {
		$.ig.StraightNumericAxisBase.prototype.renderAxisOverride.call(this, animate);
		var windowRect = this.seriesViewer() != null ? this.seriesViewer().actualWindowRect() : $.ig.Rect.prototype.empty();
		var viewportRect = !windowRect.isEmpty() ? this.viewportRect() : $.ig.Rect.prototype.empty();
		this.renderer().render(animate, viewportRect, windowRect);
	}

	, 
	viewportChangedOverride: function (oldRect, newRect) {
		$.ig.StraightNumericAxisBase.prototype.viewportChangedOverride.call(this, oldRect, newRect);
		if (newRect.height() != oldRect.height()) {
			this.updateRange();
		}

	}

	, 
	orientation: function () {

			return $.ig.AxisOrientation.prototype.horizontal;
	}

	, 
	createScalerOverride: function () {
		if (this.isLogarithmic()) {
			return new $.ig.HorizontalLogarithmicScaler();
		}

		switch (this.scaleMode()) {
			case $.ig.NumericScaleMode.prototype.linear:
				return new $.ig.HorizontalLinearScaler();
			case $.ig.NumericScaleMode.prototype.logarithmic:
				return new $.ig.HorizontalLogarithmicScaler();
		}

		return null;
	}
	, 
	$type: new $.ig.Type('NumericXAxis', $.ig.StraightNumericAxisBase.prototype.$type, [$.ig.IScaler.prototype.$type])
}, true);

$.ig.util.defType('StraightNumericAxisBaseView', 'NumericAxisBaseView', {

	_straightModel: null,
	straightModel: function (value) {
		if (arguments.length === 1) {
			this._straightModel = value;
			return value;
		} else {
			return this._straightModel;
		}
	}
	, 
	init: function (model) {



		$.ig.NumericAxisBaseView.prototype.init.call(this, model);
			this.straightModel(model);
	}

	, 
	bindScalerProperties: function () {
		this.straightModel().actualScaler().setActualMaximumValue(this.straightModel().actualMaximumValue());
		this.straightModel().actualScaler().setActualMinimumValue(this.straightModel().actualMinimumValue());
	}
	, 
	$type: new $.ig.Type('StraightNumericAxisBaseView', $.ig.NumericAxisBaseView.prototype.$type)
}, true);

$.ig.util.defType('NumericXAxisView', 'StraightNumericAxisBaseView', {

	_xModel: null,
	xModel: function (value) {
		if (arguments.length === 1) {
			this._xModel = value;
			return value;
		} else {
			return this._xModel;
		}
	}
	, 
	init: function (model) {



		$.ig.StraightNumericAxisBaseView.prototype.init.call(this, model);
			this.xModel(model);
	}
	, 
	$type: new $.ig.Type('NumericXAxisView', $.ig.StraightNumericAxisBaseView.prototype.$type)
}, true);

$.ig.util.defType('NumericYAxis', 'StraightNumericAxisBase', {

	createView: function () {
		return new $.ig.NumericYAxisView(this);
	}
	, 
	init: function () {



		$.ig.StraightNumericAxisBase.prototype.init.call(this);
			this.defaultStyleKey($.ig.NumericYAxis.prototype.$type);
			this.renderer(this.createRenderer());
	}

	, 
	createLabelPanel: function () {
		return new $.ig.VerticalAxisLabelPanel();
	}

	, 
	isVertical: function () {

			return true;
	}

	, 
	getScaledValue: function (unscaledValue, p) {
		if (this._cachedActualScaler != null) {
			return this._cachedActualScaler.getScaledValue(unscaledValue, p);
		}

		return this.actualScaler().getScaledValue(unscaledValue, p);
	}

	, 
	getScaledValueList: function (unscaledValues, startIndex, count, p) {
		if (this._cachedActualScaler != null) {
			this._cachedActualScaler.getScaledValueList(unscaledValues, startIndex, count, p);
			return;
		}

		this.actualScaler().getScaledValueList(unscaledValues, startIndex, count, p);
	}

	, 
	getUnscaledValue: function (scaledValue, p) {
		if (this._cachedActualScaler != null) {
			return this._cachedActualScaler.getUnscaledValue(scaledValue, p);
		}

		return this.actualScaler().getUnscaledValue(scaledValue, p);
	}

	, 
	getUnscaledValueList: function (scaledValues, startIndex, count, p) {
		if (this._cachedActualScaler != null) {
			this._cachedActualScaler.getUnscaledValueList(scaledValues, startIndex, count, p);
			return;
		}

		this.actualScaler().getUnscaledValueList(scaledValues, startIndex, count, p);
	}

	, 
	createRenderer: function () {
		var $self = this;
		var renderer = $.ig.StraightNumericAxisBase.prototype.createRenderer.call($self);
		renderer.labelManager().floatPanelAction(function (crossing) {
			if ($self.labelSettings() == null || $self.labelSettings().visibility() == $.ig.Visibility.prototype.visible) {
				$self.labelPanel().crossingValue(crossing);
				if ($self.labelSettings() != null && ($self.labelSettings().location() == $.ig.AxisLabelsLocation.prototype.insideRight || $self.labelSettings().location() == $.ig.AxisLabelsLocation.prototype.insideLeft)) {
					$self.seriesViewer().invalidatePanels();
				}

			}

		});
		renderer.line(function (p, g, value) {
			$self.horizontalLine(g, value, p.viewportRect(), p.currentRenderingInfo());
		});
		renderer.strip(function (p, g, start, end) {
			$self.horizontalStrip(g, start, end, p.viewportRect());
		});
		renderer.scaling(function (p, unscaled) {
			var sParams = new $.ig.ScalerParams(p.windowRect(), p.viewportRect(), $self.isInvertedCached());
			return $self.getScaledValue(unscaled, sParams);
		});
		renderer.shouldRenderLines(function (p, value) {
			return true;
		});
		renderer.axisLine(function (p) {
			$self.verticalLine(p.axisGeometry(), p.crossingValue(), p.viewportRect(), p.axisRenderingInfo());
		});
		renderer.determineCrossingValue(function (p) {
			p.crossingValue(p.viewportRect().left());
			var sParams2 = new $.ig.ScalerParams(p.windowRect(), p.viewportRect(), $self.isInvertedCached());
			if ($self.crossingAxis() != null && $self.crossingAxis().seriesViewer() != null) {
				p.crossingValue($self.crossingValue());
				p.crossingValue($self.crossingAxis().getScaledValue(p.crossingValue(), sParams2));
				var categoryAxis = $.ig.util.cast($.ig.CategoryAxisBase.prototype.$type, $self.crossingAxis());
				if (categoryAxis != null && categoryAxis.categoryMode() == $.ig.CategoryMode.prototype.mode2) {
					var offset = 0.5 * categoryAxis.getCategorySize(p.windowRect(), p.viewportRect());
					if (categoryAxis.isInverted()) {
					offset = -offset;
					}

					p.crossingValue(p.crossingValue() + offset);
				}

				p.relativeCrossingValue(p.crossingValue() - p.viewportRect().left());
				if (p.crossingValue() < p.viewportRect().left()) {
					p.crossingValue(p.viewportRect().left());

				} else if (p.crossingValue() > p.viewportRect().right()) {
					p.crossingValue(p.viewportRect().right());
				}


				if (p.relativeCrossingValue() < 0) {
					p.relativeCrossingValue(0);

				} else if (p.relativeCrossingValue() > p.viewportRect().width()) {
					p.relativeCrossingValue(p.viewportRect().width());
				}


			}

		});
		renderer.shouldRenderLabel(function (p, value, last) {
			var pixelValue = Math.round(value);
			return pixelValue >= Math.floor(p.viewportRect().top()) && pixelValue <= Math.ceil(p.viewportRect().bottom());
		});
		return renderer;
	}

	, 
	createRenderingParams: function (viewportRect, windowRect) {
		var $self = this;
		var renderingParams = $.ig.StraightNumericAxisBase.prototype.createRenderingParams.call($self, viewportRect, windowRect);
		var yParams = new $.ig.ScalerParams(windowRect, viewportRect, $self.isInverted());
		var visibleMinimum = NaN;
		var visibleMaximum = NaN;
		if (!$self.isInverted() && windowRect.top() == 0) {
			visibleMaximum = $self.actualMaximumValue();

		} else if ($self.isInverted() && windowRect.bottom() == 1) {
			visibleMinimum = $self.actualMaximumValue();
		}


		if ($.ig.util.isNaN(visibleMinimum)) {
			visibleMinimum = $self.getUnscaledValue(viewportRect.bottom(), yParams);
		}

		if ($.ig.util.isNaN(visibleMaximum)) {
			visibleMaximum = $self.getUnscaledValue(viewportRect.top(), yParams);
		}

		var trueVisibleMinimum = Math.min(visibleMinimum, visibleMaximum);
		var trueVisibleMaximum = Math.max(visibleMinimum, visibleMaximum);
		var newRangeInfo = (function () { var $ret = new $.ig.RangeInfo();
		$ret.visibleMinimum(trueVisibleMinimum);
		$ret.visibleMaximum(trueVisibleMaximum);
		$ret.resolution(viewportRect.height()); return $ret;}());
		renderingParams.rangeInfos().add(newRangeInfo);
		return renderingParams;
	}

	, 
	renderAxisOverride: function (animate) {
		$.ig.StraightNumericAxisBase.prototype.renderAxisOverride.call(this, animate);
		var windowRect = this.seriesViewer() != null ? this.seriesViewer().actualWindowRect() : $.ig.Rect.prototype.empty();
		var viewportRect = this.viewportRect();
		this.renderer().render(animate, viewportRect, windowRect);
	}

	, 
	viewportChangedOverride: function (oldRect, newRect) {
		$.ig.StraightNumericAxisBase.prototype.viewportChangedOverride.call(this, oldRect, newRect);
		if (newRect.height() != oldRect.height()) {
			this.updateRange();
		}

	}

	, 
	orientation: function () {

			return $.ig.AxisOrientation.prototype.vertical;
	}

	, 
	createScalerOverride: function () {
		if (this.isLogarithmic()) {
			return new $.ig.VerticalLogarithmicScaler();
		}

		switch (this.scaleMode()) {
			case $.ig.NumericScaleMode.prototype.linear:
				return new $.ig.VerticalLinearScaler();
			case $.ig.NumericScaleMode.prototype.logarithmic:
				return new $.ig.VerticalLogarithmicScaler();
		}

		return null;
	}

	, 
	createLinearScaler: function () {
		return new $.ig.VerticalLinearScaler();
	}
	, 
	$type: new $.ig.Type('NumericYAxis', $.ig.StraightNumericAxisBase.prototype.$type, [$.ig.IScaler.prototype.$type])
}, true);

$.ig.util.defType('NumericYAxisView', 'StraightNumericAxisBaseView', {
	init: function (model) {



		$.ig.StraightNumericAxisBaseView.prototype.init.call(this, model);
			this.yModel(model);
	}

	, 
	_yModel: null,
	yModel: function (value) {
		if (arguments.length === 1) {
			this._yModel = value;
			return value;
		} else {
			return this._yModel;
		}
	}
	, 
	$type: new $.ig.Type('NumericYAxisView', $.ig.StraightNumericAxisBaseView.prototype.$type)
}, true);




$.ig.util.defType('NumericAxisRenderingParameters', 'AxisRenderingParametersBase', {
	init: function () {


		$.ig.AxisRenderingParametersBase.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('NumericAxisRenderingParameters', $.ig.AxisRenderingParametersBase.prototype.$type)
}, true);

























$.ig.util.defType('NumericAxisRenderer', 'AxisRendererBase', {
	init: function (labelManager) {



		$.ig.AxisRendererBase.prototype.init.call(this, labelManager);
	}

	, 
	getLabel: function (renderingParams, unscaledValue, index, interval) {
		var label;
		if (renderingParams.label() != null) {
			label = this.getLabelForItem()(unscaledValue);

		} else {
			unscaledValue = Math.round(unscaledValue * 1000000) / 1000000;
			label = unscaledValue.toString();
		}

		return label;
	}
	, 
	$type: new $.ig.Type('NumericAxisRenderer', $.ig.AxisRendererBase.prototype.$type)
}, true);

$.ig.util.defType('RangeInfo', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.intervalOverride(-1);
			this.minorCountOverride(-1);
	}

	, 
	_visibleMinimum: 0,
	visibleMinimum: function (value) {
		if (arguments.length === 1) {
			this._visibleMinimum = value;
			return value;
		} else {
			return this._visibleMinimum;
		}
	}

	, 
	_visibleMaximum: 0,
	visibleMaximum: function (value) {
		if (arguments.length === 1) {
			this._visibleMaximum = value;
			return value;
		} else {
			return this._visibleMaximum;
		}
	}

	, 
	_intervalOverride: 0,
	intervalOverride: function (value) {
		if (arguments.length === 1) {
			this._intervalOverride = value;
			return value;
		} else {
			return this._intervalOverride;
		}
	}

	, 
	_resolution: 0,
	resolution: function (value) {
		if (arguments.length === 1) {
			this._resolution = value;
			return value;
		} else {
			return this._resolution;
		}
	}

	, 
	_minorCountOverride: 0,
	minorCountOverride: function (value) {
		if (arguments.length === 1) {
			this._minorCountOverride = value;
			return value;
		} else {
			return this._minorCountOverride;
		}
	}
	, 
	$type: new $.ig.Type('RangeInfo', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('NumericScaler', 'DependencyObject', {
	init: function () {


		$.ig.DependencyObject.prototype.init.call(this);

	}
	, 
	calculateRange: function (target, minimumValue, maximumValue, actualMinimumValue, actualMaximumValue) {}

	, 
	actualMinimumValue: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.NumericScaler.prototype.actualMinimumValueProperty, value);
			return value;
		} else {

			return this.getValue($.ig.NumericScaler.prototype.actualMinimumValueProperty);
		}
	}

	, 
	actualMaximumValue: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.NumericScaler.prototype.actualMaximumValueProperty, value);
			return value;
		} else {

			return this.getValue($.ig.NumericScaler.prototype.actualMaximumValueProperty);
		}
	}
	, 
	_cachedActualMinimumValue: 0
	, 
	_cachedActualMaximumValue: 0

	, 
	setActualMinimumValue: function (value) {
		this.actualMinimumValue(value);
	}

	, 
	setActualMaximumValue: function (value) {
		this.actualMaximumValue(value);
	}

	, 
	onPropertyChanged: function (propertyName, oldValue, newValue) {
		switch (propertyName) {
			case $.ig.NumericScaler.prototype.actualMinimumValuePropertyName:
				this._cachedActualMinimumValue = this.actualMinimumValue();
				this.updateActualRange();
				break;
			case $.ig.NumericScaler.prototype.actualMaximumValuePropertyName:
				this._cachedActualMaximumValue = this.actualMaximumValue();
				this.updateActualRange();
				break;
		}

	}

	, 
	updateActualRange: function () {
		if ($.ig.util.isNaN(this.actualMinimumValue()) || $.ig.util.isNaN(this.actualMaximumValue()) || Number.isInfinity(this.actualMinimumValue()) || Number.isInfinity(this.actualMaximumValue()) || this.actualMinimumValue() < (-79228162514264337593543950335) || this.actualMaximumValue() > (79228162514264337593543950335)) {
			this.actualRange(this.actualMaximumValue() - this.actualMinimumValue());

		} else {
			this.actualRange(this.actualMaximumValue() - this.actualMinimumValue());
		}

	}

	, 
	_actualRange: 0,
	actualRange: function (value) {
		if (arguments.length === 1) {
			this._actualRange = value;
			return value;
		} else {
			return this._actualRange;
		}
	}

	, 
	getUnscaledValue: function (scaledValue, p) {}

	, 
	getScaledValue: function (unscaledValue, p) {}

	, 
	getUnscaledValueList: function (scaledValues, startIndex, count, p) {
		var result = new $.ig.List$1(Number, 2, scaledValues.count());
		for (var i = startIndex; i < count; i++) {
			result.add(this.getUnscaledValue(scaledValues.item(i), p));
		}

		return result;
	}

	, 
	getScaledValueList: function (unscaledValues, startIndex, count, p) {
		for (var i = startIndex; i < count; i++) {
			unscaledValues.item(i, this.getScaledValue(unscaledValues.item(i), p));
		}

	}
	, 
	$type: new $.ig.Type('NumericScaler', $.ig.DependencyObject.prototype.$type)
}, true);

$.ig.util.defType('LinearScaler', 'NumericScaler', {
	init: function () {


		$.ig.NumericScaler.prototype.init.call(this);

	}
	, 
	calculateRange: function (target, minimumValue, maximumValue, actualMinimumValue, actualMaximumValue) {
		var $self = this;
		var innerMin;
		var innerMax;
		(function () { var $ret = $.ig.AutoRangeCalculator.prototype.calculateRange(target, minimumValue, maximumValue, false, -1, innerMin, innerMax); innerMin = $ret.p5; innerMax = $ret.p6; return $ret.ret; }());
		actualMinimumValue = innerMin;
		actualMaximumValue = innerMax;
		return {
			p3: actualMinimumValue, 
			p4: actualMaximumValue
		};
	}
	, 
	$type: new $.ig.Type('LinearScaler', $.ig.NumericScaler.prototype.$type)
}, true);

$.ig.util.defType('HorizontalLinearScaler', 'LinearScaler', {
	init: function () {


		$.ig.LinearScaler.prototype.init.call(this);

	}
	, 
	getUnscaledValue: function (scaledValue, p) {
		return this.getUnscaledValue1(scaledValue, p._windowRect, p._viewportRect, p._isInverted);
	}

	, 
	getScaledValue: function (unscaledValue, p) {
		return this.getScaledValue1(unscaledValue, p._windowRect, p._viewportRect, p._isInverted);
	}

	, 
	asArray: function (values_) {
		var arr = $.isArray(values_) ? values_ : null;;
		return arr;
		return null;
	}

	, 
	getScaledValueList: function (unscaledValues, startIndex, count, p) {
		var unscaledValue;
		var windowRect = p._windowRect;
		var viewportRect = p._viewportRect;
		var effectiveViewportRect = p._effectiveViewportRect;
		var isInverted = p._isInverted;
		var useEffectiveRect = !effectiveViewportRect.isEmpty();
		var actualRange = this.actualRange();
		var minimumValue = this._cachedActualMinimumValue;
		var effectiveLeft = effectiveViewportRect.left();
		var effectiveWidth = effectiveViewportRect.width();
		var windowLeft = windowRect.left();
		var windowWidth = windowRect.width();
		var viewportLeft = viewportRect.left();
		var viewportWidth = viewportRect.width();
		var unitLeft = 0;
		var unitWidth = 1;
		var input = this.asArray(unscaledValues);
		var useArray = false;
		if (input != null) {
			useArray = true;
		}

		for (var i = startIndex; i < count; i++) {
			if (useArray) {
				unscaledValue = input[i];

			} else {
				unscaledValue = unscaledValues.item(i);
			}

			if (useEffectiveRect) {
				var u = (unscaledValue - minimumValue) / (actualRange);
				if (isInverted) {
					u = 1 - u;
				}

				u = effectiveLeft + effectiveWidth * (u - unitLeft) / unitWidth;
				var scaledValue = (u - (windowLeft * viewportWidth)) / windowWidth;
				if (useArray) {
					input[i] = scaledValue;

				} else {
					unscaledValues.item(i, scaledValue);
				}


			} else {
				var scaledValue1 = (unscaledValue - minimumValue) / (actualRange);
				if (isInverted) {
					scaledValue1 = 1 - scaledValue1;
				}

				scaledValue1 = viewportLeft + viewportWidth * (scaledValue1 - windowLeft) / windowWidth;
				if (useArray) {
					input[i] = scaledValue1;

				} else {
					unscaledValues.item(i, scaledValue1);
				}

			}

		}

	}

	, 
	getUnscaledValue1: function (scaledValue, windowRect, viewportRect, isInverted) {
		var unscaledValue = windowRect.left() + windowRect.width() * (scaledValue - viewportRect.left()) / viewportRect.width();
		if (isInverted) {
			unscaledValue = 1 - unscaledValue;
		}

		return this._cachedActualMinimumValue + unscaledValue * (this.actualRange());
	}

	, 
	getScaledValue1: function (unscaledValue, windowRect, viewportRect, isInverted) {
		var scaledValue = (unscaledValue - this._cachedActualMinimumValue) / (this.actualRange());
		if (isInverted) {
			scaledValue = 1 - scaledValue;
		}

		return viewportRect.left() + viewportRect.width() * (scaledValue - windowRect.left()) / windowRect.width();
	}
	, 
	$type: new $.ig.Type('HorizontalLinearScaler', $.ig.LinearScaler.prototype.$type)
}, true);

$.ig.util.defType('LogarithmicScaler', 'NumericScaler', {
	init: function () {


		$.ig.NumericScaler.prototype.init.call(this);

	}
	, 
	_logActualMinimumValue: 0,
	logActualMinimumValue: function (value) {
		if (arguments.length === 1) {
			this._logActualMinimumValue = value;
			return value;
		} else {
			return this._logActualMinimumValue;
		}
	}

	, 
	_logActualMaximumValue: 0,
	logActualMaximumValue: function (value) {
		if (arguments.length === 1) {
			this._logActualMaximumValue = value;
			return value;
		} else {
			return this._logActualMaximumValue;
		}
	}

	, 
	onPropertyChanged: function (propertyName, oldValue, newValue) {
		$.ig.NumericScaler.prototype.onPropertyChanged.call(this, propertyName, oldValue, newValue);
		switch (propertyName) {
			case $.ig.NumericScaler.prototype.actualMinimumValuePropertyName:
				this.logActualMinimumValue(Math.log(this.actualMinimumValue()));
				break;
			case $.ig.NumericScaler.prototype.actualMaximumValuePropertyName:
				this.logActualMaximumValue(Math.log(this.actualMaximumValue()));
				break;
		}

	}

	, 
	calculateRange: function (target, minimumValue, maximumValue, actualMinimumValue, actualMaximumValue) {
		var $self = this;
		var innerMin;
		var innerMax;
		(function () { var $ret = $.ig.AutoRangeCalculator.prototype.calculateRange(target, minimumValue, maximumValue, true, target.logarithmBase(), innerMin, innerMax); innerMin = $ret.p5; innerMax = $ret.p6; return $ret.ret; }());
		actualMinimumValue = innerMin;
		actualMaximumValue = innerMax;
		return {
			p3: actualMinimumValue, 
			p4: actualMaximumValue
		};
	}
	, 
	$type: new $.ig.Type('LogarithmicScaler', $.ig.NumericScaler.prototype.$type)
}, true);

$.ig.util.defType('HorizontalLogarithmicScaler', 'LogarithmicScaler', {
	init: function () {


		$.ig.LogarithmicScaler.prototype.init.call(this);

	}
	, 
	getUnscaledValue: function (scaledValue, p) {
		return this.getUnscaledValue1(scaledValue, p._windowRect, p._viewportRect, p._isInverted);
	}

	, 
	getScaledValue: function (unscaledValue, p) {
		return this.getScaledValue1(unscaledValue, p._windowRect, p._viewportRect, p._isInverted);
	}

	, 
	getUnscaledValue1: function (scaledValue, windowRect, viewportRect, isInverted) {
		var unscaledValue = windowRect.left() + windowRect.width() * (scaledValue - viewportRect.left()) / viewportRect.width();
		if (isInverted) {
			unscaledValue = 1 - unscaledValue;
		}

		return Math.exp(unscaledValue * (this.logActualMaximumValue() - this.logActualMinimumValue()) + this.logActualMinimumValue());
	}

	, 
	getScaledValue1: function (unscaledValue, windowRect, viewportRect, isInverted) {
		if ($.ig.util.isNaN(unscaledValue)) {
			return NaN;
		}

		var scaledValue = 0;
		if (unscaledValue <= 0) {
			scaledValue = (Math.log(this._cachedActualMinimumValue) - this.logActualMinimumValue()) / (this.logActualMaximumValue() - this.logActualMinimumValue());

		} else {
			scaledValue = (Math.log(unscaledValue) - this.logActualMinimumValue()) / (this.logActualMaximumValue() - this.logActualMinimumValue());
		}

		if (isInverted) {
			scaledValue = 1 - scaledValue;
		}

		return viewportRect.left() + viewportRect.width() * (scaledValue - windowRect.left()) / windowRect.width();
	}
	, 
	$type: new $.ig.Type('HorizontalLogarithmicScaler', $.ig.LogarithmicScaler.prototype.$type)
}, true);


$.ig.util.defType('VerticalLinearScaler', 'LinearScaler', {
	init: function () {


		$.ig.LinearScaler.prototype.init.call(this);

	}
	, 
	getUnscaledValue: function (scaledValue, p) {
		return this.getUnscaledValue1(scaledValue, p._windowRect, p._viewportRect, p._isInverted);
	}

	, 
	getScaledValue: function (unscaledValue, p) {
		return this.getScaledValue1(unscaledValue, p._windowRect, p._viewportRect, p._isInverted);
	}

	, 
	asArray: function (values_) {
		var arr = $.isArray(values_) ? values_ : null;;
		return arr;
		return null;
	}

	, 
	getScaledValueList: function (unscaledValues, startIndex, count, p) {
		var unscaledValue;
		var windowRect = p._windowRect;
		var viewportRect = p._viewportRect;
		var effectiveViewportRect = p._effectiveViewportRect;
		var isInverted = p._isInverted;
		var useEffectiveRect = !effectiveViewportRect.isEmpty();
		var actualRange = this.actualRange();
		var minimumValue = this._cachedActualMinimumValue;
		var effectiveTop = effectiveViewportRect.top();
		var effectiveHeight = effectiveViewportRect.height();
		var windowTop = windowRect.top();
		var windowHeight = windowRect.height();
		var viewportTop = viewportRect.top();
		var viewportHeight = viewportRect.height();
		var unitTop = 0;
		var unitHeight = 1;
		var input = this.asArray(unscaledValues);
		var useArray = false;
		if (input != null) {
			useArray = true;
		}

		for (var i = startIndex; i < count; i++) {
			if (useArray) {
				unscaledValue = input[i];

			} else {
				unscaledValue = unscaledValues.item(i);
			}

			if (useEffectiveRect) {
				var u = (unscaledValue - minimumValue) / (actualRange);
				if (!isInverted) {
					u = 1 - u;
				}

				u = effectiveTop + effectiveHeight * (u - unitTop) / unitHeight;
				var scaledValue = (u - (windowTop * viewportHeight)) / windowHeight;
				if (useArray) {
					input[i] = scaledValue;

				} else {
					unscaledValues.item(i, scaledValue);
				}


			} else {
				var scaledValue1 = (unscaledValue - minimumValue) / (actualRange);
				if (!isInverted) {
					scaledValue1 = 1 - scaledValue1;
				}

				scaledValue1 = viewportTop + viewportHeight * (scaledValue1 - windowTop) / windowHeight;
				if (useArray) {
					input[i] = scaledValue1;

				} else {
					unscaledValues.item(i, scaledValue1);
				}

			}

		}

	}

	, 
	getScaledValue1: function (unscaledValue, windowRect, viewportRect, isInverted) {
		var scaledValue = (unscaledValue - this._cachedActualMinimumValue) / (this.actualRange());
		if (!isInverted) {
			scaledValue = 1 - scaledValue;
		}

		return viewportRect.top() + viewportRect.height() * (scaledValue - windowRect.top()) / windowRect.height();
	}

	, 
	getUnscaledValue1: function (scaledValue, windowRect, viewportRect, isInverted) {
		var unscaledValue = windowRect.top() + windowRect.height() * (scaledValue - viewportRect.top()) / viewportRect.height();
		if (!isInverted) {
			unscaledValue = 1 - unscaledValue;
		}

		return this._cachedActualMinimumValue + unscaledValue * (this.actualRange());
	}
	, 
	$type: new $.ig.Type('VerticalLinearScaler', $.ig.LinearScaler.prototype.$type)
}, true);

$.ig.util.defType('VerticalLogarithmicScaler', 'LogarithmicScaler', {
	init: function () {


		$.ig.LogarithmicScaler.prototype.init.call(this);

	}
	, 
	getUnscaledValue: function (scaledValue, p) {
		return this.getUnscaledValue1(scaledValue, p._windowRect, p._viewportRect, p._isInverted);
	}

	, 
	getScaledValue: function (unscaledValue, p) {
		return this.getScaledValue1(unscaledValue, p._windowRect, p._viewportRect, p._isInverted);
	}

	, 
	getScaledValue1: function (unscaledValue, windowRect, viewportRect, isInverted) {
		if ($.ig.util.isNaN(unscaledValue)) {
			return NaN;
		}

		var scaledValue;
		if (unscaledValue <= 0) {
			scaledValue = (Math.log(this._cachedActualMinimumValue) - this.logActualMinimumValue()) / (this.logActualMaximumValue() - this.logActualMinimumValue());

		} else {
			scaledValue = (Math.log(unscaledValue) - this.logActualMinimumValue()) / (this.logActualMaximumValue() - this.logActualMinimumValue());
		}

		if (!isInverted) {
			scaledValue = 1 - scaledValue;
		}

		return viewportRect.top() + viewportRect.height() * (scaledValue - windowRect.top()) / windowRect.height();
	}

	, 
	getUnscaledValue1: function (scaledValue, windowRect, viewportRect, isInverted) {
		var unscaledValue = windowRect.top() + windowRect.height() * (scaledValue - viewportRect.top()) / viewportRect.height();
		if (!isInverted) {
			unscaledValue = 1 - unscaledValue;
		}

		return Math.exp(unscaledValue * (this.logActualMaximumValue() - this.logActualMinimumValue()) + this.logActualMinimumValue());
	}
	, 
	$type: new $.ig.Type('VerticalLogarithmicScaler', $.ig.LogarithmicScaler.prototype.$type)
}, true);





$.ig.util.defType('LinearTickmarkValues', 'TickmarkValues', {
	init: function () {


		this.__majorValues = null;
		this.__minorValues = null;

		$.ig.TickmarkValues.prototype.init.call(this);
			this.minTicks(0);
	}

	, 
	_minTicks: 0,
	minTicks: function (value) {
		if (arguments.length === 1) {
			this._minTicks = value;
			return value;
		} else {
			return this._minTicks;
		}
	}

	, 
	initialize: function (initializationParameters) {
		$.ig.TickmarkValues.prototype.initialize.call(this, initializationParameters);
		var snapper;
		if (this.minTicks() != 0) {
			snapper = new $.ig.LinearNumericSnapper(1, initializationParameters.visibleMinimum(), initializationParameters.visibleMaximum(), initializationParameters.resolution(), this.minTicks());

		} else {
			snapper = new $.ig.LinearNumericSnapper(0, initializationParameters.visibleMinimum(), initializationParameters.visibleMaximum(), initializationParameters.resolution());
		}

		this.interval(snapper.interval());
		if ((initializationParameters.hasUserInterval()) && initializationParameters.userInterval() > 0 && (initializationParameters.visibleMaximum() - initializationParameters.visibleMinimum()) / initializationParameters.userInterval() < 1000) {
			this.interval(initializationParameters.userInterval());
		}

		if (initializationParameters.intervalOverride() != -1) {
			this.interval(initializationParameters.intervalOverride());
		}

		this.firstIndex($.ig.truncate(Math.floor((initializationParameters.visibleMinimum() - initializationParameters.actualMinimum()) / this.interval())));
		this.lastIndex($.ig.truncate(Math.ceil((initializationParameters.visibleMaximum() - initializationParameters.actualMinimum()) / this.interval())));
		this.minorCount(snapper.minorCount());
		if (initializationParameters.minorCountOverride() != -1) {
			this.minorCount(initializationParameters.minorCountOverride());
		}

		this.actualMinimum(initializationParameters.actualMinimum());
	}

	, 
	_actualMinimum: 0,
	actualMinimum: function (value) {
		if (arguments.length === 1) {
			this._actualMinimum = value;
			return value;
		} else {
			return this._actualMinimum;
		}
	}
	, 
	__majorValues: null

	, 
	majorValuesArray: function () {
		var count = 0;
		var firstIndex = this.firstIndex();
		if (!$.ig.util.isNaN(this.interval())) {
			count = this.lastIndex() - firstIndex + 1;
			if (count < 0) {
				count = 0;
			}

		}

		if (this.__majorValues == null || this.__majorValues.length != count) {
			this.__majorValues = new Array(count);
		}

		var array = this.__majorValues;
		for (var i = 0; i < count; ++i) {
			var major = this.actualMinimum() + (i + firstIndex) * this.interval();
			array[i] = major;
		}

		return array;
	}
	, 
	__minorValues: null

	, 
	minorValuesArray: function () {
		var firstIndex = this.firstIndex();
		var lastIndex = this.lastIndex();
		var minorCount = this.minorCount();
		var interval = this.interval();
		var actualMinimum = this.actualMinimum();
		var visibleMaximum = this.visibleMaximum();
		var minorSpan = interval / minorCount;
		var count = 0;
		for (var i = firstIndex; i < lastIndex; ++i) {
			for (var j = 1; j < minorCount; ++j) {
				var minor = actualMinimum + i * interval + (j * minorSpan);
				if (minor <= visibleMaximum) {
					count++;
				}

			}

		}

		if (this.__minorValues == null || this.__minorValues.length != count) {
			this.__minorValues = new Array(count);
		}

		var array = this.__minorValues;
		var pos = 0;
		for (var i1 = firstIndex; i1 < lastIndex; ++i1) {
			for (var j1 = 1; j1 < minorCount; ++j1) {
				var minor1 = actualMinimum + i1 * interval + (j1 * minorSpan);
				if (minor1 <= this.visibleMaximum()) {
					array[pos] = minor1;
					pos++;
				}

			}

		}

		return array;
	}
	, 
	$type: new $.ig.Type('LinearTickmarkValues', $.ig.TickmarkValues.prototype.$type)
}, true);

$.ig.util.defType('LogarithmicTickmarkValues', 'TickmarkValues', {
	init: function () {

		this.__majorValues = null;
		this.__minorValues = null;

		$.ig.TickmarkValues.prototype.init.call(this);

	}
	, 
	initialize: function (initializationParameters) {
		$.ig.TickmarkValues.prototype.initialize.call(this, initializationParameters);
		var snapper = new $.ig.LogarithmicNumericSnapper(initializationParameters.visibleMinimum(), initializationParameters.visibleMaximum(), this.logarithmBase(), initializationParameters.resolution());
		this.interval(1);
		this.minorCount($.ig.truncate(snapper.minorCount()));
		this.firstIndex($.ig.truncate(Math.floor(Math.logBase(Math.max($.ig.LogarithmicTickmarkValues.prototype._mINIMUM_VALUE_GREATER_THAN_ZERO, initializationParameters.visibleMinimum()), this.logarithmBase()))));
		this.lastIndex($.ig.truncate(Math.ceil(Math.logBase(Math.max($.ig.LogarithmicTickmarkValues.prototype._mINIMUM_VALUE_GREATER_THAN_ZERO, initializationParameters.visibleMaximum()), this.logarithmBase()))));
	}

	, 
	logarithmBase: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.LogarithmicTickmarkValues.prototype.logarithmBaseProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.LogarithmicTickmarkValues.prototype.logarithmBaseProperty));
		}
	}

	, 
	majorValueAt: function (tickIndex) {
		var majorLog = tickIndex * this.interval();
		return Math.pow(this.logarithmBase(), majorLog);
	}
	, 
	__majorValues: null

	, 
	majorValuesArray: function () {
		var firstIndex = this.firstIndex();
		var lastIndex = this.lastIndex();
		var visibleMaximum = this.visibleMaximum();
		var count = 0;
		for (var i = firstIndex; i <= lastIndex; ++i) {
			var major = this.majorValueAt(i);
			if (major <= visibleMaximum) {
				count++;
			}

		}

		if (this.__majorValues == null || this.__majorValues.length != count) {
			this.__majorValues = new Array(count);
		}

		var array = this.__majorValues;
		var pos = 0;
		for (var i1 = firstIndex; i1 <= lastIndex; ++i1) {
			var major1 = this.majorValueAt(i1);
			if (major1 <= visibleMaximum) {
				array[pos] = major1;
				pos++;
			}

		}

		return array;
	}
	, 
	__minorValues: null

	, 
	minorValuesArray: function () {
		var firstIndex = this.firstIndex();
		var lastIndex = this.lastIndex();
		var logarithmBase = this.logarithmBase();
		var minorCount = this.minorCount();
		var visibleMaximum = this.visibleMaximum();
		var count = 0;
		for (var i = firstIndex; i <= lastIndex; ++i) {
			var majorValue = this.majorValueAt(i);
			var minorInterval = Math.pow(logarithmBase, i);
			for (var j = 1; j < this.minorCount() - 1; ++j) {
				var minor = majorValue + j * minorInterval;
				if (minor <= visibleMaximum) {
					count++;
				}

			}

		}

		if (this.__minorValues == null || this.__minorValues.length != count) {
			this.__minorValues = new Array(count);
		}

		var array = this.__minorValues;
		var pos = 0;
		for (var i1 = firstIndex; i1 <= lastIndex; ++i1) {
			var majorValue1 = this.majorValueAt(i1);
			var minorInterval1 = Math.pow(logarithmBase, i1);
			for (var j1 = 1; j1 < this.minorCount() - 1; ++j1) {
				var minor1 = majorValue1 + j1 * minorInterval1;
				if (minor1 <= visibleMaximum) {
					array[pos] = minor1;
					pos++;
				}

			}

		}

		return array;
	}
	, 
	$type: new $.ig.Type('LogarithmicTickmarkValues', $.ig.TickmarkValues.prototype.$type)
}, true);



$.ig.util.defType('FramePreparer', 'Object', {
	init: function (initNumber, host) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.FramePreparer.prototype.init1.call(this, 1, $.ig.util.cast($.ig.ISupportsMarkers.prototype.$type, host), $.ig.util.cast($.ig.IProvidesViewport.prototype.$type, host), $.ig.util.cast($.ig.ISupportsErrorBars.prototype.$type, host));
	}
	, 
	init1: function (initNumber, markersHost, viewportHost, errorBarsHost) {


		$.ig.Object.prototype.init.call(this);
			this.markersHost(new $.ig.DefaultSupportsMarkers());
			this.viewportHost(new $.ig.DefaultProvidesViewport());
			this.errorBarsHost(new $.ig.DefaultSupportsErrorBars());
			if (markersHost != null) {
				this.markersHost(markersHost);
			}

			if (viewportHost != null) {
				this.viewportHost(viewportHost);
			}

			if (errorBarsHost != null) {
				this.errorBarsHost(errorBarsHost);
			}

	}

	, 
	_errorBarsHost: null,
	errorBarsHost: function (value) {
		if (arguments.length === 1) {
			this._errorBarsHost = value;
			return value;
		} else {
			return this._errorBarsHost;
		}
	}

	, 
	_markersHost: null,
	markersHost: function (value) {
		if (arguments.length === 1) {
			this._markersHost = value;
			return value;
		} else {
			return this._markersHost;
		}
	}

	, 
	_viewportHost: null,
	viewportHost: function (value) {
		if (arguments.length === 1) {
			this._viewportHost = value;
			return value;
		} else {
			return this._viewportHost;
		}
	}

	, 
	prepareFrame: function (frame, view) {}
	, 
	$type: new $.ig.Type('FramePreparer', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('CategoryFramePreparerBase', 'FramePreparer', {
	init: function (initNumber, host) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.CategoryFramePreparerBase.prototype.init1.call(this, 1, host, $.ig.util.cast($.ig.ISupportsMarkers.prototype.$type, host), $.ig.util.cast($.ig.IProvidesViewport.prototype.$type, host), $.ig.util.cast($.ig.ISupportsErrorBars.prototype.$type, host), $.ig.util.cast($.ig.IBucketizer.prototype.$type, host));
	}
	, 
	init1: function (initNumber, host, markersHost, viewportHost, errorBarsHost, bucketizingHost) {


		$.ig.FramePreparer.prototype.init1.call(this, 1, markersHost, viewportHost, errorBarsHost);
			this.categoryBasedHost(host);
			this.bucketizingHost(bucketizingHost);
	}

	, 
	_bucketizingHost: null,
	bucketizingHost: function (value) {
		if (arguments.length === 1) {
			this._bucketizingHost = value;
			return value;
		} else {
			return this._bucketizingHost;
		}
	}

	, 
	_categoryBasedHost: null,
	categoryBasedHost: function (value) {
		if (arguments.length === 1) {
			this._categoryBasedHost = value;
			return value;
		} else {
			return this._categoryBasedHost;
		}
	}

	, 
	prepareMarker: function (frame, bucket, collisionAvoider, itemIndex, markerCount, markerBucket) {}

	, 
	_skipUnknowns: false,
	skipUnknowns: function (value) {
		if (arguments.length === 1) {
			this._skipUnknowns = value;
			return value;
		} else {
			return this._skipUnknowns;
		}
	}

	, 
	getParams: function (inputFrame) {
		var $self = this;
		var p = new $.ig.PreparationParams();
		p.useHighMarkerFidelity($self.categoryBasedHost().useHighMarkerFidelity());
		p.scaler($self.categoryBasedHost().scaler());
		p.yScaler($self.categoryBasedHost().yScaler());
		p.sortingScaler($.ig.util.cast($.ig.ISortingAxis.prototype.$type, p.scaler()));
		p.frame($.ig.util.cast($.ig.CategoryFrame.prototype.$type, inputFrame));
		if (p.frame() == null || p.scaler() == null || p.yScaler() == null) {
			return null;
		}

		var firstBucket;
		var lastBucket;
		var bucketSize;
		var resolution;
		(function () { var $ret = $self.bucketizingHost().getBucketInfo(firstBucket, lastBucket, bucketSize, resolution); firstBucket = $ret.p0; lastBucket = $ret.p1; bucketSize = $ret.p2; resolution = $ret.p3; return $ret.ret; }());
		p.firstBucket(firstBucket);
		p.lastBucket(lastBucket);
		p.bucketSize(bucketSize);
		p.resolution(resolution);
		if (p.lastBucket() < p.firstBucket()) {
			return null;
		}

		var windowRect;
		var viewportRect;
		(function () { var $ret = $self.viewportHost().getViewInfo(viewportRect, windowRect); viewportRect = $ret.p0; windowRect = $ret.p1; return $ret.ret; }());
		p.windowRect(windowRect);
		p.viewportRect(viewportRect);
		if (p.windowRect() == $.ig.Rect.prototype.empty() || p.viewportRect() == $.ig.Rect.prototype.empty()) {
			return null;
		}

		if ($self.categoryBasedHost() != null && $.ig.util.cast($.ig.FragmentBase.prototype.$type, $self.categoryBasedHost()) !== null && $self.bucketizingHost() != null) {
			p.isFragment(true);
		}

		return p;
	}

	, 
	getOffset: function (scaler, windowRect, viewportRect) {
		var categoryMode = this.categoryBasedHost().currentCategoryMode();
		var offset = 0;
		if (categoryMode == $.ig.CategoryMode.prototype.mode0 && scaler.categoryMode() != $.ig.CategoryMode.prototype.mode0) {
			categoryMode = $.ig.CategoryMode.prototype.mode1;
		}

		switch (categoryMode) {
			case $.ig.CategoryMode.prototype.mode0:
				offset = 0;
				break;
			case $.ig.CategoryMode.prototype.mode1:
				offset = 0.5 * scaler.getCategorySize(windowRect, viewportRect);
				break;
			case $.ig.CategoryMode.prototype.mode2:
				offset = scaler.getGroupCenter(this.categoryBasedHost().currentMode2Index(), windowRect, viewportRect);
				break;
		}

		if ($.ig.util.cast($.ig.CategoryYAxis.prototype.$type, scaler) !== null) {
			if (!scaler.isInverted()) {
			offset = -offset;
			}


		} else if (scaler.isInverted()) {
			offset = -offset;
		}


		return offset;
	}

	, 
	getOffset1: function (p) {
		return this.getOffset(p.scaler(), p.windowRect(), p.viewportRect());
	}

	, 
	prepareFrame: function (inputFrame, view) {
		var p = this.getParams(inputFrame);
		if (p == null || this.bucketizingHost() == null) {
			return;
		}

		p.frame()._buckets.clear();
		p.frame()._errorBuckets.clear();
		p.frame()._markers.clear();
		p.frame()._trend.clear();
		p.frame()._errorBars.clear();
		p.frame()._errorBarSizes.clear();
		var markers = this.markersHost().shouldDisplayMarkers();
		var errorBars = false;
		var offset = this.getOffset1(p);
		var h = this.getValues(p);
		if (p.sortingScaler() != null && p.sortingScaler().sortedIndices().count() != h.count()) {
			return;
		}

		if (p.sortingScaler() != null && $.ig.util.cast($.ig.CategoryDateTimeXAxis.prototype.$type, p.sortingScaler()) !== null) {
			(p.sortingScaler()).initializeActualMinimumAndMaximum();
		}

		this.bucketizingHost().cacheValues();
		if (this.skipUnknowns() && p.sortingScaler() != null && p.sortingScaler().sortedIndices().count() > 0) {
			var firstIndex = p.sortingScaler().sortedIndices().__inner[p.firstBucket()];
			this.storeYValues(h, firstIndex, true, p.isFragment());
			while (($.ig.util.isNaN(h.tempY0()) || $.ig.util.isNaN(h.tempY1())) && p.firstBucket() > 0) {
				p.firstBucket(p.firstBucket() - 1);
				firstIndex = p.sortingScaler().sortedIndices().__inner[p.firstBucket()];
				this.storeYValues(h, firstIndex, true, p.isFragment());

			}
			var lastIndex = p.sortingScaler().sortedIndices().__inner[p.lastBucket()];
			this.storeYValues(h, lastIndex, true, p.isFragment());
			while (($.ig.util.isNaN(h.tempY0()) || $.ig.util.isNaN(h.tempY1())) && p.lastBucket() < h.count() - 1) {
				p.lastBucket(p.lastBucket() + 1);
				lastIndex = p.sortingScaler().sortedIndices().__inner[p.lastBucket()];
				this.storeYValues(h, lastIndex, true, p.isFragment());

			}
		}

		if (this.skipUnknowns() && p.sortingScaler() == null) {
			var firstIndex1 = p.firstBucket();
			var bucket = this.bucketizingHost().getBucket(firstIndex1);
			while (($.ig.util.isNaN(bucket[1]) || $.ig.util.isNaN(bucket[2])) && p.firstBucket() > 0) {
				p.firstBucket(p.firstBucket() - 1);
				firstIndex1 = p.firstBucket();
				bucket = this.bucketizingHost().getBucket(firstIndex1);

			}
			var lastIndex1 = p.lastBucket();
			bucket = this.bucketizingHost().getBucket(lastIndex1);
			while (($.ig.util.isNaN(bucket[1]) || $.ig.util.isNaN(bucket[2])) && p.lastBucket() < ($.ig.intDivide(h.count(), p.bucketSize()))) {
				p.lastBucket(p.lastBucket() + 1);
				lastIndex1 = p.lastBucket();
				bucket = this.bucketizingHost().getBucket(lastIndex1);

			}
		}

		this.prepareTrendline(p, h, offset);
		var markerCount = this.prepareData(p, h, offset, markers, errorBars);
		this.markersHost().updateMarkerCount(markerCount);
		this.prepareErrorBars($.ig.util.cast($.ig.CategoryFrame.prototype.$type, inputFrame), view);
		this.bucketizingHost().unCacheValues();
		return;
	}

	, 
	convertToBucket: function (value) {
		return value;
	}

	, 
	prepareErrorBars: function (frame, view) {
	}

	, 
	prepareData: function (p, h, offset, markers, errorBars) {
		var $self = this;
		var markerCount = 0;
		var isCluster = false;
		var endBucket = null;
		var isAreaOrLineBasedSeries = false;
		var isSortingScaler = p.sortingScaler() != null;
		var windowRect = p.windowRect();
		var viewportRect = p.viewportRect();
		var isLogarithmicYScaler = $.ig.util.cast($.ig.NumericAxisBase.prototype.$type, p.yScaler()) !== null && ($.ig.util.cast($.ig.NumericAxisBase.prototype.$type, p.yScaler())).isReallyLogarithmic();
		var highMarkerFidelity = p.useHighMarkerFidelity();
		var collisionAvoider = $self.categoryBasedHost().provideCollisionDetector();
		var singlePixelSpan = 0;
		var sParams = new $.ig.ScalerParams(windowRect, viewportRect, p.scaler().isInverted());
		var yParams = new $.ig.ScalerParams(windowRect, viewportRect, p.yScaler().isInverted());
		if (isSortingScaler) {
			singlePixelSpan = $self.convertToBucket(p.scaler().getUnscaledValue(2, sParams) - p.scaler().getUnscaledValue(1, sParams));
			isAreaOrLineBasedSeries = $self.isAreaOrLine();
		}

		for (var i = p.firstBucket(); i <= p.lastBucket(); ++i) {
			var bucket;
			if (!isSortingScaler) {
				bucket = $self.bucketizingHost().getBucket(i);

			} else {
				bucket = (function () { var $ret = $self.sortingBucketize(p, i, h, singlePixelSpan, isCluster, endBucket, offset); i = $ret.p1; isCluster = $ret.p4; endBucket = $ret.p5; return $ret.ret; }());
			}

			var isValidBucket = !isLogarithmicYScaler || (isLogarithmicYScaler && bucket[1] > 0);
			var bucketX = bucket[0];
			if (!isNaN(bucket[0])) {
				$self.scaleBucketValues(p, bucket, offset, isSortingScaler, sParams, yParams);
				p.frame()._buckets.add(bucket);
				if (isCluster && isAreaOrLineBasedSeries) {
					if (endBucket != null) {
						$self.scaleBucketValues(p, endBucket, offset, isSortingScaler, sParams, yParams);
						p.frame()._buckets.add(endBucket);
					}

				}

				if (markers && isValidBucket) {
					var itemIndex = i * p.bucketSize();
					var unsortedIndex = itemIndex;
					if (isSortingScaler && p.sortingScaler().sortedIndices() != null && itemIndex >= 0 && itemIndex < p.sortingScaler().sortedIndices().count()) {
						itemIndex = p.sortingScaler().sortedIndices().__inner[itemIndex];
					}

					var markerBucket = bucket;
					if (highMarkerFidelity && itemIndex < h.count()) {
						markerBucket = new Array(bucket.length);
						markerBucket[0] = bucketX;
						$self.storeYValues(h, itemIndex, true, p.isFragment());
						markerBucket[1] = h.tempY0();
						markerBucket[2] = h.tempY1();
						$self.scaleBucketValues(p, markerBucket, offset, isSortingScaler, sParams, yParams);
					}

					if ($self.prepareMarker(p.frame(), markerBucket, collisionAvoider, Math.min(itemIndex, h.count() - 1), markerCount, p.frame()._buckets.count() - 1)) {
						++markerCount;
					}

				}

			}

		}

		return markerCount;
	}

	, 
	isAreaOrLine: function () {
		var isAreaOrLineBasedSeries = $.ig.util.cast($.ig.LineSeries.prototype.$type, this.categoryBasedHost()) !== null || $.ig.util.cast($.ig.SplineSeriesBase.prototype.$type, this.categoryBasedHost()) !== null || $.ig.util.cast($.ig.AreaSeries.prototype.$type, this.categoryBasedHost()) !== null || $.ig.util.cast($.ig.StepLineSeries.prototype.$type, this.categoryBasedHost()) !== null || $.ig.util.cast($.ig.StepAreaSeries.prototype.$type, this.categoryBasedHost()) !== null || $.ig.util.cast($.ig.RangeAreaSeries.prototype.$type, this.categoryBasedHost()) !== null || $.ig.util.cast($.ig.LineFragment.prototype.$type, this.categoryBasedHost()) !== null || $.ig.util.cast($.ig.AreaFragment.prototype.$type, this.categoryBasedHost()) !== null;
		return isAreaOrLineBasedSeries;
	}

	, 
	storeYValues: function (h, index, useTemp, isFragment) {}

	, 
	minMaxYValues: function (h, index, isFragment) {}

	, 
	getBucketSorting: function (xVAl, h) {}

	, 
	sortingBucketize: function (p, currentIndex, h, singlePixelSpan, isCluster, endBucket, offset) {
		var $self = this;
		var bucket;
		endBucket = null;
		isCluster = false;
		var series = $.ig.util.cast($.ig.CategorySeries.prototype.$type, $self.categoryBasedHost());
		var rangeSeries = $.ig.util.cast($.ig.RangeCategorySeries.prototype.$type, $self.categoryBasedHost());
		var anchoredSeries = $.ig.util.cast($.ig.AnchoredCategorySeries.prototype.$type, $self.categoryBasedHost());
		var viewportRect = p.viewportRect();
		var windowRect = p.windowRect();
		var sParams = new $.ig.ScalerParams(windowRect, viewportRect, p.scaler().isInverted());
		var yParams = new $.ig.ScalerParams(windowRect, viewportRect, p.yScaler().isInverted());
		var isFragment = p.isFragment();
		if (p.sortingScaler() == null || p.sortingScaler().sortedIndices() == null || p.sortingScaler().sortedIndices().count() == 0) {
			return {
				ret: [ NaN, NaN, NaN ], 
				p1: currentIndex, 
				p4: isCluster, 
				p5: endBucket
			};
		}

		if (series != null && series.fastItemsSource() != null && series.fastItemsSource().count() < p.sortingScaler().sortedIndices().count()) {
			return {
				ret: [ NaN, NaN, NaN ], 
				p1: currentIndex, 
				p4: isCluster, 
				p5: endBucket
			};
		}

		var index = p.sortingScaler().sortedIndices().__inner[currentIndex];
		var bucketX = p.sortingScaler().getUnscaledValueAt(index);
		var currentX = bucketX;
		$self.storeYValues(h, index, false, isFragment);
		while (currentIndex < p.lastBucket()) {
			index = p.sortingScaler().sortedIndices().__inner[currentIndex + 1];
			currentX = p.sortingScaler().getUnscaledValueAt(index);
			$self.storeYValues(h, index, true, isFragment);
			if (currentX - bucketX >= singlePixelSpan || $.ig.util.isNaN(h.tempY0()) || $.ig.util.isNaN(h.tempY1())) {
				if (isCluster) {
					var previousIndex = p.sortingScaler().sortedIndices().__inner[currentIndex];
					$self.storeYValues(h, previousIndex, true, isFragment);
					endBucket = [ p.scaler().getScaledValue(bucketX + singlePixelSpan, sParams), h.tempY0(), h.tempY1() ];
				}

				break;
			}

			if (!isCluster && $self.isAreaOrLine()) {
				var previousIndex1 = p.sortingScaler().sortedIndices().__inner[currentIndex];
				$self.storeYValues(h, previousIndex1, true, isFragment);
				var startBucket = [ p.scaler().getScaledValue(bucketX, sParams), h.tempY0(), h.tempY1() ];
				if (!$.ig.util.isNaN(startBucket[0])) {
					if (!$.ig.util.isNaN(startBucket[1]) && !$.ig.util.isNaN(startBucket[2])) {
						$self.scaleBucketValues(p, startBucket, offset, p.sortingScaler() != null, sParams, yParams);
						p.frame()._buckets.add(startBucket);
						isCluster = true;

					} else {
						break;
					}

				}

			}

			currentIndex++;
			$self.minMaxYValues(h, index, isFragment);

		}
		var xVal = NaN;
		if (!$.ig.util.isNaN(bucketX)) {
			xVal = p.scaler().getScaledValue(bucketX, sParams);
		}

		bucket = $self.getBucketSorting(xVal, h);
		return {
			ret: bucket, 
			p1: currentIndex, 
			p4: isCluster, 
			p5: endBucket
		};
	}

	, 
	scaleBucketValues: function (pp, bucket, offset, isSortingScaler, xParams, yParams) {}

	, 
	prepareTrendline: function (pp, h, offset) {
	}

	, 
	getValues: function (p) {}
	, 
	$type: new $.ig.Type('CategoryFramePreparerBase', $.ig.FramePreparer.prototype.$type)
}, true);

$.ig.util.defType('CategoryFramePreparer', 'CategoryFramePreparerBase', {
	init: function (initNumber, host) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.CategoryFramePreparer.prototype.init1.call(this, 1, host, $.ig.util.cast($.ig.ISupportsMarkers.prototype.$type, host), $.ig.util.cast($.ig.IProvidesViewport.prototype.$type, host), $.ig.util.cast($.ig.ISupportsErrorBars.prototype.$type, host), $.ig.util.cast($.ig.IBucketizer.prototype.$type, host));
	}
	, 
	init1: function (initNumber, host, markersHost, viewportHost, errorBarsHost, bucketizingHost) {


		$.ig.CategoryFramePreparerBase.prototype.init1.call(this, 1, host, markersHost, viewportHost, errorBarsHost, bucketizingHost);
			this.trendlineHost(new $.ig.DefaultCategoryTrendlineHost());
			if ($.ig.util.cast($.ig.IHasCategoryTrendline.prototype.$type, host) !== null) {
				this.trendlineHost($.ig.util.cast($.ig.IHasCategoryTrendline.prototype.$type, host));
			}

			this.valuesProvider(new $.ig.DefaultSingleValueProvider());
			if ($.ig.util.cast($.ig.IHasSingleValueCategory.prototype.$type, host) !== null) {
				this.valuesProvider($.ig.util.cast($.ig.IHasSingleValueCategory.prototype.$type, host));
			}

	}

	, 
	_trendlineHost: null,
	trendlineHost: function (value) {
		if (arguments.length === 1) {
			this._trendlineHost = value;
			return value;
		} else {
			return this._trendlineHost;
		}
	}

	, 
	_valuesProvider: null,
	valuesProvider: function (value) {
		if (arguments.length === 1) {
			this._valuesProvider = value;
			return value;
		} else {
			return this._valuesProvider;
		}
	}

	, 
	prepareMarker: function (frame, bucket, collisionAvoider, itemIndex, markerCount, markerBucket) {
		var x = bucket[0];
		var y = bucket[1];
		var markerRect = new $.ig.Rect(0, x - 5, y - 5, 11, 11);
		if (!$.ig.util.isNaN(x) && !$.ig.util.isNaN(y) && !Number.isInfinity(x) && !Number.isInfinity(y) && collisionAvoider.tryAdd(markerRect)) {
			frame._markers.add({__x: x, __y: y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			this.markersHost().updateMarkerTemplate(markerCount, itemIndex, markerBucket);
			return true;
		}

		return false;
	}

	, 
	getValues: function (p) {
		var h = new $.ig.SingleValuesHolder();
		var values = this.valuesProvider().valueColumn();
		h.values(values);
		return h;
	}

	, 
	scaleBucketValues: function (p, bucket, offset, isSortingScaler, xParams, yParams) {
		if (isSortingScaler) {
			bucket[0] = (bucket[0] + offset);

		} else {
			bucket[0] = (p.scaler().getScaledValue(bucket[0], xParams) + offset);
		}

		bucket[1] = p.yScaler().getScaledValue(bucket[1], yParams);
		if (p.bucketSize() > 1 || isSortingScaler) {
			bucket[2] = p.yScaler().getScaledValue(bucket[2], yParams);

		} else {
			bucket[2] = bucket[1];
		}

	}

	, 
	prepareTrendline: function (p, h, offset) {
		var $self = this;
		if ($self.trendlineHost().trendLineType() == $.ig.TrendLineType.prototype.none || $self.trendlineHost().trendlinePreparer() == null || $self.trendlineHost().trendLinePeriod() < 1) {
			return;
		}

		var xParams = new $.ig.ScalerParams(p.windowRect(), p.viewportRect(), p.scaler().isInverted());
		var yParams = new $.ig.ScalerParams(p.windowRect(), p.viewportRect(), p.yScaler().isInverted());
		var values = (h).values();
		if (p.sortingScaler() != null && p.sortingScaler().sortedIndices() != null) {
			values = new $.ig.SafeSortedReadOnlyDoubleCollection(values, p.sortingScaler().sortedIndices());
		}

		var trendResolutionParams = (function () { var $ret = new $.ig.TrendResolutionParams();
		$ret.bucketSize(p.bucketSize());
		$ret.firstBucket(p.firstBucket());
		$ret.lastBucket(p.lastBucket());
		$ret.offset(offset);
		$ret.resolution(p.resolution());
		$ret.viewport(p.viewportRect()); return $ret;}());
		if ($self.trendlineHost().trendLineType() != $.ig.TrendLineType.prototype.none) {
			if ($.ig.util.cast($.ig.IBarSeries.prototype.$type, $self.trendlineHost()) !== null) {
				$self.trendlineHost().trendlinePreparer().prepareLine(p.frame()._trend, $self.trendlineHost().trendLineType(), values, $self.trendlineHost().trendLinePeriod(), function (y) { return p.yScaler().getScaledValue(y, yParams); }, function (x) { return p.scaler().getScaledValue(x, xParams); }, trendResolutionParams);

			} else {
				$self.trendlineHost().trendlinePreparer().prepareLine(p.frame()._trend, $self.trendlineHost().trendLineType(), values, $self.trendlineHost().trendLinePeriod(), function (x) { return p.scaler().getScaledValue(x, xParams); }, function (y) { return p.yScaler().getScaledValue(y, yParams); }, trendResolutionParams);
			}

		}

	}

	, 
	storeYValues: function (h, index, useTemp, isFragment) {
		var s = h;
		var values = s.values();
		var bucketY0 = this.convertToBucket(values.item(index));
		var bucketY1 = bucketY0;
		if (isFragment) {
			var bucket = this.bucketizingHost().getBucket(index);
			bucketY0 = bucket[1];
			bucketY1 = bucket[1];
		}

		if (useTemp) {
			s.tempY0(bucketY0);
			s.tempY1(bucketY1);

		} else {
			s.bucketY0(bucketY0);
			s.bucketY1(bucketY1);
		}

	}

	, 
	minMaxYValues: function (h, index, isFragment) {
		var s = h;
		var values = s.values();
		if (index < values.count()) {
			var y;
			if (isFragment) {
				var bucket = this.bucketizingHost().getBucket(index);
				y = bucket[1];

			} else {
				y = this.convertToBucket(values.item(index));
			}

			s.bucketY0(Math.min(s.bucketY0(), y));
			s.bucketY1(Math.max(s.bucketY1(), y));
		}

	}

	, 
	getBucketSorting: function (xVal, h) {
		var $self = this;
		var s = h;
		return (function () { var $ret = new Array();
		$ret.add($self.convertToBucket(xVal));
		$ret.add(s.bucketY0());
		$ret.add(s.bucketY1());return $ret;}());
	}
	, 
	$type: new $.ig.Type('CategoryFramePreparer', $.ig.CategoryFramePreparerBase.prototype.$type)
}, true);

$.ig.util.defType('BarFramePreparer', 'CategoryFramePreparer', {
	init: function (initNumber, host) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.BarFramePreparer.prototype.init1.call(this, 1, host, $.ig.util.cast($.ig.ISupportsMarkers.prototype.$type, host), $.ig.util.cast($.ig.IProvidesViewport.prototype.$type, host), $.ig.util.cast($.ig.ISupportsErrorBars.prototype.$type, host), $.ig.util.cast($.ig.IBucketizer.prototype.$type, host));
	}
	, 
	init1: function (initNumber, host, markersHost, viewportHost, errorBarsHost, bucketizingHost) {


		$.ig.CategoryFramePreparer.prototype.init1.call(this, 1, host, markersHost, viewportHost, errorBarsHost, bucketizingHost);
			this.trendlineHost(new $.ig.DefaultCategoryTrendlineHost());
			if ($.ig.util.cast($.ig.IHasCategoryTrendline.prototype.$type, host) !== null) {
				this.trendlineHost($.ig.util.cast($.ig.IHasCategoryTrendline.prototype.$type, host));
			}

			this.valuesProvider(new $.ig.DefaultSingleValueProvider());
			if ($.ig.util.cast($.ig.IHasSingleValueCategory.prototype.$type, host) !== null) {
				this.valuesProvider($.ig.util.cast($.ig.IHasSingleValueCategory.prototype.$type, host));
			}

	}

	, 
	prepareMarker: function (frame, bucket, collisionAvoider, itemIndex, markerCount, markerBucket) {
		var x = bucket[1];
		var y = bucket[0];
		var markerRect = new $.ig.Rect(0, x - 5, y - 5, 11, 11);
		if (!$.ig.util.isNaN(x) && !$.ig.util.isNaN(y) && !Number.isInfinity(x) && !Number.isInfinity(y) && collisionAvoider.tryAdd(markerRect)) {
			frame._markers.add({__x: x, __y: y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			this.markersHost().updateMarkerTemplate(markerCount, itemIndex, markerBucket);
			return true;
		}

		return false;
	}

	, 
	prepareTrendline: function (p, h, offset) {
		var $self = this;
		if ($self.trendlineHost().trendLineType() == $.ig.TrendLineType.prototype.none || $self.trendlineHost().trendlinePreparer() == null || $self.trendlineHost().trendLinePeriod() < 1) {
			return;
		}

		var sParams = new $.ig.ScalerParams(p.windowRect(), p.viewportRect(), p.scaler().isInverted());
		var yParams = new $.ig.ScalerParams(p.windowRect(), p.viewportRect(), p.yScaler().isInverted());
		var values = (h).values();
		if (p.sortingScaler() != null && p.sortingScaler().sortedIndices() != null) {
			values = new $.ig.SafeSortedReadOnlyDoubleCollection(values, p.sortingScaler().sortedIndices());
		}

		var trendResolutionParams = (function () { var $ret = new $.ig.TrendResolutionParams();
		$ret.bucketSize(p.bucketSize());
		$ret.firstBucket(p.firstBucket());
		$ret.lastBucket(p.lastBucket());
		$ret.offset(offset);
		$ret.resolution(p.resolution());
		$ret.viewport(p.viewportRect()); return $ret;}());
		if ($self.trendlineHost().trendLineType() != $.ig.TrendLineType.prototype.none) {
			$self.trendlineHost().trendlinePreparer().prepareLine(p.frame()._trend, $self.trendlineHost().trendLineType(), values, $self.trendlineHost().trendLinePeriod(), function (x) { return p.yScaler().getScaledValue(x, yParams); }, function (y) { return p.scaler().getScaledValue(y, sParams); }, trendResolutionParams);
		}

	}
	, 
	$type: new $.ig.Type('BarFramePreparer', $.ig.CategoryFramePreparer.prototype.$type)
}, true);

$.ig.util.defType('BarTrendFitCalculator', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	calculateFit: function (trend, trendLineType, trendResolutionParams, trendCoefficients, count, GetUnscaledX, GetUnscaledY, GetScaledXValue, GetScaledYValue, ymin, ymax) {
		if (trendCoefficients == null) {
			switch (trendLineType) {
				case $.ig.TrendLineType.prototype.linearFit:
					trendCoefficients = $.ig.LeastSquaresFit.prototype.linearFit(count, GetUnscaledY, GetUnscaledX);
					break;
				case $.ig.TrendLineType.prototype.quadraticFit:
					trendCoefficients = $.ig.LeastSquaresFit.prototype.quadraticFit(count, GetUnscaledY, GetUnscaledX);
					break;
				case $.ig.TrendLineType.prototype.cubicFit:
					trendCoefficients = $.ig.LeastSquaresFit.prototype.cubicFit(count, GetUnscaledY, GetUnscaledX);
					break;
				case $.ig.TrendLineType.prototype.quarticFit:
					trendCoefficients = $.ig.LeastSquaresFit.prototype.quarticFit(count, GetUnscaledY, GetUnscaledX);
					break;
				case $.ig.TrendLineType.prototype.quinticFit:
					trendCoefficients = $.ig.LeastSquaresFit.prototype.quinticFit(count, GetUnscaledY, GetUnscaledX);
					break;
				case $.ig.TrendLineType.prototype.exponentialFit:
					trendCoefficients = $.ig.LeastSquaresFit.prototype.exponentialFit(count, GetUnscaledY, GetUnscaledX);
					break;
				case $.ig.TrendLineType.prototype.logarithmicFit:
					trendCoefficients = $.ig.LeastSquaresFit.prototype.logarithmicFit(count, GetUnscaledY, GetUnscaledX);
					break;
				case $.ig.TrendLineType.prototype.powerLawFit:
					trendCoefficients = $.ig.LeastSquaresFit.prototype.powerLawFit(count, GetUnscaledY, GetUnscaledX);
					break;
				default:
					throw new $.ig.NotImplementedException(0);
			}

		}

		if (trendCoefficients == null) {
			return null;
		}

		for (var i = 0; i < trendResolutionParams.viewport().height(); i += 2) {
			var p = i / (trendResolutionParams.viewport().height() - 1);
			var yi = ymin + p * (ymax - ymin);
			var xi = NaN;
			switch (trendLineType) {
				case $.ig.TrendLineType.prototype.linearFit:
					xi = $.ig.LeastSquaresFit.prototype.linearEvaluate(trendCoefficients, yi);
					break;
				case $.ig.TrendLineType.prototype.quadraticFit:
					xi = $.ig.LeastSquaresFit.prototype.quadraticEvaluate(trendCoefficients, yi);
					break;
				case $.ig.TrendLineType.prototype.cubicFit:
					xi = $.ig.LeastSquaresFit.prototype.cubicEvaluate(trendCoefficients, yi);
					break;
				case $.ig.TrendLineType.prototype.quarticFit:
					xi = $.ig.LeastSquaresFit.prototype.quarticEvaluate(trendCoefficients, yi);
					break;
				case $.ig.TrendLineType.prototype.quinticFit:
					xi = $.ig.LeastSquaresFit.prototype.quinticEvaluate(trendCoefficients, yi);
					break;
				case $.ig.TrendLineType.prototype.exponentialFit:
					xi = $.ig.LeastSquaresFit.prototype.exponentialEvaluate(trendCoefficients, yi);
					break;
				case $.ig.TrendLineType.prototype.logarithmicFit:
					xi = $.ig.LeastSquaresFit.prototype.logarithmicEvaluate(trendCoefficients, yi);
					break;
				case $.ig.TrendLineType.prototype.powerLawFit:
					xi = $.ig.LeastSquaresFit.prototype.powerLawEvaluate(trendCoefficients, yi);
					break;
				default:
					throw new $.ig.NotImplementedException(0);
			}

			xi = GetScaledXValue(xi);
			yi = GetScaledYValue(yi);
			if (!$.ig.util.isNaN(xi) && !Number.isInfinity(xi)) {
				trend.add({__x: xi, __y: yi + trendResolutionParams.offset(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			}

		}

		return trendCoefficients;
	}
	, 
	$type: new $.ig.Type('BarTrendFitCalculator', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('IPreparesCategoryTrendline', 'Object', {
	$type: new $.ig.Type('IPreparesCategoryTrendline', null)
}, true);

$.ig.util.defType('TrendLineManagerBase$1', 'Object', {
	$tTrendColumn: null
	, 
	_trendColumn: null,
	trendColumn: function (value) {
		if (arguments.length === 1) {
			this._trendColumn = value;
			return value;
		} else {
			return this._trendColumn;
		}
	}

	, 
	_trendCoefficients: null,
	trendCoefficients: function (value) {
		if (arguments.length === 1) {
			this._trendCoefficients = value;
			return value;
		} else {
			return this._trendCoefficients;
		}
	}
	, 
	init: function ($tTrendColumn) {

		this.$tTrendColumn = $tTrendColumn;
		this.$type = this.$type.specialize(this.$tTrendColumn);

		this._trendPolyline = (function () { var $ret = new $.ig.Polyline();
		$ret.isHitTestVisible(false); return $ret;}());

		$.ig.Object.prototype.init.call(this);
			this.trendColumn(new $.ig.List$1(this.$tTrendColumn, 0));
	}

	, 
	trendPolyline: function () {

			return this._trendPolyline;
	}
	, 
	_trendPolyline: null

	, 
	rasterizeTrendLine: function (trendPoints) {
		this.rasterizeTrendLine1(trendPoints, null);
	}

	, 
	isFit: function (type) {
		return type == $.ig.TrendLineType.prototype.linearFit || type == $.ig.TrendLineType.prototype.quadraticFit || type == $.ig.TrendLineType.prototype.cubicFit || type == $.ig.TrendLineType.prototype.quarticFit || type == $.ig.TrendLineType.prototype.quinticFit || type == $.ig.TrendLineType.prototype.logarithmicFit || type == $.ig.TrendLineType.prototype.exponentialFit || type == $.ig.TrendLineType.prototype.powerLawFit;
	}

	, 
	isAverage: function (type) {
		return type == $.ig.TrendLineType.prototype.simpleAverage || type == $.ig.TrendLineType.prototype.exponentialAverage || type == $.ig.TrendLineType.prototype.modifiedAverage || type == $.ig.TrendLineType.prototype.cumulativeAverage || type == $.ig.TrendLineType.prototype.weightedAverage;
	}

	, 
	rasterizeTrendLine1: function (trendPoints, clipper) {
		this.trendPolyline().points().clear();
		if (clipper != null) {
			clipper.target(this.trendPolyline().points());
		}

		if (trendPoints != null) {
			var en = trendPoints.getEnumerator();
			while (en.moveNext()) {
				var point = en.current();
				if (!$.ig.util.isNaN(point.__x) && !$.ig.util.isNaN(point.__y)) {
					if (clipper != null) {
						clipper.add(point);

					} else {
						this.trendPolyline().points().add(point);
					}

				}

			}

		}

		this.trendPolyline().isHitTestVisible(this.trendPolyline().points().count() > 0);
	}

	, 
	flattenTrendLine: function (trend, trendResolutionParams, flattenedPoints) {
		this.flattenTrendLine1(trend, trendResolutionParams, flattenedPoints, null);
	}

	, 
	flattenTrendLine1: function (trend, trendResolutionParams, flattenedPoints, clipper) {
		var $self = this;
		if (clipper != null) {
			clipper.target(flattenedPoints);
		}

		var en = $.ig.Flattener.prototype.flatten3(trend.count(), function (i) { return trend.item(i).__x; }, function (i) { return trend.item(i).__y; }, trendResolutionParams.resolution()).getEnumerator();
		while (en.moveNext()) {
			var i = en.current();
			if (clipper != null) {
				clipper.add(trend.item(i));

			} else {
				flattenedPoints.add(trend.item(i));
			}

		}

	}

	, 
	attachPolyLine: function (rootCanvas, owner) {
		if (rootCanvas == null || owner == null) {
			return;
		}

		if (this.trendPolyline().parent() != null) {
			this.detach();
		}

		rootCanvas.children().add(this.trendPolyline());
	}

	, 
	detach: function () {
		if (this.trendPolyline() == null) {
			return;
		}

		var parent = $.ig.util.cast($.ig.Panel.prototype.$type, this.trendPolyline().parent());
		if (parent != null) {
			parent.children().remove(this.trendPolyline());
		}

	}

	, 
	clearPoints: function () {
		this.trendPolyline().points().clear();
	}

	, 
	reset: function () {
		this.trendCoefficients(null);
		this.trendColumn().clear();
	}

	, 
	dataUpdated: function (action, position, count, propertyName) {
		switch (action) {
			case $.ig.FastItemsSourceEventAction.prototype.change:
			case $.ig.FastItemsSourceEventAction.prototype.replace:
			case $.ig.FastItemsSourceEventAction.prototype.insert:
			case $.ig.FastItemsSourceEventAction.prototype.remove:
			case $.ig.FastItemsSourceEventAction.prototype.reset:
				this.reset();
				break;
		}

	}

	, 
	propertyUpdated: function (sender, propertyName, oldValue, newValue) {
		var requiresRender = false;
		switch (propertyName) {
			case $.ig.TrendLineManagerBase$1.prototype.trendLineTypePropertyName:
			case $.ig.TrendLineManagerBase$1.prototype.trendLinePeriodPropertyName:
				this.reset();
				requiresRender = true;
				break;
			case $.ig.TrendLineManagerBase$1.prototype.trendLineThicknessPropertyName:
				requiresRender = true;
				break;
			case $.ig.Series.prototype.fastItemsSourcePropertyName:
				requiresRender = true;
				this.reset();
				break;
		}

		return requiresRender;
	}
	, 
	$type: new $.ig.Type('TrendLineManagerBase$1', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('CategoryTrendLineManagerBase', 'TrendLineManagerBase$1', {
	init: function () {


		$.ig.TrendLineManagerBase$1.prototype.init.call(this, Number);

	}
	, 
	prepareLine: function (flattenedPoints, trendLineType, valueColumn, period, GetScaledXValue, GetScaledYValue, trendResolutionParams) {}

	, 
	selectManager: function (trendLineManager, xAxis, rootCanvas, series) {
		var $self = this;
		if (xAxis != null && $.ig.util.cast($.ig.ISortingAxis.prototype.$type, xAxis) !== null) {
			if (trendLineManager != null) {
				trendLineManager.detach();
			}

			var newManager = new $.ig.SortingTrendLineManager(function (x) {
				var sortedIndex = x;
				var axis = $.ig.util.cast($.ig.ISortingAxis.prototype.$type, xAxis);
				if (axis != null) {
					x = Math.min(x, axis.sortedIndices().count() - 1);
					sortedIndex = axis.sortedIndices().__inner[x];
				}

				return axis.getUnscaledValueAt(sortedIndex);
			}, function (x, viewport, window) {
				var xParams = new $.ig.ScalerParams(window, viewport, xAxis.isInverted());
				return xAxis.getUnscaledValue(x, xParams);
			});
			newManager.attachPolyLine(rootCanvas, series);
			return newManager;

		} else if (!($.ig.util.cast($.ig.CategoryTrendLineManager.prototype.$type, trendLineManager) !== null)) {
			if (trendLineManager != null) {
				trendLineManager.detach();
			}

			var newManager1 = new $.ig.CategoryTrendLineManager();
			newManager1.attachPolyLine(rootCanvas, series);
			return newManager1;
		}


		return trendLineManager;
	}
	, 
	$type: new $.ig.Type('CategoryTrendLineManagerBase', $.ig.TrendLineManagerBase$1.prototype.$type.specialize(Number), [$.ig.IPreparesCategoryTrendline.prototype.$type])
}, true);

$.ig.util.defType('CategoryTrendLineManager', 'CategoryTrendLineManagerBase', {
	init: function () {


		$.ig.CategoryTrendLineManagerBase.prototype.init.call(this);

	}
	, 
	prepareLine: function (flattenedPoints, trendLineType, valueColumn, period, GetScaledXValue, GetScaledYValue, trendResolutionParams) {
		var $self = this;
		var xmin = trendResolutionParams.firstBucket() * trendResolutionParams.bucketSize();
		var xmax = trendResolutionParams.lastBucket() * trendResolutionParams.bucketSize();
		var trend = new $.ig.List$1($.ig.Point.prototype.$type, 0);
		if (trendLineType == $.ig.TrendLineType.prototype.none) {
			$self.trendCoefficients(null);
			$self.trendColumn().clear();
			return;
		}

		if ($self.isFit(trendLineType)) {
			$self.trendColumn().clear();
			$self.trendCoefficients($.ig.TrendFitCalculator.prototype.calculateFit(trend, trendLineType, trendResolutionParams, $self.trendCoefficients(), valueColumn.count(), function (i) { return (i + 1); }, function (i) { return valueColumn.item(i); }, function (x) { return GetScaledXValue(x - 1); }, GetScaledYValue, xmin + 1, xmax + 1));
		}

		if ($self.isAverage(trendLineType)) {
			$self.trendCoefficients(null);
			$.ig.TrendAverageCalculator.prototype.calculateSingleValueAverage(trendLineType, $self.trendColumn(), valueColumn, period);
			for (var i = trendResolutionParams.firstBucket(); i <= trendResolutionParams.lastBucket(); i += 1) {
				var itemIndex = i * trendResolutionParams.bucketSize();
				if (itemIndex >= 0 && itemIndex < $self.trendColumn().count()) {
					var xi = GetScaledXValue(itemIndex);
					var yi = GetScaledYValue($self.trendColumn().__inner[itemIndex]);
					trend.add({__x: xi + trendResolutionParams.offset(), __y: yi, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
				}

			}

		}

		$self.flattenTrendLine(trend, trendResolutionParams, flattenedPoints);
	}
	, 
	$type: new $.ig.Type('CategoryTrendLineManager', $.ig.CategoryTrendLineManagerBase.prototype.$type)
}, true);

$.ig.util.defType('BarTrendLineManager', 'CategoryTrendLineManager', {
	init: function () {


		$.ig.CategoryTrendLineManager.prototype.init.call(this);

	}
	, 
	prepareLine: function (flattenedPoints, trendLineType, valueColumn, period, GetScaledXValue, GetScaledYValue, trendResolutionParams) {
		var $self = this;
		var ymin = trendResolutionParams.firstBucket() * trendResolutionParams.bucketSize();
		var ymax = trendResolutionParams.lastBucket() * trendResolutionParams.bucketSize();
		var trend = new $.ig.List$1($.ig.Point.prototype.$type, 0);
		if (trendLineType == $.ig.TrendLineType.prototype.none) {
			$self.trendCoefficients(null);
			$self.trendColumn().clear();
			return;
		}

		if ($self.isFit(trendLineType)) {
			$self.trendColumn().clear();
			$self.trendCoefficients($.ig.BarTrendFitCalculator.prototype.calculateFit(trend, trendLineType, trendResolutionParams, $self.trendCoefficients(), valueColumn.count(), function (i) { return valueColumn.item(i); }, function (i) { return i + 1; }, GetScaledXValue, function (x) { return GetScaledYValue(x - 1); }, ymin + 1, ymax + 1));
		}

		if ($self.isAverage(trendLineType)) {
			$self.trendCoefficients(null);
			$.ig.TrendAverageCalculator.prototype.calculateSingleValueAverage(trendLineType, $self.trendColumn(), valueColumn, period);
			for (var i = trendResolutionParams.firstBucket(); i <= trendResolutionParams.lastBucket(); i += 1) {
				var itemIndex = i * trendResolutionParams.bucketSize();
				if (itemIndex >= 0 && itemIndex < $self.trendColumn().count()) {
					var xi = GetScaledXValue($self.trendColumn().__inner[itemIndex]);
					var yi = GetScaledYValue(itemIndex);
					trend.add({__x: xi, __y: yi + trendResolutionParams.offset(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
				}

			}

		}

		$self.flattenTrendLine(trend, trendResolutionParams, flattenedPoints);
	}
	, 
	$type: new $.ig.Type('BarTrendLineManager', $.ig.CategoryTrendLineManager.prototype.$type)
}, true);




$.ig.util.defType('MarkerSeries', 'Series', {

	_markerView: null,
	markerView: function (value) {
		if (arguments.length === 1) {
			this._markerView = value;
			return value;
		} else {
			return this._markerView;
		}
	}
	, 
	init: function () {



		$.ig.Series.prototype.init.call(this);
	}

	, 
	onViewCreated: function (view) {
		$.ig.Series.prototype.onViewCreated.call(this, view);
		this.markerView(view);
	}

	, 
	hasMarkers: function () {

			return true;
	}

	, 
	getActualMarkerBrush: function () {
		return this.actualMarkerBrush();
	}

	, 
	getActualMarkerOutlineBrush: function () {
		return this.actualMarkerOutline();
	}

	, 
	getActualMarkerTemplate: function () {
		return this._cachedActualMarkerTemplate;
	}

	, 
	markerType: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.MarkerSeries.prototype.markerTypeProperty, $.ig.MarkerType.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.MarkerSeries.prototype.markerTypeProperty));
		}
	}

	, 
	markerTemplate: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.MarkerSeries.prototype.markerTemplateProperty, value);
			return value;
		} else {

			return this.getValue($.ig.MarkerSeries.prototype.markerTemplateProperty);
		}
	}

	, 
	actualMarkerTemplate: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.MarkerSeries.prototype.actualMarkerTemplateProperty, value);
			return value;
		} else {

			return this.getValue($.ig.MarkerSeries.prototype.actualMarkerTemplateProperty);
		}
	}
	, 
	_cachedActualMarkerTemplate: null

	, 
	nullMarkerTemplate: function () {

			if ($.ig.MarkerSeries.prototype.__nullMarkerTemplate == null) {
				$.ig.MarkerSeries.prototype.__nullMarkerTemplate = new $.ig.DataTemplate();
			}

			return $.ig.MarkerSeries.prototype.__nullMarkerTemplate;
	}

	, 
	markerBrush: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.MarkerSeries.prototype.markerBrushProperty, value);
			return value;
		} else {

			return this.getValue($.ig.MarkerSeries.prototype.markerBrushProperty);
		}
	}

	, 
	actualMarkerBrush: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.MarkerSeries.prototype.actualMarkerBrushProperty, value);
			return value;
		} else {

			return this.getValue($.ig.MarkerSeries.prototype.actualMarkerBrushProperty);
		}
	}

	, 
	markerOutline: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.MarkerSeries.prototype.markerOutlineProperty, value);
			return value;
		} else {

			return this.getValue($.ig.MarkerSeries.prototype.markerOutlineProperty);
		}
	}

	, 
	actualMarkerOutline: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.MarkerSeries.prototype.actualMarkerOutlineProperty, value);
			return value;
		} else {

			return this.getValue($.ig.MarkerSeries.prototype.actualMarkerOutlineProperty);
		}
	}

	, 
	markerStyle: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.MarkerSeries.prototype.markerStyleProperty, value);
			return value;
		} else {

			return this.getValue($.ig.MarkerSeries.prototype.markerStyleProperty);
		}
	}

	, 
	useLightweightMarkers: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.MarkerSeries.prototype.useLightweightMarkersProperty, value);
			return value;
		} else {

			return this.getValue($.ig.MarkerSeries.prototype.useLightweightMarkersProperty);
		}
	}

	, 
	shouldDisplayMarkers: function () {
		return this._cachedActualMarkerTemplate != null && ((this.markerType() != $.ig.MarkerType.prototype.none && this.markerType() != $.ig.MarkerType.prototype.unset) || this.markerTemplate() != null);
	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		$.ig.Series.prototype.propertyUpdatedOverride.call(this, sender, propertyName, oldValue, newValue);
		switch (propertyName) {
			case $.ig.MarkerSeries.prototype.markerBrushPropertyName:
			case $.ig.MarkerSeries.prototype.markerTypePropertyName:
			case $.ig.MarkerSeries.prototype.markerOutlinePropertyName:
			case $.ig.MarkerSeries.prototype.markerTemplatePropertyName:
				this.updateIndexedProperties();
				this.onVisualPropertiesChanged();
				break;
			case $.ig.MarkerSeries.prototype.actualMarkerTemplatePropertyName:
				this._cachedActualMarkerTemplate = newValue;
				if (oldValue == $.ig.MarkerSeries.prototype.nullMarkerTemplate() || newValue == $.ig.MarkerSeries.prototype.nullMarkerTemplate() || (oldValue == null || newValue != null)) {
					this.markerView().doUpdateMarkerTemplates();
					var thumbnailView = $.ig.util.cast($.ig.MarkerSeriesView.prototype.$type, this.thumbnailView());
					if (thumbnailView != null) {
						thumbnailView.doUpdateMarkerTemplates();
					}

					this.renderSeries(false);
				}

				this.notifyThumbnailAppearanceChanged();
				break;
			case $.ig.MarkerSeries.prototype.useLightweightMarkersPropertyName:
				this.markerView().setUseLightweightMode(this.useLightweightMarkers());
				this.renderSeries(false);
				break;
		}

	}

	, 
	getMarkerTemplatePropertyName: function (markerType) {
		switch (markerType) {
			case $.ig.MarkerType.prototype.circle:
				return $.ig.XamDataChart.prototype.circleMarkerTemplatePropertyName;
			case $.ig.MarkerType.prototype.triangle:
				return $.ig.XamDataChart.prototype.triangleMarkerTemplatePropertyName;
			case $.ig.MarkerType.prototype.pyramid:
				return $.ig.XamDataChart.prototype.pyramidMarkerTemplatePropertyName;
			case $.ig.MarkerType.prototype.square:
				return $.ig.XamDataChart.prototype.squareMarkerTemplatePropertyName;
			case $.ig.MarkerType.prototype.diamond:
				return $.ig.XamDataChart.prototype.diamondMarkerTemplatePropertyName;
			case $.ig.MarkerType.prototype.pentagon:
				return $.ig.XamDataChart.prototype.pentagonMarkerTemplatePropertyName;
			case $.ig.MarkerType.prototype.hexagon:
				return $.ig.XamDataChart.prototype.hexagonMarkerTemplatePropertyName;
			case $.ig.MarkerType.prototype.tetragram:
				return $.ig.XamDataChart.prototype.tetragramMarkerTemplatePropertyName;
			case $.ig.MarkerType.prototype.pentagram:
				return $.ig.XamDataChart.prototype.pentagramMarkerTemplatePropertyName;
			case $.ig.MarkerType.prototype.hexagram:
				return $.ig.XamDataChart.prototype.hexagramMarkerTemplatePropertyName;
			default:
			case $.ig.MarkerType.prototype.unset:
			case $.ig.MarkerType.prototype.none:
				return null;
		}

	}

	, 
	resolveMarkerType: function (series, seriesMarkerType) {
		var $self = this;
		var markerType = series.seriesViewer() != null ? seriesMarkerType : $.ig.MarkerType.prototype.none;
		if (markerType == $.ig.MarkerType.prototype.automatic) {
			var markerTypes = (function () { var $ret = new Array();
			$ret.add($.ig.MarkerType.prototype.circle);
			$ret.add($.ig.MarkerType.prototype.triangle);
			$ret.add($.ig.MarkerType.prototype.pentagon);
			$ret.add($.ig.MarkerType.prototype.tetragram);
			$ret.add($.ig.MarkerType.prototype.diamond);
			$ret.add($.ig.MarkerType.prototype.square);
			$ret.add($.ig.MarkerType.prototype.hexagon);
			$ret.add($.ig.MarkerType.prototype.pentagram);
			$ret.add($.ig.MarkerType.prototype.pyramid);
			$ret.add($.ig.MarkerType.prototype.hexagram);return $ret;}());
			markerType = series.index() >= 0 ? markerTypes[series.index() % markerTypes.length] : $.ig.MarkerType.prototype.none;
		}

		return markerType;
	}

	, 
	updateIndexedProperties: function () {
		$.ig.Series.prototype.updateIndexedProperties.call(this);
		if (this.index() < 0) {
			return;
		}

		if (this.markerView().hasCustomMarkerTemplate()) {
			this.markerView().clearActualMarkerTemplate();
			this.markerView().bindActualToCustomMarkerTemplate();

		} else {
			var markerType = $.ig.MarkerSeries.prototype.resolveMarkerType(this, this.markerType());
			var markerTemplatePropertyName = $.ig.MarkerSeries.prototype.getMarkerTemplatePropertyName(markerType);
			if (markerTemplatePropertyName == null) {
				this.actualMarkerTemplate($.ig.MarkerSeries.prototype.nullMarkerTemplate());

			} else {
				this.markerView().bindActualToMarkerTemplate(markerTemplatePropertyName);
			}

		}

		if (this.markerBrush() != null) {
			this.markerView().clearActualMarkerBrush();
			this.markerView().bindActualToMarkerBrush();

		} else {
			this.actualMarkerBrush(this.seriesViewer() == null ? null : this.seriesViewer().getMarkerBrushByIndex(this.index()));
		}

		if (this.markerOutline() != null) {
			this.markerView().clearActualMarkerOutline();
			this.markerView().bindActualToMarkerOutline();

		} else {
			this.actualMarkerOutline(this.seriesViewer() == null ? null : this.seriesViewer().getMarkerOutlineByIndex(this.index()));
		}

	}

	, 
	exportVisualDataOverride: function (svd) {
		var $self = this;
		$.ig.Series.prototype.exportVisualDataOverride.call($self, svd);
		$self.markerView().doToAllMarkers(function (m) {
			var mvd = new $.ig.MarkerVisualData();
			var appearance = new $.ig.PrimitiveAppearanceData();
			mvd.x(m.canvasLeft());
			mvd.y(m.canvasTop());
			appearance.fill($.ig.Color.prototype.fromArgb(0, 0, 0, 0));
			appearance.stroke($.ig.Color.prototype.fromArgb(0, 0, 0, 0));
			mvd.index(-1);
			mvd.contentTemplate(m.contentTemplate());
			if (m.content() != null && $.ig.util.cast($.ig.DataContext.prototype.$type, m.content()) !== null && m.__visibility == $.ig.Visibility.prototype.visible) {
				var dataContext = m.content();
				appearance.fill($.ig.AppearanceHelper.prototype.fromBrush(dataContext.actualItemBrush()));
				appearance.fillExtended($.ig.AppearanceHelper.prototype.fromBrushExtended(dataContext.actualItemBrush()));
				appearance.stroke($.ig.AppearanceHelper.prototype.fromBrush(dataContext.outline()));
				appearance.strokeExtended($.ig.AppearanceHelper.prototype.fromBrushExtended(dataContext.outline()));
				appearance.strokeThickness($self.thickness());
				if (dataContext.item() != null) {
					mvd.index($self.fastItemsSource().indexOf(dataContext.item()));
				}

			}

			mvd.visibility(m.__visibility);
			appearance.visibility(m.__visibility);
			mvd.markerAppearance(appearance);
			if ($self._cachedActualMarkerTemplate == $self.seriesViewer().circleMarkerTemplate()) {
				mvd.markerType("Circle");

			} else if ($self._cachedActualMarkerTemplate == $self.seriesViewer().diamondMarkerTemplate()) {
				mvd.markerType("Diamond");

			} else if ($self._cachedActualMarkerTemplate == $self.seriesViewer().hexagonMarkerTemplate()) {
				mvd.markerType("Hexagon");

			} else if ($self._cachedActualMarkerTemplate == $self.seriesViewer().hexagramMarkerTemplate()) {
				mvd.markerType("Hexagram");

			} else if ($self._cachedActualMarkerTemplate == $self.seriesViewer().pentagonMarkerTemplate()) {
				mvd.markerType("Pentagon");

			} else if ($self._cachedActualMarkerTemplate == $self.seriesViewer().pentagramMarkerTemplate()) {
				mvd.markerType("Pentagram");

			} else if ($self._cachedActualMarkerTemplate == $self.seriesViewer().pyramidMarkerTemplate()) {
				mvd.markerType("Pyramid");

			} else if ($self._cachedActualMarkerTemplate == $self.seriesViewer().squareMarkerTemplate()) {
				mvd.markerType("Square");

			} else if ($self._cachedActualMarkerTemplate == $self.seriesViewer().tetragramMarkerTemplate()) {
				mvd.markerType("Tetragram");

			} else if ($self._cachedActualMarkerTemplate == $self.seriesViewer().triangleMarkerTemplate()) {
				mvd.markerType("Triangle");

			} else {
				mvd.markerType("None");
			}










			svd.markerShapes().add(mvd);
		});
	}

	, 
	getHitDataContext: function (position) {
		var marker = this.markerView().getHitMarker(position);
		var ret = null;
		if (marker != null) {
			ret = marker.content();
		}

		return ret;
	}
	, 
	$type: new $.ig.Type('MarkerSeries', $.ig.Series.prototype.$type)
}, true);

$.ig.util.defType('ISupportsErrorBars', 'Object', {
	$type: new $.ig.Type('ISupportsErrorBars', null)
}, true);



$.ig.util.defType('MarkerSeriesView', 'SeriesView', {

	_markerModel: null,
	markerModel: function (value) {
		if (arguments.length === 1) {
			this._markerModel = value;
			return value;
		} else {
			return this._markerModel;
		}
	}
	, 
	init: function (model) {


		this.__hitMarker = new $.ig.Marker();

		$.ig.SeriesView.prototype.init.call(this, model);
			this.__hitMarker = new $.ig.Marker();
			this.__hitMarker.content(new $.ig.DataContext());
			this.markerModel(model);
	}

	, 
	onInit: function () {
		var $self = this;
		$.ig.SeriesView.prototype.onInit.call($self);
		$self.visibleMarkers(new $.ig.List$1($.ig.Marker.prototype.$type, 0));
		$self.__hitTemplate = (function () { var $ret = new $.ig.DataTemplate();
		$ret.render($.ig.MarkerTemplates.prototype.renderAlignedSquareMarkerTemplate);
		$ret.measure($.ig.MarkerTemplates.prototype.measureAsEightByEightConstantMarkerTemplate); return $ret;}());
	}

	, 
	doUpdateMarkerTemplates: function () {
		var en = this.visibleMarkers().getEnumerator();
		while (en.moveNext()) {
			var marker = en.current();
			marker.contentTemplate(this.markerModel()._cachedActualMarkerTemplate);
		}

		this.makeDirty();
	}

	, 
	setUseLightweightMode: function (p) {
	}

	, 
	_visibleMarkers: null,
	visibleMarkers: function (value) {
		if (arguments.length === 1) {
			this._visibleMarkers = value;
			return value;
		} else {
			return this._visibleMarkers;
		}
	}

	, 
	markerCreate: function () {
		var $self = this;
		var marker = new $.ig.Marker();
		marker.content((function () { var $ret = new $.ig.DataContext();
		$ret.series($self.model()); return $ret;}()));
		marker.contentTemplate($self.markerModel()._cachedActualMarkerTemplate);
		$self.visibleMarkers().add(marker);
		return marker;
	}

	, 
	doToAllMarkers: function (action) {}

	, 
	markerActivate: function (marker) {
		marker.__visibility = $.ig.Visibility.prototype.visible;
	}

	, 
	markerDisactivate: function (marker) {
		marker.__visibility = $.ig.Visibility.prototype.collapsed;
	}

	, 
	markerDestroy: function (marker) {
		this.visibleMarkers().remove(marker);
	}

	, 
	hasCustomMarkerTemplate: function () {
		return this.markerModel().markerTemplate() != null;
	}

	, 
	clearActualMarkerTemplate: function () {
		this.markerModel().actualMarkerTemplate(null);
	}

	, 
	bindActualToCustomMarkerTemplate: function () {
		this.markerModel().actualMarkerTemplate(this.markerModel().markerTemplate());
	}

	, 
	bindActualToMarkerTemplate: function (p) {
		switch (p) {
			case $.ig.XamDataChart.prototype.circleMarkerTemplatePropertyName:
				this.markerModel().actualMarkerTemplate(this.markerModel().seriesViewer().circleMarkerTemplate());
				break;
			case $.ig.XamDataChart.prototype.triangleMarkerTemplatePropertyName:
				this.markerModel().actualMarkerTemplate(this.markerModel().seriesViewer().triangleMarkerTemplate());
				break;
			case $.ig.XamDataChart.prototype.pyramidMarkerTemplatePropertyName:
				this.markerModel().actualMarkerTemplate(this.markerModel().seriesViewer().pyramidMarkerTemplate());
				break;
			case $.ig.XamDataChart.prototype.squareMarkerTemplatePropertyName:
				this.markerModel().actualMarkerTemplate(this.markerModel().seriesViewer().squareMarkerTemplate());
				break;
			case $.ig.XamDataChart.prototype.diamondMarkerTemplatePropertyName:
				this.markerModel().actualMarkerTemplate(this.markerModel().seriesViewer().diamondMarkerTemplate());
				break;
			case $.ig.XamDataChart.prototype.pentagonMarkerTemplatePropertyName:
				this.markerModel().actualMarkerTemplate(this.markerModel().seriesViewer().pentagonMarkerTemplate());
				break;
			case $.ig.XamDataChart.prototype.hexagonMarkerTemplatePropertyName:
				this.markerModel().actualMarkerTemplate(this.markerModel().seriesViewer().hexagonMarkerTemplate());
				break;
			case $.ig.XamDataChart.prototype.tetragramMarkerTemplatePropertyName:
				this.markerModel().actualMarkerTemplate(this.markerModel().seriesViewer().tetragramMarkerTemplate());
				break;
			case $.ig.XamDataChart.prototype.pentagramMarkerTemplatePropertyName:
				this.markerModel().actualMarkerTemplate(this.markerModel().seriesViewer().pentagramMarkerTemplate());
				break;
			case $.ig.XamDataChart.prototype.hexagramMarkerTemplatePropertyName:
				this.markerModel().actualMarkerTemplate(this.markerModel().seriesViewer().hexagramMarkerTemplate());
				break;
		}

	}

	, 
	clearActualMarkerBrush: function () {
		this.markerModel().actualMarkerBrush(null);
	}

	, 
	bindActualToMarkerBrush: function () {
		this.markerModel().actualMarkerBrush(this.markerModel().markerBrush());
	}

	, 
	clearActualMarkerOutline: function () {
		this.markerModel().actualMarkerOutline(null);
	}

	, 
	bindActualToMarkerOutline: function () {
		this.markerModel().actualMarkerOutline(this.markerModel().markerOutline());
	}

	, 
	renderMarkers: function () {
		this.makeDirty();
	}

	, 
	_markerAppearanceHandled: false,
	markerAppearanceHandled: function (value) {
		if (arguments.length === 1) {
			this._markerAppearanceHandled = value;
			return value;
		} else {
			return this._markerAppearanceHandled;
		}
	}

	, 
	setupMarkerAppearanceOverride: function (item, index) {
		$.ig.SeriesView.prototype.setupMarkerAppearanceOverride.call(this, item, index);
		if (!this.markerAppearanceHandled()) {
			var marker = item;
			var context = marker.content();
			if (context != null) {
				context.actualItemBrush(this.markerModel().actualMarkerBrush());
				if (context.itemBrush() != null) {
					context.actualItemBrush(context.itemBrush());
				}

				context.outline(this.markerModel().actualMarkerOutline());
				context.thickness(0.5);
			}

		}

	}
	, 
	__hitMarker: null

	, 
	setupMarkerHitAppearanceOverride: function (item, index) {
		$.ig.SeriesView.prototype.setupMarkerHitAppearanceOverride.call(this, item, index);
		var marker = item;
		this.__hitMarker.__visibility = marker.__visibility;
		this.__hitMarker.contentTemplate(marker.contentTemplate());
		this.__hitMarker.width(marker.width());
		this.__hitMarker.height(marker.height());
		this.__hitMarker.actualWidth(marker.actualWidth());
		this.__hitMarker.actualHeight(marker.actualHeight());
		this.__hitMarker.canvasLeft(marker.canvasLeft());
		this.__hitMarker.canvasTop(marker.canvasTop());
		var hitBrush = this.getHitBrush1(index);
		var context = this.__hitMarker.content();
		var markerContext = marker.content();
		context.item(markerContext.item());
		context.series(markerContext.series());
		context.thickness(markerContext.thickness());
		if (context != null) {
			context.actualItemBrush(hitBrush);
			context.outline(hitBrush);
			context.thickness(1 + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
		}

	}

	, 
	getDataContextByIndex: function (itemIndex) {
		if (itemIndex >= 0 && itemIndex < this.visibleMarkers().count()) {
			return this.visibleMarkers().__inner[itemIndex].content();
		}

		return $.ig.SeriesView.prototype.getDataContextByIndex.call(this, itemIndex);
	}
	, 
	__hitTemplate: null

	, 
	renderMarkersOverride: function (context, isHitContext) {
		$.ig.SeriesView.prototype.renderMarkersOverride.call(this, context, isHitContext);
		if (context.shouldRender()) {
			var passInfo = new $.ig.DataTemplatePassInfo();
			passInfo.isHitTestRender = isHitContext;
			passInfo.context = context.getUnderlyingContext();
			passInfo.viewportTop = this.viewport().top();
			passInfo.viewportLeft = this.viewport().left();
			passInfo.viewportWidth = this.viewport().width();
			passInfo.viewportHeight = this.viewport().height();
			passInfo.passID = "Markers";
			var renderInfo = new $.ig.DataTemplateRenderInfo();
			renderInfo.isHitTestRender = isHitContext;
			renderInfo.passInfo = passInfo;
			var measureInfo = new $.ig.DataTemplateMeasureInfo();
			measureInfo.passInfo = passInfo;
			var isConstant = false;
			var cont = context.getUnderlyingContext();
			measureInfo.context = cont;
			renderInfo.context = cont;
			var constantWidth = 0;
			var constantHeight = 0;
			var first = true;
			if (this.markerModel()._cachedActualMarkerTemplate != null && this.markerModel()._cachedActualMarkerTemplate.passStarting() != null) {
				this.markerModel()._cachedActualMarkerTemplate.passStarting()(passInfo);
			}

			for (var i = 0; i < this.visibleMarkers().count(); i++) {
				var marker = this.visibleMarkers().__inner[i];
				if (marker.__visibility == $.ig.Visibility.prototype.collapsed) {
					continue;
				}

				this.setupMarkerAppearance(marker, i, isHitContext);
				if (isHitContext) {
					marker = this.__hitMarker;
				}

				if (!isConstant) {
					measureInfo.data = marker.content();
					measureInfo.width = marker.width();
					measureInfo.height = marker.height();
					measureInfo.renderOffsetX = 0;
					measureInfo.renderOffsetY = 0;
					measureInfo.renderContext = context;
					var template = marker.contentTemplate();
					if (template.measure() != null) {
						measureInfo.data = marker.content();
						template.measure()(measureInfo);
						isConstant = measureInfo.isConstant;
						if (isConstant) {
							constantWidth = measureInfo.width;
							constantHeight = measureInfo.height;
						}

					}

					renderInfo.availableWidth = measureInfo.width;
					renderInfo.availableHeight = measureInfo.height;
					renderInfo.renderOffsetX = measureInfo.renderOffsetX;
					renderInfo.renderOffsetY = measureInfo.renderOffsetY;
					renderInfo.renderContext = context;

				} else {
					renderInfo.availableWidth = constantWidth;
					renderInfo.availableHeight = constantHeight;
				}

				if (!$.ig.util.isNaN(marker.width()) && !Number.isInfinity(marker.width())) {
					renderInfo.availableWidth = marker.width();
				}

				if (!$.ig.util.isNaN(marker.height()) && !Number.isInfinity(marker.height())) {
					renderInfo.availableHeight = marker.height();
				}

				first = false;
				context.renderContentControl(renderInfo, marker);
				marker.actualWidth(renderInfo.availableWidth);
				marker.actualHeight(renderInfo.availableHeight);
				marker._renderOffsetX = renderInfo.renderOffsetX;
				marker._renderOffsetY = renderInfo.renderOffsetY;
			}

			if (this.markerModel()._cachedActualMarkerTemplate != null && this.markerModel()._cachedActualMarkerTemplate.passCompleted() != null) {
				this.markerModel()._cachedActualMarkerTemplate.passCompleted()(passInfo);
			}

		}

	}

	, 
	initMarkers: function (Markers) {
		Markers.create(this.markerCreate.runOn(this));
		Markers.destroy(this.markerDestroy.runOn(this));
		Markers.activate(this.markerActivate.runOn(this));
		Markers.disactivate(this.markerDisactivate.runOn(this));
	}

	, 
	initMarkers1: function (Markers) {
		Markers.create(this.markerCreate.runOn(this));
		Markers.destroy(this.markerDestroy.runOn(this));
		Markers.activate(this.markerActivate.runOn(this));
		Markers.disactivate(this.markerDisactivate.runOn(this));
	}

	, 
	getHitMarker: function (point) {
		var hitMarker = this.getHitMarkerWithBuffer(point, 0);
		if (hitMarker == null) {
			hitMarker = this.getHitMarkerWithBuffer(point, $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
		}

		return hitMarker;
	}

	, 
	getHitMarkerWithBuffer: function (point, buffer) {
		var halfWidth;
		var halfHeight;
		var offsetX;
		var offsetY;
		for (var i = this.visibleMarkers().count() - 1; i >= 0; i--) {
			var marker = this.visibleMarkers().__inner[i];
			if (marker.__visibility == $.ig.Visibility.prototype.collapsed || marker.__opacity == 0) {
				continue;
			}

			halfWidth = (marker.actualWidth() / 2) + buffer;
			halfHeight = (marker.actualHeight() / 2) + buffer;
			offsetX = marker._renderOffsetX;
			offsetY = marker._renderOffsetY;
			if ((marker.canvasLeft() + offsetX) - halfWidth <= point.__x && (marker.canvasLeft() + offsetX) + halfWidth >= point.__x && (marker.canvasTop() + offsetY) - halfHeight <= point.__y && (marker.canvasTop() + offsetY) + halfHeight >= point.__y) {
				return marker;
			}

		}

		return null;
	}
	, 
	$type: new $.ig.Type('MarkerSeriesView', $.ig.SeriesView.prototype.$type)
}, true);






$.ig.util.defType('IHasCategoryAxis', 'Object', {
	$type: new $.ig.Type('IHasCategoryAxis', null)
}, true);

$.ig.util.defType('IHasCategoryModePreference', 'Object', {
	$type: new $.ig.Type('IHasCategoryModePreference', null, [$.ig.IHasCategoryAxis.prototype.$type])
}, true);

$.ig.util.defType('CategorySeries', 'MarkerSeries', {

	_framePreparer: null,
	framePreparer: function (value) {
		if (arguments.length === 1) {
			this._framePreparer = value;
			return value;
		} else {
			return this._framePreparer;
		}
	}

	, 
	createView: function () {
		var view = new $.ig.CategorySeriesView(this);
		return view;
	}

	, 
	_categoryView: null,
	categoryView: function (value) {
		if (arguments.length === 1) {
			this._categoryView = value;
			return value;
		} else {
			return this._categoryView;
		}
	}

	, 
	onViewCreated: function (view) {
		$.ig.MarkerSeries.prototype.onViewCreated.call(this, view);
		this.categoryView(view);
	}

	, 
	preferredCategoryMode: function (axis) {
		return $.ig.CategoryMode.prototype.mode0;
	}

	, 
	categoryAxis: function () {

			return this.getCategoryAxis();
	}

	, 
	getCategoryAxis: function () {
		return this.getXAxis();
	}

	, 
	isCategory: function () {

			return true;
	}
	, 
	init: function () {


		this._previousFrame = new $.ig.CategoryFrame(3);
		this._transitionFrame = new $.ig.CategoryFrame(3);
		this._currentFrame = new $.ig.CategoryFrame(3);
		this._thumbnailFrame = new $.ig.CategoryFrame(3);

		$.ig.MarkerSeries.prototype.init.call(this);
			this._renderManager = new $.ig.CategorySeriesRenderManager();
			this.sourceFramePreparer(new $.ig.CategoryTransitionSourceFramePreparer());
			this.__fullClip = new $.ig.Rect(0, 0, 0, 1, 1);
			this.actualIsCustomCategoryStyleAllowed(false);
			this.actualIsCustomCategoryMarkerStyleAllowed(false);
			this.defaultStyleKey($.ig.CategorySeries.prototype.$type);
	}

	, 
	onApplyTemplate: function () {
		$.ig.MarkerSeries.prototype.onApplyTemplate.call(this);
		this.categoryView().bucketCalculator().calculateBuckets(this.resolution());
	}

	, 
	isCustomCategoryStyleAllowed: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.CategorySeries.prototype.isCustomCategoryStyleAllowedProperty, value);
			return value;
		} else {

			return this.getValue($.ig.CategorySeries.prototype.isCustomCategoryStyleAllowedProperty);
		}
	}

	, 
	isCustomCategoryMarkerStyleAllowed: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.CategorySeries.prototype.isCustomCategoryMarkerStyleAllowedProperty, value);
			return value;
		} else {

			return this.getValue($.ig.CategorySeries.prototype.isCustomCategoryMarkerStyleAllowedProperty);
		}
	}

	, 
	_actualIsCustomCategoryStyleAllowed: false,
	actualIsCustomCategoryStyleAllowed: function (value) {
		if (arguments.length === 1) {
			this._actualIsCustomCategoryStyleAllowed = value;
			return value;
		} else {
			return this._actualIsCustomCategoryStyleAllowed;
		}
	}

	, 
	_actualIsCustomCategoryMarkerStyleAllowed: false,
	actualIsCustomCategoryMarkerStyleAllowed: function (value) {
		if (arguments.length === 1) {
			this._actualIsCustomCategoryMarkerStyleAllowed = value;
			return value;
		} else {
			return this._actualIsCustomCategoryMarkerStyleAllowed;
		}
	}
	, 
	assigningCategoryStyle: null, 
	assigningCategoryMarkerStyle: null
	, 
	shouldOverrideCategoryStyle: function () {
		return (this.assigningCategoryStyle != null && this.actualIsCustomCategoryStyleAllowed()) || this.isHighlightingEnabled();
	}

	, 
	shouldOverrideMarkerStyle: function () {
		return (this.assigningCategoryMarkerStyle != null && this.actualIsCustomCategoryMarkerStyleAllowed()) || this.isHighlightingEnabled();
	}

	, 
	raiseAssigningCategoryStyles: function (args) {
		if (this.assigningCategoryStyle != null && this.actualIsCustomCategoryStyleAllowed()) {
			this.assigningCategoryStyle(this, args);
		}

	}

	, 
	raiseAssigningCategoryMarkerStyles: function (args) {
		if (this.assigningCategoryMarkerStyle != null && this.actualIsCustomCategoryMarkerStyleAllowed()) {
			this.assigningCategoryMarkerStyle(this, args);
		}

	}

	, 
	getCategoryItems: function (startIndex, endIndex) {
		return null;
	}

	, 
	clearRendering: function (wipeClean, view) {
		$.ig.MarkerSeries.prototype.clearRendering.call(this, wipeClean, view);
		if (wipeClean) {
			this.clearMarkers(view);
		}

	}

	, 
	getSeriesComponentsForView: function () {
		var ret = $.ig.MarkerSeries.prototype.getSeriesComponentsForView.call(this);
		return ret;
	}

	, 
	invalidateAxes: function () {
		$.ig.MarkerSeries.prototype.invalidateAxes.call(this);
		var xAxis = this.getXAxis();
		if (xAxis != null) {
			xAxis.renderAxis1(false);
		}

		var yAxis = this.getYAxis();
		if (yAxis != null) {
			yAxis.renderAxis1(false);
		}

	}

	, 
	useHighMarkerFidelity: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.CategorySeries.prototype.useHighMarkerFidelityProperty, value);
			return value;
		} else {

			return this.getValue($.ig.CategorySeries.prototype.useHighMarkerFidelityProperty);
		}
	}

	, 
	windowRectChangedOverride: function (oldWindowRect, newWindowRect) {
		$.ig.MarkerSeries.prototype.windowRectChangedOverride.call(this, oldWindowRect, newWindowRect);
		this.categoryView().bucketCalculator().calculateBuckets(this.resolution());
		this.renderSeries(false);
	}

	, 
	transitionInMode: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.CategorySeries.prototype.transitionInModeProperty, $.ig.CategoryTransitionInMode.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.CategorySeries.prototype.transitionInModeProperty));
		}
	}

	, 
	isTransitionInEnabled: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.CategorySeries.prototype.isTransitionInEnabledProperty, value);
			return value;
		} else {

			return this.getValue($.ig.CategorySeries.prototype.isTransitionInEnabledProperty);
		}
	}

	, 
	viewportRectChangedOverride: function (oldViewportRect, newViewportRect) {
		if (this.transitionInIsInProgress() && this.transitionProgress() < 0.05 && (this.seriesViewer() == null || !this.seriesViewer().justZoomed())) {
			this.transitionInViable(true);
		}

		$.ig.MarkerSeries.prototype.viewportRectChangedOverride.call(this, oldViewportRect, newViewportRect);
		this.categoryView().bucketCalculator().calculateBuckets(this.resolution());
		this.renderSeries(false);
	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		$.ig.MarkerSeries.prototype.propertyUpdatedOverride.call(this, sender, propertyName, oldValue, newValue);
		switch (propertyName) {
			case $.ig.Series.prototype.seriesViewerPropertyName:
				var yAxis = this.getYAxis();
				var xAxis = this.getXAxis();
				if (oldValue != null && newValue == null) {
					this.deregisterForAxis(xAxis);
					this.deregisterForAxis(yAxis);
				}

				if (oldValue == null && newValue != null) {
					this.registerForAxis(xAxis);
					this.registerForAxis(yAxis);
				}

				this.categoryView().bucketCalculator().calculateBuckets(this.resolution());
				this.renderSeries(false);
				break;
			case $.ig.Series.prototype.syncLinkPropertyName:
				if (this.syncLink() != null && this.seriesViewer() != null) {
					this.categoryView().bucketCalculator().calculateBuckets(this.resolution());
				}

				this.renderSeries(false);
				break;
			case $.ig.Series.prototype.transitionProgressPropertyName:
				this._transitionFrame.interpolate3(this.transitionProgress(), this._previousFrame, this._currentFrame);
				if (this.clearAndAbortIfInvalid1(this.view())) {
					return;
				}

				if (this.transitionProgress() == 1) {
					this._currentFrame.clearSpeedModifiers();
					this.renderFrame(this._currentFrame, this.categoryView());
					if (this.transitionInIsInProgress()) {
						this.transitionInIsInProgress(false);
						this.clearSpeedModifiers();
						this.animator().intervalMilliseconds($.ig.truncate(this.getTotalMilliseconds()));
						this.animator().easingFunction(this.transitionEasingFunction());
					}


				} else {
					this.renderFrame(this._transitionFrame, this.categoryView());
				}

				break;
			case $.ig.CategorySeries.prototype.errorBarSettingsPropertyName:
				this.notifyThumbnailAppearanceChanged();
				break;
			case $.ig.CategorySeries.prototype.useHighMarkerFidelityPropertyName:
				this.renderSeries(false);
				break;
			case $.ig.CategorySeries.prototype.isCustomCategoryStyleAllowedPropertyName:
				this.actualIsCustomCategoryStyleAllowed(this.getIsCustomCategoryStyleAllowed());
				this.renderSeries(false);
				break;
			case $.ig.CategorySeries.prototype.isCustomCategoryMarkerStyleAllowedPropertyName:
				this.actualIsCustomCategoryMarkerStyleAllowed(this.getIsCustomCategoryMarkerStyleAllowed());
				this.renderSeries(false);
				break;
		}

	}

	, 
	getIsCustomCategoryStyleAllowed: function () {
		return this.isCustomCategoryStyleAllowed();
	}

	, 
	getIsCustomCategoryMarkerStyleAllowed: function () {
		return this.isCustomCategoryMarkerStyleAllowed();
	}

	, 
	getExactUnsortedItemIndex: function (world) {
		return this.getExactUnsortedItemIndexHelper(world, this.getXAxis());
	}

	, 
	getItemIndexSorted: function (world) {
		var windowRect = this.view().windowRect();
		var viewportRect = this.view().viewport();
		if (windowRect.isEmpty() || viewportRect.isEmpty()) {
			return -1;
		}

		if ($.ig.util.isNaN(world.__x) || $.ig.util.isNaN(world.__y)) {
			return -1;
		}

		var xAxis = this.getXAxis();
		var sorting = $.ig.util.cast($.ig.ISortingAxis.prototype.$type, xAxis);
		var p = new $.ig.ScalerParams(windowRect, viewportRect, xAxis.isInverted());
		var left = xAxis.getUnscaledValue(viewportRect.left(), p);
		var right = xAxis.getUnscaledValue(viewportRect.right(), p);
		var windowX = (world.__x - windowRect.left()) / windowRect.width();
		var axisValue = left + ((right - left) * windowX);
		var itemIndex = sorting.getIndexClosestToUnscaledValue(axisValue);
		return itemIndex;
	}

	, 
	getOffsetValue: function () {}

	, 
	getCategoryWidth: function () {}

	, 
	getItem: function (world) {
		var index = 0;
		var xAxis = this.getXAxis();
		if ($.ig.util.cast($.ig.ISortingAxis.prototype.$type, xAxis) !== null) {
			index = this.getItemIndexSorted(world);
			if (index == -1) {
				return null;
			}


		} else {
			index = this.getItemIndex(world);
		}

		return index >= 0 && this.fastItemsSource() != null && index < this.fastItemsSource().count() ? this.fastItemsSource().item(index) : null;
	}

	, 
	getItemIndex: function (world) {
		var rowIndex = $.ig.truncate(Math.round(this.getExactItemIndex(world)));
		return rowIndex;
	}

	, 
	getExactItemIndex: function (world) {
		var windowRect = this.view().windowRect();
		var viewportRect = this.view().viewport();
		var rowIndex = -1;
		var xAxis = this.getXAxis();
		if (xAxis != null && !windowRect.isEmpty() && !viewportRect.isEmpty()) {
			var left = xAxis.getUnscaledValue2(viewportRect.left(), windowRect, viewportRect, xAxis.categoryMode());
			var right = xAxis.getUnscaledValue2(viewportRect.right(), windowRect, viewportRect, xAxis.categoryMode());
			var windowX = (world.__x - windowRect.left()) / windowRect.width();
			var bucket = left + (windowX * (right - left));
			if (xAxis.categoryMode() != $.ig.CategoryMode.prototype.mode0) {
				bucket -= 0.5;
			}

			rowIndex = bucket;
		}

		return rowIndex;
	}

	, 
	_prevHighlightingInfo: null,
	prevHighlightingInfo: function (value) {
		if (arguments.length === 1) {
			this._prevHighlightingInfo = value;
			return value;
		} else {
			return this._prevHighlightingInfo;
		}
	}

	, 
	_prevMarkerHighlightingInfo: null,
	prevMarkerHighlightingInfo: function (value) {
		if (arguments.length === 1) {
			this._prevMarkerHighlightingInfo = value;
			return value;
		} else {
			return this._prevMarkerHighlightingInfo;
		}
	}

	, 
	hasIndividualElements: function () {

			return false;
	}

	, 
	getSortingCategoryBucketIndex: function (world) {
		var current = this._currentFrame;
		if (this.animationActive()) {
			current = this._transitionFrame;
		}

		var viewportRect = this.view().viewport();
		var windowRect = this.view().windowRect();
		var indexAxis = this.getCategoryAxis();
		var p = new $.ig.ScalerParams(windowRect, viewportRect, indexAxis.isInverted());
		var screenPos = 0;
		if (indexAxis.isVertical()) {
			var windowY = (world.__y - windowRect.top()) / windowRect.height();
			screenPos = windowY * viewportRect.height() + viewportRect.top();

		} else {
			var windowX = (world.__x - windowRect.left()) / windowRect.width();
			screenPos = windowX * viewportRect.width() + viewportRect.left();
		}

		if (indexAxis.isInverted()) {
			var count = current._buckets.count();
			var i = 0;
			for (i = count - 1; i >= 0; i--) {
				var bucket = current._buckets.__inner[i];
				var nextBucket = null;
				if (i > 0) {
					nextBucket = current._buckets.__inner[i - 1];
				}

				if (bucket[0] <= screenPos && nextBucket == null || nextBucket[0] >= screenPos) {
					if (nextBucket != null) {
						if (Math.abs(bucket[0] - screenPos) < Math.abs(nextBucket[0] - screenPos)) {
							return i;

						} else {
							return i - 1;
						}


					} else {
						return i;
					}

				}

			}

			return i;

		} else {
			var count1 = current._buckets.count();
			var i1 = 0;
			for (i1 = 0; i1 < count1; i1++) {
				var bucket1 = current._buckets.__inner[i1];
				var nextBucket1 = null;
				if (i1 < count1 - 1) {
					nextBucket1 = current._buckets.__inner[i1 + 1];
				}

				if (bucket1[0] <= screenPos && nextBucket1 == null || nextBucket1[0] >= screenPos) {
					if (nextBucket1 != null) {
						if (Math.abs(bucket1[0] - screenPos) < Math.abs(nextBucket1[0] - screenPos)) {
							return i1;

						} else {
							return i1 + 1;
						}


					} else {
						return i1;
					}

				}

			}

			return i1;
		}

	}

	, 
	getMarkerHighlightingInfo: function (item, world) {
		var info = this.getSpecificMarkerHighlightingInfo(item, world, this.prevMarkerHighlightingInfo());
		this.prevMarkerHighlightingInfo(info);
		return info;
	}

	, 
	isHighlightingSupported: function () {

			return true;
	}

	, 
	getHighlightingInfo: function (item, world) {
		if (this.hasIndividualElements()) {
			var info = this.getSpecificHighlightingInfo(item, world, this.prevHighlightingInfo());
			this.prevHighlightingInfo(info);
			return info;

		} else {
			var info1 = this.getFullSeriesInfo(item, world, this.prevHighlightingInfo());
			this.prevHighlightingInfo(info1);
			return info1;
		}

	}

	, 
	getActiveMarkers: function () {
		return this.categoryView().markers().active();
	}

	, 
	getSpecificMarkerHighlightingInfo: function (item, world, prevValue) {
		if (!this.shouldDisplayMarkers()) {
			return null;
		}

		var current = this._currentFrame;
		if (this.animationActive()) {
			current = this._transitionFrame;
		}

		var seriesPos = this.fromWorldPosition(world);
		var activeMarkers = this.getActiveMarkers();
		if (activeMarkers == null) {
			return null;
		}

		var markerCount = activeMarkers.count();
		if (markerCount == 0) {
			return null;
		}

		var bucket = activeMarkers.__inner[0].markerBucket();
		if (this.isVertical()) {
			var currY = current._buckets.__inner[activeMarkers.__inner[0].markerBucket()][0];
			var minDistance = (seriesPos.__y - currY) * (seriesPos.__y - currY);
			var dist;
			for (var i = 0; i < markerCount; i++) {
				currY = current._buckets.__inner[activeMarkers.__inner[i].markerBucket()][0];
				dist = (seriesPos.__y - currY) * (seriesPos.__y - currY);
				if (dist <= minDistance) {
					minDistance = dist;
					bucket = activeMarkers.__inner[i].markerBucket();
				}

			}


		} else {
			var currX = current._buckets.__inner[activeMarkers.__inner[0].markerBucket()][0];
			var minDistance1 = (seriesPos.__x - currX) * (seriesPos.__x - currX);
			var dist1;
			for (var i1 = 0; i1 < markerCount; i1++) {
				currX = current._buckets.__inner[activeMarkers.__inner[i1].markerBucket()][0];
				dist1 = (seriesPos.__x - currX) * (seriesPos.__x - currX);
				if (dist1 <= minDistance1) {
					minDistance1 = dist1;
					bucket = activeMarkers.__inner[i1].markerBucket();
				}

			}

		}

		var info = new $.ig.HighlightingInfo();
		info.series(this);
		info.isMarker(true);
		info.startIndex(bucket);
		info.endIndex(info.startIndex());
		if (prevValue != null && prevValue.startIndex() == info.startIndex() && prevValue.endIndex() == info.endIndex()) {
			return prevValue;
		}

		return info;
	}

	, 
	getSpecificHighlightingInfo: function (item, world, prevValue) {
		var count = this.fastItemsSource().count();
		var firstBucket = this.categoryView().bucketCalculator()._firstBucket;
		var lastBucket = this.categoryView().bucketCalculator()._lastBucket;
		var bucketSize = this.categoryView().bucketCalculator()._bucketSize;
		var axis = this.getCategoryAxis();
		var bucketStart = -1;
		var bucketEnd = -1;
		if (axis.isSorting()) {
			var current = this._currentFrame;
			if (this.animationActive()) {
				current = this._transitionFrame;
			}

			var bucket = this.getSortingCategoryBucketIndex(world);
			bucketStart = bucket;
			bucketEnd = bucket;

		} else {
			var index = this.getItemIndex(world);
			bucketStart = $.ig.truncate(Math.floor(($.ig.intDivide(index, bucketSize)))) * bucketSize;
			bucketEnd = bucketStart + (bucketSize - 1);
		}

		if (prevValue != null && prevValue.startIndex() == bucketStart && prevValue.endIndex() == bucketEnd) {
			return prevValue;
		}

		var info = new $.ig.HighlightingInfo();
		info.series(this);
		info.startIndex(bucketStart);
		info.endIndex(bucketEnd);
		return info;
	}

	, 
	getFullSeriesInfo: function (item, world, prevValue) {
		var info = new $.ig.HighlightingInfo();
		info.series(this);
		info.startIndex(0);
		info.endIndex(this.fastItemsSource().count() - 1);
		if (prevValue != null && prevValue.startIndex() == info.startIndex() && prevValue.endIndex() == info.endIndex()) {
			return prevValue;
		}

		return info;
	}
	, 
	_previousFrame: null
	, 
	_transitionFrame: null
	, 
	_currentFrame: null
	, 
	_thumbnailFrame: null
	, 
	_renderManager: null

	, 
	performCategoryMarkerStyleOverride: function (buckets, currentIndex, valueCount, categoryAxis, axisParams, isThumbnail) {
		var isHighlightingEnabled = this.actualIsHighlightingEnabled();
		this._renderManager.prePerformCategoryMarkerStyleOverride(buckets, currentIndex, valueCount, categoryAxis, axisParams, isThumbnail, isHighlightingEnabled);
		var args = this._renderManager.categoryMarkerOverrideArgs();
		var info = null;
		var itemsSource = this.fastItemsSource();
		if (isHighlightingEnabled && this.seriesViewer() != null) {
			info = this.seriesViewer().highlightingManager().getHighlightingInfo(this, itemsSource, categoryAxis, args.startIndex(), args.endIndex(), true);
			args.highlightingInfo(info);
		}

		args.isThumbnail(isThumbnail);
		this.raiseAssigningCategoryMarkerStyles(args);
		this._renderManager.postPerformCategoryMarkerStyleOverride(info, isThumbnail, isHighlightingEnabled);
	}

	, 
	performCategoryStyleOverride: function (buckets, currentIndex, valueCount, categoryAxis, axisParams, isThumbnail) {
		var isHighlightingEnabled = this.actualIsHighlightingEnabled();
		this._renderManager.prePerformCategoryStyleOverride(buckets, currentIndex, valueCount, categoryAxis, axisParams, isThumbnail, isHighlightingEnabled);
		var args = this._renderManager.categoryOverrideArgs();
		var info = null;
		var itemsSource = this.fastItemsSource();
		if (isHighlightingEnabled && this.seriesViewer() != null) {
			info = this.seriesViewer().highlightingManager().getHighlightingInfo(this, itemsSource, categoryAxis, args.startIndex(), args.endIndex(), false);
			args.highlightingInfo(info);
		}

		args.isThumbnail(isThumbnail);
		this.raiseAssigningCategoryStyles(args);
		this._renderManager.postPerformCategoryStyleOverride(info, isThumbnail, isHighlightingEnabled);
	}

	, 
	validateSeries: function (viewportRect, windowRect, view) {
		var isValid = $.ig.MarkerSeries.prototype.validateSeries.call(this, viewportRect, windowRect, view);
		isValid &= this.validateAxis(this.getXAxis());
		isValid &= this.validateAxis(this.getYAxis());
		var categoryView = view;
		if (!view.hasSurface() || windowRect.isEmpty() || viewportRect.isEmpty() || this.fastItemsSource() == null) {
			isValid = false;
		}

		if (!isValid) {
			categoryView.bucketCalculator()._bucketSize = 0;
		}

		return isValid;
	}

	, 
	validateAxis: function (axis) {
		if (axis == null || axis.seriesViewer() == null) {
			return false;
		}

		var categoryAxis = $.ig.util.cast($.ig.CategoryAxisBase.prototype.$type, axis);
		if (categoryAxis != null) {
			if (categoryAxis.itemsSource() == null) {
				return false;
			}

			if (categoryAxis._cachedItemsCount < 1) {
				return false;
			}


		} else {
			var numericAxis = $.ig.util.cast($.ig.NumericAxisBase.prototype.$type, axis);
			if (numericAxis != null) {
				return numericAxis.actualMinimumValue() != numericAxis.actualMaximumValue();
			}

		}

		return true;
	}

	, 
	shouldTransitionIn: function () {
		return this.isTransitionInEnabled();
	}

	, 
	getDefaultTransitionInMode: function () {
		return $.ig.CategoryTransitionInMode.prototype.sweepFromCategoryAxisMinimum;
	}

	, 
	_sourceFramePreparer: null,
	sourceFramePreparer: function (value) {
		if (arguments.length === 1) {
			this._sourceFramePreparer = value;
			return value;
		} else {
			return this._sourceFramePreparer;
		}
	}

	, 
	clearSpeedModifiers: function () {
		$.ig.MarkerSeries.prototype.clearSpeedModifiers.call(this);
		this._previousFrame.clearSpeedModifiers();
		this._currentFrame.clearSpeedModifiers();
		this._transitionFrame.clearSpeedModifiers();
	}

	, 
	renderSeriesOverride: function (animate) {
		$.ig.MarkerSeries.prototype.renderSeriesOverride.call(this, animate);
		this.categoryView().bucketCalculator().calculateBuckets(this.resolution());
		if (this.clearAndAbortIfInvalid1(this.view())) {
			this._currentFrame.resetFrame();
			this._transitionFrame.resetFrame();
			this._previousFrame.resetFrame();
			return;
		}

		if (this.skipPrepare()) {
			if (this.animationActive()) {
				if (this.animator().needsFlush()) {
					this.animator().flush();
				}

				this.renderFrame(this._transitionFrame, this.categoryView());

			} else {
				this.renderFrame(this._currentFrame, this.categoryView());
			}

			return;
		}

		if (this.shouldAnimate(animate)) {
			var previous = this._previousFrame;
			if (this.animationActive()) {
				if (this.animator().needsFlush()) {
					this.animator().flush();
				}

				this._previousFrame = this._transitionFrame;
				this._transitionFrame = previous;

			} else {
				this._previousFrame = this._currentFrame;
				this._currentFrame = previous;
			}

			this.prepareFrame(this._currentFrame, this.categoryView());
			if (this.transitionInViable()) {
				this.animator().stop();
				this.animator().intervalMilliseconds($.ig.truncate(this.getTotalTransitionInMilliseconds()));
				this.animator().easingFunction(this.transitionInEasingFunction() != null ? this.transitionInEasingFunction() : this.transitionEasingFunction());
				this.sourceFramePreparer().prepareSourceFrame(this._previousFrame, this._currentFrame, this.isVertical(), this.getXAxis(), this.getYAxis(), this.transitionInMode(), this.getDefaultTransitionInMode(), this.transitionInSpeedType(), this.getDefaultTransitionInSpeedType(), this.getTransitionFromZeroValue.runOn(this), this.categoryView().viewport());
			}

			this.checkTransitionInterrupted();
			this.startAnimation();
			if (this.transitionInViable()) {
				this.transitionInViable(false);
				this.transitionInIsInProgress(true);
			}


		} else {
			this.prepareFrame(this._currentFrame, this.categoryView());
			this.renderFrame(this._currentFrame, this.categoryView());
		}

	}

	, 
	getDefaultTransitionInSpeedType: function () {
		return $.ig.TransitionInSpeedType.prototype.indexScaled;
	}

	, 
	getTransitionFromZeroValue: function () {
		if (this.isVertical()) {
			return this.viewport().left();
		}

		return this.viewport().bottom();
	}

	, 
	getMode2Index: function () {
		var result = 0;
		var xAxis = this.getXAxis();
		var en = this.seriesViewer().series().getEnumerator();
		while (en.moveNext()) {
			var currentSeries = en.current();
			if (currentSeries == this) {
				return result;
			}

			var currentCategorySeries = $.ig.util.cast($.ig.CategorySeries.prototype.$type, currentSeries);
			if (currentCategorySeries != null) {
				var currentXAxis = $.ig.util.cast($.ig.CategoryAxisBase.prototype.$type, currentCategorySeries.getXAxis());
				if (currentXAxis == xAxis && currentCategorySeries.preferredCategoryMode(currentXAxis) == $.ig.CategoryMode.prototype.mode2) {
					result++;
				}

			}

		}

		return -1;
	}

	, 
	xAxis: function () {

			return this.getXAxis();
	}

	, 
	yAxis: function () {

			return this.getYAxis();
	}

	, 
	colorizeMarkers: function (view, frame) {
		this._renderManager.initCategoryMarkerRenderSettings(this, this.shouldOverrideMarkerStyle(), this.getCategoryItems.runOn(this), this.getBucketSize(view), this.getFirstBucket(view));
		var markerOverrideArgs = this._renderManager.categoryMarkerOverrideArgs();
		var areMarkerStylesOverriden = markerOverrideArgs != null;
		var xAxis = this.getCategoryAxis();
		if (xAxis == null) {
		return;
		}

		var xParams = new $.ig.ScalerParams(view.windowRect(), view.viewport(), xAxis.isInverted());
		var valueCount = this.fastItemsSource().count();
		var categoryView = view;
		var buckets = frame._buckets;
		var firstBucket = categoryView.bucketCalculator()._firstBucket;
		var lastBucket = categoryView.bucketCalculator()._lastBucket;
		var bucketSize = categoryView.bucketCalculator()._bucketSize;
		var firstIndex = firstBucket * bucketSize;
		for (var i = 0; i < view.markers().count(); i++) {
			var marker = view.markers().item(i);
			var context = marker.content();
			if (areMarkerStylesOverriden) {
				var bucket = marker.markerBucket();
				this.performCategoryMarkerStyleOverride(buckets, bucket, valueCount, xAxis, xParams, view.isThumbnailView());
			}

			this._renderManager.setCategoryMarkerAppearance(marker, context);
		}

	}

	, 
	renderFrame: function (frame, view) {
		this.customClipRect(frame.customClip());
		view.onRenderFrame();
	}
	, 
	__fullClip: null

	, 
	fullClip: function () {

			return this.__fullClip;
	}

	, 
	prepareFrame: function (frame, view) {
		frame.clearFrame();
	}

	, 
	getBucketSize: function (view) {
		return (view).bucketCalculator()._bucketSize;
	}

	, 
	getFirstBucket: function (view) {
		return (view).bucketCalculator()._firstBucket;
	}

	, 
	clearMarkers: function (view) {
		var catView = view;
		catView.markers().count(0);
	}

	, 
	renderThumbnail: function (viewportRect, surface) {
		$.ig.MarkerSeries.prototype.renderThumbnail.call(this, viewportRect, surface);
		if (!this.thumbnailDirty()) {
			this.view().prepSurface(surface);
			return;
		}

		var categorySeriesView = $.ig.util.cast($.ig.CategorySeriesView.prototype.$type, this.thumbnailView());
		categorySeriesView.bucketCalculator().calculateBuckets(this.resolution());
		this.view().prepSurface(surface);
		if (this.clearAndAbortIfInvalid1(this.thumbnailView())) {
			return;
		}

		this.renderThumbnailFrame();
		this.thumbnailDirty(false);
	}

	, 
	renderThumbnailFrame: function () {
		var thumbnailView = $.ig.util.cast($.ig.CategorySeriesView.prototype.$type, this.thumbnailView());
		if (!this.skipThumbnailPrepare()) {
			this.prepareFrame(this._thumbnailFrame, thumbnailView);
		}

		this.skipThumbnailPrepare(false);
		this.renderFrame(this._thumbnailFrame, thumbnailView);
	}

	, 
	getXAxis: function () {}

	, 
	getYAxis: function () {}

	, 
	updateNumericAxisRange: function () {}

	, 
	getFramePreparer: function (view) {
		var categoryView = $.ig.util.cast($.ig.CategorySeriesView.prototype.$type, view);
		if (categoryView != null && categoryView.isThumbnailView()) {
			if (categoryView.isAlternateView()) {
				return new $.ig.CategoryFramePreparer(1, $.ig.util.cast($.ig.IIsCategoryBased.prototype.$type, this), $.ig.util.cast($.ig.ISupportsMarkers.prototype.$type, categoryView), categoryView, this, categoryView.bucketCalculator());

			} else {
				return new $.ig.CategoryFramePreparer(1, $.ig.util.cast($.ig.IIsCategoryBased.prototype.$type, this), $.ig.util.cast($.ig.ISupportsMarkers.prototype.$type, categoryView), this.seriesViewer().view().overviewPlusDetailViewportHost(), this, categoryView.bucketCalculator());
			}


		} else {
			return this.framePreparer();
		}

	}
	, 
	$type: new $.ig.Type('CategorySeries', $.ig.MarkerSeries.prototype.$type, [$.ig.IHasCategoryModePreference.prototype.$type, $.ig.ISupportsErrorBars.prototype.$type])
}, true);

$.ig.util.defType('IIsCategoryBased', 'Object', {
	$type: new $.ig.Type('IIsCategoryBased', null)
}, true);

$.ig.util.defType('IHasSingleValueCategory', 'Object', {
	$type: new $.ig.Type('IHasSingleValueCategory', null)
}, true);

$.ig.util.defType('IHasTrendline', 'Object', {
	$type: new $.ig.Type('IHasTrendline', null)
}, true);

$.ig.util.defType('IHasCategoryTrendline', 'Object', {
	$type: new $.ig.Type('IHasCategoryTrendline', null, [$.ig.IHasTrendline.prototype.$type])
}, true);

$.ig.util.defType('AnchoredCategorySeries', 'CategorySeries', {

	_anchoredView: null,
	anchoredView: function (value) {
		if (arguments.length === 1) {
			this._anchoredView = value;
			return value;
		} else {
			return this._anchoredView;
		}
	}

	, 
	createView: function () {
		var view = new $.ig.AnchoredCategorySeriesView(this);
		return view;
	}

	, 
	onViewCreated: function (view) {
		$.ig.CategorySeries.prototype.onViewCreated.call(this, view);
		this.anchoredView(view);
	}

	, 
	_shouldSuspendChangedNotification: false,
	shouldSuspendChangedNotification: function (value) {
		if (arguments.length === 1) {
			this._shouldSuspendChangedNotification = value;
			return value;
		} else {
			return this._shouldSuspendChangedNotification;
		}
	}
	, 
	init: function () {



		$.ig.CategorySeries.prototype.init.call(this);
			this.lineRasterizer(new $.ig.CategoryLineRasterizer());
			this.framePreparer(new $.ig.CategoryFramePreparer(1, this, this.categoryView(), this, this, this.categoryView().bucketCalculator()));
	}

	, 
	_lineRasterizer: null,
	lineRasterizer: function (value) {
		if (arguments.length === 1) {
			this._lineRasterizer = value;
			return value;
		} else {
			return this._lineRasterizer;
		}
	}

	, 
	valueMemberPath: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.AnchoredCategorySeries.prototype.valueMemberPathProperty, value);
			return value;
		} else {

			return this.getValue($.ig.AnchoredCategorySeries.prototype.valueMemberPathProperty);
		}
	}

	, 
	valueColumn: function (value) {
		if (arguments.length === 1) {

			if (this._valueColumn != value) {
				var oldValueColumn = this._valueColumn;
				this._valueColumn = value;
				if (!this.shouldSuspendChangedNotification()) {
				this.raisePropertyChanged($.ig.AnchoredCategorySeries.prototype.valueColumnPropertyName, oldValueColumn, this._valueColumn);
				}

			}

			return value;
		} else {

			return this._valueColumn;
		}
	}
	, 
	_valueColumn: null

	, 
	trendLineType: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.AnchoredCategorySeries.prototype.trendLineTypeProperty, $.ig.TrendLineType.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.AnchoredCategorySeries.prototype.trendLineTypeProperty));
		}
	}

	, 
	trendLineBrush: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.AnchoredCategorySeries.prototype.trendLineBrushProperty, value);
			return value;
		} else {

			return this.getValue($.ig.AnchoredCategorySeries.prototype.trendLineBrushProperty);
		}
	}

	, 
	actualTrendLineBrush: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.AnchoredCategorySeries.prototype.actualTrendLineBrushProperty, value);
			return value;
		} else {

			return this.getValue($.ig.AnchoredCategorySeries.prototype.actualTrendLineBrushProperty);
		}
	}

	, 
	trendLineThickness: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.AnchoredCategorySeries.prototype.trendLineThicknessProperty, value);
			return value;
		} else {

			return this.getValue($.ig.AnchoredCategorySeries.prototype.trendLineThicknessProperty);
		}
	}

	, 
	trendLineDashCap: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.AnchoredCategorySeries.prototype.trendLineDashCapProperty, $.ig.PenLineCap.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.AnchoredCategorySeries.prototype.trendLineDashCapProperty));
		}
	}

	, 
	trendLineDashArray: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.AnchoredCategorySeries.prototype.trendLineDashArrayProperty, value);
			return value;
		} else {

			return this.getValue($.ig.AnchoredCategorySeries.prototype.trendLineDashArrayProperty);
		}
	}

	, 
	trendLinePeriod: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.AnchoredCategorySeries.prototype.trendLinePeriodProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.AnchoredCategorySeries.prototype.trendLinePeriodProperty));
		}
	}

	, 
	trendLineZIndex: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.AnchoredCategorySeries.prototype.trendLineZIndexProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.AnchoredCategorySeries.prototype.trendLineZIndexProperty));
		}
	}

	, 
	scrollIntoView: function (item) {
		var windowRect = this.view().windowRect();
		var viewportRect = this.view().viewport();
		var unitRect = new $.ig.Rect(0, 0, 0, 1, 1);
		var index = !windowRect.isEmpty() && !viewportRect.isEmpty() && this.fastItemsSource() != null ? this.fastItemsSource().indexOf(item) : -1;
		var xAxis = this.getXAxis();
		var yAxis = this.getYAxis();
		var xParams = new $.ig.ScalerParams(unitRect, unitRect, xAxis.isInverted());
		var yParams = new $.ig.ScalerParams(unitRect, unitRect, yAxis.isInverted());
		var cx = xAxis != null ? xAxis.getScaledValue(index, xParams) : NaN;
		var offset = xAxis != null ? this.framePreparer().getOffset($.ig.util.cast($.ig.ICategoryScaler.prototype.$type, xAxis), xParams._windowRect, xParams._viewportRect) : 0;
		cx += offset;
		var cy = yAxis != null && this.valueColumn() != null && index < this.valueColumn().count() ? yAxis.getScaledValue(this.valueColumn().item(index), yParams) : NaN;
		if (!$.ig.util.isNaN(cx)) {
			if (cx < windowRect.left() + 0.1 * windowRect.width()) {
				cx = cx + 0.4 * windowRect.width();
				windowRect.x(cx - 0.5 * windowRect.width());
			}

			if (cx > windowRect.right() - 0.1 * windowRect.width()) {
				cx = cx - 0.4 * windowRect.width();
				windowRect.x(cx - 0.5 * windowRect.width());
			}

		}

		if (!$.ig.util.isNaN(cy)) {
			if (cy < windowRect.top() + 0.1 * windowRect.height()) {
				cy = cy + 0.4 * windowRect.height();
				windowRect.y(cy - 0.5 * windowRect.height());
			}

			if (cy > windowRect.bottom() - 0.1 * windowRect.height()) {
				cy = cy - 0.4 * windowRect.height();
				windowRect.y(cy - 0.5 * windowRect.height());
			}

		}

		if (this.syncLink() != null) {
			this.syncLink().windowNotify(this.seriesViewer(), windowRect);
		}

		return index >= 0;
	}

	, 
	getCategoryItemsHelper: function (orderedStartIndex, orderedEndIndex, axis) {
		if (orderedEndIndex < orderedStartIndex || orderedStartIndex < 0 || orderedStartIndex > this.valueColumn().count() || orderedEndIndex < 0 || orderedEndIndex > this.valueColumn().count() || axis == null) {
			return null;
		}

		var ret = new Array((orderedEndIndex - orderedStartIndex) + 1);
		var isSorting = axis.isSorting();
		var sortedIndices = null;
		if (isSorting) {
			sortedIndices = (axis).sortedIndices();
		}

		for (var i = orderedStartIndex; i <= orderedEndIndex; i++) {
			var ind = i;
			if (isSorting) {
				ind = sortedIndices.__inner[ind];
			}

			ret[i - orderedStartIndex] = this.fastItemsSource().item(i);
		}

		return ret;
	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		$.ig.CategorySeries.prototype.propertyUpdatedOverride.call(this, sender, propertyName, oldValue, newValue);
		if (this.anchoredView().trendLineManager().propertyUpdated(sender, propertyName, oldValue, newValue)) {
			this.renderSeries(false);
			this.notifyThumbnailAppearanceChanged();
		}

		switch (propertyName) {
			case $.ig.Series.prototype.fastItemsSourcePropertyName:
				if ($.ig.util.cast($.ig.IFastItemsSource.prototype.$type, oldValue) != null) {
					($.ig.util.cast($.ig.IFastItemsSource.prototype.$type, oldValue)).deregisterColumn(this.valueColumn());
					this.valueColumn(null);
				}

				if ($.ig.util.cast($.ig.IFastItemsSource.prototype.$type, newValue) != null) {
					this.valueColumn(this.registerDoubleColumn(this.valueMemberPath()));
				}

				var yaxis = $.ig.util.cast($.ig.NumericAxisBase.prototype.$type, this.getYAxis());
				if (yaxis != null && !yaxis.updateRange()) {
					this.anchoredView().bucketCalculator().calculateBuckets(this.resolution());
					this.renderSeries(false);
				}

				break;
			case $.ig.AnchoredCategorySeries.prototype.valueMemberPathPropertyName:
				if (this.fastItemsSource() != null) {
					this.fastItemsSource().deregisterColumn(this.valueColumn());
					this.valueColumn(this.registerDoubleColumn(this.valueMemberPath()));
				}

				this.cachedValueMemberPath(this.valueMemberPath());
				break;
			case $.ig.AnchoredCategorySeries.prototype.valueColumnPropertyName:
				this.anchoredView().trendLineManager().reset();
				var yaxis2 = $.ig.util.cast($.ig.NumericAxisBase.prototype.$type, this.getYAxis());
				if (yaxis2 != null && !yaxis2.updateRange()) {
					this.anchoredView().bucketCalculator().calculateBuckets(this.resolution());
					this.renderSeries(false);
				}

				break;
			case $.ig.Series.prototype.trendLineBrushPropertyName:
				this.updateIndexedProperties();
				break;
			case $.ig.AnchoredCategorySeries.prototype.errorBarSettingsPropertyName:
				this.renderSeries(false);
				break;
			case $.ig.Series.prototype.trendLineTypePropertyName:
				this.notifyThumbnailAppearanceChanged();
				break;
		}

	}

	, 
	getRange: function (axis) {
		if (this.valueColumn() == null || this.valueColumn().count() == 0) {
			return null;
		}

		if (axis == this.getXAxis()) {
			return new $.ig.AxisRange(0, this.valueColumn().count() - 1);
		}

		if (axis == this.getYAxis()) {
			return new $.ig.AxisRange(this.valueColumn().minimum(), this.valueColumn().maximum());
		}

		return null;
	}

	, 
	dataUpdatedOverride: function (action, position, count, propertyName) {
		switch (action) {
			case $.ig.FastItemsSourceEventAction.prototype.reset:
			case $.ig.FastItemsSourceEventAction.prototype.insert:
			case $.ig.FastItemsSourceEventAction.prototype.remove:
				this.anchoredView().bucketCalculator().calculateBuckets(this.resolution());
				break;
		}

		this.anchoredView().trendLineManager().dataUpdated(action, position, count, propertyName);
	}

	, 
	getTransitionFromZeroValue: function () {
		return this.getWorldZeroValue(this.categoryView());
	}

	, 
	getWorldZeroValue: function (view) {
		var value = 0;
		var windowRect = view.windowRect();
		var viewportRect = view.viewport();
		var yAxis = $.ig.util.cast($.ig.NumericYAxis.prototype.$type, this.getYAxis());
		if (!windowRect.isEmpty() && !viewportRect.isEmpty() && yAxis != null) {
			var p = new $.ig.ScalerParams(windowRect, viewportRect, yAxis.isInverted());
			value = yAxis.getScaledValue(yAxis.referenceValue(), p);
		}

		return value;
	}

	, 
	terminatePolygon: function (polygon, count, view) {
		var worldZeroValue = this.getWorldZeroValue(view);
		if (polygon.count() > 0) {
			var zero = worldZeroValue;
			polygon.add({__x: $.ig.Enumerable.prototype.last$1($.ig.Point.prototype.$type, polygon).__x, __y: zero, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			polygon.add({__x: $.ig.Enumerable.prototype.first$1($.ig.Point.prototype.$type, polygon).__x, __y: zero, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
		}

	}

	, 
	getLineClipper: function (buckets, endIndex, viewportRect, windowRect) {
		var clipper = null;
		if (endIndex > -1 && !windowRect.isEmpty() && !viewportRect.isEmpty()) {
			var left = buckets.__inner[0][0] < viewportRect.left() - 2000 ? viewportRect.left() - 10 : NaN;
			var bottom = viewportRect.bottom() + 10;
			var right = buckets.__inner[endIndex][0] > viewportRect.right() + 2000 ? viewportRect.right() + 10 : NaN;
			var top = viewportRect.top() - 10;
			clipper = new $.ig.Clipper(1, left, bottom, right, top, false);
		}

		return clipper;
	}

	, 
	validateSeries: function (viewportRect, windowRect, view) {
		var isValid = $.ig.CategorySeries.prototype.validateSeries.call(this, viewportRect, windowRect, view);
		var anchoredView = view;
		if (this.valueColumn() == null || this.valueColumn().count() == 0 || anchoredView.bucketCalculator()._bucketSize < 1) {
			isValid = false;
		}

		return isValid;
	}

	, 
	clearRendering: function (wipeClean, view) {
		$.ig.CategorySeries.prototype.clearRendering.call(this, wipeClean, view);
		var catView = view;
		catView.hideErrorBars();
		catView.trendLineManager().clearPoints();
	}

	, 
	prepareFrame: function (frame, view) {
		$.ig.CategorySeries.prototype.prepareFrame.call(this, frame, view);
		this.getFramePreparer(view).prepareFrame(frame, view);
	}

	, 
	renderFrame: function (frame, view) {
		$.ig.CategorySeries.prototype.renderFrame.call(this, frame, view);
		var anchoredView = $.ig.util.cast($.ig.AnchoredCategorySeriesView.prototype.$type, view);
		anchoredView.markerAppearanceHandled(true);
		anchoredView.trendLineManager().rasterizeTrendLine(frame._trend);
		if (this.shouldDisplayMarkers()) {
			$.ig.CategoryMarkerManager.prototype.rasterizeMarkers(this, frame._markers, view.markers(), this.useLightweightMarkers());
			this.colorizeMarkers(view, frame);
			view.renderMarkers();
		}

		this.renderErrorBars(frame, view);
	}

	, 
	_alternateFrame: null,
	alternateFrame: function (value) {
		if (arguments.length === 1) {
			this._alternateFrame = value;
			return value;
		} else {
			return this._alternateFrame;
		}
	}

	, 
	renderAlternateView: function (viewportRect, windowRect, surface, viewIdentifier, effectiveScalingRatio) {
		$.ig.CategorySeries.prototype.renderAlternateView.call(this, viewportRect, windowRect, surface, viewIdentifier, effectiveScalingRatio);
		var view = this.alternateViews().item(viewIdentifier);
		var categorySeriesView = view;
		categorySeriesView.bucketCalculator().calculateBuckets(this.resolution());
		view.prepAltSurface(surface);
		if (this.clearAndAbortIfInvalid1(categorySeriesView)) {
			return;
		}

		if (this.alternateFrame() == null) {
			this.alternateFrame(new $.ig.CategoryFrame(3));
		}

		this.alternateFrame().clearFrame();
		this.prepareFrame(this.alternateFrame(), categorySeriesView);
		this.renderFrame(this.alternateFrame(), categorySeriesView);
	}

	, 
	renderErrorBars: function (frame, view) {
	}

	, 
	updateIndexedProperties: function () {
		$.ig.CategorySeries.prototype.updateIndexedProperties.call(this);
		if (this.index() < 0) {
			return;
		}

		this.anchoredView().resetTrendlineBrush();
		if (this.trendLineBrush() != null) {
			this.anchoredView().bindTrendlineBrushToActualTrendlineBrush();

		} else {
			this.anchoredView().bindTrendlineBrushToActualBrush();
		}

	}

	, 
	item: function (sender, point) {
		if (sender == this.anchoredView().trendLineManager().trendPolyline()) {
			return null;
		}

		return $.ig.CategorySeries.prototype.item.call(this, sender, point);
	}

	, 
	currentCategoryMode: function () {

			return this.preferredCategoryMode($.ig.util.cast($.ig.CategoryAxisBase.prototype.$type, this.getXAxis()));
	}

	, 
	scaler: function () {

			return $.ig.util.cast($.ig.ICategoryScaler.prototype.$type, this.getXAxis());
	}

	, 
	yScaler: function () {

			return $.ig.util.cast($.ig.IScaler.prototype.$type, this.getYAxis());
	}

	, 
	bucketizer: function () {

			return this.anchoredView().bucketCalculator();
	}

	, 
	currentMode2Index: function () {

			return this.getMode2Index();
	}

	, 
	provideCollisionDetector: function () {
		return new $.ig.CollisionAvoider();
	}

	, 
	trendlinePreparer: function () {

			return this.anchoredView().trendLineManager();
	}

	, 
	_cachedValueMemberPath: null,
	cachedValueMemberPath: function (value) {
		if (arguments.length === 1) {
			this._cachedValueMemberPath = value;
			return value;
		} else {
			return this._cachedValueMemberPath;
		}
	}

	, 
	setXAxis: function (xAxis) {}

	, 
	setYAxis: function (yAxis) {}

	, 
	exportVisualDataOverride: function (svd) {
		$.ig.CategorySeries.prototype.exportVisualDataOverride.call(this, svd);
		var trendShape = new $.ig.PolyLineVisualData(1, "trendLine", this.anchoredView().trendLineManager().trendPolyline());
		trendShape.tags().add("Trend");
		svd.shapes().add(trendShape);
	}
	, 
	$type: new $.ig.Type('AnchoredCategorySeries', $.ig.CategorySeries.prototype.$type, [$.ig.IIsCategoryBased.prototype.$type, $.ig.IHasSingleValueCategory.prototype.$type, $.ig.IHasCategoryTrendline.prototype.$type])
}, true);

$.ig.util.defType('VerticalAnchoredCategorySeries', 'AnchoredCategorySeries', {
	init: function () {


		$.ig.AnchoredCategorySeries.prototype.init.call(this);

	}
	, 
	xAxis: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.VerticalAnchoredCategorySeries.prototype.xAxisProperty, value);
			return value;
		} else {

			return this.getValue($.ig.VerticalAnchoredCategorySeries.prototype.xAxisProperty);
		}
	}

	, 
	yAxis: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.VerticalAnchoredCategorySeries.prototype.yAxisProperty, value);
			return value;
		} else {

			return this.getValue($.ig.VerticalAnchoredCategorySeries.prototype.yAxisProperty);
		}
	}

	, 
	isVertical: function () {

			return true;
	}

	, 
	getCategoryAxis: function () {
		return this.yAxis();
	}

	, 
	getOffsetValue: function () {
		return this.framePreparer().getOffset(this.yAxis(), this.view().windowRect(), this.view().viewport());
	}

	, 
	getCategoryWidth: function () {
		return this.yAxis().getCategorySize(this.view().windowRect(), this.view().viewport());
	}

	, 
	getNextOrExactIndex: function (world, skipUnknowns) {
		return this.getNextOrExactIndexHelper(world, skipUnknowns, this.yAxis(), this.getExactUnsortedItemIndex.runOn(this), this.valueColumn());
	}

	, 
	getPreviousOrExactIndex: function (world, skipUnknowns) {
		return this.getPreviousOrExactIndexHelper(world, skipUnknowns, this.yAxis(), this.getExactUnsortedItemIndex.runOn(this), this.valueColumn());
	}

	, 
	getDistanceToIndex: function (world, index, axis, p, offset) {
		if (this.valueColumn() == null) {
			return Number.POSITIVE_INFINITY;
		}

		return this.getDistanceToIndexHelper(world, index, this.yAxis(), p, offset, this.valueColumn().count(), this.getExactUnsortedItemIndex.runOn(this));
	}

	, 
	getSeriesValue: function (world, useInterpolation, skipUnknowns) {
		if (this.seriesViewer() == null) {
			return NaN;
		}

		var yParams = new $.ig.ScalerParams(this.seriesViewer().actualWindowRect(), this.view().viewport(), this.yAxis().isInverted());
		var offset = this.framePreparer().getOffset(this.yAxis(), this.seriesViewer().actualWindowRect(), this.view().viewport());
		return this.getSeriesValueHelper(this.valueColumn(), world, this.yAxis(), yParams, offset, this.getExactUnsortedItemIndex.runOn(this), useInterpolation, skipUnknowns);
	}

	, 
	getSeriesValuePosition: function (world, useInterpolation, skipUnknowns) {
		return this.getSeriesValuePositionHelper(world, useInterpolation, skipUnknowns, this.framePreparer().getOffset(this.yAxis(), this.view().windowRect(), this.view().viewport()), this.xAxis(), this.yAxis(), null, null, null);
	}

	, 
	getXAxis: function () {
		return this.xAxis();
	}

	, 
	getYAxis: function () {
		return this.yAxis();
	}

	, 
	setXAxis: function (xAxis) {
		this.xAxis($.ig.util.cast($.ig.NumericXAxis.prototype.$type, xAxis));
	}

	, 
	setYAxis: function (yAxis) {
		this.yAxis($.ig.util.cast($.ig.CategoryYAxis.prototype.$type, yAxis));
	}

	, 
	updateNumericAxisRange: function () {
		return this.xAxis() != null && this.xAxis().updateRange();
	}

	, 
	getCategoryItems: function (orderedStartIndex, orderedEndIndex) {
		return this.getCategoryItemsHelper(orderedStartIndex, orderedEndIndex, this.yAxis());
	}

	, 
	getExactItemIndex: function (world) {
		var windowRect = this.seriesViewer() != null ? this.seriesViewer().actualWindowRect() : $.ig.Rect.prototype.empty();
		var viewportRect = this.view().viewport();
		var rowIndex = -1;
		if (this.yAxis() != null && !windowRect.isEmpty() && !viewportRect.isEmpty()) {
			var top = this.yAxis().getUnscaledValue2(viewportRect.top(), windowRect, viewportRect, this.yAxis().categoryMode());
			var bottom = this.yAxis().getUnscaledValue2(viewportRect.bottom(), windowRect, viewportRect, this.yAxis().categoryMode());
			var windowY = (world.__y - windowRect.top()) / windowRect.height();
			var bucket = top + (windowY * (bottom - top));
			if (this.yAxis().categoryMode() != $.ig.CategoryMode.prototype.mode0) {
				bucket -= 0.5;
			}

			rowIndex = bucket;
		}

		return rowIndex;
	}

	, 
	getExactUnsortedItemIndex: function (world) {
		return this.getExactUnsortedItemIndexHelper(world, this.getYAxis());
	}

	, 
	getItemIndex: function (world) {
		return $.ig.truncate(Math.round(this.getExactItemIndex(world)));
	}

	, 
	getItem: function (world) {
		var index = this.getItemIndex(world);
		return index >= 0 && this.fastItemsSource() != null && index < this.fastItemsSource().count() ? this.fastItemsSource().item(index) : null;
	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		$.ig.AnchoredCategorySeries.prototype.propertyUpdatedOverride.call(this, sender, propertyName, oldValue, newValue);
		switch (propertyName) {
			case $.ig.VerticalAnchoredCategorySeries.prototype.xAxisPropertyName:
				if (oldValue != newValue) {
					this.deregisterForAxis($.ig.util.cast($.ig.Axis.prototype.$type, oldValue));
					this.registerForAxis($.ig.util.cast($.ig.Axis.prototype.$type, newValue));
					this.categoryView().bucketCalculator().calculateBuckets(this.resolution());
					this.renderSeries(false);
					this.notifyThumbnailAppearanceChanged();
				}

				break;
			case $.ig.VerticalAnchoredCategorySeries.prototype.yAxisPropertyName:
				if (oldValue != newValue) {
					this.deregisterForAxis($.ig.util.cast($.ig.Axis.prototype.$type, oldValue));
					this.registerForAxis($.ig.util.cast($.ig.Axis.prototype.$type, newValue));
					this.categoryView().bucketCalculator().calculateBuckets(this.resolution());
					this.updateNumericAxisRange();
					this.renderSeries(false);
					this.notifyThumbnailAppearanceChanged();
				}

				break;
		}

	}
	, 
	$type: new $.ig.Type('VerticalAnchoredCategorySeries', $.ig.AnchoredCategorySeries.prototype.$type)
}, true);

$.ig.util.defType('IBarSeries', 'Object', {
	$type: new $.ig.Type('IBarSeries', null)
}, true);

$.ig.util.defType('BarSeries', 'VerticalAnchoredCategorySeries', {

	createView: function () {
		return new $.ig.BarSeriesView(this);
	}

	, 
	getDefaultTransitionInMode: function () {
		return $.ig.CategoryTransitionInMode.prototype.fromZero;
	}

	, 
	onViewCreated: function (view) {
		$.ig.VerticalAnchoredCategorySeries.prototype.onViewCreated.call(this, view);
		this.barView(view);
	}

	, 
	_barView: null,
	barView: function (value) {
		if (arguments.length === 1) {
			this._barView = value;
			return value;
		} else {
			return this._barView;
		}
	}

	, 
	hasIndividualElements: function () {

			return true;
	}
	, 
	init: function () {



		$.ig.VerticalAnchoredCategorySeries.prototype.init.call(this);
			this.defaultStyleKey($.ig.BarSeries.prototype.$type);
			this.framePreparer(new $.ig.BarFramePreparer(1, this, this.barView(), this, this, this.barView().bucketCalculator()));
	}

	, 
	getFramePreparer: function (view) {
		var categoryView = $.ig.util.cast($.ig.CategorySeriesView.prototype.$type, view);
		if (categoryView != null && categoryView.isThumbnailView()) {
			if (categoryView.isAlternateView()) {
				return new $.ig.BarFramePreparer(1, this, $.ig.util.cast($.ig.ISupportsMarkers.prototype.$type, categoryView), categoryView, this, categoryView.bucketCalculator());

			} else {
				return new $.ig.BarFramePreparer(1, this, $.ig.util.cast($.ig.ISupportsMarkers.prototype.$type, categoryView), this.seriesViewer().view().overviewPlusDetailViewportHost(), this, categoryView.bucketCalculator());
			}


		} else {
			return this.framePreparer();
		}

	}

	, 
	onApplyTemplate: function () {
		$.ig.VerticalAnchoredCategorySeries.prototype.onApplyTemplate.call(this);
	}

	, 
	radiusX: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.BarSeries.prototype.radiusXProperty, value);
			return value;
		} else {

			return this.getValue($.ig.BarSeries.prototype.radiusXProperty);
		}
	}

	, 
	radiusY: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.BarSeries.prototype.radiusYProperty, value);
			return value;
		} else {

			return this.getValue($.ig.BarSeries.prototype.radiusYProperty);
		}
	}

	, 
	preferredCategoryMode: function (axis) {
		return $.ig.CategoryMode.prototype.mode2;
	}

	, 
	clearRendering: function (wipeClean, view) {
		$.ig.VerticalAnchoredCategorySeries.prototype.clearRendering.call(this, wipeClean, view);
		var barView = $.ig.util.cast($.ig.BarSeriesView.prototype.$type, view);
		if (wipeClean && barView != null && barView.columns() != null) {
			barView.columns().count(0);
		}

	}

	, 
	getMode2Index: function () {
		var result = 0;
		var en = this.seriesViewer().series().getEnumerator();
		while (en.moveNext()) {
			var currentSeries = en.current();
			if (currentSeries == this) {
				return result;
			}

			var currentCategorySeries = $.ig.util.cast($.ig.IBarSeries.prototype.$type, currentSeries);
			if (currentCategorySeries != null && currentCategorySeries.yAxis() == this.yAxis() && currentCategorySeries.getPreferredCategoryMode() == $.ig.CategoryMode.prototype.mode2) {
				result++;
			}

		}

		$.ig.Debug.prototype.assert1(false, "CategorySeries.GetMode2Index failed to find series");
		return -1;
	}

	, 
	getWorldZeroValue: function (view) {
		var value = 0;
		var windowRect = view.windowRect();
		var viewportRect = view.viewport();
		var xParams = new $.ig.ScalerParams(windowRect, viewportRect, this.xAxis().isInverted());
		if (!windowRect.isEmpty() && !viewportRect.isEmpty() && this.xAxis() != null) {
			value = this.xAxis().getScaledValue(this.xAxis().referenceValue(), xParams);
		}

		return value;
	}

	, 
	getRange: function (axis) {
		if (this.valueColumn() == null || this.valueColumn().count() == 0) {
			return null;
		}

		if (axis == this.yAxis()) {
			return new $.ig.AxisRange(0, this.valueColumn().count() - 1);
		}

		if (axis == this.xAxis()) {
			return new $.ig.AxisRange(this.valueColumn().minimum(), this.valueColumn().maximum());
		}

		return null;
	}

	, 
	scrollIntoView: function (item) {
		var windowRect = this.view().windowRect();
		var viewportRect = this.view().viewport();
		var unitRect = new $.ig.Rect(0, 0, 0, 1, 1);
		var index = !windowRect.isEmpty() && !viewportRect.isEmpty() && this.fastItemsSource() != null ? this.fastItemsSource().indexOf(item) : -1;
		var xParams = new $.ig.ScalerParams(unitRect, unitRect, this.xAxis().isInverted());
		var yParams = new $.ig.ScalerParams(unitRect, unitRect, this.yAxis().isInverted());
		var cy = this.yAxis() != null ? this.yAxis().getScaledValue(index, yParams) : NaN;
		var offset = this.yAxis() != null ? this.framePreparer().getOffset(this.yAxis(), unitRect, unitRect) : 0;
		cy += offset;
		var cx = this.xAxis() != null && this.valueColumn() != null && index < this.valueColumn().count() ? this.xAxis().getScaledValue(this.valueColumn().item(index), xParams) : NaN;
		if (!$.ig.util.isNaN(cx)) {
			if (cx < windowRect.left() + 0.1 * windowRect.width()) {
				cx = cx + 0.4 * windowRect.width();
				windowRect.x(cx - 0.5 * windowRect.width());
			}

			if (cx > windowRect.right() - 0.1 * windowRect.width()) {
				cx = cx - 0.4 * windowRect.width();
				windowRect.x(cx - 0.5 * windowRect.width());
			}

		}

		if (!$.ig.util.isNaN(cy)) {
			if (cy < windowRect.top() + 0.1 * windowRect.height()) {
				cy = cy + 0.4 * windowRect.height();
				windowRect.y(cy - 0.5 * windowRect.height());
			}

			if (cy > windowRect.bottom() - 0.1 * windowRect.height()) {
				cy = cy - 0.4 * windowRect.height();
				windowRect.y(cy - 0.5 * windowRect.height());
			}

		}

		if (this.syncLink() != null) {
			this.syncLink().windowNotify(this.seriesViewer(), windowRect);
		}

		return index >= 0;
	}

	, 
	renderFrame: function (frame, view) {
		$.ig.VerticalAnchoredCategorySeries.prototype.renderFrame.call(this, frame, view);
		var buckets = frame._buckets;
		if (!view.hasSurface()) {
			return;
		}

		var windowRect = view.windowRect();
		var viewportRect = view.viewport();
		var xParams = new $.ig.ScalerParams(windowRect, viewportRect, this.xAxis().isInverted());
		var yAxis = this.yAxis();
		var yParams = new $.ig.ScalerParams(windowRect, viewportRect, this.yAxis().isInverted());
		var xscale = this.xAxis();
		var zero = xscale.getScaledValue(xscale.referenceValue(), xParams);
		var groupWidth = this.yAxis().getGroupSize(windowRect, viewportRect);
		var barView = $.ig.util.cast($.ig.BarSeriesView.prototype.$type, view);
		if ($.ig.util.isNaN(groupWidth) || Number.isInfinity(groupWidth) || $.ig.util.isNaN(zero)) {
			barView.columns().count(0);
			return;
		}

		this._renderManager.initCategoryRenderSettings(this, this.shouldOverrideCategoryStyle(), this.yAxis(), this.getCategoryItems.runOn(this), this.getBucketSize(view), this.getFirstBucket(view));
		this._renderManager._initialRenderRadiusX = this.radiusX();
		this._renderManager._initialRenderRadiusY = this.radiusY();
		this._renderManager._actualRenderRadiusX = this.radiusX();
		this._renderManager._actualRenderRadiusY = this.radiusY();
		var areStylesOverriden = false;
		var args = this._renderManager.categoryOverrideArgs();
		if (args != null) {
			areStylesOverriden = true;
		}

		var isSorting = this.xAxis().isSorting();
		var valueCount = this.valueColumn().count();
		for (var i = 0; i < buckets.count(); ++i) {
			var top = buckets.__inner[i][0] - 0.5 * groupWidth;
			var right = buckets.__inner[i][1];
			var left = zero;
			left = Math.max(left, -100);
			right = Math.min(right, viewportRect.right() + 100);
			var column = barView.columns().item(i);
			column.height(groupWidth);
			column.width(Math.abs(right - left));
			if (areStylesOverriden) {
				this.performCategoryStyleOverride(buckets, i, valueCount, yAxis, yParams, view.isThumbnailView());
			}

			this._renderManager.setCategoryShapeAppearance(column, false, false, false, false);
			column.radiusX(this._renderManager._actualRenderRadiusX);
			column.radiusY(this._renderManager._actualRenderRadiusY);
			barView.setColumnPosition(column, Math.min(right, left), top);
		}

		barView.columns().count(buckets.count());
		view.updateFrameVersion(frame);
	}

	, 
	dataUpdatedOverride: function (action, position, count, propertyName) {
		switch (action) {
			case $.ig.FastItemsSourceEventAction.prototype.reset:
			case $.ig.FastItemsSourceEventAction.prototype.insert:
			case $.ig.FastItemsSourceEventAction.prototype.remove:
				this.anchoredView().bucketCalculator().calculateBuckets(this.resolution());
				break;
		}

		this.anchoredView().trendLineManager().dataUpdated(action, position, count, propertyName);
		switch (action) {
			case $.ig.FastItemsSourceEventAction.prototype.reset:
				if (this.xAxis() != null && !this.xAxis().updateRange()) {
					this.renderSeries(true);
				}

				break;
			case $.ig.FastItemsSourceEventAction.prototype.insert:
				if (this.xAxis() != null && !this.xAxis().updateRange()) {
					this.renderSeries(true);
				}

				break;
			case $.ig.FastItemsSourceEventAction.prototype.remove:
				if (this.xAxis() != null && !this.xAxis().updateRange()) {
					this.renderSeries(true);
				}

				break;
			case $.ig.FastItemsSourceEventAction.prototype.replace:
				if (this.valueMemberPath() != null && this.anchoredView().bucketCalculator()._bucketSize > 0) {
					this.renderSeries(true);
				}

				break;
			case $.ig.FastItemsSourceEventAction.prototype.change:
				if (propertyName == this.valueMemberPath()) {
					if (this.xAxis() != null && !this.xAxis().updateRange()) {
						this.renderSeries(true);
					}

				}

				break;
		}

	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		$.ig.VerticalAnchoredCategorySeries.prototype.propertyUpdatedOverride.call(this, sender, propertyName, oldValue, newValue);
		switch (propertyName) {
			case $.ig.VerticalAnchoredCategorySeries.prototype.xAxisPropertyName:
				if (oldValue != null) {
					($.ig.util.cast($.ig.Axis.prototype.$type, oldValue)).deregisterSeries(this);
				}

				if (newValue != null) {
					($.ig.util.cast($.ig.Axis.prototype.$type, newValue)).registerSeries(this);
				}

				this.anchoredView().bucketCalculator().calculateBuckets(this.resolution());
				if (this.xAxis() != null && this.xAxis().updateRange()) {
					this.renderSeries(false);
				}

				break;
			case $.ig.VerticalAnchoredCategorySeries.prototype.yAxisPropertyName:
				if (oldValue != null) {
					($.ig.util.cast($.ig.Axis.prototype.$type, oldValue)).deregisterSeries(this);
				}

				if (newValue != null) {
					($.ig.util.cast($.ig.Axis.prototype.$type, newValue)).registerSeries(this);
				}

				this.anchoredView().trendLineManager($.ig.CategoryTrendLineManagerBase.prototype.selectManager(this.anchoredView().trendLineManager(), this.yAxis(), this.rootCanvas(), this));
				this.anchoredView().bucketCalculator().calculateBuckets(this.resolution());
				this.renderSeries(false);
				break;
			case $.ig.Series.prototype.fastItemsSourcePropertyName:
				if (this.xAxis() != null && !this.xAxis().updateRange()) {
					this.anchoredView().bucketCalculator().calculateBuckets(this.resolution());
					this.renderSeries(false);
				}

				break;
			case $.ig.AnchoredCategorySeries.prototype.valueColumnPropertyName:
				if (this.xAxis() != null && !this.xAxis().updateRange()) {
					this.anchoredView().bucketCalculator().calculateBuckets(this.resolution());
					this.renderSeries(false);
				}

				break;
			case $.ig.Series.prototype.seriesViewerPropertyName:
				if (oldValue != null && newValue == null) {
					this.deregisterForAxis(this.xAxis());
					this.deregisterForAxis(this.yAxis());
				}

				if (oldValue == null && newValue != null) {
					this.registerForAxis(this.xAxis());
					this.registerForAxis(this.yAxis());
				}

				this.anchoredView().bucketCalculator().calculateBuckets(this.resolution());
				this.renderSeries(false);
				break;
		}

	}

	, 
	getPreferredCategoryMode: function () {
		return this.preferredCategoryMode(this.yAxis());
	}

	, 
	currentCategoryMode: function () {

			return this.preferredCategoryMode(this.yAxis());
	}

	, 
	scaler: function () {

			return this.yAxis();
	}

	, 
	yScaler: function () {

			return this.xAxis();
	}
	, 
	$type: new $.ig.Type('BarSeries', $.ig.VerticalAnchoredCategorySeries.prototype.$type, [$.ig.IIsCategoryBased.prototype.$type, $.ig.IBarSeries.prototype.$type])
}, true);

$.ig.util.defType('ISupportsMarkers', 'Object', {
	$type: new $.ig.Type('ISupportsMarkers', null)
}, true);

$.ig.util.defType('CategorySeriesView', 'MarkerSeriesView', {

	_categoryModel: null,
	categoryModel: function (value) {
		if (arguments.length === 1) {
			this._categoryModel = value;
			return value;
		} else {
			return this._categoryModel;
		}
	}

	, 
	_frameVersion: 0,
	frameVersion: function (value) {
		if (arguments.length === 1) {
			this._frameVersion = value;
			return value;
		} else {
			return this._frameVersion;
		}
	}

	, 
	checkFrameDirty: function (frame) {
		if (this.frameVersion() != frame.frameVersion()) {
			return true;
		}

		return false;
	}

	, 
	updateFrameVersion: function (frame) {
		this.frameVersion(frame.frameVersion());
	}
	, 
	init: function (model) {



		var $self = this;
		$.ig.MarkerSeriesView.prototype.init.call(this, model);
			this.frameVersion(-1);
			this.categoryModel(model);
			this.bucketCalculator(this.createBucketCalculator());
			this.markers((function () { var $ret = new $.ig.Pool$1($.ig.Marker.prototype.$type);
			$ret.create($self.markerCreate.runOn($self));
			$ret.activate($self.markerActivate.runOn($self));
			$ret.disactivate($self.markerDisactivate.runOn($self));
			$ret.destroy($self.markerDestroy.runOn($self)); return $ret;}()));
	}

	, 
	updateMarkerTemplate: function (markerCount, itemIndex, markerBucket) {
		if (!this.markerModel().useLightweightMarkers()) {
			var marker = this.markers().item(markerCount);
			var context = marker.content();
			context.item(this.model().fastItemsSource().item(itemIndex));
			marker.currentIndex(itemIndex);
			marker.markerBucket(markerBucket);
		}

	}

	, 
	_bucketCalculator: null,
	bucketCalculator: function (value) {
		if (arguments.length === 1) {
			this._bucketCalculator = value;
			return value;
		} else {
			return this._bucketCalculator;
		}
	}

	, 
	createBucketCalculator: function () {
		return new $.ig.CategoryBucketCalculator(this);
	}

	, 
	_markers: null,
	markers: function (value) {
		if (arguments.length === 1) {
			this._markers = value;
			return value;
		} else {
			return this._markers;
		}
	}

	, 
	shouldDisplayMarkers: function () {

			return this.categoryModel().shouldDisplayMarkers();
	}

	, 
	updateMarkerCount: function (markerCount) {
		this.markers().count(markerCount);
	}

	, 
	doToAllMarkers: function (action) {
		this.markers().doToAll(action);
	}

	, 
	hideErrorBars: function () {
	}
	, 
	$type: new $.ig.Type('CategorySeriesView', $.ig.MarkerSeriesView.prototype.$type, [$.ig.ISupportsMarkers.prototype.$type])
}, true);

$.ig.util.defType('AnchoredCategorySeriesView', 'CategorySeriesView', {

	_anchoredModel: null,
	anchoredModel: function (value) {
		if (arguments.length === 1) {
			this._anchoredModel = value;
			return value;
		} else {
			return this._anchoredModel;
		}
	}
	, 
	init: function (model) {



		$.ig.CategorySeriesView.prototype.init.call(this, model);
			this.anchoredModel(model);
			this.trendLineManager(new $.ig.CategoryTrendLineManager());
	}

	, 
	_trendLineManager: null,
	trendLineManager: function (value) {
		if (arguments.length === 1) {
			this._trendLineManager = value;
			return value;
		} else {
			return this._trendLineManager;
		}
	}

	, 
	resetTrendlineBrush: function () {
		this.anchoredModel().actualTrendLineBrush(null);
	}

	, 
	bindTrendlineBrushToActualTrendlineBrush: function () {
		this.anchoredModel().actualTrendLineBrush(this.anchoredModel().trendLineBrush());
	}

	, 
	bindTrendlineBrushToActualBrush: function () {
		this.anchoredModel().actualTrendLineBrush(this.anchoredModel().actualBrush());
	}

	, 
	createBucketCalculator: function () {
		return new $.ig.AnchoredCategoryBucketCalculator(this);
	}

	, 
	cacheValues: function () {
		this.bucketCalculator().cacheValues();
	}

	, 
	unCacheValues: function () {
		this.bucketCalculator().unCacheValues();
	}

	, 
	renderMarkersOverride: function (context, isHitContext) {
		if (context.shouldRender()) {
			if (this.anchoredModel().trendLineType() != $.ig.TrendLineType.prototype.none && !isHitContext) {
				var polyline = this.trendLineManager().trendPolyline();
				polyline.strokeThickness(this.anchoredModel().trendLineThickness());
				polyline.__stroke = this.anchoredModel().actualTrendLineBrush();
				polyline.strokeDashArray(this.anchoredModel().trendLineDashArray());
				polyline.strokeDashCap(this.anchoredModel().trendLineDashCap());
				context.renderPolyline(polyline);
			}

		}

		$.ig.CategorySeriesView.prototype.renderMarkersOverride.call(this, context, isHitContext);
	}

	, 
	getDefaultTooltipTemplate: function () {
		var tooltipTemplate = "<div class=\'ui-chart-default-tooltip-content\'>";
		var axis = null;
		if (this.anchoredModel().getXAxis().isCategory()) {
			axis = this.anchoredModel().getXAxis();

		} else if (this.anchoredModel().getYAxis().isCategory()) {
			axis = this.anchoredModel().getYAxis();
		}


		var dateTimeAxis = $.ig.util.cast($.ig.CategoryDateTimeXAxis.prototype.$type, axis);
		if (dateTimeAxis != null) {
			tooltipTemplate += "<span>${item." + dateTimeAxis.dateTimeMemberPath() + "}</span><br/>";

		} else if (axis != null && axis.label() != null) {
			tooltipTemplate += "<span>${item." + axis.label() + "}</span><br/>";
		}


		tooltipTemplate += "<span";
		if (this.model().actualOutline() != null && $.ig.Color.prototype.l_op_Inequality_Lifted($.ig.util.toNullable($.ig.Color.prototype.$type, this.model().actualOutline().color()), $.ig.util.toNullable($.ig.Color.prototype.$type, null))) {
			tooltipTemplate += " style=\'color:" + this.model().actualOutline().__fill + "\'";
		}

		tooltipTemplate += ">${series.title}: </span><span class=\'ui-priority-primary\'>" + "${item." + this.anchoredModel().valueMemberPath() + "}</span></div>";
		return tooltipTemplate;
	}
	, 
	$type: new $.ig.Type('AnchoredCategorySeriesView', $.ig.CategorySeriesView.prototype.$type)
}, true);

$.ig.util.defType('BarSeriesView', 'AnchoredCategorySeriesView', {

	_barModel: null,
	barModel: function (value) {
		if (arguments.length === 1) {
			this._barModel = value;
			return value;
		} else {
			return this._barModel;
		}
	}
	, 
	init: function (model) {


		this.__hitItem = new $.ig.Rectangle();

		var $self = this;
		$.ig.AnchoredCategorySeriesView.prototype.init.call(this, model);
			this.barModel(model);
			this.columns((function () { var $ret = new $.ig.Pool$1($.ig.Rectangle.prototype.$type);
			$ret.create($self.columnCreate.runOn($self));
			$ret.activate($self.columnActivate.runOn($self));
			$ret.disactivate($self.columnDisactivate.runOn($self));
			$ret.destroy($self.columnDestroy.runOn($self)); return $ret;}()));
			this.trendLineManager(new $.ig.BarTrendLineManager());
	}

	, 
	_columns: null,
	columns: function (value) {
		if (arguments.length === 1) {
			this._columns = value;
			return value;
		} else {
			return this._columns;
		}
	}

	, 
	onInit: function () {
		var $self = this;
		$.ig.AnchoredCategorySeriesView.prototype.onInit.call($self);
		$self.visibleColumns(new $.ig.List$1($.ig.Rectangle.prototype.$type, 0));
		if (!$self.isThumbnailView()) {
			$self.model().resolution(4);
			$self.model().legendItemBadgeTemplate((function () { var $ret = new $.ig.DataTemplate();
			$ret.render($.ig.LegendTemplates.prototype.rectBadgeTemplate);
			$ret.measure($.ig.LegendTemplates.prototype.legendItemBadgeMeasure); return $ret;}()));
		}

	}

	, 
	columnCreate: function () {
		var column = new $.ig.Rectangle();
		this.visibleColumns().add(column);
		column.__visibility = $.ig.Visibility.prototype.collapsed;
		return column;
	}

	, 
	_visibleColumns: null,
	visibleColumns: function (value) {
		if (arguments.length === 1) {
			this._visibleColumns = value;
			return value;
		} else {
			return this._visibleColumns;
		}
	}

	, 
	columnActivate: function (column) {
		column.__visibility = $.ig.Visibility.prototype.visible;
	}

	, 
	columnDisactivate: function (column) {
		column.__visibility = $.ig.Visibility.prototype.collapsed;
	}

	, 
	columnDestroy: function (column) {
		this.visibleColumns().remove(column);
	}

	, 
	setColumnPosition: function (column, x, y) {
		if (!this.isDirty()) {
			this.makeDirty();
		}

		column.canvasTop(y);
		column.canvasLeft(x);
	}

	, 
	createBucketCalculator: function () {
		return new $.ig.BarBucketCalculator(this);
	}

	, 
	setupItemHitAppearanceOverride: function (item, index) {
		$.ig.AnchoredCategorySeriesView.prototype.setupItemHitAppearanceOverride.call(this, item, index);
		var rect = item;
		var brush = this.getHitBrush1(index);
		rect.__fill = brush;
		rect.__stroke = brush;
		rect.strokeThickness(this.model().thickness());
	}

	, 
	getItem: function (index) {
		return this.visibleColumns().__inner[index];
	}
	, 
	__hitItem: null

	, 
	getHitItem: function (index) {
		var item = this.visibleColumns().__inner[index];
		this.__hitItem.canvasLeft(item.canvasLeft());
		this.__hitItem.canvasTop(item.canvasTop());
		this.__hitItem.width(item.width());
		this.__hitItem.height(item.height());
		var hitBrush = this.getHitBrush1(index);
		this.__hitItem.__fill = hitBrush;
		this.__hitItem.__stroke = hitBrush;
		this.__hitItem.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
		return this.__hitItem;
	}

	, 
	renderOverride: function (context, isHitContext) {
		$.ig.AnchoredCategorySeriesView.prototype.renderOverride.call(this, context, isHitContext);
		if (context.shouldRender()) {
			for (var i = 0; i < this.visibleColumns().count(); i++) {
				var column = this.getCurrentItem(i, isHitContext);
				this.setupItemAppearance(column, i, isHitContext);
				context.renderRectangle(column);
			}

		}

	}

	, 
	exportViewShapes: function (svd) {
		var $self = this;
		$.ig.AnchoredCategorySeriesView.prototype.exportViewShapes.call($self, svd);
		var i = 0;
		var toSort = new $.ig.List$1($.ig.Rectangle.prototype.$type, 0);
		var en = $self.columns().active().getEnumerator();
		while (en.moveNext()) {
			var column = en.current();
			toSort.add(column);
		}

		toSort.sort2(function (c1, c2) {
			if (c1.canvasTop() > c2.canvasTop()) {
				return -1;

			} else if (c1.canvasTop() < c2.canvasTop()) {
				return 1;

			} else {
				return 0;
			}


		});
		var en1 = toSort.getEnumerator();
		while (en1.moveNext()) {
			var column1 = en1.current();
			var rvd = new $.ig.RectangleVisualData(1, "column" + i, column1);
			rvd.tags().add("Main");
			rvd.tags().add("Fill");
			svd.shapes().add(rvd);
		}

		i++;
	}

	, 
	applyDropShadowDefaultSettings: function () {
		var color = new $.ig.Color();
		color.colorString("rgba(95,95,95,0.5)");
		this.model().shadowColor(color);
		this.model().shadowBlur(5);
		this.model().shadowOffsetX(5);
		this.model().shadowOffsetY(-5);
	}
	, 
	$type: new $.ig.Type('BarSeriesView', $.ig.AnchoredCategorySeriesView.prototype.$type)
}, true);

$.ig.util.defType('IBucketizer', 'Object', {
	$type: new $.ig.Type('IBucketizer', null)
}, true);

$.ig.util.defType('CategoryBucketCalculator', 'Object', {

	_view: null,
	view: function (value) {
		if (arguments.length === 1) {
			this._view = value;
			return value;
		} else {
			return this._view;
		}
	}
	, 
	init: function (view) {



		$.ig.Object.prototype.init.call(this);
			if (view == null) {
				throw new $.ig.ArgumentNullException(0, "view");
			}

			this.view(view);
			this._firstBucket = -1;
			this._lastBucket = this._lastBucket;
			this._bucketSize = 0;
	}
	, 
	_firstBucket: 0
	, 
	_lastBucket: 0
	, 
	_bucketSize: 0

	, 
	getBucket: function (bucket) {
		return null;
	}

	, 
	getErrorBucket: function (bucket, column) {
		return NaN;
	}

	, 
	calculateBuckets: function (resolution) {
		var windowRect = this.view().windowRect();
		var viewportRect = this.view().viewport();
		var xAxis = $.ig.util.cast($.ig.CategoryAxisBase.prototype.$type, this.view().categoryModel().getXAxis());
		var fastItemsSource = this.view().categoryModel().fastItemsSource();
		if (windowRect.isEmpty() || viewportRect.isEmpty() || xAxis == null || fastItemsSource == null || fastItemsSource.count() == 0) {
			this._bucketSize = 0;
			return;
		}

		var sortingXAxis = $.ig.util.cast($.ig.ISortingAxis.prototype.$type, xAxis);
		if (sortingXAxis == null || sortingXAxis.sortedIndices() == null) {
			var x0 = Math.floor(xAxis.getUnscaledValue2(viewportRect.left(), windowRect, viewportRect, $.ig.CategoryMode.prototype.mode0));
			var x1 = Math.ceil(xAxis.getUnscaledValue2(viewportRect.right(), windowRect, viewportRect, $.ig.CategoryMode.prototype.mode0));
			if (xAxis.isInverted()) {
				x1 = Math.ceil(xAxis.getUnscaledValue2(viewportRect.left(), windowRect, viewportRect, $.ig.CategoryMode.prototype.mode0));
				x0 = Math.floor(xAxis.getUnscaledValue2(viewportRect.right(), windowRect, viewportRect, $.ig.CategoryMode.prototype.mode0));
			}

			var c = Math.floor((x1 - x0 + 1) * resolution / viewportRect.width());
			this._bucketSize = $.ig.truncate(Math.max(1, c));
			this._firstBucket = $.ig.truncate(Math.max(0, Math.floor(x0 / this._bucketSize) - 1));
			this._lastBucket = $.ig.truncate(Math.ceil(x1 / this._bucketSize));

		} else {
			this._firstBucket = sortingXAxis.getFirstVisibleIndex(windowRect, viewportRect);
			this._lastBucket = sortingXAxis.getLastVisibleIndex(windowRect, viewportRect);
			this._bucketSize = 1;
		}

	}

	, 
	getBucketInfo: function (firstBucket, lastBucket, bucketSize, resolution) {
		firstBucket = this._firstBucket;
		lastBucket = this._lastBucket;
		bucketSize = this._bucketSize;
		resolution = this.view().categoryModel().resolution();
		return {
			p0: firstBucket, 
			p1: lastBucket, 
			p2: bucketSize, 
			p3: resolution
		};
	}

	, 
	cacheValues: function () {
	}

	, 
	unCacheValues: function () {
	}
	, 
	$type: new $.ig.Type('CategoryBucketCalculator', $.ig.Object.prototype.$type, [$.ig.IBucketizer.prototype.$type])
}, true);

$.ig.util.defType('AnchoredCategoryBucketCalculator', 'CategoryBucketCalculator', {
	init: function (view) {



		$.ig.CategoryBucketCalculator.prototype.init.call(this, view);
			this.anchoredView(view);
	}

	, 
	_anchoredView: null,
	anchoredView: function (value) {
		if (arguments.length === 1) {
			this._anchoredView = value;
			return value;
		} else {
			return this._anchoredView;
		}
	}

	, 
	getBucket: function (bucket) {
		var $self = this;
		var column = $self.__values;
		var count = column.length;
		var i0 = Math.min(bucket * $self._bucketSize, count - 1);
		var i1 = Math.min(i0 + $self._bucketSize - 1, count - 1);
		var min = NaN;
		var max = NaN;
		var first = true;
		for (var i = i0; i <= i1; ++i) {
			var y = column[i];
			if (!first) {
				if (!$.ig.util.isNaN(y)) {
					min = min < y ? min : y;
					max = max > y ? max : y;
				}


			} else {
				if (!$.ig.util.isNaN(y)) {
					min = y;
					max = y;
					first = false;
				}

			}

		}

		if (!first) {
			return (function () { var $ret = new Array();
			$ret.add((0.5 * (i0 + i1)));
			$ret.add(min);
			$ret.add(max);return $ret;}());
		}

		return (function () { var $ret = new Array();
		$ret.add((0.5 * (i0 + i1)));
		$ret.add(NaN);
		$ret.add(NaN);return $ret;}());
	}
	, 
	__values: null

	, 
	cacheValues: function () {
		this.__values = this.anchoredView().anchoredModel().valueColumn().asArray();
	}

	, 
	unCacheValues: function () {
		this.__values = null;
	}
	, 
	$type: new $.ig.Type('AnchoredCategoryBucketCalculator', $.ig.CategoryBucketCalculator.prototype.$type)
}, true);

$.ig.util.defType('BarBucketCalculator', 'CategoryBucketCalculator', {
	init: function (view) {



		$.ig.CategoryBucketCalculator.prototype.init.call(this, view);
			this.barView(view);
	}

	, 
	_barView: null,
	barView: function (value) {
		if (arguments.length === 1) {
			this._barView = value;
			return value;
		} else {
			return this._barView;
		}
	}

	, 
	calculateBuckets: function (resolution) {
		var windowRect = this.view().windowRect();
		var viewportRect = this.view().viewport();
		var fastItemsSource = this.view().categoryModel().fastItemsSource();
		if (windowRect.isEmpty() || viewportRect.isEmpty() || this.barView().barModel().yAxis() == null || fastItemsSource == null || fastItemsSource.count() == 0) {
			this._bucketSize = 0;
			return;
		}

		var barSeries = $.ig.util.cast($.ig.BarSeries.prototype.$type, this.view().categoryModel());
		var y0 = Math.floor(barSeries.yAxis().getUnscaledValue2(viewportRect.top(), windowRect, viewportRect, $.ig.CategoryMode.prototype.mode0));
		var y1 = Math.ceil(barSeries.yAxis().getUnscaledValue2(viewportRect.bottom(), windowRect, viewportRect, $.ig.CategoryMode.prototype.mode0));
		if (!barSeries.yAxis().isInverted()) {
			y1 = Math.ceil(barSeries.yAxis().getUnscaledValue2(viewportRect.top(), windowRect, viewportRect, $.ig.CategoryMode.prototype.mode0));
			y0 = Math.floor(barSeries.yAxis().getUnscaledValue2(viewportRect.bottom(), windowRect, viewportRect, $.ig.CategoryMode.prototype.mode0));
		}

		var c = Math.floor((y1 - y0 + 1) * resolution / viewportRect.height());
		this._bucketSize = $.ig.truncate(Math.max(1, c));
		this._firstBucket = $.ig.truncate(Math.max(0, Math.floor(y0 / this._bucketSize) - 1));
		this._lastBucket = $.ig.truncate(Math.ceil(y1 / this._bucketSize));
	}

	, 
	getBucket: function (bucket) {
		var $self = this;
		var column = $self.__values;
		var count = column.length;
		var i0 = Math.min(bucket * $self._bucketSize, count - 1);
		var i1 = Math.min(i0 + $self._bucketSize - 1, count - 1);
		var min = NaN;
		var max = NaN;
		for (var i = i0; i <= i1; ++i) {
			var y = column[i];
			if (!$.ig.util.isNaN(min)) {
				if (!$.ig.util.isNaN(y)) {
					min = Math.min(min, y);
					max = Math.max(max, y);
				}


			} else {
				min = y;
				max = y;
			}

		}

		if (!$.ig.util.isNaN(min)) {
			return (function () { var $ret = new Array();
			$ret.add((0.5 * (i0 + i1)));
			$ret.add(min);
			$ret.add(max);return $ret;}());
		}

		return (function () { var $ret = new Array();
		$ret.add((0.5 * (i0 + i1)));
		$ret.add(NaN);
		$ret.add(NaN);return $ret;}());
	}
	, 
	__values: null

	, 
	cacheValues: function () {
		this.__values = this.barView().barModel().valueColumn().asArray();
	}

	, 
	unCacheValues: function () {
		this.__values = null;
	}
	, 
	$type: new $.ig.Type('BarBucketCalculator', $.ig.CategoryBucketCalculator.prototype.$type)
}, true);


$.ig.util.defType('HorizontalAnchoredCategorySeries', 'AnchoredCategorySeries', {
	init: function () {


		$.ig.AnchoredCategorySeries.prototype.init.call(this);

	}
	, 
	xAxis: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.HorizontalAnchoredCategorySeries.prototype.xAxisProperty, value);
			return value;
		} else {

			return this.getValue($.ig.HorizontalAnchoredCategorySeries.prototype.xAxisProperty);
		}
	}

	, 
	yAxis: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.HorizontalAnchoredCategorySeries.prototype.yAxisProperty, value);
			return value;
		} else {

			return this.getValue($.ig.HorizontalAnchoredCategorySeries.prototype.yAxisProperty);
		}
	}

	, 
	getOffsetValue: function () {
		return this.framePreparer().getOffset(this.cachedXAxis(), this.view().windowRect(), this.view().viewport());
	}

	, 
	getCategoryWidth: function () {
		return this.cachedXAxis().getCategorySize(this.view().windowRect(), this.view().viewport());
	}

	, 
	getSeriesValue: function (world, useInterpolation, skipUnknowns) {
		if (this.seriesViewer() == null) {
			return NaN;
		}

		var xParams = new $.ig.ScalerParams(this.seriesViewer().actualWindowRect(), this.view().viewport(), this.cachedXAxis().isInverted());
		var offset = this.framePreparer().getOffset(this.cachedXAxis(), this.seriesViewer().actualWindowRect(), this.view().viewport());
		return this.getSeriesValueHelper(this.valueColumn(), world, this.cachedXAxis(), xParams, offset, this.getExactUnsortedItemIndex.runOn(this), useInterpolation, skipUnknowns);
	}

	, 
	getPreviousOrExactIndex: function (world, skipUnknowns) {
		return this.getPreviousOrExactIndexHelper(world, skipUnknowns, this.cachedXAxis(), this.getExactUnsortedItemIndex.runOn(this), this.valueColumn());
	}

	, 
	getNextOrExactIndex: function (world, skipUnknowns) {
		return this.getNextOrExactIndexHelper(world, skipUnknowns, this.cachedXAxis(), this.getExactUnsortedItemIndex.runOn(this), this.valueColumn());
	}

	, 
	getDistanceToIndex: function (world, index, axis, p, offset) {
		if (this.valueColumn() == null) {
			return Number.POSITIVE_INFINITY;
		}

		return this.getDistanceToIndexHelper(world, index, this.cachedXAxis(), p, offset, this.valueColumn().count(), this.getExactUnsortedItemIndex.runOn(this));
	}

	, 
	getSeriesValuePosition: function (world, useInterpolation, skipUnknowns) {
		return this.getSeriesValuePositionHelper(world, useInterpolation, skipUnknowns, this.framePreparer().getOffset(this.cachedXAxis(), this.view().windowRect(), this.view().viewport()), this.cachedYAxis(), this.cachedXAxis(), null, null, null);
	}

	, 
	getXAxis: function () {
		return this.cachedXAxis();
	}

	, 
	getYAxis: function () {
		return this.cachedYAxis();
	}

	, 
	setXAxis: function (xAxis) {
		this.xAxis($.ig.util.cast($.ig.CategoryAxisBase.prototype.$type, xAxis));
	}

	, 
	setYAxis: function (yAxis) {
		this.yAxis($.ig.util.cast($.ig.NumericYAxis.prototype.$type, yAxis));
	}

	, 
	updateNumericAxisRange: function () {
		return this.cachedYAxis() != null && this.cachedYAxis().updateRange();
	}

	, 
	_cachedXAxis: null,
	cachedXAxis: function (value) {
		if (arguments.length === 1) {
			this._cachedXAxis = value;
			return value;
		} else {
			return this._cachedXAxis;
		}
	}

	, 
	_cachedYAxis: null,
	cachedYAxis: function (value) {
		if (arguments.length === 1) {
			this._cachedYAxis = value;
			return value;
		} else {
			return this._cachedYAxis;
		}
	}

	, 
	cacheXAxis: function (xAxis) {
		this.cachedXAxis(xAxis);
	}

	, 
	cacheYAxis: function (yAxis) {
		this.cachedYAxis(yAxis);
	}

	, 
	getCategoryItems: function (orderedStartIndex, orderedEndIndex) {
		return this.getCategoryItemsHelper(orderedStartIndex, orderedEndIndex, this.cachedXAxis());
	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		switch (propertyName) {
			case $.ig.HorizontalAnchoredCategorySeries.prototype.xAxisPropertyName:
				this.cacheXAxis(this.xAxis());
				this.anchoredView().trendLineManager($.ig.CategoryTrendLineManagerBase.prototype.selectManager(this.anchoredView().trendLineManager(), this.cachedXAxis(), this.rootCanvas(), this));
				break;
		}

		$.ig.AnchoredCategorySeries.prototype.propertyUpdatedOverride.call(this, sender, propertyName, oldValue, newValue);
		switch (propertyName) {
			case $.ig.HorizontalAnchoredCategorySeries.prototype.xAxisPropertyName:
				if (oldValue != newValue) {
					this.deregisterForAxis($.ig.util.cast($.ig.Axis.prototype.$type, oldValue));
					this.registerForAxis($.ig.util.cast($.ig.Axis.prototype.$type, newValue));
					this.cacheXAxis(this.xAxis());
					this.categoryView().bucketCalculator().calculateBuckets(this.resolution());
					this.renderSeries(false);
					this.notifyThumbnailAppearanceChanged();
				}

				break;
			case $.ig.HorizontalAnchoredCategorySeries.prototype.yAxisPropertyName:
				if (oldValue != newValue) {
					this.deregisterForAxis($.ig.util.cast($.ig.Axis.prototype.$type, oldValue));
					this.registerForAxis($.ig.util.cast($.ig.Axis.prototype.$type, newValue));
					this.cacheYAxis(this.yAxis());
					this.categoryView().bucketCalculator().calculateBuckets(this.resolution());
					this.updateNumericAxisRange();
					this.renderSeries(false);
					this.notifyThumbnailAppearanceChanged();
				}

				break;
		}

	}

	, 
	dataUpdatedOverride: function (action, position, count, propertyName) {
		$.ig.AnchoredCategorySeries.prototype.dataUpdatedOverride.call(this, action, position, count, propertyName);
		if (this.cachedXAxis() != null && $.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.cachedXAxis()) !== null) {
			($.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.cachedXAxis())).notifyDataChanged();
		}

		switch (action) {
			case $.ig.FastItemsSourceEventAction.prototype.reset:
				if (this.cachedXAxis() != null) {
					this.cachedXAxis().updateRange();
				}

				if (this.cachedYAxis() != null && !this.cachedYAxis().updateRange()) {
					this.renderSeries(true);
				}

				break;
			case $.ig.FastItemsSourceEventAction.prototype.insert:
				if (this.cachedXAxis() != null) {
					this.cachedXAxis().updateRange();
				}

				if (this.cachedYAxis() != null && !this.cachedYAxis().updateRange()) {
					this.renderSeries(true);
				}

				break;
			case $.ig.FastItemsSourceEventAction.prototype.remove:
				if (this.cachedXAxis() != null) {
					this.cachedXAxis().updateRange();
				}

				if (this.cachedYAxis() != null && !this.cachedYAxis().updateRange()) {
					this.renderSeries(true);
				}

				break;
			case $.ig.FastItemsSourceEventAction.prototype.replace:
				if (this.cachedValueMemberPath() != null && this.anchoredView().bucketCalculator()._bucketSize > 0 && this.cachedYAxis() != null && !this.cachedYAxis().updateRange()) {
					this.renderSeries(true);
				}

				break;
			case $.ig.FastItemsSourceEventAction.prototype.change:
				if (propertyName == this.cachedValueMemberPath()) {
					if (this.cachedXAxis() != null) {
						this.cachedXAxis().updateRange();
					}

					if (this.cachedYAxis() != null && !this.cachedYAxis().updateRange()) {
						this.renderSeries(true);
					}

				}

				break;
		}

	}
	, 
	$type: new $.ig.Type('HorizontalAnchoredCategorySeries', $.ig.AnchoredCategorySeries.prototype.$type)
}, true);

$.ig.util.defType('PointSeries', 'HorizontalAnchoredCategorySeries', {

	createView: function () {
		return new $.ig.PointSeriesView(this);
	}

	, 
	_pointView: null,
	pointView: function (value) {
		if (arguments.length === 1) {
			this._pointView = value;
			return value;
		} else {
			return this._pointView;
		}
	}

	, 
	onViewCreated: function (view) {
		$.ig.HorizontalAnchoredCategorySeries.prototype.onViewCreated.call(this, view);
		this.pointView(view);
	}
	, 
	init: function () {



		$.ig.HorizontalAnchoredCategorySeries.prototype.init.call(this);
			this.defaultStyleKey($.ig.PointSeries.prototype.$type);
	}

	, 
	renderFrame: function (frame, view) {
		$.ig.HorizontalAnchoredCategorySeries.prototype.renderFrame.call(this, frame, view);
	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		$.ig.HorizontalAnchoredCategorySeries.prototype.propertyUpdatedOverride.call(this, sender, propertyName, oldValue, newValue);
	}
	, 
	$type: new $.ig.Type('PointSeries', $.ig.HorizontalAnchoredCategorySeries.prototype.$type)
}, true);

$.ig.util.defType('PointSeriesView', 'AnchoredCategorySeriesView', {

	_pointModel: null,
	pointModel: function (value) {
		if (arguments.length === 1) {
			this._pointModel = value;
			return value;
		} else {
			return this._pointModel;
		}
	}
	, 
	init: function (model) {



		$.ig.AnchoredCategorySeriesView.prototype.init.call(this, model);
			this.pointModel(model);
	}

	, 
	onInit: function () {
		var $self = this;
		$.ig.AnchoredCategorySeriesView.prototype.onInit.call($self);
		if (!$self.isThumbnailView()) {
			$self.markerModel().markerType($.ig.MarkerType.prototype.automatic);
			$self.model().legendItemBadgeTemplate((function () { var $ret = new $.ig.DataTemplate();
			$ret.render($.ig.LegendTemplates.prototype.pointBadgeTemplate);
			$ret.measure($.ig.LegendTemplates.prototype.legendItemBadgeMeasure); return $ret;}()));
		}

	}

	, 
	applyDropShadowDefaultSettings: function () {
		var color = new $.ig.Color();
		color.colorString("rgba(95,95,95,0.5)");
		this.model().shadowColor(color);
		this.model().shadowBlur(3);
		this.model().shadowOffsetX(2);
		this.model().shadowOffsetY(2);
		this.model().useSingleShadow(false);
	}
	, 
	$type: new $.ig.Type('PointSeriesView', $.ig.AnchoredCategorySeriesView.prototype.$type)
}, true);








$.ig.util.defType('ValuesHolder', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	count: function () {
	}

	, 
	_bucketY0: 0,
	bucketY0: function (value) {
		if (arguments.length === 1) {
			this._bucketY0 = value;
			return value;
		} else {
			return this._bucketY0;
		}
	}

	, 
	_bucketY1: 0,
	bucketY1: function (value) {
		if (arguments.length === 1) {
			this._bucketY1 = value;
			return value;
		} else {
			return this._bucketY1;
		}
	}

	, 
	_tempY0: 0,
	tempY0: function (value) {
		if (arguments.length === 1) {
			this._tempY0 = value;
			return value;
		} else {
			return this._tempY0;
		}
	}

	, 
	_tempY1: 0,
	tempY1: function (value) {
		if (arguments.length === 1) {
			this._tempY1 = value;
			return value;
		} else {
			return this._tempY1;
		}
	}
	, 
	$type: new $.ig.Type('ValuesHolder', $.ig.Object.prototype.$type)
}, true);






$.ig.util.defType('SplineSeriesBaseView', 'AnchoredCategorySeriesView', {

	_splineBaseModel: null,
	splineBaseModel: function (value) {
		if (arguments.length === 1) {
			this._splineBaseModel = value;
			return value;
		} else {
			return this._splineBaseModel;
		}
	}
	, 
	init: function (model) {



		$.ig.AnchoredCategorySeriesView.prototype.init.call(this, model);
			this.splineBaseModel(model);
	}

	, 
	applyDropShadowDefaultSettings: function () {
		var color = new $.ig.Color();
		color.colorString("rgba(95,95,95,0.5)");
		this.model().shadowColor(color);
		this.model().shadowBlur(3);
		this.model().shadowOffsetX(1);
		this.model().shadowOffsetY(4);
		this.model().useSingleShadow(false);
	}
	, 
	$type: new $.ig.Type('SplineSeriesBaseView', $.ig.AnchoredCategorySeriesView.prototype.$type)
}, true);

$.ig.util.defType('SplineAreaSeriesView', 'SplineSeriesBaseView', {

	_splineAreaModel: null,
	splineAreaModel: function (value) {
		if (arguments.length === 1) {
			this._splineAreaModel = value;
			return value;
		} else {
			return this._splineAreaModel;
		}
	}
	, 
	init: function (model) {


		this._polygon0 = new $.ig.Path();
		this._polyline0 = new $.ig.Path();
		this._polygon1 = new $.ig.Path();
		this._polyline1 = new $.ig.Path();
		this.__hitPolygon0 = new $.ig.Path();
		this.__hitPolyline0 = new $.ig.Path();
		this.__hitPolygon1 = new $.ig.Path();
		this.__hitPolyline1 = new $.ig.Path();

		$.ig.SplineSeriesBaseView.prototype.init.call(this, model);
			this.splineAreaModel(model);
	}

	, 
	onInit: function () {
		var $self = this;
		$.ig.SplineSeriesBaseView.prototype.onInit.call($self);
		if (!$self.isThumbnailView()) {
			$self.model().legendItemBadgeTemplate((function () { var $ret = new $.ig.DataTemplate();
			$ret.render($.ig.LegendTemplates.prototype.rectBadgeTemplate);
			$ret.measure($.ig.LegendTemplates.prototype.legendItemBadgeMeasure); return $ret;}()));
		}

	}
	, 
	_polygon0: null
	, 
	_polyline0: null
	, 
	_polygon1: null
	, 
	_polyline1: null

	, 
	line0: function () {

			return this._polyline0;
	}

	, 
	line1: function () {

			return this._polyline1;
	}

	, 
	polygon0: function () {

			return this._polygon0;
	}

	, 
	polygon1: function () {

			return this._polygon1;
	}

	, 
	clearSplineArea: function () {
		this._polygon0.data(null);
		this._polygon1.data(null);
		this._polyline0.data(null);
		this._polyline1.data(null);
		this.makeDirty();
	}

	, 
	rasterizeSplineArea: function (count, buckets, useX0AsX1, bucketSize, resolution, terminatePolygon, unknownValuePlotting) {
		this.anchoredModel().lineRasterizer().isSortingAxis($.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.categoryModel().getXAxis()) !== null ? true : false);
		this.anchoredModel().lineRasterizer().rasterizePolygonPaths(this._polygon0, this._polyline0, this._polygon1, this._polyline1, count, buckets, useX0AsX1, bucketSize, resolution, terminatePolygon, unknownValuePlotting);
		this.makeDirty();
	}
	, 
	__hitPolygon0: null
	, 
	__hitPolyline0: null
	, 
	__hitPolygon1: null
	, 
	__hitPolyline1: null

	, 
	setupHitAppearanceOverride: function () {
		$.ig.SplineSeriesBaseView.prototype.setupHitAppearanceOverride.call(this);
		this.__hitPolygon0.data(this._polygon0.data());
		this.__hitPolyline0.data(this._polyline0.data());
		this.__hitPolygon1.data(this._polygon1.data());
		this.__hitPolyline1.data(this._polyline1.data());
		var hitBrush = this.getHitBrush();
		this.__hitPolygon0.__fill = hitBrush;
		this.__hitPolygon0.__opacity = 1;
		this.__hitPolygon1.__fill = hitBrush;
		this.__hitPolygon1.__opacity = 1;
		this.__hitPolyline0.__stroke = hitBrush;
		this.__hitPolyline0.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
		this.__hitPolyline1.__stroke = hitBrush;
		this.__hitPolyline1.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
	}

	, 
	renderOverride: function (context, isHitContext) {
		$.ig.SplineSeriesBaseView.prototype.renderOverride.call(this, context, isHitContext);
		if (isHitContext) {
			context.renderPath(this.__hitPolygon0);
			context.renderPath(this.__hitPolygon1);
			context.renderPath(this.__hitPolyline0);
			context.renderPath(this.__hitPolyline1);

		} else {
			context.renderPath(this._polygon0);
			context.renderPath(this._polygon1);
			context.renderPath(this._polyline0);
			context.renderPath(this._polyline1);
		}

	}

	, 
	exportViewShapes: function (svd) {
		$.ig.SplineSeriesBaseView.prototype.exportViewShapes.call(this, svd);
		var lowerShape = new $.ig.PathVisualData(1, "lowerShape", this._polyline0);
		lowerShape.tags().add("Lower");
		var upperShape = new $.ig.PathVisualData(1, "upperShape", this._polyline1);
		upperShape.tags().add("Upper");
		upperShape.tags().add("Main");
		var translucent = new $.ig.PathVisualData(1, "translucentShape", this._polygon0);
		translucent.tags().add("Translucent");
		var fill = new $.ig.PathVisualData(1, "fillShape", this._polygon1);
		fill.tags().add("Fill");
		svd.shapes().add(lowerShape);
		svd.shapes().add(upperShape);
		svd.shapes().add(translucent);
		svd.shapes().add(fill);
	}

	, 
	applyDropShadowDefaultSettings: function () {
		var color = new $.ig.Color();
		color.colorString("rgba(95,95,95,0.5)");
		this.model().shadowColor(color);
		this.model().shadowBlur(5);
		this.model().shadowOffsetX(1);
		this.model().shadowOffsetY(-3);
	}
	, 
	$type: new $.ig.Type('SplineAreaSeriesView', $.ig.SplineSeriesBaseView.prototype.$type)
}, true);



$.ig.util.defType('AreaSeries', 'HorizontalAnchoredCategorySeries', {

	createView: function () {
		return new $.ig.AreaSeriesView(this);
	}

	, 
	getDefaultTransitionInMode: function () {
		return $.ig.CategoryTransitionInMode.prototype.fromZero;
	}

	, 
	onViewCreated: function (view) {
		$.ig.HorizontalAnchoredCategorySeries.prototype.onViewCreated.call(this, view);
		this.areaView(view);
	}

	, 
	_areaView: null,
	areaView: function (value) {
		if (arguments.length === 1) {
			this._areaView = value;
			return value;
		} else {
			return this._areaView;
		}
	}
	, 
	init: function () {



		$.ig.HorizontalAnchoredCategorySeries.prototype.init.call(this);
			this.defaultStyleKey($.ig.AreaSeries.prototype.$type);
	}

	, 
	preferredCategoryMode: function (axis) {
		return $.ig.CategoryMode.prototype.mode0;
	}

	, 
	clearRendering: function (wipeClean, view) {
		$.ig.HorizontalAnchoredCategorySeries.prototype.clearRendering.call(this, wipeClean, view);
		var areaView = view;
		areaView.clearAreaLines();
	}

	, 
	renderFrame: function (frame, view) {
		var $self = this;
		$.ig.HorizontalAnchoredCategorySeries.prototype.renderFrame.call($self, frame, view);
		var bucketSize = view.bucketCalculator()._bucketSize;
		var areaView = $.ig.util.cast($.ig.AreaSeriesView.prototype.$type, view);
		var buckets = frame._buckets;
		$self._renderManager.initCategoryRenderSettings($self, $self.shouldOverrideCategoryStyle(), $self.cachedXAxis(), $self.getCategoryItems.runOn($self), $self.getBucketSize(view), $self.getFirstBucket(view));
		var areStylesOverriden = false;
		var args = $self._renderManager.categoryOverrideArgs();
		if (args != null) {
			areStylesOverriden = true;
		}

		if (areStylesOverriden) {
			var xParams = new $.ig.ScalerParams(view.windowRect(), view.viewport(), $self.cachedXAxis().isInverted());
			$self.performCategoryStyleOverride(buckets, -1, $self.valueColumn().count(), $self.cachedXAxis(), xParams, view.isThumbnailView());
		}

		var line0 = areaView.line0();
		var line1 = areaView.line1();
		var polygon0 = areaView.polygon0();
		var polygon1 = areaView.polygon1();
		$self._renderManager.setCategoryShapeAppearance(line0, true, false, true, true);
		$self._renderManager.setCategoryShapeAppearance(line1, true, false, true, true);
		$self._renderManager.setCategoryShapeAppearance(polygon0, false, true, false, false);
		$self._renderManager.setCategoryShapeAppearance(polygon1, false, true, false, false);
		if (view.checkFrameDirty(frame)) {
			areaView.rasterizeArea(buckets.count(), buckets, true, bucketSize, $self.resolution(), function (p0, l0, p01, l1, f) { $self.terminatePolygon(p0, frame._buckets.count(), view); }, $self.unknownValuePlotting());
			view.updateFrameVersion(frame);
		}

		var yAxis = $self.getYAxis();
		polygon0.__opacity = $self._renderManager._actualRenderOpacity * $self.actualAreaFillOpacity();
		polygon1.__opacity = 0.5 * $self._renderManager._actualRenderOpacity * $self.actualAreaFillOpacity();
	}

	, 
	unknownValuePlotting: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.AreaSeries.prototype.unknownValuePlottingProperty, $.ig.UnknownValuePlotting.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.AreaSeries.prototype.unknownValuePlottingProperty));
		}
	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		$.ig.HorizontalAnchoredCategorySeries.prototype.propertyUpdatedOverride.call(this, sender, propertyName, oldValue, newValue);
		switch (propertyName) {
			case $.ig.AreaSeries.prototype._unknownValuePlottingPropertyName:
				this.framePreparer().skipUnknowns(this.unknownValuePlotting() == $.ig.UnknownValuePlotting.prototype.linearInterpolate);
				this.renderSeries(false);
				this.notifyThumbnailAppearanceChanged();
				break;
		}

	}
	, 
	$type: new $.ig.Type('AreaSeries', $.ig.HorizontalAnchoredCategorySeries.prototype.$type)
}, true);

$.ig.util.defType('AreaSeriesView', 'AnchoredCategorySeriesView', {

	_areaModel: null,
	areaModel: function (value) {
		if (arguments.length === 1) {
			this._areaModel = value;
			return value;
		} else {
			return this._areaModel;
		}
	}
	, 
	init: function (model) {


		this._polygon0 = new $.ig.Path();
		this._polyline0 = new $.ig.Path();
		this._polygon1 = new $.ig.Path();
		this._polyline1 = new $.ig.Path();
		this.__hitPolygon0 = new $.ig.Path();
		this.__hitPolyline0 = new $.ig.Path();
		this.__hitPolygon1 = new $.ig.Path();
		this.__hitPolyline1 = new $.ig.Path();

		$.ig.AnchoredCategorySeriesView.prototype.init.call(this, model);
			this.areaModel(model);
	}

	, 
	onInit: function () {
		var $self = this;
		$.ig.AnchoredCategorySeriesView.prototype.onInit.call($self);
		if (!$self.isThumbnailView()) {
			$self.model().legendItemBadgeTemplate((function () { var $ret = new $.ig.DataTemplate();
			$ret.render($.ig.LegendTemplates.prototype.rectBadgeTemplate);
			$ret.measure($.ig.LegendTemplates.prototype.legendItemBadgeMeasure); return $ret;}()));
		}

	}

	, 
	line0: function () {

			return this._polyline0;
	}

	, 
	line1: function () {

			return this._polyline1;
	}

	, 
	polygon0: function () {

			return this._polygon0;
	}

	, 
	polygon1: function () {

			return this._polygon1;
	}
	, 
	_polygon0: null
	, 
	_polyline0: null
	, 
	_polygon1: null
	, 
	_polyline1: null

	, 
	clearAreaLines: function () {
		this._polygon0.data(null);
		this._polygon1.data(null);
		this._polyline0.data(null);
		this._polyline1.data(null);
		this.makeDirty();
	}

	, 
	rasterizeArea: function (count, buckets, useX0AsX1, bucketSize, resolution, terminatePolygon, unknownValuePlotting) {
		this.anchoredModel().lineRasterizer().isSortingAxis($.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.categoryModel().getXAxis()) !== null ? true : false);
		this.anchoredModel().lineRasterizer().rasterizePolygonPaths(this._polygon0, this._polyline0, this._polygon1, this._polyline1, count, buckets, useX0AsX1, bucketSize, resolution, terminatePolygon, unknownValuePlotting);
		this.makeDirty();
	}
	, 
	__hitPolygon0: null
	, 
	__hitPolyline0: null
	, 
	__hitPolygon1: null
	, 
	__hitPolyline1: null

	, 
	setupHitAppearanceOverride: function () {
		$.ig.AnchoredCategorySeriesView.prototype.setupHitAppearanceOverride.call(this);
		this.__hitPolygon0.data(this._polygon0.data());
		this.__hitPolyline0.data(this._polyline0.data());
		this.__hitPolygon1.data(this._polygon1.data());
		this.__hitPolyline1.data(this._polyline1.data());
		var hitBrush = this.getHitBrush();
		this.__hitPolygon0.__fill = hitBrush;
		this.__hitPolygon0.__opacity = 1;
		this.__hitPolygon1.__fill = hitBrush;
		this.__hitPolygon1.__opacity = 1;
		this.__hitPolyline0.__stroke = hitBrush;
		this.__hitPolyline0.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
		this.__hitPolyline1.__stroke = hitBrush;
		this.__hitPolyline1.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
	}

	, 
	renderOverride: function (context, isHitContext) {
		$.ig.AnchoredCategorySeriesView.prototype.renderOverride.call(this, context, isHitContext);
		if (isHitContext) {
			context.renderPath(this.__hitPolygon0);
			context.renderPath(this.__hitPolygon1);
			context.renderPath(this.__hitPolyline0);
			context.renderPath(this.__hitPolyline1);

		} else {
			context.renderPath(this._polygon0);
			context.renderPath(this._polygon1);
			context.renderPath(this._polyline0);
			context.renderPath(this._polyline1);
		}

	}

	, 
	exportViewShapes: function (svd) {
		$.ig.AnchoredCategorySeriesView.prototype.exportViewShapes.call(this, svd);
		var lowerShape = new $.ig.PathVisualData(1, "lowerShape", this._polyline0);
		lowerShape.tags().add("Lower");
		var upperShape = new $.ig.PathVisualData(1, "upperShape", this._polyline1);
		upperShape.tags().add("Upper");
		upperShape.tags().add("Main");
		var translucent = new $.ig.PathVisualData(1, "translucentShape", this._polygon0);
		translucent.tags().add("Translucent");
		var fill = new $.ig.PathVisualData(1, "fillShape", this._polygon1);
		fill.tags().add("Fill");
		svd.shapes().add(lowerShape);
		svd.shapes().add(upperShape);
		svd.shapes().add(translucent);
		svd.shapes().add(fill);
	}

	, 
	applyDropShadowDefaultSettings: function () {
		var color = new $.ig.Color();
		color.colorString("rgba(95,95,95,0.5)");
		this.model().shadowColor(color);
		this.model().shadowBlur(5);
		this.model().shadowOffsetX(1);
		this.model().shadowOffsetY(-3);
	}
	, 
	$type: new $.ig.Type('AreaSeriesView', $.ig.AnchoredCategorySeriesView.prototype.$type)
}, true);

$.ig.util.defType('CategoryFrame', 'Frame', {
	init: function (count) {


		this._buckets = new $.ig.List$1($.ig.Array.prototype.$type, 0);
		this._errorBuckets = new $.ig.List$1($.ig.Number.prototype.$type, 0);
		this._errorSpeedModifiers = new $.ig.List$1(Number, 0);
		this._markers = new $.ig.List$1($.ig.Point.prototype.$type, 0);
		this._markerSpeedModifiers = new $.ig.List$1(Number, 0);
		this._trend = new $.ig.List$1($.ig.Point.prototype.$type, 0);
		this._trendSpeedModifiers = new $.ig.List$1(Number, 0);
		this._errorBars = new $.ig.List$1($.ig.Point.prototype.$type, 0);
		this._errorBarsSpeedModifiers = new $.ig.List$1(Number, 0);
		this._errorBarSizes = new $.ig.List$1(Number, 0);
		this._speedModifiers = new $.ig.List$1(Number, 0);

		$.ig.Frame.prototype.init.call(this);
			this.__fullClip = new $.ig.Rect(0, 0, 0, 1, 1);
			this._cnt = count;
			this.incrementFrameVersion();
	}
	, 
	__fullClip: null
	, 
	_buckets: null
	, 
	_errorBuckets: null
	, 
	_errorSpeedModifiers: null
	, 
	_markers: null
	, 
	_markerSpeedModifiers: null
	, 
	_trend: null
	, 
	_trendSpeedModifiers: null
	, 
	_errorBars: null
	, 
	_errorBarsSpeedModifiers: null
	, 
	_errorBarSizes: null
	, 
	_speedModifiers: null

	, 
	_frameVersion: 0,
	frameVersion: function (value) {
		if (arguments.length === 1) {
			this._frameVersion = value;
			return value;
		} else {
			return this._frameVersion;
		}
	}
	, 
	_cnt: 0

	, 
	interpolate3: function (p, _min, _max) {
		this.incrementFrameVersion();
		var min = $.ig.util.cast($.ig.CategoryFrame.prototype.$type, _min);
		var max = $.ig.util.cast($.ig.CategoryFrame.prototype.$type, _max);
		var minCount = min._buckets.count();
		var maxCount = max._buckets.count();
		var count = Math.max(minCount, maxCount);
		var markerCount = Math.max(min._markers.count(), max._markers.count());
		var trendCount = Math.max(min._trend.count(), max._trend.count());
		var errorCount = Math.max(min._errorBuckets.count(), max._errorBuckets.count());
		var errorBarsCount = Math.max(min._errorBars.count(), max._errorBars.count());
		var speedModified = min._speedModifiers.count() > 0;
		if (speedModified) {
			this.reconcileSpeedModifiers(this._speedModifiers, p, min._speedModifiers, max._speedModifiers, count);
		}

		var markerSpeedModified = min._markerSpeedModifiers.count() > 0;
		if (markerSpeedModified) {
			this.reconcileSpeedModifiers(this._markerSpeedModifiers, p, min._markerSpeedModifiers, max._markerSpeedModifiers, markerCount);
		}

		var trendSpeedModified = min._trendSpeedModifiers.count() > 0;
		if (trendSpeedModified) {
			this.reconcileSpeedModifiers(this._trendSpeedModifiers, p, min._trendSpeedModifiers, max._trendSpeedModifiers, trendCount);
		}

		var errorSpeedModified = min._errorSpeedModifiers.count() > 0;
		if (errorSpeedModified) {
			this.reconcileSpeedModifiers(this._errorSpeedModifiers, p, min._errorSpeedModifiers, max._errorSpeedModifiers, errorCount);
		}

		var errorBarsSpeedModified = min._errorBarsSpeedModifiers.count() > 0;
		if (errorBarsSpeedModified) {
			this.reconcileSpeedModifiers(this._errorBarsSpeedModifiers, p, min._errorBarsSpeedModifiers, max._errorBarsSpeedModifiers, errorBarsCount);
		}

		if (this._buckets.count() < count) {
			while (this._buckets.count() < count) {
				this._buckets.add(new Array(this._cnt));

			}
		}

		if (this._buckets.count() > count) {
			this._buckets.removeRange(count, this._buckets.count() - count);
		}

		if (speedModified) {
			var speed = 0;
			for (var i = 0; i < Math.min(minCount, maxCount); ++i) {
				var bucket = this._buckets.__inner[i];
				speed = p * this._speedModifiers.__inner[i];
				speed = speed > 1 ? 1 : speed;
				for (var j = 0; j < this._cnt; ++j) {
					bucket[j] = min._buckets.__inner[i][j] + speed * (max._buckets.__inner[i][j] - min._buckets.__inner[i][j]);
				}

			}


		} else {
			for (var i1 = 0; i1 < Math.min(minCount, maxCount); ++i1) {
				var bucket1 = this._buckets.__inner[i1];
				for (var j1 = 0; j1 < this._cnt; ++j1) {
					bucket1[j1] = min._buckets.__inner[i1][j1] + p * (max._buckets.__inner[i1][j1] - min._buckets.__inner[i1][j1]);
				}

			}

		}

		if (minCount < maxCount) {
			var b = new Array(this._cnt);
			for (var j2 = this._cnt - 1; j2 >= 0; --j2) {
				b[j2] = min._buckets.count() > 0 ? min._buckets.__inner[min._buckets.count() - 1][j2] : 0;
			}

			if (speedModified) {
				var speed1 = 0;
				for (var i2 = minCount; i2 < maxCount; ++i2) {
					var bucket2 = this._buckets.__inner[i2];
					speed1 = p * this._speedModifiers.__inner[i2];
					speed1 = speed1 > 1 ? 1 : speed1;
					for (var j3 = this._cnt - 1; j3 >= 0; --j3) {
						bucket2[j3] = b[j3] + speed1 * (max._buckets.__inner[i2][j3] - b[j3]);
					}

				}


			} else {
				for (var i3 = minCount; i3 < maxCount; ++i3) {
					var bucket3 = this._buckets.__inner[i3];
					for (var j4 = this._cnt - 1; j4 >= 0; --j4) {
						bucket3[j4] = b[j4] + p * (max._buckets.__inner[i3][j4] - b[j4]);
					}

				}

			}

		}

		if (minCount > maxCount) {
			var e = new Array(this._cnt);
			for (var j5 = this._cnt - 1; j5 >= 0; --j5) {
				e[j5] = max._buckets.count() > 0 ? max._buckets.__inner[max._buckets.count() - 1][j5] : 0;
			}

			if (speedModified) {
				var speed2 = 0;
				for (var i4 = maxCount; i4 < minCount; ++i4) {
					var bucket4 = this._buckets.__inner[i4];
					speed2 = p * this._speedModifiers.__inner[i4];
					speed2 = speed2 > 1 ? 1 : speed2;
					for (var j6 = this._cnt - 1; j6 >= 0; --j6) {
						bucket4[j6] = min._buckets.__inner[i4][j6] + speed2 * (e[j6] - min._buckets.__inner[i4][j6]);
					}

				}


			} else {
				for (var i5 = maxCount; i5 < minCount; ++i5) {
					var bucket5 = this._buckets.__inner[i5];
					for (var j7 = this._cnt - 1; j7 >= 0; --j7) {
						bucket5[j7] = min._buckets.__inner[i5][j7] + p * (e[j7] - min._buckets.__inner[i5][j7]);
					}

				}

			}

		}

		if (markerSpeedModified) {
			$.ig.Frame.prototype.interpolateWithSpeed(this._markers, p, min._markers, max._markers, this._markerSpeedModifiers);

		} else {
			$.ig.Frame.prototype.interpolate(this._markers, p, min._markers, max._markers);
		}

		if (trendSpeedModified) {
			$.ig.Frame.prototype.interpolateWithSpeed(this._trend, p, min._trend, max._trend, this._trendSpeedModifiers);

		} else {
			$.ig.Frame.prototype.interpolate(this._trend, p, min._trend, max._trend);
		}

		if (errorSpeedModified) {
			$.ig.Frame.prototype.interpolateWithSpeed(this._errorBars, p, min._errorBars, max._errorBars, this._errorSpeedModifiers);

		} else {
			$.ig.Frame.prototype.interpolate(this._errorBars, p, min._errorBars, max._errorBars);
		}

		if (errorBarsSpeedModified) {
			$.ig.Frame.prototype.interpolateWithSpeed1(this._errorBarSizes, p, min._errorBarSizes, max._errorBarSizes, this._errorBarsSpeedModifiers);

		} else {
			$.ig.Frame.prototype.interpolate1(this._errorBarSizes, p, min._errorBarSizes, max._errorBarSizes);
		}

		var minClip = min.customClip();
		var maxClip = max.customClip();
		if (minClip == null) {
			minClip = this.__fullClip;
		}

		if (maxClip == null) {
			maxClip = this.__fullClip;
		}

		var left = minClip.left() + (maxClip.left() - minClip.left()) * p;
		var top = minClip.top() + (maxClip.top() - minClip.top()) * p;
		var width = minClip.width() + (maxClip.width() - minClip.width()) * p;
		var height = minClip.height() + (maxClip.height() - minClip.height()) * p;
		this.customClip(new $.ig.Rect(0, left, top, width, height));
	}

	, 
	reconcileSpeedModifiers: function (modifiers, p, minSpeedModifiers, maxSpeedModifiers, count) {
		if (maxSpeedModifiers.count() == 0) {
			for (var i = 0; i < minSpeedModifiers.count(); i++) {
				maxSpeedModifiers.add(minSpeedModifiers.__inner[i]);
			}


		} else {
			$.ig.Frame.prototype.interpolate1(modifiers, p, minSpeedModifiers, maxSpeedModifiers);
		}

		if (modifiers.count() < count) {
			var speedCount = modifiers.count();
			for (var i1 = 0; i1 < count - speedCount; i1++) {
				modifiers.add(1);
			}

		}

	}

	, 
	clearSpeedModifiers: function () {
		this._speedModifiers.clear();
		this._trendSpeedModifiers.clear();
		this._markerSpeedModifiers.clear();
		this._errorSpeedModifiers.clear();
		this._errorBarsSpeedModifiers.clear();
	}

	, 
	clearFrame: function () {
		this.incrementFrameVersion();
		this.clearSpeedModifiers();
		this.customClip(this.__fullClip);
	}

	, 
	resetFrame: function () {
		this.clearFrame();
		this._buckets.clear();
		this._errorBars.clear();
		this._errorBuckets.clear();
		this._markers.clear();
		this._trend.clear();
	}

	, 
	incrementFrameVersion: function () {
		$.ig.CategoryFrame.prototype._categoryFrameVersion++;
		if ($.ig.CategoryFrame.prototype._categoryFrameVersion >= (0x7FFFFFFF - 1)) {
			$.ig.CategoryFrame.prototype._categoryFrameVersion = 0;
		}

		this.frameVersion($.ig.CategoryFrame.prototype._categoryFrameVersion);
	}

	, 
	_customClip: null,
	customClip: function (value) {
		if (arguments.length === 1) {
			this._customClip = value;
			return value;
		} else {
			return this._customClip;
		}
	}
	, 
	$type: new $.ig.Type('CategoryFrame', $.ig.Frame.prototype.$type)
}, true);

$.ig.util.defType('SingleValuesHolder', 'ValuesHolder', {
	init: function () {


		$.ig.ValuesHolder.prototype.init.call(this);

	}
	, 
	_values: null,
	values: function (value) {
		if (arguments.length === 1) {
			this._values = value;
			return value;
		} else {
			return this._values;
		}
	}

	, 
	count: function () {

			if (this.values() != null) {
				return this.values().count();
			}

			return 0;
	}
	, 
	$type: new $.ig.Type('SingleValuesHolder', $.ig.ValuesHolder.prototype.$type)
}, true);

$.ig.util.defType('DefaultSingleValueProvider', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	valueColumn: function () {

			return new $.ig.List$1(Number, 0);
	}
	, 
	$type: new $.ig.Type('DefaultSingleValueProvider', $.ig.Object.prototype.$type, [$.ig.IHasSingleValueCategory.prototype.$type])
}, true);

$.ig.util.defType('PreparationParams', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	_firstBucket: 0,
	firstBucket: function (value) {
		if (arguments.length === 1) {
			this._firstBucket = value;
			return value;
		} else {
			return this._firstBucket;
		}
	}

	, 
	_lastBucket: 0,
	lastBucket: function (value) {
		if (arguments.length === 1) {
			this._lastBucket = value;
			return value;
		} else {
			return this._lastBucket;
		}
	}

	, 
	_bucketSize: 0,
	bucketSize: function (value) {
		if (arguments.length === 1) {
			this._bucketSize = value;
			return value;
		} else {
			return this._bucketSize;
		}
	}

	, 
	_resolution: 0,
	resolution: function (value) {
		if (arguments.length === 1) {
			this._resolution = value;
			return value;
		} else {
			return this._resolution;
		}
	}

	, 
	_windowRect: null,
	windowRect: function (value) {
		if (arguments.length === 1) {
			this._windowRect = value;
			return value;
		} else {
			return this._windowRect;
		}
	}

	, 
	_viewportRect: null,
	viewportRect: function (value) {
		if (arguments.length === 1) {
			this._viewportRect = value;
			return value;
		} else {
			return this._viewportRect;
		}
	}

	, 
	_scaler: null,
	scaler: function (value) {
		if (arguments.length === 1) {
			this._scaler = value;
			return value;
		} else {
			return this._scaler;
		}
	}

	, 
	_sortingScaler: null,
	sortingScaler: function (value) {
		if (arguments.length === 1) {
			this._sortingScaler = value;
			return value;
		} else {
			return this._sortingScaler;
		}
	}

	, 
	_yScaler: null,
	yScaler: function (value) {
		if (arguments.length === 1) {
			this._yScaler = value;
			return value;
		} else {
			return this._yScaler;
		}
	}

	, 
	_frame: null,
	frame: function (value) {
		if (arguments.length === 1) {
			this._frame = value;
			return value;
		} else {
			return this._frame;
		}
	}

	, 
	_isFragment: false,
	isFragment: function (value) {
		if (arguments.length === 1) {
			this._isFragment = value;
			return value;
		} else {
			return this._isFragment;
		}
	}

	, 
	_useHighMarkerFidelity: false,
	useHighMarkerFidelity: function (value) {
		if (arguments.length === 1) {
			this._useHighMarkerFidelity = value;
			return value;
		} else {
			return this._useHighMarkerFidelity;
		}
	}
	, 
	$type: new $.ig.Type('PreparationParams', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('CategoryLineRasterizer', 'Object', {
	init: function () {

		this.__flattenedLinePoints = new $.ig.PointCollection(0);

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_isSortingAxis: false,
	isSortingAxis: function (value) {
		if (arguments.length === 1) {
			this._isSortingAxis = value;
			return value;
		} else {
			return this._isSortingAxis;
		}
	}
	, 
	__flattenedLinePoints: null

	, 
	flattenedLinePoints: function (value) {
		if (arguments.length === 1) {

			this.__flattenedLinePoints = value;
			return value;
		} else {

			return this.__flattenedLinePoints;
		}
	}

	, 
	rasterizePolylinePaths: function (polylines0, polygons01, polylines1, count, buckets, useX0AsX1, unknownValuePlotting, clipper, bucketSize, resolution) {
		var $self = this;
		var polylineData0 = new $.ig.PathGeometry();
		var polygonData01 = new $.ig.PathGeometry();
		var polylineData1 = new $.ig.PathGeometry();
		polylines0.data(polylineData0);
		polygons01.data(polygonData01);
		polylines1.data(polylineData1);
		polylineData0.figures(new $.ig.PathFigureCollection());
		polygonData01.figures(new $.ig.PathFigureCollection());
		polylineData1.figures(new $.ig.PathFigureCollection());
		var polylineSegments0 = new $.ig.List$1($.ig.PolyLineSegment.prototype.$type, 0);
		var polylineSegments1 = new $.ig.List$1($.ig.PolyLineSegment.prototype.$type, 0);
		var polygonSegments0 = new $.ig.List$1($.ig.PolyLineSegment.prototype.$type, 0);
		var polygonSegments1 = new $.ig.List$1($.ig.PolyLineSegment.prototype.$type, 0);
		if (unknownValuePlotting == $.ig.UnknownValuePlotting.prototype.linearInterpolate || unknownValuePlotting == $.ig.UnknownValuePlotting.prototype.dontPlot) {
			var incrementalClipper = unknownValuePlotting == $.ig.UnknownValuePlotting.prototype.dontPlot ? clipper : null;
			var currentLineStartIndex = 0;
			for (var i = 0; i < count; i++) {
				if ($.ig.util.isNaN(buckets.__inner[i][1])) {
					var pointsInCurrentLine = i - currentLineStartIndex;
					var addPoints = (unknownValuePlotting == $.ig.UnknownValuePlotting.prototype.linearInterpolate && pointsInCurrentLine > 0) || (unknownValuePlotting == $.ig.UnknownValuePlotting.prototype.dontPlot && pointsInCurrentLine > 1);
					if (addPoints) {
						if (unknownValuePlotting == $.ig.UnknownValuePlotting.prototype.dontPlot || polylineSegments0.count() == 0) {
							var currentPolylineSegment0 = new $.ig.PolyLineSegment();
							var currentPolylineSegment1 = new $.ig.PolyLineSegment();
							var currentPolygonSegment0 = new $.ig.PolyLineSegment();
							var currentPolygonSegment1 = new $.ig.PolyLineSegment();
							polylineSegments0.add(currentPolylineSegment0);
							polylineSegments1.add(currentPolylineSegment1);
							polygonSegments0.add(currentPolygonSegment0);
							polygonSegments1.add(currentPolygonSegment1);
						}

						$self.rasterizePolyline1(polylineSegments0.__inner[polylineSegments0.count() - 1].__points, polylineSegments1.__inner[polylineSegments1.count() - 1].__points, polygonSegments0.__inner[polygonSegments0.count() - 1].__points, polygonSegments1.__inner[polygonSegments1.count() - 1].__points, currentLineStartIndex, i - 1, buckets, useX0AsX1, incrementalClipper, bucketSize, resolution);
					}

					currentLineStartIndex = i + 1;
				}

			}

			if (unknownValuePlotting == $.ig.UnknownValuePlotting.prototype.dontPlot || polylineSegments0.count() == 0) {
				var lastPolylineSegment0 = new $.ig.PolyLineSegment();
				var lastPolygonSegment0 = new $.ig.PolyLineSegment();
				var lastPolygonSegment1 = new $.ig.PolyLineSegment();
				var lastPolylineSegment1 = new $.ig.PolyLineSegment();
				polylineSegments0.add(lastPolylineSegment0);
				polylineSegments1.add(lastPolylineSegment1);
				polygonSegments0.add(lastPolygonSegment0);
				polygonSegments1.add(lastPolygonSegment1);
			}

			$self.rasterizePolyline1(polylineSegments0.__inner[polylineSegments0.count() - 1].__points, polylineSegments1.__inner[polylineSegments1.count() - 1].__points, polygonSegments0.__inner[polygonSegments0.count() - 1].__points, polygonSegments1.__inner[polygonSegments1.count() - 1].__points, currentLineStartIndex, count - 1, buckets, useX0AsX1, incrementalClipper, bucketSize, resolution);
			if (incrementalClipper == null && polylineSegments0.count() == 1 && clipper != null) {
				$self.clipSegment(polylineSegments0.__inner[0], clipper);
				if (polylineSegments1.count() == 1) {
					$self.clipSegment(polylineSegments1.__inner[0], clipper);
				}

			}


		} else {
			polylineSegments0.add(new $.ig.PolyLineSegment());
			polylineSegments1.add(new $.ig.PolyLineSegment());
			polygonSegments0.add(new $.ig.PolyLineSegment());
			polygonSegments1.add(new $.ig.PolyLineSegment());
			$self.rasterizePolyline(polylineSegments0.__inner[0].__points, polylineSegments1.__inner[0].__points, polygonSegments0.__inner[0].__points, polygonSegments1.__inner[0].__points, count, buckets, useX0AsX1, clipper, bucketSize, resolution);
		}

		for (var current = 0; current < polylineSegments0.count(); current++) {
			var polylineSegment0 = polylineSegments0.__inner[current];
			var polylineSegment1 = polylineSegments1.__inner[current];
			var polygonSegment0 = polygonSegments0.__inner[current];
			var polygonSegment1 = polygonSegments1.__inner[current];
			if (polylineSegment0.__points.count() > 0) {
				var polylineFigure0 = (function () { var $ret = new $.ig.PathFigure();
				$ret.startPoint(polylineSegment0.__points.__inner[0]); return $ret;}());
				polylineFigure0.__segments.add(polylineSegment0);
				polylineData0.figures().add(polylineFigure0);
			}

			if (polylineSegment1.__points.count() > 0) {
				var polylineFigure1 = (function () { var $ret = new $.ig.PathFigure();
				$ret.startPoint(polylineSegment1.__points.__inner[0]); return $ret;}());
				polylineFigure1.__segments.add(polylineSegment1);
				polylineData1.figures().add(polylineFigure1);
			}

			if (polygonSegment0.__points.count() > 0 && polygonSegment1.__points.count() > 0) {
				var polygonSegment01 = new $.ig.PolyLineSegment();
				if (clipper != null) {
					var temp = clipper.isClosed();
					clipper.isClosed(true);
					clipper.target(polygonSegment01.__points);
					var en = polygonSegment0.__points.getEnumerator();
					while (en.moveNext()) {
						var p = en.current();
						clipper.add(p);
					}

					for (var i1 = polygonSegment1.__points.count() - 1; i1 >= 0; i1--) {
						clipper.add(polygonSegment1.__points.__inner[i1]);
					}

					clipper.target(null);
					clipper.isClosed(temp);

				} else {
					var en1 = polygonSegment0.__points.getEnumerator();
					while (en1.moveNext()) {
						var p1 = en1.current();
						polygonSegment01.__points.add(p1);
					}

					for (var i2 = polygonSegment1.__points.count() - 1; i2 >= 0; i2--) {
						polygonSegment01.__points.add(polygonSegment1.__points.__inner[i2]);
					}

				}

				if (polygonSegment01.__points.count() > 0) {
					var polygonFigure01 = (function () { var $ret = new $.ig.PathFigure();
					$ret.startPoint(polygonSegment01.__points.__inner[0]); return $ret;}());
					polygonFigure01.__segments.add(polygonSegment01);
					polygonData01.figures().add(polygonFigure01);
				}

			}

		}

	}

	, 
	clipSegment: function (segment, clipper) {
		var points = segment.__points;
		clipper.target(segment.__points = new $.ig.PointCollection(0));
		var en = points.getEnumerator();
		while (en.moveNext()) {
			var p = en.current();
			clipper.add(p);
		}

		clipper.target(null);
	}

	, 
	rasterizePolyline2: function (polyline0, polyline1, polygon0, polygon1, count, buckets, useX0AsX1, clipper, bucketSize, resolution) {
		polyline0.points().clear();
		polygon0.points().clear();
		polygon1.points().clear();
		polyline1.points().clear();
		this.rasterizePolyline(polyline0.points(), polyline1.points(), polygon0.points(), polygon1.points(), count, buckets, useX0AsX1, clipper, bucketSize, resolution);
		polyline0.isHitTestVisible(polyline0.points().count() > 0);
		polygon0.isHitTestVisible(polygon0.points().count() > 0);
		polygon1.isHitTestVisible(polygon1.points().count() > 0);
		polyline1.isHitTestVisible(polyline1.points().count() > 0);
	}

	, 
	rasterizePolyline: function (polylinePoints0, polylinePoints1, polygonPoints0, polygonPoints1, count, buckets, useX0AsX1, clipper, bucketSize, resolution) {
		this.rasterizePolyline1(polylinePoints0, polylinePoints1, polygonPoints0, polygonPoints1, 0, count - 1, buckets, useX0AsX1, clipper, bucketSize, resolution);
	}

	, 
	flattenPoints: function (points, startIndex, endIndex, buckets, point0, useX0AsX1, resolution) {
		var flattened = $.ig.Flattener.prototype.fastFlatten3(new $.ig.List$1($.ig.Number.prototype.$type, 0), buckets, point0, useX0AsX1, startIndex, endIndex, resolution);
		var j = 0;
		var flattenedCount = flattened.count();
		var bucket;
		var x;
		var y;
		if (point0) {
			for (var i = 0; i < flattenedCount; i++) {
				j = flattened.__inner[i];
				bucket = buckets.__inner[j];
				x = bucket[0];
				y = bucket[1];
				var pointToAdd = {__x: x, __y: y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
				points.add(pointToAdd);
			}


		} else if (useX0AsX1) {
			for (var i1 = 0; i1 < flattenedCount; i1++) {
				j = flattened.__inner[i1];
				bucket = buckets.__inner[j];
				x = bucket[0];
				y = bucket[2];
				var pointToAdd1 = {__x: x, __y: y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
				points.add(pointToAdd1);
			}


		} else {
			for (var i2 = 0; i2 < flattenedCount; i2++) {
				j = flattened.__inner[i2];
				bucket = buckets.__inner[j];
				x = bucket[2];
				y = bucket[3];
				var pointToAdd2 = {__x: x, __y: y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
				points.add(pointToAdd2);
			}

		}


	}

	, 
	clipPoints: function (points, pointsToClip, clipper, resolution) {
		clipper.target(points);
		for (var i = 0; i < pointsToClip.count(); i++) {
			clipper.add(pointsToClip.__inner[i]);
		}

		clipper.target(null);
	}

	, 
	rasterizePolyline1: function (polylinePoints0, polylinePoints1, polygonPoints0, polygonPoints1, startIndex, endIndex, buckets, useX0AsX1, clipper, bucketSize, resolution) {
		if (endIndex > -1) {
			if (bucketSize == 1 && !this.isSortingAxis()) {
				var polylinePoints0_new = new $.ig.PointCollection(0);
				this.flattenPoints(polylinePoints0_new, startIndex, endIndex, buckets, true, useX0AsX1, resolution);
				if (clipper != null) {
					this.clipPoints(polylinePoints0, polylinePoints0_new, clipper, resolution);

				} else {
					var en = polylinePoints0_new.getEnumerator();
					while (en.moveNext()) {
						var p = en.current();
						polylinePoints0.add(p);
					}

				}


			} else {
				var polylinePoints0_new1 = new $.ig.PointCollection(0);
				var polylinePoints1_new = new $.ig.PointCollection(0);
				this.flattenPoints(polylinePoints0_new1, startIndex, endIndex, buckets, true, useX0AsX1, resolution);
				this.flattenPoints(polylinePoints1_new, startIndex, endIndex, buckets, false, useX0AsX1, resolution);
				var en1 = polylinePoints0_new1.getEnumerator();
				while (en1.moveNext()) {
					var point = en1.current();
					polygonPoints0.add(point);
				}

				var en2 = polylinePoints1_new.getEnumerator();
				while (en2.moveNext()) {
					var point1 = en2.current();
					polygonPoints1.add(point1);
				}

				if (clipper != null) {
					this.clipPoints(polylinePoints0, polylinePoints0_new1, clipper, resolution);
					this.clipPoints(polylinePoints1, polylinePoints1_new, clipper, resolution);

				} else {
					var en3 = polylinePoints0_new1.getEnumerator();
					while (en3.moveNext()) {
						var p1 = en3.current();
						polylinePoints0.add(p1);
					}

					var en4 = polylinePoints1_new.getEnumerator();
					while (en4.moveNext()) {
						var p2 = en4.current();
						polylinePoints1.add(p2);
					}

				}

			}

		}

	}

	, 
	rasterizePolygonPaths: function (polygons0, polylines0, polygons01, polylines1, count, buckets, useX0AsX1, bucketSize, resolution, terminatePolygon, unknownValuePlotting) {
		var $self = this;
		var polygonData0 = new $.ig.PathGeometry();
		var polylineData0 = new $.ig.PathGeometry();
		var polygonData01 = new $.ig.PathGeometry();
		var polylineData1 = new $.ig.PathGeometry();
		polygons0.data(polygonData0);
		polylines0.data(polylineData0);
		polygons01.data(polygonData01);
		polylines1.data(polylineData1);
		polygonData0.figures(new $.ig.PathFigureCollection());
		polylineData0.figures(new $.ig.PathFigureCollection());
		polygonData01.figures(new $.ig.PathFigureCollection());
		polylineData1.figures(new $.ig.PathFigureCollection());
		var polygonSegments0 = new $.ig.List$1($.ig.PolyLineSegment.prototype.$type, 0);
		var polylineSegments0 = new $.ig.List$1($.ig.PolyLineSegment.prototype.$type, 0);
		var polygonSegments01 = new $.ig.List$1($.ig.PolyLineSegment.prototype.$type, 0);
		var polylineSegments1 = new $.ig.List$1($.ig.PolyLineSegment.prototype.$type, 0);
		if (unknownValuePlotting == $.ig.UnknownValuePlotting.prototype.linearInterpolate || unknownValuePlotting == $.ig.UnknownValuePlotting.prototype.dontPlot) {
			var currentLineStartIndex = 0;
			for (var i = 0; i < count; i++) {
				if ($.ig.util.isNaN(buckets.__inner[i][1])) {
					var pointsInCurrentLine = i - currentLineStartIndex;
					var addPoints = (unknownValuePlotting == $.ig.UnknownValuePlotting.prototype.linearInterpolate && pointsInCurrentLine > 0) || (unknownValuePlotting == $.ig.UnknownValuePlotting.prototype.dontPlot && pointsInCurrentLine > 1);
					if (addPoints) {
						if (unknownValuePlotting == $.ig.UnknownValuePlotting.prototype.dontPlot || polylineSegments0.count() == 0) {
							var currentPolygonSegment0 = new $.ig.PolyLineSegment();
							var currentPolylineSegment0 = new $.ig.PolyLineSegment();
							var currentPolygonSegment01 = new $.ig.PolyLineSegment();
							var currentPolylineSegment1 = new $.ig.PolyLineSegment();
							polygonSegments0.add(currentPolygonSegment0);
							polylineSegments0.add(currentPolylineSegment0);
							polygonSegments01.add(currentPolygonSegment01);
							polylineSegments1.add(currentPolylineSegment1);
						}

						$self.rasterizePolygon(polygonSegments0.__inner[polygonSegments0.count() - 1].__points, polylineSegments0.__inner[polylineSegments0.count() - 1].__points, polygonSegments01.__inner[polygonSegments01.count() - 1].__points, polylineSegments1.__inner[polylineSegments1.count() - 1].__points, currentLineStartIndex, i - 1, buckets, useX0AsX1, bucketSize, resolution);
						if (unknownValuePlotting == $.ig.UnknownValuePlotting.prototype.dontPlot) {
							terminatePolygon(polygonSegments0.__inner[polygonSegments0.count() - 1].__points, polylineSegments0.__inner[polylineSegments0.count() - 1].__points, polygonSegments01.__inner[polygonSegments01.count() - 1].__points, polylineSegments1.__inner[polylineSegments1.count() - 1].__points, false);
						}

					}

					currentLineStartIndex = i + 1;
				}

			}

			if (unknownValuePlotting == $.ig.UnknownValuePlotting.prototype.dontPlot || polylineSegments0.count() == 0) {
				var lastPolygonSegment0 = new $.ig.PolyLineSegment();
				var lastPolylineSegment0 = new $.ig.PolyLineSegment();
				var lastPolygonSegment01 = new $.ig.PolyLineSegment();
				var lastPolylineSegment1 = new $.ig.PolyLineSegment();
				polygonSegments0.add(lastPolygonSegment0);
				polylineSegments0.add(lastPolylineSegment0);
				polygonSegments01.add(lastPolygonSegment01);
				polylineSegments1.add(lastPolylineSegment1);
			}

			$self.rasterizePolygon(polygonSegments0.__inner[polygonSegments0.count() - 1].__points, polylineSegments0.__inner[polylineSegments0.count() - 1].__points, polygonSegments01.__inner[polygonSegments01.count() - 1].__points, polylineSegments1.__inner[polylineSegments1.count() - 1].__points, currentLineStartIndex, count - 1, buckets, useX0AsX1, bucketSize, resolution);
			terminatePolygon(polygonSegments0.__inner[polygonSegments0.count() - 1].__points, polylineSegments0.__inner[polylineSegments0.count() - 1].__points, polygonSegments01.__inner[polygonSegments01.count() - 1].__points, polylineSegments1.__inner[polylineSegments1.count() - 1].__points, true);

		} else {
			polygonSegments0.add(new $.ig.PolyLineSegment());
			polylineSegments0.add(new $.ig.PolyLineSegment());
			polygonSegments01.add(new $.ig.PolyLineSegment());
			polylineSegments1.add(new $.ig.PolyLineSegment());
			$self.rasterizePolygon(polygonSegments0.__inner[0].__points, polylineSegments0.__inner[0].__points, polygonSegments01.__inner[0].__points, polylineSegments1.__inner[0].__points, 0, count - 1, buckets, useX0AsX1, bucketSize, resolution);
			terminatePolygon(polygonSegments0.__inner[0].__points, polylineSegments0.__inner[0].__points, polygonSegments01.__inner[0].__points, polylineSegments1.__inner[0].__points, true);
		}

		for (var current = 0; current < polylineSegments0.count(); current++) {
			var polygonSegment0 = polygonSegments0.__inner[current];
			var polylineSegment0 = polylineSegments0.__inner[current];
			var polygonSegment01 = polygonSegments01.__inner[current];
			var polylineSegment1 = polylineSegments1.__inner[current];
			if (polygonSegment0.__points.count() > 0) {
				var polygonFigure0 = (function () { var $ret = new $.ig.PathFigure();
				$ret.startPoint(polygonSegment0.__points.__inner[0]); return $ret;}());
				polygonFigure0.__segments.add(polygonSegment0);
				polygonData0.figures().add(polygonFigure0);
			}

			if (polylineSegment0.__points.count() > 0) {
				var polylineFigure0 = (function () { var $ret = new $.ig.PathFigure();
				$ret.startPoint(polylineSegment0.__points.__inner[0]); return $ret;}());
				polylineFigure0.__segments.add(polylineSegment0);
				polylineData0.figures().add(polylineFigure0);
			}

			if (polygonSegment01.__points.count() > 0) {
				var polygonFigure01 = (function () { var $ret = new $.ig.PathFigure();
				$ret.startPoint(polygonSegment01.__points.__inner[0]); return $ret;}());
				polygonFigure01.__segments.add(polygonSegment01);
				polygonData01.figures().add(polygonFigure01);
			}

			if (polylineSegment1.__points.count() > 0) {
				var polylineFigure1 = (function () { var $ret = new $.ig.PathFigure();
				$ret.startPoint(polylineSegment1.__points.__inner[0]); return $ret;}());
				polylineFigure1.__segments.add(polylineSegment1);
				polylineData1.figures().add(polylineFigure1);
			}

		}

	}

	, 
	rasterizePolygon: function (polygonPoints0, polylinePoints0, polygonPoints01, polylinePoints1, startIndex, endIndex, buckets, useX0AsX1, bucketSize, resolution) {
		this.flattenedLinePoints().clear();
		if (bucketSize == 1 && !this.isSortingAxis()) {
			var indexes = $.ig.Flattener.prototype.fastFlatten3(new $.ig.List$1($.ig.Number.prototype.$type, 0), buckets, true, useX0AsX1, startIndex, endIndex, resolution);
			var indexCount = indexes.count();
			var index = 0;
			var bucket;
			var x0;
			var y0;
			for (var i = 0; i < indexCount; i++) {
				index = indexes.__inner[i];
				bucket = buckets.__inner[index];
				x0 = bucket[0];
				y0 = bucket[1];
				polygonPoints0.add({__x: x0, __y: y0, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
				polylinePoints1.add({__x: x0, __y: y0, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
				this.flattenedLinePoints().add({__x: x0, __y: y0, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			}


		} else {
			var indexes1 = $.ig.Flattener.prototype.fastFlatten3(new $.ig.List$1($.ig.Number.prototype.$type, 0), buckets, true, useX0AsX1, startIndex, endIndex, resolution);
			var indexes2 = $.ig.Flattener.prototype.fastFlatten3(new $.ig.List$1($.ig.Number.prototype.$type, 0), buckets, false, useX0AsX1, startIndex, endIndex, resolution);
			var indexCount1 = indexes1.count();
			var index2Count = indexes2.count();
			var index1 = 0;
			var bucket1;
			var x01;
			var y01;
			for (var i1 = 0; i1 < indexCount1; i1++) {
				index1 = indexes1.__inner[i1];
				bucket1 = buckets.__inner[index1];
				x01 = bucket1[0];
				y01 = bucket1[1];
				polygonPoints0.add({__x: x01, __y: y01, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
				polylinePoints0.add({__x: x01, __y: y01, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
				polygonPoints01.add({__x: x01, __y: y01, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
				this.flattenedLinePoints().add({__x: x01, __y: y01, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			}

			var x1;
			var y1;
			for (var i2 = index2Count - 1; i2 >= 0; i2--) {
				index1 = indexes2.__inner[i2];
				bucket1 = buckets.__inner[index1];
				if (useX0AsX1) {
					x1 = bucket1[0];
					y1 = bucket1[2];

				} else {
					x1 = bucket1[2];
					y1 = bucket1[3];
				}

				polylinePoints1.add({__x: x1, __y: y1, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
				polygonPoints01.add({__x: x1, __y: y1, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			}

		}

	}
	, 
	$type: new $.ig.Type('CategoryLineRasterizer', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('CategoryTransitionSourceFramePreparer', 'Object', {
	init: function () {

		this.__rand = new $.ig.Random(0);

		$.ig.Object.prototype.init.call(this);

	}
	, 
	prepareSourceFrame: function (previousFrame, currentFrame, isVertical, xAxis, yAxis, mode, defaultMode, speedType, defaultSpeedType, getZeroValue, viewport) {
		previousFrame.customClip(new $.ig.Rect(0, 0, 0, 1, 1));
		previousFrame._buckets.clear();
		previousFrame._errorBuckets.clear();
		previousFrame._markers.clear();
		previousFrame._trend.clear();
		previousFrame._errorBars.clear();
		previousFrame._errorBarSizes.clear();
		var yAxisIsInverted = false;
		var xAxisIsInverted = false;
		if (yAxis != null) {
			yAxisIsInverted = yAxis.isInverted();
		}

		if (xAxis != null) {
			xAxisIsInverted = xAxis.isInverted();
		}

		var transitionMode = mode;
		if (transitionMode == $.ig.CategoryTransitionInMode.prototype.auto) {
			transitionMode = defaultMode;
		}

		switch (transitionMode) {
			case $.ig.CategoryTransitionInMode.prototype.fromZero:
				var zeroValue = getZeroValue();
				this.prepareSourceFrameFromZero(previousFrame, currentFrame, zeroValue, isVertical);
				break;
			case $.ig.CategoryTransitionInMode.prototype.accordionFromLeft:
				this.prepareSourceFrameFromLeftOrRight(previousFrame, currentFrame, false, isVertical, viewport);
				break;
			case $.ig.CategoryTransitionInMode.prototype.accordionFromTop:
				this.prepareSourceFrameFromTopOrBottom(previousFrame, currentFrame, true, isVertical, viewport);
				break;
			case $.ig.CategoryTransitionInMode.prototype.accordionFromBottom:
				this.prepareSourceFrameFromTopOrBottom(previousFrame, currentFrame, false, isVertical, viewport);
				break;
			case $.ig.CategoryTransitionInMode.prototype.accordionFromRight:
				this.prepareSourceFrameFromLeftOrRight(previousFrame, currentFrame, true, isVertical, viewport);
				break;
			case $.ig.CategoryTransitionInMode.prototype.sweepFromLeft:
				this.prepareSourceFrameSweepFromLeftOrRight(previousFrame, currentFrame, false);
				break;
			case $.ig.CategoryTransitionInMode.prototype.sweepFromRight:
				this.prepareSourceFrameSweepFromLeftOrRight(previousFrame, currentFrame, true);
				break;
			case $.ig.CategoryTransitionInMode.prototype.sweepFromTop:
				this.prepareSourceFrameSweepFromTopOrBottom(previousFrame, currentFrame, true);
				break;
			case $.ig.CategoryTransitionInMode.prototype.sweepFromBottom:
				this.prepareSourceFrameSweepFromTopOrBottom(previousFrame, currentFrame, false);
				break;
			case $.ig.CategoryTransitionInMode.prototype.sweepFromCenter:
				this.copyFrame(previousFrame, currentFrame);
				previousFrame.customClip(new $.ig.Rect(0, 0.5, 0.5, 0, 0));
				break;
			case $.ig.CategoryTransitionInMode.prototype.accordionFromCategoryAxisMinimum:
				if (isVertical) {
					this.prepareSourceFrameFromTopOrBottom(previousFrame, currentFrame, yAxisIsInverted, isVertical, viewport);

				} else {
					this.prepareSourceFrameFromLeftOrRight(previousFrame, currentFrame, xAxisIsInverted, isVertical, viewport);
				}

				break;
			case $.ig.CategoryTransitionInMode.prototype.accordionFromCategoryAxisMaximum:
				if (isVertical) {
					this.prepareSourceFrameFromTopOrBottom(previousFrame, currentFrame, !yAxisIsInverted, isVertical, viewport);

				} else {
					this.prepareSourceFrameFromLeftOrRight(previousFrame, currentFrame, !xAxisIsInverted, isVertical, viewport);
				}

				break;
			case $.ig.CategoryTransitionInMode.prototype.accordionFromValueAxisMinimum:
				if (isVertical) {
					this.prepareSourceFrameFromLeftOrRight(previousFrame, currentFrame, xAxisIsInverted, isVertical, viewport);

				} else {
					this.prepareSourceFrameFromTopOrBottom(previousFrame, currentFrame, yAxisIsInverted, isVertical, viewport);
				}

				break;
			case $.ig.CategoryTransitionInMode.prototype.accordionFromValueAxisMaximum:
				if (isVertical) {
					this.prepareSourceFrameFromLeftOrRight(previousFrame, currentFrame, !xAxisIsInverted, isVertical, viewport);

				} else {
					this.prepareSourceFrameFromTopOrBottom(previousFrame, currentFrame, !yAxisIsInverted, isVertical, viewport);
				}

				break;
			case $.ig.CategoryTransitionInMode.prototype.sweepFromCategoryAxisMinimum:
				if (isVertical) {
					this.prepareSourceFrameSweepFromTopOrBottom(previousFrame, currentFrame, yAxisIsInverted);

				} else {
					this.prepareSourceFrameSweepFromLeftOrRight(previousFrame, currentFrame, xAxisIsInverted);
				}

				break;
			case $.ig.CategoryTransitionInMode.prototype.sweepFromCategoryAxisMaximum:
				if (isVertical) {
					this.prepareSourceFrameSweepFromTopOrBottom(previousFrame, currentFrame, !yAxisIsInverted);

				} else {
					this.prepareSourceFrameSweepFromLeftOrRight(previousFrame, currentFrame, !xAxisIsInverted);
				}

				break;
			case $.ig.CategoryTransitionInMode.prototype.sweepFromValueAxisMinimum:
				if (isVertical) {
					this.prepareSourceFrameSweepFromLeftOrRight(previousFrame, currentFrame, xAxisIsInverted);

				} else {
					this.prepareSourceFrameSweepFromTopOrBottom(previousFrame, currentFrame, yAxisIsInverted);
				}

				break;
			case $.ig.CategoryTransitionInMode.prototype.sweepFromValueAxisMaximum:
				if (isVertical) {
					this.prepareSourceFrameSweepFromLeftOrRight(previousFrame, currentFrame, !xAxisIsInverted);

				} else {
					this.prepareSourceFrameSweepFromTopOrBottom(previousFrame, currentFrame, !yAxisIsInverted);
				}

				break;
			case $.ig.CategoryTransitionInMode.prototype.expand:
				this.prepareSourceFrameExpand(previousFrame, currentFrame);
				break;
		}

		if (speedType == $.ig.TransitionInSpeedType.prototype.auto) {
			speedType = defaultSpeedType;
		}

		previousFrame.clearSpeedModifiers();
		currentFrame.clearSpeedModifiers();
		switch (speedType) {
			case $.ig.TransitionInSpeedType.prototype.indexScaled:
				this.applyIndexScaledSpeedModifiers(previousFrame._buckets.count(), transitionMode, previousFrame._speedModifiers, currentFrame._speedModifiers, xAxis, yAxis, isVertical, viewport);
				this.applyIndexScaledSpeedModifiers(previousFrame._markers.count(), transitionMode, previousFrame._markerSpeedModifiers, currentFrame._markerSpeedModifiers, xAxis, yAxis, isVertical, viewport);
				this.applyIndexScaledSpeedModifiers(previousFrame._trend.count(), transitionMode, previousFrame._trendSpeedModifiers, currentFrame._trendSpeedModifiers, xAxis, yAxis, isVertical, viewport);
				this.applyIndexScaledSpeedModifiers(previousFrame._errorBars.count(), transitionMode, previousFrame._errorSpeedModifiers, currentFrame._errorSpeedModifiers, xAxis, yAxis, isVertical, viewport);
				this.applyIndexScaledSpeedModifiers(previousFrame._errorBarSizes.count(), transitionMode, previousFrame._errorBarsSpeedModifiers, currentFrame._errorBarsSpeedModifiers, xAxis, yAxis, isVertical, viewport);
				break;
			case $.ig.TransitionInSpeedType.prototype.valueScaled:
				var zeroVAlue = getZeroValue();
				this.applyValueScaledSpeedModifiersFromBuckets(previousFrame._buckets.count(), zeroVAlue, transitionMode, previousFrame._buckets, currentFrame._buckets, previousFrame._speedModifiers, currentFrame._speedModifiers, xAxis, yAxis, isVertical, viewport);
				this.applyValueScaledSpeedModifiersFromPoints(previousFrame._markers.count(), zeroVAlue, transitionMode, previousFrame._markers, currentFrame._markers, previousFrame._markerSpeedModifiers, currentFrame._markerSpeedModifiers, xAxis, yAxis, isVertical, viewport);
				this.applyValueScaledSpeedModifiersFromPoints(previousFrame._trend.count(), zeroVAlue, transitionMode, previousFrame._trend, currentFrame._trend, previousFrame._trendSpeedModifiers, currentFrame._trendSpeedModifiers, xAxis, yAxis, isVertical, viewport);
				this.applyValueScaledSpeedModifiersFromPoints(previousFrame._errorBars.count(), zeroVAlue, transitionMode, previousFrame._errorBars, currentFrame._errorBars, previousFrame._errorSpeedModifiers, currentFrame._errorSpeedModifiers, xAxis, yAxis, isVertical, viewport);
				this.applyValueScaledSpeedModifiersFromDoubles(previousFrame._errorBarSizes.count(), zeroVAlue, transitionMode, previousFrame._errorBarSizes, currentFrame._errorBarSizes, previousFrame._errorBarsSpeedModifiers, currentFrame._errorBarsSpeedModifiers, xAxis, yAxis, isVertical, viewport);
				break;
			case $.ig.TransitionInSpeedType.prototype.random:
				this.applyRandomSpeedModifiers(previousFrame._buckets.count(), transitionMode, previousFrame._speedModifiers, currentFrame._speedModifiers);
				this.applyRandomSpeedModifiers(previousFrame._markers.count(), transitionMode, previousFrame._markerSpeedModifiers, currentFrame._markerSpeedModifiers);
				this.applyRandomSpeedModifiers(previousFrame._trend.count(), transitionMode, previousFrame._trendSpeedModifiers, currentFrame._trendSpeedModifiers);
				this.applyRandomSpeedModifiers(previousFrame._errorBars.count(), transitionMode, previousFrame._errorSpeedModifiers, currentFrame._errorSpeedModifiers);
				this.applyRandomSpeedModifiers(previousFrame._errorBarSizes.count(), transitionMode, previousFrame._errorBarsSpeedModifiers, currentFrame._errorBarsSpeedModifiers);
				break;
		}

	}
	, 
	__rand: null

	, 
	applyRandomSpeedModifiers: function (count, transitionMode, previousModifiers, currentModifiers) {
		if (count == 0) {
			return;
		}

		for (var i = 0; i < count; i++) {
			previousModifiers.add(1 + this.__rand.nextDouble());
			currentModifiers.add(1 + this.__rand.nextDouble());
		}

	}

	, 
	applyValueScaledSpeedModifiersFromBuckets: function (count, zeroValue, transitionMode, previousBuckets, currentBuckets, previousModifiers, currentModifiers, xAxis, yAxis, isVertical, viewport) {
		if (count == 0) {
			return;
		}

		var isInverted = false;
		var valueAxis = yAxis;
		if (isVertical) {
			valueAxis = xAxis;
		}

		if (valueAxis != null) {
			isInverted = valueAxis.isInverted();
		}

		var bound = viewport.bottom();
		var maxBound = viewport.bottom();
		var minBound = viewport.top();
		if (isVertical) {
			maxBound = viewport.right();
			minBound = viewport.left();
		}

		if (isInverted) {
			maxBound = viewport.top();
			minBound = viewport.bottom();
			if (isVertical) {
				maxBound = viewport.left();
				minBound = viewport.right();
			}

		}

		zeroValue = Math.max(zeroValue, Math.min(minBound, maxBound));
		zeroValue = Math.min(zeroValue, Math.max(minBound, maxBound));
		bound = 0;
		var currentBucket;
		for (var i = 0; i < count; i++) {
			currentBucket = currentBuckets.__inner[i];
			for (var j = 1; j < currentBucket.length; j++) {
				if ($.ig.util.isNaN(currentBucket[j]) || Number.isInfinity(currentBucket[j])) {
					continue;
				}

				bound = Math.max(bound, Math.abs(zeroValue - currentBucket[j]));
			}

		}

		var max;
		var min;
		var p;
		for (var i1 = 0; i1 < count; i1++) {
			currentBucket = currentBuckets.__inner[i1];
			max = Math.abs(currentBucket[1] - zeroValue);
			min = Math.abs(currentBucket[1] - zeroValue);
			for (var j1 = 1; j1 < currentBucket.length; j1++) {
				if ($.ig.util.isNaN(currentBucket[j1]) || Number.isInfinity(currentBucket[j1])) {
					continue;
				}

				max = Math.max(Math.abs(currentBucket[j1] - zeroValue), max);
				min = Math.min(Math.abs(currentBucket[j1] - zeroValue), min);
			}

			var mid = (max + min) / 2;
			if ($.ig.util.isNaN(mid) || bound == 0) {
				p = 1;

			} else {
				p = mid / bound;
			}

			previousModifiers.add(2 - p);
			currentModifiers.add(2 - p);
		}

	}

	, 
	applyValueScaledSpeedModifiersFromPoints: function (count, zeroValue, transitionMode, previousPoints, currentPoints, previousModifiers, currentModifiers, xAxis, yAxis, isVertical, viewport) {
		if (count == 0) {
			return;
		}

		var isInverted = false;
		var valueAxis = yAxis;
		if (isVertical) {
			valueAxis = xAxis;
		}

		if (valueAxis != null) {
			isInverted = valueAxis.isInverted();
		}

		var bound = viewport.bottom();
		var maxBound = viewport.bottom();
		var minBound = viewport.top();
		if (isVertical) {
			maxBound = viewport.right();
			minBound = viewport.left();
		}

		if (isInverted) {
			maxBound = viewport.top();
			minBound = viewport.bottom();
			if (isVertical) {
				maxBound = viewport.left();
				minBound = viewport.right();
			}

		}

		zeroValue = Math.max(zeroValue, Math.min(minBound, maxBound));
		zeroValue = Math.min(zeroValue, Math.max(minBound, maxBound));
		bound = 0;
		var currentPoint;
		for (var i = 0; i < count; i++) {
			currentPoint = currentPoints.__inner[i];
			if (isVertical) {
				if ($.ig.util.isNaN(currentPoint.__x) || Number.isInfinity(currentPoint.__x)) {
					continue;
				}

				bound = Math.max(bound, Math.abs(currentPoint.__x - zeroValue));

			} else {
				if ($.ig.util.isNaN(currentPoint.__y) || Number.isInfinity(currentPoint.__y)) {
					continue;
				}

				bound = Math.max(bound, Math.abs(currentPoint.__y - zeroValue));
			}

		}

		var p;
		for (var i1 = 0; i1 < count; i1++) {
			currentPoint = currentPoints.__inner[i1];
			var mid;
			if (isVertical) {
				mid = currentPoint.__x;

			} else {
				mid = currentPoint.__y;
			}

			if ($.ig.util.isNaN(mid) || Number.isInfinity(mid) || bound == 0) {
				p = 1;

			} else {
				p = Math.abs(mid - zeroValue) / bound;
			}

			previousModifiers.add(2 - p);
			currentModifiers.add(2 - p);
		}

	}

	, 
	applyValueScaledSpeedModifiersFromDoubles: function (count, zeroValue, transitionMode, previousDoubles, currentDoubles, previousModifiers, currentModifiers, xAxis, yAxis, isVertical, viewport) {
		if (count == 0) {
			return;
		}

		var isInverted = false;
		var valueAxis = yAxis;
		if (isVertical) {
			valueAxis = xAxis;
		}

		if (valueAxis != null) {
			isInverted = valueAxis.isInverted();
		}

		var bound = viewport.bottom();
		var maxBound = viewport.bottom();
		var minBound = viewport.top();
		if (isVertical) {
			maxBound = viewport.right();
			minBound = viewport.left();
		}

		if (isInverted) {
			maxBound = viewport.top();
			minBound = viewport.bottom();
			if (isVertical) {
				maxBound = viewport.left();
				minBound = viewport.right();
			}

		}

		zeroValue = Math.max(zeroValue, Math.min(minBound, maxBound));
		zeroValue = Math.min(zeroValue, Math.max(minBound, maxBound));
		bound = 0;
		var currentDouble;
		for (var i = 0; i < count; i++) {
			currentDouble = currentDoubles.__inner[i];
			if ($.ig.util.isNaN(currentDouble) || Number.isInfinity(currentDouble)) {
				continue;
			}

			bound = Math.max(bound, Math.abs(currentDouble - zeroValue));
		}

		var p;
		for (var i1 = 0; i1 < count; i1++) {
			currentDouble = currentDoubles.__inner[i1];
			var mid;
			mid = currentDouble;
			if (bound == 0 || $.ig.util.isNaN(mid) || Number.isInfinity(mid)) {
				p = 1;

			} else {
				p = Math.abs(mid - zeroValue) / bound;
			}

			previousModifiers.add(2 - p);
			currentModifiers.add(2 - p);
		}

	}

	, 
	applyIndexScaledSpeedModifiers: function (count, transitionMode, previousModifiers, currentModifiers, xAxis, yAxis, isVertical, viewport) {
		if (count == 0) {
			return;
		}

		var indexAxis = xAxis;
		if (isVertical) {
			indexAxis = yAxis;
		}

		var isInverted = false;
		if (indexAxis != null) {
			isInverted = indexAxis.isInverted();
		}

		var p;
		for (var i = 0; i < count; i++) {
			if (count == 1) {
				p = 1;

			} else {
				p = i / (count - 1);
			}

			p = 1 - p;
			previousModifiers.add(1 + p);
			currentModifiers.add(1 + p);
		}

	}

	, 
	prepareSourceFrameExpand: function (previousFrame, currentFrame) {
		previousFrame._buckets.clear();
		previousFrame._errorBuckets.clear();
		previousFrame._markers.clear();
		previousFrame._trend.clear();
		previousFrame._errorBars.clear();
		previousFrame._errorBarSizes.clear();
		this.copyBucketList(previousFrame._buckets, currentFrame._buckets);
		this.copyFloatList(previousFrame._errorBuckets, currentFrame._errorBuckets);
		this.copyPointList(previousFrame._markers, currentFrame._markers);
		this.copyPointList(previousFrame._trend, currentFrame._trend);
		this.copyPointList(previousFrame._errorBars, currentFrame._errorBars);
		this.copyDoubleList(previousFrame._errorBarSizes, currentFrame._errorBarSizes);
		var bucketsCount = previousFrame._buckets.count();
		var buckets = previousFrame._buckets;
		var currentBucket;
		var min;
		var max;
		var mid;
		for (var i = 0; i < bucketsCount; i++) {
			currentBucket = buckets.__inner[i];
			min = currentBucket[1];
			max = currentBucket[1];
			for (var j = 2; j < currentBucket.length; j++) {
				min = Math.min(min, currentBucket[j]);
				max = Math.max(max, currentBucket[j]);
			}

			mid = (min + max) / 2;
			for (var j1 = 1; j1 < currentBucket.length; j1++) {
				currentBucket[j1] = mid;
			}

		}

		var errorBarSizesCount = previousFrame._errorBarSizes.count();
		var errorBarSizes = previousFrame._errorBarSizes;
		for (var i1 = 0; i1 < errorBarSizesCount; i1++) {
			errorBarSizes.__inner[i1] = 0;
		}

	}

	, 
	prepareSourceFrameSweepFromLeftOrRight: function (previousFrame, currentFrame, isRight) {
		if (isRight) {
			this.copyFrame(previousFrame, currentFrame);
			previousFrame.customClip(new $.ig.Rect(0, 1, 0, 0, 1));

		} else {
			this.copyFrame(previousFrame, currentFrame);
			previousFrame.customClip(new $.ig.Rect(0, 0, 0, 0, 1));
		}

	}

	, 
	prepareSourceFrameSweepFromTopOrBottom: function (previousFrame, currentFrame, isTop) {
		if (isTop) {
			this.copyFrame(previousFrame, currentFrame);
			previousFrame.customClip(new $.ig.Rect(0, 0, 0, 1, 0));

		} else {
			this.copyFrame(previousFrame, currentFrame);
			previousFrame.customClip(new $.ig.Rect(0, 0, 1, 1, 0));
		}

	}

	, 
	copyFrame: function (previousFrame, currentFrame) {
		previousFrame._buckets.clear();
		previousFrame._errorBuckets.clear();
		previousFrame._markers.clear();
		previousFrame._trend.clear();
		previousFrame._errorBars.clear();
		previousFrame._errorBarSizes.clear();
		this.copyBucketList(previousFrame._buckets, currentFrame._buckets);
		this.copyFloatList(previousFrame._errorBuckets, currentFrame._errorBuckets);
		this.copyPointList(previousFrame._markers, currentFrame._markers);
		this.copyPointList(previousFrame._trend, currentFrame._trend);
		this.copyPointList(previousFrame._errorBars, currentFrame._errorBars);
		this.copyDoubleList(previousFrame._errorBarSizes, currentFrame._errorBarSizes);
	}

	, 
	preparePointListFromValue: function (sourceItems, targetItems, isVertical, value, isValueAxis) {
		var targetCount = targetItems.count();
		var currentPoint;
		var sourcePoint;
		for (var i = 0; i < targetCount; i++) {
			currentPoint = targetItems.__inner[i];
			if (isValueAxis) {
				if (isVertical) {
					sourcePoint = {__x: value, __y: currentPoint.__y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};

				} else {
					sourcePoint = {__x: currentPoint.__x, __y: value, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
				}


			} else {
				if (isVertical) {
					sourcePoint = {__x: currentPoint.__x, __y: value, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};

				} else {
					sourcePoint = {__x: value, __y: currentPoint.__y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
				}

			}

			sourceItems.add(sourcePoint);
		}

	}

	, 
	copyPointList: function (sourceItems, targetItems) {
		var targetCount = targetItems.count();
		var currentPoint;
		var sourcePoint;
		for (var i = 0; i < targetCount; i++) {
			currentPoint = targetItems.__inner[i];
			sourcePoint = {__x: currentPoint.__x, __y: currentPoint.__y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			sourceItems.add(sourcePoint);
		}

	}

	, 
	copyBucketList: function (sourceItems, targetItems) {
		var bucketsCount = targetItems.count();
		var buckets = targetItems;
		var sourceBucket;
		var currentBucket;
		var sourceBuckets = sourceItems;
		for (var i = 0; i < bucketsCount; i++) {
			currentBucket = buckets.__inner[i];
			sourceBucket = new Array(currentBucket.length);
			for (var j = 0; j < sourceBucket.length; j++) {
				sourceBucket[j] = currentBucket[j];
			}

			sourceBuckets.add(sourceBucket);
		}

	}

	, 
	prepareBucketListFromValue: function (sourceItems, targetItems, isVertical, value, isValueAxis) {
		var bucketsCount = targetItems.count();
		var buckets = targetItems;
		var sourceBucket;
		var currentBucket;
		var sourceBuckets = sourceItems;
		for (var i = 0; i < bucketsCount; i++) {
			currentBucket = buckets.__inner[i];
			sourceBucket = new Array(currentBucket.length);
			if (isValueAxis) {
				sourceBucket[0] = currentBucket[0];
				for (var j = 1; j < sourceBucket.length; j++) {
					sourceBucket[j] = value;
				}


			} else {
				sourceBucket[0] = value;
				for (var j1 = 1; j1 < sourceBucket.length; j1++) {
					sourceBucket[j1] = currentBucket[j1];
				}

			}

			sourceBuckets.add(sourceBucket);
		}

	}

	, 
	prepareFloatListFromValue: function (sourceItems, targetItems) {
		var targetCount = targetItems.count();
		var currentItem;
		for (var i = 0; i < targetCount; i++) {
			currentItem = targetItems.__inner[i];
			sourceItems.add(currentItem);
		}

	}

	, 
	copyFloatList: function (sourceItems, targetItems) {
		var targetCount = targetItems.count();
		var currentItem;
		for (var i = 0; i < targetCount; i++) {
			currentItem = targetItems.__inner[i];
			sourceItems.add(currentItem);
		}

	}

	, 
	copyDoubleList: function (sourceItems, targetItems) {
		var targetCount = targetItems.count();
		var currentItem;
		for (var i = 0; i < targetCount; i++) {
			currentItem = targetItems.__inner[i];
			sourceItems.add(currentItem);
		}

	}

	, 
	prepareDoubleListFromValue: function (sourceItems, targetItems, isVertical, value, isValueAxis) {
		var targetCount = targetItems.count();
		var currentItem;
		for (var i = 0; i < targetCount; i++) {
			currentItem = targetItems.__inner[i];
			sourceItems.add(currentItem);
		}

	}

	, 
	prepareSourceFrameFromLeftOrRight: function (previousFrame, currentFrame, isRight, isVertical, viewport) {
		var fromValue = viewport.right();
		if (!isRight) {
			fromValue = viewport.left();
		}

		var isValueAxis = false;
		if (isVertical) {
			isValueAxis = true;
		}

		this.prepareBucketListFromValue(previousFrame._buckets, currentFrame._buckets, isVertical, fromValue, isValueAxis);
		this.prepareFloatListFromValue(previousFrame._errorBuckets, currentFrame._errorBuckets);
		this.preparePointListFromValue(previousFrame._markers, currentFrame._markers, isVertical, fromValue, isValueAxis);
		this.preparePointListFromValue(previousFrame._trend, currentFrame._trend, isVertical, fromValue, isValueAxis);
		this.preparePointListFromValue(previousFrame._errorBars, currentFrame._errorBars, isVertical, fromValue, isValueAxis);
		this.prepareDoubleListFromValue(previousFrame._errorBarSizes, currentFrame._errorBarSizes, isVertical, fromValue, isValueAxis);
	}

	, 
	prepareSourceFrameFromTopOrBottom: function (previousFrame, currentFrame, isTop, isVertical, viewport) {
		var fromValue = viewport.bottom();
		if (isTop) {
			fromValue = viewport.top();
		}

		var isValueAxis = true;
		if (isVertical) {
			isValueAxis = false;
		}

		this.prepareBucketListFromValue(previousFrame._buckets, currentFrame._buckets, isVertical, fromValue, isValueAxis);
		this.prepareFloatListFromValue(previousFrame._errorBuckets, currentFrame._errorBuckets);
		this.preparePointListFromValue(previousFrame._markers, currentFrame._markers, isVertical, fromValue, isValueAxis);
		this.preparePointListFromValue(previousFrame._trend, currentFrame._trend, isVertical, fromValue, isValueAxis);
		this.preparePointListFromValue(previousFrame._errorBars, currentFrame._errorBars, isVertical, fromValue, isValueAxis);
		this.prepareDoubleListFromValue(previousFrame._errorBarSizes, currentFrame._errorBarSizes, isVertical, fromValue, isValueAxis);
	}

	, 
	prepareSourceFrameFromZero: function (previousFrame, currentFrame, zeroValue, isVertical) {
		this.prepareBucketListFromValue(previousFrame._buckets, currentFrame._buckets, isVertical, zeroValue, true);
		this.prepareFloatListFromValue(previousFrame._errorBuckets, currentFrame._errorBuckets);
		this.preparePointListFromValue(previousFrame._markers, currentFrame._markers, isVertical, zeroValue, true);
		this.preparePointListFromValue(previousFrame._trend, currentFrame._trend, isVertical, zeroValue, true);
		this.preparePointListFromValue(previousFrame._errorBars, currentFrame._errorBars, isVertical, zeroValue, true);
		this.prepareDoubleListFromValue(previousFrame._errorBarSizes, currentFrame._errorBarSizes, isVertical, zeroValue, true);
	}
	, 
	$type: new $.ig.Type('CategoryTransitionSourceFramePreparer', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('CategorySeriesRenderManager', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}, 
	_actualRenderFill: null
	, 
	_actualRenderOutline: null
	, 
	_actualRenderThickness: 0
	, 
	_actualRenderDashArray: null
	, 
	_actualRenderDashCap: 0
	, 
	_actualRenderRadiusX: 0
	, 
	_actualRenderRadiusY: 0
	, 
	_actualRenderOpacity: 0
	, 
	_actualRenderMiterLimit: 0
	, 
	_actualRenderStartCap: 0
	, 
	_actualRenderEndCap: 0
	, 
	_initialRenderFill: null
	, 
	_initialRenderOutline: null
	, 
	_initialRenderThickness: 0
	, 
	_initialRenderDashArray: null
	, 
	_initialRenderDashCap: 0
	, 
	_initialRenderRadiusX: 0
	, 
	_initialRenderRadiusY: 0
	, 
	_initialRenderOpacity: 0
	, 
	_initialRenderMiterLimit: 0
	, 
	_initialRenderStartCap: 0
	, 
	_initialRenderEndCap: 0
	, 
	_initialMarkerRenderFill: null
	, 
	_initialMarkerRenderOutline: null
	, 
	_initialMarkerRenderOpacity: 0
	, 
	_actualNegativeShape: false
	, 
	_actualNegativeMarkerShape: false
	, 
	_actualMarkerRenderFill: null
	, 
	_actualMarkerRenderOutline: null
	, 
	_actualMarkerRenderOpacity: 0

	, 
	_categoryOverrideArgs: null,
	categoryOverrideArgs: function (value) {
		if (arguments.length === 1) {
			this._categoryOverrideArgs = value;
			return value;
		} else {
			return this._categoryOverrideArgs;
		}
	}

	, 
	_categoryMarkerOverrideArgs: null,
	categoryMarkerOverrideArgs: function (value) {
		if (arguments.length === 1) {
			this._categoryMarkerOverrideArgs = value;
			return value;
		} else {
			return this._categoryMarkerOverrideArgs;
		}
	}
	, 
	_actualRenderCategoryAxis: null
	, 
	_bucketSize: 0
	, 
	_firstBucket: 0

	, 
	initCategoryMarkerRenderSettings: function (source, shouldOverrideMarkerStyle, getItems, size, first) {
		this._bucketSize = size;
		this._firstBucket = first;
		this._actualNegativeMarkerShape = false;
		this._initialMarkerRenderFill = source.actualMarkerBrush();
		this._initialMarkerRenderOutline = source.actualMarkerOutline();
		this._initialMarkerRenderOpacity = 1;
		this._actualMarkerRenderFill = this._initialMarkerRenderFill;
		this._actualMarkerRenderOutline = this._initialMarkerRenderOutline;
		this._actualMarkerRenderOpacity = this._initialMarkerRenderOpacity;
		var areMarkerStylesOverriden = shouldOverrideMarkerStyle;
		this.categoryMarkerOverrideArgs(null);
		if (areMarkerStylesOverriden) {
			this.categoryMarkerOverrideArgs(new $.ig.AssigningCategoryMarkerStyleEventArgs());
			this.categoryMarkerOverrideArgs().maxAllSeriesHighlightingProgress(0);
			this.categoryMarkerOverrideArgs().sumAllSeriesHighlightingProgress(0);
			if (source.seriesViewer() != null) {
				this.categoryMarkerOverrideArgs().maxAllSeriesHighlightingProgress(source.seriesViewer().highlightingManager().maxMarkerHighlightingProgress());
				this.categoryMarkerOverrideArgs().sumAllSeriesHighlightingProgress(source.seriesViewer().highlightingManager().sumMarkerHighlightingProgress());
			}

			this.categoryMarkerOverrideArgs().getItems(getItems);
		}

	}

	, 
	initCategoryRenderSettings: function (source, shouldOverrideCategoryStyle, categoryAxis, getItems, size, first) {
		this._bucketSize = size;
		this._firstBucket = first;
		this._actualNegativeShape = false;
		this._initialRenderFill = source.actualBrush();
		this._initialRenderOutline = source.actualOutline();
		this._initialRenderThickness = source.thickness();
		this._initialRenderDashArray = source.dashArray();
		this._initialRenderDashCap = source.dashCap();
		this._initialRenderRadiusX = 0;
		this._initialRenderRadiusY = 0;
		this._initialRenderOpacity = 1;
		this._initialRenderMiterLimit = source.miterLimit();
		this._initialRenderStartCap = source.startCap();
		this._initialRenderEndCap = source.endCap();
		this._actualRenderFill = this._initialRenderFill;
		this._actualRenderOutline = this._initialRenderOutline;
		this._actualRenderThickness = this._initialRenderThickness;
		this._actualRenderDashArray = this._initialRenderDashArray;
		this._actualRenderDashCap = this._initialRenderDashCap;
		this._actualRenderRadiusX = this._initialRenderRadiusX;
		this._actualRenderRadiusY = this._initialRenderRadiusY;
		this._actualRenderOpacity = this._initialRenderOpacity;
		this._actualRenderMiterLimit = this._initialRenderMiterLimit;
		this._actualRenderStartCap = this._initialRenderStartCap;
		this._actualRenderEndCap = this._initialRenderEndCap;
		this._actualRenderCategoryAxis = categoryAxis;
		var areStylesOverriden = shouldOverrideCategoryStyle;
		this.categoryOverrideArgs(null);
		if (areStylesOverriden) {
			this.categoryOverrideArgs(new $.ig.AssigningCategoryStyleEventArgs());
			this.categoryOverrideArgs().maxAllSeriesHighlightingProgress(0);
			this.categoryOverrideArgs().sumAllSeriesHighlightingProgress(0);
			if (source.seriesViewer() != null) {
				this.categoryOverrideArgs().maxAllSeriesHighlightingProgress(source.seriesViewer().highlightingManager().maxHighlightingProgress());
				this.categoryOverrideArgs().sumAllSeriesHighlightingProgress(source.seriesViewer().highlightingManager().sumHighlightingProgress());
			}

			this.categoryOverrideArgs().getItems(getItems);
		}

	}

	, 
	setCategoryShapeAppearance: function (shape, strokeOnly, fillOnly, extended, useOutline) {
		var main = this._actualRenderFill;
		if (useOutline) {
			main = this._actualRenderOutline;
		}

		if (fillOnly) {
			shape.__fill = main;

		} else {
			if (strokeOnly) {
				shape.__stroke = main;

			} else {
				shape.__fill = main;
				shape.__stroke = this._actualRenderOutline;
			}

			shape.strokeThickness(this._actualRenderThickness);
			shape.strokeDashArray(this._actualRenderDashArray);
			shape.strokeDashCap(this._actualRenderDashCap);
			if (extended) {
			}

		}

		shape.__opacity = this._actualRenderOpacity;
	}

	, 
	setCategoryMarkerAppearance: function (marker, context) {
		marker.__opacity = this._actualMarkerRenderOpacity;
		context.itemBrush(this._actualMarkerRenderFill);
		context.actualItemBrush(context.itemBrush());
		context.outline(this._actualMarkerRenderOutline);
		context.thickness(0.5);
	}

	, 
	getBucketBounds: function (count, bucket) {
		var size = this._bucketSize;
		var i0 = Math.min(bucket * size, count - 1);
		var i1 = Math.min(i0 + size - 1, count - 1);
		var ret = new Array(2);
		ret[0] = Math.min(i0 + this._firstBucket * size, count - 1);
		ret[1] = Math.min(i1 + this._firstBucket * size, count - 1);
		return ret;
	}

	, 
	applyHighlightingStyle: function (info) {
		if (info == null) {
			return;
		}

		var additionalBrightness = info.progress();
		additionalBrightness = additionalBrightness * 0.5;
		this._actualRenderFill = this.getBrightenedBrush(this._actualRenderFill, additionalBrightness);
		this._actualRenderOutline = this.getBrightenedBrush(this._actualRenderOutline, additionalBrightness);
	}

	, 
	getBrightenedBrush: function (brush, additionalBrightness) {
		if (brush == null) {
			return brush;
		}

		return $.ig.BrushUtil.prototype.getLightened(brush, additionalBrightness);
	}

	, 
	applyMarkerHighlightingStyle: function (info) {
		if (info == null) {
			return;
		}

		var additionalBrightness = info.progress();
		additionalBrightness = additionalBrightness * 0.5;
		this._actualMarkerRenderFill = this.getBrightenedBrush(this._actualMarkerRenderFill, additionalBrightness);
		this._actualMarkerRenderOutline = this.getBrightenedBrush(this._actualMarkerRenderOutline, additionalBrightness);
	}

	, 
	populateArgsBounds: function (args, isSorting, buckets, currentIndex, valueCount, categoryAxis, axisParams, isThumbnail, isMarker) {
		if (currentIndex == -1) {
			if (isSorting) {
				args.hasDateRange(true);
				args.startDate((categoryAxis).actualMinimumValue());
				args.endDate((categoryAxis).actualMaximumValue());

			} else {
				args.hasDateRange(false);
				args.startIndex(0);
				args.endIndex(valueCount - 1);
			}


		} else {
			if (isSorting) {
				var longStart_ = $.ig.truncate(categoryAxis.getUnscaledValue(buckets.__inner[currentIndex][0], axisParams));
				var longEnd_ = longStart_;
				if (currentIndex + 1 < buckets.count()) {
					longEnd_ = $.ig.truncate(categoryAxis.getUnscaledValue(buckets.__inner[currentIndex + 1][0], axisParams));
				}

				args.hasDateRange(true);
				args.startDate(new Date(longStart_));
				args.endDate(new Date(longEnd_));
				if (categoryAxis.isInverted()) {
					var swap = args.endDate();
					args.endDate(args.startDate());
					args.startDate(swap);
				}

				if (isMarker) {
					args.startIndex(currentIndex);
					args.endIndex(currentIndex);

				} else {
					var bounds = this.getBucketBounds(valueCount, currentIndex);
					args.startIndex(bounds[0]);
					args.endIndex(bounds[1]);
				}


			} else {
				if (isMarker) {
					args.startIndex(currentIndex);
					args.endIndex(currentIndex);

				} else {
					var bounds1 = this.getBucketBounds(valueCount, currentIndex);
					args.hasDateRange(false);
					args.startIndex(bounds1[0]);
					args.endIndex(bounds1[1]);
				}

			}

		}

	}

	, 
	prePerformCategoryStyleOverride: function (buckets, currentIndex, valueCount, categoryAxis, axisParams, isThumbnail, isHighlightingEnabled) {
		this._actualRenderFill = this._initialRenderFill;
		this._actualRenderOutline = this._initialRenderOutline;
		this._actualRenderThickness = this._initialRenderThickness;
		this._actualRenderDashArray = this._initialRenderDashArray;
		this._actualRenderDashCap = this._initialRenderDashCap;
		this._actualRenderRadiusX = this._initialRenderRadiusX;
		this._actualRenderRadiusY = this._initialRenderRadiusY;
		this._actualRenderOpacity = this._initialRenderOpacity;
		var args = this.categoryOverrideArgs();
		var isSorting = categoryAxis.isSorting();
		this.populateArgsBounds(args, isSorting, buckets, currentIndex, valueCount, categoryAxis, axisParams, isThumbnail, false);
		args.fill(this._actualRenderFill);
		args.stroke(this._actualRenderOutline);
		args.strokeThickness(this._actualRenderThickness);
		args.strokeDashArray(this._actualRenderDashArray);
		args.strokeDashCap(this._actualRenderDashCap);
		args.radiusX(this._actualRenderRadiusX);
		args.radiusY(this._actualRenderRadiusY);
		args.opacity(this._actualRenderOpacity);
		args.isNegativeShape(this._actualNegativeShape);
		args.highlightingHandled(false);
	}

	, 
	postPerformCategoryStyleOverride: function (info, isThumbnail, isHighlightingEnabled) {
		var args = this.categoryOverrideArgs();
		this._actualRenderFill = args.fill();
		this._actualRenderOutline = args.stroke();
		this._actualRenderThickness = args.strokeThickness();
		this._actualRenderDashArray = args.strokeDashArray();
		this._actualRenderDashCap = args.strokeDashCap();
		this._actualRenderRadiusX = args.radiusX();
		this._actualRenderRadiusY = args.radiusY();
		this._actualRenderOpacity = args.opacity();
		if (isHighlightingEnabled && !args.highlightingHandled() && !isThumbnail) {
			this.applyHighlightingStyle(info);
		}

	}

	, 
	prePerformCategoryMarkerStyleOverride: function (buckets, currentIndex, valueCount, categoryAxis, axisParams, isThumbnail, isHighlightingEnabled) {
		this._actualMarkerRenderFill = this._initialMarkerRenderFill;
		this._actualMarkerRenderOutline = this._initialMarkerRenderOutline;
		this._actualMarkerRenderOpacity = this._initialMarkerRenderOpacity;
		var args = this.categoryMarkerOverrideArgs();
		var isSorting = categoryAxis.isSorting();
		this.populateArgsBounds(args, isSorting, buckets, currentIndex, valueCount, categoryAxis, axisParams, isThumbnail, true);
		args.fill(this._actualMarkerRenderFill);
		args.stroke(this._actualMarkerRenderOutline);
		args.opacity(this._actualMarkerRenderOpacity);
		args.isNegativeShape(this._actualNegativeMarkerShape);
		args.highlightingHandled(false);
	}

	, 
	postPerformCategoryMarkerStyleOverride: function (info, isThumbnail, isHighlightingEnabled) {
		var args = this.categoryMarkerOverrideArgs();
		this._actualMarkerRenderFill = args.fill();
		this._actualMarkerRenderOutline = args.stroke();
		this._actualMarkerRenderOpacity = args.opacity();
		if (isHighlightingEnabled && !args.highlightingHandled() && !isThumbnail) {
			this.applyMarkerHighlightingStyle(info);
		}

	}
	, 
	$type: new $.ig.Type('CategorySeriesRenderManager', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('ColumnSeries', 'HorizontalAnchoredCategorySeries', {

	createView: function () {
		return new $.ig.ColumnSeriesView(this);
	}

	, 
	_columnView: null,
	columnView: function (value) {
		if (arguments.length === 1) {
			this._columnView = value;
			return value;
		} else {
			return this._columnView;
		}
	}

	, 
	onViewCreated: function (view) {
		$.ig.HorizontalAnchoredCategorySeries.prototype.onViewCreated.call(this, view);
		this.columnView(view);
	}

	, 
	getDefaultTransitionInMode: function () {
		return $.ig.CategoryTransitionInMode.prototype.fromZero;
	}
	, 
	init: function () {



		$.ig.HorizontalAnchoredCategorySeries.prototype.init.call(this);
			this.defaultStyleKey($.ig.ColumnSeries.prototype.$type);
	}

	, 
	radiusX: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.ColumnSeries.prototype.radiusXProperty, value);
			return value;
		} else {

			return this.getValue($.ig.ColumnSeries.prototype.radiusXProperty);
		}
	}

	, 
	radiusY: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.ColumnSeries.prototype.radiusYProperty, value);
			return value;
		} else {

			return this.getValue($.ig.ColumnSeries.prototype.radiusYProperty);
		}
	}

	, 
	hasIndividualElements: function () {

			return true;
	}

	, 
	preferredCategoryMode: function (axis) {
		return $.ig.CategoryMode.prototype.mode2;
	}

	, 
	clearRendering: function (wipeClean, view) {
		$.ig.HorizontalAnchoredCategorySeries.prototype.clearRendering.call(this, wipeClean, view);
		var columnView = view;
		if (wipeClean && columnView.columns() != null) {
			columnView.columns().count(0);
		}

	}

	, 
	renderFrame: function (frame, view) {
		$.ig.HorizontalAnchoredCategorySeries.prototype.renderFrame.call(this, frame, view);
		var buckets = frame._buckets;
		if (!view.ready()) {
			return;
		}

		var windowRect = view.windowRect();
		var viewportRect = view.viewport();
		var yParams = new $.ig.ScalerParams(windowRect, viewportRect, this.cachedYAxis().isInverted());
		var xParams = new $.ig.ScalerParams(windowRect, viewportRect, this.cachedXAxis().isInverted());
		var yscale = this.cachedYAxis();
		var zero = yscale.getScaledValue(yscale.referenceValue(), yParams);
		var groupWidth = this.cachedXAxis().getGroupSize(windowRect, viewportRect);
		var xAxis = this.cachedXAxis();
		var columnView = view;
		if ($.ig.util.isNaN(groupWidth) || Number.isInfinity(groupWidth)) {
			columnView.columns().count(0);
			return;
		}

		this._renderManager.initCategoryRenderSettings(this, this.shouldOverrideCategoryStyle(), this.cachedXAxis(), this.getCategoryItems.runOn(this), this.getBucketSize(view), this.getFirstBucket(view));
		this._renderManager._initialRenderRadiusX = this.radiusX();
		this._renderManager._initialRenderRadiusY = this.radiusY();
		this._renderManager._actualRenderRadiusX = this.radiusX();
		this._renderManager._actualRenderRadiusY = this.radiusY();
		var areStylesOverriden = false;
		var args = this._renderManager.categoryOverrideArgs();
		if (args != null) {
			areStylesOverriden = true;
		}

		var isSorting = this.cachedXAxis().isSorting();
		var valueCount = this.valueColumn().count();
		for (var i = 0; i < buckets.count(); ++i) {
			var left = buckets.__inner[i][0] - 0.5 * groupWidth;
			var top = buckets.__inner[i][1];
			var bottom = zero;
			top = Math.max(top, -100);
			bottom = Math.min(bottom, viewportRect.bottom() + 100);
			var column = columnView.columns().item(i);
			column.width(groupWidth);
			column.height(Math.abs(bottom - top));
			if (areStylesOverriden) {
				this.performCategoryStyleOverride(buckets, i, valueCount, xAxis, xParams, view.isThumbnailView());
			}

			this._renderManager.setCategoryShapeAppearance(column, false, false, false, false);
			column.radiusX(this._renderManager._actualRenderRadiusX);
			column.radiusY(this._renderManager._actualRenderRadiusY);
			columnView.positionRectangle(column, left, Math.min(bottom, top));
		}

		columnView.columns().count(buckets.count());
		view.updateFrameVersion(frame);
	}
	, 
	$type: new $.ig.Type('ColumnSeries', $.ig.HorizontalAnchoredCategorySeries.prototype.$type)
}, true);

$.ig.util.defType('ColumnSeriesView', 'AnchoredCategorySeriesView', {

	onInit: function () {
		var $self = this;
		$.ig.AnchoredCategorySeriesView.prototype.onInit.call($self);
		$self.visibleColumns(new $.ig.List$1($.ig.Rectangle.prototype.$type, 0));
		if (!$self.isThumbnailView()) {
			$self.model().resolution(4);
			$self.model().legendItemBadgeTemplate((function () { var $ret = new $.ig.DataTemplate();
			$ret.render($.ig.LegendTemplates.prototype.rectBadgeTemplate);
			$ret.measure($.ig.LegendTemplates.prototype.legendItemBadgeMeasure); return $ret;}()));
		}

	}

	, 
	_columnModel: null,
	columnModel: function (value) {
		if (arguments.length === 1) {
			this._columnModel = value;
			return value;
		} else {
			return this._columnModel;
		}
	}
	, 
	init: function (model) {


		this.__hitItem = new $.ig.Rectangle();

		var $self = this;
		$.ig.AnchoredCategorySeriesView.prototype.init.call(this, model);
			this.columnModel(model);
			this.columns((function () { var $ret = new $.ig.Pool$1($.ig.Rectangle.prototype.$type);
			$ret.create($self.columnCreate.runOn($self));
			$ret.activate($self.columnActivate.runOn($self));
			$ret.disactivate($self.columnDisactivate.runOn($self));
			$ret.destroy($self.columnDestroy.runOn($self)); return $ret;}()));
	}

	, 
	columnCreate: function () {
		var column = new $.ig.Rectangle();
		this.visibleColumns().add(column);
		column.__visibility = $.ig.Visibility.prototype.collapsed;
		return column;
	}

	, 
	_visibleColumns: null,
	visibleColumns: function (value) {
		if (arguments.length === 1) {
			this._visibleColumns = value;
			return value;
		} else {
			return this._visibleColumns;
		}
	}

	, 
	columnActivate: function (column) {
		column.__visibility = $.ig.Visibility.prototype.visible;
	}

	, 
	columnDisactivate: function (column) {
		column.__visibility = $.ig.Visibility.prototype.collapsed;
	}

	, 
	columnDestroy: function (column) {
		this.visibleColumns().remove(column);
	}

	, 
	positionRectangle: function (column, left, top) {
		if (!this.isDirty()) {
			this.makeDirty();
		}

		column.canvasTop(top);
		column.canvasLeft(left);
	}

	, 
	getItem: function (index) {
		return this.visibleColumns().__inner[index];
	}
	, 
	__hitItem: null

	, 
	getHitItem: function (index) {
		var item = this.visibleColumns().__inner[index];
		this.__hitItem.__visibility = item.__visibility;
		this.__hitItem.canvasLeft(item.canvasLeft());
		this.__hitItem.canvasTop(item.canvasTop());
		this.__hitItem.width(item.width());
		this.__hitItem.height(item.height());
		var hitBrush = this.getHitBrush1(index);
		this.__hitItem.__fill = hitBrush;
		this.__hitItem.__stroke = hitBrush;
		this.__hitItem.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
		return this.__hitItem;
	}

	, 
	renderOverride: function (context, isHitContext) {
		$.ig.AnchoredCategorySeriesView.prototype.renderOverride.call(this, context, isHitContext);
		var doGradients = false;
		if (context.shouldRender()) {
			for (var i = 0; i < this.visibleColumns().count(); i++) {
				var column = this.getCurrentItem(i, isHitContext);
				this.setupItemAppearance(column, i, isHitContext);
				context.renderRectangle(column);
			}

		}

	}

	, 
	_columns: null,
	columns: function (value) {
		if (arguments.length === 1) {
			this._columns = value;
			return value;
		} else {
			return this._columns;
		}
	}

	, 
	exportViewShapes: function (svd) {
		var $self = this;
		$.ig.AnchoredCategorySeriesView.prototype.exportViewShapes.call($self, svd);
		var i = 0;
		var toSort = new $.ig.List$1($.ig.Rectangle.prototype.$type, 0);
		var en = $self.columns().active().getEnumerator();
		while (en.moveNext()) {
			var column = en.current();
			toSort.add(column);
		}

		toSort.sort2(function (c1, c2) {
			if (c1.canvasLeft() < c2.canvasLeft()) {
				return -1;

			} else if (c1.canvasLeft() > c2.canvasLeft()) {
				return 1;

			} else {
				return 0;
			}


		});
		var en1 = toSort.getEnumerator();
		while (en1.moveNext()) {
			var column1 = en1.current();
			var rvd = new $.ig.RectangleVisualData(1, "column" + i, column1);
			rvd.tags().add("Main");
			rvd.tags().add("Fill");
			svd.shapes().add(rvd);
		}

		i++;
	}
	, 
	$type: new $.ig.Type('ColumnSeriesView', $.ig.AnchoredCategorySeriesView.prototype.$type)
}, true);

$.ig.util.defType('DefaultSupportsMarkers', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	shouldDisplayMarkers: function () {

			return false;
	}

	, 
	updateMarkerCount: function (markerCount) {
	}

	, 
	updateMarkerTemplate: function (markerCount, itemIndex, markerBucket) {
	}
	, 
	$type: new $.ig.Type('DefaultSupportsMarkers', $.ig.Object.prototype.$type, [$.ig.ISupportsMarkers.prototype.$type])
}, true);

$.ig.util.defType('DefaultProvidesViewport', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	getViewInfo: function (viewportRect, windowRect) {
		viewportRect = $.ig.Rect.prototype.empty();
		windowRect = $.ig.Rect.prototype.empty();
		return {
			p0: viewportRect, 
			p1: windowRect
		};
	}
	, 
	$type: new $.ig.Type('DefaultProvidesViewport', $.ig.Object.prototype.$type, [$.ig.IProvidesViewport.prototype.$type])
}, true);

$.ig.util.defType('DefaultSupportsErrorBars', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	xAxis: function () {

			return null;
	}

	, 
	yAxis: function () {

			return null;
	}
	, 
	$type: new $.ig.Type('DefaultSupportsErrorBars', $.ig.Object.prototype.$type, [$.ig.ISupportsErrorBars.prototype.$type])
}, true);

$.ig.util.defType('LineSeries', 'HorizontalAnchoredCategorySeries', {

	createView: function () {
		return new $.ig.LineSeriesView(this);
	}

	, 
	_lineView: null,
	lineView: function (value) {
		if (arguments.length === 1) {
			this._lineView = value;
			return value;
		} else {
			return this._lineView;
		}
	}

	, 
	onViewCreated: function (view) {
		$.ig.HorizontalAnchoredCategorySeries.prototype.onViewCreated.call(this, view);
		this.lineView(view);
	}
	, 
	init: function () {



		$.ig.HorizontalAnchoredCategorySeries.prototype.init.call(this);
			this.defaultStyleKey($.ig.LineSeries.prototype.$type);
	}

	, 
	preferredCategoryMode: function (axis) {
		return $.ig.CategoryMode.prototype.mode0;
	}

	, 
	clearRendering: function (wipeClean, view) {
		$.ig.HorizontalAnchoredCategorySeries.prototype.clearRendering.call(this, wipeClean, view);
		var lineView = view;
		lineView.clearLine();
	}

	, 
	renderFrame: function (frame, view) {
		$.ig.HorizontalAnchoredCategorySeries.prototype.renderFrame.call(this, frame, view);
		var bucketSize = view.bucketCalculator()._bucketSize;
		var lineView = $.ig.util.cast($.ig.LineSeriesView.prototype.$type, view);
		var buckets = frame._buckets;
		this._renderManager.initCategoryRenderSettings(this, this.shouldOverrideCategoryStyle(), this.cachedXAxis(), this.getCategoryItems.runOn(this), this.getBucketSize(view), this.getFirstBucket(view));
		var areStylesOverriden = false;
		var args = this._renderManager.categoryOverrideArgs();
		if (args != null) {
			areStylesOverriden = true;
		}

		if (areStylesOverriden) {
			var xParams = new $.ig.ScalerParams(view.windowRect(), view.viewport(), this.cachedXAxis().isInverted());
			this.performCategoryStyleOverride(buckets, -1, this.valueColumn().count(), this.cachedXAxis(), xParams, view.isThumbnailView());
		}

		var line0 = lineView.line0();
		var line1 = lineView.line1();
		var fillArea = lineView.fillArea();
		this._renderManager.setCategoryShapeAppearance(line0, true, false, true, false);
		this._renderManager.setCategoryShapeAppearance(line1, true, false, true, false);
		this._renderManager.setCategoryShapeAppearance(fillArea, false, true, false, false);
		fillArea.__opacity = 0.75 * this._renderManager._actualRenderOpacity;
		if (view.checkFrameDirty(frame)) {
			lineView.rasterizeLine(buckets.count(), buckets, true, this.unknownValuePlotting(), this.getLineClipper(buckets, buckets.count() - 1, view.viewport(), view.windowRect()), bucketSize, this.resolution());
			view.updateFrameVersion(frame);
		}

	}

	, 
	unknownValuePlotting: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.LineSeries.prototype.unknownValuePlottingProperty, $.ig.UnknownValuePlotting.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.LineSeries.prototype.unknownValuePlottingProperty));
		}
	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		$.ig.HorizontalAnchoredCategorySeries.prototype.propertyUpdatedOverride.call(this, sender, propertyName, oldValue, newValue);
		switch (propertyName) {
			case $.ig.LineSeries.prototype._unknownValuePlottingPropertyName:
				this.framePreparer().skipUnknowns(this.unknownValuePlotting() == $.ig.UnknownValuePlotting.prototype.linearInterpolate);
				this.renderSeries(false);
				this.notifyThumbnailAppearanceChanged();
				break;
		}

	}
	, 
	$type: new $.ig.Type('LineSeries', $.ig.HorizontalAnchoredCategorySeries.prototype.$type)
}, true);

$.ig.util.defType('LineSeriesView', 'AnchoredCategorySeriesView', {

	_lineModel: null,
	lineModel: function (value) {
		if (arguments.length === 1) {
			this._lineModel = value;
			return value;
		} else {
			return this._lineModel;
		}
	}
	, 
	init: function (model) {


		this._polyline0 = new $.ig.Path();
		this._polygon01 = new $.ig.Path();
		this._polyline1 = new $.ig.Path();
		this.__hitPolyline1 = new $.ig.Path();
		this.__hitPolyline0 = new $.ig.Path();
		this.__hitPolygon01 = new $.ig.Path();

		$.ig.AnchoredCategorySeriesView.prototype.init.call(this, model);
			this.lineModel(model);
	}
	, 
	_polyline0: null
	, 
	_polygon01: null
	, 
	_polyline1: null

	, 
	line0: function () {

			return this._polyline0;
	}

	, 
	line1: function () {

			return this._polyline1;
	}

	, 
	fillArea: function () {

			return this._polygon01;
	}

	, 
	clearLine: function () {
		this._polygon01.data(null);
		this._polyline0.data(null);
		this._polyline1.data(null);
		this.makeDirty();
	}

	, 
	rasterizeLine: function (bucketCount, buckets, useX0AsX1, unknownValuePlotting, clipper, bucketSize, resolution) {
		this.lineModel().lineRasterizer().isSortingAxis($.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.categoryModel().getXAxis()) !== null ? true : false);
		this.lineModel().lineRasterizer().rasterizePolylinePaths(this._polyline0, this._polygon01, this._polyline1, bucketCount, buckets, useX0AsX1, unknownValuePlotting, clipper, bucketSize, resolution);
		this.makeDirty();
	}

	, 
	setupAppearanceOverride: function () {
		$.ig.AnchoredCategorySeriesView.prototype.setupAppearanceOverride.call(this);
	}
	, 
	__hitPolyline1: null
	, 
	__hitPolyline0: null
	, 
	__hitPolygon01: null

	, 
	setupHitAppearanceOverride: function () {
		$.ig.AnchoredCategorySeriesView.prototype.setupHitAppearanceOverride.call(this);
		this.__hitPolyline0.data(this._polyline0.data());
		this.__hitPolyline1.data(this._polyline1.data());
		this.__hitPolygon01.data(this._polygon01.data());
		var hitBrush = this.getHitBrush();
		this.__hitPolyline0.__stroke = hitBrush;
		this.__hitPolyline0.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
		this.__hitPolyline1.__stroke = hitBrush;
		this.__hitPolyline1.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
		this.__hitPolygon01.__fill = hitBrush;
		this.__hitPolygon01.__opacity = 1;
	}

	, 
	renderOverride: function (context, isHitContext) {
		$.ig.AnchoredCategorySeriesView.prototype.renderOverride.call(this, context, isHitContext);
		if (context.shouldRender()) {
			if (isHitContext) {
				context.renderPath(this.__hitPolygon01);
				context.renderPath(this.__hitPolyline0);
				context.renderPath(this.__hitPolyline1);

			} else {
				context.renderPath(this._polygon01);
				context.renderPath(this._polyline0);
				context.renderPath(this._polyline1);
			}

		}

	}

	, 
	exportViewShapes: function (svd) {
		$.ig.AnchoredCategorySeriesView.prototype.exportViewShapes.call(this, svd);
		var lowerShape = new $.ig.PathVisualData(1, "lowerShape", this._polyline0);
		lowerShape.tags().add("Lower");
		lowerShape.tags().add("Main");
		var upperShape = new $.ig.PathVisualData(1, "upperShape", this._polyline1);
		upperShape.tags().add("Upper");
		var translucent = new $.ig.PathVisualData(1, "translucentShape", this._polygon01);
		translucent.tags().add("Translucent");
		svd.shapes().add(lowerShape);
		svd.shapes().add(upperShape);
		svd.shapes().add(translucent);
	}

	, 
	applyDropShadowDefaultSettings: function () {
		var color = new $.ig.Color();
		color.colorString("rgba(95,95,95,0.5)");
		this.model().shadowColor(color);
		this.model().shadowBlur(3);
		this.model().shadowOffsetX(1);
		this.model().shadowOffsetY(4);
		this.model().useSingleShadow(false);
	}
	, 
	$type: new $.ig.Type('LineSeriesView', $.ig.AnchoredCategorySeriesView.prototype.$type)
}, true);

$.ig.util.defType('SplineSeriesBase', 'HorizontalAnchoredCategorySeries', {
	init: function () {


		$.ig.HorizontalAnchoredCategorySeries.prototype.init.call(this);

	}
	, 
	createView: function () {
		return new $.ig.SplineSeriesBaseView(this);
	}

	, 
	onViewCreated: function (view) {
		$.ig.HorizontalAnchoredCategorySeries.prototype.onViewCreated.call(this, view);
		this.splineBaseView(view);
	}

	, 
	_splineBaseView: null,
	splineBaseView: function (value) {
		if (arguments.length === 1) {
			this._splineBaseView = value;
			return value;
		} else {
			return this._splineBaseView;
		}
	}

	, 
	_uColumn: null,
	uColumn: function (value) {
		if (arguments.length === 1) {
			this._uColumn = value;
			return value;
		} else {
			return this._uColumn;
		}
	}

	, 
	convertToSingle: function (value) {
		return value;
	}

	, 
	prepareDateTimeFrame: function (frame, windowRect, viewportRect, xaxis, yaxis, view) {
		var $self = this;
		var sortingXAxis = $.ig.util.cast($.ig.ISortingAxis.prototype.$type, xaxis);
		if (sortingXAxis == null) {
			return;
		}

		var xParams = new $.ig.ScalerParams(windowRect, viewportRect, xaxis.isInverted());
		var yParams = new $.ig.ScalerParams(windowRect, viewportRect, yaxis.isInverted());
		var markers = $self.shouldDisplayMarkers();
		var markerCount = 0;
		var offset = $self.getOffset(xaxis, windowRect, viewportRect);
		var xv = function (i) { return i; };
		var yv = function (i) { return $self.valueColumn().item(sortingXAxis.sortedIndices().__inner[i]); };
		var lastBucket = $self.categoryView().bucketCalculator()._lastBucket;
		var firstBucket = $self.categoryView().bucketCalculator()._firstBucket;
		var n = $.ig.truncate(Math.ceil(viewportRect.width() / (lastBucket - firstBucket)));
		var collisionAvoider = new $.ig.CollisionAvoider();
		var bucketSize = $self.categoryView().bucketCalculator()._bucketSize;
		if (bucketSize <= 0 || (firstBucket <= 0 && lastBucket <= 0)) {
			$self.categoryView().markers().count(markerCount);
			return;
		}

		var bucketCount = 0;
		var markerBucket = 0;
		for (var i = firstBucket; i < lastBucket + 1; ++i) {
			var bucket = null;
			var itemIndex = i * bucketSize;
			if (sortingXAxis != null && sortingXAxis.sortedIndices() != null && itemIndex >= 0 && itemIndex < sortingXAxis.sortedIndices().count()) {
				itemIndex = sortingXAxis.sortedIndices().__inner[itemIndex];
			}

			if (i >= ($self.valueColumn().count() - 1)) {
				if (markers && $self.prepareMarker(frame, $.ig.Enumerable.prototype.last$1($.ig.Array.prototype.$type, frame._buckets), collisionAvoider, Math.min(itemIndex, $self.fastItemsSource().count() - 1), markerCount, view, bucketCount - 1)) {
					++markerCount;
				}

				break;
			}

			var x1 = xv(i);
			var y1 = yv(i);
			var x2 = xv(i + 1);
			var y2 = yv(i + 1);
			var h = x2 - x1;
			var u1 = $self.uColumn()[i];
			var u2 = $self.uColumn()[i + 1];
			var unscaledValue = sortingXAxis.getUnscaledValueAt(sortingXAxis.sortedIndices().__inner[i]);
			var firstPointX = xaxis.getScaledValue(unscaledValue, xParams) + offset;
			var firstPointY = yaxis.getScaledValue(y1, yParams);
			frame._buckets.add((function () { var $ret = new Array();
			$ret.add(firstPointX);
			$ret.add(firstPointY);
			$ret.add(firstPointY);return $ret;}()));
			bucketCount++;
			markerBucket = bucketCount;
			for (var j = 1; j < n; ++j) {
				var pp = (j) / (n);
				var x = x1 + h * pp;
				var a = (x2 - x) / h;
				var b = (x - x1) / h;
				var y = a * y1 + b * y2 + ((a * a * a - a) * u1 + (b * b * b - b) * u2) * (h * h) / 6;
				var unscaledValueFirst = sortingXAxis.getUnscaledValueAt(sortingXAxis.sortedIndices().__inner[i]);
				var unscaledValueNext = sortingXAxis.getUnscaledValueAt(sortingXAxis.sortedIndices().__inner[i + 1]);
				var currentUnscaledValue = unscaledValueFirst + (unscaledValueNext - unscaledValueFirst) * pp;
				x = xaxis.getScaledValue(currentUnscaledValue, xParams) + offset;
				y = yaxis.getScaledValue(y, yParams);
				frame._buckets.add((function () { var $ret = new Array();
				$ret.add(x);
				$ret.add(y);
				$ret.add(y);return $ret;}()));
				bucketCount++;
			}

			if (markers) {
				bucket = (function () { var $ret = new Array();
				$ret.add(firstPointX);
				$ret.add(firstPointY);
				$ret.add(firstPointY);return $ret;}());
			}

			if (markers && $self.prepareMarker(frame, bucket, collisionAvoider, Math.min(itemIndex, $self.fastItemsSource().count() - 1), markerCount, view, markerBucket - 1)) {
				++markerCount;
			}

		}

		$self.categoryView().markers().count(markerCount);
	}

	, 
	prepareMarker: function (frame, bucket, collisionAvoider, itemIndex, markerCount, view, bucketIndex) {
		var x = bucket[0];
		var y = bucket[1];
		var markerRect = new $.ig.Rect(0, x - 5, y - 5, 11, 11);
		if (!$.ig.util.isNaN(x) && !$.ig.util.isNaN(y) && collisionAvoider.tryAdd(markerRect)) {
			frame._markers.add({__x: x, __y: y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			var marker = view.markers().item(markerCount);
			($.ig.util.cast($.ig.DataContext.prototype.$type, marker.content())).item(this.fastItemsSource().item(itemIndex));
			marker.markerBucket(bucketIndex);
			return true;
		}

		return false;
	}

	, 
	prepareFrame: function (frame, view) {
		var $self = this;
		$.ig.HorizontalAnchoredCategorySeries.prototype.prepareFrame.call($self, frame, view);
		if (frame._buckets.count() <= 1) {
			return;
		}

		if (view.bucketCalculator()._bucketSize == 0) {
			return;
		}

		var windowRect = view.windowRect();
		var viewportRect = view.viewport();
		var xaxis = $self.cachedXAxis();
		var yaxis = $self.cachedYAxis();
		var xParams = new $.ig.ScalerParams(windowRect, viewportRect, xaxis.isInverted());
		var yParams = new $.ig.ScalerParams(windowRect, viewportRect, yaxis.isInverted());
		frame._buckets.clear();
		frame._markers.clear();
		var markers = $self.shouldDisplayMarkers();
		var markerCount = 0;
		var sortingXAxis = $.ig.util.cast($.ig.ISortingAxis.prototype.$type, $self.cachedXAxis());
		if (sortingXAxis != null && sortingXAxis.sortedIndices().count() != $self.fastItemsSource().count()) {
			return;
		}

		var offset = $self.getOffset(xaxis, windowRect, viewportRect);
		var xv = function (i) { return i; };
		var yv = function (i) { return $self.valueColumn().item(i); };
		var bucketSize = view.bucketCalculator()._bucketSize;
		if (($self.uColumn() == null || $self.uColumn().length != $self.valueColumn().count()) && bucketSize == 1) {
			var endPointsFirstDerivative = $self.splineType() == $.ig.SplineType.prototype.natural ? NaN : 0;
			if ($self.cachedXAxis() != null && $.ig.util.cast($.ig.ISortingAxis.prototype.$type, $self.cachedXAxis()) !== null && ($.ig.util.cast($.ig.ISortingAxis.prototype.$type, $self.cachedXAxis())).sortedIndices() != null) {
				var sorted = new $.ig.SafeSortedReadOnlyDoubleCollection($self.valueColumn(), ($.ig.util.cast($.ig.ISortingAxis.prototype.$type, $self.cachedXAxis())).sortedIndices());
				yv = function (i) { return sorted.item(i); };
			}

			$self.uColumn($.ig.Numeric.prototype.safeCubicSplineFit($self.valueColumn().count(), xv, yv, endPointsFirstDerivative, endPointsFirstDerivative));
		}

		var lastBucket = view.bucketCalculator()._lastBucket;
		var firstBucket = view.bucketCalculator()._firstBucket;
		var n = $.ig.truncate(Math.ceil(viewportRect.width() / (lastBucket - firstBucket)));
		var collisionAvoider = new $.ig.CollisionAvoider();
		if (sortingXAxis != null) {
			$self.prepareDateTimeFrame(frame, windowRect, viewportRect, xaxis, yaxis, view);
			return;
		}

		var anchoredView = view;
		anchoredView.cacheValues();
		var bucketCount = 0;
		var markerBucket = 0;
		for (var i = firstBucket; i <= lastBucket; ++i) {
			var bucket = null;
			if (bucketSize == 1) {
				if (i >= ($self.valueColumn().count() - 1)) {
					if (markers && $self.prepareMarker(frame, frame._buckets.__inner[frame._buckets.count() - 1], collisionAvoider, Math.min(i * bucketSize, $self.fastItemsSource().count() - 1), markerCount, view, bucketCount - 1)) {
						++markerCount;
					}

					break;
				}

				var x1 = xv(i);
				var y1 = yv(i);
				var x2 = xv(i + 1);
				var y2 = yv(i + 1);
				var h = x2 - x1;
				var u1 = $self.uColumn()[i];
				var u2 = $self.uColumn()[i + 1];
				var firstPointX = xaxis.getScaledValue(x1, xParams) + offset;
				var firstPointY = yaxis.getScaledValue(y1, yParams);
				frame._buckets.add((function () { var $ret = new Array();
				$ret.add(firstPointX);
				$ret.add(firstPointY);
				$ret.add(firstPointY);return $ret;}()));
				bucketCount++;
				markerBucket = bucketCount;
				for (var j = 1; j < n; ++j) {
					var x = x1 + h * j / n;
					var a = (x2 - x) / h;
					var b = (x - x1) / h;
					var y = a * y1 + b * y2 + ((a * a * a - a) * u1 + (b * b * b - b) * u2) * (h * h) / 6;
					x = xaxis.getScaledValue(x, xParams) + offset;
					y = yaxis.getScaledValue(y, yParams);
					frame._buckets.add((function () { var $ret = new Array();
					$ret.add(x);
					$ret.add(y);
					$ret.add(y);return $ret;}()));
					bucketCount++;
				}

				if (markers) {
					bucket = view.bucketCalculator().getBucket(i);
					bucket[0] = (xaxis.getScaledValue(bucket[0], xParams) + offset);
					bucket[1] = yaxis.getScaledValue(bucket[1], yParams);
					bucket[2] = yaxis.getScaledValue(bucket[2], yParams);
				}


			} else {
				bucket = view.bucketCalculator().getBucket(i);
				if (!isNaN(bucket[0])) {
					bucket[0] = (xaxis.getScaledValue(bucket[0], xParams) + offset);
					bucket[1] = yaxis.getScaledValue(bucket[1], yParams);
					bucket[2] = yaxis.getScaledValue(bucket[2], yParams);
					frame._buckets.add(bucket);
					bucketCount++;
				}

			}

			if (markers && $self.prepareMarker(frame, bucket, collisionAvoider, Math.min(i * bucketSize, $self.fastItemsSource().count() - 1), markerCount, view, markerBucket - 1)) {
				++markerCount;
			}

		}

		anchoredView.unCacheValues();
		view.markers().count(markerCount);
	}

	, 
	calculateSplineValue: function (p, x1, y1, x2, y2, u1, u2) {
		var h = x2 - x1;
		var x = x1 + h * p;
		var a = (x2 - x) / h;
		var b = (x - x1) / h;
		var y = a * y1 + b * y2 + ((a * a * a - a) * u1 + (b * b * b - b) * u2) * (h * h) / 6;
		return y;
	}

	, 
	getInterpolatedSeriesValue: function (p, column, prevItem, nextItem, unsortedPrevItem, unsortedNextItem, offset, isSorting) {
		var prevValue = NaN;
		if (prevItem >= 0 && prevItem < column.count()) {
			prevValue = column.item(prevItem);
		}

		var nextValue = NaN;
		if (nextItem >= 0 && nextItem < column.count()) {
			nextValue = column.item(nextItem);
		}

		if (unsortedNextItem == 0) {
			return nextValue;
		}

		if (unsortedPrevItem == column.count() - 1) {
			return prevValue;
		}

		if ($.ig.util.isNaN(nextValue) && offset != 0 && p <= 0.5 && !isSorting) {
			return prevValue;
		}

		if ($.ig.util.isNaN(prevValue) && offset != 0 && p >= 0.5 && !isSorting) {
			return nextValue;
		}

		var x1 = unsortedPrevItem;
		var x2 = unsortedNextItem;
		var y1 = prevValue;
		var y2 = nextValue;
		var u1 = NaN;
		var u2 = NaN;
		if (this.uColumn() != null && unsortedPrevItem >= 0 && unsortedPrevItem < this.uColumn().length) {
			u1 = this.uColumn()[unsortedPrevItem];
		}

		if (this.uColumn() != null && unsortedNextItem >= 0 && unsortedNextItem < this.uColumn().length) {
			u2 = this.uColumn()[unsortedNextItem];
		}

		return this.calculateSplineValue(p, x1, y1, x2, y2, u1, u2);
	}

	, 
	getOffset: function (axis, windowRect, viewportRect) {
		var categoryMode = this.preferredCategoryMode(axis);
		if (categoryMode == $.ig.CategoryMode.prototype.mode0 && axis.categoryMode() != $.ig.CategoryMode.prototype.mode0) {
			categoryMode = $.ig.CategoryMode.prototype.mode1;
		}

		var offset = 0;
		switch (categoryMode) {
			case $.ig.CategoryMode.prototype.mode0:
				offset = 0;
				break;
			case $.ig.CategoryMode.prototype.mode1:
				offset = 0.5 * axis.getCategorySize(windowRect, viewportRect);
				break;
			case $.ig.CategoryMode.prototype.mode2:
				offset = axis.getGroupCenter(this.index(), windowRect, viewportRect);
				break;
		}

		if (axis.isInverted()) {
		offset = -offset;
		}

		return offset;
	}

	, 
	splineType: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SplineSeriesBase.prototype.splineTypeProperty, $.ig.SplineType.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.SplineSeriesBase.prototype.splineTypeProperty));
		}
	}

	, 
	splineFitMustBeRecalculated: function () {
		this.uColumn(null);
	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		switch (propertyName) {
			case $.ig.AnchoredCategorySeries.prototype.valueColumnPropertyName:
			case $.ig.Series.prototype.fastItemsSourcePropertyName:
				this.splineFitMustBeRecalculated();
				break;
		}

		$.ig.HorizontalAnchoredCategorySeries.prototype.propertyUpdatedOverride.call(this, sender, propertyName, oldValue, newValue);
		switch (propertyName) {
			case $.ig.SplineSeriesBase.prototype._splineTypePropertyName:
				this.splineFitMustBeRecalculated();
				this.renderSeries(false);
				this.notifyThumbnailAppearanceChanged();
				break;
		}

	}

	, 
	dataUpdatedOverride: function (action, position, count, propertyName) {
		this.splineFitMustBeRecalculated();
		$.ig.HorizontalAnchoredCategorySeries.prototype.dataUpdatedOverride.call(this, action, position, count, propertyName);
	}
	, 
	$type: new $.ig.Type('SplineSeriesBase', $.ig.HorizontalAnchoredCategorySeries.prototype.$type)
}, true);

$.ig.util.defType('SplineAreaSeries', 'SplineSeriesBase', {

	createView: function () {
		return new $.ig.SplineAreaSeriesView(this);
	}

	, 
	getDefaultTransitionInMode: function () {
		return $.ig.CategoryTransitionInMode.prototype.fromZero;
	}

	, 
	onViewCreated: function (view) {
		$.ig.SplineSeriesBase.prototype.onViewCreated.call(this, view);
		this.splineAreaView(view);
	}

	, 
	_splineAreaView: null,
	splineAreaView: function (value) {
		if (arguments.length === 1) {
			this._splineAreaView = value;
			return value;
		} else {
			return this._splineAreaView;
		}
	}
	, 
	init: function () {



		$.ig.SplineSeriesBase.prototype.init.call(this);
			this.defaultStyleKey($.ig.SplineAreaSeries.prototype.$type);
	}

	, 
	preferredCategoryMode: function (axis) {
		return $.ig.CategoryMode.prototype.mode0;
	}

	, 
	clearRendering: function (wipeClean, view) {
		$.ig.SplineSeriesBase.prototype.clearRendering.call(this, wipeClean, view);
		var splineAreaView = view;
		splineAreaView.clearSplineArea();
	}

	, 
	renderFrame: function (frame, view) {
		var $self = this;
		$.ig.SplineSeriesBase.prototype.renderFrame.call($self, frame, view);
		var bucketSize = $self.categoryView().bucketCalculator()._bucketSize;
		var splineAreaView = $.ig.util.cast($.ig.SplineAreaSeriesView.prototype.$type, view);
		var buckets = frame._buckets;
		$self._renderManager.initCategoryRenderSettings($self, $self.shouldOverrideCategoryStyle(), $self.cachedXAxis(), $self.getCategoryItems.runOn($self), $self.getBucketSize(view), $self.getFirstBucket(view));
		var areStylesOverriden = false;
		var args = $self._renderManager.categoryOverrideArgs();
		if (args != null) {
			areStylesOverriden = true;
		}

		if (areStylesOverriden) {
			var xParams = new $.ig.ScalerParams(view.windowRect(), view.viewport(), $self.cachedXAxis().isInverted());
			$self.performCategoryStyleOverride(buckets, -1, $self.valueColumn().count(), $self.cachedXAxis(), xParams, view.isThumbnailView());
		}

		var line0 = splineAreaView.line0();
		var line1 = splineAreaView.line1();
		var polygon0 = splineAreaView.polygon0();
		var polygon1 = splineAreaView.polygon1();
		$self._renderManager.setCategoryShapeAppearance(line0, true, false, true, true);
		$self._renderManager.setCategoryShapeAppearance(line1, true, false, true, true);
		$self._renderManager.setCategoryShapeAppearance(polygon0, false, true, false, false);
		$self._renderManager.setCategoryShapeAppearance(polygon1, false, true, false, false);
		polygon0.__opacity = $self._renderManager._actualRenderOpacity * $self.actualAreaFillOpacity();
		polygon1.__opacity = 0.5 * $self._renderManager._actualRenderOpacity * $self.actualAreaFillOpacity();
		if (view.checkFrameDirty(frame)) {
			splineAreaView.rasterizeSplineArea(frame._buckets.count(), buckets, true, bucketSize, $self.resolution(), function (p0, l0, p1, l1, f) { $self.terminatePolygon(p0, frame._buckets.count(), view); }, $.ig.UnknownValuePlotting.prototype.dontPlot);
			view.updateFrameVersion(frame);
		}

		var yAxis = $self.getYAxis();
	}
	, 
	$type: new $.ig.Type('SplineAreaSeries', $.ig.SplineSeriesBase.prototype.$type)
}, true);

$.ig.util.defType('SplineSeries', 'SplineSeriesBase', {

	createView: function () {
		return new $.ig.SplineSeriesView(this);
	}

	, 
	onViewCreated: function (view) {
		$.ig.SplineSeriesBase.prototype.onViewCreated.call(this, view);
		this.splineView(view);
	}

	, 
	_splineView: null,
	splineView: function (value) {
		if (arguments.length === 1) {
			this._splineView = value;
			return value;
		} else {
			return this._splineView;
		}
	}
	, 
	init: function () {



		$.ig.SplineSeriesBase.prototype.init.call(this);
			this.defaultStyleKey($.ig.SplineSeries.prototype.$type);
	}

	, 
	preferredCategoryMode: function (axis) {
		return $.ig.CategoryMode.prototype.mode0;
	}

	, 
	clearRendering: function (wipeClean, view) {
		$.ig.SplineSeriesBase.prototype.clearRendering.call(this, wipeClean, view);
		var splineView = view;
		splineView.clearSplineLines();
	}

	, 
	renderFrame: function (frame, view) {
		$.ig.SplineSeriesBase.prototype.renderFrame.call(this, frame, view);
		var categoryView = view;
		var bucketSize = categoryView.bucketCalculator()._bucketSize;
		var splineView = $.ig.util.cast($.ig.SplineSeriesView.prototype.$type, view);
		var buckets = frame._buckets;
		this._renderManager.initCategoryRenderSettings(this, this.shouldOverrideCategoryStyle(), this.cachedXAxis(), this.getCategoryItems.runOn(this), this.getBucketSize(view), this.getFirstBucket(view));
		var areStylesOverriden = false;
		var args = this._renderManager.categoryOverrideArgs();
		if (args != null) {
			areStylesOverriden = true;
		}

		if (areStylesOverriden) {
			var xParams = new $.ig.ScalerParams(view.windowRect(), view.viewport(), this.cachedXAxis().isInverted());
			this.performCategoryStyleOverride(buckets, -1, this.valueColumn().count(), this.cachedXAxis(), xParams, view.isThumbnailView());
		}

		var line0 = splineView.line0();
		var line1 = splineView.line1();
		var fillArea = splineView.fillArea();
		this._renderManager.setCategoryShapeAppearance(line0, true, false, true, false);
		this._renderManager.setCategoryShapeAppearance(line1, true, false, true, false);
		this._renderManager.setCategoryShapeAppearance(fillArea, false, true, false, false);
		fillArea.__opacity = 0.75 * this._renderManager._actualRenderOpacity;
		if (view.checkFrameDirty(frame)) {
			splineView.rasterizeSpline(buckets.count(), buckets, true, $.ig.UnknownValuePlotting.prototype.dontPlot, this.getLineClipper(buckets, buckets.count() - 1, view.viewport(), view.windowRect()), bucketSize, this.resolution());
			view.updateFrameVersion(frame);
		}

	}
	, 
	$type: new $.ig.Type('SplineSeries', $.ig.SplineSeriesBase.prototype.$type)
}, true);

$.ig.util.defType('SplineSeriesView', 'SplineSeriesBaseView', {

	_splineModel: null,
	splineModel: function (value) {
		if (arguments.length === 1) {
			this._splineModel = value;
			return value;
		} else {
			return this._splineModel;
		}
	}
	, 
	init: function (model) {


		this._polyline0 = new $.ig.Path();
		this._polygon01 = new $.ig.Path();
		this._polyline1 = new $.ig.Path();
		this.__hitPolyline1 = new $.ig.Path();
		this.__hitPolyline0 = new $.ig.Path();
		this.__hitPolygon01 = new $.ig.Path();

		$.ig.SplineSeriesBaseView.prototype.init.call(this, model);
			this.splineModel(model);
	}
	, 
	_polyline0: null
	, 
	_polygon01: null
	, 
	_polyline1: null

	, 
	line0: function () {

			return this._polyline0;
	}

	, 
	line1: function () {

			return this._polyline1;
	}

	, 
	fillArea: function () {

			return this._polygon01;
	}

	, 
	clearSplineLines: function () {
		this._polygon01.data(null);
		this._polyline0.data(null);
		this._polyline1.data(null);
		this.makeDirty();
	}

	, 
	rasterizeSpline: function (count, buckets, useX0AsX1, unknownValuePlotting, clipper, bucketSize, resolution) {
		this.anchoredModel().lineRasterizer().isSortingAxis($.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.categoryModel().getXAxis()) !== null ? true : false);
		this.anchoredModel().lineRasterizer().rasterizePolylinePaths(this._polyline0, this._polygon01, this._polyline1, count, buckets, useX0AsX1, unknownValuePlotting, clipper, bucketSize, resolution);
		this.makeDirty();
	}
	, 
	__hitPolyline1: null
	, 
	__hitPolyline0: null
	, 
	__hitPolygon01: null

	, 
	setupHitAppearanceOverride: function () {
		$.ig.SplineSeriesBaseView.prototype.setupHitAppearanceOverride.call(this);
		this.__hitPolyline0.data(this._polyline0.data());
		this.__hitPolyline1.data(this._polyline1.data());
		this.__hitPolygon01.data(this._polygon01.data());
		var hitBrush = this.getHitBrush();
		this.__hitPolyline0.__stroke = hitBrush;
		this.__hitPolyline0.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
		this.__hitPolyline1.__stroke = hitBrush;
		this.__hitPolyline1.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
		this.__hitPolygon01.__fill = hitBrush;
		this.__hitPolygon01.__opacity = 1;
	}

	, 
	renderOverride: function (context, isHitContext) {
		$.ig.SplineSeriesBaseView.prototype.renderOverride.call(this, context, isHitContext);
		if (context.shouldRender()) {
			if (isHitContext) {
				context.renderPath(this.__hitPolygon01);
				context.renderPath(this.__hitPolyline0);
				context.renderPath(this.__hitPolyline1);

			} else {
				context.renderPath(this._polygon01);
				context.renderPath(this._polyline0);
				context.renderPath(this._polyline1);
			}

		}

	}

	, 
	exportViewShapes: function (svd) {
		$.ig.SplineSeriesBaseView.prototype.exportViewShapes.call(this, svd);
		var lowerShape = new $.ig.PathVisualData(1, "lowerShape", this._polyline0);
		lowerShape.tags().add("Lower");
		lowerShape.tags().add("Main");
		var upperShape = new $.ig.PathVisualData(1, "upperShape", this._polyline1);
		upperShape.tags().add("Upper");
		var translucent = new $.ig.PathVisualData(1, "translucentShape", this._polygon01);
		translucent.tags().add("Translucent");
		svd.shapes().add(lowerShape);
		svd.shapes().add(upperShape);
		svd.shapes().add(translucent);
	}
	, 
	$type: new $.ig.Type('SplineSeriesView', $.ig.SplineSeriesBaseView.prototype.$type)
}, true);

$.ig.util.defType('StepAreaSeries', 'HorizontalAnchoredCategorySeries', {

	createView: function () {
		return new $.ig.StepAreaSeriesView(this);
	}

	, 
	onViewCreated: function (view) {
		$.ig.HorizontalAnchoredCategorySeries.prototype.onViewCreated.call(this, view);
		this.stepAreaView(view);
	}

	, 
	_stepAreaView: null,
	stepAreaView: function (value) {
		if (arguments.length === 1) {
			this._stepAreaView = value;
			return value;
		} else {
			return this._stepAreaView;
		}
	}
	, 
	init: function () {



		$.ig.HorizontalAnchoredCategorySeries.prototype.init.call(this);
			this.defaultStyleKey($.ig.StepAreaSeries.prototype.$type);
	}

	, 
	preferredCategoryMode: function (axis) {
		return $.ig.CategoryMode.prototype.mode1;
	}

	, 
	clearRendering: function (wipeClean, view) {
		$.ig.HorizontalAnchoredCategorySeries.prototype.clearRendering.call(this, wipeClean, view);
		var stepAreaView = view;
		stepAreaView.clearStepArea();
	}

	, 
	getXValue: function (i, fromEnd, frame, width, isSorting) {
		if (fromEnd) {
			if (isSorting) {
				if ((i & 1) == 0 || (($.ig.intDivide(i, 2)) + 1) >= frame._buckets.count()) {
					return frame._buckets.__inner[($.ig.intDivide(i, 2))][0];
				}

				return frame._buckets.__inner[(($.ig.intDivide(i, 2))) + 1][0];
			}

			return frame._buckets.__inner[($.ig.intDivide(i, 2))][0] + ((i & 1) == 1 ? -width : width);
		}

		if (isSorting) {
			if ((i & 1) == 0 || (($.ig.intDivide(i, 2)) + 1) >= frame._buckets.count()) {
				return frame._buckets.__inner[($.ig.intDivide(i, 2))][0];
			}

			return frame._buckets.__inner[(($.ig.intDivide(i, 2))) + 1][0];
		}

		return frame._buckets.__inner[($.ig.intDivide(i, 2))][0] + ((i & 1) == 0 ? -width : width);
	}

	, 
	getDefaultTransitionInMode: function () {
		return $.ig.CategoryTransitionInMode.prototype.fromZero;
	}

	, 
	renderFrame: function (frame, view) {
		var $self = this;
		$.ig.HorizontalAnchoredCategorySeries.prototype.renderFrame.call($self, frame, view);
		var windowRect = view.windowRect();
		var viewportRect = view.viewport();
		var isSorting = $.ig.util.cast($.ig.ISortingAxis.prototype.$type, $self.cachedXAxis()) != null;
		var width = $self.cachedXAxis() != null ? 0.5 * $self.cachedXAxis().getCategorySize(windowRect, viewportRect) : 0;
		if ($self.cachedXAxis() != null && $self.cachedXAxis().isInverted()) {
			width = -width;
		}

		var count = frame._buckets.count() * 2;
		var buckets = new $.ig.List$1($.ig.Array.prototype.$type, 2, count);
		$self._renderManager.initCategoryRenderSettings($self, $self.shouldOverrideCategoryStyle(), $self.cachedXAxis(), $self.getCategoryItems.runOn($self), $self.getBucketSize(view), $self.getFirstBucket(view));
		var areStylesOverriden = false;
		var args = $self._renderManager.categoryOverrideArgs();
		if (args != null) {
			areStylesOverriden = true;
		}

		for (var i = 0; i < count; i++) {
			var bucket = new Array(4);
			bucket[0] = $self.getXValue(i, false, frame, width, isSorting);
			bucket[1] = frame._buckets.__inner[($.ig.intDivide(i, 2))][1];
			bucket[2] = $self.getXValue(i, true, frame, width, isSorting);
			bucket[3] = frame._buckets.__inner[($.ig.intDivide(i, 2))][2];
			buckets.add(bucket);
		}

		var bucketSize = $self.categoryView().bucketCalculator()._bucketSize;
		if (areStylesOverriden) {
			var xParams = new $.ig.ScalerParams(view.windowRect(), view.viewport(), $self.cachedXAxis().isInverted());
			$self.performCategoryStyleOverride(buckets, -1, $self.valueColumn().count(), $self.cachedXAxis(), xParams, view.isThumbnailView());
		}

		var stepAreaView = $.ig.util.cast($.ig.StepAreaSeriesView.prototype.$type, view);
		var line0 = stepAreaView.polyline0();
		var line1 = stepAreaView.polyline1();
		var polygon0 = stepAreaView.polygon0();
		var polygon1 = stepAreaView.polygon1();
		$self._renderManager.setCategoryShapeAppearance(line0, true, false, true, true);
		$self._renderManager.setCategoryShapeAppearance(line1, true, false, true, true);
		$self._renderManager.setCategoryShapeAppearance(polygon0, false, true, false, false);
		$self._renderManager.setCategoryShapeAppearance(polygon1, false, true, false, false);
		if (view.checkFrameDirty(frame)) {
			stepAreaView.rasterizeStepArea(count, buckets, false, bucketSize, $self.resolution(), function (p0, l0, p01, l1, f) { $self.terminatePolygon(p0, 2 * frame._buckets.count(), view); }, $.ig.UnknownValuePlotting.prototype.dontPlot);
			view.updateFrameVersion(frame);
		}

		var yAxis = $self.getYAxis();
		stepAreaView.polygon0().__opacity = $self.actualAreaFillOpacity();
		stepAreaView.polygon1().__opacity = 0.5 * $self.actualAreaFillOpacity();
	}

	, 
	currentCategoryMode: function () {

			if (this.cachedXAxis() != null && $.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.cachedXAxis()) !== null) {
				this.cachedXAxis().categoryMode($.ig.CategoryMode.prototype.mode0);
				return $.ig.CategoryMode.prototype.mode0;
			}

			return $.ig.CategoryMode.prototype.mode1;
	}
	, 
	$type: new $.ig.Type('StepAreaSeries', $.ig.HorizontalAnchoredCategorySeries.prototype.$type, [$.ig.IIsCategoryBased.prototype.$type])
}, true);

$.ig.util.defType('StepAreaSeriesView', 'AnchoredCategorySeriesView', {

	_stepAreaModel: null,
	stepAreaModel: function (value) {
		if (arguments.length === 1) {
			this._stepAreaModel = value;
			return value;
		} else {
			return this._stepAreaModel;
		}
	}
	, 
	init: function (model) {


		this._polygon0 = new $.ig.Path();
		this._polyline0 = new $.ig.Path();
		this._polygon1 = new $.ig.Path();
		this._polyline1 = new $.ig.Path();
		this.__hitPolygon0 = new $.ig.Path();
		this.__hitPolyline0 = new $.ig.Path();
		this.__hitPolygon1 = new $.ig.Path();
		this.__hitPolyline1 = new $.ig.Path();

		$.ig.AnchoredCategorySeriesView.prototype.init.call(this, model);
			this.stepAreaModel(model);
	}

	, 
	onInit: function () {
		var $self = this;
		$.ig.AnchoredCategorySeriesView.prototype.onInit.call($self);
		if (!$self.isThumbnailView()) {
			$self.model().legendItemBadgeTemplate((function () { var $ret = new $.ig.DataTemplate();
			$ret.render($.ig.LegendTemplates.prototype.rectBadgeTemplate);
			$ret.measure($.ig.LegendTemplates.prototype.legendItemBadgeMeasure); return $ret;}()));
		}

	}
	, 
	_polygon0: null
	, 
	_polyline0: null
	, 
	_polygon1: null
	, 
	_polyline1: null

	, 
	polygon0: function () {

			return this._polygon0;
	}

	, 
	polyline0: function () {

			return this._polyline0;
	}

	, 
	polygon1: function () {

			return this._polygon1;
	}

	, 
	polyline1: function () {

			return this._polyline1;
	}

	, 
	clearStepArea: function () {
		this._polygon0.data(null);
		this._polygon1.data(null);
		this._polyline0.data(null);
		this._polyline1.data(null);
		this.makeDirty();
	}

	, 
	rasterizeStepArea: function (count, buckets, useX0AsX1, bucketSize, resolution, terminatePolygon, unknownValuePlotting) {
		this.anchoredModel().lineRasterizer().isSortingAxis($.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.categoryModel().getXAxis()) !== null ? true : false);
		this.anchoredModel().lineRasterizer().rasterizePolygonPaths(this._polygon0, this._polyline0, this._polygon1, this._polyline1, count, buckets, useX0AsX1, bucketSize, resolution, terminatePolygon, unknownValuePlotting);
		this.makeDirty();
	}
	, 
	__hitPolygon0: null
	, 
	__hitPolyline0: null
	, 
	__hitPolygon1: null
	, 
	__hitPolyline1: null

	, 
	setupHitAppearanceOverride: function () {
		$.ig.AnchoredCategorySeriesView.prototype.setupHitAppearanceOverride.call(this);
		this.__hitPolygon0.data(this._polygon0.data());
		this.__hitPolyline0.data(this._polyline0.data());
		this.__hitPolygon1.data(this._polygon1.data());
		this.__hitPolyline1.data(this._polyline1.data());
		var hitBrush = this.getHitBrush();
		this.__hitPolygon0.__fill = hitBrush;
		this.__hitPolygon0.__opacity = 1;
		this.__hitPolygon1.__fill = hitBrush;
		this.__hitPolygon1.__opacity = 1;
		this.__hitPolyline0.__stroke = hitBrush;
		this.__hitPolyline0.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
		this.__hitPolyline1.__stroke = hitBrush;
		this.__hitPolyline1.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
	}

	, 
	renderOverride: function (context, isHitContext) {
		$.ig.AnchoredCategorySeriesView.prototype.renderOverride.call(this, context, isHitContext);
		if (isHitContext) {
			context.renderPath(this.__hitPolygon0);
			context.renderPath(this.__hitPolygon1);
			context.renderPath(this.__hitPolyline0);
			context.renderPath(this.__hitPolyline1);

		} else {
			context.renderPath(this._polygon0);
			context.renderPath(this._polygon1);
			context.renderPath(this._polyline0);
			context.renderPath(this._polyline1);
		}

	}

	, 
	exportViewShapes: function (svd) {
		$.ig.AnchoredCategorySeriesView.prototype.exportViewShapes.call(this, svd);
		var lowerShape = new $.ig.PathVisualData(1, "lowerShape", this._polyline0);
		lowerShape.tags().add("Lower");
		var upperShape = new $.ig.PathVisualData(1, "upperShape", this._polyline1);
		upperShape.tags().add("Upper");
		upperShape.tags().add("Main");
		var translucent = new $.ig.PathVisualData(1, "translucentShape", this._polygon0);
		translucent.tags().add("Translucent");
		var fill = new $.ig.PathVisualData(1, "fillShape", this._polygon1);
		fill.tags().add("Fill");
		svd.shapes().add(lowerShape);
		svd.shapes().add(upperShape);
		svd.shapes().add(translucent);
		svd.shapes().add(fill);
	}
	, 
	$type: new $.ig.Type('StepAreaSeriesView', $.ig.AnchoredCategorySeriesView.prototype.$type)
}, true);

$.ig.util.defType('StepLineSeries', 'HorizontalAnchoredCategorySeries', {

	createView: function () {
		return new $.ig.StepLineSeriesView(this);
	}

	, 
	onViewCreated: function (view) {
		$.ig.HorizontalAnchoredCategorySeries.prototype.onViewCreated.call(this, view);
		this.stepView(view);
	}

	, 
	_stepView: null,
	stepView: function (value) {
		if (arguments.length === 1) {
			this._stepView = value;
			return value;
		} else {
			return this._stepView;
		}
	}
	, 
	init: function () {



		$.ig.HorizontalAnchoredCategorySeries.prototype.init.call(this);
			this.defaultStyleKey($.ig.StepLineSeries.prototype.$type);
	}

	, 
	onApplyTemplate: function () {
		$.ig.HorizontalAnchoredCategorySeries.prototype.onApplyTemplate.call(this);
	}

	, 
	preferredCategoryMode: function (axis) {
		return $.ig.CategoryMode.prototype.mode1;
	}

	, 
	clearRendering: function (wipeClean, view) {
		$.ig.HorizontalAnchoredCategorySeries.prototype.clearRendering.call(this, wipeClean, view);
		var stepView = view;
		stepView.clearStepLine();
	}

	, 
	getXValue: function (i, fromEnd, frame, width, xInverted, isSorting) {
		var even;
		if (fromEnd) {
			if (isSorting) {
				even = (i & 1) == 0;
				if (even || ($.ig.intDivide(i, 2)) + 1 < 0) {
					return frame._buckets.__inner[($.ig.intDivide(i, 2))][0];
				}

				if (frame._buckets.count() == ($.ig.intDivide(i, 2)) + 1) {
					return frame._buckets.__inner[($.ig.intDivide(i, 2))][0];
				}

				return frame._buckets.__inner[($.ig.intDivide(i, 2)) + 1][0];
			}

			even = (i & 1) == 0;
			return (frame._buckets.__inner[($.ig.intDivide(i, 2))][0] + (even ? width : -width));
		}

		if (isSorting) {
			even = (i & 1) == 0;
			if (even || (($.ig.intDivide(i, 2)) + 1) >= frame._buckets.count()) {
				return frame._buckets.__inner[($.ig.intDivide(i, 2))][0];
			}

			if (frame._buckets.count() == ($.ig.intDivide(i, 2)) + 1) {
				return frame._buckets.__inner[($.ig.intDivide(i, 2))][0];
			}

			return (frame._buckets.__inner[($.ig.intDivide(i, 2)) + 1][0]);
		}

		even = (i & 1) == 0;
		return (frame._buckets.__inner[($.ig.intDivide(i, 2))][0] + (even ? -width : width));
	}

	, 
	renderFrame: function (frame, view) {
		$.ig.HorizontalAnchoredCategorySeries.prototype.renderFrame.call(this, frame, view);
		var windowRect = view.windowRect();
		var viewportRect = view.viewport();
		var isSorting = $.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.cachedXAxis()) != null;
		var xIsInverted = this.cachedXAxis().isInverted();
		var width = 0;
		if (this.cachedXAxis() != null) {
			width = 0.5 * this.cachedXAxis().getCategorySize(windowRect, viewportRect);
		}

		var buckets = frame._buckets;
		var count = 2 * buckets.count();
		var procesedBuckets = new $.ig.List$1($.ig.Array.prototype.$type, 2, count);
		if (!this.cachedXAxis().isInverted()) {
			for (var i = 0; i < count; i++) {
				var values = new Array(4);
				values[0] = this.getXValue(i, false, frame, width, xIsInverted, isSorting);
				values[1] = frame._buckets.__inner[($.ig.intDivide(i, 2))][1];
				values[2] = this.getXValue(i, true, frame, width, xIsInverted, isSorting);
				values[3] = frame._buckets.__inner[($.ig.intDivide(i, 2))][2];
				procesedBuckets.add(values);
			}


		} else {
			for (var i1 = 0; i1 < count; i1++) {
				var values1 = new Array(4);
				values1[0] = this.getXValue(i1, true, frame, width, xIsInverted, isSorting);
				values1[1] = frame._buckets.__inner[($.ig.intDivide(i1, 2))][1];
				values1[2] = this.getXValue(i1, true, frame, width, xIsInverted, isSorting);
				values1[3] = frame._buckets.__inner[($.ig.intDivide(i1, 2))][2];
				procesedBuckets.add(values1);
			}

		}

		var stepLineView = $.ig.util.cast($.ig.StepLineSeriesView.prototype.$type, view);
		var bucketSize = stepLineView.bucketCalculator()._bucketSize;
		this._renderManager.initCategoryRenderSettings(this, this.shouldOverrideCategoryStyle(), this.cachedXAxis(), this.getCategoryItems.runOn(this), this.getBucketSize(view), this.getFirstBucket(view));
		var areStylesOverriden = false;
		var args = this._renderManager.categoryOverrideArgs();
		if (args != null) {
			areStylesOverriden = true;
		}

		if (areStylesOverriden) {
			var xParams = new $.ig.ScalerParams(view.windowRect(), view.viewport(), this.cachedXAxis().isInverted());
			this.performCategoryStyleOverride(buckets, -1, this.valueColumn().count(), this.cachedXAxis(), xParams, view.isThumbnailView());
		}

		var line0 = stepLineView.line0();
		var line1 = stepLineView.line1();
		var fillArea = stepLineView.fillArea();
		this._renderManager.setCategoryShapeAppearance(line0, true, false, true, false);
		this._renderManager.setCategoryShapeAppearance(line1, true, false, true, false);
		this._renderManager.setCategoryShapeAppearance(fillArea, false, true, false, false);
		fillArea.__opacity = 0.75 * this._renderManager._actualRenderOpacity;
		if (view.checkFrameDirty(frame)) {
			stepLineView.rasterizeStepLine(count, procesedBuckets, false, $.ig.UnknownValuePlotting.prototype.dontPlot, this.getLineClipper(procesedBuckets, count - 1, view.viewport(), view.windowRect()), bucketSize, this.resolution());
			view.updateFrameVersion(frame);
		}

	}

	, 
	currentCategoryMode: function () {

			if (this.cachedXAxis() != null && $.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.cachedXAxis()) !== null) {
				this.cachedXAxis().categoryMode($.ig.CategoryMode.prototype.mode0);
				return $.ig.CategoryMode.prototype.mode0;
			}

			return $.ig.CategoryMode.prototype.mode1;
	}
	, 
	$type: new $.ig.Type('StepLineSeries', $.ig.HorizontalAnchoredCategorySeries.prototype.$type, [$.ig.IIsCategoryBased.prototype.$type])
}, true);

$.ig.util.defType('StepLineSeriesView', 'AnchoredCategorySeriesView', {

	_stepModel: null,
	stepModel: function (value) {
		if (arguments.length === 1) {
			this._stepModel = value;
			return value;
		} else {
			return this._stepModel;
		}
	}
	, 
	init: function (model) {


		this._polyline0 = new $.ig.Path();
		this._polygon01 = new $.ig.Path();
		this._polyline1 = new $.ig.Path();
		this.__hitPolyline1 = new $.ig.Path();
		this.__hitPolyline0 = new $.ig.Path();
		this.__hitPolygon01 = new $.ig.Path();

		$.ig.AnchoredCategorySeriesView.prototype.init.call(this, model);
			this.stepModel(model);
	}
	, 
	_polyline0: null
	, 
	_polygon01: null
	, 
	_polyline1: null

	, 
	line0: function () {

			return this._polyline0;
	}

	, 
	line1: function () {

			return this._polyline1;
	}

	, 
	fillArea: function () {

			return this._polygon01;
	}

	, 
	clearStepLine: function () {
		this._polygon01.data(null);
		this._polyline0.data(null);
		this._polyline1.data(null);
		this.makeDirty();
	}

	, 
	rasterizeStepLine: function (count, buckets, useX0AsX1, unknownValuePlotting, clipper, bucketSize, resolution) {
		this.anchoredModel().lineRasterizer().isSortingAxis($.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.categoryModel().getXAxis()) !== null ? true : false);
		this.anchoredModel().lineRasterizer().rasterizePolylinePaths(this._polyline0, this._polygon01, this._polyline1, count, buckets, useX0AsX1, unknownValuePlotting, clipper, bucketSize, resolution);
		this.makeDirty();
	}
	, 
	__hitPolyline1: null
	, 
	__hitPolyline0: null
	, 
	__hitPolygon01: null

	, 
	setupHitAppearanceOverride: function () {
		$.ig.AnchoredCategorySeriesView.prototype.setupHitAppearanceOverride.call(this);
		this.__hitPolyline0.data(this._polyline0.data());
		this.__hitPolyline1.data(this._polyline1.data());
		this.__hitPolygon01.data(this._polygon01.data());
		var hitBrush = this.getHitBrush();
		this.__hitPolyline0.__stroke = hitBrush;
		this.__hitPolyline0.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
		this.__hitPolyline1.__stroke = hitBrush;
		this.__hitPolyline1.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
		this.__hitPolygon01.__fill = hitBrush;
		this.__hitPolygon01.__opacity = 1;
	}

	, 
	renderOverride: function (context, isHitContext) {
		$.ig.AnchoredCategorySeriesView.prototype.renderOverride.call(this, context, isHitContext);
		if (context.shouldRender()) {
			if (isHitContext) {
				context.renderPath(this.__hitPolygon01);
				context.renderPath(this.__hitPolyline0);
				context.renderPath(this.__hitPolyline1);

			} else {
				context.renderPath(this._polygon01);
				context.renderPath(this._polyline0);
				context.renderPath(this._polyline1);
			}

		}

	}

	, 
	exportViewShapes: function (svd) {
		$.ig.AnchoredCategorySeriesView.prototype.exportViewShapes.call(this, svd);
		var lowerShape = new $.ig.PathVisualData(1, "lowerShape", this._polyline0);
		lowerShape.tags().add("Lower");
		lowerShape.tags().add("Main");
		var upperShape = new $.ig.PathVisualData(1, "upperShape", this._polyline1);
		upperShape.tags().add("Upper");
		var translucent = new $.ig.PathVisualData(1, "translucentShape", this._polygon01);
		translucent.tags().add("Translucent");
		svd.shapes().add(lowerShape);
		svd.shapes().add(upperShape);
		svd.shapes().add(translucent);
	}

	, 
	applyDropShadowDefaultSettings: function () {
		var color = new $.ig.Color();
		color.colorString("rgba(95,95,95,0.5)");
		this.model().shadowColor(color);
		this.model().shadowBlur(3);
		this.model().shadowOffsetX(1);
		this.model().shadowOffsetY(4);
		this.model().useSingleShadow(false);
	}
	, 
	$type: new $.ig.Type('StepLineSeriesView', $.ig.AnchoredCategorySeriesView.prototype.$type)
}, true);

$.ig.util.defType('WaterfallSeries', 'HorizontalAnchoredCategorySeries', {

	createView: function () {
		return new $.ig.WaterfallSeriesView(this);
	}

	, 
	onViewCreated: function (view) {
		$.ig.HorizontalAnchoredCategorySeries.prototype.onViewCreated.call(this, view);
		this.waterfallView(view);
	}

	, 
	_waterfallView: null,
	waterfallView: function (value) {
		if (arguments.length === 1) {
			this._waterfallView = value;
			return value;
		} else {
			return this._waterfallView;
		}
	}
	, 
	init: function () {



		$.ig.HorizontalAnchoredCategorySeries.prototype.init.call(this);
			this.defaultStyleKey($.ig.WaterfallSeries.prototype.$type);
	}

	, 
	preferredCategoryMode: function (axis) {
		return $.ig.CategoryMode.prototype.mode2;
	}

	, 
	negativeBrush: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.WaterfallSeries.prototype.negativeBrushProperty, value);
			return value;
		} else {

			return this.getValue($.ig.WaterfallSeries.prototype.negativeBrushProperty);
		}
	}

	, 
	radiusX: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.WaterfallSeries.prototype.radiusXProperty, value);
			return value;
		} else {

			return this.getValue($.ig.WaterfallSeries.prototype.radiusXProperty);
		}
	}

	, 
	radiusY: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.WaterfallSeries.prototype.radiusYProperty, value);
			return value;
		} else {

			return this.getValue($.ig.WaterfallSeries.prototype.radiusYProperty);
		}
	}

	, 
	hasIndividualElements: function () {

			return true;
	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		$.ig.HorizontalAnchoredCategorySeries.prototype.propertyUpdatedOverride.call(this, sender, propertyName, oldValue, newValue);
		switch (propertyName) {
			case $.ig.WaterfallSeries.prototype.radiusYPropertyName:
			case $.ig.WaterfallSeries.prototype.radiusXPropertyName:
			case $.ig.WaterfallSeries.prototype.negativeBrushPropertyName:
				this.renderSeries(false);
				break;
		}

	}

	, 
	getDefaultTransitionInMode: function () {
		return $.ig.CategoryTransitionInMode.prototype.fromZero;
	}

	, 
	clearRendering: function (wipeClean, view) {
		$.ig.HorizontalAnchoredCategorySeries.prototype.clearRendering.call(this, wipeClean, view);
		this.waterfallView().columns().count(0);
	}

	, 
	renderFrame: function (frame, view) {
		var waterfallView = view;
		$.ig.HorizontalAnchoredCategorySeries.prototype.renderFrame.call(this, frame, view);
		var windowRect = view.windowRect();
		var viewportRect = view.viewport();
		var groupWidth = this.cachedXAxis().getGroupSize(windowRect, viewportRect);
		var radiusX = this.radiusX();
		var radiusY = this.radiusY();
		var rectangleGeometry;
		var rect;
		var left;
		var zeroVal = this.getWorldZeroValue(view);
		var lastKnownValue = NaN;
		var columns = waterfallView.columns();
		var currentRectangle;
		var columnCount = 0;
		this._renderManager.initCategoryRenderSettings(this, this.shouldOverrideCategoryStyle(), this.cachedXAxis(), this.getCategoryItems.runOn(this), this.getBucketSize(view), this.getFirstBucket(view));
		this._renderManager._initialRenderRadiusX = this.radiusX();
		this._renderManager._initialRenderRadiusY = this.radiusY();
		this._renderManager._actualRenderRadiusX = this.radiusX();
		this._renderManager._actualRenderRadiusY = this.radiusY();
		var areStylesOverriden = false;
		var args = this._renderManager.categoryOverrideArgs();
		if (args != null) {
			areStylesOverriden = true;
		}

		var isSorting = this.cachedXAxis().isSorting();
		var valueCount = this.valueColumn().count();
		var buckets = frame._buckets;
		var xAxis = this.cachedXAxis();
		var xParams = new $.ig.ScalerParams(windowRect, viewportRect, this.cachedXAxis().isInverted());
		var positiveBrush = this.actualBrush();
		var negativeBrush = this.negativeBrush();
		if (frame._buckets.count() > 0) {
			left = frame._buckets.__inner[0][0] - 0.5 * groupWidth;
			var currentValue = frame._buckets.__inner[0][1];
			if (!$.ig.util.isNaN(currentValue)) {
				if (currentValue > zeroVal) {
					currentRectangle = columns.item(columnCount);
					columnCount++;
					waterfallView.positionRectangle(currentRectangle, left, zeroVal);
					currentRectangle.width(groupWidth);
					currentRectangle.height(Math.abs(zeroVal - currentValue));
					this._renderManager._initialRenderFill = negativeBrush;
					this._renderManager._actualRenderFill = negativeBrush;
					this._renderManager._actualNegativeShape = true;
					if (areStylesOverriden) {
						this.performCategoryStyleOverride(buckets, 0, valueCount, xAxis, xParams, view.isThumbnailView());
					}

					this._renderManager.setCategoryShapeAppearance(currentRectangle, false, false, false, false);
					currentRectangle.radiusX(this._renderManager._actualRenderRadiusX);
					currentRectangle.radiusY(this._renderManager._actualRenderRadiusY);

				} else {
					currentRectangle = columns.item(columnCount);
					columnCount++;
					waterfallView.positionRectangle(currentRectangle, left, currentValue);
					currentRectangle.width(groupWidth);
					currentRectangle.height(Math.abs(currentValue - zeroVal));
					this._renderManager._initialRenderFill = positiveBrush;
					this._renderManager._actualRenderFill = positiveBrush;
					this._renderManager._actualNegativeShape = false;
					if (areStylesOverriden) {
						this.performCategoryStyleOverride(buckets, 0, valueCount, xAxis, xParams, view.isThumbnailView());
					}

					this._renderManager.setCategoryShapeAppearance(currentRectangle, false, false, false, false);
					currentRectangle.radiusX(this._renderManager._actualRenderRadiusX);
					currentRectangle.radiusY(this._renderManager._actualRenderRadiusY);
				}

				lastKnownValue = currentValue;

			} else {
				lastKnownValue = zeroVal;
			}

		}

		for (var i = 1; i < frame._buckets.count(); ++i) {
			var bucket1 = frame._buckets.__inner[i];
			left = frame._buckets.__inner[i][0] - 0.5 * groupWidth;
			var currentValue1 = bucket1[1];
			if (!$.ig.util.isNaN(currentValue1)) {
				currentRectangle = columns.item(columnCount);
				columnCount++;
				waterfallView.positionRectangle(currentRectangle, left, Math.min(lastKnownValue, currentValue1));
				currentRectangle.width(groupWidth);
				currentRectangle.height(Math.abs(lastKnownValue - currentValue1));
				this._renderManager._initialRenderFill = positiveBrush;
				this._renderManager._actualRenderFill = positiveBrush;
				this._renderManager._actualNegativeShape = false;
				if (lastKnownValue > currentValue1) {
					if (areStylesOverriden) {
						this.performCategoryStyleOverride(buckets, i, valueCount, xAxis, xParams, view.isThumbnailView());
					}


				} else {
					this._renderManager._initialRenderFill = negativeBrush;
					this._renderManager._actualRenderFill = negativeBrush;
					this._renderManager._actualNegativeShape = true;
					if (areStylesOverriden) {
						this.performCategoryStyleOverride(buckets, i, valueCount, xAxis, xParams, view.isThumbnailView());
					}

				}

				this._renderManager.setCategoryShapeAppearance(currentRectangle, false, false, false, false);
				currentRectangle.radiusX(this._renderManager._actualRenderRadiusX);
				currentRectangle.radiusY(this._renderManager._actualRenderRadiusY);
				lastKnownValue = currentValue1;
			}

		}

		columns.count(columnCount);
		view.updateFrameVersion(frame);
	}
	, 
	$type: new $.ig.Type('WaterfallSeries', $.ig.HorizontalAnchoredCategorySeries.prototype.$type)
}, true);

$.ig.util.defType('WaterfallSeriesView', 'AnchoredCategorySeriesView', {

	onInit: function () {
		var $self = this;
		$.ig.AnchoredCategorySeriesView.prototype.onInit.call($self);
		$self.visibleColumns(new $.ig.List$1($.ig.Rectangle.prototype.$type, 0));
		if (!$self.isThumbnailView()) {
			$self.model().resolution(4);
			$self.waterfallModel().negativeBrush((function () { var $ret = new $.ig.Brush();
			$ret.fill("#415460"); return $ret;}()));
			$self.model().legendItemBadgeTemplate((function () { var $ret = new $.ig.DataTemplate();
			$ret.render($.ig.LegendTemplates.prototype.positiveNegativeBadgeTemplate);
			$ret.measure($.ig.LegendTemplates.prototype.legendItemBadgeMeasure); return $ret;}()));
		}

	}

	, 
	_waterfallModel: null,
	waterfallModel: function (value) {
		if (arguments.length === 1) {
			this._waterfallModel = value;
			return value;
		} else {
			return this._waterfallModel;
		}
	}
	, 
	init: function (model) {


		this.__hitItem = new $.ig.Rectangle();

		var $self = this;
		$.ig.AnchoredCategorySeriesView.prototype.init.call(this, model);
			this.waterfallModel(model);
			this.columns((function () { var $ret = new $.ig.Pool$1($.ig.Rectangle.prototype.$type);
			$ret.create($self.columnCreate.runOn($self));
			$ret.activate($self.columnActivate.runOn($self));
			$ret.disactivate($self.columnDisactivate.runOn($self));
			$ret.destroy($self.columnDestroy.runOn($self)); return $ret;}()));
	}

	, 
	columnCreate: function () {
		var column = new $.ig.Rectangle();
		this.visibleColumns().add(column);
		column.__visibility = $.ig.Visibility.prototype.collapsed;
		return column;
	}

	, 
	_visibleColumns: null,
	visibleColumns: function (value) {
		if (arguments.length === 1) {
			this._visibleColumns = value;
			return value;
		} else {
			return this._visibleColumns;
		}
	}

	, 
	columnActivate: function (column) {
		column.__visibility = $.ig.Visibility.prototype.visible;
	}

	, 
	columnDisactivate: function (column) {
		column.__visibility = $.ig.Visibility.prototype.collapsed;
	}

	, 
	columnDestroy: function (column) {
		this.visibleColumns().remove(column);
	}

	, 
	positionRectangle: function (column, left, top) {
		var dirty = false;
		if (column.canvasTop() != top) {
			dirty = true;
			column.canvasTop(top);
		}

		if (column.canvasLeft() != left) {
			dirty = true;
			column.canvasLeft(left);
		}

		if (dirty) {
			this.makeDirty();
		}

	}

	, 
	getItem: function (index) {
		return this.visibleColumns().__inner[index];
	}
	, 
	__hitItem: null

	, 
	getHitItem: function (index) {
		var item = this.visibleColumns().__inner[index];
		this.__hitItem.__visibility = item.__visibility;
		this.__hitItem.canvasLeft(item.canvasLeft());
		this.__hitItem.canvasTop(item.canvasTop());
		this.__hitItem.width(item.width());
		this.__hitItem.height(item.height());
		var hitBrush = this.getHitBrush1(index);
		this.__hitItem.__fill = hitBrush;
		this.__hitItem.__stroke = hitBrush;
		this.__hitItem.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
		return this.__hitItem;
	}

	, 
	renderOverride: function (context, isHitContext) {
		$.ig.AnchoredCategorySeriesView.prototype.renderOverride.call(this, context, isHitContext);
		var doGradients = false;
		if (context.shouldRender()) {
			for (var i = 0; i < this.visibleColumns().count(); i++) {
				var column = this.getCurrentItem(i, isHitContext);
				this.setupItemAppearance(column, i, isHitContext);
				context.renderRectangle(column);
			}

		}

	}

	, 
	_columns: null,
	columns: function (value) {
		if (arguments.length === 1) {
			this._columns = value;
			return value;
		} else {
			return this._columns;
		}
	}

	, 
	exportViewShapes: function (svd) {
		var $self = this;
		$.ig.AnchoredCategorySeriesView.prototype.exportViewShapes.call($self, svd);
		var i = 0;
		var toSort = new $.ig.List$1($.ig.Rectangle.prototype.$type, 0);
		var en = $self.columns().active().getEnumerator();
		while (en.moveNext()) {
			var column = en.current();
			toSort.add(column);
		}

		toSort.sort2(function (c1, c2) {
			if (c1.canvasLeft() < c2.canvasLeft()) {
				return -1;

			} else if (c1.canvasLeft() > c2.canvasLeft()) {
				return 1;

			} else {
				return 0;
			}


		});
		var en1 = toSort.getEnumerator();
		while (en1.moveNext()) {
			var column1 = en1.current();
			var rvd = new $.ig.RectangleVisualData(1, "column" + i, column1);
			rvd.tags().add("Main");
			svd.shapes().add(rvd);
			if (column1.__fill == $self.model().actualBrush()) {
				rvd.tags().add("Positive");

			} else {
				rvd.tags().add("Negative");
			}

		}

		i++;
	}
	, 
	$type: new $.ig.Type('WaterfallSeriesView', $.ig.AnchoredCategorySeriesView.prototype.$type)
}, true);

























$.ig.util.defType('AssigningCategoryStyleEventArgsBase', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	_startIndex: 0,
	startIndex: function (value) {
		if (arguments.length === 1) {
			this._startIndex = value;
			return value;
		} else {
			return this._startIndex;
		}
	}

	, 
	_endIndex: 0,
	endIndex: function (value) {
		if (arguments.length === 1) {
			this._endIndex = value;
			return value;
		} else {
			return this._endIndex;
		}
	}

	, 
	_startDate: new Date(),
	startDate: function (value) {
		if (arguments.length === 1) {
			this._startDate = value;
			return value;
		} else {
			return this._startDate;
		}
	}

	, 
	_endDate: new Date(),
	endDate: function (value) {
		if (arguments.length === 1) {
			this._endDate = value;
			return value;
		} else {
			return this._endDate;
		}
	}

	, 
	_getItems: null,
	getItems: function (value) {
		if (arguments.length === 1) {
			this._getItems = value;
			return value;
		} else {
			return this._getItems;
		}
	}

	, 
	_fill: null,
	fill: function (value) {
		if (arguments.length === 1) {
			this._fill = value;
			return value;
		} else {
			return this._fill;
		}
	}

	, 
	_stroke: null,
	stroke: function (value) {
		if (arguments.length === 1) {
			this._stroke = value;
			return value;
		} else {
			return this._stroke;
		}
	}

	, 
	_opacity: 0,
	opacity: function (value) {
		if (arguments.length === 1) {
			this._opacity = value;
			return value;
		} else {
			return this._opacity;
		}
	}

	, 
	_highlightingInfo: null,
	highlightingInfo: function (value) {
		if (arguments.length === 1) {
			this._highlightingInfo = value;
			return value;
		} else {
			return this._highlightingInfo;
		}
	}

	, 
	_maxAllSeriesHighlightingProgress: 0,
	maxAllSeriesHighlightingProgress: function (value) {
		if (arguments.length === 1) {
			this._maxAllSeriesHighlightingProgress = value;
			return value;
		} else {
			return this._maxAllSeriesHighlightingProgress;
		}
	}

	, 
	_sumAllSeriesHighlightingProgress: 0,
	sumAllSeriesHighlightingProgress: function (value) {
		if (arguments.length === 1) {
			this._sumAllSeriesHighlightingProgress = value;
			return value;
		} else {
			return this._sumAllSeriesHighlightingProgress;
		}
	}

	, 
	_highlightingHandled: false,
	highlightingHandled: function (value) {
		if (arguments.length === 1) {
			this._highlightingHandled = value;
			return value;
		} else {
			return this._highlightingHandled;
		}
	}

	, 
	_hasDateRange: false,
	hasDateRange: function (value) {
		if (arguments.length === 1) {
			this._hasDateRange = value;
			return value;
		} else {
			return this._hasDateRange;
		}
	}

	, 
	_isNegativeShape: false,
	isNegativeShape: function (value) {
		if (arguments.length === 1) {
			this._isNegativeShape = value;
			return value;
		} else {
			return this._isNegativeShape;
		}
	}

	, 
	_isThumbnail: false,
	isThumbnail: function (value) {
		if (arguments.length === 1) {
			this._isThumbnail = value;
			return value;
		} else {
			return this._isThumbnail;
		}
	}
	, 
	$type: new $.ig.Type('AssigningCategoryStyleEventArgsBase', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('AssigningCategoryStyleEventArgs', 'AssigningCategoryStyleEventArgsBase', {
	init: function () {


		$.ig.AssigningCategoryStyleEventArgsBase.prototype.init.call(this);

	}
	, 
	_strokeThickness: 0,
	strokeThickness: function (value) {
		if (arguments.length === 1) {
			this._strokeThickness = value;
			return value;
		} else {
			return this._strokeThickness;
		}
	}

	, 
	_strokeDashArray: null,
	strokeDashArray: function (value) {
		if (arguments.length === 1) {
			this._strokeDashArray = value;
			return value;
		} else {
			return this._strokeDashArray;
		}
	}

	, 
	_strokeDashCap: 0,
	strokeDashCap: function (value) {
		if (arguments.length === 1) {
			this._strokeDashCap = value;
			return value;
		} else {
			return this._strokeDashCap;
		}
	}

	, 
	_radiusX: 0,
	radiusX: function (value) {
		if (arguments.length === 1) {
			this._radiusX = value;
			return value;
		} else {
			return this._radiusX;
		}
	}

	, 
	_radiusY: 0,
	radiusY: function (value) {
		if (arguments.length === 1) {
			this._radiusY = value;
			return value;
		} else {
			return this._radiusY;
		}
	}
	, 
	$type: new $.ig.Type('AssigningCategoryStyleEventArgs', $.ig.AssigningCategoryStyleEventArgsBase.prototype.$type)
}, true);



$.ig.util.defType('AssigningCategoryMarkerStyleEventArgs', 'AssigningCategoryStyleEventArgsBase', {
	init: function () {


		$.ig.AssigningCategoryStyleEventArgsBase.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('AssigningCategoryMarkerStyleEventArgs', $.ig.AssigningCategoryStyleEventArgsBase.prototype.$type)
}, true);




$.ig.util.defType('StackedSeriesCreatedEventArgs', 'EventArgs', {
	init: function (series) {



		$.ig.EventArgs.prototype.init.call(this);
			this.series(series);
	}

	, 
	_series: null,
	series: function (value) {
		if (arguments.length === 1) {
			this._series = value;
			return value;
		} else {
			return this._series;
		}
	}

	, 
	brush: function (value) {
		if (arguments.length === 1) {

			this.series().brush(value);
			return value;
		} else {

			return this.series().brush();
		}
	}

	, 
	legendItemTemplate: function (value) {
		if (arguments.length === 1) {

			this.series().legendItemTemplate(value);
			return value;
		} else {

			return this.series().legendItemTemplate();
		}
	}

	, 
	legendItemBadgeTemplate: function (value) {
		if (arguments.length === 1) {

			this.series().legendItemBadgeTemplate(value);
			return value;
		} else {

			return this.series().legendItemBadgeTemplate();
		}
	}

	, 
	legendItemVisibility: function (value) {
		if (arguments.length === 1) {

			this.series().legendItemVisibility(value);
			return value;
		} else {

			return this.series().legendItemVisibility();
		}
	}

	, 
	outline: function (value) {
		if (arguments.length === 1) {

			this.series().outline(value);
			return value;
		} else {

			return this.series().outline();
		}
	}

	, 
	dashArray: function (value) {
		if (arguments.length === 1) {

			this.series().dashArray(value);
			return value;
		} else {

			return this.series().dashArray();
		}
	}

	, 
	dashCap: function (value) {
		if (arguments.length === 1) {

			this.series().dashCap(value);
			return value;
		} else {

			return this.series().dashCap();
		}
	}

	, 
	index: function () {

			return this.series().index();
	}

	, 
	thickness: function (value) {
		if (arguments.length === 1) {

			this.series().thickness(value);
			return value;
		} else {

			return this.series().thickness();
		}
	}

	, 
	title: function (value) {
		if (arguments.length === 1) {

			this.series().title(value);
			return value;
		} else {

			return this.series().title();
		}
	}

	, 
	markerBrush: function (value) {
		if (arguments.length === 1) {

			this.series().markerBrush(value);
			return value;
		} else {

			return this.series().markerBrush();
		}
	}

	, 
	markerOutline: function (value) {
		if (arguments.length === 1) {

			this.series().markerOutline(value);
			return value;
		} else {

			return this.series().markerOutline();
		}
	}

	, 
	markerStyle: function (value) {
		if (arguments.length === 1) {

			this.series().markerStyle(value);
			return value;
		} else {

			return this.series().markerStyle();
		}
	}

	, 
	markerTemplate: function (value) {
		if (arguments.length === 1) {

			this.series().markerTemplate(value);
			return value;
		} else {

			return this.series().markerTemplate();
		}
	}

	, 
	markerType: function (value) {
		if (arguments.length === 1) {

			this.series().markerType(value);
			return value;
		} else {

			return this.series().markerType();
		}
	}

	, 
	startCap: function (value) {
		if (arguments.length === 1) {

			this.series().startCap(value);
			return value;
		} else {

			return this.series().actualStartCap();
		}
	}

	, 
	endCap: function (value) {
		if (arguments.length === 1) {

			this.series().endCap(value);
			return value;
		} else {

			return this.series().actualEndCap();
		}
	}
	, 
	$type: new $.ig.Type('StackedSeriesCreatedEventArgs', $.ig.EventArgs.prototype.$type)
}, true);
























































































































$.ig.util.defType('Marker', 'ContentControl', {
	init: function () {


		$.ig.ContentControl.prototype.init.call(this);

	}
	, 
	_brush: null,
	brush: function (value) {
		if (arguments.length === 1) {
			this._brush = value;
			return value;
		} else {
			return this._brush;
		}
	}

	, 
	_outline: null,
	outline: function (value) {
		if (arguments.length === 1) {
			this._outline = value;
			return value;
		} else {
			return this._outline;
		}
	}

	, 
	_canvasZIndex: 0,
	canvasZIndex: function (value) {
		if (arguments.length === 1) {
			this._canvasZIndex = value;
			return value;
		} else {
			return this._canvasZIndex;
		}
	}

	, 
	_currentIndex: 0,
	currentIndex: function (value) {
		if (arguments.length === 1) {
			this._currentIndex = value;
			return value;
		} else {
			return this._currentIndex;
		}
	}

	, 
	_markerBucket: 0,
	markerBucket: function (value) {
		if (arguments.length === 1) {
			this._markerBucket = value;
			return value;
		} else {
			return this._markerBucket;
		}
	}
	, 
	_renderOffsetX: 0
	, 
	_renderOffsetY: 0
	, 
	$type: new $.ig.Type('Marker', $.ig.ContentControl.prototype.$type)
}, true);


$.ig.util.defType('CategoryMarkerManager', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	rasterizeMarkers: function (series, markerLocations, markers, lightweight) {
		var hasMarkers = series.shouldDisplayMarkers();
		if (markers == null) {
			return;
		}

		if (hasMarkers) {
			for (var i = 0; i < markerLocations.count(); ++i) {
				$.ig.CategoryMarkerManager.prototype.positionMarker(markers, i, markerLocations, lightweight);
			}

			markers.count(markerLocations.count());
		}

	}

	, 
	positionMarker: function (markers, i, markerLocations, lightweight) {
		markers.item(i).canvasLeft(markerLocations.__inner[i].__x);
		markers.item(i).canvasTop(markerLocations.__inner[i].__y);
	}
	, 
	$type: new $.ig.Type('CategoryMarkerManager', $.ig.Object.prototype.$type)
}, true);




















$.ig.util.defType('DefaultCategoryTrendlineHost', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.__trendLinePreparer = new $.ig.DefaultCategoryTrendlinePreparer();
	}
	, 
	__trendLinePreparer: null

	, 
	trendlinePreparer: function () {

			return this.__trendLinePreparer;
	}

	, 
	trendLineType: function () {

			return $.ig.TrendLineType.prototype.none;
	}

	, 
	trendLinePeriod: function () {

			return 1;
	}
	, 
	$type: new $.ig.Type('DefaultCategoryTrendlineHost', $.ig.Object.prototype.$type, [$.ig.IHasCategoryTrendline.prototype.$type])
}, true);

$.ig.util.defType('DefaultCategoryTrendlinePreparer', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	prepareLine: function (flattenedPoints, trendLineType, valueColumn, period, getScaledXValue, getScaledYValue, trendResolutionParams) {
	}
	, 
	$type: new $.ig.Type('DefaultCategoryTrendlinePreparer', $.ig.Object.prototype.$type, [$.ig.IPreparesCategoryTrendline.prototype.$type])
}, true);

$.ig.util.defType('TrendResolutionParams', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	_firstBucket: 0,
	firstBucket: function (value) {
		if (arguments.length === 1) {
			this._firstBucket = value;
			return value;
		} else {
			return this._firstBucket;
		}
	}

	, 
	_lastBucket: 0,
	lastBucket: function (value) {
		if (arguments.length === 1) {
			this._lastBucket = value;
			return value;
		} else {
			return this._lastBucket;
		}
	}

	, 
	_bucketSize: 0,
	bucketSize: function (value) {
		if (arguments.length === 1) {
			this._bucketSize = value;
			return value;
		} else {
			return this._bucketSize;
		}
	}

	, 
	_viewport: null,
	viewport: function (value) {
		if (arguments.length === 1) {
			this._viewport = value;
			return value;
		} else {
			return this._viewport;
		}
	}

	, 
	_window: null,
	window: function (value) {
		if (arguments.length === 1) {
			this._window = value;
			return value;
		} else {
			return this._window;
		}
	}

	, 
	_resolution: 0,
	resolution: function (value) {
		if (arguments.length === 1) {
			this._resolution = value;
			return value;
		} else {
			return this._resolution;
		}
	}

	, 
	_offset: 0,
	offset: function (value) {
		if (arguments.length === 1) {
			this._offset = value;
			return value;
		} else {
			return this._offset;
		}
	}
	, 
	$type: new $.ig.Type('TrendResolutionParams', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('TrendFitCalculator', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	calculateFit: function (trend, trendLineType, trendResolutionParams, trendCoefficients, count, GetUnscaledX, GetUnscaledY, GetScaledXValue, GetScaledYValue, xmin, xmax) {
		if (trendCoefficients == null) {
			switch (trendLineType) {
				case $.ig.TrendLineType.prototype.linearFit:
					trendCoefficients = $.ig.LeastSquaresFit.prototype.linearFit(count, GetUnscaledX, GetUnscaledY);
					break;
				case $.ig.TrendLineType.prototype.quadraticFit:
					trendCoefficients = $.ig.LeastSquaresFit.prototype.quadraticFit(count, GetUnscaledX, GetUnscaledY);
					break;
				case $.ig.TrendLineType.prototype.cubicFit:
					trendCoefficients = $.ig.LeastSquaresFit.prototype.cubicFit(count, GetUnscaledX, GetUnscaledY);
					break;
				case $.ig.TrendLineType.prototype.quarticFit:
					trendCoefficients = $.ig.LeastSquaresFit.prototype.quarticFit(count, GetUnscaledX, GetUnscaledY);
					break;
				case $.ig.TrendLineType.prototype.quinticFit:
					trendCoefficients = $.ig.LeastSquaresFit.prototype.quinticFit(count, GetUnscaledX, GetUnscaledY);
					break;
				case $.ig.TrendLineType.prototype.exponentialFit:
					trendCoefficients = $.ig.LeastSquaresFit.prototype.exponentialFit(count, GetUnscaledX, GetUnscaledY);
					break;
				case $.ig.TrendLineType.prototype.logarithmicFit:
					trendCoefficients = $.ig.LeastSquaresFit.prototype.logarithmicFit(count, GetUnscaledX, GetUnscaledY);
					break;
				case $.ig.TrendLineType.prototype.powerLawFit:
					trendCoefficients = $.ig.LeastSquaresFit.prototype.powerLawFit(count, GetUnscaledX, GetUnscaledY);
					break;
				default:
					throw new $.ig.NotImplementedException(0);
			}

		}

		if (trendCoefficients == null) {
			return null;
		}

		for (var i = 0; i < trendResolutionParams.viewport().width(); i += 2) {
			var p = i / (trendResolutionParams.viewport().width() - 1);
			var xi = xmin + p * (xmax - xmin);
			var yi = NaN;
			switch (trendLineType) {
				case $.ig.TrendLineType.prototype.linearFit:
					yi = $.ig.LeastSquaresFit.prototype.linearEvaluate(trendCoefficients, xi);
					break;
				case $.ig.TrendLineType.prototype.quadraticFit:
					yi = $.ig.LeastSquaresFit.prototype.quadraticEvaluate(trendCoefficients, xi);
					break;
				case $.ig.TrendLineType.prototype.cubicFit:
					yi = $.ig.LeastSquaresFit.prototype.cubicEvaluate(trendCoefficients, xi);
					break;
				case $.ig.TrendLineType.prototype.quarticFit:
					yi = $.ig.LeastSquaresFit.prototype.quarticEvaluate(trendCoefficients, xi);
					break;
				case $.ig.TrendLineType.prototype.quinticFit:
					yi = $.ig.LeastSquaresFit.prototype.quinticEvaluate(trendCoefficients, xi);
					break;
				case $.ig.TrendLineType.prototype.exponentialFit:
					yi = $.ig.LeastSquaresFit.prototype.exponentialEvaluate(trendCoefficients, xi);
					break;
				case $.ig.TrendLineType.prototype.logarithmicFit:
					yi = $.ig.LeastSquaresFit.prototype.logarithmicEvaluate(trendCoefficients, xi);
					break;
				case $.ig.TrendLineType.prototype.powerLawFit:
					yi = $.ig.LeastSquaresFit.prototype.powerLawEvaluate(trendCoefficients, xi);
					break;
				default:
					throw new $.ig.NotImplementedException(0);
			}

			xi = GetScaledXValue(xi);
			yi = GetScaledYValue(yi);
			if (!$.ig.util.isNaN(yi) && !Number.isInfinity(yi)) {
				trend.add({__x: xi + trendResolutionParams.offset(), __y: yi, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			}

		}

		return trendCoefficients;
	}
	, 
	$type: new $.ig.Type('TrendFitCalculator', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('TrendAverageCalculator', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	getAverage: function (trendLineType, sourceColumn, period) {
		var average;
		switch (trendLineType) {
			case $.ig.TrendLineType.prototype.simpleAverage:
			case $.ig.TrendLineType.prototype.exponentialAverage:
			case $.ig.TrendLineType.prototype.modifiedAverage:
			case $.ig.TrendLineType.prototype.weightedAverage:
				if (period < 1) {
					period = 1;
				}

				break;
		}

		switch (trendLineType) {
			case $.ig.TrendLineType.prototype.simpleAverage:
				average = $.ig.Series.prototype.sMA(sourceColumn, period);
				break;
			case $.ig.TrendLineType.prototype.exponentialAverage:
				average = $.ig.Series.prototype.eMA(sourceColumn, period);
				break;
			case $.ig.TrendLineType.prototype.modifiedAverage:
				average = $.ig.Series.prototype.mMA(sourceColumn, period);
				break;
			case $.ig.TrendLineType.prototype.cumulativeAverage:
				average = $.ig.Series.prototype.cMA(sourceColumn);
				break;
			case $.ig.TrendLineType.prototype.weightedAverage:
				average = $.ig.Series.prototype.wMA(sourceColumn, period);
				break;
			default:
				throw new $.ig.NotImplementedException(0);
		}

		return average;
	}

	, 
	calculateSingleValueAverage: function (trendLineType, trendColumn, valueColumn, period) {
		if (trendColumn.count() == 0) {
			var average = $.ig.TrendAverageCalculator.prototype.getAverage(trendLineType, valueColumn, period);
			var en = average.getEnumerator();
			while (en.moveNext()) {
				var d = en.current();
				trendColumn.add(d);
			}

		}

	}

	, 
	calculateXYAverage: function (trendLineType, trendColumn, XColumn, YColumn, period) {
		if (trendColumn.count() == 0) {
			var xAverage = $.ig.TrendAverageCalculator.prototype.getAverage(trendLineType, XColumn, period).getEnumerator();
			var yAverage = $.ig.TrendAverageCalculator.prototype.getAverage(trendLineType, YColumn, period).getEnumerator();
			while (xAverage.moveNext() && yAverage.moveNext()) {
				trendColumn.add({__x: xAverage.current(), __y: yAverage.current(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});

			}
		}

	}
	, 
	$type: new $.ig.Type('TrendAverageCalculator', $.ig.Object.prototype.$type)
}, true);




$.ig.util.defType('SortingTrendLineManager', 'CategoryTrendLineManagerBase', {
	init: function (getUnscaledXValueFromUnsortedIndex, getUnscaledXValue) {



		$.ig.CategoryTrendLineManagerBase.prototype.init.call(this);
			this.getUnscaledValueFromUnsortedIndex(getUnscaledXValueFromUnsortedIndex);
			this.getUnscaledXValue(getUnscaledXValue);
	}

	, 
	_getUnscaledValueFromUnsortedIndex: null,
	getUnscaledValueFromUnsortedIndex: function (value) {
		if (arguments.length === 1) {
			this._getUnscaledValueFromUnsortedIndex = value;
			return value;
		} else {
			return this._getUnscaledValueFromUnsortedIndex;
		}
	}

	, 
	_getUnscaledXValue: null,
	getUnscaledXValue: function (value) {
		if (arguments.length === 1) {
			this._getUnscaledXValue = value;
			return value;
		} else {
			return this._getUnscaledXValue;
		}
	}

	, 
	prepareLine: function (flattenedPoints, trendLineType, valueColumn, period, GetScaledXValue, GetScaledYValue, trendResolutionParams) {
		var $self = this;
		var xmin = trendResolutionParams.firstBucket() * trendResolutionParams.bucketSize();
		var xmax = trendResolutionParams.lastBucket() * trendResolutionParams.bucketSize();
		var trend = new $.ig.List$1($.ig.Point.prototype.$type, 0);
		if (trendLineType == $.ig.TrendLineType.prototype.none) {
			$self.trendCoefficients(null);
			$self.trendColumn().clear();
			return;
		}

		if ($self.isFit(trendLineType)) {
			$self.trendColumn().clear();
			$self.trendCoefficients($.ig.TrendFitCalculator.prototype.calculateFit(trend, trendLineType, trendResolutionParams, $self.trendCoefficients(), valueColumn.count(), function (x) { return (x + 1); }, function (i) { return valueColumn.item(i); }, function (x) {
				var floor = $.ig.truncate(Math.floor(x));
				var ceil = $.ig.truncate(Math.ceil(x));
				var p = x - floor;
				var unscaled;
				if (ceil <= xmax) {
					unscaled = $self.getUnscaledValueFromUnsortedIndex()(floor) + p * ($self.getUnscaledValueFromUnsortedIndex()(ceil) - $self.getUnscaledValueFromUnsortedIndex()(floor));

				} else {
					unscaled = $self.getUnscaledValueFromUnsortedIndex()(floor) + p * ($self.getUnscaledValueFromUnsortedIndex()($.ig.truncate(xmax)) - $self.getUnscaledValueFromUnsortedIndex()(floor));
				}

				return GetScaledXValue(unscaled);
			}, GetScaledYValue, xmin, xmax));
		}

		if ($self.isAverage(trendLineType)) {
			$self.trendCoefficients(null);
			$.ig.TrendAverageCalculator.prototype.calculateSingleValueAverage(trendLineType, $self.trendColumn(), valueColumn, period);
			for (var i = trendResolutionParams.firstBucket(); i <= trendResolutionParams.lastBucket(); i += 1) {
				var itemIndex = i * trendResolutionParams.bucketSize();
				var unscaledX = $self.getUnscaledValueFromUnsortedIndex()(itemIndex);
				if (itemIndex >= 0 && itemIndex < $self.trendColumn().count()) {
					var xi = GetScaledXValue(unscaledX);
					var yi = GetScaledYValue($self.trendColumn().__inner[itemIndex]);
					trend.add({__x: xi + trendResolutionParams.offset(), __y: yi, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
				}

			}

		}

		$self.flattenTrendLine(trend, trendResolutionParams, flattenedPoints);
	}
	, 
	$type: new $.ig.Type('SortingTrendLineManager', $.ig.CategoryTrendLineManagerBase.prototype.$type)
}, true);

























































































$.ig.util.defType('FragmentBase', 'HorizontalAnchoredCategorySeries', {
	init: function () {

		this.__parentSeries = null;

		$.ig.HorizontalAnchoredCategorySeries.prototype.init.call(this);

	}
	, 
	_logicalSeriesLink: null,
	logicalSeriesLink: function (value) {
		if (arguments.length === 1) {
			this._logicalSeriesLink = value;
			return value;
		} else {
			return this._logicalSeriesLink;
		}
	}
	, 
	__parentSeries: null

	, 
	parentSeries: function (value) {
		if (arguments.length === 1) {

			this.__parentSeries = value;
			return value;
		} else {

			return this.__parentSeries;
		}
	}

	, 
	isHighlightingSupported: function () {

			return false;
	}

	, 
	isDropShadowSupported: function () {

			return false;
	}

	, 
	getCategoryAxis: function () {
		if (this.parentSeries() == null) {
			return null;
		}

		return this.parentSeries().getXAxis();
	}

	, 
	prepareMarker: function (markersHost, frame, bucket, collisionAvoider, value, itemIndex, markerCount, markerBucket) {
		var x = bucket[0];
		var y = bucket[1];
		var markerRect = new $.ig.Rect(0, x - 5, y - 5, 11, 11);
		if (!$.ig.util.isNaN(x) && !$.ig.util.isNaN(y) && !Number.isInfinity(x) && !Number.isInfinity(y) && collisionAvoider.tryAdd(markerRect)) {
			frame._markers.add({__x: x, __y: y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			markersHost.updateMarkerTemplate(markerCount, itemIndex, markerBucket);
			return true;
		}

		return false;
	}

	, 
	prepareFrame: function (frame, view) {
		frame.clearFrame();
		if (this.valueColumn() == null || this.parentSeries() == null || this.logicalSeriesLink() == null) {
		return;
		}

		if (this.logicalSeriesLink().lowValues().count() == 0 || this.logicalSeriesLink().highValues().count() == 0) {
		return;
		}

		this.getFramePreparer(view).prepareFrame(frame, view);
	}

	, 
	terminatePolygon1: function (polygon, buckets, view) {
		var worldZeroValue = this.getWorldZeroValue(view);
		var zero = worldZeroValue;
		var positive = this.logicalSeriesLink().positive();
		var seriesCollection = positive ? this.parentSeries().stackedSeriesManager().positiveSeries() : this.parentSeries().stackedSeriesManager().negativeSeries();
		var seriesIndex = seriesCollection.indexOf(this);
		if (polygon.count() == 0) {
		return;
		}

		if (seriesIndex == -1) {
		return;
		}

		var foundValidSeries = false;
		for (var index = seriesIndex; index >= 0; index--) {
			if (foundValidSeries) {
			break;
			}

			if (index == 0) {
				polygon.add({__x: $.ig.Enumerable.prototype.last$1($.ig.Point.prototype.$type, polygon).__x, __y: zero, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
				polygon.add({__x: $.ig.Enumerable.prototype.first$1($.ig.Point.prototype.$type, polygon).__x, __y: zero, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
				break;
			}

			var previousSeries = $.ig.util.cast($.ig.FragmentBase.prototype.$type, seriesCollection.__inner[index - 1]);
			if (previousSeries != null && previousSeries.lineRasterizer() != null && previousSeries.lineRasterizer().flattenedLinePoints().count() > 0 && this.view() != null && previousSeries.validateSeries(this.view().viewport(), this.view().windowRect(), this.view())) {
				foundValidSeries = true;
				for (var i = previousSeries.lineRasterizer().flattenedLinePoints().count() - 1; i >= 0; i--) {
					polygon.add(previousSeries.lineRasterizer().flattenedLinePoints().__inner[i]);
				}

			}

		}

	}

	, 
	validateSeries: function (viewportRect, windowRect, view) {
		var isValid = $.ig.HorizontalAnchoredCategorySeries.prototype.validateSeries.call(this, viewportRect, windowRect, view);
		var xAxis = $.ig.util.cast($.ig.CategoryAxisBase.prototype.$type, this.parentSeries().getXAxis());
		var yAxis = this.parentSeries().getYAxis();
		if (this.parentSeries() == null || xAxis == null || xAxis.itemsSource() == null || yAxis == null || this.parentSeries().fastItemsSource() == null || xAxis.seriesViewer() == null || yAxis.seriesViewer() == null) {
			isValid = false;
		}

		if (this.valueColumn() == null) {
			return false;
		}

		if (Number.isInfinity(this.valueColumn().minimum()) && Number.isInfinity(this.valueColumn().maximum())) {
			isValid = false;
		}

		if ($.ig.util.isNaN(this.valueColumn().minimum()) && $.ig.util.isNaN(this.valueColumn().maximum())) {
			isValid = false;
		}

		return isValid;
	}

	, 
	getWorldZeroValue: function (view) {
		var value = 0;
		var windowRect = view.windowRect();
		var viewportRect = view.viewport();
		var yParams = new $.ig.ScalerParams(windowRect, viewportRect, this.yAxis().isInverted());
		if (!windowRect.isEmpty() && !viewportRect.isEmpty() && this.yAxis() != null) {
			value = this.yAxis().getScaledValue(0, yParams);
		}

		return value;
	}

	, 
	getRange: function (axis) {
		return null;
	}

	, 
	getLegendItemIndex: function () {
		if (this.parentSeries() == null) {
		return -1;
		}

		var index = this.parentSeries().index();
		var list = new $.ig.PointCollection(0);
		list.reverse();
		var toEnumerate = this.parentSeries().actualSeries();
		if (this.parentSeries().reverseLegendOrder()) {
			toEnumerate = $.ig.Enumerable.prototype.reverse$1($.ig.StackedFragmentSeries.prototype.$type, this.parentSeries().actualSeries());
		}

		var en = toEnumerate.getEnumerator();
		while (en.moveNext()) {
			var series = en.current();
			if (series.visualSeriesLink() == this) {
				return index;
			}

			if (this.parentSeries().actualLegend() == null || series.actualVisibility() != $.ig.Visibility.prototype.visible || series.actualLegendItemVisibility() != $.ig.Visibility.prototype.visible) {
				continue;
			}

			index++;
		}

		return -1;
	}

	, 
	updateLegend: function (legend) {
		if (legend == null) {
		}

	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		$.ig.HorizontalAnchoredCategorySeries.prototype.propertyUpdatedOverride.call(this, sender, propertyName, oldValue, newValue);
		if (this.parentSeries() == null) {
		return;
		}

		var yAxis = $.ig.util.cast($.ig.NumericAxisBase.prototype.$type, this.parentSeries().getYAxis());
		if (yAxis == null) {
		return;
		}

		switch (propertyName) {
			case $.ig.AnchoredCategorySeries.prototype.valueColumnPropertyName:
				this.anchoredView().trendLineManager().reset();
				if (yAxis != null && !yAxis.updateRange()) {
					this.parentSeries().getSeriesView().bucketCalculator().calculateBuckets(this.resolution());
					this.renderSeries(false);
				}

				break;
		}

	}

	, 
	renderThumbnail: function (viewportRect, surface) {
		$.ig.HorizontalAnchoredCategorySeries.prototype.renderThumbnail.call(this, viewportRect, surface);
	}
	, 
	$type: new $.ig.Type('FragmentBase', $.ig.HorizontalAnchoredCategorySeries.prototype.$type)
}, true);

$.ig.util.defType('AreaFragment', 'FragmentBase', {
	init: function () {



		$.ig.FragmentBase.prototype.init.call(this);
			this.defaultStyleKey($.ig.AreaFragment.prototype.$type);
	}

	, 
	createView: function () {
		return new $.ig.AreaFragmentView(this);
	}

	, 
	_areaFragmentView: null,
	areaFragmentView: function (value) {
		if (arguments.length === 1) {
			this._areaFragmentView = value;
			return value;
		} else {
			return this._areaFragmentView;
		}
	}

	, 
	onViewCreated: function (view) {
		$.ig.FragmentBase.prototype.onViewCreated.call(this, view);
		this.areaFragmentView(view);
	}

	, 
	preferredCategoryMode: function (axis) {
		return $.ig.CategoryMode.prototype.mode0;
	}

	, 
	clearRendering: function (wipeClean, view) {
		$.ig.FragmentBase.prototype.clearRendering.call(this, wipeClean, view);
		var areaFragmentView = view;
		areaFragmentView.clearRendering();
	}

	, 
	renderFrame: function (frame, view) {
		var $self = this;
		$.ig.FragmentBase.prototype.renderFrame.call($self, frame, view);
		$self.lineRasterizer().isSortingAxis($.ig.util.cast($.ig.ISortingAxis.prototype.$type, $self.xAxis()) !== null ? true : false);
		var areaView = $.ig.util.cast($.ig.AreaFragmentView.prototype.$type, view);
		var bucketSize = areaView.bucketCalculator()._bucketSize;
		$self.lineRasterizer().rasterizePolygonPaths(areaView._polygon0, areaView._polyline0, areaView._polygon1, areaView._polyline1, frame._buckets.count(), frame._buckets, true, bucketSize, $self.resolution(), function (p0, l0, p01, l1, f) { $self.terminatePolygon1(p0, frame._buckets, view); }, $.ig.UnknownValuePlotting.prototype.linearInterpolate);
		areaView._polygon0.__opacity = $self.actualAreaFillOpacity();
		areaView._polygon1.__opacity = 0.5 * $self.actualAreaFillOpacity();
	}

	, 
	updateActualAreaFillOpacity: function () {
		var chart = ($.ig.util.cast($.ig.XamDataChart.prototype.$type, this.seriesViewer()));
		if (chart != null) {
			this.actualAreaFillOpacity($.ig.util.isNaN(this.areaFillOpacity()) ? this.parentSeries().actualAreaFillOpacity() : this.areaFillOpacity());
		}

	}
	, 
	$type: new $.ig.Type('AreaFragment', $.ig.FragmentBase.prototype.$type)
}, true);

$.ig.util.defType('AreaFragmentView', 'AnchoredCategorySeriesView', {

	_areaFragmentModel: null,
	areaFragmentModel: function (value) {
		if (arguments.length === 1) {
			this._areaFragmentModel = value;
			return value;
		} else {
			return this._areaFragmentModel;
		}
	}

	, 
	onInit: function () {
		var $self = this;
		$.ig.AnchoredCategorySeriesView.prototype.onInit.call($self);
		if (!$self.isThumbnailView()) {
			$self.model().legendItemBadgeTemplate((function () { var $ret = new $.ig.DataTemplate();
			$ret.render($.ig.LegendTemplates.prototype.rectBadgeTemplate);
			$ret.measure($.ig.LegendTemplates.prototype.legendItemBadgeMeasure); return $ret;}()));
		}

	}
	, 
	init: function (model) {


		this._polygon0 = new $.ig.Path();
		this._polyline0 = new $.ig.Path();
		this._polygon1 = new $.ig.Path();
		this._polyline1 = new $.ig.Path();

		$.ig.AnchoredCategorySeriesView.prototype.init.call(this, model);
			this.areaFragmentModel(model);
	}
	, 
	_polygon0: null
	, 
	_polyline0: null
	, 
	_polygon1: null
	, 
	_polyline1: null

	, 
	clearRendering: function () {
		this._polygon0.data(null);
		this._polygon1.data(null);
		this._polyline0.data(null);
		this._polyline1.data(null);
	}

	, 
	createBucketCalculator: function () {
		return new $.ig.AreaFragmentBucketCalculator(this);
	}

	, 
	setupAppearanceOverride: function () {
		$.ig.AnchoredCategorySeriesView.prototype.setupAppearanceOverride.call(this);
		this._polygon0.__fill = this.model().actualBrush();
		this._polygon1.__fill = this.model().actualBrush();
		this._polygon0.__opacity = this.model().actualAreaFillOpacity();
		this._polygon1.__opacity = 0.5 * this.model().actualAreaFillOpacity();
		this._polyline0.__stroke = this.model().actualOutline();
		this._polyline0.strokeThickness(this.model().thickness());
		this._polyline0.strokeDashArray(this.model().dashArray());
		this._polyline0.strokeDashCap(this.model().dashCap());
		this._polyline1.__stroke = this.model().actualOutline();
		this._polyline1.strokeThickness(this.model().thickness());
		this._polyline1.strokeDashArray(this.model().dashArray());
		this._polyline1.strokeDashCap(this.model().dashCap());
	}

	, 
	setupHitAppearanceOverride: function () {
		$.ig.AnchoredCategorySeriesView.prototype.setupHitAppearanceOverride.call(this);
		var hitBrush = this.getHitBrush();
		this._polygon0.__fill = hitBrush;
		this._polygon1.__fill = hitBrush;
		this._polygon0.__opacity = 1;
		this._polygon1.__opacity = 1;
		this._polyline0.__stroke = hitBrush;
		this._polyline0.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
		this._polyline1.__stroke = hitBrush;
		this._polyline1.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
	}

	, 
	renderOverride: function (context, isHitContext) {
		$.ig.AnchoredCategorySeriesView.prototype.renderOverride.call(this, context, isHitContext);
		context.renderPath(this._polygon0);
		context.renderPath(this._polygon1);
		context.renderPath(this._polyline0);
		context.renderPath(this._polyline1);
	}

	, 
	index: function () {

			return this.areaFragmentModel().parentSeries().stackedView().index();
	}

	, 
	exportViewShapes: function (svd) {
		$.ig.AnchoredCategorySeriesView.prototype.exportViewShapes.call(this, svd);
		var lowerShape = new $.ig.PathVisualData(1, "lowerShape", this._polyline0);
		lowerShape.tags().add("Lower");
		var upperShape = new $.ig.PathVisualData(1, "upperShape", this._polyline1);
		upperShape.tags().add("Upper");
		upperShape.tags().add("Main");
		var translucent = new $.ig.PathVisualData(1, "translucentShape", this._polygon0);
		translucent.tags().add("Translucent");
		var fill = new $.ig.PathVisualData(1, "fillShape", this._polygon1);
		fill.tags().add("Fill");
		svd.shapes().add(lowerShape);
		svd.shapes().add(upperShape);
		svd.shapes().add(translucent);
		svd.shapes().add(fill);
	}
	, 
	$type: new $.ig.Type('AreaFragmentView', $.ig.AnchoredCategorySeriesView.prototype.$type)
}, true);

$.ig.util.defType('ColumnFragment', 'FragmentBase', {
	init: function () {



		$.ig.FragmentBase.prototype.init.call(this);
			this.defaultStyleKey($.ig.ColumnFragment.prototype.$type);
	}

	, 
	createView: function () {
		return new $.ig.ColumnFragmentView(this);
	}

	, 
	_columnFragmentView: null,
	columnFragmentView: function (value) {
		if (arguments.length === 1) {
			this._columnFragmentView = value;
			return value;
		} else {
			return this._columnFragmentView;
		}
	}

	, 
	onViewCreated: function (view) {
		$.ig.FragmentBase.prototype.onViewCreated.call(this, view);
		this.columnFragmentView(view);
	}

	, 
	radiusX: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.ColumnFragment.prototype.radiusXProperty, value);
			return value;
		} else {

			return this.getValue($.ig.ColumnFragment.prototype.radiusXProperty);
		}
	}

	, 
	radiusY: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.ColumnFragment.prototype.radiusYProperty, value);
			return value;
		} else {

			return this.getValue($.ig.ColumnFragment.prototype.radiusYProperty);
		}
	}

	, 
	xAxis: function () {

			return this.parentSeries() != null ? $.ig.util.cast($.ig.CategoryAxisBase.prototype.$type, this.parentSeries().getXAxis()) : null;
	}

	, 
	yAxis: function () {

			return this.parentSeries() != null ? $.ig.util.cast($.ig.NumericYAxis.prototype.$type, this.parentSeries().getYAxis()) : null;
	}

	, 
	preferredCategoryMode: function (axis) {
		return $.ig.CategoryMode.prototype.mode2;
	}

	, 
	getXAxis: function () {
		return null;
	}

	, 
	getYAxis: function () {
		return null;
	}

	, 
	clearRendering: function (wipeClean, view) {
		$.ig.FragmentBase.prototype.clearRendering.call(this, wipeClean, view);
		var columnFragmentView = view;
		if (wipeClean && columnFragmentView.columns() != null) {
			this._currentFrame._markers.clear();
			columnFragmentView.columns().count(0);
		}

	}

	, 
	getRange: function (axis) {
		if (this.valueColumn() == null || this.valueColumn().count() == 0) {
			return null;
		}

		return new $.ig.AxisRange(this.valueColumn().minimum(), this.valueColumn().maximum());
	}

	, 
	validateSeries: function (viewportRect, windowRect, view) {
		if (this.parentSeries() == null) {
		return false;
		}

		return this.parentSeries().validateFragmentSeries(this, viewportRect, windowRect, this.getParentView(view));
	}

	, 
	useParentMarkerCanvas: function () {
		return true;
	}

	, 
	item: function (sender, point) {
		var frameworkElement = $.ig.util.cast($.ig.FrameworkElement.prototype.$type, sender);
		var dataContext = frameworkElement != null ? $.ig.util.cast($.ig.DataContext.prototype.$type, frameworkElement.dataContext()) : null;
		var item = dataContext != null ? dataContext.item() : null;
		if (item == null) {
			var viewportRect = this.view().viewport();
			var windowRect = this.seriesViewer() != null ? this.seriesViewer().actualWindowRect() : $.ig.Rect.prototype.empty();
			var world = {__x: windowRect.left() + windowRect.width() * (point.__x - viewportRect.left()) / viewportRect.width(), __y: windowRect.top() + windowRect.height() * (point.__y - viewportRect.top()) / viewportRect.height(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			item = this.getItem(world);
		}

		return item;
	}

	, 
	getItem: function (world) {
		var index = 0;
		if ($.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.xAxis()) !== null) {
			index = this.getItemIndexSorted(world);
			if (index == -1) {
				return null;
			}


		} else {
			index = this.getItemIndex(world);
		}

		return index >= 0 && this.fastItemsSource() != null && index < this.fastItemsSource().count() ? this.fastItemsSource().item(index) : null;
	}

	, 
	getItemIndexSorted: function (world) {
		var windowRect = this.view().windowRect();
		var viewportRect = this.view().viewport();
		if (windowRect.isEmpty() || viewportRect.isEmpty()) {
			return -1;
		}

		var xParams = new $.ig.ScalerParams(windowRect, viewportRect, this.xAxis().isInverted());
		var sorting = $.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.xAxis());
		var left = this.xAxis().getUnscaledValue(viewportRect.left(), xParams);
		var right = this.xAxis().getUnscaledValue(viewportRect.right(), xParams);
		var windowX = (world.__x - windowRect.left()) / windowRect.width();
		var axisValue = left + ((right - left) * windowX);
		if ($.ig.truncate(axisValue) <= $.ig.Date.prototype.minValue().getTime() || $.ig.truncate(axisValue) >= $.ig.Date.prototype.maxValue().getTime()) {
			return -1;
		}

		var itemIndex = sorting.getIndexClosestToUnscaledValue(axisValue);
		return itemIndex;
	}

	, 
	getItemIndex: function (world) {
		if (this.parentSeries() == null) {
		return -1;
		}

		return this.parentSeries().getFragmentItemIndex(world);
	}

	, 
	prepareMarker: function (markersHost, frame, bucket, collisionAvoider, value, itemIndex, markerCount, markerBucket) {
		var zero = 0;
		var x = bucket[0];
		var y = value < zero ? bucket[2] : bucket[1];
		var markerRect = new $.ig.Rect(0, x - 5, y - 5, 11, 11);
		if (!$.ig.util.isNaN(x) && !$.ig.util.isNaN(y) && !Number.isInfinity(x) && !Number.isInfinity(y) && collisionAvoider.tryAdd(markerRect)) {
			frame._markers.add({__x: x, __y: y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			markersHost.updateMarkerTemplate(markerCount, itemIndex, markerBucket);
			return true;
		}

		return false;
	}

	, 
	getParentView: function (view) {
		if (view.isAlternateView()) {
			return this.parentSeries().alternateViews().item(view.alternateViewIdentifier());

		} else if (view == this.thumbnailView()) {
			return this.parentSeries().thumbnailView();

		} else {
			return this.parentSeries().categoryView();
		}


	}

	, 
	renderAlternateView: function (viewportRect, windowRect, surface, viewIdentifier, effectiveScalingRatio) {
		this.ensureAlternateView(viewportRect, windowRect, viewIdentifier, effectiveScalingRatio);
		var view = this.alternateViews().item(viewIdentifier);
		var categorySeriesView = view;
		view.prepAltSurface(surface);
		var parentView = this.getParentView(view);
		parentView.bucketCalculator().calculateBuckets(this.resolution());
		if (this.clearAndAbortIfInvalid1(categorySeriesView)) {
			return;
		}

		if (this.alternateFrame() == null) {
			this.alternateFrame(new $.ig.CategoryFrame(3));
		}

		this.alternateFrame().clearFrame();
		this.prepareFrame(this.alternateFrame(), categorySeriesView);
		this.renderFrame(this.alternateFrame(), categorySeriesView);
	}

	, 
	prepareFrame: function (frame, view) {
		frame.clearFrame();
		if (this.valueColumn() == null || this.parentSeries() == null || this.logicalSeriesLink() == null || this.logicalSeriesLink().highValues().count() == 0 || this.logicalSeriesLink().lowValues().count() == 0) {
			return;
		}

		var parentFrame;
		if (view.isAlternateView()) {
			parentFrame = this.parentSeries().alternateFrame();

		} else if (view == this.thumbnailView()) {
			parentFrame = this.parentSeries()._thumbnailFrame;

		} else {
			parentFrame = this.parentSeries()._currentFrame;
		}


		var parentView = $.ig.util.cast($.ig.CategorySeriesView.prototype.$type, this.getParentView(view));
		frame._buckets.clear();
		frame._markers.clear();
		var firstBucket = parentView.bucketCalculator()._firstBucket;
		var lastbucket = parentView.bucketCalculator()._lastBucket;
		var yScaler = this.parentSeries().framePreparer().categoryBasedHost().yScaler();
		var sortingScaler = $.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.parentSeries().framePreparer().categoryBasedHost().scaler());
		var isLogarithmicYScaler = $.ig.util.cast($.ig.NumericAxisBase.prototype.$type, yScaler) !== null && ($.ig.util.cast($.ig.NumericAxisBase.prototype.$type, yScaler)).isReallyLogarithmic();
		var bucketCalculator = $.ig.util.cast($.ig.StackedBucketCalculator.prototype.$type, parentView.bucketCalculator());
		var bucketSize = parentView.bucketCalculator()._bucketSize;
		var markerCount = 0;
		for (var i = firstBucket; i <= lastbucket; i++) {
			var itemIndex = i * bucketSize;
			if (this.__visibility != $.ig.Visibility.prototype.visible) {
			break;
			}

			if (i >= this.valueColumn().count() || i >= parentFrame._buckets.count() + firstBucket) {
			continue;
			}

			var value = this.valueColumn().item(i);
			var isValidBucket = !isLogarithmicYScaler || (isLogarithmicYScaler && value > 0);
			var bucket;
			if (sortingScaler == null) {
				bucket = bucketCalculator.getBucket1(this, i, i, view.windowRect(), view.viewport(), parentFrame);

			} else {
				bucket = bucketCalculator.getBucket1(this, i, sortingScaler.sortedIndices().__inner[i], view.windowRect(), view.viewport(), parentFrame);
			}

			frame._buckets.add(bucket);
			if (isValidBucket) {
				if (this.prepareMarker(view, frame, bucket, this.framePreparer().categoryBasedHost().provideCollisionDetector(), value, itemIndex, markerCount, i)) {
					markerCount++;
				}

			}

		}

		view.markers().count(markerCount);
	}

	, 
	renderFrame: function (frame, view) {
		$.ig.FragmentBase.prototype.renderFrame.call(this, frame, view);
		if (this.parentSeries() == null) {
			return;
		}

		this.parentSeries().renderFragment(this, frame, view);
		$.ig.CategoryMarkerManager.prototype.rasterizeMarkers(this, frame._markers, view.markers(), this.useLightweightMarkers());
	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		$.ig.FragmentBase.prototype.propertyUpdatedOverride.call(this, sender, propertyName, oldValue, newValue);
	}
	, 
	$type: new $.ig.Type('ColumnFragment', $.ig.FragmentBase.prototype.$type)
}, true);

$.ig.util.defType('BarFragment', 'ColumnFragment', {
	init: function () {



		$.ig.ColumnFragment.prototype.init.call(this);
			this.defaultStyleKey($.ig.BarFragment.prototype.$type);
	}

	, 
	xAxis: function () {

			return this.parentSeries() != null ? (this.parentSeries()).xAxis() : null;
	}

	, 
	yAxis: function () {

			return this.parentSeries() != null ? (this.parentSeries()).yAxis() : null;
	}

	, 
	getCategoryAxis: function () {
		if (this.parentSeries() == null) {
			return null;
		}

		return this.parentSeries().getYAxis();
	}

	, 
	prepareMarker: function (markersHost, frame, bucket, collisionAvoider, value, itemIndex, markerCount, markerBucket) {
		var y = bucket[0];
		var x = value < 0 ? bucket[2] : bucket[1];
		var markerRect = new $.ig.Rect(0, x - 5, y - 5, 11, 11);
		if (!$.ig.util.isNaN(x) && !$.ig.util.isNaN(y) && !Number.isInfinity(x) && !Number.isInfinity(y) && collisionAvoider.tryAdd(markerRect)) {
			frame._markers.add({__x: x, __y: y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			markersHost.updateMarkerTemplate(markerCount, itemIndex, markerBucket);
			return true;
		}

		return false;
	}

	, 
	getItem: function (world) {
		var index = 0;
		if ($.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.yAxis()) !== null) {
			index = this.getItemIndexSorted(world);
			if (index == -1) {
				return null;
			}


		} else {
			index = this.getItemIndex(world);
		}

		return index >= 0 && this.fastItemsSource() != null && index < this.fastItemsSource().count() ? this.fastItemsSource().item(index) : null;
	}

	, 
	getItemIndexSorted: function (world) {
		var windowRect = this.view().windowRect();
		var viewportRect = this.view().viewport();
		if (windowRect.isEmpty() || viewportRect.isEmpty()) {
			return -1;
		}

		var yParams = new $.ig.ScalerParams(windowRect, viewportRect, this.yAxis().isInverted());
		var sorting = $.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.yAxis());
		var top = this.yAxis().getUnscaledValue(viewportRect.top(), yParams);
		var bottom = this.yAxis().getUnscaledValue(viewportRect.bottom(), yParams);
		var windowY = (world.__y - windowRect.top()) / windowRect.height();
		var axisValue = top + ((bottom - top) * windowY);
		if ($.ig.truncate(axisValue) <= $.ig.Date.prototype.minValue().getTime() || $.ig.truncate(axisValue) >= $.ig.Date.prototype.maxValue().getTime()) {
			return -1;
		}

		var itemIndex = sorting.getIndexClosestToUnscaledValue(axisValue);
		return itemIndex;
	}

	, 
	getWorldZeroValue: function (view) {
		var value = 0;
		var windowRect = view.windowRect();
		var viewportRect = view.viewport();
		var xParams = new $.ig.ScalerParams(windowRect, viewportRect, this.xAxis().isInverted());
		if (!windowRect.isEmpty() && !viewportRect.isEmpty() && this.xAxis() != null) {
			value = this.xAxis().getScaledValue(0, xParams);
		}

		return value;
	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		$.ig.ColumnFragment.prototype.propertyUpdatedOverride.call(this, sender, propertyName, oldValue, newValue);
		if (this.parentSeries() == null || this.xAxis() == null) {
		return;
		}

		var xAxis = this.xAxis();
		switch (propertyName) {
			case $.ig.AnchoredCategorySeries.prototype.valueColumnPropertyName:
				this.anchoredView().trendLineManager().reset();
				if (xAxis != null && !xAxis.updateRange()) {
					this.parentSeries().getSeriesView().bucketCalculator().calculateBuckets(this.resolution());
					this.renderSeries(false);
				}

				break;
		}

	}
	, 
	$type: new $.ig.Type('BarFragment', $.ig.ColumnFragment.prototype.$type)
}, true);

$.ig.util.defType('AreaFragmentBucketCalculator', 'AnchoredCategoryBucketCalculator', {
	init: function (view) {



		$.ig.AnchoredCategoryBucketCalculator.prototype.init.call(this, view);
	}

	, 
	getBucket: function (bucket) {
		var $self = this;
		var i0 = Math.min(bucket * $self._bucketSize, $self.anchoredView().anchoredModel().valueColumn().count() - 1);
		var i1 = Math.min(i0 + $self._bucketSize - 1, $self.anchoredView().anchoredModel().valueColumn().count() - 1);
		var min = NaN;
		var max = NaN;
		var fragment = $.ig.util.cast($.ig.FragmentBase.prototype.$type, $self.anchoredView().anchoredModel());
		var parentSeries = fragment.parentSeries();
		for (var i = i0; i <= i1; ++i) {
			var y = $self.anchoredView().anchoredModel().valueColumn().item(i);
			if ($.ig.util.isNaN(y) || Number.isInfinity(y)) {
				y = 0;
			}

			var total = Math.abs(parentSeries.lows()[i]) + parentSeries.highs()[i];
			if ($.ig.util.cast($.ig.IStacked100Series.prototype.$type, parentSeries) !== null) {
				if (total == 0) {
					y = 0;

				} else if (y < 0) {
					y = (fragment.logicalSeriesLink().lowValues().__inner[i] + y) / total * 100;

				} else {
					y = (fragment.logicalSeriesLink().highValues().__inner[i] + y) / total * 100;
				}



			} else {
				y = y < 0 ? fragment.logicalSeriesLink().lowValues().__inner[i] + y : fragment.logicalSeriesLink().highValues().__inner[i] + y;
			}

			if (!$.ig.util.isNaN(min)) {
				if (!$.ig.util.isNaN(y)) {
					min = Math.min(min, y);
					max = Math.max(max, y);
				}


			} else {
				min = y;
				max = y;
			}

		}

		if (!$.ig.util.isNaN(min)) {
			return (function () { var $ret = new Array();
			$ret.add((0.5 * (i0 + i1)));
			$ret.add(min);
			$ret.add(max);return $ret;}());
		}

		return (function () { var $ret = new Array();
		$ret.add((0.5 * (i0 + i1)));
		$ret.add(NaN);
		$ret.add(NaN);return $ret;}());
	}
	, 
	$type: new $.ig.Type('AreaFragmentBucketCalculator', $.ig.AnchoredCategoryBucketCalculator.prototype.$type)
}, true);

$.ig.util.defType('LineFragmentBucketCalculator', 'AnchoredCategoryBucketCalculator', {
	init: function (view) {



		$.ig.AnchoredCategoryBucketCalculator.prototype.init.call(this, view);
	}

	, 
	getBucket: function (bucket) {
		var $self = this;
		var i0 = Math.min(bucket * $self._bucketSize, $self.anchoredView().anchoredModel().valueColumn().count() - 1);
		var i1 = Math.min(i0 + $self._bucketSize - 1, $self.anchoredView().anchoredModel().valueColumn().count() - 1);
		var min = NaN;
		var max = NaN;
		var fragment = $.ig.util.cast($.ig.FragmentBase.prototype.$type, $self.anchoredView().anchoredModel());
		var parentSeries = fragment.parentSeries();
		for (var i = i0; i <= i1; ++i) {
			var y = $self.anchoredView().anchoredModel().valueColumn().item(i);
			var total = Math.abs(parentSeries.lows()[i]) + parentSeries.highs()[i];
			if ($.ig.util.isNaN(y) || Number.isInfinity(y)) {
				y = 0;
			}

			if ($.ig.util.cast($.ig.IStacked100Series.prototype.$type, parentSeries) !== null) {
				if (total == 0) {
					y = 0;

				} else if (y < 0) {
					y = (fragment.logicalSeriesLink().lowValues().__inner[i] + y) / total * 100;

				} else {
					y = (fragment.logicalSeriesLink().highValues().__inner[i] + y) / total * 100;
				}



			} else {
				y = y < 0 ? fragment.logicalSeriesLink().lowValues().__inner[i] + y : fragment.logicalSeriesLink().highValues().__inner[i] + y;
			}

			if (!$.ig.util.isNaN(min)) {
				if (!$.ig.util.isNaN(y)) {
					min = Math.min(min, y);
					max = Math.max(max, y);
				}


			} else {
				min = y;
				max = y;
			}

		}

		if (!$.ig.util.isNaN(min)) {
			return (function () { var $ret = new Array();
			$ret.add((0.5 * (i0 + i1)));
			$ret.add(min);
			$ret.add(max);return $ret;}());
		}

		return (function () { var $ret = new Array();
		$ret.add((0.5 * (i0 + i1)));
		$ret.add(NaN);
		$ret.add(NaN);return $ret;}());
	}
	, 
	$type: new $.ig.Type('LineFragmentBucketCalculator', $.ig.AnchoredCategoryBucketCalculator.prototype.$type)
}, true);

$.ig.util.defType('SplineFragmentBucketCalculator', 'AnchoredCategoryBucketCalculator', {
	init: function (view) {



		$.ig.AnchoredCategoryBucketCalculator.prototype.init.call(this, view);
	}

	, 
	getBucket: function (bucket) {
		var $self = this;
		var i0 = Math.min(bucket * $self._bucketSize, $self.anchoredView().anchoredModel().valueColumn().count() - 1);
		var i1 = Math.min(i0 + $self._bucketSize - 1, $self.anchoredView().anchoredModel().valueColumn().count() - 1);
		var min = NaN;
		var max = NaN;
		var fragment = $.ig.util.cast($.ig.SplineFragmentBase.prototype.$type, $self.anchoredView().anchoredModel());
		var parentSeries = fragment.parentSeries();
		for (var i = i0; i <= i1; ++i) {
			var y = $self.anchoredView().anchoredModel().valueColumn().item(i);
			var total = Math.abs(parentSeries.lows()[i]) + parentSeries.highs()[i];
			if ($.ig.util.isNaN(y) || Number.isInfinity(y)) {
				y = 0;
			}

			if ($.ig.util.cast($.ig.IStacked100Series.prototype.$type, parentSeries) !== null) {
				if (total == 0) {
					y = 0;

				} else if (y < 0) {
					y = (fragment.logicalSeriesLink().lowValues().__inner[i] + y) / total * 100;

				} else {
					y = (fragment.logicalSeriesLink().highValues().__inner[i] + y) / total * 100;
				}



			} else {
				y = y < 0 ? fragment.logicalSeriesLink().lowValues().__inner[i] + y : fragment.logicalSeriesLink().highValues().__inner[i] + y;
			}

			if (!$.ig.util.isNaN(min)) {
				if (!$.ig.util.isNaN(y)) {
					min = Math.min(min, y);
					max = Math.max(max, y);
				}


			} else {
				min = y;
				max = y;
			}

		}

		if (!$.ig.util.isNaN(min)) {
			return (function () { var $ret = new Array();
			$ret.add((0.5 * (i0 + i1)));
			$ret.add(min);
			$ret.add(max);return $ret;}());
		}

		return (function () { var $ret = new Array();
		$ret.add((0.5 * (i0 + i1)));
		$ret.add(NaN);
		$ret.add(NaN);return $ret;}());
	}
	, 
	$type: new $.ig.Type('SplineFragmentBucketCalculator', $.ig.AnchoredCategoryBucketCalculator.prototype.$type)
}, true);

$.ig.util.defType('StackedBucketCalculator', 'CategoryBucketCalculator', {
	init: function (view) {



		$.ig.CategoryBucketCalculator.prototype.init.call(this, view);
	}

	, 
	getBucket: function (index) {
		var $self = this;
		var series = $.ig.util.cast($.ig.StackedSeriesBase.prototype.$type, $self.view().categoryModel());
		var count = Math.min(series.lows() != null ? series.lows().length : 0, series.highs() != null ? series.highs().length : 0);
		var i0 = Math.min(index * $self._bucketSize, count - 1);
		var i1 = Math.min(i0 + $self._bucketSize - 1, count - 1);
		var min = NaN;
		var max = NaN;
		for (var i = i0; i <= i1; ++i) {
			var low = Math.min(series.lows()[i], series.highs()[i]);
			var high = Math.max(series.lows()[i], series.highs()[i]);
			if (!$.ig.util.isNaN(min)) {
				if (!$.ig.util.isNaN(low)) {
					min = Math.min(min, low);
					max = Math.max(max, low);
				}

				if (!$.ig.util.isNaN(high)) {
					min = Math.min(min, high);
					max = Math.max(max, high);
				}


			} else {
				min = low;
				max = high;
			}

		}

		if (!$.ig.util.isNaN(min) && !$.ig.util.isNaN(max)) {
			return (function () { var $ret = new Array();
			$ret.add((0.5 * (i0 + i1)));
			$ret.add(min);
			$ret.add(max);return $ret;}());
		}

		return (function () { var $ret = new Array();
		$ret.add(NaN);
		$ret.add(NaN);
		$ret.add(NaN);return $ret;}());
	}

	, 
	getBucket1: function (series, index, sortingIndex, windowRect, viewportRect, currentFrame) {
		return null;
	}
	, 
	$type: new $.ig.Type('StackedBucketCalculator', $.ig.CategoryBucketCalculator.prototype.$type)
}, true);

$.ig.util.defType('StackedBarBucketCalculator', 'StackedBucketCalculator', {
	init: function (view) {



		$.ig.StackedBucketCalculator.prototype.init.call(this, view);
	}

	, 
	calculateBuckets: function (resolution) {
		var windowRect = this.view().windowRect();
		var viewportRect = this.view().viewport();
		var series = $.ig.util.cast($.ig.StackedBarSeries.prototype.$type, this.view().categoryModel());
		var fastItemsSource = this.view().categoryModel().fastItemsSource();
		if (windowRect.isEmpty() || viewportRect.isEmpty() || series.yAxis() == null || fastItemsSource == null || fastItemsSource.count() == 0) {
			this._bucketSize = 0;
			return;
		}

		var y0 = Math.floor(series.yAxis().getUnscaledValue2(viewportRect.top(), windowRect, viewportRect, $.ig.CategoryMode.prototype.mode0));
		var y1 = Math.ceil(series.yAxis().getUnscaledValue2(viewportRect.bottom(), windowRect, viewportRect, $.ig.CategoryMode.prototype.mode0));
		if (!series.yAxis().isInverted()) {
			y1 = Math.ceil(series.yAxis().getUnscaledValue2(viewportRect.top(), windowRect, viewportRect, $.ig.CategoryMode.prototype.mode0));
			y0 = Math.floor(series.yAxis().getUnscaledValue2(viewportRect.bottom(), windowRect, viewportRect, $.ig.CategoryMode.prototype.mode0));
		}

		var c = Math.floor((y1 - y0 + 1) * resolution / viewportRect.height());
		this._bucketSize = $.ig.truncate(Math.max(1, c));
		this._firstBucket = $.ig.truncate(Math.max(0, Math.floor(y0 / this._bucketSize) - 1));
		this._lastBucket = $.ig.truncate(Math.ceil(y1 / this._bucketSize));
	}

	, 
	getBucket: function (index) {
		return $.ig.StackedBucketCalculator.prototype.getBucket.call(this, index);
	}

	, 
	getBucket1: function (series, index, sortingIndex, windowRect, viewportRect, currentFrame) {
		var $self = this;
		var bucket = (function () { var $ret = new Array();
		$ret.add(NaN);
		$ret.add(NaN);
		$ret.add(NaN);return $ret;}());
		var fragment = $.ig.util.cast($.ig.BarFragment.prototype.$type, series);
		if (fragment == null || fragment.logicalSeriesLink() == null) {
		return bucket;
		}

		var barSeries = $.ig.util.cast($.ig.StackedBarSeries.prototype.$type, $self.view().categoryModel());
		var value = series.valueColumn().item(sortingIndex);
		var zero = 0;
		var min = NaN;
		var max = NaN;
		var high = Number.NEGATIVE_INFINITY;
		var low = Number.POSITIVE_INFINITY;
		var count = Math.min(barSeries.lows() != null ? barSeries.lows().length : 0, barSeries.highs() != null ? barSeries.highs().length : 0);
		var i0 = sortingIndex * $self._bucketSize;
		var i1 = Math.min(i0 + $self._bucketSize - 1, count - 1);
		for (var i = i0; i <= i1; ++i) {
			value = series.valueColumn().item(i);
			if (value < zero) {
				low = Math.min(low, fragment.logicalSeriesLink().lowValues().__inner[i] + value);
				high = Math.max(high, fragment.logicalSeriesLink().lowValues().__inner[i]);

			} else {
				low = Math.min(low, fragment.logicalSeriesLink().highValues().__inner[i]);
				high = Math.max(high, fragment.logicalSeriesLink().highValues().__inner[i] + value);
			}

			if (!$.ig.util.isNaN(min)) {
				if (!$.ig.util.isNaN(low)) {
					min = Math.min(min, low);
					max = Math.max(max, low);
				}

				if (!$.ig.util.isNaN(high)) {
					min = Math.min(min, high);
					max = Math.max(max, high);
				}


			} else {
				min = low;
				max = high;
			}

		}

		var xParams = new $.ig.ScalerParams(windowRect, viewportRect, barSeries.xAxis().isInverted());
		bucket = [ currentFrame._buckets.__inner[index - $self._firstBucket][0], barSeries.xAxis().getScaledValue(max, xParams), barSeries.xAxis().getScaledValue(min, xParams) ];
		return bucket;
	}
	, 
	$type: new $.ig.Type('StackedBarBucketCalculator', $.ig.StackedBucketCalculator.prototype.$type)
}, true);


$.ig.util.defType('StackedColumnBucketCalculator', 'StackedBucketCalculator', {
	init: function (view) {



		$.ig.StackedBucketCalculator.prototype.init.call(this, view);
	}

	, 
	getBucket: function (index) {
		return $.ig.StackedBucketCalculator.prototype.getBucket.call(this, index);
	}

	, 
	getBucket1: function (series, index, sortingIndex, windowRect, viewportRect, currentFrame) {
		var $self = this;
		var bucket = (function () { var $ret = new Array();
		$ret.add(NaN);
		$ret.add(NaN);
		$ret.add(NaN);return $ret;}());
		var fragment = $.ig.util.cast($.ig.ColumnFragment.prototype.$type, series);
		if (fragment == null || fragment.logicalSeriesLink() == null) {
		return bucket;
		}

		var columnSeries = $.ig.util.cast($.ig.StackedColumnSeries.prototype.$type, $self.view().categoryModel());
		var value = series.valueColumn().item(sortingIndex);
		var zero = 0;
		var min = NaN;
		var max = NaN;
		var high = Number.NEGATIVE_INFINITY;
		var low = Number.POSITIVE_INFINITY;
		var count = Math.min(columnSeries.lows() != null ? columnSeries.lows().length : 0, columnSeries.highs() != null ? columnSeries.highs().length : 0);
		var i0 = sortingIndex * $self._bucketSize;
		var i1 = Math.min(i0 + $self._bucketSize - 1, count - 1);
		for (var i = i0; i <= i1; ++i) {
			value = series.valueColumn().item(i);
			if (value < zero) {
				low = Math.min(low, fragment.logicalSeriesLink().lowValues().__inner[i] + value);
				high = Math.max(high, fragment.logicalSeriesLink().lowValues().__inner[i]);

			} else {
				low = Math.min(low, fragment.logicalSeriesLink().highValues().__inner[i]);
				high = Math.max(high, fragment.logicalSeriesLink().highValues().__inner[i] + value);
			}

			if (!$.ig.util.isNaN(min)) {
				if (!$.ig.util.isNaN(low)) {
					min = Math.min(min, low);
					max = Math.max(max, low);
				}

				if (!$.ig.util.isNaN(high)) {
					min = Math.min(min, high);
					max = Math.max(max, high);
				}


			} else {
				min = low;
				max = high;
			}

		}

		var yParams = new $.ig.ScalerParams(windowRect, viewportRect, columnSeries.yAxis().isInverted());
		bucket = [ currentFrame._buckets.__inner[index - $self._firstBucket][0], columnSeries.yAxis().getScaledValue(max, yParams), columnSeries.yAxis().getScaledValue(min, yParams) ];
		return bucket;
	}
	, 
	$type: new $.ig.Type('StackedColumnBucketCalculator', $.ig.StackedBucketCalculator.prototype.$type)
}, true);


$.ig.util.defType('ColumnFragmentView', 'AnchoredCategorySeriesView', {

	_columnFragmentModel: null,
	columnFragmentModel: function (value) {
		if (arguments.length === 1) {
			this._columnFragmentModel = value;
			return value;
		} else {
			return this._columnFragmentModel;
		}
	}

	, 
	onInit: function () {
		var $self = this;
		$.ig.AnchoredCategorySeriesView.prototype.onInit.call($self);
		if (!$self.isThumbnailView()) {
			$self.model().legendItemBadgeTemplate((function () { var $ret = new $.ig.DataTemplate();
			$ret.render($.ig.LegendTemplates.prototype.rectBadgeTemplate);
			$ret.measure($.ig.LegendTemplates.prototype.legendItemBadgeMeasure); return $ret;}()));
		}

	}
	, 
	init: function (model) {



		var $self = this;
		$.ig.AnchoredCategorySeriesView.prototype.init.call(this, model);
			this.columnFragmentModel(model);
			this.high(new $.ig.List$1(Number, 0));
			this.low(new $.ig.List$1(Number, 0));
			this.columns((function () { var $ret = new $.ig.Pool$1($.ig.Rectangle.prototype.$type);
			$ret.create($self.columnCreate.runOn($self));
			$ret.activate($self.columnActivate.runOn($self));
			$ret.disactivate($self.columnDisactivate.runOn($self));
			$ret.destroy($self.columnDestroy.runOn($self)); return $ret;}()));
			this.visibleColumns(new $.ig.List$1($.ig.Rectangle.prototype.$type, 0));
	}

	, 
	_visibleColumns: null,
	visibleColumns: function (value) {
		if (arguments.length === 1) {
			this._visibleColumns = value;
			return value;
		} else {
			return this._visibleColumns;
		}
	}

	, 
	_columns: null,
	columns: function (value) {
		if (arguments.length === 1) {
			this._columns = value;
			return value;
		} else {
			return this._columns;
		}
	}

	, 
	_high: null,
	high: function (value) {
		if (arguments.length === 1) {
			this._high = value;
			return value;
		} else {
			return this._high;
		}
	}

	, 
	_low: null,
	low: function (value) {
		if (arguments.length === 1) {
			this._low = value;
			return value;
		} else {
			return this._low;
		}
	}

	, 
	columnCreate: function () {
		var $self = this;
		var column = (function () { var $ret = new $.ig.Rectangle();
		$ret.dataContext((function () { var $ret = new $.ig.DataContext();
		$ret.series($self.model()); return $ret;}())); return $ret;}());
		$self.visibleColumns().add(column);
		column.__visibility = $.ig.Visibility.prototype.collapsed;
		return column;
	}

	, 
	columnActivate: function (column) {
		column.__visibility = $.ig.Visibility.prototype.visible;
	}

	, 
	columnDisactivate: function (column) {
		column.__visibility = $.ig.Visibility.prototype.collapsed;
	}

	, 
	columnDestroy: function (column) {
		this.visibleColumns().remove(column);
	}

	, 
	setupItemAppearanceOverride: function (item, index) {
		$.ig.AnchoredCategorySeriesView.prototype.setupItemAppearanceOverride.call(this, item, index);
		var column = item;
		column.__fill = this.model().actualBrush();
		column.__stroke = this.model().actualOutline();
		column.strokeThickness(this.model().thickness());
		column.strokeDashArray(this.model().dashArray());
		column.strokeDashCap(this.model().dashCap());
		column.radiusX(this.columnFragmentModel().radiusX());
		column.radiusY(this.columnFragmentModel().radiusY());
	}

	, 
	positionRectangle: function (column, left, top) {
		var dirty = false;
		if (column.canvasTop() != top) {
			dirty = true;
			column.canvasTop(top);
		}

		if (column.canvasLeft() != left) {
			dirty = true;
			column.canvasLeft(left);
		}

		if (dirty) {
			this.makeDirty();
		}

	}

	, 
	setupItemHitAppearanceOverride: function (item, index) {
		$.ig.AnchoredCategorySeriesView.prototype.setupItemHitAppearanceOverride.call(this, item, index);
		var column = item;
		var hitBrush = this.getHitBrush1(index);
		column.__fill = hitBrush;
		column.__stroke = hitBrush;
		column.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
	}

	, 
	renderOverride: function (context, isHitContext) {
		$.ig.AnchoredCategorySeriesView.prototype.renderOverride.call(this, context, isHitContext);
		if (context.shouldRender()) {
			for (var i = 0; i < this.visibleColumns().count(); i++) {
				var column = this.visibleColumns().__inner[i];
				this.setupItemAppearance(column, i, isHitContext);
				context.renderRectangle(column);
			}

		}

	}

	, 
	index: function () {

			return this.columnFragmentModel().parentSeries().stackedView().index();
	}

	, 
	exportViewShapes: function (svd) {
		var $self = this;
		$.ig.AnchoredCategorySeriesView.prototype.exportViewShapes.call($self, svd);
		var i = 0;
		var toSort = new $.ig.List$1($.ig.Rectangle.prototype.$type, 0);
		var en = $self.columns().active().getEnumerator();
		while (en.moveNext()) {
			var column = en.current();
			toSort.add(column);
		}

		toSort.sort2(function (c1, c2) {
			if (c1.canvasLeft() < c2.canvasLeft()) {
				return -1;

			} else if (c1.canvasLeft() > c2.canvasLeft()) {
				return 1;

			} else {
				return 0;
			}


		});
		var en1 = toSort.getEnumerator();
		while (en1.moveNext()) {
			var column1 = en1.current();
			var rvd = new $.ig.RectangleVisualData(1, "column" + i, column1);
			rvd.tags().add("Main");
			svd.shapes().add(rvd);
		}

		i++;
	}

	, 
	getDefaultTooltipTemplate: function () {
		var tooltipTemplate = "<div class=\'ui-chart-default-tooltip-content\'>";
		var axis = null;
		if (this.columnFragmentModel().xAxis().isCategory()) {
			axis = this.columnFragmentModel().xAxis();

		} else if (this.columnFragmentModel().yAxis().isCategory()) {
			axis = this.columnFragmentModel().yAxis();
		}


		var dateTimeAxis = $.ig.util.cast($.ig.CategoryDateTimeXAxis.prototype.$type, axis);
		if (dateTimeAxis != null) {
			tooltipTemplate += "<span>${item." + dateTimeAxis.dateTimeMemberPath() + "}</span><br/>";
		}

		if (axis != null && axis.label() != null) {
			tooltipTemplate += "<span>${item." + axis.label() + "}</span><br/>";
		}

		tooltipTemplate += "<span";
		if (this.model().actualOutline() != null && $.ig.Color.prototype.l_op_Inequality_Lifted($.ig.util.toNullable($.ig.Color.prototype.$type, this.model().actualOutline().color()), $.ig.util.toNullable($.ig.Color.prototype.$type, null))) {
			tooltipTemplate += " style=\'color:" + this.model().actualOutline().__fill + "\'";
		}

		tooltipTemplate += ">" + this.columnFragmentModel().title() + ": </span><span class=\'ui-priority-primary\'>" + "${item." + this.columnFragmentModel().valueMemberPath() + "}</span></div>";
		return tooltipTemplate;
	}
	, 
	$type: new $.ig.Type('ColumnFragmentView', $.ig.AnchoredCategorySeriesView.prototype.$type)
}, true);

$.ig.util.defType('LineFragment', 'FragmentBase', {
	init: function () {



		$.ig.FragmentBase.prototype.init.call(this);
			this.defaultStyleKey($.ig.LineFragment.prototype.$type);
	}

	, 
	createView: function () {
		return new $.ig.LineFragmentView(this);
	}

	, 
	_lineFragmentView: null,
	lineFragmentView: function (value) {
		if (arguments.length === 1) {
			this._lineFragmentView = value;
			return value;
		} else {
			return this._lineFragmentView;
		}
	}

	, 
	onViewCreated: function (view) {
		$.ig.FragmentBase.prototype.onViewCreated.call(this, view);
		this.lineFragmentView(view);
	}

	, 
	preferredCategoryMode: function (axis) {
		return $.ig.CategoryMode.prototype.mode0;
	}

	, 
	clearRendering: function (wipeClean, view) {
		$.ig.FragmentBase.prototype.clearRendering.call(this, wipeClean, view);
		var lineFragmentView = view;
		lineFragmentView.clearLine();
	}

	, 
	renderFrame: function (frame, view) {
		var $self = this;
		$.ig.FragmentBase.prototype.renderFrame.call($self, frame, view);
		var x0 = function (i) {
				return frame._buckets.__inner[i][0];
		};
		var y0 = function (i) {
				return frame._buckets.__inner[i][1];
		};
		var x1 = function (i) {
				return frame._buckets.__inner[i][0];
		};
		var y1 = function (i) {
				return frame._buckets.__inner[i][2];
		};
		$self.lineRasterizer().isSortingAxis($.ig.util.cast($.ig.ISortingAxis.prototype.$type, $self.xAxis()) !== null ? true : false);
		var bucketSize = view.bucketCalculator()._bucketSize;
		var lineFragmentView = $.ig.util.cast($.ig.LineFragmentView.prototype.$type, view);
		$self.lineRasterizer().rasterizePolylinePaths(lineFragmentView._polyline0, lineFragmentView._polygon01, lineFragmentView._polyline1, frame._buckets.count(), frame._buckets, true, $.ig.UnknownValuePlotting.prototype.linearInterpolate, $self.getLineClipper(frame._buckets, frame._buckets.count() - 1, view.viewport(), view.windowRect()), bucketSize, $self.resolution());
	}
	, 
	$type: new $.ig.Type('LineFragment', $.ig.FragmentBase.prototype.$type)
}, true);

$.ig.util.defType('LineFragmentView', 'AnchoredCategorySeriesView', {

	_lineFragmentModel: null,
	lineFragmentModel: function (value) {
		if (arguments.length === 1) {
			this._lineFragmentModel = value;
			return value;
		} else {
			return this._lineFragmentModel;
		}
	}
	, 
	init: function (model) {


		this._polyline0 = new $.ig.Path();
		this._polygon01 = new $.ig.Path();
		this._polyline1 = new $.ig.Path();

		$.ig.AnchoredCategorySeriesView.prototype.init.call(this, model);
			this.lineFragmentModel(model);
	}
	, 
	_polyline0: null
	, 
	_polygon01: null
	, 
	_polyline1: null

	, 
	clearLine: function () {
		this._polygon01.data(null);
		this._polyline0.data(null);
		this._polyline1.data(null);
	}

	, 
	createBucketCalculator: function () {
		return new $.ig.LineFragmentBucketCalculator(this);
	}

	, 
	setupAppearanceOverride: function () {
		$.ig.AnchoredCategorySeriesView.prototype.setupAppearanceOverride.call(this);
		this._polyline0.__stroke = this.model().actualBrush();
		this._polyline0.strokeThickness(this.model().thickness());
		this._polyline0.strokeDashArray(this.model().dashArray());
		this._polyline0.strokeDashCap(this.model().dashCap());
		this._polyline1.__stroke = this.model().actualBrush();
		this._polyline1.strokeThickness(this.model().thickness());
		this._polyline1.strokeDashArray(this.model().dashArray());
		this._polyline1.strokeDashCap(this.model().dashCap());
		this._polygon01.__fill = this.model().actualBrush();
		this._polygon01.__opacity = 0.75;
	}

	, 
	setupHitAppearanceOverride: function () {
		$.ig.AnchoredCategorySeriesView.prototype.setupHitAppearanceOverride.call(this);
		var hitBrush = this.getHitBrush();
		this._polyline0.__stroke = hitBrush;
		this._polyline0.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
		this._polyline1.__stroke = hitBrush;
		this._polyline1.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
		this._polygon01.__fill = hitBrush;
		this._polygon01.__opacity = 1;
	}

	, 
	renderOverride: function (context, isHitContext) {
		$.ig.AnchoredCategorySeriesView.prototype.renderOverride.call(this, context, isHitContext);
		if (context.shouldRender()) {
			context.renderPath(this._polygon01);
			context.renderPath(this._polyline0);
			context.renderPath(this._polyline1);
		}

	}

	, 
	index: function () {

			return this.lineFragmentModel().parentSeries().stackedView().index();
	}

	, 
	exportViewShapes: function (svd) {
		$.ig.AnchoredCategorySeriesView.prototype.exportViewShapes.call(this, svd);
		var lowerShape = new $.ig.PathVisualData(1, "lowerShape", this._polyline0);
		lowerShape.tags().add("Lower");
		lowerShape.tags().add("Main");
		var upperShape = new $.ig.PathVisualData(1, "upperShape", this._polyline1);
		upperShape.tags().add("Upper");
		var translucent = new $.ig.PathVisualData(1, "translucentShape", this._polygon01);
		translucent.tags().add("Translucent");
		svd.shapes().add(lowerShape);
		svd.shapes().add(upperShape);
		svd.shapes().add(translucent);
	}
	, 
	$type: new $.ig.Type('LineFragmentView', $.ig.AnchoredCategorySeriesView.prototype.$type)
}, true);

$.ig.util.defType('SplineFragmentBase', 'SplineSeriesBase', {
	init: function () {

		this.__parentSeries = null;

		$.ig.SplineSeriesBase.prototype.init.call(this);

	}
	, 
	_logicalSeriesLink: null,
	logicalSeriesLink: function (value) {
		if (arguments.length === 1) {
			this._logicalSeriesLink = value;
			return value;
		} else {
			return this._logicalSeriesLink;
		}
	}
	, 
	__parentSeries: null

	, 
	parentSeries: function (value) {
		if (arguments.length === 1) {

			this.__parentSeries = value;
			return value;
		} else {

			return this.__parentSeries;
		}
	}

	, 
	isDropShadowSupported: function () {

			return false;
	}

	, 
	preferredCategoryMode: function (axis) {
		return $.ig.CategoryMode.prototype.mode0;
	}

	, 
	prepareMarker: function (frame, bucket, collisionAvoider, itemIndex, markerCount, view, markerBucket) {
		var x = bucket[0];
		var y = bucket[1];
		var markerRect = new $.ig.Rect(0, x - 5, y - 5, 11, 11);
		if (!$.ig.util.isNaN(x) && !$.ig.util.isNaN(y) && !Number.isInfinity(x) && !Number.isInfinity(y) && collisionAvoider.tryAdd(markerRect)) {
			frame._markers.add({__x: x, __y: y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			var marker = view.markers().item(markerCount);
			($.ig.util.cast($.ig.DataContext.prototype.$type, marker.content())).item(this.fastItemsSource().item(itemIndex));
			marker.markerBucket(markerBucket);
			return true;
		}

		return false;
	}

	, 
	validateSeries: function (viewportRect, windowRect, view) {
		var isValid = $.ig.SplineSeriesBase.prototype.validateSeries.call(this, viewportRect, windowRect, view);
		var xAxis = $.ig.util.cast($.ig.CategoryAxisBase.prototype.$type, this.parentSeries().getXAxis());
		var yAxis = this.parentSeries().getYAxis();
		if (this.parentSeries() == null || xAxis == null || xAxis.itemsSource() == null || yAxis == null || this.parentSeries().fastItemsSource() == null || xAxis.seriesViewer() == null || yAxis.seriesViewer() == null) {
			isValid = false;
		}

		if (this.valueColumn() == null) {
			return false;
		}

		if (Number.isInfinity(this.valueColumn().minimum()) && Number.isInfinity(this.valueColumn().maximum())) {
			isValid = false;
		}

		if ($.ig.util.isNaN(this.valueColumn().minimum()) && $.ig.util.isNaN(this.valueColumn().maximum())) {
			isValid = false;
		}

		return isValid;
	}

	, 
	getRange: function (axis) {
		return null;
	}

	, 
	prepareDateTimeFrame: function (frame, windowRect, viewportRect, xaxis, yaxis, view) {
		var $self = this;
		var sortingXAxis = $.ig.util.cast($.ig.ISortingAxis.prototype.$type, xaxis);
		if (sortingXAxis == null) {
			return;
		}

		var xParams = new $.ig.ScalerParams(windowRect, viewportRect, xaxis.isInverted());
		var yParams = new $.ig.ScalerParams(windowRect, viewportRect, yaxis.isInverted());
		var singlePixelSpan = $self.convertToSingle(xaxis.getUnscaledValue(2, xParams) - xaxis.getUnscaledValue(1, xParams));
		var markers = $self.shouldDisplayMarkers();
		var markerCount = 0;
		var offset = $self.getOffset(xaxis, windowRect, viewportRect);
		var total = function (i) { return Math.abs($self.parentSeries().lows()[i]) + $self.parentSeries().highs()[i]; };
		var xv = function (i) { return i; };
		var yv = function (i) {
			var index = sortingXAxis.sortedIndices().__inner[i];
			if ($.ig.util.cast($.ig.IStacked100Series.prototype.$type, $self.parentSeries()) !== null) {
				return $self.valueColumn().item(index) < 0 ? ($self.logicalSeriesLink().lowValues().__inner[index] + $self.valueColumn().item(index)) / total(index) * 100 : ($self.logicalSeriesLink().highValues().__inner[index] + $self.valueColumn().item(index)) / total(index) * 100;

			} else {
				return $self.valueColumn().item(index) < 0 ? $self.logicalSeriesLink().lowValues().__inner[index] + $self.valueColumn().item(index) : $self.logicalSeriesLink().highValues().__inner[index] + $self.valueColumn().item(index);
			}

		};
		var lastBucket = $self.categoryView().bucketCalculator()._lastBucket;
		var firstBucket = $self.categoryView().bucketCalculator()._firstBucket;
		var n = $.ig.truncate(Math.ceil(viewportRect.width() / (lastBucket - firstBucket)));
		var collisionAvoider = new $.ig.CollisionAvoider();
		var bucketSize = $self.categoryView().bucketCalculator()._bucketSize;
		if (bucketSize <= 0 || (firstBucket <= 0 && lastBucket <= 0)) {
			$self.categoryView().markers().count(markerCount);
			return;
		}

		var bucketCount = 0;
		for (var i = firstBucket; i < lastBucket + 1; ++i) {
			var bucket = null;
			var itemIndex = i * bucketSize;
			if (sortingXAxis != null && sortingXAxis.sortedIndices() != null && itemIndex >= 0 && itemIndex < sortingXAxis.sortedIndices().count()) {
				itemIndex = sortingXAxis.sortedIndices().__inner[itemIndex];
			}

			if (i >= ($self.valueColumn().count() - 1)) {
				if (markers && $self.prepareMarker(frame, $.ig.Enumerable.prototype.last$1($.ig.Array.prototype.$type, frame._buckets), collisionAvoider, Math.min(itemIndex, $self.fastItemsSource().count() - 1), markerCount, view, bucketCount - 1)) {
					++markerCount;
				}

				break;
			}

			var x1 = xv(i);
			var y1 = yv(i);
			var x2 = xv(i + 1);
			var y2 = yv(i + 1);
			var h = x2 - x1;
			var u1 = $self.uColumn()[i];
			var u2 = $self.uColumn()[i + 1];
			var unscaledValue = sortingXAxis.getUnscaledValueAt(sortingXAxis.sortedIndices().__inner[i]);
			var firstPointX = xaxis.getScaledValue(unscaledValue, xParams) + offset;
			var firstPointY = yaxis.getScaledValue(y1, yParams);
			frame._buckets.add((function () { var $ret = new Array();
			$ret.add(firstPointX);
			$ret.add(firstPointY);
			$ret.add(firstPointY);return $ret;}()));
			bucketCount++;
			for (var j = 1; j < n; ++j) {
				var pp = (j) / (n);
				var x = x1 + h * pp;
				var a = (x2 - x) / h;
				var b = (x - x1) / h;
				var y = a * y1 + b * y2 + ((a * a * a - a) * u1 + (b * b * b - b) * u2) * (h * h) / 6;
				var unscaledValueFirst = sortingXAxis.getUnscaledValueAt(sortingXAxis.sortedIndices().__inner[i]);
				var unscaledValueNext = sortingXAxis.getUnscaledValueAt(sortingXAxis.sortedIndices().__inner[i + 1]);
				if (unscaledValueFirst == unscaledValueNext && y1 == y2) {
					break;
				}

				var currentUnscaledValue = unscaledValueFirst + (unscaledValueNext - unscaledValueFirst) * pp;
				x = xaxis.getScaledValue(currentUnscaledValue, xParams) + offset;
				y = yaxis.getScaledValue(y, yParams);
				frame._buckets.add((function () { var $ret = new Array();
				$ret.add(x);
				$ret.add(y);
				$ret.add(y);return $ret;}()));
				bucketCount++;
			}

			if (markers) {
				bucket = (function () { var $ret = new Array();
				$ret.add(firstPointX);
				$ret.add(firstPointY);
				$ret.add(firstPointY);return $ret;}());
			}

			if (markers && $self.prepareMarker(frame, bucket, collisionAvoider, Math.min(itemIndex, $self.fastItemsSource().count() - 1), markerCount, view, bucketCount - 1)) {
				++markerCount;
			}

		}

		$self.categoryView().markers().count(markerCount);
	}

	, 
	prepareFrame: function (frame, view) {
		var $self = this;
		frame.clearFrame();
		if ($self.valueColumn() == null || $self.parentSeries() == null || $self.logicalSeriesLink() == null) {
		return;
		}

		if ($self.logicalSeriesLink().lowValues().count() == 0 || $self.logicalSeriesLink().highValues().count() == 0) {
		return;
		}

		if ($self.categoryView().bucketCalculator()._bucketSize == 0) {
		return;
		}

		$.ig.SplineSeriesBase.prototype.prepareFrame.call($self, frame, view);
		if (frame._buckets.count() <= 1) {
			return;
		}

		var windowRect = view.windowRect();
		var viewportRect = view.viewport();
		var xaxis = $.ig.util.cast($.ig.CategoryAxisBase.prototype.$type, $self.parentSeries().getXAxis());
		var yaxis = $.ig.util.cast($.ig.NumericYAxis.prototype.$type, $self.parentSeries().getYAxis());
		var xParams = new $.ig.ScalerParams(windowRect, viewportRect, xaxis.isInverted());
		var yParams = new $.ig.ScalerParams(windowRect, viewportRect, yaxis.isInverted());
		frame._buckets.clear();
		frame._markers.clear();
		var markers = $self.shouldDisplayMarkers();
		var markerCount = 0;
		var parentFrame;
		var parentView;
		if (view.isAlternateView()) {
			parentFrame = $self.parentSeries().alternateFrame();
			parentView = $self.parentSeries().alternateViews().item(view.alternateViewIdentifier());

		} else if (view == $self.thumbnailView()) {
			parentFrame = $self.parentSeries()._thumbnailFrame;
			parentView = $.ig.util.cast($.ig.CategorySeriesView.prototype.$type, $self.parentSeries().thumbnailView());

		} else {
			parentFrame = $self.parentSeries()._currentFrame;
			parentView = $self.parentSeries().categoryView();
		}


		var parentBucketSize = parentView.bucketCalculator()._bucketSize;
		var sortingXAxis = $.ig.util.cast($.ig.ISortingAxis.prototype.$type, xaxis);
		if (sortingXAxis != null && sortingXAxis.sortedIndices().count() != $self.fastItemsSource().count()) {
			return;
		}

		var categoryMode = $self.preferredCategoryMode(xaxis);
		if (categoryMode == $.ig.CategoryMode.prototype.mode0 && xaxis.categoryMode() != $.ig.CategoryMode.prototype.mode0) {
			categoryMode = $.ig.CategoryMode.prototype.mode1;
		}

		var offset = 0;
		switch (categoryMode) {
			case $.ig.CategoryMode.prototype.mode0:
				offset = 0;
				break;
			case $.ig.CategoryMode.prototype.mode1:
				offset = 0.5 * xaxis.getCategorySize(windowRect, viewportRect);
				break;
			case $.ig.CategoryMode.prototype.mode2:
				var index = $self.index();
				offset = xaxis.getGroupCenter($self.index(), windowRect, viewportRect);
				break;
		}

		if (xaxis.isInverted()) {
		offset = -offset;
		}

		var total = function (i) { return Math.abs($self.parentSeries().lows()[i]) + $self.parentSeries().highs()[i]; };
		var xv = function (i) { return i; };
		var yv = function (i) {
			var value = $self.valueColumn().item(i);
			if ($.ig.util.isNaN(value) || Number.isInfinity(value)) {
				value = 0;
			}

			if ($.ig.util.cast($.ig.IStacked100Series.prototype.$type, $self.parentSeries()) !== null) {
				if (total(i) == 0) {
				return 0;
				}

				return value < 0 ? ($self.logicalSeriesLink().lowValues().__inner[i] + value) / total(i) * 100 : ($self.logicalSeriesLink().highValues().__inner[i] + value) / total(i) * 100;
			}

			return value < 0 ? $self.logicalSeriesLink().lowValues().__inner[i] + value : $self.logicalSeriesLink().highValues().__inner[i] + value;
		};
		var bucketSize = view.bucketCalculator()._bucketSize;
		var endPointsFirstDerivative = $self.splineType() == $.ig.SplineType.prototype.natural ? NaN : 0;
		if (xaxis != null && $.ig.util.cast($.ig.ISortingAxis.prototype.$type, xaxis) !== null && ($.ig.util.cast($.ig.ISortingAxis.prototype.$type, xaxis)).sortedIndices() != null) {
			var sorted = new $.ig.SafeSortedReadOnlyDoubleCollection($self.valueColumn(), ($.ig.util.cast($.ig.ISortingAxis.prototype.$type, xaxis)).sortedIndices());
			yv = function (i) { return sorted.item(i); };
		}

		$self.uColumn($.ig.Numeric.prototype.safeCubicSplineFit($self.valueColumn().count(), xv, yv, endPointsFirstDerivative, endPointsFirstDerivative));
		var firstBucket = parentView.bucketCalculator()._firstBucket;
		var lastBucket = parentView.bucketCalculator()._lastBucket;
		var n = $.ig.truncate(Math.ceil(viewportRect.width() / (lastBucket - firstBucket)));
		var collisionAvoider = new $.ig.CollisionAvoider();
		if (sortingXAxis != null) {
			$self.prepareDateTimeFrame(frame, windowRect, viewportRect, xaxis, yaxis, view);
			return;
		}

		var bucketCount = 0;
		var markerBucket = 0;
		for (var i = firstBucket; i < lastBucket + 1; ++i) {
			if (i >= $self.valueColumn().count()) {
			break;
			}

			var bucket = null;
			if (bucketSize == 1) {
				if (i >= ($self.valueColumn().count() - 1)) {
					if (markers && frame._buckets.count() > 0 && $self.prepareMarker(frame, frame._buckets.__inner[frame._buckets.count() - 1], collisionAvoider, Math.min(i * bucketSize, $self.fastItemsSource().count() - 1), markerCount, view, bucketCount - 1)) {
						++markerCount;
					}

					break;
				}

				var x1 = xv(i);
				var x2 = xv(i + 1);
				var y1 = yv(i);
				var y2 = yv(i + 1);
				var h = x2 - x1;
				var u1 = $self.uColumn()[i];
				var u2 = $self.uColumn()[i + 1];
				var firstPointX = xaxis.getScaledValue(x1, xParams) + offset;
				var firstPointY = yaxis.getScaledValue(y1, yParams);
				frame._buckets.add((function () { var $ret = new Array();
				$ret.add(firstPointX);
				$ret.add(firstPointY);
				$ret.add(firstPointY);return $ret;}()));
				bucketCount++;
				markerBucket = bucketCount;
				for (var j = 1; j < n; ++j) {
					var x = x1 + h * j / n;
					var a = (x2 - x) / h;
					var b = (x - x1) / h;
					var y = a * y1 + b * y2 + ((a * a * a - a) * u1 + (b * b * b - b) * u2) * (h * h) / 6;
					x = xaxis.getScaledValue(x, xParams) + offset;
					y = yaxis.getScaledValue(y, yParams);
					frame._buckets.add((function () { var $ret = new Array();
					$ret.add(x);
					$ret.add(y);
					$ret.add(y);return $ret;}()));
					bucketCount++;
				}

				if (markers) {
					bucket = (function () { var $ret = new Array();
					$ret.add(firstPointX);
					$ret.add(firstPointY);
					$ret.add(firstPointY);return $ret;}());
				}


			} else {
				bucket = view.bucketCalculator().getBucket(i);
				if (!isNaN(bucket[0])) {
					bucket[0] = (xaxis.getScaledValue(bucket[0], xParams) + offset);
					bucket[1] = yaxis.getScaledValue(bucket[1], yParams);
					bucket[2] = yaxis.getScaledValue(bucket[2], yParams);
					frame._buckets.add(bucket);
				}

			}

			if (markers && $self.prepareMarker(frame, bucket, collisionAvoider, Math.min(i * bucketSize, $self.fastItemsSource().count() - 1), markerCount, view, markerBucket - 1)) {
				++markerCount;
			}

		}

		view.markers().count(markerCount);
	}
	, 
	$type: new $.ig.Type('SplineFragmentBase', $.ig.SplineSeriesBase.prototype.$type)
}, true);

$.ig.util.defType('SplineAreaFragment', 'SplineFragmentBase', {
	init: function () {



		$.ig.SplineFragmentBase.prototype.init.call(this);
			this.defaultStyleKey($.ig.SplineAreaFragment.prototype.$type);
	}

	, 
	createView: function () {
		return new $.ig.SplineAreaFragmentView(this);
	}

	, 
	onViewCreated: function (view) {
		$.ig.SplineFragmentBase.prototype.onViewCreated.call(this, view);
		this.splineAreaFragmentView($.ig.util.cast($.ig.SplineAreaFragmentView.prototype.$type, view));
	}

	, 
	_splineAreaFragmentView: null,
	splineAreaFragmentView: function (value) {
		if (arguments.length === 1) {
			this._splineAreaFragmentView = value;
			return value;
		} else {
			return this._splineAreaFragmentView;
		}
	}

	, 
	onApplyTemplate: function () {
		$.ig.SplineFragmentBase.prototype.onApplyTemplate.call(this);
		this.renderSeries(false);
	}

	, 
	_points: null,
	points: function (value) {
		if (arguments.length === 1) {
			this._points = value;
			return value;
		} else {
			return this._points;
		}
	}

	, 
	clearRendering: function (wipeClean, view) {
		$.ig.SplineFragmentBase.prototype.clearRendering.call(this, wipeClean, view);
		var splineAreaFragmentView = view;
		splineAreaFragmentView.clearRendering();
	}

	, 
	renderFrame: function (frame, view) {
		var $self = this;
		$.ig.SplineFragmentBase.prototype.renderFrame.call($self, frame, view);
		$self.lineRasterizer().isSortingAxis($.ig.util.cast($.ig.ISortingAxis.prototype.$type, $self.xAxis()) !== null ? true : false);
		var splineView = $.ig.util.cast($.ig.SplineAreaFragmentView.prototype.$type, view);
		var bucketSize = view.bucketCalculator()._bucketSize;
		$self.lineRasterizer().rasterizePolygonPaths(splineView._polygon0, splineView._polyline0, splineView._polygon1, splineView._polyline1, frame._buckets.count(), frame._buckets, true, bucketSize, $self.resolution(), function (p0, l0, p1, l1, f) { $self.terminatePolygon1(p0, frame._buckets, view); }, $.ig.UnknownValuePlotting.prototype.dontPlot);
		splineView._polygon0.__opacity = $self.actualAreaFillOpacity();
		splineView._polygon1.__opacity = 0.5 * $self.actualAreaFillOpacity();
	}

	, 
	terminatePolygon1: function (polygon, buckets, view) {
		var worldZeroValue = this.getWorldZeroValue(view);
		var zero = worldZeroValue;
		var positive = this.logicalSeriesLink().positive();
		var seriesCollection = positive ? this.parentSeries().stackedSeriesManager().positiveSeries() : this.parentSeries().stackedSeriesManager().negativeSeries();
		var seriesIndex = seriesCollection.indexOf(this);
		if (polygon.count() == 0) {
		return;
		}

		if (seriesIndex == -1) {
		return;
		}

		var foundValidSeries = false;
		for (var index = seriesIndex; index >= 0; index--) {
			if (foundValidSeries) {
			break;
			}

			if (index == 0) {
				polygon.add({__x: $.ig.Enumerable.prototype.last$1($.ig.Point.prototype.$type, polygon).__x, __y: zero, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
				polygon.add({__x: $.ig.Enumerable.prototype.first$1($.ig.Point.prototype.$type, polygon).__x, __y: zero, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
				break;
			}

			var previousSeries = $.ig.util.cast($.ig.SplineFragmentBase.prototype.$type, seriesCollection.__inner[index - 1]);
			if (previousSeries != null && previousSeries.lineRasterizer() != null && previousSeries.lineRasterizer().flattenedLinePoints().count() > 0 && this.view() != null && previousSeries.validateSeries(this.view().viewport(), this.view().windowRect(), this.view())) {
				foundValidSeries = true;
				for (var i = previousSeries.lineRasterizer().flattenedLinePoints().count() - 1; i >= 0; i--) {
					polygon.add(previousSeries.lineRasterizer().flattenedLinePoints().__inner[i]);
				}

			}

		}

	}

	, 
	getWorldZeroValue: function (view) {
		var value = 0;
		var windowRect = view.windowRect();
		var viewportRect = view.viewport();
		var yParams = new $.ig.ScalerParams(windowRect, viewportRect, this.yAxis().isInverted());
		if (!windowRect.isEmpty() && !viewportRect.isEmpty() && this.yAxis() != null) {
			value = this.yAxis().getScaledValue(0, yParams);
		}

		return value;
	}

	, 
	updateActualAreaFillOpacity: function () {
		var chart = ($.ig.util.cast($.ig.XamDataChart.prototype.$type, this.seriesViewer()));
		if (chart != null) {
			this.actualAreaFillOpacity($.ig.util.isNaN(this.areaFillOpacity()) ? this.parentSeries().actualAreaFillOpacity() : this.areaFillOpacity());
		}

	}
	, 
	$type: new $.ig.Type('SplineAreaFragment', $.ig.SplineFragmentBase.prototype.$type)
}, true);

$.ig.util.defType('SplineAreaFragmentView', 'SplineSeriesBaseView', {

	_splineAreaFragmentModel: null,
	splineAreaFragmentModel: function (value) {
		if (arguments.length === 1) {
			this._splineAreaFragmentModel = value;
			return value;
		} else {
			return this._splineAreaFragmentModel;
		}
	}

	, 
	onInit: function () {
		var $self = this;
		$.ig.SplineSeriesBaseView.prototype.onInit.call($self);
		if (!$self.isThumbnailView()) {
			$self.model().legendItemBadgeTemplate((function () { var $ret = new $.ig.DataTemplate();
			$ret.render($.ig.LegendTemplates.prototype.rectBadgeTemplate);
			$ret.measure($.ig.LegendTemplates.prototype.legendItemBadgeMeasure); return $ret;}()));
		}

	}
	, 
	init: function (model) {


		this._polygon0 = new $.ig.Path();
		this._polyline0 = new $.ig.Path();
		this._polygon1 = new $.ig.Path();
		this._polyline1 = new $.ig.Path();

		$.ig.SplineSeriesBaseView.prototype.init.call(this, model);
			this.splineAreaFragmentModel(model);
	}
	, 
	_polygon0: null
	, 
	_polyline0: null
	, 
	_polygon1: null
	, 
	_polyline1: null

	, 
	clearRendering: function () {
		this._polygon0.data(null);
		this._polygon1.data(null);
		this._polyline0.data(null);
		this._polyline1.data(null);
	}

	, 
	setupAppearanceOverride: function () {
		$.ig.SplineSeriesBaseView.prototype.setupAppearanceOverride.call(this);
		this._polygon0.__fill = this.model().actualBrush();
		this._polygon1.__fill = this.model().actualBrush();
		this._polygon0.__opacity = this.model().actualAreaFillOpacity();
		this._polygon1.__opacity = 0.5 * this.model().actualAreaFillOpacity();
		this._polyline0.__stroke = this.model().actualOutline();
		this._polyline0.strokeThickness(this.model().thickness());
		this._polyline0.strokeDashArray(this.model().dashArray());
		this._polyline0.strokeDashCap(this.model().dashCap());
		this._polyline1.__stroke = this.model().actualOutline();
		this._polyline1.strokeThickness(this.model().thickness());
		this._polyline1.strokeDashArray(this.model().dashArray());
		this._polyline1.strokeDashCap(this.model().dashCap());
	}

	, 
	setupHitAppearanceOverride: function () {
		$.ig.SplineSeriesBaseView.prototype.setupHitAppearanceOverride.call(this);
		var hitBrush = this.getHitBrush();
		this._polygon0.__fill = hitBrush;
		this._polygon1.__fill = hitBrush;
		this._polygon1.__opacity = 1;
		this._polygon0.__opacity = 1;
		this._polyline0.__stroke = hitBrush;
		this._polyline0.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
		this._polyline1.__stroke = hitBrush;
		this._polyline1.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
	}

	, 
	renderOverride: function (context, isHitContext) {
		$.ig.SplineSeriesBaseView.prototype.renderOverride.call(this, context, isHitContext);
		if (context.shouldRender()) {
			context.renderPath(this._polygon0);
			context.renderPath(this._polygon1);
			context.renderPath(this._polyline0);
			context.renderPath(this._polyline1);
		}

	}

	, 
	index: function () {

			return this.splineAreaFragmentModel().parentSeries().stackedView().index();
	}

	, 
	exportViewShapes: function (svd) {
		$.ig.SplineSeriesBaseView.prototype.exportViewShapes.call(this, svd);
		var lowerShape = new $.ig.PathVisualData(1, "lowerShape", this._polyline0);
		lowerShape.tags().add("Lower");
		var upperShape = new $.ig.PathVisualData(1, "upperShape", this._polyline1);
		upperShape.tags().add("Upper");
		upperShape.tags().add("Main");
		var translucent = new $.ig.PathVisualData(1, "translucentShape", this._polygon0);
		translucent.tags().add("Translucent");
		var fill = new $.ig.PathVisualData(1, "fillShape", this._polygon1);
		fill.tags().add("Fill");
		svd.shapes().add(lowerShape);
		svd.shapes().add(upperShape);
		svd.shapes().add(translucent);
		svd.shapes().add(fill);
	}
	, 
	$type: new $.ig.Type('SplineAreaFragmentView', $.ig.SplineSeriesBaseView.prototype.$type)
}, true);

$.ig.util.defType('SplineFragment', 'SplineFragmentBase', {
	init: function () {



		$.ig.SplineFragmentBase.prototype.init.call(this);
			this.defaultStyleKey($.ig.SplineFragment.prototype.$type);
	}

	, 
	createView: function () {
		return new $.ig.SplineFragmentView(this);
	}

	, 
	_splineFragmentView: null,
	splineFragmentView: function (value) {
		if (arguments.length === 1) {
			this._splineFragmentView = value;
			return value;
		} else {
			return this._splineFragmentView;
		}
	}

	, 
	onViewCreated: function (view) {
		$.ig.SplineFragmentBase.prototype.onViewCreated.call(this, view);
		this.splineFragmentView(view);
	}

	, 
	clearRendering: function (wipeClean, view) {
		$.ig.SplineFragmentBase.prototype.clearRendering.call(this, wipeClean, view);
		var splineFragmentView = view;
		splineFragmentView.clearRendering();
	}

	, 
	renderFrame: function (frame, view) {
		$.ig.SplineFragmentBase.prototype.renderFrame.call(this, frame, view);
		this.lineRasterizer().isSortingAxis($.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.xAxis()) !== null ? true : false);
		var splineView = $.ig.util.cast($.ig.SplineFragmentView.prototype.$type, view);
		var bucketSize = splineView.bucketCalculator()._bucketSize;
		this.lineRasterizer().rasterizePolylinePaths(splineView._polyline0, splineView._polygon01, splineView._polyline1, frame._buckets.count(), frame._buckets, true, $.ig.UnknownValuePlotting.prototype.dontPlot, this.getLineClipper(frame._buckets, frame._buckets.count() - 1, view.viewport(), view.windowRect()), bucketSize, this.resolution());
	}
	, 
	$type: new $.ig.Type('SplineFragment', $.ig.SplineFragmentBase.prototype.$type)
}, true);

$.ig.util.defType('SplineFragmentView', 'SplineSeriesBaseView', {

	_splineFragmentModel: null,
	splineFragmentModel: function (value) {
		if (arguments.length === 1) {
			this._splineFragmentModel = value;
			return value;
		} else {
			return this._splineFragmentModel;
		}
	}
	, 
	init: function (model) {


		this._polyline0 = new $.ig.Path();
		this._polygon01 = new $.ig.Path();
		this._polyline1 = new $.ig.Path();

		$.ig.SplineSeriesBaseView.prototype.init.call(this, model);
			this.splineFragmentModel(model);
	}

	, 
	createBucketCalculator: function () {
		return new $.ig.SplineFragmentBucketCalculator(this);
	}
	, 
	_polyline0: null
	, 
	_polygon01: null
	, 
	_polyline1: null

	, 
	clearRendering: function () {
		this._polygon01.data(null);
		this._polyline0.data(null);
		this._polyline1.data(null);
	}

	, 
	setupAppearanceOverride: function () {
		$.ig.SplineSeriesBaseView.prototype.setupAppearanceOverride.call(this);
		this._polyline0.__stroke = this.model().actualBrush();
		this._polyline0.strokeThickness(this.model().thickness());
		this._polyline0.strokeDashArray(this.model().dashArray());
		this._polyline0.strokeDashCap(this.model().dashCap());
		this._polyline1.__stroke = this.model().actualBrush();
		this._polyline1.strokeThickness(this.model().thickness());
		this._polyline1.strokeDashArray(this.model().dashArray());
		this._polyline1.strokeDashCap(this.model().dashCap());
		this._polygon01.__fill = this.model().actualBrush();
		this._polygon01.__opacity = 0.75;
	}

	, 
	setupHitAppearanceOverride: function () {
		$.ig.SplineSeriesBaseView.prototype.setupHitAppearanceOverride.call(this);
		var hitBrush = this.getHitBrush();
		this._polyline0.__stroke = hitBrush;
		this._polyline0.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
		this._polyline1.__stroke = hitBrush;
		this._polyline1.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
		this._polygon01.__fill = hitBrush;
		this._polygon01.__opacity = 0.75;
	}

	, 
	renderOverride: function (context, isHitContext) {
		$.ig.SplineSeriesBaseView.prototype.renderOverride.call(this, context, isHitContext);
		if (context.shouldRender()) {
			context.renderPath(this._polygon01);
			context.renderPath(this._polyline0);
			context.renderPath(this._polyline1);
		}

	}

	, 
	index: function () {

			return this.splineFragmentModel().parentSeries().stackedView().index();
	}

	, 
	exportViewShapes: function (svd) {
		$.ig.SplineSeriesBaseView.prototype.exportViewShapes.call(this, svd);
		var lowerShape = new $.ig.PathVisualData(1, "lowerShape", this._polyline0);
		lowerShape.tags().add("Lower");
		lowerShape.tags().add("Main");
		var upperShape = new $.ig.PathVisualData(1, "upperShape", this._polyline1);
		upperShape.tags().add("Upper");
		var translucent = new $.ig.PathVisualData(1, "translucentShape", this._polygon01);
		translucent.tags().add("Translucent");
		svd.shapes().add(lowerShape);
		svd.shapes().add(upperShape);
		svd.shapes().add(translucent);
	}
	, 
	$type: new $.ig.Type('SplineFragmentView', $.ig.SplineSeriesBaseView.prototype.$type)
}, true);

$.ig.util.defType('StackedSeriesBase', 'CategorySeries', {
	init: function () {


		this.__previousSeriesKeys = new $.ig.Dictionary$2(String, $.ig.Boolean.prototype.$type, 0);

		$.ig.CategorySeries.prototype.init.call(this);
			this.series(new $.ig.StackedSeriesCollection());
			this.series().collectionResetting = $.ig.Delegate.prototype.combine(this.series().collectionResetting, this.series_CollectionResetting.runOn(this));
			this.series().collectionChanged = $.ig.Delegate.prototype.combine(this.series().collectionChanged, this.series_CollectionChanged.runOn(this));
			this.framePreparer(new $.ig.StackedSeriesFramePreparer(1, this, this.stackedView(), this, this, this.stackedView().bucketCalculator()));
			this.stackedSeriesManager(new $.ig.StackedSeriesManager(this));
			this.autoGeneratedSeries(new $.ig.StackedSeriesCollection());
			this.autoGeneratedSeries().collectionChanged = $.ig.Delegate.prototype.combine(this.autoGeneratedSeries().collectionChanged, this.series_CollectionChanged.runOn(this));
			this.autoGeneratedSeries().collectionResetting = $.ig.Delegate.prototype.combine(this.autoGeneratedSeries().collectionResetting, this.autoGeneratedSeries_CollectionResetting.runOn(this));
	}

	, 
	isHighlightingSupported: function () {

			return false;
	}

	, 
	createView: function () {
		return new $.ig.StackedSeriesView(this);
	}

	, 
	_stackedView: null,
	stackedView: function (value) {
		if (arguments.length === 1) {
			this._stackedView = value;
			return value;
		} else {
			return this._stackedView;
		}
	}

	, 
	onViewCreated: function (view) {
		$.ig.CategorySeries.prototype.onViewCreated.call(this, view);
		this.stackedView(view);
	}

	, 
	onViewportChanged: function (oldViewportRect, newViewportRect) {
		$.ig.CategorySeries.prototype.onViewportChanged.call(this, oldViewportRect, newViewportRect);
		var en = this.series().getEnumerator();
		while (en.moveNext()) {
			var series = en.current();
			series.visualSeriesLink().view().viewport(newViewportRect);
		}

	}

	, 
	_series: null,
	series: function (value) {
		if (arguments.length === 1) {
			this._series = value;
			return value;
		} else {
			return this._series;
		}
	}

	, 
	autoGenerateSeries: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedSeriesBase.prototype.autoGenerateSeriesProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedSeriesBase.prototype.autoGenerateSeriesProperty);
		}
	}

	, 
	reverseLegendOrder: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedSeriesBase.prototype.reverseLegendOrderProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedSeriesBase.prototype.reverseLegendOrderProperty);
		}
	}

	, 
	isStacked: function () {

			return true;
	}
	, 
	seriesCreated: null
	, 
	seriesVisibility: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedSeriesBase.prototype.seriesVisibilityProperty, $.ig.Visibility.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.StackedSeriesBase.prototype.seriesVisibilityProperty));
		}
	}

	, 
	_minimum: 0,
	minimum: function (value) {
		if (arguments.length === 1) {
			this._minimum = value;
			return value;
		} else {
			return this._minimum;
		}
	}

	, 
	_maximum: 0,
	maximum: function (value) {
		if (arguments.length === 1) {
			this._maximum = value;
			return value;
		} else {
			return this._maximum;
		}
	}

	, 
	_highs: null,
	highs: function (value) {
		if (arguments.length === 1) {
			this._highs = value;
			return value;
		} else {
			return this._highs;
		}
	}

	, 
	_lows: null,
	lows: function (value) {
		if (arguments.length === 1) {
			this._lows = value;
			return value;
		} else {
			return this._lows;
		}
	}

	, 
	_framePreparer: null,
	framePreparer: function (value) {
		if (arguments.length === 1) {
			this._framePreparer = value;
			return value;
		} else {
			return this._framePreparer;
		}
	}

	, 
	_stackedSeriesManager: null,
	stackedSeriesManager: function (value) {
		if (arguments.length === 1) {
			this._stackedSeriesManager = value;
			return value;
		} else {
			return this._stackedSeriesManager;
		}
	}

	, 
	_autoGeneratedSeries: null,
	autoGeneratedSeries: function (value) {
		if (arguments.length === 1) {
			this._autoGeneratedSeries = value;
			return value;
		} else {
			return this._autoGeneratedSeries;
		}
	}

	, 
	actualSeries: function () {

			return this.autoGenerateSeries() ? this.autoGeneratedSeries() : this.series();
	}

	, 
	autoGeneratedSeries_CollectionResetting: function (sender, e) {
		var en = this.autoGeneratedSeries().getEnumerator();
		while (en.moveNext()) {
			var series = en.current();
			if (this.stackedSeriesManager() != null && this.stackedSeriesManager().seriesLogical().contains(series)) {
				series.parentSeries(null);
				this.stackedSeriesManager().seriesLogical().remove(series);
			}

		}

	}

	, 
	series_CollectionResetting: function (sender, e) {
		var en = this.series().getEnumerator();
		while (en.moveNext()) {
			var series = en.current();
			if (this.stackedSeriesManager() != null && this.stackedSeriesManager().seriesLogical().contains(series)) {
				series.parentSeries(null);
				this.stackedSeriesManager().seriesLogical().remove(series);
			}

		}

	}

	, 
	series_CollectionChanged: function (sender, e) {
		if (e.oldItems() != null) {
			var en = e.oldItems().getEnumerator();
			while (en.moveNext()) {
				var series = en.current();
				if (this.stackedSeriesManager() != null && this.stackedSeriesManager().seriesLogical().contains(series)) {
					series.parentSeries(null);
					this.stackedSeriesManager().seriesLogical().remove(series);
				}

			}

		}

		if (e.newItems() != null) {
			var counter = e.newStartingIndex();
			var en1 = e.newItems().getEnumerator();
			while (en1.moveNext()) {
				var series1 = en1.current();
				if (this.stackedSeriesManager() != null && !this.stackedSeriesManager().seriesLogical().contains(series1)) {
					series1.parentSeries(this);
					series1.updateIsDropShadowEnabled();
					series1.updateShadowBlur();
					series1.updateShadowColor();
					series1.updateUseSingleShadow();
					series1.updateShadowOffsetX();
					series1.updateShadowOffsetY();
					series1.updateBrush();
					series1.updateDashArray();
					series1.updateDashCap();
					series1.updateEndCap();
					series1.updateIsHitTestVisible();
					series1.updateLegendItemBadgeTemplate();
					series1.updateLegendItemTemplate();
					series1.updateLegendItemVisibility();
					series1.updateMarkerTemplate();
					series1.updateMarkerType();
					series1.updateMarkerBrush();
					series1.updateMarkerOutline();
					series1.updateMarkerStyle();
					series1.updateMarkerTemplate();
					series1.updateOpacity();
					series1.updateOpacityMask();
					series1.updateOutline();
					series1.updateAreaFillOpacity();
					series1.updateRadiusX();
					series1.updateRadiusY();
					series1.updateStartCap();
					series1.updateThickness();
					series1.updateToolTip();
					series1.updateUseLightweightMarkers();
					series1.updateVisibility();
					if (!this.autoGenerateSeries()) {
						this.stackedSeriesManager().seriesLogical().insert(counter, series1);
						counter++;
					}

				}

			}

		}

		if (!this.autoGenerateSeries()) {
			this.updateAxisRanges();
		}

	}

	, 
	getFramePreparer: function (view) {
		if (view != null && view.isThumbnailView()) {
			if (view.isAlternateView()) {
				return new $.ig.StackedSeriesFramePreparer(1, $.ig.util.cast($.ig.IIsCategoryBased.prototype.$type, this), $.ig.util.cast($.ig.ISupportsMarkers.prototype.$type, view), view, this, view.bucketCalculator());

			} else {
				var thumbnailView = $.ig.util.cast($.ig.CategorySeriesView.prototype.$type, this.thumbnailView());
				return new $.ig.StackedSeriesFramePreparer(1, this, $.ig.util.cast($.ig.ISupportsMarkers.prototype.$type, thumbnailView), this.seriesViewer().view().overviewPlusDetailViewportHost(), this, thumbnailView.bucketCalculator());
			}


		} else {
			return this.framePreparer();
		}

	}

	, 
	prepareFrame: function (frame, view) {
		frame.clearFrame();
		this.prepareData();
		this.getFramePreparer(view).prepareFrame(frame, view);
	}

	, 
	clearRendering: function (wipeClean, view) {
		$.ig.CategorySeries.prototype.clearRendering.call(this, wipeClean, view);
		var en = this.actualSeries().getEnumerator();
		while (en.moveNext()) {
			var series = en.current();
			if (series.visualSeriesLink() != null) {
				series.visualSeriesLink().clearRendering(wipeClean, series.visualSeriesLink().view());
			}

		}

	}

	, 
	calculateStackedValues: function () {
		this.prepareData();
	}

	, 
	updateAxisRanges: function () {
		var xAxis = this.getXAxis();
		if (xAxis != null) {
			xAxis.updateRange1(true);
		}

		var yAxis = this.getYAxis();
		if (yAxis != null) {
			yAxis.updateRange1(true);
		}

	}

	, 
	scrollIntoView: function (item) {
		var index = this.fastItemsSource() != null ? this.fastItemsSource().indexOf(item) : -1;
		var windowRect = this.seriesViewer() != null ? this.seriesViewer().actualWindowRect() : $.ig.Rect.prototype.empty();
		var viewportRect = this.view().viewport();
		if (index >= 0 && windowRect != null && viewportRect != null) {
			var xAxis = this.getXAxis();
			if (xAxis != null) {
				var xParams = new $.ig.ScalerParams(windowRect, viewportRect, xAxis.isInverted());
				var cx = xAxis.getScaledValue(index, xParams);
				if (cx < windowRect.left() + 0.1 * windowRect.width()) {
					cx = cx + 0.4 * windowRect.width();
				}

				if (cx > windowRect.right() - 0.1 * windowRect.width()) {
					cx = cx - 0.4 * windowRect.width();
				}

				windowRect.x(cx - 0.5 * windowRect.width());
			}

			var yAxis = this.getYAxis();
			if (yAxis != null && this.highs() != null && index < this.highs().length) {
				var yParams = new $.ig.ScalerParams(windowRect, viewportRect, yAxis.isInverted());
				var high = yAxis.getScaledValue(this.highs()[index], yParams);
				var low = yAxis.getScaledValue(this.lows()[index], yParams);
				if (!$.ig.util.isNaN(high) && !$.ig.util.isNaN(low)) {
					var height = Math.abs(low - high);
					if (windowRect.height() < height) {
						windowRect.height(height);
						windowRect.y(Math.min(low, high));

					} else {
						if (low < windowRect.top() + 0.1 * windowRect.height()) {
							low = low + 0.4 * windowRect.height();
						}

						if (low > windowRect.bottom() - 0.1 * windowRect.height()) {
							low = low - 0.4 * windowRect.height();
						}

						windowRect.y(low - 0.5 * windowRect.height());
					}

				}

			}

			this.syncLink().windowNotify(this.seriesViewer(), windowRect);
		}

		return index >= 0;
	}

	, 
	getRange: function (axis) {
		if (this.lows() == null || this.lows().length == 0 || this.highs() == null || this.highs().length == 0) {
			return null;
		}

		if (axis == this.getXAxis()) {
			var max = Math.min(this.lows().length, this.highs().length);
			return new $.ig.AxisRange(0, max - 1);
		}

		if (axis == this.getYAxis()) {
			return new $.ig.AxisRange(this.minimum(), this.maximum());
		}

		return null;
	}

	, 
	shouldDisplayMarkers: function () {
		return false;
	}

	, 
	dataUpdatedOverride: function (action, position, count, propertyName) {
		this.updateNumericAxisRange();
		this.renderSeries(false);
	}

	, 
	getSeriesView: function () {
		return this.stackedView();
	}

	, 
	getScaledWorldZeroValue: function () {
		var value = 0;
		var windowRect = this.view().windowRect();
		var viewportRect = this.view().viewport();
		var yAxis = $.ig.util.cast($.ig.NumericYAxis.prototype.$type, this.getYAxis());
		if (!windowRect.isEmpty() && !viewportRect.isEmpty() && yAxis != null) {
			var yParams = new $.ig.ScalerParams(windowRect, viewportRect, yAxis.isInverted());
			value = yAxis.getScaledValue(yAxis.referenceValue(), yParams);
		}

		return value;
	}

	, 
	getUnscaledWorldZeroValue: function () {
		var yAxis = $.ig.util.cast($.ig.NumericYAxis.prototype.$type, this.getYAxis());
		if (yAxis != null) {
			return yAxis.referenceValue();
		}

		return 0;
	}

	, 
	getFragmentSeriesIndex: function (series) {
		return this.index() < 0 || this.actualSeries() == null || this.actualSeries().count() == 0 ? -1 : this.index() + this.actualSeries().indexOf(series);
	}

	, 
	getFragmentItemIndex: function (world) {
		var windowRect = this.seriesViewer() != null ? this.seriesViewer().actualWindowRect() : $.ig.Rect.prototype.empty();
		var viewportRect = this.view().viewport();
		var rowIndex = -1;
		var xAxis = $.ig.util.cast($.ig.CategoryAxisBase.prototype.$type, this.getXAxis());
		if (xAxis != null && !windowRect.isEmpty() && !viewportRect.isEmpty()) {
			var left = xAxis.getUnscaledValue2(viewportRect.left(), windowRect, viewportRect, xAxis.categoryMode());
			var right = xAxis.getUnscaledValue2(viewportRect.right(), windowRect, viewportRect, xAxis.categoryMode());
			var windowX = (world.__x - windowRect.left()) / windowRect.width();
			var bucket = left + (windowX * (right - left));
			if (xAxis.categoryMode() != $.ig.CategoryMode.prototype.mode0) {
				bucket -= 0.5;
			}

			var bucketNumber = $.ig.truncate(Math.round(bucket));
			rowIndex = bucketNumber;
		}

		return rowIndex;
	}

	, 
	validateFragmentSeries: function (series, viewportRect, windowRect, view) {
		var isValid = true;
		var xAxis = $.ig.util.cast($.ig.CategoryAxisBase.prototype.$type, this.getXAxis());
		var yAxis = $.ig.util.cast($.ig.NumericYAxis.prototype.$type, this.getYAxis());
		if (!view.hasSurface() || windowRect.isEmpty() || viewportRect.isEmpty() || xAxis == null || xAxis.itemsSource() == null || yAxis == null || this.fastItemsSource() == null || xAxis.seriesViewer() == null || yAxis.seriesViewer() == null || yAxis.actualMinimumValue() == yAxis.actualMaximumValue()) {
			isValid = false;
		}

		var categoryView = view;
		var bucketSize = categoryView.bucketCalculator()._bucketSize;
		if (series.valueColumn() == null || series.valueColumn().count() == 0 || bucketSize < 1 || series.__visibility != $.ig.Visibility.prototype.visible) {
			isValid = false;
		}

		return isValid;
	}
	, 
	__previousSeriesKeys: null

	, 
	generateSeries: function () {
		if (this.seriesViewer() == null || this.stackedSeriesManager() == null) {
		return;
		}

		if (!this.autoGenerateSeries()) {
			this.autoGeneratedSeries().clear();
			var en = this.series().getEnumerator();
			while (en.moveNext()) {
				var series = en.current();
				if (!this.stackedSeriesManager().seriesLogical().contains(series)) {
					this.stackedSeriesManager().seriesLogical().add(series);
				}

			}

			this.updateAxisRanges();
			return;
		}

	}

	, 
	renderFrame: function (frame, view) {
		$.ig.CategorySeries.prototype.renderFrame.call(this, frame, view);
		this.stackedSeriesManager().renderSeries();
	}

	, 
	renderFragment: function (series, frame, view) {
	}

	, 
	prepareData: function () {
		if (this.fastItemsSource() == null) {
		return;
		}

		var count = this.fastItemsSource().count();
		this.highs(new Array(count));
		this.lows(new Array(count));
		for (var i = 0; i < count; i++) {
			this.highs()[i] = 0;
			this.lows()[i] = 0;
		}

		this.minimum(Number.POSITIVE_INFINITY);
		this.maximum(Number.NEGATIVE_INFINITY);
		var zero = 0;
		var en = this.actualSeries().getEnumerator();
		while (en.moveNext()) {
			var series = en.current();
			this.fastItemsSource().deregisterColumn(series.valueColumn());
			series.valueColumn(this.registerDoubleColumn(series.valueMemberPath()));
			if (series.visualSeriesLink() != null) {
				series.visualSeriesLink().shouldSuspendChangedNotification(true);
				series.visualSeriesLink().valueColumn(series.valueColumn());
				series.visualSeriesLink().shouldSuspendChangedNotification(false);
			}

			series.positive(true);
			if (series.valueColumn() != null) {
				series.highValues().clear();
				series.lowValues().clear();
				for (var i1 = 0; i1 < series.valueColumn().count(); i1++) {
					var value = series.valueColumn().item(i1);
					if (value < zero) {
						series.highValues().add(zero);
						series.lowValues().add(this.lows()[i1]);
						this.lows()[i1] = this.lows()[i1] + value;
						if (series.positive()) {
						series.positive(false);
						}


					} else if (value >= zero) {
						series.highValues().add(this.highs()[i1]);
						series.lowValues().add(zero);
						this.highs()[i1] = this.highs()[i1] + value;

					} else if ($.ig.util.isNaN(value) || Number.isInfinity(value)) {
						series.highValues().add(this.highs()[i1]);
						series.lowValues().add(this.lows()[i1]);
					}



				}

			}

		}

		for (var i2 = 0; i2 < count; i2++) {
			this.minimum(Math.min(this.minimum(), this.lows()[i2]));
			this.maximum(Math.max(this.maximum(), this.highs()[i2]));
		}

	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		$.ig.CategorySeries.prototype.propertyUpdatedOverride.call(this, sender, propertyName, oldValue, newValue);
		switch (propertyName) {
			case $.ig.CategorySeries.prototype.seriesViewerPropertyName:
				if (this.actualSeries() != null) {
					var en = this.actualSeries().getEnumerator();
					while (en.moveNext()) {
						var series = en.current();
						series.chart(this.seriesViewer());
					}

					this.stackedSeriesManager().renderSeries();
				}

				break;
			case $.ig.Series.prototype.itemsSourcePropertyName:
				if (this.actualSeries() != null) {
					var en1 = this.actualSeries().getEnumerator();
					while (en1.moveNext()) {
						var series1 = en1.current();
						if (series1.visualSeriesLink() != null) {
							series1.visualSeriesLink().itemsSource(newValue);
						}

					}

				}

				break;
			case $.ig.CategorySeries.prototype.fastItemsSourcePropertyName:
				if (this.autoGenerateSeries()) {
					this.generateSeries();
				}

				if (!this.updateNumericAxisRange()) {
					this.stackedView().bucketCalculator().calculateBuckets(this.resolution());
				}

				this.renderSeries(false);
				break;
			case $.ig.StackedSeriesBase.prototype.autoGenerateSeriesPropertyName:
				this.generateSeries();
				break;
			case $.ig.StackedSeriesBase.prototype.reverseLegendOrderPropertyName:
				if (this.seriesViewer() != null) {
				this.seriesViewer().onLegendSortChanged1(this.stackedSeriesManager().seriesVisual());
				}

				break;
			case $.ig.StackedSeriesBase.prototype.seriesVisibilityPropertyName:
				var en2 = this.actualSeries().getEnumerator();
				while (en2.moveNext()) {
					var series2 = en2.current();
					series2.updateVisibility();
				}

				break;
			case $.ig.Series.prototype.brushPropertyName:
				var en3 = this.actualSeries().getEnumerator();
				while (en3.moveNext()) {
					var series3 = en3.current();
				series3.updateBrush()}

				break;
			case $.ig.Series.prototype.dashArrayPropertyName:
				var en4 = this.actualSeries().getEnumerator();
				while (en4.moveNext()) {
					var series4 = en4.current();
				series4.updateDashArray()}

				break;
			case $.ig.Series.prototype.dashCapPropertyName:
				var en5 = this.actualSeries().getEnumerator();
				while (en5.moveNext()) {
					var series5 = en5.current();
				series5.updateDashCap()}

				break;
			case $.ig.Series.prototype.isDropShadowEnabledPropertyName:
				var en6 = this.actualSeries().getEnumerator();
				while (en6.moveNext()) {
					var series6 = en6.current();
				series6.updateIsDropShadowEnabled()}

				break;
			case $.ig.Series.prototype.shadowBlurPropertyName:
				var en7 = this.actualSeries().getEnumerator();
				while (en7.moveNext()) {
					var series7 = en7.current();
				series7.updateShadowBlur()}

				break;
			case $.ig.Series.prototype.shadowColorPropertyName:
				var en8 = this.actualSeries().getEnumerator();
				while (en8.moveNext()) {
					var series8 = en8.current();
				series8.updateShadowColor()}

				break;
			case $.ig.Series.prototype.useSingleShadowPropertyName:
				var en9 = this.actualSeries().getEnumerator();
				while (en9.moveNext()) {
					var series9 = en9.current();
				series9.updateUseSingleShadow()}

				break;
			case $.ig.Series.prototype.shadowOffsetXPropertyName:
				var en10 = this.actualSeries().getEnumerator();
				while (en10.moveNext()) {
					var series10 = en10.current();
				series10.updateShadowOffsetX()}

				break;
			case $.ig.Series.prototype.shadowOffsetYPropertyName:
				var en11 = this.actualSeries().getEnumerator();
				while (en11.moveNext()) {
					var series11 = en11.current();
				series11.updateShadowOffsetY()}

				break;
			case $.ig.Series.prototype.endCapPropertyName:
				var en12 = this.actualSeries().getEnumerator();
				while (en12.moveNext()) {
					var series12 = en12.current();
				series12.updateEndCap()}

				break;
			case "IsHitTestVisible":
				var en13 = this.actualSeries().getEnumerator();
				while (en13.moveNext()) {
					var series13 = en13.current();
				series13.updateIsHitTestVisible()}

				break;
			case $.ig.Series.prototype.legendItemBadgeTemplatePropertyName:
				var en14 = this.actualSeries().getEnumerator();
				while (en14.moveNext()) {
					var series14 = en14.current();
				series14.updateLegendItemBadgeTemplate()}

				break;
			case $.ig.Series.prototype.legendItemTemplatePropertyName:
				var en15 = this.actualSeries().getEnumerator();
				while (en15.moveNext()) {
					var series15 = en15.current();
				series15.updateLegendItemTemplate()}

				break;
			case $.ig.Series.prototype.legendItemVisibilityPropertyName:
				var en16 = this.actualSeries().getEnumerator();
				while (en16.moveNext()) {
					var series16 = en16.current();
				series16.updateLegendItemVisibility()}

				break;
			case $.ig.MarkerSeries.prototype.markerTemplatePropertyName:
				var en17 = this.actualSeries().getEnumerator();
				while (en17.moveNext()) {
					var series17 = en17.current();
				series17.updateMarkerTemplate()}

				break;
			case $.ig.MarkerSeries.prototype.markerTypePropertyName:
				var en18 = this.actualSeries().getEnumerator();
				while (en18.moveNext()) {
					var series18 = en18.current();
					series18.updateMarkerType();
				}

				break;
			case $.ig.MarkerSeries.prototype.markerBrushPropertyName:
				var en19 = this.actualSeries().getEnumerator();
				while (en19.moveNext()) {
					var series19 = en19.current();
					series19.updateMarkerBrush();
				}

				break;
			case $.ig.MarkerSeries.prototype.markerOutlinePropertyName:
				var en20 = this.actualSeries().getEnumerator();
				while (en20.moveNext()) {
					var series20 = en20.current();
					series20.updateMarkerOutline();
				}

				break;
			case $.ig.MarkerSeries.prototype.markerStylePropertyName:
				var en21 = this.actualSeries().getEnumerator();
				while (en21.moveNext()) {
					var series21 = en21.current();
					series21.updateMarkerStyle();
				}

				break;
			case "Opacity":
				var en22 = this.actualSeries().getEnumerator();
				while (en22.moveNext()) {
					var series22 = en22.current();
					series22.updateOpacity();
				}

				break;
			case "OpacityMask":
				var en23 = this.actualSeries().getEnumerator();
				while (en23.moveNext()) {
					var series23 = en23.current();
					series23.updateOpacityMask();
				}

				break;
			case "AreaFillOpacity":
				var en24 = this.actualSeries().getEnumerator();
				while (en24.moveNext()) {
					var series24 = en24.current();
					series24.updateAreaFillOpacity();
				}

				break;
			case $.ig.Series.prototype.outlinePropertyName:
				var en25 = this.actualSeries().getEnumerator();
				while (en25.moveNext()) {
					var series25 = en25.current();
					series25.updateOutline();
				}

				break;
			case $.ig.Series.prototype.startCapPropertyName:
				var en26 = this.actualSeries().getEnumerator();
				while (en26.moveNext()) {
					var series26 = en26.current();
					series26.updateStartCap();
				}

				break;
			case $.ig.Series.prototype.thicknessPropertyName:
				var en27 = this.actualSeries().getEnumerator();
				while (en27.moveNext()) {
					var series27 = en27.current();
					series27.updateThickness();
				}

				break;
			case $.ig.Series.prototype.toolTipPropertyName:
				var en28 = this.actualSeries().getEnumerator();
				while (en28.moveNext()) {
					var series28 = en28.current();
					series28.updateToolTip();
				}

				break;
			case $.ig.MarkerSeries.prototype.useLightweightMarkersPropertyName:
				var en29 = this.actualSeries().getEnumerator();
				while (en29.moveNext()) {
					var series29 = en29.current();
					series29.updateUseLightweightMarkers();
				}

				break;
		}

	}

	, 
	currentCategoryMode: function () {

			return this.preferredCategoryMode($.ig.util.cast($.ig.CategoryAxisBase.prototype.$type, this.getXAxis()));
	}

	, 
	scaler: function () {

			return $.ig.util.cast($.ig.ICategoryScaler.prototype.$type, this.getXAxis());
	}

	, 
	yScaler: function () {

			return $.ig.util.cast($.ig.IScaler.prototype.$type, this.getYAxis());
	}

	, 
	bucketizer: function () {

			return this.categoryView().bucketCalculator();
	}

	, 
	currentMode2Index: function () {

			return this.getMode2Index();
	}

	, 
	provideCollisionDetector: function () {
		return new $.ig.CollisionAvoider();
	}

	, 
	shouldTransitionIn: function () {
		return false;
	}

	, 
	isDropShadowSupported: function () {

			return false;
	}

	, 
	renderThumbnail: function (viewportRect, surface) {
		var dirty = this.thumbnailDirty();
		$.ig.CategorySeries.prototype.renderThumbnail.call(this, viewportRect, surface);
		if (!dirty) {
			this.view().prepSurface(surface);
			return;
		}

		this.view().prepSurface(surface);
		if (this.clearAndAbortIfInvalid1(this.thumbnailView())) {
			return;
		}

		var en = this.series().getEnumerator();
		while (en.moveNext()) {
			var fragment = en.current();
			fragment.visualSeriesLink().renderThumbnail(viewportRect, surface);
		}

		this.thumbnailDirty(false);
	}

	, 
	_alternateFrame: null,
	alternateFrame: function (value) {
		if (arguments.length === 1) {
			this._alternateFrame = value;
			return value;
		} else {
			return this._alternateFrame;
		}
	}

	, 
	renderAlternateView: function (viewportRect, windowRect, surface, viewIdentifier, effectiveScalingRatio) {
		$.ig.CategorySeries.prototype.renderAlternateView.call(this, viewportRect, windowRect, surface, viewIdentifier, effectiveScalingRatio);
		var view = this.alternateViews().item(viewIdentifier);
		(view).bucketCalculator().calculateBuckets(this.resolution());
		view.prepAltSurface(surface);
		if (this.clearAndAbortIfInvalid1(view)) {
			return;
		}

		if (this.alternateFrame() == null) {
			this.alternateFrame(new $.ig.CategoryFrame(3));
		}

		this.alternateFrame().clearFrame();
		this.prepareData();
		this.getFramePreparer(view).prepareFrame(this.alternateFrame(), view);
		this.renderFrame(this.alternateFrame(), view);
		var en = this.series().getEnumerator();
		while (en.moveNext()) {
			var fragment = en.current();
			fragment.visualSeriesLink().renderAlternateView(viewportRect, windowRect, surface, viewIdentifier, effectiveScalingRatio);
		}

	}

	, 
	exportVisualData: function () {
		var svd = new $.ig.StackedSeriesVisualData();
		svd.viewport(this.viewport());
		svd.type(this.getType().typeName());
		svd.name(this.name());
		var en = this.series().getEnumerator();
		while (en.moveNext()) {
			var fragment = en.current();
			var fragmentVisualData = new $.ig.SeriesVisualData();
			fragmentVisualData.viewport(this.viewport());
			fragmentVisualData.type(fragment.getType().typeName());
			fragment.visualSeriesLink().view().exportViewShapes(fragmentVisualData);
			svd.fragmentSeries().add(fragmentVisualData);
		}

		this.exportVisualDataOverride(svd);
		this.view().exportViewShapes(svd);
		return svd;
	}
	, 
	$type: new $.ig.Type('StackedSeriesBase', $.ig.CategorySeries.prototype.$type, [$.ig.IIsCategoryBased.prototype.$type])
}, true);

$.ig.util.defType('HorizontalStackedSeriesBase', 'StackedSeriesBase', {
	init: function () {


		$.ig.StackedSeriesBase.prototype.init.call(this);

	}
	, 
	xAxis: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.HorizontalStackedSeriesBase.prototype.xAxisProperty, value);
			return value;
		} else {

			return this.getValue($.ig.HorizontalStackedSeriesBase.prototype.xAxisProperty);
		}
	}

	, 
	yAxis: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.HorizontalStackedSeriesBase.prototype.yAxisProperty, value);
			return value;
		} else {

			return this.getValue($.ig.HorizontalStackedSeriesBase.prototype.yAxisProperty);
		}
	}

	, 
	getOffsetValue: function () {
		return this.framePreparer().getOffset(this.xAxis(), this.view().windowRect(), this.view().viewport());
	}

	, 
	getCategoryWidth: function () {
		return this.xAxis().getCategorySize(this.view().windowRect(), this.view().viewport());
	}

	, 
	getXAxis: function () {
		return this.xAxis();
	}

	, 
	getYAxis: function () {
		return this.yAxis();
	}

	, 
	updateNumericAxisRange: function () {
		return this.yAxis() != null && this.yAxis().updateRange();
	}

	, 
	updateActualAreaFillOpacity: function () {
		var chart = ($.ig.util.cast($.ig.XamDataChart.prototype.$type, this.seriesViewer()));
		if (chart != null) {
			this.actualAreaFillOpacity($.ig.util.isNaN(this.areaFillOpacity()) ? chart.chartView().defaultAreaFillOpacity() : this.areaFillOpacity());
			var en = this.actualSeries().getEnumerator();
			while (en.moveNext()) {
				var series = en.current();
				series.updateAreaFillOpacity();
			}

		}

	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		$.ig.StackedSeriesBase.prototype.propertyUpdatedOverride.call(this, sender, propertyName, oldValue, newValue);
		switch (propertyName) {
			case $.ig.HorizontalStackedSeriesBase.prototype.xAxisPropertyName:
				if (oldValue != newValue) {
					this.deregisterForAxis($.ig.util.cast($.ig.Axis.prototype.$type, oldValue));
					this.registerForAxis($.ig.util.cast($.ig.Axis.prototype.$type, newValue));
					this.categoryView().bucketCalculator().calculateBuckets(this.resolution());
					this.renderSeries(false);
					this.notifyThumbnailAppearanceChanged();
				}

				break;
			case $.ig.HorizontalStackedSeriesBase.prototype.yAxisPropertyName:
				if (oldValue != newValue) {
					this.deregisterForAxis($.ig.util.cast($.ig.Axis.prototype.$type, oldValue));
					this.registerForAxis($.ig.util.cast($.ig.Axis.prototype.$type, newValue));
					this.categoryView().bucketCalculator().calculateBuckets(this.resolution());
					this.updateNumericAxisRange();
					this.renderSeries(false);
					this.notifyThumbnailAppearanceChanged();
				}

				break;
		}

	}
	, 
	$type: new $.ig.Type('HorizontalStackedSeriesBase', $.ig.StackedSeriesBase.prototype.$type)
}, true);

$.ig.util.defType('StackedAreaSeries', 'HorizontalStackedSeriesBase', {
	init: function () {



		$.ig.HorizontalStackedSeriesBase.prototype.init.call(this);
			this.defaultStyleKey($.ig.StackedAreaSeries.prototype.$type);
	}

	, 
	onApplyTemplate: function () {
		$.ig.HorizontalStackedSeriesBase.prototype.onApplyTemplate.call(this);
		this.renderSeries(false);
	}

	, 
	getRange: function (axis) {
		if (this.itemsSource() == null) {
			return null;
		}

		if (axis == this.xAxis()) {
			return new $.ig.AxisRange(0, this.fastItemsSource().count() - 1);
		}

		if (axis == this.yAxis()) {
			this.prepareData();
			return new $.ig.AxisRange(this.minimum(), this.maximum());
		}

		return null;
	}

	, 
	preferredCategoryMode: function (axis) {
		return $.ig.CategoryMode.prototype.mode0;
	}
	, 
	$type: new $.ig.Type('StackedAreaSeries', $.ig.HorizontalStackedSeriesBase.prototype.$type)
}, true);

$.ig.util.defType('IStacked100Series', 'Object', {
	$type: new $.ig.Type('IStacked100Series', null)
}, true);


$.ig.util.defType('VerticalStackedSeriesBase', 'StackedSeriesBase', {
	init: function () {


		$.ig.StackedSeriesBase.prototype.init.call(this);

	}
	, 
	xAxis: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.VerticalStackedSeriesBase.prototype.xAxisProperty, value);
			return value;
		} else {

			return this.getValue($.ig.VerticalStackedSeriesBase.prototype.xAxisProperty);
		}
	}

	, 
	yAxis: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.VerticalStackedSeriesBase.prototype.yAxisProperty, value);
			return value;
		} else {

			return this.getValue($.ig.VerticalStackedSeriesBase.prototype.yAxisProperty);
		}
	}

	, 
	getCategoryAxis: function () {
		return this.yAxis();
	}

	, 
	getOffsetValue: function () {
		return this.framePreparer().getOffset(this.yAxis(), this.view().windowRect(), this.view().viewport());
	}

	, 
	getCategoryWidth: function () {
		return this.yAxis().getCategorySize(this.view().windowRect(), this.view().viewport());
	}

	, 
	isVertical: function () {

			return true;
	}

	, 
	getXAxis: function () {
		return this.xAxis();
	}

	, 
	getYAxis: function () {
		return this.yAxis();
	}

	, 
	updateNumericAxisRange: function () {
		return this.xAxis() != null && this.xAxis().updateRange();
	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		$.ig.StackedSeriesBase.prototype.propertyUpdatedOverride.call(this, sender, propertyName, oldValue, newValue);
		switch (propertyName) {
			case $.ig.VerticalStackedSeriesBase.prototype.xAxisPropertyName:
				if (oldValue != newValue) {
					this.deregisterForAxis($.ig.util.cast($.ig.Axis.prototype.$type, oldValue));
					this.registerForAxis($.ig.util.cast($.ig.Axis.prototype.$type, newValue));
					this.categoryView().bucketCalculator().calculateBuckets(this.resolution());
					this.renderSeries(false);
					this.notifyThumbnailAppearanceChanged();
				}

				break;
			case $.ig.VerticalStackedSeriesBase.prototype.yAxisPropertyName:
				if (oldValue != newValue) {
					this.deregisterForAxis($.ig.util.cast($.ig.Axis.prototype.$type, oldValue));
					this.registerForAxis($.ig.util.cast($.ig.Axis.prototype.$type, newValue));
					this.categoryView().bucketCalculator().calculateBuckets(this.resolution());
					this.updateNumericAxisRange();
					this.renderSeries(false);
					this.notifyThumbnailAppearanceChanged();
				}

				break;
		}

	}
	, 
	$type: new $.ig.Type('VerticalStackedSeriesBase', $.ig.StackedSeriesBase.prototype.$type)
}, true);

$.ig.util.defType('StackedBarSeries', 'VerticalStackedSeriesBase', {
	init: function () {



		$.ig.VerticalStackedSeriesBase.prototype.init.call(this);
			this.defaultStyleKey($.ig.StackedBarSeries.prototype.$type);
	}

	, 
	onApplyTemplate: function () {
		$.ig.VerticalStackedSeriesBase.prototype.onApplyTemplate.call(this);
		this.renderSeries(false);
	}

	, 
	createView: function () {
		return new $.ig.StackedBarSeriesView(this);
	}

	, 
	_stackedBarView: null,
	stackedBarView: function (value) {
		if (arguments.length === 1) {
			this._stackedBarView = value;
			return value;
		} else {
			return this._stackedBarView;
		}
	}

	, 
	onViewCreated: function (view) {
		$.ig.VerticalStackedSeriesBase.prototype.onViewCreated.call(this, view);
		this.stackedBarView(view);
	}

	, 
	radiusX: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedBarSeries.prototype.radiusXProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedBarSeries.prototype.radiusXProperty);
		}
	}

	, 
	radiusY: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedBarSeries.prototype.radiusYProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedBarSeries.prototype.radiusYProperty);
		}
	}

	, 
	getSeriesView: function () {
		return this.stackedBarView();
	}

	, 
	preferredCategoryMode: function (axis) {
		return $.ig.CategoryMode.prototype.mode2;
	}

	, 
	getMode2Index: function () {
		var result = 0;
		var en = this.seriesViewer().series().getEnumerator();
		while (en.moveNext()) {
			var currentSeries = en.current();
			if (currentSeries == this) {
				return result;
			}

			var currentCategorySeries = $.ig.util.cast($.ig.IBarSeries.prototype.$type, currentSeries);
			if (currentCategorySeries != null && currentCategorySeries.yAxis() == this.yAxis() && currentCategorySeries.getPreferredCategoryMode() == $.ig.CategoryMode.prototype.mode2) {
				result++;
			}

		}

		$.ig.Debug.prototype.assert1(false, "CategorySeries.GetMode2Index failed to find series");
		return -1;
	}

	, 
	getScaledWorldZeroValue: function () {
		var value = 0;
		var windowRect = this.seriesViewer() != null ? this.seriesViewer().actualWindowRect() : $.ig.Rect.prototype.empty();
		var viewportRect = this.view().viewport();
		var xParams = new $.ig.ScalerParams(windowRect, viewportRect, this.xAxis().isInverted());
		if (!windowRect.isEmpty() && !viewportRect.isEmpty() && this.xAxis() != null) {
			value = this.xAxis().getScaledValue(this.xAxis().referenceValue(), xParams);
		}

		return value;
	}

	, 
	getUnscaledWorldZeroValue: function () {
		if (this.xAxis() != null) {
			return this.xAxis().referenceValue();
		}

		return 0;
	}

	, 
	getRange: function (axis) {
		if (this.itemsSource() == null) {
			return null;
		}

		if (axis == this.yAxis()) {
			return new $.ig.AxisRange(0, this.fastItemsSource().count() - 1);
		}

		if (axis == this.xAxis()) {
			this.prepareData();
			return new $.ig.AxisRange(this.minimum(), this.maximum());
		}

		return null;
	}

	, 
	scrollIntoView: function (item) {
		var index = this.fastItemsSource() != null ? this.fastItemsSource().indexOf(item) : -1;
		var windowRect = this.seriesViewer() != null ? this.seriesViewer().actualWindowRect() : $.ig.Rect.prototype.empty();
		var viewportRect = this.view().viewport();
		var unitRect = new $.ig.Rect(0, 0, 0, 1, 1);
		var xParams = new $.ig.ScalerParams(unitRect, unitRect, this.xAxis().isInverted());
		var yParams = new $.ig.ScalerParams(unitRect, unitRect, this.yAxis().isInverted());
		if (index >= 0 && windowRect != null && viewportRect != null) {
			if (this.yAxis() != null) {
				var cy = this.yAxis().getScaledValue(index, yParams);
				if (cy < windowRect.top() + 0.1 * windowRect.height()) {
					cy = cy + 0.4 * windowRect.height();
				}

				if (cy > windowRect.bottom() - 0.1 * windowRect.height()) {
					cy = cy - 0.4 * windowRect.height();
				}

				windowRect.y(cy - 0.5 * windowRect.height());
			}

			if (this.xAxis() != null && this.highs() != null && index < this.highs().length) {
				var high = this.xAxis().getScaledValue(this.highs()[index], xParams);
				var low = this.xAxis().getScaledValue(this.lows()[index], xParams);
				if (!$.ig.util.isNaN(high) && !$.ig.util.isNaN(low)) {
					var width = Math.abs(low - high);
					if (windowRect.width() < width) {
						windowRect.width(width);
						windowRect.x(Math.min(low, high));

					} else {
						if (low < windowRect.left() + 0.1 * windowRect.width()) {
							low = low + 0.4 * windowRect.width();
						}

						if (low > windowRect.right() - 0.1 * windowRect.width()) {
							low = low - 0.4 * windowRect.width();
						}

						windowRect.x(low - 0.5 * windowRect.width());
					}

				}

			}

			this.syncLink().windowNotify(this.seriesViewer(), windowRect);
		}

		return index >= 0;
	}

	, 
	validateSeries: function (viewportRect, windowRect, view) {
		var isValid = true;
		var categoryView = view;
		if (!view.hasSurface() || windowRect.isEmpty() || viewportRect.isEmpty() || this.yAxis() == null || this.yAxis().itemsSource() == null || this.xAxis() == null || this.fastItemsSource() == null || this.xAxis().seriesViewer() == null || this.yAxis().seriesViewer() == null || this.xAxis().actualMinimumValue() == this.xAxis().actualMaximumValue()) {
			categoryView.bucketCalculator()._bucketSize = 0;
			isValid = false;
		}

		return isValid;
	}

	, 
	dataUpdatedOverride: function (action, position, count, propertyName) {
		switch (action) {
			case $.ig.FastItemsSourceEventAction.prototype.reset:
			case $.ig.FastItemsSourceEventAction.prototype.insert:
			case $.ig.FastItemsSourceEventAction.prototype.remove:
				this.categoryView().bucketCalculator().calculateBuckets(this.resolution());
				break;
		}

		switch (action) {
			case $.ig.FastItemsSourceEventAction.prototype.reset:
				if (this.xAxis() != null && !this.xAxis().updateRange()) {
					this.renderSeries(true);
				}

				break;
			case $.ig.FastItemsSourceEventAction.prototype.insert:
				if (this.xAxis() != null && !this.xAxis().updateRange()) {
					this.renderSeries(true);
				}

				break;
			case $.ig.FastItemsSourceEventAction.prototype.remove:
				if (this.xAxis() != null && !this.xAxis().updateRange()) {
					this.renderSeries(true);
				}

				break;
			case $.ig.FastItemsSourceEventAction.prototype.replace:
				if (this.categoryView().bucketCalculator()._bucketSize > 0) {
					this.renderSeries(true);
				}

				break;
			case $.ig.FastItemsSourceEventAction.prototype.change:
				if (this.xAxis() != null && !this.xAxis().updateRange()) {
					this.renderSeries(true);
				}

				break;
		}

	}

	, 
	getItemIndex: function (world) {
		var windowRect = this.seriesViewer() != null ? this.seriesViewer().actualWindowRect() : $.ig.Rect.prototype.empty();
		var viewportRect = this.view().viewport();
		var rowIndex = -1;
		if (this.yAxis() != null && !windowRect.isEmpty() && !viewportRect.isEmpty()) {
			var top = this.yAxis().getUnscaledValue2(viewportRect.top(), windowRect, viewportRect, this.yAxis().categoryMode());
			var bottom = this.yAxis().getUnscaledValue2(viewportRect.bottom(), windowRect, viewportRect, this.yAxis().categoryMode());
			var windowY = (world.__y - windowRect.top()) / windowRect.height();
			var bucket = top + (windowY * (bottom - top));
			if (this.yAxis().categoryMode() != $.ig.CategoryMode.prototype.mode0) {
				bucket -= 0.5;
			}

			var bucketNumber = $.ig.truncate(Math.round(bucket));
			rowIndex = bucketNumber;
		}

		return rowIndex;
	}

	, 
	getItem: function (world) {
		var index = this.getItemIndex(world);
		return index >= 0 && this.fastItemsSource() != null && index < this.fastItemsSource().count() ? this.fastItemsSource().item(index) : null;
	}

	, 
	updateAxisRanges: function () {
		if (this.xAxis() != null) {
		this.xAxis().updateRange1(true);
		}

		if (this.yAxis() != null) {
		this.yAxis().updateRange1(true);
		}

	}

	, 
	getFragmentItemIndex: function (world) {
		return this.getItemIndex(world);
	}

	, 
	validateFragmentSeries: function (series, viewportRect, windowRect, view) {
		var isValid = true;
		if (!view.hasSurface() || windowRect.isEmpty() || viewportRect.isEmpty() || this.yAxis() == null || this.yAxis().itemsSource() == null || this.xAxis() == null || this.fastItemsSource() == null || this.xAxis().seriesViewer() == null || this.yAxis().seriesViewer() == null) {
			isValid = false;
		}

		var categoryView = view;
		if (series.valueColumn() == null || series.valueColumn().count() == 0 || categoryView.bucketCalculator()._bucketSize < 1) {
			isValid = false;
		}

		return isValid;
	}

	, 
	renderFragment: function (series, frame, view) {
		var barSeries = $.ig.util.cast($.ig.BarFragment.prototype.$type, series);
		var fragmentView = $.ig.util.cast($.ig.ColumnFragmentView.prototype.$type, view);
		if (!this.validateSeries(view.viewport(), view.windowRect(), view) || barSeries == null || fragmentView == null) {
			return;
		}

		var groupWidth = this.yAxis().getGroupSize(view.windowRect(), view.viewport());
		if ($.ig.util.isNaN(groupWidth) || Number.isInfinity(groupWidth)) {
			barSeries.columnFragmentView().columns().count(0);
			return;
		}

		var counter = 0;
		var en = frame._buckets.getEnumerator();
		while (en.moveNext()) {
			var bucket = en.current();
			if (Number.isInfinity(bucket[0]) || $.ig.util.isNaN(bucket[0]) || Number.isInfinity(bucket[1]) || Number.isInfinity(bucket[2]) || $.ig.util.isNaN(bucket[1]) || $.ig.util.isNaN(bucket[2])) {
				continue;
			}

			var top = bucket[0] - 0.5 * groupWidth;
			var right = bucket[1];
			var left = bucket[2];
			left = Math.max(left, -100);
			right = Math.min(right, view.viewport().right() + 100);
			var column = fragmentView.columns().item(counter);
			column.height(groupWidth);
			column.width(Math.abs(right - left));
			fragmentView.positionRectangle(column, Math.min(right, left), top);
			counter++;
		}

		fragmentView.columns().count(counter);
	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		$.ig.VerticalStackedSeriesBase.prototype.propertyUpdatedOverride.call(this, sender, propertyName, oldValue, newValue);
		switch (propertyName) {
			case $.ig.StackedBarSeries.prototype.radiusXPropertyName:
			case $.ig.StackedBarSeries.prototype.radiusYPropertyName:
				var en = this.actualSeries().getEnumerator();
				while (en.moveNext()) {
					var series = en.current();
					series.updateRadiusX();
					series.updateRadiusY();
				}

				this.renderSeries(false);
				break;
			case $.ig.Series.prototype.syncLinkPropertyName:
				if (this.xAxis() != null) {
				this.xAxis().updateRange();
				}

				break;
			case $.ig.CategorySeries.prototype.fastItemsSourcePropertyName:
				if (this.xAxis() != null && !this.xAxis().updateRange()) {
					this.stackedBarView().bucketCalculator().calculateBuckets(this.resolution());
				}

				this.renderSeries(false);
				break;
			case $.ig.Series.prototype.seriesViewerPropertyName:
				if (oldValue != null && newValue == null) {
					this.deregisterForAxis(this.xAxis());
					this.deregisterForAxis(this.yAxis());
				}

				if (oldValue == null && newValue != null) {
					this.registerForAxis(this.xAxis());
					this.registerForAxis(this.yAxis());
				}

				this.stackedBarView().bucketCalculator().calculateBuckets(this.resolution());
				this.renderSeries(false);
				if (this.xAxis() != null) {
				this.xAxis().updateRange();
				}

				break;
		}

	}

	, 
	getPreferredCategoryMode: function () {
		return this.preferredCategoryMode(this.yAxis());
	}

	, 
	currentCategoryMode: function () {

			return this.preferredCategoryMode(this.yAxis());
	}

	, 
	scaler: function () {

			return this.yAxis();
	}

	, 
	yScaler: function () {

			return this.xAxis();
	}
	, 
	$type: new $.ig.Type('StackedBarSeries', $.ig.VerticalStackedSeriesBase.prototype.$type, [$.ig.IIsCategoryBased.prototype.$type, $.ig.IBarSeries.prototype.$type])
}, true);


$.ig.util.defType('StackedSeriesView', 'CategorySeriesView', {

	_stackedModel: null,
	stackedModel: function (value) {
		if (arguments.length === 1) {
			this._stackedModel = value;
			return value;
		} else {
			return this._stackedModel;
		}
	}
	, 
	__plotArea: null

	, 
	plotArea: function () {

			return this.__plotArea;
	}
	, 
	__seriesPanel: null

	, 
	seriesPanel: function () {

			return this.__seriesPanel;
	}
	, 
	init: function (model) {


		this.__plotArea = new $.ig.Canvas();
		this.__seriesPanel = new $.ig.Panel();

		$.ig.CategorySeriesView.prototype.init.call(this, model);
			this.stackedModel(model);
	}

	, 
	createBucketCalculator: function () {
		return new $.ig.StackedBucketCalculator(this);
	}

	, 
	onInit: function () {
		$.ig.CategorySeriesView.prototype.onInit.call(this);
	}

	, 
	hideTooltip: function () {
		$.ig.CategorySeriesView.prototype.hideTooltip.call(this);
		for (var i = 0; i < this.stackedModel().stackedSeriesManager().seriesVisual().count(); i++) {
			this.stackedModel().stackedSeriesManager().seriesVisual().__inner[i].view().hideTooltip();
		}

	}

	, 
	onContextProvided: function (context, hitContext) {
		$.ig.CategorySeriesView.prototype.onContextProvided.call(this, context, hitContext);
		var en = this.stackedModel().series().getEnumerator();
		while (en.moveNext()) {
			var fragment = en.current();
			fragment.visualSeriesLink().view().onContextProvided(context, hitContext);
		}

	}

	, 
	applyDropShadowDefaultSettings: function () {
		var colorString = "rgba(95,95,95,0.5)";
		var useSingleShadow = true;
		var blur = 5, offsetX = 5, offsetY = 5;
		var model = this.model();
		if ($.ig.util.cast($.ig.StackedAreaSeries.prototype.$type, model) !== null || $.ig.util.cast($.ig.StackedSplineAreaSeries.prototype.$type, model) !== null) {
			offsetX = 1;
			offsetY = -3;

		} else if ($.ig.util.cast($.ig.StackedLineSeries.prototype.$type, model) !== null || $.ig.util.cast($.ig.StackedSplineSeries.prototype.$type, model) !== null) {
			blur = 3;
			offsetX = 1;
			offsetY = 4;
			useSingleShadow = false;

		} else if ($.ig.util.cast($.ig.StackedColumnSeries.prototype.$type, model) !== null) {
			offsetX = 5;
			offsetY = 0;
		}



		var color = new $.ig.Color();
		color.colorString(colorString);
		model.shadowColor(color);
		model.shadowBlur(blur);
		model.shadowOffsetX(offsetX);
		model.shadowOffsetY(offsetY);
		model.useSingleShadow(useSingleShadow);
	}
	, 
	$type: new $.ig.Type('StackedSeriesView', $.ig.CategorySeriesView.prototype.$type)
}, true);

$.ig.util.defType('StackedBarSeriesView', 'StackedSeriesView', {

	_stackedBarModel: null,
	stackedBarModel: function (value) {
		if (arguments.length === 1) {
			this._stackedBarModel = value;
			return value;
		} else {
			return this._stackedBarModel;
		}
	}
	, 
	init: function (model) {



		$.ig.StackedSeriesView.prototype.init.call(this, model);
			this.stackedBarModel(model);
	}

	, 
	createBucketCalculator: function () {
		return new $.ig.StackedBarBucketCalculator(this);
	}
	, 
	$type: new $.ig.Type('StackedBarSeriesView', $.ig.StackedSeriesView.prototype.$type)
}, true);


$.ig.util.defType('StackedColumnSeries', 'HorizontalStackedSeriesBase', {
	init: function () {



		$.ig.HorizontalStackedSeriesBase.prototype.init.call(this);
			this.defaultStyleKey($.ig.StackedColumnSeries.prototype.$type);
	}

	, 
	createView: function () {
		return new $.ig.StackedColumnSeriesView(this);
	}

	, 
	_stackedColumnView: null,
	stackedColumnView: function (value) {
		if (arguments.length === 1) {
			this._stackedColumnView = value;
			return value;
		} else {
			return this._stackedColumnView;
		}
	}

	, 
	onViewCreated: function (view) {
		$.ig.HorizontalStackedSeriesBase.prototype.onViewCreated.call(this, view);
		this.stackedColumnView(view);
	}

	, 
	radiusX: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedColumnSeries.prototype.radiusXProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedColumnSeries.prototype.radiusXProperty);
		}
	}

	, 
	radiusY: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedColumnSeries.prototype.radiusYProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedColumnSeries.prototype.radiusYProperty);
		}
	}

	, 
	getSeriesView: function () {
		return this.stackedColumnView();
	}

	, 
	preferredCategoryMode: function (axis) {
		return $.ig.CategoryMode.prototype.mode2;
	}

	, 
	getRange: function (axis) {
		if (this.itemsSource() == null) {
			return null;
		}

		if (axis == this.xAxis()) {
			return new $.ig.AxisRange(0, this.fastItemsSource().count() - 1);
		}

		if (axis == this.yAxis()) {
			this.prepareData();
			return new $.ig.AxisRange(this.minimum(), this.maximum());
		}

		return null;
	}

	, 
	renderFragment: function (series, frame, view) {
		var columnSeries = $.ig.util.cast($.ig.ColumnFragment.prototype.$type, series);
		var fragmentView = $.ig.util.cast($.ig.ColumnFragmentView.prototype.$type, view);
		if (!this.validateSeries(view.viewport(), view.windowRect(), view) || columnSeries == null || fragmentView == null) {
			return;
		}

		if (columnSeries == null) {
		return;
		}

		var groupWidth = this.xAxis().getGroupSize(view.windowRect(), view.viewport());
		if ($.ig.util.isNaN(groupWidth) || Number.isInfinity(groupWidth)) {
			columnSeries.columnFragmentView().columns().count(0);
			return;
		}

		var counter = 0;
		var en = frame._buckets.getEnumerator();
		while (en.moveNext()) {
			var bucket = en.current();
			if (Number.isInfinity(bucket[0]) || $.ig.util.isNaN(bucket[0]) || Number.isInfinity(bucket[1]) || Number.isInfinity(bucket[2]) || $.ig.util.isNaN(bucket[1]) || $.ig.util.isNaN(bucket[2])) {
				continue;
			}

			var left = bucket[0] - 0.5 * groupWidth;
			var top = bucket[1];
			var bottom = bucket[2];
			top = Math.max(top, -100);
			bottom = Math.min(bottom, view.viewport().bottom() + 100);
			var column = fragmentView.columns().item(counter);
			column.width(groupWidth);
			column.height(Math.abs(bottom - top));
			fragmentView.positionRectangle(column, left, Math.min(bottom, top));
			counter++;
		}

		fragmentView.columns().count(counter);
	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		$.ig.HorizontalStackedSeriesBase.prototype.propertyUpdatedOverride.call(this, sender, propertyName, oldValue, newValue);
		switch (propertyName) {
			case $.ig.StackedColumnSeries.prototype.radiusXPropertyName:
			case $.ig.StackedColumnSeries.prototype.radiusYPropertyName:
				var en = this.actualSeries().getEnumerator();
				while (en.moveNext()) {
					var series = en.current();
					series.updateRadiusX();
					series.updateRadiusY();
				}

				this.renderSeries(false);
				break;
			case $.ig.Series.prototype.syncLinkPropertyName:
				if (this.yAxis() != null) {
				this.yAxis().updateRange();
				}

				break;
			case $.ig.Series.prototype.seriesViewerPropertyName:
				if (this.yAxis() != null) {
				this.yAxis().updateRange();
				}

				break;
		}

	}
	, 
	$type: new $.ig.Type('StackedColumnSeries', $.ig.HorizontalStackedSeriesBase.prototype.$type)
}, true);


$.ig.util.defType('StackedColumnSeriesView', 'StackedSeriesView', {
	init: function (model) {



		$.ig.StackedSeriesView.prototype.init.call(this, model);
	}

	, 
	createBucketCalculator: function () {
		return new $.ig.StackedColumnBucketCalculator(this);
	}
	, 
	$type: new $.ig.Type('StackedColumnSeriesView', $.ig.StackedSeriesView.prototype.$type)
}, true);


$.ig.util.defType('StackedLineSeries', 'HorizontalStackedSeriesBase', {
	init: function () {



		$.ig.HorizontalStackedSeriesBase.prototype.init.call(this);
			this.defaultStyleKey($.ig.StackedLineSeries.prototype.$type);
	}

	, 
	onApplyTemplate: function () {
		$.ig.HorizontalStackedSeriesBase.prototype.onApplyTemplate.call(this);
		this.renderSeries(false);
	}

	, 
	getRange: function (axis) {
		if (this.itemsSource() == null) {
			return null;
		}

		if (axis == this.xAxis()) {
			return new $.ig.AxisRange(0, this.fastItemsSource().count() - 1);
		}

		if (axis == this.yAxis()) {
			this.prepareData();
			return new $.ig.AxisRange(this.minimum(), this.maximum());
		}

		return null;
	}

	, 
	preferredCategoryMode: function (axis) {
		return $.ig.CategoryMode.prototype.mode0;
	}
	, 
	$type: new $.ig.Type('StackedLineSeries', $.ig.HorizontalStackedSeriesBase.prototype.$type)
}, true);


$.ig.util.defType('StackedSplineAreaSeries', 'HorizontalStackedSeriesBase', {
	init: function () {



		$.ig.HorizontalStackedSeriesBase.prototype.init.call(this);
			this.defaultStyleKey($.ig.StackedSplineAreaSeries.prototype.$type);
	}

	, 
	onApplyTemplate: function () {
		$.ig.HorizontalStackedSeriesBase.prototype.onApplyTemplate.call(this);
		this.renderSeries(false);
	}

	, 
	getRange: function (axis) {
		if (this.itemsSource() == null) {
			return null;
		}

		if (axis == this.xAxis()) {
			return new $.ig.AxisRange(0, this.fastItemsSource().count() - 1);
		}

		if (axis == this.yAxis()) {
			this.prepareData();
			return new $.ig.AxisRange(this.minimum(), this.maximum());
		}

		return null;
	}

	, 
	preferredCategoryMode: function (axis) {
		return $.ig.CategoryMode.prototype.mode0;
	}
	, 
	$type: new $.ig.Type('StackedSplineAreaSeries', $.ig.HorizontalStackedSeriesBase.prototype.$type)
}, true);


$.ig.util.defType('StackedSplineSeries', 'HorizontalStackedSeriesBase', {
	init: function () {



		$.ig.HorizontalStackedSeriesBase.prototype.init.call(this);
			this.defaultStyleKey($.ig.StackedSplineSeries.prototype.$type);
	}

	, 
	onApplyTemplate: function () {
		$.ig.HorizontalStackedSeriesBase.prototype.onApplyTemplate.call(this);
		this.renderSeries(false);
	}

	, 
	getRange: function (axis) {
		if (this.itemsSource() == null) {
			return null;
		}

		if (axis == this.xAxis()) {
			return new $.ig.AxisRange(0, this.fastItemsSource().count() - 1);
		}

		if (axis == this.yAxis()) {
			this.prepareData();
			return new $.ig.AxisRange(this.minimum(), this.maximum());
		}

		return null;
	}

	, 
	preferredCategoryMode: function (axis) {
		return $.ig.CategoryMode.prototype.mode0;
	}
	, 
	$type: new $.ig.Type('StackedSplineSeries', $.ig.HorizontalStackedSeriesBase.prototype.$type)
}, true);


$.ig.util.defType('StackedFragmentSeries', 'DependencyObject', {
	init: function () {


		this.__hasUserSetDropShadow = false;
		this.__hasUserSetSingleShadow = false;

		var $self = this;
		$.ig.DependencyObject.prototype.init.call(this);
			this.highValues(new $.ig.List$1(Number, 0));
			this.lowValues(new $.ig.List$1(Number, 0));
			this.buckets(new $.ig.List$1($.ig.Array.prototype.$type, 0));
			this.propertyUpdated = $.ig.Delegate.prototype.combine(this.propertyUpdated, function (o, e) {
				$self.propertyUpdatedOverride(o, e.propertyName(), e.oldValue(), e.newValue());
			});
	}

	, 
	brush: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.brushProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.brushProperty);
		}
	}

	, 
	actualBrush: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.actualBrushProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.actualBrushProperty);
		}
	}

	, 
	dashArray: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.dashArrayProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.dashArrayProperty);
		}
	}

	, 
	actualDashArray: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.actualDashArrayProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.actualDashArrayProperty);
		}
	}

	, 
	dashCap: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.dashCapProperty, $.ig.PenLineCap.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.StackedFragmentSeries.prototype.dashCapProperty));
		}
	}

	, 
	actualDashCap: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.actualDashCapProperty, $.ig.PenLineCap.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.StackedFragmentSeries.prototype.actualDashCapProperty));
		}
	}

	, 
	isDropShadowEnabled: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.isDropShadowEnabledProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.isDropShadowEnabledProperty);
		}
	}
	, 
	__hasUserSetDropShadow: false

	, 
	actualIsDropShadowEnabled: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.actualIsDropShadowEnabledProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.actualIsDropShadowEnabledProperty);
		}
	}

	, 
	shadowBlur: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.shadowBlurProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.shadowBlurProperty);
		}
	}

	, 
	actualShadowBlur: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.actualShadowBlurProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.actualShadowBlurProperty);
		}
	}

	, 
	shadowColor: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.shadowColorProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.shadowColorProperty);
		}
	}

	, 
	actualShadowColor: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.actualShadowColorProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.actualShadowColorProperty);
		}
	}

	, 
	useSingleShadow: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.useSingleShadowProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.useSingleShadowProperty);
		}
	}
	, 
	__hasUserSetSingleShadow: false

	, 
	actualUseSingleShadow: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.actualUseSingleShadowProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.actualUseSingleShadowProperty);
		}
	}

	, 
	shadowOffsetX: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.shadowOffsetXProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.shadowOffsetXProperty);
		}
	}

	, 
	actualShadowOffsetX: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.actualShadowOffsetXProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.actualShadowOffsetXProperty);
		}
	}

	, 
	shadowOffsetY: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.shadowOffsetYProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.shadowOffsetYProperty);
		}
	}

	, 
	actualShadowOffsetY: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.actualShadowOffsetYProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.actualShadowOffsetYProperty);
		}
	}

	, 
	endCap: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.endCapProperty, $.ig.PenLineCap.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.StackedFragmentSeries.prototype.endCapProperty));
		}
	}

	, 
	actualEndCap: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.actualEndCapProperty, $.ig.PenLineCap.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.StackedFragmentSeries.prototype.actualEndCapProperty));
		}
	}

	, 
	isHitTestVisible: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.isHitTestVisibleProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.isHitTestVisibleProperty);
		}
	}

	, 
	actualIsHitTestVisible: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.actualIsHitTestVisibleProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.actualIsHitTestVisibleProperty);
		}
	}

	, 
	legendItemBadgeTemplate: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.legendItemBadgeTemplateProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.legendItemBadgeTemplateProperty);
		}
	}

	, 
	actualLegendItemBadgeTemplate: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.actualLegendItemBadgeTemplateProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.actualLegendItemBadgeTemplateProperty);
		}
	}

	, 
	legendItemTemplate: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.legendItemTemplateProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.legendItemTemplateProperty);
		}
	}

	, 
	actualLegendItemTemplate: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.actualLegendItemTemplateProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.actualLegendItemTemplateProperty);
		}
	}

	, 
	legendItemVisibility: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.legendItemVisibilityProperty, $.ig.Visibility.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.StackedFragmentSeries.prototype.legendItemVisibilityProperty));
		}
	}

	, 
	actualLegendItemVisibility: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.actualLegendItemVisibilityProperty, $.ig.Visibility.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.StackedFragmentSeries.prototype.actualLegendItemVisibilityProperty));
		}
	}

	, 
	markerBrush: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.markerBrushProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.markerBrushProperty);
		}
	}

	, 
	actualMarkerBrush: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.actualMarkerBrushProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.actualMarkerBrushProperty);
		}
	}

	, 
	markerOutline: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.markerOutlineProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.markerOutlineProperty);
		}
	}

	, 
	actualMarkerOutline: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.actualMarkerOutlineProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.actualMarkerOutlineProperty);
		}
	}

	, 
	markerStyle: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.markerStyleProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.markerStyleProperty);
		}
	}

	, 
	actualMarkerStyle: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.actualMarkerStyleProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.actualMarkerStyleProperty);
		}
	}

	, 
	markerTemplate: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.markerTemplateProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.markerTemplateProperty);
		}
	}

	, 
	actualMarkerTemplate: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.actualMarkerTemplateProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.actualMarkerTemplateProperty);
		}
	}

	, 
	markerType: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.markerTypeProperty, $.ig.MarkerType.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.StackedFragmentSeries.prototype.markerTypeProperty));
		}
	}

	, 
	actualMarkerType: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.actualMarkerTypeProperty, $.ig.MarkerType.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.StackedFragmentSeries.prototype.actualMarkerTypeProperty));
		}
	}

	, 
	name: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.nameProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.nameProperty);
		}
	}

	, 
	opacity: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.opacityProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.opacityProperty);
		}
	}

	, 
	actualOpacity: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.actualOpacityProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.actualOpacityProperty);
		}
	}

	, 
	opacityMask: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.opacityMaskProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.opacityMaskProperty);
		}
	}

	, 
	actualOpacityMask: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.actualOpacityMaskProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.actualOpacityMaskProperty);
		}
	}

	, 
	outline: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.outlineProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.outlineProperty);
		}
	}

	, 
	actualOutline: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.actualOutlineProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.actualOutlineProperty);
		}
	}

	, 
	areaFillOpacity: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.areaFillOpacityProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.areaFillOpacityProperty);
		}
	}

	, 
	actualAreaFillOpacity: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.actualAreaFillOpacityProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.actualAreaFillOpacityProperty);
		}
	}

	, 
	radiusX: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.radiusXProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.radiusXProperty);
		}
	}

	, 
	actualRadiusX: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.actualRadiusXProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.actualRadiusXProperty);
		}
	}

	, 
	radiusY: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.radiusYProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.radiusYProperty);
		}
	}

	, 
	actualRadiusY: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.actualRadiusYProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.actualRadiusYProperty);
		}
	}

	, 
	startCap: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.startCapProperty, $.ig.PenLineCap.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.StackedFragmentSeries.prototype.startCapProperty));
		}
	}

	, 
	actualStartCap: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.actualStartCapProperty, $.ig.PenLineCap.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.StackedFragmentSeries.prototype.actualStartCapProperty));
		}
	}

	, 
	thickness: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.thicknessProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.thicknessProperty);
		}
	}

	, 
	actualThickness: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.actualThicknessProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.actualThicknessProperty);
		}
	}

	, 
	title: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.titleProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.titleProperty);
		}
	}

	, 
	toolTip: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.toolTipProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.toolTipProperty);
		}
	}

	, 
	actualToolTip: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.actualToolTipProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.actualToolTipProperty);
		}
	}

	, 
	useLightweightMarkers: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.useLightweightMarkersProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.useLightweightMarkersProperty);
		}
	}

	, 
	actualUseLightweightMarkers: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.actualUseLightweightMarkersProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.actualUseLightweightMarkersProperty);
		}
	}

	, 
	valueMemberPath: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.valueMemberPathProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StackedFragmentSeries.prototype.valueMemberPathProperty);
		}
	}

	, 
	visibility: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.visibilityProperty, $.ig.Visibility.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.StackedFragmentSeries.prototype.visibilityProperty));
		}
	}

	, 
	actualVisibility: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StackedFragmentSeries.prototype.actualVisibilityProperty, $.ig.Visibility.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.StackedFragmentSeries.prototype.actualVisibilityProperty));
		}
	}

	, 
	_parentSeries: null,
	parentSeries: function (value) {
		if (arguments.length === 1) {
			this._parentSeries = value;
			return value;
		} else {
			return this._parentSeries;
		}
	}

	, 
	_index: 0,
	index: function (value) {
		if (arguments.length === 1) {
			this._index = value;
			return value;
		} else {
			return this._index;
		}
	}

	, 
	_chart: null,
	chart: function (value) {
		if (arguments.length === 1) {
			this._chart = value;
			return value;
		} else {
			return this._chart;
		}
	}

	, 
	_valueColumn: null,
	valueColumn: function (value) {
		if (arguments.length === 1) {
			this._valueColumn = value;
			return value;
		} else {
			return this._valueColumn;
		}
	}

	, 
	_visualSeriesLink: null,
	visualSeriesLink: function (value) {
		if (arguments.length === 1) {
			this._visualSeriesLink = value;
			return value;
		} else {
			return this._visualSeriesLink;
		}
	}

	, 
	_highValues: null,
	highValues: function (value) {
		if (arguments.length === 1) {
			this._highValues = value;
			return value;
		} else {
			return this._highValues;
		}
	}

	, 
	_lowValues: null,
	lowValues: function (value) {
		if (arguments.length === 1) {
			this._lowValues = value;
			return value;
		} else {
			return this._lowValues;
		}
	}

	, 
	_buckets: null,
	buckets: function (value) {
		if (arguments.length === 1) {
			this._buckets = value;
			return value;
		} else {
			return this._buckets;
		}
	}

	, 
	_positive: false,
	positive: function (value) {
		if (arguments.length === 1) {
			this._positive = value;
			return value;
		} else {
			return this._positive;
		}
	}

	, 
	updateVisibility: function () {
		if (this.parentSeries() == null) {
		return;
		}

		this.actualVisibility(this.parentSeries().__visibility != $.ig.Visibility.prototype.visible ? $.ig.Visibility.prototype.collapsed : this.visibility());
		if (this.visualSeriesLink() != null) {
			this.visualSeriesLink().__visibility = this.actualVisibility();
		}

	}

	, 
	updateMarkerTemplate: function () {
		if (this.parentSeries() == null) {
		return;
		}

		this.actualMarkerTemplate(this.markerTemplate() != null ? this.markerTemplate() : this.parentSeries().markerTemplate());
		if (this.visualSeriesLink() != null) {
			this.visualSeriesLink().markerTemplate(this.actualMarkerTemplate());
		}

	}

	, 
	updateMarkerType: function () {
		if (this.parentSeries() == null) {
		return;
		}

		var localMarkerType = this.markerType() == $.ig.MarkerType.prototype.unset ? $.ig.MarkerType.prototype.none : this.markerType();
		this.actualMarkerType(this.markerType() == $.ig.MarkerType.prototype.unset ? this.parentSeries().markerType() : localMarkerType);
		if (this.visualSeriesLink() != null) {
			this.visualSeriesLink().markerType(this.actualMarkerType());
		}

	}

	, 
	updateBrush: function () {
		if (this.parentSeries() == null) {
		return;
		}

		this.actualBrush(this.brush() != null ? this.brush() : this.parentSeries().brush());
		if (this.visualSeriesLink() != null) {
			this.visualSeriesLink().brush(this.actualBrush());
		}

	}

	, 
	updateDashArray: function () {
		if (this.parentSeries() == null) {
		return;
		}

		this.actualDashArray(this.dashArray() != null ? this.dashArray() : this.parentSeries().dashArray());
		if (this.visualSeriesLink() != null) {
			this.visualSeriesLink().dashArray(this.actualDashArray());
		}

	}

	, 
	updateDashCap: function () {
		if (this.parentSeries() == null) {
		return;
		}

		this.actualDashCap(this.dashCap());
		if (this.visualSeriesLink() != null) {
			this.visualSeriesLink().dashCap(this.actualDashCap());
		}

	}

	, 
	updateIsDropShadowEnabled: function () {
		if (this.parentSeries() == null) {
		return;
		}

		if (!this.__hasUserSetDropShadow) {
			this.actualIsDropShadowEnabled(this.parentSeries().isDropShadowEnabled());

		} else {
			this.actualIsDropShadowEnabled(this.isDropShadowEnabled());
		}

		if (this.visualSeriesLink() != null) {
			this.visualSeriesLink().isDropShadowEnabled(this.actualIsDropShadowEnabled());
		}

	}

	, 
	updateShadowBlur: function () {
		if (this.parentSeries() == null) {
		return;
		}

		this.actualShadowBlur(!$.ig.util.isNaN(this.shadowBlur()) ? this.shadowBlur() : this.parentSeries().shadowBlur());
		if (this.visualSeriesLink() != null && !$.ig.util.isNaN(this.actualShadowBlur())) {
			this.visualSeriesLink().shadowBlur(this.actualShadowBlur());
		}

	}

	, 
	updateShadowColor: function () {
		if (this.parentSeries() == null) {
		return;
		}

		this.actualShadowColor($.ig.Color.prototype.l_op_Inequality_Lifted($.ig.util.toNullable($.ig.Color.prototype.$type, this.shadowColor()), $.ig.util.toNullable($.ig.Color.prototype.$type, null)) ? this.shadowColor() : this.parentSeries().shadowColor());
		if (this.visualSeriesLink() != null && $.ig.Color.prototype.l_op_Inequality_Lifted($.ig.util.toNullable($.ig.Color.prototype.$type, this.actualShadowColor()), $.ig.util.toNullable($.ig.Color.prototype.$type, null))) {
			this.visualSeriesLink().shadowColor(this.actualShadowColor());
		}

	}

	, 
	updateUseSingleShadow: function () {
		if (this.parentSeries() == null) {
		return;
		}

		if (!this.__hasUserSetSingleShadow) {
			this.actualUseSingleShadow(this.parentSeries().useSingleShadow());

		} else {
			this.actualUseSingleShadow(this.useSingleShadow());
		}

		if (this.visualSeriesLink() != null) {
			this.visualSeriesLink().useSingleShadow(this.actualUseSingleShadow());
		}

	}

	, 
	updateShadowOffsetX: function () {
		if (this.parentSeries() == null) {
		return;
		}

		this.actualShadowOffsetX(!$.ig.util.isNaN(this.shadowOffsetX()) ? this.shadowOffsetX() : this.parentSeries().shadowOffsetX());
		if (this.visualSeriesLink() != null && !$.ig.util.isNaN(this.actualShadowOffsetX())) {
			this.visualSeriesLink().shadowOffsetX(this.actualShadowOffsetX());
		}

	}

	, 
	updateShadowOffsetY: function () {
		if (this.parentSeries() == null) {
		return;
		}

		this.actualShadowOffsetY(!$.ig.util.isNaN(this.shadowOffsetY()) ? this.shadowOffsetY() : this.parentSeries().shadowOffsetY());
		if (this.visualSeriesLink() != null && !$.ig.util.isNaN(this.actualShadowOffsetY())) {
			this.visualSeriesLink().shadowOffsetY(this.actualShadowOffsetY());
		}

	}

	, 
	updateEndCap: function () {
		if (this.parentSeries() == null) {
		return;
		}

		this.actualEndCap(this.endCap());
		if (this.visualSeriesLink() != null) {
			this.visualSeriesLink().endCap(this.actualEndCap());
		}

	}

	, 
	updateIsHitTestVisible: function () {
		if (this.parentSeries() == null) {
		return;
		}

		this.actualIsHitTestVisible(this.isHitTestVisible());
	}

	, 
	updateLegendItemBadgeTemplate: function () {
		if (this.parentSeries() == null) {
		return;
		}

		this.actualLegendItemBadgeTemplate(this.legendItemBadgeTemplate() != null ? this.legendItemBadgeTemplate() : this.parentSeries().legendItemBadgeTemplate());
		if (this.visualSeriesLink() != null) {
			if (this.actualLegendItemBadgeTemplate() != null) {
				this.visualSeriesLink().legendItemBadgeTemplate(this.actualLegendItemBadgeTemplate());

			} else {
				this.visualSeriesLink().legendItemBadgeTemplate(null);
			}

		}

	}

	, 
	updateLegendItemTemplate: function () {
		if (this.parentSeries() == null) {
		return;
		}

		this.actualLegendItemTemplate(this.legendItemTemplate() != null ? this.legendItemTemplate() : this.parentSeries().legendItemTemplate());
		if (this.visualSeriesLink() != null) {
			if (this.actualLegendItemTemplate() != null) {
				this.visualSeriesLink().legendItemTemplate(this.actualLegendItemTemplate());

			} else {
				this.visualSeriesLink().legendItemTemplate(null);
			}

		}

	}

	, 
	updateLegendItemVisibility: function () {
		if (this.parentSeries() == null) {
		return;
		}

		this.actualLegendItemVisibility(this.parentSeries().legendItemVisibility() != $.ig.Visibility.prototype.visible ? $.ig.Visibility.prototype.collapsed : this.legendItemVisibility());
		if (this.visualSeriesLink() != null) {
			this.visualSeriesLink().legendItemVisibility(this.actualLegendItemVisibility());
		}

	}

	, 
	updateMarkerBrush: function () {
		if (this.parentSeries() == null) {
		return;
		}

		this.actualMarkerBrush(this.markerBrush() != null ? this.markerBrush() : this.parentSeries().markerBrush());
		if (this.visualSeriesLink() != null) {
			this.visualSeriesLink().markerBrush(this.actualMarkerBrush());
		}

	}

	, 
	updateMarkerOutline: function () {
		if (this.parentSeries() == null) {
		return;
		}

		this.actualMarkerOutline(this.markerOutline() != null ? this.markerOutline() : this.parentSeries().markerOutline());
		if (this.visualSeriesLink() != null) {
			this.visualSeriesLink().markerOutline(this.actualMarkerOutline());
		}

	}

	, 
	updateMarkerStyle: function () {
		if (this.parentSeries() == null) {
		return;
		}

		this.actualMarkerStyle(this.markerStyle() != null ? this.markerStyle() : this.parentSeries().markerStyle());
		if (this.visualSeriesLink() != null) {
			if (this.actualMarkerStyle() != null) {
				this.visualSeriesLink().markerStyle(this.actualMarkerStyle());

			} else {
				this.visualSeriesLink().markerStyle(null);
			}

		}

	}

	, 
	updateOpacity: function () {
		if (this.parentSeries() == null) {
		return;
		}

		this.actualOpacity(!$.ig.util.isNaN(this.opacity()) ? this.opacity() : this.parentSeries().__opacity);
		if (this.visualSeriesLink() != null) {
			this.visualSeriesLink().__opacity = this.actualOpacity();
		}

	}

	, 
	updateOpacityMask: function () {
	}

	, 
	updateOutline: function () {
		if (this.parentSeries() == null) {
		return;
		}

		this.actualOutline(this.outline() != null ? this.outline() : this.parentSeries().outline());
		if (this.visualSeriesLink() != null) {
			this.visualSeriesLink().outline(this.actualOutline());
		}

	}

	, 
	updateAreaFillOpacity: function () {
		if (this.parentSeries() == null) {
		return;
		}

		var actualAreaFill = NaN;
		if ($.ig.util.cast($.ig.StackedAreaSeries.prototype.$type, this.parentSeries()) !== null) {
			actualAreaFill = ($.ig.util.cast($.ig.StackedAreaSeries.prototype.$type, this.parentSeries())).actualAreaFillOpacity();
		}

		if ($.ig.util.cast($.ig.StackedSplineAreaSeries.prototype.$type, this.parentSeries()) !== null) {
			actualAreaFill = ($.ig.util.cast($.ig.StackedSplineAreaSeries.prototype.$type, this.parentSeries())).actualAreaFillOpacity();
		}

		this.actualAreaFillOpacity(!$.ig.util.isNaN(this.areaFillOpacity()) ? this.areaFillOpacity() : actualAreaFill);
		if (this.visualSeriesLink() != null) {
			if ($.ig.util.cast($.ig.AreaFragment.prototype.$type, this.visualSeriesLink()) !== null) {
				(this.visualSeriesLink()).areaFillOpacity(this.actualAreaFillOpacity());
			}

			if ($.ig.util.cast($.ig.SplineAreaFragment.prototype.$type, this.visualSeriesLink()) !== null) {
				(this.visualSeriesLink()).areaFillOpacity(this.actualAreaFillOpacity());
			}

		}

	}

	, 
	updateRadiusX: function () {
		if (this.parentSeries() == null) {
		return;
		}

		var radiusX = NaN;
		if ($.ig.util.cast($.ig.StackedColumnSeries.prototype.$type, this.parentSeries()) !== null) {
			radiusX = ($.ig.util.cast($.ig.StackedColumnSeries.prototype.$type, this.parentSeries())).radiusX();
		}

		if ($.ig.util.cast($.ig.StackedBarSeries.prototype.$type, this.parentSeries()) !== null) {
			radiusX = ($.ig.util.cast($.ig.StackedBarSeries.prototype.$type, this.parentSeries())).radiusX();
		}

		this.actualRadiusX(!$.ig.util.isNaN(radiusX) ? radiusX : this.radiusX());
		if (this.visualSeriesLink() != null) {
			if ($.ig.util.cast($.ig.ColumnFragment.prototype.$type, this.visualSeriesLink()) !== null) {
				(this.visualSeriesLink()).radiusX(this.actualRadiusX());
			}

			if ($.ig.util.cast($.ig.BarFragment.prototype.$type, this.visualSeriesLink()) !== null) {
				(this.visualSeriesLink()).radiusX(this.actualRadiusX());
			}

		}

	}

	, 
	updateRadiusY: function () {
		if (this.parentSeries() == null) {
		return;
		}

		var radiusY = NaN;
		if ($.ig.util.cast($.ig.StackedColumnSeries.prototype.$type, this.parentSeries()) !== null) {
			radiusY = ($.ig.util.cast($.ig.StackedColumnSeries.prototype.$type, this.parentSeries())).radiusY();
		}

		if ($.ig.util.cast($.ig.StackedBarSeries.prototype.$type, this.parentSeries()) !== null) {
			radiusY = ($.ig.util.cast($.ig.StackedBarSeries.prototype.$type, this.parentSeries())).radiusY();
		}

		this.actualRadiusY(!$.ig.util.isNaN(radiusY) ? radiusY : this.radiusY());
		if (this.visualSeriesLink() != null) {
			if ($.ig.util.cast($.ig.ColumnFragment.prototype.$type, this.visualSeriesLink()) !== null) {
				(this.visualSeriesLink()).radiusY(this.actualRadiusY());
			}

			if ($.ig.util.cast($.ig.BarFragment.prototype.$type, this.visualSeriesLink()) !== null) {
				(this.visualSeriesLink()).radiusY(this.actualRadiusY());
			}

		}

	}

	, 
	updateStartCap: function () {
		if (this.parentSeries() == null) {
		return;
		}

		this.actualStartCap(this.startCap());
		if (this.visualSeriesLink() != null) {
			this.visualSeriesLink().startCap(this.actualStartCap());
		}

	}

	, 
	updateThickness: function () {
		if (this.parentSeries() == null) {
		return;
		}

		this.actualThickness(!$.ig.util.isNaN(this.thickness()) ? this.thickness() : this.parentSeries().thickness());
		if (this.visualSeriesLink() != null) {
			this.visualSeriesLink().thickness(this.actualThickness());
		}

	}

	, 
	updateToolTip: function () {
		if (this.parentSeries() == null) {
		return;
		}

		if (this.visualSeriesLink() != null) {
			this.visualSeriesLink().toolTip(this.toolTip());
		}

	}

	, 
	updateUseLightweightMarkers: function () {
		if (this.parentSeries() == null) {
		return;
		}

		this.actualUseLightweightMarkers(this.useLightweightMarkers());
		if (this.visualSeriesLink() != null) {
			this.visualSeriesLink().useLightweightMarkers(this.actualUseLightweightMarkers());
		}

	}
	, 
	propertyChanged: null, 
	propertyUpdated: null
	, 
	raisePropertyChanged: function (propertyName, oldValue, newValue) {
		if (this.propertyChanged != null) {
			this.propertyChanged(this, new $.ig.PropertyChangedEventArgs(propertyName));
		}

		if (this.propertyUpdated != null) {
			this.propertyUpdated(this, new $.ig.PropertyUpdatedEventArgs(propertyName, oldValue, newValue));
		}

	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		if (this.parentSeries() == null) {
		return;
		}

		switch (propertyName) {
			case $.ig.StackedFragmentSeries.prototype.titlePropertyName:
				if (this.parentSeries() == null || this.visualSeriesLink() == null) {
				return;
				}

				this.visualSeriesLink().title(newValue);
				break;
			case $.ig.StackedFragmentSeries.prototype.visibilityPropertyName:
				this.updateVisibility();
				break;
			case $.ig.StackedFragmentSeries.prototype.brushPropertyName:
				this.updateBrush();
				break;
			case $.ig.StackedFragmentSeries.prototype.dashArrayPropertyName:
				this.updateDashArray();
				break;
			case $.ig.StackedFragmentSeries.prototype.dashCapPropertyName:
				this.updateDashCap();
				break;
			case $.ig.StackedFragmentSeries.prototype.isDropShadowEnabledPropertyName:
				this.__hasUserSetDropShadow = true;
				this.updateIsDropShadowEnabled();
				break;
			case $.ig.StackedFragmentSeries.prototype.shadowBlurPropertyName:
				this.updateShadowBlur();
				break;
			case $.ig.StackedFragmentSeries.prototype.shadowColorPropertyName:
				this.updateShadowColor();
				break;
			case $.ig.StackedFragmentSeries.prototype.useSingleShadowPropertyName:
				this.__hasUserSetDropShadow = true;
				this.updateUseSingleShadow();
				break;
			case $.ig.StackedFragmentSeries.prototype.shadowOffsetXPropertyName:
				this.updateShadowOffsetX();
				break;
			case $.ig.StackedFragmentSeries.prototype.shadowOffsetYPropertyName:
				this.updateShadowOffsetY();
				break;
			case $.ig.StackedFragmentSeries.prototype.endCapPropertyName:
				this.updateEndCap();
				break;
			case $.ig.StackedFragmentSeries.prototype.isHitTestVisiblePropertyName:
				this.updateIsHitTestVisible();
				break;
			case $.ig.StackedFragmentSeries.prototype.markerTemplatePropertyName:
				this.updateMarkerTemplate();
				break;
			case $.ig.StackedFragmentSeries.prototype.markerTypePropertyName:
				this.updateMarkerType();
				break;
			case $.ig.StackedFragmentSeries.prototype.legendItemBadgeTemplatePropertyName:
				this.updateLegendItemBadgeTemplate();
				break;
			case $.ig.StackedFragmentSeries.prototype.legendItemTemplatePropertyName:
				this.updateLegendItemTemplate();
				break;
			case $.ig.StackedFragmentSeries.prototype.legendItemVisibilityPropertyName:
				this.updateLegendItemVisibility();
				break;
			case $.ig.StackedFragmentSeries.prototype.markerBrushPropertyName:
				this.updateMarkerBrush();
				break;
			case $.ig.StackedFragmentSeries.prototype.markerOutlinePropertyName:
				this.updateMarkerOutline();
				break;
			case $.ig.StackedFragmentSeries.prototype.markerStylePropertyName:
				this.updateMarkerStyle();
				break;
			case $.ig.StackedFragmentSeries.prototype.opacityPropertyName:
				this.updateOpacity();
				break;
			case $.ig.StackedFragmentSeries.prototype.opacityMaskPropertyName:
				this.updateOpacityMask();
				break;
			case $.ig.StackedFragmentSeries.prototype.outlinePropertyName:
				this.updateOutline();
				break;
			case $.ig.StackedFragmentSeries.prototype.areaFillOpacityPropertyName:
				this.updateAreaFillOpacity();
				break;
			case $.ig.StackedFragmentSeries.prototype.radiusXPropertyName:
				this.updateRadiusX();
				break;
			case $.ig.StackedFragmentSeries.prototype.radiusYPropertyName:
				this.updateRadiusY();
				break;
			case $.ig.StackedFragmentSeries.prototype.startCapPropertyName:
				this.updateStartCap();
				break;
			case $.ig.StackedFragmentSeries.prototype.thicknessPropertyName:
				this.updateThickness();
				break;
			case $.ig.StackedFragmentSeries.prototype.toolTipPropertyName:
				this.updateToolTip();
				break;
			case $.ig.StackedFragmentSeries.prototype.useLightweightMarkersPropertyName:
				this.updateUseLightweightMarkers();
				break;
		}

		this.parentSeries().renderSeries(false);
	}
	, 
	$type: new $.ig.Type('StackedFragmentSeries', $.ig.DependencyObject.prototype.$type, [$.ig.INotifyPropertyChanged.prototype.$type])
}, true);

$.ig.util.defType('StackedSeriesCollection', 'ObservableCollection$1', {
	init: function () {



		$.ig.ObservableCollection$1.prototype.init.call(this, $.ig.StackedFragmentSeries.prototype.$type, 0);
	}
	, 
	collectionResetting: null
	, 
	clearItems: function () {
		if (this.collectionResetting != null) {
			this.collectionResetting(this, null);
		}

		$.ig.ObservableCollection$1.prototype.clearItems.call(this);
	}
	, 
	$type: new $.ig.Type('StackedSeriesCollection', $.ig.ObservableCollection$1.prototype.$type.specialize($.ig.StackedFragmentSeries.prototype.$type))
}, true);

$.ig.util.defType('StackedSeriesFramePreparer', 'CategoryFramePreparer', {
	init: function (initNumber, host) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.CategoryFramePreparer.prototype.init.call(this, 0, host);
	}
	, 
	init1: function (initNumber, host, markersHost, viewportHost, errorBarsHost, bucketizingHost) {


		$.ig.CategoryFramePreparer.prototype.init1.call(this, 1, host, markersHost, viewportHost, errorBarsHost, bucketizingHost);
	}

	, 
	getValues: function (p) {
		var h = new $.ig.SingleValuesHolder();
		if ($.ig.util.cast($.ig.StackedColumnSeries.prototype.$type, this.categoryBasedHost()) !== null || $.ig.util.cast($.ig.StackedBarSeries.prototype.$type, this.categoryBasedHost()) !== null) {
			var host = $.ig.util.cast($.ig.StackedSeriesBase.prototype.$type, this.categoryBasedHost());
			if (host.actualSeries().count() > 0) {
			h.values(host.actualSeries().__inner[0].valueColumn());
			}

			return h;
		}

		var values = this.valuesProvider().valueColumn();
		h.values(values);
		return h;
	}

	, 
	prepareData: function (p, h, offset, markers, errorBars) {
		var $self = this;
		var markerCount = 0;
		var isCluster = false;
		var endBucket;
		var isSortingScaler = p.sortingScaler() != null;
		var collisionAvoider = $self.categoryBasedHost().provideCollisionDetector();
		var highMarkerFidelity = p.useHighMarkerFidelity();
		var sParams = new $.ig.ScalerParams(p.windowRect(), p.viewportRect(), p.scaler().isInverted());
		var yParams = new $.ig.ScalerParams(p.windowRect(), p.viewportRect(), p.yScaler().isInverted());
		var singlePixelSpan = (p.scaler().getUnscaledValue(2, sParams) - p.scaler().getUnscaledValue(1, sParams));
		var windowRect = p.windowRect();
		var viewportRect = p.viewportRect();
		var isLogarithmicYScaler = $.ig.util.cast($.ig.NumericAxisBase.prototype.$type, p.yScaler()) !== null && ($.ig.util.cast($.ig.NumericAxisBase.prototype.$type, p.yScaler())).isReallyLogarithmic();
		for (var i = p.firstBucket(); i <= p.lastBucket(); ++i) {
			var bucket;
			if (p.sortingScaler() == null) {
				bucket = $self.bucketizingHost().getBucket(i);

			} else {
				bucket = (function () { var $ret = $self.sortingBucketize(p, i, h, singlePixelSpan, isCluster, endBucket, offset); i = $ret.p1; isCluster = $ret.p4; endBucket = $ret.p5; return $ret.ret; }());
			}

			var isValidBucket = !isLogarithmicYScaler || (isLogarithmicYScaler && bucket[1] > 0);
			var bucketX = bucket[0];
			if (!isNaN(bucket[0])) {
				$self.scaleBucketValues(p, bucket, offset, isSortingScaler, sParams, yParams);
				p.frame()._buckets.add(bucket);
				var itemIndex = i * p.bucketSize();
				var unsortedIndex = itemIndex;
				if (p.sortingScaler() != null && p.sortingScaler().sortedIndices() != null && itemIndex >= 0 && itemIndex < p.sortingScaler().sortedIndices().count()) {
					itemIndex = p.sortingScaler().sortedIndices().__inner[itemIndex];
				}

				var markerBucket = bucket;
				if (highMarkerFidelity) {
					markerBucket = new Array(bucket.length);
					markerBucket[0] = bucketX;
					$self.storeYValues(h, itemIndex, true, p.isFragment());
					markerBucket[1] = h.tempY0();
					markerBucket[2] = h.tempY1();
					$self.scaleBucketValues(p, markerBucket, offset, isSortingScaler, sParams, yParams);
				}

				if (markers && isValidBucket && $self.prepareMarker(p.frame(), markerBucket, collisionAvoider, Math.min(itemIndex, h.count() - 1), markerCount, p.frame()._buckets.count() - 1)) {
					++markerCount;
				}

			}

		}

		return markerCount;
	}

	, 
	prepareMarker: function (frame, bucket, collisionAvoider, itemIndex, markerCount, markerBucket) {
		var x = bucket[0];
		var y = bucket[1];
		if ($.ig.util.cast($.ig.IBarSeries.prototype.$type, this.markersHost()) !== null) {
			y = bucket[0];
			x = bucket[1];
		}

		var markerRect = new $.ig.Rect(0, x - 5, y - 5, 11, 11);
		if (!$.ig.util.isNaN(x) && !$.ig.util.isNaN(y) && !Number.isInfinity(x) && !Number.isInfinity(y) && collisionAvoider.tryAdd(markerRect)) {
			frame._markers.add({__x: x, __y: y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			this.markersHost().updateMarkerTemplate(markerCount, itemIndex, markerBucket);
			return true;
		}

		return false;
	}
	, 
	$type: new $.ig.Type('StackedSeriesFramePreparer', $.ig.CategoryFramePreparer.prototype.$type)
}, true);

$.ig.util.defType('StackedSeriesManager', 'Object', {
	init: function (parent) {



		var $self = this;
		$.ig.Object.prototype.init.call(this);
			if (parent == null) {
			return;
			}

			this.parentSeries(parent);
			this.seriesVisual(new $.ig.ObservableCollection$1($.ig.AnchoredCategorySeries.prototype.$type, 0));
			this.seriesLogical(new $.ig.StackedSeriesCollection());
			this.positiveSeries(new $.ig.ObservableCollection$1($.ig.AnchoredCategorySeries.prototype.$type, 0));
			this.negativeSeries(new $.ig.ObservableCollection$1($.ig.AnchoredCategorySeries.prototype.$type, 0));
			this.plotArea(this.parentSeries().stackedView().plotArea());
			this.seriesPanel(this.parentSeries().stackedView().seriesPanel());
			this.seriesLogical().collectionChanged = $.ig.Delegate.prototype.combine(this.seriesLogical().collectionChanged, function (o, e) {
				if (e.oldItems() != null) {
					var en = e.oldItems().getEnumerator();
					while (en.moveNext()) {
						var logicalSeries = en.current();
						if ($self.seriesVisual().contains(logicalSeries.visualSeriesLink())) {
							$self.seriesVisual().remove(logicalSeries.visualSeriesLink());
						}

					}

				}

				if (e.newItems() != null) {
					var counter = e.newStartingIndex();
					var en1 = e.newItems().getEnumerator();
					while (en1.moveNext()) {
						var logicalSeries1 = en1.current();
						var series = $self.createSeries(logicalSeries1);
						$self.seriesVisual().insert(counter, series);
						counter++;
					}

				}

			});
			this.seriesVisual().collectionChanged = $.ig.Delegate.prototype.combine(this.seriesVisual().collectionChanged, function (o, e) {
				if (e.oldItems() != null) {
					var en = e.oldItems().getEnumerator();
					while (en.moveNext()) {
						var visualSeries = en.current();
						visualSeries.clearRendering(true, visualSeries.view());
						visualSeries.seriesViewer(null);
						visualSeries.syncLink(null);
						visualSeries.itemsSource(null);
						visualSeries.legend(null);
						if ($self.seriesPanel() != null && $self.seriesPanel().children().contains(visualSeries)) {
							$self.seriesPanel().children().remove(visualSeries);
						}

						if ($self.parentSeries().seriesViewer() != null) {
							$self.parentSeries().seriesViewer().removeSeries(visualSeries);
						}

					}

				}

				if (e.newItems() != null) {
					var en1 = e.newItems().getEnumerator();
					while (en1.moveNext()) {
						var visualSeries1 = en1.current();
						visualSeries1.seriesViewer($self.parentSeries().seriesViewer());
						visualSeries1.syncLink($self.parentSeries().syncLink());
						if (!$self.seriesPanel().children().contains(visualSeries1)) {
							$self.seriesPanel().children().add(visualSeries1);
						}

						if ($self.parentSeries().seriesViewer() != null) {
							$self.parentSeries().seriesViewer().attachSeries(visualSeries1);
						}

					}

				}

				$self.renderSeries();
			});
	}

	, 
	_parentSeries: null,
	parentSeries: function (value) {
		if (arguments.length === 1) {
			this._parentSeries = value;
			return value;
		} else {
			return this._parentSeries;
		}
	}

	, 
	_seriesVisual: null,
	seriesVisual: function (value) {
		if (arguments.length === 1) {
			this._seriesVisual = value;
			return value;
		} else {
			return this._seriesVisual;
		}
	}

	, 
	_seriesLogical: null,
	seriesLogical: function (value) {
		if (arguments.length === 1) {
			this._seriesLogical = value;
			return value;
		} else {
			return this._seriesLogical;
		}
	}

	, 
	_positiveSeries: null,
	positiveSeries: function (value) {
		if (arguments.length === 1) {
			this._positiveSeries = value;
			return value;
		} else {
			return this._positiveSeries;
		}
	}

	, 
	_negativeSeries: null,
	negativeSeries: function (value) {
		if (arguments.length === 1) {
			this._negativeSeries = value;
			return value;
		} else {
			return this._negativeSeries;
		}
	}

	, 
	_plotArea: null,
	plotArea: function (value) {
		if (arguments.length === 1) {
			this._plotArea = value;
			return value;
		} else {
			return this._plotArea;
		}
	}

	, 
	_seriesPanel: null,
	seriesPanel: function (value) {
		if (arguments.length === 1) {
			this._seriesPanel = value;
			return value;
		} else {
			return this._seriesPanel;
		}
	}

	, 
	createSeries: function (seriesFragment) {
		if ($.ig.util.cast($.ig.StackedLineSeries.prototype.$type, this.parentSeries()) !== null) {
			var series = new $.ig.LineFragment();
			series.parentSeries(this.parentSeries());
			seriesFragment.visualSeriesLink(series);
			series.logicalSeriesLink(seriesFragment);
			this.setSeriesBindings(series, seriesFragment);
			return series;
		}

		if ($.ig.util.cast($.ig.StackedColumnSeries.prototype.$type, this.parentSeries()) !== null) {
			var series1 = new $.ig.ColumnFragment();
			series1.parentSeries(this.parentSeries());
			seriesFragment.visualSeriesLink(series1);
			series1.logicalSeriesLink(seriesFragment);
			this.setSeriesBindings(series1, seriesFragment);
			return series1;
		}

		if ($.ig.util.cast($.ig.StackedBarSeries.prototype.$type, this.parentSeries()) !== null) {
			var series2 = new $.ig.BarFragment();
			series2.parentSeries($.ig.util.cast($.ig.StackedBarSeries.prototype.$type, this.parentSeries()));
			seriesFragment.visualSeriesLink(series2);
			series2.logicalSeriesLink(seriesFragment);
			this.setSeriesBindings(series2, seriesFragment);
			return series2;
		}

		if ($.ig.util.cast($.ig.StackedAreaSeries.prototype.$type, this.parentSeries()) !== null) {
			var series3 = new $.ig.AreaFragment();
			series3.parentSeries(this.parentSeries());
			seriesFragment.visualSeriesLink(series3);
			series3.logicalSeriesLink(seriesFragment);
			this.setSeriesBindings(series3, seriesFragment);
			return series3;
		}

		if ($.ig.util.cast($.ig.StackedSplineSeries.prototype.$type, this.parentSeries()) !== null) {
			var series4 = new $.ig.SplineFragment();
			series4.parentSeries(this.parentSeries());
			seriesFragment.visualSeriesLink(series4);
			series4.logicalSeriesLink(seriesFragment);
			this.setSeriesBindings(series4, seriesFragment);
			return series4;
		}

		if ($.ig.util.cast($.ig.StackedSplineAreaSeries.prototype.$type, this.parentSeries()) !== null) {
			var series5 = new $.ig.SplineAreaFragment();
			series5.parentSeries(this.parentSeries());
			seriesFragment.visualSeriesLink(series5);
			series5.logicalSeriesLink(seriesFragment);
			this.setSeriesBindings(series5, seriesFragment);
			return series5;
		}

		return null;
	}

	, 
	setSeriesBindings: function (visualSeries, logicalSeries) {
		visualSeries.brush(logicalSeries.actualBrush());
		visualSeries.dashArray(logicalSeries.actualDashArray());
		visualSeries.dashCap(logicalSeries.actualDashCap());
		visualSeries.endCap(logicalSeries.actualEndCap());
		visualSeries.itemsSource(this.parentSeries().itemsSource());
		visualSeries.legend(this.parentSeries().actualLegend());
		visualSeries.legendItemVisibility(logicalSeries.actualLegendItemVisibility());
		visualSeries.markerBrush(logicalSeries.actualMarkerBrush());
		visualSeries.markerOutline(logicalSeries.actualMarkerOutline());
		visualSeries.markerStyle(logicalSeries.actualMarkerStyle());
		visualSeries.markerTemplate(logicalSeries.actualMarkerTemplate());
		visualSeries.markerType(logicalSeries.actualMarkerType());
		visualSeries.miterLimit(this.parentSeries().miterLimit());
		visualSeries.__opacity = logicalSeries.opacity();
		visualSeries.outline(logicalSeries.actualOutline());
		visualSeries.resolution(this.parentSeries().resolution());
		visualSeries.startCap(logicalSeries.actualStartCap());
		visualSeries.thickness(logicalSeries.actualThickness());
		visualSeries.title(logicalSeries.title());
		visualSeries.useLightweightMarkers(logicalSeries.actualUseLightweightMarkers());
		visualSeries.valueMemberPath(logicalSeries.valueMemberPath());
		visualSeries.__visibility = logicalSeries.actualVisibility();
		var areaFragment = $.ig.util.cast($.ig.AreaFragment.prototype.$type, visualSeries);
		if (areaFragment != null) {
			areaFragment.actualAreaFillOpacity(logicalSeries.actualAreaFillOpacity());
		}

		var splineAreaFragment = $.ig.util.cast($.ig.SplineAreaFragment.prototype.$type, visualSeries);
		if (splineAreaFragment != null) {
			splineAreaFragment.actualAreaFillOpacity(logicalSeries.actualAreaFillOpacity());
		}

		var columnFragment = $.ig.util.cast($.ig.ColumnFragment.prototype.$type, visualSeries);
		if (columnFragment != null) {
			columnFragment.radiusX(logicalSeries.actualRadiusX());
			columnFragment.radiusY(logicalSeries.actualRadiusY());
		}

		var barFragment = $.ig.util.cast($.ig.BarFragment.prototype.$type, visualSeries);
		if (barFragment != null) {
			barFragment.radiusX(logicalSeries.actualRadiusX());
			barFragment.radiusY(logicalSeries.actualRadiusY());
		}

		visualSeries.toolTip(logicalSeries.toolTip());
		visualSeries.isDropShadowEnabled(logicalSeries.actualIsDropShadowEnabled());
		visualSeries.useSingleShadow(logicalSeries.actualUseSingleShadow());
		logicalSeries.updateShadowBlur();
		logicalSeries.updateShadowColor();
		logicalSeries.updateShadowOffsetX();
		logicalSeries.updateShadowOffsetY();
	}

	, 
	renderSeries: function () {
		this.positiveSeries().clear();
		this.negativeSeries().clear();
		var en = this.seriesVisual().getEnumerator();
		while (en.moveNext()) {
			var series = en.current();
			series.thumbnailDirty(true);
			series.seriesViewer(this.parentSeries().seriesViewer());
			series.syncLink(this.parentSeries().syncLink());
			series.index(this.parentSeries().getFragmentSeriesIndex(this.seriesLogical().__inner[this.seriesVisual().indexOf(series)]));
			if (this.seriesLogical().__inner[this.seriesVisual().indexOf(series)].positive()) {
				this.positiveSeries().add(series);

			} else {
				this.negativeSeries().add(series);
			}

			if ($.ig.util.cast($.ig.StackedLineSeries.prototype.$type, this.parentSeries()) !== null || $.ig.util.cast($.ig.StackedAreaSeries.prototype.$type, this.parentSeries()) !== null || $.ig.util.cast($.ig.StackedSplineSeries.prototype.$type, this.parentSeries()) !== null || $.ig.util.cast($.ig.StackedSplineAreaSeries.prototype.$type, this.parentSeries()) !== null) {
				series.setXAxis(this.parentSeries().getXAxis());
				series.setYAxis(this.parentSeries().getYAxis());
			}

			series.renderSeries(false);
		}

	}
	, 
	$type: new $.ig.Type('StackedSeriesManager', $.ig.Object.prototype.$type)
}, true);






$.ig.util.defType('IDetectsCollisions', 'Object', {
	$type: new $.ig.Type('IDetectsCollisions', null)
}, true);

$.ig.util.defType('CollisionAvoider', 'Object', {
	init: function () {


		this._rects = new $.ig.List$1($.ig.Rect.prototype.$type, 0);

		$.ig.Object.prototype.init.call(this);
	}

	, 
	tryAdd: function (rc) {
		var $self = this;
		for (var i = $self._rects.count() - 1; i >= 0; --i) {
			if (rc.left() > $self._rects.__inner[i].right()) {
				break;
			}

			if ($self._rects.__inner[i].intersectsWith(rc)) {
				return false;
			}

		}

		if ($self._rects.count() == 0 || rc.right() >= $self._rects.__inner[$self._rects.count() - 1].right()) {
			$self._rects.add(rc);

		} else {
			$self._rects.add(rc);
			$self._rects.sort2(function (a, b) {
				return Math.sign(a.right() - b.right());
			});
		}

		return true;
	}

	, 
	clear: function () {
		this._rects.clear();
	}
	, 
	_rects: null
	, 
	$type: new $.ig.Type('CollisionAvoider', $.ig.Object.prototype.$type, [$.ig.IDetectsCollisions.prototype.$type])
}, true);







$.ig.util.defType('SafeEnumerable', 'Object', {
	__target: null
	, 
	init: function (target) {



		$.ig.Object.prototype.init.call(this);
			this.__target = target;
	}

	, 
	makeSafe1: function (value) {
		if (Number.isInfinity(value) || $.ig.util.isNaN(value)) {
			return 0;
		}

		return value;
	}

	, 
	makeSafe: function () {
		var d__ = new $.ig.SafeEnumerable___MakeSafe__IteratorClass(-2);
		d__.__4__this = this;
		return d__;
	}

	, 
	getEnumerator: function () {
		return this.makeSafe().getEnumerator();
	}
	, 
	$type: new $.ig.Type('SafeEnumerable', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(Number)])
}, true);

$.ig.util.defType('SafeReadOnlyDoubleCollection', 'Object', {
	__target: null

	, 
	makeSafe: function (value) {
		if (Number.isInfinity(value) || $.ig.util.isNaN(value)) {
			return 0;
		}

		return value;
	}
	, 
	init: function (target) {



		$.ig.Object.prototype.init.call(this);
			this.__target = new $.ig.ReadOnlyCollection$1(Number, 1, target);
	}

	, 
	indexOf: function (item) {
		return this.__target.indexOf(item);
	}

	, 
	insert: function (index, item) {
		($.ig.util.cast($.ig.IList$1.prototype.$type.specialize(Number), this.__target)).insert(index, item);
	}

	, 
	removeAt: function (index) {
		($.ig.util.cast($.ig.IList$1.prototype.$type.specialize(Number), this.__target)).removeAt(index);
	}

	, 
	item: function (index, value) {
		if (arguments.length === 2) {

			($.ig.util.cast($.ig.IList$1.prototype.$type.specialize(Number), this.__target)).item(index, value);
			return value;
		} else {

			return this.makeSafe(this.__target.item(index));
		}
	}

	, 
	add: function (item) {
		($.ig.util.cast($.ig.IList$1.prototype.$type.specialize(Number), this.__target)).add(item);
	}

	, 
	clear: function () {
		($.ig.util.cast($.ig.IList$1.prototype.$type.specialize(Number), this.__target)).clear();
	}

	, 
	contains: function (item) {
		return this.__target.contains(item);
	}

	, 
	copyTo: function (array, arrayIndex) {
		for (var i = arrayIndex; i < array.length; i++) {
			array[i] = this.item(i);
		}

	}

	, 
	count: function () {

			return this.__target.count();
	}

	, 
	isReadOnly: function () {

			return ($.ig.util.cast($.ig.IList$1.prototype.$type.specialize(Number), this.__target)).isReadOnly();
	}

	, 
	remove: function (item) {
		return ($.ig.util.cast($.ig.IList$1.prototype.$type.specialize(Number), this.__target)).remove(item);
	}

	, 
	getEnumerator: function () {
		return new $.ig.SafeEnumerable(this.__target).getEnumerator();
	}
	, 
	$type: new $.ig.Type('SafeReadOnlyDoubleCollection', $.ig.Object.prototype.$type, [$.ig.IList$1.prototype.$type.specialize(Number)])
}, true);

$.ig.util.defType('SafeSortedReadOnlyDoubleCollection', 'Object', {
	__target: null
	, 
	__sortedIndices: null

	, 
	makeSafe: function (value) {
		if (Number.isInfinity(value) || $.ig.util.isNaN(value)) {
			return 0;
		}

		return value;
	}
	, 
	init: function (target, sortedIndices) {



		$.ig.Object.prototype.init.call(this);
			this.__target = new $.ig.SafeReadOnlyDoubleCollection(target);
			this.__sortedIndices = sortedIndices;
	}

	, 
	indexOf: function (item) {
		var innerIndex = this.__target.indexOf(item);
		return this.__sortedIndices.indexOf(innerIndex);
	}

	, 
	insert: function (index, item) {
		($.ig.util.cast($.ig.IList$1.prototype.$type.specialize(Number), this.__target)).insert(index, item);
	}

	, 
	removeAt: function (index) {
		($.ig.util.cast($.ig.IList$1.prototype.$type.specialize(Number), this.__target)).removeAt(index);
	}

	, 
	item: function (index, value) {
		if (arguments.length === 2) {

			($.ig.util.cast($.ig.IList$1.prototype.$type.specialize(Number), this.__target)).item(index, value);
			return value;
		} else {

			var innerIndex = this.__sortedIndices.item(index);
			return this.makeSafe(this.__target.item(innerIndex));
		}
	}

	, 
	add: function (item) {
		($.ig.util.cast($.ig.IList$1.prototype.$type.specialize(Number), this.__target)).add(item);
	}

	, 
	clear: function () {
		($.ig.util.cast($.ig.IList$1.prototype.$type.specialize(Number), this.__target)).clear();
	}

	, 
	contains: function (item) {
		return this.__target.contains(item);
	}

	, 
	copyTo: function (array, arrayIndex) {
		for (var i = arrayIndex; i < array.length; i++) {
			array[i] = this.item(i);
		}

	}

	, 
	count: function () {

			return this.__target.count();
	}

	, 
	isReadOnly: function () {

			return ($.ig.util.cast($.ig.IList$1.prototype.$type.specialize(Number), this.__target)).isReadOnly();
	}

	, 
	remove: function (item) {
		return ($.ig.util.cast($.ig.IList$1.prototype.$type.specialize(Number), this.__target)).remove(item);
	}

	, 
	getEnumerator: function () {
		var d__ = new $.ig.SafeSortedReadOnlyDoubleCollection___GetEnumerator__IteratorClass(0);
		d__.__4__this = this;
		return d__;
	}
	, 
	$type: new $.ig.Type('SafeSortedReadOnlyDoubleCollection', $.ig.Object.prototype.$type, [$.ig.IList$1.prototype.$type.specialize(Number)])
}, true);

$.ig.util.defType('SortedListView$1', 'Object', {
	$t: null, 
	__sortedIndices: null
	, 
	__source: null
	, 
	init: function ($t, source, sortedIndices) {

		this.$t = $t;
		this.$type = this.$type.specialize(this.$t);

		this.__sortedIndices = null;
		this.__source = null;

		$.ig.Object.prototype.init.call(this);
			this.__sortedIndices = sortedIndices;
			this.__source = source;
	}

	, 
	add: function (value) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	clear: function () {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	contains: function (value) {
		return this.__source.contains(value);
	}

	, 
	indexOf: function (value) {
		return this.__sortedIndices.indexOf(this.__source.indexOf(value));
	}

	, 
	insert: function (index, value) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	isFixedSize: function () {

			return true;
	}

	, 
	isReadOnly: function () {

			return true;
	}

	, 
	remove: function (value) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	removeAt: function (index) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	item: function (index, value) {
		if (arguments.length === 2) {

			throw new $.ig.NotImplementedException(0);
			return value;
		} else {

			return this.__source.item(this.__sortedIndices.item(index));
		}
	}

	, 
	count: function () {

			return this.__source.count();
	}

	, 
	isSynchronized: function () {

			throw new $.ig.NotImplementedException(0);
	}

	, 
	syncRoot: function () {

			throw new $.ig.NotImplementedException(0);
	}

	, 
	getEnumerator: function () {
		var d__ = new $.ig.SortedListView___GetEnumerator__IteratorClass$1(this.$t, 0);
		d__.__4__this = this;
		return d__;
	}

	, 
	getEnumerator: function () {
		var d__ = new $.ig.SortedListView___GetEnumerator__IteratorClass1$1(this.$t, 0);
		d__.__4__this = this;
		return d__;
	}

	, 
	copyTo: function (array, arrayIndex) {
		throw new $.ig.NotImplementedException(0);
	}
	, 
	$type: new $.ig.Type('SortedListView$1', $.ig.Object.prototype.$type, [$.ig.IList$1.prototype.$type.specialize(0)])
}, true);
































































































$.ig.util.defType('StackedSeriesVisualData', 'SeriesVisualData', {
	init: function () {



		$.ig.SeriesVisualData.prototype.init.call(this);
			this.fragmentSeries(new $.ig.SeriesVisualDataList());
	}

	, 
	_fragmentSeries: null,
	fragmentSeries: function (value) {
		if (arguments.length === 1) {
			this._fragmentSeries = value;
			return value;
		} else {
			return this._fragmentSeries;
		}
	}
	, 
	$type: new $.ig.Type('StackedSeriesVisualData', $.ig.SeriesVisualData.prototype.$type)
}, true);



$.ig.util.defType('SafeEnumerable___MakeSafe__IteratorClass', 'Object', {
	__1__state: 0
	, 
	__2__current: 0
	, 
	_valueEnumerator: null
	, 
	__value_5_0: 0
	, 
	__4__this: null
	, 
	init: function (_1__state) {



		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	_m_Finally0: function () {
		this.__1__state = -1;
		if (this._valueEnumerator != null) {
			this._valueEnumerator.dispose();
		}

	}

	, 
	moveNext: function () {
		var __hasError__ = false;
		try {
				while (this.__1__state >= 0) {
					switch (this.__1__state) {
						case 0:
							this.__1__state = -1;
							if (this.__4__this.__target == null) {
								return false;
							}

							this.__1__state = 1;
							this._valueEnumerator = this.__4__this.__target.getEnumerator();
							this.__1__state = 2;
							break;
						case 2:
							this.__1__state = 1;
							if (this._valueEnumerator.moveNext()) {
								this.__value_5_0 = this._valueEnumerator.current();
								this.__2__current = this.__4__this.makeSafe1(this.__value_5_0);
								this.__1__state = 2;
								return true;
							}

							this._m_Finally0();
							break;
					}


				}

		}
		catch (e) {
				__hasError__ = true;
				throw e;

		}finally {
				if (__hasError__) {
				(this).dispose();
				}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.SafeEnumerable___MakeSafe__IteratorClass(0);
			d__.__4__this = this.__4__this;
		}

		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
		switch (this.__1__state) {
			case 1:
			case 2:
				this._m_Finally0();
				break;
		}

	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('SafeEnumerable___MakeSafe__IteratorClass', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(Number), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize(Number), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

$.ig.util.defType('SafeSortedReadOnlyDoubleCollection___GetEnumerator__IteratorClass', 'Object', {
	__1__state: 0
	, 
	__2__current: 0
	, 
	__i_5_0: 0
	, 
	__4__this: null
	, 
	init: function (_1__state) {



		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	moveNext: function () {
		while (this.__1__state >= 0) {
			switch (this.__1__state) {
				case 0:
					this.__1__state = -1;
					this.__i_5_0 = 0;
					this.__1__state = 1;
					break;
				case 1:
					this.__1__state = -1;
					if (this.__i_5_0 < this.__4__this.__target.count()) {
						this.__2__current = this.__4__this.item(this.__i_5_0);
						this.__1__state = 2;
						return true;
					}

					break;
				case 2:
					this.__1__state = -1;
					this.__i_5_0++;
					this.__1__state = 1;
					break;
			}


		}
		return false;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('SafeSortedReadOnlyDoubleCollection___GetEnumerator__IteratorClass', $.ig.Object.prototype.$type, [$.ig.IEnumerator$1.prototype.$type.specialize(Number), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

$.ig.util.defType('SortedListView___GetEnumerator__IteratorClass$1', 'Object', {
	$t: null, 
	__1__state: 0
	, 
	__2__current: null
	, 
	__i_5_0: 0
	, 
	__4__this: null
	, 
	init: function ($t, _1__state) {

		this.$t = $t;
		this.$type = this.$type.specialize(this.$t);


		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	moveNext: function () {
		while (this.__1__state >= 0) {
			switch (this.__1__state) {
				case 0:
					this.__1__state = -1;
					this.__i_5_0 = 0;
					this.__1__state = 1;
					break;
				case 1:
					this.__1__state = -1;
					if (this.__i_5_0 < this.__4__this.count()) {
						this.__2__current = $.ig.util.getBoxIfEnum(this.$t, this.__4__this.item(this.__i_5_0));
						this.__1__state = 2;
						return true;
					}

					break;
				case 2:
					this.__1__state = -1;
					this.__i_5_0++;
					this.__1__state = 1;
					break;
			}


		}
		return false;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('SortedListView___GetEnumerator__IteratorClass$1', $.ig.Object.prototype.$type, [$.ig.IEnumerator$1.prototype.$type.specialize($.ig.Object.prototype.$type), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);









$.ig.util.defType('SortedListView___GetEnumerator__IteratorClass1$1', 'Object', {
	$t: null, 
	__1__state: 0
	, 
	__2__current: null
	, 
	__i_5_0: 0
	, 
	__4__this: null
	, 
	init: function ($t, _1__state) {

		this.$t = $t;
		this.$type = this.$type.specialize(this.$t);


		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	moveNext: function () {
		while (this.__1__state >= 0) {
			switch (this.__1__state) {
				case 0:
					this.__1__state = -1;
					this.__i_5_0 = 0;
					this.__1__state = 1;
					break;
				case 1:
					this.__1__state = -1;
					if (this.__i_5_0 < this.__4__this.count()) {
						this.__2__current = this.__4__this.item(this.__i_5_0);
						this.__1__state = 2;
						return true;
					}

					break;
				case 2:
					this.__1__state = -1;
					this.__i_5_0++;
					this.__1__state = 1;
					break;
			}


		}
		return false;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('SortedListView___GetEnumerator__IteratorClass1$1', $.ig.Object.prototype.$type, [$.ig.IEnumerator$1.prototype.$type.specialize(0), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);














$.ig.util.defType('CategoryAxisBase___RelatedAxes__IteratorClass', 'Object', {
	__1__state: 0
	, 
	__2__current: null
	, 
	__dataChart_5_0: null
	, 
	_chartEnumerator: null
	, 
	__chart_5_1: null
	, 
	__otherChart_5_2: null
	, 
	_axisEnumerator: null
	, 
	__axis_5_3: null
	, 
	__4__this: null
	, 
	init: function (_1__state) {



		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	_m_Finally0: function () {
		this.__1__state = -1;
		if (this._chartEnumerator != null) {
			this._chartEnumerator.dispose();
		}

	}

	, 
	_m_Finally1: function () {
		this.__1__state = 1;
		if (this._axisEnumerator != null) {
			this._axisEnumerator.dispose();
		}

	}

	, 
	moveNext: function () {
		var __hasError__ = false;
		try {
				while (this.__1__state >= 0) {
					switch (this.__1__state) {
						case 0:
							this.__1__state = -1;
							this.__dataChart_5_0 = $.ig.util.cast($.ig.XamDataChart.prototype.$type, this.__4__this.seriesViewer());
							if (this.__dataChart_5_0 != null && this.__dataChart_5_0.isSyncReady() && this.__4__this.shouldShareMode(this.__dataChart_5_0)) {
								this.__1__state = 1;
								this._chartEnumerator = this.__dataChart_5_0.synchronizedCharts().getEnumerator();
								this.__1__state = 2;
								break;
							}

							break;
						case 2:
							this.__1__state = 1;
							if (this._chartEnumerator.moveNext()) {
								this.__chart_5_1 = this._chartEnumerator.current();
								if (this.__chart_5_1 != this.__4__this.seriesViewer()) {
									this.__otherChart_5_2 = $.ig.util.cast($.ig.XamDataChart.prototype.$type, this.__chart_5_1);
									if (this.__otherChart_5_2 != null) {
										this.__1__state = 3;
										this._axisEnumerator = ((this.__otherChart_5_2.axes())).getEnumerator();
										this.__1__state = 4;
										break;
									}

								}

								this.__1__state = 2;
								break;
							}

							this._m_Finally0();
							break;
						case 4:
							this.__1__state = 3;
							if (this._axisEnumerator.moveNext()) {
								this.__axis_5_3 = this._axisEnumerator.current();
								if ($.ig.util.cast($.ig.CategoryAxisBase.prototype.$type, this.__axis_5_3) !== null) {
									this.__2__current = $.ig.util.cast($.ig.CategoryAxisBase.prototype.$type, this.__axis_5_3);
									this.__1__state = 4;
									return true;
								}

								this.__1__state = 4;
								break;
							}

							this._m_Finally1();
							this.__1__state = 2;
							break;
					}


				}

		}
		catch (e) {
				__hasError__ = true;
				throw e;

		}finally {
				if (__hasError__) {
				(this).dispose();
				}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.CategoryAxisBase___RelatedAxes__IteratorClass(0);
			d__.__4__this = this.__4__this;
		}

		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
		switch (this.__1__state) {
			case 1:
			case 2:
				this._m_Finally0();
				break;
			case 3:
			case 4:
				try {
						this._m_Finally1();

				}
				finally {
						this._m_Finally0();

				}
				break;
		}

	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('CategoryAxisBase___RelatedAxes__IteratorClass', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize($.ig.CategoryAxisBase.prototype.$type), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize($.ig.CategoryAxisBase.prototype.$type), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

$.ig.util.defType('CategoryAxisBase___RelatedSeries__IteratorClass', 'Object', {
	__1__state: 0
	, 
	__2__current: null
	, 
	_currentSeriesEnumerator: null
	, 
	__currentSeries_5_0: null
	, 
	_chartEnumerator: null
	, 
	__chart_5_1: null
	, 
	_currentSeriesEnumerator0: null
	, 
	__currentSeries_5_2: null
	, 
	__4__this: null
	, 
	init: function (_1__state) {



		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	_m_Finally0: function () {
		this.__1__state = -1;
		if (this._currentSeriesEnumerator != null) {
			this._currentSeriesEnumerator.dispose();
		}

	}

	, 
	_m_Finally1: function () {
		this.__1__state = -1;
		if (this._chartEnumerator != null) {
			this._chartEnumerator.dispose();
		}

	}

	, 
	_m_Finally2: function () {
		this.__1__state = 3;
		if (this._currentSeriesEnumerator0 != null) {
			this._currentSeriesEnumerator0.dispose();
		}

	}

	, 
	moveNext: function () {
		var __hasError__ = false;
		try {
				while (this.__1__state >= 0) {
					switch (this.__1__state) {
						case 0:
							this.__1__state = 1;
							this._currentSeriesEnumerator = this.__4__this.series().getEnumerator();
							this.__1__state = 2;
							break;
						case 2:
							this.__1__state = 1;
							if (this._currentSeriesEnumerator.moveNext()) {
								this.__currentSeries_5_0 = this._currentSeriesEnumerator.current();
								this.__2__current = this.__currentSeries_5_0;
								this.__1__state = 2;
								return true;
							}

							this._m_Finally0();
							if (this.__4__this.seriesViewer() != null && this.__4__this.seriesViewer().isSyncReady() && this.__4__this.shouldShareMode(this.__4__this.seriesViewer())) {
								this.__1__state = 3;
								this._chartEnumerator = this.__4__this.seriesViewer().synchronizedCharts().getEnumerator();
								this.__1__state = 4;
								break;
							}

							break;
						case 4:
							this.__1__state = 3;
							if (this._chartEnumerator.moveNext()) {
								this.__chart_5_1 = this._chartEnumerator.current();
								if (this.__chart_5_1 != this.__4__this.seriesViewer()) {
									this.__1__state = 5;
									this._currentSeriesEnumerator0 = ((this.__chart_5_1.series())).getEnumerator();
									this.__1__state = 6;
									break;
								}

								this.__1__state = 4;
								break;
							}

							this._m_Finally1();
							break;
						case 6:
							this.__1__state = 5;
							if (this._currentSeriesEnumerator0.moveNext()) {
								this.__currentSeries_5_2 = this._currentSeriesEnumerator0.current();
								this.__2__current = this.__currentSeries_5_2;
								this.__1__state = 6;
								return true;
							}

							this._m_Finally2();
							this.__1__state = 4;
							break;
					}


				}

		}
		catch (e) {
				__hasError__ = true;
				throw e;

		}finally {
				if (__hasError__) {
				(this).dispose();
				}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.CategoryAxisBase___RelatedSeries__IteratorClass(0);
			d__.__4__this = this.__4__this;
		}

		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
		switch (this.__1__state) {
			case 1:
			case 2:
				this._m_Finally0();
				break;
			case 3:
			case 4:
				this._m_Finally1();
				break;
			case 5:
			case 6:
				try {
						this._m_Finally2();

				}
				finally {
						this._m_Finally1();

				}
				break;
		}

	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('CategoryAxisBase___RelatedSeries__IteratorClass', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize($.ig.Series.prototype.$type), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize($.ig.Series.prototype.$type), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);







$.ig.SplineType.prototype.natural = 0;
$.ig.SplineType.prototype.clamped = 1;




$.ig.MarkerType.prototype.unset = 0;
$.ig.MarkerType.prototype.none = 1;
$.ig.MarkerType.prototype.automatic = 2;
$.ig.MarkerType.prototype.circle = 3;
$.ig.MarkerType.prototype.triangle = 4;
$.ig.MarkerType.prototype.pyramid = 5;
$.ig.MarkerType.prototype.square = 6;
$.ig.MarkerType.prototype.diamond = 7;
$.ig.MarkerType.prototype.pentagon = 8;
$.ig.MarkerType.prototype.hexagon = 9;
$.ig.MarkerType.prototype.tetragram = 10;
$.ig.MarkerType.prototype.pentagram = 11;
$.ig.MarkerType.prototype.hexagram = 12;














$.ig.TimeAxisDisplayType.prototype.continuous = 0;
$.ig.TimeAxisDisplayType.prototype.discrete = 1;





$.ig.CategoryTransitionInMode.prototype.auto = 0;
$.ig.CategoryTransitionInMode.prototype.fromZero = 1;
$.ig.CategoryTransitionInMode.prototype.sweepFromLeft = 2;
$.ig.CategoryTransitionInMode.prototype.sweepFromRight = 3;
$.ig.CategoryTransitionInMode.prototype.sweepFromTop = 4;
$.ig.CategoryTransitionInMode.prototype.sweepFromBottom = 5;
$.ig.CategoryTransitionInMode.prototype.sweepFromCenter = 6;
$.ig.CategoryTransitionInMode.prototype.accordionFromLeft = 7;
$.ig.CategoryTransitionInMode.prototype.accordionFromRight = 8;
$.ig.CategoryTransitionInMode.prototype.accordionFromTop = 9;
$.ig.CategoryTransitionInMode.prototype.accordionFromBottom = 10;
$.ig.CategoryTransitionInMode.prototype.expand = 11;
$.ig.CategoryTransitionInMode.prototype.sweepFromCategoryAxisMinimum = 12;
$.ig.CategoryTransitionInMode.prototype.sweepFromCategoryAxisMaximum = 13;
$.ig.CategoryTransitionInMode.prototype.sweepFromValueAxisMinimum = 14;
$.ig.CategoryTransitionInMode.prototype.sweepFromValueAxisMaximum = 15;
$.ig.CategoryTransitionInMode.prototype.accordionFromCategoryAxisMinimum = 16;
$.ig.CategoryTransitionInMode.prototype.accordionFromCategoryAxisMaximum = 17;
$.ig.CategoryTransitionInMode.prototype.accordionFromValueAxisMinimum = 18;
$.ig.CategoryTransitionInMode.prototype.accordionFromValueAxisMaximum = 19;



$.ig.NumericScaleMode.prototype.linear = 0;
$.ig.NumericScaleMode.prototype.logarithmic = 1;





















$.ig.Snapper.prototype.resolution = 7;


$.ig.CategoryAxisBase.prototype.fastItemsSourcePropertyName = "FastItemsSource";
$.ig.CategoryAxisBase.prototype.fastItemsSourceProperty = $.ig.DependencyProperty.prototype.register($.ig.CategoryAxisBase.prototype.fastItemsSourcePropertyName, $.ig.IFastItemsSource.prototype.$type, $.ig.CategoryAxisBase.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.CategoryAxisBase.prototype.$type, sender)).raisePropertyChanged($.ig.CategoryAxisBase.prototype.fastItemsSourcePropertyName, e.oldValue(), e.newValue());
}));
$.ig.CategoryAxisBase.prototype.itemsSourcePropertyName = "ItemsSource";
$.ig.CategoryAxisBase.prototype.itemsSourceProperty = $.ig.DependencyProperty.prototype.register($.ig.CategoryAxisBase.prototype.itemsSourcePropertyName, $.ig.IEnumerable.prototype.$type, $.ig.CategoryAxisBase.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	var axis = $.ig.util.cast($.ig.CategoryAxisBase.prototype.$type, sender);
	if (axis.fastItemsSourceProvider() != null) {
		axis.fastItemsSourceProvider().releaseFastItemsSource(e.oldValue());
	}

	($.ig.util.cast($.ig.CategoryAxisBase.prototype.$type, sender)).raisePropertyChanged($.ig.CategoryAxisBase.prototype.itemsSourcePropertyName, e.oldValue(), e.newValue());
}));
$.ig.CategoryAxisBase.prototype.itemsCountPropertyName = "ItemsCount";
$.ig.CategoryAxisBase.prototype.categoryModePropertyName = "CategoryMode";
$.ig.CategoryAxisBase.prototype.gapPropertyName = "Gap";
$.ig.CategoryAxisBase.prototype.gapProperty = $.ig.DependencyProperty.prototype.register($.ig.CategoryAxisBase.prototype.gapPropertyName, Number, $.ig.CategoryAxisBase.prototype.$type, new $.ig.PropertyMetadata(2, 0.2, function (sender, e) {
	($.ig.util.cast($.ig.CategoryAxisBase.prototype.$type, sender)).raisePropertyChanged($.ig.CategoryAxisBase.prototype.gapPropertyName, e.oldValue(), e.newValue());
}));
$.ig.CategoryAxisBase.prototype.overlapPropertyName = "Overlap";
$.ig.CategoryAxisBase.prototype.overlapProperty = $.ig.DependencyProperty.prototype.register($.ig.CategoryAxisBase.prototype.overlapPropertyName, Number, $.ig.CategoryAxisBase.prototype.$type, new $.ig.PropertyMetadata(2, 0, function (sender, e) {
	($.ig.util.cast($.ig.CategoryAxisBase.prototype.$type, sender)).raisePropertyChanged($.ig.CategoryAxisBase.prototype.overlapPropertyName, e.oldValue(), e.newValue());
}));
$.ig.CategoryAxisBase.prototype.useClusteringModePropertyName = "UseClusteringMode";
$.ig.CategoryAxisBase.prototype.useClusteringModeProperty = $.ig.DependencyProperty.prototype.register($.ig.CategoryAxisBase.prototype.useClusteringModePropertyName, $.ig.Boolean.prototype.$type, $.ig.CategoryAxisBase.prototype.$type, new $.ig.PropertyMetadata(2, false, function (sender, e) {
	($.ig.util.cast($.ig.CategoryAxisBase.prototype.$type, sender)).raisePropertyChanged($.ig.CategoryAxisBase.prototype.useClusteringModePropertyName, e.oldValue(), e.newValue());
}));
$.ig.CategoryAxisBase.prototype.groupCountPropertyName = "GroupCount";



$.ig.CategoryDateTimeXAxis.prototype.displayTypePropertyName = "DisplayType";
$.ig.CategoryDateTimeXAxis.prototype.displayTypeProperty = $.ig.DependencyProperty.prototype.register($.ig.CategoryDateTimeXAxis.prototype.displayTypePropertyName, $.ig.TimeAxisDisplayType.prototype.$type, $.ig.CategoryDateTimeXAxis.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.TimeAxisDisplayType.prototype.getBox($.ig.TimeAxisDisplayType.prototype.continuous), function (sender, e) {
	($.ig.util.cast($.ig.CategoryDateTimeXAxis.prototype.$type, sender)).raisePropertyChanged($.ig.CategoryDateTimeXAxis.prototype.displayTypePropertyName, e.oldValue(), e.newValue());
}));
$.ig.CategoryDateTimeXAxis.prototype.minimumValuePropertyName = "MinimumValue";
$.ig.CategoryDateTimeXAxis.prototype.minimumValueProperty = $.ig.DependencyProperty.prototype.register($.ig.CategoryDateTimeXAxis.prototype.minimumValuePropertyName, $.ig.Date.prototype.$type, $.ig.CategoryDateTimeXAxis.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.CategoryDateTimeXAxis.prototype.$type, sender)).raisePropertyChanged($.ig.CategoryDateTimeXAxis.prototype.minimumValuePropertyName, e.oldValue(), e.newValue());
}));
$.ig.CategoryDateTimeXAxis.prototype.maximumValuePropertyName = "MaximumValue";
$.ig.CategoryDateTimeXAxis.prototype.maximumValueProperty = $.ig.DependencyProperty.prototype.register($.ig.CategoryDateTimeXAxis.prototype.maximumValuePropertyName, $.ig.Date.prototype.$type, $.ig.CategoryDateTimeXAxis.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.CategoryDateTimeXAxis.prototype.$type, sender)).raisePropertyChanged($.ig.CategoryDateTimeXAxis.prototype.maximumValuePropertyName, e.oldValue(), e.newValue());
}));
$.ig.CategoryDateTimeXAxis.prototype.intervalPropertyName = "Interval";
$.ig.CategoryDateTimeXAxis.prototype.intervalProperty = $.ig.DependencyProperty.prototype.register($.ig.CategoryDateTimeXAxis.prototype.intervalPropertyName, $.ig.Number.prototype.$type, $.ig.CategoryDateTimeXAxis.prototype.$type, new $.ig.PropertyMetadata(2, 0, function (sender, e) {
	($.ig.util.cast($.ig.CategoryDateTimeXAxis.prototype.$type, sender)).raisePropertyChanged($.ig.CategoryDateTimeXAxis.prototype.intervalPropertyName, e.oldValue(), e.newValue());
}));
$.ig.CategoryDateTimeXAxis.prototype._actualMinimumValuePropertyName = "ActualMinimumValue";
$.ig.CategoryDateTimeXAxis.prototype._actualMaximumValuePropertyName = "ActualMaximumValue";
$.ig.CategoryDateTimeXAxis.prototype._dateTimeMemberPathPropertyName = "DateTimeMemberPath";
$.ig.CategoryDateTimeXAxis.prototype.dateTimeMemberPathProperty = $.ig.DependencyProperty.prototype.register($.ig.CategoryDateTimeXAxis.prototype._dateTimeMemberPathPropertyName, String, $.ig.CategoryDateTimeXAxis.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.CategoryDateTimeXAxis.prototype.$type, sender)).raisePropertyChanged($.ig.CategoryDateTimeXAxis.prototype._dateTimeMemberPathPropertyName, e.oldValue(), e.newValue());
}));
$.ig.CategoryDateTimeXAxis.prototype.dateTimeColumnPropertyName = "DateTimeColumn";


$.ig.CategoryXAxis.prototype._intervalPropertyName = "Interval";
$.ig.CategoryXAxis.prototype.intervalProperty = $.ig.DependencyProperty.prototype.register($.ig.CategoryXAxis.prototype._intervalPropertyName, Number, $.ig.CategoryXAxis.prototype.$type, new $.ig.PropertyMetadata(2, NaN, function (sender, e) {
	($.ig.util.cast($.ig.CategoryXAxis.prototype.$type, sender)).raisePropertyChanged($.ig.CategoryXAxis.prototype._intervalPropertyName, e.oldValue(), e.newValue());
	($.ig.util.cast($.ig.CategoryXAxis.prototype.$type, sender)).renderAxis1(false);
}));


$.ig.CategoryYAxis.prototype._intervalPropertyName = "Interval";
$.ig.CategoryYAxis.prototype.intervalProperty = $.ig.DependencyProperty.prototype.register($.ig.CategoryYAxis.prototype._intervalPropertyName, Number, $.ig.CategoryYAxis.prototype.$type, new $.ig.PropertyMetadata(2, NaN, function (sender, e) {
	($.ig.util.cast($.ig.CategoryYAxis.prototype.$type, sender)).raisePropertyChanged($.ig.CategoryYAxis.prototype._intervalPropertyName, e.oldValue(), e.newValue());
	($.ig.util.cast($.ig.CategoryYAxis.prototype.$type, sender)).renderAxis1(false);
}));


$.ig.NumericAxisBase.prototype.minimumValuePropertyName = "MinimumValue";
$.ig.NumericAxisBase.prototype.minimumValueProperty = $.ig.DependencyProperty.prototype.register($.ig.NumericAxisBase.prototype.minimumValuePropertyName, Number, $.ig.NumericAxisBase.prototype.$type, new $.ig.PropertyMetadata(2, NaN, function (sender, e) {
	($.ig.util.cast($.ig.NumericAxisBase.prototype.$type, sender)).raisePropertyChanged($.ig.NumericAxisBase.prototype.minimumValuePropertyName, e.oldValue(), e.newValue());
}));
$.ig.NumericAxisBase.prototype.actualMinimumValuePropertyName = "ActualMinimumValue";
$.ig.NumericAxisBase.prototype.maximumValuePropertyName = "MaximumValue";
$.ig.NumericAxisBase.prototype.maximumValueProperty = $.ig.DependencyProperty.prototype.register($.ig.NumericAxisBase.prototype.maximumValuePropertyName, Number, $.ig.NumericAxisBase.prototype.$type, new $.ig.PropertyMetadata(2, NaN, function (sender, e) {
	($.ig.util.cast($.ig.NumericAxisBase.prototype.$type, sender)).raisePropertyChanged($.ig.NumericAxisBase.prototype.maximumValuePropertyName, e.oldValue(), e.newValue());
}));
$.ig.NumericAxisBase.prototype.actualMaximumValuePropertyName = "ActualMaximumValue";
$.ig.NumericAxisBase.prototype.intervalPropertyName = "Interval";
$.ig.NumericAxisBase.prototype.intervalProperty = $.ig.DependencyProperty.prototype.register($.ig.NumericAxisBase.prototype.intervalPropertyName, Number, $.ig.NumericAxisBase.prototype.$type, new $.ig.PropertyMetadata(2, NaN, function (sender, e) {
	($.ig.util.cast($.ig.NumericAxisBase.prototype.$type, sender)).raisePropertyChanged($.ig.NumericAxisBase.prototype.intervalPropertyName, e.oldValue(), e.newValue());
}));
$.ig.NumericAxisBase.prototype.referenceValuePropertyName = "ReferenceValue";
$.ig.NumericAxisBase.prototype.referenceValueProperty = $.ig.DependencyProperty.prototype.register($.ig.NumericAxisBase.prototype.referenceValuePropertyName, Number, $.ig.NumericAxisBase.prototype.$type, new $.ig.PropertyMetadata(2, 0, function (sender, e) {
	($.ig.util.cast($.ig.NumericAxisBase.prototype.$type, sender)).raisePropertyChanged($.ig.NumericAxisBase.prototype.referenceValuePropertyName, e.oldValue(), e.newValue());
}));
$.ig.NumericAxisBase.prototype.isLogarithmicPropertyName = "IsLogarithmic";
$.ig.NumericAxisBase.prototype.isLogarithmicProperty = $.ig.DependencyProperty.prototype.register($.ig.NumericAxisBase.prototype.isLogarithmicPropertyName, $.ig.Boolean.prototype.$type, $.ig.NumericAxisBase.prototype.$type, new $.ig.PropertyMetadata(2, false, function (sender, e) {
	($.ig.util.cast($.ig.NumericAxisBase.prototype.$type, sender)).raisePropertyChanged($.ig.NumericAxisBase.prototype.isLogarithmicPropertyName, e.oldValue(), e.newValue());
}));
$.ig.NumericAxisBase.prototype._actualIsLogarithmicPropertyName = "ActualIsLogarithmic";
$.ig.NumericAxisBase.prototype.logarithmBasePropertyName = "LogarithmBase";
$.ig.NumericAxisBase.prototype.logarithmBaseProperty = $.ig.DependencyProperty.prototype.register($.ig.NumericAxisBase.prototype.logarithmBasePropertyName, $.ig.Number.prototype.$type, $.ig.NumericAxisBase.prototype.$type, new $.ig.PropertyMetadata(2, 10, function (sender, e) {
	($.ig.util.cast($.ig.NumericAxisBase.prototype.$type, sender)).raisePropertyChanged($.ig.NumericAxisBase.prototype.logarithmBasePropertyName, e.oldValue(), e.newValue());
}));
$.ig.NumericAxisBase.prototype._tickmarkValuesPropertyName = "TickmarkValues";
$.ig.NumericAxisBase.prototype.tickmarkValuesProperty = $.ig.DependencyProperty.prototype.register($.ig.NumericAxisBase.prototype._tickmarkValuesPropertyName, $.ig.TickmarkValues.prototype.$type, $.ig.NumericAxisBase.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.NumericAxisBase.prototype.$type, sender)).raisePropertyChanged($.ig.NumericAxisBase.prototype._tickmarkValuesPropertyName, e.oldValue(), e.newValue());
}));
$.ig.NumericAxisBase.prototype._actualTickmarkValuesPropertyName = "ActualTickmarkValues";



$.ig.StraightNumericAxisBase.prototype.scaleModePropertyName = "ScaleMode";
$.ig.StraightNumericAxisBase.prototype.scaleModeProperty = $.ig.DependencyProperty.prototype.register($.ig.StraightNumericAxisBase.prototype.scaleModePropertyName, $.ig.NumericScaleMode.prototype.$type, $.ig.StraightNumericAxisBase.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.NumericScaleMode.prototype.getBox($.ig.NumericScaleMode.prototype.linear), function (sender, e) {
	($.ig.util.cast($.ig.StraightNumericAxisBase.prototype.$type, sender)).raisePropertyChanged($.ig.StraightNumericAxisBase.prototype.scaleModePropertyName, e.oldValue(), e.newValue());
}));
$.ig.StraightNumericAxisBase.prototype.scalerPropertyName = "Scaler";
$.ig.StraightNumericAxisBase.prototype.scalerProperty = $.ig.DependencyProperty.prototype.register($.ig.StraightNumericAxisBase.prototype.scalerPropertyName, $.ig.NumericScaler.prototype.$type, $.ig.StraightNumericAxisBase.prototype.$type, new $.ig.PropertyMetadata(2, null, $.ig.StraightNumericAxisBase.prototype.onScalerPropertyChanged));
$.ig.StraightNumericAxisBase.prototype._actualScalerPropertyName = "ActualScaler";



$.ig.NumericScaler.prototype.actualMinimumValuePropertyName = "ActualMinimumValue";
$.ig.NumericScaler.prototype.actualMinimumValueProperty = $.ig.DependencyProperty.prototype.register($.ig.NumericScaler.prototype.actualMinimumValuePropertyName, Number, $.ig.NumericScaler.prototype.$type, new $.ig.PropertyMetadata(2, NaN, function (sender, e) {
	($.ig.util.cast($.ig.NumericScaler.prototype.$type, sender)).onPropertyChanged($.ig.NumericScaler.prototype.actualMinimumValuePropertyName, e.oldValue(), e.newValue());
}));
$.ig.NumericScaler.prototype.actualMaximumValuePropertyName = "ActualMaximumValue";
$.ig.NumericScaler.prototype.actualMaximumValueProperty = $.ig.DependencyProperty.prototype.register($.ig.NumericScaler.prototype.actualMaximumValuePropertyName, Number, $.ig.NumericScaler.prototype.$type, new $.ig.PropertyMetadata(2, NaN, function (sender, e) {
	($.ig.util.cast($.ig.NumericScaler.prototype.$type, sender)).onPropertyChanged($.ig.NumericScaler.prototype.actualMaximumValuePropertyName, e.oldValue(), e.newValue());
}));


$.ig.LogarithmicTickmarkValues.prototype._mINIMUM_VALUE_GREATER_THAN_ZERO = 4.94065645841247E-324;
$.ig.LogarithmicTickmarkValues.prototype._logarithmBasePropertyName = "LogarithmBase";
$.ig.LogarithmicTickmarkValues.prototype.logarithmBaseProperty = $.ig.DependencyProperty.prototype.register($.ig.LogarithmicTickmarkValues.prototype._logarithmBasePropertyName, $.ig.Number.prototype.$type, $.ig.LogarithmicTickmarkValues.prototype.$type, new $.ig.PropertyMetadata(2, 10, function (sender, e) {
}));


$.ig.TrendLineManagerBase$1.prototype.trendLineDashArrayPropertyName = "TrendLineDashArray";
$.ig.TrendLineManagerBase$1.prototype.trendLineTypePropertyName = "TrendLineType";
$.ig.TrendLineManagerBase$1.prototype.trendLinePeriodPropertyName = "TrendLinePeriod";
$.ig.TrendLineManagerBase$1.prototype.trendLineBrushPropertyName = "TrendLineBrush";
$.ig.TrendLineManagerBase$1.prototype.trendLineActualBrushPropertyName = "ActualTrendLineBrush";
$.ig.TrendLineManagerBase$1.prototype.trendLineThicknessPropertyName = "TrendLineThickness";
$.ig.TrendLineManagerBase$1.prototype.trendLineDashCapPropertyName = "TrendLineDashCap";
$.ig.TrendLineManagerBase$1.prototype.trendLineZIndexPropertyName = "TrendLineZIndex";


$.ig.MarkerSeries.prototype.markerTypePropertyName = "MarkerType";
$.ig.MarkerSeries.prototype.markerTypeProperty = $.ig.DependencyProperty.prototype.register($.ig.MarkerSeries.prototype.markerTypePropertyName, $.ig.MarkerType.prototype.$type, $.ig.MarkerSeries.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.MarkerType.prototype.getBox($.ig.MarkerType.prototype.none), function (sender, e) {
	($.ig.util.cast($.ig.MarkerSeries.prototype.$type, sender)).raisePropertyChanged($.ig.MarkerSeries.prototype.markerTypePropertyName, e.oldValue(), e.newValue());
}));
$.ig.MarkerSeries.prototype.markerTemplatePropertyName = "MarkerTemplate";
$.ig.MarkerSeries.prototype.markerTemplateProperty = $.ig.DependencyProperty.prototype.register($.ig.MarkerSeries.prototype.markerTemplatePropertyName, $.ig.DataTemplate.prototype.$type, $.ig.MarkerSeries.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.MarkerSeries.prototype.$type, sender)).raisePropertyChanged($.ig.MarkerSeries.prototype.markerTemplatePropertyName, e.oldValue(), e.newValue());
}));
$.ig.MarkerSeries.prototype.actualMarkerTemplatePropertyName = "ActualMarkerTemplate";
$.ig.MarkerSeries.prototype.actualMarkerTemplateProperty = $.ig.DependencyProperty.prototype.register($.ig.MarkerSeries.prototype.actualMarkerTemplatePropertyName, $.ig.DataTemplate.prototype.$type, $.ig.MarkerSeries.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.MarkerSeries.prototype.$type, sender)).raisePropertyChanged($.ig.MarkerSeries.prototype.actualMarkerTemplatePropertyName, e.oldValue(), e.newValue());
}));
$.ig.MarkerSeries.prototype.__nullMarkerTemplate = null;
$.ig.MarkerSeries.prototype.markerBrushPropertyName = "MarkerBrush";
$.ig.MarkerSeries.prototype.markerBrushProperty = $.ig.DependencyProperty.prototype.register($.ig.MarkerSeries.prototype.markerBrushPropertyName, $.ig.Brush.prototype.$type, $.ig.MarkerSeries.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	var markerSeries = ($.ig.util.cast($.ig.MarkerSeries.prototype.$type, sender));
	markerSeries.raisePropertyChanged($.ig.MarkerSeries.prototype.markerBrushPropertyName, e.oldValue(), e.newValue());
}));
$.ig.MarkerSeries.prototype.actualMarkerBrushPropertyName = "ActualMarkerBrush";
$.ig.MarkerSeries.prototype.actualMarkerBrushProperty = $.ig.DependencyProperty.prototype.register($.ig.MarkerSeries.prototype.actualMarkerBrushPropertyName, $.ig.Brush.prototype.$type, $.ig.MarkerSeries.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.MarkerSeries.prototype.$type, sender)).raisePropertyChanged($.ig.MarkerSeries.prototype.actualMarkerBrushPropertyName, e.oldValue(), e.newValue());
}));
$.ig.MarkerSeries.prototype.markerOutlinePropertyName = "MarkerOutline";
$.ig.MarkerSeries.prototype.markerOutlineProperty = $.ig.DependencyProperty.prototype.register($.ig.MarkerSeries.prototype.markerOutlinePropertyName, $.ig.Brush.prototype.$type, $.ig.MarkerSeries.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.MarkerSeries.prototype.$type, sender)).raisePropertyChanged($.ig.MarkerSeries.prototype.markerOutlinePropertyName, e.oldValue(), e.newValue());
}));
$.ig.MarkerSeries.prototype.actualMarkerOutlinePropertyName = "ActualMarkerOutline";
$.ig.MarkerSeries.prototype.actualMarkerOutlineProperty = $.ig.DependencyProperty.prototype.register($.ig.MarkerSeries.prototype.actualMarkerOutlinePropertyName, $.ig.Brush.prototype.$type, $.ig.MarkerSeries.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.MarkerSeries.prototype.$type, sender)).raisePropertyChanged($.ig.MarkerSeries.prototype.actualMarkerOutlinePropertyName, e.oldValue(), e.newValue());
}));
$.ig.MarkerSeries.prototype.markerStylePropertyName = "MarkerStyle";
$.ig.MarkerSeries.prototype.markerStyleProperty = $.ig.DependencyProperty.prototype.register($.ig.MarkerSeries.prototype.markerStylePropertyName, $.ig.Style.prototype.$type, $.ig.MarkerSeries.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.MarkerSeries.prototype.$type, sender)).raisePropertyChanged($.ig.MarkerSeries.prototype.markerStylePropertyName, e.oldValue(), e.newValue());
}));
$.ig.MarkerSeries.prototype.useLightweightMarkersPropertyName = "UseLightweightMarkers";
$.ig.MarkerSeries.prototype.useLightweightMarkersProperty = $.ig.DependencyProperty.prototype.register($.ig.MarkerSeries.prototype.useLightweightMarkersPropertyName, $.ig.Boolean.prototype.$type, $.ig.MarkerSeries.prototype.$type, new $.ig.PropertyMetadata(2, false, function (sender, e) {
	($.ig.util.cast($.ig.MarkerSeries.prototype.$type, sender)).raisePropertyChanged($.ig.MarkerSeries.prototype.useLightweightMarkersPropertyName, e.oldValue(), e.newValue());
}));







$.ig.CategorySeries.prototype.isCustomCategoryStyleAllowedPropertyName = "IsCustomCategoryStyleAllowed";
$.ig.CategorySeries.prototype.isCustomCategoryStyleAllowedProperty = $.ig.DependencyProperty.prototype.register($.ig.CategorySeries.prototype.isCustomCategoryStyleAllowedPropertyName, $.ig.Boolean.prototype.$type, $.ig.CategorySeries.prototype.$type, new $.ig.PropertyMetadata(2, false, function (sender, e) {
	($.ig.util.cast($.ig.CategorySeries.prototype.$type, sender)).raisePropertyChanged($.ig.CategorySeries.prototype.isCustomCategoryStyleAllowedPropertyName, e.oldValue(), e.newValue());
}));
$.ig.CategorySeries.prototype.isCustomCategoryMarkerStyleAllowedPropertyName = "IsCustomCategoryMarkerStyleAllowed";
$.ig.CategorySeries.prototype.isCustomCategoryMarkerStyleAllowedProperty = $.ig.DependencyProperty.prototype.register($.ig.CategorySeries.prototype.isCustomCategoryMarkerStyleAllowedPropertyName, $.ig.Boolean.prototype.$type, $.ig.CategorySeries.prototype.$type, new $.ig.PropertyMetadata(2, false, function (sender, e) {
	($.ig.util.cast($.ig.CategorySeries.prototype.$type, sender)).raisePropertyChanged($.ig.CategorySeries.prototype.isCustomCategoryMarkerStyleAllowedPropertyName, e.oldValue(), e.newValue());
}));
$.ig.CategorySeries.prototype.errorBarSettingsPropertyName = "ErrorBarSettings";
$.ig.CategorySeries.prototype.useHighMarkerFidelityPropertyName = "UseHighMarkerFidelity";
$.ig.CategorySeries.prototype.useHighMarkerFidelityProperty = $.ig.DependencyProperty.prototype.register($.ig.CategorySeries.prototype.useHighMarkerFidelityPropertyName, $.ig.Boolean.prototype.$type, $.ig.CategorySeries.prototype.$type, new $.ig.PropertyMetadata(2, false, function (sender, e) {
	($.ig.util.cast($.ig.CategorySeries.prototype.$type, sender)).raisePropertyChanged($.ig.CategorySeries.prototype.useHighMarkerFidelityPropertyName, e.oldValue(), e.newValue());
}));
$.ig.CategorySeries.prototype.transitionInModePropertyName = "TransitionInMode";
$.ig.CategorySeries.prototype.transitionInModeProperty = $.ig.DependencyProperty.prototype.register($.ig.CategorySeries.prototype.transitionInModePropertyName, $.ig.CategoryTransitionInMode.prototype.$type, $.ig.CategorySeries.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.CategoryTransitionInMode.prototype.getBox($.ig.CategoryTransitionInMode.prototype.auto), function (sender, e) {
	($.ig.util.cast($.ig.CategorySeries.prototype.$type, sender)).raisePropertyChanged($.ig.CategorySeries.prototype.transitionInModePropertyName, e.oldValue(), e.newValue());
}));
$.ig.CategorySeries.prototype.isTransitionInEnabledPropertyName = "IsTransitionInEnabled";
$.ig.CategorySeries.prototype.isTransitionInEnabledProperty = $.ig.DependencyProperty.prototype.register($.ig.CategorySeries.prototype.isTransitionInEnabledPropertyName, $.ig.Boolean.prototype.$type, $.ig.CategorySeries.prototype.$type, new $.ig.PropertyMetadata(2, false, function (sender, e) {
	($.ig.util.cast($.ig.CategorySeries.prototype.$type, sender)).raisePropertyChanged($.ig.CategorySeries.prototype.isTransitionInEnabledPropertyName, e.oldValue(), e.newValue());
}));


$.ig.AnchoredCategorySeries.prototype.valueMemberPathPropertyName = "ValueMemberPath";
$.ig.AnchoredCategorySeries.prototype.valueMemberPathProperty = $.ig.DependencyProperty.prototype.register($.ig.AnchoredCategorySeries.prototype.valueMemberPathPropertyName, String, $.ig.AnchoredCategorySeries.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
		($.ig.util.cast($.ig.AnchoredCategorySeries.prototype.$type, sender)).raisePropertyChanged($.ig.AnchoredCategorySeries.prototype.valueMemberPathPropertyName, e.oldValue(), e.newValue());
}));
$.ig.AnchoredCategorySeries.prototype.valueColumnPropertyName = "ValueColumn";
$.ig.AnchoredCategorySeries.prototype.trendLineTypeProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.trendLineTypePropertyName, $.ig.TrendLineType.prototype.$type, $.ig.AnchoredCategorySeries.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.TrendLineType.prototype.getBox($.ig.TrendLineType.prototype.none), function (sender, e) {
	($.ig.util.cast($.ig.AnchoredCategorySeries.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.trendLineTypePropertyName, e.oldValue(), e.newValue());
}));
$.ig.AnchoredCategorySeries.prototype.trendLineBrushProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.trendLineBrushPropertyName, $.ig.Brush.prototype.$type, $.ig.AnchoredCategorySeries.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.AnchoredCategorySeries.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.trendLineBrushPropertyName, e.oldValue(), e.newValue());
}));
$.ig.AnchoredCategorySeries.prototype.actualTrendLineBrushProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.trendLineActualBrushPropertyName, $.ig.Brush.prototype.$type, $.ig.AnchoredCategorySeries.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.AnchoredCategorySeries.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.trendLineActualBrushPropertyName, e.oldValue(), e.newValue());
}));
$.ig.AnchoredCategorySeries.prototype.trendLineThicknessProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.trendLineThicknessPropertyName, Number, $.ig.AnchoredCategorySeries.prototype.$type, new $.ig.PropertyMetadata(2, 1.5, function (sender, e) {
	($.ig.util.cast($.ig.AnchoredCategorySeries.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.trendLineThicknessPropertyName, e.oldValue(), e.newValue());
}));
$.ig.AnchoredCategorySeries.prototype.trendLineDashCapProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.trendLineDashCapPropertyName, $.ig.PenLineCap.prototype.$type, $.ig.AnchoredCategorySeries.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.PenLineCap.prototype.getBox($.ig.PenLineCap.prototype.flat), function (sender, e) {
	($.ig.util.cast($.ig.AnchoredCategorySeries.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.trendLineDashCapPropertyName, e.oldValue(), e.newValue());
}));
$.ig.AnchoredCategorySeries.prototype.trendLineDashArrayProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.trendLineDashArrayPropertyName, $.ig.DoubleCollection.prototype.$type, $.ig.AnchoredCategorySeries.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.AnchoredCategorySeries.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.trendLineDashArrayPropertyName, e.oldValue(), e.newValue());
}));
$.ig.AnchoredCategorySeries.prototype.trendLinePeriodProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.trendLinePeriodPropertyName, $.ig.Number.prototype.$type, $.ig.AnchoredCategorySeries.prototype.$type, new $.ig.PropertyMetadata(2, 7, function (sender, e) {
	($.ig.util.cast($.ig.AnchoredCategorySeries.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.trendLinePeriodPropertyName, e.oldValue(), e.newValue());
}));
$.ig.AnchoredCategorySeries.prototype.trendLineZIndexProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.trendLineZIndexPropertyName, $.ig.Number.prototype.$type, $.ig.AnchoredCategorySeries.prototype.$type, new $.ig.PropertyMetadata(2, 1001, function (sender, e) {
	($.ig.util.cast($.ig.AnchoredCategorySeries.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.trendLineZIndexPropertyName, e.oldValue(), e.newValue());
}));


$.ig.VerticalAnchoredCategorySeries.prototype.xAxisPropertyName = "XAxis";
$.ig.VerticalAnchoredCategorySeries.prototype.xAxisProperty = $.ig.DependencyProperty.prototype.register($.ig.VerticalAnchoredCategorySeries.prototype.xAxisPropertyName, $.ig.NumericXAxis.prototype.$type, $.ig.VerticalAnchoredCategorySeries.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
		($.ig.util.cast($.ig.VerticalAnchoredCategorySeries.prototype.$type, sender)).raisePropertyChanged($.ig.VerticalAnchoredCategorySeries.prototype.xAxisPropertyName, e.oldValue(), e.newValue());
}));
$.ig.VerticalAnchoredCategorySeries.prototype.yAxisPropertyName = "YAxis";
$.ig.VerticalAnchoredCategorySeries.prototype.yAxisProperty = $.ig.DependencyProperty.prototype.register($.ig.VerticalAnchoredCategorySeries.prototype.yAxisPropertyName, $.ig.CategoryYAxis.prototype.$type, $.ig.VerticalAnchoredCategorySeries.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
		($.ig.util.cast($.ig.VerticalAnchoredCategorySeries.prototype.$type, sender)).raisePropertyChanged($.ig.VerticalAnchoredCategorySeries.prototype.yAxisPropertyName, e.oldValue(), e.newValue());
}));


$.ig.BarSeries.prototype.radiusXPropertyName = "RadiusX";
$.ig.BarSeries.prototype.radiusXProperty = $.ig.DependencyProperty.prototype.register($.ig.BarSeries.prototype.radiusXPropertyName, Number, $.ig.BarSeries.prototype.$type, new $.ig.PropertyMetadata(2, 2, function (sender, e) {
	($.ig.util.cast($.ig.BarSeries.prototype.$type, sender)).raisePropertyChanged($.ig.BarSeries.prototype.radiusXPropertyName, e.oldValue(), e.newValue());
}));
$.ig.BarSeries.prototype.radiusYPropertyName = "RadiusY";
$.ig.BarSeries.prototype.radiusYProperty = $.ig.DependencyProperty.prototype.register($.ig.BarSeries.prototype.radiusYPropertyName, Number, $.ig.BarSeries.prototype.$type, new $.ig.PropertyMetadata(2, 2, function (sender, e) {
	($.ig.util.cast($.ig.BarSeries.prototype.$type, sender)).raisePropertyChanged($.ig.BarSeries.prototype.radiusYPropertyName, e.oldValue(), e.newValue());
}));


$.ig.HorizontalAnchoredCategorySeries.prototype.xAxisPropertyName = "XAxis";
$.ig.HorizontalAnchoredCategorySeries.prototype.xAxisProperty = $.ig.DependencyProperty.prototype.register($.ig.HorizontalAnchoredCategorySeries.prototype.xAxisPropertyName, $.ig.CategoryAxisBase.prototype.$type, $.ig.HorizontalAnchoredCategorySeries.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
		($.ig.util.cast($.ig.HorizontalAnchoredCategorySeries.prototype.$type, sender)).raisePropertyChanged($.ig.HorizontalAnchoredCategorySeries.prototype.xAxisPropertyName, e.oldValue(), e.newValue());
}));
$.ig.HorizontalAnchoredCategorySeries.prototype.yAxisPropertyName = "YAxis";
$.ig.HorizontalAnchoredCategorySeries.prototype.yAxisProperty = $.ig.DependencyProperty.prototype.register($.ig.HorizontalAnchoredCategorySeries.prototype.yAxisPropertyName, $.ig.NumericYAxis.prototype.$type, $.ig.HorizontalAnchoredCategorySeries.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
		($.ig.util.cast($.ig.HorizontalAnchoredCategorySeries.prototype.$type, sender)).raisePropertyChanged($.ig.HorizontalAnchoredCategorySeries.prototype.yAxisPropertyName, e.oldValue(), e.newValue());
}));





$.ig.AreaSeries.prototype._unknownValuePlottingPropertyName = "UnknownValuePlotting";
$.ig.AreaSeries.prototype.unknownValuePlottingProperty = $.ig.DependencyProperty.prototype.register($.ig.AreaSeries.prototype._unknownValuePlottingPropertyName, $.ig.UnknownValuePlotting.prototype.$type, $.ig.AreaSeries.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.UnknownValuePlotting.prototype.getBox($.ig.UnknownValuePlotting.prototype.dontPlot), function (sender, e) {
	($.ig.util.cast($.ig.AreaSeries.prototype.$type, sender)).raisePropertyChanged($.ig.AreaSeries.prototype._unknownValuePlottingPropertyName, e.oldValue(), e.newValue());
}));


$.ig.CategoryFrame.prototype._categoryFrameVersion = 0;


$.ig.ColumnSeries.prototype.radiusXPropertyName = "RadiusX";
$.ig.ColumnSeries.prototype.radiusXProperty = $.ig.DependencyProperty.prototype.register($.ig.ColumnSeries.prototype.radiusXPropertyName, Number, $.ig.ColumnSeries.prototype.$type, new $.ig.PropertyMetadata(2, 2, function (sender, e) {
	($.ig.util.cast($.ig.ColumnSeries.prototype.$type, sender)).raisePropertyChanged($.ig.ColumnSeries.prototype.radiusXPropertyName, e.oldValue(), e.newValue());
}));
$.ig.ColumnSeries.prototype.radiusYPropertyName = "RadiusY";
$.ig.ColumnSeries.prototype.radiusYProperty = $.ig.DependencyProperty.prototype.register($.ig.ColumnSeries.prototype.radiusYPropertyName, Number, $.ig.ColumnSeries.prototype.$type, new $.ig.PropertyMetadata(2, 2, function (sender, e) {
	($.ig.util.cast($.ig.ColumnSeries.prototype.$type, sender)).raisePropertyChanged($.ig.ColumnSeries.prototype.radiusYPropertyName, e.oldValue(), e.newValue());
}));


$.ig.LineSeries.prototype._unknownValuePlottingPropertyName = "UnknownValuePlotting";
$.ig.LineSeries.prototype.unknownValuePlottingProperty = $.ig.DependencyProperty.prototype.register($.ig.LineSeries.prototype._unknownValuePlottingPropertyName, $.ig.UnknownValuePlotting.prototype.$type, $.ig.LineSeries.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.UnknownValuePlotting.prototype.getBox($.ig.UnknownValuePlotting.prototype.dontPlot), function (sender, e) {
	($.ig.util.cast($.ig.LineSeries.prototype.$type, sender)).raisePropertyChanged($.ig.LineSeries.prototype._unknownValuePlottingPropertyName, e.oldValue(), e.newValue());
}));


$.ig.SplineSeriesBase.prototype._splineTypePropertyName = "SplineType";
$.ig.SplineSeriesBase.prototype.splineTypeProperty = $.ig.DependencyProperty.prototype.register($.ig.SplineSeriesBase.prototype._splineTypePropertyName, $.ig.SplineType.prototype.$type, $.ig.SplineSeriesBase.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.SplineType.prototype.getBox($.ig.SplineType.prototype.natural), function (sender, e) {
	($.ig.util.cast($.ig.SplineSeriesBase.prototype.$type, sender)).raisePropertyChanged($.ig.SplineSeriesBase.prototype._splineTypePropertyName, e.oldValue(), e.newValue());
}));


$.ig.WaterfallSeries.prototype.negativeBrushPropertyName = "NegativeBrush";
$.ig.WaterfallSeries.prototype.negativeBrushProperty = $.ig.DependencyProperty.prototype.register($.ig.WaterfallSeries.prototype.negativeBrushPropertyName, $.ig.Brush.prototype.$type, $.ig.WaterfallSeries.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.WaterfallSeries.prototype.$type, sender)).raisePropertyChanged($.ig.WaterfallSeries.prototype.negativeBrushPropertyName, e.oldValue(), e.newValue());
}));
$.ig.WaterfallSeries.prototype.radiusXPropertyName = "RadiusX";
$.ig.WaterfallSeries.prototype.radiusXProperty = $.ig.DependencyProperty.prototype.register($.ig.WaterfallSeries.prototype.radiusXPropertyName, Number, $.ig.WaterfallSeries.prototype.$type, new $.ig.PropertyMetadata(2, 2, function (sender, e) {
	($.ig.util.cast($.ig.WaterfallSeries.prototype.$type, sender)).raisePropertyChanged($.ig.WaterfallSeries.prototype.radiusXPropertyName, e.oldValue(), e.newValue());
}));
$.ig.WaterfallSeries.prototype.radiusYPropertyName = "RadiusY";
$.ig.WaterfallSeries.prototype.radiusYProperty = $.ig.DependencyProperty.prototype.register($.ig.WaterfallSeries.prototype.radiusYPropertyName, Number, $.ig.WaterfallSeries.prototype.$type, new $.ig.PropertyMetadata(2, 2, function (sender, e) {
	($.ig.util.cast($.ig.WaterfallSeries.prototype.$type, sender)).raisePropertyChanged($.ig.WaterfallSeries.prototype.radiusYPropertyName, e.oldValue(), e.newValue());
}));




































































$.ig.ColumnFragment.prototype.radiusXPropertyName = "RadiusX";
$.ig.ColumnFragment.prototype.radiusXProperty = $.ig.DependencyProperty.prototype.register($.ig.ColumnFragment.prototype.radiusXPropertyName, Number, $.ig.ColumnFragment.prototype.$type, new $.ig.PropertyMetadata(2, 2, function (sender, e) {
	($.ig.util.cast($.ig.ColumnFragment.prototype.$type, sender)).raisePropertyChanged($.ig.ColumnFragment.prototype.radiusXPropertyName, e.oldValue(), e.newValue());
}));
$.ig.ColumnFragment.prototype.radiusYPropertyName = "RadiusY";
$.ig.ColumnFragment.prototype.radiusYProperty = $.ig.DependencyProperty.prototype.register($.ig.ColumnFragment.prototype.radiusYPropertyName, Number, $.ig.ColumnFragment.prototype.$type, new $.ig.PropertyMetadata(2, 2, function (sender, e) {
	($.ig.util.cast($.ig.ColumnFragment.prototype.$type, sender)).raisePropertyChanged($.ig.ColumnFragment.prototype.radiusYPropertyName, e.oldValue(), e.newValue());
}));


$.ig.StackedSeriesBase.prototype.autoGenerateSeriesPropertyName = "AutoGenerateSeries";
$.ig.StackedSeriesBase.prototype.autoGenerateSeriesProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedSeriesBase.prototype.autoGenerateSeriesPropertyName, $.ig.Boolean.prototype.$type, $.ig.StackedSeriesBase.prototype.$type, new $.ig.PropertyMetadata(2, false, function (o, e) {
	($.ig.util.cast($.ig.StackedSeriesBase.prototype.$type, o)).raisePropertyChanged($.ig.StackedSeriesBase.prototype.autoGenerateSeriesPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedSeriesBase.prototype.reverseLegendOrderPropertyName = "ReverseLegendOrder";
$.ig.StackedSeriesBase.prototype.reverseLegendOrderProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedSeriesBase.prototype.reverseLegendOrderPropertyName, $.ig.Boolean.prototype.$type, $.ig.StackedSeriesBase.prototype.$type, new $.ig.PropertyMetadata(2, false, function (sender, e) {
	($.ig.util.cast($.ig.StackedSeriesBase.prototype.$type, sender)).raisePropertyChanged($.ig.StackedSeriesBase.prototype.reverseLegendOrderPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedSeriesBase.prototype.seriesVisibilityPropertyName = "SeriesVisibility";
$.ig.StackedSeriesBase.prototype.seriesVisibilityProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedSeriesBase.prototype.seriesVisibilityPropertyName, $.ig.Visibility.prototype.$type, $.ig.StackedSeriesBase.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.Visibility.prototype.getBox($.ig.Visibility.prototype.visible), function (o, e) {
	($.ig.util.cast($.ig.StackedSeriesBase.prototype.$type, o)).raisePropertyChanged($.ig.StackedSeriesBase.prototype.seriesVisibilityPropertyName, e.oldValue(), e.newValue());
}));


$.ig.HorizontalStackedSeriesBase.prototype.xAxisPropertyName = "XAxis";
$.ig.HorizontalStackedSeriesBase.prototype.xAxisProperty = $.ig.DependencyProperty.prototype.register($.ig.HorizontalStackedSeriesBase.prototype.xAxisPropertyName, $.ig.CategoryAxisBase.prototype.$type, $.ig.HorizontalStackedSeriesBase.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
		($.ig.util.cast($.ig.HorizontalStackedSeriesBase.prototype.$type, sender)).raisePropertyChanged($.ig.HorizontalStackedSeriesBase.prototype.xAxisPropertyName, e.oldValue(), e.newValue());
}));
$.ig.HorizontalStackedSeriesBase.prototype.yAxisPropertyName = "YAxis";
$.ig.HorizontalStackedSeriesBase.prototype.yAxisProperty = $.ig.DependencyProperty.prototype.register($.ig.HorizontalStackedSeriesBase.prototype.yAxisPropertyName, $.ig.NumericYAxis.prototype.$type, $.ig.HorizontalStackedSeriesBase.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
		($.ig.util.cast($.ig.HorizontalStackedSeriesBase.prototype.$type, sender)).raisePropertyChanged($.ig.HorizontalStackedSeriesBase.prototype.yAxisPropertyName, e.oldValue(), e.newValue());
}));


$.ig.VerticalStackedSeriesBase.prototype.xAxisPropertyName = "XAxis";
$.ig.VerticalStackedSeriesBase.prototype.xAxisProperty = $.ig.DependencyProperty.prototype.register($.ig.VerticalStackedSeriesBase.prototype.xAxisPropertyName, $.ig.NumericXAxis.prototype.$type, $.ig.VerticalStackedSeriesBase.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
		($.ig.util.cast($.ig.VerticalStackedSeriesBase.prototype.$type, sender)).raisePropertyChanged($.ig.VerticalStackedSeriesBase.prototype.xAxisPropertyName, e.oldValue(), e.newValue());
}));
$.ig.VerticalStackedSeriesBase.prototype.yAxisPropertyName = "YAxis";
$.ig.VerticalStackedSeriesBase.prototype.yAxisProperty = $.ig.DependencyProperty.prototype.register($.ig.VerticalStackedSeriesBase.prototype.yAxisPropertyName, $.ig.CategoryYAxis.prototype.$type, $.ig.VerticalStackedSeriesBase.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
		($.ig.util.cast($.ig.VerticalStackedSeriesBase.prototype.$type, sender)).raisePropertyChanged($.ig.VerticalStackedSeriesBase.prototype.yAxisPropertyName, e.oldValue(), e.newValue());
}));


$.ig.StackedBarSeries.prototype.radiusXPropertyName = "RadiusX";
$.ig.StackedBarSeries.prototype.radiusXProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedBarSeries.prototype.radiusXPropertyName, Number, $.ig.StackedBarSeries.prototype.$type, new $.ig.PropertyMetadata(2, 2, function (sender, e) {
	($.ig.util.cast($.ig.StackedBarSeries.prototype.$type, sender)).raisePropertyChanged($.ig.StackedBarSeries.prototype.radiusXPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedBarSeries.prototype.radiusYPropertyName = "RadiusY";
$.ig.StackedBarSeries.prototype.radiusYProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedBarSeries.prototype.radiusYPropertyName, Number, $.ig.StackedBarSeries.prototype.$type, new $.ig.PropertyMetadata(2, 2, function (sender, e) {
	($.ig.util.cast($.ig.StackedBarSeries.prototype.$type, sender)).raisePropertyChanged($.ig.StackedBarSeries.prototype.radiusYPropertyName, e.oldValue(), e.newValue());
}));


$.ig.StackedColumnSeries.prototype.radiusXPropertyName = "RadiusX";
$.ig.StackedColumnSeries.prototype.radiusXProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedColumnSeries.prototype.radiusXPropertyName, Number, $.ig.StackedColumnSeries.prototype.$type, new $.ig.PropertyMetadata(2, 2, function (sender, e) {
	($.ig.util.cast($.ig.StackedColumnSeries.prototype.$type, sender)).raisePropertyChanged($.ig.StackedColumnSeries.prototype.radiusXPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedColumnSeries.prototype.radiusYPropertyName = "RadiusY";
$.ig.StackedColumnSeries.prototype.radiusYProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedColumnSeries.prototype.radiusYPropertyName, Number, $.ig.StackedColumnSeries.prototype.$type, new $.ig.PropertyMetadata(2, 2, function (sender, e) {
	($.ig.util.cast($.ig.StackedColumnSeries.prototype.$type, sender)).raisePropertyChanged($.ig.StackedColumnSeries.prototype.radiusYPropertyName, e.oldValue(), e.newValue());
}));


$.ig.StackedFragmentSeries.prototype.brushPropertyName = "Brush";
$.ig.StackedFragmentSeries.prototype.brushProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.brushPropertyName, $.ig.Brush.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(1, function (o, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, o)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.brushPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.actualBrushPropertyName = "ActualBrush";
$.ig.StackedFragmentSeries.prototype.actualBrushProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.actualBrushPropertyName, $.ig.Brush.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(1, function (o, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, o)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.actualBrushPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.dashArrayPropertyName = "DashArray";
$.ig.StackedFragmentSeries.prototype.dashArrayProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.dashArrayPropertyName, $.ig.DoubleCollection.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, sender)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.dashArrayPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.actualDashArrayPropertyName = "ActualDashArray";
$.ig.StackedFragmentSeries.prototype.actualDashArrayProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.actualDashArrayPropertyName, $.ig.DoubleCollection.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(1, function (o, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, o)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.actualDashArrayPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.dashCapPropertyName = "DashCap";
$.ig.StackedFragmentSeries.prototype.dashCapProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.dashCapPropertyName, $.ig.PenLineCap.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.PenLineCap.prototype.getBox($.ig.PenLineCap.prototype.flat), function (sender, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, sender)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.dashCapPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.actualDashCapPropertyName = "ActualDashCap";
$.ig.StackedFragmentSeries.prototype.actualDashCapProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.actualDashCapPropertyName, $.ig.PenLineCap.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.PenLineCap.prototype.getBox($.ig.PenLineCap.prototype.flat), function (o, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, o)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.actualDashCapPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.isDropShadowEnabledPropertyName = "IsDropShadowEnabled";
$.ig.StackedFragmentSeries.prototype.isDropShadowEnabledProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.isDropShadowEnabledPropertyName, $.ig.Boolean.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, sender)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.isDropShadowEnabledPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.actualIsDropShadowEnabledPropertyName = "ActualIsDropShadowEnabled";
$.ig.StackedFragmentSeries.prototype.actualIsDropShadowEnabledProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.actualIsDropShadowEnabledPropertyName, $.ig.Boolean.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, false, function (sender, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, sender)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.actualIsDropShadowEnabledPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.shadowBlurPropertyName = "ShadowBlur";
$.ig.StackedFragmentSeries.prototype.shadowBlurProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.shadowBlurPropertyName, Number, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, NaN, function (sender, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, sender)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.shadowBlurPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.actualShadowBlurPropertyName = "ActualShadowBlur";
$.ig.StackedFragmentSeries.prototype.actualShadowBlurProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.actualShadowBlurPropertyName, Number, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, NaN, function (sender, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, sender)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.actualShadowBlurPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.shadowColorPropertyName = "ShadowColor";
$.ig.StackedFragmentSeries.prototype.shadowColorProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.shadowColorPropertyName, $.ig.Color.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, sender)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.shadowColorPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.actualShadowColorPropertyName = "ActualShadowColor";
$.ig.StackedFragmentSeries.prototype.actualShadowColorProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.actualShadowColorPropertyName, $.ig.Color.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, sender)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.actualShadowColorPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.useSingleShadowPropertyName = "UseSingleShadow";
$.ig.StackedFragmentSeries.prototype.useSingleShadowProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.useSingleShadowPropertyName, $.ig.Boolean.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, sender)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.useSingleShadowPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.actualUseSingleShadowPropertyName = "ActualUseSingleShadow";
$.ig.StackedFragmentSeries.prototype.actualUseSingleShadowProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.actualUseSingleShadowPropertyName, $.ig.Boolean.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, true, function (sender, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, sender)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.actualUseSingleShadowPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.shadowOffsetXPropertyName = "ShadowOffsetX";
$.ig.StackedFragmentSeries.prototype.shadowOffsetXProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.shadowOffsetXPropertyName, Number, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, NaN, function (sender, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, sender)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.shadowOffsetXPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.actualShadowOffsetXPropertyName = "ActualShadowOffsetX";
$.ig.StackedFragmentSeries.prototype.actualShadowOffsetXProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.actualShadowOffsetXPropertyName, Number, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, NaN, function (sender, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, sender)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.actualShadowOffsetXPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.shadowOffsetYPropertyName = "ShadowOffsetY";
$.ig.StackedFragmentSeries.prototype.shadowOffsetYProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.shadowOffsetYPropertyName, Number, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, NaN, function (sender, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, sender)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.shadowOffsetYPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.actualShadowOffsetYPropertyName = "ActualShadowOffsetY";
$.ig.StackedFragmentSeries.prototype.actualShadowOffsetYProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.actualShadowOffsetYPropertyName, Number, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, NaN, function (sender, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, sender)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.actualShadowOffsetYPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.endCapPropertyName = "EndCap";
$.ig.StackedFragmentSeries.prototype.endCapProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.endCapPropertyName, $.ig.PenLineCap.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.PenLineCap.prototype.getBox($.ig.PenLineCap.prototype.round), function (sender, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, sender)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.endCapPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.actualEndCapPropertyName = "ActualEndCap";
$.ig.StackedFragmentSeries.prototype.actualEndCapProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.actualEndCapPropertyName, $.ig.PenLineCap.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.PenLineCap.prototype.getBox($.ig.PenLineCap.prototype.round), function (o, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, o)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.actualEndCapPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.isHitTestVisiblePropertyName = "IsHitTestVisible";
$.ig.StackedFragmentSeries.prototype.isHitTestVisibleProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.isHitTestVisiblePropertyName, $.ig.Boolean.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, true, function (o, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, o)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.isHitTestVisiblePropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.actualIsHitTestVisiblePropertyName = "ActualIsHitTestVisible";
$.ig.StackedFragmentSeries.prototype.actualIsHitTestVisibleProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.actualIsHitTestVisiblePropertyName, $.ig.Boolean.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, true, function (o, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, o)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.actualIsHitTestVisiblePropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.legendItemBadgeTemplatePropertyName = "LegendItemBadgeTemplate";
$.ig.StackedFragmentSeries.prototype.legendItemBadgeTemplateProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.legendItemBadgeTemplatePropertyName, $.ig.DataTemplate.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, sender)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.legendItemBadgeTemplatePropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.actualLegendItemBadgeTemplatePropertyName = "ActualLegendItemBadgeTemplate";
$.ig.StackedFragmentSeries.prototype.actualLegendItemBadgeTemplateProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.actualLegendItemBadgeTemplatePropertyName, $.ig.DataTemplate.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(1, function (o, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, o)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.actualLegendItemBadgeTemplatePropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.legendItemTemplatePropertyName = "LegendItemTemplate";
$.ig.StackedFragmentSeries.prototype.legendItemTemplateProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.legendItemTemplatePropertyName, $.ig.DataTemplate.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, sender)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.legendItemTemplatePropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.actualLegendItemTemplatePropertyName = "ActualLegendItemTemplate";
$.ig.StackedFragmentSeries.prototype.actualLegendItemTemplateProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.actualLegendItemTemplatePropertyName, $.ig.DataTemplate.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(1, function (o, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, o)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.actualLegendItemTemplatePropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.legendItemVisibilityPropertyName = "LegendItemVisibility";
$.ig.StackedFragmentSeries.prototype.legendItemVisibilityProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.legendItemVisibilityPropertyName, $.ig.Visibility.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.Visibility.prototype.getBox($.ig.Visibility.prototype.visible), function (sender, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, sender)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.legendItemVisibilityPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.actualLegendItemVisibilityPropertyName = "ActualLegendItemVisibility";
$.ig.StackedFragmentSeries.prototype.actualLegendItemVisibilityProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.actualLegendItemVisibilityPropertyName, $.ig.Visibility.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.Visibility.prototype.getBox($.ig.Visibility.prototype.visible), function (o, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, o)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.actualLegendItemVisibilityPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.markerBrushPropertyName = "MarkerBrush";
$.ig.StackedFragmentSeries.prototype.markerBrushProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.markerBrushPropertyName, $.ig.Brush.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, sender)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.markerBrushPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.actualMarkerBrushPropertyName = "ActualMarkerBrush";
$.ig.StackedFragmentSeries.prototype.actualMarkerBrushProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.actualMarkerBrushPropertyName, $.ig.Brush.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(1, function (o, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, o)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.actualMarkerBrushPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.markerOutlinePropertyName = "MarkerOutline";
$.ig.StackedFragmentSeries.prototype.markerOutlineProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.markerOutlinePropertyName, $.ig.Brush.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, sender)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.markerOutlinePropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.actualMarkerOutlinePropertyName = "ActualMarkerOutline";
$.ig.StackedFragmentSeries.prototype.actualMarkerOutlineProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.actualMarkerOutlinePropertyName, $.ig.Brush.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(1, function (o, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, o)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.actualMarkerOutlinePropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.markerStylePropertyName = "MarkerStyle";
$.ig.StackedFragmentSeries.prototype.markerStyleProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.markerStylePropertyName, $.ig.Style.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, sender)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.markerStylePropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.actualMarkerStylePropertyName = "ActualMarkerStyle";
$.ig.StackedFragmentSeries.prototype.actualMarkerStyleProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.actualMarkerStylePropertyName, $.ig.Style.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(1, function (o, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, o)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.actualMarkerStylePropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.markerTemplatePropertyName = "MarkerTemplate";
$.ig.StackedFragmentSeries.prototype.markerTemplateProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.markerTemplatePropertyName, $.ig.DataTemplate.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, sender)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.markerTemplatePropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.actualMarkerTemplatePropertyName = "ActualMarkerTemplate";
$.ig.StackedFragmentSeries.prototype.actualMarkerTemplateProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.actualMarkerTemplatePropertyName, $.ig.DataTemplate.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(1, function (o, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, o)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.actualMarkerTemplatePropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.markerTypePropertyName = "MarkerType";
$.ig.StackedFragmentSeries.prototype.markerTypeProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.markerTypePropertyName, $.ig.MarkerType.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.MarkerType.prototype.getBox($.ig.MarkerType.prototype.unset), function (sender, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, sender)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.markerTypePropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.actualMarkerTypePropertyName = "ActualMarkerType";
$.ig.StackedFragmentSeries.prototype.actualMarkerTypeProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.actualMarkerTypePropertyName, $.ig.MarkerType.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.MarkerType.prototype.getBox($.ig.MarkerType.prototype.none), function (o, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, o)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.actualMarkerTypePropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.namePropertyName = "Name";
$.ig.StackedFragmentSeries.prototype.nameProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.namePropertyName, String, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(1, function (o, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, o)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.namePropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.opacityPropertyName = "Opacity";
$.ig.StackedFragmentSeries.prototype.opacityProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.opacityPropertyName, Number, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, 1, function (o, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, o)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.opacityPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.actualOpacityPropertyName = "ActualOpacity";
$.ig.StackedFragmentSeries.prototype.actualOpacityProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.actualOpacityPropertyName, Number, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, 1, function (o, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, o)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.actualOpacityPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.opacityMaskPropertyName = "OpacityMask";
$.ig.StackedFragmentSeries.prototype.opacityMaskProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.opacityMaskPropertyName, $.ig.Brush.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(1, function (o, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, o)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.opacityMaskPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.actualOpacityMaskPropertyName = "ActualOpacityMask";
$.ig.StackedFragmentSeries.prototype.actualOpacityMaskProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.actualOpacityMaskPropertyName, $.ig.Brush.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(1, function (o, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, o)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.actualOpacityMaskPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.outlinePropertyName = "Outline";
$.ig.StackedFragmentSeries.prototype.outlineProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.outlinePropertyName, $.ig.Brush.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, sender)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.outlinePropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.actualOutlinePropertyName = "ActualOutline";
$.ig.StackedFragmentSeries.prototype.actualOutlineProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.actualOutlinePropertyName, $.ig.Brush.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(1, function (o, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, o)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.actualOutlinePropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.areaFillOpacityPropertyName = "AreaFillOpacity";
$.ig.StackedFragmentSeries.prototype.areaFillOpacityProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.areaFillOpacityPropertyName, Number, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, NaN, function (o, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, o)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.areaFillOpacityPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.actualAreaFillOpacityPropertyName = "ActualAreaFillOpacity";
$.ig.StackedFragmentSeries.prototype.actualAreaFillOpacityProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.actualAreaFillOpacityPropertyName, Number, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, 1, function (o, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, o)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.actualAreaFillOpacityPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.radiusXPropertyName = "RadiusX";
$.ig.StackedFragmentSeries.prototype.radiusXProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.radiusXPropertyName, Number, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, 2, function (sender, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, sender)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.radiusXPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.actualRadiusXPropertyName = "ActualRadiusX";
$.ig.StackedFragmentSeries.prototype.actualRadiusXProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.actualRadiusXPropertyName, Number, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, 0, function (o, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, o)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.actualRadiusXPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.radiusYPropertyName = "RadiusY";
$.ig.StackedFragmentSeries.prototype.radiusYProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.radiusYPropertyName, Number, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, 2, function (sender, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, sender)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.radiusYPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.actualRadiusYPropertyName = "ActualRadiusY";
$.ig.StackedFragmentSeries.prototype.actualRadiusYProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.actualRadiusYPropertyName, Number, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, 0, function (o, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, o)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.actualRadiusYPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.startCapPropertyName = "StartCap";
$.ig.StackedFragmentSeries.prototype.startCapProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.startCapPropertyName, $.ig.PenLineCap.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.PenLineCap.prototype.getBox($.ig.PenLineCap.prototype.round), function (sender, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, sender)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.startCapPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.actualStartCapPropertyName = "ActualStartCap";
$.ig.StackedFragmentSeries.prototype.actualStartCapProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.actualStartCapPropertyName, $.ig.PenLineCap.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.PenLineCap.prototype.getBox($.ig.PenLineCap.prototype.round), function (o, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, o)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.actualStartCapPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.thicknessPropertyName = "Thickness";
$.ig.StackedFragmentSeries.prototype.thicknessProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.thicknessPropertyName, Number, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, 1.5, function (sender, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, sender)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.thicknessPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.actualThicknessPropertyName = "ActualThickness";
$.ig.StackedFragmentSeries.prototype.actualThicknessProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.actualThicknessPropertyName, Number, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, 1, function (o, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, o)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.actualThicknessPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.titlePropertyName = "Title";
$.ig.StackedFragmentSeries.prototype.titleProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.titlePropertyName, $.ig.Object.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, "Series Title", function (sender, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, sender)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.titlePropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.toolTipPropertyName = "ToolTip";
$.ig.StackedFragmentSeries.prototype.toolTipProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.toolTipPropertyName, $.ig.Object.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, sender)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.toolTipPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.actualToolTipPropertyName = "ActualToolTip";
$.ig.StackedFragmentSeries.prototype.actualToolTipProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.actualToolTipPropertyName, $.ig.Object.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(1, function (o, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, o)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.actualToolTipPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.useLightweightMarkersPropertyName = "UseLightweightMarkers";
$.ig.StackedFragmentSeries.prototype.useLightweightMarkersProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.useLightweightMarkersPropertyName, $.ig.Boolean.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, false, function (sender, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, sender)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.useLightweightMarkersPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.actualUseLightweightMarkersPropertyName = "ActualUseLightweightMarkers";
$.ig.StackedFragmentSeries.prototype.actualUseLightweightMarkersProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.actualUseLightweightMarkersPropertyName, $.ig.Boolean.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, false, function (o, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, o)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.actualUseLightweightMarkersPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.valueMemberPathPropertyName = "ValueMemberPath";
$.ig.StackedFragmentSeries.prototype.valueMemberPathProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.valueMemberPathPropertyName, String, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
		($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, sender)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.valueMemberPathPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.visibilityPropertyName = "Visibility";
$.ig.StackedFragmentSeries.prototype.visibilityProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.visibilityPropertyName, $.ig.Visibility.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.Visibility.prototype.getBox($.ig.Visibility.prototype.visible), function (o, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, o)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.visibilityPropertyName, e.oldValue(), e.newValue());
}));
$.ig.StackedFragmentSeries.prototype.actualVisibilityPropertyName = "ActualVisibility";
$.ig.StackedFragmentSeries.prototype.actualVisibilityProperty = $.ig.DependencyProperty.prototype.register($.ig.StackedFragmentSeries.prototype.actualVisibilityPropertyName, $.ig.Visibility.prototype.$type, $.ig.StackedFragmentSeries.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.Visibility.prototype.getBox($.ig.Visibility.prototype.visible), function (o, e) {
	($.ig.util.cast($.ig.StackedFragmentSeries.prototype.$type, o)).raisePropertyChanged($.ig.StackedFragmentSeries.prototype.actualVisibilityPropertyName, e.oldValue(), e.newValue());
}));


} (jQuery));



/*!@license
* Infragistics.Web.ClientUI infragistics.chart_financialchart.js 14.2.20142.1018
*
* Copyright (c) 2011-2014 Infragistics Inc.
*
* http://www.infragistics.com/
*
* Depends:
*     jquery-1.4.4.js
*     jquery.ui.core.js
*     jquery.ui.widget.js
*     infragistics.util.js
*/

// Declare empty types
$.ig = $.ig || {};
(function ($) {
var $$t = {}
$.ig.$currDefinitions = $$t;
$.ig.util.bulkDefine(["Object:b", 
"Type:c", 
"Boolean:d", 
"ValueType:e", 
"Void:f", 
"IConvertible:g", 
"IFormatProvider:h", 
"Number:i", 
"String:j", 
"IComparable:k", 
"Number:l", 
"Number:m", 
"Number:n", 
"Number:o", 
"NumberStyles:p", 
"Enum:q", 
"Array:r", 
"IList:s", 
"ICollection:t", 
"IEnumerable:u", 
"IEnumerator:v", 
"Number:w", 
"String:x", 
"StringComparison:y", 
"RegExp:z", 
"CultureInfo:aa", 
"Calendar:ab", 
"Date:ac", 
"DayOfWeek:ad", 
"DateTimeKind:ae", 
"Date:af", 
"Error:ag", 
"CompareInfo:ah", 
"CompareOptions:ai", 
"NumberFormatInfo:aj", 
"DateTimeFormatInfo:ak", 
"CalendarWeekRule:al", 
"IEnumerable$1:am", 
"IEnumerator$1:an", 
"IDisposable:ao", 
"StringSplitOptions:ap", 
"Number:aq", 
"Number:ar", 
"Number:as", 
"Number:at", 
"Number:au", 
"Number:av", 
"Assembly:aw", 
"Stream:ax", 
"SeekOrigin:ay", 
"RuntimeTypeHandle:az", 
"MethodInfo:a0", 
"MethodBase:a1", 
"MemberInfo:a2", 
"ParameterInfo:a3", 
"TypeCode:a4", 
"ConstructorInfo:a5", 
"PropertyInfo:a6", 
"Point:a9", 
"Rect:ba", 
"Size:bb", 
"Nullable$1:bc", 
"Math:bd", 
"Color:be", 
"ArgumentException:bf", 
"NotImplementedException:bg", 
"Script:bh", 
"ArgumentNullException:bi", 
"Convert:bl", 
"Environment:bm", 
"IComparable$1:bp", 
"IEquatable$1:bq", 
"InvalidOperationException:by", 
"Predicate$1:bz", 
"MulticastDelegate:b0", 
"IntPtr:b1", 
"IComparer:b3", 
"IEqualityComparer:b4", 
"IComparer$1:b5", 
"IEqualityComparer$1:b6", 
"Random:b7", 
"Tuple$2:b8", 
"List$1:ct", 
"IList$1:cu", 
"ICollection$1:cv", 
"IArray:cw", 
"Enumerable:cx", 
"Func$2:cy", 
"Func$3:cz", 
"IOrderedEnumerable$1:c0", 
"SortedList$1:c1", 
"IArrayList:c2", 
"Array:c3", 
"CompareCallback:c4", 
"Action$1:c5", 
"Comparer$1:c6", 
"DefaultComparer$1:c7", 
"Comparison$1:c8", 
"ReadOnlyCollection$1:c9", 
"UIElement:db", 
"DependencyObject:dc", 
"Dictionary:dd", 
"DependencyProperty:de", 
"PropertyMetadata:df", 
"PropertyChangedCallback:dg", 
"DependencyPropertyChangedEventArgs:dh", 
"UnsetValue:di", 
"DependencyPropertiesCollection:dj", 
"Binding:dk", 
"PropertyPath:dl", 
"Transform:dm", 
"UIElementCollection:dn", 
"ObservableCollection$1:dp", 
"INotifyCollectionChanged:dq", 
"NotifyCollectionChangedEventHandler:dr", 
"NotifyCollectionChangedEventArgs:ds", 
"EventArgs:dt", 
"NotifyCollectionChangedAction:du", 
"INotifyPropertyChanged:dv", 
"PropertyChangedEventHandler:dw", 
"PropertyChangedEventArgs:dx", 
"Delegate:dy", 
"Interlocked:dz", 
"FrameworkElement:d0", 
"Visibility:d1", 
"Style:d2", 
"Control:d3", 
"Thickness:d4", 
"HorizontalAlignment:d5", 
"VerticalAlignment:d6", 
"ContentControl:d7", 
"DataTemplate:d8", 
"DataTemplateRenderHandler:d9", 
"DataTemplateRenderInfo:ea", 
"DataTemplatePassInfo:eb", 
"DataTemplateMeasureHandler:ec", 
"DataTemplateMeasureInfo:ed", 
"DataTemplatePassHandler:ee", 
"PointCollection:eg", 
"Line:em", 
"Shape:en", 
"Brush:eo", 
"DoubleCollection:ep", 
"Path:eq", 
"Geometry:er", 
"GeometryType:es", 
"Polygon:et", 
"Polyline:eu", 
"Rectangle:ev", 
"LinearGradientBrush:ew", 
"GradientStop:ex", 
"FillRule:ey", 
"GeometryCollection:ez", 
"GeometryGroup:e0", 
"LineGeometry:e1", 
"RectangleGeometry:e2", 
"EllipseGeometry:e3", 
"PathGeometry:e4", 
"PathFigureCollection:e5", 
"PathFigure:e6", 
"PathSegmentCollection:e7", 
"PathSegmentType:e8", 
"PathSegment:e9", 
"LineSegment:fa", 
"BezierSegment:fb", 
"PolyBezierSegment:fc", 
"PolyLineSegment:fd", 
"ArcSegment:fe", 
"SweepDirection:ff", 
"PenLineCap:fg", 
"RotateTransform:fi", 
"TranslateTransform:fj", 
"ScaleTransform:fk", 
"TransformGroup:fl", 
"TransformCollection:fm", 
"Key:fn", 
"ModifierKeys:fo", 
"MouseEventArgs:fp", 
"MouseButtonEventArgs:fq", 
"Canvas:fr", 
"Panel:fs", 
"TextBlock:fu", 
"JQueryPromise:fy", 
"Action:fz", 
"JQueryDeferred:f2", 
"JQuery:f3", 
"JQueryObject:f4", 
"Element:f5", 
"ElementAttributeCollection:f6", 
"ElementCollection:f7", 
"WebStyle:f8", 
"ElementNodeType:f9", 
"Document:ga", 
"EventListener:gb", 
"IElementEventHandler:gc", 
"ElementEventHandler:gd", 
"ElementAttribute:ge", 
"JQueryPosition:gf", 
"JQueryCallback:gg", 
"JQueryEvent:gh", 
"JQueryUICallback:gi", 
"StringBuilder:gk", 
"Dictionary$2:hc", 
"IDictionary$2:hd", 
"IDictionary:he", 
"EqualityComparer$1:hf", 
"DefaultEqualityComparer$1:hg", 
"KeyValuePair$2:hi", 
"Debug:hs", 
"AbstractEnumerable:h6", 
"Func$1:h7", 
"AbstractEnumerator:h8", 
"GenericEnumerable$1:ia", 
"GenericEnumerator$1:ib", 
"LinkedList$1:id", 
"LinkedListNode$1:ie", 
"Stack$1:ii", 
"ReverseArrayEnumerator$1:ij"]);













































































































































































































$.ig.util.defType('Stack$1', 'Object', {
	$t: null, 
	init: function ($t) {
		this.$t = $t;
		this.$type = this.$type.specialize(this.$t);

		this.__inner = new $.ig.Array();

		$.ig.Object.prototype.init.call(this);

	}, 
	__inner: null

	, 
	push: function (item) {
		this.__inner.add($.ig.util.getBoxIfEnum(this.$t, item));
	}

	, 
	peek: function () {
		if (this.__inner.length < 1) {
			return $.ig.util.getDefaultValue(this.$t);
		}

		return $.ig.util.getValueIfEnum(this.$t, this.__inner[this.__inner.length - 1]);
	}

	, 
	pop: function () {
		var ret = this.__inner[this.__inner.length - 1];
		this.__inner.removeAt(this.__inner.length - 1);
		return $.ig.util.getValueIfEnum(this.$t, ret);
	}

	, 
	count: function () {

			return this.__inner.length;
	}

	, 
	clear: function () {
		this.__inner.clear();
	}

	, 
	contains: function (item) {
		return this.__inner.contains($.ig.util.getBoxIfEnum(this.$t, item));
	}

	, 
	getEnumerator: function () {
		return new $.ig.ReverseArrayEnumerator$1(this.$t, this.__inner);
	}

	, 
	getEnumerator: function () {
		return new $.ig.ReverseArrayEnumerator$1(this.$t, this.__inner);
	}
	, 
	$type: new $.ig.Type('Stack$1', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(0)])
}, true);

$.ig.util.defType('ReverseArrayEnumerator$1', 'Object', {
	$t: null, 
	__index: 0
	, 
	__array: null
	, 
	init: function ($t, array) {

		this.$t = $t;
		this.$type = this.$type.specialize(this.$t);


		$.ig.Object.prototype.init.call(this);
			this.__array = array;
			this.__index = array.length;
	}

	, 
	current: function () {

			return $.ig.util.getValueIfEnum(this.$t, this.__array[this.__index]);
	}

	, 
	current: function () {

			return this.__array[this.__index];
	}

	, 
	moveNext: function () {
		this.__index--;
		return this.__index >= 0;
	}

	, 
	reset: function () {
		this.__index = this.__array.length;
	}

	, 
	dispose: function () {
		throw new $.ig.NotImplementedException(0);
	}
	, 
	$type: new $.ig.Type('ReverseArrayEnumerator$1', $.ig.Object.prototype.$type, [$.ig.IEnumerator$1.prototype.$type.specialize(0)])
}, true);
















































} (jQuery));



// Declare empty types
$.ig = $.ig || {};
(function ($) {
var $$t = {}
$.ig.$currDefinitions = $$t;
$.ig.util.bulkDefine(["BrushCollection:a", 
"ObservableCollection$1:b", 
"List$1:c", 
"Object:d", 
"Type:e", 
"Boolean:f", 
"ValueType:g", 
"Void:h", 
"IConvertible:i", 
"IFormatProvider:j", 
"Number:k", 
"String:l", 
"IComparable:m", 
"Number:n", 
"Number:o", 
"Number:p", 
"Number:q", 
"NumberStyles:r", 
"Enum:s", 
"Array:t", 
"IList:u", 
"ICollection:v", 
"IEnumerable:w", 
"IEnumerator:x", 
"Number:y", 
"String:z", 
"StringComparison:aa", 
"RegExp:ab", 
"CultureInfo:ac", 
"Calendar:ad", 
"Date:ae", 
"DayOfWeek:af", 
"DateTimeKind:ag", 
"Date:ah", 
"Error:ai", 
"CompareInfo:aj", 
"CompareOptions:ak", 
"NumberFormatInfo:al", 
"DateTimeFormatInfo:am", 
"CalendarWeekRule:an", 
"IEnumerable$1:ao", 
"IEnumerator$1:ap", 
"IDisposable:aq", 
"StringSplitOptions:ar", 
"Number:as", 
"Number:at", 
"Number:au", 
"Number:av", 
"Number:aw", 
"Number:ax", 
"Assembly:ay", 
"Stream:az", 
"SeekOrigin:a0", 
"RuntimeTypeHandle:a1", 
"MethodInfo:a2", 
"MethodBase:a3", 
"MemberInfo:a4", 
"ParameterInfo:a5", 
"TypeCode:a6", 
"ConstructorInfo:a7", 
"PropertyInfo:a8", 
"IList$1:a9", 
"ICollection$1:ba", 
"IArray:bb", 
"Script:bc", 
"Enumerable:bd", 
"Func$2:be", 
"MulticastDelegate:bf", 
"IntPtr:bg", 
"Func$3:bh", 
"IOrderedEnumerable$1:bi", 
"SortedList$1:bj", 
"Math:bk", 
"ArgumentNullException:bl", 
"NotImplementedException:bm", 
"IArrayList:bn", 
"Array:bo", 
"CompareCallback:bp", 
"Action$1:bq", 
"Comparer$1:br", 
"IComparer:bs", 
"IComparer$1:bt", 
"DefaultComparer$1:bu", 
"IComparable$1:bv", 
"Comparison$1:bw", 
"ReadOnlyCollection$1:bx", 
"Predicate$1:by", 
"INotifyCollectionChanged:bz", 
"NotifyCollectionChangedEventHandler:b0", 
"NotifyCollectionChangedEventArgs:b1", 
"EventArgs:b2", 
"NotifyCollectionChangedAction:b3", 
"INotifyPropertyChanged:b4", 
"PropertyChangedEventHandler:b5", 
"PropertyChangedEventArgs:b6", 
"Delegate:b7", 
"Interlocked:b8", 
"InterpolationMode:b9", 
"Brush:ca", 
"Color:cb", 
"ArgumentException:cc", 
"Nullable$1:cd", 
"Random:ce", 
"MathUtil:cf", 
"RuntimeHelpers:cg", 
"RuntimeFieldHandle:ch", 
"ColorUtil:ci", 
"ErrorBarCalculatorReference:cj", 
"ErrorBarCalculatorType:ck", 
"IErrorBarCalculator:cl", 
"IFastItemColumn$1:cm", 
"IFastItemColumnPropertyName:cn", 
"EventHandler$1:co", 
"FastItemColumn:cq", 
"IFastItemColumnInternal:cr", 
"IFastItemsSource:cs", 
"FastReflectionHelper:ct", 
"FastItemDateTimeColumn:cu", 
"FastItemObjectColumn:cv", 
"FastItemIntColumn:cw", 
"FastItemsSource:cx", 
"Dictionary$2:cy", 
"IDictionary$2:cz", 
"IDictionary:c0", 
"IEqualityComparer$1:c1", 
"EqualityComparer$1:c2", 
"IEqualityComparer:c3", 
"DefaultEqualityComparer$1:c4", 
"InvalidOperationException:c5", 
"KeyValuePair$2:c6", 
"FastItemsSourceEventAction:c7", 
"FastItemsSourceEventArgs:c8", 
"ColumnReference:c9", 
"FastItemsSourceReference:da", 
"IFastItemsSourceProvider:db", 
"IRenderer:dc", 
"Rectangle:dd", 
"Shape:de", 
"FrameworkElement:df", 
"UIElement:dg", 
"DependencyObject:dh", 
"Dictionary:di", 
"DependencyProperty:dj", 
"PropertyMetadata:dk", 
"PropertyChangedCallback:dl", 
"DependencyPropertyChangedEventArgs:dm", 
"UnsetValue:dn", 
"DependencyPropertiesCollection:dp", 
"Binding:dq", 
"PropertyPath:dr", 
"Transform:ds", 
"Visibility:dt", 
"Style:du", 
"DoubleCollection:dv", 
"Rect:dw", 
"Size:dx", 
"Point:dy", 
"Path:dz", 
"Geometry:d0", 
"GeometryType:d1", 
"TextBlock:d2", 
"Polygon:d3", 
"PointCollection:d4", 
"Polyline:d5", 
"DataTemplateRenderInfo:d6", 
"DataTemplatePassInfo:d7", 
"ContentControl:d8", 
"Control:d9", 
"Thickness:ea", 
"HorizontalAlignment:eb", 
"VerticalAlignment:ec", 
"DataTemplate:ed", 
"DataTemplateRenderHandler:ee", 
"DataTemplateMeasureHandler:ef", 
"DataTemplateMeasureInfo:eg", 
"DataTemplatePassHandler:eh", 
"Line:ei", 
"RectChangedEventArgs:ej", 
"RectChangedEventHandler:ek", 
"RenderingContext:em", 
"ArrayUtil:en", 
"BrushUtil:eo", 
"LinearGradientBrush:ep", 
"GradientStop:eq", 
"JQueryObject:er", 
"Element:es", 
"ElementAttributeCollection:et", 
"ElementCollection:eu", 
"WebStyle:ev", 
"ElementNodeType:ew", 
"Document:ex", 
"EventListener:ey", 
"IElementEventHandler:ez", 
"ElementEventHandler:e0", 
"ElementAttribute:e1", 
"JQueryPosition:e2", 
"JQueryCallback:e3", 
"JQueryEvent:e4", 
"JQueryUICallback:e5", 
"CssHelper:e6", 
"JQuery:e7", 
"JQueryDeferred:e8", 
"JQueryPromise:e9", 
"Action:fa", 
"CssGradientUtil:fb", 
"GeometryUtil:fc", 
"Tuple$2:fd", 
"Clipper:fe", 
"EdgeClipper:ff", 
"LeftClipper:fg", 
"BottomClipper:fh", 
"RightClipper:fi", 
"TopClipper:fj", 
"EasingFunctions:fk", 
"FontUtil:fl", 
"FontInfo:fm", 
"DoubleAnimator:fn", 
"EasingFunctionHandler:fo", 
"Callback:fp", 
"Extensions:fq", 
"PathGeometry:fr", 
"PathFigureCollection:fs", 
"PathFigure:ft", 
"PathSegmentCollection:fu", 
"GeometryGroup:fv", 
"GeometryCollection:fw", 
"FillRule:fx", 
"Panel:fy", 
"UIElementCollection:fz", 
"Flattener:f0", 
"Stack$1:f1", 
"ReverseArrayEnumerator$1:f2", 
"SpiralTodo:f3", 
"Func$1:f5", 
"PathFigureUtil:f7", 
"PathSegment:f8", 
"PathSegmentType:f9", 
"ArcSegment:ga", 
"SweepDirection:gb", 
"LineSegment:gc", 
"PolyLineSegment:gd", 
"Pool$1:gg", 
"IIndexedPool$1:gh", 
"IPool$1:gi", 
"IHashPool$2:gj", 
"HashPool$2:gk", 
"RectUtil:gm", 
"SmartPlaceableWrapper$1:gn", 
"ISmartPlaceable:go", 
"SmartPosition:gp", 
"SmartPlacer:gq", 
"IVisualData:gs", 
"PrimitiveVisualDataList:gt", 
"PrimitiveVisualData:gu", 
"PrimitiveAppearanceData:gv", 
"BrushAppearanceData:gw", 
"StringBuilder:gx", 
"Environment:gy", 
"AppearanceHelper:gz", 
"LinearGradientBrushAppearanceData:g0", 
"GradientStopAppearanceData:g1", 
"SolidBrushAppearanceData:g2", 
"LineGeometry:g3", 
"RectangleGeometry:g4", 
"EllipseGeometry:g5", 
"EllipseGeometryData:g6", 
"GeometryData:g7", 
"GetPointsSettings:g8", 
"RectangleGeometryData:g9", 
"LineGeometryData:ha", 
"PathGeometryData:hb", 
"PathFigureData:hc", 
"LineSegmentData:hd", 
"SegmentData:he", 
"PolylineSegmentData:hf", 
"ArcSegmentData:hg", 
"PolyBezierSegment:hh", 
"PolyBezierSegmentData:hi", 
"LabelAppearanceData:hj", 
"RotateTransform:hk", 
"TransformGroup:hl", 
"TransformCollection:hm", 
"ShapeTags:hn", 
"RectangleVisualData:hq", 
"PolyLineVisualData:hs", 
"PolygonVisualData:ht", 
"PathVisualData:hu", 
"DOMEventProxy:hv", 
"EventProxy:hw", 
"ModifierKeys:hx", 
"MouseWheelHandler:hy", 
"GestureHandler:hz", 
"ContactHandler:h0", 
"TouchHandler:h1", 
"MouseOverHandler:h2", 
"MouseHandler:h3", 
"KeyHandler:h4", 
"Key:h5", 
"MSGesture:h6", 
"window:h7", 
"MouseEventArgs:h8", 
"CanvasRenderScheduler:h9", 
"ISchedulableRender:ia", 
"CanvasViewRenderer:ib", 
"CanvasContext2D:ic", 
"CanvasContext:id", 
"TextMetrics:ie", 
"ImageData:ig", 
"CanvasElement:ih", 
"Gradient:ii", 
"BezierSegment:ij", 
"TranslateTransform:ik", 
"ScaleTransform:il", 
"InteractionState:io", 
"IOverviewPlusDetailControl:ip", 
"OverviewPlusDetailPaneMode:ir", 
"PropertyChangedEventArgs$1:is", 
"XamOverviewPlusDetailPane:it", 
"XamOverviewPlusDetailPaneView:iu", 
"XamOverviewPlusDetailPaneViewManager:iv", 
"DivElement:iw", 
"ImageElement:ix", 
"Convert:jb", 
"Debug:jc", 
"TrendCalculators:jg", 
"TrendLineType:jh", 
"UnknownValuePlotting:ji", 
"LeastSquaresFit:jj", 
"Numeric:jk", 
"AbstractEnumerable:jl", 
"AbstractEnumerator:jm", 
"GenericEnumerable$1:jn", 
"GenericEnumerator$1:jo"]);


$.ig.util.defType('TrendLineType', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "None";
			case 1: return "LinearFit";
			case 2: return "QuadraticFit";
			case 3: return "CubicFit";
			case 4: return "QuarticFit";
			case 5: return "QuinticFit";
			case 6: return "LogarithmicFit";
			case 7: return "ExponentialFit";
			case 8: return "PowerLawFit";
			case 9: return "SimpleAverage";
			case 10: return "ExponentialAverage";
			case 11: return "ModifiedAverage";
			case 12: return "CumulativeAverage";
			case 13: return "WeightedAverage";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('TrendLineType', $.ig.Enum.prototype.$type)
}, true);






























$.ig.util.defType('ArrayUtil', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	shuffle$1: function ($t, list) {
		if (list != null) {
			var random = new $.ig.Random(0);
			for (var n = list.count() - 1; n > 0; --n) {
				var k = random.next1(n);
				var temp = list.item(n);
				list.item(n, list.item(k));
				list.item(k, temp);
			}

		}

	}

	, 
	insertionIndex$11: function ($t, collection, value) {
		var index = -1;
		var b = 0;
		var e = collection.count();
		while (index == -1) {
			if (e <= b) {
				index = b;

			} else {
				var m = $.ig.intDivide((b + e), 2);
				switch (Math.sign((value).compareTo($.ig.util.getBoxIfEnum($t, collection.item(m))))) {
					case -1:
						e = m;
						break;
					case 0:
						index = m;
						break;
					case 1:
						b = m + 1;
						break;
				}

			}


		}
		return index;
	}

	, 
	insertionIndex$1: function ($t, collection, comparison, value) {
		var index = -1;
		var b = 0;
		var e = collection.count();
		while (index == -1) {
			if (e <= b) {
				index = b;

			} else {
				var m = $.ig.intDivide((b + e), 2);
				switch (Math.sign(comparison(value, collection.item(m)))) {
					case -1:
						e = m;
						break;
					case 0:
						index = m;
						break;
					case 1:
						b = m + 1;
						break;
				}

			}


		}
		return index;
	}

	, 
	binarySearch$1: function ($t, list, comparisonFunction) {
		var currMin = 0;
		var currMax = list.count() - 1;
		while (currMin <= currMax) {
			var currMid = (currMin + ((currMax - currMin) >> 1));
			var compResult = comparisonFunction(list.item(currMid));
			if (compResult < 0) {
				currMax = currMid - 1;

			} else if (compResult > 0) {
				currMin = currMid + 1;

			} else {
				return currMid;
			}



		}
		return ~currMin;
	}
	, 
	$type: new $.ig.Type('ArrayUtil', $.ig.Object.prototype.$type)
}, true);


$.ig.util.defType('Clipper', 'Object', {

	target: function (value) {
		if (arguments.length === 1) {

			if (this.__firstClipper != null) {
				this.__firstClipper.clear();
			}

			this.__firstClipper = null;
			this._target = value;
			var headVal = this._target;
			if (this._leftClipper != null) {
				this._leftClipper.dst(headVal);
				headVal = this._leftClipper;
				this.__firstClipper = this._leftClipper;
			}

			if (this._bottomClipper != null) {
				this._bottomClipper.dst(headVal);
				headVal = this._bottomClipper;
				this._bottomClipper.__nextClipper = this.__firstClipper;
				this.__firstClipper = this._bottomClipper;
			}

			if (this._rightClipper != null) {
				this._rightClipper.dst(headVal);
				headVal = this._rightClipper;
				this._rightClipper.__nextClipper = this.__firstClipper;
				this.__firstClipper = this._rightClipper;
			}

			if (this._topClipper != null) {
				this._topClipper.dst(headVal);
				headVal = this._topClipper;
				this._topClipper.__nextClipper = this.__firstClipper;
				this.__firstClipper = this._topClipper;
			}

			this._head = headVal;
			return value;
		} else {

			return this._target;
		}
	}
	, 
	_head: null
	, 
	__firstClipper: null
	, 
	_target: null
	, 
	_leftClipper: null
	, 
	_bottomClipper: null
	, 
	_rightClipper: null
	, 
	_topClipper: null
	, 
	init: function (initNumber, clip, isClosed) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		var $self = this;
		$.ig.Object.prototype.init.call(this);
			this._leftClipper = (function () { var $ret = new $.ig.LeftClipper();
			$ret._edge = clip.left();
			$ret._isClosed = isClosed; return $ret;}());
			this._bottomClipper = (function () { var $ret = new $.ig.BottomClipper();
			$ret._edge = clip.bottom();
			$ret._isClosed = isClosed; return $ret;}());
			this._rightClipper = (function () { var $ret = new $.ig.RightClipper();
			$ret._edge = clip.right();
			$ret._isClosed = isClosed; return $ret;}());
			this._topClipper = (function () { var $ret = new $.ig.TopClipper();
			$ret._edge = clip.top();
			$ret._isClosed = isClosed; return $ret;}());
	}
	, 
	init1: function (initNumber, left, bottom, right, top, isClosed) {


		var $self = this;
		$.ig.Object.prototype.init.call(this);
			this._leftClipper = !$.ig.util.isNaN(left) ? (function () { var $ret = new $.ig.LeftClipper();
			$ret._edge = left;
			$ret._isClosed = isClosed; return $ret;}()) : null;
			this._bottomClipper = !$.ig.util.isNaN(bottom) ? (function () { var $ret = new $.ig.BottomClipper();
			$ret._edge = bottom;
			$ret._isClosed = isClosed; return $ret;}()) : null;
			this._rightClipper = !$.ig.util.isNaN(right) ? (function () { var $ret = new $.ig.RightClipper();
			$ret._edge = right;
			$ret._isClosed = isClosed; return $ret;}()) : null;
			this._topClipper = !$.ig.util.isNaN(top) ? (function () { var $ret = new $.ig.TopClipper();
			$ret._edge = top;
			$ret._isClosed = isClosed; return $ret;}()) : null;
	}

	, 
	add: function (point) {
		this._head.add(point);
	}

	, 
	isClosed: function (value) {
		if (arguments.length === 1) {

			if (this._leftClipper != null) {
			this._leftClipper._isClosed = value;
			}

			if (this._bottomClipper != null) {
			this._bottomClipper._isClosed = value;
			}

			if (this._rightClipper != null) {
			this._rightClipper._isClosed = value;
			}

			if (this._topClipper != null) {
			this._topClipper._isClosed = value;
			}

			return value;
		} else {

			return (this._leftClipper == null || this._leftClipper._isClosed) && (this._bottomClipper == null || this._bottomClipper._isClosed) && (this._rightClipper == null || this._rightClipper._isClosed) && (this._topClipper == null || this._topClipper._isClosed);
		}
	}
	, 
	$type: new $.ig.Type('Clipper', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('EdgeClipper', 'Object', {
	init: function () {

		this._init = true;
		this._isOutput = false;

		$.ig.Object.prototype.init.call(this);

	}
	, 
	dst: function (value) {
		if (arguments.length === 1) {

			if (this._dst != value) {
				this._init = true;
				this._dst = value;
			}

			return value;
		} else {

			return this._dst;
		}
	}
	, 
	_dst: null
	, 
	__nextClipper: null

	, 
	nextClipper: function (value) {
		if (arguments.length === 1) {

			this.__nextClipper = value;
			return value;
		} else {

			return this.__nextClipper;
		}
	}
	, 
	_init: false
	, 
	_first: null
	, 
	_prev: null
	, 
	_prevInside: false
	, 
	_isClosed: false
	, 
	_isOutput: false

	, 
	add: function (cur) {
		var CurInside = this.isInside(cur);
		if (this._init) {
			this._init = false;
			this._first = cur;

		} else {
			if (true) {
				if (CurInside) {
					if (!this._prevInside) {
						this.dst().add(this.intersection(this._prev, cur));

					} else {
						if (!this._isClosed && !this._isOutput) {
							this.dst().add(this._prev);
							this._isOutput = true;
						}

					}

					this.dst().add(cur);

				} else {
					if (this._prevInside) {
						if (!this._isClosed && !this._isOutput) {
							this.dst().add(this._prev);
							this._isOutput = true;
						}

						this.dst().add(this.intersection(this._prev, cur));
					}

				}

			}

		}

		this._prev = cur;
		this._prevInside = CurInside;
	}

	, 
	clear: function () {
		if (this._isClosed && !this._init) {
			this.add(this._first);
		}

		if (this.__nextClipper != null) {
			this.__nextClipper.clear();
		}

		this._init = true;
		this._isOutput = false;
	}

	, 
	isInside: function (pt) {}

	, 
	intersection: function (b, e) {}

	, 
	getEnumerator: function () {
		return null;
	}

	, 
	getEnumerator: function () {
		return null;
	}

	, 
	isReadOnly: function () {

			return false;
	}

	, 
	count: function () {

			return 0;
	}

	, 
	remove: function (pt) {
		return false;
	}

	, 
	removeAt: function (n) {
	}

	, 
	copyTo: function (pt, n) {
	}

	, 
	contains: function (pt) {
		return false;
	}

	, 
	item: function (n, value) {
		if (arguments.length === 2) {

			return value;
		} else {

			return {__x: 0, __y: 0, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		}
	}

	, 
	insert: function (n, pt) {
	}

	, 
	indexOf: function (pt) {
		return -1;
	}
	, 
	$type: new $.ig.Type('EdgeClipper', $.ig.Object.prototype.$type, [$.ig.IList$1.prototype.$type.specialize($.ig.Point.prototype.$type)])
}, true);

$.ig.util.defType('LeftClipper', 'EdgeClipper', {
	init: function () {


		$.ig.EdgeClipper.prototype.init.call(this);

	}, 
	_edge: 0

	, 
	isInside: function (pt) {
		return pt.__x >= this._edge;
	}

	, 
	intersection: function (b, e) {
		return {__x: this._edge, __y: b.__y + (e.__y - b.__y) * (this._edge - b.__x) / (e.__x - b.__x), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
	}
	, 
	$type: new $.ig.Type('LeftClipper', $.ig.EdgeClipper.prototype.$type)
}, true);

$.ig.util.defType('BottomClipper', 'EdgeClipper', {
	init: function () {


		$.ig.EdgeClipper.prototype.init.call(this);

	}, 
	_edge: 0

	, 
	isInside: function (pt) {
		return pt.__y <= this._edge;
	}

	, 
	intersection: function (b, e) {
		return {__x: b.__x + (e.__x - b.__x) * (this._edge - b.__y) / (e.__y - b.__y), __y: this._edge, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
	}
	, 
	$type: new $.ig.Type('BottomClipper', $.ig.EdgeClipper.prototype.$type)
}, true);

$.ig.util.defType('RightClipper', 'EdgeClipper', {
	init: function () {


		$.ig.EdgeClipper.prototype.init.call(this);

	}, 
	_edge: 0

	, 
	isInside: function (pt) {
		return pt.__x <= this._edge;
	}

	, 
	intersection: function (b, e) {
		return {__x: this._edge, __y: b.__y + (e.__y - b.__y) * (this._edge - b.__x) / (e.__x - b.__x), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
	}
	, 
	$type: new $.ig.Type('RightClipper', $.ig.EdgeClipper.prototype.$type)
}, true);

$.ig.util.defType('TopClipper', 'EdgeClipper', {
	init: function () {


		$.ig.EdgeClipper.prototype.init.call(this);

	}, 
	_edge: 0

	, 
	isInside: function (pt) {
		return pt.__y >= this._edge;
	}

	, 
	intersection: function (b, e) {
		return {__x: b.__x + (e.__x - b.__x) * (this._edge - b.__y) / (e.__y - b.__y), __y: this._edge, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
	}
	, 
	$type: new $.ig.Type('TopClipper', $.ig.EdgeClipper.prototype.$type)
}, true);









$.ig.util.defType('Extensions', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	reset1: function (geom) {
		geom.figures().clear();
		geom.figures().add(new $.ig.PathFigure());
		geom.figures().removeAt(0);
	}

	, 
	reset: function (geom) {
		geom.children().clear();
		geom.children().add(new $.ig.PathGeometry());
		geom.children().removeAt(0);
	}

	, 
	detach: function (child) {
		if (child == null) {
			return;
		}

		var parent = $.ig.util.cast($.ig.Panel.prototype.$type, child.parent());
		if (parent != null) {
			parent.children().remove(child);
			return;
		}

		var cont = $.ig.util.cast($.ig.ContentControl.prototype.$type, child.parent());
		if (cont != null) {
			cont.content(null);
			return;
		}

	}

	, 
	transferChildrenTo: function (from, to) {
		var transfer = new $.ig.List$1($.ig.UIElement.prototype.$type, 0);
		var en = $.ig.Enumerable.prototype.ofType$1($.ig.UIElement.prototype.$type, from.children()).getEnumerator();
		while (en.moveNext()) {
			var child = en.current();
			transfer.add(child);
		}

		var en1 = transfer.getEnumerator();
		while (en1.moveNext()) {
			var child1 = en1.current();
			from.children().remove(child1);
			to.children().add(child1);
		}

	}

	, 
	isPlottable: function (point) {
		return !$.ig.util.isNaN(point.__x) && !$.ig.util.isNaN(point.__y) && !Number.isInfinity(point.__x) && !Number.isInfinity(point.__y);
	}

	, 
	isPlottable1: function (rect) {
		return !$.ig.util.isNaN(rect.left()) && !$.ig.util.isNaN(rect.right()) && !$.ig.util.isNaN(rect.top()) && !$.ig.util.isNaN(rect.bottom()) && !Number.isInfinity(rect.left()) && !Number.isInfinity(rect.right()) && !Number.isInfinity(rect.top()) && !Number.isInfinity(rect.bottom());
	}
	, 
	$type: new $.ig.Type('Extensions', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('Flattener', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
	}

	, 
	spiral: function (startAngle, startRadius, endAngle, endRadius, error) {
		var $self = this;
		if ($.ig.util.isNaN(error) || error <= 0) {
			error = 1;
		}

		var ret = new $.ig.List$1(Number, 0);
		var todo = new $.ig.Stack$1($.ig.SpiralTodo.prototype.$type);
		var b = (endRadius - startRadius) / (endAngle - startAngle);
		var a = startRadius - b * startAngle;
		var b2 = b * b;
		var a2 = a * a;
		var ab = a * b;
		todo.push((function () { var $ret = new $.ig.SpiralTodo();
		$ret._p0 = 0;
		$ret._p1 = 1; return $ret;}()));
		while (todo.count() != 0) {
			var s = todo.pop();
			var r0 = startRadius + s._p0 * (endRadius - startRadius);
			var t0 = startAngle + s._p0 * (endAngle - startAngle);
			var t02 = t0 * t0;
			var t03 = t02 * t0;
			var r1 = startRadius + s._p1 * (endRadius - startRadius);
			var t1 = startAngle + s._p1 * (endAngle - startAngle);
			var t12 = t1 * t1;
			var t13 = t12 * t1;
			var segment;
			if (b == 0) {
				segment = a2 * (t1 - t0) / 2 + ab * (t12 - t02) / 2 + b2 * (t13 - t03) / 6;

			} else {
				segment = (Math.pow(a + b * t1, 3) - Math.pow(a + b * t0, 3)) / (6 * b);
			}

			var triangle = 0.5 * r0 * r1 * Math.sin(t1 - t0);
			if (segment - triangle > error) {
				var pm = 0.5 * (s._p0 + s._p1);
				todo.push((function () { var $ret = new $.ig.SpiralTodo();
				$ret._p0 = pm;
				$ret._p1 = s._p1; return $ret;}()));
				todo.push((function () { var $ret = new $.ig.SpiralTodo();
				$ret._p0 = s._p0;
				$ret._p1 = pm; return $ret;}()));

			} else {
				ret.add(s._p0);
			}


		}
		ret.add(1);
		return ret;
	}

	, 
	flatten3: function (count, X, Y, resolution) {
		var indices = new $.ig.List$1($.ig.Number.prototype.$type, 0);
		$.ig.Flattener.prototype.flatten2(indices, X, Y, 0, count - 1, resolution);
		return indices;
	}

	, 
	flatten2: function (result, X, Y, b, e, E) {
		var $self = this;
		return $.ig.Flattener.prototype.flatten1(result, function (i) {
			return i;
		}, X, Y, b, e, E);
	}

	, 
	flatten: function (result, indices, X, Y, b, e, E) {
		var $self = this;
		return $.ig.Flattener.prototype.flatten1(result, function (i) {
			return indices.item(i);
		}, X, Y, b, e, E);
	}

	, 
	flatten1: function (result, getIndex, X, Y, b, e, E) {
		if (b > e) {
			return result;
		}

		var Xb = X(getIndex(b));
		var Yb = Y(getIndex(b));
		while (($.ig.util.isNaN(Xb) || $.ig.util.isNaN(Yb)) && b < e) {
			++b;
			Xb = X(getIndex(b));
			Yb = Y(getIndex(b));

		}
		var Xe = X(getIndex(e));
		var Ye = Y(getIndex(e));
		while (($.ig.util.isNaN(Xe) || $.ig.util.isNaN(Ye)) && b < e) {
			--e;
			Xe = X(getIndex(e));
			Ye = Y(getIndex(e));

		}
		if (b == e) {
			result.add(getIndex(b));
			return result;
		}

		result.add(getIndex(b));
		$.ig.Flattener.prototype.flattenRecursive(result, getIndex, X, Y, b, e, E);
		result.add(getIndex(e));
		return result;
	}

	, 
	fastFlatten2: function (result, X, Y, b, e, E) {
		if (b > e) {
			return result;
		}

		var Xb = X[b];
		var Yb = Y[b];
		while (($.ig.util.isNaN(Xb) || $.ig.util.isNaN(Yb)) && b < e) {
			++b;
			Xb = X[b];
			Yb = Y[b];

		}
		var Xe = X[e];
		var Ye = Y[e];
		while (($.ig.util.isNaN(Xe) || $.ig.util.isNaN(Ye)) && b < e) {
			--e;
			Xe = X[e];
			Ye = Y[e];

		}
		if (b == e) {
			result.add(b);
			return result;
		}

		result.add(b);
		$.ig.Flattener.prototype.fastFlattenRecursive(result, X, Y, b, e, E);
		result.add(e);
		return result;
	}

	, 
	fastFlatten: function (count, buckets, point0, useX0AsX1, resolution) {
		var xIndex;
		var yIndex;
		if (point0) {
			xIndex = 0;
			yIndex = 1;

		} else if (useX0AsX1) {
			xIndex = 0;
			yIndex = 2;

		} else {
			xIndex = 2;
			yIndex = 3;
		}


		return $.ig.Flattener.prototype.fastFlatten1(count, buckets, xIndex, yIndex, resolution);
	}

	, 
	fastFlatten1: function (count, buckets, xIndex, yIndex, resolution) {
		var indices = new $.ig.List$1($.ig.Number.prototype.$type, 0);
		$.ig.Flattener.prototype.fastFlatten4(indices, buckets, xIndex, yIndex, 0, count - 1, resolution);
		return indices;
	}

	, 
	fastFlatten3: function (result, buckets, point0, useX0AsX1, b, e, E) {
		var xIndex;
		var yIndex;
		if (point0) {
			xIndex = 0;
			yIndex = 1;

		} else if (useX0AsX1) {
			xIndex = 0;
			yIndex = 2;

		} else {
			xIndex = 2;
			yIndex = 3;
		}


		return $.ig.Flattener.prototype.fastFlatten4(result, buckets, xIndex, yIndex, b, e, E);
	}

	, 
	fastFlatten4: function (result, buckets, xIndex, yIndex, b, e, E) {
		if (b > e) {
			return result;
		}

		var bucketB = buckets.__inner[b];
		var Xb, Yb;
		Xb = bucketB[xIndex];
		Yb = bucketB[yIndex];
		while (($.ig.util.isNaN(Xb) || $.ig.util.isNaN(Yb)) && b < e) {
			++b;
			bucketB = buckets.__inner[b];
			Xb = bucketB[xIndex];
			Yb = bucketB[yIndex];

		}
		var bucketE = buckets.__inner[e];
		var Xe, Ye;
		Xe = bucketE[xIndex];
		Ye = bucketE[yIndex];
		while (($.ig.util.isNaN(Xe) || $.ig.util.isNaN(Ye)) && b < e) {
			--e;
			bucketE = buckets.__inner[e];
			Xe = bucketE[xIndex];
			Ye = bucketE[yIndex];

		}
		if (b == e) {
			result.add(b);
			return result;
		}

		result.add(b);
		$.ig.Flattener.prototype.fastFlattenRecursive1(result, buckets, xIndex, yIndex, b, e, E);
		result.add(e);
		return result;
	}

	, 
	fastFlattenRecursive: function (result, X, Y, b, e, E) {
		var Xb = X[b];
		var Yb = Y[b];
		while (($.ig.util.isNaN(Xb) || $.ig.util.isNaN(Yb)) && b < e) {
			++b;
			Xb = X[b];
			Yb = Y[b];

		}
		var Xe = X[e];
		var Ye = Y[e];
		while (($.ig.util.isNaN(Xe) || $.ig.util.isNaN(Ye)) && b < e) {
			--e;
			Xe = X[e];
			Ye = Y[e];

		}
		if (b + 1 >= e) {
			return;
		}

		var si = -1;
		var se = E * E;
		var xDelt;
		var yDelt;
		xDelt = Xe - Xb;
		yDelt = Ye - Yb;
		var L = xDelt * xDelt + yDelt * yDelt;
		if (L == 0) {
			for (var i = b + 1; i < e; ++i) {
				var Xi = X[i];
				var Yi = Y[i];
				if ($.ig.util.isNaN(Xi) || $.ig.util.isNaN(Yi)) {
					continue;
				}

				xDelt = Xe - Xi;
				yDelt = Ye - Yi;
				var err = xDelt * xDelt + yDelt * yDelt;
				if (err >= se) {
					se = err;
					si = i;
				}

			}


		} else {
			var vx = Xe - Xb;
			var vy = Ye - Yb;
			for (var i1 = b + 1; i1 < e; ++i1) {
				var Xi1 = X[i1];
				var Yi1 = Y[i1];
				if ($.ig.util.isNaN(Xi1) || $.ig.util.isNaN(Yi1)) {
					continue;
				}

				var err1 = NaN;
				var wx = X[i1] - Xb;
				var wy = Y[i1] - Yb;
				var c1 = vx * wx + vy * wy;
				if (c1 <= 0) {
					xDelt = Xb - Xi1;
					yDelt = Yb - Yi1;
					err1 = xDelt * xDelt + yDelt * yDelt;

				} else {
					var c2 = vx * vx + vy * vy;
					if (c2 <= c1) {
						xDelt = Xe - Xi1;
						yDelt = Ye - Yi1;
						err1 = xDelt * xDelt + yDelt * yDelt;

					} else {
						var p = c1 / c2;
						xDelt = Xb + p * vx - Xi1;
						yDelt = Yb + p * vy - Yi1;
						err1 = xDelt * xDelt + yDelt * yDelt;
					}

				}

				if (err1 >= se) {
					se = err1;
					si = i1;
				}

			}

		}

		if (si != -1) {
			$.ig.Flattener.prototype.fastFlattenRecursive(result, X, Y, b, si, E);
			result.add(si);
			$.ig.Flattener.prototype.fastFlattenRecursive(result, X, Y, si, e, E);
		}

		return;
	}

	, 
	fastFlattenRecursive1: function (result, buckets, xIndex, yIndex, b, e, E) {
		var bucketB = buckets.__inner[b];
		var Xb, Yb;
		Xb = bucketB[xIndex];
		Yb = bucketB[yIndex];
		while ((Xb != Xb) || (Yb != Yb) && b < e) {
			++b;
			bucketB = buckets.__inner[b];
			Xb = bucketB[xIndex];
			Yb = bucketB[yIndex];

		}
		var bucketE = buckets.__inner[e];
		var Xe, Ye;
		Xe = bucketE[xIndex];
		Ye = bucketE[yIndex];
		while ((Xe != Xe) || (Ye != Ye) && b < e) {
			--e;
			bucketE = buckets.__inner[e];
			Xe = bucketE[xIndex];
			Ye = bucketE[yIndex];

		}
		if (b + 1 >= e) {
			return;
		}

		var si = -1;
		var se = E * E;
		var xDelt;
		var yDelt;
		xDelt = Xe - Xb;
		yDelt = Ye - Yb;
		var L = xDelt * xDelt + yDelt * yDelt;
		if (L == 0) {
			for (var i = b + 1; i < e; ++i) {
				var bucketI = buckets.__inner[i];
				var Xi, Yi;
				Xi = bucketI[xIndex];
				Yi = bucketI[yIndex];
				if ((Xi != Xi) || (Yi != Yi)) {
					continue;
				}

				xDelt = Xe - Xi;
				yDelt = Ye - Yi;
				var err = xDelt * xDelt + yDelt * yDelt;
				if (err >= se) {
					se = err;
					si = i;
				}

			}


		} else {
			var vx = Xe - Xb;
			var vy = Ye - Yb;
			for (var i1 = b + 1; i1 < e; ++i1) {
				var bucketI1 = buckets.__inner[i1];
				var Xi1, Yi1;
				Xi1 = bucketI1[xIndex];
				Yi1 = bucketI1[yIndex];
				if ((Xi1 != Xi1) || (Yi1 != Yi1)) {
					continue;
				}

				var err1 = NaN;
				var wx = Xi1 - Xb;
				var wy = Yi1 - Yb;
				var c1 = vx * wx + vy * wy;
				if (c1 <= 0) {
					xDelt = Xb - Xi1;
					yDelt = Yb - Yi1;
					err1 = xDelt * xDelt + yDelt * yDelt;

				} else {
					var c2 = vx * vx + vy * vy;
					if (c2 <= c1) {
						xDelt = Xe - Xi1;
						yDelt = Ye - Yi1;
						err1 = xDelt * xDelt + yDelt * yDelt;

					} else {
						var p = c1 / c2;
						xDelt = Xb + p * vx - Xi1;
						yDelt = Yb + p * vy - Yi1;
						err1 = xDelt * xDelt + yDelt * yDelt;
					}

				}

				if (err1 >= se) {
					se = err1;
					si = i1;
				}

			}

		}

		if (si != -1) {
			$.ig.Flattener.prototype.fastFlattenRecursive1(result, buckets, xIndex, yIndex, b, si, E);
			result.add(si);
			$.ig.Flattener.prototype.fastFlattenRecursive1(result, buckets, xIndex, yIndex, si, e, E);
		}

		return;
	}

	, 
	flattenRecursive: function (result, getIndex, X, Y, b, e, E) {
		var Xb = X(getIndex(b));
		var Yb = Y(getIndex(b));
		while (($.ig.util.isNaN(Xb) || $.ig.util.isNaN(Yb)) && b < e) {
			++b;
			Xb = X(getIndex(b));
			Yb = Y(getIndex(b));

		}
		var Xe = X(getIndex(e));
		var Ye = Y(getIndex(e));
		while (($.ig.util.isNaN(Xe) || $.ig.util.isNaN(Ye)) && b < e) {
			--e;
			Xe = X(getIndex(e));
			Ye = Y(getIndex(e));

		}
		if (b + 1 >= e) {
			return;
		}

		var si = -1;
		var se = E;
		var L = $.ig.MathUtil.prototype.hypot(Xe - Xb, Ye - Yb);
		if (L == 0) {
			for (var i = b + 1; i < e; ++i) {
				var Xi = X(getIndex(i));
				var Yi = Y(getIndex(i));
				if ($.ig.util.isNaN(Xi) || $.ig.util.isNaN(Yi)) {
					continue;
				}

				var err = $.ig.MathUtil.prototype.hypot(Xe - Xi, Ye - Yi);
				if (err >= se) {
					se = err;
					si = i;
				}

			}


		} else {
			var vx = Xe - Xb;
			var vy = Ye - Yb;
			for (var i1 = b + 1; i1 < e; ++i1) {
				var Xi1 = X(getIndex(i1));
				var Yi1 = Y(getIndex(i1));
				if ($.ig.util.isNaN(Xi1) || $.ig.util.isNaN(Yi1)) {
					continue;
				}

				var err1 = NaN;
				var wx = X(getIndex(i1)) - Xb;
				var wy = Y(getIndex(i1)) - Yb;
				var c1 = vx * wx + vy * wy;
				if (c1 <= 0) {
					err1 = $.ig.MathUtil.prototype.hypot(Xb - Xi1, Yb - Yi1);

				} else {
					var c2 = vx * vx + vy * vy;
					if (c2 <= c1) {
						err1 = $.ig.MathUtil.prototype.hypot(Xe - Xi1, Ye - Yi1);

					} else {
						var p = c1 / c2;
						err1 = $.ig.MathUtil.prototype.hypot(Xb + p * vx - Xi1, Yb + p * vy - Yi1);
					}

				}

				if (err1 >= se) {
					se = err1;
					si = i1;
				}

			}

		}

		if (si != -1) {
			$.ig.Flattener.prototype.flattenRecursive(result, getIndex, X, Y, b, si, E);
			result.add(getIndex(si));
			$.ig.Flattener.prototype.flattenRecursive(result, getIndex, X, Y, si, e, E);
		}

		return;
	}

	, 
	spline: function (count, X, Y) {
		var spline = new $.ig.PointCollection(0);
		if (count < 5) {
			for (var i = 0; i < count; ++i) {
				spline.add({__x: X(i), __y: Y(i), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			}

			return spline;
		}

		spline.add({__x: X(0), __y: Y(0), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
		var n = count - 1;
		var pa;
		var pb = {__x: X(0), __y: Y(0), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		var pc = {__x: X(0 + 1), __y: Y(0 + 1), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		var pd = {__x: X(0 + 2), __y: Y(0 + 2), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		var eab;
		var mab;
		var ebc = {__x: pc.__x - pb.__x, __y: pc.__y - pb.__y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		var mbc = $.ig.MathUtil.prototype.hypot(ebc.__x, ebc.__y);
		var ecd = {__x: pd.__x - pc.__x, __y: pd.__y - pc.__y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		var mcd = $.ig.MathUtil.prototype.hypot(ecd.__x, ecd.__y);
		var tc;
		var sc;
		var alpha = 0.1;
		var beta = 0.3;
			tc = {__x: pd.__x - pb.__x, __y: pd.__y - pb.__y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
				var m = $.ig.MathUtil.prototype.hypot(tc.__x, tc.__y);
				tc.__x /= m;
				tc.__y /= m;

			sc = 0.5 + (ebc.__x * ecd.__x + ebc.__y * ecd.__y) / (2 * mbc * mcd);
			spline.add({__x: pc.__x - tc.__x * (alpha + beta * sc) * mbc, __y: pc.__y - tc.__y * (alpha + beta * sc) * mbc, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			spline.add(pc);

		for (var i1 = 1; i1 < n - 1; ++i1) {
			pa = pb;
			pb = pc;
			pc = pd;
			pd = {__x: X(i1 + 2), __y: Y(i1 + 2), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			eab = ebc;
			mab = mbc;
			ebc = ecd;
			mbc = mcd;
			ecd = {__x: pd.__x - pc.__x, __y: pd.__y - pc.__y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			mcd = $.ig.MathUtil.prototype.hypot(ecd.__x, ecd.__y);
			var tb = tc;
			var sb = sc;
			tc = {__x: pd.__x - pb.__x, __y: pd.__y - pb.__y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
				var m1 = $.ig.MathUtil.prototype.hypot(tc.__x, tc.__y);
				tc.__x /= m1;
				tc.__y /= m1;

			sc = 0.5 + (ebc.__x * ecd.__x + ebc.__y * ecd.__y) / (2 * mbc * mcd);
			spline.add({__x: pb.__x + tb.__x * (alpha + beta * sb) * mbc, __y: pb.__y + tb.__y * (alpha + beta * sb) * mbc, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			spline.add({__x: pc.__x - tc.__x * (alpha + beta * sc) * mbc, __y: pc.__y - tc.__y * (alpha + beta * sc) * mbc, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			spline.add(pc);
		}

			pa = pb;
			pb = pc;
			pc = pd;
			eab = ebc;
			mab = mbc;
			ebc = ecd;
			mbc = mcd;
			var tb1 = tc;
			var sb1 = sc;
			spline.add({__x: pb.__x + tb1.__x * (alpha + beta * sb1) * mbc, __y: pb.__y + tb1.__y * (alpha + beta * sb1) * mbc, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			spline.add(pc);

		return spline;
	}
	, 
	$type: new $.ig.Type('Flattener', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('SpiralTodo', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}, 
	_p0: 0
	, 
	_p1: 0
	, 
	$type: new $.ig.Type('SpiralTodo', $.ig.Object.prototype.$type)
}, true);




$.ig.util.defType('PathFigureUtil', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	duplicate1: function (pathFigureCollection) {
		var dup = new $.ig.PathFigureCollection();
		var en = pathFigureCollection.getEnumerator();
		while (en.moveNext()) {
			var pathFigure = en.current();
			dup.add($.ig.PathFigureUtil.prototype.duplicate(pathFigure));
		}

		return dup;
	}

	, 
	duplicate: function (pathFigure) {
		var $self = this;
		if (pathFigure == null) {
			return null;
		}

		var segments = new $.ig.PathSegmentCollection();
		var en = pathFigure.__segments.getEnumerator();
		while (en.moveNext()) {
			var pathSegment = en.current();
			switch (pathSegment.type()) {
				case $.ig.PathSegmentType.prototype.arc:
					var arcSeg = pathSegment;
					var newArcSeg = new $.ig.ArcSegment();
					newArcSeg.isLargeArc(arcSeg.isLargeArc());
					newArcSeg.point(arcSeg.point());
					newArcSeg.rotationAngle(arcSeg.rotationAngle());
					newArcSeg.size(arcSeg.size());
					newArcSeg.sweepDirection(arcSeg.sweepDirection());
					segments.add(newArcSeg);
					break;
				case $.ig.PathSegmentType.prototype.line:
					var lineSeg = pathSegment;
					var newLineSeg = new $.ig.LineSegment(1);
					newLineSeg.point(lineSeg.point());
					segments.add(newLineSeg);
					break;
				case $.ig.PathSegmentType.prototype.polyLine:
					var polyLineSeg = pathSegment;
					var newPolyLineSeg = new $.ig.PolyLineSegment();
					var en1 = polyLineSeg.__points.getEnumerator();
					while (en1.moveNext()) {
						var p = en1.current();
						newPolyLineSeg.__points.add(p);
					}

					segments.add(newPolyLineSeg);
					break;
			}

		}

		return (function () { var $ret = new $.ig.PathFigure();
		$ret.isClosed(pathFigure.__isClosed);
		$ret.isFilled(pathFigure.__isFilled);
		$ret.startPoint(pathFigure.__startPoint);
		$ret.segments(segments); return $ret;}());
	}
	, 
	$type: new $.ig.Type('PathFigureUtil', $.ig.Object.prototype.$type)
}, true);













































































$.ig.util.defType('Numeric', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
	}

	, 
	solve1: function (a, b, c, r, u) {
		var j;
		var n = a.count();
		var gam = new Array(n);
		if (b.__inner[0] == 0) {
			return false;
		}

		var bet = b.__inner[0];
		u.__inner[0] = r.__inner[0] / (bet);
		for (j = 1; j < n; j++) {
			gam[j] = c.__inner[j - 1] / bet;
			bet = b.__inner[j] - a.__inner[j] * gam[j];
			if (bet == 0) {
				return false;
			}

			u.__inner[j] = (r.__inner[j] - a.__inner[j] * u.__inner[j - 1]) / bet;
		}

		for (j = (n - 2); j >= 0; j--) {
			u.__inner[j] -= gam[j + 1] * u.__inner[j + 1];
		}

		return true;
	}

	, 
	solve: function (a, b) {
		var n = a.getLength(0);
		var indxc = new Array(n);
		var indxr = new Array(n);
		var ipiv = new Array(n);
		for (var i = 0; i < n; i++) {
			ipiv[i] = 0;
		}

		for (var i1 = 0; i1 < n; i1++) {
			var big = 0;
			var irow = 0;
			var icol = 0;
			for (var j = 0; j < n; j++) {
				if (ipiv[j] != 1) {
					for (var k = 0; k < n; k++) {
						if (ipiv[k] == 0) {
							if (Math.abs(a[j][k]) >= big) {
								big = Math.abs(a[j][k]);
								irow = j;
								icol = k;
							}

						}

					}

				}

			}

			++(ipiv[icol]);
			if (irow != icol) {
				for (var j1 = 0; j1 < n; j1++) {
					var t = a[irow][j1];
					a[irow][j1] = a[icol][j1];
					a[icol][j1] = t;
				}

					var t1 = b[irow];
					b[irow] = b[icol];
					b[icol] = t1;

			}

			indxr[i1] = irow;
			indxc[i1] = icol;
			if (a[icol][icol] == 0) {
				return false;
			}

			var pivinv = 1 / a[icol][icol];
			a[icol][icol] = 1;
			for (var j2 = 0; j2 < n; j2++) {
				a[icol][j2] *= pivinv;
			}

			b[icol] *= pivinv;
			for (var j3 = 0; j3 < n; j3++) {
				if (j3 != icol) {
					var dum = a[j3][icol];
					a[j3][icol] = 0;
					for (var l = 0; l < n; l++) {
						a[j3][l] -= a[icol][l] * dum;
					}

					b[j3] -= b[icol] * dum;
				}

			}

		}

		for (var i2 = n - 1; i2 >= 0; i2--) {
			if (indxr[i2] != indxc[i2]) {
				for (var j4 = 0; j4 < n; j4++) {
					var t2 = a[j4][indxr[i2]];
					a[j4][indxr[i2]] = a[j4][indxc[i2]];
					a[j4][indxc[i2]] = t2;
				}

			}

		}

		return true;
	}

	, 
	safeCubicSplineFit: function (count, x, y, yp1, ypn) {
		var ret = new $.ig.List$1(Number, 0);
		for (var i = 0; i < count; ++i) {
			while (i < count && ($.ig.util.isNaN(x(i)) || $.ig.util.isNaN(y(i)))) {
				ret.add(NaN);
				++i;

			}
			var j = i;
			while (i < count && !$.ig.util.isNaN(x(i)) && !$.ig.util.isNaN(y(i))) {
				++i;

			}
			--i;
			if (i - j > 0) {
				ret.addRange($.ig.Numeric.prototype.cubicSplineFit1(j, i - j + 1, x, y, yp1, ypn));

			} else {
				for (; j <= i; ++j) {
					ret.add(NaN);
				}

			}

		}

		return ret.toArray();
	}

	, 
	cubicSplineFit1: function (start, count, x, y, yp1, ypn) {
		var $self = this;
		return $.ig.Numeric.prototype.cubicSplineFit(count, function (i) { return x(i + start); }, function (i) { return y(i + start); }, yp1, ypn);
	}

	, 
	cubicSplineFit: function (count, x, y, yp1, ypn) {
		var u = new Array(count - 1);
		var y2 = new Array(count);
		y2[0] = $.ig.util.isNaN(yp1) ? 0 : -0.5;
		u[0] = $.ig.util.isNaN(yp1) ? 0 : (3 / (x(1) - x(0))) * ((y(1) - y(0)) / (x(1) - x(0)) - yp1);
		for (var i = 1; i < count - 1; i++) {
			var sig = (x(i) - x(i - 1)) / (x(i + 1) - x(i - 1));
			var p = sig * y2[i - 1] + 2;
			y2[i] = (sig - 1) / p;
			u[i] = (y(i + 1) - y(i)) / (x(i + 1) - x(i)) - (y(i) - y(i - 1)) / (x(i) - x(i - 1));
			u[i] = (6 * u[i] / (x(i + 1) - x(i - 1)) - sig * u[i - 1]) / p;
		}

		var qn = $.ig.util.isNaN(ypn) ? 0 : 0.5;
		var un = $.ig.util.isNaN(ypn) ? 0 : (3 / (x(count - 1) - x(count - 2))) * (ypn - (y(count - 1) - y(count - 2)) / (x(count - 1) - x(count - 2)));
		y2[count - 1] = (un - qn * u[count - 2]) / (qn * y2[count - 2] + 1);
		for (var i1 = count - 2; i1 >= 0; i1--) {
			y2[i1] = y2[i1] * y2[i1 + 1] + u[i1];
		}

		return y2;
	}

	, 
	cubicSplineEvaluate: function (x, x1, y1, x2, y2, u1, u2) {
		var h = x2 - x1;
		var a = (x2 - x) / h;
		var b = (x - x1) / h;
		return a * y1 + b * y2 + ((a * a * a - a) * u1 + (b * b * b - b) * u2) * (h * h) / 6;
	}

	, 
	spline2D1: function (count, x, y, stiffness) {
		var result = new $.ig.PathFigureCollection();
		var currentSegmentStart = 0;
		var currentSegmentEnd = -1;
		var valueX = NaN;
		var valueY = NaN;
		for (var i = 0; i < count; i++) {
			valueX = x(i);
			valueY = y(i);
			if ($.ig.util.isNaN(valueX) || $.ig.util.isNaN(valueY)) {
				currentSegmentEnd = i - 1;
				if (currentSegmentEnd - currentSegmentStart > 0) {
					result.add($.ig.Numeric.prototype.spline2D(currentSegmentStart, currentSegmentEnd, x, y, stiffness));
				}

				currentSegmentStart = i + 1;
			}

		}

		if (!$.ig.util.isNaN(valueX) && !$.ig.util.isNaN(valueY)) {
			currentSegmentEnd = count - 1;
		}

		if (currentSegmentEnd - currentSegmentStart > 0) {
			result.add($.ig.Numeric.prototype.spline2D(currentSegmentStart, currentSegmentEnd, x, y, stiffness));
		}

		return result;
	}

	, 
	spline2D: function (startIndex, endIndex, x, y, stiffness) {
		var $self = this;
		stiffness = 0.5 * $.ig.MathUtil.prototype.clamp($.ig.util.isNaN(stiffness) ? 0.5 : stiffness, 0, 1);
		var pathFigure = new $.ig.PathFigure();
		var count = endIndex - startIndex + 1;
		if (count < 2) {
			return pathFigure;
		}

		if (count == 2) {
			pathFigure.__startPoint = {__x: x(startIndex), __y: y(startIndex), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			var newSeg = (function () { var $ret = new $.ig.LineSegment(1);
			$ret.point({__x: x(startIndex + 1), __y: y(startIndex + 1), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}); return $ret;}());
			pathFigure.__segments.add(newSeg);
			return pathFigure;
		}

		var Segment = new $.ig.PolyBezierSegment();
		var pix = x(startIndex);
		var piy = y(startIndex);
		var pixnext = x(startIndex + 1);
		var piynext = y(startIndex + 1);
		while (pixnext == pix && piynext == piy && startIndex + 1 <= endIndex) {
			startIndex++;
			pixnext = x(startIndex + 1);
			piynext = y(startIndex + 1);

		}
		var tix = pixnext - pix;
		var tiy = piynext - piy;
		var li = Math.sqrt(tix * tix + tiy * tiy);
		for (var j = startIndex + 1; j < endIndex; ++j) {
			var pjx = x(j);
			var pjy = y(j);
			if (pjx == pix && pjy == piy) {
				continue;
			}

			var tjx = x(j + 1) - x(j - 1);
			var tjy = y(j + 1) - y(j - 1);
			var lj = tjx * tjx + tjy * tjy;
			if (lj < 0.01) {
				tjx = -(y(j + 1) - y(j));
				tjy = x(j + 1) - x(j);
				lj = tjx * tjx + tjy * tjy;
			}

			lj = Math.sqrt(lj);
			var d = stiffness * Math.sqrt((pjx - pix) * (pjx - pix) + (pjy - piy) * (pjy - piy));
			if (lj > 0.01) {
				Segment.points().add({__x: pix + tix * d / li, __y: piy + tiy * d / li, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
				Segment.points().add({__x: pjx - tjx * d / lj, __y: pjy - tjy * d / lj, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
				Segment.points().add({__x: pjx, __y: pjy, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
				pix = pjx;
				piy = pjy;
				tix = tjx;
				tiy = tjy;
				li = lj;
			}

		}

			var j1 = endIndex;
			var pjx1 = x(j1);
			var pjy1 = y(j1);
			var tjx1 = x(j1) - x(j1 - 1);
			var tjy1 = y(j1) - y(j1 - 1);
			var lj1 = tjx1 * tjx1 + tjy1 * tjy1;
			var d1 = stiffness * Math.sqrt((pjx1 - pix) * (pjx1 - pix) + (pjy1 - piy) * (pjy1 - piy));
			Segment.points().add({__x: pix + tix * d1 / li, __y: piy + tiy * d1 / li, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			Segment.points().add({__x: pjx1 - tjx1 * d1 / lj1, __y: pjy1 - tjy1 * d1 / lj1, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			Segment.points().add({__x: pjx1, __y: pjy1, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});

		pathFigure.__startPoint = {__x: x(startIndex), __y: y(startIndex), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		pathFigure.__segments.add(Segment);
		return pathFigure;
	}
	, 
	$type: new $.ig.Type('Numeric', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('LeastSquaresFit', 'Numeric', {

	test: function () {
		return $.ig.LeastSquaresFit.prototype.linearTest() && $.ig.LeastSquaresFit.prototype.logarithmicTest() && $.ig.LeastSquaresFit.prototype.exponentialTest() && $.ig.LeastSquaresFit.prototype.powerLawTest() && $.ig.LeastSquaresFit.prototype.quadraticTest() && $.ig.LeastSquaresFit.prototype.cubicTest() && $.ig.LeastSquaresFit.prototype.quarticTest() && $.ig.LeastSquaresFit.prototype.quinticTest();
	}
	, 
	init: function () {



		$.ig.Numeric.prototype.init.call(this);
	}

	, 
	linearFit: function (n, x, y) {
		var $self = this;
		var s0 = 0;
		var s1 = 0;
		var s2 = 0;
		var s3 = 0;
		var N = 0;
		for (var i = 0; i < n; ++i) {
			var xi = x(i);
			var yi = y(i);
			if (!$.ig.util.isNaN(xi) && !$.ig.util.isNaN(yi)) {
				s0 += yi;
				s1 += xi * xi;
				s2 += xi;
				s3 += xi * yi;
				++N;
			}

		}

		if (N < 2) {
			return null;
		}

		var A = (s0 * s1 - s2 * s3) / (N * s1 - s2 * s2);
		var B = (N * s3 - s2 * s0) / (N * s1 - s2 * s2);
		return (function () { var $ret = new Array();
		$ret.add(A);
		$ret.add(B);return $ret;}());
	}

	, 
	linearEvaluate: function (a, x) {
		if (a.length != 2) {
			return NaN;
		}

		return a[0] + a[1] * x;
	}

	, 
	linearTest: function () {
		var $self = this;
		var random = new $.ig.Random(0);
		var coeffs = new Array(2);
		for (var i = 0; i < coeffs.length; ++i) {
			coeffs[i] = 10 * random.nextDouble();
		}

		var x = new $.ig.List$1(Number, 0);
		var y = new $.ig.List$1(Number, 0);
		for (var i1 = -100; i1 < 100; ++i1) {
			var X = i1;
			var Y = $.ig.LeastSquaresFit.prototype.linearEvaluate(coeffs, X);
			if (!$.ig.util.isNaN(Y)) {
				x.add(X);
				y.add(Y);
			}

		}

		var fit = $.ig.LeastSquaresFit.prototype.linearFit(x.count(), function (i) {
				return x.__inner[i];
		}, function (i) {
				return y.__inner[i];
		});
		for (var i2 = 0; i2 < coeffs.length; ++i2) {
			if (Math.abs(coeffs[i2] - fit[i2]) > 0.0001) {
			}

		}

		return true;
	}

	, 
	logarithmicFit: function (n, x, y) {
		var $self = this;
		var s0 = 0;
		var s1 = 0;
		var s2 = 0;
		var s3 = 0;
		var N = 0;
		for (var i = 0; i < n; ++i) {
			var xi = x(i);
			var yi = y(i);
			if (!$.ig.util.isNaN(xi) && !$.ig.util.isNaN(yi) && xi > 0) {
				var lnxi = Math.log(xi);
				s0 += yi * lnxi;
				s1 += yi;
				s2 += lnxi;
				s3 += lnxi * lnxi;
				++N;
			}

		}

		if (N < 2) {
			return null;
		}

		var B = (N * s0 - s1 * s2) / (N * s3 - s2 * s2);
		var A = (s1 - B * s2) / N;
		return (function () { var $ret = new Array();
		$ret.add(A);
		$ret.add(B);return $ret;}());
	}

	, 
	logarithmicEvaluate: function (a, x) {
		if (a.length != 2 || x < 0 || Number.isInfinity(x) || $.ig.util.isNaN(x)) {
			return NaN;
		}

		return a[0] + a[1] * Math.log(x);
	}

	, 
	logarithmicTest: function () {
		var $self = this;
		var random = new $.ig.Random(0);
		var coeffs = new Array(2);
		for (var i = 0; i < coeffs.length; ++i) {
			coeffs[i] = 10 * random.nextDouble();
		}

		var x = new $.ig.List$1(Number, 0);
		var y = new $.ig.List$1(Number, 0);
		for (var i1 = 1; i1 < 100; ++i1) {
			var X = i1;
			var Y = $.ig.LeastSquaresFit.prototype.logarithmicEvaluate(coeffs, X);
			if (!$.ig.util.isNaN(Y)) {
				x.add(X);
				y.add(Y);
			}

		}

		var fit = $.ig.LeastSquaresFit.prototype.logarithmicFit(x.count(), function (i) {
				return x.__inner[i];
		}, function (i) {
				return y.__inner[i];
		});
		for (var i2 = 0; i2 < coeffs.length; ++i2) {
			if (Math.abs(coeffs[i2] - fit[i2]) > 0.0001) {
			}

		}

		return true;
	}

	, 
	exponentialFit: function (n, x, y) {
		var $self = this;
		var s0 = 0;
		var s1 = 0;
		var s2 = 0;
		var s3 = 0;
		var s4 = 0;
		var N = 0;
		for (var i = 0; i < n; ++i) {
			var xi = x(i);
			var yi = y(i);
			if (!$.ig.util.isNaN(xi) && !$.ig.util.isNaN(yi) && yi > 0) {
				var lnyi = Math.log(yi);
				s0 += xi * xi * yi;
				s1 += yi * lnyi;
				s2 += xi * yi;
				s3 += xi * yi * lnyi;
				s4 += yi;
				++N;
			}

		}

		if (N < 2) {
			return null;
		}

		var a = (s0 * s1 - s2 * s3) / (s4 * s0 - s2 * s2);
		var B = (s4 * s3 - s2 * s1) / (s4 * s0 - s2 * s2);
		return (function () { var $ret = new Array();
		$ret.add(Math.exp(a));
		$ret.add(B);return $ret;}());
	}

	, 
	exponentialEvaluate: function (a, x) {
		if (a.length != 2 || x < 0 || Number.isInfinity(x) || $.ig.util.isNaN(x)) {
			return NaN;
		}

		return a[0] * Math.exp(a[1] * x);
	}

	, 
	exponentialTest: function () {
		var $self = this;
		var random = new $.ig.Random(0);
		var coeffs = new Array(2);
		for (var i = 0; i < coeffs.length; ++i) {
			coeffs[i] = 2 * random.nextDouble();
		}

		var x = new $.ig.List$1(Number, 0);
		var y = new $.ig.List$1(Number, 0);
		for (var i1 = 1; i1 < 100; ++i1) {
			var X = i1;
			var Y = $.ig.LeastSquaresFit.prototype.exponentialEvaluate(coeffs, X);
			if (!$.ig.util.isNaN(Y)) {
				x.add(X);
				y.add(Y);
			}

		}

		var fit = $.ig.LeastSquaresFit.prototype.exponentialFit(x.count(), function (i) {
				return x.__inner[i];
		}, function (i) {
				return y.__inner[i];
		});
		for (var i2 = 0; i2 < coeffs.length; ++i2) {
			if (Math.abs(coeffs[i2] - fit[i2]) > 0.0001) {
				return false;
			}

		}

		return true;
	}

	, 
	powerLawFit: function (n, x, y) {
		var $self = this;
		var s0 = 0;
		var s1 = 0;
		var s2 = 0;
		var s3 = 0;
		var N = 0;
		for (var i = 0; i < n; ++i) {
			var xi = x(i);
			var yi = y(i);
			if (!$.ig.util.isNaN(xi) && !$.ig.util.isNaN(yi) && xi > 0 && yi > 0) {
				var lnxi = Math.log(x(i));
				var lnyi = Math.log(y(i));
				s0 += lnxi * lnyi;
				s1 += lnxi;
				s2 += lnyi;
				s3 += lnxi * lnxi;
				++N;
			}

		}

		if (N < 2) {
			return null;
		}

		var B = (N * s0 - s1 * s2) / (N * s3 - s1 * s1);
		var A = Math.exp((s2 - B * s1) / N);
		return (function () { var $ret = new Array();
		$ret.add(A);
		$ret.add(B);return $ret;}());
	}

	, 
	powerLawEvaluate: function (a, x) {
		if (a.length != 2 || x < 0 || Number.isInfinity(x) || $.ig.util.isNaN(x)) {
			return NaN;
		}

		return a[0] * Math.pow(x, a[1]);
	}

	, 
	powerLawTest: function () {
		var $self = this;
		var random = new $.ig.Random(0);
		var coeffs = new Array(2);
		for (var i = 0; i < coeffs.length; ++i) {
			coeffs[i] = 10 * random.nextDouble();
		}

		var x = new $.ig.List$1(Number, 0);
		var y = new $.ig.List$1(Number, 0);
		for (var i1 = -100; i1 < 100; ++i1) {
			x.add(i1);
			y.add($.ig.LeastSquaresFit.prototype.powerLawEvaluate(coeffs, i1));
		}

		var fit = $.ig.LeastSquaresFit.prototype.powerLawFit(x.count(), function (i) {
				return x.__inner[i];
		}, function (i) {
				return y.__inner[i];
		});
		for (var i2 = 0; i2 < coeffs.length; ++i2) {
			if (Math.abs(coeffs[i2] - fit[i2]) > 0.0001) {
				return false;
			}

		}

		return true;
	}

	, 
	quadraticFit: function (n, x, y) {
		return $.ig.LeastSquaresFit.prototype.polynomialFit(n, 2, x, y);
	}

	, 
	quadraticEvaluate: function (a, x) {
		return $.ig.LeastSquaresFit.prototype.polynomialEvaluate(a, x);
	}

	, 
	quadraticTest: function () {
		return $.ig.LeastSquaresFit.prototype.polynomialTest(2);
	}

	, 
	cubicFit: function (n, x, y) {
		return $.ig.LeastSquaresFit.prototype.polynomialFit(n, 3, x, y);
	}

	, 
	cubicEvaluate: function (a, x) {
		return $.ig.LeastSquaresFit.prototype.polynomialEvaluate(a, x);
	}

	, 
	cubicTest: function () {
		return $.ig.LeastSquaresFit.prototype.polynomialTest(3);
	}

	, 
	quarticFit: function (n, x, y) {
		return $.ig.LeastSquaresFit.prototype.polynomialFit(n, 4, x, y);
	}

	, 
	quarticEvaluate: function (a, x) {
		return $.ig.LeastSquaresFit.prototype.polynomialEvaluate(a, x);
	}

	, 
	quarticTest: function () {
		return $.ig.LeastSquaresFit.prototype.polynomialTest(4);
	}

	, 
	quinticFit: function (n, x, y) {
		return $.ig.LeastSquaresFit.prototype.polynomialFit(n, 5, x, y);
	}

	, 
	quinticEvaluate: function (a, x) {
		return $.ig.LeastSquaresFit.prototype.polynomialEvaluate(a, x);
	}

	, 
	quinticTest: function () {
		return $.ig.LeastSquaresFit.prototype.polynomialTest(5);
	}

	, 
	polynomialFit: function (n, k, x, y) {
		var ps = new Array(1 + 2 * k);
		for (var ind1 = 0; ind1 < ps.length; ind1++) {
			ps[ind1] = 0;
		}

		var A = (function () { var $ret = new Array($firstRank = k + 1); var $currRet = $ret; for (var $rankInit = 0; $rankInit < $firstRank; $rankInit++) { $currRet[$rankInit] = new Array(k + 1); };return $ret;}());
		var B = new Array(k + 1);
		for (var ind2 = 0; ind2 < B.length; ind2++) {
			B[ind2] = 0;
		}

		var N = 0;
		for (var i = 0; i < n; ++i) {
			var s = 1;
			var xi = x(i);
			if (!$.ig.util.isNaN(xi) && !$.ig.util.isNaN(y(i))) {
				for (var p = 0; p < ps.length; ++p) {
					ps[p] += s;
					s *= xi;
					++N;
				}

			}

		}

		if (N < k) {
			return null;
		}

		for (var i1 = 0; i1 <= k; ++i1) {
			for (var j = 0; j <= k; ++j) {
				A[i1][j] = ps[i1 + j];
			}

		}

		for (var i2 = 0; i2 < n; ++i2) {
			var xi1 = x(i2);
			var yi = y(i2);
			if (!$.ig.util.isNaN(xi1) && !$.ig.util.isNaN(yi)) {
				for (var j1 = 0; j1 <= k; ++j1) {
					B[j1] += (Math.pow(xi1, j1) * yi);
				}

			}

		}

		return $.ig.Numeric.prototype.solve(A, B) ? B : null;
	}

	, 
	polynomialEvaluate: function (a, x) {
		if (a.length < 1 || Number.isInfinity(x) || $.ig.util.isNaN(x)) {
			return NaN;
		}

		var y = 0;
		for (var i = 0; i < a.length; ++i) {
			y += a[i] * Math.pow(x, i);
		}

		return y;
	}

	, 
	polynomialTest: function (k) {
		var $self = this;
		var random = new $.ig.Random(0);
		var coeffs = new Array(k + 1);
		for (var i = 0; i < coeffs.length; ++i) {
			coeffs[i] = 2 * random.nextDouble();
		}

		var x = new $.ig.List$1(Number, 0);
		var y = new $.ig.List$1(Number, 0);
		for (var i1 = -100; i1 < 100; ++i1) {
			var X = i1;
			var Y = $.ig.LeastSquaresFit.prototype.polynomialEvaluate(coeffs, X);
			if (!$.ig.util.isNaN(Y)) {
				x.add(X);
				y.add(Y);
			}

		}

		var fit = $.ig.LeastSquaresFit.prototype.polynomialFit(x.count(), k, function (i) {
				return x.__inner[i];
		}, function (i) {
				return y.__inner[i];
		});
		for (var i2 = 0; i2 < k; ++i2) {
			if (Math.abs(coeffs[i2] - fit[i2]) > 0.0001) {
				return false;
			}

		}

		return true;
	}
	, 
	$type: new $.ig.Type('LeastSquaresFit', $.ig.Numeric.prototype.$type)
}, true);












$.ig.TrendLineType.prototype.none = 0;
$.ig.TrendLineType.prototype.linearFit = 1;
$.ig.TrendLineType.prototype.quadraticFit = 2;
$.ig.TrendLineType.prototype.cubicFit = 3;
$.ig.TrendLineType.prototype.quarticFit = 4;
$.ig.TrendLineType.prototype.quinticFit = 5;
$.ig.TrendLineType.prototype.logarithmicFit = 6;
$.ig.TrendLineType.prototype.exponentialFit = 7;
$.ig.TrendLineType.prototype.powerLawFit = 8;
$.ig.TrendLineType.prototype.simpleAverage = 9;
$.ig.TrendLineType.prototype.exponentialAverage = 10;
$.ig.TrendLineType.prototype.modifiedAverage = 11;
$.ig.TrendLineType.prototype.cumulativeAverage = 12;
$.ig.TrendLineType.prototype.weightedAverage = 13;























} (jQuery));



// Declare empty types
$.ig = $.ig || {};
(function ($) {
var $$t = {}
$.ig.$currDefinitions = $$t;
$.ig.util.bulkDefine(["Enum:b", 
"ValueType:c", 
"Object:d", 
"Type:e", 
"Boolean:f", 
"IConvertible:g", 
"IFormatProvider:h", 
"Number:i", 
"String:j", 
"IComparable:k", 
"Number:l", 
"Number:m", 
"Number:n", 
"Number:o", 
"NumberStyles:p", 
"Number:q", 
"Void:r", 
"String:s", 
"StringComparison:t", 
"Array:u", 
"IList:v", 
"ICollection:w", 
"IEnumerable:x", 
"IEnumerator:y", 
"RegExp:z", 
"CultureInfo:aa", 
"Calendar:ab", 
"Date:ac", 
"DayOfWeek:ad", 
"DateTimeKind:ae", 
"Date:af", 
"Error:ag", 
"CompareInfo:ah", 
"CompareOptions:ai", 
"NumberFormatInfo:aj", 
"DateTimeFormatInfo:ak", 
"CalendarWeekRule:al", 
"IEnumerable$1:am", 
"IEnumerator$1:an", 
"IDisposable:ao", 
"StringSplitOptions:ap", 
"Number:aq", 
"Number:ar", 
"Number:as", 
"Number:at", 
"Number:au", 
"Number:av", 
"Assembly:aw", 
"Stream:ax", 
"SeekOrigin:ay", 
"RuntimeTypeHandle:az", 
"MethodInfo:a0", 
"MethodBase:a1", 
"MemberInfo:a2", 
"ParameterInfo:a3", 
"TypeCode:a4", 
"ConstructorInfo:a5", 
"PropertyInfo:a6", 
"SeriesViewer:a7", 
"Control:a8", 
"FrameworkElement:a9", 
"UIElement:ba", 
"DependencyObject:bb", 
"Dictionary:bc", 
"DependencyProperty:bd", 
"PropertyMetadata:be", 
"PropertyChangedCallback:bf", 
"MulticastDelegate:bg", 
"IntPtr:bh", 
"DependencyPropertyChangedEventArgs:bi", 
"UnsetValue:bj", 
"DependencyPropertiesCollection:bk", 
"Script:bl", 
"Binding:bm", 
"PropertyPath:bn", 
"Transform:bo", 
"Visibility:bp", 
"Style:bq", 
"Thickness:br", 
"HorizontalAlignment:bs", 
"VerticalAlignment:bt", 
"INotifyPropertyChanged:bu", 
"PropertyChangedEventHandler:bv", 
"PropertyChangedEventArgs:bw", 
"SeriesViewerView:bx", 
"ISchedulableRender:by", 
"CanvasRenderScheduler:bz", 
"List$1:b0", 
"IList$1:b1", 
"ICollection$1:b2", 
"IArray:b3", 
"Enumerable:b4", 
"Func$2:b5", 
"Func$3:b6", 
"IOrderedEnumerable$1:b7", 
"SortedList$1:b8", 
"Math:b9", 
"ArgumentNullException:ca", 
"NotImplementedException:cb", 
"IArrayList:cc", 
"Array:cd", 
"CompareCallback:ce", 
"Action$1:cf", 
"Comparer$1:cg", 
"IComparer:ch", 
"IComparer$1:ci", 
"DefaultComparer$1:cj", 
"IComparable$1:ck", 
"Comparison$1:cl", 
"ReadOnlyCollection$1:cm", 
"Predicate$1:cn", 
"Callback:co", 
"window:cp", 
"RenderingContext:cq", 
"IRenderer:cr", 
"Rectangle:cs", 
"Shape:ct", 
"Brush:cu", 
"Color:cv", 
"ArgumentException:cw", 
"Nullable$1:cx", 
"DoubleCollection:cy", 
"Rect:cz", 
"Size:c0", 
"Point:c1", 
"Path:c2", 
"Geometry:c3", 
"GeometryType:c4", 
"TextBlock:c5", 
"Polygon:c6", 
"PointCollection:c7", 
"Polyline:c8", 
"DataTemplateRenderInfo:c9", 
"DataTemplatePassInfo:da", 
"ContentControl:db", 
"DataTemplate:dc", 
"DataTemplateRenderHandler:dd", 
"DataTemplateMeasureHandler:de", 
"DataTemplateMeasureInfo:df", 
"DataTemplatePassHandler:dg", 
"Line:dh", 
"XamOverviewPlusDetailPane:di", 
"XamOverviewPlusDetailPaneView:dj", 
"XamOverviewPlusDetailPaneViewManager:dk", 
"JQueryObject:dl", 
"Element:dm", 
"ElementAttributeCollection:dn", 
"ElementCollection:dp", 
"WebStyle:dq", 
"ElementNodeType:dr", 
"Document:ds", 
"EventListener:dt", 
"IElementEventHandler:du", 
"ElementEventHandler:dv", 
"ElementAttribute:dw", 
"JQueryPosition:dx", 
"JQueryCallback:dy", 
"JQueryEvent:dz", 
"JQueryUICallback:d0", 
"EventProxy:d1", 
"ModifierKeys:d2", 
"MouseWheelHandler:d3", 
"Delegate:d4", 
"Interlocked:d5", 
"GestureHandler:d6", 
"ContactHandler:d7", 
"TouchHandler:d8", 
"MouseOverHandler:d9", 
"MouseHandler:ea", 
"KeyHandler:eb", 
"Key:ec", 
"JQuery:ed", 
"JQueryDeferred:ee", 
"JQueryPromise:ef", 
"Action:eg", 
"CanvasViewRenderer:eh", 
"CanvasContext2D:ei", 
"CanvasContext:ej", 
"TextMetrics:ek", 
"ImageData:el", 
"CanvasElement:em", 
"Gradient:en", 
"LinearGradientBrush:eo", 
"GradientStop:ep", 
"GeometryGroup:eq", 
"GeometryCollection:er", 
"FillRule:es", 
"PathGeometry:et", 
"PathFigureCollection:eu", 
"LineGeometry:ev", 
"RectangleGeometry:ew", 
"EllipseGeometry:ex", 
"ArcSegment:ey", 
"PathSegment:ez", 
"PathSegmentType:e0", 
"SweepDirection:e1", 
"PathFigure:e2", 
"PathSegmentCollection:e3", 
"LineSegment:e4", 
"PolyLineSegment:e5", 
"BezierSegment:e6", 
"PolyBezierSegment:e7", 
"GeometryUtil:e8", 
"Tuple$2:e9", 
"TransformGroup:fa", 
"TransformCollection:fb", 
"TranslateTransform:fc", 
"RotateTransform:fd", 
"ScaleTransform:fe", 
"DivElement:ff", 
"DOMEventProxy:fg", 
"MSGesture:fh", 
"MouseEventArgs:fi", 
"EventArgs:fj", 
"DoubleAnimator:fk", 
"EasingFunctionHandler:fl", 
"ImageElement:fm", 
"RectUtil:fn", 
"MathUtil:fo", 
"RuntimeHelpers:fp", 
"RuntimeFieldHandle:fq", 
"PropertyChangedEventArgs$1:fr", 
"InteractionState:fs", 
"OverviewPlusDetailPaneMode:ft", 
"IOverviewPlusDetailControl:fu", 
"EventHandler$1:fv", 
"OverviewPlusDetailViewportHost:fw", 
"IProvidesViewport:fx", 
"SeriesCollection:fy", 
"ObservableCollection$1:fz", 
"INotifyCollectionChanged:f0", 
"NotifyCollectionChangedEventHandler:f1", 
"NotifyCollectionChangedEventArgs:f2", 
"NotifyCollectionChangedAction:f3", 
"AxisCollection:f4", 
"SeriesViewerViewManager:f5", 
"AxisTitlePosition:f6", 
"PointerTooltipStyle:f7", 
"Dictionary$2:f8", 
"IDictionary$2:f9", 
"IDictionary:ga", 
"IEqualityComparer$1:gb", 
"EqualityComparer$1:gc", 
"IEqualityComparer:gd", 
"DefaultEqualityComparer$1:ge", 
"InvalidOperationException:gf", 
"KeyValuePair$2:gg", 
"BrushCollection:gh", 
"InterpolationMode:gi", 
"Random:gj", 
"ColorUtil:gk", 
"CssHelper:gl", 
"CssGradientUtil:gm", 
"FontUtil:gn", 
"FontInfo:go", 
"TileZoomTile:gp", 
"TileZoomTileInfo:gq", 
"TileZoomTileCache:gr", 
"TileZoomManager:gs", 
"RectChangedEventHandler:gt", 
"RectChangedEventArgs:gu", 
"Debug:gv", 
"TileZoomInfo:gw", 
"LinkedList$1:gx", 
"LinkedListNode$1:gy", 
"RenderSurface:gz", 
"Series:g0", 
"SeriesView:g1", 
"XamDataChart:g2", 
"GridMode:g3", 
"XamDataChartView:g4", 
"FragmentBase:g5", 
"HorizontalAnchoredCategorySeries:g6", 
"AnchoredCategorySeries:g7", 
"CategorySeries:g8", 
"MarkerSeries:g9", 
"MarkerSeriesView:ha", 
"Marker:hb", 
"DataContext:hc", 
"MarkerTemplates:hd", 
"HashPool$2:he", 
"IHashPool$2:hf", 
"IPool$1:hg", 
"Func$1:hh", 
"Pool$1:hi", 
"IIndexedPool$1:hj", 
"MarkerType:hk", 
"SeriesVisualData:hl", 
"PrimitiveVisualDataList:hm", 
"IVisualData:hn", 
"PrimitiveVisualData:ho", 
"PrimitiveAppearanceData:hp", 
"BrushAppearanceData:hq", 
"StringBuilder:hr", 
"Environment:hs", 
"AppearanceHelper:ht", 
"LinearGradientBrushAppearanceData:hu", 
"GradientStopAppearanceData:hv", 
"SolidBrushAppearanceData:hw", 
"EllipseGeometryData:hx", 
"GeometryData:hy", 
"GetPointsSettings:hz", 
"RectangleGeometryData:h0", 
"LineGeometryData:h1", 
"PathGeometryData:h2", 
"PathFigureData:h3", 
"LineSegmentData:h4", 
"SegmentData:h5", 
"PolylineSegmentData:h6", 
"ArcSegmentData:h7", 
"PolyBezierSegmentData:h8", 
"LabelAppearanceData:h9", 
"ShapeTags:ia", 
"PointerTooltipVisualDataList:ib", 
"MarkerVisualDataList:ic", 
"MarkerVisualData:id", 
"PointerTooltipVisualData:ie", 
"RectangleVisualData:ig", 
"PolygonVisualData:ih", 
"PolyLineVisualData:ii", 
"IHasCategoryModePreference:ij", 
"IHasCategoryAxis:ik", 
"CategoryAxisBase:il", 
"Axis:im", 
"AxisView:io", 
"AxisLabelPanelBase:ip", 
"Panel:iq", 
"UIElementCollection:ir", 
"AxisLabelPanelBaseView:is", 
"AxisLabelSettings:it", 
"AxisLabelsLocation:iu", 
"PropertyUpdatedEventHandler:iv", 
"PropertyUpdatedEventArgs:iw", 
"PathRenderingInfo:ix", 
"NumericAxisBase:iy", 
"NumericAxisBaseView:iz", 
"NumericAxisRenderer:i0", 
"AxisRendererBase:i1", 
"ShouldRenderHandler:i2", 
"ScaleValueHandler:i3", 
"AxisRenderingParametersBase:i4", 
"RangeInfo:i5", 
"TickmarkValues:i6", 
"TickmarkValuesInitializationParameters:i7", 
"CategoryMode:i8", 
"Func$4:i9", 
"GetGroupCenterHandler:ja", 
"GetUnscaledGroupCenterHandler:jb", 
"RenderStripHandler:jc", 
"RenderLineHandler:jd", 
"ShouldRenderLinesHandler:je", 
"ShouldRenderContentHandler:jf", 
"RenderAxisLineHandler:jg", 
"DetermineCrossingValueHandler:jh", 
"ShouldRenderLabelHandler:ji", 
"GetLabelLocationHandler:jj", 
"LabelPosition:jk", 
"TransformToLabelValueHandler:jl", 
"AxisLabelManager:jm", 
"GetLabelForItemHandler:jn", 
"CreateRenderingParamsHandler:jo", 
"SnapMajorValueHandler:jp", 
"AdjustMajorValueHandler:jq", 
"CategoryAxisRenderingParameters:jr", 
"LogarithmicTickmarkValues:js", 
"LogarithmicNumericSnapper:jt", 
"Snapper:ju", 
"LinearTickmarkValues:jv", 
"LinearNumericSnapper:jw", 
"AxisRangeChangedEventArgs:jx", 
"AxisRange:jy", 
"IEquatable$1:jz", 
"AutoRangeCalculator:j0", 
"NumericYAxis:j1", 
"StraightNumericAxisBase:j2", 
"StraightNumericAxisBaseView:j3", 
"NumericScaler:j4", 
"ScalerParams:j5", 
"NumericScaleMode:j6", 
"LogarithmicScaler:j7", 
"IScaler:j8", 
"AxisOrientation:j9", 
"NumericYAxisView:ka", 
"VerticalAxisLabelPanel:kb", 
"VerticalAxisLabelPanelView:kc", 
"TitleSettings:kd", 
"NumericAxisRenderingParameters:ke", 
"VerticalLogarithmicScaler:kf", 
"VerticalLinearScaler:kg", 
"LinearScaler:kh", 
"NumericRadiusAxis:ki", 
"NumericRadiusAxisView:kj", 
"PolarAxisRenderingManager:kk", 
"ViewportUtils:kl", 
"PolarAxisRenderingParameters:km", 
"IPolarRadialRenderingParameters:kn", 
"RadialAxisRenderingParameters:ko", 
"RadialAxisLabelPanel:kp", 
"HorizontalAxisLabelPanelBase:kq", 
"HorizontalAxisLabelPanelBaseView:kr", 
"RadialAxisLabelPanelView:ks", 
"NumericAngleAxis:kt", 
"IAngleScaler:ku", 
"NumericAngleAxisView:kv", 
"AngleAxisLabelPanel:kw", 
"AngleAxisLabelPanelView:kx", 
"Extensions:ky", 
"CategoryAngleAxis:kz", 
"CategoryAngleAxisView:k0", 
"CategoryAxisBaseView:k1", 
"CategoryAxisRenderer:k2", 
"LinearCategorySnapper:k3", 
"IFastItemsSource:k4", 
"IFastItemColumn$1:k5", 
"IFastItemColumnPropertyName:k6", 
"CategoryTickmarkValues:k7", 
"AxisComponentsForView:k8", 
"AxisComponentsFromView:k9", 
"AxisFormatLabelHandler:la", 
"VisualExportHelper:lb", 
"Canvas:lc", 
"IFastItemsSourceProvider:ld", 
"AxisExtentType:le", 
"ContentInfo:lf", 
"SmartAxisLabelPanel:lg", 
"SmartAxisLabelPanelView:lh", 
"AxisRangeChangedEventHandler:li", 
"ChartContentManager:lj", 
"ChartContentType:lk", 
"SplineFragmentBase:ll", 
"SplineSeriesBase:lm", 
"SplineSeriesBaseView:ln", 
"AnchoredCategorySeriesView:lo", 
"CategorySeriesView:lp", 
"ISupportsMarkers:lq", 
"CategoryBucketCalculator:lr", 
"IBucketizer:ls", 
"ISortingAxis:lt", 
"CategoryFrame:lu", 
"Frame:lv", 
"BrushUtil:lw", 
"CategoryTrendLineManagerBase:lx", 
"TrendLineManagerBase$1:ly", 
"TrendLineType:lz", 
"Clipper:l0", 
"EdgeClipper:l1", 
"LeftClipper:l2", 
"BottomClipper:l3", 
"RightClipper:l4", 
"TopClipper:l5", 
"TrendResolutionParams:l6", 
"Flattener:l7", 
"Stack$1:l8", 
"ReverseArrayEnumerator$1:l9", 
"SpiralTodo:ma", 
"FastItemsSourceEventAction:mb", 
"IPreparesCategoryTrendline:mc", 
"SortingTrendLineManager:md", 
"TrendFitCalculator:me", 
"LeastSquaresFit:mf", 
"Numeric:mg", 
"TrendAverageCalculator:mh", 
"CategoryTrendLineManager:mi", 
"AnchoredCategoryBucketCalculator:mj", 
"CategoryDateTimeXAxis:mk", 
"CategoryDateTimeXAxisView:ml", 
"TimeAxisDisplayType:mm", 
"FastItemDateTimeColumn:mn", 
"IFastItemColumnInternal:mo", 
"FastItemColumn:mp", 
"FastReflectionHelper:mq", 
"HorizontalAxisLabelPanel:mr", 
"CoercionInfo:ms", 
"FastItemsSourceEventArgs:mt", 
"SortedListView$1:mu", 
"ArrayUtil:mv", 
"SplineType:mw", 
"CollisionAvoider:mx", 
"IDetectsCollisions:my", 
"SafeSortedReadOnlyDoubleCollection:mz", 
"SafeReadOnlyDoubleCollection:m0", 
"SafeEnumerable:m1", 
"StackedFragmentSeries:m2", 
"PenLineCap:m3", 
"StackedSeriesBase:m4", 
"IIsCategoryBased:m5", 
"ICategoryScaler:m6", 
"StackedSeriesView:m7", 
"StackedBucketCalculator:m8", 
"StackedSeriesManager:m9", 
"StackedSeriesCollection:na", 
"StackedLineSeries:nb", 
"HorizontalStackedSeriesBase:nc", 
"CategoryFramePreparerBase:nd", 
"FramePreparer:ne", 
"ISupportsErrorBars:nf", 
"DefaultSupportsMarkers:ng", 
"DefaultProvidesViewport:nh", 
"DefaultSupportsErrorBars:ni", 
"PreparationParams:nj", 
"CategoryYAxis:nk", 
"CategoryYAxisView:nl", 
"SyncSettings:nm", 
"NumericXAxis:nn", 
"NumericXAxisView:no", 
"HorizontalLogarithmicScaler:np", 
"HorizontalLinearScaler:nq", 
"ValuesHolder:nr", 
"LineSeries:ns", 
"LineSeriesView:nt", 
"UnknownValuePlotting:nu", 
"CategoryLineRasterizer:nv", 
"Action$5:nw", 
"PathVisualData:nx", 
"CategorySeriesRenderManager:ny", 
"AssigningCategoryStyleEventArgs:nz", 
"AssigningCategoryStyleEventArgsBase:n0", 
"GetCategoryItemsHandler:n1", 
"HighlightingInfo:n2", 
"HighlightingState:n3", 
"AssigningCategoryMarkerStyleEventArgs:n4", 
"HighlightingManager:n5", 
"AreaSeries:n6", 
"AreaSeriesView:n7", 
"LegendTemplates:n8", 
"PieChartBase:n9", 
"PieChartBaseView:oa", 
"PieChartViewManager:ob", 
"PieChartVisualData:oc", 
"PieSliceVisualDataList:od", 
"PieSliceVisualData:oe", 
"PieSliceDataContext:of", 
"Slice:og", 
"SliceView:oh", 
"PieLabel:oi", 
"MouseButtonEventArgs:oj", 
"FastItemsSource:ok", 
"ColumnReference:ol", 
"FastItemObjectColumn:om", 
"FastItemIntColumn:on", 
"LabelsPosition:oo", 
"LeaderLineType:op", 
"OthersCategoryType:oq", 
"IndexCollection:or", 
"LegendBase:os", 
"LegendBaseView:ot", 
"LegendBaseViewManager:ou", 
"GradientData:ov", 
"GradientStopData:ow", 
"DataChartLegendMouseButtonEventArgs:ox", 
"DataChartMouseButtonEventArgs:oy", 
"ChartLegendMouseEventArgs:oz", 
"ChartMouseEventArgs:o0", 
"DataChartLegendMouseButtonEventHandler:o1", 
"DataChartLegendMouseEventHandler:o2", 
"PieChartFormatLabelHandler:o3", 
"SliceClickEventHandler:o4", 
"SliceClickEventArgs:o5", 
"ItemLegend:o6", 
"ItemLegendView:o7", 
"LegendItemInfo:o8", 
"BubbleSeries:o9", 
"ScatterBase:pa", 
"ScatterBaseView:pb", 
"MarkerManagerBase:pc", 
"MarkerManagerBucket:pd", 
"ScatterTrendLineManager:pe", 
"NumericMarkerManager:pf", 
"OwnedPoint:pg", 
"CollisionAvoidanceType:ph", 
"SmartPlacer:pi", 
"ISmartPlaceable:pj", 
"SmartPosition:pk", 
"SmartPlaceableWrapper$1:pl", 
"ScatterAxisInfoCache:pm", 
"ScatterErrorBarSettings:pn", 
"ErrorBarSettingsBase:po", 
"EnableErrorBars:pp", 
"ErrorBarCalculatorReference:pq", 
"IErrorBarCalculator:pr", 
"ErrorBarCalculatorType:ps", 
"ScatterFrame:pt", 
"ScatterFrameBase$1:pu", 
"DictInterpolator$3:pv", 
"Action$6:pw", 
"SyncLink:px", 
"ChartCollection:py", 
"FastItemsSourceReference:pz", 
"SyncManager:p0", 
"SyncLinkManager:p1", 
"ErrorBarsHelper:p2", 
"BubbleSeriesView:p3", 
"BubbleMarkerManager:p4", 
"SizeScale:p5", 
"BrushScale:p6", 
"ScaleLegend:p7", 
"ScaleLegendView:p8", 
"CustomPaletteBrushScale:p9", 
"BrushSelectionMode:qa", 
"ValueBrushScale:qb", 
"RingSeriesBase:qc", 
"XamDoughnutChart:qd", 
"RingCollection:qe", 
"Ring:qf", 
"RingControl:qg", 
"RingControlView:qh", 
"Arc:qi", 
"ArcView:qj", 
"ArcItem:qk", 
"SliceItem:ql", 
"Legend:qm", 
"LegendView:qn", 
"BarSeries:qo", 
"VerticalAnchoredCategorySeries:qp", 
"IBarSeries:qq", 
"BarSeriesView:qr", 
"BarTrendLineManager:qs", 
"BarTrendFitCalculator:qt", 
"BarBucketCalculator:qu", 
"CategoryTransitionInMode:qv", 
"BarFramePreparer:qw", 
"CategoryFramePreparer:qx", 
"IHasCategoryTrendline:qy", 
"IHasTrendline:qz", 
"IHasSingleValueCategory:q0", 
"DefaultCategoryTrendlineHost:q1", 
"DefaultCategoryTrendlinePreparer:q2", 
"DefaultSingleValueProvider:q3", 
"SingleValuesHolder:q4", 
"RingSeriesBaseView:q5", 
"RingSeriesCollection:q6", 
"SliceCollection:q7", 
"XamDoughnutChartView:q8", 
"Action$2:q9", 
"DoughnutChartVisualData:ra", 
"RingSeriesVisualDataList:rb", 
"RingSeriesVisualData:rc", 
"RingVisualDataList:rd", 
"RingVisualData:re", 
"ArcVisualDataList:rf", 
"ArcVisualData:rg", 
"SliceVisualDataList:rh", 
"SliceVisualData:ri", 
"DoughnutChartLabelVisualData:rj", 
"HoleDimensionsChangedEventHandler:rk", 
"HoleDimensionsChangedEventArgs:rl", 
"FunnelSliceDataContext:rm", 
"XamFunnelChart:rn", 
"IItemProvider:ro", 
"Array:rv", 
"XamFunnelConnector:rw", 
"XamFunnelController:rx", 
"SliceInfoList:ry", 
"SliceInfoUnaryComparison:rz", 
"SliceInfo:r0", 
"SliceAppearance:r1", 
"PointList:r2", 
"FunnelSliceVisualData:r3", 
"Bezier:r4", 
"Array:r5", 
"BezierPoint:r6", 
"BezierOp:r7", 
"BezierPointComparison:r8", 
"DoubleColumn:r9", 
"ObjectColumn:sa", 
"XamFunnelView:sb", 
"IOuterLabelWidthDecider:sc", 
"IFunnelLabelSizeDecider:sd", 
"MouseButtonMessage:sh", 
"MouseButtonAction:si", 
"MouseButtonType:sj", 
"SetAreaSizeMessage:sk", 
"RenderSliceMessage:sm", 
"RenderOuterLabelMessage:sn", 
"TooltipValueChangedMessage:so", 
"TooltipUpdateMessage:sp", 
"FunnelDataContext:sq", 
"ClearTooltipMessage:su", 
"ViewPropertyChangedMessage:sx", 
"OuterLabelAlignment:sy", 
"FunnelSliceDisplay:sz", 
"SliceSelectionManager:s0", 
"DataUpdatedMessage:s1", 
"ItemsSourceAction:s2", 
"DictionaryEntry:s3", 
"FunnelFrame:s4", 
"UserSelectedItemsChangedMessage:s5", 
"LabelSizeChangedMessage:s6", 
"FrameRenderCompleteMessage:s7", 
"IntColumn:s8", 
"IntColumnComparison:s9", 
"Convert:ta", 
"SelectedItemsChangedMessage:tb", 
"ModelUpdateMessage:tc", 
"SliceClickedMessage:td", 
"FunnelSliceClickedEventHandler:te", 
"FunnelSliceClickedEventArgs:tf", 
"FunnelChartVisualData:tg", 
"FunnelSliceVisualDataList:th", 
"RingSeries:ti", 
"WaterfallSeries:tj", 
"WaterfallSeriesView:tk", 
"FinancialSeries:tl", 
"FinancialSeriesView:tm", 
"FinancialBucketCalculator:tn", 
"CategoryTransitionSourceFramePreparer:to", 
"TransitionInSpeedType:tp", 
"AssigningCategoryStyleEventHandler:tq", 
"FinancialValueList:tr", 
"FinancialEventHandler:ts", 
"FinancialEventArgs:tt", 
"FinancialCalculationDataSource:tu", 
"CalculatedColumn:tv", 
"FinancialCalculationSupportingCalculations:tw", 
"ColumnSupportingCalculation:tx", 
"SupportingCalculation$1:ty", 
"SupportingCalculationStrategy:tz", 
"DataSourceSupportingCalculation:t0", 
"ProvideColumnValuesStrategy:t1", 
"StepLineSeries:t2", 
"StepLineSeriesView:t3", 
"StepAreaSeries:t4", 
"StepAreaSeriesView:t5", 
"RangeAreaSeries:t6", 
"HorizontalRangeCategorySeries:t7", 
"RangeCategorySeries:t8", 
"IHasHighLowValueCategory:t9", 
"RangeCategorySeriesView:ua", 
"RangeCategoryBucketCalculator:ub", 
"RangeCategoryFramePreparer:uc", 
"DefaultHighLowValueProvider:ud", 
"HighLowValuesHolder:ue", 
"CategoryMarkerManager:uf", 
"RangeValueList:ug", 
"RangeAreaSeriesView:uh", 
"LineFragment:ui", 
"LineFragmentView:uj", 
"LineFragmentBucketCalculator:uk", 
"IStacked100Series:ul", 
"AreaFragment:um", 
"AreaFragmentView:un", 
"AreaFragmentBucketCalculator:uo", 
"StackedColumnSeries:up", 
"StackedColumnSeriesView:uq", 
"StackedColumnBucketCalculator:ur", 
"ColumnFragment:us", 
"ColumnFragmentView:ut", 
"StackedBarSeries:uu", 
"VerticalStackedSeriesBase:uv", 
"StackedBarSeriesView:uw", 
"StackedBarBucketCalculator:ux", 
"BarFragment:uy", 
"StackedAreaSeries:uz", 
"StackedSplineSeries:u0", 
"SplineFragment:u1", 
"SplineFragmentView:u2", 
"SplineFragmentBucketCalculator:u3", 
"StackedSplineAreaSeries:u4", 
"SplineAreaFragment:u5", 
"SplineAreaFragmentView:u6", 
"StackedSeriesFramePreparer:u7", 
"StackedSeriesCreatedEventHandler:u8", 
"StackedSeriesCreatedEventArgs:u9", 
"StackedSeriesVisualData:va", 
"SeriesVisualDataList:vb", 
"RenderRequestedEventArgs:vc", 
"ChartTitleVisualData:vd", 
"VisualDataSerializer:ve", 
"AxisVisualData:vf", 
"AxisLabelVisualDataList:vg", 
"AxisLabelVisualData:vh", 
"AssigningCategoryMarkerStyleEventHandler:vi", 
"SeriesComponentsForView:vj", 
"DataChartAxisRangeChangedEventHandler:vk", 
"ChartAxisRangeChangedEventArgs:vl", 
"ChartVisualData:vm", 
"AxisVisualDataList:vn", 
"RadialBase:vo", 
"RadialBaseView:vp", 
"RadialBucketCalculator:vq", 
"SeriesRenderer$2:vr", 
"SeriesRenderingArguments:vs", 
"RadialFrame:vt", 
"RadialAxes:vu", 
"PolarBase:vv", 
"PolarBaseView:vw", 
"PolarTrendLineManager:vx", 
"PolarLinePlanner:vy", 
"AngleRadiusPair:vz", 
"PolarAxisInfoCache:v0", 
"PolarFrame:v1", 
"PolarAxes:v2", 
"SeriesComponentsFromView:v3", 
"EasingFunctions:v4", 
"TrendCalculators:v5", 
"SeriesViewerComponentsFromView:v6", 
"SeriesViewerSurfaceViewer:v7", 
"LabelPanelArranger:v8", 
"LabelPanelsArrangeState:v9", 
"WindowResponse:wa", 
"SeriesViewerComponentsForView:wb", 
"DataChartCursorEventHandler:wc", 
"ChartCursorEventArgs:wd", 
"DataChartMouseButtonEventHandler:we", 
"DataChartMouseEventHandler:wf", 
"AnnotationLayer:wg", 
"AnnotationLayerView:wh", 
"RefreshCompletedEventHandler:wi", 
"CategoryXAxis:xb", 
"CategoryXAxisView:xc", 
"IndicatorDisplayType:xs", 
"AbsoluteVolumeOscillatorIndicator:xt", 
"StrategyBasedIndicator:xu", 
"FinancialIndicator:xv", 
"FinancialIndicatorView:xw", 
"FinancialIndicatorBucketCalculator:xx", 
"IndicatorRenderer:xy", 
"PathFigureUtil:xz", 
"IndicatorCalculationStrategy:x0", 
"AbsoluteVolumeOscillatorIndicatorStrategy:x1", 
"AccumulationDistributionIndicator:x2", 
"AccumulationDistributionIndicatorStrategy:x3", 
"StreamingIndicatorCalculationStrategy:x4", 
"AverageDirectionalIndexIndicator:x5", 
"AverageDirectionalIndexIndicatorStrategy:x6", 
"AverageTrueRangeIndicator:x7", 
"AverageTrueRangeIndicatorStrategy:x8", 
"BollingerBandsOverlay:x9", 
"FinancialOverlay:ya", 
"BollingerBandsOverlayView:yb", 
"BollingerBandsBucketCalculator:yc", 
"BollingerBandWidthIndicator:yd", 
"BollingerBandWidthIndicatorStrategy:ye", 
"ChaikinOscillatorIndicator:yf", 
"ChaikinOscillatorIndicatorStrategy:yg", 
"ChaikinVolatilityIndicator:yh", 
"ChaikinVolatilityIndicatorStrategy:yi", 
"CommodityChannelIndexIndicator:yj", 
"CommodityChannelIndexIndicatorStrategy:yk", 
"CustomIndicator:yl", 
"CustomIndicatorStrategy:ym", 
"PriceChannelOverlayView:yn", 
"PriceChannelOverlay:yo", 
"PriceChannelBucketCalculator:yp", 
"DetrendedPriceOscillatorIndicator:yq", 
"DetrendedPriceOscillatorIndicatorStrategy:yr", 
"EaseOfMovementIndicator:ys", 
"EaseOfMovementIndicatorStrategy:yt", 
"FastStochasticOscillatorIndicator:yu", 
"FastStochasticOscillatorIndicatorStrategy:yv", 
"PercentKCalculationStrategy:yw", 
"ForceIndexIndicator:yx", 
"ForceIndexIndicatorStrategy:yy", 
"FullStochasticOscillatorIndicator:yz", 
"FullStochasticOscillatorIndicatorStrategy:y0", 
"ItemwiseIndicatorCalculationStrategy:y1", 
"ItemwiseStrategyBasedIndicator:y2", 
"ItemwiseStrategyCalculationStrategy:y3", 
"MarketFacilitationIndexIndicator:y4", 
"MarketFacilitationIndexIndicatorStrategy:y5", 
"MassIndexIndicator:y6", 
"MassIndexIndicatorStrategy:y7", 
"MedianPriceIndicator:y8", 
"MedianPriceIndicatorStrategy:y9", 
"MoneyFlowIndexIndicator:za", 
"MoneyFlowIndexIndicatorStrategy:zb", 
"MovingAverageConvergenceDivergenceIndicator:zc", 
"MovingAverageConvergenceDivergenceIndicatorStrategy:zd", 
"NegativeVolumeIndexIndicator:ze", 
"NegativeVolumeIndexIndicatorStrategy:zf", 
"OnBalanceVolumeIndicator:zg", 
"OnBalanceVolumeIndicatorStrategy:zh", 
"PercentagePriceOscillatorIndicator:zi", 
"PercentagePriceOscillatorIndicatorStrategy:zj", 
"PercentageVolumeOscillatorIndicator:zk", 
"PercentageVolumeOscillatorIndicatorStrategy:zl", 
"PositiveVolumeIndexIndicator:zm", 
"PositiveVolumeIndexIndicatorStrategy:zn", 
"PriceVolumeTrendIndicator:zo", 
"PriceVolumeTrendIndicatorStrategy:zp", 
"RateOfChangeAndMomentumIndicator:zq", 
"RateOfChangeAndMomentumIndicatorStrategy:zr", 
"RelativeStrengthIndexIndicator:zs", 
"RelativeStrengthIndexIndicatorStrategy:zt", 
"SlowStochasticOscillatorIndicator:zu", 
"SlowStochasticOscillatorIndicatorStrategy:zv", 
"StandardDeviationIndicator:zw", 
"StandardDeviationIndicatorStrategy:zx", 
"StochRSIIndicator:zy", 
"StochRSIIndicatorStrategy:zz", 
"TRIXIndicator:z0", 
"TRIXIndicatorStrategy:z1", 
"TypicalPriceIndicator:z2", 
"TypicalPriceIndicatorStrategy:z3", 
"UltimateOscillatorIndicator:z4", 
"UltimateOscillatorIndicatorCalculationStrategy:z5", 
"WeightedCloseIndicator:z6", 
"WeightedCloseIndicatorStrategy:z7", 
"WilliamsPercentRIndicator:z8", 
"WilliamsPercentRIndicatorStrategy:z9", 
"PriceDisplayType:aa7", 
"FinancialPriceSeries:aa9", 
"FinancialPriceSeriesView:aba", 
"FinancialPriceBucketCalculator:abb", 
"AbstractEnumerable:acd", 
"AbstractEnumerator:ace", 
"GenericEnumerable$1:acf", 
"GenericEnumerator$1:acg"]);







$.ig.util.defType('PriceDisplayType', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "Candlestick";
			case 1: return "OHLC";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('PriceDisplayType', $.ig.Enum.prototype.$type)
}, true);















$.ig.util.defType('TimeAxisDisplayType', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "Continuous";
			case 1: return "Discrete";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('TimeAxisDisplayType', $.ig.Enum.prototype.$type)
}, true);


$.ig.util.defType('IndicatorDisplayType', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "Line";
			case 1: return "Area";
			case 2: return "Column";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('IndicatorDisplayType', $.ig.Enum.prototype.$type)
}, true);


$.ig.util.defType('CategoryTransitionInMode', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "Auto";
			case 1: return "FromZero";
			case 2: return "SweepFromLeft";
			case 3: return "SweepFromRight";
			case 4: return "SweepFromTop";
			case 5: return "SweepFromBottom";
			case 6: return "SweepFromCenter";
			case 7: return "AccordionFromLeft";
			case 8: return "AccordionFromRight";
			case 9: return "AccordionFromTop";
			case 10: return "AccordionFromBottom";
			case 11: return "Expand";
			case 12: return "SweepFromCategoryAxisMinimum";
			case 13: return "SweepFromCategoryAxisMaximum";
			case 14: return "SweepFromValueAxisMinimum";
			case 15: return "SweepFromValueAxisMaximum";
			case 16: return "AccordionFromCategoryAxisMinimum";
			case 17: return "AccordionFromCategoryAxisMaximum";
			case 18: return "AccordionFromValueAxisMinimum";
			case 19: return "AccordionFromValueAxisMaximum";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('CategoryTransitionInMode', $.ig.Enum.prototype.$type)
}, true);


$.ig.util.defType('NumericScaleMode', 'Enum', {
	init: function (v) {
		this._v = v;
	}, 
	getName: function (v) {
		switch (v) {
			case 0: return "Linear";
			case 1: return "Logarithmic";
			default: return v.toString();
		}
	}, 
	value: function () {
		return this._v;
	}, 
	$type: new $.ig.Type('NumericScaleMode', $.ig.Enum.prototype.$type)
}, true);

















$.ig.util.defType('Frame', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	interpolate3: function (p, min, max) {}

	, 
	interpolate: function (ret, p, min, max) {
		var minCount = min.count();
		var maxCount = max.count();
		var count = Math.max(minCount, maxCount);
		var q = 1 - p;
		if (ret.count() < count) {
			ret.insertRange(ret.count(), new Array(count - ret.count()));
		}

		if (ret.count() > count) {
			ret.removeRange(count, ret.count() - count);
		}

		for (var i = 0; i < Math.min(minCount, maxCount); ++i) {
			ret.__inner[i] = {__x: min.__inner[i].__x * q + max.__inner[i].__x * p, __y: min.__inner[i].__y * q + max.__inner[i].__y * p, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		}

		if (minCount < maxCount) {
			var mn = minCount > 0 ? min.__inner[minCount - 1] : {__x: 0, __y: 0, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			for (var i1 = minCount; i1 < maxCount; ++i1) {
				ret.__inner[i1] = {__x: mn.__x * q + max.__inner[i1].__x * p, __y: mn.__y * q + max.__inner[i1].__y * p, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			}

		}

		if (minCount > maxCount) {
			var mx = maxCount > 0 ? max.__inner[maxCount - 1] : {__x: 0, __y: 0, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			for (var i2 = maxCount; i2 < minCount; ++i2) {
				ret.__inner[i2] = {__x: min.__inner[i2].__x * q + mx.__x * p, __y: min.__inner[i2].__y * q + mx.__y * p, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			}

		}

	}

	, 
	interpolateWithSpeed: function (ret, p, min, max, speedModifiers) {
		var minCount = min.count();
		var maxCount = max.count();
		var count = Math.max(minCount, maxCount);
		var q = 1 - p;
		if (ret.count() < count) {
			ret.insertRange(ret.count(), new Array(count - ret.count()));
		}

		if (ret.count() > count) {
			ret.removeRange(count, ret.count() - count);
		}

		var speed;
		var speedq;
		for (var i = 0; i < Math.min(minCount, maxCount); ++i) {
			speed = p * speedModifiers.__inner[i];
			speed = speed > 1 ? 1 : speed;
			speedq = 1 - speed;
			ret.__inner[i] = {__x: min.__inner[i].__x * speedq + max.__inner[i].__x * speed, __y: min.__inner[i].__y * speedq + max.__inner[i].__y * speed, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
		}

		if (minCount < maxCount) {
			var mn = minCount > 0 ? min.__inner[minCount - 1] : {__x: 0, __y: 0, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			for (var i1 = minCount; i1 < maxCount; ++i1) {
				speed = p * speedModifiers.__inner[i1];
				speed = speed > 1 ? 1 : speed;
				speedq = 1 - speed;
				ret.__inner[i1] = {__x: mn.__x * speedq + max.__inner[i1].__x * speed, __y: mn.__y * speedq + max.__inner[i1].__y * speed, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			}

		}

		if (minCount > maxCount) {
			var mx = maxCount > 0 ? max.__inner[maxCount - 1] : {__x: 0, __y: 0, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			for (var i2 = maxCount; i2 < minCount; ++i2) {
				speed = p * speedModifiers.__inner[i2];
				speed = speed > 1 ? 1 : speed;
				speedq = 1 - speed;
				ret.__inner[i2] = {__x: min.__inner[i2].__x * speedq + mx.__x * speed, __y: min.__inner[i2].__y * speedq + mx.__y * speed, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			}

		}

	}

	, 
	interpolate1: function (ret, p, min, max) {
		var minCount = min.count();
		var maxCount = max.count();
		var count = Math.max(minCount, maxCount);
		var q = 1 - p;
		if (ret.count() < count) {
			var newVals = new Array(count - ret.count());
			for (var i = 0; i < count - ret.count(); i++) {
				newVals[i] = 0;
			}

			ret.insertRange(ret.count(), newVals);
		}

		if (ret.count() > count) {
			ret.removeRange(count, ret.count() - count);
		}

		for (var i1 = 0; i1 < Math.min(minCount, maxCount); ++i1) {
			ret.__inner[i1] = min.__inner[i1] * q + max.__inner[i1] * p;
		}

		if (minCount < maxCount) {
			var mn = minCount > 0 ? min.__inner[minCount - 1] : 0;
			for (var i2 = minCount; i2 < maxCount; ++i2) {
				ret.__inner[i2] = mn * q + max.__inner[i2] * p;
			}

		}

		if (minCount > maxCount) {
			var mx = maxCount > 0 ? max.__inner[maxCount - 1] : 0;
			for (var i3 = maxCount; i3 < minCount; ++i3) {
				ret.__inner[i3] = min.__inner[i3] * q + mx * p;
			}

		}

	}

	, 
	interpolateWithSpeed1: function (ret, p, min, max, speedModifiers) {
		var minCount = min.count();
		var maxCount = max.count();
		var count = Math.max(minCount, maxCount);
		var q = 1 - p;
		if (ret.count() < count) {
			var newVals = new Array(count - ret.count());
			for (var i = 0; i < count - ret.count(); i++) {
				newVals[i] = 0;
			}

			ret.insertRange(ret.count(), newVals);
		}

		if (ret.count() > count) {
			ret.removeRange(count, ret.count() - count);
		}

		var speed;
		var speedq;
		for (var i1 = 0; i1 < Math.min(minCount, maxCount); ++i1) {
			speed = p * speedModifiers.__inner[i1];
			speed = speed > 1 ? 1 : speed;
			speedq = 1 - speed;
			ret.__inner[i1] = min.__inner[i1] * speedq + max.__inner[i1] * speed;
		}

		if (minCount < maxCount) {
			var mn = minCount > 0 ? min.__inner[minCount - 1] : 0;
			for (var i2 = minCount; i2 < maxCount; ++i2) {
				speed = p * speedModifiers.__inner[i2];
				speed = speed > 1 ? 1 : speed;
				speedq = 1 - speed;
				ret.__inner[i2] = mn * speedq + max.__inner[i2] * speed;
			}

		}

		if (minCount > maxCount) {
			var mx = maxCount > 0 ? max.__inner[maxCount - 1] : 0;
			for (var i3 = maxCount; i3 < minCount; ++i3) {
				speed = p * speedModifiers.__inner[i3];
				speed = speed > 1 ? 1 : speed;
				speedq = 1 - speed;
				ret.__inner[i3] = min.__inner[i3] * speedq + mx * speed;
			}

		}

	}

	, 
	interpolateBrushes: function (p, minBrush, maxBrush, InterpolationMode) {
		var b = $.ig.BrushUtil.prototype.getInterpolation(minBrush, p, maxBrush, InterpolationMode);
		return b;
	}

	, 
	interpolate2: function (ret, p, min, max, interpolationMode) {
		var $self = this;
		var minCount = min.count();
		var maxCount = max.count();
		var count = Math.max(minCount, maxCount);
		var transparentBrush = (function () { var $ret = new $.ig.Brush();
		$ret.fill("transparent"); return $ret;}());
		var q = 1 - p;
		if (ret.count() < count) {
			var newVals = new Array(count - ret.count());
			for (var i = 0; i < count - ret.count(); i++) {
				newVals[i] = new $.ig.Brush();
			}

			ret.insertRange(ret.count(), newVals);
		}

		if (ret.count() > count) {
			ret.removeRange(count, ret.count() - count);
		}

		for (var i1 = 0; i1 < Math.min(minCount, maxCount); ++i1) {
			ret.__inner[i1] = $.ig.Frame.prototype.interpolateBrushes(p, min.__inner[i1], max.__inner[i1], interpolationMode);
		}

		if (minCount < maxCount) {
			var mn = minCount > 0 ? min.__inner[minCount - 1] : transparentBrush;
			for (var i2 = minCount; i2 < maxCount; ++i2) {
				ret.__inner[i2] = $.ig.Frame.prototype.interpolateBrushes(p, mn, max.__inner[i2], interpolationMode);
			}

		}

		if (minCount > maxCount) {
			var mx = maxCount > 0 ? max.__inner[maxCount - 1] : transparentBrush;
			for (var i3 = maxCount; i3 < minCount; ++i3) {
				ret.__inner[i3] = $.ig.Frame.prototype.interpolateBrushes(p, min.__inner[i3], mx, interpolationMode);
			}

		}

	}
	, 
	$type: new $.ig.Type('Frame', $.ig.Object.prototype.$type)
}, true);



























$.ig.util.defType('AutoRangeCalculator', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	getAxisWidth: function (target) {
		return target.viewportRect().width();
	}

	, 
	getAxisHeight: function (target) {
		return target.viewportRect().height();
	}

	, 
	calculateRange: function (target, userMinimum, userMaximum, isLogarithmic, logarithmBase, minimumValue, maximumValue) {
		minimumValue = !$.ig.util.isNaN(userMinimum) && !Number.isInfinity(userMinimum) ? userMinimum : Number.POSITIVE_INFINITY;
		maximumValue = !$.ig.util.isNaN(userMaximum) && !Number.isInfinity(userMaximum) ? userMaximum : Number.NEGATIVE_INFINITY;
		var min = minimumValue;
		var max = maximumValue;
		if (Number.isInfinity(min) || Number.isInfinity(max)) {
			if (target != null) {
				var axisRange = target.getAxisRange();
				if (axisRange != null) {
					min = Math.min(min, axisRange.minimum());
					max = Math.max(max, axisRange.maximum());
				}

			}

		}

		if (!Number.isInfinity(min) && !Number.isInfinity(max)) {
			if (min == max && min != 0) {
				min *= min > 0 ? 0.9 : 1.1;
				max *= max > 0 ? 1.1 : 0.9;
			}

			if (min == max && min == 0) {
				max = 1;
			}

			if (userMinimum > userMaximum) {
				var temp = userMaximum;
				userMaximum = userMinimum;
				userMinimum = temp;
			}

			var actualMinimum = $.ig.util.isNaN(userMinimum) || Number.isInfinity(userMinimum) ? min : userMinimum;
			var actualMaximum = $.ig.util.isNaN(userMaximum) || Number.isInfinity(userMaximum) ? max : userMaximum;
			if (isLogarithmic) {
				if (actualMinimum <= 0) {
					if (actualMaximum > 1) {
						actualMinimum = 1;

					} else {
						actualMinimum = Math.pow(logarithmBase, Math.floor(Math.logBase(actualMaximum, logarithmBase)));
					}

				}

				if ($.ig.util.isNaN(userMinimum) || Number.isInfinity(userMinimum)) {
					min = Math.pow(logarithmBase, Math.floor(Math.logBase(actualMinimum, logarithmBase)));

				} else {
					min = actualMinimum;
				}

				if ($.ig.util.isNaN(userMaximum) || Number.isInfinity(userMaximum)) {
					max = Math.pow(logarithmBase, Math.ceil(Math.logBase(actualMaximum, logarithmBase)));

				} else {
					max = actualMaximum;
				}


			} else {
				var n = Math.pow(10, Math.floor(Math.log10(actualMaximum - actualMinimum)) - 1);
				var axisResolution = $.ig.AutoRangeCalculator.prototype.getAxisWidth(target);
				if ($.ig.util.cast($.ig.NumericYAxis.prototype.$type, target) !== null) {
					axisResolution = $.ig.AutoRangeCalculator.prototype.getAxisHeight(target);
				}

				if ($.ig.util.cast($.ig.NumericRadiusAxis.prototype.$type, target) !== null && axisResolution > 0) {
					var radiusExtentScale = (target).actualRadiusExtentScale();
					var innerRadiusExtentScale = (target).actualInnerRadiusExtentScale();
					axisResolution = Math.min($.ig.AutoRangeCalculator.prototype.getAxisWidth(target), $.ig.AutoRangeCalculator.prototype.getAxisHeight(target)) * (radiusExtentScale - innerRadiusExtentScale) / 2;
					axisResolution = Math.max(axisResolution, 14);
				}

				if (target != null && axisResolution > 0 && (!target.hasUserMinimum() && !target.hasUserMaximum())) {
					var snapper = new $.ig.LinearNumericSnapper(0, min, max, axisResolution);
					n = snapper.interval();
				}

				if (($.ig.util.isNaN(userMinimum) || Number.isInfinity(userMinimum)) && !$.ig.util.isNaN(min) && !$.ig.util.isNaN(n) && n != 0) {
						min = n * Math.floor(min / n);


				} else {
					min = actualMinimum;
				}

				if (($.ig.util.isNaN(userMaximum) || Number.isInfinity(userMaximum)) && !$.ig.util.isNaN(max) && !$.ig.util.isNaN(n) && n != 0) {
					var ceilingOfQuotient = Math.ceil(max / n);
						max = n * ceilingOfQuotient;


				} else {
					max = actualMaximum;
				}

			}

		}

		minimumValue = min;
		maximumValue = max;
		return {
			p5: minimumValue, 
			p6: maximumValue
		};
	}
	, 
	$type: new $.ig.Type('AutoRangeCalculator', $.ig.Object.prototype.$type)
}, true);







$.ig.util.defType('AxisLabelManager', 'Object', {

	_labelDataContext: null,
	labelDataContext: function (value) {
		if (arguments.length === 1) {
			this._labelDataContext = value;
			return value;
		} else {
			return this._labelDataContext;
		}
	}

	, 
	_labelPositions: null,
	labelPositions: function (value) {
		if (arguments.length === 1) {
			this._labelPositions = value;
			return value;
		} else {
			return this._labelPositions;
		}
	}

	, 
	_targetPanel: null,
	targetPanel: function (value) {
		if (arguments.length === 1) {
			this._targetPanel = value;
			return value;
		} else {
			return this._targetPanel;
		}
	}

	, 
	_axis: null,
	axis: function (value) {
		if (arguments.length === 1) {
			this._axis = value;
			return value;
		} else {
			return this._axis;
		}
	}

	, 
	_floatPanelAction: null,
	floatPanelAction: function (value) {
		if (arguments.length === 1) {
			this._floatPanelAction = value;
			return value;
		} else {
			return this._floatPanelAction;
		}
	}
	, 
	init: function () {



		var $self = this;
		$.ig.Object.prototype.init.call(this);
			this.floatPanelAction(function (crossing) {
			});
	}

	, 
	clear: function (windowRect, viewportRect) {
		this.labelDataContext().clear();
		this.labelPositions().clear();
		this.targetPanel().axis(this.axis());
		this.targetPanel().windowRect(windowRect);
		this.targetPanel().viewportRect(viewportRect);
		if (viewportRect.isEmpty() || windowRect.isEmpty()) {
			this.setTextBlockCount(0);
		}

		if (this.axis().textBlocks().count() == 0) {
			this.targetPanel().children().clear();
		}

	}

	, 
	addLabelObject: function (labelObject, position) {
		this.labelDataContext().add1(labelObject);
		this.labelPositions().add(position);
	}

	, 
	updateLabelPanel: function () {
		this.targetPanel().labelDataContext(this.labelDataContext());
		this.targetPanel().labelPositions(this.labelPositions());
	}

	, 
	bindLabel: function (label) {
	}

	, 
	bindTitleLabel: function (label) {
	}

	, 
	addLabel: function (label) {
		this.targetPanel().children().add(label);
	}

	, 
	setLabelInterval: function (p) {
		this.targetPanel().interval(p);
	}

	, 
	floatPanel: function (crossingValue) {
		this.floatPanelAction()(crossingValue);
	}

	, 
	getTextBlock: function (i) {
		var tb = this.axis().textBlocks().item(i);
		return tb;
	}

	, 
	setTextBlockCount: function (p) {
		if (this.axis() == null) {
			return;
		}

		this.axis().textBlocks().count(p);
	}

	, 
	labelsHidden: function () {

			if (this.axis() == null || this.axis().labelSettings() == null) {
				return false;
			}

			return this.axis().labelSettings().visibility() != $.ig.Visibility.prototype.visible;
	}

	, 
	resetLabels: function () {
		this.axis().textBlocks().count(0);
		this.axis().labelPanel().textBlocks().clear();
	}
	, 
	$type: new $.ig.Type('AxisLabelManager', $.ig.Object.prototype.$type)
}, true);





$.ig.util.defType('Snapper', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	expt: function (a, n) {
		var x = 1;
		if (n > 0) {
			for (; n > 0; --n) {
				x *= a;
			}


		} else {
			for (; n < 0; ++n) {
				x /= a;
			}

		}

		return x;
	}

	, 
	nicenum: function (x, round) {
		var exp = $.ig.truncate(Math.floor(Math.log10(x)));
		var f = x / Math.pow(10, exp);
		if (round) {
			var nf = f < 1.5 ? 1 : f < 3 ? 2 : f < 7 ? 5 : 10;
			return nf * Math.pow(10, exp);

		} else {
			var nf1 = f <= 1 ? 1 : f <= 2 ? 2 : f <= 5 ? 5 : 10;
			return nf1 * Math.pow(10, exp);
		}

	}

	, 
	nicenum1: function (span, round) {
		var niceSpan = $.ig.Date.prototype.zero;
		if (span.totalDays() > 1) {
			niceSpan = $.ig.Date.prototype.fromDays(Math.ceil(span.totalDays()));

		} else if (span.totalHours() > 1) {
			niceSpan = $.ig.Date.prototype.fromHours(Math.ceil(span.totalHours()));

		} else if (span.totalMinutes() > 1) {
			niceSpan = $.ig.Date.prototype.fromMinutes(Math.ceil(span.totalMinutes()));

		} else if (span.totalSeconds() > 1) {
			niceSpan = $.ig.Date.prototype.fromSeconds(Math.ceil(span.totalSeconds()));

		} else if (span.totalMilliseconds() > 1) {
			niceSpan = $.ig.Date.prototype.fromMilliseconds(Math.ceil(span.totalMilliseconds()));
		}





		return niceSpan;
	}
	, 
	$type: new $.ig.Type('Snapper', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('LinearNumericSnapper', 'Snapper', {
	init: function (initNumber, visibleMinimum, visibleMaximum, pixels) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.Snapper.prototype.init.call(this);
			this.initialize(visibleMinimum, visibleMaximum, pixels, 10);
	}
	, 
	init1: function (initNumber, visibleMinimum, visibleMaximum, pixels, minTicks) {


		$.ig.Snapper.prototype.init.call(this);
			this.initialize(visibleMinimum, visibleMaximum, pixels, minTicks);
	}

	, 
	initialize: function (visibleMinimum, visibleMaximum, pixels, minTicks) {
		this.interval(NaN);
		this.precision(0);
		this.minorCount(0);
		var ticks = Math.min(minTicks, $.ig.truncate((pixels / $.ig.Snapper.prototype.resolution)));
		if (ticks > 0) {
			var range = $.ig.Snapper.prototype.nicenum(visibleMaximum - visibleMinimum, false);
			this.interval($.ig.Snapper.prototype.nicenum(range / (ticks - 1), true));
			var graphmin = Math.floor(visibleMinimum / this.interval()) * this.interval();
			var graphmax = Math.ceil(visibleMaximum / this.interval()) * this.interval();
			ticks = $.ig.truncate(Math.round((graphmax - graphmin) / this.interval()));
			if (pixels / ticks > $.ig.Snapper.prototype.resolution * 10) {
				this.minorCount(10);

			} else {
				if (pixels / ticks > $.ig.Snapper.prototype.resolution * 5) {
					this.minorCount(5);

				} else {
					if (pixels / ticks > $.ig.Snapper.prototype.resolution * 2) {
						this.minorCount(2);
					}

				}

			}

			this.precision(Math.max(-$.ig.truncate(Math.floor(Math.log10(this.interval()))), 0));
		}

	}

	, 
	_interval: 0,
	interval: function (value) {
		if (arguments.length === 1) {
			this._interval = value;
			return value;
		} else {
			return this._interval;
		}
	}

	, 
	_precision: 0,
	precision: function (value) {
		if (arguments.length === 1) {
			this._precision = value;
			return value;
		} else {
			return this._precision;
		}
	}

	, 
	_minorCount: 0,
	minorCount: function (value) {
		if (arguments.length === 1) {
			this._minorCount = value;
			return value;
		} else {
			return this._minorCount;
		}
	}
	, 
	$type: new $.ig.Type('LinearNumericSnapper', $.ig.Snapper.prototype.$type)
}, true);

$.ig.util.defType('LogarithmicNumericSnapper', 'Snapper', {
	init: function (visibleMinimum, visibleMaximum, logarithmBase, pixels) {



		$.ig.Snapper.prototype.init.call(this);
			this.interval(1);
			this.minorCount(logarithmBase);
	}

	, 
	_interval: 0,
	interval: function (value) {
		if (arguments.length === 1) {
			this._interval = value;
			return value;
		} else {
			return this._interval;
		}
	}

	, 
	_minorCount: 0,
	minorCount: function (value) {
		if (arguments.length === 1) {
			this._minorCount = value;
			return value;
		} else {
			return this._minorCount;
		}
	}
	, 
	$type: new $.ig.Type('LogarithmicNumericSnapper', $.ig.Snapper.prototype.$type)
}, true);

$.ig.util.defType('LinearCategorySnapper', 'Snapper', {
	init: function (initNumber, visibleMinimum, visibleMaximum, pixels) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.LinearCategorySnapper.prototype.init1.call(this, 1, visibleMinimum, visibleMaximum, pixels, NaN, $.ig.CategoryMode.prototype.mode0);
	}
	, 
	init1: function (initNumber, visibleMinimum, visibleMaximum, pixels, interval, categoryMode) {


		$.ig.Snapper.prototype.init.call(this);
			this.interval(interval);
			this.minorCount(0);
			var ticks = Math.min(10, $.ig.truncate((pixels / $.ig.Snapper.prototype.resolution)));
			if (ticks > 0) {
				var range = $.ig.Snapper.prototype.nicenum(visibleMaximum - visibleMinimum, false);
				if ($.ig.util.isNaN(this.interval())) {
					this.interval($.ig.Snapper.prototype.nicenum(range / (ticks - 1), true));
				}

				if (this.interval() < 1) {
					this.interval(1);
				}

				var graphmin = Math.floor(visibleMinimum / this.interval()) * this.interval();
				var graphmax = Math.ceil(visibleMaximum / this.interval()) * this.interval();
				ticks = $.ig.truncate(Math.round((graphmax - graphmin) / this.interval()));
				if (pixels / ticks > $.ig.Snapper.prototype.resolution * 10) {
					this.minorCount(10);

				} else {
					if (pixels / ticks > $.ig.Snapper.prototype.resolution * 5) {
						this.minorCount(5);

					} else {
						if (pixels / ticks > $.ig.Snapper.prototype.resolution * 2) {
							this.minorCount(2);
						}

					}

				}

			}

	}

	, 
	_interval: 0,
	interval: function (value) {
		if (arguments.length === 1) {
			this._interval = value;
			return value;
		} else {
			return this._interval;
		}
	}

	, 
	_minorCount: 0,
	minorCount: function (value) {
		if (arguments.length === 1) {
			this._minorCount = value;
			return value;
		} else {
			return this._minorCount;
		}
	}
	, 
	$type: new $.ig.Type('LinearCategorySnapper', $.ig.Snapper.prototype.$type)
}, true);


$.ig.util.defType('IScaler', 'Object', {
	$type: new $.ig.Type('IScaler', null)
}, true);

$.ig.util.defType('ICategoryScaler', 'Object', {
	$type: new $.ig.Type('ICategoryScaler', null, [$.ig.IScaler.prototype.$type])
}, true);

$.ig.util.defType('CategoryAxisBase', 'Axis', {

	createView: function () {
		return new $.ig.CategoryAxisBaseView(this);
	}

	, 
	onViewCreated: function (view) {
		$.ig.Axis.prototype.onViewCreated.call(this, view);
		this.categoryView(view);
	}

	, 
	_categoryView: null,
	categoryView: function (value) {
		if (arguments.length === 1) {
			this._categoryView = value;
			return value;
		} else {
			return this._categoryView;
		}
	}
	, 
	init: function () {


		this.__itemsCount = 0;
		this._cachedItemsCount = 0;
		this._mode2GroupCount = 0;
		this.__spreading = false;

		$.ig.Axis.prototype.init.call(this);
			this.majorLinePositions(new $.ig.List$1(Number, 0));
	}

	, 
	validateAxis: function (viewportRect, windowRect, view) {
		var isValid = $.ig.Axis.prototype.validateAxis.call(this, viewportRect, windowRect, view);
		if (!isValid) {
			return false;
		}

		return this.itemsSource() != null && this._cachedItemsCount > 0;
	}

	, 
	onDetached: function () {
		if (this.fastItemsSource() != null && this.fastItemsSourceProvider() != null && this.itemsSource() != null) {
			this.fastItemsSource(this.fastItemsSourceProvider().releaseFastItemsSource(this.itemsSource()));
		}

	}

	, 
	onAttached: function () {
		if (this.fastItemsSource() == null && this.fastItemsSourceProvider() != null && this.itemsSource() != null) {
			this.fastItemsSource(this.fastItemsSourceProvider().getFastItemsSource(this.itemsSource()));
		}

	}

	, 
	_majorLinePositions: null,
	majorLinePositions: function (value) {
		if (arguments.length === 1) {
			this._majorLinePositions = value;
			return value;
		} else {
			return this._majorLinePositions;
		}
	}

	, 
	isCategory: function () {

			return true;
	}

	, 
	getCategoryBoundingBox: function (point, useInterpolation, singularWidth) {
		if (this.isAngular()) {
			return $.ig.Rect.prototype.empty();
		}

		return this.getCategoryBoundingBoxHelper(point, useInterpolation, singularWidth, this.isVertical());
	}

	, 
	getCategoryBoundingBoxHelper: function (point, useInterpolation, singularWidth, isVertical) {
		var i = 0;
		var comparison = point.__x;
		var viewportMinExtreme = this.viewportRect().left();
		var viewportMaxExtreme = this.viewportRect().right();
		if (isVertical) {
			comparison = point.__y;
			viewportMinExtreme = this.viewportRect().top();
			viewportMaxExtreme = this.viewportRect().bottom();
		}

		var positions = this.majorLinePositions();
		if ((isVertical && !this.isInverted()) || (!isVertical && this.isInverted())) {
			positions = new $.ig.List$1(Number, 0);
			for (var j = this.majorLinePositions().count() - 1; j >= 0; j--) {
				positions.add(this.majorLinePositions().__inner[j]);
			}

		}

		if (this.categoryMode() == $.ig.CategoryMode.prototype.mode0) {
			if (useInterpolation) {
				var ret;
				if (isVertical) {
					ret = new $.ig.Rect(0, this.viewportRect().left(), point.__y - singularWidth / 2, this.viewportRect().width(), singularWidth);

				} else {
					ret = new $.ig.Rect(0, point.__x - singularWidth / 2, this.viewportRect().top(), singularWidth, this.viewportRect().height());
				}

				ret.intersect(this.viewportRect());
				return ret;

			} else {
				if (comparison > viewportMaxExtreme) {
					return $.ig.Rect.prototype.empty();
				}

				if (comparison < viewportMinExtreme) {
					return $.ig.Rect.prototype.empty();
				}

				var minDist = 1.7976931348623157E+308;
				var minPos = -1;
				for (i = 0; i < positions.count(); i++) {
					var dist = Math.abs(positions.__inner[i] - comparison);
					if (dist < minDist) {
						minDist = dist;
						minPos = i;
					}

				}

				if (minPos == -1) {
					return $.ig.Rect.prototype.empty();
				}

				var target = positions.__inner[minPos];
				var ret1;
				if (isVertical) {
					ret1 = new $.ig.Rect(0, this.viewportRect().left(), target - singularWidth / 2, this.viewportRect().width(), singularWidth);

				} else {
					ret1 = new $.ig.Rect(0, target - singularWidth / 2, this.viewportRect().top(), singularWidth, this.viewportRect().height());
				}

				ret1.intersect(this.viewportRect());
				return ret1;
			}


		} else {
			for (i = 0; i < positions.count(); i++) {
				if (positions.__inner[i] > comparison) {
					break;
				}

			}

			if (i == 0) {
				return $.ig.Rect.prototype.empty();
			}

			if (comparison > viewportMaxExtreme) {
				return $.ig.Rect.prototype.empty();
			}

			if (comparison < viewportMinExtreme) {
				return $.ig.Rect.prototype.empty();
			}

			var curr = this.viewportRect().right();
			if (isVertical) {
				curr = this.viewportRect().bottom();
			}

			if (i < positions.count()) {
				curr = positions.__inner[i];
			}

			if (isVertical) {
				return new $.ig.Rect(0, this.viewportRect().left(), positions.__inner[i - 1], this.viewportRect().width(), curr - positions.__inner[i - 1]);

			} else {
				return new $.ig.Rect(0, positions.__inner[i - 1], this.viewportRect().top(), curr - positions.__inner[i - 1], this.viewportRect().height());
			}

		}

	}

	, 
	fastItemsSource: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.CategoryAxisBase.prototype.fastItemsSourceProperty, value);
			return value;
		} else {

			return this.getValue($.ig.CategoryAxisBase.prototype.fastItemsSourceProperty);
		}
	}
	, 
	__fastItemsSource: null

	, 
	itemsSource: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.CategoryAxisBase.prototype.itemsSourceProperty, value);
			return value;
		} else {

			return this.getValue($.ig.CategoryAxisBase.prototype.itemsSourceProperty);
		}
	}
	, 
	__itemsCount: 0
	, 
	_cachedItemsCount: 0

	, 
	itemsCount: function (value) {
		if (arguments.length === 1) {

			this.__itemsCount = value;
			this._cachedItemsCount = this.__itemsCount;
			return value;
		} else {

			return this.__itemsCount;
		}
	}

	, 
	categoryMode: function (value) {
		if (arguments.length === 1) {

			if (this.__categoryMode != value) {
				var oldValue = this.__categoryMode;
				this.__categoryMode = value;
				this.raisePropertyChanged($.ig.CategoryAxisBase.prototype.categoryModePropertyName, $.ig.CategoryMode.prototype.getBox(oldValue), $.ig.CategoryMode.prototype.getBox(value));
			}

			return value;
		} else {

			return this.__categoryMode;
		}
	}
	, 
	__categoryMode: 0

	, 
	gap: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.CategoryAxisBase.prototype.gapProperty, value);
			return value;
		} else {

			return this.getValue($.ig.CategoryAxisBase.prototype.gapProperty);
		}
	}

	, 
	overlap: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.CategoryAxisBase.prototype.overlapProperty, value);
			return value;
		} else {

			return this.getValue($.ig.CategoryAxisBase.prototype.overlapProperty);
		}
	}

	, 
	useClusteringMode: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.CategoryAxisBase.prototype.useClusteringModeProperty, value);
			return value;
		} else {

			return this.getValue($.ig.CategoryAxisBase.prototype.useClusteringModeProperty);
		}
	}

	, 
	mode2GroupCount: function (value) {
		if (arguments.length === 1) {

			if (value != this._mode2GroupCount) {
				var oldGroupCount = this._mode2GroupCount;
				this._mode2GroupCount = value;
				this.raisePropertyChanged($.ig.CategoryAxisBase.prototype.groupCountPropertyName, oldGroupCount, this._mode2GroupCount);
			}

			return value;
		} else {

			return this._mode2GroupCount;
		}
	}
	, 
	_mode2GroupCount: 0

	, 
	getUnscaledValue: function (scaledValue, p) {
		return NaN;
	}

	, 
	getUnscaledValue2: function (scaledValue, windowRect, viewportRect, categoryMode) {
		return NaN;
	}

	, 
	getCategorySize: function (windowRect, viewportRect) {
		return NaN;
	}

	, 
	getGroupSize: function (windowRect, viewportRect) {
		return NaN;
	}

	, 
	getGroupCenter: function (index, windowRect, viewportRect) {
		return NaN;
	}

	, 
	unscaleValue: function (unscaledValue) {
		var windowRect = this.seriesViewer().windowRect();
		var viewportRect = this.viewportRect();
		var sParams = new $.ig.ScalerParams(windowRect, viewportRect, this.isInverted());
		return this.getUnscaledValue(unscaledValue, sParams);
	}

	, 
	relatedSeries: function () {
		var d__ = new $.ig.CategoryAxisBase___RelatedSeries__IteratorClass(-2);
		d__.__4__this = this;
		return d__;
	}

	, 
	hasSeries: function (series) {
		return this.series().contains(series);
	}

	, 
	shouldShareMode: function (chart) {
		return false;
	}

	, 
	relatedAxes: function () {
		var d__ = new $.ig.CategoryAxisBase___RelatedAxes__IteratorClass(-2);
		d__.__4__this = this;
		return d__;
	}
	, 
	__spreading: false

	, 
	spread: function (propagate) {
		if (this.__spreading) {
			return;
		}

		try {
				this.__spreading = true;
				var categoryMode = $.ig.CategoryMode.prototype.mode0;
				var mode2GroupCount = 0;
				var mode2Present = false;
				var en = this.relatedSeries().getEnumerator();
				while (en.moveNext()) {
					var currentSeries = en.current();
					var categorySeries = $.ig.util.cast($.ig.IHasCategoryModePreference.prototype.$type, currentSeries);
					if (categorySeries != null) {
						var seriesMode = categorySeries.preferredCategoryMode(this);
						if (seriesMode == $.ig.CategoryMode.prototype.mode2) {
							categoryMode = $.ig.CategoryMode.prototype.mode2;
							mode2Present = true;
							if (this.hasSeries(currentSeries)) {
								mode2GroupCount++;
							}

						}

						if (seriesMode == $.ig.CategoryMode.prototype.mode1 && !mode2Present) {
							categoryMode = $.ig.CategoryMode.prototype.mode1;
						}

					}

				}

				var useClusteringMode = this.useClusteringMode();
				var en1 = this.relatedAxes().getEnumerator();
				while (en1.moveNext()) {
					var axis = en1.current();
					if (axis.useClusteringMode()) {
						useClusteringMode = true;
					}

					if (propagate) {
						axis.spread(false);
					}

				}

				if (categoryMode == $.ig.CategoryMode.prototype.mode0 && useClusteringMode) {
					categoryMode = $.ig.CategoryMode.prototype.mode2;
					if (mode2GroupCount == 0) {
						mode2GroupCount = 1;
					}

				}

				this.categoryMode(categoryMode);
				this.mode2GroupCount(mode2GroupCount);

		}
		finally {
				this.__spreading = false;

		}
	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		$.ig.Axis.prototype.propertyUpdatedOverride.call(this, sender, propertyName, oldValue, newValue);
		switch (propertyName) {
			case $.ig.CategoryAxisBase.prototype.fastItemsSourceProviderPropertyName:
				if (($.ig.util.cast($.ig.IFastItemsSourceProvider.prototype.$type, oldValue)) != null) {
					this.fastItemsSource(($.ig.util.cast($.ig.IFastItemsSourceProvider.prototype.$type, oldValue)).releaseFastItemsSource(this.itemsSource()));
				}

				if (($.ig.util.cast($.ig.IFastItemsSourceProvider.prototype.$type, newValue)) != null) {
					this.fastItemsSource(($.ig.util.cast($.ig.IFastItemsSourceProvider.prototype.$type, newValue)).getFastItemsSource(this.itemsSource()));
				}

				this.itemsCount(0);
				if (this.fastItemsSource() != null) {
					this.itemsCount(this.fastItemsSource().count());
				}

				this.spread(true);
				break;
			case $.ig.CategoryAxisBase.prototype.itemsSourcePropertyName:
				if (this.fastItemsSourceProvider() != null) {
					this.fastItemsSource(this.fastItemsSourceProvider().getFastItemsSource(this.itemsSource()));
				}

				break;
			case $.ig.CategoryAxisBase.prototype.fastItemsSourcePropertyName:
				var oldFastItemsSource = $.ig.util.cast($.ig.IFastItemsSource.prototype.$type, oldValue);
				this.cacheFastItemsSource();
				this.mustInvalidateLabels(true);
				if (oldFastItemsSource != null) {
					oldFastItemsSource.event = $.ig.Delegate.prototype.remove(oldFastItemsSource.event, this.handleFastItemsSourceEvent.runOn(this));
				}

				this.itemsCount(0);
				if (this.fastItemsSource() != null) {
					this.itemsCount(this.fastItemsSource().count());
				}

				if (this.fastItemsSource() != null) {
					this.fastItemsSource().event = $.ig.Delegate.prototype.combine(this.fastItemsSource().event, this.handleFastItemsSourceEvent.runOn(this));
					this.renderAxis1(false);
					var en = this.directSeries().getEnumerator();
					while (en.moveNext()) {
						var currentSeries = en.current();
						currentSeries.renderSeries(false);
						if (currentSeries.seriesViewer() != null) {
							currentSeries.notifyThumbnailAppearanceChanged();
						}

					}


				} else {
					this.clearAllMarks();
					var en1 = this.directSeries().getEnumerator();
					while (en1.moveNext()) {
						var currentSeries1 = en1.current();
						currentSeries1.clearRendering(true, currentSeries1.view());
						if (currentSeries1.seriesViewer() != null) {
							currentSeries1.notifyThumbnailAppearanceChanged();
						}

					}

				}

				break;
			case $.ig.CategoryAxisBase.prototype.itemsCountPropertyName:
				this.raiseRangeChanged(new $.ig.AxisRangeChangedEventArgs(0, 0, $.ig.util.getValue((oldValue)) - 1, $.ig.util.getValue((newValue)) - 1));
				this.renderAxis1(false);
				break;
			case $.ig.CategoryAxisBase.prototype.useClusteringModePropertyName:
				this.mustInvalidateLabels(true);
				this.updateCategoryMode();
				this.renderAxis1(false);
				this.forceSeriesUpdate();
				break;
			case $.ig.CategoryAxisBase.prototype.categoryModePropertyName:
				this.mustInvalidateLabels(true);
				this.renderAxis1(false);
				this.renderCrossingAxis();
				this.forceSeriesUpdate();
				break;
			case $.ig.CategoryAxisBase.prototype.overlapPropertyName:
			case $.ig.CategoryAxisBase.prototype.gapPropertyName:
				this.mustInvalidateLabels(true);
				var en2 = this.directSeries().getEnumerator();
				while (en2.moveNext()) {
					var currentSeries2 = en2.current();
					currentSeries2.thumbnailDirty(true);
					var currentCategorySeries = $.ig.util.cast($.ig.IHasCategoryModePreference.prototype.$type, currentSeries2);
					if (currentCategorySeries != null && currentCategorySeries.preferredCategoryMode(this) == $.ig.CategoryMode.prototype.mode2) {
						currentSeries2.renderSeries(false);
					}

				}

				this.renderAxis1(false);
				if (this.seriesViewer() != null) {
					this.seriesViewer().notifyThumbnailAppearanceChanged();
				}

				break;
			case $.ig.CategoryAxisBase.prototype.crossingValuePropertyName:
			case $.ig.CategoryAxisBase.prototype.crossingAxisPropertyName:
				this.mustInvalidateLabels(true);
				this.renderAxis1(true);
				break;
		}

	}

	, 
	forceSeriesUpdate: function () {
		var en = this.directSeries().getEnumerator();
		while (en.moveNext()) {
			var currentSeries = en.current();
			currentSeries.renderSeries(false);
		}

	}

	, 
	handleFastItemsSourceEvent: function (sender, e) {
		switch (e.action()) {
			case $.ig.FastItemsSourceEventAction.prototype.change:
			case $.ig.FastItemsSourceEventAction.prototype.remove:
			case $.ig.FastItemsSourceEventAction.prototype.insert:
			case $.ig.FastItemsSourceEventAction.prototype.replace:
			case $.ig.FastItemsSourceEventAction.prototype.reset:
				if (this.fastItemsSource() != null) {
					this.itemsCount(this.fastItemsSource().count());
				}

				this.renderAxis1(false);
				break;
		}

		if (this.fastItemsSource() != null) {
			this.itemsCount(this.fastItemsSource().count());
		}

	}

	, 
	updateCategoryMode: function () {
		var mode1Present = false, mode2Present = false;
		var en = this.series().getEnumerator();
		while (en.moveNext()) {
			var currentSeries = en.current();
			var currentCategorySeries = $.ig.util.cast($.ig.IHasCategoryModePreference.prototype.$type, currentSeries);
			if (currentCategorySeries == null) {
				continue;
			}

			var currentMode = currentCategorySeries.preferredCategoryMode(this);
			mode1Present |= currentMode == $.ig.CategoryMode.prototype.mode1;
			mode2Present |= currentMode == $.ig.CategoryMode.prototype.mode2;
		}

		var categoryMode = mode2Present ? $.ig.CategoryMode.prototype.mode2 : mode1Present ? $.ig.CategoryMode.prototype.mode1 : $.ig.CategoryMode.prototype.mode0;
		if (categoryMode == $.ig.CategoryMode.prototype.mode0 && this.useClusteringMode()) {
			categoryMode = $.ig.CategoryMode.prototype.mode1;
			if (this.mode2GroupCount() == 0) {
				this.mode2GroupCount(1);
			}

		}

		this.categoryMode(categoryMode);
	}

	, 
	registerSeries: function (series) {
		var success = $.ig.Axis.prototype.registerSeries.call(this, series);
		if (success) {
			this.spread(true);
			var registeredCategorySeries = $.ig.util.cast($.ig.IHasCategoryModePreference.prototype.$type, series);
			if (registeredCategorySeries != null && registeredCategorySeries.preferredCategoryMode(this) == $.ig.CategoryMode.prototype.mode2) {
				var en = this.directSeries().getEnumerator();
				while (en.moveNext()) {
					var currentSeries = en.current();
					var currentCategorySeries = $.ig.util.cast($.ig.IHasCategoryModePreference.prototype.$type, currentSeries);
					if (currentCategorySeries != null && currentCategorySeries != registeredCategorySeries && currentCategorySeries.preferredCategoryMode(this) == $.ig.CategoryMode.prototype.mode2) {
						currentSeries.renderSeries(false);
					}

				}

			}

			this.renderAxis1(false);
			this.updateRange();
		}

		return success;
	}

	, 
	deregisterSeries: function (series) {
		var success = $.ig.Axis.prototype.deregisterSeries.call(this, series);
		if (success) {
			this.spread(true);
			var deregisteredCategorySeries = $.ig.util.cast($.ig.IHasCategoryModePreference.prototype.$type, series);
			if (deregisteredCategorySeries != null && deregisteredCategorySeries.preferredCategoryMode(this) != $.ig.CategoryMode.prototype.mode0) {
				var en = this.directSeries().getEnumerator();
				while (en.moveNext()) {
					var currentSeries = en.current();
					var currentCategorySeries = $.ig.util.cast($.ig.IHasCategoryModePreference.prototype.$type, currentSeries);
					if (currentCategorySeries != null) {
						currentSeries.renderSeries(false);
					}

				}

			}

			this.renderAxis1(false);
		}

		return success;
	}

	, 
	renderCrossingAxis: function () {
		var crossingAxis = null;
		var en = this.directSeries().getEnumerator();
		while (en.moveNext()) {
			var currentSeries = en.current();
			var categorySeries = $.ig.util.cast($.ig.CategorySeries.prototype.$type, currentSeries);
			if (categorySeries != null) {
				var yAxis = categorySeries.getYAxis();
				if (yAxis != null && yAxis.crossingAxis() == this) {
					crossingAxis = yAxis;
				}

			}

		}

		if (crossingAxis != null) {
			crossingAxis.renderAxis();
		}

	}

	, 
	cacheFastItemsSource: function () {
		this.__fastItemsSource = this.fastItemsSource();
	}

	, 
	renderLabels: function () {
		var labelSettings = this.labelSettings();
		if (labelSettings == null) {
			labelSettings = new $.ig.AxisLabelSettings();
		}

		if (labelSettings.visibility() == $.ig.Visibility.prototype.collapsed) {
			this.textBlocks().count(0);

		} else {
			var textBlockCount = 0;
			textBlockCount = this.categoryView().addLabels(this.labelDataContext());
			this.textBlocks().count(textBlockCount);
		}

	}

	, 
	handleCollectionChanged: function (e) {
		if (this.fastItemsSource() != null) {
			this.fastItemsSource().handleCollectionChanged(e);
		}

	}

	, 
	notifySetItem: function (index, oldItem, newItem) {
		this.handleCollectionChanged(new $.ig.NotifyCollectionChangedEventArgs(2, $.ig.NotifyCollectionChangedAction.prototype.replace, newItem, oldItem, index));
	}

	, 
	notifyClearItems: function () {
		this.handleCollectionChanged(new $.ig.NotifyCollectionChangedEventArgs(0, $.ig.NotifyCollectionChangedAction.prototype.reset));
	}

	, 
	notifyInsertItem: function (index, newItem) {
		this.handleCollectionChanged(new $.ig.NotifyCollectionChangedEventArgs(1, $.ig.NotifyCollectionChangedAction.prototype.add, newItem, index));
	}

	, 
	notifyRemoveItem: function (index, oldItem) {
		this.handleCollectionChanged(new $.ig.NotifyCollectionChangedEventArgs(1, $.ig.NotifyCollectionChangedAction.prototype.remove, oldItem, index));
	}
	, 
	$type: new $.ig.Type('CategoryAxisBase', $.ig.Axis.prototype.$type, [$.ig.ICategoryScaler.prototype.$type])
}, true);



$.ig.util.defType('CategoryAxisBaseView', 'AxisView', {

	_categoryModel: null,
	categoryModel: function (value) {
		if (arguments.length === 1) {
			this._categoryModel = value;
			return value;
		} else {
			return this._categoryModel;
		}
	}
	, 
	init: function (model) {



		$.ig.AxisView.prototype.init.call(this, model);
			this.categoryModel(model);
	}

	, 
	addLabels: function (list) {
		var textBlockCount = 0;
		for (var i = 0; i < list.count(); i++) {
			var label = $.ig.util.cast($.ig.FrameworkElement.prototype.$type, list.__inner[i]);
			if (label == null) {
				label = this.model().textBlocks().item(i);
				($.ig.util.cast($.ig.TextBlock.prototype.$type, label)).text(list.__inner[i] == null ? "" : list.__inner[i].toString());
				textBlockCount++;

			} else {
				this.labelPanel().children().add(label);
			}

		}

		return textBlockCount;
	}
	, 
	$type: new $.ig.Type('CategoryAxisBaseView', $.ig.AxisView.prototype.$type)
}, true);



$.ig.util.defType('CategoryDateTimeXAxis', 'CategoryAxisBase', {
	init: function () {



		$.ig.CategoryAxisBase.prototype.init.call(this);
			this.defaultStyleKey($.ig.CategoryDateTimeXAxis.prototype.$type);
			this.__actualMinimumValue = new Date();
			this.__actualMaximumValue = new Date();
	}

	, 
	createView: function () {
		return new $.ig.CategoryDateTimeXAxisView(this);
	}

	, 
	onViewCreated: function (view) {
		$.ig.CategoryAxisBase.prototype.onViewCreated.call(this, view);
		this.dateTimeView(view);
	}

	, 
	_dateTimeView: null,
	dateTimeView: function (value) {
		if (arguments.length === 1) {
			this._dateTimeView = value;
			return value;
		} else {
			return this._dateTimeView;
		}
	}

	, 
	isSorting: function () {

			return true;
	}

	, 
	isDateTime: function () {

			return true;
	}

	, 
	displayType: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.CategoryDateTimeXAxis.prototype.displayTypeProperty, $.ig.TimeAxisDisplayType.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.CategoryDateTimeXAxis.prototype.displayTypeProperty));
		}
	}

	, 
	minimumValue: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.CategoryDateTimeXAxis.prototype.minimumValueProperty, value);
			return value;
		} else {

			return this.getValue($.ig.CategoryDateTimeXAxis.prototype.minimumValueProperty);
		}
	}

	, 
	maximumValue: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.CategoryDateTimeXAxis.prototype.maximumValueProperty, value);
			return value;
		} else {

			return this.getValue($.ig.CategoryDateTimeXAxis.prototype.maximumValueProperty);
		}
	}

	, 
	interval: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.CategoryDateTimeXAxis.prototype.intervalProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.CategoryDateTimeXAxis.prototype.intervalProperty));
		}
	}

	, 
	validateAxis: function (viewportRect, windowRect, view) {
		var isValid = $.ig.CategoryAxisBase.prototype.validateAxis.call(this, viewportRect, windowRect, view);
		if (!isValid) {
			return false;
		}

		return this.actualMinimumValue() != this.actualMaximumValue();
	}

	, 
	createLabelPanel: function () {
		if (this.useSmartAxis()) {
			return new $.ig.SmartAxisLabelPanel();

		} else {
			return new $.ig.HorizontalAxisLabelPanel();
		}

	}

	, 
	getCategorySize: function (windowRect, viewportRect) {
		return viewportRect.width() / (this._cachedItemsCount * windowRect.width());
	}

	, 
	getGroupCenter: function (groupIndex, windowRect, viewportRect) {
		return this.getCategorySize(windowRect, viewportRect) * 0.5;
	}

	, 
	getGroupSize: function (windowRect, viewportRect) {
		var gap = !$.ig.util.isNaN(this.gap()) ? $.ig.MathUtil.prototype.clamp(this.gap(), 0, 1) : 0;
		var categorySpace = 1 - 0.5 * gap;
		var ret = this.getCategorySize(windowRect, viewportRect) * categorySpace;
		return ret;
	}
	, 
	__sorderDateTimeIndices: null

	, 
	sortedDateTimeIndices: function (value) {
		if (arguments.length === 1) {

			this.__sorderDateTimeIndices = value;
			return value;
		} else {

			return this.__sorderDateTimeIndices;
		}
	}

	, 
	renderAxisOverride: function (animate) {
		$.ig.CategoryAxisBase.prototype.renderAxisOverride.call(this, animate);
		var windowRect = this.seriesViewer() != null ? this.seriesViewer().actualWindowRect() : $.ig.Rect.prototype.empty();
		var viewportRect = !windowRect.isEmpty() ? this.viewportRect() : $.ig.Rect.prototype.empty();
		var xParams = new $.ig.ScalerParams(windowRect, viewportRect, this.isInverted());
		var axisGeometry = this.view().getAxisLinesGeometry();
		var stripsGeometry = this.view().getStripsGeometry();
		var majorGeometry = this.view().getMajorLinesGeometry();
		var minorGeometry = this.view().getMinorLinesGeometry();
		var axisLinesPathInfo = this.view().getAxisLinesPathInfo();
		var majorLinesPathInfo = this.view().getMajorLinesPathInfo();
		var minorLinesPathInfo = this.view().getMinorLinesPathInfo();
		this.updateLineVisibility();
		this.clearMarks(axisGeometry);
		this.clearMarks(stripsGeometry);
		this.clearMarks(majorGeometry);
		this.clearMarks(minorGeometry);
		this.labelDataContext().clear();
		this.labelPositions().clear();
		this.majorLinePositions().clear();
		this.labelPanel().axis(this);
		this.labelPanel().windowRect(windowRect);
		this.labelPanel().viewportRect(viewportRect);
		if (windowRect.isEmpty() || viewportRect.isEmpty()) {
			this.textBlocks().count(0);
		}

		if (this.textBlocks().count() == 0) {
			this.labelPanel().children().clear();
		}

		if (this.labelSettings() != null) {
			this.labelSettings().registerAxis(this);
		}

		this.initializeActualMinimumAndMaximum();
		if (!windowRect.isEmpty() && !viewportRect.isEmpty() && (this.displayType() != $.ig.TimeAxisDisplayType.prototype.discrete || this.dateTimeColumn() != null)) {
			var crossingValue = viewportRect.bottom();
			var relativeCrossingValue = crossingValue - viewportRect.top();
			if (this.crossingAxis() != null) {
				var yAxis = $.ig.util.cast($.ig.NumericYAxis.prototype.$type, this.crossingAxis());
				if (yAxis != null) {
					var yParams = new $.ig.ScalerParams(windowRect, viewportRect, yAxis.isInverted());
					crossingValue = this.crossingValue();
					crossingValue = yAxis.getScaledValue(crossingValue, yParams);
					relativeCrossingValue = crossingValue - viewportRect.top();
					if (crossingValue < viewportRect.top()) {
						crossingValue = viewportRect.top();

					} else if (crossingValue > viewportRect.bottom()) {
						crossingValue = viewportRect.bottom();
					}


					if (relativeCrossingValue < 0) {
						relativeCrossingValue = 0;

					} else if (relativeCrossingValue > viewportRect.height()) {
						relativeCrossingValue = viewportRect.height();
					}


				}

			}

			if ($.ig.util.isNaN(crossingValue)) {
				crossingValue = 0;
			}

			this.horizontalLine(axisGeometry, crossingValue, viewportRect, axisLinesPathInfo);
			this.labelPanel().crossingValue(relativeCrossingValue);
			if (this.displayType() == $.ig.TimeAxisDisplayType.prototype.discrete) {
				var first = (this).getFirstVisibleIndex(windowRect, viewportRect);
				var last = (this).getLastVisibleIndex(windowRect, viewportRect);
				if (first < 0 || last < 0) {
					return;
				}

				var lastMajorValue = NaN;
				for (var i = first; i <= last; i++) {
					var sortedIndex = this.sortedDateTimeIndices() == null ? i : this.sortedDateTimeIndices().__inner[i];
					var majorValue = this.getScaledValue(this.dateTimeColumn().item(sortedIndex).getTime(), xParams);
					if (majorValue == lastMajorValue) {
						continue;
					}

					lastMajorValue = majorValue;
					if (this.categoryMode() == $.ig.CategoryMode.prototype.mode2) {
						majorValue += this.isInverted() ? -this.getGroupCenter(i, windowRect, viewportRect) : this.getGroupCenter(i, windowRect, viewportRect);
					}

					if (majorValue < viewportRect.left() || majorValue > viewportRect.right()) {
						continue;
					}

					this.verticalLine(majorGeometry, majorValue, viewportRect, majorLinesPathInfo);
					this.majorLinePositions().add(majorValue);
					if (this.fastItemsSource() != null && i < this.fastItemsSource().count()) {
						var dataItem = this.fastItemsSource().item(sortedIndex);
						var labelText = $.ig.CategoryAxisBase.prototype.getLabel.call(this, dataItem);
						if (!$.ig.util.isNaN(majorValue) && !Number.isInfinity(majorValue) && labelText != null) {
							if (($.ig.util.cast(String, labelText) !== null || typeof labelText === "string") && (labelText).equals("")) {

							} else {
								this.labelDataContext().add1(labelText);
								this.labelPositions().add(new $.ig.LabelPosition(majorValue));
							}

						}

					}

				}


			} else {
				var visibleMinimum = this.getUnscaledValue(viewportRect.left(), xParams);
				var visibleMaximum = this.getUnscaledValue(viewportRect.right(), xParams);
				var trueVisibleMinimum = Math.min(visibleMinimum, visibleMaximum);
				var trueVisibleMaximum = Math.max(visibleMinimum, visibleMaximum);
				var snapper = new $.ig.LinearNumericSnapper(0, trueVisibleMinimum, trueVisibleMaximum, viewportRect.width());
				var interval = this.hasUserInterval() ? this.getUserIntervalTicks() : snapper.interval();
				var first1 = $.ig.truncate(Math.floor((trueVisibleMinimum - this.actualMinimumValue().getTime()) / interval));
				var last1 = $.ig.truncate(Math.ceil((trueVisibleMaximum - this.actualMinimumValue().getTime()) / interval));
				var offset = 0;
				if (this.categoryMode() == $.ig.CategoryMode.prototype.mode2) {
					offset = this.getGroupCenter(0, windowRect, viewportRect);
					offset = this.isInverted() ? -offset : offset;
				}

				var viewportPixelRight = $.ig.truncate(Math.ceil(viewportRect.right()));
				var viewportPixelLeft = $.ig.truncate(Math.floor(viewportRect.left()));
				var majorValue1 = this.getScaledValue(this.actualMinimumValue().getTime() + first1 * interval, xParams) + offset;
				for (var i1 = first1; i1 <= last1; i1++) {
					var nextMajorValue = this.getScaledValue(this.actualMinimumValue().getTime() + (i1 + 1) * interval, xParams) + offset;
					if (!$.ig.util.isNaN(majorValue1) && !Number.isInfinity(majorValue1)) {
						var categoryPixelValue = $.ig.truncate(Math.round(majorValue1));
						if (categoryPixelValue <= viewportPixelRight) {
							if (i1 % 2 == 0) {
								this.verticalStrip(stripsGeometry, majorValue1, nextMajorValue, viewportRect);
							}

							this.verticalLine(majorGeometry, majorValue1, viewportRect, majorLinesPathInfo);
							this.majorLinePositions().add(majorValue1);
							if (this.shouldRenderMinorLines()) {
								for (var j = 1; j < snapper.minorCount(); ++j) {
									var minorValue = this.getScaledValue(this.actualMinimumValue().getTime() + i1 * interval + (j * interval) / snapper.minorCount(), xParams) + offset;
									this.verticalLine(minorGeometry, minorValue, viewportRect, minorLinesPathInfo);
								}

							}

						}

						if (categoryPixelValue >= viewportPixelLeft && categoryPixelValue <= viewportPixelRight) {
							var majorX = this.actualMinimumValue().getTime() + i1 * interval;
							var ticks_ = $.ig.truncate(Math.floor(majorX));
							var dateValue = new Date(ticks_);
							var labelText1 = this.getLabel(dateValue);
							if (labelText1 != null && labelText1 != "") {
								this.labelDataContext().add1(labelText1);
								this.labelPositions().add(new $.ig.LabelPosition(majorValue1));
							}

						}

					}

					majorValue1 = nextMajorValue;
				}

			}

			if ((this.labelSettings() == null || this.labelSettings().visibility() == $.ig.Visibility.prototype.visible) && this.crossingAxis() != null) {
				if (this.labelSettings() != null && (this.labelSettings().location() == $.ig.AxisLabelsLocation.prototype.insideTop || this.labelSettings().location() == $.ig.AxisLabelsLocation.prototype.insideBottom)) {
					this.seriesViewer().invalidatePanels();
				}

			}

			this.labelPanel().labelDataContext(this.labelDataContext());
			this.labelPanel().labelPositions(this.labelPositions());
			this.renderLabels();
		}

	}

	, 
	getUserIntervalTicks: function () {
		return this.actualInterval();
	}

	, 
	initializeActualMinimumAndMaximum: function () {
		var windowRect = this.seriesViewer() != null ? this.seriesViewer().actualWindowRect() : $.ig.Rect.prototype.empty();
		var viewportRect = !windowRect.isEmpty() ? this.viewportRect() : $.ig.Rect.prototype.empty();
		var newActualMinimum = new Date();
		var newActualMaximum = new Date();
		if (!windowRect.isEmpty() && !viewportRect.isEmpty() && this.dateTimeColumn() != null) {
			var fastDateColumn = $.ig.util.cast($.ig.FastItemDateTimeColumn.prototype.$type, this.dateTimeColumn());
			if (fastDateColumn != null) {
				if (this.sortedDateTimeIndices() == null) {
					this.sortedDateTimeIndices(fastDateColumn.getSortedIndices());
				}


			} else {
				this.sortedDateTimeIndices(null);
			}

			if (this.dateTimeColumn().count() > 0) {
				var firstIndex = this.sortedDateTimeIndices() == null ? 0 : this.sortedDateTimeIndices().__inner[0];
				var lastIndex = this.sortedDateTimeIndices() == null ? this.dateTimeColumn().count() - 1 : this.sortedDateTimeIndices().__inner[this.dateTimeColumn().count() - 1];
				newActualMinimum = this.dateTimeColumn().item(firstIndex);
				newActualMaximum = this.dateTimeColumn().item(lastIndex);
				this.hasUserInterval(false);
				if (this.categoryMode() == $.ig.CategoryMode.prototype.mode2) {
					var timeSpan = newActualMaximum.getTime() - newActualMinimum.getTime();
					var timeOffset_ = $.ig.truncate(Math.round(timeSpan * 1.25 / this._cachedItemsCount / 2));
					if (timeOffset_ == 0) {
						timeOffset_ = 1;
					}

					var minTime_ = newActualMinimum.getTime();
					var maxTime_ = newActualMaximum.getTime();
					newActualMinimum = new Date(minTime_ - timeOffset_);
					newActualMaximum = new Date(maxTime_ + timeOffset_);
				}

			}

		}

		if (this.minimumValueIsSet()) {
			newActualMinimum = this.minimumValue();
		}

		if (this.maximumValueIsSet()) {
			newActualMaximum = this.maximumValue();
		}

		if (this.intervalIsSet()) {
			this.actualInterval(this.interval());
			var span = Math.abs(newActualMaximum.getTime() - newActualMinimum.getTime());
			this.hasUserInterval(this.actualIntervalIsEmpty() || (this.displayType() == $.ig.TimeAxisDisplayType.prototype.discrete) || (1 * span / this.getUserIntervalTicks() > (viewportRect.width() / windowRect.width())) ? false : true);

		} else {
			this.hasUserInterval(false);
		}

		this.actualMinimumValue(newActualMinimum);
		this.actualMaximumValue(newActualMaximum);
	}

	, 
	intervalIsSet: function () {
		return this.interval() != 0;
	}

	, 
	actualIntervalIsEmpty: function () {
		return this.actualInterval() == 0;
	}

	, 
	minimumValueIsSet: function () {
		return this.minimumValue() != null;
	}

	, 
	maximumValueIsSet: function () {
		return this.maximumValue() != null;
	}
	, 
	__actualMinimumValue: new Date()

	, 
	actualMinimumValue: function (value) {
		if (arguments.length === 1) {

			var changed = this.__actualMinimumValue != value;
			if (changed) {
				var oldValue = this.__actualMinimumValue;
				this.__actualMinimumValue = value;
				this.raisePropertyChanged($.ig.CategoryDateTimeXAxis.prototype._actualMinimumValuePropertyName, oldValue, value);
			}

			return value;
		} else {

			return this.__actualMinimumValue;
		}
	}
	, 
	__actualMaximumValue: new Date()

	, 
	actualMaximumValue: function (value) {
		if (arguments.length === 1) {

			var changed = this.__actualMaximumValue != value;
			if (changed) {
				var oldValue = this.__actualMaximumValue;
				this.__actualMaximumValue = value;
				this.raisePropertyChanged($.ig.CategoryDateTimeXAxis.prototype._actualMaximumValuePropertyName, oldValue, value);
			}

			return value;
		} else {

			return this.__actualMaximumValue;
		}
	}

	, 
	_hasUserInterval: false,
	hasUserInterval: function (value) {
		if (arguments.length === 1) {
			this._hasUserInterval = value;
			return value;
		} else {
			return this._hasUserInterval;
		}
	}
	, 
	__actualInterval: 0

	, 
	actualInterval: function (value) {
		if (arguments.length === 1) {

			this.__actualInterval = value;
			return value;
		} else {

			return this.__actualInterval;
		}
	}

	, 
	getScaledValue: function (unscaledValue, p) {
		var scaledValue;
		if (this.actualMaximumValue() == this.actualMinimumValue()) {
			scaledValue = -1;

		} else {
			scaledValue = (unscaledValue - this.actualMinimumValue().getTime()) / (this.actualMaximumValue().getTime() - this.actualMinimumValue().getTime());
		}

		var offset = 0;
		if (this.categoryMode() == $.ig.CategoryMode.prototype.mode2) {
			offset = this.getGroupCenter(0, p._windowRect, p._viewportRect);
		}

		if (this.isInverted()) {
			scaledValue = 1 - scaledValue;
			offset = -offset;
		}

		return p._viewportRect.left() + p._viewportRect.width() * (scaledValue - p._windowRect.left()) / p._windowRect.width() - offset;
	}

	, 
	getUnscaledValue: function (scaledValue, p) {
		return this.getUnscaledValue2(scaledValue, p._windowRect, p._viewportRect, this.categoryMode());
	}

	, 
	getUnscaledValue2: function (scaledValue, windowRect, viewportRect, categoryMode) {
		var unscaledValue = windowRect.left() + windowRect.width() * (scaledValue - viewportRect.left()) / viewportRect.width();
		if (this.isInverted()) {
			unscaledValue = 1 - unscaledValue;
		}

		return $.ig.truncate(Math.floor(this.actualMinimumValue().getTime() + unscaledValue * (this.actualMaximumValue().getTime() - this.actualMinimumValue().getTime())));
	}

	, 
	getDate: function (index) {
		return this.dateTimeColumn() == null ? $.ig.Date.prototype.minValue() : this.dateTimeColumn().item(index);
	}

	, 
	dateTimeMemberPath: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.CategoryDateTimeXAxis.prototype.dateTimeMemberPathProperty, value);
			return value;
		} else {

			return this.getValue($.ig.CategoryDateTimeXAxis.prototype.dateTimeMemberPathProperty);
		}
	}

	, 
	dateTimeColumn: function (value) {
		if (arguments.length === 1) {

			if (this._dateTimeColumn != value) {
				var oldDateTimeColumn = this._dateTimeColumn;
				this._dateTimeColumn = value;
				this.raisePropertyChanged($.ig.CategoryDateTimeXAxis.prototype.dateTimeColumnPropertyName, oldDateTimeColumn, this._dateTimeColumn);
			}

			return value;
		} else {

			return this._dateTimeColumn;
		}
	}
	, 
	_dateTimeColumn: null

	, 
	registerDateTimeColumn: function (memberPath) {
		if (memberPath == null) {
			return this.fastItemsSource().registerColumnDateTime(null, null, false);
		}

		var coercionMethod = null;
		var info = $.ig.SeriesViewer.prototype.getCoercionMethod(memberPath, this.coercionMethods());
		memberPath = info.memberPath();
		coercionMethod = info.coercionMethod();
		return this.fastItemsSource().registerColumnDateTime(memberPath, coercionMethod, this.expectFunctions());
	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		$.ig.CategoryAxisBase.prototype.propertyUpdatedOverride.call(this, sender, propertyName, oldValue, newValue);
		switch (propertyName) {
			case $.ig.CategoryAxisBase.prototype.fastItemsSourcePropertyName:
				var oldFastItemsSource = $.ig.util.cast($.ig.IFastItemsSource.prototype.$type, oldValue);
				if (oldFastItemsSource != null) {
					oldFastItemsSource.deregisterColumn(this.dateTimeColumn());
					this.dateTimeColumn(null);
					oldFastItemsSource.event = $.ig.Delegate.prototype.remove(oldFastItemsSource.event, this.fastItemsSource_Event.runOn(this));
				}

				var newFastItemsSource = $.ig.util.cast($.ig.IFastItemsSource.prototype.$type, newValue);
				if (newFastItemsSource != null) {
					this.sortedDateTimeIndices(null);
					this.dateTimeColumn(this.registerDateTimeColumn(this.dateTimeMemberPath()));
					newFastItemsSource.event = $.ig.Delegate.prototype.combine(newFastItemsSource.event, this.fastItemsSource_Event.runOn(this));
				}

				this.renderAxisAndSeries(false);
				break;
			case $.ig.CategoryDateTimeXAxis.prototype._dateTimeMemberPathPropertyName:
				if (this.fastItemsSource() != null) {
					this.fastItemsSource().deregisterColumn(this.dateTimeColumn());
					this.dateTimeColumn(this.registerDateTimeColumn(this.dateTimeMemberPath()));
					this.sortedDateTimeIndices(null);
				}

				break;
			case $.ig.CategoryDateTimeXAxis.prototype.displayTypePropertyName:
				this.mustInvalidateLabels(true);
				this.labelPanel().areLabelsUnevenlySpaced(this.displayType() == $.ig.TimeAxisDisplayType.prototype.discrete);
				this.renderAxis1(false);
				break;
			case $.ig.CategoryDateTimeXAxis.prototype.minimumValuePropertyName:
				this.updateRange();
				this.renderAxisAndSeries(false);
				break;
			case $.ig.CategoryDateTimeXAxis.prototype.maximumValuePropertyName:
				this.updateRange();
				this.renderAxisAndSeries(false);
				break;
			case $.ig.CategoryDateTimeXAxis.prototype.intervalPropertyName:
				this.mustInvalidateLabels(true);
				this.renderAxis1(false);
				break;
		}

	}

	, 
	fastItemsSource_Event: function (sender, e) {
		this.sortedDateTimeIndices(null);
	}

	, 
	renderAxisAndSeries: function (animate) {
		this.renderAxisOverride(animate);
		if (this.fastItemsSource() == null) {
		return;
		}

		var en = this.directSeries().getEnumerator();
		while (en.moveNext()) {
			var currentSeries = en.current();
			currentSeries.renderSeries(animate);
		}

	}

	, 
	updateRangeOverride: function () {
		var oldMin = this.actualMinimumValue().getTime();
		var oldMax = this.actualMaximumValue().getTime();
		var newMin = !this.minimumValueIsSet() ? this.actualMinimumValue().getTime() : this.minimumValue().getTime();
		var newMax = !this.maximumValueIsSet() ? this.actualMaximumValue().getTime() : this.maximumValue().getTime();
		var ea = new $.ig.AxisRangeChangedEventArgs(oldMin, newMin, oldMax, newMax);
		this.raiseRangeChanged(ea);
		return true;
	}

	, 
	sortedIndices: function () {

			if (this.sortedDateTimeIndices() == null) {
				var fastDateColumn = $.ig.util.cast($.ig.FastItemDateTimeColumn.prototype.$type, this.dateTimeColumn());
				if (fastDateColumn != null) {
					this.sortedDateTimeIndices(fastDateColumn.getSortedIndices());

				} else {
					this.sortedDateTimeIndices(null);
				}

			}

			return this.sortedDateTimeIndices();
	}

	, 
	getFirstVisibleIndex: function (windowRect, viewportRect) {
		var xParams = new $.ig.ScalerParams(windowRect, viewportRect, this.isInverted());
		var x0, x1;
		if (this.isInverted()) {
			x1 = this.getUnscaledValue(viewportRect.left(), xParams);
			x0 = this.getUnscaledValue(viewportRect.right(), xParams);

		} else {
			x0 = this.getUnscaledValue(viewportRect.left(), xParams);
			x1 = this.getUnscaledValue(viewportRect.right(), xParams);
		}

		var result = 0;
		for (var i = 0; i < this.sortedDateTimeIndices().count(); i++) {
			if (this.dateTimeColumn() == null) {
				break;
			}

			var currentDateTime = this.dateTimeColumn().item(this.sortedDateTimeIndices().__inner[i]);
			if (currentDateTime.getTime() >= x0) {
				break;
			}

			result = i;
		}

		return result;
	}

	, 
	getLastVisibleIndex: function (windowRect, viewportRect) {
		var xParams = new $.ig.ScalerParams(windowRect, viewportRect, this.isInverted());
		var x0, x1;
		if (this.isInverted()) {
			x1 = this.getUnscaledValue(viewportRect.left(), xParams);
			x0 = this.getUnscaledValue(viewportRect.right(), xParams);

		} else {
			x0 = this.getUnscaledValue(viewportRect.left(), xParams);
			x1 = this.getUnscaledValue(viewportRect.right(), xParams);
		}

		var last = this.sortedDateTimeIndices().count() - 1;
		var result = last;
		for (var i = last; i >= 0; i--) {
			if (this.dateTimeColumn() == null || this.sortedDateTimeIndices().count() <= i) {
				break;
			}

			var sortedIndex = this.sortedDateTimeIndices().__inner[i];
			if (sortedIndex >= this.dateTimeColumn().count()) {
				break;
			}

			var currentDateTime = this.dateTimeColumn().item(sortedIndex);
			if (currentDateTime.getTime() < x1) {
				break;
			}

			result = Math.min(i + 1, this.sortedDateTimeIndices().count() - 1);
		}

		return result;
	}

	, 
	getUnscaledValueAt: function (index) {
		if (this.dateTimeColumn() == null) {
		return NaN;
		}

		var date = this._dateTimeColumn.item(index);
		var ticks = date.getTime();
		var ticksAsDouble = ticks;
		return ticksAsDouble;
	}

	, 
	getExactUnsortedIndexClosestToUnscaledValue: function (unscaledValue) {
		var sorting = this;
		var view = new $.ig.SortedListView$1($.ig.Date.prototype.$type, this.dateTimeColumn(), sorting.sortedIndices());
		var ticks_ = unscaledValue;
		var target = new Date(ticks_);
		var res = this.getSearchResult(unscaledValue, target, view);
		if (res >= 0 && res < sorting.sortedIndices().count() && res - 1 >= 0 && res - 1 < sorting.sortedIndices().count()) {
			var diff1_ = target.getTime() - view.item(res - 1).getTime();
			var diff2_ = view.item(res).getTime() - target.getTime();
			var prev = res - 1;
			var next = res;
			if (prev < 0 && next >= 0) {
				return next;
			}

			if (next > sorting.sortedIndices().count() - 1 && prev < sorting.sortedIndices().count()) {
				return prev;
			}

			if (prev < 0 && next < 0) {
				return -1;
			}

			if (prev > sorting.sortedIndices().count() - 1 && next > sorting.sortedIndices().count() - 1) {
				return -1;
			}

			var p = diff1_ / (diff1_ + diff2_);
			if ($.ig.util.isNaN(p)) {
				p = 0;
			}

			return prev + p;
		}

		if (res >= 0 && res < sorting.sortedIndices().count()) {
			return res;
		}

		return -1;
	}

	, 
	getSearchResult: function (unscaledValue, target, view) {
		var $self = this;
		var sorting = $self;
		if ($self.dateTimeColumn() == null || sorting.sortedIndices() == null) {
			return -1;
		}

		var res = -1;
		var result = $.ig.ArrayUtil.prototype.binarySearch$1($.ig.Date.prototype.$type, view, function (item) {
			if (target < item) {
				return -1;
			}

			if (target > item) {
				return 1;
			}

			return 0;
		});
		if (result >= 0) {
			res = result;

		} else {
			res = ~result;
		}

		while (res >= 0 && res < view.count() && res - 1 >= 0 && view.item(res) == view.item(res - 1)) {
			res--;

		}
		return res;
	}

	, 
	getIndexClosestToUnscaledValue: function (unscaledValue) {
		var sorting = this;
		var view = new $.ig.SortedListView$1($.ig.Date.prototype.$type, this.dateTimeColumn(), sorting.sortedIndices());
		var ticks_ = unscaledValue;
		var target = new Date(ticks_);
		var res = this.getSearchResult(unscaledValue, target, view);
		if (res >= 0 && res < sorting.sortedIndices().count() && res - 1 >= 0 && res - 1 < sorting.sortedIndices().count()) {
			var diff1 = target - view.item(res - 1);
			var diff2 = view.item(res) - target;
			if (diff1 < diff2) {
				res = res - 1;
			}

		}

		if (res >= 0 && res < sorting.sortedIndices().count()) {
			return sorting.sortedIndices().__inner[res];
		}

		if (res == sorting.sortedIndices().count() && this.seriesViewer() != null && Math.abs(this.getScaledValue(unscaledValue, new $.ig.ScalerParams(this.seriesViewer().actualWindowRect(), this.viewportRect(), this.isInverted())) - this.viewportRect().right()) < 2) {
			return res - 1;
		}

		if (res == -1 && this.seriesViewer() != null && Math.abs(this.getScaledValue(unscaledValue, new $.ig.ScalerParams(this.seriesViewer().actualWindowRect(), this.viewportRect(), this.isInverted())) - this.viewportRect().left()) < 2) {
			return 0;
		}

		return -1;
	}

	, 
	notifyDataChanged: function () {
		this.sortedDateTimeIndices(null);
		this.renderAxis();
	}

	, 
	orientation: function () {

			return $.ig.AxisOrientation.prototype.horizontal;
	}
	, 
	$type: new $.ig.Type('CategoryDateTimeXAxis', $.ig.CategoryAxisBase.prototype.$type, [$.ig.ISortingAxis.prototype.$type])
}, true);

$.ig.util.defType('CategoryDateTimeXAxisView', 'CategoryAxisBaseView', {

	_xModel: null,
	xModel: function (value) {
		if (arguments.length === 1) {
			this._xModel = value;
			return value;
		} else {
			return this._xModel;
		}
	}
	, 
	init: function (model) {



		$.ig.CategoryAxisBaseView.prototype.init.call(this, model);
			this.xModel(model);
	}
	, 
	$type: new $.ig.Type('CategoryDateTimeXAxisView', $.ig.CategoryAxisBaseView.prototype.$type)
}, true);

$.ig.util.defType('AxisRenderingParametersBase', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.rangeInfos(new $.ig.List$1($.ig.RangeInfo.prototype.$type, 0));
	}

	, 
	_viewportRect: null,
	viewportRect: function (value) {
		if (arguments.length === 1) {
			this._viewportRect = value;
			return value;
		} else {
			return this._viewportRect;
		}
	}

	, 
	_windowRect: null,
	windowRect: function (value) {
		if (arguments.length === 1) {
			this._windowRect = value;
			return value;
		} else {
			return this._windowRect;
		}
	}

	, 
	_rangeInfos: null,
	rangeInfos: function (value) {
		if (arguments.length === 1) {
			this._rangeInfos = value;
			return value;
		} else {
			return this._rangeInfos;
		}
	}

	, 
	_currentRangeInfo: null,
	currentRangeInfo: function (value) {
		if (arguments.length === 1) {
			this._currentRangeInfo = value;
			return value;
		} else {
			return this._currentRangeInfo;
		}
	}

	, 
	_tickmarkValues: null,
	tickmarkValues: function (value) {
		if (arguments.length === 1) {
			this._tickmarkValues = value;
			return value;
		} else {
			return this._tickmarkValues;
		}
	}

	, 
	_strips: null,
	strips: function (value) {
		if (arguments.length === 1) {
			this._strips = value;
			return value;
		} else {
			return this._strips;
		}
	}

	, 
	_major: null,
	major: function (value) {
		if (arguments.length === 1) {
			this._major = value;
			return value;
		} else {
			return this._major;
		}
	}

	, 
	_minor: null,
	minor: function (value) {
		if (arguments.length === 1) {
			this._minor = value;
			return value;
		} else {
			return this._minor;
		}
	}

	, 
	_axisGeometry: null,
	axisGeometry: function (value) {
		if (arguments.length === 1) {
			this._axisGeometry = value;
			return value;
		} else {
			return this._axisGeometry;
		}
	}

	, 
	_actualMinimumValue: 0,
	actualMinimumValue: function (value) {
		if (arguments.length === 1) {
			this._actualMinimumValue = value;
			return value;
		} else {
			return this._actualMinimumValue;
		}
	}

	, 
	_actualMaximumValue: 0,
	actualMaximumValue: function (value) {
		if (arguments.length === 1) {
			this._actualMaximumValue = value;
			return value;
		} else {
			return this._actualMaximumValue;
		}
	}

	, 
	_crossingValue: 0,
	crossingValue: function (value) {
		if (arguments.length === 1) {
			this._crossingValue = value;
			return value;
		} else {
			return this._crossingValue;
		}
	}

	, 
	_relativeCrossingValue: 0,
	relativeCrossingValue: function (value) {
		if (arguments.length === 1) {
			this._relativeCrossingValue = value;
			return value;
		} else {
			return this._relativeCrossingValue;
		}
	}

	, 
	_label: null,
	label: function (value) {
		if (arguments.length === 1) {
			this._label = value;
			return value;
		} else {
			return this._label;
		}
	}

	, 
	_interval: 0,
	interval: function (value) {
		if (arguments.length === 1) {
			this._interval = value;
			return value;
		} else {
			return this._interval;
		}
	}

	, 
	_hasUserInterval: false,
	hasUserInterval: function (value) {
		if (arguments.length === 1) {
			this._hasUserInterval = value;
			return value;
		} else {
			return this._hasUserInterval;
		}
	}

	, 
	_hasUserMax: false,
	hasUserMax: function (value) {
		if (arguments.length === 1) {
			this._hasUserMax = value;
			return value;
		} else {
			return this._hasUserMax;
		}
	}

	, 
	_shouldRenderMinorLines: false,
	shouldRenderMinorLines: function (value) {
		if (arguments.length === 1) {
			this._shouldRenderMinorLines = value;
			return value;
		} else {
			return this._shouldRenderMinorLines;
		}
	}

	, 
	_currentRenderingInfo: null,
	currentRenderingInfo: function (value) {
		if (arguments.length === 1) {
			this._currentRenderingInfo = value;
			return value;
		} else {
			return this._currentRenderingInfo;
		}
	}

	, 
	_axisRenderingInfo: null,
	axisRenderingInfo: function (value) {
		if (arguments.length === 1) {
			this._axisRenderingInfo = value;
			return value;
		} else {
			return this._axisRenderingInfo;
		}
	}

	, 
	_majorRenderingInfo: null,
	majorRenderingInfo: function (value) {
		if (arguments.length === 1) {
			this._majorRenderingInfo = value;
			return value;
		} else {
			return this._majorRenderingInfo;
		}
	}

	, 
	_minorRenderingInfo: null,
	minorRenderingInfo: function (value) {
		if (arguments.length === 1) {
			this._minorRenderingInfo = value;
			return value;
		} else {
			return this._minorRenderingInfo;
		}
	}
	, 
	$type: new $.ig.Type('AxisRenderingParametersBase', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('CategoryAxisRenderingParameters', 'AxisRenderingParametersBase', {
	init: function () {


		$.ig.AxisRenderingParametersBase.prototype.init.call(this);

	}
	, 
	_count: 0,
	count: function (value) {
		if (arguments.length === 1) {
			this._count = value;
			return value;
		} else {
			return this._count;
		}
	}

	, 
	_categoryMode: 0,
	categoryMode: function (value) {
		if (arguments.length === 1) {
			this._categoryMode = value;
			return value;
		} else {
			return this._categoryMode;
		}
	}

	, 
	_wrapAround: false,
	wrapAround: function (value) {
		if (arguments.length === 1) {
			this._wrapAround = value;
			return value;
		} else {
			return this._wrapAround;
		}
	}

	, 
	_mode2GroupCount: 0,
	mode2GroupCount: function (value) {
		if (arguments.length === 1) {
			this._mode2GroupCount = value;
			return value;
		} else {
			return this._mode2GroupCount;
		}
	}

	, 
	_isInverted: false,
	isInverted: function (value) {
		if (arguments.length === 1) {
			this._isInverted = value;
			return value;
		} else {
			return this._isInverted;
		}
	}
	, 
	$type: new $.ig.Type('CategoryAxisRenderingParameters', $.ig.AxisRenderingParametersBase.prototype.$type)
}, true);

$.ig.util.defType('AxisRendererBase', 'Object', {
	init: function (labelManager) {



		var $self = this;
		$.ig.Object.prototype.init.call(this);
			this.clear(function () {
			});
			this.shouldRender(function (r1, r2) {
				return false;
			});
			this.onRendering(function () {
			});
			this.scaling(function (p, v) {
				return v;
			});
			this.strip(function (p, g, min, max) {
			});
			this.line(function (p, g, v) {
			});
			this.shouldRenderLines(function (p, v) {
				return false;
			});
			this.shouldRenderContent(function (p, v) {
				return $self.shouldRenderLines()(p, v);
			});
			this.axisLine(function (p) {
			});
			this.determineCrossingValue(function (p) {
			});
			this.shouldRenderLabel(function (p, v, last) {
				return false;
			});
			this.getLabelLocation(function (p, v) {
				return new $.ig.LabelPosition(v);
			});
			this.transformToLabelValue(function (p, v) {
				return v;
			});
			this.getLabelForItem(function (item) { return null; });
			this.snapMajorValue(function (p, v, i, interval) { return v; });
			this.adjustMajorValue(function (p, v, i, interval) { return v; });
			this.labelManager(labelManager);
			this.createRenderingParams(function (r1, r2) {
				return null;
			});
	}

	, 
	_clear: null,
	clear: function (value) {
		if (arguments.length === 1) {
			this._clear = value;
			return value;
		} else {
			return this._clear;
		}
	}

	, 
	_shouldRender: null,
	shouldRender: function (value) {
		if (arguments.length === 1) {
			this._shouldRender = value;
			return value;
		} else {
			return this._shouldRender;
		}
	}

	, 
	_onRendering: null,
	onRendering: function (value) {
		if (arguments.length === 1) {
			this._onRendering = value;
			return value;
		} else {
			return this._onRendering;
		}
	}

	, 
	_scaling: null,
	scaling: function (value) {
		if (arguments.length === 1) {
			this._scaling = value;
			return value;
		} else {
			return this._scaling;
		}
	}

	, 
	_strip: null,
	strip: function (value) {
		if (arguments.length === 1) {
			this._strip = value;
			return value;
		} else {
			return this._strip;
		}
	}

	, 
	_line: null,
	line: function (value) {
		if (arguments.length === 1) {
			this._line = value;
			return value;
		} else {
			return this._line;
		}
	}

	, 
	_shouldRenderLines: null,
	shouldRenderLines: function (value) {
		if (arguments.length === 1) {
			this._shouldRenderLines = value;
			return value;
		} else {
			return this._shouldRenderLines;
		}
	}

	, 
	_shouldRenderContent: null,
	shouldRenderContent: function (value) {
		if (arguments.length === 1) {
			this._shouldRenderContent = value;
			return value;
		} else {
			return this._shouldRenderContent;
		}
	}

	, 
	_axisLine: null,
	axisLine: function (value) {
		if (arguments.length === 1) {
			this._axisLine = value;
			return value;
		} else {
			return this._axisLine;
		}
	}

	, 
	_determineCrossingValue: null,
	determineCrossingValue: function (value) {
		if (arguments.length === 1) {
			this._determineCrossingValue = value;
			return value;
		} else {
			return this._determineCrossingValue;
		}
	}

	, 
	_shouldRenderLabel: null,
	shouldRenderLabel: function (value) {
		if (arguments.length === 1) {
			this._shouldRenderLabel = value;
			return value;
		} else {
			return this._shouldRenderLabel;
		}
	}

	, 
	_getLabelLocation: null,
	getLabelLocation: function (value) {
		if (arguments.length === 1) {
			this._getLabelLocation = value;
			return value;
		} else {
			return this._getLabelLocation;
		}
	}

	, 
	_transformToLabelValue: null,
	transformToLabelValue: function (value) {
		if (arguments.length === 1) {
			this._transformToLabelValue = value;
			return value;
		} else {
			return this._transformToLabelValue;
		}
	}

	, 
	_labelManager: null,
	labelManager: function (value) {
		if (arguments.length === 1) {
			this._labelManager = value;
			return value;
		} else {
			return this._labelManager;
		}
	}

	, 
	_getLabelForItem: null,
	getLabelForItem: function (value) {
		if (arguments.length === 1) {
			this._getLabelForItem = value;
			return value;
		} else {
			return this._getLabelForItem;
		}
	}

	, 
	_createRenderingParams: null,
	createRenderingParams: function (value) {
		if (arguments.length === 1) {
			this._createRenderingParams = value;
			return value;
		} else {
			return this._createRenderingParams;
		}
	}

	, 
	_snapMajorValue: null,
	snapMajorValue: function (value) {
		if (arguments.length === 1) {
			this._snapMajorValue = value;
			return value;
		} else {
			return this._snapMajorValue;
		}
	}

	, 
	_adjustMajorValue: null,
	adjustMajorValue: function (value) {
		if (arguments.length === 1) {
			this._adjustMajorValue = value;
			return value;
		} else {
			return this._adjustMajorValue;
		}
	}

	, 
	_getGroupCenter: null,
	getGroupCenter: function (value) {
		if (arguments.length === 1) {
			this._getGroupCenter = value;
			return value;
		} else {
			return this._getGroupCenter;
		}
	}

	, 
	_getUnscaledGroupCenter: null,
	getUnscaledGroupCenter: function (value) {
		if (arguments.length === 1) {
			this._getUnscaledGroupCenter = value;
			return value;
		} else {
			return this._getUnscaledGroupCenter;
		}
	}

	, 
	render: function (animate, viewportRect, windowRect) {
		var $self = this;
		$self.clearLabels(windowRect, viewportRect);
		if ($self.shouldRender()(viewportRect, windowRect)) {
			$self.onRendering()();
			var renderingParams = $self.createRenderingParams()(viewportRect, windowRect);
			$self.clearLabels(windowRect, viewportRect);
			if (renderingParams == null) {
				$self.resetLabels();
				return;
			}

			if (renderingParams.rangeInfos().count() > 1 && !renderingParams.hasUserInterval()) {
				$self.spreadInterval(renderingParams);
			}

			var en = renderingParams.rangeInfos().getEnumerator();
			while (en.moveNext()) {
				var range = en.current();
				renderingParams.currentRangeInfo(range);
				if ($.ig.util.isNaN(range.visibleMaximum()) || Number.isInfinity(range.visibleMaximum()) || $.ig.util.isNaN(range.visibleMinimum()) || Number.isInfinity(range.visibleMinimum())) {
					continue;
				}

				if (range.visibleMinimum() == range.visibleMaximum()) {
					continue;
				}

				$self.determineCrossingValue()(renderingParams);
				$self.labelManager().floatPanel(renderingParams.crossingValue());
				var mode = $.ig.CategoryMode.prototype.mode0;
				var mode2GroupCount = 0;
				var isInverted = false;
				var getUnscaledGroupCenter = function (n) { return n; };
				if ($self.getGroupCenter() != null) {
					getUnscaledGroupCenter = $self.getUnscaledGroupCenter();
				}

				if ($.ig.util.cast($.ig.CategoryAxisRenderingParameters.prototype.$type, renderingParams) !== null) {
					mode = (renderingParams).categoryMode();
					mode2GroupCount = (renderingParams).mode2GroupCount();
					isInverted = (renderingParams).isInverted();
				}

				renderingParams.tickmarkValues($self.getTickmarkValues(renderingParams));
				renderingParams.tickmarkValues().initialize((function () { var $ret = new $.ig.TickmarkValuesInitializationParameters();
				$ret.visibleMinimum(renderingParams.currentRangeInfo().visibleMinimum());
				$ret.visibleMaximum(renderingParams.currentRangeInfo().visibleMaximum());
				$ret.actualMinimum(renderingParams.actualMinimumValue());
				$ret.actualMaximum(renderingParams.actualMaximumValue());
				$ret.resolution(renderingParams.currentRangeInfo().resolution());
				$ret.hasUserInterval(renderingParams.hasUserInterval());
				$ret.userInterval(renderingParams.interval());
				$ret.intervalOverride(renderingParams.currentRangeInfo().intervalOverride());
				$ret.minorCountOverride(renderingParams.currentRangeInfo().minorCountOverride());
				$ret.mode(mode);
				$ret.mode2GroupCount(mode2GroupCount);
				$ret.window(renderingParams.windowRect());
				$ret.viewport(renderingParams.viewportRect());
				$ret.isInverted(isInverted);
				$ret.getUnscaledGroupCenter(getUnscaledGroupCenter); return $ret;}()));
				$self.renderInternal(renderingParams);
			}

			$self.renderLabels();
		}

	}

	, 
	resetLabels: function () {
		this.labelManager().resetLabels();
	}

	, 
	spreadInterval: function (renderingParams) {
		var $self = this;
		var maxInterval = -1.7976931348623157E+308;
		var maxMinorCount = -2147483648;
		var mode = $.ig.CategoryMode.prototype.mode0;
		var mode2GroupCount = 0;
		var isInverted = false;
		var getUnscaledGroupCenter = function (n) { return n; };
		if ($self.getGroupCenter() != null) {
			getUnscaledGroupCenter = $self.getUnscaledGroupCenter();
		}

		if ($.ig.util.cast($.ig.CategoryAxisRenderingParameters.prototype.$type, renderingParams) !== null) {
			mode = (renderingParams).categoryMode();
			mode2GroupCount = (renderingParams).mode2GroupCount();
			isInverted = (renderingParams).isInverted();
		}

		var en = renderingParams.rangeInfos().getEnumerator();
		while (en.moveNext()) {
			var rangeInfo = en.current();
			renderingParams.currentRangeInfo(rangeInfo);
			renderingParams.tickmarkValues().initialize((function () { var $ret = new $.ig.TickmarkValuesInitializationParameters();
			$ret.visibleMinimum(rangeInfo.visibleMinimum());
			$ret.visibleMaximum(rangeInfo.visibleMaximum());
			$ret.actualMinimum(renderingParams.actualMinimumValue());
			$ret.actualMaximum(renderingParams.actualMaximumValue());
			$ret.resolution(rangeInfo.resolution());
			$ret.hasUserInterval(renderingParams.hasUserInterval());
			$ret.userInterval(renderingParams.interval());
			$ret.intervalOverride(rangeInfo.intervalOverride());
			$ret.minorCountOverride(rangeInfo.minorCountOverride());
			$ret.mode(mode);
			$ret.mode2GroupCount(mode2GroupCount);
			$ret.window(renderingParams.windowRect());
			$ret.viewport(renderingParams.viewportRect());
			$ret.isInverted(isInverted);
			$ret.getUnscaledGroupCenter(getUnscaledGroupCenter); return $ret;}()));
			rangeInfo.intervalOverride(renderingParams.tickmarkValues().interval());
			rangeInfo.minorCountOverride(renderingParams.tickmarkValues().minorCount());
			if (!$.ig.util.isNaN(renderingParams.tickmarkValues().interval())) {
				maxInterval = Math.max(maxInterval, renderingParams.tickmarkValues().interval());
				maxMinorCount = Math.max(maxMinorCount, renderingParams.tickmarkValues().minorCount());
			}

		}

		var en1 = renderingParams.rangeInfos().getEnumerator();
		while (en1.moveNext()) {
			var rangeInfo1 = en1.current();
			if (rangeInfo1.intervalOverride() == maxInterval) {
				rangeInfo1.intervalOverride(-1);
				rangeInfo1.minorCountOverride(-1);

			} else {
				rangeInfo1.intervalOverride(maxInterval);
				rangeInfo1.minorCountOverride(maxMinorCount);
			}

		}

	}

	, 
	clearLabels: function (windowRect, viewportRect) {
		this.clear()();
		this.labelManager().clear(windowRect, viewportRect);
		this.labelManager().updateLabelPanel();
	}

	, 
	renderLabels: function () {
		this.labelManager().updateLabelPanel();
		if (this.labelManager().labelsHidden()) {
			this.labelManager().setTextBlockCount(0);

		} else {
			var textBlockCount = 0;
			var en = this.labelManager().labelDataContext().getEnumerator();
			while (en.moveNext()) {
				var labelObj = en.current();
				var label = $.ig.util.cast($.ig.FrameworkElement.prototype.$type, labelObj);
				if (label == null) {
					label = this.labelManager().getTextBlock(textBlockCount);
					(label).text(labelObj.toString());
					textBlockCount++;

				} else {
					this.labelManager().addLabel(label);
				}

			}

			this.labelManager().setTextBlockCount(textBlockCount);
		}

	}

	, 
	getTickmarkValues: function (renderingParams) {
		return renderingParams.tickmarkValues();
	}

	, 
	renderInternal: function (renderingParams) {
		var majorTicks = renderingParams.tickmarkValues().majorValuesArray();
		var minorTicks = renderingParams.tickmarkValues().minorValuesArray();
		this.labelManager().setLabelInterval(this.scaling()(renderingParams, renderingParams.tickmarkValues().interval()));
		this.axisLine()(renderingParams);
		for (var maj = 0; maj < majorTicks.length; maj++) {
			var absoluteIndex = renderingParams.tickmarkValues().firstIndex() + maj;
			var majorTick = majorTicks[maj];
			var unscaledValue = majorTick;
			var nextUnscaledValue = 0;
			if (maj < majorTicks.length - 1) {
				nextUnscaledValue = majorTicks[maj + 1];

			} else {
				nextUnscaledValue = Number.POSITIVE_INFINITY;
			}

			unscaledValue = this.snapMajorValue()(renderingParams, unscaledValue, absoluteIndex, renderingParams.tickmarkValues().interval());
			nextUnscaledValue = this.snapMajorValue()(renderingParams, nextUnscaledValue, absoluteIndex, renderingParams.tickmarkValues().interval());
			var majorValue = this.scaling()(renderingParams, unscaledValue);
			var nextMajorValue = this.scaling()(renderingParams, nextUnscaledValue);
			if (this.shouldRenderLines()(renderingParams, majorValue)) {
				if (absoluteIndex % 2 == 0 && this.shouldRenderContent()(renderingParams, nextMajorValue) && !Number.isInfinity(nextMajorValue)) {
					this.strip()(renderingParams, renderingParams.strips(), majorValue, nextMajorValue);
				}

				renderingParams.currentRenderingInfo(renderingParams.majorRenderingInfo());
				this.line()(renderingParams, renderingParams.major(), majorValue);
				renderingParams.currentRenderingInfo(null);
			}

			majorValue = this.adjustMajorValue()(renderingParams, majorValue, absoluteIndex, renderingParams.tickmarkValues().interval());
			if (!$.ig.util.isNaN(majorValue) && !Number.isInfinity(majorValue) && this.shouldRenderLabel()(renderingParams, majorValue, maj == majorTicks.length - 1)) {
				var label = this.getLabel(renderingParams, unscaledValue, absoluteIndex, renderingParams.tickmarkValues().interval());
				if (label != null) {
					this.labelManager().addLabelObject(label, this.getLabelLocation()(renderingParams, majorValue));
				}

			}

		}

		if (renderingParams.shouldRenderMinorLines()) {
			for (var min = 0; min < minorTicks.length; min++) {
				var minorTick = minorTicks[min];
				var minorValue = this.scaling()(renderingParams, minorTick);
				renderingParams.currentRenderingInfo(renderingParams.minorRenderingInfo());
				this.line()(renderingParams, renderingParams.minor(), minorValue);
				renderingParams.currentRenderingInfo(null);
			}

		}

	}

	, 
	getLabel: function (renderingParams, unscaledValue, index, interval) {
		return null;
	}
	, 
	$type: new $.ig.Type('AxisRendererBase', $.ig.Object.prototype.$type)
}, true);


$.ig.util.defType('CategoryXAxis', 'CategoryAxisBase', {

	createView: function () {
		return new $.ig.CategoryXAxisView(this);
	}

	, 
	onViewCreated: function (view) {
		$.ig.CategoryAxisBase.prototype.onViewCreated.call(this, view);
		this.xView(view);
	}

	, 
	_xView: null,
	xView: function (value) {
		if (arguments.length === 1) {
			this._xView = value;
			return value;
		} else {
			return this._xView;
		}
	}
	, 
	init: function () {


		this.__actualMinimum = 1;
		this.__actualMaximum = 1;

		$.ig.CategoryAxisBase.prototype.init.call(this);
			this.majorLinePositions(new $.ig.List$1(Number, 0));
			this.defaultStyleKey($.ig.CategoryXAxis.prototype.$type);
	}
	, 
	__actualMinimum: 0

	, 
	actualMinimum: function (value) {
		if (arguments.length === 1) {

			this.__actualMinimum = value;
			return value;
		} else {

			return this.__actualMinimum;
		}
	}
	, 
	__actualMaximum: 0

	, 
	actualMaximum: function (value) {
		if (arguments.length === 1) {

			this.__actualMaximum = value;
			return value;
		} else {

			return this.__actualMaximum;
		}
	}

	, 
	createLabelPanel: function () {
		if (this.useSmartAxis()) {
			return new $.ig.SmartAxisLabelPanel();

		} else {
			return new $.ig.HorizontalAxisLabelPanel();
		}

	}

	, 
	getCategorySize: function (windowRect, viewportRect) {
		return viewportRect.width() / (this._cachedItemsCount * windowRect.width());
	}

	, 
	getGroupSize: function (windowRect, viewportRect) {
		var gap = !$.ig.util.isNaN(this.gap()) ? $.ig.MathUtil.prototype.clamp(this.gap(), 0, 1) : 0;
		var overlap = 0;
		if (!$.ig.util.isNaN(this.overlap())) {
			overlap = Math.min(this.overlap(), 1);

		} else {
			overlap = 0;
		}

		;var categorySpace = 1 - 0.5 * gap;
		var mode2GroupCount = this.mode2GroupCount() == 0 ? 1 : this.mode2GroupCount();
		var ret = this.getCategorySize(windowRect, viewportRect) * categorySpace / (mode2GroupCount - (mode2GroupCount - 1) * overlap);
		return ret;
	}

	, 
	getGroupCenter: function (groupIndex, windowRect, viewportRect) {
		var groupCenter = 0.5;
		if (this.mode2GroupCount() > 1) {
			var gap = !$.ig.util.isNaN(this.gap()) ? $.ig.MathUtil.prototype.clamp(this.gap(), 0, 1) : 0;
			var overlap = 0;
			if (!$.ig.util.isNaN(this.overlap())) {
				overlap = Math.min(this.overlap(), 1);
			}

			var categorySpace = 1 - 0.5 * gap;
			var groupWidth = categorySpace / (this.mode2GroupCount() - (this.mode2GroupCount() - 1) * overlap);
			var groupSep = (categorySpace - groupWidth) / (this.mode2GroupCount() - 1);
			groupCenter = 0.25 * gap + 0.5 * groupWidth + groupIndex * groupSep;
		}

		return this.getCategorySize(windowRect, viewportRect) * groupCenter;
	}

	, 
	scrollIntoView: function (item) {
		var windowRect = this.seriesViewer() != null ? this.seriesViewer().actualWindowRect() : $.ig.Rect.prototype.empty();
		var viewportRect = this.viewportRect();
		var unitRect = new $.ig.Rect(0, 0, 0, 1, 1);
		var xParams = new $.ig.ScalerParams(unitRect, unitRect, this.isInverted());
		var index = !windowRect.isEmpty() && !viewportRect.isEmpty() && this.fastItemsSource() != null ? this.fastItemsSource().indexOf(item) : -1;
		var cx = index > -1 ? this.getScaledValue(index, xParams) : NaN;
		if (!$.ig.util.isNaN(cx) && this.seriesViewer().isSyncReady()) {
			if (!$.ig.util.isNaN(cx)) {
				if (cx < windowRect.left() + 0.1 * windowRect.width()) {
					cx = cx + 0.4 * windowRect.width();
					windowRect.x(cx - 0.5 * windowRect.width());
				}

				if (cx > windowRect.right() - 0.1 * windowRect.width()) {
					cx = cx - 0.4 * windowRect.width();
					windowRect.x(cx - 0.5 * windowRect.width());
				}

			}

			this.seriesViewer().windowNotify(windowRect);
		}

	}

	, 
	getScaledValue: function (unscaledValue, p) {
		var itemCount = this.categoryMode() == $.ig.CategoryMode.prototype.mode0 ? this._cachedItemsCount - 1 : this._cachedItemsCount;
		if (itemCount < 0) {
			itemCount = 0;
		}

		var scaledValue = itemCount >= 1 ? (unscaledValue) / (itemCount) : itemCount == 0 ? 0.5 : NaN;
		if (this.isInvertedCached()) {
			scaledValue = 1 - scaledValue;
		}

		return p._viewportRect.left() + p._viewportRect.width() * (scaledValue - p._windowRect.left()) / p._windowRect.width();
	}

	, 
	getUnscaledValue: function (scaledValue, p) {
		return this.getUnscaledValue2(scaledValue, p._windowRect, p._viewportRect, this.categoryMode());
	}

	, 
	getUnscaledValue2: function (scaledValue, windowRect, viewportRect, categoryMode) {
		var unscaledValue = windowRect.left() + (scaledValue - viewportRect.left()) * windowRect.width() / viewportRect.width();
		if (this.isInvertedCached()) {
			unscaledValue = 1 - unscaledValue;
		}

		var itemCount = categoryMode == $.ig.CategoryMode.prototype.mode0 ? this._cachedItemsCount - 1 : this._cachedItemsCount;
		if (itemCount < 0) {
			itemCount = 0;
		}

		return unscaledValue * itemCount;
	}

	, 
	renderAxisOverride: function (animate) {
		$.ig.CategoryAxisBase.prototype.renderAxisOverride.call(this, animate);
		var windowRect = this.seriesViewer() != null ? this.seriesViewer().actualWindowRect() : $.ig.Rect.prototype.empty();
		var viewportRect = this.viewportRect();
		var xParams = new $.ig.ScalerParams(windowRect, viewportRect, this.isInverted());
		var axisGeometry = this.view().getAxisLinesGeometry();
		var stripsGeometry = this.view().getStripsGeometry();
		var majorGeometry = this.view().getMajorLinesGeometry();
		var minorGeometry = this.view().getMinorLinesGeometry();
		var axisLinesPathInfo = this.view().getAxisLinesPathInfo();
		var majorLinesPathInfo = this.view().getMajorLinesPathInfo();
		var minorLinesPathInfo = this.view().getMinorLinesPathInfo();
		var fastItemsSource = this.fastItemsSource();
		this.updateLineVisibility();
		this.clearMarks(axisGeometry);
		this.clearMarks(stripsGeometry);
		this.clearMarks(majorGeometry);
		this.clearMarks(minorGeometry);
		this.labelDataContext().clear();
		this.labelPositions().clear();
		this.majorLinePositions().clear();
		this.view().updateLabelPanel(this, windowRect, viewportRect);
		if (windowRect.isEmpty() || viewportRect.isEmpty()) {
			this.textBlocks().count(0);
		}

		if (this.textBlocks().count() == 0) {
			this.view().clearLabelPanel();
		}

		if (this.labelSettings() != null) {
			this.labelSettings().registerAxis(this);
		}

		if (this.itemsSource() == null || fastItemsSource == null || fastItemsSource.count() == 0) {
		return;
		}

		if (!windowRect.isEmpty() && !viewportRect.isEmpty()) {
			var visibleMinimum = this.getUnscaledValue(viewportRect.left(), xParams);
			var visibleMaximum = this.getUnscaledValue(viewportRect.right(), xParams);
			if (this.isInverted()) {
				visibleMinimum = Math.ceil(visibleMinimum);
				visibleMaximum = Math.floor(visibleMaximum);

			} else {
				visibleMinimum = Math.floor(visibleMinimum);
				visibleMaximum = Math.ceil(visibleMaximum);
			}

			var crossingValue = viewportRect.bottom();
			var relativeCrossingValue = crossingValue - viewportRect.top();
			if (this.crossingAxis() != null) {
				var yAxis = $.ig.util.cast($.ig.NumericYAxis.prototype.$type, this.crossingAxis());
				if (yAxis != null) {
					var yParams = new $.ig.ScalerParams(windowRect, viewportRect, yAxis.isInverted());
					crossingValue = this.crossingValue();
					crossingValue = yAxis.getScaledValue(crossingValue, yParams);
					relativeCrossingValue = crossingValue - viewportRect.top();
					if (crossingValue < viewportRect.top()) {
						crossingValue = viewportRect.top();

					} else if (crossingValue > viewportRect.bottom()) {
						crossingValue = viewportRect.bottom();
					}


					if (relativeCrossingValue < 0) {
						relativeCrossingValue = 0;

					} else if (relativeCrossingValue > viewportRect.height()) {
						relativeCrossingValue = viewportRect.height();
					}


				}

			}

			this.horizontalLine(axisGeometry, crossingValue, viewportRect, axisLinesPathInfo);
			this.view().setLabelPanelCrossingValue(relativeCrossingValue);
			var trueVisibleMinimum = Math.min(visibleMinimum, visibleMaximum);
			var trueVisibleMaximum = Math.max(visibleMinimum, visibleMaximum);
			var snapper = new $.ig.LinearCategorySnapper(1, trueVisibleMinimum, trueVisibleMaximum, viewportRect.width(), this.interval(), this.categoryMode());
			var firstValue = Math.floor((trueVisibleMinimum - 0) / snapper.interval());
			var lastValue = Math.ceil((trueVisibleMaximum - 0) / snapper.interval());
			if (!$.ig.util.isNaN(firstValue) && !$.ig.util.isNaN(lastValue)) {
				var first = $.ig.truncate(firstValue);
				var last = $.ig.truncate(lastValue);
				var majorValue = this.getScaledValue(0 + first * snapper.interval(), xParams);
				this.view().setLabelPanelInterval(this.getScaledValue(snapper.interval(), xParams));
				var viewportPixelRight = $.ig.truncate(Math.ceil(viewportRect.right()));
				var viewportPixelLeft = $.ig.truncate(Math.floor(viewportRect.left()));
				for (var i = first; i <= last; ++i) {
					var nextMajorValue = this.getScaledValue(0 + (i + 1) * snapper.interval(), xParams);
					if (majorValue <= viewportRect.right()) {
						if (i % 2 == 0) {
							this.verticalStrip(stripsGeometry, majorValue, nextMajorValue, viewportRect);
						}

						this.verticalLine(majorGeometry, majorValue, viewportRect, majorLinesPathInfo);
						this.majorLinePositions().add(majorValue);
						if (this.categoryMode() != $.ig.CategoryMode.prototype.mode0 && this.mode2GroupCount() != 0 && this.shouldRenderMinorLines()) {
							for (var categoryNumber = 0; categoryNumber < $.ig.truncate(snapper.interval()); categoryNumber++) {
								for (var groupNumber = 0; groupNumber < this.mode2GroupCount(); groupNumber++) {
									var center = this.getGroupCenter(groupNumber, windowRect, viewportRect);
									if (this.isInverted()) {
									center = -center;
									}

									var minorValue = this.getScaledValue(categoryNumber + i * snapper.interval(), xParams) + center;
									this.verticalLine(minorGeometry, minorValue, viewportRect, minorLinesPathInfo);
								}

							}

						}

					}

					var categoryValue = majorValue;
					if (this.categoryMode() != $.ig.CategoryMode.prototype.mode0) {
						var nextCategoryValue = this.getScaledValue(i * snapper.interval() + 1, xParams);
						categoryValue = (majorValue + nextCategoryValue) / 2;
					}

					var categoryPixelValue = $.ig.truncate(Math.round(categoryValue));
					if (categoryPixelValue >= viewportPixelLeft && categoryPixelValue <= viewportPixelRight) {
						var itemIndex = 0;
						if (snapper.interval() >= 1) {
							itemIndex = i * $.ig.truncate(Math.floor(snapper.interval()));

						} else {
							if ((i * snapper.interval()) * 2 % 2 == 0) {
								itemIndex = $.ig.truncate(Math.floor(i * snapper.interval()));

							} else {
								itemIndex = -1;
							}

						}

						if (fastItemsSource != null && itemIndex < fastItemsSource.count() && itemIndex >= 0) {
							var dataItem = fastItemsSource.item(itemIndex);
							var labelText = this.getLabel(dataItem);
							if (!$.ig.util.isNaN(categoryValue) && !Number.isInfinity(categoryValue) && labelText != null) {
								if (($.ig.util.cast(String, labelText) !== null || typeof labelText === "string") && (labelText).equals("")) {

								} else {
									this.labelDataContext().add1(labelText);
									this.labelPositions().add(new $.ig.LabelPosition(categoryValue));
								}

							}

						}

					}

					majorValue = nextMajorValue;
				}

			}

			if ((this.labelSettings() == null || this.labelSettings().visibility() == $.ig.Visibility.prototype.visible) && this.crossingAxis() != null) {
				if (this.labelSettings() != null && (this.labelSettings().location() == $.ig.AxisLabelsLocation.prototype.insideTop || this.labelSettings().location() == $.ig.AxisLabelsLocation.prototype.insideBottom)) {
					this.seriesViewer().invalidatePanels();
				}

			}

			this.view().updateLabelPanelContent(this.labelDataContext(), this.labelPositions());
			this.renderLabels();
		}

	}

	, 
	updateRangeOverride: function () {
		if (this.fastItemsSource() == null) {
			return false;
		}

		var max = this.fastItemsSource().count();
		if (max != this.actualMaximum()) {
			var ea = new $.ig.AxisRangeChangedEventArgs(1, 1, this.actualMaximum(), max);
			this.actualMaximum(max);
			this.raiseRangeChanged(ea);
			return true;
		}

		return false;
	}

	, 
	interval: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.CategoryXAxis.prototype.intervalProperty, value);
			return value;
		} else {

			return this.getValue($.ig.CategoryXAxis.prototype.intervalProperty);
		}
	}

	, 
	shouldShareMode: function (chart) {
		if (chart == null) {
			return false;
		}

		var settings = this.getSyncSettings();
		if (settings == null) {
			return false;
		}

		return settings.synchronizeHorizontally();
	}

	, 
	orientation: function () {

			return $.ig.AxisOrientation.prototype.horizontal;
	}
	, 
	$type: new $.ig.Type('CategoryXAxis', $.ig.CategoryAxisBase.prototype.$type)
}, true);

$.ig.util.defType('CategoryXAxisView', 'CategoryAxisBaseView', {

	_xModel: null,
	xModel: function (value) {
		if (arguments.length === 1) {
			this._xModel = value;
			return value;
		} else {
			return this._xModel;
		}
	}
	, 
	init: function (model) {



		$.ig.CategoryAxisBaseView.prototype.init.call(this, model);
			this.xModel(model);
	}
	, 
	$type: new $.ig.Type('CategoryXAxisView', $.ig.CategoryAxisBaseView.prototype.$type)
}, true);






$.ig.util.defType('NumericAxisBase', 'Axis', {

	createView: function () {
		return new $.ig.NumericAxisBaseView(this);
	}

	, 
	onViewCreated: function (view) {
		$.ig.Axis.prototype.onViewCreated.call(this, view);
		this.numericView(view);
	}

	, 
	_numericView: null,
	numericView: function (value) {
		if (arguments.length === 1) {
			this._numericView = value;
			return value;
		} else {
			return this._numericView;
		}
	}

	, 
	isNumeric: function () {

			return true;
	}
	, 
	init: function () {



		$.ig.Axis.prototype.init.call(this);
			this.logarithmBaseCached(10);
	}

	, 
	minimumValue: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.NumericAxisBase.prototype.minimumValueProperty, value);
			return value;
		} else {

			return this.getValue($.ig.NumericAxisBase.prototype.minimumValueProperty);
		}
	}

	, 
	actualMinimumValue: function (value) {
		if (arguments.length === 1) {

			if (this.actualMinimumValue() != value) {
				var oldValue = this._actualMinimumValue;
				this._actualMinimumValue = value;
				this.logActualMinimumValue(Math.log(this.actualMinimumValue()));
				this.raisePropertyChanged($.ig.NumericAxisBase.prototype.actualMinimumValuePropertyName, oldValue, this.actualMinimumValue());
			}

			return value;
		} else {

			return this._actualMinimumValue;
		}
	}
	, 
	_actualMinimumValue: 0

	, 
	_logActualMinimumValue: 0,
	logActualMinimumValue: function (value) {
		if (arguments.length === 1) {
			this._logActualMinimumValue = value;
			return value;
		} else {
			return this._logActualMinimumValue;
		}
	}

	, 
	maximumValue: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.NumericAxisBase.prototype.maximumValueProperty, value);
			return value;
		} else {

			return this.getValue($.ig.NumericAxisBase.prototype.maximumValueProperty);
		}
	}

	, 
	actualMaximumValue: function (value) {
		if (arguments.length === 1) {

			if (this.actualMaximumValue() != value) {
				var oldValue = this._actualMaximumValue;
				this._actualMaximumValue = value;
				this.logActualMaximumValue(Math.log(this.actualMaximumValue()));
				this.raisePropertyChanged($.ig.NumericAxisBase.prototype.actualMaximumValuePropertyName, oldValue, this.actualMaximumValue());
			}

			return value;
		} else {

			return this._actualMaximumValue;
		}
	}
	, 
	_actualMaximumValue: 0

	, 
	_logActualMaximumValue: 0,
	logActualMaximumValue: function (value) {
		if (arguments.length === 1) {
			this._logActualMaximumValue = value;
			return value;
		} else {
			return this._logActualMaximumValue;
		}
	}

	, 
	interval: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.NumericAxisBase.prototype.intervalProperty, value);
			return value;
		} else {

			return this.getValue($.ig.NumericAxisBase.prototype.intervalProperty);
		}
	}

	, 
	referenceValue: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.NumericAxisBase.prototype.referenceValueProperty, value);
			return value;
		} else {

			return this.getValue($.ig.NumericAxisBase.prototype.referenceValueProperty);
		}
	}

	, 
	isLogarithmic: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.NumericAxisBase.prototype.isLogarithmicProperty, value);
			return value;
		} else {

			return this.getValue($.ig.NumericAxisBase.prototype.isLogarithmicProperty);
		}
	}
	, 
	__actualIsLogarithmic: false

	, 
	actualIsLogarithmic: function (value) {
		if (arguments.length === 1) {

			if (this.actualIsLogarithmic() != value) {
				var oldValue = this.__actualIsLogarithmic;
				if (oldValue != value) {
					this.__actualIsLogarithmic = value;
					this.raisePropertyChanged($.ig.NumericAxisBase.prototype._actualIsLogarithmicPropertyName, oldValue, this.actualIsLogarithmic());
				}

			}

			return value;
		} else {

			return this.__actualIsLogarithmic;
		}
	}

	, 
	isReallyLogarithmic: function () {

			return this.actualIsLogarithmic() && this.actualMinimumValue() > 0 && this.logarithmBaseCached() > 1;
	}

	, 
	logarithmBase: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.NumericAxisBase.prototype.logarithmBaseProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.NumericAxisBase.prototype.logarithmBaseProperty));
		}
	}

	, 
	_logarithmBaseCached: 0,
	logarithmBaseCached: function (value) {
		if (arguments.length === 1) {
			this._logarithmBaseCached = value;
			return value;
		} else {
			return this._logarithmBaseCached;
		}
	}

	, 
	_renderer: null,
	renderer: function (value) {
		if (arguments.length === 1) {
			this._renderer = value;
			return value;
		} else {
			return this._renderer;
		}
	}

	, 
	_logDirty: false,
	logDirty: function (value) {
		if (arguments.length === 1) {
			this._logDirty = value;
			return value;
		} else {
			return this._logDirty;
		}
	}

	, 
	renderAxisOverride: function (animate) {
		var $self = this;
		$.ig.Axis.prototype.renderAxisOverride.call($self, animate);
		if ($self.isReallyLogarithmic() && $self.seriesViewer() != null) {
			var renderingParams = $self.createRenderingParams($self.viewportRect(), $self.seriesViewer().actualWindowRect());
			if (renderingParams == null) {
				return;
			}

			for (var i = 0; i < renderingParams.rangeInfos().count(); i++) {
				var logBase = $self.logarithmBase();
				var currentRange = renderingParams.rangeInfos().__inner[i];
				var trueVisibleMinimum = Math.min(currentRange.visibleMinimum(), currentRange.visibleMaximum());
				var trueVisibleMaximum = Math.max(currentRange.visibleMinimum(), currentRange.visibleMaximum());
				var logMin = Math.floor(Math.logBase(trueVisibleMinimum, logBase));
				var logMax = Math.ceil(Math.logBase(trueVisibleMaximum, logBase));
				if (logMax - logMin < 2) {
					if ($.ig.util.cast($.ig.LogarithmicTickmarkValues.prototype.$type, $self.__actualTickmarkValues) !== null) {
						$self.__actualTickmarkValues = new $.ig.LinearTickmarkValues();
					}


				} else {
					$self.__actualTickmarkValues = $self.tickmarkValues() != null ? $self.tickmarkValues() : (function () { var $ret = new $.ig.LogarithmicTickmarkValues();
					$ret.logarithmBase(logBase); return $ret;}());
				}

			}

		}

	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		$.ig.Axis.prototype.propertyUpdatedOverride.call(this, sender, propertyName, oldValue, newValue);
		switch (propertyName) {
			case $.ig.NumericAxisBase.prototype.minimumValuePropertyName:
				this.updateRange();
				this.renderAxis1(false);
				break;
			case $.ig.NumericAxisBase.prototype.maximumValuePropertyName:
				this.updateRange();
				this.renderAxis1(false);
				break;
			case $.ig.NumericAxisBase.prototype.isLogarithmicPropertyName:
				this.logDirty(true);
				this.actualIsLogarithmic(this.isLogarithmic());
				break;
			case $.ig.Axis.prototype.crossingValuePropertyName:
			case $.ig.Axis.prototype.crossingAxisPropertyName:
			case $.ig.NumericAxisBase.prototype.intervalPropertyName:
				this.mustInvalidateLabels(true);
				this.renderAxis1(false);
				break;
			case $.ig.NumericAxisBase.prototype.logarithmBasePropertyName:
				this.logDirty(true);
				this.logarithmBaseCached(this.logarithmBase());
				if (this.actualIsLogarithmic()) {
					this.updateRange();
					this.invalidateSeries();
					this.renderAxis1(false);
				}

				break;
			case $.ig.NumericAxisBase.prototype.referenceValuePropertyName:
				var ea = new $.ig.AxisRangeChangedEventArgs(this.actualMinimumValue(), this.actualMinimumValue(), this.actualMaximumValue(), this.actualMaximumValue());
				this.raiseRangeChanged(ea);
				this.mustInvalidateLabels(true);
				this.renderAxis1(false);
				break;
			case $.ig.NumericAxisBase.prototype.labelSettingsPropertyName:
				this.renderer(this.createRenderer());
				this.mustInvalidateLabels(true);
				this.renderAxis1(false);
				break;
			case $.ig.NumericAxisBase.prototype._tickmarkValuesPropertyName:
				this.updateActualTickmarkValues();
				break;
			case $.ig.NumericAxisBase.prototype._actualIsLogarithmicPropertyName:
				this.updateRange();
				this.invalidateSeries();
				this.mustInvalidateLabels(true);
				this.updateActualTickmarkValues();
				this.renderAxis1(false);
				break;
			case $.ig.NumericAxisBase.prototype._actualTickmarkValuesPropertyName:
				this.mustInvalidateLabels(true);
				this.renderAxis1(false);
				break;
		}

	}

	, 
	invalidateSeries: function () {
		var en = this.directSeries().getEnumerator();
		while (en.moveNext()) {
			var series = en.current();
			series.renderSeries(false);
		}

	}

	, 
	getAxisRange: function () {
		var newRange = new $.ig.AxisRange(Number.POSITIVE_INFINITY, Number.NEGATIVE_INFINITY);
		var rangeFound = false;
		if (this.seriesViewer() != null) {
			var en = this.directSeries().getEnumerator();
			while (en.moveNext()) {
				var series = en.current();
				var range = series.getRange(this);
				if (range != null) {
					rangeFound = true;
					newRange = new $.ig.AxisRange(Math.min(newRange.minimum(), range.minimum()), Math.max(newRange.maximum(), range.maximum()));
				}

			}

		}

		if (rangeFound) {
			return newRange;
		}

		return null;
	}

	, 
	calculateRange: function (target, minimumValue, maximumValue, isLogarithmic, logarithmBase, actualMinimumValue, actualMaximumValue) {
		var $self = this;
		(function () { var $ret = $.ig.AutoRangeCalculator.prototype.calculateRange(target, minimumValue, maximumValue, isLogarithmic, logarithmBase, actualMinimumValue, actualMaximumValue); actualMinimumValue = $ret.p5; actualMaximumValue = $ret.p6; return $ret.ret; }());
		return {
			p5: actualMinimumValue, 
			p6: actualMaximumValue
		};
	}

	, 
	updateRangeOverride: function () {
		var $self = this;
		var isLogarithmic = $self.actualIsLogarithmic() && !$.ig.util.isNaN($self.logarithmBase()) && !Number.isInfinity($self.logarithmBase()) && $self.logarithmBase() > 1;
		var minimumValue;
		var maximumValue;
		(function () { var $ret = $self.calculateRange($self, $self.minimumValue(), $self.maximumValue(), isLogarithmic, $self.logarithmBase(), minimumValue, maximumValue); minimumValue = $ret.p5; maximumValue = $ret.p6; return $ret.ret; }());
		if (minimumValue != $self.actualMinimumValue() || maximumValue != $self.actualMaximumValue() || $self.logDirty()) {
			$self.logDirty(false);
			var ea = new $.ig.AxisRangeChangedEventArgs($self.actualMinimumValue(), minimumValue, $self.actualMaximumValue(), maximumValue);
			$self.actualMinimumValue(minimumValue);
			$self.actualMaximumValue(maximumValue);
			$self.raiseRangeChanged(ea);
			$self.onRangeChanged(ea);
			$self.renderAxis1(true);
			return true;
		}

		return false;
	}

	, 
	onRangeChanged: function (ea) {
	}

	, 
	registerSeries: function (series) {
		var success = $.ig.Axis.prototype.registerSeries.call(this, series);
		if (success) {
			this.updateRange();
		}

		return success;
	}

	, 
	deregisterSeries: function (series) {
		var success = $.ig.Axis.prototype.deregisterSeries.call(this, series);
		if (success) {
			this.updateRange();
		}

		return success;
	}

	, 
	createRenderer: function () {
		var $self = this;
		var labelManager = (function () { var $ret = new $.ig.AxisLabelManager();
		$ret.axis($self);
		$ret.labelPositions($self.labelPositions());
		$ret.labelDataContext($self.labelDataContext());
		$ret.targetPanel($self.labelPanel()); return $ret;}());
		if ($self.labelSettings() != null) {
			$self.labelSettings().registerAxis($self);
		}

		var renderer = new $.ig.NumericAxisRenderer(labelManager);
		renderer.clear(function () {
			var axisGeometry = $self.view().getAxisLinesGeometry();
			var stripsGeometry = $self.view().getStripsGeometry();
			var majorGeometry = $self.view().getMajorLinesGeometry();
			var minorGeometry = $self.view().getMinorLinesGeometry();
			$self.updateLineVisibility();
			$self.clearMarks(axisGeometry);
			$self.clearMarks(stripsGeometry);
			$self.clearMarks(majorGeometry);
			$self.clearMarks(minorGeometry);
		});
		renderer.shouldRender(function (viewport, window) {
			return !window.isEmpty() && !viewport.isEmpty();
		});
		renderer.createRenderingParams(function (viewport, window) {
			return $self.createRenderingParams(viewport, window);
		});
		renderer.getLabelForItem(function (item) {
			return $self.getLabel(item);
		});
		return renderer;
	}

	, 
	createRenderingParamsInstance: function () {
		return new $.ig.NumericAxisRenderingParameters();
	}

	, 
	floatLabelPanel: function () {
	}

	, 
	createScalerOverride: function () {
		return null;
	}

	, 
	createRenderingParams: function (viewportRect, windowRect) {
		var parameters = this.createRenderingParamsInstance();
		var axisGeometry = this.view().getAxisLinesGeometry();
		var stripsGeometry = this.view().getStripsGeometry();
		var majorGeometry = this.view().getMajorLinesGeometry();
		var minorGeometry = this.view().getMinorLinesGeometry();
		var axisRenderingInfo = this.view().getAxisLinesPathInfo();
		var majorLinesRenderingInfo = this.view().getMajorLinesPathInfo();
		var minorLinesRenderingInfo = this.view().getMinorLinesPathInfo();
		parameters.axisGeometry(axisGeometry);
		parameters.strips(stripsGeometry);
		parameters.major(majorGeometry);
		parameters.minor(minorGeometry);
		parameters.axisRenderingInfo(axisRenderingInfo);
		parameters.majorRenderingInfo(majorLinesRenderingInfo);
		parameters.minorRenderingInfo(minorLinesRenderingInfo);
		parameters.actualMaximumValue(this.actualMaximumValue());
		parameters.actualMinimumValue(this.actualMinimumValue());
		parameters.hasUserMax(this.hasUserMaximum());
		parameters.tickmarkValues(this.actualTickmarkValues());
		parameters.viewportRect(viewportRect);
		parameters.windowRect(windowRect);
		parameters.hasUserInterval(this.hasUserInterval());
		parameters.interval(this.interval());
		parameters.label(this.label());
		if (this.label() == null && this.formatLabel() != null) {
			parameters.label("Format");
		}

		parameters.shouldRenderMinorLines(this.shouldRenderMinorLines());
		return parameters;
	}

	, 
	unscaleValue: function (unscaledValue) {
		var sParams = new $.ig.ScalerParams(this.seriesViewer().windowRect(), this.viewportRect(), this.isInverted());
		sParams._effectiveViewportRect = this.seriesViewer().effectiveViewport();
		return this.getUnscaledValue(unscaledValue, sParams);
	}

	, 
	hasUserInterval: function () {
		return !$.ig.util.isNaN(this.interval());
	}

	, 
	hasUserMinimum: function () {

			return !$.ig.util.isNaN(this.minimumValue());
	}

	, 
	hasUserMaximum: function () {

			return !$.ig.util.isNaN(this.maximumValue());
	}

	, 
	updateActualTickmarkValues: function () {
		if (this.tickmarkValues() != null) {
			this.actualTickmarkValues(this.tickmarkValues());

		} else if (this.actualIsLogarithmic()) {
			this.actualTickmarkValues(new $.ig.LogarithmicTickmarkValues());
			this.numericView().bindLogarithmBaseToActualTickmarks();

		} else {
			this.actualTickmarkValues(new $.ig.LinearTickmarkValues());
		}


	}

	, 
	tickmarkValues: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.NumericAxisBase.prototype.tickmarkValuesProperty, value);
			return value;
		} else {

			return $.ig.util.cast($.ig.TickmarkValues.prototype.$type, this.getValue($.ig.NumericAxisBase.prototype.tickmarkValuesProperty));
		}
	}
	, 
	__actualTickmarkValues: null

	, 
	actualTickmarkValues: function (value) {
		if (arguments.length === 1) {

			var oldValue = this.__actualTickmarkValues;
			var changed = oldValue != value;
			if (changed) {
				this.__actualTickmarkValues = value;
				this.raisePropertyChanged($.ig.NumericAxisBase.prototype._actualTickmarkValuesPropertyName, oldValue, value);
			}

			return value;
		} else {

			if (this.__actualTickmarkValues == null) {
				this.updateActualTickmarkValues();
			}

			return this.__actualTickmarkValues;
		}
	}
	, 
	$type: new $.ig.Type('NumericAxisBase', $.ig.Axis.prototype.$type)
}, true);


$.ig.util.defType('NumericAxisBaseView', 'AxisView', {

	_numericModel: null,
	numericModel: function (value) {
		if (arguments.length === 1) {
			this._numericModel = value;
			return value;
		} else {
			return this._numericModel;
		}
	}
	, 
	init: function (model) {



		$.ig.AxisView.prototype.init.call(this, model);
			this.numericModel(model);
	}

	, 
	bindLogarithmBaseToActualTickmarks: function () {
	}
	, 
	$type: new $.ig.Type('NumericAxisBaseView', $.ig.AxisView.prototype.$type)
}, true);


$.ig.util.defType('StraightNumericAxisBase', 'NumericAxisBase', {
	init: function () {



		$.ig.NumericAxisBase.prototype.init.call(this);
			this.updateActualScaler();
	}

	, 
	createView: function () {
		return new $.ig.StraightNumericAxisBaseView(this);
	}

	, 
	onViewCreated: function (view) {
		$.ig.NumericAxisBase.prototype.onViewCreated.call(this, view);
		this.straightView(view);
	}

	, 
	_straightView: null,
	straightView: function (value) {
		if (arguments.length === 1) {
			this._straightView = value;
			return value;
		} else {
			return this._straightView;
		}
	}

	, 
	scaleMode: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StraightNumericAxisBase.prototype.scaleModeProperty, $.ig.NumericScaleMode.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.StraightNumericAxisBase.prototype.scaleModeProperty));
		}
	}

	, 
	scaler: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StraightNumericAxisBase.prototype.scalerProperty, value);
			return value;
		} else {

			return this.getValue($.ig.StraightNumericAxisBase.prototype.scalerProperty);
		}
	}

	, 
	onScalerPropertyChanged: function (d, e) {
		var strNumAcxisBase = $.ig.util.cast($.ig.StraightNumericAxisBase.prototype.$type, d);
		strNumAcxisBase.updateActualScaler();
		strNumAcxisBase.raisePropertyChanged($.ig.StraightNumericAxisBase.prototype.scalerPropertyName, e.oldValue(), e.newValue());
	}

	, 
	createLinearScaler: function () {
		return null;
	}
	, 
	_cachedActualScaler: null

	, 
	actualScaler: function (value) {
		if (arguments.length === 1) {

			var changed = this._cachedActualScaler != value;
			if (changed) {
				var oldValue = this._cachedActualScaler;
				this._cachedActualScaler = value;
				this.raisePropertyChanged($.ig.StraightNumericAxisBase.prototype._actualScalerPropertyName, oldValue, value);
			}

			return value;
		} else {

			if (this._cachedActualScaler == null) {
				this.updateActualScaler();
			}

			return this._cachedActualScaler;
		}
	}

	, 
	calculateRange: function (target, minimumValue, maximumValue, isLogarithmic, logarithmBase, actualMinimumValue, actualMaximumValue) {
		var $self = this;
		(function () { var $ret = $self.actualScaler().calculateRange(target, minimumValue, maximumValue, actualMinimumValue, actualMaximumValue); actualMinimumValue = $ret.p3; actualMaximumValue = $ret.p4; return $ret.ret; }());
		return {
			p5: actualMinimumValue, 
			p6: actualMaximumValue
		};
	}

	, 
	suspendPropertyUpdatedAndExecute: function (a) {
		var suspendPropertyUpdatedStored = this.suspendPropertyUpdated();
		this.suspendPropertyUpdated(true);
		a.invoke();
		this.suspendPropertyUpdated(suspendPropertyUpdatedStored);
	}

	, 
	_suspendPropertyUpdated: false,
	suspendPropertyUpdated: function (value) {
		if (arguments.length === 1) {
			this._suspendPropertyUpdated = value;
			return value;
		} else {
			return this._suspendPropertyUpdated;
		}
	}

	, 
	updateActualScaler: function () {
		var scaler = this.scaler();
		if (scaler == null) {
			scaler = this.createScalerOverride();
		}

		this.actualScaler(scaler);
		if (this.actualScaler() == null) {
			throw new $.ig.ArgumentNullException(0, "ActualScaler");
		}

		this.bindScalerProperties();
	}

	, 
	bindScalerProperties: function () {
		this.straightView().bindScalerProperties();
	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		if (this.suspendPropertyUpdated()) {
			return;
		}

		$.ig.NumericAxisBase.prototype.propertyUpdatedOverride.call(this, sender, propertyName, oldValue, newValue);
		switch (propertyName) {
			case $.ig.NumericAxisBase.prototype.logarithmBasePropertyName:
				this.updateActualScaler();
				break;
			case $.ig.NumericAxisBase.prototype.isLogarithmicPropertyName:
				this.updateActualScaler();
				break;
			case $.ig.StraightNumericAxisBase.prototype.scaleModePropertyName:
				this.updateActualScaler();
				break;
			case $.ig.StraightNumericAxisBase.prototype.scalerPropertyName:
				this.updateActualScaler();
				break;
			case $.ig.StraightNumericAxisBase.prototype._actualScalerPropertyName:
				this.actualIsLogarithmic($.ig.util.cast($.ig.LogarithmicScaler.prototype.$type, this.actualScaler()) !== null);
				this.bindScalerProperties();
				this.updateRange();
				this.renderAxis1(false);
				break;
			case $.ig.NumericAxisBase.prototype.actualMaximumValuePropertyName:
				this.onActualMaximumValueChanged();
				break;
			case $.ig.NumericAxisBase.prototype.actualMinimumValuePropertyName:
				this.onActualMinimumValueChanged();
				this.updateActualScaler();
				break;
		}

	}

	, 
	onActualMinimumValueChanged: function () {
		this.actualScaler().setActualMinimumValue(this.actualMinimumValue());
	}

	, 
	onActualMaximumValueChanged: function () {
		this.actualScaler().setActualMaximumValue(this.actualMaximumValue());
	}
	, 
	$type: new $.ig.Type('StraightNumericAxisBase', $.ig.NumericAxisBase.prototype.$type)
}, true);




$.ig.util.defType('StraightNumericAxisBaseView', 'NumericAxisBaseView', {

	_straightModel: null,
	straightModel: function (value) {
		if (arguments.length === 1) {
			this._straightModel = value;
			return value;
		} else {
			return this._straightModel;
		}
	}
	, 
	init: function (model) {



		$.ig.NumericAxisBaseView.prototype.init.call(this, model);
			this.straightModel(model);
	}

	, 
	bindScalerProperties: function () {
		this.straightModel().actualScaler().setActualMaximumValue(this.straightModel().actualMaximumValue());
		this.straightModel().actualScaler().setActualMinimumValue(this.straightModel().actualMinimumValue());
	}
	, 
	$type: new $.ig.Type('StraightNumericAxisBaseView', $.ig.NumericAxisBaseView.prototype.$type)
}, true);


$.ig.util.defType('NumericYAxis', 'StraightNumericAxisBase', {

	createView: function () {
		return new $.ig.NumericYAxisView(this);
	}
	, 
	init: function () {



		$.ig.StraightNumericAxisBase.prototype.init.call(this);
			this.defaultStyleKey($.ig.NumericYAxis.prototype.$type);
			this.renderer(this.createRenderer());
	}

	, 
	createLabelPanel: function () {
		return new $.ig.VerticalAxisLabelPanel();
	}

	, 
	isVertical: function () {

			return true;
	}

	, 
	getScaledValue: function (unscaledValue, p) {
		if (this._cachedActualScaler != null) {
			return this._cachedActualScaler.getScaledValue(unscaledValue, p);
		}

		return this.actualScaler().getScaledValue(unscaledValue, p);
	}

	, 
	getScaledValueList: function (unscaledValues, startIndex, count, p) {
		if (this._cachedActualScaler != null) {
			this._cachedActualScaler.getScaledValueList(unscaledValues, startIndex, count, p);
			return;
		}

		this.actualScaler().getScaledValueList(unscaledValues, startIndex, count, p);
	}

	, 
	getUnscaledValue: function (scaledValue, p) {
		if (this._cachedActualScaler != null) {
			return this._cachedActualScaler.getUnscaledValue(scaledValue, p);
		}

		return this.actualScaler().getUnscaledValue(scaledValue, p);
	}

	, 
	getUnscaledValueList: function (scaledValues, startIndex, count, p) {
		if (this._cachedActualScaler != null) {
			this._cachedActualScaler.getUnscaledValueList(scaledValues, startIndex, count, p);
			return;
		}

		this.actualScaler().getUnscaledValueList(scaledValues, startIndex, count, p);
	}

	, 
	createRenderer: function () {
		var $self = this;
		var renderer = $.ig.StraightNumericAxisBase.prototype.createRenderer.call($self);
		renderer.labelManager().floatPanelAction(function (crossing) {
			if ($self.labelSettings() == null || $self.labelSettings().visibility() == $.ig.Visibility.prototype.visible) {
				$self.labelPanel().crossingValue(crossing);
				if ($self.labelSettings() != null && ($self.labelSettings().location() == $.ig.AxisLabelsLocation.prototype.insideRight || $self.labelSettings().location() == $.ig.AxisLabelsLocation.prototype.insideLeft)) {
					$self.seriesViewer().invalidatePanels();
				}

			}

		});
		renderer.line(function (p, g, value) {
			$self.horizontalLine(g, value, p.viewportRect(), p.currentRenderingInfo());
		});
		renderer.strip(function (p, g, start, end) {
			$self.horizontalStrip(g, start, end, p.viewportRect());
		});
		renderer.scaling(function (p, unscaled) {
			var sParams = new $.ig.ScalerParams(p.windowRect(), p.viewportRect(), $self.isInvertedCached());
			return $self.getScaledValue(unscaled, sParams);
		});
		renderer.shouldRenderLines(function (p, value) {
			return true;
		});
		renderer.axisLine(function (p) {
			$self.verticalLine(p.axisGeometry(), p.crossingValue(), p.viewportRect(), p.axisRenderingInfo());
		});
		renderer.determineCrossingValue(function (p) {
			p.crossingValue(p.viewportRect().left());
			var sParams2 = new $.ig.ScalerParams(p.windowRect(), p.viewportRect(), $self.isInvertedCached());
			if ($self.crossingAxis() != null && $self.crossingAxis().seriesViewer() != null) {
				p.crossingValue($self.crossingValue());
				p.crossingValue($self.crossingAxis().getScaledValue(p.crossingValue(), sParams2));
				var categoryAxis = $.ig.util.cast($.ig.CategoryAxisBase.prototype.$type, $self.crossingAxis());
				if (categoryAxis != null && categoryAxis.categoryMode() == $.ig.CategoryMode.prototype.mode2) {
					var offset = 0.5 * categoryAxis.getCategorySize(p.windowRect(), p.viewportRect());
					if (categoryAxis.isInverted()) {
					offset = -offset;
					}

					p.crossingValue(p.crossingValue() + offset);
				}

				p.relativeCrossingValue(p.crossingValue() - p.viewportRect().left());
				if (p.crossingValue() < p.viewportRect().left()) {
					p.crossingValue(p.viewportRect().left());

				} else if (p.crossingValue() > p.viewportRect().right()) {
					p.crossingValue(p.viewportRect().right());
				}


				if (p.relativeCrossingValue() < 0) {
					p.relativeCrossingValue(0);

				} else if (p.relativeCrossingValue() > p.viewportRect().width()) {
					p.relativeCrossingValue(p.viewportRect().width());
				}


			}

		});
		renderer.shouldRenderLabel(function (p, value, last) {
			var pixelValue = Math.round(value);
			return pixelValue >= Math.floor(p.viewportRect().top()) && pixelValue <= Math.ceil(p.viewportRect().bottom());
		});
		return renderer;
	}

	, 
	createRenderingParams: function (viewportRect, windowRect) {
		var $self = this;
		var renderingParams = $.ig.StraightNumericAxisBase.prototype.createRenderingParams.call($self, viewportRect, windowRect);
		var yParams = new $.ig.ScalerParams(windowRect, viewportRect, $self.isInverted());
		var visibleMinimum = NaN;
		var visibleMaximum = NaN;
		if (!$self.isInverted() && windowRect.top() == 0) {
			visibleMaximum = $self.actualMaximumValue();

		} else if ($self.isInverted() && windowRect.bottom() == 1) {
			visibleMinimum = $self.actualMaximumValue();
		}


		if ($.ig.util.isNaN(visibleMinimum)) {
			visibleMinimum = $self.getUnscaledValue(viewportRect.bottom(), yParams);
		}

		if ($.ig.util.isNaN(visibleMaximum)) {
			visibleMaximum = $self.getUnscaledValue(viewportRect.top(), yParams);
		}

		var trueVisibleMinimum = Math.min(visibleMinimum, visibleMaximum);
		var trueVisibleMaximum = Math.max(visibleMinimum, visibleMaximum);
		var newRangeInfo = (function () { var $ret = new $.ig.RangeInfo();
		$ret.visibleMinimum(trueVisibleMinimum);
		$ret.visibleMaximum(trueVisibleMaximum);
		$ret.resolution(viewportRect.height()); return $ret;}());
		renderingParams.rangeInfos().add(newRangeInfo);
		return renderingParams;
	}

	, 
	renderAxisOverride: function (animate) {
		$.ig.StraightNumericAxisBase.prototype.renderAxisOverride.call(this, animate);
		var windowRect = this.seriesViewer() != null ? this.seriesViewer().actualWindowRect() : $.ig.Rect.prototype.empty();
		var viewportRect = this.viewportRect();
		this.renderer().render(animate, viewportRect, windowRect);
	}

	, 
	viewportChangedOverride: function (oldRect, newRect) {
		$.ig.StraightNumericAxisBase.prototype.viewportChangedOverride.call(this, oldRect, newRect);
		if (newRect.height() != oldRect.height()) {
			this.updateRange();
		}

	}

	, 
	orientation: function () {

			return $.ig.AxisOrientation.prototype.vertical;
	}

	, 
	createScalerOverride: function () {
		if (this.isLogarithmic()) {
			return new $.ig.VerticalLogarithmicScaler();
		}

		switch (this.scaleMode()) {
			case $.ig.NumericScaleMode.prototype.linear:
				return new $.ig.VerticalLinearScaler();
			case $.ig.NumericScaleMode.prototype.logarithmic:
				return new $.ig.VerticalLogarithmicScaler();
		}

		return null;
	}

	, 
	createLinearScaler: function () {
		return new $.ig.VerticalLinearScaler();
	}
	, 
	$type: new $.ig.Type('NumericYAxis', $.ig.StraightNumericAxisBase.prototype.$type, [$.ig.IScaler.prototype.$type])
}, true);

$.ig.util.defType('NumericYAxisView', 'StraightNumericAxisBaseView', {
	init: function (model) {



		$.ig.StraightNumericAxisBaseView.prototype.init.call(this, model);
			this.yModel(model);
	}

	, 
	_yModel: null,
	yModel: function (value) {
		if (arguments.length === 1) {
			this._yModel = value;
			return value;
		} else {
			return this._yModel;
		}
	}
	, 
	$type: new $.ig.Type('NumericYAxisView', $.ig.StraightNumericAxisBaseView.prototype.$type)
}, true);




$.ig.util.defType('NumericAxisRenderingParameters', 'AxisRenderingParametersBase', {
	init: function () {


		$.ig.AxisRenderingParametersBase.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('NumericAxisRenderingParameters', $.ig.AxisRenderingParametersBase.prototype.$type)
}, true);

























$.ig.util.defType('NumericAxisRenderer', 'AxisRendererBase', {
	init: function (labelManager) {



		$.ig.AxisRendererBase.prototype.init.call(this, labelManager);
	}

	, 
	getLabel: function (renderingParams, unscaledValue, index, interval) {
		var label;
		if (renderingParams.label() != null) {
			label = this.getLabelForItem()(unscaledValue);

		} else {
			unscaledValue = Math.round(unscaledValue * 1000000) / 1000000;
			label = unscaledValue.toString();
		}

		return label;
	}
	, 
	$type: new $.ig.Type('NumericAxisRenderer', $.ig.AxisRendererBase.prototype.$type)
}, true);

$.ig.util.defType('RangeInfo', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.intervalOverride(-1);
			this.minorCountOverride(-1);
	}

	, 
	_visibleMinimum: 0,
	visibleMinimum: function (value) {
		if (arguments.length === 1) {
			this._visibleMinimum = value;
			return value;
		} else {
			return this._visibleMinimum;
		}
	}

	, 
	_visibleMaximum: 0,
	visibleMaximum: function (value) {
		if (arguments.length === 1) {
			this._visibleMaximum = value;
			return value;
		} else {
			return this._visibleMaximum;
		}
	}

	, 
	_intervalOverride: 0,
	intervalOverride: function (value) {
		if (arguments.length === 1) {
			this._intervalOverride = value;
			return value;
		} else {
			return this._intervalOverride;
		}
	}

	, 
	_resolution: 0,
	resolution: function (value) {
		if (arguments.length === 1) {
			this._resolution = value;
			return value;
		} else {
			return this._resolution;
		}
	}

	, 
	_minorCountOverride: 0,
	minorCountOverride: function (value) {
		if (arguments.length === 1) {
			this._minorCountOverride = value;
			return value;
		} else {
			return this._minorCountOverride;
		}
	}
	, 
	$type: new $.ig.Type('RangeInfo', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('NumericScaler', 'DependencyObject', {
	init: function () {


		$.ig.DependencyObject.prototype.init.call(this);

	}
	, 
	calculateRange: function (target, minimumValue, maximumValue, actualMinimumValue, actualMaximumValue) {}

	, 
	actualMinimumValue: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.NumericScaler.prototype.actualMinimumValueProperty, value);
			return value;
		} else {

			return this.getValue($.ig.NumericScaler.prototype.actualMinimumValueProperty);
		}
	}

	, 
	actualMaximumValue: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.NumericScaler.prototype.actualMaximumValueProperty, value);
			return value;
		} else {

			return this.getValue($.ig.NumericScaler.prototype.actualMaximumValueProperty);
		}
	}
	, 
	_cachedActualMinimumValue: 0
	, 
	_cachedActualMaximumValue: 0

	, 
	setActualMinimumValue: function (value) {
		this.actualMinimumValue(value);
	}

	, 
	setActualMaximumValue: function (value) {
		this.actualMaximumValue(value);
	}

	, 
	onPropertyChanged: function (propertyName, oldValue, newValue) {
		switch (propertyName) {
			case $.ig.NumericScaler.prototype.actualMinimumValuePropertyName:
				this._cachedActualMinimumValue = this.actualMinimumValue();
				this.updateActualRange();
				break;
			case $.ig.NumericScaler.prototype.actualMaximumValuePropertyName:
				this._cachedActualMaximumValue = this.actualMaximumValue();
				this.updateActualRange();
				break;
		}

	}

	, 
	updateActualRange: function () {
		if ($.ig.util.isNaN(this.actualMinimumValue()) || $.ig.util.isNaN(this.actualMaximumValue()) || Number.isInfinity(this.actualMinimumValue()) || Number.isInfinity(this.actualMaximumValue()) || this.actualMinimumValue() < (-79228162514264337593543950335) || this.actualMaximumValue() > (79228162514264337593543950335)) {
			this.actualRange(this.actualMaximumValue() - this.actualMinimumValue());

		} else {
			this.actualRange(this.actualMaximumValue() - this.actualMinimumValue());
		}

	}

	, 
	_actualRange: 0,
	actualRange: function (value) {
		if (arguments.length === 1) {
			this._actualRange = value;
			return value;
		} else {
			return this._actualRange;
		}
	}

	, 
	getUnscaledValue: function (scaledValue, p) {}

	, 
	getScaledValue: function (unscaledValue, p) {}

	, 
	getUnscaledValueList: function (scaledValues, startIndex, count, p) {
		var result = new $.ig.List$1(Number, 2, scaledValues.count());
		for (var i = startIndex; i < count; i++) {
			result.add(this.getUnscaledValue(scaledValues.item(i), p));
		}

		return result;
	}

	, 
	getScaledValueList: function (unscaledValues, startIndex, count, p) {
		for (var i = startIndex; i < count; i++) {
			unscaledValues.item(i, this.getScaledValue(unscaledValues.item(i), p));
		}

	}
	, 
	$type: new $.ig.Type('NumericScaler', $.ig.DependencyObject.prototype.$type)
}, true);

$.ig.util.defType('LinearScaler', 'NumericScaler', {
	init: function () {


		$.ig.NumericScaler.prototype.init.call(this);

	}
	, 
	calculateRange: function (target, minimumValue, maximumValue, actualMinimumValue, actualMaximumValue) {
		var $self = this;
		var innerMin;
		var innerMax;
		(function () { var $ret = $.ig.AutoRangeCalculator.prototype.calculateRange(target, minimumValue, maximumValue, false, -1, innerMin, innerMax); innerMin = $ret.p5; innerMax = $ret.p6; return $ret.ret; }());
		actualMinimumValue = innerMin;
		actualMaximumValue = innerMax;
		return {
			p3: actualMinimumValue, 
			p4: actualMaximumValue
		};
	}
	, 
	$type: new $.ig.Type('LinearScaler', $.ig.NumericScaler.prototype.$type)
}, true);


$.ig.util.defType('LogarithmicScaler', 'NumericScaler', {
	init: function () {


		$.ig.NumericScaler.prototype.init.call(this);

	}
	, 
	_logActualMinimumValue: 0,
	logActualMinimumValue: function (value) {
		if (arguments.length === 1) {
			this._logActualMinimumValue = value;
			return value;
		} else {
			return this._logActualMinimumValue;
		}
	}

	, 
	_logActualMaximumValue: 0,
	logActualMaximumValue: function (value) {
		if (arguments.length === 1) {
			this._logActualMaximumValue = value;
			return value;
		} else {
			return this._logActualMaximumValue;
		}
	}

	, 
	onPropertyChanged: function (propertyName, oldValue, newValue) {
		$.ig.NumericScaler.prototype.onPropertyChanged.call(this, propertyName, oldValue, newValue);
		switch (propertyName) {
			case $.ig.NumericScaler.prototype.actualMinimumValuePropertyName:
				this.logActualMinimumValue(Math.log(this.actualMinimumValue()));
				break;
			case $.ig.NumericScaler.prototype.actualMaximumValuePropertyName:
				this.logActualMaximumValue(Math.log(this.actualMaximumValue()));
				break;
		}

	}

	, 
	calculateRange: function (target, minimumValue, maximumValue, actualMinimumValue, actualMaximumValue) {
		var $self = this;
		var innerMin;
		var innerMax;
		(function () { var $ret = $.ig.AutoRangeCalculator.prototype.calculateRange(target, minimumValue, maximumValue, true, target.logarithmBase(), innerMin, innerMax); innerMin = $ret.p5; innerMax = $ret.p6; return $ret.ret; }());
		actualMinimumValue = innerMin;
		actualMaximumValue = innerMax;
		return {
			p3: actualMinimumValue, 
			p4: actualMaximumValue
		};
	}
	, 
	$type: new $.ig.Type('LogarithmicScaler', $.ig.NumericScaler.prototype.$type)
}, true);



$.ig.util.defType('VerticalLinearScaler', 'LinearScaler', {
	init: function () {


		$.ig.LinearScaler.prototype.init.call(this);

	}
	, 
	getUnscaledValue: function (scaledValue, p) {
		return this.getUnscaledValue1(scaledValue, p._windowRect, p._viewportRect, p._isInverted);
	}

	, 
	getScaledValue: function (unscaledValue, p) {
		return this.getScaledValue1(unscaledValue, p._windowRect, p._viewportRect, p._isInverted);
	}

	, 
	asArray: function (values_) {
		var arr = $.isArray(values_) ? values_ : null;;
		return arr;
		return null;
	}

	, 
	getScaledValueList: function (unscaledValues, startIndex, count, p) {
		var unscaledValue;
		var windowRect = p._windowRect;
		var viewportRect = p._viewportRect;
		var effectiveViewportRect = p._effectiveViewportRect;
		var isInverted = p._isInverted;
		var useEffectiveRect = !effectiveViewportRect.isEmpty();
		var actualRange = this.actualRange();
		var minimumValue = this._cachedActualMinimumValue;
		var effectiveTop = effectiveViewportRect.top();
		var effectiveHeight = effectiveViewportRect.height();
		var windowTop = windowRect.top();
		var windowHeight = windowRect.height();
		var viewportTop = viewportRect.top();
		var viewportHeight = viewportRect.height();
		var unitTop = 0;
		var unitHeight = 1;
		var input = this.asArray(unscaledValues);
		var useArray = false;
		if (input != null) {
			useArray = true;
		}

		for (var i = startIndex; i < count; i++) {
			if (useArray) {
				unscaledValue = input[i];

			} else {
				unscaledValue = unscaledValues.item(i);
			}

			if (useEffectiveRect) {
				var u = (unscaledValue - minimumValue) / (actualRange);
				if (!isInverted) {
					u = 1 - u;
				}

				u = effectiveTop + effectiveHeight * (u - unitTop) / unitHeight;
				var scaledValue = (u - (windowTop * viewportHeight)) / windowHeight;
				if (useArray) {
					input[i] = scaledValue;

				} else {
					unscaledValues.item(i, scaledValue);
				}


			} else {
				var scaledValue1 = (unscaledValue - minimumValue) / (actualRange);
				if (!isInverted) {
					scaledValue1 = 1 - scaledValue1;
				}

				scaledValue1 = viewportTop + viewportHeight * (scaledValue1 - windowTop) / windowHeight;
				if (useArray) {
					input[i] = scaledValue1;

				} else {
					unscaledValues.item(i, scaledValue1);
				}

			}

		}

	}

	, 
	getScaledValue1: function (unscaledValue, windowRect, viewportRect, isInverted) {
		var scaledValue = (unscaledValue - this._cachedActualMinimumValue) / (this.actualRange());
		if (!isInverted) {
			scaledValue = 1 - scaledValue;
		}

		return viewportRect.top() + viewportRect.height() * (scaledValue - windowRect.top()) / windowRect.height();
	}

	, 
	getUnscaledValue1: function (scaledValue, windowRect, viewportRect, isInverted) {
		var unscaledValue = windowRect.top() + windowRect.height() * (scaledValue - viewportRect.top()) / viewportRect.height();
		if (!isInverted) {
			unscaledValue = 1 - unscaledValue;
		}

		return this._cachedActualMinimumValue + unscaledValue * (this.actualRange());
	}
	, 
	$type: new $.ig.Type('VerticalLinearScaler', $.ig.LinearScaler.prototype.$type)
}, true);

$.ig.util.defType('VerticalLogarithmicScaler', 'LogarithmicScaler', {
	init: function () {


		$.ig.LogarithmicScaler.prototype.init.call(this);

	}
	, 
	getUnscaledValue: function (scaledValue, p) {
		return this.getUnscaledValue1(scaledValue, p._windowRect, p._viewportRect, p._isInverted);
	}

	, 
	getScaledValue: function (unscaledValue, p) {
		return this.getScaledValue1(unscaledValue, p._windowRect, p._viewportRect, p._isInverted);
	}

	, 
	getScaledValue1: function (unscaledValue, windowRect, viewportRect, isInverted) {
		if ($.ig.util.isNaN(unscaledValue)) {
			return NaN;
		}

		var scaledValue;
		if (unscaledValue <= 0) {
			scaledValue = (Math.log(this._cachedActualMinimumValue) - this.logActualMinimumValue()) / (this.logActualMaximumValue() - this.logActualMinimumValue());

		} else {
			scaledValue = (Math.log(unscaledValue) - this.logActualMinimumValue()) / (this.logActualMaximumValue() - this.logActualMinimumValue());
		}

		if (!isInverted) {
			scaledValue = 1 - scaledValue;
		}

		return viewportRect.top() + viewportRect.height() * (scaledValue - windowRect.top()) / windowRect.height();
	}

	, 
	getUnscaledValue1: function (scaledValue, windowRect, viewportRect, isInverted) {
		var unscaledValue = windowRect.top() + windowRect.height() * (scaledValue - viewportRect.top()) / viewportRect.height();
		if (!isInverted) {
			unscaledValue = 1 - unscaledValue;
		}

		return Math.exp(unscaledValue * (this.logActualMaximumValue() - this.logActualMinimumValue()) + this.logActualMinimumValue());
	}
	, 
	$type: new $.ig.Type('VerticalLogarithmicScaler', $.ig.LogarithmicScaler.prototype.$type)
}, true);





$.ig.util.defType('LinearTickmarkValues', 'TickmarkValues', {
	init: function () {


		this.__majorValues = null;
		this.__minorValues = null;

		$.ig.TickmarkValues.prototype.init.call(this);
			this.minTicks(0);
	}

	, 
	_minTicks: 0,
	minTicks: function (value) {
		if (arguments.length === 1) {
			this._minTicks = value;
			return value;
		} else {
			return this._minTicks;
		}
	}

	, 
	initialize: function (initializationParameters) {
		$.ig.TickmarkValues.prototype.initialize.call(this, initializationParameters);
		var snapper;
		if (this.minTicks() != 0) {
			snapper = new $.ig.LinearNumericSnapper(1, initializationParameters.visibleMinimum(), initializationParameters.visibleMaximum(), initializationParameters.resolution(), this.minTicks());

		} else {
			snapper = new $.ig.LinearNumericSnapper(0, initializationParameters.visibleMinimum(), initializationParameters.visibleMaximum(), initializationParameters.resolution());
		}

		this.interval(snapper.interval());
		if ((initializationParameters.hasUserInterval()) && initializationParameters.userInterval() > 0 && (initializationParameters.visibleMaximum() - initializationParameters.visibleMinimum()) / initializationParameters.userInterval() < 1000) {
			this.interval(initializationParameters.userInterval());
		}

		if (initializationParameters.intervalOverride() != -1) {
			this.interval(initializationParameters.intervalOverride());
		}

		this.firstIndex($.ig.truncate(Math.floor((initializationParameters.visibleMinimum() - initializationParameters.actualMinimum()) / this.interval())));
		this.lastIndex($.ig.truncate(Math.ceil((initializationParameters.visibleMaximum() - initializationParameters.actualMinimum()) / this.interval())));
		this.minorCount(snapper.minorCount());
		if (initializationParameters.minorCountOverride() != -1) {
			this.minorCount(initializationParameters.minorCountOverride());
		}

		this.actualMinimum(initializationParameters.actualMinimum());
	}

	, 
	_actualMinimum: 0,
	actualMinimum: function (value) {
		if (arguments.length === 1) {
			this._actualMinimum = value;
			return value;
		} else {
			return this._actualMinimum;
		}
	}
	, 
	__majorValues: null

	, 
	majorValuesArray: function () {
		var count = 0;
		var firstIndex = this.firstIndex();
		if (!$.ig.util.isNaN(this.interval())) {
			count = this.lastIndex() - firstIndex + 1;
			if (count < 0) {
				count = 0;
			}

		}

		if (this.__majorValues == null || this.__majorValues.length != count) {
			this.__majorValues = new Array(count);
		}

		var array = this.__majorValues;
		for (var i = 0; i < count; ++i) {
			var major = this.actualMinimum() + (i + firstIndex) * this.interval();
			array[i] = major;
		}

		return array;
	}
	, 
	__minorValues: null

	, 
	minorValuesArray: function () {
		var firstIndex = this.firstIndex();
		var lastIndex = this.lastIndex();
		var minorCount = this.minorCount();
		var interval = this.interval();
		var actualMinimum = this.actualMinimum();
		var visibleMaximum = this.visibleMaximum();
		var minorSpan = interval / minorCount;
		var count = 0;
		for (var i = firstIndex; i < lastIndex; ++i) {
			for (var j = 1; j < minorCount; ++j) {
				var minor = actualMinimum + i * interval + (j * minorSpan);
				if (minor <= visibleMaximum) {
					count++;
				}

			}

		}

		if (this.__minorValues == null || this.__minorValues.length != count) {
			this.__minorValues = new Array(count);
		}

		var array = this.__minorValues;
		var pos = 0;
		for (var i1 = firstIndex; i1 < lastIndex; ++i1) {
			for (var j1 = 1; j1 < minorCount; ++j1) {
				var minor1 = actualMinimum + i1 * interval + (j1 * minorSpan);
				if (minor1 <= this.visibleMaximum()) {
					array[pos] = minor1;
					pos++;
				}

			}

		}

		return array;
	}
	, 
	$type: new $.ig.Type('LinearTickmarkValues', $.ig.TickmarkValues.prototype.$type)
}, true);

$.ig.util.defType('LogarithmicTickmarkValues', 'TickmarkValues', {
	init: function () {

		this.__majorValues = null;
		this.__minorValues = null;

		$.ig.TickmarkValues.prototype.init.call(this);

	}
	, 
	initialize: function (initializationParameters) {
		$.ig.TickmarkValues.prototype.initialize.call(this, initializationParameters);
		var snapper = new $.ig.LogarithmicNumericSnapper(initializationParameters.visibleMinimum(), initializationParameters.visibleMaximum(), this.logarithmBase(), initializationParameters.resolution());
		this.interval(1);
		this.minorCount($.ig.truncate(snapper.minorCount()));
		this.firstIndex($.ig.truncate(Math.floor(Math.logBase(Math.max($.ig.LogarithmicTickmarkValues.prototype._mINIMUM_VALUE_GREATER_THAN_ZERO, initializationParameters.visibleMinimum()), this.logarithmBase()))));
		this.lastIndex($.ig.truncate(Math.ceil(Math.logBase(Math.max($.ig.LogarithmicTickmarkValues.prototype._mINIMUM_VALUE_GREATER_THAN_ZERO, initializationParameters.visibleMaximum()), this.logarithmBase()))));
	}

	, 
	logarithmBase: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.LogarithmicTickmarkValues.prototype.logarithmBaseProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.LogarithmicTickmarkValues.prototype.logarithmBaseProperty));
		}
	}

	, 
	majorValueAt: function (tickIndex) {
		var majorLog = tickIndex * this.interval();
		return Math.pow(this.logarithmBase(), majorLog);
	}
	, 
	__majorValues: null

	, 
	majorValuesArray: function () {
		var firstIndex = this.firstIndex();
		var lastIndex = this.lastIndex();
		var visibleMaximum = this.visibleMaximum();
		var count = 0;
		for (var i = firstIndex; i <= lastIndex; ++i) {
			var major = this.majorValueAt(i);
			if (major <= visibleMaximum) {
				count++;
			}

		}

		if (this.__majorValues == null || this.__majorValues.length != count) {
			this.__majorValues = new Array(count);
		}

		var array = this.__majorValues;
		var pos = 0;
		for (var i1 = firstIndex; i1 <= lastIndex; ++i1) {
			var major1 = this.majorValueAt(i1);
			if (major1 <= visibleMaximum) {
				array[pos] = major1;
				pos++;
			}

		}

		return array;
	}
	, 
	__minorValues: null

	, 
	minorValuesArray: function () {
		var firstIndex = this.firstIndex();
		var lastIndex = this.lastIndex();
		var logarithmBase = this.logarithmBase();
		var minorCount = this.minorCount();
		var visibleMaximum = this.visibleMaximum();
		var count = 0;
		for (var i = firstIndex; i <= lastIndex; ++i) {
			var majorValue = this.majorValueAt(i);
			var minorInterval = Math.pow(logarithmBase, i);
			for (var j = 1; j < this.minorCount() - 1; ++j) {
				var minor = majorValue + j * minorInterval;
				if (minor <= visibleMaximum) {
					count++;
				}

			}

		}

		if (this.__minorValues == null || this.__minorValues.length != count) {
			this.__minorValues = new Array(count);
		}

		var array = this.__minorValues;
		var pos = 0;
		for (var i1 = firstIndex; i1 <= lastIndex; ++i1) {
			var majorValue1 = this.majorValueAt(i1);
			var minorInterval1 = Math.pow(logarithmBase, i1);
			for (var j1 = 1; j1 < this.minorCount() - 1; ++j1) {
				var minor1 = majorValue1 + j1 * minorInterval1;
				if (minor1 <= visibleMaximum) {
					array[pos] = minor1;
					pos++;
				}

			}

		}

		return array;
	}
	, 
	$type: new $.ig.Type('LogarithmicTickmarkValues', $.ig.TickmarkValues.prototype.$type)
}, true);








$.ig.util.defType('IPreparesCategoryTrendline', 'Object', {
	$type: new $.ig.Type('IPreparesCategoryTrendline', null)
}, true);

$.ig.util.defType('TrendLineManagerBase$1', 'Object', {
	$tTrendColumn: null
	, 
	_trendColumn: null,
	trendColumn: function (value) {
		if (arguments.length === 1) {
			this._trendColumn = value;
			return value;
		} else {
			return this._trendColumn;
		}
	}

	, 
	_trendCoefficients: null,
	trendCoefficients: function (value) {
		if (arguments.length === 1) {
			this._trendCoefficients = value;
			return value;
		} else {
			return this._trendCoefficients;
		}
	}
	, 
	init: function ($tTrendColumn) {

		this.$tTrendColumn = $tTrendColumn;
		this.$type = this.$type.specialize(this.$tTrendColumn);

		this._trendPolyline = (function () { var $ret = new $.ig.Polyline();
		$ret.isHitTestVisible(false); return $ret;}());

		$.ig.Object.prototype.init.call(this);
			this.trendColumn(new $.ig.List$1(this.$tTrendColumn, 0));
	}

	, 
	trendPolyline: function () {

			return this._trendPolyline;
	}
	, 
	_trendPolyline: null

	, 
	rasterizeTrendLine: function (trendPoints) {
		this.rasterizeTrendLine1(trendPoints, null);
	}

	, 
	isFit: function (type) {
		return type == $.ig.TrendLineType.prototype.linearFit || type == $.ig.TrendLineType.prototype.quadraticFit || type == $.ig.TrendLineType.prototype.cubicFit || type == $.ig.TrendLineType.prototype.quarticFit || type == $.ig.TrendLineType.prototype.quinticFit || type == $.ig.TrendLineType.prototype.logarithmicFit || type == $.ig.TrendLineType.prototype.exponentialFit || type == $.ig.TrendLineType.prototype.powerLawFit;
	}

	, 
	isAverage: function (type) {
		return type == $.ig.TrendLineType.prototype.simpleAverage || type == $.ig.TrendLineType.prototype.exponentialAverage || type == $.ig.TrendLineType.prototype.modifiedAverage || type == $.ig.TrendLineType.prototype.cumulativeAverage || type == $.ig.TrendLineType.prototype.weightedAverage;
	}

	, 
	rasterizeTrendLine1: function (trendPoints, clipper) {
		this.trendPolyline().points().clear();
		if (clipper != null) {
			clipper.target(this.trendPolyline().points());
		}

		if (trendPoints != null) {
			var en = trendPoints.getEnumerator();
			while (en.moveNext()) {
				var point = en.current();
				if (!$.ig.util.isNaN(point.__x) && !$.ig.util.isNaN(point.__y)) {
					if (clipper != null) {
						clipper.add(point);

					} else {
						this.trendPolyline().points().add(point);
					}

				}

			}

		}

		this.trendPolyline().isHitTestVisible(this.trendPolyline().points().count() > 0);
	}

	, 
	flattenTrendLine: function (trend, trendResolutionParams, flattenedPoints) {
		this.flattenTrendLine1(trend, trendResolutionParams, flattenedPoints, null);
	}

	, 
	flattenTrendLine1: function (trend, trendResolutionParams, flattenedPoints, clipper) {
		var $self = this;
		if (clipper != null) {
			clipper.target(flattenedPoints);
		}

		var en = $.ig.Flattener.prototype.flatten3(trend.count(), function (i) { return trend.item(i).__x; }, function (i) { return trend.item(i).__y; }, trendResolutionParams.resolution()).getEnumerator();
		while (en.moveNext()) {
			var i = en.current();
			if (clipper != null) {
				clipper.add(trend.item(i));

			} else {
				flattenedPoints.add(trend.item(i));
			}

		}

	}

	, 
	attachPolyLine: function (rootCanvas, owner) {
		if (rootCanvas == null || owner == null) {
			return;
		}

		if (this.trendPolyline().parent() != null) {
			this.detach();
		}

		rootCanvas.children().add(this.trendPolyline());
	}

	, 
	detach: function () {
		if (this.trendPolyline() == null) {
			return;
		}

		var parent = $.ig.util.cast($.ig.Panel.prototype.$type, this.trendPolyline().parent());
		if (parent != null) {
			parent.children().remove(this.trendPolyline());
		}

	}

	, 
	clearPoints: function () {
		this.trendPolyline().points().clear();
	}

	, 
	reset: function () {
		this.trendCoefficients(null);
		this.trendColumn().clear();
	}

	, 
	dataUpdated: function (action, position, count, propertyName) {
		switch (action) {
			case $.ig.FastItemsSourceEventAction.prototype.change:
			case $.ig.FastItemsSourceEventAction.prototype.replace:
			case $.ig.FastItemsSourceEventAction.prototype.insert:
			case $.ig.FastItemsSourceEventAction.prototype.remove:
			case $.ig.FastItemsSourceEventAction.prototype.reset:
				this.reset();
				break;
		}

	}

	, 
	propertyUpdated: function (sender, propertyName, oldValue, newValue) {
		var requiresRender = false;
		switch (propertyName) {
			case $.ig.TrendLineManagerBase$1.prototype.trendLineTypePropertyName:
			case $.ig.TrendLineManagerBase$1.prototype.trendLinePeriodPropertyName:
				this.reset();
				requiresRender = true;
				break;
			case $.ig.TrendLineManagerBase$1.prototype.trendLineThicknessPropertyName:
				requiresRender = true;
				break;
			case $.ig.Series.prototype.fastItemsSourcePropertyName:
				requiresRender = true;
				this.reset();
				break;
		}

		return requiresRender;
	}
	, 
	$type: new $.ig.Type('TrendLineManagerBase$1', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('CategoryTrendLineManagerBase', 'TrendLineManagerBase$1', {
	init: function () {


		$.ig.TrendLineManagerBase$1.prototype.init.call(this, Number);

	}
	, 
	prepareLine: function (flattenedPoints, trendLineType, valueColumn, period, GetScaledXValue, GetScaledYValue, trendResolutionParams) {}

	, 
	selectManager: function (trendLineManager, xAxis, rootCanvas, series) {
		var $self = this;
		if (xAxis != null && $.ig.util.cast($.ig.ISortingAxis.prototype.$type, xAxis) !== null) {
			if (trendLineManager != null) {
				trendLineManager.detach();
			}

			var newManager = new $.ig.SortingTrendLineManager(function (x) {
				var sortedIndex = x;
				var axis = $.ig.util.cast($.ig.ISortingAxis.prototype.$type, xAxis);
				if (axis != null) {
					x = Math.min(x, axis.sortedIndices().count() - 1);
					sortedIndex = axis.sortedIndices().__inner[x];
				}

				return axis.getUnscaledValueAt(sortedIndex);
			}, function (x, viewport, window) {
				var xParams = new $.ig.ScalerParams(window, viewport, xAxis.isInverted());
				return xAxis.getUnscaledValue(x, xParams);
			});
			newManager.attachPolyLine(rootCanvas, series);
			return newManager;

		} else if (!($.ig.util.cast($.ig.CategoryTrendLineManager.prototype.$type, trendLineManager) !== null)) {
			if (trendLineManager != null) {
				trendLineManager.detach();
			}

			var newManager1 = new $.ig.CategoryTrendLineManager();
			newManager1.attachPolyLine(rootCanvas, series);
			return newManager1;
		}


		return trendLineManager;
	}
	, 
	$type: new $.ig.Type('CategoryTrendLineManagerBase', $.ig.TrendLineManagerBase$1.prototype.$type.specialize(Number), [$.ig.IPreparesCategoryTrendline.prototype.$type])
}, true);

$.ig.util.defType('CategoryTrendLineManager', 'CategoryTrendLineManagerBase', {
	init: function () {


		$.ig.CategoryTrendLineManagerBase.prototype.init.call(this);

	}
	, 
	prepareLine: function (flattenedPoints, trendLineType, valueColumn, period, GetScaledXValue, GetScaledYValue, trendResolutionParams) {
		var $self = this;
		var xmin = trendResolutionParams.firstBucket() * trendResolutionParams.bucketSize();
		var xmax = trendResolutionParams.lastBucket() * trendResolutionParams.bucketSize();
		var trend = new $.ig.List$1($.ig.Point.prototype.$type, 0);
		if (trendLineType == $.ig.TrendLineType.prototype.none) {
			$self.trendCoefficients(null);
			$self.trendColumn().clear();
			return;
		}

		if ($self.isFit(trendLineType)) {
			$self.trendColumn().clear();
			$self.trendCoefficients($.ig.TrendFitCalculator.prototype.calculateFit(trend, trendLineType, trendResolutionParams, $self.trendCoefficients(), valueColumn.count(), function (i) { return (i + 1); }, function (i) { return valueColumn.item(i); }, function (x) { return GetScaledXValue(x - 1); }, GetScaledYValue, xmin + 1, xmax + 1));
		}

		if ($self.isAverage(trendLineType)) {
			$self.trendCoefficients(null);
			$.ig.TrendAverageCalculator.prototype.calculateSingleValueAverage(trendLineType, $self.trendColumn(), valueColumn, period);
			for (var i = trendResolutionParams.firstBucket(); i <= trendResolutionParams.lastBucket(); i += 1) {
				var itemIndex = i * trendResolutionParams.bucketSize();
				if (itemIndex >= 0 && itemIndex < $self.trendColumn().count()) {
					var xi = GetScaledXValue(itemIndex);
					var yi = GetScaledYValue($self.trendColumn().__inner[itemIndex]);
					trend.add({__x: xi + trendResolutionParams.offset(), __y: yi, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
				}

			}

		}

		$self.flattenTrendLine(trend, trendResolutionParams, flattenedPoints);
	}
	, 
	$type: new $.ig.Type('CategoryTrendLineManager', $.ig.CategoryTrendLineManagerBase.prototype.$type)
}, true);















$.ig.util.defType('IHasCategoryAxis', 'Object', {
	$type: new $.ig.Type('IHasCategoryAxis', null)
}, true);

$.ig.util.defType('IHasCategoryModePreference', 'Object', {
	$type: new $.ig.Type('IHasCategoryModePreference', null, [$.ig.IHasCategoryAxis.prototype.$type])
}, true);














$.ig.util.defType('IBucketizer', 'Object', {
	$type: new $.ig.Type('IBucketizer', null)
}, true);


















$.ig.util.defType('RangeValueList', 'Object', {
	__highColumn: null
	, 
	__lowColumn: null
	, 
	init: function (highColumn, lowColumn) {



		$.ig.Object.prototype.init.call(this);
			this.__highColumn = highColumn;
			this.__lowColumn = lowColumn;
	}

	, 
	indexOf: function (item) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	insert: function (index, item) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	removeAt: function (index) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	item: function (index, value) {
		if (arguments.length === 2) {

			throw new $.ig.NotImplementedException(0);
			return value;
		} else {

			var high = NaN;
			var low = NaN;
			if (this.__highColumn != null && index >= 0 && index < this.__highColumn.count()) {
				high = this.__highColumn.item(index);
			}

			if (this.__lowColumn != null && index >= 0 && index < this.__lowColumn.count()) {
				low = this.__lowColumn.item(index);
			}

			var highIsNaN = $.ig.util.isNaN(high);
			var lowIsNaN = $.ig.util.isNaN(low);
			if (!highIsNaN && !lowIsNaN) {
				return (high + low) / 2;
			}

			if (!highIsNaN) {
				return high;
			}

			if (!lowIsNaN) {
				return low;
			}

			return NaN;
		}
	}

	, 
	add: function (item) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	clear: function () {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	contains: function (item) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	copyTo: function (array, arrayIndex) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	count: function () {

			var highCount = 0;
			var lowCount = 0;
			if (this.__highColumn != null) {
				highCount = this.__highColumn.count();
			}

			if (this.__lowColumn != null) {
				lowCount = this.__lowColumn.count();
			}

			var count = 0;
			count = Math.max(count, highCount);
			count = Math.max(count, lowCount);
			return count;
	}

	, 
	isReadOnly: function () {

			return true;
	}

	, 
	remove: function (item) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	getEnumerator: function () {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	getEnumerator: function () {
		throw new $.ig.NotImplementedException(0);
	}
	, 
	$type: new $.ig.Type('RangeValueList', $.ig.Object.prototype.$type, [$.ig.IList$1.prototype.$type.specialize(Number)])
}, true);









$.ig.util.defType('CategoryFrame', 'Frame', {
	init: function (count) {


		this._buckets = new $.ig.List$1($.ig.Array.prototype.$type, 0);
		this._errorBuckets = new $.ig.List$1($.ig.Number.prototype.$type, 0);
		this._errorSpeedModifiers = new $.ig.List$1(Number, 0);
		this._markers = new $.ig.List$1($.ig.Point.prototype.$type, 0);
		this._markerSpeedModifiers = new $.ig.List$1(Number, 0);
		this._trend = new $.ig.List$1($.ig.Point.prototype.$type, 0);
		this._trendSpeedModifiers = new $.ig.List$1(Number, 0);
		this._errorBars = new $.ig.List$1($.ig.Point.prototype.$type, 0);
		this._errorBarsSpeedModifiers = new $.ig.List$1(Number, 0);
		this._errorBarSizes = new $.ig.List$1(Number, 0);
		this._speedModifiers = new $.ig.List$1(Number, 0);

		$.ig.Frame.prototype.init.call(this);
			this.__fullClip = new $.ig.Rect(0, 0, 0, 1, 1);
			this._cnt = count;
			this.incrementFrameVersion();
	}
	, 
	__fullClip: null
	, 
	_buckets: null
	, 
	_errorBuckets: null
	, 
	_errorSpeedModifiers: null
	, 
	_markers: null
	, 
	_markerSpeedModifiers: null
	, 
	_trend: null
	, 
	_trendSpeedModifiers: null
	, 
	_errorBars: null
	, 
	_errorBarsSpeedModifiers: null
	, 
	_errorBarSizes: null
	, 
	_speedModifiers: null

	, 
	_frameVersion: 0,
	frameVersion: function (value) {
		if (arguments.length === 1) {
			this._frameVersion = value;
			return value;
		} else {
			return this._frameVersion;
		}
	}
	, 
	_cnt: 0

	, 
	interpolate3: function (p, _min, _max) {
		this.incrementFrameVersion();
		var min = $.ig.util.cast($.ig.CategoryFrame.prototype.$type, _min);
		var max = $.ig.util.cast($.ig.CategoryFrame.prototype.$type, _max);
		var minCount = min._buckets.count();
		var maxCount = max._buckets.count();
		var count = Math.max(minCount, maxCount);
		var markerCount = Math.max(min._markers.count(), max._markers.count());
		var trendCount = Math.max(min._trend.count(), max._trend.count());
		var errorCount = Math.max(min._errorBuckets.count(), max._errorBuckets.count());
		var errorBarsCount = Math.max(min._errorBars.count(), max._errorBars.count());
		var speedModified = min._speedModifiers.count() > 0;
		if (speedModified) {
			this.reconcileSpeedModifiers(this._speedModifiers, p, min._speedModifiers, max._speedModifiers, count);
		}

		var markerSpeedModified = min._markerSpeedModifiers.count() > 0;
		if (markerSpeedModified) {
			this.reconcileSpeedModifiers(this._markerSpeedModifiers, p, min._markerSpeedModifiers, max._markerSpeedModifiers, markerCount);
		}

		var trendSpeedModified = min._trendSpeedModifiers.count() > 0;
		if (trendSpeedModified) {
			this.reconcileSpeedModifiers(this._trendSpeedModifiers, p, min._trendSpeedModifiers, max._trendSpeedModifiers, trendCount);
		}

		var errorSpeedModified = min._errorSpeedModifiers.count() > 0;
		if (errorSpeedModified) {
			this.reconcileSpeedModifiers(this._errorSpeedModifiers, p, min._errorSpeedModifiers, max._errorSpeedModifiers, errorCount);
		}

		var errorBarsSpeedModified = min._errorBarsSpeedModifiers.count() > 0;
		if (errorBarsSpeedModified) {
			this.reconcileSpeedModifiers(this._errorBarsSpeedModifiers, p, min._errorBarsSpeedModifiers, max._errorBarsSpeedModifiers, errorBarsCount);
		}

		if (this._buckets.count() < count) {
			while (this._buckets.count() < count) {
				this._buckets.add(new Array(this._cnt));

			}
		}

		if (this._buckets.count() > count) {
			this._buckets.removeRange(count, this._buckets.count() - count);
		}

		if (speedModified) {
			var speed = 0;
			for (var i = 0; i < Math.min(minCount, maxCount); ++i) {
				var bucket = this._buckets.__inner[i];
				speed = p * this._speedModifiers.__inner[i];
				speed = speed > 1 ? 1 : speed;
				for (var j = 0; j < this._cnt; ++j) {
					bucket[j] = min._buckets.__inner[i][j] + speed * (max._buckets.__inner[i][j] - min._buckets.__inner[i][j]);
				}

			}


		} else {
			for (var i1 = 0; i1 < Math.min(minCount, maxCount); ++i1) {
				var bucket1 = this._buckets.__inner[i1];
				for (var j1 = 0; j1 < this._cnt; ++j1) {
					bucket1[j1] = min._buckets.__inner[i1][j1] + p * (max._buckets.__inner[i1][j1] - min._buckets.__inner[i1][j1]);
				}

			}

		}

		if (minCount < maxCount) {
			var b = new Array(this._cnt);
			for (var j2 = this._cnt - 1; j2 >= 0; --j2) {
				b[j2] = min._buckets.count() > 0 ? min._buckets.__inner[min._buckets.count() - 1][j2] : 0;
			}

			if (speedModified) {
				var speed1 = 0;
				for (var i2 = minCount; i2 < maxCount; ++i2) {
					var bucket2 = this._buckets.__inner[i2];
					speed1 = p * this._speedModifiers.__inner[i2];
					speed1 = speed1 > 1 ? 1 : speed1;
					for (var j3 = this._cnt - 1; j3 >= 0; --j3) {
						bucket2[j3] = b[j3] + speed1 * (max._buckets.__inner[i2][j3] - b[j3]);
					}

				}


			} else {
				for (var i3 = minCount; i3 < maxCount; ++i3) {
					var bucket3 = this._buckets.__inner[i3];
					for (var j4 = this._cnt - 1; j4 >= 0; --j4) {
						bucket3[j4] = b[j4] + p * (max._buckets.__inner[i3][j4] - b[j4]);
					}

				}

			}

		}

		if (minCount > maxCount) {
			var e = new Array(this._cnt);
			for (var j5 = this._cnt - 1; j5 >= 0; --j5) {
				e[j5] = max._buckets.count() > 0 ? max._buckets.__inner[max._buckets.count() - 1][j5] : 0;
			}

			if (speedModified) {
				var speed2 = 0;
				for (var i4 = maxCount; i4 < minCount; ++i4) {
					var bucket4 = this._buckets.__inner[i4];
					speed2 = p * this._speedModifiers.__inner[i4];
					speed2 = speed2 > 1 ? 1 : speed2;
					for (var j6 = this._cnt - 1; j6 >= 0; --j6) {
						bucket4[j6] = min._buckets.__inner[i4][j6] + speed2 * (e[j6] - min._buckets.__inner[i4][j6]);
					}

				}


			} else {
				for (var i5 = maxCount; i5 < minCount; ++i5) {
					var bucket5 = this._buckets.__inner[i5];
					for (var j7 = this._cnt - 1; j7 >= 0; --j7) {
						bucket5[j7] = min._buckets.__inner[i5][j7] + p * (e[j7] - min._buckets.__inner[i5][j7]);
					}

				}

			}

		}

		if (markerSpeedModified) {
			$.ig.Frame.prototype.interpolateWithSpeed(this._markers, p, min._markers, max._markers, this._markerSpeedModifiers);

		} else {
			$.ig.Frame.prototype.interpolate(this._markers, p, min._markers, max._markers);
		}

		if (trendSpeedModified) {
			$.ig.Frame.prototype.interpolateWithSpeed(this._trend, p, min._trend, max._trend, this._trendSpeedModifiers);

		} else {
			$.ig.Frame.prototype.interpolate(this._trend, p, min._trend, max._trend);
		}

		if (errorSpeedModified) {
			$.ig.Frame.prototype.interpolateWithSpeed(this._errorBars, p, min._errorBars, max._errorBars, this._errorSpeedModifiers);

		} else {
			$.ig.Frame.prototype.interpolate(this._errorBars, p, min._errorBars, max._errorBars);
		}

		if (errorBarsSpeedModified) {
			$.ig.Frame.prototype.interpolateWithSpeed1(this._errorBarSizes, p, min._errorBarSizes, max._errorBarSizes, this._errorBarsSpeedModifiers);

		} else {
			$.ig.Frame.prototype.interpolate1(this._errorBarSizes, p, min._errorBarSizes, max._errorBarSizes);
		}

		var minClip = min.customClip();
		var maxClip = max.customClip();
		if (minClip == null) {
			minClip = this.__fullClip;
		}

		if (maxClip == null) {
			maxClip = this.__fullClip;
		}

		var left = minClip.left() + (maxClip.left() - minClip.left()) * p;
		var top = minClip.top() + (maxClip.top() - minClip.top()) * p;
		var width = minClip.width() + (maxClip.width() - minClip.width()) * p;
		var height = minClip.height() + (maxClip.height() - minClip.height()) * p;
		this.customClip(new $.ig.Rect(0, left, top, width, height));
	}

	, 
	reconcileSpeedModifiers: function (modifiers, p, minSpeedModifiers, maxSpeedModifiers, count) {
		if (maxSpeedModifiers.count() == 0) {
			for (var i = 0; i < minSpeedModifiers.count(); i++) {
				maxSpeedModifiers.add(minSpeedModifiers.__inner[i]);
			}


		} else {
			$.ig.Frame.prototype.interpolate1(modifiers, p, minSpeedModifiers, maxSpeedModifiers);
		}

		if (modifiers.count() < count) {
			var speedCount = modifiers.count();
			for (var i1 = 0; i1 < count - speedCount; i1++) {
				modifiers.add(1);
			}

		}

	}

	, 
	clearSpeedModifiers: function () {
		this._speedModifiers.clear();
		this._trendSpeedModifiers.clear();
		this._markerSpeedModifiers.clear();
		this._errorSpeedModifiers.clear();
		this._errorBarsSpeedModifiers.clear();
	}

	, 
	clearFrame: function () {
		this.incrementFrameVersion();
		this.clearSpeedModifiers();
		this.customClip(this.__fullClip);
	}

	, 
	resetFrame: function () {
		this.clearFrame();
		this._buckets.clear();
		this._errorBars.clear();
		this._errorBuckets.clear();
		this._markers.clear();
		this._trend.clear();
	}

	, 
	incrementFrameVersion: function () {
		$.ig.CategoryFrame.prototype._categoryFrameVersion++;
		if ($.ig.CategoryFrame.prototype._categoryFrameVersion >= (0x7FFFFFFF - 1)) {
			$.ig.CategoryFrame.prototype._categoryFrameVersion = 0;
		}

		this.frameVersion($.ig.CategoryFrame.prototype._categoryFrameVersion);
	}

	, 
	_customClip: null,
	customClip: function (value) {
		if (arguments.length === 1) {
			this._customClip = value;
			return value;
		} else {
			return this._customClip;
		}
	}
	, 
	$type: new $.ig.Type('CategoryFrame', $.ig.Frame.prototype.$type)
}, true);





$.ig.util.defType('CategoryTransitionSourceFramePreparer', 'Object', {
	init: function () {

		this.__rand = new $.ig.Random(0);

		$.ig.Object.prototype.init.call(this);

	}
	, 
	prepareSourceFrame: function (previousFrame, currentFrame, isVertical, xAxis, yAxis, mode, defaultMode, speedType, defaultSpeedType, getZeroValue, viewport) {
		previousFrame.customClip(new $.ig.Rect(0, 0, 0, 1, 1));
		previousFrame._buckets.clear();
		previousFrame._errorBuckets.clear();
		previousFrame._markers.clear();
		previousFrame._trend.clear();
		previousFrame._errorBars.clear();
		previousFrame._errorBarSizes.clear();
		var yAxisIsInverted = false;
		var xAxisIsInverted = false;
		if (yAxis != null) {
			yAxisIsInverted = yAxis.isInverted();
		}

		if (xAxis != null) {
			xAxisIsInverted = xAxis.isInverted();
		}

		var transitionMode = mode;
		if (transitionMode == $.ig.CategoryTransitionInMode.prototype.auto) {
			transitionMode = defaultMode;
		}

		switch (transitionMode) {
			case $.ig.CategoryTransitionInMode.prototype.fromZero:
				var zeroValue = getZeroValue();
				this.prepareSourceFrameFromZero(previousFrame, currentFrame, zeroValue, isVertical);
				break;
			case $.ig.CategoryTransitionInMode.prototype.accordionFromLeft:
				this.prepareSourceFrameFromLeftOrRight(previousFrame, currentFrame, false, isVertical, viewport);
				break;
			case $.ig.CategoryTransitionInMode.prototype.accordionFromTop:
				this.prepareSourceFrameFromTopOrBottom(previousFrame, currentFrame, true, isVertical, viewport);
				break;
			case $.ig.CategoryTransitionInMode.prototype.accordionFromBottom:
				this.prepareSourceFrameFromTopOrBottom(previousFrame, currentFrame, false, isVertical, viewport);
				break;
			case $.ig.CategoryTransitionInMode.prototype.accordionFromRight:
				this.prepareSourceFrameFromLeftOrRight(previousFrame, currentFrame, true, isVertical, viewport);
				break;
			case $.ig.CategoryTransitionInMode.prototype.sweepFromLeft:
				this.prepareSourceFrameSweepFromLeftOrRight(previousFrame, currentFrame, false);
				break;
			case $.ig.CategoryTransitionInMode.prototype.sweepFromRight:
				this.prepareSourceFrameSweepFromLeftOrRight(previousFrame, currentFrame, true);
				break;
			case $.ig.CategoryTransitionInMode.prototype.sweepFromTop:
				this.prepareSourceFrameSweepFromTopOrBottom(previousFrame, currentFrame, true);
				break;
			case $.ig.CategoryTransitionInMode.prototype.sweepFromBottom:
				this.prepareSourceFrameSweepFromTopOrBottom(previousFrame, currentFrame, false);
				break;
			case $.ig.CategoryTransitionInMode.prototype.sweepFromCenter:
				this.copyFrame(previousFrame, currentFrame);
				previousFrame.customClip(new $.ig.Rect(0, 0.5, 0.5, 0, 0));
				break;
			case $.ig.CategoryTransitionInMode.prototype.accordionFromCategoryAxisMinimum:
				if (isVertical) {
					this.prepareSourceFrameFromTopOrBottom(previousFrame, currentFrame, yAxisIsInverted, isVertical, viewport);

				} else {
					this.prepareSourceFrameFromLeftOrRight(previousFrame, currentFrame, xAxisIsInverted, isVertical, viewport);
				}

				break;
			case $.ig.CategoryTransitionInMode.prototype.accordionFromCategoryAxisMaximum:
				if (isVertical) {
					this.prepareSourceFrameFromTopOrBottom(previousFrame, currentFrame, !yAxisIsInverted, isVertical, viewport);

				} else {
					this.prepareSourceFrameFromLeftOrRight(previousFrame, currentFrame, !xAxisIsInverted, isVertical, viewport);
				}

				break;
			case $.ig.CategoryTransitionInMode.prototype.accordionFromValueAxisMinimum:
				if (isVertical) {
					this.prepareSourceFrameFromLeftOrRight(previousFrame, currentFrame, xAxisIsInverted, isVertical, viewport);

				} else {
					this.prepareSourceFrameFromTopOrBottom(previousFrame, currentFrame, yAxisIsInverted, isVertical, viewport);
				}

				break;
			case $.ig.CategoryTransitionInMode.prototype.accordionFromValueAxisMaximum:
				if (isVertical) {
					this.prepareSourceFrameFromLeftOrRight(previousFrame, currentFrame, !xAxisIsInverted, isVertical, viewport);

				} else {
					this.prepareSourceFrameFromTopOrBottom(previousFrame, currentFrame, !yAxisIsInverted, isVertical, viewport);
				}

				break;
			case $.ig.CategoryTransitionInMode.prototype.sweepFromCategoryAxisMinimum:
				if (isVertical) {
					this.prepareSourceFrameSweepFromTopOrBottom(previousFrame, currentFrame, yAxisIsInverted);

				} else {
					this.prepareSourceFrameSweepFromLeftOrRight(previousFrame, currentFrame, xAxisIsInverted);
				}

				break;
			case $.ig.CategoryTransitionInMode.prototype.sweepFromCategoryAxisMaximum:
				if (isVertical) {
					this.prepareSourceFrameSweepFromTopOrBottom(previousFrame, currentFrame, !yAxisIsInverted);

				} else {
					this.prepareSourceFrameSweepFromLeftOrRight(previousFrame, currentFrame, !xAxisIsInverted);
				}

				break;
			case $.ig.CategoryTransitionInMode.prototype.sweepFromValueAxisMinimum:
				if (isVertical) {
					this.prepareSourceFrameSweepFromLeftOrRight(previousFrame, currentFrame, xAxisIsInverted);

				} else {
					this.prepareSourceFrameSweepFromTopOrBottom(previousFrame, currentFrame, yAxisIsInverted);
				}

				break;
			case $.ig.CategoryTransitionInMode.prototype.sweepFromValueAxisMaximum:
				if (isVertical) {
					this.prepareSourceFrameSweepFromLeftOrRight(previousFrame, currentFrame, !xAxisIsInverted);

				} else {
					this.prepareSourceFrameSweepFromTopOrBottom(previousFrame, currentFrame, !yAxisIsInverted);
				}

				break;
			case $.ig.CategoryTransitionInMode.prototype.expand:
				this.prepareSourceFrameExpand(previousFrame, currentFrame);
				break;
		}

		if (speedType == $.ig.TransitionInSpeedType.prototype.auto) {
			speedType = defaultSpeedType;
		}

		previousFrame.clearSpeedModifiers();
		currentFrame.clearSpeedModifiers();
		switch (speedType) {
			case $.ig.TransitionInSpeedType.prototype.indexScaled:
				this.applyIndexScaledSpeedModifiers(previousFrame._buckets.count(), transitionMode, previousFrame._speedModifiers, currentFrame._speedModifiers, xAxis, yAxis, isVertical, viewport);
				this.applyIndexScaledSpeedModifiers(previousFrame._markers.count(), transitionMode, previousFrame._markerSpeedModifiers, currentFrame._markerSpeedModifiers, xAxis, yAxis, isVertical, viewport);
				this.applyIndexScaledSpeedModifiers(previousFrame._trend.count(), transitionMode, previousFrame._trendSpeedModifiers, currentFrame._trendSpeedModifiers, xAxis, yAxis, isVertical, viewport);
				this.applyIndexScaledSpeedModifiers(previousFrame._errorBars.count(), transitionMode, previousFrame._errorSpeedModifiers, currentFrame._errorSpeedModifiers, xAxis, yAxis, isVertical, viewport);
				this.applyIndexScaledSpeedModifiers(previousFrame._errorBarSizes.count(), transitionMode, previousFrame._errorBarsSpeedModifiers, currentFrame._errorBarsSpeedModifiers, xAxis, yAxis, isVertical, viewport);
				break;
			case $.ig.TransitionInSpeedType.prototype.valueScaled:
				var zeroVAlue = getZeroValue();
				this.applyValueScaledSpeedModifiersFromBuckets(previousFrame._buckets.count(), zeroVAlue, transitionMode, previousFrame._buckets, currentFrame._buckets, previousFrame._speedModifiers, currentFrame._speedModifiers, xAxis, yAxis, isVertical, viewport);
				this.applyValueScaledSpeedModifiersFromPoints(previousFrame._markers.count(), zeroVAlue, transitionMode, previousFrame._markers, currentFrame._markers, previousFrame._markerSpeedModifiers, currentFrame._markerSpeedModifiers, xAxis, yAxis, isVertical, viewport);
				this.applyValueScaledSpeedModifiersFromPoints(previousFrame._trend.count(), zeroVAlue, transitionMode, previousFrame._trend, currentFrame._trend, previousFrame._trendSpeedModifiers, currentFrame._trendSpeedModifiers, xAxis, yAxis, isVertical, viewport);
				this.applyValueScaledSpeedModifiersFromPoints(previousFrame._errorBars.count(), zeroVAlue, transitionMode, previousFrame._errorBars, currentFrame._errorBars, previousFrame._errorSpeedModifiers, currentFrame._errorSpeedModifiers, xAxis, yAxis, isVertical, viewport);
				this.applyValueScaledSpeedModifiersFromDoubles(previousFrame._errorBarSizes.count(), zeroVAlue, transitionMode, previousFrame._errorBarSizes, currentFrame._errorBarSizes, previousFrame._errorBarsSpeedModifiers, currentFrame._errorBarsSpeedModifiers, xAxis, yAxis, isVertical, viewport);
				break;
			case $.ig.TransitionInSpeedType.prototype.random:
				this.applyRandomSpeedModifiers(previousFrame._buckets.count(), transitionMode, previousFrame._speedModifiers, currentFrame._speedModifiers);
				this.applyRandomSpeedModifiers(previousFrame._markers.count(), transitionMode, previousFrame._markerSpeedModifiers, currentFrame._markerSpeedModifiers);
				this.applyRandomSpeedModifiers(previousFrame._trend.count(), transitionMode, previousFrame._trendSpeedModifiers, currentFrame._trendSpeedModifiers);
				this.applyRandomSpeedModifiers(previousFrame._errorBars.count(), transitionMode, previousFrame._errorSpeedModifiers, currentFrame._errorSpeedModifiers);
				this.applyRandomSpeedModifiers(previousFrame._errorBarSizes.count(), transitionMode, previousFrame._errorBarsSpeedModifiers, currentFrame._errorBarsSpeedModifiers);
				break;
		}

	}
	, 
	__rand: null

	, 
	applyRandomSpeedModifiers: function (count, transitionMode, previousModifiers, currentModifiers) {
		if (count == 0) {
			return;
		}

		for (var i = 0; i < count; i++) {
			previousModifiers.add(1 + this.__rand.nextDouble());
			currentModifiers.add(1 + this.__rand.nextDouble());
		}

	}

	, 
	applyValueScaledSpeedModifiersFromBuckets: function (count, zeroValue, transitionMode, previousBuckets, currentBuckets, previousModifiers, currentModifiers, xAxis, yAxis, isVertical, viewport) {
		if (count == 0) {
			return;
		}

		var isInverted = false;
		var valueAxis = yAxis;
		if (isVertical) {
			valueAxis = xAxis;
		}

		if (valueAxis != null) {
			isInverted = valueAxis.isInverted();
		}

		var bound = viewport.bottom();
		var maxBound = viewport.bottom();
		var minBound = viewport.top();
		if (isVertical) {
			maxBound = viewport.right();
			minBound = viewport.left();
		}

		if (isInverted) {
			maxBound = viewport.top();
			minBound = viewport.bottom();
			if (isVertical) {
				maxBound = viewport.left();
				minBound = viewport.right();
			}

		}

		zeroValue = Math.max(zeroValue, Math.min(minBound, maxBound));
		zeroValue = Math.min(zeroValue, Math.max(minBound, maxBound));
		bound = 0;
		var currentBucket;
		for (var i = 0; i < count; i++) {
			currentBucket = currentBuckets.__inner[i];
			for (var j = 1; j < currentBucket.length; j++) {
				if ($.ig.util.isNaN(currentBucket[j]) || Number.isInfinity(currentBucket[j])) {
					continue;
				}

				bound = Math.max(bound, Math.abs(zeroValue - currentBucket[j]));
			}

		}

		var max;
		var min;
		var p;
		for (var i1 = 0; i1 < count; i1++) {
			currentBucket = currentBuckets.__inner[i1];
			max = Math.abs(currentBucket[1] - zeroValue);
			min = Math.abs(currentBucket[1] - zeroValue);
			for (var j1 = 1; j1 < currentBucket.length; j1++) {
				if ($.ig.util.isNaN(currentBucket[j1]) || Number.isInfinity(currentBucket[j1])) {
					continue;
				}

				max = Math.max(Math.abs(currentBucket[j1] - zeroValue), max);
				min = Math.min(Math.abs(currentBucket[j1] - zeroValue), min);
			}

			var mid = (max + min) / 2;
			if ($.ig.util.isNaN(mid) || bound == 0) {
				p = 1;

			} else {
				p = mid / bound;
			}

			previousModifiers.add(2 - p);
			currentModifiers.add(2 - p);
		}

	}

	, 
	applyValueScaledSpeedModifiersFromPoints: function (count, zeroValue, transitionMode, previousPoints, currentPoints, previousModifiers, currentModifiers, xAxis, yAxis, isVertical, viewport) {
		if (count == 0) {
			return;
		}

		var isInverted = false;
		var valueAxis = yAxis;
		if (isVertical) {
			valueAxis = xAxis;
		}

		if (valueAxis != null) {
			isInverted = valueAxis.isInverted();
		}

		var bound = viewport.bottom();
		var maxBound = viewport.bottom();
		var minBound = viewport.top();
		if (isVertical) {
			maxBound = viewport.right();
			minBound = viewport.left();
		}

		if (isInverted) {
			maxBound = viewport.top();
			minBound = viewport.bottom();
			if (isVertical) {
				maxBound = viewport.left();
				minBound = viewport.right();
			}

		}

		zeroValue = Math.max(zeroValue, Math.min(minBound, maxBound));
		zeroValue = Math.min(zeroValue, Math.max(minBound, maxBound));
		bound = 0;
		var currentPoint;
		for (var i = 0; i < count; i++) {
			currentPoint = currentPoints.__inner[i];
			if (isVertical) {
				if ($.ig.util.isNaN(currentPoint.__x) || Number.isInfinity(currentPoint.__x)) {
					continue;
				}

				bound = Math.max(bound, Math.abs(currentPoint.__x - zeroValue));

			} else {
				if ($.ig.util.isNaN(currentPoint.__y) || Number.isInfinity(currentPoint.__y)) {
					continue;
				}

				bound = Math.max(bound, Math.abs(currentPoint.__y - zeroValue));
			}

		}

		var p;
		for (var i1 = 0; i1 < count; i1++) {
			currentPoint = currentPoints.__inner[i1];
			var mid;
			if (isVertical) {
				mid = currentPoint.__x;

			} else {
				mid = currentPoint.__y;
			}

			if ($.ig.util.isNaN(mid) || Number.isInfinity(mid) || bound == 0) {
				p = 1;

			} else {
				p = Math.abs(mid - zeroValue) / bound;
			}

			previousModifiers.add(2 - p);
			currentModifiers.add(2 - p);
		}

	}

	, 
	applyValueScaledSpeedModifiersFromDoubles: function (count, zeroValue, transitionMode, previousDoubles, currentDoubles, previousModifiers, currentModifiers, xAxis, yAxis, isVertical, viewport) {
		if (count == 0) {
			return;
		}

		var isInverted = false;
		var valueAxis = yAxis;
		if (isVertical) {
			valueAxis = xAxis;
		}

		if (valueAxis != null) {
			isInverted = valueAxis.isInverted();
		}

		var bound = viewport.bottom();
		var maxBound = viewport.bottom();
		var minBound = viewport.top();
		if (isVertical) {
			maxBound = viewport.right();
			minBound = viewport.left();
		}

		if (isInverted) {
			maxBound = viewport.top();
			minBound = viewport.bottom();
			if (isVertical) {
				maxBound = viewport.left();
				minBound = viewport.right();
			}

		}

		zeroValue = Math.max(zeroValue, Math.min(minBound, maxBound));
		zeroValue = Math.min(zeroValue, Math.max(minBound, maxBound));
		bound = 0;
		var currentDouble;
		for (var i = 0; i < count; i++) {
			currentDouble = currentDoubles.__inner[i];
			if ($.ig.util.isNaN(currentDouble) || Number.isInfinity(currentDouble)) {
				continue;
			}

			bound = Math.max(bound, Math.abs(currentDouble - zeroValue));
		}

		var p;
		for (var i1 = 0; i1 < count; i1++) {
			currentDouble = currentDoubles.__inner[i1];
			var mid;
			mid = currentDouble;
			if (bound == 0 || $.ig.util.isNaN(mid) || Number.isInfinity(mid)) {
				p = 1;

			} else {
				p = Math.abs(mid - zeroValue) / bound;
			}

			previousModifiers.add(2 - p);
			currentModifiers.add(2 - p);
		}

	}

	, 
	applyIndexScaledSpeedModifiers: function (count, transitionMode, previousModifiers, currentModifiers, xAxis, yAxis, isVertical, viewport) {
		if (count == 0) {
			return;
		}

		var indexAxis = xAxis;
		if (isVertical) {
			indexAxis = yAxis;
		}

		var isInverted = false;
		if (indexAxis != null) {
			isInverted = indexAxis.isInverted();
		}

		var p;
		for (var i = 0; i < count; i++) {
			if (count == 1) {
				p = 1;

			} else {
				p = i / (count - 1);
			}

			p = 1 - p;
			previousModifiers.add(1 + p);
			currentModifiers.add(1 + p);
		}

	}

	, 
	prepareSourceFrameExpand: function (previousFrame, currentFrame) {
		previousFrame._buckets.clear();
		previousFrame._errorBuckets.clear();
		previousFrame._markers.clear();
		previousFrame._trend.clear();
		previousFrame._errorBars.clear();
		previousFrame._errorBarSizes.clear();
		this.copyBucketList(previousFrame._buckets, currentFrame._buckets);
		this.copyFloatList(previousFrame._errorBuckets, currentFrame._errorBuckets);
		this.copyPointList(previousFrame._markers, currentFrame._markers);
		this.copyPointList(previousFrame._trend, currentFrame._trend);
		this.copyPointList(previousFrame._errorBars, currentFrame._errorBars);
		this.copyDoubleList(previousFrame._errorBarSizes, currentFrame._errorBarSizes);
		var bucketsCount = previousFrame._buckets.count();
		var buckets = previousFrame._buckets;
		var currentBucket;
		var min;
		var max;
		var mid;
		for (var i = 0; i < bucketsCount; i++) {
			currentBucket = buckets.__inner[i];
			min = currentBucket[1];
			max = currentBucket[1];
			for (var j = 2; j < currentBucket.length; j++) {
				min = Math.min(min, currentBucket[j]);
				max = Math.max(max, currentBucket[j]);
			}

			mid = (min + max) / 2;
			for (var j1 = 1; j1 < currentBucket.length; j1++) {
				currentBucket[j1] = mid;
			}

		}

		var errorBarSizesCount = previousFrame._errorBarSizes.count();
		var errorBarSizes = previousFrame._errorBarSizes;
		for (var i1 = 0; i1 < errorBarSizesCount; i1++) {
			errorBarSizes.__inner[i1] = 0;
		}

	}

	, 
	prepareSourceFrameSweepFromLeftOrRight: function (previousFrame, currentFrame, isRight) {
		if (isRight) {
			this.copyFrame(previousFrame, currentFrame);
			previousFrame.customClip(new $.ig.Rect(0, 1, 0, 0, 1));

		} else {
			this.copyFrame(previousFrame, currentFrame);
			previousFrame.customClip(new $.ig.Rect(0, 0, 0, 0, 1));
		}

	}

	, 
	prepareSourceFrameSweepFromTopOrBottom: function (previousFrame, currentFrame, isTop) {
		if (isTop) {
			this.copyFrame(previousFrame, currentFrame);
			previousFrame.customClip(new $.ig.Rect(0, 0, 0, 1, 0));

		} else {
			this.copyFrame(previousFrame, currentFrame);
			previousFrame.customClip(new $.ig.Rect(0, 0, 1, 1, 0));
		}

	}

	, 
	copyFrame: function (previousFrame, currentFrame) {
		previousFrame._buckets.clear();
		previousFrame._errorBuckets.clear();
		previousFrame._markers.clear();
		previousFrame._trend.clear();
		previousFrame._errorBars.clear();
		previousFrame._errorBarSizes.clear();
		this.copyBucketList(previousFrame._buckets, currentFrame._buckets);
		this.copyFloatList(previousFrame._errorBuckets, currentFrame._errorBuckets);
		this.copyPointList(previousFrame._markers, currentFrame._markers);
		this.copyPointList(previousFrame._trend, currentFrame._trend);
		this.copyPointList(previousFrame._errorBars, currentFrame._errorBars);
		this.copyDoubleList(previousFrame._errorBarSizes, currentFrame._errorBarSizes);
	}

	, 
	preparePointListFromValue: function (sourceItems, targetItems, isVertical, value, isValueAxis) {
		var targetCount = targetItems.count();
		var currentPoint;
		var sourcePoint;
		for (var i = 0; i < targetCount; i++) {
			currentPoint = targetItems.__inner[i];
			if (isValueAxis) {
				if (isVertical) {
					sourcePoint = {__x: value, __y: currentPoint.__y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};

				} else {
					sourcePoint = {__x: currentPoint.__x, __y: value, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
				}


			} else {
				if (isVertical) {
					sourcePoint = {__x: currentPoint.__x, __y: value, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};

				} else {
					sourcePoint = {__x: value, __y: currentPoint.__y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
				}

			}

			sourceItems.add(sourcePoint);
		}

	}

	, 
	copyPointList: function (sourceItems, targetItems) {
		var targetCount = targetItems.count();
		var currentPoint;
		var sourcePoint;
		for (var i = 0; i < targetCount; i++) {
			currentPoint = targetItems.__inner[i];
			sourcePoint = {__x: currentPoint.__x, __y: currentPoint.__y, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
			sourceItems.add(sourcePoint);
		}

	}

	, 
	copyBucketList: function (sourceItems, targetItems) {
		var bucketsCount = targetItems.count();
		var buckets = targetItems;
		var sourceBucket;
		var currentBucket;
		var sourceBuckets = sourceItems;
		for (var i = 0; i < bucketsCount; i++) {
			currentBucket = buckets.__inner[i];
			sourceBucket = new Array(currentBucket.length);
			for (var j = 0; j < sourceBucket.length; j++) {
				sourceBucket[j] = currentBucket[j];
			}

			sourceBuckets.add(sourceBucket);
		}

	}

	, 
	prepareBucketListFromValue: function (sourceItems, targetItems, isVertical, value, isValueAxis) {
		var bucketsCount = targetItems.count();
		var buckets = targetItems;
		var sourceBucket;
		var currentBucket;
		var sourceBuckets = sourceItems;
		for (var i = 0; i < bucketsCount; i++) {
			currentBucket = buckets.__inner[i];
			sourceBucket = new Array(currentBucket.length);
			if (isValueAxis) {
				sourceBucket[0] = currentBucket[0];
				for (var j = 1; j < sourceBucket.length; j++) {
					sourceBucket[j] = value;
				}


			} else {
				sourceBucket[0] = value;
				for (var j1 = 1; j1 < sourceBucket.length; j1++) {
					sourceBucket[j1] = currentBucket[j1];
				}

			}

			sourceBuckets.add(sourceBucket);
		}

	}

	, 
	prepareFloatListFromValue: function (sourceItems, targetItems) {
		var targetCount = targetItems.count();
		var currentItem;
		for (var i = 0; i < targetCount; i++) {
			currentItem = targetItems.__inner[i];
			sourceItems.add(currentItem);
		}

	}

	, 
	copyFloatList: function (sourceItems, targetItems) {
		var targetCount = targetItems.count();
		var currentItem;
		for (var i = 0; i < targetCount; i++) {
			currentItem = targetItems.__inner[i];
			sourceItems.add(currentItem);
		}

	}

	, 
	copyDoubleList: function (sourceItems, targetItems) {
		var targetCount = targetItems.count();
		var currentItem;
		for (var i = 0; i < targetCount; i++) {
			currentItem = targetItems.__inner[i];
			sourceItems.add(currentItem);
		}

	}

	, 
	prepareDoubleListFromValue: function (sourceItems, targetItems, isVertical, value, isValueAxis) {
		var targetCount = targetItems.count();
		var currentItem;
		for (var i = 0; i < targetCount; i++) {
			currentItem = targetItems.__inner[i];
			sourceItems.add(currentItem);
		}

	}

	, 
	prepareSourceFrameFromLeftOrRight: function (previousFrame, currentFrame, isRight, isVertical, viewport) {
		var fromValue = viewport.right();
		if (!isRight) {
			fromValue = viewport.left();
		}

		var isValueAxis = false;
		if (isVertical) {
			isValueAxis = true;
		}

		this.prepareBucketListFromValue(previousFrame._buckets, currentFrame._buckets, isVertical, fromValue, isValueAxis);
		this.prepareFloatListFromValue(previousFrame._errorBuckets, currentFrame._errorBuckets);
		this.preparePointListFromValue(previousFrame._markers, currentFrame._markers, isVertical, fromValue, isValueAxis);
		this.preparePointListFromValue(previousFrame._trend, currentFrame._trend, isVertical, fromValue, isValueAxis);
		this.preparePointListFromValue(previousFrame._errorBars, currentFrame._errorBars, isVertical, fromValue, isValueAxis);
		this.prepareDoubleListFromValue(previousFrame._errorBarSizes, currentFrame._errorBarSizes, isVertical, fromValue, isValueAxis);
	}

	, 
	prepareSourceFrameFromTopOrBottom: function (previousFrame, currentFrame, isTop, isVertical, viewport) {
		var fromValue = viewport.bottom();
		if (isTop) {
			fromValue = viewport.top();
		}

		var isValueAxis = true;
		if (isVertical) {
			isValueAxis = false;
		}

		this.prepareBucketListFromValue(previousFrame._buckets, currentFrame._buckets, isVertical, fromValue, isValueAxis);
		this.prepareFloatListFromValue(previousFrame._errorBuckets, currentFrame._errorBuckets);
		this.preparePointListFromValue(previousFrame._markers, currentFrame._markers, isVertical, fromValue, isValueAxis);
		this.preparePointListFromValue(previousFrame._trend, currentFrame._trend, isVertical, fromValue, isValueAxis);
		this.preparePointListFromValue(previousFrame._errorBars, currentFrame._errorBars, isVertical, fromValue, isValueAxis);
		this.prepareDoubleListFromValue(previousFrame._errorBarSizes, currentFrame._errorBarSizes, isVertical, fromValue, isValueAxis);
	}

	, 
	prepareSourceFrameFromZero: function (previousFrame, currentFrame, zeroValue, isVertical) {
		this.prepareBucketListFromValue(previousFrame._buckets, currentFrame._buckets, isVertical, zeroValue, true);
		this.prepareFloatListFromValue(previousFrame._errorBuckets, currentFrame._errorBuckets);
		this.preparePointListFromValue(previousFrame._markers, currentFrame._markers, isVertical, zeroValue, true);
		this.preparePointListFromValue(previousFrame._trend, currentFrame._trend, isVertical, zeroValue, true);
		this.preparePointListFromValue(previousFrame._errorBars, currentFrame._errorBars, isVertical, zeroValue, true);
		this.prepareDoubleListFromValue(previousFrame._errorBarSizes, currentFrame._errorBarSizes, isVertical, zeroValue, true);
	}
	, 
	$type: new $.ig.Type('CategoryTransitionSourceFramePreparer', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('CategorySeriesRenderManager', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}, 
	_actualRenderFill: null
	, 
	_actualRenderOutline: null
	, 
	_actualRenderThickness: 0
	, 
	_actualRenderDashArray: null
	, 
	_actualRenderDashCap: 0
	, 
	_actualRenderRadiusX: 0
	, 
	_actualRenderRadiusY: 0
	, 
	_actualRenderOpacity: 0
	, 
	_actualRenderMiterLimit: 0
	, 
	_actualRenderStartCap: 0
	, 
	_actualRenderEndCap: 0
	, 
	_initialRenderFill: null
	, 
	_initialRenderOutline: null
	, 
	_initialRenderThickness: 0
	, 
	_initialRenderDashArray: null
	, 
	_initialRenderDashCap: 0
	, 
	_initialRenderRadiusX: 0
	, 
	_initialRenderRadiusY: 0
	, 
	_initialRenderOpacity: 0
	, 
	_initialRenderMiterLimit: 0
	, 
	_initialRenderStartCap: 0
	, 
	_initialRenderEndCap: 0
	, 
	_initialMarkerRenderFill: null
	, 
	_initialMarkerRenderOutline: null
	, 
	_initialMarkerRenderOpacity: 0
	, 
	_actualNegativeShape: false
	, 
	_actualNegativeMarkerShape: false
	, 
	_actualMarkerRenderFill: null
	, 
	_actualMarkerRenderOutline: null
	, 
	_actualMarkerRenderOpacity: 0

	, 
	_categoryOverrideArgs: null,
	categoryOverrideArgs: function (value) {
		if (arguments.length === 1) {
			this._categoryOverrideArgs = value;
			return value;
		} else {
			return this._categoryOverrideArgs;
		}
	}

	, 
	_categoryMarkerOverrideArgs: null,
	categoryMarkerOverrideArgs: function (value) {
		if (arguments.length === 1) {
			this._categoryMarkerOverrideArgs = value;
			return value;
		} else {
			return this._categoryMarkerOverrideArgs;
		}
	}
	, 
	_actualRenderCategoryAxis: null
	, 
	_bucketSize: 0
	, 
	_firstBucket: 0

	, 
	initCategoryMarkerRenderSettings: function (source, shouldOverrideMarkerStyle, getItems, size, first) {
		this._bucketSize = size;
		this._firstBucket = first;
		this._actualNegativeMarkerShape = false;
		this._initialMarkerRenderFill = source.actualMarkerBrush();
		this._initialMarkerRenderOutline = source.actualMarkerOutline();
		this._initialMarkerRenderOpacity = 1;
		this._actualMarkerRenderFill = this._initialMarkerRenderFill;
		this._actualMarkerRenderOutline = this._initialMarkerRenderOutline;
		this._actualMarkerRenderOpacity = this._initialMarkerRenderOpacity;
		var areMarkerStylesOverriden = shouldOverrideMarkerStyle;
		this.categoryMarkerOverrideArgs(null);
		if (areMarkerStylesOverriden) {
			this.categoryMarkerOverrideArgs(new $.ig.AssigningCategoryMarkerStyleEventArgs());
			this.categoryMarkerOverrideArgs().maxAllSeriesHighlightingProgress(0);
			this.categoryMarkerOverrideArgs().sumAllSeriesHighlightingProgress(0);
			if (source.seriesViewer() != null) {
				this.categoryMarkerOverrideArgs().maxAllSeriesHighlightingProgress(source.seriesViewer().highlightingManager().maxMarkerHighlightingProgress());
				this.categoryMarkerOverrideArgs().sumAllSeriesHighlightingProgress(source.seriesViewer().highlightingManager().sumMarkerHighlightingProgress());
			}

			this.categoryMarkerOverrideArgs().getItems(getItems);
		}

	}

	, 
	initCategoryRenderSettings: function (source, shouldOverrideCategoryStyle, categoryAxis, getItems, size, first) {
		this._bucketSize = size;
		this._firstBucket = first;
		this._actualNegativeShape = false;
		this._initialRenderFill = source.actualBrush();
		this._initialRenderOutline = source.actualOutline();
		this._initialRenderThickness = source.thickness();
		this._initialRenderDashArray = source.dashArray();
		this._initialRenderDashCap = source.dashCap();
		this._initialRenderRadiusX = 0;
		this._initialRenderRadiusY = 0;
		this._initialRenderOpacity = 1;
		this._initialRenderMiterLimit = source.miterLimit();
		this._initialRenderStartCap = source.startCap();
		this._initialRenderEndCap = source.endCap();
		this._actualRenderFill = this._initialRenderFill;
		this._actualRenderOutline = this._initialRenderOutline;
		this._actualRenderThickness = this._initialRenderThickness;
		this._actualRenderDashArray = this._initialRenderDashArray;
		this._actualRenderDashCap = this._initialRenderDashCap;
		this._actualRenderRadiusX = this._initialRenderRadiusX;
		this._actualRenderRadiusY = this._initialRenderRadiusY;
		this._actualRenderOpacity = this._initialRenderOpacity;
		this._actualRenderMiterLimit = this._initialRenderMiterLimit;
		this._actualRenderStartCap = this._initialRenderStartCap;
		this._actualRenderEndCap = this._initialRenderEndCap;
		this._actualRenderCategoryAxis = categoryAxis;
		var areStylesOverriden = shouldOverrideCategoryStyle;
		this.categoryOverrideArgs(null);
		if (areStylesOverriden) {
			this.categoryOverrideArgs(new $.ig.AssigningCategoryStyleEventArgs());
			this.categoryOverrideArgs().maxAllSeriesHighlightingProgress(0);
			this.categoryOverrideArgs().sumAllSeriesHighlightingProgress(0);
			if (source.seriesViewer() != null) {
				this.categoryOverrideArgs().maxAllSeriesHighlightingProgress(source.seriesViewer().highlightingManager().maxHighlightingProgress());
				this.categoryOverrideArgs().sumAllSeriesHighlightingProgress(source.seriesViewer().highlightingManager().sumHighlightingProgress());
			}

			this.categoryOverrideArgs().getItems(getItems);
		}

	}

	, 
	setCategoryShapeAppearance: function (shape, strokeOnly, fillOnly, extended, useOutline) {
		var main = this._actualRenderFill;
		if (useOutline) {
			main = this._actualRenderOutline;
		}

		if (fillOnly) {
			shape.__fill = main;

		} else {
			if (strokeOnly) {
				shape.__stroke = main;

			} else {
				shape.__fill = main;
				shape.__stroke = this._actualRenderOutline;
			}

			shape.strokeThickness(this._actualRenderThickness);
			shape.strokeDashArray(this._actualRenderDashArray);
			shape.strokeDashCap(this._actualRenderDashCap);
			if (extended) {
			}

		}

		shape.__opacity = this._actualRenderOpacity;
	}

	, 
	setCategoryMarkerAppearance: function (marker, context) {
		marker.__opacity = this._actualMarkerRenderOpacity;
		context.itemBrush(this._actualMarkerRenderFill);
		context.actualItemBrush(context.itemBrush());
		context.outline(this._actualMarkerRenderOutline);
		context.thickness(0.5);
	}

	, 
	getBucketBounds: function (count, bucket) {
		var size = this._bucketSize;
		var i0 = Math.min(bucket * size, count - 1);
		var i1 = Math.min(i0 + size - 1, count - 1);
		var ret = new Array(2);
		ret[0] = Math.min(i0 + this._firstBucket * size, count - 1);
		ret[1] = Math.min(i1 + this._firstBucket * size, count - 1);
		return ret;
	}

	, 
	applyHighlightingStyle: function (info) {
		if (info == null) {
			return;
		}

		var additionalBrightness = info.progress();
		additionalBrightness = additionalBrightness * 0.5;
		this._actualRenderFill = this.getBrightenedBrush(this._actualRenderFill, additionalBrightness);
		this._actualRenderOutline = this.getBrightenedBrush(this._actualRenderOutline, additionalBrightness);
	}

	, 
	getBrightenedBrush: function (brush, additionalBrightness) {
		if (brush == null) {
			return brush;
		}

		return $.ig.BrushUtil.prototype.getLightened(brush, additionalBrightness);
	}

	, 
	applyMarkerHighlightingStyle: function (info) {
		if (info == null) {
			return;
		}

		var additionalBrightness = info.progress();
		additionalBrightness = additionalBrightness * 0.5;
		this._actualMarkerRenderFill = this.getBrightenedBrush(this._actualMarkerRenderFill, additionalBrightness);
		this._actualMarkerRenderOutline = this.getBrightenedBrush(this._actualMarkerRenderOutline, additionalBrightness);
	}

	, 
	populateArgsBounds: function (args, isSorting, buckets, currentIndex, valueCount, categoryAxis, axisParams, isThumbnail, isMarker) {
		if (currentIndex == -1) {
			if (isSorting) {
				args.hasDateRange(true);
				args.startDate((categoryAxis).actualMinimumValue());
				args.endDate((categoryAxis).actualMaximumValue());

			} else {
				args.hasDateRange(false);
				args.startIndex(0);
				args.endIndex(valueCount - 1);
			}


		} else {
			if (isSorting) {
				var longStart_ = $.ig.truncate(categoryAxis.getUnscaledValue(buckets.__inner[currentIndex][0], axisParams));
				var longEnd_ = longStart_;
				if (currentIndex + 1 < buckets.count()) {
					longEnd_ = $.ig.truncate(categoryAxis.getUnscaledValue(buckets.__inner[currentIndex + 1][0], axisParams));
				}

				args.hasDateRange(true);
				args.startDate(new Date(longStart_));
				args.endDate(new Date(longEnd_));
				if (categoryAxis.isInverted()) {
					var swap = args.endDate();
					args.endDate(args.startDate());
					args.startDate(swap);
				}

				if (isMarker) {
					args.startIndex(currentIndex);
					args.endIndex(currentIndex);

				} else {
					var bounds = this.getBucketBounds(valueCount, currentIndex);
					args.startIndex(bounds[0]);
					args.endIndex(bounds[1]);
				}


			} else {
				if (isMarker) {
					args.startIndex(currentIndex);
					args.endIndex(currentIndex);

				} else {
					var bounds1 = this.getBucketBounds(valueCount, currentIndex);
					args.hasDateRange(false);
					args.startIndex(bounds1[0]);
					args.endIndex(bounds1[1]);
				}

			}

		}

	}

	, 
	prePerformCategoryStyleOverride: function (buckets, currentIndex, valueCount, categoryAxis, axisParams, isThumbnail, isHighlightingEnabled) {
		this._actualRenderFill = this._initialRenderFill;
		this._actualRenderOutline = this._initialRenderOutline;
		this._actualRenderThickness = this._initialRenderThickness;
		this._actualRenderDashArray = this._initialRenderDashArray;
		this._actualRenderDashCap = this._initialRenderDashCap;
		this._actualRenderRadiusX = this._initialRenderRadiusX;
		this._actualRenderRadiusY = this._initialRenderRadiusY;
		this._actualRenderOpacity = this._initialRenderOpacity;
		var args = this.categoryOverrideArgs();
		var isSorting = categoryAxis.isSorting();
		this.populateArgsBounds(args, isSorting, buckets, currentIndex, valueCount, categoryAxis, axisParams, isThumbnail, false);
		args.fill(this._actualRenderFill);
		args.stroke(this._actualRenderOutline);
		args.strokeThickness(this._actualRenderThickness);
		args.strokeDashArray(this._actualRenderDashArray);
		args.strokeDashCap(this._actualRenderDashCap);
		args.radiusX(this._actualRenderRadiusX);
		args.radiusY(this._actualRenderRadiusY);
		args.opacity(this._actualRenderOpacity);
		args.isNegativeShape(this._actualNegativeShape);
		args.highlightingHandled(false);
	}

	, 
	postPerformCategoryStyleOverride: function (info, isThumbnail, isHighlightingEnabled) {
		var args = this.categoryOverrideArgs();
		this._actualRenderFill = args.fill();
		this._actualRenderOutline = args.stroke();
		this._actualRenderThickness = args.strokeThickness();
		this._actualRenderDashArray = args.strokeDashArray();
		this._actualRenderDashCap = args.strokeDashCap();
		this._actualRenderRadiusX = args.radiusX();
		this._actualRenderRadiusY = args.radiusY();
		this._actualRenderOpacity = args.opacity();
		if (isHighlightingEnabled && !args.highlightingHandled() && !isThumbnail) {
			this.applyHighlightingStyle(info);
		}

	}

	, 
	prePerformCategoryMarkerStyleOverride: function (buckets, currentIndex, valueCount, categoryAxis, axisParams, isThumbnail, isHighlightingEnabled) {
		this._actualMarkerRenderFill = this._initialMarkerRenderFill;
		this._actualMarkerRenderOutline = this._initialMarkerRenderOutline;
		this._actualMarkerRenderOpacity = this._initialMarkerRenderOpacity;
		var args = this.categoryMarkerOverrideArgs();
		var isSorting = categoryAxis.isSorting();
		this.populateArgsBounds(args, isSorting, buckets, currentIndex, valueCount, categoryAxis, axisParams, isThumbnail, true);
		args.fill(this._actualMarkerRenderFill);
		args.stroke(this._actualMarkerRenderOutline);
		args.opacity(this._actualMarkerRenderOpacity);
		args.isNegativeShape(this._actualNegativeMarkerShape);
		args.highlightingHandled(false);
	}

	, 
	postPerformCategoryMarkerStyleOverride: function (info, isThumbnail, isHighlightingEnabled) {
		var args = this.categoryMarkerOverrideArgs();
		this._actualMarkerRenderFill = args.fill();
		this._actualMarkerRenderOutline = args.stroke();
		this._actualMarkerRenderOpacity = args.opacity();
		if (isHighlightingEnabled && !args.highlightingHandled() && !isThumbnail) {
			this.applyMarkerHighlightingStyle(info);
		}

	}
	, 
	$type: new $.ig.Type('CategorySeriesRenderManager', $.ig.Object.prototype.$type)
}, true);










































$.ig.util.defType('AssigningCategoryStyleEventArgsBase', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	_startIndex: 0,
	startIndex: function (value) {
		if (arguments.length === 1) {
			this._startIndex = value;
			return value;
		} else {
			return this._startIndex;
		}
	}

	, 
	_endIndex: 0,
	endIndex: function (value) {
		if (arguments.length === 1) {
			this._endIndex = value;
			return value;
		} else {
			return this._endIndex;
		}
	}

	, 
	_startDate: new Date(),
	startDate: function (value) {
		if (arguments.length === 1) {
			this._startDate = value;
			return value;
		} else {
			return this._startDate;
		}
	}

	, 
	_endDate: new Date(),
	endDate: function (value) {
		if (arguments.length === 1) {
			this._endDate = value;
			return value;
		} else {
			return this._endDate;
		}
	}

	, 
	_getItems: null,
	getItems: function (value) {
		if (arguments.length === 1) {
			this._getItems = value;
			return value;
		} else {
			return this._getItems;
		}
	}

	, 
	_fill: null,
	fill: function (value) {
		if (arguments.length === 1) {
			this._fill = value;
			return value;
		} else {
			return this._fill;
		}
	}

	, 
	_stroke: null,
	stroke: function (value) {
		if (arguments.length === 1) {
			this._stroke = value;
			return value;
		} else {
			return this._stroke;
		}
	}

	, 
	_opacity: 0,
	opacity: function (value) {
		if (arguments.length === 1) {
			this._opacity = value;
			return value;
		} else {
			return this._opacity;
		}
	}

	, 
	_highlightingInfo: null,
	highlightingInfo: function (value) {
		if (arguments.length === 1) {
			this._highlightingInfo = value;
			return value;
		} else {
			return this._highlightingInfo;
		}
	}

	, 
	_maxAllSeriesHighlightingProgress: 0,
	maxAllSeriesHighlightingProgress: function (value) {
		if (arguments.length === 1) {
			this._maxAllSeriesHighlightingProgress = value;
			return value;
		} else {
			return this._maxAllSeriesHighlightingProgress;
		}
	}

	, 
	_sumAllSeriesHighlightingProgress: 0,
	sumAllSeriesHighlightingProgress: function (value) {
		if (arguments.length === 1) {
			this._sumAllSeriesHighlightingProgress = value;
			return value;
		} else {
			return this._sumAllSeriesHighlightingProgress;
		}
	}

	, 
	_highlightingHandled: false,
	highlightingHandled: function (value) {
		if (arguments.length === 1) {
			this._highlightingHandled = value;
			return value;
		} else {
			return this._highlightingHandled;
		}
	}

	, 
	_hasDateRange: false,
	hasDateRange: function (value) {
		if (arguments.length === 1) {
			this._hasDateRange = value;
			return value;
		} else {
			return this._hasDateRange;
		}
	}

	, 
	_isNegativeShape: false,
	isNegativeShape: function (value) {
		if (arguments.length === 1) {
			this._isNegativeShape = value;
			return value;
		} else {
			return this._isNegativeShape;
		}
	}

	, 
	_isThumbnail: false,
	isThumbnail: function (value) {
		if (arguments.length === 1) {
			this._isThumbnail = value;
			return value;
		} else {
			return this._isThumbnail;
		}
	}
	, 
	$type: new $.ig.Type('AssigningCategoryStyleEventArgsBase', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('AssigningCategoryStyleEventArgs', 'AssigningCategoryStyleEventArgsBase', {
	init: function () {


		$.ig.AssigningCategoryStyleEventArgsBase.prototype.init.call(this);

	}
	, 
	_strokeThickness: 0,
	strokeThickness: function (value) {
		if (arguments.length === 1) {
			this._strokeThickness = value;
			return value;
		} else {
			return this._strokeThickness;
		}
	}

	, 
	_strokeDashArray: null,
	strokeDashArray: function (value) {
		if (arguments.length === 1) {
			this._strokeDashArray = value;
			return value;
		} else {
			return this._strokeDashArray;
		}
	}

	, 
	_strokeDashCap: 0,
	strokeDashCap: function (value) {
		if (arguments.length === 1) {
			this._strokeDashCap = value;
			return value;
		} else {
			return this._strokeDashCap;
		}
	}

	, 
	_radiusX: 0,
	radiusX: function (value) {
		if (arguments.length === 1) {
			this._radiusX = value;
			return value;
		} else {
			return this._radiusX;
		}
	}

	, 
	_radiusY: 0,
	radiusY: function (value) {
		if (arguments.length === 1) {
			this._radiusY = value;
			return value;
		} else {
			return this._radiusY;
		}
	}
	, 
	$type: new $.ig.Type('AssigningCategoryStyleEventArgs', $.ig.AssigningCategoryStyleEventArgsBase.prototype.$type)
}, true);



$.ig.util.defType('AssigningCategoryMarkerStyleEventArgs', 'AssigningCategoryStyleEventArgsBase', {
	init: function () {


		$.ig.AssigningCategoryStyleEventArgsBase.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('AssigningCategoryMarkerStyleEventArgs', $.ig.AssigningCategoryStyleEventArgsBase.prototype.$type)
}, true);






$.ig.util.defType('FinancialSeries', 'Series', {

	onViewCreated: function (view) {
		$.ig.Series.prototype.onViewCreated.call(this, view);
		this.financialView(view);
	}

	, 
	_financialView: null,
	financialView: function (value) {
		if (arguments.length === 1) {
			this._financialView = value;
			return value;
		} else {
			return this._financialView;
		}
	}

	, 
	isFinancial: function () {

			return true;
	}
	, 
	init: function () {


		this._columnToMapping = new $.ig.Dictionary$2($.ig.IFastItemColumn$1.prototype.$type.specialize(Number), String, 0);
		this._mappingToColumnName = new $.ig.Dictionary$2(String, String, 0);
		this.__ignoreColumnChanges = false;
		this.__dontRenderTypical = false;

		$.ig.Series.prototype.init.call(this);
			this._renderManager = new $.ig.CategorySeriesRenderManager();
			this.actualIsCustomCategoryStyleAllowed(false);
			this.sourceFramePreparer(new $.ig.CategoryTransitionSourceFramePreparer());
			this.thumbnailFrame(new $.ig.CategoryFrame(3));
			this.defaultStyleKey($.ig.FinancialSeries.prototype.$type);
	}

	, 
	negativeBrush: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.FinancialSeries.prototype.negativeBrushProperty, value);
			return value;
		} else {

			return this.getValue($.ig.FinancialSeries.prototype.negativeBrushProperty);
		}
	}

	, 
	xAxis: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.FinancialSeries.prototype.xAxisProperty, value);
			return value;
		} else {

			return this.getValue($.ig.FinancialSeries.prototype.xAxisProperty);
		}
	}

	, 
	yAxis: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.FinancialSeries.prototype.yAxisProperty, value);
			return value;
		} else {

			return this.getValue($.ig.FinancialSeries.prototype.yAxisProperty);
		}
	}

	, 
	openMemberPath: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.FinancialSeries.prototype.openMemberPathProperty, value);
			return value;
		} else {

			return this.getValue($.ig.FinancialSeries.prototype.openMemberPathProperty);
		}
	}

	, 
	openColumn: function (value) {
		if (arguments.length === 1) {

			if (this._openColumn != value) {
				var oldOpenColumn = this._openColumn;
				this._openColumn = value;
				this.raisePropertyChanged($.ig.FinancialSeries.prototype.openColumnPropertyName, oldOpenColumn, this._openColumn);
			}

			return value;
		} else {

			return this._openColumn;
		}
	}
	, 
	_openColumn: null

	, 
	highMemberPath: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.FinancialSeries.prototype.highMemberPathProperty, value);
			return value;
		} else {

			return this.getValue($.ig.FinancialSeries.prototype.highMemberPathProperty);
		}
	}

	, 
	highColumn: function (value) {
		if (arguments.length === 1) {

			if (this._highColumn != value) {
				var oldHighColumn = this._highColumn;
				this._highColumn = value;
				this.raisePropertyChanged($.ig.FinancialSeries.prototype.highColumnPropertyName, oldHighColumn, this._highColumn);
			}

			return value;
		} else {

			return this._highColumn;
		}
	}
	, 
	_highColumn: null

	, 
	lowMemberPath: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.FinancialSeries.prototype.lowMemberPathProperty, value);
			return value;
		} else {

			return this.getValue($.ig.FinancialSeries.prototype.lowMemberPathProperty);
		}
	}

	, 
	lowColumn: function (value) {
		if (arguments.length === 1) {

			if (this._lowColumn != value) {
				var oldLowColumn = this._lowColumn;
				this._lowColumn = value;
				this.raisePropertyChanged($.ig.FinancialSeries.prototype.lowColumnPropertyName, oldLowColumn, this._lowColumn);
			}

			return value;
		} else {

			return this._lowColumn;
		}
	}
	, 
	_lowColumn: null

	, 
	closeMemberPath: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.FinancialSeries.prototype.closeMemberPathProperty, value);
			return value;
		} else {

			return this.getValue($.ig.FinancialSeries.prototype.closeMemberPathProperty);
		}
	}

	, 
	closeColumn: function (value) {
		if (arguments.length === 1) {

			if (this._closeColumn != value) {
				var oldCloseColumn = this._closeColumn;
				this._closeColumn = value;
				this.raisePropertyChanged($.ig.FinancialSeries.prototype.closeColumnPropertyName, oldCloseColumn, this._closeColumn);
			}

			return value;
		} else {

			return this._closeColumn;
		}
	}
	, 
	_closeColumn: null

	, 
	volumeMemberPath: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.FinancialSeries.prototype.volumeMemberPathProperty, value);
			return value;
		} else {

			return this.getValue($.ig.FinancialSeries.prototype.volumeMemberPathProperty);
		}
	}

	, 
	volumeColumn: function (value) {
		if (arguments.length === 1) {

			if (this._volumeColumn != value) {
				var oldVolumeColumn = this._volumeColumn;
				this._volumeColumn = value;
				this.raisePropertyChanged($.ig.FinancialSeries.prototype.volumeColumnPropertyName, oldVolumeColumn, this._volumeColumn);
			}

			return value;
		} else {

			return this._volumeColumn;
		}
	}
	, 
	_volumeColumn: null

	, 
	isCustomCategoryStyleAllowed: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.FinancialSeries.prototype.isCustomCategoryStyleAllowedProperty, value);
			return value;
		} else {

			return this.getValue($.ig.FinancialSeries.prototype.isCustomCategoryStyleAllowedProperty);
		}
	}

	, 
	_actualIsCustomCategoryStyleAllowed: false,
	actualIsCustomCategoryStyleAllowed: function (value) {
		if (arguments.length === 1) {
			this._actualIsCustomCategoryStyleAllowed = value;
			return value;
		} else {
			return this._actualIsCustomCategoryStyleAllowed;
		}
	}
	, 
	assigningCategoryStyle: null
	, 
	shouldOverrideCategoryStyle: function () {
		return (this.assigningCategoryStyle != null && this.actualIsCustomCategoryStyleAllowed()) || this.isHighlightingEnabled();
	}

	, 
	raiseAssigningCategoryStyles: function (args) {
		if (this.assigningCategoryStyle != null && this.actualIsCustomCategoryStyleAllowed()) {
			this.assigningCategoryStyle(this, args);
		}

	}
	, 
	_renderManager: null

	, 
	performCategoryStyleOverride: function (buckets, currentIndex, valueCount, categoryAxis, axisParams, isThumbnail) {
		var isHighlightingEnabled = this.actualIsHighlightingEnabled();
		this._renderManager.prePerformCategoryStyleOverride(buckets, currentIndex, valueCount, categoryAxis, axisParams, isThumbnail, isHighlightingEnabled);
		var args = this._renderManager.categoryOverrideArgs();
		var info = null;
		var itemsSource = this.fastItemsSource();
		if (isHighlightingEnabled && this.seriesViewer() != null) {
			info = this.seriesViewer().highlightingManager().getHighlightingInfo(this, itemsSource, categoryAxis, args.startIndex(), args.endIndex(), false);
			args.highlightingInfo(info);
		}

		args.isThumbnail(isThumbnail);
		this.raiseAssigningCategoryStyles(args);
		this._renderManager.postPerformCategoryStyleOverride(info, isThumbnail, isHighlightingEnabled);
	}

	, 
	getExactUnsortedItemIndex: function (world) {
		return this.getExactUnsortedItemIndexHelper(world, this.xAxis());
	}

	, 
	getPreviousOrExactIndex: function (world, skipUnknowns) {
		return this.getPreviousOrExactIndexHelper(world, skipUnknowns, this.xAxis(), this.getExactUnsortedItemIndex.runOn(this), new $.ig.FinancialValueList(this.openColumn(), this.highColumn(), this.lowColumn(), this.closeColumn(), this.volumeColumn()));
	}

	, 
	getNextOrExactIndex: function (world, skipUnknowns) {
		return this.getNextOrExactIndexHelper(world, skipUnknowns, this.xAxis(), this.getExactUnsortedItemIndex.runOn(this), new $.ig.FinancialValueList(this.openColumn(), this.highColumn(), this.lowColumn(), this.closeColumn(), this.volumeColumn()));
	}

	, 
	getDistanceToIndex: function (world, index, axis, p, offset) {
		if (axis == null) {
			return Number.POSITIVE_INFINITY;
		}

		var count = this.xAxis()._cachedItemsCount;
		return this.getDistanceToIndexHelper(world, index, this.xAxis(), p, offset, count, this.getExactUnsortedItemIndex.runOn(this));
	}

	, 
	getOffsetValue: function () {
		return this.getOffset(this.view().windowRect(), this.view().viewport());
	}

	, 
	getCategoryWidth: function () {
		return this.xAxis().getCategorySize(this.view().windowRect(), this.view().viewport());
	}

	, 
	getSeriesValuePosition: function (world, useInterpolation, skipUnknowns) {
		return this.getSeriesValuePositionHelper(world, useInterpolation, skipUnknowns, this.getOffset(this.view().windowRect(), this.view().viewport()), this.yAxis(), this.xAxis(), null, null, null);
	}

	, 
	getSeriesValue: function (world, useInterpolation, skipUnknowns) {
		var offset = this.getOffset(this.view().windowRect(), this.view().viewport());
		var xParams = new $.ig.ScalerParams(this.view().windowRect(), this.view().viewport(), this.xAxis().isInverted());
		xParams._effectiveViewportRect = this.seriesViewer().viewportRect();
		return this.getSeriesValueHelper(new $.ig.FinancialValueList(this.openColumn(), this.highColumn(), this.lowColumn(), this.closeColumn(), this.volumeColumn()), world, this.xAxis(), xParams, offset, this.getExactUnsortedItemIndex.runOn(this), useInterpolation, skipUnknowns);
	}

	, 
	getSeriesHighValue: function (world, useInterpolation, skipUnknowns) {
		var offset = this.getOffset(this.view().windowRect(), this.view().viewport());
		var xParams = new $.ig.ScalerParams(this.view().windowRect(), this.view().viewport(), this.xAxis().isInverted());
		xParams._effectiveViewportRect = this.seriesViewer().viewportRect();
		return this.getSeriesValueHelper(this.highColumn(), world, this.xAxis(), xParams, offset, this.getExactUnsortedItemIndex.runOn(this), useInterpolation, skipUnknowns);
	}

	, 
	getSeriesLowValue: function (world, useInterpolation, skipUnknowns) {
		var offset = this.getOffset(this.view().windowRect(), this.view().viewport());
		var xParams = new $.ig.ScalerParams(this.view().windowRect(), this.view().viewport(), this.xAxis().isInverted());
		xParams._effectiveViewportRect = this.seriesViewer().viewportRect();
		return this.getSeriesValueHelper(this.lowColumn(), world, this.xAxis(), xParams, offset, this.getExactUnsortedItemIndex.runOn(this), useInterpolation, skipUnknowns);
	}

	, 
	getSeriesCloseValue: function (world, useInterpolation, skipUnknowns) {
		var offset = this.getOffset(this.view().windowRect(), this.view().viewport());
		var xParams = new $.ig.ScalerParams(this.view().windowRect(), this.view().viewport(), this.xAxis().isInverted());
		xParams._effectiveViewportRect = this.seriesViewer().viewportRect();
		return this.getSeriesValueHelper(this.closeColumn(), world, this.xAxis(), xParams, offset, this.getExactUnsortedItemIndex.runOn(this), useInterpolation, skipUnknowns);
	}

	, 
	getSeriesOpenValue: function (world, useInterpolation, skipUnknowns) {
		var offset = this.getOffset(this.view().windowRect(), this.view().viewport());
		var xParams = new $.ig.ScalerParams(this.view().windowRect(), this.view().viewport(), this.xAxis().isInverted());
		xParams._effectiveViewportRect = this.seriesViewer().viewportRect();
		return this.getSeriesValueHelper(this.openColumn(), world, this.xAxis(), xParams, offset, this.getExactUnsortedItemIndex.runOn(this), useInterpolation, skipUnknowns);
	}

	, 
	getSeriesVolumeValue: function (world, useInterpolation, skipUnknowns) {
		var offset = this.getOffset(this.view().windowRect(), this.view().viewport());
		var xParams = new $.ig.ScalerParams(this.view().windowRect(), this.view().viewport(), this.xAxis().isInverted());
		xParams._effectiveViewportRect = this.seriesViewer().viewportRect();
		return this.getSeriesValueHelper(this.volumeColumn(), world, this.xAxis(), xParams, offset, this.getExactUnsortedItemIndex.runOn(this), useInterpolation, skipUnknowns);
	}

	, 
	getSeriesHighValuePosition: function (world, useInterpolation, skipUnknowns) {
		var $self = this;
		return $self.getSeriesValuePositionHelper(world, useInterpolation, skipUnknowns, $self.getOffset($self.view().windowRect(), $self.view().viewport()), $self.yAxis(), $self.xAxis(), $self.getSeriesHighValue.runOn($self), function (w, skip) { return $self.getPreviousOrExactIndexHelper(w, skip, $self.xAxis(), $self.getExactUnsortedItemIndex.runOn($self), $self.highColumn()); }, function (w, skip) { return $self.getNextOrExactIndexHelper(w, skip, $self.xAxis(), $self.getExactUnsortedItemIndex.runOn($self), $self.highColumn()); });
	}

	, 
	getSeriesLowValuePosition: function (world, useInterpolation, skipUnknowns) {
		var $self = this;
		return $self.getSeriesValuePositionHelper(world, useInterpolation, skipUnknowns, $self.getOffset($self.view().windowRect(), $self.view().viewport()), $self.yAxis(), $self.xAxis(), $self.getSeriesLowValue.runOn($self), function (w, skip) { return $self.getPreviousOrExactIndexHelper(w, skip, $self.xAxis(), $self.getExactUnsortedItemIndex.runOn($self), $self.lowColumn()); }, function (w, skip) { return $self.getNextOrExactIndexHelper(w, skip, $self.xAxis(), $self.getExactUnsortedItemIndex.runOn($self), $self.lowColumn()); });
	}

	, 
	getSeriesOpenValuePosition: function (world, useInterpolation, skipUnknowns) {
		var $self = this;
		return $self.getSeriesValuePositionHelper(world, useInterpolation, skipUnknowns, $self.getOffset($self.view().windowRect(), $self.view().viewport()), $self.yAxis(), $self.xAxis(), $self.getSeriesOpenValue.runOn($self), function (w, skip) { return $self.getPreviousOrExactIndexHelper(w, skip, $self.xAxis(), $self.getExactUnsortedItemIndex.runOn($self), $self.openColumn()); }, function (w, skip) { return $self.getNextOrExactIndexHelper(w, skip, $self.xAxis(), $self.getExactUnsortedItemIndex.runOn($self), $self.openColumn()); });
	}

	, 
	getSeriesCloseValuePosition: function (world, useInterpolation, skipUnknowns) {
		var $self = this;
		return $self.getSeriesValuePositionHelper(world, useInterpolation, skipUnknowns, $self.getOffset($self.view().windowRect(), $self.view().viewport()), $self.yAxis(), $self.xAxis(), $self.getSeriesCloseValue.runOn($self), function (w, skip) { return $self.getPreviousOrExactIndexHelper(w, skip, $self.xAxis(), $self.getExactUnsortedItemIndex.runOn($self), $self.closeColumn()); }, function (w, skip) { return $self.getNextOrExactIndexHelper(w, skip, $self.xAxis(), $self.getExactUnsortedItemIndex.runOn($self), $self.closeColumn()); });
	}

	, 
	getSeriesVolumeValuePosition: function (world, useInterpolation, skipUnknowns) {
		var $self = this;
		return $self.getSeriesValuePositionHelper(world, useInterpolation, skipUnknowns, $self.getOffset($self.view().windowRect(), $self.view().viewport()), $self.yAxis(), $self.xAxis(), $self.getSeriesVolumeValue.runOn($self), function (w, skip) { return $self.getPreviousOrExactIndexHelper(w, skip, $self.xAxis(), $self.getExactUnsortedItemIndex.runOn($self), $self.volumeColumn()); }, function (w, skip) { return $self.getNextOrExactIndexHelper(w, skip, $self.xAxis(), $self.getExactUnsortedItemIndex.runOn($self), $self.volumeColumn()); });
	}

	, 
	invalidateAxes: function () {
		$.ig.Series.prototype.invalidateAxes.call(this);
		if (this.xAxis() != null) {
			this.xAxis().renderAxis1(false);
		}

		if (this.yAxis() != null) {
			this.yAxis().renderAxis1(false);
		}

	}

	, 
	windowRectChangedOverride: function (oldWindowRect, newWindowRect) {
		this.financialView().bucketCalculator().calculateBuckets(this.resolution());
		this.renderSeries(false);
	}

	, 
	viewportRectChangedOverride: function (oldViewportRect, newViewportRect) {
		if (this.transitionInIsInProgress() && this.transitionProgress() < 0.05) {
			this.transitionInViable(true);
		}

		this.financialView().bucketCalculator().calculateBuckets(this.resolution());
		this.renderSeries(false);
	}
	, 
	_columnToMapping: null
	, 
	_mappingToColumnName: null

	, 
	registerColumn: function (itemsSource, mapping, propertyName) {
		var column = this.registerDoubleColumn(mapping);
		this._columnToMapping.add(column, mapping);
		this._mappingToColumnName.add(mapping, propertyName);
		return column;
	}

	, 
	deRegisterColumn: function (itemsSource, column) {
		if (column == null) {
			return;
		}

		itemsSource.deregisterColumn(column);
		var mapping = this._columnToMapping.item(column);
		this._mappingToColumnName.remove(mapping);
		this._columnToMapping.remove(column);
	}
	, 
	__ignoreColumnChanges: false

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		$.ig.Series.prototype.propertyUpdatedOverride.call(this, sender, propertyName, oldValue, newValue);
		switch (propertyName) {
			case $.ig.Series.prototype.syncLinkPropertyName:
				if (this.syncLink() != null && this.seriesViewer() != null) {
					this.financialView().bucketCalculator().calculateBuckets(this.resolution());
					this.renderSeries(false);
				}

				break;
			case $.ig.Series.prototype.seriesViewerPropertyName:
				if (oldValue != null && newValue == null) {
					if (this.xAxis() != null) {
						this.xAxis().deregisterSeries(this);
					}

					if (this.yAxis() != null) {
						this.yAxis().deregisterSeries(this);
					}

				}

				if (oldValue == null && newValue != null) {
					if (this.xAxis() != null) {
						this.xAxis().registerSeries(this);
					}

					if (this.yAxis() != null) {
						this.yAxis().registerSeries(this);
					}

				}

				this.financialView().bucketCalculator().calculateBuckets(this.resolution());
				this.renderSeries(false);
				break;
			case $.ig.Series.prototype.fastItemsSourcePropertyName:
				this.__ignoreColumnChanges = true;
				if ($.ig.util.cast($.ig.IFastItemsSource.prototype.$type, oldValue) != null) {
					this.deRegisterColumn($.ig.util.cast($.ig.IFastItemsSource.prototype.$type, oldValue), this.openColumn());
					this.deRegisterColumn($.ig.util.cast($.ig.IFastItemsSource.prototype.$type, oldValue), this.highColumn());
					this.deRegisterColumn($.ig.util.cast($.ig.IFastItemsSource.prototype.$type, oldValue), this.lowColumn());
					this.deRegisterColumn($.ig.util.cast($.ig.IFastItemsSource.prototype.$type, oldValue), this.closeColumn());
					this.deRegisterColumn($.ig.util.cast($.ig.IFastItemsSource.prototype.$type, oldValue), this.volumeColumn());
					this.openColumn(null);
					this.highColumn(null);
					this.lowColumn(null);
					this.closeColumn(null);
					this.volumeColumn(null);
				}

				if ($.ig.util.cast($.ig.IFastItemsSource.prototype.$type, newValue) != null) {
					if (this.openMemberPath() != null) {
						this.openColumn(this.registerColumn($.ig.util.cast($.ig.IFastItemsSource.prototype.$type, newValue), this.openMemberPath(), $.ig.FinancialSeries.prototype.openColumnPropertyName));
					}

					if (this.highMemberPath() != null) {
						this.highColumn(this.registerColumn($.ig.util.cast($.ig.IFastItemsSource.prototype.$type, newValue), this.highMemberPath(), $.ig.FinancialSeries.prototype.highColumnPropertyName));
					}

					if (this.lowMemberPath() != null) {
						this.lowColumn(this.registerColumn($.ig.util.cast($.ig.IFastItemsSource.prototype.$type, newValue), this.lowMemberPath(), $.ig.FinancialSeries.prototype.lowColumnPropertyName));
					}

					if (this.closeMemberPath() != null) {
						this.closeColumn(this.registerColumn($.ig.util.cast($.ig.IFastItemsSource.prototype.$type, newValue), this.closeMemberPath(), $.ig.FinancialSeries.prototype.closeColumnPropertyName));
					}

					if (this.volumeMemberPath() != null) {
						this.volumeColumn(this.registerColumn($.ig.util.cast($.ig.IFastItemsSource.prototype.$type, newValue), this.volumeMemberPath(), $.ig.FinancialSeries.prototype.volumeColumnPropertyName));
					}

				}

				this.__ignoreColumnChanges = false;
				if (this.yAxis() != null && !this.yAxis().updateRange()) {
					this.financialView().bucketCalculator().calculateBuckets(this.resolution());
					this.renderSeries(false);
				}

				break;
			case $.ig.FinancialSeries.prototype.openMemberPathPropertyName:
				if (this.fastItemsSource() != null) {
					this.deRegisterColumn(this.fastItemsSource(), this.openColumn());
					this.openColumn(this.registerColumn(this.fastItemsSource(), this.openMemberPath(), $.ig.FinancialSeries.prototype.openColumnPropertyName));
				}

				break;
			case $.ig.FinancialSeries.prototype.openColumnPropertyName:
				if (this.yAxis() != null && !this.yAxis().updateRange() && !this.__ignoreColumnChanges) {
					this.financialView().bucketCalculator().calculateBuckets(this.resolution());
					this.renderSeries(false);
				}

				break;
			case $.ig.FinancialSeries.prototype.highMemberPathPropertyName:
				if (this.fastItemsSource() != null) {
					this.deRegisterColumn(this.fastItemsSource(), this.highColumn());
					this.highColumn(this.registerColumn(this.fastItemsSource(), this.highMemberPath(), $.ig.FinancialSeries.prototype.highColumnPropertyName));
				}

				break;
			case $.ig.FinancialSeries.prototype.highColumnPropertyName:
				if (this.yAxis() != null && !this.yAxis().updateRange() && !this.__ignoreColumnChanges) {
					this.financialView().bucketCalculator().calculateBuckets(this.resolution());
					this.renderSeries(false);
				}

				break;
			case $.ig.FinancialSeries.prototype.lowMemberPathPropertyName:
				if (this.fastItemsSource() != null) {
					this.deRegisterColumn(this.fastItemsSource(), this.lowColumn());
					this.lowColumn(this.registerColumn(this.fastItemsSource(), this.lowMemberPath(), $.ig.FinancialSeries.prototype.lowColumnPropertyName));
				}

				break;
			case $.ig.FinancialSeries.prototype.lowColumnPropertyName:
				if (this.yAxis() != null && !this.yAxis().updateRange() && !this.__ignoreColumnChanges) {
					this.financialView().bucketCalculator().calculateBuckets(this.resolution());
					this.renderSeries(false);
				}

				break;
			case $.ig.FinancialSeries.prototype.closeMemberPathPropertyName:
				if (this.fastItemsSource() != null) {
					this.deRegisterColumn(this.fastItemsSource(), this.closeColumn());
					this.closeColumn(this.registerColumn(this.fastItemsSource(), this.closeMemberPath(), $.ig.FinancialSeries.prototype.closeColumnPropertyName));
				}

				break;
			case $.ig.FinancialSeries.prototype.closeColumnPropertyName:
				if (this.yAxis() != null && !this.yAxis().updateRange() && !this.__ignoreColumnChanges) {
					this.financialView().bucketCalculator().calculateBuckets(this.resolution());
					this.renderSeries(false);
				}

				break;
			case $.ig.FinancialSeries.prototype.volumeMemberPathPropertyName:
				if (this.fastItemsSource() != null) {
					this.deRegisterColumn(this.fastItemsSource(), this.volumeColumn());
					this.volumeColumn(this.registerColumn(this.fastItemsSource(), this.volumeMemberPath(), $.ig.FinancialSeries.prototype.volumeColumnPropertyName));
				}

				break;
			case $.ig.FinancialSeries.prototype.volumeColumnPropertyName:
				if (this.yAxis() != null && !this.yAxis().updateRange() && !this.__ignoreColumnChanges) {
					this.financialView().bucketCalculator().calculateBuckets(this.resolution());
					this.renderSeries(false);
				}

				break;
			case $.ig.FinancialSeries.prototype.xAxisPropertyName:
				if (oldValue != null) {
					($.ig.util.cast($.ig.Axis.prototype.$type, oldValue)).deregisterSeries(this);
				}

				if (newValue != null) {
					($.ig.util.cast($.ig.Axis.prototype.$type, newValue)).registerSeries(this);
				}

				this.financialView().bucketCalculator().calculateBuckets(this.resolution());
				this.renderSeries(false);
				this.notifyThumbnailAppearanceChanged();
				break;
			case $.ig.FinancialSeries.prototype.yAxisPropertyName:
				if (oldValue != null) {
					($.ig.util.cast($.ig.Axis.prototype.$type, oldValue)).deregisterSeries(this);
				}

				if (newValue != null) {
					($.ig.util.cast($.ig.Axis.prototype.$type, newValue)).registerSeries(this);
				}

				this.financialView().bucketCalculator().calculateBuckets(this.resolution());
				if (this.yAxis() != null) {
					this.yAxis().updateRange();
				}

					this.renderSeries(false);

				this.notifyThumbnailAppearanceChanged();
				break;
			case $.ig.Series.prototype.transitionProgressPropertyName:
				this._transitionFrame.interpolate3(this.transitionProgress(), this._previousFrame, this._currentFrame);
				if (this.clearAndAbortIfInvalid1(this.view())) {
					return;
				}

				if (this.transitionProgress() == 1) {
					this._currentFrame.clearSpeedModifiers();
					this.renderFrame(this._currentFrame, this.financialView());
					if (this.transitionInIsInProgress()) {
						this.transitionInIsInProgress(false);
						this.clearSpeedModifiers();
						this.animator().intervalMilliseconds($.ig.truncate(this.getTotalMilliseconds()));
						this.animator().easingFunction(this.transitionEasingFunction());
					}


				} else {
					this.renderFrame(this._transitionFrame, this.financialView());
				}

				break;
			case $.ig.FinancialSeries.prototype.negativeBrushPropertyName:
				this.renderSeries(false);
				break;
			case $.ig.CategorySeries.prototype.isCustomCategoryStyleAllowedPropertyName:
				this.actualIsCustomCategoryStyleAllowed(this.getIsCustomCategoryStyleAllowed());
				this.renderSeries(false);
				break;
		}

	}

	, 
	getCategoryItemsHelper: function (orderedStartIndex, orderedEndIndex, axis) {
		if (orderedEndIndex < orderedStartIndex || orderedStartIndex < 0 || orderedStartIndex > this.fastItemsSource().count() || orderedEndIndex < 0 || orderedEndIndex > this.fastItemsSource().count() || axis == null) {
			return null;
		}

		var ret = new Array((orderedEndIndex - orderedStartIndex) + 1);
		var isSorting = axis.isSorting();
		var sortedIndices = null;
		if (isSorting) {
			sortedIndices = (axis).sortedIndices();
		}

		for (var i = orderedStartIndex; i <= orderedEndIndex; i++) {
			var ind = i;
			if (isSorting) {
				ind = sortedIndices.__inner[ind];
			}

			ret[i - orderedStartIndex] = this.fastItemsSource().item(i);
		}

		return ret;
	}

	, 
	getBucketSize: function (view) {
		return (view).bucketCalculator().bucketSize();
	}

	, 
	getFirstBucket: function (view) {
		return (view).bucketCalculator().firstBucket();
	}

	, 
	getCategoryItems: function (orderedStartIndex, orderedEndIndex) {
		return this.getCategoryItemsHelper(orderedStartIndex, orderedEndIndex, this.yAxis());
	}

	, 
	_prevHighlightingInfo: null,
	prevHighlightingInfo: function (value) {
		if (arguments.length === 1) {
			this._prevHighlightingInfo = value;
			return value;
		} else {
			return this._prevHighlightingInfo;
		}
	}

	, 
	hasIndividualElements: function () {

			return false;
	}

	, 
	isHighlightingSupported: function () {

			return true;
	}

	, 
	getHighlightingInfo: function (item, world) {
		if (this.hasIndividualElements()) {
			var info = this.getSpecificHighlightingInfo(item, world, this.prevHighlightingInfo());
			this.prevHighlightingInfo(info);
			return info;

		} else {
			var info1 = this.getFullSeriesInfo(item, world, this.prevHighlightingInfo());
			this.prevHighlightingInfo(info1);
			return info1;
		}

	}

	, 
	getSortingCategoryBucketIndex: function (world) {
		var current = this._currentFrame;
		if (this.animationActive()) {
			current = this._transitionFrame;
		}

		var viewportRect = this.view().viewport();
		var windowRect = this.view().windowRect();
		var indexAxis = this.xAxis();
		var p = new $.ig.ScalerParams(windowRect, viewportRect, indexAxis.isInverted());
		var screenPos = 0;
		if (indexAxis.isVertical()) {
			var windowY = (world.__y - windowRect.top()) / windowRect.height();
			screenPos = windowY * viewportRect.height() + viewportRect.top();

		} else {
			var windowX = (world.__x - windowRect.left()) / windowRect.width();
			screenPos = windowX * viewportRect.width() + viewportRect.left();
		}

		var count = current._buckets.count();
		var i = 0;
		for (i = 0; i < count; i++) {
			var bucket = current._buckets.__inner[i];
			var nextBucket = null;
			if (i < count - 1) {
				nextBucket = current._buckets.__inner[i + 1];
			}

			if (bucket[0] <= screenPos && nextBucket == null || nextBucket[0] >= screenPos) {
				if (nextBucket != null) {
					if (Math.abs(bucket[0] - screenPos) < Math.abs(nextBucket[0] - screenPos)) {
						return i;

					} else {
						return i + 1;
					}


				} else {
					return i;
				}

			}

		}

		return i;
	}

	, 
	getSpecificHighlightingInfo: function (item, world, prevValue) {
		var count = this.fastItemsSource().count();
		var firstBucket = this.financialView().bucketCalculator().firstBucket();
		var lastBucket = this.financialView().bucketCalculator().lastBucket();
		var bucketSize = this.financialView().bucketCalculator().bucketSize();
		var axis = this.xAxis();
		var bucketStart = -1;
		var bucketEnd = -1;
		if (axis.isSorting()) {
			var current = this._currentFrame;
			if (this.animationActive()) {
				current = this._transitionFrame;
			}

			var bucket = this.getSortingCategoryBucketIndex(world);
			bucketStart = bucket;
			bucketEnd = bucket;

		} else {
			var index = this.getItemIndex(world);
			bucketStart = $.ig.truncate(Math.floor(($.ig.intDivide(index, bucketSize)))) * bucketSize;
			bucketEnd = bucketStart + (bucketSize - 1);
		}

		if (prevValue != null && prevValue.startIndex() == bucketStart && prevValue.endIndex() == bucketEnd) {
			return prevValue;
		}

		var info = new $.ig.HighlightingInfo();
		info.series(this);
		info.startIndex(bucketStart);
		info.endIndex(bucketEnd);
		return info;
	}

	, 
	getFullSeriesInfo: function (item, world, prevValue) {
		var info = new $.ig.HighlightingInfo();
		info.series(this);
		info.startIndex(0);
		info.endIndex(this.fastItemsSource().count() - 1);
		if (prevValue != null && prevValue.startIndex() == info.startIndex() && prevValue.endIndex() == info.endIndex()) {
			return prevValue;
		}

		return info;
	}

	, 
	getIsCustomCategoryStyleAllowed: function () {
		return this.isCustomCategoryStyleAllowed();
	}

	, 
	getExactItemIndex: function (world) {
		var windowRect = this.view().windowRect();
		var viewportRect = this.view().viewport();
		var rowIndex = -1;
		if (!windowRect.isEmpty() && !viewportRect.isEmpty() & this.xAxis() != null) {
			var left = this.xAxis().getUnscaledValue2(viewportRect.left(), windowRect, viewportRect, this.xAxis().categoryMode());
			var right = this.xAxis().getUnscaledValue2(viewportRect.right(), windowRect, viewportRect, this.xAxis().categoryMode());
			var windowX = (world.__x - windowRect.left()) / windowRect.width();
			var bucket = left + (windowX * (right - left));
			if (this.xAxis().categoryMode() != $.ig.CategoryMode.prototype.mode0) {
				bucket -= 0.5;
			}

			rowIndex = bucket;
		}

		return rowIndex;
	}

	, 
	getItemIndex: function (world) {
		return $.ig.truncate(Math.round(this.getExactItemIndex(world)));
	}

	, 
	getItemIndexSorted: function (world) {
		var windowRect = this.view().windowRect();
		var viewportRect = this.view().viewport();
		if (windowRect.isEmpty() || viewportRect.isEmpty()) {
			return -1;
		}

		var xParams = new $.ig.ScalerParams(windowRect, viewportRect, this.xAxis().isInverted());
		var sorting = $.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.xAxis());
		var left = this.xAxis().getUnscaledValue(viewportRect.left(), xParams);
		var right = this.xAxis().getUnscaledValue(viewportRect.right(), xParams);
		var windowX = (world.__x - windowRect.left()) / windowRect.width();
		var axisValue = left + ((right - left) * windowX);
		var itemIndex = sorting.getIndexClosestToUnscaledValue(axisValue);
		return itemIndex;
	}

	, 
	getItem: function (world) {
		var index = 0;
		if ($.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.xAxis()) !== null) {
			index = this.getItemIndexSorted(world);
			if (index == -1) {
				return null;
			}


		} else {
			index = this.getItemIndex(world);
		}

		return index >= 0 && this.fastItemsSource() != null && index < this.fastItemsSource().count() ? this.fastItemsSource().item(index) : null;
	}
	, 
	_previousFrame: null
	, 
	_transitionFrame: null
	, 
	_currentFrame: null

	, 
	getOffset: function (windowRect, viewportRect) {
		var offset = 0;
		if (this.xAxis() == null) {
			return offset;
		}

		var categoryMode = this.xAxis().categoryMode();
		switch (categoryMode) {
			case $.ig.CategoryMode.prototype.mode0:
				offset = 0;
				break;
			case $.ig.CategoryMode.prototype.mode1:
				offset = 0.5 * this.xAxis().getCategorySize(windowRect, viewportRect);
				break;
			case $.ig.CategoryMode.prototype.mode2:
				offset = this.xAxis().getGroupCenter(this.index(), windowRect, viewportRect);
				break;
		}

		if (this.xAxis().isInverted()) {
		offset = -offset;
		}

		return offset;
	}

	, 
	transitionInMode: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.FinancialSeries.prototype.transitionInModeProperty, $.ig.CategoryTransitionInMode.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.FinancialSeries.prototype.transitionInModeProperty));
		}
	}

	, 
	isTransitionInEnabled: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.FinancialSeries.prototype.isTransitionInEnabledProperty, value);
			return value;
		} else {

			return this.getValue($.ig.FinancialSeries.prototype.isTransitionInEnabledProperty);
		}
	}

	, 
	shouldTransitionIn: function () {
		return this.isTransitionInEnabled();
	}

	, 
	getDefaultTransitionInMode: function () {
		return $.ig.CategoryTransitionInMode.prototype.expand;
	}

	, 
	getDefaultTransitionInSpeedType: function () {
		return $.ig.TransitionInSpeedType.prototype.indexScaled;
	}

	, 
	_transitionInIsInProgress: false,
	transitionInIsInProgress: function (value) {
		if (arguments.length === 1) {
			this._transitionInIsInProgress = value;
			return value;
		} else {
			return this._transitionInIsInProgress;
		}
	}

	, 
	renderFrame: function (frame, view) {
		this.customClipRect(frame.customClip());
		view.onRenderFrame();
	}
	, 
	__fullClip: null

	, 
	fullClip: function () {

			return this.__fullClip;
	}

	, 
	prepareFrame: function (frame, view) {
		frame.clearFrame();
	}

	, 
	validateSeries: function (viewportRect, windowRect, view) {
		var isValid = $.ig.Series.prototype.validateSeries.call(this, viewportRect, windowRect, view);
		var financialView = view;
		if (this.fastItemsSource() == null || this.fastItemsSource().count() == 0 || !view.hasSurface() || windowRect.isEmpty() || viewportRect.isEmpty() || this.xAxis() == null || this.yAxis() == null || financialView.bucketCalculator().bucketSize() < 1 || this.xAxis().seriesViewer() == null || this.yAxis().seriesViewer() == null || this.yAxis().actualMinimumValue() == this.yAxis().actualMaximumValue() || this.xAxis().itemsSource() == null || this.xAxis()._cachedItemsCount < 1) {
			financialView.bucketCalculator().bucketSize(0);
			isValid = false;
		}

		return isValid;
	}

	, 
	getViewInfo: function (viewportRect, windowRect) {
		windowRect = this.view().windowRect();
		viewportRect = this.view().viewport();
		return {
			p0: viewportRect, 
			p1: windowRect
		};
	}

	, 
	_sourceFramePreparer: null,
	sourceFramePreparer: function (value) {
		if (arguments.length === 1) {
			this._sourceFramePreparer = value;
			return value;
		} else {
			return this._sourceFramePreparer;
		}
	}

	, 
	getWorldZeroValue: function (view) {
		var value = 0;
		var windowRect = view.windowRect();
		var viewportRect = view.viewport();
		if (!windowRect.isEmpty() && !viewportRect.isEmpty() && this.yAxis() != null) {
			var yParams = new $.ig.ScalerParams(windowRect, viewportRect, this.yAxis().isInverted());
			value = this.yAxis().getScaledValue(this.yAxis().referenceValue(), yParams);
		}

		return value;
	}

	, 
	clearSpeedModifiers: function () {
		$.ig.Series.prototype.clearSpeedModifiers.call(this);
		this._previousFrame.clearSpeedModifiers();
		this._currentFrame.clearSpeedModifiers();
		this._transitionFrame.clearSpeedModifiers();
	}

	, 
	renderSeriesOverride: function (animate) {
		var $self = this;
		$.ig.Series.prototype.renderSeriesOverride.call($self, animate);
		$self.financialView().bucketCalculator().calculateBuckets($self.resolution());
		if ($self.clearAndAbortIfInvalid1($self.view())) {
			return;
		}

		if ($self.skipPrepare()) {
			if ($self.animationActive()) {
				$self.renderFrame($self._transitionFrame, $self.financialView());

			} else {
				$self.renderFrame($self._currentFrame, $self.financialView());
			}

			return;
		}

		if ($self.shouldAnimate(animate)) {
			var previous = $self._previousFrame;
			if ($self.animationActive()) {
				if ($self.animator().needsFlush()) {
					$self.animator().flush();
				}

				$self._previousFrame = $self._transitionFrame;
				$self._transitionFrame = previous;

			} else {
				$self._previousFrame = $self._currentFrame;
				$self._currentFrame = previous;
			}

			$self.prepareFrame($self._currentFrame, $self.financialView());
			if ($self.transitionInViable()) {
				$self.animator().stop();
				$self.animator().intervalMilliseconds($.ig.truncate($self.getTotalTransitionInMilliseconds()));
				$self.animator().easingFunction($self.transitionInEasingFunction() != null ? $self.transitionInEasingFunction() : $self.transitionEasingFunction());
				$self.sourceFramePreparer().prepareSourceFrame($self._previousFrame, $self._currentFrame, $self.isVertical(), $self.xAxis(), $self.yAxis(), $self.transitionInMode(), $self.getDefaultTransitionInMode(), $self.transitionInSpeedType(), $self.getDefaultTransitionInSpeedType(), function () { return $self.getWorldZeroValue($self.financialView()); }, $self.financialView().viewport());
			}

			$self.checkTransitionInterrupted();
			$self.startAnimation();
			if ($self.transitionInViable()) {
				$self.transitionInViable(false);
				$self.transitionInIsInProgress(true);
			}


		} else {
			$self.prepareFrame($self._currentFrame, $self.financialView());
			$self.renderFrame($self._currentFrame, $self.financialView());
		}

	}
	, 
	typical: null, 
	typicalBasedOn: null
	, 
	validateBasedOn: function (basedOn) {
		var en = basedOn.getEnumerator();
		while (en.moveNext()) {
			var col = en.current();
			switch (col) {
				case "HighColumn":
					if (this.highColumn() == null) {
						return false;
					}

					break;
				case "LowColumn":
					if (this.lowColumn() == null) {
						return false;
					}

					break;
				case "OpenColumn":
					if (this.openColumn() == null) {
						return false;
					}

					break;
				case "CloseColumn":
					if (this.closeColumn() == null) {
						return false;
					}

					break;
				case "VolumeColumn":
					if (this.volumeColumn() == null) {
						return false;
					}

					break;
			}

		}

		return true;
	}

	, 
	xAxisSortRequired: function () {

			return this.xAxis() != null && $.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.xAxis()) !== null;
	}

	, 
	hasTypical: function () {
		return this.typical != null;
	}

	, 
	callTypical: function (args) {
		this.typical(this, args);
	}

	, 
	typicalColumn: function () {

			var d__ = new $.ig.FinancialSeries___get_TypicalColumn__IteratorClass(-2);
			d__.__4__this = this;
			return d__;
	}

	, 
	tR: function () {

			var d__ = new $.ig.FinancialSeries___get_TR__IteratorClass(-2);
			d__.__4__this = this;
			return d__;
	}

	, 
	tL: function () {

			var d__ = new $.ig.FinancialSeries___get_TL__IteratorClass(-2);
			d__.__4__this = this;
			return d__;
	}

	, 
	makeReadOnlyAndEnsureSorted: function (column) {
		if (column == null) {
			return null;
		}

		if (this.xAxisSortRequired() && ($.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.xAxis())).sortedIndices() != null) {
			return new $.ig.SafeSortedReadOnlyDoubleCollection(column, ($.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.xAxis())).sortedIndices());
		}

		return new $.ig.SafeReadOnlyDoubleCollection(column);
	}
	, 
	__dontRenderTypical: false

	, 
	getTypicalBasedOn: function () {
		var ret = new $.ig.List$1(String, 0);
		ret.add("HighColumn");
		ret.add("LowColumn");
		ret.add("CloseColumn");
		if (this.typicalBasedOn != null && this.fastItemsSource() != null && !this.__dontRenderTypical) {
			this.__dontRenderTypical = true;
			var dataSource = this.provideDataSource(0, this.fastItemsSource().count());
			this.__dontRenderTypical = false;
			var args = new $.ig.FinancialEventArgs(0, this.fastItemsSource().count(), dataSource, this.provideSupportingCalculations(dataSource));
			this.typicalBasedOn(this, args);
			if (args.basedOn() != null && args.basedOn().count() > 0) {
				return args.basedOn();
			}

		}

		return ret;
	}
	, 
	__openArray: null

	, 
	getOpenColumnAsArray: function () {
		if (this.openColumn() == null) {
			return null;
		}

		if (this.xAxis() != null && $.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.xAxis()) !== null) {
			if (this.__openArray != null) {
				return this.__openArray.asArray();
			}

			var _arr = new $.ig.List$1(Number, 2, this.openColumn().count());
			var indices = (this.xAxis()).sortedIndices();
			var _colArr = this.openColumn().asArray();
			for (var i = 0; i < indices.count(); i++) {
				_arr.add(_colArr[indices.__inner[i]]);
			}

			this.__openArray = _arr;
			return this.__openArray.asArray();

		} else {
			return this.openColumn().asArray();
		}

	}
	, 
	__highArray: null

	, 
	getHighColumnAsArray: function () {
		if (this.highColumn() == null) {
			return null;
		}

		if (this.xAxis() != null && $.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.xAxis()) !== null) {
			if (this.__highArray != null) {
				return this.__highArray.asArray();
			}

			var _arr = new $.ig.List$1(Number, 2, this.highColumn().count());
			var indices = (this.xAxis()).sortedIndices();
			var _colArr = this.highColumn().asArray();
			for (var i = 0; i < indices.count(); i++) {
				_arr.add(_colArr[indices.__inner[i]]);
			}

			this.__highArray = _arr;
			return this.__highArray.asArray();

		} else {
			return this.highColumn().asArray();
		}

	}
	, 
	__lowArray: null

	, 
	getLowColumnAsArray: function () {
		if (this.lowColumn() == null) {
			return null;
		}

		if (this.xAxis() != null && $.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.xAxis()) !== null) {
			if (this.__lowArray != null) {
				return this.__lowArray.asArray();
			}

			var _arr = new $.ig.List$1(Number, 2, this.lowColumn().count());
			var indices = (this.xAxis()).sortedIndices();
			var _colArr = this.lowColumn().asArray();
			for (var i = 0; i < indices.count(); i++) {
				_arr.add(_colArr[indices.__inner[i]]);
			}

			this.__lowArray = _arr;
			return this.__lowArray.asArray();

		} else {
			return this.lowColumn().asArray();
		}

	}
	, 
	__closeArray: null

	, 
	getCloseColumnAsArray: function () {
		if (this.closeColumn() == null) {
			return null;
		}

		if (this.xAxis() != null && $.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.xAxis()) !== null) {
			if (this.__closeArray != null) {
				return this.__closeArray.asArray();
			}

			var _arr = new $.ig.List$1(Number, 2, this.closeColumn().count());
			var indices = (this.xAxis()).sortedIndices();
			var _colArr = this.closeColumn().asArray();
			for (var i = 0; i < indices.count(); i++) {
				_arr.add(_colArr[indices.__inner[i]]);
			}

			this.__closeArray = _arr;
			return this.__closeArray.asArray();

		} else {
			return this.closeColumn().asArray();
		}

	}
	, 
	__volumeArray: null

	, 
	getVolumeColumnAsArray: function () {
		if (this.volumeColumn() == null) {
			return null;
		}

		if (this.xAxis() != null && $.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.xAxis()) !== null) {
			if (this.__volumeArray != null) {
				return this.__volumeArray.asArray();
			}

			var _arr = new $.ig.List$1(Number, 2, this.volumeColumn().count());
			var indices = (this.xAxis()).sortedIndices();
			var _colArr = this.volumeColumn().asArray();
			for (var i = 0; i < indices.count(); i++) {
				_arr.add(_colArr[indices.__inner[i]]);
			}

			this.__volumeArray = _arr;
			return this.__volumeArray.asArray();

		} else {
			return this.volumeColumn().asArray();
		}

	}

	, 
	dataUpdatedOverride: function (action, position, count, propertyName) {
		$.ig.Series.prototype.dataUpdatedOverride.call(this, action, position, count, propertyName);
		if (this.xAxis() == null || !($.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.xAxis()) !== null)) {
			return;
		}

		var indices = (this.xAxis()).sortedIndices();
		switch (action) {
			case $.ig.FastItemsSourceEventAction.prototype.insert:
				for (var i = position; i < count; i++) {
					var index = indices.__inner[i];
					if (this.__openArray != null) {
						this.__openArray.insert(i, this.openColumn().item(index));
					}

					if (this.__highArray != null) {
						this.__highArray.insert(i, this.highColumn().item(index));
					}

					if (this.__lowArray != null) {
						this.__lowArray.insert(i, this.lowColumn().item(index));
					}

					if (this.__closeArray != null) {
						this.__closeArray.insert(i, this.closeColumn().item(index));
					}

					if (this.__volumeArray != null) {
						this.__volumeArray.insert(i, this.volumeColumn().item(index));
					}

				}

				break;
			case $.ig.FastItemsSourceEventAction.prototype.remove:
				if (this.__openArray != null) {
					this.__openArray.removeRange(position, count);
				}

				if (this.__highArray != null) {
					this.__highArray.removeRange(position, count);
				}

				if (this.__lowArray != null) {
					this.__lowArray.removeRange(position, count);
				}

				if (this.__closeArray != null) {
					this.__closeArray.removeRange(position, count);
				}

				if (this.__volumeArray != null) {
					this.__volumeArray.removeRange(position, count);
				}

				break;
			case $.ig.FastItemsSourceEventAction.prototype.reset:
				if (this.__openArray != null) {
					this.__openArray = new $.ig.List$1(Number, 0);
				}

				if (this.__highArray != null) {
					this.__highArray = new $.ig.List$1(Number, 0);
				}

				if (this.__lowArray != null) {
					this.__lowArray = new $.ig.List$1(Number, 0);
				}

				if (this.__closeArray != null) {
					this.__closeArray = new $.ig.List$1(Number, 0);
				}

				if (this.__volumeArray != null) {
					this.__volumeArray = new $.ig.List$1(Number, 0);
				}

				break;
			case $.ig.FastItemsSourceEventAction.prototype.change:
			case $.ig.FastItemsSourceEventAction.prototype.replace:
				for (var i1 = position; i1 < count; i1++) {
					var index1 = indices.__inner[i1];
					if (this.__openArray != null) {
						this.__openArray.__inner[i1] = this.openColumn().item(index1);
					}

					if (this.__highArray != null) {
						this.__highArray.__inner[i1] = this.highColumn().item(index1);
					}

					if (this.__lowArray != null) {
						this.__lowArray.__inner[i1] = this.lowColumn().item(index1);
					}

					if (this.__closeArray != null) {
						this.__closeArray.__inner[i1] = this.closeColumn().item(index1);
					}

					if (this.__volumeArray != null) {
						this.__volumeArray.__inner[i1] = this.volumeColumn().item(index1);
					}

				}

				break;
		}

	}

	, 
	provideDataSource: function (position, count) {
		var $self = this;
		var readOnlyOpenColumn = $self.makeReadOnlyAndEnsureSorted($self.openColumn());
		var readOnlyCloseColumn = $self.makeReadOnlyAndEnsureSorted($self.closeColumn());
		var readOnlyHighColumn = $self.makeReadOnlyAndEnsureSorted($self.highColumn());
		var readOnlyLowColumn = $self.makeReadOnlyAndEnsureSorted($self.lowColumn());
		var readOnlyVolumeColumn = $self.makeReadOnlyAndEnsureSorted($self.volumeColumn());
		var dataSource = (function () { var $ret = new $.ig.FinancialCalculationDataSource();
		$ret.typicalColumn(new $.ig.CalculatedColumn(1, new $.ig.SafeEnumerable($self.typicalColumn()), $self.getTypicalBasedOn()));
		$ret.trueRange(new $.ig.CalculatedColumn(1, new $.ig.SafeEnumerable($self.tR()), (function () { var $ret = new $.ig.List$1(String, 0);
		$ret.add("HighColumn");
		$ret.add("LowColumn");
		$ret.add("CloseColumn"); return $ret;}())));
		$ret.trueLow(new $.ig.CalculatedColumn(1, new $.ig.SafeEnumerable($self.tL()), (function () { var $ret = new $.ig.List$1(String, 0);
		$ret.add("LowColumn");
		$ret.add("CloseColumn"); return $ret;}())));
		$ret.openColumn(readOnlyOpenColumn);
		$ret.closeColumn(readOnlyCloseColumn);
		$ret.highColumn(readOnlyHighColumn);
		$ret.lowColumn(readOnlyLowColumn);
		$ret.volumeColumn(readOnlyVolumeColumn);
		$ret.calculateFrom(position);
		$ret.calculateCount(count);
		$ret.minimumValue(NaN);
		$ret.maximumValue(NaN);
		$ret.count($self.fastItemsSource() != null ? $self.fastItemsSource().count() : 0); return $ret;}());
		return dataSource;
	}

	, 
	makeSafe: function (value) {
		if (Number.isInfinity(value) || $.ig.util.isNaN(value)) {
			return 0;
		}

		return value;
	}

	, 
	provideSupportingCalculations: function (dataSource) {
		var $self = this;
		return (function () { var $ret = new $.ig.FinancialCalculationSupportingCalculations();
		$ret.eMA(new $.ig.ColumnSupportingCalculation(1, $.ig.Series.prototype.eMA, new $.ig.List$1(String, 0)));
		$ret.sMA(new $.ig.ColumnSupportingCalculation(1, $.ig.Series.prototype.sMA, new $.ig.List$1(String, 0)));
		$ret.sTDEV(new $.ig.ColumnSupportingCalculation(1, $.ig.Series.prototype.sTDEV, new $.ig.List$1(String, 0)));
		$ret.movingSum(new $.ig.ColumnSupportingCalculation(1, $.ig.Series.prototype.movingSum, new $.ig.List$1(String, 0)));
		$ret.shortVolumeOscillatorAverage(new $.ig.DataSourceSupportingCalculation(1, function (ds1) { return $.ig.Series.prototype.eMA(ds1.volumeColumn(), ds1.shortPeriod()); }, (function () { var $ret = new $.ig.List$1(String, 0);
		$ret.add($.ig.FinancialSeries.prototype.volumeColumnPropertyName); return $ret;}())));
		$ret.longVolumeOscillatorAverage(new $.ig.DataSourceSupportingCalculation(1, function (ds2) { return $.ig.Series.prototype.eMA(ds2.volumeColumn(), ds2.longPeriod()); }, (function () { var $ret = new $.ig.List$1(String, 0);
		$ret.add($.ig.FinancialSeries.prototype.volumeColumnPropertyName); return $ret;}())));
		$ret.shortPriceOscillatorAverage(new $.ig.DataSourceSupportingCalculation(1, function (ds3) { return $.ig.Series.prototype.eMA(ds3.typicalColumn(), ds3.shortPeriod()); }, dataSource.typicalColumn().basedOn()));
		$ret.longPriceOscillatorAverage(new $.ig.DataSourceSupportingCalculation(1, function (ds4) { return $.ig.Series.prototype.eMA(ds4.typicalColumn(), ds4.longPeriod()); }, dataSource.typicalColumn().basedOn()));
		$ret.toEnumerableRange($.ig.Series.prototype.toEnumerableRange);
		$ret.toEnumerable($.ig.Series.prototype.toEnumerable);
		$ret.makeSafe($self.makeSafe.runOn($self)); return $ret;}());
	}

	, 
	categoryAxis: function () {

			return this.xAxis();
	}

	, 
	_thumbnailFrame: null,
	thumbnailFrame: function (value) {
		if (arguments.length === 1) {
			this._thumbnailFrame = value;
			return value;
		} else {
			return this._thumbnailFrame;
		}
	}

	, 
	renderThumbnail: function (viewportRect, surface) {
		$.ig.Series.prototype.renderThumbnail.call(this, viewportRect, surface);
		if (!this.thumbnailDirty()) {
			this.view().prepSurface(surface);
			return;
		}

		var thumbnailView = $.ig.util.cast($.ig.FinancialSeriesView.prototype.$type, this.thumbnailView());
		this.view().prepSurface(surface);
		thumbnailView.bucketCalculator().calculateBuckets(this.resolution());
		if (this.clearAndAbortIfInvalid1(this.thumbnailView())) {
			return;
		}

		if (!this.skipThumbnailPrepare()) {
			this.prepareFrame(this.thumbnailFrame(), thumbnailView);
		}

		this.skipThumbnailPrepare(false);
		this.renderFrame(this.thumbnailFrame(), thumbnailView);
		this.thumbnailDirty(false);
	}

	, 
	_alternateFrame: null,
	alternateFrame: function (value) {
		if (arguments.length === 1) {
			this._alternateFrame = value;
			return value;
		} else {
			return this._alternateFrame;
		}
	}

	, 
	renderAlternateView: function (viewportRect, windowRect, surface, viewIdentifier, effectiveScalingRatio) {
		$.ig.Series.prototype.renderAlternateView.call(this, viewportRect, windowRect, surface, viewIdentifier, effectiveScalingRatio);
		var view = this.alternateViews().item(viewIdentifier);
		var financialSeriesView = view;
		financialSeriesView.bucketCalculator().calculateBuckets(this.resolution());
		view.prepAltSurface(surface);
		if (this.clearAndAbortIfInvalid1(financialSeriesView)) {
			return;
		}

		if (this.alternateFrame() == null) {
			this.alternateFrame(new $.ig.CategoryFrame(3));
		}

		this.alternateFrame().clearFrame();
		this.prepareFrame(this.alternateFrame(), financialSeriesView);
		this.renderFrame(this.alternateFrame(), financialSeriesView);
	}
	, 
	$type: new $.ig.Type('FinancialSeries', $.ig.Series.prototype.$type, [$.ig.IHasCategoryAxis.prototype.$type])
}, true);

$.ig.util.defType('FinancialIndicator', 'FinancialSeries', {

	createView: function () {
		return new $.ig.FinancialIndicatorView(this);
	}

	, 
	onViewCreated: function (view) {
		$.ig.FinancialSeries.prototype.onViewCreated.call(this, view);
		this.indicatorView(view);
	}

	, 
	_indicatorView: null,
	indicatorView: function (value) {
		if (arguments.length === 1) {
			this._indicatorView = value;
			return value;
		} else {
			return this._indicatorView;
		}
	}
	, 
	init: function () {



		$.ig.FinancialSeries.prototype.init.call(this);
			this._previousFrame = new $.ig.CategoryFrame(3);
			this._transitionFrame = new $.ig.CategoryFrame(3);
			this._currentFrame = new $.ig.CategoryFrame(3);
			this.indicatorColumn(new $.ig.List$1(Number, 0));
			this.indicatorRange(new $.ig.AxisRange(-100, 100));
	}

	, 
	ensureYRangeThenRender: function (animate) {
		if (this.yAxis() != null && !this.yAxis().updateRange()) {
			this.renderSeries(true);
		}

	}

	, 
	dataUpdatedOverride: function (action, position, count, propertyName) {
		var $self = this;
		if ($self.xAxis() != null && $.ig.util.cast($.ig.ISortingAxis.prototype.$type, $self.xAxis()) !== null) {
			($.ig.util.cast($.ig.ISortingAxis.prototype.$type, $self.xAxis())).notifyDataChanged();
		}

		$self.indicatorView().trendLineManager().dataUpdated(action, position, count, propertyName);
		if (propertyName != null && $self._mappingToColumnName.containsKey(propertyName)) {
			(function () { var $ret = $self._mappingToColumnName.tryGetValue(propertyName, propertyName); propertyName = $ret.p1; return $ret.ret; }());
		}

		if ($self.xAxis() != null && $.ig.util.cast($.ig.ISortingAxis.prototype.$type, $self.xAxis()) !== null) {
			action = $.ig.FastItemsSourceEventAction.prototype.reset;
			position = 0;
			count = $self.fastItemsSource().count();
		}

		switch (action) {
			case $.ig.FastItemsSourceEventAction.prototype.change:
				if ($self.shouldUpdateIndicator(position, count, propertyName)) {
					$self.updateIndicator(position, count, propertyName);
					$self.ensureYRangeThenRender(true);
				}

				break;
			case $.ig.FastItemsSourceEventAction.prototype.replace:
				if ($self.shouldUpdateIndicator(position, $self.fastItemsSource().count() - position, propertyName)) {
					$self.updateIndicator(position, $self.fastItemsSource().count() - position, propertyName);
					$self.ensureYRangeThenRender(true);
				}

				break;
			case $.ig.FastItemsSourceEventAction.prototype.insert:
				if ($self.shouldUpdateIndicator(position, $self.fastItemsSource().count() - position, propertyName)) {
					var newVals = new Array(count);
					for (var j = 0; j < count; j++) {
						newVals[j] = 0;
					}

					$self.indicatorColumn().insertRange(position, newVals);
					$self.updateIndicator(position, $self.fastItemsSource().count() - position, propertyName);
					$self.ensureYRangeThenRender(true);
				}

				break;
			case $.ig.FastItemsSourceEventAction.prototype.remove:
				if ($self.shouldUpdateIndicator(position, $self.fastItemsSource().count() - position, propertyName)) {
					$self.indicatorColumn().removeRange(position, count);
					$self.updateIndicator(position, $self.fastItemsSource().count() - position, propertyName);
					$self.ensureYRangeThenRender(true);
				}

				break;
			case $.ig.FastItemsSourceEventAction.prototype.reset:
				if ($self.shouldUpdateIndicator(position, $self.fastItemsSource().count() - position, propertyName)) {
					$self.indicatorColumn(new $.ig.List$1(Number, 2, $self.fastItemsSource().count()));
					var newVals1 = new Array(count);
					for (var j1 = 0; j1 < count; j1++) {
						newVals1[j1] = 0;
					}

					$self.indicatorColumn().insertRange(0, newVals1);
					$self.updateIndicator(position, $self.fastItemsSource().count() - position, propertyName);
					$self.ensureYRangeThenRender(true);
				}

				break;
		}

	}

	, 
	displayType: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.FinancialIndicator.prototype.displayTypeProperty, $.ig.IndicatorDisplayType.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.FinancialIndicator.prototype.displayTypeProperty));
		}
	}

	, 
	ignoreFirst: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.FinancialIndicator.prototype.ignoreFirstProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.FinancialIndicator.prototype.ignoreFirstProperty));
		}
	}

	, 
	trendLineType: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.FinancialIndicator.prototype.trendLineTypeProperty, $.ig.TrendLineType.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.FinancialIndicator.prototype.trendLineTypeProperty));
		}
	}

	, 
	trendLineBrush: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.FinancialIndicator.prototype.trendLineBrushProperty, value);
			return value;
		} else {

			return this.getValue($.ig.FinancialIndicator.prototype.trendLineBrushProperty);
		}
	}

	, 
	actualTrendLineBrush: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.FinancialIndicator.prototype.actualTrendLineBrushProperty, value);
			return value;
		} else {

			return this.getValue($.ig.FinancialIndicator.prototype.actualTrendLineBrushProperty);
		}
	}

	, 
	trendLineThickness: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.FinancialIndicator.prototype.trendLineThicknessProperty, value);
			return value;
		} else {

			return this.getValue($.ig.FinancialIndicator.prototype.trendLineThicknessProperty);
		}
	}

	, 
	trendLineDashCap: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.FinancialIndicator.prototype.trendLineDashCapProperty, $.ig.PenLineCap.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.FinancialIndicator.prototype.trendLineDashCapProperty));
		}
	}

	, 
	trendLineDashArray: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.FinancialIndicator.prototype.trendLineDashArrayProperty, value);
			return value;
		} else {

			return this.getValue($.ig.FinancialIndicator.prototype.trendLineDashArrayProperty);
		}
	}

	, 
	trendLinePeriod: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.FinancialIndicator.prototype.trendLinePeriodProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.FinancialIndicator.prototype.trendLinePeriodProperty));
		}
	}

	, 
	trendPeriodOverride: function () {
		return -1;
	}

	, 
	trendLineZIndex: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.FinancialIndicator.prototype.trendLineZIndexProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.FinancialIndicator.prototype.trendLineZIndexProperty));
		}
	}

	, 
	_indicatorColumn: null,
	indicatorColumn: function (value) {
		if (arguments.length === 1) {
			this._indicatorColumn = value;
			return value;
		} else {
			return this._indicatorColumn;
		}
	}

	, 
	_indicatorRange: null,
	indicatorRange: function (value) {
		if (arguments.length === 1) {
			this._indicatorRange = value;
			return value;
		} else {
			return this._indicatorRange;
		}
	}

	, 
	indicatorOverride: function (position, count) {}

	, 
	basedOn: function (position, count) {}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		switch (propertyName) {
			case $.ig.FinancialSeries.prototype.xAxisPropertyName:
				this.indicatorView().selectTrendlineManager();
				break;
		}

		$.ig.FinancialSeries.prototype.propertyUpdatedOverride.call(this, sender, propertyName, oldValue, newValue);
		if (this.indicatorView().trendLineManager().propertyUpdated(sender, propertyName, oldValue, newValue)) {
			this.renderSeries(false);
			this.notifyThumbnailAppearanceChanged();
		}

		switch (propertyName) {
			case $.ig.Series.prototype.fastItemsSourcePropertyName:
				if (this.fastItemsSource() != null) {
					this.indicatorColumn(new $.ig.List$1(Number, 2, this.fastItemsSource().count()));
					var newVals = new Array(this.fastItemsSource().count());
					for (var j = 0; j < this.fastItemsSource().count(); j++) {
						newVals[j] = 0;
					}

					this.indicatorColumn().insertRange(0, newVals);
					this.updateIndicator(0, this.fastItemsSource().count(), null);
					if (this.yAxis() != null && !this.yAxis().updateRange()) {
						this.financialView().bucketCalculator().calculateBuckets(this.resolution());
						this.renderSeries(false);
					}

				}

				break;
			case $.ig.Series.prototype.trendLineBrushPropertyName:
				this.updateIndexedProperties();
				break;
			case $.ig.FinancialIndicator.prototype.displayTypePropertyName:
				this.clearRendering(true, this.view());
				this.renderSeries(false);
				this.notifyThumbnailAppearanceChanged();
				break;
			case $.ig.FinancialSeries.prototype.openColumnPropertyName:
			case $.ig.FinancialSeries.prototype.highColumnPropertyName:
			case $.ig.FinancialSeries.prototype.lowColumnPropertyName:
			case $.ig.FinancialSeries.prototype.closeColumnPropertyName:
			case $.ig.FinancialSeries.prototype.volumeColumnPropertyName:
				if (this.fastItemsSource() != null) {
					if (this.indicatorColumn().count() != this.fastItemsSource().count()) {
						this.indicatorColumn(new $.ig.List$1(Number, 2, this.fastItemsSource().count()));
						var newVals1 = new Array(this.fastItemsSource().count());
						for (var j1 = 0; j1 < this.fastItemsSource().count(); j1++) {
							newVals1[j1] = 0;
						}

						this.indicatorColumn().insertRange(0, newVals1);
					}

					if (this.shouldUpdateIndicator(0, this.fastItemsSource().count() - 1, propertyName)) {
						this.fullIndicatorRefresh();
					}

				}

				break;
			case $.ig.FinancialSeries.prototype.xAxisPropertyName:
				if (this.xAxis() != null && ($.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.xAxis()) !== null || $.ig.util.cast($.ig.ISortingAxis.prototype.$type, oldValue) !== null)) {
					this.fullIndicatorRefresh();
				}

				break;
			case $.ig.FinancialSeries.prototype.yAxisPropertyName:
			case $.ig.FinancialIndicator.prototype.ignoreFirstPropertyName:
				this.fullIndicatorRefresh();
				this.notifyThumbnailAppearanceChanged();
				break;
			case $.ig.Series.prototype.trendLineTypePropertyName:
				this.notifyThumbnailAppearanceChanged();
				break;
		}

	}

	, 
	getSeriesValue: function (world, useInterpolation, skipUnknowns) {
		if (this.indicatorColumn() == null) {
			return $.ig.FinancialSeries.prototype.getSeriesValue.call(this, world, useInterpolation, skipUnknowns);
		}

		var offset = this.getOffset(this.view().windowRect(), this.view().viewport());
		var xParams = new $.ig.ScalerParams(this.view().windowRect(), this.view().viewport(), this.xAxis().isInverted());
		xParams._effectiveViewportRect = this.seriesViewer().viewportRect();
		return this.getSeriesValueHelper(this.indicatorColumn(), world, this.xAxis(), xParams, offset, this.getExactUnsortedItemIndex.runOn(this), useInterpolation, skipUnknowns);
	}

	, 
	getPreviousOrExactIndex: function (world, skipUnknowns) {
		if (this.indicatorColumn() == null) {
			return $.ig.FinancialSeries.prototype.getPreviousOrExactIndex.call(this, world, skipUnknowns);
		}

		return this.getPreviousOrExactIndexHelper(world, skipUnknowns, this.xAxis(), this.getExactUnsortedItemIndex.runOn(this), this.indicatorColumn());
	}

	, 
	getNextOrExactIndex: function (world, skipUnknowns) {
		if (this.indicatorColumn() == null) {
			return $.ig.FinancialSeries.prototype.getNextOrExactIndex.call(this, world, skipUnknowns);
		}

		return this.getNextOrExactIndexHelper(world, skipUnknowns, this.xAxis(), this.getExactUnsortedItemIndex.runOn(this), this.indicatorColumn());
	}

	, 
	usesPresortedValueColumn: function () {

			return true;
	}

	, 
	shouldUpdateIndicator: function (position, count, updatedPropertyName) {
		if (updatedPropertyName == null) {
			return true;
		}

		if (this.basedOn(position, count).contains(updatedPropertyName)) {
			return true;
		}

		return false;
	}

	, 
	updateIndicator: function (position, count, updatedPropertyName) {
		this.indicatorOverride(position, count);
	}

	, 
	getRange: function (axis) {
		if (this.fastItemsSource() == null) {
			return null;
		}

		if (axis != null && axis == this.yAxis()) {
			return this.indicatorRange();
		}

		return null;
	}

	, 
	scrollIntoView: function (item) {
		var index = this.fastItemsSource() != null ? this.fastItemsSource().indexOf(item) : -1;
		var windowRect = this.view().windowRect();
		var viewportRect = this.view().viewport();
		var unitRect = new $.ig.Rect(0, 0, 0, 1, 1);
		if (index >= 0 && windowRect != null && viewportRect != null) {
			if (this.xAxis() != null) {
				var xParams = new $.ig.ScalerParams(unitRect, unitRect, this.xAxis().isInverted());
				var cx = this.xAxis().getScaledValue(index, xParams);
				if (cx < windowRect.left() + 0.1 * windowRect.width()) {
					cx = cx + 0.4 * windowRect.width();
				}

				if (cx > windowRect.right() - 0.1 * windowRect.width()) {
					cx = cx - 0.4 * windowRect.width();
				}

				windowRect.x(cx - 0.5 * windowRect.width());
			}

			if (this.yAxis() != null && this.indicatorColumn() != null && index < this.indicatorColumn().count()) {
				var yParams = new $.ig.ScalerParams(unitRect, unitRect, this.yAxis().isInverted());
				var cy = this.yAxis().getScaledValue(this.indicatorColumn().__inner[index], yParams);
				if (cy < windowRect.top() + 0.1 * windowRect.height()) {
					cy = cy + 0.4 * windowRect.height();
				}

				if (cy > windowRect.bottom() - 0.1 * windowRect.height()) {
					cy = cy - 0.4 * windowRect.height();
				}

				windowRect.y(cy - 0.5 * windowRect.height());
			}

			this.syncLink().windowNotify(this.seriesViewer(), windowRect);
		}

		return index >= 0;
	}

	, 
	validateSeries: function (viewportRect, windowRect, view) {
		var isValid = $.ig.FinancialSeries.prototype.validateSeries.call(this, viewportRect, windowRect, view);
		if (this.indicatorColumn() == null || this.indicatorColumn().count() == 0) {
			isValid = false;
		}

		return isValid;
	}

	, 
	prepareFrame: function (frame, view) {
		var $self = this;
		$.ig.FinancialSeries.prototype.prepareFrame.call($self, frame, view);
		var windowRect = view.windowRect();
		var viewportRect = view.viewport();
		var xaxis = $self.xAxis();
		var yaxis = $self.yAxis();
		var xParams = new $.ig.ScalerParams(windowRect, viewportRect, xaxis.isInverted());
		var yParams = new $.ig.ScalerParams(windowRect, viewportRect, yaxis.isInverted());
		frame._buckets.clear();
		frame._markers.clear();
		frame._trend.clear();
		var offset = 0;
		var sortingXAxis = $.ig.util.cast($.ig.ISortingAxis.prototype.$type, $self.xAxis());
		if (sortingXAxis != null && sortingXAxis.sortedIndices().count() != $self.fastItemsSource().count()) {
			return;
		}

		offset = $self.getOffset(windowRect, viewportRect);
		var _trendPeriod = $self.trendPeriodOverride();
		if (_trendPeriod == -1) {
			_trendPeriod = $self.trendLinePeriod();
		}

		var indicatorView = $.ig.util.cast($.ig.FinancialIndicatorView.prototype.$type, view);
		$self.indicatorView().trendLineManager().prepareLine(frame._trend, $self.trendLineType(), $self.indicatorColumn(), _trendPeriod, function (x) { return $self.xAxis().getScaledValue(x, xParams); }, function (y) { return $self.yAxis().getScaledValue(y, yParams); }, (function () { var $ret = new $.ig.TrendResolutionParams();
		$ret.bucketSize(view.bucketCalculator().bucketSize());
		$ret.firstBucket(view.bucketCalculator().firstBucket());
		$ret.lastBucket(view.bucketCalculator().lastBucket());
		$ret.offset(offset);
		$ret.resolution($self.resolution());
		$ret.viewport(viewportRect);
		$ret.window(windowRect); return $ret;}()));
		var singlePixelSpan = $self.convertToSingle($self.xAxis().getUnscaledValue(2, xParams) - $self.xAxis().getUnscaledValue(1, xParams));
		for (var i = view.bucketCalculator().firstBucket(); i <= view.bucketCalculator().lastBucket(); ++i) {
			var bucket;
			if (sortingXAxis == null) {
				bucket = view.bucketCalculator().getBucket(i);

			} else {
				var index = sortingXAxis.sortedIndices().__inner[i];
				var bucketX = sortingXAxis.getUnscaledValueAt(index);
				var bucketY0 = $self.convertToSingle($self.indicatorColumn().__inner[i]);
				var bucketY1 = bucketY0;
				var currentX = bucketX;
				while (i < view.bucketCalculator().lastBucket()) {
					index = sortingXAxis.sortedIndices().__inner[i + 1];
					currentX = sortingXAxis.getUnscaledValueAt(index);
					if (currentX - bucketX > singlePixelSpan) {
						break;
					}

					i++;
					var y = $self.convertToSingle($self.indicatorColumn().__inner[i]);
					bucketY0 = Math.min(bucketY0, y);
					bucketY1 = Math.max(bucketY1, y);

				}
				var xVal = NaN;
				if (!$.ig.util.isNaN(bucketX)) {
					xVal = $self.xAxis().getScaledValue(bucketX, xParams);
				}

				bucket = (function () { var $ret = new Array();
				$ret.add($self.convertToSingle(xVal));
				$ret.add(bucketY0);
				$ret.add(bucketY1);return $ret;}());
			}

			if (!isNaN(bucket[0])) {
				if ($self.xAxis() != null && $.ig.util.cast($.ig.ISortingAxis.prototype.$type, $self.xAxis()) !== null) {
					bucket[0] = (bucket[0] + offset);

				} else {
					bucket[0] = (xaxis.getScaledValue(bucket[0], xParams) + offset);
				}

				bucket[1] = yaxis.getScaledValue(bucket[1], yParams);
				if (view.bucketCalculator().bucketSize() > 1 || sortingXAxis != null) {
					bucket[2] = yaxis.getScaledValue(bucket[2], yParams);

				} else {
					bucket[2] = bucket[1];
				}

				frame._buckets.add(bucket);
			}

		}

		return;
	}

	, 
	convertToSingle: function (p) {
		return p;
	}

	, 
	clearRendering: function (wipeClean, view) {
		$.ig.FinancialSeries.prototype.clearRendering.call(this, wipeClean, view);
		var indicatorView = view;
		indicatorView.clearIndicatorVisual(wipeClean);
		indicatorView.trendLineManager().clearPoints();
	}

	, 
	getDefaultTransitionInMode: function () {
		switch (this.displayType()) {
			case $.ig.IndicatorDisplayType.prototype.area:
				return $.ig.CategoryTransitionInMode.prototype.fromZero;
			case $.ig.IndicatorDisplayType.prototype.column:
				return $.ig.CategoryTransitionInMode.prototype.fromZero;
			case $.ig.IndicatorDisplayType.prototype.line:
				return $.ig.CategoryTransitionInMode.prototype.sweepFromCategoryAxisMinimum;
		}

		return $.ig.CategoryTransitionInMode.prototype.fromZero;
	}

	, 
	renderFrame: function (frame, view) {
		var $self = this;
		$.ig.FinancialSeries.prototype.renderFrame.call($self, frame, view);
		var indicatorView = $.ig.util.cast($.ig.FinancialIndicatorView.prototype.$type, view);
		var x0 = function (i) {
				return frame._buckets.__inner[i][0];
		};
		var y0 = function (i) {
				return frame._buckets.__inner[i][1];
		};
		var x1 = function (i) {
				return frame._buckets.__inner[i][0];
		};
		var y1 = function (i) {
				return frame._buckets.__inner[i][2];
		};
		indicatorView.trendLineManager().clearPoints();
		indicatorView.trendLineManager().rasterizeTrendLine(frame._trend);
		var viewportRect = view.viewport();
		var zero = 0;
		var positiveBrush = $self.actualBrush();
		var negativeBrush = $self.negativeBrush();
		if (view.checkFrameDirty(frame)) {
			indicatorView.clearIndicatorVisual(false);
			if (frame._buckets.count() > 0) {
				switch ($self.displayType()) {
					case $.ig.IndicatorDisplayType.prototype.line:
						indicatorView.rasterizeLine(frame._buckets.count(), x0, y0, x1, y1, true);
						break;
					case $.ig.IndicatorDisplayType.prototype.area:
						if ($self.yAxis() != null) {
							zero = $self.getWorldZeroValue(view);

						} else {
							zero = 0.5 * (viewportRect.top() + viewportRect.bottom());
						}

						indicatorView.rasterizeArea(frame._buckets.count(), x0, y0, x1, y1, true, zero);
						break;
					case $.ig.IndicatorDisplayType.prototype.column:
						zero = $self.getWorldZeroValue(view);
						indicatorView.rasterizeColumns(frame._buckets.count(), x0, y0, x1, y1, true, zero);
						break;
					default:
						throw new $.ig.NotImplementedException(0);
				}

			}

			view.updateFrameVersion(frame);
		}

		var buckets = frame._buckets;
		var valueCount = $self.fastItemsSource().count();
		$self._renderManager.initCategoryRenderSettings($self, $self.shouldOverrideCategoryStyle(), $self.xAxis(), $self.getCategoryItems.runOn($self), $self.getBucketSize(view), $self.getFirstBucket(view));
		var areStylesOverriden = false;
		var args = $self._renderManager.categoryOverrideArgs();
		if (args != null) {
			areStylesOverriden = true;
		}

		$self._renderManager._initialRenderFill = positiveBrush;
		$self._renderManager._actualRenderFill = positiveBrush;
		if (areStylesOverriden) {
			var xParams = new $.ig.ScalerParams(view.windowRect(), view.viewport(), $self.xAxis().isInverted());
			$self._renderManager._actualNegativeShape = false;
			$self.performCategoryStyleOverride(buckets, -1, valueCount, $self.xAxis(), xParams, view.isThumbnailView());
		}

		$self._renderManager.setCategoryShapeAppearance(indicatorView._positivePath0, true, false, true, false);
		$self._renderManager.setCategoryShapeAppearance(indicatorView._positivePath1, true, false, true, false);
		$self._renderManager.setCategoryShapeAppearance(indicatorView._positivePath01, false, true, false, false);
		indicatorView._positivePath01.__opacity = 0.8 * $self._renderManager._actualRenderOpacity * $self.actualAreaFillOpacity();
		$self._renderManager.setCategoryShapeAppearance(indicatorView._positiveColumns, true, false, false, false);
		$self._renderManager._initialRenderFill = negativeBrush;
		$self._renderManager._actualRenderFill = negativeBrush;
		if (areStylesOverriden) {
			var xParams1 = new $.ig.ScalerParams(view.windowRect(), view.viewport(), $self.xAxis().isInverted());
			$self._renderManager._actualNegativeShape = true;
			$self.performCategoryStyleOverride(buckets, -1, valueCount, $self.xAxis(), xParams1, view.isThumbnailView());
		}

		$self._renderManager.setCategoryShapeAppearance(indicatorView._negativePath0, true, false, true, false);
		$self._renderManager.setCategoryShapeAppearance(indicatorView._negativePath1, true, false, true, false);
		$self._renderManager.setCategoryShapeAppearance(indicatorView._negativePath01, false, true, false, false);
		indicatorView._negativePath01.__opacity = 0.8 * $self._renderManager._actualRenderOpacity * $self.actualAreaFillOpacity();
		$self._renderManager.setCategoryShapeAppearance(indicatorView._negativeColumns, true, false, false, false);
		indicatorView.updateHitTests();
	}

	, 
	updateIndexedProperties: function () {
		$.ig.FinancialSeries.prototype.updateIndexedProperties.call(this);
		if (this.index() < 0) {
			return;
		}

		this.indicatorView().updateTrendlineBrush();
	}

	, 
	fullIndicatorRefresh: function () {
		this.indicatorView().trendLineManager().reset();
		this.indicatorOverride(0, this.indicatorColumn().count());
		if (this.yAxis() != null && !this.yAxis().updateRange()) {
			this.renderSeries(false);
		}

	}

	, 
	exportVisualDataOverride: function (svd) {
		$.ig.FinancialSeries.prototype.exportVisualDataOverride.call(this, svd);
		var trendShape = new $.ig.PolyLineVisualData(1, "trendLine", this.indicatorView().trendLineManager().trendPolyline());
		trendShape.tags().add("Trend");
		svd.shapes().add(trendShape);
	}
	, 
	$type: new $.ig.Type('FinancialIndicator', $.ig.FinancialSeries.prototype.$type)
}, true);

$.ig.util.defType('StrategyBasedIndicator', 'FinancialIndicator', {
	init: function () {



		$.ig.FinancialIndicator.prototype.init.call(this);
			this.actualCalculationStrategy(this.calculationStrategy());
			this.defaultStyleKey(this.styleKeyType());
	}

	, 
	_actualCalculationStrategy: null,
	actualCalculationStrategy: function (value) {
		if (arguments.length === 1) {
			this._actualCalculationStrategy = value;
			return value;
		} else {
			return this._actualCalculationStrategy;
		}
	}

	, 
	calculationStrategy: function () {
	}

	, 
	styleKeyType: function () {
	}

	, 
	periodOverride: function () {
		return -2147483648;
	}

	, 
	shortPeriodOverride: function () {
		return -2147483648;
	}

	, 
	longPeriodOverride: function () {
		return -2147483648;
	}

	, 
	createPeriodPropertyHelper: function (defaultValue, ownerType, propertyName) {
		var $self = this;
		var prop = $.ig.DependencyProperty.prototype.register(propertyName, $.ig.Number.prototype.$type, ownerType, new $.ig.PropertyMetadata(2, defaultValue, function (sender, e) {
			($.ig.util.cast($.ig.StrategyBasedIndicator.prototype.$type, sender)).raisePropertyChanged(propertyName, e.oldValue(), e.newValue());
		}));
		$.ig.StrategyBasedIndicator.prototype.invalidatesSeries.add(propertyName);
		return prop;
	}

	, 
	createPeriodProperty: function (defaultValue, ownerType) {
		return $.ig.StrategyBasedIndicator.prototype.createPeriodPropertyHelper(defaultValue, ownerType, $.ig.StrategyBasedIndicator.prototype.periodPropertyName);
	}

	, 
	createLongPeriodProperty: function (defaultValue, ownerType) {
		return $.ig.StrategyBasedIndicator.prototype.createPeriodPropertyHelper(defaultValue, ownerType, $.ig.StrategyBasedIndicator.prototype.longPeriodPropertyName);
	}

	, 
	createShortPeriodProperty: function (defaultValue, ownerType) {
		return $.ig.StrategyBasedIndicator.prototype.createPeriodPropertyHelper(defaultValue, ownerType, $.ig.StrategyBasedIndicator.prototype.shortPeriodPropertyName);
	}

	, 
	basedOn: function (position, count) {
		var dataSource = this.provideDataSource(position, count);
		var supportingCalculations = this.provideSupportingCalculations(dataSource);
		return this.actualCalculationStrategy().basedOn(dataSource, supportingCalculations);
	}

	, 
	indicatorOverride: function (position, count) {
		var dataSource = this.provideDataSource(position, count);
		if (count == 0) {
			return false;
		}

		if (!this.validateBasedOn(this.basedOn(position, count))) {
			return false;
		}

		var supportingCalculations = this.provideSupportingCalculations(dataSource);
		if (this.indicatorRange() != null) {
			dataSource.minimumValue(this.indicatorRange().minimum());
			dataSource.maximumValue(this.indicatorRange().maximum());
		}

		var retVal = this.actualCalculationStrategy().calculateIndicator(dataSource, supportingCalculations);
		for (var i = 0; i < this.ignoreFirst() && i < dataSource.indicatorColumn().count(); i++) {
			dataSource.indicatorColumn().item(i, NaN);
		}

		if (this.yAxis() != null && this.updateRange(dataSource)) {
			this.yAxis().updateRange();
		}

		return retVal;
	}

	, 
	updateRange: function (dataSource) {
		if (!$.ig.util.isNaN(dataSource.minimumValue()) && !$.ig.util.isNaN(dataSource.maximumValue()) && dataSource.specifiesRange()) {
			var pRange = this.indicatorRange();
			this.indicatorRange(new $.ig.AxisRange(dataSource.minimumValue(), dataSource.maximumValue()));
			return this.rangesDiffer(pRange, this.indicatorRange());
		}

		var minimum = 1.7976931348623157E+308;
		var maximum = -1.7976931348623157E+308;
		var en = dataSource.indicatorColumn().getEnumerator();
		while (en.moveNext()) {
			var value = en.current();
			if (!$.ig.util.isNaN(value)) {
				minimum = Math.min(minimum, value);
				maximum = Math.max(maximum, value);
			}

		}

		var prevRange = this.indicatorRange();
		this.indicatorRange(new $.ig.AxisRange(minimum, maximum));
		return this.rangesDiffer(prevRange, this.indicatorRange());
	}

	, 
	rangesDiffer: function (prevRange, indicatorRange) {
		if (prevRange == null || indicatorRange == null) {
			return true;
		}

		if (prevRange.minimum() != indicatorRange.minimum()) {
			return true;
		}

		if (prevRange.maximum() != indicatorRange.maximum()) {
			return true;
		}

		return false;
	}

	, 
	sanitizePeriod: function (periodValue) {
		if (periodValue == -2147483648) {
			return 0;
		}

		if (periodValue > this.indicatorColumn().count() && this.indicatorColumn().count() > 0) {
			periodValue = this.indicatorColumn().count() - 1;
		}

		if (periodValue < 1) {
			return 1;
		}

		return periodValue;
	}

	, 
	provideDataSource: function (position, count) {
		var dataSource = $.ig.FinancialIndicator.prototype.provideDataSource.call(this, position, count);
		dataSource.indicatorColumn(this.indicatorColumn());
		dataSource.period(this.sanitizePeriod(this.periodOverride()));
		dataSource.shortPeriod(this.sanitizePeriod(this.shortPeriodOverride()));
		dataSource.longPeriod(this.sanitizePeriod(this.longPeriodOverride()));
		dataSource.multiplier(this.multiplierOverride());
		return dataSource;
	}

	, 
	multiplierOverride: function () {
		return 1;
	}

	, 
	createMultiplierProperty: function (defaultValue, ownerType) {
		var $self = this;
		var prop = $.ig.DependencyProperty.prototype.register($.ig.StrategyBasedIndicator.prototype._multiplerPropertyName, Number, ownerType, new $.ig.PropertyMetadata(2, defaultValue, function (sender, e) {
			($.ig.util.cast($.ig.StrategyBasedIndicator.prototype.$type, sender)).raisePropertyChanged($.ig.StrategyBasedIndicator.prototype._multiplerPropertyName, e.oldValue(), e.newValue());
		}));
		$.ig.StrategyBasedIndicator.prototype.invalidatesSeries.add($.ig.StrategyBasedIndicator.prototype._multiplerPropertyName);
		return prop;
	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		$.ig.FinancialIndicator.prototype.propertyUpdatedOverride.call(this, sender, propertyName, oldValue, newValue);
		if ($.ig.StrategyBasedIndicator.prototype.invalidatesSeries.contains(propertyName)) {
			if (this.yAxis() != null && !this.yAxis().updateRange()) {
				this.financialView().bucketCalculator().calculateBuckets(this.resolution());
				this.indicatorOverride(0, this.indicatorColumn().count());
				this.indicatorView().trendLineManager().reset();
				this.renderSeries(false);
			}

		}

	}
	, 
	$type: new $.ig.Type('StrategyBasedIndicator', $.ig.FinancialIndicator.prototype.$type)
}, true);

$.ig.util.defType('AbsoluteVolumeOscillatorIndicator', 'StrategyBasedIndicator', {
	init: function () {


		$.ig.StrategyBasedIndicator.prototype.init.call(this);

	}
	, 
	calculationStrategy: function () {

			return new $.ig.AbsoluteVolumeOscillatorIndicatorStrategy();
	}

	, 
	styleKeyType: function () {

			return $.ig.AbsoluteVolumeOscillatorIndicator.prototype.$type;
	}

	, 
	shortPeriod: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.AbsoluteVolumeOscillatorIndicator.prototype.shortPeriodProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.AbsoluteVolumeOscillatorIndicator.prototype.shortPeriodProperty));
		}
	}

	, 
	shortPeriodOverride: function () {
		return this.shortPeriod();
	}

	, 
	longPeriod: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.AbsoluteVolumeOscillatorIndicator.prototype.longPeriodProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.AbsoluteVolumeOscillatorIndicator.prototype.longPeriodProperty));
		}
	}

	, 
	longPeriodOverride: function () {
		return this.longPeriod();
	}
	, 
	$type: new $.ig.Type('AbsoluteVolumeOscillatorIndicator', $.ig.StrategyBasedIndicator.prototype.$type)
}, true);

$.ig.util.defType('AccumulationDistributionIndicator', 'StrategyBasedIndicator', {
	init: function () {


		$.ig.StrategyBasedIndicator.prototype.init.call(this);

	}
	, 
	calculationStrategy: function () {

			return new $.ig.AccumulationDistributionIndicatorStrategy();
	}

	, 
	styleKeyType: function () {

			return $.ig.AccumulationDistributionIndicator.prototype.$type;
	}
	, 
	$type: new $.ig.Type('AccumulationDistributionIndicator', $.ig.StrategyBasedIndicator.prototype.$type)
}, true);

$.ig.util.defType('AverageDirectionalIndexIndicator', 'StrategyBasedIndicator', {
	init: function () {


		$.ig.StrategyBasedIndicator.prototype.init.call(this);

	}
	, 
	calculationStrategy: function () {

			return new $.ig.AverageDirectionalIndexIndicatorStrategy();
	}

	, 
	styleKeyType: function () {

			return $.ig.AverageDirectionalIndexIndicator.prototype.$type;
	}

	, 
	period: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.AverageDirectionalIndexIndicator.prototype.periodProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.AverageDirectionalIndexIndicator.prototype.periodProperty));
		}
	}

	, 
	periodOverride: function () {
		return this.period();
	}
	, 
	$type: new $.ig.Type('AverageDirectionalIndexIndicator', $.ig.StrategyBasedIndicator.prototype.$type)
}, true);

$.ig.util.defType('AverageTrueRangeIndicator', 'StrategyBasedIndicator', {
	init: function () {


		$.ig.StrategyBasedIndicator.prototype.init.call(this);

	}
	, 
	calculationStrategy: function () {

			return new $.ig.AverageTrueRangeIndicatorStrategy();
	}

	, 
	styleKeyType: function () {

			return $.ig.AverageTrueRangeIndicator.prototype.$type;
	}

	, 
	period: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.AverageTrueRangeIndicator.prototype.periodProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.AverageTrueRangeIndicator.prototype.periodProperty));
		}
	}

	, 
	periodOverride: function () {
		return this.period();
	}
	, 
	$type: new $.ig.Type('AverageTrueRangeIndicator', $.ig.StrategyBasedIndicator.prototype.$type)
}, true);

$.ig.util.defType('FinancialOverlay', 'FinancialSeries', {
	init: function () {



		$.ig.FinancialSeries.prototype.init.call(this);
			this.overlayValid(false);
	}

	, 
	dataUpdatedOverride: function (action, position, count, propertyName) {
		if (this.xAxis() != null && $.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.xAxis()) !== null) {
			($.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.xAxis())).notifyDataChanged();
		}

		this.financialView().bucketCalculator().calculateBuckets(this.resolution());
		this.validateOverlay();
		if (this.yAxis() != null) {
			this.yAxis().updateRange();
		}

		this.renderSeries(true);
	}

	, 
	ignoreFirst: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.FinancialOverlay.prototype.ignoreFirstProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.FinancialOverlay.prototype.ignoreFirstProperty));
		}
	}

	, 
	usesPresortedValueColumn: function () {

			return true;
	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		switch (propertyName) {
			case $.ig.Series.prototype.fastItemsSourcePropertyName:
				this.overlayValid(false);
				break;
			case $.ig.FinancialOverlay.prototype.ignoreFirstPropertyName:
				this.overlayValid(false);
				this.renderSeries(false);
				this.notifyThumbnailAppearanceChanged();
				break;
			case $.ig.FinancialSeries.prototype.xAxisPropertyName:
				this.overlayValid(false);
				break;
		}

		$.ig.FinancialSeries.prototype.propertyUpdatedOverride.call(this, sender, propertyName, oldValue, newValue);
	}

	, 
	onApplyTemplate: function () {
		$.ig.FinancialSeries.prototype.onApplyTemplate.call(this);
		this.renderSeries(false);
	}

	, 
	scrollIntoView: function (item) {
		var index = this.fastItemsSource() != null ? this.fastItemsSource().indexOf(item) : -1;
		var windowRect = this.view().windowRect();
		var viewportRect = this.view().viewport();
		var unitRect = new $.ig.Rect(0, 0, 0, 1, 1);
		var xParams = new $.ig.ScalerParams(unitRect, unitRect, this.xAxis().isInverted());
		var yParams = new $.ig.ScalerParams(unitRect, unitRect, this.yAxis().isInverted());
		if (index >= 0 && windowRect != null && viewportRect != null) {
			if (this.xAxis() != null) {
				var cx = this.xAxis().getScaledValue(index, xParams);
				if (cx < windowRect.left() + 0.1 * windowRect.width()) {
					cx = cx + 0.4 * windowRect.width();
				}

				if (cx > windowRect.right() - 0.1 * windowRect.width()) {
					cx = cx - 0.4 * windowRect.width();
				}

				windowRect.x(cx - 0.5 * windowRect.width());
			}

			if (this.yAxis() != null && this.lowColumn() != null && this.highColumn() != null && index < this.lowColumn().count() && index < this.highColumn().count()) {
				var low = this.yAxis().getScaledValue(this.lowColumn().item(index), yParams);
				var high = this.yAxis().getScaledValue(this.highColumn().item(index), yParams);
				if (!$.ig.util.isNaN(low) && !$.ig.util.isNaN(high)) {
					var height = Math.abs(low - high);
					if (windowRect.height() < height) {
						windowRect.height(height);
						windowRect.y(Math.min(low, high));

					} else {
						if (low < windowRect.top() + 0.1 * windowRect.height()) {
							low = low + 0.4 * windowRect.height();
						}

						if (low > windowRect.bottom() - 0.1 * windowRect.height()) {
							low = low - 0.4 * windowRect.height();
						}

						windowRect.y(low - 0.5 * windowRect.height());
					}

				}

			}

			this.syncLink().windowNotify(this.seriesViewer(), windowRect);
		}

		return index >= 0;
	}

	, 
	getRange: function (axis) {
		if (axis != null && axis == this.yAxis() && this.lowColumn() != null && this.highColumn() != null) {
			return new $.ig.AxisRange(this.lowColumn().minimum(), this.highColumn().maximum());
		}

		return null;
	}

	, 
	_overlayValid: false,
	overlayValid: function (value) {
		if (arguments.length === 1) {
			this._overlayValid = value;
			return value;
		} else {
			return this._overlayValid;
		}
	}

	, 
	validateOverlay: function () {}
	, 
	$type: new $.ig.Type('FinancialOverlay', $.ig.FinancialSeries.prototype.$type)
}, true);

$.ig.util.defType('BollingerBandsOverlay', 'FinancialOverlay', {
	init: function () {


		this._averageColumn = new $.ig.List$1(Number, 0);
		this._deviationColumn = new $.ig.List$1(Number, 0);

		$.ig.FinancialOverlay.prototype.init.call(this);
			this.defaultStyleKey($.ig.BollingerBandsOverlay.prototype.$type);
			this._previousFrame = new $.ig.CategoryFrame(4);
			this._transitionFrame = new $.ig.CategoryFrame(4);
			this._currentFrame = new $.ig.CategoryFrame(4);
	}

	, 
	period: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.BollingerBandsOverlay.prototype.periodProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.BollingerBandsOverlay.prototype.periodProperty));
		}
	}

	, 
	multiplier: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.BollingerBandsOverlay.prototype.multiplierProperty, value);
			return value;
		} else {

			return this.getValue($.ig.BollingerBandsOverlay.prototype.multiplierProperty);
		}
	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		if (this.getTypicalBasedOn().contains(propertyName)) {
			this.overlayValid(false);
		}

		$.ig.FinancialOverlay.prototype.propertyUpdatedOverride.call(this, sender, propertyName, oldValue, newValue);
		switch (propertyName) {
			case $.ig.BollingerBandsOverlay.prototype.periodPropertyName:
				this.overlayValid(false);
				this.renderSeries(false);
				break;
			case $.ig.BollingerBandsOverlay.prototype.multiplierPropertyName:
				this.renderSeries(false);
				break;
		}

	}
	, 
	__maxBandWidth: 0
	, 
	__minBandWidth: 0

	, 
	validateOverlay: function () {
		this._averageColumn.clear();
		this._deviationColumn.clear();
		var sma = $.ig.Series.prototype.sMA(new $.ig.SafeEnumerable(this.typicalColumn()), this.period()).getEnumerator();
		var stdev = $.ig.Series.prototype.sTDEV(new $.ig.SafeEnumerable(this.typicalColumn()), this.period()).getEnumerator();
		this.__minBandWidth = 1.7976931348623157E+308;
		this.__maxBandWidth = -1.7976931348623157E+308;
		var moreSma = true;
		var moreStdev = true;
		var multiplier = this.multiplier();
		while (moreSma || moreStdev) {
			if (sma.moveNext()) {
				this._averageColumn.add(sma.current());

			} else {
				moreSma = false;
			}

			if (stdev.moveNext()) {
				this._deviationColumn.add(stdev.current());

			} else {
				moreStdev = false;
			}

			if (moreSma && moreStdev) {
				this.__minBandWidth = Math.min(this.__minBandWidth, sma.current() - stdev.current() * multiplier);
				this.__maxBandWidth = Math.max(this.__maxBandWidth, sma.current() + stdev.current() * multiplier);
			}


		}
		return true;
	}

	, 
	getRange: function (axis) {
		if (this._averageColumn == null || this._deviationColumn == null || axis == null || this.fastItemsSource() == null || axis != this.yAxis()) {
			return null;
		}

		var range = new $.ig.AxisRange(this.__minBandWidth, this.__maxBandWidth);
		return range;
	}
	, 
	_averageColumn: null
	, 
	_deviationColumn: null

	, 
	convertToSingle: function (value) {
		return value;
	}

	, 
	prepareFrame: function (frame, view) {
		var $self = this;
		$.ig.FinancialOverlay.prototype.prepareFrame.call($self, frame, view);
		var windowRect = view.windowRect();
		var viewportRect = view.viewport();
		var xaxis = $self.xAxis();
		var yaxis = $self.yAxis();
		var xParams = new $.ig.ScalerParams(windowRect, viewportRect, xaxis.isInverted());
		var yParams = new $.ig.ScalerParams(windowRect, viewportRect, yaxis.isInverted());
		frame._buckets.clear();
		frame._markers.clear();
		frame._trend.clear();
		var sortingXAxis = $.ig.util.cast($.ig.ISortingAxis.prototype.$type, $self.xAxis());
		if (sortingXAxis != null && sortingXAxis.sortedIndices().count() != $self.fastItemsSource().count()) {
			return;
		}

		var offset = 0;
		offset = $self.getOffset(windowRect, viewportRect);
		if (!$self.overlayValid()) {
			$self.overlayValid($self.validateOverlay());
			if ($self.yAxis() != null) {
				$self.yAxis().updateRange1(true);
			}

		}

		var singlePixelSpan = $self.convertToSingle($self.xAxis().getUnscaledValue(2, xParams) - $self.xAxis().getUnscaledValue(1, xParams));
		for (var i = view.bucketCalculator().firstBucket(); i <= view.bucketCalculator().lastBucket(); ++i) {
			var bucket;
			if (sortingXAxis == null) {
				bucket = view.bucketCalculator().getBucket(i);

			} else {
				var index = sortingXAxis.sortedIndices().__inner[i];
				var bucketX = sortingXAxis.getUnscaledValueAt(index);
				var bucketAverage = $self.convertToSingle($self._averageColumn.__inner[i]);
				var bucketDeviation = $self.convertToSingle($self._deviationColumn.__inner[i]);
				var currentAverage = bucketAverage;
				var currentDeviation = bucketDeviation;
				var currentX = bucketX;
				var counter = 1;
				while (i < view.bucketCalculator().lastBucket()) {
					index = sortingXAxis.sortedIndices().__inner[i + 1];
					currentX = sortingXAxis.getUnscaledValueAt(index);
					if (currentX - bucketX > singlePixelSpan) {
						break;
					}

					i++;
					currentAverage += $self.convertToSingle($self._averageColumn.__inner[i]);
					currentDeviation += $self.convertToSingle($self._deviationColumn.__inner[i]);
					counter++;

				}
				currentAverage /= counter;
				currentDeviation /= counter;
				var param0 = $self.convertToSingle(currentAverage - currentDeviation * $self.multiplier());
				var param1 = $self.convertToSingle(currentAverage);
				var param2 = $self.convertToSingle(currentAverage + currentDeviation * $self.multiplier());
				var xVal = NaN;
				if (!$.ig.util.isNaN(bucketX)) {
					xVal = $self.xAxis().getScaledValue(bucketX, xParams);
				}

				bucket = (function () { var $ret = new Array();
				$ret.add($self.convertToSingle(xVal));
				$ret.add(param0);
				$ret.add(param1);
				$ret.add(param2);return $ret;}());
			}

			var pp = Math.max(1, singlePixelSpan);
			if (!isNaN(bucket[0]) && i * pp >= $self.ignoreFirst()) {
				if ($self.xAxis() != null && $.ig.util.cast($.ig.ISortingAxis.prototype.$type, $self.xAxis()) !== null) {
					bucket[0] = (bucket[0] + offset);

				} else {
					bucket[0] = (xaxis.getScaledValue(bucket[0], xParams) + offset);
				}

				bucket[1] = yaxis.getScaledValue(bucket[1], yParams);
				bucket[2] = yaxis.getScaledValue(bucket[2], yParams);
				bucket[3] = yaxis.getScaledValue(bucket[3], yParams);
				frame._buckets.add(bucket);
			}

		}

	}

	, 
	clearRendering: function (wipeClean, view) {
		$.ig.FinancialOverlay.prototype.clearRendering.call(this, wipeClean, view);
		var bollingerView = view;
		if (bollingerView != null) {
			bollingerView.clearRendering();
		}

	}

	, 
	getSeriesValue: function (world, useInterpolation, skipUnknowns) {
		if (this._averageColumn == null) {
			return $.ig.FinancialOverlay.prototype.getSeriesValue.call(this, world, useInterpolation, skipUnknowns);
		}

		var offset = this.getOffset(this.view().windowRect(), this.view().viewport());
		var xParams = new $.ig.ScalerParams(this.view().windowRect(), this.view().viewport(), this.xAxis().isInverted());
		xParams._effectiveViewportRect = this.seriesViewer().viewportRect();
		return this.getSeriesValueHelper(this._averageColumn, world, this.xAxis(), xParams, offset, this.getExactUnsortedItemIndex.runOn(this), useInterpolation, skipUnknowns);
	}

	, 
	getPreviousOrExactIndex: function (world, skipUnknowns) {
		if (this._averageColumn == null) {
			return $.ig.FinancialOverlay.prototype.getPreviousOrExactIndex.call(this, world, skipUnknowns);
		}

		return this.getPreviousOrExactIndexHelper(world, skipUnknowns, this.xAxis(), this.getExactUnsortedItemIndex.runOn(this), this._averageColumn);
	}

	, 
	getNextOrExactIndex: function (world, skipUnknowns) {
		if (this._averageColumn == null) {
			return $.ig.FinancialOverlay.prototype.getNextOrExactIndex.call(this, world, skipUnknowns);
		}

		return this.getNextOrExactIndexHelper(world, skipUnknowns, this.xAxis(), this.getExactUnsortedItemIndex.runOn(this), this._averageColumn);
	}

	, 
	validateSeries: function (viewportRect, windowRect, view) {
		var isValid = $.ig.FinancialOverlay.prototype.validateSeries.call(this, viewportRect, windowRect, view);
		if (!this.validateBasedOn(this.getTypicalBasedOn())) {
			isValid = false;
		}

		return isValid;
	}

	, 
	renderFrame: function (frame, view) {
		var $self = this;
		$.ig.FinancialOverlay.prototype.renderFrame.call($self, frame, view);
		var bollingerBandsView = $.ig.util.cast($.ig.BollingerBandsOverlayView.prototype.$type, view);
		if (view.checkFrameDirty(frame)) {
			bollingerBandsView.clearRendering();
			var count = frame._buckets.count();
			var px = function (i) { return frame._buckets.__inner[i][0]; };
			var nx = function (i) { return frame._buckets.__inner[count - 1 - i][0]; };
			var y0 = function (i) { return frame._buckets.__inner[i][1]; };
			var y1 = function (i) { return frame._buckets.__inner[i][2]; };
			var y2 = function (i) { return frame._buckets.__inner[count - 1 - i][3]; };
			bollingerBandsView.renderBands(count, px, nx, y0, y1, y2);
			view.updateFrameVersion(frame);
		}

		$self._renderManager.initCategoryRenderSettings($self, $self.shouldOverrideCategoryStyle(), $self.xAxis(), $self.getCategoryItems.runOn($self), $self.getBucketSize(view), $self.getFirstBucket(view));
		var areStylesOverriden = false;
		var args = $self._renderManager.categoryOverrideArgs();
		var buckets = frame._buckets;
		var valueCount = $self.fastItemsSource().count();
		if (args != null) {
			areStylesOverriden = true;
		}

		if (areStylesOverriden) {
			var xParams = new $.ig.ScalerParams(view.windowRect(), view.viewport(), $self.xAxis().isInverted());
			$self.performCategoryStyleOverride(buckets, -1, valueCount, $self.xAxis(), xParams, view.isThumbnailView());
		}

		var line0 = bollingerBandsView.line0();
		var line1 = bollingerBandsView.line1();
		var line2 = bollingerBandsView.line2();
		var polygon = bollingerBandsView.fillArea();
		$self._renderManager.setCategoryShapeAppearance(line1, true, false, true, true);
		$self._renderManager._initialRenderDashArray = null;
		$self._renderManager._actualRenderDashArray = null;
		$self._renderManager.setCategoryShapeAppearance(line0, true, false, false, true);
		$self._renderManager.setCategoryShapeAppearance(line2, true, false, false, true);
		$self._renderManager.setCategoryShapeAppearance(polygon, false, true, false, false);
		polygon.__opacity = $self._renderManager._actualRenderOpacity * $self.actualAreaFillOpacity();
	}

	, 
	createView: function () {
		return new $.ig.BollingerBandsOverlayView(this);
	}

	, 
	onViewCreated: function (view) {
		$.ig.FinancialOverlay.prototype.onViewCreated.call(this, view);
		this.bollingerBandsView($.ig.util.cast($.ig.BollingerBandsOverlayView.prototype.$type, view));
	}

	, 
	_bollingerBandsView: null,
	bollingerBandsView: function (value) {
		if (arguments.length === 1) {
			this._bollingerBandsView = value;
			return value;
		} else {
			return this._bollingerBandsView;
		}
	}
	, 
	$type: new $.ig.Type('BollingerBandsOverlay', $.ig.FinancialOverlay.prototype.$type)
}, true);

$.ig.util.defType('FinancialBucketCalculator', 'Object', {

	_view: null,
	view: function (value) {
		if (arguments.length === 1) {
			this._view = value;
			return value;
		} else {
			return this._view;
		}
	}
	, 
	init: function (view) {



		$.ig.Object.prototype.init.call(this);
			if (view == null) {
				throw new $.ig.ArgumentNullException(0, "view");
			}

			this.view(view);
			this.firstBucket(-1);
			this.lastBucket(this.lastBucket());
			this.bucketSize(0);
	}

	, 
	getBucket: function (index) {
		return null;
	}

	, 
	getErrorBucket: function (index, column) {
		return NaN;
	}

	, 
	_firstBucket: 0,
	firstBucket: function (value) {
		if (arguments.length === 1) {
			this._firstBucket = value;
			return value;
		} else {
			return this._firstBucket;
		}
	}

	, 
	_lastBucket: 0,
	lastBucket: function (value) {
		if (arguments.length === 1) {
			this._lastBucket = value;
			return value;
		} else {
			return this._lastBucket;
		}
	}

	, 
	_bucketSize: 0,
	bucketSize: function (value) {
		if (arguments.length === 1) {
			this._bucketSize = value;
			return value;
		} else {
			return this._bucketSize;
		}
	}

	, 
	getBucketInfo: function (firstBucket, lastBucket, bucketSize, resolution) {
		firstBucket = this.firstBucket();
		lastBucket = this.lastBucket();
		bucketSize = this.bucketSize();
		resolution = this.view().financialModel().resolution();
		return {
			p0: firstBucket, 
			p1: lastBucket, 
			p2: bucketSize, 
			p3: resolution
		};
	}

	, 
	calculateBuckets: function (resolution) {
		var windowRect = this.view().windowRect();
		var viewportRect = this.view().viewport();
		if (windowRect.isEmpty() || viewportRect.isEmpty() || this.view().financialModel().xAxis() == null) {
			this.bucketSize(0);
			return;
		}

		var xIsInverted = (this.view().financialModel().xAxis() != null) ? this.view().financialModel().xAxis().isInverted() : false;
		var xParams = new $.ig.ScalerParams(windowRect, viewportRect, xIsInverted);
		var sortingXAxis = $.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.view().financialModel().xAxis());
		if (sortingXAxis == null || sortingXAxis.sortedIndices() == null) {
			var x0 = Math.floor(this.view().financialModel().xAxis().getUnscaledValue(viewportRect.left(), xParams));
			var x1 = Math.ceil(this.view().financialModel().xAxis().getUnscaledValue(viewportRect.right(), xParams));
			if (this.view().financialModel().xAxis().isInverted()) {
				x1 = Math.ceil(this.view().financialModel().xAxis().getUnscaledValue(viewportRect.left(), xParams));
				x0 = Math.floor(this.view().financialModel().xAxis().getUnscaledValue(viewportRect.right(), xParams));
			}

			var c = Math.floor((x1 - x0 + 1) * resolution / viewportRect.width());
			this.bucketSize($.ig.truncate(Math.max(1, c)));
			this.firstBucket($.ig.truncate(Math.floor(x0 / this.bucketSize())));
			this.lastBucket($.ig.truncate(Math.ceil(x1 / this.bucketSize())));

		} else {
			this.firstBucket(sortingXAxis.getFirstVisibleIndex(windowRect, viewportRect));
			this.lastBucket(sortingXAxis.getLastVisibleIndex(windowRect, viewportRect));
			this.bucketSize(1);
		}

	}

	, 
	cacheValues: function () {
	}

	, 
	unCacheValues: function () {
	}
	, 
	$type: new $.ig.Type('FinancialBucketCalculator', $.ig.Object.prototype.$type, [$.ig.IBucketizer.prototype.$type])
}, true);

$.ig.util.defType('BollingerBandsBucketCalculator', 'FinancialBucketCalculator', {
	init: function (view) {



		$.ig.FinancialBucketCalculator.prototype.init.call(this, view);
			this.bollingerView(view);
	}

	, 
	_bollingerView: null,
	bollingerView: function (value) {
		if (arguments.length === 1) {
			this._bollingerView = value;
			return value;
		} else {
			return this._bollingerView;
		}
	}

	, 
	getBucket: function (index) {
		var $self = this;
		var i0 = index * $self.bucketSize();
		var i1 = Math.min(i0 + $self.bucketSize() - 1, $self.view().financialModel().fastItemsSource().count() - 1);
		if (i0 <= i1) {
			var multiplier = $self.bollingerView().bollingerBandsOverlayModel().multiplier();
			var average = 0;
			var deviation = 0;
			var cnt = 0;
			for (var i = i0; i <= i1; ++i) {
				if (!$.ig.util.isNaN($self.bollingerView().bollingerBandsOverlayModel()._averageColumn.__inner[i]) && !$.ig.util.isNaN($self.bollingerView().bollingerBandsOverlayModel()._deviationColumn.__inner[i])) {
					average += $self.bollingerView().bollingerBandsOverlayModel()._averageColumn.__inner[i];
					deviation += $self.bollingerView().bollingerBandsOverlayModel()._deviationColumn.__inner[i];
					++cnt;
				}

			}

			if (cnt > 0) {
				average = average / cnt;
				deviation = deviation / cnt;
				return (function () { var $ret = new Array();
				$ret.add((0.5 * (i0 + i1)));
				$ret.add((average - deviation * multiplier));
				$ret.add((average));
				$ret.add((average + deviation * multiplier));return $ret;}());
			}

		}

		return (function () { var $ret = new Array();
		$ret.add(NaN);
		$ret.add(NaN);
		$ret.add(NaN);
		$ret.add(NaN);return $ret;}());
	}
	, 
	$type: new $.ig.Type('BollingerBandsBucketCalculator', $.ig.FinancialBucketCalculator.prototype.$type)
}, true);

$.ig.util.defType('FinancialSeriesView', 'SeriesView', {

	_financialModel: null,
	financialModel: function (value) {
		if (arguments.length === 1) {
			this._financialModel = value;
			return value;
		} else {
			return this._financialModel;
		}
	}

	, 
	_bucketCalculator: null,
	bucketCalculator: function (value) {
		if (arguments.length === 1) {
			this._bucketCalculator = value;
			return value;
		} else {
			return this._bucketCalculator;
		}
	}

	, 
	_frameVersion: 0,
	frameVersion: function (value) {
		if (arguments.length === 1) {
			this._frameVersion = value;
			return value;
		} else {
			return this._frameVersion;
		}
	}

	, 
	checkFrameDirty: function (frame) {
		if (this.frameVersion() != frame.frameVersion()) {
			return true;
		}

		return false;
	}

	, 
	updateFrameVersion: function (frame) {
		this.frameVersion(frame.frameVersion());
	}
	, 
	init: function (model) {



		$.ig.SeriesView.prototype.init.call(this, model);
			this.frameVersion(-1);
			this.financialModel(model);
			this.bucketCalculator(this.createBucketCalculator());
	}

	, 
	createBucketCalculator: function () {}

	, 
	onInit: function () {
		var $self = this;
		$.ig.SeriesView.prototype.onInit.call($self);
		if (!$self.isThumbnailView()) {
			$self.model().legendItemBadgeTemplate((function () { var $ret = new $.ig.DataTemplate();
			$ret.render($.ig.LegendTemplates.prototype.financialBadgeTemplate);
			$ret.measure($.ig.LegendTemplates.prototype.legendItemBadgeMeasure); return $ret;}()));
		}

	}

	, 
	getDefaultTooltipTemplate: function () {
		var tooltipString = "<div class=\'ui-chart-default-tooltip-content\'>";
		var dateTimeAxis = $.ig.util.cast($.ig.CategoryDateTimeXAxis.prototype.$type, this.financialModel().xAxis());
		if (dateTimeAxis != null) {
			tooltipString += "<span>${item." + dateTimeAxis.dateTimeMemberPath() + "}</span><br/>";

		} else if (this.financialModel().xAxis().label() != null) {
			tooltipString += "<span>${item." + this.financialModel().xAxis().label() + "}</span><br/>";
		}


		tooltipString += "<span class=\'ui-priority-primary\'";
		if (this.model().actualOutline() != null && $.ig.Color.prototype.l_op_Inequality_Lifted($.ig.util.toNullable($.ig.Color.prototype.$type, this.model().actualOutline().color()), $.ig.util.toNullable($.ig.Color.prototype.$type, null))) {
			tooltipString += " style=\'color:" + this.model().actualOutline().__fill + "\'";
		}

		tooltipString += ">" + this.financialModel().title() + "</span><table><tr><td>" + "Open:</td><td>" + "${item." + this.financialModel().openMemberPath() + "}</td></tr><tr><td>" + "High:</td><td>" + "${item." + this.financialModel().highMemberPath() + "}</td></tr><tr><td>" + "Low:</td><td>" + "${item." + this.financialModel().lowMemberPath() + "}</td></tr><tr><td>" + "Close:</td><td>" + "${item." + this.financialModel().closeMemberPath() + "}</td></tr>";
		if (!String.isNullOrEmpty(this.financialModel().volumeMemberPath())) {
			tooltipString += "<tr><td>" + "Volume:</td><td>" + "${item." + this.financialModel().volumeMemberPath() + "}</td></tr>";
		}

		tooltipString += "</table></div>";
		return tooltipString;
	}

	, 
	applyDropShadowDefaultSettings: function () {
		var color = new $.ig.Color();
		color.colorString("rgba(95,95,95,0.5)");
		this.model().shadowColor(color);
		this.model().shadowBlur(5);
		this.model().shadowOffsetX(2);
		this.model().shadowOffsetY(2);
	}
	, 
	$type: new $.ig.Type('FinancialSeriesView', $.ig.SeriesView.prototype.$type)
}, true);

$.ig.util.defType('BollingerBandsOverlayView', 'FinancialSeriesView', {

	_bollingerBandsOverlayModel: null,
	bollingerBandsOverlayModel: function (value) {
		if (arguments.length === 1) {
			this._bollingerBandsOverlayModel = value;
			return value;
		} else {
			return this._bollingerBandsOverlayModel;
		}
	}
	, 
	init: function (model) {


		this._polygon = new $.ig.Polygon();
		this._polyline0 = new $.ig.Polyline();
		this._polyline1 = new $.ig.Polyline();
		this._polyline2 = new $.ig.Polyline();
		this.__hitPolygon0 = new $.ig.Polygon();
		this.__hitPolyline0 = new $.ig.Polyline();
		this.__hitPolyline1 = new $.ig.Polyline();
		this.__hitPolyline2 = new $.ig.Polyline();

		$.ig.FinancialSeriesView.prototype.init.call(this, model);
			this.bollingerBandsOverlayModel(model);
	}

	, 
	onInit: function () {
		var $self = this;
		$.ig.FinancialSeriesView.prototype.onInit.call($self);
		if (!$self.isThumbnailView()) {
			$self.model().legendItemBadgeTemplate((function () { var $ret = new $.ig.DataTemplate();
			$ret.render($.ig.LegendTemplates.prototype.rectBadgeTemplate);
			$ret.measure($.ig.LegendTemplates.prototype.legendItemBadgeMeasure); return $ret;}()));
		}

	}

	, 
	createBucketCalculator: function () {
		return new $.ig.BollingerBandsBucketCalculator(this);
	}

	, 
	renderBands: function (count, px, nx, y0, y1, y2) {
		var en = $.ig.Flattener.prototype.flatten3(count, px, y0, this.model().resolution()).getEnumerator();
		while (en.moveNext()) {
			var i = en.current();
			this._polygon.points().add({__x: px(i), __y: y0(i), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			this._polyline0.points().add({__x: px(i), __y: y0(i), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
		}

		var en1 = $.ig.Flattener.prototype.flatten3(count, px, y1, this.model().resolution()).getEnumerator();
		while (en1.moveNext()) {
			var i1 = en1.current();
			this._polyline1.points().add({__x: px(i1), __y: y1(i1), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
		}

		var en2 = $.ig.Flattener.prototype.flatten3(count, nx, y2, this.model().resolution()).getEnumerator();
		while (en2.moveNext()) {
			var i2 = en2.current();
			this._polygon.points().add({__x: nx(i2), __y: y2(i2), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			this._polyline2.points().add({__x: nx(i2), __y: y2(i2), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
		}

		this.makeDirty();
	}

	, 
	clearRendering: function () {
		this._polygon.points().clear();
		this._polyline0.points().clear();
		this._polyline1.points().clear();
		this._polyline2.points().clear();
		this.makeDirty();
	}

	, 
	fillArea: function () {

			return this._polygon;
	}

	, 
	line0: function () {

			return this._polyline0;
	}

	, 
	line1: function () {

			return this._polyline1;
	}

	, 
	line2: function () {

			return this._polyline2;
	}
	, 
	_polygon: null
	, 
	_polyline0: null
	, 
	_polyline1: null
	, 
	_polyline2: null
	, 
	__hitPolygon0: null
	, 
	__hitPolyline0: null
	, 
	__hitPolyline1: null
	, 
	__hitPolyline2: null

	, 
	setupHitAppearanceOverride: function () {
		$.ig.FinancialSeriesView.prototype.setupHitAppearanceOverride.call(this);
		this.__hitPolygon0.points(this._polygon.points());
		this.__hitPolyline0.points(this._polyline0.points());
		this.__hitPolyline1.points(this._polyline1.points());
		this.__hitPolyline2.points(this._polyline2.points());
		var hitBrush = this.getHitBrush();
		this.__hitPolygon0.__fill = hitBrush;
		this.__hitPolygon0.__opacity = 1;
		this.__hitPolyline0.__stroke = hitBrush;
		this.__hitPolyline0.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
		this.__hitPolyline1.__stroke = hitBrush;
		this.__hitPolyline1.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
		this.__hitPolyline2.__stroke = hitBrush;
		this.__hitPolyline2.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
	}

	, 
	renderOverride: function (context, isHitContext) {
		$.ig.FinancialSeriesView.prototype.renderOverride.call(this, context, isHitContext);
		if (context.shouldRender()) {
			if (isHitContext) {
				context.renderPolygon(this.__hitPolygon0);
				context.renderPolyline(this.__hitPolyline0);
				context.renderPolyline(this.__hitPolyline1);
				context.renderPolyline(this.__hitPolyline2);

			} else {
				context.renderPolygon(this._polygon);
				context.renderPolyline(this._polyline0);
				context.renderPolyline(this._polyline1);
				context.renderPolyline(this._polyline2);
			}

		}

	}

	, 
	exportViewShapes: function (svd) {
		$.ig.FinancialSeriesView.prototype.exportViewShapes.call(this, svd);
		var fill = new $.ig.PolygonVisualData(1, "FillShape", this._polygon);
		fill.tags().add("Fill");
		var bottom = new $.ig.PolyLineVisualData(1, "BottomLine", this._polyline0);
		bottom.tags().add("Main");
		bottom.tags().add("Lower");
		var center = new $.ig.PolyLineVisualData(1, "CentralLine", this._polyline1);
		center.tags().add("Central");
		var top = new $.ig.PolyLineVisualData(1, "TopLine", this._polyline2);
		top.tags().add("Upper");
		svd.shapes().add(fill);
		svd.shapes().add(bottom);
		svd.shapes().add(center);
		svd.shapes().add(top);
	}
	, 
	$type: new $.ig.Type('BollingerBandsOverlayView', $.ig.FinancialSeriesView.prototype.$type)
}, true);

$.ig.util.defType('BollingerBandWidthIndicator', 'StrategyBasedIndicator', {
	init: function () {


		$.ig.StrategyBasedIndicator.prototype.init.call(this);

	}
	, 
	calculationStrategy: function () {

			return new $.ig.BollingerBandWidthIndicatorStrategy();
	}

	, 
	styleKeyType: function () {

			return $.ig.BollingerBandWidthIndicator.prototype.$type;
	}

	, 
	period: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.BollingerBandWidthIndicator.prototype.periodProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.BollingerBandWidthIndicator.prototype.periodProperty));
		}
	}

	, 
	periodOverride: function () {
		return this.period();
	}

	, 
	multiplier: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.BollingerBandWidthIndicator.prototype.multiplierProperty, value);
			return value;
		} else {

			return this.getValue($.ig.BollingerBandWidthIndicator.prototype.multiplierProperty);
		}
	}

	, 
	multiplierOverride: function () {
		return this.multiplier();
	}
	, 
	$type: new $.ig.Type('BollingerBandWidthIndicator', $.ig.StrategyBasedIndicator.prototype.$type)
}, true);

$.ig.util.defType('ChaikinOscillatorIndicator', 'StrategyBasedIndicator', {
	init: function () {


		$.ig.StrategyBasedIndicator.prototype.init.call(this);

	}
	, 
	calculationStrategy: function () {

			return new $.ig.ChaikinOscillatorIndicatorStrategy();
	}

	, 
	styleKeyType: function () {

			return $.ig.ChaikinOscillatorIndicator.prototype.$type;
	}

	, 
	shortPeriod: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.ChaikinOscillatorIndicator.prototype.shortPeriodProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.ChaikinOscillatorIndicator.prototype.shortPeriodProperty));
		}
	}

	, 
	shortPeriodOverride: function () {
		return this.shortPeriod();
	}

	, 
	longPeriod: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.ChaikinOscillatorIndicator.prototype.longPeriodProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.ChaikinOscillatorIndicator.prototype.longPeriodProperty));
		}
	}

	, 
	longPeriodOverride: function () {
		return this.longPeriod();
	}
	, 
	$type: new $.ig.Type('ChaikinOscillatorIndicator', $.ig.StrategyBasedIndicator.prototype.$type)
}, true);

$.ig.util.defType('ChaikinVolatilityIndicator', 'StrategyBasedIndicator', {
	init: function () {


		$.ig.StrategyBasedIndicator.prototype.init.call(this);

	}
	, 
	calculationStrategy: function () {

			return new $.ig.ChaikinVolatilityIndicatorStrategy();
	}

	, 
	styleKeyType: function () {

			return $.ig.ChaikinVolatilityIndicator.prototype.$type;
	}

	, 
	period: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.ChaikinVolatilityIndicator.prototype.periodProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.ChaikinVolatilityIndicator.prototype.periodProperty));
		}
	}

	, 
	periodOverride: function () {
		return this.period();
	}
	, 
	$type: new $.ig.Type('ChaikinVolatilityIndicator', $.ig.StrategyBasedIndicator.prototype.$type)
}, true);

$.ig.util.defType('CommodityChannelIndexIndicator', 'StrategyBasedIndicator', {
	init: function () {


		$.ig.StrategyBasedIndicator.prototype.init.call(this);

	}
	, 
	calculationStrategy: function () {

			return new $.ig.CommodityChannelIndexIndicatorStrategy();
	}

	, 
	styleKeyType: function () {

			return $.ig.CommodityChannelIndexIndicator.prototype.$type;
	}

	, 
	period: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.CommodityChannelIndexIndicator.prototype.periodProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.CommodityChannelIndexIndicator.prototype.periodProperty));
		}
	}

	, 
	periodOverride: function () {
		return this.period();
	}
	, 
	$type: new $.ig.Type('CommodityChannelIndexIndicator', $.ig.StrategyBasedIndicator.prototype.$type)
}, true);

$.ig.util.defType('CustomIndicator', 'StrategyBasedIndicator', {
	init: function () {


		$.ig.StrategyBasedIndicator.prototype.init.call(this);

	}
	, 
	calculationStrategy: function () {

			return new $.ig.CustomIndicatorStrategy();
	}

	, 
	styleKeyType: function () {

			return $.ig.CustomIndicator.prototype.$type;
	}

	, 
	basedOn: function (position, count) {
		var dataSource = this.provideDataSource(position, count);
		var supportingCalculations = this.provideSupportingCalculations(dataSource);
		var list = new $.ig.List$1(String, 0);
		if (this.__basedOnColumns != null) {
			var args = new $.ig.FinancialEventArgs(dataSource.calculateFrom(), dataSource.calculateCount(), dataSource, supportingCalculations);
			this.__basedOnColumns(this, args);
			if (args.basedOn() != null) {
				var en = args.basedOn().getEnumerator();
				while (en.moveNext()) {
					var propertyName = en.current();
					list.add(propertyName);
				}

			}

		}

		return list;
	}
	, 
	__indicator: null

	, 
	indicator: function (value) {
		if (arguments.length === 1) {

			this.__indicator = value;
			this.fullIndicatorRefresh();
			return value;
		} else {

			return this.__indicator;
		}
	}
	, 
	__basedOnColumns: null

	, 
	basedOnColumns: function (value) {
		if (arguments.length === 1) {

			this.__basedOnColumns = value;
			return value;
		} else {

			return this.__basedOnColumns;
		}
	}

	, 
	indicatorOverride: function (position, count) {
		$.ig.StrategyBasedIndicator.prototype.indicatorOverride.call(this, position, count);
		if (this.__indicator != null) {
			var dataSource = this.provideDataSource(position, count);
			if (count == 0) {
				return false;
			}

			if (!this.validateBasedOn(this.basedOn(position, count))) {
				return false;
			}

			this.__indicator(this, new $.ig.FinancialEventArgs(position, count, dataSource, this.provideSupportingCalculations(dataSource)));
			if (this.updateRange(dataSource) && this.yAxis() != null) {
				this.yAxis().updateRange();
			}

			return true;
		}

		return false;
	}
	, 
	$type: new $.ig.Type('CustomIndicator', $.ig.StrategyBasedIndicator.prototype.$type)
}, true);

$.ig.util.defType('IndicatorCalculationStrategy', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	calculateIndicator: function (dataSource, supportingCalculations) {}

	, 
	basedOn: function (dataSource, supportingCalculations) {}
	, 
	$type: new $.ig.Type('IndicatorCalculationStrategy', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('CustomIndicatorStrategy', 'IndicatorCalculationStrategy', {
	init: function () {


		$.ig.IndicatorCalculationStrategy.prototype.init.call(this);

	}
	, 
	calculateIndicator: function (dataSource, supportingCalculations) {
		return true;
	}

	, 
	basedOn: function (dataSource, supportingCalculations) {
		return new $.ig.List$1(String, 0);
	}
	, 
	$type: new $.ig.Type('CustomIndicatorStrategy', $.ig.IndicatorCalculationStrategy.prototype.$type)
}, true);

$.ig.util.defType('PriceChannelOverlayView', 'FinancialSeriesView', {
	_polygon: null
	, 
	_polyline0: null
	, 
	_polyline1: null

	, 
	fillArea: function () {

			return this._polygon;
	}

	, 
	line0: function () {

			return this._polyline0;
	}

	, 
	line1: function () {

			return this._polyline1;
	}

	, 
	_priceChannelOverlayModel: null,
	priceChannelOverlayModel: function (value) {
		if (arguments.length === 1) {
			this._priceChannelOverlayModel = value;
			return value;
		} else {
			return this._priceChannelOverlayModel;
		}
	}
	, 
	init: function (model) {


		this._polygon = new $.ig.Polygon();
		this._polyline0 = new $.ig.Polyline();
		this._polyline1 = new $.ig.Polyline();
		this.__hitPolygon0 = new $.ig.Polygon();
		this.__hitPolyline0 = new $.ig.Polyline();
		this.__hitPolyline1 = new $.ig.Polyline();

		$.ig.FinancialSeriesView.prototype.init.call(this, model);
			this.priceChannelOverlayModel(model);
	}

	, 
	onInit: function () {
		var $self = this;
		$.ig.FinancialSeriesView.prototype.onInit.call($self);
		if (!$self.isThumbnailView()) {
			$self.model().legendItemBadgeTemplate((function () { var $ret = new $.ig.DataTemplate();
			$ret.render($.ig.LegendTemplates.prototype.rectBadgeTemplate);
			$ret.measure($.ig.LegendTemplates.prototype.legendItemBadgeMeasure); return $ret;}()));
		}

	}

	, 
	createBucketCalculator: function () {
		return new $.ig.PriceChannelBucketCalculator(this);
	}

	, 
	clearRendering: function () {
		this._polygon.points().clear();
		this._polyline0.points().clear();
		this._polyline1.points().clear();
		this.makeDirty();
	}

	, 
	renderChannel: function (count, px, nx, y0, y1) {
		var en = $.ig.Flattener.prototype.flatten3(count, px, y0, this.model().resolution()).getEnumerator();
		while (en.moveNext()) {
			var i = en.current();
			this._polygon.points().add({__x: px(i), __y: y0(i), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			this._polyline0.points().add({__x: px(i), __y: y0(i), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
		}

		var en1 = $.ig.Flattener.prototype.flatten3(count, nx, y1, this.model().resolution()).getEnumerator();
		while (en1.moveNext()) {
			var i1 = en1.current();
			this._polygon.points().add({__x: nx(i1), __y: y1(i1), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			this._polyline1.points().add({__x: nx(i1), __y: y1(i1), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
		}

		this.makeDirty();
	}
	, 
	__hitPolygon0: null
	, 
	__hitPolyline0: null
	, 
	__hitPolyline1: null

	, 
	setupHitAppearanceOverride: function () {
		$.ig.FinancialSeriesView.prototype.setupHitAppearanceOverride.call(this);
		this.__hitPolygon0.points(this._polygon.points());
		this.__hitPolyline0.points(this._polyline0.points());
		this.__hitPolyline1.points(this._polyline1.points());
		var hitBrush = this.getHitBrush();
		this.__hitPolygon0.__fill = hitBrush;
		this.__hitPolygon0.__opacity = 1;
		this.__hitPolyline0.__stroke = hitBrush;
		this.__hitPolyline0.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
		this.__hitPolyline1.__stroke = hitBrush;
		this.__hitPolyline1.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
	}

	, 
	renderOverride: function (context, isHitContext) {
		$.ig.FinancialSeriesView.prototype.renderOverride.call(this, context, isHitContext);
		if (context.shouldRender()) {
			if (isHitContext) {
				context.renderPolygon(this.__hitPolygon0);
				context.renderPolyline(this.__hitPolyline0);
				context.renderPolyline(this.__hitPolyline1);

			} else {
				context.renderPolygon(this._polygon);
				context.renderPolyline(this._polyline0);
				context.renderPolyline(this._polyline1);
			}

		}

	}

	, 
	exportViewShapes: function (svd) {
		$.ig.FinancialSeriesView.prototype.exportViewShapes.call(this, svd);
		var poly = new $.ig.PolygonVisualData(1, "fill", this._polygon);
		var poly0 = new $.ig.PolyLineVisualData(1, "bottom", this._polyline0);
		var poly1 = new $.ig.PolyLineVisualData(1, "top", this._polyline1);
		poly.tags().add("Fill");
		poly0.tags().add("Lower");
		poly0.tags().add("Main");
		poly1.tags().add("Upper");
		svd.shapes().add(poly);
		svd.shapes().add(poly0);
		svd.shapes().add(poly1);
	}
	, 
	$type: new $.ig.Type('PriceChannelOverlayView', $.ig.FinancialSeriesView.prototype.$type)
}, true);

$.ig.util.defType('DetrendedPriceOscillatorIndicator', 'StrategyBasedIndicator', {
	init: function () {


		$.ig.StrategyBasedIndicator.prototype.init.call(this);

	}
	, 
	calculationStrategy: function () {

			return new $.ig.DetrendedPriceOscillatorIndicatorStrategy();
	}

	, 
	styleKeyType: function () {

			return $.ig.DetrendedPriceOscillatorIndicator.prototype.$type;
	}

	, 
	period: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.DetrendedPriceOscillatorIndicator.prototype.periodProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.DetrendedPriceOscillatorIndicator.prototype.periodProperty));
		}
	}

	, 
	periodOverride: function () {
		return this.period();
	}
	, 
	$type: new $.ig.Type('DetrendedPriceOscillatorIndicator', $.ig.StrategyBasedIndicator.prototype.$type)
}, true);

$.ig.util.defType('EaseOfMovementIndicator', 'StrategyBasedIndicator', {
	init: function () {


		$.ig.StrategyBasedIndicator.prototype.init.call(this);

	}
	, 
	calculationStrategy: function () {

			return new $.ig.EaseOfMovementIndicatorStrategy();
	}

	, 
	styleKeyType: function () {

			return $.ig.EaseOfMovementIndicator.prototype.$type;
	}
	, 
	$type: new $.ig.Type('EaseOfMovementIndicator', $.ig.StrategyBasedIndicator.prototype.$type)
}, true);

$.ig.util.defType('FastStochasticOscillatorIndicator', 'StrategyBasedIndicator', {
	init: function () {



		var $self = this;
		$.ig.StrategyBasedIndicator.prototype.init.call(this);
			this.trendLineBrush((function () { var $ret = new $.ig.Brush();
			$ret.fill("Blue"); return $ret;}()));
			this.trendLineType($.ig.TrendLineType.prototype.exponentialAverage);
			this.trendLinePeriod(3);
	}

	, 
	calculationStrategy: function () {

			return new $.ig.FastStochasticOscillatorIndicatorStrategy();
	}

	, 
	styleKeyType: function () {

			return $.ig.FastStochasticOscillatorIndicator.prototype.$type;
	}

	, 
	period: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.FastStochasticOscillatorIndicator.prototype.periodProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.FastStochasticOscillatorIndicator.prototype.periodProperty));
		}
	}

	, 
	periodOverride: function () {
		return this.period();
	}
	, 
	$type: new $.ig.Type('FastStochasticOscillatorIndicator', $.ig.StrategyBasedIndicator.prototype.$type)
}, true);

$.ig.util.defType('FinancialIndicatorBucketCalculator', 'FinancialBucketCalculator', {
	init: function (view) {



		$.ig.FinancialBucketCalculator.prototype.init.call(this, view);
			this.indicatorView(view);
	}

	, 
	_indicatorView: null,
	indicatorView: function (value) {
		if (arguments.length === 1) {
			this._indicatorView = value;
			return value;
		} else {
			return this._indicatorView;
		}
	}

	, 
	getBucket: function (index) {
		var $self = this;
		var i0 = index * $self.bucketSize();
		var i1 = Math.min(i0 + $self.bucketSize() - 1, $self.indicatorView().indicatorModel().indicatorColumn().count() - 1);
		var min = NaN;
		var max = NaN;
		for (var i = i0; i <= i1; ++i) {
			var y = $self.indicatorView().indicatorModel().indicatorColumn().__inner[i];
			if (!$.ig.util.isNaN(min)) {
				if (!$.ig.util.isNaN(y)) {
					min = Math.min(min, y);
					max = Math.max(max, y);
				}


			} else {
				min = y;
				max = y;
			}

		}

		if (!$.ig.util.isNaN(min)) {
			return (function () { var $ret = new Array();
			$ret.add((0.5 * (i0 + i1)));
			$ret.add(min);
			$ret.add(max);return $ret;}());
		}

		return (function () { var $ret = new Array();
		$ret.add(NaN);
		$ret.add(NaN);
		$ret.add(NaN);return $ret;}());
	}
	, 
	$type: new $.ig.Type('FinancialIndicatorBucketCalculator', $.ig.FinancialBucketCalculator.prototype.$type)
}, true);

$.ig.util.defType('FinancialIndicatorView', 'FinancialSeriesView', {

	_indicatorModel: null,
	indicatorModel: function (value) {
		if (arguments.length === 1) {
			this._indicatorModel = value;
			return value;
		} else {
			return this._indicatorModel;
		}
	}
	, 
	init: function (model) {


		this._positivePath0 = (function () { var $ret = new $.ig.Path();
		$ret.data(new $.ig.PathGeometry()); return $ret;}());
		this._negativePath0 = (function () { var $ret = new $.ig.Path();
		$ret.data(new $.ig.PathGeometry()); return $ret;}());
		this._positivePath01 = (function () { var $ret = new $.ig.Path();
		$ret.data(new $.ig.PathGeometry()); return $ret;}());
		this._negativePath01 = (function () { var $ret = new $.ig.Path();
		$ret.data(new $.ig.PathGeometry()); return $ret;}());
		this._positivePath1 = (function () { var $ret = new $.ig.Path();
		$ret.data(new $.ig.PathGeometry()); return $ret;}());
		this._negativePath1 = (function () { var $ret = new $.ig.Path();
		$ret.data(new $.ig.PathGeometry()); return $ret;}());
		this._positiveColumns = (function () { var $ret = new $.ig.Path();
		$ret.data(new $.ig.GeometryGroup()); return $ret;}());
		this._negativeColumns = (function () { var $ret = new $.ig.Path();
		$ret.data(new $.ig.GeometryGroup()); return $ret;}());
		this.__hitPositivePath0 = new $.ig.Path();
		this.__hitPositivePath1 = new $.ig.Path();
		this.__hitPositivePath01 = new $.ig.Path();
		this.__hitPositiveColumns = new $.ig.Path();
		this.__hitNegativePath0 = new $.ig.Path();
		this.__hitNegativePath1 = new $.ig.Path();
		this.__hitNegativePath01 = new $.ig.Path();
		this.__hitNegativeColumns = new $.ig.Path();

		var $self = this;
		$.ig.FinancialSeriesView.prototype.init.call(this, model);
			this.indicatorModel(model);
			this._columns = (function () { var $ret = new $.ig.Pool$1($.ig.LineGeometry.prototype.$type);
			$ret.create($self.createColumn.runOn($self));
			$ret.destroy($self.destroyColumn.runOn($self)); return $ret;}());
			this.trendLineManager(new $.ig.CategoryTrendLineManager());
	}

	, 
	createBucketCalculator: function () {
		return new $.ig.FinancialIndicatorBucketCalculator(this);
	}

	, 
	onInit: function () {
		var $self = this;
		$.ig.FinancialSeriesView.prototype.onInit.call($self);
		if (!$self.isThumbnailView()) {
			$self.financialModel().negativeBrush((function () { var $ret = new $.ig.Brush();
			$ret.fill("#415460"); return $ret;}()));
		}

	}
	, 
	_columns: null

	, 
	createColumn: function () {
		return new $.ig.LineGeometry();
	}

	, 
	destroyColumn: function (column) {
	}
	, 
	_positivePath0: null
	, 
	_negativePath0: null
	, 
	_positivePath01: null
	, 
	_negativePath01: null
	, 
	_positivePath1: null
	, 
	_negativePath1: null
	, 
	_positiveColumns: null
	, 
	_negativeColumns: null

	, 
	_trendLineManager: null,
	trendLineManager: function (value) {
		if (arguments.length === 1) {
			this._trendLineManager = value;
			return value;
		} else {
			return this._trendLineManager;
		}
	}

	, 
	clearIndicatorVisual: function (wipeClean) {
		$.ig.Extensions.prototype.reset1(($.ig.util.cast($.ig.PathGeometry.prototype.$type, this._positivePath0.data())));
		$.ig.Extensions.prototype.reset1(($.ig.util.cast($.ig.PathGeometry.prototype.$type, this._positivePath01.data())));
		$.ig.Extensions.prototype.reset1(($.ig.util.cast($.ig.PathGeometry.prototype.$type, this._positivePath1.data())));
		$.ig.Extensions.prototype.reset1(($.ig.util.cast($.ig.PathGeometry.prototype.$type, this._negativePath0.data())));
		$.ig.Extensions.prototype.reset1(($.ig.util.cast($.ig.PathGeometry.prototype.$type, this._negativePath01.data())));
		$.ig.Extensions.prototype.reset1(($.ig.util.cast($.ig.PathGeometry.prototype.$type, this._negativePath1.data())));
		$.ig.Extensions.prototype.reset(($.ig.util.cast($.ig.GeometryGroup.prototype.$type, this._positiveColumns.data())));
		$.ig.Extensions.prototype.reset(($.ig.util.cast($.ig.GeometryGroup.prototype.$type, this._negativeColumns.data())));
		if (wipeClean) {
			this._columns.count(0);
		}

		this.makeDirty();
	}

	, 
	updateHitTests: function () {
	}

	, 
	rasterizeLine: function (count, x0, y0, x1, y1, colorByGradient) {
		$.ig.IndicatorRenderer.prototype.rasterizeLine(count, x0, y0, x1, y1, colorByGradient, this.windowRect(), this.viewport(), this._positivePath0, this._positivePath01, this._positivePath1, this._negativePath0, this._negativePath01, this._negativePath1, this.bucketCalculator().bucketSize(), this.model().resolution());
		this.makeDirty();
	}

	, 
	rasterizeArea: function (count, x0, y0, x1, y1, colorByGradient, worldZero) {
		$.ig.IndicatorRenderer.prototype.rasterizeArea(count, x0, y0, x1, y1, colorByGradient, this.windowRect(), this.viewport(), this._positivePath0, this._positivePath01, this._positivePath1, this._negativePath0, this._negativePath01, this._negativePath1, worldZero, this.bucketCalculator().bucketSize(), this.model().resolution());
		this.makeDirty();
	}

	, 
	rasterizeColumns: function (count, x0, y0, x1, y1, colorByGradient, worldZero) {
		$.ig.IndicatorRenderer.prototype.rasterizeColumns(count, x0, y0, x1, y1, colorByGradient, worldZero, this._columns, this._positiveColumns, this._negativeColumns);
		this.makeDirty();
	}

	, 
	updateTrendlineBrush: function () {
		this.indicatorModel().actualTrendLineBrush(null);
		if (this.indicatorModel().trendLineBrush() != null) {
			this.indicatorModel().actualTrendLineBrush(this.indicatorModel().trendLineBrush());

		} else {
			this.indicatorModel().actualTrendLineBrush(this.indicatorModel().actualBrush());
		}

	}
	, 
	__hitPositivePath0: null
	, 
	__hitPositivePath1: null
	, 
	__hitPositivePath01: null
	, 
	__hitPositiveColumns: null
	, 
	__hitNegativePath0: null
	, 
	__hitNegativePath1: null
	, 
	__hitNegativePath01: null
	, 
	__hitNegativeColumns: null

	, 
	setupHitAppearanceOverride: function () {
		$.ig.FinancialSeriesView.prototype.setupHitAppearanceOverride.call(this);
		var hitBrush = this.getHitBrush();
		this.__hitPositivePath0.data(this._positivePath0.data());
		this.__hitPositivePath1.data(this._positivePath1.data());
		this.__hitPositivePath01.data(this._positivePath01.data());
		this.__hitPositiveColumns.data(this._positiveColumns.data());
		this.__hitNegativePath0.data(this._negativePath0.data());
		this.__hitNegativePath1.data(this._negativePath1.data());
		this.__hitNegativePath01.data(this._negativePath01.data());
		this.__hitNegativeColumns.data(this._negativeColumns.data());
		this.__hitPositivePath0.__stroke = hitBrush;
		this.__hitPositivePath1.__stroke = hitBrush;
		this.__hitPositivePath0.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
		this.__hitPositivePath1.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
		this.__hitPositivePath01.__fill = hitBrush;
		this.__hitPositivePath01.__opacity = 1;
		this.__hitPositiveColumns.__stroke = hitBrush;
		this.__hitPositiveColumns.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
		this.__hitNegativePath0.__stroke = hitBrush;
		this.__hitNegativePath1.__stroke = hitBrush;
		this.__hitNegativePath0.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
		this.__hitNegativePath1.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
		this.__hitNegativePath01.__fill = hitBrush;
		this.__hitNegativePath01.__opacity = 1;
		this.__hitNegativeColumns.__stroke = hitBrush;
		this.__hitNegativeColumns.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
	}

	, 
	renderOverride: function (context, isHitContext) {
		$.ig.FinancialSeriesView.prototype.renderOverride.call(this, context, isHitContext);
		if (context.shouldRender()) {
			if (isHitContext) {
				if (this.indicatorModel().displayType() == $.ig.IndicatorDisplayType.prototype.column) {
					context.renderPath(this.__hitPositiveColumns);
					context.renderPath(this.__hitNegativeColumns);

				} else {
					context.renderPath(this.__hitPositivePath01);
					context.renderPath(this.__hitPositivePath0);
					context.renderPath(this.__hitPositivePath1);
					context.renderPath(this.__hitNegativePath01);
					context.renderPath(this.__hitNegativePath0);
					context.renderPath(this.__hitNegativePath1);
				}


			} else {
				if (this.indicatorModel().displayType() == $.ig.IndicatorDisplayType.prototype.column) {
					context.renderPath(this._positiveColumns);
					context.renderPath(this._negativeColumns);

				} else {
					context.renderPath(this._positivePath01);
					context.renderPath(this._positivePath0);
					context.renderPath(this._positivePath1);
					context.renderPath(this._negativePath01);
					context.renderPath(this._negativePath0);
					context.renderPath(this._negativePath1);
				}

			}

		}

	}

	, 
	renderMarkersOverride: function (context, isHitContext) {
		if (context.shouldRender()) {
			if (this.indicatorModel().trendLineType() != $.ig.TrendLineType.prototype.none && !isHitContext) {
				var polyline = this.trendLineManager().trendPolyline();
				polyline.strokeThickness(this.indicatorModel().trendLineThickness());
				polyline.__stroke = this.indicatorModel().actualTrendLineBrush();
				polyline.strokeDashCap(this.indicatorModel().trendLineDashCap());
				polyline.strokeDashArray(this.indicatorModel().trendLineDashArray());
				context.renderPolyline(polyline);
			}

		}

		$.ig.FinancialSeriesView.prototype.renderMarkersOverride.call(this, context, isHitContext);
	}

	, 
	exportViewShapes: function (svd) {
		$.ig.FinancialSeriesView.prototype.exportViewShapes.call(this, svd);
		var positiveColumnsShape = new $.ig.PathVisualData(1, "positiveColumnsShape", this._positiveColumns);
		positiveColumnsShape.tags().add("Positive");
		positiveColumnsShape.tags().add("Main");
		var negativeColumnsShape = new $.ig.PathVisualData(1, "negativeColumnsShape", this._negativeColumns);
		negativeColumnsShape.tags().add("Negative");
		var positive0 = new $.ig.PathVisualData(1, "positive0", this._positivePath0);
		positive0.tags().add("Positive");
		positive0.tags().add("Main");
		var positive1 = new $.ig.PathVisualData(1, "positive1", this._positivePath1);
		positive1.tags().add("Positive");
		var positive01 = new $.ig.PathVisualData(1, "positive01", this._positivePath01);
		positive01.tags().add("PositiveFill");
		var negative0 = new $.ig.PathVisualData(1, "negative0", this._negativePath0);
		negative0.tags().add("Negative");
		negative0.tags().add("Main");
		var negative1 = new $.ig.PathVisualData(1, "negative1", this._negativePath1);
		negative1.tags().add("Negative");
		var negative01 = new $.ig.PathVisualData(1, "negative01", this._negativePath01);
		negative01.tags().add("NegativeFill");
		svd.shapes().add(positive0);
		svd.shapes().add(positive1);
		svd.shapes().add(positive01);
		svd.shapes().add(negative0);
		svd.shapes().add(negative1);
		svd.shapes().add(negative01);
	}

	, 
	selectTrendlineManager: function () {
		this.trendLineManager($.ig.CategoryTrendLineManagerBase.prototype.selectManager(this.trendLineManager(), this.indicatorModel().xAxis(), this.model().rootCanvas(), this.indicatorModel()));
	}
	, 
	$type: new $.ig.Type('FinancialIndicatorView', $.ig.FinancialSeriesView.prototype.$type)
}, true);

$.ig.util.defType('ForceIndexIndicator', 'StrategyBasedIndicator', {
	init: function () {



		$.ig.StrategyBasedIndicator.prototype.init.call(this);
			this.displayType($.ig.IndicatorDisplayType.prototype.area);
	}

	, 
	calculationStrategy: function () {

			return new $.ig.ForceIndexIndicatorStrategy();
	}

	, 
	styleKeyType: function () {

			return $.ig.ForceIndexIndicator.prototype.$type;
	}

	, 
	period: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.ForceIndexIndicator.prototype.periodProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.ForceIndexIndicator.prototype.periodProperty));
		}
	}

	, 
	periodOverride: function () {
		return this.period();
	}
	, 
	$type: new $.ig.Type('ForceIndexIndicator', $.ig.StrategyBasedIndicator.prototype.$type)
}, true);

$.ig.util.defType('FullStochasticOscillatorIndicator', 'StrategyBasedIndicator', {
	init: function () {



		var $self = this;
		$.ig.StrategyBasedIndicator.prototype.init.call(this);
			this.trendLineBrush((function () { var $ret = new $.ig.Brush();
			$ret.fill("Blue"); return $ret;}()));
			this.trendLineType($.ig.TrendLineType.prototype.exponentialAverage);
			this.trendLinePeriod(3);
	}

	, 
	calculationStrategy: function () {

			return new $.ig.FullStochasticOscillatorIndicatorStrategy();
	}

	, 
	styleKeyType: function () {

			return $.ig.FullStochasticOscillatorIndicator.prototype.$type;
	}

	, 
	period: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.FullStochasticOscillatorIndicator.prototype.periodProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.FullStochasticOscillatorIndicator.prototype.periodProperty));
		}
	}

	, 
	periodOverride: function () {
		return this.period();
	}

	, 
	smoothingPeriod: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.FullStochasticOscillatorIndicator.prototype.smoothingPeriodProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.FullStochasticOscillatorIndicator.prototype.smoothingPeriodProperty));
		}
	}

	, 
	shortPeriodOverride: function () {
		return this.smoothingPeriod();
	}

	, 
	triggerPeriod: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.FullStochasticOscillatorIndicator.prototype.triggerPeriodProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.FullStochasticOscillatorIndicator.prototype.triggerPeriodProperty));
		}
	}

	, 
	longPeriodOverride: function () {
		return this.triggerPeriod();
	}

	, 
	trendPeriodOverride: function () {
		return this.triggerPeriod();
	}
	, 
	$type: new $.ig.Type('FullStochasticOscillatorIndicator', $.ig.StrategyBasedIndicator.prototype.$type)
}, true);

$.ig.util.defType('IndicatorRenderer', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	output: function (segments, x0, y0, resolution) {
		var $self = this;
		var pathFigure = new $.ig.PathFigure();
		var flattenedIndices = $.ig.Flattener.prototype.flatten(new $.ig.List$1($.ig.Number.prototype.$type, 0), segments, x0, y0, 0, segments.count() - 1, resolution);
		for (var j = 0; j < flattenedIndices.count(); j++) {
			var k = flattenedIndices.item(j);
			pathFigure.__segments.add((function () { var $ret = new $.ig.LineSegment(1);
			$ret.point({__x: x0(k), __y: y0(k), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}); return $ret;}()));
		}

		pathFigure.__startPoint = ($.ig.util.cast($.ig.LineSegment.prototype.$type, pathFigure.__segments.__inner[0])).point();
		return pathFigure;
	}

	, 
	rasterizeLine: function (count, x0, y0, x1, y1, colorByGradient, windowRect, viewportRect, positivePath0, positivePath01, positivePath1, negativePath0, negativePath01, negativePath1, bucketSize, resolution) {
		var positiveFigures0 = ($.ig.util.cast($.ig.PathGeometry.prototype.$type, positivePath0.data())).figures();
		var negativeFigures0 = ($.ig.util.cast($.ig.PathGeometry.prototype.$type, negativePath0.data())).figures();
		if (bucketSize == 1) {
			var currentSegment = new $.ig.List$1($.ig.Number.prototype.$type, 0);
			var currentFigures0 = positiveFigures0;
			var currentType = 0;
			currentSegment.add(0);
			for (var i = 0, j = 1; j < count; i = j++) {
				var type = currentType;
				var valueDelegateResult = y0(j) - y0(i);
				if (colorByGradient && !$.ig.util.isNaN(valueDelegateResult)) {
					type = Math.sign(valueDelegateResult);
				}

				if (type != 0 && type != currentType) {
					currentFigures0.add($.ig.IndicatorRenderer.prototype.output(currentSegment, x0, y0, resolution));
					currentType = type;
					currentFigures0 = currentType == 1 ? negativeFigures0 : positiveFigures0;
					currentSegment.clear();
					currentSegment.add(i);
				}

				currentSegment.add(j);
			}

			currentFigures0.add($.ig.IndicatorRenderer.prototype.output(currentSegment, x0, y0, resolution));

		} else {
			var currentSegment1 = new $.ig.List$1($.ig.Number.prototype.$type, 0);
			var currentFigures01 = positiveFigures0;
			var currentType1 = 0;
			currentSegment1.add(0);
			for (var i1 = 0, j1 = 1; j1 < count; i1 = j1++) {
				var type1 = currentType1;
				var valueDelegateResult1 = y0(j1) - y0(i1);
				if (colorByGradient && !$.ig.util.isNaN(valueDelegateResult1)) {
					type1 = Math.sign(valueDelegateResult1);
				}

				if (type1 != 0 && type1 != currentType1) {
					if (currentSegment1.count() > 0) {
						currentFigures01.add($.ig.IndicatorRenderer.prototype.output(currentSegment1, x0, y0, resolution));
					}

					currentType1 = type1;
					currentFigures01 = currentType1 == 1 ? negativeFigures0 : positiveFigures0;
					currentSegment1.clear();
					currentSegment1.add(i1);
				}

				currentSegment1.add(j1);
			}

			if (currentSegment1.count() > 0) {
				currentFigures01.add($.ig.IndicatorRenderer.prototype.output(currentSegment1, x0, y0, resolution));
			}

		}

	}

	, 
	rasterizeArea: function (count, x0, y0, x1, y1, colorByGradient, windowRect, viewportRect, positivePath0, positivePath01, positivePath1, negativePath0, negativePath01, negativePath1, worldZero, bucketSize, resolution) {
		var $self = this;
		var positiveFigures0 = ($.ig.util.cast($.ig.PathGeometry.prototype.$type, positivePath0.data())).figures();
		var positiveFigures01 = ($.ig.util.cast($.ig.PathGeometry.prototype.$type, positivePath01.data())).figures();
		var negativeFigures0 = ($.ig.util.cast($.ig.PathGeometry.prototype.$type, negativePath0.data())).figures();
		var negativeFigures01 = ($.ig.util.cast($.ig.PathGeometry.prototype.$type, negativePath01.data())).figures();
		if (bucketSize == 1) {
			var currentSegment = new $.ig.List$1($.ig.Number.prototype.$type, 0);
			var currentFigures0 = positiveFigures0;
			var currentFigures01 = positiveFigures01;
			var currentType = 0;
			currentSegment.add(0);
			for (var i = 0, j = 1; j < count; i = j++) {
				var type = currentType;
				var valueDelegateResult = y0(j) - y0(i);
				if (colorByGradient && !$.ig.util.isNaN(valueDelegateResult)) {
					type = Math.sign(valueDelegateResult);
				}

				if (type != 0 && type != currentType) {
					if (currentSegment.count() > 0) {
						var figure0 = $.ig.IndicatorRenderer.prototype.output(currentSegment, x0, y0, resolution);
						var figure01 = $.ig.PathFigureUtil.prototype.duplicate(figure0);
						figure01.__segments.add((function () { var $ret = new $.ig.LineSegment(1);
						$ret.point({__x: ($.ig.util.cast($.ig.LineSegment.prototype.$type, figure0.__segments.__inner[figure0.__segments.count() - 1])).point().__x, __y: worldZero, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}); return $ret;}()));
						figure01.__segments.add((function () { var $ret = new $.ig.LineSegment(1);
						$ret.point({__x: ($.ig.util.cast($.ig.LineSegment.prototype.$type, figure0.__segments.__inner[0])).point().__x, __y: worldZero, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}); return $ret;}()));
						currentFigures0.add(figure0);
						currentFigures01.add(figure01);
					}

					currentType = type;
					currentFigures0 = currentType == 1 ? negativeFigures0 : positiveFigures0;
					currentFigures01 = currentType == 1 ? negativeFigures01 : positiveFigures01;
					currentSegment.clear();
					currentSegment.add(i);
				}

				currentSegment.add(j);
			}

				var figure01 = $.ig.IndicatorRenderer.prototype.output(currentSegment, x0, y0, resolution);
				var figure011 = $.ig.PathFigureUtil.prototype.duplicate(figure01);
				figure011.__segments.add((function () { var $ret = new $.ig.LineSegment(1);
				$ret.point({__x: ($.ig.util.cast($.ig.LineSegment.prototype.$type, figure01.__segments.__inner[figure01.__segments.count() - 1])).point().__x, __y: worldZero, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}); return $ret;}()));
				figure011.__segments.add((function () { var $ret = new $.ig.LineSegment(1);
				$ret.point({__x: ($.ig.util.cast($.ig.LineSegment.prototype.$type, figure01.__segments.__inner[0])).point().__x, __y: worldZero, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}); return $ret;}()));
				currentFigures0.add(figure01);
				currentFigures01.add(figure011);


		} else {
			var currentSegment1 = new $.ig.List$1($.ig.Number.prototype.$type, 0);
			var currentFigures01 = positiveFigures0;
			var currentFigures011 = positiveFigures01;
			var currentType1 = 0;
			currentSegment1.add(0);
			for (var i1 = 0, j1 = 1; j1 < count; i1 = j1++) {
				var type1 = currentType1;
				var valueDelegateResult1 = (y0(j1) + y1(j1)) - (y0(i1) + y1(i1));
				if (colorByGradient && !$.ig.util.isNaN(valueDelegateResult1)) {
					type1 = Math.sign(valueDelegateResult1);
				}

				if (type1 != 0 && type1 != currentType1) {
					if (currentSegment1.count() > 0) {
						var figure02 = $.ig.IndicatorRenderer.prototype.output(currentSegment1, x0, y0, resolution);
						var figure012 = $.ig.PathFigureUtil.prototype.duplicate(figure02);
						figure012.__segments.add((function () { var $ret = new $.ig.LineSegment(1);
						$ret.point({__x: ($.ig.util.cast($.ig.LineSegment.prototype.$type, figure02.__segments.__inner[figure02.__segments.count() - 1])).point().__x, __y: worldZero, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}); return $ret;}()));
						figure012.__segments.add((function () { var $ret = new $.ig.LineSegment(1);
						$ret.point({__x: ($.ig.util.cast($.ig.LineSegment.prototype.$type, figure02.__segments.__inner[0])).point().__x, __y: worldZero, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}); return $ret;}()));
						currentFigures01.add(figure02);
						currentFigures011.add(figure012);
					}

					currentType1 = type1;
					currentFigures01 = currentType1 == 1 ? negativeFigures0 : positiveFigures0;
					currentFigures011 = currentType1 == 1 ? negativeFigures01 : positiveFigures01;
					currentSegment1.clear();
					currentSegment1.add(i1);
				}

				currentSegment1.add(j1);
			}

				var figure03 = $.ig.IndicatorRenderer.prototype.output(currentSegment1, x0, y0, resolution);
				var figure013 = $.ig.PathFigureUtil.prototype.duplicate(figure03);
				figure013.__segments.add((function () { var $ret = new $.ig.LineSegment(1);
				$ret.point({__x: ($.ig.util.cast($.ig.LineSegment.prototype.$type, figure03.__segments.__inner[figure03.__segments.count() - 1])).point().__x, __y: worldZero, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}); return $ret;}()));
				figure013.__segments.add((function () { var $ret = new $.ig.LineSegment(1);
				$ret.point({__x: ($.ig.util.cast($.ig.LineSegment.prototype.$type, figure03.__segments.__inner[0])).point().__x, __y: worldZero, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}); return $ret;}()));
				currentFigures01.add(figure03);
				currentFigures011.add(figure013);

		}

	}

	, 
	rasterizeColumns: function (count, x0, y0, x1, y1, colorByGradient, worldZero, Columns, positiveColumns, negativeColumns) {
		var positiveGeometryGroup = $.ig.util.cast($.ig.GeometryGroup.prototype.$type, positiveColumns.data());
		var negativeGeometryGroup = $.ig.util.cast($.ig.GeometryGroup.prototype.$type, negativeColumns.data());
		for (var i = 0; i < count; ++i) {
			var column = Columns.item(i);
			column.startPoint({__x: x0(i), __y: worldZero, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			column.endPoint({__x: x0(i), __y: y0(i), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			var pos = false;
			if (i > 0) {
				if (y0(i) <= y0(i - 1)) {
					pos = true;
				}


			} else {
				if (count > 1) {
					if (y0(i + 1) <= y0(i)) {
						pos = true;
					}

				}

			}

			if (pos) {
				positiveGeometryGroup.children().add(column);

			} else {
				negativeGeometryGroup.children().add(column);
			}

		}

		Columns.count(count);
	}
	, 
	$type: new $.ig.Type('IndicatorRenderer', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('ItemwiseIndicatorCalculationStrategy', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	calculateIndicatorItem: function (dataSource, supportingCalculations, currentIndex) {}

	, 
	basedOn: function (dataSource, supportingCalculations) {}
	, 
	$type: new $.ig.Type('ItemwiseIndicatorCalculationStrategy', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('ItemwiseStrategyBasedIndicator', 'StrategyBasedIndicator', {

	_actualItemwiseStrategy: null,
	actualItemwiseStrategy: function (value) {
		if (arguments.length === 1) {
			this._actualItemwiseStrategy = value;
			return value;
		} else {
			return this._actualItemwiseStrategy;
		}
	}

	, 
	itemwiseStrategy: function () {
	}

	, 
	calculationStrategy: function () {

			return new $.ig.ItemwiseStrategyCalculationStrategy();
	}
	, 
	init: function () {



		$.ig.StrategyBasedIndicator.prototype.init.call(this);
			this.actualItemwiseStrategy(this.itemwiseStrategy());
			(this.actualCalculationStrategy()).itemwiseStrategy(this.actualItemwiseStrategy());
	}
	, 
	$type: new $.ig.Type('ItemwiseStrategyBasedIndicator', $.ig.StrategyBasedIndicator.prototype.$type)
}, true);

$.ig.util.defType('ItemwiseStrategyCalculationStrategy', 'IndicatorCalculationStrategy', {
	init: function () {


		$.ig.IndicatorCalculationStrategy.prototype.init.call(this);

	}
	, 
	_itemwiseStrategy: null,
	itemwiseStrategy: function (value) {
		if (arguments.length === 1) {
			this._itemwiseStrategy = value;
			return value;
		} else {
			return this._itemwiseStrategy;
		}
	}

	, 
	basedOn: function (dataSource, supportingCalculations) {
		return this.itemwiseStrategy().basedOn(dataSource, supportingCalculations);
	}

	, 
	calculateIndicator: function (dataSource, supportingCalculations) {
		var shouldContinue = true;
		for (var i = dataSource.calculateFrom(); i < dataSource.calculateFrom() + dataSource.calculateCount(); i++) {
			shouldContinue = this.itemwiseStrategy().calculateIndicatorItem(dataSource, supportingCalculations, i);
			if (!shouldContinue) {
				return false;
			}

		}

		return shouldContinue;
	}
	, 
	$type: new $.ig.Type('ItemwiseStrategyCalculationStrategy', $.ig.IndicatorCalculationStrategy.prototype.$type)
}, true);

$.ig.util.defType('MarketFacilitationIndexIndicator', 'ItemwiseStrategyBasedIndicator', {
	init: function () {



		$.ig.ItemwiseStrategyBasedIndicator.prototype.init.call(this);
			this.displayType($.ig.IndicatorDisplayType.prototype.area);
	}

	, 
	itemwiseStrategy: function () {

			return new $.ig.MarketFacilitationIndexIndicatorStrategy();
	}

	, 
	styleKeyType: function () {

			return $.ig.MarketFacilitationIndexIndicator.prototype.$type;
	}
	, 
	$type: new $.ig.Type('MarketFacilitationIndexIndicator', $.ig.ItemwiseStrategyBasedIndicator.prototype.$type)
}, true);

$.ig.util.defType('MassIndexIndicator', 'StrategyBasedIndicator', {
	init: function () {


		$.ig.StrategyBasedIndicator.prototype.init.call(this);

	}
	, 
	calculationStrategy: function () {

			return new $.ig.MassIndexIndicatorStrategy();
	}

	, 
	styleKeyType: function () {

			return $.ig.MassIndexIndicator.prototype.$type;
	}
	, 
	$type: new $.ig.Type('MassIndexIndicator', $.ig.StrategyBasedIndicator.prototype.$type)
}, true);

$.ig.util.defType('MedianPriceIndicator', 'ItemwiseStrategyBasedIndicator', {
	init: function () {


		$.ig.ItemwiseStrategyBasedIndicator.prototype.init.call(this);

	}
	, 
	itemwiseStrategy: function () {

			return new $.ig.MedianPriceIndicatorStrategy();
	}

	, 
	styleKeyType: function () {

			return $.ig.MedianPriceIndicator.prototype.$type;
	}
	, 
	$type: new $.ig.Type('MedianPriceIndicator', $.ig.ItemwiseStrategyBasedIndicator.prototype.$type)
}, true);

$.ig.util.defType('MoneyFlowIndexIndicator', 'StrategyBasedIndicator', {
	init: function () {



		$.ig.StrategyBasedIndicator.prototype.init.call(this);
			this.displayType($.ig.IndicatorDisplayType.prototype.area);
	}

	, 
	calculationStrategy: function () {

			return new $.ig.MoneyFlowIndexIndicatorStrategy();
	}

	, 
	styleKeyType: function () {

			return $.ig.MoneyFlowIndexIndicator.prototype.$type;
	}

	, 
	period: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.MoneyFlowIndexIndicator.prototype.periodProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.MoneyFlowIndexIndicator.prototype.periodProperty));
		}
	}

	, 
	periodOverride: function () {
		return this.period();
	}
	, 
	$type: new $.ig.Type('MoneyFlowIndexIndicator', $.ig.StrategyBasedIndicator.prototype.$type)
}, true);

$.ig.util.defType('MovingAverageConvergenceDivergenceIndicator', 'StrategyBasedIndicator', {
	init: function () {



		var $self = this;
		$.ig.StrategyBasedIndicator.prototype.init.call(this);
			this.trendLineBrush((function () { var $ret = new $.ig.Brush();
			$ret.fill("Blue"); return $ret;}()));
			this.trendLineType($.ig.TrendLineType.prototype.exponentialAverage);
			this.trendLinePeriod(9);
	}

	, 
	calculationStrategy: function () {

			return new $.ig.MovingAverageConvergenceDivergenceIndicatorStrategy();
	}

	, 
	styleKeyType: function () {

			return $.ig.MovingAverageConvergenceDivergenceIndicator.prototype.$type;
	}

	, 
	shortPeriod: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.MovingAverageConvergenceDivergenceIndicator.prototype.shortPeriodProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.MovingAverageConvergenceDivergenceIndicator.prototype.shortPeriodProperty));
		}
	}

	, 
	shortPeriodOverride: function () {
		return this.shortPeriod();
	}

	, 
	longPeriod: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.MovingAverageConvergenceDivergenceIndicator.prototype.longPeriodProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.MovingAverageConvergenceDivergenceIndicator.prototype.longPeriodProperty));
		}
	}

	, 
	longPeriodOverride: function () {
		return this.longPeriod();
	}

	, 
	signalPeriod: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.MovingAverageConvergenceDivergenceIndicator.prototype.signalPeriodProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.MovingAverageConvergenceDivergenceIndicator.prototype.signalPeriodProperty));
		}
	}

	, 
	trendPeriodOverride: function () {
		return this.signalPeriod();
	}
	, 
	$type: new $.ig.Type('MovingAverageConvergenceDivergenceIndicator', $.ig.StrategyBasedIndicator.prototype.$type)
}, true);

$.ig.util.defType('NegativeVolumeIndexIndicator', 'StrategyBasedIndicator', {
	init: function () {


		$.ig.StrategyBasedIndicator.prototype.init.call(this);

	}
	, 
	calculationStrategy: function () {

			return new $.ig.NegativeVolumeIndexIndicatorStrategy();
	}

	, 
	styleKeyType: function () {

			return $.ig.NegativeVolumeIndexIndicator.prototype.$type;
	}
	, 
	$type: new $.ig.Type('NegativeVolumeIndexIndicator', $.ig.StrategyBasedIndicator.prototype.$type)
}, true);

$.ig.util.defType('OnBalanceVolumeIndicator', 'StrategyBasedIndicator', {
	init: function () {


		$.ig.StrategyBasedIndicator.prototype.init.call(this);

	}
	, 
	calculationStrategy: function () {

			return new $.ig.OnBalanceVolumeIndicatorStrategy();
	}

	, 
	styleKeyType: function () {

			return $.ig.OnBalanceVolumeIndicator.prototype.$type;
	}
	, 
	$type: new $.ig.Type('OnBalanceVolumeIndicator', $.ig.StrategyBasedIndicator.prototype.$type)
}, true);

$.ig.util.defType('PercentagePriceOscillatorIndicator', 'StrategyBasedIndicator', {
	init: function () {


		$.ig.StrategyBasedIndicator.prototype.init.call(this);

	}
	, 
	calculationStrategy: function () {

			return new $.ig.PercentagePriceOscillatorIndicatorStrategy();
	}

	, 
	styleKeyType: function () {

			return $.ig.PercentagePriceOscillatorIndicator.prototype.$type;
	}

	, 
	shortPeriod: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.PercentagePriceOscillatorIndicator.prototype.shortPeriodProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.PercentagePriceOscillatorIndicator.prototype.shortPeriodProperty));
		}
	}

	, 
	shortPeriodOverride: function () {
		return this.shortPeriod();
	}

	, 
	longPeriod: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.PercentagePriceOscillatorIndicator.prototype.longPeriodProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.PercentagePriceOscillatorIndicator.prototype.longPeriodProperty));
		}
	}

	, 
	longPeriodOverride: function () {
		return this.longPeriod();
	}
	, 
	$type: new $.ig.Type('PercentagePriceOscillatorIndicator', $.ig.StrategyBasedIndicator.prototype.$type)
}, true);

$.ig.util.defType('PercentageVolumeOscillatorIndicator', 'StrategyBasedIndicator', {
	init: function () {


		$.ig.StrategyBasedIndicator.prototype.init.call(this);

	}
	, 
	calculationStrategy: function () {

			return new $.ig.PercentageVolumeOscillatorIndicatorStrategy();
	}

	, 
	styleKeyType: function () {

			return $.ig.PercentageVolumeOscillatorIndicator.prototype.$type;
	}

	, 
	shortPeriod: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.PercentageVolumeOscillatorIndicator.prototype.shortPeriodProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.PercentageVolumeOscillatorIndicator.prototype.shortPeriodProperty));
		}
	}

	, 
	shortPeriodOverride: function () {
		return this.shortPeriod();
	}

	, 
	longPeriod: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.PercentageVolumeOscillatorIndicator.prototype.longPeriodProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.PercentageVolumeOscillatorIndicator.prototype.longPeriodProperty));
		}
	}

	, 
	longPeriodOverride: function () {
		return this.longPeriod();
	}
	, 
	$type: new $.ig.Type('PercentageVolumeOscillatorIndicator', $.ig.StrategyBasedIndicator.prototype.$type)
}, true);

$.ig.util.defType('PositiveVolumeIndexIndicator', 'StrategyBasedIndicator', {
	init: function () {


		$.ig.StrategyBasedIndicator.prototype.init.call(this);

	}
	, 
	calculationStrategy: function () {

			return new $.ig.PositiveVolumeIndexIndicatorStrategy();
	}

	, 
	styleKeyType: function () {

			return $.ig.PositiveVolumeIndexIndicator.prototype.$type;
	}
	, 
	$type: new $.ig.Type('PositiveVolumeIndexIndicator', $.ig.StrategyBasedIndicator.prototype.$type)
}, true);

$.ig.util.defType('PriceChannelOverlay', 'FinancialOverlay', {
	init: function () {


		this._channelTopColumn = new $.ig.List$1(Number, 0);
		this._channelBottomColumn = new $.ig.List$1(Number, 0);

		$.ig.FinancialOverlay.prototype.init.call(this);
			this.defaultStyleKey($.ig.PriceChannelOverlay.prototype.$type);
			this._previousFrame = new $.ig.CategoryFrame(3);
			this._transitionFrame = new $.ig.CategoryFrame(3);
			this._currentFrame = new $.ig.CategoryFrame(3);
	}

	, 
	period: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.PriceChannelOverlay.prototype.periodProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.PriceChannelOverlay.prototype.periodProperty));
		}
	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		switch (propertyName) {
			case $.ig.FinancialSeries.prototype.highColumnPropertyName:
			case $.ig.FinancialSeries.prototype.lowColumnPropertyName:
				this.overlayValid(false);
				break;
		}

		$.ig.FinancialOverlay.prototype.propertyUpdatedOverride.call(this, sender, propertyName, oldValue, newValue);
		switch (propertyName) {
			case $.ig.PriceChannelOverlay.prototype.periodPropertyName:
				this.overlayValid(false);
				this.renderSeries(false);
				break;
		}

	}

	, 
	validateSeries: function (viewportRect, windowRect, view) {
		var isValid = $.ig.FinancialOverlay.prototype.validateSeries.call(this, viewportRect, windowRect, view);
		if (this.highColumn() == null || this.lowColumn() == null) {
			isValid = false;
		}

		return isValid;
	}

	, 
	validateOverlay: function () {
		this._channelTopColumn.clear();
		this._channelBottomColumn.clear();
		var period = $.ig.truncate($.ig.MathUtil.prototype.clamp(this.period(), 0, this.fastItemsSource().count()));
		var count = Math.min(this.highColumn().count(), this.lowColumn().count());
		var safeHigh = this.makeReadOnlyAndEnsureSorted(this.highColumn());
		var safeLow = this.makeReadOnlyAndEnsureSorted(this.lowColumn());
		for (var i = 0; i < count; i++) {
			var ago = Math.min(period, i);
			var highestHigh = -1.7976931348623157E+308;
			var lowestLow = 1.7976931348623157E+308;
			for (var j = 0; j < ago; j++) {
				if (!$.ig.util.isNaN(safeHigh.item(i - j))) {
					highestHigh = Math.max(highestHigh, safeHigh.item(i - j));
				}

				if (!$.ig.util.isNaN(safeLow.item(i - j))) {
					lowestLow = Math.min(lowestLow, safeLow.item(i - j));
				}

			}

			if (i == 0) {
				lowestLow = safeLow.item(0);
				highestHigh = safeHigh.item(0);
			}

			this._channelTopColumn.add(highestHigh);
			this._channelBottomColumn.add(lowestLow);
		}

		return true;
	}

	, 
	convertToSingle: function (value) {
		return value;
	}

	, 
	prepareFrame: function (frame, view) {
		var $self = this;
		$.ig.FinancialOverlay.prototype.prepareFrame.call($self, frame, view);
		var windowRect = view.windowRect();
		var viewportRect = view.viewport();
		var xParams = new $.ig.ScalerParams(windowRect, viewportRect, $self.xAxis().isInverted());
		var yParams = new $.ig.ScalerParams(windowRect, viewportRect, $self.yAxis().isInverted());
		var xaxis = $self.xAxis();
		var yaxis = $self.yAxis();
		frame._buckets.clear();
		frame._markers.clear();
		frame._trend.clear();
		var offset = 0;
		var sortingXAxis = $.ig.util.cast($.ig.ISortingAxis.prototype.$type, $self.xAxis());
		if (sortingXAxis != null && sortingXAxis.sortedIndices().count() != $self.fastItemsSource().count()) {
			return;
		}

		offset = $self.getOffset(windowRect, viewportRect);
		if (!$self.overlayValid()) {
			$self.overlayValid($self.validateOverlay());
		}

		var singlePixelSpan = $self.convertToSingle($self.xAxis().getUnscaledValue(2, xParams) - $self.xAxis().getUnscaledValue(1, xParams));
		for (var i = view.bucketCalculator().firstBucket(); i <= view.bucketCalculator().lastBucket(); ++i) {
			var bucket;
			if (sortingXAxis == null) {
				bucket = view.bucketCalculator().getBucket(i);

			} else {
				var index = sortingXAxis.sortedIndices().__inner[i];
				var bucketX = sortingXAxis.getUnscaledValueAt(index);
				var bucketTop = $self.convertToSingle($self._channelTopColumn.__inner[i]);
				var bucketBottom = $self.convertToSingle($self._channelBottomColumn.__inner[i]);
				var currentTop = bucketTop;
				var currentBottom = bucketBottom;
				var currentX = bucketX;
				while (i < view.bucketCalculator().lastBucket()) {
					index = sortingXAxis.sortedIndices().__inner[i + 1];
					currentX = sortingXAxis.getUnscaledValueAt(index);
					if (currentX - bucketX > singlePixelSpan) {
						break;
					}

					i++;
					currentTop = Math.max(bucketTop, $self.convertToSingle($self._channelTopColumn.__inner[i]));
					currentBottom = Math.min(bucketBottom, $self.convertToSingle($self._channelBottomColumn.__inner[i]));

				}
				if (!$.ig.Number.prototype.isInfinity(currentBottom) && !$.ig.Number.prototype.isInfinity(currentTop)) {
					var xVal = NaN;
					if (!$.ig.util.isNaN(bucketX)) {
						xVal = $self.xAxis().getScaledValue(bucketX, xParams);
					}

					bucket = (function () { var $ret = new Array();
					$ret.add($self.convertToSingle(xVal));
					$ret.add(currentBottom);
					$ret.add(currentTop);return $ret;}());

				} else {
					bucket = (function () { var $ret = new Array();
					$ret.add(NaN);
					$ret.add(NaN);
					$ret.add(NaN);return $ret;}());
				}

			}

			var pp = Math.max(1, singlePixelSpan);
			if (!isNaN(bucket[0]) && i * pp >= $self.ignoreFirst()) {
				if ($self.xAxis() != null && $.ig.util.cast($.ig.ISortingAxis.prototype.$type, $self.xAxis()) !== null) {
					bucket[0] = (bucket[0] + offset);

				} else {
					bucket[0] = (xaxis.getScaledValue(bucket[0], xParams) + offset);
				}

				bucket[1] = yaxis.getScaledValue(bucket[1], yParams);
				bucket[2] = yaxis.getScaledValue(bucket[2], yParams);
				frame._buckets.add(bucket);
			}

		}

	}

	, 
	clearRendering: function (wipeClean, view) {
		$.ig.FinancialOverlay.prototype.clearRendering.call(this, wipeClean, view);
		var priceChannelView = view;
		if (priceChannelView != null) {
			priceChannelView.clearRendering();
		}

	}

	, 
	renderFrame: function (frame, view) {
		var $self = this;
		$.ig.FinancialOverlay.prototype.renderFrame.call($self, frame, view);
		var priceChannelView = $.ig.util.cast($.ig.PriceChannelOverlayView.prototype.$type, view);
		if (priceChannelView == null) {
			return;
		}

		if (view.checkFrameDirty(frame)) {
			priceChannelView.clearRendering();
			var count = frame._buckets.count();
			var px = function (i) { return frame._buckets.__inner[i][0]; };
			var nx = function (i) { return frame._buckets.__inner[count - 1 - i][0]; };
			var y0 = function (i) { return frame._buckets.__inner[i][1]; };
			var y1 = function (i) { return frame._buckets.__inner[count - 1 - i][2]; };
			priceChannelView.renderChannel(count, px, nx, y0, y1);
			view.updateFrameVersion(frame);
		}

		$self._renderManager.initCategoryRenderSettings($self, $self.shouldOverrideCategoryStyle(), $self.xAxis(), $self.getCategoryItems.runOn($self), $self.getBucketSize(view), $self.getFirstBucket(view));
		var areStylesOverriden = false;
		var args = $self._renderManager.categoryOverrideArgs();
		var buckets = frame._buckets;
		var valueCount = $self.fastItemsSource().count();
		if (args != null) {
			areStylesOverriden = true;
		}

		if (areStylesOverriden) {
			var xParams = new $.ig.ScalerParams(view.windowRect(), view.viewport(), $self.xAxis().isInverted());
			$self.performCategoryStyleOverride(buckets, -1, valueCount, $self.xAxis(), xParams, view.isThumbnailView());
		}

		var line0 = priceChannelView.line0();
		var line1 = priceChannelView.line1();
		var polygon = priceChannelView.fillArea();
		$self._renderManager.setCategoryShapeAppearance(line0, true, false, true, true);
		$self._renderManager.setCategoryShapeAppearance(line1, true, false, true, true);
		$self._renderManager.setCategoryShapeAppearance(polygon, false, true, false, false);
		polygon.__opacity = $self._renderManager._actualRenderOpacity * $self.actualAreaFillOpacity();
	}
	, 
	_channelTopColumn: null
	, 
	_channelBottomColumn: null

	, 
	createView: function () {
		return new $.ig.PriceChannelOverlayView(this);
	}

	, 
	onViewCreated: function (view) {
		$.ig.FinancialOverlay.prototype.onViewCreated.call(this, view);
		this.priceChannelOverlayView($.ig.util.cast($.ig.PriceChannelOverlayView.prototype.$type, view));
	}

	, 
	_priceChannelOverlayView: null,
	priceChannelOverlayView: function (value) {
		if (arguments.length === 1) {
			this._priceChannelOverlayView = value;
			return value;
		} else {
			return this._priceChannelOverlayView;
		}
	}

	, 
	getSeriesValue: function (world, useInterpolation, skipUnknowns) {
		if (this.seriesViewer() == null) {
			return NaN;
		}

		var xParams = new $.ig.ScalerParams(this.seriesViewer().actualWindowRect(), this.view().viewport(), this.xAxis().isInverted());
		var offset = this.getOffset(this.seriesViewer().actualWindowRect(), this.view().viewport());
		return this.getSeriesValueHelper(new $.ig.RangeValueList(this._channelTopColumn, this._channelBottomColumn), world, this.xAxis(), xParams, offset, this.getExactUnsortedItemIndex.runOn(this), useInterpolation, skipUnknowns);
	}

	, 
	getNextOrExactIndex: function (world, skipUnknowns) {
		if (this._channelTopColumn == null || this._channelBottomColumn == null) {
			return $.ig.FinancialOverlay.prototype.getNextOrExactIndex.call(this, world, skipUnknowns);
		}

		return this.getNextOrExactIndexHelper(world, skipUnknowns, this.xAxis(), this.getExactUnsortedItemIndex.runOn(this), new $.ig.RangeValueList(this._channelTopColumn, this._channelBottomColumn));
	}

	, 
	getPreviousOrExactIndex: function (world, skipUnknowns) {
		if (this._channelTopColumn == null || this._channelBottomColumn == null) {
			return $.ig.FinancialOverlay.prototype.getPreviousOrExactIndex.call(this, world, skipUnknowns);
		}

		return this.getPreviousOrExactIndexHelper(world, skipUnknowns, this.xAxis(), this.getExactUnsortedItemIndex.runOn(this), new $.ig.RangeValueList(this._channelTopColumn, this._channelBottomColumn));
	}
	, 
	$type: new $.ig.Type('PriceChannelOverlay', $.ig.FinancialOverlay.prototype.$type)
}, true);

$.ig.util.defType('PriceChannelBucketCalculator', 'FinancialBucketCalculator', {
	init: function (view) {



		$.ig.FinancialBucketCalculator.prototype.init.call(this, view);
			this.priceChannelView(view);
	}

	, 
	_priceChannelView: null,
	priceChannelView: function (value) {
		if (arguments.length === 1) {
			this._priceChannelView = value;
			return value;
		} else {
			return this._priceChannelView;
		}
	}

	, 
	getBucket: function (index) {
		var $self = this;
		var i0 = index * $self.bucketSize();
		var i1 = Math.min(i0 + $self.bucketSize() - 1, $self.view().financialModel().fastItemsSource().count() - 1);
		if (i0 <= i1) {
			var highestHigh = -1.7976931348623157E+308;
			var lowestLow = 1.7976931348623157E+308;
			var cnt = 0;
			for (var i = i0; i <= i1; ++i) {
				if (!$.ig.util.isNaN($self.priceChannelView().priceChannelOverlayModel()._channelTopColumn.__inner[i]) && !$.ig.util.isNaN($self.priceChannelView().priceChannelOverlayModel()._channelBottomColumn.__inner[i])) {
					highestHigh = Math.max(highestHigh, $self.priceChannelView().priceChannelOverlayModel()._channelTopColumn.__inner[i]);
					lowestLow = Math.min(lowestLow, $self.priceChannelView().priceChannelOverlayModel()._channelBottomColumn.__inner[i]);
					++cnt;
				}

			}

			if (cnt > 0 && lowestLow != 1.7976931348623157E+308 && highestHigh != -1.7976931348623157E+308) {
				return (function () { var $ret = new Array();
				$ret.add((0.5 * (i0 + i1)));
				$ret.add((lowestLow));
				$ret.add((highestHigh));return $ret;}());
			}

		}

		return (function () { var $ret = new Array();
		$ret.add(NaN);
		$ret.add(NaN);
		$ret.add(NaN);return $ret;}());
	}
	, 
	$type: new $.ig.Type('PriceChannelBucketCalculator', $.ig.FinancialBucketCalculator.prototype.$type)
}, true);

$.ig.util.defType('PriceVolumeTrendIndicator', 'StrategyBasedIndicator', {
	init: function () {


		$.ig.StrategyBasedIndicator.prototype.init.call(this);

	}
	, 
	calculationStrategy: function () {

			return new $.ig.PriceVolumeTrendIndicatorStrategy();
	}

	, 
	styleKeyType: function () {

			return $.ig.PriceVolumeTrendIndicator.prototype.$type;
	}
	, 
	$type: new $.ig.Type('PriceVolumeTrendIndicator', $.ig.StrategyBasedIndicator.prototype.$type)
}, true);

$.ig.util.defType('RateOfChangeAndMomentumIndicator', 'StrategyBasedIndicator', {
	init: function () {


		$.ig.StrategyBasedIndicator.prototype.init.call(this);

	}
	, 
	calculationStrategy: function () {

			return new $.ig.RateOfChangeAndMomentumIndicatorStrategy();
	}

	, 
	styleKeyType: function () {

			return $.ig.RateOfChangeAndMomentumIndicator.prototype.$type;
	}

	, 
	period: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.RateOfChangeAndMomentumIndicator.prototype.periodProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.RateOfChangeAndMomentumIndicator.prototype.periodProperty));
		}
	}

	, 
	periodOverride: function () {
		return this.period();
	}
	, 
	$type: new $.ig.Type('RateOfChangeAndMomentumIndicator', $.ig.StrategyBasedIndicator.prototype.$type)
}, true);

$.ig.util.defType('RelativeStrengthIndexIndicator', 'StrategyBasedIndicator', {
	init: function () {



		$.ig.StrategyBasedIndicator.prototype.init.call(this);
			this.displayType($.ig.IndicatorDisplayType.prototype.area);
	}

	, 
	calculationStrategy: function () {

			return new $.ig.RelativeStrengthIndexIndicatorStrategy();
	}

	, 
	styleKeyType: function () {

			return $.ig.RelativeStrengthIndexIndicator.prototype.$type;
	}

	, 
	period: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.RelativeStrengthIndexIndicator.prototype.periodProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.RelativeStrengthIndexIndicator.prototype.periodProperty));
		}
	}

	, 
	periodOverride: function () {
		return this.period();
	}
	, 
	$type: new $.ig.Type('RelativeStrengthIndexIndicator', $.ig.StrategyBasedIndicator.prototype.$type)
}, true);

$.ig.util.defType('SlowStochasticOscillatorIndicator', 'StrategyBasedIndicator', {
	init: function () {



		var $self = this;
		$.ig.StrategyBasedIndicator.prototype.init.call(this);
			this.trendLineBrush((function () { var $ret = new $.ig.Brush();
			$ret.fill("Blue"); return $ret;}()));
			this.trendLineType($.ig.TrendLineType.prototype.exponentialAverage);
			this.trendLinePeriod(3);
	}

	, 
	calculationStrategy: function () {

			return new $.ig.SlowStochasticOscillatorIndicatorStrategy();
	}

	, 
	styleKeyType: function () {

			return $.ig.SlowStochasticOscillatorIndicator.prototype.$type;
	}

	, 
	period: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.SlowStochasticOscillatorIndicator.prototype.periodProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.SlowStochasticOscillatorIndicator.prototype.periodProperty));
		}
	}

	, 
	periodOverride: function () {
		return this.period();
	}
	, 
	$type: new $.ig.Type('SlowStochasticOscillatorIndicator', $.ig.StrategyBasedIndicator.prototype.$type)
}, true);

$.ig.util.defType('StandardDeviationIndicator', 'StrategyBasedIndicator', {
	init: function () {


		$.ig.StrategyBasedIndicator.prototype.init.call(this);

	}
	, 
	calculationStrategy: function () {

			return new $.ig.StandardDeviationIndicatorStrategy();
	}

	, 
	styleKeyType: function () {

			return $.ig.StandardDeviationIndicator.prototype.$type;
	}

	, 
	period: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StandardDeviationIndicator.prototype.periodProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.StandardDeviationIndicator.prototype.periodProperty));
		}
	}

	, 
	periodOverride: function () {
		return this.period();
	}
	, 
	$type: new $.ig.Type('StandardDeviationIndicator', $.ig.StrategyBasedIndicator.prototype.$type)
}, true);

$.ig.util.defType('StochRSIIndicator', 'StrategyBasedIndicator', {
	init: function () {


		$.ig.StrategyBasedIndicator.prototype.init.call(this);

	}
	, 
	calculationStrategy: function () {

			return new $.ig.StochRSIIndicatorStrategy();
	}

	, 
	styleKeyType: function () {

			return $.ig.StochRSIIndicator.prototype.$type;
	}

	, 
	period: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.StochRSIIndicator.prototype.periodProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.StochRSIIndicator.prototype.periodProperty));
		}
	}

	, 
	periodOverride: function () {
		return this.period();
	}
	, 
	$type: new $.ig.Type('StochRSIIndicator', $.ig.StrategyBasedIndicator.prototype.$type)
}, true);

$.ig.util.defType('StreamingIndicatorCalculationStrategy', 'IndicatorCalculationStrategy', {
	init: function () {


		$.ig.IndicatorCalculationStrategy.prototype.init.call(this);

	}
	, 
	provideStream: function (dataSource, supportingCalculations) {}
	, 
	$type: new $.ig.Type('StreamingIndicatorCalculationStrategy', $.ig.IndicatorCalculationStrategy.prototype.$type)
}, true);

$.ig.util.defType('TRIXIndicator', 'StrategyBasedIndicator', {
	init: function () {



		var $self = this;
		$.ig.StrategyBasedIndicator.prototype.init.call(this);
			this.displayType($.ig.IndicatorDisplayType.prototype.line);
			this.trendLineBrush((function () { var $ret = new $.ig.Brush();
			$ret.fill("Blue"); return $ret;}()));
			this.trendLineType($.ig.TrendLineType.prototype.simpleAverage);
			this.trendLinePeriod(9);
	}

	, 
	calculationStrategy: function () {

			return new $.ig.TRIXIndicatorStrategy();
	}

	, 
	styleKeyType: function () {

			return $.ig.TRIXIndicator.prototype.$type;
	}

	, 
	period: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.TRIXIndicator.prototype.periodProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.TRIXIndicator.prototype.periodProperty));
		}
	}

	, 
	periodOverride: function () {
		return this.period();
	}
	, 
	$type: new $.ig.Type('TRIXIndicator', $.ig.StrategyBasedIndicator.prototype.$type)
}, true);

$.ig.util.defType('TypicalPriceIndicator', 'StrategyBasedIndicator', {
	init: function () {


		$.ig.StrategyBasedIndicator.prototype.init.call(this);

	}
	, 
	calculationStrategy: function () {

			return new $.ig.TypicalPriceIndicatorStrategy();
	}

	, 
	styleKeyType: function () {

			return $.ig.TypicalPriceIndicator.prototype.$type;
	}
	, 
	$type: new $.ig.Type('TypicalPriceIndicator', $.ig.StrategyBasedIndicator.prototype.$type)
}, true);

$.ig.util.defType('UltimateOscillatorIndicator', 'StrategyBasedIndicator', {
	init: function () {


		$.ig.StrategyBasedIndicator.prototype.init.call(this);

	}
	, 
	calculationStrategy: function () {

			return new $.ig.UltimateOscillatorIndicatorCalculationStrategy();
	}

	, 
	styleKeyType: function () {

			return $.ig.UltimateOscillatorIndicator.prototype.$type;
	}
	, 
	$type: new $.ig.Type('UltimateOscillatorIndicator', $.ig.StrategyBasedIndicator.prototype.$type)
}, true);

$.ig.util.defType('WeightedCloseIndicator', 'ItemwiseStrategyBasedIndicator', {
	init: function () {


		$.ig.ItemwiseStrategyBasedIndicator.prototype.init.call(this);

	}
	, 
	itemwiseStrategy: function () {

			return new $.ig.WeightedCloseIndicatorStrategy();
	}

	, 
	styleKeyType: function () {

			return $.ig.WeightedCloseIndicator.prototype.$type;
	}
	, 
	$type: new $.ig.Type('WeightedCloseIndicator', $.ig.ItemwiseStrategyBasedIndicator.prototype.$type)
}, true);

$.ig.util.defType('WilliamsPercentRIndicator', 'StrategyBasedIndicator', {
	init: function () {


		$.ig.StrategyBasedIndicator.prototype.init.call(this);

	}
	, 
	calculationStrategy: function () {

			return new $.ig.WilliamsPercentRIndicatorStrategy();
	}

	, 
	styleKeyType: function () {

			return $.ig.WilliamsPercentRIndicator.prototype.$type;
	}

	, 
	period: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.WilliamsPercentRIndicator.prototype.periodProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.WilliamsPercentRIndicator.prototype.periodProperty));
		}
	}

	, 
	periodOverride: function () {
		return this.period();
	}
	, 
	$type: new $.ig.Type('WilliamsPercentRIndicator', $.ig.StrategyBasedIndicator.prototype.$type)
}, true);































































$.ig.util.defType('Marker', 'ContentControl', {
	init: function () {


		$.ig.ContentControl.prototype.init.call(this);

	}
	, 
	_brush: null,
	brush: function (value) {
		if (arguments.length === 1) {
			this._brush = value;
			return value;
		} else {
			return this._brush;
		}
	}

	, 
	_outline: null,
	outline: function (value) {
		if (arguments.length === 1) {
			this._outline = value;
			return value;
		} else {
			return this._outline;
		}
	}

	, 
	_canvasZIndex: 0,
	canvasZIndex: function (value) {
		if (arguments.length === 1) {
			this._canvasZIndex = value;
			return value;
		} else {
			return this._canvasZIndex;
		}
	}

	, 
	_currentIndex: 0,
	currentIndex: function (value) {
		if (arguments.length === 1) {
			this._currentIndex = value;
			return value;
		} else {
			return this._currentIndex;
		}
	}

	, 
	_markerBucket: 0,
	markerBucket: function (value) {
		if (arguments.length === 1) {
			this._markerBucket = value;
			return value;
		} else {
			return this._markerBucket;
		}
	}
	, 
	_renderOffsetX: 0
	, 
	_renderOffsetY: 0
	, 
	$type: new $.ig.Type('Marker', $.ig.ContentControl.prototype.$type)
}, true);
























$.ig.util.defType('TrendResolutionParams', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	_firstBucket: 0,
	firstBucket: function (value) {
		if (arguments.length === 1) {
			this._firstBucket = value;
			return value;
		} else {
			return this._firstBucket;
		}
	}

	, 
	_lastBucket: 0,
	lastBucket: function (value) {
		if (arguments.length === 1) {
			this._lastBucket = value;
			return value;
		} else {
			return this._lastBucket;
		}
	}

	, 
	_bucketSize: 0,
	bucketSize: function (value) {
		if (arguments.length === 1) {
			this._bucketSize = value;
			return value;
		} else {
			return this._bucketSize;
		}
	}

	, 
	_viewport: null,
	viewport: function (value) {
		if (arguments.length === 1) {
			this._viewport = value;
			return value;
		} else {
			return this._viewport;
		}
	}

	, 
	_window: null,
	window: function (value) {
		if (arguments.length === 1) {
			this._window = value;
			return value;
		} else {
			return this._window;
		}
	}

	, 
	_resolution: 0,
	resolution: function (value) {
		if (arguments.length === 1) {
			this._resolution = value;
			return value;
		} else {
			return this._resolution;
		}
	}

	, 
	_offset: 0,
	offset: function (value) {
		if (arguments.length === 1) {
			this._offset = value;
			return value;
		} else {
			return this._offset;
		}
	}
	, 
	$type: new $.ig.Type('TrendResolutionParams', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('TrendFitCalculator', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	calculateFit: function (trend, trendLineType, trendResolutionParams, trendCoefficients, count, GetUnscaledX, GetUnscaledY, GetScaledXValue, GetScaledYValue, xmin, xmax) {
		if (trendCoefficients == null) {
			switch (trendLineType) {
				case $.ig.TrendLineType.prototype.linearFit:
					trendCoefficients = $.ig.LeastSquaresFit.prototype.linearFit(count, GetUnscaledX, GetUnscaledY);
					break;
				case $.ig.TrendLineType.prototype.quadraticFit:
					trendCoefficients = $.ig.LeastSquaresFit.prototype.quadraticFit(count, GetUnscaledX, GetUnscaledY);
					break;
				case $.ig.TrendLineType.prototype.cubicFit:
					trendCoefficients = $.ig.LeastSquaresFit.prototype.cubicFit(count, GetUnscaledX, GetUnscaledY);
					break;
				case $.ig.TrendLineType.prototype.quarticFit:
					trendCoefficients = $.ig.LeastSquaresFit.prototype.quarticFit(count, GetUnscaledX, GetUnscaledY);
					break;
				case $.ig.TrendLineType.prototype.quinticFit:
					trendCoefficients = $.ig.LeastSquaresFit.prototype.quinticFit(count, GetUnscaledX, GetUnscaledY);
					break;
				case $.ig.TrendLineType.prototype.exponentialFit:
					trendCoefficients = $.ig.LeastSquaresFit.prototype.exponentialFit(count, GetUnscaledX, GetUnscaledY);
					break;
				case $.ig.TrendLineType.prototype.logarithmicFit:
					trendCoefficients = $.ig.LeastSquaresFit.prototype.logarithmicFit(count, GetUnscaledX, GetUnscaledY);
					break;
				case $.ig.TrendLineType.prototype.powerLawFit:
					trendCoefficients = $.ig.LeastSquaresFit.prototype.powerLawFit(count, GetUnscaledX, GetUnscaledY);
					break;
				default:
					throw new $.ig.NotImplementedException(0);
			}

		}

		if (trendCoefficients == null) {
			return null;
		}

		for (var i = 0; i < trendResolutionParams.viewport().width(); i += 2) {
			var p = i / (trendResolutionParams.viewport().width() - 1);
			var xi = xmin + p * (xmax - xmin);
			var yi = NaN;
			switch (trendLineType) {
				case $.ig.TrendLineType.prototype.linearFit:
					yi = $.ig.LeastSquaresFit.prototype.linearEvaluate(trendCoefficients, xi);
					break;
				case $.ig.TrendLineType.prototype.quadraticFit:
					yi = $.ig.LeastSquaresFit.prototype.quadraticEvaluate(trendCoefficients, xi);
					break;
				case $.ig.TrendLineType.prototype.cubicFit:
					yi = $.ig.LeastSquaresFit.prototype.cubicEvaluate(trendCoefficients, xi);
					break;
				case $.ig.TrendLineType.prototype.quarticFit:
					yi = $.ig.LeastSquaresFit.prototype.quarticEvaluate(trendCoefficients, xi);
					break;
				case $.ig.TrendLineType.prototype.quinticFit:
					yi = $.ig.LeastSquaresFit.prototype.quinticEvaluate(trendCoefficients, xi);
					break;
				case $.ig.TrendLineType.prototype.exponentialFit:
					yi = $.ig.LeastSquaresFit.prototype.exponentialEvaluate(trendCoefficients, xi);
					break;
				case $.ig.TrendLineType.prototype.logarithmicFit:
					yi = $.ig.LeastSquaresFit.prototype.logarithmicEvaluate(trendCoefficients, xi);
					break;
				case $.ig.TrendLineType.prototype.powerLawFit:
					yi = $.ig.LeastSquaresFit.prototype.powerLawEvaluate(trendCoefficients, xi);
					break;
				default:
					throw new $.ig.NotImplementedException(0);
			}

			xi = GetScaledXValue(xi);
			yi = GetScaledYValue(yi);
			if (!$.ig.util.isNaN(yi) && !Number.isInfinity(yi)) {
				trend.add({__x: xi + trendResolutionParams.offset(), __y: yi, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
			}

		}

		return trendCoefficients;
	}
	, 
	$type: new $.ig.Type('TrendFitCalculator', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('TrendAverageCalculator', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	getAverage: function (trendLineType, sourceColumn, period) {
		var average;
		switch (trendLineType) {
			case $.ig.TrendLineType.prototype.simpleAverage:
			case $.ig.TrendLineType.prototype.exponentialAverage:
			case $.ig.TrendLineType.prototype.modifiedAverage:
			case $.ig.TrendLineType.prototype.weightedAverage:
				if (period < 1) {
					period = 1;
				}

				break;
		}

		switch (trendLineType) {
			case $.ig.TrendLineType.prototype.simpleAverage:
				average = $.ig.Series.prototype.sMA(sourceColumn, period);
				break;
			case $.ig.TrendLineType.prototype.exponentialAverage:
				average = $.ig.Series.prototype.eMA(sourceColumn, period);
				break;
			case $.ig.TrendLineType.prototype.modifiedAverage:
				average = $.ig.Series.prototype.mMA(sourceColumn, period);
				break;
			case $.ig.TrendLineType.prototype.cumulativeAverage:
				average = $.ig.Series.prototype.cMA(sourceColumn);
				break;
			case $.ig.TrendLineType.prototype.weightedAverage:
				average = $.ig.Series.prototype.wMA(sourceColumn, period);
				break;
			default:
				throw new $.ig.NotImplementedException(0);
		}

		return average;
	}

	, 
	calculateSingleValueAverage: function (trendLineType, trendColumn, valueColumn, period) {
		if (trendColumn.count() == 0) {
			var average = $.ig.TrendAverageCalculator.prototype.getAverage(trendLineType, valueColumn, period);
			var en = average.getEnumerator();
			while (en.moveNext()) {
				var d = en.current();
				trendColumn.add(d);
			}

		}

	}

	, 
	calculateXYAverage: function (trendLineType, trendColumn, XColumn, YColumn, period) {
		if (trendColumn.count() == 0) {
			var xAverage = $.ig.TrendAverageCalculator.prototype.getAverage(trendLineType, XColumn, period).getEnumerator();
			var yAverage = $.ig.TrendAverageCalculator.prototype.getAverage(trendLineType, YColumn, period).getEnumerator();
			while (xAverage.moveNext() && yAverage.moveNext()) {
				trendColumn.add({__x: xAverage.current(), __y: yAverage.current(), $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});

			}
		}

	}
	, 
	$type: new $.ig.Type('TrendAverageCalculator', $.ig.Object.prototype.$type)
}, true);




$.ig.util.defType('SortingTrendLineManager', 'CategoryTrendLineManagerBase', {
	init: function (getUnscaledXValueFromUnsortedIndex, getUnscaledXValue) {



		$.ig.CategoryTrendLineManagerBase.prototype.init.call(this);
			this.getUnscaledValueFromUnsortedIndex(getUnscaledXValueFromUnsortedIndex);
			this.getUnscaledXValue(getUnscaledXValue);
	}

	, 
	_getUnscaledValueFromUnsortedIndex: null,
	getUnscaledValueFromUnsortedIndex: function (value) {
		if (arguments.length === 1) {
			this._getUnscaledValueFromUnsortedIndex = value;
			return value;
		} else {
			return this._getUnscaledValueFromUnsortedIndex;
		}
	}

	, 
	_getUnscaledXValue: null,
	getUnscaledXValue: function (value) {
		if (arguments.length === 1) {
			this._getUnscaledXValue = value;
			return value;
		} else {
			return this._getUnscaledXValue;
		}
	}

	, 
	prepareLine: function (flattenedPoints, trendLineType, valueColumn, period, GetScaledXValue, GetScaledYValue, trendResolutionParams) {
		var $self = this;
		var xmin = trendResolutionParams.firstBucket() * trendResolutionParams.bucketSize();
		var xmax = trendResolutionParams.lastBucket() * trendResolutionParams.bucketSize();
		var trend = new $.ig.List$1($.ig.Point.prototype.$type, 0);
		if (trendLineType == $.ig.TrendLineType.prototype.none) {
			$self.trendCoefficients(null);
			$self.trendColumn().clear();
			return;
		}

		if ($self.isFit(trendLineType)) {
			$self.trendColumn().clear();
			$self.trendCoefficients($.ig.TrendFitCalculator.prototype.calculateFit(trend, trendLineType, trendResolutionParams, $self.trendCoefficients(), valueColumn.count(), function (x) { return (x + 1); }, function (i) { return valueColumn.item(i); }, function (x) {
				var floor = $.ig.truncate(Math.floor(x));
				var ceil = $.ig.truncate(Math.ceil(x));
				var p = x - floor;
				var unscaled;
				if (ceil <= xmax) {
					unscaled = $self.getUnscaledValueFromUnsortedIndex()(floor) + p * ($self.getUnscaledValueFromUnsortedIndex()(ceil) - $self.getUnscaledValueFromUnsortedIndex()(floor));

				} else {
					unscaled = $self.getUnscaledValueFromUnsortedIndex()(floor) + p * ($self.getUnscaledValueFromUnsortedIndex()($.ig.truncate(xmax)) - $self.getUnscaledValueFromUnsortedIndex()(floor));
				}

				return GetScaledXValue(unscaled);
			}, GetScaledYValue, xmin, xmax));
		}

		if ($self.isAverage(trendLineType)) {
			$self.trendCoefficients(null);
			$.ig.TrendAverageCalculator.prototype.calculateSingleValueAverage(trendLineType, $self.trendColumn(), valueColumn, period);
			for (var i = trendResolutionParams.firstBucket(); i <= trendResolutionParams.lastBucket(); i += 1) {
				var itemIndex = i * trendResolutionParams.bucketSize();
				var unscaledX = $self.getUnscaledValueFromUnsortedIndex()(itemIndex);
				if (itemIndex >= 0 && itemIndex < $self.trendColumn().count()) {
					var xi = GetScaledXValue(unscaledX);
					var yi = GetScaledYValue($self.trendColumn().__inner[itemIndex]);
					trend.add({__x: xi + trendResolutionParams.offset(), __y: yi, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
				}

			}

		}

		$self.flattenTrendLine(trend, trendResolutionParams, flattenedPoints);
	}
	, 
	$type: new $.ig.Type('SortingTrendLineManager', $.ig.CategoryTrendLineManagerBase.prototype.$type)
}, true);

















$.ig.util.defType('FinancialEventArgs', 'EventArgs', {
	init: function (position, count, dataSource, supportingCalculations) {



		$.ig.EventArgs.prototype.init.call(this);
			this.position(position);
			this.count(count);
			this.dataSource(dataSource);
			this.supportingCalculations(supportingCalculations);
	}

	, 
	_position: 0,
	position: function (value) {
		if (arguments.length === 1) {
			this._position = value;
			return value;
		} else {
			return this._position;
		}
	}

	, 
	_count: 0,
	count: function (value) {
		if (arguments.length === 1) {
			this._count = value;
			return value;
		} else {
			return this._count;
		}
	}

	, 
	_dataSource: null,
	dataSource: function (value) {
		if (arguments.length === 1) {
			this._dataSource = value;
			return value;
		} else {
			return this._dataSource;
		}
	}

	, 
	_supportingCalculations: null,
	supportingCalculations: function (value) {
		if (arguments.length === 1) {
			this._supportingCalculations = value;
			return value;
		} else {
			return this._supportingCalculations;
		}
	}

	, 
	_basedOn: null,
	basedOn: function (value) {
		if (arguments.length === 1) {
			this._basedOn = value;
			return value;
		} else {
			return this._basedOn;
		}
	}
	, 
	$type: new $.ig.Type('FinancialEventArgs', $.ig.EventArgs.prototype.$type)
}, true);






$.ig.util.defType('FinancialPriceSeries', 'FinancialSeries', {

	createView: function () {
		return new $.ig.FinancialPriceSeriesView(this);
	}

	, 
	onViewCreated: function (view) {
		$.ig.FinancialSeries.prototype.onViewCreated.call(this, view);
		this.financialPriceView(view);
	}

	, 
	_financialPriceView: null,
	financialPriceView: function (value) {
		if (arguments.length === 1) {
			this._financialPriceView = value;
			return value;
		} else {
			return this._financialPriceView;
		}
	}
	, 
	init: function () {



		$.ig.FinancialSeries.prototype.init.call(this);
			this.defaultStyleKey($.ig.FinancialPriceSeries.prototype.$type);
			this._previousFrame = new $.ig.CategoryFrame(5);
			this._transitionFrame = new $.ig.CategoryFrame(5);
			this._currentFrame = new $.ig.CategoryFrame(5);
	}

	, 
	trendLineType: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.FinancialPriceSeries.prototype.trendLineTypeProperty, $.ig.TrendLineType.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.FinancialPriceSeries.prototype.trendLineTypeProperty));
		}
	}

	, 
	trendLineBrush: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.FinancialPriceSeries.prototype.trendLineBrushProperty, value);
			return value;
		} else {

			return this.getValue($.ig.FinancialPriceSeries.prototype.trendLineBrushProperty);
		}
	}

	, 
	actualTrendLineBrush: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.FinancialPriceSeries.prototype.actualTrendLineBrushProperty, value);
			return value;
		} else {

			return this.getValue($.ig.FinancialPriceSeries.prototype.actualTrendLineBrushProperty);
		}
	}

	, 
	trendLineThickness: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.FinancialPriceSeries.prototype.trendLineThicknessProperty, value);
			return value;
		} else {

			return this.getValue($.ig.FinancialPriceSeries.prototype.trendLineThicknessProperty);
		}
	}

	, 
	trendLineDashCap: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.FinancialPriceSeries.prototype.trendLineDashCapProperty, $.ig.PenLineCap.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.FinancialPriceSeries.prototype.trendLineDashCapProperty));
		}
	}

	, 
	trendLineDashArray: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.FinancialPriceSeries.prototype.trendLineDashArrayProperty, value);
			return value;
		} else {

			return this.getValue($.ig.FinancialPriceSeries.prototype.trendLineDashArrayProperty);
		}
	}

	, 
	trendLinePeriod: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.FinancialPriceSeries.prototype.trendLinePeriodProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.FinancialPriceSeries.prototype.trendLinePeriodProperty));
		}
	}

	, 
	trendLineZIndex: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.FinancialPriceSeries.prototype.trendLineZIndexProperty, value);
			return value;
		} else {

			return $.ig.util.getValue(this.getValue($.ig.FinancialPriceSeries.prototype.trendLineZIndexProperty));
		}
	}

	, 
	dataUpdatedOverride: function (action, position, count, propertyName) {
		if (this.xAxis() != null && $.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.xAxis()) !== null) {
			($.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.xAxis())).notifyDataChanged();
		}

		this.financialPriceView().bucketCalculator().calculateBuckets(this.resolution());
		this.financialPriceView().trendLineManager().dataUpdated(action, position, count, propertyName);
		if (this.yAxis() != null) {
			this.yAxis().updateRange();
		}

		this.renderSeries(true);
	}

	, 
	displayType: function (value) {
		if (arguments.length === 1) {

			this.setValue($.ig.FinancialPriceSeries.prototype.displayTypeProperty, $.ig.PriceDisplayType.prototype.getBox(value));
			return value;
		} else {

			return $.ig.util.getEnumValue(this.getValue($.ig.FinancialPriceSeries.prototype.displayTypeProperty));
		}
	}

	, 
	propertyUpdatedOverride: function (sender, propertyName, oldValue, newValue) {
		switch (propertyName) {
			case $.ig.FinancialSeries.prototype.xAxisPropertyName:
				this.financialPriceView().selectTrendlineManager();
				break;
		}

		$.ig.FinancialSeries.prototype.propertyUpdatedOverride.call(this, sender, propertyName, oldValue, newValue);
		if (this.financialPriceView().trendLineManager() != null && this.financialPriceView().trendLineManager().propertyUpdated(sender, propertyName, oldValue, newValue)) {
			this.renderSeries(false);
			this.notifyThumbnailAppearanceChanged();
		}

		switch (propertyName) {
			case $.ig.FinancialPriceSeries.prototype.displayTypePropertyName:
				if (this.rootCanvas() != null) {
					this.updatePathBrushes();
					this._currentFrame.incrementFrameVersion();
					this.renderFrame(this._currentFrame, this.financialPriceView());
				}

				this.notifyThumbnailAppearanceChanged();
				break;
			case $.ig.Series.prototype.trendLineBrushPropertyName:
				this.updateIndexedProperties();
				break;
			case $.ig.Series.prototype.trendLineTypePropertyName:
				this.notifyThumbnailAppearanceChanged();
				break;
		}

	}

	, 
	updatePathBrushes: function () {
		this.financialPriceView().updatePathBrushes();
		if (this.thumbnailView() != null) {
			(this.thumbnailView()).updatePathBrushes();
		}

	}

	, 
	getRange: function (axis) {
		if (axis != null && axis == this.yAxis() && this.lowColumn() != null && !$.ig.util.isNaN(this.lowColumn().minimum()) && this.highColumn() != null && !$.ig.util.isNaN(this.highColumn().maximum())) {
			return new $.ig.AxisRange(this.lowColumn().minimum(), this.highColumn().maximum());
		}

		return null;
	}

	, 
	scrollIntoView: function (item) {
		var index = this.fastItemsSource() != null ? this.fastItemsSource().indexOf(item) : -1;
		var windowRect = this.view().windowRect();
		var viewportRect = this.view().viewport();
		var unitRect = new $.ig.Rect(0, 0, 0, 1, 1);
		if (index >= 0 && windowRect != null && viewportRect != null) {
			if (this.xAxis() != null) {
				var xParams = new $.ig.ScalerParams(unitRect, unitRect, this.xAxis().isInverted());
				var cx = this.xAxis().getScaledValue(index, xParams);
				if (cx < windowRect.left() + 0.1 * windowRect.width()) {
					cx = cx + 0.4 * windowRect.width();
				}

				if (cx > windowRect.right() - 0.1 * windowRect.width()) {
					cx = cx - 0.4 * windowRect.width();
				}

				windowRect.x(cx - 0.5 * windowRect.width());
			}

			if (this.yAxis() != null && this.lowColumn() != null && this.highColumn() != null && index < this.lowColumn().count() && index < this.highColumn().count()) {
				var yParams = new $.ig.ScalerParams(unitRect, unitRect, this.yAxis().isInverted());
				var low = this.yAxis().getScaledValue(this.lowColumn().item(index), yParams);
				var high = this.yAxis().getScaledValue(this.highColumn().item(index), yParams);
				if (!$.ig.util.isNaN(low) && !$.ig.util.isNaN(high)) {
					var height = Math.abs(low - high);
					if (windowRect.height() < height) {
						windowRect.height(height);
						windowRect.y(Math.min(low, high));

					} else {
						if (low < windowRect.top() + 0.1 * windowRect.height()) {
							low = low + 0.4 * windowRect.height();
						}

						if (low > windowRect.bottom() - 0.1 * windowRect.height()) {
							low = low - 0.4 * windowRect.height();
						}

						windowRect.y(low - 0.5 * windowRect.height());
					}

				}

			}

			this.syncLink().windowNotify(this.seriesViewer(), windowRect);
		}

		return index >= 0;
	}

	, 
	validateSeries: function (viewportRect, windowRect, view) {
		var isValid = $.ig.FinancialSeries.prototype.validateSeries.call(this, viewportRect, windowRect, view);
		if (this.openColumn() == null || this.closeColumn() == null || this.highColumn() == null || this.lowColumn() == null) {
			isValid = false;
		}

		return isValid;
	}

	, 
	convertToSingle: function (value) {
		return value;
	}

	, 
	prepareFrame: function (frame, view) {
		var $self = this;
		$.ig.FinancialSeries.prototype.prepareFrame.call($self, frame, view);
		var windowRect = view.windowRect();
		var viewportRect = view.viewport();
		var xaxis = $self.xAxis();
		var yaxis = $self.yAxis();
		var xParams = new $.ig.ScalerParams(windowRect, viewportRect, xaxis.isInverted());
		var yParams = new $.ig.ScalerParams(windowRect, viewportRect, yaxis.isInverted());
		frame._buckets.clear();
		frame._markers.clear();
		frame._trend.clear();
		var offset = 0;
		var sortingXAxis = $.ig.util.cast($.ig.ISortingAxis.prototype.$type, $self.xAxis());
		if (sortingXAxis != null && sortingXAxis.sortedIndices().count() != $self.fastItemsSource().count()) {
			return;
		}

		offset = $self.getOffset(windowRect, viewportRect);
		var priceSeriesView = $.ig.util.cast($.ig.FinancialPriceSeriesView.prototype.$type, view);
		if ($self.trendLineType() != $.ig.TrendLineType.prototype.none) {
			var typical = new Array($self.fastItemsSource().count());
			var typicalIndex = 0;
			var en = $self.typicalColumn().getEnumerator();
			while (en.moveNext()) {
				var typicalPrice = en.current();
				typical[typicalIndex] = typicalPrice;
				typicalIndex++;
			}

			$self.financialPriceView().trendLineManager().prepareLine(frame._trend, $self.trendLineType(), typical, $self.trendLinePeriod(), function (x) { return $self.xAxis().getScaledValue(x, xParams); }, function (y) { return $self.yAxis().getScaledValue(y, yParams); }, (function () { var $ret = new $.ig.TrendResolutionParams();
			$ret.bucketSize(view.bucketCalculator().bucketSize());
			$ret.firstBucket(view.bucketCalculator().firstBucket());
			$ret.lastBucket(view.bucketCalculator().lastBucket());
			$ret.offset(offset);
			$ret.resolution($self.resolution());
			$ret.viewport(viewportRect); return $ret;}()));
		}

		var singlePixelSpan = $self.convertToSingle($self.xAxis().getUnscaledValue(2, xParams) - $self.xAxis().getUnscaledValue(1, xParams));
		for (var i = view.bucketCalculator().firstBucket(); i <= view.bucketCalculator().lastBucket(); ++i) {
			var bucket;
			if (sortingXAxis == null) {
				bucket = view.bucketCalculator().getBucket(i);

			} else {
				var index = sortingXAxis.sortedIndices().__inner[i];
				var bucketX = sortingXAxis.getUnscaledValueAt(index);
				var bucketOpen = $self.convertToSingle($self.openColumn().item(index));
				var bucketHigh = $self.convertToSingle($self.highColumn().item(index));
				var bucketLow = $self.convertToSingle($self.lowColumn().item(index));
				var bucketClose = $self.convertToSingle($self.closeColumn().item(index));
				var currentOpen = bucketOpen;
				var currentHigh = bucketHigh;
				var currentLow = bucketLow;
				var currentClose = bucketClose;
				var currentX = bucketX;
				while (i < view.bucketCalculator().lastBucket()) {
					index = sortingXAxis.sortedIndices().__inner[i + 1];
					currentX = sortingXAxis.getUnscaledValueAt(index);
					if (currentX - bucketX > singlePixelSpan) {
						break;
					}

					i++;
					currentHigh = Math.max(bucketHigh, $self.convertToSingle($self.highColumn().item(index)));
					currentLow = Math.min(bucketLow, $self.convertToSingle($self.lowColumn().item(index)));
					currentClose = $self.convertToSingle($self.closeColumn().item(index));

				}
				var xVal = NaN;
				if (!$.ig.util.isNaN(bucketX)) {
					xVal = $self.xAxis().getScaledValue(bucketX, xParams);
				}

				bucket = (function () { var $ret = new Array();
				$ret.add($self.convertToSingle(xVal));
				$ret.add(currentOpen);
				$ret.add(currentHigh);
				$ret.add(currentLow);
				$ret.add(currentClose);return $ret;}());
			}

			if (!isNaN(bucket[0])) {
				if ($self.xAxis() != null && $.ig.util.cast($.ig.ISortingAxis.prototype.$type, $self.xAxis()) !== null) {
					bucket[0] = (bucket[0] + offset);

				} else {
					bucket[0] = (xaxis.getScaledValue(bucket[0], xParams) + offset);
				}

				bucket[1] = yaxis.getScaledValue(bucket[1], yParams);
				bucket[2] = yaxis.getScaledValue(bucket[2], yParams);
				bucket[3] = yaxis.getScaledValue(bucket[3], yParams);
				bucket[4] = yaxis.getScaledValue(bucket[4], yParams);
				frame._buckets.add(bucket);
			}

		}

		return;
	}

	, 
	clearRendering: function (wipeClean, view) {
		$.ig.FinancialSeries.prototype.clearRendering.call(this, wipeClean, view);
		var financialPriceView = $.ig.util.cast($.ig.FinancialPriceSeriesView.prototype.$type, view);
		financialPriceView.clearPriceSymbols();
		if (wipeClean) {
			financialPriceView.shapes().count(0);
		}

		if (financialPriceView.trendLineManager() != null) {
			financialPriceView.trendLineManager().clearPoints();
		}

	}

	, 
	hasIndividualElements: function () {

			return true;
	}

	, 
	renderFrame: function (frame, view) {
		$.ig.FinancialSeries.prototype.renderFrame.call(this, frame, view);
		if (this.xAxis() == null || this.yAxis() == null) {
			return;
		}

		var isDirty = false;
		if (view.checkFrameDirty(frame)) {
			isDirty = true;
			view.updateFrameVersion(frame);
		}

		this._renderManager.initCategoryRenderSettings(this, this.shouldOverrideCategoryStyle(), this.xAxis(), this.getCategoryItems.runOn(this), this.getBucketSize(view), this.getFirstBucket(view));
		var areStylesOverriden = false;
		var args = this._renderManager.categoryOverrideArgs();
		if (args != null) {
			areStylesOverriden = true;
		}

		var priceSeriesView = $.ig.util.cast($.ig.FinancialPriceSeriesView.prototype.$type, view);
		priceSeriesView.clearGroupedPriceSymbols();
		priceSeriesView.separateMode(false);
		if (priceSeriesView.trendLineManager() != null) {
			priceSeriesView.trendLineManager().clearPoints();
		}

		if (this.trendLineType() != $.ig.TrendLineType.prototype.none) {
			priceSeriesView.trendLineManager().rasterizeTrendLine(frame._trend);
		}

		if (areStylesOverriden) {
			this.renderSeparate(frame, view, isDirty);

		} else {
			priceSeriesView.shapes().count(0);
			this.renderCombinedGrouping(frame, view);
		}

	}

	, 
	renderSeparate: function (frame, view, isDirty) {
		var $self = this;
		var displayType = $self.displayType();
		var width = $self.xAxis().getGroupSize(view.windowRect(), view.viewport()) / 2;
		width = Math.max(width, $.ig.FinancialPriceSeries.prototype._mIN_WIDTH);
		var priceView = $.ig.util.cast($.ig.FinancialPriceSeriesView.prototype.$type, view);
		priceView.separateMode(true);
		var buckets = frame._buckets;
		var count = 0;
		var valueCount = $self.fastItemsSource().count();
		var xAxis = $self.xAxis();
		var xParams = new $.ig.ScalerParams($self.view().windowRect(), $self.view().viewport(), xAxis.isInverted());
		var actualBrush = $self.actualBrush();
		var negativeBrush = $self.negativeBrush();
		if (negativeBrush == null) {
			negativeBrush = actualBrush;
		}

		for (var i = 0; i < buckets.count(); ++i) {
			var left = buckets.__inner[i][0] - width;
			var center = buckets.__inner[i][0];
			var right = buckets.__inner[i][0] + width;
			var open = buckets.__inner[i][1];
			var high = buckets.__inner[i][2];
			var low = buckets.__inner[i][3];
			var close = buckets.__inner[i][4];
			if ($.ig.util.isNaN(open) || $.ig.util.isNaN(high) || $.ig.util.isNaN(low) || $.ig.util.isNaN(close)) {
				continue;
			}

			var p = priceView.shapes().item(count);
			count++;
			var negative = open < close;
			var pg = new $.ig.PathGeometry();
			if (isDirty) {
				switch (displayType) {
					case $.ig.PriceDisplayType.prototype.candlestick:
						if (negative) {
							var tmp = open;
							open = close;
							close = tmp;
						}

						var pf1 = new $.ig.PathFigure();
						pf1.__startPoint = {__x: center, __y: low, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
						pf1.__segments.add((function () { var $ret = new $.ig.LineSegment(1);
						$ret.point({__x: center, __y: open, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}); return $ret;}()));
						var pf2 = new $.ig.PathFigure();
						pf2.__startPoint = {__x: left, __y: close, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
						pf2.__segments.add((function () { var $ret = new $.ig.LineSegment(1);
						$ret.point({__x: right, __y: close, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}); return $ret;}()));
						pf2.__segments.add((function () { var $ret = new $.ig.LineSegment(1);
						$ret.point({__x: right, __y: open, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}); return $ret;}()));
						pf2.__segments.add((function () { var $ret = new $.ig.LineSegment(1);
						$ret.point({__x: left, __y: open, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}); return $ret;}()));
						pf2.__segments.add((function () { var $ret = new $.ig.LineSegment(1);
						$ret.point({__x: left, __y: close, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}); return $ret;}()));
						var pf3 = new $.ig.PathFigure();
						pf3.__startPoint = {__x: center, __y: close, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
						pf3.__segments.add((function () { var $ret = new $.ig.LineSegment(1);
						$ret.point({__x: center, __y: high, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}); return $ret;}()));
						pg.figures().add(pf1);
						pg.figures().add(pf2);
						pg.figures().add(pf3);
						break;
					case $.ig.PriceDisplayType.prototype.oHLC:
						var pf4 = new $.ig.PathFigure();
						pf4.__startPoint = {__x: left, __y: open, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
						pf4.__segments.add((function () { var $ret = new $.ig.LineSegment(1);
						$ret.point({__x: center, __y: open, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}); return $ret;}()));
						var pf5 = new $.ig.PathFigure();
						pf5.__startPoint = {__x: center, __y: low, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
						pf5.__segments.add((function () { var $ret = new $.ig.LineSegment(1);
						$ret.point({__x: center, __y: high, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}); return $ret;}()));
						var pf6 = new $.ig.PathFigure();
						pf6.__startPoint = {__x: center, __y: close, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName};
						pf6.__segments.add((function () { var $ret = new $.ig.LineSegment(1);
						$ret.point({__x: right, __y: close, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}); return $ret;}()));
						pg.figures().add(pf4);
						pg.figures().add(pf5);
						pg.figures().add(pf6);
						break;
				}

			}

			if (negative) {
				$self._renderManager._initialRenderFill = negativeBrush;
				$self._renderManager._actualRenderFill = negativeBrush;
				$self._renderManager._actualNegativeShape = true;

			} else {
				$self._renderManager._initialRenderFill = actualBrush;
				$self._renderManager._actualRenderFill = actualBrush;
				$self._renderManager._actualNegativeShape = false;
			}

			$self.performCategoryStyleOverride(buckets, i, valueCount, xAxis, xParams, view.isThumbnailView());
			if (displayType == $.ig.PriceDisplayType.prototype.oHLC) {
				$self._renderManager.setCategoryShapeAppearance(p, true, false, false, false);

			} else {
				$self._renderManager.setCategoryShapeAppearance(p, false, false, false, false);
			}

			if (isDirty) {
				p.data(pg);
			}

		}

		priceView.shapes().count(count);
		priceView.frameRendered();
	}

	, 
	renderCombinedGrouping: function (frame, view) {
		var $self = this;
		var displayType = $self.displayType();
		var width = $self.xAxis().getGroupSize(view.windowRect(), view.viewport()) / 2;
		width = Math.max(width, $.ig.FinancialPriceSeries.prototype._mIN_WIDTH);
		var priceView = $.ig.util.cast($.ig.FinancialPriceSeriesView.prototype.$type, view);
		var positiveGroup = priceView.getPositiveGroup();
		var negativeGroup = priceView.getNegativeGroup();
		var buckets = frame._buckets;
		for (var i = 0; i < buckets.count(); ++i) {
			var left = buckets.__inner[i][0] - width;
			var center = buckets.__inner[i][0];
			var right = buckets.__inner[i][0] + width;
			var open = buckets.__inner[i][1];
			var high = buckets.__inner[i][2];
			var low = buckets.__inner[i][3];
			var close = buckets.__inner[i][4];
			if ($.ig.util.isNaN(open) || $.ig.util.isNaN(high) || $.ig.util.isNaN(low) || $.ig.util.isNaN(close)) {
				continue;
			}

			var negative = open < close;
			var group = negative ? negativeGroup : positiveGroup;
			switch (displayType) {
				case $.ig.PriceDisplayType.prototype.candlestick:
					if (negative) {
						var tmp = open;
						open = close;
						close = tmp;
					}

					group.children().add((function () { var $ret = new $.ig.LineGeometry();
					$ret.startPoint({__x: center, __y: low, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
					$ret.endPoint({__x: center, __y: open, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}); return $ret;}()));
					group.children().add((function () { var $ret = new $.ig.RectangleGeometry();
					$ret.rect(new $.ig.Rect(0, left, close, right - left, open - close)); return $ret;}()));
					group.children().add((function () { var $ret = new $.ig.LineGeometry();
					$ret.startPoint({__x: center, __y: close, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
					$ret.endPoint({__x: center, __y: high, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}); return $ret;}()));
					break;
				case $.ig.PriceDisplayType.prototype.oHLC:
					group.children().add((function () { var $ret = new $.ig.LineGeometry();
					$ret.startPoint({__x: left, __y: open, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
					$ret.endPoint({__x: center, __y: open, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}); return $ret;}()));
					group.children().add((function () { var $ret = new $.ig.LineGeometry();
					$ret.startPoint({__x: center, __y: low, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
					$ret.endPoint({__x: center, __y: high, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}); return $ret;}()));
					group.children().add((function () { var $ret = new $.ig.LineGeometry();
					$ret.startPoint({__x: center, __y: close, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName});
					$ret.endPoint({__x: right, __y: close, $type: $.ig.Point.prototype.$type, getType: $.ig.Object.prototype.getType, getGetHashCode: $.ig.Object.prototype.getGetHashCode, typeName: $.ig.Object.prototype.typeName}); return $ret;}()));
					break;
			}

		}

	}

	, 
	item: function (sender, point) {
		if (sender == this.financialPriceView().trendLineManager().trendPolyline()) {
			return null;
		}

		return $.ig.FinancialSeries.prototype.item.call(this, sender, point);
	}

	, 
	updateIndexedProperties: function () {
		$.ig.FinancialSeries.prototype.updateIndexedProperties.call(this);
		if (this.index() < 0) {
			return;
		}

		this.financialPriceView().updateTrendlineBrush();
	}

	, 
	exportVisualDataOverride: function (svd) {
		$.ig.FinancialSeries.prototype.exportVisualDataOverride.call(this, svd);
		var trendShape = new $.ig.PolyLineVisualData(1, "trendLine", this.financialPriceView().trendLineManager().trendPolyline());
		trendShape.tags().add("Trend");
		svd.shapes().add(trendShape);
	}
	, 
	$type: new $.ig.Type('FinancialPriceSeries', $.ig.FinancialSeries.prototype.$type)
}, true);

$.ig.util.defType('FinancialPriceBucketCalculator', 'FinancialBucketCalculator', {
	init: function (view) {



		$.ig.FinancialBucketCalculator.prototype.init.call(this, view);
	}

	, 
	getBucket: function (index) {
		var $self = this;
		var i0 = index * $self.bucketSize();
		var i1 = Math.min(i0 + $self.bucketSize() - 1, $self.view().financialModel().fastItemsSource().count() - 1);
		if (i0 <= i1 && i0 >= 0 && i1 >= 0) {
			var open = $self.view().financialModel().openColumn().item(i0);
			var high = Number.NEGATIVE_INFINITY;
			var low = Number.POSITIVE_INFINITY;
			var close = $self.view().financialModel().closeColumn().item(i1);
			for (var i = i0; i <= i1; ++i) {
				high = Math.max(high, $self.view().financialModel().highColumn().item(i));
				low = Math.min(low, $self.view().financialModel().lowColumn().item(i));
			}

			low = Math.min(open, low);
			high = Math.max(close, high);
			return (function () { var $ret = new Array();
			$ret.add((0.5 * (i0 + i1)));
			$ret.add(open);
			$ret.add(high);
			$ret.add(low);
			$ret.add(close);return $ret;}());
		}

		return (function () { var $ret = new Array();
		$ret.add(NaN);
		$ret.add(NaN);
		$ret.add(NaN);
		$ret.add(NaN);
		$ret.add(NaN);return $ret;}());
	}
	, 
	$type: new $.ig.Type('FinancialPriceBucketCalculator', $.ig.FinancialBucketCalculator.prototype.$type)
}, true);

$.ig.util.defType('FinancialPriceSeriesView', 'FinancialSeriesView', {

	_financialPriceModel: null,
	financialPriceModel: function (value) {
		if (arguments.length === 1) {
			this._financialPriceModel = value;
			return value;
		} else {
			return this._financialPriceModel;
		}
	}
	, 
	init: function (model) {


		this._positivePath = (function () { var $ret = new $.ig.Path();
		$ret.data(new $.ig.GeometryGroup()); return $ret;}());
		this._negativePath = (function () { var $ret = new $.ig.Path();
		$ret.data(new $.ig.GeometryGroup()); return $ret;}());
		this.__hitItem = new $.ig.Path();

		var $self = this;
		$.ig.FinancialSeriesView.prototype.init.call(this, model);
			this.financialPriceModel(model);
			this.visibleShapes(new $.ig.List$1($.ig.Path.prototype.$type, 0));
			this.trendLineManager(new $.ig.CategoryTrendLineManager());
			this.shapes((function () { var $ret = new $.ig.Pool$1($.ig.Path.prototype.$type);
			$ret.create($self.shapeCreate.runOn($self));
			$ret.activate($self.shapeActivate.runOn($self));
			$ret.disactivate($self.shapeDisactivate.runOn($self));
			$ret.destroy($self.shapeDestroy.runOn($self)); return $ret;}()));
	}

	, 
	_shapes: null,
	shapes: function (value) {
		if (arguments.length === 1) {
			this._shapes = value;
			return value;
		} else {
			return this._shapes;
		}
	}

	, 
	shapeCreate: function () {
		var shape = new $.ig.Path();
		this.visibleShapes().add(shape);
		shape.__visibility = $.ig.Visibility.prototype.collapsed;
		return shape;
	}

	, 
	_visibleShapes: null,
	visibleShapes: function (value) {
		if (arguments.length === 1) {
			this._visibleShapes = value;
			return value;
		} else {
			return this._visibleShapes;
		}
	}

	, 
	shapeActivate: function (shape) {
		shape.__visibility = $.ig.Visibility.prototype.visible;
	}

	, 
	shapeDisactivate: function (shape) {
		shape.__visibility = $.ig.Visibility.prototype.collapsed;
	}

	, 
	shapeDestroy: function (shape) {
		this.visibleShapes().remove(shape);
	}

	, 
	createBucketCalculator: function () {
		return new $.ig.FinancialPriceBucketCalculator(this);
	}

	, 
	onInit: function () {
		var $self = this;
		$.ig.FinancialSeriesView.prototype.onInit.call($self);
		if (!$self.isThumbnailView()) {
			$self.financialModel().negativeBrush((function () { var $ret = new $.ig.Brush();
			$ret.fill("#415460"); return $ret;}()));
			$self.financialModel().resolution(2);
			$self.financialModel().thickness(1);
			$self.financialModel().outline((function () { var $ret = new $.ig.Brush();
			$ret.fill("#222222"); return $ret;}()));
		}

	}
	, 
	_positivePath: null
	, 
	_negativePath: null

	, 
	_trendLineManager: null,
	trendLineManager: function (value) {
		if (arguments.length === 1) {
			this._trendLineManager = value;
			return value;
		} else {
			return this._trendLineManager;
		}
	}

	, 
	updatePathBrushes: function () {
		if (this.financialPriceModel().displayType() == $.ig.PriceDisplayType.prototype.oHLC) {
			this._positivePath.__stroke = this.model().actualBrush();

		} else {
			this._positivePath.__stroke = this.model().actualOutline();
		}

		if (this.financialPriceModel().displayType() == $.ig.PriceDisplayType.prototype.oHLC) {
			this._negativePath.__stroke = this.financialModel().negativeBrush();

		} else {
			this._negativePath.__stroke = this.model().actualOutline();
		}

	}

	, 
	clearPriceSymbols: function () {
		this.makeDirty();
		this.shapes().count(0);
		this.clearGroupedPriceSymbols();
	}

	, 
	clearGroupedPriceSymbols: function () {
		var positiveGroup = $.ig.util.cast($.ig.GeometryGroup.prototype.$type, this._positivePath.data());
		var negativeGroup = $.ig.util.cast($.ig.GeometryGroup.prototype.$type, this._negativePath.data());
		$.ig.Extensions.prototype.reset(positiveGroup);
		$.ig.Extensions.prototype.reset(negativeGroup);
	}

	, 
	getPositiveGroup: function () {
		this.makeDirty();
		return $.ig.util.cast($.ig.GeometryGroup.prototype.$type, this._positivePath.data());
	}

	, 
	getNegativeGroup: function () {
		this.makeDirty();
		return $.ig.util.cast($.ig.GeometryGroup.prototype.$type, this._negativePath.data());
	}

	, 
	updateTrendlineBrush: function () {
		this.financialPriceModel().actualTrendLineBrush(null);
		if (this.financialPriceModel().trendLineBrush() != null) {
			this.financialPriceModel().actualTrendLineBrush(this.financialPriceModel().trendLineBrush());

		} else {
			this.financialPriceModel().actualTrendLineBrush(this.financialPriceModel().actualBrush());
		}

	}

	, 
	setupAppearanceOverride: function () {
		$.ig.FinancialSeriesView.prototype.setupAppearanceOverride.call(this);
		this._positivePath.strokeThickness(this.model().thickness());
		this._positivePath.strokeDashArray(this.model().dashArray());
		this._positivePath.strokeDashCap(this.model().dashCap());
		if (this.financialPriceModel().displayType() == $.ig.PriceDisplayType.prototype.oHLC) {
			this._positivePath.__stroke = this.model().actualBrush();

		} else {
			this._positivePath.__stroke = this.model().actualOutline();
			this._positivePath.__fill = this.model().actualBrush();
		}

		this._negativePath.strokeThickness(this.model().thickness());
		this._negativePath.strokeDashArray(this.model().dashArray());
		this._negativePath.strokeDashCap(this.model().dashCap());
		if (this.financialPriceModel().displayType() == $.ig.PriceDisplayType.prototype.oHLC) {
			this._negativePath.__stroke = this.financialModel().negativeBrush();

		} else {
			this._negativePath.__stroke = this.model().actualOutline();
			this._negativePath.__fill = this.financialModel().negativeBrush();
		}

	}

	, 
	setupHitAppearanceOverride: function () {
		$.ig.FinancialSeriesView.prototype.setupHitAppearanceOverride.call(this);
		var hitBrush = this.getHitBrush();
		this._positivePath.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
		if (this.financialPriceModel().displayType() == $.ig.PriceDisplayType.prototype.oHLC) {
			this._positivePath.__stroke = hitBrush;

		} else {
			this._positivePath.__stroke = hitBrush;
			this._positivePath.__fill = hitBrush;
		}

		this._negativePath.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
		if (this.financialPriceModel().displayType() == $.ig.PriceDisplayType.prototype.oHLC) {
			this._negativePath.__stroke = hitBrush;

		} else {
			this._negativePath.__stroke = hitBrush;
			this._negativePath.__fill = hitBrush;
		}

	}

	, 
	getItem: function (index) {
		return this.visibleShapes().__inner[index];
	}
	, 
	__hitItem: null

	, 
	getHitItem: function (index) {
		var item = this.visibleShapes().__inner[index];
		this.__hitItem.__visibility = item.__visibility;
		this.__hitItem.data(item.data());
		var hitBrush = this.getHitBrush1(index);
		this.__hitItem.__fill = hitBrush;
		this.__hitItem.__stroke = hitBrush;
		this.__hitItem.strokeThickness(this.model().thickness() + $.ig.SeriesView.prototype.hIT_THICKNESS_AUGMENT);
		return this.__hitItem;
	}

	, 
	renderOverride: function (context, isHitContext) {
		$.ig.FinancialSeriesView.prototype.renderOverride.call(this, context, isHitContext);
		if (context.shouldRender()) {
			if (this.separateMode()) {
				for (var i = 0; i < this.visibleShapes().count(); i++) {
					var shape = this.getCurrentItem(i, isHitContext);
					if (shape.__visibility == $.ig.Visibility.prototype.visible) {
						context.renderPath(shape);
					}

				}


			} else {
				context.renderPath(this._positivePath);
				context.renderPath(this._negativePath);
			}

		}

	}

	, 
	renderMarkersOverride: function (context, isHitContext) {
		if (context.shouldRender()) {
			if (this.financialPriceModel().trendLineType() != $.ig.TrendLineType.prototype.none && !isHitContext) {
				var polyline = this.trendLineManager().trendPolyline();
				polyline.strokeThickness(this.financialPriceModel().trendLineThickness());
				polyline.__stroke = this.financialPriceModel().actualTrendLineBrush();
				polyline.strokeDashArray(this.financialPriceModel().trendLineDashArray());
				polyline.strokeDashCap(this.financialPriceModel().trendLineDashCap());
				context.renderPolyline(polyline);
			}

		}

		$.ig.FinancialSeriesView.prototype.renderMarkersOverride.call(this, context, isHitContext);
	}

	, 
	exportViewShapes: function (svd) {
		$.ig.FinancialSeriesView.prototype.exportViewShapes.call(this, svd);
		var positivePathShape = new $.ig.PathVisualData(1, "positivePathShape", this._positivePath);
		positivePathShape.tags().add("Positive");
		positivePathShape.tags().add("Main");
		var negativePathShape = new $.ig.PathVisualData(1, "negativePathShape", this._negativePath);
		negativePathShape.tags().add("Negative");
		svd.shapes().add(positivePathShape);
		svd.shapes().add(negativePathShape);
	}

	, 
	frameRendered: function () {
		this.makeDirty();
	}

	, 
	_separateMode: false,
	separateMode: function (value) {
		if (arguments.length === 1) {
			this._separateMode = value;
			return value;
		} else {
			return this._separateMode;
		}
	}

	, 
	selectTrendlineManager: function () {
		this.trendLineManager($.ig.CategoryTrendLineManagerBase.prototype.selectManager(this.trendLineManager(), this.financialModel().xAxis(), this.model().rootCanvas(), this.financialModel()));
	}
	, 
	$type: new $.ig.Type('FinancialPriceSeriesView', $.ig.FinancialSeriesView.prototype.$type)
}, true);

$.ig.util.defType('FinancialValueList', 'Object', {
	__openColumn: null
	, 
	__highColumn: null
	, 
	__closeColumn: null
	, 
	__lowColumn: null
	, 
	__volumeColumn: null
	, 
	init: function (openColumn, highColumn, lowColumn, closeColumn, volumeColumn) {



		$.ig.Object.prototype.init.call(this);
			this.__openColumn = openColumn;
			this.__highColumn = highColumn;
			this.__closeColumn = closeColumn;
			this.__lowColumn = lowColumn;
			this.__volumeColumn = volumeColumn;
	}

	, 
	indexOf: function (item) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	insert: function (index, item) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	removeAt: function (index) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	item: function (index, value) {
		if (arguments.length === 2) {

			throw new $.ig.NotImplementedException(0);
			return value;
		} else {

			var open = NaN;
			var high = NaN;
			var low = NaN;
			var close = NaN;
			var volume = NaN;
			if (this.__openColumn != null && index >= 0 && index < this.__openColumn.count()) {
				open = this.__openColumn.item(index);
			}

			if (this.__highColumn != null && index >= 0 && index < this.__highColumn.count()) {
				high = this.__highColumn.item(index);
			}

			if (this.__lowColumn != null && index >= 0 && index < this.__lowColumn.count()) {
				low = this.__lowColumn.item(index);
			}

			if (this.__closeColumn != null && index >= 0 && index < this.__closeColumn.count()) {
				close = this.__closeColumn.item(index);
			}

			if (this.__volumeColumn != null && index >= 0 && index < this.__volumeColumn.count()) {
				volume = this.__volumeColumn.item(index);
			}

			var openIsNaN = $.ig.util.isNaN(open);
			var highIsNaN = $.ig.util.isNaN(high);
			var lowIsNaN = $.ig.util.isNaN(low);
			var closeIsNaN = $.ig.util.isNaN(close);
			var volumeIsNaN = $.ig.util.isNaN(volume);
			if (!highIsNaN && !lowIsNaN && !closeIsNaN) {
				return (high + low + close) / 3;
			}

			if (!highIsNaN && !lowIsNaN) {
				return (high + low) / 2;
			}

			if (!openIsNaN && !closeIsNaN) {
				return (open + close) / 2;
			}

			if (!openIsNaN) {
				return open;
			}

			if (!highIsNaN) {
				return high;
			}

			if (!lowIsNaN) {
				return low;
			}

			if (!closeIsNaN) {
				return close;
			}

			return NaN;
		}
	}

	, 
	add: function (item) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	clear: function () {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	contains: function (item) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	copyTo: function (array, arrayIndex) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	count: function () {

			var openCount = 0;
			var highCount = 0;
			var lowCount = 0;
			var closeCount = 0;
			var volumeCount = 0;
			if (this.__openColumn != null) {
				openCount = this.__openColumn.count();
			}

			if (this.__highColumn != null) {
				highCount = this.__highColumn.count();
			}

			if (this.__lowColumn != null) {
				lowCount = this.__lowColumn.count();
			}

			if (this.__closeColumn != null) {
				closeCount = this.__closeColumn.count();
			}

			if (this.__volumeColumn != null) {
				volumeCount = this.__volumeColumn.count();
			}

			var count = 0;
			count = Math.max(count, openCount);
			count = Math.max(count, highCount);
			count = Math.max(count, lowCount);
			count = Math.max(count, closeCount);
			count = Math.max(count, volumeCount);
			return count;
	}

	, 
	isReadOnly: function () {

			return true;
	}

	, 
	remove: function (item) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	getEnumerator: function () {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	getEnumerator: function () {
		throw new $.ig.NotImplementedException(0);
	}
	, 
	$type: new $.ig.Type('FinancialValueList', $.ig.Object.prototype.$type, [$.ig.IList$1.prototype.$type.specialize(Number)])
}, true);

$.ig.util.defType('FinancialCalculationDataSource', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	_openColumn: null,
	openColumn: function (value) {
		if (arguments.length === 1) {
			this._openColumn = value;
			return value;
		} else {
			return this._openColumn;
		}
	}

	, 
	_closeColumn: null,
	closeColumn: function (value) {
		if (arguments.length === 1) {
			this._closeColumn = value;
			return value;
		} else {
			return this._closeColumn;
		}
	}

	, 
	_highColumn: null,
	highColumn: function (value) {
		if (arguments.length === 1) {
			this._highColumn = value;
			return value;
		} else {
			return this._highColumn;
		}
	}

	, 
	_lowColumn: null,
	lowColumn: function (value) {
		if (arguments.length === 1) {
			this._lowColumn = value;
			return value;
		} else {
			return this._lowColumn;
		}
	}

	, 
	_volumeColumn: null,
	volumeColumn: function (value) {
		if (arguments.length === 1) {
			this._volumeColumn = value;
			return value;
		} else {
			return this._volumeColumn;
		}
	}

	, 
	_indicatorColumn: null,
	indicatorColumn: function (value) {
		if (arguments.length === 1) {
			this._indicatorColumn = value;
			return value;
		} else {
			return this._indicatorColumn;
		}
	}

	, 
	_typicalColumn: null,
	typicalColumn: function (value) {
		if (arguments.length === 1) {
			this._typicalColumn = value;
			return value;
		} else {
			return this._typicalColumn;
		}
	}

	, 
	_trueRange: null,
	trueRange: function (value) {
		if (arguments.length === 1) {
			this._trueRange = value;
			return value;
		} else {
			return this._trueRange;
		}
	}

	, 
	_trueLow: null,
	trueLow: function (value) {
		if (arguments.length === 1) {
			this._trueLow = value;
			return value;
		} else {
			return this._trueLow;
		}
	}

	, 
	_period: 0,
	period: function (value) {
		if (arguments.length === 1) {
			this._period = value;
			return value;
		} else {
			return this._period;
		}
	}

	, 
	_shortPeriod: 0,
	shortPeriod: function (value) {
		if (arguments.length === 1) {
			this._shortPeriod = value;
			return value;
		} else {
			return this._shortPeriod;
		}
	}

	, 
	_longPeriod: 0,
	longPeriod: function (value) {
		if (arguments.length === 1) {
			this._longPeriod = value;
			return value;
		} else {
			return this._longPeriod;
		}
	}

	, 
	_count: 0,
	count: function (value) {
		if (arguments.length === 1) {
			this._count = value;
			return value;
		} else {
			return this._count;
		}
	}

	, 
	_calculateFrom: 0,
	calculateFrom: function (value) {
		if (arguments.length === 1) {
			this._calculateFrom = value;
			return value;
		} else {
			return this._calculateFrom;
		}
	}

	, 
	_calculateCount: 0,
	calculateCount: function (value) {
		if (arguments.length === 1) {
			this._calculateCount = value;
			return value;
		} else {
			return this._calculateCount;
		}
	}

	, 
	_multiplier: 0,
	multiplier: function (value) {
		if (arguments.length === 1) {
			this._multiplier = value;
			return value;
		} else {
			return this._multiplier;
		}
	}

	, 
	_minimumValue: 0,
	minimumValue: function (value) {
		if (arguments.length === 1) {
			this._minimumValue = value;
			return value;
		} else {
			return this._minimumValue;
		}
	}

	, 
	_maximumValue: 0,
	maximumValue: function (value) {
		if (arguments.length === 1) {
			this._maximumValue = value;
			return value;
		} else {
			return this._maximumValue;
		}
	}

	, 
	_specifiesRange: false,
	specifiesRange: function (value) {
		if (arguments.length === 1) {
			this._specifiesRange = value;
			return value;
		} else {
			return this._specifiesRange;
		}
	}
	, 
	$type: new $.ig.Type('FinancialCalculationDataSource', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('FinancialCalculationSupportingCalculations', 'Object', {
	init: function () {


		$.ig.Object.prototype.init.call(this);

	}
	, 
	_eMA: null,
	eMA: function (value) {
		if (arguments.length === 1) {
			this._eMA = value;
			return value;
		} else {
			return this._eMA;
		}
	}

	, 
	_sMA: null,
	sMA: function (value) {
		if (arguments.length === 1) {
			this._sMA = value;
			return value;
		} else {
			return this._sMA;
		}
	}

	, 
	_sTDEV: null,
	sTDEV: function (value) {
		if (arguments.length === 1) {
			this._sTDEV = value;
			return value;
		} else {
			return this._sTDEV;
		}
	}

	, 
	_movingSum: null,
	movingSum: function (value) {
		if (arguments.length === 1) {
			this._movingSum = value;
			return value;
		} else {
			return this._movingSum;
		}
	}

	, 
	_shortVolumeOscillatorAverage: null,
	shortVolumeOscillatorAverage: function (value) {
		if (arguments.length === 1) {
			this._shortVolumeOscillatorAverage = value;
			return value;
		} else {
			return this._shortVolumeOscillatorAverage;
		}
	}

	, 
	_longVolumeOscillatorAverage: null,
	longVolumeOscillatorAverage: function (value) {
		if (arguments.length === 1) {
			this._longVolumeOscillatorAverage = value;
			return value;
		} else {
			return this._longVolumeOscillatorAverage;
		}
	}

	, 
	_shortPriceOscillatorAverage: null,
	shortPriceOscillatorAverage: function (value) {
		if (arguments.length === 1) {
			this._shortPriceOscillatorAverage = value;
			return value;
		} else {
			return this._shortPriceOscillatorAverage;
		}
	}

	, 
	_longPriceOscillatorAverage: null,
	longPriceOscillatorAverage: function (value) {
		if (arguments.length === 1) {
			this._longPriceOscillatorAverage = value;
			return value;
		} else {
			return this._longPriceOscillatorAverage;
		}
	}

	, 
	_toEnumerableRange: null,
	toEnumerableRange: function (value) {
		if (arguments.length === 1) {
			this._toEnumerableRange = value;
			return value;
		} else {
			return this._toEnumerableRange;
		}
	}

	, 
	_toEnumerable: null,
	toEnumerable: function (value) {
		if (arguments.length === 1) {
			this._toEnumerable = value;
			return value;
		} else {
			return this._toEnumerable;
		}
	}

	, 
	_makeSafe: null,
	makeSafe: function (value) {
		if (arguments.length === 1) {
			this._makeSafe = value;
			return value;
		} else {
			return this._makeSafe;
		}
	}
	, 
	$type: new $.ig.Type('FinancialCalculationSupportingCalculations', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('SupportingCalculation$1', 'Object', {
	$tCalculationStrategy: null, 
	init: function ($tCalculationStrategy, initNumber, strategy) {

		this.$tCalculationStrategy = $tCalculationStrategy;
		this.$type = this.$type.specialize(this.$tCalculationStrategy);

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.Object.prototype.init.call(this);
			this.__strategy = strategy;
			this.__basedOn = new $.ig.List$1(String, 0);
	}
	, 
	init1: function ($tCalculationStrategy, initNumber, strategy, basedOn) {

		this.$tCalculationStrategy = $tCalculationStrategy;
		this.$type = this.$type.specialize(this.$tCalculationStrategy);

		$.ig.Object.prototype.init.call(this);
			this.__strategy = strategy;
			this.__basedOn = new $.ig.List$1(String, 1, basedOn);
	}
	, 
	__strategy: null
	, 
	__basedOn: null

	, 
	strategy: function () {

			return this.__strategy;
	}

	, 
	basedOn: function () {

			return this.__basedOn;
	}
	, 
	$type: new $.ig.Type('SupportingCalculation$1', $.ig.Object.prototype.$type)
}, true);


$.ig.util.defType('ColumnSupportingCalculation', 'SupportingCalculation$1', {
	init: function (initNumber, strategy) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.SupportingCalculation$1.prototype.init.call(this, $.ig.SupportingCalculationStrategy.prototype.$type, 0, strategy);
	}
	, 
	init1: function (initNumber, strategy, basedOn) {


		$.ig.SupportingCalculation$1.prototype.init1.call(this, $.ig.SupportingCalculationStrategy.prototype.$type, 1, strategy, basedOn);
	}
	, 
	$type: new $.ig.Type('ColumnSupportingCalculation', $.ig.SupportingCalculation$1.prototype.$type.specialize($.ig.SupportingCalculationStrategy.prototype.$type))
}, true);


$.ig.util.defType('DataSourceSupportingCalculation', 'SupportingCalculation$1', {
	init: function (initNumber, strategy) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.SupportingCalculation$1.prototype.init.call(this, $.ig.ProvideColumnValuesStrategy.prototype.$type, 0, strategy);
	}
	, 
	init1: function (initNumber, strategy, basedOn) {


		$.ig.SupportingCalculation$1.prototype.init1.call(this, $.ig.ProvideColumnValuesStrategy.prototype.$type, 1, strategy, basedOn);
	}
	, 
	$type: new $.ig.Type('DataSourceSupportingCalculation', $.ig.SupportingCalculation$1.prototype.$type.specialize($.ig.ProvideColumnValuesStrategy.prototype.$type))
}, true);

$.ig.util.defType('CalculatedColumn', 'Object', {
	init: function (initNumber, valuesProvider, basedOn) {


		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		$.ig.Object.prototype.init.call(this);
			this.__valuesProvider = valuesProvider;
			this.__basedOn = new $.ig.List$1(String, 1, basedOn);
	}
	, 
	init1: function (initNumber, valuesProvider, basedOn) {


		$.ig.Object.prototype.init.call(this);
			this.__valuesProvider = valuesProvider;
			this.__basedOn = new $.ig.List$1(String, 1, basedOn);
	}
	, 
	__valuesProvider: null
	, 
	__basedOn: null

	, 
	basedOn: function () {

			return this.__basedOn;
	}

	, 
	getEnumerator: function () {
		return this.__valuesProvider.getEnumerator();
	}

	, 
	getEnumerator: function () {
		return this.__valuesProvider.getEnumerator();
	}
	, 
	$type: new $.ig.Type('CalculatedColumn', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(Number)])
}, true);


















































































































$.ig.util.defType('SafeEnumerable', 'Object', {
	__target: null
	, 
	init: function (target) {



		$.ig.Object.prototype.init.call(this);
			this.__target = target;
	}

	, 
	makeSafe1: function (value) {
		if (Number.isInfinity(value) || $.ig.util.isNaN(value)) {
			return 0;
		}

		return value;
	}

	, 
	makeSafe: function () {
		var d__ = new $.ig.SafeEnumerable___MakeSafe__IteratorClass(-2);
		d__.__4__this = this;
		return d__;
	}

	, 
	getEnumerator: function () {
		return this.makeSafe().getEnumerator();
	}
	, 
	$type: new $.ig.Type('SafeEnumerable', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(Number)])
}, true);

$.ig.util.defType('SafeReadOnlyDoubleCollection', 'Object', {
	__target: null

	, 
	makeSafe: function (value) {
		if (Number.isInfinity(value) || $.ig.util.isNaN(value)) {
			return 0;
		}

		return value;
	}
	, 
	init: function (target) {



		$.ig.Object.prototype.init.call(this);
			this.__target = new $.ig.ReadOnlyCollection$1(Number, 1, target);
	}

	, 
	indexOf: function (item) {
		return this.__target.indexOf(item);
	}

	, 
	insert: function (index, item) {
		($.ig.util.cast($.ig.IList$1.prototype.$type.specialize(Number), this.__target)).insert(index, item);
	}

	, 
	removeAt: function (index) {
		($.ig.util.cast($.ig.IList$1.prototype.$type.specialize(Number), this.__target)).removeAt(index);
	}

	, 
	item: function (index, value) {
		if (arguments.length === 2) {

			($.ig.util.cast($.ig.IList$1.prototype.$type.specialize(Number), this.__target)).item(index, value);
			return value;
		} else {

			return this.makeSafe(this.__target.item(index));
		}
	}

	, 
	add: function (item) {
		($.ig.util.cast($.ig.IList$1.prototype.$type.specialize(Number), this.__target)).add(item);
	}

	, 
	clear: function () {
		($.ig.util.cast($.ig.IList$1.prototype.$type.specialize(Number), this.__target)).clear();
	}

	, 
	contains: function (item) {
		return this.__target.contains(item);
	}

	, 
	copyTo: function (array, arrayIndex) {
		for (var i = arrayIndex; i < array.length; i++) {
			array[i] = this.item(i);
		}

	}

	, 
	count: function () {

			return this.__target.count();
	}

	, 
	isReadOnly: function () {

			return ($.ig.util.cast($.ig.IList$1.prototype.$type.specialize(Number), this.__target)).isReadOnly();
	}

	, 
	remove: function (item) {
		return ($.ig.util.cast($.ig.IList$1.prototype.$type.specialize(Number), this.__target)).remove(item);
	}

	, 
	getEnumerator: function () {
		return new $.ig.SafeEnumerable(this.__target).getEnumerator();
	}
	, 
	$type: new $.ig.Type('SafeReadOnlyDoubleCollection', $.ig.Object.prototype.$type, [$.ig.IList$1.prototype.$type.specialize(Number)])
}, true);

$.ig.util.defType('SafeSortedReadOnlyDoubleCollection', 'Object', {
	__target: null
	, 
	__sortedIndices: null

	, 
	makeSafe: function (value) {
		if (Number.isInfinity(value) || $.ig.util.isNaN(value)) {
			return 0;
		}

		return value;
	}
	, 
	init: function (target, sortedIndices) {



		$.ig.Object.prototype.init.call(this);
			this.__target = new $.ig.SafeReadOnlyDoubleCollection(target);
			this.__sortedIndices = sortedIndices;
	}

	, 
	indexOf: function (item) {
		var innerIndex = this.__target.indexOf(item);
		return this.__sortedIndices.indexOf(innerIndex);
	}

	, 
	insert: function (index, item) {
		($.ig.util.cast($.ig.IList$1.prototype.$type.specialize(Number), this.__target)).insert(index, item);
	}

	, 
	removeAt: function (index) {
		($.ig.util.cast($.ig.IList$1.prototype.$type.specialize(Number), this.__target)).removeAt(index);
	}

	, 
	item: function (index, value) {
		if (arguments.length === 2) {

			($.ig.util.cast($.ig.IList$1.prototype.$type.specialize(Number), this.__target)).item(index, value);
			return value;
		} else {

			var innerIndex = this.__sortedIndices.item(index);
			return this.makeSafe(this.__target.item(innerIndex));
		}
	}

	, 
	add: function (item) {
		($.ig.util.cast($.ig.IList$1.prototype.$type.specialize(Number), this.__target)).add(item);
	}

	, 
	clear: function () {
		($.ig.util.cast($.ig.IList$1.prototype.$type.specialize(Number), this.__target)).clear();
	}

	, 
	contains: function (item) {
		return this.__target.contains(item);
	}

	, 
	copyTo: function (array, arrayIndex) {
		for (var i = arrayIndex; i < array.length; i++) {
			array[i] = this.item(i);
		}

	}

	, 
	count: function () {

			return this.__target.count();
	}

	, 
	isReadOnly: function () {

			return ($.ig.util.cast($.ig.IList$1.prototype.$type.specialize(Number), this.__target)).isReadOnly();
	}

	, 
	remove: function (item) {
		return ($.ig.util.cast($.ig.IList$1.prototype.$type.specialize(Number), this.__target)).remove(item);
	}

	, 
	getEnumerator: function () {
		var d__ = new $.ig.SafeSortedReadOnlyDoubleCollection___GetEnumerator__IteratorClass(0);
		d__.__4__this = this;
		return d__;
	}
	, 
	$type: new $.ig.Type('SafeSortedReadOnlyDoubleCollection', $.ig.Object.prototype.$type, [$.ig.IList$1.prototype.$type.specialize(Number)])
}, true);

$.ig.util.defType('SortedListView$1', 'Object', {
	$t: null, 
	__sortedIndices: null
	, 
	__source: null
	, 
	init: function ($t, source, sortedIndices) {

		this.$t = $t;
		this.$type = this.$type.specialize(this.$t);

		this.__sortedIndices = null;
		this.__source = null;

		$.ig.Object.prototype.init.call(this);
			this.__sortedIndices = sortedIndices;
			this.__source = source;
	}

	, 
	add: function (value) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	clear: function () {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	contains: function (value) {
		return this.__source.contains(value);
	}

	, 
	indexOf: function (value) {
		return this.__sortedIndices.indexOf(this.__source.indexOf(value));
	}

	, 
	insert: function (index, value) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	isFixedSize: function () {

			return true;
	}

	, 
	isReadOnly: function () {

			return true;
	}

	, 
	remove: function (value) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	removeAt: function (index) {
		throw new $.ig.NotImplementedException(0);
	}

	, 
	item: function (index, value) {
		if (arguments.length === 2) {

			throw new $.ig.NotImplementedException(0);
			return value;
		} else {

			return this.__source.item(this.__sortedIndices.item(index));
		}
	}

	, 
	count: function () {

			return this.__source.count();
	}

	, 
	isSynchronized: function () {

			throw new $.ig.NotImplementedException(0);
	}

	, 
	syncRoot: function () {

			throw new $.ig.NotImplementedException(0);
	}

	, 
	getEnumerator: function () {
		var d__ = new $.ig.SortedListView___GetEnumerator__IteratorClass$1(this.$t, 0);
		d__.__4__this = this;
		return d__;
	}

	, 
	getEnumerator: function () {
		var d__ = new $.ig.SortedListView___GetEnumerator__IteratorClass1$1(this.$t, 0);
		d__.__4__this = this;
		return d__;
	}

	, 
	copyTo: function (array, arrayIndex) {
		throw new $.ig.NotImplementedException(0);
	}
	, 
	$type: new $.ig.Type('SortedListView$1', $.ig.Object.prototype.$type, [$.ig.IList$1.prototype.$type.specialize(0)])
}, true);
































$.ig.util.defType('AbsoluteVolumeOscillatorIndicatorStrategy', 'IndicatorCalculationStrategy', {
	init: function () {


		$.ig.IndicatorCalculationStrategy.prototype.init.call(this);

	}
	, 
	basedOn: function (dataSource, supportingCalculations) {
		var list = new $.ig.List$1(String, 0);
		list.addRange(supportingCalculations.shortVolumeOscillatorAverage().basedOn());
		list.addRange(supportingCalculations.longVolumeOscillatorAverage().basedOn());
		return list;
	}

	, 
	calculateIndicator: function (dataSource, supportingCalculations) {
		var shortEma = supportingCalculations.shortVolumeOscillatorAverage().strategy()(dataSource).getEnumerator();
		var longEma = supportingCalculations.longVolumeOscillatorAverage().strategy()(dataSource).getEnumerator();
		var indicatorColumn = dataSource.indicatorColumn();
		var i = 0;
		while (shortEma.moveNext() && longEma.moveNext()) {
			var pvo = shortEma.current() - longEma.current();
			indicatorColumn.item(i, supportingCalculations.makeSafe()(pvo));
			++i;

		}
		return true;
	}
	, 
	$type: new $.ig.Type('AbsoluteVolumeOscillatorIndicatorStrategy', $.ig.IndicatorCalculationStrategy.prototype.$type)
}, true);

$.ig.util.defType('AccumulationDistributionIndicatorStrategy', 'StreamingIndicatorCalculationStrategy', {
	init: function () {


		$.ig.StreamingIndicatorCalculationStrategy.prototype.init.call(this);

	}
	, 
	basedOn: function (dataSource, supportingCalculations) {
		var list = new $.ig.List$1(String, 0);
		list.add($.ig.FinancialSeries.prototype.closeColumnPropertyName);
		list.add($.ig.FinancialSeries.prototype.lowColumnPropertyName);
		list.add($.ig.FinancialSeries.prototype.highColumnPropertyName);
		list.add($.ig.FinancialSeries.prototype.volumeColumnPropertyName);
		return list;
	}

	, 
	calculateIndicator: function (dataSource, supportingCalculations) {
		var i = 0;
		var en = this.provideStream(dataSource, supportingCalculations).getEnumerator();
		while (en.moveNext()) {
			var value = en.current();
			dataSource.indicatorColumn().item(i, value);
			i++;
		}

		return true;
	}

	, 
	provideStream: function (dataSource, supportingCalculations) {
		var d__ = new $.ig.AccumulationDistributionIndicatorStrategy___ProvideStream__IteratorClass(-2);
		d__.__4__this = this;
		d__.__3__dataSource = dataSource;
		d__.__3__supportingCalculations = supportingCalculations;
		return d__;
	}
	, 
	$type: new $.ig.Type('AccumulationDistributionIndicatorStrategy', $.ig.StreamingIndicatorCalculationStrategy.prototype.$type)
}, true);

$.ig.util.defType('AverageDirectionalIndexIndicatorStrategy', 'IndicatorCalculationStrategy', {
	init: function () {


		$.ig.IndicatorCalculationStrategy.prototype.init.call(this);

	}
	, 
	basedOn: function (dataSource, supportingCalculations) {
		var list = new $.ig.List$1(String, 0);
		list.add($.ig.FinancialSeries.prototype.lowColumnPropertyName);
		list.add($.ig.FinancialSeries.prototype.highColumnPropertyName);
		list.addRange(dataSource.trueRange().basedOn());
		list.addRange(supportingCalculations.eMA().basedOn());
		return list;
	}

	, 
	upMove: function (index, highColumn, lowColumn) {
		return highColumn.item(index) - highColumn.item(index - 1);
	}

	, 
	downMove: function (index, highColumn, lowColumn) {
		return lowColumn.item(index - 1) - lowColumn.item(index);
	}

	, 
	plusDM: function (highColumn, lowColumn) {
		var d__ = new $.ig.AverageDirectionalIndexIndicatorStrategy___PlusDM__IteratorClass(-2);
		d__.__4__this = this;
		d__.__3__highColumn = highColumn;
		d__.__3__lowColumn = lowColumn;
		return d__;
	}

	, 
	minusDM: function (highColumn, lowColumn) {
		var d__ = new $.ig.AverageDirectionalIndexIndicatorStrategy___MinusDM__IteratorClass(-2);
		d__.__4__this = this;
		d__.__3__highColumn = highColumn;
		d__.__3__lowColumn = lowColumn;
		return d__;
	}

	, 
	plusDI: function (dataSource, supportingCalculations) {
		var d__ = new $.ig.AverageDirectionalIndexIndicatorStrategy___PlusDI__IteratorClass(-2);
		d__.__4__this = this;
		d__.__3__dataSource = dataSource;
		d__.__3__supportingCalculations = supportingCalculations;
		return d__;
	}

	, 
	minusDI: function (dataSource, supportingCalculations) {
		var d__ = new $.ig.AverageDirectionalIndexIndicatorStrategy___MinusDI__IteratorClass(-2);
		d__.__4__this = this;
		d__.__3__dataSource = dataSource;
		d__.__3__supportingCalculations = supportingCalculations;
		return d__;
	}

	, 
	aDXHelper: function (dataSource, supportingCalculations) {
		var d__ = new $.ig.AverageDirectionalIndexIndicatorStrategy___ADXHelper__IteratorClass(-2);
		d__.__4__this = this;
		d__.__3__dataSource = dataSource;
		d__.__3__supportingCalculations = supportingCalculations;
		return d__;
	}

	, 
	aDX: function (dataSource, supportingCalculations) {
		var d__ = new $.ig.AverageDirectionalIndexIndicatorStrategy___ADX__IteratorClass(-2);
		d__.__4__this = this;
		d__.__3__dataSource = dataSource;
		d__.__3__supportingCalculations = supportingCalculations;
		return d__;
	}

	, 
	calculateIndicator: function (dataSource, supportingCalculations) {
		var adx = this.aDX(dataSource, supportingCalculations).getEnumerator();
		var indicatorColumn = dataSource.indicatorColumn();
		for (var i = 0; i < indicatorColumn.count(); i++) {
			if (adx.moveNext()) {
				indicatorColumn.item(i, adx.current());
			}

		}

		return true;
	}
	, 
	$type: new $.ig.Type('AverageDirectionalIndexIndicatorStrategy', $.ig.IndicatorCalculationStrategy.prototype.$type)
}, true);

$.ig.util.defType('AverageTrueRangeIndicatorStrategy', 'IndicatorCalculationStrategy', {
	init: function () {


		$.ig.IndicatorCalculationStrategy.prototype.init.call(this);

	}
	, 
	basedOn: function (dataSource, supportingCalculations) {
		var list = new $.ig.List$1(String, 0);
		list.addRange(dataSource.trueRange().basedOn());
		list.addRange(supportingCalculations.eMA().basedOn());
		return list;
	}

	, 
	calculateIndicator: function (dataSource, supportingCalculations) {
		var i = 0;
		var en = supportingCalculations.eMA().strategy()(dataSource.trueRange(), dataSource.period()).getEnumerator();
		while (en.moveNext()) {
			var atr = en.current();
			dataSource.indicatorColumn().item(i, atr);
			++i;
		}

		return true;
	}
	, 
	$type: new $.ig.Type('AverageTrueRangeIndicatorStrategy', $.ig.IndicatorCalculationStrategy.prototype.$type)
}, true);

$.ig.util.defType('BollingerBandWidthIndicatorStrategy', 'IndicatorCalculationStrategy', {
	init: function () {


		$.ig.IndicatorCalculationStrategy.prototype.init.call(this);

	}
	, 
	basedOn: function (dataSource, supportingCalculations) {
		var list = new $.ig.List$1(String, 0);
		list.addRange(dataSource.typicalColumn().basedOn());
		list.addRange(supportingCalculations.sMA().basedOn());
		list.addRange(supportingCalculations.sTDEV().basedOn());
		return list;
	}

	, 
	calculateIndicator: function (dataSource, supportingCalculations) {
		var sma = supportingCalculations.sMA().strategy()(dataSource.typicalColumn(), dataSource.period()).getEnumerator();
		var stdev = supportingCalculations.sTDEV().strategy()(dataSource.typicalColumn(), dataSource.period()).getEnumerator();
		var multiplier = dataSource.multiplier();
		var indicatorColumn = dataSource.indicatorColumn();
		var i = 0;
		while (sma.moveNext() && stdev.moveNext()) {
			var offset = stdev.current() * multiplier;
			var upperBand = sma.current() + offset;
			var lowerBand = sma.current() - offset;
			var middleBand = sma.current();
			var bandWidth = supportingCalculations.makeSafe()((upperBand - lowerBand) / middleBand);
			indicatorColumn.item(i, bandWidth);
			i++;

		}
		return true;
	}
	, 
	$type: new $.ig.Type('BollingerBandWidthIndicatorStrategy', $.ig.IndicatorCalculationStrategy.prototype.$type)
}, true);

$.ig.util.defType('ChaikinOscillatorIndicatorStrategy', 'IndicatorCalculationStrategy', {

	_accumulationDistributionStrategy: null,
	accumulationDistributionStrategy: function (value) {
		if (arguments.length === 1) {
			this._accumulationDistributionStrategy = value;
			return value;
		} else {
			return this._accumulationDistributionStrategy;
		}
	}
	, 
	init: function () {



		$.ig.IndicatorCalculationStrategy.prototype.init.call(this);
			this.accumulationDistributionStrategy(new $.ig.AccumulationDistributionIndicatorStrategy());
	}

	, 
	basedOn: function (dataSource, supportingCalculations) {
		var list = new $.ig.List$1(String, 0);
		list.addRange(this.accumulationDistributionStrategy().basedOn(dataSource, supportingCalculations));
		list.addRange(supportingCalculations.eMA().basedOn());
		return list;
	}

	, 
	calculateIndicator: function (dataSource, supportingCalculations) {
		var indicatorColumn = dataSource.indicatorColumn();
		var accDist = this.accumulationDistributionStrategy().provideStream(dataSource, supportingCalculations);
		var emaShort = supportingCalculations.eMA().strategy()(accDist, dataSource.shortPeriod()).getEnumerator();
		var emaLong = supportingCalculations.eMA().strategy()(accDist, dataSource.longPeriod()).getEnumerator();
		var i = 0;
		while (emaShort.moveNext() && emaLong.moveNext()) {
			var indicatorValue = emaShort.current() - emaLong.current();
			indicatorColumn.item(i, indicatorValue);
			i++;

		}
		return true;
	}
	, 
	$type: new $.ig.Type('ChaikinOscillatorIndicatorStrategy', $.ig.IndicatorCalculationStrategy.prototype.$type)
}, true);

$.ig.util.defType('ChaikinVolatilityIndicatorStrategy', 'IndicatorCalculationStrategy', {
	init: function () {


		$.ig.IndicatorCalculationStrategy.prototype.init.call(this);

	}
	, 
	basedOn: function (dataSource, supportingCalculations) {
		var list = new $.ig.List$1(String, 0);
		list.add($.ig.FinancialSeries.prototype.highColumnPropertyName);
		list.add($.ig.FinancialSeries.prototype.lowColumnPropertyName);
		list.addRange(supportingCalculations.eMA().basedOn());
		return list;
	}

	, 
	calculateIndicator: function (dataSource, supportingCalculations) {
		var $self = this;
		var highMinusLow = supportingCalculations.toEnumerable()(function (index) { return dataSource.highColumn().item(index) - dataSource.lowColumn().item(index); }, dataSource.count());
		var emaHighLow = supportingCalculations.eMA().strategy()(highMinusLow, dataSource.period()).getEnumerator();
		var indicatorColumn = dataSource.indicatorColumn();
		var buffer = new Array(dataSource.period());
		for (var j = 0; j < dataSource.period(); j++) {
			buffer[j] = 0;
		}

		var i = 0;
		while (emaHighLow.moveNext()) {
			var cursor = i % dataSource.period();
			var chaikinVolatility = supportingCalculations.makeSafe()((emaHighLow.current() - buffer[cursor]) / (buffer[cursor] * 100));
			if (i < dataSource.period()) {
				indicatorColumn.item(i, 0);

			} else {
				indicatorColumn.item(i, chaikinVolatility);
			}

			buffer[cursor] = emaHighLow.current();
			i++;

		}
		return true;
	}
	, 
	$type: new $.ig.Type('ChaikinVolatilityIndicatorStrategy', $.ig.IndicatorCalculationStrategy.prototype.$type)
}, true);

$.ig.util.defType('CommodityChannelIndexIndicatorStrategy', 'IndicatorCalculationStrategy', {
	init: function () {


		$.ig.IndicatorCalculationStrategy.prototype.init.call(this);

	}
	, 
	basedOn: function (dataSource, supportingCalculations) {
		var list = new $.ig.List$1(String, 0);
		list.addRange(dataSource.typicalColumn().basedOn());
		list.addRange(supportingCalculations.sMA().basedOn());
		return list;
	}

	, 
	calculateIndicator: function (dataSource, supportingCalculations) {
		var period = dataSource.period();
		var typicalColumn = dataSource.typicalColumn();
		var indicatorColumn = dataSource.indicatorColumn();
		var sma = supportingCalculations.sMA().strategy()(typicalColumn, period).getEnumerator();
		var price = typicalColumn.getEnumerator();
		var buffer = new Array(period);
		for (var j = 0; j < period; j++) {
			buffer[j] = 0;
		}

		var i = 0;
		while (price.moveNext() && sma.moveNext()) {
			buffer[i % period] = price.current();
			var mad = 0;
			for (var j1 = 0; j1 < period; ++j1) {
				mad += Math.abs(sma.current() - buffer[j1]);
			}

			mad /= period;
			indicatorColumn.item(i, supportingCalculations.makeSafe()((price.current() - sma.current()) / (0.015 * mad)));
			++i;

		}
		return true;
	}
	, 
	$type: new $.ig.Type('CommodityChannelIndexIndicatorStrategy', $.ig.IndicatorCalculationStrategy.prototype.$type)
}, true);

$.ig.util.defType('DetrendedPriceOscillatorIndicatorStrategy', 'IndicatorCalculationStrategy', {
	init: function () {


		$.ig.IndicatorCalculationStrategy.prototype.init.call(this);

	}
	, 
	basedOn: function (dataSource, supportingCalculations) {
		var list = new $.ig.List$1(String, 0);
		list.add($.ig.FinancialSeries.prototype.closeColumnPropertyName);
		list.addRange(supportingCalculations.sMA().basedOn());
		return list;
	}

	, 
	calculateIndicator: function (dataSource, supportingCalculations) {
		var period = dataSource.period();
		var closeColumn = dataSource.closeColumn();
		var indicatorColumn = dataSource.indicatorColumn();
		var sma = supportingCalculations.sMA().strategy()(closeColumn, period).getEnumerator();
		var daysAgo = ($.ig.intDivide(period, 2)) + 1;
		var buffer = new Array(daysAgo);
		for (var j = 0; j < daysAgo; j++) {
			buffer[j] = 0;
		}

		for (var i = 1; i < Math.min(daysAgo + 1, indicatorColumn.count()); ++i) {
			var cursor = i % daysAgo;
			indicatorColumn.item(i, 0);
			sma.moveNext();
			buffer[cursor] = sma.current();
		}

		for (var i1 = daysAgo + 1; i1 < indicatorColumn.count(); i1++) {
			var cursor1 = i1 % daysAgo;
			indicatorColumn.item(i1, closeColumn.item(i1) - buffer[cursor1]);
			sma.moveNext();
			buffer[cursor1] = sma.current();
		}

		return true;
	}
	, 
	$type: new $.ig.Type('DetrendedPriceOscillatorIndicatorStrategy', $.ig.IndicatorCalculationStrategy.prototype.$type)
}, true);

$.ig.util.defType('EaseOfMovementIndicatorStrategy', 'IndicatorCalculationStrategy', {
	init: function () {


		$.ig.IndicatorCalculationStrategy.prototype.init.call(this);

	}
	, 
	basedOn: function (dataSource, supportingCalculations) {
		var list = new $.ig.List$1(String, 0);
		list.add($.ig.FinancialSeries.prototype.highColumnPropertyName);
		list.add($.ig.FinancialSeries.prototype.lowColumnPropertyName);
		list.add($.ig.FinancialSeries.prototype.volumeColumnPropertyName);
		return list;
	}

	, 
	calculateIndicator: function (dataSource, supportingCalculations) {
		var indicatorColumn = dataSource.indicatorColumn();
		var highColumn = dataSource.highColumn();
		var lowColumn = dataSource.lowColumn();
		var volumeColumn = dataSource.volumeColumn();
		var count = dataSource.count();
		if (count > 0) {
			indicatorColumn.item(0, 0);
		}

		for (var i = 1; i < count; i++) {
			var todayMidPoint = (highColumn.item(i) + lowColumn.item(i)) / 2;
			var yesterdayMidPoint = (highColumn.item(i - 1) + lowColumn.item(i - 1)) / 2;
			var midPointMove = todayMidPoint - yesterdayMidPoint;
			var volumeScalingFactor = 10000;
			var boxRatio = supportingCalculations.makeSafe()((volumeColumn.item(i) / volumeScalingFactor) / (highColumn.item(i) - lowColumn.item(i)));
			indicatorColumn.item(i, supportingCalculations.makeSafe()(midPointMove / boxRatio));
		}

		return true;
	}
	, 
	$type: new $.ig.Type('EaseOfMovementIndicatorStrategy', $.ig.IndicatorCalculationStrategy.prototype.$type)
}, true);

$.ig.util.defType('FastStochasticOscillatorIndicatorStrategy', 'IndicatorCalculationStrategy', {

	_percentKStrategy: null,
	percentKStrategy: function (value) {
		if (arguments.length === 1) {
			this._percentKStrategy = value;
			return value;
		} else {
			return this._percentKStrategy;
		}
	}
	, 
	init: function () {



		$.ig.IndicatorCalculationStrategy.prototype.init.call(this);
			this.percentKStrategy(new $.ig.PercentKCalculationStrategy());
	}

	, 
	basedOn: function (dataSource, supportingCalculations) {
		var list = new $.ig.List$1(String, 0);
		list.addRange(this.percentKStrategy().basedOn(dataSource, supportingCalculations));
		return list;
	}

	, 
	calculateIndicator: function (dataSource, supportingCalculations) {
		var percentK = this.percentKStrategy().provideStream(dataSource, supportingCalculations);
		var i = 0;
		var en = percentK.getEnumerator();
		while (en.moveNext()) {
			var value = en.current();
			dataSource.indicatorColumn().item(i, value);
			i++;
		}

		return true;
	}
	, 
	$type: new $.ig.Type('FastStochasticOscillatorIndicatorStrategy', $.ig.IndicatorCalculationStrategy.prototype.$type)
}, true);

$.ig.util.defType('ForceIndexIndicatorStrategy', 'IndicatorCalculationStrategy', {
	init: function () {


		$.ig.IndicatorCalculationStrategy.prototype.init.call(this);

	}
	, 
	basedOn: function (dataSource, supportingCalculations) {
		var list = new $.ig.List$1(String, 0);
		list.add($.ig.FinancialSeries.prototype.closeColumnPropertyName);
		list.add($.ig.FinancialSeries.prototype.volumeColumnPropertyName);
		list.addRange(supportingCalculations.eMA().basedOn());
		return list;
	}

	, 
	fI: function (dataSource) {
		var d__ = new $.ig.ForceIndexIndicatorStrategy___FI__IteratorClass(-2);
		d__.__4__this = this;
		d__.__3__dataSource = dataSource;
		return d__;
	}

	, 
	calculateIndicator: function (dataSource, supportingCalculations) {
		var fi = this.fI(dataSource);
		var period = dataSource.period();
		var indicatorColumn = dataSource.indicatorColumn();
		if (period != 0 && !$.ig.util.isNaN(period) && !Number.isInfinity(period)) {
			fi = supportingCalculations.eMA().strategy()(fi, dataSource.period());
		}

		var i = 0;
		var en = fi.getEnumerator();
		while (en.moveNext()) {
			var d = en.current();
			indicatorColumn.item(i, d);
			++i;
		}

		return true;
	}
	, 
	$type: new $.ig.Type('ForceIndexIndicatorStrategy', $.ig.IndicatorCalculationStrategy.prototype.$type)
}, true);

$.ig.util.defType('FullStochasticOscillatorIndicatorStrategy', 'IndicatorCalculationStrategy', {

	_percentKStrategy: null,
	percentKStrategy: function (value) {
		if (arguments.length === 1) {
			this._percentKStrategy = value;
			return value;
		} else {
			return this._percentKStrategy;
		}
	}
	, 
	init: function () {



		$.ig.IndicatorCalculationStrategy.prototype.init.call(this);
			this.percentKStrategy(new $.ig.PercentKCalculationStrategy());
	}

	, 
	basedOn: function (dataSource, supportingCalculations) {
		var list = new $.ig.List$1(String, 0);
		list.addRange(this.percentKStrategy().basedOn(dataSource, supportingCalculations));
		list.addRange(supportingCalculations.eMA().basedOn());
		return list;
	}

	, 
	calculateIndicator: function (dataSource, supportingCalculations) {
		var percentK = this.percentKStrategy().provideStream(dataSource, supportingCalculations);
		var fullPercentK = supportingCalculations.eMA().strategy()(percentK, dataSource.shortPeriod());
		var i = 0;
		var en = fullPercentK.getEnumerator();
		while (en.moveNext()) {
			var value = en.current();
			dataSource.indicatorColumn().item(i, value);
			i++;
		}

		return true;
	}
	, 
	$type: new $.ig.Type('FullStochasticOscillatorIndicatorStrategy', $.ig.IndicatorCalculationStrategy.prototype.$type)
}, true);

$.ig.util.defType('PercentKCalculationStrategy', 'StreamingIndicatorCalculationStrategy', {
	init: function () {


		$.ig.StreamingIndicatorCalculationStrategy.prototype.init.call(this);

	}
	, 
	basedOn: function (dataSource, supportingCalculations) {
		var list = new $.ig.List$1(String, 0);
		list.add($.ig.FinancialSeries.prototype.highColumnPropertyName);
		list.add($.ig.FinancialSeries.prototype.lowColumnPropertyName);
		list.add($.ig.FinancialSeries.prototype.closeColumnPropertyName);
		return list;
	}

	, 
	provideStream: function (dataSource, supportingCalculations) {
		var d__ = new $.ig.PercentKCalculationStrategy___ProvideStream__IteratorClass(-2);
		d__.__4__this = this;
		d__.__3__dataSource = dataSource;
		d__.__3__supportingCalculations = supportingCalculations;
		return d__;
	}

	, 
	calculateIndicator: function (dataSource, supportingCalculations) {
		var i = 0;
		var en = this.provideStream(dataSource, supportingCalculations).getEnumerator();
		while (en.moveNext()) {
			var value = en.current();
			dataSource.indicatorColumn().item(i, value);
			i++;
		}

		return true;
	}
	, 
	$type: new $.ig.Type('PercentKCalculationStrategy', $.ig.StreamingIndicatorCalculationStrategy.prototype.$type)
}, true);

$.ig.util.defType('MarketFacilitationIndexIndicatorStrategy', 'ItemwiseIndicatorCalculationStrategy', {
	init: function () {


		$.ig.ItemwiseIndicatorCalculationStrategy.prototype.init.call(this);

	}
	, 
	basedOn: function (dataSource, supportingCalculations) {
		var list = new $.ig.List$1(String, 0);
		list.add($.ig.FinancialSeries.prototype.highColumnPropertyName);
		list.add($.ig.FinancialSeries.prototype.lowColumnPropertyName);
		list.add($.ig.FinancialSeries.prototype.volumeColumnPropertyName);
		return list;
	}

	, 
	calculateIndicatorItem: function (dataSource, supportingCalculations, currentIndex) {
		dataSource.indicatorColumn().item(currentIndex, supportingCalculations.makeSafe()((dataSource.highColumn().item(currentIndex) - dataSource.lowColumn().item(currentIndex)) / dataSource.volumeColumn().item(currentIndex)));
		return true;
	}
	, 
	$type: new $.ig.Type('MarketFacilitationIndexIndicatorStrategy', $.ig.ItemwiseIndicatorCalculationStrategy.prototype.$type)
}, true);

$.ig.util.defType('MassIndexIndicatorStrategy', 'IndicatorCalculationStrategy', {
	init: function () {


		$.ig.IndicatorCalculationStrategy.prototype.init.call(this);

	}
	, 
	basedOn: function (dataSource, supportingCalculations) {
		var list = new $.ig.List$1(String, 0);
		list.add($.ig.FinancialSeries.prototype.highColumnPropertyName);
		list.add($.ig.FinancialSeries.prototype.lowColumnPropertyName);
		list.addRange(supportingCalculations.eMA().basedOn());
		return list;
	}

	, 
	highLowRange: function (highColumn, lowColumn) {
		var result = new $.ig.List$1(Number, 0);
		for (var i = 0; i < (Math.min(highColumn.count(), lowColumn.count())); i++) {
			result.add(highColumn.item(i) - lowColumn.item(i));
		}

		return result;
	}

	, 
	calculateIndicator: function (dataSource, supportingCalculations) {
		var period = 9;
		var highColumn = dataSource.highColumn();
		var lowColumn = dataSource.lowColumn();
		var indicatorColumn = dataSource.indicatorColumn();
		var ema9 = supportingCalculations.eMA().strategy()(this.highLowRange(highColumn, lowColumn), period).getEnumerator();
		var ema9ema9 = supportingCalculations.eMA().strategy()(supportingCalculations.eMA().strategy()(this.highLowRange(highColumn, lowColumn), period), period).getEnumerator();
		var buffer = new Array(period);
		for (var i = 0; i < period; i++) {
			buffer[i] = 0;
		}

		var mass = 0;
		for (var i1 = 0; i1 < indicatorColumn.count(); i1++) {
			var cursor = i1 % period;
			mass -= buffer[cursor];
			ema9.moveNext();
			ema9ema9.moveNext();
			var newMassValue = supportingCalculations.makeSafe()(ema9.current() / ema9ema9.current());
			mass += newMassValue;
			indicatorColumn.item(i1, mass);
			buffer[cursor] = newMassValue;
		}

		return true;
	}
	, 
	$type: new $.ig.Type('MassIndexIndicatorStrategy', $.ig.IndicatorCalculationStrategy.prototype.$type)
}, true);

$.ig.util.defType('MedianPriceIndicatorStrategy', 'ItemwiseIndicatorCalculationStrategy', {
	init: function () {


		$.ig.ItemwiseIndicatorCalculationStrategy.prototype.init.call(this);

	}
	, 
	basedOn: function (dataSource, supportingCalculations) {
		var list = new $.ig.List$1(String, 0);
		list.add($.ig.FinancialSeries.prototype.highColumnPropertyName);
		list.add($.ig.FinancialSeries.prototype.lowColumnPropertyName);
		return list;
	}

	, 
	calculateIndicatorItem: function (dataSource, supportingCalculations, currentIndex) {
		dataSource.indicatorColumn().item(currentIndex, (dataSource.highColumn().item(currentIndex) + dataSource.lowColumn().item(currentIndex)) / 2);
		return true;
	}
	, 
	$type: new $.ig.Type('MedianPriceIndicatorStrategy', $.ig.ItemwiseIndicatorCalculationStrategy.prototype.$type)
}, true);

$.ig.util.defType('MoneyFlowIndexIndicatorStrategy', 'IndicatorCalculationStrategy', {
	init: function () {


		$.ig.IndicatorCalculationStrategy.prototype.init.call(this);

	}
	, 
	basedOn: function (dataSource, supportingCalculations) {
		var list = new $.ig.List$1(String, 0);
		list.addRange(dataSource.typicalColumn().basedOn());
		list.add($.ig.FinancialSeries.prototype.volumeColumnPropertyName);
		return list;
	}

	, 
	calculateIndicator: function (dataSource, supportingCalculations) {
		var typical = dataSource.typicalColumn().getEnumerator();
		var volume = dataSource.volumeColumn().getEnumerator();
		var period = dataSource.period();
		var i = 0;
		var positiveBuffer = new Array(period);
		for (i = 0; i < period; i++) {
			positiveBuffer[i] = 0;
		}

		var positiveFlow = 0;
		var negativeBuffer = new Array(period);
		for (i = 0; i < period; i++) {
			negativeBuffer[i] = 0;
		}

		var negativeFlow = 0;
		var flowYesterday = 0;
		i = 0;
		while (typical.moveNext() && volume.moveNext()) {
			var cursor = i % period;
			var flowToday = typical.current() * volume.current();
			positiveFlow -= positiveBuffer[cursor];
			negativeFlow -= negativeBuffer[cursor];
			switch (Math.sign(flowToday - flowYesterday)) {
				case -1:
					positiveBuffer[cursor] = 0;
					negativeBuffer[cursor] = flowToday;
					break;
				case 0:
					positiveBuffer[cursor] = 0;
					negativeBuffer[cursor] = 0;
					break;
				case 1:
					positiveBuffer[cursor] = flowToday;
					negativeBuffer[cursor] = 0;
					break;
			}

			positiveFlow += positiveBuffer[cursor];
			negativeFlow += negativeBuffer[cursor];
			var mfi = supportingCalculations.makeSafe()(100 * positiveFlow / (positiveFlow + negativeFlow));
			dataSource.indicatorColumn().item(i, mfi);
			flowYesterday = flowToday;
			++i;

		}
		return true;
	}
	, 
	$type: new $.ig.Type('MoneyFlowIndexIndicatorStrategy', $.ig.IndicatorCalculationStrategy.prototype.$type)
}, true);

$.ig.util.defType('MovingAverageConvergenceDivergenceIndicatorStrategy', 'IndicatorCalculationStrategy', {
	init: function () {


		$.ig.IndicatorCalculationStrategy.prototype.init.call(this);

	}
	, 
	basedOn: function (dataSource, supportingCalculations) {
		var list = new $.ig.List$1(String, 0);
		list.addRange(dataSource.typicalColumn().basedOn());
		list.addRange(supportingCalculations.eMA().basedOn());
		return list;
	}

	, 
	calculateIndicator: function (dataSource, supportingCalculations) {
		var typicalColumn = dataSource.typicalColumn();
		var indicatorColumn = dataSource.indicatorColumn();
		var shortPeriod = dataSource.shortPeriod();
		var longPeriod = dataSource.longPeriod();
		var shortEma = supportingCalculations.eMA().strategy()(typicalColumn, shortPeriod).getEnumerator();
		var longEma = supportingCalculations.eMA().strategy()(typicalColumn, longPeriod).getEnumerator();
		var i = 0;
		while (shortEma.moveNext() && longEma.moveNext()) {
			var macd = supportingCalculations.makeSafe()(shortEma.current() - longEma.current());
			indicatorColumn.item(i, macd);
			i++;

		}
		return true;
	}
	, 
	$type: new $.ig.Type('MovingAverageConvergenceDivergenceIndicatorStrategy', $.ig.IndicatorCalculationStrategy.prototype.$type)
}, true);

$.ig.util.defType('NegativeVolumeIndexIndicatorStrategy', 'IndicatorCalculationStrategy', {
	init: function () {


		$.ig.IndicatorCalculationStrategy.prototype.init.call(this);

	}
	, 
	basedOn: function (dataSource, supportingCalculations) {
		var list = new $.ig.List$1(String, 0);
		list.add($.ig.FinancialSeries.prototype.closeColumnPropertyName);
		list.add($.ig.FinancialSeries.prototype.volumeColumnPropertyName);
		return list;
	}

	, 
	calculateIndicator: function (dataSource, supportingCalculations) {
		var closeColumn = dataSource.closeColumn();
		var volumeColumn = dataSource.volumeColumn();
		var indicatorColumn = dataSource.indicatorColumn();
		var nvi = 0;
		var newValue = 0;
		var yesterdayNVI = 0;
		if (indicatorColumn.count() > 0) {
			indicatorColumn.item(0, nvi);
		}

		for (var i = 1; i < indicatorColumn.count(); i++) {
			if (volumeColumn.item(i) < volumeColumn.item(i - 1)) {
				newValue = supportingCalculations.makeSafe()((closeColumn.item(i) - closeColumn.item(i - 1)) / closeColumn.item(i - 1));
				if (yesterdayNVI != 0) {
					nvi += newValue * yesterdayNVI;

				} else {
					nvi += newValue;
				}

			}

			indicatorColumn.item(i, nvi);
			yesterdayNVI = nvi;
		}

		return true;
	}
	, 
	$type: new $.ig.Type('NegativeVolumeIndexIndicatorStrategy', $.ig.IndicatorCalculationStrategy.prototype.$type)
}, true);

$.ig.util.defType('OnBalanceVolumeIndicatorStrategy', 'IndicatorCalculationStrategy', {
	init: function () {


		$.ig.IndicatorCalculationStrategy.prototype.init.call(this);

	}
	, 
	basedOn: function (dataSource, supportingCalculations) {
		var list = new $.ig.List$1(String, 0);
		list.add($.ig.FinancialSeries.prototype.closeColumnPropertyName);
		list.add($.ig.FinancialSeries.prototype.volumeColumnPropertyName);
		return list;
	}

	, 
	calculateIndicator: function (dataSource, supportingCalculations) {
		var closeColumn = dataSource.closeColumn();
		var volumeColumn = dataSource.volumeColumn();
		var indicatorColumn = dataSource.indicatorColumn();
		var n = 0;
		if (closeColumn != null && volumeColumn != null) {
			n = Math.min(closeColumn.count(), volumeColumn.count());
		}

		var obv = 0;
		if (n > 0) {
			obv = volumeColumn.item(0);
			indicatorColumn.item(0, obv);
		}

		for (var i = 1; i < n; ++i) {
			switch (Math.sign(closeColumn.item(i) - closeColumn.item(i - 1))) {
				case -1:
					obv -= volumeColumn.item(i);
					break;
				case 1:
					obv += volumeColumn.item(i);
					break;
			}

			indicatorColumn.item(i, obv);
		}

		return true;
	}
	, 
	$type: new $.ig.Type('OnBalanceVolumeIndicatorStrategy', $.ig.IndicatorCalculationStrategy.prototype.$type)
}, true);

$.ig.util.defType('PercentagePriceOscillatorIndicatorStrategy', 'IndicatorCalculationStrategy', {
	init: function () {


		$.ig.IndicatorCalculationStrategy.prototype.init.call(this);

	}
	, 
	basedOn: function (dataSource, supportingCalculations) {
		var list = new $.ig.List$1(String, 0);
		list.addRange(supportingCalculations.shortPriceOscillatorAverage().basedOn());
		list.addRange(supportingCalculations.longPriceOscillatorAverage().basedOn());
		return list;
	}

	, 
	calculateIndicator: function (dataSource, supportingCalculations) {
		var indicatorColumn = dataSource.indicatorColumn();
		var shortEma = supportingCalculations.shortPriceOscillatorAverage().strategy()(dataSource).getEnumerator();
		var longEma = supportingCalculations.longPriceOscillatorAverage().strategy()(dataSource).getEnumerator();
		var i = 0;
		while (shortEma.moveNext() && longEma.moveNext()) {
			var ppo = supportingCalculations.makeSafe()(100 * (shortEma.current() - longEma.current()) / longEma.current());
			indicatorColumn.item(i, ppo);
			++i;

		}
		return true;
	}
	, 
	$type: new $.ig.Type('PercentagePriceOscillatorIndicatorStrategy', $.ig.IndicatorCalculationStrategy.prototype.$type)
}, true);

$.ig.util.defType('PercentageVolumeOscillatorIndicatorStrategy', 'IndicatorCalculationStrategy', {
	init: function () {


		$.ig.IndicatorCalculationStrategy.prototype.init.call(this);

	}
	, 
	basedOn: function (dataSource, supportingCalculations) {
		var list = new $.ig.List$1(String, 0);
		list.addRange(supportingCalculations.shortVolumeOscillatorAverage().basedOn());
		list.addRange(supportingCalculations.longVolumeOscillatorAverage().basedOn());
		return list;
	}

	, 
	calculateIndicator: function (dataSource, supportingCalculations) {
		var shortEma = supportingCalculations.shortVolumeOscillatorAverage().strategy()(dataSource).getEnumerator();
		var longEma = supportingCalculations.longVolumeOscillatorAverage().strategy()(dataSource).getEnumerator();
		var indicatorColumn = dataSource.indicatorColumn();
		var i = 0;
		while (shortEma.moveNext() && longEma.moveNext()) {
			var pvo = supportingCalculations.makeSafe()(100 * (shortEma.current() - longEma.current()) / longEma.current());
			indicatorColumn.item(i, pvo);
			++i;

		}
		return true;
	}
	, 
	$type: new $.ig.Type('PercentageVolumeOscillatorIndicatorStrategy', $.ig.IndicatorCalculationStrategy.prototype.$type)
}, true);

$.ig.util.defType('PositiveVolumeIndexIndicatorStrategy', 'IndicatorCalculationStrategy', {
	init: function () {


		$.ig.IndicatorCalculationStrategy.prototype.init.call(this);

	}
	, 
	basedOn: function (dataSource, supportingCalculations) {
		var list = new $.ig.List$1(String, 0);
		list.add($.ig.FinancialSeries.prototype.closeColumnPropertyName);
		list.add($.ig.FinancialSeries.prototype.volumeColumnPropertyName);
		return list;
	}

	, 
	calculateIndicator: function (dataSource, supportingCalculations) {
		var closeColumn = dataSource.closeColumn();
		var volumeColumn = dataSource.volumeColumn();
		var indicatorColumn = dataSource.indicatorColumn();
		var pvi = 0;
		var newValue = 0;
		var yesterdayPVI = 0;
		if (indicatorColumn.count() > 0) {
			indicatorColumn.item(0, pvi);
		}

		for (var i = 1; i < indicatorColumn.count(); i++) {
			if (volumeColumn.item(i) > volumeColumn.item(i - 1)) {
				newValue = supportingCalculations.makeSafe()((closeColumn.item(i) - closeColumn.item(i - 1)) / closeColumn.item(i - 1));
				if (yesterdayPVI != 0) {
					pvi += newValue * yesterdayPVI;

				} else {
					pvi += newValue;
				}

			}

			indicatorColumn.item(i, pvi);
			yesterdayPVI = pvi;
		}

		return true;
	}
	, 
	$type: new $.ig.Type('PositiveVolumeIndexIndicatorStrategy', $.ig.IndicatorCalculationStrategy.prototype.$type)
}, true);

$.ig.util.defType('PriceVolumeTrendIndicatorStrategy', 'IndicatorCalculationStrategy', {
	init: function () {


		$.ig.IndicatorCalculationStrategy.prototype.init.call(this);

	}
	, 
	basedOn: function (dataSource, supportingCalculations) {
		var list = new $.ig.List$1(String, 0);
		list.add($.ig.FinancialSeries.prototype.volumeColumnPropertyName);
		list.add($.ig.FinancialSeries.prototype.closeColumnPropertyName);
		return list;
	}

	, 
	calculateIndicator: function (dataSource, supportingCalculations) {
		var pvt = 0;
		var indicatorColumn = dataSource.indicatorColumn();
		var volumeColumn = dataSource.volumeColumn();
		var closeColumn = dataSource.closeColumn();
		var count = dataSource.count();
		if (count > 0) {
			indicatorColumn.item(0, pvt);
		}

		for (var i = 1; i < count; ++i) {
			pvt = pvt + supportingCalculations.makeSafe()(volumeColumn.item(i) * (closeColumn.item(i) - closeColumn.item(i - 1)) / closeColumn.item(i - 1));
			indicatorColumn.item(i, pvt);
		}

		return true;
	}
	, 
	$type: new $.ig.Type('PriceVolumeTrendIndicatorStrategy', $.ig.IndicatorCalculationStrategy.prototype.$type)
}, true);

$.ig.util.defType('RateOfChangeAndMomentumIndicatorStrategy', 'IndicatorCalculationStrategy', {
	init: function () {


		$.ig.IndicatorCalculationStrategy.prototype.init.call(this);

	}
	, 
	basedOn: function (dataSource, supportingCalculations) {
		var list = new $.ig.List$1(String, 0);
		list.add($.ig.FinancialSeries.prototype.closeColumnPropertyName);
		return list;
	}

	, 
	calculateIndicator: function (dataSource, supportingCalculations) {
		var closeColumn = dataSource.closeColumn();
		var indicatorColumn = dataSource.indicatorColumn();
		var period = dataSource.period();
		var i = 0;
		var buffer = new Array(period);
		for (i = 0; i < period; i++) {
			buffer[i] = 0;
		}

		i = 0;
		var en = closeColumn.getEnumerator();
		while (en.moveNext()) {
			var close = en.current();
			var cursor = i % period;
			var rcm = supportingCalculations.makeSafe()(100 * (close - buffer[cursor]) / buffer[cursor]);
			indicatorColumn.item(i, rcm);
			buffer[cursor] = close;
			++i;
		}

		return true;
	}
	, 
	$type: new $.ig.Type('RateOfChangeAndMomentumIndicatorStrategy', $.ig.IndicatorCalculationStrategy.prototype.$type)
}, true);

$.ig.util.defType('RelativeStrengthIndexIndicatorStrategy', 'StreamingIndicatorCalculationStrategy', {
	init: function () {


		$.ig.StreamingIndicatorCalculationStrategy.prototype.init.call(this);

	}
	, 
	basedOn: function (dataSource, supportingCalculations) {
		var list = new $.ig.List$1(String, 0);
		list.add($.ig.FinancialSeries.prototype.closeColumnPropertyName);
		return list;
	}

	, 
	calculateIndicator: function (dataSource, supportingCalculations) {
		var i = 0;
		var en = this.provideStream(dataSource, supportingCalculations).getEnumerator();
		while (en.moveNext()) {
			var value = en.current();
			dataSource.indicatorColumn().item(i, value);
			i++;
		}

		return true;
	}

	, 
	provideStream: function (dataSource, supportingCalculations) {
		var d__ = new $.ig.RelativeStrengthIndexIndicatorStrategy___ProvideStream__IteratorClass(-2);
		d__.__4__this = this;
		d__.__3__dataSource = dataSource;
		d__.__3__supportingCalculations = supportingCalculations;
		return d__;
	}
	, 
	$type: new $.ig.Type('RelativeStrengthIndexIndicatorStrategy', $.ig.StreamingIndicatorCalculationStrategy.prototype.$type)
}, true);

$.ig.util.defType('SlowStochasticOscillatorIndicatorStrategy', 'IndicatorCalculationStrategy', {

	_percentKStrategy: null,
	percentKStrategy: function (value) {
		if (arguments.length === 1) {
			this._percentKStrategy = value;
			return value;
		} else {
			return this._percentKStrategy;
		}
	}
	, 
	init: function () {



		$.ig.IndicatorCalculationStrategy.prototype.init.call(this);
			this.percentKStrategy(new $.ig.PercentKCalculationStrategy());
	}

	, 
	basedOn: function (dataSource, supportingCalculations) {
		var list = new $.ig.List$1(String, 0);
		list.addRange(this.percentKStrategy().basedOn(dataSource, supportingCalculations));
		list.addRange(supportingCalculations.eMA().basedOn());
		return list;
	}

	, 
	calculateIndicator: function (dataSource, supportingCalculations) {
		var percentK = this.percentKStrategy().provideStream(dataSource, supportingCalculations);
		var slowPercentK = supportingCalculations.eMA().strategy()(percentK, 3);
		var i = 0;
		var en = slowPercentK.getEnumerator();
		while (en.moveNext()) {
			var value = en.current();
			dataSource.indicatorColumn().item(i, value);
			i++;
		}

		return true;
	}
	, 
	$type: new $.ig.Type('SlowStochasticOscillatorIndicatorStrategy', $.ig.IndicatorCalculationStrategy.prototype.$type)
}, true);

$.ig.util.defType('StandardDeviationIndicatorStrategy', 'IndicatorCalculationStrategy', {
	init: function () {


		$.ig.IndicatorCalculationStrategy.prototype.init.call(this);

	}
	, 
	basedOn: function (dataSource, supportingCalculations) {
		var list = new $.ig.List$1(String, 0);
		list.addRange(dataSource.typicalColumn().basedOn());
		list.addRange(supportingCalculations.sTDEV().basedOn());
		return list;
	}

	, 
	calculateIndicator: function (dataSource, supportingCalculations) {
		var stddev = supportingCalculations.sTDEV().strategy()(dataSource.typicalColumn(), dataSource.period()).getEnumerator();
		var indicatorColumn = dataSource.indicatorColumn();
		var i = 0;
		while (stddev.moveNext()) {
			indicatorColumn.item(i, stddev.current());
			i++;

		}
		return true;
	}
	, 
	$type: new $.ig.Type('StandardDeviationIndicatorStrategy', $.ig.IndicatorCalculationStrategy.prototype.$type)
}, true);

$.ig.util.defType('StochRSIIndicatorStrategy', 'IndicatorCalculationStrategy', {

	_rSIStrategy: null,
	rSIStrategy: function (value) {
		if (arguments.length === 1) {
			this._rSIStrategy = value;
			return value;
		} else {
			return this._rSIStrategy;
		}
	}
	, 
	init: function () {



		$.ig.IndicatorCalculationStrategy.prototype.init.call(this);
			this.rSIStrategy(new $.ig.RelativeStrengthIndexIndicatorStrategy());
	}

	, 
	basedOn: function (dataSource, supportingCalculations) {
		var list = new $.ig.List$1(String, 0);
		list.addRange(this.rSIStrategy().basedOn(dataSource, supportingCalculations));
		return list;
	}

	, 
	calculateIndicator: function (dataSource, supportingCalculations) {
		var RSI = this.rSIStrategy().provideStream(dataSource, supportingCalculations).getEnumerator();
		var period = dataSource.period();
		var i = 0;
		var buffer = new Array(period);
		for (i = 0; i < period; i++) {
			buffer[i] = 0;
		}

		i = 0;
		while (RSI.moveNext()) {
			var ago = Math.min(period, i);
			var highestHigh = -1.7976931348623157E+308;
			var lowestLow = 1.7976931348623157E+308;
			var cursor = i % period;
			for (var j = 0; j < ago; j++) {
				if (!$.ig.util.isNaN(buffer[ago - j - 1])) {
					highestHigh = Math.max(highestHigh, buffer[ago - j - 1]);
				}

				if (!$.ig.util.isNaN(buffer[ago - j - 1])) {
					lowestLow = Math.min(lowestLow, buffer[ago - j - 1]);
				}

			}

			buffer[cursor] = RSI.current();
			var stochRSI = supportingCalculations.makeSafe()((RSI.current() - lowestLow) / (highestHigh - lowestLow));
			dataSource.indicatorColumn().item(i, stochRSI);
			i++;

		}
		return true;
	}
	, 
	$type: new $.ig.Type('StochRSIIndicatorStrategy', $.ig.IndicatorCalculationStrategy.prototype.$type)
}, true);

$.ig.util.defType('TRIXIndicatorStrategy', 'IndicatorCalculationStrategy', {
	init: function () {


		$.ig.IndicatorCalculationStrategy.prototype.init.call(this);

	}
	, 
	basedOn: function (dataSource, supportingCalculations) {
		var list = new $.ig.List$1(String, 0);
		list.add($.ig.FinancialSeries.prototype.closeColumnPropertyName);
		list.addRange(supportingCalculations.eMA().basedOn());
		return list;
	}

	, 
	calculateIndicator: function (dataSource, supportingCalculations) {
		var ema1 = supportingCalculations.eMA().strategy()(dataSource.closeColumn(), dataSource.period());
		var ema2 = supportingCalculations.eMA().strategy()(ema1, dataSource.period());
		var ema3 = supportingCalculations.eMA().strategy()(ema2, dataSource.period()).getEnumerator();
		var indicatorColumn = dataSource.indicatorColumn();
		if (indicatorColumn.count() > 0) {
			indicatorColumn.item(0, 0);
		}

		var i = 1;
		ema3.moveNext();
		var lastEMA = ema3.current();
		while (ema3.moveNext()) {
			indicatorColumn.item(i, supportingCalculations.makeSafe()((ema3.current() - lastEMA) / lastEMA));
			lastEMA = ema3.current();
			i++;

		}
		return true;
	}
	, 
	$type: new $.ig.Type('TRIXIndicatorStrategy', $.ig.IndicatorCalculationStrategy.prototype.$type)
}, true);

$.ig.util.defType('TypicalPriceIndicatorStrategy', 'IndicatorCalculationStrategy', {
	init: function () {


		$.ig.IndicatorCalculationStrategy.prototype.init.call(this);

	}
	, 
	basedOn: function (dataSource, supportingCalculations) {
		var list = new $.ig.List$1(String, 0);
		list.addRange(dataSource.typicalColumn().basedOn());
		return list;
	}

	, 
	calculateIndicator: function (dataSource, supportingCalculations) {
		var i = 0;
		var en = dataSource.typicalColumn().getEnumerator();
		while (en.moveNext()) {
			var value = en.current();
			dataSource.indicatorColumn().item(i, value);
			i++;
		}

		return true;
	}
	, 
	$type: new $.ig.Type('TypicalPriceIndicatorStrategy', $.ig.IndicatorCalculationStrategy.prototype.$type)
}, true);

$.ig.util.defType('UltimateOscillatorIndicatorCalculationStrategy', 'IndicatorCalculationStrategy', {
	init: function () {


		$.ig.IndicatorCalculationStrategy.prototype.init.call(this);

	}
	, 
	basedOn: function (dataSource, supportingCalculations) {
		var list = new $.ig.List$1(String, 0);
		list.addRange(dataSource.trueLow().basedOn());
		list.add($.ig.FinancialSeries.prototype.closeColumnPropertyName);
		list.addRange(dataSource.trueRange().basedOn());
		list.addRange(supportingCalculations.movingSum().basedOn());
		return list;
	}

	, 
	buyingPressure: function (dataSource) {
		var i = 0;
		var result = new $.ig.List$1(Number, 0);
		var tl = dataSource.trueLow().getEnumerator();
		while (tl.moveNext()) {
			result.add(dataSource.closeColumn().item(i) - tl.current());
			i++;

		}
		return result;
	}

	, 
	calculateIndicator: function (dataSource, supportingCalculations) {
		var buyingPressure = this.buyingPressure(dataSource);
		var trueRange = dataSource.trueRange();
		var bpShort = supportingCalculations.movingSum().strategy()(buyingPressure, 7).getEnumerator();
		var trShort = supportingCalculations.movingSum().strategy()(trueRange, 7).getEnumerator();
		var bpMedium = supportingCalculations.movingSum().strategy()(buyingPressure, 14).getEnumerator();
		var trMedium = supportingCalculations.movingSum().strategy()(trueRange, 14).getEnumerator();
		var bpLong = supportingCalculations.movingSum().strategy()(buyingPressure, 28).getEnumerator();
		var trLong = supportingCalculations.movingSum().strategy()(trueRange, 28).getEnumerator();
		var i = 0;
		while (bpShort.moveNext() && trShort.moveNext() && bpMedium.moveNext() && trMedium.moveNext() && bpLong.moveNext() && trLong.moveNext()) {
			var rawValue = supportingCalculations.makeSafe()(4 * (bpShort.current() / trShort.current()) + 2 * (bpMedium.current() / trMedium.current()) + (bpLong.current() / trLong.current()));
			var uo = (rawValue / (4 + 2 + 1)) * 100;
			dataSource.indicatorColumn().item(i, uo);
			i++;

		}
		return true;
	}
	, 
	$type: new $.ig.Type('UltimateOscillatorIndicatorCalculationStrategy', $.ig.IndicatorCalculationStrategy.prototype.$type)
}, true);

$.ig.util.defType('WeightedCloseIndicatorStrategy', 'ItemwiseIndicatorCalculationStrategy', {
	init: function () {


		$.ig.ItemwiseIndicatorCalculationStrategy.prototype.init.call(this);

	}
	, 
	basedOn: function (dataSource, supportingCalculations) {
		var list = new $.ig.List$1(String, 0);
		list.add($.ig.FinancialSeries.prototype.highColumnPropertyName);
		list.add($.ig.FinancialSeries.prototype.lowColumnPropertyName);
		list.add($.ig.FinancialSeries.prototype.closeColumnPropertyName);
		return list;
	}

	, 
	calculateIndicatorItem: function (dataSource, supportingCalculations, currentIndex) {
		dataSource.indicatorColumn().item(currentIndex, (dataSource.highColumn().item(currentIndex) + dataSource.lowColumn().item(currentIndex) + (dataSource.closeColumn().item(currentIndex) * 2)) / 4);
		return true;
	}
	, 
	$type: new $.ig.Type('WeightedCloseIndicatorStrategy', $.ig.ItemwiseIndicatorCalculationStrategy.prototype.$type)
}, true);

$.ig.util.defType('WilliamsPercentRIndicatorStrategy', 'IndicatorCalculationStrategy', {
	init: function () {


		$.ig.IndicatorCalculationStrategy.prototype.init.call(this);

	}
	, 
	basedOn: function (dataSource, supportingCalculations) {
		var list = new $.ig.List$1(String, 0);
		list.add($.ig.FinancialSeries.prototype.highColumnPropertyName);
		list.add($.ig.FinancialSeries.prototype.lowColumnPropertyName);
		list.add($.ig.FinancialSeries.prototype.closeColumnPropertyName);
		return list;
	}

	, 
	calculateIndicator: function (dataSource, supportingCalculations) {
		var period = dataSource.period();
		var highColumn = dataSource.highColumn();
		var lowColumn = dataSource.lowColumn();
		for (var i = 0; i < dataSource.count(); i++) {
			var ago = Math.min(period, i);
			var highestHigh = -1.7976931348623157E+308;
			var lowestLow = 1.7976931348623157E+308;
			for (var j = 0; j < ago; j++) {
				if (!$.ig.util.isNaN(highColumn.item(i - j))) {
					highestHigh = Math.max(highestHigh, highColumn.item(i - j));
				}

				if (!$.ig.util.isNaN(lowColumn.item(i - j))) {
					lowestLow = Math.min(lowestLow, lowColumn.item(i - j));
				}

			}

			dataSource.indicatorColumn().item(i, supportingCalculations.makeSafe()((dataSource.closeColumn().item(i) - highestHigh) / (highestHigh - lowestLow) * 100));
		}

		return true;
	}
	, 
	$type: new $.ig.Type('WilliamsPercentRIndicatorStrategy', $.ig.IndicatorCalculationStrategy.prototype.$type)
}, true);

































$.ig.util.defType('SafeEnumerable___MakeSafe__IteratorClass', 'Object', {
	__1__state: 0
	, 
	__2__current: 0
	, 
	_valueEnumerator: null
	, 
	__value_5_0: 0
	, 
	__4__this: null
	, 
	init: function (_1__state) {



		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	_m_Finally0: function () {
		this.__1__state = -1;
		if (this._valueEnumerator != null) {
			this._valueEnumerator.dispose();
		}

	}

	, 
	moveNext: function () {
		var __hasError__ = false;
		try {
				while (this.__1__state >= 0) {
					switch (this.__1__state) {
						case 0:
							this.__1__state = -1;
							if (this.__4__this.__target == null) {
								return false;
							}

							this.__1__state = 1;
							this._valueEnumerator = this.__4__this.__target.getEnumerator();
							this.__1__state = 2;
							break;
						case 2:
							this.__1__state = 1;
							if (this._valueEnumerator.moveNext()) {
								this.__value_5_0 = this._valueEnumerator.current();
								this.__2__current = this.__4__this.makeSafe1(this.__value_5_0);
								this.__1__state = 2;
								return true;
							}

							this._m_Finally0();
							break;
					}


				}

		}
		catch (e) {
				__hasError__ = true;
				throw e;

		}finally {
				if (__hasError__) {
				(this).dispose();
				}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.SafeEnumerable___MakeSafe__IteratorClass(0);
			d__.__4__this = this.__4__this;
		}

		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
		switch (this.__1__state) {
			case 1:
			case 2:
				this._m_Finally0();
				break;
		}

	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('SafeEnumerable___MakeSafe__IteratorClass', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(Number), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize(Number), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

$.ig.util.defType('SafeSortedReadOnlyDoubleCollection___GetEnumerator__IteratorClass', 'Object', {
	__1__state: 0
	, 
	__2__current: 0
	, 
	__i_5_0: 0
	, 
	__4__this: null
	, 
	init: function (_1__state) {



		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	moveNext: function () {
		while (this.__1__state >= 0) {
			switch (this.__1__state) {
				case 0:
					this.__1__state = -1;
					this.__i_5_0 = 0;
					this.__1__state = 1;
					break;
				case 1:
					this.__1__state = -1;
					if (this.__i_5_0 < this.__4__this.__target.count()) {
						this.__2__current = this.__4__this.item(this.__i_5_0);
						this.__1__state = 2;
						return true;
					}

					break;
				case 2:
					this.__1__state = -1;
					this.__i_5_0++;
					this.__1__state = 1;
					break;
			}


		}
		return false;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('SafeSortedReadOnlyDoubleCollection___GetEnumerator__IteratorClass', $.ig.Object.prototype.$type, [$.ig.IEnumerator$1.prototype.$type.specialize(Number), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

$.ig.util.defType('SortedListView___GetEnumerator__IteratorClass$1', 'Object', {
	$t: null, 
	__1__state: 0
	, 
	__2__current: null
	, 
	__i_5_0: 0
	, 
	__4__this: null
	, 
	init: function ($t, _1__state) {

		this.$t = $t;
		this.$type = this.$type.specialize(this.$t);


		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	moveNext: function () {
		while (this.__1__state >= 0) {
			switch (this.__1__state) {
				case 0:
					this.__1__state = -1;
					this.__i_5_0 = 0;
					this.__1__state = 1;
					break;
				case 1:
					this.__1__state = -1;
					if (this.__i_5_0 < this.__4__this.count()) {
						this.__2__current = $.ig.util.getBoxIfEnum(this.$t, this.__4__this.item(this.__i_5_0));
						this.__1__state = 2;
						return true;
					}

					break;
				case 2:
					this.__1__state = -1;
					this.__i_5_0++;
					this.__1__state = 1;
					break;
			}


		}
		return false;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('SortedListView___GetEnumerator__IteratorClass$1', $.ig.Object.prototype.$type, [$.ig.IEnumerator$1.prototype.$type.specialize($.ig.Object.prototype.$type), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

$.ig.util.defType('FinancialSeries___get_TR__IteratorClass', 'Object', {
	__1__state: 0
	, 
	__2__current: 0
	, 
	__count_5_0: 0
	, 
	__sorted_5_1: null
	, 
	__i_5_2: 0
	, 
	__count_5_3: 0
	, 
	__i_5_4: 0
	, 
	__4__this: null
	, 
	init: function (_1__state) {



		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	moveNext: function () {
		while (this.__1__state >= 0) {
			switch (this.__1__state) {
				case 0:
					this.__1__state = -1;
					if (this.__4__this.xAxisSortRequired() && ($.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.__4__this.xAxis())).sortedIndices() != null) {
						this.__count_5_0 = this.__4__this.highColumn().count();
						this.__sorted_5_1 = ($.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.__4__this.xAxis())).sortedIndices();
						if (this.__count_5_0 > 0) {
							this.__2__current = this.__4__this.makeSafe(this.__4__this.highColumn().item(this.__sorted_5_1.item(0)) - this.__4__this.lowColumn().item(this.__sorted_5_1.item(0)));
							this.__1__state = 1;
							return true;
						}

						this.__1__state = 1;
						break;
					}

					this.__count_5_3 = this.__4__this.highColumn().count();
					if (this.__count_5_3 > 0) {
						this.__2__current = this.__4__this.makeSafe(this.__4__this.highColumn().item(0) - this.__4__this.lowColumn().item(0));
						this.__1__state = 4;
						return true;
					}

					this.__1__state = 4;
					break;
				case 1:
					this.__1__state = -1;
					this.__i_5_2 = 1;
					this.__1__state = 2;
					break;
				case 2:
					this.__1__state = -1;
					if (this.__i_5_2 < this.__count_5_0) {
						this.__2__current = Math.max(this.__4__this.makeSafe(this.__4__this.highColumn().item(this.__sorted_5_1.item(this.__i_5_2)) - this.__4__this.lowColumn().item(this.__sorted_5_1.item(this.__i_5_2))), Math.max(this.__4__this.makeSafe(Math.abs(this.__4__this.highColumn().item(this.__sorted_5_1.item(this.__i_5_2)) - this.__4__this.closeColumn().item(this.__sorted_5_1.item(this.__i_5_2 - 1)))), this.__4__this.makeSafe(Math.abs(this.__4__this.lowColumn().item(this.__sorted_5_1.item(this.__i_5_2)) - this.__4__this.closeColumn().item(this.__sorted_5_1.item(this.__i_5_2 - 1))))));
						this.__1__state = 3;
						return true;
					}

					break;
				case 3:
					this.__1__state = -1;
					++this.__i_5_2;
					this.__1__state = 2;
					break;
				case 4:
					this.__1__state = -1;
					this.__i_5_4 = 1;
					this.__1__state = 5;
					break;
				case 5:
					this.__1__state = -1;
					if (this.__i_5_4 < this.__count_5_3) {
						this.__2__current = Math.max(this.__4__this.makeSafe(this.__4__this.highColumn().item(this.__i_5_4) - this.__4__this.lowColumn().item(this.__i_5_4)), Math.max(this.__4__this.makeSafe(Math.abs(this.__4__this.highColumn().item(this.__i_5_4) - this.__4__this.closeColumn().item(this.__i_5_4 - 1))), this.__4__this.makeSafe(Math.abs(this.__4__this.lowColumn().item(this.__i_5_4) - this.__4__this.closeColumn().item(this.__i_5_4 - 1)))));
						this.__1__state = 6;
						return true;
					}

					break;
				case 6:
					this.__1__state = -1;
					++this.__i_5_4;
					this.__1__state = 5;
					break;
			}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.FinancialSeries___get_TR__IteratorClass(0);
			d__.__4__this = this.__4__this;
		}

		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('FinancialSeries___get_TR__IteratorClass', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(Number), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize(Number), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

$.ig.util.defType('PercentKCalculationStrategy___ProvideStream__IteratorClass', 'Object', {
	__1__state: 0
	, 
	__2__current: 0
	, 
	__period_5_0: 0
	, 
	__highColumn_5_1: null
	, 
	__lowColumn_5_2: null
	, 
	__i_5_3: 0
	, 
	__ago_5_4: 0
	, 
	__highestHigh_5_5: 0
	, 
	__lowestLow_5_6: 0
	, 
	_dataSource: null
	, 
	__3__dataSource: null
	, 
	_supportingCalculations: null
	, 
	__3__supportingCalculations: null
	, 
	__4__this: null
	, 
	init: function (_1__state) {



		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	moveNext: function () {
		while (this.__1__state >= 0) {
			switch (this.__1__state) {
				case 0:
					this.__1__state = -1;
					this.__period_5_0 = this._dataSource.period();
					this.__highColumn_5_1 = this._dataSource.highColumn();
					this.__lowColumn_5_2 = this._dataSource.lowColumn();
					this.__i_5_3 = 0;
					this.__1__state = 1;
					break;
				case 1:
					this.__1__state = -1;
					if (this.__i_5_3 < this._dataSource.count()) {
						this.__ago_5_4 = Math.min(this.__period_5_0, this.__i_5_3);
						this.__highestHigh_5_5 = -1.7976931348623157E+308;
						this.__lowestLow_5_6 = 1.7976931348623157E+308;
						for (var j = 0; j < this.__ago_5_4; j++) {
							if (!$.ig.util.isNaN(this.__highColumn_5_1.item(this.__i_5_3 - j))) {
								this.__highestHigh_5_5 = Math.max(this.__highestHigh_5_5, this.__highColumn_5_1.item(this.__i_5_3 - j));
							}

							if (!$.ig.util.isNaN(this.__lowColumn_5_2.item(this.__i_5_3 - j))) {
								this.__lowestLow_5_6 = Math.min(this.__lowestLow_5_6, this.__lowColumn_5_2.item(this.__i_5_3 - j));
							}

						}

						this.__2__current = this._supportingCalculations.makeSafe()((this._dataSource.closeColumn().item(this.__i_5_3) - this.__lowestLow_5_6) / (this.__highestHigh_5_5 - this.__lowestLow_5_6) * 100);
						this.__1__state = 2;
						return true;
					}

					break;
				case 2:
					this.__1__state = -1;
					this.__i_5_3++;
					this.__1__state = 1;
					break;
			}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.PercentKCalculationStrategy___ProvideStream__IteratorClass(0);
			d__.__4__this = this.__4__this;
		}

		d__._dataSource = this.__3__dataSource;
		d__._supportingCalculations = this.__3__supportingCalculations;
		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('PercentKCalculationStrategy___ProvideStream__IteratorClass', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(Number), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize(Number), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

$.ig.util.defType('FinancialSeries___get_TypicalColumn__IteratorClass', 'Object', {
	__1__state: 0
	, 
	__2__current: 0
	, 
	__userSpecified_5_0: false
	, 
	__dataSource_5_1: null
	, 
	_valueEnumerator: null
	, 
	__value_5_2: 0
	, 
	__count_5_3: 0
	, 
	__sorted_5_4: null
	, 
	__i_5_5: 0
	, 
	__count_5_6: 0
	, 
	__i_5_7: 0
	, 
	__4__this: null
	, 
	init: function (_1__state) {



		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	_m_Finally0: function () {
		this.__1__state = -1;
		if (this._valueEnumerator != null) {
			this._valueEnumerator.dispose();
		}

	}

	, 
	moveNext: function () {
		var __hasError__ = false;
		try {
				while (this.__1__state >= 0) {
					switch (this.__1__state) {
						case 0:
							this.__1__state = -1;
							this.__userSpecified_5_0 = false;
							if (this.__4__this.hasTypical()) {
								this.__dataSource_5_1 = this.__4__this.provideDataSource(0, this.__4__this.fastItemsSource().count());
								this.__4__this.callTypical(new $.ig.FinancialEventArgs(0, this.__4__this.fastItemsSource().count(), this.__dataSource_5_1, this.__4__this.provideSupportingCalculations(this.__dataSource_5_1)));
								if (this.__dataSource_5_1.typicalColumn() != null) {
									this.__userSpecified_5_0 = true;
									this.__1__state = 1;
									this._valueEnumerator = this.__dataSource_5_1.typicalColumn().getEnumerator();
									this.__1__state = 2;
									break;
								}

							}

							if (!this.__userSpecified_5_0) {
								if (this.__4__this.xAxisSortRequired() && ($.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.__4__this.xAxis())).sortedIndices() != null) {
									this.__count_5_3 = this.__4__this.fastItemsSource().count();
									this.__sorted_5_4 = ($.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.__4__this.xAxis())).sortedIndices();
									this.__i_5_5 = 0;
									this.__1__state = 3;
									break;
								}

								this.__count_5_6 = this.__4__this.fastItemsSource().count();
								this.__i_5_7 = 0;
								this.__1__state = 5;
								break;
							}

							break;
						case 2:
							this.__1__state = 1;
							if (this._valueEnumerator.moveNext()) {
								this.__value_5_2 = this._valueEnumerator.current();
								this.__2__current = this.__value_5_2;
								this.__1__state = 2;
								return true;
							}

							this._m_Finally0();
							if (!this.__userSpecified_5_0) {
								if (this.__4__this.xAxisSortRequired() && ($.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.__4__this.xAxis())).sortedIndices() != null) {
									this.__count_5_3 = this.__4__this.fastItemsSource().count();
									this.__sorted_5_4 = ($.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.__4__this.xAxis())).sortedIndices();
									this.__i_5_5 = 0;
									this.__1__state = 3;
									break;
								}

								this.__count_5_6 = this.__4__this.fastItemsSource().count();
								this.__i_5_7 = 0;
								this.__1__state = 5;
								break;
							}

							break;
						case 3:
							this.__1__state = -1;
							if (this.__i_5_5 < this.__count_5_3) {
								this.__2__current = (this.__4__this.highColumn().item(this.__sorted_5_4.item(this.__i_5_5)) + this.__4__this.lowColumn().item(this.__sorted_5_4.item(this.__i_5_5)) + this.__4__this.closeColumn().item(this.__sorted_5_4.item(this.__i_5_5))) / 3;
								this.__1__state = 4;
								return true;
							}

							break;
						case 4:
							this.__1__state = -1;
							++this.__i_5_5;
							this.__1__state = 3;
							break;
						case 5:
							this.__1__state = -1;
							if (this.__i_5_7 < this.__count_5_6) {
								this.__2__current = (this.__4__this.highColumn().item(this.__i_5_7) + this.__4__this.lowColumn().item(this.__i_5_7) + this.__4__this.closeColumn().item(this.__i_5_7)) / 3;
								this.__1__state = 6;
								return true;
							}

							break;
						case 6:
							this.__1__state = -1;
							++this.__i_5_7;
							this.__1__state = 5;
							break;
					}


				}

		}
		catch (e) {
				__hasError__ = true;
				throw e;

		}finally {
				if (__hasError__) {
				(this).dispose();
				}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.FinancialSeries___get_TypicalColumn__IteratorClass(0);
			d__.__4__this = this.__4__this;
		}

		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
		switch (this.__1__state) {
			case 1:
			case 2:
				this._m_Finally0();
				break;
		}

	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('FinancialSeries___get_TypicalColumn__IteratorClass', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(Number), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize(Number), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);






$.ig.util.defType('SortedListView___GetEnumerator__IteratorClass1$1', 'Object', {
	$t: null, 
	__1__state: 0
	, 
	__2__current: null
	, 
	__i_5_0: 0
	, 
	__4__this: null
	, 
	init: function ($t, _1__state) {

		this.$t = $t;
		this.$type = this.$type.specialize(this.$t);


		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	moveNext: function () {
		while (this.__1__state >= 0) {
			switch (this.__1__state) {
				case 0:
					this.__1__state = -1;
					this.__i_5_0 = 0;
					this.__1__state = 1;
					break;
				case 1:
					this.__1__state = -1;
					if (this.__i_5_0 < this.__4__this.count()) {
						this.__2__current = this.__4__this.item(this.__i_5_0);
						this.__1__state = 2;
						return true;
					}

					break;
				case 2:
					this.__1__state = -1;
					this.__i_5_0++;
					this.__1__state = 1;
					break;
			}


		}
		return false;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('SortedListView___GetEnumerator__IteratorClass1$1', $.ig.Object.prototype.$type, [$.ig.IEnumerator$1.prototype.$type.specialize(0), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);



$.ig.util.defType('RelativeStrengthIndexIndicatorStrategy___ProvideStream__IteratorClass', 'Object', {
	__1__state: 0
	, 
	__2__current: 0
	, 
	__period_5_0: 0
	, 
	__alpha_5_1: 0
	, 
	__uema_5_2: 0
	, 
	__dema_5_3: 0
	, 
	__indicatorColumn_5_4: null
	, 
	__closeColumn_5_5: null
	, 
	__i_5_6: 0
	, 
	__c_5_7: 0
	, 
	__u_5_8: 0
	, 
	__d_5_9: 0
	, 
	__i_5_10: 0
	, 
	__c_5_11: 0
	, 
	__u_5_12: 0
	, 
	__d_5_13: 0
	, 
	_dataSource: null
	, 
	__3__dataSource: null
	, 
	_supportingCalculations: null
	, 
	__3__supportingCalculations: null
	, 
	__4__this: null
	, 
	init: function (_1__state) {



		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	moveNext: function () {
		while (this.__1__state >= 0) {
			switch (this.__1__state) {
				case 0:
					this.__1__state = -1;
					this.__period_5_0 = this._dataSource.period();
					this.__alpha_5_1 = 2 / (this.__period_5_0 + 1);
					this.__uema_5_2 = 0;
					this.__dema_5_3 = 0;
					this.__indicatorColumn_5_4 = this._dataSource.indicatorColumn();
					this.__closeColumn_5_5 = this._dataSource.closeColumn();
					if (this.__indicatorColumn_5_4.count() > 0) {
						this.__2__current = 0;
						this.__1__state = 1;
						return true;
					}

					this.__1__state = 1;
					break;
				case 1:
					this.__1__state = -1;
					this.__i_5_6 = 1;
					this.__1__state = 2;
					break;
				case 2:
					this.__1__state = -1;
					if (this.__i_5_6 < Math.min(this._dataSource.period(), this.__indicatorColumn_5_4.count())) {
						this.__c_5_7 = this.__closeColumn_5_5.item(this.__i_5_6) - this.__closeColumn_5_5.item(this.__i_5_6 - 1);
						this.__u_5_8 = this.__c_5_7 > 0 ? this.__c_5_7 : 0;
						this.__d_5_9 = this.__c_5_7 > 0 ? 0 : -this.__c_5_7;
						this.__uema_5_2 += this.__u_5_8 / (this.__period_5_0 - 1);
						this.__dema_5_3 += this.__d_5_9 / (this.__period_5_0 - 1);
						this.__2__current = 0;
						this.__1__state = 3;
						return true;
					}

					this.__i_5_10 = this._dataSource.period();
					this.__1__state = 4;
					break;
				case 3:
					this.__1__state = -1;
					++this.__i_5_6;
					this.__1__state = 2;
					break;
				case 4:
					this.__1__state = -1;
					if (this.__i_5_10 < this.__indicatorColumn_5_4.count()) {
						this.__c_5_11 = this.__closeColumn_5_5.item(this.__i_5_10) - this.__closeColumn_5_5.item(this.__i_5_10 - 1);
						this.__u_5_12 = this.__c_5_11 > 0 ? this.__c_5_11 : 0;
						this.__d_5_13 = this.__c_5_11 > 0 ? 0 : -this.__c_5_11;
						this.__uema_5_2 = (this.__uema_5_2 * (this.__period_5_0 - 1) + this.__u_5_12) / this.__period_5_0;
						this.__dema_5_3 = (this.__dema_5_3 * (this.__period_5_0 - 1) + this.__d_5_13) / this.__period_5_0;
						this.__2__current = this._supportingCalculations.makeSafe()(this.__uema_5_2 != 0 ? 100 * this.__uema_5_2 / (this.__uema_5_2 + this.__dema_5_3) : 0);
						this.__1__state = 5;
						return true;
					}

					break;
				case 5:
					this.__1__state = -1;
					++this.__i_5_10;
					this.__1__state = 4;
					break;
			}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.RelativeStrengthIndexIndicatorStrategy___ProvideStream__IteratorClass(0);
			d__.__4__this = this.__4__this;
		}

		d__._dataSource = this.__3__dataSource;
		d__._supportingCalculations = this.__3__supportingCalculations;
		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('RelativeStrengthIndexIndicatorStrategy___ProvideStream__IteratorClass', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(Number), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize(Number), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);


$.ig.util.defType('AccumulationDistributionIndicatorStrategy___ProvideStream__IteratorClass', 'Object', {
	__1__state: 0
	, 
	__2__current: 0
	, 
	__ad_5_0: 0
	, 
	__min_5_1: 0
	, 
	__max_5_2: 0
	, 
	__indicatorCount_5_3: 0
	, 
	__closeCount_5_4: 0
	, 
	__highCount_5_5: 0
	, 
	__volumeCount_5_6: 0
	, 
	__count_5_7: 0
	, 
	__i_5_8: 0
	, 
	__c_5_9: 0
	, 
	__l_5_10: 0
	, 
	__h_5_11: 0
	, 
	__v_5_12: 0
	, 
	__cLV_5_13: 0
	, 
	_dataSource: null
	, 
	__3__dataSource: null
	, 
	_supportingCalculations: null
	, 
	__3__supportingCalculations: null
	, 
	__4__this: null
	, 
	init: function (_1__state) {



		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	moveNext: function () {
		while (this.__1__state >= 0) {
			switch (this.__1__state) {
				case 0:
					this.__1__state = -1;
					this.__ad_5_0 = 0;
					this.__min_5_1 = Number.POSITIVE_INFINITY;
					this.__max_5_2 = Number.NEGATIVE_INFINITY;
					this.__indicatorCount_5_3 = this._dataSource.indicatorColumn() != null ? this._dataSource.indicatorColumn().count() : 0;
					this.__closeCount_5_4 = this._dataSource.closeColumn() != null ? this._dataSource.closeColumn().count() : 0;
					this.__highCount_5_5 = this._dataSource.highColumn() != null ? this._dataSource.highColumn().count() : 0;
					this.__volumeCount_5_6 = this._dataSource.volumeColumn() != null ? this._dataSource.volumeColumn().count() : 0;
					this.__count_5_7 = Math.min(this.__indicatorCount_5_3, Math.min(this.__closeCount_5_4, Math.min(this.__highCount_5_5, this.__volumeCount_5_6)));
					this.__i_5_8 = 0;
					this.__1__state = 1;
					break;
				case 1:
					this.__1__state = -1;
					if (this.__i_5_8 < this.__count_5_7) {
						this.__c_5_9 = this._dataSource.closeColumn().item(this.__i_5_8);
						this.__l_5_10 = this._dataSource.lowColumn().item(this.__i_5_8);
						this.__h_5_11 = this._dataSource.highColumn().item(this.__i_5_8);
						this.__v_5_12 = this._dataSource.volumeColumn().item(this.__i_5_8);
						this.__cLV_5_13 = ((this.__c_5_9 - this.__l_5_10) - (this.__h_5_11 - this.__c_5_9)) / (this.__h_5_11 - this.__l_5_10);
						this.__ad_5_0 += this._supportingCalculations.makeSafe()(this.__cLV_5_13 * this.__v_5_12);
						this.__min_5_1 = Math.min(this.__min_5_1, this.__ad_5_0);
						this.__max_5_2 = Math.max(this.__max_5_2, this.__ad_5_0);
						this.__2__current = this.__ad_5_0;
						this.__1__state = 2;
						return true;
					}

					break;
				case 2:
					this.__1__state = -1;
					++this.__i_5_8;
					this.__1__state = 1;
					break;
			}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.AccumulationDistributionIndicatorStrategy___ProvideStream__IteratorClass(0);
			d__.__4__this = this.__4__this;
		}

		d__._dataSource = this.__3__dataSource;
		d__._supportingCalculations = this.__3__supportingCalculations;
		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('AccumulationDistributionIndicatorStrategy___ProvideStream__IteratorClass', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(Number), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize(Number), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

$.ig.util.defType('FinancialSeries___get_TL__IteratorClass', 'Object', {
	__1__state: 0
	, 
	__2__current: 0
	, 
	__count_5_0: 0
	, 
	__sorted_5_1: null
	, 
	__i_5_2: 0
	, 
	__count_5_3: 0
	, 
	__i_5_4: 0
	, 
	__4__this: null
	, 
	init: function (_1__state) {



		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	moveNext: function () {
		while (this.__1__state >= 0) {
			switch (this.__1__state) {
				case 0:
					this.__1__state = -1;
					if (this.__4__this.xAxisSortRequired() && ($.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.__4__this.xAxis())).sortedIndices() != null) {
						this.__count_5_0 = this.__4__this.lowColumn().count();
						this.__sorted_5_1 = ($.ig.util.cast($.ig.ISortingAxis.prototype.$type, this.__4__this.xAxis())).sortedIndices();
						if (this.__count_5_0 > 0) {
							this.__2__current = this.__4__this.makeSafe(this.__4__this.lowColumn().item(this.__sorted_5_1.item(0)));
							this.__1__state = 1;
							return true;
						}

						this.__1__state = 1;
						break;
					}

					this.__count_5_3 = this.__4__this.lowColumn().count();
					if (this.__count_5_3 > 0) {
						this.__2__current = this.__4__this.makeSafe(this.__4__this.lowColumn().item(0));
						this.__1__state = 4;
						return true;
					}

					this.__1__state = 4;
					break;
				case 1:
					this.__1__state = -1;
					this.__i_5_2 = 1;
					this.__1__state = 2;
					break;
				case 2:
					this.__1__state = -1;
					if (this.__i_5_2 < this.__count_5_0) {
						this.__2__current = Math.min(this.__4__this.makeSafe(this.__4__this.lowColumn().item(this.__sorted_5_1.item(this.__i_5_2))), this.__4__this.makeSafe(this.__4__this.closeColumn().item(this.__sorted_5_1.item(this.__i_5_2 - 1))));
						this.__1__state = 3;
						return true;
					}

					break;
				case 3:
					this.__1__state = -1;
					this.__i_5_2++;
					this.__1__state = 2;
					break;
				case 4:
					this.__1__state = -1;
					this.__i_5_4 = 1;
					this.__1__state = 5;
					break;
				case 5:
					this.__1__state = -1;
					if (this.__i_5_4 < this.__count_5_3) {
						this.__2__current = Math.min(this.__4__this.makeSafe(this.__4__this.lowColumn().item(this.__i_5_4)), this.__4__this.makeSafe(this.__4__this.closeColumn().item(this.__i_5_4 - 1)));
						this.__1__state = 6;
						return true;
					}

					break;
				case 6:
					this.__1__state = -1;
					this.__i_5_4++;
					this.__1__state = 5;
					break;
			}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.FinancialSeries___get_TL__IteratorClass(0);
			d__.__4__this = this.__4__this;
		}

		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('FinancialSeries___get_TL__IteratorClass', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(Number), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize(Number), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

$.ig.util.defType('AverageDirectionalIndexIndicatorStrategy___PlusDM__IteratorClass', 'Object', {
	__1__state: 0
	, 
	__2__current: 0
	, 
	__upMove_5_0: 0
	, 
	__downMove_5_1: 0
	, 
	__i_5_2: 0
	, 
	_highColumn: null
	, 
	__3__highColumn: null
	, 
	_lowColumn: null
	, 
	__3__lowColumn: null
	, 
	__4__this: null
	, 
	init: function (_1__state) {



		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	moveNext: function () {
		while (this.__1__state >= 0) {
			switch (this.__1__state) {
				case 0:
					this.__1__state = -1;
					this.__2__current = 0;
					this.__1__state = 1;
					return true;
				case 1:
					this.__1__state = -1;
					this.__upMove_5_0 = 0;
					this.__downMove_5_1 = 0;
					this.__i_5_2 = 1;
					this.__1__state = 2;
					break;
				case 2:
					this.__1__state = -1;
					if (this.__i_5_2 < this._highColumn.count()) {
						this.__upMove_5_0 = this.__4__this.upMove(this.__i_5_2, this._highColumn, this._lowColumn);
						this.__downMove_5_1 = this.__4__this.downMove(this.__i_5_2, this._highColumn, this._lowColumn);
						if (this.__upMove_5_0 > this.__downMove_5_1 && this.__upMove_5_0 > 0) {
							this.__2__current = this.__upMove_5_0;
							this.__1__state = 3;
							return true;
						}

						this.__2__current = 0;
						this.__1__state = 3;
						return true;
					}

					break;
				case 3:
					this.__1__state = -1;
					this.__i_5_2++;
					this.__1__state = 2;
					break;
			}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.AverageDirectionalIndexIndicatorStrategy___PlusDM__IteratorClass(0);
			d__.__4__this = this.__4__this;
		}

		d__._highColumn = this.__3__highColumn;
		d__._lowColumn = this.__3__lowColumn;
		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('AverageDirectionalIndexIndicatorStrategy___PlusDM__IteratorClass', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(Number), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize(Number), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

$.ig.util.defType('AverageDirectionalIndexIndicatorStrategy___MinusDM__IteratorClass', 'Object', {
	__1__state: 0
	, 
	__2__current: 0
	, 
	__upMove_5_0: 0
	, 
	__downMove_5_1: 0
	, 
	__i_5_2: 0
	, 
	_highColumn: null
	, 
	__3__highColumn: null
	, 
	_lowColumn: null
	, 
	__3__lowColumn: null
	, 
	__4__this: null
	, 
	init: function (_1__state) {



		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	moveNext: function () {
		while (this.__1__state >= 0) {
			switch (this.__1__state) {
				case 0:
					this.__1__state = -1;
					this.__2__current = 0;
					this.__1__state = 1;
					return true;
				case 1:
					this.__1__state = -1;
					this.__upMove_5_0 = 0;
					this.__downMove_5_1 = 0;
					this.__i_5_2 = 1;
					this.__1__state = 2;
					break;
				case 2:
					this.__1__state = -1;
					if (this.__i_5_2 < this._highColumn.count()) {
						this.__upMove_5_0 = this.__4__this.upMove(this.__i_5_2, this._highColumn, this._lowColumn);
						this.__downMove_5_1 = this.__4__this.downMove(this.__i_5_2, this._highColumn, this._lowColumn);
						if (this.__downMove_5_1 > this.__upMove_5_0 && this.__downMove_5_1 > 0) {
							this.__2__current = this.__downMove_5_1;
							this.__1__state = 3;
							return true;
						}

						this.__2__current = 0;
						this.__1__state = 3;
						return true;
					}

					break;
				case 3:
					this.__1__state = -1;
					this.__i_5_2++;
					this.__1__state = 2;
					break;
			}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.AverageDirectionalIndexIndicatorStrategy___MinusDM__IteratorClass(0);
			d__.__4__this = this.__4__this;
		}

		d__._highColumn = this.__3__highColumn;
		d__._lowColumn = this.__3__lowColumn;
		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('AverageDirectionalIndexIndicatorStrategy___MinusDM__IteratorClass', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(Number), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize(Number), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

$.ig.util.defType('AverageDirectionalIndexIndicatorStrategy___PlusDI__IteratorClass', 'Object', {
	__1__state: 0
	, 
	__2__current: 0
	, 
	__emaPlusDM_5_0: null
	, 
	__averageTrueRange_5_1: null
	, 
	_dataSource: null
	, 
	__3__dataSource: null
	, 
	_supportingCalculations: null
	, 
	__3__supportingCalculations: null
	, 
	__4__this: null
	, 
	init: function (_1__state) {



		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	moveNext: function () {
		while (this.__1__state >= 0) {
			switch (this.__1__state) {
				case 0:
					this.__1__state = -1;
					this.__emaPlusDM_5_0 = this._supportingCalculations.eMA().strategy()(this.__4__this.plusDM(this._dataSource.highColumn(), this._dataSource.lowColumn()), this._dataSource.period()).getEnumerator();
					this.__averageTrueRange_5_1 = this._supportingCalculations.eMA().strategy()(this._dataSource.trueRange(), this._dataSource.period()).getEnumerator();
					this.__1__state = 1;
					break;
				case 1:
					this.__1__state = -1;
					if (this.__emaPlusDM_5_0.moveNext() && this.__averageTrueRange_5_1.moveNext()) {
						this.__2__current = this._supportingCalculations.makeSafe()(this.__emaPlusDM_5_0.current() / this.__averageTrueRange_5_1.current());
						this.__1__state = 1;
						return true;
					}

					break;
			}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.AverageDirectionalIndexIndicatorStrategy___PlusDI__IteratorClass(0);
			d__.__4__this = this.__4__this;
		}

		d__._dataSource = this.__3__dataSource;
		d__._supportingCalculations = this.__3__supportingCalculations;
		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('AverageDirectionalIndexIndicatorStrategy___PlusDI__IteratorClass', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(Number), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize(Number), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

$.ig.util.defType('AverageDirectionalIndexIndicatorStrategy___MinusDI__IteratorClass', 'Object', {
	__1__state: 0
	, 
	__2__current: 0
	, 
	__emaMinusDM_5_0: null
	, 
	__averageTrueRange_5_1: null
	, 
	_dataSource: null
	, 
	__3__dataSource: null
	, 
	_supportingCalculations: null
	, 
	__3__supportingCalculations: null
	, 
	__4__this: null
	, 
	init: function (_1__state) {



		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	moveNext: function () {
		while (this.__1__state >= 0) {
			switch (this.__1__state) {
				case 0:
					this.__1__state = -1;
					this.__emaMinusDM_5_0 = this._supportingCalculations.eMA().strategy()(this.__4__this.minusDM(this._dataSource.highColumn(), this._dataSource.lowColumn()), this._dataSource.period()).getEnumerator();
					this.__averageTrueRange_5_1 = this._supportingCalculations.eMA().strategy()(this._dataSource.trueRange(), this._dataSource.period()).getEnumerator();
					this.__1__state = 1;
					break;
				case 1:
					this.__1__state = -1;
					if (this.__emaMinusDM_5_0.moveNext() && this.__averageTrueRange_5_1.moveNext()) {
						this.__2__current = this._supportingCalculations.makeSafe()(this.__emaMinusDM_5_0.current() / this.__averageTrueRange_5_1.current());
						this.__1__state = 1;
						return true;
					}

					break;
			}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.AverageDirectionalIndexIndicatorStrategy___MinusDI__IteratorClass(0);
			d__.__4__this = this.__4__this;
		}

		d__._dataSource = this.__3__dataSource;
		d__._supportingCalculations = this.__3__supportingCalculations;
		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('AverageDirectionalIndexIndicatorStrategy___MinusDI__IteratorClass', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(Number), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize(Number), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

$.ig.util.defType('AverageDirectionalIndexIndicatorStrategy___ADXHelper__IteratorClass', 'Object', {
	__1__state: 0
	, 
	__2__current: 0
	, 
	__plusDI_5_0: null
	, 
	__minusDI_5_1: null
	, 
	_dataSource: null
	, 
	__3__dataSource: null
	, 
	_supportingCalculations: null
	, 
	__3__supportingCalculations: null
	, 
	__4__this: null
	, 
	init: function (_1__state) {



		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	moveNext: function () {
		while (this.__1__state >= 0) {
			switch (this.__1__state) {
				case 0:
					this.__1__state = -1;
					this.__plusDI_5_0 = this.__4__this.plusDI(this._dataSource, this._supportingCalculations).getEnumerator();
					this.__minusDI_5_1 = this.__4__this.minusDI(this._dataSource, this._supportingCalculations).getEnumerator();
					this.__plusDI_5_0.moveNext();
					this.__minusDI_5_1.moveNext();
					this.__1__state = 1;
					break;
				case 1:
					this.__1__state = -1;
					if (this.__plusDI_5_0.moveNext() && this.__minusDI_5_1.moveNext()) {
						this.__2__current = Math.abs(this._supportingCalculations.makeSafe()((this.__plusDI_5_0.current() - this.__minusDI_5_1.current()) / (this.__plusDI_5_0.current() + this.__minusDI_5_1.current())));
						this.__1__state = 1;
						return true;
					}

					break;
			}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.AverageDirectionalIndexIndicatorStrategy___ADXHelper__IteratorClass(0);
			d__.__4__this = this.__4__this;
		}

		d__._dataSource = this.__3__dataSource;
		d__._supportingCalculations = this.__3__supportingCalculations;
		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('AverageDirectionalIndexIndicatorStrategy___ADXHelper__IteratorClass', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(Number), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize(Number), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

$.ig.util.defType('AverageDirectionalIndexIndicatorStrategy___ADX__IteratorClass', 'Object', {
	__1__state: 0
	, 
	__2__current: 0
	, 
	__adxHelperEMA_5_0: null
	, 
	_dataSource: null
	, 
	__3__dataSource: null
	, 
	_supportingCalculations: null
	, 
	__3__supportingCalculations: null
	, 
	__4__this: null
	, 
	init: function (_1__state) {



		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	moveNext: function () {
		switch (this.__1__state) {
			case 0:
				this.__1__state = -1;
				this.__adxHelperEMA_5_0 = this._supportingCalculations.eMA().strategy()(this.__4__this.aDXHelper(this._dataSource, this._supportingCalculations), this._dataSource.period()).getEnumerator();
				this.__2__current = 0;
				this.__1__state = 1;
				return true;
			case 1:
				this.__1__state = -1;
				if (this.__adxHelperEMA_5_0.moveNext()) {
					this.__2__current = this.__adxHelperEMA_5_0.current() * 100;
					this.__1__state = 1;
					return true;
				}

				break;
		}

		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.AverageDirectionalIndexIndicatorStrategy___ADX__IteratorClass(0);
			d__.__4__this = this.__4__this;
		}

		d__._dataSource = this.__3__dataSource;
		d__._supportingCalculations = this.__3__supportingCalculations;
		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('AverageDirectionalIndexIndicatorStrategy___ADX__IteratorClass', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(Number), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize(Number), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

$.ig.util.defType('ForceIndexIndicatorStrategy___FI__IteratorClass', 'Object', {
	__1__state: 0
	, 
	__2__current: 0
	, 
	__count_5_0: 0
	, 
	__closeColumn_5_1: null
	, 
	__volumeColumn_5_2: null
	, 
	__indicatorColumn_5_3: null
	, 
	__i_5_4: 0
	, 
	_dataSource: null
	, 
	__3__dataSource: null
	, 
	__4__this: null
	, 
	init: function (_1__state) {



		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	moveNext: function () {
		while (this.__1__state >= 0) {
			switch (this.__1__state) {
				case 0:
					this.__1__state = -1;
					this.__count_5_0 = 0;
					this.__closeColumn_5_1 = this._dataSource.closeColumn();
					this.__volumeColumn_5_2 = this._dataSource.volumeColumn();
					this.__indicatorColumn_5_3 = this._dataSource.indicatorColumn();
					if (this.__closeColumn_5_1 != null && this.__volumeColumn_5_2 != null) {
						this.__count_5_0 = Math.min(this.__closeColumn_5_1.count(), this.__volumeColumn_5_2.count());
					}

					if (this.__count_5_0 > 0) {
						this.__2__current = 0;
						this.__1__state = 1;
						return true;
					}

					this.__1__state = 1;
					break;
				case 1:
					this.__1__state = -1;
					this.__i_5_4 = 1;
					this.__1__state = 2;
					break;
				case 2:
					this.__1__state = -1;
					if (this.__i_5_4 < this.__count_5_0) {
						this.__2__current = this.__volumeColumn_5_2.item(this.__i_5_4) * (this.__closeColumn_5_1.item(this.__i_5_4) - this.__closeColumn_5_1.item(this.__i_5_4 - 1));
						this.__1__state = 3;
						return true;
					}

					break;
				case 3:
					this.__1__state = -1;
					++this.__i_5_4;
					this.__1__state = 2;
					break;
			}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.ForceIndexIndicatorStrategy___FI__IteratorClass(0);
			d__.__4__this = this.__4__this;
		}

		d__._dataSource = this.__3__dataSource;
		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('ForceIndexIndicatorStrategy___FI__IteratorClass', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(Number), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize(Number), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

$.ig.util.defType('CategoryAxisBase___RelatedAxes__IteratorClass', 'Object', {
	__1__state: 0
	, 
	__2__current: null
	, 
	__dataChart_5_0: null
	, 
	_chartEnumerator: null
	, 
	__chart_5_1: null
	, 
	__otherChart_5_2: null
	, 
	_axisEnumerator: null
	, 
	__axis_5_3: null
	, 
	__4__this: null
	, 
	init: function (_1__state) {



		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	_m_Finally0: function () {
		this.__1__state = -1;
		if (this._chartEnumerator != null) {
			this._chartEnumerator.dispose();
		}

	}

	, 
	_m_Finally1: function () {
		this.__1__state = 1;
		if (this._axisEnumerator != null) {
			this._axisEnumerator.dispose();
		}

	}

	, 
	moveNext: function () {
		var __hasError__ = false;
		try {
				while (this.__1__state >= 0) {
					switch (this.__1__state) {
						case 0:
							this.__1__state = -1;
							this.__dataChart_5_0 = $.ig.util.cast($.ig.XamDataChart.prototype.$type, this.__4__this.seriesViewer());
							if (this.__dataChart_5_0 != null && this.__dataChart_5_0.isSyncReady() && this.__4__this.shouldShareMode(this.__dataChart_5_0)) {
								this.__1__state = 1;
								this._chartEnumerator = this.__dataChart_5_0.synchronizedCharts().getEnumerator();
								this.__1__state = 2;
								break;
							}

							break;
						case 2:
							this.__1__state = 1;
							if (this._chartEnumerator.moveNext()) {
								this.__chart_5_1 = this._chartEnumerator.current();
								if (this.__chart_5_1 != this.__4__this.seriesViewer()) {
									this.__otherChart_5_2 = $.ig.util.cast($.ig.XamDataChart.prototype.$type, this.__chart_5_1);
									if (this.__otherChart_5_2 != null) {
										this.__1__state = 3;
										this._axisEnumerator = ((this.__otherChart_5_2.axes())).getEnumerator();
										this.__1__state = 4;
										break;
									}

								}

								this.__1__state = 2;
								break;
							}

							this._m_Finally0();
							break;
						case 4:
							this.__1__state = 3;
							if (this._axisEnumerator.moveNext()) {
								this.__axis_5_3 = this._axisEnumerator.current();
								if ($.ig.util.cast($.ig.CategoryAxisBase.prototype.$type, this.__axis_5_3) !== null) {
									this.__2__current = $.ig.util.cast($.ig.CategoryAxisBase.prototype.$type, this.__axis_5_3);
									this.__1__state = 4;
									return true;
								}

								this.__1__state = 4;
								break;
							}

							this._m_Finally1();
							this.__1__state = 2;
							break;
					}


				}

		}
		catch (e) {
				__hasError__ = true;
				throw e;

		}finally {
				if (__hasError__) {
				(this).dispose();
				}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.CategoryAxisBase___RelatedAxes__IteratorClass(0);
			d__.__4__this = this.__4__this;
		}

		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
		switch (this.__1__state) {
			case 1:
			case 2:
				this._m_Finally0();
				break;
			case 3:
			case 4:
				try {
						this._m_Finally1();

				}
				finally {
						this._m_Finally0();

				}
				break;
		}

	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('CategoryAxisBase___RelatedAxes__IteratorClass', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize($.ig.CategoryAxisBase.prototype.$type), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize($.ig.CategoryAxisBase.prototype.$type), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);

$.ig.util.defType('CategoryAxisBase___RelatedSeries__IteratorClass', 'Object', {
	__1__state: 0
	, 
	__2__current: null
	, 
	_currentSeriesEnumerator: null
	, 
	__currentSeries_5_0: null
	, 
	_chartEnumerator: null
	, 
	__chart_5_1: null
	, 
	_currentSeriesEnumerator0: null
	, 
	__currentSeries_5_2: null
	, 
	__4__this: null
	, 
	init: function (_1__state) {



		$.ig.Object.prototype.init.call(this);
			this.__1__state = _1__state;
	}

	, 
	_m_Finally0: function () {
		this.__1__state = -1;
		if (this._currentSeriesEnumerator != null) {
			this._currentSeriesEnumerator.dispose();
		}

	}

	, 
	_m_Finally1: function () {
		this.__1__state = -1;
		if (this._chartEnumerator != null) {
			this._chartEnumerator.dispose();
		}

	}

	, 
	_m_Finally2: function () {
		this.__1__state = 3;
		if (this._currentSeriesEnumerator0 != null) {
			this._currentSeriesEnumerator0.dispose();
		}

	}

	, 
	moveNext: function () {
		var __hasError__ = false;
		try {
				while (this.__1__state >= 0) {
					switch (this.__1__state) {
						case 0:
							this.__1__state = 1;
							this._currentSeriesEnumerator = this.__4__this.series().getEnumerator();
							this.__1__state = 2;
							break;
						case 2:
							this.__1__state = 1;
							if (this._currentSeriesEnumerator.moveNext()) {
								this.__currentSeries_5_0 = this._currentSeriesEnumerator.current();
								this.__2__current = this.__currentSeries_5_0;
								this.__1__state = 2;
								return true;
							}

							this._m_Finally0();
							if (this.__4__this.seriesViewer() != null && this.__4__this.seriesViewer().isSyncReady() && this.__4__this.shouldShareMode(this.__4__this.seriesViewer())) {
								this.__1__state = 3;
								this._chartEnumerator = this.__4__this.seriesViewer().synchronizedCharts().getEnumerator();
								this.__1__state = 4;
								break;
							}

							break;
						case 4:
							this.__1__state = 3;
							if (this._chartEnumerator.moveNext()) {
								this.__chart_5_1 = this._chartEnumerator.current();
								if (this.__chart_5_1 != this.__4__this.seriesViewer()) {
									this.__1__state = 5;
									this._currentSeriesEnumerator0 = ((this.__chart_5_1.series())).getEnumerator();
									this.__1__state = 6;
									break;
								}

								this.__1__state = 4;
								break;
							}

							this._m_Finally1();
							break;
						case 6:
							this.__1__state = 5;
							if (this._currentSeriesEnumerator0.moveNext()) {
								this.__currentSeries_5_2 = this._currentSeriesEnumerator0.current();
								this.__2__current = this.__currentSeries_5_2;
								this.__1__state = 6;
								return true;
							}

							this._m_Finally2();
							this.__1__state = 4;
							break;
					}


				}

		}
		catch (e) {
				__hasError__ = true;
				throw e;

		}finally {
				if (__hasError__) {
				(this).dispose();
				}


		}
		return false;
	}

	, 
	getEnumerator: function () {
		var d__;
		if (this.__1__state == -2) {
			this.__1__state = 0;
			d__ = this;

		} else {
			d__ = new $.ig.CategoryAxisBase___RelatedSeries__IteratorClass(0);
			d__.__4__this = this.__4__this;
		}

		return d__;
	}

	, 
	reset: function () {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	dispose: function () {
		switch (this.__1__state) {
			case 1:
			case 2:
				this._m_Finally0();
				break;
			case 3:
			case 4:
				this._m_Finally1();
				break;
			case 5:
			case 6:
				try {
						this._m_Finally2();

				}
				finally {
						this._m_Finally1();

				}
				break;
		}

	}

	, 
	current: function () {

			return this.__2__current;
	}

	, 
	current1: function () {

			return this.__2__current;
	}
	, 
	$type: new $.ig.Type('CategoryAxisBase___RelatedSeries__IteratorClass', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize($.ig.Series.prototype.$type), $.ig.IEnumerable.prototype.$type, $.ig.IEnumerator$1.prototype.$type.specialize($.ig.Series.prototype.$type), $.ig.IEnumerator.prototype.$type, $.ig.IDisposable.prototype.$type])
}, true);








$.ig.PriceDisplayType.prototype.candlestick = 0;
$.ig.PriceDisplayType.prototype.oHLC = 1;
















$.ig.TimeAxisDisplayType.prototype.continuous = 0;
$.ig.TimeAxisDisplayType.prototype.discrete = 1;



$.ig.IndicatorDisplayType.prototype.line = 0;
$.ig.IndicatorDisplayType.prototype.area = 1;
$.ig.IndicatorDisplayType.prototype.column = 2;



$.ig.CategoryTransitionInMode.prototype.auto = 0;
$.ig.CategoryTransitionInMode.prototype.fromZero = 1;
$.ig.CategoryTransitionInMode.prototype.sweepFromLeft = 2;
$.ig.CategoryTransitionInMode.prototype.sweepFromRight = 3;
$.ig.CategoryTransitionInMode.prototype.sweepFromTop = 4;
$.ig.CategoryTransitionInMode.prototype.sweepFromBottom = 5;
$.ig.CategoryTransitionInMode.prototype.sweepFromCenter = 6;
$.ig.CategoryTransitionInMode.prototype.accordionFromLeft = 7;
$.ig.CategoryTransitionInMode.prototype.accordionFromRight = 8;
$.ig.CategoryTransitionInMode.prototype.accordionFromTop = 9;
$.ig.CategoryTransitionInMode.prototype.accordionFromBottom = 10;
$.ig.CategoryTransitionInMode.prototype.expand = 11;
$.ig.CategoryTransitionInMode.prototype.sweepFromCategoryAxisMinimum = 12;
$.ig.CategoryTransitionInMode.prototype.sweepFromCategoryAxisMaximum = 13;
$.ig.CategoryTransitionInMode.prototype.sweepFromValueAxisMinimum = 14;
$.ig.CategoryTransitionInMode.prototype.sweepFromValueAxisMaximum = 15;
$.ig.CategoryTransitionInMode.prototype.accordionFromCategoryAxisMinimum = 16;
$.ig.CategoryTransitionInMode.prototype.accordionFromCategoryAxisMaximum = 17;
$.ig.CategoryTransitionInMode.prototype.accordionFromValueAxisMinimum = 18;
$.ig.CategoryTransitionInMode.prototype.accordionFromValueAxisMaximum = 19;



$.ig.NumericScaleMode.prototype.linear = 0;
$.ig.NumericScaleMode.prototype.logarithmic = 1;





















$.ig.Snapper.prototype.resolution = 7;


$.ig.CategoryAxisBase.prototype.fastItemsSourcePropertyName = "FastItemsSource";
$.ig.CategoryAxisBase.prototype.fastItemsSourceProperty = $.ig.DependencyProperty.prototype.register($.ig.CategoryAxisBase.prototype.fastItemsSourcePropertyName, $.ig.IFastItemsSource.prototype.$type, $.ig.CategoryAxisBase.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.CategoryAxisBase.prototype.$type, sender)).raisePropertyChanged($.ig.CategoryAxisBase.prototype.fastItemsSourcePropertyName, e.oldValue(), e.newValue());
}));
$.ig.CategoryAxisBase.prototype.itemsSourcePropertyName = "ItemsSource";
$.ig.CategoryAxisBase.prototype.itemsSourceProperty = $.ig.DependencyProperty.prototype.register($.ig.CategoryAxisBase.prototype.itemsSourcePropertyName, $.ig.IEnumerable.prototype.$type, $.ig.CategoryAxisBase.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	var axis = $.ig.util.cast($.ig.CategoryAxisBase.prototype.$type, sender);
	if (axis.fastItemsSourceProvider() != null) {
		axis.fastItemsSourceProvider().releaseFastItemsSource(e.oldValue());
	}

	($.ig.util.cast($.ig.CategoryAxisBase.prototype.$type, sender)).raisePropertyChanged($.ig.CategoryAxisBase.prototype.itemsSourcePropertyName, e.oldValue(), e.newValue());
}));
$.ig.CategoryAxisBase.prototype.itemsCountPropertyName = "ItemsCount";
$.ig.CategoryAxisBase.prototype.categoryModePropertyName = "CategoryMode";
$.ig.CategoryAxisBase.prototype.gapPropertyName = "Gap";
$.ig.CategoryAxisBase.prototype.gapProperty = $.ig.DependencyProperty.prototype.register($.ig.CategoryAxisBase.prototype.gapPropertyName, Number, $.ig.CategoryAxisBase.prototype.$type, new $.ig.PropertyMetadata(2, 0.2, function (sender, e) {
	($.ig.util.cast($.ig.CategoryAxisBase.prototype.$type, sender)).raisePropertyChanged($.ig.CategoryAxisBase.prototype.gapPropertyName, e.oldValue(), e.newValue());
}));
$.ig.CategoryAxisBase.prototype.overlapPropertyName = "Overlap";
$.ig.CategoryAxisBase.prototype.overlapProperty = $.ig.DependencyProperty.prototype.register($.ig.CategoryAxisBase.prototype.overlapPropertyName, Number, $.ig.CategoryAxisBase.prototype.$type, new $.ig.PropertyMetadata(2, 0, function (sender, e) {
	($.ig.util.cast($.ig.CategoryAxisBase.prototype.$type, sender)).raisePropertyChanged($.ig.CategoryAxisBase.prototype.overlapPropertyName, e.oldValue(), e.newValue());
}));
$.ig.CategoryAxisBase.prototype.useClusteringModePropertyName = "UseClusteringMode";
$.ig.CategoryAxisBase.prototype.useClusteringModeProperty = $.ig.DependencyProperty.prototype.register($.ig.CategoryAxisBase.prototype.useClusteringModePropertyName, $.ig.Boolean.prototype.$type, $.ig.CategoryAxisBase.prototype.$type, new $.ig.PropertyMetadata(2, false, function (sender, e) {
	($.ig.util.cast($.ig.CategoryAxisBase.prototype.$type, sender)).raisePropertyChanged($.ig.CategoryAxisBase.prototype.useClusteringModePropertyName, e.oldValue(), e.newValue());
}));
$.ig.CategoryAxisBase.prototype.groupCountPropertyName = "GroupCount";



$.ig.CategoryDateTimeXAxis.prototype.displayTypePropertyName = "DisplayType";
$.ig.CategoryDateTimeXAxis.prototype.displayTypeProperty = $.ig.DependencyProperty.prototype.register($.ig.CategoryDateTimeXAxis.prototype.displayTypePropertyName, $.ig.TimeAxisDisplayType.prototype.$type, $.ig.CategoryDateTimeXAxis.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.TimeAxisDisplayType.prototype.getBox($.ig.TimeAxisDisplayType.prototype.continuous), function (sender, e) {
	($.ig.util.cast($.ig.CategoryDateTimeXAxis.prototype.$type, sender)).raisePropertyChanged($.ig.CategoryDateTimeXAxis.prototype.displayTypePropertyName, e.oldValue(), e.newValue());
}));
$.ig.CategoryDateTimeXAxis.prototype.minimumValuePropertyName = "MinimumValue";
$.ig.CategoryDateTimeXAxis.prototype.minimumValueProperty = $.ig.DependencyProperty.prototype.register($.ig.CategoryDateTimeXAxis.prototype.minimumValuePropertyName, $.ig.Date.prototype.$type, $.ig.CategoryDateTimeXAxis.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.CategoryDateTimeXAxis.prototype.$type, sender)).raisePropertyChanged($.ig.CategoryDateTimeXAxis.prototype.minimumValuePropertyName, e.oldValue(), e.newValue());
}));
$.ig.CategoryDateTimeXAxis.prototype.maximumValuePropertyName = "MaximumValue";
$.ig.CategoryDateTimeXAxis.prototype.maximumValueProperty = $.ig.DependencyProperty.prototype.register($.ig.CategoryDateTimeXAxis.prototype.maximumValuePropertyName, $.ig.Date.prototype.$type, $.ig.CategoryDateTimeXAxis.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.CategoryDateTimeXAxis.prototype.$type, sender)).raisePropertyChanged($.ig.CategoryDateTimeXAxis.prototype.maximumValuePropertyName, e.oldValue(), e.newValue());
}));
$.ig.CategoryDateTimeXAxis.prototype.intervalPropertyName = "Interval";
$.ig.CategoryDateTimeXAxis.prototype.intervalProperty = $.ig.DependencyProperty.prototype.register($.ig.CategoryDateTimeXAxis.prototype.intervalPropertyName, $.ig.Number.prototype.$type, $.ig.CategoryDateTimeXAxis.prototype.$type, new $.ig.PropertyMetadata(2, 0, function (sender, e) {
	($.ig.util.cast($.ig.CategoryDateTimeXAxis.prototype.$type, sender)).raisePropertyChanged($.ig.CategoryDateTimeXAxis.prototype.intervalPropertyName, e.oldValue(), e.newValue());
}));
$.ig.CategoryDateTimeXAxis.prototype._actualMinimumValuePropertyName = "ActualMinimumValue";
$.ig.CategoryDateTimeXAxis.prototype._actualMaximumValuePropertyName = "ActualMaximumValue";
$.ig.CategoryDateTimeXAxis.prototype._dateTimeMemberPathPropertyName = "DateTimeMemberPath";
$.ig.CategoryDateTimeXAxis.prototype.dateTimeMemberPathProperty = $.ig.DependencyProperty.prototype.register($.ig.CategoryDateTimeXAxis.prototype._dateTimeMemberPathPropertyName, String, $.ig.CategoryDateTimeXAxis.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.CategoryDateTimeXAxis.prototype.$type, sender)).raisePropertyChanged($.ig.CategoryDateTimeXAxis.prototype._dateTimeMemberPathPropertyName, e.oldValue(), e.newValue());
}));
$.ig.CategoryDateTimeXAxis.prototype.dateTimeColumnPropertyName = "DateTimeColumn";


$.ig.CategoryXAxis.prototype._intervalPropertyName = "Interval";
$.ig.CategoryXAxis.prototype.intervalProperty = $.ig.DependencyProperty.prototype.register($.ig.CategoryXAxis.prototype._intervalPropertyName, Number, $.ig.CategoryXAxis.prototype.$type, new $.ig.PropertyMetadata(2, NaN, function (sender, e) {
	($.ig.util.cast($.ig.CategoryXAxis.prototype.$type, sender)).raisePropertyChanged($.ig.CategoryXAxis.prototype._intervalPropertyName, e.oldValue(), e.newValue());
	($.ig.util.cast($.ig.CategoryXAxis.prototype.$type, sender)).renderAxis1(false);
}));



$.ig.NumericAxisBase.prototype.minimumValuePropertyName = "MinimumValue";
$.ig.NumericAxisBase.prototype.minimumValueProperty = $.ig.DependencyProperty.prototype.register($.ig.NumericAxisBase.prototype.minimumValuePropertyName, Number, $.ig.NumericAxisBase.prototype.$type, new $.ig.PropertyMetadata(2, NaN, function (sender, e) {
	($.ig.util.cast($.ig.NumericAxisBase.prototype.$type, sender)).raisePropertyChanged($.ig.NumericAxisBase.prototype.minimumValuePropertyName, e.oldValue(), e.newValue());
}));
$.ig.NumericAxisBase.prototype.actualMinimumValuePropertyName = "ActualMinimumValue";
$.ig.NumericAxisBase.prototype.maximumValuePropertyName = "MaximumValue";
$.ig.NumericAxisBase.prototype.maximumValueProperty = $.ig.DependencyProperty.prototype.register($.ig.NumericAxisBase.prototype.maximumValuePropertyName, Number, $.ig.NumericAxisBase.prototype.$type, new $.ig.PropertyMetadata(2, NaN, function (sender, e) {
	($.ig.util.cast($.ig.NumericAxisBase.prototype.$type, sender)).raisePropertyChanged($.ig.NumericAxisBase.prototype.maximumValuePropertyName, e.oldValue(), e.newValue());
}));
$.ig.NumericAxisBase.prototype.actualMaximumValuePropertyName = "ActualMaximumValue";
$.ig.NumericAxisBase.prototype.intervalPropertyName = "Interval";
$.ig.NumericAxisBase.prototype.intervalProperty = $.ig.DependencyProperty.prototype.register($.ig.NumericAxisBase.prototype.intervalPropertyName, Number, $.ig.NumericAxisBase.prototype.$type, new $.ig.PropertyMetadata(2, NaN, function (sender, e) {
	($.ig.util.cast($.ig.NumericAxisBase.prototype.$type, sender)).raisePropertyChanged($.ig.NumericAxisBase.prototype.intervalPropertyName, e.oldValue(), e.newValue());
}));
$.ig.NumericAxisBase.prototype.referenceValuePropertyName = "ReferenceValue";
$.ig.NumericAxisBase.prototype.referenceValueProperty = $.ig.DependencyProperty.prototype.register($.ig.NumericAxisBase.prototype.referenceValuePropertyName, Number, $.ig.NumericAxisBase.prototype.$type, new $.ig.PropertyMetadata(2, 0, function (sender, e) {
	($.ig.util.cast($.ig.NumericAxisBase.prototype.$type, sender)).raisePropertyChanged($.ig.NumericAxisBase.prototype.referenceValuePropertyName, e.oldValue(), e.newValue());
}));
$.ig.NumericAxisBase.prototype.isLogarithmicPropertyName = "IsLogarithmic";
$.ig.NumericAxisBase.prototype.isLogarithmicProperty = $.ig.DependencyProperty.prototype.register($.ig.NumericAxisBase.prototype.isLogarithmicPropertyName, $.ig.Boolean.prototype.$type, $.ig.NumericAxisBase.prototype.$type, new $.ig.PropertyMetadata(2, false, function (sender, e) {
	($.ig.util.cast($.ig.NumericAxisBase.prototype.$type, sender)).raisePropertyChanged($.ig.NumericAxisBase.prototype.isLogarithmicPropertyName, e.oldValue(), e.newValue());
}));
$.ig.NumericAxisBase.prototype._actualIsLogarithmicPropertyName = "ActualIsLogarithmic";
$.ig.NumericAxisBase.prototype.logarithmBasePropertyName = "LogarithmBase";
$.ig.NumericAxisBase.prototype.logarithmBaseProperty = $.ig.DependencyProperty.prototype.register($.ig.NumericAxisBase.prototype.logarithmBasePropertyName, $.ig.Number.prototype.$type, $.ig.NumericAxisBase.prototype.$type, new $.ig.PropertyMetadata(2, 10, function (sender, e) {
	($.ig.util.cast($.ig.NumericAxisBase.prototype.$type, sender)).raisePropertyChanged($.ig.NumericAxisBase.prototype.logarithmBasePropertyName, e.oldValue(), e.newValue());
}));
$.ig.NumericAxisBase.prototype._tickmarkValuesPropertyName = "TickmarkValues";
$.ig.NumericAxisBase.prototype.tickmarkValuesProperty = $.ig.DependencyProperty.prototype.register($.ig.NumericAxisBase.prototype._tickmarkValuesPropertyName, $.ig.TickmarkValues.prototype.$type, $.ig.NumericAxisBase.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.NumericAxisBase.prototype.$type, sender)).raisePropertyChanged($.ig.NumericAxisBase.prototype._tickmarkValuesPropertyName, e.oldValue(), e.newValue());
}));
$.ig.NumericAxisBase.prototype._actualTickmarkValuesPropertyName = "ActualTickmarkValues";



$.ig.StraightNumericAxisBase.prototype.scaleModePropertyName = "ScaleMode";
$.ig.StraightNumericAxisBase.prototype.scaleModeProperty = $.ig.DependencyProperty.prototype.register($.ig.StraightNumericAxisBase.prototype.scaleModePropertyName, $.ig.NumericScaleMode.prototype.$type, $.ig.StraightNumericAxisBase.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.NumericScaleMode.prototype.getBox($.ig.NumericScaleMode.prototype.linear), function (sender, e) {
	($.ig.util.cast($.ig.StraightNumericAxisBase.prototype.$type, sender)).raisePropertyChanged($.ig.StraightNumericAxisBase.prototype.scaleModePropertyName, e.oldValue(), e.newValue());
}));
$.ig.StraightNumericAxisBase.prototype.scalerPropertyName = "Scaler";
$.ig.StraightNumericAxisBase.prototype.scalerProperty = $.ig.DependencyProperty.prototype.register($.ig.StraightNumericAxisBase.prototype.scalerPropertyName, $.ig.NumericScaler.prototype.$type, $.ig.StraightNumericAxisBase.prototype.$type, new $.ig.PropertyMetadata(2, null, $.ig.StraightNumericAxisBase.prototype.onScalerPropertyChanged));
$.ig.StraightNumericAxisBase.prototype._actualScalerPropertyName = "ActualScaler";



$.ig.NumericScaler.prototype.actualMinimumValuePropertyName = "ActualMinimumValue";
$.ig.NumericScaler.prototype.actualMinimumValueProperty = $.ig.DependencyProperty.prototype.register($.ig.NumericScaler.prototype.actualMinimumValuePropertyName, Number, $.ig.NumericScaler.prototype.$type, new $.ig.PropertyMetadata(2, NaN, function (sender, e) {
	($.ig.util.cast($.ig.NumericScaler.prototype.$type, sender)).onPropertyChanged($.ig.NumericScaler.prototype.actualMinimumValuePropertyName, e.oldValue(), e.newValue());
}));
$.ig.NumericScaler.prototype.actualMaximumValuePropertyName = "ActualMaximumValue";
$.ig.NumericScaler.prototype.actualMaximumValueProperty = $.ig.DependencyProperty.prototype.register($.ig.NumericScaler.prototype.actualMaximumValuePropertyName, Number, $.ig.NumericScaler.prototype.$type, new $.ig.PropertyMetadata(2, NaN, function (sender, e) {
	($.ig.util.cast($.ig.NumericScaler.prototype.$type, sender)).onPropertyChanged($.ig.NumericScaler.prototype.actualMaximumValuePropertyName, e.oldValue(), e.newValue());
}));


$.ig.LogarithmicTickmarkValues.prototype._mINIMUM_VALUE_GREATER_THAN_ZERO = 4.94065645841247E-324;
$.ig.LogarithmicTickmarkValues.prototype._logarithmBasePropertyName = "LogarithmBase";
$.ig.LogarithmicTickmarkValues.prototype.logarithmBaseProperty = $.ig.DependencyProperty.prototype.register($.ig.LogarithmicTickmarkValues.prototype._logarithmBasePropertyName, $.ig.Number.prototype.$type, $.ig.LogarithmicTickmarkValues.prototype.$type, new $.ig.PropertyMetadata(2, 10, function (sender, e) {
}));


$.ig.TrendLineManagerBase$1.prototype.trendLineDashArrayPropertyName = "TrendLineDashArray";
$.ig.TrendLineManagerBase$1.prototype.trendLineTypePropertyName = "TrendLineType";
$.ig.TrendLineManagerBase$1.prototype.trendLinePeriodPropertyName = "TrendLinePeriod";
$.ig.TrendLineManagerBase$1.prototype.trendLineBrushPropertyName = "TrendLineBrush";
$.ig.TrendLineManagerBase$1.prototype.trendLineActualBrushPropertyName = "ActualTrendLineBrush";
$.ig.TrendLineManagerBase$1.prototype.trendLineThicknessPropertyName = "TrendLineThickness";
$.ig.TrendLineManagerBase$1.prototype.trendLineDashCapPropertyName = "TrendLineDashCap";
$.ig.TrendLineManagerBase$1.prototype.trendLineZIndexPropertyName = "TrendLineZIndex";

















$.ig.CategoryFrame.prototype._categoryFrameVersion = 0;













$.ig.FinancialSeries.prototype.negativeBrushPropertyName = "NegativeBrush";
$.ig.FinancialSeries.prototype.negativeBrushProperty = $.ig.DependencyProperty.prototype.register($.ig.FinancialSeries.prototype.negativeBrushPropertyName, $.ig.Brush.prototype.$type, $.ig.FinancialSeries.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.FinancialSeries.prototype.$type, sender)).raisePropertyChanged($.ig.FinancialSeries.prototype.negativeBrushPropertyName, e.oldValue(), e.newValue());
}));
$.ig.FinancialSeries.prototype.xAxisPropertyName = "XAxis";
$.ig.FinancialSeries.prototype.xAxisProperty = $.ig.DependencyProperty.prototype.register($.ig.FinancialSeries.prototype.xAxisPropertyName, $.ig.CategoryAxisBase.prototype.$type, $.ig.FinancialSeries.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
		($.ig.util.cast($.ig.FinancialSeries.prototype.$type, sender)).raisePropertyChanged($.ig.FinancialSeries.prototype.xAxisPropertyName, e.oldValue(), e.newValue());
}));
$.ig.FinancialSeries.prototype.yAxisPropertyName = "YAxis";
$.ig.FinancialSeries.prototype.yAxisProperty = $.ig.DependencyProperty.prototype.register($.ig.FinancialSeries.prototype.yAxisPropertyName, $.ig.NumericYAxis.prototype.$type, $.ig.FinancialSeries.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
		($.ig.util.cast($.ig.FinancialSeries.prototype.$type, sender)).raisePropertyChanged($.ig.FinancialSeries.prototype.yAxisPropertyName, e.oldValue(), e.newValue());
}));
$.ig.FinancialSeries.prototype.openMemberPathPropertyName = "OpenMemberPath";
$.ig.FinancialSeries.prototype.openMemberPathProperty = $.ig.DependencyProperty.prototype.register($.ig.FinancialSeries.prototype.openMemberPathPropertyName, String, $.ig.FinancialSeries.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.FinancialSeries.prototype.$type, sender)).raisePropertyChanged($.ig.FinancialSeries.prototype.openMemberPathPropertyName, e.oldValue(), e.newValue());
}));
$.ig.FinancialSeries.prototype.openColumnPropertyName = "OpenColumn";
$.ig.FinancialSeries.prototype.highMemberPathPropertyName = "HighMemberPath";
$.ig.FinancialSeries.prototype.highMemberPathProperty = $.ig.DependencyProperty.prototype.register($.ig.FinancialSeries.prototype.highMemberPathPropertyName, String, $.ig.FinancialSeries.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
		($.ig.util.cast($.ig.FinancialSeries.prototype.$type, sender)).raisePropertyChanged($.ig.FinancialSeries.prototype.highMemberPathPropertyName, e.oldValue(), e.newValue());
}));
$.ig.FinancialSeries.prototype.highColumnPropertyName = "HighColumn";
$.ig.FinancialSeries.prototype.lowMemberPathPropertyName = "LowMemberPath";
$.ig.FinancialSeries.prototype.lowMemberPathProperty = $.ig.DependencyProperty.prototype.register($.ig.FinancialSeries.prototype.lowMemberPathPropertyName, String, $.ig.FinancialSeries.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
		($.ig.util.cast($.ig.FinancialSeries.prototype.$type, sender)).raisePropertyChanged($.ig.FinancialSeries.prototype.lowMemberPathPropertyName, e.oldValue(), e.newValue());
}));
$.ig.FinancialSeries.prototype.lowColumnPropertyName = "LowColumn";
$.ig.FinancialSeries.prototype.closeMemberPathPropertyName = "CloseMemberPath";
$.ig.FinancialSeries.prototype.closeMemberPathProperty = $.ig.DependencyProperty.prototype.register($.ig.FinancialSeries.prototype.closeMemberPathPropertyName, String, $.ig.FinancialSeries.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
		($.ig.util.cast($.ig.FinancialSeries.prototype.$type, sender)).raisePropertyChanged($.ig.FinancialSeries.prototype.closeMemberPathPropertyName, e.oldValue(), e.newValue());
}));
$.ig.FinancialSeries.prototype.closeColumnPropertyName = "CloseColumn";
$.ig.FinancialSeries.prototype.volumeMemberPathPropertyName = "VolumeMemberPath";
$.ig.FinancialSeries.prototype.volumeMemberPathProperty = $.ig.DependencyProperty.prototype.register($.ig.FinancialSeries.prototype.volumeMemberPathPropertyName, String, $.ig.FinancialSeries.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
		($.ig.util.cast($.ig.FinancialSeries.prototype.$type, sender)).raisePropertyChanged($.ig.FinancialSeries.prototype.volumeMemberPathPropertyName, e.oldValue(), e.newValue());
}));
$.ig.FinancialSeries.prototype.volumeColumnPropertyName = "VolumeColumn";
$.ig.FinancialSeries.prototype.isCustomCategoryStyleAllowedPropertyName = "IsCustomCategoryStyleAllowed";
$.ig.FinancialSeries.prototype.isCustomCategoryStyleAllowedProperty = $.ig.DependencyProperty.prototype.register($.ig.FinancialSeries.prototype.isCustomCategoryStyleAllowedPropertyName, $.ig.Boolean.prototype.$type, $.ig.FinancialSeries.prototype.$type, new $.ig.PropertyMetadata(2, false, function (sender, e) {
	($.ig.util.cast($.ig.FinancialSeries.prototype.$type, sender)).raisePropertyChanged($.ig.FinancialSeries.prototype.isCustomCategoryStyleAllowedPropertyName, e.oldValue(), e.newValue());
}));
$.ig.FinancialSeries.prototype.transitionInModePropertyName = "TransitionInMode";
$.ig.FinancialSeries.prototype.transitionInModeProperty = $.ig.DependencyProperty.prototype.register($.ig.FinancialSeries.prototype.transitionInModePropertyName, $.ig.CategoryTransitionInMode.prototype.$type, $.ig.FinancialSeries.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.CategoryTransitionInMode.prototype.getBox($.ig.CategoryTransitionInMode.prototype.auto), function (sender, e) {
	($.ig.util.cast($.ig.FinancialSeries.prototype.$type, sender)).raisePropertyChanged($.ig.FinancialSeries.prototype.transitionInModePropertyName, e.oldValue(), e.newValue());
}));
$.ig.FinancialSeries.prototype.isTransitionInEnabledPropertyName = "IsTransitionInEnabled";
$.ig.FinancialSeries.prototype.isTransitionInEnabledProperty = $.ig.DependencyProperty.prototype.register($.ig.FinancialSeries.prototype.isTransitionInEnabledPropertyName, $.ig.Boolean.prototype.$type, $.ig.FinancialSeries.prototype.$type, new $.ig.PropertyMetadata(2, false, function (sender, e) {
	($.ig.util.cast($.ig.FinancialSeries.prototype.$type, sender)).raisePropertyChanged($.ig.FinancialSeries.prototype.isTransitionInEnabledPropertyName, e.oldValue(), e.newValue());
}));


$.ig.FinancialIndicator.prototype.displayTypePropertyName = "DisplayType";
$.ig.FinancialIndicator.prototype.displayTypeProperty = $.ig.DependencyProperty.prototype.register($.ig.FinancialIndicator.prototype.displayTypePropertyName, $.ig.IndicatorDisplayType.prototype.$type, $.ig.FinancialIndicator.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.IndicatorDisplayType.prototype.getBox($.ig.IndicatorDisplayType.prototype.line), function (sender, e) {
	($.ig.util.cast($.ig.FinancialIndicator.prototype.$type, sender)).raisePropertyChanged($.ig.FinancialIndicator.prototype.displayTypePropertyName, e.oldValue(), e.newValue());
}));
$.ig.FinancialIndicator.prototype.ignoreFirstPropertyName = "IgnoreFirst";
$.ig.FinancialIndicator.prototype.ignoreFirstProperty = $.ig.DependencyProperty.prototype.register($.ig.FinancialIndicator.prototype.ignoreFirstPropertyName, $.ig.Number.prototype.$type, $.ig.FinancialSeries.prototype.$type, new $.ig.PropertyMetadata(2, 0, function (sender, e) {
		($.ig.util.cast($.ig.FinancialIndicator.prototype.$type, sender)).raisePropertyChanged($.ig.FinancialIndicator.prototype.ignoreFirstPropertyName, e.oldValue(), e.newValue());
}));
$.ig.FinancialIndicator.prototype.trendLineTypeProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.trendLineTypePropertyName, $.ig.TrendLineType.prototype.$type, $.ig.FinancialIndicator.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.TrendLineType.prototype.getBox($.ig.TrendLineType.prototype.none), function (sender, e) {
	($.ig.util.cast($.ig.FinancialIndicator.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.trendLineTypePropertyName, e.oldValue(), e.newValue());
}));
$.ig.FinancialIndicator.prototype.trendLineBrushProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.trendLineBrushPropertyName, $.ig.Brush.prototype.$type, $.ig.FinancialIndicator.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.FinancialIndicator.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.trendLineBrushPropertyName, e.oldValue(), e.newValue());
}));
$.ig.FinancialIndicator.prototype.actualTrendLineBrushProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.trendLineActualBrushPropertyName, $.ig.Brush.prototype.$type, $.ig.FinancialIndicator.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.FinancialIndicator.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.trendLineActualBrushPropertyName, e.oldValue(), e.newValue());
}));
$.ig.FinancialIndicator.prototype.trendLineThicknessProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.trendLineThicknessPropertyName, Number, $.ig.FinancialIndicator.prototype.$type, new $.ig.PropertyMetadata(2, 1.5, function (sender, e) {
	($.ig.util.cast($.ig.FinancialIndicator.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.trendLineThicknessPropertyName, e.oldValue(), e.newValue());
}));
$.ig.FinancialIndicator.prototype.trendLineDashCapProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.trendLineDashCapPropertyName, $.ig.PenLineCap.prototype.$type, $.ig.FinancialIndicator.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.PenLineCap.prototype.getBox($.ig.PenLineCap.prototype.flat), function (sender, e) {
	($.ig.util.cast($.ig.FinancialIndicator.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.trendLineDashCapPropertyName, e.oldValue(), e.newValue());
}));
$.ig.FinancialIndicator.prototype.trendLineDashArrayProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.trendLineDashArrayPropertyName, $.ig.DoubleCollection.prototype.$type, $.ig.FinancialIndicator.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.FinancialIndicator.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.trendLineDashArrayPropertyName, e.oldValue(), e.newValue());
}));
$.ig.FinancialIndicator.prototype.trendLinePeriodProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.trendLinePeriodPropertyName, $.ig.Number.prototype.$type, $.ig.FinancialIndicator.prototype.$type, new $.ig.PropertyMetadata(2, 7, function (sender, e) {
	($.ig.util.cast($.ig.FinancialIndicator.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.trendLinePeriodPropertyName, e.oldValue(), e.newValue());
}));
$.ig.FinancialIndicator.prototype.trendLineZIndexProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.trendLineZIndexPropertyName, $.ig.Number.prototype.$type, $.ig.FinancialIndicator.prototype.$type, new $.ig.PropertyMetadata(2, 1001, function (sender, e) {
	($.ig.util.cast($.ig.FinancialIndicator.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.trendLineZIndexPropertyName, e.oldValue(), e.newValue());
}));


$.ig.StrategyBasedIndicator.prototype.invalidatesSeries = new $.ig.List$1(String, 0);
$.ig.StrategyBasedIndicator.prototype.periodPropertyName = "Period";
$.ig.StrategyBasedIndicator.prototype.longPeriodPropertyName = "LongPeriod";
$.ig.StrategyBasedIndicator.prototype.shortPeriodPropertyName = "ShortPeriod";
$.ig.StrategyBasedIndicator.prototype._multiplerPropertyName = "Multiplier";


$.ig.AbsoluteVolumeOscillatorIndicator.prototype.shortPeriodProperty = $.ig.StrategyBasedIndicator.prototype.createShortPeriodProperty(10, $.ig.AbsoluteVolumeOscillatorIndicator.prototype.$type);
$.ig.AbsoluteVolumeOscillatorIndicator.prototype.longPeriodProperty = $.ig.StrategyBasedIndicator.prototype.createLongPeriodProperty(30, $.ig.AbsoluteVolumeOscillatorIndicator.prototype.$type);


$.ig.AverageDirectionalIndexIndicator.prototype.periodProperty = $.ig.StrategyBasedIndicator.prototype.createPeriodProperty(14, $.ig.AverageDirectionalIndexIndicator.prototype.$type);


$.ig.AverageTrueRangeIndicator.prototype.periodProperty = $.ig.StrategyBasedIndicator.prototype.createPeriodProperty(14, $.ig.AverageTrueRangeIndicator.prototype.$type);


$.ig.FinancialOverlay.prototype.ignoreFirstPropertyName = "IgnoreFirst";
$.ig.FinancialOverlay.prototype.ignoreFirstProperty = $.ig.DependencyProperty.prototype.register($.ig.FinancialOverlay.prototype.ignoreFirstPropertyName, $.ig.Number.prototype.$type, $.ig.FinancialOverlay.prototype.$type, new $.ig.PropertyMetadata(2, 0, function (sender, e) {
		($.ig.util.cast($.ig.FinancialOverlay.prototype.$type, sender)).raisePropertyChanged($.ig.FinancialOverlay.prototype.ignoreFirstPropertyName, e.oldValue(), e.newValue());
}));


$.ig.BollingerBandsOverlay.prototype.periodPropertyName = "Period";
$.ig.BollingerBandsOverlay.prototype.periodProperty = $.ig.DependencyProperty.prototype.register($.ig.BollingerBandsOverlay.prototype.periodPropertyName, $.ig.Number.prototype.$type, $.ig.BollingerBandsOverlay.prototype.$type, new $.ig.PropertyMetadata(2, 14, function (sender, e) {
	($.ig.util.cast($.ig.BollingerBandsOverlay.prototype.$type, sender)).raisePropertyChanged($.ig.BollingerBandsOverlay.prototype.periodPropertyName, e.oldValue(), e.newValue());
}));
$.ig.BollingerBandsOverlay.prototype.multiplierPropertyName = "Multiplier";
$.ig.BollingerBandsOverlay.prototype.multiplierProperty = $.ig.DependencyProperty.prototype.register($.ig.BollingerBandsOverlay.prototype.multiplierPropertyName, Number, $.ig.BollingerBandsOverlay.prototype.$type, new $.ig.PropertyMetadata(2, 2, function (sender, e) {
	($.ig.util.cast($.ig.BollingerBandsOverlay.prototype.$type, sender)).raisePropertyChanged($.ig.BollingerBandsOverlay.prototype.multiplierPropertyName, e.oldValue(), e.newValue());
}));


$.ig.BollingerBandWidthIndicator.prototype.periodProperty = $.ig.StrategyBasedIndicator.prototype.createPeriodProperty(20, $.ig.BollingerBandWidthIndicator.prototype.$type);
$.ig.BollingerBandWidthIndicator.prototype.multiplierPropertyName = "Multiplier";
$.ig.BollingerBandWidthIndicator.prototype.multiplierProperty = $.ig.StrategyBasedIndicator.prototype.createMultiplierProperty(2, $.ig.BollingerBandWidthIndicator.prototype.$type);


$.ig.ChaikinOscillatorIndicator.prototype.shortPeriodProperty = $.ig.StrategyBasedIndicator.prototype.createShortPeriodProperty(3, $.ig.ChaikinOscillatorIndicator.prototype.$type);
$.ig.ChaikinOscillatorIndicator.prototype.longPeriodProperty = $.ig.StrategyBasedIndicator.prototype.createLongPeriodProperty(10, $.ig.ChaikinOscillatorIndicator.prototype.$type);


$.ig.ChaikinVolatilityIndicator.prototype.periodProperty = $.ig.StrategyBasedIndicator.prototype.createPeriodProperty(10, $.ig.ChaikinVolatilityIndicator.prototype.$type);


$.ig.CommodityChannelIndexIndicator.prototype.periodProperty = $.ig.StrategyBasedIndicator.prototype.createPeriodProperty(20, $.ig.CommodityChannelIndexIndicator.prototype.$type);


$.ig.DetrendedPriceOscillatorIndicator.prototype.periodProperty = $.ig.StrategyBasedIndicator.prototype.createPeriodProperty(20, $.ig.DetrendedPriceOscillatorIndicator.prototype.$type);


$.ig.FastStochasticOscillatorIndicator.prototype.periodProperty = $.ig.StrategyBasedIndicator.prototype.createPeriodProperty(14, $.ig.FastStochasticOscillatorIndicator.prototype.$type);


$.ig.ForceIndexIndicator.prototype.periodProperty = $.ig.StrategyBasedIndicator.prototype.createPeriodProperty(0, $.ig.ForceIndexIndicator.prototype.$type);


$.ig.FullStochasticOscillatorIndicator.prototype.periodProperty = $.ig.StrategyBasedIndicator.prototype.createPeriodProperty(14, $.ig.FullStochasticOscillatorIndicator.prototype.$type);
$.ig.FullStochasticOscillatorIndicator.prototype.smoothingPeriodPropertyName = "SmoothingPeriod";
$.ig.FullStochasticOscillatorIndicator.prototype.smoothingPeriodProperty = $.ig.StrategyBasedIndicator.prototype.createPeriodPropertyHelper(3, $.ig.FullStochasticOscillatorIndicator.prototype.$type, "SmoothingPeriod");
$.ig.FullStochasticOscillatorIndicator.prototype.triggerPeriodPropertyName = "TriggerPeriod";
$.ig.FullStochasticOscillatorIndicator.prototype.triggerPeriodProperty = $.ig.StrategyBasedIndicator.prototype.createPeriodPropertyHelper(3, $.ig.FullStochasticOscillatorIndicator.prototype.$type, "TriggerPeriod");


$.ig.MoneyFlowIndexIndicator.prototype.periodProperty = $.ig.StrategyBasedIndicator.prototype.createPeriodProperty(14, $.ig.MoneyFlowIndexIndicator.prototype.$type);


$.ig.MovingAverageConvergenceDivergenceIndicator.prototype.shortPeriodProperty = $.ig.StrategyBasedIndicator.prototype.createShortPeriodProperty(10, $.ig.MovingAverageConvergenceDivergenceIndicator.prototype.$type);
$.ig.MovingAverageConvergenceDivergenceIndicator.prototype.longPeriodProperty = $.ig.StrategyBasedIndicator.prototype.createLongPeriodProperty(30, $.ig.MovingAverageConvergenceDivergenceIndicator.prototype.$type);
$.ig.MovingAverageConvergenceDivergenceIndicator.prototype.signalPeriodPropertyName = "SignalPeriod";
$.ig.MovingAverageConvergenceDivergenceIndicator.prototype.signalPeriodProperty = $.ig.StrategyBasedIndicator.prototype.createPeriodPropertyHelper(9, $.ig.MovingAverageConvergenceDivergenceIndicator.prototype.$type, $.ig.MovingAverageConvergenceDivergenceIndicator.prototype.signalPeriodPropertyName);


$.ig.PercentagePriceOscillatorIndicator.prototype.shortPeriodProperty = $.ig.StrategyBasedIndicator.prototype.createShortPeriodProperty(10, $.ig.PercentagePriceOscillatorIndicator.prototype.$type);
$.ig.PercentagePriceOscillatorIndicator.prototype.longPeriodProperty = $.ig.StrategyBasedIndicator.prototype.createLongPeriodProperty(30, $.ig.PercentagePriceOscillatorIndicator.prototype.$type);


$.ig.PercentageVolumeOscillatorIndicator.prototype.shortPeriodProperty = $.ig.StrategyBasedIndicator.prototype.createShortPeriodProperty(10, $.ig.PercentageVolumeOscillatorIndicator.prototype.$type);
$.ig.PercentageVolumeOscillatorIndicator.prototype.longPeriodProperty = $.ig.StrategyBasedIndicator.prototype.createLongPeriodProperty(30, $.ig.PercentageVolumeOscillatorIndicator.prototype.$type);


$.ig.PriceChannelOverlay.prototype.periodPropertyName = "Period";
$.ig.PriceChannelOverlay.prototype.periodProperty = $.ig.DependencyProperty.prototype.register($.ig.PriceChannelOverlay.prototype.periodPropertyName, $.ig.Number.prototype.$type, $.ig.PriceChannelOverlay.prototype.$type, new $.ig.PropertyMetadata(2, 14, function (sender, e) {
	($.ig.util.cast($.ig.PriceChannelOverlay.prototype.$type, sender)).raisePropertyChanged($.ig.PriceChannelOverlay.prototype.periodPropertyName, e.oldValue(), e.newValue());
}));


$.ig.RateOfChangeAndMomentumIndicator.prototype.periodProperty = $.ig.StrategyBasedIndicator.prototype.createPeriodProperty(14, $.ig.RateOfChangeAndMomentumIndicator.prototype.$type);


$.ig.RelativeStrengthIndexIndicator.prototype.periodProperty = $.ig.StrategyBasedIndicator.prototype.createPeriodProperty(14, $.ig.RelativeStrengthIndexIndicator.prototype.$type);


$.ig.SlowStochasticOscillatorIndicator.prototype.periodProperty = $.ig.StrategyBasedIndicator.prototype.createPeriodProperty(14, $.ig.SlowStochasticOscillatorIndicator.prototype.$type);


$.ig.StandardDeviationIndicator.prototype.periodProperty = $.ig.StrategyBasedIndicator.prototype.createPeriodProperty(20, $.ig.StandardDeviationIndicator.prototype.$type);


$.ig.StochRSIIndicator.prototype.periodProperty = $.ig.StrategyBasedIndicator.prototype.createPeriodProperty(14, $.ig.StochRSIIndicator.prototype.$type);


$.ig.TRIXIndicator.prototype.periodProperty = $.ig.StrategyBasedIndicator.prototype.createPeriodProperty(15, $.ig.TRIXIndicator.prototype.$type);


$.ig.WilliamsPercentRIndicator.prototype.periodProperty = $.ig.StrategyBasedIndicator.prototype.createPeriodProperty(14, $.ig.WilliamsPercentRIndicator.prototype.$type);




















$.ig.FinancialPriceSeries.prototype.trendLineTypeProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.trendLineTypePropertyName, $.ig.TrendLineType.prototype.$type, $.ig.FinancialPriceSeries.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.TrendLineType.prototype.getBox($.ig.TrendLineType.prototype.none), function (sender, e) {
	($.ig.util.cast($.ig.FinancialPriceSeries.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.trendLineTypePropertyName, e.oldValue(), e.newValue());
}));
$.ig.FinancialPriceSeries.prototype.trendLineBrushProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.trendLineBrushPropertyName, $.ig.Brush.prototype.$type, $.ig.FinancialPriceSeries.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.FinancialPriceSeries.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.trendLineBrushPropertyName, e.oldValue(), e.newValue());
}));
$.ig.FinancialPriceSeries.prototype.actualTrendLineBrushProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.trendLineActualBrushPropertyName, $.ig.Brush.prototype.$type, $.ig.FinancialPriceSeries.prototype.$type, new $.ig.PropertyMetadata(2, null, function (sender, e) {
	($.ig.util.cast($.ig.FinancialPriceSeries.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.trendLineActualBrushPropertyName, e.oldValue(), e.newValue());
}));
$.ig.FinancialPriceSeries.prototype.trendLineThicknessProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.trendLineThicknessPropertyName, Number, $.ig.FinancialPriceSeries.prototype.$type, new $.ig.PropertyMetadata(2, 1.5, function (sender, e) {
	($.ig.util.cast($.ig.FinancialPriceSeries.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.trendLineThicknessPropertyName, e.oldValue(), e.newValue());
}));
$.ig.FinancialPriceSeries.prototype.trendLineDashCapProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.trendLineDashCapPropertyName, $.ig.PenLineCap.prototype.$type, $.ig.FinancialPriceSeries.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.PenLineCap.prototype.getBox($.ig.PenLineCap.prototype.flat), function (sender, e) {
	($.ig.util.cast($.ig.FinancialPriceSeries.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.trendLineDashCapPropertyName, e.oldValue(), e.newValue());
}));
$.ig.FinancialPriceSeries.prototype.trendLineDashArrayProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.trendLineDashArrayPropertyName, $.ig.DoubleCollection.prototype.$type, $.ig.FinancialPriceSeries.prototype.$type, new $.ig.PropertyMetadata(1, function (sender, e) {
	($.ig.util.cast($.ig.FinancialPriceSeries.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.trendLineDashArrayPropertyName, e.oldValue(), e.newValue());
}));
$.ig.FinancialPriceSeries.prototype.trendLinePeriodProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.trendLinePeriodPropertyName, $.ig.Number.prototype.$type, $.ig.FinancialPriceSeries.prototype.$type, new $.ig.PropertyMetadata(2, 7, function (sender, e) {
	($.ig.util.cast($.ig.FinancialPriceSeries.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.trendLinePeriodPropertyName, e.oldValue(), e.newValue());
}));
$.ig.FinancialPriceSeries.prototype.trendLineZIndexProperty = $.ig.DependencyProperty.prototype.register($.ig.Series.prototype.trendLineZIndexPropertyName, $.ig.Number.prototype.$type, $.ig.FinancialPriceSeries.prototype.$type, new $.ig.PropertyMetadata(2, 1001, function (sender, e) {
	($.ig.util.cast($.ig.FinancialPriceSeries.prototype.$type, sender)).raisePropertyChanged($.ig.Series.prototype.trendLineZIndexPropertyName, e.oldValue(), e.newValue());
}));
$.ig.FinancialPriceSeries.prototype.displayTypePropertyName = "DisplayType";
$.ig.FinancialPriceSeries.prototype.displayTypeProperty = $.ig.DependencyProperty.prototype.register($.ig.FinancialPriceSeries.prototype.displayTypePropertyName, $.ig.PriceDisplayType.prototype.$type, $.ig.FinancialPriceSeries.prototype.$type, new $.ig.PropertyMetadata(2, $.ig.PriceDisplayType.prototype.getBox($.ig.PriceDisplayType.prototype.candlestick), function (sender, e) {
	($.ig.util.cast($.ig.FinancialPriceSeries.prototype.$type, sender)).raisePropertyChanged($.ig.FinancialPriceSeries.prototype.displayTypePropertyName, e.oldValue(), e.newValue());
}));
$.ig.FinancialPriceSeries.prototype._mIN_WIDTH = 3;





















} (jQuery));



/*!@license
	* Infragistics.Web.ClientUI Chart 14.2.20142.1018
	*
	* Copyright (c) 2011-2014 Infragistics Inc.
	*
	* http://www.infragistics.com/
	*
	* Depends on:
	* jquery-1.4.4.js
	* jquery.ui.core.js
	* jquery.ui.widget.js
	* infragistics.util.js
	* infragistics.dv.core.js
	* infragistics.chart_funnelchart.js
	*/

/*global jQuery */
if (typeof jQuery !== "function") {
	throw new Error("jQuery is undefined");
}

(function ($) {
	/*
		igChartLegend is a widget based on jQuery UI that can be used to identify 
		the name of a series or its elements represented in chart plot area.
	*/
	$.widget("ui.igChartLegend", {
		options: {
			/* type="item|legend|scale" Type of the legend.
				item type="string" Specify the legend as item legend. It displays a legend item for each pie in the igPieChart control.
				legend type="string" Specify the legend as legend. It is supported by all types of series in the igDataChart control.
				scale type="string" Specify the legend as a scale legend. It displays a color/size scale for the bubble series.
			*/
			type: "legend",
			/* type="number" The width of the legend. It can be set as a number in pixels, string (px) or percentage (%). */
			width: null,
			/* type="number" The height of the legend. It can be set as a number in pixels, string (px) or percentage (%). */
			height: null,/*BUILDREMOVESTHIS*/
			/* type="string" The swatch used to style this widget */
			theme: "c"
		},
		css: {
			/* Classes applied on the parent element. */
			legend: "ui-corner-all ui-widget-content ui-chart-legend",
			/* Class applied on the legend items table element. */
			legendItemsList: "ui-chart-legend-items-list",
			/* Class applied on the legend item tr element. */
			legendItem: "ui-chart-legend-item",
			/* Class applied on the legend item badge td element. */
			legendItemBadge: "ui-chart-legend-item-badge",
			/* Class applied on the legend item text td element. */
			legendItemText: "ui-chart-legend-item-text"
		},
		events: {
			/* cancel="false"
			Occurs when the left mouse button is pressed while the mouse pointer is over an element of this legend.
			Function takes arguments evt and ui.
			Use ui.legend to get reference to current legend object.
			Use ui.chart to get reference to chart owner object.
			Use ui.series to get reference to current series owner object.
			Use ui.actualItemBrush to get legend item brush.
			Use ui.actualSeriesBrush to get series owner brush.
			Use ui.item to get reference to chart item related to event.
			*/
			legendItemMouseLeftButtonDown: null,
			/* cancel="false"
			Occurs when the left mouse button is released while the mouse pointer is over an element of this legend.
			Function takes arguments evt and ui.
			Use ui.legend to get reference to current legend object.
			Use ui.chart to get reference to chart owner object.
			Use ui.series to get reference to current series owner object.
			Use ui.actualItemBrush to get legend item brush.
			Use ui.actualSeriesBrush to get series owner brush.
			Use ui.item to get reference to chart item related to event.
			*/
			legendItemMouseLeftButtonUp: null,
			/* cancel="false"
			Occurs when the left mouse pointer enters an element of this legend.
			Function takes arguments evt and ui.
			Use ui.legend to get reference to current legend object.
			Use ui.chart to get reference to chart owner object.
			Use ui.series to get reference to current series owner object.
			Use ui.actualItemBrush to get legend item brush.
			Use ui.actualSeriesBrush to get series owner brush.
			Use ui.item to get reference to chart item related to event.
			*/
			legendItemMouseEnter: null,
			/* cancel="false"
			Occurs when the left mouse pointer leaves an element of this legend.
			Function takes arguments evt and ui.
			Use ui.legend to get reference to current legend object.
			Use ui.chart to get reference to chart owner object.
			Use ui.series to get reference to current series owner object.
			Use ui.actualItemBrush to get legend item brush.
			Use ui.actualSeriesBrush to get series owner brush.
			Use ui.item to get reference to chart item related to event.
			*/
			legendItemMouseLeave: null
		},
		_create: function () {
			var legend, o = this.options, elem = this.element;
			if (o.type === "item") {
				legend = new $.ig.ItemLegend();
			} else if (o.type === "scale") {
			    legend = new $.ig.ScaleLegend();
			    if (!o.width) {
			        o.width = "100px";
			    }
			    if (!o.height) {
			        o.height = "150px";
			    }
			} else {
				legend = new $.ig.Legend();
			}
			if (o.owner) {
				this._owner = o.owner;
				o.owner = this._owner.options;
			}
			this.legend = legend;
			legend.name(this.id());
			legend.legendItemsListStyle(this.css.legendItemsList);
			legend.legendItemStyle(this.css.legendItem);
			legend.legendItemBadgeStyle(this.css.legendItemBadge);
			legend.legendItemTextStyle(this.css.legendItemText);
			if (o.width) {
				this._oldWidth = elem[0].style.width;
				elem.css("width", o.width);
			}
			if (o.height) {
				this._oldHeight = elem[0].style.width;
				elem.css("height", o.height);
			}
			this._cssLegend = this.css.legend.replace("{0}", o.theme);
			elem.addClass(this._cssLegend);
			this._bindLegendEvents(legend);
			legend.provideContainer(elem);
		},
		_bindLegendEvents: function (legend) {
			legend.legendItemMouseLeftButtonDown = $.ig.Delegate.prototype.combine(legend.legendItemMouseLeftButtonDown, jQuery.proxy(this._fireLegend_ItemMouseLeftButtonDown, this));
			legend.legendItemMouseLeftButtonUp = $.ig.Delegate.prototype.combine(legend.legendItemMouseLeftButtonUp, jQuery.proxy(this._fireLegend_ItemMouseLeftButtonUp, this));
			legend.legendItemMouseEnter = $.ig.Delegate.prototype.combine(legend.legendItemMouseEnter, jQuery.proxy(this._fireLegend_ItemMouseEnter, this));
			legend.legendItemMouseLeave = $.ig.Delegate.prototype.combine(legend.legendItemMouseLeave, jQuery.proxy(this._fireLegend_ItemMouseLeave, this));
		},
		_getLegendEvt: function (evtArgs) {
			var e, brush,
				series = evtArgs.series ? evtArgs.series() : null,
				owner = this._owner;
			if (!owner) {
				return null;
			}
			e = {
				legend: this.options,
				series: owner._seriesOpt && series ? owner._seriesOpt[series.name()] : owner.options,
				chart: owner,
				item: evtArgs._item
			};
			e[owner.dvWidget ? owner.dvWidget._getWidgetName() : owner.widgetName] = owner.options;
			brush = (evtArgs.legendItem && evtArgs.legendItem() !== null && evtArgs.legendItem().content) ? evtArgs.legendItem().content() : null;
			brush = brush && brush.actualItemBrush ? brush.actualItemBrush() : null;
			e.actualItemBrush = brush ? brush.fill() : null;
			brush = (series && series.actualBrush) ? series.actualBrush() : null;
			e.actualSeriesBrush = brush ? brush.fill() : null;
			return e;
		},
		_fireLegend_ItemMouseLeftButtonDown: function (sender, evtArgs) {
			this._trigger("legendItemMouseLeftButtonDown", null, this._getLegendEvt(evtArgs));
		},
		_fireLegend_ItemMouseLeftButtonUp: function (sender, evtArgs) {
			this._trigger("legendItemMouseLeftButtonUp", null, this._getLegendEvt(evtArgs));
		},
		_fireLegend_ItemMouseEnter: function (sender, evtArgs) {
			this._trigger("legendItemMouseEnter", null, this._getLegendEvt(evtArgs));
		},

		_fireLegend_ItemMouseLeave: function (sender, evtArgs) {
			this._trigger("legendItemMouseLeave", null, this._getLegendEvt(evtArgs));
		},
		_getLegend: function () {
			return this.legend;
		},
		_setOption: function (key, value) {
			switch (key) {
				case "width":
					this.element.css("width", value);
					break;
				case "height":
					this.element.css("height", value);
					break;
			}
		},
		destroy: function () {
			/* Destroys the widget. */
			var elements, elem = this.element;
			$.Widget.prototype.destroy.call(this);
			if (this.legend) {
				this.legend = null;
			}
			if (elem) {
				elem.removeClass(this._cssLegend);
				if (this.options.width) {
					elem[0].style.width = this._oldWidth || "";
				}
				if (this.options.height) {
					elem[0].style.height = this._oldHeight || "";
				}
				if (elem.children("table").length > 0) {
					elements = elem.children("table").children("tr");
					$.each(elements, function (key, tr) {
						$(tr).unbind("mouseleave").unbind("mouseup").unbind("mousedown").unbind("mousemove");
					});
				}
				elem.empty();
			}
			return this;
		},
		widget: function () {
			/* Returns the element holding the legend. */
			return this.element;
		},
		id: function () {
			/*  returns the ID of the DOM element holding the legend.
				returnType="string" 
			*/
			return this.element[0].id;
		}
	});
	$.extend($.ui.igChartLegend, {version: "14.2.20142.1018"});
}(jQuery));

/*
* Infragistics Report Viewer 14.2.20142.1007
*
* Copyright (c) 2013 Infragistics Inc.
*
* http://www.infragistics.com/
*
* Depends on:
*  jquery-1.4.4.js
*  jquery.ui.core.js
*  jquery.ui.widget.js
*  jquery.ui.button.js
*  jquery.ui.dialog.js
*  jquery.ui.position.js
*  jquery.effects.core.js
*  jquery.effects.scale.js
*  jquery.effects.fade.js
*  jquery.effects.highlight.js
*  modernizr-2.5.2.js
*  infragistics.util.js
*  infragistics.dataSource.js
*  infragistics.dv.core.js
*  infragistics.dvcommonwidget.js
*  infragistics.ui.chart.js
*  infragistics.chart_categorychart.js
*  infragistics.chart_financialchart.js
*/

/*global jQuery */
if (typeof (jQuery) === 'undefined') {
    throw new Error('jQuery is undefined');
}


/*!  
PDFObject, copyright (C) 2008 Philip Hutchison (pipwerks.com)
Documentation and examples are at www.pdfobject.com 
Version 1.2, April 2011
MIT style license 
*/
(function ($) {
    $.ig.PdfObject = Class.extend({
        init: function () {
        },

        //Tests specifically for Adobe Reader (aka Acrobat) in Internet Explorer
        _hasReaderActiveX: function () {

            var axObj = null;

            try {
                axObj = new ActiveXObject("AcroPDF.PDF");

                //If "AcroPDF.PDF" didn't work, try "PDF.PdfCtrl"
                if (!axObj) {
                    axObj = new ActiveXObject("PDF.PdfCtrl");
                }

                //If either "AcroPDF.PDF" or "PDF.PdfCtrl" are found, return true
                if (axObj !== null) {
                    return true;
                }
            } catch (e) {
                return false;
            }

            //If you got to this point, there's no ActiveXObject for PDFs
            return false;
        },

        //Tests specifically for Adobe Reader (aka Adobe Acrobat) in non-IE browsers
        _hasReader: function () {
            var i,
                n = navigator.plugins,
                count = n.length,
                regx = /Adobe Reader|Adobe PDF|Acrobat/gi;

            for (i = 0; i < count; i++) {
                if (regx.test(n[i].name)) {
                    return true;
                }
            }

            return false;
        },

        //Detects unbranded PDF support
        _hasGeneric: function () {
            var plugin = navigator.mimeTypes["application/pdf"];

            return (plugin && plugin.enabledPlugin);
        },

        //Determines what kind of PDF support is available: Adobe or generic
        pluginFound: function () {
            var type = null;

            if (this._hasReader() || this._hasReaderActiveX()) {
                type = "Adobe";
            }

            return type;
        },

        /* ----------------------------------------------------
        PDF Embedding functions
        ---------------------------------------------------- */
        embed: function (container, url) {
            if (!this.pluginFound()) {
                return false;
            }

            container.html('<object data="' + url + '" type="application/pdf" width="0px" height="0px" />');

            return true;
        }
    });
}(jQuery));

(function ($) {

    $.ui.igReportViewerConstants = $.ui.igReportViewerConstants || {};

    $.extend($.ui.igReportViewerConstants, {
        definition: {
            maxZoom: 250,
            minZoom: 10,
            doubleTapDelta: 20,
            doubleTapTimeout: 500,
            toggleToolbarTimeout: 250,
            availableExportFormats:
                {
                    pdf: 'PDF',
                    xps: 'XPS',
                    xls: 'XLS',
                    xlsx: 'XLSX'
                },
            timeBetweenFrames: 50,
            maxAnimationFrames: 5,
            animationStates:
                {
                    idle: 0,
                    animating: 1
                },
            intertialScrollTimeBetweenFrames: 10,
            intertialScrollDeceleration: 0.1,
            outsideBoundsEasingFactor: 1 / 3,
            fullWindowScrollTolerance: 10,
            ui: {
                reportViewer: 'ui-widget ui-reportviewer',
                background: 'ui-reportviewer-background',
                emptyPage: 'ui-reportviewer-empty-page',
                touchSliderGridline: 'ui-touchSlider-sliderGridline',
                viewerLoading: 'ui-reportviewer-loading',
                toolbarTopSubpanel: 'ui-floatingtoolbar-subpanel-top',
                toolbarBottomSubpanel: 'ui-floatingtoolbar-subpanel-bottom'
            },
            hideToolbarTime: 4000,
            renderControlDefaults: [
                {
                    control: "Chart",
                    properties: [{ key: "Background", value: "lightGray" }]
                },
                {
                    control: "HorizontalLine",
                    properties: [{ key: "LineColor", value: "black" }, { key: "LineStyle", value: "solid" }, { key: "LineThickness", value: "1pt" }]
                },
                {
                    control: "Image",
                    properties: [{ key: "Background", value: "lightGray" }, { key: "BorderColor", value: "gray" }, { key: "BorderThickness", value: "1pt" }, { key: "Padding", value: "0pt" }, { key: "Sizing", value: "FitProportional" }]
                },
                {
                    control: "Label",
                    properties: [{ key: "Background", value: "Transparent" }, { key: "BorderColor", value: "Black" }, { key: "BorderThickness", value: "0pt" }, { key: "Padding", value: "0pt" }, { key: "Foreground", value: "Black" }, { key: "FontSize", value: "12pt" }, { key: "FontStyle", value: "Normal" }, { key: "FontWeight", value: "Normal" }, { key: "TextDecoration", value: "None" }, { key: "VerticalTextAlignment", value: "Top" }, { key: "HorizontalTextAlignment", value: "Left" }]
                },
                {
                    control: "Section",
                    properties: [{ key: "Background", value: "White" }]
                },
                {
                    control: "PageHeaderSection",
                    properties: [{ key: "Background", value: "White" }]
                },
                {
                    control: "PageFooterSection",
                    properties: [{ key: "Background", value: "White" }]
                },
                {
                    control: "ReportHeaderSection",
                    properties: [{ key: "Background", value: "White" }]
                },
                {
                    control: "ReportFooterSection",
                    properties: [{ key: "Background", value: "White" }]
                },
                {
                    control: "SummaryHeaderSection",
                    properties: [{ key: "Background", value: "White" }]
                },
                {
                    control: "SummaryFooterSection",
                    properties: [{ key: "Background", value: "White" }]
                }
            ]
        }
    });

}(jQuery));


(function ($) {

    $.ig = $.ig || {};

    $.ui.igReportViewerErrorLocale = $.ui.igReportViewerErrorLocale || {};

    $.ui.igReportViewerDefinitions = $.ui.igReportViewer || {};

    /*
    igReportViewer is a widget based on jQuery UI that displays a rendered report.
    */
    $.widget('ui.igReportViewer', {
        css: {
            /* Classes applied to the top container element. Default value is 'ui-widget ui-reportviewer'. */
            reportViewer: '' + $.ui.igReportViewerConstants.definition.ui.reportViewer,
            /* Background of the main viewer div. Default value is 'ui-reportviewer-background'. */
            background: '' + $.ui.igReportViewerConstants.definition.ui.background,
            /* Classes applied to loading page. Default ui value is 'ui-reportviewer-empty-page'. */
            emptyPage: '' + $.ui.igReportViewerConstants.definition.ui.emptyPage,
            /* Page touch slider's gridline color and style. Default ui value is 'ui-touchSlider-sliderGridline'. */
            touchSliderGridline: '' + $.ui.igReportViewerConstants.definition.ui.touchSliderGridline,
            /* Classes applied to viewer loading div. Default ui value is 'ui-reportviewer-loading'. */
            viewerLoading: '' + $.ui.igReportViewerConstants.definition.ui.viewerLoading,
            /* Classes applied to the floating toolbar's top submenus. Default ui value is 'ui-floatingtoolbar-subpanel-top'. */
            toolbarTopSubpanel: '' + $.ui.igReportViewerConstants.definition.ui.toolbarTopSubpanel,
            /* Classes applied to the floating toolbar's bottom submenus. Default ui value is 'ui-floatingtoolbar-subpanel-bottom'. */
            toolbarBottomSubpanel: '' + $.ui.igReportViewerConstants.definition.ui.toolbarBottomSubpanel
        },

        options: {
            /* type="string|number|null"
            string The widget width can be set in pixels (px) and percentage (%).
            number The widget width can be set as a number in pixels.
            null type="object" will stretch to fit data, if no other widths are defined.
            */
            width: null,

            /* type="string|number|null"
            string The height width can be set in pixels (px) and percentage (%).
            number The height width can be set as a number in pixels.
            null type="object" will fit the tree inside its parent container, if no other widths are defined.
            */
            height: null,

            /* type="bool" If this property is set to "true", the report will start rendering immediately after the viewer is loaded.
            */
            autoRender: true,

            /* type="off|fitToWidth|fitToPage" Indicates the way the zoom is applied on the page.
            off type="string" Use the current zoom scale.
            fitToWidth type="string" Set the zoom scale so that the viewer displays the whole width of the report page.
            fitToPage type="string" Set the zoom scale so that the viewer displays the whole report page.
            */
            pageFit: 'off',

            /* type="viewerOnly|fullWindow" Indicates the way the viewer scroll interacts with the window scroll on touch devices.
            viewerOnly type="string" Panning and swiping touch events performed inside the viewer only affect the viewer.
            fullWindow type="string" Panning touch events affect the window when the report page is on the edge, viewer swiping is disabled.
            */
            gestureScrolling: 'viewerOnly',

            /* type="int" Indicates the zoom level of the report page being displayed in the viewer. This value ranges between 10 and 250 percent, where 100 is the actual page size.
            */
            zoomScale: 100,

            /* type="array" Indicates the collection of parameter values that will be used to render the report.
            */
            parameters: null,

            renderSettings: {
                /* type="string" Indicates the URI of the report to be loaded and rendered by the viewer.
                */
                definitionUri: null,

                /* type="string" Indicates the URI of the service endpoint that will be invoked to get the report rendered.
                */
                serviceEndpointUri: null
            },

            /* type="bool" If this property is set to "true", the viewer will create a toolbar for performing usual visualization tasks on the current report.
            */
            createToolbar: true
        },

        events: {
            /* Event fired when the zoom scale is changed.
                Function takes arguments evt and args.
				Argument args.oldValue represents the zoom value before it changed.
				Argument args.newValue represents the zoom value after it changed.
            */
            zoomScaleChanged: 'zoomScaleChanged',

            /* Event fired before starting the processing.
            */
            reportProcessingRequested: 'reportProcessingRequested',

            /* Event fired when an export process is started.
            */
            exportStarted: 'exportStarted',

            /* Event fired when an export process is finished.
                Function takes arguments evt and args.
				Argument args.format gets the rendering format.
				Argument args.downloadUri gets the download Uri.
            */
            exportCompleted: 'exportCompleted',

            /* Event fired when an export process is canceled, either by user or by an export error.
                Function takes arguments evt and args.
				Argument args.error gets the exception that contains the information about the error.
            */
            exportCanceled: 'exportCanceled',

            /* Event fired when report processing is started.
            */
            processingStarted: 'processingStarted',

            /* Event fired when report processing is progressing.
                Function takes arguments evt and args.
                Argument args.pagesProcessed gets the number of pages processed so far.
            */
            processingProgress: 'processingProgress',

            /* Event fired when report processing is canceled, either by user, by error, or by refreshing the report.
                Function takes arguments evt and args.
                Argument args.error gets the error information that aborted report processing.
            */
            processingCanceled: 'processingCanceled',

            /* Event fired when report processing is completed.
                Function takes arguments evt and args.
			    Argument args.totalPages gets the total number of pages in the report.
            */
            processingCompleted: 'processingCompleted',

            /* Event fired when printing is started.
            */
            printStarted: 'printStarted',

            /* Event fired when printing is finished.
                Function takes arguments evt and args.
				Argument args.downloadUri gets the download Uri.
                Argument args.canceled returns <c>true</c> if the printing process was cancelled, <c>false</c> otherwise.
                Argument args.error returns the error that caused the printing process to be aborted. If no error occurred, returned value is null.
            */
            printFinished: 'printFinished',

            /* Event fired when the current page changed.
                Function takes arguments evt and args.
                Argument args.oldValue indicates the page number before the value changed.
                Argument args.newValue indicates the page number after the value changed.
            */
            currentPageChanged: 'currentPageChanged',

            /* Event fired when the current page is available.
                Function takes arguments evt and args.
                Argument args.pageNumber indicates the number of the available page.
            */
            currentPageAvailable: 'currentPageAvailable',

            /* Event fired when the total number of pages changed.
                Function takes arguments evt and args.
                Argument args.totalPages indicates the total number of pages so far.
            */
            totalPagesChanged: 'totalPagesChanged',

            /* Event fired when first page is available.
            */
            firstPageAvailable: 'firstPageAvailable'
        },

        _createWidget: function (options, element) {
            /* Strip dummy objects from options, because they are defined for documentation purposes only! */
            this.options.bindings = null;
            $.Widget.prototype._createWidget.apply(this, arguments);
        },

        _initialized: false,

        _create: function () {
            if (!this._isBrowserSupported()) {
                this._renderUnsupportedBrowser();
                return;
            }

            var opt = this.options;

            //if ($.browser.msie && parseInt($.browser.version, 10) === 7 && this.element.css('position') === 'static') {

            if ($.ig.util.isIE && $.ig.util.isIE7 && this.element.css('position') === 'static') {
                this.element.css('position', 'relative');
            }
            if (!opt.width) {
                opt.width = '100%';
            }
            if (!opt.height) {
                opt.height = '100%';
            }
            if (opt.zoomScale != null) {
                if (opt.zoomScale < $.ui.igReportViewerConstants.definition.minZoom) {
                    opt.zoomScale = $.ui.igReportViewerConstants.definition.minZoom;
                }
                else if (opt.zoomScale > $.ui.igReportViewerConstants.definition.maxZoom) {
                    opt.zoomScale = $.ui.igReportViewerConstants.definition.maxZoom;
                }
            }

            this.element.css('width', opt.width);
            this.element.css('height', opt.height);

            this._currentPage = 0;

            this._renderer = new $.ig.RenderManager();
            this._vsm = new $.ig.ViewerStateMachine();
            this._attachToEventsNotifier();
            this._vsm.parametersReady(this.options.parameters);
            this._vsm.definitionUri(this.options.renderSettings.definitionUri);
            this._vsm.serviceEndpointUri(this.options.renderSettings.serviceEndpointUri);
            this._vsm.autoRender(this.options.autoRender);
            this._pdfObject = new $.ig.PdfObject();

            var that = this;
            this._widgetSize = { width: 0, height: 0 };
            $(this.element).add(window).resize(function (event) {
                that._onWindowResize(event);
            });

            $(window).bind('resize.igReportViewer', function (event) {
                that._onWindowResize(event);
            });
            this._provideContainer(this.element);
            this._animationState = $.ui.igReportViewerConstants.definition.animationStates.idle;
            this._loadingFirstPage = false;

            this._initialized = true;
        },

        _attachToEventsNotifier: function () {
            var that = this;
            var eventNotifications = this._vsm.eventNotificationService();
            eventNotifications.reportProcessingRequested = function (evt, args) {
                that._onReportProcessingRequested(args);
            };
            eventNotifications.exportStarted = function (evt, args) {
                that._onExportStarted(args);
            };
            eventNotifications.exportCompleted = function (evt, args) {
                that._onExportCompleted(args);
            };
            eventNotifications.exportCanceled = function (evt, args) {
                that._onExportCanceled(args);
            };
            eventNotifications.processingStarted = function (evt, args) {
                that._onProcessingStarted();
            };
            eventNotifications.processingProgress = function (evt, args) {
                that._onProcessingProgress(args);
            };
            eventNotifications.processingCanceled = function (evt, args) {
                that._onProcessingCanceled(args);
            };
            eventNotifications.processingCompleted = function (evt, args) {
                that._onProcessingCompleted(args);
            };
            eventNotifications.printPreparingStarted = function (evt, args) {
                that._onPrintPreparingStarted(args);
            };
            eventNotifications.printPreparingFinished = function (evt, args) {
                that._onPrintPreparingFinished(args);
            };
            eventNotifications.printStarted = function (evt, args) {
                that._onPrintStarted(args);
            };
            eventNotifications.printFinished = function (evt, args) {
                that._onPrintFinished(args);
            };
            eventNotifications.currentPageAvailable = function (evt, args) {
                that._onCurrentPageAvailable(args);
            };
        },

        _initializeRenderer: function (document) {

            // RenderManager
            this._renderer.initialize(document);

            // Page
            var pageRenderer = new $.ig.PageRenderer();
            this._renderer.addRenderer("Page", pageRenderer);

            // Section
            var sectionRenderer = new $.ig.SectionRenderer();
            this._renderer.addRenderer("Section", sectionRenderer);

            // Table
            var tableRenderer = new $.ig.TableRenderer();
            this._renderer.addRenderer("Table", tableRenderer);

            // Image
            var imageRenderer = new $.ig.ImageRenderer();
            this._renderer.addRenderer("Image", imageRenderer);

            // Horizontal Line
            var horizontalLineRenderer = new $.ig.HorizontalLineRenderer();
            this._renderer.addRenderer("HorizontalLine", horizontalLineRenderer);

            // Label Renderer
            var labelRenderer = new $.ig.LabelRenderer();
            this._renderer.addRenderer("Label", labelRenderer);

            // Chart Renderer
            var chartRenderer = new $.ig.ChartRenderer();
            this._renderer.addRenderer("Chart", chartRenderer);
        },

        _setOption: function (option, value) {
            var oldValue = null;
            switch (option) {
                case 'width':
                    if (!value) {
                        value = '100%';
                    }
                    if (oldValue != value) {
                        this.options.width = value;
                        this.element.css('width', value);
                        this._viewerResized();
                    }
                    break;
                case 'height':
                    if (!value) {
                        value = '100%';
                    }
                    if (oldValue != value) {
                        this.options.height = value;
                        this.element.css('height', value);
                        this._viewerResized();
                    }
                    break;
                case 'autoRender':
                    oldValue = this.options.autoRender;
                    this.options.autoRender = value;
                    this._onAutoRenderChanged(oldValue, value);
                    break;
                case 'pageFit':
                    oldValue = this.options.pageFit;
                    if (oldValue != value) {
                        this.options.pageFit = value;
                        this._applyPageFit();
                    }
                    break;
                case 'gestureScrolling':
                    this.options.gestureScrolling = value;
                    break;
                case 'createToolbar':
                    if (oldValue != this.options.createToolbar) {
                        this.options.createToolbar = value;
                        if (!value) {
                            this._mainDiv.data('igFloatingToolbar')._hideToolbar();
                        }
                    }
                    break;
                case 'zoomScale':
                    oldValue = this.options.zoomScale;
                    if (oldValue != value) {
                        if (value != null) {
                            if (value < $.ui.igReportViewerConstants.definition.minZoom) {
                                value = $.ui.igReportViewerConstants.definition.minZoom;
                            }
                            else if (value > $.ui.igReportViewerConstants.definition.maxZoom) {
                                value = $.ui.igReportViewerConstants.definition.maxZoom;
                            }
                        }
                        this._internalChangeZoomScale(value);
                        this._onZoomScaleChanged(oldValue, value);
                    }
                    break;
                case 'parameters':
                    this.options.parameters = value;
                    this._vsm.parametersReady(value);
                    break;
                case 'renderSettings':
                    if (this.options.renderSettings.definitionUri != value.definitionUri) {
                        this.options.renderSettings.definitionUri = value.definitionUri;
                        this._currentPage = 0;
                        this._vsm.definitionUri(this.options.renderSettings.definitionUri);
                    }
                    if (this.options.renderSettings.serviceEndpointUri != value.serviceEndpointUri) {
                        this.options.renderSettings.serviceEndpointUri = value.serviceEndpointUri;
                        this._currentPage = 0;
                        this._vsm.serviceEndpointUri(this.options.renderSettings.serviceEndpointUri);
                    }
                    break;
                default:
                    $.Widget.prototype._setOption.apply(this, arguments);
            }
        },

        _provideContainer: function (container) {
            var UI_CONSTANTS = {
                MAIN_DIV_CSS_CLASS: "ui-reportviewer-main ui-reportviewer-minimum-size",
                VIEWER_BACKGROUND_CSS_CLASS: this.css.background,
                VIEWER_CONTENT_CSS_CLASS: "ui-reportviewer-content",
                VIEWER_DIV_CSS_CLASS: this.css.reportViewer + " ui-reportviewer-layout",
                MESSAGE_LAYOUT_DIV_CSS_CLASSES: "ui-reportviewer-message-layout",
                MESSAGE_DIV_CSS_CLASS: "ui-reportviewer-message",
                MESSAGE_TEXT_DIV_CSS_CLASS: "ui-reportviewer-message-text",
                MESSAGE_ANIMATION_DIV_CSS_CLASS: "ui-reportviewer-message-animation",
                ERROR_DIV_CSS_CLASS: "ui-reportviewer-error-layout",
                TOOLBAR_DIV_CSS_CLASS: "ui-reportviewer-toolbar-div",
                EXPORT_DIV_CSS_CLASS: "ui-reportviewer-export-div",
                PRINT_DIV_CSS_CLASS: "ui-reportviewer-print-div",
                SCROLL_DIV_CSS_CLASS: "ui-reportviewer-scroll",
                CLIP_DIV_CSS_CLASS: "ui-reportviewer-clip",
                TOUCH_SLIDER_MEASURER_CLASS: "ui-touchSlider-measurer"
            };

            var reportViewerHtmlTemplate = '<div class="' + UI_CONSTANTS.MAIN_DIV_CSS_CLASS + ' ' + UI_CONSTANTS.VIEWER_BACKGROUND_CSS_CLASS + ' ' + UI_CONSTANTS.TOUCH_SLIDER_MEASURER_CLASS + '">';

            reportViewerHtmlTemplate += '   <div class="viewerContainer ' + UI_CONSTANTS.VIEWER_CONTENT_CSS_CLASS + '">';
            reportViewerHtmlTemplate += '      <div class="viewerDiv ' + UI_CONSTANTS.VIEWER_DIV_CSS_CLASS + '">';
            reportViewerHtmlTemplate += '         <div class="scrollPanelDiv ' + UI_CONSTANTS.SCROLL_DIV_CSS_CLASS + '" >';
            reportViewerHtmlTemplate += '            <div class="clippingPanelDiv ' + UI_CONSTANTS.CLIP_DIV_CSS_CLASS + '" />';
            reportViewerHtmlTemplate += '         </div>';
            reportViewerHtmlTemplate += '      </div>';
            reportViewerHtmlTemplate += '      <div class="' + UI_CONSTANTS.MESSAGE_LAYOUT_DIV_CSS_CLASSES + '">';
            reportViewerHtmlTemplate += '         <div class="messageDiv ui-dialog ui-widget-content ui-corner-all ' + UI_CONSTANTS.MESSAGE_DIV_CSS_CLASS + '">';
            reportViewerHtmlTemplate += '            <div class="animationMessageDiv ' + UI_CONSTANTS.MESSAGE_ANIMATION_DIV_CSS_CLASS + '"/>';
            reportViewerHtmlTemplate += '            <div class="textMessageDiv ' + UI_CONSTANTS.MESSAGE_TEXT_DIV_CSS_CLASS + '">' + $.ui.igReportViewerLocale.locale.loadingReportMsg + '</div>';
            reportViewerHtmlTemplate += '         </div>';
            reportViewerHtmlTemplate += '      </div>';
            reportViewerHtmlTemplate += '      <div class="toolbarDiv ' + UI_CONSTANTS.TOOLBAR_DIV_CSS_CLASS + '" />';
            reportViewerHtmlTemplate += '      <div class="exportDiv ' + UI_CONSTANTS.EXPORT_DIV_CSS_CLASS + '" />';
            reportViewerHtmlTemplate += '      <div class="printDiv ' + UI_CONSTANTS.PRINT_DIV_CSS_CLASS + '" />';
            reportViewerHtmlTemplate += '      <div class="printPdfObjectDiv" />';
            reportViewerHtmlTemplate += '   </div>';
            reportViewerHtmlTemplate += '   <div class="errorDiv ' + UI_CONSTANTS.ERROR_DIV_CSS_CLASS + '" />';

            reportViewerHtmlTemplate += '</div>';

            var mainDiv = $(reportViewerHtmlTemplate);
            container.append(mainDiv);
            container.addClass('ui-reportviewer-minimum-size');

            this._mainDiv = mainDiv;
            this._viewerContainer = mainDiv.find(".viewerContainer");
            this._viewerDiv = mainDiv.find(".viewerDiv");
            this._messageDiv = mainDiv.find(".messageDiv");
            this._errorDiv = mainDiv.find(".errorDiv");
            this._exportDiv = mainDiv.find(".exportDiv");
            this._printDiv = mainDiv.find(".printDiv");
            this._animationPrintDiv = this._printDiv.find('.animationPrintDiv');
            this._printPdfObjectDiv = mainDiv.find('.printPdfObjectDiv');
            this._animationMessageDiv = this._messageDiv.find('.animationMessageDiv');
            this._textMessageDiv = this._messageDiv.find('.textMessageDiv');

            mainDiv.igFloatingToolbar({ viewer: this });

            this._scrollPanel = mainDiv.find(".scrollPanelDiv");
            this._clippingPanel = mainDiv.find(".clippingPanelDiv");

            if (Modernizr.touch) {
                this._clippingPanel.css('left', 0);
                this._clippingPanel.css('top', 0);
                this._clippingPanel.css('margin', '0px');
                this._clippingPanel.css('position', 'absolute');
            }

            this._hidePanels();
        },

        _hidePanels: function () {
            if (this._showingLoadingMessage) {
                this._animationMessageDiv.igReportViewerLoading('destroy');
                this._animationMessageDiv.empty();
                this._showingLoadingMessage = false;
            }

            this._errorDiv.css('display', 'none');
            this._viewerDiv.css('display', 'none');
            this._messageDiv.css('display', 'none');
        },

        _elementWidth: function (selector) {
            var elem = $(selector);
            return elem.width() +
					         parseInt(elem.css('margin-left')) +
					         parseInt(elem.css('margin-right')) +
					         parseInt(elem.css('padding-left')) +
					         parseInt(elem.css('padding-right')) +
					         parseInt(elem.css('border-left-width')) +
					         parseInt(elem.css('border-right-width'));
        },

        _elementPaddingWidth: function (selector) {
            var elem = $(selector);
            return parseInt(elem.css('padding-left')) + parseInt(elem.css('padding-right'));
        },

        _showMessage: function (message) {
            this._textMessageDiv.empty();
            this._textMessageDiv.append(message);
            this._viewerDiv.css('display', 'none');
            this._errorDiv.css('display', 'none');
            this._animationMessageDiv.igReportViewerLoading({ rotationInterval: 10 });
            this._messageDiv.css('display', 'block');
            this._messageDiv.css('visibility', 'hidden');
            this._showingLoadingMessage = true;
            var that = this;

            this._animationMessageDiv.bind('_imageLoaded.igReportViewer', function () {
                // IE & FF somehow don't behave as the other browsers do here w.r.t. size measurement
                var browserOffset = ($.ig.util.isIE || $.ig.util.isFF) ? 5 : 0;
                that._messageDiv.css('margin-right',
                    (-(that._elementPaddingWidth(that._messageDiv) +
                        that._elementWidth('.textMessageDiv') +
                        that._elementWidth('.ui-reportviewer-loading') +
                            browserOffset) / 2) + 'px');
                that._messageDiv.css('visibility', 'visible');
            });

        },

        _showViewerPanel: function () {
            this._viewerDiv.css('display', 'block');
            this._messageDiv.css('display', 'none');
            this._animationMessageDiv.unbind('_imageLoaded.igReportViewer');

            if (this._showingLoadingMessage) {
                this._animationMessageDiv.igReportViewerLoading('destroy');
                this._animationMessageDiv.empty();
                this._showingLoadingMessage = false;
            }

            this._errorDiv.css('display', 'none');
        },

        _showErrorPanel: function () {
            this._viewerDiv.css('display', 'none');
            this._messageDiv.css('display', 'none');
            this._errorDiv.css('display', 'block');
            this._subscribeToIgReportViewerErrorEvents();
        },

        _showErrorPanelNoFatal: function () {
            this._errorDiv.css('display', 'block');
            this._subscribeToIgReportViewerErrorEvents();
        },

        _showExportPanel: function () {
            var that = this;
            var dialogOpts = {
                autoOpen: false,
                draggable: false,
                resizable: false,
                show: 'highlight',
                hide: 'scale',
                buttons: {},
                closeOnEscape: true
            };

            dialogOpts.buttons[$.ui.igReportViewerLocale.locale.cancelExportLabel] = function () { that._exportDiv.dialog("close"); };

            var dialog = that._exportDiv.dialog(dialogOpts);

            dialog.dialog({
                beforeClose: function () {
                    dialog.dialog("option", "closeOnEscape", false);
                    that._vsm.cancelExport();
                    that._showingExportDialog = false;
                    window.setTimeout(function () { that._exportDiv.dialog("destroy"); }, 1000);
                }
            });

            dialog.siblings('div.ui-dialog-titlebar').remove();

            var dialogButtonPane = dialog.siblings('.ui-dialog-buttonpane');
            var UI_CONSTANTS = {
                EXPORT_TEXT_DIV_CSS_CLASS: "ui-reportviewer-export-text-div",
                EXPORT_ANIMATION_DIV_CSS_CLASS: "ui-reportviewer-export-animation-div"
            };

            $('<div class="textExportDiv ' + UI_CONSTANTS.EXPORT_TEXT_DIV_CSS_CLASS + '">' + $.ui.igReportViewerLocale.locale.exportingLabel + '</div>')
                .prependTo(dialogButtonPane);
            $('<div class="animationExportDiv ' + UI_CONSTANTS.EXPORT_ANIMATION_DIV_CSS_CLASS + '"/>')
                .prependTo(dialogButtonPane)
                .igReportViewerLoading({ rotationInterval: 10 });

            dialogButtonPane.css('border-top-width', '0px');

            that._exportDiv.dialog('open');
            that._showingExportDialog = true;

            that._positionExportPanel();
        },

        _showPrintPanel: function () {
            var that = this;
            var dialogOpts = {
                autoOpen: false,
                draggable: false,
                resizable: false,
                show: 'highlight',
                hide: 'scale',
                buttons: {},
                closeOnEscape: true
            };

            dialogOpts.buttons[$.ui.igReportViewerLocale.locale.cancelPrintLabel] = function () { that._printDiv.dialog("close"); };

            var dialog = that._printDiv.dialog(dialogOpts);

            dialog.dialog({
                beforeClose: function () {
                    dialog.dialog("option", "closeOnEscape", false);
                    that._showingPrintDialog = false;
                    that._vsm.cancelPrint();
                    window.setTimeout(function () { that._printDiv.dialog("destroy"); }, 1000);
                }
            });

            dialog.siblings('div.ui-dialog-titlebar').remove();

            var dialogButtonPane = dialog.siblings('.ui-dialog-buttonpane');
            var UI_CONSTANTS = {
                PRINT_TEXT_DIV_CSS_CLASS: "ui-reportviewer-print-text-div",
                PRINT_ANIMATION_DIV_CSS_CLASS: "ui-reportviewer-print-animation-div"
            };

            $('<div class="textPrintDiv ' + UI_CONSTANTS.PRINT_TEXT_DIV_CSS_CLASS + '">' + $.ui.igReportViewerLocale.locale.printingLabel + '</div>')
                .prependTo(dialogButtonPane);
            $('<div class="animationPrintDiv ' + UI_CONSTANTS.PRINT_ANIMATION_DIV_CSS_CLASS + '"/>')
                .prependTo(dialogButtonPane)
                .igReportViewerLoading({ rotationInterval: 10 });

            dialogButtonPane.css('border-top-width', '0px');

            that._animationPrintDiv.igReportViewerLoading({ rotationInterval: 10 });

            that._printDiv.dialog('open');
            that._showingPrintDialog = true;
            that._positionPrintPanel(true);
        },

        _positionExportPanel: function () {
            if (!this._showingExportDialog) {
                return;
            }

            if (this.options.createToolbar) {
                var floatingToolbar = this._mainDiv.find('.floatingToolbar');

                var hidden = false;
                if (floatingToolbar.css('display') == 'none') {
                    hidden = true;
                    floatingToolbar.css('visibility', 'hidden');
                    floatingToolbar.css('display', 'block');
                }

                this._exportDiv.dialog('widget').position({
                    my: 'right bottom',
                    at: 'right top',
                    of: floatingToolbar,
                    offset: '0 -10',
                    collision: 'none none'
                });

                if (hidden) {
                    floatingToolbar.css('visibility', 'visible');
                    floatingToolbar.css('display', 'none');
                }
            } else {
                this._exportDiv.dialog('widget').position({
                    my: 'right bottom',
                    at: 'right bottom',
                    of: this._viewerDiv,
                    offset: (this._scrollPanel[0].clientWidth - this._scrollPanel.width()) + ' ' + (this._scrollPanel[0].clientHeight - this._scrollPanel.height()),
                    collision: 'none none'
                });
            }
        },

        _positionPrintPanel: function (force) {
            if (!this._showingPrintDialog) {
                return;
            }

            if (this.options.createToolbar) {
                var floatingToolbar = this._mainDiv.find('.floatingToolbar');

                var hidden = false;
                if (floatingToolbar.css('display') == 'none') {
                    hidden = true;
                    floatingToolbar.css('visibility', 'hidden');
                    floatingToolbar.css('display', 'block');
                }

                this._printDiv.dialog('widget').position({
                    my: 'right bottom',
                    at: 'right top',
                    of: floatingToolbar,
                    offset: '0 -10',
                    collision: 'none none'
                });

                if (hidden) {
                    floatingToolbar.css('visibility', 'visible');
                    floatingToolbar.css('display', 'none');
                }
            } else {
                this._printDiv.dialog('widget').position({
                    my: 'right bottom',
                    at: 'right bottom',
                    of: this._viewerDiv,
                    offset: (this._scrollPanel[0].clientWidth - this._scrollPanel.width()) + ' ' + (this._scrollPanel[0].clientHeight - this._scrollPanel.height()),
                    collision: 'none none'
                });
            }
        },

        _showError: function (e) {
            if (e.error() != null) {
                this._errorDiv.igReportViewerError({ errorObj: e.error() });
                this._showErrorPanel();
            }
        },

        _subscribeToIgReportViewerErrorEvents: function () {
            var that = this;
            var errorWidget = this._errorDiv.find('.ui-reportviewer-error');
            var adjustErrorTopMargin = function () {
                errorWidget.css('margin-top', -(errorWidget.height() / 2) + 'px');
            };

            adjustErrorTopMargin();
            this._errorDiv.bind('_detailsButtonPressed.igReportViewer', function () {
                adjustErrorTopMargin();
            });

            this._errorDiv.bind('_closeButtonPressed.igReportViewer', function () {
                that._errorDiv.unbind('_detailsButtonPressed');
                that._errorDiv.unbind('_closeButtonPressed');
            });
        },

        _startInertialScroll: function (speedX, speedY) {
            if (this._animationState == $.ui.igReportViewerConstants.definition.animationStates.animating) {
                // already performing an animation
                return;
            }

            var maxX = this._getMaxScrollX();
            var minX = 0;
            var maxY = this._getMaxScrollY();
            var minY = 0;

            var marginX = this._scrollPanel.width() - this._clippingPanel.width();
            var marginY = this._scrollPanel.height() - this._clippingPanel.height();
            if (marginX > 0) {
                speedX = 0;
                maxX = marginX / 2;
                minX = marginX / 2;
            }
            if (marginY > 0) {
                speedY = 0;
                maxY = marginY / 2;
                minY = marginY / 2;
            }

            this._animationState = $.ui.igReportViewerConstants.definition.animationStates.animating;
            var that = this;
            setTimeout(
                function () {
                    that._animateInertialScroll(speedX, speedY, minX, minY, maxX, maxY);
                },
                $.ui.igReportViewerConstants.definition.intertialScrollTimeBetweenFrames);
        },

        _animateInertialScroll: function (speedX, speedY, minX, minY, maxX, maxY) {
            var mustIterate = false;

            var currentX = parseInt(this._clippingPanel.css('left'));
            speedX = this._reduceSpeed(speedX, currentX, minX, maxX);
            var nextX = this._intertialScrollNextPosition(speedX, currentX, minX, maxX);
            this._clippingPanel.css('left', nextX);
            if (Math.abs(currentX - nextX) >= 1) {
                mustIterate = true;
            }

            var currentY = parseInt(this._clippingPanel.css('top'));
            speedY = this._reduceSpeed(speedY, currentY, minY, maxY);
            var nextY = this._intertialScrollNextPosition(speedY, currentY, minY, maxY);
            this._clippingPanel.css('top', nextY);
            if (Math.abs(currentY - nextY) >= 1) {
                mustIterate = true;
            }

            if (mustIterate) {
                var that = this;
                setTimeout(
                    function () {
                        that._animateInertialScroll(speedX, speedY, minX, minY, maxX, maxY);
                    },
                    $.ui.igReportViewerConstants.definition.intertialScrollTimeBetweenFrames);
            }
            else {
                // inertial scroll ended
                this._animationState = $.ui.igReportViewerConstants.definition.animationStates.idle;
            }
        },

        _reduceSpeed: function (speed, currentScroll, minScroll, maxScroll) {
            if (this.options.gestureScrolling == 'fullWindow') {
                if (currentScroll > minScroll) {
                    return 0;
                }
                if (currentScroll < maxScroll) {
                    return 0;
                }
            }

            if (speed > 0) {
                if (currentScroll > minScroll || currentScroll < maxScroll) {
                    // reduce speed quickly
                    speed /= 2;
                    if (Math.abs(speed) <= 0.1) {
                        speed = 0;
                    }
                }
                else {
                    // reduce speed slowly
                    speed -= $.ui.igReportViewerConstants.definition.intertialScrollDeceleration;
                    if (speed < 0) {
                        speed = 0;
                    }
                }
            }
            else if (speed < 0) {
                if (currentScroll > minScroll || currentScroll < maxScroll) {
                    // reduce speed quickly
                    speed /= 2;
                    if (Math.abs(speed) <= 0.1) {
                        speed = 0;
                    }
                }
                else {
                    // reduce speed slowly
                    speed += $.ui.igReportViewerConstants.definition.intertialScrollDeceleration;
                    if (speed > 0) {
                        speed = 0;
                    }
                }
            }
            return speed;
        },

        _intertialScrollNextPosition: function (speed, currentScroll, minScroll, maxScroll) {
            if (speed != 0) {
                var nextScroll = currentScroll + speed * $.ui.igReportViewerConstants.definition.intertialScrollTimeBetweenFrames;
                if (this.options.gestureScrolling == 'fullWindow') {
                    if (nextScroll > minScroll) {
                        return minScroll;
                    }
                    if (nextScroll < maxScroll) {
                        return maxScroll;
                    }
                }
                return nextScroll;
            }

            if (currentScroll > minScroll) {
                // converge towards minimum
                if (currentScroll - minScroll < 1) {
                    return minScroll;
                }
                return currentScroll * (1 - $.ui.igReportViewerConstants.definition.outsideBoundsEasingFactor) + minScroll * $.ui.igReportViewerConstants.definition.outsideBoundsEasingFactor;
            }

            if (currentScroll < maxScroll) {
                // converge towards maximum
                if (maxScroll - currentScroll < 1) {
                    return maxScroll;
                }
                return currentScroll * (1 - $.ui.igReportViewerConstants.definition.outsideBoundsEasingFactor) + maxScroll * $.ui.igReportViewerConstants.definition.outsideBoundsEasingFactor;
            }

            return currentScroll;
        },

        render: function () {
            /* Starts rendering the report.
            */
            this._hideExportDialogIfOpen();
            this._hidePrintDialogIfOpen();
            this._vsm.render(true, this.options.parameters);
        },

        refresh: function () {
            /* Cancels, reloads and starts rendering the current report again.
            */
            this._hideExportDialogIfOpen();
            this._hidePrintDialogIfOpen();
            this._currentPage = 0;
            this._vsm.render(true, this.options.parameters);
        },

        cancel: function () {
            /* Cancels the current report rendering and display.
            */
            this._hideExportDialogIfOpen();
            this._hidePrintDialogIfOpen();
            this._vsm.cancel();
        },

        exportReport: function (renderingFormat) {
            /* Starts exporting the current rendered report using the specified exporting format.
            paramType="string" optional="false" One of the available exporting formats: PDF, XPS, XLS or XLSX.
            */
            if ($.ig.util._isIOSPlatform() && renderingFormat == 'XPS') {
                throw new Error($.ui.igReportViewerLocale.locale.invalidExportFormat);
            }

            this._vsm.exportReport(renderingFormat);
            this._showExportPanel();
        },

        _pdfPluginSupported: function () {
            return this._pdfObject.pluginFound();
        },

        printReport: function () {
            /* Displays the printing dialog to print the rendered report.
            */
            if (!this._pdfObject.pluginFound()) {
                var igError = new $.ig.Error();

                igError.message($.ui.igReportViewerLocale.locale.acrobatPluginNotFoundErrorMsg);

                this._errorDiv.igReportViewerError({ errorObj: igError });
                this._showErrorPanelNoFatal();

                return;
            }

            this._vsm.printReport();
            this._showPrintPanel();
        },

        cancelExport: function () {
            /* Cancels the current exporting process.
            */
            this._hideExportDialogIfOpen();
        },

        cancelPrint: function () {
            /* Cancels the current printing process.
            */
            this._hidePrintDialogIfOpen();
        },

        moveToFirstPage: function () {
            /* Sets the current displaying page as the first page of the report.
               Throws an error 'reportHasNotFinishedLoadingErrorMsg' if there's still no page to display.
            */
            if (this._vsm.currentState().processingState() !== $.ig.ProcessingState.prototype.completed) {
                throw new Error($.ui.igReportViewerLocale.locale.reportHasNotFinishedLoadingErrorMsg);
            }

            this.currentPage(1);
        },

        moveToLastPage: function () {
            /* Sets the current displaying page as the last page of the report.
               Throws an error 'reportHasNotFinishedLoadingErrorMsg' if there's still no page to display.
            */
            if (this._cannotMovePage()) {
                throw new Error($.ui.igReportViewerLocale.locale.reportHasNotFinishedLoadingErrorMsg);
            }

            this.currentPage(this._vsm.currentState().totalPages());
        },

        moveToPreviousPage: function () {
            /* Sets the new displaying page as the current page minus one.
               If the current page is the first, it does nothing.
               Throws an error 'reportHasNotFinishedLoadingErrorMsg' if there's still no page to display.
            */
            if (this._cannotMovePage()) {
                throw new Error($.ui.igReportViewerLocale.locale.reportHasNotFinishedLoadingErrorMsg);
            }

            if (this._currentPage > 1) {
                this.currentPage(this._currentPage - 1);
            }
        },

        moveToNextPage: function () {
            /* Sets the new displaying page as the current page plus one.
               If the current page is the last, it does nothing.
               Throws an error 'reportHasNotFinishedLoadingErrorMsg' if there's still no page to display.
            */
            if (this._cannotMovePage()) {
                throw new Error($.ui.igReportViewerLocale.locale.reportHasNotFinishedLoadingErrorMsg);
            }

            if (this._currentPage < this._vsm.currentState().totalPages()) {
                this.currentPage(this._currentPage + 1);
            }
        },

        _hideExportDialogIfOpen: function () {
            if (this._vsm.currentState().exportState() != $.ig.ExportState.prototype.idle &&
                this._vsm.currentState().exportState() != $.ig.ExportState.prototype.canceling) {
                this._exportDiv.dialog('close');
            }
        },

        _hidePrintDialogIfOpen: function () {
            if (this._vsm.currentState().printingState() != $.ig.PrintingState.prototype.idle &&
                this._vsm.currentState().printingState() != $.ig.PrintingState.prototype.canceling) {
                this._printDiv.dialog('close');
            }
        },

        _cannotMovePage: function () {
            return this._vsm.currentState().processingState() != $.ig.ProcessingState.prototype.completed &&
                this._vsm.currentState().processingState() != $.ig.ProcessingState.prototype.processing;
        },

        _animateMoveToPreviousPage: function () {
            // Shows an animation of the current page disappearing and the previous page appearing
            // Returns true if the page was changed
            if (this._cannotMovePage()) {
                throw new Error($.ui.igReportViewerLocale.locale.reportHasNotFinishedLoadingErrorMsg);
            }

            if (this._currentPage <= 1) {
                // It's the first page, do nothing
                return false;
            }

            if (this._animationState == $.ui.igReportViewerConstants.definition.animationStates.animating) {
                // There's another animation running
                return false;
            }

            var currentY = parseInt(this._clippingPanel.css('top'));
            var targetX = this._scrollPanel.width();

            this._newPage = this._createLoadingPage();
            this._scrollPanel.append(this._newPage);

            var newPageTargetX = this._calculateTargetX(this._newPage, 'right');
            var newPageTargetY = this._calculateTargetY(this._newPage, currentY);
            var newPageScrollX = -this._clippingPanel.width() - 10;
            this._newPage.css('left', newPageScrollX);
            this._newPage.css('top', newPageTargetY);

            var that = this;
            var pagesList = [{ page: this._clippingPanel, targetX: targetX, targetY: currentY }, { page: this._newPage, targetX: newPageTargetX, targetY: newPageTargetY }];

            this._movePages(
                pagesList,
                $.ui.igReportViewerConstants.definition.maxAnimationFrames,
                function () {
                    that._zoomContent.detach();
                    that._newPage.append(this._zoomContent);
                    that._clippingPanel.detach();
                    that._clippingPanel = that._newPage;
                    that.currentPage(that._currentPage - 1);
                });

            return true;
        },

        _animateMoveToNextPage: function () {
            // Shows an animation of the current page disappearing and the next page appearing
            // Returns true if the page was changed
            if (this._cannotMovePage()) {
                throw new Error($.ui.igReportViewerLocale.locale.reportHasNotFinishedLoadingErrorMsg);
            }

            if (this._currentPage >= this._vsm.currentState().totalPages()) {
                // It's the last page, do nothing
                return false;
            }

            if (this._animationState == $.ui.igReportViewerConstants.definition.animationStates.animating) {
                // There's another animation running
                return false;
            }

            var currentY = parseInt(this._clippingPanel.css('top'));
            var targetX = -this._clippingPanel.width();

            this._newPage = this._createLoadingPage();
            this._scrollPanel.append(this._newPage);

            var newPageTargetX = this._calculateTargetX(this._newPage, 'left');
            var newPageTargetY = this._calculateTargetY(this._newPage, currentY);
            var newPageScrollX = this._scrollPanel.width();
            if (this._clippingPanel.width() > newPageScrollX) {
                newPageScrollX = this._clippingPanel.width();
            }
            newPageScrollX += 10;
            this._newPage.css('left', newPageScrollX);
            this._newPage.css('top', newPageTargetY);

            var that = this;
            var pagesList = [{ page: this._clippingPanel, targetX: targetX, targetY: currentY }, { page: this._newPage, targetX: newPageTargetX, targetY: newPageTargetY }];

            this._movePages(
                pagesList,
                $.ui.igReportViewerConstants.definition.maxAnimationFrames,
                function () {
                    that._zoomContent.detach();
                    that._newPage.append(this._zoomContent);
                    that._clippingPanel.detach();
                    that._clippingPanel = that._newPage;
                    that.currentPage(that._currentPage + 1);
                });

            return true;
        },

        _createLoadingPage: function () {
            var UI_CONSTANTS = {
                CLIP_DIV_CSS_CLASS: "ui-reportviewer-clip",
                EMPTY_PAGE_CSS_CLASS: this.css.emptyPage + " ui-reportviewer-empty-page-layout"
            };

            var newPageHtml = '<div class="' + UI_CONSTANTS.CLIP_DIV_CSS_CLASS + '">';
            newPageHtml += '   <div class="' + UI_CONSTANTS.EMPTY_PAGE_CSS_CLASS + '">';
            newPageHtml += '   <div>' + $.ui.igReportViewerLocale.locale.loadingPageMsg + '</div>';
            newPageHtml += '   </div>';
            newPageHtml += '</div>';

            var newPage = $(newPageHtml);
            newPage.css('width', this._clippingPanel.width());
            newPage.css('height', this._clippingPanel.height());
            return newPage;
        },

        _isBrowserSupported: function () {
            return Modernizr.canvas;
        },

        _renderUnsupportedBrowser: function () {
            var UI_CONSTANTS = {
                UNSUPPORTED_BROWSER_CSS_CLASS: "ui-unsupported-message " + $.ui.igReportViewerConstants.definition.ui.reportViewer
            };

            var browserUnsupported;
            if ($.ig.util.isIE) {
                browserUnsupported = 'Internet Explorer ' + $.ig.util.browserVersion;
            } else if ($.ig.util.isOpera) {
                browserUnsupported = 'Opera ' + $.ig.util.browserVersion;
            } else if ($.ig.util.isWebKit) {
                browserUnsupported = 'Webkit ' + $.ig.util.browserVersion;
            } else if ($.ig.util.isFF) {
                browserUnsupported = 'Mozilla Firefox ' + $.ig.util.browserVersion;
            } else {
                browserUnsupported = $.ig.util.browserVersion;
            }

            var unsupportedMessage = '<div class="' + UI_CONSTANTS.UNSUPPORTED_BROWSER_CSS_CLASS + '">';
            unsupportedMessage += '   <div class="unsupportedImage"/>';
            unsupportedMessage += '   <div>' + $.ui.igReportViewerLocale.locale.currentBrowser.replace('{0}', browserUnsupported) + '</div>';
            unsupportedMessage += '   <div>' + $.ui.igReportViewerLocale.locale.unsupportedBrowser + '</div>';
            unsupportedMessage += '   <ul class="browserList">';
            unsupportedMessage += '   <li class="chrome"><span class="brIcon"></span><a href="' + $.ui.igReportViewerLocale.locale.chromeDownload + '">' + $.ui.igReportViewerLocale.locale.chrome8 + '</a></li>';
            unsupportedMessage += '   <li class="fireFox"><span class="brIcon"></span><a href="' + $.ui.igReportViewerLocale.locale.firefoxDownload + '">' + $.ui.igReportViewerLocale.locale.firefox36 + '</a></li>';
            unsupportedMessage += '   <li class="opera"><span class="brIcon"></span><a href="' + $.ui.igReportViewerLocale.locale.operaDownload + '">' + $.ui.igReportViewerLocale.locale.opera11 + '</a></li>';
            unsupportedMessage += '   <li class="safari"><span class="brIcon"></span><a href="' + $.ui.igReportViewerLocale.locale.safariDownload + '">' + $.ui.igReportViewerLocale.locale.safari5 + '</a></li>';
            unsupportedMessage += '   <li class="ie"><span class="brIcon"></span><a href="' + $.ui.igReportViewerLocale.locale.ieDownload + '">' + $.ui.igReportViewerLocale.locale.ie9 + '</a></li>';
            unsupportedMessage += '   </ul>';
            unsupportedMessage += '</div>';

            this.element.append(unsupportedMessage);
            this.element.css("width", this.options.width);
            this.element.css("height", this.options.height);
        },


        _calculateTargetX: function (page, scrollDirection) {
            var margin = this._scrollPanel.width() - page.width();

            if (margin >= 0) {
                return margin / 2;
            }

            if (scrollDirection == 'left') {
                return 0;
            }

            return margin;
        },

        _calculateTargetY: function (page, currentScroll) {
            var margin = this._scrollPanel.height() - page.height();

            if (margin >= 0) {
                return margin / 2;
            }

            if (currentScroll > 0) {
                return 0;
            }

            if (currentScroll < margin) {
                return margin;
            }

            return currentScroll;
        },

        _movePages: function (pagesToMove, maxMoves, onMovementEnded) {
            this._animationState = $.ui.igReportViewerConstants.definition.animationStates.animating;

            for (var i = 0; i < pagesToMove.length; i++) {
                var pageToMove = pagesToMove[i];
                var initialX = parseInt(pageToMove.page.css('left'));
                var initialY = parseInt(pageToMove.page.css('top'));

                pageToMove.speedX = (pageToMove.targetX - initialX) / (maxMoves - 1);
                pageToMove.speedY = (pageToMove.targetY - initialY) / (maxMoves - 1);
            }

            this._animateMovePages(pagesToMove, maxMoves, onMovementEnded);
        },

        _animateMovePages: function (pagesToMove, maxMoves, onMovementEnded) {
            // Animates the movement of several pages
            var mustIterate = false;
            for (var i = 0; i < pagesToMove.length; i++) {
                var pageToMove = pagesToMove[i];
                var currentX = parseInt(pageToMove.page.css('left'));
                if (Math.abs(currentX - pageToMove.targetX) < Math.abs(pageToMove.speedX)) {
                    pageToMove.page.css('left', pageToMove.targetX);
                }
                else {
                    pageToMove.page.css('left', currentX + pageToMove.speedX);
                    mustIterate = true;
                }

                var currentY = parseInt(pageToMove.page.css('top'));
                if (Math.abs(currentY - pageToMove.targetY) < Math.abs(pageToMove.speedY)) {
                    pageToMove.page.css('top', pageToMove.targetY);
                }
                else {
                    pageToMove.page.css('top', currentY + pageToMove.speedY);
                    mustIterate = true;
                }
            }

            if (mustIterate && maxMoves > 0) {
                var that = this;
                setTimeout(
                    function () {
                        that._animateMovePages(pagesToMove, maxMoves - 1, onMovementEnded);
                    },
                    $.ui.igReportViewerConstants.definition.timeBetweenFrames);
            }
            else {
                // Animation ended
                this._animationState = $.ui.igReportViewerConstants.definition.animationStates.idle;
                if (onMovementEnded != null) {
                    onMovementEnded();
                }
            }
        },

        currentPage: function (value) {
            /* Gets or sets the number of the currently displayed page.
               Throws an error 'reportHasNotFinishedLoadingErrorMsg' if there's still no page to display.
				paramType="number" optional="true" Number of the new page to display.
				returnType="number" Returns the new page number. If the page is not changed the previous value will be returned.
			*/
            if (arguments.length === 1) {
                var intValue = parseInt(value);
                var oldValue = this._currentPage;
                if (oldValue == intValue) {
                    return intValue;
                }

                if (intValue != 1 && !this._vsm.canNavigate()) {
                    throw new Error($.ui.igReportViewerLocale.locale.reportHasNotFinishedLoadingErrorMsg);
                }

                if (intValue >= 1 && intValue <= this._vsm.currentState().totalPages()) {
                    this._currentPage = intValue;
                    this._vsm.getPage(intValue);
                    this._onCurrentPageChanged(oldValue, intValue);
                    return intValue;
                }
                else {
                    return oldValue;
                }
            } else {
                return this._currentPage;
            }
        },

        fitToWidth: function () {
            /* Sets the zoom scale so that the viewer displays the whole width of the report page.
			*/
            if (this._pageWidth != null) {
                var adjustment = this._getBrowserScrollBarWidth();
                var currentWidth = parseInt(this._viewerDiv.css('width'));
                var currentHeight = parseInt(this._viewerDiv.css('height'));
                var scaleX = currentWidth / this._pageWidth;

                if (this._pageHeight * scaleX - currentHeight > this._fitThreshold) {
                    scaleX = (currentWidth - adjustment) / this._pageWidth;
                }

                this._setOption('zoomScale', scaleX * 100);
                this.options.pageFit = 'fitToWidth';
            }
        },

        fitToPage: function () {
            /* Sets the zoom scale so that the viewer displays the whole report page.
			*/
            if (this._pageWidth != null) {
                var scaleX = parseInt(this._viewerDiv.css('width')) / this._pageWidth;
                var scaleY = parseInt(this._viewerDiv.css('height')) / this._pageHeight;
                this._setOption('zoomScale', Math.min(scaleX, scaleY) * 100);
                this.options.pageFit = 'fitToPage';
            }
        },

        _onZoomScaleChanged: function (oldValue, newValue) {
            this.element.trigger(this.events.zoomScaleChanged,
                {
                    oldValue: oldValue,
                    newValue: newValue
                });
        },

        _onWindowResize: function (event) {
            if (this._mainDiv.width() == this._widgetSize.width && this._mainDiv.height() == this._widgetSize.height) {
                return;
            }

            this._viewerResized();
        },

        _viewerResized: function () {
            this._resizing = true;
            this._widgetSize.width = this._mainDiv.width();
            this._widgetSize.height = this._mainDiv.height();
            this._correctViewport();

            if (this._initialized === true) {
                $(this.element).trigger('_viewerResized');
            }

            this._positionExportPanel();
            this._positionPrintPanel();
            this._resizing = false;
        },

        _pageFitsHorizontally: function () {
            if (!this._pageWidth) {
                return true;
            }

            var viewportWidth = this._scrollPanel[0].clientWidth;
            return viewportWidth - this._pageWidth * this.options.zoomScale / 100 > this._fitThreshold;
        },

        _fitThreshold: -0.01,
        _internalChangeZoomScale: function (value) {
            var oldScale = this.options.zoomScale / 100;
            this.options.zoomScale = value;

            if (this._zoomContent != undefined) {
                var newScale = value / 100;

                var totalWidth = this._pageWidth * newScale;
                var totalHeight = this._pageHeight * newScale;
                var newLeftScroll = 0, newTopScroll = 0;
                var viewport = {
                    width: parseInt(this._scrollPanel.css('width')),
                    height: parseInt(this._scrollPanel.css('height'))
                };

                viewport.center = { x: viewport.width / 2, y: viewport.height / 2 };

                var horizontalMargin = viewport.width - this._getBrowserScrollBarWidth() - totalWidth;
                var verticalMargin = viewport.height - this._getBrowserScrollBarWidth() - totalHeight;
                if (!Modernizr.touch) {
                    var zoomCenter = {
                        x: viewport.center.x + this._scrollPanel.scrollLeft(),
                        y: viewport.center.y + this._scrollPanel.scrollTop()
                    };

                    if (horizontalMargin <= this._fitThreshold) {
                        newLeftScroll = Math.round(zoomCenter.x * newScale / oldScale - viewport.center.x);
                    }

                    if (verticalMargin <= this._fitThreshold) {
                        newTopScroll = Math.round(zoomCenter.y * newScale / oldScale - viewport.center.y);
                    }
                }
                else {
                    var oldLeftScroll = parseInt(this._clippingPanel.css('left'));
                    var oldTopScroll = parseInt(this._clippingPanel.css('top'));

                    var midPointX = (viewport.width / 2 - oldLeftScroll) / oldScale;
                    var midPointY = (viewport.height / 2 - oldTopScroll) / oldScale;

                    newLeftScroll = viewport.width / 2 - midPointX * newScale;
                    newTopScroll = viewport.height / 2 - midPointY * newScale;
                }

                this._clippingPanel.css('width', totalWidth + "px");
                this._clippingPanel.css('height', totalHeight + "px");

                if (!Modernizr.touch) {
                    this._clippingPanel.css('top', "0px");
                    if (verticalMargin > this._fitThreshold) {
                        this._clippingPanel.css('margin-top', ((viewport.height - totalHeight) / 2) + "px");
                    } else {
                        this._clippingPanel.css('margin-top', "0px");
                    }
                }

                if ($.ig.util.isWebKit) {
                    this._zoomContent.css('-webkit-transform', 'scale(' + newScale + ')');
                }
                else {
                    this._zoomContent.css('zoom', newScale);
                    this._zoomContent.css('-moz-transform', 'scale(' + newScale + ')');
                    this._zoomContent.css('-o-transform', 'scale(' + newScale + ')');
                }

                if (!Modernizr.touch) {
                    this._scrollPanel.scrollLeft(newLeftScroll);
                    this._scrollPanel.scrollTop(newTopScroll);
                }
                else {
                    if (horizontalMargin < 0) {
                        this._clippingPanel.css('left', newLeftScroll + "px");
                    }

                    if (verticalMargin < 0) {
                        this._clippingPanel.css('top', newTopScroll + "px");
                    }

                    this._correctViewport();
                }
            }
        },

        _forceZoomScale: function (value) {
            var oldValue = this.options.zoomScale;
            this.options.zoomScale = value;

            if (this._zoomContent != undefined) {
                var newScale = value / 100;

                var totalWidth = this._pageWidth * newScale;
                var totalHeight = this._pageHeight * newScale;

                this._clippingPanel.css('width', totalWidth + "px");
                this._clippingPanel.css('height', totalHeight + "px");

                if ($.ig.util.isWebKit) {
                    this._zoomContent.css('-webkit-transform', 'scale(' + newScale + ')');
                }
                else {
                    this._zoomContent.css('zoom', newScale);
                    this._zoomContent.css('-moz-transform', 'scale(' + newScale + ')');
                    this._zoomContent.css('-o-transform', 'scale(' + newScale + ')');
                }

                this._onZoomScaleChanged(oldValue, value);
            }
        },

        _onCurrentPageChanged: function (oldValue, newValue) {
            this._vsm.currentPage(newValue);
            this.element.trigger(this.events.currentPageChanged,
                {
                    oldValue: oldValue,
                    newValue: newValue
                });
        },

        _onAutoRenderChanged: function (oldValue, newValue) {
            this._vsm.autoRender(newValue);
        },

        _fetchFirstPage: function () {
            this.element.trigger(this.events.firstPageAvailable);
            this._loadingFirstPage = true;
            var reportDefinition = this._vsm.reportDefinition();
            var document = $.ig.XmlDocumentParser.prototype.parse(reportDefinition);
            this._initializeRenderer(document);
            this.currentPage(1);
        },

        _onReportProcessingRequested: function (args) {
            this.element.trigger(this.events.reportProcessingRequested, args);
        },

        _onExportStarted: function (args) {
            this.element.trigger(this.events.exportStarted, args);
        },

        _onExportCanceled: function (args) {
            // Close the dialog only if visible
            if (this._exportDiv.dialog('isOpen')) {
                this._exportDiv.dialog('close');
            }

            if (args.error() != null) {
                this._errorDiv.igReportViewerError({ errorObj: args.error() });
                this._showErrorPanelNoFatal();
            }

            this.element.trigger(this.events.exportCanceled, {
                error: args.error()
            });
        },

        _onExportCompleted: function (args) {
            this._exportDiv.dialog('close');

            if (this._showingLoadingMessage) {
                this._animationMessageDiv.igReportViewerLoading('destroy');
                this._showingLoadingMessage = false;
            }

            this._animationMessageDiv.empty();

            if ($.ig.util._isIOSPlatform()) {
                var link = $('<a href="' + args.downloadUri() + '" target="_blank" style="display:none;"></a>').appendTo('body');
                var click = document.createEvent('Event');
                click.initEvent('click', true, false);
                link[0].dispatchEvent(click);
                link.remove();
            } else {
                window.open(args.downloadUri(), '_self');
            }

            this.element.trigger(this.events.exportCompleted,
                {
                    downloadUri: args.downloadUri(),
                    format: args.format()
                });
        },

        _onProcessingStarted: function () {
            this.element.trigger(this.events.processingStarted);
            this._showMessage($.ui.igReportViewerLocale.locale.loadingReportMsg);
        },

        _onProcessingCanceled: function (args) {
            this._pageWidth = 0;
            this._pageHeight = 0;
            this.element.trigger(this.events.processingCanceled,
                {
                    error: args.error()
                });
            this._hidePanels();
            this._currentPage = 0;
            this._showError(args);
        },

        _onProcessingCompleted: function (args) {
            this.element.trigger(this.events.totalPagesChanged, { totalPages: args.totalPages() });
            this.element.trigger(this.events.processingCompleted,
                {
                    totalPages: args.totalPages()
                });
        },

        _onProcessingProgress: function (args) {
            if (this._currentPage == 0) {
                this._fetchFirstPage(this);
            }
            this.element.trigger(this.events.totalPagesChanged, { totalPages: args.pagesProcessed() });
            this.element.trigger(this.events.processingProgress,
                {
                    pagesProcessed: args.pagesProcessed()
                });
        },

        _onPrintPreparingStarted: function (args) {
            this.element.trigger(this.events.printPreparingStarted, args);
        },

        _onPrintPreparingFinished: function (args) {
            this.element.trigger(this.events.printPreparingFinished, args);
        },

        _onPrintStarted: function (args) {
            this.element.trigger(this.events.printStarted, args);
        },

        _onPrintFinished: function (args) {
            if (args.error()) {
                this._printDiv.dialog('close');
                this._errorDiv.igReportViewerError({ errorObj: args.error() });
                this._showErrorPanelNoFatal();
            } else if (!args.canceled()) {
                this._pdfObject.embed(this._printPdfObjectDiv, args.downloadUri());
                this._printDiv.dialog('close');
            }

            if (this._showingLoadingMessage) {
                this._animationPrintDiv.igReportViewerLoading('destroy');
                this._showingLoadingMessage = false;
            }

            this._animationPrintDiv.empty();

            this.element.trigger(this.events.printFinished,
                {
                    downloadUri: args.downloadUri(),
                    canceled: args.canceled(),
                    error: args.error()
                });
        },

        _onCurrentPageAvailable: function (args) {
            var pageRangeData = args.pageData();
            var page = $.ig.XmlDocumentParser.prototype.parse(pageRangeData.getPageXml()).documentElement;

            var dataSources = pageRangeData.getSerializedReportDataSources();
            for (var i = 0; i < dataSources.length; i++) {
                var dataSource = dataSources[i];
                this._renderer.addDataSource(dataSource.getSerializedReportDataSourceId(), dataSource.getSerializedReportDataSourceXml());
            }

            this._zoomContent = $('<div class="viewerZoomContentFrame"/>');
            this._zoomContent.css('-moz-transform-origin', '0 0');
            this._zoomContent.css('-o-transform-origin', '0 0');
            this._zoomContent.css('-webkit-transform-origin', '0 0');

            // Remember previous scroll positions
            var scrollLeft = parseInt(this._clippingPanel.css('left'));
            var scrollTop = parseInt(this._clippingPanel.css('top'));

            this._clippingPanel.empty();
            this._clippingPanel.append(this._zoomContent);

            this._showViewerPanel();
            var pageVisual = this._renderer.render(page, this._zoomContent);
            this._pageWidth = parseInt(pageVisual[0].attributes['width'].value);
            this._pageHeight = parseInt(pageVisual[0].attributes['height'].value);

            if (this._loadingFirstPage) {
                this._loadingFirstPage = false;
                if (this.options.pageFit == 'fitToPage') {
                    this.fitToPage();
                }
                else if (this.options.pageFit == 'fitToWidth') {
                    this.fitToWidth();
                }

                this._internalChangeZoomScale(this.options.zoomScale);
                //this._correctViewport();
            }
            else {
                this._internalChangeZoomScale(this.options.zoomScale);

                // Restore scroll positions
                if (Modernizr.touch) {
                    this._clippingPanel.css('left', scrollLeft);
                    this._clippingPanel.css('top', scrollTop);
                }
            }

            this._zoomContent.css('width', this._pageWidth + "px");
            this._zoomContent.css('height', this._pageHeight + "px");
            this.element.trigger(this.events.currentPageAvailable, { pageNumber: pageRangeData.getPageNumber() });
        },

        _startScale: undefined,

        _startZoom: undefined,

        _getScrollX: function () {
            return parseInt(this._clippingPanel.css('left'));
        },

        _getMaxScrollX: function () {
            return this._scrollPanel.width() - this._clippingPanel.width();
        },

        _getMaxScrollY: function () {
            return this._scrollPanel.height() - this._clippingPanel.height();
        },

        _getScrollY: function () {
            return parseInt(this._clippingPanel.css('top'));
        },

        _setScrollOffset: function (scrollX, scrollY) {
            // Sets the scroll offset of the clipping panel
            // Returns true if it was possible to change the offset

            if (this._animationState == $.ui.igReportViewerConstants.definition.animationStates.animating) {
                // Ignore panning when it's animating
                return false;
            }

            var offsetChanged = false;
            var horizontalScrollEnabled = true;
            var verticalScrollEnabled = true;

            var contentWidth = this._clippingPanel.width();
            var contentHeight = this._clippingPanel.height();
            var containerWidth = this._scrollPanel.width();
            var containerHeight = this._scrollPanel.height();

            if (contentWidth <= containerWidth) {
                horizontalScrollEnabled = false;
            }

            if (contentHeight <= containerHeight) {
                verticalScrollEnabled = false;
            }

            if ((horizontalScrollEnabled || verticalScrollEnabled) && this.options.gestureScrolling == 'fullWindow') {
                var overLeftEdge = scrollX > 0;
                var overRightEdge = scrollX < this._getMaxScrollX();
                var overTopEdge = scrollY > 0;
                var overBottomEdge = scrollY < this._getMaxScrollY();
                var slightX = Math.abs(this._getScrollX() - scrollX) <= $.ui.igReportViewerConstants.definition.fullWindowScrollTolerance;
                var slightY = Math.abs(this._getScrollY() - scrollY) <= $.ui.igReportViewerConstants.definition.fullWindowScrollTolerance;

                if (overLeftEdge || overRightEdge) {
                    // Lock horizontal scroll
                    horizontalScrollEnabled = false;
                }

                if (overTopEdge || overBottomEdge) {
                    // Lock vertical scroll
                    verticalScrollEnabled = false;
                }

                if (overLeftEdge && slightY) {
                    // Trying to scroll to the left of the viewer, disable vertical scroll
                    verticalScrollEnabled = false;
                }

                if (overRightEdge && slightY) {
                    // Trying to scroll to the right of the viewer, disable vertical scroll
                    verticalScrollEnabled = false;
                }

                if (overTopEdge && slightX) {
                    // Trying to scroll to the top of the viewer, disable horizontal scroll
                    horizontalScrollEnabled = false;
                }

                if (overBottomEdge && slightX) {
                    // Trying to scroll to the bottom of the viewer, disable horizontal scroll
                    horizontalScrollEnabled = false;
                }
            }

            if (horizontalScrollEnabled) {
                this._clippingPanel.css('left', scrollX);
                offsetChanged = true;
            }

            if (verticalScrollEnabled) {
                this._clippingPanel.css('top', scrollY);
                offsetChanged = true;
            }

            return offsetChanged;
        },

        _applyPageFit: function () {
            if (this.options.pageFit == "fitToPage") {
                this.fitToPage();
                return true;
            }
            else if (this.options.pageFit == "fitToWidth") {
                this.fitToWidth();
                return true;
            }
            return false;
        },

        _correctViewport: function () {
            if (Modernizr.touch) {
                this._correctViewportTouch();
            }
            else {
                this._correctViewportNoTouch();
            }
        },

        _correctViewportTouch: function () {
            // If the page is smaller than the viewer, move the viewport to set the page in the center
            // If it's larger, move the viewport to display the page in the entire viewer

            if (!this._clippingPanel) {
                // There's no page displaying
                return;
            }

            if (this._animationState == $.ui.igReportViewerConstants.definition.animationStates.animating) {
                // Ignore viewport changes when there's an animation in progress
                return;
            }

            var contentWidth = this._clippingPanel.width();
            var contentHeight = this._clippingPanel.height();
            var contentPosition = this._clippingPanel.offset();

            if (contentWidth == 0) {
                // There's no page loaded, do nothing
                return;
            }

            var containerWidth = this._scrollPanel.width();
            var containerHeight = this._scrollPanel.height();
            var containerPosition = this._scrollPanel.offset();

            var leftMargin = contentPosition.left - containerPosition.left;
            var rightMargin = (containerPosition.left + containerWidth) - (contentPosition.left + contentWidth);
            var topMargin = contentPosition.top - containerPosition.top;
            var bottomMargin = (containerPosition.top + containerHeight) - (contentPosition.top + contentHeight);

            var currentX = parseInt(this._clippingPanel.css('left'));
            var currentY = parseInt(this._clippingPanel.css('top'));
            var targetX = currentX;
            var targetY = currentY;

            if (contentWidth < containerWidth) {
                // must center horizontally
                var targetHorizontalMargin = (containerWidth - contentWidth) / 2;
                targetX = targetHorizontalMargin;
            }
            else if (leftMargin > 0) {
                // must move left
                targetX = 0;
            }
            else if (rightMargin > 0) {
                // must move right
                targetX = this._getMaxScrollX();
            }

            if (contentHeight < containerHeight) {
                // must center vertically
                var targetVerticalMargin = (containerHeight - contentHeight) / 2;
                targetY = targetVerticalMargin;
            }
            else if (topMargin > 0) {
                // must move up
                targetY = 0;
            }
            else if (bottomMargin > 0) {
                // must move down
                targetY = this._getMaxScrollY();
            }

            this._clippingPanel.css('left', targetX);
            this._clippingPanel.css('top', targetY);

            if (this._resizing) {
                this._applyPageFit();
            }
        },

        _correctViewportNoTouch: function () {
            if (!this._applyPageFit()) {
                var totalHeight = this._pageHeight * this.options.zoomScale / 100;
                var viewportHeight = parseInt(this._scrollPanel.css('height'));
                var pageFitsVertically = viewportHeight - this._getBrowserScrollBarWidth() - totalHeight >= 1;

                if (pageFitsVertically) {
                    this._clippingPanel.css('top', "50%");
                    this._clippingPanel.css('margin-top', -(totalHeight / 2) + "px");
                } else {
                    this._clippingPanel.css('top', "0px");
                    this._clippingPanel.css('margin-top', "0px");
                }
            }
        },

        _scrollBarWidth: 0,

        /*! Grabbed from jquery-getscrollbarwidth: https://github.com/brandonaaron/jquery-getscrollbarwidth
        * Copyright (c) 2008 Brandon Aaron (brandon.aaron@gmail.com || http://brandonaaron.net)
        * MIT licensed (http://www.opensource.org/licenses/mit-license.php) 
        */
        _getBrowserScrollBarWidth: function () {
            if (!this._scrollbarWidth) {
                if ($.ig.util.isIE) {
                    var $textarea1 = $('<textarea cols="10" rows="2"></textarea>')
                        .css({ position: 'absolute', top: -1000, left: -1000 }).appendTo('body'),
                        $textarea2 = $('<textarea cols="10" rows="2" style="overflow: hidden;"></textarea>')
                            .css({ position: 'absolute', top: -1000, left: -1000 }).appendTo('body');
                    this._scrollbarWidth = $textarea1.width() - $textarea2.width();
                    $textarea1.add($textarea2).remove();
                } else {
                    var $div = $('<div />')
                        .css({ width: 100, height: 100, overflow: 'auto', position: 'absolute', top: -1000, left: -1000 })
                        .prependTo('body').append('<div />').find('div')
                        .css({ width: '100%', height: 200 });
                    this._scrollbarWidth = 100 - $div.width();
                    $div.parent().remove();
                }
            }

            return this._scrollbarWidth;
        },

        destroy: function () {
            /* Destroys the igReportViewer widget.
            */
            $.Widget.prototype.destroy.apply(this, arguments);
            this._vsm.cancel();
            this.element.removeClass(this.css.reportViewer);
            if (this.options.width) {
                this.element.css('width', '');
            }
            if (this.options.height) {
                this.element.css('height', '');
            }
            this.element.empty();
            $(this.element).removeClass('ui-reportviewer-minimum-size');
            $(this.element).remove(window);
            $(window).unbind('resize.igReportViewer');
            return this;
        }
    });

    $.extend($.ui.igReportViewer, $.ui.igReportViewerDefinitions);

    $.extend($.ui.igReportViewer, { version: '14.2.20142.1007' });
    $.ui.igReportViewerDefinitions = undefined;

}(jQuery));

(function ($) {
    $.widget('ui.igReportViewerLoading', {
        css: {
        },

        options: {
            /* type="string|number|null"
            string The widget width can be set in pixels (px) and percentage (%).
            number The widget width can be set as a number in pixels.
            null type="object" will stretch to fit data, if no other widths are defined.
            */
            width: null,

            /* type="string|number|null"
            string The height width can be set in pixels (px) and percentage (%).
            number The height width can be set as a number in pixels.
            null type="object" will fit the tree inside its parent container, if no other widths are defined.
            */
            height: null,

            /*
            The interval for the image to be rotated.
            */
            rotationInterval: null
        },

        widget: function () {
            return this.element;
        },

        destroy: function () {
            /* Destructor */
            $.Widget.prototype.destroy.apply(this, arguments);

            if (this._loadingIntervalId) {
                clearInterval(this._loadingIntervalId);
                this._loadingIntervalId = null;
                this._rotation = 0;
                this._imageUrlLoaded = false;
                this._canvas.width = this._canvas.width;
            }

            return this;
        },

        _createWidget: function (options, element) {
            /* Strip dummy objects from options, because they are defined for documentation purposes only! */
            this.options.bindings = null;
            $.Widget.prototype._createWidget.apply(this, arguments);
        },

        _create: function () {
            this._provideContainer(this.element);

            var opt = this.options;

            this.element.addClass(this.css.reportViewer);

            if ($.ig.util.isIE && $.ig.util.isIE7 && this.element.css('position') === 'static') {
                this.element.css('position', 'relative');
            }

            if (opt.width) {
                this.element.css('width', opt.width);
            }

            if (opt.height) {
                this.element.css('height', opt.height);
            }

            if (opt.rotationInterval) {
                this._rotationInterval = opt.rotationInterval;
            }
        },

        _setOption: function (option, value) {
            switch (option) {
                case 'width':
                    this.element.css('width', value);
                    break;
                case 'height':
                    this.element.css('height', value);
                    break;
                case 'rotationInterval':
                    this.options.rotationInterval = value;
                    break;
            }

            $.Widget.prototype._setOption.apply(this, arguments);
        },

        _provideContainer: function (container) {
            var UI_CONSTANTS = { LOADING_CSS_CLASSES: $.ui.igReportViewerConstants.definition.ui.viewerLoading };

            var loadingHtmlTemplate = '<div class="' + UI_CONSTANTS.LOADING_CSS_CLASSES + '">';
            loadingHtmlTemplate += '   <canvas class="animatedCanvas" width="0" height="0" />';
            loadingHtmlTemplate += '   <img class="imageToLoad" style="display:none"/>';
            loadingHtmlTemplate += '   </div>';

            var mainDiv = $(loadingHtmlTemplate);

            this._mainDiv = mainDiv;
            this._canvas = mainDiv.find('.animatedCanvas')[0];
            this._imageToLoad = mainDiv.find('.imageToLoad')[0];

            var self = this;

            container.append(this._mainDiv);

            this._rotation = 0;
            this._imageUrlLoaded = false;
            var ctx;

            this._imageToLoad.onerror = function () {
                container.trigger('_imageLoaded');
            };

            this._imageToLoad.onload = function () {
                if (!self._imageUrlLoaded) {
                    self._canvas.width = self._imageToLoad.naturalWidth;
                    self._canvas.height = self._imageToLoad.naturalHeight;

                    ctx = self._canvas.getContext("2d");
                    ctx.globalCompositeOperation = 'destination-over';
                    ctx.save();
                    ctx.drawImage(self._imageToLoad, 0, 0);

                    var color = self._mainDiv.css('color');
                    var colorRgb = self._parseColor(color);
                    var imageData = ctx.getImageData(0, 0, self._canvas.width, self._canvas.height);
                    var data = imageData.data;
                    var length = data.length;
                    var i = 0;

                    while (i < length) {
                        data[i++] = colorRgb.r;
                        data[i++] = colorRgb.g;
                        data[i++] = colorRgb.b;
                        i++;
                    }

                    ctx.putImageData(imageData, 0, 0);
                    ctx.restore();

                    self._imageUrlLoaded = true;
                    self._imageToLoad.src = self._canvas.toDataURL();
                    container.trigger('_imageLoaded');
                }
                else {
                    self._loadingIntervalId = setInterval(function () {
                        self._canvas.width = self._canvas.width;
                        self._rotation += 1;

                        ctx.translate(self._canvas.width / 2, self._canvas.height / 2);
                        ctx.rotate(self._rotation * Math.PI / 64);
                        ctx.translate(-self._canvas.width / 2, -self._canvas.height / 2);
                        ctx.drawImage(self._imageToLoad, 0, 0);
                        ctx.restore();
                    }, self.options.rotationInterval);
                }
            };

            var imageCssUrl = this._mainDiv.css('background-image');

            this._mainDiv.css('background-image', 'none');
            this._imageToLoad.src = this._parseUrl(imageCssUrl);
        },

        _parseUrl: function (imageCssUrl) {
            return imageCssUrl.replace(/"/g, '').replace(/'/g, '').replace(/url\(|\)$/ig, '');
        },

        _parseColor: function (color) {
            var regex = /^rgb\((\d{1,3}),\s*(\d{1,3}),\s*(\d{1,3})\)$/;
            var bits = regex.exec(color);

            return {
                r: parseInt(bits[1]),
                g: parseInt(bits[2]),
                b: parseInt(bits[3])
            };
        }
    });

    $.ig.util = $.ig.util || {};
    $.extend($.ig.util, {
        _isIOSPlatform: function () {
            return (navigator.platform.indexOf("iPod") != -1) || (navigator.platform.indexOf("iPhone") != -1) || (navigator.platform.indexOf("iPad") != -1);
        }
    });

    $.extend($.ui.igReportViewerLoading, { version: '14.2.20142.1007' });
}(jQuery));
$.ig.RepUtil = Class.extend({}, true);

$.ig.RepUtil.getAttributeValue = function (node, attributeName) {
    if (node.attributes[attributeName] == undefined) {
        return null;
    }
    return node.attributes[attributeName].value;
};

$.ig.RepUtil.parseColor = function (val, defaultIfNull) {

    if (val == null || val == "") {
        return defaultIfNull;
    }

    if (val.startsWith("##")) {

        // removing ##
        var value = val.substring(2, val.length);

        if (value.length == 8) { //Has alpha

            var red = parseInt(value.substring(2, 4), 16);
            var green = parseInt(value.substring(4, 6), 16);
            var blue = parseInt(value.substring(6, 8), 16);

            var alpha = Math.round((parseInt(value.substring(0, 2), 16) / 255) * 10) / 10;
            return "rgba(" + red + "," + green + "," + blue + "," + alpha + ")";
        } else if (value.length == 6) {
            return "#" + value;
        }
    }

    if (val == "0") {
        return "rgba(0,0,0,0)";
    }

    return val;
};

$.ig.RepUtil.getAttribute = function (node, attr) {
    var attribute = node.attributes.getNamedItem(attr);
    if (attribute != null) {
        return attribute.value;
    }
    return null;
};

$.ig.RepUtil.parseBool = function (value, defaultIfNull) {
    if (value == null) {
        return defaultIfNull;
    }
    if (value == "True" || value == "true") {
        return true;
    }

    return false;
};

$.ig.RepUtil.getBounds = function (node) {
    var widthValue = $.ig.RepUtil.getAttribute(node, "WidthInPx");
    if (widthValue == null) {
        widthValue = 0;
    }

    var heightValue = $.ig.RepUtil.getAttribute(node, "HeightInPx");
    if (heightValue == null) {
        heightValue = 0;
    }

    var posXValue = $.ig.RepUtil.getAttribute(node, "PositionXInPx");
    if (posXValue == null) {
        posXValue = 0;
    }

    var posYValue = $.ig.RepUtil.getAttribute(node, "PositionYInPx");
    if (posYValue == null) {
        posYValue = 0;
    }

    var zIndexValue = $.ig.RepUtil.getAttribute(node, "ZIndex");
    if (zIndexValue == null) {
        zIndexValue = null;
    }

    var width = parseFloat(widthValue);
    var height = parseFloat(heightValue);
    var posX = parseFloat(posXValue);
    var posY = parseFloat(posYValue);

    var zIndex = parseFloat(zIndexValue);

    var bounds = new $.ig.Bounds(posX, posY, width, height);
    bounds.setzIndex(zIndex);

    return bounds;
};

$.ig.RepUtil.translateVisibility = function (value) {
    if (value == "True") {
        return "visible";
    } else {
        return "none";
    }
};

$.ig.RepUtil.roundVal = function (val) {
    var dec = 2;
    var result = Math.round(val * Math.pow(10, dec)) / Math.pow(10, dec);

    //return Math.round(val)
    return result;
};

$.ig.PageSettingsData = Class.extend({
    _width: null,
    _height: null,
    _leftMargin: null,
    _topMargin: null,
    _rightMargin: null,
    _bottomMargin: null,
    _isLandscape: null,
    _isMirrorred: null,
    _paperName: null,

    init: function (width, height, topMargin, leftMargin, rightMargin, bottomMargin, isLandscape, isMirrored, paperName) {
        this._width = width;
        this._height = height;
        this._topMargin = topMargin;
        this._leftMargin = leftMargin;
        this._rightMargin = rightMargin;
        this._bottomMargin = bottomMargin;
        this._isLandscape = isLandscape;
        this._isMirrored = isMirrored;
        this._paperName = paperName;
    },

    getWidth: function () {
        return this._width;
    },

    getHeight: function () {
        return this._height;
    },

    getTopMargin: function () {
        return this._topMargin;
    },

    getLeftMargin: function () {
        return this._leftMargin;
    },

    getRightMargin: function () {
        return this._rightMargin;
    },

    getBottomMargin: function () {
        return this._bottomMargin;
    },

    getIsLandscape: function () {
        return this._isLandscape;
    },

    getIsMirrored: function () {
        return this._isMirrored;
    },

    getPaperName: function () {
        return this._paperName;
    }
}, true);

$.ig.PageSettingsData.parsePageSettingsData = function (xmlDefinition) {
    var top = null;
    var left = null;
    var right = null;
    var bottom = null;
    var mirrored = null;
    var width = null;
    var height = null;
    var landscape = null;
    var name = null;
    var margins = xmlDefinition.getElementsByTagName('Margin');
    if (margins.length > 0) {
        top = $.ig.RepUtil.getAttributeValue(margins[0], "Top");
        left = $.ig.RepUtil.getAttributeValue(margins[0], "Left");
        right = $.ig.RepUtil.getAttributeValue(margins[0], "Right");
        bottom = $.ig.RepUtil.getAttributeValue(margins[0], "Bottom");
        mirrored = $.ig.RepUtil.getAttributeValue(margins[0], "IsMirrored");
    }
    var paperSize = xmlDefinition.getElementsByTagName('PaperSize');
    if (paperSize.length > 0) {
        width = $.ig.RepUtil.getAttributeValue(paperSize[0], "Width");
        height = $.ig.RepUtil.getAttributeValue(paperSize[0], "Height");
        landscape = $.ig.RepUtil.getAttributeValue(paperSize[0], "IsLandscape");
        name = $.ig.RepUtil.getAttributeValue(paperSize[0], "Name");
    }
    return new $.ig.PageSettingsData(width, height, top, left, right, bottom, landscape, mirrored, name);
};

if (window.CanvasRenderingContext2D && CanvasRenderingContext2D.prototype.lineTo) {
    CanvasRenderingContext2D.prototype.dashedLine = function (x, y, x2, y2, dashArray) {
        if (!dashArray) {
            dashArray = [10, 5];
        }

        var dashCount = dashArray.length;
        this.moveTo(x, y);
        var dx = (x2 - x), dy = (y2 - y);
        var slope = dy / dx;
        var distRemaining = Math.sqrt(dx * dx + dy * dy);
        var dashIndex = 0, draw = true;

        while (distRemaining >= 0.1 && dashIndex < 10000) {
            var dashLength = dashArray[dashIndex++ % dashCount];
            if (dashLength > distRemaining) {
                dashLength = distRemaining;
            }
            var xStep = Math.sqrt(dashLength * dashLength / (1 + slope * slope));
            x += xStep
            y += slope * xStep;
            this[draw ? 'lineTo' : 'moveTo'](x, y);
            distRemaining -= dashLength;
            draw = !draw;
        }

        this.moveTo(0, 0);
    }
};

$.ig.Bounds = Class.extend({
    _top: 0,
    _left: 0,
    _width: 0,
    _height: 0,
    _zindex: 0,

    init: function (x, y, width, height) {
        this._top = y;
        this._left = x;
        this._width = width;
        this._height = height;
    },

    getLeft: function () {
        return this._left;
    },

    getTop: function () {
        return this._top;
    },

    getWidth: function () {
        return this._width;
    },

    getHeight: function () {
        return this._height;
    },

    getzIndex: function () {
        return this._zindex;
    },

    setzIndex: function (value) {
        this._zindex = value;
    }
}, true);

$.ig.RenderManager = Class.extend({
    _document: null,
    _rendererContainer: null,

    init: function () {
        this._rendererContainer = new $.ig.RendererContainer();
        this._dataSources = new Array();
    },

    initialize: function (reportDefinition) {
        this._reportDefinition = reportDefinition.documentElement;
        var defaultValues = {};
        this._getDefaultValues(reportDefinition.documentElement, defaultValues);
        this._defaultValues = defaultValues;
    },

    render: function (pageNode, container) {
        this._setDefaultValues(pageNode, this._defaultValues);
        var element = this._renderInternal(pageNode, container);

        return element;
    },

    addRenderer: function (controlName, renderer) {
        renderer.initialize(this);
        this._rendererContainer.addRenderer(controlName, renderer);
    },

    addDataSource: function (dataSourceName, data) {
        this._dataSources[dataSourceName] = data;
    },

    cleanDatasources: function () {
        this._datasources = new Array();
    },

    _renderInternal: function (item, container) {
        var name = item.nodeName;
        var renderer = this._rendererContainer.getRenderer(name);
        return renderer.render(item, container);
    },

    _getDefaultValues: function (element, defaultValues) {
        for (var controlIndex = 0; controlIndex < $.ui.igReportViewerConstants.definition.renderControlDefaults.length; controlIndex++) {
            var controlDefaults = $.ui.igReportViewerConstants.definition.renderControlDefaults[controlIndex];
            if (element.tagName == controlDefaults.control) {
                var uid = "#" + element.attributes["m:Uid"].value;
                
                defaultValues[uid] = {};

                for (var propertyIndex = 0; propertyIndex < controlDefaults.properties.length; propertyIndex++) {
                    var propertyName = controlDefaults.properties[propertyIndex].key;
                    var attribute = element.attributes[propertyName];
                    if (attribute != null) {
                        defaultValues[uid][propertyName] = attribute.value;
                    } else {
                        defaultValues[uid][propertyName] = controlDefaults.properties[propertyIndex].value;
                    }
                }
            }
        }

        for (var childIndex = 0; childIndex < element.childNodes.length; childIndex++) {
            var child = element.childNodes[childIndex];
            this._getDefaultValues(child, defaultValues);
        }
    },

    _setDefaultValues: function (element, defaultValues) {
        for (var controlIndex = 0; controlIndex < $.ui.igReportViewerConstants.definition.renderControlDefaults.length; controlIndex++) {
            var controlDefaults = $.ui.igReportViewerConstants.definition.renderControlDefaults[controlIndex];
            if (element.tagName == controlDefaults.control) {
                var relatedElement = element.attributes["Related" + controlDefaults.control];
                if (relatedElement != null) {
                    var uid = relatedElement.value;
                    var defaultForControl = defaultValues[uid];
                    if (defaultForControl != null) {
                        for (var propertyIndex = 0; propertyIndex < controlDefaults.properties.length; propertyIndex++) {
                            var propertyName = controlDefaults.properties[propertyIndex].key;
                            var attribute = element.attributes[propertyName];
                            if (attribute == null) {
                                var defaultPropertyValue = defaultForControl[propertyName];
                                if (defaultPropertyValue != null) {
                                    element.setAttribute(propertyName, defaultPropertyValue);
                                }
                            }
                        }
                    }
                }
            }
        }

        for (var i = 0; i < element.childNodes.length; i++) {
            var child = element.childNodes[i];
            this._setDefaultValues(child, defaultValues);
        }
    },

    getItemsDefinitionByTag: function (itemTagName) {
        return this._reportDefinition.getElementsByTagName(itemTagName);
    }
}, true);

$.ig.RendererContainer = Class.extend({
    _renderers: null,

    init: function () {
        this._renderers = new Array();
    },

    addRenderer: function (name, renderer) {
        this._renderers[name] = renderer;
    },

    getRenderer: function (typeName) {
        return this._renderers[typeName];
    }
}, true);

$.ig.PageRenderer = Class.extend({
    init: function () {
    },

    _rendererContainer: null,
    _pageSettings: null,

    initialize: function (renderManager) {
        this._rendererContainer = renderManager._rendererContainer;

        var settings = renderManager.getItemsDefinitionByTag("PageSettings");
        if (settings.length >= 1) {
            this._pageSettings = $.ig.PageSettingsData.parsePageSettingsData(settings[0]);
        }
    },

    render: function (page, container) {
        var pageWidth = $.ig.RepUtil.getAttribute(page, "WidthInPx") + "px";
        var pageHeight = $.ig.RepUtil.getAttribute(page, "HeightInPx") + "px";
        var background = $.ig.RepUtil.parseColor($.ig.RepUtil.getAttribute(page, "Background"));
        var topmargin = new $.ig.Measure(this._pageSettings.getTopMargin()).getValueInPx();
        var bottomMargin = new $.ig.Measure(this._pageSettings.getBottomMargin()).getValueInPx();
        var leftMargin = new $.ig.Measure(this._pageSettings.getLeftMargin()).getValueInPx();
        var rightMargin = new $.ig.Measure(this._pageSettings.getRightMargin()).getValueInPx();

        var pageHtml = "<table border='0px' ";
        pageHtml += "Width='" + pageWidth + "'";
        pageHtml += "Height='" + pageHeight + "'";
        pageHtml += "cellspacing='0px' cellpadding='0px' ";

        if (background != null) {
            pageHtml += "style='background:" + background + "'>";
        } else {
            pageHtml += "style='background:White'>";
        }

        pageHtml += "<tr Height='" + topmargin + "'>";
        pageHtml += "<td width='" + leftMargin + "'></td>";
        pageHtml += "<td></td>";
        pageHtml += "<td width='" + rightMargin + "'></td>";
        pageHtml += "</tr>";

        pageHtml += "<tr>";
        pageHtml += "<td></td>";
        pageHtml += "<td><table id='internalTable' cellspacing='0px' cellpadding='0px' border='0px'></table></td>";
        pageHtml += "<td></td>";
        pageHtml += "</tr>";

        pageHtml += "<tr Height='" + bottomMargin + "'>";
        pageHtml += "<td />";
        pageHtml += "<td />";
        pageHtml += "<td />";
        pageHtml += "</tr>";

        var pageInstance = $(pageHtml);
        container.append(pageInstance);

        var internalTable = pageInstance.find("#internalTable");

        var sections = page.getElementsByTagName("Section");
        var sectionRenderer = this._rendererContainer.getRenderer("Section");
        var i = 0;
        while (sections[i] != null) {
            var section = sections[i];
            var sectionBounds = sectionRenderer.getBounds(section);

            var sectionRowHtml = "<tr height='" + sectionBounds.getHeight() + "px'>";
            sectionRowHtml += "<td id='section" + i + "' width='" + sectionBounds.getWidth() + "px'></td></tr>";
            var sectionRow = $(sectionRowHtml);

            internalTable.append(sectionRow);

            var td = sectionRow.find("#section" + i);
            sectionRenderer.render(section, td);

            i++;
        }

        return pageInstance;
    }
}, true);

$.ig.SectionRenderer = Class.extend({
    init: function () {
    },
    _rendererContainer: null,

    initialize: function (renderManager) {
        this._rendererContainer = renderManager._rendererContainer;
    },

    render: function (node, container) {
        var sectionBounds = this.getBounds(node);
        var background = $.ig.RepUtil.parseColor($.ig.RepUtil.getAttribute(node, "Background"));

        var sectionHtml = "<div style='overflow: hidden";
        sectionHtml += "; position: relative";
        sectionHtml += "; height:" + sectionBounds.getHeight() + "px";
        sectionHtml += "; width:" + sectionBounds.getWidth() + "px";
        sectionHtml += "; background:" + background + "'>";

        var section = $(sectionHtml);
        container.append(section);

        if (node.childElementCount > 0) {

            var currentItem = node.firstElementChild.firstElementChild;

            // Getting visual for each of the elements included inside section.
            while (currentItem != null) {
                var renderer = this._rendererContainer.getRenderer(currentItem.tagName);
                if (renderer != null) {
                    var bounds = renderer.getBounds(currentItem);

                    var itemHtml = "<div style='position: absolute";
                    itemHtml += "; height:" + bounds.getHeight() + "px";
                    itemHtml += "; width:" + bounds.getWidth() + "px";
                    itemHtml += "; top:" + bounds.getTop() + "px";
                    itemHtml += "; left:" + bounds.getLeft() + "px";
                    itemHtml += "; z-index:" + bounds.getzIndex() + "'>";

                    var itemVisual = $(itemHtml);
                    section.append(itemVisual);

                    renderer.render(currentItem, itemVisual);
                }
                currentItem = currentItem.nextElementSibling;
            }
        }

        return section;
    },

    getBounds: function (node) {
        return $.ig.RepUtil.getBounds(node);
    }

}, true);

$.ig.TableRenderer = Class.extend({
    init: function () {
    },
    _rendererContainer: null,

    initialize: function (renderManager) {
        this._rendererContainer = renderManager._rendererContainer;
    },

    render: function (node, container) {

        var table = this._parseTable(node);
        var tableHtml = this._renderInternal(table);

        if (!(typeof (container.html) === 'undefined')) {
            container.html(tableHtml);
        }

        return tableHtml;
    },

    _parseTable: function (node) {
        var table = {};
        // Retrieving Table information from XML
        table.borderColor = $.ig.RepUtil.parseColor($.ig.RepUtil.getAttribute(node, "BorderColor"));
        table.borderThickness = new $.ig.reporting.Thickness($.ig.RepUtil.getAttribute(node, "BorderThickness"));
        table.visibility = $.ig.RepUtil.translateVisibility($.ig.RepUtil.getAttribute(node, "Visible"));
        table.padding = $.ig.RepUtil.getAttribute(node, "Padding");
        table.gridLinesColor = $.ig.RepUtil.parseColor($.ig.RepUtil.getAttribute(node, "GridLinesColor"));
        table.gridLinesThickness = $.ig.RepUtil.getAttribute(node, "GridLinesThickness");
        table.zIndex = $.ig.RepUtil.getAttribute(node, "ZIndex");
        table.childNode = node.firstElementChild;
        table.childsCount = node.childElementCount;

        return table;
    },

    _renderInternal: function (table) {

        if (table.padding == null) {
            table.padding = 0;
        }

        if (table.gridLinesThickness == null) {
            table.gridLinesThickness = 0;
        }

        if (table.gridLinesColor == null) {
            table.gridLinesColor = "black";
        }

        var template = "<table cellspacing='0px' cellpadding='0px' ";
        template += " style='border-style : solid ";
        template += ";visibility: " + table.visibility;

        if (table.borderThickness.getValue() != "0px 0px 0px 0px") {
            template += "; border-width:" + table.borderThickness.getValue();
            template += "; border-color:" + table.borderColor;
        } else {
            template += "; border-width:0px";
        }
        template += "'>";

        //Records : TableRecord*
        if (table.childsCount > 0) {

            // Retrieving table records.
            var currentRecord = table.childNode.firstElementChild;
            var i = 0;
            while (currentRecord != null) {
                var row = "<tr>";

                // Retrieveing fields.
                //var tableRecordFields = currentRecord.firstElementChild.childNodes;
                var currentTableRecordField = currentRecord.firstElementChild.firstElementChild;
                var j = 0;
                while (currentTableRecordField != null) {
                    // Foreach field

                    var rowspan = $.ig.RepUtil.getAttribute(currentTableRecordField, "RowSpan");
                    var colspan = $.ig.RepUtil.getAttribute(currentTableRecordField, "ColumnSpan");

                    var field = currentTableRecordField.firstElementChild.firstElementChild;
                    var renderer = this._rendererContainer.getRenderer(field.tagName);
                    if (renderer != null) {
                        // Getting field visual.

                        var cell = "<td ";

                        if (colspan != 1) {
                            cell += "colspan='" + colspan + "' ";
                        }

                        if (rowspan != 1) {
                            cell += " rowspan='" + rowspan + "'";
                        }

                        cell += " style='border-width: 0px";

                        if (i == 0) {
                            cell += ";border-top-width: " + table.gridLinesThickness;
                        }
                        if (j == 0) {
                            cell += ";border-left-width: " + table.gridLinesThickness;
                        }

                        cell += ";border-bottom-width: " + table.gridLinesThickness;
                        cell += ";border-right-width: " + table.gridLinesThickness;
                        cell += ";border-color: " + table.gridLinesColor;
                        cell += ";border-style: solid";
                        cell += ";padding: 0";

                        cell += "'>";

                        cell += renderer.render(field, cell);
                        cell += "</td>";

                        row += cell;
                    }

                    currentTableRecordField = currentTableRecordField.nextElementSibling;
                    j++;
                }

                row += "</tr>";
                template += row;
                i++;
                currentRecord = currentRecord.nextElementSibling;
            }
        }

        template += "</table>";

        return template;
    },

    getBounds: function (node) {
        return $.ig.RepUtil.getBounds(node);
    }
}, true);

$.ig.ImageRenderer = Class.extend({
    init: function () {
    },
    _embeddedImages: null,
    _imageId: 0,

    initialize: function (renderManager) {
        this._embeddedImages = new Array();

        var images = renderManager.getItemsDefinitionByTag("EmbeddedImage");
        for (var i = 0; i < images.length; i++) {
            var image = images[i];
            var imageData = image.attributes["ImageData"];
            if (imageData != undefined) {
                var imageName = $.ig.RepUtil.getAttribute(image, "Name");
                var mimeType = $.ig.RepUtil.getAttribute(image, "MimeType");

                this._embeddedImages[imageName] = { data: imageData.value, mimeType: mimeType };
            }
        }
    },

    render: function (node, container) {

        var imageData = this._parseImage(node);
        var imageHtml = this._renderInternal(imageData);

        if (!(typeof (container.html) === 'undefined')) {
            container.html(imageHtml);
        }

        return imageHtml;
    },

    _parseImage: function (node) {
        var image = {};
        var bounds = this.getBounds(node);
        image.name = $.ig.RepUtil.getAttribute(node, "ImageName");
        image.background = $.ig.RepUtil.parseColor($.ig.RepUtil.getAttribute(node, "Background"));
        image.borderColor = $.ig.RepUtil.parseColor($.ig.RepUtil.getAttribute(node, "BorderColor"), 'transparent');
        image.borderThickness = new $.ig.reporting.Thickness($.ig.RepUtil.getAttribute(node, "BorderThickness"));
        image.padding = new $.ig.reporting.Thickness($.ig.RepUtil.getAttribute(node, "Padding"));
        image.visibility = $.ig.RepUtil.translateVisibility($.ig.RepUtil.getAttribute(node, "Visible"));
        image.imageSizing = $.ig.RepUtil.getAttribute(node, "Sizing"); //  FitProportional, Fit, Clip
        image.imageUrl = $.ig.RepUtil.getAttribute(node, "ImageUrl");

        // In Html the with of the div do not include border width and we are suposing that includes so we 
        // have to remove those values from width / height.
        image.leftAndRightBorder = image.borderThickness.getLeftAndRight();
        image.topAndBottomBorder = image.borderThickness.getTopAndBottom();
        image.widthWithoutBorders = bounds.getWidth() - image.leftAndRightBorder;
        image.heightWithoutBorders = bounds.getHeight() - image.topAndBottomBorder;

        return image;
    },

    _renderInternal: function (node) {

        var imageId = this._imageId;
        this._imageId++;

        // Creating image html representation
        var imageHtml = "<table id='imageContainer" + imageId + "' ";
        imageHtml += "style='border-style: solid";
        imageHtml += ";border-color: " + node.borderColor;
        imageHtml += ";border-spacing: 0pt";
        imageHtml += ";border-width: " + node.borderThickness.getValue();
        imageHtml += ";visibility: " + node.visibility;
        imageHtml += "'><tr><td style='padding: 0px'>";

        imageHtml += "<div id='internalImageContainer" + imageId + "' ";
        imageHtml += "style='overflow: hidden; position: relative";
        imageHtml += ";width:" + node.widthWithoutBorders + "px";
        imageHtml += ";height:" + node.heightWithoutBorders + "px";
        imageHtml += ";background-color:" + node.background + "'>";

        if (node.name != null) {
            imageHtml += "<img alt='" + node.name + "' ";
        } else if (node.imageUrl != null) {
            imageHtml += "<img alt='" + node.imageUrl + "' ";
        } else {
            imageHtml += "<img ";
        }

        if (node.imageSizing == "Fit") {
            imageHtml += "style='";
            imageHtml += "width: " + node.widthWithoutBorders + "px";
            imageHtml += ";height: " + node.heightWithoutBorders + "px'";
        }
        else if (node.imageSizing == "Clip") {

        } else { // If it's not Clip or Fit then its FitProportional.
            imageHtml += "onload ='$.ig.ImageRenderer.resizeImage(this)' style='position: absolute' ";
        }

        if (node.imageUrl != null) { // Is not an embedded Image...
            imageHtml += "src ='" + node.imageUrl + "'";
        } else {
            var image = this._embeddedImages[node.name];
            if (image != null) {
                imageHtml += "src ='data:" + image.mimeType + ";base64," + image.data + "'";
            }
        }

        imageHtml += ">";
        imageHtml += "</img></div></td></tr></table>";

        return imageHtml;
    },

    getBounds: function (node) {
        return $.ig.RepUtil.getBounds(node);
    }
}, true);

$.ig.ImageRenderer.resizeImage = function (image) {
    var containerWidth = parseInt(image.parentNode.style.width);
    var containerHeight = parseInt(image.parentNode.style.height);
    var imageWidth = image.width;
    var imageHeight = image.height;

    var widthRatio = imageWidth / containerWidth;
    var heightRatio = imageHeight / containerHeight;
    if (widthRatio > heightRatio) {
        image.style.width = "100%";
        image.style.height = "auto";

        // centering the image
        var newImageHeight = containerWidth * imageHeight / imageWidth;
        var newTop = (containerHeight / 2) - (newImageHeight / 2);
        image.style.top = newTop + "px";
    } else {
        image.style.height = "100%";
        image.style.width = "auto";

        // centering the image
        var newImageWidth = containerHeight * imageWidth / imageHeight;
        var newLeft = (containerWidth / 2) - (newImageWidth / 2);
        image.style.left = newLeft + "px";
    }
};

$.ig.HorizontalLineRenderer = Class.extend({
    init: function () {
    },

    initialize: function (renderManager) {
    },

    render: function (node, container) {

        var line = this._parseLine(node);
        var bounds = this.getBounds(node);
        var dashGapArray = [];

        if (line.lineStyle == "Dot") {
            dashGapArray = [3, 2];
        }
        else if (line.lineStyle == "Dash") {
            dashGapArray = [16, 5];
        }
        else if (line.lineStyle == "DashDot") {
            dashGapArray = [16, 5, 3, 5];
        }
        else if (line.lineStyle == "DashDotDot") {
            dashGapArray = [16, 5, 3, 2, 3, 5];
        }

        var height = line.lineThickness;
        var width = bounds.getWidth();
        var c = $('<canvas></canvas>');

        c.css("visibility", line.visibility);
        c.css("position", "absolute");
        c.css("top", "0");

        c[0].width = width;

        if (height > 2) {
            c[0].height = height;
        } else {
            c[0].height = 2;
        }

        var ctx = (c[0]).getContext('2d');
        ctx.strokeStyle = line.lineColor;
        ctx.clearRect(0, 0, c[0].width, c[0].height);

        ctx.lineWidth = height;
        ctx.lineCap = "butt";
        ctx.beginPath();
        if (dashGapArray.length == 0) {
            ctx.moveTo(0, height / 2);
            ctx.lineTo(width, height / 2);
        } else {
            ctx.dashedLine(0, height / 2, width, height / 2, dashGapArray);
        }
        ctx.closePath();
        ctx.stroke();
        ctx = null;

        container.append(c);

        return c;
    },

    _parseLine: function (node) {
        var line = {};
        line.lineColor = $.ig.RepUtil.parseColor($.ig.RepUtil.getAttribute(node, "LineColor"));
        line.lineThickness = new $.ig.Measure($.ig.RepUtil.getAttribute(node, "LineThickness")).getValueInPx();
        line.lineStyle = $.ig.RepUtil.getAttribute(node, "LineStyle");
        line.visibility = $.ig.RepUtil.translateVisibility($.ig.RepUtil.getAttribute(node, "Visible"));

        return line;
    },

    getBounds: function (node) {
        return $.ig.RepUtil.getBounds(node);
    }
}, true);

$.ig.LabelRenderer = Class.extend({
    init: function () {
    },

    initialize: function (renderManager) {
    },

    render: function (node, container) {
        var label = this._parseLabel(node);

        var labelHtml = null;

        labelHtml = this._renderNormalLabel(label);

        label = null;

        if (!(typeof (container.html) === 'undefined')) {
            container.html(labelHtml);
        }

        return labelHtml;
    },

    _parseLabel: function (node) {
        var label = {};
        // Parsing XML retrieving label attributes.
        var bounds = this.getBounds(node);
        label.text = this._prepareText($.ig.RepUtil.getAttribute(node, "Text"));
        label.borderColor = $.ig.RepUtil.parseColor($.ig.RepUtil.getAttribute(node, "BorderColor"));
        label.borderThickness = new $.ig.reporting.Thickness($.ig.RepUtil.getAttribute(node, "BorderThickness"));
        label.borderWidth = label.borderThickness.getValue();
        label.foreground = $.ig.RepUtil.parseColor($.ig.RepUtil.getAttribute(node, "Foreground"));
        label.background = $.ig.RepUtil.parseColor($.ig.RepUtil.getAttribute(node, "Background"));
        label.fontSize = $.ig.RepUtil.getAttribute(node, "FontSize");
        label.visibility = $.ig.RepUtil.translateVisibility($.ig.RepUtil.getAttribute(node, "Visible"));
        label.padding = new $.ig.reporting.Thickness($.ig.RepUtil.getAttribute(node, "Padding"));
        label.fontStyle = $.ig.RepUtil.getAttribute(node, "FontStyle");
        label.fontWeight = $.ig.RepUtil.getAttribute(node, "FontWeight");
        label.textDecoration = $.ig.RepUtil.getAttribute(node, "TextDecoration");
        label.verticalTextAlignment = $.ig.RepUtil.getAttribute(node, "VerticalTextAlignment");
        label.horizontalTextAlignment = $.ig.RepUtil.getAttribute(node, "HorizontalTextAlignment");
        label.fontFamily = $.ig.RepUtil.getAttribute(node, "FontFamily");

        // In Html the with of the div do not include border width and we are suposing that includes so we 
        // have to remove those values from width / height.
        label.leftAndRightBorder = label.borderThickness.getLeftAndRight();
        label.topAndBottomBorder = label.borderThickness.getTopAndBottom();
        label.widthWithoutBorders = bounds.getWidth() - label.leftAndRightBorder;
        label.heightWithoutBorders = bounds.getHeight() - label.topAndBottomBorder;

        return label;
    },

    _renderNormalLabel: function (label) {
        var template = "<div style='overflow:hidden; border-style:solid";
        template += ";width:" + label.widthWithoutBorders + "px";
        template += ";height:" + label.heightWithoutBorders + "px";
        template += ";background:" + label.background;
        template += ";visibility: " + label.visibility;
        template += ";border-color: " + label.borderColor;
        template += ";border-width: " + label.borderWidth + "'>";

        template += "<table style='table-layout:fixed;overflow:hidden;";
        template += ";width:" + label.widthWithoutBorders + "px";
        template += ";height:" + label.heightWithoutBorders + "px" + "' cellspacing='0'>";

        template += "<tr><td style='word-wrap: break-word";

        if (label.horizontalTextAlignment != null) {
            template += ";text-align:" + label.horizontalTextAlignment;
        }
        else {
            template += ";text-align: Left";
        }

        if (label.verticalTextAlignment != null) {
            template += ";vertical-align:" + label.verticalTextAlignment;
        } else {
            template += ";vertical-align: Top";
        }

        if (label.foreground != null) {
            template += ";color:" + label.foreground;
        }

        if (label.fontStyle != null) {
            template += ";font-style:" + label.fontStyle;
        }

        if (label.fontWeight != null) {
            template += ";font-weight:" + label.fontWeight;
        }

        if (label.fontSize != null) {
            template += ";font-size:" + label.fontSize;
        }

        if (label.fontFamily != null) {
            template += ";font-family:" + label.fontFamily;
        }
        else {
            template += ";font-family: verdana";
        }

        if (label.textDecoration != null) {
            template += ";text-decoration:" + label.textDecoration;
        }

        template += ";padding:" + label.padding.getValue() + ";'>";

        template += label.text + "</td></tr></table></div>";

        return template;
    },

    getBounds: function (node) {
        return $.ig.RepUtil.getBounds(node);
    },

    _prepareText: function (text) {
        if (text == null || text == "") {
            return "";
        }

        text = this._replaceAll("\r\n", "<br/>", text);
        text = this._replaceAll("\n", "<br>", text);
        text = this._replaceAll("\r", "<br>", text);

        var trasformedText = "";

        // If the text starts with space in HTML then will be cut
        if (text.startsWith(" ")) {
            trasformedText += "&nbsp;";
        }
        else {
            trasformedText = text[0];
        }

        // If there are more than one space together then the first character will be a space and the others a "&nbsp;"
        var i = 1;
        while (i < text.length) {
            if (text[i] == " ") {
                trasformedText += text[i];
                var auxIndex = i + 1;
                while (text[auxIndex] == " ") {
                    trasformedText += "&nbsp;";
                    auxIndex++;
                }
                i = auxIndex;
            } else {
                trasformedText += text[i];
                i++;
            }
        }

        if (trasformedText != null && trasformedText[0] == '#' && trasformedText[1] == "#") {
            trasformedText = trasformedText.substring(1, trasformedText.length);
        }

        return trasformedText;
    },

    _replaceAll: function (find, replace, str) {
        while (str.contains(find)) {
            str = str.replace(find, replace);
        }

        return str;
    }
}, true);

$.ig.ChartRenderer = Class.extend({
    init: function () {
    },
    _charts: new Array(),
    _chartId: 0,

    initialize: function (renderManager) {
        this._rendererManager = renderManager;

        var charts = this._rendererManager.getItemsDefinitionByTag("Chart");

        for (var i = 0; i < charts.length; i++) {
            var chartId = $.ig.RepUtil.getAttribute(charts[i], "m:Uid");
            this._charts[chartId] = charts[i];
        }
    },

    render: function (chartRim, container) {
        var bounds = this.getBounds(chartRim);
        var id = this._getChartId();
        var chartName = "chartContent" + id;
        var chartContainerWidth = bounds.getWidth() + "px";
        var chartContainerHeight = bounds.getHeight() + "px";
        var visibility = $.ig.RepUtil.translateVisibility($.ig.RepUtil.getAttribute(chartRim, "Visible"));
        var background = $.ig.RepUtil.parseColor($.ig.RepUtil.getAttribute(chartRim, "Background"));
        var chartDefId = $.ig.RepUtil.getAttribute(chartRim, "RelatedChart");

        if (chartDefId.startsWith("#")) {
            chartDefId = chartDefId.split("#")[1];
        }

        var chartDefinition = this._charts[chartDefId];

        try {
            var axes = this._parseAxis(chartDefinition);
            var series = this._parseSeries(chartDefinition);
            var legend = this._parseLegend(chartDefinition, series);
        } catch (e) {
            var message = "Error parsing Chart Data. " + e;
            this._renderError(container, chartContainerWidth, chartContainerHeight, message);
            return;
        }

        try {
            var datasources = $.ig.RepUtil.getAttribute(chartRim, "_DataRequirementsProperties");
            if (datasources == null) {
                throw "Chart datasource couldn't be read";
            }

            var serieDataSourceIds = datasources.split("#");
            var data = this._createDataStructure(serieDataSourceIds);
        } catch (e) {
            var message = "Error processing Chart DataSource. " + e;
            this._renderError(container, chartContainerWidth, chartContainerHeight, message);
            return;
        }

        try {
            var templateParam = {
                chartVisibility: visibility,
                chartBackground: background,
                containerWidth: chartContainerWidth,
                containerHeight: chartContainerHeight,
                chartName: chartName,
                legend: legend
            };

            var jQueryTemplate = this._getChartTemplate(templateParam, container);

            var chartVisualContent = jQueryTemplate.find("#" + chartName);
            var chartContentHeight = chartVisualContent.css("height");
            var chartContentWidth = chartVisualContent.css("width");

            var chartVisualLegend = jQueryTemplate.find("#" + legend.name);
            if (chartVisualLegend.length > 0) {
                $.each(series, function (i, serie) {
                    serie.legend = { element: legend.name };
                });
            }
        }
        catch (e) {
            var message = "Error creating Chart Template. " + e;
            this._renderError(container, chartContainerWidth, chartContainerHeight, message);
            return;
        }

        try {
            chartVisualContent.igDataChart({
                width: chartContentWidth,
                height: chartContentHeight,
                dataSource: data,
                axes: axes,
                series: series,
                plotAreaBackground: "#EEF0F2",
                horizontalZoomable: false,
                verticalZoomable: false,
                windowResponse: "immediate",
                tooltipShown: this._tooltipHandler
            });
        }
        catch (e) {
            var message = "Error instantiating Chart. " + e;
            this._renderError(container, chartContainerWidth, chartContainerHeight, message);
            return;
        }

        try {

            jQueryTemplate.find("*").not(".ui-chart-legend-item").not(".ui-chart-legend-items-list ").not(".ui-chart-axis").not(".ui-chart-legend-item-text").not(".ui-chart-legend-item-badge").not(".ui-chart-tooltip").removeClass();

            var width = parseFloat(chartContentWidth);
            var height = parseFloat(chartContentHeight);

            chartVisualContent.igDataChart("flush");

            var chartImage = chartVisualContent.data('igDataChart').exportImage(width, height);

            chartVisualContent.empty();
            chartVisualContent.append(chartImage);
        }
        catch (e) {
            var message = "Error creating Chart Image. " + e;
            this._renderError(container, chartContainerWidth, chartContainerHeight, message);
            return;
        }
    },

    getBounds: function (node) {
        return $.ig.RepUtil.getBounds(node);
    },

    setUpZoom: function (zoomManager) {
        var that = this;
        zoomManager.element.bind('zoomScaleChanged', function (event, oldValue, newZoomScale) {
            var viewer = $(event.target);

            if (oldValue == 100) {
                if (newZoomScale != 100) {
                    // Disable Tooltip
                    that._disableChartTooltips(viewer);
                } else {
                    // this should never happend.
                }
            } else {
                if (newZoomScale != 100) {
                    // If tooltip was not disabled yet then should be disabled.
                    if (that._chartTooltipsDisabled == undefined || !that._chartTooltipsDisabled) {
                        that._disableChartTooltips(viewer);
                    }
                } else {
                    // Enable tooltip
                    that._enableChartTooltips(viewer);
                }
            }

        });
    },

    _disableChartTooltips: function (viewer) {
        var brush = "rgba(0,255,0,1)";
        var charts = viewer.find("[id^=chartContent]").not("[id$=container]");
        for (var i = 0; i < charts.length; i++) {
            var chartHtml = charts[i];
            var chart = $(chartHtml);
            var chartSeries = chart.data('igDataChart').options.series;
            for (var j = 0; j < chartSeries.length; j++) {
                if (chartSeries[j] != null && chartSeries[j] != undefined) {
                    //chart.igDataChart("option", "series", [{ name: chartSeries[j].name, brush: brush}]);
                    //chart.igDataChart("option", "series", [{ name: chartSeries[j].name, brush: brush, showTooltip: false}]);    
                }
            }

            chart.igDataChart("styleUpdated");
        }

        this._chartTooltipsDisabled = true;
    },

    _enableChartTooltips: function (viewer) {
        var brush = "rgba(0,0,255,1)";
        var charts = viewer.find("[id^=chartContent]").not("[id$=container]");
        for (var i = 0; i < charts.length; i++) {
            var chartHtml = charts[i];
            var chart = $(chartHtml);
            var chartSeries = chart.data('igDataChart').options.series;
            for (var j = 0; j < chartSeries.length; j++) {
                if (chartSeries[j] != null && chartSeries[j] != undefined) {
                    //chart.igDataChart("option", "series", [{ name: chartSeries[j].name, brush: brush}]);
                    //chart.igDataChart("option", "series", [{ name: chartSeries[j].name, brush: brush, showTooltip: false}]);    
                }
            }

            chart.igDataChart("styleUpdated");
        }

        this._chartTooltipsDisabled = false;
    },

    _setAxisLabelSettings: function (axisLabelSettingsDef, axis) {
        var angle = parseInt($.ig.RepUtil.getAttribute(axisLabelSettingsDef, "Angle"));
        var extent = $.ig.RepUtil.getAttribute(axisLabelSettingsDef, "Extent");
        var foreground = $.ig.RepUtil.getAttribute(axisLabelSettingsDef, "Foreground");
        var location = $.ig.RepUtil.getAttribute(axisLabelSettingsDef, "Location");

        var fontFamily = $.ig.RepUtil.getAttribute(axisLabelSettingsDef, "FontFamily");
        if (fontFamily == null) {
            fontFamily = "Verdana";
        }

        var fontSize = $.ig.RepUtil.getAttribute(axisLabelSettingsDef, "FontSize");
        if (fontSize == null) {
            fontSize = new $.ig.Measure("12pt").getValueInPx() + "px";
        }
        else {
            fontSize = new $.ig.Measure(fontSize).getValueInPx() + "px";
        }

        var fontStyle = $.ig.RepUtil.getAttribute(axisLabelSettingsDef, "FontStyle");
        if (fontStyle == null) {
            fontStyle = "normal";
        }

        var fontWeight = $.ig.RepUtil.getAttribute(axisLabelSettingsDef, "FontWeight");
        if (fontWeight == null) {
            fontWeight = "normal";
        }

        var font = fontStyle + " " + fontWeight + " " + fontSize + " " + fontFamily;

        if (extent == null) {
            extent = "25px";
        }
        extent = parseInt(new $.ig.Measure(extent).getValueInPx());

        if (foreground == null) {
            foreground = "black";
        }
        foreground = $.ig.RepUtil.parseColor(foreground);

        var labelVisibility = $.ig.RepUtil.getAttribute(axisLabelSettingsDef, "Visible");
        if (labelVisibility == null) {
            axis.labelVisibility = "visible";
        }
        else if (labelVisibility == "False") {
            axis.labelVisibility = "collapsed";
        }

        axis.labelTextStyle = font;
        axis.labelTextColor = foreground;
        axis.labelAngle = angle;
        axis.labelExtent = extent;
        axis.labelLocation = this._translateLocation(location);

        /*
        var horizontalTextAlignment = $.ig.RepUtil.getAttribute(axisLabelSettingsDef, "HorizontalTextAlignment");
        var opacity = $.ig.RepUtil.getAttribute(axisLabelSettingsDef, "Opacity");
        var opacityMask = $.ig.RepUtil.getAttribute(axisLabelSettingsDef, "OpacityMask");
        var padding = $.ig.RepUtil.getAttribute(axisLabelSettingsDef, "Padding");
        var textDecoration = $.ig.RepUtil.getAttribute(axisLabelSettingsDef, "TextDecoration");
        var verticalTextAlignment = $.ig.RepUtil.getAttribute(axisLabelSettingsDef, "VerticalTextAlignment");*/
    },

    _parseAxis: function (chartDef) {
        var axesDef = chartDef.getElementsByTagName("Axes")[0].childNodes;
        var axes = [];

        for (var i = 0; i < axesDef.length; i++) {
            var axisDef = axesDef[i];
            var axisType = this._convertAxisType(axisDef.tagName);

            var axis = {
                name: "Axis" + i,
                type: axisType
            };

            var label = $.ig.RepUtil.getAttribute(axisDef, "Label");
            if (label != null) {
                axis.label = label;
            }

            var majorStroke = $.ig.RepUtil.getAttribute(axisDef, "MajorStroke");
            if (majorStroke != null && majorStroke != "") {
                axis.majorStroke = $.ig.RepUtil.parseColor(majorStroke);
            } else {
                axis.majorStroke = "Gray";
            }

            var majorStrokeThickness = $.ig.RepUtil.getAttribute(axisDef, "MajorStrokeThickness");
            if (majorStrokeThickness != null) {
                axis.majorStrokeThickness = parseFloat(new $.ig.Measure(majorStrokeThickness).getValueInPx());
            }
            else {
                axis.majorStrokeThickness = 0;
            }

            var minorStroke = $.ig.RepUtil.getAttribute(axisDef, "MinorStroke");
            var minorStrokeThickness = $.ig.RepUtil.getAttribute(axisDef, "MinorStrokeThickness");

            if ((minorStroke != null && minorStroke != "") && minorStrokeThickness != null) {
                axis.minorStroke = $.ig.RepUtil.parseColor(minorStroke);
            }

            if (minorStrokeThickness != null) {
                axis.minorStrokeThickness = parseFloat(new $.ig.Measure(minorStrokeThickness).getValueInPx());
            }

            var interval = $.ig.RepUtil.getAttribute(axisDef, "Interval");
            if (interval != null && interval != "NaN") {
                axis.interval = parseInt(interval);
            }

            axis.isInverted = $.ig.RepUtil.parseBool($.ig.RepUtil.getAttribute(axisDef, "IsInverted"), false);

            var strip = $.ig.RepUtil.getAttribute(axisDef, "Strip");
            if (strip != null && strip != "") {
                axis.strip = $.ig.RepUtil.parseColor(strip);
            }

            this._setAxisLabelSettings(axisDef.getElementsByTagName("LabelSettings")[0], axis);
            axes.add(axis);

            if (axisType == "numericY") {

                var islog = $.ig.RepUtil.getAttribute(axisDef, "IsLogarithmic");
                axis.isLogarithmic = $.ig.RepUtil.parseBool(islog, false);

                var logBase = $.ig.RepUtil.getAttribute(axisDef, "LogarithmBase");
                if (logBase != null && logBase != undefined) {
                    axis.logarithmBase = parseFloat(logBase);
                } else {
                    axis.logarithmBase = 10;
                }

                var minimumValue = $.ig.RepUtil.getAttribute(axisDef, "MinimumValue");
                if (minimumValue != null) {
                    axis.minimumValue = parseFloat(minimumValue);
                }

                var maximumValue = $.ig.RepUtil.getAttribute(axisDef, "MaximumValue");
                if (maximumValue != null) {
                    axis.maximumValue = parseFloat(maximumValue);
                }
            }
            if (axisType == "categoryDateTimeX") {
                var member = $.ig.RepUtil.getAttribute(axisDef, "Label");
                axis.dateTimeMemberPath = member + "!parseDate";
                axis.coercionMethods =
                     {
                         parseDate: function (val) {
                             var newVal = new Date(val);
                             return newVal;
                         }
                     };
                axis.formatLabel = function (val) {
                    var month = val.getMonth() + 1;
                    var day = val.getDate();
                    var year = val.getFullYear();
                    return month + "/" + day + "/" + year;
                };
            }
        }

        return axes;
    },

    _parseSeries: function (chartDef) {
        var seriesDef = chartDef.getElementsByTagName("ChartSeries")[0].childNodes;

        var defaultBrushColor = "Yellow";
        var defaultOutlineColor = "Blue";
        var defaultNegativeColor = "Red";
        var defaultThickness = 1;

        var series = new Array();
        for (var i = 0; i < seriesDef.length; i++) {
            var serieDef = seriesDef[i];

            var serieType = this._convertSerieType(serieDef.tagName);

            var toolTip = $.ig.RepUtil.getAttribute(serieDef, "Tooltip");

            var brush = $.ig.RepUtil.getAttribute(serieDef, "Brush");
            if (brush == null) {
                brush = defaultBrushColor;
            }
            brush = $.ig.RepUtil.parseColor(brush);

            var outline = $.ig.RepUtil.getAttribute(serieDef, "Outline");
            if (outline == null) {
                outline = defaultOutlineColor;
            }
            var outlineColor = $.ig.RepUtil.parseColor(outline);

            var outlineThickness = $.ig.RepUtil.getAttribute(serieDef, "OutlineThickness");
            if (outlineThickness == null) {
                outlineThickness = defaultThickness;
            }
            outlineThickness = parseInt(outlineThickness);

            var thickness = $.ig.RepUtil.getAttribute(serieDef, "Thickness");
            if (thickness == null) {
                thickness = defaultThickness;
            }
            thickness = parseInt(thickness);

            var negativeColor = $.ig.RepUtil.getAttribute(serieDef, "NegativeBrush");
            if (negativeColor == null) {
                negativeColor = defaultNegativeColor;
            }
            negativeColor = $.ig.RepUtil.parseColor(negativeColor);

            var title = $.ig.RepUtil.getAttribute(serieDef, "Title");
            if (title == null) {
                title = " ";
            }

            if (serieType == "column") {
                var columnSerie = {
                    name: "Serie" + i,
                    type: serieType,
                    brush: brush,
                    outline: outlineColor,
                    thickness: outlineThickness,
                    valueMemberPath: $.ig.RepUtil.getAttribute(serieDef, "ValueMemberPath"),
                    title: title,
                    xAxis: "Axis0",
                    yAxis: "Axis1"
                };

                if (toolTip != null) {
                    columnSerie.toolTip = toolTip;
                    columnSerie.showTooltip = true;
                }

                series.add(columnSerie);
            } else if (serieType == "line") {
                var lineSerie = {
                    name: "Serie" + i,
                    type: serieType,
                    xAxis: "Axis0",
                    yAxis: "Axis1",
                    brush: brush,
                    title: title,
                    thickness: thickness,
                    valueMemberPath: $.ig.RepUtil.getAttribute(serieDef, "ValueMemberPath")
                };

                if (toolTip != null) {
                    lineSerie.toolTip = toolTip;
                    lineSerie.showTooltip = true;
                }

                series.add(lineSerie);
            } else if (serieType == "area") {
                var areaSerie = {
                    name: "Serie" + i,
                    type: serieType,
                    xAxis: "Axis0",
                    yAxis: "Axis1",
                    brush: brush,
                    title: title,
                    outline: outlineColor,
                    thickness: outlineThickness,
                    valueMemberPath: $.ig.RepUtil.getAttribute(serieDef, "ValueMemberPath")
                };

                if (toolTip != null) {
                    areaSerie.toolTip = toolTip;
                    areaSerie.showTooltip = true;
                }

                series.add(areaSerie);
            } else if (serieType == "financial") {
                var financialSerie = {
                    name: "Serie" + i,
                    type: serieType,
                    xAxis: "Axis0",
                    yAxis: "Axis1",
                    brush: brush,
                    title: title,
                    outline: outlineColor,
                    thickness: outlineThickness,
                    negativeBrush: negativeColor,
                    lowMemberPath: $.ig.RepUtil.getAttribute(serieDef, "LowMemberPath"),
                    highMemberPath: $.ig.RepUtil.getAttribute(serieDef, "HighMemberPath"),
                    openMemberPath: $.ig.RepUtil.getAttribute(serieDef, "OpenMemberPath"),
                    closeMemberPath: $.ig.RepUtil.getAttribute(serieDef, "CloseMemberPath"),
                    displayType: this._getFinancialSerieDisplayType(serieDef)
                };

                if (toolTip != null) {
                    financialSerie.toolTip = toolTip;
                    financialSerie.showTooltip = true;
                }

                series.add(financialSerie);
            }
        }

        return series;
    },

    _parseLegend: function (chartDef) {

        var legendWidthMargin = 50;
        var legendWidthInternalMargin = 29;
        var legendHeightMargin = 30;
        var legendHeightInternalMargin = 8;
        //Segoe UI - 12px
        // 11px Segoe UI, Verdana;
        var legendCSSFormatFontStyle = "10px Verdana";
        var legendHTMLFormatFontStyle = "font-family: Verdana; font-size: 10px;";

        var chartLegendName = "chartLegend" + this._chartId;
        var chartLegend = chartDef.getElementsByTagName("Legend")[0];
        var background = $.ig.RepUtil.parseColor($.ig.RepUtil.getAttribute(chartLegend, "Background"));

        var visible = $.ig.RepUtil.getAttribute(chartLegend, "LegendVisible");
        visible = $.ig.RepUtil.parseBool(visible, false);

        var location = $.ig.RepUtil.getAttribute(chartLegend, "Location");

        if (location == null) {
            location = "InsideBottom";
        }

        var orientation = "";

        if ($.ig.RepUtil.getAttribute(chartLegend, "HorizontalOrientation") == "True") {
            orientation = "Horizontal";
        } else {
            orientation = "Vertical";
        }

        var title = $.ig.RepUtil.getAttribute(chartLegend, "Content");

        var legendWidth = 0;
        var legendHeight = 0;

        var seriesDef = chartDef.getElementsByTagName("ChartSeries")[0].childNodes;
        for (var i = 0; i < seriesDef.length; i++) {
            var serieDef = seriesDef[i];
            var serieTitle = $.ig.RepUtil.getAttribute(serieDef, "Title");
            var auxWidth = this._getTextWidth(legendCSSFormatFontStyle, serieTitle);
            var auxHeight = this._getTextHeight(legendHTMLFormatFontStyle, serieTitle);

            if (orientation == "Vertical") {
                legendWidth = Math.max(legendWidth, auxWidth);
                legendHeight += (auxHeight + legendHeightInternalMargin);
            } else if (orientation == "Horizontal") {
                legendWidth += (auxWidth + legendWidthInternalMargin);
                legendHeight = Math.max(legendHeight, auxHeight); ;
            }
        }

        if (title != null) {
            auxWidth = this._getTextWidth(legendCSSFormatFontStyle, title);
            legendWidth = Math.max(legendWidth, auxWidth);

            auxHeight = this._getTextHeight(legendHTMLFormatFontStyle, title);
            legendHeight += auxHeight;
        }

        var legend = {
            fontStyle: legendCSSFormatFontStyle,
            title: title,
            background: background,
            visible: visible,
            location: location,
            orientation: orientation,
            name: chartLegendName
        };

        if (legendWidth != 0) {
            legend.width = (legendWidth + legendWidthMargin) + "px";
        }

        if (legendHeight != 0) {
            legend.height = (legendHeight + legendHeightMargin) + "px";
        }

        return legend;
    },

    _createDataStructure: function (dataSourceIds) {
        // This should not be necessary. We are doing this as a workaround because datasources per serie is not working as expected.
        var attributes = [];
        var names = [];
        var fieldsType = [];
        for (var j = 0; j < dataSourceIds.length; j++) {
            var id = dataSourceIds[j];
            if (id != null && id != "") {
                var xml = this._rendererManager._dataSources[id.split(";")[0]];

                // Getting datasource fields from metadata.
                var parsedDatasource = $.ig.XmlDocumentParser.prototype.parse(xml).documentElement;
                var fields = parsedDatasource.getElementsByTagName("Field");
                var fieldsArray = [];
                for (var i = 0; i < fields.length; i++) {
                    var attr = $.ig.RepUtil.getAttribute(fields[i], "Name");
                    var typeAttr = $.ig.RepUtil.getAttribute(fields[i], "Type");

                    fieldsArray.add(attr);

                    if (fieldsType[attr] == null) {
                        fieldsType[attr] = typeAttr;
                    }
                }

                var records = parsedDatasource.getElementsByTagName("Record");
                if (records.length == 0) {
                    return null;
                }

                var keyName = fieldsArray[0];

                for (var k = 0; k < records.length; k++) {
                    var record = records[k];
                    var recordName = $.ig.RepUtil.getAttribute(record, keyName);
                    if (attributes[k] == null) {
                        attributes[k] = [];
                        names.add(recordName);
                    }

                    for (var l = 0; l < record.attributes.length; l++) {
                        var attr = record.attributes[l];
                        if (attr.name != keyName) {
                            attributes[k].add(attr);
                        }
                    }
                }
            }
        }

        var stringData = "[";

        for (var m = 0; m < names.length; m++) {
            var attrs = attributes[m];

            var item = '{ "' + keyName + '" : ' + this._parseValue(names[m], fieldsType[keyName]);

            for (var n = 0; n < attrs.length; n++) {
                item += ', "' + attrs[n].name + '" : ' + this._parseValue(attrs[n].value, fieldsType[attrs[n].name]);
            }
            item += '},';
            stringData += item;
        }

        stringData = stringData.substr(0, stringData.length - 1);

        stringData += "]";
        var data = eval('(' + stringData + ')');
        return data;
    },

    _getTextWidth: function (fontStyle, text) {
        var canvas = $("<canvas>")[0];
        var ctx = canvas.getContext("2d");
        ctx.font = fontStyle;
        var textWidth = ctx.measureText(text);
        canvas = null;
        ctx = null;
        return textWidth.width;
    },

    _getTextHeight: function (fontStyle, text) {
        var body = document.getElementsByTagName("body")[0];
        var dummy = document.createElement("div");
        var dummyText = document.createTextNode(text);
        dummy.appendChild(dummyText);
        dummy.setAttribute("style", fontStyle);
        body.appendChild(dummy);
        var result = dummy.offsetHeight;
        body.removeChild(dummy);

        body = null;
        dummy = null;

        return result;
    },

    _getChartTemplate: function (param, container) {
        var chartContainerTemplate = $('<div> </div>');

        var margin = 5;
        var legendVisibility = param.legend.visible;
        var legendPosition = param.legend.location;
        var chartContentWidth = (parseInt(param.containerWidth) - (margin * 2)) + "px";
        var chartContentHeight = (parseInt(param.containerHeight) - (margin * 2)) + "px";
        var legendWidth = param.legend.width;
        var legendHeight = param.legend.height;

        var chartVisibility = param.chartVisibility;

        var chartBackground = param.chartBackground;

        // Tooltip
        var tooltipTemplate = '<table  id="tooltip" style="display: none; z-index:100;"><tr> ';
        tooltipTemplate += '<td> <div id="serieColor" style="Margin:5px; width: 10px; height: 10px" > </div></td>';
        tooltipTemplate += '<td style="padding: 3px 3px 3px 3px">';
        tooltipTemplate += '<span id="tooltipValue" style="font-family: Arial; font-size: 11px">test</span>';
        tooltipTemplate += '</td></tr></table>';

        var tooltipVisual = $(tooltipTemplate);

        chartContainerTemplate.css("background", chartBackground);
        chartContainerTemplate.css("visible", chartVisibility);
        chartContainerTemplate.css("overflow", "hidden");
        chartContainerTemplate.css("height", param.containerHeight);
        chartContainerTemplate.css("width", param.containerWidth);

        chartContainerTemplate.append(tooltipVisual);
        container.append(chartContainerTemplate);

        // Chart
        var chartContent = $('<div id="' + param.chartName + '"></div>');
        chartContent.css("height", chartContentHeight);
        chartContent.css("width", chartContentWidth);
        chartContent.css("margin", margin + "px");

        if (!legendVisibility) {
            chartContainerTemplate.append(chartContent);
            return chartContainerTemplate;
        }

        // Legend
        var fontStyle = param.legend.fontStyle.split(" ");

        var chartLegendHtml = '<div id="' + param.legend.name + '">';

        if (param.legend.title != null) {
            chartLegendHtml += '<span>' + param.legend.title + '</span>';
        }

        var chartLegend = $(chartLegendHtml);

        chartLegend.css("background", param.legend.background);
        chartLegend.css("padding", "5px");
        chartLegend.css("margin", margin + "px");
        chartLegend.css("font-size", fontStyle[0]);
        chartLegend.css("font-family", fontStyle[1]);
        chartLegend.css("height", (parseInt(legendHeight) - 10) + "px");
        chartLegend.css("width", (parseInt(legendWidth) - 10) + "px");
        chartLegend.css("overflow", "hidden");
        chartLegend.css("border-radius", "5px");
        chartLegend.css("-ms-border-radius", "5px");
        chartLegend.css("-moz-border-radius", "5px");
        chartLegend.css("-webkit-border-radius", "5px");
        chartLegend.css("-khtml-border-radius", "5px");

        if (param.legend.orientation == "Horizontal") {
            var horizontalStyle = $("<style type='text/css'> .ui-chart-legend-item{ display: block; display: block; float: left; margin: 0px; margin-right: 8px;} .ui-chart-legend-item-text{ white-space: nowrap; } </style>");
            chartContainerTemplate.append(horizontalStyle);
        }

        if (legendPosition == "OutsideBottom") {
            chartContentHeight = (parseInt(chartContentHeight) - parseInt(legendHeight) - (margin * 2)) + "px";
            chartContent.css("height", chartContentHeight);
            chartContainerTemplate.append(chartContent).append(chartLegend);
            return chartContainerTemplate;

        }
        else if (legendPosition == "OutsideTop") {
            chartContentHeight = (parseInt(chartContentHeight) - parseInt(legendHeight) - (margin * 2)) + "px";
            chartContent.css("height", chartContentHeight);
            chartContainerTemplate.append(chartLegend).append(chartContent);
            return chartContainerTemplate;
        }
        else if (legendPosition == "OutsideRight") {
            chartContentWidth = (parseInt(chartContentWidth) - parseInt(legendWidth) - (margin * 2));
            chartContent.css("width", chartContentWidth + "px");

            chartContainerTemplate.css("position", "relative");
            chartLegend.css("position", "absolute");
            chartLegend.css("top", "0px");
            chartLegend.css("left", chartContentWidth + margin + "px");

            chartContainerTemplate.append(chartContent).append(chartLegend);

            return chartContainerTemplate;
        }
        else if (legendPosition == "OutsideLeft") {
            chartContentWidth = (parseInt(chartContentWidth) - parseInt(legendWidth) - (margin * 2));
            chartContent.css("width", chartContentWidth + "px");

            chartContainerTemplate.css("position", "relative");
            chartContent.css("position", "absolute");
            chartContent.css("top", "0px");
            chartContent.css("left", parseInt(legendWidth) + (margin * 2) + "px");

            chartContainerTemplate.append(chartContent).append(chartLegend);

            return chartContainerTemplate;
        }
        else if (legendPosition == "InsideLeft" || legendPosition == "InsideTop") {
            chartContainerTemplate.css("position", "relative");
            chartLegend.css("position", "absolute");
            chartLegend.css("top", "0px");
            chartLegend.css("left", "0px");

            chartContainerTemplate.append(chartContent).append(chartLegend);

            return chartContainerTemplate;
        }
        else if (legendPosition == "InsideRight") {
            chartContainerTemplate.css("position", "relative");
            chartLegend.css("position", "absolute");
            chartLegend.css("top", "0px");

            chartLegend.css("left", (parseInt(chartContentWidth) - parseInt(legendWidth)) + "px");

            chartContainerTemplate.append(chartContent).append(chartLegend);

            return chartContainerTemplate;
        }
        else if (legendPosition == "InsideBottom") {
            chartContainerTemplate.css("position", "relative");
            chartLegend.css("position", "absolute");

            chartLegend.css("top", (parseInt(chartContentHeight) - parseInt(legendHeight)) + "px");

            chartContainerTemplate.append(chartContent).append(chartLegend);

            return chartContainerTemplate;
        }
        else if (legendPosition == "Central") {
            chartContainerTemplate.css("position", "relative");
            chartLegend.css("position", "absolute");

            chartLegend.css("left", (parseInt(chartContentWidth) / 2 - parseInt(legendWidth) / 2) + "px");
            chartLegend.css("top", (parseInt(chartContentHeight) / 2 - parseInt(legendHeight) / 2) + "px");


            chartContainerTemplate.append(chartContent).append(chartLegend);

            return chartContainerTemplate;
        }
        return chartContainerTemplate;
    },

    _getChartId: function () {
        this._chartId++;
        return this._chartId;
    },

    _translateLocation: function (location) {
        if (location == "OutsideTop") {
            return "outsideTop";
        }
        else if (location == "OutsideBottom") {
            return "outsideBottom";
        }
        else if (location == "OutsideLeft") {
            return "outsideLeft";
        }
        else if (location == "OutsideRight") {
            return "outsideRight";
        }
        else if (location == "InsideTop") {
            return "insideTop";
        }
        else if (location == "InsideBottom") {
            return "insideBottom";
        }
        else if (location == "InsideLeft") {
            return "insideLeft";
        }
        else if (location == "InsideRight") {
            return "insideRight";
        }

        return "outsideBottom";
    },

    _tooltipHandler: function (e, ui) {
        var tooltip = $("#tooltip").clone();
        $(ui.element).empty();
        $(ui.element).append(tooltip);
        tooltip.show();

        if (!tooltip) {
            return;
        }

        var tooltipText = ui.series.name;
        var serieColor = ui.series.brush;

        if (ui.series.toolTip != null) {
            tooltipText = ui.series.toolTip;
        }

        tooltip.find("#tooltipValue").text(tooltipText);
        tooltip.find("#serieColor").css("background", serieColor);
    },

    _convertSerieType: function (tagName) {
        if (tagName == "ColumnSeries") {
            return "column";
        }
        else if (tagName == "AreaSeries") {
            return "area";
        } else if (tagName == "LineSeries") {
            return "line";
        } else if (tagName == "FinancialPriceSeries") {
            return "financial";
        }

        return "column";
    },

    _convertAxisType: function (tagName) {

        if (tagName == "CategoryXAxis") {
            return "categoryX";
        } else if (tagName == "CategoryYAxis") {
            return "categoryY";
        } else if (tagName == "NumericYAxis") {
            return "numericY";
        } else if (tagName == "NumericXAxis") {
            return "numericX";
        } else if (tagName == "CategoryDateTimeXAxis") {
            // After jQuery chart supports Dates converstions this should be uncommented. 
            // Until that dates will just be treated as strings
            return "categoryDateTimeX";
            //return "categoryX";
        }

        return "categoryX";
    },

    _getFinancialSerieDisplayType: function (serieDef) {
        var displaytype = $.ig.RepUtil.getAttribute(serieDef, "Display");
        if (displaytype == "OHLC") {
            return "ohlc";
        }

        return "candlestick";
    },

    _parseValue: function (value, type) {
        if (type.startsWith("System.String")) {

            var scapedString = value.replace("'", "´");

            return "'" + scapedString + "'";
        }

        if (type.startsWith("System.Double")) {
            return parseFloat(value);
        }

        if (type.startsWith("System.Decimal")) {
            return parseFloat(value);
        }

        // After jQuery chart supports Dates converstions this should be uncommented. 
        // Until that dates will just be treated as strings
        if (type.startsWith("System.DateTime")) {
            //                var splittedValue = value.split(" ");
            //                var date = splittedValue[0].split("/");
            //                var time = splittedValue[1].split(":");

            //                var year = parseInt(date[2]);
            //                var month = parseInt(date[0]);
            //                var day = parseInt(date[1]);

            //                var hours = parseInt(time[0]);
            //                var minutes = parseInt(time[1]);
            //                var seconds = parseInt(time[2]);

            //                var jsDate = new Date(year, month, day, hours, minutes, seconds, 0);
            //                return JSON.stringify(jsDate);
            return "'" + value + "'";
        }

        return value;
    },

    _renderError: function (container, chartContainerWidth, chartContainerHeight, message) {
        container.empty();
        var errorMessage = "<div style='overflow: hidden";
        errorMessage += ";width:" + chartContainerWidth;
        errorMessage += ";height: " + chartContainerHeight + "'>";
        errorMessage += "<table style='border-width: 1px, border-color:#1382CE; font-family: verdana; font-size: 11px; table-layout:fixed; background:#F1F1F2; width:" + chartContainerWidth;
        errorMessage += ";height: " + chartContainerHeight + "'>";
        errorMessage += "<tr style='height:30px; color: #1382CE'><td style='font-family: verdana; font-size: 11px;'>Chart couldn't be rendered.</td></tr>";
        errorMessage += "<tr><td style='font-family: verdana; font-size: 11px;vertical-align: Top;'>" + message + "</td></tr>";
        errorMessage += "</table></div>";
        container.append(errorMessage);
    }
}, true);

$.ig.Measure = Class.extend({
    _valueInPx: 0,
    init: function (measure) {
        this._valueInPx = this._convertToPixel(measure);
    },
    _convertToPixel: function (measure) {
        if (measure == null) {
            return 0;
        }

        if (measure.endsWith("px")) {
            return $.ig.RepUtil.roundVal(parseFloat(measure));
        }

        if (measure.endsWith("cm")) {
            var valueInCm = parseFloat(measure);
            return $.ig.RepUtil.roundVal(valueInCm * 96 / 2.54);
        }
        if (measure.endsWith("mm")) {
            var valueInMm = parseFloat(measure);
            return $.ig.RepUtil.roundVal(valueInMm * 96 / (2.54 * 10));
        }
        if (measure.endsWith("pt")) {
            var valueInPt = parseFloat(measure);
            return $.ig.RepUtil.roundVal(valueInPt * 96 / 72);
        }
        if (measure.endsWith("twip")) {
            var valueInTwip = parseFloat(measure);
            return $.ig.RepUtil.roundVal(valueInTwip * 96 / (72 * 20));
        }
        if (measure.endsWith("in")) {
            var floatValue = parseFloat(measure);
            return $.ig.RepUtil.roundVal(floatValue * 96);
        }

        return parseFloat(measure);
    },

    getValueInPx: function () {
        return this._valueInPx;
    }
}, true);

$.ig.reporting = $.ig.reporting || {};

$.ig.reporting.Thickness = Class.extend({
    _originalValue: "",
    _leftInPx: 0,
    _topInPx: 0,
    _rightInPx: 0,
    _bottomInPx: 0,

    init: function (thickness) {

        if (thickness == null) {
            this._originalValue = "0";
            return;
        }

        var values = thickness.split(" ");
        if (values.length == 4) {
            this._leftInPx = (new $.ig.Measure(values[0])).getValueInPx();
            this._topInPx = (new $.ig.Measure(values[1])).getValueInPx();
            this._rightInPx = (new $.ig.Measure(values[2])).getValueInPx();
            this._bottomInPx = (new $.ig.Measure(values[3])).getValueInPx();


        }
        else {
            var value = (new $.ig.Measure(thickness)).getValueInPx();
            this._leftInPx = value;
            this._topInPx = value;
            this._rightInPx = value;
            this._bottomInPx = value;
        }

        this._originalValue = this._topInPx + "px " + this._rightInPx + "px " + this._bottomInPx + "px " + this._leftInPx + "px";
    },

    getValue: function () {
        return this._originalValue;
    },

    getLeftAndRight: function () {
        return this._leftInPx + this._rightInPx;
    },

    getTopAndBottom: function () {
        return this._topInPx + this._bottomInPx;
    }

}, true);


/* Copyright: Infragistics Inc. 2011. Automatically generated code. Please do not modify. */
// Declare empty types
$.ig = $.ig || {};
$.ig.Error = $.ig.Error || Class.extend({}, true);
$.ig.IViewerStateMachineAction = $.ig.IViewerStateMachineAction || Class.extend({}, true);
$.ig.PrintFinishedAction = $.ig.PrintFinishedAction || Class.extend({}, true);
$.ig.ExportCanceledAction = $.ig.ExportCanceledAction || Class.extend({}, true);
$.ig.ProcessingCompletedAction = $.ig.ProcessingCompletedAction || Class.extend({}, true);
$.ig.ProcessingCanceledAction = $.ig.ProcessingCanceledAction || Class.extend({}, true);
$.ig.IViewerStateMachine = $.ig.IViewerStateMachine || Class.extend({}, true);
$.ig.ViewerStateMachine = $.ig.ViewerStateMachine || Class.extend({}, true);
$.ig.ExportStartedAction = $.ig.ExportStartedAction || Class.extend({}, true);
$.ig.ViewerState = $.ig.ViewerState || Class.extend({}, true);
$.ig.ParametersState = $.ig.ParametersState || {
	empty: 0,
	loading: 1,
	loaded: 2,
	ready: 3
};
$.ig.ViewerVisualState = $.ig.ViewerVisualState || {
	inDesignMode: 0,
	nonVisualReady: 1,
	visualReady: 2,
	disposed: 3
};
$.ig.ViewerRenderSettingsState = $.ig.ViewerRenderSettingsState || {
	empty: 0,
	invalid: 1,
	valid: 2,
	changing: 3
};
$.ig.PrintingState = $.ig.PrintingState || {
	idle: 0,
	preparingStarted: 1,
	preparingFinished: 2,
	started: 3,
	finished: 4,
	canceling: 5
};
$.ig.ProcessingState = $.ig.ProcessingState || {
	idle: 0,
	requested: 1,
	downloading: 2,
	started: 3,
	processing: 4,
	completed: 5,
	canceling: 6,
	repaginating: 7
};
$.ig.PageContainerState = $.ig.PageContainerState || {
	empty: 0,
	loding: 1,
	loaded: 2,
	canceled: 3
};
$.ig.ErrorWindowState = $.ig.ErrorWindowState || {
	visible: 0,
	hidden: 1
};
$.ig.ExportState = $.ig.ExportState || {
	idle: 0,
	started: 1,
	exporting: 2,
	canceling: 3
};
$.ig.ReportProcessingMode = $.ig.ReportProcessingMode || {
	local: 0,
	server: 1
};
$.ig.IEventQueueManager = $.ig.IEventQueueManager || Class.extend({}, true);
$.ig.EventQueueManager = $.ig.EventQueueManager || Class.extend({}, true);
$.ig.ViewerEvent = $.ig.ViewerEvent || Class.extend({}, true);
$.ig.ViewerEventType = $.ig.ViewerEventType || {
	autoRenderSet: 0,
	visualReady: 1,
	visualNotReady: 2,
	settingsNotReady: 5,
	settingsReady: 6,
	dataReady: 7,
	parametersProcessingRequested: 8,
	parametersReady: 9,
	reportProcessingRequested: 10,
	reportParametersSubmit: 12,
	exportStarted: 14,
	exportCompleted: 15,
	exportCanceling: 16,
	exportCanceled: 17,
	processingStarted: 19,
	processingDownloading: 20,
	processingDownloaded: 21,
	processingProgress: 22,
	processingCanceling: 23,
	processingCanceled: 24,
	processingCompleted: 25,
	printPreparingStarted: 26,
	printPreparingFinished: 27,
	printStarted: 28,
	printCanceling: 29,
	printFinished: 30,
	pageFetched: 31,
	pageRequested: 32
};
$.ig.EventNotificationService = $.ig.EventNotificationService || Class.extend({}, true);
$.ig.ProcessingDownloadedAction = $.ig.ProcessingDownloadedAction || Class.extend({}, true);
$.ig.PrintStartedAction = $.ig.PrintStartedAction || Class.extend({}, true);
$.ig.ProcessingDownloadingAction = $.ig.ProcessingDownloadingAction || Class.extend({}, true);
$.ig.ProcessingStartedAction = $.ig.ProcessingStartedAction || Class.extend({}, true);
$.ig.ProcessingCancelingAction = $.ig.ProcessingCancelingAction || Class.extend({}, true);
$.ig.ParametersReadyAction = $.ig.ParametersReadyAction || Class.extend({}, true);
$.ig.ReportProcessingRequestedAction = $.ig.ReportProcessingRequestedAction || Class.extend({}, true);
$.ig.ExportCompletedAction = $.ig.ExportCompletedAction || Class.extend({}, true);
$.ig.PageFetchedAction = $.ig.PageFetchedAction || Class.extend({}, true);
$.ig.AutoRenderSetAction = $.ig.AutoRenderSetAction || Class.extend({}, true);
$.ig.IViewerStateMachineActionFactory = $.ig.IViewerStateMachineActionFactory || Class.extend({}, true);
$.ig.ViewerStateMachineActionFactory = $.ig.ViewerStateMachineActionFactory || Class.extend({}, true);
$.ig.SettingsNotReadyAction = $.ig.SettingsNotReadyAction || Class.extend({}, true);
$.ig.ProcessingProgressAction = $.ig.ProcessingProgressAction || Class.extend({}, true);
$.ig.IProcessingSessionStateMachine = $.ig.IProcessingSessionStateMachine || Class.extend({}, true);
$.ig.AsyncReportProcessorAction = $.ig.AsyncReportProcessorAction || Class.extend({}, true);
$.ig.ProcessingSessionStateMachine = $.ig.ProcessingSessionStateMachine || Class.extend({}, true);
$.ig.ReportProcessorEventArgs = $.ig.ReportProcessorEventArgs || Class.extend({}, true);
$.ig.PageAvailableEventArgs = $.ig.PageAvailableEventArgs || Class.extend({}, true);
$.ig.ProcessingSessionPageAvailableEventArgs = $.ig.ProcessingSessionPageAvailableEventArgs || Class.extend({}, true);
$.ig.PageFetchedEventArgs = $.ig.PageFetchedEventArgs || Class.extend({}, true);
$.ig.SettingsReadyAction = $.ig.SettingsReadyAction || Class.extend({}, true);
$.ig.PageRequestedAction = $.ig.PageRequestedAction || Class.extend({}, true);
$.ig.IProcessingSessionFactory = $.ig.IProcessingSessionFactory || Class.extend({}, true);
$.ig.ProcessingSessionFactory = $.ig.ProcessingSessionFactory || Class.extend({}, true);
$.ig.ExportCancelingAction = $.ig.ExportCancelingAction || Class.extend({}, true);
$.ig.ProcessingEventArgs = $.ig.ProcessingEventArgs || Class.extend({}, true);
$.ig.ProcessingCanceledEventArgs = $.ig.ProcessingCanceledEventArgs || Class.extend({}, true);
$.ig.ProcessingStartedEventArgs = $.ig.ProcessingStartedEventArgs || Class.extend({}, true);
$.ig.ProcessingProgressEventArgs = $.ig.ProcessingProgressEventArgs || Class.extend({}, true);
$.ig.ProcessingCompletedEventArgs = $.ig.ProcessingCompletedEventArgs || Class.extend({}, true);
$.ig.ErrorEventArgs = $.ig.ErrorEventArgs || Class.extend({}, true);
$.ig.ExportCompletedEventArgs = $.ig.ExportCompletedEventArgs || Class.extend({}, true);
$.ig.ExportCanceledEventArgs = $.ig.ExportCanceledEventArgs || Class.extend({}, true);
$.ig.PrintFinishedEventArgs = $.ig.PrintFinishedEventArgs || Class.extend({}, true);
$.ig.PrintCancelingAction = $.ig.PrintCancelingAction || Class.extend({}, true);
$.ig.Object = $.ig.Object || Class.extend({}, true);
$.ig.ValueType = $.ig.ValueType || Class.extend({}, true);
$.ig.UInt64 = $.ig.UInt64 || Class.extend({}, true);
$.ig.TimeSpan = $.ig.TimeSpan || Class.extend({}, true);
$.ig.MulticastDelegate = $.ig.MulticastDelegate || Class.extend({}, true);
$.ig.IEnumerator = $.ig.IEnumerator || Class.extend({}, true);
$.ig.Enum = $.ig.Enum || Class.extend({}, true);
$.ig.ListSortDirection = $.ig.ListSortDirection || {
	ascending: 0,
	descending: 1
};
$.ig.BackgroundWorker = $.ig.BackgroundWorker || Class.extend({}, true);
$.ig.XmlDocumentParser = $.ig.XmlDocumentParser || Class.extend({}, true);
$.ig.Attribute = $.ig.Attribute || Class.extend({}, true);
$.ig.DefaultMemberAttribute = $.ig.DefaultMemberAttribute || Class.extend({}, true);
$.ig.Char = $.ig.Char || Class.extend({}, true);
$.ig.Func$1 = $.ig.Func$1 || Class.extend({ $type: new $.ig.Type("Func`1", $.ig.Object.prototype.$type) }, true);
$.ig.Func$2 = $.ig.Func$2 || Class.extend({ $type: new $.ig.Type("Func`2", $.ig.Object.prototype.$type) }, true);
$.ig.Func$3 = $.ig.Func$3 || Class.extend({ $type: new $.ig.Type("Func`3", $.ig.Object.prototype.$type) }, true);
$.ig.Func$4 = $.ig.Func$4 || Class.extend({ $type: new $.ig.Type("Func`4", $.ig.Object.prototype.$type) }, true);
$.ig.Func$5 = $.ig.Func$5 || Class.extend({ $type: new $.ig.Type("Func`5", $.ig.Object.prototype.$type) }, true);
$.ig.Func$6 = $.ig.Func$6 || Class.extend({ $type: new $.ig.Type("Func`6", $.ig.Object.prototype.$type) }, true);
$.ig.Func$7 = $.ig.Func$7 || Class.extend({ $type: new $.ig.Type("Func`7", $.ig.Object.prototype.$type) }, true);
$.ig.Func$8 = $.ig.Func$8 || Class.extend({ $type: new $.ig.Type("Func`8", $.ig.Object.prototype.$type) }, true);
$.ig.Func$9 = $.ig.Func$9 || Class.extend({ $type: new $.ig.Type("Func`9", $.ig.Object.prototype.$type) }, true);
$.ig.ITypeDescriptorContext = $.ig.ITypeDescriptorContext || Class.extend({}, true);
$.ig.EventArgs = $.ig.EventArgs || Class.extend({}, true);
$.ig.DoWorkEventArgs = $.ig.DoWorkEventArgs || Class.extend({}, true);
$.ig.Action = $.ig.Action || Class.extend({ $type: new $.ig.Type("Action", $.ig.Object.prototype.$type) }, true);
$.ig.Action$1 = $.ig.Action$1 || Class.extend({ $type: new $.ig.Type("Action`1", $.ig.Object.prototype.$type) }, true);
$.ig.Action$2 = $.ig.Action$2 || Class.extend({ $type: new $.ig.Type("Action`2", $.ig.Object.prototype.$type) }, true);
$.ig.Action$3 = $.ig.Action$3 || Class.extend({ $type: new $.ig.Type("Action`3", $.ig.Object.prototype.$type) }, true);
$.ig.Action$4 = $.ig.Action$4 || Class.extend({ $type: new $.ig.Type("Action`4", $.ig.Object.prototype.$type) }, true);
$.ig.Action$5 = $.ig.Action$5 || Class.extend({ $type: new $.ig.Type("Action`5", $.ig.Object.prototype.$type) }, true);
$.ig.Action$6 = $.ig.Action$6 || Class.extend({ $type: new $.ig.Type("Action`6", $.ig.Object.prototype.$type) }, true);
$.ig.Action$7 = $.ig.Action$7 || Class.extend({ $type: new $.ig.Type("Action`7", $.ig.Object.prototype.$type) }, true);
$.ig.Action$8 = $.ig.Action$8 || Class.extend({ $type: new $.ig.Type("Action`8", $.ig.Object.prototype.$type) }, true);
$.ig.IEnumerable = $.ig.IEnumerable || Class.extend({}, true);
$.ig.XmlNodeList = $.ig.XmlNodeList || Class.extend({}, true);
$.ig.RuntimeFieldHandle = $.ig.RuntimeFieldHandle || Class.extend({}, true);
$.ig.IComparable = $.ig.IComparable || Class.extend({}, true);
$.ig.DateTime = $.ig.DateTime || Class.extend({}, true);
$.ig.XmlNodeType = $.ig.XmlNodeType || {
	attribute: 0,
	text: 1
};
$.ig.XmlNode = $.ig.XmlNode || Class.extend({}, true);
$.ig.GuidAttribute = $.ig.GuidAttribute || Class.extend({}, true);
$.ig.MemberInfo = $.ig.MemberInfo || Class.extend({}, true);
$.ig.DesignTimeVisibleAttribute = $.ig.DesignTimeVisibleAttribute || Class.extend({}, true);
$.ig.XmlDocument = $.ig.XmlDocument || Class.extend({}, true);
$.ig.TypeCode = $.ig.TypeCode || {
	empty: 0,
	object1: 1,
	dBNull: 2,
	boolean1: 3,
	char1: 4,
	sByte: 5,
	byte1: 6,
	int16: 7,
	uInt16: 8,
	int32: 9,
	uInt32: 10,
	int64: 11,
	uInt64: 12,
	single: 13,
	double1: 14,
	decimal: 15,
	dateTime: 16,
	string1: 17
};
$.ig.WaitHandle = $.ig.WaitHandle || Class.extend({}, true);
$.ig.Monitor = $.ig.Monitor || Class.extend({}, true);
$.ig.IgnoreAttribute = $.ig.IgnoreAttribute || Class.extend({}, true);
$.ig.GlobalMemberAttribute = $.ig.GlobalMemberAttribute || Class.extend({}, true);
$.ig.DictionaryEntry = $.ig.DictionaryEntry || Class.extend({}, true);
$.ig.Comparison$1 = $.ig.Comparison$1 || Class.extend({ $type: new $.ig.Type("Comparison`1", $.ig.Object.prototype.$type) }, true);
$.ig.Queue = $.ig.Queue || Class.extend({}, true);
$.ig.ComVisibleAttribute = $.ig.ComVisibleAttribute || Class.extend({}, true);
$.ig.WidgetAttribute = $.ig.WidgetAttribute || Class.extend({}, true);
$.ig.MainWidgetAttribute = $.ig.MainWidgetAttribute || Class.extend({}, true);
$.ig.SuppressWidgetMemberAttribute = $.ig.SuppressWidgetMemberAttribute || Class.extend({}, true);
$.ig.SuppressWidgetMemberCopyAttribute = $.ig.SuppressWidgetMemberCopyAttribute || Class.extend({}, true);
$.ig.WidgetDefaultStringAttribute = $.ig.WidgetDefaultStringAttribute || Class.extend({}, true);
$.ig.WidgetDefaultNumberAttribute = $.ig.WidgetDefaultNumberAttribute || Class.extend({}, true);
$.ig.WidgetDefaultBooleanAttribute = $.ig.WidgetDefaultBooleanAttribute || Class.extend({}, true);
$.ig.AssemblyCopyrightAttribute = $.ig.AssemblyCopyrightAttribute || Class.extend({}, true);
$.ig.Double = $.ig.Double || Class.extend({}, true);
$.ig.Delegate = $.ig.Delegate || Class.extend({}, true);
$.ig.AttributeUsageAttribute = $.ig.AttributeUsageAttribute || Class.extend({}, true);
$.ig.EventHandler$1 = $.ig.EventHandler$1 || Class.extend({ $type: new $.ig.Type("EventHandler`1", $.ig.Object.prototype.$type) }, true);
$.ig.SByte = $.ig.SByte || Class.extend({}, true);
$.ig.NativeMethodAttribute = $.ig.NativeMethodAttribute || Class.extend({}, true);
$.ig.InlineItemAccessAttribute = $.ig.InlineItemAccessAttribute || Class.extend({}, true);
$.ig.AssemblyFileVersionAttribute = $.ig.AssemblyFileVersionAttribute || Class.extend({}, true);
$.ig.Exception = $.ig.Exception || Class.extend({}, true);
$.ig.PropertyChangedEventArgs = $.ig.PropertyChangedEventArgs || Class.extend({}, true);
$.ig.ParamArrayAttribute = $.ig.ParamArrayAttribute || Class.extend({}, true);
$.ig.PlaceholderSystemCollectionsObjectModel = $.ig.PlaceholderSystemCollectionsObjectModel || Class.extend({}, true);
$.ig.PlaceholderSystemCollectionsSpecialized = $.ig.PlaceholderSystemCollectionsSpecialized || Class.extend({}, true);
$.ig.PlaceholderSystemWindows = $.ig.PlaceholderSystemWindows || Class.extend({}, true);
$.ig.PlaceholderSystemWindowsControls = $.ig.PlaceholderSystemWindowsControls || Class.extend({}, true);
$.ig.PlaceholderSystemWindowsData = $.ig.PlaceholderSystemWindowsData || Class.extend({}, true);
$.ig.PlaceholderSystemWindowsInput = $.ig.PlaceholderSystemWindowsInput || Class.extend({}, true);
$.ig.PlaceholderSystemWindowsMarkup = $.ig.PlaceholderSystemWindowsMarkup || Class.extend({}, true);
$.ig.PlaceholderSystemWindowsMediaImaging = $.ig.PlaceholderSystemWindowsMediaImaging || Class.extend({}, true);
$.ig.PlaceholderSystemWindowsShapes = $.ig.PlaceholderSystemWindowsShapes || Class.extend({}, true);
$.ig.PlaceholderSystemWindowsControlsPrimitives = $.ig.PlaceholderSystemWindowsControlsPrimitives || Class.extend({}, true);
$.ig.PlaceholderSystemWindowsAutomation = $.ig.PlaceholderSystemWindowsAutomation || Class.extend({}, true);
$.ig.PlaceholderSystemWindowsAutomationPeers = $.ig.PlaceholderSystemWindowsAutomationPeers || Class.extend({}, true);
$.ig.PlaceholderSystemText = $.ig.PlaceholderSystemText || Class.extend({}, true);
$.ig.PlaceholderSystemGlobalization = $.ig.PlaceholderSystemGlobalization || Class.extend({}, true);
$.ig.PlaceholderSystemWindowsDocuments = $.ig.PlaceholderSystemWindowsDocuments || Class.extend({}, true);
$.ig.PlaceholderSystemWindowsInk = $.ig.PlaceholderSystemWindowsInk || Class.extend({}, true);
$.ig.PlaceholderSystemWindowsMediaAnimation = $.ig.PlaceholderSystemWindowsMediaAnimation || Class.extend({}, true);
$.ig.PlaceholderSystemWindowsMediaEffects = $.ig.PlaceholderSystemWindowsMediaEffects || Class.extend({}, true);
$.ig.PlaceholderSystemWindowsThreading = $.ig.PlaceholderSystemWindowsThreading || Class.extend({}, true);
$.ig.PlaceholderInfragisticsControlerChartsAutomationPeers = $.ig.PlaceholderInfragisticsControlerChartsAutomationPeers || Class.extend({}, true);
$.ig.SuppressMessageAttribute = $.ig.SuppressMessageAttribute || Class.extend({}, true);
$.ig.IEqualityComparer$1 = $.ig.IEqualityComparer$1 || Class.extend({}, true);
$.ig.XmlNamedNodeMap = $.ig.XmlNamedNodeMap || Class.extend({}, true);
$.ig.Type = $.ig.Type || Class.extend({}, true);
$.ig.EventWaitHandle = $.ig.EventWaitHandle || Class.extend({}, true);
$.ig.InlinePropertyAttribute = $.ig.InlinePropertyAttribute || Class.extend({}, true);
$.ig.ParameterInfo = $.ig.ParameterInfo || Class.extend({}, true);
$.ig.AssemblyTrademarkAttribute = $.ig.AssemblyTrademarkAttribute || Class.extend({}, true);
$.ig.AssemblyCultureAttribute = $.ig.AssemblyCultureAttribute || Class.extend({}, true);
$.ig.Int16 = $.ig.Int16 || Class.extend({}, true);
$.ig.PropertyChangedEventHandler = $.ig.PropertyChangedEventHandler || Class.extend({ $type: new $.ig.Type("PropertyChangedEventHandler", $.ig.Object.prototype.$type) }, true);
$.ig.XmlHttpRequest = $.ig.XmlHttpRequest || Class.extend({}, true);
$.ig.AsyncCompletedEventArgs = $.ig.AsyncCompletedEventArgs || Class.extend({}, true);
$.ig.AsyncCompletedEventHandler = $.ig.AsyncCompletedEventHandler || Class.extend({ $type: new $.ig.Type("AsyncCompletedEventHandler", $.ig.Object.prototype.$type) }, true);
$.ig.String = $.ig.String || Class.extend({}, true);
$.ig.Single = $.ig.Single || Class.extend({}, true);
$.ig.ClientNameAttribute = $.ig.ClientNameAttribute || Class.extend({}, true);
$.ig.MethodBase = $.ig.MethodBase || Class.extend({}, true);
$.ig.AssemblyVersionAttribute = $.ig.AssemblyVersionAttribute || Class.extend({}, true);
$.ig.Nullable$1 = $.ig.Nullable$1 || Class.extend({}, true);
$.ig.IFormatProvider = $.ig.IFormatProvider || Class.extend({}, true);
$.ig.NativePropertyAttribute = $.ig.NativePropertyAttribute || Class.extend({}, true);
$.ig.ReflectionUtil = $.ig.ReflectionUtil || Class.extend({}, true);
$.ig.CultureInfo = $.ig.CultureInfo || Class.extend({}, true);
$.ig.Decimal = $.ig.Decimal || Class.extend({}, true);
$.ig.ICollection = $.ig.ICollection || Class.extend({}, true);
$.ig.UInt16 = $.ig.UInt16 || Class.extend({}, true);
$.ig.PropertyInfo = $.ig.PropertyInfo || Class.extend({}, true);
$.ig.AssemblyDescriptionAttribute = $.ig.AssemblyDescriptionAttribute || Class.extend({}, true);
$.ig.Math = $.ig.Math || Class.extend({}, true);
$.ig.FlagsAttribute = $.ig.FlagsAttribute || Class.extend({}, true);
$.ig.TypeConverter = $.ig.TypeConverter || Class.extend({}, true);
$.ig.RunWorkerCompletedEventHandler = $.ig.RunWorkerCompletedEventHandler || Class.extend({ $type: new $.ig.Type("RunWorkerCompletedEventHandler", $.ig.Object.prototype.$type) }, true);
$.ig.UIntPtr = $.ig.UIntPtr || Class.extend({}, true);
$.ig.RuntimeTypeHandle = $.ig.RuntimeTypeHandle || Class.extend({}, true);
$.ig.MethodInfo = $.ig.MethodInfo || Class.extend({}, true);
$.ig.AssemblyConfigurationAttribute = $.ig.AssemblyConfigurationAttribute || Class.extend({}, true);
$.ig.IDisposable = $.ig.IDisposable || Class.extend({}, true);
$.ig.Boolean = $.ig.Boolean || Class.extend({}, true);
$.ig.DoWorkEventHandler = $.ig.DoWorkEventHandler || Class.extend({ $type: new $.ig.Type("DoWorkEventHandler", $.ig.Object.prototype.$type) }, true);
$.ig.IDictionary = $.ig.IDictionary || Class.extend({}, true);
$.ig.TargetFrameworkAttribute = $.ig.TargetFrameworkAttribute || Class.extend({}, true);
$.ig.ClientScriptAttribute = $.ig.ClientScriptAttribute || Class.extend({}, true);
$.ig.AssemblyCompanyAttribute = $.ig.AssemblyCompanyAttribute || Class.extend({}, true);
$.ig.IntPtr = $.ig.IntPtr || Class.extend({}, true);
$.ig.AttributeTargets = $.ig.AttributeTargets || {
	all: 0,
	assembly: 1,
	clss: 2,
	cons: 3,
	delegate: 4,
	en: 5,
	event: 6,
	field: 7,
	genericParameter: 8,
	interface1: 9,
	method: 10,
	module: 11,
	parameter: 12,
	property: 13,
	returnValue: 14,
	struct: 15,
	type: 16
};
$.ig.Array = $.ig.Array || Class.extend({}, true);
$.ig.RunWorkerCompletedEventArgs = $.ig.RunWorkerCompletedEventArgs || Class.extend({}, true);
$.ig.Void = $.ig.Void || Class.extend({}, true);
$.ig.Script = $.ig.Script || Class.extend({}, true);
$.ig.RuntimeHelpers = $.ig.RuntimeHelpers || Class.extend({}, true);
$.ig.Int32 = $.ig.Int32 || Class.extend({}, true);
$.ig.Stack = $.ig.Stack || Class.extend({}, true);
$.ig.IList = $.ig.IList || Class.extend({}, true);
$.ig.OutAttribute = $.ig.OutAttribute || Class.extend({}, true);
$.ig.KeepOriginalNameAttribute = $.ig.KeepOriginalNameAttribute || Class.extend({}, true);
$.ig.AssemblyTitleAttribute = $.ig.AssemblyTitleAttribute || Class.extend({}, true);
$.ig.Int64 = $.ig.Int64 || Class.extend({}, true);
$.ig.NotSupportedException = $.ig.NotSupportedException || Class.extend({}, true);
$.ig.TypeConverterAttribute = $.ig.TypeConverterAttribute || Class.extend({}, true);
$.ig.ISupportInitialize = $.ig.ISupportInitialize || Class.extend({}, true);
$.ig.ManualResetEvent = $.ig.ManualResetEvent || Class.extend({}, true);
$.ig.NativeTypeAttribute = $.ig.NativeTypeAttribute || Class.extend({}, true);
$.ig.Number = $.ig.Number || Class.extend({}, true);
$.ig.ConstructorInfo = $.ig.ConstructorInfo || Class.extend({}, true);
$.ig.EditorBrowsableAttribute = $.ig.EditorBrowsableAttribute || Class.extend({}, true);
$.ig.EditorBrowsableState = $.ig.EditorBrowsableState || {
	always: 0,
	never: 1,
	advanced: 2
};
$.ig.UInt32 = $.ig.UInt32 || Class.extend({}, true);
$.ig.Thread = $.ig.Thread || Class.extend({}, true);
$.ig.LiteralStringAttribute = $.ig.LiteralStringAttribute || Class.extend({}, true);
$.ig.ExtensionAttribute = $.ig.ExtensionAttribute || Class.extend({}, true);
$.ig.EmitIgnoreTypeAttribute = $.ig.EmitIgnoreTypeAttribute || Class.extend({}, true);
$.ig.AssemblyProductAttribute = $.ig.AssemblyProductAttribute || Class.extend({}, true);
$.ig.INotifyPropertyChanged = $.ig.INotifyPropertyChanged || Class.extend({}, true);
$.ig.Dictionary = $.ig.Dictionary || Class.extend({}, true);
$.ig.ArrayList = $.ig.ArrayList || Class.extend({}, true);
$.ig.CompareCallback = $.ig.CompareCallback || Class.extend({ $type: new $.ig.Type("CompareCallback", $.ig.Object.prototype.$type) }, true);
$.ig.Byte = $.ig.Byte || Class.extend({}, true);
$.ig.PenLineCap = $.ig.PenLineCap || {
	flat: 0,
	square: 1,
	round: 2,
	triangle: 3
};
$.ig.DependencyObject = $.ig.DependencyObject || Class.extend({}, true);
$.ig.IEnumerable$1 = $.ig.IEnumerable$1 || Class.extend({}, true);
$.ig.ICollection$1 = $.ig.ICollection$1 || Class.extend({}, true);
$.ig.IDictionary$2 = $.ig.IDictionary$2 || Class.extend({}, true);
$.ig.Debug = $.ig.Debug || Class.extend({}, true);
$.ig.DependencyProperty = $.ig.DependencyProperty || Class.extend({}, true);
$.ig.UnsetValue = $.ig.UnsetValue || Class.extend({}, true);
$.ig.DependencyPropertiesCollection = $.ig.DependencyPropertiesCollection || Class.extend({}, true);
$.ig.ArgumentException = $.ig.ArgumentException || Class.extend({}, true);
$.ig.UIElement = $.ig.UIElement || Class.extend({}, true);
$.ig.FrameworkElement = $.ig.FrameworkElement || Class.extend({}, true);
$.ig.Shape = $.ig.Shape || Class.extend({}, true);
$.ig.Path = $.ig.Path || Class.extend({}, true);
$.ig.Panel = $.ig.Panel || Class.extend({}, true);
$.ig.IList$1 = $.ig.IList$1 || Class.extend({}, true);
$.ig.Stack$1 = $.ig.Stack$1 || Class.extend({}, true);
$.ig.Expression = $.ig.Expression || Class.extend({}, true);
$.ig.BinaryReader = $.ig.BinaryReader || Class.extend({}, true);
$.ig.ArgumentNullException = $.ig.ArgumentNullException || Class.extend({}, true);
$.ig.IArrayList = $.ig.IArrayList || Class.extend({}, true);
$.ig.List$1 = $.ig.List$1 || Class.extend({}, true);
$.ig.Test = $.ig.Test || Class.extend({}, true);
$.ig.MethodCallExpression = $.ig.MethodCallExpression || Class.extend({}, true);
$.ig.ParameterExpression = $.ig.ParameterExpression || Class.extend({}, true);
$.ig.MemberExpression = $.ig.MemberExpression || Class.extend({}, true);
$.ig.Visibility = $.ig.Visibility || {
	visible: 0,
	collapsed: 1
};
$.ig.Line = $.ig.Line || Class.extend({}, true);
$.ig.Key = $.ig.Key || {
	none: 0,
	back: 1,
	tab: 2,
	enter: 3,
	shift: 4,
	ctrl: 5,
	alt: 6,
	capsLock: 7,
	escape: 8,
	space: 9,
	pageUp: 10,
	pageDown: 11,
	end: 12,
	home: 13,
	left: 14,
	up: 15,
	right: 16,
	down: 17,
	insert: 18,
	del: 19,
	d0: 20,
	d1: 21,
	d2: 22,
	d3: 23,
	d4: 24,
	d5: 25,
	d6: 26,
	d7: 27,
	d8: 28,
	d9: 29,
	a: 30,
	b: 31,
	c: 32,
	d: 33,
	e: 34,
	f: 35,
	g: 36,
	h: 37,
	i: 38,
	j: 39,
	k: 40,
	l: 41,
	m: 42,
	n: 43,
	o: 44,
	p: 45,
	q: 46,
	r: 47,
	s: 48,
	t: 49,
	u: 50,
	v: 51,
	w: 52,
	x: 53,
	y: 54,
	z: 55,
	f1: 56,
	f2: 57,
	f3: 58,
	f4: 59,
	f5: 60,
	f6: 61,
	f7: 62,
	f8: 63,
	f9: 64,
	f10: 65,
	f11: 66,
	f12: 67,
	numPad0: 68,
	numPad1: 69,
	numPad2: 70,
	numPad3: 71,
	numPad4: 72,
	numPad5: 73,
	numPad6: 74,
	numPad7: 75,
	numPad8: 76,
	numPad9: 77,
	multiply: 78,
	add: 79,
	subtract: 80,
	decimal: 81,
	divide: 82,
	unknown: 83
};
$.ig.Encoding = $.ig.Encoding || Class.extend({}, true);
$.ig.UTF8Encoding = $.ig.UTF8Encoding || Class.extend({}, true);
$.ig.IEnumerator$1 = $.ig.IEnumerator$1 || Class.extend({}, true);
$.ig.LambdaExpression = $.ig.LambdaExpression || Class.extend({}, true);
$.ig.ReadOnlyCollection$1 = $.ig.ReadOnlyCollection$1 || Class.extend({}, true);
$.ig.INotifyCollectionChanged = $.ig.INotifyCollectionChanged || Class.extend({}, true);
$.ig.NotifyCollectionChangedEventHandler = $.ig.NotifyCollectionChangedEventHandler || Class.extend({ $type: new $.ig.Type("NotifyCollectionChangedEventHandler", $.ig.Object.prototype.$type) }, true);
$.ig.NotifyCollectionChangedEventArgs = $.ig.NotifyCollectionChangedEventArgs || Class.extend({}, true);
$.ig.NotifyCollectionChangedAction = $.ig.NotifyCollectionChangedAction || {
	add: 0,
	remove: 1,
	replace: 2,
	reset: 3
};
$.ig.TemplateVisualStateAttribute = $.ig.TemplateVisualStateAttribute || Class.extend({}, true);
$.ig.Size = $.ig.Size || Class.extend({}, true);
$.ig.Polygon = $.ig.Polygon || Class.extend({}, true);
$.ig.Rect = $.ig.Rect || Class.extend({}, true);
$.ig.DoubleCollection = $.ig.DoubleCollection || Class.extend({}, true);
$.ig.Color = $.ig.Color || Class.extend({}, true);
$.ig.MouseEventArgs = $.ig.MouseEventArgs || Class.extend({}, true);
$.ig.MouseButtonEventArgs = $.ig.MouseButtonEventArgs || Class.extend({}, true);
$.ig.NotImplementedException = $.ig.NotImplementedException || Class.extend({}, true);
$.ig.KeyValuePair$2 = $.ig.KeyValuePair$2 || Class.extend({}, true);
$.ig.TemplatePartAttribute = $.ig.TemplatePartAttribute || Class.extend({}, true);
$.ig.GeometryType = $.ig.GeometryType || {
	group: 0,
	line: 1,
	rectangle: 2,
	ellipse: 3,
	path: 4
};
$.ig.Geometry = $.ig.Geometry || Class.extend({}, true);
$.ig.GeometryCollection = $.ig.GeometryCollection || Class.extend({}, true);
$.ig.GeometryGroup = $.ig.GeometryGroup || Class.extend({}, true);
$.ig.LineGeometry = $.ig.LineGeometry || Class.extend({}, true);
$.ig.RectangleGeometry = $.ig.RectangleGeometry || Class.extend({}, true);
$.ig.EllipseGeometry = $.ig.EllipseGeometry || Class.extend({}, true);
$.ig.PathGeometry = $.ig.PathGeometry || Class.extend({}, true);
$.ig.PathFigure = $.ig.PathFigure || Class.extend({}, true);
$.ig.PathFigureCollection = $.ig.PathFigureCollection || Class.extend({}, true);
$.ig.PathSegmentType = $.ig.PathSegmentType || {
	line: 0,
	bezier: 1,
	polyBezier: 2,
	polyLine: 3,
	arc: 4
};
$.ig.PathSegment = $.ig.PathSegment || Class.extend({}, true);
$.ig.PathSegmentCollection = $.ig.PathSegmentCollection || Class.extend({}, true);
$.ig.LineSegment = $.ig.LineSegment || Class.extend({}, true);
$.ig.BezierSegment = $.ig.BezierSegment || Class.extend({}, true);
$.ig.PolyBezierSegment = $.ig.PolyBezierSegment || Class.extend({}, true);
$.ig.PolyLineSegment = $.ig.PolyLineSegment || Class.extend({}, true);
$.ig.ArcSegment = $.ig.ArcSegment || Class.extend({}, true);
$.ig.SweepDirection = $.ig.SweepDirection || {
	counterclockwise: 0,
	clockwise: 1
};
$.ig.Brush = $.ig.Brush || Class.extend({}, true);
$.ig.Image = $.ig.Image || Class.extend({}, true);
$.ig.PropertyPath = $.ig.PropertyPath || Class.extend({}, true);
$.ig.PropertyChangedCallback = $.ig.PropertyChangedCallback || Class.extend({ $type: new $.ig.Type("PropertyChangedCallback", $.ig.Object.prototype.$type) }, true);
$.ig.CoerceValueCallback = $.ig.CoerceValueCallback || Class.extend({ $type: new $.ig.Type("CoerceValueCallback", $.ig.Object.prototype.$type) }, true);
$.ig.TextBlock = $.ig.TextBlock || Class.extend({}, true);
$.ig.Random = $.ig.Random || Class.extend({}, true);
$.ig.Queryable = $.ig.Queryable || Class.extend({}, true);
$.ig.Binding = $.ig.Binding || Class.extend({}, true);
$.ig.StringBuilder = $.ig.StringBuilder || Class.extend({}, true);
$.ig.IQueryable = $.ig.IQueryable || Class.extend({}, true);
$.ig.IQueryable$1 = $.ig.IQueryable$1 || Class.extend({}, true);
$.ig.IQueryProvider = $.ig.IQueryProvider || Class.extend({}, true);
$.ig.Collection$1 = $.ig.Collection$1 || Class.extend({}, true);
$.ig.AbstractEnumerable = $.ig.AbstractEnumerable || Class.extend({}, true);
$.ig.AbstractEnumerator = $.ig.AbstractEnumerator || Class.extend({}, true);
$.ig.Point = $.ig.Point || Class.extend({}, true);
$.ig.PointCollection = $.ig.PointCollection || Class.extend({}, true);
$.ig.ReadOnlyObservableCollection$1 = $.ig.ReadOnlyObservableCollection$1 || Class.extend({}, true);
$.ig.Queue$1 = $.ig.Queue$1 || Class.extend({}, true);
$.ig.GenericEnumerable$1 = $.ig.GenericEnumerable$1 || Class.extend({}, true);
$.ig.GenericEnumerator$1 = $.ig.GenericEnumerator$1 || Class.extend({}, true);
$.ig.PropertyMetadata = $.ig.PropertyMetadata || Class.extend({}, true);
$.ig.Transform = $.ig.Transform || Class.extend({}, true);
$.ig.RotateTransform = $.ig.RotateTransform || Class.extend({}, true);
$.ig.TranslateTransform = $.ig.TranslateTransform || Class.extend({}, true);
$.ig.TransformGroup = $.ig.TransformGroup || Class.extend({}, true);
$.ig.TransformCollection = $.ig.TransformCollection || Class.extend({}, true);
$.ig.ModifierKeys = $.ig.ModifierKeys || {
	none: 0,
	alt: 1,
	control: 2,
	shift: 3,
	windows: 4,
	apple: 5
};
$.ig.Tuple$2 = $.ig.Tuple$2 || Class.extend({}, true);
$.ig.BinaryFileDownloader = $.ig.BinaryFileDownloader || Class.extend({}, true);
$.ig.IComparer$1 = $.ig.IComparer$1 || Class.extend({}, true);
$.ig.Dictionary$2 = $.ig.Dictionary$2 || Class.extend({}, true);
$.ig.Style = $.ig.Style || Class.extend({}, true);
$.ig.Rectangle = $.ig.Rectangle || Class.extend({}, true);
$.ig.Polyline = $.ig.Polyline || Class.extend({}, true);
$.ig.ObservableCollection$1 = $.ig.ObservableCollection$1 || Class.extend({}, true);
$.ig.UIElementCollection = $.ig.UIElementCollection || Class.extend({}, true);
$.ig.Control = $.ig.Control || Class.extend({}, true);
$.ig.ContentControl = $.ig.ContentControl || Class.extend({}, true);
$.ig.InvalidOperationException = $.ig.InvalidOperationException || Class.extend({}, true);
$.ig.DependencyPropertyChangedEventArgs = $.ig.DependencyPropertyChangedEventArgs || Class.extend({}, true);
$.ig.DataTemplate = $.ig.DataTemplate || Class.extend({}, true);
$.ig.DataTemplateMeasureInfo = $.ig.DataTemplateMeasureInfo || Class.extend({}, true);
$.ig.DataTemplateRenderInfo = $.ig.DataTemplateRenderInfo || Class.extend({}, true);
$.ig.DataTemplateRenderHandler = $.ig.DataTemplateRenderHandler || Class.extend({ $type: new $.ig.Type("DataTemplateRenderHandler", $.ig.Object.prototype.$type) }, true);
$.ig.DataTemplateMeasureHandler = $.ig.DataTemplateMeasureHandler || Class.extend({ $type: new $.ig.Type("DataTemplateMeasureHandler", $.ig.Object.prototype.$type) }, true);
$.ig.Canvas = $.ig.Canvas || Class.extend({}, true);
$.ig.Convert = $.ig.Convert || Class.extend({}, true);
$.ig.StyleTypedPropertyAttribute = $.ig.StyleTypedPropertyAttribute || Class.extend({}, true);
$.ig.IArray = $.ig.IArray || Class.extend({}, true);
$.ig.Enumerable = $.ig.Enumerable || Class.extend({}, true);
$.ig.IOrderedEnumerable$1 = $.ig.IOrderedEnumerable$1 || Class.extend({}, true);
$.ig.SortedList$1 = $.ig.SortedList$1 || Class.extend({}, true);
$.ig.IGrouping$2 = $.ig.IGrouping$2 || Class.extend({}, true);
$.ig.Uri = $.ig.Uri || Class.extend({}, true);
$.ig.IEquatable$1 = $.ig.IEquatable$1 || Class.extend({}, true);
$.ig.ArgumentOutOfRangeException = $.ig.ArgumentOutOfRangeException || Class.extend({}, true);
$.ig.Activator = $.ig.Activator || Class.extend({}, true);
$.ig.Window = $.ig.Window || Class.extend({}, true);
$.ig.Callback = $.ig.Callback || Class.extend({ $type: new $.ig.Type("Callback", $.ig.Object.prototype.$type) }, true);
$.ig.Element = $.ig.Element || Class.extend({}, true);
$.ig.ImageElement = $.ig.ImageElement || Class.extend({}, true);
$.ig.JQueryObject = $.ig.JQueryObject || Class.extend({}, true);
$.ig.JQueryCallback = $.ig.JQueryCallback || Class.extend({ $type: new $.ig.Type("JQueryCallback", $.ig.Object.prototype.$type) }, true);
$.ig.CanvasContext = $.ig.CanvasContext || Class.extend({}, true);
$.ig.CanvasContext2D = $.ig.CanvasContext2D || Class.extend({}, true);
$.ig.ImageData = $.ig.ImageData || Class.extend({}, true);
$.ig.Gradient = $.ig.Gradient || Class.extend({}, true);
$.ig.TextMetrics = $.ig.TextMetrics || Class.extend({}, true);
$.ig.ElementEventHandler = $.ig.ElementEventHandler || Class.extend({}, true);
$.ig.ElementAttributeCollection = $.ig.ElementAttributeCollection || Class.extend({}, true);
$.ig.CanvasElement = $.ig.CanvasElement || Class.extend({}, true);
$.ig.ElementNodeType = $.ig.ElementNodeType || {
};
$.ig.DivElement = $.ig.DivElement || Class.extend({}, true);
$.ig.EventListener = $.ig.EventListener || Class.extend({}, true);
$.ig.Document = $.ig.Document || Class.extend({}, true);
$.ig.JQueryEvent = $.ig.JQueryEvent || Class.extend({}, true);
$.ig.ElementAttribute = $.ig.ElementAttribute || Class.extend({}, true);
$.ig.JQueryPosition = $.ig.JQueryPosition || Class.extend({}, true);
$.ig.JQuery = $.ig.JQuery || Class.extend({}, true);
$.ig.IElementEventHandler = $.ig.IElementEventHandler || Class.extend({}, true);
$.ig.ElementCollection = $.ig.ElementCollection || Class.extend({}, true);
$.ig.Console = $.ig.Console || Class.extend({}, true);

$.ig.ViewerEventType = $.ig.Enum.extend({
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	},
	$type: new $.ig.Type('ViewerEventType', $.ig.Object.prototype.$type)
}, true);

$.ig.ReportProcessingMode = $.ig.Enum.extend({
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	},
	$type: new $.ig.Type('ReportProcessingMode', $.ig.Object.prototype.$type)
}, true);

$.ig.ExportState = $.ig.Enum.extend({
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	},
	$type: new $.ig.Type('ExportState', $.ig.Object.prototype.$type)
}, true);

$.ig.ErrorWindowState = $.ig.Enum.extend({
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	},
	$type: new $.ig.Type('ErrorWindowState', $.ig.Object.prototype.$type)
}, true);

$.ig.PageContainerState = $.ig.Enum.extend({
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	},
	$type: new $.ig.Type('PageContainerState', $.ig.Object.prototype.$type)
}, true);

$.ig.ProcessingState = $.ig.Enum.extend({
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	},
	$type: new $.ig.Type('ProcessingState', $.ig.Object.prototype.$type)
}, true);

$.ig.PrintingState = $.ig.Enum.extend({
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	},
	$type: new $.ig.Type('PrintingState', $.ig.Object.prototype.$type)
}, true);

$.ig.ViewerRenderSettingsState = $.ig.Enum.extend({
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	},
	$type: new $.ig.Type('ViewerRenderSettingsState', $.ig.Object.prototype.$type)
}, true);

$.ig.ViewerVisualState = $.ig.Enum.extend({
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	},
	$type: new $.ig.Type('ViewerVisualState', $.ig.Object.prototype.$type)
}, true);

$.ig.ParametersState = $.ig.Enum.extend({
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	},
	$type: new $.ig.Type('ParametersState', $.ig.Object.prototype.$type)
}, true);

$.ig.Error = $.ig.Object.extend({
	init: function () {

		$.ig.Object.prototype.init.call(this);

	},
	_message: null,
	message: function (value) {
		if (arguments.length === 1) {
			this._message = value;
			return value;
		} else {
			return this._message;
		}
	},
	_exceptionDetail: null,
	exceptionDetail: function (value) {
		if (arguments.length === 1) {
			this._exceptionDetail = value;
			return value;
		} else {
			return this._exceptionDetail;
		}
	},
	_engineErrorsList: null,
	engineErrorsList: function (value) {
		if (arguments.length === 1) {
			this._engineErrorsList = value;
			return value;
		} else {
			return this._engineErrorsList;
		}
	},
	$type: new $.ig.Type('Error', $.ig.Object.prototype.$type)
}, true);

$.ig.IViewerStateMachineAction = Class.extend({
		$type: new $.ig.Type('IViewerStateMachineAction', null)
}, true);

$.ig.PrintFinishedAction = $.ig.Object.extend({
	init: function () {

		$.ig.Object.prototype.init.call(this);

	},
	execute: function (currentState, queueManager, notificationService, viewerStateMachine, parameter) {
		currentState.printingState($.ig.PrintingState.prototype.idle);
		notificationService.raiseEvent($.ig.ViewerEventType.prototype.printFinished, parameter);
	},
	$type: new $.ig.Type('PrintFinishedAction', $.ig.Object.prototype.$type, [$.ig.IViewerStateMachineAction.prototype.$type])
}, true);

$.ig.ExportCanceledAction = $.ig.Object.extend({
	init: function () {

		$.ig.Object.prototype.init.call(this);

	},
	execute: function (currentState, queueManager, notificationService, viewerStateMachine, parameter) {
		currentState.exportState($.ig.ExportState.prototype.idle);
		notificationService.raiseEvent($.ig.ViewerEventType.prototype.exportCanceled, parameter);
	},
	$type: new $.ig.Type('ExportCanceledAction', $.ig.Object.prototype.$type, [$.ig.IViewerStateMachineAction.prototype.$type])
}, true);

$.ig.ProcessingCompletedAction = $.ig.Object.extend({
	init: function () {

		$.ig.Object.prototype.init.call(this);

	},
	execute: function (currentState, queueManager, notificationService, viewerStateMachine, parameter) {
		if (currentState.processingState() == $.ig.ProcessingState.prototype.canceling) {
			return;
		}
		var processingCompletedEventArgs = parameter;
		if (processingCompletedEventArgs.error() != null) {
			queueManager.enqueue1($.ig.ViewerEventType.prototype.processingCanceling, processingCompletedEventArgs.error());

		} else {
			currentState.processingState($.ig.ProcessingState.prototype.completed);
			currentState.totalPages(processingCompletedEventArgs.pageNumber());
			notificationService.raiseEvent($.ig.ViewerEventType.prototype.processingCompleted, new $.ig.ProcessingCompletedEventArgs(false, processingCompletedEventArgs.pageNumber()));
		}
	},
	$type: new $.ig.Type('ProcessingCompletedAction', $.ig.Object.prototype.$type, [$.ig.IViewerStateMachineAction.prototype.$type])
}, true);

$.ig.ProcessingCanceledAction = $.ig.Object.extend({
	init: function () {

		$.ig.Object.prototype.init.call(this);

	},
	execute: function (currentState, queueManager, notificationService, viewerStateMachine, parameter) {
		currentState.parametersState($.ig.ParametersState.prototype.empty);
		currentState.processingState($.ig.ProcessingState.prototype.idle);
		currentState.pageContainerState($.ig.PageContainerState.prototype.empty);
		currentState.totalPages(0);
		notificationService.raiseEvent($.ig.ViewerEventType.prototype.processingCanceled, new $.ig.ProcessingCanceledEventArgs(false, parameter));
	},
	$type: new $.ig.Type('ProcessingCanceledAction', $.ig.Object.prototype.$type, [$.ig.IViewerStateMachineAction.prototype.$type])
}, true);

$.ig.IViewerStateMachine = Class.extend({
		$type: new $.ig.Type('IViewerStateMachine', null)
}, true);

$.ig.ViewerStateMachine = $.ig.Object.extend({
    currentPage: function (value) {
        if (arguments.length === 1) {
            this.currentState().currentPage(value);
            return value;
        } else {
            return this.currentState().currentPage();
        }
    },
    totalPages: function () {
        return this.currentState().totalPages();
    },
    reportDefinition: function () {
        if (this.currentState().processingSessionStateMachine() != null) {
            return this.currentState().processingSessionStateMachine().reportDefinition();
        }
        return null;
    },
    autoRender: function (value) {
        if (arguments.length === 1) {
            if (value) {
                this.eventQueueManager().enqueue($.ig.ViewerEventType.prototype.autoRenderSet);
            } else {
                this.currentState().autoRender(false);
            }
            return value;
        } else {
            return this.currentState().autoRender();
        }
    },
    isExporting: function () {
        return this.currentState().exportState() != $.ig.ExportState.prototype.idle;
    },
    __viewerStateMachine: null,
    definitionUri: function (value) {
        if (arguments.length === 1) {
            this.currentState().definitionUri(value);
            this.checkForValidSettings();
            return value;
        } else {
            return this.currentState().definitionUri();
        }
    },
    serviceEndpointUri: function (value) {
        if (arguments.length === 1) {
            this.currentState().serviceEndpointUri(value);
            this.checkForValidSettings();
            return value;
        } else {
            return this.currentState().serviceEndpointUri();
        }
    },
    render: function (firstRender, selectedParameterValues) {
        this.currentState().selectedParameterValues(selectedParameterValues);
        this.eventQueueManager().enqueue1($.ig.ViewerEventType.prototype.reportProcessingRequested, false);
    },
    cancel: function () {
        this.eventQueueManager().enqueue($.ig.ViewerEventType.prototype.processingCanceling);
    },
    getPage: function (pageNumber) {
        this.eventQueueManager().enqueue1($.ig.ViewerEventType.prototype.pageRequested, pageNumber);
    },
    parametersReady: function (selectedParameterValues) {
        this.eventQueueManager().enqueue1($.ig.ViewerEventType.prototype.parametersReady, selectedParameterValues);
    },
    canNavigate: function () {
        return this.currentState().processingState() != $.ig.ProcessingState.prototype.idle && this.currentState().processingState() != $.ig.ProcessingState.prototype.started && this.currentState().processingState() != $.ig.ProcessingState.prototype.downloading && this.currentState().processingState() != $.ig.ProcessingState.prototype.canceling && this.currentState().totalPages() > 1;
    },
    errorClosed: function (sender, e) {
        this.currentState().errorWindowState($.ig.ErrorWindowState.prototype.hidden);
    },
    attachToProcessingSession: function (processingSessionStateMachine) {
        this.currentState().processingSessionStateMachine(processingSessionStateMachine);
        this.currentState().processingSessionStateMachine().pageAvailable = $.ig.Delegate.prototype.combine(this.currentState().processingSessionStateMachine().pageAvailable, this.pageAvailable.runOn(this));
        this.currentState().processingSessionStateMachine().pageFetched = $.ig.Delegate.prototype.combine(this.currentState().processingSessionStateMachine().pageFetched, this.pageFetched.runOn(this));
        this.currentState().processingSessionStateMachine().processingCompleted = $.ig.Delegate.prototype.combine(this.currentState().processingSessionStateMachine().processingCompleted, this.processingCompleted.runOn(this));
        this.currentState().processingSessionStateMachine().processingCanceled = $.ig.Delegate.prototype.combine(this.currentState().processingSessionStateMachine().processingCanceled, this.processingCanceled.runOn(this));
        this.currentState().processingSessionStateMachine().exportCanceled = $.ig.Delegate.prototype.combine(this.currentState().processingSessionStateMachine().exportCanceled, this.exportCanceled.runOn(this));
        this.currentState().processingSessionStateMachine().exportCompleted = $.ig.Delegate.prototype.combine(this.currentState().processingSessionStateMachine().exportCompleted, this.exportCompleted.runOn(this));
        this.currentState().processingSessionStateMachine().printFinished = $.ig.Delegate.prototype.combine(this.currentState().processingSessionStateMachine().printFinished, this.printFinished.runOn(this));
    },
    detachFromProcessingSession: function (cancelImmediately) {
        var $self = this;
        if (cancelImmediately) {
            this.applyTransition((function () {
                var $ret = new $.ig.ViewerEvent();
                $ret.eventType($.ig.ViewerEventType.prototype.processingCanceling); return $ret;
            } ()));
        } else if (this.currentState().processingSessionStateMachine() != null) {
            this.currentState().processingSessionStateMachine().pageAvailable = $.ig.Delegate.prototype.remove(this.currentState().processingSessionStateMachine().pageAvailable, this.pageAvailable.runOn(this));
            this.currentState().processingSessionStateMachine().pageFetched = $.ig.Delegate.prototype.remove(this.currentState().processingSessionStateMachine().pageFetched, this.pageFetched.runOn(this));
            this.currentState().processingSessionStateMachine().processingCompleted = $.ig.Delegate.prototype.remove(this.currentState().processingSessionStateMachine().processingCompleted, this.processingCompleted.runOn(this));
            this.currentState().processingSessionStateMachine().processingCanceled = $.ig.Delegate.prototype.remove(this.currentState().processingSessionStateMachine().processingCanceled, this.processingCanceled.runOn(this));
            this.currentState().processingSessionStateMachine().exportCanceled = $.ig.Delegate.prototype.remove(this.currentState().processingSessionStateMachine().exportCanceled, this.exportCanceled.runOn(this));
            this.currentState().processingSessionStateMachine().exportCompleted = $.ig.Delegate.prototype.remove(this.currentState().processingSessionStateMachine().exportCompleted, this.exportCompleted.runOn(this));
            this.currentState().processingSessionStateMachine().printFinished = $.ig.Delegate.prototype.remove(this.currentState().processingSessionStateMachine().printFinished, this.printFinished.runOn(this));
            this.currentState().processingSessionStateMachine().close();
            this.currentState().processingSessionStateMachine(null);
        }
    },
    exportReport: function (format) {
        if (this.currentState().processingState() != $.ig.ProcessingState.prototype.completed) {
            this.throwException("reportHasNotFinishedLoadingErrorMsg");
        }
        if (this.currentState().exportState() != $.ig.ExportState.prototype.idle || this.eventQueueManager().isEventTypeInQueue($.ig.ViewerEventType.prototype.exportStarted)) {
            this.throwException("exportInProgressErrorMsg");
        }
        var availableExportFormats = $.ig.ViewerStateMachine.prototype.availableExportFormats;
        var containsFormat = false;
        containsFormat = availableExportFormats.contains(format ? format.toUpperCase() : "");
        if (String.isNullOrEmpty(format) || !containsFormat) {
            this.throwException("invalidExportFormat");
        }

        this.eventQueueManager().enqueue1($.ig.ViewerEventType.prototype.exportStarted, format);
    },
    printReport: function () {
        if (this.currentState().processingState() != $.ig.ProcessingState.prototype.completed) {
            this.throwException("reportHasNotFinishedLoadingErrorMsg");
        }
        if (this.currentState().exportState() != $.ig.ExportState.prototype.idle || this.eventQueueManager().isEventTypeInQueue($.ig.ViewerEventType.prototype.exportStarted)) {
            this.throwException("exportInProgressErrorMsg");
        }
        this.eventQueueManager().enqueue($.ig.ViewerEventType.prototype.printStarted);
    },
    cancelExport: function () {
        this.eventQueueManager().enqueue1($.ig.ViewerEventType.prototype.exportCanceling, new $.ig.ExportCanceledEventArgs());
    },
    cancelPrint: function () {
        var $self = this;
        this.eventQueueManager().enqueue1($.ig.ViewerEventType.prototype.printCanceling, (function () {
            var $ret = new $.ig.PrintFinishedEventArgs();
            $ret.canceled(true); return $ret;
        } ()));
    },
    throwException: function (messageKey) {
        throw new Error($.ui.igReportViewerLocale.locale[messageKey]);
    },
    exportCompleted: function (sender, e) {
        this.eventQueueManager().enqueue1($.ig.ViewerEventType.prototype.exportCompleted, e);
    },
    exportCanceled: function (sender, e) {
        this.eventQueueManager().enqueue1($.ig.ViewerEventType.prototype.exportCanceled, e);
    },
    printFinished: function (sender, e) {
        this.eventQueueManager().enqueue1($.ig.ViewerEventType.prototype.printFinished, e);
    },
    processingCompleted: function (sender, e) {
        this.eventQueueManager().enqueue1($.ig.ViewerEventType.prototype.processingCompleted, e);
    },
    pageFetched: function (sender, e) {
        this.eventQueueManager().enqueue1($.ig.ViewerEventType.prototype.pageFetched, e);
    },
    pageAvailable: function (sender, e) {
        if (e.processingSession() == this.currentState().processingSessionStateMachine()) {
            this.eventQueueManager().enqueue1($.ig.ViewerEventType.prototype.processingProgress, e);
        }
    },
    processingCanceled: function (sender, e) {
        this.eventQueueManager().enqueue1($.ig.ViewerEventType.prototype.processingCanceled, e);
    },
    _processingSessionStateMachineFactory: null,
    processingSessionStateMachineFactory: function (value) {
        if (arguments.length === 1) {
            this._processingSessionStateMachineFactory = value;
            return value;
        } else {
            return this._processingSessionStateMachineFactory;
        }
    },
    _currentState: null,
    currentState: function (value) {
        if (arguments.length === 1) {
            this._currentState = value;
            return value;
        } else {
            return this._currentState;
        }
    },
    _eventQueueManager: null,
    eventQueueManager: function (value) {
        if (arguments.length === 1) {
            this._eventQueueManager = value;
            return value;
        } else {
            return this._eventQueueManager;
        }
    },
    _eventNotificationService: null,
    eventNotificationService: function (value) {
        if (arguments.length === 1) {
            this._eventNotificationService = value;
            return value;
        } else {
            return this._eventNotificationService;
        }
    },
    _actionFactory: null,
    actionFactory: function (value) {
        if (arguments.length === 1) {
            this._actionFactory = value;
            return value;
        } else {
            return this._actionFactory;
        }
    },
    init: function () {


        $.ig.Object.prototype.init.call(this);
        this.__viewerStateMachine = this;
        this.currentState(new $.ig.ViewerState());
        this.actionFactory(new $.ig.ViewerStateMachineActionFactory());
        (this).processingSessionStateMachineFactory(new $.ig.ProcessingSessionFactory());
        this.eventNotificationService(new $.ig.EventNotificationService(this.currentState()));
        this.eventQueueManager(new $.ig.EventQueueManager());
        this.eventQueueManager().eventQueued = $.ig.Delegate.prototype.combine(this.eventQueueManager().eventQueued, this.eventQueued.runOn(this));
    },
    eventQueued: function (sender, e) {
        var eventToProcess = sender;
        this.applyTransition(eventToProcess);
    },
    checkForValidSettings: function () {
        var validSettings = this.currentState().definitionUri() != null && this.currentState().serviceEndpointUri() != null;
        if (validSettings) {
            this.eventQueueManager().enqueue($.ig.ViewerEventType.prototype.settingsReady);

        } else {
            this.eventQueueManager().enqueue($.ig.ViewerEventType.prototype.settingsNotReady);
        }
    },
    applyTransition: function (eventToProcess) {
        var action = this.actionFactory().getActionFor(eventToProcess.eventType());
        action.execute(this.currentState(), this.eventQueueManager(), this.eventNotificationService(), this, eventToProcess.parameter());
    },
    $type: new $.ig.Type('ViewerStateMachine', $.ig.Object.prototype.$type, [$.ig.IViewerStateMachine.prototype.$type])
}, true);

$.ig.ExportStartedAction = $.ig.Object.extend({
	init: function () {

		$.ig.Object.prototype.init.call(this);

	},
	execute: function (currentState, queueManager, notificationService, viewerStateMachine, parameter) {
		var format = parameter;
		currentState.exportState($.ig.ExportState.prototype.started);
		currentState.exportingToFormat(format);
		currentState.processingSessionStateMachine().exportReport(format, false);
		notificationService.raiseEvent($.ig.ViewerEventType.prototype.exportStarted);
	},
	$type: new $.ig.Type('ExportStartedAction', $.ig.Object.prototype.$type, [$.ig.IViewerStateMachineAction.prototype.$type])
}, true);

$.ig.ViewerState = $.ig.Object.extend({
		init: function () {


			$.ig.Object.prototype.init.call(this);
						this.renderSettingsState($.ig.ViewerRenderSettingsState.prototype.empty);
				this.printingState($.ig.PrintingState.prototype.idle);
				this.processingState($.ig.ProcessingState.prototype.idle);
				this.pageContainerState($.ig.PageContainerState.prototype.empty);
				this.errorWindowState($.ig.ErrorWindowState.prototype.hidden);
				this.exportState($.ig.ExportState.prototype.idle);
				this.totalPages(0);
				this.processingSessionStateMachine(null);
				this.autoRender(true);
				this.selectedParameterValues(null);
				this.viewerVisualState($.ig.ViewerVisualState.prototype.visualReady);
				this.reportProcessingMode($.ig.ReportProcessingMode.prototype.server);
		},
	_selectedParameterValues: null,
	selectedParameterValues: function (value) {
		if (arguments.length === 1) {
			this._selectedParameterValues = value;
			return value;
		} else {
			return this._selectedParameterValues;
		}
	},
	_processingSessionStateMachine: null,
	processingSessionStateMachine: function (value) {
		if (arguments.length === 1) {
			this._processingSessionStateMachine = value;
			return value;
		} else {
			return this._processingSessionStateMachine;
		}
	},
	_definitionUri: null,
	definitionUri: function (value) {
		if (arguments.length === 1) {
			this._definitionUri = value;
			return value;
		} else {
			return this._definitionUri;
		}
	},
	_serviceEndpointUri: null,
	serviceEndpointUri: function (value) {
		if (arguments.length === 1) {
			this._serviceEndpointUri = value;
			return value;
		} else {
			return this._serviceEndpointUri;
		}
	},
	_currentPage: null,
	currentPage: function (value) {
		if (arguments.length === 1) {
			this._currentPage = value;
			return value;
		} else {
			return this._currentPage;
		}
	},
	_totalPages: null,
	totalPages: function (value) {
		if (arguments.length === 1) {
			this._totalPages = value;
			return value;
		} else {
			return this._totalPages;
		}
	},
	_reportProcessingMode: null,
	reportProcessingMode: function (value) {
		if (arguments.length === 1) {
			this._reportProcessingMode = value;
			return value;
		} else {
			return this._reportProcessingMode;
		}
	},
	_autoRender: null,
	autoRender: function (value) {
		if (arguments.length === 1) {
			this._autoRender = value;
			return value;
		} else {
			return this._autoRender;
		}
	},
	_viewerVisualState: null,
	viewerVisualState: function (value) {
		if (arguments.length === 1) {
			this._viewerVisualState = value;
			return value;
		} else {
			return this._viewerVisualState;
		}
	},
	_renderSettingsState: null,
	renderSettingsState: function (value) {
		if (arguments.length === 1) {
			this._renderSettingsState = value;
			return value;
		} else {
			return this._renderSettingsState;
		}
	},
	_printingState: null,
	printingState: function (value) {
		if (arguments.length === 1) {
			this._printingState = value;
			return value;
		} else {
			return this._printingState;
		}
	},
	_processingState: null,
	processingState: function (value) {
		if (arguments.length === 1) {
			this._processingState = value;
			return value;
		} else {
			return this._processingState;
		}
	},
	_pageContainerState: null,
	pageContainerState: function (value) {
		if (arguments.length === 1) {
			this._pageContainerState = value;
			return value;
		} else {
			return this._pageContainerState;
		}
	},
	_pageRequiresPostProcessing: null,
	pageRequiresPostProcessing: function (value) {
		if (arguments.length === 1) {
			this._pageRequiresPostProcessing = value;
			return value;
		} else {
			return this._pageRequiresPostProcessing;
		}
	},
	_errorWindowState: null,
	errorWindowState: function (value) {
		if (arguments.length === 1) {
			this._errorWindowState = value;
			return value;
		} else {
			return this._errorWindowState;
		}
	},
    _exportingToFormat: null,
    exportingToFormat: function (value) {
        if (arguments.length === 1) {
            this._exportingToFormat = value;
            return value;
        } else {
            return this._exportingToFormat;
        }
    },
    _exportState: null,
	exportState: function (value) {
		if (arguments.length === 1) {
			this._exportState = value;
			return value;
		} else {
			return this._exportState;
		}
	},
	_parametersState: null,
	parametersState: function (value) {
		if (arguments.length === 1) {
			this._parametersState = value;
			return value;
		} else {
			return this._parametersState;
		}
	},
	$type: new $.ig.Type('ViewerState', $.ig.Object.prototype.$type)
}, true);

$.ig.IEventQueueManager = Class.extend({
		$type: new $.ig.Type('IEventQueueManager', null)
}, true);

$.ig.EventQueueManager = $.ig.Object.extend({
	__queuedEvents: null,
		init: function () {


			$.ig.Object.prototype.init.call(this);
						this.__queuedEvents = new Array(0);
		},
	eventQueued: null,
	enqueue: function (eventType) {
		(this).enqueue1(eventType, null);
	},
	enqueue1: function (eventType, parameter) {
		var $self = this;
		var eventToEnqueue = (function () { var $ret = new $.ig.ViewerEvent();
$ret.eventType(eventType);
$ret.parameter(parameter); return $ret;}());
		this.__queuedEvents.push(eventToEnqueue);
		window.setTimeout(function () { return $self.enqueueWork(eventToEnqueue)}, 0);
	},
	isEventTypeInQueue: function (eventType) {
		for (var i = 0; i < this.__queuedEvents.length; i++) {
			var viewerEvent = null;
			viewerEvent = this.__queuedEvents[i];
			if (viewerEvent.eventType() == eventType) {
				return true;
			}
		}
		return false;
	},
	enqueueWork: function (eventToEnqueue) {
		this.__queuedEvents.shift();
		if (this.eventQueued != null) {
			this.eventQueued(eventToEnqueue, new $.ig.EventArgs());
		}
	},
	$type: new $.ig.Type('EventQueueManager', $.ig.Object.prototype.$type, [$.ig.IEventQueueManager.prototype.$type])
}, true);

$.ig.ViewerEvent = $.ig.Object.extend({
	init: function () {

		$.ig.Object.prototype.init.call(this);

	},
	_eventType: null,
	eventType: function (value) {
		if (arguments.length === 1) {
			this._eventType = value;
			return value;
		} else {
			return this._eventType;
		}
	},
	_parameter: null,
	parameter: function (value) {
		if (arguments.length === 1) {
			this._parameter = value;
			return value;
		} else {
			return this._parameter;
		}
	},
	$type: new $.ig.Type('ViewerEvent', $.ig.Object.prototype.$type)
}, true);

$.ig.EventNotificationService = $.ig.Object.extend({
	__currentState: null,
		init: function (currentState) {


			$.ig.Object.prototype.init.call(this);
						this.__currentState = currentState;
		},
	reportProcessingRequested: null,
	exportStarted: null,
	exportCompleted: null,
	exportCanceled: null,
	processingStarted: null,
	processingProgress: null,
	processingCanceled: null,
	processingCompleted: null,
	currentPageAvailable: null,
	printStarted: null,
	printFinished: null,
	canRaiseEvent: function (eventTypeToRaise) {
		return true;
	},
	raiseEvent: function (eventTypeToRaise, e) {
		if (this.canRaiseEvent(eventTypeToRaise)) {
			switch (eventTypeToRaise) {
				case $.ig.ViewerEventType.prototype.reportProcessingRequested:
					this.onReportProcessingRequested();
					break;
				case $.ig.ViewerEventType.prototype.exportStarted:
					this.onExportStarted();
					break;
				case $.ig.ViewerEventType.prototype.exportCompleted:
					this.onExportCompleted(e);
					break;
				case $.ig.ViewerEventType.prototype.exportCanceled:
					this.onExportCanceled(e);
					break;
				case $.ig.ViewerEventType.prototype.processingStarted:
					this.onProcessingStarted(e);
					break;
				case $.ig.ViewerEventType.prototype.processingProgress:
					this.onProcessingProgress(e);
					break;
				case $.ig.ViewerEventType.prototype.processingCanceled:
					this.onProcessingCanceled(e);
					break;
				case $.ig.ViewerEventType.prototype.processingCompleted:
					this.onProcessingCompleted(e);
					break;
				case $.ig.ViewerEventType.prototype.pageFetched:
					this.onPageFetched(e);
					break;
				case $.ig.ViewerEventType.prototype.printStarted:
					this.onPrintStarted();
					break;
				case $.ig.ViewerEventType.prototype.printFinished:
					this.onPrintFinished(e);
					break;
			}
		}
	},
	onReportProcessingRequested: function () {
		if (this.reportProcessingRequested != null) {
			this.reportProcessingRequested(this, new $.ig.EventArgs());
		}
	},
	onExportStarted: function () {
		if (this.exportStarted != null) {
			this.exportStarted(this, new $.ig.EventArgs());
		}
	},
	onExportCompleted: function (e) {
		if (this.exportCompleted != null) {
			this.exportCompleted(this, e);
		}
	},
	onExportCanceled: function (e) {
		if (this.exportCanceled != null) {
			this.exportCanceled(this, e);
		}
	},
	onProcessingStarted: function (e) {
		if (this.processingStarted != null) {
			this.processingStarted(this, e);
		}
	},
	onProcessingProgress: function (e) {
		if (this.processingProgress != null) {
			this.processingProgress(this, e);
		}
	},
	onProcessingCanceled: function (e) {
		if (this.processingCanceled != null) {
			this.processingCanceled(this, e);
		}
	},
	onProcessingCompleted: function (e) {
		if (this.processingCompleted != null) {
			this.processingCompleted(this, e);
		}
	},
	onPageFetched: function (e) {
		if (this.currentPageAvailable != null) {
			this.currentPageAvailable(this, e);
		}
	},
	onPrintStarted: function () {
		if (this.printStarted != null) {
			this.printStarted(this, new $.ig.EventArgs());
		}
	},
	onPrintFinished: function (e) {
		if (this.printFinished != null) {
			this.printFinished(this, e);
		}
	},
	$type: new $.ig.Type('EventNotificationService', $.ig.Object.prototype.$type)
}, true);

$.ig.ProcessingDownloadedAction = $.ig.Object.extend({
	init: function () {

		$.ig.Object.prototype.init.call(this);

	},
	execute: function (currentState, queueManager, notificationService, viewerStateMachine, parameter) {
		if (currentState.processingState() == $.ig.ProcessingState.prototype.canceling) {
			return;
		}
		currentState.processingState($.ig.ProcessingState.prototype.processing);
		currentState.processingSessionStateMachine().processReport(currentState.selectedParameterValues());
		queueManager.enqueue($.ig.ViewerEventType.prototype.processingStarted);
	},
	$type: new $.ig.Type('ProcessingDownloadedAction', $.ig.Object.prototype.$type, [$.ig.IViewerStateMachineAction.prototype.$type])
}, true);

$.ig.PrintStartedAction = $.ig.Object.extend({
	init: function () {

		$.ig.Object.prototype.init.call(this);

	},
	execute: function (currentState, queueManager, notificationService, viewerStateMachine, parameter) {
		currentState.printingState($.ig.PrintingState.prototype.started);
		currentState.processingSessionStateMachine().exportReport("PDF", true);
		notificationService.raiseEvent($.ig.ViewerEventType.prototype.printStarted);
	},
	$type: new $.ig.Type('PrintStartedAction', $.ig.Object.prototype.$type, [$.ig.IViewerStateMachineAction.prototype.$type])
}, true);

$.ig.ProcessingDownloadingAction = $.ig.Object.extend({
	init: function () {

		$.ig.Object.prototype.init.call(this);

	},
	execute: function (currentState, queueManager, notificationService, viewerStateMachine, parameter) {
		if (currentState.processingState() == $.ig.ProcessingState.prototype.canceling) {
			return;
        }

        notificationService.raiseEvent($.ig.ViewerEventType.prototype.reportProcessingRequested);
		currentState.processingState($.ig.ProcessingState.prototype.downloading);
		if (currentState.reportProcessingMode() == $.ig.ReportProcessingMode.prototype.server) {
			queueManager.enqueue($.ig.ViewerEventType.prototype.processingDownloaded);

		} else {
		}
	},
	$type: new $.ig.Type('ProcessingDownloadingAction', $.ig.Object.prototype.$type, [$.ig.IViewerStateMachineAction.prototype.$type])
}, true);

$.ig.ProcessingStartedAction = $.ig.Object.extend({
	init: function () {

		$.ig.Object.prototype.init.call(this);

	},
	execute: function (currentState, queueManager, notificationService, viewerStateMachine, parameter) {
		if (currentState.processingState() == $.ig.ProcessingState.prototype.canceling) {
			return;
		}
		currentState.processingState($.ig.ProcessingState.prototype.started);
		notificationService.raiseEvent($.ig.ViewerEventType.prototype.processingStarted);
	},
	$type: new $.ig.Type('ProcessingStartedAction', $.ig.Object.prototype.$type, [$.ig.IViewerStateMachineAction.prototype.$type])
}, true);

$.ig.ProcessingCancelingAction = $.ig.Object.extend({
	init: function () {

		$.ig.Object.prototype.init.call(this);

	},
	execute: function (currentState, queueManager, notificationService, viewerStateMachine, parameter) {
		if (currentState.processingState() == $.ig.ProcessingState.prototype.canceling || currentState.processingState() == $.ig.ProcessingState.prototype.idle) {
			return;
		}
		currentState.processingState($.ig.ProcessingState.prototype.canceling);
		if (currentState.exportState() != $.ig.ExportState.prototype.idle && currentState.exportState() != $.ig.ExportState.prototype.canceling) {
			queueManager.enqueue($.ig.ViewerEventType.prototype.exportCanceling);
		}
		if (currentState.printingState() != $.ig.PrintingState.prototype.idle && currentState.printingState() != $.ig.PrintingState.prototype.finished) {
			queueManager.enqueue1($.ig.ViewerEventType.prototype.printFinished, true);
		}
		viewerStateMachine.detachFromProcessingSession(false);
		queueManager.enqueue1($.ig.ViewerEventType.prototype.processingCanceled, parameter);
	},
	$type: new $.ig.Type('ProcessingCancelingAction', $.ig.Object.prototype.$type, [$.ig.IViewerStateMachineAction.prototype.$type])
}, true);

$.ig.ParametersReadyAction = $.ig.Object.extend({
    init: function () {

        $.ig.Object.prototype.init.call(this);

    },
    execute: function (currentState, queueManager, notificationService, viewerStateMachine, parameter) {
        currentState.selectedParameterValues(parameter);
        notificationService.raiseEvent($.ig.ViewerEventType.prototype.parametersReady);
    },
    $type: new $.ig.Type('ParametersReadyAction', $.ig.Object.prototype.$type, [$.ig.IViewerStateMachineAction.prototype.$type])
}, true);

$.ig.ReportProcessingRequestedAction = $.ig.Object.extend({
	init: function () {

		$.ig.Object.prototype.init.call(this);

	},
	execute: function (currentState, queueManager, notificationService, viewerStateMachine, parameter) {
		if (currentState.renderSettingsState() != $.ig.ViewerRenderSettingsState.prototype.valid) {
			return;
		}
		if (currentState.processingSessionStateMachine() != null) {
			viewerStateMachine.detachFromProcessingSession(true);
		}
		currentState.processingState($.ig.ProcessingState.prototype.requested);
		var processingSession = viewerStateMachine.processingSessionStateMachineFactory().createServerProcessingSession(currentState.definitionUri(), currentState.serviceEndpointUri());
		viewerStateMachine.attachToProcessingSession(processingSession);
		queueManager.enqueue($.ig.ViewerEventType.prototype.processingDownloading);
	},
	$type: new $.ig.Type('ReportProcessingRequestedAction', $.ig.Object.prototype.$type, [$.ig.IViewerStateMachineAction.prototype.$type])
}, true);

$.ig.ExportCompletedAction = $.ig.Object.extend({
    init: function () {

        $.ig.Object.prototype.init.call(this);

    },
    execute: function (currentState, queueManager, notificationService, viewerStateMachine, parameter) {
        currentState.exportState($.ig.ExportState.prototype.idle);
        parameter.format(currentState.exportingToFormat());
        notificationService.raiseEvent($.ig.ViewerEventType.prototype.exportCompleted, parameter);
    },
    $type: new $.ig.Type('ExportCompletedAction', $.ig.Object.prototype.$type, [$.ig.IViewerStateMachineAction.prototype.$type])
}, true);

$.ig.PageFetchedAction = $.ig.Object.extend({
	init: function () {

		$.ig.Object.prototype.init.call(this);

	},
	execute: function (currentState, queueManager, notificationService, viewerStateMachine, parameter) {
		var arguments = parameter;
		if (arguments.pageNumber() != currentState.currentPage()) {
			return;
		}
		notificationService.raiseEvent($.ig.ViewerEventType.prototype.pageFetched, arguments);
		currentState.pageContainerState($.ig.PageContainerState.prototype.loaded);
	},
	$type: new $.ig.Type('PageFetchedAction', $.ig.Object.prototype.$type, [$.ig.IViewerStateMachineAction.prototype.$type])
}, true);

$.ig.AutoRenderSetAction = $.ig.Object.extend({
	init: function () {

		$.ig.Object.prototype.init.call(this);

	},
	execute: function (currentState, queueManager, notificationService, viewerStateMachine, parameter) {
		if (!currentState.autoRender() && currentState.viewerVisualState() == $.ig.ViewerVisualState.prototype.visualReady && currentState.renderSettingsState() == $.ig.ViewerRenderSettingsState.prototype.valid && currentState.processingState() == $.ig.ProcessingState.prototype.idle) {
			currentState.autoRender(true);
			queueManager.enqueue1($.ig.ViewerEventType.prototype.reportProcessingRequested, false);
		}
	},
	$type: new $.ig.Type('AutoRenderSetAction', $.ig.Object.prototype.$type, [$.ig.IViewerStateMachineAction.prototype.$type])
}, true);

$.ig.IViewerStateMachineActionFactory = Class.extend({
		$type: new $.ig.Type('IViewerStateMachineActionFactory', null)
}, true);

$.ig.ViewerStateMachineActionFactory = $.ig.Object.extend({
	__actions: null,
	actions: function () {
			return this.__actions;
	},
		init: function () {


			$.ig.Object.prototype.init.call(this);
						this.__actions = new $.ig.Dictionary$2($.ig.ViewerEventType.prototype.$type, $.ig.IViewerStateMachineAction.prototype.$type, 0);
				this.actions().item($.ig.ViewerEventType.prototype.autoRenderSet, new $.ig.AutoRenderSetAction());
				this.actions().item($.ig.ViewerEventType.prototype.settingsNotReady, new $.ig.SettingsNotReadyAction());
				this.actions().item($.ig.ViewerEventType.prototype.settingsReady, new $.ig.SettingsReadyAction());
				this.actions().item($.ig.ViewerEventType.prototype.parametersReady, new $.ig.ParametersReadyAction());
				this.actions().item($.ig.ViewerEventType.prototype.exportStarted, new $.ig.ExportStartedAction());
				this.actions().item($.ig.ViewerEventType.prototype.exportCompleted, new $.ig.ExportCompletedAction());
				this.actions().item($.ig.ViewerEventType.prototype.exportCanceling, new $.ig.ExportCancelingAction());
				this.actions().item($.ig.ViewerEventType.prototype.exportCanceled, new $.ig.ExportCanceledAction());
				this.actions().item($.ig.ViewerEventType.prototype.pageFetched, new $.ig.PageFetchedAction());
				this.actions().item($.ig.ViewerEventType.prototype.pageRequested, new $.ig.PageRequestedAction());
				this.actions().item($.ig.ViewerEventType.prototype.processingStarted, new $.ig.ProcessingStartedAction());
				this.actions().item($.ig.ViewerEventType.prototype.processingDownloading, new $.ig.ProcessingDownloadingAction());
				this.actions().item($.ig.ViewerEventType.prototype.processingDownloaded, new $.ig.ProcessingDownloadedAction());
				this.actions().item($.ig.ViewerEventType.prototype.processingProgress, new $.ig.ProcessingProgressAction());
				this.actions().item($.ig.ViewerEventType.prototype.processingCanceling, new $.ig.ProcessingCancelingAction());
				this.actions().item($.ig.ViewerEventType.prototype.processingCanceled, new $.ig.ProcessingCanceledAction());
				this.actions().item($.ig.ViewerEventType.prototype.processingCompleted, new $.ig.ProcessingCompletedAction());
				this.actions().item($.ig.ViewerEventType.prototype.reportProcessingRequested, new $.ig.ReportProcessingRequestedAction());
				this.actions().item($.ig.ViewerEventType.prototype.printStarted, new $.ig.PrintStartedAction());
				this.actions().item($.ig.ViewerEventType.prototype.printFinished, new $.ig.PrintFinishedAction());
				this.actions().item($.ig.ViewerEventType.prototype.printCanceling, new $.ig.PrintCancelingAction());
		},
	getActionFor: function (eventType) {
		return this.actions().item(eventType);
	},
	$type: new $.ig.Type('ViewerStateMachineActionFactory', $.ig.Object.prototype.$type, [$.ig.IViewerStateMachineActionFactory.prototype.$type])
}, true);

$.ig.SettingsNotReadyAction = $.ig.Object.extend({
	init: function () {

		$.ig.Object.prototype.init.call(this);

	},
	execute: function (currentState, queueManager, notificationService, viewerStateMachine, parameter) {
		currentState.renderSettingsState($.ig.ViewerRenderSettingsState.prototype.invalid);
		if (currentState.processingState() != $.ig.ProcessingState.prototype.idle && currentState.processingState() != $.ig.ProcessingState.prototype.canceling) {
			queueManager.enqueue($.ig.ViewerEventType.prototype.processingCanceling);
		}
	},
	$type: new $.ig.Type('SettingsNotReadyAction', $.ig.Object.prototype.$type, [$.ig.IViewerStateMachineAction.prototype.$type])
}, true);

$.ig.ProcessingProgressAction = $.ig.Object.extend({
	init: function () {

		$.ig.Object.prototype.init.call(this);

	},
	execute: function (currentState, queueManager, notificationService, viewerStateMachine, parameter) {
	    var args = parameter;
	    if (currentState.processingState() == $.ig.ProcessingState.prototype.canceling || currentState.totalPages() > args.pageNumber()) {
			return;
		}
		currentState.totalPages(args.pageNumber());
		notificationService.raiseEvent($.ig.ViewerEventType.prototype.processingProgress, new $.ig.ProcessingProgressEventArgs(false, args.pageNumber()));
		currentState.processingState($.ig.ProcessingState.prototype.processing);
	},
	$type: new $.ig.Type('ProcessingProgressAction', $.ig.Object.prototype.$type, [$.ig.IViewerStateMachineAction.prototype.$type])
}, true);

$.ig.IProcessingSessionStateMachine = Class.extend({
		$type: new $.ig.Type('IProcessingSessionStateMachine', null)
}, true);

$.ig.AsyncReportProcessorAction = $.ig.Object.extend({
		init: function (resultCallback, asyncErrorCallback) {


			$.ig.Object.prototype.init.call(this);
						this.resultCallback(resultCallback);
				this.asyncErrorCallback(asyncErrorCallback);
		},
	_resultCallback: null,
	resultCallback: function (value) {
		if (arguments.length === 1) {
			this._resultCallback = value;
			return value;
		} else {
			return this._resultCallback;
		}
	},
	_asyncErrorCallback: null,
	asyncErrorCallback: function (value) {
		if (arguments.length === 1) {
			this._asyncErrorCallback = value;
			return value;
		} else {
			return this._asyncErrorCallback;
		}
	},
	$type: new $.ig.Type('AsyncReportProcessorAction', $.ig.Object.prototype.$type)
}, true);

$.ig.ProcessingSessionStateMachine = $.ig.Object.extend({
	reportDefinition: function () {
			if (this.__adapter) { return this.__adapter.getReportDefinition(); };
			return null;
	},
	__adapter: null,
	__canceled: null,
		init: function (definitionUri, serviceEndpointUri) {

			var $self = this;

			$.ig.Object.prototype.init.call(this);
			    this.__adapter = new $.ig.ReportProcessorJsAdapter(definitionUri, serviceEndpointUri, 96);
				this.__processReportCallback = new $.ig.AsyncReportProcessorAction(function (p) { return $self.notifyProcessingCompleted(p, false)				}, function (p) { return $self.notifyProcessingCompleted(p, true)				});
				this.__getPageCallback = new $.ig.AsyncReportProcessorAction(function (p) { return $self.notifyPageFetched(p, false)				}, function (p) { return $self.notifyPageFetched(p, true)				});
				this.__pageCountCallback = new $.ig.AsyncReportProcessorAction(function (p) { return $self.notifyProcessingCompleted(p, false)				}, function (p) { return $self.notifyProcessingCompleted(p, true)				});
				this.__cancelProcessingCallback = new $.ig.AsyncReportProcessorAction(function (p) { return $self.notifyCancelProcessingCompleted(p, false)				}, function (p) { return $self.notifyCancelProcessingCompleted(p, true)				});
				this.__exportReportCallback = new $.ig.AsyncReportProcessorAction(function (p) { return $self.notifyExportCompleted(p, false)				}, function (p) { return $self.notifyExportCompleted(p, true)				});
				this.__printReportCallback = new $.ig.AsyncReportProcessorAction(function (p) { return $self.notifyPrintFinished(p, false)				}, function (p) { return $self.notifyPrintFinished(p, true)				});
				this.__cancelExportCallback = new $.ig.AsyncReportProcessorAction(function (p) { return $self.notifyCancelExportCompleted(p, false)				}, function (p) { return $self.notifyCancelExportCompleted(p, true)				});
				this.__cancelPrintCallback = new $.ig.AsyncReportProcessorAction(function (p) { return $self.notifyCancelPrintCompleted(p, false)				}, function (p) { return $self.notifyCancelPrintCompleted(p, true)				});
				var notifyPageAvailable = function (p) { return $self.notifyPageAvailable(p)};
				this.__adapter.pageAvailable = notifyPageAvailable;
		},
	pageFetched: null,
	pageAvailable: null,
	processingCompleted: null,
	processingCanceled: null,
	exportCompleted: null,
	exportCanceled: null,
	printFinished: null,
	printCanceled: null,
	processReport: function (selectedParameterValues) {
		var asyncCallback = this.__processReportCallback;
		this.__adapter.processReport(selectedParameterValues, asyncCallback);
	},
	getPage: function (pageNumber) {
		var asyncCallback = this.__getPageCallback;
		this.__adapter.getPage(pageNumber, asyncCallback);
	},
	pageCount: function () {
		var asyncCallback = this.__pageCountCallback;
		this.__adapter.pageCount(asyncCallback);
	},
	close: function () {
		this.__canceled = true;
		var asyncCallback = this.__cancelProcessingCallback;
		this.__adapter.cancelProcessing(true, asyncCallback);
	},
	exportReport: function (format, printOnOpen) {
		if (printOnOpen) {
			var asyncCallback = this.__printReportCallback;
			this.__adapter.printReport(asyncCallback);

		} else {
			var asyncCallback = this.__exportReportCallback;
			this.__adapter.exportReport(format, asyncCallback);
		}
	},
	cancelExport: function () {
		var asyncCallback = this.__cancelExportCallback;
		this.__adapter.cancelExport(asyncCallback);
	},
	cancelPrint: function () {
		var asyncCallback = this.__cancelPrintCallback;
		this.__adapter.cancelPrint(asyncCallback);
	},
	__processReportCallback: null,
	__getPageCallback: null,
	__pageCountCallback: null,
	__cancelProcessingCallback: null,
	__exportReportCallback: null,
	__printReportCallback: null,
	__cancelExportCallback: null,
	__cancelPrintCallback: null,
	getError: function (error) {
		var exception = error;
		return exception;
	},
	notifyPageAvailable: function (parameter) {
		if (this.__canceled) {
			return;
		}
		var args = parameter;
		var pageCount = args.pageNumber();
		if (this.pageAvailable != null) {
			this.pageAvailable(this, new $.ig.ProcessingSessionPageAvailableEventArgs(pageCount, args.error(), this));
		}
	},
	notifyPageFetched: function (parameter, error) {
		if (this.__canceled) {
			return;
		}
		var pageNumber = 0;
		var pageData = " ";
		var exception = null;
		if (error) {
			exception = this.getError(parameter);

		} else {
			pageData = parameter;
			pageNumber = pageData.getPageNumber();
		}
		if (this.pageFetched != null) {
			this.pageFetched(this, new $.ig.PageFetchedEventArgs(pageNumber, pageData, exception));
		}
	},
	notifyProcessingCompleted: function (parameter, error) {
		if (this.__canceled) {
			return;
		}
		var totalPages = -1;
		var exception = null;
		if (error) {
			exception = this.getError(parameter);

		} else {
			totalPages = parameter;
		}
		if (this.processingCompleted != null) {
			this.processingCompleted(this, new $.ig.ProcessingSessionPageAvailableEventArgs(totalPages, exception, this));
		}
	},
	notifyPrintFinished: function (parameter, error) {
		var $self = this;
		if (this.__canceled) {
			return;
		}
		var uri = null;
		var exception = null;
		if (error) {
			exception = this.getError(parameter);
			if (this.printFinished != null) {
				this.printFinished(this, (function () { var $ret = new $.ig.PrintFinishedEventArgs();
				$ret.error(exception); return $ret;}()));
			}

		} else {
			uri = parameter;
			if (uri != null && this.printFinished != null) {
				this.printFinished(this, (function () { var $ret = new $.ig.PrintFinishedEventArgs();
				$ret.downloadUri(uri); return $ret;}()));
			}
		}
	},
	notifyExportCompleted: function (parameter, error) {
		var $self = this;
		if (this.__canceled) {
			return;
		}
		var uri = null;
		var exception = null;
		if (error) {
			exception = this.getError(parameter);
			if (this.exportCanceled != null) {
				this.exportCanceled(this, (function () { var $ret = new $.ig.ExportCanceledEventArgs();
				$ret.error(exception); return $ret;}()));
			}

		} else {
			uri = parameter;
			if (uri != null && this.exportCompleted != null) {
				this.exportCompleted(this, (function () { var $ret = new $.ig.ExportCompletedEventArgs();
				$ret.downloadUri(uri); return $ret;}()));
			}
		}
	},
	notifyCancelExportCompleted: function (parameter, error) {
	},
	notifyCancelPrintCompleted: function (parameter, error) {
	},
	notifyCancelProcessingCompleted: function (parameter, error) {
		var exception = null;
		if (error) {
			exception = this.getError(parameter);
		}
		if (this.processingCanceled != null) {
			this.processingCanceled(this, new $.ig.ReportProcessorEventArgs(exception));
		}
	},
	$type: new $.ig.Type('ProcessingSessionStateMachine', $.ig.Object.prototype.$type, [$.ig.IProcessingSessionStateMachine.prototype.$type])
}, true);

$.ig.ReportProcessorEventArgs = $.ig.EventArgs.extend({
	__error: null,
		init: function (error) {


			$.ig.EventArgs.prototype.init.call(this);
						this.__error = error;
		},
	error: function () {
			return this.__error;
	},
	$type: new $.ig.Type('ReportProcessorEventArgs', $.ig.EventArgs.prototype.$type)
}, true);

$.ig.PageAvailableEventArgs = $.ig.ReportProcessorEventArgs.extend({
	__pageNumber: null,
		init: function (pageNumber, error) {


			$.ig.ReportProcessorEventArgs.prototype.init.call(this, error);
						this.__pageNumber = pageNumber;
		},
	pageNumber: function () {
			return this.__pageNumber;
	},
	$type: new $.ig.Type('PageAvailableEventArgs', $.ig.ReportProcessorEventArgs.prototype.$type)
}, true);

$.ig.ProcessingSessionPageAvailableEventArgs = $.ig.PageAvailableEventArgs.extend({
	__processingSession: null,
		init: function (pageNumber, error, processingSession) {


			$.ig.PageAvailableEventArgs.prototype.init.call(this, pageNumber, error);
						this.__processingSession = processingSession;
		},
	processingSession: function () {
			return this.__processingSession;
	},
	$type: new $.ig.Type('ProcessingSessionPageAvailableEventArgs', $.ig.PageAvailableEventArgs.prototype.$type)
}, true);

$.ig.PageFetchedEventArgs = $.ig.EventArgs.extend({
	__pageNumber: null,
	__pageData: null,
	__error: null,
		init: function (pageNumber, pageData, error) {


			$.ig.EventArgs.prototype.init.call(this);
						this.__pageNumber = pageNumber;
				this.__pageData = pageData;
				this.__error = error;
		},
	pageNumber: function () {
			return this.__pageNumber;
	},
	pageData: function () {
			return this.__pageData;
	},
	error: function () {
			return this.__error;
	},
	$type: new $.ig.Type('PageFetchedEventArgs', $.ig.EventArgs.prototype.$type)
}, true);

$.ig.SettingsReadyAction = $.ig.Object.extend({
	init: function () {

		$.ig.Object.prototype.init.call(this);

	},
	execute: function (currentState, queueManager, notificationService, viewerStateMachine, parameter) {
		currentState.renderSettingsState($.ig.ViewerRenderSettingsState.prototype.valid);

		if (currentState.processingState() != $.ig.ProcessingState.prototype.idle && currentState.processingState() != $.ig.ProcessingState.prototype.canceling) {
		    queueManager.enqueue($.ig.ViewerEventType.prototype.processingCanceling);
		}

		if (currentState.autoRender() && currentState.viewerVisualState() == $.ig.ViewerVisualState.prototype.visualReady) {
			queueManager.enqueue1($.ig.ViewerEventType.prototype.reportProcessingRequested, false);
		}
	},
	$type: new $.ig.Type('SettingsReadyAction', $.ig.Object.prototype.$type, [$.ig.IViewerStateMachineAction.prototype.$type])
}, true);

$.ig.PageRequestedAction = $.ig.Object.extend({
	init: function () {

		$.ig.Object.prototype.init.call(this);

	},
	execute: function (currentState, queueManager, notificationService, viewerStateMachine, parameter) {
		if ((currentState.processingState() == $.ig.ProcessingState.prototype.processing || currentState.processingState() == $.ig.ProcessingState.prototype.completed) && currentState.totalPages() >= 1) {
			currentState.processingSessionStateMachine().getPage(parameter);
		}
	},
	$type: new $.ig.Type('PageRequestedAction', $.ig.Object.prototype.$type, [$.ig.IViewerStateMachineAction.prototype.$type])
}, true);

$.ig.IProcessingSessionFactory = Class.extend({
		$type: new $.ig.Type('IProcessingSessionFactory', null)
}, true);

$.ig.ProcessingSessionFactory = $.ig.Object.extend({
	init: function () {

		$.ig.Object.prototype.init.call(this);

	},
	createServerProcessingSession: function (definitionUri, serviceEndpointUri) {
		return new $.ig.ProcessingSessionStateMachine(definitionUri, serviceEndpointUri);
	},
	$type: new $.ig.Type('ProcessingSessionFactory', $.ig.Object.prototype.$type, [$.ig.IProcessingSessionFactory.prototype.$type])
}, true);

$.ig.ExportCancelingAction = $.ig.Object.extend({
    init: function () {

        $.ig.Object.prototype.init.call(this);

    },
    execute: function (currentState, queueManager, notificationService, viewerStateMachine, parameter) {
        if (currentState.exportState() == $.ig.ExportState.prototype.idle || currentState.exportState() == $.ig.ExportState.prototype.canceling) {
            return;
        }

        currentState.exportState($.ig.ExportState.prototype.canceling);
        currentState.processingSessionStateMachine().cancelExport();
        queueManager.enqueue1($.ig.ViewerEventType.prototype.exportCanceled, new $.ig.ExportCanceledEventArgs());
    },
    $type: new $.ig.Type('ExportCancelingAction', $.ig.Object.prototype.$type, [$.ig.IViewerStateMachineAction.prototype.$type])
}, true);

$.ig.ProcessingEventArgs = $.ig.EventArgs.extend({
		init: function (isRepaginating) {


			$.ig.EventArgs.prototype.init.call(this);
						this.isRepaginating(isRepaginating);
		},
	_isRepaginating: null,
	isRepaginating: function (value) {
		if (arguments.length === 1) {
			this._isRepaginating = value;
			return value;
		} else {
			return this._isRepaginating;
		}
	},
	$type: new $.ig.Type('ProcessingEventArgs', $.ig.EventArgs.prototype.$type)
}, true);

$.ig.ProcessingCanceledEventArgs = $.ig.ProcessingEventArgs.extend({
		init: function (isRepaginating, error) {


			$.ig.ProcessingEventArgs.prototype.init.call(this, isRepaginating);
						this.error(error);
		},
	_error: null,
	error: function (value) {
		if (arguments.length === 1) {
			this._error = value;
			return value;
		} else {
			return this._error;
		}
	},
	$type: new $.ig.Type('ProcessingCanceledEventArgs', $.ig.ProcessingEventArgs.prototype.$type)
}, true);

$.ig.ProcessingStartedEventArgs = $.ig.ProcessingEventArgs.extend({
		init: function (isRepaginating) {


			$.ig.ProcessingEventArgs.prototype.init.call(this, isRepaginating);
		},
	$type: new $.ig.Type('ProcessingStartedEventArgs', $.ig.ProcessingEventArgs.prototype.$type)
}, true);

$.ig.ProcessingProgressEventArgs = $.ig.ProcessingEventArgs.extend({
		init: function (isRepaginating, pagesProcessed) {


			$.ig.ProcessingEventArgs.prototype.init.call(this, isRepaginating);
						this.pagesProcessed(pagesProcessed);
		},
	_pagesProcessed: null,
	pagesProcessed: function (value) {
		if (arguments.length === 1) {
			this._pagesProcessed = value;
			return value;
		} else {
			return this._pagesProcessed;
		}
	},
	$type: new $.ig.Type('ProcessingProgressEventArgs', $.ig.ProcessingEventArgs.prototype.$type)
}, true);

$.ig.ProcessingCompletedEventArgs = $.ig.ProcessingEventArgs.extend({
		init: function (isRepaginating, totalPages) {


			$.ig.ProcessingEventArgs.prototype.init.call(this, isRepaginating);
						this.totalPages(totalPages);
		},
	_totalPages: null,
	totalPages: function (value) {
		if (arguments.length === 1) {
			this._totalPages = value;
			return value;
		} else {
			return this._totalPages;
		}
	},
	$type: new $.ig.Type('ProcessingCompletedEventArgs', $.ig.ProcessingEventArgs.prototype.$type)
}, true);

$.ig.ErrorEventArgs = $.ig.EventArgs.extend({
		init: function (exception) {


			$.ig.EventArgs.prototype.init.call(this);
						this.error(exception);
		},
	_error: null,
	error: function (value) {
		if (arguments.length === 1) {
			this._error = value;
			return value;
		} else {
			return this._error;
		}
	},
	_isFatal: null,
	isFatal: function (value) {
		if (arguments.length === 1) {
			this._isFatal = value;
			return value;
		} else {
			return this._isFatal;
		}
	},
	_handled: null,
	handled: function (value) {
		if (arguments.length === 1) {
			this._handled = value;
			return value;
		} else {
			return this._handled;
		}
	},
	$type: new $.ig.Type('ErrorEventArgs', $.ig.EventArgs.prototype.$type)
}, true);

$.ig.ExportCompletedEventArgs = $.ig.EventArgs.extend({
		init: function () {


			$.ig.EventArgs.prototype.init.call(this);
		},
	_format: null,
	format: function (value) {
		if (arguments.length === 1) {
			this._format = value;
			return value;
		} else {
			return this._format;
		}
	},
	_downloadUri: null,
	downloadUri: function (value) {
		if (arguments.length === 1) {
			this._downloadUri = value;
			return value;
		} else {
			return this._downloadUri;
		}
	},
	$type: new $.ig.Type('ExportCompletedEventArgs', $.ig.EventArgs.prototype.$type)
}, true);

$.ig.ExportCanceledEventArgs = $.ig.EventArgs.extend({
		init: function () {


			$.ig.EventArgs.prototype.init.call(this);
		},
	_error: null,
	error: function (value) {
		if (arguments.length === 1) {
			this._error = value;
			return value;
		} else {
			return this._error;
		}
	},
	$type: new $.ig.Type('ExportCanceledEventArgs', $.ig.EventArgs.prototype.$type)
}, true);

$.ig.PrintFinishedEventArgs = $.ig.EventArgs.extend({
		init: function () {


			$.ig.EventArgs.prototype.init.call(this);
		},
	_downloadUri: null,
	downloadUri: function (value) {
		if (arguments.length === 1) {
			this._downloadUri = value;
			return value;
		} else {
			return this._downloadUri;
		}
	},
	_error: null,
	error: function (value) {
		if (arguments.length === 1) {
			this._error = value;
			return value;
		} else {
			return this._error;
		}
	},
	_canceled: null,
	canceled: function (value) {
		if (arguments.length === 1) {
			this._canceled = value;
			return value;
		} else {
			return this._canceled;
		}
	},
	$type: new $.ig.Type('PrintFinishedEventArgs', $.ig.EventArgs.prototype.$type)
}, true);

$.ig.PrintCancelingAction = $.ig.Object.extend({
	init: function () {

		$.ig.Object.prototype.init.call(this);

	},
	execute: function (currentState, queueManager, notificationService, viewerStateMachine, parameter) {
	    var $self = this;

	    if (currentState.printingState() == $.ig.PrintingState.prototype.idle || currentState.printingState() == $.ig.PrintingState.prototype.canceling) {
	        return;
	    }

		currentState.printingState($.ig.PrintingState.prototype.canceling);
		currentState.processingSessionStateMachine().cancelPrint();
		queueManager.enqueue1($.ig.ViewerEventType.prototype.printFinished, (function () { var $ret = new $.ig.PrintFinishedEventArgs();
		$ret.canceled(true); return $ret;}()));
	},
	$type: new $.ig.Type('PrintCancelingAction', $.ig.Object.prototype.$type, [$.ig.IViewerStateMachineAction.prototype.$type])
}, true);
$.ig.ViewerEventType.prototype.autoRenderSet = 0;
$.ig.ViewerEventType.prototype.visualReady = 1;
$.ig.ViewerEventType.prototype.visualNotReady = 2;
$.ig.ViewerEventType.prototype.settingsNotReady = 5;
$.ig.ViewerEventType.prototype.settingsReady = 6;
$.ig.ViewerEventType.prototype.dataReady = 7;
$.ig.ViewerEventType.prototype.parametersProcessingRequested = 8;
$.ig.ViewerEventType.prototype.parametersReady = 9;
$.ig.ViewerEventType.prototype.reportProcessingRequested = 10;
$.ig.ViewerEventType.prototype.reportParametersSubmit = 12;
$.ig.ViewerEventType.prototype.exportStarted = 14;
$.ig.ViewerEventType.prototype.exportCompleted = 15;
$.ig.ViewerEventType.prototype.exportCanceling = 16;
$.ig.ViewerEventType.prototype.exportCanceled = 17;
$.ig.ViewerEventType.prototype.processingStarted = 19;
$.ig.ViewerEventType.prototype.processingDownloading = 20;
$.ig.ViewerEventType.prototype.processingDownloaded = 21;
$.ig.ViewerEventType.prototype.processingProgress = 22;
$.ig.ViewerEventType.prototype.processingCanceling = 23;
$.ig.ViewerEventType.prototype.processingCanceled = 24;
$.ig.ViewerEventType.prototype.processingCompleted = 25;
$.ig.ViewerEventType.prototype.printPreparingStarted = 26;
$.ig.ViewerEventType.prototype.printPreparingFinished = 27;
$.ig.ViewerEventType.prototype.printStarted = 28;
$.ig.ViewerEventType.prototype.printCanceling = 29;
$.ig.ViewerEventType.prototype.printFinished = 30;
$.ig.ViewerEventType.prototype.pageFetched = 31;
$.ig.ViewerEventType.prototype.pageRequested = 32;
$.ig.ViewerEventType.prototype.autoRenderSet = 0;
$.ig.ViewerEventType.prototype.visualReady = 1;
$.ig.ViewerEventType.prototype.visualNotReady = 2;
$.ig.ViewerEventType.prototype.settingsNotReady = 5;
$.ig.ViewerEventType.prototype.settingsReady = 6;
$.ig.ViewerEventType.prototype.dataReady = 7;
$.ig.ViewerEventType.prototype.parametersProcessingRequested = 8;
$.ig.ViewerEventType.prototype.parametersReady = 9;
$.ig.ViewerEventType.prototype.reportProcessingRequested = 10;
$.ig.ViewerEventType.prototype.reportParametersSubmit = 12;
$.ig.ViewerEventType.prototype.exportStarted = 14;
$.ig.ViewerEventType.prototype.exportCompleted = 15;
$.ig.ViewerEventType.prototype.exportCanceling = 16;
$.ig.ViewerEventType.prototype.exportCanceled = 17;
$.ig.ViewerEventType.prototype.processingStarted = 19;
$.ig.ViewerEventType.prototype.processingDownloading = 20;
$.ig.ViewerEventType.prototype.processingDownloaded = 21;
$.ig.ViewerEventType.prototype.processingProgress = 22;
$.ig.ViewerEventType.prototype.processingCanceling = 23;
$.ig.ViewerEventType.prototype.processingCanceled = 24;
$.ig.ViewerEventType.prototype.processingCompleted = 25;
$.ig.ViewerEventType.prototype.printPreparingStarted = 26;
$.ig.ViewerEventType.prototype.printPreparingFinished = 27;
$.ig.ViewerEventType.prototype.printStarted = 28;
$.ig.ViewerEventType.prototype.printCanceling = 29;
$.ig.ViewerEventType.prototype.printFinished = 30;
$.ig.ViewerEventType.prototype.pageFetched = 31;
$.ig.ViewerEventType.prototype.pageRequested = 32;
$.ig.ReportProcessingMode.prototype.local = 0;
$.ig.ReportProcessingMode.prototype.server = 1;
$.ig.ReportProcessingMode.prototype.local = 0;
$.ig.ReportProcessingMode.prototype.server = 1;
$.ig.ExportState.prototype.idle = 0;
$.ig.ExportState.prototype.started = 1;
$.ig.ExportState.prototype.exporting = 2;
$.ig.ExportState.prototype.canceling = 3;
$.ig.ExportState.prototype.idle = 0;
$.ig.ExportState.prototype.started = 1;
$.ig.ExportState.prototype.exporting = 2;
$.ig.ExportState.prototype.canceling = 3;
$.ig.ErrorWindowState.prototype.visible = 0;
$.ig.ErrorWindowState.prototype.hidden = 1;
$.ig.ErrorWindowState.prototype.visible = 0;
$.ig.ErrorWindowState.prototype.hidden = 1;
$.ig.PageContainerState.prototype.empty = 0;
$.ig.PageContainerState.prototype.loding = 1;
$.ig.PageContainerState.prototype.loaded = 2;
$.ig.PageContainerState.prototype.canceled = 3;
$.ig.PageContainerState.prototype.empty = 0;
$.ig.PageContainerState.prototype.loding = 1;
$.ig.PageContainerState.prototype.loaded = 2;
$.ig.PageContainerState.prototype.canceled = 3;
$.ig.ProcessingState.prototype.idle = 0;
$.ig.ProcessingState.prototype.requested = 1;
$.ig.ProcessingState.prototype.downloading = 2;
$.ig.ProcessingState.prototype.started = 3;
$.ig.ProcessingState.prototype.processing = 4;
$.ig.ProcessingState.prototype.completed = 5;
$.ig.ProcessingState.prototype.canceling = 6;
$.ig.ProcessingState.prototype.repaginating = 7;
$.ig.ProcessingState.prototype.idle = 0;
$.ig.ProcessingState.prototype.requested = 1;
$.ig.ProcessingState.prototype.downloading = 2;
$.ig.ProcessingState.prototype.started = 3;
$.ig.ProcessingState.prototype.processing = 4;
$.ig.ProcessingState.prototype.completed = 5;
$.ig.ProcessingState.prototype.canceling = 6;
$.ig.ProcessingState.prototype.repaginating = 7;
$.ig.PrintingState.prototype.idle = 0;
$.ig.PrintingState.prototype.preparingStarted = 1;
$.ig.PrintingState.prototype.preparingFinished = 2;
$.ig.PrintingState.prototype.started = 3;
$.ig.PrintingState.prototype.finished = 4;
$.ig.PrintingState.prototype.canceling = 5;
$.ig.PrintingState.prototype.idle = 0;
$.ig.PrintingState.prototype.preparingStarted = 1;
$.ig.PrintingState.prototype.preparingFinished = 2;
$.ig.PrintingState.prototype.started = 3;
$.ig.PrintingState.prototype.finished = 4;
$.ig.PrintingState.prototype.canceling = 5;
$.ig.ViewerRenderSettingsState.prototype.empty = 0;
$.ig.ViewerRenderSettingsState.prototype.invalid = 1;
$.ig.ViewerRenderSettingsState.prototype.valid = 2;
$.ig.ViewerRenderSettingsState.prototype.changing = 3;
$.ig.ViewerRenderSettingsState.prototype.empty = 0;
$.ig.ViewerRenderSettingsState.prototype.invalid = 1;
$.ig.ViewerRenderSettingsState.prototype.valid = 2;
$.ig.ViewerRenderSettingsState.prototype.changing = 3;
$.ig.ViewerVisualState.prototype.inDesignMode = 0;
$.ig.ViewerVisualState.prototype.nonVisualReady = 1;
$.ig.ViewerVisualState.prototype.visualReady = 2;
$.ig.ViewerVisualState.prototype.disposed = 3;
$.ig.ViewerVisualState.prototype.inDesignMode = 0;
$.ig.ViewerVisualState.prototype.nonVisualReady = 1;
$.ig.ViewerVisualState.prototype.visualReady = 2;
$.ig.ViewerVisualState.prototype.disposed = 3;
$.ig.ParametersState.prototype.empty = 0;
$.ig.ParametersState.prototype.loading = 1;
$.ig.ParametersState.prototype.loaded = 2;
$.ig.ParametersState.prototype.ready = 3;
$.ig.ParametersState.prototype.empty = 0;
$.ig.ParametersState.prototype.loading = 1;
$.ig.ParametersState.prototype.loaded = 2;
$.ig.ParametersState.prototype.ready = 3;
$.ig.ViewerStateMachine.prototype.availableExportFormats = (function () { var $ret = new Array();
$ret.add("PDF");
$ret.add("XPS");
$ret.add("XLS");
$ret.add("XLSX"); return $ret;}());

$.ig.RecomputeObj = Class.extend({
    _recompute: false,

    init: function (newRecompute) {
        this._recompute = newRecompute;
    },

    getRecompute: function () {
        return this._recompute;
    },

    setRecompute: function (newRecompute) {
        this._recompute = newRecompute;
    }
});

$.ig.Range = Class.extend({
    _from: null,
    _to: null,

    init: function (from, to) {
        this._from = from;
        this._to = to;
    },

    size: function () {
        return this._to - this._from + 1;
    },

    toString: function () {
        return this._from + "-" + this._to;
    },

    getFrom: function () {
        return this._from;
    },

    setFrom: function (newFrom) {
        this._from = newFrom;
    },

    getTo: function () {
        return this._to;
    },

    setTo: function (newTo) {
        this._to = newTo;
    }
});

$.ig.SerializedReportDataSource = Class.extend({
    _serializedReportDataSourceId: null,
    _serializedReportDataSourceXml: null,

    init: function (serializedReportDataSourceId, serializedReportDataSourceXml) {
        this._serializedReportDataSourceId = serializedReportDataSourceId;
        this._serializedReportDataSourceXml = serializedReportDataSourceXml;
    },

    getSerializedReportDataSourceId: function () {
        return this._serializedReportDataSourceId;
    },

    getSerializedReportDataSourceXml: function () {
        return this._serializedReportDataSourceXml;
    }
});

$.ig.PageRangeData = Class.extend({
    _pageXmlString: null,
    _pageNumber: null,
    _requiresPostProcessing: false,
    _serializedReportDataSources: null,
    _fromCache: false,

    init: function (pageXmlString, pageNumber, requiresPostProcessing) {
        this._pageXmlString = pageXmlString;
        this._pageNumber = pageNumber;
        this._requiresPostProcessing = requiresPostProcessing;
        this._serializedReportDataSources = new Array();
    },

    getPageXml: function () {
        return this._pageXmlString;
    },

    getPageNumber: function () {
        return this._pageNumber;
    },

    getRequiresPostProcessing: function () {
        return this._requiresPostProcessing;
    },

    addSerializedReportDataSource: function (serializedDataSource) {
        this._serializedReportDataSources.add(serializedDataSource);
    },

    getSerializedReportDataSources: function () {
        return this._serializedReportDataSources;
    },

    setRetrievedFromCache: function (fromCache) {
        this._fromCache = fromCache;
    },

    getRetrievedFromCache: function () {
        return this._fromCache;
    }
});


// Report processor Javascript adapter.
$.ig.ReportProcessorJsAdapter = Class.extend({
    _reportDefinition: null,
    _selectedParameterValues: null,
    _processingCompleted: null,
    _pageCountTimerId: null,
    _isCanceled: false,
    _reportData: null,
    _cacheSize: 50,
    _cache: null,
    _lastRequestedPage: 0,
    _lastReturnedPage: 0,
    _prefetchingRangeSize: 7,
    _requestedRanges: null,

    // Callbacks.
    _processReportCallback: null,
    _getPageCallback: null,
    _pageCountCallback: null,
    _exportReportCallback: null,
    _cancelCallback: null,
    _printReportCallback: null,

    // Events. (as callbacks)
    processReportStarted: null,
    processReportCompleted: null,
    cancelProcessingCompleted: null,
    pageAvailable: null,

    init: function (reportUri, reportServiceUrl, systemDpi) {
        this._reportUri = reportUri;
        this._reportServiceUrl = reportServiceUrl;
        this._systemDpi = systemDpi;
        this._reportServiceProxy = new $.ig.ReportServiceProxy(reportServiceUrl, true);
        this._cache = new $.ig.Cache(this._cacheSize);
        this._requestedRanges = new Array();
    },

    setReportServiceProxy: function (reportServiceProxy) {
        this._reportServiceProxy = reportServiceProxy;
    },

    setPagesCacheSize: function (cacheSize) {
        this._cacheSize = cacheSize;
        this._cache = new $.ig.Cache(this._cacheSize);
    },

    createSessionForReportSuccess: function (that, result) {
        if (!result) {
            return;
        }

        that._reportData = result;

        if (that._isCanceled) {
            that._reportServiceProxy.cancel(that._reportData.Token, true, function (cancelResult) { that.cancelSuccess(that, cancelResult); }, function (cancelError) { that.cancelError(that, cancelError); });

            return;
        }

        that._reportDefinition = result.ReportDefinition;
        that.raiseProcessReportStarted(that, null);
        that._pageCountTimerId = setInterval(function () { that.pageCountTimerTick(that); }, 1000);
        that._reportServiceProxy.processReport(that._reportData.Token, that._selectedParameterValues, function (callbackResult) { that.processReportSuccess(that, callbackResult); }, function (error) { that.processReportError(that, error); });
    },

    createSessionForReportError: function (that, error) {
        that._processReportCallback.asyncErrorCallback()(error);
        that.raiseProcessReportStarted(that, error);
    },

    processReportSuccess: function (that, result) {
        that.removeInvalidPagesFromCache();
        that.stopGetPageCountTimer(that);
        that._processingCompleted = true;

        var pageCount = result;

        if (pageCount > 0 && that.pageAvailable) {
            that.pageAvailable(new $.ig.PageAvailableEventArgs(pageCount, null));
        }

        that.raiseProcessReportCompleted(that, null);
        that._processReportCallback.resultCallback()(result);
    },

    processReportError: function (that, error) {
        that.removeInvalidPagesFromCache();
        that.stopGetPageCountTimer(that);
        that._processingCompleted = true;
        that.raiseProcessReportCompleted(that, error);
        that._processReportCallback.asyncErrorCallback()(error);
    },

    getReportDefinition: function () {
        if (!this._reportData) {
            return null;
        }

        return this._reportData.ReportDefinition;
    },

    getToken: function () {
        if (!this._reportData) {
            return null;
        }

        return this._reportData.Token;
    },

    getPageSuccess: function (that, result) {
        if (!result) {
            return;
        }

        var reportPageDataXml = that.buildReportPageData(result);

        that._getPageCallback.resultCallback()(reportPageDataXml);
    },

    getPageError: function (that, error) {
        that._getPageCallback.asyncErrorCallback()(error);
    },

    getPageRangeError: function (that, error) {
        that._getPageCallback.asyncErrorCallback()(error);
    },

    pageCountSuccess: function (that, result) {
        that._pageCountCallback.resultCallback()(result);
    },

    pageCountError: function (that, error) {
        that._pageCountCallback.asyncErrorCallback()(error);
    },

    exportReportSuccess: function (that, result) {
        that._exportReportCallback.resultCallback()(result);
    },

    exportReportError: function (that, error) {
        that._exportReportCallback.asyncErrorCallback()(error);
    },

    printReportSuccess: function (that, result) {
        that._printReportCallback.resultCallback()(result);
    },

    printReportError: function (that, error) {
        that._printReportCallback.asyncErrorCallback()(error);
    },

    cancelExportSuccess: function (that, result) {
        that._cancelExportCallback.resultCallback()(result);
    },

    cancelExportError: function (that, error) {
        that._cancelExportCallback.asyncErrorCallback()(error);
    },

    cancelPrintSuccess: function (that, result) {
        that._cancelPrintCallback.resultCallback()(result);
    },

    cancelPrintError: function (that, error) {
        that._cancelPrintCallback.asyncErrorCallback()(error);
    },

    cancelSuccess: function (that, result) {
        that._cancelCallback.resultCallback()(result);
    },

    cancelError: function (that, error) {
        that._cancelCallback.asyncErrorCallback()(error);
    },

    processReport: function (selectedParameterValues, callback) {
        this.removeAllPagesFromCache();

        var reportSource = { ReportUri: this._reportUri };
        var that = this;

        this._processingCompleted = false;

        var settings = [{ Key: 'systemDpi', Value: this._systemDpi}];

        if (selectedParameterValues) {
            function pad(n) {
                return n < 10 ? '0' + n : n;
            };

            for (var parameterKey in selectedParameterValues) {
                if (selectedParameterValues.hasOwnProperty(parameterKey)) {
                    var parameterValue = selectedParameterValues[parameterKey].Value;

                    if (parameterValue && Object.prototype.toString.call(parameterValue) === '[object Date]') {                        
                        selectedParameterValues[parameterKey].Value = parameterValue.getFullYear() + '-' + pad(parameterValue.getMonth() + 1) + '-' + pad(parameterValue.getDate()) + 'T' + pad(parameterValue.getHours()) + ':' + pad(parameterValue.getMinutes()) + ':' + pad(parameterValue.getSeconds());
                    }
                }
            }
        }

        this._selectedParameterValues = selectedParameterValues;
        this._processReportCallback = callback;
        this._reportServiceProxy.createSessionForReport(reportSource, settings, function (result) { that.createSessionForReportSuccess(that, result); }, function (error) { that.createSessionForReportError(that, error); });
    },

    getPage: function (pageNumber, callback) {
        if (!this._reportData) {
            return;
        }

        this._lastRequestedPage = pageNumber;

        var cachedPage = this._cache.tryGet(pageNumber);

        if (this._lastRequestedPage != this._lastReturnedPage && cachedPage) {
            this._lastReturnedPage = this._lastRequestedPage;
        }

        if (cachedPage) {
            cachedPage.setRetrievedFromCache(true);
            callback.resultCallback()(cachedPage);

            return;
        }

        var range = this.computePrefetchingRange(pageNumber);
        var existsRange = false;

        $.each(this._requestedRanges, function () {
            if (this.getFrom() <= pageNumber && pageNumber <= this.getTo()) {
                existsRange = true;

                return;
            }
        });

        if (existsRange) {
            return;
        }

        this._requestedRanges.add(range);

        var that = this;

        this._getPageCallback = callback;
        this._reportServiceProxy.getPageRange(this._reportData.Token, range.toString(),
            function (result) {
                var pageToNotify = null;

                that._requestedRanges.removeItem(range);

                var reportPageRange = that.buildReportPageRangeData(result);

                $.each(reportPageRange, function () {
                    if (!that._processingCompleted || !this.getRequiresPostProcessing()) {
                        that._cache.set(this.getPageNumber(), this);
                    }

                    if (this.getPageNumber() == that._lastRequestedPage && that._lastRequestedPage != that._lastReturnedPage) {
                        that._lastReturnedPage = that._lastRequestedPage;
                        pageToNotify = this;
                    }
                });

                if (pageToNotify != null) {
                    callback.resultCallback()(pageToNotify);
                }
            },

            function (error) { that.getPageRangeError(that, error); },
            this._processingCompleted);
    },

    pageCount: function (callback) {
        if (!this._reportData) {
            return;
        }

        var that = this;

        this._pageCountCallback = callback;
        this._reportServiceProxy.pageCount(this._reportData.Token, function (result) { that.pageCountSuccess(that, result); }, function (error) { that.pageCountError(that, error); });
    },

    exportReport: function (format, callback) {
        if (!this._reportData) {
            return;
        }

        var that = this;

        this._exportReportCallback = callback;
        // pass true on 3rd parameter to generate PDF for printing
        this._reportServiceProxy.exportReport(this._reportData.Token, format, false, function (result) { that.exportReportSuccess(that, result); }, function (error) { that.exportReportError(that, error); });
    },

    printReport: function (callback) {
        if (!this._reportData) {
            return;
        }

        var that = this;

        this._printReportCallback = callback;
        // pass true on 3rd parameter to generate PDF for printing
        this._reportServiceProxy.exportReport(this._reportData.Token, 'PDF', true, function (result) { that.printReportSuccess(that, result); }, function (error) { that.printReportError(that, error); });
    },

    cancelExport: function (callback) {
        if (!this._reportData) {
            return;
        }

        var that = this;

        this._cancelExportCallback = callback;
        this._reportServiceProxy.cancelExport(this._reportData.Token, function (result) { that.cancelExportSuccess(that, result); }, function (error) { that.cancelExportError(that, error); });
    },

    cancelPrint: function (callback) {
        if (!this._reportData) {
            return;
        }

        var that = this;

        this._cancelPrintCallback = callback;
        this._reportServiceProxy.cancelExport(this._reportData.Token, function (result) { that.cancelPrintSuccess(that, result); }, function (error) { that.cancelPrintError(that, error); });
    },

    cancelProcessing: function (cleanReportResources, callback) {
        this._cancelCallback = callback;
        this._cache.reset();

        if (!this._reportData) {
            this._isCanceled = true;

            return;
        }

        var that = this;

        this.stopGetPageCountTimer(this);
        this._reportServiceProxy.cancel(this._reportData.Token, cleanReportResources, function (result) { that.cancelSuccess(that, result); }, function (error) { that.cancelError(that, error); });
    },

    hasEndedProcessing: function () {
        return this._processingCompleted;
    },

    raiseProcessReportStarted: function (that, error) {
        if (that.processReportStarted) {
            that.processReportStarted(new $.ig.ReportProcessorEventArgs(error));
        }
    },

    raiseProcessReportCompleted: function (that, error) {
        if (that.processReportCompleted) {
            that.processReportCompleted(new $.ig.ReportProcessorEventArgs(error));
        }
    },

    raiseCancelProcessingCompleted: function (that, error) {
        if (that.cancelProcessingCompleted) {
            that.cancelProcessingCompleted(new $.ig.ReportProcessorEventArgs(error));
        }
    },

    raisePageAvailable: function (that, pageNumber, error) {
        if (that.pageAvailable && !that._processingCompleted) {
            that.pageAvailable(new $.ig.PageAvailableEventArgs(pageNumber, error));
        }
    },

    pageCountTimerTick: function (that) {
        var callback = new $.ig.AsyncReportProcessorAction();

        callback.resultCallback(function (pageCount) {
            that.raisePageAvailable(that, pageCount, null);
        });

        callback.asyncErrorCallback(function (error) {
            that.raiseCancelProcessingCompleted(that, error);
        });

        that.pageCount(callback);
    },

    stopGetPageCountTimer: function (that) {
        if (that._pageCountTimerId) {
            clearTimeout(that._pageCountTimerId);
            that._pageCountTimerId = null;
        }
    },

    computePrefetchingRange: function (pageNumber) {
        var result = new $.ig.Range(pageNumber, pageNumber);
        var recomputeObjFrom = new $.ig.RecomputeObj(true);
        var recomputeObjTo = new $.ig.RecomputeObj(true);

        while ((recomputeObjFrom.getRecompute() || recomputeObjTo.getRecompute()) && result.size() <= this._prefetchingRangeSize) {
            this.tryToExtendRange(result.getFrom() - 1, function (newValue) { result.setFrom(newValue); }, recomputeObjFrom);
            this.tryToExtendRange(result.getTo() + 1, function (newValue) { result.setTo(newValue); }, recomputeObjTo);
        }

        return result;
    },

    tryToExtendRange: function (position, action, recomputeObj) {
        var dummyPage = this._cache.tryGet(position);

        if (recomputeObj.getRecompute() && position >= 1 && !dummyPage) {
            action(position);
        }
        else {
            recomputeObj.setRecompute(false);
        }
    },

    buildReportPageRangeData: function (reportPageRange) {
        var reportPageRanges = new Array();

        // For each page in the retrieved range...
        for (var i = 0; i < reportPageRange.Pages.length; i++) {
            var pageXmlString = reportPageRange.Pages[i];
            var pageXml = $.ig.XmlDocumentParser.prototype.parse(pageXmlString);

            // Find chart series nodes. (Which uses serialized report data sources)
            var rootItem = pageXml.documentElement;
            var pageRangeData = new $.ig.PageRangeData(pageXmlString, parseInt(rootItem.getAttribute('PageNumber')), rootItem.getAttribute('RequiresPostProcessing') != null);
            var chartNodes = rootItem.getElementsByTagName('Chart');
            var reportDataSourceIds = new Array();

            $.each(chartNodes, function () {
                // Get Data Requirements.
                var dataRequirementsPropertiesAttr = this.getAttribute('_DataRequirementsProperties');

                if (dataRequirementsPropertiesAttr) {
                    var dataRequirements = dataRequirementsPropertiesAttr.split('#');

                    // Here we only need the Serialized Report Data Source Id.
                    $.each(dataRequirements, function () {
                        var reportDataSourceId = this.split(';')[0];

                        // Check not to add the same data source twice.
                        if (reportDataSourceId != '' && !reportDataSourceIds.contains(reportDataSourceId)) {
                            reportDataSourceIds.add(reportDataSourceId);
                        }
                    });
                }
            });

            // Append found serialized report data sources...
            $.each(reportDataSourceIds, function () {
                var reportDataSourceId = this;

                $.each(reportPageRange.SerializedReportDataSources, function () {
                    if (this.ReportDataSourceId == reportDataSourceId) {
                        var serializedReportDataSource = new $.ig.SerializedReportDataSource(this.ReportDataSourceId, this.ReportDataSource);

                        pageRangeData.addSerializedReportDataSource(serializedReportDataSource);
                    }
                });
            });

            reportPageRanges.add(pageRangeData);
        }

        return reportPageRanges;
    },

    removeAllPagesFromCache: function () {
        this._cache.reset();
        this._requestedRanges.clear();
        this._lastRequestedPage = 0;
    },

    removeInvalidPagesFromCache: function () {
        var pages = this._cache.values();

        pages = $.grep(pages, function (page) {
            return page.getRequiresPostProcessing() === true;
        });

        var that = this;

        $.each(pages, function () {
            that._cache.remove(this.getPageNumber());

            if (this.getPageNumber() != that._lastReturnedPage) {
                return true;
            }

            that._lastReturnedPage = 0;
        });
    }
});

$.ig.ReportServiceProxyLocale = $.ig.ReportServiceProxyLocale || {};

$.ig.ReportServiceProxy = Class.extend({
    _baseURL: null,
    _async: null,

    init: function (reportServerUrl, async) {
        this._baseURL = reportServerUrl;
        this._async = async;
    },

    // Given a report path, creates a new processing session for the report to be generated.
    createSessionForReport: function (reportSource, settings, success, error) {        
        var jsonReportSource = JSON.stringify({ reportSource: reportSource, settings: settings });

        this._doAjaxPost("CreateSessionForReport", jsonReportSource, success, error, true);
    },

    // Processes the report.
    processReport: function (token, selectedParameterValues, success, error) {
        var jsonProcessReportParams = JSON.stringify({ token: token, selectedParameterValues: selectedParameterValues, pageSettingsData: null });

        this._doAjaxPost("ProcessReport", jsonProcessReportParams, success, error);
    },

    // Returns a page range.
    getPageRange: function (token, range, success, error, processingCompleted) {
        var jsonGetPageParams = JSON.stringify({ token: token, range: range });

        this._doAjaxPost("GetPageRange", jsonGetPageParams, success, error, !processingCompleted);
    },

    // Returns the current page count for report being generated. 
    pageCount: function (token, success, error) {
        var jsonToken = JSON.stringify({ token: token });

        this._doAjaxPost("PageCount", jsonToken, success, error, true);
    },

    // exports the report to the selected format. 
    exportReport: function (token, format, printOnOpen, success, error) {
        var jsonToken = JSON.stringify({ token: token, format: format, printOnOpen: printOnOpen });

        this._doAjaxPost("Export", jsonToken, success, error);
    },

    // Interrupts current export operation. 
    cancelExport: function (token, success, error) {
        var jsonToken = JSON.stringify({ token: token });

        this._doAjaxPost("CancelExport", jsonToken, success, error, true);
    },

    // Interrupts current report execution.
    cancel: function (token, cleanReportResources, success, error) {
        var jsonCancelParams = JSON.stringify({ token: token, cleanReportResources: cleanReportResources });

        this._doAjaxPost("Cancel", jsonCancelParams, success, error, true);
    },

    buildError: function (ajaxError) {
        var igError = new $.ig.Error();

        if (ajaxError.status == 404) {
            igError.message($.ig.ReportServiceProxyLocale.locale.serverConnectionErrorMsg);
        }
        else if (ajaxError.responseText && ajaxError.responseText !== '') {
            try {
                var reportServerErrorObj = $.parseJSON(ajaxError.responseText);
                
                igError.message(reportServerErrorObj.Message);
                igError.exceptionDetail(reportServerErrorObj.Detail);
                igError.engineErrorsList(reportServerErrorObj.EngineErrorsList);

            } catch (e) {                
                igError.message($.ig.ReportServiceProxyLocale.locale.unknownReportServerErrorMsg);
            }
        }
        else {
            igError.message($.ig.ReportServiceProxyLocale.locale.unknownReportServerErrorMsg);
            igError.exceptionDetail(ajaxError.statusText);
        }

        return igError;
    },
    
    _doAjaxPost: function (method, data, fnSuccess, fnError, disableCache) {
        if (!data) data = {};

        var that = this;

        $.ajax({
            type: "POST",
            url: this._baseURL + method,
            async: this._async,
            data: data,
            contentType: "application/json; charset=utf-8",
            headers: disableCache ? { "cache-control": "no-cache" } : {},
            dataType: "json",
            success: fnSuccess,
            error: function (xhr) {
                var wrappedError = that.buildError(xhr);

                fnError(wrappedError);
            },
            dataFilter: function (data) {
                return data.replace(/^\{"d":(.*)\}$/, "$1");
            },
            beforeSend: function (request) {
                request.setRequestHeader('IgReportProcessorService', true);
            }
        });
    }
});

$.ig.CacheItem = Class.extend ({
    _key: null,
    _item: null,
    _timeStamp: null,

    init : function () {
        this._key = null;
        this._item = null;
        this._timeStamp = null;
    },

    setKey: function (keyToSet) {
        this._key = keyToSet;
    },

    getKey: function () {
        return this._key;
    },

    setItem: function (itemToSet) {
        this._item = itemToSet;
    },

    getItem: function () {
        return this._item;
    },

    setTimeStamp: function (timeStampToSet) {
        this._timeStamp = timeStampToSet;
    },

    getTimeStamp: function () {
        return this._timeStamp;
    },

    renew: function () {
        this._timeStamp = new Date();
    }
});

$.ig.Cache = Class.extend({
    _cacheSize: 0,
    _cache: null,

    init: function (cacheSize) {
        this._cacheSize = cacheSize;
        this._cache = new Array();
    },

    reset: function () {
        this._cache.clear();
    },

    remove: function (key) {
        delete this._cache[key];
    },

    tryGet: function (key) {
        var cacheItem = this._cache[key];

        if (cacheItem) {
            cacheItem.renew();

            return cacheItem.getItem();
        }

        return null;
    },

    set: function (key, item) {
        if (this._cacheSize > 0 && this.size() >= this._cacheSize) {
            var minTimestamp = null;
            var keyToRemove = null;

            for (var cacheKey in this._cache) {
                if (this._cache.hasOwnProperty(cacheKey)) {
                    if (minTimestamp == null || this._cache[cacheKey] < minTimestamp) {
                        minTimestamp = this._cache[cacheKey].getTimeStamp();
                        keyToRemove = cacheKey;
                    }
                }
            }

            if (keyToRemove != null) {
                delete this._cache[keyToRemove];
            }
        }

        var cacheItem = new $.ig.CacheItem();

        cacheItem.setKey(key);
        cacheItem.setItem(item);
        cacheItem.setTimeStamp(new Date());

        this._cache[key] = cacheItem;
    },

    size: function () {
        var size = 0;

        for (var key in this._cache) {
            if (this._cache.hasOwnProperty(key)) size++;
        }

        return size;
    },

    values: function () {
        var values = [];

        for (var cacheKey in this._cache) {
            if (this._cache.hasOwnProperty(cacheKey)) {
                values.add(this._cache[cacheKey].getItem());
            }
        }

        return values;
    }
});


/*global jQuery */
if (typeof (jQuery) === 'undefined') {
    throw new Error('The Infragistics Report Viewer Error Control requires jQuery to be loaded');
}

(function($) {
    
    $.ui.igReportViewerErrorLocale = $.ui.igReportViewerErrorLocale || {};

     $.widget('ui.igReportViewerError', {
        css: {
            /* classes applied to the top container element */
            error: 'ui-widget ui-reportviewer-error'
        },
         
         options: {
            /* type="string|number|null"
            string The widget width can be set in pixels (px) and percentage (%).
            number The widget width can be set as a number in pixels.
            null type="object" will stretch to fit data, if no other widths are defined.
            */
            width: null,

            /* type="string|number|null"
            string The height width can be set in pixels (px) and percentage (%).
            number The height width can be set as a number in pixels.
            null type="object" will fit the tree inside its parent container, if no other widths are defined.
            */
            height: null,
             
            /*
            The error object.
            */
            errorObj: null
         },
         
         widget: function () {
             return this.element;
         },

         destroy: function () {
             this._mainDiv.remove();
             
             return this;
        },
         
         _createWidget: function (options, element) {
            /* !Strip dummy objects from options, because they are defined for documentation purposes only! */
            this.options.bindings = null;
            $.Widget.prototype._createWidget.apply(this, arguments);
        },

        _create: function () {
            this._provideContainer(this.element);

            var opt = this.options;

            this.element.addClass(this.css.reportViewer);

            if ($.ig.util.isIE && $.ig.util.isIE7 && this.element.css('position') === 'static') {
                this.element.css('position', 'relative');
            }

            if (opt.width) {
                this.element.css('width', opt.width);
            }

            if (opt.height) {
                this.element.css('height', opt.height);
            }
            
            if (opt.errorObj) {
                this._errorObj = opt.errorObj;
            }                       
        },
         
        _setOption: function (option, value) {
             switch (option) {
                 case 'width':
                     this.element.css('width', value);
                     break;
                 case 'height':
                     this.element.css('height', value);
                     break;
                 case 'errorObj':                 
                     this.options.errorObj = value;
                     this._mainDiv.toggle(true);
                     this._detailsDiv.toggle(false);
                     this._detailsDivVisible = false;
                     this._mainDiv.find('.buttonShowDetails').text($.ui.igReportViewerErrorLocale.locale.showDetails).button();
                     this._setErrorMessage(value);              
                     this._setErrorDetail(value);
                     break;
             }

             $.Widget.prototype._setOption.apply(this, arguments);
         },
         
         _onShowDetailsButtonPressed: function (event) {             
             event.preventDefault();             
                    
             if (this._detailsDivVisible) {                   
                 this._mainDiv.find('.buttonShowDetails').button('option', 'label', $.ui.igReportViewerErrorLocale.locale.showDetails);
             }
             else {
                 this._mainDiv.find('.buttonShowDetails').button('option', 'label', $.ui.igReportViewerErrorLocale.locale.hideDetails);
             }
             
             this._detailsDiv.toggle();
             this._detailsDivVisible = !this._detailsDivVisible;
             this.element.trigger('_detailsButtonPressed');
             this._adjustTopMargin();
         },                 

         _adjustTopMargin: function() {
             this._mainDiv.css('margin-top', -(this._mainDiv.height() / 2) +'px');
         },
         
         _onCloseButtonPressed: function (event) {
             event.preventDefault();
             
             this._mainDiv.toggle(false);
             this.element.trigger('_closeButtonPressed');
         },
         
         _buildDetail: function (errorObj) {
             var detail = '';                                      
             var that = this;
             
             if (errorObj.engineErrorsList()) {
                 $.each(errorObj.engineErrorsList(),
                     function() {
                         detail += that._buildEngineErrorDetail(this);
                     });   
             }             

             if (errorObj.exceptionDetail()) {
                 if (detail) {
                     detail += '\n\n';
                 }

                 detail += errorObj.exceptionDetail();
             }
             
             return detail;
         },
         
         _buildEngineErrorDetail: function(engineError) {
             var detail = '';
             
             if (engineError.ChildErrors) {
                 $.each(engineError.ChildErrors,
                     function() {
                         detail += this.Message + '\n';
                     });
             }

             return detail;
         },
                  
         _setErrorMessage: function(value) {
            var errorMessageText = this._mainDiv.find('.labelErrorMessage');
            errorMessageText.text(value.message());
              
            if (!Modernizr.touch) {
                var lineHeight = parseInt(errorMessageText.css('line-height'));
                errorMessageText.css('max-height', lineHeight * 2 + 'px');
            }
         },

         _setErrorDetail: function(errorObj) {
             var errorDetail = this._buildDetail(errorObj);                     
                    
             if (errorDetail == '') {
                 this._mainDiv.find('.buttonShowDetails').button("option", "disabled",  true);
             }
             else {
                 this._detailsDiv.text(errorDetail);
             }            
         },
         
         _provideContainer: function (container) {
             var UI_CONSTANTS = {
                 ERROR_CSS_CLASSES: this.css.error + " ui-reportviewer-error-background",
                 ERROR_ICON_CSS_CLASS: "ui-reportviewer-error-icon",
                 ERROR_ROW_CSS_CLASS: "ui-reportviewer-error-row",
                 ERROR_CELL_CSS_CLASS: "ui-reportviewer-error-cell",
                 ERROR_BUTTON_CSS_CLASS: "ui-reportviewer-error-button",
                 ERROR_DETAIL_CSS_CLASS: "ui-reportviewer-error-detail ui-widget-content",
                 ERROR_MESSAGE_CSS_CLASS: "ui-reportviewer-error-message"
             };

             var errorHtmlTemplate = '<div class="' + UI_CONSTANTS.ERROR_CSS_CLASSES + '">';
             
             errorHtmlTemplate += '   <div class="ui-state-error ui-corner-all ' + UI_CONSTANTS.ERROR_ROW_CSS_CLASS + '">';    
             errorHtmlTemplate += '      <span class="' + UI_CONSTANTS.ERROR_ICON_CSS_CLASS + ' ui-icon ui-icon-alert"></span>';
             errorHtmlTemplate += '      <p class="labelErrorMessage ' + UI_CONSTANTS.ERROR_MESSAGE_CSS_CLASS + '"></p>';
             errorHtmlTemplate += '      <div class="' + UI_CONSTANTS.ERROR_CELL_CSS_CLASS + '"><button class="buttonClose ' + UI_CONSTANTS.ERROR_BUTTON_CSS_CLASS + '">' + $.ui.igReportViewerErrorLocale.locale.close + '</button><button class="buttonShowDetails ' + UI_CONSTANTS.ERROR_BUTTON_CSS_CLASS + '">' + $.ui.igReportViewerErrorLocale.locale.showDetails + '</button></div>';
             errorHtmlTemplate += '      <div class="detailsDiv ' + UI_CONSTANTS.ERROR_DETAIL_CSS_CLASS + '" />';
             errorHtmlTemplate += '   </div>';             
             errorHtmlTemplate += '</div>';             
             
             var mainDiv = $(errorHtmlTemplate);
             
             this._mainDiv = mainDiv;
             this._detailsDiv = mainDiv.find('.detailsDiv');
             this._detailsDiv.toggle(false);
             this._detailsDivVisible = false;
             
             container.append(this._mainDiv);
             
             mainDiv.find('.buttonShowDetails').click(this._onShowDetailsButtonPressed.runOn(this)).button();
             mainDiv.find('.buttonClose').click(this._onCloseButtonPressed.runOn(this)).button();
             
             var errorObj = this.options.errorObj;
             
             if (errorObj) {
                 this._setErrorMessage(this.options.errorObj);
                 this._setErrorDetail(this.options.errorObj);                 
            }
         }
     });
    
     $.ui.igReportViewerError = $.ui.igReportViewerError || {};
         
    $.extend($.ui.igReportViewerError, { version: '14.2.20142.1007' });          
}(jQuery));


(function ($) {
    /*!
    * jQuery UI Mouse 1.8.19
    * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
    * Dual licensed under the MIT or GPL Version 2 licenses.
    * http://jquery.org/license
    * http://docs.jquery.com/UI/Mouse
    */
    /* Modified to touchMouse to proxy touch events as mouse events and leave $.ui.mouse untouched.
    */

    var mouseHandled = false;
    $(document).mouseup(function (e) {
        mouseHandled = false;
    });

    $.widget("ui.touchMouse", {
        options: {
            cancel: 'input,textarea,button,select,option',
            distance: 1,
            delay: 0
        },
        _mouseInit: function () {
            var self = this;

            this.element
			.bind('mousedown.' + this.widgetName, function (event) {
			    return self._mouseDown(event);
			})
			.bind('click.' + this.widgetName, function (event) {
			    if (true === $.data(event.target, self.widgetName + '.preventClickEvent')) {
			        $.removeData(event.target, self.widgetName + '.preventClickEvent');
			        event.stopImmediatePropagation();
			        return false;
			    }
			});

            this.started = false;
        },

        // TODO: make sure destroying one instance of mouse doesn't mess with
        // other instances of mouse
        _mouseDestroy: function () {
            this.element.unbind('.' + this.widgetName);
            if (this._mouseMoveDelegate) {
                $(document)
                    .unbind('mousemove.' + this.widgetName, this._mouseMoveDelegate)
                    .unbind('mouseup.' + this.widgetName, this._mouseUpDelegate);
            }
        },

        _mouseDown: function (event) {
            // don't let more than one widget handle mouseStart
            if (mouseHandled) { return };

            // we may have missed mouseup (out of window)
            (this._mouseStarted && this._mouseUp(event));

            this._mouseDownEvent = event;

            var self = this,
			btnIsLeft = (event.which == 1),
            // event.target.nodeName works around a bug in IE 8 with
            // disabled inputs (#7620)
			elIsCancel = (typeof this.options.cancel == "string" && event.target.nodeName ? $(event.target).closest(this.options.cancel).length : false);
            if (!btnIsLeft || elIsCancel || !this._mouseCapture(event)) {
                return true;
            }

            this.mouseDelayMet = !this.options.delay;
            if (!this.mouseDelayMet) {
                this._mouseDelayTimer = setTimeout(function () {
                    self.mouseDelayMet = true;
                }, this.options.delay);
            }

            if (this._mouseDistanceMet(event) && this._mouseDelayMet(event)) {
                this._mouseStarted = (this._mouseStart(event) !== false);
                if (!this._mouseStarted) {
                    event.preventDefault();
                    return true;
                }
            }

            // Click event may never have fired (Gecko & Opera)
            if (true === $.data(event.target, this.widgetName + '.preventClickEvent')) {
                $.removeData(event.target, this.widgetName + '.preventClickEvent');
            }

            // these delegates are required to keep context
            this._mouseMoveDelegate = function (event) {
                if (Modernizr.touch) {
                    if (!self._simulatedMove) {
                        return;
                    }
                    self._simulatedMove = false;
                }

                return self._mouseMove(event);
            };
            this._mouseUpDelegate = function (event) {
                return self._mouseUp(event);
            };
            $(document)
			.bind('mousemove.' + this.widgetName, this._mouseMoveDelegate)
			.bind('mouseup.' + this.widgetName, this._mouseUpDelegate);

            event.preventDefault();

            mouseHandled = true;
            return true;
        },

        _mouseMove: function (event) {
            // IE mouseup check - mouseup happened when mouse was out of window
            if ($.ig.util.isIE && !(document.documentMode >= 9) && !event.button) {
                return this._mouseUp(event);
            }

            if (this._mouseStarted) {
                this._mouseDrag(event);
                return event.preventDefault();
            }

            if (this._mouseDistanceMet(event) && this._mouseDelayMet(event)) {
                this._mouseStarted =
				(this._mouseStart(this._mouseDownEvent, event) !== false);
                (this._mouseStarted ? this._mouseDrag(event) : this._mouseUp(event));
            }

            return !this._mouseStarted;
        },

        _mouseUp: function (event) {
            $(document)
			.unbind('mousemove.' + this.widgetName, this._mouseMoveDelegate)
			.unbind('mouseup.' + this.widgetName, this._mouseUpDelegate);

            if (this._mouseStarted) {
                this._mouseStarted = false;

                if (event.target == this._mouseDownEvent.target) {
                    $.data(event.target, this.widgetName + '.preventClickEvent', true);
                }

                this._mouseStop(event);
            }

            return false;
        },

        _mouseDistanceMet: function (event) {
            return (Math.max(
				Math.abs(this._mouseDownEvent.pageX - event.pageX),
				Math.abs(this._mouseDownEvent.pageY - event.pageY)
			) >= this.options.distance
		);
        },

        _mouseDelayMet: function (event) {
            return this.mouseDelayMet;
        },

        // These are placeholder methods, to be overriden by extending plugin
        _mouseStart: function (event) { },
        _mouseDrag: function (event) { },
        _mouseStop: function (event) { },
        _mouseCapture: function (event) { return true; }
    });

    /*!
    * jQuery UI Touch Punch 0.2.2
    * Copyright 2011, Dave Furfero
    * Dual licensed under the MIT or GPL Version 2 licenses.
    */
    /* Modified to subscribe to touchMouse to avoid tinkering with $.ui.mouse.
    */
    $.support.touch = 'ontouchend' in document;

    if ($.support.touch) {
        var mouseProto = $.ui.touchMouse.prototype,
      _mouseInit = mouseProto._mouseInit,
      touchHandled;

        /**
        * Simulate a mouse event based on a corresponding touch event
        * @param {Object} event A touch event
        * @param {String} simulatedType The corresponding mouse event
        */
        function simulateMouseEvent(event, simulatedType) {

            // Ignore multi-touch events
            if (event.originalEvent.touches.length > 1) {
                return;
            }

            event.preventDefault();

            var touch = event.originalEvent.changedTouches[0],
        simulatedEvent = document.createEvent('MouseEvents');

            // Initialize the simulated mouse event using the touch event's coordinates
            simulatedEvent.initMouseEvent(
      simulatedType,    // type
      true,             // bubbles                    
      true,             // cancelable                 
      window,           // view                       
      1,                // detail                     
      touch.screenX,    // screenX                    
      touch.screenY,    // screenY                    
      touch.clientX,    // clientX                    
      touch.clientY,    // clientY                    
      false,            // ctrlKey                    
      false,            // altKey                     
      false,            // shiftKey                   
      false,            // metaKey                    
      0,                // button                     
      null              // relatedTarget              
    );

            // Dispatch the simulated event to the target element
            event.target.dispatchEvent(simulatedEvent);
        }

        /**
        * Handle the jQuery UI widget's touchstart events
        * @param {Object} event The widget element's touchstart event
        */
        mouseProto._touchStart = function (event) {

            var self = this;

            // Ignore the event if another widget is already being handled
            if (touchHandled || !self._mouseCapture(event.originalEvent.changedTouches[0])) {
                return;
            }

            // Set the flag to prevent other widgets from inheriting the touch event
            touchHandled = true;

            // Track movement to determine if interaction was a click
            self._touchMoved = false;

            // Simulate the mouseover event
            simulateMouseEvent(event, 'mouseover');

            // Simulate the mousemove event
            simulateMouseEvent(event, 'mousemove');

            // Simulate the mousedown event
            simulateMouseEvent(event, 'mousedown');
        };

        /**
        * Handle the jQuery UI widget's touchmove events
        * @param {Object} event The document's touchmove event
        */
        mouseProto._touchMove = function (event) {

            // Ignore event if not handled
            if (!touchHandled) {
                return;
            }

            // Interaction was not a click
            this._touchMoved = true;
            this._simulatedMove = true;

            // Simulate the mousemove event
            simulateMouseEvent(event, 'mousemove');
        };

        /**
        * Handle the jQuery UI widget's touchend events
        * @param {Object} event The document's touchend event
        */
        mouseProto._touchEnd = function (event) {

            // Ignore event if not handled
            if (!touchHandled) {
                return;
            }

            // Simulate the mouseup event
            simulateMouseEvent(event, 'mouseup');

            // Simulate the mouseout event
            simulateMouseEvent(event, 'mouseout');

            // If the touch interaction did not move, it should trigger a click
            if (!this._touchMoved) {

                // Simulate the click event
                simulateMouseEvent(event, 'click');
            }

            // Unset the flag to allow other widgets to inherit the touch event
            touchHandled = false;
        };

        /**
        * A duck punch of the $.ui.mouse _mouseInit method to support touch events.
        * This method extends the widget with bound touch event handlers that
        * translate touch events to mouse events and pass them to the widget's
        * original mouse event handling methods.
        */
        mouseProto._mouseInit = function () {

            var self = this;

            // Delegate the touch handlers to the widget's element
            self.element
      .bind('touchstart', $.proxy(self, '_touchStart'))
      .bind('touchmove', $.proxy(self, '_touchMove'))
      .bind('touchend', $.proxy(self, '_touchEnd'));

            // Call the original $.ui.mouse init method
            _mouseInit.call(self);
        };
    }

    /*!
    * jQuery UI Slider 1.8.17
    * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
    * Dual licensed under the MIT or GPL Version 2 licenses.
    * http://jquery.org/license
    * http://docs.jquery.com/UI/Slider
    */
    /* Modified to use $.ui.touchMouse. Added ticks. Currently supports only one handle.
    */
    var numPages = 5;

    $.widget("ui.touchSlider", $.ui.touchMouse, {

        widgetEventPrefix: "slide",

        options: {
            animate: false,
            distance: 0,
            max: 100,
            min: 0,
            orientation: "horizontal",
            range: false,
            step: 1,
            ticks: false,
            roundTickLabels: false,
            value: 0,
            values: null,
            labelForPercentage: null,
            percentageForPageNumber: null
        },

        _labelForPercentage: function (percentage) {
            return percentage == 1 ? this.options.max : this.options.min + Math.round(this.options.max * percentage);
        },

        _percentageForPageNumber: function (page) {
            return page;
        },

        _addTicks: function (container, ticks, min, max, roundTickLabels) {
            var maxValue = max - min;
            var value = 0;
            var percent = 0;
            var increment = 1 / (ticks + 1);
            var tick;
            var self = this;
            var labelForPercentage = function (p) {
                return self._labelForPercentage(p);
            };
            var percentageForPageNumber = function (p) {
                return self._percentageForPageNumber(p);
            };
            var getRoundedValue = function (v) {
                return v;
            };

            if (roundTickLabels) {
                getRoundedValue = function (v) {
                    if (v <= 1) {
                        return 1;
                    }

                    var lastDigit = v % 5;

                    return lastDigit > 0 ? v - lastDigit : v;
                };
            }

            if (this.options.labelForPercentage) {
                labelForPercentage = this.options.labelForPercentage;
            }

            if (this.options.percentageForPageNumber) {
                percentageForPageNumber = this.options.percentageForPageNumber;
            }

            var width = this.element.find(".ui-touchSlider").width() / (ticks + 1);
            var measurer = $('<span class="ui-widget" style="visibility: hidden" />');
            measurer.appendTo($(document).find('.ui-touchSlider-measurer'));

            for (var s = 0; s < ticks + 2; s++) {
                var isNotLast = s + 1 < ticks + 2;
                tick = $('<li></li>');
                tick.appendTo(container);
                tick.css('width', width + 'px');
                var roundedValue = isNotLast ? getRoundedValue(labelForPercentage(percent)) : labelForPercentage(percent);
                var percentage = roundTickLabels ? percentageForPageNumber(roundedValue) : percent * 100;
                measurer.empty();
                measurer.append(roundedValue);
                var span = $('<span>' + roundedValue + '</span>');
                tick.append(span);
                span.css('margin-left', -(measurer.width() / 2) + 'px');
                span.css('width', measurer.width() + 'px');

                if (!isNotLast) {
                    tick.css('width', measurer.width() / 2 + 'px');
                }

                var clickEvent = function () {
                    var v = roundTickLabels ? roundedValue : percentage;
                    return function (event) {
                        event.preventDefault();

                        if (self.options.disabled) {
                            return;
                        }

                        self._slide(event, 0, v);
                        self._stop(event, 0);
                    };
                };

                span.click(clickEvent());

                percent += increment;
                value = percent * maxValue;
            }

            measurer.remove();
        },

        _setTicks: function (ticks, min, max, roundTickLabels) {
            if (ticks === false) {
                return;
            }

            ticks = +ticks;

            this.element.find(".ui-touchSlider").removeClass('ui-touchSlider-width');
            if (ticks >= 0) {
                $(this.element).find('.' + $.ui.igReportViewerConstants.definition.ui.touchSliderGridline).remove();
                this.element.find(".ui-touchSlider").addClass('ui-touchSlider-width');
                var ticksContainer = $('<ol></ol>')
					.appendTo(this.element)
					.addClass('ui-touchSlider-sliderGridline-structure ' + $.ui.igReportViewerConstants.definition.ui.touchSliderGridline + ' ui-widget ui-helper-clearfix');

                this._addTicks(ticksContainer, ticks, min, max, roundTickLabels);
            }
        },

        _create: function () {
            var self = this,
			o = this.options,
			existingHandles = this.element.find(".ui-touchSlider-handle").addClass("ui-state-default ui-corner-all"),
			handle = "<a class='ui-touchSlider-handle ui-state-default ui-corner-all' href='#'></a>",
			handleCount = (o.values && o.values.length) || 1,
			handles = [];

            var handleContainer = $('<div />');

            this._keySliding = false;
            this._mouseSliding = false;
            this._animateOff = true;
            this._handleIndex = null;
            this._detectOrientation();
            this._mouseInit();

            handleContainer
                .addClass("ui-touchSlider" +
                    " ui-touchSlider-" + this.orientation +
                    " ui-widget" +
                    " ui-widget-content" +
                    " ui-corner-all" +
                    (o.disabled ? " ui-touchSlider-disabled ui-disabled" : ""))
                .appendTo(this.element);

            this._setTicks(o.ticks, o.min, o.max, o.roundTickLabels);
            this.range = $([]);

            if (o.range) {
                if (o.range === true) {
                    if (!o.values) {
                        o.values = [this._valueMin(), this._valueMin()];
                    }
                    if (o.values.length && o.values.length !== 2) {
                        o.values = [o.values[0], o.values[0]];
                    }
                }

                this.range = $("<div></div>")
				.appendTo(this.element)
				.addClass("ui-touchSlider-range" +
                // note: this isn't the most fittingly semantic framework class for this element,
                // but worked best visually with a variety of themes
				" ui-widget-header" +
				((o.range === "min" || o.range === "max") ? " ui-touchSlider-range-" + o.range : ""));
            }

            for (var i = existingHandles.length; i < handleCount; i += 1) {
                handles.push(handle);
            }

            this.handles = existingHandles.add($(handles.join("")).appendTo(handleContainer));

            this.handle = this.handles.eq(0);

            this.handles.add(this.range).filter("a")
			.click(function (event) {
			    event.preventDefault();
			})
			.hover(function () {
			    if (!o.disabled) {
			        $(this).addClass("ui-state-hover");
			    }
			}, function () {
			    $(this).removeClass("ui-state-hover");
			})
			.focus(function () {
			    if (!o.disabled) {
			        $(".ui-touchSlider .ui-state-focus").removeClass("ui-state-focus");
			        $(this).addClass("ui-state-focus");
			    } else {
			        $(this).blur();
			    }
			})
			.blur(function () {
			    $(this).removeClass("ui-state-focus");
			});

            this.handles.each(function (i) {
                $(this).data("index.ui-touchSlider-handle", i);
            });

            this.handles
			.keydown(function (event) {
			    var ret = true,
					index = $(this).data("index.ui-touchSlider-handle"),
					allowed,
					curVal,
					newVal,
					step;

			    if (self.options.disabled) {
			        return;
			    }

			    switch (event.keyCode) {
			        case $.ui.keyCode.HOME:
			        case $.ui.keyCode.END:
			        case $.ui.keyCode.PAGE_UP:
			        case $.ui.keyCode.PAGE_DOWN:
			        case $.ui.keyCode.UP:
			        case $.ui.keyCode.RIGHT:
			        case $.ui.keyCode.DOWN:
			        case $.ui.keyCode.LEFT:
			            ret = false;
			            if (!self._keySliding) {
			                self._keySliding = true;
			                $(this).addClass("ui-state-active");
			                allowed = self._start(event, index);
			                if (allowed === false) {
			                    return;
			                }
			            }
			            break;
			    }

			    step = self.options.step;
			    if (self.options.values && self.options.values.length) {
			        curVal = newVal = self.values(index);
			    } else {
			        curVal = newVal = self.value();
			    }

			    switch (event.keyCode) {
			        case $.ui.keyCode.HOME:
			            newVal = self._valueMin();
			            break;
			        case $.ui.keyCode.END:
			            newVal = self._valueMax();
			            break;
			        case $.ui.keyCode.PAGE_UP:
			            newVal = self._trimAlignValue(curVal + ((self._valueMax() - self._valueMin()) / numPages));
			            break;
			        case $.ui.keyCode.PAGE_DOWN:
			            newVal = self._trimAlignValue(curVal - ((self._valueMax() - self._valueMin()) / numPages));
			            break;
			        case $.ui.keyCode.UP:
			        case $.ui.keyCode.RIGHT:
			            if (curVal === self._valueMax()) {
			                return;
			            }
			            newVal = self._trimAlignValue(curVal + step);
			            break;
			        case $.ui.keyCode.DOWN:
			        case $.ui.keyCode.LEFT:
			            if (curVal === self._valueMin()) {
			                return;
			            }
			            newVal = self._trimAlignValue(curVal - step);
			            break;
			    }

			    self._slide(event, index, newVal);

			    return ret;

			})
			.keyup(function (event) {
			    var index = $(this).data("index.ui-touchSlider-handle");

			    if (self._keySliding) {
			        self._keySliding = false;
			        self._stop(event, index);
			        self._change(event, index);
			        $(this).removeClass("ui-state-active");
			    }

			});

            this._refreshValue();

            this._animateOff = false;
        },

        destroy: function () {
            this.handles.remove();
            this.range.remove();

            $(this.element)
                .find('.touchSlider')
                .remove();

            $(this.element)
                .find('.' + $.ui.igReportViewerConstants.definition.ui.touchSliderGridline)
                .remove();

            $(this.element)
                .find('.ui-touchSlider')
                .remove();

            this.element
			.removeClass("ui-touchSlider" +
				" ui-touchSlider-horizontal" +
				" ui-touchSlider-vertical" +
				" ui-touchSlider-disabled" +
				" ui-widget" +
				" ui-widget-content" +
				" ui-corner-all")
			.removeData("touchSlider")
			.unbind(".touchSlider");

            this._mouseDestroy();

            return this;
        },

        _mouseCapture: function (event) {
            var o = this.options,
			position,
			normValue,
			distance,
			closestHandle,
			self,
			index,
			allowed,
			offset,
			mouseOverHandle;

            if (o.disabled) {
                return false;
            }

            if (event.target.tagName == 'SPAN') {
                return false;
            }

            this.elementSize = {
                width: this.element.outerWidth(),
                height: this.element.outerHeight()
            };
            this.elementOffset = this.element.offset();

            position = { x: event.pageX, y: event.pageY };
            normValue = this._normValueFromMouse(position);
            distance = this._valueMax() - this._valueMin() + 1;
            self = this;

            if (this.handles.length === 1) {
                index = 0;
                closestHandle = $(this.handles[index]);
            } else {
                this.handles.each(function (i) {
                    var thisDistance = Math.abs(normValue - self.values(i));
                    if (distance > thisDistance) {
                        distance = thisDistance;
                        closestHandle = $(this);
                        index = i;
                    }
                });
            }

            // workaround for bug #3736 (if both handles of a range are at 0,
            // the first is always used as the one with least distance,
            // and moving it is obviously prevented by preventing negative ranges)
            if (o.range === true && this.values(1) === o.min) {
                index += 1;
                closestHandle = $(this.handles[index]);
            }

            allowed = this._start(event, index);
            if (allowed === false) {
                return false;
            }
            this._mouseSliding = true;

            self._handleIndex = index;

            closestHandle
			.addClass("ui-state-active")
			.focus();

            offset = closestHandle.offset();
            mouseOverHandle = !$(event.target).parents().andSelf().is(".ui-touchSlider-handle");
            this._clickOffset = mouseOverHandle ? { left: 0, top: 0 } : {
                left: event.pageX - offset.left - (closestHandle.width() / 2),
                top: event.pageY - offset.top -
				(closestHandle.height() / 2) -
				(parseInt(closestHandle.css("borderTopWidth"), 10) || 0) -
				(parseInt(closestHandle.css("borderBottomWidth"), 10) || 0) +
				(parseInt(closestHandle.css("marginTop"), 10) || 0)
            };

            if (!this.handles.hasClass("ui-state-hover")) {
                this._slide(event, index, normValue);
            }
            this._animateOff = true;
            return true;
        },

        _mouseStart: function (event) {
            return true;
        },

        _mouseDrag: function (event) {
            var position = { x: event.pageX, y: event.pageY },
			normValue = this._normValueFromMouse(position);

            this._slide(event, this._handleIndex, normValue);

            return false;
        },

        _mouseStop: function (event) {
            this.handles.removeClass("ui-state-active");
            this._mouseSliding = false;

            this._stop(event, this._handleIndex);
            this._change(event, this._handleIndex);

            this._handleIndex = null;
            this._clickOffset = null;
            this._animateOff = false;

            return false;
        },

        _detectOrientation: function () {
            this.orientation = (this.options.orientation === "vertical") ? "vertical" : "horizontal";
        },

        _normValueFromMouse: function (position) {
            var pixelTotal,
			pixelMouse,
			percentMouse,
			valueTotal,
			valueMouse;

            if (this.orientation === "horizontal") {
                pixelTotal = this.elementSize.width;
                pixelMouse = position.x - this.elementOffset.left - (this._clickOffset ? this._clickOffset.left : 0);
            } else {
                pixelTotal = this.elementSize.height;
                pixelMouse = position.y - this.elementOffset.top - (this._clickOffset ? this._clickOffset.top : 0);
            }

            percentMouse = (pixelMouse / pixelTotal);
            if (percentMouse > 1) {
                percentMouse = 1;
            }
            if (percentMouse < 0) {
                percentMouse = 0;
            }
            if (this.orientation === "vertical") {
                percentMouse = 1 - percentMouse;
            }

            valueTotal = this._valueMax() - this._valueMin();
            valueMouse = this._valueMin() + percentMouse * valueTotal;

            return this._trimAlignValue(valueMouse);
        },

        _start: function (event, index) {
            var uiHash = {
                handle: this.handles[index],
                value: this.value()
            };
            if (this.options.values && this.options.values.length) {
                uiHash.value = this.values(index);
                uiHash.values = this.values();
            }
            return this._trigger("start", event, uiHash);
        },

        _slide: function (event, index, newVal) {
            var otherVal,
			newValues,
			allowed;

            if (this.options.values && this.options.values.length) {
                otherVal = this.values(index ? 0 : 1);

                if ((this.options.values.length === 2 && this.options.range === true) &&
					((index === 0 && newVal > otherVal) || (index === 1 && newVal < otherVal))
				) {
                    newVal = otherVal;
                }

                if (newVal !== this.values(index)) {
                    newValues = this.values();
                    newValues[index] = newVal;
                    // A slide can be canceled by returning false from the slide callback
                    allowed = this._trigger("slide", event, {
                        handle: this.handles[index],
                        value: newVal,
                        values: newValues
                    });
                    otherVal = this.values(index ? 0 : 1);
                    if (allowed !== false) {
                        this.values(index, newVal, true);
                    }
                }
            } else {
                if (newVal !== this.value()) {
                    // A slide can be canceled by returning false from the slide callback
                    allowed = this._trigger("slide", event, {
                        handle: this.handles[index],
                        value: newVal
                    });
                    if (allowed !== false) {
                        this.value(newVal);
                    }
                }
            }
        },

        _stop: function (event, index) {
            var uiHash = {
                handle: this.handles[index],
                value: this.value()
            };
            if (this.options.values && this.options.values.length) {
                uiHash.value = this.values(index);
                uiHash.values = this.values();
            }

            this._trigger("stop", event, uiHash);
        },

        _change: function (event, index) {
            if (!this._keySliding && !this._mouseSliding) {
                var uiHash = {
                    handle: this.handles[index],
                    value: this.value()
                };
                if (this.options.values && this.options.values.length) {
                    uiHash.value = this.values(index);
                    uiHash.values = this.values();
                }

                this._trigger("change", event, uiHash);
            }
        },

        value: function (newValue) {
            if (arguments.length) {
                this.options.value = this._trimAlignValue(newValue);
                this._refreshValue();
                this._change(null, 0);
                return;
            }

            return this._value();
        },

        values: function (index, newValue) {
            var vals,
			newValues,
			i;

            if (arguments.length > 1) {
                this.options.values[index] = this._trimAlignValue(newValue);
                this._refreshValue();
                this._change(null, index);
                return;
            }

            if (arguments.length) {
                if ($.isArray(arguments[0])) {
                    vals = this.options.values;
                    newValues = arguments[0];
                    for (i = 0; i < vals.length; i += 1) {
                        vals[i] = this._trimAlignValue(newValues[i]);
                        this._change(null, i);
                    }
                    this._refreshValue();
                } else {
                    if (this.options.values && this.options.values.length) {
                        return this._values(index);
                    } else {
                        return this.value();
                    }
                }
            } else {
                return this._values();
            }
        },

        _propAttr: function (t, a, b) {
            if ($.fn.prop) {
                t.prop(a, b);
            } else if ($.fn.attr) {
                t.attr(a, b);
            }
        },

        _setOption: function (key, value) {
            var i,
			valsLength = 0;

            if ($.isArray(this.options.values)) {
                valsLength = this.options.values.length;
            }

            $.Widget.prototype._setOption.apply(this, arguments);

            switch (key) {
                case "disabled":
                    if (value) {
                        this.handles.filter(".ui-state-focus").blur();
                        this.handles.removeClass("ui-state-hover");
                        this._propAttr(this.handles, "disabled", true);
                        this.element.addClass("ui-disabled");
                    } else {
                        this._propAttr(this.handles, "disabled", false);
                        this.element.removeClass("ui-disabled");
                    }
                    break;
                case "orientation":
                    this._detectOrientation();
                    $(this.element)
                    .find('.ui-touchSlider')
					.removeClass("ui-touchSlider-horizontal ui-touchSlider-vertical")
					.addClass("ui-touchSlider-" + this.orientation);
                    this._refreshValue();
                    break;
                case "value":
                    this._animateOff = true;
                    this._refreshValue();
                    this._change(null, 0);
                    this._animateOff = false;
                    break;
                case "values":
                    this._animateOff = true;
                    this._refreshValue();
                    for (i = 0; i < valsLength; i += 1) {
                        this._change(null, i);
                    }
                    this._animateOff = false;
                    break;
                case "ticks":
                    this._setTicks(value, this.options.min, this.options.max, this.options.roundTickLabels);
                    break;
                case "roundTickLabels":
                    this._setTicks(this.options.ticks, this.options.min, this.options.max, value);
                    break;
            }
        },

        //internal value getter
        // _value() returns value trimmed by min and max, aligned by step
        _value: function () {
            var val = this.options.value;
            val = this._trimAlignValue(val);

            return val;
        },

        //internal values getter
        // _values() returns array of values trimmed by min and max, aligned by step
        // _values( index ) returns single value trimmed by min and max, aligned by step
        _values: function (index) {
            var val,
			vals,
			i;

            if (arguments.length) {
                val = this.options.values[index];
                val = this._trimAlignValue(val);

                return val;
            } else {
                // .slice() creates a copy of the array
                // this copy gets trimmed by min and max and then returned
                vals = this.options.values.slice();
                for (i = 0; i < vals.length; i += 1) {
                    vals[i] = this._trimAlignValue(vals[i]);
                }

                return vals;
            }
        },

        // returns the step-aligned value that val is closest to, between (inclusive) min and max
        _trimAlignValue: function (val) {
            if (val <= this._valueMin()) {
                return this._valueMin();
            }
            if (val >= this._valueMax()) {
                return this._valueMax();
            }
            var step = (this.options.step > 0) ? this.options.step : 1,
			valModStep = (val - this._valueMin()) % step,
			alignValue = val - valModStep;

            if (Math.abs(valModStep) * 2 >= step) {
                alignValue += (valModStep > 0) ? step : (-step);
            }

            // Since JavaScript has problems with large floats, round
            // the final value to 5 digits after the decimal point (see #4124)
            return parseFloat(alignValue.toFixed(5));
        },

        _valueMin: function () {
            return this.options.min;
        },

        _valueMax: function () {
            return this.options.max;
        },

        _refreshValue: function () {
            var oRange = this.options.range,
			o = this.options,
			self = this,
			animate = (!this._animateOff) ? o.animate : false,
			valPercent,
			_set = {},
			lastValPercent,
			value,
			valueMin,
			valueMax;

            if (this.options.values && this.options.values.length) {
                this.handles.each(function (i, j) {
                    valPercent = (self.values(i) - self._valueMin()) / (self._valueMax() - self._valueMin()) * 100;
                    _set[self.orientation === "horizontal" ? "left" : "bottom"] = valPercent + "%";
                    $(this).stop(1, 1)[animate ? "animate" : "css"](_set, o.animate);
                    if (self.options.range === true) {
                        if (self.orientation === "horizontal") {
                            if (i === 0) {
                                self.range.stop(1, 1)[animate ? "animate" : "css"]({ left: valPercent + "%" }, o.animate);
                            }
                            if (i === 1) {
                                self.range[animate ? "animate" : "css"]({ width: (valPercent - lastValPercent) + "%" }, { queue: false, duration: o.animate });
                            }
                        } else {
                            if (i === 0) {
                                self.range.stop(1, 1)[animate ? "animate" : "css"]({ bottom: (valPercent) + "%" }, o.animate);
                            }
                            if (i === 1) {
                                self.range[animate ? "animate" : "css"]({ height: (valPercent - lastValPercent) + "%" }, { queue: false, duration: o.animate });
                            }
                        }
                    }
                    lastValPercent = valPercent;
                });
            } else {
                value = this.value();
                valueMin = this._valueMin();
                valueMax = this._valueMax();
                valPercent = (valueMax !== valueMin) ?
					(value - valueMin) / (valueMax - valueMin) * 100 :
					0;
                _set[self.orientation === "horizontal" ? "left" : "bottom"] = valPercent + "%";
                this.handle.stop(1, 1)[animate ? "animate" : "css"](_set, o.animate);

                if (oRange === "min" && this.orientation === "horizontal") {
                    this.range.stop(1, 1)[animate ? "animate" : "css"]({ width: valPercent + "%" }, o.animate);
                }
                if (oRange === "max" && this.orientation === "horizontal") {
                    this.range[animate ? "animate" : "css"]({ width: (100 - valPercent) + "%" }, { queue: false, duration: o.animate });
                }
                if (oRange === "min" && this.orientation === "vertical") {
                    this.range.stop(1, 1)[animate ? "animate" : "css"]({ height: valPercent + "%" }, o.animate);
                }
                if (oRange === "max" && this.orientation === "vertical") {
                    this.range[animate ? "animate" : "css"]({ height: (100 - valPercent) + "%" }, { queue: false, duration: o.animate });
                }
            }
        }
    });

    $.widget('ui.igToolbarSubpanel', {
        options: {
            at: 'top',
            of: null
        },

        _contentDiv: null,
        _arrow: null,
        _innerContent: null,

        _create: function () {
            this._arrow = $('<div class="ui-igSubpanel-arrow" />');
            this._arrowBorder = $('<span class="ui-igSubpanel-arrow-border"></span>');
            this._arrowBackground = $('<span class="ui-igSubpanel-arrow-background"></span>');
            this._arrow.append(this._arrowBorder).append(this._arrowBackground);

            var $element = $(this.element);

            $($element.children()[0]).wrap('<div class="ui-igSubpanel-content" />');
            this._contentDiv = $element.find('.ui-igSubpanel-content');

            $element.append(this._arrow);

            this._refresh();
        },

        _refresh: function () {
            if (!this.options.of) {
                return;
            }

            var borderColorStyle = 'border-bottom-color';
            var borderWidthStyle = 'border-bottom-width';
            if (this.options.at == 'bottom') {
                borderColorStyle = 'border-top-color';
                borderWidthStyle = 'border-top-width';
            }
            this._arrowBorder.css('border-' + this.options.at + '-color', this.element.css(borderColorStyle));
            this._arrowBackground.css('border-' + this.options.at + '-color', this.element.css('background-color'));

            var borderWidth = this.element.css(borderWidthStyle);
            var lineWidth = parseInt(borderWidth);
            var caretContentPosition = 'bottom';
            var contentCaretPosition = 'top';
            this._arrowBorder.removeClass('ui-igSubpanel-arrow-inverted');
            this._arrowBackground.removeClass('ui-igSubpanel-arrow-inverted');

            if (this.options.at == 'top') {
                this._arrowBorder.addClass('ui-igSubpanel-arrow-inverted');
                this._arrowBackground.addClass('ui-igSubpanel-arrow-inverted');
                this._arrowBackground.css('margin-top', -lineWidth);

                caretContentPosition = 'top';
                contentCaretPosition = 'bottom';
            } else {
                this._arrowBackground.css('margin-top', lineWidth);
            }

            this._arrow.position({
                my: 'center ' + contentCaretPosition,
                at: 'center ' + caretContentPosition,
                of: $(this.options.of),
                collision: 'none none'
            });

            this.element.position({
                my: 'center ' + contentCaretPosition,
                at: 'center ' + caretContentPosition,
                offset: '0 ' + (this.options.at == 'top' ? '' : '-') + lineWidth,
                of: this._arrow,
                collision: 'fit none'
            });

            this._trigger("change");
        },

        _destroy: function () {
            $(this._arrow).remove();
            $(this._contentDiv).children().unwrap();
        },

        _setOptions: function () {
            $.Widget.prototype._setOptions.apply(this, arguments);
            this._refresh();
        },

        _setOption: function (key, value) {
            switch (key) {
                case 'at':
                    this.options.at = value;
                    break;
            }

            $.Widget.prototype._setOption.call(this, key, value);
        }
    });

    /*
    ReportViewer is a widget based on jQuery UI that displays a rendered report.
    */
    $.widget('ui.igFloatingToolbar', {
        css: {
        },

        options: {
            /* type="string|number|null"
            string The widget width can be set in pixels (px) and percentage (%).
            number The widget width can be set as a number in pixels.
            null type="object" will stretch to fit data, if no other widths are defined.
            */
            width: null,

            /* type="string|number|null"
            string The height width can be set in pixels (px) and percentage (%).
            number The height width can be set as a number in pixels.
            null type="object" will fit the tree inside its parent container, if no other widths are defined.
            */
            height: null,

            viewer: null
        },

        events: {
        },

        _createWidget: function (options, element) {
            /* Strip dummy objects from options, because they are defined for documentation purposes only! */
            this.options.bindings = null;
            $.Widget.prototype._createWidget.apply(this, arguments);
        },

        _create: function () {
            var opt = this.options;
            if ($.ig.util.isIE && $.ig.util.isIE7 && this.element.css('position') === 'static') {
                this.element.css('position', 'relative');
            }
            if (opt.width) {
                this.element.css('width', opt.width);
            }
            if (opt.height) {
                this.element.css('height', opt.height);
            }

            this._provideContainer(this.element);
            this._bindToViewerEvents();
            this._zoomSet(this.options.viewer.options.zoomScale);
            this._disableAll(true);
            this._disableExportElements(true);
        },

        _setOption: function (option, value) {
            var oldValue = null;
            switch (option) {
                case 'width':
                    this.element.css('width', value);
                    break;
                case 'height':
                    this.element.css('height', value);
                    break;
                case 'viewer':
                    var oldViewer = this.options.viewer;
                    if (oldViewer != null) {
                        oldViewer.element.unbind('currentPageChanged.toolbar');
                        oldViewer.element.unbind('currentPageAvailable.toolbar');
                        oldViewer.element.unbind('totalPagesChanged.toolbar');
                        oldViewer.element.unbind('zoomScaleChanged.toolbar');
                        oldViewer.element.unbind('processingStarted.toolbar');
                        oldViewer.element.unbind('processingCompleted.toolbar');
                        oldViewer.element.unbind('processingCanceled.toolbar');
                        oldViewer.element.unbind('exportStarted.toolbar');
                        oldViewer.element.unbind('exportCompleted.toolbar');
                        oldViewer.element.unbind('exportCanceled.toolbar');
                        oldViewer.element.unbind('printStarted.toolbar');
                        oldViewer.element.unbind('printFinished.toolbar');
                        oldViewer.element.unbind('_viewerResized.toolbar');
                    }

                    this.options.viewer = value;
                    if (this.options.viewer != null) {
                        this._bindToViewerEvents();
                        this._zoomSet(this.options.viewer.options.zoomScale);
                    }

                    break;
                default:
                    $.Widget.prototype._setOption.apply(this, arguments);
            }
        },

        _mainDiv: null,
        _currentPage: 0,
        _totalPages: 0,
        _pageNumberForValue: function (value) {
            return Math.round(this._totalPages >= 100 ? value : 1 + (this._totalPages - 1) * (value / 100));
        },

        _percentageForPageNumber: null,

        _provideContainer: function (container) {
            var UI_CONSTANTS = {
                TOOLBAR_PAGE_CONTROLS_CSS_CLASS: "ui-floatingtoolbar-page-controls ui-floatingtoolbar-panel",
                TOOLBAR_FLOATING_TOOLBAR_CONTAINER_CSS_CLASS: "ui-floatingtoolbar-main-controls ui-floatingtoolbar-bottom-container",
                TOOLBAR_FLOATING_TOOLBAR_CSS_CLASS: "ui-floatingtoolbar-floating-toolbar ui-floatingtoolbar-panel",
                TOOLBAR_PAGE_TEXT_CSS_CLASS: "ui-floatingtoolbar-page-text",
                TOOLBAR_PAGE_SLIDER_CONTAINER_CSS_CLASS: "ui-corner-all ui-floatingtoolbar-page-slider-container " + $.ui.igReportViewerConstants.definition.ui.toolbarTopSubpanel + " ui-floatingtoolbar-subpanel-top-layout ui-floatingtoolbar-subpanel-hidden",
                TOOLBAR_PAGE_SLIDER_CSS_CLASS: "ui-floatingtoolbar-page-slider " + $.ui.igReportViewerConstants.definition.ui.toolbarTopSubpanel + " ui-floatingtoolbar-subpanel-top-layout",
                TOOLBAR_EXPORT_FORMATS_CSS_CLASS: "ui-floatingtoolbar-export-formats " + $.ui.igReportViewerConstants.definition.ui.toolbarBottomSubpanel + " ui-floatingtoolbar-subpanel-bottom-layout ui-floatingtoolbar-subpanel-hidden",
                TOOLBAR_ZOOM_CONTROLS_CSS_CLASS: "ui-floatingtoolbar-zoom-controls " + $.ui.igReportViewerConstants.definition.ui.toolbarBottomSubpanel + " ui-floatingtoolbar-subpanel-bottom-layout ui-floatingtoolbar-subpanel-hidden",
                TOOLBAR_SLIDER_CSS_CLASS: "ui-floatingtoolbar-slider",
                TOOLBAR_PANEL_SHADOW_CSS_CLASS: "ui-floatingtoolbar-panel-shadow"
            };

            var reportViewerHtmlTemplate = '';

            reportViewerHtmlTemplate += '<div class="pageControls ' + UI_CONSTANTS.TOOLBAR_PAGE_CONTROLS_CSS_CLASS + '">';
            reportViewerHtmlTemplate += '   <div class="ui-corner-all ui-widget-shadow ui-widget-overlay ' + UI_CONSTANTS.TOOLBAR_PANEL_SHADOW_CSS_CLASS + '" />';
            reportViewerHtmlTemplate += '      <button class="buttonPrevious">' + $.ui.igReportViewerLocale.locale.previousButtonLabel + '</button>';
            reportViewerHtmlTemplate += '      <span class="pageText ui-widget ui-widget-content ui-corner-all ' + UI_CONSTANTS.TOOLBAR_PAGE_TEXT_CSS_CLASS + '">';
            reportViewerHtmlTemplate += '          <span class="currentPageSpan">0</span>';
            reportViewerHtmlTemplate += '          <span class="totalPagesSpan">' + $.ui.igReportViewerLocale.locale.totalPagesLabel.replace('{0}', 0) + '</span>';
            reportViewerHtmlTemplate += '      </span>';
            reportViewerHtmlTemplate += '      <button class="buttonNext">' + $.ui.igReportViewerLocale.locale.nextButtonLabel + '</button>';
            reportViewerHtmlTemplate += '   </div>';

            reportViewerHtmlTemplate += '   <div class="pageSliderContainer ui-widget-content ' + UI_CONSTANTS.TOOLBAR_PAGE_SLIDER_CONTAINER_CSS_CLASS + '">';
            reportViewerHtmlTemplate += '       <div class="pageSliderInnerContainer">';
            reportViewerHtmlTemplate += '           <div class="pageSlider" />';
            reportViewerHtmlTemplate += '       </div>';
            reportViewerHtmlTemplate += '   </div>';

            reportViewerHtmlTemplate += '   <div class="floatingToolbarContainer ' + UI_CONSTANTS.TOOLBAR_FLOATING_TOOLBAR_CONTAINER_CSS_CLASS + '">';
            reportViewerHtmlTemplate += '      <div class="floatingToolbar ' + UI_CONSTANTS.TOOLBAR_FLOATING_TOOLBAR_CSS_CLASS + '">';
            reportViewerHtmlTemplate += '       <div class="ui-corner-all ui-widget-shadow ui-widget-overlay ' + UI_CONSTANTS.TOOLBAR_PANEL_SHADOW_CSS_CLASS + '"></div>';
            reportViewerHtmlTemplate += '           <ul class="ui-toolbar-items ui-helper-reset ui-helper-clearfix">';
            reportViewerHtmlTemplate += '               <li><button class="buttonExport">' + $.ui.igReportViewerLocale.locale.exportButtonLabel + '</button></li>';
            if (!Modernizr.touch && this.options.viewer._pdfPluginSupported()) {
                reportViewerHtmlTemplate += '           <li><button class="buttonPrint">' + $.ui.igReportViewerLocale.locale.printButtonLabel + '</button></li>';
            }
            reportViewerHtmlTemplate += '               <li><button class="buttonZoom">' + $.ui.igReportViewerLocale.locale.zoomButtonLabel + '</button></li>';
            reportViewerHtmlTemplate += '               <li><button class="buttonRefresh">' + $.ui.igReportViewerLocale.locale.refreshButtonLabel + '</button></li>';
            reportViewerHtmlTemplate += '           </ul>';
            reportViewerHtmlTemplate += '       </div>';
            reportViewerHtmlTemplate += '   </div>';

            reportViewerHtmlTemplate += '   <div class="exportFormats ui-widget-content ui-corner-all ' + UI_CONSTANTS.TOOLBAR_EXPORT_FORMATS_CSS_CLASS + '">';
            reportViewerHtmlTemplate += '       <div class="exportFormatsInnerContainer">';
            reportViewerHtmlTemplate += '           <button class="buttonPdfExport">' + $.ui.igReportViewerLocale.locale.pdfFormatText + '</button>';

            if (!$.ig.util._isIOSPlatform()) {
                reportViewerHtmlTemplate += '       <button class="buttonXpsExport">' + $.ui.igReportViewerLocale.locale.xpsFormatText + '</button>';
            }

            reportViewerHtmlTemplate += '           <button class="buttonXlsExport">' + $.ui.igReportViewerLocale.locale.xlsFormatText + '</button>';
            reportViewerHtmlTemplate += '           <button class="buttonXlsxExport">' + $.ui.igReportViewerLocale.locale.xlsxFormatText + '</button>';
            reportViewerHtmlTemplate += '       </div>';
            reportViewerHtmlTemplate += '   </div>';

            reportViewerHtmlTemplate += '   <div class="zoomControls ui-corner-all ' + UI_CONSTANTS.TOOLBAR_ZOOM_CONTROLS_CSS_CLASS + '">';
            reportViewerHtmlTemplate += '       <div class="zoomControlsInnerContainer">';
            reportViewerHtmlTemplate += '           <div class="zoomSlider ' + UI_CONSTANTS.TOOLBAR_SLIDER_CSS_CLASS + '" />';
            reportViewerHtmlTemplate += '           <button class="buttonFitToPage ' + UI_CONSTANTS.TOOLBAR_BUTTON_CSS_CLASS + '">' + $.ui.igReportViewerLocale.locale.fitToPageButtonLabel + '</button>';
            reportViewerHtmlTemplate += '           <button class="buttonFitToWidth ' + UI_CONSTANTS.TOOLBAR_BUTTON_CSS_CLASS + '">' + $.ui.igReportViewerLocale.locale.fitToWidthButtonLabel + '</button>';
            reportViewerHtmlTemplate += '       </div>';
            reportViewerHtmlTemplate += '   </div>';

            container.append($(reportViewerHtmlTemplate));
            var mainDiv = container;
            this._mainDiv = container;

            var that = this;

            var pageSliderContainer = mainDiv.find('.pageSliderContainer');
            var pageSlider = pageSliderContainer.find('.pageSlider');
            this._pageSliderContainer = pageSliderContainer;
            pageSliderContainer.css('display', 'none');
            var labelForPercentage = function (percentage) {
                return 1 + Math.round((that._totalPages - 1) * percentage);
            };

            var percentageForPageNumber = function (page) {
                if (that._totalPages >= 100) {
                    return page;
                }

                return page == 1 ? 0 : ((page - 1) * 100) / (that._totalPages - 1);
            };

            this._percentageForPageNumber = percentageForPageNumber;

            pageSlider.touchSlider({
                labelForPercentage: labelForPercentage,
                percentageForPageNumber: percentageForPageNumber,
                slide: function (o, e) {
                    var page = that._pageNumberForValue(e.value);
                    that._updateCurrentPage(page, true);
                },
                stop: function (o, e) {
                    var page = that._pageNumberForValue(e.value);
                    if (page != that.options.viewer.currentPage()) {
                        that.options.viewer.currentPage(page);
                    }
                }
            });

            var exportFormats = mainDiv.find('.exportFormats');
            this._exportFormats = exportFormats;
            exportFormats.css('display', 'none');

            var zoomControls = mainDiv.find('.zoomControls');
            this._zoomControls = zoomControls;
            zoomControls.css('display', 'none');

            var buttonNext = mainDiv.find('.buttonNext');
            buttonNext.button({ icons: { secondary: 'ui-icon ui-icon-circle-triangle-e' } }).click(function (event) {
                event.preventDefault();
                that._hideCallouts();
                that.options.viewer.moveToNextPage();
                buttonNext.blur();
                that._removeHover(buttonNext);
            });

            var buttonPrevious = mainDiv.find('.buttonPrevious');
            buttonPrevious.button({ icons: { primary: 'ui-icon ui-icon-circle-triangle-w' } }).click(function (event) {
                event.preventDefault();
                that._hideCallouts();
                that.options.viewer.moveToPreviousPage();
                buttonPrevious.blur();
                that._removeHover(buttonPrevious);
            });

            var buttonExport = mainDiv.find('.buttonExport');
            buttonExport.button().click(function (event) {
                event.preventDefault();
                that._removeHover(buttonExport);
                that._hideZoomControls();
                that._hidePageSliderContainer();

                if (that._exportFormatsVisible) {
                    that._exportFormatsVisible = false;
                    exportFormats.fadeOut('fast');
                    exportFormats.css('left', '');
                    exportFormats.addClass('ui-floatingtoolbar-subpanel-hidden');
                } else {
                    that._exportFormatsVisible = true;
                    exportFormats.fadeIn('fast', function () {
                        exportFormats.removeClass('ui-floatingtoolbar-subpanel-hidden');
                        exportFormats.igToolbarSubpanel({ at: 'top', of: buttonExport });
                        exportFormats.data('igToolbarSubpanel')._refresh();
                    });
                }
            });

            var buttonPdfExport = mainDiv.find('.buttonPdfExport');
            buttonPdfExport.button({ icons: { primary: "ui-button-export-pdf" } }).click(function (event) {
                event.preventDefault();
                that._hideExportFormats();
                that._removeHover(buttonPdfExport);
                that.options.viewer.exportReport($.ui.igReportViewerConstants.definition.availableExportFormats.pdf);
            });

            var buttonXpsExport = mainDiv.find('.buttonXpsExport');
            buttonXpsExport.button({ icons: { primary: "ui-button-export-xps" } }).click(function (event) {
                event.preventDefault();
                that._hideExportFormats();
                that._removeHover(buttonXpsExport);
                that.options.viewer.exportReport($.ui.igReportViewerConstants.definition.availableExportFormats.xps);
            });

            var buttonXlsExport = mainDiv.find('.buttonXlsExport');
            buttonXlsExport.button({ icons: { primary: "ui-button-export-xls3" } }).click(function (event) {
                event.preventDefault();
                that._hideExportFormats();
                that._removeHover(buttonXlsExport);
                that.options.viewer.exportReport($.ui.igReportViewerConstants.definition.availableExportFormats.xls);
            });

            var buttonXlsxExport = mainDiv.find('.buttonXlsxExport');
            buttonXlsxExport.button({ icons: { primary: "ui-button-export-xls7" } }).click(function (event) {
                event.preventDefault();
                that._hideExportFormats();
                that._removeHover(buttonXlsxExport);
                that.options.viewer.exportReport($.ui.igReportViewerConstants.definition.availableExportFormats.xlsx);
            });

            var pageControls = mainDiv.find('.pageControls');
            this._pageControls = pageControls;
            var floatingToolbar = mainDiv.find('.floatingToolbar');
            this._floatingToolbar = floatingToolbar;
            this._floatingToolbarContainer = mainDiv.find('.floatingToolbarContainer');

            if (!Modernizr.touch) {
                var buttonPrint = mainDiv.find('.buttonPrint');
                buttonPrint.button().click(function (event) {
                    event.preventDefault();
                    that._removeHover(buttonPrint);
                    that._hideCallouts();
                    that.options.viewer.printReport();
                });

                $('html').click(function () {
                    that._hidePageSliderContainer();
                    that._hideZoomControls();
                    that._hideExportFormats();
                });

                var stopPropagationEvent = function (event) {
                    event.stopPropagation();
                };

                pageControls.click(stopPropagationEvent);
                floatingToolbar.click(stopPropagationEvent);
                pageSliderContainer.click(stopPropagationEvent);
                zoomControls.click(stopPropagationEvent);
                exportFormats.click(stopPropagationEvent);
            }

            var buttonZoom = mainDiv.find('.buttonZoom');
            buttonZoom.button().click(function (event) {
                event.preventDefault();
                that._removeHover(buttonZoom);
                that._hideExportFormats();
                that._hidePageSliderContainer();
                if (that._zoomControlsVisible) {
                    that._zoomControlsVisible = false;
                    zoomControls.fadeOut('fast');
                    zoomControls.css('left', '');
                    zoomControls.addClass('ui-floatingtoolbar-subpanel-hidden');
                }
                else {
                    that._zoomControlsVisible = true;
                    zoomControls.fadeIn('fast', function () {
                        zoomControls.removeClass('ui-floatingtoolbar-subpanel-hidden');
                        zoomControls.igToolbarSubpanel({ at: 'top', of: buttonZoom });
                        zoomControls.data('igToolbarSubpanel')._refresh();
                    });
                }
            });

            mainDiv.find('.zoomSlider').touchSlider({
                min: $.ui.igReportViewerConstants.definition.minZoom,
                max: $.ui.igReportViewerConstants.definition.maxZoom,
                value: 100,
                slide: function (o, e) {
                    that.options.viewer._setOptions({ pageFit: 'off', zoomScale: e.value });
                }
            });

            mainDiv.find('.buttonFitToPage').button({
                icons: {
                    primary: "ui-icon-arrow-4-diag"
                },
                text: false
            }).click(function (event) {
                event.preventDefault();
                that.options.viewer._setOptions({ pageFit: 'fitToPage' });
            });

            mainDiv.find('.buttonFitToWidth').button({
                icons: {
                    primary: "ui-icon-arrowthick-2-e-w"
                },
                text: false
            }).click(function (event) {
                event.preventDefault();
                that.options.viewer._setOptions({ pageFit: 'fitToWidth' });
            });

            var buttonRefresh = mainDiv.find('.buttonRefresh');
            buttonRefresh.button().click(function (event) {
                event.preventDefault();
                that._removeHover(buttonRefresh);
                that.options.viewer.refresh();
            });

            var pageText = mainDiv.find('.pageText');
            pageText.click(function (event) {
                if (that._showingSlider) {
                    that._showingSlider = false;
                    pageSliderContainer.fadeOut('fast');
                    pageSliderContainer.css('left', '');
                    pageSliderContainer.addClass('ui-floatingtoolbar-subpanel-hidden');
                }
                else {
                    if (that._mainDiv.find(".pageSlider").touchSlider('option', 'disabled')) {
                        return;
                    }

                    that._hideZoomControls();
                    that._hideExportFormats();
                    that._showingSlider = true;

                    pageSliderContainer.fadeIn('fast', function () {
                        pageSliderContainer.removeClass('ui-floatingtoolbar-subpanel-hidden');
                        pageSliderContainer.igToolbarSubpanel({ at: 'bottom', of: pageText });
                        pageSliderContainer.data('igToolbarSubpanel')._refresh();
                    });
                }
            });

            if (Modernizr.touch) {
                if (!this._createToolbar()) {
                    this._showingToolbar = false;
                    pageControls.css('display', 'none');
                    floatingToolbar.css('display', 'none');
                }
                else {
                    this._showingToolbar = true;
                }

                this.options.viewer._viewerContainer.bind('touchstart', function (event) {
                    that._onTouchStart(event);
                });
            }
            else {
                this._showingToolbar = false;
                pageControls.css('display', 'none');
                floatingToolbar.css('display', 'none');
                this._timerNumber = 0;
                container.hover(
                    function (event) {
                        if (that._createToolbar()) {
                            that._showingToolbar = true;
                            pageControls.fadeIn('fast');
                            floatingToolbar.fadeIn('fast');

                            that._startToolbarTimer();
                        }
                    },
                    function (event) {
                        that._hideToolbar();
                    });

                container.bind('mousemove', function (event) {
                    that._resetToolbarTimer();
                });

                this._mouseOverToolbar = false;
                this._keepToolbarAlive(pageControls);
                this._keepToolbarAlive(floatingToolbar);
                this._keepToolbarAlive(pageSliderContainer);
                this._keepToolbarAlive(exportFormats);
                this._keepToolbarAlive(zoomControls);
            }
        },

        _createToolbar: function () {
            // sanitizing createToolbar option, i.e. handle both boolean literals and Boolean objects.
            var createToolbar = this.options.viewer.options.createToolbar;
            return (createToolbar.valueOf && createToolbar.valueOf()) || (!createToolbar.valueOf && createToolbar);
        },

        _keepToolbarAlive: function (control) {
            var that = this;
            control.hover(
                function (event) {
                    that._mouseOverToolbar = true;
                },
                function (event) {
                    that._mouseOverToolbar = false;
                });
        },

        _startToolbarTimer: function () {
            this._timerNumber++;
            var timerId = this._timerNumber;
            var self = this;
            this._toolbarTimer = setTimeout(
                function () {
                    if (self._timerNumber <= timerId) {
                        // Only react to the latest timer, not one from a previous event
                        if (!self._mouseOverToolbar) {
                            self._hideToolbar();
                        }
                    }
                },
                $.ui.igReportViewerConstants.definition.hideToolbarTime);
        },

        _resetToolbarTimer: function () {
            if (this._toolbarTimer != null) {
                clearTimeout(this._toolbarTimer);
            }

            if (this._createToolbar() && !this._showingToolbar) {
                this._showingToolbar = true;
                this._pageControls.fadeIn('fast');
                this._floatingToolbar.fadeIn('fast');
            }

            this._startToolbarTimer();
        },

        _viewerResized: function () {
            if (this._showingToolbar) {
                this._hideCallouts();
                $(this.options.viewer.element).focus();
                this._removeHover(this._mainDiv, '.buttonExport');
                this._removeHover(this._mainDiv, '.buttonPrint');
                this._removeHover(this._mainDiv, '.buttonZoom');
                this._removeHover(this._mainDiv, '.buttonRefresh');
            }

            this._adjustBottomFloatingToolbarContainer();
        },

        _zoomSet: function (zoom) {
            this._mainDiv.find(".zoomSlider").data('touchSlider')._setOption('value', zoom);
            this._adjustBottomFloatingToolbarContainer();
        },

        _lastBottomAdjustment: null,
        _adjustBottomFloatingToolbarContainer: function () {
            var bottomAdjustment = this.options.viewer._pageFitsHorizontally() ? 0 : this.options.viewer._getBrowserScrollBarWidth();
            $(this._floatingToolbarContainer).css('bottom', bottomAdjustment);

            if (bottomAdjustment != this._lastBottomAdjustment) {

                if (this._zoomControlsVisible) {
                    // Sometimes one refresh does not position well the arrow, so two refreshes are needed
                    this._zoomControls.data('igToolbarSubpanel')._refresh();
                    this._zoomControls.data('igToolbarSubpanel')._refresh();
                }

                if (this._exportFormatsVisible) {
                    // Sometimes one refresh does not position well the arrow, so two refreshes are needed
                    this._exportFormats.data('igToolbarSubpanel')._refresh();
                    this._exportFormats.data('igToolbarSubpanel')._refresh();
                }

                this.options.viewer._positionExportPanel();
                this.options.viewer._positionPrintPanel();

                this._lastBottomAdjustment = bottomAdjustment;
            }
        },

        _hidePageSliderContainer: function () {
            if (this._showingSlider) {
                this._showingSlider = false;
                this._pageSliderContainer.fadeOut('fast');
                this._pageSliderContainer.css('left', '');
                this._pageSliderContainer.addClass('ui-floatingtoolbar-subpanel-hidden');
            }
        },

        _hideZoomControls: function () {
            if (this._zoomControlsVisible) {
                this._zoomControlsVisible = false;
                this._zoomControls.fadeOut('fast');
                this._zoomControls.css('left', '');
                this._zoomControls.addClass('ui-floatingtoolbar-subpanel-hidden');
            }
        },

        _hideExportFormats: function () {
            if (this._exportFormatsVisible) {
                this._exportFormatsVisible = false;
                this._exportFormats.fadeOut('fast');
                this._exportFormats.css('left', '');
                this._exportFormats.addClass('ui-floatingtoolbar-subpanel-hidden');
            }
        },

        _bindToViewerEvents: function () {
            var that = this;

            this.options.viewer.element.bind('currentPageChanged.toolbar', function (event, args) {
                that._updateCurrentPage(args.newValue);
                var sliderPage = that._pageNumberForValue(that._pageSliderContainer.find('.pageSlider').data('touchSlider').value());

                if (sliderPage != args.newValue) {
                    var percentage = that._percentageForPageNumber(args.newValue);
                    that._pageSliderContainer.find('.pageSlider').touchSlider({ value: percentage });
                }
            });

            this.options.viewer.element.bind('currentPageAvailable.toolbar', function () {
                if (that._adjustToolbarContainer) {
                    that._adjustToolbarContainer = false;
                    that._adjustBottomFloatingToolbarContainer();
                }
            });

            this.options.viewer.element.bind('totalPagesChanged.toolbar', function (event, args) {
                that._updateTotalPages(args.totalPages);
            });
            this.options.viewer.element.bind('zoomScaleChanged.toolbar', function (event, args) {
                that._zoomSet(args.newValue);
            });
            this.options.viewer.element.bind('processingStarted.toolbar', function (event, object) {
                that._disableAll(true);
                that._disableExportElements(true);
            });
            this.options.viewer.element.bind('processingCanceled.toolbar', function (event, object) {
                that._updateCurrentPage(0);
                that._updateTotalPages(0);
                that._pageSliderContainer.find('.pageSlider').touchSlider({ value: 0 });
                that._disableAll(true);
                that._disableExportElements(true);
                that._hideCallouts();
                that._adjustBottomFloatingToolbarContainer();
            });
            this.options.viewer.element.bind('processingCompleted.toolbar', function (event, eventData) {
                that._disableExportElements(false);
                var totalPages = eventData.totalPages;
                var ticks = false;

                if (totalPages > 1 && totalPages <= 5) {
                    ticks = totalPages - 2;
                } else if (totalPages > 5) {
                    ticks = 4;
                }

                that._pageSliderContainer.find('.pageSlider').touchSlider({
                    disabled: totalPages <= 1,
                    min: 1,
                    max: totalPages >= 100 ? totalPages : 100,
                    ticks: ticks,
                    step: Math.round(totalPages >= 100 ? 1 : (ticks === 0 ? 100 : 100 / (totalPages - 1))),
                    roundTickLabels: totalPages >= 100,
                    value: that._percentageForPageNumber(that.options.viewer.currentPage())
                });
            });
            this.options.viewer.element.bind('exportStarted.toolbar', function (event, object) {
                that._disableExportElements(true);
            });
            this.options.viewer.element.bind('exportCompleted.toolbar', function (event, object) {
                that._disableExportElements(false);
            });
            this.options.viewer.element.bind('exportCanceled.toolbar', function (event, object) {
                that._disableExportElements(false);
            });
            this.options.viewer.element.bind('printStarted.toolbar', function (event, object) {
                that._disableExportElements(true);
            });
            this.options.viewer.element.bind('printFinished.toolbar', function (event, object) {
                that._disableExportElements(false);
            });
            this.options.viewer.element.bind('_viewerResized.toolbar', function (event, object) {
                that._viewerResized();
            });
        },
        _updateCurrentPage: function (currentPage, skipToggleToolbarNavigationButtons) {
            this._adjustToolbarContainer = this._currentPage == 0 && currentPage != 0;
            this._currentPage = currentPage;
            this._mainDiv.find(".currentPageSpan").empty().append('' + currentPage);

            if (!skipToggleToolbarNavigationButtons) {
                this._toggleNavigationButtons();
            }
        },
        _updateTotalPages: function (totalPages) {
            this._totalPages = totalPages;
            this._mainDiv.find(".totalPagesSpan").empty();
            this._mainDiv.find(".totalPagesSpan").append($.ui.igReportViewerLocale.locale.totalPagesLabel.replace('{0}', totalPages));
            this._disableAll(false);

            if (totalPages <= 1) {
                this._mainDiv.find(".pageSlider").touchSlider({ disabled: true, min: 0, max: 0, value: 0, ticks: false });
                this._hidePageSliderContainer();
            }

            this._toggleNavigationButtons();
        },

        _toggleNavigationButtons: function () {
            var disablePreviousButton = this._currentPage <= 1;
            var disableNextButton = this._currentPage >= this._totalPages;

            var previousButton = this._mainDiv.find(".buttonPrevious");
            previousButton.button('option', 'disabled', disablePreviousButton);

            if (disablePreviousButton) {
                previousButton.removeClass('ui-state-focus');
            }

            var nextButton = this._mainDiv.find(".buttonNext");
            nextButton.button('option', 'disabled', disableNextButton);

            if (disableNextButton) {
                nextButton.removeClass('ui-state-focus');
            }
        },

        _disableAll: function (isDisabled) {
            this._disabled = isDisabled;
            this._mainDiv.find(".buttonPrevious").button({ disabled: isDisabled });
            this._mainDiv.find(".buttonNext").button({ disabled: isDisabled });

            // touch slider enabling is done at processing completed callback
            if (isDisabled) {
                this._mainDiv.find(".pageSlider").touchSlider({ disabled: isDisabled, ticks: false });
            }

            this._mainDiv.find(".buttonZoom").button({ disabled: isDisabled });
            this._mainDiv.find(".zoomSlider").touchSlider({ disabled: isDisabled });
            this._mainDiv.find('.buttonFitToPage').button({ disabled: isDisabled });
            this._mainDiv.find('.buttonFitToWidth').button({ disabled: isDisabled });
        },
        _disableExportElements: function (isDisabled) {
            this._mainDiv.find(".buttonExport").button({ disabled: isDisabled });
            this._mainDiv.find(".buttonPdfExport").button({ disabled: isDisabled });
            this._mainDiv.find(".buttonXpsExport").button({ disabled: isDisabled });
            this._mainDiv.find(".buttonXlsExport").button({ disabled: isDisabled });
            this._mainDiv.find(".buttonXlsxExport").button({ disabled: isDisabled });
            this._mainDiv.find(".buttonPrint").button({ disabled: isDisabled });
        },

        _distance: function (x1, y1, x2, y2) {
            var dx = x2 - x1;
            var dy = y1 - y2;
            return Math.sqrt(dx * dx + dy * dy);
        },

        _onTouchStart: function (event) {
            var that = this;

            var touch = event.originalEvent.touches[0];
            this._touchStartX = touch.pageX;
            this._touchStartY = touch.pageY;
            this._touchStartTime = event.originalEvent.timeStamp;
            this._scrollStartX = this.options.viewer._getScrollX();
            this._scrollStartY = this.options.viewer._getScrollY();
            this._multiTouchGesture = false;

            this._scaleStart = this.options.viewer.options.zoomScale / 100;

            // for calculating speed
            this._touchLastX = touch.pageX;
            this._touchLastY = touch.pageY;
            this._touchLastTime = event.originalEvent.timeStamp;
            this._speedX = 0;
            this._speedY = 0;

            if (event.originalEvent.touches.length > 1) {
                var second = event.originalEvent.touches[1];
                this._secondStartX = second.pageX;
                this._secondStartY = second.pageY;
                this._originalDistance = this._distance(touch.pageX, touch.pageY, second.pageX, second.pageY);

                // Calculate the coordinates in the report where the middle point between fingers is placed
                var clippingPanelPosition = this.options.viewer._clippingPanel.offset();
                var clientMidPointX = (touch.pageX + second.pageX) / 2;
                var clientMidPointY = (touch.pageY + second.pageY) / 2;
                this._reportStartX = (clientMidPointX - clippingPanelPosition.left) / this._scaleStart;
                this._reportStartY = (clientMidPointY - clippingPanelPosition.top) / this._scaleStart;

                this._multiTouchGesture = true;
            }

            this.options.viewer._viewerContainer.bind('touchmove',
                function (moveEvent) {
                    that._onTouchMove(moveEvent);
                });

            this.options.viewer._viewerContainer.bind('touchend',
                function (endEvent) {
                    that._onTouchEnd(endEvent);
                });
        },

        _onTouchMove: function (event) {
            var touch = event.originalEvent.touches[0];
            if (event.originalEvent.touches.length == 1) {
                // Pan
                if (this._showingToolbar) {
                    this._toggleToolbarVisible();
                }

                var offsetX = touch.pageX - this._touchStartX;
                var offsetY = touch.pageY - this._touchStartY;

                this._touchLast2X = this._touchLastX;
                this._touchLast2Y = this._touchLastY;
                this._touchLast2Time = this._touchLastTime;

                // for calculating speed
                if (event.originalEvent.timeStamp > this._touchLastTime) {
                    this._speedX = (touch.pageX - this._touchLastX) / (event.originalEvent.timeStamp - this._touchLastTime);
                    this._speedY = (touch.pageY - this._touchLastY) / (event.originalEvent.timeStamp - this._touchLastTime);
                }
                this._touchLastX = touch.pageX;
                this._touchLastY = touch.pageY;
                this._touchLastTime = event.originalEvent.timeStamp;

                var scrollChanged = this.options.viewer._setScrollOffset(this._scrollStartX + offsetX, this._scrollStartY + offsetY);
                if (scrollChanged || this.options.viewer.options.gestureScrolling != 'fullWindow') {
                    // Prevent browser events if the user is panning
                    event.preventDefault();
                }
            }
            else if (event.originalEvent.touches.length == 2) {
                // Zoom
                event.preventDefault();
                if (this._showingToolbar) {
                    this._toggleToolbarVisible();
                }

                var second = event.originalEvent.touches[1];
                var newDistance = this._distance(touch.pageX, touch.pageY, second.pageX, second.pageY);
                var newScale = this._scaleStart * newDistance / this._originalDistance;

                var targetZoom = newScale * 100;
                if (targetZoom >= $.ui.igReportViewerConstants.definition.maxZoom) {
                    targetZoom = $.ui.igReportViewerConstants.definition.maxZoom;
                }
                else if (targetZoom <= $.ui.igReportViewerConstants.definition.minZoom) {
                    targetZoom = $.ui.igReportViewerConstants.definition.minZoom;
                }
                newScale = targetZoom / 100;

                // Based on the report coordinates, calculate the what the new clippingPanel position should be
                var newClientMidPointX = (touch.pageX + second.pageX) / 2;
                var newClientMidPointY = (touch.pageY + second.pageY) / 2;
                var newClippingPanelLeft = newClientMidPointX - this._reportStartX * newScale;
                var newClippingPanelTop = newClientMidPointY - this._reportStartY * newScale;

                // The clippingPanel position is the scrollPanel position plus the scroll offset
                var scrollPanelPosition = this.options.viewer._scrollPanel.offset();
                var newScrollLeft = newClippingPanelLeft - scrollPanelPosition.left;
                var newScrollTop = newClippingPanelTop - scrollPanelPosition.top;

                this.options.viewer._setOptions({ pageFit: 'off' });
                this.options.viewer._forceZoomScale(targetZoom);

                this.options.viewer._clippingPanel.css('left', newScrollLeft);
                this.options.viewer._clippingPanel.css('top', newScrollTop);
            }
        },

        _onTouchEnd: function (event) {
            var timestamp = event.originalEvent.timeStamp;

            this._scaleStart = null;

            var useInertialScroll = true;

            if (event.originalEvent.touches.length == 0 && !this._multiTouchGesture) {
                var touch = event.originalEvent.changedTouches[0];

                var swipeTan = Infinity;
                if (touch.pageX != this._touchStartX) {
                    swipeTan = (touch.pageY - this._touchStartY) / (touch.pageX - this._touchStartX);
                }

                if ((timestamp - this._touchStartTime <= 1000)
                    && (touch.pageX == this._touchStartX
                    && touch.pageY == this._touchStartY)) {
                    // tap
                    this._onTap(event);
                    useInertialScroll = false;
                }
                else {
                    var scrollX = this.options.viewer._getScrollX();
                    var scrollWidth = this.options.viewer._scrollPanel.width();
                    var clippingWidth = this.options.viewer._clippingPanel.width();
                    if (clippingWidth > 0 && scrollX + clippingWidth < scrollWidth / 2) {
                        // swipe left
                        if (this.options.viewer.options.gestureScrolling != 'fullWindow') {
                            // don't use inertial scroll if current page is swiped
                            useInertialScroll = !this._onSwipeLeft(event);
                        }
                    }
                    else if (clippingWidth > 0 && scrollX > scrollWidth / 2) {
                        // swipe right
                        if (this.options.viewer.options.gestureScrolling != 'fullWindow') {
                            // don't use inertial scroll if current page is swiped
                            useInertialScroll = !this._onSwipeRight(event);
                        }
                    }
                    else if (timestamp - this._touchStartTime <= 1000) {
                        if (Math.abs(swipeTan) <= 1) {
                            if (touch.pageX - this._touchStartX > 30) {
                                // swipe right
                                if (this.options.viewer.options.gestureScrolling != 'fullWindow') {
                                    // don't use inertial scroll if current page is swiped
                                    useInertialScroll = !this._onSwipeRight(event);
                                }
                            }
                            else if (touch.pageX - this._touchStartX < -30) {
                                // swipe left
                                if (this.options.viewer.options.gestureScrolling != 'fullWindow') {
                                    // don't use inertial scroll if current page is swiped
                                    useInertialScroll = !this._onSwipeLeft(event);
                                }
                            }
                        }
                    }
                }
            }

            if (useInertialScroll) {
                this.options.viewer._startInertialScroll(this._speedX, this._speedY);
            }

            this.options.viewer._viewerContainer.unbind('touchmove');
            this.options.viewer._viewerContainer.unbind('touchend');
        },

        _onTap: function (event) {
            event.preventDefault();

            var touch = event.originalEvent.changedTouches[0];
            var tapHorizontalPosition = touch.pageX - this.options.viewer._mainDiv.offset().left;
            var totalWidth = this.options.viewer._mainDiv.width();

            if (tapHorizontalPosition < totalWidth * 0.15) {
                // tap on left band
                try {
                    this.options.viewer.moveToPreviousPage();
                    return;
                }
                catch (err) {
                    // the report hasn't finished loading yet
                }
            }

            if (tapHorizontalPosition > totalWidth * 0.85) {
                // tap on right band
                try {
                    this.options.viewer.moveToNextPage();
                    return;
                }
                catch (err) {
                    // the report hasn't finished loading yet
                }
            }

            // middle tap   
            try {
                var self = this;

                // Set timer to show / hide toolbar.
                if (!this._toogleToolbarTimerId) {
                    this._toogleToolbarTimerId = setTimeout(function () {
                        self._toggleToolbarVisible();
                        self._toogleToolbarTimerId = null;
                    }, $.ui.igReportViewerConstants.definition.toggleToolbarTimeout);
                }

                // check for double tap
                if (!this._doubleTapTime) {
                    return;
                }

                if ((event.originalEvent.timeStamp - this._doubleTapTime) <= $.ui.igReportViewerConstants.definition.doubleTapTimeout) {
                    if (Math.abs(this._doubleTapX - touch.pageX) <= $.ui.igReportViewerConstants.definition.doubleTapDelta && Math.abs(this._doubleTapY - touch.pageY) <= $.ui.igReportViewerConstants.definition.doubleTapDelta) {
                        if (this._showingToolbar) {
                            this._toggleToolbarVisible();
                        }

                        if (this.options.viewer.options.pageFit == 'fitToPage') {
                            // Begin centering
                            var scaleStart = this.options.viewer.options.zoomScale / 100;

                            var clippingPanelPosition = this.options.viewer._clippingPanel.offset();
                            var reportStartX = (touch.pageX - clippingPanelPosition.left) / scaleStart;
                            var reportStartY = (touch.pageY - clippingPanelPosition.top) / scaleStart;

                            this.options.viewer._setOptions({ pageFit: 'off' });
                            this.options.viewer._forceZoomScale(100);

                            var newClippingPanelLeft = touch.pageX - reportStartX;
                            var newClippingPanelTop = touch.pageY - reportStartY;
                            var scrollPanelPosition = this.options.viewer._scrollPanel.offset();
                            var newScrollLeft = newClippingPanelLeft - scrollPanelPosition.left;
                            var newScrollTop = newClippingPanelTop - scrollPanelPosition.top;

                            this.options.viewer._clippingPanel.css('left', newScrollLeft);
                            this.options.viewer._clippingPanel.css('top', newScrollTop);

                            var scrollStartX = this.options.viewer._getScrollX();
                            var scrollStartY = this.options.viewer._getScrollY();

                            if (scrollStartX > 0) {
                                this.options.viewer._clippingPanel.css('left', 0);
                            }
                            else if (scrollStartX < this.options.viewer._getMaxScrollX()) {
                                this.options.viewer._clippingPanel.css('left', this.options.viewer._getMaxScrollX());
                            }

                            if (scrollStartY > 0) {
                                this.options.viewer._clippingPanel.css('top', 0);
                            }
                            else if (scrollStartY < this.options.viewer._getMaxScrollY()) {
                                this.options.viewer._clippingPanel.css('top', this.options.viewer._getMaxScrollY());
                            }
                            // End centering
                        }
                        else {
                            this.options.viewer._setOptions({ pageFit: 'fitToPage' });
                        }

                        if (this._toogleToolbarTimerId) {
                            clearTimeout(this._toogleToolbarTimerId);
                            this._toogleToolbarTimerId = null;
                        }
                    }
                }
            }
            finally {
                this._doubleTapTime = event.originalEvent.timeStamp;
                this._doubleTapX = touch.pageX;
                this._doubleTapY = touch.pageY;
            }
        },

        _onSwipeRight: function (event) {
            if (this._showingToolbar) {
                this._toggleToolbarVisible();
            }

            if (this.options.viewer._getScrollX() <= 0) {
                // It should pan instead of swipe
                return false;
            }

            event.preventDefault();
            try {
                return this.options.viewer._animateMoveToPreviousPage();
            }
            catch (err) {
                return false;
            }
        },

        _onSwipeLeft: function (event) {
            if (this._showingToolbar) {
                this._toggleToolbarVisible();
            }

            if (this.options.viewer._getScrollX() > this.options.viewer._getMaxScrollX()) {
                // It should pan instead of swipe
                return false;
            }

            event.preventDefault();
            try {
                return this.options.viewer._animateMoveToNextPage();
            }
            catch (err) {
                return false;
            }
        },

        _toggleToolbarVisible: function () {
            if (this._showingToolbar) {
                this._showingToolbar = false;
                this._pageControls.fadeOut('fast');
                this._floatingToolbar.fadeOut('fast');
                this._hideCallouts();
            }
            else {
                if (this._createToolbar()) {
                    this._showingToolbar = true;
                    this._pageControls.fadeIn('fast');
                    this._floatingToolbar.fadeIn('fast');
                }
            }
        },

        _hideCallouts: function () {
            this._hidePageSliderContainer();
            this._hideZoomControls();
            this._hideExportFormats();
        },

        _hideToolbar: function () {
            this._showingToolbar = false;
            this._pageControls.fadeOut('fast');
            this._floatingToolbar.fadeOut('fast');
            this._hideCallouts();
            this._removeHover(this._mainDiv, '.buttonExport');
            this._removeHover(this._mainDiv, '.buttonPrint');
            this._removeHover(this._mainDiv, '.buttonZoom');
            this._removeHover(this._mainDiv, '.buttonRefresh');

            if (this._toolbarTimer != null) {
                clearTimeout(this._toolbarTimer);
            }
        },

        _removeHover: function (container, selector) {
            if (arguments.length === 1) {
                container.removeClass('ui-state-hover').removeClass('ui-state-active');
            } else {
                container.find(selector).removeClass('ui-state-hover').removeClass('ui-state-active');
            }
        },

        destroy: function () {
            /* Destructor */
            $.Widget.prototype.destroy.apply(this, arguments);

            this._setOption('viewer', null);

            this.element.removeClass(this.css.reportViewer);
            if (this.options.width) {
                this.element.css('width', '');
            }
            if (this.options.height) {
                this.element.css('height', '');
            }
            this.element.empty();
            return this;
        }
    });

    $.ig = $.ig || {};

}(jQuery));

(function ($) {
    if (!$.ui.igReportViewerLocale) {

        $.ui.igReportViewerLocale = {};

        $.extend($.ui.igReportViewerLocale, {
            locale: {
                unsupportedBrowser: "The current browser does not support HTML5 canvas element. <br/>Try upgrading to any of the following versions:",
                currentBrowser: "Current browser: {0}",
                ie9: "Microsoft Internet Explorer V 9+",
                chrome8: "Google Chrome V 8+",
                firefox36: "Mozilla Firefox V 3.6+",
                safari5: "Apple Safari V 5+",
                opera11: "Opera V 11+",
                ieDownload: "http://www.microsoft.com/windows/internet-explorer/default.aspx",
                operaDownload: "http://www.opera.com/download/",
                chromeDownload: "http://www.google.com/chrome",
                firefoxDownload: "http://www.mozilla.com/",
                safariDownload: "http://www.apple.com/safari/download/",
                reportHasNotFinishedLoadingErrorMsg: "This operation requires a viewer with a report that has finished loading.",
                serverConnectionErrorMsg: "Cannot establish a connection with the Report Server.",
                loadingReportMsg: "Loading report...",
                loadingPageMsg: "Loading page...",
                totalPagesLabel: "of {0}",
                firstPageButtonLabel: "First Page",
                previousPageButtonLabel: "Previous Page",
                nextPageButtonLabel: "Next Page",
                lastPageButtonLabel: "Last Page",
                exportButtonLabel: "Export",
                printButtonLabel: "Print",
                refreshButtonLabel: "Refresh",
                exportingLabel: "Exporting...",
                printingLabel: "Printing...",
                cancelExportLabel: "Cancel",
                cancelPrintLabel: "Cancel",
                pdfFormatText: "PDF",
                xpsFormatText: "XPS",
                xlsFormatText: "Excel 2003",
                xlsxFormatText: "Excel 2007",
                exportInProgressErrorMsg: "Another export is already in progress, please invoke the cancelExport() method and wait for the ExportCanceled event before exporting again.",
                printInProgressErrorMsg: "Another print job is already in progress, please invoke the cancelPrint() method and wait for the PrintFinished event before printing again.",
                invalidExportFormat: "Invalid export format. Valid formats are: PDF, XLS, XLSX and XPS. On Apple devices, XPS is not valid.",
                zoomButtonLabel: "Zoom",
                zoomInButtonLabel: "Zoom In",
                zoomOutButtonLabel: "Zoom Out",
                fitToPageButtonLabel: "Fit to Page",
                fitToWidthButtonLabel: "Fit to Width",
                acrobatPluginNotFoundErrorMsg: 'Adobe Acrobat plug-in not found.',
                previousButtonLabel: "Prev",
                nextButtonLabel: "Next"
            }
        });

        $.ig.ReportServiceProxyLocale = {};

        $.extend($.ig.ReportServiceProxyLocale, {
            locale: {
                serverConnectionErrorMsg: "Cannot establish a connection with the Report Server.",
                unknownReportServerErrorMsg: "Unknown report server error."
            }
        });

        $.ui.igReportViewerErrorLocale = $.ui.igReportViewerErrorLocale || {};

        $.extend($.ui.igReportViewerErrorLocale, {
            locale: {
                showDetails: "Show Details",
                hideDetails: "Hide Details",
                close: "Close"
            }
        });
    }

} (jQuery));




